<?php

/*
The array below is built from the Lexique 3.80 database
http://www.lexique.org

Reference:
New B., Pallier C., Ferrand L. & Matos R. (2001)
Une base de données lexicales du français contemporain
sur internet: LEXIQUE.
L'Année Psychologique 101:447-462, www.lexique.org.


Copyright 2014 - Hyeran Lee-Jean, Philippe Gambette

This file is part of iPhocomp.

    iPhocomp is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    iPhocomp is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with iPhocomp.  If not, see <http://www.gnu.org/licenses/>.
*/


//definition of $dicoPhon (phonetic transcription of the word)
//and of $dicoHomog (list of words which have homographs which
//are not homonyms)

$dicoPhon=array(
"iphocomp" => "ifok§p",
"a" => "a",
"à" => "a",
"à brûle-pourpoint" => "abRylpuRpw5",
"a capella" => "akapEla",
"a cappella" => "akapEla",
"à cloche-pied" => "aklOSpje",
"a contrario" => "ak§tRaRjo",
"à cropetons" => "akROp°t§",
"à croupetons" => "akRup°t§",
"a fortiori" => "afORsjoRi",
"à fortiori" => "afORsjoRi",
"a giorno" => "adZjORno",
"à giorno" => "adZjORno",
"à glagla" => "aglagla",
"a jeun" => "aZ1",
"à jeun" => "aZ1",
"à l'aveuglette" => "alav9glEt",
"à l'encan" => "al@k@",
"à l'encontre" => "al@k§tR",
"à l'envi" => "al@vi",
"à l'improviste" => "al5pRovist",
"a l'instar" => "al5staR",
"à l'instar" => "al5staR",
"à la daumont" => "aladom§",
"à la saint-glinglin" => "alas5gl5gl5",
"à leur encontre" => "al9R@k§tR",
"à lurelure" => "alyR°lyR",
"à mon encontre" => "am§n@k§tR",
"à notre encontre" => "anOtR@k§tR",
"a posteriori" => "apOsteRjoRi",
"à posteriori" => "apOsteRjoRi",
"a priori" => "apRijoRi",
"à priori" => "apRijoRi",
"à rebrousse-poil" => "aR°bRuspwal",
"à son encontre" => "as§n@k§tR",
"à tâtons" => "atat§",
"à tire-larigot" => "atiRlaRigo",
"à ton encontre" => "at§n@k§tR",
"à touche-touche" => "atuStuS",
"à tue-tête" => "atytEt",
"à votre encontre" => "avOtR@k§tR",
"à-côté" => "akote",
"à-côtés" => "akote",
"à-coup" => "aku",
"à-coups" => "aku",
"à-dieu-vat" => "adj2va",
"à-peu-près" => "ap2pRE",
"à-pic" => "apik",
"à-pics" => "apik",
"à-plat" => "apla",
"à-plats" => "apla",
"à-propos" => "apRopo",
"à-valoir" => "avalwaR",
"aa" => "aa",
"ab absurdo" => "abapsuRdo",
"ab initio" => "abinisjo",
"ab ovo" => "abovo",
"abaca" => "abaka",
"abaissa" => "abEsa",
"abaissai" => "abEsE",
"abaissaient" => "abEsE",
"abaissait" => "abEsE",
"abaissant" => "abEs@",
"abaissante" => "abEs@t",
"abaisse" => "abEs",
"abaissé" => "abese",
"abaisse-langue" => "abEsl@g",
"abaissée" => "abese",
"abaissées" => "abese",
"abaissement" => "abEs°m@",
"abaissent" => "abEs",
"abaisser" => "abese",
"abaissera" => "abEs°Ra",
"abaisserai" => "abEs°RE",
"abaisseraient" => "abEs°RE",
"abaisserais" => "abEs°RE",
"abaisserait" => "abEs°RE",
"abaissèrent" => "abEsER",
"abaisses" => "abEs",
"abaissés" => "abese",
"abaissez" => "abEse",
"abaissons" => "abEs§",
"abalone" => "abalOn",
"abalones" => "abalOn",
"abandon" => "ab@d§",
"abandonna" => "ab@dona",
"abandonnai" => "ab@donE",
"abandonnaient" => "ab@donE",
"abandonnais" => "ab@donE",
"abandonnait" => "ab@donE",
"abandonnâmes" => "ab@donam",
"abandonnant" => "ab@don@",
"abandonnas" => "ab@dona",
"abandonnât" => "ab@dona",
"abandonne" => "ab@dOn",
"abandonné" => "ab@done",
"abandonnée" => "ab@done",
"abandonnées" => "ab@done",
"abandonnent" => "ab@dOn",
"abandonner" => "ab@done",
"abandonnera" => "ab@dOn°Ra",
"abandonnerai" => "ab@dOn°RE",
"abandonneraient" => "ab@dOn°RE",
"abandonnerais" => "ab@dOn°RE",
"abandonnerait" => "ab@dOn°RE",
"abandonneras" => "ab@dOn°Ra",
"abandonnèrent" => "ab@donER",
"abandonnerez" => "ab@dOn°Re",
"abandonneriez" => "ab@dOn°Rje",
"abandonnerions" => "ab@dOn°Rj§",
"abandonnerons" => "ab@dOn°R§",
"abandonneront" => "ab@dOn°R§",
"abandonnes" => "ab@dOn",
"abandonnés" => "ab@done",
"abandonneurs" => "ab@don9R",
"abandonnez" => "ab@done",
"abandonniez" => "ab@donje",
"abandonnions" => "ab@donj§",
"abandonnique" => "ab@donik",
"abandonnons" => "ab@don§",
"abandons" => "ab@d§",
"abaque" => "abak",
"abasourdi" => "abazuRdi",
"abasourdie" => "abazuRdi",
"abasourdir" => "abazuRdiR",
"abasourdis" => "abazuRdi",
"abasourdissant" => "abazuRdis@",
"abasourdissants" => "abazuRdis@",
"abat" => "aba",
"abat-jour" => "abaZuR",
"abat-son" => "abas§",
"abatage" => "abataZ",
"abâtardi" => "abataRdi",
"abâtardie" => "abataRdi",
"abâtardies" => "abataRdi",
"abâtardir" => "abataRdiR",
"abâtardirai" => "abataRdiRE",
"abâtardissant" => "abataRdis@",
"abatis" => "abati",
"abats" => "aba",
"abattage" => "abataZ",
"abattages" => "abataZ",
"abattaient" => "abatE",
"abattais" => "abatE",
"abattait" => "abatE",
"abattant" => "abat@",
"abattants" => "abat@",
"abatte" => "abat",
"abattement" => "abat°m@",
"abattements" => "abat°m@",
"abattent" => "abat",
"abattes" => "abat",
"abatteur" => "abat9R",
"abatteurs" => "abat9R",
"abattez" => "abate",
"abattiez" => "abatje",
"abattions" => "abatj§",
"abattirent" => "abatiR",
"abattis" => "abati",
"abattit" => "abati",
"abattoir" => "abatwaR",
"abattoirs" => "abatwaR",
"abattons" => "abat§",
"abattra" => "abatRa",
"abattrai" => "abatRE",
"abattraient" => "abatRE",
"abattrais" => "abatRE",
"abattrait" => "abatRE",
"abattras" => "abatRa",
"abattre" => "abatR",
"abattrez" => "abatRe",
"abattriez" => "abatRie",
"abattrons" => "abatR§",
"abattront" => "abatR§",
"abattu" => "abaty",
"abattue" => "abaty",
"abattues" => "abaty",
"abattures" => "abatyR",
"abattus" => "abaty",
"abbatial" => "abasjal",
"abbatiale" => "abasjal",
"abbatiales" => "abasjal",
"abbaye" => "abei",
"abbayes" => "abei",
"abbé" => "abe",
"abbés" => "abe",
"abbesse" => "abEs",
"abbesses" => "abEs",
"abc" => "abese",
"abcès" => "apsE",
"abdication" => "abdikasj§",
"abdications" => "abdikasj§",
"abdiqua" => "abdika",
"abdiquai" => "abdikE",
"abdiquaient" => "abdikE",
"abdiquais" => "abdikE",
"abdiquait" => "abdikE",
"abdiquant" => "abdik@",
"abdique" => "abdik",
"abdiqué" => "abdike",
"abdiquée" => "abdike",
"abdiquer" => "abdike",
"abdiquera" => "abdik°Ra",
"abdiquerais" => "abdik°RE",
"abdiquerait" => "abdik°RE",
"abdiquez" => "abdike",
"abdomen" => "abdomEn",
"abdominal" => "abdominal",
"abdominale" => "abdominal",
"abdominales" => "abdominal",
"abdominaux" => "abdomino",
"abdos" => "abdo",
"abducteur" => "abdykt9R",
"abduction" => "abdyksj§",
"abécédaire" => "abesedER",
"abeille" => "abEj",
"abeilles" => "abEj",
"aber" => "abe",
"aberrant" => "abER@",
"aberrante" => "abER@t",
"aberrantes" => "abER@t",
"aberrants" => "abER@",
"aberration" => "abERasj§",
"aberrations" => "abERasj§",
"abêti" => "abeti",
"abêties" => "abeti",
"abêtir" => "abetiR",
"abêtis" => "abeti",
"abêtissait" => "abetisE",
"abêtissement" => "abetis°m@",
"abêtit" => "abeti",
"abhorrais" => "abORE",
"abhorrait" => "abORE",
"abhorrant" => "abOR@",
"abhorre" => "abOR",
"abhorré" => "abORe",
"abhorrée" => "abORe",
"abhorrer" => "abORe",
"abhorrés" => "abORe",
"abhorrez" => "abORe",
"abîma" => "abima",
"abîmai" => "abimE",
"abîmaient" => "abimE",
"abîmait" => "abimE",
"abîmant" => "abim@",
"abîme" => "abim",
"abîmé" => "abime",
"abîmée" => "abime",
"abîmées" => "abime",
"abîment" => "abim",
"abîmer" => "abime",
"abîmera" => "abim°Ra",
"abîmerai" => "abim°RE",
"abîmerais" => "abim°RE",
"abîmerait" => "abim°RE",
"abîmeras" => "abim°Ra",
"abîmerez" => "abim°Re",
"abîmeront" => "abim°R§",
"abîmes" => "abim",
"abîmés" => "abime",
"abîmez" => "abime",
"abîmions" => "abimj§",
"abîmons" => "abim§",
"abject" => "abZEkt",
"abjecte" => "abZEkt",
"abjectement" => "abZEkt°m@",
"abjectes" => "abZEkt",
"abjection" => "abZEksj§",
"abjections" => "abZEksj§",
"abjects" => "abZEkt",
"abjurant" => "abZyR@",
"abjuration" => "abZyRasj§",
"abjurations" => "abZyRasj§",
"abjure" => "abZyR",
"abjuré" => "abZyRe",
"abjurer" => "abZyRe",
"abjurez" => "abZyRe",
"abjurons" => "abZyR§",
"abkhaze" => "abkaz",
"ablatif" => "ablatif",
"ablation" => "ablasj§",
"ablations" => "ablasj§",
"able" => "abl",
"ablette" => "ablEt",
"ablettes" => "ablEt",
"ablution" => "ablysj§",
"ablutions" => "ablysj§",
"abnégation" => "abnegasj§",
"aboi" => "abwa",
"aboie" => "abwa",
"aboiement" => "abwam@",
"aboiements" => "abwam@",
"aboient" => "abwa",
"aboiera" => "abwaRa",
"aboierait" => "abwaRE",
"aboieront" => "abwaR§",
"aboies" => "abwa",
"abois" => "abwa",
"aboli" => "aboli",
"abolie" => "aboli",
"abolies" => "aboli",
"abolir" => "aboliR",
"abolira" => "aboliRa",
"abolirait" => "aboliRE",
"aboliras" => "aboliRa",
"abolis" => "aboli",
"abolissaient" => "abolisE",
"abolissais" => "abolisE",
"abolissait" => "abolisE",
"abolissant" => "abolis@",
"abolissent" => "abolis",
"abolissions" => "abolisj§",
"abolissons" => "abolis§",
"abolit" => "aboli",
"abolition" => "abolisj§",
"abolitionniste" => "abolisjonist",
"abolitionnistes" => "abolisjonist",
"abominable" => "abominabl",
"abominablement" => "abominabl°m@",
"abominables" => "abominabl",
"abominaient" => "abominE",
"abomination" => "abominasj§",
"abominations" => "abominasj§",
"abomine" => "abomin",
"abominer" => "abomine",
"abonda" => "ab§da",
"abondai" => "ab§dE",
"abondaient" => "ab§dE",
"abondais" => "ab§dE",
"abondait" => "ab§dE",
"abondamment" => "ab§dam@",
"abondance" => "ab§d@s",
"abondant" => "ab§d@",
"abondante" => "ab§d@t",
"abondantes" => "ab§d@t",
"abondants" => "ab§d@",
"abondassent" => "ab§das",
"abonde" => "ab§d",
"abondé" => "ab§de",
"abondent" => "ab§d",
"abonder" => "ab§de",
"abonnai" => "abonE",
"abonnant" => "abOn@",
"abonnât" => "abona",
"abonne" => "abOn",
"abonné" => "abone",
"abonnée" => "abone",
"abonnées" => "abone",
"abonnement" => "abOn°m@",
"abonnements" => "abOn°m@",
"abonner" => "abone",
"abonnés" => "abone",
"abonnez" => "abone",
"abord" => "abOR",
"aborda" => "abORda",
"abordable" => "abORdabl",
"abordables" => "abORdabl",
"abordage" => "abORdaZ",
"abordages" => "abORdaZ",
"abordai" => "abORdE",
"abordaient" => "abORdE",
"abordais" => "abORdE",
"abordait" => "abORdE",
"abordâmes" => "abORdam",
"abordant" => "abORd@",
"aborde" => "abORd",
"abordé" => "abORde",
"abordée" => "abORde",
"abordées" => "abORde",
"abordent" => "abORd",
"aborder" => "abORde",
"abordera" => "abORd°Ra",
"aborderai" => "abORd°RE",
"aborderaient" => "abORd°RE",
"aborderais" => "abORd°RE",
"aborderait" => "abORd°RE",
"abordèrent" => "abORdER",
"aborderiez" => "abORd°Rje",
"aborderions" => "abORd°Rj§",
"aborderons" => "abORd°R§",
"aborderont" => "abORd°R§",
"abordes" => "abORd",
"abordés" => "abORde",
"abordez" => "abORde",
"abordiez" => "abORdje",
"abordions" => "abORdj§",
"abordons" => "abORd§",
"abords" => "abOR",
"aborigène" => "aboRiZEn",
"aborigènes" => "aboRiZEn",
"abornement" => "abORn°m@",
"abortif" => "abORtif",
"abortive" => "abORtiv",
"abortives" => "abORtiv",
"abouchaient" => "abuSE",
"abouchais" => "abuSE",
"abouchait" => "abuSE",
"abouchant" => "abuS@",
"abouché" => "abuSe",
"abouchée" => "abuSe",
"abouchements" => "abuS°m@",
"aboucher" => "abuSe",
"abouchés" => "abuSe",
"aboule" => "abul",
"abouler" => "abule",
"aboules" => "abul",
"aboulez" => "abule",
"aboulie" => "abuli",
"aboulique" => "abulik",
"abouliques" => "abulik",
"abounas" => "abuna",
"about" => "abu",
"aboutait" => "abutE",
"abouti" => "abuti",
"aboutie" => "abuti",
"aboutîmes" => "abutim",
"aboutir" => "abutiR",
"aboutira" => "abutiRa",
"aboutirai" => "abutiRE",
"aboutiraient" => "abutiRE",
"aboutirais" => "abutiRE",
"aboutirait" => "abutiRE",
"aboutiras" => "abutiRa",
"aboutirent" => "abutiR",
"aboutirons" => "abutiR§",
"aboutiront" => "abutiR§",
"aboutis" => "abuti",
"aboutissaient" => "abutisE",
"aboutissait" => "abutisE",
"aboutissant" => "abutis@",
"aboutissants" => "abutis@",
"aboutisse" => "abutis",
"aboutissement" => "abutis°m@",
"aboutissent" => "abutis",
"aboutissez" => "abutise",
"aboutissiez" => "abutisje",
"aboutissions" => "abutisj§",
"aboutit" => "abuti",
"aboutonnai" => "abutonE",
"aboutons" => "abut§",
"aboya" => "abwaja",
"aboyaient" => "abwajE",
"aboyait" => "abwajE",
"aboyant" => "abwaj@",
"aboyante" => "abwaj@t",
"aboyé" => "abwaje",
"aboyer" => "abwaje",
"aboyèrent" => "abwajER",
"aboyeur" => "abwaj9R",
"aboyeurs" => "abwaj9R",
"aboyons" => "abwaj§",
"abracadabra" => "abRakadabRa",
"abracadabrant" => "abRakadabR@",
"abracadabrante" => "abRakadabR@t",
"abracadabrantes" => "abRakadabR@t",
"abracadabrants" => "abRakadabR@",
"abracadabré" => "abRakadabRe",
"abrasé" => "abRaze",
"abrasif" => "abRazif",
"abrasifs" => "abRazif",
"abrasion" => "abRazj§",
"abrasive" => "abRaziv",
"abraxas" => "abRaksas",
"abrège" => "abREZ",
"abrégé" => "abReZe",
"abrégea" => "abReZa",
"abrégeai" => "abReZE",
"abrégeaient" => "abReZE",
"abrégeait" => "abReZE",
"abrégeant" => "abReZ@",
"abrégeât" => "abReZa",
"abrégée" => "abReZe",
"abrègent" => "abREZ",
"abrégeons" => "abReZ§",
"abréger" => "abReZe",
"abrégera" => "abReZ°Ra",
"abrégerai" => "abReZ°RE",
"abrégerait" => "abReZ°RE",
"abrégés" => "abReZe",
"abrégez" => "abReZe",
"abreuva" => "abR9va",
"abreuvage" => "abR9vaZ",
"abreuvaient" => "abR9vE",
"abreuvait" => "abR9vE",
"abreuvant" => "abR9v@",
"abreuve" => "abR9v",
"abreuvé" => "abR9ve",
"abreuvée" => "abR9ve",
"abreuvent" => "abR9v",
"abreuver" => "abR9ve",
"abreuvera" => "abR9v°Ra",
"abreuveraient" => "abR9v°RE",
"abreuvés" => "abR9ve",
"abreuvez" => "abR9ve",
"abreuvoir" => "abR9vwaR",
"abreuvoirs" => "abR9vwaR",
"abreuvons" => "abR9v§",
"abréviatif" => "abRevjatif",
"abréviation" => "abRevjasj§",
"abréviations" => "abRevjasj§",
"abri" => "abRi",
"abri-refuge" => "abRiR°fyZ",
"abribus" => "abRibys",
"abricot" => "abRiko",
"abricotez" => "abRikote",
"abricotier" => "abRikotje",
"abricotiers" => "abRikotje",
"abricotine" => "abRikotin",
"abricots" => "abRiko",
"abris" => "abRi",
"abrita" => "abRita",
"abritai" => "abRitE",
"abritaient" => "abRitE",
"abritais" => "abRitE",
"abritait" => "abRitE",
"abritâmes" => "abRitam",
"abritant" => "abRit@",
"abrite" => "abRit",
"abrité" => "abRite",
"abritée" => "abRite",
"abritées" => "abRite",
"abritent" => "abRit",
"abriter" => "abRite",
"abritera" => "abRit°Ra",
"abriterait" => "abRit°RE",
"abritèrent" => "abRitER",
"abriterons" => "abRit°R§",
"abriteront" => "abRit°R§",
"abrites" => "abRit",
"abrités" => "abRite",
"abritez" => "abRite",
"abritiez" => "abRitje",
"abritions" => "abRitj§",
"abritons" => "abRit§",
"abrogation" => "abRogasj§",
"abrogé" => "abRoZe",
"abrogée" => "abRoZe",
"abrogées" => "abRoZe",
"abrogent" => "abROZ",
"abroger" => "abRoZe",
"abrogés" => "abRoZe",
"abrupt" => "abRypt",
"abrupte" => "abRypt",
"abruptement" => "abRypt°m@",
"abruptes" => "abRypt",
"abrupts" => "abRypt",
"abruti" => "abRyti",
"abrutie" => "abRyti",
"abruties" => "abRyti",
"abrutir" => "abRytiR",
"abrutira" => "abRytiRa",
"abrutis" => "abRyti",
"abrutissaient" => "abRytisE",
"abrutissais" => "abRytisE",
"abrutissait" => "abRytisE",
"abrutissant" => "abRytis@",
"abrutissante" => "abRytis@t",
"abrutissantes" => "abRytis@t",
"abrutissants" => "abRytis@",
"abrutissement" => "abRytis°m@",
"abrutissent" => "abRytis",
"abrutisseur" => "abRytis9R",
"abrutissions" => "abRytisj§",
"abrutit" => "abRyti",
"abscisse" => "apsis",
"abscission" => "apsisj§",
"abscons" => "apsk§",
"absconse" => "apsk§s",
"absconses" => "apsk§s",
"absence" => "aps@s",
"absences" => "aps@s",
"absent" => "aps@",
"absenta" => "aps@ta",
"absentai" => "aps@tE",
"absentaient" => "aps@tE",
"absentais" => "aps@tE",
"absentait" => "aps@tE",
"absentant" => "aps@t@",
"absente" => "aps@t",
"absenté" => "aps@te",
"absentée" => "aps@te",
"absentéisme" => "aps@teizm",
"absentéiste" => "aps@teist",
"absenter" => "aps@te",
"absentera" => "aps@t°Ra",
"absenterai" => "aps@t°RE",
"absenterait" => "aps@t°RE",
"absentèrent" => "aps@tER",
"absentes" => "aps@t",
"absentés" => "aps@te",
"absents" => "aps@",
"abside" => "apsid",
"absides" => "apsid",
"absidiales" => "apsidjal",
"absidiole" => "apsidjOl",
"absinthant" => "aps5t@",
"absinthe" => "aps5t",
"absolu" => "apsoly",
"absolue" => "apsoly",
"absolues" => "apsoly",
"absolument" => "apsolym@",
"absolus" => "apsoly",
"absolution" => "apsolysj§",
"absolutisme" => "apsolytizm",
"absolvaient" => "apsOlvE",
"absolvait" => "apsOlvE",
"absolvant" => "apsOlv@",
"absolve" => "apsOlv",
"absolvent" => "apsOlv",
"absolves" => "apsOlv",
"absorba" => "apsORba",
"absorbables" => "apsORbabl",
"absorbai" => "apsORbE",
"absorbaient" => "apsORbE",
"absorbais" => "apsORbE",
"absorbait" => "apsORbE",
"absorbant" => "apsORb@",
"absorbante" => "apsORb@t",
"absorbantes" => "apsORb@t",
"absorbants" => "apsORb@",
"absorbe" => "apsORb",
"absorbé" => "apsORbe",
"absorbée" => "apsORbe",
"absorbées" => "apsORbe",
"absorbent" => "apsORb",
"absorber" => "apsORbe",
"absorbera" => "apsORb°Ra",
"absorberai" => "apsORb°RE",
"absorberaient" => "apsORb°RE",
"absorberait" => "apsORb°RE",
"absorbèrent" => "apsORbER",
"absorbés" => "apsORbe",
"absorbeur" => "apsORb9R",
"absorbez" => "apsORbe",
"absorbions" => "apsORbj§",
"absorbons" => "apsORb§",
"absorption" => "apsORpsj§",
"absorptions" => "apsORpsj§",
"absoudrai" => "apsudRE",
"absoudrait" => "apsudRE",
"absoudre" => "apsudR",
"absoudriez" => "apsudRije",
"absous" => "apsu",
"absout" => "apsu",
"absoute" => "apsut",
"absoutes" => "apsut",
"abstenaient" => "apst°nE",
"abstenais" => "apst°nE",
"abstenait" => "apst°nE",
"abstenant" => "apst°n@",
"abstenez" => "apst°ne",
"absteniez" => "apst°nje",
"abstenions" => "apst°nj§",
"abstenir" => "apst°niR",
"abstenons" => "apst°n§",
"abstention" => "apst@sj§",
"abstentionniste" => "apst@sjOnist",
"abstentionnistes" => "apst@sjonist",
"abstenu" => "apst°ny",
"abstenue" => "apst°ny",
"abstenues" => "apst°ny",
"abstenus" => "apst°ny",
"abstiendrai" => "apstj5dRE",
"abstiendraient" => "apstj5dRE",
"abstiendrais" => "apstj5dRE",
"abstiendrait" => "apstj5dRE",
"abstiendras" => "apstj5dRa",
"abstiendrions" => "apstj5dRj§",
"abstiendrons" => "apstj5dR§",
"abstiendront" => "apstj5dR§",
"abstienne" => "apstjEn",
"abstiennent" => "apstjEn",
"abstiennes" => "apstjEn",
"abstiens" => "apstj5",
"abstient" => "apstj5",
"abstinence" => "apstin@s",
"abstinences" => "apstin@s",
"abstinent" => "apstin@",
"abstinente" => "apstin@t",
"abstinrent" => "apst5R",
"abstins" => "apst5",
"abstint" => "apst5",
"abstînt" => "apst5",
"abstraction" => "apstRaksj§",
"abstractions" => "apstRaksj§",
"abstraire" => "apstRER",
"abstrais" => "apstRE",
"abstrait" => "apstRE",
"abstraite" => "apstREt",
"abstraitement" => "apstREt°m@",
"abstraites" => "apstREt",
"abstraits" => "apstRE",
"abstrus" => "apstRy",
"abstruse" => "apstRyz",
"abstruses" => "apstRyz",
"absurde" => "apsyRd",
"absurdement" => "apsyRd°m@",
"absurdes" => "apsyRd",
"absurdistes" => "apsyRdist",
"absurdité" => "apsyRdite",
"absurdités" => "apsyRdite",
"abus" => "aby",
"abusa" => "abyza",
"abusai" => "abyzE",
"abusaient" => "abyzE",
"abusais" => "abyzE",
"abusait" => "abyzE",
"abusant" => "abyz@",
"abuse" => "abyz",
"abusé" => "abyze",
"abusée" => "abyze",
"abusées" => "abyze",
"abusent" => "abyz",
"abuser" => "abyze",
"abusera" => "abyz°Ra",
"abuserai" => "abyz°RE",
"abuserais" => "abyz°RE",
"abuserait" => "abyz°RE",
"abusèrent" => "abyzER",
"abuserez" => "abyz°Re",
"abuseriez" => "abyz°Rje",
"abuses" => "abyz",
"abusés" => "abyze",
"abuseur" => "abyz9R",
"abusez" => "abyze",
"abusiez" => "abyzje",
"abusif" => "abyzif",
"abusifs" => "abyzif",
"abusive" => "abyziv",
"abusivement" => "abyziv°m@",
"abusives" => "abyziv",
"abusons" => "abyz§",
"abyme" => "abim",
"abyssal" => "abisal",
"abyssale" => "abisal",
"abyssales" => "abisal",
"abysse" => "abis",
"abysses" => "abis",
"abyssin" => "abis5",
"abyssinien" => "abisinj5",
"abyssinienne" => "abisinjEn",
"abyssins" => "abis5",
"acabit" => "akabi",
"acabits" => "akabi",
"acacia" => "akasja",
"acacias" => "akasja",
"académicien" => "akademisj5",
"académiciens" => "akademisj5",
"académie" => "akademi",
"académies" => "akademi",
"académique" => "akademik",
"académiquement" => "akademik°m@",
"académiques" => "akademik",
"académisé" => "akademize",
"académisme" => "akademizm",
"acadien" => "akadj5",
"acadienne" => "akadjEn",
"acadiens" => "akadj5",
"acagnardai" => "akaNaRdE",
"acagnardait" => "akaNaRdE",
"acagnardé" => "akaNaRde",
"acagnardée" => "akaNaRde",
"acagnarder" => "akaNaRde",
"acajou" => "akaZu",
"acajous" => "akaZu",
"acanthe" => "ak@t",
"acanthes" => "ak@t",
"acariâtre" => "akaRjatR",
"acariâtres" => "akaRjatR",
"acariens" => "akaRj5",
"accabla" => "akabla",
"accablai" => "akablE",
"accablaient" => "akablE",
"accablais" => "akablE",
"accablait" => "akablE",
"accablant" => "akabl@",
"accablante" => "akabl@t",
"accablantes" => "akabl@t",
"accablants" => "akabl@",
"accablât" => "akabla",
"accable" => "akabl",
"accablé" => "akable",
"accablée" => "akable",
"accablées" => "akable",
"accablement" => "akabl°m@",
"accablements" => "akabl°m@",
"accablent" => "akabl",
"accabler" => "akable",
"accableraient" => "akabl°RE",
"accablèrent" => "akablER",
"accablés" => "akable",
"accablez" => "akable",
"accablions" => "akablij§",
"accalmie" => "akalmi",
"accalmies" => "akalmi",
"accalmit" => "akalmi",
"accapara" => "akapaRa",
"accaparaient" => "akapaRE",
"accaparait" => "akapaRE",
"accaparant" => "akapaR@",
"accaparante" => "akapaR@t",
"accapare" => "akapaR",
"accaparé" => "akapaRe",
"accaparée" => "akapaRe",
"accaparées" => "akapaRe",
"accaparer" => "akapaRe",
"accaparerait" => "akapaR°RE",
"accaparés" => "akapaRe",
"accapareur" => "akapaR9R",
"accaparez" => "akapaRe",
"accastillage" => "akastijaZ",
"accastillages" => "akastijaZ",
"accéda" => "akseda",
"accédai" => "aksedE",
"accédaient" => "aksedE",
"accédais" => "aksedE",
"accédait" => "aksedE",
"accédâmes" => "aksedam",
"accédant" => "aksed@",
"accède" => "aksEd",
"accédé" => "aksede",
"accèdent" => "aksEd",
"accéder" => "aksede",
"accédera" => "aksed°Ra",
"accéderai" => "aksed°RE",
"accéderaient" => "aksed°RE",
"accéderais" => "aksed°RE",
"accéderait" => "aksed°RE",
"accéderas" => "aksed°Ra",
"accèdes" => "aksEd",
"accédez" => "aksede",
"accédons" => "aksed§",
"accéléra" => "akseleRa",
"accélérai" => "akseleRE",
"accéléraient" => "akseleRE",
"accélérais" => "akseleRE",
"accélérait" => "akseleRE",
"accelerando" => "akseleRando",
"accélérant" => "akseleR@",
"accélérants" => "akseleR@",
"accélérateur" => "akseleRat9R",
"accélérateurs" => "akseleRat9R",
"accélération" => "akseleRasj§",
"accélérations" => "akseleRasj§",
"accélératrice" => "akseleRatRis",
"accélère" => "akselER",
"accéléré" => "akseleRe",
"accélérée" => "akseleRe",
"accélérées" => "akseleRe",
"accélèrent" => "akselER",
"accélérer" => "akseleRe",
"accélérera" => "akseleR°Ra",
"accélérerait" => "akseleR°RE",
"accéléreras" => "akseleR°Ra",
"accélérèrent" => "akseleRER",
"accélères" => "akselER",
"accélérés" => "akseleRe",
"accélérez" => "akseleRe",
"accélériez" => "akseleRje",
"accélérons" => "akseleR§",
"accent" => "aks@",
"accenteur" => "aks@t9R",
"accents" => "aks@",
"accentua" => "aks@t8a",
"accentuai" => "aks@t8E",
"accentuaient" => "aks@t8E",
"accentuais" => "aks@t8E",
"accentuait" => "aks@t8E",
"accentuant" => "aks@t8@",
"accentuât" => "aks@t8a",
"accentuation" => "aks@t8asj§",
"accentue" => "aks@ty",
"accentué" => "aks@t8e",
"accentuée" => "aks@t8e",
"accentuées" => "aks@t8e",
"accentuent" => "aks@ty",
"accentuer" => "aks@t8e",
"accentuerait" => "aks@tyRE",
"accentuèrent" => "aks@t8ER",
"accentués" => "aks@t8e",
"accentuez" => "aks@tye",
"accepta" => "aksEpta",
"acceptable" => "aksEptabl",
"acceptables" => "aksEptabl",
"acceptai" => "aksEptE",
"acceptaient" => "aksEptE",
"acceptais" => "aksEptE",
"acceptait" => "aksEptE",
"acceptâmes" => "aksEptam",
"acceptant" => "aksEpt@",
"acceptassent" => "aksEptas",
"acceptasses" => "aksEptas",
"acceptât" => "aksEpta",
"acceptation" => "aksEptasj§",
"acceptations" => "aksEptasj§",
"accepte" => "aksEpt",
"accepté" => "aksEpte",
"acceptée" => "aksEpte",
"acceptées" => "aksEpte",
"acceptent" => "aksEpt",
"accepter" => "aksEpte",
"acceptera" => "aksEpt°Ra",
"accepterai" => "aksEpt°RE",
"accepteraient" => "aksEpt°RE",
"accepterais" => "aksEpt°RE",
"accepterait" => "aksEpt°RE",
"accepteras" => "aksEpt°Ra",
"acceptèrent" => "aksEptER",
"accepterez" => "aksEpt°Re",
"accepteriez" => "aksEpt°Rje",
"accepterions" => "aksEpt°Rj§",
"accepterons" => "aksEpt°R§",
"accepteront" => "aksEpt°R§",
"acceptes" => "aksEpt",
"acceptés" => "aksEpte",
"acceptez" => "aksEpte",
"acceptiez" => "aksEptje",
"acception" => "aksEpsj§",
"acceptions" => "aksEptj§",
"acceptons" => "aksEpt§",
"accès" => "aksE",
"accesseurs" => "aksEs9R",
"accessibilité" => "aksEsibilite",
"accessible" => "aksesibl",
"accessibles" => "aksesibl",
"accession" => "aksEsj§",
"accessit" => "aksesit",
"accessoire" => "akseswaR",
"accessoirement" => "akseswaR°m@",
"accessoires" => "akseswaR",
"accessoirise" => "aksEswaRiz",
"accessoiriser" => "aksEswaRize",
"accessoiriste" => "akseswaRist",
"accessoiristes" => "akseswaRist",
"accident" => "aksid@",
"accidente" => "aksid@t",
"accidenté" => "aksid@te",
"accidentée" => "aksid@te",
"accidentées" => "aksid@te",
"accidentel" => "aksid@tEl",
"accidentelle" => "aksid@tEl",
"accidentellement" => "aksid@tEl°m@",
"accidentelles" => "aksid@tEl",
"accidentels" => "aksid@tEl",
"accidenter" => "aksid@te",
"accidentés" => "aksid@te",
"accidents" => "aksid@",
"acclama" => "aklama",
"acclamaient" => "aklamE",
"acclamait" => "aklamE",
"acclamant" => "aklam@",
"acclamation" => "aklamasj§",
"acclamations" => "aklamasj§",
"acclame" => "aklam",
"acclamé" => "aklame",
"acclamée" => "aklame",
"acclamées" => "aklame",
"acclament" => "aklam",
"acclamer" => "aklame",
"acclamera" => "aklam°Ra",
"acclamerait" => "aklam°RE",
"acclameront" => "aklam°R§",
"acclamés" => "aklame",
"acclamez" => "aklame",
"acclamiez" => "aklamje",
"acclamons" => "aklam§",
"acclimata" => "aklimata",
"acclimatai" => "aklimatE",
"acclimatation" => "aklimatasj§",
"acclimate" => "aklimat",
"acclimaté" => "aklimate",
"acclimatement" => "aklimat°m@",
"acclimatent" => "aklimat",
"acclimater" => "aklimate",
"acclimaterait" => "aklimat°RE",
"acclimates" => "aklimat",
"acclimatés" => "aklimate",
"acclimatez" => "aklimate",
"accointance" => "akw5t@s",
"accointances" => "akw5t@s",
"accointé" => "akw5te",
"accointés" => "akw5te",
"accola" => "akola",
"accolade" => "akolad",
"accolades" => "akolad",
"accolait" => "akolE",
"accolant" => "akol@",
"accole" => "akOl",
"accolé" => "akole",
"accolée" => "akole",
"accolées" => "akole",
"accolement" => "akOl°m@",
"accolent" => "akOl",
"accoler" => "akole",
"accolerais" => "akOl°RE",
"accolés" => "akole",
"accommoda" => "akomoda",
"accommodai" => "akomodE",
"accommodaient" => "akomodE",
"accommodais" => "akomodE",
"accommodait" => "akomodE",
"accommodant" => "akomod@",
"accommodante" => "akomod@t",
"accommodantes" => "akomod@t",
"accommodants" => "akomod@",
"accommodât" => "akomoda",
"accommodation" => "akomodasj§",
"accommodatrices" => "akomodatRis",
"accommode" => "akomOd",
"accommodé" => "akomode",
"accommodée" => "akomode",
"accommodement" => "akomOd°m@",
"accommodements" => "akomOd°m@",
"accommodent" => "akomOd",
"accommoder" => "akomode",
"accommodera" => "akomOd°Ra",
"accommoderai" => "akomOd°RE",
"accommoderaient" => "akomOd°RE",
"accommoderais" => "akomOd°RE",
"accommoderait" => "akomOd°RE",
"accommodèrent" => "akomodER",
"accommoderez" => "akomOd°Re",
"accommoderions" => "akomOd°Rj§",
"accommoderont" => "akomOd°R§",
"accommodés" => "akomode",
"accommodions" => "akomodj§",
"accommodons" => "akomod§",
"accompagna" => "ak§paNa",
"accompagnai" => "ak§paNE",
"accompagnaient" => "ak§paNE",
"accompagnais" => "ak§paNE",
"accompagnait" => "ak§paNE",
"accompagnâmes" => "ak§paNam",
"accompagnant" => "ak§paN@",
"accompagnât" => "ak§paNa",
"accompagnateur" => "ak§paNat9R",
"accompagnateurs" => "ak§paNat9R",
"accompagnatrice" => "ak§paNatRis",
"accompagnatrices" => "ak§paNatRis",
"accompagne" => "ak§paN",
"accompagné" => "ak§paNe",
"accompagnée" => "ak§paNe",
"accompagnées" => "ak§paNe",
"accompagnement" => "ak§paN°m@",
"accompagnements" => "ak§paN°m@",
"accompagnent" => "ak§paN",
"accompagner" => "ak§paNe",
"accompagnera" => "ak§paN°Ra",
"accompagnerai" => "ak§paN°RE",
"accompagneraient" => "ak§paN°RE",
"accompagnerais" => "ak§paN°RE",
"accompagnerait" => "ak§paN°RE",
"accompagneras" => "ak§paN°Ra",
"accompagnèrent" => "ak§paNER",
"accompagnerez" => "ak§paN°Re",
"accompagneriez" => "ak§paN°Rje",
"accompagnerons" => "ak§paN°R§",
"accompagneront" => "ak§paN°R§",
"accompagnes" => "ak§paN",
"accompagnés" => "ak§paNe",
"accompagnez" => "ak§paNe",
"accompagniez" => "ak§paNe",
"accompagnions" => "ak§paN§",
"accompagnons" => "ak§paN§",
"accompli" => "ak§pli",
"accomplie" => "ak§pli",
"accomplies" => "ak§pli",
"accomplir" => "ak§pliR",
"accomplira" => "ak§pliRa",
"accomplirai" => "ak§pliRE",
"accompliraient" => "ak§pliRE",
"accomplirais" => "ak§pliRE",
"accomplirait" => "ak§pliRE",
"accompliras" => "ak§pliRa",
"accomplirent" => "ak§pliR",
"accomplirez" => "ak§pliRe",
"accomplirons" => "ak§pliR§",
"accompliront" => "ak§pliR§",
"accomplis" => "ak§pli",
"accomplissaient" => "ak§plisE",
"accomplissais" => "ak§plisE",
"accomplissait" => "ak§plisE",
"accomplissant" => "ak§plis@",
"accomplisse" => "ak§plis",
"accomplissement" => "ak§plis°m@",
"accomplissements" => "ak§plis°m@",
"accomplissent" => "ak§plis",
"accomplissez" => "ak§plise",
"accomplissiez" => "ak§plisje",
"accomplissions" => "ak§plisj§",
"accomplissons" => "ak§plis§",
"accomplit" => "ak§pli",
"accomplît" => "ak§pli",
"accord" => "akOR",
"accorda" => "akORda",
"accordai" => "akORdE",
"accordaient" => "akORdE",
"accordailles" => "akORdaj",
"accordais" => "akORdE",
"accordait" => "akORdE",
"accordant" => "akORd@",
"accordas" => "akORda",
"accordassent" => "akORdas",
"accordât" => "akORda",
"accorde" => "akORd",
"accordé" => "akORde",
"accordée" => "akORde",
"accordées" => "akORde",
"accordement" => "akORd°m@",
"accordent" => "akORd",
"accordéon" => "akORde§",
"accordéoniste" => "akORdeonist",
"accordéonistes" => "akORdeonist",
"accordéons" => "akORde§",
"accorder" => "akORde",
"accordera" => "akORd°Ra",
"accorderai" => "akORd°RE",
"accorderaient" => "akORd°RE",
"accorderais" => "akORd°RE",
"accorderait" => "akORd°RE",
"accorderas" => "akORd°Ra",
"accordèrent" => "akORdER",
"accorderez" => "akORd°Re",
"accorderiez" => "akORd°Rje",
"accorderons" => "akORd°R§",
"accorderont" => "akORd°R§",
"accordes" => "akORd",
"accordés" => "akORde",
"accordeur" => "akORd9R",
"accordez" => "akORde",
"accordiez" => "akORdje",
"accordions" => "akORdj§",
"accordo" => "akORdo",
"accordons" => "akORd§",
"accords" => "akOR",
"accore" => "akOR",
"accores" => "akOR",
"accort" => "akOR",
"accorte" => "akORt",
"accortes" => "akORt",
"accorts" => "akOR",
"accosta" => "akOsta",
"accostage" => "akOstaZ",
"accostaient" => "akOstE",
"accostais" => "akOstE",
"accostait" => "akOstE",
"accostant" => "akOst@",
"accoste" => "akOst",
"accosté" => "akOste",
"accostée" => "akOste",
"accostées" => "akOste",
"accostent" => "akOst",
"accoster" => "akOste",
"accosterez" => "akOst°Re",
"accosterons" => "akOst°R§",
"accostez" => "akOste",
"accostiez" => "akOstje",
"accostons" => "akOst§",
"accota" => "akota",
"accotaient" => "akotE",
"accotait" => "akotE",
"accotant" => "akot@",
"accote" => "akOt",
"accoté" => "akote",
"accotée" => "akote",
"accotées" => "akote",
"accotement" => "akOt°m@",
"accotements" => "akOt°m@",
"accotent" => "akOt",
"accoter" => "akote",
"accotèrent" => "akotER",
"accotés" => "akote",
"accotoirs" => "akotwaR",
"accotons" => "akot§",
"accoucha" => "akuSa",
"accouchaient" => "akuSE",
"accouchais" => "akuSE",
"accouchait" => "akuSE",
"accouchant" => "akuS@",
"accouche" => "akuS",
"accouché" => "akuSe",
"accouchée" => "akuSe",
"accouchées" => "akuSe",
"accouchement" => "akuS°m@",
"accouchements" => "akuS°m@",
"accouchent" => "akuS",
"accoucher" => "akuSe",
"accouchera" => "akuS°Ra",
"accoucherait" => "akuS°RE",
"accoucheras" => "akuS°Ra",
"accouches" => "akuS",
"accouchés" => "akuSe",
"accoucheur" => "akuS9R",
"accoucheurs" => "akuS9R",
"accoucheuse" => "akuS2z",
"accouchez" => "akuSe",
"accouda" => "akuda",
"accoudai" => "akudE",
"accoudaient" => "akudE",
"accoudais" => "akudE",
"accoudait" => "akudE",
"accoudant" => "akud@",
"accoude" => "akud",
"accoudé" => "akude",
"accoudée" => "akude",
"accoudées" => "akude",
"accouder" => "akude",
"accoudèrent" => "akudER",
"accoudés" => "akude",
"accoudions" => "akudj§",
"accoudoir" => "akudwaR",
"accoudoirs" => "akudwaR",
"accoudons" => "akud§",
"accoupla" => "akupla",
"accouplaient" => "akuplE",
"accouplais" => "akuplE",
"accouplait" => "akuplE",
"accouplant" => "akupl@",
"accouple" => "akupl",
"accouplé" => "akuple",
"accouplée" => "akuple",
"accouplées" => "akuple",
"accouplement" => "akupl°m@",
"accouplements" => "akupl°m@",
"accouplent" => "akupl",
"accoupler" => "akuple",
"accouplera" => "akupl°Ra",
"accouplerait" => "akupl°RE",
"accouplèrent" => "akuplER",
"accoupleront" => "akupl°R§",
"accouplés" => "akuple",
"accouraient" => "akuRE",
"accourais" => "akuRE",
"accourait" => "akuRE",
"accourant" => "akuR@",
"accourcissant" => "akuRsis@",
"accoure" => "akuR",
"accourent" => "akuR",
"accoures" => "akuR",
"accourez" => "akuRe",
"accouriez" => "akuRje",
"accourir" => "akuRiR",
"accourons" => "akuR§",
"accourra" => "akuRa",
"accourrai" => "akuRE",
"accourraient" => "akuRE",
"accourrais" => "akuRE",
"accourrait" => "akuRE",
"accourront" => "akuR§",
"accours" => "akuR",
"accourt" => "akuR",
"accouru" => "akuRy",
"accourue" => "akuRy",
"accourues" => "akuRy",
"accoururent" => "akuRyR",
"accourus" => "akuRy",
"accourussent" => "akuRys",
"accourut" => "akuRy",
"accourût" => "akuRy",
"accoutre" => "akutR",
"accoutré" => "akutRe",
"accoutrée" => "akutRe",
"accoutrement" => "akutR°m@",
"accoutrements" => "akutR°m@",
"accoutrés" => "akutRe",
"accoutuma" => "akutyma",
"accoutumai" => "akutymE",
"accoutumaient" => "akutymE",
"accoutumais" => "akutymE",
"accoutumait" => "akutymE",
"accoutumance" => "akutym@s",
"accoutumances" => "akutym@s",
"accoutumant" => "akutym@",
"accoutume" => "akutym",
"accoutumé" => "akutyme",
"accoutumée" => "akutyme",
"accoutumées" => "akutyme",
"accoutument" => "akutym",
"accoutumer" => "akutyme",
"accoutumerait" => "akutym°RE",
"accoutumés" => "akutyme",
"accouvée" => "akuve",
"accras" => "akRas",
"accrédita" => "akRedita",
"accréditaient" => "akReditE",
"accréditait" => "akReditE",
"accréditant" => "akRedit@",
"accréditation" => "akReditasj§",
"accréditations" => "akReditasj§",
"accrédité" => "akRedite",
"accréditée" => "akRedite",
"accréditer" => "akRedite",
"accrédités" => "akRedite",
"accréditif" => "akReditif",
"accrétion" => "akResj§",
"accro" => "akRo",
"accroc" => "akRo",
"accrocha" => "akRoSa",
"accrochage" => "akRoSaZ",
"accrochages" => "akRoSaZ",
"accrochai" => "akRoSE",
"accrochaient" => "akRoSE",
"accrochais" => "akRoSE",
"accrochait" => "akRoSE",
"accrochant" => "akRoS@",
"accrochât" => "akRoSa",
"accroche" => "akROS",
"accroché" => "akRoSe",
"accroche-coeur" => "akROSk9R",
"accroche-coeurs" => "akROSk9R",
"accrochée" => "akRoSe",
"accrochées" => "akRoSe",
"accrochent" => "akROS",
"accrocher" => "akRoSe",
"accrochera" => "akROS°Ra",
"accrocherai" => "akROS°RE",
"accrocheraient" => "akROS°RE",
"accrocherais" => "akROS°RE",
"accrocherait" => "akROS°RE",
"accrochèrent" => "akRoSER",
"accrocherez" => "akROS°Re",
"accrocheriez" => "akRoS°Rje",
"accrocheront" => "akROS°R§",
"accroches" => "akROS",
"accrochés" => "akRoSe",
"accrocheur" => "akRoS9R",
"accrocheurs" => "akRoS9R",
"accrocheuse" => "akRoS2z",
"accrocheuses" => "akRoS2z",
"accrochez" => "akRoSe",
"accrochiez" => "akRoSje",
"accrochions" => "akRoSj§",
"accrochons" => "akRoS§",
"accrocs" => "akRo",
"accroire" => "akRwaR",
"accrois" => "akRwa",
"accroissaient" => "akRwasE",
"accroissait" => "akRwasE",
"accroissant" => "akRwas@",
"accroisse" => "akRwas",
"accroissement" => "akRwas°m@",
"accroissent" => "akRwas",
"accroissez" => "akRwase",
"accroît" => "akRwa",
"accroîtra" => "akRwatRa",
"accroîtrait" => "akRwatRE",
"accroître" => "akRwatR",
"accroîtront" => "akRwatR§",
"accros" => "akRo",
"accroupi" => "akRupi",
"accroupie" => "akRupi",
"accroupies" => "akRupi",
"accroupir" => "akRupiR",
"accroupirent" => "akRupiR",
"accroupis" => "akRupi",
"accroupissaient" => "akRupisE",
"accroupissais" => "akRupisE",
"accroupissait" => "akRupisE",
"accroupissant" => "akRupis@",
"accroupisse" => "akRupis",
"accroupissement" => "akRupis°m@",
"accroupissent" => "akRupis",
"accroupissons" => "akRupis§",
"accroupit" => "akRupi",
"accru" => "akRy",
"accrue" => "akRy",
"accrues" => "akRy",
"accrurent" => "akRyR",
"accrus" => "akRy",
"accrut" => "akRy",
"accrût" => "akRy",
"accu" => "aky",
"accueil" => "ak9j",
"accueillaient" => "ak9jE",
"accueillais" => "ak9jE",
"accueillait" => "ak9jE",
"accueillant" => "ak9j@",
"accueillante" => "ak9j@t",
"accueillantes" => "ak9j@t",
"accueillants" => "ak9j@",
"accueille" => "ak9j",
"accueillent" => "ak9j",
"accueillera" => "ak9j°Ra",
"accueillerai" => "ak9j°RE",
"accueilleraient" => "ak9j°RE",
"accueillerait" => "ak9j°RE",
"accueilleras" => "ak9j°Ra",
"accueillerez" => "ak9j°Re",
"accueilleriez" => "ak9j°Rje",
"accueillerons" => "ak9j°R§",
"accueilleront" => "ak9j°R§",
"accueilles" => "ak9j",
"accueillez" => "ak9je",
"accueilli" => "ak9ji",
"accueillie" => "ak9ji",
"accueillies" => "ak9ji",
"accueillir" => "ak9jiR",
"accueillirent" => "ak9jiR",
"accueillis" => "ak9ji",
"accueillit" => "ak9ji",
"accueillît" => "ak9ji",
"accueillons" => "ak9j§",
"accueils" => "ak9j",
"accula" => "akyla",
"acculaient" => "akylE",
"acculais" => "akylE",
"acculait" => "akylE",
"acculant" => "akyl@",
"acculât" => "akyla",
"accule" => "akyl",
"acculé" => "akyle",
"acculée" => "akyle",
"acculées" => "akyle",
"acculent" => "akyl",
"acculer" => "akyle",
"acculera" => "akyl°Ra",
"acculeraient" => "akyl°RE",
"acculèrent" => "akylER",
"acculés" => "akyle",
"acculez" => "akyle",
"acculturation" => "akyltyRasj§",
"accumula" => "akymyla",
"accumulai" => "akymylE",
"accumulaient" => "akymylE",
"accumulais" => "akymylE",
"accumulait" => "akymylE",
"accumulant" => "akymyl@",
"accumulateur" => "akymylat9R",
"accumulateurs" => "akymylat9R",
"accumulation" => "akymylasj§",
"accumulations" => "akymylasj§",
"accumule" => "akymyl",
"accumulé" => "akymyle",
"accumulée" => "akymyle",
"accumulées" => "akymyle",
"accumulent" => "akymyl",
"accumuler" => "akymyle",
"accumulèrent" => "akymylER",
"accumulerez" => "akymyl°Re",
"accumulés" => "akymyle",
"accumulez" => "akymyle",
"accus" => "aky",
"accusa" => "akyza",
"accusai" => "akyzE",
"accusaient" => "akyzE",
"accusais" => "akyzE",
"accusait" => "akyzE",
"accusant" => "akyz@",
"accusât" => "akyza",
"accusateur" => "akyzat9R",
"accusateurs" => "akyzat9R",
"accusatif" => "akyzatif",
"accusation" => "akyzasj§",
"accusations" => "akyzasj§",
"accusatoire" => "akyzatwaR",
"accusatrice" => "akyzatRis",
"accusatrices" => "akyzatRis",
"accuse" => "akyz",
"accusé" => "akyze",
"accusée" => "akyze",
"accusées" => "akyze",
"accusent" => "akyz",
"accuser" => "akyze",
"accusera" => "akyz°Ra",
"accuseraient" => "akyz°RE",
"accuserais" => "akyz°RE",
"accuserait" => "akyz°RE",
"accusèrent" => "akyzER",
"accuserez" => "akyz°Re",
"accuseriez" => "akyz°Rje",
"accuserions" => "akyz°Rj§",
"accuserons" => "akyz°R§",
"accuseront" => "akyz°R§",
"accuses" => "akyz",
"accusés" => "akyze",
"accusez" => "akyze",
"accusiez" => "akyzje",
"accusions" => "akyzj§",
"accusons" => "akyz§",
"ace" => "Ejs",
"acellulaire" => "aselylER",
"acéphale" => "asefal",
"acéphales" => "asefal",
"acerbe" => "asERb",
"acerbes" => "asERb",
"acerbité" => "asERbite",
"acéré" => "aseRe",
"acérée" => "aseRe",
"acérées" => "aseRe",
"acérés" => "aseRe",
"acetabulum" => "asetabylOm",
"acétate" => "asetat",
"acétique" => "asetik",
"acétone" => "asetOn",
"acétylcholine" => "asetilkolin",
"acétylène" => "asetilEn",
"acétylsalicylique" => "asetilsalisilik",
"achalandage" => "aSal@daZ",
"achalandaient" => "aSal@dE",
"achalandé" => "aSal@de",
"achalandée" => "aSal@de",
"achalandées" => "aSal@de",
"achalandés" => "aSal@de",
"achaler" => "aSale",
"achards" => "aSaR",
"acharna" => "aSaRna",
"acharnai" => "aSaRnE",
"acharnaient" => "aSaRnE",
"acharnais" => "aSaRnE",
"acharnait" => "aSaRnE",
"acharnant" => "aSaRn@",
"acharne" => "aSaRn",
"acharné" => "aSaRne",
"acharnée" => "aSaRne",
"acharnées" => "aSaRne",
"acharnement" => "aSaRn°m@",
"acharnements" => "aSaRn°m@",
"acharnent" => "aSaRn",
"acharner" => "aSaRne",
"acharnera" => "aSaRn°Ra",
"acharnerai" => "aSaRn°RE",
"acharnerait" => "aSaRn°RE",
"acharnèrent" => "aSaRnER",
"acharnes" => "aSaRn",
"acharnés" => "aSaRne",
"acharnez" => "aSaRne",
"achat" => "aSa",
"achats" => "aSa",
"ache" => "aS",
"achélème" => "akelEm",
"achélèmes" => "akelEm",
"achemina" => "aS°mina",
"acheminai" => "aS°minE",
"acheminaient" => "aS°minE",
"acheminait" => "aS°minE",
"acheminâmes" => "aS°minam",
"acheminant" => "aS°min@",
"achemine" => "aS°min",
"acheminé" => "aS°mine",
"acheminée" => "aS°mine",
"acheminées" => "aS°mine",
"acheminement" => "aS°min°m@",
"acheminent" => "aS°min",
"acheminer" => "aS°mine",
"acheminèrent" => "aS°minER",
"achemineront" => "aS°min°R§",
"acheminés" => "aS°mine",
"acheminons" => "aS°min§",
"aches" => "aS",
"acheta" => "aS°ta",
"achetable" => "aS°tabl",
"achetai" => "aS°tE",
"achetaient" => "aS°tE",
"achetais" => "aS°tE",
"achetait" => "aS°tE",
"achetâmes" => "aS°tam",
"achetant" => "aS°t@",
"achetassent" => "aS°tas",
"achetât" => "aS°ta",
"achète" => "aSEt",
"acheté" => "aS°te",
"achetée" => "aS°te",
"achetées" => "aS°te",
"achètent" => "aSEt",
"acheter" => "aS°te",
"achètera" => "aSEt°Ra",
"achèterai" => "aSEt°RE",
"achèteraient" => "aSEt°RE",
"achèterais" => "aSEt°RE",
"achèterait" => "aSEt°RE",
"achèteras" => "aSEt°Ra",
"achetèrent" => "aS°tER",
"achèterez" => "aSEt°Re",
"achèteriez" => "aSEt°Rje",
"achèterions" => "aSEt°Rj§",
"achèterons" => "aSEt°R§",
"achèteront" => "aSEt°R§",
"achètes" => "aSEt",
"achetés" => "aS°te",
"acheteur" => "aS°t9R",
"acheteurs" => "aS°t9R",
"acheteuse" => "aS°t2z",
"acheteuses" => "aS°t2z",
"achetez" => "aS°te",
"achetiez" => "aS°tje",
"achetions" => "aS°tj§",
"achetons" => "aS°t§",
"acheva" => "aS°va",
"achevai" => "aS°vE",
"achevaient" => "aS°vE",
"achevais" => "aS°vE",
"achevait" => "aS°vE",
"achevâmes" => "aS°vam",
"achevant" => "aS°v@",
"achevât" => "aS°va",
"achève" => "aSEv",
"achevé" => "aS°ve",
"achevée" => "aS°ve",
"achevées" => "aS°ve",
"achèvement" => "aSEv°m@",
"achèvements" => "aSEv°m@",
"achèvent" => "aSEv",
"achever" => "aS°ve",
"achèvera" => "aSEv°Ra",
"achèverai" => "aSEv°RE",
"achèveraient" => "aSEv°RE",
"achèverait" => "aSEv°RE",
"achevèrent" => "aS°vER",
"achèverez" => "aSEv°Re",
"achèverons" => "aSEv°R§",
"achèveront" => "aSEv°R§",
"achèves" => "aSEv",
"achevés" => "aS°ve",
"achevez" => "aS°ve",
"acheviez" => "aS°vje",
"achevions" => "aS°vj§",
"achevons" => "aS°v§",
"achillée" => "akile",
"achondroplasie" => "ak§dRoplazi",
"achondroplasies" => "ak§dRoplazi",
"achoppa" => "aSopa",
"achoppai" => "aSopE",
"achoppaient" => "aSopE",
"achoppais" => "aSopE",
"achoppait" => "aSopE",
"achoppe" => "aSOp",
"achoppé" => "aSope",
"achoppée" => "aSope",
"achoppement" => "aSOp°m@",
"achopper" => "aSOpe",
"acid jazz" => "asiddZaz",
"acide" => "asid",
"acides" => "asid",
"acidité" => "asidite",
"acidités" => "asidite",
"acidocétose" => "asidosetoz",
"acidose" => "asidoz",
"acidulé" => "asidyle",
"acidulée" => "asidyle",
"acidulées" => "asidyle",
"acidulés" => "asidyle",
"acier" => "asje",
"aciérie" => "asjeRi",
"aciéries" => "asjeRi",
"aciers" => "asje",
"acmé" => "akme",
"acné" => "akne",
"acnéiques" => "akneik",
"acnés" => "akne",
"acolyte" => "akolit",
"acolytes" => "akolit",
"acompte" => "ak§t",
"acomptes" => "ak§t",
"aconiers" => "akonje",
"aconit" => "akonit",
"acoquina" => "akokina",
"acoquine" => "akokin",
"acoquiné" => "akokine",
"acoquinée" => "akokine",
"acoquiner" => "akokine",
"acoquinés" => "akokine",
"acouphène" => "akufEn",
"acoustique" => "akustik",
"acoustiques" => "akustik",
"acqua-toffana" => "akwatofana",
"acquéraient" => "akeRE",
"acquérais" => "akeRE",
"acquérait" => "akeRE",
"acquérant" => "akeR@",
"acquéreur" => "akeR9R",
"acquéreurs" => "akeR9R",
"acquérions" => "akeRj§",
"acquérir" => "akeRiR",
"acquérons" => "akeR§",
"acquerra" => "akERRa",
"acquerrai" => "akERRE",
"acquerraient" => "akERRE",
"acquerront" => "akERR§",
"acquêt" => "akE",
"acquêts" => "akE",
"acquière" => "akjER",
"acquièrent" => "akjER",
"acquiers" => "akjER",
"acquiert" => "akjER",
"acquiesça" => "akjEsa",
"acquiesçai" => "akjEsE",
"acquiesçaient" => "akjEsE",
"acquiesçais" => "akjEsE",
"acquiesçait" => "akjEsE",
"acquiesçant" => "akjEs@",
"acquiesce" => "akjEs",
"acquiescé" => "akjEse",
"acquiescement" => "akjEs°m@",
"acquiescements" => "akjEs°m@",
"acquiescent" => "akjEs",
"acquiescer" => "akjese",
"acquiescèrent" => "akjEsER",
"acquiesceront" => "akjEs°R§",
"acquiesces" => "akjEs",
"acquiesçons" => "akjEs§",
"acquirent" => "akiR",
"acquis" => "aki",
"acquise" => "akiz",
"acquises" => "akiz",
"acquisition" => "akizisj§",
"acquisitions" => "akizisj§",
"acquit" => "aki",
"acquits" => "aki",
"acquitta" => "akita",
"acquittai" => "akitE",
"acquittaient" => "akitE",
"acquittais" => "akitE",
"acquittait" => "akitE",
"acquittant" => "akit@",
"acquittât" => "akita",
"acquitte" => "akit",
"acquitté" => "akite",
"acquittée" => "akite",
"acquittement" => "akit°m@",
"acquittent" => "akit",
"acquitter" => "akite",
"acquittera" => "akit°Ra",
"acquitterai" => "akit°RE",
"acquitterais" => "akit°RE",
"acquitterait" => "akit°RE",
"acquitterez" => "akit°Re",
"acquittes" => "akit",
"acquittés" => "akite",
"acquittez" => "akite",
"acquittions" => "akitj§",
"acra" => "akRa",
"acre" => "akR",
"âcre" => "akR",
"acré" => "akRe",
"âcrement" => "akR°m@",
"acres" => "akR",
"âcres" => "akR",
"âcreté" => "akR°te",
"acrimonie" => "akRimoni",
"acrimonieuse" => "akRimonj2z",
"acrimonieusement" => "akRimonj2z°m@",
"acrimonieuses" => "akRimonj2z",
"acrimonieux" => "akRimonj2",
"acrobate" => "akRobat",
"acrobates" => "akRobat",
"acrobatie" => "akRobasi",
"acrobaties" => "akRobasi",
"acrobatique" => "akRobatik",
"acrobatiquement" => "akRobatik°m@",
"acrobatiques" => "akRobatik",
"acrocéphale" => "akRosefal",
"acromion" => "akRomj§",
"acronyme" => "akRonim",
"acrophobie" => "akRofobi",
"acropole" => "akRopOl",
"acrostiche" => "akROstiS",
"acrotère" => "akRotER",
"acrylique" => "akRilik",
"acryliques" => "akRilik",
"acrylonitrile" => "akRilonitRil",
"acta" => "akta",
"acte" => "akt",
"actes" => "akt",
"acteur" => "akt9R",
"acteurs" => "akt9R",
"actif" => "aktif",
"actifs" => "aktif",
"actine" => "aktin",
"actinies" => "aktini",
"action" => "aksj§",
"action painting" => "akSj9npEjntiG",
"actionna" => "aksjona",
"actionnai" => "aksjonE",
"actionnaient" => "aksjonE",
"actionnaire" => "aksjonER",
"actionnaires" => "aksjonER",
"actionnais" => "aksjonE",
"actionnait" => "aksjonE",
"actionnant" => "aksjon@",
"actionnariat" => "aksjOnaRja",
"actionnât" => "aksjona",
"actionne" => "aksjOn",
"actionné" => "aksjone",
"actionnée" => "aksjone",
"actionnées" => "aksjone",
"actionnement" => "aksjOn°m@",
"actionnent" => "aksjOn",
"actionner" => "aksjone",
"actionneront" => "aksjOn°R§",
"actionnés" => "aksjone",
"actionneur" => "aksjOn9R",
"actionnez" => "aksjone",
"actions" => "aksj§",
"activa" => "aktiva",
"activai" => "aktivE",
"activaient" => "aktivE",
"activait" => "aktivE",
"activant" => "aktiv@",
"activateur" => "aktivat9R",
"activation" => "aktivasj§",
"activations" => "aktivasj§",
"active" => "aktiv",
"activé" => "aktive",
"activée" => "aktive",
"activées" => "aktive",
"activement" => "aktiv°m@",
"activent" => "aktiv",
"activer" => "aktive",
"activera" => "aktiv°Ra",
"activerai" => "aktiv°RE",
"activerait" => "aktiv°RE",
"activeras" => "aktiv°Ra",
"activèrent" => "aktivER",
"actives" => "aktiv",
"activés" => "aktive",
"activez" => "aktive",
"activisme" => "aktivizm",
"activiste" => "aktivist",
"activistes" => "aktivist",
"activité" => "aktivite",
"activités" => "aktivite",
"activons" => "aktiv§",
"actrice" => "aktRis",
"actrices" => "aktRis",
"actuaire" => "akt8ER",
"actualisation" => "akt8alizasj§",
"actualise" => "akt8aliz",
"actualisé" => "akt8alize",
"actualisée" => "akt8alize",
"actualisées" => "akt8alize",
"actualiser" => "akt8alize",
"actualisez" => "aktyalize",
"actualité" => "akt8alite",
"actualités" => "akt8alite",
"actuariel" => "aktyaRjEl",
"actuation" => "akt8asj§",
"actuel" => "akt8El",
"actuelle" => "akt8El",
"actuellement" => "akt8El°m@",
"actuelles" => "akt8El",
"actuels" => "akt8El",
"acuité" => "ak8ite",
"acumen" => "akymEn",
"acuponcteur" => "akyp§kt9R",
"acuponcture" => "akyp§ktyR",
"acupuncteur" => "akyp§kt9R",
"acupuncture" => "akyp§ktyR",
"ad hoc" => "adOk",
"ad infinitum" => "ad5finitOm",
"ad libitum" => "adlibitOm",
"ad limina" => "adlimina",
"ad majorem dei gloriam" => "admaZoREmdeigloRjam",
"ad nutum" => "adnutOm",
"ad patres" => "adpatREs",
"ad vitam aeternam" => "advitametERnam",
"ada" => "ada",
"adage" => "adaZ",
"adages" => "adaZ",
"adagio" => "adadZjo",
"adamantin" => "adam@t5",
"adamantine" => "adam@tin",
"adamique" => "adamik",
"adapta" => "adapta",
"adaptabilité" => "adaptabilite",
"adaptable" => "adaptabl",
"adaptables" => "adaptabl",
"adaptai" => "adaptE",
"adaptaient" => "adaptE",
"adaptais" => "adaptE",
"adaptait" => "adaptE",
"adaptant" => "adapt@",
"adaptât" => "adapta",
"adaptateur" => "adaptat9R",
"adaptateurs" => "adaptat9R",
"adaptatif" => "adaptatif",
"adaptatifs" => "adaptatif",
"adaptation" => "adaptasj§",
"adaptations" => "adaptasj§",
"adapte" => "adapt",
"adapté" => "adapte",
"adaptée" => "adapte",
"adaptées" => "adapte",
"adaptent" => "adapt",
"adapter" => "adapte",
"adaptera" => "adapt°Ra",
"adapterai" => "adapt°RE",
"adapterais" => "adapt°RE",
"adapterait" => "adapt°RE",
"adapteras" => "adapt°Ra",
"adaptèrent" => "adaptER",
"adapterez" => "adapt°Re",
"adapterons" => "adapt°R§",
"adapteront" => "adapt°R§",
"adaptes" => "adapt",
"adaptés" => "adapte",
"adaptez" => "adapte",
"addenda" => "ad5da",
"addendum" => "ad5dOm",
"addiction" => "adiksj§",
"additif" => "aditif",
"additifs" => "aditif",
"addition" => "adisj§",
"additionnaient" => "adisjonE",
"additionnais" => "adisjonE",
"additionnait" => "adisjonE",
"additionnant" => "adisjon@",
"additionne" => "adisjOn",
"additionné" => "adisjone",
"additionnée" => "adisjone",
"additionnées" => "adisjone",
"additionnel" => "adisjonEl",
"additionnelle" => "adisjonEl",
"additionnelles" => "adisjonEl",
"additionnels" => "adisjonEl",
"additionnent" => "adisjOn",
"additionner" => "adisjone",
"additionneraient" => "adisjOn°RE",
"additionnerait" => "adisjOn°RE",
"additionnés" => "adisjone",
"additionnez" => "adisjone",
"additions" => "adisj§",
"adducteur" => "adykt9R",
"adducteurs" => "adykt9R",
"adduction" => "adyksj§",
"adénine" => "adenin",
"adénocarcinome" => "adenokaRsinom",
"adénome" => "adenom",
"adénopathie" => "adenopati",
"adénosine" => "adenozin",
"adénovirus" => "adenoviRys",
"adent" => "ad@",
"adepte" => "adEpt",
"adeptes" => "adEpt",
"adéquat" => "adekwa",
"adéquate" => "adekwat",
"adéquatement" => "adekwat°m@",
"adéquates" => "adekwat",
"adéquation" => "adekwasj§",
"adéquats" => "adekwa",
"adhéra" => "adeRa",
"adhéraient" => "adeRE",
"adhérais" => "adeRE",
"adhérait" => "adeRE",
"adhérant" => "adeR@",
"adhère" => "adER",
"adhéré" => "adeRe",
"adhérence" => "adeR@s",
"adhérences" => "adeR@s",
"adhérent" => "adeR@",
"adhèrent" => "adER",
"adhérente" => "adeR@t",
"adhérentes" => "adeR@t",
"adhérents" => "adeR@",
"adhérer" => "adeRe",
"adhérez" => "adeRe",
"adhésif" => "adezif",
"adhésifs" => "adezif",
"adhésion" => "adezj§",
"adhésions" => "adezj§",
"adhésive" => "adeziv",
"adhésives" => "adeziv",
"adieu" => "adj2",
"adieux" => "adj2",
"adipeuse" => "adip2z",
"adipeuses" => "adip2z",
"adipeux" => "adip2",
"adipique" => "adipik",
"adiposité" => "adipozite",
"adira" => "adiRa",
"adja" => "adZa",
"adjacent" => "adZas@",
"adjacente" => "adZas@t",
"adjacentes" => "adZas@t",
"adjacents" => "adZas@",
"adjas" => "adZa",
"adjectif" => "adZEktif",
"adjectifs" => "adZEktif",
"adjective" => "adZEktiv",
"adjoignait" => "adZwaNE",
"adjoignant" => "adZwaN@",
"adjoigne" => "adZwaN",
"adjoignit" => "adZwaNi",
"adjoignît" => "adZwaNi",
"adjoindra" => "adZw5dRa",
"adjoindre" => "adZw5dR",
"adjoindront" => "adZw5dR§",
"adjoins" => "adZw5",
"adjoint" => "adZw5",
"adjointe" => "adZw5t",
"adjointes" => "adZw5t",
"adjoints" => "adZw5",
"adjonction" => "adZ§ksj§",
"adjudant" => "adZyd@",
"adjudant-chef" => "adZyd@SEf",
"adjudant-major" => "adZyd@maZOR",
"adjudants" => "adZyd@",
"adjudants-chefs" => "adZyd@SEf",
"adjudication" => "adZydikasj§",
"adjudications" => "adZydikasj§",
"adjuge" => "adZyZ",
"adjugé" => "adZyZe",
"adjugeait" => "adZyZE",
"adjugeant" => "adZyZ@",
"adjugée" => "adZyZe",
"adjuger" => "adZyZe",
"adjugés" => "adZyZe",
"adjugez" => "adZyZe",
"adjupète" => "adZypEt",
"adjupètes" => "adZypEt",
"adjura" => "adZyRa",
"adjurai" => "adZyRE",
"adjuraient" => "adZyRE",
"adjurais" => "adZyRE",
"adjurait" => "adZyRE",
"adjurant" => "adZyR@",
"adjuration" => "adZyRasj§",
"adjurations" => "adZyRasj§",
"adjure" => "adZyR",
"adjuré" => "adZyRe",
"adjurer" => "adZyRe",
"adjurerai" => "adZyR°RE",
"adjurerait" => "adZyR°RE",
"adjutrice" => "adZytRis",
"adjuvants" => "adZyv@",
"admet" => "admE",
"admets" => "admE",
"admettaient" => "admEtE",
"admettais" => "admEtE",
"admettait" => "admEtE",
"admettant" => "admEt@",
"admette" => "admEt",
"admettent" => "admEt",
"admettes" => "admEt",
"admettez" => "admEte",
"admettiez" => "admEtje",
"admettions" => "admEtj§",
"admettons" => "admEt§",
"admettra" => "admEtRa",
"admettrai" => "admEtRE",
"admettraient" => "admEtRE",
"admettrais" => "admEtRE",
"admettrait" => "admEtRE",
"admettras" => "admEtRa",
"admettre" => "admEtR",
"admettrez" => "admEtRe",
"admettriez" => "admEtRije",
"admettrons" => "admEtR§",
"admettront" => "admEtR§",
"administra" => "administRa",
"administrai" => "administRE",
"administraient" => "administRE",
"administrais" => "administRE",
"administrait" => "administRE",
"administrant" => "administR@",
"administrât" => "administRa",
"administrateur" => "administRat9R",
"administrateurs" => "administRat9R",
"administratif" => "administRatif",
"administratifs" => "administRatif",
"administration" => "administRasj§",
"administrations" => "administRasj§",
"administrative" => "administRativ",
"administrativement" => "administRativ°m@",
"administratives" => "administRativ",
"administratrice" => "administRatRis",
"administre" => "administR",
"administré" => "administRe",
"administrée" => "administRe",
"administrées" => "administRe",
"administrent" => "administR",
"administrer" => "administRe",
"administrera" => "administR°Ra",
"administrerai" => "administR°RE",
"administrerons" => "administR°R§",
"administres" => "administR",
"administrés" => "administRe",
"administrez" => "administRe",
"admira" => "admiRa",
"admirable" => "admiRabl",
"admirablement" => "admiRabl°m@",
"admirables" => "admiRabl",
"admirai" => "admiRE",
"admiraient" => "admiRE",
"admirais" => "admiRE",
"admirait" => "admiRE",
"admirâmes" => "admiRam",
"admirant" => "admiR@",
"admirateur" => "admiRat9R",
"admirateurs" => "admiRat9R",
"admiratif" => "admiRatif",
"admiratifs" => "admiRatif",
"admiration" => "admiRasj§",
"admirations" => "admiRasj§",
"admirative" => "admiRativ",
"admirativement" => "admiRativ°m@",
"admiratives" => "admiRativ",
"admiratrice" => "admiRatRis",
"admiratrices" => "admiRatRis",
"admire" => "admiR",
"admiré" => "admiRe",
"admirée" => "admiRe",
"admirées" => "admiRe",
"admirent" => "admiR",
"admirer" => "admiRe",
"admirera" => "admiR°Ra",
"admirerai" => "admiR°RE",
"admirerais" => "admiR°RE",
"admirerait" => "admiR°RE",
"admirèrent" => "admiRER",
"admirerez" => "admiR°Re",
"admireront" => "admiR°R§",
"admires" => "admiR",
"admirés" => "admiRe",
"admirez" => "admiRe",
"admiriez" => "admiRje",
"admirions" => "admiRj§",
"admirons" => "admiR§",
"admis" => "admi",
"admise" => "admiz",
"admises" => "admiz",
"admissibilité" => "admisibilite",
"admissible" => "admisibl",
"admissibles" => "admisibl",
"admission" => "admisj§",
"admissions" => "admisj§",
"admit" => "admi",
"admît" => "admi",
"admixtion" => "admiksj§",
"admonesta" => "admonEsta",
"admonestait" => "admonEstE",
"admonestât" => "admonEsta",
"admonestation" => "admonEstasj§",
"admonestations" => "admonEstasj§",
"admoneste" => "admonEst",
"admonesté" => "admonEste",
"admonester" => "admOnEste",
"admonestés" => "admonEste",
"admonition" => "admonisj§",
"admonitions" => "admonisj§",
"ado" => "ado",
"adobe" => "adOb",
"adolescence" => "adoles@s",
"adolescences" => "adoles@s",
"adolescent" => "adoles@",
"adolescente" => "adoles@t",
"adolescentes" => "adoles@t",
"adolescents" => "adoles@",
"adon" => "ad§",
"adonc" => "ad§k",
"adoncques" => "ad§k",
"adonies" => "adoni",
"adonis" => "adonis",
"adonisant" => "adoniz@",
"adonna" => "adona",
"adonnai" => "adonE",
"adonnaient" => "adonE",
"adonnais" => "adonE",
"adonnait" => "adonE",
"adonnant" => "adon@",
"adonne" => "adOn",
"adonné" => "adone",
"adonnée" => "adone",
"adonnées" => "adone",
"adonnent" => "adOn",
"adonner" => "adone",
"adonnerait" => "adOn°RE",
"adonnés" => "adone",
"adonnez" => "adone",
"adonnions" => "adonj§",
"adopta" => "adOpta",
"adoptable" => "adOptabl",
"adoptai" => "adOptE",
"adoptaient" => "adOptE",
"adoptais" => "adOptE",
"adoptait" => "adOptE",
"adoptant" => "adOpt@",
"adoptât" => "adOpta",
"adopte" => "adOpt",
"adopté" => "adOpte",
"adoptée" => "adOpte",
"adoptées" => "adOpte",
"adoptent" => "adOpt",
"adopter" => "adOpte",
"adoptera" => "adOpt°Ra",
"adopterai" => "adOpt°RE",
"adopteraient" => "adOpt°RE",
"adopterait" => "adOpt°RE",
"adoptèrent" => "adOptER",
"adopterez" => "adOpt°Re",
"adopterons" => "adOpt°R§",
"adopteront" => "adOpt°R§",
"adoptés" => "adOpte",
"adoptez" => "adOpte",
"adoptif" => "adOptif",
"adoptifs" => "adOptif",
"adoption" => "adOpsj§",
"adoptions" => "adOpsj§",
"adoptive" => "adOptiv",
"adoptives" => "adOptiv",
"adoptons" => "adOpt§",
"adora" => "adoRa",
"adorable" => "adoRabl",
"adorablement" => "adoRabl°m@",
"adorables" => "adoRabl",
"adorai" => "adoRE",
"adoraient" => "adoRE",
"adorais" => "adoRE",
"adorait" => "adoRE",
"adorant" => "adoR@",
"adorante" => "adoR@t",
"adorants" => "adoR@",
"adorateur" => "adoRat9R",
"adorateurs" => "adoRat9R",
"adoration" => "adoRasj§",
"adorations" => "adoRasj§",
"adoratrice" => "adoRatRis",
"adoratrices" => "adoRatRis",
"adore" => "adOR",
"adoré" => "adoRe",
"adorée" => "adoRe",
"adorées" => "adoRe",
"adorent" => "adOR",
"adorer" => "adoRe",
"adorera" => "adOR°Ra",
"adorerai" => "adOR°RE",
"adoreraient" => "adOR°RE",
"adorerais" => "adOR°RE",
"adorerait" => "adOR°RE",
"adoreras" => "adOR°Ra",
"adorèrent" => "adORER",
"adorerez" => "adOR°Re",
"adoreriez" => "adOR°Rje",
"adorerions" => "adOR°Rj§",
"adorerons" => "adOR°R§",
"adoreront" => "adOR°R§",
"adores" => "adOR",
"adorés" => "adoRe",
"adorez" => "adoRe",
"adoriez" => "adoRje",
"adorions" => "adoRj§",
"adornaient" => "adORnE",
"adornait" => "adORnE",
"adorne" => "adORn",
"adorné" => "adORne",
"adorons" => "adoR§",
"ados" => "ado",
"adossa" => "adosa",
"adossai" => "adosE",
"adossaient" => "adosE",
"adossais" => "adosE",
"adossait" => "adosE",
"adossant" => "ados@",
"adosse" => "ados",
"adossé" => "adose",
"adossée" => "adose",
"adossées" => "adose",
"adossent" => "ados",
"adosser" => "adose",
"adossèrent" => "adosER",
"adossés" => "adose",
"adossez" => "adose",
"adouba" => "aduba",
"adoubé" => "adube",
"adoubement" => "adub°m@",
"adouber" => "adube",
"adouci" => "adusi",
"adoucie" => "adusi",
"adoucies" => "adusi",
"adoucir" => "adusiR",
"adoucira" => "adusiRa",
"adoucirait" => "adusiRE",
"adoucirent" => "adusiR",
"adoucis" => "adusi",
"adoucissaient" => "adusisE",
"adoucissait" => "adusisE",
"adoucissant" => "adusis@",
"adoucissantes" => "adusis@t",
"adoucisse" => "adusis",
"adoucissement" => "adusis°m@",
"adoucissements" => "adusis°m@",
"adoucissent" => "adusis",
"adoucisseur" => "adusis9R",
"adoucisseurs" => "adusis9R",
"adoucissez" => "adusise",
"adoucit" => "adusi",
"adoucît" => "adusi",
"adp" => "adepe",
"adragante" => "adRag@t",
"adrénaline" => "adRenalin",
"adrénalines" => "adRenalin",
"adressa" => "adREsa",
"adressage" => "adResaZ",
"adressai" => "adREsE",
"adressaient" => "adREsE",
"adressais" => "adREsE",
"adressait" => "adREsE",
"adressâmes" => "adREsam",
"adressant" => "adREs@",
"adressassent" => "adREsas",
"adressât" => "adREsa",
"adresse" => "adREs",
"adressé" => "adRese",
"adressée" => "adRese",
"adressées" => "adRese",
"adressent" => "adREs",
"adresser" => "adRese",
"adressera" => "adREs°Ra",
"adresserai" => "adREs°RE",
"adresseraient" => "adREs°RE",
"adresserais" => "adREs°RE",
"adresserait" => "adREs°RE",
"adresseras" => "adREs°Ra",
"adressèrent" => "adREsER",
"adresserez" => "adREs°Re",
"adresserons" => "adREs°R§",
"adresseront" => "adREs°R§",
"adresses" => "adREs",
"adressés" => "adRese",
"adressez" => "adREse",
"adressiez" => "adREsje",
"adressions" => "adREsj§",
"adressons" => "adREs§",
"adret" => "adRE",
"adriatique" => "adRijatik",
"adriatiques" => "adRijatik",
"adroit" => "adRwa",
"adroite" => "adRwat",
"adroitement" => "adRwat°m@",
"adroites" => "adRwat",
"adroits" => "adRwa",
"adulaient" => "adylE",
"adulais" => "adylE",
"adulait" => "adylE",
"adulateur" => "adylat9R",
"adulation" => "adylasj§",
"adulations" => "adylasj§",
"adulé" => "adyle",
"adulée" => "adyle",
"adulent" => "adyl",
"aduler" => "adyle",
"adulés" => "adyle",
"adultat" => "adylta",
"adulte" => "adylt",
"adultéraient" => "adylteRE",
"adultération" => "adylteRasj§",
"adultère" => "adyltER",
"adultéré" => "adylteRe",
"adultérées" => "adylteRe",
"adultères" => "adyltER",
"adultérin" => "adylteR5",
"adultérine" => "adylteRin",
"adultérins" => "adylteR5",
"adultes" => "adylt",
"advenait" => "adv°nE",
"advenir" => "adv°niR",
"adventices" => "adv@tis",
"adventiste" => "adv@tist",
"advenu" => "adv°ny",
"advenue" => "adv°ny",
"advenues" => "adv°ny",
"adverbe" => "advERb",
"adverbes" => "advERb",
"adversaire" => "advERsER",
"adversaires" => "advERsER",
"adverse" => "advERs",
"adverses" => "advERs",
"adversité" => "advERsite",
"adversités" => "advERsite",
"adviendra" => "advj5dRa",
"adviendrait" => "advj5dRE",
"advienne" => "advjEn",
"adviennent" => "advjEn",
"advient" => "advj5",
"advint" => "adv5",
"advînt" => "adv5",
"aède" => "aEd",
"aèdes" => "aEd",
"aegipans" => "eZip@",
"aérage" => "aeRaZ",
"aéraient" => "aeRE",
"aérait" => "aeRE",
"aérateur" => "aeRat9R",
"aérateurs" => "aeRat9R",
"aération" => "aeRasj§",
"aérations" => "aeRasj§",
"aère" => "aER",
"aéré" => "aeRe",
"aérée" => "aeRe",
"aérées" => "aeRe",
"aérer" => "aeRe",
"aérèrent" => "aeRER",
"aérés" => "aeRe",
"aérez" => "aeRe",
"aérien" => "aeRj5",
"aérienne" => "aeRjEn",
"aériennes" => "aeRjEn",
"aériens" => "aeRj5",
"aéro" => "aeRo",
"aéro-club" => "aeRokl9b",
"aérobic" => "aeRobik",
"aérobics" => "aeRobik",
"aérodrome" => "aeRodRom",
"aérodromes" => "aeRodRom",
"aérodynamique" => "aeRodinamik",
"aérodynamiques" => "aeRodinamik",
"aérodynamisme" => "aeRodinamizm",
"aérofrein" => "aeRofR5",
"aérofreins" => "aeRofR5",
"aérogare" => "aeRogaR",
"aérogares" => "aeRogaR",
"aéroglisseur" => "aeRoglis9R",
"aéroglisseurs" => "aeRoglis9R",
"aérographe" => "aeRogRaf",
"aérolithe" => "aeRolit",
"aérolithes" => "aeRolit",
"aérologie" => "aeROlOZi",
"aéromobile" => "aeRomobil",
"aéromodélisme" => "aeRomodelizm",
"aéronaute" => "aeRonot",
"aéronautes" => "aeRonot",
"aéronautique" => "aeRonotik",
"aéronautiques" => "aeRonotik",
"aéronaval" => "aeRonaval",
"aéronavale" => "aeRonaval",
"aéronavales" => "aeRonaval",
"aéronavals" => "aeRonaval",
"aéronef" => "aeRonEf",
"aéronefs" => "aeRonEf",
"aérons" => "aeR§",
"aéropathie" => "aeROpati",
"aérophagie" => "aeRofaZi",
"aéroplane" => "aeRoplan",
"aéroplanes" => "aeRoplan",
"aéroport" => "aeRopOR",
"aéroporté" => "aeRopORte",
"aéroportée" => "aeRopORte",
"aéroportées" => "aeRopORte",
"aéroportés" => "aeRopORte",
"aéroports" => "aeRopOR",
"aéropostale" => "aeRopOstal",
"aérosol" => "aeRosOl",
"aérosols" => "aeRosOl",
"aérospatial" => "aeROspasjal",
"aérospatiale" => "aeRospasjal",
"aérostat" => "aeRosta",
"aérostier" => "aeRostje",
"aérostiers" => "aeRostje",
"aérotrains" => "aeRotR5",
"affabilité" => "afabilite",
"affabilités" => "afabilite",
"affable" => "afabl",
"affablement" => "afabl°m@",
"affables" => "afabl",
"affabulation" => "afabylasj§",
"affabulations" => "afabylasj§",
"affabulatrice" => "afabylatRis",
"affabule" => "afabyl",
"affabulé" => "afabyle",
"affabuler" => "afabyle",
"affabules" => "afabyl",
"affacturage" => "afaktyRaZ",
"affadi" => "afadi",
"affadie" => "afadi",
"affadies" => "afadi",
"affadir" => "afadiR",
"affadis" => "afadi",
"affadissaient" => "afadisE",
"affadissait" => "afadisE",
"affadissant" => "afadis@",
"affadisse" => "afadis",
"affadissement" => "afadis°m@",
"affadit" => "afadi",
"affaibli" => "afEbli",
"affaiblie" => "afEbli",
"affaiblies" => "afEbli",
"affaiblir" => "afebliR",
"affaiblira" => "afEbliRa",
"affaiblis" => "afEbli",
"affaiblissaient" => "afEblisE",
"affaiblissais" => "afEblisE",
"affaiblissait" => "afEblisE",
"affaiblissant" => "afeblis@",
"affaiblisse" => "afEblis",
"affaiblissement" => "afeblis°m@",
"affaiblissent" => "afEblis",
"affaiblissez" => "afEblise",
"affaiblissons" => "afEblis§",
"affaiblit" => "afEbli",
"affaira" => "afERa",
"affairai" => "afERE",
"affairaient" => "afERE",
"affairais" => "afERE",
"affairait" => "afERE",
"affairant" => "afER@",
"affaire" => "afER",
"affairé" => "afeRe",
"affairée" => "afeRe",
"affairées" => "afeRe",
"affairement" => "afER°m@",
"affairements" => "afER°m@",
"affairent" => "afER",
"affairer" => "afERe",
"affaireraient" => "afER°RE",
"affairèrent" => "afERER",
"affaires" => "afER",
"affairés" => "afeRe",
"affairions" => "afERj§",
"affairisme" => "afERizm",
"affairiste" => "afeRist",
"affairistes" => "afeRist",
"affairons" => "afER§",
"affaissa" => "afEsa",
"affaissaient" => "afEsE",
"affaissait" => "afEsE",
"affaissant" => "afEs@",
"affaisse" => "afEs",
"affaissé" => "afese",
"affaissée" => "afese",
"affaissées" => "afese",
"affaissement" => "afEs°m@",
"affaissements" => "afEs°m@",
"affaissent" => "afEs",
"affaisser" => "afese",
"affaisseraient" => "afEs°RE",
"affaisserait" => "afEs°RE",
"affaissèrent" => "afEsER",
"affaissés" => "afese",
"affaissions" => "afEsj§",
"affala" => "afala",
"affalai" => "afalE",
"affalaient" => "afalE",
"affalais" => "afalE",
"affalait" => "afalE",
"affalant" => "afal@",
"affale" => "afal",
"affalé" => "afale",
"affalée" => "afale",
"affalées" => "afale",
"affalement" => "afal°m@",
"affalent" => "afal",
"affaler" => "afale",
"affalèrent" => "afalER",
"affalés" => "afale",
"affalez" => "afale",
"affalons" => "afal§",
"affamaient" => "afamE",
"affamait" => "afamE",
"affamant" => "afam@",
"affamantes" => "afam@t",
"affame" => "afam",
"affamé" => "afame",
"affamée" => "afame",
"affamées" => "afame",
"affament" => "afam",
"affamer" => "afame",
"affamera" => "afam°Ra",
"affamés" => "afame",
"affamez" => "afame",
"affect" => "afEkt",
"affecta" => "afEkta",
"affectai" => "afEktE",
"affectaient" => "afEktE",
"affectais" => "afEktE",
"affectait" => "afEktE",
"affectâmes" => "afEktam",
"affectant" => "afEkt@",
"affectassent" => "afEktas",
"affectât" => "afEkta",
"affectation" => "afEktasj§",
"affectations" => "afEktasj§",
"affecte" => "afEkt",
"affecté" => "afEkte",
"affectée" => "afEkte",
"affectées" => "afEkte",
"affectent" => "afEkt",
"affecter" => "afEkte",
"affectera" => "afEkt°Ra",
"affecterai" => "afEkt°RE",
"affecteraient" => "afEkt°RE",
"affecterait" => "afEkt°RE",
"affectèrent" => "afEktER",
"affecteriez" => "afEkt°Rje",
"affecteront" => "afEkt°R§",
"affectés" => "afEkte",
"affectez" => "afEkte",
"affectiez" => "afEktje",
"affectif" => "afEktif",
"affectifs" => "afEktif",
"affection" => "afEksj§",
"affectionnaient" => "afEksjonE",
"affectionnais" => "afEksjonE",
"affectionnait" => "afEksjonE",
"affectionnant" => "afEksjon@",
"affectionne" => "afEksjOn",
"affectionné" => "afEksjone",
"affectionnée" => "afEksjone",
"affectionnent" => "afEksjOn",
"affectionner" => "afEksjone",
"affectionnés" => "afEksjone",
"affectionnez" => "afEksjone",
"affections" => "afEksj§",
"affective" => "afEktiv",
"affectivement" => "afEktiv°m@",
"affectives" => "afEktiv",
"affectivité" => "afEktivite",
"affectons" => "afEkt§",
"affectueuse" => "afEkt82z",
"affectueusement" => "afEkt82z°m@",
"affectueuses" => "afEkt82z",
"affectueux" => "afEkt82",
"afférent" => "afeR@",
"afférente" => "afeR@t",
"afférentes" => "afeR@t",
"afférents" => "afeR@",
"affermi" => "afERmi",
"affermie" => "afERmi",
"affermir" => "afERmiR",
"affermira" => "afERmiRa",
"affermis" => "afERmi",
"affermissaient" => "afERmisE",
"affermissait" => "afERmisE",
"affermissant" => "afERmis@",
"affermisse" => "afERmis",
"affermissement" => "afERmis°m@",
"affermissent" => "afERmis",
"affermit" => "afERmi",
"affétées" => "afete",
"afféterie" => "afet°Ri",
"afféteries" => "afet°Ri",
"afficha" => "afiSa",
"affichage" => "afiSaZ",
"affichages" => "afiSaZ",
"affichaient" => "afiSE",
"affichais" => "afiSE",
"affichait" => "afiSE",
"affichant" => "afiS@",
"affichât" => "afiSa",
"affiche" => "afiS",
"affiché" => "afiSe",
"affichée" => "afiSe",
"affichées" => "afiSe",
"affichent" => "afiS",
"afficher" => "afiSe",
"affichera" => "afiS°Ra",
"afficherai" => "afiS°RE",
"afficherait" => "afiS°RE",
"affichèrent" => "afiSER",
"affiches" => "afiS",
"affichés" => "afiSe",
"affichette" => "afiSEt",
"affichettes" => "afiSEt",
"afficheur" => "afiS9R",
"afficheurs" => "afiS9R",
"affichez" => "afiSe",
"affichions" => "afiSj§",
"affichiste" => "afiSist",
"affichistes" => "afiSist",
"affichons" => "afiS§",
"affidavit" => "afidavi",
"affidé" => "afide",
"affidée" => "afide",
"affidés" => "afide",
"affile" => "afil",
"affilé" => "afile",
"affilée" => "afile",
"affilées" => "afile",
"affiler" => "afile",
"affilés" => "afile",
"affilia" => "afilja",
"affiliaient" => "afiljE",
"affiliant" => "afilj@",
"affiliation" => "afiljasj§",
"affiliations" => "afiljasj§",
"affilié" => "afilje",
"affiliée" => "afilje",
"affiliées" => "afilje",
"affilier" => "afilje",
"affiliés" => "afilje",
"affin" => "af5",
"affina" => "afina",
"affinage" => "afinaZ",
"affinaient" => "afinE",
"affinait" => "afinE",
"affinant" => "afin@",
"affine" => "afin",
"affiné" => "afine",
"affinée" => "afine",
"affinées" => "afine",
"affinement" => "afin°m@",
"affinent" => "afin",
"affiner" => "afine",
"affinera" => "afin°Ra",
"affinerait" => "afin°RE",
"affinité" => "afinite",
"affinités" => "afinite",
"affinons" => "afin§",
"affiquets" => "afikE",
"affirma" => "afiRma",
"affirmai" => "afiRmE",
"affirmaient" => "afiRmE",
"affirmais" => "afiRmE",
"affirmait" => "afiRmE",
"affirmant" => "afiRm@",
"affirmât" => "afiRma",
"affirmatif" => "afiRmatif",
"affirmatifs" => "afiRmatif",
"affirmation" => "afiRmasj§",
"affirmations" => "afiRmasj§",
"affirmative" => "afiRmativ",
"affirmativement" => "afiRmativ°m@",
"affirme" => "afiRm",
"affirmé" => "afiRme",
"affirmée" => "afiRme",
"affirmées" => "afiRme",
"affirment" => "afiRm",
"affirmer" => "afiRme",
"affirmerai" => "afiRm°RE",
"affirmerait" => "afiRm°RE",
"affirmeras" => "afiRm°Ra",
"affirmèrent" => "afiRmER",
"affirmerez" => "afiRm°Re",
"affirmeriez" => "afiRm°Rje",
"affirmeront" => "afiRm°R§",
"affirmes" => "afiRm",
"affirmés" => "afiRme",
"affirmez" => "afiRme",
"affirmiez" => "afiRmje",
"affirmions" => "afiRmj§",
"affirmons" => "afiRm§",
"affixé" => "afikse",
"afflanqué" => "afl@ke",
"affleura" => "afl9Ra",
"affleuraient" => "afl9RE",
"affleurait" => "afl9RE",
"affleurant" => "afl9R@",
"affleurât" => "afl9Ra",
"affleure" => "afl9R",
"affleuré" => "afl9Re",
"affleurement" => "afl9R°m@",
"affleurements" => "afl9R°m@",
"affleurent" => "afl9R",
"affleurer" => "afl9Re",
"affleurèrent" => "afl9RER",
"affliction" => "afliksj§",
"afflictions" => "afliksj§",
"afflige" => "afliZ",
"affligé" => "afliZe",
"affligea" => "afliZa",
"affligeaient" => "afliZE",
"affligeait" => "afliZE",
"affligeant" => "afliZ@",
"affligeante" => "afliZ@t",
"affligeantes" => "afliZ@t",
"affligeants" => "afliZ@",
"affligée" => "afliZe",
"affligent" => "afliZ",
"affliger" => "afliZe",
"affligèrent" => "afliZER",
"affligés" => "afliZe",
"affligez" => "afliZe",
"afflua" => "aflya",
"affluaient" => "aflyE",
"affluait" => "aflyE",
"affluant" => "afly@",
"afflue" => "afly",
"afflué" => "aflye",
"affluence" => "afly@s",
"affluent" => "afly",
"affluentes" => "afly@t",
"affluents" => "afly@",
"affluer" => "aflye",
"afflueraient" => "aflyRE",
"affluèrent" => "aflyER",
"afflux" => "afly",
"affola" => "afola",
"affolai" => "afolE",
"affolaient" => "afolE",
"affolais" => "afolE",
"affolait" => "afolE",
"affolant" => "afol@",
"affolante" => "afol@t",
"affolantes" => "afol@t",
"affolants" => "afol@",
"affolât" => "afola",
"affole" => "afOl",
"affolé" => "afole",
"affolée" => "afole",
"affolées" => "afole",
"affolement" => "afOl°m@",
"affolent" => "afOl",
"affoler" => "afole",
"affolera" => "afOl°Ra",
"affolerais" => "afOl°RE",
"affolerait" => "afOl°RE",
"affolèrent" => "afolER",
"affoleront" => "afOl°R§",
"affoles" => "afOl",
"affolés" => "afole",
"affolez" => "afole",
"affoliez" => "afolje",
"affolons" => "afol§",
"affouage" => "afwaZ",
"affouages" => "afwaZ",
"affouillait" => "afujE",
"affouillé" => "afuje",
"affouillement" => "afuj°m@",
"affouillements" => "afuj°m@",
"affranchi" => "afR@Si",
"affranchie" => "afR@Si",
"affranchies" => "afR@Si",
"affranchir" => "afR@SiR",
"affranchirait" => "afR@SiRE",
"affranchis" => "afR@Si",
"affranchissais" => "afR@SisE",
"affranchissait" => "afR@SisE",
"affranchissant" => "afR@Sis@",
"affranchisse" => "afR@Sis",
"affranchissement" => "afR@Sism@",
"affranchit" => "afR@Si",
"affres" => "afR",
"affrète" => "afREt",
"affrété" => "afRete",
"affrètement" => "afREt°m@",
"affréter" => "afRete",
"affréterons" => "afRet°R§",
"affréteur" => "afRet9R",
"affrétez" => "afRete",
"affreuse" => "afR2z",
"affreusement" => "afR2z°m@",
"affreuses" => "afR2z",
"affreux" => "afR2",
"affriandai" => "afRij@dE",
"affriandé" => "afRij@de",
"affriander" => "afRij@de",
"affriandés" => "afRij@de",
"affriolait" => "afRijolE",
"affriolant" => "afRijol@",
"affriolante" => "afRijol@t",
"affriolantes" => "afRiol@t",
"affriolants" => "afRiol@",
"affriole" => "afRijOl",
"affrioler" => "afRijole",
"affriolerait" => "afRiOl°RE",
"affriolés" => "afRijole",
"affront" => "afR§",
"affronta" => "afR§ta",
"affrontai" => "afR§tE",
"affrontaient" => "afR§tE",
"affrontais" => "afR§tE",
"affrontait" => "afR§tE",
"affrontant" => "afR§t@",
"affronte" => "afR§t",
"affronté" => "afR§te",
"affrontée" => "afR§te",
"affrontées" => "afR§te",
"affrontement" => "afR§t°m@",
"affrontements" => "afR§t°m@",
"affrontent" => "afR§t",
"affronter" => "afR§te",
"affrontera" => "afR§t°Ra",
"affronterai" => "afR§t°RE",
"affronteraient" => "afR§t°RE",
"affronterais" => "afR§t°RE",
"affronterait" => "afR§t°RE",
"affronteras" => "afR§t°Ra",
"affrontèrent" => "afR§tER",
"affronterez" => "afR§t°Re",
"affronterons" => "afR§t°R§",
"affronteront" => "afR§t°R§",
"affrontes" => "afR§t",
"affrontés" => "afR§te",
"affrontez" => "afR§te",
"affrontiez" => "afR§tje",
"affrontions" => "afR§tj§",
"affrontons" => "afR§t§",
"affronts" => "afR§",
"affubla" => "afybla",
"affublait" => "afyblE",
"affublant" => "afybl@",
"affuble" => "afybl",
"affublé" => "afyble",
"affublée" => "afyble",
"affublées" => "afyble",
"affublement" => "afybl°m@",
"affublent" => "afybl",
"affubler" => "afyble",
"affublerais" => "afybl°RE",
"affublerait" => "afybl°RE",
"affublés" => "afyble",
"affublons" => "afybl§",
"affurait" => "afyRE",
"affure" => "afyR",
"affuré" => "afyRe",
"affurée" => "afyRe",
"affurer" => "afyRe",
"affures" => "afyR",
"affusions" => "afyzj§",
"affût" => "afy",
"affûta" => "afyta",
"affûtage" => "afytaZ",
"affûtait" => "afytE",
"affûtant" => "afyt@",
"affûtât" => "afyta",
"affûte" => "afyt",
"affûté" => "afyte",
"affûtée" => "afyte",
"affûtées" => "afyte",
"affûter" => "afyte",
"affûterai" => "afyt°RE",
"affûtés" => "afyte",
"affûteur" => "afyt9R",
"affûtez" => "afyte",
"affûts" => "afy",
"afghan" => "afg@",
"afghane" => "afgan",
"afghanes" => "afgan",
"afghans" => "afg@",
"aficionado" => "afisjonado",
"aficionados" => "afisjonado",
"afin" => "af5",
"afin d" => "af5d",
"afin de" => "af5d°",
"afin qu" => "af5k8y",
"afin que" => "af5k",
"africain" => "afRik5",
"africaine" => "afRikEn",
"africaines" => "afRikEn",
"africains" => "afRik5",
"africanisme" => "afRikanism",
"afrikaans" => "afRik@s",
"afrikaner" => "afRikan9R",
"afrikaners" => "afRikanER",
"afro" => "afRo",
"afro-américain" => "afRoameRik5",
"afro-américaine" => "afRoameRikEn",
"afro-américains" => "afRoameRik5",
"afro-asiatique" => "afROazjatik",
"afro-brésilienne" => "afRobReziljEn",
"afro-cubain" => "afRokyb5",
"afro-cubaine" => "afRokybEn",
"afro-cubains" => "afRokyb5",
"after shave" => "aftERSav",
"after-shave" => "aft9RSav",
"aga" => "aga",
"agaça" => "agasa",
"agaçaient" => "agasE",
"agaçais" => "agasE",
"agaçait" => "agasE",
"agaçant" => "agas@",
"agaçante" => "agas@t",
"agaçantes" => "agas@t",
"agaçants" => "agas@",
"agace" => "agas",
"agacé" => "agase",
"agacée" => "agase",
"agacées" => "agase",
"agacement" => "agas°m@",
"agacements" => "agas°m@",
"agacent" => "agas",
"agacer" => "agase",
"agacera" => "agas°Ra",
"agacerait" => "agas°RE",
"agaceras" => "agas°Ra",
"agacèrent" => "agasER",
"agacerie" => "agas°Ri",
"agaceries" => "agas°Ri",
"agaceront" => "agas°R§",
"agaces" => "agas",
"agacés" => "agase",
"agaceur" => "agas9R",
"agacez" => "agase",
"agames" => "agam",
"agami" => "agami",
"agapanthe" => "agap@t",
"agapanthes" => "agap@t",
"agape" => "agap",
"agapes" => "agap",
"agar-agar" => "agaRagaR",
"agas" => "aga",
"agasses" => "agas",
"agate" => "agat",
"agates" => "agat",
"agathe" => "agat",
"agave" => "agav",
"agaves" => "agav",
"age" => "aZ",
"âge" => "aZ",
"âgé" => "aZe",
"âgée" => "aZe",
"âgées" => "aZe",
"agença" => "aZ@sa",
"agençaient" => "aZ@sE",
"agençait" => "aZ@sE",
"agençant" => "aZ@s@",
"agence" => "aZ@s",
"agencé" => "aZ@se",
"agencée" => "aZ@se",
"agencées" => "aZ@se",
"agencement" => "aZ@s°m@",
"agencements" => "aZ@s°m@",
"agencer" => "aZ@se",
"agences" => "aZ@s",
"agencés" => "aZ@se",
"agenda" => "aZ5da",
"agendas" => "aZ5da",
"agenouilla" => "aZ°nuja",
"agenouillai" => "aZ°nujE",
"agenouillaient" => "aZ°nujE",
"agenouillais" => "aZ°nujE",
"agenouillait" => "aZ°nujE",
"agenouillant" => "aZ°nuj@",
"agenouillât" => "aZ°nuja",
"agenouille" => "aZ°nuj",
"agenouillé" => "aZ°nuje",
"agenouillée" => "aZ°nuje",
"agenouillées" => "aZ°nuje",
"agenouillement" => "aZnuj°m@",
"agenouillent" => "aZ°nuj",
"agenouiller" => "aZ°nuje",
"agenouillera" => "aZ°nuj°Ra",
"agenouillèrent" => "aZ°nujER",
"agenouilleront" => "aZ°nuj°R§",
"agenouilles" => "aZ°nuj",
"agenouillés" => "aZ°nuje",
"agenouillez" => "aZ°nuje",
"agenouillons" => "aZ°nuj§",
"agent" => "aZ@",
"agente" => "aZ@t",
"agents" => "aZ@",
"ages" => "aZ",
"âges" => "aZ",
"âgés" => "aZe",
"aggiornamento" => "aZjORnamEnto",
"agglo" => "aglo",
"aggloméraient" => "aglomeRE",
"agglomérant" => "aglomeR@",
"agglomérat" => "aglomeRa",
"agglomération" => "aglomeRasj§",
"agglomérations" => "aglomeRasj§",
"agglomère" => "aglomER",
"aggloméré" => "aglomeRe",
"agglomérée" => "aglomeRe",
"agglomérées" => "aglomeRe",
"agglomèrent" => "aglomER",
"agglomérer" => "aglomeRe",
"agglomérera" => "aglomeR°Ra",
"aggloméreront" => "aglomeR°R§",
"agglomérés" => "aglomeRe",
"agglutina" => "aglytina",
"agglutinaient" => "aglytinE",
"agglutinait" => "aglytinE",
"agglutinant" => "aglytin@",
"agglutinatif" => "aglytinatif",
"agglutination" => "aglytinasj§",
"agglutine" => "aglytin",
"agglutiné" => "aglytine",
"agglutinée" => "aglytine",
"agglutinées" => "aglytine",
"agglutinement" => "aglytin°m@",
"agglutinent" => "aglytin",
"agglutiner" => "aglytine",
"agglutinèrent" => "aglytinER",
"agglutinés" => "aglytine",
"agglutinez" => "aglytine",
"agglutinogène" => "aglytinoZEn",
"aggrava" => "agRava",
"aggravai" => "agRavE",
"aggravaient" => "agRavE",
"aggravait" => "agRavE",
"aggravant" => "agRav@",
"aggravante" => "agRav@t",
"aggravantes" => "agRav@t",
"aggravation" => "agRavasj§",
"aggrave" => "agRav",
"aggravé" => "agRave",
"aggravée" => "agRave",
"aggravées" => "agRave",
"aggravent" => "agRav",
"aggraver" => "agRave",
"aggravera" => "agRav°Ra",
"aggraverait" => "agRav°RE",
"aggravèrent" => "agRavER",
"aggraveriez" => "agRav°Rje",
"aggravés" => "agRave",
"aggravez" => "agRave",
"aggraviez" => "agRavje",
"aggravons" => "agRav§",
"aghas" => "aga",
"agi" => "aZi",
"agie" => "aZi",
"agile" => "aZil",
"agiles" => "aZil",
"agilité" => "aZilite",
"agilités" => "aZilite",
"agios" => "aZjo",
"agioteur" => "aZjot9R",
"agir" => "aZiR",
"agira" => "aZiRa",
"agirai" => "aZiRE",
"agiraient" => "aZiRE",
"agirais" => "aZiRE",
"agirait" => "aZiRE",
"agiras" => "aZiRa",
"agirent" => "aZiR",
"agirez" => "aZiRe",
"agiriez" => "aZiRje",
"agirons" => "aZiR§",
"agiront" => "aZiR§",
"agis" => "aZi",
"âgisme" => "aZism",
"agissaient" => "aZisE",
"agissais" => "aZisE",
"agissait" => "aZisE",
"agissant" => "aZis@",
"agissante" => "aZis@t",
"agissantes" => "aZis@t",
"agisse" => "aZis",
"agissement" => "aZis°m@",
"agissements" => "aZis°m@",
"agissent" => "aZis",
"agisses" => "aZis",
"agissez" => "aZise",
"agissiez" => "aZisje",
"agissions" => "aZisj§",
"agissons" => "aZis§",
"agit" => "aZi",
"agît" => "aZi",
"agit-prop" => "aZitpROp",
"agita" => "aZita",
"agitai" => "aZitE",
"agitaient" => "aZitE",
"agitais" => "aZitE",
"agitait" => "aZitE",
"agitant" => "aZit@",
"agitassent" => "aZitas",
"agitât" => "aZita",
"agitateur" => "aZitat9R",
"agitateurs" => "aZitat9R",
"agitation" => "aZitasj§",
"agitations" => "aZitasj§",
"agitato" => "aZitato",
"agitatrice" => "aZitatRis",
"agite" => "aZit",
"agité" => "aZite",
"agitée" => "aZite",
"agitées" => "aZite",
"agitent" => "aZit",
"agiter" => "aZite",
"agitera" => "aZit°Ra",
"agiterai" => "aZit°RE",
"agiterait" => "aZit°RE",
"agitèrent" => "aZitER",
"agiteront" => "aZit°R§",
"agites" => "aZit",
"agités" => "aZite",
"agitez" => "aZite",
"agitiez" => "aZitje",
"agitions" => "aZitj§",
"agitons" => "aZit§",
"aglagla" => "aglagla",
"agnat" => "aNa",
"agnathes" => "aNat",
"agneau" => "aNo",
"agneaux" => "aNo",
"agnela" => "aN2la",
"agnelage" => "aN2laZ",
"agnelet" => "aN2lE",
"agneline" => "aN2lin",
"agnelle" => "aNEl",
"agnelles" => "aNEl",
"agnosie" => "agnozi",
"agnostique" => "agnostik",
"agnostiques" => "agnostik",
"agnus dei" => "agnusdei",
"agnus-dei" => "agnusdei",
"agonie" => "agoni",
"agonies" => "agoni",
"agonique" => "agonik",
"agoniques" => "agonik",
"agonir" => "agoniR",
"agonirent" => "agoniR",
"agonisa" => "agoniza",
"agonisai" => "agonizE",
"agonisaient" => "agonizE",
"agonisais" => "agonizE",
"agonisait" => "agonizE",
"agonisant" => "agoniz@",
"agonisante" => "agoniz@t",
"agonisantes" => "agoniz@t",
"agonisants" => "agoniz@",
"agonise" => "agoniz",
"agonisé" => "agonize",
"agonisent" => "agoniz",
"agoniser" => "agonize",
"agonisez" => "agonize",
"agonisiez" => "agonizje",
"agonissait" => "agonisE",
"agoniste" => "agonist",
"agonit" => "agoni",
"agora" => "agoRa",
"agoraphobe" => "agoRafOb",
"agoraphobes" => "agoRafOb",
"agoraphobie" => "agoRafobi",
"agouti" => "aguti",
"agoutis" => "aguti",
"agoyate" => "agojat",
"agoyates" => "agojat",
"agrafa" => "agRafa",
"agrafage" => "agRafaZ",
"agrafait" => "agRafE",
"agrafant" => "agRaf@",
"agrafe" => "agRaf",
"agrafé" => "agRafe",
"agrafée" => "agRafe",
"agrafées" => "agRafe",
"agrafent" => "agRaf",
"agrafer" => "agRafe",
"agraferai" => "agRaf°RE",
"agrafes" => "agRaf",
"agrafés" => "agRafe",
"agrafeur" => "agRaf9R",
"agrafeuse" => "agRaf2z",
"agrafeuses" => "agRaf2z",
"agrafez" => "agRafe",
"agrafons" => "agRaf§",
"agrainage" => "agREnaZ",
"agraire" => "agRER",
"agraires" => "agRER",
"agrandi" => "agR@di",
"agrandie" => "agR@di",
"agrandies" => "agR@di",
"agrandir" => "agR@diR",
"agrandira" => "agR@diRa",
"agrandirai" => "agR@diRE",
"agrandirait" => "agR@diRE",
"agrandirent" => "agR@diR",
"agrandiront" => "agR@diR§",
"agrandis" => "agR@di",
"agrandissaient" => "agR@disE",
"agrandissait" => "agR@disE",
"agrandissant" => "agR@dis@",
"agrandissement" => "agR@dis°m@",
"agrandissements" => "agR@dis°m@",
"agrandissent" => "agR@dis",
"agrandisseur" => "agR@dis9R",
"agrandisseurs" => "agR@dis9R",
"agrandissez" => "agR@dise",
"agrandissons" => "agR@dis§",
"agrandit" => "agR@di",
"agrandît" => "agR@di",
"agranulocytose" => "agRanylositoz",
"agrarien" => "agRaRj5",
"agréa" => "agRea",
"agréable" => "agReabl",
"agréablement" => "agReabl°m@",
"agréables" => "agReabl",
"agréaient" => "agReE",
"agréais" => "agReE",
"agréait" => "agReE",
"agrée" => "agRe",
"agréé" => "agRee",
"agréée" => "agRee",
"agréées" => "agRee",
"agréent" => "agRe",
"agréer" => "agRee",
"agréera" => "agReRa",
"agréerait" => "agReRE",
"agrées" => "agRe",
"agréés" => "agRee",
"agréez" => "agRee",
"agrég" => "agReg",
"agrégat" => "agRega",
"agrégatif" => "agRegatif",
"agrégatifs" => "agRegatif",
"agrégation" => "agRegasj§",
"agrégative" => "agRegativ",
"agrégats" => "agRega",
"agrège" => "agREZ",
"agrégé" => "agReZe",
"agrégeaient" => "agReZE",
"agrégeait" => "agReZE",
"agrégée" => "agReZe",
"agrégées" => "agReZe",
"agrègent" => "agREZ",
"agréger" => "agReZe",
"agrégés" => "agReZe",
"agréions" => "agRej§",
"agrément" => "agRem@",
"agrémenta" => "agRem@ta",
"agrémentaient" => "agRem@tE",
"agrémentait" => "agRem@tE",
"agrémentant" => "agRem@t@",
"agrémente" => "agRem@t",
"agrémenté" => "agRem@te",
"agrémentée" => "agRem@te",
"agrémentées" => "agRem@te",
"agrémentent" => "agRem@t",
"agrémenter" => "agRem@te",
"agrémentés" => "agRem@te",
"agréments" => "agRem@",
"agrès" => "agRE",
"agressa" => "agREsa",
"agressaient" => "agREsE",
"agressais" => "agREsE",
"agressait" => "agREsE",
"agressant" => "agREs@",
"agresse" => "agREs",
"agressé" => "agRese",
"agressée" => "agRese",
"agressées" => "agRese",
"agressent" => "agREs",
"agresser" => "agRese",
"agresseraient" => "agREs°RE",
"agresserait" => "agREs°RE",
"agressés" => "agRese",
"agresseur" => "agREs9R",
"agresseurs" => "agRes9R",
"agressez" => "agREse",
"agressif" => "agREsif",
"agressifs" => "agResif",
"agression" => "agREsj§",
"agressions" => "agResj§",
"agressive" => "agREsiv",
"agressivement" => "agResiv°m@",
"agressives" => "agResiv",
"agressivité" => "agResivite",
"agressivités" => "agResivite",
"agreste" => "agREst",
"agrestes" => "agREst",
"agriche" => "agRiS",
"agriches" => "agRiS",
"agricole" => "agRikOl",
"agricoles" => "agRikOl",
"agriculteur" => "agRikylt9R",
"agriculteurs" => "agRikylt9R",
"agricultrice" => "agRikyltRis",
"agricultrices" => "agRikyltRis",
"agriculture" => "agRikyltyR",
"agrippa" => "agRipa",
"agrippai" => "agRipE",
"agrippaient" => "agRipE",
"agrippais" => "agRipE",
"agrippait" => "agRipE",
"agrippant" => "agRip@",
"agrippants" => "agRip@",
"agrippe" => "agRip",
"agrippé" => "agRipe",
"agrippée" => "agRipe",
"agrippées" => "agRipe",
"agrippement" => "agRip°m@",
"agrippent" => "agRip",
"agripper" => "agRipe",
"agrippèrent" => "agRipER",
"agrippes" => "agRip",
"agrippés" => "agRipe",
"agrippez" => "agRipe",
"agrippions" => "agRipj§",
"agro" => "agRo",
"agro-alimentaire" => "agRoalim@tER",
"agroalimentaire" => "agRoalim@tER",
"agronome" => "agRonom",
"agronomes" => "agRonom",
"agronomie" => "agRonomi",
"agronomique" => "agRonomik",
"agrovilles" => "agRovij",
"agrume" => "agRym",
"agrumes" => "agRym",
"aguardiente" => "agwaRdjEnte",
"aguerri" => "agERi",
"aguerrie" => "agERi",
"aguerries" => "agERi",
"aguerrir" => "ageRiR",
"aguerrira" => "agERiRa",
"aguerris" => "agERi",
"aguerrissait" => "agERisE",
"aguerrit" => "agERi",
"aguichage" => "agiSaZ",
"aguichait" => "agiSE",
"aguichant" => "agiS@",
"aguichante" => "agiS@t",
"aguichantes" => "agiS@t",
"aguiche" => "agiS",
"aguichent" => "agiS",
"aguicher" => "agiSe",
"aguicheur" => "agiS9R",
"aguicheurs" => "agiS9R",
"aguicheuse" => "agiS2z",
"aguicheuses" => "agiS2z",
"aguillera" => "agij°Ra",
"ah" => "a",
"ahan" => "a@",
"ahana" => "aana",
"ahanaient" => "aanE",
"ahanait" => "aanE",
"ahanant" => "aan@",
"ahanante" => "aan@t",
"ahane" => "aan",
"ahané" => "aane",
"ahanement" => "aan°m@",
"ahanements" => "aan°m@",
"ahanent" => "aan",
"ahaner" => "aane",
"ahans" => "a@",
"ahi" => "ai",
"ahou" => "au",
"ahuri" => "ayRi",
"ahurie" => "ayRi",
"ahuries" => "ayRi",
"ahurir" => "ayRiR",
"ahuris" => "ayRi",
"ahurissait" => "ayRisE",
"ahurissant" => "ayRis@",
"ahurissante" => "ayRis@t",
"ahurissantes" => "ayRis@t",
"ahurissants" => "ayRis@",
"ahurissement" => "ayRis°m@",
"ahurissements" => "ayRis°m@",
"ahurit" => "ayRi",
"ai" => "E",
"aï" => "ai",
"aicher" => "ESe",
"aïd" => "aid",
"aida" => "Eda",
"aidai" => "EdE",
"aidaient" => "EdE",
"aidais" => "EdE",
"aidait" => "EdE",
"aidant" => "Ed@",
"aidassent" => "Edas",
"aidât" => "Eda",
"aide" => "Ed",
"aidé" => "Ede",
"aide-bourreau" => "EdbuRo",
"aide-comptable" => "Edk§tabl",
"aide-cuisinier" => "Edk8izinje",
"aide-infirmier" => "Ed5fiRmje",
"aide-jardinier" => "EdZaRdinje",
"aide-major" => "EdmaZOR",
"aide-mémoire" => "EdmemwaR",
"aide-ménagère" => "EdmenaZER",
"aide-pharmacien" => "EdfaRmasj5",
"aide-soignant" => "EdswaN@",
"aide-soignante" => "EdswaN@t",
"aidée" => "Ede",
"aidées" => "Ede",
"aident" => "Ed",
"aider" => "ede",
"aidera" => "Ed°Ra",
"aiderai" => "Ed°RE",
"aideraient" => "Ed°RE",
"aiderais" => "Ed°RE",
"aiderait" => "Ed°RE",
"aideras" => "Ed°Ra",
"aidèrent" => "EdER",
"aiderez" => "Ed°Re",
"aideriez" => "Ed°Rje",
"aiderions" => "Ed°Rj§",
"aiderons" => "Ed°R§",
"aideront" => "Ed°R§",
"aides" => "Ed",
"aidés" => "Ede",
"aides-soignantes" => "EdswaN@t",
"aides-soignants" => "EdswaN@",
"aidez" => "Ede",
"aidiez" => "Edje",
"aidions" => "Edj§",
"aidons" => "Ed§",
"aie" => "E",
"aïe" => "aj",
"aient" => "E",
"aies" => "E",
"aïeul" => "aj9l",
"aïeule" => "aj9l",
"aïeules" => "aj9l",
"aïeuls" => "aj9l",
"aïeux" => "aj2",
"aigle" => "Egl",
"aiglefin" => "Egl°f5",
"aigles" => "Egl",
"aiglon" => "Egl§",
"aiglons" => "Egl§",
"aigre" => "EgR",
"aigre-douce" => "EgR°dus",
"aigre-doux" => "EgR°du",
"aigrelet" => "EgR°lE",
"aigrelets" => "EgR°lE",
"aigrelette" => "EgR°lEt",
"aigrelettes" => "EgR°lEt",
"aigrement" => "EgR°m@",
"aigres" => "EgR",
"aigres-douces" => "EgR°dus",
"aigres-doux" => "EgR°du",
"aigrette" => "EgREt",
"aigrettes" => "EgREt",
"aigreur" => "EgR9R",
"aigreurs" => "EgR9R",
"aigri" => "egRi",
"aigrie" => "egRi",
"aigries" => "egRi",
"aigrir" => "egRiR",
"aigrirent" => "egRiR",
"aigris" => "egRi",
"aigrissaient" => "egRisE",
"aigrissait" => "egRisE",
"aigrissent" => "egRis",
"aigrit" => "egRi",
"aigu" => "egy",
"aiguade" => "Egad",
"aiguail" => "Egaj",
"aigue" => "Eg",
"aiguë" => "egy",
"aigue-marine" => "EgmaRin",
"aiguës" => "egy",
"aigues-marines" => "EgmaRin",
"aiguière" => "EgjER",
"aiguilla" => "eg8ija",
"aiguillage" => "eg8ijaZ",
"aiguillages" => "eg8ijaZ",
"aiguillant" => "eg8ij@",
"aiguillat" => "eg8ija",
"aiguille" => "eg8ij",
"aiguillé" => "eg8ije",
"aiguillée" => "eg8ije",
"aiguillées" => "eg8ije",
"aiguiller" => "eg8ije",
"aiguilles" => "eg8ij",
"aiguillés" => "eg8ije",
"aiguillettes" => "eg8ijEt",
"aiguilleur" => "eg8ij9R",
"aiguilleurs" => "eg8ij9R",
"aiguillon" => "eg8ij§",
"aiguillonnaient" => "eg8ijonE",
"aiguillonnait" => "eg8ijonE",
"aiguillonnant" => "eg8ijon@",
"aiguillonnante" => "Eg8ijon@t",
"aiguillonne" => "eg8ijOn",
"aiguillonné" => "eg8ijone",
"aiguillonnée" => "eg8ijone",
"aiguillonnées" => "eg8ijone",
"aiguillonnent" => "eg8ijOn",
"aiguillonner" => "eg8ijone",
"aiguillonnés" => "eg8ijone",
"aiguillons" => "eg8ij§",
"aiguisa" => "egiza",
"aiguisai" => "egizE",
"aiguisaient" => "egizE",
"aiguisait" => "egizE",
"aiguisant" => "egiz@",
"aiguisas" => "egiza",
"aiguise" => "egiz",
"aiguisé" => "egize",
"aiguisée" => "egize",
"aiguisées" => "egize",
"aiguisent" => "egiz",
"aiguiser" => "egize",
"aiguisera" => "Egiz°Ra",
"aiguiserai" => "egiz°RE",
"aiguisèrent" => "egizER",
"aiguisés" => "egize",
"aiguiseur" => "egiz9R",
"aiguisez" => "Egize",
"aiguisoir" => "egizwaR",
"aiguisons" => "Egiz§",
"aigus" => "egy",
"aïkido" => "ajkido",
"ail" => "aj",
"aile" => "El",
"ailé" => "ele",
"ailée" => "ele",
"ailées" => "ele",
"aileron" => "El°R§",
"ailerons" => "El°R§",
"ailes" => "El",
"ailés" => "ele",
"ailette" => "ElEt",
"ailettes" => "ElEt",
"ailier" => "elje",
"ailiers" => "elje",
"aillais" => "ajE",
"aille" => "aj",
"aillé" => "aje",
"aillée" => "aje",
"aillent" => "aj",
"ailler" => "aje",
"ailles" => "aj",
"aillés" => "aje",
"ailleurs" => "aj9R",
"aillions" => "aj§",
"aillons" => "aj§",
"aima" => "Ema",
"aimable" => "Emabl",
"aimablement" => "Emabl°m@",
"aimables" => "Emabl",
"aimai" => "EmE",
"aimaient" => "EmE",
"aimais" => "EmE",
"aimait" => "EmE",
"aimâmes" => "Emam",
"aimant" => "Em@",
"aimantaient" => "Em@tE",
"aimantait" => "Em@tE",
"aimantation" => "Em@tasj§",
"aimante" => "Em@t",
"aimanté" => "Em@te",
"aimantée" => "Em@te",
"aimantées" => "Em@te",
"aimanter" => "Em@te",
"aimantes" => "Em@t",
"aimantés" => "Em@te",
"aimants" => "Em@",
"aimasse" => "Emas",
"aimassent" => "Emas",
"aimassions" => "Emasj§",
"aimât" => "Ema",
"aimâtes" => "Emat",
"aime" => "Em",
"aimé" => "eme",
"aimée" => "eme",
"aimées" => "eme",
"aiment" => "Em",
"aimer" => "eme",
"aimera" => "Em°Ra",
"aimerai" => "Em°RE",
"aimeraient" => "Em°RE",
"aimerais" => "Em°RE",
"aimerait" => "Em°RE",
"aimeras" => "Em°Ra",
"aimèrent" => "EmER",
"aimerez" => "Em°Re",
"aimeriez" => "Em°Rje",
"aimerions" => "Em°Rj§",
"aimerons" => "Em°R§",
"aimeront" => "Em°R§",
"aimes" => "Em",
"aimés" => "eme",
"aimeuse" => "Em2z",
"aimez" => "Eme",
"aimiez" => "Emje",
"aimions" => "Emj§",
"aimons" => "Em§",
"aine" => "En",
"aîné" => "ene",
"aînée" => "ene",
"aînées" => "ene",
"aines" => "En",
"aînés" => "ene",
"aînesse" => "EnEs",
"ains" => "5s",
"ainsi" => "5si",
"aïoli" => "ajoli",
"air" => "ER",
"air bag" => "ERbag",
"air-air" => "ERER",
"air-mer" => "ERmER",
"air-sol" => "ERsOl",
"airain" => "ER5",
"airbag" => "ERbag",
"airbags" => "ERba",
"airbus" => "ERbys",
"aire" => "ER",
"airedale" => "ERdEl",
"airelle" => "EREl",
"airelles" => "EREl",
"aires" => "ER",
"airs" => "ER",
"ais" => "e",
"aisance" => "Ez@s",
"aisances" => "Ez@s",
"aise" => "Ez",
"aisé" => "eze",
"aisée" => "eze",
"aisées" => "eze",
"aisément" => "ezem@",
"aises" => "Ez",
"aisés" => "eze",
"aisseau" => "Eso",
"aisselle" => "EsEl",
"aisselles" => "EsEl",
"ait" => "e",
"aître" => "EtR",
"aîtres" => "EtR",
"aixois" => "Ekswa",
"ajaccienne" => "aZaksjEn",
"ajax" => "aZaks",
"ajistes" => "aZist",
"ajointée" => "aZw5te",
"ajointer" => "aZw5te",
"ajonc" => "aZ§",
"ajoncs" => "aZ§",
"ajouraient" => "aZuRE",
"ajourait" => "aZuRE",
"ajourant" => "aZuR@",
"ajouré" => "aZuRe",
"ajourée" => "aZuRe",
"ajourées" => "aZuRe",
"ajourés" => "aZuRe",
"ajourna" => "aZuRna",
"ajournait" => "aZuRnE",
"ajourne" => "aZuRn",
"ajourné" => "aZuRne",
"ajournée" => "aZuRne",
"ajournement" => "aZuRn°m@",
"ajournements" => "aZuRn°m@",
"ajourner" => "aZuRne",
"ajournés" => "aZuRne",
"ajournez" => "aZuRne",
"ajours" => "aZuR",
"ajout" => "aZu",
"ajouta" => "aZuta",
"ajoutai" => "aZutE",
"ajoutaient" => "aZutE",
"ajoutais" => "aZutE",
"ajoutait" => "aZutE",
"ajoutant" => "aZut@",
"ajoutassent" => "aZutas",
"ajoutât" => "aZuta",
"ajoute" => "aZut",
"ajouté" => "aZute",
"ajoutée" => "aZute",
"ajoutées" => "aZute",
"ajoutent" => "aZut",
"ajouter" => "aZute",
"ajoutera" => "aZut°Ra",
"ajouterai" => "aZut°RE",
"ajouteraient" => "aZut°RE",
"ajouterais" => "aZut°RE",
"ajouterait" => "aZut°RE",
"ajouteras" => "aZut°Ra",
"ajoutèrent" => "aZutER",
"ajouterez" => "aZut°Re",
"ajouterons" => "aZut°R§",
"ajouteront" => "aZut°R§",
"ajoutes" => "aZut",
"ajoutés" => "aZute",
"ajoutez" => "aZute",
"ajoutiez" => "aZutje",
"ajoutions" => "aZutj§",
"ajoutons" => "aZut§",
"ajouts" => "aZu",
"ajusta" => "aZysta",
"ajustable" => "aZystabl",
"ajustables" => "aZystabl",
"ajustage" => "aZystaZ",
"ajustaient" => "aZystE",
"ajustais" => "aZystE",
"ajustait" => "aZystE",
"ajustant" => "aZyst@",
"ajuste" => "aZyst",
"ajusté" => "aZyste",
"ajustée" => "aZyste",
"ajustées" => "aZyste",
"ajustement" => "aZyst°m@",
"ajustements" => "aZyst°m@",
"ajustent" => "aZyst",
"ajuster" => "aZyste",
"ajusterai" => "aZyst°RE",
"ajustèrent" => "aZystER",
"ajustés" => "aZyste",
"ajusteur" => "aZyst9R",
"ajusteurs" => "aZyst9R",
"ajustez" => "aZyste",
"ajustons" => "aZyst§",
"ajusture" => "aZystyR",
"ajutage" => "aZytaZ",
"akkadien" => "akadj5",
"akkadienne" => "akadjEn",
"ako" => "ako",
"akvavit" => "akvavit",
"al dente" => "aldEnte",
"alabandines" => "alab@din",
"alacrité" => "alakRite",
"alain" => "al5",
"alaire" => "alER",
"alaise" => "alEz",
"alambic" => "al@bik",
"alambics" => "al@bik",
"alambiqué" => "al@bike",
"alambiquée" => "al@bike",
"alambiquées" => "al@bike",
"alambiqués" => "al@bike",
"alangui" => "al@gi",
"alanguie" => "al@gi",
"alanguies" => "al@gi",
"alanguir" => "al@giR",
"alanguis" => "al@gi",
"alanguissaient" => "al@gisE",
"alanguissait" => "al@gisE",
"alanguissant" => "al@gis@",
"alanguissante" => "al@gis@t",
"alanguissement" => "al@gis°m@",
"alanguissements" => "al@gis°m@",
"alanguissent" => "al@gis",
"alanguit" => "al@gi",
"alarma" => "alaRma",
"alarmai" => "alaRmE",
"alarmaient" => "alaRmE",
"alarmait" => "alaRmE",
"alarmant" => "alaRm@",
"alarmante" => "alaRm@t",
"alarmantes" => "alaRm@t",
"alarmants" => "alaRm@",
"alarme" => "alaRm",
"alarmé" => "alaRme",
"alarmée" => "alaRme",
"alarmées" => "alaRme",
"alarmer" => "alaRme",
"alarmeraient" => "alaRm°RE",
"alarmerait" => "alaRm°RE",
"alarmes" => "alaRm",
"alarmés" => "alaRme",
"alarmez" => "alaRme",
"alarmisme" => "alaRmizm",
"alarmiste" => "alaRmist",
"alarmistes" => "alaRmist",
"alba" => "alba",
"albacore" => "albakOR",
"albanais" => "albanE",
"albanaise" => "albanEz",
"albanaises" => "albanEz",
"albanophone" => "albanofOn",
"albâtre" => "albatR",
"albâtres" => "albatR",
"albatros" => "albatRos",
"albe" => "alb",
"albène" => "albEn",
"albertine" => "albERtin",
"albigeois" => "albiZwa",
"albinisme" => "albinism",
"albinos" => "albinos",
"alboche" => "albOS",
"albugo" => "albygo",
"album" => "albOm",
"albumine" => "albymin",
"albumines" => "albymin",
"albumineuse" => "albymin2z",
"albums" => "albOm",
"alcade" => "alkad",
"alcalde" => "alkald",
"alcali" => "alkali",
"alcalin" => "alkal5",
"alcaline" => "alkalin",
"alcalines" => "alkalin",
"alcaliniser" => "alkalinize",
"alcalinité" => "alkalinite",
"alcalins" => "alkal5",
"alcalis" => "alkali",
"alcaloïde" => "alkalOid",
"alcalose" => "alkaloz",
"alcatraz" => "alkatRaz",
"alcazar" => "alkazaR",
"alcées" => "alse",
"alchimie" => "alSimi",
"alchimies" => "alSimi",
"alchimique" => "alSimik",
"alchimiques" => "alSimik",
"alchimiste" => "alSimist",
"alchimistes" => "alSimist",
"alcibiade" => "alsibjad",
"alcool" => "alkOl",
"alcoolémie" => "alkolemi",
"alcoolique" => "alkolik",
"alcooliques" => "alkolik",
"alcoolise" => "alkoliz",
"alcoolisé" => "alkolize",
"alcoolisée" => "alkolize",
"alcoolisées" => "alkolize",
"alcoolisés" => "alkolize",
"alcoolisme" => "alkolizm",
"alcoolo" => "alkolo",
"alcoolos" => "alkolo",
"alcools" => "alkOl",
"alcoomètre" => "alkomEtR",
"alcootest" => "alkotEst",
"alcoran" => "alkoR@",
"alcôve" => "alkov",
"alcôves" => "alkov",
"alcyon" => "alsj§",
"alcyons" => "alsj§",
"alde" => "ald",
"aldéhyde" => "aldeid",
"alderman" => "aldERman",
"aldol" => "aldOl",
"ale" => "al",
"aléa" => "alea",
"alea jacta est" => "aleaZaktaEst",
"aléas" => "alea",
"aléatoire" => "aleatwaR",
"aléatoirement" => "aleatwaR°m@",
"aléatoires" => "aleatwaR",
"alémaniques" => "alemanik",
"alençonnais" => "al@sonE",
"alençonnaise" => "al@sonEz",
"alène" => "alEn",
"alenti" => "al@ti",
"alentie" => "al@ti",
"alenties" => "al@ti",
"alentis" => "al@ti",
"alentour" => "al@tuR",
"alentours" => "al@tuR",
"aléoutien" => "aleusj5",
"aleph" => "alEf",
"alerta" => "alERta",
"alertait" => "alERtE",
"alertant" => "alERt@",
"alertât" => "alERta",
"alerte" => "alERt",
"alerté" => "alERte",
"alertée" => "alERte",
"alertées" => "alERte",
"alertement" => "alERt°m@",
"alertent" => "alERt",
"alerter" => "alERte",
"alertera" => "alERt°Ra",
"alerterai" => "alERt°RE",
"alerterais" => "alERt°RE",
"alerterait" => "alERt°RE",
"alertèrent" => "alERtER",
"alerterez" => "alERt°Re",
"alerteront" => "alERt°R§",
"alertes" => "alERt",
"alertés" => "alERte",
"alertez" => "alERte",
"alertions" => "alERtj§",
"alertons" => "alERt§",
"alésait" => "alezE",
"alèse" => "alEz",
"aléser" => "aleze",
"alevin" => "al°v5",
"alevins" => "al°v5",
"alexandra" => "alEks@dRa",
"alexandrin" => "alEks@dR5",
"alexandrine" => "alEks@dRin",
"alexandrines" => "alEks@dRin",
"alexandrins" => "alEks@dR5",
"alexie" => "alEksi",
"alexithymie" => "alEksitimi",
"alezan" => "al°z@",
"alezane" => "al°zan",
"alezanes" => "al°zan",
"alezans" => "al°z@",
"alèze" => "alEz",
"alfa" => "alfa",
"alfas" => "alfa",
"alfénides" => "alfenid",
"algarade" => "algaRad",
"algarades" => "algaRad",
"algèbre" => "alZEbR",
"algébrique" => "alZebRik",
"algébriquement" => "alZebRik°m@",
"algébriques" => "alZebRik",
"algébriste" => "alZebRist",
"algébristes" => "alZebRist",
"algérien" => "alZeRj5",
"algérienne" => "alZeRjEn",
"algériennes" => "alZeRjEn",
"algériens" => "alZeRj5",
"algérois" => "alZeRwa",
"algéroise" => "alZeRwaz",
"algie" => "alZi",
"algonquin" => "alg§k5",
"algonquines" => "alg§kin",
"algorithme" => "algoRitm",
"algorithmes" => "algoRitm",
"algorithmique" => "algoRitmik",
"algue" => "alg",
"algues" => "alg",
"alhambra" => "al@bRa",
"alias" => "aljas",
"alibi" => "alibi",
"alibis" => "alibi",
"alidade" => "alidad",
"aliéna" => "aljena",
"aliénant" => "aljen@",
"aliénante" => "aljen@t",
"aliénât" => "aljena",
"aliénation" => "aljenasj§",
"aliène" => "aljEn",
"aliéné" => "aljene",
"aliénée" => "aljene",
"aliénées" => "aljene",
"aliéner" => "aljene",
"aliénerait" => "aljen°RE",
"aliénerez" => "aljen°Re",
"aliénés" => "aljene",
"aliéniez" => "aljenje",
"aliéniste" => "aljenist",
"aligna" => "aliNa",
"alignaient" => "aliNE",
"alignais" => "aliNE",
"alignait" => "aliNE",
"alignant" => "aliN@",
"aligne" => "aliN",
"aligné" => "aliNe",
"alignée" => "aliNe",
"alignées" => "aliNe",
"alignement" => "aliN°m@",
"alignements" => "aliN°m@",
"alignent" => "aliN",
"aligner" => "aliNe",
"alignera" => "aliN°Ra",
"aligneraient" => "aliN°RE",
"alignèrent" => "aliNER",
"alignerez" => "aliN°Re",
"alignerons" => "aliN°R§",
"aligneront" => "aliN°R§",
"alignes" => "aliN",
"alignés" => "aliNe",
"alignez" => "aliNe",
"alignons" => "aliN§",
"aligot" => "aligo",
"aligoté" => "aligote",
"alim" => "alim",
"aliment" => "alim@",
"alimenta" => "alim@ta",
"alimentaient" => "alim@tE",
"alimentaire" => "alim@tER",
"alimentaires" => "alim@tER",
"alimentais" => "alim@tE",
"alimentait" => "alim@tE",
"alimentant" => "alim@t@",
"alimentation" => "alim@tasj§",
"alimentations" => "alim@tasj§",
"alimente" => "alim@t",
"alimenté" => "alim@te",
"alimentée" => "alim@te",
"alimentées" => "alim@te",
"alimentent" => "alim@t",
"alimenter" => "alim@te",
"alimentera" => "alim@t°Ra",
"alimentèrent" => "alim@tER",
"alimentés" => "alim@te",
"alimentez" => "alim@te",
"alimentons" => "alim@t§",
"aliments" => "alim@",
"alinéa" => "alinea",
"alinéas" => "alinea",
"alise" => "aliz",
"alises" => "aliz",
"alisier" => "alizje",
"alita" => "alita",
"alitai" => "alitE",
"alitait" => "alitE",
"alité" => "alite",
"alitée" => "alite",
"alitées" => "alite",
"alitement" => "alit°m@",
"aliter" => "alite",
"alizé" => "alize",
"alizés" => "alize",
"alkali" => "alkali",
"all right" => "alRajt",
"alla" => "ala",
"allai" => "alE",
"allaient" => "alE",
"allais" => "alE",
"allait" => "alE",
"allaitais" => "alEtE",
"allaitait" => "alEtE",
"allaitant" => "alEt@",
"allaitante" => "alEt@t",
"allaitantes" => "alEt@t",
"allaite" => "alEt",
"allaité" => "alete",
"allaitée" => "alEte",
"allaitement" => "alEt°m@",
"allaitent" => "alEt",
"allaiter" => "alete",
"allaiterait" => "alEt°RE",
"allaités" => "alete",
"allâmes" => "alam",
"allant" => "al@",
"allante" => "al@t",
"allas" => "ala",
"allassent" => "alas",
"allât" => "ala",
"allé" => "ale",
"allécha" => "aleSa",
"alléchait" => "aleSE",
"alléchant" => "aleS@",
"alléchante" => "aleS@t",
"alléchantes" => "aleS@t",
"alléchants" => "aleS@",
"allèche" => "alES",
"alléché" => "aleSe",
"alléchée" => "aleSe",
"allécher" => "aleSe",
"allécherait" => "aleS°RE",
"alléchés" => "aleSe",
"allée" => "ale",
"allées" => "ale",
"allégation" => "alegasj§",
"allégations" => "alegasj§",
"allège" => "alEZ",
"allégé" => "aleZe",
"allégea" => "aleZa",
"allégeaient" => "aleZE",
"allégeais" => "aleZE",
"allégeait" => "aleZE",
"allégeance" => "aleZ@s",
"allégeances" => "aleZ@s",
"allégeant" => "aleZ@",
"allégée" => "aleZe",
"allégées" => "aleZe",
"allégement" => "alEZ°m@",
"allègement" => "alEZ°m@",
"allégements" => "alEZ°m@",
"allègent" => "alEZ",
"alléger" => "aleZe",
"allégera" => "aleZ°Ra",
"allégerait" => "aleZ°RE",
"allégés" => "aleZe",
"allégez" => "aleZe",
"allégorie" => "alegoRi",
"allégories" => "alegoRi",
"allégorique" => "alegoRik",
"allégoriquement" => "alegoRik°m@",
"allégoriques" => "alegoRik",
"allégorisé" => "alegoRize",
"allègre" => "alEgR",
"allégrement" => "alEgR°m@",
"allègrement" => "alEgR°m@",
"allègres" => "alEgR",
"allégresse" => "alegREs",
"allégresses" => "alegREs",
"allegretto" => "alEgREto",
"allegro" => "alEgRo",
"allégua" => "alega",
"alléguaient" => "alegE",
"alléguais" => "alegE",
"alléguait" => "alegE",
"alléguant" => "aleg@",
"allègue" => "alEg",
"allégué" => "alege",
"alléguée" => "alege",
"alléguer" => "alege",
"alléguera" => "aleg°Ra",
"allèle" => "alEl",
"alléluia" => "aleluja",
"alléluias" => "aleluja",
"allemagne" => "al°maN",
"allemand" => "al°m@",
"allemande" => "al°m@d",
"allemandes" => "al°m@d",
"allemands" => "al°m@",
"aller" => "ale",
"aller-retour" => "aleR°tuR",
"allèrent" => "alER",
"allergène" => "alERZEn",
"allergènes" => "alERZEn",
"allergie" => "alERZi",
"allergies" => "alERZi",
"allergique" => "alERZik",
"allergiques" => "alERZik",
"allergologie" => "alERgOlOZi",
"allergologue" => "alERgolOg",
"allers" => "ale",
"allers-retours" => "aleR°tuR",
"allés" => "ale",
"allez" => "ale",
"allia" => "alja",
"alliacé" => "aljase",
"alliage" => "aljaZ",
"alliages" => "aljaZ",
"alliait" => "aljE",
"alliance" => "alj@s",
"alliances" => "alj@s",
"alliant" => "alj@",
"alliât" => "alja",
"allie" => "ali",
"allié" => "alje",
"alliée" => "alje",
"alliées" => "alje",
"allient" => "ali",
"allier" => "alje",
"alliera" => "aliRa",
"allierait" => "aliRE",
"alliés" => "alje",
"alliez" => "alje",
"alligator" => "aligatOR",
"alligators" => "aligatOR",
"allions" => "alj§",
"allitératif" => "aliteRatif",
"allitération" => "aliteRasj§",
"allitérations" => "aliteRasj§",
"allium" => "aljOm",
"allo" => "alo",
"allô" => "alo",
"allobarbital" => "alobaRbital",
"allobroges" => "alobROZ",
"alloc" => "alOk",
"allocataires" => "alokatER",
"allocation" => "alokasj§",
"allocations" => "alokasj§",
"allochtone" => "alOktOn",
"allocs" => "alok",
"allocution" => "alokysj§",
"allocutions" => "alokysj§",
"allogènes" => "aloZEn",
"allogreffe" => "alOgREf",
"allonge" => "al§Z",
"allongé" => "al§Ze",
"allongea" => "al§Za",
"allongeai" => "al§ZE",
"allongeaient" => "al§ZE",
"allongeais" => "al§ZE",
"allongeait" => "al§ZE",
"allongeâmes" => "al§Zam",
"allongeant" => "al§Z@",
"allongeât" => "al§Za",
"allongée" => "al§Ze",
"allongées" => "al§Ze",
"allongement" => "al§Z°m@",
"allongent" => "al§Z",
"allongeons" => "al§Z§",
"allonger" => "al§Ze",
"allongera" => "al§Z°Ra",
"allongerai" => "al§Z°RE",
"allongeraient" => "al§Z°RE",
"allongerais" => "al§Z°RE",
"allongerait" => "al§Z°RE",
"allongeras" => "al§Z°Ra",
"allongèrent" => "al§ZER",
"allonges" => "al§Z",
"allongés" => "al§Ze",
"allongez" => "al§Ze",
"allongiez" => "al§Zje",
"allongions" => "al§Zj§",
"allons" => "al§",
"allopathie" => "alOpati",
"allostérique" => "alOsteRik",
"alloua" => "alwa",
"allouait" => "alwE",
"allouant" => "alw@",
"alloue" => "alu",
"alloué" => "alwe",
"allouée" => "alwe",
"allouer" => "alwe",
"allouerait" => "aluRE",
"alloués" => "alwe",
"alluma" => "alyma",
"allumage" => "alymaZ",
"allumai" => "alymE",
"allumaient" => "alymE",
"allumais" => "alymE",
"allumait" => "alymE",
"allumâmes" => "alymam",
"allumant" => "alym@",
"allumât" => "alyma",
"allume" => "alym",
"allumé" => "alyme",
"allume-cigare" => "alymsigaR",
"allume-cigares" => "alymsigaR",
"allume-feu" => "alymf2",
"allume-gaz" => "alymgaz",
"allumée" => "alyme",
"allumées" => "alyme",
"allument" => "alym",
"allumer" => "alyme",
"allumera" => "alym°Ra",
"allumerai" => "alym°RE",
"allumeraient" => "alym°RE",
"allumerais" => "alym°RE",
"allumerait" => "alym°RE",
"allumeras" => "alym°Ra",
"allumèrent" => "alymER",
"allumerons" => "alym°R§",
"allumeront" => "alym°R§",
"allumes" => "alym",
"allumés" => "alyme",
"allumette" => "alymEt",
"allumettes" => "alymEt",
"allumeur" => "alym9R",
"allumeurs" => "alym9R",
"allumeuse" => "alym2z",
"allumeuses" => "alym2z",
"allumez" => "alyme",
"allumiez" => "alymje",
"allumions" => "alymj§",
"allumoir" => "alymwaR",
"allumons" => "alym§",
"allure" => "alyR",
"alluré" => "alyRe",
"allures" => "alyR",
"allusif" => "alyzif",
"allusifs" => "alyzif",
"allusion" => "alyzj§",
"allusionne" => "alyzjOn",
"allusions" => "alyzj§",
"allusive" => "alyziv",
"allusivement" => "alyziv°m@",
"allusives" => "alyziv",
"alluvion" => "alyvj§",
"alluvions" => "alyvj§",
"alma" => "alma",
"almanach" => "almanak",
"almanachs" => "almanak",
"almée" => "alme",
"almées" => "alme",
"almohade" => "almoad",
"almohades" => "almoad",
"aloès" => "aloEs",
"aloi" => "alwa",
"alopécie" => "alopesi",
"alors" => "alOR",
"alose" => "aloz",
"aloses" => "aloz",
"alouette" => "alwEt",
"alouettes" => "alwEt",
"alourdi" => "aluRdi",
"alourdie" => "aluRdi",
"alourdies" => "aluRdi",
"alourdir" => "aluRdiR",
"alourdirai" => "aluRdiRE",
"alourdiraient" => "aluRdiRE",
"alourdirent" => "aluRdiR",
"alourdis" => "aluRdi",
"alourdissaient" => "aluRdisE",
"alourdissait" => "aluRdisE",
"alourdissant" => "aluRdis@",
"alourdissement" => "aluRdis°m@",
"alourdissent" => "aluRdis",
"alourdit" => "aluRdi",
"alourdît" => "aluRdi",
"aloyau" => "alwajo",
"alpa" => "alpa",
"alpaga" => "alpaga",
"alpage" => "alpaZ",
"alpages" => "alpaZ",
"alpaguait" => "alpagE",
"alpague" => "alpag",
"alpagué" => "alpage",
"alpaguée" => "alpage",
"alpaguent" => "alpag",
"alpaguer" => "alpage",
"alpaguerait" => "alpag°RE",
"alpagués" => "alpage",
"alpe" => "alp",
"alpenstock" => "alp@stOk",
"alpes" => "alp",
"alpestre" => "alpEstR",
"alpestres" => "alpEstR",
"alpha" => "alfa",
"alphabet" => "alfabE",
"alphabétique" => "alfabetik",
"alphabétiquement" => "alfabetik°m@",
"alphabétisation" => "alfabetizasj§",
"alphabétisé" => "alfabetize",
"alphabétiser" => "alfabetize",
"alphabets" => "alfabE",
"alphanumérique" => "alfanymeRik",
"alpin" => "alp5",
"alpine" => "alpin",
"alpines" => "alpin",
"alpinisme" => "alpinizm",
"alpiniste" => "alpinist",
"alpinistes" => "alpinist",
"alpins" => "alp5",
"alsacien" => "alzasj5",
"alsacienne" => "alzasjEn",
"alsaciennes" => "alzasjEn",
"alsaciens" => "alzasj5",
"alstonia" => "alstonja",
"alter" => "altER",
"alter ego" => "altERego",
"altéra" => "alteRa",
"altérable" => "alteRabl",
"altéraient" => "alteRE",
"altérait" => "alteRE",
"altérant" => "alteR@",
"altérât" => "alteRa",
"altération" => "alteRasj§",
"altérations" => "alteRasj§",
"altercation" => "altERkasj§",
"altercations" => "altERkasj§",
"altère" => "altER",
"altéré" => "alteRe",
"altérée" => "alteRe",
"altérées" => "alteRe",
"altèrent" => "altER",
"altérer" => "alteRe",
"altérera" => "alteR°Ra",
"altérèrent" => "alteRER",
"altéreront" => "alteR°R§",
"altérés" => "alteRe",
"altérez" => "alteRe",
"altériez" => "alteRje",
"altérité" => "alteRite",
"alterna" => "altERna",
"alternaient" => "altERnE",
"alternait" => "altERnE",
"alternance" => "altERn@s",
"alternances" => "altERn@s",
"alternant" => "altERn@",
"alternateur" => "altERnat9R",
"alternatif" => "altERnatif",
"alternatifs" => "altERnatif",
"alternative" => "altERnativ",
"alternativement" => "altERnativ°m@",
"alternatives" => "altERnativ",
"alterne" => "altERn",
"alterné" => "altERne",
"alternée" => "altERne",
"alternées" => "altERne",
"alternent" => "altERn",
"alterner" => "altERne",
"alternera" => "altERn°Ra",
"alternèrent" => "altERnER",
"alternés" => "altERne",
"alternez" => "altERne",
"alternions" => "altERnj§",
"altesse" => "altEs",
"altesses" => "altEs",
"althaea" => "altea",
"altier" => "altje",
"altière" => "altjER",
"altièrement" => "altjER°m@",
"altières" => "altjER",
"altiers" => "altje",
"altimètre" => "altimEtR",
"altimètres" => "altimEtR",
"altitude" => "altityd",
"altitudes" => "altityd",
"alto" => "alto",
"altos" => "alto",
"altruisme" => "altR8izm",
"altruiste" => "altR8ist",
"altruistes" => "altR8ist",
"altuglas" => "altyglas",
"alu" => "aly",
"aludes" => "alyd",
"aluette" => "al8Et",
"aluminium" => "alyminjOm",
"alun" => "al1",
"aluni" => "alyni",
"alunir" => "alyniR",
"alunira" => "alyniRa",
"alunissage" => "alynisaZ",
"alunissages" => "alynisaZ",
"alvar" => "alvaR",
"alvéolaire" => "alveOlER",
"alvéole" => "alveOl",
"alvéolé" => "alveole",
"alvéolée" => "alveole",
"alvéolées" => "alveole",
"alvéoles" => "alveOl",
"alvéolés" => "alveole",
"alvin" => "alv5",
"alysse" => "alis",
"am stram gram" => "amstRamgRam",
"amabilité" => "amabilite",
"amabilités" => "amabilite",
"amadou" => "amadu",
"amadoua" => "amadwa",
"amadouaient" => "amadwE",
"amadouait" => "amadwE",
"amadouant" => "amadw@",
"amadoue" => "amadu",
"amadoué" => "amadwe",
"amadouer" => "amadwe",
"amadoueras" => "amaduRa",
"amadouez" => "amadue",
"amaigri" => "amegRi",
"amaigrie" => "amegRi",
"amaigries" => "amegRi",
"amaigris" => "amEgRi",
"amaigrissait" => "amEgRisE",
"amaigrissant" => "amegRis@",
"amaigrissante" => "amegRis@t",
"amaigrissantes" => "amEgRis@t",
"amaigrissants" => "amegRis@",
"amaigrissement" => "amegRis°m@",
"amaigrit" => "amEgRi",
"amalfitaine" => "amalfitEn",
"amalgamaient" => "amalgamE",
"amalgamais" => "amalgamE",
"amalgamait" => "amalgamE",
"amalgamant" => "amalgam@",
"amalgame" => "amalgam",
"amalgamé" => "amalgame",
"amalgamée" => "amalgame",
"amalgamées" => "amalgame",
"amalgamer" => "amalgame",
"amalgames" => "amalgam",
"amalgamés" => "amalgame",
"amalgamez" => "amalgame",
"aman" => "am@",
"amande" => "am@d",
"amandes" => "am@d",
"amandier" => "am@dje",
"amandiers" => "am@dje",
"amandine" => "am@din",
"amandines" => "am@din",
"amanite" => "amanit",
"amanites" => "amanit",
"amant" => "am@",
"amante" => "am@t",
"amantes" => "am@t",
"amants" => "am@",
"amarante" => "amaR@t",
"amarantes" => "amaR@t",
"amaro" => "amaRo",
"amarra" => "amaRa",
"amarrage" => "amaRaZ",
"amarrages" => "amaRaZ",
"amarrai" => "amaRE",
"amarraient" => "amaRE",
"amarrais" => "amaRE",
"amarrait" => "amaRE",
"amarrant" => "amaR@",
"amarre" => "amaR",
"amarré" => "amaRe",
"amarrée" => "amaRe",
"amarrées" => "amaRe",
"amarrent" => "amaR",
"amarrer" => "amaRe",
"amarres" => "amaR",
"amarrés" => "amaRe",
"amarrez" => "amaRe",
"amaryllis" => "amaRilis",
"amas" => "ama",
"amassa" => "amasa",
"amassai" => "amasE",
"amassaient" => "amasE",
"amassait" => "amasE",
"amassant" => "amas@",
"amasse" => "amas",
"amassé" => "amase",
"amassée" => "amase",
"amassées" => "amase",
"amassent" => "amas",
"amasser" => "amase",
"amassera" => "amas°Ra",
"amassèrent" => "amasER",
"amassés" => "amase",
"amassez" => "amase",
"amassons" => "amas§",
"amateur" => "amat9R",
"amateurisme" => "amat9Rizm",
"amateurs" => "amat9R",
"amati" => "amati",
"amatrice" => "amatRis",
"amaurose" => "amoRoz",
"amazone" => "amazon",
"amazones" => "amazon",
"amazonien" => "amazonj5",
"amazonienne" => "amazonjEn",
"amazoniennes" => "amazonjEn",
"ambages" => "@baZ",
"ambassade" => "@basad",
"ambassades" => "@basad",
"ambassadeur" => "@basad9R",
"ambassadeurs" => "@basad9R",
"ambassadrice" => "@basadRis",
"ambassadrices" => "@basadRis",
"ambiance" => "@bj@s",
"ambiances" => "@bj@s",
"ambiant" => "@bj@",
"ambiante" => "@bj@t",
"ambiantes" => "@bj@t",
"ambiants" => "@bj@",
"ambidextre" => "@bidEkstR",
"ambigu" => "@bigy",
"ambiguë" => "@bigy",
"ambiguës" => "@bigy",
"ambiguïté" => "@big8ite",
"ambiguïtés" => "@big8ite",
"ambigus" => "@bigy",
"ambitieuse" => "@bisj2z",
"ambitieuses" => "@bitj2z",
"ambitieux" => "@bisj2",
"ambition" => "@bisj§",
"ambitionnais" => "@bisjonE",
"ambitionnait" => "@bisjonE",
"ambitionnant" => "@bisjon@",
"ambitionne" => "@bisjOn",
"ambitionné" => "@bisjone",
"ambitionnent" => "@bisjOn",
"ambitionner" => "@bisjone",
"ambitionnez" => "@bisjone",
"ambitions" => "@bisj§",
"ambivalence" => "@bival@s",
"ambivalences" => "@bival@s",
"ambivalent" => "@bival@",
"ambivalente" => "@bival@t",
"amble" => "@bl",
"ambler" => "@ble",
"amboine" => "@bwan",
"ambon" => "@b§",
"ambras" => "@bRa",
"ambre" => "@bR",
"ambré" => "@bRe",
"ambrée" => "@bRe",
"ambrées" => "@bRe",
"ambrer" => "@bRe",
"ambrés" => "@bRe",
"ambroisie" => "@bRwazi",
"ambulance" => "@byl@s",
"ambulances" => "@byl@s",
"ambulancier" => "@byl@sje",
"ambulancière" => "@byl@sjER",
"ambulancières" => "@byl@sjER",
"ambulanciers" => "@byl@sje",
"ambulant" => "@byl@",
"ambulante" => "@byl@t",
"ambulantes" => "@byl@t",
"ambulants" => "@byl@",
"ambulatoire" => "@bylatwaR",
"âme" => "am",
"amé" => "ame",
"âme-soeur" => "ams9R",
"améliora" => "ameljoRa",
"améliorable" => "ameljoRabl",
"amélioraient" => "ameljoRE",
"améliorait" => "ameljoRE",
"améliorant" => "ameljoR@",
"améliorateur" => "ameljoRat9R",
"amélioration" => "ameljoRasj§",
"améliorations" => "ameljoRasj§",
"améliore" => "ameljOR",
"amélioré" => "ameljoRe",
"améliorée" => "ameljoRe",
"améliorées" => "ameljoRe",
"améliorent" => "ameljOR",
"améliorer" => "ameljoRe",
"améliorera" => "ameljOR°Ra",
"améliorerait" => "ameljOR°RE",
"améliorèrent" => "ameljORER",
"amélioreront" => "ameljOR°R§",
"améliores" => "ameljOR",
"améliorés" => "ameljoRe",
"améliorez" => "ameljoRe",
"améliorons" => "ameljoR§",
"amen" => "amEn",
"amena" => "am°na",
"aménage" => "amenaZ",
"aménagé" => "amenaZe",
"aménagea" => "amenaZa",
"aménageai" => "amenaZE",
"aménageaient" => "amenaZE",
"aménageait" => "amenaZE",
"aménageant" => "amenaZ@",
"aménagée" => "amenaZe",
"aménagées" => "amenaZe",
"aménagement" => "amenaZ°m@",
"aménagements" => "amenaZ°m@",
"aménagent" => "amenaZ",
"aménager" => "amenaZe",
"aménagerai" => "amenaZ°RE",
"aménagerait" => "amenaZ°RE",
"aménagèrent" => "amenaZER",
"aménagés" => "amenaZe",
"aménagez" => "amenaZe",
"amenai" => "am°nE",
"amenaient" => "am°nE",
"amenais" => "am°nE",
"amenait" => "am°nE",
"amenant" => "am°n@",
"amenât" => "am°na",
"amendai" => "am@dE",
"amendait" => "am@dE",
"amendât" => "am@da",
"amende" => "am@d",
"amendé" => "am@de",
"amendée" => "am@de",
"amendement" => "am@d°m@",
"amendements" => "am@d°m@",
"amendent" => "am@d",
"amender" => "am@de",
"amenderez" => "am@d°Re",
"amendes" => "am@d",
"amendez" => "am@de",
"amène" => "amEn",
"amené" => "amne",
"amenée" => "am°ne",
"amenées" => "am°ne",
"amènent" => "amEn",
"amener" => "am°ne",
"amènera" => "amEn°Ra",
"amènerai" => "amEn°RE",
"amèneraient" => "amEn°RE",
"amènerais" => "amEn°RE",
"amènerait" => "amEn°RE",
"amèneras" => "amEn°Ra",
"amenèrent" => "am°nER",
"amènerez" => "amEn°Re",
"amèneriez" => "amEn°Rje",
"amènerions" => "amEn°Rj§",
"amènerons" => "amEn°R§",
"amèneront" => "amEn°R§",
"amènes" => "amEn",
"amenés" => "am°ne",
"amenez" => "am°ne",
"ameniez" => "am°nje",
"amenions" => "am°nj§",
"aménité" => "amenite",
"aménités" => "amenite",
"amenons" => "am°n§",
"aménorrhée" => "amenoRe",
"amenuisaient" => "am2n8izE",
"amenuisait" => "am2n8izE",
"amenuisant" => "am2n8iz@",
"amenuise" => "am2n8iz",
"amenuisé" => "am2n8ize",
"amenuisée" => "am2n8ize",
"amenuisement" => "am2n8iz°m@",
"amenuisent" => "am2n8iz",
"amenuiser" => "am2n8ize",
"amenuiserait" => "am2n8iz°RE",
"amenuisèrent" => "am2n8izER",
"amenuisés" => "am2n8ize",
"amer" => "amER",
"amère" => "amER",
"amèrement" => "amER°m@",
"amères" => "amER",
"américain" => "ameRik5",
"américaine" => "ameRikEn",
"américaines" => "ameRikEn",
"américains" => "ameRik5",
"américanisais" => "ameRikanizE",
"américanisation" => "ameRikanizasj§",
"américanisé" => "ameRikanize",
"américaniser" => "ameRikanize",
"américanisés" => "ameRikanize",
"américanisme" => "ameRikanizm",
"américanismes" => "ameRikanizm",
"américanité" => "ameRikanite",
"américano" => "ameRikano",
"américano-britannique" => "ameRikanobRitanik",
"américano-japonaise" => "ameRikanoZaponEz",
"américano-russe" => "ameRikanoRys",
"américano-soviétique" => "ameRikanOsOvjetik",
"américano-suédoise" => "ameRikanos8edwaz",
"américanophile" => "ameRikanofil",
"américanophiles" => "ameRikanofil",
"américanos" => "ameRikanOs",
"américium" => "ameRisjOm",
"amérindien" => "ameR5dj5",
"amérindienne" => "ameR5djEn",
"amérindiennes" => "ameR5djEn",
"amérindiens" => "ameR5dj5",
"amérique" => "ameRik",
"amerlo" => "amERlo",
"amerloque" => "amERlOk",
"amerloques" => "amERlOk",
"amerlos" => "amERlo",
"amerri" => "amERi",
"amerrir" => "ameRiR",
"amerrissage" => "amERisaZ",
"amerrit" => "amERi",
"amers" => "amER",
"amertume" => "amERtym",
"amertumes" => "amERtym",
"âmes" => "am",
"améthyste" => "ametist",
"améthystes" => "ametist",
"ameublement" => "am9bl°m@",
"ameublements" => "am9bl°m@",
"ameuta" => "am2ta",
"ameutaient" => "am2tE",
"ameutait" => "am2tE",
"ameutant" => "am2t@",
"ameutât" => "am2ta",
"ameute" => "am2t",
"ameuté" => "am2te",
"ameutée" => "am2te",
"ameutées" => "am2te",
"ameutent" => "am2t",
"ameuter" => "am2te",
"ameutera" => "am2t°Ra",
"ameuterait" => "am2t°RE",
"ameutés" => "am2te",
"amharique" => "amaRik",
"ami" => "ami",
"amiable" => "amjabl",
"amiante" => "amj@t",
"amibe" => "amib",
"amibes" => "amib",
"amibienne" => "amibjEn",
"amical" => "amikal",
"amicale" => "amikal",
"amicalement" => "amikal°m@",
"amicales" => "amikal",
"amicalités" => "amikalite",
"amicaux" => "amiko",
"amidon" => "amid§",
"amidonnaient" => "amidonE",
"amidonné" => "amidone",
"amidonnée" => "amidone",
"amidonnées" => "amidone",
"amidonnent" => "amidOn",
"amidonner" => "amidone",
"amidonnés" => "amidone",
"amidonnez" => "amidone",
"amie" => "ami",
"amies" => "ami",
"amignoter" => "amiNote",
"amigo" => "amigo",
"amigos" => "amigo",
"aminci" => "am5si",
"amincie" => "am5si",
"amincies" => "am5si",
"amincir" => "am5siR",
"amincis" => "am5si",
"amincissaient" => "am5sisE",
"amincissait" => "am5sisE",
"amincissant" => "am5sis@",
"amincissante" => "am5sis@t",
"amincissantes" => "am5sis@t",
"amincissants" => "am5sis@",
"amincissement" => "am5sis°m@",
"amincissent" => "am5sis",
"amincit" => "am5si",
"amine" => "amin",
"aminé" => "amine",
"aminés" => "amine",
"aminoacides" => "aminoasid",
"aminophylline" => "aminofilin",
"amiral" => "amiRal",
"amirale" => "amiRal",
"amirauté" => "amiRote",
"amirautés" => "amiRote",
"amiraux" => "amiRo",
"amis" => "ami",
"amish" => "amiS",
"amitié" => "amitje",
"amitiés" => "amitje",
"amitieuse" => "amitj2z",
"ammoniac" => "amonjak",
"ammoniacale" => "amonjakal",
"ammoniacales" => "amonjakal",
"ammoniacaux" => "amonjako",
"ammoniaque" => "amonjak",
"ammoniaqué" => "amonjake",
"ammoniaquée" => "amonjake",
"ammoniaquées" => "amonjake",
"ammonite" => "amonit",
"ammonitrate" => "amOnitRat",
"ammonium" => "amonjOm",
"amnésie" => "amnezi",
"amnésies" => "amnezi",
"amnésique" => "amnezik",
"amnésiques" => "amnezik",
"amniocentèse" => "amnjos5tEz",
"amnios" => "amnjos",
"amniotique" => "amnjotik",
"amnistiable" => "amnistjabl",
"amnistiante" => "amnistj@t",
"amnistie" => "amnisti",
"amnistié" => "amnistje",
"amnistiée" => "amnistje",
"amnistier" => "amnistje",
"amnistierons" => "amnistiR§",
"amnisties" => "amnisti",
"amnistiés" => "amnistje",
"amochait" => "amoSE",
"amoche" => "amOS",
"amoché" => "amoSe",
"amochée" => "amoSe",
"amocher" => "amoSe",
"amochés" => "amoSe",
"amochez" => "amoSe",
"amochie" => "amoSi",
"amoindri" => "amw5dRi",
"amoindrie" => "amw5dRi",
"amoindries" => "amw5dRi",
"amoindrir" => "amw5dRiR",
"amoindrira" => "amw5dRiRa",
"amoindris" => "amw5dRi",
"amoindrissait" => "amw5dRisE",
"amoindrissement" => "amw5dRis°m@",
"amoindrit" => "amw5dRi",
"amok" => "amOk",
"amolli" => "amoli",
"amollie" => "amoli",
"amollies" => "amoli",
"amollir" => "amoliR",
"amollirent" => "amoliR",
"amollis" => "amoli",
"amollissaient" => "amolisE",
"amollissait" => "amolisE",
"amollissant" => "amolis@",
"amollissement" => "amolis°m@",
"amollissent" => "amolis",
"amollit" => "amoli",
"amoncelaient" => "am§s°lE",
"amoncelait" => "am§s°lE",
"amoncelant" => "am§s°l@",
"amoncelé" => "am§s°le",
"amoncelée" => "am§s°le",
"amoncelées" => "am§s°le",
"amonceler" => "am§s°le",
"amoncelèrent" => "am§s°lER",
"amoncelés" => "am§s°le",
"amoncelle" => "am§sEl",
"amoncellement" => "am§sEl°m@",
"amoncellements" => "am§sEl°m@",
"amoncellent" => "am§sEl",
"amoncelleraient" => "am§sEl°RE",
"amont" => "am§",
"amontillado" => "am§tijado",
"amoral" => "amoRal",
"amorale" => "amoRal",
"amoraliste" => "amORalist",
"amoralité" => "amoRalite",
"amoraux" => "amoRo",
"amorça" => "amORsa",
"amorçage" => "amORsaZ",
"amorçai" => "amORsE",
"amorçaient" => "amORsE",
"amorçais" => "amORsE",
"amorçait" => "amORsE",
"amorçant" => "amORs@",
"amorce" => "amORs",
"amorcé" => "amORse",
"amorcée" => "amORse",
"amorcées" => "amORse",
"amorcent" => "amORs",
"amorcer" => "amORse",
"amorcerait" => "amORs°RE",
"amorcèrent" => "amORsER",
"amorces" => "amORs",
"amorcés" => "amORse",
"amorcez" => "amORse",
"amorçoir" => "amORswaR",
"amorçons" => "amORs§",
"amoroso" => "amoRozo",
"amorphe" => "amORf",
"amorphes" => "amORf",
"amorti" => "amORti",
"amortie" => "amORti",
"amorties" => "amORti",
"amortir" => "amORtiR",
"amortirent" => "amORtiR",
"amortiront" => "amORtiR§",
"amortis" => "amORti",
"amortissaient" => "amORtisE",
"amortissait" => "amORtisE",
"amortissant" => "amORtis@",
"amortisse" => "amORtis",
"amortissement" => "amORtis°m@",
"amortissent" => "amORtis",
"amortisseur" => "amORtis9R",
"amortisseurs" => "amORtis9R",
"amortit" => "amORti",
"amour" => "amuR",
"amour-goût" => "amuRgu",
"amour-passion" => "amuRpasj§",
"amour-propre" => "amuRpROpR",
"amouracha" => "amuRaSa",
"amourache" => "amuRaS",
"amouraché" => "amuRaSe",
"amourachée" => "amuRaSe",
"amourachent" => "amuRaS",
"amouracher" => "amuRaSe",
"amourachera" => "amuRaS°Ra",
"amouraches" => "amuRaS",
"amourer" => "amuRe",
"amourette" => "amuREt",
"amourettes" => "amuREt",
"amoureuse" => "amuR2z",
"amoureusement" => "amuR2z°m@",
"amoureuses" => "amuR2z",
"amoureux" => "amuR2",
"amours" => "amuR",
"amours-propres" => "amuRpROpR",
"amovible" => "amovibl",
"amovibles" => "amovibl",
"ampélopsis" => "@pelOpsis",
"ampérage" => "@peRaZ",
"ampère" => "@pER",
"ampèremètre" => "@pER°mEtR",
"ampères" => "@pER",
"amphés" => "@fe",
"amphétamine" => "@fetamin",
"amphétamines" => "@fetamin",
"amphi" => "@fi",
"amphibie" => "@fibi",
"amphibien" => "@fibj5",
"amphibiens" => "@fibj5",
"amphibies" => "@fibi",
"amphigouri" => "@figuRi",
"amphigourique" => "@figuRik",
"amphigouriques" => "@figuRik",
"amphigouris" => "@figuRi",
"amphis" => "@fi",
"amphithéâtre" => "@fiteatR",
"amphithéâtres" => "@fiteatR",
"amphitrite" => "@fitRit",
"amphitryon" => "@fitRi§",
"amphore" => "@fOR",
"amphores" => "@fOR",
"ample" => "@pl",
"amplement" => "@pl°m@",
"amples" => "@pl",
"ampleur" => "@pl9R",
"ampleurs" => "@pl9R",
"ampli" => "@pli",
"ampli-tuner" => "@plitjyn9R",
"amplifia" => "@plifja",
"amplifiaient" => "@plifjE",
"amplifiait" => "@plifjE",
"amplifiant" => "@plifj@",
"amplificateur" => "@plifikat9R",
"amplificateurs" => "@plifikat9R",
"amplification" => "@plifikasj§",
"amplifications" => "@plifikasj§",
"amplifie" => "@plifi",
"amplifié" => "@plifje",
"amplifiée" => "@plifje",
"amplifiées" => "@plifje",
"amplifient" => "@plifi",
"amplifier" => "@plifje",
"amplifiera" => "@plifiRa",
"amplifierais" => "@plifiRE",
"amplifièrent" => "@plifjER",
"amplifiés" => "@plifje",
"amplifiez" => "@plifje",
"amplifions" => "@plifj§",
"amplis" => "@pli",
"amplitude" => "@plityd",
"ampoule" => "@pul",
"ampoulé" => "@pule",
"ampoulée" => "@pule",
"ampoulées" => "@pule",
"ampoules" => "@pul",
"ampoulés" => "@pule",
"amputa" => "@pyta",
"amputait" => "@pytE",
"amputant" => "@pyt@",
"amputation" => "@pytasj§",
"amputations" => "@pytasj§",
"ampute" => "@pyt",
"amputé" => "@pyte",
"amputée" => "@pyte",
"amputées" => "@pyte",
"amputent" => "@pyt",
"amputer" => "@pyte",
"amputerai" => "@pyt°RE",
"amputerait" => "@pyt°RE",
"amputés" => "@pyte",
"amputez" => "@pyte",
"amulette" => "amylEt",
"amulettes" => "amylEt",
"amura" => "amyRa",
"amure" => "amyR",
"amures" => "amyR",
"amusa" => "amyza",
"amusai" => "amyzE",
"amusaient" => "amyzE",
"amusais" => "amyzE",
"amusait" => "amyzE",
"amusâmes" => "amyzam",
"amusant" => "amyz@",
"amusante" => "amyz@t",
"amusantes" => "amyz@t",
"amusants" => "amyz@",
"amusât" => "amyza",
"amuse" => "amyz",
"amusé" => "amyze",
"amuse-bouche" => "amyzbuS",
"amuse-bouches" => "amyzbuS",
"amuse-gueule" => "amyzg9l",
"amuse-gueules" => "amyzg9l",
"amusée" => "amyze",
"amusées" => "amyze",
"amusement" => "amyz°m@",
"amusements" => "amyz°m@",
"amusent" => "amyz",
"amuser" => "amyze",
"amusera" => "amyz°Ra",
"amuserai" => "amyz°RE",
"amuseraient" => "amyz°RE",
"amuserais" => "amyz°RE",
"amuserait" => "amyz°RE",
"amuseras" => "amyz°Ra",
"amusèrent" => "amyzER",
"amuserez" => "amyz°Re",
"amuseriez" => "amyz°Rje",
"amuserons" => "amyz°R§",
"amuseront" => "amyz°R§",
"amuses" => "amyz",
"amusés" => "amyze",
"amusette" => "amyzEt",
"amusettes" => "amyzEt",
"amuseur" => "amyz9R",
"amuseurs" => "amyz9R",
"amusez" => "amyze",
"amusiez" => "amyzje",
"amusions" => "amyzj§",
"amusons" => "amyz§",
"amygdale" => "amidal",
"amygdalectomie" => "amidalEktomi",
"amygdalectomies" => "amidalEktomi",
"amygdales" => "amidal",
"amygdalien" => "amidalj5",
"amygdalite" => "amidalit",
"amylase" => "amilaz",
"amyle" => "amil",
"amylique" => "amilik",
"amyotrophique" => "amjotRofik",
"an" => "@",
"ana" => "ana",
"anabaptiste" => "anabatist",
"anabaptistes" => "anabatist",
"anabase" => "anabaz",
"anabolisant" => "anabOliz@",
"anabolisants" => "anaboliz@",
"anachorète" => "anakoREt",
"anachorètes" => "anakoREt",
"anachronique" => "anakRonik",
"anachroniquement" => "anakRonik°m@",
"anachroniques" => "anakRonik",
"anachronisme" => "anakRonizm",
"anachronismes" => "anakRonizm",
"anacoluthe" => "anakolyt",
"anaconda" => "anak§da",
"anacondas" => "anak§da",
"anadyomène" => "anadjomEn",
"anaérobie" => "anaeRObi",
"anaglyphe" => "anaglif",
"anagramme" => "anagRam",
"anagrammes" => "anagRam",
"anal" => "anal",
"anale" => "anal",
"analeptiques" => "analEptik",
"anales" => "anal",
"analgésie" => "analZezi",
"analgésique" => "analZezik",
"analgésiques" => "analZezik",
"analogie" => "analoZi",
"analogies" => "analoZi",
"analogique" => "analoZik",
"analogiques" => "analoZik",
"analogue" => "analOg",
"analogues" => "analOg",
"analphabète" => "analfabEt",
"analphabètes" => "analfabEt",
"analphabétisme" => "analfabetizm",
"analysa" => "analiza",
"analysaient" => "analizE",
"analysais" => "analizE",
"analysait" => "analizE",
"analysant" => "analiz@",
"analysants" => "analiz@",
"analyse" => "analiz",
"analysé" => "analize",
"analysée" => "analize",
"analysées" => "analize",
"analysent" => "analiz",
"analyser" => "analize",
"analysera" => "analiz°Ra",
"analyserai" => "analiz°RE",
"analyserait" => "analiz°RE",
"analysèrent" => "analizER",
"analyserons" => "analiz°R§",
"analyseront" => "analiz°R§",
"analyses" => "analiz",
"analysés" => "analize",
"analyseur" => "analiz9R",
"analyseurs" => "analiz9R",
"analysez" => "analize",
"analysions" => "analizj§",
"analysons" => "analiz§",
"analyste" => "analist",
"analystes" => "analist",
"analytique" => "analitik",
"analytiquement" => "analitik°m@",
"anamnèse" => "anamnEz",
"anamorphose" => "anamORfoz",
"ananas" => "anana",
"anaphase" => "anafaz",
"anaphoriquement" => "anafoRik°m@",
"anaphylactique" => "anafilaktik",
"anaphylaxie" => "anafilaksi",
"anar" => "anaR",
"anarchie" => "anaRSi",
"anarchique" => "anaRSik",
"anarchiquement" => "anaRSik°m@",
"anarchiques" => "anaRSik",
"anarchisant" => "anaRSiz@",
"anarchisme" => "anaRSizm",
"anarchiste" => "anaRSist",
"anarchistes" => "anaRSist",
"anarcho-syndicalisme" => "anaRkos5dikalizm",
"anarcho-syndicaliste" => "anaRkos5dikalist",
"anarcho-syndicalistes" => "anaRkos5dikalist",
"anars" => "anaR",
"anas" => "ana",
"anastomose" => "anastOmoz",
"anastomoses" => "anastomoz",
"anathématisait" => "anatematizE",
"anathématisé" => "anatematize",
"anathème" => "anatEm",
"anathèmes" => "anatEm",
"anatidés" => "anatide",
"anatifes" => "anatif",
"anatomie" => "anatomi",
"anatomies" => "anatomi",
"anatomique" => "anatomik",
"anatomiquement" => "anatomik°m@",
"anatomiques" => "anatomik",
"anatomiser" => "anatomize",
"anatomiste" => "anatomist",
"anatomistes" => "anatomist",
"anatomophysiologique" => "anatomofizjoloZik",
"anaux" => "ano",
"ancestral" => "@sEstRal",
"ancestrale" => "@sEstRal",
"ancestralement" => "@sEstRal°m@",
"ancestrales" => "@sEstRal",
"ancestralité" => "@sEstRalite",
"ancestraux" => "@sEstRo",
"ancêtre" => "@sEtR",
"ancêtres" => "@sEtR",
"anch'io son pittore" => "@kjosOnpitORe",
"anche" => "@S",
"anchilops" => "@kilOps",
"anchoïade" => "@Swajad",
"anchois" => "@Swa",
"ancien" => "@sj5",
"ancienne" => "@sjEn",
"anciennement" => "@sjEn°m@",
"anciennes" => "@sjEn",
"ancienneté" => "@sjEn°te",
"anciens" => "@sj5",
"ancillaire" => "@silER",
"ancillaires" => "@silER",
"ancolie" => "@koli",
"ancra" => "@kRa",
"ancrage" => "@kRaZ",
"ancraient" => "@kRE",
"ancrais" => "@kRE",
"ancrait" => "@kRE",
"ancrant" => "@kR@",
"ancre" => "@kR",
"ancré" => "@kRe",
"ancrée" => "@kRe",
"ancrées" => "@kRe",
"ancrer" => "@kRe",
"ancrera" => "@kR°Ra",
"ancres" => "@kR",
"ancrés" => "@kRe",
"ancrez" => "@kRe",
"anda" => "@da",
"andain" => "@d5",
"andains" => "@d5",
"andalou" => "@dalu",
"andalous" => "@dalu",
"andalouse" => "@daluz",
"andalouses" => "@daluz",
"andante" => "@d@t",
"andine" => "@din",
"andines" => "@din",
"andorranes" => "@doRan",
"andouille" => "@duj",
"andouiller" => "@duje",
"andouillers" => "@duje",
"andouilles" => "@duj",
"andouillette" => "@dujEt",
"andouillettes" => "@dujEt",
"andrinople" => "@dRinOpl",
"androgènes" => "@dRoZEn",
"androgyne" => "@dRoZin",
"androgynes" => "@dRoZin",
"androgynie" => "@dRoZini",
"androgynique" => "@dRoZinik",
"androïde" => "@dRoid",
"androïdes" => "@dRoid",
"andropause" => "@dRopoz",
"âne" => "an",
"anéanti" => "ane@ti",
"anéantie" => "ane@ti",
"anéanties" => "ane@ti",
"anéantir" => "ane@tiR",
"anéantira" => "ane@tiRa",
"anéantirai" => "ane@tiRE",
"anéantiraient" => "ane@tiRE",
"anéantirait" => "ane@tiRE",
"anéantirent" => "ane@tiR",
"anéantiriez" => "ane@tiRje",
"anéantirons" => "ane@tiR§",
"anéantiront" => "ane@tiR§",
"anéantis" => "ane@ti",
"anéantissaient" => "ane@tisE",
"anéantissait" => "ane@tisE",
"anéantissant" => "ane@tis@",
"anéantissante" => "ane@tis@t",
"anéantissantes" => "ane@tis@t",
"anéantisse" => "ane@tis",
"anéantissement" => "ane@tis°m@",
"anéantissements" => "ane@tis°m@",
"anéantissent" => "ane@tis",
"anéantissez" => "ane@tise",
"anéantissons" => "ane@tis§",
"anéantit" => "ane@ti",
"anecdote" => "anEkdOt",
"anecdotes" => "anEkdOt",
"anecdotier" => "anEkdOtje",
"anecdotique" => "anEkdotik",
"anecdotiquement" => "anEkdOtik°m@",
"anecdotiques" => "anEkdotik",
"anémiais" => "anemjE",
"anémiante" => "anemj@t",
"anémie" => "anemi",
"anémié" => "anemje",
"anémiée" => "anemje",
"anémiés" => "anemje",
"anémique" => "anemik",
"anémiques" => "anemik",
"anémomètre" => "anemomEtR",
"anémométrique" => "anemometRik",
"anémone" => "anemOn",
"anémones" => "anemOn",
"ânerie" => "an°Ri",
"âneries" => "an°Ri",
"ânes" => "an",
"ânesse" => "anEs",
"ânesses" => "anEs",
"anesthésia" => "anEstezja",
"anesthésiaient" => "anEstezjE",
"anesthésiait" => "anEstezjE",
"anesthésiant" => "anEstezj@",
"anesthésiante" => "anEstezj@t",
"anesthésiantes" => "anEstezj@t",
"anesthésiants" => "anEstezj@",
"anesthésie" => "anEstezi",
"anesthésié" => "anEstezje",
"anesthésiée" => "anEstezje",
"anesthésiées" => "anEstezje",
"anesthésient" => "anEstezi",
"anesthésier" => "anEstezje",
"anesthésierai" => "anEsteziRE",
"anesthésies" => "anEstezi",
"anesthésiés" => "anEstezje",
"anesthésiez" => "anEstezje",
"anesthésions" => "anEstezj§",
"anesthésique" => "anEstezik",
"anesthésiques" => "anEstezik",
"anesthésiste" => "anEstezist",
"anesthésistes" => "anEstezist",
"aneth" => "anEt",
"anévrisme" => "anevRizm",
"anévrismes" => "anevRizm",
"anfractuosité" => "@fRakt8ozite",
"anfractuosités" => "@fRakt8ozite",
"ange" => "@Z",
"angéite" => "@Zeit",
"angélique" => "@Zelik",
"angéliquement" => "@Zelik°m@",
"angéliques" => "@Zelik",
"angélisme" => "@Zelizm",
"angelot" => "@Z°lo",
"angelots" => "@Z°lo",
"angélus" => "@Zelys",
"anges" => "@Z",
"angevin" => "@Z°v5",
"angevine" => "@Z°vin",
"angevins" => "@Z°v5",
"angine" => "@Zin",
"angines" => "@Zin",
"angiocholite" => "@ZjokOlit",
"angiographie" => "@ZjOgRafi",
"angiome" => "@Zjom",
"angioplastie" => "@Zjoplasti",
"anglais" => "@glE",
"anglaise" => "@glEz",
"anglaises" => "@glEz",
"angle" => "@gl",
"angler" => "@gle",
"angles" => "@gl",
"angleterre" => "@gl2tER",
"anglican" => "@glik@",
"anglicane" => "@glikan",
"anglicans" => "@glik@",
"angliche" => "@gliS",
"angliches" => "@gliS",
"anglicisation" => "@glisizasj§",
"anglicisé" => "@glisize",
"angliciser" => "@glisize",
"anglicismes" => "@glisizm",
"anglo-albanais" => "@gloalbanE",
"anglo-allemand" => "@gloal°m@",
"anglo-américain" => "@gloameRik5",
"anglo-américaine" => "@gloameRikEn",
"anglo-américaines" => "@gloameRikEn",
"anglo-américains" => "@gloameRik5",
"anglo-arabe" => "@gloaRab",
"anglo-arabes" => "@gloaRab",
"anglo-chinois" => "@gloSinwa",
"anglo-égyptien" => "@gloeZipsj5",
"anglo-égyptienne" => "@gloeZipsjEn",
"anglo-éthiopien" => "@gloetjopj5",
"anglo-français" => "@glofR@sE",
"anglo-française" => "@glofR@sEz",
"anglo-hellénique" => "@gloelenik",
"anglo-irlandais" => "@gloiRl@dE",
"anglo-normand" => "@glonORm@",
"anglo-normande" => "@glonORm@d",
"anglo-normandes" => "@glonORm@d",
"anglo-russe" => "@gloRus",
"anglo-russes" => "@gloRys",
"anglo-saxon" => "@glosaks§",
"anglo-saxonne" => "@glosaksOn",
"anglo-saxonnes" => "@glosaksOn",
"anglo-saxons" => "@glosaks§",
"anglo-soviétique" => "@glosovjetik",
"anglomane" => "@gloman",
"anglomanes" => "@gloman",
"anglomanie" => "@glomani",
"anglophile" => "@glofil",
"anglophobe" => "@glofOb",
"anglophobes" => "@glofOb",
"anglophobie" => "@glofobi",
"anglophone" => "@glofOn",
"anglophones" => "@glofOn",
"angoissa" => "@gwasa",
"angoissaient" => "@gwasE",
"angoissais" => "@gwasE",
"angoissait" => "@gwasE",
"angoissant" => "@gwas@",
"angoissante" => "@gwas@t",
"angoissantes" => "@gwas@t",
"angoissants" => "@gwas@",
"angoisse" => "@gwas",
"angoissé" => "@gwase",
"angoissée" => "@gwase",
"angoissées" => "@gwase",
"angoissent" => "@gwas",
"angoisser" => "@gwase",
"angoisserait" => "@gwas°RE",
"angoisses" => "@gwas",
"angoissés" => "@gwase",
"angoissez" => "@gwase",
"angoissiez" => "@gwasje",
"angolais" => "@golE",
"angon" => "@g§",
"angor" => "@gOR",
"angora" => "@goRa",
"angoras" => "@goRa",
"angström" => "@gStR2m",
"anguille" => "@gij",
"anguilles" => "@gij",
"anguillules" => "@gijyl",
"anguis" => "@gi",
"angulaire" => "@gylER",
"angulaires" => "@gylER",
"anguleuse" => "@gyl2z",
"anguleuses" => "@gyl2z",
"anguleux" => "@gyl2",
"angulosité" => "@gylozite",
"angustura" => "@gystyRa",
"anhélations" => "anelasj§",
"anhèle" => "anEl",
"anhydre" => "anidR",
"anhydride" => "anidRid",
"anicroche" => "anikROS",
"anicroches" => "anikROS",
"ânier" => "anje",
"aniline" => "anilin",
"anima" => "anima",
"animai" => "animE",
"animaient" => "animE",
"animais" => "animE",
"animait" => "animE",
"animal" => "animal",
"animal-roi" => "animalRwa",
"animalcule" => "animalkyl",
"animale" => "animal",
"animalement" => "animal°m@",
"animalerie" => "animal°Ri",
"animales" => "animal",
"animalier" => "animalje",
"animalière" => "animaljER",
"animalières" => "animaljER",
"animaliers" => "animalje",
"animalisait" => "animalizE",
"animalise" => "animaliz",
"animalité" => "animalite",
"animant" => "anim@",
"animas" => "anima",
"animât" => "anima",
"animateur" => "animat9R",
"animateurs" => "animat9R",
"animation" => "animasj§",
"animations" => "animasj§",
"animatrice" => "animatRis",
"animatrices" => "animatRis",
"animaux" => "animo",
"animaux-espions" => "animoEspj§",
"anime" => "anim",
"animé" => "anime",
"animée" => "anime",
"animées" => "anime",
"animent" => "anim",
"animer" => "anime",
"animeraient" => "anim°RE",
"animerait" => "anim°RE",
"animèrent" => "animER",
"animes" => "anim",
"animés" => "anime",
"animique" => "animik",
"animisme" => "animizm",
"animiste" => "animist",
"animosité" => "animozite",
"animosités" => "animozite",
"animus" => "animys",
"anionique" => "anjOnik",
"anis" => "anis",
"anise" => "aniz",
"anisé" => "anize",
"anisée" => "anize",
"anisées" => "anize",
"anisette" => "anizEt",
"anisettes" => "anizEt",
"ankh" => "@k",
"ankylosait" => "@kilozE",
"ankylose" => "@kiloz",
"ankylosé" => "@kiloze",
"ankylosée" => "@kiloze",
"ankylosées" => "@kiloze",
"ankyloser" => "@kiloze",
"ankyloses" => "@kiloz",
"ankylosés" => "@kiloze",
"annales" => "anal",
"annamite" => "anamit",
"annamites" => "anamit",
"anneau" => "ano",
"anneaux" => "ano",
"année" => "ane",
"année-lumière" => "anelymjER",
"années" => "ane",
"années-homme" => "aneOm",
"années-lumière" => "anelymjER",
"annelé" => "an°le",
"annelée" => "an°le",
"annelées" => "an°le",
"annelés" => "an°le",
"annelets" => "an°lE",
"annelures" => "an°lyR",
"annexa" => "anEksa",
"annexaient" => "anEksE",
"annexait" => "anEksE",
"annexant" => "anEks@",
"annexe" => "anEks",
"annexé" => "anEkse",
"annexée" => "anEkse",
"annexées" => "anEkse",
"annexer" => "anEkse",
"annexèrent" => "anEksER",
"annexes" => "anEks",
"annexés" => "anEkse",
"annexion" => "anEksj§",
"annexions" => "anEksj§",
"annihila" => "aniila",
"annihilait" => "aniilE",
"annihilant" => "aniil@",
"annihilante" => "aniil@t",
"annihilateur" => "aniilat9R",
"annihilation" => "aniilasj§",
"annihile" => "aniil",
"annihilé" => "aniile",
"annihilée" => "aniile",
"annihilent" => "aniil",
"annihiler" => "aniile",
"annihilez" => "aniile",
"annihilons" => "aniil§",
"anniv" => "aniv",
"anniversaire" => "anivERsER",
"anniversaires" => "anivERsER",
"annonça" => "an§sa",
"annonçai" => "an§sE",
"annonçaient" => "an§sE",
"annonçais" => "an§sE",
"annonçait" => "an§sE",
"annonçant" => "an§s@",
"annonçât" => "an§sa",
"annonce" => "an§s",
"annoncé" => "an§se",
"annoncée" => "an§se",
"annoncées" => "an§se",
"annoncent" => "an§s",
"annoncer" => "an§se",
"annoncera" => "an§s°Ra",
"annoncerai" => "an§s°RE",
"annonceraient" => "an§s°RE",
"annoncerais" => "an§s°RE",
"annoncerait" => "an§s°RE",
"annonceras" => "an§s°Ra",
"annoncèrent" => "an§sER",
"annoncerez" => "an§s°Re",
"annoncerons" => "an§s°R§",
"annonceront" => "an§s°R§",
"annonces" => "an§s",
"annoncés" => "an§se",
"annonceur" => "an§s9R",
"annonceurs" => "an§s9R",
"annonceuse" => "an§s2z",
"annoncez" => "an§se",
"annonciateur" => "an§sjat9R",
"annonciateurs" => "an§sjat9R",
"annonciation" => "an§sjasj§",
"annonciations" => "an§sjasj§",
"annonciatrice" => "an§sjatRis",
"annonciatrices" => "an§sjatRis",
"annonciez" => "an§sje",
"annoncions" => "an§sj§",
"annonçons" => "an§s§",
"annotais" => "anotE",
"annotait" => "anotE",
"annotant" => "anot@",
"annotation" => "anotasj§",
"annotations" => "anotasj§",
"annote" => "anOt",
"annoté" => "anote",
"annotée" => "anote",
"annoter" => "anote",
"annotés" => "anote",
"annuaire" => "an8ER",
"annuaires" => "an8ER",
"annuel" => "an8El",
"annuelle" => "an8El",
"annuellement" => "an8El°m@",
"annuelles" => "an8El",
"annuels" => "an8El",
"annula" => "anyla",
"annulai" => "anylE",
"annulaient" => "anylE",
"annulaire" => "anylER",
"annulais" => "anylE",
"annulait" => "anylE",
"annulant" => "anyl@",
"annulation" => "anylasj§",
"annulations" => "anylasj§",
"annule" => "anyl",
"annulé" => "anyle",
"annulée" => "anyle",
"annulées" => "anyle",
"annulent" => "anyl",
"annuler" => "anyle",
"annulera" => "anyl°Ra",
"annulerai" => "anyl°RE",
"annuleraient" => "anyl°RE",
"annulerais" => "anyl°RE",
"annulerait" => "anyl°RE",
"annulèrent" => "anylER",
"annulerez" => "anyl°Re",
"annulerons" => "anyl°R§",
"annuleront" => "anyl°R§",
"annules" => "anyl",
"annulés" => "anyle",
"annulez" => "anyle",
"annuliez" => "anylje",
"annulons" => "anyl§",
"anobli" => "anobli",
"anoblie" => "anobli",
"anoblies" => "anobli",
"anoblir" => "anobliR",
"anoblissait" => "anoblisE",
"anoblissant" => "anoblis@",
"anoblissante" => "anoblis@t",
"anoblissement" => "anoblis°m@",
"anoblit" => "anobli",
"anode" => "anOd",
"anodin" => "anod5",
"anodine" => "anodin",
"anodines" => "anodin",
"anodins" => "anod5",
"anodique" => "anOdik",
"anodisé" => "anodize",
"anomalie" => "anomali",
"anomalies" => "anomali",
"anomoure" => "anomuR",
"ânon" => "an§",
"ânonna" => "anona",
"ânonnaient" => "anonE",
"ânonnait" => "anonE",
"ânonnant" => "anon@",
"ânonne" => "anOn",
"ânonnement" => "anOn°m@",
"ânonnements" => "anOn°m@",
"ânonner" => "anone",
"ânonnés" => "anone",
"ânonnions" => "anonj§",
"ânons" => "an§",
"anonymat" => "anonima",
"anonyme" => "anonim",
"anonymement" => "anonim°m@",
"anonymes" => "anonim",
"anonymographe" => "anonimogRaf",
"anophèle" => "anofEl",
"anorak" => "anoRak",
"anoraks" => "anoRak",
"anorexie" => "anoREksi",
"anorexies" => "anoREksi",
"anorexique" => "anoREksik",
"anorexiques" => "anoREksik",
"anormal" => "anORmal",
"anormale" => "anORmal",
"anormalement" => "anORmal°m@",
"anormales" => "anORmal",
"anormalité" => "anORmalite",
"anormaux" => "anORmo",
"anosmie" => "anOsmi",
"anosmique" => "anOsmik",
"anoxie" => "anOksi",
"ans" => "@",
"anse" => "@s",
"ansée" => "@se",
"ansées" => "@se",
"anses" => "@s",
"antagonique" => "@tagOnik",
"antagonisme" => "@tagonizm",
"antagonismes" => "@tagonizm",
"antagoniste" => "@tagonist",
"antagonistes" => "@tagonist",
"antalgique" => "@talZik",
"antalgiques" => "@talZik",
"antan" => "@t@",
"antarctique" => "@taRktik",
"antarctiques" => "@taRtik",
"ante" => "@t",
"anté" => "@te",
"antécédent" => "@tesed@",
"antécédents" => "@tesed@",
"antéchrist" => "@tekRist",
"antéchrists" => "@tekRist",
"antédiluvien" => "@tedilyvj5",
"antédiluvienne" => "@tedilyvjEn",
"antédiluviennes" => "@tedilyvjEn",
"antédiluviens" => "@tedilyvj5",
"antenne" => "@tEn",
"antennes" => "@tEn",
"antépénultième" => "@tepenyltjEm",
"antépénultièmes" => "@tepenyltjEm",
"antérieur" => "@teRj9R",
"antérieure" => "@teRj9R",
"antérieurement" => "@teRj9R°m@",
"antérieures" => "@teRj9R",
"antérieurs" => "@teRj9R",
"antérograde" => "@teRogRad",
"anthologie" => "@toloZi",
"anthologies" => "@toloZi",
"anthonome" => "@tOnOm",
"anthracène" => "@tRasEn",
"anthracine" => "@tRasin",
"anthracite" => "@tRasit",
"anthracites" => "@tRasit",
"anthracose" => "@tRakoz",
"anthraquinone" => "@tRakinOn",
"anthrax" => "@tRaks",
"anthropiques" => "@tRopik",
"anthropoïde" => "@tRopoid",
"anthropoïdes" => "@tRopoid",
"anthropologie" => "@tRopoloZi",
"anthropologique" => "@tRopoloZik",
"anthropologiquement" => "@tRopoloZik°m@",
"anthropologiques" => "@tRopoloZik",
"anthropologiste" => "@tRopoloZist",
"anthropologue" => "@tRopolOg",
"anthropologues" => "@tRopolOg",
"anthropométrie" => "@tRopometRi",
"anthropométrique" => "@tRopometRik",
"anthropométriques" => "@tRopometRik",
"anthropomorphe" => "@tRopomORf",
"anthropomorphique" => "@tRopomORfik",
"anthropomorphiser" => "@tROpOmORfize",
"anthropomorphisme" => "@tRopomORfizm",
"anthropophage" => "@tRopofaZ",
"anthropophages" => "@tRopofaZ",
"anthropophagie" => "@tRopofaZi",
"anthropophagiques" => "@tRopofaZik",
"anthropopithèque" => "@tRopopitEk",
"anthropopithèques" => "@tRopopitEk",
"anthume" => "@tym",
"anti" => "@ti",
"anti-acné" => "@tiakne",
"anti-aérien" => "@tiaeRj5",
"anti-aérienne" => "@tiaeRjEn",
"anti-aériens" => "@tiaeRj5",
"anti-âge" => "@tiaZ",
"anti-agression" => "@tiagREsj§",
"anti-allergie" => "@tialERZi",
"anti-anatomique" => "@tianatomik",
"anti-apartheid" => "@tiapaRtEd",
"anti-aphrodisiaque" => "@tiafRodizjak",
"anti-asthmatique" => "@tiasmatik",
"anti-atomique" => "@tiatomik",
"anti-atomiques" => "@tiatomik",
"anti-avortement" => "@tiavORt°m@",
"anti-beauf" => "@tibof",
"anti-bison" => "@tibiz§",
"anti-blindage" => "@tibl5daZ",
"anti-blouson" => "@tibluz§",
"anti-bombe" => "@tib§b",
"anti-bombes" => "@tib§b",
"anti-bosons" => "@tiboz§",
"anti-braquage" => "@tibRakaZ",
"anti-brouillard" => "@tibRujaR",
"anti-bruit" => "@tibR8i",
"anti-calciques" => "@tikalsik",
"anti-cancer" => "@tik@sER",
"anti-capitaliste" => "@tikapitalist",
"anti-castriste" => "@tikastRist",
"anti-castristes" => "@tikastRist",
"anti-célibataires" => "@tiselibatER",
"anti-cellulite" => "@tisElylit",
"anti-chambre" => "@tiS@bR",
"anti-chambres" => "@tiS@bR",
"anti-char" => "@tiSaR",
"anti-chars" => "@tiSaR",
"anti-chiens" => "@tiSj5",
"anti-cité" => "@tisite",
"anti-civilisation" => "@tisivilizasj§",
"anti-club" => "@tikl9b",
"anti-cocos" => "@tikoko",
"anti-colère" => "@tikolER",
"anti-communisme" => "@tikomynizm",
"anti-communiste" => "@tikomynist",
"anti-conformisme" => "@tik§fORmizm",
"anti-conformiste" => "@tik§fORmist",
"anti-conglutinatif" => "@tik§glytinatif",
"anti-corps" => "@tikOR",
"anti-corruption" => "@tikoRypsj§",
"anti-crash" => "@tikRaS",
"anti-crime" => "@tikRim",
"anti-criminalité" => "@tikRiminalite",
"anti-dauphins" => "@tidof5",
"anti-débauche" => "@tideboS",
"anti-démocratique" => "@tidemokRatik",
"anti-démocratiques" => "@tidemokRatik",
"anti-démon" => "@tidem§",
"anti-desperado" => "@tidEspeRado",
"anti-dieu" => "@tidj2",
"anti-discrimination" => "@tidiskRiminasj§",
"anti-dopage" => "@tidopaZ",
"anti-douleur" => "@tidul9R",
"anti-douleurs" => "@tidul9R",
"anti-drague" => "@tidRag",
"anti-dramatique" => "@tidRamatik",
"anti-drogue" => "@tidROg",
"anti-drogues" => "@tidROg",
"anti-émeute" => "@tiem2t",
"anti-émeutes" => "@tiem2t",
"anti-émotionnelle" => "@tiemosjonEl",
"anti-espionnes" => "@tiEspjOn",
"anti-establishment" => "@tiEstabliSmEnt",
"anti-évasion" => "@tievazj§",
"anti-existence" => "@tiEgzist@s",
"anti-explosion" => "@tiEksplozj§",
"anti-fantômes" => "@tif@tom",
"anti-fasciste" => "@tifaSist",
"anti-féministe" => "@tifeminist",
"anti-femme" => "@tifam",
"anti-flingage" => "@tifl5gaZ",
"anti-flip" => "@tiflip",
"anti-frigo" => "@tifRigo",
"anti-fusées" => "@tifyze",
"anti-fusionnel" => "@tifyzjonEl",
"anti-g" => "@tiZe",
"anti-gang" => "@tig@g",
"anti-gel" => "@tiZEl",
"anti-gerce" => "@tiZERs",
"anti-gouvernement" => "@tiguvERn°m@",
"anti-graffiti" => "@tigRafiti",
"anti-gravité" => "@tigRavite",
"anti-grimaces" => "@tigRimas",
"anti-gros" => "@tigRo",
"anti-hannetons" => "@tian°t§",
"anti-hypertenseur" => "@tiipERt@s9R",
"anti-immigration" => "@tiimigRasj§",
"anti-immigrés" => "@tiimigRe",
"anti-impérialiste" => "@ti5peRjalist",
"anti-incendie" => "@ti5s@di",
"anti-inertie" => "@tiinERsi",
"anti-infectieux" => "@ti5fEksj2",
"anti-inflammatoire" => "@ti5flamatwaR",
"anti-insecte" => "@ti5sEkt",
"anti-insectes" => "@ti5sEkt",
"anti-instinct" => "@ti5st5",
"anti-insurrectionnel" => "@ti5syREksjonEl",
"anti-intimité" => "@ti5timite",
"anti-japon" => "@tiZap§",
"anti-jeunes" => "@tiZ9n",
"anti-mafia" => "@timafja",
"anti-maison" => "@timEz§",
"anti-manipulation" => "@timanipylasj§",
"anti-manoir" => "@timanwaR",
"anti-mariage" => "@timaRjaZ",
"anti-matière" => "@timatjER",
"anti-matières" => "@timatjER",
"anti-mecs" => "@timEk",
"anti-médicaments" => "@timedikam@",
"anti-métaphysique" => "@timetafizik",
"anti-météorites" => "@timeteoRit",
"anti-militariste" => "@timilitaRist",
"anti-missiles" => "@timisil",
"anti-mite" => "@timit",
"anti-mites" => "@timit",
"anti-monde" => "@tim§d",
"anti-monstres" => "@tim§stR",
"anti-moustique" => "@timustik",
"anti-moustiques" => "@timustik",
"anti-nausée" => "@tinoze",
"anti-navire" => "@tinaviR",
"anti-nucléaire" => "@tinykleER",
"anti-nucléaires" => "@tinykleER",
"anti-odeur" => "@tiod9R",
"anti-odeurs" => "@tiod9R",
"anti-odorants" => "@tiodoR@",
"anti-origine" => "@tioRiZin",
"anti-panache" => "@tipanaS",
"anti-particule" => "@tipaRtikyl",
"anti-pasteur" => "@tipast9R",
"anti-patriote" => "@tipatRiOt",
"anti-patriotique" => "@tipatRiotik",
"anti-pédérastiques" => "@tipedeRastik",
"anti-pelliculaire" => "@tipElikylER",
"anti-piratage" => "@tipiRataZ",
"anti-pirate" => "@tipiRat",
"anti-poison" => "@tipwaz§",
"anti-poisse" => "@tipwas",
"anti-pollution" => "@tipolysj§",
"anti-poux" => "@tipu",
"anti-progressistes" => "@tipRogResist",
"anti-psychotique" => "@tipsikotik",
"anti-pub" => "@tipyb",
"anti-puces" => "@tipys",
"anti-racket" => "@tiRakEt",
"anti-radiations" => "@tiRadjasj§",
"anti-rapt" => "@tiRapt",
"anti-reflets" => "@tiR°flE",
"anti-rejet" => "@tiR°ZE",
"anti-religion" => "@tiR°liZj§",
"anti-rhume" => "@tiRym",
"anti-rides" => "@tiRid",
"anti-romain" => "@tiRom5",
"anti-romantique" => "@tiRom@tik",
"anti-rouille" => "@tiRuj",
"anti-russe" => "@tiRys",
"anti-sèche" => "@tisES",
"anti-sèches" => "@tisES",
"anti-sémite" => "@tisemit",
"anti-sémites" => "@tisemit",
"anti-sémitisme" => "@tisemitizm",
"anti-sida" => "@tisida",
"anti-socialistes" => "@tisosjalist",
"anti-sociaux" => "@tisosjo",
"anti-société" => "@tisosjete",
"anti-somnolence" => "@tisomnol@s",
"anti-souffle" => "@tisufl",
"anti-sous-marin" => "@tisumaR5",
"anti-soviétique" => "@tisovjetik",
"anti-stress" => "@tistREs",
"anti-syndical" => "@tis5dikal",
"anti-tabac" => "@titaba",
"anti-taches" => "@titaS",
"anti-tank" => "@tit@k",
"anti-tapisserie" => "@titapis°Ri",
"anti-temps" => "@tit@",
"anti-tension" => "@tit@sj§",
"anti-terrorisme" => "@titeRoRizm",
"anti-terroriste" => "@titeRoRist",
"anti-tornades" => "@titORnad",
"anti-toux" => "@titu",
"anti-truie" => "@titR8i",
"anti-trusts" => "@titR9st",
"anti-venin" => "@tiv°n5",
"anti-vieillissement" => "@tivjEjis°m@",
"anti-viol" => "@tivjOl",
"anti-violence" => "@tivjol@s",
"anti-viral" => "@tiviRal",
"anti-virus" => "@tiviRys",
"anti-vol" => "@tivOl",
"anti-vols" => "@tivOl",
"antiacide" => "@tiasid",
"antiacides" => "@tiasid",
"antiaérien" => "@tiaeRj5",
"antiaérienne" => "@tiaeRjEn",
"antiaériennes" => "@tiaeRjEn",
"antiaériens" => "@tiaeRj5",
"antialcoolique" => "@tialkolik",
"antiallemands" => "@tial°m@",
"antiaméricain" => "@tiameRik5",
"antiaméricaine" => "@tiameRikEn",
"antiaméricaines" => "@tiameRikEn",
"antiaméricanisme" => "@tiameRikanizm",
"antiatomique" => "@tiatomik",
"antibactérien" => "@tibakteRj5",
"antibiotique" => "@tibjotik",
"antibiotiques" => "@tibjotik",
"antiblocage" => "@tiblokaZ",
"antibois" => "@tibwa",
"antibolcheviques" => "@tibOlS°vik",
"antibolchevisme" => "@tibOlS°vizm",
"antibourgeois" => "@tibuRZwa",
"antibrouillard" => "@tibRujaR",
"antibruit" => "@tibR8i",
"anticalcaire" => "@tikalkER",
"anticapitaliste" => "@tikapitalist",
"anticastriste" => "@tikastRist",
"anticastristes" => "@tikastRist",
"anticatalyseurs" => "@tikataliz9R",
"anticatholique" => "@tikatolik",
"antichambre" => "@tiS@bR",
"antichambres" => "@tiS@bR",
"antichar" => "@tiSaR",
"antichars" => "@tiSaR",
"antichoc" => "@tiSOk",
"anticholinergique" => "@tikOlinERZik",
"antichrétien" => "@tikRetj5",
"antichrétienne" => "@tikRetjEn",
"antichristianisme" => "@tikRistjanizm",
"anticipa" => "@tisipa",
"anticipais" => "@tisipE",
"anticipait" => "@tisipE",
"anticipant" => "@tisip@",
"anticipateur" => "@tisipat9R",
"anticipation" => "@tisipasj§",
"anticipations" => "@tisipasj§",
"anticipatoire" => "@tisipatwaR",
"anticipatrice" => "@tisipatRis",
"anticipe" => "@tisip",
"anticipé" => "@tisipe",
"anticipée" => "@tisipe",
"anticipées" => "@tisipe",
"anticipent" => "@tisip",
"anticiper" => "@tisipe",
"anticipera" => "@tisip°Ra",
"anticiperait" => "@tisip°RE",
"anticipés" => "@tisipe",
"anticipez" => "@tisipe",
"anticipons" => "@tisip§",
"anticlérical" => "@tikleRikal",
"anticléricale" => "@tikleRikal",
"anticléricales" => "@tikleRikal",
"anticléricalisme" => "@tikleRikalizm",
"anticléricaux" => "@tikleRiko",
"anticoagulant" => "@tikoagyl@",
"anticoagulants" => "@tikoagyl@",
"anticolonialisme" => "@tikolonjalizm",
"anticommunisme" => "@tikomynizm",
"anticommuniste" => "@tikomynist",
"anticommunistes" => "@tikomynist",
"anticonceptionnelle" => "@tik§sEpsjOnEl",
"anticonceptionnelles" => "@tik§sEpsjonEl",
"anticonceptionnels" => "@tik§sEpsjonEl",
"anticonformisme" => "@tik§fORmizm",
"anticonformiste" => "@tik§fORmist",
"anticonstitutionnel" => "@tik§stitysjonEl",
"anticonstitutionnelle" => "@tik§stitysjonEl",
"anticonstitutionnellement" => "@tik§stitysjonEl°m@",
"anticorps" => "@tikOR",
"anticyclique" => "@tisiklik",
"anticyclone" => "@tisiklon",
"anticycloniques" => "@tisiklonik",
"antidatait" => "@tidatE",
"antidaté" => "@tidate",
"antidatée" => "@tidate",
"antidater" => "@tidate",
"antidémarrage" => "@tidemaRaZ",
"antidémocratique" => "@tidemokRatik",
"antidépresseur" => "@tidepRes9R",
"antidépresseurs" => "@tidepREs9R",
"antidérapant" => "@tideRap@",
"antidérapante" => "@tideRap@t",
"antidérapantes" => "@tideRap@t",
"antidérapants" => "@tideRap@",
"antidictatoriaux" => "@tidiktatoRjo",
"antidopage" => "@tidopaZ",
"antidote" => "@tidOt",
"antidotes" => "@tidOt",
"antidouleur" => "@tidul9R",
"antidreyfusard" => "@tidREfyzaR",
"antidreyfusarde" => "@tidREfyzaRd",
"antidreyfusards" => "@tidREfyzaR",
"antidreyfusisme" => "@tidREfyzizm",
"antidrogue" => "@tidROg",
"antiémétique" => "@tiemetik",
"antiémeute" => "@jem2t",
"antienne" => "@tjEn",
"antiennes" => "@tjEn",
"antiesclavagiste" => "@tiEsklavaZist",
"antifading" => "@tifEjdiG",
"antifascisme" => "@tifaSizm",
"antifasciste" => "@tifaSist",
"antifascistes" => "@tifaSist",
"antiféminisme" => "@tifeminizm",
"antifongique" => "@tif§Zik",
"antifrançaise" => "@tifR@sEz",
"antifrançaises" => "@tifR@sEz",
"antifumée" => "@tifyme",
"antigang" => "@tig@g",
"antigangs" => "@tig@g",
"antigaullistes" => "@tigolist",
"antigel" => "@tiZEl",
"antigène" => "@tiZEn",
"antigènes" => "@tiZEn",
"antigermanisme" => "@tiZERmanism",
"antigravitation" => "@tigRavitasj§",
"antigravitationnel" => "@tigRavitasjOnEl",
"antigravité" => "@tigRavite",
"antigrippe" => "@tigRip",
"antihémorragiques" => "@tiemoRaZik",
"antihéros" => "@tieRo",
"antihistaminique" => "@tiistaminik",
"antihistaminiques" => "@tiistaminik",
"antihygiénique" => "@tiiZjenik",
"antillais" => "@tijE",
"antillaise" => "@tijEz",
"antillaises" => "@tijEz",
"antilogique" => "@tilOZik",
"antilope" => "@tilOp",
"antilopes" => "@tilOp",
"antimaçonniques" => "@timasonik",
"antimarxiste" => "@timaRksist",
"antimatière" => "@timatjER",
"antimicrobien" => "@timikRObj5",
"antimigraineux" => "@timigREn2",
"antimilitarisme" => "@timilitaRizm",
"antimilitariste" => "@timilitaRist",
"antimilitaristes" => "@timilitaRist",
"antimissile" => "@timisil",
"antimissiles" => "@timisil",
"antimite" => "@timit",
"antimites" => "@timit",
"antimitotiques" => "@timitotik",
"antimoine" => "@timwan",
"antimonde" => "@tim§d",
"antinationale" => "@tinasjonal",
"antinationales" => "@tinasjonal",
"antinationaliste" => "@tinasjonalist",
"antinaturel" => "@tinatyREl",
"antinaturelle" => "@tinatyREl",
"antinazie" => "@tinazi",
"antinazis" => "@tinazi",
"antinomie" => "@tinomi",
"antinomies" => "@tinomi",
"antinomique" => "@tinomik",
"antinomiques" => "@tinomik",
"antinucléaire" => "@tinykleER",
"antinucléaires" => "@tinykleER",
"antioxydant" => "@tiOksid@",
"antioxydants" => "@tiOksid@",
"antipape" => "@tipap",
"antipapes" => "@tipap",
"antiparasitage" => "@tipaRazitaZ",
"antiparasite" => "@tipaRazit",
"antiparasites" => "@tipaRazit",
"antipathie" => "@tipati",
"antipathies" => "@tipati",
"antipathique" => "@tipatik",
"antipathiques" => "@tipatik",
"antipatriote" => "@tipatRijOt",
"antipatriotiques" => "@tipatRiotik",
"antipelliculaire" => "@tipElikylER",
"antipersonnel" => "@tipERsonEl",
"antipersonnelle" => "@tipERsonEl",
"antipersonnelles" => "@tipERsonEl",
"antiphonaires" => "@tifonER",
"antiphrase" => "@tifRaz",
"antiphysiques" => "@tifizik",
"antipodaire" => "@tipodER",
"antipode" => "@tipOd",
"antipodes" => "@tipOd",
"antipodiste" => "@tipodist",
"antipodistes" => "@tipodist",
"antipoison" => "@tipwaz§",
"antipoisons" => "@tipwaz§",
"antipoliomyélitique" => "@tipoljomjelitik",
"antipollution" => "@tipolysj§",
"antipopulaire" => "@tipopylER",
"antiprotéase" => "@tipROteaz",
"antiproton" => "@tipROt§",
"antiprotons" => "@tipRot§",
"antipsychiatrie" => "@tipsikjatRi",
"antipsychotique" => "@tipsikOtik",
"antipsychotiques" => "@tipsikotik",
"antiquaille" => "@tikaj",
"antiquailleries" => "@tikaj°Ri",
"antiquailles" => "@tikaj",
"antiquaire" => "@tikER",
"antiquaires" => "@tikER",
"antiquark" => "@tikwaRk",
"antique" => "@tik",
"antiques" => "@tik",
"antiquité" => "@tikite",
"antiquités" => "@tikite",
"antirabique" => "@tiRabik",
"antiracisme" => "@tiRasism",
"antiracistes" => "@tiRasist",
"antiradiation" => "@tiRadjasj§",
"antireligieuse" => "@tiR°liZj2z",
"antireligieux" => "@tiR°liZj2",
"antirépublicain" => "@tiRepyblik5",
"antirides" => "@tiRid",
"antirouille" => "@tiRuj",
"antirusse" => "@tiR9s",
"antisatellite" => "@tisatElit",
"antiscientifique" => "@tisj@tifik",
"antisèche" => "@tisES",
"antisèches" => "@tisES",
"antisémite" => "@tisemit",
"antisémites" => "@tisemit",
"antisémitisme" => "@tisemitizm",
"antisepsie" => "@tisEpsi",
"antiseptique" => "@tisEptik",
"antiseptiques" => "@tisEptik",
"antisérum" => "@tiseROm",
"antisexistes" => "@tiseksist",
"antisexuel" => "@tiseksyEl",
"antisionistes" => "@tisjonist",
"antiskating" => "@tiskEjtiG",
"antisocial" => "@tisosjal",
"antisociale" => "@tisOsjal",
"antisociales" => "@tisosjal",
"antisociaux" => "@tisOsjo",
"antisolaire" => "@tisolER",
"antisolaires" => "@tisolER",
"antisoviétique" => "@tisovjetik",
"antisoviétiques" => "@tisovjetik",
"antisoviétisme" => "@tisovjetizm",
"antispasmodique" => "@tispasmodik",
"antisportif" => "@tispORtif",
"antistalinien" => "@tistalinj5",
"antistaliniens" => "@tistalinj5",
"antistatique" => "@tistatik",
"antistatiques" => "@tistatik",
"antistress" => "@tistREs",
"antitabac" => "@titaba",
"antiterrorisme" => "@tit°RoRizm",
"antiterroriste" => "@titERoRist",
"antitétanique" => "@titetanik",
"antithèse" => "@titEz",
"antithèses" => "@titEz",
"antithétiques" => "@titetik",
"antitout" => "@titu",
"antitoxine" => "@titOksin",
"antitoxique" => "@titOksik",
"antitrust" => "@titR9st",
"antituberculeux" => "@titybERkyl2",
"antitussif" => "@titysif",
"antitussives" => "@titysiv",
"antityphoïdique" => "@titifOidik",
"antivariolique" => "@tivaRjOlik",
"antivenimeux" => "@tiv2nim2",
"antiviolence" => "@tivjol@s",
"antiviral" => "@tiviRal",
"antiviraux" => "@tiviRo",
"antivirus" => "@tiviRys",
"antivol" => "@tivOl",
"antonin" => "@ton5",
"antonomase" => "@tonomaz",
"antonyme" => "@tonim",
"antonymes" => "@tonim",
"antre" => "@tR",
"antres" => "@tR",
"anuité" => "an8ite",
"anuitées" => "an8ite",
"anus" => "anys",
"anuscopie" => "anyskOpi",
"anxiété" => "@ksjete",
"anxiétés" => "@ksjete",
"anxieuse" => "@ksj2z",
"anxieusement" => "@ksj2z°m@",
"anxieuses" => "@ksj2z",
"anxieux" => "@ksj2",
"anxiolytique" => "@ksjolitik",
"anxiolytiques" => "@ksjolitik",
"anya" => "ania",
"aoriste" => "aoRist",
"aorte" => "aORt",
"aortique" => "aORtik",
"aortiques" => "aORtik",
"aouls" => "aul",
"août" => "ut",
"aoûtat" => "auta",
"aoûtien" => "ausj5",
"apache" => "apaS",
"apaches" => "apaS",
"apaisa" => "apEza",
"apaisai" => "apEzE",
"apaisaient" => "apEzE",
"apaisais" => "apEzE",
"apaisait" => "apEzE",
"apaisant" => "apEz@",
"apaisante" => "apEz@t",
"apaisantes" => "apEz@t",
"apaisants" => "apEz@",
"apaisât" => "apEza",
"apaise" => "apEz",
"apaisé" => "apeze",
"apaisée" => "apeze",
"apaisées" => "apeze",
"apaisement" => "apEz°m@",
"apaisements" => "apEz°m@",
"apaisent" => "apEz",
"apaiser" => "apeze",
"apaisera" => "apEz°Ra",
"apaiseraient" => "apEz°RE",
"apaiserais" => "apEz°RE",
"apaiserait" => "apEz°RE",
"apaisèrent" => "apEzER",
"apaisés" => "apeze",
"apaisez" => "apEze",
"apaisiez" => "apEzje",
"apaisons" => "apEz§",
"apâli" => "apali",
"apâlis" => "apali",
"apanage" => "apanaZ",
"apanages" => "apanaZ",
"aparté" => "apaRte",
"apartés" => "apaRte",
"apartheid" => "apaRtEjd",
"apathie" => "apati",
"apathique" => "apatik",
"apathiques" => "apatik",
"apatride" => "apatRid",
"apatrides" => "apatRid",
"apax" => "apaks",
"ape" => "ap",
"aperceptions" => "apERsEpsj§",
"apercevaient" => "apERs°vE",
"apercevais" => "apERs°vE",
"apercevait" => "apERs°vE",
"apercevant" => "apERs°v@",
"apercevez" => "apERs°ve",
"aperceviez" => "apERs°vje",
"apercevions" => "apERs°vj§",
"apercevoir" => "apERs°vwaR",
"apercevons" => "apERs°v§",
"apercevra" => "apERs°vRa",
"apercevrai" => "apERs°vRE",
"apercevraient" => "apERs°vRE",
"apercevrais" => "apERs°vRE",
"apercevrait" => "apERs°vRE",
"apercevras" => "apERs°vRa",
"apercevrez" => "apERs°vRe",
"apercevrons" => "apERs°vR§",
"apercevront" => "apERs°vR§",
"aperçois" => "apERswa",
"aperçoit" => "apERswa",
"aperçoive" => "apERswav",
"aperçoivent" => "apERswav",
"aperçoives" => "apERswav",
"aperçu" => "apERsy",
"aperçue" => "apERsy",
"aperçues" => "apERsy",
"aperçûmes" => "apERsym",
"aperçurent" => "apERsyR",
"aperçus" => "apERsy",
"aperçussent" => "apERsys",
"aperçut" => "apERsy",
"aperçût" => "apERsy",
"apéritif" => "apeRitif",
"apéritifs" => "apeRitif",
"apéritive" => "apeRitiv",
"apéritives" => "apeRitiv",
"apéro" => "apeRo",
"apéros" => "apeRo",
"apes" => "ap",
"apesanteur" => "ap°z@t9R",
"apeura" => "ap9Ra",
"apeuraient" => "ap9RE",
"apeurait" => "ap9RE",
"apeure" => "ap9R",
"apeuré" => "ap9Re",
"apeurée" => "ap9Re",
"apeurées" => "ap9Re",
"apeurer" => "ap9Re",
"apeurés" => "ap9Re",
"apex" => "apEks",
"aphaniptères" => "afaniptER",
"aphasie" => "afazi",
"aphasique" => "afazik",
"aphasiques" => "afazik",
"aphérèse" => "afeREz",
"aphone" => "afOn",
"aphones" => "afOn",
"aphonie" => "afoni",
"aphorisme" => "afoRizm",
"aphorismes" => "afoRizm",
"aphrodisiaque" => "afRodizjak",
"aphrodisiaques" => "afRodizjak",
"aphrodisie" => "afRodizi",
"aphrodite" => "afROdit",
"aphtes" => "aft",
"aphteuse" => "aft2z",
"aphteux" => "aft2",
"api" => "api",
"apiculteur" => "apikylt9R",
"apiculteurs" => "apikylt9R",
"apicultrice" => "apikyltRis",
"apiculture" => "apikyltyR",
"apion" => "apj§",
"apis" => "apis",
"apitoie" => "apitwa",
"apitoiement" => "apitwam@",
"apitoient" => "apitwa",
"apitoierai" => "apitwaRE",
"apitoierait" => "apitwaRE",
"apitoies" => "apitwa",
"apitoya" => "apitwaja",
"apitoyaient" => "apitwajE",
"apitoyait" => "apitwajE",
"apitoyant" => "apitwaj@",
"apitoyé" => "apitwaje",
"apitoyée" => "apitwaje",
"apitoyées" => "apitwaje",
"apitoyer" => "apitwaje",
"apitoyèrent" => "apitwajER",
"apitoyés" => "apitwaje",
"apitoyez" => "apitwaje",
"apitoyons" => "apitwaj§",
"apivore" => "apivOR",
"aplani" => "aplani",
"aplanie" => "aplani",
"aplanies" => "aplani",
"aplanir" => "aplaniR",
"aplanira" => "aplaniRa",
"aplaniront" => "aplaniR§",
"aplanis" => "aplani",
"aplanissaient" => "aplanisE",
"aplanissait" => "aplanisE",
"aplanissant" => "aplanis@",
"aplanissement" => "aplanis°m@",
"aplanissez" => "aplanise",
"aplanissons" => "aplanis§",
"aplanit" => "aplani",
"aplasie" => "aplazi",
"aplat" => "apla",
"aplati" => "aplati",
"aplatie" => "aplati",
"aplaties" => "aplati",
"aplatir" => "aplatiR",
"aplatirais" => "aplatiRE",
"aplatirait" => "aplatiRE",
"aplatirent" => "aplatiR",
"aplatirez" => "aplatiRe",
"aplatis" => "aplati",
"aplatissaient" => "aplatisE",
"aplatissais" => "aplatisE",
"aplatissait" => "aplatisE",
"aplatissant" => "aplatis@",
"aplatisse" => "aplatis",
"aplatissement" => "aplatis°m@",
"aplatissements" => "aplatis°m@",
"aplatissent" => "aplatis",
"aplatissez" => "aplatise",
"aplatit" => "aplati",
"aplats" => "apla",
"aplomb" => "apl§",
"aplombs" => "apl§",
"apnée" => "apne",
"apocalypse" => "apokalips",
"apocalypses" => "apokalips",
"apocalyptique" => "apokaliptik",
"apocalyptiques" => "apokaliptik",
"apocope" => "apokOp",
"apocryphe" => "apokRif",
"apocryphes" => "apokRif",
"apodictique" => "apodiktik",
"apogée" => "apoZe",
"apolitique" => "apolitik",
"apolitiques" => "apolitik",
"apolitisme" => "apolitizm",
"apollon" => "apol§",
"apollons" => "apol§",
"apologétique" => "apoloZetik",
"apologétiques" => "apoloZetik",
"apologie" => "apoloZi",
"apologiste" => "apoloZist",
"apologistes" => "apoloZist",
"apologue" => "apolOg",
"aponévroses" => "aponevRoz",
"aponévrotique" => "aponevROtik",
"apophtegmes" => "apoftEgm",
"apoplectique" => "apoplEktik",
"apoplectiques" => "apoplEktik",
"apoplexie" => "apoplEksi",
"apoplexies" => "apoplEksi",
"apoptose" => "apOptoz",
"apostasie" => "apostazi",
"apostasié" => "apostazje",
"apostat" => "aposta",
"apostate" => "apostat",
"apostats" => "aposta",
"apostées" => "aposte",
"apostillée" => "apostije",
"apostolat" => "apostola",
"apostolique" => "apostolik",
"apostoliques" => "apostolik",
"apostropha" => "apostRofa",
"apostrophaient" => "apostRofE",
"apostrophait" => "apostRofE",
"apostrophant" => "apostRof@",
"apostrophe" => "apostROf",
"apostrophé" => "apostRofe",
"apostrophée" => "apostRofe",
"apostrophent" => "apostROf",
"apostropher" => "apostRofe",
"apostrophèrent" => "apostRofER",
"apostrophes" => "apostROf",
"apostume" => "apOstym",
"apothéose" => "apoteoz",
"apothéoses" => "apoteoz",
"apothicaire" => "apotikER",
"apothicairerie" => "apotikER°Ri",
"apothicaires" => "apotikER",
"apôtre" => "apotR",
"apôtres" => "apotR",
"apparais" => "apaRE",
"apparaissaient" => "apaREsE",
"apparaissais" => "apaREsE",
"apparaissait" => "apaREsE",
"apparaissant" => "apaREs@",
"apparaisse" => "apaREs",
"apparaissent" => "apaREs",
"apparaissez" => "apaREse",
"apparaissiez" => "apaREsje",
"apparaissions" => "apaREsj§",
"apparaissons" => "apaREs§",
"apparaît" => "apaRE",
"apparaîtra" => "apaREtRa",
"apparaîtrai" => "apaREtRE",
"apparaîtraient" => "apaREtRE",
"apparaîtrais" => "apaREtRE",
"apparaîtrait" => "apaREtRE",
"apparaîtras" => "apaREtRa",
"apparaître" => "apaREtR",
"apparaîtrez" => "apaREtRe",
"apparaîtrions" => "apaREtRij§",
"apparaîtrons" => "apaREtR§",
"apparaîtront" => "apaREtR§",
"apparat" => "apaRa",
"apparatchik" => "apaRatSik",
"apparatchiks" => "apaRatSik",
"apparats" => "apaRa",
"apparaux" => "apaRo",
"appareil" => "apaREj",
"appareil-photo" => "apaREjfOto",
"appareilla" => "apaREja",
"appareillage" => "apaREjaZ",
"appareillages" => "apaREjaZ",
"appareillaient" => "apaREjE",
"appareillait" => "apaREjE",
"appareillant" => "apaREj@",
"appareille" => "apaREj",
"appareillé" => "apaREje",
"appareillent" => "apaREj",
"appareiller" => "apaReje",
"appareilleraient" => "apaREj°RE",
"appareillés" => "apaREje",
"appareillez" => "apaREje",
"appareillions" => "apaREj§",
"appareillons" => "apaREj§",
"appareils" => "apaREj",
"apparemment" => "apaRam@",
"apparence" => "apaR@s",
"apparences" => "apaR@s",
"apparent" => "apaR@",
"apparentaient" => "apaR@tE",
"apparentait" => "apaR@tE",
"apparentant" => "apaR@t@",
"apparente" => "apaR@t",
"apparenté" => "apaR@te",
"apparentée" => "apaR@te",
"apparentement" => "apaR@t°m@",
"apparentent" => "apaR@t",
"apparenter" => "apaR@te",
"apparentes" => "apaR@t",
"apparentés" => "apaR@te",
"apparents" => "apaR@",
"appariait" => "apaRjE",
"appariant" => "apaRj@",
"apparie" => "apaRi",
"apparié" => "apaRje",
"appariée" => "apaRje",
"appariées" => "apaRje",
"apparier" => "apaRje",
"appariés" => "apaRje",
"appariteur" => "apaRit9R",
"appariteurs" => "apaRit9R",
"apparition" => "apaRisj§",
"apparitions" => "apaRisj§",
"appart" => "apaRt",
"appartement" => "apaRt°m@",
"appartement-roi" => "apaRt°m@Rwa",
"appartements" => "apaRt°m@",
"appartenaient" => "apaRt°nE",
"appartenais" => "apaRt°nE",
"appartenait" => "apaRt°nE",
"appartenance" => "apaRt°n@s",
"appartenances" => "apaRt°n@s",
"appartenant" => "apaRt°n@",
"appartenez" => "apaRt°ne",
"apparteniez" => "apaRt°nje",
"appartenions" => "apaRt°nj§",
"appartenir" => "apaRt°niR",
"appartenons" => "apaRt°n§",
"appartenu" => "apaRt°ny",
"appartenues" => "apaRt°ny",
"appartiendra" => "apaRtj5dRa",
"appartiendrai" => "apaRtj5dRE",
"appartiendraient" => "apaRtj5dRE",
"appartiendrais" => "apaRtj5dRE",
"appartiendrait" => "apaRtj5dRE",
"appartiendras" => "apaRtj5dRa",
"appartiendrons" => "apaRtj5dR§",
"appartiendront" => "apaRtj5dR§",
"appartienne" => "apaRtjEn",
"appartiennent" => "apaRtjEn",
"appartiens" => "apaRtj5",
"appartient" => "apaRtj5",
"appartins" => "apaRt5",
"appartinssent" => "apaRt5s",
"appartint" => "apaRt5",
"appartînt" => "apaRt5",
"apparts" => "apaR",
"apparu" => "apaRy",
"apparue" => "apaRy",
"apparues" => "apaRy",
"apparurent" => "apaRyR",
"apparus" => "apaRy",
"apparussent" => "apaRys",
"apparut" => "apaRy",
"apparût" => "apaRy",
"appas" => "apa",
"appât" => "apa",
"appâtais" => "apatE",
"appâtant" => "apat@",
"appâte" => "apat",
"appâté" => "apate",
"appâtée" => "apate",
"appâtées" => "apate",
"appâtent" => "apat",
"appâter" => "apate",
"appâtera" => "apat°Ra",
"appâterait" => "apat°RE",
"appâtes" => "apat",
"appâtés" => "apate",
"appâtez" => "apate",
"appâtons" => "apat§",
"appâts" => "apa",
"appauvri" => "apovRi",
"appauvrie" => "apovRi",
"appauvries" => "apovRi",
"appauvrir" => "apovRiR",
"appauvris" => "apovRi",
"appauvrissaient" => "apovRisE",
"appauvrissait" => "apovRisE",
"appauvrissant" => "apovRis@",
"appauvrissante" => "apovRis@t",
"appauvrissement" => "apovRis°m@",
"appauvrissez" => "apovRise",
"appauvrissions" => "apovRisj§",
"appauvrissons" => "apovRis§",
"appauvrit" => "apovRi",
"appeau" => "apo",
"appeaux" => "apo",
"appel" => "apEl",
"appela" => "ap°la",
"appelai" => "ap°lE",
"appelaient" => "ap°lE",
"appelais" => "ap°lE",
"appelait" => "ap°lE",
"appelant" => "ap°l@",
"appelants" => "ap°l@",
"appelât" => "ap°la",
"appelé" => "ap°le",
"appelée" => "ap°le",
"appelées" => "ap°le",
"appeler" => "ap°le",
"appelèrent" => "ap°lER",
"appelés" => "ap°le",
"appeleur" => "ap°l9R",
"appelez" => "ap°le",
"appeliez" => "ap°lje",
"appelions" => "ap°lj§",
"appellation" => "apelasj§",
"appellations" => "apelasj§",
"appelle" => "apEl",
"appellent" => "apEl",
"appellera" => "apEl°Ra",
"appellerai" => "apEl°RE",
"appelleraient" => "apEl°RE",
"appellerais" => "apEl°RE",
"appellerait" => "apEl°RE",
"appelleras" => "apEl°Ra",
"appellerez" => "apEl°Re",
"appelleriez" => "apEl2Rje",
"appellerions" => "apEl°Rj§",
"appellerons" => "apEl°R§",
"appelleront" => "apEl°R§",
"appelles" => "apEl",
"appelons" => "ap°l§",
"appels" => "apEl",
"appendait" => "ap@dE",
"appendice" => "ap5dis",
"appendicectomie" => "ap5disektomi",
"appendices" => "ap5dis",
"appendicite" => "ap5disit",
"appendrait" => "ap@dRE",
"appendre" => "ap@dR",
"appends" => "ap@",
"appendu" => "ap@dy",
"appendues" => "ap@dy",
"appendus" => "ap@dy",
"appentis" => "ap@ti",
"appert" => "apER",
"appesanti" => "ap°z@ti",
"appesantie" => "ap°z@ti",
"appesanties" => "ap°z@ti",
"appesantir" => "ap°z@tiR",
"appesantis" => "ap°z@ti",
"appesantissais" => "ap°z@tisE",
"appesantissait" => "ap°z@tisE",
"appesantissant" => "ap°z@tis@",
"appesantissement" => "ap°z@tis°m@",
"appesantit" => "ap°z@ti",
"appétence" => "apet@s",
"appétences" => "apet@s",
"appétissant" => "apetis@",
"appétissante" => "apetis@t",
"appétissantes" => "apetis@t",
"appétissants" => "apetis@",
"appétit" => "apeti",
"appétits" => "apeti",
"applaudi" => "aplodi",
"applaudie" => "aplodi",
"applaudies" => "aplodi",
"applaudîmes" => "aplodim",
"applaudimètre" => "aplodimEtR",
"applaudir" => "aplodiR",
"applaudira" => "aplodiRa",
"applaudirai" => "aplodiRE",
"applaudiraient" => "aplodiRE",
"applaudirais" => "aplodiRE",
"applaudirait" => "aplodiRE",
"applaudirent" => "aplodiR",
"applaudirez" => "aplodiRe",
"applaudirons" => "aplodiR§",
"applaudis" => "aplodi",
"applaudissaient" => "aplodisE",
"applaudissais" => "aplodisE",
"applaudissait" => "aplodisE",
"applaudissant" => "aplodis@",
"applaudisse" => "aplodis",
"applaudissement" => "aplodis°m@",
"applaudissements" => "aplodis°m@",
"applaudissent" => "aplodis",
"applaudisseur" => "aplodis9R",
"applaudissez" => "aplodise",
"applaudissiez" => "aplodisje",
"applaudissions" => "aplodisj§",
"applaudissons" => "aplodis§",
"applaudit" => "aplodi",
"applaudît" => "aplodi",
"applicabilité" => "aplikabilite",
"applicable" => "aplikabl",
"applicables" => "aplikabl",
"applicateur" => "aplikat9R",
"application" => "aplikasj§",
"applications" => "aplikasj§",
"appliqua" => "aplika",
"appliquai" => "aplikE",
"appliquaient" => "aplikE",
"appliquais" => "aplikE",
"appliquait" => "aplikE",
"appliquant" => "aplik@",
"appliquasse" => "aplikas",
"appliquassions" => "aplikasj§",
"appliquât" => "aplika",
"applique" => "aplik",
"appliqué" => "aplike",
"appliquée" => "aplike",
"appliquées" => "aplike",
"appliquent" => "aplik",
"appliquer" => "aplike",
"appliquera" => "aplik°Ra",
"appliquerai" => "aplik°RE",
"appliquerais" => "aplik°RE",
"appliquerait" => "aplik°RE",
"appliqueras" => "aplik°Ra",
"appliquèrent" => "aplikER",
"appliquerez" => "aplik°Re",
"appliquerons" => "aplik°R§",
"appliques" => "aplik",
"appliqués" => "aplike",
"appliquez" => "aplike",
"appliquions" => "aplikj§",
"appliquons" => "aplik§",
"appoggiature" => "apOdZjatyR",
"appoggiatures" => "apodZjatyR",
"appoint" => "apw5",
"appointaient" => "apw5tE",
"appointait" => "apw5tE",
"appointe" => "apw5t",
"appointé" => "apw5te",
"appointée" => "apw5te",
"appointements" => "apw5t°m@",
"appointer" => "apw5te",
"appointés" => "apw5te",
"appontage" => "ap§taZ",
"appontement" => "ap§t°m@",
"apponter" => "ap§te",
"apport" => "apOR",
"apporta" => "apORta",
"apportai" => "apORtE",
"apportaient" => "apORtE",
"apportais" => "apORtE",
"apportait" => "apORtE",
"apportant" => "apORt@",
"apportas" => "apORta",
"apportât" => "apORta",
"apporte" => "apORt",
"apporté" => "apORte",
"apportée" => "apORte",
"apportées" => "apORte",
"apportent" => "apORt",
"apporter" => "apORte",
"apportera" => "apORt°Ra",
"apporterai" => "apORt°RE",
"apporteraient" => "apORt°RE",
"apporterais" => "apORt°RE",
"apporterait" => "apORt°RE",
"apporteras" => "apORt°Ra",
"apportèrent" => "apORtER",
"apporterez" => "apORt°Re",
"apporteriez" => "apORt°Rje",
"apporterons" => "apORt°R§",
"apporteront" => "apORt°R§",
"apportes" => "apORt",
"apportés" => "apORte",
"apportez" => "apORte",
"apportiez" => "apORtje",
"apportions" => "apORtj§",
"apportons" => "apORt§",
"apports" => "apOR",
"apposa" => "apoza",
"apposai" => "apozE",
"apposait" => "apozE",
"apposant" => "apoz@",
"appose" => "apoz",
"apposé" => "apoze",
"apposée" => "apoze",
"apposées" => "apoze",
"apposent" => "apoz",
"apposer" => "apoze",
"apposerait" => "apoz°RE",
"apposeras" => "apoz°Ra",
"apposés" => "apoze",
"apposez" => "apoze",
"apposition" => "apozisj§",
"apprécia" => "apResja",
"appréciable" => "apResjabl",
"appréciables" => "apResjabl",
"appréciai" => "apResjE",
"appréciaient" => "apResjE",
"appréciais" => "apResjE",
"appréciait" => "apResjE",
"appréciant" => "apResj@",
"appréciât" => "apResja",
"appréciateur" => "apResjat9R",
"appréciation" => "apResjasj§",
"appréciations" => "apResjasj§",
"appréciatrice" => "apResjatRis",
"apprécie" => "apResi",
"apprécié" => "apResje",
"appréciée" => "apResje",
"appréciées" => "apResje",
"apprécient" => "apResi",
"apprécier" => "apResje",
"appréciera" => "apResiRa",
"apprécierai" => "apResiRE",
"apprécieraient" => "apResiRE",
"apprécierais" => "apResiRE",
"apprécierait" => "apResiRE",
"apprécieras" => "apResiRa",
"apprécièrent" => "apResjER",
"apprécierez" => "apResiRe",
"apprécieriez" => "apResiRje",
"apprécierions" => "apResiRj§",
"apprécierons" => "apResiR§",
"apprécieront" => "apResiR§",
"apprécies" => "apResi",
"appréciés" => "apResje",
"appréciez" => "apResje",
"appréciions" => "apResij§",
"apprécions" => "apResj§",
"appréhendai" => "apRe@dE",
"appréhendaient" => "apRe@dE",
"appréhendais" => "apRe@dE",
"appréhendait" => "apRe@dE",
"appréhendant" => "apRe@d@",
"appréhende" => "apRe@d",
"appréhendé" => "apRe@de",
"appréhendée" => "apRe@de",
"appréhendées" => "apRe@de",
"appréhendent" => "apRe@d",
"appréhender" => "apRe@de",
"appréhendera" => "apRe@d°Ra",
"appréhenderons" => "apRe@d°R§",
"appréhendés" => "apRe@de",
"appréhendez" => "apRe@de",
"appréhendions" => "apRe@dj§",
"appréhendons" => "apRe@d§",
"appréhensif" => "apRe@sif",
"appréhension" => "apRe@sj§",
"appréhensions" => "apRe@sj§",
"apprenaient" => "apR°nE",
"apprenais" => "apR°nE",
"apprenait" => "apR°nE",
"apprenant" => "apR°n@",
"apprend" => "apR@",
"apprendra" => "apR@dRa",
"apprendrai" => "apR@dRE",
"apprendraient" => "apR@dRE",
"apprendrais" => "apR@dRE",
"apprendrait" => "apR@dRE",
"apprendras" => "apR@dRa",
"apprendre" => "apR@dR",
"apprendrez" => "apR@dRe",
"apprendriez" => "apR@dRije",
"apprendrions" => "apR@dRij§",
"apprendrons" => "apR@dR§",
"apprendront" => "apR@dR§",
"apprends" => "apR@",
"apprenez" => "apR°ne",
"appreniez" => "apR°nje",
"apprenions" => "apR°nj§",
"apprenne" => "apREn",
"apprennent" => "apREn",
"apprennes" => "apREn",
"apprenons" => "apR°n§",
"apprenti" => "apR@ti",
"apprenti-pilote" => "apR@tipilOt",
"apprenti-sorcier" => "apR@tisORsje",
"apprentie" => "apR@ti",
"apprenties" => "apR@ti",
"apprentis" => "apR@ti",
"apprentissage" => "apR@tisaZ",
"apprentissages" => "apR@tisaZ",
"apprêt" => "apRE",
"apprêta" => "apREta",
"apprêtai" => "apREtE",
"apprêtaient" => "apREtE",
"apprêtais" => "apREtE",
"apprêtait" => "apREtE",
"apprêtant" => "apREt@",
"apprête" => "apREt",
"apprêté" => "apRete",
"apprêtée" => "apRete",
"apprêtées" => "apRete",
"apprêtent" => "apREt",
"apprêter" => "apRete",
"apprêterait" => "apREt°RE",
"apprêtèrent" => "apREtER",
"apprêtes" => "apREt",
"apprêtés" => "apRete",
"apprêtez" => "apREte",
"apprêtiez" => "apREtje",
"apprêtions" => "apREtj§",
"apprêts" => "apRE",
"apprîmes" => "apRim",
"apprirent" => "apRiR",
"appris" => "apRi",
"apprise" => "apRiz",
"apprises" => "apRiz",
"apprissent" => "apRis",
"apprit" => "apRi",
"apprît" => "apRi",
"apprivoisa" => "apRivwaza",
"apprivoisaient" => "apRivwazE",
"apprivoisais" => "apRivwazE",
"apprivoisait" => "apRivwazE",
"apprivoisant" => "apRivwaz@",
"apprivoise" => "apRivwaz",
"apprivoisé" => "apRivwaze",
"apprivoisée" => "apRivwaze",
"apprivoisées" => "apRivwaze",
"apprivoisent" => "apRivwaz",
"apprivoiser" => "apRivwaze",
"apprivoiserai" => "apRivwaz°RE",
"apprivoisèrent" => "apRivwazER",
"apprivoisés" => "apRivwaze",
"apprivoiseur" => "apRivwaz9R",
"apprivoisez" => "apRivwaze",
"apprivoisons" => "apRivwaz§",
"approbateur" => "apRobat9R",
"approbateurs" => "apRobat9R",
"approbatif" => "apRobatif",
"approbation" => "apRobasj§",
"approbations" => "apRobasj§",
"approbativement" => "apRobativ°m@",
"approbatrice" => "apRobatRis",
"approcha" => "apRoSa",
"approchai" => "apRoSE",
"approchaient" => "apRoSE",
"approchais" => "apRoSE",
"approchait" => "apRoSE",
"approchâmes" => "apRoSam",
"approchant" => "apRoS@",
"approchants" => "apRoS@",
"approchassent" => "apRoSas",
"approchât" => "apRoSa",
"approche" => "apROS",
"approché" => "apRoSe",
"approchée" => "apRoSe",
"approchées" => "apRoSe",
"approchent" => "apROS",
"approcher" => "apRoSe",
"approchera" => "apROS°Ra",
"approcherai" => "apROS°RE",
"approcherais" => "apROS°RE",
"approcherait" => "apROS°RE",
"approcheras" => "apROS°Ra",
"approchèrent" => "apRoSER",
"approcherez" => "apROS°Re",
"approcherions" => "apRoS°Rj§",
"approcherons" => "apROS°R§",
"approcheront" => "apROS°R§",
"approches" => "apROS",
"approchés" => "apRoSe",
"approchez" => "apRoSe",
"approchiez" => "apRoSje",
"approchions" => "apRoSj§",
"approchons" => "apRoS§",
"approfondi" => "apRof§di",
"approfondie" => "apRof§di",
"approfondies" => "apRof§di",
"approfondir" => "apRof§diR",
"approfondirai" => "apRof§diRE",
"approfondirent" => "apRof§diR",
"approfondirions" => "apRof§diRj§",
"approfondirons" => "apRof§diR§",
"approfondis" => "apRof§di",
"approfondissaient" => "apRof§disE",
"approfondissais" => "apRof§disE",
"approfondissait" => "apRof§disE",
"approfondissant" => "apRof§dis@",
"approfondisse" => "apRof§dis",
"approfondissement" => "apROf§dis°m@",
"approfondissent" => "apRof§dis",
"approfondissons" => "apRof§dis§",
"approfondit" => "apRof§di",
"approfondît" => "apRof§di",
"appropriaient" => "apRopRijE",
"appropriait" => "apRopRijE",
"appropriant" => "apRopRij@",
"appropriation" => "apRopRijasj§",
"appropriations" => "apRopRijasj§",
"approprie" => "apRopRi",
"approprié" => "apRopRije",
"appropriée" => "apRopRije",
"appropriées" => "apRopRije",
"approprient" => "apRopRi",
"approprier" => "apRopRije",
"approprieraient" => "apRopRiRE",
"approprierais" => "apRopRiRE",
"approprierait" => "apRopRiRE",
"approprieront" => "apRopRiR§",
"appropriés" => "apRopRije",
"appropriez" => "apRopRie",
"approuva" => "apRuva",
"approuvai" => "apRuvE",
"approuvaient" => "apRuvE",
"approuvais" => "apRuvE",
"approuvait" => "apRuvE",
"approuvâmes" => "apRuvam",
"approuvant" => "apRuv@",
"approuvât" => "apRuva",
"approuve" => "apRuv",
"approuvé" => "apRuve",
"approuvée" => "apRuve",
"approuvées" => "apRuve",
"approuvent" => "apRuv",
"approuver" => "apRuve",
"approuvera" => "apRuv°Ra",
"approuverai" => "apRuv°RE",
"approuverais" => "apRuv°RE",
"approuverait" => "apRuv°RE",
"approuveras" => "apRuv°Ra",
"approuvèrent" => "apRuvER",
"approuverons" => "apRuv°R§",
"approuveront" => "apRuv°R§",
"approuves" => "apRuv",
"approuvés" => "apRuve",
"approuvez" => "apRuve",
"approuviez" => "apRuvje",
"approuvions" => "apRuvj§",
"approuvons" => "apRuv§",
"approvisionnait" => "apRovizjonE",
"approvisionnant" => "apROvizjOn@",
"approvisionne" => "apRovizjOn",
"approvisionné" => "apRovizjone",
"approvisionnée" => "apRovizjone",
"approvisionnées" => "apRovizjone",
"approvisionnement" => "apRovizjOn°m@",
"approvisionnements" => "apRovizjOn°m@",
"approvisionnent" => "apRovizjOn",
"approvisionner" => "apRovizjone",
"approvisionnera" => "apRovizjOn°Ra",
"approvisionnés" => "apRovizjone",
"approvisionniez" => "apRovizjonje",
"approvisionnons" => "apRovizjon§",
"approximatif" => "apROksimatif",
"approximatifs" => "apROksimatif",
"approximation" => "apROksimasj§",
"approximations" => "apROksimasj§",
"approximative" => "apROksimativ",
"approximativement" => "apROksimativ°m@",
"approximatives" => "apROksimativ",
"appui" => "ap8i",
"appui-main" => "ap8im5",
"appui-tête" => "ap8itEt°",
"appuie" => "ap8i",
"appuie-tête" => "ap8itEt",
"appuient" => "ap8i",
"appuiera" => "ap8iRa",
"appuierai" => "ap8iRE",
"appuieraient" => "ap8iRE",
"appuierais" => "ap8iRE",
"appuierait" => "ap8iRE",
"appuieras" => "ap8iRa",
"appuierez" => "ap8iRe",
"appuierons" => "ap8iR§",
"appuieront" => "ap8iR§",
"appuies" => "ap8i",
"appuis" => "ap8i",
"appuya" => "ap8ija",
"appuyai" => "ap8ijE",
"appuyaient" => "ap8ijE",
"appuyais" => "ap8ijE",
"appuyait" => "ap8ijE",
"appuyâmes" => "ap8ijam",
"appuyant" => "ap8ij@",
"appuyât" => "ap8ija",
"appuyé" => "ap8ije",
"appuyée" => "ap8ije",
"appuyées" => "ap8ije",
"appuyer" => "ap8ije",
"appuyèrent" => "ap8ijER",
"appuyés" => "ap8ije",
"appuyez" => "ap8ije",
"appuyiez" => "ap8ije",
"appuyons" => "ap8ij§",
"âpre" => "apR",
"aprèm" => "apREm",
"aprème" => "apREm",
"âprement" => "apR°m@",
"âpres" => "apR",
"après" => "apRE",
"après-coup" => "apREku",
"après-déjeuner" => "apREdeZ9ne",
"après-demain" => "apREd°m5",
"après-dîner" => "apREdine",
"après-dîners" => "apREdine",
"après-guerre" => "apREgER",
"après-mort" => "apREmOR",
"après-rasage" => "apRERazaZ",
"après-repas" => "apRER°pa",
"après-shampoing" => "apRES@pw5",
"après-shampooing" => "apRES@pw5",
"après-ski" => "apREski",
"après-vente" => "apREv@t",
"âpreté" => "apR°te",
"âpretés" => "apR°te",
"apte" => "apt",
"aptère" => "aptER",
"aptères" => "aptER",
"aptes" => "apt",
"aptitude" => "aptityd",
"aptitudes" => "aptityd",
"apurait" => "apyRE",
"apuré" => "apyRe",
"apurer" => "apyRe",
"apurés" => "apyRe",
"aquaculture" => "akwakyltyR",
"aquagym" => "akwaZim",
"aquaplane" => "akwaplan",
"aquarellait" => "akwaRElE",
"aquarelle" => "akwaREl",
"aquarelles" => "akwaREl",
"aquarellés" => "akwaREle",
"aquarelliste" => "akwaRelist",
"aquarellistes" => "akwaRElist",
"aquariophilie" => "akwaRjOfili",
"aquarium" => "akwaRjOm",
"aquariums" => "akwaRjOm",
"aquatinte" => "akwat5t",
"aquatique" => "akwatik",
"aquatiques" => "akwatik",
"aquavit" => "akwavit",
"aqueduc" => "ak°dyk",
"aqueducs" => "ak°dyk",
"aqueuse" => "ak2z",
"aqueuses" => "ak2z",
"aqueux" => "ak2",
"aquifère" => "akifER",
"aquilin" => "akil5",
"aquilon" => "akil§",
"aquilons" => "akil§",
"aquitain" => "akit5",
"ara" => "aRa",
"arabe" => "aRab",
"arabes" => "aRab",
"arabesque" => "aRabEsk",
"arabesques" => "aRabEsk",
"arabica" => "aRabika",
"arabicas" => "aRabika",
"arabique" => "aRabik",
"arabisant" => "aRabiz@",
"arabisants" => "aRabiz@",
"arabisé" => "aRabize",
"arable" => "aRabl",
"arables" => "aRabl",
"arac" => "aRak",
"arachide" => "aRaSid",
"arachides" => "aRaSid",
"arachnéen" => "aRakne5",
"arachnéenne" => "aRakneEn",
"arachnéennes" => "aRakneEn",
"arachnide" => "aRaknid",
"arachnides" => "aRaknid",
"arachnoïde" => "aRaknoid",
"arachnoïdes" => "aRaknoid",
"aragonais" => "aRagonE",
"aragonaise" => "aRagonEz",
"aragonite" => "aRagOnit",
"araigne" => "aREN",
"araignée" => "aRENe",
"araignée-crabe" => "aRENekRab",
"araignées" => "aRENe",
"araire" => "aRER",
"arak" => "aRak",
"araldite" => "aRaldit",
"aralia" => "aRalja",
"araméen" => "aRame5",
"araméenne" => "aRameEn",
"aramide" => "aRamid",
"aramon" => "aRam§",
"aranéeuse" => "aRane2z",
"arapèdes" => "aRapEd",
"aras" => "aRa",
"arasant" => "aRaz@",
"arasée" => "aRaze",
"araser" => "aRaze",
"aratoire" => "aRatwaR",
"aratoires" => "aRatwaR",
"araucan" => "aRok@",
"araucanien" => "aRokanj5",
"araucaniennes" => "aRokanjEn",
"araucaniens" => "aRokanj5",
"araucaria" => "aRokaRja",
"araucarias" => "aRokaRja",
"arbalète" => "aRbalEt",
"arbalètes" => "aRbalEt",
"arbalétrier" => "aRbaletRije",
"arbalétriers" => "aRbaletRije",
"arbi" => "aRbi",
"arbis" => "aRbi",
"arbitrage" => "aRbitRaZ",
"arbitrages" => "aRbitRaZ",
"arbitraire" => "aRbitRER",
"arbitrairement" => "aRbitRER°m@",
"arbitraires" => "aRbitRER",
"arbitrait" => "aRbitRE",
"arbitrale" => "aRbitRal",
"arbitre" => "aRbitR",
"arbitré" => "aRbitRe",
"arbitrée" => "aRbitRe",
"arbitrées" => "aRbitRe",
"arbitrer" => "aRbitRe",
"arbitrera" => "aRbitR°Ra",
"arbitres" => "aRbitR",
"arbois" => "aRbwa",
"arbora" => "aRboRa",
"arboraient" => "aRboRE",
"arborais" => "aRboRE",
"arborait" => "aRboRE",
"arborant" => "aRboR@",
"arborât" => "aRboRa",
"arbore" => "aRbOR",
"arboré" => "aRboRe",
"arborée" => "aRboRe",
"arborent" => "aRbOR",
"arborer" => "aRboRe",
"arborerait" => "aRbOR°RE",
"arborèrent" => "aRbORER",
"arbores" => "aRbOR",
"arborés" => "aRboRe",
"arborescence" => "aRboREs@s",
"arborescences" => "aRboREs@s",
"arborescent" => "aRboREs@",
"arborescentes" => "aRboREs@t",
"arborescents" => "aRboREs@",
"arboretum" => "aRbORetOm",
"arborez" => "aRboRe",
"arboricole" => "aRboRikOl",
"arboriculteur" => "aRbORikylt9R",
"arboriculture" => "aRboRikyltyR",
"arborions" => "aRboRj§",
"arborisations" => "aRboRizasj§",
"arbouse" => "aRbuz",
"arbouses" => "aRbuz",
"arbousiers" => "aRbuzje",
"arbre" => "aRbR",
"arbres" => "aRbR",
"arbres-refuges" => "aRbR°R°fyZ",
"arbrisseau" => "aRbRiso",
"arbrisseaux" => "aRbRiso",
"arbuste" => "aRbyst",
"arbustes" => "aRbyst",
"arc" => "aRk",
"arc-bouta" => "aRkbuta",
"arc-boutais" => "aRkbutE",
"arc-boutait" => "aRkbutE",
"arc-boutant" => "aRkbut@",
"arc-boutants" => "aRkbut@",
"arc-boute" => "aRkbut",
"arc-bouté" => "aRkbute",
"arc-boutée" => "aRkbute",
"arc-boutées" => "aRkbute",
"arc-boutement" => "aRkbut°m@",
"arc-boutent" => "aRkbut",
"arc-bouter" => "aRkbute",
"arc-boutera" => "aRkbut°Ra",
"arc-boutèrent" => "aRkbutER",
"arc-boutés" => "aRkbute",
"arc-en-ciel" => "aRk@sjEl",
"arcade" => "aRkad",
"arcades" => "aRkad",
"arcadien" => "aRkadj5",
"arcadienne" => "aRkadjEn",
"arcadiens" => "aRkadj5",
"arcan" => "aRk@",
"arcane" => "aRkan",
"arcanes" => "aRkan",
"arcans" => "aRk@",
"arcatures" => "aRkatyR",
"arceau" => "aRso",
"arceaux" => "aRso",
"archaïque" => "aRkaik",
"archaïques" => "aRkaik",
"archaïsant" => "aRkaiz@",
"archaïsme" => "aRkaizm",
"archange" => "aRk@Z",
"archangélique" => "aRk@Zelik",
"archanges" => "aRk@Z",
"arche" => "aRS",
"archéologie" => "aRkeoloZi",
"archéologique" => "aRkeoloZik",
"archéologiques" => "aRkeoloZik",
"archéologue" => "aRkeolOg",
"archéologues" => "aRkeolOg",
"archéoptéryx" => "aRkeOpteRiks",
"archer" => "aRSe",
"archères" => "aRSER",
"archers" => "aRSe",
"arches" => "aRS",
"archet" => "aRSE",
"archets" => "aRSE",
"archétypale" => "aRketipal",
"archétypaux" => "aRketipo",
"archétype" => "aRketip",
"archétypes" => "aRketip",
"archevêché" => "aRS°veSe",
"archevêchés" => "aRS°veSe",
"archevêque" => "aRS°vEk",
"archevêques" => "aRS°vEk",
"archi" => "aRSi",
"archi-blet" => "aRSiblE",
"archi-chiants" => "aRSiSj@",
"archi-connu" => "aRSikony",
"archi-connus" => "aRSikony",
"archi-dégueu" => "aRSideg2",
"archi-duchesse" => "aRSidySEs",
"archi-faux" => "aRSifo",
"archi-libre" => "aRSilibR",
"archi-méfiance" => "aRSimefj@s",
"archi-mortels" => "aRSimORtEl",
"archi-morts" => "aRSimOR",
"archi-nul" => "aRSinyl",
"archi-nuls" => "aRSinyl",
"archi-plein" => "aRSipl5",
"archi-prouvé" => "aRSipRuve",
"archi-prudent" => "aRSipRyd@",
"archi-ringard" => "aRSiR5gaR",
"archi-sèches" => "aRSisES",
"archi-sophistiquée" => "aRSisofistike",
"archi-usé" => "aRSiyze",
"archi-vieux" => "aRSivj2",
"archiatre" => "aRSiatR",
"archicomble" => "aRSik§bl",
"archicombles" => "aRSik§bl",
"archiconnu" => "aRSikony",
"archidiacre" => "aRSidjakR",
"archidiocèse" => "aRSidjosEz",
"archiduc" => "aRSidyk",
"archiduchesse" => "aRSidySEs",
"archiducs" => "aRSidyk",
"archie" => "aRSi",
"archiépiscopal" => "aRSiepiskopal",
"archifaux" => "aRSifo",
"archimandrite" => "aRSim@dRit",
"archinulles" => "aRSinyl",
"archipel" => "aRSipEl",
"archipels" => "aRSipEl",
"archiprêtre" => "aRSipREtR",
"architecte" => "aRSitEkt",
"architectes" => "aRSitEkt",
"architectonie" => "aRSitEktOni",
"architectonique" => "aRSitEktonik",
"architectural" => "aRSitEktyRal",
"architecturale" => "aRSitEktyRal",
"architecturalement" => "aRSitEktyRal°m@",
"architecturales" => "aRSitEktyRal",
"architecturant" => "aRSitEktyR@",
"architecturaux" => "aRSitEktyRo",
"architecture" => "aRSitEktyR",
"architecturées" => "aRSitEktyRe",
"architecturent" => "aRSitEktyR",
"architectures" => "aRSitEktyR",
"architrave" => "aRSitRav",
"archivage" => "aRSivaZ",
"archive" => "aRSiv",
"archivé" => "aRSive",
"archivées" => "aRSive",
"archiver" => "aRSive",
"archives" => "aRSiv",
"archivés" => "aRSive",
"archivez" => "aRSive",
"archivions" => "aRSivj§",
"archiviste" => "aRSivist",
"archiviste-paléographe" => "aRSivistpaleOgRaf",
"archivistes" => "aRSivist",
"archivistes-paléographes" => "aRSivistpaleOgRaf",
"archivolte" => "aRSivOlt",
"archivoltes" => "aRSivOlt",
"archivons" => "aRSiv§",
"archonte" => "aRk§t",
"arçon" => "aRs§",
"arçons" => "aRs§",
"arcs" => "aRk",
"arcs-boutants" => "aRkbut@",
"arcs-en-ciel" => "aRk@sjEl",
"arctique" => "aRktik",
"arctiques" => "aRktik",
"ardais" => "aRdE",
"ardait" => "aRdE",
"ardant" => "aRd@",
"arde" => "aRd",
"ardé" => "aRde",
"ardéchois" => "aRdeSwa",
"ardéchoise" => "aRdeSwaz",
"ardemment" => "aRdam@",
"ardennais" => "aRd°nE",
"ardennaise" => "aRd°nEz",
"ardent" => "aRd@",
"ardente" => "aRd@t",
"ardentes" => "aRd@t",
"ardents" => "aRd@",
"arder" => "aRde",
"ardeur" => "aRd9R",
"ardeurs" => "aRd9R",
"ardillon" => "aRdij§",
"ardillons" => "aRdij§",
"ardin" => "aRd5",
"ardito" => "aRdito",
"ardoise" => "aRdwaz",
"ardoisée" => "aRdwaze",
"ardoisées" => "aRdwaze",
"ardoises" => "aRdwaz",
"ardoisés" => "aRdwaze",
"ardoisière" => "aRdwazjER",
"ardre" => "aRdR°",
"ardu" => "aRdy",
"ardue" => "aRdy",
"ardues" => "aRdy",
"ardûment" => "aRdym@",
"ardus" => "aRdy",
"are" => "aR",
"area" => "aRea",
"arec" => "aREk",
"aréflexie" => "aReflEksi",
"aréna" => "aRena",
"arène" => "aREn",
"arènes" => "aREn",
"aréole" => "aReOl",
"aréoles" => "aReOl",
"aréopage" => "aReopaZ",
"aréopages" => "aReopaZ",
"aréopagite" => "aReopaZit",
"aréquier" => "aRekie",
"ares" => "aR",
"arête" => "aREt",
"arêtes" => "aREt",
"arétin" => "aRet5",
"arganier" => "aRganje",
"arganiers" => "aRganje",
"argans" => "aRg@",
"argent" => "aRZ@",
"argentait" => "aRZ@tE",
"argente" => "aRZ@t",
"argenté" => "aRZ@te",
"argentée" => "aRZ@te",
"argentées" => "aRZ@te",
"argenterie" => "aRZ@t°Ri",
"argenteries" => "aRZ@t°Ri",
"argentés" => "aRZ@te",
"argentier" => "aRZ@tje",
"argentifères" => "aRZ@tifER",
"argentin" => "aRZ@t5",
"argentine" => "aRZ@tin",
"argentines" => "aRZ@tin",
"argentins" => "aRZ@t5",
"argenton" => "aRZ@t§",
"argents" => "aRZ@",
"argile" => "aRZil",
"argiles" => "aRZil",
"argileuse" => "aRZil2z",
"argileux" => "aRZil2",
"argilière" => "aRZiljER",
"argol" => "aRgOl",
"argon" => "aRg§",
"argonaute" => "aRgonot",
"argot" => "aRgo",
"argotique" => "aRgotik",
"argotiques" => "aRgotik",
"argots" => "aRgo",
"argougnasses" => "aRguNas",
"argougne" => "aRguN",
"argousin" => "aRguz5",
"argousins" => "aRguz5",
"argua" => "aRga",
"arguais" => "aRgE",
"arguait" => "aRgE",
"arguant" => "aRg@",
"argue" => "aRg",
"argué" => "aRg8e",
"arguer" => "aRge",
"argument" => "aRgym@",
"argumenta" => "aRgym@ta",
"argumentaire" => "aRgym@tER",
"argumentait" => "aRgym@tE",
"argumentant" => "aRgym@t@",
"argumentateur" => "aRgym@tat9R",
"argumentatif" => "aRgym@tatif",
"argumentation" => "aRgym@tasj§",
"argumentations" => "aRgym@tasj§",
"argumente" => "aRgym@t",
"argumenté" => "aRgym@te",
"argumentent" => "aRgym@t",
"argumenter" => "aRgym@te",
"argumenterai" => "aRgym@t°RE",
"argumentes" => "aRgym@t",
"argumentez" => "aRgym@te",
"arguments" => "aRgym@",
"argus" => "aRgys",
"argutie" => "aRgysi",
"arguties" => "aRgysi",
"aria" => "aRja",
"arianisme" => "aRjanizm",
"arias" => "aRja",
"aride" => "aRid",
"arides" => "aRid",
"aridité" => "aRidite",
"ariégeois" => "aRjeZwa",
"ariégeoise" => "aRjeZwaz",
"arien" => "aRj5",
"arienne" => "aRjEn",
"ariens" => "aRj5",
"ariettes" => "aRjEt",
"arioso" => "aRjozo",
"aristarque" => "aRistaRk",
"aristarques" => "aRistaRk",
"aristo" => "aRisto",
"aristocrate" => "aRistokRat",
"aristocrates" => "aRistokRat",
"aristocratie" => "aRistokRasi",
"aristocratique" => "aRistokRatik",
"aristocratiquement" => "aRistokRatik°m@",
"aristocratiques" => "aRistokRatik",
"aristocratisme" => "aRistokRatizm",
"aristoloche" => "aRistolOS",
"aristoloches" => "aRistolOS",
"aristos" => "aRisto",
"aristotélicien" => "aRistotelisj5",
"aristotélicienne" => "aRistotelisjEn",
"arithmétique" => "aRitmetik",
"arithmétiquement" => "aRitmetik°m@",
"arithmétiques" => "aRitmetik",
"arithmomètre" => "aRitmomEtR",
"arkose" => "aRkoz",
"arlequin" => "aRl°k5",
"arlequins" => "aRl°k5",
"arlésien" => "aRlezj5",
"arlésienne" => "aRlezjEn",
"arlésiennes" => "aRlezjEn",
"arma" => "aRma",
"armada" => "aRmada",
"armadas" => "aRmada",
"armadille" => "aRmadil",
"armagnac" => "aRmaNak",
"armagnacs" => "aRmaNak",
"armai" => "aRmE",
"armaient" => "aRmE",
"armait" => "aRmE",
"armant" => "aRm@",
"armât" => "aRma",
"armateur" => "aRmat9R",
"armateurs" => "aRmat9R",
"armature" => "aRmatyR",
"armaturent" => "aRmatyR",
"armatures" => "aRmatyR",
"arme" => "aRm",
"armé" => "aRme",
"arme-miracle" => "aRmmiRakl",
"armée" => "aRme",
"armées" => "aRme",
"armement" => "aRm°m@",
"armements" => "aRm°m@",
"arménien" => "aRmenj5",
"arménienne" => "aRmenjEn",
"arméniennes" => "aRmenjEn",
"arméniens" => "aRmenj5",
"arménoïde" => "aRmenoid",
"arment" => "aRm",
"armer" => "aRme",
"armeraient" => "aRm°RE",
"armerais" => "aRm°RE",
"arméria" => "aRmeRja",
"armérias" => "aRmeRja",
"armeront" => "aRm°R§",
"armes" => "aRm",
"armés" => "aRme",
"armez" => "aRme",
"armistice" => "aRmistis",
"armistices" => "aRmistis",
"armoire" => "aRmwaR",
"armoires" => "aRmwaR",
"armoirie" => "aRmwaRi",
"armoiries" => "aRmwaRi",
"armoise" => "aRmwaz",
"armoises" => "aRmwaz",
"armon" => "aRm§",
"armons" => "aRm§",
"armorial" => "aRmoRjal",
"armoricaine" => "aRmoRikEn",
"armorié" => "aRmoRje",
"armoriée" => "aRmoRje",
"armoriées" => "aRmoRje",
"armoriés" => "aRmoRje",
"armure" => "aRmyR",
"armurerie" => "aRmyR°Ri",
"armureries" => "aRmyR°Ri",
"armures" => "aRmyR",
"armurier" => "aRmyRje",
"armuriers" => "aRmyRje",
"arnaquait" => "aRnakE",
"arnaquant" => "aRnak@",
"arnaque" => "aRnak",
"arnaqué" => "aRnake",
"arnaquée" => "aRnake",
"arnaquent" => "aRnak",
"arnaquer" => "aRnake",
"arnaquera" => "aRnak°Ra",
"arnaques" => "aRnak",
"arnaqués" => "aRnake",
"arnaqueur" => "aRnak9R",
"arnaqueurs" => "aRnak9R",
"arnaqueuse" => "aRnak2z",
"arnaquez" => "aRnake",
"arnica" => "aRnika",
"arobase" => "aRObaz",
"aromate" => "aRomat",
"aromates" => "aRomat",
"aromathérapie" => "aRomateRapi",
"aromatique" => "aRomatik",
"aromatiques" => "aRomatik",
"aromatisé" => "aRomatize",
"aromatisée" => "aRomatize",
"aromatisées" => "aRomatize",
"aromatiser" => "aROmatize",
"aromatisés" => "aRomatize",
"arôme" => "aRom",
"arômes" => "aRom",
"aronde" => "aR§d",
"arousal" => "aRuzal",
"arpège" => "aRpEZ",
"arpégé" => "aRpeZe",
"arpèges" => "aRpEZ",
"arpent" => "aRp@",
"arpenta" => "aRp@ta",
"arpentage" => "aRp@taZ",
"arpentages" => "aRp@taZ",
"arpentai" => "aRp@tE",
"arpentaient" => "aRp@tE",
"arpentais" => "aRp@tE",
"arpentait" => "aRp@tE",
"arpentant" => "aRp@t@",
"arpente" => "aRp@t",
"arpenté" => "aRp@te",
"arpentée" => "aRp@te",
"arpentent" => "aRp@t",
"arpenter" => "aRp@te",
"arpenterai" => "aRp@t°RE",
"arpentèrent" => "aRp@tER",
"arpenteront" => "aRp@t°R§",
"arpentés" => "aRp@te",
"arpenteur" => "aRp@t9R",
"arpenteurs" => "aRp@t9R",
"arpentez" => "aRp@te",
"arpentions" => "aRp@tj§",
"arpentons" => "aRp@t§",
"arpents" => "aRp@",
"arpète" => "aRpEt",
"arpètes" => "aRpEt",
"arpette" => "aRpEt",
"arpion" => "aRpj§",
"arpions" => "aRpj§",
"arqua" => "aRka",
"arquaient" => "aRkE",
"arquait" => "aRkE",
"arquant" => "aRk@",
"arque" => "aRk",
"arqué" => "aRke",
"arquebusade" => "aRk°byzad",
"arquebusât" => "aRk°byza",
"arquebuse" => "aRk°byz",
"arquebuses" => "aRk°byz",
"arquebusiers" => "aRk°byzje",
"arquée" => "aRke",
"arquées" => "aRke",
"arquent" => "aRk",
"arquepince" => "aRk°p5s",
"arquer" => "aRke",
"arqués" => "aRke",
"arracha" => "aRaSa",
"arrachage" => "aRaSaZ",
"arrachai" => "aRaSE",
"arrachaient" => "aRaSE",
"arrachais" => "aRaSE",
"arrachait" => "aRaSE",
"arrachant" => "aRaS@",
"arrachât" => "aRaSa",
"arrache" => "aRaS",
"arraché" => "aRaSe",
"arrache-clou" => "aRaSklu",
"arrachée" => "aRaSe",
"arrachées" => "aRaSe",
"arrachement" => "aRaS°m@",
"arrachements" => "aRaS°m@",
"arrachent" => "aRaS",
"arracher" => "aRaSe",
"arrachera" => "aRaS°Ra",
"arracherai" => "aRaS°RE",
"arracheraient" => "aRaS°RE",
"arracherais" => "aRaS°RE",
"arracherait" => "aRaS°RE",
"arracheras" => "aRaS°Ra",
"arrachèrent" => "aRaSER",
"arracherons" => "aRaS°R§",
"arracheront" => "aRaS°R§",
"arraches" => "aRaS",
"arrachés" => "aRaSe",
"arracheur" => "aRaS9R",
"arracheurs" => "aRaS9R",
"arracheuse" => "aRaS2z",
"arracheuses" => "aRaS2z",
"arrachez" => "aRaSe",
"arrachiez" => "aRaSje",
"arrachions" => "aRaSj§",
"arrachons" => "aRaS§",
"arrachures" => "aRaSyR",
"arraisonné" => "aREzone",
"arraisonnées" => "aREzone",
"arraisonner" => "aREzone",
"arraisonnerons" => "aREzOn°R§",
"arraisonnés" => "aREzone",
"arrange" => "aR@Z",
"arrangé" => "aR@Ze",
"arrangea" => "aR@Za",
"arrangeai" => "aR@ZE",
"arrangeaient" => "aR@ZE",
"arrangeais" => "aR@ZE",
"arrangeait" => "aR@ZE",
"arrangeant" => "aR@Z@",
"arrangeante" => "aR@Z@t",
"arrangeantes" => "aR@Z@t",
"arrangeants" => "aR@Z@",
"arrangeât" => "aR@Za",
"arrangée" => "aR@Ze",
"arrangées" => "aR@Ze",
"arrangement" => "aR@Z°m@",
"arrangements" => "aR@Z°m@",
"arrangent" => "aR@Z",
"arrangeons" => "aR@Z§",
"arranger" => "aR@Ze",
"arrangera" => "aR@Z°Ra",
"arrangerai" => "aR@Z°RE",
"arrangeraient" => "aR@Z°RE",
"arrangerais" => "aR@Z°RE",
"arrangerait" => "aR@Z°RE",
"arrangeras" => "aR@Z°Ra",
"arrangèrent" => "aR@ZER",
"arrangerez" => "aR@Z°Re",
"arrangerions" => "aR@Z°Rj§",
"arrangerons" => "aR@Z°R§",
"arrangeront" => "aR@Z°R§",
"arranges" => "aR@Z",
"arrangés" => "aR@Ze",
"arrangeur" => "aR@Z9R",
"arrangeurs" => "aR@Z9R",
"arrangez" => "aR@Ze",
"arrangiez" => "aR@Zje",
"arrangions" => "aR@Zj§",
"arrérages" => "aReRaZ",
"arrestation" => "aREstasj§",
"arrestations" => "aREstasj§",
"arrêt" => "aRE",
"arrêt-buffet" => "aREbyfE",
"arrêta" => "aREta",
"arrêtai" => "aREtE",
"arrêtaient" => "aREtE",
"arrêtais" => "aREtE",
"arrêtait" => "aREtE",
"arrêtâmes" => "aREtam",
"arrêtant" => "aREt@",
"arrêtassent" => "aREtas",
"arrêtât" => "aREta",
"arrête" => "aREt",
"arrêté" => "aRete",
"arrête-boeuf" => "aREtb9f",
"arrêtée" => "aRete",
"arrêtées" => "aRete",
"arrêtent" => "aREt",
"arrêter" => "aRete",
"arrêtera" => "aREt°Ra",
"arrêterai" => "aREt°RE",
"arrêteraient" => "aREt°RE",
"arrêterais" => "aREt°RE",
"arrêterait" => "aREt°RE",
"arrêteras" => "aREt°Ra",
"arrêtèrent" => "aREtER",
"arrêterez" => "aREt°Re",
"arrêteriez" => "aREt°Rje",
"arrêterions" => "aREt°Rj§",
"arrêterons" => "aREt°R§",
"arrêteront" => "aREt°R§",
"arrêtes" => "aREt",
"arrêtés" => "aRete",
"arrêtez" => "aREte",
"arrêtiez" => "aREtje",
"arrêtions" => "aREtj§",
"arrêtons" => "aREt§",
"arrêts" => "aRE",
"arrêts-buffet" => "aREbyfE",
"arrhes" => "aR",
"arriération" => "aRjeRasj§",
"arrière" => "aRjER",
"arriéré" => "aRjeRe",
"arrière-automne" => "aRjERotOn",
"arrière-ban" => "aRjERb@",
"arrière-boutique" => "aRjERbutik",
"arrière-boutiques" => "aRjERbutik",
"arrière-cabinets" => "aRjERkabinE",
"arrière-cour" => "aRjERkuR",
"arrière-cours" => "aRjERkuR",
"arrière-cousin" => "aRjERkuz5",
"arrière-cuisine" => "aRjERk8izin",
"arrière-cuisines" => "aRjERk8izin",
"arrière-fond" => "aRjERf§",
"arrière-garde" => "aRjERgaRd",
"arrière-gardes" => "aRjERgaRd",
"arrière-gorge" => "aRjERgORZ",
"arrière-goût" => "aRjERgu",
"arrière-goûts" => "aRjERgu",
"arrière-grand-mère" => "aRjERgR@mER",
"arrière-grand-mères" => "aRjERgR@mER",
"arrière-grand-oncle" => "aRjERgR@§kl",
"arrière-grand-père" => "aRjERgR@pER",
"arrière-grand-tante" => "aRjERgR@t@t",
"arrière-grand-tantes" => "aRjERgR@t@t",
"arrière-grands-mères" => "aRjERgR@mER",
"arrière-grands-parents" => "aRjERgR@paR@",
"arrière-grands-pères" => "aRjERgR@pER",
"arrière-loge" => "aRjERlOZ",
"arrière-magasin" => "aRjERmagaz5",
"arrière-main" => "aRjERm5",
"arrière-monde" => "aRjERm§d",
"arrière-neveux" => "aRjERn°v2",
"arrière-pays" => "aRjERpei",
"arrière-pensée" => "aRjERp@se",
"arrière-pensées" => "aRjERp@se",
"arrière-petit-fils" => "aRjERp°tifis",
"arrière-petit-neveu" => "aRjERp°tin°v2",
"arrière-petite-fille" => "aRjERp°titfij",
"arrière-petite-nièce" => "aRjERp°titnjEs",
"arrière-petites-filles" => "aRjERp°titfij",
"arrière-petites-nièces" => "aRjERp°titnjEs",
"arrière-petits-enfants" => "aRjERp°tiz@f@",
"arrière-petits-fils" => "aRjERp°tifis",
"arrière-petits-neveux" => "aRjERp°tin°v2",
"arrière-plan" => "aRjERpl@",
"arrière-plans" => "aRjERpl@",
"arrière-saison" => "aRjERsEz§",
"arrière-salle" => "aRjERsal",
"arrière-salles" => "aRjERsal",
"arrière-train" => "aRjERtR5",
"arrière-trains" => "aRjERtR5",
"arriérée" => "aRjeRe",
"arriérées" => "aRjeRe",
"arrières" => "aRjER",
"arriérés" => "aRjeRe",
"arrima" => "aRima",
"arrimage" => "aRimaZ",
"arrimais" => "aRimE",
"arrimait" => "aRimE",
"arrimant" => "aRim@",
"arrime" => "aRim",
"arrimé" => "aRime",
"arrimée" => "aRime",
"arrimées" => "aRime",
"arriment" => "aRim",
"arrimer" => "aRime",
"arrimés" => "aRime",
"arrimez" => "aRime",
"arriva" => "aRiva",
"arrivage" => "aRivaZ",
"arrivages" => "aRivaZ",
"arrivai" => "aRivE",
"arrivaient" => "aRivE",
"arrivais" => "aRivE",
"arrivait" => "aRivE",
"arrivâmes" => "aRivam",
"arrivant" => "aRiv@",
"arrivante" => "aRiv@t",
"arrivants" => "aRiv@",
"arrivas" => "aRiva",
"arrivassent" => "aRivas",
"arrivât" => "aRiva",
"arrivâtes" => "aRivat",
"arrive" => "aRiv",
"arrivé" => "aRive",
"arrivée" => "aRive",
"arrivées" => "aRive",
"arrivent" => "aRiv",
"arriver" => "aRive",
"arrivera" => "aRiv°Ra",
"arriverai" => "aRiv°RE",
"arriveraient" => "aRiv°RE",
"arriverais" => "aRiv°RE",
"arriverait" => "aRiv°RE",
"arriveras" => "aRiv°Ra",
"arrivèrent" => "aRivER",
"arriverez" => "aRiv°Re",
"arriveriez" => "aRiv°Rje",
"arriverions" => "aRiv°Rj§",
"arriverons" => "aRiv°R§",
"arriveront" => "aRiv°R§",
"arrives" => "aRiv",
"arrivés" => "aRive",
"arrivez" => "aRive",
"arriviez" => "aRivje",
"arrivions" => "aRivj§",
"arrivisme" => "aRivizm",
"arriviste" => "aRivist",
"arrivistes" => "aRivist",
"arrivons" => "aRiv§",
"arrogamment" => "aRogam@",
"arrogance" => "aRog@s",
"arrogant" => "aRog@",
"arrogante" => "aRog@t",
"arrogantes" => "aRog@t",
"arrogants" => "aRog@",
"arroge" => "aROZ",
"arrogé" => "aRoZe",
"arrogeaient" => "aRoZE",
"arrogeait" => "aRoZE",
"arrogeant" => "aRoZ@",
"arrogée" => "aRoZe",
"arrogent" => "aROZ",
"arroger" => "aRoZe",
"arrogèrent" => "aRoZER",
"arroi" => "aRwa",
"arrondi" => "aR§di",
"arrondie" => "aR§di",
"arrondies" => "aR§di",
"arrondir" => "aR§diR",
"arrondira" => "aR§diRa",
"arrondirait" => "aR§diRE",
"arrondirent" => "aR§diR",
"arrondis" => "aR§di",
"arrondissaient" => "aR§disE",
"arrondissait" => "aR§disE",
"arrondissant" => "aR§dis@",
"arrondissement" => "aR§dis°m@",
"arrondissements" => "aR§dis°m@",
"arrondissent" => "aR§dis",
"arrondissons" => "aR§dis§",
"arrondit" => "aR§di",
"arrosa" => "aRoza",
"arrosage" => "aRozaZ",
"arrosaient" => "aRozE",
"arrosais" => "aRozE",
"arrosait" => "aRozE",
"arrosant" => "aRoz@",
"arrose" => "aRoz",
"arrosé" => "aRoze",
"arrosée" => "aRoze",
"arrosées" => "aRoze",
"arrosent" => "aRoz",
"arroser" => "aRoze",
"arrosera" => "aRoz°Ra",
"arroserais" => "aRoz°RE",
"arroserait" => "aRoz°RE",
"arroseras" => "aRoz°Ra",
"arrosèrent" => "aRozER",
"arroserez" => "aRoz°Re",
"arroseront" => "aRoz°R§",
"arroses" => "aRoz",
"arrosés" => "aRoze",
"arroseur" => "aRoz9R",
"arroseurs" => "aRoz9R",
"arroseuse" => "aRoz2z",
"arroseuses" => "aRoz2z",
"arrosez" => "aRoze",
"arrosiez" => "aRozje",
"arrosions" => "aRozj§",
"arrosoir" => "aRozwaR",
"arrosoirs" => "aRozwaR",
"arrosons" => "aRoz§",
"ars" => "aR",
"arsacide" => "aRsasid",
"arsenal" => "aRs2nal",
"arsenaux" => "aRs2no",
"arsenic" => "aRs2nik",
"arsenicales" => "aRs2nikal",
"arsénieux" => "aRsenj2",
"arsouille" => "aRsuj",
"arsouiller" => "aRsuje",
"arsouilles" => "aRsuj",
"art" => "aR",
"artefact" => "aRtefakt",
"artéfact" => "aRtefakt",
"artefacts" => "aRtefakt",
"artère" => "aRtER",
"artères" => "aRtER",
"artériectomie" => "aRteRjEktomi",
"artériel" => "aRteRjEl",
"artérielle" => "aRteRjEl",
"artérielles" => "aRteRjEl",
"artériographie" => "aRteRjOgRafi",
"artériole" => "aRteRjOl",
"artérioles" => "aRteRjOl",
"artériopathie" => "aRteRjopati",
"artériosclérose" => "aRteRjoskleRoz",
"artérite" => "aRteRit",
"artésien" => "aRtezj5",
"arthrite" => "aRtRit",
"arthrites" => "aRtRit",
"arthritique" => "aRtRitik",
"arthritiques" => "aRtRitik",
"arthrodèse" => "aRtRodEz",
"arthropathie" => "aRtROpati",
"arthroplastie" => "aRtROplasti",
"arthropodes" => "aRtRopOd",
"arthroscopie" => "aRtROskOpi",
"arthrose" => "aRtRoz",
"arthroses" => "aRtRoz",
"arthurien" => "aRtyRj5",
"arthurienne" => "aRtyRjEn",
"arthuriens" => "aRtyRj5",
"artichaut" => "aRtiSo",
"artichauts" => "aRtiSo",
"artiche" => "aRtiS",
"article" => "aRtikl",
"article-choc" => "aRtikl°SOk",
"articles" => "aRtikl",
"articula" => "aRtikyla",
"articulai" => "aRtikylE",
"articulaient" => "aRtikylE",
"articulaire" => "aRtikylER",
"articulaires" => "aRtikylER",
"articulait" => "aRtikylE",
"articulant" => "aRtikyl@",
"articulation" => "aRtikylasj§",
"articulations" => "aRtikylasj§",
"articule" => "aRtikyl",
"articulé" => "aRtikyle",
"articulée" => "aRtikyle",
"articulées" => "aRtikyle",
"articulent" => "aRtikyl",
"articuler" => "aRtikyle",
"articulés" => "aRtikyle",
"articulet" => "aRtikylE",
"articulez" => "aRtikyle",
"artifice" => "aRtifis",
"artifices" => "aRtifis",
"artificialité" => "aRtifisjalite",
"artificiel" => "aRtifisjEl",
"artificielle" => "aRtifisjEl",
"artificiellement" => "aRtifisjEl°m@",
"artificielles" => "aRtifisjEl",
"artificiels" => "aRtifisjEl",
"artificier" => "aRtifisje",
"artificiers" => "aRtifisje",
"artificieuse" => "aRtifisj2z",
"artificieuses" => "aRtifisj2z",
"artiflot" => "aRtiflo",
"artiflots" => "aRtiflo",
"artillerie" => "aRtij°Ri",
"artilleur" => "aRtij9R",
"artilleurs" => "aRtij9R",
"artimon" => "aRtim§",
"artisan" => "aRtiz@",
"artisanal" => "aRtizanal",
"artisanale" => "aRtizanal",
"artisanalement" => "aRtizanal°m@",
"artisanales" => "aRtizanal",
"artisanat" => "aRtizana",
"artisanaux" => "aRtizano",
"artisane" => "aRtizan",
"artisans" => "aRtiz@",
"artison" => "aRtiz§",
"artiste" => "aRtist",
"artiste-peintre" => "aRtist2p5tR",
"artistement" => "aRtist°m@",
"artistes" => "aRtist",
"artistique" => "aRtistik",
"artistiquement" => "aRtistik°m@",
"artistiques" => "aRtistik",
"arts" => "aR",
"arum" => "aROm",
"arums" => "aROm",
"aruspice" => "aRyspis",
"aruspices" => "aRyspis",
"arverne" => "aRvERn",
"arvernes" => "aRvERn",
"aryen" => "aRj5",
"aryenne" => "aRjEn",
"aryennes" => "aRjEn",
"aryens" => "aRj5",
"arythmie" => "aRitmi",
"arythmique" => "aRitmik",
"arzels" => "aRzEl",
"as" => "a",
"as-rois" => "asRwa",
"asa" => "aza",
"asana" => "azana",
"asbeste" => "asbEst",
"asbestose" => "asbEstoz",
"ascaris" => "askaRis",
"ascendance" => "as@d@s",
"ascendances" => "as@d@s",
"ascendant" => "as@d@",
"ascendante" => "as@d@t",
"ascendantes" => "as@d@t",
"ascendants" => "as@d@",
"ascendre" => "as@dR",
"ascendu" => "as@dy",
"ascenseur" => "as@s9R",
"ascenseurs" => "as@s9R",
"ascension" => "as@sj§",
"ascensionne" => "as@sjOn",
"ascensionnel" => "as@sjonEl",
"ascensionnelle" => "as@sjonEl",
"ascensionnelles" => "as@sjonEl",
"ascensionner" => "as@sjOne",
"ascensions" => "as@sj§",
"ascèse" => "asEz",
"ascèses" => "asEz",
"ascète" => "asEt",
"ascètes" => "asEt",
"ascétique" => "asetik",
"ascétiques" => "asetik",
"ascétisme" => "asetizm",
"ascite" => "asit",
"asclépias" => "asklepja",
"ascorbique" => "askORbik",
"ascot" => "askOt",
"asdic" => "asdik",
"ase" => "az",
"asepsie" => "asEpsi",
"aseptique" => "asEptik",
"aseptiques" => "asEptik",
"aseptisant" => "asEptis@",
"aseptisation" => "asEptizasj§",
"aseptisé" => "asEptize",
"aseptisée" => "asEptize",
"aseptisées" => "asEptize",
"aseptisés" => "asEptize",
"asexualité" => "asEksyalite",
"asexué" => "aseks8e",
"asexuée" => "aseks8e",
"asexuées" => "aseks8e",
"asexuelle" => "aseks8El",
"asexués" => "aseks8e",
"ashanti" => "aS@ti",
"ashkénaze" => "aSkenaz",
"ashkénazes" => "aSkenaz",
"ashram" => "aSRam",
"asiate" => "azjat",
"asiatique" => "azjatik",
"asiatiques" => "azjatik",
"asiatisé" => "azjatize",
"asilaire" => "azilER",
"asile" => "azil",
"asiles" => "azil",
"asociabilité" => "asosjabilite",
"asocial" => "asosjal",
"asociale" => "asosjal",
"asociales" => "azosjal",
"asociaux" => "asosjo",
"asparagus" => "aspaRagys",
"aspartam" => "aspaRtam",
"aspartame" => "aspaRtam",
"aspartique" => "aspaRtik",
"aspécifique" => "aspesifik",
"aspect" => "aspE",
"aspects" => "aspE",
"asperge" => "aspERZ",
"aspergé" => "aspERZe",
"aspergea" => "aspERZa",
"aspergeaient" => "aspERZE",
"aspergeait" => "aspERZE",
"aspergeant" => "aspERZ@",
"aspergée" => "aspERZe",
"aspergées" => "aspERZe",
"aspergent" => "aspERZ",
"asperger" => "aspERZe",
"aspergerait" => "aspERZ°RE",
"aspergèrent" => "aspERZER",
"asperges" => "aspERZ",
"aspergés" => "aspERZe",
"aspergez" => "aspERZe",
"aspergillose" => "aspERZiloz",
"aspergillus" => "aspERZilys",
"aspérité" => "aspeRite",
"aspérités" => "aspeRite",
"aspersion" => "aspERsj§",
"aspersions" => "aspERsj§",
"asphalte" => "asfalt",
"asphalté" => "asfalte",
"asphaltée" => "asfalte",
"asphaltées" => "asfalte",
"asphalter" => "asfalte",
"asphaltés" => "asfalte",
"asphodèle" => "asfodEl",
"asphodèles" => "asfodEl",
"asphyxia" => "asfiksja",
"asphyxiaient" => "asfiksjE",
"asphyxiait" => "asfiksjE",
"asphyxiant" => "asfiksj@",
"asphyxiante" => "asfiksj@t",
"asphyxiants" => "asfiksj@",
"asphyxie" => "asfiksi",
"asphyxié" => "asfiksje",
"asphyxiée" => "asfiksje",
"asphyxiées" => "asfiksje",
"asphyxient" => "asfiksi",
"asphyxier" => "asfiksje",
"asphyxiera" => "asfiksiRa",
"asphyxiés" => "asfiksje",
"aspi" => "aspi",
"aspic" => "aspik",
"aspics" => "aspik",
"aspidistra" => "aspidistRa",
"aspidistras" => "aspidistRa",
"aspira" => "aspiRa",
"aspirai" => "aspiRE",
"aspiraient" => "aspiRE",
"aspirais" => "aspiRE",
"aspirait" => "aspiRE",
"aspirant" => "aspiR@",
"aspirante" => "aspiR@t",
"aspirantes" => "aspiR@t",
"aspirants" => "aspiR@",
"aspirât" => "aspiRa",
"aspirateur" => "aspiRat9R",
"aspirateurs" => "aspiRat9R",
"aspirateurs-traîneaux" => "aspiRat9RtREno",
"aspiration" => "aspiRasj§",
"aspirations" => "aspiRasj§",
"aspire" => "aspiR",
"aspiré" => "aspiRe",
"aspirée" => "aspiRe",
"aspirées" => "aspiRe",
"aspirent" => "aspiR",
"aspirer" => "aspiRe",
"aspirera" => "aspiR°Ra",
"aspireraient" => "aspiR°RE",
"aspirerait" => "aspiR°RE",
"aspires" => "aspiR",
"aspirés" => "aspiRe",
"aspirez" => "aspiRe",
"aspiriez" => "aspiRje",
"aspirine" => "aspiRin",
"aspirines" => "aspiRin",
"aspirions" => "aspiRj§",
"aspirons" => "aspiR§",
"aspis" => "aspi",
"aspre" => "aspR",
"assa-foetida" => "asafetida",
"assagi" => "asaZi",
"assagie" => "asaZi",
"assagir" => "asaZiR",
"assagirai" => "asaZiRE",
"assagis" => "asaZi",
"assagissant" => "asaZis@",
"assagisse" => "asaZis",
"assagit" => "asaZi",
"assaillaient" => "asajE",
"assaillait" => "asajE",
"assaillant" => "asaj@",
"assaillante" => "asaj@t",
"assaillants" => "asaj@",
"assaille" => "asaj",
"assaillent" => "asaj",
"assailles" => "asaj",
"assailli" => "asaji",
"assaillie" => "asaji",
"assaillies" => "asaji",
"assaillir" => "asajiR",
"assaillira" => "asajiRa",
"assaillirent" => "asajiR",
"assaillis" => "asaji",
"assaillit" => "asaji",
"assaillons" => "asaj§",
"assaini" => "asEni",
"assainie" => "asEni",
"assainir" => "aseniR",
"assainirait" => "asEniRE",
"assainis" => "asEni",
"assainissement" => "asenis°m@",
"assaisonna" => "asEzona",
"assaisonnait" => "asEzonE",
"assaisonne" => "asEzOn",
"assaisonné" => "asEzone",
"assaisonnée" => "asEzone",
"assaisonnées" => "asEzone",
"assaisonnement" => "asEzOn°m@",
"assaisonnements" => "asEzOn°m@",
"assaisonner" => "asEzone",
"assaisonnerait" => "asEzOn°RE",
"assaisonnèrent" => "asEzonER",
"assaisonnés" => "asEzone",
"assassin" => "asas5",
"assassina" => "asasina",
"assassinai" => "asasinE",
"assassinaient" => "asasinE",
"assassinais" => "asasinE",
"assassinait" => "asasinE",
"assassinant" => "asasin@",
"assassinat" => "asasina",
"assassinats" => "asasina",
"assassine" => "asasin",
"assassiné" => "asasine",
"assassinée" => "asasine",
"assassinées" => "asasine",
"assassinent" => "asasin",
"assassiner" => "asasine",
"assassinera" => "asasin°Ra",
"assassinerai" => "asasin°RE",
"assassinerais" => "asasin°RE",
"assassinerez" => "asasin°Re",
"assassines" => "asasin",
"assassinés" => "asasine",
"assassinez" => "asasine",
"assassinons" => "asasin§",
"assassins" => "asas5",
"assaut" => "aso",
"assauts" => "aso",
"assavoir" => "asavwaR",
"asse" => "as",
"asseau" => "aso",
"assécha" => "aseSa",
"asséchaient" => "aseSE",
"asséchais" => "aseSE",
"asséchait" => "aseSE",
"asséchant" => "aseS@",
"assèche" => "asES",
"asséché" => "aseSe",
"asséchée" => "aseSe",
"asséchées" => "aseSe",
"assèchement" => "asES°m@",
"assèchent" => "asES",
"assécher" => "aseSe",
"assécherait" => "aseS°RE",
"asséchés" => "aseSe",
"asséchez" => "aseSe",
"asséchons" => "aseS§",
"assembla" => "as@bla",
"assemblage" => "as@blaZ",
"assemblages" => "as@blaZ",
"assemblaient" => "as@blE",
"assemblait" => "as@blE",
"assemblant" => "as@bl@",
"assemble" => "as@bl",
"assemblé" => "as@ble",
"assemblée" => "as@ble",
"assemblées" => "as@ble",
"assemblent" => "as@bl",
"assembler" => "as@ble",
"assemblera" => "as@bl°Ra",
"assemblerez" => "as@bl°Re",
"assemblés" => "as@ble",
"assembleur" => "as@bl9R",
"assembleurs" => "as@bl9R",
"assemblez" => "as@ble",
"assemblons" => "as@bl§",
"assena" => "asena",
"asséna" => "asena",
"assenai" => "asenE",
"assenaient" => "asenE",
"assenais" => "asenE",
"assenait" => "asenE",
"assénait" => "asenE",
"assenant" => "asen@",
"assène" => "asEn",
"assené" => "asene",
"asséné" => "asene",
"assenée" => "asene",
"assenées" => "asene",
"assénées" => "asene",
"assènent" => "asEn",
"assener" => "asene",
"asséner" => "asene",
"assènerai" => "asEn°RE",
"assenés" => "asene",
"assentiment" => "as@tim@",
"assentiments" => "as@tim@",
"asseoir" => "aswaR",
"assermenté" => "asERm@te",
"assermentée" => "asERm@te",
"assermenter" => "asERm@te",
"assermentés" => "asERm@te",
"assermentez" => "asERm@te",
"assertion" => "asERsj§",
"assertions" => "asERsj§",
"asservi" => "asERvi",
"asservie" => "asERvi",
"asservies" => "asERvi",
"asservir" => "asERviR",
"asservirai" => "asERviRE",
"asservirait" => "asERviRE",
"asserviront" => "asERviR§",
"asservis" => "asERvi",
"asservissaient" => "asERvisE",
"asservissait" => "asERvisE",
"asservissant" => "asERvis@",
"asservissement" => "asERvis°m@",
"asservissements" => "asERvis°m@",
"asservissent" => "asERvis",
"asservit" => "asERvi",
"assesseur" => "ases9R",
"assesseurs" => "ases9R",
"asseyaient" => "asEjE",
"asseyais" => "asEjE",
"asseyait" => "asEjE",
"asseyant" => "asEj@",
"asseye" => "asEj",
"asseyent" => "asEj",
"asseyes" => "asEj",
"asseyez" => "asEje",
"asseyiez" => "asEje",
"asseyions" => "asEjj§",
"asseyons" => "asEj§",
"assez" => "ase",
"assidu" => "asidy",
"assidue" => "asidy",
"assidues" => "asidy",
"assiduité" => "asid8ite",
"assiduités" => "asid8ite",
"assidûment" => "asidym@",
"assidus" => "asidy",
"assied" => "asje",
"assieds" => "asje",
"assiège" => "asjEZ",
"assiégé" => "asjeZe",
"assiégea" => "asjeZa",
"assiégeaient" => "asjeZE",
"assiégeait" => "asjeZE",
"assiégeant" => "asjeZ@",
"assiégeantes" => "asjeZ@t",
"assiégeants" => "asjeZ@",
"assiégée" => "asjeZe",
"assiégées" => "asjeZe",
"assiègent" => "asjEZ",
"assiéger" => "asjeZe",
"assiégera" => "asjeZ°Ra",
"assiégeraient" => "asjeZ°RE",
"assiégés" => "asjeZe",
"assiéra" => "asjeRa",
"assiérai" => "asjeRE",
"assiérais" => "asjeRE",
"assiérait" => "asjeRE",
"assiéras" => "asjeRa",
"assiérions" => "asjeRj§",
"assiéront" => "asjeR§",
"assiette" => "asjEt",
"assiettée" => "asjete",
"assiettées" => "asjete",
"assiettes" => "asjEt",
"assigna" => "asiNa",
"assignai" => "asiNE",
"assignais" => "asiNE",
"assignait" => "asiNE",
"assignant" => "asiN@",
"assignation" => "asiNasj§",
"assignations" => "asiNasj§",
"assignats" => "asiNa",
"assigne" => "asiN",
"assigné" => "asiNe",
"assignée" => "asiNe",
"assignées" => "asiNe",
"assignement" => "asiN°m@",
"assignent" => "asiN",
"assigner" => "asiNe",
"assignera" => "asiN°Ra",
"assignerai" => "asiN°RE",
"assignerait" => "asiN°RE",
"assignerons" => "asiN°R§",
"assigneront" => "asiN°R§",
"assignes" => "asiN",
"assignés" => "asiNe",
"assîmes" => "asim",
"assimila" => "asimila",
"assimilable" => "asimilabl",
"assimilables" => "asimilabl",
"assimilaient" => "asimilE",
"assimilais" => "asimilE",
"assimilait" => "asimilE",
"assimilant" => "asimil@",
"assimilateurs" => "asimilat9R",
"assimilation" => "asimilasj§",
"assimilations" => "asimilasj§",
"assimile" => "asimil",
"assimilé" => "asimile",
"assimilée" => "asimile",
"assimilées" => "asimile",
"assimilent" => "asimil",
"assimiler" => "asimile",
"assimilerait" => "asimil°RE",
"assimilèrent" => "asimilER",
"assimilés" => "asimile",
"assimilez" => "asimile",
"assirent" => "asiR",
"assis" => "asi",
"assise" => "asiz",
"assises" => "asiz",
"assista" => "asista",
"assistai" => "asistE",
"assistaient" => "asistE",
"assistais" => "asistE",
"assistait" => "asistE",
"assistâmes" => "asistam",
"assistanat" => "asistana",
"assistance" => "asist@s",
"assistances" => "asist@s",
"assistant" => "asist@",
"assistante" => "asist@t",
"assistantes" => "asist@t",
"assistants" => "asist@",
"assistas" => "asista",
"assistât" => "asista",
"assiste" => "asist",
"assisté" => "asiste",
"assistée" => "asiste",
"assistées" => "asiste",
"assistent" => "asist",
"assister" => "asiste",
"assistera" => "asist°Ra",
"assisterai" => "asist°RE",
"assisteraient" => "asist°RE",
"assisterais" => "asist°RE",
"assisterait" => "asist°RE",
"assisteras" => "asist°Ra",
"assistèrent" => "asistER",
"assisterez" => "asist°Re",
"assisteriez" => "asist°Rje",
"assisterons" => "asist°R§",
"assisteront" => "asist°R§",
"assistés" => "asiste",
"assistez" => "asiste",
"assistiez" => "asistje",
"assistions" => "asistj§",
"assistons" => "asist§",
"assit" => "asi",
"assît" => "asi",
"associa" => "asosja",
"associai" => "asosjE",
"associaient" => "asosjE",
"associais" => "asosjE",
"associait" => "asosjE",
"associant" => "asosj@",
"associassent" => "asosjas",
"associât" => "asosja",
"associatifs" => "asosjatif",
"association" => "asosjasj§",
"associations" => "asosjasj§",
"associative" => "asosjativ",
"associe" => "asosi",
"associé" => "asosje",
"associée" => "asosje",
"associées" => "asosje",
"associent" => "asosi",
"associer" => "asosje",
"associera" => "asosiRa",
"associerai" => "asosiRE",
"associeraient" => "asosiRE",
"associerais" => "asosiRE",
"associerait" => "asosiRE",
"associèrent" => "asosjER",
"associeront" => "asosiR§",
"associés" => "asosje",
"associez" => "asosje",
"associions" => "asosij§",
"associons" => "asosj§",
"assoie" => "aswa",
"assoient" => "aswa",
"assoies" => "aswa",
"assoiffé" => "aswafe",
"assoiffée" => "aswafe",
"assoiffées" => "aswafe",
"assoiffent" => "aswaf",
"assoiffer" => "aswafe",
"assoiffés" => "aswafe",
"assoiffez" => "aswafe",
"assoira" => "aswaRa",
"assoirai" => "aswaRE",
"assoiraient" => "aswaRE",
"assoirais" => "aswaRE",
"assoirait" => "aswaRE",
"assoiras" => "aswaRa",
"assoiront" => "aswaR§",
"assois" => "aswa",
"assoit" => "aswa",
"assombri" => "as§bRi",
"assombrie" => "as§bRi",
"assombries" => "as§bRi",
"assombrir" => "as§bRiR",
"assombrira" => "as§bRiRa",
"assombrirent" => "as§bRiR",
"assombris" => "as§bRi",
"assombrissaient" => "as§bRisE",
"assombrissait" => "as§bRisE",
"assombrissant" => "as§bRis@",
"assombrissement" => "as§bRis°m@",
"assombrissent" => "as§bRis",
"assombrit" => "as§bRi",
"assombrît" => "as§bRi",
"assomma" => "asoma",
"assommaient" => "asomE",
"assommait" => "asomE",
"assommant" => "asom@",
"assommante" => "asom@t",
"assommantes" => "asom@t",
"assommants" => "asom@",
"assommât" => "asoma",
"assomme" => "asOm",
"assommé" => "asome",
"assommée" => "asome",
"assommées" => "asome",
"assomment" => "asOm",
"assommer" => "asome",
"assommera" => "asOm°Ra",
"assommerai" => "asOm°RE",
"assommeraient" => "asOm°RE",
"assommerais" => "asOm°RE",
"assommerait" => "asOm°RE",
"assommeras" => "asOm°Ra",
"assommes" => "asOm",
"assommés" => "asome",
"assommeur" => "asom9R",
"assommez" => "asome",
"assommiez" => "asomje",
"assommoir" => "asomwaR",
"assommoirs" => "asomwaR",
"assommons" => "asom§",
"assomption" => "as§psj§",
"assomptions" => "as§psj§",
"assonance" => "ason@s",
"assonances" => "ason@s",
"assonants" => "ason@",
"assorti" => "asORti",
"assortie" => "asORti",
"assorties" => "asORti",
"assortiment" => "asORtim@",
"assortiments" => "asORtim@",
"assortir" => "asORtiR",
"assortirai" => "asORtiRE",
"assortirais" => "asORtiRE",
"assortis" => "asORti",
"assortissaient" => "asORtisE",
"assortissais" => "asORtisE",
"assortissait" => "asORtisE",
"assortissant" => "asORtis@",
"assortissent" => "asORtis",
"assortit" => "asORti",
"assoté" => "asote",
"assotés" => "asote",
"assoupi" => "asupi",
"assoupie" => "asupi",
"assoupies" => "asupi",
"assoupir" => "asupiR",
"assoupira" => "asupiRa",
"assoupirais" => "asupiRE",
"assoupis" => "asupi",
"assoupissaient" => "asupisE",
"assoupissais" => "asupisE",
"assoupissait" => "asupisE",
"assoupissant" => "asupis@",
"assoupisse" => "asupis",
"assoupissement" => "asupis°m@",
"assoupissent" => "asupis",
"assoupit" => "asupi",
"assoupli" => "asupli",
"assouplie" => "asupli",
"assouplies" => "asupli",
"assouplir" => "asupliR",
"assouplira" => "asupliRa",
"assouplis" => "asupli",
"assouplissaient" => "asuplisE",
"assouplissait" => "asuplisE",
"assouplissant" => "asuplis@",
"assouplissement" => "asuplis°m@",
"assouplissements" => "asuplis°m@",
"assouplissent" => "asuplis",
"assouplit" => "asupli",
"assourdi" => "asuRdi",
"assourdie" => "asuRdi",
"assourdies" => "asuRdi",
"assourdir" => "asuRdiR",
"assourdiraient" => "asuRdiRE",
"assourdiras" => "asuRdiRa",
"assourdirent" => "asuRdiR",
"assourdis" => "asuRdi",
"assourdissaient" => "asuRdisE",
"assourdissait" => "asuRdisE",
"assourdissant" => "asuRdis@",
"assourdissante" => "asuRdis@t",
"assourdissantes" => "asuRdis@t",
"assourdissants" => "asuRdis@",
"assourdissement" => "asuRdis°m@",
"assourdissent" => "asuRdis",
"assourdit" => "asuRdi",
"assouvi" => "asuvi",
"assouvie" => "asuvi",
"assouvies" => "asuvi",
"assouvir" => "asuviR",
"assouvira" => "asuviRa",
"assouvirai" => "asuviRE",
"assouvirait" => "asuviRE",
"assouviras" => "asuviRa",
"assouvirent" => "asuviR",
"assouvis" => "asuvi",
"assouvissaient" => "asuvisE",
"assouvissait" => "asuvisE",
"assouvissant" => "asuvis@",
"assouvisse" => "asuvis",
"assouvissement" => "asuvis°m@",
"assouvissent" => "asuvis",
"assouvit" => "asuvi",
"assoyait" => "aswajE",
"assoyez" => "aswaje",
"assoyons" => "aswaj§",
"assuétude" => "as8etyd",
"assujetti" => "asyZEti",
"assujettie" => "asyZEti",
"assujetties" => "asyZeti",
"assujettir" => "asyZetiR",
"assujettiraient" => "asyZEtiRE",
"assujettis" => "asyZEti",
"assujettissaient" => "asyZEtisE",
"assujettissait" => "asyZEtisE",
"assujettissant" => "asyZetis@",
"assujettisse" => "asyZEtis",
"assujettissement" => "asyZetis°m@",
"assujettissent" => "asyZEtis",
"assujettit" => "asyZEti",
"assuma" => "asyma",
"assumai" => "asymE",
"assumaient" => "asymE",
"assumais" => "asymE",
"assumait" => "asymE",
"assumant" => "asym@",
"assumât" => "asyma",
"assume" => "asym",
"assumé" => "asyme",
"assumée" => "asyme",
"assumées" => "asyme",
"assument" => "asym",
"assumer" => "asyme",
"assumera" => "asym°Ra",
"assumerai" => "asym°RE",
"assumeraient" => "asym°RE",
"assumerais" => "asym°RE",
"assumerait" => "asym°RE",
"assumeras" => "asym°Ra",
"assumèrent" => "asymER",
"assumerez" => "asym°Re",
"assumerions" => "asym°Rj§",
"assumerons" => "asym°R§",
"assumés" => "asyme",
"assumez" => "asyme",
"assumions" => "asymj§",
"assumons" => "asym§",
"assura" => "asyRa",
"assurable" => "asyRabl",
"assurage" => "asyRaZ",
"assurai" => "asyRE",
"assuraient" => "asyRE",
"assurais" => "asyRE",
"assurait" => "asyRE",
"assurance" => "asyR@s",
"assurance-accidents" => "asyR@saksid@",
"assurance-chômage" => "asyR@sSomaZ",
"assurance-maladie" => "asyR@smaladi",
"assurance-vie" => "asyR@svi",
"assurances" => "asyR@s",
"assurances-vie" => "asyR@svi",
"assurant" => "asyR@",
"assurassent" => "asyRas",
"assurât" => "asyRa",
"assure" => "asyR",
"assuré" => "asyRe",
"assurée" => "asyRe",
"assurées" => "asyRe",
"assurément" => "asyRem@",
"assurent" => "asyR",
"assurer" => "asyRe",
"assurera" => "asyR°Ra",
"assurerai" => "asyR°RE",
"assureraient" => "asyR°RE",
"assurerais" => "asyR°RE",
"assurerait" => "asyR°RE",
"assureras" => "asyR°Ra",
"assurèrent" => "asyRER",
"assurerez" => "asyR°Re",
"assurerons" => "asyR°R§",
"assureront" => "asyR°R§",
"assures" => "asyR",
"assurés" => "asyRe",
"assureur" => "asyR9R",
"assureur-conseil" => "asyR9Rk§sEj",
"assureurs" => "asyR9R",
"assurez" => "asyRe",
"assuriez" => "asyRje",
"assurions" => "asyRj§",
"assurons" => "asyR§",
"assyrien" => "asiRj5",
"assyrienne" => "asiRjEn",
"assyriennes" => "asiRjEn",
"assyriens" => "asiRj5",
"assyro" => "asiRo",
"astarté" => "astaRte",
"aste" => "ast",
"aster" => "astER",
"astérisme" => "asteRism",
"astérisque" => "asteRisk",
"astérisques" => "asteRisk",
"astéroïde" => "asteRoid",
"astéroïdes" => "asteRoid",
"asters" => "astER",
"asthénie" => "asteni",
"asthénies" => "asteni",
"asthmatique" => "asmatik",
"asthmatiques" => "asmatik",
"asthme" => "asm",
"asthmes" => "asm",
"asti" => "asti",
"astic" => "astik",
"asticot" => "astiko",
"asticota" => "astikota",
"asticotages" => "astikotaZ",
"asticotaient" => "astikotE",
"asticotais" => "astikotE",
"asticotait" => "astikotE",
"asticotant" => "astikot@",
"asticote" => "astikOt",
"asticoté" => "astikote",
"asticotent" => "astikOt",
"asticoter" => "astikote",
"asticotés" => "astikote",
"asticotez" => "astikote",
"asticots" => "astiko",
"astigmate" => "astigmat",
"astigmatisme" => "astigmatizm",
"astiqua" => "astika",
"astiquage" => "astikaZ",
"astiquaient" => "astikE",
"astiquais" => "astikE",
"astiquait" => "astikE",
"astiquant" => "astik@",
"astique" => "astik",
"astiqué" => "astike",
"astiquée" => "astike",
"astiquées" => "astike",
"astiquent" => "astik",
"astiquer" => "astike",
"astiquera" => "astik°Ra",
"astiquerai" => "astik°RE",
"astiquerons" => "astik°R§",
"astiqués" => "astike",
"astiqueur" => "astik9R",
"astiquez" => "astike",
"astragale" => "astRagal",
"astragales" => "astRagal",
"astrakan" => "astRak@",
"astral" => "astRal",
"astrale" => "astRal",
"astrales" => "astRal",
"astraux" => "astRo",
"astre" => "astR",
"astreignais" => "astRENE",
"astreignait" => "astRENE",
"astreignant" => "astREN@",
"astreignante" => "astREN@t",
"astreignantes" => "astREN@t",
"astreigne" => "astREN",
"astreignions" => "astREN§",
"astreignis" => "astRENi",
"astreignit" => "astRENi",
"astreindre" => "astR5dR",
"astreins" => "astR5",
"astreint" => "astR5",
"astreinte" => "astR5t",
"astreintes" => "astR5t",
"astreints" => "astR5",
"astres" => "astR",
"astringent" => "astR5Z@",
"astringente" => "astR5Z@t",
"astringentes" => "astR5Z@t",
"astro" => "astRo",
"astrochimie" => "astRoSimi",
"astrolabe" => "astRolab",
"astrolabes" => "astRolab",
"astrolâtres" => "astRolatR",
"astrologie" => "astRoloZi",
"astrologique" => "astRoloZik",
"astrologiquement" => "astROlOZik°m@",
"astrologiques" => "astRoloZik",
"astrologue" => "astRolOg",
"astrologues" => "astRolOg",
"astrométrie" => "astRometRi",
"astronaute" => "astRonot",
"astronautes" => "astRonot",
"astronautique" => "astRonotik",
"astronef" => "astRonEf",
"astronome" => "astRonOm",
"astronomes" => "astRonOm",
"astronomie" => "astRonomi",
"astronomique" => "astRonomik",
"astronomiquement" => "astROnOmik°m@",
"astronomiques" => "astRonomik",
"astrophore" => "astRofOR",
"astrophysicien" => "astRofizisj5",
"astrophysicienne" => "astRofizisjEn",
"astrophysiciens" => "astRofizisj5",
"astrophysique" => "astRofizik",
"astroport" => "astRopOR",
"astroscope" => "astRoskOp",
"astuce" => "astys",
"astuces" => "astys",
"astucieuse" => "astysj2z",
"astucieusement" => "astysj2z°m@",
"astucieuses" => "astysj2z",
"astucieux" => "astysj2",
"asturienne" => "astyRjEn",
"asymétrie" => "asimetRi",
"asymétrique" => "asimetRik",
"asymétriquement" => "asimetRik°m@",
"asymétriques" => "asimetRik",
"asymptomatique" => "as5ptomatik",
"asymptomatiques" => "as5ptomatik",
"asynchrone" => "as5kRon",
"asystolie" => "asistoli",
"atabeg" => "atab°g",
"atabegs" => "atab°g",
"ataman" => "atam@",
"atamans" => "atam@",
"ataraxie" => "ataRaksi",
"atavique" => "atavik",
"ataviques" => "atavik",
"atavisme" => "atavizm",
"atavismes" => "atavizm",
"ataxie" => "ataksi",
"atchoum" => "atSum",
"atèle" => "atEl",
"atélectasie" => "atelEktazi",
"atelier" => "at°lje",
"ateliers" => "at°lje",
"atellanes" => "atelan",
"atémi" => "atemi",
"atermoiement" => "atERmwam@",
"atermoiements" => "atERmwam@",
"atermoyé" => "atERmwaje",
"athanor" => "atanOR",
"athée" => "ate",
"athées" => "ate",
"athéisme" => "ateizm",
"athéiste" => "ateist",
"athénée" => "atene",
"athénien" => "atenj5",
"athénienne" => "atenjEn",
"athéniennes" => "atenjEn",
"athéniens" => "atenj5",
"athlète" => "atlEt",
"athlètes" => "atlEt",
"athlétique" => "atletik",
"athlétiques" => "atletik",
"athlétisme" => "atletizm",
"atlante" => "atl@t",
"atlantes" => "atl@t",
"atlantique" => "atl@tik",
"atlantiques" => "atl@tik",
"atlas" => "atlas",
"atmosphère" => "atmosfER",
"atmosphères" => "atmosfER",
"atmosphérique" => "atmosfeRik",
"atmosphériques" => "atmosfeRik",
"atoll" => "atOl",
"atolls" => "atOl",
"atome" => "atom",
"atomes" => "atom",
"atomique" => "atomik",
"atomiques" => "atomik",
"atomisait" => "atomizE",
"atomise" => "atomiz",
"atomisé" => "atomize",
"atomisée" => "atomize",
"atomisent" => "atomiz",
"atomiser" => "atomize",
"atomisés" => "atomize",
"atomiseur" => "atomiz9R",
"atomisez" => "atomize",
"atomiste" => "atomist",
"atomistes" => "atomist",
"atonal" => "atonal",
"atonale" => "atonal",
"atonales" => "atonal",
"atone" => "aton",
"atones" => "aton",
"atonie" => "atoni",
"atour" => "atuR",
"atourné" => "atuRne",
"atours" => "atuR",
"atout" => "atu",
"atouts" => "atu",
"atrabilaire" => "atRabilER",
"âtre" => "atR",
"âtres" => "atR",
"atrésie" => "atRezi",
"atrium" => "atRijOm",
"atroce" => "atROs",
"atrocement" => "atROs°m@",
"atroces" => "atROs",
"atrocité" => "atRosite",
"atrocités" => "atRosite",
"atrophiait" => "atRofjE",
"atrophie" => "atRofi",
"atrophié" => "atRofje",
"atrophiée" => "atRofje",
"atrophiées" => "atRofje",
"atrophient" => "atRofi",
"atrophier" => "atRofje",
"atrophieraient" => "atRofiRE",
"atrophies" => "atRofi",
"atrophiés" => "atRofje",
"atropine" => "atRopin",
"attabla" => "atabla",
"attablai" => "atablE",
"attablaient" => "atablE",
"attablais" => "atablE",
"attablait" => "atablE",
"attablant" => "atabl@",
"attable" => "atabl",
"attablé" => "atable",
"attablée" => "atable",
"attablées" => "atable",
"attablent" => "atabl",
"attabler" => "atable",
"attablèrent" => "atablER",
"attablés" => "atable",
"attablions" => "atablij§",
"attablons" => "atabl§",
"attacha" => "ataSa",
"attachai" => "ataSE",
"attachaient" => "ataSE",
"attachais" => "ataSE",
"attachait" => "ataSE",
"attachant" => "ataS@",
"attachante" => "ataS@t",
"attachants" => "ataS@",
"attachât" => "ataSa",
"attache" => "ataS",
"attaché" => "ataSe",
"attaché-case" => "ataSekaz",
"attachée" => "ataSe",
"attachées" => "ataSe",
"attachement" => "ataS°m@",
"attachements" => "ataS°m@",
"attachent" => "ataS",
"attacher" => "ataSe",
"attachera" => "ataS°Ra",
"attacherai" => "ataS°RE",
"attacherais" => "ataS°RE",
"attacherait" => "ataS°RE",
"attacheras" => "ataS°Ra",
"attachèrent" => "ataSER",
"attacherez" => "ataS°Re",
"attacherions" => "ataS°Rj§",
"attacheront" => "ataS°R§",
"attaches" => "ataS",
"attachés" => "ataSe",
"attachés-cases" => "ataSekaz",
"attachez" => "ataSe",
"attachiez" => "ataSje",
"attachions" => "ataSj§",
"attachons" => "ataS§",
"attaqua" => "ataka",
"attaquable" => "atakabl",
"attaquai" => "atakE",
"attaquaient" => "atakE",
"attaquais" => "atakE",
"attaquait" => "atakE",
"attaquâmes" => "atakam",
"attaquant" => "atak@",
"attaquante" => "atak@t",
"attaquants" => "atak@",
"attaquât" => "ataka",
"attaque" => "atak",
"attaqué" => "atake",
"attaquée" => "atake",
"attaquées" => "atake",
"attaquent" => "atak",
"attaquer" => "atake",
"attaquera" => "atak°Ra",
"attaquerai" => "atak°RE",
"attaqueraient" => "atak°RE",
"attaquerais" => "atak°RE",
"attaquerait" => "atak°RE",
"attaqueras" => "atak°Ra",
"attaquèrent" => "atakER",
"attaquerez" => "atak°Re",
"attaqueriez" => "atak°Rje",
"attaquerions" => "atak°Rj§",
"attaquerons" => "atak°R§",
"attaqueront" => "atak°R§",
"attaques" => "atak",
"attaqués" => "atake",
"attaqueur" => "atak9R",
"attaquez" => "atake",
"attaquiez" => "atakje",
"attaquons" => "atak§",
"attarda" => "ataRda",
"attardai" => "ataRdE",
"attardaient" => "ataRdE",
"attardais" => "ataRdE",
"attardait" => "ataRdE",
"attardâmes" => "ataRdam",
"attardant" => "ataRd@",
"attardât" => "ataRda",
"attarde" => "ataRd",
"attardé" => "ataRde",
"attardée" => "ataRde",
"attardées" => "ataRde",
"attardement" => "ataRd°m@",
"attardent" => "ataRd",
"attarder" => "ataRde",
"attardera" => "ataRd°Ra",
"attarderai" => "ataRd°RE",
"attarderaient" => "ataRd°RE",
"attarderait" => "ataRd°RE",
"attardèrent" => "ataRdER",
"attarderont" => "ataRd°R§",
"attardés" => "ataRde",
"attardez" => "ataRde",
"attardions" => "ataRdj§",
"attardons" => "ataRd§",
"atteignable" => "atENabl",
"atteignaient" => "atENE",
"atteignais" => "atENE",
"atteignait" => "atENE",
"atteignant" => "atEN@",
"atteigne" => "atEN",
"atteignent" => "atEN",
"atteignes" => "atEN",
"atteignez" => "atENe",
"atteignîmes" => "atENim",
"atteignions" => "atEN§",
"atteignirent" => "atENiR",
"atteignis" => "atENi",
"atteignissent" => "atENis",
"atteignit" => "atENi",
"atteignît" => "atENi",
"atteignons" => "atEN§",
"atteindra" => "at5dRa",
"atteindrai" => "at5dRE",
"atteindraient" => "at5dRE",
"atteindrais" => "at5dRE",
"atteindrait" => "at5dRE",
"atteindras" => "at5dRa",
"atteindre" => "at5dR",
"atteindrez" => "at5dRe",
"atteindrons" => "at5dR§",
"atteindront" => "at5dR§",
"atteins" => "at5",
"atteint" => "at5",
"atteinte" => "at5t",
"atteintes" => "at5t",
"atteints" => "at5",
"attela" => "at°la",
"attelage" => "at°laZ",
"attelages" => "at°laZ",
"attelai" => "at°lE",
"attelaient" => "at°lE",
"attelais" => "at°lE",
"attelait" => "at°lE",
"attelâmes" => "at°lam",
"attelant" => "at°l@",
"attelé" => "at°le",
"attelée" => "at°le",
"attelées" => "at°le",
"atteler" => "at°le",
"attelèrent" => "at°lER",
"attelés" => "at°le",
"attelez" => "at°le",
"attelions" => "at°lj§",
"attelle" => "atEl",
"attellent" => "atEl",
"attellera" => "atEl°Ra",
"attellerais" => "atEl°RE",
"attelles" => "atEl",
"attelons" => "at°l§",
"attenant" => "at°n@",
"attenante" => "at°n@t",
"attenantes" => "at°n@t",
"attend" => "at@",
"attendaient" => "at@dE",
"attendais" => "at@dE",
"attendait" => "at@dE",
"attendant" => "at@d@",
"attende" => "at@d",
"attendent" => "at@d",
"attendes" => "at@d",
"attendez" => "at@de",
"attendiez" => "at@dje",
"attendîmes" => "at@dim",
"attendions" => "at@dj§",
"attendirent" => "at@diR",
"attendis" => "at@di",
"attendisse" => "at@dis",
"attendissent" => "at@dis",
"attendit" => "at@di",
"attendît" => "at@di",
"attendons" => "at@d§",
"attendra" => "at@dRa",
"attendrai" => "at@dRE",
"attendraient" => "at@dRE",
"attendrais" => "at@dRE",
"attendrait" => "at@dRE",
"attendras" => "at@dRa",
"attendre" => "at@dR",
"attendrez" => "at@dRe",
"attendri" => "at@dRi",
"attendrie" => "at@dRi",
"attendries" => "at@dRi",
"attendriez" => "at@dRie",
"attendrions" => "at@dRij§",
"attendrir" => "at@dRiR",
"attendrirait" => "at@dRiRE",
"attendriras" => "at@dRiRa",
"attendrirent" => "at@dRiR",
"attendris" => "at@dRi",
"attendrissaient" => "at@dRisE",
"attendrissais" => "at@dRisE",
"attendrissait" => "at@dRisE",
"attendrissant" => "at@dRis@",
"attendrissante" => "at@dRis@t",
"attendrissantes" => "at@dRis@t",
"attendrissants" => "at@dRis@",
"attendrisse" => "at@dRis",
"attendrissement" => "at@dRis°m@",
"attendrissements" => "at@dRis°m@",
"attendrissent" => "at@dRis",
"attendrisseur" => "at@dRis9R",
"attendrissons" => "at@dRis§",
"attendrit" => "at@dRi",
"attendrons" => "at@dR§",
"attendront" => "at@dR§",
"attends" => "at@",
"attendu" => "at@dy",
"attendue" => "at@dy",
"attendues" => "at@dy",
"attendus" => "at@dy",
"attenta" => "at@ta",
"attentais" => "at@tE",
"attentait" => "at@tE",
"attentant" => "at@t@",
"attentat" => "at@ta",
"attentatoire" => "at@tatwaR",
"attentatoires" => "at@tatwaR",
"attentats" => "at@ta",
"attente" => "at@t",
"attenté" => "at@te",
"attenter" => "at@te",
"attenterai" => "at@t°RE",
"attenterait" => "at@t°RE",
"attentes" => "at@t",
"attentez" => "at@te",
"attentiez" => "at@tje",
"attentif" => "at@tif",
"attentifs" => "at@tif",
"attention" => "at@sj§",
"attentionné" => "at@sjone",
"attentionnée" => "at@sjone",
"attentionnées" => "at@sjone",
"attentionnés" => "at@sjone",
"attentions" => "at@sj§",
"attentisme" => "at@tizm",
"attentiste" => "at@tist",
"attentistes" => "at@tist",
"attentive" => "at@tiv",
"attentivement" => "at@tiv°m@",
"attentives" => "at@tiv",
"atténua" => "aten8a",
"atténuaient" => "aten8E",
"atténuait" => "aten8E",
"atténuant" => "aten8@",
"atténuante" => "aten8@t",
"atténuantes" => "aten8@t",
"atténuât" => "aten8a",
"atténuateur" => "aten8at9R",
"atténuation" => "aten8asj§",
"atténuations" => "aten8asj§",
"atténue" => "ateny",
"atténué" => "aten8e",
"atténuée" => "aten8e",
"atténuées" => "aten8e",
"atténuent" => "ateny",
"atténuer" => "aten8e",
"atténuera" => "atenyRa",
"atténueraient" => "atenyRE",
"atténuèrent" => "aten8ER",
"atténués" => "aten8e",
"atténuez" => "atenye",
"atténuons" => "ateny§",
"atterrages" => "atERaZ",
"atterraient" => "atERE",
"atterrait" => "atERE",
"atterrant" => "atER@",
"atterrante" => "atER@t",
"atterre" => "atER",
"atterré" => "ateRe",
"atterrée" => "ateRe",
"atterrées" => "ateRe",
"atterrèrent" => "atERER",
"atterrés" => "ateRe",
"atterri" => "atERi",
"atterrîmes" => "atERim",
"atterrir" => "ateRiR",
"atterrira" => "atERiRa",
"atterrirai" => "atERiRE",
"atterrirais" => "atERiRE",
"atterriras" => "atERiRa",
"atterrirent" => "atERiR",
"atterrirez" => "atERiRe",
"atterrirons" => "atERiR§",
"atterris" => "atERi",
"atterrissage" => "ateRisaZ",
"atterrissages" => "ateRisaZ",
"atterrissaient" => "atERisE",
"atterrissais" => "atERisE",
"atterrissait" => "atERisE",
"atterrissant" => "atERis@",
"atterrisse" => "atERis",
"atterrissent" => "atERis",
"atterrisses" => "atERis",
"atterrissez" => "atERise",
"atterrissons" => "atERis§",
"atterrit" => "atERi",
"atterrît" => "atERi",
"attesta" => "atEsta",
"attestaient" => "atEstE",
"attestait" => "atEstE",
"attestant" => "atEst@",
"attestation" => "atEstasj§",
"attestations" => "atEstasj§",
"atteste" => "atEst",
"attesté" => "atEste",
"attestée" => "atEste",
"attestées" => "atEste",
"attestent" => "atEst",
"attester" => "atEste",
"attestera" => "atEst°Ra",
"attestèrent" => "atEstER",
"attestons" => "atEst§",
"attiédi" => "atjedi",
"attiédie" => "atjedi",
"attiédis" => "atjedi",
"attiédissait" => "atjedisE",
"attifa" => "atifa",
"attifait" => "atifE",
"attifant" => "atif@",
"attife" => "atif",
"attifé" => "atife",
"attifée" => "atife",
"attifées" => "atife",
"attifer" => "atife",
"attifés" => "atife",
"attifiaux" => "atifjo",
"attige" => "atiZ",
"attigeait" => "atiZE",
"attigent" => "atiZ",
"attiges" => "atiZ",
"attigés" => "atiZe",
"attique" => "atik",
"attiques" => "atik",
"attira" => "atiRa",
"attirai" => "atiRE",
"attiraient" => "atiRE",
"attirail" => "atiRaj",
"attirais" => "atiRE",
"attirait" => "atiRE",
"attirance" => "atiR@s",
"attirances" => "atiR@s",
"attirant" => "atiR@",
"attirante" => "atiR@t",
"attirantes" => "atiR@t",
"attirants" => "atiR@",
"attirât" => "atiRa",
"attire" => "atiR",
"attiré" => "atiRe",
"attirée" => "atiRe",
"attirées" => "atiRe",
"attirent" => "atiR",
"attirer" => "atiRe",
"attirera" => "atiR°Ra",
"attirerai" => "atiR°RE",
"attireraient" => "atiR°RE",
"attirerais" => "atiR°RE",
"attirerait" => "atiR°RE",
"attirèrent" => "atiRER",
"attirerez" => "atiR°Re",
"attireriez" => "atiR°Rje",
"attirerons" => "atiR°R§",
"attireront" => "atiR°R§",
"attires" => "atiR",
"attirés" => "atiRe",
"attirez" => "atiRe",
"attiriez" => "atiRje",
"attirions" => "atiRj§",
"attirons" => "atiR§",
"attisa" => "atiza",
"attisaient" => "atizE",
"attisait" => "atizE",
"attisant" => "atiz@",
"attise" => "atiz",
"attisé" => "atize",
"attisée" => "atize",
"attisées" => "atize",
"attisement" => "atiz°m@",
"attisent" => "atiz",
"attiser" => "atize",
"attisera" => "atiz°Ra",
"attises" => "atiz",
"attisés" => "atize",
"attisez" => "atize",
"attisoir" => "atizwaR",
"attisons" => "atiz§",
"attitré" => "atitRe",
"attitrée" => "atitRe",
"attitrées" => "atitRe",
"attitrés" => "atitRe",
"attitude" => "atityd",
"attitudes" => "atityd",
"attorney" => "atORnE",
"attouchant" => "atuS@",
"attouchement" => "atuS°m@",
"attouchements" => "atuS°m@",
"attracteur" => "atRakt9R",
"attracteurs" => "atRakt9R",
"attractif" => "atRaktif",
"attractifs" => "atRaktif",
"attraction" => "atRaksj§",
"attraction-vedette" => "atRaksj§v°dEt",
"attractions" => "atRaksj§",
"attractive" => "atRaktiv",
"attrait" => "atRE",
"attraits" => "atRE",
"attrapa" => "atRapa",
"attrapage" => "atRapaZ",
"attrapai" => "atRapE",
"attrapaient" => "atRapE",
"attrapais" => "atRapE",
"attrapait" => "atRapE",
"attrapant" => "atRap@",
"attrape" => "atRap",
"attrapé" => "atRape",
"attrape-couillon" => "atRapkuj§",
"attrape-couillons" => "atRapkuj§",
"attrape-mouche" => "atRapmuS",
"attrape-mouches" => "atRapmuS",
"attrape-nigaud" => "atRapnigo",
"attrapée" => "atRape",
"attrapées" => "atRape",
"attrapent" => "atRap",
"attraper" => "atRape",
"attrapera" => "atRap°Ra",
"attraperai" => "atRap°RE",
"attraperaient" => "atRap°RE",
"attraperais" => "atRap°RE",
"attraperait" => "atRap°RE",
"attraperas" => "atRap°Ra",
"attrapèrent" => "atRapER",
"attraperez" => "atRap°Re",
"attraperiez" => "atRap°Rje",
"attraperons" => "atRap°R§",
"attraperont" => "atRap°R§",
"attrapes" => "atRap",
"attrapés" => "atRape",
"attrapeur" => "atRap9R",
"attrapez" => "atRape",
"attrapiez" => "atRapje",
"attrapions" => "atRapj§",
"attrapons" => "atRap§",
"attrayant" => "atREj@",
"attrayante" => "atREj@t",
"attrayantes" => "atREj@t",
"attrayants" => "atREj@",
"attribua" => "atRib8a",
"attribuable" => "atRib8abl",
"attribuai" => "atRib8E",
"attribuaient" => "atRib8E",
"attribuais" => "atRib8E",
"attribuait" => "atRib8E",
"attribuâmes" => "atRib8am",
"attribuant" => "atRib8@",
"attribuât" => "atRib8a",
"attribue" => "atRiby",
"attribué" => "atRib8e",
"attribuée" => "atRib8e",
"attribuées" => "atRib8e",
"attribuent" => "atRiby",
"attribuer" => "atRib8e",
"attribuera" => "atRibyRa",
"attribueraient" => "atRibyRE",
"attribuerais" => "atRibyRE",
"attribuerait" => "atRibyRE",
"attribuèrent" => "atRib8ER",
"attribueront" => "atRibyR§",
"attribues" => "atRiby",
"attribués" => "atRib8e",
"attribuez" => "atRibye",
"attribuions" => "atRibyj§",
"attribuons" => "atRib8§",
"attribut" => "atRiby",
"attribution" => "atRibysj§",
"attributions" => "atRibysj§",
"attributs" => "atRiby",
"attriquait" => "atRikE",
"attriquant" => "atRik@",
"attrique" => "atRik",
"attriqué" => "atRike",
"attriquée" => "atRike",
"attriquent" => "atRik",
"attriquer" => "atRike",
"attriquerait" => "atRik°RE",
"attrista" => "atRista",
"attristai" => "atRistE",
"attristaient" => "atRistE",
"attristais" => "atRistE",
"attristait" => "atRistE",
"attristant" => "atRist@",
"attristante" => "atRist@t",
"attristantes" => "atRist@t",
"attristât" => "atRista",
"attriste" => "atRist",
"attristé" => "atRiste",
"attristée" => "atRiste",
"attristent" => "atRist",
"attrister" => "at°Riste",
"attristerait" => "at°Rist°RE",
"attristèrent" => "atRistER",
"attristés" => "atRiste",
"attristez" => "atRiste",
"attrition" => "atRisj§",
"attritions" => "atRisj§",
"attroupa" => "atRupa",
"attroupaient" => "atRupE",
"attroupait" => "atRupE",
"attroupé" => "atRupe",
"attroupée" => "atRupe",
"attroupées" => "atRupe",
"attroupement" => "atRup°m@",
"attroupements" => "atRup°m@",
"attroupent" => "atRup",
"attrouper" => "atRupe",
"attrouperaient" => "atRup°RE",
"attroupèrent" => "atRupER",
"attroupés" => "atRupe",
"atypique" => "atipik",
"atypiques" => "atipik",
"au" => "o",
"au-dedans" => "od°d@",
"au-dehors" => "od2OR",
"au-delà" => "od°la",
"au-dessous" => "od°su",
"au-dessus" => "od°sy",
"au-devant" => "od°v@",
"aubade" => "obad",
"aubadent" => "obad",
"aubain" => "ob5",
"aubaine" => "obEn",
"aubaines" => "obEn",
"aube" => "ob",
"aubépine" => "obepin",
"aubépines" => "obepin",
"aubère" => "obER",
"aubères" => "obER",
"auberge" => "obERZ",
"auberges" => "obERZ",
"aubergine" => "obERZin",
"aubergines" => "obERZin",
"aubergiste" => "obERZist",
"aubergistes" => "obERZist",
"aubes" => "ob",
"aubette" => "obEt",
"aubier" => "obje",
"aubour" => "obuR",
"auburn" => "ob9Rn",
"aubusson" => "obys§",
"aucubas" => "okyba",
"aucun" => "ok1",
"aucune" => "okyn",
"aucunement" => "okyn°m@",
"aucunes" => "okyn",
"aucuns" => "ok1",
"audace" => "odas",
"audaces" => "odas",
"audacieuse" => "odasj2z",
"audacieusement" => "odasj2z°m@",
"audacieuses" => "odasj2z",
"audacieux" => "odasj2",
"audible" => "odibl",
"audibles" => "odibl",
"audience" => "odj@s",
"audiences" => "odj@s",
"audiencia" => "odj@sja",
"audienciers" => "odj@sje",
"audimat" => "odimat",
"audimats" => "odimat",
"audio" => "odjo",
"audio-visuel" => "odjoviz8El",
"audio-visuelle" => "odjoviz8El",
"audioconférence" => "odjok§feR@s",
"audiogramme" => "odjogRam",
"audiométrie" => "odjometRi",
"audiophile" => "odjofil",
"audiophone" => "odjofOn",
"audiovisuel" => "odjoviz8El",
"audiovisuelle" => "odjovizyEl",
"audiovisuelles" => "odjoviz8El",
"audit" => "odit",
"auditer" => "odite",
"auditeur" => "odit9R",
"auditeurs" => "odit9R",
"auditif" => "oditif",
"auditifs" => "oditif",
"audition" => "odisj§",
"auditionnais" => "odisjonE",
"auditionne" => "odisjOn",
"auditionné" => "odisjone",
"auditionnée" => "odisjone",
"auditionnent" => "odisjOn",
"auditionner" => "odisjone",
"auditionnera" => "odisjOn°Ra",
"auditionnerais" => "odisjOn°RE",
"auditionnes" => "odisjOn",
"auditionnez" => "odisjone",
"auditions" => "Odisj§",
"auditive" => "oditiv",
"auditives" => "oditiv",
"auditoire" => "oditwaR",
"auditoires" => "oditwaR",
"auditorium" => "oditoRjOm",
"auditoriums" => "oditoRjOm",
"auditrice" => "oditRis",
"auditrices" => "oditRis",
"audits" => "odit",
"auge" => "oZ",
"auges" => "oZ",
"augment" => "Ogm@",
"augmenta" => "ogm@ta",
"augmentaient" => "ogm@tE",
"augmentais" => "ogm@tE",
"augmentait" => "ogm@tE",
"augmentant" => "ogm@t@",
"augmentât" => "ogm@ta",
"augmentation" => "ogm@tasj§",
"augmentations" => "ogm@tasj§",
"augmente" => "ogm@t",
"augmenté" => "ogm@te",
"augmentée" => "ogm@te",
"augmentées" => "ogm@te",
"augmentent" => "ogm@t",
"augmenter" => "ogm@te",
"augmentera" => "ogm@t°Ra",
"augmenterai" => "ogm@t°RE",
"augmenteraient" => "ogm@t°RE",
"augmenterais" => "ogm@t°RE",
"augmenterait" => "ogm@t°RE",
"augmenteras" => "ogm@t°Ra",
"augmentèrent" => "ogm@tER",
"augmenterez" => "ogm@t°Re",
"augmenteront" => "ogm@t°R§",
"augmentés" => "ogm@te",
"augmentez" => "ogm@te",
"augmentions" => "ogm@tj§",
"augmentons" => "ogm@t§",
"augurai" => "ogyRE",
"augurais" => "ogyRE",
"augurait" => "ogyRE",
"augural" => "ogyRal",
"augurale" => "ogyRal",
"augurant" => "ogyR@",
"augure" => "ogyR",
"augurent" => "ogyR",
"augurer" => "ogyRe",
"augurerais" => "ogyR°RE",
"augures" => "ogyR",
"auguste" => "ogyst",
"augustes" => "ogyst",
"augustin" => "ogyst5",
"augustinien" => "ogystinj5",
"augustins" => "ogyst5",
"aujourd'hui" => "oZuRd8i",
"aula" => "ola",
"aulique" => "olik",
"aulnaie" => "OnE",
"aulne" => "on",
"aulnes" => "on",
"auloffée" => "olofe",
"aulos" => "olo",
"aulx" => "o",
"aumône" => "omon",
"aumônerie" => "omon°Ri",
"aumônes" => "omon",
"aumônier" => "omonje",
"aumônière" => "omonjER",
"aumônières" => "omonjER",
"aumôniers" => "omonje",
"aune" => "on",
"auner" => "one",
"aunes" => "on",
"auparavant" => "opaRav@",
"auprès" => "opRE",
"auquel" => "okEl",
"aura" => "oRa",
"aurai" => "oRE",
"auraient" => "oRE",
"aurais" => "oRE",
"aurait" => "oRE",
"auras" => "oRa",
"auréola" => "oReola",
"auréolaient" => "oReolE",
"auréolaire" => "oReolER",
"auréolait" => "oReolE",
"auréolant" => "oReol@",
"auréole" => "oReOl",
"auréolé" => "oReole",
"auréolée" => "oReole",
"auréolées" => "oReole",
"auréoler" => "oReole",
"auréoles" => "oReOl",
"auréolés" => "oReole",
"auréomycine" => "oReomisin",
"aureus" => "oReys",
"aurez" => "oRe",
"auriculaire" => "oRikylER",
"auriculaires" => "oRikylER",
"auricule" => "oRikyl",
"auriez" => "oRje",
"aurifère" => "oRifER",
"aurifères" => "oRifER",
"aurifiées" => "oRifje",
"aurige" => "oRiZ",
"aurions" => "oRj§",
"aurochs" => "oROk",
"aurone" => "oROn",
"aurons" => "oR§",
"auront" => "oR§",
"auroral" => "oRoRal",
"aurore" => "oROR",
"aurores" => "oROR",
"ausculta" => "oskylta",
"auscultais" => "oskyltE",
"auscultait" => "oskyltE",
"auscultant" => "oskylt@",
"auscultation" => "oskyltasj§",
"auscultations" => "oskyltasj§",
"ausculte" => "oskylt",
"ausculté" => "oskylte",
"auscultées" => "oskylte",
"auscultent" => "oskylt",
"ausculter" => "oskylte",
"auscultés" => "oskylte",
"auscultez" => "oskylte",
"auspices" => "ospis",
"aussi" => "osi",
"aussière" => "osjER",
"aussières" => "osjER",
"aussitôt" => "osito",
"austère" => "ostER",
"austèrement" => "ostER°m@",
"austères" => "ostER",
"austérité" => "osteRite",
"austérités" => "osteRite",
"austral" => "ostRal",
"australe" => "ostRal",
"australes" => "ostRal",
"australien" => "ostRalj5",
"australienne" => "ostRaljEn",
"australiennes" => "ostRaljEn",
"australiens" => "ostRalj5",
"australopithèque" => "ostRalopitEk",
"australopithèques" => "ostRalopitEk",
"austro" => "ostRo",
"austro-hongrois" => "ostRo§gRwa",
"austro-hongroises" => "ostRo§gRwaz",
"ausweis" => "oswE",
"autan" => "ot@",
"autant" => "ot@",
"autarcie" => "otaRsi",
"autarcique" => "otaRsik",
"autarciques" => "otaRsik",
"autel" => "otEl",
"autels" => "otEl",
"auteur" => "ot9R",
"auteure" => "ot9R",
"auteurs" => "ot9R",
"authenticité" => "ot@tisite",
"authentifiait" => "ot@tifjE",
"authentification" => "ot@tifikasj§",
"authentifie" => "ot@tifi",
"authentifié" => "ot@tifje",
"authentifiée" => "ot@tifje",
"authentifiées" => "ot@tifje",
"authentifient" => "ot@tifi",
"authentifier" => "ot@tifje",
"authentifierait" => "ot@tifiRE",
"authentifiés" => "ot@tifje",
"authentifiez" => "ot@tifje",
"authentiquant" => "ot@tik@",
"authentique" => "ot@tik",
"authentiquement" => "ot@tik°m@",
"authentiques" => "ot@tik",
"autisme" => "otizm",
"autiste" => "otist",
"autistes" => "otist",
"autistique" => "otistik",
"auto" => "oto",
"auto-adhésive" => "otoadeziv",
"auto-analyse" => "otoanaliz",
"auto-école" => "otoekOl",
"auto-érotisme" => "otoeRotizm",
"auto-immun" => "otoimm1",
"auto-immune" => "otoimmyn",
"auto-intoxication" => "oto5tOksikasj§",
"auto-pilote" => "otopilOt",
"auto-stop" => "otostOp",
"auto-stoppeur" => "otostop9R",
"auto-stoppeurs" => "otostop9R",
"auto-stoppeuse" => "otostop2z",
"auto-stoppeuses" => "otostop2z",
"auto-tamponneuse" => "otot@pon2z",
"auto-tamponneuses" => "otot@pon2z",
"autobiographe" => "otobjogRaf",
"autobiographie" => "otobjogRafi",
"autobiographies" => "otobjogRafi",
"autobiographique" => "otobjogRafik",
"autobiographiques" => "otobjogRafik",
"autobronzant" => "otobR§z@",
"autobus" => "otobys",
"autocar" => "otokaR",
"autocars" => "otokaR",
"autocensure" => "otos@syR",
"autocensurent" => "otos@syR",
"autocensurer" => "otos@syRe",
"autochenille" => "otoS°nij",
"autochtone" => "otoktOn",
"autochtones" => "otoktOn",
"autoclave" => "otoklav",
"autocollant" => "otokol@",
"autocollante" => "otokOl@t",
"autocollantes" => "otokol@t",
"autocollants" => "otokol@",
"autoconservation" => "otok§sERvasj§",
"autocrate" => "otOkRat",
"autocrates" => "otokRat",
"autocratie" => "otokRasi",
"autocratique" => "otokRatik",
"autocratiques" => "otokRatik",
"autocréation" => "otokReasj§",
"autocritique" => "otokRitik",
"autocritiquer" => "otok°Ritike",
"autocritiques" => "otokRitik",
"autocuiseur" => "otok8iz9R",
"autodafé" => "otodafe",
"autodafés" => "otodafe",
"autodéfense" => "otodef@s",
"autodénigrement" => "otodenigR°m@",
"autodérision" => "otodeRizj§",
"autodestructeur" => "otodEstRykt9R",
"autodestructeurs" => "otodEstRykt9R",
"autodestructible" => "otodEstRyktibl",
"autodestruction" => "otodEstRyksj§",
"autodestructrice" => "otodEstRyktRis",
"autodétermination" => "otodetERminasj§",
"autodétruira" => "otodetR8iRa",
"autodétruire" => "otodetR8iR",
"autodétruiront" => "otodetR8iR§",
"autodétruisant" => "otodetR8iz@",
"autodétruisent" => "otodetR8iz",
"autodétruit" => "otodetR8i",
"autodétruite" => "otodetR8it",
"autodidacte" => "otodidakt",
"autodidactes" => "otodidakt",
"autodidactique" => "otodidaktik",
"autodirecteur" => "otodiREkt9R",
"autodiscipline" => "otodisiplin",
"autodrome" => "OtOdRom",
"autoérotique" => "otoeROtik",
"autofinancement" => "otofin@s°m@",
"autofocus" => "otofokys",
"autogène" => "otoZEn",
"autogenèse" => "otoZ°nEz",
"autogérée" => "otoZeRe",
"autogérer" => "otoZeRe",
"autogestion" => "otoZEstj§",
"autogire" => "otoZiR",
"autogires" => "otoZiR",
"autographe" => "otogRaf",
"autographes" => "otogRaf",
"autographié" => "OtOgRafje",
"autographier" => "otogRafje",
"autoguidage" => "otogidaZ",
"autoguidé" => "otogide",
"autolimite" => "otolimit",
"autologues" => "otolOg",
"autolysat" => "otoliza",
"autolyse" => "otoliz",
"automate" => "otomat",
"automates" => "otomat",
"automatico" => "otomatiko",
"automation" => "otomasj§",
"automatique" => "otomatik",
"automatiquement" => "otomatik°m@",
"automatiques" => "otomatik",
"automatisation" => "otomatizasj§",
"automatisé" => "otomatize",
"automatisée" => "otomatize",
"automatisées" => "otomatize",
"automatisés" => "otomatize",
"automatisme" => "otomatizm",
"automatismes" => "otomatizm",
"automédication" => "otomedikasj§",
"automitrailleuse" => "otomitRaj2z",
"automitrailleuses" => "otomitRaj2z",
"automnal" => "otonal",
"automnale" => "otonal",
"automnales" => "otonal",
"automne" => "otOn",
"automnes" => "otOn",
"automobile" => "otomobil",
"automobile-club" => "otomobilkl9b",
"automobiles" => "otomobil",
"automobiliste" => "otomobilist",
"automobilistes" => "otomobilist",
"automoteur" => "otOmOt9R",
"automoteurs" => "otomot9R",
"automotrice" => "otomotRis",
"automutilation" => "otomytilasj§",
"automutiler" => "otomytile",
"autoneige" => "otonEZ",
"autoneiges" => "otonEZ",
"autonettoyant" => "otonEtwaj@",
"autonettoyante" => "otonetwaj@t",
"autonome" => "otonom",
"autonomes" => "otonom",
"autonomie" => "otonomi",
"autonomique" => "OtOnOmik",
"autonomistes" => "otonomist",
"autopilote" => "otopilOt",
"autoplastie" => "otoplasti",
"autoportée" => "otopORte",
"autoportrait" => "otopORtRE",
"autoportraits" => "otopORtRE",
"autoproclamé" => "otopRoklame",
"autoproclamée" => "otopRoklame",
"autoproduit" => "otopRod8i",
"autopropulsé" => "otOpROpylse",
"autopropulsée" => "otopRopylse",
"autopropulsés" => "otopRopylse",
"autopropulseur" => "otopROpyls9R",
"autopsia" => "otOpsja",
"autopsiais" => "otOpsijE",
"autopsie" => "otOpsi",
"autopsié" => "otOpsje",
"autopsier" => "otOpsje",
"autopsies" => "otOpsi",
"autopunition" => "otopynisj§",
"autoradio" => "otoRadjo",
"autoradios" => "otoRadjo",
"autorail" => "otoRaj",
"autorégulateur" => "otoRegylat9R",
"autorégulation" => "otoRegylasj§",
"autorégule" => "otoRegyl",
"autoreproduction" => "otoRpROdyksj§",
"autorisa" => "otoRiza",
"autorisai" => "otoRizE",
"autorisaient" => "otoRizE",
"autorisais" => "otoRizE",
"autorisait" => "otoRizE",
"autorisant" => "otoRiz@",
"autorisassent" => "otoRizas",
"autorisât" => "otoRiza",
"autorisation" => "otoRizasj§",
"autorisations" => "otoRizasj§",
"autorise" => "otoRiz",
"autorisé" => "otoRize",
"autorisée" => "otoRize",
"autorisées" => "otoRize",
"autorisent" => "otoRiz",
"autoriser" => "otoRize",
"autorisera" => "otoRiz°Ra",
"autoriserai" => "otoRiz°RE",
"autoriserais" => "otoRiz°RE",
"autoriserait" => "otoRiz°RE",
"autorisèrent" => "otoRizER",
"autoriserez" => "otoRiz°Re",
"autoriserons" => "otoRiz°R§",
"autoriseront" => "otoRiz°R§",
"autorises" => "otoRiz",
"autorisés" => "otoRize",
"autorisez" => "otoRize",
"autorisiez" => "otoRizje",
"autorisions" => "otoRizj§",
"autorisons" => "otoRiz§",
"autoritaire" => "otoRitER",
"autoritairement" => "OtORitER°m@",
"autoritaires" => "otoRitER",
"autoritarisme" => "otoRitaRizm",
"autorité" => "otoRite",
"autorités" => "otoRite",
"autoroute" => "otoRut",
"autoroutes" => "otoRut",
"autoroutière" => "otoRutjER",
"autoroutiers" => "otoRutje",
"autos" => "oto",
"autosatisfaction" => "otosatisfaksj§",
"autostop" => "otostOp",
"autostrade" => "otostRad",
"autostrades" => "otostRad",
"autosubsistance" => "otosybzist@s",
"autosuffisance" => "otosyfiz@s",
"autosuffisant" => "otosyfiz@",
"autosuffisants" => "otosyfiz@",
"autosuggestion" => "otosygZEstj§",
"autosuggestionna" => "otosygZEstjona",
"autosurveillance" => "otosyRvEj@s",
"autour" => "otuR",
"autours" => "otuR",
"autre" => "otR",
"autrefois" => "otR°fwa",
"autrement" => "otR°m@",
"autres" => "otR",
"autrichien" => "otRiSj5",
"autrichienne" => "otRiSjEn",
"autrichiennes" => "otRiSjEn",
"autrichiens" => "otRiSj5",
"autruche" => "otRyS",
"autruches" => "otRyS",
"autrui" => "otR8i",
"auvent" => "ov@",
"auvents" => "ov@",
"auvergnat" => "ovERNa",
"auvergnate" => "ovERNat",
"auvergnates" => "ovERNat",
"auvergnats" => "ovERNa",
"auvergne" => "ovERN",
"auverpin" => "ovERp5",
"auverpins" => "ovERp5",
"aux" => "o",
"aux aguets" => "ozagE",
"auxdits" => "odi",
"auxerrois" => "osERwa",
"auxiliaire" => "oksiljER",
"auxiliaires" => "oksiljER",
"auxquelles" => "okEl",
"auxquels" => "okEl",
"avachi" => "avaSi",
"avachie" => "avaSi",
"avachies" => "avaSi",
"avachir" => "avaSiR",
"avachirait" => "avaSiRE",
"avachirons" => "avaSiR§",
"avachis" => "avaSi",
"avachissait" => "avaSisE",
"avachissement" => "avaSis°m@",
"avachissent" => "avaSis",
"avachit" => "avaSi",
"avaient" => "avE",
"avais" => "avE",
"avait" => "avE",
"aval" => "aval",
"avala" => "avala",
"avalage" => "avalaZ",
"avalai" => "avalE",
"avalaient" => "avalE",
"avalais" => "avalE",
"avalait" => "avalE",
"avalâmes" => "avalam",
"avalanche" => "aval@S",
"avalanches" => "aval@S",
"avalant" => "aval@",
"avalât" => "avala",
"avale" => "aval",
"avalé" => "avale",
"avalée" => "avale",
"avalées" => "avale",
"avalement" => "aval°m@",
"avalent" => "aval",
"avaler" => "avale",
"avalera" => "aval°Ra",
"avalerai" => "aval°RE",
"avaleraient" => "aval°RE",
"avalerais" => "aval°RE",
"avalerait" => "aval°RE",
"avaleras" => "aval°Ra",
"avalèrent" => "avalER",
"avaleriez" => "aval°Rje",
"avaleront" => "aval°R§",
"avales" => "aval",
"avalés" => "avale",
"avaleur" => "aval9R",
"avaleurs" => "aval9R",
"avaleuse" => "aval2z",
"avalez" => "avale",
"avaliez" => "avalje",
"avaliser" => "avalize",
"avalisés" => "avalize",
"avaliseur" => "avaliz9R",
"avaloires" => "avalwaR",
"avalons" => "aval§",
"avança" => "av@sa",
"avançai" => "av@sE",
"avançaient" => "av@sE",
"avançais" => "av@sE",
"avançait" => "av@sE",
"avançâmes" => "av@sam",
"avançant" => "av@s@",
"avançât" => "av@sa",
"avance" => "av@s",
"avancé" => "av@se",
"avancée" => "av@se",
"avancées" => "av@se",
"avancement" => "av@s°m@",
"avancements" => "av@s°m@",
"avancent" => "av@s",
"avancer" => "av@se",
"avancera" => "av@s°Ra",
"avancerai" => "av@s°RE",
"avancerais" => "av@s°RE",
"avancerait" => "av@s°RE",
"avancèrent" => "av@sER",
"avancerez" => "av@s°Re",
"avancerons" => "av@s°R§",
"avanceront" => "av@s°R§",
"avances" => "av@s",
"avancés" => "av@se",
"avancez" => "av@se",
"avanciez" => "av@sje",
"avancions" => "av@sj§",
"avançons" => "av@s§",
"avanie" => "avani",
"avanies" => "avani",
"avant" => "av@",
"avant-avant-dernier" => "av@av@dERnje",
"avant-bec" => "av@bEk",
"avant-bras" => "av@bRa",
"avant-centre" => "av@s@tR",
"avant-clous" => "av@klu",
"avant-corps" => "av@kOR",
"avant-coureur" => "av@kuR9R",
"avant-coureurs" => "av@kuR9R",
"avant-courrière" => "av@kuRjER",
"avant-courrières" => "av@kuRjER",
"avant-cours" => "av@kuR",
"avant-dernier" => "av@dERnje",
"avant-dernière" => "av@dERnjER",
"avant-dîner" => "av@dine",
"avant-garde" => "av@gaRd",
"avant-gardes" => "av@gaRd",
"avant-gardiste" => "av@gaRdist",
"avant-gardistes" => "av@gaRdist",
"avant-gauche" => "av@goS",
"avant-goût" => "av@gu",
"avant-guerre" => "av@gER",
"avant-hier" => "av@tjER",
"avant-monts" => "av@m§",
"avant-papier" => "av@papje",
"avant-plan" => "av@pl@",
"avant-port" => "av@pOR",
"avant-poste" => "av@pOst",
"avant-postes" => "av@pOst",
"avant-première" => "av@pR°mjER",
"avant-premières" => "av@pR°mjER",
"avant-printemps" => "av@pR5t@",
"avant-projet" => "av@pRoZE",
"avant-propos" => "av@pRopo",
"avant-scène" => "av@sEn",
"avant-scènes" => "av@sEn",
"avant-toit" => "av@twa",
"avant-toits" => "av@twa",
"avant-train" => "av@tR5",
"avant-trains" => "av@tR5",
"avant-trou" => "av@tRu",
"avant-veille" => "av@vEj",
"avantage" => "av@taZ",
"avantagé" => "av@taZe",
"avantageaient" => "av@taZE",
"avantageais" => "av@taZE",
"avantageait" => "av@taZE",
"avantageant" => "av@taZ@",
"avantagée" => "av@taZe",
"avantagent" => "av@taZ",
"avantager" => "av@taZe",
"avantagera" => "av@taZ°Ra",
"avantages" => "av@taZ",
"avantagés" => "av@taZe",
"avantageuse" => "av@taZ2z",
"avantageusement" => "av@taZ2z°m@",
"avantageuses" => "av@taZ2z",
"avantageux" => "av@taZ2",
"avants" => "av@",
"avare" => "avaR",
"avarement" => "avaR°m@",
"avares" => "avaR",
"avarice" => "avaRis",
"avarices" => "avaRis",
"avaricieuse" => "avaRisj2z",
"avaricieusement" => "avaRisj2z°m@",
"avaricieux" => "avaRisj2",
"avarie" => "avaRi",
"avarié" => "avaRje",
"avariée" => "avaRje",
"avariées" => "avaRje",
"avarient" => "avaRi",
"avaries" => "avaRi",
"avariés" => "avaRje",
"avaro" => "avaRo",
"avaros" => "avaRo",
"avatar" => "avataR",
"avatars" => "avataR",
"ave" => "ave",
"avé" => "ave",
"avec" => "avEk",
"avelines" => "av°lin",
"avenant" => "av°n@",
"avenante" => "av°n@t",
"avenantes" => "av°n@t",
"avenants" => "av°n@",
"avènement" => "avEn°m@",
"avenir" => "av°niR",
"avenirs" => "av°niR",
"avent" => "av@",
"aventura" => "av@tyRa",
"aventurai" => "av@tyRE",
"aventuraient" => "av@tyRE",
"aventurais" => "av@tyRE",
"aventurait" => "av@tyRE",
"aventurant" => "av@tyR@",
"aventurât" => "av@tyRa",
"aventure" => "av@tyR",
"aventuré" => "av@tyRe",
"aventurée" => "av@tyRe",
"aventurées" => "av@tyRe",
"aventurent" => "av@tyR",
"aventurer" => "av@tyRe",
"aventurerai" => "av@tyR°RE",
"aventurerais" => "av@tyR°RE",
"aventurerait" => "av@tyR°RE",
"aventurèrent" => "av@tyRER",
"aventures" => "av@tyR",
"aventurés" => "av@tyRe",
"aventureuse" => "av@tyR2z",
"aventureuses" => "av@tyR2z",
"aventureux" => "av@tyR2",
"aventurez" => "av@tyRe",
"aventurier" => "av@tyRje",
"aventurière" => "av@tyRjER",
"aventurières" => "av@tyRjER",
"aventuriers" => "av@tyRje",
"aventurines" => "av@tyRin",
"aventurions" => "av@tyRj§",
"aventurons" => "av@tyR§",
"avenu" => "av°ny",
"avenue" => "av°ny",
"avenues" => "av°ny",
"avenus" => "av°ny",
"avéra" => "aveRa",
"avérai" => "aveRE",
"avéraient" => "aveRE",
"avérait" => "aveRE",
"avérant" => "aveR@",
"avérât" => "aveRa",
"avère" => "avER",
"avéré" => "aveRe",
"avérée" => "aveRe",
"avérées" => "aveRe",
"avèrent" => "avER",
"avérer" => "aveRe",
"avérera" => "aveR°Ra",
"avéreraient" => "aveR°RE",
"avérerait" => "aveR°RE",
"avérèrent" => "aveRER",
"avérés" => "aveRe",
"avers" => "avER",
"averse" => "avERs",
"averses" => "avERs",
"aversion" => "avERsj§",
"aversions" => "avERsj§",
"averti" => "avERti",
"avertie" => "avERti",
"averties" => "avERti",
"avertir" => "avERtiR",
"avertira" => "avERtiRa",
"avertirai" => "avERtiRE",
"avertirait" => "avERtiRE",
"avertiras" => "avERtiRa",
"avertirent" => "avERtiR",
"avertirez" => "avERtiRe",
"avertis" => "avERti",
"avertissaient" => "avERtisE",
"avertissais" => "avERtisE",
"avertissait" => "avERtisE",
"avertissant" => "avERtis@",
"avertisse" => "avERtis",
"avertissement" => "avERtis°m@",
"avertissements" => "avERtis°m@",
"avertissent" => "avERtis",
"avertisseur" => "avERtis9R",
"avertisseurs" => "avERtis9R",
"avertisseuses" => "avERtis2z",
"avertissez" => "avERtise",
"avertissiez" => "avERtisje",
"avertissons" => "avERtis§",
"avertit" => "avERti",
"avertît" => "avERti",
"aveu" => "av2",
"aveugla" => "av9gla",
"aveuglaient" => "av9glE",
"aveuglais" => "av9glE",
"aveuglait" => "av9glE",
"aveuglant" => "av9gl@",
"aveuglante" => "av9gl@t",
"aveuglantes" => "av9gl@t",
"aveuglants" => "av9gl@",
"aveuglât" => "av9gla",
"aveugle" => "av9gl",
"aveuglé" => "av9gle",
"aveugle-né" => "av9gl°ne",
"aveugle-née" => "av9gl°ne",
"aveuglée" => "av9gle",
"aveuglées" => "av9gle",
"aveuglement" => "av9gl°m@",
"aveuglément" => "av9glem@",
"aveuglements" => "av9gl°m@",
"aveuglent" => "av9gl",
"aveugler" => "av9gle",
"aveuglera" => "av9gl°Ra",
"aveuglerait" => "av9gl°RE",
"aveuglèrent" => "av9glER",
"aveugles" => "av9gl",
"aveuglés" => "av9gle",
"aveuglez" => "av9gle",
"aveuglons" => "av9gl§",
"aveuli" => "av2li",
"aveulissante" => "av2lis@t",
"aveux" => "av2",
"avez" => "ave",
"aviaire" => "avjER",
"aviateur" => "avjat9R",
"aviateurs" => "avjat9R",
"aviation" => "avjasj§",
"aviations" => "avjasj§",
"aviatrice" => "avjatRis",
"aviatrices" => "avjatRis",
"avicole" => "avikOl",
"aviculture" => "avikyltyR",
"avide" => "avid",
"avidement" => "avid°m@",
"avides" => "avid",
"avidité" => "avidite",
"avidités" => "avidite",
"aviez" => "avje",
"avignonnais" => "aviNonE",
"avignonnaise" => "aviNonEz",
"avili" => "avili",
"avilie" => "avili",
"avilies" => "avili",
"avilir" => "aviliR",
"avilis" => "avili",
"avilissait" => "avilisE",
"avilissant" => "avilis@",
"avilissante" => "avilis@t",
"avilissantes" => "avilis@t",
"avilissants" => "avilis@",
"avilissement" => "avilis°m@",
"avilissent" => "avilis",
"avilit" => "avili",
"aviné" => "avine",
"avinée" => "avine",
"avinées" => "avine",
"avinés" => "avine",
"avion" => "avj§",
"avion-cargo" => "avj§kaRgo",
"avion-citerne" => "avj§sitERn",
"avion-école" => "avj§ekOl",
"avion-suicide" => "avj§s8isid",
"avionique" => "avjonik",
"avionnettes" => "avjonEt",
"avionneurs" => "avjon9R",
"avions" => "avj§",
"avions-cargos" => "avj§kaRgo",
"avions-espions" => "avj§Espj§",
"aviron" => "aviR§",
"avirons" => "aviR§",
"avis" => "avi",
"avisa" => "aviza",
"avisai" => "avizE",
"avisaient" => "avizE",
"avisais" => "avizE",
"avisait" => "avizE",
"avisant" => "aviz@",
"avisât" => "aviza",
"avise" => "aviz",
"avisé" => "avize",
"avisée" => "avize",
"avisées" => "avize",
"avisent" => "aviz",
"aviser" => "avize",
"avisera" => "aviz°Ra",
"aviserai" => "aviz°RE",
"aviseraient" => "aviz°RE",
"aviserais" => "aviz°RE",
"aviserait" => "aviz°RE",
"aviseras" => "aviz°Ra",
"avisèrent" => "avizER",
"aviserons" => "aviz°R§",
"aviseront" => "aviz°R§",
"avises" => "aviz",
"avisés" => "avize",
"avisez" => "avize",
"avisions" => "avizj§",
"aviso" => "avizo",
"avisos" => "avizo",
"avitailler" => "avitaje",
"avitaminose" => "avitaminoz",
"aviva" => "aviva",
"avivaient" => "avivE",
"avivait" => "avivE",
"avivant" => "aviv@",
"avivât" => "aviva",
"avive" => "aviv",
"avivé" => "avive",
"avivée" => "avive",
"avivées" => "avive",
"avivent" => "aviv",
"aviver" => "avive",
"avivèrent" => "avivER",
"avivés" => "avive",
"avivons" => "aviv§",
"avocaillon" => "avokaj§",
"avocasseries" => "avokas°Ri",
"avocat" => "avoka",
"avocat-conseil" => "avokak§sEj",
"avocate" => "avokat",
"avocates" => "avokat",
"avocatier" => "avokatje",
"avocats" => "avoka",
"avocette" => "avosEt",
"avoient" => "avwa",
"avoinaient" => "avwanE",
"avoine" => "avwan",
"avoiner" => "avwane",
"avoines" => "avwan",
"avoir" => "avwaR",
"avoirs" => "avwaR",
"avoisinaient" => "avwazinE",
"avoisinait" => "avwazinE",
"avoisinant" => "avwazin@",
"avoisinante" => "avwazin@t",
"avoisinantes" => "avwazin@t",
"avoisinants" => "avwazin@",
"avoisine" => "avwazin",
"avoisinent" => "avwazin",
"avoisiner" => "avwazine",
"avoisinerait" => "avwazin°RE",
"avons" => "av§",
"avorta" => "avORta",
"avortait" => "avORtE",
"avortant" => "avORt@",
"avorte" => "avORt",
"avorté" => "avORte",
"avortée" => "avORte",
"avortées" => "avORte",
"avortement" => "avORt°m@",
"avortements" => "avORt°m@",
"avortent" => "avORt",
"avorter" => "avORte",
"avorterai" => "avORt°RE",
"avorterait" => "avORt°RE",
"avorteriez" => "avORt°Rje",
"avortés" => "avORte",
"avorteur" => "avORt9R",
"avorteurs" => "avORt9R",
"avorteuse" => "avORt2z",
"avorteuses" => "avORt2z",
"avortez" => "avORte",
"avorton" => "avORt§",
"avortons" => "avORt§",
"avoua" => "avwa",
"avouable" => "avwabl",
"avouables" => "avwabl",
"avouai" => "avwE",
"avouaient" => "avwE",
"avouais" => "avwE",
"avouait" => "avwE",
"avouâmes" => "avwam",
"avouant" => "avw@",
"avouas" => "avwa",
"avouât" => "avwa",
"avoue" => "avu",
"avoué" => "avwe",
"avouée" => "avwe",
"avouées" => "avwe",
"avouent" => "avu",
"avouer" => "avwe",
"avouera" => "avuRa",
"avouerai" => "avuRE",
"avoueraient" => "avuRE",
"avouerais" => "avuRE",
"avouerait" => "avuRE",
"avoueras" => "avuRa",
"avouèrent" => "avwER",
"avouerez" => "avuRe",
"avoueriez" => "avuRje",
"avouerions" => "avuRj§",
"avoueront" => "avuR§",
"avoues" => "avu",
"avoués" => "avwe",
"avouez" => "avue",
"avouiez" => "avuje",
"avouions" => "avuj§",
"avouons" => "avw§",
"avoyer" => "avwaje",
"avril" => "avRil",
"avrillée" => "avRije",
"avulsion" => "avylsj§",
"avunculaire" => "av§kylER",
"avunculat" => "av§kyla",
"awacs" => "awak",
"axa" => "aksa",
"axe" => "aks",
"axé" => "akse",
"axée" => "akse",
"axées" => "akse",
"axel" => "aksEl",
"axels" => "aksEl",
"axent" => "aks",
"axer" => "akse",
"axes" => "aks",
"axés" => "akse",
"axial" => "aksjal",
"axiale" => "aksjal",
"axillaire" => "aksilER",
"axiomatisation" => "aksijomatizasj§",
"axiome" => "aksjom",
"axiomes" => "aksjom",
"axis" => "aksis",
"axolotl" => "aksolOtl",
"axolotls" => "aksolOtl",
"axonge" => "aks§Z",
"aya" => "aja",
"ayans" => "Ej@",
"ayant" => "Ej@",
"ayants droit" => "Ej@dRwa",
"ayatollah" => "ajatola",
"ayatollahs" => "ajatola",
"aye-aye" => "ajaj",
"ayez" => "Eje",
"ayons" => "Ej§",
"ayuntamiento" => "ajuntamjEnto",
"azalée" => "azale",
"azalées" => "azale",
"azerbaïdjanais" => "azERbaidZanE",
"azéri" => "azeRi",
"azéris" => "azeRi",
"azimut" => "azimyt",
"azimutal" => "azimytal",
"azimuté" => "azimyte",
"azimutée" => "azimyte",
"azimuts" => "azimyt",
"azoïque" => "azOik",
"azoospermie" => "azoospERmi",
"azote" => "azOt",
"azoture" => "azOtyR",
"aztèque" => "astEk",
"aztèques" => "astEk",
"azulejo" => "azulexo",
"azulejos" => "azulexOs",
"azur" => "azyR",
"azuré" => "azyRe",
"azurée" => "azyRe",
"azurées" => "azyRe",
"azurés" => "azyRe",
"azurs" => "azyR",
"azygos" => "azigOs",
"azyme" => "azim",
"b" => "be",
"baba" => "baba",
"baballe" => "babal",
"babas" => "baba",
"babasse" => "babas",
"babel" => "babEl",
"babélienne" => "babeljEn",
"babeurre" => "bab9R",
"babi" => "babi",
"babil" => "babil",
"babillage" => "babijaZ",
"babillages" => "babijaZ",
"babillaient" => "babijE",
"babillait" => "babijE",
"babillant" => "babij@",
"babillard" => "babijaR",
"babillarde" => "babijaRd",
"babille" => "babij",
"babillé" => "babije",
"babillent" => "babij",
"babiller" => "babije",
"babilles" => "babij",
"babils" => "babil",
"babine" => "babin",
"babines" => "babin",
"babiole" => "babjOl",
"babioles" => "babjOl",
"babiroussa" => "babiRusa",
"bâbord" => "babOR",
"babouche" => "babuS",
"babouches" => "babuS",
"babouchka" => "babuSka",
"babouchkas" => "babuSka",
"babouin" => "babw5",
"babouine" => "babwin",
"babouines" => "babwin",
"babouins" => "babw5",
"babouvistes" => "babuvist",
"baby" => "bejbi",
"baby-boom" => "babibum",
"baby-foot" => "babifut",
"baby-sitter" => "babisit9R",
"baby-sitters" => "babisit9R",
"baby-sitting" => "babisitiG",
"babylonien" => "babilonj5",
"babylonienne" => "babilonjEn",
"babyloniens" => "babilonj5",
"babys" => "babi",
"bac" => "bak",
"baccalauréat" => "bakaloRea",
"baccara" => "bakaRa",
"baccarat" => "bakaRa",
"bacchanal" => "bakanal",
"bacchanale" => "bakanal",
"bacchanales" => "bakanal",
"bacchante" => "bak@t",
"bacchantes" => "bak@t",
"bachaghas" => "baSaga",
"bâche" => "baS",
"bâché" => "baSe",
"bâchée" => "baSe",
"bâchées" => "baSe",
"bachelier" => "baS2lje",
"bachelière" => "baS2ljER",
"bacheliers" => "baS2lje",
"bâcher" => "baSe",
"bâches" => "baS",
"bâchés" => "baSe",
"bachi-bouzouk" => "baSibuzuk",
"bachique" => "baSik",
"bachiques" => "baSik",
"bachot" => "baSo",
"bachotage" => "baSotaZ",
"bachotaient" => "baSotE",
"bachotait" => "baSotE",
"bachotant" => "baSot@",
"bachoter" => "baSOte",
"bachots" => "baSo",
"bacillaires" => "basilER",
"bacille" => "basil",
"bacilles" => "basil",
"back" => "bak",
"back up" => "bak9p",
"backgammon" => "bakgamon",
"background" => "bakgRawnd",
"bâcla" => "bakla",
"bâclai" => "baklE",
"bâclaient" => "baklE",
"bâclais" => "baklE",
"bâclait" => "baklE",
"bâclant" => "bakl@",
"bâcle" => "bakl",
"bâclé" => "bakle",
"bâclée" => "bakle",
"bâclées" => "bakle",
"bâcler" => "bakle",
"bâclera" => "bakl°Ra",
"bâclerait" => "bakl°RE",
"bâcles" => "bakl",
"bâclés" => "bakle",
"bâcleurs" => "bakl9R",
"bâclez" => "bakle",
"bâclons" => "bakl§",
"bacon" => "bekon",
"bacs" => "bak",
"bactéricide" => "bakteRisid",
"bactéricides" => "bakteRisid",
"bactérie" => "bakteRi",
"bactériémie" => "bakteRjemi",
"bactérien" => "bakteRj5",
"bactérienne" => "bakteRjEn",
"bactériennes" => "bakteRjEn",
"bactéries" => "bakteRi",
"bactériologie" => "bakteRjoloZi",
"bactériologique" => "bakteRjoloZik",
"bactériologiques" => "bakteRjoloZik",
"bactériologiste" => "bakteRjOlOZist",
"bactériophage" => "bakteRjOfaZ",
"bada" => "bada",
"badabam" => "badabam",
"badaboum" => "badabum",
"badamier" => "badamje",
"badamiers" => "badamje",
"badant" => "bad@",
"badaud" => "bado",
"badauda" => "badoda",
"badaudaient" => "badodE",
"badaudant" => "badod@",
"badaude" => "badod",
"badauder" => "badode",
"badauderie" => "badod°Ri",
"badauderies" => "badod°Ri",
"badauds" => "bado",
"bader" => "bade",
"baderne" => "badERn",
"badernes" => "badERn",
"bades" => "bad",
"badge" => "badZ",
"badges" => "badZ",
"badgés" => "badZe",
"badigeon" => "badiZ§",
"badigeonna" => "badiZona",
"badigeonnage" => "badiZonaZ",
"badigeonnages" => "badiZonaZ",
"badigeonnaient" => "badiZonE",
"badigeonnait" => "badiZonE",
"badigeonnant" => "badiZon@",
"badigeonne" => "badiZOn",
"badigeonné" => "badiZone",
"badigeonnée" => "badiZone",
"badigeonnées" => "badiZone",
"badigeonner" => "badiZone",
"badigeonnerai" => "badiZOn°RE",
"badigeonnèrent" => "badiZonER",
"badigeonnerez" => "badiZOn°Re",
"badigeonnés" => "badiZone",
"badigeonneur" => "badiZon9R",
"badigeonnions" => "badiZonj§",
"badigeons" => "badiZ§",
"badigoinces" => "badigw5s",
"badin" => "bad5",
"badina" => "badina",
"badinage" => "badinaZ",
"badinages" => "badinaZ",
"badinaient" => "badinE",
"badinais" => "badinE",
"badinait" => "badinE",
"badine" => "badin",
"badiné" => "badine",
"badiner" => "badine",
"badines" => "badin",
"badinez" => "badine",
"badins" => "bad5",
"badminton" => "badmintOn",
"badois" => "badwa",
"badoise" => "badwaz",
"baffe" => "baf",
"baffer" => "bafe",
"baffes" => "baf",
"baffés" => "bafe",
"baffle" => "bafl",
"baffles" => "bafl",
"bafouais" => "bafwE",
"bafouait" => "bafwE",
"bafouant" => "bafw@",
"bafoue" => "bafu",
"bafoué" => "bafwe",
"bafouée" => "bafwe",
"bafouées" => "bafwe",
"bafouent" => "bafu",
"bafouer" => "bafwe",
"bafoues" => "bafu",
"bafoués" => "bafwe",
"bafouez" => "bafue",
"bafouilla" => "bafuja",
"bafouillage" => "bafujaZ",
"bafouillages" => "bafujaZ",
"bafouillai" => "bafujE",
"bafouillaient" => "bafujE",
"bafouillais" => "bafujE",
"bafouillait" => "bafujE",
"bafouillant" => "bafuj@",
"bafouillante" => "bafuj@t",
"bafouillantes" => "bafuj@t",
"bafouille" => "bafuj",
"bafouillé" => "bafuje",
"bafouillent" => "bafuj",
"bafouiller" => "bafuje",
"bafouillèrent" => "bafujER",
"bafouilles" => "bafuj",
"bafouilleur" => "bafuj9R",
"bafouillez" => "bafuje",
"bafouillis" => "bafuji",
"bâfra" => "bafRa",
"bâfraient" => "bafRE",
"bâfrais" => "bafRE",
"bâfrait" => "bafRE",
"bâfrant" => "bafR@",
"bâfre" => "bafR",
"bâfré" => "bafRe",
"bâfrements" => "bafR°m@",
"bâfrer" => "bafRe",
"bâfrèrent" => "bafRER",
"bâfres" => "bafR",
"bâfreur" => "bafR9R",
"bâfreurs" => "bafR9R",
"bâfrez" => "bafRe",
"bagage" => "bagaZ",
"bagagerie" => "bagaZ°Ri",
"bagages" => "bagaZ",
"bagagiste" => "bagaZist",
"bagagistes" => "bagaZist",
"bagarraient" => "bagaRE",
"bagarrais" => "bagaRE",
"bagarrait" => "bagaRE",
"bagarrant" => "bagaR@",
"bagarre" => "bagaR",
"bagarré" => "bagaRe",
"bagarrée" => "bagaRe",
"bagarrent" => "bagaR",
"bagarrer" => "bagaRe",
"bagarrerais" => "bagaR°RE",
"bagarrerait" => "bagaR°RE",
"bagarres" => "bagaR",
"bagarrés" => "bagaRe",
"bagarreur" => "bagaR9R",
"bagarreurs" => "bagaR9R",
"bagarreuse" => "bagaR2z",
"bagarreuses" => "bagaR2z",
"bagarrez" => "bagaRe",
"bagarrons" => "bagaR§",
"bagasse" => "bagas",
"bagatelle" => "bagatEl",
"bagatelles" => "bagatEl",
"bagnard" => "baNaR",
"bagnards" => "baNaR",
"bagne" => "baN",
"bagnes" => "baN",
"bagnole" => "baNOl",
"bagnoles" => "baNOl",
"bagote" => "bagOt",
"bagoter" => "bagote",
"bagottaient" => "bagotE",
"bagottais" => "bagotE",
"bagotte" => "bagOt",
"bagotter" => "bagote",
"bagou" => "bagu",
"bagoulait" => "bagulE",
"bagoule" => "bagul",
"bagouse" => "baguz",
"bagousées" => "baguze",
"bagout" => "bagu",
"bagouts" => "bagu",
"bagouze" => "baguz",
"bagouzes" => "baguz",
"baguage" => "bagaZ",
"bague" => "bag",
"bagué" => "bage",
"baguée" => "bage",
"baguées" => "bage",
"baguenaudaient" => "bag°nodE",
"baguenaudais" => "bag°nodE",
"baguenaudait" => "bag°nodE",
"baguenaudant" => "bag°nod@",
"baguenaude" => "bag°nod",
"baguenaudé" => "bag°node",
"baguenaudent" => "bag°nod",
"baguenauder" => "bag°node",
"baguenauderait" => "bag°nod°RE",
"baguer" => "bage",
"bagues" => "bag",
"bagués" => "bage",
"baguette" => "bagEt",
"baguettes" => "bagEt",
"bah" => "ba",
"baht" => "bat",
"bahts" => "bat",
"bahut" => "bay",
"bahute" => "bayt",
"bahutent" => "bayt",
"bahuts" => "bay",
"bai" => "bE",
"baie" => "bE",
"baies" => "bE",
"baigna" => "bENa",
"baignade" => "bENad",
"baignades" => "bENad",
"baignai" => "bENE",
"baignaient" => "bENE",
"baignais" => "bENE",
"baignait" => "bENE",
"baignant" => "bEN@",
"baigne" => "bEN",
"baigné" => "beNe",
"baignée" => "beNe",
"baignées" => "beNe",
"baignent" => "bEN",
"baigner" => "beNe",
"baignera" => "bEN°Ra",
"baigneraient" => "bEN°RE",
"baignerait" => "bEN°RE",
"baignèrent" => "bENER",
"baignerons" => "bEN°R§",
"baigneront" => "bEN°R§",
"baignes" => "bEN",
"baignés" => "beNe",
"baigneur" => "bEN9R",
"baigneurs" => "bEN9R",
"baigneuse" => "bEN2z",
"baigneuses" => "bEN2z",
"baignez" => "bENe",
"baignions" => "bEN§",
"baignoire" => "bENwaR",
"baignoires" => "bENwaR",
"baignons" => "bEN§",
"bail" => "baj",
"baile" => "bel",
"bailes" => "bel",
"bâilla" => "baja",
"bâillai" => "bajE",
"bâillaient" => "bajE",
"bâillais" => "bajE",
"baillait" => "bajE",
"bâillait" => "bajE",
"bâillâmes" => "bajam",
"baillant" => "baj@",
"bâillant" => "baj@",
"bâillante" => "baj@t",
"bâillantes" => "baj@t",
"baille" => "baj",
"bâille" => "baj",
"baillé" => "baje",
"bâillé" => "baje",
"bâillement" => "baj°m@",
"bâillements" => "baj°m@",
"bâillent" => "baj",
"bailler" => "baje",
"bâiller" => "baje",
"bâillera" => "baj°Ra",
"bâillèrent" => "bajER",
"bâillerez" => "baj°Re",
"bailles" => "baj",
"bâilles" => "baj",
"bailleur" => "baj9R",
"bailleurs" => "baj9R",
"baillez" => "baje",
"bâillez" => "baje",
"bailli" => "baji",
"bailliage" => "bajaZ",
"baillis" => "baji",
"baillive" => "bajiv",
"bâillon" => "baj§",
"bâillonna" => "bajona",
"bâillonnait" => "bajonE",
"bâillonnant" => "bajon@",
"bâillonne" => "bajOn",
"bâillonné" => "bajone",
"bâillonnée" => "bajone",
"bâillonnent" => "bajOn",
"bâillonner" => "bajone",
"bâillonnera" => "bajOn°Ra",
"bâillonnerait" => "bajOn°RE",
"bâillonnés" => "bajone",
"bâillonnez" => "bajone",
"bâillonnons" => "bajon§",
"bâillons" => "baj§",
"bain" => "b5",
"bain-marie" => "b5maRi",
"bains" => "b5",
"bains-marie" => "b5maRi",
"baïonnette" => "bajonEt",
"baïonnettes" => "bajonEt",
"bais" => "bE",
"baisa" => "bEza",
"baisable" => "bEzabl",
"baisables" => "bEzabl",
"baisade" => "b°zad",
"baisai" => "bEzE",
"baisaient" => "bEzE",
"baisais" => "bEzE",
"baisait" => "bEzE",
"baisant" => "bEz@",
"baise" => "bEz",
"baisé" => "beze",
"baise-en-ville" => "bEz@vil",
"baisée" => "beze",
"baisées" => "beze",
"baisemain" => "bEz°m5",
"baisemains" => "bEz°m5",
"baisement" => "bEz°m@",
"baisent" => "bEz",
"baiser" => "beze",
"baisera" => "bEz°Ra",
"baiserai" => "bEz°RE",
"baiseraient" => "bEz°RE",
"baiserais" => "bEz°RE",
"baiserait" => "bEz°RE",
"baiseras" => "bEz°Ra",
"baisèrent" => "bEzER",
"baiserez" => "bEz°Re",
"baiseriez" => "bEz°Rje",
"baiserons" => "bEz°R§",
"baiseront" => "bEz°R§",
"baisers" => "beze",
"baises" => "bEz",
"baisés" => "beze",
"baiseur" => "bEz9R",
"baiseurs" => "bEz9R",
"baiseuse" => "bEz2z",
"baisez" => "bEze",
"baisiez" => "bEzje",
"baisions" => "bEzj§",
"baisodrome" => "bEzodRom",
"baisons" => "bEz§",
"baisotant" => "bEzot@",
"baisouillé" => "bEzuje",
"baisouiller" => "bEzuje",
"baissa" => "bEsa",
"baissai" => "bEsE",
"baissaient" => "bEsE",
"baissais" => "bEsE",
"baissait" => "bEsE",
"baissâmes" => "bEsam",
"baissant" => "bEs@",
"baissât" => "bEsa",
"baisse" => "bEs",
"baissé" => "bese",
"baissée" => "bese",
"baissées" => "bese",
"baissement" => "bEs°m@",
"baissent" => "bEs",
"baisser" => "bese",
"baissera" => "bEs°Ra",
"baisserai" => "bEs°RE",
"baisseraient" => "bEs°RE",
"baisserais" => "bEs°RE",
"baisserait" => "bEs°RE",
"baisseras" => "bEs°Ra",
"baissèrent" => "bEsER",
"baisserez" => "bEs°Re",
"baisserons" => "bEs°R§",
"baisseront" => "bEs°R§",
"baisses" => "bEs",
"baissés" => "bese",
"baissez" => "bEse",
"baissier" => "besje",
"baissiez" => "bEsje",
"baissions" => "bEsj§",
"baissons" => "bEs§",
"bajoue" => "baZu",
"bajoues" => "baZu",
"bajoyers" => "baZwaje",
"bakchich" => "bakSiS",
"bakchichs" => "bakSiS",
"bakélite" => "bakelit",
"baklava" => "baklava",
"baklavas" => "baklava",
"bal" => "bal",
"balada" => "balada",
"baladai" => "baladE",
"baladaient" => "baladE",
"baladais" => "baladE",
"baladait" => "baladE",
"baladant" => "balad@",
"balade" => "balad",
"baladé" => "balade",
"baladée" => "balade",
"baladées" => "balade",
"baladent" => "balad",
"balader" => "balade",
"baladera" => "balad°Ra",
"baladerai" => "balad°RE",
"baladerais" => "balad°RE",
"baladerait" => "balad°RE",
"baladèrent" => "baladER",
"baladerez" => "balad°Re",
"balades" => "balad",
"baladés" => "balade",
"baladeur" => "balad9R",
"baladeurs" => "balad9R",
"baladeuse" => "balad2z",
"baladeuses" => "balad2z",
"baladez" => "balade",
"baladiez" => "baladje",
"baladin" => "balad5",
"baladins" => "balad5",
"balafon" => "balaf§",
"balafons" => "balaf§",
"balafra" => "balafRa",
"balafraient" => "balafRE",
"balafrait" => "balafRE",
"balafrât" => "balafRa",
"balafre" => "balafR",
"balafré" => "balafRe",
"balafrée" => "balafRe",
"balafrées" => "balafRe",
"balafrent" => "balafR",
"balafrer" => "balafRe",
"balafres" => "balafR",
"balafrés" => "balafRe",
"balafrons" => "balafR§",
"balai" => "balE",
"balai-brosse" => "balEbROs",
"balaie" => "balE",
"balaient" => "balE",
"balaiera" => "balERa",
"balaierai" => "balERE",
"balaieraient" => "balERE",
"balaierait" => "balERE",
"balaieras" => "balERa",
"balaierez" => "baleRe",
"balaies" => "balE",
"balais" => "balE",
"balais-brosses" => "balEbROs",
"balaise" => "balEz",
"balaises" => "balEz",
"balalaïka" => "balalaika",
"balalaïkas" => "balalaika",
"balan" => "bal@",
"balança" => "bal@sa",
"balançage" => "bal@saZ",
"balançages" => "bal@saZ",
"balançai" => "bal@sE",
"balançaient" => "bal@sE",
"balançais" => "bal@sE",
"balançait" => "bal@sE",
"balançant" => "bal@s@",
"balance" => "bal@s",
"balancé" => "bal@se",
"balancée" => "bal@se",
"balancées" => "bal@se",
"balancelle" => "bal@sEl",
"balancelles" => "bal@sEl",
"balancement" => "bal@s°m@",
"balancements" => "bal@s°m@",
"balancent" => "bal@s",
"balancer" => "bal@se",
"balancera" => "bal@s°Ra",
"balancerai" => "bal@s°RE",
"balanceraient" => "bal@s°RE",
"balancerais" => "bal@s°RE",
"balancerait" => "bal@s°RE",
"balanceras" => "bal@s°Ra",
"balancèrent" => "bal@sER",
"balancerez" => "bal@s°Re",
"balanceriez" => "bal@s°Rje",
"balanceront" => "bal@s°R§",
"balances" => "bal@s",
"balancés" => "bal@se",
"balancez" => "bal@se",
"balancier" => "bal@sje",
"balanciers" => "bal@sje",
"balanciez" => "bal@sje",
"balancines" => "bal@sin",
"balancions" => "bal@sj§",
"balançoire" => "bal@swaR",
"balançoires" => "bal@swaR",
"balançons" => "bal@s§",
"balandras" => "bal@dRa",
"balanes" => "balan",
"balanstiquant" => "bal@stik@",
"balanstique" => "bal@stik",
"balanstiquer" => "bal@stike",
"balatum" => "balatOm",
"balaya" => "balEja",
"balayage" => "balEjaZ",
"balayages" => "balEjaZ",
"balayai" => "balEjE",
"balayaient" => "balEjE",
"balayais" => "balEjE",
"balayait" => "balEjE",
"balayant" => "balEj@",
"balayât" => "balEja",
"balaye" => "balEj",
"balayé" => "baleje",
"balayée" => "baleje",
"balayées" => "baleje",
"balayent" => "balEj",
"balayer" => "baleje",
"balayera" => "balEj°Ra",
"balayerai" => "balEj°RE",
"balayeraient" => "balEj°RE",
"balayerait" => "balEj°RE",
"balayèrent" => "balEjER",
"balayerez" => "balEj°Re",
"balayerons" => "balEj°R§",
"balayeront" => "balEj°R§",
"balayés" => "baleje",
"balayette" => "balEjEt",
"balayettes" => "balEjEt",
"balayeur" => "balEj9R",
"balayeurs" => "balEj9R",
"balayeuse" => "balEj2z",
"balayeuses" => "balEj2z",
"balayez" => "balEje",
"balayons" => "balEj§",
"balayure" => "balEjyR",
"balayures" => "balEjyR",
"balboa" => "balboa",
"balbutia" => "balbysja",
"balbutiai" => "balbysjE",
"balbutiaient" => "balbysjE",
"balbutiais" => "balbysjE",
"balbutiait" => "balbysjE",
"balbutiant" => "balbysj@",
"balbutiante" => "balbysj@t",
"balbutiantes" => "balbysj@t",
"balbutie" => "balbysi",
"balbutié" => "balbysje",
"balbutiées" => "balbysje",
"balbutiement" => "balbysim@",
"balbutiements" => "balbysim@",
"balbutier" => "balbysje",
"balbutièrent" => "balbysjER",
"balbutiés" => "balbysje",
"balbutions" => "balbysj§",
"balbuzard" => "balbyzaR",
"balcon" => "balk§",
"balconnet" => "balkonE",
"balconnets" => "balkonE",
"balcons" => "balk§",
"baldaquin" => "baldak5",
"baldaquins" => "baldak5",
"bale" => "bal",
"baleine" => "balEn",
"baleiné" => "balene",
"baleineau" => "balEno",
"baleinée" => "balene",
"baleinées" => "balEne",
"baleines" => "balEn",
"baleinés" => "balEne",
"baleinier" => "balenje",
"baleinière" => "balenjER",
"baleinières" => "balenjER",
"baleiniers" => "balenje",
"bales" => "bal",
"balèze" => "balEz",
"balèzes" => "balEz",
"balinais" => "balinE",
"balinaise" => "balinEz",
"balisage" => "balizaZ",
"balisaient" => "balizE",
"balisait" => "balizE",
"balisant" => "baliz@",
"balise" => "baliz",
"balisé" => "balize",
"balisée" => "balize",
"balisées" => "balize",
"balisent" => "baliz",
"baliser" => "balize",
"baliseraient" => "baliz°RE",
"balises" => "baliz",
"balisés" => "balize",
"baliste" => "balist",
"balistes" => "balist",
"balistique" => "balistik",
"balistiquement" => "balistik°m@",
"balistiques" => "balistik",
"baliveau" => "balivo",
"baliveaux" => "balivo",
"baliverne" => "balivERn",
"balivernes" => "balivERn",
"balkanique" => "balkanik",
"balkaniques" => "balkanik",
"balkanisés" => "balkanize",
"ball-trap" => "baltRap",
"ballade" => "balad",
"ballades" => "balad",
"ballaient" => "balE",
"ballant" => "bal@",
"ballante" => "bal@t",
"ballantes" => "bal@t",
"ballants" => "bal@",
"ballast" => "balast",
"ballasts" => "balast",
"balle" => "bal",
"balle-peau" => "balpo",
"baller" => "bale",
"ballerine" => "bal°Rin",
"ballerines" => "bal°Rin",
"balles" => "bal",
"ballet" => "balE",
"ballets" => "balE",
"balloches" => "balOS",
"ballon" => "bal§",
"ballon-sonde" => "bal§s§d",
"ballonnaient" => "balonE",
"ballonnant" => "balon@",
"ballonnante" => "balon@t",
"ballonnants" => "balon@",
"ballonne" => "balOn",
"ballonné" => "balone",
"ballonnée" => "balone",
"ballonnées" => "balone",
"ballonnement" => "balOn°m@",
"ballonnements" => "balOn°m@",
"ballonnent" => "balOn",
"ballonner" => "balone",
"ballonnés" => "balone",
"ballonnets" => "balonE",
"ballons" => "bal§",
"ballot" => "balo",
"ballote" => "balOt",
"ballots" => "balo",
"ballottage" => "balOtaZ",
"ballottages" => "balotaZ",
"ballottaient" => "balotE",
"ballottait" => "balotE",
"ballottant" => "balot@",
"ballotte" => "balOt",
"ballotté" => "balote",
"ballottée" => "balote",
"ballottées" => "balote",
"ballottement" => "balot°m@",
"ballottent" => "balOt",
"ballotter" => "balote",
"ballottèrent" => "balotER",
"ballottés" => "balote",
"ballottine" => "balOtin",
"ballottines" => "balotin",
"balluche" => "balyS",
"balluches" => "balyS",
"balluchon" => "balyS§",
"balluchonnage" => "balySonaZ",
"balluchonné" => "balySone",
"balluchons" => "balyS§",
"balnéaire" => "balneER",
"balnéaires" => "balneER",
"balnéothérapie" => "balneoteRapi",
"balourd" => "baluR",
"balourde" => "baluRd",
"balourdise" => "baluRdiz",
"balourdises" => "baluRdiz",
"balourds" => "baluR",
"balpeau" => "balpo",
"bals" => "bal",
"balsa" => "balza",
"balsamier" => "balzamje",
"balsamiers" => "balzamje",
"balsamine" => "balzamin",
"balsamines" => "balzamin",
"balsamique" => "balzamik",
"balsamiques" => "balzamik",
"balte" => "balt",
"baltes" => "balt",
"balthazar" => "baltazaR",
"balthazars" => "baltazaR",
"baltique" => "baltik",
"baltiques" => "baltik",
"balto" => "balto",
"baluba" => "balyba",
"baluchon" => "balyS§",
"baluchonnage" => "balySonaZ",
"baluchonne" => "balySOn",
"baluchonné" => "balySone",
"baluchonnent" => "balySon",
"baluchonner" => "balySone",
"baluchonneur" => "balySon9R",
"baluchonneurs" => "balySon9R",
"baluchons" => "balyS§",
"balustrade" => "balystRad",
"balustrades" => "balystRad",
"balustre" => "balystR",
"balustres" => "balystR",
"balzacien" => "balzasj5",
"balzacienne" => "balzasjEn",
"balzaciennes" => "balzasjEn",
"balzaciens" => "balzasj5",
"balzanes" => "balzan",
"bambara" => "b@baRa",
"bambin" => "b@b5",
"bambine" => "b@bin",
"bambines" => "b@bin",
"bambinette" => "b@binEt",
"bambino" => "b@bino",
"bambinos" => "b@binOs",
"bambins" => "b@b5",
"bambochait" => "b@boSE",
"bamboche" => "b@bOS",
"bambocher" => "b@bOSe",
"bambocheurs" => "b@boS9R",
"bambou" => "b@bu",
"bamboula" => "b@bula",
"bambous" => "b@bu",
"ban" => "b@",
"banal" => "banal",
"banale" => "banal",
"banalement" => "banal°m@",
"banales" => "banal",
"banalisait" => "banalizE",
"banalisation" => "banalizasj§",
"banalise" => "banaliz",
"banalisé" => "banalize",
"banalisée" => "banalize",
"banalisées" => "banalize",
"banalisent" => "banaliz",
"banaliser" => "banalize",
"banalisés" => "banalize",
"banalité" => "banalite",
"banalités" => "banalite",
"banals" => "banal",
"banana" => "banana",
"bananas" => "banana",
"banane" => "banan",
"bananer" => "banane",
"bananeraie" => "banan°RE",
"bananes" => "banan",
"bananier" => "bananje",
"bananière" => "bananjER",
"bananiers" => "bananje",
"banaux" => "bano",
"banc" => "b@",
"banc-titre" => "b@titR",
"bancaire" => "b@kER",
"bancaires" => "b@kER",
"bancal" => "b@kal",
"bancale" => "b@kal",
"bancales" => "b@kal",
"bancals" => "b@kal",
"banche" => "b@S",
"banco" => "b@ko",
"bancos" => "b@ko",
"bancroche" => "b@kROS",
"bancroches" => "b@kROS",
"bancs" => "b@",
"banda" => "b@da",
"bandage" => "b@daZ",
"bandages" => "b@daZ",
"bandagiste" => "b@daZist",
"bandai" => "b@dE",
"bandaient" => "b@dE",
"bandais" => "b@dE",
"bandaison" => "b@dEz§",
"bandaisons" => "b@dEz§",
"bandait" => "b@dE",
"bandana" => "b@dana",
"bandanas" => "b@dana",
"bandant" => "b@d@",
"bandante" => "b@d@t",
"bandantes" => "b@d@t",
"bandants" => "b@d@",
"bandasse" => "b@das",
"bande" => "b@d",
"bandé" => "b@de",
"bande-annonce" => "b@dan§s",
"bande-son" => "b@ds§",
"bandeau" => "b@do",
"bandeaux" => "b@do",
"bandée" => "b@de",
"bandées" => "b@de",
"bandelette" => "b@d°lEt",
"bandelettes" => "b@d°lEt",
"bandent" => "b@d",
"bander" => "b@de",
"bandera" => "b@d°Ra",
"banderai" => "b@d°RE",
"banderaient" => "b@d°RE",
"banderait" => "b@d°RE",
"banderas" => "b@d°Ra",
"banderille" => "b@d°Rij",
"banderillero" => "b@d°RijeRo",
"banderilleros" => "b@d°RijeROs",
"banderilles" => "b@d°Rij",
"banderole" => "b@d°ROl",
"banderoles" => "b@d°ROl",
"bandes" => "b@d",
"bandés" => "b@de",
"bandes-annonces" => "b@dan§s",
"bandeur" => "b@d9R",
"bandeurs" => "b@d9R",
"bandez" => "b@de",
"bandiez" => "b@dje",
"bandit" => "b@di",
"banditisme" => "b@ditizm",
"bandits" => "b@di",
"bandoline" => "b@dolin",
"bandonéon" => "b@done§",
"bandothèque" => "b@dOtEk",
"bandoulière" => "b@duljER",
"bang" => "b@g",
"bangladais" => "b@gladE",
"bangs" => "b@g",
"banian" => "banj@",
"banians" => "banj@",
"banjo" => "b@dZo",
"banjos" => "b@dZo",
"bank-note" => "b@knOt",
"bank-notes" => "b@knOt",
"banlieue" => "b@lj2",
"banlieues" => "b@lj2",
"banlieusard" => "b@lj2zaR",
"banlieusarde" => "b@lj2zaRd",
"banlieusardes" => "b@lj2zaRd",
"banlieusards" => "b@lj2zaR",
"banne" => "ban",
"banner" => "bane",
"bannes" => "ban",
"banni" => "bani",
"bannie" => "bani",
"bannière" => "banjER",
"bannières" => "banjER",
"bannies" => "bani",
"bannir" => "baniR",
"bannirait" => "baniRE",
"bannirent" => "baniR",
"bannis" => "bani",
"bannissaient" => "banisE",
"bannissait" => "banisE",
"bannissant" => "banis@",
"bannisse" => "banis",
"bannissement" => "banis°m@",
"bannissements" => "banis°m@",
"bannissez" => "banise",
"bannissons" => "banis§",
"bannit" => "bani",
"banqua" => "b@ka",
"banque" => "b@k",
"banqué" => "b@ke",
"banquer" => "b@ke",
"banquerai" => "b@k°RE",
"banqueroute" => "b@k°Rut",
"banqueroutes" => "b@k°Rut",
"banqueroutier" => "b@k°Rutje",
"banqueroutiers" => "b@k°Rutje",
"banques" => "b@k",
"banquet" => "b@kE",
"banqueté" => "b@k°te",
"banquets" => "b@kE",
"banquette" => "b@kEt",
"banquettes" => "b@kEt",
"banquier" => "b@kje",
"banquière" => "b@kjER",
"banquières" => "b@kjER",
"banquiers" => "b@kje",
"banquise" => "b@kiz",
"banquises" => "b@kiz",
"banquistes" => "b@kist",
"bans" => "b@",
"bantou" => "b@tu",
"bantoue" => "b@tu",
"bantu" => "b@tu",
"banyan" => "banjan",
"banyuls" => "banjyl",
"baobab" => "baobab",
"baobabs" => "baobab",
"baou" => "bau",
"baptême" => "batEm",
"baptêmes" => "batEm",
"baptisa" => "batiza",
"baptisai" => "batizE",
"baptisaient" => "batizE",
"baptisais" => "batizE",
"baptisait" => "batizE",
"baptisant" => "batiz@",
"baptise" => "batiz",
"baptisé" => "batize",
"baptisée" => "batize",
"baptisées" => "batize",
"baptisent" => "batiz",
"baptiser" => "batize",
"baptisera" => "batiz°Ra",
"baptiserai" => "batiz°RE",
"baptiseraient" => "batiz°RE",
"baptiserait" => "batiz°RE",
"baptisèrent" => "batizER",
"baptiseront" => "batiz°R§",
"baptises" => "batiz",
"baptisés" => "batize",
"baptiseur" => "batiz9R",
"baptisez" => "batize",
"baptisions" => "batizj§",
"baptismal" => "batismal",
"baptismale" => "batismal",
"baptismales" => "batismal",
"baptismaux" => "batismo",
"baptisons" => "batiz§",
"baptiste" => "batist",
"baptistère" => "batistER",
"baptistes" => "batist",
"baquet" => "bakE",
"baquets" => "bakE",
"bar" => "baR",
"bar-hôtel" => "baRotEl",
"bar-mitsva" => "baRmisva",
"bar-restaurant" => "baRREstoR@",
"bar-tabac" => "baRtaba",
"baragouin" => "baRagw5",
"baragouinage" => "baRagwinaZ",
"baragouinaient" => "baRagwinE",
"baragouinait" => "baRagwinE",
"baragouinant" => "baRagwin@",
"baragouine" => "baRagwin",
"baragouiné" => "baRagwine",
"baragouinent" => "baRagwin",
"baragouiner" => "baRagwine",
"baragouines" => "baRagwin",
"baragouineur" => "baRagwin9R",
"baragouinez" => "baRagwine",
"baragouins" => "baRagw5",
"baraka" => "baRaka",
"baralipton" => "baRalipt§",
"baraque" => "baRak",
"baraqué" => "baRake",
"baraquée" => "baRake",
"baraquement" => "baRak°m@",
"baraquements" => "baRak°m@",
"baraques" => "baRak",
"baraqués" => "baRake",
"baraterie" => "baRat°Ri",
"baratin" => "baRat5",
"baratinais" => "baRatinE",
"baratinait" => "baRatinE",
"baratine" => "baRatin",
"baratiné" => "baRatine",
"baratinée" => "baRatine",
"baratinent" => "baRatin",
"baratiner" => "baRatine",
"baratines" => "baRatin",
"baratinés" => "baRatine",
"baratineur" => "baRatin9R",
"baratineurs" => "baRatin9R",
"baratineuse" => "baRatin2z",
"baratinez" => "baRatine",
"baratins" => "baRat5",
"barattage" => "baRataZ",
"barattait" => "baRatE",
"barattant" => "baRat@",
"baratte" => "baRat",
"baratté" => "baRate",
"barattent" => "baRat",
"baratter" => "baRate",
"barattes" => "baRat",
"barattés" => "baRate",
"barba" => "baRba",
"barbacane" => "baRbakan",
"barbacanes" => "baRbakan",
"barbaient" => "baRbE",
"barbait" => "baRbE",
"barbant" => "baRb@",
"barbante" => "baRb@t",
"barbantes" => "baRb@t",
"barbants" => "baRb@",
"barbaque" => "baRbak",
"barbara" => "baRbaRa",
"barbare" => "baRbaR",
"barbarement" => "baRbaR°m@",
"barbares" => "baRbaR",
"barbaresque" => "baRbaREsk",
"barbaresques" => "baRbaREsk",
"barbarie" => "baRbaRi",
"barbaries" => "baRbaRi",
"barbarisme" => "baRbaRizm",
"barbarismes" => "baRbaRizm",
"barbe" => "baRb",
"barbé" => "baRbe",
"barbe-de-capucin" => "baRbdkapys5",
"barbeau" => "baRbo",
"barbeaux" => "baRbo",
"barbecue" => "baRb°kju",
"barbecues" => "baRb°kju",
"barbelé" => "baRb°le",
"barbelée" => "baRb°le",
"barbelées" => "baRb°le",
"barbelés" => "baRb°le",
"barbent" => "baRb",
"barber" => "baRbe",
"barbera" => "baRb°Ra",
"barberait" => "baRb°RE",
"barbes" => "baRb",
"barbés" => "baRbe",
"barbet" => "baRbE",
"barbets" => "baRbE",
"barbette" => "baRbEt",
"barbiche" => "baRbiS",
"barbiches" => "baRbiS",
"barbichette" => "baRbiSEt",
"barbichu" => "baRbiSy",
"barbichus" => "baRbiSy",
"barbier" => "baRbje",
"barbiers" => "baRbje",
"barbillon" => "baRbij§",
"barbillons" => "baRbij§",
"barbiquet" => "baRbikE",
"barbiquets" => "baRbikE",
"barbiturique" => "baRbityRik",
"barbituriques" => "baRbityRik",
"barbon" => "baRb§",
"barbons" => "baRb§",
"barbot" => "baRbo",
"barbota" => "baRbota",
"barbotages" => "baRbotaZ",
"barbotaient" => "baRbotE",
"barbotait" => "baRbotE",
"barbotant" => "baRbot@",
"barbote" => "baRbOt",
"barboté" => "baRbote",
"barbotent" => "baRbOt",
"barboter" => "baRbote",
"barboterais" => "baRbOt°RE",
"barboterait" => "baRbOt°RE",
"barboteuse" => "baRbot2z",
"barboteuses" => "baRbot2z",
"barbotière" => "baRbotjER",
"barbotons" => "baRbot§",
"barbotte" => "baRbOt",
"barbottes" => "baRbOt",
"barbouilla" => "baRbuja",
"barbouillage" => "baRbujaZ",
"barbouillages" => "baRbujaZ",
"barbouillai" => "baRbujE",
"barbouillaient" => "baRbujE",
"barbouillais" => "baRbujE",
"barbouillait" => "baRbujE",
"barbouillant" => "baRbuj@",
"barbouille" => "baRbuj",
"barbouillé" => "baRbuje",
"barbouillée" => "baRbuje",
"barbouillées" => "baRbuje",
"barbouillent" => "baRbuj",
"barbouiller" => "baRbuje",
"barbouillèrent" => "baRbujER",
"barbouilles" => "baRbuj",
"barbouillés" => "baRbuje",
"barbouilleur" => "baRbuj9R",
"barbouilleurs" => "baRbuj9R",
"barbouillis" => "baRbuji",
"barbouze" => "baRbuz",
"barbouzes" => "baRbuz",
"barbu" => "baRby",
"barbue" => "baRby",
"barbues" => "baRby",
"barbules" => "baRbyl",
"barbus" => "baRby",
"barca" => "baRka",
"barcarolle" => "baRkaROl",
"barcasse" => "baRkas",
"barcasses" => "baRkas",
"barda" => "baRda",
"bardage" => "baRdaZ",
"bardaient" => "baRdE",
"bardait" => "baRdE",
"bardane" => "baRdan",
"bardanes" => "baRdan",
"bardas" => "baRda",
"barde" => "baRd",
"bardé" => "baRde",
"bardeau" => "baRdo",
"bardeaux" => "baRdo",
"bardée" => "baRde",
"bardées" => "baRde",
"barder" => "baRde",
"bardera" => "baRd°Ra",
"barderait" => "baRd°RE",
"bardes" => "baRd",
"bardés" => "baRde",
"bardeurs" => "baRd9R",
"bardiques" => "baRdik",
"bardo" => "baRdo",
"bardolino" => "baRdolino",
"bardot" => "baRdo",
"bardots" => "baRdo",
"barème" => "baREm",
"barèmes" => "baREm",
"baret" => "baRE",
"barge" => "baRZ",
"barges" => "baRZ",
"barguigna" => "baRgiNa",
"barguigné" => "baRgiNe",
"barguigner" => "baRgiNe",
"baril" => "baRil",
"barillet" => "baRijE",
"barillets" => "baRijE",
"barils" => "baRil",
"barine" => "baRin",
"bariolage" => "baRjolaZ",
"bariolages" => "baRjolaZ",
"bariolaient" => "baRjolE",
"bariolant" => "baRjol@",
"bariole" => "baRjOl",
"bariolé" => "baRjole",
"bariolée" => "baRjole",
"bariolées" => "baRjole",
"bariolés" => "baRjole",
"bariolures" => "baRjolyR",
"barje" => "baRZ",
"barjes" => "baRZ",
"barjo" => "baRZo",
"barjos" => "baRZo",
"barjot" => "baRZo",
"barjots" => "baRZo",
"barmaid" => "baRmEd",
"barmaids" => "baRmEd",
"barman" => "baRman",
"barmans" => "baRman",
"barmen" => "baRmEn",
"barnum" => "baRnOm",
"barolo" => "baRolo",
"baromètre" => "baRomEtR",
"baromètres" => "baRomEtR",
"barométrique" => "baRometRik",
"baron" => "baR§",
"baronet" => "baRonE",
"baronnait" => "baRonE",
"baronne" => "baROn",
"baronner" => "baRone",
"baronnes" => "baROn",
"baronnet" => "baRonE",
"baronnets" => "baRonE",
"baronnez" => "baRone",
"baronnie" => "baRoni",
"baronnies" => "baRoni",
"barons" => "baR§",
"baroque" => "baROk",
"baroques" => "baROk",
"barotraumatisme" => "baRotRomatism",
"baroud" => "baRud",
"baroudé" => "baRude",
"baroudeur" => "baRud9R",
"baroudeurs" => "baRud9R",
"baroudeuse" => "baRud2z",
"barouf" => "baRuf",
"barque" => "baRk",
"barques" => "baRk",
"barquette" => "baRkEt",
"barquettes" => "baRkEt",
"barra" => "baRa",
"barracuda" => "baRakyda",
"barracudas" => "baRakuda",
"barrage" => "baRaZ",
"barrages" => "baRaZ",
"barrai" => "baRE",
"barraient" => "baRE",
"barrais" => "baRE",
"barrait" => "baRE",
"barrant" => "baR@",
"barre" => "baR",
"barré" => "baRe",
"barreau" => "baRo",
"barreaudées" => "baRode",
"barreaux" => "baRo",
"barrée" => "baRe",
"barrées" => "baRe",
"barrent" => "baR",
"barrer" => "baRe",
"barrera" => "baR°Ra",
"barrerai" => "baR°RE",
"barrerais" => "baR°RE",
"barrèrent" => "baRER",
"barreront" => "baR°R§",
"barres" => "baR",
"barrés" => "baRe",
"barrésien" => "baRezj5",
"barrette" => "baREt",
"barrettes" => "baREt",
"barreur" => "baR9R",
"barreurs" => "baR9R",
"barreuse" => "baR2z",
"barrez" => "baRe",
"barri" => "baRi",
"barricada" => "baRikada",
"barricadai" => "baRikadE",
"barricadaient" => "baRikadE",
"barricadait" => "baRikadE",
"barricade" => "baRikad",
"barricadé" => "baRikade",
"barricadée" => "baRikade",
"barricadées" => "baRikade",
"barricadent" => "baRikad",
"barricader" => "baRikade",
"barricaderait" => "baRikad°RE",
"barricadèrent" => "baRikadER",
"barricades" => "baRikad",
"barricadés" => "baRikade",
"barricadez" => "baRikade",
"barricadier" => "baRikadje",
"barricadières" => "baRikadjER",
"barricadons" => "baRikad§",
"barrière" => "baRjER",
"barrières" => "baRjER",
"barrique" => "baRik",
"barriques" => "baRik",
"barris" => "baRi",
"barrissait" => "baRisE",
"barrissant" => "baRis@",
"barrissement" => "baRis°m@",
"barrissements" => "baRis°m@",
"barrissent" => "baRis",
"barriste" => "baRist",
"barrit" => "baRi",
"barrons" => "baR§",
"bars" => "baR",
"bartavelle" => "baRtavEl",
"bartavelles" => "baRtavEl",
"barye" => "baRi",
"baryon" => "baRj§",
"baryte" => "baRit",
"baryté" => "baRite",
"baryton" => "baRit§",
"barytonnant" => "baRiton@",
"barytonner" => "baRitone",
"barytons" => "baRit§",
"baryum" => "baRjOm",
"barzoï" => "baRzOj",
"bas" => "ba",
"bas-bleu" => "babl2",
"bas-bleus" => "babl2",
"bas-côté" => "bakote",
"bas-côtés" => "bakote",
"bas-empire" => "baz@piR",
"bas-flanc" => "bafl@",
"bas-fond" => "baf§",
"bas-fonds" => "baf§",
"bas-relief" => "baR°ljEf",
"bas-reliefs" => "baR°ljEf",
"bas-ventre" => "bav@tR",
"basa" => "baza",
"basaient" => "bazE",
"basait" => "bazE",
"basal" => "bazal",
"basalte" => "bazalt",
"basaltes" => "bazalt",
"basaltique" => "bazaltik",
"basane" => "bazan",
"basané" => "bazane",
"basanée" => "bazane",
"basanées" => "bazane",
"basanes" => "bazan",
"basanés" => "bazane",
"basant" => "baz@",
"bascula" => "baskyla",
"basculai" => "baskylE",
"basculaient" => "baskylE",
"basculais" => "baskylE",
"basculait" => "baskylE",
"basculâmes" => "baskylam",
"basculant" => "baskyl@",
"basculante" => "baskyl@t",
"basculants" => "baskyl@",
"basculât" => "baskyla",
"bascule" => "baskyl",
"basculé" => "baskyle",
"basculée" => "baskyle",
"basculées" => "baskyle",
"basculement" => "baskyl°m@",
"basculent" => "baskyl",
"basculer" => "baskyle",
"basculera" => "baskyl°Ra",
"basculerai" => "baskyl°RE",
"basculerais" => "baskyl°RE",
"basculerait" => "baskyl°RE",
"basculèrent" => "baskylER",
"basculeront" => "baskyl°R§",
"bascules" => "baskyl",
"basculés" => "baskyle",
"basculez" => "baskyle",
"basculions" => "baskylj§",
"base" => "baz",
"basé" => "baze",
"base-ball" => "bEzbol",
"baseball" => "bezbol",
"basée" => "baze",
"basées" => "baze",
"basent" => "baz",
"baser" => "baze",
"basera" => "baz°Ra",
"baseront" => "baz°R§",
"bases" => "baz",
"basés" => "baze",
"basez" => "baze",
"basic" => "bazik",
"basilaire" => "bazilER",
"basileus" => "bazil2",
"basilic" => "bazilik",
"basilicum" => "bazilikOm",
"basilique" => "bazilik",
"basiliques" => "bazilik",
"basin" => "baz5",
"basique" => "bazik",
"basiques" => "bazik",
"basket" => "baskEt",
"basket-ball" => "baskEtbOl",
"baskets" => "baskEt",
"basketteur" => "baskEt9R",
"basketteurs" => "baskEt9R",
"basketteuse" => "baskEt2z",
"basketteuses" => "baskEt2z",
"basmati" => "basmati",
"basoche" => "bazOS",
"basons" => "baz§",
"basquaise" => "baskEz",
"basque" => "bask",
"basques" => "bask",
"bassa" => "basa",
"bassas" => "basa",
"basse" => "bas",
"basse-cour" => "baskuR",
"basse-fosse" => "basfos",
"basse-taille" => "bastaj",
"bassement" => "bas°m@",
"basses" => "bas",
"basses-cours" => "baskuR",
"basses-fosses" => "basfos",
"bassesse" => "basEs",
"bassesses" => "basEs",
"basset" => "basE",
"bassets" => "basE",
"bassette" => "basEt",
"bassin" => "bas5",
"bassinaient" => "basinE",
"bassinais" => "basinE",
"bassinait" => "basinE",
"bassinant" => "basin@",
"bassine" => "basin",
"bassiné" => "basine",
"bassiner" => "basine",
"bassines" => "basin",
"bassinet" => "basinE",
"bassinez" => "basine",
"bassinoire" => "basinwaR",
"bassinoires" => "basinwaR",
"bassins" => "bas5",
"bassiste" => "basist",
"bassistes" => "basist",
"basson" => "bas§",
"basta" => "basta",
"baste" => "bast",
"baster" => "baste",
"bastide" => "bastid",
"bastides" => "bastid",
"bastille" => "bastij",
"bastilles" => "bastij",
"bastingage" => "bast5gaZ",
"bastingages" => "bast5gaZ",
"bastion" => "bastj§",
"bastionnée" => "bastjone",
"bastions" => "bastj§",
"baston" => "bast§",
"bastonnade" => "bastonad",
"bastonnades" => "bastonad",
"bastonne" => "bastOn",
"bastonné" => "bastone",
"bastonnée" => "bastone",
"bastonnent" => "baston",
"bastonner" => "bastone",
"bastonnés" => "bastone",
"bastonneurs" => "baston9R",
"bastons" => "bast§",
"bastos" => "bastOs",
"bastringue" => "bastR5g",
"bastringues" => "bastR5g",
"bat" => "ba",
"bât" => "ba",
"bat-flanc" => "bafl@",
"bat-l'eau" => "balo",
"bataclan" => "batakl@",
"batailla" => "bataja",
"bataillait" => "batajE",
"bataillant" => "bataj@",
"bataille" => "bataj",
"bataillé" => "bataje",
"bataillent" => "bataj",
"batailler" => "bataje",
"bataillèrent" => "batajER",
"batailles" => "bataj",
"bataillés" => "bataje",
"batailleur" => "bataj9R",
"batailleurs" => "bataj9R",
"batailleuse" => "bataj2z",
"batailleuses" => "bataj2z",
"bataillon" => "bataj§",
"bataillonnaire" => "batajonER",
"bataillonnaires" => "batajonER",
"bataillons" => "bataj§",
"batak" => "batak",
"bâtard" => "bataR",
"bâtarde" => "bataRd",
"batardeau" => "bataRdo",
"bâtardes" => "bataRd",
"bâtardise" => "bataRdiz",
"bâtardises" => "bataRdiz",
"bâtards" => "bataR",
"batave" => "batav",
"bataves" => "batav",
"bâté" => "bate",
"bateau" => "bato",
"bateau-citerne" => "batositERn",
"bateau-lavoir" => "batolavwaR",
"bateau-mouche" => "batomuS",
"bateau-pilote" => "batopilOt",
"bateau-pompe" => "batop§p",
"bateaux" => "bato",
"bateaux-lavoirs" => "batolavwaR",
"bateaux-mouches" => "batomuS",
"batée" => "bate",
"batelets" => "bat°lE",
"bateleur" => "bat°l9R",
"bateleurs" => "bat°l9R",
"batelier" => "bat°lje",
"bateliers" => "bat°lje",
"batellerie" => "batEl°Ri",
"bâter" => "bate",
"bâtés" => "bate",
"bath" => "bat",
"bathyale" => "batjal",
"bathymètre" => "batimEtR",
"bathymétrique" => "batimetRik",
"bathyscaphe" => "batiskaf",
"bathysphère" => "batisfER",
"bâti" => "bati",
"bâtie" => "bati",
"bâtière" => "batjER",
"bâties" => "bati",
"batifola" => "batifola",
"batifolage" => "batifolaZ",
"batifolages" => "batifolaZ",
"batifolaient" => "batifolE",
"batifolais" => "batifolE",
"batifolait" => "batifolE",
"batifolant" => "batifol@",
"batifole" => "batifOl",
"batifolé" => "batifole",
"batifolent" => "batifOl",
"batifoler" => "batifole",
"batifoles" => "batifOl",
"batifoleurs" => "batifol9R",
"batifolez" => "batifole",
"batik" => "batik",
"bâtiment" => "batim@",
"bâtiments" => "batim@",
"bâtir" => "batiR",
"bâtira" => "batiRa",
"bâtirai" => "batiRE",
"bâtirais" => "batiRE",
"bâtirait" => "batiRE",
"bâtirent" => "batiR",
"bâtirions" => "batiRj§",
"bâtirons" => "batiR§",
"bâtiront" => "batiR§",
"bâtis" => "bati",
"bâtissaient" => "batisE",
"bâtissais" => "batisE",
"bâtissait" => "batisE",
"bâtissant" => "batis@",
"bâtisse" => "batis",
"bâtissent" => "batis",
"bâtisses" => "batis",
"bâtisseur" => "batis9R",
"bâtisseurs" => "batis9R",
"bâtisseuse" => "batis2z",
"bâtissez" => "batise",
"bâtissions" => "batisj§",
"bâtissons" => "batis§",
"batiste" => "batist",
"bâtit" => "bati",
"bâton" => "bat§",
"bâtonnant" => "baton@",
"bâtonnée" => "batone",
"bâtonner" => "batOne",
"bâtonnet" => "batonE",
"bâtonnets" => "batonE",
"bâtonnier" => "batonje",
"bâtons" => "bat§",
"batracien" => "batRasj5",
"batracienne" => "batRasjEn",
"batraciens" => "batRasj5",
"bats" => "ba",
"bâts" => "ba",
"battage" => "bataZ",
"battages" => "bataZ",
"battaient" => "batE",
"battais" => "batE",
"battait" => "batE",
"battant" => "bat@",
"battante" => "bat@t",
"battantes" => "bat@t",
"battants" => "bat@",
"batte" => "bat",
"battement" => "bat°m@",
"battements" => "bat°m@",
"battent" => "bat",
"batterie" => "bat°Ri",
"batteries" => "bat°Ri",
"battes" => "bat",
"batteur" => "bat9R",
"batteurs" => "bat9R",
"batteuse" => "bat2z",
"batteuses" => "bat2z",
"battez" => "bate",
"battiez" => "batje",
"battîmes" => "batim",
"battions" => "batj§",
"battirent" => "batiR",
"battis" => "bati",
"battit" => "bati",
"battît" => "bati",
"battle-dress" => "bat9ldREs",
"battoir" => "batwaR",
"battoires" => "batwaR",
"battoirs" => "batwaR",
"battons" => "bat§",
"battra" => "batRa",
"battrai" => "batRE",
"battraient" => "batRE",
"battrais" => "batRE",
"battrait" => "batRE",
"battras" => "batRa",
"battre" => "batR",
"battrez" => "batRe",
"battriez" => "batRie",
"battrions" => "batRi§",
"battrons" => "batR§",
"battront" => "batR§",
"battu" => "baty",
"battue" => "baty",
"battues" => "baty",
"battus" => "baty",
"bau" => "bo",
"baud" => "bo",
"baudelairien" => "bod°lERj5",
"baudelairiennes" => "bod°lERjEn",
"baudelairiens" => "bod°lERj5",
"baudet" => "bodE",
"baudets" => "bodE",
"baudrier" => "bodRije",
"baudriers" => "bodRije",
"baudroie" => "bodRwa",
"baudroies" => "bodRwa",
"baudruche" => "bodRyS",
"baudruches" => "bodRyS",
"bauge" => "boZ",
"baugé" => "boZe",
"bauges" => "boZ",
"baume" => "bom",
"baumes" => "bom",
"baumier" => "bomje",
"baumiers" => "bomje",
"baux" => "bo",
"bauxite" => "boksit",
"bava" => "bava",
"bavaient" => "bavE",
"bavais" => "bavE",
"bavait" => "bavE",
"bavant" => "bav@",
"bavard" => "bavaR",
"bavarda" => "bavaRda",
"bavardage" => "bavaRdaZ",
"bavardages" => "bavaRdaZ",
"bavardai" => "bavaRdE",
"bavardaient" => "bavaRdE",
"bavardais" => "bavaRdE",
"bavardait" => "bavaRdE",
"bavardant" => "bavaRd@",
"bavarde" => "bavaRd",
"bavardé" => "bavaRde",
"bavardent" => "bavaRd",
"bavarder" => "bavaRde",
"bavardera" => "bavaRd°Ra",
"bavarderai" => "bavaRd°RE",
"bavarderait" => "bavaRd°RE",
"bavarderas" => "bavaRd°Ra",
"bavardèrent" => "bavaRdER",
"bavarderons" => "bavaRd°R§",
"bavardes" => "bavaRd",
"bavardez" => "bavaRde",
"bavardiez" => "bavaRdje",
"bavardions" => "bavaRdj§",
"bavardons" => "bavaRd§",
"bavards" => "bavaR",
"bavarois" => "bavaRwa",
"bavaroise" => "bavaRwaz",
"bavaroises" => "bavaRwaz",
"bavassaient" => "bavasE",
"bavassait" => "bavasE",
"bavassant" => "bavas@",
"bavasse" => "bavas",
"bavassé" => "bavase",
"bavassent" => "bavas",
"bavasser" => "bavase",
"bavasses" => "bavas",
"bavasseur" => "bavas9R",
"bavassiez" => "bavasje",
"bave" => "bav",
"bavé" => "bave",
"bavent" => "bav",
"baver" => "bave",
"baverais" => "bav°RE",
"baveras" => "bav°Ra",
"baverez" => "bav°Re",
"baveront" => "bav°R§",
"baves" => "bav",
"bavette" => "bavEt",
"bavettes" => "bavEt",
"baveur" => "bav9R",
"baveurs" => "bav9R",
"baveuse" => "bav2z",
"baveuses" => "bav2z",
"baveux" => "bav2",
"bavez" => "bave",
"bavocher" => "bavoSe",
"bavoir" => "bavwaR",
"bavoirs" => "bavwaR",
"bavons" => "bav§",
"bavotait" => "bavotE",
"bavotant" => "bavot@",
"bavure" => "bavyR",
"bavures" => "bavyR",
"bayadère" => "bajadER",
"bayadères" => "bajadER",
"bayaient" => "bajE",
"bayant" => "baj@",
"bayard" => "bajaR",
"baye" => "baj",
"bayé" => "baje",
"bayer" => "baje",
"bayons" => "baj§",
"bayou" => "baju",
"bayous" => "baju",
"bazar" => "bazaR",
"bazard" => "bazaR",
"bazardait" => "bazaRdE",
"bazardant" => "bazaRd@",
"bazarde" => "bazaRd",
"bazardé" => "bazaRde",
"bazardée" => "bazaRde",
"bazardées" => "bazaRde",
"bazarder" => "bazaRde",
"bazarderez" => "bazaRd°Re",
"bazardes" => "bazaRd",
"bazardeur" => "bazaRd9R",
"bazars" => "bazaR",
"bazooka" => "bazuka",
"bazookas" => "bazuka",
"bcbg" => "besebeZe",
"bé" => "be",
"be-bop" => "bibOp",
"béa" => "bea",
"beagle" => "big9l",
"beagles" => "big9ls",
"béaient" => "beE",
"béait" => "beE",
"béance" => "be@s",
"béant" => "be@",
"béante" => "be@t",
"béantes" => "be@t",
"béants" => "be@",
"béarnais" => "beaRnE",
"béarnaise" => "beaRnEz",
"beat" => "bit",
"béat" => "bea",
"beat generation" => "bitZeneRasj§",
"béate" => "beat",
"béatement" => "beat°m@",
"béates" => "beat",
"béatification" => "beatifikasj§",
"béatifications" => "beatifikasj§",
"béatifié" => "beatifje",
"béatifiée" => "beatifje",
"béatifier" => "beatifje",
"béatifiés" => "beatifje",
"béatifique" => "beatifik",
"béatitude" => "beatityd",
"béatitudes" => "beatityd",
"beatnik" => "bitnik",
"beatniks" => "bitnik",
"béats" => "bea",
"beau" => "bo",
"beau-fils" => "bofis",
"beau-frère" => "bofRER",
"beau-papa" => "bopapa",
"beau-parent" => "bopaR@",
"beau-père" => "bopER",
"beauceron" => "bos°R§",
"beauceronne" => "bos°ROn",
"beauceronnes" => "bos°ROn",
"beaucerons" => "bos°R§",
"beaucoup" => "boku",
"beauf" => "bof",
"beaufs" => "bof",
"beaujolais" => "boZolE",
"beaujolpif" => "boZOlpif",
"beaupré" => "bopRe",
"beauté" => "bote",
"beautés" => "bote",
"beauvais" => "bovE",
"beaux" => "bo",
"beaux-arts" => "bozaR",
"beaux-enfants" => "boz@f@",
"beaux-fils" => "bofis",
"beaux-frères" => "bofRER",
"beaux-parents" => "bopaR@",
"bébé" => "bebe",
"bébés" => "bebe",
"bébés-éprouvette" => "bebeepRuvEt",
"bébête" => "bebEt",
"bébêtes" => "bebEt",
"bec" => "bEk",
"bec-de-cane" => "bEkd2kan",
"bec-de-lièvre" => "bEkd2ljEvR",
"bécabunga" => "bekabuGa",
"bécane" => "bekan",
"bécanes" => "bekan",
"bécard" => "bekaR",
"bécarre" => "bekaR",
"bécasse" => "bekas",
"bécasses" => "bekas",
"bécassine" => "bekasin",
"bécassines" => "bekasin",
"because" => "bikoz",
"becfigue" => "bEkfig",
"becfigues" => "bEkfig",
"bêchaient" => "bESE",
"bêchait" => "bESE",
"béchamel" => "beSamEl",
"bêchant" => "bES@",
"bêche" => "bES",
"bêché" => "beSe",
"bêchent" => "bES",
"bécher" => "beSe",
"bêcher" => "beSe",
"bêches" => "bES",
"bêcheur" => "bES9R",
"bêcheurs" => "bES9R",
"bêcheuse" => "bES2z",
"bêcheuses" => "bES2z",
"bécot" => "beko",
"bécotait" => "bekotE",
"bécotant" => "bekot@",
"bécote" => "bekOt",
"bécoté" => "bekOte",
"bécotée" => "bekote",
"bécotent" => "bekOt",
"bécoter" => "bekote",
"bécotés" => "bekote",
"bécoteur" => "bekot9R",
"bécots" => "beko",
"becquant" => "bEk@",
"becqué" => "beke",
"becquée" => "bEke",
"becquer" => "beke",
"becquet" => "bekE",
"becquetaient" => "bEk°tE",
"becquetait" => "bEk°tE",
"becquetance" => "bEk°t@s",
"becquetant" => "bEk°t@",
"becqueté" => "bEk°te",
"becqueter" => "bEk°te",
"becquetés" => "bEk°te",
"becquets" => "bEkE",
"becquette" => "bEkEt",
"becs" => "bEk",
"becta" => "bEkta",
"bectais" => "bEktE",
"bectait" => "bEktE",
"bectance" => "bEkt@s",
"bectant" => "bEkt@",
"becte" => "bEkt",
"becté" => "bEkte",
"bectées" => "bEkte",
"bectent" => "bEkt",
"becter" => "bEkte",
"becterais" => "bEkt°RE",
"becteras" => "bEkt°Ra",
"bectés" => "bEkte",
"bedaine" => "b2dEn",
"bedaines" => "b2dEn",
"bédane" => "bedan",
"bédé" => "bede",
"bedeau" => "b2do",
"bedeaux" => "b2do",
"bédéphiles" => "bedefil",
"bédés" => "bede",
"bedon" => "b2d§",
"bedonnant" => "b2don@",
"bedonnante" => "b2don@t",
"bedonnantes" => "b2don@t",
"bedonnants" => "b2don@",
"bedonne" => "b2dOn",
"bedons" => "b2d§",
"bédouin" => "bedw5",
"bédouine" => "bedwin",
"bédouines" => "bedwin",
"bédouins" => "bedw5",
"bée" => "be",
"béé" => "bee",
"béée" => "bee",
"beefsteak" => "biftEk",
"beefsteaks" => "biftEk",
"béent" => "be",
"beeper" => "bip9R",
"béer" => "bee",
"béèrent" => "beER",
"bées" => "be",
"beethovénien" => "betovenj5",
"beffroi" => "befRwa",
"bégaie" => "begE",
"bégaiement" => "begEm@",
"bégaiements" => "begEm@",
"bégaient" => "begE",
"bégaiera" => "begERa",
"bégaies" => "begE",
"bégaya" => "begeja",
"bégayai" => "begejE",
"bégayaient" => "begejE",
"bégayais" => "begejE",
"bégayait" => "begejE",
"bégayant" => "begej@",
"bégayante" => "begej@t",
"bégayantes" => "begej@t",
"bégayants" => "begej@",
"bégaye" => "begej",
"bégayé" => "begeje",
"bégayées" => "begeje",
"bégayer" => "begeje",
"bégayes" => "begEj",
"bégayeur" => "begEj9R",
"bégayez" => "begeje",
"bégonias" => "begonja",
"bègue" => "bEg",
"bègues" => "bEg",
"bégueule" => "beg9l",
"bégueulerie" => "beg9l°Ri",
"bégueules" => "beg9l",
"béguin" => "beg5",
"béguinage" => "beginaZ",
"béguine" => "begin",
"béguineuse" => "begin2z",
"béguins" => "beg5",
"bégum" => "begOm",
"behavioriste" => "beavjoRist",
"béhème" => "beEm",
"béhémoth" => "beemOt",
"beige" => "bEZ",
"beigeasses" => "bEZas",
"beiges" => "bEZ",
"beigne" => "bEN",
"beignes" => "bEN",
"beignet" => "bENE",
"beignets" => "bENE",
"béjaune" => "beZon",
"bel" => "bEl",
"bel canto" => "bElk@to",
"bêlaient" => "bElE",
"bêlait" => "bElE",
"bêlant" => "bEl@",
"bêlantes" => "bEl@t",
"bêlants" => "bEl@",
"bêle" => "bEl",
"bêlé" => "bele",
"bêlement" => "bEl°m@",
"bêlements" => "bEl°m@",
"bêlent" => "bEl",
"bêler" => "bele",
"belette" => "b°lEt",
"belettes" => "b°lEt",
"belge" => "bElZ",
"belges" => "bElZ",
"belgicains" => "bElZik5",
"belgique" => "bElZik",
"bélier" => "belje",
"béliers" => "belje",
"bélinogramme" => "belinogRam",
"bélître" => "belitR",
"belladone" => "beladOn",
"belladones" => "beladOn",
"bellâtre" => "bElatR",
"belle" => "bEl",
"belle lurette" => "bEllyREt",
"belle-à-voir" => "bElavwaR",
"belle-doche" => "bEldOS",
"belle-famille" => "bElfamij",
"belle-fille" => "bElfij",
"belle-maman" => "bElmam@",
"belle-mère" => "bElmER",
"belle-soeur" => "bEls9R",
"bellement" => "bEl°m@",
"belles" => "bEl",
"belles-de-jour" => "bEld2ZuR",
"belles-de-nuit" => "bEld2n8i",
"belles-familles" => "bElfamij",
"belles-filles" => "bElfij",
"belles-lettres" => "bEllEtR",
"belles-mères" => "bElmER",
"belles-soeurs" => "bEls9R",
"bellevillois" => "bel°vilwa",
"bellevilloise" => "bel°vilwaz",
"belliciste" => "bElisist",
"bellicistes" => "bElisist",
"belligérance" => "bEliZeR@s",
"belligérant" => "beliZeR@",
"belligérante" => "beliZeR@t",
"belligérantes" => "beliZeR@t",
"belligérants" => "beliZeR@",
"belliqueuse" => "belik2z",
"belliqueusement" => "belik2z°m@",
"belliqueuses" => "belik2z",
"belliqueux" => "belik2",
"bellissime" => "bElisim",
"bellot" => "bElo",
"belluaire" => "bEl8ER",
"belon" => "b°l§",
"belons" => "b°l§",
"belote" => "b°lOt",
"beloter" => "b°lote",
"belotes" => "b°lOt",
"beloteurs" => "b°lot9R",
"belotte" => "b°lOt",
"bélouga" => "beluga",
"beluga" => "belyga",
"béluga" => "belyga",
"belvédère" => "bElvedER",
"belvédères" => "bElvedER",
"bémol" => "bemOl",
"bémolisé" => "bemolize",
"bémols" => "bemOl",
"ben" => "b5",
"bénard" => "benaR",
"bénarde" => "benaRd",
"bénards" => "benaR",
"bénédicité" => "benedisite",
"bénédicités" => "benedisite",
"bénédictin" => "benedikt5",
"bénédictine" => "benediktin",
"bénédictines" => "benediktin",
"bénédictins" => "benedikt5",
"bénédiction" => "benediksj§",
"bénédictions" => "benediksj§",
"benedictus" => "benediktys",
"bénef" => "benEf",
"bénéfice" => "benefis",
"bénéfices" => "benefis",
"bénéficia" => "benefisja",
"bénéficiaient" => "benefisjE",
"bénéficiaire" => "benefisjER",
"bénéficiaires" => "benefisjER",
"bénéficiais" => "benefisjE",
"bénéficiait" => "benefisjE",
"bénéficiant" => "benefisj@",
"bénéficiât" => "benefisja",
"bénéficie" => "benefisi",
"bénéficié" => "benefisje",
"bénéficient" => "benefisi",
"bénéficier" => "benefisje",
"bénéficiera" => "benefisiRa",
"bénéficierai" => "benefisiRE",
"bénéficierais" => "benefisiRE",
"bénéficierait" => "benefisiRE",
"bénéficièrent" => "benefisjER",
"bénéficierez" => "benefisiRe",
"bénéficierons" => "benefisiR§",
"bénéficies" => "benefisi",
"bénéficiez" => "benefisje",
"bénéficions" => "benefisj§",
"bénéfique" => "benefik",
"bénéfiques" => "benefik",
"bénefs" => "benEf",
"benêt" => "b°nE",
"benêts" => "b°nE",
"bénévolat" => "benevola",
"bénévole" => "benevOl",
"bénévolement" => "benevOl°m@",
"bénévolence" => "benevOl@s",
"bénévoles" => "benevOl",
"bengalais" => "b5galE",
"bengali" => "b5gali",
"bengalis" => "b5gali",
"béni" => "beni",
"bénie" => "beni",
"bénies" => "beni",
"bénigne" => "beniN",
"bénignement" => "beniN°m@",
"bénignes" => "beniN",
"bénignité" => "beniNite",
"bénin" => "ben5",
"béninois" => "beninwa",
"bénins" => "ben5",
"bénir" => "beniR",
"bénira" => "beniRa",
"bénirai" => "beniRE",
"bénirais" => "beniRE",
"bénirait" => "beniRE",
"béniras" => "beniRa",
"bénirez" => "beniRe",
"bénirons" => "beniR§",
"béniront" => "beniR§",
"bénis" => "beni",
"bénissaient" => "benisE",
"bénissais" => "benisE",
"bénissait" => "benisE",
"bénissant" => "benis@",
"bénisse" => "benis",
"bénissent" => "benis",
"bénisseur" => "benis9R",
"bénisseurs" => "benis9R",
"bénisseuse" => "benis2z",
"bénissez" => "benise",
"bénissions" => "benisj§",
"bénissons" => "benis§",
"bénit" => "beni",
"bénite" => "benit",
"bénites" => "benit",
"bénitier" => "benitje",
"bénitiers" => "benitje",
"bénits" => "beni",
"benjamin" => "b5Zam5",
"benjamine" => "b5Zamin",
"benjamins" => "b5Zam5",
"benjoin" => "b5Zw5",
"benne" => "bEn",
"bennes" => "bEn",
"benoît" => "b°nwa",
"benoîte" => "b°nwat",
"benoîtement" => "b°nwat°m@",
"bénouze" => "benuz",
"benthique" => "b5tik",
"benzédrine" => "b5zedRin",
"benzène" => "b5zEn",
"benzidine" => "b5zidin",
"benzine" => "b5zin",
"benzoate" => "b5zOat",
"benzodiazépine" => "b5zodjazepin",
"benzonaphtol" => "b5zonaftOl",
"benzylique" => "b5zilik",
"béotien" => "beosj5",
"béotienne" => "beosjEn",
"béotiens" => "beosj5",
"béquant" => "bek@",
"béquillant" => "bekij@",
"béquillard" => "bekijaR",
"béquille" => "bekij",
"béquillent" => "bekij",
"béquilles" => "bekij",
"béquilleux" => "bekj2",
"ber" => "b9R",
"berbère" => "bERbER",
"berbères" => "bERbER",
"berça" => "bERsa",
"berçaient" => "bERsE",
"bercail" => "bERkaj",
"berçais" => "bERsE",
"berçait" => "bERsE",
"berçant" => "bERs@",
"berce" => "bERs",
"bercé" => "bERse",
"berceau" => "bERso",
"berceaux" => "bERso",
"bercée" => "bERse",
"bercelonnette" => "bERs°lonEt",
"bercement" => "bERs°m@",
"bercements" => "bERs°m@",
"bercent" => "bERs",
"bercer" => "bERse",
"bercera" => "bERs°Ra",
"bercerai" => "bERs°RE",
"bercerait" => "bERs°RE",
"bercèrent" => "bERsER",
"bercerez" => "bERs°Re",
"berces" => "bERs",
"bercés" => "bERse",
"berceur" => "bERs9R",
"berceurs" => "bERs9R",
"berceuse" => "bERs2z",
"berceuses" => "bERs2z",
"bercez" => "bERse",
"berdouillette" => "bERdujEt",
"béret" => "beRE",
"bérets" => "beRE",
"bérézina" => "beRezina",
"berg" => "bERg",
"bergamasques" => "bERgamask",
"bergamote" => "bERgamOt",
"berge" => "bERZ",
"berger" => "bERZe",
"bergère" => "bERZER",
"bergères" => "bERZER",
"bergerie" => "bERZ°Ri",
"bergeries" => "bERZ°Ri",
"bergeronnette" => "bERZ°RonEt",
"bergeronnettes" => "bERZ°RonEt",
"bergers" => "bERZe",
"berges" => "bERZ",
"béribéri" => "beRibeRi",
"berk" => "bERk",
"berle" => "bERl",
"berlin" => "bERl5",
"berline" => "bERlin",
"berlines" => "bERlin",
"berlingot" => "bERl5go",
"berlingots" => "bERl5go",
"berlingue" => "bERl5g",
"berlinois" => "bERlinwa",
"berlinoise" => "bERlinwaz",
"berlinoises" => "bERlinwaz",
"berloque" => "bERlOk",
"berlue" => "bERly",
"berlues" => "bERly",
"berlurais" => "bERlyRE",
"berlurait" => "bERlyRE",
"berlure" => "bERlyR",
"berluré" => "bERlyRe",
"berlurée" => "bERlyRe",
"berlurent" => "bERlyR",
"berlurer" => "bERlyRe",
"berlures" => "bERlyR",
"berme" => "bERm",
"bermes" => "bERm",
"bermuda" => "bERmyda",
"bermudas" => "bERmyda",
"bernache" => "bERnaS",
"bernaches" => "bERnaS",
"bernait" => "bERnE",
"bernant" => "bERn@",
"bernard-l'ermite" => "bERnaRlERmit",
"bernard-l'hermite" => "bERnaRlERmit",
"bernardines" => "bERnaRdin",
"berne" => "bERn",
"berné" => "bERne",
"bernée" => "bERne",
"bernées" => "bERne",
"berner" => "bERne",
"berneras" => "bERn°Ra",
"bernés" => "bERne",
"bernez" => "bERne",
"bernicle" => "bERnikl",
"bernicles" => "bERnikl",
"bernique" => "bERnik",
"berniques" => "bERnik",
"bernois" => "bERnwa",
"bernoise" => "bERnwaz",
"bernoises" => "bERnwaz",
"berrichon" => "bERiS§",
"berrichonne" => "bERiSOn",
"bersaglier" => "bERsaglije",
"bersagliers" => "bERsaglije",
"bertha" => "bERta",
"berthas" => "bERta",
"berthe" => "bERt",
"bérullienne" => "beRyljEn",
"béryl" => "beRil",
"béryllium" => "beRiljOm",
"béryls" => "beRil",
"berzingue" => "bERz5g",
"besace" => "b°zas",
"besaces" => "b°zas",
"besaiguë" => "b°zegy",
"besant" => "b°z@",
"besants" => "b°z@",
"besef" => "b°zEf",
"bésef" => "bezEf",
"bésiclard" => "beziklaR",
"besicles" => "bezikl",
"bésicles" => "bezikl",
"bésigue" => "bezig",
"besogna" => "b2zoNa",
"besognaient" => "b2zoNE",
"besognais" => "b2zoNE",
"besognait" => "b2zoNE",
"besognant" => "b2zoN@",
"besogne" => "b2zON",
"besogné" => "b2zONe",
"besognent" => "b2zON",
"besogner" => "b2zoNe",
"besogneras" => "b2zON°Ra",
"besognèrent" => "b2zoNER",
"besognes" => "b2zON",
"besogneuse" => "b2zoN2z",
"besogneuses" => "b2zoN2z",
"besogneux" => "b2zoN2",
"besoin" => "b2zw5",
"besoins" => "b2zw5",
"besson" => "bes§",
"bessons" => "bes§",
"best" => "bEst",
"best of" => "bEstOf",
"best-seller" => "bEstsel9R",
"best-sellers" => "bEstsel9R",
"bestiaire" => "bEstjER",
"bestiaires" => "bEstjER",
"bestial" => "bEstjal",
"bestiale" => "bEstjal",
"bestialement" => "bEstjal°m@",
"bestiales" => "bEstjal",
"bestialité" => "bEstjalite",
"bestialités" => "bEstjalite",
"bestiasse" => "bEstjas",
"bestiau" => "bEstjo",
"bestiaux" => "bEstjo",
"bestiole" => "bEstjOl",
"bestioles" => "bEstjOl",
"bêta" => "bEta",
"bétail" => "betaj",
"bétaillère" => "betajER",
"bétaillères" => "betajER",
"bétails" => "betaj",
"bêtas" => "bEta",
"bêtasse" => "bEtas",
"bêtasses" => "bEtas",
"bêtatron" => "bEtatR§",
"bête" => "bEt",
"bétel" => "betEl",
"bêtement" => "bEt°m@",
"bêtes" => "bEt",
"bêtifia" => "betifja",
"bêtifiaient" => "betifjE",
"bêtifiais" => "betifjE",
"bêtifiait" => "betifjE",
"bêtifiant" => "betifj@",
"bêtifie" => "betifi",
"bêtifié" => "betifje",
"bêtifier" => "betifje",
"bêtise" => "betiz",
"bêtises" => "betiz",
"bêtisier" => "betizje",
"bétoine" => "betwan",
"béton" => "bet§",
"bétonnage" => "betonaZ",
"bétonnaient" => "betonE",
"bétonné" => "betone",
"bétonnée" => "betone",
"bétonnées" => "betone",
"bétonner" => "betone",
"bétonnés" => "betone",
"bétonneurs" => "beton9R",
"bétonneuse" => "beton2z",
"bétonneuses" => "beton2z",
"bétonnière" => "betonjER",
"bétonnières" => "betonjER",
"bétons" => "bet§",
"bette" => "bEt",
"betterave" => "bEt°Rav",
"betteraves" => "bEt°Rav",
"betteravier" => "bEt°Ravje",
"bettes" => "bEt",
"betting" => "bEtiG",
"beu" => "b2",
"beuark" => "b2aRk",
"beugla" => "b2gla",
"beuglaient" => "b2glE",
"beuglais" => "b2glE",
"beuglait" => "b2glE",
"beuglant" => "b2gl@",
"beuglante" => "b2gl@t",
"beuglantes" => "b2gl@t",
"beuglants" => "b2gl@",
"beugle" => "b2gl",
"beuglé" => "b2gle",
"beuglée" => "b2gle",
"beuglement" => "b2gl°m@",
"beuglements" => "b2gl°m@",
"beuglent" => "b2gl",
"beugler" => "b2gle",
"beuglions" => "b2glij§",
"beuh" => "b2",
"beur" => "b9R",
"beurk" => "b9Rk",
"beurra" => "b9Ra",
"beurrage" => "b9RaZ",
"beurraient" => "b9RE",
"beurrais" => "b9RE",
"beurrait" => "b9RE",
"beurrant" => "b9R@",
"beurre" => "b9R",
"beurré" => "b9Re",
"beurrée" => "b9Re",
"beurrées" => "b9Re",
"beurrer" => "b9Re",
"beurres" => "b9R",
"beurrés" => "b9Re",
"beurrier" => "b9Rje",
"beuverie" => "b9v°Ri",
"beuveries" => "b9v°Ri",
"bévue" => "bevy",
"bévues" => "bevy",
"bey" => "bE",
"bezef" => "bezEf",
"bézef" => "bezEf",
"bézoard" => "bezoaR",
"bi" => "bi",
"biafrais" => "bjafRE",
"biais" => "bjE",
"biaisai" => "bjEzE",
"biaise" => "bjEz",
"biaisé" => "bjeze",
"biaisée" => "bjeze",
"biaisements" => "bjEz°m@",
"biaiser" => "bjeze",
"biaises" => "bjEz",
"biathlon" => "biatl§",
"bib" => "bib",
"bibard" => "bibaR",
"bibelot" => "bib°lo",
"bibelots" => "bib°lo",
"bibendum" => "bib5dOm",
"biberon" => "bib°R§",
"biberonnait" => "bib°RonE",
"biberonne" => "bib°ROn",
"biberonné" => "bib°Rone",
"biberonner" => "bib°Rone",
"biberonneurs" => "bib°Ron9R",
"biberons" => "bib°R§",
"bibi" => "bibi",
"bibiche" => "bibiS",
"bibine" => "bibin",
"bibines" => "bibin",
"bibis" => "bibi",
"bibite" => "bibit",
"bible" => "bibl",
"bibles" => "bibl",
"bibliobus" => "biblijobys",
"bibliographe" => "biblijogRaf",
"bibliographie" => "biblijogRafi",
"bibliographies" => "biblijogRafi",
"bibliographique" => "biblijOgRafik",
"bibliographiques" => "biblijogRafik",
"bibliophile" => "biblijofil",
"bibliophiles" => "biblijofil",
"bibliophilie" => "biblijofili",
"bibliophilique" => "biblijofilik",
"bibliothécaire" => "biblijotekER",
"bibliothécaires" => "biblijotekER",
"bibliothèque" => "biblijotEk",
"bibliothèques" => "biblijotEk",
"biblique" => "biblik",
"bibliquement" => "biblik°m@",
"bibliques" => "biblik",
"bic" => "bik",
"bicamérale" => "bikameRal",
"bicarbonate" => "bikaRbonat",
"bicarbonates" => "bikaRbonat",
"bicause" => "bikoz",
"bicentenaire" => "bis@t°nER",
"bicéphale" => "bisefal",
"bicéphales" => "bisefal",
"bicéphalie" => "bisefali",
"biceps" => "bisEps",
"bichais" => "biSE",
"bichait" => "biSE",
"bichant" => "biS@",
"biche" => "biS",
"biché" => "biSe",
"bicher" => "biSe",
"biches" => "biS",
"bichette" => "biSEt",
"bichez" => "biSe",
"bichon" => "biS§",
"bichonnait" => "biSonE",
"bichonnant" => "biSon@",
"bichonne" => "biSOn",
"bichonné" => "biSone",
"bichonnée" => "biSone",
"bichonner" => "biSone",
"bichonnerai" => "biSOn°RE",
"bichonnez" => "biSone",
"biclou" => "biklu",
"biclous" => "biklu",
"bicolore" => "bikolOR",
"bicolores" => "bikolOR",
"biconvexes" => "bik§vEks",
"bicoque" => "bikOk",
"bicoques" => "bikOk",
"bicorne" => "bikORn",
"bicornes" => "bikORn",
"bicot" => "biko",
"bicots" => "biko",
"biculturelle" => "bikyltyREl",
"bicuspide" => "bikyspid",
"bicycle" => "bisikl",
"bicycles" => "bisikl",
"bicyclette" => "bisiklEt",
"bicyclettes" => "bisiklEt",
"bicycliste" => "bisiklist",
"bidasse" => "bidas",
"bidasses" => "bidas",
"bide" => "bid",
"bides" => "bid",
"bidet" => "bidE",
"bidets" => "bidE",
"bidimensionnel" => "bidim@sjonEl",
"bidoche" => "bidOS",
"bidoches" => "bidOS",
"bidon" => "bid§",
"bidonnage" => "bidonaZ",
"bidonnaient" => "bidonE",
"bidonnais" => "bidonE",
"bidonnait" => "bidonE",
"bidonnant" => "bidon@",
"bidonnante" => "bidOn@t",
"bidonne" => "bidOn",
"bidonné" => "bidone",
"bidonnée" => "bidone",
"bidonnées" => "bidone",
"bidonnent" => "bidOn",
"bidonner" => "bidone",
"bidonnera" => "bidOn°Ra",
"bidonnés" => "bidone",
"bidonnez" => "bidone",
"bidons" => "bid§",
"bidonville" => "bid§vil",
"bidonvilles" => "bid§vil",
"bidouilla" => "biduja",
"bidouillage" => "bidujaZ",
"bidouille" => "biduj",
"bidouillé" => "biduje",
"bidouillée" => "biduje",
"bidouiller" => "biduje",
"bidouillerai" => "biduj°RE",
"bidouillés" => "biduje",
"bidule" => "bidyl",
"bidules" => "bidyl",
"bief" => "bjEf",
"biefs" => "bjEf",
"bielle" => "bjEl",
"bielles" => "bjEl",
"bien" => "bj5",
"bien-aimé" => "bj5neme",
"bien-aimée" => "bj5neme",
"bien-aimées" => "bj5neme",
"bien-aimés" => "bj5neme",
"bien-disants" => "bj5diz@",
"bien-être" => "bj5nEtR",
"bien-fondé" => "bj5f§de",
"bien-fonds" => "bj5f§",
"bien-manger" => "bj5m@Ze",
"bien-pensant" => "bj5p@s@",
"bien-pensante" => "bj5p@s@t",
"bien-pensants" => "bj5p@s@",
"bien-portant" => "bj5pORt@",
"bien-portants" => "bj5pORt@",
"bienfaisance" => "bj5f°z@s",
"bienfaisant" => "bj5f°z@",
"bienfaisante" => "bj5f°z@t",
"bienfaisantes" => "bj@f°z@t",
"bienfaisants" => "bj@f°z@",
"bienfait" => "bj5fE",
"bienfaiteur" => "bj5fEt9R",
"bienfaiteurs" => "bj5fEt9R",
"bienfaitrice" => "bj5fEtRis",
"bienfaitrices" => "bj5fEtRis",
"bienfaits" => "bj5fE",
"bienheureuse" => "bj5n2R2z",
"bienheureusement" => "bj5n2R2z°m@",
"bienheureuses" => "bj5n2R2z",
"bienheureux" => "bj5n2R2",
"biennale" => "bjenal",
"biens" => "bj5",
"bienséance" => "bj5se@s",
"bienséances" => "bj5se@s",
"bienséant" => "bj5se@",
"bienséante" => "bj5se@t",
"bienséantes" => "bj5se@t",
"bienséants" => "bj5se@",
"bientôt" => "bj5to",
"bienveillamment" => "bj5vEjam@",
"bienveillance" => "bj5vEj@s",
"bienveillances" => "bj5vEj@s",
"bienveillant" => "bj5vEj@",
"bienveillante" => "bj5vEj@t",
"bienveillantes" => "bj5vEj@t",
"bienveillants" => "bj5vEj@",
"bienvenu" => "bj5v°ny",
"bienvenue" => "bj5v°ny",
"bienvenues" => "bj5v°ny",
"bienvenus" => "bj5v°ny",
"bière" => "bjER",
"bières" => "bjER",
"bif" => "bif",
"biface" => "bifas",
"bifaces" => "bifas",
"biffa" => "bifa",
"biffaient" => "bifE",
"biffais" => "bifE",
"biffant" => "bif@",
"biffe" => "bif",
"biffé" => "bife",
"biffer" => "bife",
"biffeton" => "bif°t§",
"biffetons" => "bif°t§",
"biffin" => "bif5",
"biffins" => "bif5",
"bifide" => "bifid",
"bifides" => "bifid",
"bifrons" => "bifR§",
"bifteck" => "biftEk",
"biftecks" => "biftEk",
"biftèque" => "biftEk",
"biftèques" => "biftEk",
"bifton" => "bift§",
"biftons" => "bift§",
"bifurcation" => "bifyRkasj§",
"bifurcations" => "bifyRkasj§",
"bifurqua" => "bifyRka",
"bifurquait" => "bifyRkE",
"bifurquant" => "bifyRk@",
"bifurque" => "bifyRk",
"bifurqué" => "bifyRke",
"bifurquée" => "bifyRke",
"bifurquent" => "bifyRk",
"bifurquer" => "bifyRke",
"bifurqueront" => "bifyRk°R§",
"big band" => "bigb@d",
"big bang" => "bigb@g",
"big-bang" => "bigb@g",
"bigaille" => "bigaj",
"bigame" => "bigam",
"bigamie" => "bigami",
"bigarré" => "bigaRe",
"bigarreau" => "bigaRo",
"bigarrée" => "bigaRe",
"bigarrées" => "bigaRe",
"bigarrer" => "bigaRe",
"bigarrés" => "bigaRe",
"bigarrure" => "bigaRyR",
"bigarrures" => "bigaRyR",
"bighorn" => "bigORn",
"bighorns" => "bigORn",
"biglaient" => "biglE",
"biglais" => "biglE",
"biglait" => "biglE",
"biglant" => "bigl@",
"bigle" => "bigl",
"biglé" => "bigle",
"biglée" => "bigle",
"biglent" => "bigl",
"bigler" => "bigle",
"bigles" => "bigl",
"biglés" => "bigle",
"bigleuse" => "bigl2z",
"bigleux" => "bigl2",
"biglez" => "bigle",
"bigne" => "biN",
"bignolait" => "biNolE",
"bignole" => "biNOl",
"bignoles" => "biNOl",
"bignolle" => "biNOl",
"bignon" => "biN§",
"bignones" => "biNOn",
"bignonias" => "biNoNa",
"bigo" => "bigo",
"bigophone" => "bigofOn",
"bigophoné" => "bigofone",
"bigophoner" => "bigofone",
"bigophones" => "bigofOn",
"bigorne" => "bigORn",
"bigorné" => "bigORne",
"bigorneau" => "bigORno",
"bigorneaux" => "bigORno",
"bigorner" => "bigORne",
"bigornes" => "bigORn",
"bigornés" => "bigORne",
"bigot" => "bigo",
"bigote" => "bigOt",
"bigoterie" => "bigOt°Ri",
"bigotes" => "bigOt",
"bigots" => "bigo",
"bigouden" => "bigudEn",
"bigoudens" => "bigudEn",
"bigoudi" => "bigudi",
"bigoudis" => "bigudi",
"bigre" => "bigR",
"bigrement" => "bigR°m@",
"bigue" => "big",
"biguine" => "bigin",
"bihebdomadaire" => "biEbdomadER",
"bihebdomadaires" => "biEbdomadER",
"bihoreau" => "bioRo",
"bijou" => "biZu",
"bijouterie" => "biZut°Ri",
"bijouteries" => "biZut°Ri",
"bijoutier" => "biZutje",
"bijoutière" => "biZutjER",
"bijoutiers" => "biZutje",
"bijoux" => "biZu",
"bikini" => "bikini",
"bikinis" => "bikini",
"bilais" => "bilE",
"bilait" => "bilE",
"bilan" => "bil@",
"bilans" => "bil@",
"bilatéral" => "bilateRal",
"bilatérale" => "bilateRal",
"bilatéralement" => "bilateRal°m@",
"bilatéraux" => "bilateRo",
"bilbergia" => "bilbERZja",
"bilboquet" => "bilbokE",
"bilboquets" => "bilbokE",
"bile" => "bil",
"biler" => "bile",
"biles" => "bil",
"bileux" => "bil2",
"bilez" => "bile",
"bilharziose" => "bilaRzjoz",
"biliaire" => "biljER",
"biliaires" => "biljER",
"bilieuse" => "bilj2z",
"bilieuses" => "bilj2z",
"bilieux" => "bilj2",
"bilingue" => "bil5g",
"bilingues" => "bil5g",
"bilinguisme" => "bil5g8izm",
"bilirubine" => "biliRybin",
"bill" => "bil",
"billard" => "bijaR",
"billards" => "bijaR",
"bille" => "bij",
"biller" => "bije",
"billes" => "bij",
"billet" => "bijE",
"billets" => "bijE",
"billetterie" => "bijEt°Ri",
"billetteries" => "bijEt°Ri",
"billettes" => "bijEt",
"billevesée" => "bil°v°ze",
"billevesées" => "bil°v°ze",
"billion" => "bilj§",
"billions" => "bilj§",
"billon" => "bij§",
"billot" => "bijo",
"billots" => "bijo",
"bills" => "bil",
"bilobée" => "bilObe",
"bim" => "bim",
"bimbeloterie" => "b5b°lOt°Ri",
"bimbeloteries" => "b5b°lOt°Ri",
"bimensuel" => "bim@s8El",
"bimensuelle" => "bim@s8El",
"bimensuelles" => "bim@s8El",
"bimestre" => "bimEstR",
"bimétallisme" => "bimetalizm",
"bimoteur" => "bimot9R",
"bimoteurs" => "bimot9R",
"bin's" => "bins",
"binaire" => "binER",
"binaires" => "binER",
"binait" => "binE",
"binant" => "bin@",
"biné" => "bine",
"biner" => "bine",
"binet-simon" => "binEsim§",
"binette" => "binEt",
"binettes" => "binEt",
"bing" => "biG",
"bingo" => "biGo",
"biniou" => "binju",
"binious" => "binju",
"binoclard" => "binoklaR",
"binoclarde" => "binoklaRd",
"binoclards" => "binoklaR",
"binocle" => "binOkl",
"binocles" => "binOkl",
"binoculaire" => "binokylER",
"binôme" => "binom",
"binômes" => "binom",
"bintje" => "bintS",
"binz" => "binz",
"bio" => "bjo",
"biochimie" => "bjoSimi",
"biochimique" => "bjoSimik",
"biochimiquement" => "bjoSimik°m@",
"biochimiques" => "bjoSimik",
"biochimiste" => "bjoSimist",
"biochimistes" => "bjoSimist",
"biodégradable" => "bjodegRadabl",
"biodégradables" => "bjodegRadabl",
"biodiversité" => "bjodivERsite",
"bioélectrique" => "bjoelEktRik",
"biogénétique" => "bjoZenetik",
"biogénique" => "bjoZenik",
"biographe" => "bjogRaf",
"biographes" => "bjogRaf",
"biographie" => "bjogRafi",
"biographies" => "bjogRafi",
"biographique" => "bjogRafik",
"biographiques" => "bjogRafik",
"biologie" => "bjoloZi",
"biologique" => "bjoloZik",
"biologiquement" => "bjoloZik°m@",
"biologiques" => "bjoloZik",
"biologisé" => "bjoloZize",
"biologiste" => "bjoloZist",
"biologistes" => "bjoloZist",
"bioluminescence" => "bjolymines@s",
"bioluminescente" => "bjolymines@t",
"biomasse" => "bjomas",
"biomécanique" => "bjomekanik",
"biomécanisme" => "bjomekanizm",
"biomédical" => "bjomedikal",
"biomédicale" => "bjomedikal",
"biomédicaux" => "bjomediko",
"biométrie" => "bjOmetRi",
"biométrique" => "bjometRik",
"biométriques" => "bjometRik",
"bionique" => "bjonik",
"bioniques" => "bjonik",
"biophysique" => "bjOfizik",
"biopsie" => "bjOpsi",
"biopsies" => "bjOpsi",
"biorythme" => "bjoRitm",
"biorythmes" => "bioRitm",
"biosphère" => "bjosfER",
"biosynthétiques" => "bjos5tetik",
"biotechnique" => "bjotEknik",
"biotechnologie" => "bjotEknoloZi",
"biotique" => "bjotik",
"biotite" => "bjOtit",
"biotope" => "bjotOp",
"bioxyde" => "bjOksid",
"bip" => "bip",
"bip-bip" => "bipbip",
"bipais" => "bipE",
"bipartisan" => "bipaRtiz@",
"bipartisme" => "bipaRtism",
"bipartite" => "bipaRtit",
"bipe" => "bip",
"bipé" => "bipe",
"bipède" => "bipEd",
"bipèdes" => "bipEd",
"bipée" => "bipe",
"biper" => "bipe",
"biperai" => "bip°RE",
"biperait" => "bip°RE",
"bipes" => "bip",
"bipés" => "bipe",
"bipez" => "bipe",
"biphényle" => "bifenil",
"biplace" => "biplas",
"biplaces" => "biplas",
"biplan" => "bipl@",
"biplans" => "bipl@",
"bipolaire" => "bipolER",
"bipolaires" => "bipolER",
"bipolarité" => "bipolaRite",
"bips" => "bip",
"bique" => "bik",
"biques" => "bik",
"biquet" => "bikE",
"biquets" => "bikE",
"biquette" => "bikEt",
"biquettes" => "bikEt",
"biquotidienne" => "bikotidjEn",
"biquotidiens" => "bikotidj5",
"birbe" => "biRb",
"birbes" => "biRb",
"birchers" => "biRSe",
"bire" => "biR",
"biréfringence" => "biRefR5Z@s",
"biribi" => "biRibi",
"birman" => "biRm@",
"birmane" => "biRman",
"birmanes" => "biRman",
"birmans" => "biRm@",
"biroute" => "biRut",
"biroutes" => "biRut",
"birth control" => "b9Rsk§tROl",
"bis" => "bis",
"bisaïeul" => "bizaj9l",
"bisaïeule" => "bizaj9l",
"bisannuel" => "bizan8El",
"bisannuelles" => "bizan8El",
"bisbille" => "bisbij",
"bisbilles" => "bisbij",
"biscaïen" => "biskaj5",
"bischof" => "biSOf",
"biscornu" => "biskORny",
"biscornue" => "biskORny",
"biscornues" => "biskORny",
"biscornus" => "biskORny",
"biscoteaux" => "biskoto",
"biscotos" => "biskoto",
"biscotte" => "biskOt",
"biscottes" => "biskOt",
"biscuit" => "bisk8i",
"biscuiterie" => "bisk8it°Ri",
"biscuits" => "bisk8i",
"bise" => "biz",
"biseau" => "bizo",
"biseauté" => "bizote",
"biseautée" => "bizote",
"biseautées" => "bizote",
"biseautés" => "bizote",
"biseaux" => "bizo",
"biseness" => "biznEs",
"biser" => "bize",
"bises" => "biz",
"bisets" => "bizE",
"bisette" => "bizEt",
"bisexualité" => "biseks8alite",
"bisexué" => "biseks8e",
"bisexuel" => "biseks8El",
"bisexuelle" => "biseks8El",
"bisexuelles" => "biseksyEl",
"bisexuels" => "biseksyEl",
"bisexués" => "biseksye",
"bishop" => "biSOp",
"bismarckien" => "bismaRkj5",
"bismuth" => "bismyt",
"bisness" => "biznEs",
"bison" => "biz§",
"bisons" => "biz§",
"bisou" => "bizu",
"bisou-éclair" => "bizueklER",
"bisous" => "bizu",
"bisque" => "bisk",
"bisquent" => "bisk",
"bisquer" => "biske",
"bisques" => "bisk",
"bissac" => "bisak",
"bissacs" => "bisak",
"bissant" => "bis@",
"bisse" => "bis",
"bissé" => "bise",
"bissel" => "bisEl",
"bisser" => "bise",
"bissextile" => "bisekstil",
"bissextiles" => "bisekstil",
"bistorte" => "bistORt",
"bistouille" => "bistuj",
"bistouquette" => "bistukEt",
"bistouri" => "bistuRi",
"bistouris" => "bistuRi",
"bistouriser" => "bistuRize",
"bistre" => "bistR",
"bistré" => "bistRe",
"bistrée" => "bistRe",
"bistrées" => "bistRe",
"bistres" => "bistR",
"bistrés" => "bistRe",
"bistro" => "bistRo",
"bistroquet" => "bistRokE",
"bistros" => "bistRo",
"bistrot" => "bistRo",
"bistrote" => "bistROt",
"bistrotier" => "bistRotje",
"bistrotière" => "bistRotjER",
"bistrotières" => "bistRotjER",
"bistrotiers" => "bistRotje",
"bistrots" => "bistRo",
"bistrouille" => "bistRuj",
"bisulfite" => "bisylfit",
"bit" => "bit",
"bite" => "bit",
"bité" => "bite",
"bitent" => "bit",
"bites" => "bit",
"bithynien" => "bitinj5",
"bithyniens" => "bitinj5",
"bitoniau" => "bitonjo",
"bitos" => "bitOs",
"bits" => "bit",
"bitte" => "bit",
"bitter" => "bitER",
"bitters" => "bit9R",
"bittes" => "bit",
"bitume" => "bitym",
"bitumé" => "bityme",
"bitumée" => "bityme",
"bitumées" => "bityme",
"bitumes" => "bitym",
"bitumeuse" => "bitym2z",
"bitumeux" => "bitym2",
"bitumineuse" => "bitymin2z",
"bitumineux" => "bitymin2",
"biture" => "bityR",
"bituré" => "bityRe",
"biturer" => "bityRe",
"bitures" => "bityR",
"biturés" => "bityRe",
"biturin" => "bityR5",
"biturins" => "bityR5",
"bivalente" => "bival@t",
"bivalve" => "bivalv",
"bivalves" => "bivalv",
"bivouac" => "bivwak",
"bivouacs" => "bivwak",
"bivouaquaient" => "bivwakE",
"bivouaquait" => "bivwakE",
"bivouaque" => "bivwak",
"bivouaqué" => "bivwake",
"bivouaquée" => "bivwake",
"bivouaquent" => "bivwak",
"bivouaquer" => "bivwake",
"bivouaquerons" => "bivuak°R§",
"bivouaquons" => "bivuak§",
"bizarde" => "bizaRd",
"bizarre" => "bizaR",
"bizarrement" => "bizaR°m@",
"bizarrerie" => "bizaR°Ri",
"bizarreries" => "bizaR°Ri",
"bizarres" => "bizaR",
"bizarroïde" => "bizaRoid",
"bizarroïdes" => "bizaRoid",
"bizness" => "biznEs",
"bizou" => "bizu",
"bizut" => "bizy",
"bizutage" => "bizytaZ",
"bizutages" => "bizytaZ",
"bizuté" => "bizyte",
"bizuter" => "bizyte",
"bizuteurs" => "bizyt9R",
"bizuth" => "bizy",
"bizuts" => "bizy",
"bla bla" => "blabla",
"bla-bla" => "blabla",
"bla-bla-bla" => "blablabla",
"blabla" => "blabla",
"blablabla" => "blablabla",
"blablatait" => "blablatE",
"blablaté" => "blablate",
"blablater" => "blablate",
"blablateurs" => "blablat9R",
"blablatez" => "blablate",
"black" => "blak",
"black-bass" => "blakbas",
"black-jack" => "blakdZak",
"black-out" => "blakaut",
"blackboule" => "blakbul",
"blackboulé" => "blakbule",
"blackbouler" => "blakbule",
"blacks" => "blak",
"blafard" => "blafaR",
"blafarde" => "blafaRd",
"blafardes" => "blafaRd",
"blafards" => "blafaR",
"blagua" => "blaga",
"blaguaient" => "blagE",
"blaguais" => "blagE",
"blaguait" => "blagE",
"blaguant" => "blag@",
"blague" => "blag",
"blagué" => "blage",
"blaguent" => "blag",
"blaguer" => "blage",
"blaguerais" => "blag°RE",
"blagues" => "blag",
"blagueur" => "blag9R",
"blagueurs" => "blag9R",
"blagueuse" => "blag2z",
"blagueuses" => "blag2z",
"blaguez" => "blage",
"blaguons" => "blag§",
"blair" => "blER",
"blairaient" => "blERE",
"blairait" => "blERE",
"blaire" => "blER",
"blairé" => "bleRe",
"blaireau" => "blERo",
"blaireaux" => "blERo",
"blairer" => "bleRe",
"blairs" => "blER",
"blaise" => "blEz",
"blaisois" => "blEzwa",
"blâma" => "blama",
"blâmable" => "blamabl",
"blâmaient" => "blamE",
"blâmais" => "blamE",
"blâmait" => "blamE",
"blâmant" => "blam@",
"blâme" => "blam",
"blâmé" => "blame",
"blâmée" => "blame",
"blâmées" => "blame",
"blâment" => "blam",
"blâmer" => "blame",
"blâmera" => "blam°Ra",
"blâmerais" => "blam°RE",
"blâmerait" => "blam°RE",
"blâmeras" => "blam°Ra",
"blâmerions" => "blam°Rj§",
"blâmeront" => "blam°R§",
"blâmes" => "blam",
"blâmés" => "blame",
"blâmez" => "blame",
"blâmons" => "blam§",
"blanc" => "bl@",
"blanc-bec" => "bl@bEk",
"blanc-bleu" => "bl@bl2",
"blanc-gris" => "bl@gRi",
"blanc-seing" => "bl@s5",
"blanchâtre" => "bl@SatR",
"blanchâtres" => "bl@SatR",
"blanche" => "bl@S°",
"blanchecaille" => "bl@Skaj",
"blanchecailles" => "bl@Skaj",
"blanchement" => "bl@S°m@",
"blanches" => "bl@S",
"blanchet" => "bl@SE",
"blancheur" => "bl@S9R",
"blancheurs" => "bl@S9R",
"blanchi" => "bl@Si",
"blanchie" => "bl@Si",
"blanchies" => "bl@Si",
"blanchiment" => "bl@Sim@",
"blanchiments" => "bl@Sim@",
"blanchir" => "bl@SiR",
"blanchira" => "bl@SiRa",
"blanchiraient" => "bl@SiRE",
"blanchirait" => "bl@SiRE",
"blanchirent" => "bl@SiR",
"blanchirez" => "bl@SiRe",
"blanchiront" => "bl@SiR§",
"blanchis" => "bl@Si",
"blanchissage" => "bl@SisaZ",
"blanchissaient" => "bl@SisE",
"blanchissait" => "bl@SisE",
"blanchissant" => "bl@Sis@",
"blanchissante" => "bl@Sis@t",
"blanchissantes" => "bl@Sis@t",
"blanchissants" => "bl@Sis@",
"blanchisse" => "bl@Sis",
"blanchissement" => "bl@Sis°m@",
"blanchissent" => "bl@Sis",
"blanchisserie" => "bl@Sis°Ri",
"blanchisses" => "bl@Sis",
"blanchisseur" => "bl@Sis9R",
"blanchisseurs" => "bl@Sis9R",
"blanchisseuse" => "bl@Sis2z",
"blanchisseuses" => "bl@Sis2z",
"blanchissez" => "bl@Sise",
"blanchit" => "bl@Si",
"blanchoie" => "bl@Swa",
"blanchoiement" => "bl@Swam@",
"blanchon" => "bl@S§",
"blanchoyait" => "bl@SwajE",
"blanchoyant" => "bl@Swaj@",
"blancs" => "bl@",
"blancs-becs" => "bl@bEk",
"blancs-manteaux" => "bl@m@to",
"blandices" => "bl@dis",
"blanque" => "bl@k",
"blanquette" => "bl@kEt",
"blanquettes" => "bl@kEt",
"blasait" => "blazE",
"blase" => "blaz",
"blasé" => "blaze",
"blasée" => "blaze",
"blasées" => "blaze",
"blaser" => "blaze",
"blases" => "blaz",
"blasés" => "blaze",
"blason" => "blaz§",
"blasonnait" => "blazonE",
"blasonné" => "blazone",
"blasonnée" => "blazone",
"blasonnées" => "blazone",
"blasonnés" => "blazone",
"blasons" => "blaz§",
"blasphéma" => "blasfema",
"blasphémaient" => "blasfemE",
"blasphémais" => "blasfemE",
"blasphémait" => "blasfemE",
"blasphémant" => "blasfem@",
"blasphémateur" => "blasfemat9R",
"blasphémateurs" => "blasfemat9R",
"blasphématoire" => "blasfematwaR",
"blasphématoires" => "blasfematwaR",
"blasphématrice" => "blasfematRis",
"blasphème" => "blasfEm",
"blasphémé" => "blasfeme",
"blasphèment" => "blasfEm",
"blasphémer" => "blasfeme",
"blasphèmes" => "blasfEm",
"blasphémez" => "blasfeme",
"blastula" => "blastyla",
"blatérant" => "blateR@",
"blatte" => "blat",
"blattes" => "blat",
"blaze" => "blaz",
"blazer" => "blazER",
"blazers" => "blazER",
"blazes" => "blaz",
"blé" => "ble",
"blèche" => "blES",
"blèches" => "blES",
"bled" => "blEd",
"blédard" => "bledaR",
"blédards" => "bledaR",
"bleds" => "blEd",
"blême" => "blEm",
"blêmes" => "blEm",
"blêmi" => "blEmi",
"blêmies" => "blEmi",
"blêmir" => "blemiR",
"blêmis" => "blEmi",
"blêmissais" => "blEmisE",
"blêmissait" => "blEmisE",
"blêmissant" => "blEmis@",
"blêmissante" => "blEmis@t",
"blêmit" => "blEmi",
"blennies" => "blEni",
"blennorragie" => "blenoRaZi",
"blépharite" => "blefaRit",
"blés" => "ble",
"blèsement" => "blEzm@",
"blessa" => "blEsa",
"blessaient" => "blEsE",
"blessais" => "blEsE",
"blessait" => "blEsE",
"blessant" => "blEs@",
"blessante" => "blEs@t",
"blessantes" => "blEs@t",
"blessants" => "blEs@",
"blessât" => "blEsa",
"blesse" => "blEs",
"blessé" => "blese",
"blessée" => "blese",
"blessées" => "blese",
"blessent" => "blEs",
"blesser" => "blese",
"blessera" => "blEs°Ra",
"blesserai" => "blEs°RE",
"blesseraient" => "blEs°RE",
"blesserais" => "blEs°RE",
"blesserait" => "blEs°RE",
"blesseras" => "blEs°Ra",
"blessèrent" => "blEsER",
"blesserez" => "blEs°Re",
"blesseriez" => "blEs°Rje",
"blesserons" => "blEs°R§",
"blesseront" => "blEs°R§",
"blesses" => "blEs",
"blessés" => "blese",
"blessez" => "blEse",
"blessiez" => "blEsje",
"blessing" => "blEsiG",
"blessure" => "blesyR",
"blessures" => "blesyR",
"blet" => "blE",
"blets" => "blE",
"blette" => "blEt",
"blettes" => "blEt",
"blettir" => "bletiR",
"blettissait" => "blEtisE",
"blettissement" => "bletis°m@",
"bleu" => "bl2",
"bleu-ciel" => "bl2sjEl",
"bleu-noir" => "bl2nwaR",
"bleu-roi" => "bl2Rwa",
"bleu-vert" => "bl2vER",
"bleuâtre" => "bl2atR",
"bleuâtres" => "bl9atR",
"bleubite" => "bl9bit",
"bleubites" => "bl9bit",
"bleue" => "bl2",
"bleues" => "bl2",
"bleuet" => "bl2E",
"bleuets" => "bl2E",
"bleuette" => "bl2Et",
"bleui" => "bl2i",
"bleuie" => "bl2i",
"bleuies" => "bl2i",
"bleuir" => "bl2iR",
"bleuira" => "bl9iRa",
"bleuis" => "bl9i",
"bleuissaient" => "bl9isE",
"bleuissait" => "bl9isE",
"bleuissante" => "bl9is@t",
"bleuissantes" => "bl9is@t",
"bleuissent" => "bl9is",
"bleuit" => "bl9i",
"bleuît" => "bl9i",
"bleus" => "bl2",
"bleusaille" => "bl2zaj",
"bleusailles" => "bl2zaj",
"bleuté" => "bl2te",
"bleutée" => "bl2te",
"bleutées" => "bl2te",
"bleutés" => "bl2te",
"bliaut" => "blijo",
"blindage" => "bl5daZ",
"blindages" => "bl5daZ",
"blindant" => "bl5d@",
"blinde" => "bl5d",
"blindé" => "bl5de",
"blindée" => "bl5de",
"blindées" => "bl5de",
"blindent" => "bl5d",
"blinder" => "bl5de",
"blindera" => "bl5d°Ra",
"blindes" => "bl5d",
"blindés" => "bl5de",
"blindez" => "bl5de",
"blini" => "blini",
"blinis" => "blinis",
"blitzkrieg" => "blitskRik",
"blizzard" => "blizaR",
"blizzards" => "blizaR",
"blob" => "blOb",
"bloc" => "blOk",
"bloc-cylindres" => "blOksil5dR",
"bloc-moteur" => "blOkmot9R",
"bloc-notes" => "blOknOt",
"blocage" => "blokaZ",
"blocages" => "blokaZ",
"blocaille" => "blokaj",
"block" => "blOk",
"blockhaus" => "blOkos",
"blocks" => "blOk",
"blocs" => "blOk",
"blocs-notes" => "blOknOt",
"blocus" => "blokys",
"blond" => "bl§",
"blondasse" => "bl§das",
"blondasses" => "bl§das",
"blonde" => "bl§d",
"blondes" => "bl§d",
"blondeur" => "bl§d9R",
"blondeurs" => "bl§d9R",
"blondi" => "bl§di",
"blondie" => "bl§di",
"blondin" => "bl§d5",
"blondine" => "bl§din",
"blondines" => "bl§din",
"blondinet" => "bl§dinE",
"blondinets" => "bl§dinE",
"blondinette" => "bl§dinEt",
"blondir" => "bl§diR",
"blondis" => "bl§di",
"blondissait" => "bl§disE",
"blondit" => "bl§di",
"blonds" => "bl§",
"bloody mary" => "blOdimaRi",
"bloom" => "blum",
"bloomer" => "blume",
"bloqua" => "bloka",
"bloquai" => "blokE",
"bloquaient" => "blokE",
"bloquais" => "blokE",
"bloquait" => "blokE",
"bloquant" => "blok@",
"bloquât" => "bloka",
"bloque" => "blOk",
"bloqué" => "bloke",
"bloquée" => "bloke",
"bloquées" => "bloke",
"bloquent" => "blOk",
"bloquer" => "bloke",
"bloquera" => "blOk°Ra",
"bloquerai" => "blOk°RE",
"bloquerais" => "blOk°RE",
"bloquerait" => "blOk°RE",
"bloquèrent" => "blokER",
"bloqueront" => "blOk°R§",
"bloques" => "blOk",
"bloqués" => "bloke",
"bloqueur" => "blok9R",
"bloqueurs" => "blok9R",
"bloquez" => "bloke",
"bloquiez" => "blokje",
"bloquons" => "blok§",
"blot" => "blo",
"blots" => "blo",
"blotti" => "bloti",
"blottie" => "bloti",
"blotties" => "bloti",
"blottir" => "blotiR",
"blottirai" => "blotiRE",
"blottirait" => "blotiRE",
"blottirent" => "blotiR",
"blottis" => "bloti",
"blottissaient" => "blotisE",
"blottissais" => "blotisE",
"blottissait" => "blotisE",
"blottissant" => "blotis@",
"blottisse" => "blotis",
"blottissement" => "blOtis°m@",
"blottissent" => "blotis",
"blottissions" => "blotisj§",
"blottit" => "bloti",
"bloum" => "blum",
"blousantes" => "bluz@t",
"blouse" => "bluz",
"blousé" => "bluze",
"blousée" => "bluze",
"blousent" => "bluz",
"blouser" => "bluze",
"blouses" => "bluz",
"blousés" => "bluze",
"blouson" => "bluz§",
"blousons" => "bluz§",
"blue jeans" => "bludZins",
"blue note" => "blunOt",
"blue-jean" => "bludZin",
"blue-jeans" => "bludZins",
"blues" => "bluz",
"bluets" => "blyE",
"bluette" => "blyEt",
"bluettes" => "blyEt",
"bluff" => "bl9f",
"bluffa" => "bl9fa",
"bluffaient" => "bl9fE",
"bluffais" => "bl9fE",
"bluffait" => "bl9fE",
"bluffant" => "bl9f@",
"bluffe" => "bl9f",
"bluffé" => "bl9fe",
"bluffée" => "bl9fe",
"bluffées" => "bl9fe",
"bluffent" => "bl9f",
"bluffer" => "bl9fe",
"blufferais" => "bl9f°RE",
"blufferez" => "bl9f°Re",
"bluffes" => "bl9f",
"bluffés" => "bl9fe",
"bluffeur" => "bl9f9R",
"bluffeurs" => "bl9f9R",
"bluffeuses" => "bl9f2z",
"bluffez" => "bl9fe",
"bluffiez" => "bl9fje",
"bluffons" => "bl9f§",
"bluffs" => "bl9f",
"blush" => "bl9S",
"bluter" => "blyte",
"blutoir" => "blytwaR",
"boa" => "boa",
"boas" => "boa",
"boat people" => "bOwtpip9l",
"bob" => "bOb",
"bobard" => "bobaR",
"bobards" => "bobaR",
"bobbies" => "bobi",
"bobby" => "bobi",
"bobèche" => "bobES",
"bobèches" => "bobES",
"bobinage" => "bobinaZ",
"bobinait" => "bobinE",
"bobinard" => "bobinaR",
"bobinards" => "bobinaR",
"bobine" => "bobin",
"bobineau" => "bobino",
"bobines" => "bobin",
"bobinette" => "bobinEt",
"bobinettes" => "bobinEt",
"bobineuse" => "bobin2z",
"bobineuses" => "bobin2z",
"bobino" => "bobino",
"bobo" => "bobo",
"bobonne" => "bobOn",
"bobonnes" => "bobOn",
"bobos" => "bobo",
"bobosse" => "bobOs",
"bobs" => "bOb",
"bobsleigh" => "bObslEg",
"boc" => "bOk",
"bocage" => "bokaZ",
"bocagères" => "bokaZER",
"bocages" => "bokaZ",
"bocal" => "bokal",
"bocard" => "bokaR",
"bocaux" => "boko",
"boche" => "bOS",
"boches" => "bOS",
"bochiman" => "boSim@",
"bock" => "bOk",
"bocks" => "bOk",
"bocson" => "bOks§",
"bodega" => "bod°ga",
"bodegas" => "bod°ga",
"bodhi" => "bOdi",
"bodhisattva" => "bodizatva",
"bodo" => "bodo",
"body" => "bOdi",
"body-building" => "bOdibildiG",
"bodybuilding" => "bOdibildiG",
"boer" => "b9R",
"boers" => "beR",
"boëttes" => "boEt",
"boeuf" => "b9f",
"boeufs" => "b2",
"bof" => "bOf",
"boggie" => "bOgi",
"boggies" => "bOgi",
"boghei" => "bogEj",
"bogie" => "bOZi",
"bogomiles" => "bogomil",
"bogue" => "bOg",
"boguer" => "boge",
"bogues" => "bOg",
"boguet" => "bOgE",
"bohème" => "boEm",
"bohême" => "boEm",
"bohèmes" => "boEm",
"bohémien" => "boemj5",
"bohémienne" => "boemjEn",
"bohémiennes" => "boemjEn",
"bohémiens" => "boemj5",
"boira" => "bwaRa",
"boirai" => "bwaRE",
"boiraient" => "bwaRE",
"boirais" => "bwaRE",
"boirait" => "bwaRE",
"boiras" => "bwaRa",
"boire" => "bwaR",
"boirez" => "bwaRe",
"boiriez" => "bwaRje",
"boirions" => "bwaRj§",
"boirons" => "bwaR§",
"boiront" => "bwaR§",
"bois" => "bwa",
"boisaient" => "bwazE",
"boisait" => "bwazE",
"boisant" => "bwaz@",
"boise" => "bwaz",
"boisé" => "bwaze",
"boisée" => "bwaze",
"boisées" => "bwaze",
"boiserie" => "bwaz°Ri",
"boiseries" => "bwaz°Ri",
"boisés" => "bwaze",
"boiseur" => "bwaz9R",
"boisseau" => "bwaso",
"boisseaux" => "bwaso",
"boisselier" => "bwas2lje",
"boisson" => "bwas§",
"boissonnée" => "bwasone",
"boissons" => "bwas§",
"boit" => "bwa",
"boitaient" => "bwatE",
"boitais" => "bwatE",
"boitait" => "bwatE",
"boitant" => "bwat@",
"boite" => "bwat",
"boîte" => "bwat",
"boité" => "bwate",
"boitement" => "bwat°m@",
"boitent" => "bwat",
"boiter" => "bwate",
"boitera" => "bwat°Ra",
"boiterai" => "bwat°RE",
"boiteraient" => "bwat°RE",
"boiterait" => "bwat°RE",
"boiteras" => "bwat°Ra",
"boiterie" => "bwat°Ri",
"boites" => "bwat",
"boîtes" => "bwat",
"boîtes-repas" => "bwatR°pa",
"boiteuse" => "bwat2z",
"boiteuses" => "bwat2z",
"boiteux" => "bwat2",
"boitez" => "bwate",
"boîtier" => "bwatje",
"boîtiers" => "bwatje",
"boitiez" => "bwatje",
"boitillait" => "bwatijE",
"boitillant" => "bwatij@",
"boitille" => "bwatij",
"boitillement" => "bwatij°m@",
"boitillements" => "bwatij°m@",
"boitiller" => "bwatije",
"boive" => "bwav",
"boivent" => "bwav",
"boives" => "bwav",
"bol" => "bOl",
"bola" => "bola",
"bolas" => "bola",
"bolchevik" => "bOlS°vik",
"bolcheviks" => "bOlS°vik",
"bolchevique" => "bOlS°vik",
"bolcheviques" => "bOlS°vik",
"bolchevisme" => "bOlS°vizm",
"bolcheviste" => "bOlS°vist",
"bolchevistes" => "bOlS°vist",
"bolcho" => "bOlSo",
"bold" => "bOld",
"boldo" => "bOldo",
"bolduc" => "bOldyk",
"bolée" => "bole",
"bolées" => "bole",
"boléro" => "boleRo",
"boléros" => "boleRo",
"bolet" => "bolE",
"bolets" => "bolE",
"bolge" => "bOlZ",
"bolide" => "bolid",
"bolides" => "bolid",
"bolivar" => "bolivaR",
"bolivien" => "bOlivj5",
"bolivienne" => "bolivjEn",
"boliviens" => "bolivj5",
"bolognais" => "boloNE",
"bolognaise" => "boloNEz",
"bolognaises" => "boloNEz",
"bolonaise" => "bolonEz",
"bols" => "bOl",
"bomba" => "b§ba",
"bombage" => "b§baZ",
"bombaient" => "b§bE",
"bombais" => "b§bE",
"bombait" => "b§bE",
"bombance" => "b§b@s",
"bombances" => "b§b@s",
"bombant" => "b§b@",
"bombarda" => "b§baRda",
"bombardaient" => "b§baRdE",
"bombardais" => "b§baRdE",
"bombardait" => "b§baRdE",
"bombardâmes" => "b§baRdam",
"bombardant" => "b§baRd@",
"bombarde" => "b§baRd",
"bombardé" => "b§baRde",
"bombardée" => "b§baRde",
"bombardées" => "b§baRde",
"bombardement" => "b§baRd°m@",
"bombardements" => "b§baRd°m@",
"bombardent" => "b§baRd",
"bombarder" => "b§baRde",
"bombardera" => "b§baRd°Ra",
"bombarderai" => "b§baRd°RE",
"bombarderaient" => "b§baRd°RE",
"bombarderais" => "b§baRd°RE",
"bombarderait" => "b§baRd°RE",
"bombardèrent" => "b§baRdER",
"bombarderons" => "b§baRd°R§",
"bombarderont" => "b§baRd°R§",
"bombardes" => "b§baRd",
"bombardés" => "b§baRde",
"bombardez" => "b§baRde",
"bombardier" => "b§baRdje",
"bombardiers" => "b§baRdje",
"bombardions" => "b§baRdj§",
"bombardon" => "b§baRd§",
"bombardons" => "b§baRd§",
"bombas" => "b§ba",
"bombasses" => "b§bas",
"bombe" => "b§b",
"bombé" => "b§be",
"bombée" => "b§be",
"bombées" => "b§be",
"bombements" => "b§b°m@",
"bombent" => "b§b",
"bomber" => "b§be",
"bombèrent" => "b§bER",
"bombes" => "b§b",
"bombés" => "b§be",
"bombes-test" => "b§btEst",
"bombeur" => "b§b9R",
"bombez" => "b§be",
"bombillement" => "b§bij°m@",
"bombinette" => "b§binEt",
"bombinettes" => "b§binEt",
"bombonne" => "b§bOn",
"bombonnes" => "b§bOn",
"bombyx" => "b§biks",
"bôme" => "bom",
"bon" => "b§",
"bon-papa" => "b§papa",
"bonace" => "bonas",
"bonaces" => "bonas",
"bonapartiste" => "bonapaRtist",
"bonapartistes" => "bonapaRtist",
"bonard" => "bonaR",
"bonardes" => "bonaRd",
"bonasse" => "bonas",
"bonassement" => "bonas°m@",
"bonasserie" => "bonas°Ri",
"bonasses" => "bonas",
"bonbon" => "b§b§",
"bonbonne" => "b§bOn",
"bonbonnes" => "b§bOn",
"bonbonnière" => "b§bonjER",
"bonbonnières" => "b§bonjER",
"bonbons" => "b§b§",
"bond" => "b§",
"bondage" => "b§daZ",
"bondages" => "b§daZ",
"bondait" => "b§dE",
"bonde" => "b§d",
"bondé" => "b§de",
"bondée" => "b§de",
"bondées" => "b§de",
"bonder" => "b§de",
"bondes" => "b§d",
"bondés" => "b§de",
"bondi" => "b§di",
"bondieusard" => "b§dj2zaR",
"bondieuserie" => "b§dj2z°Ri",
"bondieuseries" => "b§dj2z°Ri",
"bondieuses" => "b§dj2z",
"bondir" => "b§diR",
"bondira" => "b§diRa",
"bondirais" => "b§diRE",
"bondirait" => "b§diRE",
"bondirent" => "b§diR",
"bondis" => "b§di",
"bondissaient" => "b§disE",
"bondissais" => "b§disE",
"bondissait" => "b§disE",
"bondissant" => "b§dis@",
"bondissante" => "b§dis@t",
"bondissantes" => "b§dis@t",
"bondissants" => "b§dis@",
"bondisse" => "b§dis",
"bondissement" => "b§dis°m@",
"bondissements" => "b§dis°m@",
"bondissent" => "b§dis",
"bondissez" => "b§dise",
"bondissons" => "b§dis§",
"bondit" => "b§di",
"bondît" => "b§di",
"bondrée" => "b§dRe",
"bonds" => "b§",
"bongo" => "b§go",
"bongos" => "b§go",
"bonheur" => "bon9R",
"bonheur-du-jour" => "bon9RdyZuR",
"bonheurs" => "bon9R",
"bonheurs-du-jour" => "bon9RdyZuR",
"bonhomie" => "bonomi",
"bonhomme" => "bonOm",
"bonhommes" => "bonOm",
"boni" => "boni",
"boniche" => "boniS",
"boniches" => "boniS",
"bonifiaient" => "bonifjE",
"bonification" => "bonifikasj§",
"bonifié" => "bonifje",
"bonifiée" => "bonifje",
"bonifier" => "bonifje",
"bonifierait" => "bonifiRE",
"bonifiez" => "bonifje",
"boniment" => "bonim@",
"bonimentait" => "bonim@tE",
"bonimente" => "bonim@t",
"bonimenter" => "bonim@te",
"bonimenteur" => "bonim@t9R",
"bonimenteurs" => "bonim@t9R",
"boniments" => "bonim@",
"bonir" => "boniR",
"bonis" => "boni",
"bonissait" => "bonisE",
"bonisse" => "bonis",
"bonit" => "boni",
"bonjour" => "b§ZuR",
"bonjours" => "b§ZuR",
"bonnard" => "bonaR",
"bonnarde" => "bonaRd",
"bonnardes" => "bonaRd",
"bonnards" => "bonaR",
"bonne" => "bOn",
"bonne-maman" => "bOnmam@",
"bonnement" => "bOn°m@",
"bonnes" => "bOn",
"bonnet" => "bonE",
"bonneteau" => "bOn°to",
"bonneter" => "bOnEte",
"bonneterie" => "bonEt°Ri",
"bonneteries" => "bonEt°Ri",
"bonneteur" => "bOn°t9R",
"bonneteurs" => "bOn°t9R",
"bonnets" => "bonE",
"bonnette" => "bOnEt",
"bonnettes" => "bonEt",
"bonni" => "boni",
"bonniche" => "boniS",
"bonniches" => "boniS",
"bonnie" => "boni",
"bonnir" => "boniR",
"bonnis" => "boni",
"bonnisse" => "bonis",
"bonnissent" => "bonis",
"bonnit" => "boni",
"bons" => "b§",
"bons-cadeaux" => "b§kado",
"bons-chrétiens" => "b§kRetj5",
"bonsaï" => "b§zaj",
"bonsaïs" => "b§zaj",
"bonshommes" => "b§zOm",
"bonsoir" => "b§swaR",
"bonsoirs" => "b§swaR",
"bonté" => "b§te",
"bontés" => "b§te",
"bonus" => "bonys",
"bonzaï" => "b§zaj",
"bonze" => "b§z",
"bonzes" => "b§z",
"boogie-woogie" => "bugiwugi",
"book" => "buk",
"bookmaker" => "bukmEk9R",
"bookmakers" => "bukmEk9R",
"books" => "buk",
"boom" => "bum",
"boomer" => "bum9R",
"boomerang" => "bum°R@g",
"booms" => "bum",
"booster" => "buste",
"boosters" => "bust9R",
"bootlegger" => "butleg9R",
"bootleggers" => "butleg9R",
"boots" => "buts",
"bop" => "bOp",
"boqueteau" => "bOk°to",
"boqueteaux" => "bOk°to",
"boquillons" => "bokij§",
"bora" => "boRa",
"borax" => "boRaks",
"borborygme" => "bORboRigm",
"borborygmes" => "bORboRigm",
"borchtch" => "bORtS",
"bord" => "bOR",
"borda" => "bORda",
"bordage" => "bORdaZ",
"bordages" => "bORdaZ",
"bordai" => "bORdE",
"bordaient" => "bORdE",
"bordait" => "bORdE",
"bordant" => "bORd@",
"borde" => "bORd",
"bordé" => "bORde",
"bordeau" => "bORdo",
"bordeaux" => "bORdo",
"bordée" => "bORde",
"bordées" => "bORde",
"bordel" => "bORdEl",
"bordelais" => "bORd°lE",
"bordelaise" => "bORd°lEz",
"bordelaises" => "bORd°lEz",
"bordelières" => "bORd°ljER",
"bordélique" => "bORdelik",
"bordéliques" => "bORdelik",
"bordéliser" => "bORdelize",
"bordels" => "bORdEl",
"bordent" => "bORd",
"border" => "bORde",
"bordera" => "bORd°Ra",
"borderait" => "bORd°RE",
"bordereau" => "bORd°Ro",
"bordereaux" => "bORd°Ro",
"bordèrent" => "bORdER",
"borderie" => "bORd2Ri",
"borderiez" => "bORd°Rje",
"borderline" => "bORdERlin",
"bordes" => "bORd",
"bordés" => "bORde",
"bordez" => "bORde",
"bordier" => "bORdje",
"bordille" => "bORdij",
"bordj" => "bORdZ",
"bords" => "bOR",
"bordurant" => "bORdyR@",
"bordure" => "bORdyR",
"borduré" => "bORdyRe",
"bordurée" => "bORdyRe",
"bordurer" => "bORdyRe",
"bordures" => "bORdyR",
"bore" => "bOR",
"boréal" => "boReal",
"boréale" => "boReal",
"boréales" => "boReal",
"borée" => "bORe",
"borgne" => "bORN",
"borgnes" => "bORN",
"borgnotaient" => "bORNotE",
"borgnotant" => "bORNot@",
"borgnote" => "bORNOt",
"borgnoté" => "bORNote",
"borie" => "boRi",
"borique" => "bORik",
"borna" => "bORna",
"bornage" => "bORnaZ",
"bornages" => "bORnaZ",
"bornai" => "bORnE",
"bornaient" => "bORnE",
"bornais" => "bORnE",
"bornait" => "bORnE",
"bornant" => "bORn@",
"bornât" => "bORna",
"borne" => "bORn",
"borné" => "bORne",
"borne-fontaine" => "bORnf§tEn",
"bornée" => "bORne",
"bornées" => "bORne",
"bornent" => "bORn",
"borner" => "bORne",
"bornera" => "bORn°Ra",
"bornerai" => "bORn°RE",
"borneraient" => "bORn°RE",
"bornerait" => "bORn°RE",
"bornèrent" => "bORnER",
"bornerons" => "bORn°R§",
"bornes" => "bORn",
"bornés" => "bORne",
"bornes-fontaines" => "bORnf§tEn",
"bornez" => "bORne",
"bornions" => "bORnj§",
"borough" => "boRO",
"borsalino" => "bORsalino",
"bortch" => "bORtS",
"bortsch" => "bORtS",
"bosco" => "bOsko",
"boscotte" => "bOskOt",
"boskoop" => "bOskup",
"bosniaque" => "bOsnjak",
"bosniaques" => "bOsnjak",
"bosnien" => "bOsnj5",
"bosquet" => "bOskE",
"bosquets" => "bOskE",
"boss" => "bOs",
"bossa" => "bosa",
"bossa-nova" => "bosanova",
"bossage" => "bosaZ",
"bossaient" => "bosE",
"bossais" => "bosE",
"bossait" => "bosE",
"bossant" => "bos@",
"bosse" => "bOs",
"bossé" => "bose",
"bossela" => "bOs°la",
"bosselaient" => "bOs°lE",
"bosselait" => "bOs°lE",
"bosselé" => "bOs°le",
"bosselée" => "bOs°le",
"bosselées" => "bOs°le",
"bosseler" => "bOs°le",
"bosselés" => "bOs°le",
"bossellement" => "bosEl°m@",
"bossellements" => "bosEl°m@",
"bosselure" => "bOs°lyR",
"bossent" => "bOs",
"bosser" => "bose",
"bossera" => "bOs°Ra",
"bosserai" => "bOs°RE",
"bosserais" => "bOs°RE",
"bosserait" => "bOs°RE",
"bosseras" => "bOs°Ra",
"bosserez" => "bOs°Re",
"bosses" => "bOs",
"bosseur" => "bos9R",
"bosseurs" => "bos9R",
"bosseuse" => "bos2z",
"bossez" => "bose",
"bossiez" => "bosje",
"bossions" => "bosj§",
"bossoir" => "boswaR",
"bossoirs" => "boswaR",
"bosson" => "bos§",
"bossons" => "bos§",
"bossu" => "bosy",
"bossuaient" => "bos8E",
"bossue" => "bosy",
"bossué" => "bos8e",
"bossuée" => "bos8e",
"bossuées" => "bos8e",
"bossues" => "bosy",
"bossués" => "bos8e",
"bossus" => "bosy",
"boston" => "bOstOn",
"bostonien" => "bOstonj5",
"bostonienne" => "bOstonjEn",
"bostoniens" => "bOstonj5",
"bostonner" => "bOstone",
"bot" => "bo",
"botanique" => "botanik",
"botaniquement" => "bOtanik°m@",
"botaniques" => "botanik",
"botaniste" => "botanist",
"botanistes" => "botanist",
"bote" => "bOt",
"botta" => "bota",
"bottai" => "botE",
"bottaient" => "botE",
"bottait" => "botE",
"bottant" => "bot@",
"botte" => "bOt",
"botté" => "bote",
"bottée" => "bote",
"bottées" => "bote",
"bottelé" => "bOt°le",
"bottelées" => "bOt°le",
"botteler" => "bOt°le",
"bottellent" => "botEl",
"bottent" => "bOt",
"botter" => "bote",
"bottera" => "bOt°Ra",
"botterai" => "bOt°RE",
"botterais" => "bOt°RE",
"botterait" => "bOt°RE",
"botteras" => "bOt°Ra",
"botterons" => "bOt°R§",
"botteront" => "bOt°R§",
"bottes" => "bOt",
"bottés" => "bote",
"botteur" => "bot9R",
"botteurs" => "bot9R",
"bottez" => "bote",
"botticellienne" => "botisEljEn",
"bottier" => "botje",
"bottiers" => "botje",
"bottiez" => "botje",
"bottillon" => "botij§",
"bottillons" => "botij§",
"bottin" => "bot5",
"bottine" => "botin",
"bottiné" => "botine",
"bottines" => "botin",
"bottins" => "bot5",
"bottons" => "bot§",
"botulique" => "bOtylik",
"botulisme" => "botylizm°",
"boubou" => "bubu",
"bouboule" => "bubul",
"bouboules" => "bubul",
"boubous" => "bubu",
"bouc" => "buk",
"boucan" => "buk@",
"boucanait" => "bukanE",
"boucané" => "bukane",
"boucanée" => "bukane",
"boucanées" => "bukane",
"boucaner" => "bukane",
"boucanerie" => "bukan°Ri",
"boucanés" => "bukane",
"boucanier" => "bukanje",
"boucaniers" => "bukanje",
"boucha" => "buSa",
"bouchage" => "buSaZ",
"bouchai" => "buSE",
"bouchaient" => "buSE",
"bouchais" => "buSE",
"bouchait" => "buSE",
"bouchant" => "buS@",
"bouchardant" => "buSaRd@",
"boucharde" => "buSaRd",
"boucharder" => "buSaRde",
"bouche" => "buS",
"bouché" => "buSe",
"bouche-à-bouche" => "buSabuS",
"bouche-à-oreille" => "buSaoREj",
"bouche-trou" => "buStRu",
"bouche-trous" => "buStRu",
"bouchée" => "buSe",
"bouchées" => "buSe",
"bouchent" => "buS",
"boucher" => "buSe",
"bouchera" => "buS°Ra",
"boucheraient" => "buS°RE",
"boucherais" => "buS°RE",
"boucherait" => "buS°RE",
"boucheras" => "buS°Ra",
"bouchère" => "buSER",
"bouchèrent" => "buSER",
"bouchères" => "buSER",
"boucherie" => "buS°Ri",
"boucheries" => "buS°Ri",
"boucherons" => "buS°R§",
"bouchers" => "buSe",
"bouches" => "buS",
"bouchés" => "buSe",
"bouchez" => "buSe",
"bouchions" => "buSj§",
"bouchon" => "buS§",
"bouchonna" => "buSona",
"bouchonnaient" => "buSonE",
"bouchonnait" => "buSonE",
"bouchonnant" => "buSon@",
"bouchonne" => "buSOn",
"bouchonné" => "buSone",
"bouchonnée" => "buSone",
"bouchonner" => "buSone",
"bouchonneras" => "buSOn°Ra",
"bouchons" => "buS§",
"bouchot" => "buSo",
"bouchoteurs" => "buSot9R",
"bouchots" => "buSo",
"bouchure" => "buSyR",
"boucla" => "bukla",
"bouclage" => "buklaZ",
"bouclaient" => "buklE",
"bouclais" => "buklE",
"bouclait" => "buklE",
"bouclâmes" => "buklam",
"bouclant" => "bukl@",
"bouclât" => "bukla",
"boucle" => "bukl",
"bouclé" => "bukle",
"bouclée" => "bukle",
"bouclées" => "bukle",
"bouclent" => "bukl",
"boucler" => "bukle",
"bouclera" => "bukl°Ra",
"bouclerai" => "bukl°RE",
"boucleraient" => "bukl°RE",
"bouclerais" => "bukl°RE",
"bouclerait" => "bukl°RE",
"boucleras" => "bukl°Ra",
"bouclèrent" => "buklER",
"bouclerons" => "bukl°R§",
"boucleront" => "bukl°R§",
"boucles" => "bukl",
"bouclés" => "bukle",
"bouclette" => "buklEt",
"bouclettes" => "buklEt",
"bouclez" => "bukle",
"bouclier" => "buklije",
"boucliers" => "buklije",
"bouclons" => "bukl§",
"boucs" => "buk",
"bouda" => "buda",
"boudaient" => "budE",
"boudais" => "budE",
"boudait" => "budE",
"boudant" => "bud@",
"bouddha" => "buda",
"bouddhas" => "buda",
"bouddhique" => "budik",
"bouddhiques" => "budik",
"bouddhisme" => "budizm",
"bouddhiste" => "budist",
"bouddhistes" => "budist",
"boude" => "bud",
"boudé" => "bude",
"boudée" => "bude",
"boudent" => "bud",
"bouder" => "bude",
"bouderai" => "bud°RE",
"bouderait" => "bud°RE",
"boudèrent" => "budER",
"bouderie" => "bud°Ri",
"bouderies" => "bud°Ri",
"boudes" => "bud",
"boudés" => "bude",
"boudeur" => "bud9R",
"boudeurs" => "bud9R",
"boudeuse" => "bud2z°",
"boudeuses" => "bud2z",
"boudez" => "bude",
"boudi" => "budi",
"boudiez" => "budje",
"boudin" => "bud5",
"boudinaient" => "budinE",
"boudinait" => "budinE",
"boudinant" => "budin@",
"boudine" => "budin",
"boudiné" => "budine",
"boudinée" => "budine",
"boudinées" => "budine",
"boudinent" => "budin",
"boudinés" => "budine",
"boudins" => "bud5",
"boudiou" => "budju",
"boudoir" => "budwaR",
"boudoirs" => "budwaR",
"boudons" => "bud§",
"boudu" => "budy",
"boue" => "bu",
"bouée" => "bwe",
"bouées" => "bwe",
"boues" => "bu",
"boueur" => "bw9R",
"boueuse" => "bw2z",
"boueuses" => "bw2z",
"boueux" => "bw2",
"bouf" => "buf",
"bouffable" => "bufabl",
"bouffaient" => "bufE",
"bouffais" => "bufE",
"bouffait" => "bufE",
"bouffant" => "buf@",
"bouffante" => "buf@t",
"bouffantes" => "buf@t",
"bouffants" => "buf@",
"bouffarde" => "bufaRd",
"bouffardes" => "bufaRd",
"bouffe" => "buf",
"bouffé" => "bufe",
"bouffée" => "bufe",
"bouffées" => "bufe",
"bouffent" => "buf",
"bouffer" => "bufe",
"bouffera" => "buf°Ra",
"boufferai" => "buf°RE",
"boufferaient" => "buf°RE",
"boufferais" => "buf°RE",
"boufferait" => "buf°RE",
"boufferas" => "buf°Ra",
"boufferez" => "buf°Re",
"boufferont" => "buf°R§",
"bouffes" => "buf",
"bouffés" => "bufe",
"bouffetance" => "buf°t@s",
"bouffettes" => "bufEt",
"bouffeur" => "buf9R",
"bouffeurs" => "buf9R",
"bouffeuse" => "buf2z",
"bouffeuses" => "buf2z",
"bouffez" => "bufe",
"bouffi" => "bufi",
"bouffie" => "bufi",
"bouffies" => "bufi",
"bouffiez" => "bufje",
"bouffis" => "bufi",
"bouffissure" => "bufisyR",
"bouffissures" => "bufisyR",
"bouffon" => "buf§",
"bouffonna" => "bufona",
"bouffonnait" => "bufonE",
"bouffonnant" => "bufon@",
"bouffonnante" => "bufon@t",
"bouffonne" => "bufOn",
"bouffonnement" => "bufOn°m@",
"bouffonner" => "bufone",
"bouffonnerie" => "bufOn°Ri",
"bouffonneries" => "bufOn°Ri",
"bouffonnes" => "bufOn",
"bouffons" => "buf§",
"bouftance" => "buft@s",
"bougainvillée" => "bug5vile",
"bougainvillées" => "bug5vile",
"bougainvillier" => "bug5vilje",
"bougainvilliers" => "bug5vilje",
"bouge" => "buZ",
"bougé" => "buZe",
"bougea" => "buZa",
"bougeai" => "buZE",
"bougeaient" => "buZE",
"bougeais" => "buZE",
"bougeait" => "buZE",
"bougeant" => "buZ@",
"bougeassent" => "buZas",
"bougeât" => "buZa",
"bougée" => "buZe",
"bougées" => "buZe",
"bougent" => "buZ",
"bougeoir" => "buZwaR",
"bougeoirs" => "buZwaR",
"bougeons" => "buZ§",
"bougeotte" => "buZOt",
"bouger" => "buZe",
"bougera" => "buZ°Ra",
"bougerai" => "buZ°RE",
"bougeraient" => "buZ°RE",
"bougerais" => "buZ°RE",
"bougerait" => "buZ°RE",
"bougeras" => "buZ°Ra",
"bougèrent" => "buZER",
"bougerez" => "buZ°Re",
"bougeriez" => "buZ°Rje",
"bougerons" => "buZ°R§",
"bougeront" => "buZ°R§",
"bouges" => "buZ",
"bougez" => "buZe",
"bougie" => "buZi",
"bougies" => "buZi",
"bougiez" => "buZje",
"bougions" => "buZj§",
"bougnat" => "buNa",
"bougnats" => "buNa",
"bougne" => "buN",
"bougnes" => "buN",
"bougnoul" => "buNul",
"bougnoule" => "buNul",
"bougnoules" => "buNul",
"bougon" => "bug§",
"bougonna" => "bugona",
"bougonnaient" => "bugonE",
"bougonnais" => "bugonE",
"bougonnait" => "bugonE",
"bougonnant" => "bugon@",
"bougonne" => "bugOn",
"bougonné" => "bugone",
"bougonnement" => "bugOn°m@",
"bougonnent" => "bugOn",
"bougonner" => "bugone",
"bougons" => "bug§",
"bougran" => "bugR@",
"bougre" => "bugR",
"bougrement" => "bugR°m@",
"bougrerie" => "bugR°Ri",
"bougreries" => "bugR°Ri",
"bougres" => "bugR",
"bougresse" => "bugREs",
"boui-boui" => "bwibwi",
"bouiboui" => "bwibwi",
"bouibouis" => "bwibwi",
"bouif" => "bwif",
"bouillabaisse" => "bujabEs",
"bouillaient" => "bujE",
"bouillais" => "bujE",
"bouillait" => "bujE",
"bouillant" => "buj@",
"bouillante" => "buj@t",
"bouillantes" => "buj@t",
"bouillants" => "buj@",
"bouillasse" => "bujas",
"bouille" => "buj",
"bouillent" => "buj",
"bouilles" => "buj",
"bouilleur" => "buj9R",
"bouilleurs" => "buj9R",
"bouilli" => "buji",
"bouillie" => "buji",
"bouillies" => "buji",
"bouillir" => "bujiR",
"bouillira" => "bujiRa",
"bouillirons" => "bujiR§",
"bouillis" => "buji",
"bouilloire" => "bujwaR",
"bouilloires" => "bujwaR",
"bouillon" => "buj§",
"bouillonnaient" => "bujonE",
"bouillonnais" => "bujonE",
"bouillonnait" => "bujonE",
"bouillonnant" => "bujon@",
"bouillonnante" => "bujon@t",
"bouillonnantes" => "bujon@t",
"bouillonnants" => "bujon@",
"bouillonne" => "bujOn",
"bouillonné" => "bujone",
"bouillonnée" => "bujone",
"bouillonnées" => "bujone",
"bouillonnement" => "bujOn°m@",
"bouillonnements" => "bujOn°m@",
"bouillonnent" => "bujOn",
"bouillonner" => "bujone",
"bouillonnèrent" => "bujonER",
"bouillonnés" => "bujone",
"bouillonneux" => "bujOn2",
"bouillons" => "buj§",
"bouillottait" => "bujotE",
"bouillotte" => "bujOt",
"bouillottes" => "bujOt",
"bouillu" => "bujy",
"bouis-bouis" => "bwibwi",
"boukha" => "buka",
"boula" => "bula",
"boulait" => "bulE",
"boulange" => "bul@Z",
"boulanger" => "bul@Ze",
"boulanger-pâtissier" => "bul@Zepatisje",
"boulangère" => "bul@ZER",
"boulangères" => "bul@ZER",
"boulangerie" => "bul@Z°Ri",
"boulangeries" => "bul@Z°Ri",
"boulangers" => "bul@Ze",
"boulangisme" => "bul@Zizm",
"boulants" => "bul@",
"boulder" => "buld9R",
"boule" => "bul",
"boulé" => "bule",
"boule-de-neige" => "buld°nEZ",
"bouleau" => "bulo",
"bouleaux" => "bulo",
"bouledogue" => "bul°dOg",
"bouledogues" => "bul°dOg",
"boulent" => "bul",
"bouler" => "bule",
"boules" => "bul",
"boulés" => "bule",
"boulet" => "bulE",
"boulets" => "bulE",
"boulette" => "bulEt",
"boulettes" => "bulEt",
"boulevard" => "bul°vaR",
"boulevardier" => "bul°vaRdje",
"boulevardière" => "bul°vaRdjER",
"boulevardiers" => "bul°vaRdje",
"boulevards" => "bul°vaR",
"bouleversa" => "bul°vERsa",
"bouleversaient" => "bul°vERsE",
"bouleversait" => "bul°vERsE",
"bouleversant" => "bul°vERs@",
"bouleversante" => "bul°vERs@t",
"bouleversantes" => "bul°vERs@t",
"bouleversants" => "bul°vERs@",
"bouleverse" => "bul°vERs",
"bouleversé" => "bul°vERse",
"bouleversée" => "bul°vERse",
"bouleversées" => "bul°vERse",
"bouleversement" => "bul°vERs°m@",
"bouleversements" => "bul°vERs°m@",
"bouleversent" => "bul°vERs",
"bouleverser" => "bul°vERse",
"bouleversera" => "bul°vERs°Ra",
"bouleverseraient" => "bul°vERs°RE",
"bouleverserais" => "bul°vERs°RE",
"bouleverserait" => "bul°vERs°RE",
"bouleverseras" => "bul°vERs°Ra",
"bouleversèrent" => "bul°vERsER",
"bouleverserons" => "bul°vERs°R§",
"bouleverseront" => "bul°vERs°R§",
"bouleversés" => "bul°vERse",
"bouleversions" => "bul°vERsj§",
"bouleversons" => "bul°vERs§",
"boulgour" => "bulguR",
"boulier" => "bulje",
"bouliers" => "bulje",
"boulimie" => "bulimi",
"boulimies" => "bulimi",
"boulimique" => "bulimik",
"boulimiques" => "bulimik",
"bouline" => "bulin",
"boulines" => "bulin",
"boulingrins" => "bul5gR5",
"boulins" => "bul5",
"bouliste" => "bulist",
"boulistes" => "bulist",
"boulle" => "bul",
"boulochait" => "buloSE",
"boulodrome" => "bulodRom",
"bouloir" => "bulwaR",
"boulon" => "bul§",
"boulonnage" => "bulOnaZ",
"boulonnais" => "bulonE",
"boulonnait" => "bulonE",
"boulonnant" => "bulon@",
"boulonne" => "bulOn",
"boulonné" => "bulone",
"boulonnée" => "bulone",
"boulonner" => "bulone",
"boulonnerie" => "bulOn°Ri",
"boulonnés" => "bulone",
"boulons" => "bul§",
"boulot" => "bulo",
"boulot-refuge" => "buloR°fyZ",
"boulots" => "bulo",
"boulottait" => "bulotE",
"boulotte" => "bulOt",
"boulottées" => "bulote",
"boulotter" => "bulote",
"boulottes" => "bulOt",
"boulu" => "buly",
"boulus" => "buly",
"boum" => "bum",
"boumaient" => "bumE",
"boumait" => "bumE",
"boume" => "bum",
"boumé" => "bume",
"boums" => "bum",
"bouniouls" => "bunjul",
"bouquet" => "bukE",
"bouqueté" => "buk°te",
"bouquetier" => "buk°tje",
"bouquetière" => "buk°tjER",
"bouquetin" => "buk°t5",
"bouquetins" => "buk°t5",
"bouquets" => "bukE",
"bouquin" => "buk5",
"bouquinage" => "bukinaZ",
"bouquinais" => "bukinE",
"bouquinait" => "bukinE",
"bouquinant" => "bukin@",
"bouquine" => "bukin",
"bouquiné" => "bukine",
"bouquiner" => "bukine",
"bouquinerait" => "bukin°RE",
"bouquineur" => "bukin9R",
"bouquiniste" => "bukinist",
"bouquinistes" => "bukinist",
"bouquins" => "buk5",
"bour" => "buR",
"bourbe" => "buRb",
"bourbeuse" => "buRb2z",
"bourbeuses" => "buRb2z",
"bourbeux" => "buRb2",
"bourbier" => "buRbje",
"bourbiers" => "buRbje",
"bourbon" => "buRb§",
"bourbonien" => "buRbonj5",
"bourbonienne" => "buRbonjEn",
"bourbons" => "buRb§",
"bourdaine" => "buRdEn",
"bourdaines" => "buRdEn",
"bourdalous" => "buRdalu",
"bourde" => "buRd",
"bourdes" => "buRd",
"bourdillon" => "buRdij§",
"bourdon" => "buRd§",
"bourdonna" => "buRdona",
"bourdonnaient" => "buRdonE",
"bourdonnais" => "buRdonE",
"bourdonnait" => "buRdonE",
"bourdonnant" => "buRdon@",
"bourdonnante" => "buRdon@t",
"bourdonnantes" => "buRdon@t",
"bourdonnants" => "buRdon@",
"bourdonne" => "buRdOn",
"bourdonné" => "buRdone",
"bourdonnement" => "buRdOn°m@",
"bourdonnements" => "buRdOn°m@",
"bourdonnent" => "buRdOn",
"bourdonner" => "buRdone",
"bourdons" => "buRd§",
"bourg" => "buR",
"bourgade" => "buRgad",
"bourgades" => "buRgad",
"bourge" => "buRZ",
"bourgeois" => "buRZwa",
"bourgeoise" => "buRZwaz",
"bourgeoisement" => "buRZwaz°m@",
"bourgeoises" => "buRZwaz",
"bourgeoisie" => "buRZwazi",
"bourgeoisies" => "buRZwazi",
"bourgeoisisme" => "buRZwazizm",
"bourgeon" => "buRZ§",
"bourgeonnaient" => "buRZonE",
"bourgeonnait" => "buRZonE",
"bourgeonnant" => "buRZon@",
"bourgeonnante" => "buRZon@t",
"bourgeonnants" => "buRZon@",
"bourgeonne" => "buRZOn",
"bourgeonné" => "buRZOne",
"bourgeonnement" => "buRZOn°m@",
"bourgeonnements" => "buRZOn°m@",
"bourgeonnent" => "buRZOn",
"bourgeonner" => "buRZone",
"bourgeonneraient" => "buRZOn°RE",
"bourgeonneuse" => "buRZon2z",
"bourgeons" => "buRZ§",
"bourgeron" => "buRZ°R§",
"bourgerons" => "buRZ°R§",
"bourges" => "buRZ",
"bourgmestre" => "buRgmEstR",
"bourgmestres" => "buRgmEstR",
"bourgogne" => "buRgON",
"bourgognes" => "buRgON",
"bourgs" => "buR",
"bourgueil" => "buRg9j",
"bourgues" => "buRg",
"bourguignon" => "buRgiN§",
"bourguignonne" => "buRgiNOn",
"bourguignonnes" => "buRgiNOn",
"bourguignons" => "buRgiN§",
"bouriates" => "buRjat",
"bourlinguant" => "buRl5g@",
"bourlingue" => "buRl5g",
"bourlingué" => "buRl5ge",
"bourlinguer" => "buRl5ge",
"bourlinguera" => "buRl5g°Ra",
"bourlingueur" => "buRl5g9R",
"bourlingueuses" => "buRl5g2z",
"bourlinguons" => "buRl5g§",
"bourra" => "buRa",
"bourrache" => "buRaS",
"bourrade" => "buRad",
"bourrades" => "buRad",
"bourrage" => "buRaZ",
"bourrages" => "buRaZ",
"bourrai" => "buRE",
"bourraient" => "buRE",
"bourrais" => "buRE",
"bourrait" => "buRE",
"bourrant" => "buR@",
"bourrasque" => "buRask",
"bourrasques" => "buRask",
"bourratif" => "buRatif",
"bourrative" => "buRativ",
"bourratives" => "buRativ",
"bourre" => "buR",
"bourré" => "buRe",
"bourre-mou" => "buRmu",
"bourre-pif" => "buRpif",
"bourreau" => "buRo",
"bourreaux" => "buRo",
"bourrée" => "buRe",
"bourrées" => "buRe",
"bourrelé" => "buR°le",
"bourrelée" => "buR°le",
"bourrelés" => "buR°le",
"bourrelet" => "buR°lE",
"bourrelets" => "buR°lE",
"bourrelier" => "buR°lje",
"bourreliers" => "buR°lje",
"bourrellerie" => "buREl°Ri",
"bourrent" => "buR",
"bourrer" => "buRe",
"bourrera" => "buR°Ra",
"bourrerai" => "buR°RE",
"bourrèrent" => "buRER",
"bourres" => "buR",
"bourrés" => "buRe",
"bourreur" => "buR9R",
"bourrez" => "buRe",
"bourriche" => "buRiS",
"bourriches" => "buRiS",
"bourrichon" => "buRiS§",
"bourricot" => "buRiko",
"bourricots" => "buRiko",
"bourrier" => "buRje",
"bourrin" => "buR5",
"bourrine" => "buRin",
"bourrins" => "buR5",
"bourriquait" => "buRikE",
"bourrique" => "buRik",
"bourriques" => "buRik",
"bourriquet" => "buRikE",
"bourriquets" => "buRikE",
"bourrons" => "buR§",
"bourru" => "buRy",
"bourrue" => "buRy",
"bourrues" => "buRy",
"bourrus" => "buRy",
"bourse" => "buRs",
"bourses" => "buRs",
"boursicot" => "buRsiko",
"boursicotage" => "buRsikotaZ",
"boursicoteur" => "buRsikot9R",
"boursicoteurs" => "buRsikot9R",
"boursier" => "buRsje",
"boursière" => "buRsjER",
"boursières" => "buRsjER",
"boursiers" => "buRsje",
"boursouflaient" => "buRsuflE",
"boursouflait" => "buRsuflE",
"boursoufle" => "buRsufl",
"boursouflé" => "buRsufle",
"boursouflée" => "buRsufle",
"boursouflées" => "buRsufle",
"boursouflement" => "buRsufl°m@",
"boursoufler" => "buRsufle",
"boursouflés" => "buRsufle",
"boursouflure" => "buRsuflyR",
"boursouflures" => "buRsuflyR",
"bous" => "bu",
"bousards" => "buzaR",
"bousbir" => "busbiR",
"bousbirs" => "busbiR",
"bouscula" => "buskyla",
"bousculade" => "buskylad",
"bousculades" => "buskylad",
"bousculai" => "buskylE",
"bousculaient" => "buskylE",
"bousculait" => "buskylE",
"bousculant" => "buskyl@",
"bousculât" => "buskyla",
"bouscule" => "buskyl",
"bousculé" => "buskyle",
"bousculée" => "buskyle",
"bousculées" => "buskyle",
"bousculent" => "buskyl",
"bousculer" => "buskyle",
"bousculera" => "buskyl°Ra",
"bousculerait" => "buskyl°RE",
"bousculèrent" => "buskylER",
"bousculerons" => "buskyl°R§",
"bousculeront" => "buskyl°R§",
"bousculés" => "buskyle",
"bousculez" => "buskyle",
"bousculons" => "buskyl§",
"bouse" => "buz",
"bouses" => "buz",
"bouseuse" => "buz2z",
"bouseux" => "buz2",
"bousier" => "buzje",
"bousiers" => "buzje",
"bousillage" => "buzijaZ",
"bousillages" => "buzijaZ",
"bousillaient" => "buzijE",
"bousillais" => "buzijE",
"bousillait" => "buzijE",
"bousillant" => "buzij@",
"bousille" => "buzij",
"bousillé" => "buzije",
"bousillée" => "buzije",
"bousillées" => "buzije",
"bousillent" => "buzij",
"bousiller" => "buzije",
"bousillera" => "buzij°Ra",
"bousillerai" => "buzij°RE",
"bousillerait" => "buzij°RE",
"bousilleras" => "buzij°Ra",
"bousilleront" => "buzij°R§",
"bousilles" => "buzij",
"bousillés" => "buzije",
"bousilleur" => "buzij9R",
"bousillez" => "buzije",
"bousilliez" => "buzije",
"bousillons" => "buzij§",
"bousin" => "buz5",
"bousine" => "buzin",
"bousins" => "buz5",
"boussole" => "busOl",
"boussoles" => "busOl",
"boustifaille" => "bustifaj",
"boustifailles" => "bustifaj",
"boustifailleuse" => "bustifaj2z",
"boustrophédon" => "bustRofed§",
"bout" => "bu",
"bout-dehors" => "bud2OR",
"bout-rimé" => "buRime",
"bouta" => "buta",
"boutade" => "butad",
"boutades" => "butad",
"boutanche" => "but@S",
"boutanches" => "but@S",
"boutargue" => "butaRg",
"boutasse" => "butas",
"boute" => "but",
"bouté" => "bute",
"boute-en-train" => "but@tR5",
"boutée" => "bute",
"boutées" => "bute",
"boutefeu" => "but°f2",
"boutefeux" => "but°f2",
"bouteille" => "butEj",
"bouteilles" => "butEj",
"bouteillon" => "butEj§",
"bouteillons" => "butEj§",
"bouter" => "bute",
"bouterais" => "but°RE",
"boutés" => "bute",
"bouteur" => "but9R",
"bouteurs" => "but9R",
"bouthéon" => "bute§",
"bouthéons" => "bute§",
"boutillier" => "butije",
"boutique" => "butik",
"boutiqué" => "butike",
"boutique-cadeaux" => "butikkado",
"boutiquer" => "butike",
"boutiques" => "butik",
"boutiquier" => "butikje",
"boutiquière" => "butikjER",
"boutiquières" => "butikjER",
"boutiquiers" => "butikje",
"boutisses" => "butis",
"boutoir" => "butwaR",
"bouton" => "but§",
"bouton-d'or" => "but§dOR",
"bouton-pression" => "but§pREsj§",
"boutonna" => "butona",
"boutonnage" => "butonaZ",
"boutonnaient" => "butonE",
"boutonnais" => "butonE",
"boutonnait" => "butonE",
"boutonnant" => "buton@",
"boutonne" => "butOn",
"boutonné" => "butone",
"boutonnée" => "butone",
"boutonnées" => "butone",
"boutonnent" => "butOn",
"boutonner" => "butone",
"boutonnerait" => "butOn°RE",
"boutonnes" => "butOn",
"boutonnés" => "butone",
"boutonneuse" => "buton2z",
"boutonneuses" => "buton2z",
"boutonneux" => "buton2",
"boutonnez" => "butone",
"boutonnière" => "butonjER",
"boutonnières" => "butonjER",
"boutons" => "but§",
"boutons-d'or" => "but§dOR",
"boutons-pression" => "but§pREsj§",
"boutre" => "butR",
"boutres" => "butR",
"bouts" => "bu",
"bouts-rimés" => "buRime",
"bouture" => "butyR",
"boutures" => "butyR",
"bouvet" => "buvE",
"bouvier" => "buvje",
"bouviers" => "buvje",
"bouvillon" => "buvij§",
"bouvreuil" => "buvR9j",
"bouvreuils" => "buvR9j",
"bouzine" => "buzin",
"bouzouki" => "buzuki",
"bouzy" => "buzi",
"bovidé" => "bovide",
"bovidés" => "bovide",
"bovin" => "bov5",
"bovine" => "bovin",
"bovines" => "bovin",
"bovins" => "bov5",
"bow-window" => "bowindo",
"bow-windows" => "bowindoz",
"bowling" => "buliG",
"box" => "bOks",
"box-calf" => "bOkskalf",
"box-office" => "bOksofis",
"box-offices" => "bOksofis",
"boxa" => "bOksa",
"boxaient" => "bOksE",
"boxais" => "bOksE",
"boxait" => "bOksE",
"boxant" => "bOks@",
"boxe" => "bOks",
"boxé" => "bOkse",
"boxent" => "bOks",
"boxer" => "bOkse",
"boxer-short" => "bOks9RSORt",
"boxerai" => "bOks°RE",
"boxerais" => "bOks°RE",
"boxerez" => "bOks°Re",
"boxers" => "bOks9R",
"boxes" => "bOks",
"boxés" => "bOkse",
"boxeur" => "bOks9R",
"boxeurs" => "bOks9R",
"boxeuse" => "bOks2z",
"boxez" => "bOkse",
"boxon" => "bOks§",
"boxons" => "bOks§",
"boy" => "bOj",
"boy-friend" => "bOjfR5nd",
"boy-scout" => "bOjskut",
"boy-scoutesque" => "bOjskutEsk",
"boy-scouts" => "bOjskut",
"boyard" => "bwajaR",
"boyards" => "bwajaR",
"boyau" => "bwajo",
"boyauter" => "bwajOte",
"boyaux" => "bwajo",
"boycott" => "bOjkOt",
"boycotte" => "bOjkOt",
"boycotté" => "bOjkote",
"boycottent" => "bOjkOt",
"boycotter" => "bOjkote",
"boycotterai" => "bOjkOt°RE",
"boycotteront" => "bOjkOt°R§",
"boycottes" => "bOjkOt",
"boycottez" => "bOjkote",
"boys" => "bOj",
"bozo" => "bozo",
"brabançon" => "bRab@s§",
"brabançonne" => "bRab@sOn",
"brabançons" => "bRab@s§",
"brabant" => "bRab@",
"bracelet" => "bRas°lE",
"bracelet-montre" => "bRas°lEm§tR",
"bracelets" => "bRas°lE",
"bracelets-montres" => "bRas°lEm§tR",
"brachial" => "bRakjal",
"brachiale" => "bRakjal",
"brachiocéphalique" => "bRakjOsefalik",
"brachiosaure" => "bRakjozOR",
"brachycéphale" => "bRakisefal",
"brachycéphales" => "bRakisefal",
"braco" => "bRako",
"braconnage" => "bRakonaZ",
"braconnages" => "bRakonaZ",
"braconnais" => "bRakonE",
"braconnait" => "bRakonE",
"braconnant" => "bRakon@",
"braconne" => "bRakOn",
"braconné" => "bRakone",
"braconner" => "bRakone",
"braconnez" => "bRakone",
"braconnier" => "bRakonje",
"braconnière" => "bRakonjER",
"braconnières" => "bRakonjER",
"braconniers" => "bRakonje",
"bractées" => "bRakte",
"bradaient" => "bRadE",
"bradait" => "bRadE",
"brade" => "bRad",
"bradé" => "bRade",
"bradée" => "bRade",
"bradent" => "bRad",
"brader" => "bRade",
"braderai" => "bRad°RE",
"braderais" => "bRad°RE",
"braderait" => "bRad°RE",
"braderie" => "bRad°Ri",
"braderies" => "bRad°Ri",
"bradillon" => "bRadij§",
"bradillons" => "bRadij§",
"bradons" => "bRad§",
"bradycardie" => "bRadikaRdi",
"bragard" => "bRagaR",
"braguette" => "bRagEt",
"braguettes" => "bRagEt",
"brahmane" => "bRaman",
"brahmanes" => "bRaman",
"brahmanique" => "bRamanik",
"brahmanisme" => "bRamanizm",
"brahmanistes" => "bRamanist",
"brai" => "bRE",
"braie" => "bRE",
"braiement" => "bREm@",
"braiements" => "bREm@",
"braies" => "bRE",
"brailla" => "bRaja",
"braillaient" => "bRajE",
"braillait" => "bRajE",
"braillant" => "bRaj@",
"braillard" => "bRajaR",
"braillarde" => "bRajaRd",
"braillardes" => "bRajaRd",
"braillards" => "bRajaR",
"braille" => "bRaj",
"braillé" => "bRaje",
"braillée" => "bRaje",
"braillement" => "bRaj°m@",
"braillements" => "bRaj°m@",
"braillent" => "bRaj",
"brailler" => "bRaje",
"braillera" => "bRaj°Ra",
"braillerai" => "bRaj°RE",
"braillèrent" => "bRajER",
"brailles" => "bRaj",
"braillés" => "bRaje",
"brailleur" => "bRaj9R",
"brailleurs" => "bRaj9R",
"brailleuse" => "bRaj2z",
"braillez" => "bRaje",
"braiment" => "bREm@",
"braiments" => "bREm@",
"brain-trust" => "bREjntR9st",
"brainstorming" => "bREjnstORmiG",
"braire" => "bRER",
"brais" => "bRE",
"braise" => "bREz",
"braisé" => "bReze",
"braisée" => "bReze",
"braiser" => "bREze",
"braises" => "bREz",
"braisés" => "bReze",
"braisillant" => "bREzij@",
"braisillante" => "bREzij@t",
"brait" => "bRE",
"brama" => "bRama",
"bramaient" => "bRamE",
"bramait" => "bRamE",
"bramant" => "bRam@",
"brame" => "bRam",
"bramé" => "bRame",
"bramées" => "bRame",
"bramement" => "bRam°m@",
"bramements" => "bRam°m@",
"brament" => "bRam",
"bramer" => "bRame",
"brames" => "bRam",
"bran" => "bR@",
"brancard" => "bR@kaR",
"brancarder" => "bR@kaRde",
"brancardier" => "bR@kaRdje",
"brancardiers" => "bR@kaRdje",
"brancards" => "bR@kaR",
"brancha" => "bR@Sa",
"branchage" => "bR@SaZ",
"branchages" => "bR@SaZ",
"branchai" => "bR@SE",
"branchaient" => "bR@SE",
"branchais" => "bR@SE",
"branchait" => "bR@SE",
"branchant" => "bR@S@",
"branche" => "bR@S",
"branché" => "bR@Se",
"branchée" => "bR@Se",
"branchées" => "bR@Se",
"branchement" => "bR@S°m@",
"branchements" => "bR@S°m@",
"branchent" => "bR@S",
"brancher" => "bR@Se",
"branchera" => "bR@S°Ra",
"brancheraient" => "bR@S°RE",
"brancherait" => "bR@S°RE",
"brancheras" => "bR@S°Ra",
"brancherez" => "bR@S°Re",
"branches" => "bR@S",
"branchés" => "bR@Se",
"branchette" => "bR@SEt",
"branchettes" => "bR@SEt",
"branchez" => "bR@Se",
"branchiale" => "bR@Sjal",
"branchie" => "bR@Si",
"branchies" => "bR@Si",
"branchons" => "bR@S§",
"branchu" => "bR@Sy",
"branchue" => "bR@Sy",
"branchus" => "bR@Sy",
"brand" => "bR@",
"brandade" => "bR@dad",
"brande" => "bR@d",
"brandebourgeois" => "bR@d°buRZwa",
"brandebourgs" => "bR@d°buR",
"brandevin" => "bR@d°v5",
"brandevinier" => "bR@d°vinje",
"brandi" => "bR@di",
"brandie" => "bR@di",
"brandies" => "bR@di",
"brandillon" => "bR@dij§",
"brandillons" => "bR@dij§",
"brandir" => "bR@diR",
"brandira" => "bR@diRa",
"brandirait" => "bR@diRE",
"brandirent" => "bR@diR",
"brandiront" => "bR@diR§",
"brandis" => "bR@di",
"brandissaient" => "bR@disE",
"brandissais" => "bR@disE",
"brandissait" => "bR@disE",
"brandissant" => "bR@dis@",
"brandisse" => "bR@dis",
"brandissent" => "bR@dis",
"brandissez" => "bR@dise",
"brandissiez" => "bR@disje",
"brandissions" => "bR@disj§",
"brandissons" => "bR@dis§",
"brandit" => "bR@di",
"brandît" => "bR@di",
"brandon" => "bR@d§",
"brandons" => "bR@d§",
"brandouille" => "bR@duj",
"brandy" => "bR@di",
"branla" => "bR@la",
"branlage" => "bR@laZ",
"branlaient" => "bR@lE",
"branlais" => "bR@lE",
"branlait" => "bR@lE",
"branlant" => "bR@l@",
"branlante" => "bR@l@t",
"branlantes" => "bR@l@t",
"branlants" => "bR@l@",
"branle" => "bR@l",
"branlé" => "bR@le",
"branle-bas" => "bR@lba",
"branlée" => "bR@le",
"branlement" => "bR@l°m@",
"branlent" => "bR@l",
"branler" => "bR@le",
"branlera" => "bR@l°Ra",
"branlerais" => "bR@l°RE",
"branlerait" => "bR@l°RE",
"branles" => "bR@l",
"branlés" => "bR@le",
"branlette" => "bR@lEt",
"branlettes" => "bR@lEt",
"branleur" => "bR@l9R",
"branleurs" => "bR@l9R",
"branleuse" => "bR@l2z",
"branleuses" => "bR@l2z",
"branlez" => "bR@le",
"branlochais" => "bR@loSE",
"branlochant" => "bR@loS@",
"branlochent" => "bR@lOS",
"branque" => "bR@k",
"branques" => "bR@k",
"branquignol" => "bR@kiNOl",
"branquignols" => "bR@kiNOl",
"braqua" => "bRaka",
"braquage" => "bRakaZ",
"braquages" => "bRakaZ",
"braquai" => "bRakE",
"braquaient" => "bRakE",
"braquais" => "bRakE",
"braquait" => "bRakE",
"braquant" => "bRak@",
"braque" => "bRak",
"braqué" => "bRake",
"braquée" => "bRake",
"braquées" => "bRake",
"braquemart" => "bRak°maR",
"braquemarts" => "bRak°maR",
"braquent" => "bRak",
"braquer" => "bRake",
"braquera" => "bRak°Ra",
"braquerais" => "bRak°RE",
"braquerait" => "bRak°RE",
"braquèrent" => "bRakER",
"braques" => "bRak",
"braqués" => "bRake",
"braquet" => "bRakE",
"braquets" => "bRakE",
"braqueur" => "bRak9R",
"braqueurs" => "bRak9R",
"braqueuse" => "bRak2z",
"braqueuses" => "bRak2z",
"braquez" => "bRake",
"bras" => "bRa",
"brasage" => "bRazaZ",
"braser" => "bRaze",
"brasero" => "bRazeRo",
"braseros" => "bRazeRo",
"brasier" => "bRazje",
"brasiers" => "bRazje",
"brasillaient" => "bRazijE",
"brasillait" => "bRazijE",
"brasillant" => "bRazij@",
"brasille" => "bRazij",
"brasillement" => "bRazij°m@",
"brasiller" => "bRazije",
"brassage" => "bRasaZ",
"brassages" => "bRasaZ",
"brassai" => "bRasE",
"brassaient" => "bRasE",
"brassait" => "bRasE",
"brassant" => "bRas@",
"brassard" => "bRasaR",
"brassards" => "bRasaR",
"brasse" => "bRas",
"brassé" => "bRase",
"brassée" => "bRase",
"brassées" => "bRase",
"brassent" => "bRas",
"brasser" => "bRase",
"brasserie" => "bRas°Ri",
"brasserie-hôtel" => "bRas°RiotEl",
"brasseries" => "bRas°Ri",
"brasseront" => "bRas°R§",
"brasses" => "bRas",
"brassés" => "bRase",
"brasseur" => "bRas9R",
"brasseurs" => "bRas9R",
"brassez" => "bRase",
"brassicourt" => "bRasikuR",
"brassière" => "bRasjER",
"brassières" => "bRasjER",
"brassions" => "bRasj§",
"brasure" => "bRazyR",
"brava" => "bRava",
"bravache" => "bRavaS",
"bravaches" => "bRavaS",
"bravade" => "bRavad",
"bravades" => "bRavad",
"bravaient" => "bRavE",
"bravais" => "bRavE",
"bravait" => "bRavE",
"bravant" => "bRav@",
"brave" => "bRav",
"bravé" => "bRave",
"bravée" => "bRave",
"bravement" => "bRav°m@",
"bravent" => "bRav",
"braver" => "bRave",
"braverai" => "bRav°RE",
"braveraient" => "bRav°RE",
"braverait" => "bRav°RE",
"bravèrent" => "bRavER",
"braveries" => "bRav°Ri",
"braveriez" => "bRav°Rje",
"braves" => "bRav",
"bravez" => "bRave",
"bravissimo" => "bRavisimo",
"bravo" => "bRavo",
"bravons" => "bRav§",
"bravos" => "bRavo",
"bravoure" => "bRavuR",
"brayaient" => "bREjE",
"brayait" => "bREjE",
"braye" => "bREj",
"brayes" => "bREj",
"brayons" => "bREj§",
"break" => "bREk",
"break-down" => "bREkdawn",
"breakdance" => "bREkdEns",
"breakfast" => "bREkf9st",
"breakfasts" => "bREkf9st",
"breaks" => "bREk",
"brebis" => "bR°bi",
"brèche" => "bRES",
"brèche-dents" => "bRESd@",
"brèches" => "bRES",
"bréchet" => "bReSE",
"brechtienne" => "bREktjEn",
"bredin" => "bR°d5",
"bredouilla" => "bR°duja",
"bredouillage" => "bR°dujaZ",
"bredouillai" => "bR°dujE",
"bredouillaient" => "bR°dujE",
"bredouillais" => "bR°dujE",
"bredouillait" => "bR°dujE",
"bredouillant" => "bR°duj@",
"bredouillante" => "bR°duj@t",
"bredouille" => "bR°duj",
"bredouillé" => "bR°duje",
"bredouillées" => "bR°duje",
"bredouillement" => "bR°duj°m@",
"bredouillements" => "bR°duj°m@",
"bredouillent" => "bR°duj",
"bredouiller" => "bR°duje",
"bredouilles" => "bR°duj",
"bredouilleurs" => "bR°duj9R",
"bredouillez" => "bR°duje",
"bredouillis" => "bR°duji",
"bref" => "bREf",
"brefs" => "bREf",
"bregma" => "bREgma",
"bréhaigne" => "bReEN",
"bréhaignes" => "bReEN",
"breitschwanz" => "bRajtSvants",
"brelan" => "bR2l@",
"brelans" => "bR2l@",
"brêles" => "bREl",
"breloque" => "bR2lOk",
"breloques" => "bR2lOk",
"brème" => "bREm",
"brèmes" => "bREm",
"breneuses" => "bR2n2z",
"breneux" => "bR2n2",
"brésil" => "bRezil",
"brésilien" => "bRezilj5",
"brésilienne" => "bReziljEn",
"brésiliennes" => "bReziljEn",
"brésiliens" => "bRezilj5",
"brésils" => "bRezil",
"bressan" => "bREs@",
"bressane" => "bREsan",
"bressanes" => "bREsan",
"bressans" => "bREs@",
"brestois" => "bREstwa",
"brestoise" => "bREstwaz",
"bretelle" => "bR°tEl",
"bretelles" => "bR°tEl",
"breton" => "bR°t§",
"bretonnant" => "bR°ton@",
"bretonnants" => "bR°ton@",
"bretonne" => "bR°tOn",
"bretonnes" => "bR°tOn",
"bretons" => "bR°t§",
"brette" => "bREt",
"bretteur" => "bREt9R",
"bretteurs" => "bREt9R",
"bretzel" => "bREdzEl",
"bretzels" => "bREdzEl",
"breuil" => "bR9j",
"breuils" => "bR9j",
"breuvage" => "bR9vaZ",
"breuvages" => "bR9vaZ",
"brève" => "bREv",
"brèves" => "bREv",
"brevet" => "bR2vE",
"breveté" => "bR2v°te",
"brevetée" => "bR2v°te",
"brevetées" => "bR2v°te",
"breveter" => "bR2v°te",
"brevetés" => "bR2v°te",
"brevets" => "bR2vE",
"bréviaire" => "bRevjER",
"bri" => "bRi",
"briard" => "bRijaR",
"briarde" => "bRijaRd",
"briards" => "bRijaR",
"bribe" => "bRib",
"bribes" => "bRib",
"bric et de broc" => "bRiked2bRo",
"bric-à-brac" => "bRikabRak",
"bricheton" => "bRiS°t§",
"brick" => "bRik",
"bricks" => "bRik",
"bricola" => "bRikola",
"bricolage" => "bRikolaZ",
"bricolages" => "bRikolaZ",
"bricolaient" => "bRikolE",
"bricolais" => "bRikolE",
"bricolait" => "bRikolE",
"bricolant" => "bRikol@",
"bricole" => "bRikOl",
"bricolé" => "bRikole",
"bricolée" => "bRikole",
"bricolées" => "bRikole",
"bricolent" => "bRikOl",
"bricoler" => "bRikole",
"bricoles" => "bRikOl",
"bricolés" => "bRikole",
"bricoleur" => "bRikol9R",
"bricoleurs" => "bRikol9R",
"bricoleuse" => "bRikOl2z",
"bricolez" => "bRikole",
"bricolo" => "bRikolo",
"bricolons" => "bRikol§",
"bricolos" => "bRikolo",
"bridais" => "bRidE",
"bridait" => "bRidE",
"bridant" => "bRid@",
"bride" => "bRid",
"bridé" => "bRide",
"bridée" => "bRide",
"bridées" => "bRide",
"brident" => "bRid",
"brider" => "bRide",
"brides" => "bRid",
"bridés" => "bRide",
"bridez" => "bRide",
"bridge" => "bRidZ",
"bridgeait" => "bRidZE",
"bridgeant" => "bRidZ@",
"bridgées" => "bRidZe",
"bridgent" => "bRidZ",
"bridgeons" => "bRidZ§",
"bridger" => "bRidZe",
"bridges" => "bRidZ",
"bridgeurs" => "bRidZ9R",
"bridgeuse" => "bRidZ2z",
"bridgez" => "bRidZe",
"bridon" => "bRid§",
"bridons" => "bRid§",
"brie" => "bRi",
"briefe" => "bRif",
"briefé" => "bRife",
"briefée" => "bRife",
"briefer" => "bRife",
"briefera" => "bRif°Ra",
"brieferai" => "bRif°RE",
"brieferas" => "bRif°Ra",
"briefes" => "bRif",
"briefés" => "bRife",
"briefez" => "bRife",
"briefing" => "bRifiG",
"briefings" => "bRifiG",
"bries" => "bRi",
"brièvement" => "bRijEv°m@",
"brièveté" => "bRijEv°te",
"brifez" => "bRife",
"briffe" => "bRif",
"briffer" => "bRife",
"brigade" => "bRigad",
"brigades" => "bRigad",
"brigadier" => "bRigadje",
"brigadier-chef" => "bRigadjeSEf",
"brigadiers" => "bRigadje",
"brigadiers-chefs" => "bRigadjeSEf",
"brigadiste" => "bRigadist",
"brigadistes" => "bRigadist",
"brigand" => "bRig@",
"brigandage" => "bRig@daZ",
"brigandages" => "bRig@daZ",
"brigandaient" => "bRig@dE",
"brigandasse" => "bRig@das",
"brigande" => "bRig@d",
"brigandeaux" => "bRig@do",
"brigands" => "bRig@",
"brigantin" => "bRig@t5",
"brigantine" => "bRig@tin",
"brignolet" => "bRiNolE",
"briguaient" => "bRigE",
"briguait" => "bRigE",
"briguant" => "bRig@",
"brigue" => "bRig",
"brigué" => "bRige",
"briguer" => "bRige",
"briguerait" => "bRig°RE",
"briguèrent" => "bRigER",
"brigues" => "bRig",
"brilla" => "bRija",
"brillaient" => "bRijE",
"brillais" => "bRijE",
"brillait" => "bRijE",
"brillamment" => "bRijam@",
"brillance" => "bRij@s",
"brillances" => "bRij@s",
"brillant" => "bRij@",
"brillantage" => "bRij@taZ",
"brillante" => "bRij@t",
"brillantes" => "bRij@t",
"brillantés" => "bRij@te",
"brillantine" => "bRij@tin",
"brillantinée" => "bRij@tine",
"brillantinées" => "bRij@tine",
"brillantiner" => "bRij@tine",
"brillantinés" => "bRij@tine",
"brillants" => "bRij@",
"brillât" => "bRija",
"brille" => "bRij",
"brillé" => "bRije",
"brillent" => "bRij",
"briller" => "bRije",
"brillera" => "bRij°Ra",
"brilleraient" => "bRij°RE",
"brillerais" => "bRij°RE",
"brillerait" => "bRij°RE",
"brillèrent" => "bRijER",
"brillerons" => "bRij°R§",
"brilleront" => "bRij°R§",
"brilles" => "bRij",
"brillez" => "bRije",
"brillions" => "bRij§",
"brillons" => "bRij§",
"brima" => "bRima",
"brimade" => "bRimad",
"brimades" => "bRimad",
"brimaient" => "bRimE",
"brimais" => "bRimE",
"brimait" => "bRimE",
"brimbala" => "bR5bala",
"brimbalant" => "bR5bal@",
"brimbalement" => "bR5bal°m@",
"brimbalements" => "bR5bal°m@",
"brimbaler" => "bR5bale",
"brimbalés" => "bR5bale",
"brimborion" => "bR5boRj§",
"brimborions" => "bR5boRj§",
"brime" => "bRim",
"brimé" => "bRime",
"brimée" => "bRime",
"brimées" => "bRime",
"briment" => "bRim",
"brimer" => "bRime",
"brimés" => "bRime",
"brin" => "bR5",
"brindes" => "bR5d",
"brindezingue" => "bR5dz5g",
"brindille" => "bR5dij",
"brindilles" => "bR5dij",
"bringue" => "bR5g",
"bringuebalaient" => "bR5g°balE",
"bringuebalait" => "bR5g°balE",
"bringuebalant" => "bR5g°bal@",
"bringuebalante" => "bR5g°bal@t",
"bringuebalantes" => "bR5g°bal@t",
"bringuebalants" => "bR5g°bal@",
"bringuebale" => "bR5g°bal",
"bringuebalent" => "bR5g°bal",
"bringuebaler" => "bR5g°bale",
"brinquebalait" => "bR5k°balE",
"brinquebalants" => "bR5k°bal@",
"brinquebale" => "bR5k°bal",
"brinquebalé" => "bR5k°bale",
"brinquebaler" => "bR5k°bale",
"brinqueballant" => "bR5k°bal@",
"brinqueballé" => "bR5k°bale",
"brinqueballés" => "bR5k°bale",
"brins" => "bR5",
"brio" => "bRijo",
"brioche" => "bRijOS",
"brioché" => "bRijoSe",
"briochée" => "bRijOSe",
"brioches" => "bRijOS",
"briochés" => "bRijoSe",
"brions" => "bRi§",
"briquage" => "bRikaZ",
"briquaient" => "bRikE",
"briquais" => "bRikE",
"briquait" => "bRikE",
"briquant" => "bRik@",
"brique" => "bRik",
"briqué" => "bRike",
"briquée" => "bRike",
"briquées" => "bRike",
"briquent" => "bRik",
"briquer" => "bRike",
"briquerait" => "bRik°RE",
"briques" => "bRik",
"briqués" => "bRike",
"briquet" => "bRikE",
"briquetage" => "bRik°taZ",
"briquetées" => "bRik°te",
"briqueterie" => "bRikEt°Ri",
"briqueteries" => "bRikEt°Ri",
"briquetier" => "bRik°tje",
"briquets" => "bRikE",
"briquette" => "bRikEt",
"briquettes" => "bRikEt",
"briquez" => "bRike",
"bris" => "bRi",
"brisa" => "bRiza",
"brisai" => "bRizE",
"brisaient" => "bRizE",
"brisais" => "bRizE",
"brisait" => "bRizE",
"brisant" => "bRiz@",
"brisante" => "bRiz@t",
"brisantes" => "bRiz@t",
"brisants" => "bRiz@",
"brisât" => "bRiza",
"briscard" => "bRiskaR",
"briscards" => "bRiskaR",
"brise" => "bRiz",
"brisé" => "bRize",
"brise-bise" => "bRizbiz",
"brise-fer" => "bRizfER",
"brise-glace" => "bRizglas",
"brise-jet" => "bRizdZEt",
"brise-lame" => "bRizlam",
"brise-vent" => "bRizv@",
"brisée" => "bRize",
"brisées" => "bRize",
"brisent" => "bRiz",
"briser" => "bRize",
"brisera" => "bRiz°Ra",
"briserai" => "bRiz°RE",
"briseraient" => "bRiz°RE",
"briserais" => "bRiz°RE",
"briserait" => "bRiz°RE",
"briseras" => "bRiz°Ra",
"brisèrent" => "bRizER",
"briserez" => "bRiz°Re",
"briseriez" => "bRiz°Rje",
"briserons" => "bRiz°R§",
"briseront" => "bRiz°R§",
"brises" => "bRiz",
"brisés" => "bRize",
"briseur" => "bRiz9R",
"briseurs" => "bRiz9R",
"briseuse" => "bRiz2z",
"brisez" => "bRize",
"brisions" => "bRizj§",
"brisis" => "bRizi",
"brisons" => "bRiz§",
"brisque" => "bRisk",
"bristol" => "bRistOl",
"bristols" => "bRistOl",
"brisure" => "bRizyR",
"brisures" => "bRizyR",
"britannique" => "bRitanik",
"britanniques" => "bRitanik",
"british" => "bRitiS",
"brivadois" => "bRivadwa",
"brivadoise" => "bRivadwaz",
"brize" => "bRiz",
"broc" => "bRo",
"brocante" => "bRok@t",
"brocantées" => "bRok@te",
"brocantes" => "bRok@t",
"brocanteur" => "bRok@t9R",
"brocanteurs" => "bRok@t9R",
"brocanteuse" => "bRok@t2z",
"brocard" => "bRokaR",
"brocardaient" => "bRokaRdE",
"brocardait" => "bRokaRdE",
"brocarde" => "bRokaRd",
"brocarder" => "bRokaRde",
"brocardions" => "bRokaRdj§",
"brocards" => "bRokaR",
"brocart" => "bRokaR",
"brocarts" => "bRokaR",
"brocatelle" => "bRokatEl",
"brochage" => "bRoSaZ",
"brochages" => "bRoSaZ",
"brochaient" => "bRoSE",
"brochant" => "bRoS@",
"broche" => "bROS",
"broché" => "bRoSe",
"brochée" => "bRoSe",
"brochées" => "bRoSe",
"brocher" => "bRoSe",
"broches" => "bROS",
"brochés" => "bRoSe",
"brochet" => "bRoSE",
"brochets" => "bRoSE",
"brochette" => "bRoSEt",
"brochettes" => "bRoSEt",
"brocheur" => "bRoS9R",
"brocheurs" => "bRoS9R",
"brochoirs" => "bROSwaR",
"brochure" => "bRoSyR",
"brochures" => "bRoSyR",
"brocoli" => "bRokoli",
"brocolis" => "bRokoli",
"brocs" => "bRo",
"broda" => "bRoda",
"brodaient" => "bRodE",
"brodais" => "bRodE",
"brodait" => "bRodE",
"brodant" => "bRod@",
"brode" => "bROd",
"brodé" => "bRode",
"brodée" => "bRode",
"brodées" => "bRode",
"brodent" => "bROd",
"brodequin" => "bROd°k5",
"brodequins" => "bROd°k5",
"broder" => "bRode",
"brodera" => "bROd°Ra",
"broderai" => "bROd°RE",
"broderie" => "bROd°Ri",
"broderies" => "bROd°Ri",
"brodes" => "bROd",
"brodés" => "bRode",
"brodeuse" => "bRod2z",
"brodeuses" => "bRod2z",
"brodez" => "bRode",
"broie" => "bRwa",
"broiement" => "bRwam@",
"broiements" => "bRwam@",
"broient" => "bRwa",
"broiera" => "bRwaRa",
"broierai" => "bRwaRE",
"broieras" => "bRwaRa",
"broies" => "bRwa",
"broker" => "bRok9R",
"brol" => "bROl",
"brome" => "bRom",
"bromure" => "bRomyR",
"bromures" => "bRomyR",
"broncha" => "bR§Sa",
"bronchai" => "bR§SE",
"bronchaient" => "bR§SE",
"bronchais" => "bR§SE",
"bronchait" => "bR§SE",
"bronchant" => "bR§S@",
"bronchât" => "bR§Sa",
"bronche" => "bR§S",
"bronché" => "bR§Se",
"bronchent" => "bR§S",
"broncher" => "bR§Se",
"bronchera" => "bR§S°Ra",
"broncherai" => "bR§S°RE",
"broncherais" => "bR§S°RE",
"broncherait" => "bR§S°RE",
"bronchèrent" => "bR§SER",
"broncherons" => "bR§S°R§",
"broncheront" => "bR§S°R§",
"bronches" => "bR§S",
"bronchez" => "bR§Se",
"bronchioles" => "bR§SjOl",
"bronchique" => "bR§Sik",
"bronchiques" => "bR§Sik",
"bronchite" => "bR§Sit",
"bronchites" => "bR§Sit",
"bronchitique" => "bR§Sitik",
"bronchitiques" => "bR§Sitik",
"broncho" => "bR§ko",
"broncho-pneumonie" => "bR§kopn2moni",
"broncho-pneumopathie" => "bR§kopn2mopati",
"bronchons" => "bR§S§",
"bronchoscope" => "bR§kOskOp",
"bronchoscopie" => "bR§kOskOpi",
"brontosaure" => "bR§tozoR",
"brontosaures" => "bR§tozoR",
"bronzage" => "bR§zaZ",
"bronzages" => "bR§zaZ",
"bronzaient" => "bR§zE",
"bronzait" => "bR§zE",
"bronzant" => "bR§z@",
"bronzante" => "bR§z@t",
"bronzants" => "bR§z@",
"bronze" => "bR§z",
"bronzé" => "bR§ze",
"bronzée" => "bR§ze",
"bronzées" => "bR§ze",
"bronzent" => "bR§z",
"bronzer" => "bR§ze",
"bronzes" => "bR§z",
"bronzés" => "bR§ze",
"bronzette" => "bR§zEt",
"bronzettes" => "bR§zEt",
"bronzier" => "bR§zje",
"bronzions" => "bR§zj§",
"brook" => "bRuk",
"brooks" => "bRuk",
"broquarts" => "bRokaR",
"broque" => "bROk",
"broques" => "bROk",
"broquettes" => "bRokEt",
"broquille" => "bRokij",
"broquilles" => "bRokij",
"brossa" => "bRosa",
"brossage" => "bRosaZ",
"brossaient" => "bRosE",
"brossais" => "bRosE",
"brossait" => "bRosE",
"brossant" => "bRos@",
"brosse" => "bROs",
"brossé" => "bRose",
"brossée" => "bRose",
"brossées" => "bRose",
"brossent" => "bROs",
"brosser" => "bRose",
"brossera" => "bROs°Ra",
"brosserai" => "bROs°RE",
"brosseras" => "bROs°Ra",
"brosserez" => "bROs°Re",
"brosses" => "bROs",
"brossés" => "bRose",
"brosseur" => "bRos9R",
"brosseurs" => "bRos9R",
"brossez" => "bRose",
"brossier" => "bRosje",
"brou" => "bRu",
"brouet" => "bRuE",
"brouets" => "bRuE",
"brouetta" => "bRuEta",
"brouettait" => "bRuEtE",
"brouette" => "bRuEt",
"brouettée" => "bRuEte",
"brouettées" => "bRuEte",
"brouetter" => "bRuEte",
"brouettes" => "bRuEt",
"brouhaha" => "bRuaa",
"brouhahas" => "bRuaa",
"brouilla" => "bRuja",
"brouillade" => "bRujad",
"brouillage" => "bRujaZ",
"brouillages" => "bRujaZ",
"brouillaient" => "bRujE",
"brouillait" => "bRujE",
"brouillamini" => "bRujamini",
"brouillant" => "bRuj@",
"brouillard" => "bRujaR",
"brouillardeuse" => "bRujaRd2z",
"brouillardeux" => "bRujaRd2",
"brouillards" => "bRujaR",
"brouillassait" => "bRujasE",
"brouillasse" => "bRujas",
"brouillât" => "bRuja",
"brouille" => "bRuj",
"brouillé" => "bRuje",
"brouillée" => "bRuje",
"brouillées" => "bRuje",
"brouillent" => "bRuj",
"brouiller" => "bRuje",
"brouilleraient" => "bRuj°RE",
"brouillerait" => "bRuj°RE",
"brouillèrent" => "bRujER",
"brouillerons" => "bRuj°R§",
"brouilles" => "bRuj",
"brouillés" => "bRuje",
"brouilleur" => "bRuj9R",
"brouilleurs" => "bRuj9R",
"brouillez" => "bRuje",
"brouillon" => "bRuj§",
"brouillonne" => "bRujOn",
"brouillonné" => "bRujone",
"brouillonnes" => "bRujOn",
"brouillons" => "bRuj§",
"brouis" => "bRui",
"brouit" => "bRui",
"broum" => "bRum",
"broussaille" => "bRusaj",
"broussailles" => "bRusaj",
"broussailleuse" => "bRusaj2z",
"broussailleuses" => "bRusaj2z",
"broussailleux" => "bRusaj2",
"broussait" => "bRusE",
"broussard" => "bRusaR",
"brousse" => "bRus",
"brousses" => "bRus",
"brout" => "bRu",
"brouta" => "bRuta",
"broutage" => "bRutaZ",
"broutaient" => "bRutE",
"broutait" => "bRutE",
"broutant" => "bRut@",
"broutantes" => "bRut@t",
"broutard" => "bRutaR",
"broute" => "bRut",
"brouté" => "bRute",
"broutée" => "bRute",
"broutent" => "bRut",
"brouter" => "bRute",
"brouterai" => "bRut°RE",
"brouteraient" => "bRut°RE",
"broutèrent" => "bRutER",
"broutes" => "bRut",
"broutés" => "bRute",
"brouteur" => "bRut9R",
"brouteurs" => "bRut9R",
"brouteuse" => "bRut2z",
"brouteuses" => "bRut2z",
"broutez" => "bRute",
"broutille" => "bRutij",
"broutilles" => "bRutij",
"brown sugar" => "bRawnSugaR",
"browning" => "bRoniG",
"brownings" => "bRoniG",
"broya" => "bRwaja",
"broyage" => "bRwajaZ",
"broyages" => "bRwajaZ",
"broyaient" => "bRwajE",
"broyais" => "bRwajE",
"broyait" => "bRwajE",
"broyant" => "bRwaj@",
"broyé" => "bRwaje",
"broyée" => "bRwaje",
"broyées" => "bRwaje",
"broyer" => "bRwaje",
"broyèrent" => "bRwajER",
"broyés" => "bRwaje",
"broyeur" => "bRwaj9R",
"broyeurs" => "bRwaj9R",
"broyeuse" => "bRwaj2z",
"broyez" => "bRwaje",
"brrr" => "bR",
"bru" => "bRy",
"bruant" => "bRy@",
"bruants" => "bRy@",
"brucellose" => "bRysEloz",
"brugeois" => "bRyZwa",
"brugeoise" => "bRyZwaz",
"brugeoises" => "bRyZwaz",
"bruges" => "bRyZ",
"brugnon" => "bRyN§",
"brugnons" => "bRyN§",
"bruinait" => "bR8inE",
"bruinasse" => "bR8inas",
"bruine" => "bR8in",
"bruiner" => "bR8ine",
"bruines" => "bR8in",
"bruire" => "bR8iR",
"bruissa" => "bR8isa",
"bruissaient" => "bR8isE",
"bruissait" => "bR8isE",
"bruissant" => "bR8is@",
"bruissante" => "bR8is@t",
"bruissantes" => "bR8is@t",
"bruissants" => "bR8is@",
"bruisse" => "bR8is",
"bruissé" => "bR8ise",
"bruissement" => "bR8is°m@",
"bruissements" => "bR8is°m@",
"bruissent" => "bR8is",
"bruit" => "bR8i",
"bruita" => "bR8ita",
"bruitage" => "bR8itaZ",
"bruitages" => "bR8itaZ",
"bruiter" => "bR8ite",
"bruiteur" => "bR8it9R",
"bruiteuse" => "bR8it2z",
"bruits" => "bR8i",
"brûla" => "bRyla",
"brûlage" => "bRylaZ",
"brûlai" => "bRylE",
"brûlaient" => "bRylE",
"brûlais" => "bRylE",
"brûlait" => "bRylE",
"brûlant" => "bRyl@",
"brûlante" => "bRyl@t",
"brûlantes" => "bRyl@t",
"brûlants" => "bRyl@",
"brûlasse" => "bRylas",
"brûlassent" => "bRylas",
"brûlât" => "bRyla",
"brûle" => "bRyl",
"brûlé" => "bRyle",
"brûle-gueule" => "bRylg9l",
"brûlée" => "bRyle",
"brûlées" => "bRyle",
"brûlent" => "bRyl",
"brûler" => "bRyle",
"brûlera" => "bRyl°Ra",
"brûlerai" => "bRyl°RE",
"brûleraient" => "bRyl°RE",
"brûlerais" => "bRyl°RE",
"brûlerait" => "bRyl°RE",
"brûleras" => "bRyl°Ra",
"brûlèrent" => "bRylER",
"brûlerez" => "bRyl°Re",
"brûlerons" => "bRyl°R§",
"brûleront" => "bRyl°R§",
"brûles" => "bRyl",
"brûlés" => "bRyle",
"brûleur" => "bRyl9R",
"brûleurs" => "bRyl9R",
"brûleuse" => "bRyl2z",
"brûlez" => "bRyle",
"brûliez" => "bRylie",
"brûlions" => "bRylj§",
"brûlis" => "bRyli",
"brûloirs" => "bRylwaR",
"brûlons" => "bRyl§",
"brûlot" => "bRylo",
"brûlots" => "bRylo",
"brûlure" => "bRylyR",
"brûlures" => "bRylyR",
"brumaille" => "bRymaj",
"brumaire" => "bRymER",
"brumassait" => "bRymasE",
"brume" => "bRym",
"brument" => "bRym",
"brumes" => "bRym",
"brumeuse" => "bRym2z",
"brumeuses" => "bRym2z",
"brumeux" => "bRym2",
"brumisateur" => "bRymizat9R",
"brun" => "bR1",
"brunâtre" => "bRynatR",
"brunâtres" => "bRynatR",
"brunch" => "bR9nS",
"brunches" => "bR9nS",
"brunchs" => "bR9nS",
"brune" => "bRyn",
"brunes" => "bRyn",
"brunet" => "bRynE",
"brunette" => "bRynEt",
"brunettes" => "bRynEt",
"bruni" => "bRyni",
"brunie" => "bRyni",
"brunies" => "bRyni",
"brunir" => "bRyniR",
"brunirent" => "bRyniR",
"brunis" => "bRyni",
"brunissage" => "bRynisaZ",
"brunissaient" => "bRynisE",
"brunissent" => "bRynis",
"brunissoir" => "bRyniswaR",
"brunissures" => "bRynisyR",
"brunit" => "bRyni",
"bruns" => "bR1",
"brus" => "bRy",
"brushing" => "bR9SiG",
"brusqua" => "bRyska",
"brusquai" => "bRyskE",
"brusquait" => "bRyskE",
"brusquant" => "bRysk@",
"brusquât" => "bRyska",
"brusque" => "bRysk",
"brusqué" => "bRyske",
"brusquée" => "bRyske",
"brusquement" => "bRysk°m@",
"brusquent" => "bRysk",
"brusquer" => "bRyske",
"brusquerai" => "bRysk°RE",
"brusqueraient" => "bRysk°RE",
"brusquerie" => "bRysk°Ri",
"brusqueries" => "bRysk°Ri",
"brusques" => "bRysk",
"brusquette" => "bRyskEt",
"brusquez" => "bRyske",
"brusquons" => "bRysk§",
"brut" => "bRyt",
"brutal" => "bRytal",
"brutale" => "bRytal",
"brutalement" => "bRytal°m@",
"brutales" => "bRytal",
"brutalisaient" => "bRytalizE",
"brutalisait" => "bRytalizE",
"brutalisant" => "bRytaliz@",
"brutalise" => "bRytaliz",
"brutalisé" => "bRytalize",
"brutalisée" => "bRytalize",
"brutalisées" => "bRytalize",
"brutaliser" => "bRytalize",
"brutaliserai" => "bRytaliz°RE",
"brutaliserait" => "bRytaliz°RE",
"brutalisés" => "bRytalize",
"brutalisez" => "bRytalize",
"brutalité" => "bRytalite",
"brutalités" => "bRytalite",
"brutaux" => "bRyto",
"brute" => "bRyt",
"brutes" => "bRyt",
"bruts" => "bRyt",
"bruxellois" => "bRysElwa",
"bruxelloise" => "bRysElwaz",
"bruyamment" => "bR8ijam@",
"bruyant" => "bR8ij@",
"bruyante" => "bR8ij@t",
"bruyantes" => "bR8ij@t",
"bruyants" => "bR8ij@",
"bruyère" => "bR8ijER",
"bruyères" => "bR8ijER",
"bu" => "by",
"bua" => "bya",
"buanderie" => "b8@d°Ri",
"buanderies" => "b8@d°Ri",
"bubble gum" => "b9b9lgOm",
"bubble-gum" => "b9b9lgOm",
"bubon" => "byb§",
"bubonique" => "bybonik",
"bubons" => "byb§",
"buccal" => "bykal",
"buccale" => "bykal",
"buccales" => "bykal",
"buccaux" => "byko",
"buccin" => "byks5",
"buccinateur" => "byksinat9R",
"bucco" => "buko",
"bucco-génital" => "bykoZenital",
"bucco-génitales" => "bykoZenital",
"bucco-génitaux" => "bykoZenito",
"buccogénitales" => "bykoZenital",
"bucéphales" => "bysefal",
"bûchais" => "bySE",
"bûchant" => "byS@",
"bûche" => "byS",
"bûché" => "bySe",
"bûchent" => "byS",
"bûcher" => "bySe",
"bûcheron" => "byS°R§",
"bûcheronne" => "byS°ROn",
"bûcheronner" => "byS°Rone",
"bûcherons" => "byS°R§",
"bûchers" => "bySe",
"bûches" => "byS",
"bûchette" => "bySEt",
"bûchettes" => "bySEt",
"bûcheur" => "byS9R",
"bûcheurs" => "byS9R",
"bûcheuse" => "byS2z",
"bûcheuses" => "byS2z",
"bûchez" => "bySe",
"bucoliastes" => "bykoljast",
"bucolique" => "bykolik",
"bucoliques" => "bykolik",
"bucranes" => "bykRan",
"buddha" => "byda",
"budget" => "bydZE",
"budgétaire" => "bydZetER",
"budgétairement" => "bydZetER°m@",
"budgétaires" => "bydZetER",
"budgétisation" => "bydZetizasj§",
"budgétivores" => "bydZetivOR",
"budgets" => "bydZE",
"bue" => "by",
"buée" => "b8e",
"buées" => "b8e",
"buen retiro" => "b8EnR2tiRo",
"bues" => "by",
"buffalo" => "byfalo",
"buffet" => "byfE",
"buffets" => "byfE",
"buffle" => "byfl",
"buffles" => "byfl",
"buffleterie" => "byflEt°Ri",
"buffleteries" => "byflEt°Ri",
"bufflonne" => "byflOn",
"bufo" => "bufo",
"bug" => "b9g",
"buggy" => "b9gi",
"bugle" => "bygl",
"bugler" => "bygle",
"bugles" => "bygl",
"bugne" => "byN",
"bugné" => "byNe",
"bugnes" => "byN",
"bugs" => "b9gz",
"building" => "bildiG",
"buildings" => "bildiG",
"buires" => "b8iR",
"buis" => "b8i",
"buisson" => "b8is§",
"buisson-ardent" => "b8is§aRd@",
"buissonnant" => "b8ison@",
"buissonnants" => "b8ison@",
"buissonne" => "b8isOn",
"buissonner" => "b8isone",
"buissonneuse" => "b8ison2z",
"buissonneuses" => "b8ison2z",
"buissonneux" => "b8ison2",
"buissonnière" => "b8isonjER",
"buissonnières" => "b8isonjER",
"buissons" => "b8is§",
"bulbe" => "bylb",
"bulbes" => "bylb",
"bulbeuse" => "bylb2z",
"bulbeux" => "bylb2",
"bulbul" => "bylbyl",
"bulgare" => "bylgaR",
"bulgares" => "bylgaR",
"bulgaro" => "bylgaRo",
"bulge" => "b9ldZ",
"bull" => "byl",
"bull-dog" => "buldOg",
"bull-dogs" => "buldOg",
"bull-finch" => "bylfinS",
"bull-terrier" => "byltERje",
"bulla" => "byla",
"bullaire" => "bylER",
"bulldog" => "buldOg",
"bulldogs" => "buldOg",
"bulldozer" => "byldozER",
"bulldozers" => "byldozER",
"bulle" => "byl",
"buller" => "byle",
"bulles" => "byl",
"bulletin" => "byl°t5",
"bulletins" => "byl°t5",
"bulleux" => "byl2",
"bullez" => "byle",
"bulls" => "byl",
"bulot" => "bulo",
"bulots" => "bylo",
"bûmes" => "bym",
"bumper" => "b9mp9R",
"buna" => "byna",
"bungalow" => "b1galo",
"bungalows" => "b1galo",
"bunker" => "bunkER",
"bunkers" => "bunkER",
"bunraku" => "b1Raky",
"bunsen" => "b1zEn",
"buprestes" => "bypREst",
"buraliste" => "byRalist",
"buralistes" => "byRalist",
"bure" => "byR",
"bureau" => "byRo",
"bureaucrate" => "byRokRat",
"bureaucrates" => "byRokRat",
"bureaucratie" => "byRokRasi",
"bureaucraties" => "byRokRasi",
"bureaucratique" => "byRokRatik",
"bureaucratiquement" => "byRokRatik°m@",
"bureaucratiques" => "byRokRatik",
"bureaucratisées" => "byRokRatize",
"bureautique" => "byRotik",
"bureaux" => "byRo",
"burent" => "byR",
"burette" => "byREt",
"burettes" => "byREt",
"burg" => "b9Rg",
"burger" => "b9Rg9R",
"burgers" => "b9Rg9R",
"burgondes" => "byRg§d",
"burgraviat" => "byRgRavja",
"burin" => "byR5",
"burina" => "byRina",
"buriné" => "byRine",
"burinée" => "byRine",
"burinées" => "byRine",
"buriner" => "byRine",
"burinés" => "byRine",
"burins" => "byR5",
"burkinabé" => "byRkinabe",
"burlesque" => "byRlEsk",
"burlesques" => "byRlEsk",
"burlingue" => "byRl5g",
"burlingues" => "byRl5g",
"burne" => "byRn",
"burnes" => "byRn",
"burnous" => "byRnus",
"burons" => "byR§",
"bursite" => "byRsit",
"burundais" => "byRyndE",
"bus" => "bys",
"busard" => "byzaR",
"busards" => "byzaR",
"buse" => "byz",
"buses" => "byz",
"bush" => "buS",
"bushi" => "buSi",
"bushido" => "buSido",
"bushman" => "buSman",
"business" => "biznEs",
"businessman" => "biznEsman",
"businessmen" => "biznEsmEn",
"busqué" => "byske",
"busse" => "bys",
"buste" => "byst",
"bustes" => "byst",
"bustier" => "bystje",
"but" => "by",
"bût" => "by",
"buta" => "byta",
"butadiène" => "bytadjEn",
"butagaz" => "bytagaz",
"butai" => "bytE",
"butaient" => "bytE",
"butais" => "bytE",
"butait" => "bytE",
"butane" => "bytan",
"butant" => "byt@",
"bute" => "byt",
"buté" => "byte",
"butée" => "byte",
"butées" => "byte",
"butent" => "byt",
"buter" => "byte",
"butera" => "byt°Ra",
"buterai" => "byt°RE",
"buterais" => "byt°RE",
"buterait" => "byt°RE",
"buteras" => "byt°Ra",
"butèrent" => "bytER",
"buterez" => "byt°Re",
"buterions" => "byt°Rj§",
"buteront" => "byt°R§",
"butes" => "byt",
"butés" => "byte",
"buteur" => "byt9R",
"butez" => "byte",
"butin" => "byt5",
"butinait" => "bytinE",
"butinant" => "bytin@",
"butine" => "bytin",
"butiné" => "bytine",
"butinées" => "bytine",
"butinent" => "bytin",
"butiner" => "bytine",
"butines" => "bytin",
"butinés" => "bytine",
"butineur" => "bytin9R",
"butineuse" => "bytin2z",
"butineuses" => "bytin2z",
"butins" => "byt5",
"butoir" => "bytwaR",
"butoirs" => "bytwaR",
"butons" => "byt§",
"butor" => "bytOR",
"butors" => "bytOR",
"buts" => "byt",
"butte" => "byt",
"butté" => "byte",
"butter" => "byte",
"buttèrent" => "bytER",
"buttes" => "byt",
"buttés" => "byte",
"butteur" => "byt9R",
"buttoir" => "bytwaR",
"buvable" => "byvabl",
"buvables" => "byvabl",
"buvaient" => "byvE",
"buvais" => "byvE",
"buvait" => "byvE",
"buvant" => "byv@",
"buvard" => "byvaR",
"buvarde" => "byvaRd",
"buvardé" => "byvaRde",
"buvardés" => "byvaRde",
"buvards" => "byvaR",
"buvette" => "byvEt",
"buvettes" => "byvEt",
"buveur" => "byv9R",
"buveurs" => "byv9R",
"buveuse" => "byv2z",
"buvez" => "byve",
"buviez" => "byvje",
"buvions" => "byvj§",
"buvons" => "byv§",
"by" => "bi",
"by night" => "bajnajt",
"by-pass" => "bajpas",
"bye" => "baj",
"bye-bye" => "bajbaj",
"byronien" => "biRonj5",
"bytes" => "bit",
"bytures" => "bityR",
"byzantin" => "biz@t5",
"byzantine" => "biz@tin",
"byzantines" => "biz@tin",
"byzantinisant" => "biz@tiniz@",
"byzantinisme" => "biz@tinizm",
"byzantins" => "biz@t5",
"c" => "se",
"c'est-à-dire" => "sEtadiR",
"ça" => "sa",
"çà" => "sa",
"cab" => "kab",
"cabale" => "kabal",
"cabales" => "kabal",
"cabaliste" => "kabalist",
"cabalistes" => "kabalist",
"cabalistique" => "kabalistik",
"cabalistiques" => "kabalistik",
"caballero" => "kabajeRo",
"caban" => "kab@",
"cabana" => "kabana",
"cabane" => "kaban",
"cabanes" => "kaban",
"cabanettes" => "kabanEt",
"cabanon" => "kaban§",
"cabanons" => "kaban§",
"cabans" => "kab@",
"cabaret" => "kabaRE",
"cabaretier" => "kabaR°tje",
"cabaretière" => "kabaR°tjER",
"cabaretiers" => "kabaR°tje",
"cabarets" => "kabaRE",
"cabas" => "kaba",
"cabèche" => "kabES",
"cabèches" => "kabES",
"cabécous" => "kabeku",
"caberlot" => "kabERlo",
"cabernet" => "kabERnE",
"cabestan" => "kabEst@",
"cabiais" => "kabjE",
"cabillaud" => "kabijo",
"cabillots" => "kabijo",
"cabine" => "kabin",
"cabiner" => "kabine",
"cabines" => "kabin",
"cabinet" => "kabinE",
"cabinets" => "kabinE",
"câbla" => "kabla",
"câblage" => "kablaZ",
"câblages" => "kablaZ",
"câblait" => "kablE",
"câble" => "kabl",
"câblé" => "kable",
"câblée" => "kable",
"câblées" => "kable",
"câbler" => "kable",
"câblerais" => "kabl°RE",
"câblerie" => "kabl°Ri",
"câbleront" => "kabl°R§",
"câbles" => "kabl",
"câblés" => "kable",
"câbleur" => "kabl9R",
"câbleurs" => "kabl9R",
"câblez" => "kable",
"câblier" => "kablije",
"câblogramme" => "kablogRam",
"cabochard" => "kaboSaR",
"cabocharde" => "kaboSaRd",
"cabochards" => "kaboSaR",
"caboche" => "kabOS",
"caboches" => "kabOS",
"cabochon" => "kaboS§",
"cabochons" => "kaboS§",
"cabossa" => "kabosa",
"cabossages" => "kabosaZ",
"cabossait" => "kabosE",
"cabosse" => "kabOs",
"cabossé" => "kabose",
"cabossée" => "kabose",
"cabossées" => "kabose",
"cabosser" => "kabose",
"cabosses" => "kabOs",
"cabossés" => "kabose",
"cabot" => "kabo",
"cabotage" => "kabotaZ",
"cabotaient" => "kabotE",
"cabotait" => "kabotE",
"cabote" => "kabOt",
"caboté" => "kabote",
"caboter" => "kabote",
"caboteur" => "kabot9R",
"cabotin" => "kabot5",
"cabotinage" => "kabotinaZ",
"cabotine" => "kabotin",
"cabotines" => "kabotin",
"cabotins" => "kabot5",
"cabots" => "kabo",
"caboulot" => "kabulo",
"caboulots" => "kabulo",
"cabra" => "kabRa",
"cabrade" => "kabRad",
"cabrage" => "kabRaZ",
"cabraient" => "kabRE",
"cabrais" => "kabRE",
"cabrait" => "kabRE",
"cabrant" => "kabR@",
"cabre" => "kabR",
"cabré" => "kabRe",
"cabrée" => "kabRe",
"cabrées" => "kabRe",
"cabrent" => "kabR",
"cabrer" => "kabRe",
"cabrera" => "kabR°Ra",
"cabrerait" => "kabR°RE",
"cabrèrent" => "kabRER",
"cabrés" => "kabRe",
"cabrette" => "kabREt",
"cabri" => "kabRi",
"cabriolaient" => "kabRijolE",
"cabriolait" => "kabRijolE",
"cabriolant" => "kabRijol@",
"cabriole" => "kabRijOl",
"cabrioler" => "kabRijole",
"cabrioles" => "kabRijOl",
"cabriolet" => "kabRijolE",
"cabriolets" => "kabRijolE",
"cabris" => "kabRi",
"cabs" => "kab",
"cabus" => "kaby",
"caca" => "kaka",
"cacahouète" => "kakawEt",
"cacahouètes" => "kakawEt",
"cacahuète" => "kakawEt",
"cacahuètes" => "kakawEt",
"cacao" => "kakao",
"cacaos" => "kakao",
"cacaotés" => "kakaote",
"cacaotier" => "kakaOtje",
"cacaoyer" => "kakawaje",
"cacarda" => "kakaRda",
"cacardait" => "kakaRdE",
"cacarde" => "kakaRd",
"cacas" => "kaka",
"cacatoès" => "kakatoEs",
"cacatois" => "kakatwa",
"cacha" => "kaSa",
"cachai" => "kaSE",
"cachaient" => "kaSE",
"cachais" => "kaSE",
"cachait" => "kaSE",
"cachalot" => "kaSalo",
"cachalots" => "kaSalo",
"cachant" => "kaS@",
"cachât" => "kaSa",
"cache" => "kaS",
"caché" => "kaSe",
"cache-brassière" => "kaSbRasjER",
"cache-cache" => "kaSkaS",
"cache-coeur" => "kaSk9R",
"cache-col" => "kaSkOl",
"cache-corset" => "kaSkORsE",
"cache-nez" => "kaSne",
"cache-pot" => "kaSpo",
"cache-pots" => "kaSpo",
"cache-poussière" => "kaSpusjER",
"cache-sexe" => "kaSseks",
"cache-tampon" => "kaSt@p§",
"cachectique" => "kaSEktik",
"cachectiques" => "kaSEktik",
"cachée" => "kaSe",
"cachées" => "kaSe",
"cachemire" => "kaS°miR",
"cachemires" => "kaS°miR",
"cachemiris" => "kaS°miRi",
"cachent" => "kaS",
"cacher" => "kaSe",
"cachera" => "kaS°Ra",
"cacherai" => "kaS°RE",
"cacheraient" => "kaS°RE",
"cacherais" => "kaS°RE",
"cacherait" => "kaS°RE",
"cacheras" => "kaS°Ra",
"cachère" => "kaSER",
"cachèrent" => "kaSER",
"cacherez" => "kaS°Re",
"cacheriez" => "kaS°Rje",
"cacherons" => "kaS°R§",
"cacheront" => "kaS°R§",
"caches" => "kaS",
"cachés" => "kaSe",
"cachet" => "kaSE",
"cacheta" => "kaS°ta",
"cachetais" => "kaS°tE",
"cachetait" => "kaS°tE",
"cacheté" => "kaS°te",
"cachetée" => "kaS°te",
"cachetées" => "kaS°te",
"cacheter" => "kaS°te",
"cachetés" => "kaS°te",
"cacheton" => "kaS°t§",
"cachetonnais" => "kaS°tonE",
"cachetonnait" => "kaS°tonE",
"cachetonne" => "kaS°tOn",
"cachetons" => "kaS°t§",
"cachets" => "kaSE",
"cachette" => "kaSEt",
"cachettes" => "kaSEt",
"cachexie" => "kaSEksi",
"cachez" => "kaSe",
"cachiez" => "kaSje",
"cachions" => "kaSj§",
"cachons" => "kaS§",
"cachot" => "kaSo",
"cachots" => "kaSo",
"cachotterie" => "kaSOt°Ri",
"cachotteries" => "kaSOt°Ri",
"cachottier" => "kaSotje",
"cachottière" => "kaSotjER",
"cachottières" => "kaSotjER",
"cachottiers" => "kaSotje",
"cachou" => "kaSu",
"cachous" => "kaSu",
"cacique" => "kasik",
"caciques" => "kasik",
"cacochyme" => "kakoSim",
"cacochymes" => "kakoSim",
"cacodylate" => "kakodilat",
"cacographes" => "kakogRaf",
"cacophonie" => "kakofoni",
"cacophonies" => "kakofoni",
"cacophonique" => "kakofonik",
"cacophoniques" => "kakofonik",
"cactées" => "kakte",
"cactus" => "kaktys",
"cadastral" => "kadastRal",
"cadastrale" => "kadastRal",
"cadastraux" => "kadastRo",
"cadastre" => "kadastR",
"cadastré" => "kadastRe",
"cadastrée" => "kadastRe",
"cadastres" => "kadastR",
"cadavéreuse" => "kadaveR2z",
"cadavéreux" => "kadaveR2",
"cadavérique" => "kadaveRik",
"cadavériques" => "kadaveRik",
"cadavérise" => "kadaveRiz",
"cadavérisés" => "kadaveRize",
"cadavre" => "kadavR",
"cadavres" => "kadavR",
"caddie" => "kadi",
"caddies" => "kadi",
"caddy" => "kadi",
"cade" => "kad",
"cadeau" => "kado",
"cadeaux" => "kado",
"cadenas" => "kad°na",
"cadenassaient" => "kad°nasE",
"cadenassait" => "kad°nasE",
"cadenassant" => "kad°nas@",
"cadenasse" => "kad°nas",
"cadenassé" => "kad°nase",
"cadenassée" => "kad°nase",
"cadenassées" => "kad°nase",
"cadenasser" => "kad°nase",
"cadenassez" => "kad°nase",
"cadence" => "kad@s",
"cadencé" => "kad@se",
"cadencée" => "kad@se",
"cadencées" => "kad@se",
"cadencer" => "kad@se",
"cadences" => "kad@s",
"cadencés" => "kad@se",
"cadènes" => "kadEn",
"cadet" => "kadE",
"cadets" => "kadE",
"cadette" => "kadEt",
"cadettes" => "kadEt",
"cadi" => "kadi",
"cadmié" => "kadmje",
"cadmium" => "kadmjOm",
"cadogan" => "kadog@",
"cador" => "kadOR",
"cadors" => "kadOR",
"cadrage" => "kadRaZ",
"cadrages" => "kadRaZ",
"cadrais" => "kadRE",
"cadrait" => "kadRE",
"cadran" => "kadR@",
"cadrans" => "kadR@",
"cadrant" => "kadR@",
"cadratin" => "kadRat5",
"cadratins" => "kadRat5",
"cadre" => "kadR",
"cadré" => "kadRe",
"cadrée" => "kadRe",
"cadrent" => "kadR",
"cadrer" => "kadRe",
"cadres" => "kadR",
"cadreur" => "kadR9R",
"cadreurs" => "kadR9R",
"cadrez" => "kadRe",
"caduc" => "kadyk",
"caducée" => "kadyse",
"caducées" => "kadyse",
"caducité" => "kadysite",
"caducs" => "kadyk",
"caduque" => "kadyk",
"caduques" => "kadyk",
"caecum" => "sekOm",
"caesium" => "sezjOm",
"caf" => "kaf",
"cafard" => "kafaR",
"cafardage" => "kafaRdaZ",
"cafarde" => "kafaRd",
"cafarder" => "kafaRde",
"cafarderait" => "kafaRd°RE",
"cafardeur" => "kafaRd9R",
"cafardeuse" => "kafaRd2z",
"cafardeux" => "kafaRd2",
"cafards" => "kafaR",
"café" => "kafe",
"café-concert" => "kafek§sER",
"café-crème" => "kafekREm",
"café-hôtel" => "kafeotEl",
"café-restaurant" => "kafeREstOR@",
"café-tabac" => "kafetaba",
"café-théâtre" => "kafeteatR",
"caféier" => "kafeje",
"caféiers" => "kafeje",
"caféine" => "kafein",
"cafés" => "kafe",
"cafés-concerts" => "kafek§sER",
"cafetais" => "kaf°tE",
"cafetan" => "kaf°t@",
"cafetans" => "kaf°t@",
"cafeté" => "kaf°te",
"cafeter" => "kafte",
"cafeteria" => "kafeteRja",
"cafétéria" => "kafeteRja",
"cafeterias" => "kafeteRja",
"cafétérias" => "kafeteRja",
"cafeteur" => "kaf°t9R",
"cafetier" => "kaf°tje",
"cafetière" => "kaf°tjER",
"cafetières" => "kaf°tjER",
"cafetiers" => "kaf°tje",
"cafeton" => "kaf°t§",
"cafouilla" => "kafuja",
"cafouillage" => "kafujaZ",
"cafouillages" => "kafujaZ",
"cafouillait" => "kafujE",
"cafouillant" => "kafuj@",
"cafouille" => "kafuj",
"cafouillé" => "kafuje",
"cafouillent" => "kafuj",
"cafouiller" => "kafuje",
"cafouilles" => "kafuj",
"cafouilleuse" => "kafuj2z",
"cafouilleux" => "kafuj2",
"cafouillis" => "kafuji",
"cafre" => "kafR",
"caftage" => "kaftaZ",
"caftaient" => "kaftE",
"caftait" => "kaftE",
"caftan" => "kaft@",
"caftans" => "kaft@",
"cafte" => "kaft",
"cafté" => "kafte",
"cafter" => "kafte",
"cafterai" => "kaft°RE",
"cafterait" => "kaft°RE",
"cafteras" => "kaft°Ra",
"caftes" => "kaft",
"caftés" => "kafte",
"cafteur" => "kaft9R",
"cafteurs" => "kaft9R",
"cafteuse" => "kaft2z",
"cagade" => "kagad",
"cagades" => "kagad",
"cage" => "kaZ",
"cageot" => "kaZo",
"cageots" => "kaZo",
"cages" => "kaZ",
"cagette" => "kaZEt",
"cagettes" => "kaZEt",
"cagibi" => "kaZibi",
"cagibis" => "kaZibi",
"cagna" => "kaNa",
"cagnard" => "kaNaR",
"cagnards" => "kaNaR",
"cagnas" => "kaNa",
"cagne" => "kaN",
"cagneuse" => "kaN2z",
"cagneuses" => "kaN2z",
"cagneux" => "kaN2",
"cagnotte" => "kaNOt",
"cagot" => "kago",
"cagote" => "kagOt",
"cagotes" => "kagOt",
"cagots" => "kago",
"cagou" => "kagu",
"cagoulard" => "kagulaR",
"cagoulards" => "kagulaR",
"cagoule" => "kagul",
"cagoulé" => "kagule",
"cagoules" => "kagul",
"cagoulés" => "kagule",
"caguait" => "kagE",
"cague" => "kag",
"caguer" => "kage",
"cahier" => "kaje",
"cahiers" => "kaje",
"cahin-caha" => "ka5kaa",
"cahors" => "kaOR",
"cahot" => "kao",
"cahota" => "kaota",
"cahotait" => "kaotE",
"cahotant" => "kaot@",
"cahotante" => "kaot@t",
"cahote" => "kaOt",
"cahoté" => "kaote",
"cahotée" => "kaote",
"cahotées" => "kaote",
"cahotement" => "kaOt°m@",
"cahotent" => "kaOt",
"cahoter" => "kaote",
"cahotèrent" => "kaotER",
"cahotés" => "kaote",
"cahoteuse" => "kaot2z",
"cahoteuses" => "kaot2z",
"cahoteux" => "kaot2",
"cahotons" => "kaot§",
"cahots" => "kao",
"cahute" => "kayt",
"cahutes" => "kayt",
"caïd" => "kaid",
"caïds" => "kaid",
"cailla" => "kaja",
"caillaient" => "kajE",
"caillais" => "kajE",
"caillait" => "kajE",
"caillant" => "kaj@",
"caillasse" => "kajas",
"caillasser" => "kajase",
"caillasses" => "kajas",
"caille" => "kaj",
"caillé" => "kaje",
"caillebotis" => "kaj°boti",
"caillée" => "kaje",
"caillées" => "kaje",
"caillent" => "kaj",
"cailler" => "kaje",
"caillera" => "kaj°Ra",
"caillerait" => "kaj°RE",
"caillerez" => "kaj°Re",
"cailles" => "kaj",
"caillette" => "kajEt",
"caillot" => "kajo",
"caillots" => "kajo",
"caillou" => "kaju",
"cailloutage" => "kajutaZ",
"caillouté" => "kajute",
"caillouteuse" => "kajut2z",
"caillouteuses" => "kajut2z",
"caillouteux" => "kajut2",
"cailloutis" => "kajuti",
"cailloux" => "kaju",
"caïman" => "kaim@",
"caïmans" => "kaim@",
"caïque" => "kaik",
"caïques" => "kaik",
"cairn" => "kERn",
"cairns" => "kERn",
"cairote" => "kEROt",
"cairotes" => "kEROt",
"caisse" => "kEs",
"caisses" => "kEs",
"caissette" => "kEsEt",
"caissettes" => "kEsEt",
"caissier" => "kesje",
"caissière" => "kesjER",
"caissières" => "kesjER",
"caissiers" => "kesje",
"caisson" => "kEs§",
"caissons" => "kEs§",
"cajola" => "kaZola",
"cajolaient" => "kaZolE",
"cajolait" => "kaZolE",
"cajolant" => "kaZol@",
"cajole" => "kaZOl",
"cajolé" => "kaZole",
"cajolée" => "kaZole",
"cajolent" => "kaZOl",
"cajoler" => "kaZole",
"cajolera" => "kaZOl°Ra",
"cajolerai" => "kaZOl°RE",
"cajolerait" => "kaZOl°RE",
"cajolèrent" => "kaZolER",
"cajolerie" => "kaZOl°Ri",
"cajoleries" => "kaZOl°Ri",
"cajolés" => "kaZole",
"cajoleur" => "kaZol9R",
"cajoleurs" => "kaZol9R",
"cajoleuse" => "kaZol2z",
"cajou" => "kaZu",
"cajous" => "kaZu",
"cajun" => "kaZ1",
"cajuns" => "kaZ1",
"cake" => "kEk",
"cake-walk" => "kEkwOk",
"cakes" => "kEk",
"cal" => "kal",
"cala" => "kala",
"calabrais" => "kalabRE",
"calabraises" => "kalabREz",
"calade" => "kalad",
"calai" => "kalE",
"calaient" => "kalE",
"calais" => "kalE",
"calaisiens" => "kalEzj5",
"calaison" => "kalEz§",
"calait" => "kalE",
"calamar" => "kalamaR",
"calamars" => "kalamaR",
"calame" => "kalam",
"calames" => "kalam",
"calamine" => "kalamin",
"calamines" => "kalamin",
"calamistre" => "kalamistR",
"calamistré" => "kalamistRe",
"calamistrée" => "kalamistRe",
"calamistrés" => "kalamistRe",
"calamita" => "kalamita",
"calamitait" => "kalamitE",
"calamité" => "kalamite",
"calamités" => "kalamite",
"calamiteuse" => "kalamit2z",
"calamiteuses" => "kalamit2z",
"calamiteux" => "kalamit2",
"calanchaient" => "kal@SE",
"calanchais" => "kal@SE",
"calanche" => "kal@S",
"calanché" => "kal@Se",
"calancher" => "kal@Se",
"calandre" => "kal@dR",
"calanque" => "kal@k",
"calanques" => "kal@k",
"calant" => "kal@",
"calao" => "kalao",
"calbar" => "kalbaR",
"calbars" => "kalbaR",
"calbombe" => "kalb§b",
"calbombes" => "kalb§b",
"calcaire" => "kalkER",
"calcaires" => "kalkER",
"calce" => "kals",
"calcémie" => "kalsemi",
"calcer" => "kalse",
"calcerais" => "kals°RE",
"calcif" => "kalsif",
"calcification" => "kalsifikasj§",
"calcifié" => "kalsifje",
"calcifiée" => "kalsifje",
"calcifs" => "kalsif",
"calcinaient" => "kalsinE",
"calcinait" => "kalsinE",
"calcinant" => "kalsin@",
"calcination" => "kalsinasj§",
"calcine" => "kalsin",
"calciné" => "kalsine",
"calcinée" => "kalsine",
"calcinées" => "kalsine",
"calciner" => "kalsine",
"calcinés" => "kalsine",
"calcite" => "kalsit",
"calcium" => "kalsjOm",
"calcul" => "kalkyl",
"calcula" => "kalkyla",
"calculables" => "kalkylabl",
"calculai" => "kalkylE",
"calculaient" => "kalkylE",
"calculais" => "kalkylE",
"calculait" => "kalkylE",
"calculant" => "kalkyl@",
"calculateur" => "kalkylat9R",
"calculateurs" => "kalkylat9R",
"calculatrice" => "kalkylatRis",
"calculatrices" => "kalkylatRis",
"calcule" => "kalkyl",
"calculé" => "kalkyle",
"calculée" => "kalkyle",
"calculées" => "kalkyle",
"calculent" => "kalkyl",
"calculer" => "kalkyle",
"calculera" => "kalkyl°Ra",
"calculerai" => "kalkyl°RE",
"calculerait" => "kalkyl°RE",
"calculèrent" => "kalkylER",
"calcules" => "kalkyl",
"calculés" => "kalkyle",
"calculette" => "kalkylEt",
"calculettes" => "kalkylEt",
"calculeuse" => "kalkyl2z",
"calculez" => "kalkyle",
"calculiez" => "kalkylje",
"calculons" => "kalkyl§",
"calculs" => "kalkyl",
"caldarium" => "kaldaRjOm",
"caldeira" => "kaldeRa",
"cale" => "kal",
"calé" => "kale",
"cale-pied" => "kalpje",
"cale-pieds" => "kalpje",
"calebar" => "kal°baR",
"calebasse" => "kal°bas",
"calebasses" => "kal°bas",
"calebassier" => "kal°basje",
"calebombe" => "kal°b§b",
"calèche" => "kalES",
"calèches" => "kalES",
"calecif" => "kal°sif",
"caleçon" => "kals§",
"caleçonnade" => "kalsonad",
"caleçons" => "kals§",
"calédonien" => "kaledonj5",
"calédonienne" => "kaledonjEn",
"calédoniens" => "kaledonj5",
"calée" => "kale",
"calées" => "kale",
"caléidoscope" => "kaleidOskOp",
"calembour" => "kal@buR",
"calembours" => "kal@buR",
"calembredaine" => "kal@bR°dEn",
"calembredaines" => "kal@bR°dEn",
"calenché" => "kal@Se",
"calendaire" => "kal@dER",
"calendes" => "kal@d",
"calendo" => "kal@do",
"calendos" => "kal@do",
"calendre" => "kal@dR",
"calendrier" => "kal@dRije",
"calendriers" => "kal@dRije",
"calendula" => "kal@dyla",
"calent" => "kal",
"calepin" => "kal°p5",
"calepins" => "kal°p5",
"caler" => "kale",
"calerai" => "kal°RE",
"calerait" => "kal°RE",
"caleras" => "kal°Ra",
"calèrent" => "kalER",
"cales" => "kal",
"calés" => "kale",
"calez" => "kale",
"calf" => "kalf",
"calfat" => "kalfa",
"calfatage" => "kalfataZ",
"calfatait" => "kalfatE",
"calfatant" => "kalfat@",
"calfate" => "kalfat",
"calfaté" => "kalfate",
"calfatée" => "kalfate",
"calfater" => "kalfate",
"calfatés" => "kalfate",
"calfats" => "kalfa",
"calfeutra" => "kalf2tRa",
"calfeutrage" => "kalf2tRaZ",
"calfeutrai" => "kalf2tRE",
"calfeutraient" => "kalf2tRE",
"calfeutrais" => "kalf2tRE",
"calfeutrait" => "kalf2tRE",
"calfeutrant" => "kalf2tR@",
"calfeutre" => "kalf2tR",
"calfeutré" => "kalf2tRe",
"calfeutrée" => "kalf2tRe",
"calfeutrées" => "kalf2tRe",
"calfeutrer" => "kalf2tRe",
"calfeutres" => "kalf2tR",
"calfeutrés" => "kalf2tRe",
"calibrage" => "kalibRaZ",
"calibrages" => "kalibRaZ",
"calibration" => "kalibRasj§",
"calibre" => "kalibR",
"calibré" => "kalibRe",
"calibrée" => "kalibRe",
"calibrées" => "kalibRe",
"calibrer" => "kalibRe",
"calibres" => "kalibR",
"calibrés" => "kalibRe",
"calibrez" => "kalibRe",
"calice" => "kalis",
"calices" => "kalis",
"calicot" => "kaliko",
"calicots" => "kaliko",
"califat" => "kalifa",
"calife" => "kalif",
"califes" => "kalif",
"californie" => "kalifORni",
"californien" => "kalifORnj5",
"californienne" => "kalifORnjEn",
"californiennes" => "kalifORnjEn",
"californiens" => "kalifORnj5",
"californium" => "kalifORnijOm",
"califourchon" => "kalifuRS§",
"câlin" => "kal5",
"câlina" => "kalina",
"câlinait" => "kalinE",
"câlinant" => "kalin@",
"câline" => "kalin",
"câliné" => "kaline",
"câlinée" => "kaline",
"câlinement" => "kalin°m@",
"câlinent" => "kalin",
"câliner" => "kaline",
"câlinerai" => "kalin°RE",
"câlinerie" => "kalin°Ri",
"câlineries" => "kalin°Ri",
"câlines" => "kalin",
"câlins" => "kal5",
"calisson" => "kalis§",
"calissons" => "kalis§",
"call girl" => "kalg9Rl",
"call girls" => "kalg9Rl",
"call-girl" => "kOlg9Rl",
"call-girls" => "kOlg9Rl",
"calla" => "kala",
"calle" => "kal",
"caller" => "kale",
"calles" => "kal",
"calleuse" => "kal2z",
"calleuses" => "kal2z",
"calleux" => "kal2",
"calligrammes" => "kaligRam",
"calligraphe" => "kaligRaf",
"calligraphiais" => "kaligRafjE",
"calligraphiait" => "kaligRafjE",
"calligraphiant" => "kaligRafj@",
"calligraphie" => "kaligRafi",
"calligraphié" => "kaligRafje",
"calligraphiée" => "kaligRafje",
"calligraphiées" => "kaligRafje",
"calligraphient" => "kaligRafi",
"calligraphier" => "kaligRafje",
"calligraphies" => "kaligRafi",
"calligraphiés" => "kaligRafje",
"calligraphiez" => "kaligRafje",
"calligraphique" => "kaligRafik",
"calligraphiquement" => "kaligRafik°m@",
"calligraphiques" => "kaligRafik",
"callipyge" => "kalipiZ",
"callosité" => "kalozite",
"callosités" => "kalozite",
"calma" => "kalma",
"calmai" => "kalmE",
"calmaient" => "kalmE",
"calmais" => "kalmE",
"calmait" => "kalmE",
"calmant" => "kalm@",
"calmante" => "kalm@t",
"calmants" => "kalm@",
"calmar" => "kalmaR",
"calmars" => "kalmaR",
"calmas" => "kalma",
"calmât" => "kalma",
"calme" => "kalm",
"calmé" => "kalme",
"calmée" => "kalme",
"calmées" => "kalme",
"calmement" => "kalm°m@",
"calment" => "kalm",
"calmer" => "kalme",
"calmera" => "kalm°Ra",
"calmerai" => "kalm°RE",
"calmeraient" => "kalm°RE",
"calmerais" => "kalm°RE",
"calmerait" => "kalm°RE",
"calmeras" => "kalm°Ra",
"calmèrent" => "kalmER",
"calmerez" => "kalm°Re",
"calmerons" => "kalm°R§",
"calmeront" => "kalm°R§",
"calmes" => "kalm",
"calmés" => "kalme",
"calmez" => "kalme",
"calmi" => "kalmi",
"calmiez" => "kalmje",
"calmir" => "kalmiR",
"calmons" => "kalm§",
"calmos" => "kalmOs",
"calo" => "kalo",
"calomel" => "kalomEl",
"calomniant" => "kalOmnj@",
"calomniateur" => "kalOmnjat9R",
"calomniateurs" => "kalOmnjat9R",
"calomniatrice" => "kalOmnjatRis",
"calomnie" => "kalOmni",
"calomnié" => "kalOmnje",
"calomniée" => "kalOmnje",
"calomnient" => "kalOmni",
"calomnier" => "kalOmnje",
"calomnies" => "kalOmni",
"calomniés" => "kalOmnje",
"calomnieuse" => "kalOmnj2z",
"calomnieuses" => "kalOmnj2z",
"calomnieux" => "kalOmnj2",
"calomniez" => "kalOmnje",
"caloporteur" => "kalopORt9R",
"calorie" => "kaloRi",
"calories" => "kaloRi",
"calorifère" => "kaloRifER",
"calorifères" => "kaloRifER",
"calorifique" => "kaloRifik",
"calorifuges" => "kaloRifyZ",
"calorique" => "kaloRik",
"calot" => "kalo",
"calotin" => "kalot5",
"calotins" => "kalot5",
"calots" => "kalo",
"calottais" => "kalotE",
"calotte" => "kalOt",
"calotté" => "kalote",
"calottées" => "kalote",
"calottes" => "kalOt",
"calottés" => "kalote",
"calquaient" => "kalkE",
"calquait" => "kalkE",
"calquant" => "kalk@",
"calque" => "kalk",
"calqué" => "kalke",
"calquée" => "kalke",
"calquées" => "kalke",
"calquer" => "kalke",
"calquera" => "kalk°Ra",
"calques" => "kalk",
"cals" => "kal",
"calte" => "kalt",
"caltent" => "kalt",
"calter" => "kalte",
"caltés" => "kalte",
"caltez" => "kalte",
"caltons" => "kalt§",
"calumet" => "kalymE",
"calumets" => "kalymE",
"calus" => "kaly",
"calva" => "kalva",
"calvados" => "kalvados",
"calvaire" => "kalvER",
"calvaires" => "kalvER",
"calvas" => "kalva",
"calville" => "kalvil",
"calvilles" => "kalvil",
"calvinisme" => "kalvinizm",
"calviniste" => "kalvinist",
"calvinistes" => "kalvinist",
"calvitie" => "kalvisi",
"calvities" => "kalvisi",
"calypso" => "kalipso",
"cama" => "kama",
"camaïeu" => "kamaj2",
"camaïeux" => "kamaj2",
"camail" => "kamaj",
"camails" => "kamaj",
"camarade" => "kamaRad",
"camaraderie" => "kamaRad°Ri",
"camaraderies" => "kamaRad°Ri",
"camarades" => "kamaRad",
"camard" => "kamaR",
"camarde" => "kamaRd",
"camards" => "kamaR",
"camarero" => "kamaReRo",
"camareros" => "kamaR°Ro",
"camarguais" => "kamaRgE",
"camarguaises" => "kamaRgEz",
"camarilla" => "kamaRija",
"camarin" => "kamaR5",
"camarins" => "kamaR5",
"camarluche" => "kamaRlyS",
"camaro" => "kamaRo",
"camber" => "k@be",
"cambiste" => "k@bist",
"cambodgien" => "k@bOdZj5",
"cambodgienne" => "k@bOdZjEn",
"cambodgiennes" => "k@bOdZjEn",
"cambodgiens" => "k@bOdZj5",
"cambouis" => "k@bwi",
"cambra" => "k@bRa",
"cambrait" => "k@bRE",
"cambrant" => "k@bR@",
"cambre" => "k@bR",
"cambré" => "k@bRe",
"cambrée" => "k@bRe",
"cambrées" => "k@bRe",
"cambrement" => "k@bR°m@",
"cambrent" => "k@bR",
"cambrer" => "k@bRe",
"cambrera" => "k@bR°Ra",
"cambres" => "k@bR",
"cambrés" => "k@bRe",
"cambrez" => "k@bRe",
"cambrienne" => "k@bRijEn",
"cambriolage" => "k@bRijolaZ",
"cambriolages" => "k@bRijolaZ",
"cambriolaient" => "k@bRijolE",
"cambriolais" => "k@bRijolE",
"cambriolant" => "k@bRiol@",
"cambriole" => "k@bRijOl",
"cambriolé" => "k@bRijole",
"cambriolée" => "k@bRijole",
"cambriolées" => "k@bRijole",
"cambriolent" => "k@bRijOl",
"cambrioler" => "k@bRijole",
"cambrioles" => "k@bRiOl",
"cambriolés" => "k@bRiole",
"cambrioleur" => "k@bRijol9R",
"cambrioleurs" => "k@bRijol9R",
"cambrioleuse" => "k@bRiol2z",
"cambriolez" => "k@bRiole",
"cambrioliez" => "k@bRiolje",
"cambriolons" => "k@bRiol§",
"cambrousse" => "k@bRus",
"cambrousses" => "k@bRus",
"cambrure" => "k@bRyR",
"cambrures" => "k@bRyR",
"cambuse" => "k@byz",
"cambuses" => "k@byz",
"cambusier" => "k@byzje",
"cambute" => "k@byt",
"cambuté" => "k@byte",
"came" => "kam",
"camé" => "kame",
"camée" => "kame",
"camées" => "kame",
"caméléon" => "kamele§",
"caméléons" => "kamele§",
"camélia" => "kamelja",
"camélias" => "kamelja",
"camélidé" => "kamelide",
"camélidés" => "kamelide",
"camellia" => "kamelja",
"camelot" => "kam°lo",
"camelote" => "kam°lOt",
"camelotes" => "kam°lOt",
"camelots" => "kam°lo",
"camembert" => "kam@bER",
"camemberts" => "kam@bER",
"cament" => "kam",
"camer" => "kame",
"camera" => "kam°Ra",
"caméra" => "kameRa",
"caméra-espion" => "kameRaEspj§",
"cameraman" => "kameRaman",
"caméraman" => "kameRaman",
"caméramans" => "kameRaman",
"cameramen" => "kameRamEn",
"cameras" => "kam°Ra",
"caméras" => "kameRa",
"camériste" => "kameRist",
"caméristes" => "kameRist",
"camerounais" => "kam°RunE",
"camerounaise" => "kam°RunEz",
"cames" => "kam",
"camés" => "kame",
"caméscope" => "kameskOp",
"caméscopes" => "kameskOp",
"camez" => "kame",
"camion" => "kamj§",
"camion-benne" => "kamj§bEn",
"camion-citerne" => "kamj§sitERn",
"camion-grue" => "kamj§gRy",
"camionnage" => "kamjonaZ",
"camionnée" => "kamjone",
"camionnette" => "kamjonEt",
"camionnettes" => "kamjonEt",
"camionneur" => "kamjon9R",
"camionneurs" => "kamjon9R",
"camions" => "kamj§",
"camions-bennes" => "kamj§bEn",
"camions-citernes" => "kamj§sitERn",
"camisards" => "kamizaR",
"camisole" => "kamizOl",
"camisoles" => "kamizOl",
"camomille" => "kamomij",
"camomilles" => "kamomij",
"camorra" => "kamoRa",
"camoufla" => "kamufla",
"camouflage" => "kamuflaZ",
"camouflages" => "kamuflaZ",
"camouflaient" => "kamuflE",
"camouflais" => "kamuflE",
"camouflait" => "kamuflE",
"camouflant" => "kamufl@",
"camoufle" => "kamufl",
"camouflé" => "kamufle",
"camouflée" => "kamufle",
"camouflées" => "kamufle",
"camouflent" => "kamufl",
"camoufler" => "kamufle",
"camouflerait" => "kamufl°RE",
"camouflés" => "kamufle",
"camouflet" => "kamuflE",
"camouflets" => "kamuflE",
"camouflez" => "kamufle",
"camp" => "k@",
"campa" => "k@pa",
"campagnard" => "k@paNaR",
"campagnarde" => "k@paNaRd",
"campagnardes" => "k@paNaRd",
"campagnards" => "k@paNaR",
"campagne" => "k@paN",
"campagnes" => "k@paN",
"campagnol" => "k@paNOl",
"campagnols" => "k@paNOl",
"campaient" => "k@pE",
"campais" => "k@pE",
"campait" => "k@pE",
"campâmes" => "k@pam",
"campanaire" => "k@panER",
"campanelles" => "k@panEl",
"campanile" => "k@panil",
"campaniles" => "k@panil",
"campant" => "k@p@",
"campanule" => "k@panyl",
"campanules" => "k@panyl",
"campe" => "k@p",
"campé" => "k@pe",
"campêche" => "k@pES",
"campée" => "k@pe",
"campées" => "k@pe",
"campement" => "k@p°m@",
"campements" => "k@p°m@",
"campent" => "k@p",
"camper" => "k@pe",
"campera" => "k@p°Ra",
"camperai" => "k@p°RE",
"camperait" => "k@p°RE",
"campèrent" => "k@pER",
"camperons" => "k@p°R§",
"campes" => "k@p",
"campés" => "k@pe",
"campeur" => "k@p9R",
"campeurs" => "k@p9R",
"campeuse" => "k@p2z",
"campeuses" => "k@p2z",
"campez" => "k@pe",
"camphre" => "k@fR",
"camphrée" => "k@fRe",
"camphrées" => "k@fRe",
"camphrier" => "k@fRije",
"camping" => "k@piG",
"camping-car" => "k@piGkaR",
"camping-cars" => "k@piGkaR",
"camping-gaz" => "k@piGgaz",
"campings" => "k@piG",
"campions" => "k@pj§",
"campo" => "k@po",
"campons" => "k@p§",
"campos" => "k@po",
"camps" => "k@",
"campus" => "k@pys",
"camus" => "kamy",
"camuse" => "kamyz",
"cana" => "kana",
"canada" => "kanada",
"canadair" => "kanadER",
"canadairs" => "kanadER",
"canadian river" => "kanadj@Rive",
"canadien" => "kanadj5",
"canadienne" => "kanadjEn",
"canadiennes" => "kanadjEn",
"canadiens" => "kanadj5",
"canado" => "kanado",
"canaille" => "kanaj",
"canaillement" => "kanaj°m@",
"canaillerie" => "kanaj°Ri",
"canailles" => "kanaj",
"canal" => "kanal",
"canalicules" => "kanalikyl",
"canalisa" => "kanaliza",
"canalisaient" => "kanalizE",
"canalisait" => "kanalizE",
"canalisateur" => "kanalizat9R",
"canalisation" => "kanalizasj§",
"canalisations" => "kanalizasj§",
"canalise" => "kanaliz",
"canalisé" => "kanalize",
"canalisée" => "kanalize",
"canalisées" => "kanalize",
"canalisent" => "kanaliz",
"canaliser" => "kanalize",
"canalisés" => "kanalize",
"canalisez" => "kanalize",
"canalisons" => "kanaliz§",
"cananéen" => "kanane5",
"canapé" => "kanape",
"canapé-lit" => "kanapeli",
"canapés" => "kanape",
"canapés-lits" => "kanapeli",
"canaque" => "kanak",
"canaques" => "kanak",
"canard" => "kanaR",
"canardaient" => "kanaRdE",
"canardait" => "kanaRdE",
"canarde" => "kanaRd",
"canardé" => "kanaRde",
"canardeaux" => "kanaRdo",
"canardée" => "kanaRde",
"canardent" => "kanaRd",
"canarder" => "kanaRde",
"canardera" => "kanaRd°Ra",
"canarderais" => "kanaRd°RE",
"canarderont" => "kanaRd°R§",
"canardés" => "kanaRde",
"canardez" => "kanaRde",
"canards" => "kanaR",
"canari" => "kanaRi",
"canaris" => "kanaRi",
"canas" => "kana",
"canasson" => "kanas§",
"canassons" => "kanas§",
"canasta" => "kanasta",
"canaux" => "kano",
"cancan" => "k@k@",
"cancanaient" => "k@kanE",
"cancanait" => "k@kanE",
"cancanant" => "k@kan@",
"cancane" => "k@kan",
"cancaner" => "k@kane",
"cancaneries" => "k@kan°Ri",
"cancanes" => "k@kan",
"cancanier" => "k@kanje",
"cancanière" => "k@kanjER",
"cancanières" => "k@kanjER",
"cancans" => "k@k@",
"cancel" => "k@sEl",
"cancer" => "k@sER",
"cancéreuse" => "k@seR2z",
"cancéreuses" => "k@seR2z",
"cancéreux" => "k@seR2",
"cancérigène" => "k@seRiZEn",
"cancérigènes" => "k@seRiZEn",
"cancériser" => "k@seRize",
"cancérogène" => "k@seROZEn",
"cancérologie" => "k@seROlOZi",
"cancérologue" => "k@seROlOg",
"cancérologues" => "k@seRolOg",
"cancers" => "k@sER",
"canche" => "k@S",
"cancoillotte" => "k@kwajOt",
"cancre" => "k@kR",
"cancrelat" => "k@kR°la",
"cancrelats" => "k@kR°la",
"cancres" => "k@kR",
"candélabre" => "k@delabR",
"candélabres" => "k@delabR",
"candeur" => "k@d9R",
"candeurs" => "k@d9R",
"candi" => "k@di",
"candida" => "k@dida",
"candidat" => "k@dida",
"candidate" => "k@didat",
"candidates" => "k@didat",
"candidats" => "k@dida",
"candidature" => "k@didatyR",
"candidatures" => "k@didatyR",
"candide" => "k@did",
"candidement" => "k@did°m@",
"candides" => "k@did",
"candidose" => "k@didoz",
"candie" => "k@di",
"candis" => "k@di",
"cane" => "kan",
"cané" => "kane",
"canebière" => "kan°bjER",
"canepetière" => "kan°p°tjER",
"caner" => "kane",
"caneras" => "kan°Ra",
"canes" => "kan",
"canés" => "kane",
"canetille" => "kan°til",
"caneton" => "kan°t§",
"canetons" => "kan°t§",
"canette" => "kanEt",
"canettes" => "kanEt",
"canevas" => "kan°va",
"canfouine" => "k@fwin",
"cangue" => "k@g",
"caniche" => "kaniS",
"caniches" => "kaniS",
"caniculaire" => "kanikylER",
"caniculaires" => "kanikylER",
"canicule" => "kanikyl",
"canicules" => "kanikyl",
"canidés" => "kanide",
"canif" => "kanif",
"canifs" => "kanif",
"canin" => "kan5",
"canine" => "kanin",
"canines" => "kanin",
"caninette" => "kaninEt",
"canins" => "kan5",
"canisses" => "kanis",
"caniveau" => "kanivo",
"caniveaux" => "kanivo",
"canna" => "kana",
"cannabis" => "kanabis",
"cannage" => "kanaZ",
"cannait" => "kanE",
"cannant" => "kan@",
"cannas" => "kana",
"canne" => "kan",
"canné" => "kane",
"canne-épée" => "kanepe",
"canneberge" => "kan°bERZ",
"canneberges" => "kan°bERZ",
"cannée" => "kane",
"cannées" => "kane",
"cannelé" => "kan°le",
"cannelée" => "kan°le",
"cannelées" => "kan°le",
"cannelés" => "kan°le",
"canneliers" => "kan°lje",
"cannelle" => "kanEl",
"cannelloni" => "kanelOni",
"cannellonis" => "kanEloni",
"cannelure" => "kan°lyR",
"cannelures" => "kan°lyR",
"canner" => "kane",
"canneraient" => "kan°RE",
"cannes" => "kan",
"cannes-épées" => "kanepe",
"cannette" => "kanEt",
"cannettes" => "kanEt",
"cannibale" => "kanibal",
"cannibales" => "kanibal",
"cannibalisme" => "kanibalizm",
"canoë" => "kanoe",
"canoës" => "kanoe",
"canon" => "kan§",
"cañon" => "kaNOn",
"canoniale" => "kanonjal",
"canoniales" => "kanonjal",
"canonique" => "kanonik",
"canoniquement" => "kanonik°m@",
"canoniques" => "kanonik",
"canonisation" => "kanonizasj§",
"canonisations" => "kanonizasj§",
"canonisé" => "kanonize",
"canonisée" => "kanonize",
"canoniser" => "kanonize",
"canonisés" => "kanonize",
"canonisez" => "kanonize",
"canonnade" => "kanonad",
"canonnades" => "kanonad",
"canonnage" => "kanOnaZ",
"canonnait" => "kanonE",
"canonné" => "kanone",
"canonnées" => "kanone",
"canonner" => "kanone",
"canonnés" => "kanone",
"canonnier" => "kanonje",
"canonnière" => "kanonjER",
"canonnières" => "kanonjER",
"canonniers" => "kanonje",
"canons" => "kan§",
"canope" => "kanOp",
"canopes" => "kanOp",
"canot" => "kano",
"canotage" => "kanotaZ",
"canotaient" => "kanotE",
"canotâmes" => "kanotam",
"canote" => "kanOt",
"canoté" => "kanote",
"canotent" => "kanOt",
"canoter" => "kanote",
"canoteurs" => "kanot9R",
"canotier" => "kanotje",
"canotiers" => "kanotje",
"canots" => "kano",
"cantabile" => "k@tabil",
"cantabrique" => "k@tabRik",
"cantabriques" => "k@tabRik",
"cantal" => "k@tal",
"cantaloup" => "k@talu",
"cantaloups" => "k@talu",
"cantate" => "k@tat",
"cantates" => "k@tat",
"cantatrice" => "k@tatRis",
"cantatrices" => "k@tatRis",
"canter" => "k@t9R",
"canthare" => "k@taR",
"canthares" => "k@taR",
"cantharide" => "k@taRid",
"cantharides" => "k@taRid",
"cantilène" => "k@tilEn",
"cantilever" => "k@til°ve",
"cantina" => "k@tina",
"cantinaient" => "k@tinE",
"cantine" => "k@tin",
"cantiner" => "k@tine",
"cantines" => "k@tin",
"cantinier" => "k@tinje",
"cantinière" => "k@tinjER",
"cantinières" => "k@tinjER",
"cantiniers" => "k@tinje",
"cantique" => "k@tik",
"cantiques" => "k@tik",
"canton" => "k@t§",
"cantonade" => "k@tonad",
"cantonais" => "k@tonE",
"cantonaise" => "k@tonEz",
"cantonal" => "k@tonal",
"cantonale" => "k@tonal",
"cantonales" => "k@tonal",
"cantonna" => "k@tona",
"cantonnai" => "k@tonE",
"cantonnaient" => "k@tonE",
"cantonnais" => "k@tonE",
"cantonnait" => "k@tonE",
"cantonnant" => "k@ton@",
"cantonne" => "k@tOn",
"cantonné" => "k@tone",
"cantonnée" => "k@tone",
"cantonnées" => "k@tone",
"cantonnement" => "k@tOn°m@",
"cantonnements" => "k@tOn°m@",
"cantonnent" => "k@tOn",
"cantonner" => "k@tone",
"cantonneraient" => "k@tOn°RE",
"cantonnèrent" => "k@tonER",
"cantonnés" => "k@tone",
"cantonnez" => "k@tone",
"cantonnier" => "k@tonje",
"cantonnières" => "k@tonjER",
"cantonniers" => "k@tonje",
"cantonnons" => "k@ton§",
"cantons" => "k@t§",
"cantre" => "k@tR",
"canulant" => "kanyl@",
"canular" => "kanylaR",
"canularesque" => "kanylaREsk",
"canulars" => "kanylaR",
"canule" => "kanyl",
"canut" => "kany",
"canuts" => "kany",
"canyon" => "kanjOn",
"canyons" => "kanjOn",
"canzonettes" => "k@zonEt",
"caoua" => "kawa",
"caouas" => "kawa",
"caoutchouc" => "kautSu",
"caoutchoucs" => "kautSu",
"caoutchouté" => "kautSute",
"caoutchoutée" => "kautSute",
"caoutchoutées" => "kautSute",
"caoutchoutés" => "kautSute",
"caoutchouteuse" => "kautSut2z",
"caoutchouteuses" => "kautSut2z",
"caoutchouteux" => "kautSut2",
"cap" => "kap",
"cap-hornier" => "kapORnje",
"capable" => "kapabl",
"capables" => "kapabl",
"capacité" => "kapasite",
"capacités" => "kapasite",
"capades" => "kapad",
"caparaçon" => "kapaRas§",
"caparaçonnait" => "kapaRasonE",
"caparaçonne" => "kapaRasOn",
"caparaçonné" => "kapaRasone",
"caparaçonnée" => "kapaRasone",
"caparaçonnées" => "kapaRasone",
"caparaçonnés" => "kapaRasone",
"caparaçons" => "kapaRas§",
"cape" => "kap",
"capelage" => "kap°laZ",
"capelé" => "kap°le",
"capeline" => "kap°lin",
"capelines" => "kap°lin",
"caper" => "kape",
"capes" => "kap",
"capétien" => "kapesj5",
"capétienne" => "kapesjEn",
"capétiennes" => "kapesjEn",
"capharnaüm" => "kafaRnaOm",
"capillaire" => "kapilER",
"capillaires" => "kapilER",
"capillarité" => "kapilaRite",
"capilliculteur" => "kapilikylt9R",
"capilotade" => "kapilotad",
"capilotades" => "kapilotad",
"capisco" => "kapisko",
"capitaine" => "kapitEn",
"capitainerie" => "kapitEn°Ri",
"capitaines" => "kapitEn",
"capital" => "kapital",
"capital-risque" => "kapitalRisk",
"capitale" => "kapital",
"capitalement" => "kapital°m@",
"capitales" => "kapital",
"capitalisation" => "kapitalizasj§",
"capitalise" => "kapitaliz",
"capitalisé" => "kapitalize",
"capitaliser" => "kapitalize",
"capitalisés" => "kapitalize",
"capitalisme" => "kapitalizm",
"capitalisons" => "kapitaliz§",
"capitaliste" => "kapitalist",
"capitalistes" => "kapitalist",
"capitalistiques" => "kapitalistik",
"capitan" => "kapit@",
"capitanat" => "kapitana",
"capitane" => "kapitan",
"capitans" => "kapit@",
"capitaux" => "kapito",
"capiteuse" => "kapit2z",
"capiteuses" => "kapit2z",
"capiteux" => "kapit2",
"capitole" => "kapitOl",
"capiton" => "kapit§",
"capitonnage" => "kapitonaZ",
"capitonnaient" => "kapitonE",
"capitonnait" => "kapitonE",
"capitonné" => "kapitone",
"capitonnée" => "kapitone",
"capitonnées" => "kapitone",
"capitonner" => "kapitone",
"capitonnés" => "kapitone",
"capitons" => "kapit§",
"capitouls" => "kapitul",
"capitula" => "kapityla",
"capitulaient" => "kapitylE",
"capitulaire" => "kapitylER",
"capitulais" => "kapitylE",
"capitulait" => "kapitylE",
"capitulant" => "kapityl@",
"capitulard" => "kapitylaR",
"capitulation" => "kapitylasj§",
"capitulations" => "kapitylasj§",
"capitule" => "kapityl",
"capitulé" => "kapityle",
"capitulent" => "kapityl",
"capituler" => "kapityle",
"capitulera" => "kapityl°Ra",
"capitulerait" => "kapityl°RE",
"capitulèrent" => "kapitylER",
"capitulerez" => "kapityl°Re",
"capitulerons" => "kapityl°R§",
"capituleront" => "kapityl°R§",
"capitules" => "kapityl",
"capituliez" => "kapitylje",
"capitulions" => "kapitylj§",
"capitulons" => "kapityl§",
"capo" => "kapo",
"capoc" => "kapo",
"capon" => "kap§",
"capons" => "kap§",
"caporal" => "kapoRal",
"caporal-chef" => "kapoRalSEf",
"caporale" => "kapoRal",
"caporaux" => "kapoRo",
"capos" => "kapo",
"capot" => "kapo",
"capota" => "kapota",
"capotaient" => "kapotE",
"capote" => "kapOt",
"capoté" => "kapote",
"capotée" => "kapote",
"capoter" => "kapote",
"capotes" => "kapOt",
"capots" => "kapo",
"cappa" => "kapa",
"cappuccino" => "kaputSino",
"cappuccinos" => "kaputSino",
"câpre" => "kapR",
"câpres" => "kapR",
"capricant" => "kapRik@",
"capricants" => "kapRik@",
"caprice" => "kapRis",
"caprices" => "kapRis",
"capricieuse" => "kapRisj2z",
"capricieusement" => "kapRisj2z°m@",
"capricieuses" => "kapRisj2z",
"capricieux" => "kapRisj2",
"capricorne" => "kapRikORn",
"capricornes" => "kapRikORn",
"câpriers" => "kapRije",
"caprine" => "kapRin",
"caps" => "kap",
"capsulaire" => "kapsylER",
"capsule" => "kapsyl",
"capsulé" => "kapsyle",
"capsules" => "kapsyl",
"capta" => "kapta",
"captage" => "kaptaZ",
"captaient" => "kaptE",
"captais" => "kaptE",
"captait" => "kaptE",
"captant" => "kapt@",
"captation" => "kaptasj§",
"captations" => "kaptasj§",
"capte" => "kapt",
"capté" => "kapte",
"captée" => "kapte",
"captées" => "kapte",
"captent" => "kapt",
"capter" => "kapte",
"capterai" => "kapt°RE",
"capterais" => "kapt°RE",
"capterait" => "kapt°RE",
"capteront" => "kapt°R§",
"captés" => "kapte",
"capteur" => "kapt9R",
"capteurs" => "kapt9R",
"captez" => "kapte",
"captieuse" => "kapsj2z",
"captieux" => "kapsj2",
"captif" => "kaptif",
"captifs" => "kaptif",
"captions" => "kaptj§",
"captiva" => "kaptiva",
"captivaient" => "kaptivE",
"captivait" => "kaptivE",
"captivant" => "kaptiv@",
"captivante" => "kaptiv@t",
"captivantes" => "kaptiv@t",
"captive" => "kaptiv",
"captivé" => "kaptive",
"captivée" => "kaptive",
"captivent" => "kaptiv",
"captiver" => "kaptive",
"captivèrent" => "kaptivER",
"captives" => "kaptiv",
"captivés" => "kaptive",
"captivité" => "kaptivite",
"captons" => "kapt§",
"captura" => "kaptyRa",
"capturait" => "kaptyRE",
"capturant" => "kaptyR@",
"capture" => "kaptyR",
"capturé" => "kaptyRe",
"capturée" => "kaptyRe",
"capturées" => "kaptyRe",
"capturent" => "kaptyR",
"capturer" => "kaptyRe",
"capturera" => "kaptyR°Ra",
"capturerait" => "kaptyR°RE",
"captureras" => "kaptyR°Ra",
"capturerez" => "kaptyR°Re",
"capturerons" => "kaptyR°R§",
"captureront" => "kaptyR°R§",
"captures" => "kaptyR",
"capturés" => "kaptyRe",
"capturez" => "kaptyRe",
"capturons" => "kaptyR§",
"capuccino" => "kaputSino",
"capuche" => "kapyS",
"capuches" => "kapyS",
"capuchon" => "kapyS§",
"capuchonnés" => "kapySone",
"capuchons" => "kapyS§",
"capucin" => "kapys5",
"capucinade" => "kapysinad",
"capucinades" => "kapysinad",
"capucine" => "kapysin",
"capucines" => "kapysin",
"capucino" => "kaputSino",
"capucins" => "kapys5",
"capulet" => "kapylE",
"caput mortuum" => "kaputmORtuOm",
"caque" => "kak",
"caquelon" => "kakEl§",
"caques" => "kak",
"caquet" => "kakE",
"caquetage" => "kak°taZ",
"caquetages" => "kak°taZ",
"caquetaient" => "kak°tE",
"caquetait" => "kak°tE",
"caquetant" => "kak°t@",
"caquetante" => "kak°t@t",
"caquetantes" => "kak°t@t",
"caquètement" => "kakEt°m@",
"caquètements" => "kakEt°m@",
"caqueter" => "kak°te",
"caqueteuse" => "kak°t2z",
"caquets" => "kakE",
"caquette" => "kakEt",
"caquettent" => "kakEt",
"car" => "kaR",
"carabas" => "kaRaba",
"carabe" => "kaRab",
"carabes" => "kaRab",
"carabin" => "kaRab5",
"carabine" => "kaRabin",
"carabiné" => "kaRabine",
"carabinée" => "kaRabine",
"carabines" => "kaRabin",
"carabinés" => "kaRabine",
"carabinier" => "kaRabinje",
"carabiniers" => "kaRabinje",
"carabins" => "kaRab5",
"carabosse" => "kaRabOs",
"caracal" => "kaRakal",
"caraco" => "kaRako",
"caracola" => "kaRakola",
"caracolade" => "kaRakolad",
"caracolait" => "kaRakolE",
"caracolant" => "kaRakol@",
"caracole" => "kaRakOl",
"caracolent" => "kaRakOl",
"caracoler" => "kaRakole",
"caracolerez" => "kaRakOl°Re",
"caracos" => "kaRako",
"caractère" => "kaRaktER",
"caractères" => "kaRaktER",
"caractériel" => "kaRakteRjEl",
"caractérielle" => "kaRakteRjEl",
"caractérielles" => "kaRakteRjEl",
"caractériels" => "kaRakteRjEl",
"caractérisait" => "kaRakteRizE",
"caractérisant" => "kaRakteRiz@",
"caractérisation" => "kaRakteRizasj§",
"caractérise" => "kaRakteRiz",
"caractérisé" => "kaRakteRize",
"caractérisée" => "kaRakteRize",
"caractérisées" => "kaRakteRize",
"caractérisent" => "kaRakteRiz",
"caractériser" => "kaRakteRize",
"caractériserais" => "kaRakteRiz°RE",
"caractériserait" => "kaRakteRiz°RE",
"caractérisés" => "kaRakteRize",
"caractéristique" => "kaRakteRistik",
"caractéristiques" => "kaRakteRistik",
"caractérologie" => "kaRakteRoloZi",
"caracul" => "kaRakyl",
"carafe" => "kaRaf",
"carafes" => "kaRaf",
"carafon" => "kaRaf§",
"carafons" => "kaRaf§",
"caraïbe" => "kaRaib",
"caraïbes" => "kaRaib",
"caramba" => "kaR@ba",
"carambar" => "kaR@baR",
"carambars" => "kaR@baR",
"carambolage" => "kaR@bolaZ",
"carambolages" => "kaR@bolaZ",
"carambolaient" => "kaR@bolE",
"carambolait" => "kaR@bolE",
"carambole" => "kaR@bOl",
"carambolé" => "kaR@bole",
"carambolent" => "kaR@bOl",
"caramboler" => "kaR@bole",
"caramboles" => "kaR@bOl",
"carambouillage" => "kaR@bujaZ",
"carambouille" => "kaR@buj",
"carambouillé" => "kaR@buje",
"carambouilleurs" => "kaR@buj9R",
"caramel" => "kaRamEl",
"caramélisait" => "kaRamelizE",
"caramélise" => "kaRameliz",
"caramélisé" => "kaRamelize",
"caramélisée" => "kaRamelize",
"caramélisées" => "kaRamelize",
"caraméliser" => "kaRamelize",
"caramélisés" => "kaRamelize",
"caramels" => "kaRamEl",
"carapace" => "kaRapas",
"carapaces" => "kaRapas",
"carapatait" => "kaRapatE",
"carapate" => "kaRapat",
"carapaté" => "kaRapate",
"carapatent" => "kaRapat",
"carapater" => "kaRapate",
"carapatés" => "kaRapate",
"caraque" => "kaRak",
"carat" => "kaRa",
"carats" => "kaRa",
"caravane" => "kaRavan",
"caravanes" => "kaRavan",
"caravanier" => "kaRavanje",
"caravanière" => "kaRavanjER",
"caravanières" => "kaRavanjER",
"caravaniers" => "kaRavanje",
"caravaning" => "kaRavaniG",
"caravanings" => "kaRavaniG",
"caravansérail" => "kaRav@seRaj",
"caravansérails" => "kaRav@seRaj",
"caravelle" => "kaRavEl",
"caravelles" => "kaRavEl",
"carbets" => "kaRbE",
"carboglace" => "kaRboglas",
"carbonade" => "kaRbOnad",
"carbonari" => "kaRbonaRi",
"carbonate" => "kaRbonat",
"carbone" => "kaRbOn",
"carboné" => "kaRbone",
"carbones" => "kaRbOn",
"carbonique" => "kaRbonik",
"carboniques" => "kaRbonik",
"carbonisa" => "kaRboniza",
"carbonisant" => "kaRboniz@",
"carbonisation" => "kaRbOnizasj§",
"carbonisé" => "kaRbonize",
"carbonisée" => "kaRbonize",
"carbonisées" => "kaRbonize",
"carboniser" => "kaRbonize",
"carbonisés" => "kaRbonize",
"carboxyhémoglobine" => "kaRbOksiemoglObin",
"carburaient" => "kaRbyRE",
"carburais" => "kaRbyRE",
"carburait" => "kaRbyRE",
"carburant" => "kaRbyR@",
"carburants" => "kaRbyR@",
"carburateur" => "kaRbyRat9R",
"carburateurs" => "kaRbyRat9R",
"carburation" => "kaRbyRasj§",
"carbure" => "kaRbyR",
"carburé" => "kaRbyRe",
"carburent" => "kaRbyR",
"carburer" => "kaRbyRe",
"carburez" => "kaRbyRe",
"carcajou" => "kaRkaZu",
"carcan" => "kaRk@",
"carcans" => "kaRk@",
"carcasse" => "kaRkas",
"carcasses" => "kaRkas",
"carcéral" => "kaRseRal",
"carcérale" => "kaRseRal",
"carcérales" => "kaRseRal",
"carcéraux" => "kaRseRo",
"carcharodon" => "kaRkaRod§",
"carcinoïde" => "kaRsinOid",
"carcinome" => "kaRsinOm",
"cardage" => "kaRdaZ",
"cardait" => "kaRdE",
"cardamome" => "kaRdamOm",
"cardamomes" => "kaRdamOm",
"cardan" => "kaRd@",
"cardans" => "kaRd@",
"cardant" => "kaRd@",
"carde" => "kaRd",
"cardé" => "kaRde",
"cardée" => "kaRde",
"carder" => "kaRde",
"carderai" => "kaRd°RE",
"cardères" => "kaRdER",
"carderie" => "kaRd°Ri",
"cardes" => "kaRd",
"cardés" => "kaRde",
"cardeur" => "kaRd9R",
"cardeuse" => "kaRd2z",
"cardeuses" => "kaRd2z",
"cardia" => "kaRdja",
"cardiaque" => "kaRdjak",
"cardiaques" => "kaRdjak",
"cardigan" => "kaRdig@",
"cardigans" => "kaRdig@",
"cardinal" => "kaRdinal",
"cardinal-archevêque" => "kaRdinalaRS2vEk",
"cardinal-légat" => "kaRdinalega",
"cardinale" => "kaRdinal",
"cardinales" => "kaRdinal",
"cardinalice" => "kaRdinalis",
"cardinalices" => "kaRdinalis",
"cardinaux" => "kaRdino",
"cardio-pulmonaire" => "kaRdjOpylmOnER",
"cardio-respiratoire" => "kaRdjoREspiRatwaR",
"cardio-vasculaire" => "kaRdjovaskylER",
"cardiogramme" => "kaRdijogRam",
"cardiographe" => "kaRdjOgRaf",
"cardiographie" => "kaRdjOgRafi",
"cardioïde" => "kaRdjoid",
"cardiologie" => "kaRdjoloZi",
"cardiologue" => "kaRdjolOg",
"cardiologues" => "kaRdjolOg",
"cardiomégalie" => "kaRdjOmegali",
"cardiomyopathie" => "kaRdjomjopati",
"cardiotonique" => "kaRdjotonik",
"cardiovasculaire" => "kaRdjovaskylER",
"cardite" => "kaRdit",
"cardium" => "kaRdjOm",
"cardon" => "kaRd§",
"cardons" => "kaRd§",
"care" => "kaR",
"carême" => "kaREm",
"carême-prenant" => "kaREmpR°n@",
"carêmes" => "kaREm",
"carénage" => "kaRenaZ",
"carénages" => "kaRenaZ",
"carence" => "kaR@s",
"carences" => "kaR@s",
"carène" => "kaREn",
"caréné" => "kaRene",
"carénées" => "kaRene",
"caréner" => "kaRene",
"carènes" => "kaREn",
"caressa" => "kaREsa",
"caressai" => "kaREsE",
"caressaient" => "kaREsE",
"caressais" => "kaREsE",
"caressait" => "kaREsE",
"caressant" => "kaREs@",
"caressante" => "kaREs@t",
"caressantes" => "kaRes@t",
"caressants" => "kaRes@",
"caressât" => "kaREsa",
"caresse" => "kaREs",
"caressé" => "kaRese",
"caressée" => "kaRese",
"caressées" => "kaRese",
"caressent" => "kaREs",
"caresser" => "kaRese",
"caressera" => "kaREs°Ra",
"caresserai" => "kaREs°RE",
"caresseraient" => "kaREs°RE",
"caresserait" => "kaREs°RE",
"caressèrent" => "kaREsER",
"caresserez" => "kaREs°Re",
"caresseront" => "kaREs°R§",
"caresses" => "kaREs",
"caressés" => "kaRese",
"caresseurs" => "kaREs9R",
"caresseuse" => "kaREs2z",
"caresseuses" => "kaREs2z",
"caressez" => "kaREse",
"caressions" => "kaREsj§",
"caret" => "kaRE",
"carex" => "kaREks",
"cargaison" => "kaRgEz§",
"cargaisons" => "kaRgEz§",
"cargo" => "kaRgo",
"cargos" => "kaRgo",
"cargua" => "kaRga",
"carguée" => "kaRge",
"carguées" => "kaRge",
"carguent" => "kaRg",
"carguer" => "kaRge",
"carguez" => "kaRge",
"cari" => "kaRi",
"cariatide" => "kaRjatid",
"cariatides" => "kaRjatid",
"caribéenne" => "kaRibeEn",
"caribou" => "kaRibu",
"caribous" => "kaRibu",
"caricatural" => "kaRikatyRal",
"caricaturale" => "kaRikatyRal",
"caricaturales" => "kaRikatyRal",
"caricaturaux" => "kaRikatyRo",
"caricature" => "kaRikatyR",
"caricaturé" => "kaRikatyRe",
"caricaturées" => "kaRikatyRe",
"caricaturer" => "kaRikatyRe",
"caricatures" => "kaRikatyR",
"caricaturés" => "kaRikatyRe",
"caricaturiste" => "kaRikatyRist",
"caricaturistes" => "kaRikatyRist",
"carie" => "kaRi",
"carié" => "kaRje",
"cariée" => "kaRje",
"cariées" => "kaRje",
"carien" => "kaRj5",
"carier" => "kaRje",
"caries" => "kaRi",
"carillon" => "kaRij§",
"carillonnaient" => "kaRijonE",
"carillonnait" => "kaRijonE",
"carillonnant" => "kaRijon@",
"carillonne" => "kaRijOn",
"carillonné" => "kaRijone",
"carillonnées" => "kaRijone",
"carillonnent" => "kaRijOn",
"carillonner" => "kaRijone",
"carillonnes" => "kaRijOn",
"carillonnés" => "kaRijone",
"carillonneur" => "kaRijon9R",
"carillonneuse" => "kaRijOn2z",
"carillons" => "kaRij§",
"carioca" => "kaRjoka",
"caris" => "kaRi",
"carissime" => "kaRisim",
"cariste" => "kaRist",
"caritatif" => "kaRitatif",
"caritatifs" => "kaRitatif",
"caritative" => "kaRitativ",
"caritatives" => "kaRitativ",
"carlin" => "kaRl5",
"carlines" => "kaRlin",
"carlingue" => "kaRl5g",
"carlingues" => "kaRl5g",
"carlins" => "kaRl5",
"carlisme" => "kaRlism",
"carliste" => "kaRlist",
"carlistes" => "kaRlist",
"carma" => "kaRma",
"carmagnole" => "kaRmaNOl",
"carmagnoles" => "kaRmaNOl",
"carmant" => "kaRm@",
"carme" => "kaRm",
"carmé" => "kaRme",
"carmée" => "kaRme",
"carmel" => "kaRmEl",
"carmélite" => "kaRmelit",
"carmélites" => "kaRmelit",
"carmer" => "kaRme",
"carmes" => "kaRm",
"carmin" => "kaRm5",
"carmina" => "kaRmina",
"carmine" => "kaRmin",
"carminé" => "kaRmine",
"carminée" => "kaRmine",
"carminées" => "kaRmine",
"carminés" => "kaRmine",
"carmins" => "kaRm5",
"carnage" => "kaRnaZ",
"carnages" => "kaRnaZ",
"carnassier" => "kaRnasje",
"carnassière" => "kaRnasjER",
"carnassières" => "kaRnasjER",
"carnassiers" => "kaRnasje",
"carnation" => "kaRnasj§",
"carnaval" => "kaRnaval",
"carnavalesque" => "kaRnavalEsk",
"carnavals" => "kaRnaval",
"carne" => "kaRn",
"carné" => "kaRne",
"carnée" => "kaRne",
"carnées" => "kaRne",
"carnes" => "kaRn",
"carnés" => "kaRne",
"carnet" => "kaRnE",
"carnets" => "kaRnE",
"carnier" => "kaRnje",
"carniers" => "kaRnje",
"carnivore" => "kaRnivOR",
"carnivores" => "kaRnivOR",
"carogne" => "kaRON",
"carole" => "kaROl",
"caroline" => "kaRolin",
"carolines" => "kaRolin",
"carolingien" => "kaRol5Zj5",
"carolingienne" => "kaRol5ZjEn",
"carolingiens" => "kaRol5Zj5",
"carolins" => "kaRol5",
"carolus" => "kaRolys",
"caronades" => "kaRonad",
"caroncule" => "kaR§kyl",
"carotène" => "kaROtEn",
"carotide" => "kaRotid",
"carotides" => "kaRotid",
"carotidien" => "kaROtidj5",
"carotidienne" => "kaROtidjEn",
"carottage" => "kaROtaZ",
"carottait" => "kaRotE",
"carotte" => "kaROt",
"carotté" => "kaROte",
"carottent" => "kaROt",
"carotter" => "kaRote",
"carotterait" => "kaROt°RE",
"carottes" => "kaROt",
"carottés" => "kaRote",
"carotteur" => "kaRot9R",
"carotteuse" => "kaROt2z",
"carottier" => "kaROtje",
"caroube" => "kaRub",
"caroubier" => "kaRubje",
"caroubiers" => "kaRubje",
"caroublant" => "kaRubl@",
"carouble" => "kaRubl",
"caroubler" => "kaRuble",
"caroubles" => "kaRubl",
"caroubleur" => "kaRubl9R",
"carousse" => "kaRus",
"carpaccio" => "kaRpatSo",
"carpe" => "kaRp",
"carpé" => "kaRpe",
"carpes" => "kaRp",
"carpette" => "kaRpEt",
"carpettes" => "kaRpEt",
"carpien" => "kaRpj5",
"carpienne" => "kaRpjEn",
"carpillon" => "kaRpij§",
"carquois" => "kaRkwa",
"carra" => "kaRa",
"carraient" => "kaRE",
"carrais" => "kaRE",
"carrait" => "kaRE",
"carrant" => "kaR@",
"carrare" => "kaRaR",
"carre" => "kaR",
"carré" => "kaRe",
"carreau" => "kaRo",
"carreaux" => "kaRo",
"carrée" => "kaRe",
"carrées" => "kaRe",
"carrefour" => "kaR°fuR",
"carrefours" => "kaR°fuR",
"carrelage" => "kaR°laZ",
"carrelages" => "kaR°laZ",
"carrelait" => "kaR°lE",
"carrelant" => "kaR°l@",
"carrelé" => "kaR°le",
"carrelée" => "kaR°le",
"carrelées" => "kaR°le",
"carreler" => "kaR°le",
"carrelés" => "kaR°le",
"carrelet" => "kaR°lE",
"carrelets" => "kaR°lE",
"carreleur" => "kaR°l9R",
"carreleurs" => "kaR°l9R",
"carrément" => "kaRem@",
"carrent" => "kaR",
"carrer" => "kaRe",
"carrerais" => "kaR°RE",
"carres" => "kaR",
"carrés" => "kaRe",
"carrick" => "kaRik",
"carrier" => "kaRje",
"carrière" => "kaRjER",
"carrières" => "kaRjER",
"carriérisme" => "kaRjeRizm",
"carriériste" => "kaRjeRist",
"carriéristes" => "kaRjeRist",
"carriers" => "kaRje",
"carriole" => "kaRjOl",
"carrioles" => "kaRjOl",
"carron" => "kaR§",
"carrossable" => "kaRosabl",
"carrossables" => "kaRosabl",
"carrosse" => "kaROs",
"carrossée" => "kaRose",
"carrossées" => "kaRose",
"carrosser" => "kaRose",
"carrosserie" => "kaROs°Ri",
"carrosseries" => "kaROs°Ri",
"carrosses" => "kaROs",
"carrossier" => "kaRosje",
"carrossiers" => "kaRosje",
"carrousel" => "kaRusEl",
"carrousels" => "kaRusEl",
"carrure" => "kaRyR",
"carrures" => "kaRyR",
"carry" => "kaRi",
"cars" => "kaR",
"carta" => "kaRta",
"cartable" => "kaRtabl",
"cartables" => "kaRtabl",
"carte" => "kaRt",
"carté" => "kaRte",
"carte-clé" => "kaRt°kle",
"carte-lettre" => "kaRt°lEtR",
"cartel" => "kaRtEl",
"cartels" => "kaRtEl",
"carter" => "kaRtER",
"carterie" => "kaRt2Ri",
"carters" => "kaRtER",
"cartes" => "kaRt",
"cartes-lettres" => "kaRt°lEtR",
"cartésianisme" => "kaRtezjanizm",
"cartésien" => "kaRtezj5",
"cartésienne" => "kaRtezjEn",
"cartésiennes" => "kaRtezjEn",
"cartésiens" => "kaRtezj5",
"carthaginois" => "kaRtaZinwa",
"carthaginoise" => "kaRtaZinwaz",
"carthame" => "kaRtam",
"cartilage" => "kaRtilaZ",
"cartilages" => "kaRtilaZ",
"cartilagineuse" => "kaRtilaZin2z",
"cartilagineuses" => "kaRtilaZin2z",
"cartilagineux" => "kaRtilaZin2",
"cartographe" => "kaRtogRaf",
"cartographes" => "kaRtogRaf",
"cartographie" => "kaRtogRafi",
"cartographié" => "kaRtOgRafje",
"cartographient" => "kaRtogRafi",
"cartographier" => "kaRtogRafje",
"cartographiés" => "kaRtogRafje",
"cartographique" => "kaRtogRafik",
"cartographiques" => "kaRtogRafik",
"cartomancie" => "kaRtOm@si",
"cartomancien" => "kaRtom@sj5",
"cartomancienne" => "kaRtom@sjEn",
"cartomanciennes" => "kaRtom@sjEn",
"carton" => "kaRt§",
"carton-pâte" => "kaRt§pat",
"cartonnage" => "kaRtonaZ",
"cartonnages" => "kaRtonaZ",
"cartonnant" => "kaRton@",
"cartonne" => "kaRtOn",
"cartonné" => "kaRtone",
"cartonnée" => "kaRtone",
"cartonnées" => "kaRtone",
"cartonnent" => "kaRtOn",
"cartonner" => "kaRtone",
"cartonnés" => "kaRtone",
"cartonneuse" => "kaRton2z",
"cartonneuses" => "kaRton2z",
"cartonneux" => "kaRton2",
"cartonnier" => "kaRtonje",
"cartonniers" => "kaRtonje",
"cartons" => "kaRt§",
"cartoon" => "kaRtun",
"cartoons" => "kaRtun",
"cartothèque" => "kaRtOtEk",
"cartouche" => "kaRtuS",
"cartoucherie" => "kaRtuS°Ri",
"cartouches" => "kaRtuS",
"cartouchière" => "kaRtuSjER",
"cartouchières" => "kaRtuSjER",
"cartulaires" => "kaRtylER",
"carvi" => "kaRvi",
"cary" => "kaRi",
"caryatides" => "kaRjatid",
"caryotype" => "kaRjotip",
"cas" => "ka",
"casa" => "kaza",
"casablancaises" => "kazabl@kEz",
"casaient" => "kazE",
"casait" => "kazE",
"casanier" => "kazanje",
"casanière" => "kazanjER",
"casanières" => "kazanjER",
"casaniers" => "kazanje",
"casant" => "kaz@",
"casaque" => "kazak",
"casaques" => "kazak",
"casaquin" => "kazak5",
"casas" => "kaza",
"casbah" => "kasba",
"cascadaient" => "kaskadE",
"cascadait" => "kaskadE",
"cascadant" => "kaskad@",
"cascadas" => "kaskada",
"cascade" => "kaskad",
"cascadé" => "kaskade",
"cascadent" => "kaskad",
"cascader" => "kaskade",
"cascadèrent" => "kaskadER",
"cascades" => "kaskad",
"cascadeur" => "kaskad9R",
"cascadeurs" => "kaskad9R",
"cascadeuse" => "kaskad2z",
"cascara" => "kaskaRa",
"cascatelle" => "kaskatEl",
"cascatelles" => "kaskatEl",
"cascher" => "kaSER",
"case" => "kaz",
"casé" => "kaze",
"casée" => "kaze",
"casées" => "kaze",
"caséeuse" => "kaze2z",
"caséine" => "kazein",
"casemate" => "kaz°mat",
"casemates" => "kaz°mat",
"casent" => "kaz",
"caser" => "kaze",
"caserai" => "kaz°RE",
"caserais" => "kaz°RE",
"caserait" => "kaz°RE",
"caserne" => "kazERn",
"caserné" => "kazERne",
"casernement" => "kazERn°m@",
"casernements" => "kazERn°m@",
"caserner" => "kazERne",
"casernes" => "kazERn",
"casernés" => "kazERne",
"cases" => "kaz",
"casés" => "kaze",
"casette" => "kazEt",
"casettes" => "kazEt",
"cash" => "kaS",
"casher" => "kaSER",
"cashmere" => "kaSmER",
"casier" => "kazje",
"casiers" => "kazje",
"casimir" => "kazimiR",
"casino" => "kazino",
"casinos" => "kazino",
"casoar" => "kazoaR",
"casoars" => "kazoaR",
"caspiennes" => "kaspjEn",
"casquaient" => "kaskE",
"casquais" => "kaskE",
"casquait" => "kaskE",
"casquant" => "kask@",
"casque" => "kask",
"casqué" => "kaske",
"casquée" => "kaske",
"casquées" => "kaske",
"casquent" => "kask",
"casquer" => "kaske",
"casquera" => "kask°Ra",
"casqueras" => "kask°Ra",
"casqueront" => "kask°R§",
"casques" => "kask",
"casqués" => "kaske",
"casquette" => "kaskEt",
"casquettes" => "kaskEt",
"casquettés" => "kaskEte",
"casquettiers" => "kasketje",
"casquez" => "kaske",
"cassa" => "kasa",
"cassable" => "kasabl",
"cassables" => "kasabl",
"cassage" => "kasaZ",
"cassages" => "kasaZ",
"cassai" => "kasE",
"cassaient" => "kasE",
"cassais" => "kasE",
"cassait" => "kasE",
"cassandre" => "kas@dR",
"cassant" => "kas@",
"cassante" => "kas@t",
"cassantes" => "kas@t",
"cassants" => "kas@",
"cassate" => "kasat",
"cassation" => "kasasj§",
"cassations" => "kasasj§",
"casse" => "kas",
"cassé" => "kase",
"casse-bonbons" => "kasb§b§",
"casse-burnes" => "kasbyRn",
"casse-cou" => "kasku",
"casse-couilles" => "kaskuj",
"casse-croûte" => "kaskRut",
"casse-croûtes" => "kaskRut",
"casse-cul" => "kasky",
"casse-dalle" => "kasdal",
"casse-dalles" => "kasdal",
"casse-graine" => "kasgREn",
"casse-gueule" => "kasg9l",
"casse-noisette" => "kasnwazEt",
"casse-noisettes" => "kasnwazEt",
"casse-noix" => "kasnwa",
"casse-pattes" => "kaspat",
"casse-pieds" => "kaspje",
"casse-pipe" => "kaspip",
"casse-pipes" => "kaspip",
"casse-tête" => "kastEt",
"cassée" => "kase",
"cassées" => "kase",
"cassement" => "kas°m@",
"cassements" => "kas°m@",
"cassent" => "kas",
"casser" => "kase",
"cassera" => "kas°Ra",
"casserai" => "kas°RE",
"casseraient" => "kas°RE",
"casserais" => "kas°RE",
"casserait" => "kas°RE",
"casseras" => "kas°Ra",
"cassèrent" => "kasER",
"casserez" => "kas°Re",
"casseriez" => "kas°Rje",
"casserole" => "kas°ROl",
"casserolée" => "kas°Role",
"casserolées" => "kas°Role",
"casseroles" => "kas°ROl",
"casserons" => "kas°R§",
"casseront" => "kas°R§",
"casses" => "kas",
"cassés" => "kase",
"cassetins" => "kast5",
"cassette" => "kasEt",
"cassettes" => "kasEt",
"casseur" => "kas9R",
"casseurs" => "kas9R",
"casseuse" => "kas2z",
"casseuses" => "kas2z",
"cassez" => "kase",
"cassier" => "kasje",
"cassiez" => "kasje",
"cassine" => "kasin",
"cassis" => "kasi",
"cassitérite" => "kasiteRit",
"cassolette" => "kasolEt",
"cassolettes" => "kasolEt",
"cassonade" => "kasonad",
"cassons" => "kas§",
"cassoulet" => "kasulE",
"cassure" => "kasyR",
"cassures" => "kasyR",
"castagnait" => "kastaNE",
"castagne" => "kastaN",
"castagné" => "kastaNe",
"castagnent" => "kastaN",
"castagner" => "kastaNe",
"castagnes" => "kastaN",
"castagnette" => "kastaNEt",
"castagnettes" => "kastaNEt",
"castard" => "kastaR",
"caste" => "kast",
"castel" => "kastEl",
"castelet" => "kastElE",
"castes" => "kast",
"castillan" => "kastij@",
"castillane" => "kastijan",
"castillanes" => "kastijan",
"castillans" => "kastij@",
"castille" => "kastij",
"castine" => "kastin",
"casting" => "kastiG",
"castings" => "kastiG",
"castor" => "kastOR",
"castors" => "kastOR",
"castrat" => "kastRa",
"castrateur" => "kastRat9R",
"castration" => "kastRasj§",
"castratrice" => "kastRatRis",
"castratrices" => "kastRatRis",
"castrats" => "kastRa",
"castré" => "kastRe",
"castrée" => "kastRe",
"castrer" => "kastRe",
"castrés" => "kastRe",
"castreur" => "kastR9R",
"castreurs" => "kastR9R",
"castrez" => "kastRe",
"castrisme" => "kastRism",
"castriste" => "kastRist",
"castristes" => "kastRist",
"castrons" => "kastR§",
"casuel" => "kaz8El",
"casuistes" => "kaz8ist",
"casuistique" => "kaz8istik",
"casuistiques" => "kaz8istik",
"casus belli" => "kazysbElli",
"cata" => "kata",
"catabolique" => "katabOlik",
"catachrèse" => "katakREz",
"cataclysme" => "kataklizm",
"cataclysmes" => "kataklizm",
"cataclysmique" => "kataklismik",
"cataclysmiques" => "kataklismik",
"catacombe" => "katak§b",
"catacombes" => "katak§b",
"catadioptre" => "katadjOptR",
"catadioptres" => "katadjOptR",
"catafalque" => "katafalk",
"catafalques" => "katafalk",
"catalan" => "katal@",
"catalane" => "katalan",
"catalanes" => "katalan",
"catalans" => "katal@",
"catalauniques" => "katalonik",
"catalepsie" => "katalEpsi",
"catalepsies" => "katalEpsi",
"cataleptique" => "katalEptik",
"cataleptiques" => "katalEptik",
"catalogage" => "katalOgaZ",
"catalogne" => "katalON",
"cataloguais" => "katalogE",
"cataloguant" => "katalOg@",
"catalogue" => "katalOg",
"catalogué" => "kataloge",
"cataloguée" => "kataloge",
"cataloguées" => "kataloge",
"cataloguent" => "katalOg",
"cataloguer" => "kataloge",
"cataloguerai" => "katalOg°RE",
"catalogues" => "katalOg",
"catalogués" => "kataloge",
"cataloguiez" => "katalogje",
"catalpa" => "katalpa",
"catalpas" => "katalpa",
"catalysé" => "katalize",
"catalyser" => "katalize",
"catalyses" => "kataliz",
"catalyseur" => "kataliz9R",
"catalyseurs" => "kataliz9R",
"catalytique" => "katalitik",
"catalytiques" => "katalitik",
"catamaran" => "katamaR@",
"cataphotes" => "katafOt",
"cataplasme" => "kataplasm",
"cataplasmes" => "kataplasm",
"cataplexie" => "kataplEksi",
"catapulta" => "katapylta",
"catapultait" => "katapyltE",
"catapulte" => "katapylt",
"catapulté" => "katapylte",
"catapultée" => "katapylte",
"catapultées" => "katapylte",
"catapulter" => "katapylte",
"catapultera" => "katapylt°Ra",
"catapultes" => "katapylt",
"catapultés" => "katapylte",
"cataracte" => "kataRakt",
"cataractes" => "kataRakt",
"catarrhal" => "kataRal",
"catarrhe" => "kataR",
"catarrheuse" => "kataR2z",
"catarrheux" => "kataR2",
"catastropha" => "katastRofa",
"catastrophait" => "katastRofE",
"catastrophas" => "katastRofa",
"catastrophe" => "katastROf",
"catastrophé" => "katastRofe",
"catastrophée" => "katastRofe",
"catastropher" => "katastRofe",
"catastrophes" => "katastROf",
"catastrophique" => "katastRofik",
"catastrophiquement" => "katastRofik°m@",
"catastrophiques" => "katastRofik",
"catastrophisme" => "katastRofizm",
"catastrophiste" => "katastRofist",
"catatonie" => "katatoni",
"catatonique" => "katatonik",
"catatoniques" => "katatonik",
"catch" => "katS",
"catché" => "katSe",
"catcher" => "katSe",
"catcheur" => "katS9R",
"catcheurs" => "katS9R",
"catcheuse" => "katS2z",
"catcheuses" => "katS2z",
"caté" => "kate",
"catéchèse" => "kateSEz",
"catéchisée" => "kateSize",
"catéchisme" => "kateSizm",
"catéchismes" => "kateSizm",
"catéchiste" => "kateSist",
"catécholamine" => "katekOlamin",
"catéchumène" => "katekymEn",
"catéchumènes" => "katekymEn",
"catégorie" => "kategoRi",
"catégories" => "kategoRi",
"catégorique" => "kategoRik",
"catégoriquement" => "kategoRik°m@",
"catégoriques" => "kategoRik",
"catégorisation" => "kategORizasj§",
"catégorise" => "kategoRiz",
"catégorisé" => "kategoRize",
"catégoriser" => "kategoRize",
"caténaire" => "katenER",
"caténaires" => "katenER",
"caterpillar" => "katERpilaR",
"catgut" => "katg9t",
"catguts" => "katg9ts",
"cathare" => "kataR",
"cathares" => "kataR",
"catharsis" => "kataRsis",
"cathartique" => "kataRtik",
"cathédral" => "katedRal",
"cathédrale" => "katedRal",
"cathédrales" => "katedRal",
"cathèdre" => "katEdR",
"cathèdres" => "katEdR",
"catherinette" => "katRinEt",
"cathéter" => "katetER",
"cathétérisme" => "kateteRism",
"cathexis" => "katEksi",
"catho" => "kato",
"cathode" => "katOd",
"cathodique" => "katodik",
"cathodiques" => "katodik",
"catholicisme" => "katolisizm",
"catholicité" => "katolisite",
"catholique" => "katolik",
"catholiquement" => "katolik°m@",
"catholiques" => "katolik",
"cathos" => "kato",
"cati" => "kati",
"catiche" => "katiS",
"catin" => "kat5",
"catins" => "kat5",
"cation" => "katj§",
"cato" => "kato",
"catoblépas" => "katoblepa",
"catogan" => "katog@",
"catogans" => "katog@",
"cattleyas" => "katlEja",
"caucasien" => "kokazj5",
"caucasienne" => "kokazjEn",
"caucasiens" => "kokazj5",
"caucasique" => "kOkazik",
"cauchemar" => "koS°maR",
"cauchemardais" => "koS°maRdE",
"cauchemarde" => "koS°maRd",
"cauchemardé" => "koS°maRde",
"cauchemarder" => "koS°maRde",
"cauchemardes" => "koS°maRd",
"cauchemardesque" => "koS°maRdEsk",
"cauchemardesques" => "koS°maRdEsk",
"cauchemardeuse" => "koS°maRd2z",
"cauchemardeuses" => "koS°maRd2z",
"cauchemardeux" => "koS°maRd2",
"cauchemars" => "koS°maR",
"cauchois" => "koSwa",
"cauchoise" => "koSwaz",
"cauchoises" => "koSwaz",
"caudal" => "kodal",
"caudale" => "kodal",
"caudales" => "kodal",
"caudebec" => "kod°bEk",
"caudillo" => "kodijo",
"caudines" => "kodin",
"cauri" => "koRi",
"cauris" => "koRis",
"causa" => "koza",
"causai" => "kozE",
"causaient" => "kozE",
"causais" => "kozE",
"causait" => "kozE",
"causal" => "kozal",
"causaliste" => "kozalist",
"causalité" => "kozalite",
"causalités" => "kozalite",
"causâmes" => "kozam",
"causant" => "koz@",
"causante" => "koz@t",
"causantes" => "koz@t",
"causants" => "koz@",
"cause" => "koz",
"causé" => "koze",
"causée" => "koze",
"causées" => "koze",
"causent" => "koz",
"causer" => "koze",
"causera" => "koz°Ra",
"causerai" => "koz°RE",
"causeraient" => "koz°RE",
"causerais" => "koz°RE",
"causerait" => "koz°RE",
"causeras" => "koz°Ra",
"causèrent" => "kozER",
"causerez" => "koz°Re",
"causerie" => "koz°Ri",
"causeries" => "koz°Ri",
"causerions" => "koz°Rj§",
"causerons" => "koz°R§",
"causeront" => "koz°R§",
"causes" => "koz",
"causés" => "koze",
"causette" => "kozEt",
"causettes" => "kozEt",
"causeur" => "koz9R",
"causeurs" => "koz9R",
"causeuse" => "koz2z",
"causeuses" => "koz2z",
"causez" => "koze",
"causiez" => "kozje",
"causions" => "kozj§",
"causons" => "koz§",
"causse" => "kos",
"caussenard" => "kosnaR",
"causses" => "kos",
"causticité" => "kostisite",
"caustique" => "kostik",
"caustiques" => "kostik",
"cautèle" => "kotEl",
"cautèles" => "kotEl",
"cauteleuse" => "kot°l2z",
"cauteleusement" => "kot°l2z°m@",
"cauteleuses" => "kot°l2z",
"cauteleux" => "kot°l2",
"cautère" => "kotER",
"cautères" => "kotER",
"cautérisant" => "koteRiz@",
"cautérisation" => "koteRizasj§",
"cautérise" => "koteRiz",
"cautérisée" => "koteRize",
"cautérisées" => "koteRize",
"cautériser" => "koteRize",
"caution" => "kosj§",
"cautionnaire" => "kosjonER",
"cautionnait" => "kosjonE",
"cautionne" => "kosjOn",
"cautionné" => "kosjone",
"cautionnée" => "kosjone",
"cautionnement" => "kosjOn°m@",
"cautionnent" => "kosjOn",
"cautionner" => "kosjone",
"cautionnerait" => "kosjOn°RE",
"cautionnes" => "kosjOn",
"cautionnez" => "kosjone",
"cautions" => "kosj§",
"cava" => "kava",
"cavaillon" => "kavaj§",
"cavalaient" => "kavalE",
"cavalais" => "kavalE",
"cavalait" => "kavalE",
"cavalant" => "kaval@",
"cavalcadaient" => "kavalkadE",
"cavalcadait" => "kavalkadE",
"cavalcadant" => "kavalkad@",
"cavalcade" => "kavalkad",
"cavalcadent" => "kavalkad",
"cavalcader" => "kavalkade",
"cavalcades" => "kavalkad",
"cavale" => "kaval",
"cavalé" => "kavale",
"cavalent" => "kaval",
"cavaler" => "kavale",
"cavalerais" => "kaval°RE",
"cavaleras" => "kaval°Ra",
"cavalerie" => "kaval°Ri",
"cavaleries" => "kaval°Ri",
"cavaleront" => "kaval°R§",
"cavales" => "kaval",
"cavaleur" => "kaval9R",
"cavaleurs" => "kaval9R",
"cavaleuse" => "kaval2z",
"cavalez" => "kavale",
"cavalier" => "kavalje",
"cavalière" => "kavaljER",
"cavalièrement" => "kavaljER°m@",
"cavalières" => "kavaljER",
"cavaliers" => "kavalje",
"cave" => "kav",
"cavé" => "kave",
"caveau" => "kavo",
"caveaux" => "kavo",
"cavecés" => "kav°se",
"cavée" => "kave",
"cavées" => "kave",
"caver" => "kave",
"caverne" => "kavERn",
"cavernes" => "kavERn",
"caverneuse" => "kavERn2z",
"caverneuses" => "kavERn2z",
"caverneux" => "kavERn2",
"cavernicoles" => "kavERnikOl",
"caves" => "kav",
"cavette" => "kavEt",
"cavettes" => "kavEt",
"caviar" => "kavjaR",
"caviardé" => "kavjaRde",
"cavillon" => "kavij§",
"cavillonne" => "kavijOn",
"cavillons" => "kavij§",
"caviste" => "kavist",
"cavitation" => "kavitasj§",
"cavité" => "kavite",
"cavités" => "kavite",
"cavum" => "kavOm",
"cayenne" => "kajEn",
"ce" => "s2",
"céans" => "se@",
"céara" => "seaRa",
"ceci" => "s°si",
"cécidomyies" => "sesidomij",
"cécité" => "sesite",
"céda" => "seda",
"cédai" => "sedE",
"cédaient" => "sedE",
"cédais" => "sedE",
"cédait" => "sedE",
"cédant" => "sed@",
"cédât" => "seda",
"cède" => "sEd",
"cédé" => "sede",
"cédée" => "sede",
"cédées" => "sede",
"cèdent" => "sEd",
"céder" => "sede",
"cédera" => "sed°Ra",
"céderai" => "sed°RE",
"céderaient" => "sed°RE",
"céderais" => "sed°RE",
"céderait" => "sed°RE",
"céderas" => "sed°Ra",
"cédèrent" => "sedER",
"céderez" => "sed°Re",
"céderiez" => "sed°Rje",
"céderons" => "sed°R§",
"céderont" => "sed°R§",
"cédés" => "sede",
"cédez" => "sede",
"cédiez" => "sedje",
"cédions" => "sedj§",
"cédons" => "sed§",
"cédrat" => "sedRa",
"cédratier" => "sedRatje",
"cédrats" => "sedRa",
"cèdre" => "sEdR",
"cèdres" => "sEdR",
"cédulaire" => "sedylER",
"cédule" => "sedyl",
"cégep" => "seZEp",
"cégétiste" => "seZetist",
"cégétistes" => "seZetist",
"ceignait" => "sENE",
"ceignant" => "sEN@",
"ceignent" => "sEN",
"ceignit" => "sENi",
"ceindra" => "s5dRa",
"ceindrait" => "s5dRE",
"ceindre" => "s5dR",
"ceins" => "s5",
"ceint" => "s5",
"ceinte" => "s5t",
"ceintes" => "s5t",
"ceints" => "s5",
"ceintura" => "s5tyRa",
"ceinturaient" => "s5tyRE",
"ceinturait" => "s5tyRE",
"ceinturant" => "s5tyR@",
"ceinturât" => "s5tyRa",
"ceinture" => "s5tyR",
"ceinturé" => "s5tyRe",
"ceinturée" => "s5tyRe",
"ceinturées" => "s5tyRe",
"ceinturent" => "s5tyR",
"ceinturer" => "s5tyRe",
"ceinturèrent" => "s5tyRER",
"ceintures" => "s5tyR",
"ceinturés" => "s5tyRe",
"ceinturez" => "s5tyRe",
"ceinturon" => "s5tyR§",
"ceinturons" => "s5tyR§",
"cela" => "s°la",
"céladon" => "selad§",
"celait" => "selE",
"cèle" => "sEl",
"célébra" => "selebRa",
"célébraient" => "selebRE",
"célébrais" => "selebRE",
"célébrait" => "selebRE",
"célébrâmes" => "selebRam",
"célébrant" => "selebR@",
"célébrants" => "selebR@",
"célébrât" => "selebRa",
"célébration" => "selebRasj§",
"célébrations" => "selebRasj§",
"célèbre" => "selEbR",
"célébré" => "selebRe",
"célébrée" => "selebRe",
"célébrées" => "selebRe",
"célèbrent" => "selEbR",
"célébrer" => "selebRe",
"célébrera" => "selebR°Ra",
"célébrerais" => "selebR°RE",
"célébrerait" => "selebR°RE",
"célébrèrent" => "selebRER",
"célébrerons" => "selebR°R§",
"célébreront" => "selebR°R§",
"célèbres" => "selEbR",
"célébrés" => "selebRe",
"célébriez" => "selebRije",
"célébrions" => "selebRij§",
"célébrissime" => "selebRisim",
"célébrité" => "selebRite",
"célébrités" => "selebRite",
"célébrons" => "selebR§",
"celée" => "s°le",
"celer" => "sele",
"céleri" => "sEl°Ri",
"célérifère" => "seleRifER",
"céleris" => "sEl°Ri",
"célérité" => "seleRite",
"céleste" => "selEst",
"célestes" => "selEst",
"célestin" => "selEst5",
"célestins" => "selEst5",
"célibat" => "seliba",
"célibataire" => "selibatER",
"célibataires" => "selibatER",
"célimène" => "selimEn",
"célinien" => "selinj5",
"célinienne" => "selinjEn",
"cella" => "sEla",
"celle" => "sEl",
"celle-ci" => "sElsi",
"celle-là" => "sElla",
"cellérier" => "seleRje",
"celles" => "sEl",
"celles-ci" => "sElsi",
"celles-là" => "sElla",
"cellier" => "selje",
"celliers" => "selje",
"cellophane" => "selofan",
"cellulaire" => "selylER",
"cellulairement" => "selylER°m@",
"cellulaires" => "selylER",
"cellular" => "selylaR",
"cellule" => "selyl",
"cellules" => "selyl",
"cellulite" => "selylit",
"cellulites" => "selylit",
"celluliteux" => "sElylit2",
"celluloïd" => "selyloid",
"cellulose" => "selyloz",
"celte" => "sElt",
"celtes" => "sElt",
"celtique" => "sEltik",
"celtiques" => "sEltik",
"celtisants" => "sEltiz@",
"celtisme" => "sEltizm",
"celui" => "s°l8i",
"celui-ci" => "s°l8isi",
"celui-là" => "s°l8ila",
"cénacle" => "senakl",
"cénacles" => "senakl",
"cendraient" => "s@dRE",
"cendrait" => "s@dRE",
"cendre" => "s@dR",
"cendré" => "s@dRe",
"cendrée" => "s@dRe",
"cendrées" => "s@dRe",
"cendres" => "s@dR",
"cendrés" => "s@dRe",
"cendreuse" => "s@dR2z",
"cendreuses" => "s@dR2z",
"cendreux" => "s@dR2",
"cendrier" => "s@dRije",
"cendriers" => "s@dRije",
"cendrillon" => "s@dRij§",
"cendrillons" => "s@dRij§",
"cène" => "sEn",
"cénobite" => "senobit",
"cénobites" => "senobit",
"cénotaphe" => "senotaf",
"cens" => "s@s",
"censé" => "s@se",
"censée" => "s@se",
"censées" => "s@se",
"censément" => "s@sem@",
"censés" => "s@se",
"censeur" => "s@s9R",
"censeurs" => "s@s9R",
"censier" => "s@sje",
"censitaire" => "s@sitER",
"censuraient" => "s@syRE",
"censurait" => "s@syRE",
"censurant" => "s@syR@",
"censure" => "s@syR",
"censuré" => "s@syRe",
"censurée" => "s@syRe",
"censurées" => "s@syRe",
"censurer" => "s@syRe",
"censures" => "s@syR",
"censurés" => "s@syRe",
"censurez" => "s@syRe",
"censuriez" => "s@syRje",
"cent" => "s@",
"centaine" => "s@tEn",
"centaines" => "s@tEn",
"centaure" => "s@toR",
"centaurée" => "s@tORe",
"centaures" => "s@toR",
"centavo" => "s@tavo",
"centavos" => "s@tavo",
"centenaire" => "s@t°nER",
"centenaires" => "s@t°nER",
"centième" => "s@tjEm",
"centièmes" => "s@tjEm",
"centigrade" => "s@tigRad",
"centigrades" => "s@tigRad",
"centigrammes" => "s@tigRam",
"centile" => "s@til",
"centilitres" => "s@tilitR",
"centime" => "s@tim",
"centimes" => "s@tim",
"centimètre" => "s@timEtR",
"centimètres" => "s@timEtR",
"centon" => "s@t§",
"centrafricain" => "s@tRafRik5",
"centrafricaine" => "s@tRafRikEn",
"centrage" => "s@tRaZ",
"centrait" => "s@tRE",
"central" => "s@tRal",
"centrale" => "s@tRal",
"centrales" => "s@tRal",
"centralisait" => "s@tRalizE",
"centralisation" => "s@tRalizasj§",
"centralisatrice" => "s@tRalizatRis",
"centralise" => "s@tRaliz",
"centralisé" => "s@tRalize",
"centralisée" => "s@tRalize",
"centraliser" => "s@tRalize",
"centralisés" => "s@tRalize",
"centralisiez" => "s@tRalizje",
"centralisme" => "s@tRalizm",
"centralisons" => "s@tRaliz§",
"centrant" => "s@tR@",
"centraux" => "s@tRo",
"centre" => "s@tR",
"centré" => "s@tRe",
"centre-ville" => "s@tR°vil",
"centrée" => "s@tRe",
"centrées" => "s@tRe",
"centrer" => "s@tRe",
"centres" => "s@tR",
"centrés" => "s@tRe",
"centrifugation" => "s@tRifygasj§",
"centrifuge" => "s@tRifyZ",
"centrifuges" => "s@tRifyZ",
"centrifugeur" => "s@tRifyZ9R",
"centrifugeuse" => "s@tRifyZ2z",
"centrifugeuses" => "s@tRifyZ2z",
"centriole" => "s@tRijOl",
"centripète" => "s@tRipEt",
"centripètes" => "s@tRipEt",
"centriste" => "s@tRist",
"centrouse" => "s@tRuz",
"centrum" => "s@tROm",
"cents" => "s@",
"centuple" => "s@typl",
"centuplé" => "s@typle",
"centuplée" => "s@typle",
"centurie" => "s@tyRi",
"centuries" => "s@tyRi",
"centurion" => "s@tyRj§",
"centurions" => "s@tyRj§",
"cep" => "sEp",
"cépage" => "sepaZ",
"cèpe" => "sEp",
"cépée" => "sepe",
"cépées" => "sepe",
"cependant" => "s°p@d@",
"cèpes" => "sEp",
"céphalée" => "sefale",
"céphalées" => "sefale",
"céphaline" => "sefalin",
"céphalique" => "sefalik",
"céphalo-rachidien" => "sefaloRaSidj5",
"céphalopode" => "sefalOpOd",
"céphalopodes" => "sefalopOd",
"céphalorachidien" => "sefaloRaSidj5",
"céphalosporine" => "sefalospORin",
"ceps" => "sEp",
"céramique" => "seRamik",
"céramiques" => "seRamik",
"céramiste" => "seRamist",
"cerbère" => "sERbER",
"cerbères" => "sERbER",
"cerceau" => "sERso",
"cerceaux" => "sERso",
"cerclage" => "sERklaZ",
"cerclait" => "sERklE",
"cerclant" => "sERkl@",
"cercle" => "sERkl",
"cerclé" => "sERkle",
"cerclée" => "sERkle",
"cerclées" => "sERkle",
"cercler" => "sERkle",
"cercles" => "sERkl",
"cerclés" => "sERkle",
"cercleux" => "sERkl2",
"cercueil" => "sERk9j",
"cercueils" => "sERk9j",
"céréale" => "seReal",
"céréales" => "seReal",
"céréalier" => "seRealje",
"céréalière" => "seRealjER",
"céréalières" => "seRealjER",
"céréaliers" => "seRealje",
"cérébelleuse" => "seRebEl2z",
"cérébelleuses" => "seRebEl2z",
"cérébral" => "seRebRal",
"cérébrale" => "seRebRal",
"cérébralement" => "seRebRal°m@",
"cérébrales" => "seRebRal",
"cérébralité" => "seRebRalite",
"cérébraux" => "seRebRo",
"cérébro-spinale" => "seRebRospinal",
"cérémoniaires" => "seRemonjER",
"cérémonial" => "seRemonjal",
"cérémoniale" => "seRemonjal",
"cérémonials" => "seRemonjal",
"cérémonie" => "seRemoni",
"cérémoniel" => "seRemonjEl",
"cérémonielle" => "seRemOnjEl",
"cérémoniels" => "seRemonjEl",
"cérémonies" => "seRemoni",
"cérémonieuse" => "seRemonj2z",
"cérémonieusement" => "seRemonj2z°m@",
"cérémonieuses" => "seRemonj2z",
"cérémonieux" => "seRemonj2",
"cerf" => "sER",
"cerf-roi" => "sERRwa",
"cerf-volant" => "sERvol@",
"cerfeuil" => "sERf9j",
"cerfs" => "sER",
"cerfs-volants" => "sERvol@",
"cerisaie" => "s°RizE",
"cerise" => "s°Riz",
"cerises" => "s°Riz",
"cerisier" => "s°Rizje",
"cerisiers" => "s°Rizje",
"cerna" => "sERna",
"cernable" => "sERnabl",
"cernaient" => "sERnE",
"cernais" => "sERnE",
"cernait" => "sERnE",
"cernant" => "sERn@",
"cerne" => "sERn",
"cerné" => "sERne",
"cerneau" => "sERno",
"cerneaux" => "sERno",
"cernée" => "sERne",
"cernées" => "sERne",
"cernent" => "sERn",
"cerner" => "sERne",
"cernes" => "sERn",
"cernés" => "sERne",
"cernez" => "sERne",
"cerniez" => "sERnje",
"cernons" => "sERn§",
"cerque" => "sERk",
"certain" => "sERt5",
"certaine" => "sERtEn",
"certainement" => "sERtEn°m@",
"certaines" => "sERtEn",
"certains" => "sERt5",
"certes" => "sERt",
"certif" => "sERtif",
"certifia" => "sERtifja",
"certifiaient" => "sERtifjE",
"certifiait" => "sERtifjE",
"certifiant" => "sERtifj@",
"certificat" => "sERtifika",
"certification" => "sERtifikasj§",
"certificats" => "sERtifika",
"certifie" => "sERtifi",
"certifié" => "sERtifje",
"certifiée" => "sERtifje",
"certifiées" => "sERtifje",
"certifier" => "sERtifje",
"certifierait" => "sERtifiRE",
"certifieront" => "sERtifiR§",
"certifiés" => "sERtifje",
"certifiez" => "sERtifje",
"certifions" => "sERtifj§",
"certifs" => "sERtif",
"certitude" => "sERtityd",
"certitudes" => "sERtityd",
"céruléen" => "seRyle5",
"céruléens" => "seRyle5",
"cérumen" => "seRymEn",
"céruse" => "seRyz",
"cérusé" => "seRyze",
"cerveau" => "sERvo",
"cerveaux" => "sERvo",
"cervelas" => "sERv°la",
"cervelet" => "sERv°lE",
"cervelets" => "sERv°lE",
"cervelle" => "sERvEl",
"cervelles" => "sERvEl",
"cervical" => "sERvikal",
"cervicale" => "sERvikal",
"cervicales" => "sERvikal",
"cervicaux" => "sERviko",
"cervidés" => "sERvide",
"cervoise" => "sERvwaz",
"ces" => "se",
"césar" => "sezaR",
"césarien" => "sezaRj5",
"césarienne" => "sezaRjEn",
"césariennes" => "sezaRjEn",
"césariens" => "sezaRj5",
"césars" => "sezaR",
"césium" => "sezjOm",
"cessa" => "sEsa",
"cessai" => "sEsE",
"cessaient" => "sEsE",
"cessais" => "sEsE",
"cessait" => "sEsE",
"cessâmes" => "sEsam",
"cessant" => "sEs@",
"cessante" => "sEs@t",
"cessantes" => "sEs@t",
"cessasse" => "sEsas",
"cessât" => "sEsa",
"cessation" => "sEsasj§",
"cesse" => "sEs",
"cessé" => "sese",
"cessée" => "sEse",
"cessent" => "sEs",
"cesser" => "sese",
"cessera" => "sEs°Ra",
"cesserai" => "sEs°RE",
"cesseraient" => "sEs°RE",
"cesserais" => "sEs°RE",
"cesserait" => "sEs°RE",
"cesseras" => "sEs°Ra",
"cessèrent" => "sEsER",
"cesserez" => "sEs°Re",
"cesseriez" => "sEs°Rje",
"cesserons" => "sEs°R§",
"cesseront" => "sEs°R§",
"cesses" => "sEs",
"cessez" => "sEse",
"cessez-le-feu" => "sEsel°f2",
"cessiez" => "sEsje",
"cession" => "sEsj§",
"cessionnaire" => "sEsjOnER",
"cessions" => "sEsj§",
"cessons" => "sEs§",
"ceste" => "sEst",
"césure" => "sezyR",
"césures" => "sezyR",
"cet" => "sEt",
"cétacé" => "setase",
"cétacés" => "setase",
"cétoine" => "setwan",
"cétoines" => "setwan",
"cétone" => "setOn",
"cette" => "sEt",
"ceux" => "s2",
"ceux-ci" => "s2si",
"ceux-là" => "s2la",
"cévadille" => "sevadil",
"cévenol" => "sev°nOl",
"cézigue" => "sezig",
"ch'timi" => "Stimi",
"ch'timis" => "Stimi",
"cha-cha-cha" => "tSatSatSa",
"chabanais" => "SabanE",
"chabichou" => "SabiSu",
"chabler" => "Sable",
"chablis" => "Sabli",
"chaboisseaux" => "Sabwaso",
"chabot" => "Sabo",
"chabots" => "Sabo",
"chabraque" => "SabRak",
"chabrot" => "SabRo",
"chacal" => "Sakal",
"chacals" => "Sakal",
"chachlik" => "SaSlik",
"chaconne" => "SakOn",
"chacun" => "Sak1",
"chacune" => "Sakyn",
"chafaud" => "Safo",
"chafauds" => "Safo",
"chafouin" => "Safw5",
"chafouine" => "Safwin",
"chafouins" => "Safw5",
"chagatte" => "Sagat",
"chagattes" => "Sagat",
"chagrin" => "SagR5",
"chagrina" => "SagRina",
"chagrinaient" => "SagRinE",
"chagrinait" => "SagRinE",
"chagrine" => "SagRin",
"chagriné" => "SagRine",
"chagrinée" => "SagRine",
"chagrinent" => "SagRin",
"chagriner" => "SagRine",
"chagrinerait" => "SagRin°RE",
"chagrines" => "SagRin",
"chagrinés" => "SagRine",
"chagrins" => "SagR5",
"chah" => "Sa",
"chahut" => "Say",
"chahutaient" => "SaytE",
"chahutais" => "SaytE",
"chahutait" => "SaytE",
"chahutant" => "Sayt@",
"chahute" => "Sayt",
"chahuté" => "Sayte",
"chahutée" => "Sayte",
"chahutées" => "Sayte",
"chahutent" => "Sayt",
"chahuter" => "Sayte",
"chahuteraient" => "Sayt°RE",
"chahutèrent" => "SaytER",
"chahutés" => "Sayte",
"chahuteur" => "Sayt9R",
"chahuteurs" => "Sayt9R",
"chahuteuse" => "Sayt2z",
"chahutez" => "Sayte",
"chahuts" => "Say",
"chai" => "SE",
"chaîne" => "SEn",
"chaîné" => "SEne",
"chaînes" => "SEn",
"chaînette" => "SEnEt",
"chaînettes" => "SEnEt",
"chaînon" => "SEn§",
"chaînons" => "SEn§",
"chair" => "SER",
"chaire" => "SER",
"chaires" => "SER",
"chairman" => "SERm@",
"chairs" => "SER",
"chais" => "SE",
"chaise" => "SEz",
"chaises" => "SEz",
"chaisière" => "SEzjER",
"chaisières" => "SEzjER",
"chaix" => "SE",
"chaland" => "Sal@",
"chalands" => "Sal@",
"chalazions" => "Salazj§",
"chaldaïques" => "kaldaik",
"chaldéen" => "kalde5",
"chaldéens" => "kalde5",
"châle" => "Sal",
"châles" => "Sal",
"chalet" => "SalE",
"chalets" => "SalE",
"chaleur" => "Sal9R",
"chaleureuse" => "Sal2R2z",
"chaleureusement" => "Sal2R2z°m@",
"chaleureuses" => "Sal2R2z",
"chaleureux" => "Sal2R2",
"chaleurs" => "Sal9R",
"châlit" => "Sali",
"châlits" => "Sali",
"challenge" => "tSalEndZ",
"challenger" => "tSalEndZe",
"challengers" => "tSalEnZER",
"challenges" => "SalEndZ",
"challengeur" => "SalEndZ9R",
"chalon" => "Sal§",
"châlonnais" => "SalonE",
"chalonnaises" => "SalonEz",
"chalons" => "Sal§",
"chaloupait" => "SalupE",
"chaloupant" => "Salup@",
"chaloupe" => "Salup",
"chaloupé" => "Salupe",
"chaloupée" => "Salupe",
"chaloupées" => "Salupe",
"chalouper" => "Salupe",
"chaloupes" => "Salup",
"chaloupés" => "Salupe",
"chalumeau" => "Salymo",
"chalumeaux" => "Salymo",
"chalut" => "Saly",
"chalutier" => "Salytje",
"chalutier-patrouilleur" => "SalytjepatRuj9R",
"chalutiers" => "Salytje",
"chaluts" => "Saly",
"chamade" => "Samad",
"chamaillaient" => "SamajE",
"chamaillait" => "SamajE",
"chamaillant" => "Samaj@",
"chamaille" => "Samaj",
"chamaillé" => "Samaje",
"chamaillent" => "Samaj",
"chamailler" => "Samaje",
"chamaillèrent" => "SamajER",
"chamaillerie" => "Samaj°Ri",
"chamailleries" => "Samaj°Ri",
"chamaillés" => "Samaje",
"chamailleur" => "Samaj9R",
"chamailleurs" => "Samaj9R",
"chamailleuse" => "Samaj2z",
"chamaillez" => "Samaje",
"chamaillions" => "Samaj§",
"chamaillis" => "Samaji",
"chamaillons" => "Samaj§",
"chaman" => "Saman",
"chamane" => "Saman",
"chamanes" => "Saman",
"chamanisme" => "Samanizm",
"chamans" => "Saman",
"chamarré" => "SamaRe",
"chamarrée" => "SamaRe",
"chamarrées" => "SamaRe",
"chamarrés" => "SamaRe",
"chamarrures" => "SamaRyR",
"chambard" => "S@baR",
"chambarda" => "S@baRda",
"chambardait" => "S@baRdE",
"chambardé" => "S@baRde",
"chambardée" => "S@baRde",
"chambardement" => "S@baRd°m@",
"chambardements" => "S@baRd°m@",
"chambarder" => "S@baRde",
"chambellan" => "S@bEl@",
"chambellans" => "S@bEl@",
"chambertin" => "S@bERt5",
"chambertins" => "S@bERt5",
"chamboulaient" => "S@bulE",
"chamboulait" => "S@bulE",
"chamboulant" => "S@bul@",
"chamboulât" => "S@bula",
"chamboule" => "S@bul",
"chamboulé" => "S@bule",
"chamboulée" => "S@bule",
"chamboulées" => "S@bule",
"chamboulement" => "S@bul°m@",
"chamboulements" => "S@bul°m@",
"chamboulent" => "S@bul",
"chambouler" => "S@bule",
"chambouleras" => "S@bul°Ra",
"chamboulés" => "S@bule",
"chamboulez" => "S@bule",
"chambra" => "S@bRa",
"chambrais" => "S@bRE",
"chambrait" => "S@bRE",
"chambranle" => "S@bR@l",
"chambranles" => "S@bR@l",
"chambrant" => "S@bR@",
"chambre" => "S@bR",
"chambré" => "S@bRe",
"chambre-salon" => "S@bRsal§",
"chambrée" => "S@bRe",
"chambrées" => "S@bRe",
"chambrent" => "S@bR",
"chambrer" => "S@bRe",
"chambres" => "S@bR",
"chambrette" => "S@bREt",
"chambrez" => "S@bRe",
"chambrière" => "S@bRijER",
"chambrières" => "S@bRijER",
"chameau" => "Samo",
"chameaux" => "Samo",
"chamelier" => "Sam2lje",
"chameliers" => "Sam2lje",
"chamelle" => "SamEl",
"chamelles" => "SamEl",
"chamois" => "Samwa",
"chamoisine" => "Samwazin",
"champ" => "S@",
"champ'" => "S@p",
"champagne" => "S@paN",
"champagnes" => "S@paN",
"champagnisés" => "S@paNize",
"champenois" => "S@p°nwa",
"champenoise" => "S@p°nwaz",
"champenoises" => "S@p°nwaz",
"champêtre" => "S@pEtR",
"champêtres" => "S@pEtR",
"champi" => "S@pi",
"champignon" => "S@piN§",
"champignonnaient" => "S@piNonE",
"champignonnait" => "S@piNonE",
"champignonne" => "S@piNOn",
"champignonnent" => "S@piNOn",
"champignonnière" => "S@piNoNER",
"champignonnières" => "S@piNoNER",
"champignons" => "S@piN§",
"champion" => "S@pj§",
"championnat" => "S@pjona",
"championnats" => "S@pjona",
"championne" => "S@pjOn",
"championnes" => "S@pjOn",
"champions" => "S@pj§",
"champis" => "S@pi",
"champs" => "S@",
"champs élysées" => "S@elize",
"chançard" => "S@saR",
"chançarde" => "S@saRd",
"chance" => "S@s",
"chancel" => "S@sEl",
"chancela" => "S@s°la",
"chancelai" => "S@s°lE",
"chancelaient" => "S@s°lE",
"chancelais" => "S@s°lE",
"chancelait" => "S@s°lE",
"chancelant" => "S@s°l@",
"chancelante" => "S@s°l@t",
"chancelantes" => "S@s°l@t",
"chancelants" => "S@s°l@",
"chancelé" => "S@s°le",
"chanceler" => "S@s°le",
"chancelèrent" => "S@s°lER",
"chancelier" => "S@s2lje",
"chancelière" => "S@s2ljER",
"chancelières" => "S@s2ljER",
"chanceliers" => "S@s2lje",
"chancelions" => "S@s2lj§",
"chancelle" => "S@sEl",
"chancellent" => "S@sEl",
"chancellerie" => "S@sEl°Ri",
"chancelleries" => "S@sEl°Ri",
"chances" => "S@s",
"chanceuse" => "S@s2z",
"chanceuses" => "S@s2z",
"chanceux" => "S@s2",
"chanci" => "S@si",
"chancre" => "S@kR",
"chancres" => "S@kR",
"chand" => "S@",
"chandail" => "S@daj",
"chandails" => "S@daj",
"chandeleur" => "S@d°l9R",
"chandelier" => "S@d°lje",
"chandeliers" => "S@d°lje",
"chandelle" => "S@dEl",
"chandelles" => "S@dEl",
"chanfrein" => "S@fR5",
"chanfreinée" => "S@fREne",
"change" => "S@Z",
"changé" => "S@Ze",
"changea" => "S@Za",
"changeai" => "S@ZE",
"changeaient" => "S@ZE",
"changeais" => "S@ZE",
"changeait" => "S@ZE",
"changeâmes" => "S@Zam",
"changeant" => "S@Z@",
"changeante" => "S@Z@t",
"changeantes" => "S@Z@t",
"changeants" => "S@Z@",
"changeas" => "S@Za",
"changeât" => "S@Za",
"changée" => "S@Ze",
"changées" => "S@Ze",
"changement" => "S@Z°m@",
"changements" => "S@Z°m@",
"changent" => "S@Z",
"changeons" => "S@Z§",
"changer" => "S@Ze",
"changera" => "S@Z°Ra",
"changerai" => "S@Z°RE",
"changeraient" => "S@Z°RE",
"changerais" => "S@Z°RE",
"changerait" => "S@Z°RE",
"changeras" => "S@Z°Ra",
"changèrent" => "S@ZER",
"changerez" => "S@Z°Re",
"changeriez" => "S@Z°Rje",
"changerons" => "S@Z°R§",
"changeront" => "S@Z°R§",
"changes" => "S@Z",
"changés" => "S@Ze",
"changeur" => "S@Z9R",
"changeurs" => "S@Z9R",
"changeuse" => "S@Z2z",
"changez" => "S@Ze",
"changiez" => "S@Zje",
"changions" => "S@Zj§",
"chanoine" => "Sanwan",
"chanoines" => "Sanwan",
"chanoinesse" => "SanwanEs",
"chanoinesses" => "SanwanEs",
"chanson" => "S@s§",
"chansonner" => "S@sOne",
"chansonnette" => "S@sonEt",
"chansonnettes" => "S@sonEt",
"chansonnier" => "S@sonje",
"chansonniers" => "S@sonje",
"chansons" => "S@s§",
"chanstiquait" => "S@stikE",
"chanstique" => "S@stik",
"chanstiqué" => "S@stike",
"chanstiquée" => "S@stike",
"chanstiquent" => "S@stik",
"chanstiquer" => "S@stike",
"chanstiquèrent" => "S@stikER",
"chant" => "S@",
"chanta" => "S@ta",
"chantage" => "S@taZ",
"chantages" => "S@taZ",
"chantai" => "S@tE",
"chantaient" => "S@tE",
"chantais" => "S@tE",
"chantait" => "S@tE",
"chantâmes" => "S@tam",
"chantant" => "S@t@",
"chantante" => "S@t@t",
"chantantes" => "S@t@t",
"chantants" => "S@t@",
"chantât" => "S@ta",
"chante" => "S@t",
"chanté" => "S@te",
"chanteau" => "S@to",
"chantée" => "S@te",
"chantées" => "S@te",
"chantent" => "S@t",
"chanter" => "S@te",
"chantera" => "S@t°Ra",
"chanterai" => "S@t°RE",
"chanteraient" => "S@t°RE",
"chanterais" => "S@t°RE",
"chanterait" => "S@t°RE",
"chanteras" => "S@t°Ra",
"chanterelle" => "S@t°REl",
"chanterelles" => "S@t°REl",
"chantèrent" => "S@tER",
"chanterez" => "S@t°Re",
"chanteriez" => "S@t°Rje",
"chanterons" => "S@t°R§",
"chanteront" => "S@t°R§",
"chantes" => "S@t",
"chantés" => "S@te",
"chanteur" => "S@t9R",
"chanteurs" => "S@t9R",
"chanteuse" => "S@t2z",
"chanteuse-vedette" => "S@t2zv2dEt",
"chanteuses" => "S@t2z",
"chantez" => "S@te",
"chantier" => "S@tje",
"chantiers" => "S@tje",
"chantiez" => "S@tje",
"chantilly" => "S@tiji",
"chantions" => "S@tj§",
"chantonna" => "S@tona",
"chantonnai" => "S@tonE",
"chantonnaient" => "S@tonE",
"chantonnais" => "S@tonE",
"chantonnait" => "S@tonE",
"chantonnant" => "S@ton@",
"chantonnante" => "S@ton@t",
"chantonne" => "S@tOn",
"chantonné" => "S@tone",
"chantonnée" => "S@tone",
"chantonnement" => "S@tOn°m@",
"chantonnent" => "S@tOn",
"chantonner" => "S@tone",
"chantonnèrent" => "S@tonER",
"chantonnés" => "S@tone",
"chantons" => "S@t§",
"chantoung" => "S@tuG",
"chantourné" => "S@tuRne",
"chantournées" => "S@tuRne",
"chantourner" => "S@tuRne",
"chantournés" => "S@tuRne",
"chantre" => "S@tR",
"chantrerie" => "S@tR°Ri",
"chantres" => "S@tR",
"chants" => "S@",
"chanvre" => "S@vR",
"chanvres" => "S@vR",
"chao" => "kao",
"chaos" => "kao",
"chaotique" => "kaotik",
"chaotiquement" => "kaotik°m@",
"chaotiques" => "kaotik",
"chaouch" => "SauS",
"chaouchs" => "SauS",
"chaparda" => "SapaRda",
"chapardage" => "SapaRdaZ",
"chapardages" => "SapaRdaZ",
"chapardait" => "SapaRdE",
"chapardant" => "SapaRd@",
"chapardé" => "SapaRde",
"chapardée" => "SapaRde",
"chapardées" => "SapaRde",
"chapardent" => "SapaRd",
"chaparder" => "SapaRde",
"chapardeur" => "SapaRd9R",
"chapardeurs" => "SapaRd9R",
"chapardeuse" => "SapaRd2z",
"chaparral" => "SapaRal",
"chaparrals" => "SapaRal",
"chape" => "Sap",
"chapeau" => "Sapo",
"chapeautait" => "SapotE",
"chapeaute" => "Sapot",
"chapeauté" => "Sapote",
"chapeautée" => "Sapote",
"chapeautées" => "Sapote",
"chapeauter" => "Sapote",
"chapeautés" => "Sapote",
"chapeaux" => "Sapo",
"chapelain" => "Sap°l5",
"chapelains" => "Sap°l5",
"chapelet" => "Sap°lE",
"chapelets" => "Sap°lE",
"chapelier" => "Sap°lje",
"chapeliers" => "Sap°lje",
"chapelle" => "SapEl",
"chapellerie" => "SapEl°Ri",
"chapelles" => "SapEl",
"chapelure" => "Sap°lyR",
"chapelures" => "Sap°lyR",
"chaperon" => "Sap°R§",
"chaperonnais" => "Sap°RonE",
"chaperonnait" => "Sap°RonE",
"chaperonné" => "Sap°Rone",
"chaperonnée" => "Sap°Rone",
"chaperonner" => "Sap°Rone",
"chaperonnés" => "Sap°Rone",
"chaperons" => "Sap°R§",
"chapes" => "Sap",
"chapés" => "Sape",
"chapiteau" => "Sapito",
"chapiteaux" => "Sapito",
"chapiteaux-dortoirs" => "SapitodORtwaR",
"chapitre" => "SapitR",
"chapitré" => "SapitRe",
"chapitrée" => "SapitRe",
"chapitrées" => "SapitRe",
"chapitrer" => "SapitRe",
"chapitres" => "SapitR",
"chapka" => "Sapka",
"chaplinesque" => "SaplinEsk",
"chapon" => "Sap§",
"chapons" => "Sap§",
"chappe" => "Sap",
"chapska" => "Sapska",
"chapskas" => "Sapska",
"chaque" => "Sak",
"char" => "SaR",
"charabia" => "SaRabja",
"charabias" => "SaRabja",
"charade" => "SaRad",
"charades" => "SaRad",
"charale" => "SaRal",
"charançon" => "SaR@s§",
"charançonné" => "SaR@sone",
"charançonnée" => "SaR@sone",
"charançonnés" => "SaR@sone",
"charançons" => "SaR@s§",
"charbon" => "SaRb§",
"charbonnages" => "SaRbonaZ",
"charbonnaient" => "SaRbonE",
"charbonnait" => "SaRbonE",
"charbonne" => "SaRbOn",
"charbonné" => "SaRbone",
"charbonnées" => "SaRbone",
"charbonnent" => "SaRbOn",
"charbonner" => "SaRbone",
"charbonnés" => "SaRbone",
"charbonnette" => "SaRbonEt",
"charbonneuse" => "SaRbon2z",
"charbonneuses" => "SaRbon2z",
"charbonneux" => "SaRbon2",
"charbonnier" => "SaRbonje",
"charbonnière" => "SaRbonjER",
"charbonnières" => "SaRbonjER",
"charbonniers" => "SaRbonje",
"charbons" => "SaRb§",
"charca" => "SaRka",
"charcutage" => "SaRkytaZ",
"charcutaient" => "SaRkytE",
"charcutaille" => "SaRkytaj",
"charcutait" => "SaRkytE",
"charcute" => "SaRkyt",
"charcuté" => "SaRkyte",
"charcutée" => "SaRkyte",
"charcutées" => "SaRkyte",
"charcuter" => "SaRkyte",
"charcuterie" => "SaRkyt°Ri",
"charcuteries" => "SaRkyt°Ri",
"charcutés" => "SaRkyte",
"charcutez" => "SaRkyte",
"charcutier" => "SaRkytje",
"charcutière" => "SaRkytjER",
"charcutières" => "SaRkytjER",
"charcutiers" => "SaRkytje",
"chardon" => "SaRd§",
"chardonay" => "SaRdOnE",
"chardonnay" => "SaRdonE",
"chardonneret" => "SaRdOn°RE",
"chardonnerets" => "SaRdOn°RE",
"chardons" => "SaRd§",
"charentaise" => "SaR@tEz",
"charentaises" => "SaR@tEz",
"charge" => "SaRZ",
"chargé" => "SaRZe",
"chargea" => "SaRZa",
"chargeai" => "SaRZE",
"chargeaient" => "SaRZE",
"chargeais" => "SaRZE",
"chargeait" => "SaRZE",
"chargeant" => "SaRZ@",
"chargeât" => "SaRZa",
"chargée" => "SaRZe",
"chargées" => "SaRZe",
"chargement" => "SaRZ°m@",
"chargements" => "SaRZ°m@",
"chargent" => "SaRZ",
"chargeons" => "SaRZ§",
"charger" => "SaRZe",
"chargera" => "SaRZ°Ra",
"chargerai" => "SaRZ°RE",
"chargeraient" => "SaRZ°RE",
"chargerais" => "SaRZ°RE",
"chargerait" => "SaRZ°RE",
"chargeras" => "SaRZ°Ra",
"chargèrent" => "SaRZER",
"chargerez" => "SaRZ°Re",
"chargerons" => "SaRZ°R§",
"chargeront" => "SaRZ°R§",
"charges" => "SaRZ",
"chargés" => "SaRZe",
"chargeur" => "SaRZ9R",
"chargeurs" => "SaRZ9R",
"chargez" => "SaRZe",
"chargiez" => "SaRZje",
"chargions" => "SaRZj§",
"charia" => "SaRja",
"chariot" => "SaRjo",
"chariots" => "SaRjo",
"charismatique" => "kaRismatik",
"charisme" => "kaRizm",
"charitable" => "SaRitabl",
"charitablement" => "SaRitabl°m@",
"charitables" => "SaRitabl",
"charité" => "SaRite",
"charités" => "SaRite",
"charivari" => "SaRivaRi",
"charivaris" => "SaRivaRi",
"charlatan" => "SaRlat@",
"charlataner" => "SaRlatane",
"charlatanerie" => "SaRlatan°Ri",
"charlatanisme" => "SaRlatanizm",
"charlatanismes" => "SaRlatanizm",
"charlatans" => "SaRlat@",
"charleston" => "SaRlEstOn",
"charlot" => "SaRlo",
"charlots" => "SaRlo",
"charlotte" => "SaRlOt",
"charlottes" => "SaRlOt",
"charma" => "SaRma",
"charmaient" => "SaRmE",
"charmait" => "SaRmE",
"charmant" => "SaRm@",
"charmante" => "SaRm@t",
"charmantes" => "SaRm@t",
"charmants" => "SaRm@",
"charme" => "SaRm",
"charmé" => "SaRme",
"charmée" => "SaRme",
"charment" => "SaRm",
"charmer" => "SaRme",
"charmera" => "SaRm°Ra",
"charmes" => "SaRm",
"charmés" => "SaRme",
"charmeur" => "SaRm9R",
"charmeurs" => "SaRm9R",
"charmeuse" => "SaRm2z",
"charmeuses" => "SaRm2z",
"charmille" => "SaRmij",
"charmilles" => "SaRmil",
"charnel" => "SaRnEl",
"charnelle" => "SaRnEl",
"charnellement" => "SaRnEl°m@",
"charnelles" => "SaRnEl",
"charnels" => "SaRnEl",
"charnier" => "SaRnje",
"charnière" => "SaRnjER",
"charnières" => "SaRnjER",
"charniers" => "SaRnje",
"charnu" => "SaRny",
"charnue" => "SaRny",
"charnues" => "SaRny",
"charnus" => "SaRny",
"charognard" => "SaRoNaR",
"charognards" => "SaRoNaR",
"charogne" => "SaRON",
"charognerie" => "SaRON°Ri",
"charognes" => "SaRON",
"charolaise" => "SaRolEz",
"charolaises" => "SaRolEz",
"charpente" => "SaRp@t",
"charpenté" => "SaRp@te",
"charpentée" => "SaRp@te",
"charpenter" => "SaRp@te",
"charpenterie" => "SaRp@t°Ri",
"charpentes" => "SaRp@t",
"charpentés" => "SaRp@te",
"charpentier" => "SaRp@tje",
"charpentière" => "SaRp@tjER",
"charpentiers" => "SaRp@tje",
"charpie" => "SaRpi",
"charpies" => "SaRpi",
"charre" => "SaR",
"charres" => "SaR",
"charretée" => "SaR°te",
"charretées" => "SaR°te",
"charretier" => "SaR°tje",
"charretière" => "SaR°tjER",
"charretiers" => "SaR°tje",
"charreton" => "SaR°t§",
"charretons" => "SaR°t§",
"charrette" => "SaREt",
"charrettes" => "SaREt",
"charria" => "SaRja",
"charriage" => "SaRjaZ",
"charriaient" => "SaRjE",
"charriais" => "SaRjE",
"charriait" => "SaRjE",
"charriant" => "SaRj@",
"charrie" => "SaRi",
"charrié" => "SaRje",
"charriée" => "SaRje",
"charriées" => "SaRje",
"charrient" => "SaRi",
"charrier" => "SaRje",
"charrieras" => "SaRiRa",
"charrière" => "SaRjER",
"charrièrent" => "SaRjER",
"charrières" => "SaRjER",
"charrierons" => "SaRiR§",
"charrieront" => "SaRiR§",
"charries" => "SaRi",
"charriés" => "SaRje",
"charrieurs" => "SaRij9R",
"charriez" => "SaRje",
"charrions" => "SaRj§",
"charroi" => "SaRwa",
"charrois" => "SaRwa",
"charron" => "SaR§",
"charronnées" => "SaRone",
"charrons" => "SaR§",
"charrue" => "SaRy",
"charruée" => "SaR8e",
"charrues" => "SaRy",
"chars" => "SaR",
"charte" => "SaRt",
"charter" => "SaRtER",
"charters" => "SaRtER",
"chartes" => "SaRt",
"chartiste" => "SaRtist",
"chartistes" => "SaRtist",
"chartre" => "SaRtR",
"chartreuse" => "SaRtR2z",
"chartreuses" => "SaRtR2z",
"chartreux" => "SaRtR2",
"charybde" => "SaRibd",
"chas" => "Sa",
"chassa" => "Sasa",
"chassai" => "SasE",
"chassaient" => "SasE",
"chassais" => "SasE",
"chassait" => "SasE",
"chassant" => "Sas@",
"chassât" => "Sasa",
"chasse" => "Sas",
"châsse" => "Sas",
"chassé" => "Sase",
"chassé-croisé" => "SasekRwaze",
"chasse-d'eau" => "Sasdo",
"chasse-goupilles" => "Sasgupij",
"chasse-mouche" => "SasmuS",
"chasse-mouches" => "SasmuS",
"chasse-neige" => "SasnEZ",
"chasse-pierres" => "SaspjER",
"chassée" => "Sase",
"chassées" => "Sase",
"chasselas" => "Sas°la",
"chassent" => "Sas",
"chasser" => "Sase",
"chassera" => "Sas°Ra",
"chasserai" => "Sas°RE",
"chasseraient" => "Sas°RE",
"chasserais" => "Sas°RE",
"chasserait" => "Sas°RE",
"chasseras" => "Sas°Ra",
"chassèrent" => "SasER",
"chasseresse" => "Sas°REs",
"chasseresses" => "Sas°REs",
"chasserez" => "Sas°Re",
"chasserions" => "Sas°Rj§",
"chasserons" => "Sas°R§",
"chasseront" => "Sas°R§",
"chasses" => "Sas",
"châsses" => "Sas",
"chassés" => "Sase",
"chassés-croisés" => "SasekRwaze",
"chasseur" => "Sas9R",
"chasseurs" => "Sas9R",
"chasseuse" => "Sas2z",
"chassez" => "Sase",
"chassie" => "Sasi",
"chassieuse" => "Sasj2z",
"chassieux" => "Sasj2",
"chassiez" => "Sasje",
"chassions" => "Sasj§",
"châssis" => "Sasi",
"chassons" => "Sas§",
"chaste" => "Sast",
"chastement" => "Sast°m@",
"chastes" => "Sast",
"chasteté" => "Sast°te",
"chasuble" => "Sazybl",
"chasubles" => "Sazybl",
"chat" => "Sa",
"chat-huant" => "Sa8@",
"chat-tigre" => "SatigR",
"châtaigne" => "SatEN",
"châtaigné" => "SatENe",
"châtaignent" => "SatEN",
"châtaigner" => "SatENe",
"châtaigneraie" => "SatEN°RE",
"châtaigneraies" => "SatEN°RE",
"châtaignes" => "SatEN",
"châtaignier" => "SateNe",
"châtaigniers" => "SateNe",
"châtain" => "Sat5",
"châtaine" => "SatEn",
"châtaines" => "SatEn",
"châtains" => "Sat5",
"château" => "Sato",
"château-fort" => "SatofOR",
"chateaubriand" => "SatobRij@",
"chateaubriands" => "SatobRij@",
"châteaubriant" => "SatobRij@",
"châteaux" => "Sato",
"châtel" => "SatEl",
"châtelain" => "Sat°l5",
"châtelaine" => "Sat°lEn",
"châtelaines" => "Sat°lEn",
"châtelains" => "Sat°l5",
"châtelet" => "Sat°lE",
"châtellenie" => "SatEl°ni",
"châtiaient" => "SatjE",
"châtiait" => "SatjE",
"châtiant" => "Satj@",
"châtie" => "Sati",
"châtié" => "Sasje",
"châtiée" => "Sasje",
"châtier" => "Satje",
"châtiera" => "SatiRa",
"châtierai" => "SatiRE",
"châtierait" => "SatiRE",
"chatière" => "SatjER",
"châtiés" => "Sasje",
"châtiez" => "Satje",
"châtiment" => "Satim@",
"châtiments" => "Satim@",
"chatoiement" => "Satwam@",
"chatoiements" => "Satwam@",
"chatoient" => "Satwa",
"chaton" => "Sat§",
"chatonne" => "SatOn",
"chatons" => "Sat§",
"chatouilla" => "Satuja",
"chatouillaient" => "SatujE",
"chatouillait" => "SatujE",
"chatouillant" => "Satuj@",
"chatouillât" => "Satuja",
"chatouille" => "Satuj",
"chatouillé" => "Satuje",
"chatouillée" => "Satuje",
"chatouillées" => "Satuje",
"chatouillement" => "Satuj°m@",
"chatouillements" => "Satuj°m@",
"chatouillent" => "Satuj",
"chatouiller" => "Satuje",
"chatouillera" => "Satuj°Ra",
"chatouillèrent" => "SatujER",
"chatouilles" => "Satuj",
"chatouillés" => "Satuje",
"chatouilleuse" => "Satuj2z",
"chatouilleuses" => "Satuj2z",
"chatouilleux" => "Satuj2",
"chatouillez" => "Satuje",
"chatouillis" => "Satuji",
"chatouillons" => "Satuj§",
"chatoyaient" => "SatwajE",
"chatoyait" => "SatwajE",
"chatoyant" => "Satwaj@",
"chatoyante" => "Satwaj@t",
"chatoyantes" => "Satwaj@t",
"chatoyants" => "Satwaj@",
"chatoyer" => "Satwaje",
"châtrage" => "SatRaZ",
"châtraient" => "SatRE",
"châtre" => "SatR",
"châtré" => "SatRe",
"châtrent" => "SatR",
"châtrer" => "SatRe",
"châtreront" => "SatR°R§",
"châtrés" => "SatRe",
"châtron" => "SatR§",
"châtrons" => "SatR§",
"chats" => "Sa",
"chattant" => "Sat@",
"chatte" => "Sat",
"chattemite" => "Sat°mit",
"chatter" => "tSate",
"chatterie" => "Sat°Ri",
"chatteries" => "Sat°Ri",
"chatterton" => "SatERtOn",
"chattes" => "Sat",
"chattons" => "Sat§",
"chaud" => "So",
"chaud-froid" => "SofRwa",
"chaude" => "Sod",
"chaude-pisse" => "Sodpis",
"chaudement" => "Sod°m@",
"chaudes" => "Sod",
"chaudes-pisses" => "Sodpis",
"chaudière" => "SodjER",
"chaudières" => "SodjER",
"chaudron" => "SodR§",
"chaudronné" => "SodRone",
"chaudronnée" => "SodRone",
"chaudronnerie" => "SodROn°Ri",
"chaudronneries" => "SodROn°Ri",
"chaudronnier" => "SodRonje",
"chaudronniers" => "SodRonje",
"chaudrons" => "SodR§",
"chauds" => "So",
"chauds-froids" => "SofRwa",
"chauffa" => "Sofa",
"chauffage" => "SofaZ",
"chauffagiste" => "SofaZist",
"chauffaient" => "SofE",
"chauffais" => "SofE",
"chauffait" => "SofE",
"chauffâmes" => "Sofam",
"chauffant" => "Sof@",
"chauffante" => "Sof@t",
"chauffantes" => "Sof@t",
"chauffants" => "Sof@",
"chauffard" => "SofaR",
"chauffards" => "SofaR",
"chauffe" => "Sof",
"chauffé" => "Sofe",
"chauffe-biberon" => "Sofbib°R§",
"chauffe-eau" => "Sofo",
"chauffe-plats" => "Sofpla",
"chauffée" => "Sofe",
"chauffées" => "Sofe",
"chauffent" => "Sof",
"chauffer" => "Sofe",
"chauffera" => "Sof°Ra",
"chaufferai" => "Sof°RE",
"chauffèrent" => "SofER",
"chaufferette" => "Sof°REt",
"chaufferettes" => "Sof°REt",
"chaufferie" => "Sof°Ri",
"chaufferies" => "Sof°Ri",
"chauffes" => "Sof",
"chauffés" => "Sofe",
"chauffeur" => "Sof9R",
"chauffeur-livreur" => "Sof9RlivR9R",
"chauffeurs" => "Sof9R",
"chauffeuse" => "Sof2z",
"chauffez" => "Sofe",
"chauffiez" => "Sofje",
"chauffions" => "Sofj§",
"chauffons" => "Sof§",
"chaule" => "Sol",
"chaulé" => "Sole",
"chaulée" => "Sole",
"chaulées" => "Sole",
"chauler" => "Sole",
"chaulés" => "Sole",
"chaume" => "Som",
"chaumé" => "Some",
"chaumes" => "Som",
"chaumière" => "SomjER",
"chaumières" => "SomjER",
"chaumine" => "Somin",
"chaumines" => "Somin",
"chaussa" => "Sosa",
"chaussai" => "SosE",
"chaussaient" => "SosE",
"chaussait" => "SosE",
"chaussant" => "Sos@",
"chausse" => "Sos",
"chaussé" => "Sose",
"chausse-pied" => "Sospje",
"chausse-trape" => "SostRap",
"chausse-trapes" => "SostRap",
"chausse-trappe" => "SostRap",
"chaussée" => "Sose",
"chaussées" => "Sose",
"chaussent" => "Sos",
"chausser" => "Sose",
"chausserai" => "Sos°RE",
"chaussèrent" => "SosER",
"chausses" => "Sos",
"chaussés" => "Sose",
"chaussette" => "SosEt",
"chaussettes" => "SosEt",
"chausseur" => "Sos9R",
"chausseurs" => "Sos9R",
"chaussez" => "Sose",
"chausson" => "Sos§",
"chaussons" => "Sos§",
"chaussure" => "SosyR",
"chaussures" => "SosyR",
"chaut" => "So",
"chauve" => "Sov",
"chauve-souris" => "SovsuRi",
"chauves" => "Sov",
"chauves-souris" => "SovsuRi",
"chauvin" => "Sov5",
"chauvine" => "Sovin",
"chauvines" => "Sovin",
"chauvinisme" => "Sovinizm",
"chauviniste" => "Sovinist",
"chauvins" => "Sov5",
"chauvit" => "Sovi",
"chaux" => "So",
"chavignol" => "SaviNOl",
"chavira" => "SaviRa",
"chavirai" => "SaviRE",
"chaviraient" => "SaviRE",
"chavirait" => "SaviRE",
"chavirant" => "SaviR@",
"chavirante" => "SaviR@t",
"chavire" => "SaviR",
"chaviré" => "SaviRe",
"chavirée" => "SaviRe",
"chavirement" => "SaviR°m@",
"chavirements" => "SaviR°m@",
"chavirent" => "SaviR",
"chavirer" => "SaviRe",
"chavireraient" => "SaviR°RE",
"chavirerait" => "SaviR°RE",
"chavirèrent" => "SaviRER",
"chavireront" => "SaviR°R§",
"chavirés" => "SaviRe",
"chavirions" => "SaviRj§",
"chavirons" => "SaviR§",
"cheap" => "tSip",
"chébran" => "SebR@",
"chèche" => "SES",
"chèches" => "SES",
"chéchia" => "SeSja",
"chéchias" => "SeSja",
"check up" => "SEkype",
"check-list" => "tSEklist",
"check-up" => "tSEk9p",
"cheddar" => "SEdaR",
"cheddite" => "SEdit",
"cheese-cake" => "tSizkEk",
"cheese-cakes" => "tSizkEk",
"cheeseburger" => "tSizb9Rg9R",
"cheeseburgers" => "tSizb9Rg9R",
"chef" => "SEf",
"chef-adjoint" => "SEfadZw5",
"chef-d'oeuvre" => "SEd9vR",
"chef-d'oeuvres" => "SEd9vR",
"chef-lieu" => "SEflj2",
"chéfesse" => "SefEs",
"chefs" => "SEf",
"chefs-d'oeuvre" => "SEd9vR",
"chefs-lieux" => "SEflj2",
"cheftaine" => "SEftEn",
"cheftaines" => "S°ftEn",
"cheik" => "SEk",
"cheikh" => "SEk",
"cheiks" => "SEk",
"chélate" => "kelat",
"chelem" => "SelEm",
"chélidoine" => "kelidwan",
"chélidoines" => "kelidwan",
"chéloïde" => "kelOid",
"chemin" => "S°m5",
"chemina" => "S°mina",
"cheminaient" => "S°minE",
"cheminait" => "S°minE",
"cheminâmes" => "S°minam",
"cheminant" => "S°min@",
"chemine" => "S°min",
"cheminé" => "S°mine",
"chemineau" => "S°mino",
"chemineaux" => "S°mino",
"cheminée" => "S°mine",
"cheminées" => "S°mine",
"cheminement" => "S°min°m@",
"cheminements" => "S°min°m@",
"cheminent" => "S°min",
"cheminer" => "S°mine",
"chemineraient" => "S°min°RE",
"cheminerait" => "S°min°RE",
"cheminèrent" => "S°minER",
"cheminerons" => "S°min°R§",
"chemineront" => "S°min°R§",
"cheminions" => "S°minj§",
"cheminons" => "S°min§",
"cheminot" => "S°mino",
"cheminots" => "S°mino",
"chemins" => "S°m5",
"chemise" => "S°miz",
"chemisée" => "S°mize",
"chemisées" => "S°mize",
"chemiser" => "S°mize",
"chemiserie" => "S°miz°Ri",
"chemises" => "S°miz",
"chemisette" => "S°mizEt",
"chemisettes" => "S°mizEt",
"chemisier" => "S°mizje",
"chemisiers" => "S°mizje",
"chênaie" => "SEnE",
"chênaies" => "SEnE",
"chenal" => "S°nal",
"chenapan" => "S°nap@",
"chenapans" => "S°nap@",
"chenaux" => "S°no",
"chêne" => "SEn",
"chêne-liège" => "SEnljEZ",
"chéneau" => "Seno",
"chéneaux" => "Seno",
"chênes" => "SEn",
"chênes-lièges" => "SEnljEZ",
"chenet" => "S°nE",
"chêneteau" => "SEn°to",
"chenets" => "S°nE",
"chènevis" => "SEn°vi",
"chenil" => "S°nil",
"chenille" => "S°nij",
"chenillé" => "S°nije",
"chenilles" => "S°nij",
"chenillés" => "S°nije",
"chenillette" => "S°nijEt",
"chenillettes" => "S°nijEt",
"chenils" => "S°nil",
"chenu" => "S°ny",
"chenue" => "S°ny",
"chenues" => "S°ny",
"chenus" => "S°ny",
"cheptel" => "SEptEl",
"chèque" => "SEk",
"chèque-cadeau" => "SEkkado",
"chèques" => "SEk",
"chéquier" => "Sekje",
"chéquiers" => "Sekje",
"cher" => "SER",
"chercha" => "SERSa",
"cherchai" => "SERSE",
"cherchaient" => "SERSE",
"cherchais" => "SERSE",
"cherchait" => "SERSE",
"cherchâmes" => "SERSam",
"cherchant" => "SERS@",
"cherchas" => "SERSa",
"cherchât" => "SERSa",
"cherche" => "SERS",
"cherché" => "SERSe",
"cherche-midi" => "SERSmidi",
"cherchée" => "SERSe",
"cherchées" => "SERSe",
"cherchent" => "SERS",
"chercher" => "SERSe",
"cherchera" => "SERS°Ra",
"chercherai" => "SERS°RE",
"chercheraient" => "SERS°RE",
"chercherais" => "SERS°RE",
"chercherait" => "SERS°RE",
"chercheras" => "SERS°Ra",
"cherchèrent" => "SERSER",
"chercherez" => "SERS°Re",
"chercheriez" => "SERS°Rje",
"chercherions" => "SERS°Rj§",
"chercherons" => "SERS°R§",
"chercheront" => "SERS°R§",
"cherches" => "SERS",
"cherchés" => "SERSe",
"chercheur" => "SERS9R",
"chercheurs" => "SERS9R",
"chercheuse" => "SERS2z",
"chercheuses" => "SERS2z",
"cherchez" => "SERSe",
"cherchiez" => "SERSje",
"cherchions" => "SERSj§",
"cherchons" => "SERS§",
"chère" => "SER",
"chèrement" => "SER°m@",
"chères" => "SER",
"chergui" => "SERgi",
"chéri" => "SeRi",
"chérie" => "SeRi",
"chéries" => "SeRi",
"chérif" => "SeRif",
"chérifienne" => "SeRifjEn",
"chérir" => "SeRiR",
"chérirai" => "SeRiRE",
"chérirais" => "SeRiRE",
"chérirez" => "SeRiRe",
"chérirons" => "SeRiR§",
"chéris" => "SeRi",
"chérissaient" => "SeRisE",
"chérissais" => "SeRisE",
"chérissait" => "SeRisE",
"chérissant" => "SeRis@",
"chérisse" => "SeRis",
"chérissent" => "SeRis",
"chérissez" => "SeRise",
"chérissons" => "SeRis§",
"chérit" => "SeRi",
"cherokee" => "SeRoki",
"cherokees" => "SeRoki",
"chérot" => "SeRo",
"cherres" => "SER",
"cherry" => "SeRi",
"chers" => "SER",
"cherté" => "SERte",
"chérubin" => "SeRyb5",
"chérubinique" => "SeRybinik",
"chérubins" => "SeRyb5",
"chester" => "SEstER",
"chétif" => "Setif",
"chétifs" => "Setif",
"chétive" => "Setiv",
"chétivement" => "Setiv°m@",
"chétives" => "Setiv",
"chétivité" => "Setivite",
"chevai" => "S°vE",
"cheval" => "S°val",
"cheval-vapeur" => "S°valvap9R",
"chevalée" => "S°vale",
"chevaler" => "S°vale",
"chevaleresque" => "S°val°REsk",
"chevaleresquement" => "S°val°REsk°m@",
"chevaleresques" => "S°val°REsk",
"chevalerie" => "S°val°Ri",
"chevaleries" => "S°val°Ri",
"chevalet" => "S°valE",
"chevalets" => "S°valE",
"chevalier" => "S°valje",
"chevalière" => "S°valjER",
"chevalières" => "S°valjER",
"chevaliers" => "S°valje",
"chevalin" => "S°val5",
"chevaline" => "S°valin",
"chevalins" => "S°val5",
"chevance" => "S°v@s",
"chevau-léger" => "S°voleZe",
"chevaucha" => "S°voSa",
"chevauchaient" => "S°voSE",
"chevauchais" => "S°voSE",
"chevauchait" => "S°voSE",
"chevauchant" => "S°voS@",
"chevauche" => "S°voS",
"chevauché" => "S°voSe",
"chevauchée" => "S°voSe",
"chevauchées" => "S°voSe",
"chevauchement" => "S°voS°m@",
"chevauchent" => "S°voS",
"chevaucher" => "S°voSe",
"chevauchera" => "S°voS°Ra",
"chevaucherai" => "S°voS°RE",
"chevaucheraient" => "S°voS°RE",
"chevauchèrent" => "S°voSER",
"chevauchés" => "S°voSe",
"chevaucheur" => "S°voS9R",
"chevauchez" => "S°voSe",
"chevauchons" => "S°voS§",
"chevaux" => "S°vo",
"chevaux-vapeur" => "S°vovap9R",
"chevêche" => "S°vES",
"chevêches" => "S°vES",
"chevelu" => "S°v°ly",
"chevelue" => "S°v°ly",
"chevelues" => "S°v°ly",
"chevelure" => "S°v°lyR",
"chevelures" => "S°v°lyR",
"chevelus" => "S°v°ly",
"chevesne" => "S°vEn",
"chevesnes" => "S°vEn",
"chevet" => "S°vE",
"chevets" => "S°vE",
"cheveu" => "S°v2",
"cheveux" => "S°v2",
"chevillage" => "S°vijaZ",
"chevillard" => "S°vijaR",
"chevillards" => "S°vijaR",
"cheville" => "S°vij",
"chevillé" => "S°vije",
"chevillée" => "S°vije",
"chevillées" => "S°vije",
"chevilles" => "S°vij",
"chevillette" => "S°vijEt",
"cheviotte" => "S°vjOt",
"chevir" => "S2viR",
"chèvre" => "SEvR",
"chèvre-pied" => "SEvR°pje",
"chevreau" => "S°vRo",
"chevreaux" => "S°vRo",
"chèvrefeuille" => "SEvR°f9j",
"chèvrefeuilles" => "SEvR°f9j",
"chèvres" => "SEvR",
"chevrette" => "S°vREt",
"chevrettes" => "S°vREt",
"chevreuil" => "S°vR9j",
"chevreuils" => "S°vR9j",
"chevrier" => "S°vRije",
"chevrière" => "S°vRijER",
"chevriers" => "S°vRije",
"chevron" => "S°vR§",
"chevronné" => "S°vRone",
"chevronnée" => "S°vRone",
"chevronnés" => "S°vRone",
"chevrons" => "S°vR§",
"chevrota" => "S°vRota",
"chevrotais" => "S°vRotE",
"chevrotait" => "S°vRotE",
"chevrotant" => "S°vRot@",
"chevrotante" => "S°vRot@t",
"chevrote" => "S°vROt",
"chevroté" => "S°vRote",
"chevrotée" => "S°vRote",
"chevrotement" => "S°vROt°m@",
"chevrotements" => "S°vROt°m@",
"chevroter" => "S°vRote",
"chevrotine" => "S°vRotin",
"chevrotines" => "S°vRotin",
"chewing gum" => "SwiGgOm",
"chewing-gum" => "SwiGgOm",
"chewing-gums" => "SwiGgOm",
"chez" => "Se",
"chez-soi" => "Seswa",
"chi" => "ki",
"chia" => "Sja",
"chiadé" => "Sjade",
"chiadée" => "Sjade",
"chiadées" => "Sjade",
"chiader" => "Sjade",
"chiaient" => "SjE",
"chiais" => "SjE",
"chiait" => "SjE",
"chiala" => "Sjala",
"chialaient" => "SjalE",
"chialais" => "SjalE",
"chialait" => "SjalE",
"chialant" => "Sjal@",
"chiale" => "Sjal",
"chialé" => "Sjale",
"chialent" => "Sjal",
"chialer" => "Sjale",
"chialera" => "Sjal°Ra",
"chialeraient" => "Sjal°RE",
"chialerais" => "Sjal°RE",
"chialerait" => "Sjal°RE",
"chialeras" => "Sjal°Ra",
"chialèrent" => "SjalER",
"chialeries" => "Sjal°Ri",
"chiales" => "Sjal",
"chialeur" => "Sjal9R",
"chialeuse" => "Sjal2z",
"chialez" => "Sjale",
"chiant" => "Sj@",
"chiante" => "Sj@t",
"chiantes" => "Sj@t",
"chianti" => "kj@ti",
"chiants" => "Sj@",
"chiard" => "SjaR",
"chiards" => "SjaR",
"chiasma" => "kjasma",
"chiasme" => "kjasm",
"chiasse" => "Sjas",
"chiasses" => "Sjas",
"chiasseux" => "Sjas2",
"chiatique" => "Sjatik",
"chiatiques" => "Sjatik",
"chibouk" => "Sibuk",
"chibre" => "SibR",
"chic" => "Sik",
"chic-type" => "Siktip",
"chica" => "Sika",
"chicanait" => "SikanE",
"chicanant" => "Sikan@",
"chicane" => "Sikan",
"chicané" => "Sikane",
"chicanées" => "Sikane",
"chicanent" => "Sikan",
"chicaner" => "Sikane",
"chicaneries" => "Sikan°Ri",
"chicanerons" => "Sikan°R§",
"chicanes" => "Sikan",
"chicaneur" => "Sikan9R",
"chicanez" => "Sikane",
"chicanier" => "Sikanje",
"chicanière" => "SikanjER",
"chicaniers" => "Sikanje",
"chicano" => "Sikano",
"chicanons" => "Sikan§",
"chicanos" => "Sikano",
"chicas" => "Sika",
"chiche" => "SiS",
"chiche-kebab" => "SiSkebab",
"chichement" => "SiS°m@",
"chiches" => "SiS",
"chichi" => "SiSi",
"chichis" => "SiSi",
"chichiteuse" => "SiSit2z",
"chichiteuses" => "SiSit2z",
"chichiteux" => "SiSit2",
"chicon" => "Sik§",
"chicore" => "SikoR",
"chicoré" => "SikoRe",
"chicorée" => "SikoRe",
"chicorées" => "SikoRe",
"chicorent" => "SikoR",
"chicorer" => "SikoRe",
"chicores" => "SikoR",
"chicot" => "Siko",
"chicote" => "SikOt",
"chicoté" => "Sikote",
"chicoter" => "Sikote",
"chicotin" => "SikOt5",
"chicots" => "Siko",
"chicotte" => "SikOt",
"chics" => "Sik",
"chie" => "Si",
"chié" => "Sje",
"chiée" => "Sje",
"chiées" => "Sje",
"chien" => "Sj5",
"chien-assis" => "Sj5asi",
"chien-étoile" => "Sj5etwal",
"chien-loup" => "Sj5lu",
"chien-robot" => "Sj5Robo",
"chienchien" => "Sj5Sj5",
"chienchiens" => "Sj5Sj5",
"chiendent" => "Sj5d@",
"chienlit" => "Sj@li",
"chiennasse" => "SjEnas",
"chienne" => "SjEn",
"chiennerie" => "SjEn°Ri",
"chienneries" => "SjEn°Ri",
"chiennes" => "SjEn",
"chiens" => "Sj5",
"chiens-loups" => "Sj5lu",
"chient" => "Si",
"chier" => "Sje",
"chiera" => "SiRa",
"chierai" => "SiRE",
"chierais" => "SiRE",
"chieras" => "SiRa",
"chierez" => "SiRe",
"chierie" => "SiRi",
"chieries" => "SiRi",
"chieront" => "SiR§",
"chies" => "Si",
"chiés" => "Sje",
"chieur" => "Sj9R",
"chieurs" => "Sj9R",
"chieuse" => "Sj2z",
"chieuses" => "Sj2z",
"chiez" => "Sje",
"chiffe" => "Sif",
"chiffes" => "Sif",
"chiffon" => "Sif§",
"chiffonna" => "Sifona",
"chiffonnade" => "Sifonad",
"chiffonnades" => "Sifonad",
"chiffonnaient" => "SifonE",
"chiffonnait" => "SifonE",
"chiffonnant" => "Sifon@",
"chiffonne" => "SifOn",
"chiffonné" => "Sifone",
"chiffonnée" => "Sifone",
"chiffonnées" => "Sifone",
"chiffonner" => "Sifone",
"chiffonnés" => "Sifone",
"chiffonnier" => "Sifonje",
"chiffonnière" => "SifonjER",
"chiffonnières" => "SifonjER",
"chiffonniers" => "Sifonje",
"chiffons" => "Sif§",
"chiffrable" => "SifRabl",
"chiffrage" => "SifRaZ",
"chiffrait" => "SifRE",
"chiffrant" => "SifR@",
"chiffre" => "SifR",
"chiffré" => "SifRe",
"chiffrée" => "SifRe",
"chiffrées" => "SifRe",
"chiffrement" => "SifR°m@",
"chiffrent" => "SifR",
"chiffrer" => "SifRe",
"chiffres" => "SifR",
"chiffrés" => "SifRe",
"chiffres-clés" => "SifR°kle",
"chiffreur" => "SifR9R",
"chiffreuse" => "SifR2z",
"chignole" => "SiNOl",
"chignoles" => "SiNOl",
"chignon" => "SiN§",
"chignons" => "SiN§",
"chihuahua" => "Siwawa",
"chihuahuas" => "Siwawa",
"chiites" => "Siit",
"chiles" => "Sil",
"chili" => "Sili",
"chilien" => "Silj5",
"chilienne" => "SiljEn",
"chiliennes" => "SiljEn",
"chiliens" => "Silj5",
"chilis" => "Silis",
"chilom" => "SilOm",
"chimère" => "SimER",
"chimères" => "SimER",
"chimérique" => "SimeRik",
"chimériquement" => "SimeRik°m@",
"chimériques" => "SimeRik",
"chimie" => "Simi",
"chimies" => "Simi",
"chimiothérapie" => "SimjoteRapi",
"chimique" => "Simik",
"chimiquement" => "Simik°m@",
"chimiques" => "Simik",
"chimiste" => "Simist",
"chimistes" => "Simist",
"chimpanzé" => "S5p@ze",
"chimpanzés" => "S5p@ze",
"china" => "Sina",
"chinaient" => "SinE",
"chinait" => "SinE",
"chinant" => "Sin@",
"chinchard" => "S5SaR",
"chinchilla" => "S5Sila",
"chinchillas" => "S5Sila",
"chine" => "Sin",
"chiné" => "Sine",
"chinée" => "Sine",
"chinées" => "Sine",
"chiner" => "Sine",
"chinera" => "Sin°Ra",
"chinés" => "Sine",
"chinetoque" => "Sin°tOk",
"chinetoques" => "Sin°tOk",
"chineur" => "Sin9R",
"chineurs" => "Sin9R",
"chinois" => "Sinwa",
"chinoise" => "Sinwaz",
"chinoiser" => "Sinwaze",
"chinoiserie" => "Sinwaz°Ri",
"chinoiseries" => "Sinwaz°Ri",
"chinoises" => "Sinwaz",
"chinook" => "Sinuk",
"chintz" => "Sints",
"chiot" => "Sjo",
"chiots" => "Sjo",
"chiotte" => "SjOt",
"chiottes" => "SjOt",
"chiourme" => "SjuRm",
"chip" => "Sip",
"chipa" => "Sipa",
"chipaient" => "SipE",
"chipais" => "SipE",
"chipait" => "SipE",
"chipant" => "Sip@",
"chipe" => "Sip",
"chipé" => "Sipe",
"chipée" => "Sipe",
"chipées" => "Sipe",
"chiper" => "Sipe",
"chiperaient" => "Sip°RE",
"chipèrent" => "SipER",
"chiperiez" => "Sip°Rje",
"chipés" => "Sipe",
"chipeur" => "Sip9R",
"chipez" => "Sipe",
"chipie" => "Sipi",
"chipies" => "Sipi",
"chipolata" => "Sipolata",
"chipolatas" => "Sipolata",
"chipota" => "Sipota",
"chipotage" => "SipotaZ",
"chipotages" => "SipotaZ",
"chipotais" => "SipotE",
"chipotait" => "SipotE",
"chipotant" => "Sipot@",
"chipote" => "SipOt",
"chipoté" => "Sipote",
"chipotent" => "SipOt",
"chipoter" => "Sipote",
"chipotes" => "SipOt",
"chipoteur" => "Sipot9R",
"chipoteuse" => "Sipot2z",
"chipotez" => "Sipote",
"chipotons" => "Sipot§",
"chippendale" => "Sip9ndEjl",
"chippendales" => "Sip9ndEjlz",
"chips" => "Sips",
"chiquaient" => "SikE",
"chiquait" => "SikE",
"chiquant" => "Sik@",
"chique" => "Sik",
"chiqué" => "Sike",
"chiquement" => "Sik°m@",
"chiquenaude" => "Sik°nod",
"chiquenaudes" => "Sik°nod",
"chiquent" => "Sik",
"chiquer" => "Sike",
"chiquerai" => "Sik°RE",
"chiqueront" => "Sik°R§",
"chiques" => "Sik",
"chiqués" => "Sike",
"chiqueur" => "Sik9R",
"chiqueurs" => "Sik9R",
"chiqueuses" => "Sik2z",
"chiraquien" => "SiRakj5",
"chiricahua" => "SiRikaua",
"chiricahuas" => "SiRikaua",
"chiromancie" => "kiRom@si",
"chiromancien" => "kiRom@sj5",
"chiromancienne" => "kiRom@sjEn",
"chiromanciens" => "kiRom@sj5",
"chiropracteur" => "kiRopRakt9R",
"chiropraticien" => "kiROpRatisj5",
"chiropraticienne" => "kiROpRatisjEn",
"chiropratique" => "kiROpRatik",
"chiropraxie" => "kiROpRaksi",
"chiroptère" => "kiROptER",
"chiroubles" => "SiRubl",
"chirurgical" => "SiRyRZikal",
"chirurgicale" => "SiRyRZikal",
"chirurgicalement" => "SiRyRZikal°m@",
"chirurgicales" => "SiRyRZikal",
"chirurgicaux" => "SiRyRZiko",
"chirurgie" => "SiRyRZi",
"chirurgien" => "SiRyRZj5",
"chirurgien-dentiste" => "SiRyRZj5d@tist",
"chirurgienne" => "SiRyRZjEn",
"chirurgiens" => "SiRyRZj5",
"chirurgies" => "SiRyRZi",
"chisel" => "SizEl",
"chistera" => "Sist°Ra",
"chitine" => "Sitin",
"chitineux" => "Sitin2",
"chiton" => "Sit§",
"chiure" => "SjyR",
"chiures" => "SjyR",
"chlamyde" => "klamid",
"chlamydia" => "klamidja",
"chlamydiae" => "klamidje",
"chlass" => "Slas",
"chleuh" => "Sl2",
"chleuhs" => "Sl2",
"chlingue" => "Sl5g",
"chlinguer" => "Sl5ge",
"chlingues" => "Sl5g",
"chloral" => "kloRal",
"chloramphénicol" => "klOR@fenikOl",
"chlorate" => "kloRat",
"chlore" => "klOR",
"chloré" => "kloRe",
"chlorée" => "kloRe",
"chlorer" => "klORe",
"chlorhydrate" => "kloRidRat",
"chlorhydrique" => "kloRidRik",
"chlorique" => "klORik",
"chloroformant" => "kloRofORm@",
"chloroforme" => "kloRofORm",
"chloroformé" => "kloRofORme",
"chloroformer" => "kloRofORme",
"chloroformes" => "kloRofORm",
"chloroformez" => "kloRofORme",
"chloroformisation" => "kloRofORmizasj§",
"chlorophylle" => "kloRofil",
"chlorophyllien" => "kloRofilj5",
"chlorophytums" => "kloRofitOm",
"chloroplaste" => "kloRoplast",
"chloroquine" => "klOROkin",
"chlorotique" => "kloRotik",
"chlorotiques" => "kloRotik",
"chlorpromazine" => "klORpRomazin",
"chlorure" => "kloRyR",
"chlorures" => "kloRyR",
"chnoque" => "SnOk",
"chnoques" => "SnOk",
"chnord" => "knOR",
"chnouf" => "Snuf",
"choanes" => "koan",
"choc" => "SOk",
"chocard" => "SokaR",
"chochotte" => "SoSOt",
"chochottes" => "SoSOt",
"chocolat" => "Sokola",
"chocolaté" => "Sokolate",
"chocolatée" => "Sokolate",
"chocolatées" => "Sokolate",
"chocolaterie" => "Sokolat°Ri",
"chocolateries" => "Sokolat°Ri",
"chocolatés" => "Sokolate",
"chocolatier" => "Sokolatje",
"chocolatière" => "SokolatjER",
"chocolats" => "Sokola",
"chocottes" => "SokOt",
"chocs" => "SOk",
"choeur" => "k9R",
"choeurs" => "k9R",
"choie" => "Swa",
"choient" => "Swa",
"choieront" => "SwaR§",
"choir" => "SwaR",
"choiras" => "SwaRa",
"chois" => "Swa",
"choisi" => "Swazi",
"choisie" => "Swazi",
"choisies" => "Swazi",
"choisîmes" => "Swazim",
"choisir" => "SwaziR",
"choisira" => "SwaziRa",
"choisirai" => "SwaziRE",
"choisiraient" => "SwaziRE",
"choisirais" => "SwaziRE",
"choisirait" => "SwaziRE",
"choisiras" => "SwaziRa",
"choisirent" => "SwaziR",
"choisirez" => "SwaziRe",
"choisiriez" => "SwaziRje",
"choisirions" => "SwaziRj§",
"choisirons" => "SwaziR§",
"choisiront" => "SwaziR§",
"choisis" => "Swazi",
"choisissaient" => "SwazisE",
"choisissais" => "SwazisE",
"choisissait" => "SwazisE",
"choisissant" => "Swazis@",
"choisisse" => "Swazis",
"choisissent" => "Swazis",
"choisisses" => "Swazis",
"choisissez" => "Swazise",
"choisissiez" => "Swazisje",
"choisissions" => "Swazisj§",
"choisissons" => "Swazis§",
"choisit" => "Swazi",
"choisît" => "Swazi",
"choit" => "Swa",
"choix" => "Swa",
"choke" => "SOk",
"cholécystectomie" => "kOlesistEktOmi",
"cholécystite" => "kOlesistit",
"cholédoque" => "kOledOk",
"cholera" => "koleRa",
"choléra" => "koleRa",
"choléras" => "koleRa",
"cholériques" => "koleRik",
"cholestérol" => "kolEsteROl",
"choline" => "kOlin",
"cholines" => "kolin",
"cholinestérase" => "kOlinEs°teRaz",
"cholique" => "kOlik",
"chômage" => "SomaZ",
"chômaient" => "SomE",
"chômait" => "SomE",
"chôme" => "Som",
"chômé" => "Some",
"chômedu" => "Som°dy",
"chômée" => "Some",
"chôment" => "Som",
"chômer" => "Some",
"chômerez" => "Som°Re",
"chômés" => "Some",
"chômeur" => "Som9R",
"chômeurs" => "Som9R",
"chômeuse" => "Som2z",
"chômeuses" => "Som2z",
"chômez" => "Some",
"chop suey" => "SOps8Ej",
"chopaient" => "SopE",
"chopais" => "SopE",
"chopait" => "SopE",
"chopant" => "Sop@",
"chope" => "SOp",
"chopé" => "Sope",
"chopée" => "Sope",
"chopées" => "Sope",
"chopent" => "SOp",
"choper" => "Sope",
"chopera" => "SOp°Ra",
"choperai" => "SOp°RE",
"choperais" => "SOp°RE",
"choperait" => "SOp°RE",
"choperas" => "SOp°Ra",
"choperez" => "SOp°Re",
"choperons" => "SOp°R§",
"choperont" => "SOp°R§",
"chopes" => "SOp",
"chopés" => "Sope",
"chopez" => "Sope",
"chopine" => "Sopin",
"chopines" => "Sopin",
"chopons" => "Sop§",
"choppe" => "SOp",
"choppé" => "Sope",
"choppée" => "Sope",
"choppent" => "SOp",
"chopper" => "SOpe",
"choppers" => "Sop9R",
"choppes" => "SOp",
"choppez" => "Sope",
"choppons" => "Sop§",
"choqua" => "Soka",
"choquaient" => "SokE",
"choquait" => "SokE",
"choquant" => "Sok@",
"choquante" => "Sok@t",
"choquantes" => "Sok@t",
"choquants" => "Sok@",
"choque" => "SOk",
"choqué" => "Soke",
"choquée" => "Soke",
"choquées" => "Soke",
"choquent" => "SOk",
"choquer" => "Soke",
"choquera" => "SOk°Ra",
"choqueraient" => "SOk°RE",
"choquerais" => "SOk°RE",
"choquerait" => "SOk°RE",
"choqueras" => "SOk°Ra",
"choquèrent" => "SokER",
"choqués" => "Soke",
"choquez" => "Soke",
"choquons" => "Sok§",
"choral" => "koRal",
"chorale" => "koRal",
"chorales" => "koRal",
"chorals" => "koRal",
"choraux" => "koRo",
"chorba" => "SORba",
"chorée" => "koRe",
"chorégraphe" => "koRegRaf",
"chorégraphes" => "koRegRaf",
"chorégraphie" => "koRegRafi",
"chorégraphiées" => "koRegRafje",
"chorégraphier" => "kORegRafje",
"chorégraphies" => "koRegRafi",
"chorégraphique" => "koRegRafik",
"chorégraphiques" => "koRegRafik",
"choreutes" => "koR2t",
"choriste" => "koRist",
"choristes" => "koRist",
"chorizo" => "tSoRizo",
"chorizos" => "tSoRizo",
"chortens" => "SORt°n",
"chorus" => "koRys",
"chose" => "Soz",
"choser" => "Soze",
"choses" => "Soz",
"chosification" => "Sozifikasj§",
"chosifient" => "Sozifi",
"chosifier" => "Sozifje",
"chotts" => "SOt",
"chou" => "Su",
"chou-fleur" => "Sufl9R",
"chou-palmiste" => "Supalmist",
"chou-rave" => "SuRav",
"chouan" => "Sw@",
"chouannerie" => "Swan°Ri",
"chouans" => "Sw@",
"choucard" => "SukaR",
"choucarde" => "SukaRd",
"choucardes" => "SukaRd",
"choucards" => "SukaR",
"choucas" => "Suka",
"chouchou" => "SuSu",
"chouchous" => "SuSu",
"chouchoutage" => "SuSutaZ",
"chouchoutaient" => "SuSutE",
"chouchoutait" => "SuSutE",
"chouchoute" => "SuSut",
"chouchouté" => "SuSute",
"chouchoutée" => "SuSute",
"chouchouter" => "SuSute",
"chouchouteras" => "SuSut°Ra",
"chouchoutes" => "SuSut",
"chouchoutez" => "SuSute",
"choucroute" => "SukRut",
"choucroutes" => "SukRut",
"chouette" => "SwEt",
"chouettement" => "SwEt°m@",
"chouettes" => "SwEt",
"chougnait" => "SuNE",
"chougne" => "SuN",
"chouia" => "Suja",
"chouïa" => "Suja",
"chouiner" => "Swine",
"choupette" => "SupEt",
"chouquet" => "SukE",
"chouquette" => "SukEt",
"choura" => "SuRa",
"chouravait" => "SuRavE",
"chourave" => "SuRav",
"chouravé" => "SuRave",
"chouravée" => "SuRave",
"chouravent" => "SuRav",
"chouraver" => "SuRave",
"chouravés" => "SuRave",
"chouraveur" => "SuRav9R",
"chouraveurs" => "SuRav9R",
"chouraveuse" => "SuRav2z",
"chouraveuses" => "SuRav2z",
"choure" => "SuR",
"chouré" => "SuRe",
"chourée" => "SuRe",
"chourées" => "SuRe",
"chourent" => "SuR",
"chourer" => "SuRe",
"chouriez" => "SuRje",
"chourineurs" => "SuRin9R",
"choute" => "Sut",
"choutes" => "Sut",
"choux" => "Su",
"choux-fleurs" => "Sufl9R",
"choux-raves" => "SuRav",
"chouya" => "Suja",
"choya" => "Swaja",
"choyais" => "SwajE",
"choyait" => "SwajE",
"choyant" => "Swaj@",
"choyé" => "Swaje",
"choyée" => "Swaje",
"choyées" => "Swaje",
"choyer" => "Swaje",
"choyés" => "Swaje",
"choyez" => "Swaje",
"chrême" => "kREm",
"chrétien" => "kRetj5",
"chrétien-démocrate" => "kRetj5demokRat",
"chrétienne" => "kRetjEn",
"chrétiennement" => "kRetjEn°m@",
"chrétiennes" => "kRetjEn",
"chrétiens" => "kRetj5",
"chrétiens-démocrates" => "kRetj5demokRat",
"chrétienté" => "kRetj5te",
"christ" => "kRist",
"christiania" => "kRistjanja",
"christianisés" => "kRistjanize",
"christianisme" => "kRistjanizm",
"christique" => "kRistik",
"christmas" => "kRismas",
"christocentrisme" => "kRistos@tRizm",
"christologique" => "kRistoloZik",
"christs" => "kRist",
"chromage" => "kRomaZ",
"chromatique" => "kRomatik",
"chromatiques" => "kRomatik",
"chromatisme" => "kRomatizm",
"chromatismes" => "kRomatizm",
"chromatogramme" => "kROmatOgRam",
"chromatographie" => "kROmatOgRafi",
"chrome" => "kRom",
"chromé" => "kRome",
"chromée" => "kRome",
"chromées" => "kRome",
"chromes" => "kRom",
"chromés" => "kRome",
"chromo" => "kRomo",
"chromogènes" => "kRomoZEn",
"chromos" => "kRomo",
"chromosome" => "kRomozom",
"chromosomes" => "kRomozom",
"chromosomique" => "kRomozomik",
"chromosomiques" => "kRomozomik",
"chromosphère" => "kRomosfER",
"chroniquais" => "kRonikE",
"chronique" => "kRonik",
"chroniquement" => "kRonik°m@",
"chroniquer" => "kRonike",
"chroniques" => "kRonik",
"chroniqueur" => "kRonik9R",
"chroniqueurs" => "kRonik9R",
"chroniqueuse" => "kRonik2z",
"chroniqueuses" => "kRonik2z",
"chrono" => "kRono",
"chronographe" => "kRonogRaf",
"chronologie" => "kRonoloZi",
"chronologique" => "kRonoloZik",
"chronologiquement" => "kRonoloZik°m@",
"chronologiques" => "kRonoloZik",
"chronométrage" => "kRonometRaZ",
"chronométrait" => "kRonometRE",
"chronométrant" => "kRonometR@",
"chronomètre" => "kRonomEtR",
"chronométré" => "kRonometRe",
"chronométrée" => "kRonometRe",
"chronométrées" => "kRonometRe",
"chronométrer" => "kRonometRe",
"chronomètres" => "kRonomEtR",
"chronométrés" => "kRonometRe",
"chronométreur" => "kRonometR9R",
"chronométrez" => "kRonometRe",
"chronométrions" => "kRonometRij§",
"chronophotographie" => "kRonofOtOgRafi",
"chronophotographique" => "kROnofOtOgRafik",
"chronos" => "kRono",
"chrysalide" => "kRizalid",
"chrysalides" => "kRizalid",
"chrysanthème" => "kRiz@tEm",
"chrysanthèmes" => "kRiz@tEm",
"chrysolite" => "kRizOlit",
"chrysolithe" => "kRizOlit",
"chrysostome" => "kRizostom",
"chtar" => "StaR",
"chtarbé" => "StaRbe",
"chtarbée" => "StaRbe",
"chtarbées" => "StaRbe",
"chthoniennes" => "ktonjEn",
"chtibe" => "Stib",
"chtimi" => "Stimi",
"chtimis" => "Stimi",
"chtouille" => "Stuj",
"chtourbe" => "ktuRb",
"chu" => "Sy",
"chuchota" => "SySota",
"chuchotai" => "SySotE",
"chuchotaient" => "SySotE",
"chuchotais" => "SySotE",
"chuchotait" => "SySotE",
"chuchotant" => "SySot@",
"chuchotante" => "SySot@t",
"chuchotantes" => "SySot@t",
"chuchotants" => "SySot@",
"chuchotât" => "SySota",
"chuchote" => "SySOt",
"chuchoté" => "SySote",
"chuchotée" => "SySote",
"chuchotées" => "SySote",
"chuchotement" => "SySOt°m@",
"chuchotements" => "SySOt°m@",
"chuchotent" => "SySOt",
"chuchoter" => "SySote",
"chuchoteraient" => "SySOt°RE",
"chuchoterais" => "SySOt°RE",
"chuchoterait" => "SySOt°RE",
"chuchoteras" => "SySOt°Ra",
"chuchotèrent" => "SySotER",
"chuchoterez" => "SySOt°Re",
"chuchoteries" => "SySOt°Ri",
"chuchotés" => "SySote",
"chuchoteur" => "SySot9R",
"chuchoteuse" => "SySot2z",
"chuchotez" => "SySote",
"chuchotions" => "SySotj§",
"chuchotis" => "SySoti",
"chue" => "Sy",
"chues" => "Sy",
"chuinta" => "S85ta",
"chuintaient" => "S85tE",
"chuintait" => "S85tE",
"chuintant" => "S85t@",
"chuintante" => "S85t@t",
"chuintants" => "S85t@",
"chuinte" => "S85t",
"chuinté" => "S85te",
"chuintement" => "S85t°m@",
"chuintements" => "S85t°m@",
"chuinter" => "S85te",
"chuintèrent" => "S85tER",
"chulo" => "Sylo",
"chum" => "Sum",
"churrigueresque" => "SyRig°REsk",
"churros" => "SyRo",
"chus" => "Sy",
"chut" => "Syt",
"chuta" => "Syta",
"chutait" => "SytE",
"chutant" => "Syt@",
"chute" => "Syt",
"chuté" => "Syte",
"chutée" => "Syte",
"chutent" => "Syt",
"chuter" => "Syte",
"chutera" => "Syt°Ra",
"chuteraient" => "Syt°RE",
"chuterait" => "Syt°RE",
"chutèrent" => "SytER",
"chuterez" => "Syt°Re",
"chutes" => "Syt",
"chutney" => "S9tnE",
"chyle" => "Sil",
"chypre" => "SipR",
"chypriote" => "SipRijOt",
"ci" => "si",
"ci-après" => "siapRE",
"ci-contre" => "sik§tR",
"ci-dessous" => "sid°su",
"ci-dessus" => "sid°sy",
"ci-gît" => "siZi",
"ci-inclus" => "si5kly",
"ci-incluse" => "si5klyz",
"ci-incluses" => "si5klyz",
"ci-joint" => "siZw5",
"ci-jointe" => "siZw5t",
"ci-joints" => "siZw5",
"ciao" => "tSao",
"cibiche" => "sibiS",
"cibiches" => "sibiS",
"cibiste" => "sibist",
"cibistes" => "sibist",
"ciblage" => "siblaZ",
"ciblais" => "siblE",
"ciblait" => "siblE",
"cible" => "sibl",
"ciblé" => "sible",
"ciblée" => "sible",
"ciblées" => "sible",
"cibler" => "sible",
"ciblera" => "sibl°Ra",
"cibleront" => "sibl°R§",
"cibles" => "sibl",
"ciblés" => "sible",
"ciblez" => "sible",
"ciblons" => "sibl§",
"ciboire" => "sibwaR",
"ciboires" => "sibwaR",
"ciboule" => "sibul",
"ciboulette" => "sibulEt",
"ciboulot" => "sibulo",
"ciboulots" => "sibulo",
"cicatrice" => "sikatRis",
"cicatrices" => "sikatRis",
"cicatriciel" => "sikatRisjEl",
"cicatriciels" => "sikatRisjEl",
"cicatrisa" => "sikatRiza",
"cicatrisable" => "sikatRizabl",
"cicatrisait" => "sikatRizE",
"cicatrisante" => "sikatRiz@t",
"cicatrisants" => "sikatRiz@",
"cicatrisation" => "sikatRizasj§",
"cicatrise" => "sikatRiz",
"cicatrisé" => "sikatRize",
"cicatrisée" => "sikatRize",
"cicatrisées" => "sikatRize",
"cicatrisent" => "sikatRiz",
"cicatriser" => "sikatRize",
"cicatrisera" => "sikatRiz°Ra",
"cicatriserait" => "sikatRiz°RE",
"cicatriseront" => "sikatRiz°R§",
"cicatrisés" => "sikatRize",
"cicatrisez" => "sikatRize",
"cicero" => "siseRo",
"cicérone" => "siseROn",
"cicérones" => "siseROn",
"cicéronienne" => "siseRonjEn",
"cicindèle" => "sis5dEl",
"cicindèles" => "sis5dEl",
"cidre" => "sidR",
"cidrerie" => "sidR°Ri",
"ciel" => "sjEl",
"ciels" => "sjEl",
"cierge" => "sjERZ",
"cierges" => "sjERZ",
"cieux" => "sj2",
"cigale" => "sigal",
"cigales" => "sigal",
"cigalon" => "sigal§",
"cigalou" => "sigalu",
"cigare" => "sigaR",
"cigares" => "sigaR",
"cigarette" => "sigaREt",
"cigarettes" => "sigaREt",
"cigarettier" => "sigaREtje",
"cigarière" => "sigaRjER",
"cigarières" => "sigaRjER",
"cigarillo" => "sigaRijo",
"cigarillos" => "sigaRijo",
"cigle" => "sigl",
"ciglé" => "sigle",
"ciglées" => "sigle",
"ciglent" => "sigl",
"cigler" => "sigle",
"ciglés" => "sigle",
"cigogne" => "sigON",
"cigognes" => "sigON",
"ciguë" => "sigy",
"ciguës" => "sigy",
"cil" => "sil",
"ciliaires" => "siljER",
"cilice" => "silis",
"cilla" => "sija",
"cillaient" => "sijE",
"cillait" => "sijE",
"cillant" => "sij@",
"cille" => "sij",
"cillé" => "sije",
"cillement" => "sij°m@",
"cillements" => "sij°m@",
"cillent" => "sij",
"ciller" => "sije",
"cillerait" => "sij°RE",
"cillèrent" => "sijER",
"cils" => "sil",
"cimaise" => "simEz",
"cimaises" => "simEz",
"cimarron" => "simaR§",
"cime" => "sim",
"ciment" => "sim@",
"cimentaient" => "sim@tE",
"cimentait" => "sim@tE",
"cimentant" => "sim@t@",
"cimente" => "sim@t",
"cimenté" => "sim@te",
"cimentée" => "sim@te",
"cimentées" => "sim@te",
"cimentent" => "sim@t",
"cimenter" => "sim@te",
"cimentera" => "sim@t°Ra",
"cimenterie" => "sim@t°Ri",
"cimenteries" => "sim@t°Ri",
"cimentés" => "sim@te",
"ciments" => "sim@",
"cimes" => "sim",
"cimeterre" => "sim°tER",
"cimeterres" => "sim°tER",
"cimetière" => "sim°tjER",
"cimetières" => "sim°tjER",
"cimier" => "simje",
"cimiers" => "simje",
"cinabre" => "sinabR",
"ciné" => "sine",
"ciné-club" => "sinekl9b",
"ciné-clubs" => "sinekl9b",
"ciné-roman" => "sineRom@",
"cinéaste" => "sineast",
"cinéastes" => "sineast",
"cinéma" => "sinema",
"cinéma-vérité" => "sinemaveRite",
"cinémas" => "sinema",
"cinémascope" => "sinemaskOp",
"cinémathèque" => "sinematEk",
"cinémathèques" => "sinematEk",
"cinématique" => "sinematik",
"cinématographe" => "sinematogRaf",
"cinématographes" => "sinematogRaf",
"cinématographie" => "sinematogRafi",
"cinématographique" => "sinematogRafik",
"cinématographiquement" => "sinematogRafik°m@",
"cinématographiques" => "sinematogRafik",
"cinémomètres" => "sinemomEtR",
"cinéphile" => "sinefil",
"cinéphiles" => "sinefil",
"cinéraire" => "sineRER",
"cinérama" => "sineRama",
"cinés" => "sine",
"cinétique" => "sinetik",
"cinghalais" => "s5galE",
"cinghalaises" => "s5galEz",
"cingla" => "s5gla",
"cinglage" => "s5glaZ",
"cinglaient" => "s5glE",
"cinglait" => "s5glE",
"cinglant" => "s5gl@",
"cinglante" => "s5gl@t",
"cinglantes" => "s5gl@t",
"cinglants" => "s5gl@",
"cingle" => "s5gl",
"cinglé" => "s5gle",
"cinglée" => "s5gle",
"cinglées" => "s5gle",
"cinglement" => "s5gl°m@",
"cinglent" => "s5gl",
"cingler" => "s5gle",
"cinglèrent" => "s5glER",
"cinglés" => "s5gle",
"cinglions" => "s5glij§",
"cinglons" => "s5gl§",
"cinname" => "sinam",
"cinoche" => "sinOS",
"cinoches" => "sinOS",
"cinoque" => "sinOk",
"cinoques" => "sinOk",
"cinq" => "s5k",
"cinquantaine" => "s5k@tEn",
"cinquantaines" => "s5k@tEn",
"cinquante" => "s5k@t",
"cinquante-cinq" => "s5k@ts5k",
"cinquante-deux" => "s5k@td2",
"cinquante-huit" => "s5k@t8it",
"cinquante-huitième" => "s5k@t8itjEm",
"cinquante-neuf" => "s5k@tn9f",
"cinquante-neuvième" => "s5k@tn9vjEm",
"cinquante-quatre" => "s5k@tkatR",
"cinquante-sept" => "s5k@tsEt",
"cinquante-septième" => "s5k@tsEtjEm",
"cinquante-six" => "s5k@tsis",
"cinquante-sixième" => "s5k@tsizjEm",
"cinquante-trois" => "s5k@ttRwa",
"cinquante-troisième" => "s5k@ttRwazjEm",
"cinquantenaire" => "s5k@t°nER",
"cinquantenaires" => "s5k@t°nER",
"cinquantième" => "s5k@tjEm",
"cinquantièmes" => "s5k@tjEm",
"cinquième" => "s5kjEm",
"cinquièmement" => "s5kjEm°m@",
"cinquièmes" => "s5kjEm",
"cintra" => "s5tRa",
"cintrage" => "s5tRaZ",
"cintrait" => "s5tRE",
"cintrant" => "s5tR@",
"cintras" => "s5tRa",
"cintre" => "s5tR",
"cintré" => "s5tRe",
"cintrée" => "s5tRe",
"cintrées" => "s5tRe",
"cintrer" => "s5tRe",
"cintres" => "s5tR",
"cintrés" => "s5tRe",
"cinzano" => "tSinzano",
"cipal" => "sipal",
"cipaye" => "sipaj",
"cipayes" => "sipaj",
"cipolin" => "sipol5",
"cippes" => "sip",
"cira" => "siRa",
"cirage" => "siRaZ",
"ciraient" => "siRE",
"cirais" => "siRE",
"cirait" => "siRE",
"cirant" => "siR@",
"circadien" => "siRkadj5",
"circaète" => "siRkaEt",
"circassien" => "siRkasj5",
"circassienne" => "siRkasjEn",
"circassiennes" => "siRkasjEn",
"circoncire" => "siRk§siR",
"circoncis" => "siRk§si",
"circoncise" => "siRk§siz",
"circoncisent" => "siRk§siz",
"circoncision" => "siRk§sizj§",
"circoncisions" => "siRk§sizj§",
"circoncit" => "siRk§si",
"circonférence" => "siRk§feR@s",
"circonflexe" => "siRk§flEks",
"circonflexes" => "siRk§flEks",
"circonlocutions" => "siRk§lokysj§",
"circonscription" => "siRk§skRipsj§",
"circonscriptions" => "siRk§skRipsj§",
"circonscriptions-clés" => "siRk§skRipsj§kle",
"circonscrire" => "siRk§skRiR",
"circonscris" => "siRk§skRi",
"circonscrit" => "siRk§skRi",
"circonscrite" => "siRk§skRit",
"circonscrites" => "siRk§skRit",
"circonscrits" => "siRk§skRi",
"circonscrivait" => "siRk§skRivE",
"circonscrivent" => "siRk§skRiv",
"circonscrivit" => "siRk§skRivi",
"circonspect" => "siRk§spE",
"circonspecte" => "siRk§spEkt",
"circonspectes" => "siRk§spEkt",
"circonspection" => "siRk§spEksj§",
"circonspections" => "siRk§spEksj§",
"circonspects" => "siRk§spE",
"circonstance" => "siRk§st@s",
"circonstances" => "siRk§st@s",
"circonstancia" => "siRk§st@sja",
"circonstancié" => "siRk§st@sje",
"circonstanciée" => "siRk§st@sje",
"circonstanciées" => "siRk§st@sje",
"circonstanciel" => "siRk§st@sjEl",
"circonstancielle" => "siRk§st@sjEl",
"circonstanciels" => "siRk§st@sjEl",
"circonstanciés" => "siRk§st@sje",
"circonvallation" => "siRk§valasj§",
"circonvallations" => "siRk§valasj§",
"circonvenant" => "siRk§v°n@",
"circonvenir" => "siRk§v°niR",
"circonvenu" => "siRk§v°ny",
"circonvenue" => "siRk§v°ny",
"circonvient" => "siRk§vj5",
"circonvolution" => "siRk§volysj§",
"circonvolutions" => "siRk§volysj§",
"circuit" => "siRk8i",
"circuits" => "siRk8i",
"circula" => "siRkyla",
"circulaient" => "siRkylE",
"circulaire" => "siRkylER",
"circulairement" => "siRkylER°m@",
"circulaires" => "siRkylER",
"circulais" => "siRkylE",
"circulait" => "siRkylE",
"circulant" => "siRkyl@",
"circularité" => "siRkylaRite",
"circulation" => "siRkylasj§",
"circulations" => "siRkylasj§",
"circulatoire" => "siRkylatwaR",
"circulatoires" => "siRkylatwaR",
"circule" => "siRkyl",
"circulé" => "siRkyle",
"circulent" => "siRkyl",
"circuler" => "siRkyle",
"circulera" => "siRkyl°Ra",
"circuleraient" => "siRkyl°RE",
"circulerait" => "siRkyl°RE",
"circulèrent" => "siRkylER",
"circuleront" => "siRkyl°R§",
"circules" => "siRkyl",
"circulez" => "siRkyle",
"circulions" => "siRkylj§",
"circulons" => "siRkyl§",
"circumnavigation" => "siRk§navigasj§",
"cire" => "siR",
"ciré" => "siRe",
"cirée" => "siRe",
"cirées" => "siRe",
"cirent" => "siR",
"cirer" => "siRe",
"cirerais" => "siR°RE",
"cirerait" => "siR°RE",
"cires" => "siR",
"cirés" => "siRe",
"cireur" => "siR9R",
"cireurs" => "siR9R",
"cireuse" => "siR2z",
"cireuses" => "siR2z",
"cireux" => "siR2",
"cirez" => "siRe",
"cirions" => "siRj§",
"ciron" => "siR§",
"cirons" => "siR§",
"cirque" => "siRk",
"cirques" => "siRk",
"cirrhose" => "siRoz",
"cirrhotique" => "siRotik",
"cirrus" => "siRys",
"cirses" => "siRs",
"cis" => "si",
"cisailla" => "sizaja",
"cisaillage" => "sizajaZ",
"cisaillaient" => "sizajE",
"cisaillait" => "sizajE",
"cisaillant" => "sizaj@",
"cisaille" => "sizaj",
"cisaillé" => "sizaje",
"cisaillée" => "sizaje",
"cisaillées" => "sizaje",
"cisaillement" => "sizaj°m@",
"cisaillent" => "sizaj",
"cisailler" => "sizaje",
"cisaillèrent" => "sizajER",
"cisailles" => "sizaj",
"cisaillés" => "sizaje",
"ciseau" => "sizo",
"ciseaux" => "sizo",
"ciselaient" => "siz°lE",
"ciselait" => "siz°lE",
"cisèle" => "sizEl",
"ciselé" => "siz°le",
"ciselée" => "siz°le",
"ciselées" => "siz°le",
"ciseler" => "siz°le",
"ciselés" => "siz°le",
"ciselet" => "siz°lE",
"ciseleurs" => "siz°l9R",
"ciselions" => "siz°lj§",
"ciselure" => "siz°lyR",
"ciselures" => "siz°lyR",
"ciste" => "sist",
"cistercien" => "sistERsj5",
"cistercienne" => "sistERsjEn",
"cisterciennes" => "sistERsjEn",
"cisterciens" => "sistERsj5",
"cistes" => "sist",
"cita" => "sita",
"citadelle" => "sitadEl",
"citadelles" => "sitadEl",
"citadin" => "sitad5",
"citadine" => "sitadin",
"citadines" => "sitadin",
"citadins" => "sitad5",
"citai" => "sitE",
"citaient" => "sitE",
"citais" => "sitE",
"citait" => "sitE",
"citant" => "sit@",
"citât" => "sita",
"citation" => "sitasj§",
"citations" => "sitasj§",
"cite" => "sit",
"cité" => "site",
"cité-dortoir" => "sitedORtwaR",
"cité-jardin" => "siteZaRd5",
"citée" => "site",
"citées" => "site",
"citent" => "sit",
"citer" => "site",
"citera" => "sit°Ra",
"citerai" => "sit°RE",
"citerais" => "sit°RE",
"citerait" => "sit°RE",
"citeras" => "sit°Ra",
"citèrent" => "sitER",
"citérieure" => "siteRj9R",
"citerne" => "sitERn",
"citernes" => "sitERn",
"cites" => "sit",
"cités" => "site",
"cités-dortoirs" => "sitedORtwaR",
"citez" => "site",
"cithare" => "sitaR",
"cithares" => "sitaR",
"citiez" => "sitje",
"citions" => "sitj§",
"citizen band" => "sitiz2nb@d",
"citons" => "sit§",
"citoyen" => "sitwaj5",
"citoyenne" => "sitwajEn",
"citoyennes" => "sitwajEn",
"citoyenneté" => "sitwajEn°te",
"citoyens" => "sitwaj5",
"citrate" => "sitRat",
"citrine" => "sitRin",
"citrique" => "sitRik",
"citron" => "sitR§",
"citronnade" => "sitRonad",
"citronnades" => "sitRonad",
"citronné" => "sitRone",
"citronnée" => "sitROne",
"citronnelle" => "sitRonEl",
"citronnelles" => "sitRonEl",
"citronnez" => "sitRone",
"citronnier" => "sitRonje",
"citronniers" => "sitRonje",
"citrons" => "sitR§",
"citrouille" => "sitRuj",
"citrouilles" => "sitRuj",
"citrus" => "sitRys",
"city" => "siti",
"civadière" => "sivadjER",
"civelles" => "sivEl",
"civelots" => "siv°lo",
"civet" => "sivE",
"civets" => "sivE",
"civette" => "sivEt",
"civière" => "sivjER",
"civières" => "sivjER",
"civil" => "sivil",
"civile" => "sivil",
"civilement" => "sivil°m@",
"civiles" => "sivil",
"civilisateur" => "sivilizat9R",
"civilisation" => "sivilizasj§",
"civilisations" => "sivilizasj§",
"civilisatrice" => "sivilizatRis",
"civilise" => "siviliz",
"civilisé" => "sivilize",
"civilisée" => "sivilize",
"civilisées" => "sivilize",
"civiliser" => "sivilize",
"civilises" => "siviliz",
"civilisés" => "sivilize",
"civilité" => "sivilite",
"civilités" => "sivilite",
"civils" => "sivil",
"civique" => "sivik",
"civiques" => "sivik",
"civisme" => "sivizm",
"clabaudage" => "klabodaZ",
"clabaudages" => "klabodaZ",
"clabaudaient" => "klabodE",
"clabaudé" => "klabode",
"clabaudent" => "klabod",
"clabauder" => "klabode",
"clabauderies" => "klabod°Ri",
"clabote" => "klabOt",
"claboté" => "klabote",
"clabotent" => "klabOt",
"claboter" => "klabote",
"clac" => "klak",
"clafouti" => "klafuti",
"clafoutis" => "klafuti",
"claie" => "klE",
"claies" => "klE",
"claim" => "klEm",
"clair" => "klER",
"clair-obscur" => "klEROpskyR",
"claire" => "klER",
"claire-voie" => "klERvwa",
"clairement" => "klER°m@",
"claires" => "klER",
"claires-voies" => "klERvwa",
"clairet" => "klERE",
"clairette" => "klEREt",
"clairière" => "klERjER",
"clairières" => "klERjER",
"clairon" => "klER§",
"claironna" => "klERona",
"claironnait" => "klERonE",
"claironnant" => "klERon@",
"claironnante" => "klERon@t",
"claironnantes" => "klERon@t",
"claironnants" => "klERon@",
"claironne" => "klEROn",
"claironné" => "klERone",
"claironnent" => "klEROn",
"claironner" => "klERone",
"claironnions" => "klERonj§",
"clairons" => "klER§",
"clairs" => "klER",
"clairs-obscurs" => "klEROpskyR",
"clairsemaient" => "klERs°mE",
"clairsemait" => "klERs°mE",
"clairsemant" => "klERs°m@",
"clairsemé" => "klERs°me",
"clairsemée" => "klERs°me",
"clairsemées" => "klERs°me",
"clairsemés" => "klERs°me",
"clairvoyance" => "klERvwaj@s",
"clairvoyances" => "klERvwaj@s",
"clairvoyant" => "klERvwaj@",
"clairvoyante" => "klERvwaj@t",
"clairvoyants" => "klERvwaj@",
"clam" => "klam",
"clama" => "klama",
"clamai" => "klamE",
"clamaient" => "klamE",
"clamait" => "klamE",
"clamant" => "klam@",
"clame" => "klam",
"clamé" => "klame",
"clamecé" => "klam°se",
"clamecée" => "klam°se",
"clamecer" => "klam°se",
"clamée" => "klame",
"clament" => "klam",
"clamer" => "klame",
"clameraient" => "klam°RE",
"clamèrent" => "klamER",
"clamés" => "klame",
"clameur" => "klam9R",
"clameurs" => "klam9R",
"clamez" => "klame",
"clamions" => "klamj§",
"clamp" => "kl@p",
"clampe" => "kl@p",
"clampé" => "kl@pe",
"clamper" => "kl@pe",
"clampin" => "kl@p5",
"clampins" => "kl@p5",
"clamps" => "kl@p",
"clams" => "klam",
"clamse" => "klams",
"clamsé" => "klamse",
"clamsée" => "klamse",
"clamser" => "klamse",
"clamserai" => "klams°RE",
"clamserait" => "klams°RE",
"clamsés" => "klamse",
"clan" => "kl@",
"clandé" => "kl@de",
"clandés" => "kl@de",
"clandestin" => "kl@dEst5",
"clandestine" => "kl@dEstin",
"clandestinement" => "kl@dEstin°m@",
"clandestines" => "kl@dEstin",
"clandestinité" => "kl@dEstinite",
"clandestinités" => "kl@dEstinite",
"clandestins" => "kl@dEst5",
"clans" => "kl@",
"clap" => "klap",
"clapant" => "klap@",
"clape" => "klap",
"clapé" => "klape",
"clapent" => "klap",
"claper" => "klape",
"claperai" => "klap°RE",
"clapes" => "klap",
"clapet" => "klapE",
"clapets" => "klapE",
"clapette" => "klapEt",
"clapier" => "klapje",
"clapiers" => "klapje",
"clapir" => "klapiR",
"clapit" => "klapi",
"clapot" => "klapo",
"clapota" => "klapota",
"clapotaient" => "klapotE",
"clapotait" => "klapotE",
"clapotant" => "klapot@",
"clapotante" => "klapot@t",
"clapotantes" => "klapot@t",
"clapote" => "klapOt",
"clapotement" => "klapOt°m@",
"clapotements" => "klapOt°m@",
"clapotent" => "klapOt",
"clapoter" => "klapote",
"clapoterait" => "klapOt°RE",
"clapotis" => "klapoti",
"clappait" => "klapE",
"clappant" => "klap@",
"clappe" => "klap",
"clappement" => "klap°m@",
"clappements" => "klap°m@",
"clapper" => "klape",
"claqua" => "klaka",
"claquage" => "klakaZ",
"claquai" => "klakE",
"claquaient" => "klakE",
"claquais" => "klakE",
"claquait" => "klakE",
"claquant" => "klak@",
"claquante" => "klak@t",
"claquantes" => "klak@t",
"claquants" => "klak@",
"claquât" => "klaka",
"claque" => "klak",
"claqué" => "klake",
"claque-merde" => "klakmERd",
"claquedents" => "klak°d@",
"claquée" => "klake",
"claquées" => "klake",
"claquement" => "klak°m@",
"claquements" => "klak°m@",
"claquemurait" => "klak°myRE",
"claquemurant" => "klak°myR@",
"claquemuré" => "klak°myRe",
"claquemurée" => "klak°myRe",
"claquemurées" => "klak°myRe",
"claquemurer" => "klak°myRe",
"claquemures" => "klak°myR",
"claquemurés" => "klak°myRe",
"claquent" => "klak",
"claquer" => "klake",
"claquera" => "klak°Ra",
"claquerai" => "klak°RE",
"claqueraient" => "klak°RE",
"claquerais" => "klak°RE",
"claquerait" => "klak°RE",
"claquèrent" => "klakER",
"claqueriez" => "klak°Rje",
"claqueront" => "klak°R§",
"claques" => "klak",
"claqués" => "klake",
"claquet" => "klakE",
"claquetèrent" => "klak°tER",
"claquette" => "klakEt",
"claquettes" => "klakEt",
"claqueurs" => "klak9R",
"claquez" => "klake",
"claquions" => "klakj§",
"claquoirs" => "klakwaR",
"claquons" => "klak§",
"clarifia" => "klaRifja",
"clarifiant" => "klaRifj@",
"clarification" => "klaRifikasj§",
"clarifie" => "klaRifi",
"clarifié" => "klaRifje",
"clarifiée" => "klaRifje",
"clarifier" => "klaRifje",
"clarifions" => "klaRifj§",
"clarine" => "klaRin",
"clarines" => "klaRin",
"clarinette" => "klaRinEt",
"clarinettes" => "klaRinEt",
"clarinettiste" => "klaRinetist",
"clarisse" => "klaRis",
"clarisses" => "klaRis",
"clarissimes" => "klaRisim",
"clarté" => "klaRte",
"clartés" => "klaRte",
"clash" => "klaS",
"class" => "klas",
"classa" => "klasa",
"classable" => "klasabl",
"classaient" => "klasE",
"classais" => "klasE",
"classait" => "klasE",
"classant" => "klas@",
"classe" => "klas",
"classé" => "klase",
"classée" => "klase",
"classées" => "klase",
"classement" => "klas°m@",
"classements" => "klas°m@",
"classent" => "klas",
"classer" => "klase",
"classera" => "klas°Ra",
"classerai" => "klas°RE",
"classeraient" => "klas°RE",
"classerais" => "klas°RE",
"classerait" => "klas°RE",
"classeras" => "klas°Ra",
"classèrent" => "klasER",
"classes" => "klas",
"classés" => "klase",
"classeur" => "klas9R",
"classeurs" => "klas9R",
"classez" => "klase",
"classicisme" => "klasisizm",
"classico" => "klasiko",
"classieuse" => "klasj2z",
"classieux" => "klasj2",
"classiez" => "klasje",
"classifiables" => "klasifjabl",
"classificateur" => "klasifikat9R",
"classification" => "klasifikasj§",
"classifications" => "klasifikasj§",
"classificatrice" => "klasifikatRis",
"classifié" => "klasifje",
"classifiées" => "klasifje",
"classifient" => "klasifi",
"classifier" => "klasifje",
"classifierais" => "klasifiRE",
"classique" => "klasik",
"classiquement" => "klasik°m@",
"classiques" => "klasik",
"classons" => "klas§",
"clathres" => "klatR",
"claude" => "klod",
"claudélienne" => "klodeljEn",
"claudicant" => "klodik@",
"claudicante" => "klodik@t",
"claudicants" => "klodik@",
"claudication" => "klodikasj§",
"claudiquait" => "klodikE",
"claudiquant" => "klodik@",
"claudique" => "klodik",
"claudiquer" => "klodike",
"claudiquerait" => "klodik°RE",
"claudiquerez" => "klodik°Re",
"clause" => "kloz",
"clauses" => "kloz",
"clausewitziens" => "kloziwitsj5",
"claustrait" => "klostRE",
"claustrale" => "klostRal",
"claustration" => "klostRasj§",
"claustrée" => "klostRe",
"claustrophobe" => "klostRofOb",
"claustrophobie" => "klostRofobi",
"clavaire" => "klavER",
"clavaires" => "klavER",
"claveaux" => "klavo",
"clavecin" => "klav°s5",
"claveciniste" => "klav°sinist",
"clavecins" => "klav°s5",
"clavette" => "klavEt",
"clavicule" => "klavikyl",
"clavicules" => "klavikyl",
"clavier" => "klavje",
"claviers" => "klavje",
"clayettes" => "klajEt",
"claymore" => "klEjmoR",
"clayon" => "klEj§",
"clayonnage" => "klEjonaZ",
"clayonnages" => "klEjonaZ",
"clayonnée" => "klEjone",
"clayons" => "klEj§",
"clé" => "kle",
"clean" => "klin",
"clearing" => "kliRiG",
"clébard" => "klebaR",
"clébards" => "klebaR",
"clebs" => "klEps",
"clef" => "kle",
"clefs" => "kle",
"clématite" => "klematit",
"clématites" => "klematit",
"clémence" => "klem@s",
"clément" => "klem@",
"clémente" => "klem@t",
"clémentes" => "klem@t",
"clémentine" => "klem@tin",
"cléments" => "klem@",
"clenche" => "kl@S",
"clenches" => "kl@S",
"clepsydre" => "klEpsidR",
"cleptomane" => "klEptoman",
"cleptomanie" => "klEptomani",
"clerc" => "klER",
"clercs" => "klER",
"clergé" => "klERZe",
"clergeon" => "klERZ§",
"clergés" => "klERZe",
"clergyman" => "klERZiman",
"clergymen" => "klERZimEn",
"clérical" => "kleRikal",
"cléricale" => "kleRikal",
"cléricales" => "kleRikal",
"cléricalisme" => "kleRikalizm",
"cléricature" => "kleRikatyR",
"cléricaux" => "kleRiko",
"clermontois" => "klERm§twa",
"clermontoise" => "klERm§twaz",
"clés" => "kle",
"clic" => "klik",
"clic-clac" => "klikklak",
"clichage" => "kliSaZ",
"cliché" => "kliSe",
"clichée" => "kliSe",
"clicher" => "kliSe",
"clicherie" => "kliS°Ri",
"clichés" => "kliSe",
"clicheur" => "kliS9R",
"click" => "klik",
"clics" => "klik",
"client" => "klij@",
"client-roi" => "klij@Rwa",
"cliente" => "klij@t",
"clientèle" => "klij@tEl",
"clientèles" => "klij@tEl",
"clientes" => "klij@t",
"clients" => "klij@",
"cligna" => "kliNa",
"clignaient" => "kliNE",
"clignais" => "kliNE",
"clignait" => "kliNE",
"clignant" => "kliN@",
"cligne" => "kliN",
"cligné" => "kliNe",
"clignées" => "kliNe",
"clignement" => "kliN°m@",
"clignements" => "kliN°m@",
"clignent" => "kliN",
"cligner" => "kliNe",
"clignèrent" => "kliNER",
"clignés" => "kliNe",
"clignez" => "kliNe",
"clignons" => "kliN§",
"clignota" => "kliNota",
"clignotaient" => "kliNotE",
"clignotait" => "kliNotE",
"clignotant" => "kliNot@",
"clignotante" => "kliNot@t",
"clignotantes" => "kliNot@t",
"clignotants" => "kliNot@",
"clignote" => "kliNOt",
"clignoté" => "kliNote",
"clignotement" => "kliNOt°m@",
"clignotements" => "kliNOt°m@",
"clignotent" => "kliNOt",
"clignoter" => "kliNote",
"clignotera" => "kliNOt°Ra",
"clignoterait" => "kliNOt°RE",
"clignotèrent" => "kliNotER",
"clignoteur" => "kliNot9R",
"clilles" => "klil",
"climat" => "klima",
"climatériques" => "klimateRik",
"climatique" => "klimatik",
"climatiques" => "klimatik",
"climatisant" => "klimatiz@",
"climatisation" => "klimatizasj§",
"climatisé" => "klimatize",
"climatisée" => "klimatize",
"climatisées" => "klimatize",
"climatiser" => "klimatize",
"climatisés" => "klimatize",
"climatiseur" => "klimatiz9R",
"climatiseurs" => "klimatiz9R",
"climatologue" => "klimatOlOg",
"climats" => "klima",
"climax" => "klimaks",
"clin" => "kl5",
"clin-d'oeil" => "kl5d9j",
"clinche" => "kl5S",
"clinicat" => "klinika",
"clinicien" => "klinisj5",
"clinicienne" => "klinisjEn",
"cliniciens" => "klinisj5",
"clinique" => "klinik",
"cliniquement" => "klinik°m@",
"cliniques" => "klinik",
"clinker" => "klink9R",
"clinquant" => "kl5k@",
"clinquante" => "kl5k@t",
"clinquantes" => "kl5k@t",
"clinquants" => "kl5k@",
"clins" => "kl5",
"clip" => "klip",
"clipper" => "klip9R",
"clippers" => "klip9R",
"clips" => "klip",
"cliquant" => "klik@",
"clique" => "klik",
"cliqué" => "klike",
"cliquer" => "klike",
"cliques" => "klik",
"cliquet" => "klikE",
"cliqueta" => "klik°ta",
"cliquetaient" => "klik°tE",
"cliquetait" => "klik°tE",
"cliquetant" => "klik°t@",
"cliquetante" => "klik°t@t",
"cliquetantes" => "klik°t@t",
"cliquetants" => "klik°t@",
"cliquètement" => "klikEt°m@",
"cliquètements" => "klikEt°m@",
"cliqueter" => "klik°te",
"cliquetis" => "klik°ti",
"cliquets" => "klikE",
"cliquette" => "klikEt",
"cliquettement" => "klikEt°m@",
"cliquettent" => "klikEt",
"cliquettes" => "klikEt",
"cliquez" => "klike",
"clissées" => "klise",
"clito" => "klito",
"clitoridectomie" => "klitORidEktOmi",
"clitoridien" => "klitoRidj5",
"clitoridienne" => "klitoRidjEn",
"clitoris" => "klitoRis",
"clivage" => "klivaZ",
"clivages" => "klivaZ",
"cliver" => "klive",
"clivés" => "klive",
"cloacal" => "kloakal",
"cloaque" => "kloak",
"cloaques" => "kloak",
"cloc" => "klOk",
"clochaient" => "kloSE",
"clochait" => "kloSE",
"clochant" => "kloS@",
"clochard" => "kloSaR",
"clocharde" => "kloSaRd",
"clochardes" => "kloSaRd",
"clochardisait" => "kloSaRdizE",
"clochardisation" => "kloSaRdizasj§",
"clochardisé" => "kloSaRdize",
"clochardiser" => "kloSaRdize",
"clochards" => "kloSaR",
"clochât" => "kloSa",
"cloche" => "klOS",
"cloché" => "kloSe",
"cloche-pied" => "klOSpje",
"clochent" => "klOS",
"clocher" => "kloSe",
"clochers" => "kloSe",
"cloches" => "klOS",
"clocheton" => "klOS°t§",
"clochetons" => "klOS°t§",
"clochette" => "kloSEt",
"clochettes" => "kloSEt",
"clodo" => "klodo",
"clodos" => "klodo",
"cloison" => "klwaz§",
"cloisonnaient" => "klwazonE",
"cloisonnais" => "klwazonE",
"cloisonnant" => "klwazon@",
"cloisonne" => "klwazOn",
"cloisonné" => "klwazone",
"cloisonnée" => "klwazone",
"cloisonnées" => "klwazone",
"cloisonnement" => "klwazOn°m@",
"cloisonnements" => "klwazOn°m@",
"cloisonner" => "klwazone",
"cloisonnés" => "klwazone",
"cloisons" => "klwaz§",
"cloîtra" => "klwatRa",
"cloîtrai" => "klwatRE",
"cloîtraient" => "klwatRE",
"cloîtrait" => "klwatRE",
"cloîtrâmes" => "klwatRam",
"cloîtrant" => "klwatR@",
"cloître" => "klwatR",
"cloîtré" => "klwatRe",
"cloîtrée" => "klwatRe",
"cloîtrées" => "klwatRe",
"cloîtrer" => "klwatRe",
"cloîtres" => "klwatR",
"cloîtrés" => "klwatRe",
"clonage" => "klonaZ",
"clonant" => "klon@",
"clone" => "klon",
"cloné" => "klone",
"clonent" => "klon",
"cloner" => "klOne",
"clones" => "klon",
"clonés" => "klone",
"clonique" => "klOnik",
"clopais" => "klopE",
"clopant" => "klop@",
"clope" => "klOp",
"cloper" => "klOpe",
"clopes" => "klOp",
"clopeur" => "klop9R",
"clopin-clopant" => "klop5klop@",
"clopina" => "klopina",
"clopinait" => "klopinE",
"clopinâmes" => "klopinam",
"clopinant" => "klopin@",
"clopine" => "klopin",
"clopinements" => "klopin°m@",
"clopiner" => "klopine",
"clopinettes" => "klopinEt",
"clopinez" => "klopine",
"cloporte" => "klopORt",
"cloportes" => "klopORt",
"cloquait" => "klokE",
"cloquant" => "klok@",
"cloque" => "klOk",
"cloqué" => "kloke",
"cloquée" => "kloke",
"cloquées" => "kloke",
"cloquent" => "klOk",
"cloquer" => "kloke",
"cloques" => "klOk",
"cloqués" => "kloke",
"clora" => "kloRa",
"clore" => "klOR",
"clos" => "klo",
"close" => "kloz",
"close-combat" => "klozk§ba",
"close-up" => "kloz9p",
"closent" => "kloz",
"closerie" => "kloz°Ri",
"closes" => "kloz",
"clôt" => "klo",
"clôtura" => "klotyRa",
"clôturai" => "klotyRE",
"clôturaient" => "klotyRE",
"clôturait" => "klotyRE",
"clôture" => "klotyR",
"clôturé" => "klotyRe",
"clôturée" => "klotyRe",
"clôturent" => "klotyR",
"clôturer" => "klotyRe",
"clôturera" => "klotyR°Ra",
"clôtures" => "klotyR",
"clou" => "klu",
"cloua" => "klua",
"clouage" => "kluaZ",
"clouai" => "kluE",
"clouaient" => "kluE",
"clouait" => "kluE",
"clouant" => "klu@",
"cloue" => "klu",
"cloué" => "klue",
"clouée" => "klue",
"clouées" => "klue",
"clouent" => "klu",
"clouer" => "klue",
"clouera" => "kluRa",
"clouerai" => "kluRE",
"cloueraient" => "kluRE",
"clouerait" => "kluRE",
"cloueras" => "kluRa",
"clouèrent" => "kluER",
"clouerez" => "kluRe",
"cloués" => "klue",
"cloueur" => "klu9R",
"cloueuse" => "klu2z",
"clouez" => "klue",
"clouions" => "kluj§",
"clouons" => "klu§",
"clous" => "klu",
"cloutage" => "klutaZ",
"clouté" => "klute",
"cloutée" => "klute",
"cloutées" => "klute",
"cloutés" => "klute",
"cloutier" => "klutje",
"clown" => "klun",
"clownerie" => "klun°Ri",
"clowneries" => "klun°Ri",
"clownesque" => "klunEsk",
"clownesques" => "klunEsk",
"clowns" => "klun",
"club" => "kl9b",
"club-house" => "kl9baws",
"clubhouse" => "kl9baws",
"clubiste" => "klybist",
"clubman" => "kl9bman",
"clubs" => "kl9b",
"clunisien" => "klynizj5",
"cluse" => "klyz",
"cluses" => "klyz",
"cluster" => "kl9st9R",
"clystère" => "klistER",
"clystères" => "klistER",
"cm" => "s@timEtR",
"co" => "ko",
"co-animateur" => "koanimat9R",
"co-auteur" => "koot9R",
"co-avocat" => "koavoka",
"co-capitaine" => "kokapitEn",
"co-dépendance" => "kodep@d@s",
"co-dépendante" => "kodep@d@t",
"co-éducative" => "koedykativ",
"co-équipier" => "koekipje",
"co-équipière" => "koekipjER",
"co-existence" => "koEgzist@s",
"co-exister" => "koEgziste",
"co-habiter" => "koabite",
"co-locataire" => "kolokatER",
"co-pilote" => "kopilOt",
"co-pilotes" => "kopilOt",
"co-président" => "kopRezid@",
"co-production" => "kopRodyksj§",
"co-productions" => "kopRodyksj§",
"co-propriétaire" => "kopRopRietER",
"co-propriétaires" => "kopRopRietER",
"co-propriété" => "kopRopRiete",
"co-proprio" => "kopRopRio",
"co-proprios" => "kopRopRio",
"co-responsable" => "koREsp§sabl",
"co-signer" => "kosiNe",
"co-signons" => "kosiN§",
"co-tuteur" => "kotyt9R",
"co-vedette" => "kov2dEt",
"co-voiturage" => "kovwatyRaZ",
"coaccusé" => "koakyze",
"coaccusés" => "koakyze",
"coach" => "kotS",
"coache" => "kotS",
"coaché" => "kotSe",
"coacher" => "kotSe",
"coaches" => "kotS",
"coachs" => "kotS",
"coactionnaires" => "koaksjonER",
"coadjuteur" => "koadZyt9R",
"coagula" => "koagyla",
"coagulaient" => "koagylE",
"coagulait" => "koagylE",
"coagulant" => "koagyl@",
"coagulantes" => "koagyl@t",
"coagulants" => "koagyl@",
"coagulât" => "koagyla",
"coagulation" => "koagylasj§",
"coagule" => "koagyl",
"coagulé" => "koagyle",
"coagulée" => "koagyle",
"coagulées" => "koagyle",
"coagulent" => "koagyl",
"coaguler" => "koagyle",
"coagulera" => "koagyl°Ra",
"coagulés" => "koagyle",
"coalisaient" => "koalizE",
"coalisée" => "koalize",
"coalisent" => "koaliz",
"coaliser" => "koalize",
"coalisés" => "koalize",
"coalition" => "koalisj§",
"coalitions" => "koalisj§",
"coaltar" => "kOltaR",
"coassaient" => "koasE",
"coassant" => "koas@",
"coasse" => "koas",
"coassement" => "koas°m@",
"coassements" => "koas°m@",
"coassent" => "koas",
"coasser" => "koase",
"coati" => "koati",
"coauteur" => "koot9R",
"coauteurs" => "koot9R",
"coaxial" => "koaksjal",
"coaxiales" => "koaksjal",
"cob" => "kOb",
"cobalt" => "kobalt",
"cobaye" => "kobaj",
"cobayes" => "kobaj",
"cobelligérants" => "kobEliZeR@",
"cobol" => "kobOl",
"cobra" => "kobRa",
"cobras" => "kobRa",
"coca" => "koka",
"coca-cola" => "kokakola",
"cocagne" => "kokaN",
"cocagnes" => "kokaN",
"cocaïne" => "kokain",
"cocaïnomane" => "kokainoman",
"cocard" => "kokaR",
"cocardasse" => "kokaRdas",
"cocarde" => "kokaRd",
"cocarder" => "kOkaRde",
"cocardes" => "kokaRd",
"cocardés" => "kokaRde",
"cocardier" => "kokaRdje",
"cocardière" => "kOkaRdjER",
"cocardières" => "kokaRdjER",
"cocardiers" => "kokaRdje",
"cocards" => "kokaR",
"cocas" => "koka",
"cocasse" => "kokas",
"cocassement" => "kOkas°m@",
"cocasserie" => "kokas°Ri",
"cocasses" => "kokas",
"coccinelle" => "koksinEl",
"coccinelles" => "koksinEl",
"coccyx" => "kOksis",
"cocha" => "koSa",
"cochait" => "koSE",
"cochant" => "koS@",
"cochât" => "koSa",
"coche" => "kOS",
"coché" => "koSe",
"cochée" => "koSe",
"cochées" => "koSe",
"cochelet" => "koS°lE",
"cochenille" => "kOS°nij",
"cochenilles" => "kOSnil",
"cocher" => "koSe",
"cocheras" => "kOS°Ra",
"cochère" => "koSER",
"cochères" => "koSER",
"cochers" => "koSe",
"coches" => "kOS",
"cochés" => "koSe",
"cochez" => "koSe",
"cochléaire" => "kOkleER",
"cochléaires" => "kokleER",
"cochlée" => "kokle",
"cochon" => "koS§",
"cochonceté" => "koS§s°te",
"cochoncetés" => "koS§s°te",
"cochonnaille" => "koSonaj",
"cochonnailles" => "koSonaj",
"cochonne" => "koSOn",
"cochonné" => "koSone",
"cochonnée" => "kOSOne",
"cochonnées" => "koSone",
"cochonner" => "koSone",
"cochonnerie" => "koSOn°Ri",
"cochonneries" => "koSOn°Ri",
"cochonnes" => "koSOn",
"cochonnet" => "koSonE",
"cochonnets" => "koSonE",
"cochonnez" => "koSone",
"cochons" => "koS§",
"cochylis" => "kokilis",
"cocker" => "kokER",
"cockney" => "koknE",
"cockneys" => "koknE",
"cockpit" => "kOkpit",
"cocktail" => "kOktEl",
"cocktails" => "kOktEl",
"coco" => "koko",
"cocolait" => "kokolE",
"cocole" => "kokOl",
"cocon" => "kok§",
"cocons" => "kok§",
"cocoon" => "kokun",
"cocorico" => "kokoRiko",
"cocoricos" => "kokoRiko",
"cocos" => "koko",
"cocotent" => "kokOt",
"cocoter" => "kokote",
"cocoteraies" => "kokOt°RE",
"cocoterait" => "kokOt°RE",
"cocotier" => "kokotje",
"cocotiers" => "kokotje",
"cocotte" => "kokOt",
"cocotte-minute" => "kokOtminyt",
"cocottes" => "kokOt",
"coction" => "koksj§",
"cocu" => "koky",
"cocuage" => "kok8aZ",
"cocuages" => "kok8aZ",
"cocue" => "koky",
"cocues" => "koky",
"cocufiant" => "kokyfj@",
"cocufie" => "kokyfi",
"cocufié" => "kokyfje",
"cocufier" => "kokyfje",
"cocufiera" => "kokyfiRa",
"cocus" => "koky",
"coda" => "koda",
"codage" => "kodaZ",
"codages" => "kodaZ",
"codait" => "kodE",
"codante" => "kod@t",
"code" => "kOd",
"codé" => "kode",
"code-barre" => "kOdbaR",
"code-barres" => "kOdbaR",
"code-clé" => "kOdkle",
"codée" => "kode",
"codées" => "kode",
"codéine" => "kodein",
"coder" => "kode",
"codes" => "kOd",
"codés" => "kode",
"codes-clés" => "kOdkle",
"codétenu" => "kodet°ny",
"codétenus" => "kodet°ny",
"codeur" => "kod9R",
"codex" => "kodEks",
"codicille" => "kodisil",
"codicilles" => "kodisil",
"codifia" => "kodifja",
"codifiait" => "kodifjE",
"codifiant" => "kodifj@",
"codification" => "kodifikasj§",
"codifié" => "kodifje",
"codifiée" => "kodifje",
"codifiées" => "kodifje",
"codifier" => "kodifje",
"codifièrent" => "kodifjER",
"codon" => "kod§",
"coefficient" => "koefisj@",
"coefficients" => "koefisj@",
"coelacanthe" => "selak@t",
"coeliaque" => "seljak",
"coentreprise" => "ko@tR°pRiz",
"coenzyme" => "ko@zim",
"coéquipier" => "koekipje",
"coéquipière" => "koekipjER",
"coéquipières" => "koekipjER",
"coéquipiers" => "koekipje",
"coercitif" => "koERsitif",
"coercition" => "koERsisj§",
"coercitive" => "koERsitiv",
"coeur" => "k9R",
"coeur-poumons" => "k9Rpum§",
"coeurs" => "k9R",
"coexistaient" => "koegzistE",
"coexistait" => "koegzistE",
"coexistant" => "koegzist@",
"coexistants" => "koegzist@",
"coexiste" => "koegzist",
"coexisté" => "koegziste",
"coexistence" => "koEgzist@s",
"coexistent" => "koegzist",
"coexister" => "koEgziste",
"coexisteront" => "koegzist°R§",
"coexistez" => "koEgziste",
"coexistons" => "koEgzist§",
"coffee shop" => "kOfiSOp",
"coffin" => "kof5",
"coffio" => "kOfjo",
"coffios" => "kOfjo",
"coffiot" => "kOfjo",
"coffiots" => "kOfjo",
"coffrage" => "kofRaZ",
"coffrages" => "kofRaZ",
"coffraient" => "kofRE",
"coffrait" => "kofRE",
"coffre" => "kOfR",
"coffré" => "kofRe",
"coffre-fort" => "kOfR°fOR",
"coffrée" => "kofRe",
"coffrées" => "kofRe",
"coffrent" => "kOfR",
"coffrer" => "kofRe",
"coffrera" => "kOfR°Ra",
"coffrerai" => "kOfR°RE",
"coffrerais" => "kOfR°RE",
"coffrerons" => "kOfR°R§",
"coffreront" => "kOfR°R§",
"coffres" => "kOfR",
"coffrés" => "kofRe",
"coffres-forts" => "kOfR°fOR",
"coffret" => "kofRE",
"coffrets" => "kofRE",
"coffrez" => "kofRe",
"coffrons" => "kofR§",
"cofinancement" => "kofin@s°m@",
"cofondateur" => "kof§dat9R",
"cofondateurs" => "kof§dat9R",
"cofondatrice" => "kof§datRis",
"cofondé" => "kof§de",
"cogérant" => "koZeR@",
"cogitais" => "koZitE",
"cogitait" => "koZitE",
"cogitant" => "koZit@",
"cogitation" => "koZitasj§",
"cogitations" => "koZitasj§",
"cogite" => "koZit",
"cogité" => "koZite",
"cogitent" => "koZit",
"cogiter" => "koZite",
"cogito" => "koZito",
"cogna" => "koNa",
"cognac" => "koNak",
"cognacs" => "koNak",
"cognai" => "koNE",
"cognaient" => "koNE",
"cognais" => "koNE",
"cognait" => "koNE",
"cognant" => "koN@",
"cognassier" => "koNasje",
"cognassiers" => "koNasje",
"cogne" => "kON",
"cogné" => "koNe",
"cognée" => "koNe",
"cognées" => "koNe",
"cognement" => "kON°m@",
"cognements" => "kON°m@",
"cognent" => "kON",
"cogner" => "koNe",
"cognera" => "kON°Ra",
"cognerai" => "kON°RE",
"cogneraient" => "kON°RE",
"cognerais" => "kON°RE",
"cognerait" => "kON°RE",
"cognèrent" => "koNER",
"cognerez" => "kON°Re",
"cogneront" => "kON°R§",
"cognes" => "kON",
"cognés" => "koNe",
"cogneur" => "koN9R",
"cogneurs" => "koN9R",
"cogneuse" => "koN2z",
"cognez" => "koNe",
"cognitif" => "kognitif",
"cognitifs" => "kognitif",
"cognition" => "kOgnisj§",
"cognitive" => "kognitiv",
"cognitives" => "kognitiv",
"cognons" => "koN§",
"cohabita" => "koabita",
"cohabitaient" => "koabitE",
"cohabitait" => "koabitE",
"cohabitant" => "kOabit@",
"cohabitation" => "koabitasj§",
"cohabitations" => "koabitasj§",
"cohabite" => "koabit",
"cohabité" => "koabite",
"cohabitent" => "koabit",
"cohabiter" => "koabite",
"cohabiteraient" => "koabit°RE",
"cohabitiez" => "koabitje",
"cohérence" => "koeR@s",
"cohérences" => "koeR@s",
"cohérent" => "koeR@",
"cohérente" => "koeR@t",
"cohérentes" => "koeR@t",
"cohérents" => "koeR@",
"cohéritier" => "koeRitje",
"cohéritiers" => "koeRitje",
"cohésion" => "koezj§",
"cohésive" => "kOeziv",
"cohorte" => "koORt",
"cohortes" => "koORt",
"cohue" => "koy",
"cohues" => "koy",
"coi" => "kwa",
"coiffa" => "kwafa",
"coiffai" => "kwafE",
"coiffaient" => "kwafE",
"coiffais" => "kwafE",
"coiffait" => "kwafE",
"coiffant" => "kwaf@",
"coiffante" => "kwaf@t",
"coiffât" => "kwafa",
"coiffe" => "kwaf",
"coiffé" => "kwafe",
"coiffée" => "kwafe",
"coiffées" => "kwafe",
"coiffent" => "kwaf",
"coiffer" => "kwafe",
"coiffera" => "kwaf°Ra",
"coifferais" => "kwaf°RE",
"coifferait" => "kwaf°RE",
"coifferas" => "kwaf°Ra",
"coiffèrent" => "kwafER",
"coifferont" => "kwaf°R§",
"coiffes" => "kwaf",
"coiffés" => "kwafe",
"coiffeur" => "kwaf9R",
"coiffeurs" => "kwaf9R",
"coiffeuse" => "kwaf2z",
"coiffeuses" => "kwaf2z",
"coiffez" => "kwafe",
"coiffiez" => "kwafje",
"coiffure" => "kwafyR",
"coiffures" => "kwafyR",
"coin" => "kw5",
"coin-coin" => "kw5kw5",
"coin-repas" => "kw5R°pa",
"coinça" => "kw5sa",
"coinçage" => "kw5saZ",
"coinçages" => "kw5saZ",
"coinçaient" => "kw5sE",
"coinçais" => "kw5sE",
"coinçait" => "kw5sE",
"coinçant" => "kw5s@",
"coince" => "kw5s",
"coincé" => "kw5se",
"coincée" => "kw5se",
"coincées" => "kw5se",
"coincent" => "kw5s",
"coincer" => "kw5se",
"coincera" => "kw5s°Ra",
"coincerai" => "kw5s°RE",
"coincerais" => "kw5s°RE",
"coincerait" => "kw5s°RE",
"coincèrent" => "kw5sER",
"coinceriez" => "kw5s°Rje",
"coincerons" => "kw5s°R§",
"coinceront" => "kw5s°R§",
"coinces" => "kw5s",
"coincés" => "kw5se",
"coinceur" => "kw5s9R",
"coincez" => "kw5se",
"coincher" => "kw5Se",
"coïncida" => "ko5sida",
"coïncidaient" => "ko5sidE",
"coïncidais" => "ko5sidE",
"coïncidait" => "ko5sidE",
"coïncidant" => "ko5sid@",
"coïncidassent" => "ko5sidas",
"coïncidât" => "ko5sida",
"coïncide" => "ko5sid",
"coïncidé" => "ko5side",
"coïncidence" => "ko5sid@s",
"coïncidences" => "ko5sid@s",
"coïncident" => "kO5sid",
"coïncider" => "ko5side",
"coïnciderait" => "ko5sid°RE",
"coïncidèrent" => "ko5sidER",
"coïncidions" => "ko5sidj§",
"coinciez" => "kw5sje",
"coinçons" => "kw5s§",
"coing" => "kw5",
"coings" => "kw5",
"coins" => "kw5",
"coinstot" => "kw5sto",
"coinstots" => "kw5sto",
"coir" => "kwaR",
"cois" => "kwa",
"coït" => "koit",
"coite" => "kwat",
"coïté" => "koite",
"coites" => "kwat",
"coïts" => "koit",
"coke" => "kok",
"cokes" => "kok",
"col" => "kOl",
"col-de-cygne" => "kOld°siN",
"col-vert" => "kOlvER",
"cola" => "kola",
"colas" => "kola",
"colback" => "kOlbak",
"colbacks" => "kOlbak",
"colchicine" => "kOlSisin",
"colchique" => "kOlSik",
"colchiques" => "kOlSik",
"colcotar" => "kOlkotaR",
"cold" => "kold",
"cold-cream" => "koldkRim",
"colectomie" => "kOlEktomi",
"colée" => "kole",
"coléoptère" => "koleOptER",
"coléoptères" => "koleOptER",
"colère" => "kolER",
"colérer" => "kOleRe",
"colères" => "kolER",
"coléreuse" => "koleR2z",
"coléreusement" => "kOleR2z°m@",
"coléreux" => "koleR2",
"colérique" => "koleRik",
"colériques" => "koleRik",
"colibacilles" => "kolibasil",
"colibri" => "kolibRi",
"colibris" => "kolibRi",
"colifichet" => "kolifiSE",
"colifichets" => "kolifiSE",
"colimaçon" => "kolimas§",
"colimaçons" => "kolimas§",
"colin" => "kol5",
"colin-maillard" => "kol5majaR",
"colique" => "kolik",
"coliques" => "kolik",
"colis" => "koli",
"colis-cadeau" => "kolikado",
"colis-repas" => "koliR°pa",
"colistier" => "kolistje",
"colite" => "kolit",
"colites" => "kolit",
"colla" => "kola",
"collabo" => "kolabo",
"collabora" => "kolaboRa",
"collaborai" => "kolaboRE",
"collaboraient" => "kolaboRE",
"collaborais" => "kolaboRE",
"collaborait" => "kolaboRE",
"collaborant" => "kolaboR@",
"collaborateur" => "kolaboRat9R",
"collaborateurs" => "kolaboRat9R",
"collaboration" => "kolaboRasj§",
"collaborationniste" => "kolaboRasjonist",
"collaborationnistes" => "kolaboRasjonist",
"collaborations" => "kolaboRasj§",
"collaboratrice" => "kolaboRatRis",
"collaboratrices" => "kolaboRatRis",
"collabore" => "kolabOR",
"collaboré" => "kolaboRe",
"collaborent" => "kolabOR",
"collaborer" => "kolaboRe",
"collaborera" => "kolabOR°Ra",
"collaborerai" => "kolabOR°RE",
"collaboreraient" => "kolabOR°RE",
"collaborerez" => "kolabOR°Re",
"collaborerons" => "kolabOR°R§",
"collabores" => "kolabOR",
"collaborez" => "kolaboRe",
"collaborions" => "kolaboRj§",
"collaborons" => "kolaboR§",
"collabos" => "kolabo",
"collage" => "kolaZ",
"collagène" => "kolaZEn",
"collages" => "kolaZ",
"collai" => "kolE",
"collaient" => "kolE",
"collais" => "kolE",
"collait" => "kolE",
"collant" => "kol@",
"collante" => "kol@t",
"collantes" => "kol@t",
"collants" => "kol@",
"collapse" => "kolaps",
"collapserait" => "kolaps°RE",
"collapsus" => "kolapsys",
"collas" => "kola",
"collatéral" => "kolateRal",
"collatérale" => "kolateRal",
"collatérales" => "kolateRal",
"collatéraux" => "kolateRo",
"collation" => "kolasj§",
"collationne" => "kolasjOn",
"collationnement" => "kOlasjOn°m@",
"collationner" => "kolasjone",
"collationnés" => "kolasjone",
"collations" => "kolasj§",
"colle" => "kOl",
"collé" => "kole",
"collectait" => "kolEktE",
"collectant" => "kolEkt@",
"collecte" => "kolEkt",
"collecté" => "kolEkte",
"collectée" => "kolEkte",
"collectées" => "kolEkte",
"collecter" => "kolEkte",
"collectes" => "kolEkt",
"collectés" => "kolEkte",
"collecteur" => "kolEkt9R",
"collecteurs" => "kolEkt9R",
"collectez" => "kolEkte",
"collectif" => "kolEktif",
"collectifs" => "kolEktif",
"collection" => "kolEksj§",
"collectionna" => "kolEksjona",
"collectionnaient" => "kolEksjonE",
"collectionnais" => "kolEksjonE",
"collectionnait" => "kolEksjonE",
"collectionnant" => "kolEksjon@",
"collectionne" => "kolEksjOn",
"collectionné" => "kolEksjone",
"collectionnées" => "kolEksjone",
"collectionnent" => "kolEksjOn",
"collectionner" => "kolEksjone",
"collectionnes" => "kolEksjOn",
"collectionnés" => "kolEksjone",
"collectionneur" => "kolEksjon9R",
"collectionneurs" => "kolEksjon9R",
"collectionneuse" => "kolEksjon2z",
"collectionnez" => "kolEksjone",
"collectionnions" => "kolEksjonj§",
"collectionnons" => "kolEksjon§",
"collections" => "kOlEksj§",
"collective" => "kolEktiv",
"collectivement" => "kolEktiv°m@",
"collectives" => "kolEktiv",
"collectivisation" => "kolEktivizasj§",
"collectivisé" => "kolEktivize",
"collectivisée" => "kolEktivize",
"collectiviser" => "kOlEktivize",
"collectivisés" => "kolEktivize",
"collectivisme" => "kolEktivizm",
"collectiviste" => "kolEktivist",
"collectivité" => "kolEktivite",
"collectivités" => "kolEktivite",
"collectons" => "kolEkt§",
"collector" => "kOlEktOR",
"collectrice" => "kOlEktRis",
"collée" => "kole",
"collées" => "kole",
"collège" => "kolEZ",
"collèges" => "kolEZ",
"collégial" => "kOleZjal",
"collégiale" => "koleZjal",
"collégiales" => "koleZjal",
"collégialité" => "koleZjalite",
"collégiaux" => "kOleZjo",
"collégien" => "koleZj5",
"collégienne" => "koleZjEn",
"collégiennes" => "koleZjEn",
"collégiens" => "koleZj5",
"collègue" => "kolEg",
"collègues" => "kolEg",
"collent" => "kOl",
"coller" => "kole",
"collera" => "kOl°Ra",
"collerai" => "kOl°RE",
"collerais" => "kOl°RE",
"collerait" => "kOl°RE",
"colleras" => "kOl°Ra",
"collèrent" => "kolER",
"collerette" => "kOl°REt",
"collerettes" => "kOl°REt",
"collerez" => "kOl°Re",
"colleront" => "kOl°R§",
"colles" => "kOl",
"collés" => "kole",
"collet" => "kolE",
"colletage" => "kOl°taZ",
"colleté" => "kOl°te",
"colleter" => "kOl°te",
"colletés" => "kOl°te",
"colletin" => "kOl°t5",
"collets" => "kolE",
"collette" => "kolEt",
"colleur" => "kol9R",
"colleurs" => "kol9R",
"colleuse" => "kOl2z",
"colley" => "kolE",
"colleys" => "kolE",
"collez" => "kole",
"collier" => "kolje",
"colliers" => "kolje",
"colliez" => "kolje",
"collignon" => "koliN§",
"collimateur" => "kolimat9R",
"collimation" => "kolimasj§",
"colline" => "kolin",
"collines" => "kolin",
"collions" => "kolj§",
"collision" => "kolizj§",
"collisions" => "kolizj§",
"collodion" => "kolodj§",
"colloïdale" => "koloidal",
"colloïde" => "koloid",
"collons" => "kol§",
"colloquant" => "kolok@",
"colloque" => "kolOk",
"colloqué" => "koloke",
"colloquée" => "koloke",
"colloquer" => "koloke",
"colloques" => "kolOk",
"collure" => "kolyR",
"collusion" => "kolyzj§",
"collusions" => "kolyzj§",
"collutoire" => "kolytwaR",
"collyre" => "koliR",
"collyres" => "koliR",
"colmatage" => "kOlmataZ",
"colmataient" => "kOlmatE",
"colmatais" => "kOlmatE",
"colmatait" => "kOlmatE",
"colmatant" => "kOlmat@",
"colmate" => "kOlmat",
"colmaté" => "kOlmate",
"colmatée" => "kOlmate",
"colmatées" => "kOlmate",
"colmater" => "kOlmate",
"colmatés" => "kOlmate",
"colmatez" => "kOlmate",
"colmatons" => "kOlmat§",
"colo" => "kolo",
"colocataire" => "kolokatER",
"colocataires" => "kolokatER",
"colocation" => "kolokasj§",
"colombages" => "kol§baZ",
"colombe" => "kol§b",
"colombelle" => "kol§bEl",
"colombes" => "kol§b",
"colombien" => "kol§bj5",
"colombienne" => "kol§bjEn",
"colombiens" => "kol§bj5",
"colombier" => "kol§bje",
"colombiers" => "kol§bje",
"colombin" => "kol§b5",
"colombine" => "kol§bin",
"colombines" => "kol§bin",
"colombins" => "kol§b5",
"colombo" => "kol§bo",
"colombophile" => "kol§bofil",
"colombophilie" => "kol§bofili",
"colon" => "kol§",
"côlon" => "kol§",
"colonel" => "kolonEl",
"colonelle" => "kolonEl",
"colonels" => "kolonEl",
"colonial" => "kolonjal",
"coloniale" => "kolonjal",
"coloniales" => "kolonjal",
"colonialisme" => "kolonjalizm",
"colonialismes" => "kolonjalizm",
"colonialiste" => "kolonjalist",
"colonialistes" => "kolonjalist",
"coloniaux" => "kolonjo",
"colonie" => "koloni",
"colonies" => "koloni",
"colonisait" => "kolonizE",
"colonisateur" => "kolonizat9R",
"colonisateurs" => "kolonizat9R",
"colonisation" => "kolonizasj§",
"colonisations" => "kolonizasj§",
"colonisatrice" => "kolonizatRis",
"colonise" => "koloniz",
"colonisé" => "kolonize",
"colonisée" => "kolonize",
"colonisées" => "kolonize",
"colonisent" => "koloniz",
"coloniser" => "kolonize",
"coloniserait" => "koloniz°RE",
"colonisèrent" => "kolonizER",
"colonisés" => "kolonize",
"colonisez" => "kolonize",
"colonisons" => "koloniz§",
"colonnade" => "kolonad",
"colonnades" => "kolonad",
"colonne" => "kolOn",
"colonnes" => "kolOn",
"colonnette" => "kolonEt",
"colonnettes" => "kolonEt",
"colonoscopie" => "kOlOnOskOpi",
"colons" => "kol§",
"colopathie" => "kolopati",
"colophane" => "kolofan",
"colophané" => "kolofane",
"coloquinte" => "kolok5t",
"coloquintes" => "kolok5t",
"colora" => "koloRa",
"colorai" => "koloRE",
"coloraient" => "koloRE",
"colorait" => "koloRE",
"colorant" => "koloR@",
"colorantes" => "koloR@t",
"colorants" => "koloR@",
"coloration" => "koloRasj§",
"colorations" => "koloRasj§",
"colorature" => "koloRatyR",
"colore" => "kolOR",
"coloré" => "koloRe",
"colorectal" => "koloREktal",
"colorée" => "koloRe",
"colorées" => "koloRe",
"colorent" => "kolOR",
"colorer" => "koloRe",
"colorèrent" => "koloRER",
"colorés" => "koloRe",
"colorez" => "koloRe",
"coloriage" => "koloRjaZ",
"coloriages" => "koloRjaZ",
"coloriaient" => "koloRjE",
"coloriait" => "koloRjE",
"colorie" => "koloRi",
"colorié" => "koloRje",
"coloriée" => "koloRje",
"coloriées" => "koloRje",
"colorient" => "koloRi",
"colorier" => "koloRje",
"coloriés" => "koloRje",
"coloriez" => "koloRje",
"coloris" => "koloRi",
"colorisation" => "koloRizasj§",
"colorisé" => "koloRize",
"coloriste" => "koloRist",
"colos" => "kolo",
"coloscopie" => "kolOskopi",
"colossal" => "kolosal",
"colossale" => "kolosal",
"colossales" => "kolosal",
"colossaux" => "koloso",
"colosse" => "kolOs",
"colosses" => "kolOs",
"colostomie" => "kolostomi",
"colostrum" => "kOlOstROm",
"colporta" => "kOlpORta",
"colportage" => "kOlpORtaZ",
"colportaient" => "kOlpORtE",
"colportait" => "kOlpORtE",
"colportant" => "kOlpORt@",
"colporte" => "kOlpORt",
"colporté" => "kOlpORte",
"colportée" => "kOlpORte",
"colportées" => "kOlpORte",
"colportent" => "kOlpORt",
"colporter" => "kOlpORte",
"colportera" => "kOlpORt°Ra",
"colportes" => "kOlpORt",
"colporteur" => "kOlpORt9R",
"colporteurs" => "kOlpORt9R",
"colporteuse" => "kOlpORt2z",
"colportons" => "kOlpORt§",
"colposcopie" => "kOlposkOpi",
"cols" => "kOl",
"cols-de-cygne" => "kOld°siN",
"cols-verts" => "kOlvER",
"colt" => "kOlt",
"coltin" => "kOlt5",
"coltina" => "kOltina",
"coltinage" => "kOltinaZ",
"coltinages" => "kOltinaZ",
"coltinais" => "kOltinE",
"coltinait" => "kOltinE",
"coltinant" => "kOltin@",
"coltine" => "kOltin",
"coltiné" => "kOltine",
"coltinée" => "kOltine",
"coltinent" => "kOltin",
"coltiner" => "kOltine",
"coltines" => "kOltin",
"coltinés" => "kOltine",
"coltineur" => "kOltin9R",
"coltinez" => "kOltine",
"colts" => "kOlt",
"columbarium" => "kol§baRjOm",
"colvert" => "kOlvER",
"colverts" => "kOlvER",
"colza" => "kOlza",
"colzas" => "kOlza",
"com" => "kOm",
"coma" => "koma",
"comac" => "komak",
"comacs" => "komak",
"comanche" => "kOm@S",
"comandant" => "kom@d@",
"comas" => "koma",
"comateuse" => "komat2z",
"comateux" => "komat2",
"combat" => "k§ba",
"combatif" => "k§batif",
"combatifs" => "k§batif",
"combative" => "k§bativ",
"combativité" => "k§bativite",
"combats" => "k§ba",
"combattaient" => "k§batE",
"combattais" => "k§batE",
"combattait" => "k§batE",
"combattant" => "k§bat@",
"combattante" => "k§bat@t",
"combattantes" => "k§bat@t",
"combattants" => "k§bat@",
"combatte" => "k§bat",
"combattent" => "k§bat",
"combattes" => "k§bat",
"combattez" => "k§bate",
"combattiez" => "k§batje",
"combattions" => "k§batj§",
"combattirent" => "k§batiR",
"combattit" => "k§bati",
"combattît" => "k§bati",
"combattons" => "k§bat§",
"combattra" => "k§batRa",
"combattrai" => "k§batRE",
"combattraient" => "k§batRE",
"combattrais" => "k§batRE",
"combattrait" => "k§batRE",
"combattras" => "k§batRa",
"combattre" => "k§batR",
"combattrez" => "k§batRe",
"combattriez" => "k§batRie",
"combattrons" => "k§batR§",
"combattront" => "k§batR§",
"combattu" => "k§baty",
"combattue" => "k§baty",
"combattues" => "k§baty",
"combattus" => "k§baty",
"combe" => "k§b",
"combes" => "k§b",
"combette" => "k§bEt",
"combi" => "k§bi",
"combien" => "k§bj5",
"combientième" => "k§bj@tjEm",
"combina" => "k§bina",
"combinaient" => "k§binE",
"combinaison" => "k§binEz§",
"combinaisons" => "k§binEz§",
"combinait" => "k§binE",
"combinant" => "k§bin@",
"combinard" => "k§binaR",
"combinards" => "k§binaR",
"combinat" => "k§bina",
"combinatoire" => "k§binatwaR",
"combinatoires" => "k§binatwaR",
"combine" => "k§bin",
"combiné" => "k§bine",
"combinée" => "k§bine",
"combinées" => "k§bine",
"combinent" => "k§bin",
"combiner" => "k§bine",
"combineraient" => "k§bin°RE",
"combinerait" => "k§bin°RE",
"combinerons" => "k§bin°R§",
"combines" => "k§bin",
"combinés" => "k§bine",
"combinez" => "k§bine",
"combinons" => "k§bin§",
"combis" => "k§bi",
"combisme" => "k§bizm",
"combla" => "k§bla",
"comblaient" => "k§blE",
"comblais" => "k§blE",
"comblait" => "k§blE",
"comblant" => "k§bl@",
"comblants" => "k§bl@",
"comblât" => "k§bla",
"comble" => "k§bl",
"comblé" => "k§ble",
"comblée" => "k§ble",
"comblées" => "k§ble",
"comblent" => "k§bl",
"combler" => "k§ble",
"comblera" => "k§bl°Ra",
"comblerai" => "k§bl°RE",
"combleraient" => "k§bl°RE",
"comblerais" => "k§bl°RE",
"comblerait" => "k§bl°RE",
"comblèrent" => "k§blER",
"comblerez" => "k§bl°Re",
"combleront" => "k§bl°R§",
"combles" => "k§bl",
"comblés" => "k§ble",
"comblez" => "k§ble",
"comblons" => "k§bl§",
"combo" => "k§bo",
"combourgeois" => "k§buRZwa",
"comburant" => "k§byR@",
"combustible" => "k§bystibl",
"combustibles" => "k§bystibl",
"combustion" => "k§bystj§",
"combustions" => "k§bystj§",
"comédie" => "komedi",
"comédien" => "komedj5",
"comédienne" => "komedjEn",
"comédiennes" => "komedjEn",
"comédiens" => "komedj5",
"comédies" => "komedi",
"comédons" => "komed§",
"comestibilité" => "kOmEstibilite",
"comestible" => "komEstibl",
"comestibles" => "komEstibl",
"comète" => "komEt",
"comètes" => "komEt",
"comic book" => "kOmikbuk",
"comic books" => "kOmikbuk",
"comice" => "komis",
"comices" => "komis",
"comics" => "komik",
"comique" => "komik",
"comiquement" => "komik°m@",
"comiques" => "komik",
"comitadji" => "komitadZi",
"comite" => "kOmit",
"comité" => "komite",
"comites" => "komit",
"comités" => "komite",
"comma" => "kOma",
"command" => "komand",
"commanda" => "kom@da",
"commandai" => "kom@dE",
"commandaient" => "kom@dE",
"commandais" => "kom@dE",
"commandait" => "kom@dE",
"commandant" => "kom@d@",
"commandante" => "kom@d@t",
"commandants" => "kom@d@",
"commandât" => "kom@da",
"commande" => "kom@d",
"commandé" => "kom@de",
"commandée" => "kom@de",
"commandées" => "kom@de",
"commandement" => "kom@d°m@",
"commandements" => "kom@d°m@",
"commandent" => "kom@d",
"commander" => "kom@de",
"commandera" => "kom@d°Ra",
"commanderai" => "kom@d°RE",
"commanderait" => "kom@d°RE",
"commanderas" => "kom@d°Ra",
"commandèrent" => "kom@dER",
"commanderez" => "kom@d°Re",
"commanderie" => "kom@d°Ri",
"commanderies" => "kom@d°Ri",
"commanderons" => "kom@d°R§",
"commanderont" => "kom@d°R§",
"commandes" => "kom@d",
"commandés" => "kom@de",
"commandeur" => "kom@d9R",
"commandeurs" => "kom@d9R",
"commandez" => "kom@de",
"commandiez" => "kom@dje",
"commandions" => "kom@dj§",
"commanditaire" => "kom@ditER",
"commanditaires" => "kom@ditER",
"commandite" => "kom@dit",
"commandité" => "kom@dite",
"commanditée" => "kom@dite",
"commanditées" => "kom@dite",
"commanditer" => "kom@dite",
"commandites" => "kom@dit",
"commando" => "kom@do",
"commandons" => "kom@d§",
"commandos" => "kom@do",
"commandos-suicide" => "kom@dos8isid",
"comme" => "kOm",
"commedia dell'arte" => "komedjadElaRte",
"commémorait" => "komemoRE",
"commémorant" => "komemoR@",
"commémoratif" => "komemoRatif",
"commémoratifs" => "komemoRatif",
"commémoration" => "komemoRasj§",
"commémorations" => "komemoRasj§",
"commémorative" => "komemoRativ",
"commémoratives" => "komemoRativ",
"commémore" => "komemOR",
"commémoré" => "komemoRe",
"commémorent" => "komemOR",
"commémorer" => "komemoRe",
"commémorions" => "komemoRj§",
"commémorons" => "komemoR§",
"commença" => "kom@sa",
"commençai" => "kom@sE",
"commençaient" => "kom@sE",
"commençais" => "kom@sE",
"commençait" => "kom@sE",
"commençâmes" => "kom@sam",
"commençant" => "kom@s@",
"commençante" => "kom@s@t",
"commençantes" => "kom@s@t",
"commençants" => "kom@s@",
"commenças" => "kom@sa",
"commençât" => "kom@sa",
"commence" => "kom@s",
"commencé" => "kom@se",
"commencée" => "kom@se",
"commencées" => "kom@se",
"commencement" => "kom@s°m@",
"commencements" => "kom@s°m@",
"commencent" => "kom@s",
"commencer" => "kom@se",
"commencera" => "kom@s°Ra",
"commencerai" => "kom@s°RE",
"commenceraient" => "kom@s°RE",
"commencerais" => "kom@s°RE",
"commencerait" => "kom@s°RE",
"commenceras" => "kom@s°Ra",
"commencèrent" => "kom@sER",
"commencerez" => "kom@s°Re",
"commenceriez" => "kom@s°Rje",
"commencerions" => "kom@s°Rj§",
"commencerons" => "kom@s°R§",
"commenceront" => "kom@s°R§",
"commences" => "kom@s",
"commencés" => "kom@se",
"commencez" => "kom@se",
"commenciez" => "kom@sje",
"commencions" => "kom@sj§",
"commençons" => "kom@s§",
"commensal" => "kom@sal",
"commensalisme" => "kom@salizm",
"commensaux" => "kom@so",
"commensurable" => "kom@syRabl",
"commensurables" => "kom@syRabl",
"comment" => "kom@",
"commenta" => "kom@ta",
"commentai" => "kom@tE",
"commentaient" => "kom@tE",
"commentaire" => "kom@tER",
"commentaires" => "kom@tER",
"commentais" => "kom@tE",
"commentait" => "kom@tE",
"commentant" => "kom@t@",
"commentateur" => "kom@tat9R",
"commentateurs" => "kom@tat9R",
"commentatrice" => "kOm@tatRis",
"commente" => "kom@t",
"commenté" => "kom@te",
"commentée" => "kom@te",
"commentées" => "kom@te",
"commentent" => "kom@t",
"commenter" => "kom@te",
"commentera" => "kom@t°Ra",
"commenterai" => "kom@t°RE",
"commenterait" => "kom@t°RE",
"commentés" => "kom@te",
"commentez" => "kom@te",
"commentions" => "kom@tj§",
"commérage" => "komeRaZ",
"commérages" => "komeRaZ",
"commérait" => "komeRE",
"commerçait" => "komERsE",
"commerçant" => "komERs@",
"commerçante" => "komERs@t",
"commerçantes" => "komERs@t",
"commerçants" => "komERs@",
"commerce" => "komERs",
"commercé" => "komERse",
"commercent" => "komERs",
"commercer" => "komERse",
"commerces" => "komERs",
"commercial" => "komERsjal",
"commerciale" => "komERsjal",
"commercialement" => "komERsjal°m@",
"commerciales" => "komERsjal",
"commercialisable" => "kOmERsjalizabl",
"commercialisation" => "komERsjalizasj§",
"commercialisé" => "komERsjalize",
"commercialiser" => "komERsjalize",
"commercialisera" => "komERsjaliz°Ra",
"commerciaux" => "komERsjo",
"commerciez" => "komERsje",
"commerçons" => "komERs§",
"commère" => "komER",
"commérer" => "komeRe",
"commères" => "komER",
"commet" => "komE",
"commets" => "komE",
"commettaient" => "komEtE",
"commettais" => "komEtE",
"commettait" => "komEtE",
"commettant" => "komEt@",
"commettants" => "komEt@",
"commette" => "komEt",
"commettent" => "komEt",
"commettes" => "komEt",
"commettez" => "komEte",
"commettiez" => "komEtje",
"commettions" => "komEtj§",
"commettons" => "komEt§",
"commettra" => "komEtRa",
"commettrai" => "komEtRE",
"commettraient" => "komEtRE",
"commettrais" => "komEtRE",
"commettrait" => "komEtRE",
"commettras" => "komEtRa",
"commettre" => "komEtR",
"commettrez" => "komEtRe",
"comminatoire" => "kominatwaR",
"comminatoires" => "kominatwaR",
"comminutive" => "kOminytiv",
"commirent" => "komiR",
"commis" => "komi",
"commis-voyageur" => "komivwajaZ9R",
"commis-voyageurs" => "komivwajaZ9R",
"commise" => "komiz",
"commisération" => "komizeRasj§",
"commises" => "komiz",
"commissaire" => "komisER",
"commissaire-adjoint" => "kOmisERadZw5",
"commissaire-priseur" => "komisERpRiz9R",
"commissaires" => "komisER",
"commissaires-priseurs" => "komisERpRiz9R",
"commissariat" => "komisaRja",
"commissariats" => "komisaRja",
"commission" => "komisj§",
"commissionnaire" => "komisjonER",
"commissionnaires" => "komisjonER",
"commissionné" => "komisjone",
"commissions" => "komisj§",
"commissurale" => "komisyRal",
"commissure" => "komisyR",
"commissures" => "komisyR",
"commit" => "komi",
"commît" => "komi",
"commode" => "komOd",
"commode-toilette" => "kOmOdtwalEt",
"commodément" => "komodem@",
"commodes" => "komOd",
"commodité" => "komodite",
"commodités" => "komodite",
"commodore" => "komodOR",
"commodores" => "komodOR",
"commotion" => "komosj§",
"commotionné" => "komosjone",
"commotionnée" => "komosjone",
"commotionnerait" => "komosjOn°RE",
"commotionnés" => "komosjone",
"commotions" => "komosj§",
"commuais" => "kom8E",
"commuant" => "kom8@",
"commué" => "kOm8e",
"commuée" => "kom8e",
"commuent" => "komy",
"commuer" => "kom8e",
"commun" => "kom1",
"communal" => "komynal",
"communale" => "komynal",
"communales" => "komynal",
"communard" => "komynaR",
"communards" => "komynaR",
"communautaire" => "komynotER",
"communautaires" => "komynotER",
"communauté" => "komynote",
"communautés" => "komynote",
"communaux" => "komyno",
"commune" => "komyn",
"communément" => "komynem@",
"communes" => "komyn",
"communia" => "komynja",
"communiaient" => "komynjE",
"communiais" => "komynjE",
"communiait" => "komynjE",
"communiant" => "komynj@",
"communiante" => "komynj@t",
"communiantes" => "komynj@t",
"communiants" => "komynj@",
"communiasse" => "komynjas",
"communicabilité" => "komynikabilite",
"communicable" => "komynikabl",
"communicables" => "komynikabl",
"communicant" => "kOmynik@",
"communicante" => "komynik@t",
"communicantes" => "komynik@t",
"communicants" => "komynik@",
"communicateur" => "komynikat9R",
"communicateurs" => "komynikat9R",
"communicatif" => "komynikatif",
"communicatifs" => "komynikatif",
"communication" => "komynikasj§",
"communications" => "komynikasj§",
"communicative" => "komynikativ",
"communie" => "komyni",
"communié" => "komynje",
"communient" => "komyni",
"communier" => "komynje",
"communièrent" => "komynjER",
"communierons" => "komyniR§",
"communieront" => "komyniR§",
"communiez" => "komynje",
"communion" => "komynj§",
"communions" => "komynj§",
"communiqua" => "komynika",
"communiquai" => "komynikE",
"communiquaient" => "komynikE",
"communiquais" => "komynikE",
"communiquait" => "komynikE",
"communiquant" => "komynik@",
"communiquassent" => "komynikas",
"communiquât" => "komynika",
"communique" => "komynik",
"communiqué" => "komynike",
"communiquée" => "komynike",
"communiquées" => "komynike",
"communiquent" => "komynik",
"communiquer" => "komynike",
"communiquera" => "komynik°Ra",
"communiquerai" => "komynik°RE",
"communiqueraient" => "komynik°RE",
"communiquerait" => "komynik°RE",
"communiquèrent" => "komynikER",
"communiquerez" => "komynik°Re",
"communiquerons" => "komynik°R§",
"communiqueront" => "komynik°R§",
"communiques" => "komynik",
"communiqués" => "komynike",
"communiquez" => "komynike",
"communiquiez" => "komynikje",
"communiquions" => "komynikj§",
"communiquons" => "komynik§",
"communisant" => "komyniz@",
"communisants" => "komyniz@",
"communisée" => "komynize",
"communisme" => "komynizm",
"communiste" => "komynist",
"communistes" => "komynist",
"communs" => "kom1",
"commutateur" => "komytat9R",
"commutateurs" => "komytat9R",
"commutation" => "komytasj§",
"commute" => "komyt",
"commuter" => "komyte",
"comnène" => "kOmnEn",
"compacité" => "k§pasite",
"compact" => "k§pakt",
"compactage" => "k§paktaZ",
"compacte" => "k§pakt",
"compacté" => "k§pakte",
"compactes" => "k§pakt",
"compacteur" => "k§pakt9R",
"compacteurs" => "k§pakt9R",
"compacts" => "k§pakt",
"compadre" => "k§padR",
"compadres" => "k§padR",
"compagne" => "k§paN",
"compagnes" => "k§paN",
"compagnie" => "k§paNi",
"compagnies" => "k§paNi",
"compagnon" => "k§paN§",
"compagnonnage" => "k§paNonaZ",
"compagnonnages" => "k§paNonaZ",
"compagnonnes" => "k§paNOn",
"compagnons" => "k§paN§",
"compara" => "k§paRa",
"comparabilité" => "k§paRabilite",
"comparable" => "k§paRabl",
"comparables" => "k§paRabl",
"comparai" => "k§paRE",
"comparaient" => "k§paRE",
"comparais" => "k§paRE",
"comparaison" => "k§paREz§",
"comparaisons" => "k§paREz§",
"comparaissaient" => "k§paREsE",
"comparaissait" => "k§paREsE",
"comparaissant" => "k§paREs@",
"comparaissent" => "k§paREs",
"comparaisses" => "k§paREs",
"comparaissons" => "k§paREs§",
"comparait" => "k§paRE",
"comparaît" => "k§paRE",
"comparaîtra" => "k§paREtRa",
"comparaîtrait" => "k§paREtRE",
"comparaître" => "k§paREtR",
"comparaîtrez" => "k§paREtRe",
"comparaîtrons" => "k§paREtR§",
"comparant" => "k§paR@",
"comparateur" => "k§paRat9R",
"comparatif" => "k§paRatif",
"comparatifs" => "k§paRatif",
"comparative" => "k§paRativ",
"comparativement" => "k§paRativ°m@",
"comparatives" => "k§paRativ",
"compare" => "k§paR",
"comparé" => "k§paRe",
"comparée" => "k§paRe",
"comparées" => "k§paRe",
"comparent" => "k§paR",
"comparer" => "k§paRe",
"comparera" => "k§paR°Ra",
"comparerai" => "k§paR°RE",
"comparerais" => "k§paR°RE",
"comparerons" => "k§paR°R§",
"compareront" => "k§paR°R§",
"compares" => "k§paR",
"comparés" => "k§paRe",
"comparez" => "k§paRe",
"compariez" => "k§paRje",
"comparions" => "k§paRj§",
"comparoir" => "k§paRwaR",
"comparons" => "k§paR§",
"comparse" => "k§paRs",
"comparses" => "k§paRs",
"compartiment" => "k§paRtim@",
"compartimentage" => "k§paRtim@taZ",
"compartimentaient" => "k§paRtim@tE",
"compartimentant" => "k§paRtim@t@",
"compartimente" => "k§paRtim@t",
"compartimenté" => "k§paRtim@te",
"compartimentée" => "k§paRtim@te",
"compartimenter" => "k§paRtim@te",
"compartiments" => "k§paRtim@",
"comparu" => "k§paRy",
"comparut" => "k§paRy",
"comparution" => "k§paRysj§",
"compas" => "k§pa",
"compassé" => "k§pase",
"compassée" => "k§pase",
"compassées" => "k§pase",
"compassés" => "k§pase",
"compassion" => "k§pasj§",
"compati" => "k§pati",
"compatibilité" => "k§patibilite",
"compatible" => "k§patibl",
"compatibles" => "k§patibl",
"compatie" => "k§pati",
"compatir" => "k§patiR",
"compatira" => "k§patiRa",
"compatirait" => "k§patiRE",
"compatirent" => "k§patiR",
"compatis" => "k§pati",
"compatissaient" => "k§patisE",
"compatissais" => "k§patisE",
"compatissait" => "k§patisE",
"compatissant" => "k§patis@",
"compatissante" => "k§patis@t",
"compatissantes" => "k§patis@t",
"compatissants" => "k§patis@",
"compatisse" => "k§patis",
"compatissent" => "k§patis",
"compatissez" => "k§patise",
"compatissons" => "k§patis§",
"compatit" => "k§pati",
"compatriote" => "k§patRijOt",
"compatriotes" => "k§patRijOt",
"compendium" => "k§p5djOm",
"compendiums" => "k§p5djOm",
"compensa" => "k§p@sa",
"compensaient" => "k§p@sE",
"compensais" => "k§p@sE",
"compensait" => "k§p@sE",
"compensant" => "k§p@s@",
"compensât" => "k§p@sa",
"compensateur" => "k§p@sat9R",
"compensateurs" => "k§p@sat9R",
"compensation" => "k§p@sasj§",
"compensations" => "k§p@sasj§",
"compensatoire" => "k§p@satwaR",
"compense" => "k§p@s",
"compensé" => "k§p@se",
"compensée" => "k§p@se",
"compensées" => "k§p@se",
"compensent" => "k§p@s",
"compenser" => "k§p@se",
"compensera" => "k§p@s°Ra",
"compenserais" => "k§p@s°RE",
"compenserait" => "k§p@s°RE",
"compensèrent" => "k§p@sER",
"compensés" => "k§p@se",
"compensez" => "k§p@se",
"compère" => "k§pER",
"compères" => "k§pER",
"compétant" => "k§pet@",
"compète" => "k§pEt",
"compétence" => "k§pet@s",
"compétences" => "k§pet@s",
"compétent" => "k§pet@",
"compétente" => "k§pet@t",
"compétentes" => "k§pet@t",
"compétents" => "k§pet@",
"compètes" => "k§pEt",
"compétiteur" => "k§petit9R",
"compétiteurs" => "k§petit9R",
"compétitif" => "k§petitif",
"compétitifs" => "k§petitif",
"compétition" => "k§petisj§",
"compétitions" => "k§petisj§",
"compétitive" => "k§petitiv",
"compétitivité" => "k§petitivite",
"compétitrice" => "k§petitRis",
"compil" => "k§pil",
"compilant" => "k§pil@",
"compilateur" => "k§pilat9R",
"compilation" => "k§pilasj§",
"compilations" => "k§pilasj§",
"compile" => "k§pil",
"compilé" => "k§pile",
"compilées" => "k§pile",
"compiler" => "k§pile",
"compilons" => "k§pil§",
"compissait" => "k§pisE",
"compisse" => "k§pis",
"compissé" => "k§pise",
"compisser" => "k§pise",
"complainte" => "k§pl5t",
"complaintes" => "k§pl5t",
"complairait" => "k§plERE",
"complaire" => "k§plER",
"complais" => "k§plE",
"complaisaient" => "k§plEzE",
"complaisais" => "k§plEzE",
"complaisait" => "k§plEzE",
"complaisamment" => "k§plEzam@",
"complaisance" => "k§plEz@s",
"complaisances" => "k§plEz@s",
"complaisant" => "k§plEz@",
"complaisante" => "k§plEz@t",
"complaisantes" => "k§plEz@t",
"complaisants" => "k§plEz@",
"complaise" => "k§plEz",
"complaisent" => "k§plEz",
"complaisez" => "k§plEze",
"complaisiez" => "k§plEzje",
"complaît" => "k§plE",
"complément" => "k§plem@",
"complémentaire" => "k§plem@tER",
"complémentairement" => "k§plem@tER°m@",
"complémentaires" => "k§plem@tER",
"complémentarité" => "k§plem@taRite",
"compléments" => "k§plem@",
"complet" => "k§plE",
"complet-veston" => "k§plEvEst§",
"compléta" => "k§pleta",
"complétai" => "k§pletE",
"complétaient" => "k§pletE",
"complétais" => "k§pletE",
"complétait" => "k§pletE",
"complétant" => "k§plet@",
"complète" => "k§plEt",
"complété" => "k§plete",
"complétée" => "k§plete",
"complétées" => "k§plete",
"complètement" => "k§plEt°m@",
"complètements" => "k§plEt°m@",
"complètent" => "k§plEt",
"compléter" => "k§plete",
"complétera" => "k§plet°Ra",
"compléterai" => "k§plEt°RE",
"compléteraient" => "k§plet°RE",
"compléterait" => "k§plet°RE",
"compléteras" => "k§plet°Ra",
"complétèrent" => "k§pletER",
"compléterez" => "k§plet°Re",
"compléteront" => "k§plet°R§",
"complètes" => "k§plEt",
"complétés" => "k§plete",
"complétez" => "k§plete",
"complétiez" => "k§pletje",
"complétons" => "k§plet§",
"complets" => "k§plE",
"complétude" => "k§pletyd",
"complexait" => "k§plEksE",
"complexe" => "k§plEks",
"complexé" => "k§plEkse",
"complexée" => "k§plEkse",
"complexer" => "k§plEkse",
"complexes" => "k§plEks",
"complexés" => "k§plEkse",
"complexion" => "k§plEksj§",
"complexité" => "k§plEksite",
"complexités" => "k§plEksite",
"complication" => "k§plikasj§",
"complications" => "k§plikasj§",
"complice" => "k§plis",
"complices" => "k§plis",
"complicité" => "k§plisite",
"complicités" => "k§plisite",
"complies" => "k§pli",
"compliment" => "k§plim@",
"complimenta" => "k§plim@ta",
"complimentaient" => "k§plim@tE",
"complimentais" => "k§plim@tE",
"complimentait" => "k§plim@tE",
"complimentant" => "k§plim@t@",
"complimentât" => "k§plim@ta",
"complimente" => "k§plim@t",
"complimenté" => "k§plim@te",
"complimentée" => "k§plim@te",
"complimentent" => "k§plim@t",
"complimenter" => "k§plim@te",
"complimenteraient" => "k§plim@t°RE",
"complimentez" => "k§plim@te",
"compliments" => "k§plim@",
"compliqua" => "k§plika",
"compliquaient" => "k§plikE",
"compliquais" => "k§plikE",
"compliquait" => "k§plikE",
"compliquant" => "k§plik@",
"complique" => "k§plik",
"compliqué" => "k§plike",
"compliquée" => "k§plike",
"compliquées" => "k§plike",
"compliquent" => "k§plik",
"compliquer" => "k§plike",
"compliquera" => "k§plik°Ra",
"compliquerai" => "k§plik°RE",
"compliquerait" => "k§plik°RE",
"compliquèrent" => "k§plikER",
"compliques" => "k§plik",
"compliqués" => "k§plike",
"compliquez" => "k§plike",
"compliquions" => "k§plikj§",
"compliquons" => "k§plik§",
"complot" => "k§plo",
"complotai" => "k§plotE",
"complotaient" => "k§plotE",
"complotais" => "k§plotE",
"complotait" => "k§plotE",
"complotant" => "k§plot@",
"complote" => "k§plOt",
"comploté" => "k§plote",
"complotent" => "k§plOt",
"comploter" => "k§plote",
"comploteraient" => "k§plOt°RE",
"comploterait" => "k§plOt°RE",
"complotèrent" => "k§plotER",
"complotes" => "k§plOt",
"comploteur" => "k§plot9R",
"comploteurs" => "k§plot9R",
"comploteuse" => "k§plOt2z",
"complotez" => "k§plote",
"complotiez" => "k§plotje",
"complotons" => "k§plot§",
"complots" => "k§plo",
"complu" => "k§ply",
"complus" => "k§ply",
"complut" => "k§ply",
"compo" => "k§po",
"componction" => "k§p§ksj§",
"components" => "k§pon@",
"comporta" => "k§pORta",
"comportai" => "k§pORtE",
"comportaient" => "k§pORtE",
"comportais" => "k§pORtE",
"comportait" => "k§pORtE",
"comportant" => "k§pORt@",
"comportassent" => "k§pORtas",
"comportât" => "k§pORta",
"comporte" => "k§pORt",
"comporté" => "k§pORte",
"comportée" => "k§pORte",
"comportement" => "k§pORt°m@",
"comportemental" => "k§pORt°m@tal",
"comportementale" => "k§pORt°m@tal",
"comportementales" => "k§pORt°m@tal",
"comportementalisme" => "k§pORt°m@talizm",
"comportementaliste" => "k§pORt°m@talist",
"comportementaux" => "k§pORt°m@to",
"comportements" => "k§pORt°m@",
"comportent" => "k§pORt",
"comporter" => "k§pORte",
"comportera" => "k§pORt°Ra",
"comporterai" => "k§pORt°RE",
"comporteraient" => "k§pORt°RE",
"comporterais" => "k§pORt°RE",
"comporterait" => "k§pORt°RE",
"comporterez" => "k§pORt°Re",
"comporteriez" => "k§pORt°Rje",
"comporterions" => "k§pORt°Rj§",
"comporteront" => "k§pORt°R§",
"comportes" => "k§pORt",
"comportés" => "k§pORte",
"comportez" => "k§pORte",
"comportiez" => "k§pORtje",
"comportions" => "k§pORtj§",
"comportons" => "k§pORt§",
"composa" => "k§poza",
"composai" => "k§pozE",
"composaient" => "k§pozE",
"composais" => "k§pozE",
"composait" => "k§pozE",
"composant" => "k§poz@",
"composante" => "k§poz@t",
"composantes" => "k§poz@t",
"composants" => "k§poz@",
"compose" => "k§poz",
"composé" => "k§poze",
"composée" => "k§poze",
"composées" => "k§poze",
"composent" => "k§poz",
"composer" => "k§poze",
"composera" => "k§poz°Ra",
"composerai" => "k§poz°RE",
"composerait" => "k§poz°RE",
"composèrent" => "k§pozER",
"composeront" => "k§poz°R§",
"composes" => "k§poz",
"composés" => "k§poze",
"composeur" => "k§poz9R",
"composez" => "k§poze",
"composiez" => "k§pozje",
"composions" => "k§pozj§",
"composite" => "k§pozit",
"composites" => "k§pozit",
"compositeur" => "k§pozit9R",
"compositeurs" => "k§pozit9R",
"composition" => "k§pozisj§",
"compositions" => "k§pozisj§",
"compositrice" => "k§pozitRis",
"composons" => "k§poz§",
"compost" => "k§pOst",
"composté" => "k§poste",
"composter" => "k§poste",
"composteur" => "k§post9R",
"composteurs" => "k§post9R",
"compostez" => "k§poste",
"compote" => "k§pOt",
"compotes" => "k§pOt",
"compotier" => "k§potje",
"compotiers" => "k§potje",
"compound" => "k§pund",
"comprador" => "k§pRadOR",
"compréhensible" => "k§pRe@sibl",
"compréhensibles" => "k§pRe@sibl",
"compréhensif" => "k§pRe@sif",
"compréhensifs" => "k§pRe@sif",
"compréhension" => "k§pRe@sj§",
"compréhensions" => "k§pRe@sj§",
"compréhensive" => "k§pRe@siv",
"compréhensives" => "k§pRe@siv",
"comprenaient" => "k§pR°nE",
"comprenais" => "k§pR°nE",
"comprenait" => "k§pR°nE",
"comprenant" => "k§pR°n@",
"comprend" => "k§pR@",
"comprendra" => "k§pR@dRa",
"comprendrai" => "k§pR@dRE",
"comprendraient" => "k§pR@dRE",
"comprendrais" => "k§pR@dRE",
"comprendrait" => "k§pR@dRE",
"comprendras" => "k§pR@dRa",
"comprendre" => "k§pR@dR",
"comprendrez" => "k§pR@dRe",
"comprendriez" => "k§pR@dRje",
"comprendrions" => "k§pR@dRij§",
"comprendrons" => "k§pR@dR§",
"comprendront" => "k§pR@dR§",
"comprends" => "k§pR@",
"comprenette" => "k§pR°nEt",
"comprenez" => "k§pR°ne",
"compreniez" => "k§pR°nje",
"comprenions" => "k§pR°nj§",
"comprenne" => "k§pREn",
"comprennent" => "k§pREn",
"comprennes" => "k§pREn",
"comprenons" => "k§pR°n§",
"compresse" => "k§pREs",
"compressé" => "k§pREse",
"compressée" => "k§pREse",
"compressées" => "k§pREse",
"compresser" => "k§pREse",
"compresses" => "k§pREs",
"compressés" => "k§pREse",
"compresseur" => "k§pREs9R",
"compresseurs" => "k§pREs9R",
"compressible" => "k§pREsibl",
"compressibles" => "k§pREsibl",
"compressif" => "k§pREsif",
"compression" => "k§pREsj§",
"compressions" => "k§pREsj§",
"comprima" => "k§pRima",
"comprimait" => "k§pRimE",
"comprimant" => "k§pRim@",
"comprime" => "k§pRim",
"comprimé" => "k§pRime",
"comprimée" => "k§pRime",
"comprimées" => "k§pRime",
"compriment" => "k§pRim",
"comprimer" => "k§pRime",
"comprimèrent" => "k§pRimER",
"comprîmes" => "k§pRim",
"comprimés" => "k§pRime",
"comprimez" => "k§pRime",
"comprirent" => "k§pRiR",
"compris" => "k§pRi",
"comprise" => "k§pRiz",
"comprises" => "k§pRiz",
"comprisse" => "k§pRis",
"comprit" => "k§pRi",
"comprît" => "k§pRi",
"compromet" => "k§pRomE",
"compromets" => "k§pRomE",
"compromettaient" => "k§pRomEtE",
"compromettait" => "k§pRomEtE",
"compromettant" => "k§pRomEt@",
"compromettante" => "k§pRomEt@t",
"compromettantes" => "k§pRomEt@t",
"compromettants" => "k§pRomEt@",
"compromette" => "k§pRomEt",
"compromettent" => "k§pRomEt",
"compromettes" => "k§pRomEt",
"compromettez" => "k§pRomEte",
"compromettiez" => "k§pRomEtje",
"compromettrai" => "k§pRomEtRE",
"compromettrait" => "k§pRomEtRE",
"compromettre" => "k§pRomEtR",
"compromettrons" => "k§pRomEtR§",
"compromirent" => "k§pRomiR",
"compromis" => "k§pRomi",
"compromise" => "k§pRomiz",
"compromises" => "k§pRomiz",
"compromission" => "k§pRomisj§",
"compromissions" => "k§pRomisj§",
"compromissoire" => "k§pROmiswaR",
"compromit" => "k§pRomi",
"compromît" => "k§pRomi",
"compta" => "k§ta",
"comptabilisait" => "k§tabilizE",
"comptabilisant" => "k§tabiliz@",
"comptabilisation" => "k§tabilizasj§",
"comptabilise" => "k§tabiliz",
"comptabilisé" => "k§tabilize",
"comptabilisées" => "k§tabilize",
"comptabiliser" => "k§tabilize",
"comptabilisés" => "k§tabilize",
"comptabilité" => "k§tabilite",
"comptabilités" => "k§tabilite",
"comptable" => "k§tabl",
"comptables" => "k§tabl",
"comptage" => "k§taZ",
"comptai" => "k§tE",
"comptaient" => "k§tE",
"comptais" => "k§tE",
"comptait" => "k§tE",
"comptant" => "k§t@",
"comptât" => "k§ta",
"compte" => "k§t",
"compté" => "k§te",
"compte-fils" => "k§tfis",
"compte-gouttes" => "k§tgut",
"compte-rendu" => "k§tR@dy",
"compte-tours" => "k§ttuR",
"comptée" => "k§te",
"comptées" => "k§te",
"comptent" => "k§t",
"compter" => "k§te",
"comptera" => "k§t°Ra",
"compterai" => "k§t°RE",
"compteraient" => "k§t°RE",
"compterais" => "k§t°RE",
"compterait" => "k§t°RE",
"compteras" => "k§t°Ra",
"comptèrent" => "k§tER",
"compterez" => "k§t°Re",
"compterons" => "k§t°R§",
"compteront" => "k§t°R§",
"comptes" => "k§t",
"comptés" => "k§te",
"comptes-rendus" => "k§tR@dy",
"compteur" => "k§t9R",
"compteurs" => "k§t9R",
"comptez" => "k§te",
"comptiez" => "k§tje",
"comptine" => "k§tin",
"comptines" => "k§tin",
"comptions" => "k§tj§",
"comptoir" => "k§twaR",
"comptoirs" => "k§twaR",
"comptons" => "k§t§",
"compulsait" => "k§pylsE",
"compulsant" => "k§pyls@",
"compulse" => "k§pyls",
"compulsé" => "k§pylse",
"compulser" => "k§pylse",
"compulsés" => "k§pylse",
"compulsez" => "k§pylse",
"compulsif" => "k§pylsif",
"compulsifs" => "k§pylsif",
"compulsion" => "k§pylsj§",
"compulsive" => "k§pylsiv",
"compulsivement" => "k§pylsiv°m@",
"compulsives" => "k§pylsiv",
"compulsoire" => "k§pylswaR",
"compulsons" => "k§pyls§",
"comput" => "k§pyt",
"computations" => "k§pytasj§",
"computer" => "k§pyte",
"computers" => "k§pyt9R",
"computeur" => "k§pjyt9R",
"computeurs" => "k§pyt9R",
"comtal" => "k§tal",
"comtale" => "k§tal",
"comte" => "k§t",
"comté" => "k§te",
"comtes" => "k§t",
"comtés" => "k§te",
"comtesse" => "k§tEs",
"comtesses" => "k§tEs",
"comtois" => "k§twa",
"comtoise" => "k§twaz",
"con" => "k§",
"conard" => "konaR",
"conarde" => "konaRd",
"conards" => "konaR",
"conasse" => "konas",
"conasses" => "konas",
"concassage" => "k§kasaZ",
"concassait" => "k§kasE",
"concassant" => "k§kas@",
"concasse" => "k§kas",
"concassé" => "k§kase",
"concassée" => "k§kase",
"concassées" => "k§kase",
"concassent" => "k§kas",
"concasser" => "k§kase",
"concassés" => "k§kase",
"concasseur" => "k§kas9R",
"concasseurs" => "k§kas9R",
"concaténation" => "k§katenasj§",
"concave" => "k§kav",
"concaves" => "k§kav",
"concavité" => "k§kavite",
"concéda" => "k§seda",
"concédai" => "k§sedE",
"concédaient" => "k§sedE",
"concédais" => "k§sedE",
"concédait" => "k§sedE",
"concédant" => "k§sed@",
"concédât" => "k§seda",
"concède" => "k§sEd",
"concédé" => "k§sede",
"concédée" => "k§sede",
"concéder" => "k§sede",
"concéderait" => "k§sed°RE",
"concèdes" => "k§sEd",
"concédés" => "k§sede",
"concédez" => "k§sede",
"concédons" => "k§sed§",
"concélèbrent" => "k§selEbR",
"concentra" => "k§s@tRa",
"concentrai" => "k§s@tRE",
"concentraient" => "k§s@tRE",
"concentrais" => "k§s@tRE",
"concentrait" => "k§s@tRE",
"concentrant" => "k§s@tR@",
"concentrateur" => "k§s@tRat9R",
"concentration" => "k§s@tRasj§",
"concentrationnaire" => "k§s@tRasjonER",
"concentrationnaires" => "k§s@tRasjonER",
"concentrations" => "k§s@tRasj§",
"concentre" => "k§s@tR",
"concentré" => "k§s@tRe",
"concentrée" => "k§s@tRe",
"concentrées" => "k§s@tRe",
"concentrent" => "k§s@tR",
"concentrer" => "k§s@tRe",
"concentrera" => "k§s@tR°Ra",
"concentrerai" => "k§s@tR°RE",
"concentrerais" => "k§s@tR°RE",
"concentrerait" => "k§s@tR°RE",
"concentrerons" => "k§s@tR°R§",
"concentreront" => "k§s@tR°R§",
"concentres" => "k§s@tR",
"concentrés" => "k§s@tRe",
"concentrez" => "k§s@tRe",
"concentriez" => "k§s@tRije",
"concentrions" => "k§s@tRij§",
"concentrique" => "k§s@tRik",
"concentriques" => "k§s@tRik",
"concentrons" => "k§s@tR§",
"concept" => "k§sEpt",
"concepteur" => "k§sEpt9R",
"concepteurs" => "k§sEpt9R",
"conception" => "k§sEpsj§",
"conceptions" => "k§sEpsj§",
"conceptrice" => "k§sEptRis",
"concepts" => "k§sEpt",
"conceptualise" => "k§sEpt8aliz",
"conceptualisé" => "k§sEptyalize",
"conceptualiser" => "k§sEpt8alize",
"conceptuel" => "k§sEpt8El",
"conceptuelle" => "k§sEpt8El",
"conceptuellement" => "k§sEptyEl°m@",
"conceptuelles" => "k§sEpt8El",
"conceptuels" => "k§sEpt8El",
"concernaient" => "k§sERnE",
"concernait" => "k§sERnE",
"concernant" => "k§sERn@",
"concernât" => "k§sERna",
"concerne" => "k§sERn",
"concerné" => "k§sERne",
"concernée" => "k§sERne",
"concernées" => "k§sERne",
"concernent" => "k§sERn",
"concerner" => "k§sERne",
"concernera" => "k§sERn°Ra",
"concerneraient" => "k§sERn°RE",
"concernerait" => "k§sERn°RE",
"concernèrent" => "k§sERnER",
"concernés" => "k§sERne",
"concert" => "k§sER",
"concertaient" => "k§sERtE",
"concertait" => "k§sERtE",
"concertant" => "k§sERt@",
"concertation" => "k§sERtasj§",
"concertations" => "k§sERtasj§",
"concerte" => "k§sERt",
"concerté" => "k§sERte",
"concertée" => "k§sERte",
"concertées" => "k§sERte",
"concertent" => "k§sERt",
"concerter" => "k§sERte",
"concertèrent" => "k§sERtER",
"concertés" => "k§sERte",
"concertez" => "k§sERte",
"concertina" => "k§sERtina",
"concertiste" => "k§sERtist",
"concerto" => "k§sERto",
"concertons" => "k§sERt§",
"concertos" => "k§sERto",
"concerts" => "k§sER",
"concession" => "k§sesj§",
"concessionnaire" => "k§sesjonER",
"concessionnaires" => "k§sesjonER",
"concessions" => "k§sesj§",
"concetto" => "k§sEto",
"concevable" => "k§s°vabl",
"concevables" => "k§s°vabl",
"concevaient" => "k§s°vE",
"concevais" => "k§s°vE",
"concevait" => "k§s°vE",
"concevant" => "k§s°v@",
"concevez" => "k§s°ve",
"conceviez" => "k§s°vje",
"concevions" => "k§s°vj§",
"concevoir" => "k§s°vwaR",
"concevons" => "k§s°v§",
"concevrais" => "k§s°vRE",
"concevrait" => "k§s°vRE",
"conchiaient" => "k§SjE",
"conchie" => "k§Si",
"conchié" => "k§Sje",
"conchier" => "k§Sje",
"conchoïdaux" => "k§kOido",
"concierge" => "k§sjERZ",
"conciergerie" => "k§sjERZ°Ri",
"conciergeries" => "k§sjERZ°Ri",
"concierges" => "k§sjERZ",
"concile" => "k§sil",
"conciles" => "k§sil",
"conciliable" => "k§siljabl",
"conciliables" => "k§siljabl",
"conciliabule" => "k§siljabyl",
"conciliabules" => "k§siljabyl",
"conciliaient" => "k§siljE",
"conciliaires" => "k§siljER",
"conciliait" => "k§siljE",
"conciliant" => "k§silj@",
"conciliante" => "k§silj@t",
"conciliantes" => "k§silj@t",
"conciliants" => "k§silj@",
"conciliateur" => "k§siljat9R",
"conciliateurs" => "k§siljat9R",
"conciliation" => "k§siljasj§",
"conciliations" => "k§siljasj§",
"conciliatrice" => "k§siljatRis",
"concilie" => "k§sili",
"concilié" => "k§silje",
"conciliées" => "k§silje",
"concilier" => "k§silje",
"concilierait" => "k§siliRE",
"concilies" => "k§sili",
"conciliés" => "k§silje",
"concis" => "k§si",
"concise" => "k§siz",
"concision" => "k§sizj§",
"concitoyen" => "k§sitwaj5",
"concitoyenne" => "k§sitwajEn",
"concitoyennes" => "k§sitwajEn",
"concitoyens" => "k§sitwaj5",
"conclave" => "k§klav",
"conclaviste" => "k§klavist",
"conclu" => "k§kly",
"concluaient" => "k§klyE",
"concluais" => "k§klyE",
"concluait" => "k§klyE",
"concluant" => "k§kly@",
"concluante" => "k§kly@t",
"concluantes" => "k§kly@t",
"concluants" => "k§kly@",
"conclue" => "k§kly",
"concluent" => "k§kly",
"conclues" => "k§kly",
"concluez" => "k§klye",
"concluions" => "k§klyj§",
"conclûmes" => "k§klym",
"concluons" => "k§kly§",
"conclura" => "k§klyRa",
"conclurai" => "k§klyRE",
"conclurais" => "k§klyRE",
"conclurait" => "k§klyRE",
"conclure" => "k§klyR",
"conclurent" => "k§klyR",
"conclurez" => "k§klyRe",
"conclurions" => "k§klyRj§",
"conclurons" => "k§klyR§",
"concluront" => "k§klyR§",
"conclus" => "k§kly",
"conclusion" => "k§klyzj§",
"conclusions" => "k§klyzj§",
"conclusive" => "k§klyziv",
"conclut" => "k§kly",
"conclût" => "k§kly",
"concocta" => "k§kOkta",
"concoctait" => "k§kOktE",
"concocté" => "k§kOkte",
"concoctée" => "k§kOkte",
"concoctent" => "k§kOkt",
"concocter" => "k§kOkte",
"concocteras" => "k§kOkt°Ra",
"concoctés" => "k§kOkte",
"concoction" => "k§kOksj§",
"conçois" => "k§swa",
"conçoit" => "k§swa",
"conçoivent" => "k§swav",
"concombre" => "k§k§bR",
"concombres" => "k§k§bR",
"concomitance" => "k§komit@s",
"concomitant" => "k§komit@",
"concomitante" => "k§komit@t",
"concomitantes" => "k§komit@t",
"concordaient" => "k§kORdE",
"concordait" => "k§kORdE",
"concordance" => "k§kORd@s",
"concordant" => "k§kORd@",
"concordante" => "k§kORd@t",
"concordantes" => "k§kORd@t",
"concordants" => "k§kORd@",
"concordat" => "k§kORda",
"concorde" => "k§kORd",
"concordent" => "k§kORd",
"concorder" => "k§kORde",
"concordez" => "k§kORde",
"concordistes" => "k§kORdist",
"concouraient" => "k§kuRE",
"concourait" => "k§kuRE",
"concourant" => "k§kuR@",
"concoure" => "k§kuR",
"concourent" => "k§kuR",
"concourez" => "k§kuRe",
"concourir" => "k§kuRiR",
"concourrai" => "k§kuRE",
"concourrait" => "k§kuRE",
"concourront" => "k§kuR§",
"concours" => "k§kuR",
"concourt" => "k§kuR",
"concouru" => "k§kuRy",
"concourût" => "k§kuRy",
"concret" => "k§kRE",
"concrète" => "k§kREt",
"concrètement" => "k§kREt°m@",
"concrètes" => "k§kREt",
"concrétion" => "k§kResj§",
"concrétions" => "k§kResj§",
"concrétisant" => "k§kRetiz@",
"concrétisation" => "k§kRetizasj§",
"concrétise" => "k§kRetiz",
"concrétisé" => "k§kRetize",
"concrétisée" => "k§kRetize",
"concrétisées" => "k§kRetize",
"concrétisent" => "k§kRetiz",
"concrétiser" => "k§kRetize",
"concrétisèrent" => "k§kRetizER",
"concrétisés" => "k§kRetize",
"concrets" => "k§kRE",
"conçu" => "k§sy",
"concubin" => "k§kyb5",
"concubinage" => "k§kybinaZ",
"concubinages" => "k§kybinaZ",
"concubinait" => "k§kybinE",
"concubine" => "k§kybin",
"concubines" => "k§kybin",
"concubins" => "k§kyb5",
"conçue" => "k§sy",
"conçues" => "k§sy",
"concupiscence" => "k§kypis@s",
"concupiscences" => "k§kypis@s",
"concupiscent" => "k§kypis@",
"concupiscente" => "k§kypis@t",
"concupiscentes" => "k§kypis@t",
"concupiscents" => "k§kypis@",
"conçurent" => "k§syR",
"concurremment" => "k§kyRam@",
"concurrençait" => "k§kyR@sE",
"concurrence" => "k§kyR@s",
"concurrencé" => "k§kyR@se",
"concurrencée" => "k§kyR@se",
"concurrencer" => "k§kyR@se",
"concurrences" => "k§kyR@s",
"concurrent" => "k§kyR@",
"concurrente" => "k§kyR@t",
"concurrentes" => "k§kyR@t",
"concurrentiel" => "k§kyR@sjEl",
"concurrentielle" => "k§kyR@sjEl",
"concurrentiels" => "k§kyR@sjEl",
"concurrents" => "k§kyR@",
"conçus" => "k§sy",
"concussion" => "k§kysj§",
"concussionnaire" => "k§kysjonER",
"conçut" => "k§sy",
"condamna" => "k§dana",
"condamnable" => "k§danabl",
"condamnables" => "k§danabl",
"condamnai" => "k§danE",
"condamnaient" => "k§danE",
"condamnais" => "k§danE",
"condamnait" => "k§danE",
"condamnant" => "k§dan@",
"condamnât" => "k§dana",
"condamnation" => "k§danasj§",
"condamnations" => "k§danasj§",
"condamne" => "k§dan",
"condamné" => "k§dane",
"condamnée" => "k§dane",
"condamnées" => "k§dane",
"condamnent" => "k§dan",
"condamner" => "k§dane",
"condamnera" => "k§dan°Ra",
"condamnerai" => "k§dan°RE",
"condamneraient" => "k§dan°RE",
"condamnerais" => "k§dan°RE",
"condamnerait" => "k§dan°RE",
"condamneras" => "k§dan°Ra",
"condamnèrent" => "k§danER",
"condamnerons" => "k§dan°R§",
"condamneront" => "k§dan°R§",
"condamnes" => "k§dan",
"condamnés" => "k§dane",
"condamnez" => "k§dane",
"condamniez" => "k§danje",
"condamnions" => "k§danj§",
"condamnons" => "k§dan§",
"condé" => "k§de",
"condensa" => "k§d@sa",
"condensaient" => "k§d@sE",
"condensait" => "k§d@sE",
"condensant" => "k§d@s@",
"condensateur" => "k§d@sat9R",
"condensateurs" => "k§d@sat9R",
"condensation" => "k§d@sasj§",
"condense" => "k§d@s",
"condensé" => "k§d@se",
"condensée" => "k§d@se",
"condensées" => "k§d@se",
"condensent" => "k§d@s",
"condenser" => "k§d@se",
"condensera" => "k§d@s°Ra",
"condensèrent" => "k§d@sER",
"condensés" => "k§d@se",
"condenseur" => "k§d@s9R",
"condés" => "k§de",
"condescend" => "k§dEs@",
"condescendait" => "k§dEs@dE",
"condescendance" => "k§des@d@s",
"condescendant" => "k§des@d@",
"condescendante" => "k§des@d@t",
"condescendants" => "k§dEs@d@",
"condescendit" => "k§dEs@di",
"condescendrais" => "k§dEs@dRE",
"condescendre" => "k§des@dR",
"condescendu" => "k§dEs@dy",
"condiment" => "k§dim@",
"condiments" => "k§dim@",
"condisciple" => "k§disipl",
"condisciples" => "k§disipl",
"condition" => "k§disj§",
"conditionnait" => "k§disjonE",
"conditionnant" => "k§disjon@",
"conditionne" => "k§disjOn",
"conditionné" => "k§disjone",
"conditionnée" => "k§disjone",
"conditionnées" => "k§disjone",
"conditionnel" => "k§disjonEl",
"conditionnelle" => "k§disjonEl",
"conditionnellement" => "k§disjonEl°m@",
"conditionnelles" => "k§disjonEl",
"conditionnels" => "k§disjonEl",
"conditionnement" => "k§disjOn°m@",
"conditionnements" => "k§disjOn°m@",
"conditionnent" => "k§disjOn",
"conditionner" => "k§disjone",
"conditionnerons" => "k§disjOn°R§",
"conditionnés" => "k§disjone",
"conditionneur" => "k§disjon9R",
"conditionneurs" => "k§disjon9R",
"conditionnons" => "k§disjon§",
"conditions" => "k§disj§",
"condo" => "k§do",
"condoléance" => "k§dole@s",
"condoléances" => "k§dole@s",
"condoléants" => "k§dole@",
"condom" => "k§dOm",
"condominium" => "k§dominjOm",
"condor" => "k§dOR",
"condors" => "k§dOR",
"condos" => "k§do",
"condottiere" => "k§dotjeR",
"condottieres" => "k§dotjeR",
"condottieri" => "k§dotiRi",
"conductance" => "k§dykt@s",
"conducteur" => "k§dykt9R",
"conducteurs" => "k§dykt9R",
"conductibilité" => "k§dyktibilite",
"conduction" => "k§dyksj§",
"conductivité" => "k§dyktivite",
"conductrice" => "k§dyktRis",
"conductrices" => "k§dyktRis",
"conduira" => "k§d8iRa",
"conduirai" => "k§d8iRE",
"conduiraient" => "k§d8iRE",
"conduirais" => "k§d8iRE",
"conduirait" => "k§d8iRE",
"conduiras" => "k§d8iRa",
"conduire" => "k§d8iR",
"conduirez" => "k§d8iRe",
"conduiriez" => "k§d8iRje",
"conduirons" => "k§d8iR§",
"conduiront" => "k§d8iR§",
"conduis" => "k§d8i",
"conduisaient" => "k§d8izE",
"conduisais" => "k§d8izE",
"conduisait" => "k§d8izE",
"conduisant" => "k§d8iz@",
"conduise" => "k§d8iz",
"conduisent" => "k§d8iz",
"conduises" => "k§d8iz",
"conduisez" => "k§d8ize",
"conduisiez" => "k§d8izje",
"conduisions" => "k§d8izj§",
"conduisirent" => "k§d8iziR",
"conduisis" => "k§d8izi",
"conduisit" => "k§d8izi",
"conduisît" => "k§d8izi",
"conduisons" => "k§d8iz§",
"conduit" => "k§d8i",
"conduite" => "k§d8it",
"conduite-intérieure" => "k§d8it5teRj9R",
"conduites" => "k§d8it",
"conduits" => "k§d8i",
"condyle" => "k§dil",
"condyles" => "k§dil",
"cône" => "kon",
"cônes" => "kon",
"confabulaient" => "k§fabylE",
"confection" => "k§fEksj§",
"confectionna" => "k§fEksjona",
"confectionnai" => "k§fEksjonE",
"confectionnaient" => "k§fEksjonE",
"confectionnais" => "k§fEksjonE",
"confectionnait" => "k§fEksjonE",
"confectionnâmes" => "k§fEksjonam",
"confectionnât" => "k§fEksjona",
"confectionne" => "k§fEksjOn",
"confectionné" => "k§fEksjone",
"confectionnée" => "k§fEksjone",
"confectionnées" => "k§fEksjone",
"confectionner" => "k§fEksjone",
"confectionnerai" => "k§fEksjOn°RE",
"confectionnerais" => "k§fEksjOn°RE",
"confectionnerait" => "k§fEksjOn°RE",
"confectionnèrent" => "k§fEksjonER",
"confectionnés" => "k§fEksjone",
"confectionneur" => "k§fEksjon9R",
"confectionneurs" => "k§fEksjon9R",
"confectionneuse" => "k§fEksjon2z",
"confectionneuses" => "k§fEksjon2z",
"confectionnez" => "k§fEksjone",
"confectionnions" => "k§fEksjonj§",
"confédéral" => "k§fedeRal",
"confédération" => "k§fedeRasj§",
"confédéraux" => "k§fedeRo",
"confédéré" => "k§fedeRe",
"confédérée" => "k§fedeRe",
"confédérer" => "k§fedeRe",
"confédérés" => "k§fedeRe",
"conféra" => "k§feRa",
"conféraient" => "k§feRE",
"conférais" => "k§feRE",
"conférait" => "k§feRE",
"conférant" => "k§feR@",
"conférât" => "k§feRa",
"confère" => "k§fER",
"conféré" => "k§feRe",
"conférée" => "k§feRe",
"conférées" => "k§feRe",
"conférence" => "k§feR@s",
"conférences" => "k§feR@s",
"conférences-débats" => "k§feR@sdeba",
"conférencier" => "k§feR@sje",
"conférencière" => "k§feR@sjER",
"conférenciers" => "k§feR@sje",
"confèrent" => "k§fER",
"conférents" => "k§feR@",
"conférer" => "k§feRe",
"conférera" => "k§feR°Ra",
"conféreraient" => "k§feR°RE",
"conférerait" => "k§feR°RE",
"conférèrent" => "k§feRER",
"conférerez" => "k§feR°Re",
"conféreront" => "k§feR°R§",
"conférés" => "k§feRe",
"conférez" => "k§feRe",
"confessa" => "k§fEsa",
"confessai" => "k§fEsE",
"confessaient" => "k§fEsE",
"confessais" => "k§fEsE",
"confessait" => "k§fEsE",
"confessant" => "k§fEs@",
"confesse" => "k§fEs",
"confessé" => "k§fese",
"confessée" => "k§fese",
"confessent" => "k§fEs",
"confesser" => "k§fese",
"confesserai" => "k§fEs°RE",
"confesserait" => "k§fEs°RE",
"confesseras" => "k§fEs°Ra",
"confesserez" => "k§fEs°Re",
"confessés" => "k§fese",
"confesseur" => "k§fEs9R",
"confesseurs" => "k§fEs9R",
"confessez" => "k§fEse",
"confessiez" => "k§fEsje",
"confession" => "k§fesj§",
"confessionnal" => "k§fEsjonal",
"confessionnaux" => "k§fEsjono",
"confessionnel" => "k§fEsjonEl",
"confessionnelle" => "k§fEsjonEl",
"confessionnels" => "k§fEsjonEl",
"confessions" => "k§fesj§",
"confessons" => "k§fEs§",
"confetti" => "k§feti",
"confettis" => "k§feti",
"confia" => "k§fja",
"confiai" => "k§fjE",
"confiaient" => "k§fjE",
"confiais" => "k§fjE",
"confiait" => "k§fjE",
"confiâmes" => "k§fjam",
"confiance" => "k§fj@s",
"confiances" => "k§fj@s",
"confiant" => "k§fj@",
"confiante" => "k§fj@t",
"confiantes" => "k§fj@t",
"confiants" => "k§fj@",
"confiât" => "k§fja",
"confidence" => "k§fid@s",
"confidences" => "k§fid@s",
"confident" => "k§fid@",
"confidente" => "k§fid@t",
"confidentes" => "k§fid@t",
"confidentialité" => "k§fid@sjalite",
"confidentiel" => "k§fid@sjEl",
"confidentielle" => "k§fid@sjEl",
"confidentiellement" => "k§fid@sjEl°m@",
"confidentielles" => "k§fid@sjEl",
"confidentiels" => "k§fid@sjEl",
"confidents" => "k§fid@",
"confie" => "k§fi",
"confié" => "k§fje",
"confiée" => "k§fje",
"confiées" => "k§fje",
"confient" => "k§fi",
"confier" => "k§fje",
"confiera" => "k§fiRa",
"confierai" => "k§fiRE",
"confieraient" => "k§fiRE",
"confierais" => "k§fiRE",
"confierait" => "k§fiRE",
"confieras" => "k§fiRa",
"confièrent" => "k§fjER",
"confierez" => "k§fiRe",
"confieriez" => "k§fiRje",
"confiés" => "k§fje",
"confiez" => "k§fje",
"configuration" => "k§figyRasj§",
"configurations" => "k§figyRasj§",
"configure" => "k§figyR",
"configuré" => "k§figyRe",
"configurer" => "k§figyRe",
"confiions" => "k§fij§",
"confina" => "k§fina",
"confinaient" => "k§finE",
"confinait" => "k§finE",
"confinant" => "k§fin@",
"confine" => "k§fin",
"confiné" => "k§fine",
"confinée" => "k§fine",
"confinées" => "k§fine",
"confinement" => "k§fin°m@",
"confinent" => "k§fin",
"confiner" => "k§fine",
"confinerez" => "k§fin°Re",
"confinés" => "k§fine",
"confins" => "k§f5",
"confions" => "k§fj§",
"confiote" => "k§fjOt",
"confiotes" => "k§fjOt",
"confire" => "k§fiR",
"confirma" => "k§fiRma",
"confirmai" => "k§fiRmE",
"confirmaient" => "k§fiRmE",
"confirmais" => "k§fiRmE",
"confirmait" => "k§fiRmE",
"confirmâmes" => "k§fiRmam",
"confirmant" => "k§fiRm@",
"confirmât" => "k§fiRma",
"confirmation" => "k§fiRmasj§",
"confirmations" => "k§fiRmasj§",
"confirme" => "k§fiRm",
"confirmé" => "k§fiRme",
"confirmée" => "k§fiRme",
"confirmées" => "k§fiRme",
"confirment" => "k§fiRm",
"confirmer" => "k§fiRme",
"confirmera" => "k§fiRm°Ra",
"confirmerai" => "k§fiRm°RE",
"confirmeraient" => "k§fiRm°RE",
"confirmerait" => "k§fiRm°RE",
"confirmèrent" => "k§fiRmER",
"confirmerez" => "k§fiRm°Re",
"confirmeront" => "k§fiRm°R§",
"confirmes" => "k§fiRm",
"confirmés" => "k§fiRme",
"confirmez" => "k§fiRme",
"confirmions" => "k§fiRmj§",
"confirmons" => "k§fiRm§",
"confiscation" => "k§fiskasj§",
"confiscations" => "k§fiskasj§",
"confiserie" => "k§fiz°Ri",
"confiseries" => "k§fiz°Ri",
"confiseur" => "k§fiz9R",
"confiseurs" => "k§fiz9R",
"confiseuse" => "k§fiz2z",
"confisqua" => "k§fiska",
"confisquaient" => "k§fiskE",
"confisquait" => "k§fiskE",
"confisquant" => "k§fisk@",
"confisquât" => "k§fiska",
"confisque" => "k§fisk",
"confisqué" => "k§fiske",
"confisquée" => "k§fiske",
"confisquées" => "k§fiske",
"confisquent" => "k§fisk",
"confisquer" => "k§fiske",
"confisquera" => "k§fisk°Ra",
"confisquerai" => "k§fisk°RE",
"confisqueraient" => "k§fisk°RE",
"confisquerait" => "k§fisk°RE",
"confisquèrent" => "k§fiskER",
"confisquerons" => "k§fisk°R§",
"confisqueront" => "k§fisk°R§",
"confisqués" => "k§fiske",
"confisquez" => "k§fiske",
"confisquons" => "k§fisk§",
"confit" => "k§fi",
"confite" => "k§fit",
"confiteor" => "k§fiteOR",
"confites" => "k§fit",
"confits" => "k§fi",
"confiture" => "k§fityR",
"confitures" => "k§fityR",
"confiturière" => "k§fituRjER",
"confituriers" => "k§fityRje",
"conflagration" => "k§flagRasj§",
"conflictuel" => "k§flikt8El",
"conflictuelle" => "k§flikt8El",
"conflictuelles" => "k§flikt8El",
"conflictuels" => "k§flikt8El",
"conflit" => "k§fli",
"conflits" => "k§fli",
"confluaient" => "k§flyE",
"confluait" => "k§flyE",
"confluant" => "k§fly@",
"conflue" => "k§fly",
"conflué" => "k§flye",
"confluence" => "k§fly@s",
"confluent" => "k§fly@",
"confluents" => "k§fly@",
"confluer" => "k§fl8e",
"confond" => "k§f§",
"confondaient" => "k§f§dE",
"confondais" => "k§f§dE",
"confondait" => "k§f§dE",
"confondant" => "k§f§d@",
"confondante" => "k§f§d@t",
"confondantes" => "k§f§d@t",
"confondants" => "k§f§d@",
"confonde" => "k§f§d",
"confondent" => "k§f§d",
"confondez" => "k§f§de",
"confondions" => "k§f§dj§",
"confondirent" => "k§f§diR",
"confondis" => "k§f§di",
"confondit" => "k§f§di",
"confondît" => "k§f§di",
"confondons" => "k§f§d§",
"confondra" => "k§f§dRa",
"confondrai" => "k§f§dRE",
"confondrais" => "k§f§dRE",
"confondrait" => "k§f§dRE",
"confondre" => "k§f§dR",
"confondrez" => "k§f§dRe",
"confondront" => "k§f§dR§",
"confonds" => "k§f§",
"confondu" => "k§f§dy",
"confondue" => "k§f§dy",
"confondues" => "k§f§dy",
"confondus" => "k§f§dy",
"conformai" => "k§fORmE",
"conformaient" => "k§fORmE",
"conformais" => "k§fORmE",
"conformait" => "k§fORmE",
"conformant" => "k§fORm@",
"conformât" => "k§fORma",
"conformation" => "k§fORmasj§",
"conforme" => "k§fORm",
"conformé" => "k§fORme",
"conformée" => "k§fORme",
"conformément" => "k§fORmem@",
"conforment" => "k§fORm",
"conformer" => "k§fORme",
"conformera" => "k§fORm°Ra",
"conformerai" => "k§fORm°RE",
"conformeraient" => "k§fORm°RE",
"conformerez" => "k§fORm°Re",
"conformes" => "k§fORm",
"conformisme" => "k§fORmizm",
"conformismes" => "k§fORmizm",
"conformiste" => "k§fORmist",
"conformistes" => "k§fORmist",
"conformité" => "k§fORmite",
"confort" => "k§fOR",
"conforta" => "k§fORta",
"confortable" => "k§fORtabl",
"confortablement" => "k§fORtabl°m@",
"confortables" => "k§fORtabl",
"confortaient" => "k§fORtE",
"confortait" => "k§fORtE",
"confortant" => "k§fORt@",
"conforte" => "k§fORt",
"conforté" => "k§fORte",
"confortée" => "k§fORte",
"conforter" => "k§fORte",
"conforterait" => "k§fORt°RE",
"conforts" => "k§fOR",
"confraternel" => "k§fRatERnEl",
"confraternelle" => "k§fRatERnEl",
"confraternellement" => "k§fRatERnEl°m@",
"confraternelles" => "k§fRatERnEl",
"confraternels" => "k§fRatERnEl",
"confraternité" => "k§fRatERnite",
"confrère" => "k§fRER",
"confrères" => "k§fRER",
"confrérie" => "k§fReRi",
"confréries" => "k§fReRi",
"confrontai" => "k§fR§tE",
"confrontaient" => "k§fR§tE",
"confrontais" => "k§fR§tE",
"confrontait" => "k§fR§tE",
"confrontant" => "k§fR§t@",
"confrontation" => "k§fR§tasj§",
"confrontations" => "k§fR§tasj§",
"confronte" => "k§fR§t",
"confronté" => "k§fR§te",
"confrontée" => "k§fR§te",
"confrontées" => "k§fR§te",
"confrontent" => "k§fR§t",
"confronter" => "k§fR§te",
"confrontèrent" => "k§fR§tER",
"confrontés" => "k§fR§te",
"confrontez" => "k§fR§te",
"confrontons" => "k§fR§t§",
"confucéenne" => "k§fyseEn",
"confucianisme" => "k§fysjanizm",
"confus" => "k§fy",
"confuse" => "k§fyz",
"confusément" => "k§fyzem@",
"confuses" => "k§fyz",
"confusion" => "k§fyzj§",
"confusionnisme" => "k§fyzjonizm",
"confusions" => "k§fyzj§",
"conga" => "k§ga",
"congaïs" => "k§gai",
"congas" => "k§ga",
"congayes" => "k§gaj",
"congé" => "k§Ze",
"congédia" => "k§Zedja",
"congédiai" => "k§ZedjE",
"congédiait" => "k§ZedjE",
"congédiant" => "k§Zedj@",
"congédie" => "k§Zedi",
"congédié" => "k§Zedje",
"congédiée" => "k§Zedje",
"congédiées" => "k§Zedje",
"congédiement" => "k§Zedim@",
"congédient" => "k§Zedi",
"congédier" => "k§Zedje",
"congédiés" => "k§Zedje",
"congédiez" => "k§Zedje",
"congela" => "k§Z°la",
"congelait" => "k§Z°lE",
"congelant" => "k§Z°l@",
"congélateur" => "k§Zelat9R",
"congélateurs" => "k§Zelat9R",
"congélation" => "k§Zelasj§",
"congèle" => "k§ZEl",
"congelé" => "k§Z°le",
"congelée" => "k§Z°le",
"congelées" => "k§Z°le",
"congeler" => "k§Z°le",
"congèlera" => "k§ZEl°Ra",
"congèlerais" => "k§ZEl°RE",
"congelés" => "k§Z°le",
"congelez" => "k§Z°le",
"congelons" => "k§Z°l§",
"congénère" => "k§ZenER",
"congénères" => "k§ZenER",
"congénital" => "k§Zenital",
"congénitale" => "k§Zenital",
"congénitalement" => "k§Zenital°m@",
"congénitales" => "k§Zenital",
"congénitaux" => "k§Zenito",
"congère" => "k§ZER",
"congères" => "k§ZER",
"congés" => "k§Ze",
"congestif" => "k§ZEstif",
"congestion" => "k§ZEstj§",
"congestionnaient" => "k§ZEstjonE",
"congestionnait" => "k§ZEstjonE",
"congestionne" => "k§ZEstjOn",
"congestionné" => "k§ZEstjone",
"congestionnée" => "k§ZEstjone",
"congestionnées" => "k§ZEstjone",
"congestionnent" => "k§ZEstjOn",
"congestionnés" => "k§ZEstjone",
"congestions" => "k§ZEstj§",
"congestive" => "k§ZEstiv",
"conglobation" => "k§globasj§",
"conglomérat" => "k§glomeRa",
"conglomérats" => "k§glomeRa",
"conglomérée" => "k§glomeRe",
"congolais" => "k§golE",
"congolaise" => "k§golEz",
"congratula" => "k§gRatyla",
"congratulaient" => "k§gRatylE",
"congratulait" => "k§gRatylE",
"congratulâmes" => "k§gRatylam",
"congratulant" => "k§gRatyl@",
"congratulations" => "k§gRatylasj§",
"congratule" => "k§gRatyl",
"congratulé" => "k§gRatyle",
"congratulent" => "k§gRatyl",
"congratuler" => "k§gRatyle",
"congratulèrent" => "k§gRatylER",
"congratulés" => "k§gRatyle",
"congratulions" => "k§gRatylj§",
"congre" => "k§gR",
"congréganiste" => "k§gReganist",
"congrégation" => "k§gRegasj§",
"congrégationaliste" => "k§gRegasjOnalist",
"congrégations" => "k§gRegasj§",
"congres" => "k§gR",
"congrès" => "k§gRE",
"congressistes" => "k§gREsist",
"congrue" => "k§gRy",
"congrûment" => "k§gRym@",
"conifère" => "konifER",
"conifères" => "konifER",
"conique" => "konik",
"coniques" => "konik",
"conjecturai" => "k§ZEktyRE",
"conjectural" => "k§ZEktyRal",
"conjecturale" => "k§ZEktyRal",
"conjecture" => "k§ZEktyR",
"conjecturent" => "k§ZEktyR",
"conjecturer" => "k§ZEktyRe",
"conjectures" => "k§ZEktyR",
"conjoindre" => "k§Zw5dR",
"conjoint" => "k§Zw5",
"conjointe" => "k§Zw5t",
"conjointement" => "k§Zw5t°m@",
"conjointes" => "k§Zw5t",
"conjoints" => "k§Zw5",
"conjoncteur" => "k§Z§kt9R",
"conjonctif" => "k§Z§ktif",
"conjonction" => "k§Z§ksj§",
"conjonctions" => "k§Z§ksj§",
"conjonctive" => "k§Z§ktiv",
"conjonctives" => "k§Z§ktiv",
"conjonctivite" => "k§Z§ktivit",
"conjonctivites" => "k§Z§ktivit",
"conjoncture" => "k§Z§ktyR",
"conjonctures" => "k§Z§ktyR",
"conjugaison" => "k§ZygEz§",
"conjugaisons" => "k§ZygEz§",
"conjugal" => "k§Zygal",
"conjugale" => "k§Zygal",
"conjugalement" => "k§Zygal°m@",
"conjugales" => "k§Zygal",
"conjugalité" => "k§Zygalite",
"conjugaux" => "k§Zygo",
"conjuguaient" => "k§ZygE",
"conjuguait" => "k§ZygE",
"conjuguant" => "k§Zyg@",
"conjugue" => "k§Zyg",
"conjugué" => "k§Zyge",
"conjuguée" => "k§Zyge",
"conjuguées" => "k§Zyge",
"conjuguent" => "k§Zyg",
"conjuguer" => "k§Zyge",
"conjuguerions" => "k§Zyg°Rj§",
"conjugues" => "k§Zyg",
"conjugués" => "k§Zyge",
"conjungo" => "k§j§Go",
"conjungos" => "k§j§Go",
"conjura" => "k§ZyRa",
"conjurait" => "k§ZyRE",
"conjurant" => "k§ZyR@",
"conjurateur" => "k§ZyRat9R",
"conjuration" => "k§ZyRasj§",
"conjurations" => "k§ZyRasj§",
"conjuratoire" => "k§ZyRatwaR",
"conjure" => "k§ZyR",
"conjuré" => "k§ZyRe",
"conjurée" => "k§ZyRe",
"conjurées" => "k§ZyRe",
"conjurer" => "k§ZyRe",
"conjurera" => "k§ZyR°Ra",
"conjurés" => "k§ZyRe",
"connais" => "konE",
"connaissable" => "konEsabl",
"connaissables" => "konEsabl",
"connaissaient" => "konEsE",
"connaissais" => "konEsE",
"connaissait" => "konEsE",
"connaissance" => "konEs@s",
"connaissances" => "konEs@s",
"connaissant" => "konEs@",
"connaisse" => "konEs",
"connaissement" => "konEs°m@",
"connaissements" => "konEs°m@",
"connaissent" => "konEs",
"connaisses" => "konEs",
"connaisseur" => "konEs9R",
"connaisseurs" => "konEs9R",
"connaisseuse" => "konEs2z",
"connaisseuses" => "konEs2z",
"connaissez" => "konEse",
"connaissiez" => "konEsje",
"connaissions" => "konEsj§",
"connaissons" => "konEs§",
"connaît" => "konE",
"connaîtra" => "konEtRa",
"connaîtrai" => "konEtRE",
"connaîtraient" => "konEtRE",
"connaîtrais" => "konEtRE",
"connaîtrait" => "konEtRE",
"connaîtras" => "konEtRa",
"connaître" => "konEtR",
"connaîtrez" => "konEtRe",
"connaîtriez" => "konEtRije",
"connaîtrions" => "konEtRij§",
"connaîtrons" => "konEtR§",
"connaîtront" => "konEtR§",
"connard" => "konaR",
"connards" => "konaR",
"connasse" => "konas",
"connasses" => "konas",
"conne" => "kOn",
"conneau" => "kono",
"conneaux" => "kono",
"connectant" => "kOnEkt@",
"connecte" => "konEkt",
"connecté" => "konEkte",
"connectée" => "konEkte",
"connectées" => "konEkte",
"connectent" => "konEkt",
"connecter" => "konEkte",
"connectera" => "konEkt°Ra",
"connectés" => "konEkte",
"connecteur" => "konEkt9R",
"connectez" => "konEkte",
"connectiez" => "konEktje",
"connections" => "konEktj§",
"connectivité" => "konEktivite",
"connectons" => "konEkt§",
"connement" => "kOn°m@",
"connerie" => "kOn°Ri",
"conneries" => "kOn°Ri",
"connes" => "kOn",
"connétable" => "konetabl",
"connétables" => "konetabl",
"connexe" => "konEks",
"connexes" => "konEks",
"connexion" => "konEksj§",
"connexions" => "konEksj§",
"connils" => "konil",
"connivence" => "koniv@s",
"connivences" => "koniv@s",
"connotation" => "konotasj§",
"connotations" => "konotasj§",
"connu" => "kony",
"connue" => "kony",
"connues" => "kony",
"connûmes" => "konym",
"connurent" => "konyR",
"connus" => "kony",
"connusse" => "konys",
"connussent" => "konys",
"connusses" => "konys",
"connut" => "kony",
"connût" => "kony",
"conoïdaux" => "konoido",
"conoïde" => "konoid",
"conque" => "k§k",
"conquérait" => "k§keRE",
"conquérant" => "k§keR@",
"conquérante" => "k§keR@t",
"conquérantes" => "k§keR@t",
"conquérants" => "k§keR@",
"conquérez" => "k§keRe",
"conquérir" => "k§keRiR",
"conquérons" => "k§keR§",
"conquerra" => "k§kERa",
"conquerraient" => "k§kERRE",
"conquerrons" => "k§kER§",
"conquerront" => "k§kERR§",
"conques" => "k§k",
"conquête" => "k§kEt",
"conquêtes" => "k§kEt",
"conquière" => "k§kjER",
"conquièrent" => "k§kjER",
"conquiers" => "k§kjER",
"conquiert" => "k§kjER",
"conquirent" => "k§kiR",
"conquis" => "k§ki",
"conquise" => "k§kiz",
"conquises" => "k§kiz",
"conquistador" => "k§kistadOR",
"conquistadores" => "k§kistadOR",
"conquistadors" => "k§kistadOR",
"conquit" => "k§ki",
"conquît" => "k§ki",
"cons" => "k§",
"consacra" => "k§sakRa",
"consacrai" => "k§sakRE",
"consacraient" => "k§sakRE",
"consacrais" => "k§sakRE",
"consacrait" => "k§sakRE",
"consacrant" => "k§sakR@",
"consacre" => "k§sakR",
"consacré" => "k§sakRe",
"consacrée" => "k§sakRe",
"consacrées" => "k§sakRe",
"consacrent" => "k§sakR",
"consacrer" => "k§sakRe",
"consacrera" => "k§sakR°Ra",
"consacrerai" => "k§sakR°RE",
"consacreraient" => "k§sakR°RE",
"consacrerais" => "k§sakR°RE",
"consacrerait" => "k§sakR°RE",
"consacreras" => "k§sakR°Ra",
"consacrèrent" => "k§sakRER",
"consacrerez" => "k§sakR°Re",
"consacreriez" => "k§sakR°Rje",
"consacrerions" => "k§sakR°Rj§",
"consacreront" => "k§sakR°R§",
"consacres" => "k§sakR",
"consacrés" => "k§sakRe",
"consacrez" => "k§sakRe",
"consacriez" => "k§sakRje",
"consacrons" => "k§sakR§",
"consanguin" => "k§s@g5",
"consanguine" => "k§s@gin",
"consanguinité" => "k§s@ginite",
"consanguinités" => "k§s@ginite",
"consanguins" => "k§s@g5",
"consciemment" => "k§sjam@",
"conscience" => "k§sj@s",
"consciences" => "k§sj@s",
"consciencieuse" => "k§sj@sj2z",
"consciencieusement" => "k§sj@sj2z°m@",
"consciencieuses" => "k§sj@sj2z",
"consciencieux" => "k§sj@sj2",
"conscient" => "k§sj@",
"consciente" => "k§sj@t",
"conscientes" => "k§sj@t",
"conscients" => "k§sj@",
"conscription" => "k§skRipsj§",
"conscrit" => "k§skRi",
"conscrits" => "k§skRi",
"consécration" => "k§sekRasj§",
"consécutif" => "k§sekytif",
"consécutifs" => "k§sekytif",
"consécution" => "k§sekysj§",
"consécutive" => "k§sekytiv",
"consécutivement" => "k§sekytiv°m@",
"consécutives" => "k§sekytiv",
"conseil" => "k§sEj",
"conseilla" => "k§sEja",
"conseillai" => "k§sEjE",
"conseillaient" => "k§sEjE",
"conseillais" => "k§sEjE",
"conseillait" => "k§sEjE",
"conseillant" => "k§sEj@",
"conseille" => "k§sEj",
"conseillé" => "k§seje",
"conseillée" => "k§seje",
"conseillées" => "k§seje",
"conseillent" => "k§sEj",
"conseiller" => "k§seje",
"conseillera" => "k§sEj°Ra",
"conseillerai" => "k§sEj°RE",
"conseillerais" => "k§sEj°RE",
"conseillerait" => "k§sEj°RE",
"conseillère" => "k§sejER",
"conseillèrent" => "k§sEjER",
"conseillères" => "k§sEjER",
"conseillerez" => "k§sEj°Re",
"conseilleriez" => "k§sEj°Rje",
"conseillers" => "k§sEje",
"conseilles" => "k§sEj",
"conseillés" => "k§seje",
"conseilleurs" => "k§sEj9R",
"conseillez" => "k§sEje",
"conseillons" => "k§sEj§",
"conseils" => "k§sEj",
"consens" => "k§s@",
"consensuel" => "k§s@s8El",
"consensuelle" => "k§s@syEl",
"consensus" => "k§s5sys",
"consent" => "k§s@",
"consentaient" => "k§s@tE",
"consentais" => "k§s@tE",
"consentait" => "k§s@tE",
"consentant" => "k§s@t@",
"consentante" => "k§s@t@t",
"consentantes" => "k§s@t@t",
"consentants" => "k§s@t@",
"consente" => "k§s@t",
"consentement" => "k§s@t°m@",
"consentements" => "k§s@t°m@",
"consentent" => "k§s@t",
"consentes" => "k§s@t",
"consentez" => "k§s@te",
"consenti" => "k§s@ti",
"consentie" => "k§s@ti",
"consenties" => "k§s@ti",
"consentiez" => "k§s@tje",
"consentions" => "k§s@tj§",
"consentir" => "k§s@tiR",
"consentira" => "k§s@tiRa",
"consentirai" => "k§s@tiRE",
"consentiraient" => "k§s@tiRE",
"consentirais" => "k§s@tiRE",
"consentirait" => "k§s@tiRE",
"consentiras" => "k§s@tiRa",
"consentirent" => "k§s@tiR",
"consentirez" => "k§s@tiRe",
"consentiriez" => "k§s@tiRje",
"consentirions" => "k§s@tiRj§",
"consentiront" => "k§s@tiR§",
"consentis" => "k§s@ti",
"consentisse" => "k§s@tis",
"consentissent" => "k§s@tis",
"consentit" => "k§s@ti",
"consentît" => "k§s@ti",
"consentons" => "k§s@t§",
"conséquemment" => "k§sekam@",
"conséquence" => "k§sek@s",
"conséquences" => "k§sek@s",
"conséquent" => "k§sek@",
"conséquente" => "k§sek@t",
"conséquentes" => "k§sek@t",
"conséquents" => "k§sek@",
"conserva" => "k§sERva",
"conservai" => "k§sERvE",
"conservaient" => "k§sERvE",
"conservais" => "k§sERvE",
"conservait" => "k§sERvE",
"conservant" => "k§sERv@",
"conservât" => "k§sERva",
"conservateur" => "k§sERvat9R",
"conservateurs" => "k§sERvat9R",
"conservation" => "k§sERvasj§",
"conservatisme" => "k§sERvatizm",
"conservatoire" => "k§sERvatwaR",
"conservatoires" => "k§sERvatwaR",
"conservatrice" => "k§sERvatRis",
"conservatrices" => "k§sERvatRis",
"conserve" => "k§sERv",
"conservé" => "k§sERve",
"conservée" => "k§sERve",
"conservées" => "k§sERve",
"conservent" => "k§sERv",
"conserver" => "k§sERve",
"conservera" => "k§sERv°Ra",
"conserverai" => "k§sERv°RE",
"conserveraient" => "k§sERv°RE",
"conserverais" => "k§sERv°RE",
"conserverait" => "k§sERv°RE",
"conserveras" => "k§sERv°Ra",
"conservèrent" => "k§sERvER",
"conserverez" => "k§sERv°Re",
"conserverie" => "k§sERv°Ri",
"conserveries" => "k§sERv°Ri",
"conserverons" => "k§sERv°R§",
"conserveront" => "k§sERv°R§",
"conserves" => "k§sERv",
"conservés" => "k§sERve",
"conservez" => "k§sERve",
"conserviez" => "k§sERvje",
"conservions" => "k§sERvj§",
"conservons" => "k§sERv§",
"considéra" => "k§sideRa",
"considérable" => "k§sideRabl",
"considérablement" => "k§sideRabl°m@",
"considérables" => "k§sideRabl",
"considérai" => "k§sideRE",
"considéraient" => "k§sideRE",
"considérais" => "k§sideRE",
"considérait" => "k§sideRE",
"considérant" => "k§sideR@",
"considérants" => "k§sideR@",
"considérassent" => "k§sideRas",
"considérât" => "k§sideRa",
"considération" => "k§sideRasj§",
"considérations" => "k§sideRasj§",
"considère" => "k§sidER",
"considéré" => "k§sideRe",
"considérée" => "k§sideRe",
"considérées" => "k§sideRe",
"considèrent" => "k§sidER",
"considérer" => "k§sideRe",
"considérera" => "k§sideR°Ra",
"considérerai" => "k§sideR°RE",
"considéreraient" => "k§sideR°RE",
"considérerais" => "k§sideR°RE",
"considérerait" => "k§sideR°RE",
"considéreras" => "k§sideR°Ra",
"considérèrent" => "k§sideRER",
"considéreriez" => "k§sideR°Rje",
"considérerions" => "k§sideR°Rj§",
"considérerons" => "k§sideR°R§",
"considères" => "k§sidER",
"considérés" => "k§sideRe",
"considérez" => "k§sideRe",
"considériez" => "k§sideRje",
"considérions" => "k§sideRj§",
"considérons" => "k§sideR§",
"consigna" => "k§siNa",
"consignais" => "k§siNE",
"consignait" => "k§siNE",
"consignant" => "k§siN@",
"consignataire" => "k§siNatER",
"consignation" => "k§siNasj§",
"consignations" => "k§siNasj§",
"consigne" => "k§siN",
"consigné" => "k§siNe",
"consignée" => "k§siNe",
"consignées" => "k§siNe",
"consignent" => "k§siN",
"consigner" => "k§siNe",
"consignera" => "k§siN°Ra",
"consignerais" => "k§siN°RE",
"consignes" => "k§siN",
"consignés" => "k§siNe",
"consignez" => "k§siNe",
"consista" => "k§sista",
"consistaient" => "k§sistE",
"consistait" => "k§sistE",
"consistance" => "k§sist@s",
"consistances" => "k§sist@s",
"consistant" => "k§sist@",
"consistante" => "k§sist@t",
"consistantes" => "k§sist@t",
"consistants" => "k§sist@",
"consiste" => "k§sist",
"consisté" => "k§siste",
"consistent" => "k§sist",
"consister" => "k§siste",
"consistera" => "k§sist°Ra",
"consisteraient" => "k§sist°RE",
"consisterait" => "k§sist°RE",
"consistèrent" => "k§sistER",
"consistoire" => "k§sistwaR",
"consistorial" => "k§sistoRjal",
"consistoriales" => "k§sistoRjal",
"conso" => "k§so",
"consoeur" => "k§s9R",
"consoeurs" => "k§s9R",
"consola" => "k§sola",
"consolai" => "k§solE",
"consolaient" => "k§solE",
"consolais" => "k§solE",
"consolait" => "k§solE",
"consolant" => "k§sol@",
"consolante" => "k§sol@t",
"consolantes" => "k§sol@t",
"consolants" => "k§sol@",
"consolasse" => "k§solas",
"consolât" => "k§sola",
"consolateur" => "k§solat9R",
"consolateurs" => "k§solat9R",
"consolation" => "k§solasj§",
"consolations" => "k§solasj§",
"consolatrice" => "k§solatRis",
"consolatrices" => "k§solatRis",
"console" => "k§sOl",
"consolé" => "k§sole",
"consolée" => "k§sole",
"consolées" => "k§sole",
"consolent" => "k§sOl",
"consoler" => "k§sole",
"consolera" => "k§sOl°Ra",
"consolerai" => "k§sOl°RE",
"consoleraient" => "k§sOl°RE",
"consolerais" => "k§sOl°RE",
"consolerait" => "k§sOl°RE",
"consoleras" => "k§sOl°Ra",
"consolèrent" => "k§solER",
"consolerez" => "k§sOl°Re",
"consolerons" => "k§sOl°R§",
"consoleront" => "k§sOl°R§",
"consoles" => "k§sOl",
"consolés" => "k§sole",
"consolez" => "k§sole",
"consolidaient" => "k§solidE",
"consolidais" => "k§solidE",
"consolidait" => "k§solidE",
"consolidant" => "k§solid@",
"consolidation" => "k§solidasj§",
"consolide" => "k§solid",
"consolidé" => "k§solide",
"consolidée" => "k§solide",
"consolidées" => "k§solide",
"consolident" => "k§solid",
"consolider" => "k§solide",
"consolideraient" => "k§solid°RE",
"consolidés" => "k§solide",
"consolidons" => "k§solid§",
"consoliez" => "k§solje",
"consolions" => "k§solj§",
"consomma" => "k§soma",
"consommable" => "k§somabl",
"consommables" => "k§somabl",
"consommai" => "k§somE",
"consommaient" => "k§somE",
"consommait" => "k§somE",
"consommant" => "k§som@",
"consommateur" => "k§somat9R",
"consommateurs" => "k§somat9R",
"consommation" => "k§somasj§",
"consommations" => "k§somasj§",
"consommatrice" => "k§somatRis",
"consommatrices" => "k§somatRis",
"consomme" => "k§sOm",
"consommé" => "k§some",
"consommée" => "k§some",
"consommées" => "k§some",
"consomment" => "k§sOm",
"consommer" => "k§some",
"consommerait" => "k§sOm°RE",
"consommeront" => "k§sOm°R§",
"consommés" => "k§some",
"consommez" => "k§some",
"consommions" => "k§somj§",
"consommons" => "k§som§",
"consomption" => "k§s§psj§",
"consomptive" => "k§s§ptiv",
"consonance" => "k§son@s",
"consonances" => "k§son@s",
"consonne" => "k§sOn",
"consonnes" => "k§sOn",
"consort" => "k§sOR",
"consortium" => "k§sORsjOm",
"consortiums" => "k§sORtijOm",
"consorts" => "k§sOR",
"consos" => "k§so",
"consoude" => "k§sud",
"conspiraient" => "k§spiRE",
"conspirait" => "k§spiRE",
"conspirant" => "k§spiR@",
"conspirateur" => "k§spiRat9R",
"conspirateurs" => "k§spiRat9R",
"conspiratif" => "k§spiRatif",
"conspiration" => "k§spiRasj§",
"conspirations" => "k§spiRasj§",
"conspiratrice" => "k§spiRatRis",
"conspiratrices" => "k§spiRatRis",
"conspire" => "k§spiR",
"conspiré" => "k§spiRe",
"conspirent" => "k§spiR",
"conspirer" => "k§spiRe",
"conspirez" => "k§spiRe",
"conspuaient" => "k§sp8E",
"conspuant" => "k§sp8@",
"conspue" => "k§spy",
"conspué" => "k§sp8e",
"conspuer" => "k§sp8e",
"conspuèrent" => "k§spyER",
"conspués" => "k§sp8e",
"constable" => "k§stabl",
"constamment" => "k§stam@",
"constance" => "k§st@s",
"constances" => "k§st@s",
"constant" => "k§st@",
"constante" => "k§st@t",
"constantes" => "k§st@t",
"constants" => "k§st@",
"constat" => "k§sta",
"constata" => "k§stata",
"constatai" => "k§statE",
"constataient" => "k§statE",
"constatais" => "k§statE",
"constatait" => "k§statE",
"constatâmes" => "k§statam",
"constatant" => "k§stat@",
"constatation" => "k§statasj§",
"constatations" => "k§statasj§",
"constate" => "k§stat",
"constaté" => "k§state",
"constatée" => "k§state",
"constatées" => "k§state",
"constatent" => "k§stat",
"constater" => "k§state",
"constatera" => "k§stat°Ra",
"constaterai" => "k§stat°RE",
"constateraient" => "k§stat°RE",
"constaterais" => "k§stat°RE",
"constaterait" => "k§stat°RE",
"constateras" => "k§stat°Ra",
"constatèrent" => "k§statER",
"constaterez" => "k§stat°Re",
"constateriez" => "k§stat°Rje",
"constatés" => "k§state",
"constatez" => "k§state",
"constatiez" => "k§statje",
"constations" => "k§statj§",
"constatons" => "k§stat§",
"constats" => "k§sta",
"constellaient" => "k§stElE",
"constellait" => "k§stElE",
"constellant" => "k§stEl@",
"constellation" => "k§stElasj§",
"constellations" => "k§stElasj§",
"constelle" => "k§stEl",
"constellé" => "k§stEle",
"constellée" => "k§stEle",
"constellées" => "k§stEle",
"constellent" => "k§stEl",
"constellés" => "k§stEle",
"consterna" => "k§stERna",
"consternait" => "k§stERnE",
"consternant" => "k§stERn@",
"consternante" => "k§stERn@t",
"consternantes" => "k§stERn@t",
"consternants" => "k§stERn@",
"consternation" => "k§stERnasj§",
"consterne" => "k§stERn",
"consterné" => "k§stERne",
"consternée" => "k§stERne",
"consternées" => "k§stERne",
"consternent" => "k§stERn",
"consternés" => "k§stERne",
"constipant" => "k§stip@",
"constipation" => "k§stipasj§",
"constipations" => "k§stipasj§",
"constipe" => "k§stip",
"constipé" => "k§stipe",
"constipée" => "k§stipe",
"constipées" => "k§stipe",
"constipés" => "k§stipe",
"constitua" => "k§stit8a",
"constituaient" => "k§stit8E",
"constituais" => "k§stit8E",
"constituait" => "k§stit8E",
"constituant" => "k§stit8@",
"constituante" => "k§stit8@t",
"constituantes" => "k§stit8@t",
"constituants" => "k§stit8@",
"constituât" => "k§stit8a",
"constitue" => "k§stity",
"constitué" => "k§stit8e",
"constituée" => "k§stit8e",
"constituées" => "k§stit8e",
"constituent" => "k§stity",
"constituer" => "k§stit8e",
"constituera" => "k§stityRa",
"constituerai" => "k§stityRE",
"constitueraient" => "k§stityRE",
"constituerais" => "k§stityRE",
"constituerait" => "k§stityRE",
"constitueras" => "k§stityRa",
"constituèrent" => "k§stit8ER",
"constitueront" => "k§stityR§",
"constitués" => "k§stit8e",
"constituez" => "k§stitye",
"constituions" => "k§stityj§",
"constituons" => "k§stit8§",
"constitutif" => "k§stitytif",
"constitutifs" => "k§stitytif",
"constitution" => "k§stitysj§",
"constitutionnaliste" => "k§stitysjOnalist",
"constitutionnalité" => "k§stitysjOnalite",
"constitutionnel" => "k§stitysjonEl",
"constitutionnelle" => "k§stitysjonEl",
"constitutionnellement" => "k§stitysjonEl°m@",
"constitutionnelles" => "k§stitysjonEl",
"constitutionnels" => "k§stitysjonEl",
"constitutions" => "k§stitysj§",
"constricteur" => "k§stRikt9R",
"constricteurs" => "k§stRikt9R",
"constriction" => "k§stRiksj§",
"constrictive" => "k§stRiktiv",
"constrictor" => "k§stRiktOR",
"constrictors" => "k§stRiktOR",
"constructeur" => "k§stRykt9R",
"constructeurs" => "k§stRykt9R",
"constructif" => "k§stRyktif",
"constructifs" => "k§stRyktif",
"construction" => "k§stRyksj§",
"constructions" => "k§stRyksj§",
"constructive" => "k§stRyktiv",
"constructives" => "k§stRyktiv",
"constructivisme" => "k§stRyktivizm",
"construira" => "k§stR8iRa",
"construirai" => "k§stR8iRE",
"construiraient" => "k§stR8iRE",
"construirais" => "k§stR8iRE",
"construirait" => "k§stR8iRE",
"construiras" => "k§stR8iRa",
"construire" => "k§stR8iR",
"construirez" => "k§stR8iRe",
"construiriez" => "k§stR8iRje",
"construirons" => "k§stR8iR§",
"construiront" => "k§stR8iR§",
"construis" => "k§stR8i",
"construisaient" => "k§stR8izE",
"construisais" => "k§stR8izE",
"construisait" => "k§stR8izE",
"construisant" => "k§stR8iz@",
"construise" => "k§stR8iz",
"construisent" => "k§stR8iz",
"construisez" => "k§stR8ize",
"construisiez" => "k§stR8izje",
"construisions" => "k§stR8izj§",
"construisirent" => "k§stR8iziR",
"construisis" => "k§stR8izi",
"construisit" => "k§stR8izi",
"construisît" => "k§stR8izi",
"construisons" => "k§stR8iz§",
"construit" => "k§stR8i",
"construite" => "k§stR8it",
"construites" => "k§stR8it",
"construits" => "k§stR8i",
"consubstantiel" => "k§sypst@sjEl",
"consubstantielle" => "k§sypst@sjEl",
"consubstantiels" => "k§sypst@sjEl",
"consul" => "k§syl",
"consulaire" => "k§sylER",
"consulaires" => "k§sylER",
"consulat" => "k§syla",
"consulats" => "k§syla",
"consuls" => "k§syl",
"consulta" => "k§sylta",
"consultable" => "k§syltabl",
"consultai" => "k§syltE",
"consultaient" => "k§syltE",
"consultais" => "k§syltE",
"consultait" => "k§syltE",
"consultâmes" => "k§syltam",
"consultant" => "k§sylt@",
"consultante" => "k§sylt@t",
"consultants" => "k§sylt@",
"consultatif" => "k§syltatif",
"consultatifs" => "k§syltatif",
"consultation" => "k§syltasj§",
"consultations" => "k§syltasj§",
"consultative" => "k§syltativ",
"consulte" => "k§sylt",
"consulté" => "k§sylte",
"consultée" => "k§sylte",
"consultées" => "k§sylte",
"consultent" => "k§sylt",
"consulter" => "k§sylte",
"consultera" => "k§sylt°Ra",
"consulterai" => "k§sylt°RE",
"consulteraient" => "k§sylt°RE",
"consulterais" => "k§sylt°RE",
"consulteras" => "k§sylt°Ra",
"consultèrent" => "k§syltER",
"consulterons" => "k§sylt°R§",
"consulteront" => "k§sylt°R§",
"consultes" => "k§sylt",
"consultés" => "k§sylte",
"consultez" => "k§sylte",
"consultions" => "k§syltj§",
"consultons" => "k§sylt§",
"consuma" => "k§syma",
"consumable" => "k§symabl",
"consumai" => "k§symE",
"consumaient" => "k§symE",
"consumais" => "k§symE",
"consumait" => "k§symE",
"consumant" => "k§sym@",
"consumât" => "k§syma",
"consumation" => "k§symasj§",
"consume" => "k§sym",
"consumé" => "k§syme",
"consumée" => "k§syme",
"consumées" => "k§syme",
"consument" => "k§sym",
"consumer" => "k§syme",
"consumera" => "k§sym°Ra",
"consumerait" => "k§sym°RE",
"consumèrent" => "k§symER",
"consumérisme" => "k§symeRizm",
"consumériste" => "k§symeRist",
"consumeront" => "k§sym°R§",
"consumes" => "k§sym",
"consumés" => "k§syme",
"consumez" => "k§syme",
"conta" => "k§ta",
"contact" => "k§takt",
"contacta" => "k§takta",
"contactais" => "k§taktE",
"contactait" => "k§taktE",
"contactant" => "k§takt@",
"contacte" => "k§takt",
"contacté" => "k§takte",
"contactée" => "k§takte",
"contactées" => "k§takte",
"contactent" => "k§takt",
"contacter" => "k§takte",
"contactera" => "k§takt°Ra",
"contacterai" => "k§takt°RE",
"contacteraient" => "k§takt°RE",
"contacterais" => "k§takt°RE",
"contacterait" => "k§takt°RE",
"contacteras" => "k§takt°Ra",
"contacterez" => "k§takt°Re",
"contacterons" => "k§takt°R§",
"contacteront" => "k§takt°R§",
"contactés" => "k§takte",
"contacteur" => "k§takt9R",
"contactez" => "k§takte",
"contactiez" => "k§taktje",
"contactions" => "k§taktj§",
"contactons" => "k§takt§",
"contacts" => "k§takt",
"contagieuse" => "k§taZj2z",
"contagieuses" => "k§taZj2z",
"contagieux" => "k§taZj2",
"contagion" => "k§taZj§",
"contai" => "k§tE",
"contaient" => "k§tE",
"container" => "k§tEnER",
"containers" => "k§tEn9R",
"containeur" => "k§tEn9R",
"contais" => "k§tE",
"contait" => "k§tE",
"contaminaient" => "k§taminE",
"contaminait" => "k§taminE",
"contaminant" => "k§tamin@",
"contaminants" => "k§tamin@",
"contaminât" => "k§tamina",
"contaminateur" => "k§taminat9R",
"contamination" => "k§taminasj§",
"contaminations" => "k§taminasj§",
"contamine" => "k§tamin",
"contaminé" => "k§tamine",
"contaminée" => "k§tamine",
"contaminées" => "k§tamine",
"contaminer" => "k§tamine",
"contaminera" => "k§tamin°Ra",
"contamineras" => "k§tamin°Ra",
"contamines" => "k§tamin",
"contaminés" => "k§tamine",
"contaminons" => "k§tamin§",
"contant" => "k§t@",
"contât" => "k§ta",
"conte" => "k§t",
"conté" => "k§te",
"contée" => "k§te",
"contées" => "k§te",
"contempla" => "k§t@pla",
"contemplai" => "k§t@plE",
"contemplaient" => "k§t@plE",
"contemplais" => "k§t@plE",
"contemplait" => "k§t@plE",
"contemplâmes" => "k§t@plam",
"contemplant" => "k§t@pl@",
"contemplateur" => "k§t@plat9R",
"contemplatif" => "k§t@platif",
"contemplatifs" => "k§t@platif",
"contemplation" => "k§t@plasj§",
"contemplations" => "k§t@plasj§",
"contemplative" => "k§t@plativ",
"contemplativement" => "k§t@plativ°m@",
"contemplatives" => "k§t@plativ",
"contemplatrice" => "k§t@platRis",
"contemple" => "k§t@pl",
"contemplé" => "k§t@ple",
"contemplée" => "k§t@ple",
"contemplées" => "k§t@ple",
"contemplent" => "k§t@pl",
"contempler" => "k§t@ple",
"contemplera" => "k§t@pl°Ra",
"contemplerai" => "k§t@pl°RE",
"contempleraient" => "k§t@pl°RE",
"contemplerait" => "k§t@pl°RE",
"contemplèrent" => "k§t@plER",
"contempleront" => "k§t@pl°R§",
"contemples" => "k§t@pl",
"contemplés" => "k§t@ple",
"contemplez" => "k§t@ple",
"contempliez" => "k§t@plie",
"contemplions" => "k§t@plij§",
"contemplons" => "k§t@pl§",
"contemporain" => "k§t@poR5",
"contemporaine" => "k§t@poREn",
"contemporaines" => "k§t@poREn",
"contemporains" => "k§t@poR5",
"contempteur" => "k§t@pt9R",
"contempteurs" => "k§t@pt9R",
"contenaient" => "k§t°nE",
"contenais" => "k§t°nE",
"contenait" => "k§t°nE",
"contenance" => "k§t°n@s",
"contenances" => "k§t°n@s",
"contenant" => "k§t°n@",
"contenants" => "k§t°n@",
"conteneur" => "k§t°n9R",
"conteneurs" => "k§t°n9R",
"contenez" => "k§t°ne",
"contenir" => "k§t°niR",
"content" => "k§t@",
"contenta" => "k§t@ta",
"contentai" => "k§t@tE",
"contentaient" => "k§t@tE",
"contentais" => "k§t@tE",
"contentait" => "k§t@tE",
"contentant" => "k§t@t@",
"contentassent" => "k§t@tas",
"contente" => "k§t@t",
"contenté" => "k§t@te",
"contentée" => "k§t@te",
"contentées" => "k§t@te",
"contentement" => "k§t@t°m@",
"contentements" => "k§t@t°m@",
"contentent" => "k§t@t",
"contenter" => "k§t@te",
"contentera" => "k§t@t°Ra",
"contenterai" => "k§t@t°RE",
"contenteraient" => "k§t@t°RE",
"contenterais" => "k§t@t°RE",
"contenterait" => "k§t@t°RE",
"contenteras" => "k§t@t°Ra",
"contentèrent" => "k§t@tER",
"contenterez" => "k§t@t°Re",
"contenteriez" => "k§t@t°Rje",
"contenterions" => "k§t@t°Rj§",
"contenterons" => "k§t@t°R§",
"contenteront" => "k§t@t°R§",
"contentes" => "k§t@t",
"contentés" => "k§t@te",
"contentez" => "k§t@te",
"contentieux" => "k§t@sj2",
"contentiez" => "k§t@tje",
"contention" => "k§t@sj§",
"contentions" => "k§t@tj§",
"contentons" => "k§t@t§",
"contents" => "k§t@",
"contenu" => "k§t°ny",
"contenue" => "k§t°ny",
"contenues" => "k§t°ny",
"contenus" => "k§t°ny",
"conter" => "k§te",
"contera" => "k§t°Ra",
"conterai" => "k§t°RE",
"conterait" => "k§t°RE",
"conteras" => "k§t°Ra",
"conterez" => "k§t°Re",
"conterons" => "k§t°R§",
"contes" => "k§t",
"contés" => "k§te",
"contesta" => "k§tEsta",
"contestable" => "k§tEstabl",
"contestables" => "k§tEstabl",
"contestaient" => "k§tEstE",
"contestais" => "k§tEstE",
"contestait" => "k§tEstE",
"contestant" => "k§tEst@",
"contestataire" => "k§tEstatER",
"contestataires" => "k§tEstatER",
"contestation" => "k§tEstasj§",
"contestations" => "k§tEstasj§",
"conteste" => "k§tEst",
"contesté" => "k§tEste",
"contestée" => "k§tEste",
"contestées" => "k§tEste",
"contestent" => "k§tEst",
"contester" => "k§tEste",
"contestera" => "k§tEst°Ra",
"contesterai" => "k§tEst°RE",
"contesterait" => "k§tEst°RE",
"contesteriez" => "k§tEst°Rje",
"contesterons" => "k§tEst°R§",
"contestes" => "k§tEst",
"contestés" => "k§tEste",
"contestez" => "k§tEste",
"contestiez" => "k§tEstje",
"contestons" => "k§tEst§",
"conteur" => "k§t9R",
"conteurs" => "k§t9R",
"conteuse" => "k§t2z",
"contexte" => "k§tEkst",
"contextes" => "k§tEkst",
"contextualiser" => "k§tEkst8alize",
"contextuel" => "k§tEkstyEl",
"contez" => "k§te",
"contiendra" => "k§tj5dRa",
"contiendrai" => "k§tj5dRE",
"contiendraient" => "k§tj5dRE",
"contiendrait" => "k§tj5dRE",
"contienne" => "k§tjEn",
"contiennent" => "k§tjEn",
"contiens" => "k§tj5",
"contient" => "k§tj5",
"contigu" => "k§tigy",
"contiguë" => "k§tigy",
"contiguës" => "k§tigy",
"contiguïté" => "k§tig8ite",
"contigus" => "k§tigy",
"continence" => "k§tin@s",
"continent" => "k§tin@",
"continental" => "k§tin@tal",
"continentale" => "k§tin@tal",
"continentales" => "k§tin@tal",
"continentaux" => "k§tin@to",
"continents" => "k§tin@",
"contingence" => "k§t5Z@s",
"contingences" => "k§t5Z@s",
"contingent" => "k§t5Z@",
"contingente" => "k§t5Z@t",
"contingenté" => "k§t5Z@te",
"contingentement" => "k§t5Z@t°m@",
"contingentes" => "k§t5Z@t",
"contingents" => "k§t5Z@",
"continrent" => "k§t5R",
"contins" => "k§t5",
"contint" => "k§t5",
"contînt" => "k§t5",
"continu" => "k§tiny",
"continua" => "k§tin8a",
"continuai" => "k§tin8E",
"continuaient" => "k§tin8E",
"continuais" => "k§tin8E",
"continuait" => "k§tin8E",
"continuâmes" => "k§tin8am",
"continuant" => "k§tin8@",
"continuassent" => "k§tin8as",
"continuât" => "k§tin8a",
"continuateur" => "k§tin8at9R",
"continuateurs" => "k§tin8at9R",
"continuation" => "k§tin8asj§",
"continue" => "k§tiny",
"continué" => "k§tin8e",
"continuée" => "k§tin8e",
"continuées" => "k§tin8e",
"continuel" => "k§tin8El",
"continuelle" => "k§tin8El",
"continuellement" => "k§tin8El°m@",
"continuelles" => "k§tin8El",
"continuels" => "k§tin8El",
"continuent" => "k§tiny",
"continuer" => "k§tin8e",
"continuera" => "k§tinyRa",
"continuerai" => "k§tinyRE",
"continueraient" => "k§tinyRE",
"continuerais" => "k§tinyRE",
"continuerait" => "k§tinyRE",
"continueras" => "k§tinyRa",
"continuèrent" => "k§tin8ER",
"continuerez" => "k§tinyRe",
"continueriez" => "k§tinyRje",
"continuerons" => "k§tinyR§",
"continueront" => "k§tinyR§",
"continues" => "k§tiny",
"continués" => "k§tin8e",
"continuez" => "k§tinye",
"continuiez" => "k§tinyje",
"continuions" => "k§tinyj§",
"continuité" => "k§tin8ite",
"continûment" => "k§tinym@",
"continuons" => "k§tin8§",
"continus" => "k§tiny",
"continuum" => "k§tin8Om",
"contions" => "k§tj§",
"contondant" => "k§t§d@",
"contondante" => "k§t§d@t",
"contondants" => "k§t§d@",
"contorsion" => "k§tORsj§",
"contorsionna" => "k§tORsijona",
"contorsionnaient" => "k§tORsjonE",
"contorsionnait" => "k§tORsijonE",
"contorsionnant" => "k§tORsijon@",
"contorsionne" => "k§tORsijOn",
"contorsionné" => "k§tORsijone",
"contorsionnée" => "k§tORsijone",
"contorsionnées" => "k§tORsijone",
"contorsionnent" => "k§tORsijOn",
"contorsionner" => "k§tORsjone",
"contorsionnés" => "k§tORsijone",
"contorsionniste" => "k§tORsjonist",
"contorsionnistes" => "k§tORsjonist",
"contorsions" => "k§tORsj§",
"contour" => "k§tuR",
"contourna" => "k§tuRna",
"contournai" => "k§tuRnE",
"contournaient" => "k§tuRnE",
"contournais" => "k§tuRnE",
"contournait" => "k§tuRnE",
"contournant" => "k§tuRn@",
"contourne" => "k§tuRn",
"contourné" => "k§tuRne",
"contournée" => "k§tuRne",
"contournées" => "k§tuRne",
"contournement" => "k§tuRn°m@",
"contournements" => "k§tuRn°m@",
"contournent" => "k§tuRn",
"contourner" => "k§tuRne",
"contournera" => "k§tuRn°Ra",
"contournerai" => "k§tuRn°RE",
"contournerais" => "k§tuRn°RE",
"contournèrent" => "k§tuRnER",
"contournerez" => "k§tuRn°Re",
"contournerons" => "k§tuRn°R§",
"contournes" => "k§tuRn",
"contournés" => "k§tuRne",
"contournez" => "k§tuRne",
"contournions" => "k§tuRnj§",
"contournons" => "k§tuRn§",
"contours" => "k§tuR",
"contra" => "k§tRa",
"contraceptif" => "k§tRasEptif",
"contraceptifs" => "k§tRasEptif",
"contraception" => "k§tRasEpsj§",
"contraceptive" => "k§tRasEptiv",
"contraceptives" => "k§tRasEptiv",
"contracta" => "k§tRakta",
"contractai" => "k§tRaktE",
"contractaient" => "k§tRaktE",
"contractais" => "k§tRaktE",
"contractait" => "k§tRaktE",
"contractant" => "k§tRakt@",
"contractantes" => "k§tRakt@t",
"contractants" => "k§tRakt@",
"contracte" => "k§tRakt",
"contracté" => "k§tRakte",
"contractée" => "k§tRakte",
"contractées" => "k§tRakte",
"contractent" => "k§tRakt",
"contracter" => "k§t°Rakte",
"contracterait" => "k§t°Rakt°RE",
"contractèrent" => "k§tRaktER",
"contractés" => "k§tRakte",
"contractez" => "k§tRakte",
"contractile" => "k§tRaktil",
"contraction" => "k§tRaksj§",
"contractions" => "k§tRaksj§",
"contractons" => "k§tRakt§",
"contractuel" => "k§tRakt8El",
"contractuelle" => "k§tRakt8El",
"contractuellement" => "k§tRakt8El°m@",
"contractuelles" => "k§tRakt8El",
"contractuels" => "k§tRakt8El",
"contracture" => "k§tRaktyR",
"contractures" => "k§tRaktyR",
"contradicteur" => "k§tRadikt9R",
"contradicteurs" => "k§tRadikt9R",
"contradiction" => "k§tRadiksj§",
"contradictions" => "k§tRadiksj§",
"contradictoire" => "k§tRadiktwaR",
"contradictoirement" => "k§tRadiktwaR°m@",
"contradictoires" => "k§tRadiktwaR",
"contraignaient" => "k§tRENE",
"contraignais" => "k§tRENE",
"contraignait" => "k§tRENE",
"contraignant" => "k§tREN@",
"contraignante" => "k§tREN@t",
"contraignantes" => "k§tREN@t",
"contraigne" => "k§tREN",
"contraignent" => "k§tREN",
"contraignit" => "k§tRENi",
"contraignît" => "k§tRENi",
"contraindra" => "k§tR5dRa",
"contraindrai" => "k§tR5dRE",
"contraindraient" => "k§tR5dRE",
"contraindrais" => "k§tR5dRE",
"contraindrait" => "k§tR5dRE",
"contraindre" => "k§tR5dR",
"contrains" => "k§tR5",
"contraint" => "k§tR5",
"contrainte" => "k§tR5t",
"contraintes" => "k§tR5t",
"contraints" => "k§tR5",
"contraire" => "k§tRER",
"contrairement" => "k§tRER°m@",
"contraires" => "k§tRER",
"contrait" => "k§tRE",
"contralto" => "k§tRalto",
"contraltos" => "k§tRalto",
"contrant" => "k§tR@",
"contrapunctique" => "k§tRap§ktik",
"contrapuntique" => "k§tRap§tik",
"contraria" => "k§tRaRja",
"contrariaient" => "k§tRaRjE",
"contrariais" => "k§tRaRjE",
"contrariait" => "k§tRaRjE",
"contrariant" => "k§tRaRj@",
"contrariante" => "k§tRaRj@t",
"contrariantes" => "k§tRaRj@t",
"contrariants" => "k§tRaRj@",
"contrariât" => "k§tRaRja",
"contrarie" => "k§tRaRi",
"contrarié" => "k§tRaRje",
"contrariée" => "k§tRaRje",
"contrariées" => "k§tRaRje",
"contrarient" => "k§tRaRi",
"contrarier" => "k§tRaRje",
"contrarierai" => "k§tRaRiRE",
"contrarierait" => "k§tRaRiRE",
"contrariés" => "k§tRaRje",
"contrariété" => "k§tRaRjete",
"contrariétés" => "k§tRaRjete",
"contrariez" => "k§tRaRje",
"contrarions" => "k§tRaRj§",
"contras" => "k§tRa",
"contrasta" => "k§tRasta",
"contrastaient" => "k§tRastE",
"contrastait" => "k§tRastE",
"contrastant" => "k§tRast@",
"contrastât" => "k§tRasta",
"contraste" => "k§tRast",
"contrasté" => "k§tRaste",
"contrastée" => "k§tRaste",
"contrastées" => "k§tRaste",
"contrastent" => "k§tRast",
"contraster" => "k§t°Raste",
"contrasteraient" => "k§t°Rast°RE",
"contrasterait" => "k§t°Rast°RE",
"contrastes" => "k§tRast",
"contrastés" => "k§tRaste",
"contrastez" => "k§tRaste",
"contrat" => "k§tRa",
"contrat-type" => "k§tRatip",
"contrats" => "k§tRa",
"contravention" => "k§tRav@sj§",
"contraventions" => "k§tRav@sj§",
"contre" => "k§tR",
"contré" => "k§tRe",
"contre-accusations" => "k§tRakyzasj§",
"contre-alizés" => "k§tRalize",
"contre-allée" => "k§tRale",
"contre-allées" => "k§tRale",
"contre-amiral" => "k§tRamiRal",
"contre-appel" => "k§tRapEl",
"contre-assurance" => "k§tRasyR@s",
"contre-attaqua" => "k§tRataka",
"contre-attaquaient" => "k§tRatakE",
"contre-attaquait" => "k§tRatakE",
"contre-attaquant" => "k§tRatak@",
"contre-attaque" => "k§tRatak",
"contre-attaqué" => "k§tRatake",
"contre-attaquent" => "k§tRatak",
"contre-attaquer" => "k§tRatake",
"contre-attaquera" => "k§tRatak°Ra",
"contre-attaquèrent" => "k§tRatakER",
"contre-attaquerons" => "k§tRatak°R§",
"contre-attaques" => "k§tRatak",
"contre-attaquons" => "k§tRatak§",
"contre-champ" => "k§tR°S@",
"contre-chant" => "k§tR°S@",
"contre-chocs" => "k§tR°SOk",
"contre-clés" => "k§tR°kle",
"contre-courant" => "k§tR°kuR@",
"contre-culture" => "k§tR°kyltyR",
"contre-emploi" => "k§tR@plwa",
"contre-épreuve" => "k§tRepR9v",
"contre-épreuves" => "k§tRepR9v",
"contre-espionnage" => "k§tREspjonaZ",
"contre-exemple" => "k§tREgz@pl",
"contre-expertise" => "k§tREkspERtiz",
"contre-expertises" => "k§tREkspERtiz",
"contre-feu" => "k§tR2f2",
"contre-feux" => "k§tR°f2",
"contre-fiches" => "k§tR°fiS",
"contre-fil" => "k§tR°fil",
"contre-gré" => "k§tR2gRe",
"contre-indication" => "k§tR5dikasj§",
"contre-indications" => "k§tR5dikasj§",
"contre-indiqué" => "k§tR5dike",
"contre-interrogatoire" => "k§t°R5tERogatwaR",
"contre-interrogatoires" => "k§t°R5tERogatwaR",
"contre-jour" => "k§tR°ZuR",
"contre-la-montre" => "k§tR2lam§tR",
"contre-lame" => "k§tR°lam",
"contre-lettre" => "k§tR°lEtR",
"contre-manifestants" => "k§tR°manifEst@",
"contre-manifestent" => "k§tR°manifEst",
"contre-mesure" => "k§tR2m2zyR",
"contre-mesures" => "k§tR°m°zyR",
"contre-mine" => "k§tR°min",
"contre-miné" => "k§tR°mine",
"contre-mines" => "k§tR°min",
"contre-nature" => "k§tR°natyR",
"contre-offensive" => "k§tRof@siv",
"contre-offensives" => "k§tRof@siv",
"contre-ordre" => "k§tRORdR",
"contre-ordres" => "k§tRORdR",
"contre-pente" => "k§tR°p@t",
"contre-performance" => "k§tR2pERfORm@s",
"contre-performances" => "k§tR°pERfORm@s",
"contre-pied" => "k§tR°pje",
"contre-pieds" => "k§tR°pje",
"contre-plaqué" => "k§tR°plake",
"contre-plongée" => "k§tR°pl§Ze",
"contre-pouvoirs" => "k§tR°puvwaR",
"contre-pression" => "k§tR°pREsj§",
"contre-productif" => "k§tR2pROdyktif",
"contre-productive" => "k§tR2pROdyktiv",
"contre-propagande" => "k§tR°pRopag@d",
"contre-proposition" => "k§tR°pRopozisj§",
"contre-propositions" => "k§tR°pRopozisj§",
"contre-réaction" => "k§tR°Reaksj§",
"contre-réforme" => "k§tR°RefORm",
"contre-révolution" => "k§tR°Revolysj§",
"contre-révolutionnaire" => "k§tR°RevolysjonER",
"contre-révolutionnaires" => "k§tR°RevolysjonER",
"contre-terrorisme" => "k§t°R°tERORism",
"contre-terroriste" => "k§t°R°tERoRist",
"contre-test" => "k§tR°tEst",
"contre-torpilleur" => "k§tR°tORpij9R",
"contre-torpilleurs" => "k§tR°tORpij9R",
"contre-transfert" => "k§tR2tR@sfER",
"contre-ut" => "k§tR°yt",
"contre-vérité" => "k§tR°veRite",
"contre-voie" => "k§tR°vwa",
"contrebalançais" => "k§tR°bal@sE",
"contrebalançait" => "k§tR°bal@sE",
"contrebalance" => "k§tR°bal@s",
"contrebalancé" => "k§tR2bal@se",
"contrebalancée" => "k§tR°bal@se",
"contrebalancer" => "k§tR°bal@se",
"contrebalancés" => "k§tR°bal@se",
"contrebande" => "k§tR°b@d",
"contrebandier" => "k§tR°b@dje",
"contrebandière" => "k§tR°b@djER",
"contrebandiers" => "k§tR°b@dje",
"contrebas" => "k§tR°ba",
"contrebasse" => "k§tR°bas",
"contrebasses" => "k§tR°bas",
"contrebassiste" => "k§tR°basist",
"contrebassistes" => "k§tR°basist",
"contrebraque" => "k§tR°bRak",
"contrecarraient" => "k§tR°kaRE",
"contrecarrais" => "k§tR°kaRE",
"contrecarre" => "k§tR°kaR",
"contrecarré" => "k§tR°kaRe",
"contrecarrée" => "k§tR°kaRe",
"contrecarrer" => "k§tR°kaRe",
"contrecarres" => "k§tR°kaR",
"contrechamp" => "k§tR°S@",
"contrechamps" => "k§tR°S@",
"contrecoeur" => "k§tR°k9R",
"contrecollé" => "k§tR°kole",
"contrecoup" => "k§tR°ku",
"contrecoups" => "k§tR°ku",
"contredanse" => "k§tR°d@s",
"contredanses" => "k§tR°d@s",
"contredira" => "k§tR°diRa",
"contredirai" => "k§tR°diRE",
"contrediraient" => "k§tR°diRE",
"contredirait" => "k§tR°diRE",
"contredire" => "k§tR°diR",
"contredirez" => "k§tR°diRe",
"contredis" => "k§tR°di",
"contredisaient" => "k§tR°dizE",
"contredisait" => "k§tR°dizE",
"contredisant" => "k§tR°diz@",
"contredise" => "k§tR°diz",
"contredisent" => "k§tR°diz",
"contredises" => "k§tR°diz",
"contredisez" => "k§tR°dize",
"contredit" => "k§tR°di",
"contredît" => "k§tR°di",
"contredite" => "k§tR°dit",
"contredites" => "k§tR°dit",
"contredits" => "k§tR°di",
"contrée" => "k§tRe",
"contrées" => "k§tRe",
"contrefaçon" => "k§tR°fas§",
"contrefaçons" => "k§tR°fas§",
"contrefacteurs" => "k§tR°fakt9R",
"contrefaire" => "k§tR°fER",
"contrefaisait" => "k§tR°f°zE",
"contrefaisant" => "k§tR°f°z@",
"contrefait" => "k§tR°fE",
"contrefaite" => "k§tR°fEt",
"contrefaits" => "k§tR°fE",
"contreferait" => "k§tR°f°RE",
"contrefichais" => "k§tR°fiSE",
"contrefichait" => "k§tR°fiSE",
"contrefiche" => "k§tR°fiS",
"contrefort" => "k§tR°fOR",
"contreforts" => "k§tR°fOR",
"contrefous" => "k§tR°fu",
"contrefout" => "k§tR°fu",
"contrefoutait" => "k§tR°futE",
"contrefoutre" => "k§tR°futR",
"contremaître" => "k§tR°mEtR",
"contremaîtres" => "k§tR°mEtR",
"contremaîtresse" => "k§tR°mEtREs",
"contremander" => "k§tR°m@de",
"contremarches" => "k§tR°maRS",
"contremarques" => "k§tR°maRk",
"contrent" => "k§tR",
"contrepartie" => "k§tR°paRti",
"contrepèterie" => "k§tR°pEt°Ri",
"contrepèteries" => "k§tR°pEt°Ri",
"contreplaqué" => "k§tR°plake",
"contrepoids" => "k§tR°pwa",
"contrepoint" => "k§tR°pw5",
"contrepoison" => "k§tR°pwaz§",
"contrepoisons" => "k§tR°pwaz§",
"contreproposition" => "k§tR°pROpozisj§",
"contrer" => "k§tRe",
"contrerai" => "k§tR°RE",
"contrerait" => "k§tR°RE",
"contreras" => "k§tR°Ra",
"contreront" => "k§tR°R§",
"contres" => "k§tR",
"contrés" => "k§tRe",
"contrescarpe" => "k§tREskaRp",
"contreseing" => "k§tR°s5",
"contresens" => "k§tR°s@s",
"contresignait" => "k§tR°siNE",
"contresigne" => "k§tR°siN",
"contresigné" => "k§tR°siNe",
"contresignée" => "k§tR°siNe",
"contresignées" => "k§tR°siNe",
"contresigner" => "k§tR°siNe",
"contresignés" => "k§tR°siNe",
"contretemps" => "k§tR°t@",
"contretypés" => "k§tR°tipe",
"contrevallation" => "k§tR2valasj§",
"contrevenaient" => "k§tR°v°nE",
"contrevenait" => "k§tR°v°nE",
"contrevenant" => "k§tR°v°n@",
"contrevenants" => "k§tR°v°n@",
"contrevenez" => "k§tR°v°ne",
"contrevenir" => "k§tR°v°niR",
"contrevent" => "k§tR°v@",
"contrevents" => "k§tR°v@",
"contrevenu" => "k§tR°v°ny",
"contrevérité" => "k§tR°veRite",
"contrevérités" => "k§tR°veRite",
"contreviendrait" => "k§tR°vj5dRE",
"contreviens" => "k§tR°vj5",
"contrevient" => "k§tR°vj5",
"contribua" => "k§tRib8a",
"contribuable" => "k§tRib8abl",
"contribuables" => "k§tRib8abl",
"contribuaient" => "k§tRib8E",
"contribuait" => "k§tRib8E",
"contribuant" => "k§tRib8@",
"contribuât" => "k§tRib8a",
"contribue" => "k§tRiby",
"contribué" => "k§tRib8e",
"contribuent" => "k§tRiby",
"contribuer" => "k§tRib8e",
"contribuera" => "k§tRibyRa",
"contribueraient" => "k§tRibyRE",
"contribuerais" => "k§tRibyRE",
"contribuerait" => "k§tRibyRE",
"contribueras" => "k§tRibyRa",
"contribuèrent" => "k§tRib8ER",
"contribuerez" => "k§tRibyRe",
"contribueront" => "k§tRibyR§",
"contribuez" => "k§tRibye",
"contribuons" => "k§tRib8§",
"contributeur" => "k§tRibyt9R",
"contribution" => "k§tRibysj§",
"contributions" => "k§tRibysj§",
"contrista" => "k§tRista",
"contristant" => "k§tRist@",
"contristées" => "k§tRiste",
"contrit" => "k§tRi",
"contrite" => "k§tRit",
"contrites" => "k§tRit",
"contrition" => "k§tRisj§",
"contritions" => "k§tRisj§",
"contrits" => "k§tRi",
"control" => "k§tRol",
"contrôla" => "k§tRola",
"contrôlable" => "k§tRolabl",
"contrôlables" => "k§tRolabl",
"contrôlai" => "k§tRolE",
"contrôlaient" => "k§tRolE",
"contrôlais" => "k§tRolE",
"contrôlait" => "k§tRolE",
"contrôlâmes" => "k§tRolam",
"contrôlant" => "k§tRol@",
"contrôle" => "k§tRol",
"contrôlé" => "k§tRole",
"contrôlée" => "k§tRole",
"contrôlées" => "k§tRole",
"contrôlent" => "k§tRol",
"contrôler" => "k§tRole",
"contrôlera" => "k§tRol°Ra",
"contrôlerai" => "k§tRol°RE",
"contrôlerais" => "k§tRol°RE",
"contrôlerait" => "k§tRol°RE",
"contrôleras" => "k§tRol°Ra",
"contrôlèrent" => "k§tRolER",
"contrôlerez" => "k§tRol°Re",
"contrôleriez" => "k§tRol°Rje",
"contrôlerons" => "k§tRol°R§",
"contrôleront" => "k§tRol°R§",
"contrôles" => "k§tRol",
"contrôlés" => "k§tRole",
"contrôleur" => "k§tRol9R",
"contrôleurs" => "k§tRol9R",
"contrôleuse" => "k§tRol2z",
"contrôlez" => "k§tRole",
"contrôliez" => "k§tRolje",
"contrôlions" => "k§tRolj§",
"contrôlons" => "k§tRol§",
"contrordre" => "k§tRORdR",
"contrordres" => "k§tRORdR",
"controverse" => "k§tRovERs",
"controversé" => "k§tRovERse",
"controversée" => "k§tRovERse",
"controversées" => "k§tRovERse",
"controverses" => "k§tRovERs",
"controversés" => "k§tRovERse",
"contumace" => "k§tymas",
"contumaces" => "k§tymas",
"contumax" => "k§tymaks",
"contuse" => "k§tyz",
"contusion" => "k§tyzj§",
"contusionné" => "k§tyzjone",
"contusionnée" => "k§tyzjone",
"contusionnés" => "k§tyzjone",
"contusions" => "k§tyzj§",
"convainc" => "k§v5",
"convaincant" => "k§v5k@",
"convaincante" => "k§v5k@t",
"convaincantes" => "k§v5k@t",
"convaincants" => "k§v5k@",
"convaincra" => "k§v5kRa",
"convaincrai" => "k§v5kRE",
"convaincrait" => "k§v5kRE",
"convaincras" => "k§v5kRa",
"convaincre" => "k§v5kR",
"convaincrez" => "k§v5kRe",
"convaincrons" => "k§v5kR§",
"convaincront" => "k§v5kR§",
"convaincs" => "k§v5",
"convaincu" => "k§v5ky",
"convaincue" => "k§v5ky",
"convaincues" => "k§v5ky",
"convaincus" => "k§v5ky",
"convainquaient" => "k§v5kE",
"convainquait" => "k§v5kE",
"convainquant" => "k§v5k@",
"convainque" => "k§v5k",
"convainquent" => "k§v5k",
"convainques" => "k§v5k",
"convainquez" => "k§v5ke",
"convainquiez" => "k§v5kje",
"convainquirent" => "k§v5kiR",
"convainquis" => "k§v5ki",
"convainquit" => "k§v5ki",
"convainquons" => "k§v5k§",
"convalescence" => "k§vales@s",
"convalescences" => "k§vales@s",
"convalescent" => "k§vales@",
"convalescente" => "k§vales@t",
"convalescentes" => "k§valEs@t",
"convalescents" => "k§valEs@",
"convalo" => "k§valo",
"convalos" => "k§valo",
"convecteur" => "k§vEkt9R",
"convection" => "k§vEksj§",
"convenable" => "k§v°nabl",
"convenablement" => "k§v°nabl°m@",
"convenables" => "k§v°nabl",
"convenaient" => "k§v°nE",
"convenais" => "k§v°nE",
"convenait" => "k§v°nE",
"convenance" => "k§v°n@s",
"convenances" => "k§v°n@s",
"convenant" => "k§v°n@",
"convenez" => "k§v°ne",
"conveniez" => "k§v°nje",
"convenir" => "k§v°niR",
"convenons" => "k§v°n§",
"convent" => "k§v@",
"conventicule" => "k§v@tikyl",
"convention" => "k§v@sj§",
"conventionnée" => "k§v@sjOne",
"conventionnel" => "k§v@sjonEl",
"conventionnelle" => "k§v@sjonEl",
"conventionnellement" => "k§v@sjonEl°m@",
"conventionnelles" => "k§v@sjonEl",
"conventionnels" => "k§v@sjonEl",
"conventions" => "k§v@sj§",
"conventuel" => "k§v@t8El",
"conventuelle" => "k§v@t8El",
"conventuellement" => "k§v@t8El°m@",
"conventuelles" => "k§v@t8El",
"conventuels" => "k§v@t8El",
"convenu" => "k§v°ny",
"convenue" => "k§v°ny",
"convenues" => "k§v°ny",
"convenus" => "k§v°ny",
"converge" => "k§vERZ",
"convergé" => "k§vERZe",
"convergeaient" => "k§vERZE",
"convergeait" => "k§vERZE",
"convergeant" => "k§vERZ@",
"convergence" => "k§vERZ@s",
"convergent" => "k§vERZ",
"convergente" => "k§vERZ@t",
"convergentes" => "k§vERZ@t",
"convergents" => "k§vERZ@",
"convergeons" => "k§vERZ§",
"converger" => "k§vERZe",
"convergeraient" => "k§vERZ°RE",
"convergèrent" => "k§vERZER",
"convergez" => "k§vERZe",
"convers" => "k§vER",
"conversaient" => "k§vERsE",
"conversais" => "k§vERsE",
"conversait" => "k§vERsE",
"conversâmes" => "k§vERsam",
"conversant" => "k§vERs@",
"conversation" => "k§vERsasj§",
"conversations" => "k§vERsasj§",
"converse" => "k§vERs",
"conversé" => "k§vERse",
"conversent" => "k§vERs",
"converser" => "k§vERse",
"conversèrent" => "k§vERsER",
"converses" => "k§vERs",
"conversez" => "k§vERse",
"conversiez" => "k§vERsje",
"conversion" => "k§vERsj§",
"conversions" => "k§vERsj§",
"conversons" => "k§vERs§",
"converti" => "k§vERti",
"convertible" => "k§vERtibl",
"convertibles" => "k§vERtibl",
"convertie" => "k§vERti",
"converties" => "k§vERti",
"convertir" => "k§vERtiR",
"convertira" => "k§vERtiRa",
"convertirai" => "k§vERtiRE",
"convertirais" => "k§vERtiRE",
"convertirait" => "k§vERtiRE",
"convertirons" => "k§vERtiR§",
"convertis" => "k§vERti",
"convertissaient" => "k§vERtisE",
"convertissais" => "k§vERtisE",
"convertissait" => "k§vERtisE",
"convertissant" => "k§vERtis@",
"convertisse" => "k§vERtis",
"convertissent" => "k§vERtis",
"convertisseur" => "k§vERtis9R",
"convertisseurs" => "k§vERtis9R",
"convertissez" => "k§vERtise",
"convertissions" => "k§vERtisj§",
"convertit" => "k§vERti",
"convertît" => "k§vERti",
"convexe" => "k§vEks",
"convexes" => "k§vEks",
"convexité" => "k§vEksite",
"convia" => "k§vja",
"conviaient" => "k§vjE",
"conviais" => "k§vjE",
"conviait" => "k§vjE",
"conviant" => "k§vj@",
"convict" => "k§vikt",
"conviction" => "k§viksj§",
"convictions" => "k§viksj§",
"convicts" => "k§vikt",
"convie" => "k§vi",
"convié" => "k§vje",
"conviée" => "k§vje",
"conviées" => "k§vje",
"conviendra" => "k§vj5dRa",
"conviendrai" => "k§vj5dRE",
"conviendraient" => "k§vj5dRE",
"conviendrais" => "k§vj5dRE",
"conviendrait" => "k§vj5dRE",
"conviendras" => "k§vj5dRa",
"conviendrez" => "k§vj5dRe",
"conviendrions" => "k§vj5dRij§",
"conviendrons" => "k§vj5dR§",
"conviendront" => "k§vj5dR§",
"convienne" => "k§vjEn",
"conviennent" => "k§vjEn",
"conviens" => "k§vj5",
"convient" => "k§vj5",
"convier" => "k§vje",
"conviera" => "k§viRa",
"convierai" => "k§viRE",
"convierait" => "k§viRE",
"convièrent" => "k§vjER",
"conviés" => "k§vje",
"conviez" => "k§vje",
"convînmes" => "k§v5m",
"convinrent" => "k§v5R",
"convins" => "k§v5",
"convint" => "k§v5",
"convînt" => "k§v5",
"convions" => "k§vj§",
"convive" => "k§viv",
"convives" => "k§viv",
"convivial" => "k§vivjal",
"conviviale" => "k§vivjal",
"conviviales" => "k§vivjal",
"convivialisez" => "k§vivjalize",
"convivialité" => "k§vivjalite",
"conviviaux" => "k§vivjo",
"convocable" => "k§vOkabl",
"convocation" => "k§vokasj§",
"convocations" => "k§vokasj§",
"convoi" => "k§vwa",
"convoie" => "k§vwa",
"convois" => "k§vwa",
"convoita" => "k§vwata",
"convoitaient" => "k§vwatE",
"convoitais" => "k§vwatE",
"convoitait" => "k§vwatE",
"convoitant" => "k§vwat@",
"convoite" => "k§vwat",
"convoité" => "k§vwate",
"convoitée" => "k§vwate",
"convoitées" => "k§vwate",
"convoitent" => "k§vwat",
"convoiter" => "k§vwate",
"convoiteras" => "k§vwat°Ra",
"convoiteront" => "k§vwat°R§",
"convoités" => "k§vwate",
"convoiteur" => "k§vwat9R",
"convoiteux" => "k§vwat2",
"convoitez" => "k§vwate",
"convoitise" => "k§vwatiz",
"convoitises" => "k§vwatiz",
"convola" => "k§vola",
"convolait" => "k§volE",
"convolant" => "k§vol@",
"convolé" => "k§vole",
"convolent" => "k§vol",
"convoler" => "k§vole",
"convolèrent" => "k§volER",
"convoqua" => "k§voka",
"convoquai" => "k§vokE",
"convoquaient" => "k§vokE",
"convoquait" => "k§vokE",
"convoquant" => "k§vok@",
"convoquât" => "k§voka",
"convoque" => "k§vOk",
"convoqué" => "k§voke",
"convoquée" => "k§voke",
"convoquées" => "k§voke",
"convoquent" => "k§vOk",
"convoquer" => "k§voke",
"convoquera" => "k§vOk°Ra",
"convoquerai" => "k§vOk°RE",
"convoqueraient" => "k§vOk°RE",
"convoquerait" => "k§vOk°RE",
"convoquèrent" => "k§vokER",
"convoquerez" => "k§vOk°Re",
"convoqueront" => "k§vOk°R§",
"convoqués" => "k§voke",
"convoquez" => "k§voke",
"convoquions" => "k§vokj§",
"convoquons" => "k§vok§",
"convoya" => "k§vwaja",
"convoyage" => "k§vwajaZ",
"convoyages" => "k§vwajaZ",
"convoyaient" => "k§vwajE",
"convoyait" => "k§vwajE",
"convoyant" => "k§vwaj@",
"convoyé" => "k§vwaje",
"convoyée" => "k§vwaje",
"convoyer" => "k§vwaje",
"convoyés" => "k§vwaje",
"convoyeur" => "k§vwaj9R",
"convoyeurs" => "k§vwaj9R",
"convoyeuse" => "k§vwaj2z",
"convulsa" => "k§vylsa",
"convulsai" => "k§vylsE",
"convulsais" => "k§vylsE",
"convulsait" => "k§vylsE",
"convulsant" => "k§vyls@",
"convulse" => "k§vyls",
"convulsé" => "k§vylse",
"convulsée" => "k§vylse",
"convulsées" => "k§vylse",
"convulser" => "k§vylse",
"convulsés" => "k§vylse",
"convulsif" => "k§vylsif",
"convulsifs" => "k§vylsif",
"convulsion" => "k§vylsj§",
"convulsionnaire" => "k§vylsjonER",
"convulsionne" => "k§vylsjOn",
"convulsionnée" => "k§vylsjone",
"convulsions" => "k§vylsj§",
"convulsive" => "k§vylsiv",
"convulsivement" => "k§vylsiv°m@",
"convulsives" => "k§vylsiv",
"cooccupant" => "kookyp@",
"cookie" => "kuki",
"cookies" => "kukiz",
"cool" => "kul",
"coolie" => "kuli",
"coolie-pousse" => "kulipus",
"coolies" => "kuli",
"coolos" => "kulos",
"coopé" => "koope",
"coopérais" => "koopeRE",
"coopérait" => "koopeRE",
"coopérant" => "koopeR@",
"coopérante" => "koopeR@t",
"coopérants" => "koopeR@",
"coopérateur" => "kOOpeRat9R",
"coopératif" => "koopeRatif",
"coopératifs" => "koopeRatif",
"coopération" => "koopeRasj§",
"coopératisme" => "kOOpeRatism",
"coopérative" => "koopeRativ",
"coopératives" => "koopeRativ",
"coopère" => "koopER",
"coopéré" => "koopeRe",
"coopèrent" => "koopER",
"coopérer" => "koopeRe",
"coopérera" => "koopeR°Ra",
"coopérerai" => "koopeR°RE",
"coopéreraient" => "koopeR°RE",
"coopérerais" => "koopeR°RE",
"coopérerez" => "koopeR°Re",
"coopéreriez" => "koopeR°Rje",
"coopérerons" => "koopeR°R§",
"coopéreront" => "koopeR°R§",
"coopères" => "koopER",
"coopérez" => "koopeRe",
"coopériez" => "koopeRje",
"coopérions" => "koopeRj§",
"coopérons" => "koopeR§",
"cooptant" => "kOOpt@",
"cooptation" => "koOptasj§",
"coopté" => "kOOpte",
"coopter" => "koOpte",
"coordinateur" => "koORdinat9R",
"coordinateurs" => "koORdinat9R",
"coordination" => "koORdinasj§",
"coordinatrice" => "koORdinatRis",
"coordonna" => "koORdona",
"coordonnaient" => "koORdonE",
"coordonnait" => "koORdonE",
"coordonnant" => "kOORdOn@",
"coordonnateur" => "kOORdOnat9R",
"coordonne" => "koORdOn",
"coordonné" => "koORdone",
"coordonnée" => "koORdone",
"coordonnées" => "koORdone",
"coordonner" => "koORdone",
"coordonnera" => "koORdOn°Ra",
"coordonnerait" => "koORdOn°RE",
"coordonnés" => "koORdone",
"coordonnez" => "koORdone",
"coordonnons" => "koORdon§",
"cop" => "kOp",
"copaïba" => "kopaiba",
"copain" => "kop5",
"copains" => "kop5",
"copal" => "kOpal",
"copeau" => "kopo",
"copeaux" => "kopo",
"copernicienne" => "kopERnisjEn",
"copia" => "kopja",
"copiable" => "kopjabl",
"copiage" => "kOpjaZ",
"copiai" => "kopjE",
"copiaient" => "kopjE",
"copiais" => "kopjE",
"copiait" => "kopjE",
"copiant" => "kopj@",
"copie" => "kopi",
"copié" => "kopje",
"copiée" => "kopje",
"copiées" => "kopje",
"copient" => "kopi",
"copier" => "kopje",
"copiera" => "kopiRa",
"copierai" => "kopiRE",
"copierait" => "kopiRE",
"copieras" => "kopiRa",
"copierez" => "kopiRe",
"copieront" => "kopiR§",
"copies" => "kopi",
"copiés" => "kopje",
"copieur" => "kopj9R",
"copieurs" => "kopj9R",
"copieuse" => "kopj2z",
"copieusement" => "kopj2z°m@",
"copieuses" => "kopj2z",
"copieux" => "kopj2",
"copiez" => "kopje",
"copilote" => "kopilOt",
"copinage" => "kopinaZ",
"copinait" => "kopinE",
"copine" => "kopin",
"copiné" => "kopine",
"copiner" => "kopine",
"copines" => "kopin",
"copineur" => "kopin9R",
"copineurs" => "kopin9R",
"copineuse" => "kopin2z",
"copiniez" => "kopinje",
"copiste" => "kopist",
"copistes" => "kopist",
"copla" => "kopla",
"coppa" => "kOpa",
"copra" => "kopRa",
"coprésidence" => "kopRezid@s",
"coprésident" => "kOpRezid",
"coprins" => "kopR5",
"coproculture" => "kOpROkyltyR",
"coproducteur" => "kopRodykt9R",
"coproducteurs" => "kopRodykt9R",
"coproduction" => "kopRodyksj§",
"coproduire" => "kopRod8iR",
"coproduit" => "kopRod8i",
"coprologie" => "kopRoloZi",
"coprologique" => "kopRoloZik",
"coprophage" => "kopRofaZ",
"coprophagie" => "kopRofaZi",
"coprophile" => "kopRofil",
"coprophilie" => "kOpROfili",
"copropriétaire" => "kopRopRijetER",
"copropriétaires" => "kopRopRijetER",
"copropriété" => "kopRopRijete",
"cops" => "kOp",
"copte" => "kOpt",
"coptes" => "kOpt",
"copula" => "kopyla",
"copulait" => "kopylE",
"copulant" => "kopyl@",
"copulation" => "kopylasj§",
"copulations" => "kopylasj§",
"copule" => "kopyl",
"copulé" => "kopyle",
"copulent" => "kopyl",
"copuler" => "kopyle",
"copulez" => "kopyle",
"copyright" => "kopiRajt",
"coq" => "kOk",
"coq-à-l'âne" => "kOkalan",
"coqs" => "kOk",
"coquard" => "kokaR",
"coquards" => "kokaR",
"coquart" => "kokaR",
"coquarts" => "kokaR",
"coque" => "kOk",
"coquebin" => "kOk°b5",
"coquelet" => "kOk°lE",
"coquelicot" => "kOk°liko",
"coquelicots" => "kOk°liko",
"coquelle" => "kokEl",
"coqueluche" => "kOk°lyS",
"coqueluches" => "kOk°lyS",
"coquemar" => "kOk°maR",
"coquerelle" => "kOk°REl",
"coquerie" => "kOk°Ri",
"coqueron" => "kOk°R§",
"coques" => "kOk",
"coquet" => "kokE",
"coquetel" => "kOk°tEl",
"coqueter" => "kOk°te",
"coquetier" => "kOk°tje",
"coquetiers" => "kOk°tje",
"coquets" => "kokE",
"coquette" => "kokEt",
"coquettement" => "kokEt°m@",
"coquetterie" => "kokEt°Ri",
"coquetteries" => "kokEt°Ri",
"coquettes" => "kokEt",
"coquillage" => "kokijaZ",
"coquillages" => "kokijaZ",
"coquillard" => "kokijaR",
"coquillards" => "kokijaR",
"coquillart" => "kokijaR",
"coquille" => "kokij",
"coquilles" => "kokij",
"coquillettes" => "kokijEt",
"coquilleux" => "kokij2",
"coquin" => "kok5",
"coquine" => "kokin",
"coquinement" => "kokin°m@",
"coquinerie" => "kokin°Ri",
"coquineries" => "kokin°Ri",
"coquines" => "kokin",
"coquinet" => "kokinE",
"coquins" => "kok5",
"cor" => "kOR",
"cora" => "koRa",
"corail" => "koRaj",
"coralliaires" => "koRaljER",
"corallien" => "kORalj5",
"coralliens" => "koRalj5",
"coramine" => "kORamin",
"coran" => "koR@",
"coranique" => "koRanik",
"coraniques" => "koRanik",
"coras" => "koRa",
"coraux" => "koRo",
"corbeau" => "kORbo",
"corbeaux" => "kORbo",
"corbeille" => "kORbEj",
"corbeilles" => "kORbEj",
"corbières" => "kORbjER",
"corbillard" => "kORbijaR",
"corbillards" => "kORbijaR",
"corbin" => "kORb5",
"cordage" => "kORdaZ",
"cordages" => "kORdaZ",
"corde" => "kORd",
"cordé" => "kORde",
"cordeau" => "kORdo",
"cordeaux" => "kORdo",
"cordée" => "kORde",
"cordées" => "kORde",
"cordelette" => "kORd°lEt",
"cordelettes" => "kORd°lEt",
"cordelier" => "kORd°lje",
"cordelière" => "kORd°ljER",
"cordelières" => "kORd°ljER",
"cordeliers" => "kORd°lje",
"cordelle" => "kORdEl",
"corder" => "kORde",
"corderie" => "kORd°Ri",
"cordes" => "kORd",
"cordés" => "kORde",
"cordial" => "kORdjal",
"cordiale" => "kORdjal",
"cordialement" => "kORdjal°m@",
"cordiales" => "kORdjal",
"cordialité" => "kORdjalite",
"cordialités" => "kORdjalite",
"cordiaux" => "kORdjo",
"cordiers" => "kORdje",
"cordiforme" => "kORdifORm",
"cordiformes" => "kORdifORm",
"cordillère" => "kORdijER",
"cordite" => "kORdit",
"cordobas" => "kORdoba",
"cordon" => "kORd§",
"cordon-bleu" => "kORd§bl2",
"cordonnées" => "kORdone",
"cordonner" => "kORdOne",
"cordonnerie" => "kORdOn°Ri",
"cordonnet" => "kORdonE",
"cordonnets" => "kORdonE",
"cordonnier" => "kORdonje",
"cordonnière" => "kORdonjER",
"cordonniers" => "kORdonje",
"cordons" => "kORd§",
"cordons-bleus" => "kORd§bl2",
"cordouan" => "kORdu@",
"coré" => "koRe",
"coréen" => "koRe5",
"coréenne" => "koReEn",
"coréennes" => "koReEn",
"coréens" => "koRe5",
"coreligionnaires" => "koR°liZjonER",
"corelliens" => "koRElj5",
"coriace" => "koRjas",
"coriaces" => "koRjas",
"coriacité" => "koRjasite",
"coriandre" => "koRj@dR",
"corindon" => "koR5d§",
"corinthe" => "kOR5t",
"corinthien" => "koR5tj5",
"corinthiennes" => "koR5tjEn",
"corinthiens" => "koR5tj5",
"cormier" => "kORmje",
"cormoran" => "kORmoR@",
"cormorans" => "kORmoR@",
"corn flakes" => "kORnflEks",
"corn-flakes" => "kORnflEks",
"corna" => "kORna",
"cornac" => "kORnak",
"cornaient" => "kORnE",
"cornais" => "kORnE",
"cornait" => "kORnE",
"cornaline" => "kORnalin",
"cornalines" => "kORnalin",
"cornant" => "kORn@",
"cornaquaient" => "kORnakE",
"cornaquée" => "kORnake",
"cornard" => "kORnaR",
"cornards" => "kORnaR",
"cornas" => "kORna",
"corne" => "kORn",
"corné" => "kORne",
"cornecul" => "kORn°ky",
"cornée" => "kORne",
"cornéen" => "kORne5",
"cornéenne" => "kORneEn",
"cornées" => "kORne",
"corneille" => "kORnEj",
"corneilles" => "kORnEj",
"cornélien" => "kORnelj5",
"cornélienne" => "kORneljEn",
"cornéliennes" => "kORneljEn",
"cornemuse" => "kORn°myz",
"cornemuses" => "kORn°myz",
"cornemuseur" => "kORn°myz9R",
"cornent" => "kORn",
"corner" => "koRne",
"cornèrent" => "kORnER",
"corners" => "kORnER",
"cornes" => "kORn",
"cornés" => "kORne",
"cornet" => "kORnE",
"cornets" => "kORnE",
"cornette" => "kORnEt",
"cornettes" => "kORnEt",
"corniaud" => "kORnjo",
"corniauds" => "kORnjo",
"corniche" => "kORniS",
"corniches" => "kORniS",
"cornichon" => "kORniS§",
"cornichons" => "kORniS§",
"cornières" => "kORnjER",
"cornillon" => "kORnij§",
"cornistes" => "kORnist",
"cornouaillais" => "kORnuajE",
"cornouille" => "kORnuj",
"cornouiller" => "kORnuje",
"cornouillers" => "kORnuje",
"cornouilles" => "kORnuj",
"cornu" => "kORny",
"cornue" => "kORny",
"cornues" => "kORny",
"cornus" => "kORny",
"corollaire" => "koRolER",
"corollaires" => "koRolER",
"corolle" => "koROl",
"corolles" => "koROl",
"coron" => "koR§",
"corona" => "koRona",
"coronaire" => "koRonER",
"coronaires" => "koRonER",
"coronal" => "koRonal",
"coronale" => "koRonal",
"coronales" => "koRonal",
"coronarien" => "kOROnaRj5",
"coronarienne" => "koRonaRjEn",
"coroner" => "koRonER",
"coroners" => "koRonER",
"coronilles" => "koRonij",
"corons" => "koR§",
"corozo" => "koRozo",
"corporal" => "kORpoRal",
"corporalisés" => "kORpoRalize",
"corporalité" => "kORpoRalite",
"corporatif" => "kORpORatif",
"corporatifs" => "kORpoRatif",
"corporation" => "kORpoRasj§",
"corporations" => "kORpoRasj§",
"corporatisme" => "kORpoRatizm",
"corporatiste" => "kORpoRatist",
"corporative" => "kORpoRativ",
"corporatives" => "kORpoRativ",
"corporel" => "kORpoREl",
"corporelle" => "kORpoREl",
"corporelles" => "kORpoREl",
"corporels" => "kORpoREl",
"corps" => "kOR",
"corps-mort" => "kORmOR",
"corpsard" => "kORpsaRd",
"corpulence" => "kORpyl@s",
"corpulent" => "kORpyl@",
"corpulente" => "kORpyl@t",
"corpulentes" => "kORpyl@t",
"corpulents" => "kORpyl@",
"corpus" => "kORpys",
"corpus delicti" => "kORpysdelikti",
"corpuscule" => "kORpyskyl",
"corpuscules" => "kORpyskyl",
"corral" => "koRal",
"corrals" => "koRal",
"correct" => "koREkt",
"correcte" => "koREkt",
"correctement" => "koREkt°m@",
"correctes" => "koREkt",
"correcteur" => "koREkt9R",
"correcteurs" => "koREkt9R",
"correctif" => "koREktif",
"correction" => "koREksj§",
"correctionnaliser" => "koREksjonalize",
"correctionnel" => "koREksjonEl",
"correctionnelle" => "koREksjonEl",
"correctionnelles" => "koREksjonEl",
"correctionnels" => "koREksjonEl",
"corrections" => "koREksj§",
"corrective" => "koREktiv",
"corrector" => "koREktOR",
"correctrice" => "kOREktRis",
"correctrices" => "koREktRis",
"corrects" => "koREkt",
"corregidor" => "koReZidOR",
"corrélatif" => "kORelatif",
"corrélation" => "koRelasj§",
"corrélative" => "kORelativ",
"corrélativement" => "koRelativ°m@",
"corréler" => "koRele",
"correspond" => "koREsp§",
"correspondaient" => "koREsp§dE",
"correspondais" => "koREsp§dE",
"correspondait" => "koREsp§dE",
"correspondance" => "koREsp§d@s",
"correspondances" => "koREsp§d@s",
"correspondancier" => "kOREsp§d@sje",
"correspondant" => "koREsp§d@",
"correspondante" => "koREsp§d@t",
"correspondantes" => "koREsp§d@t",
"correspondants" => "koREsp§d@",
"corresponde" => "koREsp§d",
"correspondent" => "koREsp§d",
"correspondez" => "koREsp§de",
"correspondiez" => "koREsp§dje",
"correspondions" => "koREsp§dj§",
"correspondît" => "koREsp§di",
"correspondra" => "koREsp§dRa",
"correspondrai" => "koREsp§dRE",
"correspondraient" => "koREsp§dRE",
"correspondrait" => "koREsp§dRE",
"correspondre" => "koREsp§dR",
"correspondrons" => "koREsp§dR§",
"corresponds" => "koREsp§",
"correspondu" => "koREsp§dy",
"corréziennes" => "koRezjEn",
"corrida" => "koRida",
"corridas" => "koRida",
"corridor" => "koRidOR",
"corridors" => "koRidOR",
"corrige" => "koRiZ",
"corrigé" => "koRiZe",
"corrigea" => "koRiZa",
"corrigeai" => "koRiZE",
"corrigeaient" => "koRiZE",
"corrigeais" => "koRiZE",
"corrigeait" => "koRiZE",
"corrigeant" => "koRiZ@",
"corrigée" => "koRiZe",
"corrigées" => "koRiZe",
"corrigent" => "koRiZ",
"corrigeons" => "koRiZ§",
"corriger" => "koRiZe",
"corrigera" => "koRiZ°Ra",
"corrigerai" => "koRiZ°RE",
"corrigerais" => "koRiZ°RE",
"corrigerait" => "koRiZ°RE",
"corrigeras" => "koRiZ°Ra",
"corrigerez" => "koRiZ°Re",
"corrigerons" => "koRiZ°R§",
"corriges" => "koRiZ",
"corrigés" => "koRiZe",
"corrigez" => "koRiZe",
"corrigiez" => "koRiZje",
"corrigions" => "koRiZj§",
"corrobora" => "koRoboRa",
"corroboraient" => "koRoboRE",
"corroborait" => "koRoboRE",
"corroborant" => "kORObOR@",
"corroboration" => "koRoboRasj§",
"corrobore" => "koRobOR",
"corroboré" => "kORObORe",
"corroborées" => "koRoboRe",
"corroborent" => "koRobOR",
"corroborer" => "koRoboRe",
"corroborera" => "koRobOR°Ra",
"corroborèrent" => "koRoboRER",
"corrodait" => "koRodE",
"corrodant" => "koRod@",
"corrodante" => "koRod@t",
"corrode" => "koROd",
"corrodé" => "koRode",
"corrodée" => "koRode",
"corrodées" => "koRode",
"corrodent" => "koROd",
"corroder" => "koRode",
"corrodés" => "koRode",
"corroierie" => "koRwaRi",
"corrompais" => "koR§pE",
"corrompant" => "koR§p@",
"corrompe" => "koR§p",
"corrompent" => "koR§p",
"corrompez" => "koR§pe",
"corrompis" => "koR§pi",
"corrompra" => "koR§pRa",
"corrompraient" => "koR§pRE",
"corrompre" => "koR§pR",
"corromps" => "koR§",
"corrompt" => "koR§",
"corrompu" => "koR§py",
"corrompue" => "koR§py",
"corrompues" => "koR§py",
"corrompus" => "koR§py",
"corrosif" => "koRozif",
"corrosifs" => "koRozif",
"corrosion" => "koRozj§",
"corrosive" => "koRoziv",
"corrosives" => "koRoziv",
"corrupteur" => "koRypt9R",
"corrupteurs" => "koRypt9R",
"corruptible" => "koRyptibl",
"corruptibles" => "koRyptibl",
"corruption" => "koRypsj§",
"corruptions" => "koRypsj§",
"corruptrice" => "koRyptRis",
"corruptrices" => "koRyptRis",
"cors" => "kOR",
"corsa" => "kORsa",
"corsage" => "kORsaZ",
"corsages" => "kORsaZ",
"corsaire" => "kORsER",
"corsaires" => "kORsER",
"corsait" => "kORsE",
"corsant" => "kORs@",
"corse" => "kORs",
"corsé" => "kORse",
"corsée" => "kORse",
"corsées" => "kORse",
"corselet" => "kORs°lE",
"corselets" => "kORs°lE",
"corsent" => "kORs",
"corser" => "kORse",
"corserait" => "kORs°RE",
"corses" => "kORs",
"corsés" => "kORse",
"corset" => "kORsE",
"corseté" => "kORs°te",
"corsetée" => "kORs°te",
"corsetées" => "kORs°te",
"corseter" => "kORs2te",
"corsetés" => "kORs°te",
"corsetière" => "kORs°tjER",
"corsets" => "kORsE",
"corso" => "kORso",
"corsos" => "kORso",
"cortège" => "kORtEZ",
"cortégeant" => "kORteZ@",
"cortèges" => "kORtEZ",
"cortes" => "kORt",
"cortès" => "kORtEz",
"cortex" => "kORtEks",
"cortical" => "kORtikal",
"corticale" => "kORtikal",
"corticales" => "kORtikal",
"corticaux" => "kORtiko",
"cortine" => "kORtin",
"cortisol" => "kORtizOl",
"cortisone" => "kORtizOn",
"corton" => "kORt§",
"coruscant" => "koRysk@",
"coruscante" => "koRysk@t",
"coruscants" => "koRysk@",
"coruscation" => "koRyskasj§",
"corvéable" => "kORveabl",
"corvée" => "kORve",
"corvées" => "kORve",
"corvette" => "kORvEt",
"corvettes" => "kORvEt",
"corybantes" => "koRib@t",
"coryphée" => "koRife",
"coryphène" => "koRifEn",
"coryste" => "koRist",
"coryza" => "koRiza",
"cosaque" => "kozak",
"cosaques" => "kozak",
"coseigneurs" => "kozEN9R",
"cosigné" => "kosiNe",
"cosigner" => "kosiNe",
"cosinus" => "kosinys",
"cosméticienne" => "kOsmetisjEn",
"cosmétique" => "kOsmetik",
"cosmétiqué" => "kOsmetike",
"cosmétiquée" => "kOsmetike",
"cosmétiquées" => "kOsmetike",
"cosmétiques" => "kOsmetik",
"cosmétiqués" => "kOsmetike",
"cosmétologie" => "kOsmetoloZi",
"cosmétologue" => "kOsmetOlOg",
"cosmique" => "kOsmik",
"cosmiquement" => "kOsmik°m@",
"cosmiques" => "kOsmik",
"cosmo" => "kOsmo",
"cosmodromes" => "kOsmodRom",
"cosmogonie" => "kOsmogoni",
"cosmogonies" => "kOsmogoni",
"cosmogonique" => "kOsmogonik",
"cosmographie" => "kOsmogRafi",
"cosmologie" => "kOsmoloZi",
"cosmologique" => "kOsmOlOZik",
"cosmologiques" => "kOsmoloZik",
"cosmologue" => "kOsmolOg",
"cosmonaute" => "kOsmonot",
"cosmonautes" => "kOsmonot",
"cosmopolite" => "kOsmopolit",
"cosmopolites" => "kOsmopolit",
"cosmopolitisme" => "kOsmopolitizm",
"cosmos" => "kOsmos",
"cossard" => "kosaR",
"cossarde" => "kosaRd",
"cossards" => "kosaR",
"cosse" => "kOs",
"cossent" => "kOs",
"cosses" => "kOs",
"cossu" => "kosy",
"cossue" => "kosy",
"cossues" => "kosy",
"cossus" => "kosy",
"costal" => "kOstal",
"costale" => "kOstal",
"costar" => "kOstaR",
"costard" => "kOstaR",
"costards" => "kOstaR",
"costaricain" => "kOstaRik5",
"costaud" => "kOsto",
"costaude" => "kOstod",
"costaudes" => "kOstod",
"costauds" => "kOsto",
"costaux" => "kOsto",
"costume" => "kOstym",
"costumé" => "kOstyme",
"costumée" => "kOstyme",
"costumées" => "kOstyme",
"costumer" => "kOstyme",
"costumes" => "kOstym",
"costumés" => "kOstyme",
"costumier" => "kOstymje",
"costumière" => "kOstymjER",
"costumiers" => "kOstymje",
"cosy" => "kozi",
"cosy-corner" => "kozikORnER",
"cosy-corners" => "kozikORnER",
"cosys" => "kozi",
"cot cot codec" => "kOtkOtkOdEk",
"cota" => "kota",
"cotait" => "kotE",
"cotât" => "kota",
"cotation" => "kotasj§",
"cotations" => "kotasj§",
"cote" => "kOt",
"côte" => "kot",
"coté" => "kote",
"côté" => "kote",
"coteau" => "koto",
"coteaux" => "koto",
"cotée" => "kote",
"cotées" => "kote",
"côtelé" => "kot°le",
"côtelée" => "kot°le",
"côtelette" => "kot°lEt",
"côtelettes" => "kot°lEt",
"cotent" => "kOt",
"coter" => "kote",
"coterie" => "kOt°Ri",
"coteries" => "kOt°Ri",
"cotes" => "kOt",
"côtes" => "kot",
"cotés" => "kote",
"côtés" => "kote",
"côtes-du-rhône" => "kotdyRon",
"cothurne" => "kotyRn",
"cothurnes" => "kotyRn",
"côtier" => "kotje",
"côtière" => "kotjER",
"côtières" => "kotjER",
"côtiers" => "kotje",
"coties" => "koti",
"cotillon" => "kotij§",
"cotillons" => "kotij§",
"cotisa" => "kotiza",
"cotisaient" => "kotizE",
"cotisais" => "kotizE",
"cotisant" => "kotiz@",
"cotisants" => "kotiz@",
"cotisation" => "kotizasj§",
"cotisations" => "kotizasj§",
"cotise" => "kotiz",
"cotisé" => "kotize",
"cotisées" => "kotize",
"cotisent" => "kotiz",
"cotiser" => "kotize",
"cotisèrent" => "kotizER",
"cotises" => "kotiz",
"cotisés" => "kotize",
"côtoie" => "kotwa",
"côtoiements" => "kotwam@",
"côtoient" => "kotwa",
"côtoies" => "kotwa",
"coton" => "kot§",
"coton-tige" => "kot§tiZ",
"cotonéasters" => "kotoneastER",
"cotonnade" => "kotonad",
"cotonnades" => "kotonad",
"cotonnait" => "kotonE",
"cotonnant" => "koton@",
"cotonnerie" => "kOtOn°Ri",
"cotonneuse" => "koton2z",
"cotonneuses" => "koton2z",
"cotonneux" => "koton2",
"cotonnier" => "kotonje",
"cotonnière" => "kOtonjER",
"cotons" => "kot§",
"cotons-tiges" => "kot§tiZ",
"côtoya" => "kotwaja",
"côtoyaient" => "kotwajE",
"côtoyais" => "kotwajE",
"côtoyait" => "kotwajE",
"côtoyant" => "kotwaj@",
"côtoyé" => "kotwaje",
"côtoyée" => "kotwaje",
"côtoyées" => "kotwaje",
"côtoyer" => "kotwaje",
"côtoyés" => "kotwaje",
"côtoyons" => "kotwaj§",
"cotre" => "kOtR",
"cotres" => "kOtR",
"cotrets" => "kOtRE",
"cotriade" => "kotRijad",
"cottage" => "kotaZ",
"cottages" => "kotaZ",
"cotte" => "kOt",
"cottes" => "kOt",
"coturne" => "kotyRn",
"cotylédons" => "kotiled§",
"cou" => "ku",
"cou-de-pied" => "kud°pje",
"couac" => "kwak",
"couacs" => "kwak",
"couaille" => "kwaj",
"couaquait" => "kwakE",
"couaquer" => "kwake",
"couard" => "kwaR",
"couarde" => "kwaRd",
"couardise" => "kwaRdiz",
"couards" => "kwaR",
"coucha" => "kuSa",
"couchage" => "kuSaZ",
"couchai" => "kuSE",
"couchaient" => "kuSE",
"couchailler" => "kuSaje",
"couchais" => "kuSE",
"couchait" => "kuSE",
"couchâmes" => "kuSam",
"couchant" => "kuS@",
"couchants" => "kuS@",
"couchât" => "kuSa",
"couche" => "kuS",
"couché" => "kuSe",
"couche-culotte" => "kuSkylOt",
"couchée" => "kuSe",
"couchées" => "kuSe",
"couchent" => "kuS",
"coucher" => "kuSe",
"couchera" => "kuS°Ra",
"coucherai" => "kuS°RE",
"coucheraient" => "kuS°RE",
"coucherais" => "kuS°RE",
"coucherait" => "kuS°RE",
"coucheras" => "kuS°Ra",
"couchèrent" => "kuSER",
"coucherez" => "kuS°Re",
"coucherie" => "kuS°Ri",
"coucheries" => "kuS°Ri",
"coucheriez" => "kuS°Rje",
"coucherions" => "kuS°Rj§",
"coucherons" => "kuS°R§",
"coucheront" => "kuS°R§",
"couchers" => "kuSe",
"couches" => "kuS",
"couchés" => "kuSe",
"couches-culottes" => "kuSkylOt",
"couchette" => "kuSEt",
"couchettes" => "kuSEt",
"coucheur" => "kuS9R",
"coucheurs" => "kuS9R",
"coucheuse" => "kuS2z",
"couchez" => "kuSe",
"couchiez" => "kuSje",
"couchions" => "kuSj§",
"couchoir" => "kuSwaR",
"couchons" => "kuS§",
"couci-couça" => "kusikusa",
"coucou" => "kuku",
"coucous" => "kuku",
"coud" => "ku",
"coude" => "kud",
"coudé" => "kude",
"coudée" => "kude",
"coudées" => "kude",
"coudent" => "kud",
"coudes" => "kud",
"coudoie" => "kudwa",
"coudoient" => "kudwa",
"coudoyai" => "kudwajE",
"coudoyaient" => "kudwajE",
"coudoyais" => "kudwajE",
"coudoyant" => "kudwaj@",
"coudoyé" => "kudwaje",
"coudoyer" => "kudwaje",
"coudoyons" => "kudwaj§",
"coudra" => "kudRa",
"coudrai" => "kudRE",
"coudrais" => "kudRE",
"coudrait" => "kudRE",
"coudras" => "kudRa",
"coudre" => "kudR",
"coudreuse" => "kudR2z",
"coudrier" => "kudRije",
"coudriers" => "kudRije",
"couds" => "ku",
"couenne" => "kwan",
"couennes" => "kwan",
"couette" => "kwEt",
"couettes" => "kwEt",
"couffin" => "kuf5",
"couffins" => "kuf5",
"couguar" => "kugaR",
"couguars" => "kugaR",
"couic" => "kwik",
"couillard" => "kujaR",
"couille" => "kuj",
"couilles" => "kuj",
"couillettes" => "kujEt",
"couillon" => "kuj§",
"couillonnade" => "kujonad",
"couillonnades" => "kujonad",
"couillonne" => "kujOn",
"couillonné" => "kujone",
"couillonnée" => "kujone",
"couillonnent" => "kujOn",
"couillonner" => "kujone",
"couillonnés" => "kujone",
"couillons" => "kuj§",
"couillu" => "kujy",
"couillus" => "kujy",
"couina" => "kwina",
"couinaient" => "kwinE",
"couinais" => "kwinE",
"couinait" => "kwinE",
"couinant" => "kwin@",
"couine" => "kwin",
"couiné" => "kwine",
"couinement" => "kwin°m@",
"couinements" => "kwin°m@",
"couinent" => "kwin",
"couiner" => "kwine",
"couinerais" => "kwin°RE",
"couineras" => "kwin°Ra",
"couineront" => "kwin°R§",
"couines" => "kwin",
"couinez" => "kwine",
"coula" => "kula",
"coulage" => "kulaZ",
"coulai" => "kulE",
"coulaient" => "kulE",
"coulais" => "kulE",
"coulait" => "kulE",
"coulant" => "kul@",
"coulante" => "kul@t",
"coulants" => "kul@",
"coulât" => "kula",
"coule" => "kul",
"coulé" => "kule",
"coulée" => "kule",
"coulées" => "kule",
"coulemelle" => "kul°mEl",
"coulent" => "kul",
"couler" => "kule",
"coulera" => "kul°Ra",
"coulerai" => "kul°RE",
"couleraient" => "kul°RE",
"coulerais" => "kul°RE",
"coulerait" => "kul°RE",
"couleras" => "kul°Ra",
"coulèrent" => "kulER",
"coulerez" => "kul°Re",
"couleront" => "kul°R§",
"coules" => "kul",
"coulés" => "kule",
"couleur" => "kul9R",
"couleurs" => "kul9R",
"couleuvre" => "kul9vR",
"couleuvres" => "kul9vR",
"couleuvrine" => "kul9vRin",
"couleuvrines" => "kul9vRin",
"coulez" => "kule",
"couliez" => "kulje",
"coulions" => "kulj§",
"coulis" => "kuli",
"coulissa" => "kulisa",
"coulissaient" => "kulisE",
"coulissait" => "kulisE",
"coulissant" => "kulis@",
"coulissante" => "kulis@t",
"coulissantes" => "kulis@t",
"coulissants" => "kulis@",
"coulisse" => "kulis",
"coulissé" => "kulise",
"coulissée" => "kulise",
"coulissements" => "kulis°m@",
"coulissent" => "kulis",
"coulisser" => "kulise",
"coulissèrent" => "kulisER",
"coulisses" => "kulis",
"coulissier" => "kulisje",
"couloir" => "kulwaR",
"couloir-symbole" => "kulwaRs5bOl",
"couloirs" => "kulwaR",
"coulombs" => "kul§b",
"coulons" => "kul§",
"coulpe" => "kulp",
"coulure" => "kulyR",
"coulures" => "kulyR",
"coumarine" => "kumaRin",
"countries" => "kawntRi",
"country" => "kawntRi",
"coup" => "ku",
"coup-de-poing" => "kud°pw5",
"coupa" => "kupa",
"coupable" => "kupabl",
"coupablement" => "kupabl°m@",
"coupables" => "kupabl",
"coupage" => "kupaZ",
"coupages" => "kupaZ",
"coupai" => "kupE",
"coupaient" => "kupE",
"coupailler" => "kupaje",
"coupais" => "kupE",
"coupait" => "kupE",
"coupant" => "kup@",
"coupante" => "kup@t",
"coupantes" => "kup@t",
"coupants" => "kup@",
"coupe" => "kup",
"coupé" => "kupe",
"coupe-chou" => "kupSu",
"coupe-choux" => "kupSu",
"coupe-cigare" => "kupsigaR",
"coupe-cigares" => "kupsigaR",
"coupe-circuit" => "kupsiRk8i",
"coupe-circuits" => "kupsiRk8i",
"coupe-coupe" => "kupkup",
"coupe-faim" => "kupf5",
"coupe-faims" => "kupf5",
"coupe-feu" => "kupf2",
"coupe-file" => "kupfil",
"coupe-gorge" => "kupgORZ",
"coupe-jarret" => "kupZaRE",
"coupe-jarrets" => "kupZaRE",
"coupe-ongle" => "kup§gl",
"coupe-ongles" => "kup§gl",
"coupe-papier" => "kuppapje",
"coupe-pâte" => "kuppat",
"coupe-racines" => "kupRasin",
"coupe-vent" => "kupv@",
"coupée" => "kupe",
"coupées" => "kupe",
"coupelle" => "kupEl",
"coupelles" => "kupEl",
"coupent" => "kup",
"couper" => "kupe",
"coupera" => "kup°Ra",
"couperai" => "kup°RE",
"couperaient" => "kup°RE",
"couperais" => "kup°RE",
"couperait" => "kup°RE",
"couperas" => "kup°Ra",
"coupèrent" => "kupER",
"couperet" => "kup°RE",
"couperets" => "kup°RE",
"couperez" => "kup°Re",
"couperons" => "kup°R§",
"couperont" => "kup°R§",
"couperose" => "kup°Roz",
"couperosé" => "kup°Roze",
"couperosée" => "kup°Roze",
"couperosées" => "kup°Roze",
"coupes" => "kup",
"coupés" => "kupe",
"coupeur" => "kup9R",
"coupeurs" => "kup9R",
"coupeuse" => "kup2z",
"coupez" => "kupe",
"coupiez" => "kupje",
"coupions" => "kupj§",
"couplage" => "kuplaZ",
"couplages" => "kuplaZ",
"couplant" => "kupl@",
"couple" => "kupl",
"couplé" => "kuple",
"couplée" => "kuple",
"couplées" => "kuple",
"coupler" => "kuple",
"couples" => "kupl",
"couplés" => "kuple",
"couplet" => "kuplE",
"couplets" => "kuplE",
"coupleur" => "kupl9R",
"coupleurs" => "kupl9R",
"coupole" => "kupOl",
"coupoles" => "kupOl",
"coupon" => "kup§",
"coupon-cadeau" => "kup§kado",
"coupons" => "kup§",
"coups" => "ku",
"coups-de-poing" => "kud°pw5",
"coupure" => "kupyR",
"coupures" => "kupyR",
"couques" => "kuk",
"cour" => "kuR",
"cour-jardin" => "kuRZaRd5",
"courage" => "kuRaZ",
"courages" => "kuRaZ",
"courageuse" => "kuRaZ2z",
"courageusement" => "kuRaZ2z°m@",
"courageuses" => "kuRaZ2z",
"courageux" => "kuRaZ2",
"couraient" => "kuRE",
"courailler" => "kuRaje",
"courais" => "kuRE",
"courait" => "kuRE",
"couramment" => "kuRam@",
"courant" => "kuR@",
"courante" => "kuR@t",
"courantes" => "kuR@t",
"courants" => "kuR@",
"courba" => "kuRba",
"courbaient" => "kuRbE",
"courbait" => "kuRbE",
"courbant" => "kuRb@",
"courbatu" => "kuRbaty",
"courbatue" => "kuRbaty",
"courbature" => "kuRbatyR",
"courbaturé" => "kuRbatyRe",
"courbaturée" => "kuRbatyRe",
"courbatures" => "kuRbatyR",
"courbatus" => "kuRbaty",
"courbe" => "kuRb",
"courbé" => "kuRbe",
"courbée" => "kuRbe",
"courbées" => "kuRbe",
"courbent" => "kuRb",
"courber" => "kuRbe",
"courberait" => "kuRb°RE",
"courbes" => "kuRb",
"courbés" => "kuRbe",
"courbette" => "kuRbEt",
"courbettes" => "kuRbEt",
"courbez" => "kuRbe",
"courbons" => "kuRb§",
"courbure" => "kuRbyR",
"courbures" => "kuRbyR",
"coure" => "kuR",
"courent" => "kuR",
"coures" => "kuR",
"courette" => "kuREt",
"courettes" => "kuREt",
"coureur" => "kuR9R",
"coureurs" => "kuR9R",
"coureuse" => "kuR2z",
"coureuses" => "kuR2z",
"courez" => "kuRe",
"courge" => "kuRZ",
"courges" => "kuRZ",
"courgette" => "kuRZEt",
"courgettes" => "kuRZEt",
"couriez" => "kuRje",
"courions" => "kuRj§",
"courir" => "kuRiR",
"courlis" => "kuRli",
"couronna" => "kuRona",
"couronnaient" => "kuRonE",
"couronnait" => "kuRonE",
"couronnant" => "kuRon@",
"couronne" => "kuROn",
"couronné" => "kuRone",
"couronnée" => "kuRone",
"couronnées" => "kuRone",
"couronnement" => "kuROn°m@",
"couronnements" => "kuROn°m@",
"couronnent" => "kuROn",
"couronner" => "kuRone",
"couronnera" => "kuROn°Ra",
"couronnerai" => "kuROn°RE",
"couronnerons" => "kuROn°R§",
"couronnes" => "kuROn",
"couronnés" => "kuRone",
"courons" => "kuR§",
"courra" => "kuRa",
"courrai" => "kuRE",
"courraient" => "kuRE",
"courrais" => "kuRE",
"courrait" => "kuRE",
"courras" => "kuRa",
"courre" => "kuR",
"courrez" => "kuRe",
"courriel" => "kuRjEl",
"courrier" => "kuRje",
"courriériste" => "kuRjeRist",
"courriers" => "kuRje",
"courriez" => "kuRje",
"courrions" => "kuRj§",
"courroie" => "kuRwa",
"courroies" => "kuRwa",
"courrons" => "kuR§",
"courront" => "kuR§",
"courrouçaient" => "kuRusE",
"courrouçait" => "kuRusE",
"courrouce" => "kuRus",
"courroucé" => "kuRuse",
"courroucée" => "kuRuse",
"courroucées" => "kuRuse",
"courroucer" => "kuRuse",
"courroucés" => "kuRuse",
"courroux" => "kuRu",
"cours" => "kuR",
"coursaient" => "kuRsE",
"coursais" => "kuRsE",
"coursait" => "kuRsE",
"coursant" => "kuRs@",
"course" => "kuRs",
"coursé" => "kuRse",
"course-poursuite" => "kuRspuRs8it",
"coursée" => "kuRse",
"coursent" => "kuRs",
"courser" => "kuRse",
"courserais" => "kuRs°RE",
"courses" => "kuRs",
"coursés" => "kuRse",
"coursier" => "kuRsje",
"coursière" => "kuRsjER",
"coursiers" => "kuRsje",
"coursive" => "kuRsiv",
"coursives" => "kuRsiv",
"court" => "kuR",
"court-bouillon" => "kuRbuj§",
"court-circuit" => "kuRsiRk8i",
"court-circuitait" => "kuRsiRk8itE",
"court-circuitant" => "kuRsiRk8it@",
"court-circuite" => "kuRsiRk8it",
"court-circuité" => "kuRsiRk8ite",
"court-circuitée" => "kuRsiRk8ite",
"court-circuitées" => "kuRsiRk8ite",
"court-circuiter" => "kuRsiRk8ite",
"court-circuits" => "kuRsiRk8i",
"court-courrier" => "kuRkuRje",
"court-jus" => "kuRZy",
"court-métrage" => "kuRmetRaZ",
"court-vêtue" => "kuRvety",
"court-vêtues" => "kuRvEty",
"courtage" => "kuRtaZ",
"courtages" => "kuRtaZ",
"courtaud" => "kuRto",
"courtaude" => "kuRtod",
"courtaudes" => "kuRtod",
"courtauds" => "kuRto",
"courte" => "kuRt",
"courtelinesque" => "kuRtElinEsk",
"courtelinesques" => "kuRtElinEsk",
"courtement" => "kuRt°m@",
"courtepointe" => "kuRt°pw5t",
"courtepointes" => "kuRt°pw5t",
"courtes" => "kuRt",
"courtier" => "kuRtje",
"courtière" => "kuRtjER",
"courtières" => "kuRtjER",
"courtiers" => "kuRtje",
"courtilière" => "kuRtiljER",
"courtilières" => "kuRtiljER",
"courtils" => "kuRtil",
"courtine" => "kuRtin",
"courtines" => "kuRtin",
"courtisa" => "kuRtiza",
"courtisaient" => "kuRtizE",
"courtisais" => "kuRtizE",
"courtisait" => "kuRtizE",
"courtisan" => "kuRtiz@",
"courtisane" => "kuRtizan",
"courtisanerie" => "kuRtizan°Ri",
"courtisanes" => "kuRtizan",
"courtisans" => "kuRtiz@",
"courtisant" => "kuRtiz@",
"courtise" => "kuRtiz",
"courtisé" => "kuRtize",
"courtisée" => "kuRtize",
"courtisées" => "kuRtize",
"courtisent" => "kuRtiz",
"courtiser" => "kuRtize",
"courtiserai" => "kuRtiz°RE",
"courtiseras" => "kuRtiz°Ra",
"courtisez" => "kuRtize",
"courtisiez" => "kuRtizje",
"courtois" => "kuRtwa",
"courtoise" => "kuRtwaz",
"courtoisement" => "kuRtwaz°m@",
"courtoises" => "kuRtwaz",
"courtoisie" => "kuRtwazi",
"courtoisies" => "kuRtwazi",
"courts" => "kuR",
"courts-circuits" => "kuRsiRk8i",
"couru" => "kuRy",
"courue" => "kuRy",
"courues" => "kuRy",
"courûmes" => "kuRym",
"coururent" => "kuRyR",
"courus" => "kuRy",
"courussent" => "kuRys",
"courut" => "kuRy",
"courût" => "kuRy",
"courûtes" => "kuRyt",
"cous" => "ku",
"cous-de-pied" => "kud°pje",
"cousaient" => "kuzE",
"cousait" => "kuzE",
"cousant" => "kuz@",
"couscous" => "kuskus",
"couscoussier" => "kuskusje",
"couscoussiers" => "kuskusje",
"couse" => "kuz",
"cousent" => "kuz",
"cousette" => "kuzEt",
"cousettes" => "kuzEt",
"couseuse" => "kuz2z",
"cousez" => "kuze",
"cousiez" => "kuzje",
"cousin" => "kuz5",
"cousinage" => "kuzinaZ",
"cousinages" => "kuzinaZ",
"cousinant" => "kuzin@",
"cousine" => "kuzin",
"cousines" => "kuzin",
"cousins" => "kuz5",
"cousirent" => "kuziR",
"cousissent" => "kuzis",
"cousit" => "kuzi",
"coussin" => "kus5",
"coussinet" => "kusinE",
"coussinets" => "kusinE",
"coussins" => "kus5",
"cousu" => "kuzy",
"cousue" => "kuzy",
"cousues" => "kuzy",
"cousus" => "kuzy",
"coût" => "ku",
"coûta" => "kuta",
"coûtaient" => "kutE",
"coûtais" => "kutE",
"coûtait" => "kutE",
"coûtant" => "kut@",
"coûtât" => "kuta",
"coûte" => "kut",
"coûté" => "kute",
"couteau" => "kuto",
"couteau-scie" => "kutosi",
"couteaux" => "kuto",
"coûtée" => "kute",
"coûtées" => "kute",
"coutelas" => "kut°la",
"coutelier" => "kutElje",
"coutellerie" => "kutEl°Ri",
"coutelleries" => "kutEl°Ri",
"coûtent" => "kut",
"coûter" => "kute",
"coûtera" => "kut°Ra",
"coûterai" => "kut°RE",
"coûteraient" => "kut°RE",
"coûterait" => "kut°RE",
"coûteras" => "kut°Ra",
"coûteront" => "kut°R§",
"coûtes" => "kut",
"coûtés" => "kute",
"coûteuse" => "kut2z",
"coûteusement" => "kut2z°m@",
"coûteuses" => "kut2z",
"coûteux" => "kut2",
"coûtez" => "kute",
"coutil" => "kuti",
"coûtions" => "kutj§",
"coûts" => "ku",
"coutume" => "kutym",
"coutumes" => "kutym",
"coutumier" => "kutymje",
"coutumière" => "kutymjER",
"coutumièrement" => "kutymjER°m@",
"coutumières" => "kutymjER",
"coutumiers" => "kutymje",
"couturaient" => "kutyRE",
"couture" => "kutyR",
"couturé" => "kutyRe",
"couturée" => "kutyRe",
"couturées" => "kutyRe",
"coutures" => "kutyR",
"couturés" => "kutyRe",
"couturier" => "kutyRje",
"couturière" => "kutyRjER",
"couturières" => "kutyRjER",
"couturiers" => "kutyRje",
"couvade" => "kuvad",
"couvaient" => "kuvE",
"couvais" => "kuvE",
"couvaison" => "kuvEz§",
"couvaisons" => "kuvEz§",
"couvait" => "kuvE",
"couvant" => "kuv@",
"couve" => "kuv",
"couvé" => "kuve",
"couvée" => "kuve",
"couvées" => "kuve",
"couvent" => "kuv@",
"couventine" => "kuv@tin",
"couventines" => "kuv@tin",
"couvents" => "kuv@",
"couver" => "kuve",
"couvercle" => "kuvERkl",
"couvercles" => "kuvERkl",
"couveront" => "kuv°R§",
"couvert" => "kuvER",
"couverte" => "kuvERt",
"couvertes" => "kuvERt",
"couverts" => "kuvER",
"couverture" => "kuvERtyR",
"couvertures" => "kuvERtyR",
"couves" => "kuv",
"couvés" => "kuve",
"couvet" => "kuvE",
"couveuse" => "kuv2z",
"couveuses" => "kuv2z",
"couvez" => "kuve",
"couvis" => "kuvi",
"couvraient" => "kuvRE",
"couvrais" => "kuvRE",
"couvrait" => "kuvRE",
"couvrant" => "kuvR@",
"couvrante" => "kuvR@t",
"couvrantes" => "kuvR@t",
"couvre" => "kuvR",
"couvre-chef" => "kuvR°Sef",
"couvre-chefs" => "kuvR°Sef",
"couvre-feu" => "kuvR°f2",
"couvre-feux" => "kuvR°f2",
"couvre-lit" => "kuvR°li",
"couvre-lits" => "kuvR°li",
"couvre-pied" => "kuvR°pje",
"couvre-pieds" => "kuvR°pje",
"couvrent" => "kuvR",
"couvres" => "kuvR",
"couvreur" => "kuvR9R",
"couvreurs" => "kuvR9R",
"couvrez" => "kuvRe",
"couvriez" => "kuvRie",
"couvrir" => "kuvRiR",
"couvrira" => "kuvRiRa",
"couvrirai" => "kuvRiRE",
"couvriraient" => "kuvRiRE",
"couvrirais" => "kuvRiRE",
"couvrirait" => "kuvRiRE",
"couvriras" => "kuvRiRa",
"couvrirent" => "kuvRiR",
"couvrirez" => "kuvRiRe",
"couvrirons" => "kuvRiR§",
"couvriront" => "kuvRiR§",
"couvris" => "kuvRi",
"couvrit" => "kuvRi",
"couvrît" => "kuvRi",
"couvrons" => "kuvR§",
"covalent" => "koval@",
"covalente" => "koval@t",
"covenant" => "kov°n@",
"cover-girl" => "kOv9Rg9Rl",
"cover-girls" => "kOv9Rg9Rl",
"covoiturage" => "kovwatyRaZ",
"cow-boy" => "kobOj",
"cow-boys" => "kobOjz",
"coxalgie" => "kOksalZi",
"coxalgique" => "kOksalZik",
"coyote" => "kojOt",
"coyotes" => "kojOt",
"crabe" => "kRab",
"crabes" => "kRab",
"crabillon" => "kRabij§",
"crabillons" => "kRabij§",
"crabs" => "kRabs",
"crac" => "kRak",
"cracha" => "kRaSa",
"crachai" => "kRaSE",
"crachaient" => "kRaSE",
"crachais" => "kRaSE",
"crachait" => "kRaSE",
"crachant" => "kRaS@",
"crachat" => "kRaSa",
"crachats" => "kRaSa",
"crache" => "kRaS",
"craché" => "kRaSe",
"crachée" => "kRaSe",
"crachées" => "kRaSe",
"crachement" => "kRaS°m@",
"crachements" => "kRaS°m@",
"crachent" => "kRaS",
"cracher" => "kRaSe",
"crachera" => "kRaS°Ra",
"cracherai" => "kRaS°RE",
"cracherais" => "kRaS°RE",
"cracherait" => "kRaS°RE",
"crachèrent" => "kRaSER",
"cracheriez" => "kRaS°Rje",
"cracheront" => "kRaS°R§",
"craches" => "kRaS",
"crachés" => "kRaSe",
"cracheur" => "kRaS9R",
"cracheurs" => "kRaS9R",
"cracheuse" => "kRaS2z",
"cracheuses" => "kRaS2z",
"crachez" => "kRaSe",
"crachin" => "kRaS5",
"crachine" => "kRaSin",
"crachiner" => "kRaSine",
"crachins" => "kRaS5",
"crachoir" => "kRaSwaR",
"crachoirs" => "kRaSwaR",
"crachons" => "kRaS§",
"crachota" => "kRaSota",
"crachotaient" => "kRaSotE",
"crachotait" => "kRaSotE",
"crachotant" => "kRaSot@",
"crachotantes" => "kRaSot@t",
"crachotants" => "kRaSot@",
"crachote" => "kRaSOt",
"crachoté" => "kRaSote",
"crachotement" => "kRaSOt°m@",
"crachotements" => "kRaSOt°m@",
"crachotent" => "kRaSOt",
"crachoter" => "kRaSote",
"crachoteuse" => "kRaSot2z",
"crachoteux" => "kRaSot2",
"crachouilla" => "kRaSuja",
"crachouille" => "kRaSuj",
"crachouillis" => "kRaSuji",
"crack" => "kRak",
"cracker" => "kRakER",
"crackers" => "kRak9R",
"cracking" => "kRakiG",
"cracks" => "kRak",
"cracra" => "kRakRa",
"crade" => "kRad",
"crades" => "kRad",
"cradingue" => "kRad5g",
"cradingues" => "kRad5g",
"crado" => "kRado",
"cradoque" => "kRadOk",
"crados" => "kRado",
"craie" => "kRE",
"craies" => "kRE",
"craignaient" => "kRENE",
"craignais" => "kRENE",
"craignait" => "kRENE",
"craignant" => "kREN@",
"craigne" => "kREN",
"craignent" => "kREN",
"craignes" => "kREN",
"craignez" => "kRENe",
"craigniez" => "kRENe",
"craignions" => "kREN§",
"craignirent" => "kRENiR",
"craignis" => "kRENi",
"craignissent" => "kRENis",
"craignit" => "kRENi",
"craignît" => "kRENi",
"craignons" => "kREN§",
"craignos" => "kRENos",
"craillaient" => "kRajE",
"craillent" => "kRaj",
"craindra" => "kR5dRa",
"craindrai" => "kR5dRE",
"craindraient" => "kR5dRE",
"craindrais" => "kR5dRE",
"craindrait" => "kR5dRE",
"craindras" => "kR5dRa",
"craindre" => "kR5dR",
"craindriez" => "kR5dRie",
"craindrons" => "kR5dR§",
"craindront" => "kR5dR§",
"crains" => "kR5",
"craint" => "kR5",
"crainte" => "kR5t",
"craintes" => "kR5t",
"craintif" => "kR5tif",
"craintifs" => "kR5tif",
"craintive" => "kR5tiv",
"craintivement" => "kR5tiv°m@",
"craintives" => "kR5tiv",
"craints" => "kR5",
"crama" => "kRama",
"cramaient" => "kRamE",
"cramait" => "kRamE",
"cramant" => "kRam@",
"crame" => "kRam",
"cramé" => "kRame",
"cramée" => "kRame",
"cramées" => "kRame",
"crament" => "kRam",
"cramer" => "kRame",
"crameraient" => "kRam°RE",
"cramerais" => "kRam°RE",
"crameras" => "kRam°Ra",
"cramés" => "kRame",
"cramez" => "kRame",
"cramoisi" => "kRamwazi",
"cramoisie" => "kRamwazi",
"cramoisies" => "kRamwazi",
"cramoisis" => "kRamwazi",
"cramouille" => "kRamuj",
"cramouilles" => "kRamuj",
"crampe" => "kR@p",
"crampes" => "kR@p",
"crampette" => "kR@pEt",
"crampettes" => "kR@pEt",
"crampon" => "kR@p§",
"cramponna" => "kR@pona",
"cramponnaient" => "kR@ponE",
"cramponnais" => "kR@ponE",
"cramponnait" => "kR@ponE",
"cramponnant" => "kR@pon@",
"cramponne" => "kR@pOn",
"cramponné" => "kR@pone",
"cramponnée" => "kR@pone",
"cramponnées" => "kR@pone",
"cramponnent" => "kR@pOn",
"cramponner" => "kR@pone",
"cramponneront" => "kR@pOn°R§",
"cramponnés" => "kR@pone",
"cramponnez" => "kR@pone",
"cramponniez" => "kR@ponje",
"cramponnons" => "kR@pon§",
"crampons" => "kR@p§",
"cran" => "kR@",
"crâna" => "kRana",
"crânais" => "kRanE",
"crânait" => "kRanE",
"crânant" => "kRan@",
"crane" => "kRan",
"crâne" => "kRan",
"crâné" => "kRane",
"crânement" => "kRan°m@",
"crânent" => "kRan",
"crâner" => "kRane",
"crânerie" => "kRan°Ri",
"crânes" => "kRan",
"crâneur" => "kRan9R",
"crâneurs" => "kRan9R",
"crâneuse" => "kRan2z",
"crâneuses" => "kRan2z",
"crânez" => "kRane",
"crânien" => "kRanj5",
"crânienne" => "kRanjEn",
"crâniens" => "kRanj5",
"craniométrie" => "kRanjometRi",
"craniotomie" => "kRanjotomi",
"crans" => "kR@",
"cranté" => "kR@te",
"crantées" => "kR@te",
"cranter" => "kR@te",
"crantés" => "kR@te",
"craonnais" => "kRaonE",
"craonnaise" => "kRaonEz",
"craonnaises" => "kRaonEz",
"crapahutait" => "kRapaytE",
"crapahutant" => "kRapayt@",
"crapahute" => "kRapayt",
"crapahuté" => "kRapayte",
"crapahuter" => "kRapayte",
"crapahutons" => "kRapayt§",
"crapaud" => "kRapo",
"crapaud-buffle" => "kRapobyfl",
"crapauds" => "kRapo",
"crapauds-buffles" => "kRapobyfl",
"crapoter" => "kRapOte",
"crapoteuse" => "kRapot2z",
"crapoteuses" => "kRapot2z",
"crapoteux" => "kRapot2",
"crapouillot" => "kRapujo",
"crapouillots" => "kRapujo",
"craps" => "kRap",
"crapule" => "kRapyl",
"crapulerie" => "kRapyl°Ri",
"crapules" => "kRapyl",
"crapuleuse" => "kRapyl2z",
"crapuleusement" => "kRapyl2z°m@",
"crapuleuses" => "kRapyl2z",
"crapuleux" => "kRapyl2",
"craqua" => "kRaka",
"craquage" => "kRakaZ",
"craquaient" => "kRakE",
"craquais" => "kRakE",
"craquait" => "kRakE",
"craquant" => "kRak@",
"craquante" => "kRak@t",
"craquantes" => "kRak@t",
"craquants" => "kRak@",
"craque" => "kRak",
"craqué" => "kRake",
"craquée" => "kRake",
"craquées" => "kRake",
"craquela" => "kRak°la",
"craquelaient" => "kRak°lE",
"craquelait" => "kRak°lE",
"craquelant" => "kRak°l@",
"craquelé" => "kRak°le",
"craquelée" => "kRak°le",
"craquelées" => "kRak°le",
"craquèlement" => "kRakEl°m@",
"craqueler" => "kRak°le",
"craquelèrent" => "kRak°lER",
"craquelés" => "kRak°le",
"craquelin" => "kRak°l5",
"craquelins" => "kRak°l5",
"craquelle" => "kRakEl",
"craquellent" => "kRakEl",
"craquelure" => "kRak°lyR",
"craquelures" => "kRak°lyR",
"craquement" => "kRak°m@",
"craquements" => "kRak°m@",
"craquent" => "kRak",
"craquer" => "kRake",
"craquera" => "kRak°Ra",
"craqueraient" => "kRak°RE",
"craquerait" => "kRak°RE",
"craqueras" => "kRak°Ra",
"craquèrent" => "kRakER",
"craqueront" => "kRak°R§",
"craques" => "kRak",
"craquette" => "kRakEt",
"craquez" => "kRake",
"craquiez" => "kRakje",
"crase" => "kRaz",
"crash" => "kRaS",
"crash-test" => "kRaStEst",
"crashe" => "kRaS",
"crashé" => "kRaSe",
"crashée" => "kRaSe",
"crasher" => "kRaSe",
"crashes" => "kRaS",
"craspec" => "kRaspEk",
"crasse" => "kRas",
"crasses" => "kRas",
"crasseuse" => "kRas2z",
"crasseuses" => "kRas2z",
"crasseux" => "kRas2",
"crassier" => "kRasje",
"crassiers" => "kRasje",
"crassula" => "kRasyla",
"crataegus" => "kRategys",
"cratère" => "kRatER",
"cratères" => "kRatER",
"cravachais" => "kRavaSE",
"cravachait" => "kRavaSE",
"cravachant" => "kRavaS@",
"cravache" => "kRavaS",
"cravaché" => "kRavaSe",
"cravachées" => "kRavaSe",
"cravacher" => "kRavaSe",
"cravaches" => "kRavaS",
"cravant" => "kRav@",
"cravants" => "kRav@",
"cravatage" => "kRavataZ",
"cravatait" => "kRavatE",
"cravate" => "kRavat",
"cravaté" => "kRavate",
"cravatée" => "kRavate",
"cravatées" => "kRavate",
"cravater" => "kRavate",
"cravates" => "kRavat",
"cravatés" => "kRavate",
"cravateur" => "kRavat9R",
"cravatière" => "kRavatjER",
"crawl" => "kRol",
"crawlait" => "kRolE",
"crawlant" => "kRol@",
"crawlé" => "kRole",
"crayeuse" => "kREj2z",
"crayeuses" => "kREj2z",
"crayeux" => "kREj2",
"crayon" => "kREj§",
"crayon-encre" => "kREj§@kR",
"crayonna" => "kREjona",
"crayonnage" => "kREjonaZ",
"crayonnages" => "kREjonaZ",
"crayonnait" => "kREjonE",
"crayonnant" => "kREjon@",
"crayonne" => "kREjOn",
"crayonné" => "kREjone",
"crayonnées" => "kREjone",
"crayonner" => "kREjone",
"crayonnés" => "kREjone",
"crayonneur" => "kREjon9R",
"crayonneurs" => "kREjon9R",
"crayonnez" => "kREjone",
"crayons" => "kREj§",
"crayons-feutres" => "kREj§f2tR",
"cré" => "kRe",
"créa" => "kRea",
"créai" => "kReE",
"créaient" => "kReE",
"créais" => "kReE",
"créait" => "kReE",
"créance" => "kRe@s",
"créances" => "kRe@s",
"créancier" => "kRe@sje",
"créanciers" => "kRe@sje",
"créant" => "kRe@",
"créât" => "kRea",
"créateur" => "kReat9R",
"créateurs" => "kReat9R",
"créatif" => "kReatif",
"créatifs" => "kReatif",
"créatine" => "kReatin",
"créatinine" => "kReatinin",
"création" => "kReasj§",
"créationnisme" => "kReasjonizm",
"créations" => "kReasj§",
"créative" => "kReativ",
"créatives" => "kReativ",
"créativité" => "kReativite",
"créatrice" => "kReatRis",
"créatrices" => "kReatRis",
"créature" => "kReatyR",
"créatures" => "kReatyR",
"crécelle" => "kResEl",
"crécelles" => "kResEl",
"crécerelle" => "kRes°REl",
"crécerelles" => "kRes°REl",
"créchaient" => "kReSE",
"créchait" => "kReSE",
"créchant" => "kReS@",
"crèche" => "kRES",
"crèchent" => "kRES",
"crécher" => "kReSe",
"crèches" => "kRES",
"crécy" => "kResi",
"crédence" => "kRed@s",
"crédences" => "kRed@s",
"crédibilité" => "kRedibilite",
"crédible" => "kRedibl",
"crédibles" => "kRedibl",
"crédié" => "kRedje",
"crédit" => "kRedi",
"crédit-bail" => "kRedibaj",
"créditait" => "kReditE",
"crédite" => "kRedit",
"crédité" => "kRedite",
"créditée" => "kRedite",
"créditent" => "kRedit",
"créditer" => "kRedite",
"créditeraient" => "kRedit°RE",
"crédités" => "kRedite",
"créditeur" => "kRedit9R",
"créditeurs" => "kRedit9R",
"créditez" => "kRedite",
"créditrice" => "kReditRis",
"crédits" => "kRedi",
"credo" => "kRedo",
"crédule" => "kRedyl",
"crédules" => "kRedyl",
"crédulité" => "kRedylite",
"crédulités" => "kRedylite",
"crée" => "kRe",
"créé" => "kRee",
"créée" => "kRee",
"créées" => "kRee",
"creek" => "kRik",
"creeks" => "kRik",
"créent" => "kRe",
"créer" => "kRee",
"créera" => "kReRa",
"créerai" => "kReRE",
"créeraient" => "kReRE",
"créerais" => "kReRE",
"créerait" => "kReRE",
"créèrent" => "kReER",
"créerez" => "kReRe",
"créerons" => "kReR§",
"créeront" => "kReR§",
"créés" => "kRee",
"créez" => "kRee",
"créiez" => "kReje",
"créions" => "kRej§",
"crémaillère" => "kRemajER",
"crémaillères" => "kRemajER",
"crémant" => "kRem@",
"crémateurs" => "kRemat9R",
"crémation" => "kRemasj§",
"crémations" => "kRemasj§",
"crématoire" => "kRematwaR",
"crématoires" => "kRematwaR",
"crematorium" => "kRematORjOm",
"crématorium" => "kRematORjOm",
"crème" => "kREm",
"crémer" => "kReme",
"crémerie" => "kREm°Ri",
"crémeries" => "kREm°Ri",
"crèmes" => "kREm",
"crémés" => "kReme",
"crémeuse" => "kRem2z",
"crémeuses" => "kRem2z",
"crémeux" => "kRem2",
"crémier" => "kRemje",
"crémière" => "kRemjER",
"crémières" => "kRemjER",
"crémiers" => "kRemje",
"crémone" => "kRemOn",
"créneau" => "kReno",
"créneaux" => "kReno",
"crénelait" => "kRen°lE",
"crénelé" => "kRen°le",
"crénelée" => "kRen°le",
"crénelées" => "kRen°le",
"crénelés" => "kRen°le",
"crénom" => "kRen§",
"créole" => "kReOl",
"créoles" => "kReOl",
"créolophone" => "kReOlOfOn",
"créons" => "kRe§",
"créosote" => "kReozOt",
"créosotée" => "kReozote",
"crêpage" => "kREpaZ",
"crêpages" => "kREpaZ",
"crêpaient" => "kREpE",
"crêpait" => "kREpE",
"crêpe" => "kREp",
"crêpé" => "kRepe",
"crêpée" => "kRepe",
"crêpelait" => "kREp°lE",
"crêpelées" => "kREp°le",
"crêpelés" => "kREp°le",
"crêpelure" => "kREp°lyR",
"crêper" => "kRepe",
"crêpes" => "kREp",
"crêpés" => "kRepe",
"crépi" => "kRepi",
"crépie" => "kRepi",
"crépies" => "kRepi",
"crépine" => "kRepin",
"crépinette" => "kRepinEt",
"crépinettes" => "kRepinEt",
"crépins" => "kRep5",
"crépir" => "kRepiR",
"crépis" => "kRepi",
"crépissage" => "kRepisaZ",
"crépissez" => "kRepise",
"crépita" => "kRepita",
"crépitaient" => "kRepitE",
"crépitait" => "kRepitE",
"crépitant" => "kRepit@",
"crépitante" => "kRepit@t",
"crépitantes" => "kRepit@t",
"crépitants" => "kRepit@",
"crépitation" => "kRepitasj§",
"crépite" => "kRepit",
"crépité" => "kRepite",
"crépitement" => "kRepit°m@",
"crépitements" => "kRepit°m@",
"crépitent" => "kRepit",
"crépiter" => "kRepite",
"crépitèrent" => "kRepitER",
"crépiteront" => "kRepit°R§",
"crépon" => "kRep§",
"crépons" => "kRep§",
"crépu" => "kRepy",
"crépue" => "kRepy",
"crépues" => "kRepy",
"crépus" => "kRepy",
"crépusculaire" => "kRepyskylER",
"crépusculaires" => "kRepyskylER",
"crépuscule" => "kRepyskyl",
"crépuscules" => "kRepyskyl",
"créquier" => "kRekje",
"crescendo" => "kReSEndo",
"crésol" => "kRezOl",
"cresson" => "kRes§",
"cressonnette" => "kREsonEt",
"cressonnière" => "kResonjER",
"cressonnières" => "kREsonjER",
"cressons" => "kRes§",
"crésus" => "kRezys",
"crésyl" => "kRezil",
"crésylée" => "kRezile",
"crêt" => "kRE",
"crétacé" => "kRetase",
"crétacée" => "kRetase",
"crêtaient" => "kREtE",
"crête" => "kREt",
"crêté" => "kREte",
"crêtée" => "kREte",
"crêtées" => "kREte",
"crételle" => "kRetEl",
"crêtes" => "kREt",
"crêtés" => "kREte",
"crêtes-de-coq" => "kREtd2kOk",
"crétin" => "kRet5",
"crétine" => "kRetin",
"crétinerie" => "kRetin°Ri",
"crétineries" => "kRetin°Ri",
"crétineux" => "kRetin2",
"crétinisant" => "kRetiniz@",
"crétinisation" => "kRetinizasj§",
"crétinisé" => "kRetinize",
"crétiniser" => "kRetinize",
"crétinisme" => "kRetinizm",
"crétins" => "kRet5",
"crêtions" => "kREtj§",
"crétois" => "kRetwa",
"crétoise" => "kRetwaz",
"crétoises" => "kRetwaz",
"creton" => "kR2t§",
"cretonne" => "kR°tOn",
"cretonnes" => "kR°tOn",
"cretons" => "kR°t§",
"creusa" => "kR2za",
"creusai" => "kR2zE",
"creusaient" => "kR2zE",
"creusais" => "kR2zE",
"creusait" => "kR2zE",
"creusant" => "kR2z@",
"creusas" => "kR2za",
"creusassent" => "kR2zas",
"creuse" => "kR2z",
"creusé" => "kR2ze",
"creusée" => "kR2ze",
"creusées" => "kR2ze",
"creusement" => "kR2z°m@",
"creusements" => "kR2z°m@",
"creusent" => "kR2z",
"creuser" => "kR2ze",
"creusera" => "kR2z°Ra",
"creuserai" => "kR2z°RE",
"creuseraient" => "kR2z°RE",
"creuserais" => "kR2z°RE",
"creuserait" => "kR2z°RE",
"creuseras" => "kR2z°Ra",
"creusèrent" => "kR2zER",
"creuserez" => "kR2z°Re",
"creuserons" => "kR2z°R§",
"creuseront" => "kR2z°R§",
"creuses" => "kR2z",
"creusés" => "kR2ze",
"creuset" => "kR2zE",
"creusets" => "kR2zE",
"creuseur" => "kR2z9R",
"creusez" => "kR2ze",
"creusiez" => "kR2zje",
"creusions" => "kR2zj§",
"creusons" => "kR2z§",
"creux" => "kR2",
"creva" => "kR°va",
"crevage" => "kR°vaZ",
"crevaient" => "kR°vE",
"crevais" => "kR°vE",
"crevaison" => "kR°vEz§",
"crevaisons" => "kR°vEz§",
"crevait" => "kR°vE",
"crevant" => "kR°v@",
"crevante" => "kR°v@t",
"crevants" => "kR°v@",
"crevard" => "kR°vaR",
"crevarde" => "kR°vaRd",
"crevards" => "kR°vaR",
"crevasse" => "kR°vas",
"crevassé" => "kR°vase",
"crevassée" => "kR°vase",
"crevassées" => "kR°vase",
"crevassent" => "kR°vas",
"crevasser" => "kR°vase",
"crevasses" => "kR°vas",
"crevassés" => "kR°vase",
"crevât" => "kR°va",
"crève" => "kREv",
"crevé" => "kR°ve",
"crevée" => "kR°ve",
"crevées" => "kR°ve",
"crèvent" => "kREv",
"crever" => "kR°ve",
"crèvera" => "kREv°Ra",
"crèverai" => "kREv°RE",
"crèveraient" => "kREv°RE",
"crèverais" => "kREv°RE",
"crèverait" => "kREv°RE",
"crèveras" => "kREv°Ra",
"crevèrent" => "kR°vER",
"crèverez" => "kREv°Re",
"crèveriez" => "kREv°Rje",
"crèverons" => "kREv°R§",
"crèveront" => "kREv°R§",
"crèves" => "kREv",
"crevés" => "kR°ve",
"crevette" => "kR°vEt",
"crevettes" => "kR°vEt",
"crevettier" => "kR°v°tje",
"crevettiers" => "kR°v°tje",
"crevez" => "kR°ve",
"creviez" => "kR°vje",
"crevions" => "kR°vj§",
"crevons" => "kR°v§",
"crevotant" => "kR°vot@",
"crevure" => "kR°vyR",
"crevures" => "kR°vyR",
"cri" => "kRi",
"cria" => "kRija",
"criai" => "kRijE",
"criaient" => "kRijE",
"criaillaient" => "kRiajE",
"criaillait" => "kRiajE",
"criaillant" => "kRiaj@",
"criaillement" => "kRiaj°m@",
"criaillent" => "kRiaj",
"criailler" => "kRiaje",
"criaillerie" => "kRiaj°Ri",
"criailleries" => "kRiaj°Ri",
"criais" => "kRijE",
"criait" => "kRijE",
"criant" => "kRij@",
"criante" => "kRij@t",
"criantes" => "kRij@t",
"criard" => "kRijaR",
"criarde" => "kRijaRd",
"criardes" => "kRijaRd",
"criards" => "kRijaR",
"criât" => "kRija",
"crib" => "kRib",
"cribla" => "kRibla",
"criblage" => "kRiblaZ",
"criblaient" => "kRiblE",
"criblait" => "kRiblE",
"criblant" => "kRibl@",
"crible" => "kRibl",
"criblé" => "kRible",
"criblée" => "kRible",
"criblées" => "kRible",
"criblent" => "kRibl",
"cribler" => "kRible",
"cribles" => "kRibl",
"criblés" => "kRible",
"cric" => "kRik",
"cric-crac" => "kRikkRak",
"cricket" => "kRikEt",
"crickets" => "kRikEt",
"cricoïde" => "kRikoid",
"cricri" => "kRikRi",
"cricris" => "kRikRi",
"crics" => "kRik",
"crie" => "kRi",
"crié" => "kRije",
"criée" => "kRije",
"criées" => "kRije",
"crient" => "kRi",
"crier" => "kRije",
"criera" => "kRiRa",
"crierai" => "kRiRE",
"crieraient" => "kRiRE",
"crierais" => "kRiRE",
"crierait" => "kRiRE",
"crieras" => "kRiRa",
"crièrent" => "kRijER",
"crieront" => "kRiR§",
"cries" => "kRi",
"criés" => "kRije",
"crieur" => "kRij9R",
"crieurs" => "kRij9R",
"crieuse" => "kRij2z",
"criez" => "kRije",
"criions" => "kRij§",
"crime" => "kRim",
"crimes" => "kRim",
"criminaliser" => "kRiminalize",
"criminaliste" => "kRiminalist",
"criminalistique" => "kRiminalistik",
"criminalité" => "kRiminalite",
"criminel" => "kRiminEl",
"criminelle" => "kRiminEl",
"criminellement" => "kRiminEl°m@",
"criminelles" => "kRiminEl",
"criminels" => "kRiminEl",
"criminologie" => "kRiminoloZi",
"criminologiste" => "kRiminoloZist",
"criminologue" => "kRiminolOg",
"criminologues" => "kRiminolOg",
"crin" => "kR5",
"crincrin" => "kR5kR5",
"crincrins" => "kR5kR5",
"crinière" => "kRinjER",
"crinières" => "kRinjER",
"crinoline" => "kRinolin",
"crinolines" => "kRinolin",
"crins" => "kR5",
"crions" => "kRij§",
"crique" => "kRik",
"criques" => "kRik",
"criquet" => "kRikE",
"criquets" => "kRikE",
"cris" => "kRi",
"cris-craft" => "kRikRaft",
"crise" => "kRiz",
"crises" => "kRiz",
"crispa" => "kRispa",
"crispai" => "kRispE",
"crispaient" => "kRispE",
"crispait" => "kRispE",
"crispant" => "kRisp@",
"crispante" => "kRisp@t",
"crispantes" => "kRisp@t",
"crispation" => "kRispasj§",
"crispations" => "kRispasj§",
"crispe" => "kRisp",
"crispé" => "kRispe",
"crispée" => "kRispe",
"crispées" => "kRispe",
"crispent" => "kRisp",
"crisper" => "kRispe",
"crispèrent" => "kRispER",
"crispes" => "kRisp",
"crispés" => "kRispe",
"crispin" => "kRisp5",
"crissa" => "kRisa",
"crissaient" => "kRisE",
"crissait" => "kRisE",
"crissant" => "kRis@",
"crisse" => "kRis",
"crissé" => "kRise",
"crissement" => "kRis°m@",
"crissements" => "kRis°m@",
"crissent" => "kRis",
"crisser" => "kRise",
"crissèrent" => "kRisER",
"cristal" => "kRistal",
"cristallerie" => "kRistal°Ri",
"cristalleries" => "kRistal°Ri",
"cristallin" => "kRistal5",
"cristalline" => "kRistalin",
"cristallines" => "kRistalin",
"cristallins" => "kRistal5",
"cristallisaient" => "kRistalizE",
"cristallisait" => "kRistalizE",
"cristallisation" => "kRistalizasj§",
"cristallise" => "kRistaliz",
"cristallisé" => "kRistalize",
"cristallisée" => "kRistalize",
"cristallisées" => "kRistalize",
"cristallisent" => "kRistaliz",
"cristalliser" => "kRistalize",
"cristallisera" => "kRistaliz°Ra",
"cristallisèrent" => "kRistalizER",
"cristallisés" => "kRistalize",
"cristallographie" => "kRistalogRafi",
"cristalloïde" => "kRistaloid",
"cristallomancie" => "kRistalOm@si",
"cristaux" => "kRisto",
"cristi" => "kRisti",
"critère" => "kRitER",
"critères" => "kRitER",
"critérium" => "kRiteRjOm",
"critériums" => "kRiteRjOm",
"criticaillent" => "kRitikaj",
"critiqua" => "kRitika",
"critiquable" => "kRitikabl",
"critiquables" => "kRitikabl",
"critiquaient" => "kRitikE",
"critiquais" => "kRitikE",
"critiquait" => "kRitikE",
"critiquant" => "kRitik@",
"critiquât" => "kRitika",
"critique" => "kRitik",
"critiqué" => "kRitike",
"critiquée" => "kRitike",
"critiquées" => "kRitike",
"critiquent" => "kRitik",
"critiquer" => "kRitike",
"critiquera" => "kRitik°Ra",
"critiquerais" => "kRitik°RE",
"critiquerait" => "kRitik°RE",
"critiqueras" => "kRitik°Ra",
"critiques" => "kRitik",
"critiqués" => "kRitike",
"critiquez" => "kRitike",
"critiquiez" => "kRitikje",
"critiquons" => "kRitik§",
"croa croa" => "kRoakRoa",
"croa-croa" => "kRoakRoa",
"croassa" => "kRoasa",
"croassaient" => "kRoasE",
"croassait" => "kRoasE",
"croassant" => "kRoas@",
"croasse" => "kRoas",
"croassement" => "kRoas°m@",
"croassements" => "kRoas°m@",
"croassent" => "kRoas",
"croasser" => "kRoase",
"croate" => "kRoat",
"croates" => "kRoat",
"crobard" => "kRObaR",
"croc" => "kRo",
"croc-en-jambe" => "kRok@Z@b",
"crocha" => "kRoSa",
"crochaient" => "kRoSE",
"crochait" => "kRoSE",
"croche" => "kROS",
"croché" => "kRoSe",
"croche-patte" => "kROSpat",
"croche-pied" => "kROSpje",
"croche-pieds" => "kROSpje",
"crochées" => "kRoSe",
"crochent" => "kROS",
"crocher" => "kRoSe",
"croches" => "kROS",
"crochet" => "kRoSE",
"crocheta" => "kROS°ta",
"crochetage" => "kROS°taZ",
"crochetaient" => "kROS°tE",
"crochetait" => "kROS°tE",
"crochetant" => "kROS°t@",
"crocheté" => "kROS°te",
"crochetées" => "kROS°te",
"crochètent" => "kRoSEt",
"crocheter" => "kROS°te",
"crochetés" => "kROS°te",
"crocheteur" => "kROS°t9R",
"crocheteurs" => "kROS°t9R",
"crochets" => "kRoSE",
"crochu" => "kRoSy",
"crochue" => "kRoSy",
"crochues" => "kRoSy",
"crochus" => "kRoSy",
"croco" => "kRoko",
"crocodile" => "kRokodil",
"crocodiles" => "kRokodil",
"crocos" => "kRoko",
"crocs" => "kRo",
"crocs-en-jambe" => "kRok@Z@b",
"crocus" => "kRokys",
"croie" => "kRwa",
"croient" => "kRwa",
"croies" => "kRwa",
"croira" => "kRwaRa",
"croirai" => "kRwaRE",
"croiraient" => "kRwaRE",
"croirais" => "kRwaRE",
"croirait" => "kRwaRE",
"croiras" => "kRwaRa",
"croire" => "kRwaR",
"croirez" => "kRwaRe",
"croiriez" => "kRwaRje",
"croirions" => "kRwaRj§",
"croirons" => "kRwaR§",
"croiront" => "kRwaR§",
"crois" => "kRwa",
"croîs" => "kRwa",
"croisa" => "kRwaza",
"croisade" => "kRwazad",
"croisades" => "kRwazad",
"croisai" => "kRwazE",
"croisaient" => "kRwazE",
"croisais" => "kRwazE",
"croisait" => "kRwazE",
"croisâmes" => "kRwazam",
"croisant" => "kRwaz@",
"croisât" => "kRwaza",
"croise" => "kRwaz",
"croisé" => "kRwaze",
"croisée" => "kRwaze",
"croisées" => "kRwaze",
"croisement" => "kRwaz°m@",
"croisements" => "kRwaz°m@",
"croisent" => "kRwaz",
"croiser" => "kRwaze",
"croisera" => "kRwaz°Ra",
"croiserai" => "kRwaz°RE",
"croiseraient" => "kRwaz°RE",
"croiserais" => "kRwaz°RE",
"croiserait" => "kRwaz°RE",
"croisèrent" => "kRwazER",
"croiserez" => "kRwaz°Re",
"croiserons" => "kRwaz°R§",
"croiseront" => "kRwaz°R§",
"croises" => "kRwaz",
"croisés" => "kRwaze",
"croisette" => "kRwazEt",
"croiseur" => "kRwaz9R",
"croiseurs" => "kRwaz9R",
"croisez" => "kRwaze",
"croisière" => "kRwazjER",
"croisières" => "kRwazjER",
"croisillon" => "kRwazij§",
"croisillons" => "kRwazij§",
"croisions" => "kRwazj§",
"croisons" => "kRwaz§",
"croissaient" => "kRwasE",
"croissais" => "kRwasE",
"croissait" => "kRwasE",
"croissance" => "kRwas@s",
"croissances" => "kRwas@s",
"croissant" => "kRwas@",
"croissante" => "kRwas@t",
"croissantes" => "kRwas@t",
"croissants" => "kRwas@",
"croisse" => "kRwas",
"croissent" => "kRwas",
"croissez" => "kRwase",
"croit" => "kRwa",
"croît" => "kRwa",
"croîtraient" => "kRwatRE",
"croîtrait" => "kRwatRE",
"croître" => "kRwatR",
"croix" => "kRwa",
"cromlech" => "kROmlEk",
"cromlechs" => "kROmlEk",
"cromorne" => "kRomORn",
"cronstadt" => "kR§stat",
"crooner" => "kRun9R",
"crooners" => "kRun9R",
"croqua" => "kRoka",
"croquai" => "kRokE",
"croquaient" => "kRokE",
"croquais" => "kRokE",
"croquait" => "kRokE",
"croquant" => "kRok@",
"croquante" => "kRok@t",
"croquantes" => "kRok@t",
"croquants" => "kRok@",
"croque" => "kROk",
"croqué" => "kRoke",
"croque-madame" => "kROkmadam",
"croque-mitaine" => "kROkmitEn",
"croque-monsieur" => "kROkm°sj2",
"croque-mort" => "kROkmOR",
"croque-morts" => "kROkmOR",
"croquée" => "kRoke",
"croquées" => "kRoke",
"croquemitaine" => "kROk°mitEn",
"croquemitaines" => "kROk°mitEn",
"croquemort" => "kROk°mOR",
"croquemorts" => "kROk°mOR",
"croquenots" => "kROk°no",
"croquent" => "kROk",
"croquer" => "kRoke",
"croquera" => "kROk°Ra",
"croquerai" => "kROk°RE",
"croqueraient" => "kROk°RE",
"croquerais" => "kROk°RE",
"croquerait" => "kROk°RE",
"croquèrent" => "kRokER",
"croquerons" => "kROk°R§",
"croques" => "kROk",
"croqués" => "kRoke",
"croquet" => "kRokE",
"croqueton" => "kROk°t§",
"croquetons" => "kROk°t§",
"croquette" => "kRokEt",
"croquettes" => "kRokEt",
"croqueur" => "kROk9R",
"croqueuse" => "kRok2z",
"croquez" => "kRoke",
"croquignol" => "kRokiNOl",
"croquignolet" => "kRokiNolE",
"croquignolets" => "kRokiNolE",
"croquis" => "kRoki",
"croquis-minute" => "kRokiminyt",
"croquons" => "kRok§",
"crosne" => "kROn",
"crosnes" => "kROn",
"cross" => "kROs",
"cross-country" => "kROskawntRi",
"crosse" => "kROs",
"crossé" => "kRose",
"crosser" => "kROse",
"crosses" => "kROs",
"crossman" => "kROsman",
"crotale" => "kRotal",
"crotales" => "kRotal",
"croton" => "kRot§",
"crottait" => "kRotE",
"crotte" => "kROt",
"crotté" => "kRote",
"crottée" => "kRote",
"crottées" => "kRote",
"crotter" => "kRote",
"crottes" => "kROt",
"crottés" => "kRote",
"crottin" => "kRot5",
"crottins" => "kRot5",
"crouillat" => "kRuja",
"crouillats" => "kRuja",
"crouille" => "kRuj",
"croula" => "kRula",
"croulaient" => "kRulE",
"croulait" => "kRulE",
"croulant" => "kRul@",
"croulante" => "kRul@t",
"croulantes" => "kRul@t",
"croulants" => "kRul@",
"croulât" => "kRula",
"croule" => "kRul",
"croulé" => "kRule",
"croulée" => "kRule",
"croulement" => "kRul°m@",
"croulent" => "kRul",
"crouler" => "kRule",
"croulera" => "kRul°Ra",
"croulerai" => "kRul°RE",
"crouleraient" => "kRul°RE",
"croulerait" => "kRul°RE",
"crouleras" => "kRul°Ra",
"croulèrent" => "kRulER",
"croulerons" => "kRul°R§",
"crouleront" => "kRul°R§",
"croulés" => "kRule",
"croulons" => "kRul§",
"croup" => "kRup",
"croupade" => "kRupad",
"croupe" => "kRup",
"croupes" => "kRup",
"croupi" => "kRupi",
"croupie" => "kRupi",
"croupier" => "kRupje",
"croupière" => "kRupjER",
"croupières" => "kRupjER",
"croupiers" => "kRupje",
"croupies" => "kRupi",
"croupion" => "kRupj§",
"croupionne" => "kRupjOn",
"croupions" => "kRupj§",
"croupir" => "kRupiR",
"croupira" => "kRupiRa",
"croupis" => "kRupi",
"croupissaient" => "kRupisE",
"croupissais" => "kRupisE",
"croupissait" => "kRupisE",
"croupissant" => "kRupis@",
"croupissante" => "kRupis@t",
"croupissantes" => "kRupis@t",
"croupissent" => "kRupis",
"croupissez" => "kRupise",
"croupissoir" => "kRupiswaR",
"croupissure" => "kRupisyR",
"croupit" => "kRupi",
"croupon" => "kRup§",
"croustade" => "kRustad",
"croustades" => "kRustad",
"croustillaient" => "kRustijE",
"croustillait" => "kRustijE",
"croustillance" => "kRustij@s",
"croustillant" => "kRustij@",
"croustillante" => "kRustij@t",
"croustillantes" => "kRustij@t",
"croustillants" => "kRustij@",
"croustille" => "kRustij",
"croustillent" => "kRustij",
"croustilles" => "kRustij",
"croustillon" => "kRustij§",
"croustillons" => "kRustij§",
"croûte" => "kRut",
"croûté" => "kRute",
"croûtée" => "kRute",
"croûtées" => "kRute",
"croûter" => "kRute",
"croûtes" => "kRut",
"croûteuse" => "kRut2z",
"croûteuses" => "kRut2z",
"croûteux" => "kRut2",
"croûton" => "kRut§",
"croûtonnais" => "kRutonE",
"croûtons" => "kRut§",
"crown" => "kRawn",
"croyable" => "kRwajabl",
"croyables" => "kRwajabl",
"croyaient" => "kRwajE",
"croyais" => "kRwajE",
"croyait" => "kRwajE",
"croyance" => "kRwaj@s",
"croyances" => "kRwaj@s",
"croyant" => "kRwaj@",
"croyante" => "kRwaj@t",
"croyantes" => "kRwaj@t",
"croyants" => "kRwaj@",
"croyez" => "kRwaje",
"croyiez" => "kRwaje",
"croyions" => "kRwajj§",
"croyons" => "kRwaj§",
"cru" => "kRy",
"crû" => "kRy",
"cruauté" => "kRyote",
"cruautés" => "kRyote",
"cruche" => "kRyS",
"cruches" => "kRyS",
"cruchon" => "kRyS§",
"cruchons" => "kRyS§",
"crucial" => "kRysjal",
"cruciale" => "kRysjal",
"crucialement" => "kRysjal°m@",
"cruciales" => "kRysjal",
"cruciaux" => "kRysjo",
"crucifère" => "kRysifER",
"crucifères" => "kRysifER",
"crucifia" => "kRysifja",
"crucifiaient" => "kRysifjE",
"crucifiait" => "kRysifjE",
"crucifiant" => "kRysifj@",
"crucifiante" => "kRysifj@t",
"crucifie" => "kRysifi",
"crucifié" => "kRysifje",
"crucifiée" => "kRysifje",
"crucifiées" => "kRysifje",
"crucifiement" => "kRysifim@",
"crucifient" => "kRysifi",
"crucifier" => "kRysifje",
"crucifierez" => "kRysifiRe",
"crucifieront" => "kRysifiR§",
"crucifiés" => "kRysifje",
"crucifiez" => "kRysifje",
"crucifix" => "kRysifi",
"crucifixion" => "kRysifiksj§",
"crucifixions" => "kRysifiksj§",
"cruciforme" => "kRysifORm",
"cruciformes" => "kRysifORm",
"cruciverbiste" => "kRysivERbist",
"cruciverbistes" => "kRysivERbist",
"crudité" => "kRydite",
"crudités" => "kRydite",
"crue" => "kRy",
"cruel" => "kRyEl",
"cruelle" => "kRyEl",
"cruellement" => "kRyEl°m@",
"cruelles" => "kRyEl",
"cruels" => "kRyEl",
"crues" => "kRy",
"cruiser" => "kRuze",
"crumble" => "kR9mb9l",
"crûment" => "kRym@",
"crûmes" => "kRym",
"crurent" => "kRyR",
"crus" => "kRy",
"crusse" => "kRys",
"crussent" => "kRys",
"crusses" => "kRys",
"crustacé" => "kRystase",
"crustacés" => "kRystase",
"crut" => "kRy",
"crût" => "kRy",
"çruti" => "sRyti",
"cruzeiro" => "kRuzERo",
"cruzeiros" => "kRuzEROs",
"cryofracture" => "kRijofRaktyR",
"cryogène" => "kRijoZEn",
"cryogénie" => "kRijoZeni",
"cryogénique" => "kRijoZenik",
"cryogéniques" => "kRijoZenik",
"cryogénisation" => "kRijoZenizasj§",
"cryonique" => "kRijonik",
"cryotechnique" => "kRiotEknik",
"cryptage" => "kRiptaZ",
"crypte" => "kRipt",
"crypté" => "kRipte",
"cryptée" => "kRipte",
"cryptées" => "kRipte",
"crypter" => "kRipte",
"cryptes" => "kRipt",
"cryptés" => "kRipte",
"cryptique" => "kRiptik",
"cryptiques" => "kRiptik",
"crypto" => "kRipto",
"cryptocommunistes" => "kRiptokomynist",
"cryptogame" => "kRiptogam",
"cryptogames" => "kRiptogam",
"cryptogamique" => "kRiptogamik",
"cryptogramme" => "kRiptogRam",
"cryptogrammes" => "kRiptogRam",
"cryptographe" => "kRiptogRaf",
"cryptographie" => "kRiptogRafi",
"cryptographique" => "kRiptogRafik",
"cryptologie" => "kRiptOlOZi",
"cryptomère" => "kRiptomER",
"csardas" => "ksaRdas",
"cuadrilla" => "kwadRija",
"cuadrillas" => "kwadRija",
"cubage" => "kybaZ",
"cubages" => "kybaZ",
"cubain" => "kyb5",
"cubaine" => "kybEn",
"cubaines" => "kybEn",
"cubains" => "kyb5",
"cubait" => "kybE",
"cubasse" => "kybas",
"cube" => "kyb",
"cubes" => "kyb",
"cubique" => "kybik",
"cubiques" => "kybik",
"cubisme" => "kybizm",
"cubiste" => "kybist",
"cubistes" => "kybist",
"cubitainer" => "kybitEn9R",
"cubital" => "kybital",
"cubitale" => "kybital",
"cubitières" => "kybisjER",
"cubitus" => "kybitys",
"cucaracha" => "kukaRatSa",
"cucu" => "kyky",
"cucul" => "kyky",
"cucurbitacée" => "kykyRbitase",
"cucurbite" => "kykyRbit",
"cucurbites" => "kykyRbit",
"cucuterie" => "kykyt°Ri",
"cueillaient" => "k9jE",
"cueillais" => "k9jE",
"cueillaison" => "k9jEz§",
"cueillait" => "k9jE",
"cueillant" => "k9j@",
"cueille" => "k9j",
"cueillent" => "k9j",
"cueillera" => "k9j°Ra",
"cueillerai" => "k9j°RE",
"cueillerais" => "k9j°RE",
"cueillerait" => "k9j°RE",
"cueilleras" => "k9j°Ra",
"cueilleront" => "k9j°R§",
"cueilles" => "k9j",
"cueillette" => "k9jEt",
"cueillettes" => "k9jEt",
"cueilleur" => "k9j9R",
"cueilleurs" => "k9j9R",
"cueilleuse" => "k9j2z",
"cueilleuses" => "k9j2z",
"cueillez" => "k9je",
"cueilli" => "k9ji",
"cueillie" => "k9ji",
"cueillies" => "k9ji",
"cueillîmes" => "k9jim",
"cueillir" => "k9jiR",
"cueillirent" => "k9jiR",
"cueillis" => "k9ji",
"cueillissent" => "k9jis",
"cueillit" => "k9ji",
"cueillons" => "k9j§",
"cuesta" => "kwEsta",
"cueva" => "kueva",
"cuevas" => "kuevas",
"cui-cui" => "k8ik8i",
"cuiller" => "k8ijER",
"cuillère" => "k8ijER",
"cuillerée" => "k8ijeRe",
"cuillerées" => "k8ijeRe",
"cuillères" => "k8ijER",
"cuilleron" => "k8ij°R§",
"cuillers" => "k8ijER",
"cuir" => "k8iR",
"cuira" => "k8iRa",
"cuirai" => "k8iRE",
"cuirait" => "k8iRE",
"cuiras" => "k8iRa",
"cuirassaient" => "k8iRasE",
"cuirassait" => "k8iRasE",
"cuirasse" => "k8iRas",
"cuirassé" => "k8iRase",
"cuirassée" => "k8iRase",
"cuirassées" => "k8iRase",
"cuirassements" => "k8iRas°m@",
"cuirassent" => "k8iRas",
"cuirasser" => "k8iRase",
"cuirasses" => "k8iRas",
"cuirassés" => "k8iRase",
"cuirassier" => "k8iRasje",
"cuirassiers" => "k8iRasje",
"cuire" => "k8iR",
"cuirez" => "k8iRe",
"cuiront" => "k8iR§",
"cuirs" => "k8iR",
"cuis" => "k8i",
"cuisaient" => "k8izE",
"cuisait" => "k8izE",
"cuisant" => "k8iz@",
"cuisante" => "k8iz@t",
"cuisantes" => "k8iz@t",
"cuisants" => "k8iz@",
"cuise" => "k8iz",
"cuisent" => "k8iz",
"cuises" => "k8iz",
"cuiseurs" => "k8iz9R",
"cuisez" => "k8ize",
"cuisiez" => "k8izje",
"cuisina" => "k8izina",
"cuisinaient" => "k8izinE",
"cuisinais" => "k8izinE",
"cuisinait" => "k8izinE",
"cuisinant" => "k8izin@",
"cuisine" => "k8izin",
"cuisiné" => "k8izine",
"cuisinée" => "k8izine",
"cuisinées" => "k8izine",
"cuisinent" => "k8izin",
"cuisiner" => "k8izine",
"cuisinera" => "k8izin°Ra",
"cuisinerai" => "k8izin°RE",
"cuisinerais" => "k8izin°RE",
"cuisinerait" => "k8izin°RE",
"cuisineras" => "k8izin°Ra",
"cuisinerons" => "k8izin°R§",
"cuisines" => "k8izin",
"cuisinés" => "k8izine",
"cuisinette" => "k8izinEt",
"cuisinez" => "k8izine",
"cuisinier" => "k8izinje",
"cuisinière" => "k8izinjER",
"cuisinières" => "k8izinjER",
"cuisiniers" => "k8izinje",
"cuisiniez" => "k8izinje",
"cuisinons" => "k8izin§",
"cuisit" => "k8izi",
"cuisons" => "k8iz§",
"cuissage" => "k8isaZ",
"cuissard" => "k8isaR",
"cuissardes" => "k8isaRd",
"cuissards" => "k8isaR",
"cuisse" => "k8is",
"cuisse-madame" => "k8ismadam",
"cuisseau" => "k8iso",
"cuisses" => "k8is",
"cuissette" => "k8isEt",
"cuissettes" => "k8isEt",
"cuisson" => "k8is§",
"cuissons" => "k8is§",
"cuissot" => "k8iso",
"cuissots" => "k8iso",
"cuistance" => "k8ist@s",
"cuistances" => "k8ist@s",
"cuistot" => "k8isto",
"cuistots" => "k8isto",
"cuistre" => "k8istR",
"cuistrerie" => "k8istR°Ri",
"cuistreries" => "k8istR°Ri",
"cuistres" => "k8istR",
"cuit" => "k8i",
"cuitant" => "k8it@",
"cuite" => "k8it",
"cuité" => "k8ite",
"cuiter" => "k8ite",
"cuites" => "k8it",
"cuits" => "k8i",
"cuivra" => "k8ivRa",
"cuivrait" => "k8ivRE",
"cuivre" => "k8ivR",
"cuivré" => "k8ivRe",
"cuivrée" => "k8ivRe",
"cuivrées" => "k8ivRe",
"cuivres" => "k8ivR",
"cuivrés" => "k8ivRe",
"cuivreux" => "k8ivR2",
"cul" => "ky",
"cul-bénit" => "kybeni",
"cul-blanc" => "kybl@",
"cul-cul" => "kyky",
"cul-de-basse-fosse" => "kyd°basfos",
"cul-de-four" => "kyd°fuR",
"cul-de-jatte" => "kyd°Zat",
"cul-de-lampe" => "kyd°l@p",
"cul-de-plomb" => "kydpl§",
"cul-de-porc" => "kydpOR",
"cul-de-poule" => "kydpul",
"cul-de-sac" => "kydsak",
"cul-terreux" => "kytER2",
"culasse" => "kylas",
"culasses" => "kylas",
"culbuta" => "kylbyta",
"culbutages" => "kylbytaZ",
"culbutaient" => "kylbytE",
"culbutait" => "kylbytE",
"culbutant" => "kylbyt@",
"culbute" => "kylbyt",
"culbuté" => "kylbyte",
"culbutée" => "kylbyte",
"culbutées" => "kylbyte",
"culbutent" => "kylbyt",
"culbuter" => "kylbyte",
"culbuterais" => "kylbyt°RE",
"culbutèrent" => "kylbytER",
"culbutes" => "kylbyt",
"culbutés" => "kylbyte",
"culbuteur" => "kylbyt9R",
"culbuteurs" => "kylbyt9R",
"culbuto" => "kylbyto",
"cule" => "kyl",
"culé" => "kyle",
"culée" => "kyle",
"culer" => "kyle",
"culex" => "kylEks",
"culinaire" => "kylinER",
"culinaires" => "kylinER",
"culmina" => "kylmina",
"culminait" => "kylminE",
"culminance" => "kylmin@s",
"culminant" => "kylmin@",
"culminants" => "kylmin@",
"culmination" => "kylminasj§",
"culmine" => "kylmin",
"culminé" => "kylmine",
"culminent" => "kylmin",
"culminer" => "kylmine",
"culons" => "kyl§",
"culot" => "kylo",
"culots" => "kylo",
"culotte" => "kylOt",
"culotté" => "kylote",
"culottée" => "kylote",
"culottées" => "kylote",
"culotter" => "kylote",
"culottes" => "kylOt",
"culottés" => "kylote",
"culottier" => "kylotje",
"culottière" => "kylotjER",
"culottières" => "kylotjER",
"culottiers" => "kylotje",
"culpabilisais" => "kylpabilizE",
"culpabilisait" => "kylpabilizE",
"culpabilisant" => "kylpabiliz@",
"culpabilisation" => "kylpabilizasj§",
"culpabilise" => "kylpabiliz",
"culpabilisé" => "kylpabilize",
"culpabilisée" => "kylpabilize",
"culpabilisent" => "kylpabiliz",
"culpabiliser" => "kylpabilize",
"culpabiliserai" => "kylpabiliz°RE",
"culpabilises" => "kylpabiliz",
"culpabilisés" => "kylpabilize",
"culpabilisez" => "kylpabilize",
"culpabilisiez" => "kylpabilizje",
"culpabilisons" => "kylpabiliz§",
"culpabilité" => "kylpabilite",
"culs" => "ky",
"culs-bénits" => "kybeni",
"culs-blancs" => "kybl@",
"culs-de-basse-fosse" => "kyd°basfos",
"culs-de-jatte" => "kyd°Zat",
"culs-de-lampe" => "kyd°l@p",
"culs-de-sac" => "kydsak",
"culs-terreux" => "kytER2",
"culte" => "kylt",
"cultes" => "kylt",
"cultiva" => "kyltiva",
"cultivable" => "kyltivabl",
"cultivables" => "kyltivabl",
"cultivai" => "kyltivE",
"cultivaient" => "kyltivE",
"cultivais" => "kyltivE",
"cultivait" => "kyltivE",
"cultivant" => "kyltiv@",
"cultivateur" => "kyltivat9R",
"cultivateurs" => "kyltivat9R",
"cultivatrice" => "kyltivatRis",
"cultivatrices" => "kyltivatRis",
"cultive" => "kyltiv",
"cultivé" => "kyltive",
"cultivée" => "kyltive",
"cultivées" => "kyltive",
"cultivent" => "kyltiv",
"cultiver" => "kyltive",
"cultivera" => "kyltiv°Ra",
"cultiverai" => "kyltiv°RE",
"cultiveraient" => "kyltiv°RE",
"cultiverait" => "kyltiv°RE",
"cultiveras" => "kyltiv°Ra",
"cultivèrent" => "kyltivER",
"cultives" => "kyltiv",
"cultivés" => "kyltive",
"cultivez" => "kyltive",
"cultivions" => "kyltivj§",
"cultivons" => "kyltiv§",
"cultural" => "kyltyRal",
"culturalismes" => "kyltyRalizm",
"culture" => "kyltyR",
"culturel" => "kyltyREl",
"culturelle" => "kyltyREl",
"culturellement" => "kyltyREl°m@",
"culturelles" => "kyltyREl",
"culturels" => "kyltyREl",
"cultures" => "kyltyR",
"culturisme" => "kyltyRizm",
"culturiste" => "kyltyRist",
"culturistes" => "kyltyRist",
"cumin" => "kym5",
"cumul" => "kymyl",
"cumulaient" => "kymylE",
"cumulait" => "kymylE",
"cumulant" => "kymyl@",
"cumulard" => "kymylaR",
"cumulatif" => "kymylatif",
"cumulatifs" => "kymylatif",
"cumulation" => "kymylasj§",
"cumulative" => "kymylativ",
"cumule" => "kymyl",
"cumulé" => "kymyle",
"cumuler" => "kymyle",
"cumulera" => "kymyl°Ra",
"cumulés" => "kymyle",
"cumulez" => "kymyle",
"cumuliez" => "kymylje",
"cumulo-nimbus" => "kymylon5bys",
"cumulus" => "kymylys",
"cunéiforme" => "kyneifORm",
"cunéiformes" => "kyneifORm",
"cunnilinctus" => "kynil5ktys",
"cunnilingus" => "kynil5gys",
"cupide" => "kypid",
"cupidement" => "kypid°m@",
"cupides" => "kypid",
"cupidité" => "kypidite",
"cupidon" => "kypid§",
"cupidons" => "kypid§",
"cupressus" => "kypREsy",
"cuprifères" => "kypRifER",
"cupriques" => "kypRik",
"cupronickel" => "kypRonikEl",
"cupule" => "kypyl",
"cupules" => "kypyl",
"cura" => "kyRa",
"curable" => "kyRabl",
"curables" => "kyRabl",
"curaçao" => "kyRasao",
"curaçaos" => "kyRasao",
"curage" => "kyRaZ",
"curaille" => "kyRaj",
"curaillon" => "kyRaj§",
"curait" => "kyRE",
"curant" => "kyR@t",
"curare" => "kyRaR",
"curarisant" => "kyRaRiz@",
"curariser" => "kyRaRize",
"curateur" => "kyRat9R",
"curatif" => "kyRatif",
"curatifs" => "kyRatif",
"curative" => "kyRativ",
"curatives" => "kyRativ",
"curatrice" => "kyRatRis",
"curcuma" => "kyRkyma",
"cure" => "kyR",
"curé" => "kyRe",
"cure-dent" => "kyRd@",
"cure-dents" => "kyRd@",
"cure-pipe" => "kyRpip",
"cure-pipes" => "kyRpip",
"curée" => "kyRe",
"curées" => "kyRe",
"curer" => "kyRe",
"cureras" => "kyR°Ra",
"cures" => "kyR",
"curés" => "kyRe",
"curetage" => "kyR°taZ",
"cureter" => "kyR°te",
"cureton" => "kyR°t§",
"curetons" => "kyR°t§",
"curette" => "kyREt",
"curettes" => "kyREt",
"curial" => "kyRjal",
"curiales" => "kyRjal",
"curie" => "kyRi",
"curieuse" => "kyRj2z",
"curieusement" => "kyRj2z°m@",
"curieuses" => "kyRj2z",
"curieux" => "kyRj2",
"curiosité" => "kyRjozite",
"curiosités" => "kyRjozite",
"curiste" => "kyRist",
"curistes" => "kyRist",
"curling" => "k9RliG",
"curricula" => "kyRikyla",
"curriculum" => "kyRikylOm",
"curriculum vitae" => "kyRikylOmvite",
"curry" => "kyRi",
"curseur" => "kyRs9R",
"cursif" => "kyRsif",
"cursive" => "kyRsiv",
"cursus" => "kyRsys",
"curve" => "kyRv",
"curviligne" => "kyRviliN",
"curvilignes" => "kyRviliN",
"curvimètres" => "kyRvimEtR",
"custode" => "kystOd",
"custom" => "k9stOm",
"customisé" => "kystomize",
"cutané" => "kytane",
"cutanée" => "kytane",
"cutanées" => "kytane",
"cutanés" => "kytane",
"cuti" => "kyti",
"cuti-réaction" => "kytiReaksj§",
"cuticule" => "kytikyl",
"cuticules" => "kytikyl",
"cutis" => "kyti",
"cutter" => "kytER",
"cutters" => "kytER",
"cuvaient" => "kyvE",
"cuvait" => "kyvE",
"cuvant" => "kyv@",
"cuve" => "kyv",
"cuvé" => "kyve",
"cuveau" => "kyvo",
"cuveaux" => "kyvo",
"cuvée" => "kyve",
"cuvées" => "kyve",
"cuvent" => "kyv",
"cuver" => "kyve",
"cuvera" => "kyv°Ra",
"cuverez" => "kyv°Re",
"cuves" => "kyv",
"cuvette" => "kyvEt",
"cuvettes" => "kyvEt",
"cuvier" => "kyvje",
"cuviers" => "kyvje",
"cyan" => "sj@",
"cyanhydrique" => "sjanidRik",
"cyanoacrylate" => "sjanoakRilat",
"cyanobactérie" => "sjanobakteRi",
"cyanogène" => "sjanOZEn",
"cyanose" => "sjanoz",
"cyanosé" => "sjanoze",
"cyanosée" => "sjanoze",
"cyanure" => "sjanyR",
"cybercafé" => "sibERkafe",
"cyberespace" => "sibERespas",
"cybermonde" => "sibERm§d",
"cybernautes" => "sibERnot",
"cybernéticien" => "sibERnetisj5",
"cybernétique" => "sibERnetik",
"cybernétiques" => "sibERnetik",
"cybernétiser" => "sibERnetize",
"cyberspace" => "sibERspes",
"cycas" => "sikas",
"cyclable" => "siklabl",
"cyclables" => "siklabl",
"cyclamen" => "siklamEn",
"cyclamens" => "siklamEn",
"cycle" => "sikl",
"cyclées" => "sikle",
"cycles" => "sikl",
"cyclique" => "siklik",
"cycliquement" => "siklik°m@",
"cycliques" => "siklik",
"cyclisme" => "siklizm",
"cycliste" => "siklist",
"cyclistes" => "siklist",
"cyclo" => "siklo",
"cyclo-cross" => "siklokROs",
"cyclo-pousse" => "siklopus",
"cycloïdal" => "sikloidal",
"cyclomoteur" => "siklomot9R",
"cyclomoteurs" => "siklomot9R",
"cyclone" => "siklon",
"cyclones" => "siklon",
"cyclonique" => "siklonik",
"cyclope" => "siklOp",
"cyclopéen" => "siklope5",
"cyclopéenne" => "siklopeEn",
"cyclopéennes" => "siklopeEn",
"cyclopéens" => "siklope5",
"cyclopes" => "siklOp",
"cyclopousses" => "siklopus",
"cyclorama" => "siklORama",
"cyclosporine" => "siklospoRin",
"cyclostomes" => "siklostom",
"cyclothymie" => "siklotimi",
"cyclothymique" => "siklotimik",
"cyclotron" => "siklotR§",
"cygne" => "siN",
"cygnes" => "siN",
"cylindre" => "sil5dR",
"cylindré" => "sil5dRe",
"cylindrée" => "sil5dRe",
"cylindrées" => "sil5dRe",
"cylindres" => "sil5dR",
"cylindrés" => "sil5dRe",
"cylindrique" => "sil5dRik",
"cylindriques" => "sil5dRik",
"cymbale" => "s5bal",
"cymbales" => "s5bal",
"cymbaliste" => "s5balist",
"cymbalistes" => "s5balist",
"cymbalum" => "s5balOm",
"cymes" => "sim",
"cynégétique" => "sineZetik",
"cynégétiques" => "sineZetik",
"cynips" => "sinips",
"cynique" => "sinik",
"cyniquement" => "sinik°m@",
"cyniques" => "sinik",
"cynisme" => "sinizm",
"cynismes" => "sinizm",
"cynocéphale" => "sinosefal",
"cynocéphales" => "sinosefal",
"cynodrome" => "sinodRom",
"cynophile" => "sinOfil",
"cynos" => "sino",
"cyphoscoliose" => "sifoskOljoz",
"cyphose" => "sifoz",
"cyprès" => "sipRE",
"cyprin" => "sipR5",
"cyprinidé" => "sipRinide",
"cyprinidés" => "sipRinide",
"cyprins" => "sipR5",
"cypriote" => "sipRijOt",
"cypriotes" => "sipRijOt",
"cyrard" => "siRaR",
"cyrards" => "siRaR",
"cyrillique" => "siRilik",
"cyrilliques" => "siRilik",
"cystique" => "sistik",
"cystite" => "sistit",
"cystotomie" => "sistOtOmi",
"cytises" => "sitiz",
"cytologie" => "sitoloZi",
"cytologiques" => "sitoloZik",
"cytomégalovirus" => "sitomegaloviRys",
"cytoplasme" => "sitoplasm",
"cytoplasmique" => "sitOplasmik",
"cytosine" => "sitozin",
"cytotoxique" => "sitotOksik",
"czar" => "kzaR",
"czardas" => "kzaRdas",
"czars" => "kzaR",
"d" => "de",
"d'" => "d",
"d'abord" => "dabOR",
"d'autres" => "dotR",
"d'emblée" => "d@ble",
"d'ores et déjà" => "dORzedeZa",
"da" => "da",
"dab" => "dab",
"daba" => "daba",
"dabe" => "dab",
"dabs" => "dab",
"dabuche" => "dabyS",
"dabuches" => "dabyS",
"dace" => "das",
"daces" => "das",
"dache" => "daS",
"dacique" => "dasik",
"dacron" => "dakR§",
"dactyle" => "daktil",
"dactyles" => "daktil",
"dactylo" => "daktilo",
"dactylographe" => "daktilogRaf",
"dactylographes" => "daktilogRaf",
"dactylographie" => "daktilogRafi",
"dactylographié" => "daktilogRafje",
"dactylographiée" => "daktilogRafje",
"dactylographiées" => "daktilogRafje",
"dactylographier" => "daktilogRafje",
"dactylographiés" => "daktilogRafje",
"dactyloptères" => "daktiloptER",
"dactylos" => "daktilo",
"dactyloscopie" => "daktilOskOpi",
"dada" => "dada",
"dadais" => "dadE",
"dadaïsme" => "dadaizm",
"dadaïste" => "dadaist",
"dadaïstes" => "dadaist",
"dadas" => "dada",
"dague" => "dag",
"dagué" => "dage",
"daguerréotype" => "dagEReotip",
"daguerréotypes" => "dagEReotip",
"dagues" => "dag",
"daguet" => "dagE",
"daguets" => "dagE",
"dahlia" => "dalja",
"dahlias" => "dalja",
"dahoméenne" => "daomeEn",
"dahu" => "day",
"dahus" => "day",
"daigna" => "dENa",
"daignaient" => "dENE",
"daignait" => "dENE",
"daignant" => "dEN@",
"daignât" => "dENa",
"daigne" => "dEN",
"daigné" => "deNe",
"daignent" => "dEN",
"daigner" => "deNe",
"daignera" => "dEN°Ra",
"daigneraient" => "dEN°RE",
"daignerais" => "dEN°RE",
"daignerait" => "dEN°RE",
"daigneras" => "dEN°Ra",
"daignèrent" => "dENER",
"daignes" => "dEN",
"daignez" => "dENe",
"daignons" => "dEN§",
"daim" => "d5",
"daïmios" => "daimjos",
"daims" => "d5",
"daine" => "dEn",
"daiquiri" => "dajkiRi",
"daïquiri" => "dajkiRi",
"daiquiris" => "dajkiRi",
"daïquiris" => "dajkiRi",
"dais" => "dE",
"dakarois" => "dakaRwa",
"dakaroise" => "dakaRwaz",
"dakin" => "dak5",
"dakotas" => "dakota",
"dal" => "dal",
"dalaï-lama" => "dalailama",
"dale" => "dal",
"dalinienne" => "dalinjEn",
"dallage" => "dalaZ",
"dallages" => "dalaZ",
"dalle" => "dal",
"dallé" => "dale",
"dallée" => "dale",
"dallées" => "dale",
"daller" => "dale",
"dalles" => "dal",
"dallés" => "dale",
"dalmate" => "dalmat",
"dalmates" => "dalmat",
"dalmatien" => "dalmasj5",
"dalmatienne" => "dalmasjEn",
"dalmatiens" => "dalmasj5",
"dalmatique" => "dalmatik",
"dalmatiques" => "dalmatik",
"daltonien" => "daltonj5",
"daltonienne" => "daltonjEn",
"daltoniennes" => "daltonjEn",
"daltoniens" => "daltonj5",
"daltonisme" => "daltonizm",
"daltons" => "daltOn",
"dam" => "d@",
"damage" => "damaZ",
"damas" => "dama",
"damasquin" => "damask5",
"damasquinage" => "damaskinaZ",
"damasquiné" => "damaskine",
"damasquinée" => "damaskine",
"damasquinerie" => "damaskin°Ri",
"damasquinés" => "damaskine",
"damasquins" => "damask5",
"damasquinure" => "damaskinyR",
"damassé" => "damase",
"damassée" => "damase",
"damassées" => "damase",
"damassés" => "damase",
"dame" => "dam",
"damé" => "dame",
"dame-jeanne" => "damZan",
"damée" => "dame",
"damées" => "dame",
"dament" => "dam",
"damer" => "dame",
"dameret" => "dam°RE",
"dameriez" => "dam°Rje",
"dames" => "dam",
"dames-jeannes" => "damZan",
"damez" => "dame",
"damier" => "damje",
"damiers" => "damje",
"damnable" => "danabl",
"damnables" => "danabl",
"damnait" => "danE",
"damnant" => "dan@",
"damnation" => "danasj§",
"damnations" => "danasj§",
"damne" => "dan",
"damné" => "dane",
"damned" => "damnEd",
"damnée" => "dane",
"damnées" => "dane",
"damnent" => "dan",
"damner" => "dane",
"damnera" => "dan°Ra",
"damneraient" => "dan°RE",
"damnerais" => "dan°RE",
"damnés" => "dane",
"damnez" => "dane",
"damoiseau" => "damwazo",
"damoiselle" => "damwazEl",
"damoiselles" => "damwazEl",
"dams" => "d@",
"dan" => "dan",
"danaïde" => "danaid",
"dancing" => "d@siG",
"dancings" => "d@siG",
"dandina" => "d@dina",
"dandinaient" => "d@dinE",
"dandinais" => "d@dinE",
"dandinait" => "d@dinE",
"dandinant" => "d@din@",
"dandine" => "d@din",
"dandinée" => "d@dine",
"dandinement" => "d@din°m@",
"dandinements" => "d@din°m@",
"dandinent" => "d@din",
"dandiner" => "d@dine",
"dandinés" => "d@dine",
"dandinez" => "d@dine",
"dandy" => "d@di",
"dandys" => "d@di",
"dandysme" => "d@dizm",
"danger" => "d@Ze",
"dangereuse" => "d@Z°R2z",
"dangereusement" => "d@Z°R2z°m@",
"dangereuses" => "d@Z°R2z",
"dangereux" => "d@Z°R2",
"dangerosité" => "d@Z°Rozite",
"dangers" => "d@Ze",
"dano" => "dano",
"danois" => "danwa",
"danoise" => "danwaz",
"danoises" => "danwaz",
"dans" => "d@",
"dansa" => "d@sa",
"dansai" => "d@sE",
"dansaient" => "d@sE",
"dansais" => "d@sE",
"dansait" => "d@sE",
"dansâmes" => "d@sam",
"dansant" => "d@s@",
"dansante" => "d@s@t",
"dansantes" => "d@s@t",
"dansants" => "d@s@",
"danse" => "d@s",
"dansé" => "d@se",
"dansée" => "d@se",
"dansent" => "d@s",
"danser" => "d@se",
"dansera" => "d@s°Ra",
"danserai" => "d@s°RE",
"danseraient" => "d@s°RE",
"danserais" => "d@s°RE",
"danserait" => "d@s°RE",
"danseras" => "d@s°Ra",
"dansèrent" => "d@sER",
"danserez" => "d@s°Re",
"danseriez" => "d@s°Rje",
"danserions" => "d@s°Rj§",
"danserons" => "d@s°R§",
"danseront" => "d@s°R§",
"danses" => "d@s",
"danseur" => "d@s9R",
"danseurs" => "d@s9R",
"danseuse" => "d@s2z",
"danseuses" => "d@s2z",
"dansez" => "d@se",
"dansiez" => "d@sje",
"dansions" => "d@sj§",
"dansons" => "d@s§",
"dansota" => "d@sota",
"dansotait" => "d@sotE",
"dansotter" => "d@sote",
"dantesque" => "d@tEsk",
"dantesques" => "d@tEsk",
"danubien" => "danybj5",
"danubienne" => "danybjEn",
"danubiennes" => "danybjEn",
"dao" => "dao",
"daphné" => "dafne",
"darce" => "daRs",
"dard" => "daR",
"darda" => "daRda",
"dardaient" => "daRdE",
"dardait" => "daRdE",
"dardant" => "daRd@",
"darde" => "daRd",
"dardé" => "daRde",
"dardée" => "daRde",
"dardées" => "daRde",
"dardent" => "daRd",
"darder" => "daRde",
"dardés" => "daRde",
"dardillonnaient" => "daRdjonE",
"dardillonne" => "daRdjOn",
"dards" => "daR",
"dare dare" => "daRdaR",
"dare-dare" => "daRdaR",
"darioles" => "daRjOl",
"darne" => "daRn",
"daron" => "daR§",
"daronne" => "daROn",
"daronnes" => "daROn",
"darons" => "daR§",
"darse" => "daRs",
"darses" => "daRs",
"dartres" => "daRtR",
"dartreuses" => "daRtR2z",
"dasein" => "daz5",
"data" => "data",
"datable" => "databl",
"datage" => "dataZ",
"dataient" => "datE",
"datait" => "datE",
"datant" => "dat@",
"datation" => "datasj§",
"datcha" => "datSa",
"datchas" => "datSa",
"date" => "dat",
"daté" => "date",
"datée" => "date",
"datées" => "date",
"datent" => "dat",
"dater" => "date",
"daterai" => "dat°RE",
"daterais" => "dat°RE",
"daterait" => "dat°RE",
"dates" => "dat",
"datés" => "date",
"dateur" => "dat9R",
"datez" => "date",
"datif" => "datif",
"datte" => "dat",
"dattes" => "dat",
"dattier" => "datje",
"dattiers" => "datje",
"datura" => "datyRa",
"daturas" => "datyRa",
"daubait" => "dobE",
"daube" => "dob",
"daubé" => "dobe",
"dauber" => "dobe",
"daubes" => "dob",
"daubière" => "dobjER",
"dauphin" => "dof5",
"dauphinat" => "dofina",
"dauphine" => "dofin",
"dauphines" => "dofin",
"dauphinois" => "dofinwa",
"dauphins" => "dof5",
"daurade" => "doRad",
"daurades" => "doRad",
"davantage" => "dav@taZ",
"davier" => "davje",
"daya" => "daja",
"dc" => "dese",
"de" => "d2",
"dé" => "de",
"de amicis" => "deamikis",
"de auditu" => "deodity",
"de facto" => "defakto",
"de guingois" => "d2g5gwa",
"de plano" => "deplano",
"de profundis" => "depRofundis",
"de santis" => "des@tis",
"de traviole" => "d°tRavjOl",
"de visu" => "d2vizy",
"deadline" => "dEdlajn",
"deal" => "dil",
"dealaient" => "dilE",
"dealais" => "dilE",
"dealait" => "dilE",
"dealant" => "dil@",
"deale" => "dil",
"dealé" => "dile",
"dealent" => "dil",
"dealer" => "dil9R",
"dealera" => "dil°Ra",
"dealeront" => "dil°R§",
"dealers" => "dil9R",
"deales" => "dil",
"dealez" => "dile",
"deals" => "dil",
"déambula" => "de@byla",
"déambulai" => "de@bylE",
"déambulaient" => "de@bylE",
"déambulais" => "de@bylE",
"déambulait" => "de@bylE",
"déambulant" => "de@byl@",
"déambulante" => "de@byl@t",
"déambulateur" => "de@bylat9R",
"déambulation" => "de@bylasj§",
"déambulations" => "de@bylasj§",
"déambulatoire" => "de@bylatwaR",
"déambulatoires" => "de@bylatwaR",
"déambule" => "de@byl",
"déambulé" => "de@byle",
"déambulent" => "de@byl",
"déambuler" => "de@byle",
"déambulerai" => "de@byl°RE",
"déambulèrent" => "de@bylER",
"déambulez" => "de@byle",
"déambulions" => "de@bylj§",
"déambulons" => "de@byl§",
"débâcle" => "debakl",
"débâcles" => "debakl",
"débagoulage" => "debagulaZ",
"débagoule" => "debagul",
"débagouler" => "debagule",
"débagoulerait" => "debagul°RE",
"débagoules" => "debagul",
"débâillonné" => "debajone",
"déballa" => "debala",
"déballage" => "debalaZ",
"déballages" => "debalaZ",
"déballai" => "debalE",
"déballaient" => "debalE",
"déballais" => "debalE",
"déballait" => "debalE",
"déballant" => "debal@",
"déballe" => "debal",
"déballé" => "debale",
"déballée" => "debale",
"déballées" => "debale",
"déballent" => "debal",
"déballer" => "debale",
"déballera" => "debal°Ra",
"déballèrent" => "debalER",
"déballés" => "debale",
"déballez" => "debale",
"déballonnage" => "debalonaZ",
"déballonné" => "debalone",
"déballonner" => "debalone",
"déballonnerais" => "debalOn°RE",
"déballonneront" => "debalOn°R§",
"déballons" => "debal§",
"débanda" => "deb@da",
"débandade" => "deb@dad",
"débandaient" => "deb@dE",
"débandais" => "deb@dE",
"débandait" => "deb@dE",
"débande" => "deb@d",
"débandé" => "deb@de",
"débandées" => "deb@de",
"débandent" => "deb@d",
"débander" => "deb@de",
"débandera" => "deb@d°Ra",
"débanderaient" => "deb@d°RE",
"débandèrent" => "deb@dER",
"débandés" => "deb@de",
"débandez" => "deb@de",
"débaptisé" => "debatize",
"débaptisée" => "debatize",
"débaptiser" => "debatize",
"débaptiserais" => "debatiz°RE",
"débarbot" => "debaRbo",
"débarbots" => "debaRbo",
"débarbouilla" => "debaRbuja",
"débarbouillait" => "debaRbujE",
"débarbouillant" => "debaRbuj@",
"débarbouille" => "debaRbuj",
"débarbouillé" => "debaRbuje",
"débarbouillée" => "debaRbuje",
"débarbouiller" => "debaRbuje",
"débarbouillés" => "debaRbuje",
"débarbouillette" => "debaRbujEt",
"débarcadère" => "debaRkadER",
"débarcadères" => "debaRkadER",
"débardage" => "debaRdaZ",
"débardages" => "debaRdaZ",
"débardaient" => "debaRdE",
"débardée" => "debaRde",
"débarder" => "debaRde",
"débardeur" => "debaRd9R",
"débardeurs" => "debaRd9R",
"débaroule" => "debaRul",
"débaroulent" => "debaRul",
"débarqua" => "debaRka",
"débarquai" => "debaRkE",
"débarquaient" => "debaRkE",
"débarquais" => "debaRkE",
"débarquait" => "debaRkE",
"débarquâmes" => "debaRkam",
"débarquant" => "debaRk@",
"débarque" => "debaRk",
"débarqué" => "debaRke",
"débarquée" => "debaRke",
"débarquées" => "debaRke",
"débarquement" => "debaRk°m@",
"débarquements" => "debaRk°m@",
"débarquent" => "debaRk",
"débarquer" => "debaRke",
"débarquera" => "debaRk°Ra",
"débarquerai" => "debaRk°RE",
"débarqueraient" => "debaRk°RE",
"débarquerait" => "debaRk°RE",
"débarqueras" => "debaRk°Ra",
"débarquèrent" => "debaRkER",
"débarquerez" => "debaRk°Re",
"débarquerons" => "debaRk°R§",
"débarqueront" => "debaRk°R§",
"débarques" => "debaRk",
"débarqués" => "debaRke",
"débarquez" => "debaRke",
"débarquiez" => "debaRkje",
"débarquions" => "debaRkj§",
"débarquons" => "debaRk§",
"débarra" => "debaRa",
"débarras" => "debaRa",
"débarrassa" => "debaRasa",
"débarrassai" => "debaRasE",
"débarrassaient" => "debaRasE",
"débarrassais" => "debaRasE",
"débarrassait" => "debaRasE",
"débarrassant" => "debaRas@",
"débarrassât" => "debaRasa",
"débarrasse" => "debaRas",
"débarrassé" => "debaRase",
"débarrassée" => "debaRase",
"débarrassées" => "debaRase",
"débarrassent" => "debaRas",
"débarrasser" => "debaRase",
"débarrassera" => "debaRas°Ra",
"débarrasserai" => "debaRas°RE",
"débarrasserais" => "debaRas°RE",
"débarrasserait" => "debaRas°RE",
"débarrasseras" => "debaRas°Ra",
"débarrassèrent" => "debaRasER",
"débarrasserez" => "debaRas°Re",
"débarrasserons" => "debaRas°R§",
"débarrasseront" => "debaRas°R§",
"débarrasses" => "debaRas",
"débarrassés" => "debaRase",
"débarrassez" => "debaRase",
"débarrassiez" => "debaRasje",
"débarrassons" => "debaRas§",
"débarrer" => "debaRe",
"débarrons" => "debaR§",
"débat" => "deba",
"débâté" => "debate",
"débâtées" => "debate",
"debater" => "d°bate",
"débats" => "deba",
"débattaient" => "debatE",
"débattais" => "debatE",
"débattait" => "debatE",
"débattant" => "debat@",
"débatte" => "debat",
"débattent" => "debat",
"débatteur" => "debat9R",
"débattez" => "debate",
"débattiez" => "debatje",
"débattions" => "debatj§",
"débattirent" => "debatiR",
"débattis" => "debati",
"débattit" => "debati",
"débattît" => "debati",
"débattons" => "debat§",
"débattra" => "debatRa",
"débattraient" => "debatRE",
"débattrais" => "debatRE",
"débattrait" => "debatRE",
"débattre" => "debatR",
"débattrons" => "debatR§",
"débattu" => "debaty",
"débattue" => "debaty",
"débattues" => "debaty",
"débattus" => "debaty",
"débauchais" => "deboSE",
"débauchait" => "deboSE",
"débauchant" => "deboS@",
"débauche" => "deboS",
"débauché" => "deboSe",
"débauchée" => "deboSe",
"débauchées" => "deboSe",
"débaucher" => "deboSe",
"débauches" => "deboS",
"débauchés" => "deboSe",
"débaucheur" => "deboS9R",
"débaucheurs" => "deboS9R",
"débecquetait" => "debEk°tE",
"débectage" => "debEktaZ",
"débectait" => "debEktE",
"débectance" => "debEkt@s",
"débectant" => "debEkt@",
"débecte" => "debEkt",
"débecté" => "debEkte",
"débectée" => "debEkte",
"débectent" => "debEkt",
"débecter" => "debEkte",
"débecterais" => "debEkt°RE",
"débectés" => "debEkte",
"débectez" => "debEkte",
"débiffé" => "debife",
"débile" => "debil",
"débilement" => "debil°m@",
"débiles" => "debil",
"débilitaient" => "debilitE",
"débilitant" => "debilit@",
"débilitante" => "debilit@t",
"débilitantes" => "debilit@t",
"débilitation" => "debilitasj§",
"débilite" => "debilit",
"débilité" => "debilite",
"débilitée" => "debilite",
"débilités" => "debilite",
"débiller" => "debije",
"débinait" => "debinE",
"débine" => "debin",
"débiné" => "debine",
"débinées" => "debine",
"débinent" => "debin",
"débiner" => "debine",
"débinera" => "debin°Ra",
"débinerai" => "debin°RE",
"débinerait" => "debin°RE",
"débineras" => "debin°Ra",
"débines" => "debin",
"débinés" => "debine",
"débineurs" => "debin9R",
"débineuses" => "debin2z",
"débinez" => "debine",
"débit" => "debi",
"débita" => "debita",
"débitage" => "debitaZ",
"débitai" => "debitE",
"débitaient" => "debitE",
"débitais" => "debitE",
"débitait" => "debitE",
"débitant" => "debit@",
"débitants" => "debit@",
"débite" => "debit",
"débité" => "debite",
"débitée" => "debite",
"débitées" => "debite",
"débitent" => "debit",
"débiter" => "debite",
"débitera" => "debit°Ra",
"débiterai" => "debit°RE",
"débiterait" => "debit°RE",
"débites" => "debit",
"débités" => "debite",
"débiteur" => "debit9R",
"débiteurs" => "debit9R",
"débitez" => "debite",
"débitrice" => "debitRis",
"débits" => "debi",
"déblai" => "deblE",
"déblaie" => "deblE",
"déblaiement" => "deblEm@",
"déblaient" => "deblE",
"déblaierez" => "debleRe",
"déblais" => "deblE",
"déblatérait" => "deblateRE",
"déblatérant" => "deblateR@",
"déblatérations" => "deblateRasj§",
"déblatère" => "deblatER",
"déblatérer" => "deblateRe",
"déblaya" => "debleja",
"déblayage" => "deblEjaZ",
"déblayaient" => "deblejE",
"déblayait" => "deblejE",
"déblayant" => "deblej@",
"déblayé" => "debleje",
"déblayée" => "debleje",
"déblayées" => "debleje",
"déblayer" => "debleje",
"déblayera" => "deblej°Ra",
"déblayés" => "debleje",
"déblayeur" => "deblEj9R",
"déblayeurs" => "deblEj9R",
"déblayez" => "deblEje",
"déblocage" => "deblokaZ",
"déblocages" => "deblokaZ",
"débloqua" => "debloka",
"débloquait" => "deblokE",
"débloquant" => "deblok@",
"débloquât" => "debloka",
"débloque" => "deblOk",
"débloqué" => "debloke",
"débloquée" => "debloke",
"débloquent" => "deblOk",
"débloquer" => "debloke",
"débloques" => "deblOk",
"débloqués" => "debloke",
"débloquez" => "debloke",
"débobinage" => "debobinaZ",
"débobiner" => "debobine",
"débogage" => "debOgaZ",
"déboguer" => "deboge",
"déboire" => "debwaR",
"déboires" => "debwaR",
"déboisé" => "debwaze",
"déboisée" => "debwaze",
"déboisées" => "debwaze",
"déboisement" => "debwaz°m@",
"déboiser" => "debwaze",
"déboîta" => "debwata",
"déboîtaient" => "debwatE",
"déboîtais" => "debwatE",
"déboîtait" => "debwatE",
"déboîtant" => "debwat@",
"déboîte" => "debwat",
"déboîté" => "debwate",
"déboîtée" => "debwate",
"déboîtées" => "debwate",
"déboîtement" => "debwat°m@",
"déboîter" => "debwate",
"déboîtez" => "debwate",
"débonda" => "deb§da",
"débondait" => "deb§dE",
"débondant" => "deb§d@",
"débondé" => "deb§de",
"débonder" => "deb§de",
"débonnaire" => "debonER",
"débonnaires" => "debonER",
"débord" => "debOR",
"déborda" => "debORda",
"débordaient" => "debORdE",
"débordais" => "debORdE",
"débordait" => "debORdE",
"débordant" => "debORd@",
"débordante" => "debORd@t",
"débordantes" => "debORd@t",
"débordants" => "debORd@",
"débordât" => "debORda",
"déborde" => "debORd",
"débordé" => "debORde",
"débordée" => "debORde",
"débordées" => "debORde",
"débordement" => "debORd°m@",
"débordements" => "debORd°m@",
"débordent" => "debORd",
"déborder" => "debORde",
"débordera" => "debORd°Ra",
"déborderaient" => "debORd°RE",
"déborderait" => "debORd°RE",
"débordèrent" => "debORdER",
"débordés" => "debORde",
"débordez" => "debORde",
"débotté" => "debote",
"débottelons" => "debOt°l§",
"déboucha" => "debuSa",
"débouchage" => "debuSaZ",
"débouchai" => "debuSE",
"débouchaient" => "debuSE",
"débouchais" => "debuSE",
"débouchait" => "debuSE",
"débouchâmes" => "debuSam",
"débouchant" => "debuS@",
"débouche" => "debuS",
"débouché" => "debuSe",
"débouchée" => "debuSe",
"débouchées" => "debuSe",
"débouchent" => "debuS",
"déboucher" => "debuSe",
"débouchera" => "debuS°Ra",
"déboucherai" => "debuS°RE",
"déboucheraient" => "debuS°RE",
"déboucherait" => "debuS°RE",
"débouchèrent" => "debuSER",
"déboucherez" => "debuS°Re",
"débouchés" => "debuSe",
"déboucheur" => "debuS9R",
"déboucheurs" => "debuS9R",
"débouchez" => "debuSe",
"débouchions" => "debuSj§",
"débouchoir" => "debuSwaR",
"débouchoirs" => "debuSwaR",
"débouchons" => "debuS§",
"déboucla" => "debukla",
"débouclaient" => "debuklE",
"débouclait" => "debuklE",
"débouclant" => "debukl@",
"déboucle" => "debukl",
"débouclé" => "debukle",
"débouclées" => "debukle",
"débouclent" => "debukl",
"déboucler" => "debukle",
"débouclèrent" => "debuklER",
"débouclés" => "debukle",
"débouclez" => "debukle",
"débouclions" => "debuklij§",
"déboula" => "debula",
"déboulai" => "debulE",
"déboulaient" => "debulE",
"déboulais" => "debulE",
"déboulait" => "debulE",
"déboulant" => "debul@",
"déboule" => "debul",
"déboulé" => "debule",
"déboulent" => "debul",
"débouler" => "debule",
"déboulerais" => "debul°RE",
"déboulerait" => "debul°RE",
"déboulèrent" => "debulER",
"débouleront" => "debul°R§",
"déboulés" => "debule",
"déboulez" => "debule",
"débouliez" => "debulje",
"déboulions" => "debulj§",
"déboulonnant" => "debulon@",
"déboulonné" => "debulone",
"déboulonnée" => "debulone",
"déboulonnées" => "debulone",
"déboulonner" => "debulone",
"déboulonnez" => "debulone",
"débouquaient" => "debukE",
"débouqué" => "debuke",
"débourrage" => "debuRaZ",
"débourre" => "debuR",
"débourré" => "debuRe",
"débourrée" => "debuRe",
"débourrent" => "debuR",
"débourrer" => "debuRe",
"débours" => "debuR",
"débourse" => "debuRs",
"déboursé" => "debuRse",
"déboursées" => "debuRse",
"déboursement" => "debuRs2m@",
"débourser" => "debuRse",
"déboursera" => "debuRs°Ra",
"débourseront" => "debuRs°R§",
"déboussolait" => "debusolE",
"déboussolantes" => "debusol@t",
"déboussolé" => "debusole",
"déboussolée" => "debusole",
"déboussolées" => "debusole",
"déboussoler" => "debusole",
"déboussolés" => "debusole",
"debout" => "d°bu",
"déboutait" => "debutE",
"débouté" => "debute",
"déboutée" => "debute",
"débouter" => "debute",
"déboutonna" => "debutona",
"déboutonnage" => "debutonaZ",
"déboutonnait" => "debutonE",
"déboutonnant" => "debuton@",
"déboutonnât" => "debutona",
"déboutonne" => "debutOn",
"déboutonné" => "debutone",
"déboutonnée" => "debutone",
"déboutonnées" => "debutone",
"déboutonnent" => "debutOn",
"déboutonner" => "debutone",
"déboutonnés" => "debutone",
"déboutonnez" => "debutone",
"débraguette" => "debRagEt",
"débraguetté" => "debRagEte",
"débraguettent" => "debRagEt",
"débraguetter" => "debRagEte",
"débraguettés" => "debRagEte",
"débraillé" => "debRaje",
"débraillée" => "debRaje",
"débraillées" => "debRaje",
"débraillés" => "debRaje",
"débrancha" => "debR@Sa",
"débranchant" => "debR@S@",
"débranche" => "debR@S",
"débranché" => "debR@Se",
"débranchée" => "debR@Se",
"débranchées" => "debR@Se",
"débranchement" => "debR@S°m@",
"débranchent" => "debR@S",
"débrancher" => "debR@Se",
"débrancherai" => "debR@S°RE",
"débrancherais" => "debR@S°RE",
"débrancherait" => "debR@S°RE",
"débranchés" => "debR@Se",
"débranchez" => "debR@Se",
"débranchons" => "debR@S§",
"débraya" => "debREja",
"débrayage" => "debREjaZ",
"débrayages" => "debREjaZ",
"débrayait" => "debREjE",
"débraye" => "debRej",
"débrayé" => "debReje",
"débrayée" => "debReje",
"débrayent" => "debRej",
"débrayer" => "debReje",
"débrayes" => "debRej",
"débrayez" => "debREje",
"débridait" => "debRidE",
"débridant" => "debRid@",
"débride" => "debRid",
"débridé" => "debRide",
"débridée" => "debRide",
"débridées" => "debRide",
"débridement" => "debRid°m@",
"débrider" => "debRide",
"débridera" => "debRid°Ra",
"débriderai" => "debRid°RE",
"débriderait" => "debRid°RE",
"débridés" => "debRide",
"débridez" => "debRide",
"débriefé" => "debRife",
"débriefée" => "debRife",
"débriefer" => "debRife",
"débriefing" => "debRifiG",
"débris" => "debRi",
"débronzer" => "debR§ze",
"débrouilla" => "debRuja",
"débrouillage" => "debRujaZ",
"débrouillai" => "debRujE",
"débrouillaient" => "debRujE",
"débrouillais" => "debRujE",
"débrouillait" => "debRujE",
"débrouillant" => "debRuj@",
"débrouillard" => "debRujaR",
"débrouillarde" => "debRujaRd",
"débrouillardise" => "debRujaRdiz",
"débrouillards" => "debRujaR",
"débrouillât" => "debRuja",
"débrouille" => "debRuj",
"débrouillé" => "debRuje",
"débrouillée" => "debRuje",
"débrouillées" => "debRuje",
"débrouillent" => "debRuj",
"débrouiller" => "debRuje",
"débrouillera" => "debRuj°Ra",
"débrouillerai" => "debRuj°RE",
"débrouilleraient" => "debRuj°RE",
"débrouillerais" => "debRuj°RE",
"débrouillerait" => "debRuj°RE",
"débrouilleras" => "debRuj°Ra",
"débrouillerez" => "debRuj°Re",
"débrouillerions" => "debRuj°Rj§",
"débrouillerons" => "debRuj°R§",
"débrouilleront" => "debRuj°R§",
"débrouilles" => "debRuj",
"débrouillés" => "debRuje",
"débrouilleurs" => "debRuj9R",
"débrouillez" => "debRuje",
"débrouilliez" => "debRujje",
"débrouillions" => "debRujj§",
"débrouillons" => "debRuj§",
"débroussaillage" => "debRusajaZ",
"débroussaille" => "debRusaj",
"débroussaillé" => "debRusaje",
"débroussailler" => "debRusaje",
"débroussailleuse" => "debRusaj2z",
"débucher" => "debySe",
"débusquaient" => "debyskE",
"débusquait" => "debyskE",
"débusquant" => "debysk@",
"débusque" => "debysk",
"débusqué" => "debyske",
"débusquée" => "debyske",
"débusquer" => "debyske",
"débusquerait" => "debysk°RE",
"débusquèrent" => "debyskER",
"débusquerons" => "debysk°R§",
"débusqués" => "debyske",
"débusquez" => "debyske",
"début" => "deby",
"débuta" => "debyta",
"débutai" => "debytE",
"débutaient" => "debytE",
"débutais" => "debytE",
"débutait" => "debytE",
"débutant" => "debyt@",
"débutante" => "debyt@t",
"débutantes" => "debyt@t",
"débutants" => "debyt@",
"débute" => "debyt",
"débuté" => "debyte",
"débutée" => "debyte",
"débutent" => "debyt",
"débuter" => "debyte",
"débutera" => "debyt°Ra",
"débuteraient" => "debyt°RE",
"débutèrent" => "debytER",
"débutes" => "debyt",
"débutez" => "debyte",
"débutiez" => "debytje",
"débutons" => "debyt§",
"débuts" => "deby",
"déc" => "dek",
"déca" => "deka",
"deçà" => "d°sa",
"décabosser" => "dekabOse",
"décacheta" => "dekaS°ta",
"décachetage" => "dekaS°taZ",
"décachetai" => "dekaS°tE",
"décachetaient" => "dekaS°tE",
"décachetais" => "dekaS°tE",
"décachetant" => "dekaS°t@",
"décacheté" => "dekaS°te",
"décachetée" => "dekaS°te",
"décachetées" => "dekaS°te",
"décacheter" => "dekaS°te",
"décachetons" => "dekaS°t§",
"décachette" => "dekaSEt",
"décachetteraient" => "dekaSEt°RE",
"décade" => "dekad",
"décadence" => "dekad@s",
"décadent" => "dekad@",
"décadente" => "dekad@t",
"décadentes" => "dekad@t",
"décadentisme" => "dekad@tizm",
"décadents" => "dekad@",
"décades" => "dekad",
"décadi" => "dekadi",
"décadis" => "dekadi",
"décaféiné" => "dekafeine",
"décaféinée" => "dekafeine",
"décaissement" => "dekEs°m@",
"décaisser" => "dekEse",
"décalage" => "dekalaZ",
"décalages" => "dekalaZ",
"décalaminé" => "dekalamine",
"décalant" => "dekal@",
"décalcification" => "dekalsifikasj§",
"décalcifié" => "dekalsifje",
"décalcifiée" => "dekalsifje",
"décalcomanie" => "dekalkomani",
"décalcomanies" => "dekalkomani",
"décale" => "dekal",
"décalé" => "dekale",
"décalée" => "dekale",
"décalées" => "dekale",
"décalent" => "dekal",
"décaler" => "dekale",
"décalés" => "dekale",
"décalez" => "dekale",
"décalitre" => "dekalitR",
"décalitres" => "dekalitR",
"décalogue" => "dekalOg",
"décalotta" => "dekalota",
"décalotté" => "dekalote",
"décalottée" => "dekalote",
"décalotter" => "dekalote",
"décalottés" => "dekalote",
"décalquai" => "dekalkE",
"décalquait" => "dekalkE",
"décalque" => "dekalk",
"décalqué" => "dekalke",
"décalquée" => "dekalke",
"décalquées" => "dekalke",
"décalquer" => "dekalke",
"décalques" => "dekalk",
"décalqués" => "dekalke",
"décambuter" => "dek@byte",
"décamètre" => "dekamEtR",
"décamètres" => "dekamEtR",
"décampa" => "dek@pa",
"décampait" => "dek@pE",
"décampe" => "dek@p",
"décampé" => "dek@pe",
"décampent" => "dek@p",
"décamper" => "dek@pe",
"décampera" => "dek@p°Ra",
"décamperais" => "dek@p°RE",
"décamperont" => "dek@p°R§",
"décampes" => "dek@p",
"décampez" => "dek@pe",
"décampons" => "dek@p§",
"décan" => "dek@",
"décanillant" => "dekanij@",
"décanille" => "dekanij",
"décaniller" => "dekanije",
"décanillerait" => "dekanij°RE",
"décanillez" => "dekanije",
"décantai" => "dek@tE",
"décantaient" => "dek@tE",
"décantait" => "dek@tE",
"décantant" => "dek@t@",
"décantation" => "dek@tasj§",
"décante" => "dek@t",
"décanté" => "dek@te",
"décantée" => "dek@te",
"décantées" => "dek@te",
"décantent" => "dek@t",
"décanter" => "dek@te",
"décanteur" => "dek@t9R",
"décapage" => "dekapaZ",
"décapais" => "dekapE",
"décapait" => "dekapE",
"décapant" => "dekap@",
"décapante" => "dekap@t",
"décapants" => "dekap@",
"décape" => "dekap",
"décapé" => "dekape",
"décapée" => "dekape",
"décapées" => "dekape",
"décaper" => "dekape",
"décapera" => "dekap°Ra",
"décapés" => "dekape",
"décapeur" => "dekap9R",
"décapita" => "dekapita",
"décapitaient" => "dekapitE",
"décapitais" => "dekapitE",
"décapitait" => "dekapitE",
"décapitant" => "dekapit@",
"décapitât" => "dekapita",
"décapitation" => "dekapitasj§",
"décapitations" => "dekapitasj§",
"décapite" => "dekapit",
"décapité" => "dekapite",
"décapitée" => "dekapite",
"décapitées" => "dekapite",
"décapitent" => "dekapit",
"décapiter" => "dekapite",
"décapitera" => "dekapit°Ra",
"décapiterai" => "dekapit°RE",
"décapiterait" => "dekapit°RE",
"décapitèrent" => "dekapitER",
"décapiteront" => "dekapit°R§",
"décapités" => "dekapite",
"décapitez" => "dekapite",
"décapitons" => "dekapit§",
"décapode" => "dekapOd",
"décapotable" => "dekapotabl",
"décapotables" => "dekapotabl",
"décapotage" => "dekapotaZ",
"décapotait" => "dekapotE",
"décapote" => "dekapOt",
"décapoté" => "dekapOte",
"décapotée" => "dekapote",
"décapoter" => "dekapote",
"décapotés" => "dekapote",
"décapsula" => "dekapsyla",
"décapsulant" => "dekapsyl@",
"décapsule" => "dekapsyl",
"décapsulé" => "dekapsyle",
"décapsulée" => "dekapsyle",
"décapsuler" => "dekapsyle",
"décapsulerait" => "dekapsyl°RE",
"décapsuleur" => "dekapsyl9R",
"décapsulez" => "dekapsyle",
"décapuchonna" => "dekapySona",
"décapuchonne" => "dekapySOn",
"décapuchonner" => "dekapySone",
"décapuchonnèrent" => "dekapySonER",
"décarcassais" => "dekaRkasE",
"décarcassait" => "dekaRkasE",
"décarcassé" => "dekaRkase",
"décarcassée" => "dekaRkase",
"décarcassées" => "dekaRkase",
"décarcassent" => "dekaRkas",
"décarcasser" => "dekaRkase",
"décarpillage" => "dekaRpijaZ",
"décarpillé" => "dekaRpije",
"décarpiller" => "dekaRpije",
"décarrade" => "dekaRad",
"décarrades" => "dekaRad",
"décarraient" => "dekaRE",
"décarrais" => "dekaRE",
"décarrait" => "dekaRE",
"décarrant" => "dekaR@",
"décarre" => "dekaR",
"décarré" => "dekaRe",
"décarrent" => "dekaR",
"décarrer" => "dekaRe",
"décarrerait" => "dekaR°RE",
"décarres" => "dekaR",
"décarrés" => "dekaRe",
"décathlon" => "dekatl§",
"décathlons" => "dekatl§",
"décati" => "dekati",
"décatie" => "dekasi",
"décatir" => "dekatiR",
"décatis" => "dekati",
"décavé" => "dekave",
"decca" => "deka",
"décéda" => "deseda",
"décédait" => "desedE",
"décède" => "desEd",
"décédé" => "desede",
"décédée" => "desede",
"décédées" => "desede",
"décèdent" => "desEd",
"décéder" => "desede",
"décédés" => "desede",
"déceint" => "des5",
"décela" => "des°la",
"décelable" => "des°labl",
"décelai" => "des°lE",
"décelaient" => "des°lE",
"décelais" => "des°lE",
"décelait" => "des°lE",
"décelant" => "des°l@",
"décèle" => "desEl",
"décelé" => "des°le",
"décelée" => "des°le",
"décelées" => "des°le",
"déceler" => "dEs°le",
"décèlera" => "desEl°Ra",
"décèlerait" => "desEl°RE",
"décélération" => "deseleRasj§",
"décelèrent" => "des°lER",
"décélérer" => "deseleRe",
"décélérez" => "deseleRe",
"décèleront" => "desEl°R§",
"décèles" => "desEl",
"décelés" => "des°le",
"décembre" => "des@bR",
"décembres" => "des@bR",
"décembriste" => "des@bRist",
"décembristes" => "des@bRist",
"décemment" => "desam@",
"décence" => "des@s",
"décences" => "des@s",
"décennal" => "desenal",
"décennale" => "desEnal",
"décennie" => "deseni",
"décennies" => "deseni",
"décent" => "des@",
"décente" => "des@t",
"décentes" => "des@t",
"décentralisation" => "des@tRalizasj§",
"décentralisé" => "des@tRalize",
"décentralisée" => "des@tRalize",
"décentralisées" => "des@tRalize",
"décentrant" => "des@tR@",
"décentre" => "des@tR",
"décentrée" => "des@tRe",
"décentrées" => "des@tRe",
"décentrement" => "des@tR2m@",
"décents" => "des@",
"déception" => "desEpsj§",
"déceptions" => "desEpsj§",
"décérébration" => "deseRebRasj§",
"décérébré" => "deseRebRe",
"décérébrée" => "deseRebRe",
"décérébrer" => "deseRebRe",
"décérébrés" => "deseRebRe",
"décerna" => "desERna",
"décernai" => "desERnE",
"décernais" => "desERnE",
"décernait" => "desERnE",
"décernant" => "desERn@",
"décerne" => "desERn",
"décerné" => "desERne",
"décernée" => "desERne",
"décernées" => "desERne",
"décernent" => "desERn",
"décerner" => "desERne",
"décernera" => "desERn°Ra",
"décernés" => "desERne",
"décerniez" => "desERnje",
"décernons" => "desERn§",
"décervelage" => "desERv°laZ",
"décervelé" => "desERv°le",
"décerveler" => "desERv2le",
"décervelle" => "desERvEl",
"décès" => "desE",
"décesse" => "desEs",
"décessé" => "desEse",
"décevaient" => "des°vE",
"décevais" => "des°vE",
"décevait" => "des°vE",
"décevant" => "dEs°v@",
"décevante" => "dEs°v@t",
"décevantes" => "des°v@t",
"décevants" => "des°v@",
"décevez" => "des°ve",
"déceviez" => "des°vje",
"décevoir" => "dEs°vwaR",
"décevons" => "des°v§",
"décevra" => "des°vRa",
"décevrai" => "des°vRE",
"décevraient" => "des°vRE",
"décevrais" => "des°vRE",
"décevrait" => "des°vRE",
"décevras" => "des°vRa",
"décevrez" => "des°vRe",
"déchaîna" => "deSEna",
"déchaînaient" => "deSEnE",
"déchaînais" => "deSEnE",
"déchaînait" => "deSEnE",
"déchaînant" => "deSEn@",
"déchaînât" => "deSEna",
"déchaîne" => "deSEn",
"déchaîné" => "deSEne",
"déchaînée" => "deSEne",
"déchaînées" => "deSene",
"déchaînement" => "deSEn°m@",
"déchaînements" => "deSEn°m@",
"déchaînent" => "deSEn",
"déchaîner" => "deSEne",
"déchaînera" => "deSEn°Ra",
"déchaînerait" => "deSEn°RE",
"déchaîneras" => "deSEn°Ra",
"déchaînèrent" => "deSEnER",
"déchaînés" => "deSene",
"déchaînez" => "deSEne",
"déchait" => "deSE",
"déchanta" => "deS@ta",
"déchantai" => "deS@tE",
"déchantait" => "deS@tE",
"déchantant" => "deS@t@",
"déchante" => "deS@t",
"déchanté" => "deS@te",
"déchantent" => "deS@t",
"déchanter" => "deS@te",
"déchanterais" => "deS@t°RE",
"déchantèrent" => "deS@tER",
"déchard" => "deSaR",
"déchards" => "deSaR",
"décharge" => "deSaRZ",
"déchargé" => "deSaRZe",
"déchargea" => "deSaRZa",
"déchargeaient" => "deSaRZE",
"déchargeait" => "deSaRZE",
"déchargeant" => "deSaRZ@",
"déchargeât" => "deSaRZa",
"déchargée" => "deSaRZe",
"déchargées" => "deSaRZe",
"déchargement" => "deSaRZ°m@",
"déchargent" => "deSaRZ",
"déchargeons" => "deSaRZ§",
"décharger" => "deSaRZe",
"déchargera" => "deSaRZ°Ra",
"déchargerais" => "deSaRZ°RE",
"déchargerait" => "deSaRZ°RE",
"déchargèrent" => "deSaRZER",
"déchargerez" => "deSaRZ°Re",
"décharges" => "deSaRZ",
"déchargés" => "deSaRZe",
"déchargeur" => "deSaRZ9R",
"déchargez" => "deSaRZe",
"déchargions" => "deSaRZj§",
"décharne" => "deSaRn",
"décharné" => "deSaRne",
"décharnée" => "deSaRne",
"décharnées" => "deSaRne",
"décharnement" => "deSaRn°m@",
"décharnent" => "deSaRn",
"décharner" => "deSaRne",
"décharnerait" => "deSaRn°RE",
"décharnés" => "deSaRne",
"déchassé" => "deSase",
"déchaumaient" => "deSomE",
"déchaumée" => "deSome",
"déchaussa" => "deSosa",
"déchaussaient" => "deSosE",
"déchaussait" => "deSosE",
"déchaussant" => "deSos@",
"déchausse" => "deSos",
"déchaussé" => "deSose",
"déchaussée" => "deSose",
"déchaussées" => "deSose",
"déchaussent" => "deSos",
"déchausser" => "deSose",
"déchausserais" => "deSos°RE",
"déchaussés" => "deSose",
"déchaussez" => "deSose",
"dèche" => "dES",
"déché" => "deSe",
"déchéance" => "deSe@s",
"déchéances" => "deSe@s",
"décher" => "deSe",
"dèches" => "dES",
"déchet" => "deSE",
"déchets" => "deSE",
"déchetterie" => "deSEt°Ri",
"déchiffra" => "deSifRa",
"déchiffrable" => "deSifRabl",
"déchiffrables" => "deSifRabl",
"déchiffrage" => "deSifRaZ",
"déchiffrai" => "deSifRE",
"déchiffraient" => "deSifRE",
"déchiffrais" => "deSifRE",
"déchiffrait" => "deSifRE",
"déchiffrâmes" => "deSifRam",
"déchiffrant" => "deSifR@",
"déchiffrât" => "deSifRa",
"déchiffre" => "deSifR",
"déchiffré" => "deSifRe",
"déchiffrée" => "deSifRe",
"déchiffrées" => "deSifRe",
"déchiffrement" => "deSifR°m@",
"déchiffrent" => "deSifR",
"déchiffrer" => "deSifRe",
"déchiffrera" => "deSifR°Ra",
"déchiffrèrent" => "deSifRER",
"déchiffrés" => "deSifRe",
"déchiffreur" => "deSifR9R",
"déchiffrez" => "deSifRe",
"déchiffrions" => "deSifRij§",
"déchiqueta" => "deSik°ta",
"déchiquetage" => "deSik°taZ",
"déchiquetaient" => "deSik°tE",
"déchiquetait" => "deSik°tE",
"déchiquetant" => "deSik°t@",
"déchiqueté" => "deSik°te",
"déchiquetée" => "deSik°te",
"déchiquetées" => "deSik°te",
"déchiqueter" => "deSik°te",
"déchiquetés" => "deSik°te",
"déchiqueteur" => "deSik°t9R",
"déchiqueteurs" => "deSik°t9R",
"déchiqueteuse" => "deSik°t2z",
"déchiqueteuses" => "deSik°t2z",
"déchiquetons" => "deSik°t§",
"déchiquette" => "deSikEt",
"déchiquettent" => "deSikEt",
"déchiquettes" => "deSikEt",
"déchira" => "deSiRa",
"déchirage" => "deSiRaZ",
"déchirages" => "deSiRaZ",
"déchirai" => "deSiRE",
"déchiraient" => "deSiRE",
"déchirais" => "deSiRE",
"déchirait" => "deSiRE",
"déchirant" => "deSiR@",
"déchirante" => "deSiR@t",
"déchirantes" => "deSiR@t",
"déchirants" => "deSiR@",
"déchirât" => "deSiRa",
"déchire" => "deSiR",
"déchiré" => "deSiRe",
"déchirée" => "deSiRe",
"déchirées" => "deSiRe",
"déchirement" => "deSiR°m@",
"déchirements" => "deSiR°m@",
"déchirent" => "deSiR",
"déchirer" => "deSiRe",
"déchirera" => "deSiR°Ra",
"déchirerai" => "deSiR°RE",
"déchireraient" => "deSiR°RE",
"déchirerais" => "deSiR°RE",
"déchirerait" => "deSiR°RE",
"déchireras" => "deSiR°Ra",
"déchirèrent" => "deSiRER",
"déchirerons" => "deSiR°R§",
"déchireront" => "deSiR°R§",
"déchires" => "deSiR",
"déchirés" => "deSiRe",
"déchireur" => "deSiR9R",
"déchirez" => "deSiRe",
"déchiriez" => "deSiRje",
"déchirions" => "deSiRj§",
"déchirons" => "deSiR§",
"déchirure" => "deSiRyR",
"déchirures" => "deSiRyR",
"déchoient" => "deSwa",
"déchoir" => "deSwaR",
"déchoirons" => "deSwaR§",
"déchouer" => "deSue",
"déchristianise" => "dekRistjaniz",
"déchu" => "deSy",
"déchue" => "deSy",
"déchues" => "deSy",
"déchus" => "deSy",
"déci" => "desi",
"décibel" => "desibEl",
"décibels" => "desibEl",
"décida" => "desida",
"décidai" => "desidE",
"décidaient" => "desidE",
"décidais" => "desidE",
"décidait" => "desidE",
"décidâmes" => "desidam",
"décidant" => "desid@",
"décidât" => "desida",
"décide" => "desid",
"décidé" => "deside",
"décidée" => "deside",
"décidées" => "deside",
"décidément" => "desidem@",
"décident" => "desid",
"décider" => "deside",
"décidera" => "desid°Ra",
"déciderai" => "desid°RE",
"décideraient" => "desid°RE",
"déciderais" => "desid°RE",
"déciderait" => "desid°RE",
"décideras" => "desid°Ra",
"décidèrent" => "desidER",
"déciderez" => "desid°Re",
"décideriez" => "desid°Rje",
"déciderions" => "desid°Rj§",
"déciderons" => "desid°R§",
"décideront" => "desid°R§",
"décides" => "desid",
"décidés" => "deside",
"décideur" => "desid9R",
"décideurs" => "desid9R",
"décidez" => "deside",
"décidiez" => "desidje",
"décidions" => "desidj§",
"décidons" => "desid§",
"décigramme" => "desigRam",
"décigrammes" => "desigRam",
"décile" => "desil",
"décilitre" => "desilitR",
"décima" => "desima",
"décimaient" => "desimE",
"décimait" => "desimE",
"décimal" => "desimal",
"décimale" => "desimal",
"décimales" => "desimal",
"décimalisation" => "desimalizasj§",
"décimalité" => "desimalite",
"décimant" => "desim@",
"décimateur" => "desimat9R",
"décimation" => "desimasj§",
"décime" => "desim",
"décimé" => "desime",
"décimée" => "desime",
"décimées" => "desime",
"déciment" => "desim",
"décimer" => "desime",
"décimera" => "desim°Ra",
"décimerai" => "desim°RE",
"décimerait" => "desim°RE",
"décimèrent" => "desimER",
"décimeront" => "desim°R§",
"décimes" => "desim",
"décimés" => "desime",
"décimètre" => "desimEtR",
"décimètres" => "desimEtR",
"décisif" => "desizif",
"décisifs" => "desizif",
"décision" => "desizj§",
"décision-clé" => "desizj§kle",
"décisionnaire" => "desizjonER",
"décisionnel" => "desizjonEl",
"décisionnelles" => "desizjonEl",
"décisions" => "desizj§",
"décisive" => "desiziv",
"décisives" => "desiziv",
"décivilisés" => "desivilize",
"deck" => "dEk",
"déclama" => "deklama",
"déclamai" => "deklamE",
"déclamaient" => "deklamE",
"déclamais" => "deklamE",
"déclamait" => "deklamE",
"déclamant" => "deklam@",
"déclamât" => "deklama",
"déclamation" => "deklamasj§",
"déclamations" => "deklamasj§",
"déclamatoire" => "deklamatwaR",
"déclamatoires" => "deklamatwaR",
"déclamatrice" => "deklamatRis",
"déclame" => "deklam",
"déclamé" => "deklame",
"déclamée" => "deklame",
"déclamer" => "deklame",
"déclamera" => "deklam°Ra",
"déclamerait" => "deklam°RE",
"déclanche" => "dekl@S",
"déclanché" => "dekl@Se",
"déclancher" => "dekl@Se",
"déclanchera" => "dekl@S°Ra",
"déclara" => "deklaRa",
"déclarai" => "deklaRE",
"déclaraient" => "deklaRE",
"déclarais" => "deklaRE",
"déclarait" => "deklaRE",
"déclarant" => "deklaR@",
"déclarât" => "deklaRa",
"déclaration" => "deklaRasj§",
"déclarations" => "deklaRasj§",
"déclarative" => "deklaRativ",
"déclaratoire" => "deklaRatwaR",
"déclare" => "deklaR",
"déclaré" => "deklaRe",
"déclarée" => "deklaRe",
"déclarées" => "deklaRe",
"déclarent" => "deklaR",
"déclarer" => "deklaRe",
"déclarera" => "deklaR°Ra",
"déclarerai" => "deklaR°RE",
"déclarerais" => "deklaR°RE",
"déclarerait" => "deklaR°RE",
"déclarèrent" => "deklaRER",
"déclareriez" => "deklaR°Rje",
"déclarerions" => "deklaR°Rj§",
"déclarerons" => "deklaR°R§",
"déclareront" => "deklaR°R§",
"déclares" => "deklaR",
"déclarés" => "deklaRe",
"déclarez" => "deklaRe",
"déclariez" => "deklaRje",
"déclarions" => "deklaRj§",
"déclarons" => "deklaR§",
"déclasse" => "deklas",
"déclassé" => "deklase",
"déclassée" => "deklase",
"déclassées" => "deklase",
"déclassement" => "deklas°m@",
"déclasser" => "deklase",
"déclassés" => "deklase",
"déclavetées" => "deklav°te",
"déclencha" => "dekl@Sa",
"déclenchai" => "dekl@SE",
"déclenchaient" => "dekl@SE",
"déclenchait" => "dekl@SE",
"déclenchant" => "dekl@S@",
"déclenchât" => "dekl@Sa",
"déclenche" => "dekl@S",
"déclenché" => "dekl@Se",
"déclenchée" => "dekl@Se",
"déclenchées" => "dekl@Se",
"déclenchement" => "dekl@S°m@",
"déclenchent" => "dekl@S",
"déclencher" => "dekl@Se",
"déclenchera" => "dekl@S°Ra",
"déclencherai" => "dekl@S°RE",
"déclencheraient" => "dekl@S°RE",
"déclencherais" => "dekl@S°RE",
"déclencherait" => "dekl@S°RE",
"déclenchèrent" => "dekl@SER",
"déclencherez" => "dekl@S°Re",
"déclencherons" => "dekl@S°R§",
"déclencheront" => "dekl@S°R§",
"déclenchés" => "dekl@Se",
"déclencheur" => "dekl@S9R",
"déclencheurs" => "dekl@S9R",
"déclenchez" => "dekl@Se",
"déclenchions" => "dekl@Sj§",
"déclenchons" => "dekl@S§",
"déclic" => "deklik",
"déclics" => "deklik",
"déclin" => "dekl5",
"déclina" => "deklina",
"déclinai" => "deklinE",
"déclinaient" => "deklinE",
"déclinais" => "deklinE",
"déclinaison" => "deklinEz§",
"déclinaisons" => "deklinEz§",
"déclinait" => "deklinE",
"déclinant" => "deklin@",
"déclinante" => "deklin@t",
"déclinants" => "deklin@",
"décline" => "deklin",
"décliné" => "dekline",
"déclinée" => "dekline",
"déclinent" => "deklin",
"décliner" => "dekline",
"déclinera" => "deklin°Ra",
"déclinèrent" => "deklinER",
"déclines" => "deklin",
"déclinez" => "dekline",
"déclinions" => "deklinj§",
"déclins" => "dekl5",
"déclique" => "deklik",
"décliqueté" => "deklik°te",
"déclive" => "dekliv",
"déclives" => "dekliv",
"déclivité" => "deklivite",
"déclivités" => "deklivite",
"décloisonnée" => "deklwazone",
"déclose" => "dekloz",
"décloses" => "dekloz",
"décloué" => "deklue",
"déclouée" => "deklue",
"déclouées" => "deklue",
"déclouer" => "deklue",
"déclouèrent" => "dekluER",
"déco" => "deko",
"décocha" => "dekoSa",
"décochai" => "dekoSE",
"décochaient" => "dekoSE",
"décochais" => "dekoSE",
"décochait" => "dekoSE",
"décochant" => "dekoS@",
"décoche" => "dekOS",
"décoché" => "dekoSe",
"décochée" => "dekoSe",
"décochées" => "dekoSe",
"décochent" => "dekOS",
"décocher" => "dekoSe",
"décochera" => "dekOS°Ra",
"décocheuses" => "dekoS2z",
"décochez" => "dekoSe",
"décoconne" => "dekokOn",
"décoconnerai" => "dekokOn°RE",
"décoction" => "dekOksj§",
"décoctions" => "dekOksj§",
"décodage" => "dekodaZ",
"décodages" => "dekodaZ",
"décodait" => "dekodE",
"décodant" => "dekod@",
"décode" => "dekOd",
"décodé" => "dekode",
"décodée" => "dekode",
"décodées" => "dekode",
"décodent" => "dekOd",
"décoder" => "dekode",
"décoderai" => "dekOd°RE",
"décodés" => "dekode",
"décodeur" => "dekod9R",
"décodeurs" => "dekod9R",
"décodeuse" => "dekOd2z",
"décodez" => "dekode",
"décodons" => "dekod§",
"décoffrage" => "dekOfRaZ",
"décoffrés" => "dekofRe",
"décoiffa" => "dekwafa",
"décoiffait" => "dekwafE",
"décoiffe" => "dekwaf",
"décoiffé" => "dekwafe",
"décoiffée" => "dekwafe",
"décoiffées" => "dekwafe",
"décoiffer" => "dekwafe",
"décoiffera" => "dekwaf°Ra",
"décoifferais" => "dekwaf°RE",
"décoifferait" => "dekwaf°RE",
"décoiffes" => "dekwaf",
"décoiffés" => "dekwafe",
"décoiffez" => "dekwafe",
"décoinça" => "dekw5sa",
"décoinçage" => "dekw5saZ",
"décoinçant" => "dekw5s@",
"décoince" => "dekw5s",
"décoincé" => "dekw5se",
"décoincer" => "dekw5se",
"décoincera" => "dekw5s°Ra",
"décoincerait" => "dekw5s°RE",
"décoinces" => "dekw5s",
"décoincez" => "dekw5se",
"déçois" => "deswa",
"déçoit" => "deswa",
"déçoive" => "deswav",
"déçoivent" => "deswav",
"déçoives" => "deswav",
"décoléraient" => "dekoleRE",
"décolérais" => "dekoleRE",
"décolérait" => "dekoleRE",
"décolère" => "dekolER",
"décoléré" => "dekoleRe",
"décolérer" => "dekoleRe",
"décolla" => "dekola",
"décollage" => "dekolaZ",
"décollages" => "dekolaZ",
"décollai" => "dekolE",
"décollaient" => "dekolE",
"décollais" => "dekolE",
"décollait" => "dekolE",
"décollant" => "dekol@",
"décollassions" => "dekolasj§",
"décollation" => "dekolasj§",
"décolle" => "dekOl",
"décollé" => "dekole",
"décollée" => "dekole",
"décollées" => "dekole",
"décollement" => "dekOl°m@",
"décollements" => "dekOl°m@",
"décollent" => "dekOl",
"décoller" => "dekole",
"décollera" => "dekOl°Ra",
"décollerai" => "dekOl°RE",
"décollerait" => "dekOl°RE",
"décolleras" => "dekOl°Ra",
"décollèrent" => "dekolER",
"décollerons" => "dekOl°R§",
"décolleront" => "dekOl°R§",
"décolles" => "dekOl",
"décollés" => "dekole",
"décolleté" => "dekOl°te",
"décolletée" => "dekOl°te",
"décolletées" => "dekOl°te",
"décolleter" => "dekOl°te",
"décolletés" => "dekOl°te",
"décollez" => "dekole",
"décollons" => "dekol§",
"décolonisation" => "dekolonizasj§",
"décolonise" => "dekoloniz",
"décolora" => "dekoloRa",
"décoloraient" => "dekoloRE",
"décolorait" => "dekoloRE",
"décolorant" => "dekoloR@",
"décoloration" => "dekoloRasj§",
"décolorations" => "dekoloRasj§",
"décolore" => "dekolOR",
"décoloré" => "dekoloRe",
"décolorée" => "dekoloRe",
"décolorées" => "dekoloRe",
"décolorent" => "dekolOR",
"décolorer" => "dekoloRe",
"décolorés" => "dekoloRe",
"décombre" => "dek§bR",
"décombres" => "dek§bR",
"décommanda" => "dekom@da",
"décommandai" => "dekom@dE",
"décommandais" => "dekom@dE",
"décommandait" => "dekom@dE",
"décommande" => "dekom@d",
"décommandé" => "dekom@de",
"décommandée" => "dekom@de",
"décommandées" => "dekom@de",
"décommander" => "dekom@de",
"décommanderait" => "dekom@d°RE",
"décommandes" => "dekom@d",
"décommandés" => "dekom@de",
"décommandez" => "dekom@de",
"décompensation" => "dek§p@sasj§",
"décompensé" => "dek§p@se",
"décompenser" => "dek§p@se",
"décompliquer" => "dek§plike",
"décomposa" => "dek§poza",
"décomposable" => "dek§pozabl",
"décomposaient" => "dek§pozE",
"décomposais" => "dek§pozE",
"décomposait" => "dek§pozE",
"décomposant" => "dek§poz@",
"décompose" => "dek§poz",
"décomposé" => "dek§poze",
"décomposée" => "dek§poze",
"décomposées" => "dek§poze",
"décomposent" => "dek§poz",
"décomposer" => "dek§poze",
"décomposera" => "dek§poz°Ra",
"décomposeraient" => "dek§poz°RE",
"décomposerait" => "dek§poz°RE",
"décomposés" => "dek§poze",
"décomposeur" => "dek§poz9R",
"décomposition" => "dek§pozisj§",
"décompositions" => "dek§pozisj§",
"décompressa" => "dek§pREsa",
"décompresse" => "dek§pREs",
"décompressé" => "dek§pRese",
"décompresser" => "dek§pRese",
"décompressez" => "dek§pREse",
"décompression" => "dek§pREsj§",
"décompressions" => "dek§pREsj§",
"décomprimer" => "dek§pRime",
"décompte" => "dek§t",
"décompté" => "dek§te",
"décompter" => "dek§te",
"décomptes" => "dek§t",
"décomptés" => "dek§te",
"déconcentrant" => "dek§s@tR@",
"déconcentration" => "dek§s@tRasj§",
"déconcentré" => "dek§s@tRe",
"déconcentrée" => "dek§s@tRe",
"déconcentrent" => "dek§s@tR",
"déconcentrer" => "dek§s@tRe",
"déconcentrez" => "dek§s@tRe",
"déconcerta" => "dek§sERta",
"déconcertait" => "dek§sERtE",
"déconcertant" => "dek§sERt@",
"déconcertante" => "dek§sERt@t",
"déconcertantes" => "dek§sERt@t",
"déconcertants" => "dek§sERt@",
"déconcerte" => "dek§sERt",
"déconcerté" => "dek§sERte",
"déconcertée" => "dek§sERte",
"déconcertent" => "dek§sERt",
"déconcerter" => "dek§sERte",
"déconcertera" => "dek§sERt°Ra",
"déconcertèrent" => "dek§sERtER",
"déconcertés" => "dek§sERte",
"déconcertez" => "dek§sERte",
"déconditionnement" => "dek§disjOn°m@",
"déconditionner" => "dek§disjone",
"déconfire" => "dek§fiR",
"déconfit" => "dek§fi",
"déconfite" => "dek§fit",
"déconfits" => "dek§fi",
"déconfiture" => "dek§fityR",
"déconfitures" => "dek§fityR",
"décongela" => "dek§Z°la",
"décongélation" => "dek§Zelasj§",
"décongelé" => "dek§Z°le",
"décongelée" => "dek§Z°le",
"décongeler" => "dek§Z°le",
"décongèlera" => "dek§ZEl°Ra",
"décongestif" => "dek§ZEstif",
"décongestion" => "dek§ZEstj§",
"décongestionnant" => "dek§ZEstjOn@",
"décongestionne" => "dek§ZEstjOn",
"décongestionné" => "dek§ZEstjOne",
"décongestionner" => "dek§ZEstjone",
"déconnage" => "dekonaZ",
"déconnages" => "dekonaZ",
"déconnaient" => "dekonE",
"déconnais" => "dekonE",
"déconnait" => "dekonE",
"déconnant" => "dekon@",
"déconne" => "dekOn",
"déconné" => "dekone",
"déconnectaient" => "dekonEktE",
"déconnectant" => "dekonEkt@",
"déconnecte" => "dekonEkt",
"déconnecté" => "dekonEkte",
"déconnectée" => "dekonEkte",
"déconnectent" => "dekonEkt",
"déconnecter" => "dekonEkte",
"déconnectés" => "dekonEkte",
"déconnectez" => "dekonEkte",
"déconnectiez" => "dekonEktje",
"déconnection" => "dekonEksj§",
"déconnectons" => "dekonEkt§",
"déconnent" => "dekOn",
"déconner" => "dekone",
"déconnerai" => "dekOn°RE",
"déconnerais" => "dekOn°RE",
"déconnes" => "dekOn",
"déconneur" => "dekon9R",
"déconneurs" => "dekon9R",
"déconneuse" => "dekOn2z",
"déconnexion" => "dekonEksj@",
"déconnez" => "dekone",
"déconomètre" => "dekonomEtR",
"déconophone" => "dekonofOn",
"déconophones" => "dekonofOn",
"déconseilla" => "dek§sEja",
"déconseillai" => "dek§sEjE",
"déconseillait" => "dek§sEjE",
"déconseillant" => "dek§sEj@",
"déconseille" => "dek§sEj",
"déconseillé" => "dek§seje",
"déconseillée" => "dek§seje",
"déconseillées" => "dek§seje",
"déconseiller" => "dek§seje",
"déconseillerais" => "dek§sEj°RE",
"déconseillèrent" => "dek§sEjER",
"déconseilles" => "dek§sEj",
"déconsidéraient" => "dek§sideRE",
"déconsidérait" => "dek§sideRE",
"déconsidérant" => "dek§sideR@",
"déconsidération" => "dek§sideRasj§",
"déconsidéré" => "dek§sideRe",
"déconsidérée" => "dek§sideRe",
"déconsidèrent" => "dek§sidER",
"déconsidérer" => "dek§sideRe",
"déconsidérés" => "dek§sideRe",
"déconsigner" => "dek§siNe",
"déconstipe" => "dek§stip",
"déconstiper" => "dek§stipe",
"déconstruction" => "dek§stRyksj§",
"déconstruit" => "dek§stR8i",
"décontaminant" => "dek§tamin@",
"décontamination" => "dek§taminasj§",
"décontaminé" => "dek§tamine",
"décontaminer" => "dek§tamine",
"décontenança" => "dek§t°n@sa",
"décontenançaient" => "dek§t°n@sE",
"décontenançait" => "dek§t°n@sE",
"décontenancé" => "dek§t°n@se",
"décontenancée" => "dek§t°n@se",
"décontenancer" => "dek§t°n@se",
"décontenancés" => "dek§t°n@se",
"décontract" => "dek§tRakt",
"décontracta" => "dek§tRakta",
"décontractaient" => "dek§tRaktE",
"décontractait" => "dek§tRaktE",
"décontractant" => "dek§tRakt@",
"décontracte" => "dek§tRakt",
"décontracté" => "dek§tRakte",
"décontractée" => "dek§tRakte",
"décontractées" => "dek§tRakte",
"décontracter" => "dek§tRakte",
"décontractés" => "dek§tRakte",
"décontractez" => "dek§tRakte",
"décontraction" => "dek§tRaksj§",
"déconvenue" => "dek§v°ny",
"déconvenues" => "dek§v°ny",
"décor" => "dekOR",
"décora" => "dekoRa",
"décorai" => "dekoRE",
"décoraient" => "dekoRE",
"décorais" => "dekoRE",
"décorait" => "dekoRE",
"décorant" => "dekoR@",
"décorât" => "dekoRa",
"décorateur" => "dekoRat9R",
"décorateurs" => "dekoRat9R",
"décoratif" => "dekoRatif",
"décoratifs" => "dekoRatif",
"décoration" => "dekoRasj§",
"décorations" => "dekoRasj§",
"décorative" => "dekoRativ",
"décoratives" => "dekoRativ",
"décoratrice" => "dekoRatRis",
"décoratrices" => "dekoRatRis",
"décore" => "dekOR",
"décoré" => "dekoRe",
"décorée" => "dekoRe",
"décorées" => "dekoRe",
"décorent" => "dekOR",
"décorer" => "dekoRe",
"décorera" => "dekOR°Ra",
"décorerait" => "dekOR°RE",
"décorèrent" => "dekoRER",
"décoreront" => "dekOR°R§",
"décorés" => "dekoRe",
"décorez" => "dekoRe",
"décorne" => "dekORn",
"décorner" => "dekORne",
"décors" => "dekOR",
"décorticage" => "dekORtikaZ",
"décortication" => "dekORtikasj§",
"décortiqua" => "dekORtika",
"décortiquaient" => "dekORtikE",
"décortiquait" => "dekORtikE",
"décortiquant" => "dekORtik@",
"décortique" => "dekORtik",
"décortiqué" => "dekORtike",
"décortiquée" => "dekORtike",
"décortiquées" => "dekORtike",
"décortiquent" => "dekORtik",
"décortiquer" => "dekORtike",
"décortiqués" => "dekORtike",
"décortiquez" => "dekORtike",
"décorum" => "dekoROm",
"découcha" => "dekuSa",
"découchaient" => "dekuSE",
"découche" => "dekuS",
"découché" => "dekuSe",
"découcher" => "dekuSe",
"découches" => "dekuS",
"découd" => "deku",
"découdre" => "dekudR",
"découlaient" => "dekulE",
"découlait" => "dekulE",
"découlant" => "dekul@",
"découle" => "dekul",
"découlé" => "dekule",
"découlent" => "dekul",
"découler" => "dekule",
"découlera" => "dekul°Ra",
"découlerait" => "dekul°RE",
"découlèrent" => "dekulER",
"découpa" => "dekupa",
"découpage" => "dekupaZ",
"découpages" => "dekupaZ",
"découpai" => "dekupE",
"découpaient" => "dekupE",
"découpais" => "dekupE",
"découpait" => "dekupE",
"découpant" => "dekup@",
"découpe" => "dekup",
"découpé" => "dekupe",
"découpée" => "dekupe",
"découpées" => "dekupe",
"découpent" => "dekup",
"découper" => "dekupe",
"découpera" => "dekup°Ra",
"découperai" => "dekup°RE",
"découperaient" => "dekup°RE",
"découperais" => "dekup°RE",
"découperait" => "dekup°RE",
"découpèrent" => "dekupER",
"découperont" => "dekup°R§",
"découpes" => "dekup",
"découpés" => "dekupe",
"découpeur" => "dekup9R",
"découpeurs" => "dekup9R",
"découpeuse" => "dekup2z",
"découpez" => "dekupe",
"découpions" => "dekupj§",
"découplage" => "dekuplaZ",
"découplé" => "dekuple",
"découplée" => "dekuple",
"découpler" => "dekuple",
"découplons" => "dekupl§",
"découpons" => "dekup§",
"découpure" => "dekupyR",
"découpures" => "dekupyR",
"décourage" => "dekuRaZ",
"découragé" => "dekuRaZe",
"découragea" => "dekuRaZa",
"décourageai" => "dekuRaZE",
"décourageaient" => "dekuRaZE",
"décourageais" => "dekuRaZE",
"décourageait" => "dekuRaZE",
"décourageant" => "dekuRaZ@",
"décourageante" => "dekuRaZ@t",
"décourageantes" => "dekuRaZ@t",
"décourageants" => "dekuRaZ@",
"décourageât" => "dekuRaZa",
"découragée" => "dekuRaZe",
"découragées" => "dekuRaZe",
"découragement" => "dekuRaZ°m@",
"découragements" => "dekuRaZ°m@",
"découragent" => "dekuRaZ",
"décourageons" => "dekuRaZ§",
"décourager" => "dekuRaZe",
"découragera" => "dekuRaZ°Ra",
"découragerais" => "dekuRaZ°RE",
"découragerait" => "dekuRaZ°RE",
"découragèrent" => "dekuRaZER",
"décourages" => "dekuRaZ",
"découragés" => "dekuRaZe",
"découragez" => "dekuRaZe",
"découronné" => "dekuRone",
"découronnés" => "dekuRone",
"décours" => "dekuR",
"décousit" => "dekuzi",
"décousu" => "dekuzy",
"décousue" => "dekuzy",
"décousues" => "dekuzy",
"décousus" => "dekuzy",
"découvert" => "dekuvER",
"découverte" => "dekuvERt",
"découvertes" => "dekuvERt",
"découverts" => "dekuvER",
"découvraient" => "dekuvRE",
"découvrais" => "dekuvRE",
"découvrait" => "dekuvRE",
"découvrant" => "dekuvR@",
"découvre" => "dekuvR",
"découvrent" => "dekuvR",
"découvres" => "dekuvR",
"découvreur" => "dekuvR9R",
"découvreurs" => "dekuvR9R",
"découvreuse" => "dekuvR2z",
"découvrez" => "dekuvRe",
"découvriez" => "dekuvRje",
"découvrîmes" => "dekuvRim",
"découvrions" => "dekuvRij§",
"découvrir" => "dekuvRiR",
"découvrira" => "dekuvRiRa",
"découvrirai" => "dekuvRiRE",
"découvriraient" => "dekuvRiRE",
"découvrirais" => "dekuvRiRE",
"découvrirait" => "dekuvRiRE",
"découvriras" => "dekuvRiRa",
"découvrirent" => "dekuvRiR",
"découvrirez" => "dekuvRiRe",
"découvririez" => "dekuvRiRje",
"découvrirons" => "dekuvRiR§",
"découvriront" => "dekuvRiR§",
"découvris" => "dekuvRi",
"découvrisse" => "dekuvRis",
"découvrissent" => "dekuvRis",
"découvrit" => "dekuvRi",
"découvrît" => "dekuvRi",
"découvrons" => "dekuvR§",
"décramponner" => "dekR@pone",
"décrapouille" => "dekRapuj",
"décrassage" => "dekRasaZ",
"décrassait" => "dekRasE",
"décrasse" => "dekRas",
"décrassé" => "dekRase",
"décrasser" => "dekRase",
"décrassés" => "dekRase",
"décrédibiliser" => "dekRedibilize",
"décrédibilisez" => "dekRedibilize",
"décrêpage" => "dekREpaZ",
"décrêper" => "dekREpe",
"décrépi" => "dekRepi",
"décrépie" => "dekRepi",
"décrépies" => "dekRepi",
"décrépis" => "dekRepi",
"décrépit" => "dekRepi",
"décrépite" => "dekRepit",
"décrépites" => "dekRepit",
"décrépits" => "dekRepi",
"décrépitude" => "dekRepityd",
"decrescendo" => "dEkReSEndo",
"décret" => "dekRE",
"décret-loi" => "dekRElwa",
"décréta" => "dekReta",
"décrétai" => "dekRetE",
"décrétaient" => "dekRetE",
"décrétais" => "dekRetE",
"décrétait" => "dekRetE",
"décrétant" => "dekRet@",
"décrète" => "dekREt",
"décrété" => "dekRete",
"décrétée" => "dekRete",
"décrètent" => "dekREt",
"décréter" => "dekRete",
"décrétera" => "dekRet°Ra",
"décréterai" => "dekRet°RE",
"décréterais" => "dekRet°RE",
"décréterait" => "dekRet°RE",
"décrétèrent" => "dekRetER",
"décréteront" => "dekRet°R§",
"décrètes" => "dekREt",
"décrétés" => "dekRete",
"décrétez" => "dekRete",
"décrétons" => "dekRet§",
"décrets" => "dekRE",
"décrie" => "dekRi",
"décrié" => "dekRije",
"décriée" => "dekRije",
"décriées" => "dekRije",
"décrier" => "dekRije",
"décries" => "dekRi",
"décriés" => "dekRije",
"décriez" => "dekRie",
"décriminaliser" => "dekRiminalise",
"décrira" => "dekRiRa",
"décrirai" => "dekRiRE",
"décriraient" => "dekRiRE",
"décrirais" => "dekRiRE",
"décrirait" => "dekRiRE",
"décriras" => "dekRiRa",
"décrire" => "dekRiR",
"décrirez" => "dekRiRe",
"décririez" => "dekRiRje",
"décriront" => "dekRiR§",
"décris" => "dekRi",
"décrispât" => "dekRispa",
"décrispe" => "dekRisp",
"décrispé" => "dekRispe",
"décrisper" => "dekRispe",
"décrit" => "dekRi",
"décrite" => "dekRit",
"décrites" => "dekRit",
"décrits" => "dekRi",
"décrivaient" => "dekRivE",
"décrivais" => "dekRivE",
"décrivait" => "dekRivE",
"décrivant" => "dekRiv@",
"décrive" => "dekRiv",
"décrivent" => "dekRiv",
"décrives" => "dekRiv",
"décrivez" => "dekRive",
"décriviez" => "dekRivje",
"décrivirent" => "dekRiviR",
"décrivis" => "dekRivi",
"décrivit" => "dekRivi",
"décrocha" => "dekRoSa",
"décrochage" => "dekRoSaZ",
"décrochages" => "dekRoSaZ",
"décrochai" => "dekRoSE",
"décrochaient" => "dekRoSE",
"décrochais" => "dekRoSE",
"décrochait" => "dekRoSE",
"décrochant" => "dekRoS@",
"décroche" => "dekROS",
"décroché" => "dekRoSe",
"décrochée" => "dekRoSe",
"décrochées" => "dekRoSe",
"décrochement" => "dekROS°m@",
"décrochements" => "dekROS°m@",
"décrochent" => "dekROS",
"décrocher" => "dekRoSe",
"décrochera" => "dekROS°Ra",
"décrocherai" => "dekROS°RE",
"décrocheraient" => "dekROS°RE",
"décrocherais" => "dekROS°RE",
"décrocherait" => "dekROS°RE",
"décrocheras" => "dekROS°Ra",
"décrochèrent" => "dekRoSER",
"décrocheront" => "dekROS°R§",
"décrochés" => "dekRoSe",
"décrochez" => "dekRoSe",
"décrochez-moi-ça" => "dekRoSemwasa",
"décrochiez" => "dekRoSje",
"décrochons" => "dekRoS§",
"décroisa" => "dekRwaza",
"décroisait" => "dekRwazE",
"décroisant" => "dekRwaz@",
"décroise" => "dekRwaz",
"décroisé" => "dekRwaze",
"décroisées" => "dekRwaze",
"décroiser" => "dekRwaze",
"décroissaient" => "dekRwasE",
"décroissait" => "dekRwasE",
"décroissance" => "dekRwas@s",
"décroissant" => "dekRwas@",
"décroissante" => "dekRwas@t",
"décroissantes" => "dekRwas@t",
"décroissants" => "dekRwas@",
"décroisse" => "dekRwas",
"décroissent" => "dekRwas",
"décroît" => "dekRwa",
"décroître" => "dekRwatR",
"décrottages" => "dekRotaZ",
"décrottait" => "dekRotE",
"décrottant" => "dekROt@",
"décrotte" => "dekROt",
"décrottée" => "dekRote",
"décrottent" => "dekROt",
"décrotter" => "dekRote",
"décrottés" => "dekRote",
"décrottions" => "dekRotj§",
"décrottoir" => "dekRotwaR",
"décru" => "dekRy",
"décrue" => "dekRy",
"décrut" => "dekRy",
"décrût" => "dekRy",
"décryptage" => "dekRiptaZ",
"décryptai" => "dekRiptE",
"décrypte" => "dekRipt",
"décrypté" => "dekRipte",
"décrypter" => "dekRipte",
"décryptés" => "dekRipte",
"décrypteur" => "dekRipt9R",
"décrypteurs" => "dekRipt9R",
"déçu" => "desy",
"déçue" => "desy",
"déçues" => "desy",
"décuité" => "dek8ite",
"déculotta" => "dekylota",
"déculottait" => "dekylotE",
"déculottant" => "dekylot@",
"déculotte" => "dekylOt",
"déculotté" => "dekylote",
"déculottée" => "dekylote",
"déculottées" => "dekylote",
"déculotter" => "dekylote",
"déculottera" => "dekylot°Ra",
"déculottés" => "dekylote",
"déculpabilisait" => "dekylpabilizE",
"déculpabilisé" => "dekylpabilize",
"déculpabiliser" => "dekylpabilize",
"déçûmes" => "desym",
"décupla" => "dekypla",
"décuplaient" => "dekyplE",
"décuplait" => "dekyplE",
"décuplant" => "dekypl@",
"décuple" => "dekypl",
"décuplé" => "dekyple",
"décuplée" => "dekyple",
"décuplées" => "dekyple",
"décuplent" => "dekypl",
"décupler" => "dekyple",
"décuplera" => "dekypl°Ra",
"décuplerait" => "dekypl°RE",
"décuplèrent" => "dekyplER",
"décuplés" => "dekyple",
"déçurent" => "desyR",
"déçus" => "desy",
"déçut" => "desy",
"décuver" => "dekyve",
"dédaigna" => "dedENa",
"dédaignables" => "dedENabl",
"dédaignaient" => "dedENE",
"dédaignais" => "dedENE",
"dédaignait" => "dedENE",
"dédaignant" => "dedEN@",
"dédaignât" => "dedENa",
"dédaigne" => "dedEN",
"dédaigné" => "dedeNe",
"dédaignée" => "dedeNe",
"dédaignent" => "dedEN",
"dédaigner" => "dedeNe",
"dédaignes" => "dedEN",
"dédaignés" => "dedeNe",
"dédaigneuse" => "dedEN2z",
"dédaigneusement" => "dedEN2z°m@",
"dédaigneuses" => "dedEN2z",
"dédaigneux" => "dedEN2",
"dédaignez" => "dedENe",
"dédain" => "ded5",
"dédains" => "ded5",
"dédale" => "dedal",
"dédales" => "dedal",
"dedans" => "d°d@",
"dédia" => "dedja",
"dédiaient" => "dedjE",
"dédiait" => "dedjE",
"dédiant" => "dedj@",
"dédicaça" => "dedikasa",
"dédicaçait" => "dedikasE",
"dédicace" => "dedikas",
"dédicacé" => "dedikase",
"dédicacée" => "dedikase",
"dédicacées" => "dedikase",
"dédicacer" => "dedikase",
"dédicacerai" => "dedikas°RE",
"dédicaces" => "dedikas",
"dédicacés" => "dedikase",
"dédicacez" => "dedikase",
"dédicaciez" => "dedikasje",
"dédicatoire" => "dedikatwaR",
"dédicatoires" => "dedikatwaR",
"dédie" => "dedi",
"dédié" => "dedje",
"dédiée" => "dedje",
"dédiées" => "dedje",
"dédient" => "dedi",
"dédier" => "dedje",
"dédiera" => "dediRa",
"dédierai" => "dediRE",
"dédierait" => "dediRE",
"dédiés" => "dedje",
"dédiez" => "dedje",
"dédions" => "dedj§",
"dédire" => "dediR",
"dédit" => "dedi",
"dédite" => "dedit",
"dédommage" => "dedomaZ",
"dédommagé" => "dedomaZe",
"dédommagea" => "dedomaZa",
"dédommageait" => "dedomaZE",
"dédommagée" => "dedomaZe",
"dédommagement" => "dedomaZ°m@",
"dédommagements" => "dedomaZ°m@",
"dédommagent" => "dedomaZ",
"dédommager" => "dedomaZe",
"dédommagera" => "dedomaZ°Ra",
"dédommagerai" => "dedomaZ°RE",
"dédommagerait" => "dedomaZ°RE",
"dédommagerez" => "dedomaZ°Re",
"dédommagerons" => "dedomaZ°R§",
"dédommagés" => "dedomaZe",
"dédoré" => "dedoRe",
"dédorée" => "dedoRe",
"dédorées" => "dedoRe",
"dédorent" => "dedOR",
"dédorés" => "dedoRe",
"dédouanait" => "dedwanE",
"dédouane" => "dedwan",
"dédouané" => "dedwane",
"dédouanée" => "dedwane",
"dédouanement" => "dedwan°m@",
"dédouaner" => "dedwane",
"dédouanés" => "dedwane",
"dédouanez" => "dedwane",
"dédoubla" => "dedubla",
"dédoublaient" => "dedublE",
"dédoublais" => "dedublE",
"dédoublait" => "dedublE",
"dédouble" => "dedubl",
"dédoublé" => "deduble",
"dédoublée" => "deduble",
"dédoublées" => "deduble",
"dédoublement" => "dedubl°m@",
"dédoubler" => "deduble",
"dédoublerait" => "dedubl°RE",
"dédoublés" => "deduble",
"dédoublez" => "deduble",
"dédoublons" => "dedubl§",
"dédramatisant" => "dedRamatiz@",
"dédramatise" => "dedRamatiz",
"dédramatiser" => "dedRamatize",
"déducteur" => "dedykt9R",
"déductibilité" => "dedyktibilite",
"déductible" => "dedyktibl",
"déductibles" => "dedyktibl",
"déductif" => "dedyktif",
"déduction" => "dedyksj§",
"déductions" => "dedyksj§",
"déductive" => "dedyktiv",
"déduira" => "ded8iRa",
"déduirai" => "ded8iRE",
"déduiraient" => "ded8iRE",
"déduirait" => "ded8iRE",
"déduire" => "ded8iR",
"déduirez" => "ded8iRe",
"déduis" => "ded8i",
"déduisaient" => "ded8izE",
"déduisait" => "ded8izE",
"déduisant" => "ded8iz@",
"déduise" => "ded8iz",
"déduisent" => "ded8iz",
"déduisez" => "ded8ize",
"déduisiez" => "ded8izje",
"déduisit" => "ded8izi",
"déduisons" => "ded8iz§",
"déduit" => "ded8i",
"déduite" => "ded8it",
"déduites" => "ded8it",
"déduits" => "ded8i",
"déesse" => "deEs",
"déesses" => "deEs",
"défaillais" => "defajE",
"défaillait" => "defajE",
"défaillance" => "defaj@s",
"défaillances" => "defaj@s",
"défaillant" => "defaj@",
"défaillante" => "defaj@t",
"défaillantes" => "defaj@t",
"défaillants" => "defaj@",
"défaille" => "defaj",
"défaillent" => "defaj",
"défailli" => "defaji",
"défaillir" => "defajiR",
"défaillirait" => "defajiRE",
"défaillis" => "defaji",
"défaillit" => "defaji",
"défaire" => "defER",
"défais" => "defE",
"défaisaient" => "def°zE",
"défaisais" => "def°zE",
"défaisait" => "def°zE",
"défaisant" => "def°z@",
"défaisons" => "def°z§",
"défait" => "defE",
"défaite" => "defEt",
"défaites" => "defEt",
"défaitisme" => "defetizm",
"défaitiste" => "defetist",
"défaitistes" => "defetist",
"défaits" => "defE",
"défalque" => "defalk",
"défalqué" => "defalke",
"défalquées" => "defalke",
"défalquer" => "defalke",
"défarguaient" => "defaRgE",
"défargue" => "defaRg",
"défargué" => "defaRge",
"défarguer" => "defaRge",
"défasse" => "defas",
"défausse" => "defos",
"défausser" => "defose",
"défaut" => "defo",
"défauts" => "defo",
"défaveur" => "defav9R",
"défavorable" => "defavoRabl",
"défavorablement" => "defavoRabl°m@",
"défavorables" => "defavoRabl",
"défavorisait" => "defavoRizE",
"défavorisé" => "defavoRize",
"défavorisée" => "defavoRize",
"défavorisées" => "defavoRize",
"défavorisent" => "defavoRiz",
"défavorisés" => "defavoRize",
"défécation" => "defekasj§",
"défécations" => "defekasj§",
"défécatoire" => "defekatwaR",
"défectible" => "defEktibl",
"défectif" => "defEktif",
"défection" => "defEksj§",
"défectionnaires" => "defEksjonER",
"défections" => "defEksj§",
"défectueuse" => "defEkt82z",
"défectueusement" => "defEkt82z°m@",
"défectueuses" => "defEkt82z",
"défectueux" => "defEkt82",
"défectuosité" => "defEkt8ozite",
"déféminiser" => "defeminize",
"défend" => "def@",
"défendable" => "def@dabl",
"défendaient" => "def@dE",
"défendais" => "def@dE",
"défendait" => "def@dE",
"défendant" => "def@d@",
"défende" => "def@d",
"défendent" => "def@d",
"défenderesse" => "def@d°REs",
"défendes" => "def@d",
"défendeur" => "def@d9R",
"défendeurs" => "def@d9R",
"défendez" => "def@de",
"défendiez" => "def@dje",
"défendions" => "def@dj§",
"défendirent" => "def@diR",
"défendis" => "def@di",
"défendit" => "def@di",
"défendît" => "def@di",
"défendons" => "def@d§",
"défendra" => "def@dRa",
"défendrai" => "def@dRE",
"défendraient" => "def@dRE",
"défendrais" => "def@dRE",
"défendrait" => "def@dRE",
"défendras" => "def@dRa",
"défendre" => "def@dR",
"défendrez" => "def@dRe",
"défendriez" => "def@dRje",
"défendrons" => "def@dR§",
"défendront" => "def@dR§",
"défends" => "def@",
"défendu" => "def@dy",
"défendue" => "def@dy",
"défendues" => "def@dy",
"défendus" => "def@dy",
"défenestraient" => "def°nEstRE",
"défenestrant" => "def°nEstR@",
"défenestration" => "def°nEstRasj§",
"défenestré" => "def°nEstRe",
"défenestrée" => "def°nEstRe",
"défenestrer" => "def°nEstRe",
"défenestrerai" => "def°nEstR°RE",
"défens" => "def@",
"défense" => "def@s",
"défenses" => "def@s",
"défenseur" => "def@s9R",
"défenseurs" => "def@s9R",
"défensif" => "def@sif",
"défensifs" => "def@sif",
"défensive" => "def@siv",
"défensives" => "def@siv",
"déféquaient" => "defekE",
"déféquant" => "defek@",
"déféquassent" => "defekas",
"défèque" => "defEk",
"déféqué" => "defeke",
"déféquer" => "defeke",
"défera" => "def°Ra",
"déféra" => "defeRa",
"déferai" => "def°RE",
"déferaient" => "def°RE",
"déferais" => "def°RE",
"déferait" => "def°RE",
"déférait" => "defeRE",
"déférant" => "defeR@",
"déferas" => "def°Ra",
"déféré" => "defeRe",
"déférence" => "defeR@s",
"déférent" => "defeR@",
"déférente" => "defeR@t",
"déférentes" => "defeR@t",
"déférents" => "defeR@",
"déférer" => "defeRe",
"déférerait" => "defeR°RE",
"déférés" => "defeRe",
"déferez" => "def°Re",
"déferla" => "defERla",
"déferlaient" => "defERlE",
"déferlait" => "defERlE",
"déferlant" => "defERl@",
"déferlante" => "defERl@t",
"déferlantes" => "defERl@t",
"déferlât" => "defERla",
"déferle" => "defERl",
"déferlé" => "defERle",
"déferlées" => "defERle",
"déferlement" => "defERl°m@",
"déferlements" => "defERl°m@",
"déferlent" => "defERl",
"déferler" => "defERle",
"déferleraient" => "defERl°RE",
"déferlerait" => "defERl°RE",
"déferlèrent" => "defERlER",
"déferleront" => "defERl°R§",
"déferlez" => "defERle",
"déferons" => "def°R§",
"déferont" => "def°R§",
"déferré" => "defERe",
"déferrer" => "defeRe",
"défeuillées" => "def9je",
"défi" => "defi",
"défia" => "defja",
"défiaient" => "defjE",
"défiais" => "defjE",
"défiait" => "defjE",
"défiance" => "defj@s",
"défiances" => "defj@s",
"défiant" => "defj@",
"défiante" => "defj@t",
"défibreur" => "defibR9R",
"défibrillateur" => "defibRilat9R",
"défibrillateurs" => "defibRilat9R",
"défibrillation" => "defibRilasj§",
"déficeler" => "defis°le",
"déficelèrent" => "defis°lER",
"déficelle" => "defisEl",
"déficience" => "defisj@s",
"déficiences" => "defisj@s",
"déficient" => "defisj@",
"déficiente" => "defisj@t",
"déficientes" => "defisj@t",
"déficients" => "defisj@",
"déficit" => "defisit",
"déficitaire" => "defisitER",
"déficitaires" => "defisitER",
"déficits" => "defisit",
"défie" => "defi",
"défié" => "defje",
"défiée" => "defje",
"défient" => "defi",
"défier" => "defje",
"défiera" => "defiRa",
"défierai" => "defiRE",
"défierais" => "defiRE",
"défierait" => "defiRE",
"défièrent" => "defjER",
"défieriez" => "defiRje",
"défierons" => "defiR§",
"défiés" => "defje",
"défiez" => "defje",
"défigeait" => "defiZE",
"défiger" => "defiZe",
"défigura" => "defigyRa",
"défiguraient" => "defigyRE",
"défigurais" => "defigyRE",
"défigurait" => "defigyRE",
"défigurant" => "defigyR@",
"défiguration" => "defigyRasj§",
"défigurations" => "defigyRasj§",
"défigure" => "defigyR",
"défiguré" => "defigyRe",
"défigurée" => "defigyRe",
"défigurées" => "defigyRe",
"défigurement" => "defigyR°m@",
"défigurent" => "defigyR",
"défigurer" => "defigyRe",
"défigurerait" => "defigyR°RE",
"défigurés" => "defigyRe",
"défila" => "defila",
"défilaient" => "defilE",
"défilais" => "defilE",
"défilait" => "defilE",
"défilant" => "defil@",
"défilantes" => "defil@t",
"défilants" => "defil@",
"défile" => "defil",
"défilé" => "defile",
"défilée" => "defile",
"défilement" => "defil°m@",
"défilements" => "defil°m@",
"défilent" => "defil",
"défiler" => "defile",
"défilera" => "defil°Ra",
"défileraient" => "defil°RE",
"défilerait" => "defil°RE",
"défileras" => "defil°Ra",
"défilèrent" => "defilER",
"défilerez" => "defil°Re",
"défilerons" => "defil°R§",
"défileront" => "defil°R§",
"défilés" => "defile",
"défilez" => "defile",
"défiliez" => "defilje",
"défilions" => "defilj§",
"défilons" => "defil§",
"défini" => "defini",
"définie" => "defini",
"définies" => "defini",
"définir" => "definiR",
"définira" => "definiRa",
"définirais" => "definiRE",
"définirait" => "definiRE",
"définiriez" => "definiRje",
"définis" => "defini",
"définissable" => "definisabl",
"définissables" => "definisabl",
"définissaient" => "definisE",
"définissait" => "definisE",
"définissant" => "definis@",
"définisse" => "definis",
"définissent" => "definis",
"définissez" => "definise",
"définissons" => "definis§",
"définit" => "defini",
"définitif" => "definitif",
"définitifs" => "definitif",
"définition" => "definisj§",
"définitions" => "definisj§",
"définitive" => "definitiv",
"définitivement" => "definitiv°m@",
"définitives" => "definitiv",
"défions" => "defj§",
"défirent" => "defiR",
"défis" => "defi",
"défiscalisations" => "defiskalizasj§",
"défiscalisé" => "defiskalize",
"défit" => "defi",
"déflagrante" => "deflagR@t",
"déflagration" => "deflagRasj§",
"déflagrations" => "deflagRasj§",
"déflationniste" => "deflasjOnist",
"déflationnistes" => "deflasjonist",
"déflecteur" => "deflEkt9R",
"déflecteurs" => "deflEkt9R",
"défleuri" => "defl9Ri",
"défleuries" => "defl9Ri",
"défleuris" => "defl9Ri",
"déflexion" => "deflEksj§",
"défloraison" => "defloREz§",
"déflorait" => "defloRE",
"défloration" => "defloRasj§",
"défloré" => "defloRe",
"déflorée" => "defloRe",
"déflorer" => "defloRe",
"déflorerons" => "deflOR°R§",
"déflorés" => "defloRe",
"défoliant" => "defOlj@",
"défonça" => "def§sa",
"défonçai" => "def§sE",
"défonçaient" => "def§sE",
"défonçais" => "def§sE",
"défonçait" => "def§sE",
"défonçant" => "def§s@",
"défonce" => "def§s",
"défoncé" => "def§se",
"défoncée" => "def§se",
"défoncées" => "def§se",
"défoncement" => "def§s°m@",
"défoncements" => "def§s°m@",
"défoncent" => "def§s",
"défoncer" => "def§se",
"défoncera" => "def§s°Ra",
"défoncerai" => "def§s°RE",
"défonceraient" => "def§s°RE",
"défoncerait" => "def§s°RE",
"défonceront" => "def§s°R§",
"défoncés" => "def§se",
"défonceuse" => "def§s2z",
"défoncez" => "def§se",
"défonçons" => "def§s§",
"défont" => "def§",
"déforestation" => "defoREstasj§",
"déforma" => "defORma",
"déformaient" => "defORmE",
"déformait" => "defORmE",
"déformant" => "defORm@",
"déformante" => "defORm@t",
"déformantes" => "defORm@t",
"déformants" => "defORm@",
"déformation" => "defORmasj§",
"déformations" => "defORmasj§",
"déforme" => "defORm",
"déformé" => "defORme",
"déformée" => "defORme",
"déformées" => "defORme",
"déforment" => "defORm",
"déformer" => "defORme",
"déformera" => "defORm°Ra",
"déformerai" => "defORm°RE",
"déformerait" => "defORm°RE",
"déformeront" => "defORm°R§",
"déformes" => "defORm",
"déformés" => "defORme",
"déformez" => "defORme",
"défoulaient" => "defulE",
"défoulais" => "defulE",
"défoulait" => "defulE",
"défoule" => "deful",
"défoulement" => "deful°m@",
"défoulent" => "deful",
"défouler" => "defule",
"défoulera" => "deful°Ra",
"défoulerait" => "deful°RE",
"défoules" => "deful",
"défoulés" => "defule",
"défouliez" => "defulje",
"défouloir" => "defulwaR",
"défoulons" => "deful§",
"défouraillaient" => "defuRajE",
"défouraille" => "defuRaj",
"défouraillé" => "defuRaje",
"défouraillent" => "defuRaj",
"défourailler" => "defuRaje",
"défouraillerait" => "defuRaj°RE",
"défourna" => "defuRna",
"défournait" => "defuRnE",
"défragmenteur" => "defRagm@t9R",
"défraîchi" => "defRESi",
"défraîchie" => "defRESi",
"défraîchies" => "defRESi",
"défraîchir" => "defReSiR",
"défraîchis" => "defRESi",
"défraîchissait" => "defRESisE",
"défraiement" => "defREm@",
"défraiements" => "defREm@",
"défraya" => "defReja",
"défrayaient" => "defREjE",
"défrayait" => "defREjE",
"défrayant" => "defRej@",
"défrayé" => "defReje",
"défrayent" => "defRej",
"défrayer" => "defReje",
"défrayèrent" => "defRejER",
"défricha" => "defRiSa",
"défrichage" => "defRiSaZ",
"défrichait" => "defRiSE",
"défriche" => "defRiS",
"défriché" => "defRiSe",
"défrichée" => "defRiSe",
"défrichées" => "defRiSe",
"défrichement" => "defRiS°m@",
"défrichements" => "defRiS°m@",
"défricher" => "defRiSe",
"défrichés" => "defRiSe",
"défricheurs" => "defRiS9R",
"défringue" => "defR5g",
"défringues" => "defR5g",
"défripe" => "defRip",
"défripé" => "defRipe",
"défripées" => "defRipe",
"défripera" => "defRip°Ra",
"défrisage" => "defRizaZ",
"défrisaient" => "defRizE",
"défrisait" => "defRizE",
"défrise" => "defRiz",
"défrisé" => "defRize",
"défriser" => "defRize",
"défriserait" => "defRiz°RE",
"défrises" => "defRiz",
"défroissa" => "defRwasa",
"défroissai" => "defRwasE",
"défroissaient" => "defRwasE",
"défroissait" => "defRwasE",
"défroissant" => "defRwas@",
"défroisse" => "defRwas",
"défroissé" => "defRwase",
"défroissées" => "defRwase",
"défroissent" => "defRwas",
"défroisser" => "defRwase",
"défroissés" => "defRwase",
"défroqua" => "defRoka",
"défroque" => "defROk",
"défroqué" => "defRoke",
"défroquée" => "defRoke",
"défroquer" => "defROke",
"défroques" => "defROk",
"défroqués" => "defRoke",
"défunt" => "def1",
"défunte" => "def1t",
"défunté" => "def1te",
"défunter" => "def1te",
"défuntes" => "def1t",
"défunts" => "def1",
"dégage" => "degaZ",
"dégagé" => "degaZe",
"dégagea" => "degaZa",
"dégageai" => "degaZE",
"dégageaient" => "degaZE",
"dégageait" => "degaZE",
"dégageant" => "degaZ@",
"dégageât" => "degaZa",
"dégagée" => "degaZe",
"dégagées" => "degaZe",
"dégagement" => "degaZ°m@",
"dégagements" => "degaZ°m@",
"dégagent" => "degaZ",
"dégageons" => "degaZ§",
"dégager" => "degaZe",
"dégagera" => "degaZ°Ra",
"dégageraient" => "degaZ°RE",
"dégagerais" => "degaZ°RE",
"dégagerait" => "degaZ°RE",
"dégagèrent" => "degaZER",
"dégageront" => "degaZ°R§",
"dégages" => "degaZ",
"dégagés" => "degaZe",
"dégagez" => "degaZe",
"dégaina" => "degEna",
"dégainais" => "degEnE",
"dégainait" => "degEnE",
"dégainant" => "degEn@",
"dégaine" => "degEn",
"dégainé" => "degEne",
"dégainent" => "degEn",
"dégainer" => "degene",
"dégainerai" => "degEn°RE",
"dégainèrent" => "degEnER",
"dégainerez" => "degEn°Re",
"dégaines" => "degEn",
"dégainés" => "degEne",
"dégainez" => "degEne",
"déganta" => "deg@ta",
"dégantant" => "deg@t@",
"déganté" => "deg@te",
"dégantée" => "deg@te",
"dégantées" => "deg@te",
"dégarni" => "degaRni",
"dégarnie" => "degaRni",
"dégarnies" => "degaRni",
"dégarnir" => "degaRniR",
"dégarnis" => "degaRni",
"dégarnissait" => "degaRnisE",
"dégarnissant" => "degaRnis@",
"dégât" => "dega",
"dégâts" => "dega",
"dégauchi" => "degoSi",
"dégauchie" => "degoSi",
"dégauchir" => "degoSiR",
"dégauchira" => "degoSiRa",
"dégauchis" => "degoSi",
"dégauchisse" => "degoSis",
"dégauchisseuse" => "degoSis2z",
"dégazage" => "degazaZ",
"dégazent" => "degaz",
"dégazer" => "degaze",
"dégel" => "deZEl",
"dégela" => "deZ°la",
"dégelai" => "deZ°lE",
"dégelait" => "deZ°lE",
"dégelant" => "deZ°l@",
"dégelât" => "deZ°la",
"dégèle" => "deZEl",
"dégelé" => "deZ°le",
"dégelée" => "deZ°le",
"dégelées" => "deZ°le",
"dégèlent" => "deZEl",
"dégeler" => "deZ°le",
"dégèlera" => "deZEl°Ra",
"dégèlerait" => "deZEl°RE",
"dégelés" => "deZ°le",
"dégelez" => "deZ°le",
"dégénéra" => "deZeneRa",
"dégénéraient" => "deZeneRE",
"dégénérait" => "deZeneRE",
"dégénérant" => "deZeneR@",
"dégénérât" => "deZeneRa",
"dégénératif" => "deZeneRatif",
"dégénération" => "deZeneRasj§",
"dégénérative" => "deZeneRativ",
"dégénère" => "deZenER",
"dégénéré" => "deZeneRe",
"dégénérée" => "deZeneRe",
"dégénérées" => "deZeneRe",
"dégénèrent" => "deZenER",
"dégénérer" => "deZeneRe",
"dégénérés" => "deZeneRe",
"dégénérescence" => "deZeneRes@s",
"dégénérescences" => "deZeneRes@s",
"dégermait" => "deZERmE",
"dégingandé" => "deZ5g@de",
"dégingandée" => "deZ5g@de",
"dégingandées" => "deZ5g@de",
"dégingandés" => "deZ5g@de",
"dégivrage" => "deZivRaZ",
"dégivré" => "deZivRe",
"dégivrer" => "deZivRe",
"déglacé" => "deglase",
"déglacer" => "deglase",
"déglacera" => "deglas°Ra",
"déglacez" => "deglase",
"déglingua" => "degl5ga",
"déglinguaient" => "degl5gE",
"déglinguait" => "degl5gE",
"déglinguant" => "degl5g@",
"déglingue" => "degl5g",
"déglingué" => "degl5ge",
"déglinguée" => "degl5ge",
"déglinguées" => "degl5ge",
"déglinguent" => "degl5g",
"déglinguer" => "degl5ge",
"déglingués" => "degl5ge",
"déglinguions" => "degl5gj§",
"dégluti" => "deglyti",
"déglutie" => "deglyti",
"dégluties" => "deglyti",
"déglutir" => "deglytiR",
"déglutis" => "deglyti",
"déglutissait" => "deglytisE",
"déglutissant" => "deglytis@",
"déglutit" => "deglyti",
"déglutition" => "deglytisj§",
"déglutitions" => "deglytisj§",
"dégobilla" => "degobija",
"dégobillage" => "degobijaZ",
"dégobillaient" => "degobijE",
"dégobillait" => "degobijE",
"dégobillant" => "degobij@",
"dégobille" => "degobij",
"dégobillé" => "degObije",
"dégobiller" => "degobije",
"dégoisais" => "degwazE",
"dégoisait" => "degwazE",
"dégoisant" => "degwaz@",
"dégoise" => "degwaz",
"dégoisent" => "degwaz",
"dégoiser" => "degwaze",
"dégoiserai" => "degwaz°RE",
"dégoises" => "degwaz",
"dégommage" => "degomaZ",
"dégommait" => "degomE",
"dégommant" => "degom@",
"dégomme" => "degOm",
"dégommé" => "degome",
"dégommée" => "degome",
"dégommées" => "degome",
"dégomment" => "degOm",
"dégommer" => "degome",
"dégommera" => "degOm°Ra",
"dégommerai" => "degOm°RE",
"dégommés" => "degome",
"dégommez" => "degome",
"dégommons" => "degom§",
"dégonfla" => "deg§fla",
"dégonflage" => "deg§flaZ",
"dégonflaient" => "deg§flE",
"dégonflais" => "deg§flE",
"dégonflait" => "deg§flE",
"dégonflant" => "deg§fl@",
"dégonflard" => "deg§flaR",
"dégonfle" => "deg§fl",
"dégonflé" => "deg§fle",
"dégonflée" => "deg§fle",
"dégonflées" => "deg§fle",
"dégonflement" => "deg§fl2m@",
"dégonflent" => "deg§fl",
"dégonfler" => "deg§fle",
"dégonflera" => "deg§fl°Ra",
"dégonfleraient" => "deg§fl°RE",
"dégonflerais" => "deg§fl°RE",
"dégonflerait" => "deg§fl°RE",
"dégonfleriez" => "deg§fl°Rje",
"dégonfles" => "deg§fl",
"dégonflés" => "deg§fle",
"dégonflez" => "deg§fle",
"dégorge" => "degORZ",
"dégorgé" => "degORZe",
"dégorgeaient" => "degORZE",
"dégorgeais" => "degORZE",
"dégorgeait" => "degORZE",
"dégorgeant" => "degORZ@",
"dégorgée" => "degORZe",
"dégorgées" => "degORZe",
"dégorgement" => "degORZ°m@",
"dégorgent" => "degORZ",
"dégorger" => "degORZe",
"dégorgeront" => "degORZ°R§",
"dégorgés" => "degORZe",
"dégota" => "degota",
"dégotait" => "degotE",
"dégote" => "degOt",
"dégoté" => "degote",
"dégotée" => "degote",
"dégotées" => "degote",
"dégoter" => "degote",
"dégoterais" => "degOt°RE",
"dégoteras" => "degOt°Ra",
"dégotés" => "degote",
"dégotez" => "degote",
"dégotte" => "degOt",
"dégotté" => "degote",
"dégotter" => "degote",
"dégottera" => "degOt°Ra",
"dégotterai" => "degOt°RE",
"dégotterait" => "degOt°RE",
"dégottes" => "degOt",
"dégoulina" => "degulina",
"dégoulinade" => "degulinad",
"dégoulinades" => "degulinad",
"dégoulinaient" => "degulinE",
"dégoulinais" => "degulinE",
"dégoulinait" => "degulinE",
"dégoulinant" => "degulin@",
"dégoulinante" => "degulin@t",
"dégoulinantes" => "degulin@t",
"dégoulinants" => "degulin@",
"dégouline" => "degulin",
"dégouliné" => "deguline",
"dégoulinement" => "degulin°m@",
"dégoulinements" => "degulin°m@",
"dégoulinent" => "degulin",
"dégouliner" => "deguline",
"dégoulinèrent" => "degulinER",
"dégoulines" => "degulin",
"dégoulinez" => "deguline",
"dégoulinures" => "degulinyR",
"dégoupillâmes" => "degupijam",
"dégoupille" => "degupij",
"dégoupillé" => "degupije",
"dégoupillée" => "degupije",
"dégoupillées" => "degupije",
"dégoupiller" => "degupije",
"dégourdi" => "deguRdi",
"dégourdie" => "deguRdi",
"dégourdies" => "deguRdi",
"dégourdir" => "deguRdiR",
"dégourdira" => "deguRdiRa",
"dégourdiraient" => "deguRdiRE",
"dégourdis" => "deguRdi",
"dégourdissais" => "deguRdisE",
"dégourdissait" => "deguRdisE",
"dégourdissant" => "deguRdis@",
"dégourdisse" => "deguRdis",
"dégourdissions" => "deguRdisj§",
"dégourdit" => "deguRdi",
"dégoût" => "degu",
"dégoûta" => "deguta",
"dégoûtai" => "degutE",
"dégoûtaient" => "degutE",
"dégoûtais" => "degutE",
"dégoûtait" => "degutE",
"dégoûtant" => "degut@",
"dégoûtante" => "degut@t",
"dégoûtantes" => "degut@t",
"dégoûtants" => "degut@",
"dégoûtât" => "deguta",
"dégoûtation" => "degutasj§",
"dégoûtations" => "degutasj§",
"dégoûte" => "degut",
"dégoûté" => "degute",
"dégoûtée" => "degute",
"dégoûtées" => "degute",
"dégoûtent" => "degut",
"dégoûter" => "degute",
"dégoûtera" => "degut°Ra",
"dégoûteraient" => "degut°RE",
"dégoûterais" => "degut°RE",
"dégoûterait" => "degut°RE",
"dégoûtèrent" => "degutER",
"dégoûtes" => "degut",
"dégoûtés" => "degute",
"dégoûtez" => "degute",
"dégoûts" => "degu",
"dégouttaient" => "degutE",
"dégouttait" => "degutE",
"dégouttant" => "degut@",
"dégouttante" => "degut@t",
"dégouttantes" => "degut@t",
"dégouttants" => "degut@",
"dégoutte" => "degut",
"dégoutter" => "degute",
"dégrada" => "degRada",
"dégradable" => "degRadabl",
"dégradaient" => "degRadE",
"dégradait" => "degRadE",
"dégradant" => "degRad@",
"dégradante" => "degRad@t",
"dégradantes" => "degRad@t",
"dégradants" => "degRad@",
"dégradation" => "degRadasj§",
"dégradations" => "degRadasj§",
"dégrade" => "degRad",
"dégradé" => "degRade",
"dégradée" => "degRade",
"dégradées" => "degRade",
"dégradent" => "degRad",
"dégrader" => "degRade",
"dégrades" => "degRad",
"dégradés" => "degRade",
"dégradez" => "degRade",
"dégrafa" => "degRafa",
"dégrafaient" => "degRafE",
"dégrafait" => "degRafE",
"dégrafant" => "degRaf@",
"dégrafât" => "degRafa",
"dégrafe" => "degRaf",
"dégrafé" => "degRafe",
"dégrafée" => "degRafe",
"dégrafées" => "degRafe",
"dégrafer" => "degRafe",
"dégrafera" => "degRaf°Ra",
"dégraferait" => "degRaf°RE",
"dégrafés" => "degRafe",
"dégrafeur" => "degRaf9R",
"dégrafez" => "degRafe",
"dégraissage" => "degREsaZ",
"dégraissant" => "degREs@",
"dégraissante" => "degREs@t",
"dégraisse" => "degREs",
"dégraissé" => "degREse",
"dégraissent" => "degREs",
"dégraisser" => "degRese",
"dégraissés" => "degREse",
"dégraissez" => "degREse",
"degré" => "d°gRe",
"dégrée" => "degRe",
"dégrène" => "degREn",
"dégréner" => "degRene",
"degrés" => "d°gRe",
"dégressifs" => "degResif",
"dégrèvement" => "degEv°m@",
"dégrèvements" => "degREv°m@",
"dégriffe" => "degRif",
"dégriffé" => "degRife",
"dégriffer" => "degRife",
"dégriffés" => "degRife",
"dégriffeur" => "degRif9R",
"dégringola" => "degR5gola",
"dégringolade" => "degR5golad",
"dégringolades" => "degR5golad",
"dégringolai" => "degR5golE",
"dégringolaient" => "degR5golE",
"dégringolait" => "degR5golE",
"dégringolâmes" => "degR5golam",
"dégringolant" => "degR5gol@",
"dégringole" => "degR5gOl",
"dégringolé" => "degR5gole",
"dégringolée" => "degR5gole",
"dégringolent" => "degR5gOl",
"dégringoler" => "degR5gole",
"dégringoleraient" => "degR5gOl°RE",
"dégringolerais" => "degR5gOl°RE",
"dégringolèrent" => "degR5golER",
"dégringoleront" => "degR5gOl°R§",
"dégringolés" => "degR5gole",
"dégringolions" => "degR5golj§",
"dégripper" => "degRipe",
"dégrisa" => "degRiza",
"dégrisait" => "degRizE",
"dégrisât" => "degRiza",
"dégrise" => "degRiz",
"dégrisé" => "degRize",
"dégrisée" => "degRize",
"dégrisement" => "degRiz°m@",
"dégriser" => "degRize",
"dégrisés" => "degRize",
"dégrossi" => "degRosi",
"dégrossie" => "degRosi",
"dégrossies" => "degRosi",
"dégrossir" => "degRosiR",
"dégrossis" => "degRosi",
"dégrossissage" => "degRosisaZ",
"dégrossissant" => "degRosis@",
"dégrouille" => "degRuj",
"dégrouiller" => "degRuje",
"déguenillé" => "dEg°nije",
"déguenillée" => "deg°nije",
"déguenillées" => "deg°nije",
"déguenillés" => "dEg°nije",
"déguerpi" => "degERpi",
"déguerpir" => "degERpiR",
"déguerpirent" => "degERpiR",
"déguerpis" => "degERpi",
"déguerpisse" => "degERpis",
"déguerpissent" => "degERpis",
"déguerpissez" => "degERpise",
"déguerpissiez" => "degERpisje",
"déguerpissons" => "degERpis§",
"déguerpit" => "degERpi",
"dégueu" => "deg2",
"dégueula" => "deg2la",
"dégueulais" => "deg2lE",
"dégueulait" => "deg2lE",
"dégueulando" => "deg2l@do",
"dégueulant" => "deg9l@",
"dégueulasse" => "deg2las",
"dégueulassé" => "deg2lase",
"dégueulassement" => "deg2las°m@",
"dégueulasser" => "deg2lase",
"dégueulasserie" => "deg2las°Ri",
"dégueulasseries" => "deg2las°Ri",
"dégueulasses" => "deg2las",
"dégueulassés" => "deg2lase",
"dégueule" => "deg9l",
"dégueulé" => "deg2le",
"dégueulées" => "deg2le",
"dégueulent" => "deg9l",
"dégueuler" => "deg2le",
"dégueulera" => "deg9l°Ra",
"dégueules" => "deg9l",
"dégueulez" => "deg2le",
"dégueulis" => "deg2li",
"dégueus" => "deg2",
"déguisa" => "degiza",
"déguisaient" => "degizE",
"déguisais" => "degizE",
"déguisait" => "degizE",
"déguisant" => "degiz@",
"déguise" => "degiz",
"déguisé" => "degize",
"déguisée" => "degize",
"déguisées" => "degize",
"déguisement" => "degiz°m@",
"déguisements" => "degiz°m@",
"déguisent" => "degiz",
"déguiser" => "degize",
"déguisera" => "degiz°Ra",
"déguiserai" => "degiz°RE",
"déguiserais" => "degiz°RE",
"déguiserait" => "degiz°RE",
"déguises" => "degiz",
"déguisés" => "degize",
"déguisez" => "degize",
"déguisiez" => "degizje",
"déguisions" => "degizj§",
"dégurgitant" => "degyRZit@",
"dégusta" => "degysta",
"dégustai" => "degystE",
"dégustaient" => "degystE",
"dégustais" => "degystE",
"dégustait" => "degystE",
"dégustâmes" => "degystam",
"dégustant" => "degyst@",
"dégustateur" => "degystat9R",
"dégustateurs" => "degystat9R",
"dégustation" => "degystasj§",
"dégustations" => "degystasj§",
"dégustatrice" => "degystatRis",
"déguste" => "degyst",
"dégusté" => "degyste",
"dégustée" => "degyste",
"dégustées" => "degyste",
"dégustent" => "degyst",
"déguster" => "degyste",
"dégustera" => "degyst°Ra",
"dégusteras" => "degyst°Ra",
"dégustèrent" => "degystER",
"dégusterons" => "degyst°R§",
"dégustés" => "degyste",
"dégustez" => "degyste",
"dégustons" => "degyst§",
"déhale" => "deal",
"déhalées" => "deale",
"déhaler" => "deale",
"déhancha" => "de@Sa",
"déhanchaient" => "de@SE",
"déhanchait" => "de@SE",
"déhanchant" => "de@S@",
"déhanche" => "de@S",
"déhanché" => "de@Se",
"déhanchée" => "de@Se",
"déhanchées" => "de@Se",
"déhanchement" => "de@S°m@",
"déhanchements" => "de@S°m@",
"déhanchent" => "de@S",
"déhancher" => "de@Se",
"déhanchés" => "de@Se",
"déhanchez" => "de@Se",
"déharnacha" => "deaRnaSa",
"déharnachées" => "deaRnaSe",
"déhiscence" => "deis@s",
"dehors" => "d2OR",
"déhotte" => "deOt",
"déhotté" => "deote",
"déhottée" => "deote",
"déhotter" => "deote",
"déicide" => "deisid",
"déicides" => "deisid",
"déifia" => "deifja",
"déification" => "deifikasj§",
"déifié" => "deifje",
"déifier" => "deifje",
"déifiés" => "deifje",
"déisme" => "deism",
"déité" => "deite",
"déités" => "deite",
"déjà" => "deZa",
"déjà-vu" => "deZavy",
"déjanta" => "deZ@ta",
"déjantait" => "deZ@tE",
"déjante" => "deZ@t",
"déjanté" => "deZ@te",
"déjantée" => "deZ@te",
"déjantent" => "deZ@t",
"déjanter" => "deZ@te",
"déjanterais" => "deZ@t°RE",
"déjantes" => "deZ@t",
"déjantés" => "deZ@te",
"déjaugeant" => "deZoZ@",
"déjection" => "deZEksj§",
"déjections" => "deZEksj§",
"déjetait" => "deZ°tE",
"déjeté" => "dEZ°te",
"déjetée" => "dEZ°te",
"déjetés" => "deZ°te",
"déjeuna" => "deZ9na",
"déjeunai" => "deZ9nE",
"déjeunaient" => "deZ9nE",
"déjeunais" => "deZ9nE",
"déjeunait" => "deZ9nE",
"déjeunâmes" => "deZ9nam",
"déjeunant" => "deZ9n@",
"déjeunât" => "deZ9na",
"déjeune" => "deZ9n",
"déjeuné" => "deZ9ne",
"déjeunent" => "deZ9n",
"déjeuner" => "deZ9ne",
"déjeunera" => "deZ9n°Ra",
"déjeunerai" => "deZ9n°RE",
"déjeuneraient" => "deZ9n°RE",
"déjeunerait" => "deZ9n°RE",
"déjeuneras" => "deZ9n°Ra",
"déjeunèrent" => "deZ9nER",
"déjeunerez" => "deZ9n°Re",
"déjeunerions" => "deZ9n°Rj§",
"déjeunerons" => "deZ9n°R§",
"déjeuners" => "deZ9ne",
"déjeunes" => "deZ9n",
"déjeunez" => "deZ9ne",
"déjeuniez" => "deZ9nje",
"déjeunions" => "deZ9nj§",
"déjeunons" => "deZ9n§",
"déjoua" => "deZwa",
"déjouait" => "deZwE",
"déjouant" => "deZw@",
"déjoue" => "deZu",
"déjoué" => "deZwe",
"déjouée" => "deZwe",
"déjouées" => "deZwe",
"déjouent" => "deZu",
"déjouer" => "deZwe",
"déjouerai" => "deZuRE",
"déjouerez" => "deZuRe",
"déjouerions" => "deZuRj§",
"déjoués" => "deZwe",
"déjouez" => "deZue",
"déjouons" => "deZu§",
"déjuchaient" => "deZySE",
"déjugé" => "deZyZe",
"déjuger" => "deZyZe",
"dékoulakisation" => "dekulakizasj§",
"delà" => "d°la",
"délabre" => "delabR",
"délabré" => "delabRe",
"délabrée" => "delabRe",
"délabrées" => "delabRe",
"délabrement" => "delabR°m@",
"délabrer" => "delabRe",
"délabrés" => "delabRe",
"délabyrinthez" => "delabiR5te",
"délaça" => "delasa",
"délaçais" => "delasE",
"délaçait" => "delasE",
"délaçant" => "delas@",
"délace" => "delas",
"délacé" => "delase",
"délacées" => "delase",
"délacer" => "delase",
"délacèrent" => "delasER",
"délai" => "delE",
"délaie" => "delE",
"délais" => "delE",
"délaissa" => "delEsa",
"délaissaient" => "delEsE",
"délaissais" => "delEsE",
"délaissait" => "delEsE",
"délaissant" => "delEs@",
"délaisse" => "delEs",
"délaissé" => "delEse",
"délaissée" => "delEse",
"délaissées" => "delEse",
"délaissement" => "delEs°m@",
"délaissements" => "delEs°m@",
"délaissent" => "delEs",
"délaisser" => "delese",
"délaisserait" => "delEs°RE",
"délaissèrent" => "delEsER",
"délaisses" => "delEs",
"délaissés" => "delEse",
"délaissions" => "delEsj§",
"délaita" => "delEta",
"délaite" => "delEt",
"délardant" => "delaRd@",
"délassa" => "delasa",
"délassait" => "delasE",
"délassant" => "delas@",
"délassante" => "delas@t",
"délasse" => "delas",
"délassement" => "delas°m@",
"délasser" => "delase",
"délassera" => "delas°Ra",
"délasseront" => "delas°R§",
"délassés" => "delase",
"délateur" => "delat9R",
"délateurs" => "delat9R",
"délation" => "delasj§",
"délations" => "delasj§",
"délatrice" => "delatRis",
"délavait" => "delavE",
"délavant" => "delav@",
"délave" => "delav",
"délavé" => "delave",
"délavée" => "delave",
"délavées" => "delave",
"délavent" => "delav",
"délaver" => "delave",
"délavés" => "delave",
"délaya" => "deleja",
"délayage" => "delEjaZ",
"délayait" => "delejE",
"délayant" => "delej@",
"délaye" => "delej",
"délayé" => "deleje",
"délayée" => "deleje",
"délayent" => "delej",
"délayer" => "deleje",
"délayés" => "deleje",
"delco" => "dElko",
"délectable" => "delEktabl",
"délectables" => "delEktabl",
"délectai" => "delEktE",
"délectaient" => "delEktE",
"délectais" => "delEktE",
"délectait" => "delEktE",
"délectant" => "delEkt@",
"délectât" => "delEkta",
"délectation" => "delEktasj§",
"délectations" => "delEktasj§",
"délecte" => "delEkt",
"délecté" => "delEkte",
"délectent" => "delEkt",
"délecter" => "delEkte",
"délectes" => "delEkt",
"délectez" => "delEkte",
"délections" => "delEktj§",
"délégation" => "delegasj§",
"délégations" => "delegasj§",
"délégua" => "delega",
"déléguaient" => "delegE",
"déléguait" => "delegE",
"déléguant" => "deleg@",
"déléguât" => "delega",
"délègue" => "delEg",
"délégué" => "delege",
"délégué-général" => "delegeZeneRal",
"déléguée" => "delege",
"déléguer" => "delege",
"déléguerai" => "deleg°RE",
"délégueraient" => "deleg°RE",
"délégués" => "delege",
"déléguez" => "delege",
"déléguiez" => "delegje",
"déléguons" => "deleg§",
"délestage" => "delEstaZ",
"délestant" => "delEst@",
"déleste" => "delEst",
"délesté" => "delEste",
"délestée" => "delEste",
"délestées" => "delEste",
"délester" => "delEste",
"délestèrent" => "delEstER",
"délestés" => "delEste",
"délestons" => "delEst§",
"délétère" => "deletER",
"délétères" => "deletER",
"délia" => "delja",
"déliaient" => "deljE",
"déliait" => "deljE",
"déliant" => "delj@",
"délibéra" => "delibeRa",
"délibéraient" => "delibeRE",
"délibérait" => "delibeRE",
"délibérant" => "delibeR@",
"délibération" => "delibeRasj§",
"délibérations" => "delibeRasj§",
"délibérative" => "delibeRativ",
"délibératoire" => "delibeRatwaR",
"délibère" => "delibER",
"délibéré" => "delibeRe",
"délibérée" => "delibeRe",
"délibérées" => "delibeRe",
"délibérément" => "delibeRem@",
"délibèrent" => "delibER",
"délibérer" => "delibeRe",
"délibérera" => "delibeR°Ra",
"délibéreraient" => "delibeR°RE",
"délibérèrent" => "delibeRER",
"délibérés" => "delibeRe",
"délibérions" => "delibeRj§",
"délicat" => "delika",
"délicate" => "delikat",
"délicatement" => "delikat°m@",
"délicates" => "delikat",
"délicatesse" => "delikatEs",
"délicatesses" => "delikatEs",
"délicats" => "delika",
"délice" => "delis",
"délices" => "delis",
"délicieuse" => "delisj2z",
"délicieusement" => "delisj2z°m@",
"délicieuses" => "delisj2z",
"délicieux" => "delisj2",
"délictuelle" => "delikt8El",
"délictueuse" => "delikt82z",
"délictueuses" => "delikt82z",
"délictueux" => "delikt82",
"délie" => "deli",
"délié" => "delje",
"déliée" => "delje",
"déliées" => "delje",
"délient" => "deli",
"délier" => "delje",
"délieraient" => "deliRE",
"délieras" => "deliRa",
"délièrent" => "deljER",
"déliés" => "delje",
"déliez" => "delie",
"délimitaient" => "delimitE",
"délimitais" => "delimitE",
"délimitait" => "delimitE",
"délimitant" => "delimit@",
"délimitation" => "delimitasj§",
"délimitations" => "delimitasj§",
"délimite" => "delimit",
"délimité" => "delimite",
"délimitée" => "delimite",
"délimitées" => "delimite",
"délimitent" => "delimit",
"délimiter" => "delimite",
"délimités" => "delimite",
"délimitez" => "delimite",
"délimitions" => "delimitj§",
"délimitons" => "delimit§",
"délinéaments" => "delineam@",
"délinquance" => "del5k@s",
"délinquances" => "del5k@s",
"délinquant" => "del5k@",
"délinquante" => "del5k@t",
"délinquantes" => "del5k@t",
"délinquants" => "del5k@",
"déliquescence" => "delikes@s",
"déliquescent" => "delikes@",
"déliquescente" => "delikes@t",
"déliquescents" => "delikes@",
"délira" => "deliRa",
"délirai" => "deliRE",
"déliraient" => "deliRE",
"délirais" => "deliRE",
"délirait" => "deliRE",
"délirant" => "deliR@",
"délirante" => "deliR@t",
"délirantes" => "deliR@t",
"délirants" => "deliR@",
"délirassent" => "deliRas",
"délire" => "deliR",
"déliré" => "deliRe",
"délirent" => "deliR",
"délirer" => "deliRe",
"délireras" => "deliR°Ra",
"délires" => "deliR",
"délirez" => "deliRe",
"déliriez" => "deliRje",
"delirium" => "deliRjOm",
"delirium tremens" => "deliRjOmtRemEns",
"délit" => "deli",
"délitaient" => "delitE",
"délite" => "delit",
"délité" => "delite",
"délitée" => "delite",
"délitées" => "delite",
"délitent" => "delit",
"déliteront" => "delit°R§",
"délits" => "deli",
"délivra" => "delivRa",
"délivraient" => "delivRE",
"délivrais" => "delivRE",
"délivrait" => "delivRE",
"délivrance" => "delivR@s",
"délivrances" => "delivR@s",
"délivrant" => "delivR@",
"délivrât" => "delivRa",
"délivre" => "delivR",
"délivré" => "delivRe",
"délivrée" => "delivRe",
"délivrées" => "delivRe",
"délivrent" => "delivR",
"délivrer" => "delivRe",
"délivrera" => "delivR°Ra",
"délivrerai" => "delivR°RE",
"délivreraient" => "delivR°RE",
"délivrerais" => "delivR°RE",
"délivrerait" => "delivR°RE",
"délivreras" => "delivR°Ra",
"délivrèrent" => "delivRER",
"délivrerez" => "delivR°Re",
"délivrerons" => "delivR°R§",
"délivreront" => "delivR°R§",
"délivrés" => "delivRe",
"délivreurs" => "delivR9R",
"délivrez" => "delivRe",
"délivriez" => "delivRije",
"délivrions" => "delivRij§",
"délivrons" => "delivR§",
"della francesca" => "dElafR@sEska",
"della porta" => "dElapORta",
"della robbia" => "dElaRObja",
"délocalisation" => "delokalizasj§",
"délocalisé" => "delOkalize",
"délocaliser" => "delOkalize",
"délocalisez" => "delokalize",
"déloge" => "delOZ",
"délogé" => "deloZe",
"délogea" => "deloZa",
"délogeait" => "deloZE",
"délogeât" => "deloZa",
"délogée" => "deloZe",
"déloger" => "deloZe",
"délogera" => "delOZ°Ra",
"délogerait" => "delOZ°RE",
"délogerons" => "delOZ°R§",
"délogés" => "deloZe",
"délogez" => "deloZe",
"déloquaient" => "delokE",
"déloque" => "delOk",
"déloqué" => "deloke",
"déloquées" => "deloke",
"déloquer" => "deloke",
"déloques" => "delOk",
"déloqués" => "deloke",
"délourdant" => "deluRd@",
"délourder" => "deluRde",
"déloyal" => "delwajal",
"déloyale" => "delwajal",
"déloyalement" => "delwajal°m@",
"déloyauté" => "delwajote",
"déloyautés" => "delwajote",
"déloyaux" => "delwajo",
"delphinidés" => "dElfinide",
"delphinium" => "dElfinjOm",
"delphiniums" => "dElfinjOm",
"delta" => "dElta",
"delta-plane" => "dEltaplan",
"deltaplane" => "dEltaplan",
"deltas" => "dElta",
"deltoïde" => "dEltoid",
"deltoïdes" => "dEltoid",
"déluge" => "delyZ",
"déluges" => "delyZ",
"déluré" => "delyRe",
"délurée" => "delyRe",
"délurées" => "delyRe",
"délustrer" => "delystRe",
"démagnétisé" => "demaNetize",
"démagnétisée" => "demaNetize",
"démagnétiser" => "demaNetize",
"démago" => "demago",
"démagogie" => "demagoZi",
"démagogique" => "demagoZik",
"démagogiques" => "demagoZik",
"démagogue" => "demagOg",
"démagogues" => "demagOg",
"démaille" => "demaj",
"démaillée" => "demaje",
"démailler" => "demaje",
"démailloté" => "demajote",
"démailloter" => "demajote",
"demain" => "d°m5",
"demains" => "d°m5",
"démanche" => "dem@S",
"démanché" => "dem@Se",
"démancher" => "dem@Se",
"demanda" => "d°m@da",
"demandai" => "d°m@dE",
"demandaient" => "d°m@dE",
"demandais" => "d°m@dE",
"demandait" => "d°m@dE",
"demandâmes" => "d°m@dam",
"demandant" => "d°m@d@",
"demandât" => "d°m@da",
"demande" => "d°m@d",
"demandé" => "d°m@de",
"demandée" => "d°m@de",
"demandées" => "d°m@de",
"demandent" => "d°m@d",
"demander" => "d°m@de",
"demandera" => "d°m@d°Ra",
"demanderai" => "d°m@d°RE",
"demanderaient" => "d°m@d°RE",
"demanderais" => "d°m@d°RE",
"demanderait" => "d°m@d°RE",
"demanderas" => "d°m@d°Ra",
"demandèrent" => "d°m@dER",
"demanderesse" => "d°m@d°REs",
"demanderez" => "d°m@d°Re",
"demanderiez" => "d°m@d°Rje",
"demanderons" => "d°m@d°R§",
"demanderont" => "d°m@d°R§",
"demandes" => "d°m@d",
"demandés" => "d°m@de",
"demandeur" => "d°m@d9R",
"demandeurs" => "d°m@d9R",
"demandeuse" => "d°m@d2z",
"demandez" => "d°m@de",
"demandiez" => "d°m@dje",
"demandions" => "d°m@dj§",
"demandons" => "d°m@d§",
"démange" => "dem@Z",
"démangé" => "dem@Ze",
"démangeaient" => "dem@ZE",
"démangeais" => "dem@ZE",
"démangeaison" => "dem@Zez§",
"démangeaisons" => "dem@Zaiz§",
"démangeait" => "dem@ZE",
"démangent" => "dem@Z",
"démanger" => "dem@Ze",
"démangés" => "dem@Ze",
"démantèle" => "dem@tEl",
"démantelé" => "dem@t°le",
"démantelée" => "dem@t°le",
"démantelées" => "dem@t°le",
"démantèlement" => "dem@tEl°m@",
"démantèlements" => "dem@tEl°m@",
"démantèlent" => "dem@tEl",
"démanteler" => "dem@t°le",
"démantelés" => "dem@t°le",
"démantelez" => "dem@t°le",
"démantelons" => "dem@t°l§",
"démantibulant" => "dem@tibyl@",
"démantibule" => "dem@tibyl",
"démantibulé" => "dem@tibyle",
"démantibulée" => "dem@tibyle",
"démantibulées" => "dem@tibyle",
"démantibulent" => "dem@tibyl",
"démantibuler" => "dem@tibyle",
"démantibulés" => "dem@tibyle",
"démaquillage" => "demakijaZ",
"démaquillaient" => "demakijE",
"démaquillais" => "demakijE",
"démaquillait" => "demakijE",
"démaquillant" => "demakij@",
"démaquillante" => "demakij@t",
"démaquille" => "demakij",
"démaquillé" => "demakije",
"démaquillée" => "demakije",
"démaquiller" => "demakije",
"démaquillerai" => "demakij°RE",
"démarcation" => "demaRkasj§",
"démarcha" => "demaRSa",
"démarchage" => "demaRSaZ",
"démarchait" => "demaRSE",
"démarche" => "demaRS",
"démarcher" => "demaRSe",
"démarches" => "demaRS",
"démarcheur" => "demaRS9R",
"démarcheurs" => "demaRS9R",
"démarcheuse" => "demaRS2z",
"démariée" => "demaRje",
"démarient" => "demaRi",
"démarier" => "demaRje",
"démarquai" => "demaRkE",
"démarquaient" => "demaRkE",
"démarquait" => "demaRkE",
"démarque" => "demaRk",
"démarqué" => "demaRke",
"démarquée" => "demaRke",
"démarquées" => "demaRke",
"démarquer" => "demaRke",
"démarqués" => "demaRke",
"démarra" => "demaRa",
"démarrage" => "demaRaZ",
"démarrages" => "demaRaZ",
"démarrai" => "demaRE",
"démarraient" => "demaRE",
"démarrais" => "demaRE",
"démarrait" => "demaRE",
"démarrant" => "demaR@",
"démarrât" => "demaRa",
"démarre" => "demaR",
"démarré" => "demaRe",
"démarrée" => "demaRe",
"démarrées" => "demaRe",
"démarrent" => "demaR",
"démarrer" => "demaRe",
"démarrera" => "demaR°Ra",
"démarrerai" => "demaR°RE",
"démarrèrent" => "demaRER",
"démarreront" => "demaR°R§",
"démarres" => "demaR",
"démarrés" => "demaRe",
"démarreur" => "demaR9R",
"démarreurs" => "demaR9R",
"démarrez" => "demaRe",
"démarrions" => "demaRj§",
"démarrons" => "demaR§",
"démasqua" => "demaska",
"démasquage" => "demaskaZ",
"démasquaient" => "demaskE",
"démasquais" => "demaskE",
"démasquait" => "demaskE",
"démasquant" => "demask@",
"démasque" => "demask",
"démasqué" => "demaske",
"démasquée" => "demaske",
"démasquées" => "demaske",
"démasquent" => "demask",
"démasquer" => "demaske",
"démasquera" => "demask°Ra",
"démasquerai" => "demask°RE",
"démasquerait" => "demask°RE",
"démasqueriez" => "demask°Rje",
"démasquerons" => "demask°R§",
"démasqueront" => "demask°R§",
"démasqués" => "demaske",
"démasquons" => "demask§",
"démâtait" => "dematE",
"démâté" => "demate",
"démâtée" => "demate",
"démâter" => "demate",
"dématérialisation" => "demateRjalizasj§",
"dématérialise" => "demateRjaliz",
"dématérialisé" => "demateRijalize",
"dématérialisent" => "demateRjaliz",
"dématérialiser" => "demateRijalize",
"démâtés" => "demate",
"démêla" => "demEla",
"démêlage" => "demElaZ",
"démêlai" => "demElE",
"démêlais" => "demElE",
"démêlait" => "demElE",
"démêlant" => "demEl@",
"démêle" => "demEl",
"démêlé" => "demele",
"démêlées" => "demele",
"démêlent" => "demEl",
"démêler" => "demele",
"démêlerait" => "demEl°RE",
"démêlés" => "demele",
"démêlions" => "demElj§",
"démêloir" => "demElwaR",
"démembrant" => "dem@bR@",
"démembre" => "dem@bR",
"démembré" => "dem@bRe",
"démembrée" => "dem@bRe",
"démembrées" => "dem@bRe",
"démembrement" => "dem@bR°m@",
"démembrements" => "dem@bR°m@",
"démembrer" => "dem@bRe",
"démembrés" => "dem@bRe",
"démembrez" => "dem@bRe",
"démena" => "dem°na",
"déménage" => "demenaZ",
"déménagé" => "demenaZe",
"déménagea" => "demenaZa",
"déménageaient" => "demenaZE",
"déménageais" => "demenaZE",
"déménageait" => "demenaZE",
"déménageant" => "demenaZ@",
"déménagée" => "demenaZe",
"déménagement" => "demenaZ°m@",
"déménagements" => "demenaZ°m@",
"déménagent" => "demenaZ",
"déménageons" => "demenaZ§",
"déménager" => "demenaZe",
"déménagera" => "demenaZ°Ra",
"déménagerai" => "demenaZ°RE",
"déménageraient" => "demenaZ°RE",
"déménagerais" => "demenaZ°RE",
"déménagerait" => "demenaZ°RE",
"déménageras" => "demenaZ°Ra",
"déménagèrent" => "demenaZER",
"déménagerez" => "demenaZ°Re",
"déménages" => "demenaZ",
"déménagés" => "demenaZe",
"déménageur" => "demenaZ9R",
"déménageurs" => "demenaZ9R",
"déménageuse" => "demenaZ2z",
"déménagez" => "demenaZe",
"déménagiez" => "demenaZje",
"déménagions" => "demenaZj§",
"démenaient" => "dem°nE",
"démenais" => "dem°nE",
"démenait" => "dem°nE",
"démenant" => "dem°n@",
"démence" => "dem@s",
"démène" => "demEn",
"démené" => "dem°ne",
"démenée" => "dem°ne",
"démènent" => "demEn",
"démener" => "demne",
"démèneras" => "demEn°Ra",
"démènes" => "demEn",
"démenons" => "dem°n§",
"démenotte" => "dem°nOt",
"démens" => "dem@",
"dément" => "dem@",
"démentaient" => "dem@tE",
"démentait" => "dem@tE",
"démentant" => "dem@t@",
"démente" => "dem@t",
"démentent" => "dem@t",
"démentes" => "dem@t",
"démentez" => "dem@te",
"démenti" => "dem@ti",
"démentie" => "dem@ti",
"démentiel" => "dem@sjEl",
"démentielle" => "dem@sjEl",
"démentielles" => "dem@sjEl",
"démentiels" => "dem@sjEl",
"démenties" => "dem@ti",
"démentir" => "dem@tiR",
"démentirai" => "dem@tiRE",
"démentirait" => "dem@tiRE",
"démentiront" => "dem@tiR§",
"démentis" => "dem@ti",
"démentit" => "dem@ti",
"déments" => "dem@",
"démerdaient" => "demERdE",
"démerdais" => "demERdE",
"démerdait" => "demERdE",
"démerdard" => "demERdaR",
"démerdards" => "demERdaR",
"démerde" => "demERd",
"démerdé" => "demERde",
"démerdée" => "demERde",
"démerdent" => "demERd",
"démerder" => "demERde",
"démerdera" => "demERd°Ra",
"démerderai" => "demERd°RE",
"démerderas" => "demERd°Ra",
"démerdes" => "demERd",
"démerdés" => "demERde",
"démerdez" => "demERde",
"déméritait" => "demeRitE",
"démérite" => "demeRit",
"démérité" => "demeRite",
"démériter" => "demeRite",
"démérites" => "demeRit",
"dèmes" => "dEm",
"démesure" => "dem°zyR",
"démesuré" => "dem°zyRe",
"démesurée" => "dem°zyRe",
"démesurées" => "dem°zyRe",
"démesurément" => "dem°zyRem@",
"démesurent" => "dem°zyR",
"démesurés" => "dem°zyRe",
"démet" => "demE",
"démets" => "demE",
"démette" => "demEt",
"démettez" => "demEte",
"démettrait" => "demEtRE",
"démettre" => "demEtR",
"démeublé" => "dem9ble",
"démeublée" => "dem9ble",
"demeura" => "d°m9Ra",
"demeurai" => "d°m9RE",
"demeuraient" => "d°m9RE",
"demeurais" => "d°m9RE",
"demeurait" => "d°m9RE",
"demeurâmes" => "d°m9Ram",
"demeurant" => "d°m9R@",
"demeurassent" => "d°m9Ras",
"demeurât" => "d°m9Ra",
"demeure" => "d°m9R",
"demeuré" => "d°m9Re",
"demeurée" => "d°m9Re",
"demeurées" => "d°m9Re",
"demeurent" => "d°m9R",
"demeurer" => "d°m9Re",
"demeurera" => "d°m9R°Ra",
"demeurerai" => "d°m9R°RE",
"demeureraient" => "d°m9R°RE",
"demeurerais" => "d°m9R°RE",
"demeurerait" => "d°m9R°RE",
"demeureras" => "d°m9R°Ra",
"demeurèrent" => "d°m9RER",
"demeurerez" => "d°m9R°Re",
"demeurerions" => "d°m9R°Rj§",
"demeurerons" => "d°m9R°R§",
"demeureront" => "d°m9R°R§",
"demeures" => "d°m9R",
"demeurés" => "d°m9Re",
"demeurez" => "d°m9Re",
"demeuriez" => "d°m9Rje",
"demeurions" => "d°m9Rj§",
"demeurons" => "d°m9R§",
"demi" => "d°mi",
"demi-barbare" => "d2mibaRbaR",
"demi-bas" => "d°miba",
"demi-bonheur" => "d2mibOn9R",
"demi-bottes" => "d°mibOt",
"demi-bouteille" => "d°mibutEj",
"demi-brigade" => "d°mibRigad",
"demi-brigades" => "d°mibRigad",
"demi-cent" => "d2mis@",
"demi-centimètre" => "d2mis@timEtR",
"demi-centre" => "d2mis@tR",
"demi-cercle" => "d°misERkl",
"demi-cercles" => "d°misERkl",
"demi-chagrin" => "d°miSagR5",
"demi-clair" => "d2miklER",
"demi-clarté" => "d2miklaRte",
"demi-cloison" => "d2miklwaz§",
"demi-coma" => "d2mikOma",
"demi-confidence" => "d2mik§fid@s",
"demi-conscience" => "d2mik§sj@s",
"demi-cylindre" => "d2misil5dR",
"demi-degré" => "d2mid2gRe",
"demi-deuil" => "d°mid9j",
"demi-dévêtu" => "d°midevEty",
"demi-dévêtue" => "d°midevEty",
"demi-dieu" => "d°midj2",
"demi-dieux" => "d°midj2",
"demi-dose" => "d2midoz",
"demi-douzaine" => "d°miduzEn",
"demi-échec" => "d°mieSEk",
"demi-figure" => "d°mifigyR",
"demi-finale" => "d°mifinal",
"demi-finales" => "d°mifinal",
"demi-finaliste" => "d2mifinalist",
"demi-fond" => "d°mif§",
"demi-fou" => "d2mifu",
"demi-fous" => "d°mifu",
"demi-frère" => "d°mifRER",
"demi-frères" => "d°mifRER",
"demi-gros" => "d°migRo",
"demi-heure" => "d°mi9R",
"demi-heures" => "d°mi9R",
"demi-jour" => "d°miZuR",
"demi-journée" => "d°miZuRne",
"demi-journées" => "d°miZuRne",
"demi-juif" => "d2miZ8if",
"demi-kilomètre" => "d2mikilOmEtR",
"demi-liberté" => "d2milibERte",
"demi-lieue" => "d2milj2",
"demi-litre" => "d°militR",
"demi-livre" => "d2milivR",
"demi-longueur" => "d°mil§g9R",
"demi-louis" => "d2milwi",
"demi-lueur" => "d2mily9R",
"demi-lumière" => "d2milymjER",
"demi-lune" => "d°milyn",
"demi-lunes" => "d°milyn",
"demi-luxe" => "d2milyks",
"demi-mal" => "d°mimal",
"demi-mensonge" => "d2mim5s§Z",
"demi-mesure" => "d°mim°zyR",
"demi-mesures" => "d°mim°zyR",
"demi-mètre" => "d2mimEtR",
"demi-mille" => "d2mimil",
"demi-milliard" => "d2mimiljaR",
"demi-millimètre" => "d2mimilimEtR",
"demi-million" => "d2mimilj§",
"demi-minute" => "d°miminyt",
"demi-mois" => "d2mimwa",
"demi-mondaine" => "d°mim§dEn",
"demi-mondaines" => "d°mim§dEn",
"demi-monde" => "d°mim§d",
"demi-mort" => "d°mimOR",
"demi-morte" => "d°mimORt",
"demi-morts" => "d°mimOR",
"demi-mot" => "d°mimo",
"demi-muid" => "d°mim8i",
"demi-nu" => "d2miny",
"demi-nuit" => "d2min8i",
"demi-obscurité" => "d2miOpskyRite",
"demi-ouverte" => "d°miuvERt",
"demi-ouvrier" => "d°miuvRije",
"demi-page" => "d2mipaZ",
"demi-paralysé" => "d2mipaRalize",
"demi-part" => "d2mipaR",
"demi-pas" => "d2mipa",
"demi-pension" => "d°mip@sj§",
"demi-pensionnaire" => "d°mip@sjonER",
"demi-pensionnaires" => "d°mip@sjonER",
"demi-personne" => "d2mipERsOn",
"demi-pièce" => "d°mipjEs",
"demi-pied" => "d2mipje",
"demi-pinte" => "d2mip5t",
"demi-place" => "d°miplas",
"demi-plein" => "d2mipl5",
"demi-point" => "d2mipw5",
"demi-pointes" => "d°mipw5t",
"demi-porte" => "d2mipORt",
"demi-portion" => "d°mipORsj§",
"demi-portions" => "d°mipORsj§",
"demi-pouce" => "d2mipus",
"demi-quart" => "d°mikaR",
"demi-queue" => "d°mik2",
"demi-réussite" => "d2miReysit",
"demi-rêve" => "d2miREve",
"demi-révérence" => "d2miReveR@s",
"demi-ronde" => "d°miR§d",
"demi-saison" => "d°misEz§",
"demi-saisons" => "d°misEz§",
"demi-sang" => "d°mis@",
"demi-sangs" => "d°mis@",
"demi-seconde" => "d2mis2g§d",
"demi-section" => "d2misEksj§",
"demi-sel" => "d°misEl",
"demi-sels" => "d°misEl",
"demi-siècle" => "d°misjEkl",
"demi-siècles" => "d°misjEkl",
"demi-soeur" => "d°mis9R",
"demi-soeurs" => "d°mis9R",
"demi-solde" => "d°misOld",
"demi-soldes" => "d°misOld",
"demi-sommeil" => "d°misomEj",
"demi-sommeils" => "d°misomEj",
"demi-somnolence" => "d2misOmnOl@s",
"demi-sourire" => "d°misuRiR",
"demi-sourires" => "d°misuRiR",
"demi-succès" => "d°misyksE",
"demi-suicide" => "d°mis8isid",
"demi-talent" => "d2mital@",
"demi-tarif" => "d°mitaRif",
"demi-tasse" => "d°mitas",
"demi-teinte" => "d°mit5t",
"demi-teintes" => "d°mit5t",
"demi-tête" => "d2mitEt",
"demi-ton" => "d°mit§",
"demi-tonne" => "d°mitOn",
"demi-tonneau" => "d°mitono",
"demi-tons" => "d°mit§",
"demi-tour" => "d°mituR",
"demi-tours" => "d°mituR",
"demi-vérité" => "d°miveRite",
"demi-verre" => "d2mivER",
"demi-vertu" => "d2mivERty",
"demi-vie" => "d°mivi",
"demi-vierge" => "d°mivjERZ",
"demi-vierges" => "d°mivjERZ",
"demi-vies" => "d°mivi",
"demi-volée" => "d°mivole",
"demi-volte" => "d2mivOlt",
"demi-voltes" => "d°mivOlt",
"demi-volume" => "d2mivOlym",
"demie" => "d°mi",
"demies" => "d°mi",
"démilitarisation" => "demilitaRizasj§",
"démilitarisée" => "demilitaRize",
"démilitarisées" => "demilitaRize",
"déminage" => "deminaZ",
"déminant" => "demin@",
"déminé" => "demine",
"déminée" => "demine",
"déminer" => "demine",
"démineur" => "demin9R",
"démineurs" => "demin9R",
"demis" => "d°mi",
"démis" => "demi",
"démise" => "demiz",
"démises" => "demiz",
"démission" => "demisj§",
"démissionna" => "demisjona",
"démissionnaient" => "demisjonE",
"démissionnaire" => "demisjonER",
"démissionnaires" => "demisjonER",
"démissionnais" => "demisjonE",
"démissionnait" => "demisjonE",
"démissionnant" => "demisjon@",
"démissionne" => "demisjOn",
"démissionné" => "demisjone",
"démissionnent" => "demisjOn",
"démissionner" => "demisjone",
"démissionnera" => "demisjOn°Ra",
"démissionnerai" => "demisjOn°RE",
"démissionneraient" => "demisjOn°RE",
"démissionnerais" => "demisjOn°RE",
"démissionnerait" => "demisjOn°RE",
"démissionneras" => "demisjOn°Ra",
"démissionnerez" => "demisjOn°Re",
"démissionneront" => "demisjOn°R§",
"démissionnes" => "demisjOn",
"démissionnez" => "demisjone",
"démissionniez" => "demisjonje",
"démissions" => "demisj§",
"démit" => "demi",
"démiurge" => "demjyRZ",
"démiurges" => "demjyRZ",
"démobilisant" => "demobiliz@",
"démobilisateur" => "demobilizat9R",
"démobilisation" => "demobilizasj§",
"démobilise" => "demobiliz",
"démobilisé" => "demobilize",
"démobiliser" => "demobilize",
"démobiliseriez" => "demobiliz°Rje",
"démobilisés" => "demobilize",
"démocrate" => "demokRat",
"démocrate-chrétien" => "demokRatkRetj5",
"démocrates" => "demokRat",
"démocrates-chrétiens" => "demokRatkRetj5",
"démocratie" => "demokRasi",
"démocraties" => "demokRasi",
"démocratique" => "demokRatik",
"démocratiquement" => "demokRatik°m@",
"démocratiques" => "demokRatik",
"démocratisation" => "demokRatizasj§",
"démocratisations" => "demokRatizasj§",
"démocratise" => "demokRatiz",
"démocratisé" => "demOkRatize",
"démocratiser" => "demokRatize",
"démocratiseront" => "demokRatiz°R§",
"démodaient" => "demodE",
"démodant" => "demod@",
"démode" => "demOd",
"démodé" => "demode",
"démodée" => "demode",
"démodées" => "demode",
"démoder" => "demode",
"démodés" => "demode",
"démodulateur" => "demodylat9R",
"démodulateurs" => "demodylat9R",
"démographie" => "demogRafi",
"démographique" => "demogRafik",
"démographiquement" => "demogRafik°m@",
"démographiques" => "demogRafik",
"demoiselle" => "d°mwazEl",
"demoiselles" => "d°mwazEl",
"démoli" => "demoli",
"démolie" => "demoli",
"démolies" => "demoli",
"démolir" => "demoliR",
"démolira" => "demoliRa",
"démolirai" => "demoliRE",
"démoliraient" => "demoliRE",
"démolirais" => "demoliRE",
"démolirait" => "demoliRE",
"démolirent" => "demoliR",
"démolirions" => "demoliRj§",
"démoliront" => "demoliR§",
"démolis" => "demoli",
"démolissaient" => "demolisE",
"démolissais" => "demolisE",
"démolissait" => "demolisE",
"démolissant" => "demolis@",
"démolisse" => "demolis",
"démolissent" => "demolis",
"démolisses" => "demolis",
"démolisseur" => "demolis9R",
"démolisseurs" => "demolis9R",
"démolisseuse" => "demolis2z",
"démolissez" => "demolise",
"démolissions" => "demolisj§",
"démolit" => "demoli",
"démolition" => "demolisj§",
"démolitions" => "demolisj§",
"démon" => "dem§",
"démone" => "demOn",
"démones" => "demOn",
"démonétisé" => "demonetize",
"démonétisés" => "demonetize",
"démoniaque" => "demonjak",
"démoniaquement" => "demOnjak°m@",
"démoniaques" => "demonjak",
"démonique" => "demOnik",
"démonologie" => "demonoloZi",
"démonomanie" => "demonomani",
"démons" => "dem§",
"démonstrateur" => "dem§stRat9R",
"démonstrateurs" => "dem§stRat9R",
"démonstratif" => "dem§stRatif",
"démonstratifs" => "dem§stRatif",
"démonstration" => "dem§stRasj§",
"démonstrations" => "dem§stRasj§",
"démonstrative" => "dem§stRativ",
"démonstrativement" => "dem§stRativ°m@",
"démonstratrice" => "dem§stRatRis",
"démonta" => "dem§ta",
"démontable" => "dem§tabl",
"démontables" => "dem§tabl",
"démontage" => "dem§taZ",
"démontages" => "dem§taZ",
"démontaient" => "dem§tE",
"démontait" => "dem§tE",
"démontant" => "dem§t@",
"démonte" => "dem§t",
"démonté" => "dem§te",
"démonte-pneu" => "dem§tpn2",
"démonte-pneus" => "dem§tpn2",
"démontée" => "dem§te",
"démontées" => "dem§te",
"démontent" => "dem§t",
"démonter" => "dem§te",
"démontés" => "dem§te",
"démontez" => "dem§te",
"démontra" => "dem§tRa",
"démontrable" => "dem§tRabl",
"démontrai" => "dem§tRE",
"démontraient" => "dem§tRE",
"démontrait" => "dem§tRE",
"démontrant" => "dem§tR@",
"démontrât" => "dem§tRa",
"démontre" => "dem§tR",
"démontré" => "dem§tRe",
"démontrée" => "dem§tRe",
"démontrées" => "dem§tRe",
"démontrent" => "dem§tR",
"démontrer" => "dem§tRe",
"démontrera" => "dem§tR°Ra",
"démontrerai" => "dem§tR°RE",
"démontrerait" => "dem§tR°RE",
"démontrèrent" => "dem§tRER",
"démontrerons" => "dem§tR°R§",
"démontreront" => "dem§tR°R@",
"démontrés" => "dem§tRe",
"démontrez" => "dem§tRe",
"démontrions" => "dem§tRij§",
"démoralisa" => "demoRaliza",
"démoralisait" => "demoRalizE",
"démoralisant" => "demoRaliz@",
"démoralisante" => "demoRaliz@t",
"démoralisants" => "demoRaliz@",
"démoralisateur" => "demORalizat9R",
"démoralisateurs" => "demoRalizat9R",
"démoralisation" => "demoRalizasj§",
"démoralise" => "demoRaliz",
"démoralisé" => "demoRalize",
"démoralisée" => "demoRalize",
"démoralisées" => "demoRalize",
"démoralisent" => "demoRaliz",
"démoraliser" => "demoRalize",
"démoraliseraient" => "demoRaliz°RE",
"démoraliserais" => "demoRaliz°RE",
"démoralisés" => "demoRalize",
"démord" => "demOR",
"démordaient" => "demORdE",
"démordais" => "demORdE",
"démordait" => "demORdE",
"démordent" => "demORd",
"démordez" => "demORde",
"démordit" => "demORdi",
"démordra" => "demORdRa",
"démordrai" => "demORdRE",
"démordrait" => "demORdRE",
"démordre" => "demORdR",
"démordront" => "demORdR§",
"démords" => "demOR",
"démordu" => "demORdy",
"démotique" => "demotik",
"démotivation" => "demotivasj§",
"démotive" => "demotiv",
"démotivée" => "demOtive",
"démotiver" => "demOtive",
"démoucheté" => "demuS°te",
"démoule" => "demul",
"démoulé" => "demule",
"démoulées" => "demule",
"démouler" => "demule",
"démoules" => "demul",
"démultipliaient" => "demyltiplijE",
"démultipliait" => "demyltiplijE",
"démultipliant" => "demyltiplij@",
"démultiplicateur" => "demyltiplikat9R",
"démultiplication" => "demyltiplikasj§",
"démultiplie" => "demyltipli",
"démultiplié" => "demyltiplije",
"démultipliée" => "demyltiplije",
"démultipliées" => "demyltiplije",
"démultiplient" => "demyltipli",
"démultiplier" => "demyltiplije",
"démultipliés" => "demyltiplije",
"démuni" => "demyni",
"démunie" => "demyni",
"démunies" => "demyni",
"démunir" => "demyniR",
"démunis" => "demyni",
"démunissant" => "demynis@",
"démurge" => "demyRZ",
"démurger" => "demyRZe",
"démuseler" => "demyz°le",
"démystificateur" => "demistifikat9R",
"démystification" => "demistifikasj§",
"démystifications" => "demistifikasj§",
"démystificatrice" => "demistifikatRis",
"démystifié" => "demistifje",
"démystifier" => "demistifje",
"démythifie" => "demitifi",
"démythifié" => "demitifje",
"dénanti" => "den@ti",
"dénatalité" => "denatalite",
"dénaturaient" => "denatyRE",
"dénaturait" => "denatyRE",
"dénaturation" => "denatyRasj§",
"dénature" => "denatyR",
"dénaturé" => "denatyRe",
"dénaturée" => "denatyRe",
"dénaturées" => "denatyRe",
"dénaturent" => "denatyR",
"dénaturer" => "denatyRe",
"dénaturés" => "denatyRe",
"dénazification" => "denazifikasj§",
"dénazifier" => "denazifje",
"dendrite" => "d@dRit",
"dénégateurs" => "denegat9R",
"dénégation" => "denegasj§",
"dénégations" => "denegasj§",
"déneigé" => "denEZe",
"déneigement" => "denEZ°m@",
"déneiger" => "denEZe",
"dénervation" => "den2Rvasj§",
"dénervé" => "denERve",
"dengue" => "d@g",
"déni" => "deni",
"dénia" => "denja",
"déniaient" => "denjE",
"déniaisa" => "denjEza",
"déniaisas" => "denjEza",
"déniaisé" => "denjEze",
"déniaisement" => "denjEz°m@",
"déniaiser" => "denjeze",
"déniaises" => "denjEz",
"déniait" => "denjE",
"déniant" => "denj@",
"dénicha" => "deniSa",
"dénichai" => "deniSE",
"dénichaient" => "deniSE",
"dénichais" => "deniSE",
"dénichait" => "deniSE",
"dénichant" => "deniS@",
"déniche" => "deniS",
"déniché" => "deniSe",
"dénichée" => "deniSe",
"dénichées" => "deniSe",
"dénichent" => "deniS",
"dénicher" => "deniSe",
"dénichera" => "deniS°Ra",
"dénicherait" => "deniS°RE",
"dénicheras" => "deniS°Ra",
"dénichés" => "deniSe",
"dénicheur" => "deniS9R",
"dénicheurs" => "deniS9R",
"dénicheuse" => "deniS2z",
"dénichez" => "deniSe",
"dénichions" => "deniSj§",
"dénie" => "deni",
"dénié" => "denje",
"denier" => "d°nje",
"dénier" => "denje",
"dénierai" => "deniRE",
"deniers" => "d°nje",
"dénies" => "deni",
"dénigrais" => "denigRE",
"dénigrait" => "denigRE",
"dénigrant" => "denigR@",
"dénigrante" => "denigR@t",
"dénigre" => "denigR",
"dénigré" => "denigRe",
"dénigrées" => "denigRe",
"dénigrement" => "denigR°m@",
"dénigrements" => "denigR°m@",
"dénigrent" => "denigR",
"dénigrer" => "denigRe",
"dénigres" => "denigR",
"dénigrés" => "denigRe",
"dénigreuses" => "denigR2z",
"dénigrez" => "denigRe",
"denim" => "d2nim",
"denims" => "d°nim",
"dénions" => "denj§",
"dénis" => "deni",
"dénivelé" => "deniv°le",
"dénivelés" => "deniv°le",
"dénivellation" => "denivElasj§",
"dénivellations" => "denivElasj§",
"dénombra" => "den§bRa",
"dénombrables" => "den§bRabl",
"dénombrait" => "den§bRE",
"dénombrant" => "den§bR@",
"dénombre" => "den§bR",
"dénombré" => "den§bRe",
"dénombrement" => "den§bR°m@",
"dénombrements" => "den§bR°m@",
"dénombrent" => "den§bR",
"dénombrer" => "den§bRe",
"dénombrés" => "den§bRe",
"dénombrez" => "den§bRe",
"dénominateur" => "denominat9R",
"dénominatif" => "denOminatif",
"dénomination" => "denominasj§",
"dénominations" => "denominasj§",
"dénominer" => "denOmine",
"dénommaient" => "denomE",
"dénommait" => "denomE",
"dénommé" => "denome",
"dénommée" => "denome",
"dénomment" => "denOm",
"dénommer" => "denome",
"dénommés" => "denome",
"dénommez" => "denome",
"dénonça" => "den§sa",
"dénonçaient" => "den§sE",
"dénonçais" => "den§sE",
"dénonçait" => "den§sE",
"dénonçant" => "den§s@",
"dénonçât" => "den§sa",
"dénonce" => "den§s",
"dénoncé" => "den§se",
"dénoncée" => "den§se",
"dénoncées" => "den§se",
"dénoncent" => "den§s",
"dénoncer" => "den§se",
"dénoncera" => "den§s°Ra",
"dénoncerai" => "den§s°RE",
"dénonceraient" => "den§s°RE",
"dénoncerais" => "den§s°RE",
"dénoncerait" => "den§s°RE",
"dénonceras" => "den§s°Ra",
"dénoncerez" => "den§s°Re",
"dénonceriez" => "den§s°Rje",
"dénonceront" => "den§s°R§",
"dénonces" => "den§s",
"dénoncés" => "den§se",
"dénoncez" => "den§se",
"dénonciateur" => "den§sjat9R",
"dénonciation" => "den§sjasj§",
"dénonciations" => "den§sjasj§",
"dénonciatrice" => "den§sjatRis",
"dénonçons" => "den§s§",
"dénotaient" => "denotE",
"dénotait" => "denotE",
"dénotant" => "denot@",
"dénote" => "denOt",
"dénoté" => "denote",
"dénotent" => "denOt",
"dénoter" => "denote",
"dénoterait" => "denOt°RE",
"dénoua" => "denwa",
"dénouaient" => "denwE",
"dénouait" => "denwE",
"dénouant" => "denw@",
"dénouât" => "denwa",
"dénoue" => "denu",
"dénoué" => "denwe",
"dénouée" => "denwe",
"dénouées" => "denwe",
"dénouement" => "denum@",
"dénouements" => "denum@",
"dénouent" => "denu",
"dénouer" => "denwe",
"dénouera" => "denuRa",
"dénouerais" => "denuRE",
"dénouèrent" => "denwER",
"dénoués" => "denwe",
"dénouions" => "denujj§",
"dénoyautait" => "denwajotE",
"dénoyauter" => "denwajote",
"dénoyauteur" => "denwajot9R",
"denrée" => "d@Re",
"denrées" => "d@Re",
"dense" => "d@s",
"denses" => "d@s",
"densifia" => "d@sifja",
"densifie" => "d@sifi",
"densifié" => "d@sifje",
"densimètre" => "d@simEtR",
"densité" => "d@site",
"densités" => "d@site",
"dent" => "d@",
"dent-de-lion" => "d@d°lj§",
"dentaire" => "d@tER",
"dentaires" => "d@tER",
"dental" => "d@tal",
"dentale" => "d@tal",
"dentales" => "d@tal",
"denté" => "d@te",
"dentée" => "d@te",
"dentées" => "d@te",
"dentelé" => "d@t°le",
"dentelée" => "d@t°le",
"dentelées" => "d@t°le",
"dentelés" => "d@t°le",
"dentelle" => "d@tEl",
"dentelles" => "d@tEl",
"dentellière" => "d@t2ljER",
"dentelure" => "d@t°lyR",
"dentelures" => "d@tElyR",
"dentés" => "d@te",
"dentier" => "d@tje",
"dentiers" => "d@tje",
"dentifrice" => "d@tifRis",
"dentifrices" => "d@tifRis",
"dentiste" => "d@tist",
"dentisterie" => "d@tist°Ri",
"dentistes" => "d@tist",
"dentition" => "d@tisj§",
"dentitions" => "d@tisj§",
"dents" => "d@",
"denture" => "d@tyR",
"dentures" => "d@tyR",
"dénuda" => "denyda",
"dénudaient" => "denydE",
"dénudait" => "denydE",
"dénudant" => "denyd@",
"dénudation" => "denydasj§",
"dénude" => "denyd",
"dénudé" => "denyde",
"dénudée" => "denyde",
"dénudées" => "denyde",
"dénudent" => "denyd",
"dénuder" => "denyde",
"dénudera" => "denyd°Ra",
"dénuderait" => "denyd°RE",
"dénudèrent" => "denydER",
"dénudés" => "denyde",
"dénué" => "den8e",
"dénuée" => "den8e",
"dénuées" => "den8e",
"dénuement" => "denym@",
"dénués" => "den8e",
"deo gratias" => "deogRatja",
"déodorant" => "deodoR@",
"déodorants" => "deodoR@",
"déontologie" => "de§toloZi",
"déontologique" => "de§toloZik",
"déontologiques" => "de§toloZik",
"dépaillée" => "depaje",
"dépaillées" => "depaje",
"dépannage" => "depanaZ",
"dépannages" => "depanaZ",
"dépannaient" => "depanE",
"dépannait" => "depanE",
"dépanne" => "depan",
"dépanné" => "depane",
"dépannée" => "depane",
"dépannent" => "depan",
"dépanner" => "depane",
"dépannera" => "depan°Ra",
"dépannerais" => "depan°RE",
"dépannerait" => "depan°RE",
"dépanneriez" => "depan°Rje",
"dépanneront" => "depan°R§",
"dépannés" => "depane",
"dépanneur" => "depan9R",
"dépanneurs" => "depan9R",
"dépanneuse" => "depan2z",
"dépanneuses" => "depan2z",
"dépannons" => "depan§",
"dépaquetait" => "depak°tE",
"déparaient" => "depaRE",
"déparait" => "depaRE",
"déparât" => "depaRa",
"dépare" => "depaR",
"déparé" => "depaRe",
"dépareillaient" => "depaREjE",
"dépareillait" => "depaREjE",
"dépareillé" => "depaREje",
"dépareillée" => "depaREje",
"dépareillées" => "depaREje",
"dépareiller" => "depaREje",
"dépareilleraient" => "depaREj°RE",
"dépareillés" => "depaREje",
"déparer" => "depaRe",
"déparerait" => "depaR°RE",
"déparié" => "depaRje",
"dépariée" => "depaRje",
"dépariées" => "depaRje",
"dépariés" => "depaRje",
"déparlait" => "depaRlE",
"déparler" => "depaRle",
"départ" => "depaR",
"départage" => "depaRtaZ",
"départagé" => "depaRtaZe",
"départageant" => "depaRtaZ@",
"départager" => "depaRtaZe",
"départagera" => "depaRtaZ°Ra",
"départagions" => "depaRtaZj§",
"départait" => "depaRtE",
"département" => "depaRt°m@",
"départemental" => "depaRt°m@tal",
"départementale" => "depaRt°m@tal",
"départementales" => "depaRt°m@tal",
"départementaux" => "depaRt°m@to",
"départements" => "depaRt°m@",
"départent" => "depaRt",
"départi" => "depaRti",
"départie" => "depaRti",
"départir" => "depaRtiR",
"départira" => "depaRtiRa",
"départirent" => "depaRtiR",
"départis" => "depaRti",
"départit" => "depaRti",
"départs" => "depaR",
"dépassa" => "depasa",
"dépassai" => "depasE",
"dépassaient" => "depasE",
"dépassais" => "depasE",
"dépassait" => "depasE",
"dépassâmes" => "depasam",
"dépassant" => "depas@",
"dépassât" => "depasa",
"dépasse" => "depas",
"dépassé" => "depase",
"dépassée" => "depase",
"dépassées" => "depase",
"dépassement" => "depas°m@",
"dépassements" => "depas°m@",
"dépassent" => "depas",
"dépasser" => "depase",
"dépassera" => "depas°Ra",
"dépasserai" => "depas°RE",
"dépasseraient" => "depas°RE",
"dépasserais" => "depas°RE",
"dépasserait" => "depas°RE",
"dépasseras" => "depas°Ra",
"dépassèrent" => "depasER",
"dépasserions" => "depas°Rj§",
"dépasseront" => "depas°R§",
"dépasses" => "depas",
"dépassés" => "depase",
"dépassez" => "depase",
"dépassiez" => "depasje",
"dépassionnons" => "depasjon§",
"dépassions" => "depasj§",
"dépassons" => "depas§",
"dépatouillait" => "depatujE",
"dépatouille" => "depatuj",
"dépatouiller" => "depatuje",
"dépaver" => "depave",
"dépaysaient" => "depEizE",
"dépaysait" => "depEizE",
"dépaysant" => "depEiz@",
"dépaysante" => "depEiz@t",
"dépaysantes" => "depEiz@t",
"dépayse" => "depEiz",
"dépaysé" => "depEize",
"dépaysée" => "depEize",
"dépaysement" => "depeiz°m@",
"dépaysements" => "depeiz°m@",
"dépayser" => "depeize",
"dépaysera" => "depEiz°Ra",
"dépaysés" => "depEize",
"dépeçage" => "dep°saZ",
"dépeçaient" => "dep°sE",
"dépeçait" => "dep°sE",
"dépeçant" => "dep°s@",
"dépèce" => "depEs",
"dépecé" => "dep°se",
"dépecée" => "dep°se",
"dépècements" => "depEs°m@",
"dépècent" => "depEs",
"dépecer" => "dep°se",
"dépècera" => "depEs°Ra",
"dépècerai" => "depEs°RE",
"dépèceraient" => "depEs°RE",
"dépecèrent" => "dep°sER",
"dépecés" => "dep°se",
"dépeceur" => "dep°s9R",
"dépeceurs" => "dep°s9R",
"dépecez" => "dep°se",
"dépêcha" => "depESa",
"dépêchai" => "depESE",
"dépêchaient" => "depESE",
"dépêchais" => "depESE",
"dépêchait" => "depESE",
"dépêchant" => "depES@",
"dépêchât" => "depESa",
"dépêche" => "depES",
"dépêché" => "depeSe",
"dépêchée" => "depeSe",
"dépêchées" => "depeSe",
"dépêchent" => "depES",
"dépêcher" => "depeSe",
"dépêcherais" => "depES°RE",
"dépêchèrent" => "depESER",
"dépêcherons" => "depES°R§",
"dépêches" => "depES",
"dépêchés" => "depeSe",
"dépêchez" => "depESe",
"dépêchions" => "depESj§",
"dépêchons" => "depES§",
"dépeignaient" => "depENE",
"dépeignais" => "depENE",
"dépeignait" => "depENE",
"dépeignant" => "depEN@",
"dépeigne" => "depEN",
"dépeigné" => "depENe",
"dépeignée" => "depENe",
"dépeignent" => "depEN",
"dépeignés" => "depENe",
"dépeignirent" => "depENiR",
"dépeignis" => "depENi",
"dépeignit" => "depENi",
"dépeindre" => "dep5dR",
"dépeins" => "dep5",
"dépeint" => "dep5",
"dépeinte" => "dep5t",
"dépeintes" => "dep5t",
"dépeints" => "dep5",
"dépenaillé" => "dep°naje",
"dépenaillée" => "dep°naje",
"dépenaillées" => "dep°naje",
"dépenaillement" => "dep°naj°m@",
"dépenaillements" => "dep°naj°m@",
"dépenaillés" => "dep°naje",
"dépénaliser" => "depenalize",
"dépend" => "dep@",
"dépendaient" => "dep@dE",
"dépendais" => "dep@dE",
"dépendait" => "dep@dE",
"dépendance" => "dep@d@s",
"dépendances" => "dep@d@s",
"dépendant" => "dep@d@",
"dépendante" => "dep@d@t",
"dépendantes" => "dep@d@t",
"dépendants" => "dep@d@",
"dépende" => "dep@d",
"dépendent" => "dep@d",
"dépendeur" => "dep@d9R",
"dépendeurs" => "dep@d9R",
"dépendez" => "dep@de",
"dépendions" => "dep@dj§",
"dépendit" => "dep@di",
"dépendît" => "dep@di",
"dépendons" => "dep@d§",
"dépendra" => "dep@dRa",
"dépendraient" => "dep@dRE",
"dépendrait" => "dep@dRE",
"dépendre" => "dep@dR",
"dépendrez" => "dep@dRe",
"dépendront" => "dep@dR§",
"dépends" => "dep@",
"dépendu" => "dep@dy",
"dépens" => "dep@",
"dépensa" => "dep@sa",
"dépensai" => "dep@sE",
"dépensaient" => "dep@sE",
"dépensais" => "dep@sE",
"dépensait" => "dep@sE",
"dépensant" => "dep@s@",
"dépense" => "dep@s",
"dépensé" => "dep@se",
"dépensée" => "dep@se",
"dépensées" => "dep@se",
"dépensent" => "dep@s",
"dépenser" => "dep@se",
"dépensera" => "dep@s°Ra",
"dépenserai" => "dep@s°RE",
"dépenseraient" => "dep@s°RE",
"dépenserais" => "dep@s°RE",
"dépenserait" => "dep@s°RE",
"dépenseras" => "dep@s°Ra",
"dépenserez" => "dep@s°Re",
"dépenserions" => "dep@s°Rj§",
"dépenseront" => "dep@s°R§",
"dépenses" => "dep@s",
"dépensés" => "dep@se",
"dépensez" => "dep@se",
"dépensier" => "dep@sje",
"dépensière" => "dep@sjER",
"dépensiers" => "dep@sje",
"dépensiez" => "dep@sje",
"dépensons" => "dep@s§",
"déperdition" => "depERdisj§",
"déperditions" => "depERdisj§",
"dépéri" => "depeRi",
"dépérir" => "depeRiR",
"dépérira" => "depeRiRa",
"dépériraient" => "depeRiRE",
"dépérirait" => "depeRiRE",
"dépériront" => "depeRiR§",
"dépéris" => "depeRi",
"dépérissaient" => "depeRisE",
"dépérissais" => "depeRisE",
"dépérissait" => "depeRisE",
"dépérisse" => "depeRis",
"dépérissement" => "depeRis°m@",
"dépérissent" => "depeRis",
"dépérit" => "depeRi",
"dépersonnalisation" => "depERsOnalizasj§",
"dépersonnalisé" => "depERsOnalize",
"dépersonnalisée" => "depERsonalize",
"dépersonnaliser" => "depERsonalize",
"dépêtré" => "depEtRe",
"dépêtrée" => "depEtRe",
"dépêtrer" => "depetRe",
"dépêtrés" => "depEtRe",
"dépeuplait" => "dep9plE",
"dépeuple" => "dep9pl",
"dépeuplé" => "dep9ple",
"dépeuplée" => "dep9ple",
"dépeuplées" => "dep9ple",
"dépeuplent" => "dep9pl",
"dépeupler" => "dep9ple",
"dépeuplera" => "dep9pl°Ra",
"dépeuplés" => "dep9ple",
"déphasage" => "defazaZ",
"déphase" => "defaz",
"déphasé" => "defaze",
"déphasée" => "defaze",
"déphasés" => "defaze",
"déphaseurs" => "defaz9R",
"dépiautaient" => "depjotE",
"dépiautait" => "depjotE",
"dépiautant" => "depjot@",
"dépiaute" => "depjot",
"dépiauté" => "depjote",
"dépiautent" => "depjot",
"dépiauter" => "depjote",
"dépiautera" => "depjot°Ra",
"dépiautèrent" => "depjotER",
"dépiautés" => "depjote",
"dépieute" => "depj2t",
"dépigmentation" => "depigm@tasj§",
"dépigmenté" => "depigm@te",
"dépigmentés" => "depigm@te",
"dépilatoire" => "depilatwaR",
"dépiler" => "depile",
"dépiquage" => "depikaZ",
"dépique" => "depik",
"dépiquer" => "depike",
"dépiqués" => "depike",
"dépistage" => "depistaZ",
"dépistages" => "depistaZ",
"dépistait" => "depistE",
"dépistant" => "depist@",
"dépiste" => "depist",
"dépisté" => "depiste",
"dépister" => "depiste",
"dépit" => "depi",
"dépita" => "depita",
"dépitait" => "depitE",
"dépité" => "depite",
"dépitée" => "depite",
"dépiter" => "depite",
"dépités" => "depite",
"déplaça" => "deplasa",
"déplaçai" => "deplasE",
"déplaçaient" => "deplasE",
"déplaçais" => "deplasE",
"déplaçait" => "deplasE",
"déplaçant" => "deplas@",
"déplaçât" => "deplasa",
"déplace" => "deplas",
"déplacé" => "deplase",
"déplacée" => "deplase",
"déplacées" => "deplase",
"déplacement" => "deplas°m@",
"déplacements" => "deplas°m@",
"déplacent" => "deplas",
"déplacer" => "deplase",
"déplacera" => "deplas°Ra",
"déplacerai" => "deplas°RE",
"déplaceraient" => "deplas°RE",
"déplacerait" => "deplas°RE",
"déplaceras" => "deplas°Ra",
"déplacèrent" => "deplasER",
"déplacerez" => "deplas°Re",
"déplacerons" => "deplas°R§",
"déplaceront" => "deplas°R§",
"déplaces" => "deplas",
"déplacés" => "deplase",
"déplacez" => "deplase",
"déplaciez" => "deplasje",
"déplacions" => "deplasj§",
"déplaçons" => "deplas§",
"déplaira" => "deplERa",
"déplairaient" => "deplERE",
"déplairait" => "deplERE",
"déplaire" => "deplER",
"déplairont" => "deplER§",
"déplais" => "deplE",
"déplaisaient" => "deplEzE",
"déplaisais" => "deplEzE",
"déplaisait" => "deplEzE",
"déplaisant" => "deplEz@",
"déplaisante" => "deplEz@t",
"déplaisantes" => "deplEz@t",
"déplaisants" => "deplEz@",
"déplaise" => "deplEz",
"déplaisent" => "deplEz",
"déplaisez" => "deplEze",
"déplaisiez" => "deplEzje",
"déplaisir" => "depleziR",
"déplaisirs" => "deplEziR",
"déplaît" => "deplE",
"déplanque" => "depl@k",
"déplantèrent" => "depl@tER",
"déplantoir" => "depl@twaR",
"déplâtré" => "deplatRe",
"déplia" => "deplija",
"dépliable" => "deplijabl",
"dépliai" => "deplijE",
"dépliaient" => "deplijE",
"dépliais" => "deplijE",
"dépliait" => "deplijE",
"dépliâmes" => "depljam",
"dépliant" => "deplij@",
"dépliante" => "deplij@t",
"dépliants" => "deplij@",
"déplie" => "depli",
"déplié" => "deplije",
"dépliée" => "deplije",
"dépliées" => "deplije",
"dépliement" => "deplim@",
"déplient" => "depli",
"déplier" => "deplije",
"déplièrent" => "deplijER",
"déplies" => "depli",
"dépliés" => "deplije",
"déplions" => "deplij§",
"déplissa" => "deplisa",
"déplissaient" => "deplisE",
"déplissait" => "deplisE",
"déplisse" => "deplis",
"déplissent" => "deplis",
"déplisser" => "deplise",
"déploie" => "deplwa",
"déploiement" => "deplwam@",
"déploiements" => "deplwam@",
"déploient" => "deplwa",
"déploiera" => "deplwaRa",
"déploierai" => "deplwaRE",
"déploieraient" => "deplwaRE",
"déploierait" => "deplwaRE",
"déploieras" => "deplwaRa",
"déploierez" => "deplwaRe",
"déploierons" => "deplwaR§",
"déploieront" => "deplwaR§",
"déploies" => "deplwa",
"déplombé" => "depl§be",
"déplora" => "deploRa",
"déplorable" => "deploRabl",
"déplorablement" => "deploRabl°m@",
"déplorables" => "deploRabl",
"déplorai" => "deploRE",
"déploraient" => "deploRE",
"déplorais" => "deploRE",
"déplorait" => "deploRE",
"déplorant" => "deploR@",
"déploration" => "deploRasj§",
"déplore" => "deplOR",
"déploré" => "deploRe",
"déplorée" => "deploRe",
"déplorent" => "deplOR",
"déplorer" => "deploRe",
"déplorerais" => "deplOR°RE",
"déplorerait" => "deplOR°RE",
"déplorèrent" => "deplORER",
"déplorerons" => "deplOR°R§",
"déplorés" => "deploRe",
"déplorez" => "deploRe",
"déplorions" => "deplORj§",
"déplorons" => "deploR§",
"déploya" => "deplwaja",
"déployaient" => "deplwajE",
"déployais" => "deplwajE",
"déployait" => "deplwajE",
"déployant" => "deplwaj@",
"déployasse" => "deplwajas",
"déployât" => "deplwaja",
"déployé" => "deplwaje",
"déployée" => "deplwaje",
"déployées" => "deplwaje",
"déployer" => "deplwaje",
"déployèrent" => "deplwajER",
"déployés" => "deplwaje",
"déployez" => "deplwaje",
"déployions" => "deplwajj§",
"déployons" => "deplwaj§",
"déplu" => "deply",
"déplumait" => "deplymE",
"déplume" => "deplym",
"déplumé" => "deplyme",
"déplumée" => "deplyme",
"déplumer" => "deplyme",
"déplumés" => "deplyme",
"déplurent" => "deplyR",
"déplut" => "deply",
"déplût" => "deply",
"dépoétisent" => "depoetiz",
"dépoile" => "depwal",
"dépoilé" => "depwale",
"dépoilée" => "depwale",
"dépoilées" => "depwale",
"dépoiler" => "depwale",
"dépointées" => "depw5te",
"dépoitraillé" => "depwatRaje",
"dépoitraillée" => "depwatRaje",
"dépoitraillées" => "depwatRaje",
"dépoitraillés" => "depwatRaje",
"dépoli" => "depoli",
"dépolie" => "depoli",
"dépolies" => "depoli",
"dépolis" => "depoli",
"dépolissait" => "depolisE",
"dépolit" => "depoli",
"dépolitisant" => "depolitiz@",
"dépolitisé" => "depOlitize",
"dépolluer" => "depOl8e",
"dépollution" => "depOlysj§",
"dépopulation" => "depopylasj§",
"déport" => "depOR",
"déporta" => "depORta",
"déportaient" => "depORtE",
"déportais" => "depORtE",
"déportait" => "depORtE",
"déportant" => "depORt@",
"déportation" => "depORtasj§",
"déportations" => "depORtasj§",
"déporte" => "depORt",
"déporté" => "depORte",
"déportée" => "depORte",
"déportées" => "depORte",
"déportements" => "depORt°m@",
"déporter" => "depORte",
"déporteront" => "depORt°R§",
"déportés" => "depORte",
"déportez" => "depORte",
"déposa" => "depoza",
"déposai" => "depozE",
"déposaient" => "depozE",
"déposais" => "depozE",
"déposait" => "depozE",
"déposâmes" => "depozam",
"déposant" => "depoz@",
"déposât" => "depoza",
"dépose" => "depoz",
"déposé" => "depoze",
"déposée" => "depoze",
"déposées" => "depoze",
"déposent" => "depoz",
"déposer" => "depoze",
"déposera" => "depoz°Ra",
"déposerai" => "depoz°RE",
"déposeraient" => "depoz°RE",
"déposerais" => "depoz°RE",
"déposerait" => "depoz°RE",
"déposeras" => "depoz°Ra",
"déposèrent" => "depozER",
"déposerez" => "depoz°Re",
"déposerions" => "depoz°Rj§",
"déposerons" => "depoz°R§",
"déposeront" => "depoz°R§",
"déposes" => "depoz",
"déposés" => "depoze",
"déposez" => "depoze",
"déposiez" => "depozje",
"déposions" => "depozj§",
"dépositaire" => "depozitER",
"dépositaires" => "depozitER",
"déposition" => "depozisj§",
"dépositions" => "depozisj§",
"déposons" => "depoz§",
"dépossédais" => "deposedE",
"dépossédait" => "deposedE",
"dépossède" => "deposEd",
"dépossédé" => "deposede",
"dépossédée" => "deposede",
"dépossédées" => "deposede",
"déposséder" => "deposede",
"dépossédés" => "deposede",
"dépossession" => "deposesj§",
"dépôt" => "depo",
"dépôt-vente" => "depov@t",
"dépote" => "depOt",
"dépoté" => "depote",
"dépotent" => "depOt",
"dépoter" => "depote",
"dépotoir" => "depotwaR",
"dépôts" => "depo",
"dépoudrer" => "depudRe",
"dépouilla" => "depuja",
"dépouillage" => "depujaZ",
"dépouillaient" => "depujE",
"dépouillais" => "depujE",
"dépouillait" => "depujE",
"dépouillant" => "depuj@",
"dépouillât" => "depuja",
"dépouille" => "depuj",
"dépouillé" => "depuje",
"dépouillée" => "depuje",
"dépouillées" => "depuje",
"dépouillement" => "depuj°m@",
"dépouillements" => "depuj°m@",
"dépouillent" => "depuj",
"dépouiller" => "depuje",
"dépouillera" => "depuj°Ra",
"dépouillerais" => "depuj°RE",
"dépouillerait" => "depuj°RE",
"dépouillèrent" => "depujER",
"dépouillerez" => "depuj°Re",
"dépouilles" => "depuj",
"dépouillés" => "depuje",
"dépouillez" => "depuje",
"dépouillons" => "depuj§",
"dépourvu" => "depuRvy",
"dépourvue" => "depuRvy",
"dépourvues" => "depuRvy",
"dépourvus" => "depuRvy",
"dépoussiérage" => "depusjeRaZ",
"dépoussiéraient" => "depusjeRE",
"dépoussiérant" => "depusjeR@",
"dépoussière" => "depusjER",
"dépoussiéré" => "depusjeRe",
"dépoussiérer" => "depusjeRe",
"dépoussiérez" => "depusjeRe",
"dépravation" => "depRavasj§",
"dépravations" => "depRavasj§",
"dépravé" => "depRave",
"dépravée" => "depRave",
"dépravées" => "depRave",
"dépraver" => "depRave",
"dépravés" => "depRave",
"dépravons" => "depRav§",
"dépréciait" => "depResjE",
"dépréciant" => "depResj@",
"dépréciation" => "depResjasj§",
"déprécie" => "depResi",
"déprécié" => "depResje",
"dépréciée" => "depResje",
"déprécier" => "depResje",
"déprécies" => "depResi",
"dépréciez" => "depResje",
"dépréciiez" => "depResije",
"déprédateur" => "depRedat9R",
"déprédateurs" => "depRedat9R",
"déprédation" => "depRedasj§",
"déprédations" => "depRedasj§",
"déprenais" => "depR°nE",
"déprenait" => "depR°nE",
"déprend" => "depR@",
"déprendre" => "depR@dR",
"déprendront" => "depR@dR§",
"dépressif" => "depResif",
"dépressifs" => "depREsif",
"dépression" => "depResj§",
"dépressionnaire" => "depREsjonER",
"dépressions" => "depResj§",
"dépressive" => "depResiv",
"dépressives" => "depREsiv",
"dépressurisait" => "depResyRizE",
"dépressurisation" => "depREsyRizasj§",
"dépressurise" => "depResyRiz",
"dépressurisé" => "depResyRize",
"dépressuriser" => "depResyRize",
"dépressurisés" => "depResyRize",
"déprima" => "depRima",
"déprimais" => "depRimE",
"déprimait" => "depRimE",
"déprimant" => "depRim@",
"déprimante" => "depRim@t",
"déprimantes" => "depRim@t",
"déprimants" => "depRim@",
"déprime" => "depRim",
"déprimé" => "depRime",
"déprimée" => "depRime",
"déprimées" => "depRime",
"dépriment" => "depRim",
"déprimer" => "depRime",
"déprimerais" => "depRim°RE",
"déprimerait" => "depRim°RE",
"déprimes" => "depRim",
"déprimés" => "depRime",
"déprimez" => "depRime",
"déprirent" => "depRiR",
"dépris" => "depRi",
"déprit" => "depRi",
"déprogrammation" => "depROgRamasj§",
"déprogrammé" => "depRogRame",
"déprogrammée" => "depRogRame",
"déprogrammer" => "depRogRame",
"déprogrammez" => "depRogRame",
"dépucela" => "depys°la",
"dépucelage" => "depys°laZ",
"dépucelages" => "depys°laZ",
"dépucelé" => "depys°le",
"dépucelée" => "depys°le",
"dépuceler" => "depys°le",
"dépuceleur" => "depys°l9R",
"dépuceleurs" => "depys°l9R",
"dépucelle" => "depysEl",
"dépucellera" => "depysEl°Ra",
"dépucelons" => "depys°l§",
"depuis" => "d°p8i",
"dépulpé" => "depylpe",
"dépuratifs" => "depyRatif",
"dépurés" => "depyRe",
"députation" => "depytasj§",
"députations" => "depytasj§",
"député" => "depyte",
"député-maire" => "depytemER",
"députée" => "depyte",
"députer" => "depyte",
"députèrent" => "depytER",
"députés" => "depyte",
"déqualifier" => "dekalifje",
"déquillé" => "dekje",
"déquiller" => "dekije",
"déquillés" => "dekje",
"der" => "dER",
"déracina" => "deRasina",
"déracinaient" => "deRasinE",
"déracinais" => "deRasinE",
"déracinait" => "deRasinE",
"déracinant" => "deRasin@",
"déracine" => "deRasin",
"déraciné" => "deRasine",
"déracinée" => "deRasine",
"déracinées" => "deRasine",
"déracinement" => "deRasin°m@",
"déracinent" => "deRasin",
"déraciner" => "deRasine",
"déracinerait" => "deRasin°RE",
"déracinés" => "deRasine",
"dérailla" => "deRaja",
"déraillaient" => "deRajE",
"déraillais" => "deRajE",
"déraillait" => "deRajE",
"déraillant" => "deRaj@",
"déraille" => "deRaj",
"déraillé" => "deRaje",
"déraillement" => "deRaj°m@",
"déraillements" => "deRaj°m@",
"déraillent" => "deRaj",
"dérailler" => "deRaje",
"déraillera" => "deRaj°Ra",
"dérailles" => "deRaj",
"dérailleur" => "deRaj9R",
"déraillez" => "deRaje",
"déraison" => "deREz§",
"déraisonnable" => "deREzonabl",
"déraisonnablement" => "deREzonabl°m@",
"déraisonnables" => "deREzonabl",
"déraisonnait" => "deREzonE",
"déraisonne" => "deREzOn",
"déraisonné" => "deREzOne",
"déraisonner" => "deREzone",
"déraisonnes" => "deREzOn",
"déraisonnez" => "deREzone",
"déraisons" => "deREz§",
"dérange" => "deR@Z",
"dérangé" => "deR@Ze",
"dérangea" => "deR@Za",
"dérangeaient" => "deR@ZE",
"dérangeais" => "deR@ZE",
"dérangeait" => "deR@ZE",
"dérangeant" => "deR@Z@",
"dérangeante" => "deR@Z@t",
"dérangeantes" => "deR@Z@t",
"dérangeants" => "deR@Z@",
"dérangeassent" => "deR@Zas",
"dérangeât" => "deR@Za",
"dérangée" => "deR@Ze",
"dérangées" => "deR@Ze",
"dérangement" => "deR@Z°m@",
"dérangements" => "deR@Z°m@",
"dérangent" => "deR@Z",
"dérangeons" => "deR@Z§",
"déranger" => "deR@Ze",
"dérangera" => "deR@Z°Ra",
"dérangerai" => "deR@Z°RE",
"dérangeraient" => "deR@Z°RE",
"dérangerais" => "deR@Z°RE",
"dérangerait" => "deR@Z°RE",
"dérangeras" => "deR@Z°Ra",
"dérangerez" => "deR@Z°Re",
"dérangerons" => "deR@Z°R§",
"déranges" => "deR@Z",
"dérangés" => "deR@Ze",
"dérangez" => "deR@Ze",
"dérangiez" => "deR@Zje",
"dérangions" => "deR@Zj§",
"dérapa" => "deRapa",
"dérapage" => "deRapaZ",
"dérapages" => "deRapaZ",
"dérapai" => "deRapE",
"dérapaient" => "deRapE",
"dérapait" => "deRapE",
"dérapant" => "deRap@",
"dérape" => "deRap",
"dérapé" => "deRape",
"dérapent" => "deRap",
"déraper" => "deRape",
"déraperont" => "deRap°R§",
"dérapes" => "deRap",
"dérapez" => "deRape",
"dératé" => "deRate",
"dératées" => "deRate",
"dératés" => "deRate",
"dératisation" => "deRatizasj§",
"dératisations" => "deRatizasj§",
"dératisé" => "deRatize",
"dératisée" => "deRatize",
"dératiser" => "deRatize",
"dératisés" => "deRatize",
"dérayer" => "deReje",
"derby" => "dERbi",
"derbys" => "dERbi",
"derche" => "dERS",
"derches" => "dERS",
"déréalisaient" => "deRealizE",
"derechef" => "d°R°SEf",
"déréglage" => "deReglaZ",
"déréglait" => "deReglE",
"déréglant" => "deRegl@",
"dérègle" => "deREgl",
"déréglé" => "deRegle",
"déréglée" => "deRegle",
"déréglées" => "deRegle",
"dérèglement" => "deREgl°m@",
"déréglementation" => "deRegl°m@tasj§",
"dérèglements" => "deREgl°m@",
"dérèglent" => "deREgl",
"dérégler" => "deRegle",
"déréglés" => "deRegle",
"dérégulation" => "deRegylasj§",
"déréguler" => "deRegyle",
"déréliction" => "deReliksj§",
"déresponsabilisation" => "deREsp§sabilizasj§",
"dérida" => "deRida",
"déridait" => "deRidE",
"déride" => "deRid",
"déridé" => "deRide",
"dérider" => "deRide",
"déridera" => "deRid°Ra",
"dériderait" => "deRid°RE",
"déridez" => "deRide",
"dérision" => "deRizj§",
"dérisoire" => "deRizwaR",
"dérisoirement" => "deRizwaR°m@",
"dérisoires" => "deRizwaR",
"dériva" => "deRiva",
"dérivaient" => "deRivE",
"dérivais" => "deRivE",
"dérivait" => "deRivE",
"dérivant" => "deRiv@",
"dérivante" => "deRiv@t",
"dérivatif" => "deRivatif",
"dérivatifs" => "deRivatif",
"dérivation" => "deRivasj§",
"dérivations" => "deRivasj§",
"dérive" => "deRiv",
"dérivé" => "deRive",
"dérivée" => "deRive",
"dérivées" => "deRive",
"dérivent" => "deRiv",
"dériver" => "deRive",
"dériverai" => "deRiv°RE",
"dériveras" => "deRiv°Ra",
"dérives" => "deRiv",
"dérivés" => "deRive",
"dériveur" => "deRiv9R",
"dériveurs" => "deRiv9R",
"dérivez" => "deRive",
"dérivions" => "deRivj§",
"dérivons" => "deRiv§",
"dermatite" => "dERmatit",
"dermatoglyphes" => "dERmatoglif",
"dermatologie" => "dERmatOlOZi",
"dermatologique" => "dERmatoloZik",
"dermatologiques" => "dERmatoloZik",
"dermatologiste" => "dERmatOlOZist",
"dermatologue" => "dERmatolOg",
"dermatose" => "dERmatoz",
"dermatoses" => "dERmatoz",
"derme" => "dERm",
"dermeste" => "dERmEst",
"dermique" => "dERmik",
"dermiques" => "dERmik",
"dermite" => "dERmit",
"dermites" => "dERmit",
"dermographie" => "dERmogRafi",
"dernier" => "dERnje",
"dernier-né" => "dERnjene",
"dernière" => "dERnjER",
"dernière-née" => "dERnjERne",
"dernièrement" => "dERnjER°m@",
"dernières" => "dERnjER",
"derniers" => "dERnje",
"derniers-nés" => "dERnjene",
"déroba" => "deRoba",
"dérobade" => "deRobad",
"dérobades" => "deRobad",
"dérobai" => "deRobE",
"dérobaient" => "deRobE",
"dérobais" => "deRobE",
"dérobait" => "deRobE",
"dérobant" => "deRob@",
"dérobât" => "deRoba",
"dérobe" => "deROb",
"dérobé" => "deRobe",
"dérobée" => "deRobe",
"dérobées" => "deRobe",
"dérobent" => "deROb",
"dérober" => "deRobe",
"dérobera" => "deRob°Ra",
"déroberaient" => "deRob°RE",
"déroberait" => "deRob°RE",
"dérobèrent" => "deRobER",
"déroberons" => "deRob°R§",
"dérobes" => "deROb",
"dérobés" => "deRobe",
"dérobeuse" => "deRob2z",
"dérobez" => "deRobe",
"dérobiez" => "deRobje",
"dérobions" => "deRobj§",
"dérobons" => "deRob§",
"dérogation" => "deRogasj§",
"dérogations" => "deRogasj§",
"dérogatoire" => "deROgatwaR",
"déroge" => "deROZ",
"dérogé" => "deRoZe",
"dérogea" => "deRoZa",
"dérogeait" => "deRoZE",
"dérogent" => "deROZ",
"déroger" => "deRoZe",
"dérogera" => "deROZ°Ra",
"dérogerait" => "deROZ°RE",
"dérouillaient" => "deRujE",
"dérouillais" => "deRujE",
"dérouillait" => "deRujE",
"dérouillant" => "deRuj@",
"dérouille" => "deRuj",
"dérouillé" => "deRuje",
"dérouillée" => "deRuje",
"dérouillées" => "deRuje",
"dérouillement" => "deRuj°m@",
"dérouillent" => "deRuj",
"dérouiller" => "deRuje",
"dérouillera" => "deRuj°Ra",
"dérouillerai" => "deRuj°RE",
"dérouillerais" => "deRuj°RE",
"dérouillerait" => "deRuj°RE",
"dérouilles" => "deRuj",
"dérouillez" => "deRuje",
"déroula" => "deRula",
"déroulai" => "deRulE",
"déroulaient" => "deRulE",
"déroulais" => "deRulE",
"déroulait" => "deRulE",
"déroulant" => "deRul@",
"déroulât" => "deRula",
"déroule" => "deRul",
"déroulé" => "deRule",
"déroulée" => "deRule",
"déroulées" => "deRule",
"déroulement" => "deRul°m@",
"déroulements" => "deRul°m@",
"déroulent" => "deRul",
"dérouler" => "deRule",
"déroulera" => "deRul°Ra",
"dérouleraient" => "deRul°RE",
"déroulerait" => "deRul°RE",
"déroulèrent" => "deRulER",
"dérouleront" => "deRul°R§",
"déroulés" => "deRule",
"dérouleur" => "deRul9R",
"dérouleurs" => "deRul9R",
"dérouleuse" => "deRul2z",
"déroulez" => "deRule",
"déroulions" => "deRulj§",
"dérouta" => "deRuta",
"déroutage" => "deRutaZ",
"déroutaient" => "deRutE",
"déroutait" => "deRutE",
"déroutant" => "deRut@",
"déroutante" => "deRut@t",
"déroutantes" => "deRut@t",
"déroutants" => "deRut@",
"déroute" => "deRut",
"dérouté" => "deRute",
"déroutée" => "deRute",
"déroutées" => "deRute",
"déroutement" => "deRut°m@",
"déroutent" => "deRut",
"dérouter" => "deRute",
"déroutera" => "deRut°Ra",
"déroutèrent" => "deRutER",
"déroutes" => "deRut",
"déroutés" => "deRute",
"déroutez" => "deRute",
"derrick" => "dERik",
"derricks" => "dERik",
"derrière" => "dERjER",
"derrières" => "dERjER",
"ders" => "dER",
"derviche" => "dERviS",
"derviches" => "dERviS",
"des" => "de",
"dés" => "de",
"dès" => "dE",
"désabonna" => "dezabona",
"désabonnements" => "dezabOn°m@",
"désabusé" => "dezabyze",
"désabusée" => "dezabyze",
"désabusées" => "dezabyze",
"désabusement" => "dezabyz°m@",
"désabuser" => "dezabyze",
"désabusés" => "dezabyze",
"désaccord" => "dezakOR",
"désaccorda" => "dezakORda",
"désaccordaient" => "dezakORdE",
"désaccordé" => "dezakORde",
"désaccordée" => "dezakORde",
"désaccordées" => "dezakORde",
"désaccordent" => "dezakORd",
"désaccorder" => "dezakORde",
"désaccordés" => "dezakORde",
"désaccords" => "dezakOR",
"désaccoupler" => "dezakuple",
"désaccoutuma" => "dezakutyma",
"désaccoutumer" => "dezakutyme",
"désacralisation" => "desakRalizasj§",
"désacralisé" => "desakRalize",
"désacralisée" => "desakRalize",
"désacraliser" => "desakRalize",
"désactivation" => "dezaktivasj§",
"désactive" => "dezaktiv",
"désactivé" => "dezaktive",
"désactivée" => "dezaktive",
"désactivées" => "dezaktive",
"désactiver" => "dezaktive",
"désactiverai" => "dezaktiv°RE",
"désactiveront" => "dezaktiv°R§",
"désactives" => "dezaktiv",
"désactivés" => "dezaktive",
"désactivez" => "dezaktive",
"désactivons" => "dezaktiv§",
"désadaptée" => "dezadapte",
"désadopter" => "dezadOpte",
"désaffectation" => "dezafEktasj§",
"désaffecté" => "dezafEkte",
"désaffectée" => "dezafEkte",
"désaffectées" => "dezafEkte",
"désaffecter" => "dezafEkte",
"désaffectés" => "dezafEkte",
"désaffection" => "dezafEksj§",
"désagréable" => "dezagReabl",
"désagréablement" => "dezagReabl°m@",
"désagréables" => "dezagReabl",
"désagrégation" => "dezagRegasj§",
"désagrège" => "dezagREZ",
"désagrégé" => "dezagReZe",
"désagrégeait" => "dezagReZE",
"désagrégeant" => "dezagReZ@",
"désagrégée" => "dezagReZe",
"désagrègent" => "dezagREZ",
"désagréger" => "dezagReZe",
"désagrégèrent" => "dezagReZER",
"désagrégés" => "dezagReZe",
"désagrément" => "dezagRem@",
"désagréments" => "dezagRem@",
"désaimée" => "dezEme",
"désajustés" => "dezaZyste",
"désaliénation" => "dezaljenasj§",
"désalinisation" => "dezalinizasj§",
"désaltéra" => "dezalteRa",
"désaltéraient" => "dezalteRE",
"désaltérait" => "dezalteRE",
"désaltérant" => "dezalteR@",
"désaltérante" => "dezalteR@t",
"désaltérât" => "dezalteRa",
"désaltère" => "dezaltER",
"désaltéré" => "dezalteRe",
"désaltérer" => "dezalteRe",
"désaltérés" => "dezalteRe",
"désamiantage" => "dezamj@taZ",
"désaminase" => "dezaminaz",
"désamorçage" => "dezamORsaZ",
"désamorçait" => "dezamORsE",
"désamorçant" => "dezamORs@",
"désamorce" => "dezamORs",
"désamorcé" => "dezamORse",
"désamorcée" => "dezamORse",
"désamorcées" => "dezamORse",
"désamorcent" => "dezamORs",
"désamorcer" => "dezamORse",
"désamorcera" => "dezamORs°Ra",
"désamorcerez" => "dezamORs°Re",
"désamorcerons" => "dezamORs°R§",
"désamorcés" => "dezamORse",
"désamorcez" => "dezamORse",
"désamour" => "dezamuR",
"désangler" => "des@gle",
"désape" => "desap",
"désapent" => "desap",
"désaper" => "desape",
"désapeurer" => "dezap9Re",
"désapez" => "desape",
"désappointait" => "dezapw5tE",
"désappointé" => "dezapw5te",
"désappointée" => "dezapw5te",
"désappointement" => "dezapw5t°m@",
"désappointements" => "dezapw5t°m@",
"désappointer" => "dezapw5te",
"désappointés" => "dezapw5te",
"désapprenais" => "dezapR°nE",
"désapprenant" => "dezapR°n@",
"désapprendre" => "dezapR@dR",
"désapprenne" => "dezapREn",
"désapprirent" => "dezapRiR",
"désappris" => "dezapRi",
"désapprit" => "dezapRi",
"désapprobateur" => "dezapRobat9R",
"désapprobateurs" => "dezapRobat9R",
"désapprobation" => "dezapRobasj§",
"désapprobatrice" => "dezapRobatRis",
"désapprobatrices" => "dezapRobatRis",
"désapprouva" => "dezapRuva",
"désapprouvaient" => "dezapRuvE",
"désapprouvais" => "dezapRuvE",
"désapprouvait" => "dezapRuvE",
"désapprouvant" => "dezapRuv@",
"désapprouvât" => "dezapRuva",
"désapprouve" => "dezapRuv",
"désapprouvé" => "dezapRuve",
"désapprouvée" => "dezapRuve",
"désapprouvent" => "dezapRuv",
"désapprouver" => "dezapRuve",
"désapprouvera" => "dezapRuv°Ra",
"désapprouverait" => "dezapRuv°RE",
"désapprouverez" => "dezapRuv°Re",
"désapprouves" => "dezapRuv",
"désapprouvez" => "dezapRuve",
"désapprouviez" => "dezapRuvje",
"désarçonna" => "dezaRsona",
"désarçonnaient" => "dezaRsonE",
"désarçonnait" => "dezaRsonE",
"désarçonne" => "dezaRsOn",
"désarçonné" => "dezaRsone",
"désarçonnée" => "dezaRsone",
"désarçonner" => "dezaRsone",
"désarçonnés" => "dezaRsone",
"désargenté" => "dezaRZ@te",
"désargentées" => "dezaRZ@te",
"désargentés" => "dezaRZ@te",
"désarma" => "dezaRma",
"désarmai" => "dezaRmE",
"désarmaient" => "dezaRmE",
"désarmait" => "dezaRmE",
"désarmant" => "dezaRm@",
"désarmante" => "dezaRm@t",
"désarmants" => "dezaRm@",
"désarme" => "dezaRm",
"désarmé" => "dezaRme",
"désarmée" => "dezaRme",
"désarmées" => "dezaRme",
"désarmement" => "dezaRm°m@",
"désarment" => "dezaRm",
"désarmer" => "dezaRme",
"désarmera" => "dezaRm°Ra",
"désarmèrent" => "dezaRmER",
"désarmés" => "dezaRme",
"désarmez" => "dezaRme",
"désarrimage" => "dezaRimaZ",
"désarrimé" => "dezaRime",
"désarrimez" => "dezaRime",
"désarroi" => "dezaRwa",
"désarrois" => "dezaRwa",
"désarticula" => "dezaRtikyla",
"désarticulait" => "dezaRtikylE",
"désarticulant" => "dezaRtikyl@",
"désarticulation" => "dezaRtikylasj§",
"désarticulé" => "dezaRtikyle",
"désarticulée" => "dezaRtikyle",
"désarticulées" => "dezaRtikyle",
"désarticulent" => "dezaRtikyl",
"désarticuler" => "dezaRtikyle",
"désarticulera" => "dezaRtikyl°Ra",
"désarticulés" => "dezaRtikyle",
"désassemble" => "dezas@bl",
"désassemblé" => "dezas@ble",
"désassembler" => "dezas@ble",
"désassortis" => "dezasORti",
"désastre" => "dezastR",
"désastres" => "dezastR",
"désastreuse" => "dezastR2z",
"désastreusement" => "dezastR2z°m@",
"désastreuses" => "dezastR2z",
"désastreux" => "dezastR2",
"désavantage" => "dezav@taZ",
"désavantagé" => "dezav@taZe",
"désavantageaient" => "dezav@taZE",
"désavantageait" => "dezav@taZE",
"désavantager" => "dezav@taZe",
"désavantages" => "dezav@taZ",
"désavantagés" => "dezav@taZe",
"désavantageuse" => "dezav@taZ2z",
"désaveu" => "dezav2",
"désaveux" => "dezav2",
"désavoua" => "dezavwa",
"désavouait" => "dezavwE",
"désavouant" => "dezavw@",
"désavouât" => "dezavwa",
"désavoue" => "dezavu",
"désavoué" => "dezavwe",
"désavouée" => "dezavwe",
"désavouent" => "dezavu",
"désavouer" => "dezavwe",
"désavoueraient" => "dezavuRE",
"désavouerons" => "dezavuR§",
"désavoués" => "dezavwe",
"désavouez" => "dezavue",
"désaxait" => "dezaksE",
"désaxant" => "dezaks@",
"désaxe" => "dezaks",
"désaxé" => "dezakse",
"désaxée" => "dezakse",
"désaxées" => "dezakse",
"désaxement" => "dezaks°m@",
"désaxés" => "dezakse",
"descamisados" => "dEskamizado",
"descella" => "desEla",
"descellant" => "desEl@",
"descellé" => "desEle",
"descellée" => "desEle",
"descellées" => "desEle",
"desceller" => "desEle",
"descellera" => "dEsEl°Ra",
"descellés" => "desEle",
"descellez" => "desEle",
"descend" => "des@",
"descendaient" => "des@dE",
"descendais" => "des@dE",
"descendait" => "des@dE",
"descendance" => "des@d@s",
"descendances" => "des@d@s",
"descendant" => "des@d@",
"descendante" => "des@d@t",
"descendantes" => "des@d@t",
"descendants" => "des@d@",
"descende" => "des@d",
"descendent" => "des@d",
"descendes" => "des@d",
"descendeur" => "des@d9R",
"descendeurs" => "des@d9R",
"descendez" => "des@de",
"descendiez" => "des@dje",
"descendîmes" => "des@dim",
"descendions" => "des@dj§",
"descendirent" => "des@diR",
"descendis" => "des@di",
"descendit" => "des@di",
"descendît" => "des@di",
"descendons" => "des@d§",
"descendra" => "des@dRa",
"descendrai" => "des@dRE",
"descendraient" => "des@dRE",
"descendrais" => "des@dRE",
"descendrait" => "des@dRE",
"descendras" => "des@dRa",
"descendre" => "des@dR",
"descendrez" => "des@dRe",
"descendriez" => "des@dRie",
"descendrions" => "des@dRij§",
"descendrons" => "des@dR§",
"descendront" => "des@dR§",
"descends" => "des@",
"descendu" => "des@dy",
"descendue" => "des@dy",
"descendues" => "des@dy",
"descendus" => "des@dy",
"descenseur" => "des@s9R",
"descente" => "des@t",
"descentes" => "des@t",
"déscolarisé" => "deskOlaRize",
"descriptible" => "deskRiptibl",
"descriptibles" => "deskRiptibl",
"descriptif" => "deskRiptif",
"descriptifs" => "deskRiptif",
"description" => "deskRipsj§",
"descriptions" => "deskRipsj§",
"descriptive" => "deskRiptiv",
"descriptives" => "deskRiptiv",
"desdites" => "dedit",
"desdits" => "dedi",
"déséchouée" => "dezeSwe",
"déségrégation" => "desegRegasj§",
"désembourbée" => "dez@buRbe",
"désembourber" => "dez@buRbe",
"désembrouiller" => "dez@bRuje",
"désembuer" => "dez@b8e",
"désemparait" => "dez@paRE",
"désemparé" => "dez@paRe",
"désemparée" => "dez@paRe",
"désemparées" => "dez@paRe",
"désemparer" => "dez@paRe",
"désemparés" => "dez@paRe",
"désempenné" => "dez@pEne",
"désempierraient" => "dez@pjeRE",
"désemplissaient" => "dez@plisE",
"désemplissait" => "dez@plisE",
"désemplit" => "dez@pli",
"désenchaînement" => "dez@SEn°m@",
"désenchaîner" => "dez@SEne",
"désenchanta" => "dez@S@ta",
"désenchantant" => "dez@S@t@",
"désenchante" => "dez@S@t",
"désenchanté" => "dez@S@te",
"désenchantée" => "dez@S@te",
"désenchantées" => "dez@S@te",
"désenchantement" => "dez@S@t°m@",
"désenchantements" => "dez@S@t°m@",
"désenchantent" => "dez@S@t",
"désenchanter" => "dez@S@te",
"désenchantés" => "dez@S@te",
"désenchevêtra" => "dez@S°vEtRa",
"désenclavement" => "dez@klav°m@",
"désencombre" => "dez@k§bR",
"désencrasser" => "dez@kRase",
"désenflaient" => "dez@flE",
"désenfle" => "dez@fl",
"désenflé" => "dez@fle",
"désenfler" => "dez@fle",
"désengagé" => "dez@gaZe",
"désengagement" => "dez@gaZ°m@",
"désengager" => "dez@gaZe",
"désengagez" => "dez@gaZe",
"désengluer" => "dez@glye",
"désengourdir" => "dez@guRdiR",
"désennuie" => "dez@n8i",
"désennuiera" => "dez@n8iRa",
"désennuyant" => "dez@n8ij@",
"désennuyer" => "dez@n8ije",
"désenrouler" => "dez@Rule",
"désensabler" => "dez@sable",
"désensibilisation" => "des@sibilizasj§",
"désensibilisée" => "des@sibilize",
"désensibilisent" => "des@sibiliz",
"désensorcelé" => "dez@sORs°le",
"désensorceler" => "dez@sORs°le",
"désentortille" => "dez@tORtij",
"désentravé" => "dez@tRave",
"désentravée" => "dez@tRave",
"désenvoûté" => "dez@vute",
"désenvoûter" => "dez@vute",
"désenvoûteurs" => "dez@vut9R",
"désépaissir" => "dezepesiR",
"désépaissis" => "dezepEsi",
"déséquilibra" => "dezekilibRa",
"déséquilibraient" => "dezekilibRE",
"déséquilibrais" => "dezekilibRE",
"déséquilibrait" => "dezekilibRE",
"déséquilibrant" => "dezekilibR@",
"déséquilibrât" => "dezekilibRa",
"déséquilibre" => "dezekilibR",
"déséquilibré" => "dezekilibRe",
"déséquilibrée" => "dezekilibRe",
"déséquilibrées" => "dezekilibRe",
"déséquilibrer" => "dezekilibRe",
"déséquilibres" => "dezekilibR",
"déséquilibrés" => "dezekilibRe",
"déséquilibrez" => "dezekilibRe",
"déséquipé" => "dezekipe",
"déséquipent" => "dezekip",
"déséquiper" => "dezekipe",
"déséquipés" => "dezekipe",
"désert" => "dezER",
"déserta" => "dezERta",
"désertaient" => "dezERtE",
"désertais" => "dezERtE",
"désertait" => "dezERtE",
"désertâmes" => "dezERtam",
"désertant" => "dezERt@",
"déserte" => "dezERt",
"déserté" => "dezERte",
"désertée" => "dezERte",
"désertées" => "dezERte",
"désertent" => "dezERt",
"déserter" => "dezERte",
"déserterait" => "dezERt°RE",
"désertèrent" => "dezERtER",
"désertes" => "dezERt",
"désertés" => "dezERte",
"déserteur" => "dezERt9R",
"déserteurs" => "dezERt9R",
"désertifie" => "dezERtifi",
"désertion" => "dezERsj§",
"désertions" => "dezERsj§",
"désertique" => "dezERtik",
"désertiques" => "dezERtik",
"désertons" => "dezERt§",
"déserts" => "dezER",
"désespéra" => "dezEspeRa",
"désespérai" => "dezEspeRE",
"désespéraient" => "dezEspeRE",
"désespérais" => "dezEspeRE",
"désespérait" => "dezEspeRE",
"désespérance" => "dezEspeR@s",
"désespérant" => "dezEspeR@",
"désespérante" => "dezEspeR@t",
"désespérants" => "dezEspeR@",
"désespérât" => "dezEspeRa",
"désespère" => "dezEspER",
"désespéré" => "dezEspeRe",
"désespérée" => "dezEspeRe",
"désespérées" => "dezEspeRe",
"désespérément" => "dezEspeRem@",
"désespèrent" => "dezEspER",
"désespérer" => "dezEspeRe",
"désespérèrent" => "dezEspeRER",
"désespères" => "dezEspER",
"désespérés" => "dezEspeRe",
"désespérez" => "dezEspeRe",
"désespérions" => "dezEspeRj§",
"désespérons" => "dezEspeR§",
"désespoir" => "dezEspwaR",
"désespoirs" => "dezEspwaR",
"déshabilla" => "dezabija",
"déshabillage" => "dezabijaZ",
"déshabillage-éclair" => "dezabijaZeklER",
"déshabillages" => "dezabijaZ",
"déshabillai" => "dezabijE",
"déshabillaient" => "dezabijE",
"déshabillais" => "dezabijE",
"déshabillait" => "dezabijE",
"déshabillant" => "dezabij@",
"déshabille" => "dezabij",
"déshabillé" => "dezabije",
"déshabillée" => "dezabije",
"déshabillées" => "dezabije",
"déshabillent" => "dezabij",
"déshabiller" => "dezabije",
"déshabillera" => "dezabij°Ra",
"déshabillerai" => "dezabij°RE",
"déshabillerait" => "dezabij°RE",
"déshabilleras" => "dezabij°Ra",
"déshabillèrent" => "dezabijER",
"déshabilleriez" => "dezabij°Rje",
"déshabillerons" => "dezabij°R§",
"déshabilles" => "dezabij",
"déshabillés" => "dezabije",
"déshabillez" => "dezabije",
"déshabillons" => "dezabij§",
"déshabité" => "dezabite",
"déshabitée" => "dezabite",
"déshabités" => "dezabite",
"déshabitué" => "dezabit8e",
"déshabituées" => "dezabit8e",
"déshabitués" => "dezabit8e",
"désharmonie" => "dezaRmoni",
"désherbage" => "dezERbaZ",
"désherbait" => "dezERbE",
"désherbant" => "dezERb@",
"désherbants" => "dezERb@",
"désherbe" => "dezERb",
"désherbé" => "dezERbe",
"désherbée" => "dezERbe",
"désherber" => "dezERbe",
"déshérence" => "dezeR@s",
"déshérita" => "dezeRita",
"déshéritais" => "dezeRitE",
"déshérite" => "dezeRit",
"déshérité" => "dezeRite",
"déshéritée" => "dezeRite",
"déshéritées" => "dezeRite",
"déshériter" => "dezeRite",
"déshéritera" => "dezeRit°Ra",
"déshériterai" => "dezeRit°RE",
"déshériterais" => "dezeRit°RE",
"déshériterait" => "dezeRit°RE",
"déshérités" => "dezeRite",
"désheuraient" => "dez9RE",
"déshonnête" => "dezonEt",
"déshonnêtes" => "dezonEt",
"déshonneur" => "dezon9R",
"déshonoraient" => "dezonoRE",
"déshonorait" => "dezonoRE",
"déshonorant" => "dezonoR@",
"déshonorante" => "dezonoR@t",
"déshonorantes" => "dezonoR@t",
"déshonorants" => "dezonoR@",
"déshonore" => "dezonOR",
"déshonoré" => "dezonoRe",
"déshonorée" => "dezonoRe",
"déshonorées" => "dezonoRe",
"déshonorent" => "dezonOR",
"déshonorer" => "dezonoRe",
"déshonorera" => "dezonOR°Ra",
"déshonorerai" => "dezonOR°RE",
"déshonorerais" => "dezonOR°RE",
"déshonorerait" => "dezonOR°RE",
"déshonores" => "dezonOR",
"déshonorés" => "dezonoRe",
"déshonorez" => "dezonoRe",
"déshumanisant" => "dezymaniz@",
"déshumanisante" => "dezymaniz@t",
"déshumanisation" => "dezymanizasj§",
"déshumanise" => "dezymaniz",
"déshumanisé" => "dezymanize",
"déshumanisée" => "dezymanize",
"déshumanisées" => "dezymanize",
"déshumanisent" => "dezymaniz",
"déshumaniser" => "dezymanize",
"déshumidification" => "dezymidifikasj§",
"déshydratais" => "dezidRatE",
"déshydratant" => "dezidRat@",
"déshydratation" => "dezidRatasj§",
"déshydrate" => "dezidRat",
"déshydraté" => "dezidRate",
"déshydratée" => "dezidRate",
"déshydratées" => "dezidRate",
"déshydrater" => "dezidRate",
"déshydratés" => "dezidRate",
"desiderata" => "dezideRata",
"design" => "dizajn",
"désigna" => "deziNa",
"désignai" => "deziNE",
"désignaient" => "deziNE",
"désignais" => "deziNE",
"désignait" => "deziNE",
"désignant" => "deziN@",
"désignassent" => "deziNas",
"désignât" => "deziNa",
"désignation" => "deziNasj§",
"désignations" => "deziNasj§",
"désigne" => "deziN",
"désigné" => "deziNe",
"désignée" => "deziNe",
"désignées" => "deziNe",
"désignent" => "deziN",
"designer" => "deziNe",
"désigner" => "deziNe",
"désignera" => "deziN°Ra",
"désignerai" => "deziN°RE",
"désignerait" => "deziN°RE",
"désigneras" => "deziN°Ra",
"désignèrent" => "deziNER",
"désignerez" => "deziN°Re",
"désigneriez" => "deziN°Rje",
"désignerons" => "deziN°R§",
"désigneront" => "deziN°R§",
"designers" => "dizajn9R",
"désignés" => "deziNe",
"désignez" => "deziNe",
"désignions" => "deziN§",
"designs" => "dizajn",
"désillusion" => "dezilyzj§",
"désillusionné" => "dezilyzjone",
"désillusionnement" => "dezilyzjOn°m@",
"désillusionner" => "dezilyzjOne",
"désillusions" => "dezilyzj§",
"désincarcération" => "dez5kaRseRasj§",
"désincarcéré" => "dez5kaRseRe",
"désincarnant" => "dez5kaRn@",
"désincarnation" => "dez5kaRnasj§",
"désincarne" => "dez5kaRn",
"désincarné" => "dez5kaRne",
"désincarnée" => "dez5kaRne",
"désincarnées" => "dez5kaRne",
"désincarner" => "dez5kaRne",
"désincarnés" => "dez5kaRne",
"désincrustante" => "dez5kRyst@t",
"désincruster" => "dez5kRyste",
"désindividualisation" => "dez5divid8alizasj§",
"désinence" => "dezin@s",
"désinences" => "dezin@s",
"désinfecta" => "dez5fEkta",
"désinfectant" => "dez5fEkt@",
"désinfectante" => "dez5fEkt@t",
"désinfectantes" => "dez5fEkt@t",
"désinfectants" => "dez5fEkt@",
"désinfecte" => "dez5fEkt",
"désinfecté" => "dez5fEkte",
"désinfectée" => "dez5fEkte",
"désinfectées" => "dez5fEkte",
"désinfectent" => "dez5fEkt",
"désinfecter" => "dez5fEkte",
"désinfecterai" => "dez5fEkt°RE",
"désinfectés" => "dez5fEkte",
"désinfectez" => "dez5fEkte",
"désinfection" => "dez5fEksj§",
"désinfections" => "dez5fEksj§",
"désinformation" => "dez5fORmasj§",
"désinformations" => "dez5fORmasj§",
"désinformée" => "dez5fORme",
"désinformer" => "dez5fORme",
"désinhibe" => "dezinib",
"désinsectisation" => "dez5sektizasj§",
"désinsectiser" => "dez5sEktize",
"désinstallé" => "dez5stale",
"désinstaller" => "dez5stale",
"désintégra" => "dez5tegRa",
"désintégraient" => "dez5tegRE",
"désintégrait" => "dez5tegRE",
"désintégrant" => "dez5tegR@",
"désintégrateur" => "dez5tegRat9R",
"désintégration" => "dez5tegRasj§",
"désintégrations" => "dez5tegRasj§",
"désintègre" => "dez5tEgR",
"désintégré" => "dez5tegRe",
"désintégrée" => "dez5tegRe",
"désintègrent" => "dez5tEgR",
"désintégrer" => "dez5tegRe",
"désintégrera" => "dez5tegR°Ra",
"désintégreront" => "dez5tegR°R§",
"désintégrés" => "dez5tegRe",
"désintellectualiser" => "dez5tElEktyalize",
"désintéressa" => "dez5teREsa",
"désintéressaient" => "dez5teREsE",
"désintéressait" => "dez5teREsE",
"désintéressant" => "dez5teREs@",
"désintéresse" => "dez5teREs",
"désintéressé" => "dez5teRese",
"désintéressée" => "dez5teRese",
"désintéressées" => "dez5teRese",
"désintéressement" => "dez5teREs°m@",
"désintéressent" => "dez5teREs",
"désintéresser" => "dez5teRese",
"désintéresserait" => "dez5teREs°RE",
"désintéresseront" => "dez5teREs°R§",
"désintéressés" => "dez5teRese",
"désintéressiez" => "dez5teResje",
"désintérêt" => "dez5teRE",
"désintoxication" => "dez5tOksikasj§",
"désintoxique" => "dez5tOksik",
"désintoxiqué" => "dez5tOksike",
"désintoxiquée" => "dez5tOksike",
"désintoxiquer" => "dez5tOksike",
"désintoxiquera" => "dez5tOksik°Ra",
"désintoxiqués" => "dez5tOksike",
"désintoxiquez" => "dez5tOksike",
"désinvite" => "dez5vit",
"désinviter" => "dez5vite",
"désinvolte" => "dez5vOlt",
"désinvoltes" => "dez5vOlt",
"désinvolture" => "dez5vOltyR",
"désinvoltures" => "dez5vOltyR",
"désir" => "deziR",
"désira" => "deziRa",
"désirabilité" => "deziRabilite",
"désirable" => "deziRabl",
"désirables" => "deziRabl",
"désiraient" => "deziRE",
"désirais" => "deziRE",
"désirait" => "deziRE",
"désirant" => "deziR@",
"désirante" => "deziR@t",
"désirât" => "deziRa",
"désire" => "deziR",
"désiré" => "deziRe",
"désirée" => "deziRe",
"désirées" => "deziRe",
"désirent" => "deziR",
"désirer" => "deziRe",
"désirera" => "deziR°Ra",
"désireraient" => "deziR°RE",
"désirerais" => "deziR°RE",
"désirerait" => "deziR°RE",
"désireras" => "deziR°Ra",
"désireriez" => "deziR°Rje",
"désirerions" => "deziR°Rj§",
"désireront" => "deziR°R§",
"désires" => "deziR",
"désirés" => "deziRe",
"désireuse" => "deziR2z",
"désireuses" => "deziR2z",
"désireux" => "deziR2",
"désirez" => "deziRe",
"désiriez" => "deziRje",
"désirions" => "deziRj§",
"désirons" => "deziR§",
"désirs" => "deziR",
"désiste" => "dezist",
"désisté" => "deziste",
"désistée" => "deziste",
"désistement" => "dezist°m@",
"désister" => "deziste",
"désistèrent" => "dezistER",
"désistés" => "deziste",
"désistez" => "deziste",
"desk" => "dEsk",
"déslipe" => "deslip",
"désobéi" => "dezobei",
"désobéir" => "dezobeiR",
"désobéira" => "dezobeiRa",
"désobéirai" => "dezobeiRE",
"désobéirais" => "dezobeiRE",
"désobéiront" => "dezobeiR§",
"désobéis" => "dezobei",
"désobéissais" => "dezobeisE",
"désobéissait" => "dezobeisE",
"désobéissance" => "dezobeis@s",
"désobéissances" => "dezobeis@s",
"désobéissant" => "dezobeis@",
"désobéissante" => "dezobeis@t",
"désobéissants" => "dezobeis@",
"désobéisse" => "dezobeis",
"désobéissent" => "dezobeis",
"désobéissez" => "dezobeise",
"désobéissions" => "dezobeisj§",
"désobéit" => "dezobei",
"désoblige" => "dezobliZ",
"désobligea" => "dezobliZa",
"désobligeait" => "dezobliZE",
"désobligeance" => "dezobliZ@s",
"désobligeant" => "dezobliZ@",
"désobligeante" => "dezobliZ@t",
"désobligeantes" => "dezobliZ@t",
"désobligeants" => "dezobliZ@",
"désobligent" => "dezobliZ",
"désobliger" => "dezobliZe",
"désobligerait" => "dezobliZ°RE",
"désobligés" => "dezobliZe",
"désoccupés" => "dezokype",
"désodé" => "dezode",
"désodorisant" => "dezodoRiz@",
"désodorisante" => "dezodoRiz@t",
"désodorisants" => "dezodoRiz@",
"désodoriser" => "dezodoRize",
"désodorisés" => "dezodoRize",
"désoeuvre" => "dez9vR",
"désoeuvré" => "dez9vRe",
"désoeuvrée" => "dez9vRe",
"désoeuvrées" => "dez9vRe",
"désoeuvrement" => "dez9vR°m@",
"désoeuvrements" => "dez9vR°m@",
"désoeuvrés" => "dez9vRe",
"désola" => "dezola",
"désolai" => "dezolE",
"désolaient" => "dezolE",
"désolais" => "dezolE",
"désolait" => "dezolE",
"désolant" => "dezol@",
"désolante" => "dezol@t",
"désolantes" => "dezol@t",
"désolants" => "dezol@",
"désolât" => "dezola",
"désolation" => "dezolasj§",
"désolations" => "dezolasj§",
"désole" => "dezOl",
"désolé" => "dezole",
"désolée" => "dezole",
"désolées" => "dezole",
"désolent" => "dezOl",
"désoler" => "dezole",
"désolera" => "dezOl°Ra",
"désolerait" => "dezOl°RE",
"désoleront" => "dezol°R§",
"désoles" => "dezOl",
"désolés" => "dezole",
"désolez" => "dezole",
"désolidarisa" => "desolidaRiza",
"désolidarisaient" => "desolidaRizE",
"désolidarisait" => "desolidaRizE",
"désolidarisé" => "desolidaRize",
"désolidariser" => "desolidaRize",
"désolidariserai" => "desolidaRiz°RE",
"désolidarisés" => "desolidaRize",
"désopilant" => "dezopil@",
"désopilante" => "dezopil@t",
"désopilantes" => "dezopil@t",
"désopilants" => "dezopil@",
"désorbitation" => "dezORbitasj§",
"désorbitent" => "dezORbit",
"désorbiter" => "dezORbite",
"désordonne" => "dezORdOn",
"désordonné" => "dezORdone",
"désordonnée" => "dezORdone",
"désordonnées" => "dezORdone",
"désordonnément" => "dezORdonem@",
"désordonnés" => "dezORdone",
"désordre" => "dezORdR",
"désordres" => "dezORdR",
"désorganisait" => "dezORganizE",
"désorganisateur" => "dezORganizat9R",
"désorganisation" => "dezORganizasj§",
"désorganise" => "dezORganiz",
"désorganisé" => "dezORganize",
"désorganisée" => "dezORganize",
"désorganisées" => "dezORganize",
"désorganiser" => "dezORganize",
"désorganisés" => "dezORganize",
"désorienta" => "dezoRj@ta",
"désorientaient" => "dezoRj@tE",
"désorientait" => "dezoRj@tE",
"désorientant" => "dezoRj@t@",
"désorientation" => "dezoRj@tasj§",
"désoriente" => "dezoRj@t",
"désorienté" => "dezoRj@te",
"désorientée" => "dezoRj@te",
"désorientées" => "dezoRj@te",
"désorientent" => "dezoRj@t",
"désorienter" => "dezoRj@te",
"désorienterait" => "dezoRj@t°RE",
"désorientés" => "dezoRj@te",
"désormais" => "dezORmE",
"désossage" => "dezosaZ",
"désossait" => "dezosE",
"désosse" => "dezOs",
"désossé" => "dezose",
"désossée" => "dezose",
"désossées" => "dezose",
"désossement" => "dezOs°m@",
"désosser" => "dezose",
"désossés" => "dezose",
"désosseur" => "dezos9R",
"désoxygénation" => "dezOksiZenasj§",
"désoxyribonucléique" => "dezOksiRibonykleik",
"desperado" => "despeRado",
"desperados" => "despeRado",
"déspiritualisation" => "despiRit8alizasj§",
"déspiritualiser" => "despiRit8alize",
"despote" => "despOt",
"despotes" => "despOt",
"despotique" => "despotik",
"despotiques" => "despotik",
"despotisme" => "despotizm",
"desquamante" => "deskam@t",
"desquamation" => "deskwamasj§",
"desquame" => "deskwam",
"desquelles" => "dekEl",
"desquels" => "dekEl",
"dessaisi" => "desEzi",
"dessaisir" => "deseziR",
"dessaisis" => "desEzi",
"dessaisissais" => "desEzisE",
"dessaisissement" => "desezis°m@",
"dessaisissent" => "desEzis",
"dessaisit" => "desEzi",
"dessalaient" => "desalE",
"dessalait" => "desalE",
"dessalant" => "desal@",
"dessale" => "desal",
"dessalé" => "desale",
"dessalée" => "desale",
"dessalées" => "desale",
"dessaler" => "desale",
"dessalés" => "desale",
"dessaoulais" => "desulE",
"dessaoule" => "desul",
"dessaoulé" => "desule",
"dessaoulée" => "desule",
"dessaoulent" => "desul",
"dessaouler" => "desule",
"dessaoulés" => "desule",
"dessape" => "desap",
"dessaper" => "dsape",
"dessécha" => "deseSa",
"desséchaient" => "deseSE",
"desséchais" => "deseSE",
"desséchait" => "deseSE",
"desséchant" => "deseS@",
"desséchante" => "deseS@t",
"dessèche" => "desES",
"desséché" => "deseSe",
"desséchée" => "deseSe",
"desséchées" => "deseSe",
"dessèchement" => "desES°m@",
"dessèchent" => "desES",
"dessécher" => "deseSe",
"dessécherait" => "deseS°RE",
"desséchèrent" => "deseSER",
"dessécheront" => "deseS°R§",
"desséchés" => "deseSe",
"desséchez" => "deseSe",
"dessein" => "des5",
"desseins" => "des5",
"desselle" => "desEl",
"dessellé" => "desele",
"dessellées" => "desEle",
"desseller" => "desele",
"dessellés" => "desEle",
"dessellez" => "desEle",
"desserra" => "desERa",
"desserrage" => "desERaZ",
"desserrai" => "desERE",
"desserraient" => "desERE",
"desserrais" => "desERE",
"desserrait" => "desERE",
"desserrant" => "desER@",
"desserrât" => "desERa",
"desserre" => "desER",
"desserré" => "deseRe",
"desserrée" => "deseRe",
"desserrées" => "deseRe",
"desserrent" => "desER",
"desserrer" => "deseRe",
"desserrera" => "desER°Ra",
"desserreraient" => "desER°RE",
"desserrerait" => "desER°RE",
"desserrèrent" => "desERER",
"desserrés" => "deseRe",
"desserrez" => "desERe",
"desserrons" => "desER§",
"dessers" => "desER",
"dessert" => "desER",
"desserte" => "desERt",
"dessertes" => "desERt",
"dessertie" => "desERti",
"dessertir" => "desERtiR",
"desserts" => "desER",
"desservaient" => "desERvE",
"desservait" => "desERvE",
"desservant" => "desERv@",
"desserve" => "desERv",
"desservent" => "desERv",
"desservi" => "desERvi",
"desservie" => "desERvi",
"desservies" => "desERvi",
"desservir" => "desERviR",
"desservira" => "desERviRa",
"desservirait" => "desERviRE",
"desserviront" => "desERviR§",
"desservis" => "desERvi",
"desservit" => "desERvi",
"dessiccation" => "desikasj§",
"dessille" => "desij",
"dessillé" => "desije",
"dessiller" => "desije",
"dessilleront" => "desij°R§",
"dessillés" => "desije",
"dessin" => "des5",
"dessina" => "desina",
"dessinai" => "desinE",
"dessinaient" => "desinE",
"dessinais" => "desinE",
"dessinait" => "desinE",
"dessinant" => "desin@",
"dessinât" => "desina",
"dessinateur" => "desinat9R",
"dessinateurs" => "desinat9R",
"dessinatrice" => "desinatRis",
"dessine" => "desin",
"dessiné" => "desine",
"dessinée" => "desine",
"dessinées" => "desine",
"dessinent" => "desin",
"dessiner" => "desine",
"dessinera" => "desin°Ra",
"dessinerai" => "desin°RE",
"dessineraient" => "desin°RE",
"dessinerais" => "desin°RE",
"dessinerait" => "desin°RE",
"dessinèrent" => "desinER",
"dessinerez" => "desin°Re",
"dessineront" => "desin°R§",
"dessines" => "desin",
"dessinés" => "desine",
"dessinez" => "desine",
"dessiniez" => "desinje",
"dessinions" => "desinj§",
"dessins" => "des5",
"dessoucha" => "desuSa",
"dessouchée" => "desuSe",
"dessouda" => "desuda",
"dessoudé" => "desude",
"dessoudée" => "desude",
"dessoudées" => "desude",
"dessouder" => "desude",
"dessoûla" => "desula",
"dessoulait" => "desulE",
"dessoûlait" => "desulE",
"dessoûle" => "desul",
"dessoulé" => "desule",
"dessoûlé" => "desule",
"dessoûlée" => "desule",
"dessoûlent" => "desul",
"dessouler" => "desule",
"dessoûler" => "desule",
"dessoûles" => "desul",
"dessoûlez" => "desule",
"dessous" => "d°su",
"dessous-de-bras" => "d°sud°bRa",
"dessous-de-plat" => "d°sud°pla",
"dessous-de-table" => "d°sud°tabl",
"dessous-de-verre" => "d°sud°vER",
"dessuintée" => "des85te",
"dessus" => "d°sy",
"dessus-de-lit" => "d°syd°li",
"déstabilisaient" => "destabilizE",
"déstabilisant" => "destabiliz@",
"déstabilisante" => "destabiliz@t",
"déstabilisantes" => "destabiliz@t",
"déstabilisation" => "destabilizasj§",
"déstabilisatrice" => "destabilizatRis",
"déstabilise" => "destabiliz",
"déstabilisé" => "destabilize",
"déstabilisée" => "destabilize",
"déstabilisent" => "destabiliz",
"déstabiliser" => "destabilize",
"déstabilisera" => "destabiliz°Ra",
"déstabiliserait" => "destabiliz°RE",
"déstabilisés" => "destabilize",
"déstabilisez" => "destabilize",
"déstalinisation" => "destalinizasj§",
"destin" => "dest5",
"destina" => "destina",
"destinaient" => "destinE",
"destinais" => "destinE",
"destinait" => "destinE",
"destinant" => "destin@",
"destinataire" => "destinatER",
"destinataires" => "destinatER",
"destination" => "destinasj§",
"destinations" => "destinasj§",
"destinatrice" => "destinatRis",
"destine" => "destin",
"destiné" => "destine",
"destinée" => "destine",
"destinées" => "destine",
"destinent" => "destin",
"destiner" => "destine",
"destines" => "destin",
"destinés" => "destine",
"destinez" => "destine",
"destiniez" => "destinje",
"destins" => "dest5",
"destitue" => "destity",
"destitué" => "destit8e",
"destituée" => "destit8e",
"destituer" => "destit8e",
"destitueront" => "destityR§",
"destituez" => "destitye",
"destitution" => "destitysj§",
"déstockage" => "destOkaZ",
"déstocké" => "destoke",
"destrier" => "destRije",
"destriers" => "destRije",
"destroy" => "destRwaj",
"destroyer" => "destRwaje",
"destroyers" => "destRwaje",
"destructeur" => "destRykt9R",
"destructeurs" => "destRykt9R",
"destructible" => "destRyktibl",
"destructif" => "destRyktif",
"destructifs" => "destRyktif",
"destruction" => "destRyksj§",
"destructions" => "destRyksj§",
"destructive" => "destRyktiv",
"destructrice" => "destRyktRis",
"destructrices" => "destRyktRis",
"déstructuration" => "destRyktyRasj§",
"déstructuré" => "destRyktyRe",
"déstructurer" => "destRyktyRe",
"désubjectiviser" => "desybZEktivize",
"désuet" => "dez8E",
"désuète" => "dez8Et",
"désuètes" => "dez8Et",
"désuets" => "dez8E",
"désuétude" => "des8etyd",
"désuni" => "dezyni",
"désunie" => "dezyni",
"désunies" => "dezyni",
"désunion" => "dezynj§",
"désunir" => "dezyniR",
"désunirait" => "dezyniRE",
"désunirent" => "dezyniR",
"désunis" => "dezyni",
"désunissaient" => "dezynisE",
"désunissait" => "dezynisE",
"désunissant" => "dezynis@",
"désunisse" => "dezynis",
"désunissent" => "dezynis",
"désunit" => "dezyni",
"désynchronisation" => "des5kROnizasj§",
"désynchronisé" => "des5kRonize",
"détacha" => "detaSa",
"détachable" => "detaSabl",
"détachai" => "detaSE",
"détachaient" => "detaSE",
"détachais" => "detaSE",
"détachait" => "detaSE",
"détachant" => "detaS@",
"détachants" => "detaS@",
"détachât" => "detaSa",
"détache" => "detaS",
"détaché" => "detaSe",
"détachée" => "detaSe",
"détachées" => "detaSe",
"détachement" => "detaS°m@",
"détachements" => "detaS°m@",
"détachent" => "detaS",
"détacher" => "detaSe",
"détacherai" => "detaS°RE",
"détacheraient" => "detaS°RE",
"détacherais" => "detaS°RE",
"détacherait" => "detaS°RE",
"détachèrent" => "detaSER",
"détacherons" => "detaS°R§",
"détacheront" => "detaS°R§",
"détaches" => "detaS",
"détachés" => "detaSe",
"détacheur" => "detaS9R",
"détachez" => "detaSe",
"détachions" => "detaSj§",
"détachons" => "detaS§",
"détail" => "detaj",
"détailla" => "detaja",
"détaillai" => "detajE",
"détaillaient" => "detajE",
"détaillais" => "detajE",
"détaillait" => "detajE",
"détaillant" => "detaj@",
"détaillante" => "detaj@t",
"détaillants" => "detaj@",
"détaillât" => "detaja",
"détaille" => "detaj",
"détaillé" => "detaje",
"détaillée" => "detaje",
"détaillées" => "detaje",
"détailler" => "detaje",
"détaillera" => "detaj°Ra",
"détaillerai" => "detaj°RE",
"détaillèrent" => "detajER",
"détaillés" => "detaje",
"détaillez" => "detaje",
"détaillions" => "detaj§",
"détaillons" => "detaj§",
"détails" => "detaj",
"détala" => "detala",
"détalai" => "detalE",
"détalaient" => "detalE",
"détalait" => "detalE",
"détalant" => "detal@",
"détalât" => "detala",
"détale" => "detal",
"détalé" => "detale",
"détalent" => "detal",
"détaler" => "detale",
"détaleraient" => "detal°RE",
"détalèrent" => "detalER",
"détaleront" => "detal°R§",
"détales" => "detal",
"détalions" => "detalj§",
"détalonner" => "detalOne",
"détartrage" => "detaRtRaZ",
"détartrant" => "detaRtR@",
"détartrants" => "detaRtR@",
"détaxe" => "detaks",
"détaxée" => "detakse",
"détaxées" => "detakse",
"détaxes" => "detaks",
"détecta" => "detEkta",
"détectable" => "detEktabl",
"détectables" => "detEktabl",
"détectai" => "detEktE",
"détectaient" => "detEktE",
"détectait" => "detEktE",
"détecte" => "detEkt",
"détecté" => "detEkte",
"détectée" => "detEkte",
"détectées" => "detEkte",
"détectent" => "detEkt",
"détecter" => "detEkte",
"détectera" => "detEkt°Ra",
"détecteront" => "detEkt°R§",
"détectés" => "detEkte",
"détecteur" => "detEkt9R",
"détecteurs" => "detEkt9R",
"détectez" => "detEkte",
"détection" => "detEksj§",
"détections" => "deteksj§",
"détective" => "detEktiv",
"détective-conseil" => "detEktivk§sEj",
"détectives" => "detEktiv",
"détectives-conseils" => "detEktivk§sEj",
"détectons" => "detEkt§",
"déteignaient" => "detENE",
"déteignait" => "detENE",
"déteignant" => "detEN@",
"déteigne" => "detEN",
"déteignent" => "detEN",
"déteignes" => "detEN",
"déteindra" => "det5dRa",
"déteindre" => "det5dR",
"déteint" => "det5",
"déteinte" => "det5t",
"déteintes" => "det5t",
"déteints" => "det5",
"détela" => "det°la",
"dételage" => "det°laZ",
"dételaient" => "det°lE",
"dételait" => "det°lE",
"dételé" => "det°le",
"dételée" => "det°le",
"dételées" => "det°le",
"dételer" => "det°le",
"dételés" => "det°le",
"dételez" => "det°le",
"dételle" => "detEl",
"détenaient" => "det°nE",
"détenais" => "det°nE",
"détenait" => "det°nE",
"détenant" => "det°n@",
"détend" => "det@",
"détendaient" => "det@dE",
"détendais" => "det@dE",
"détendait" => "det@dE",
"détendant" => "det@d@",
"détende" => "det@d",
"détendent" => "det@d",
"détendes" => "det@d",
"détendeur" => "det@d9R",
"détendez" => "det@de",
"détendiez" => "det@dje",
"détendions" => "det@dj§",
"détendirent" => "det@diR",
"détendis" => "det@di",
"détendit" => "det@di",
"détendît" => "det@di",
"détendons" => "det@d§",
"détendra" => "det@dRa",
"détendrai" => "det@dRE",
"détendraient" => "det@dRE",
"détendrait" => "det@dRE",
"détendre" => "det@dR",
"détendrez" => "det@dRe",
"détendrons" => "det@dR§",
"détends" => "det@",
"détendu" => "det@dy",
"détendue" => "det@dy",
"détendues" => "det@dy",
"détendus" => "det@dy",
"détenez" => "det°ne",
"déteniez" => "det°nje",
"détenions" => "det°nj§",
"détenir" => "dEt°niR",
"détenons" => "det°n§",
"détente" => "det@t",
"détentes" => "det@t",
"détenteur" => "det@t9R",
"détenteurs" => "det@t9R",
"détention" => "det@sj§",
"détentions" => "det@sj§",
"détentrice" => "det@tRis",
"détentrices" => "det@tRis",
"détenu" => "dEt°ny",
"détenue" => "dEt°ny",
"détenues" => "det°ny",
"détenus" => "det°ny",
"détergeant" => "detERZ@",
"détergent" => "detERZ@",
"détergents" => "detERZ@",
"détérioraient" => "deteRjoRE",
"détériorait" => "deteRjoRE",
"détériorant" => "deteRjoR@",
"détériorât" => "deteRjoRa",
"détérioration" => "deteRjoRasj§",
"détériorations" => "deteRjoRasj§",
"détériore" => "deteRjOR",
"détérioré" => "deteRjoRe",
"détériorée" => "deteRjoRe",
"détériorées" => "deteRjoRe",
"détériorent" => "deteRjOR",
"détériorer" => "deteRjoRe",
"détériorés" => "deteRjoRe",
"détermina" => "detERmina",
"déterminai" => "detERminE",
"déterminaient" => "detERminE",
"déterminais" => "detERminE",
"déterminait" => "detERminE",
"déterminant" => "detERmin@",
"déterminante" => "detERmin@t",
"déterminantes" => "detERmin@t",
"déterminants" => "detERmin@",
"détermination" => "detERminasj§",
"déterminations" => "detERminasj§",
"détermine" => "detERmin",
"déterminé" => "detERmine",
"déterminée" => "detERmine",
"déterminées" => "detERmine",
"déterminément" => "detERminem@",
"déterminent" => "detERmin",
"déterminer" => "detERmine",
"déterminera" => "detERmin°Ra",
"détermineraient" => "detERmin°RE",
"déterminerait" => "detERmin°RE",
"déterminèrent" => "detERminER",
"déterminerons" => "detERmin°R§",
"détermineront" => "detERmin°R§",
"déterminés" => "detERmine",
"déterminez" => "detERmine",
"déterminiez" => "detERminje",
"déterminions" => "detERminj§",
"déterminisme" => "detERminizm",
"déterministe" => "detERminist",
"déterministes" => "detERminist",
"déterminons" => "detERmin§",
"déterra" => "detERa",
"déterrage" => "detERaZ",
"déterraient" => "detERE",
"déterrais" => "detERE",
"déterrait" => "detERE",
"déterrant" => "detER@",
"déterre" => "detER",
"déterré" => "deteRe",
"déterrée" => "deteRe",
"déterrées" => "deteRe",
"déterrent" => "detER",
"déterrer" => "deteRe",
"déterrera" => "detER°Ra",
"déterrerai" => "detER°RE",
"déterrerait" => "detER°RE",
"déterrerez" => "detER°Re",
"déterreront" => "detER°R§",
"déterrés" => "deteRe",
"déterreur" => "detER9R",
"déterreurs" => "detER9R",
"déterreuse" => "detER2z",
"déterrez" => "detERe",
"déterrions" => "detERj§",
"déterrons" => "detER§",
"détersifs" => "detERsif",
"détersive" => "detERsiv",
"détesta" => "detEsta",
"détestable" => "detEstabl",
"détestablement" => "detEstabl°m@",
"détestables" => "detEstabl",
"détestai" => "detEstE",
"détestaient" => "detEstE",
"détestais" => "detEstE",
"détestait" => "detEstE",
"détestant" => "detEst@",
"détestât" => "detEsta",
"détestation" => "detEstasj§",
"détestations" => "detEstasj§",
"déteste" => "detEst",
"détesté" => "detEste",
"détestée" => "detEste",
"détestent" => "detEst",
"détester" => "detEste",
"détestera" => "detEst°Ra",
"détesterai" => "detEst°RE",
"détesteraient" => "detEst°RE",
"détesterais" => "detEst°RE",
"détesterait" => "detEst°RE",
"détesteras" => "detEst°Ra",
"détesteriez" => "detEst°Rje",
"détesteront" => "detEst°R§",
"détestes" => "detEst",
"détestés" => "detEste",
"détestez" => "detEste",
"détestiez" => "detEstje",
"détestions" => "detEstj§",
"détestons" => "detEst§",
"détiendra" => "detj5dRa",
"détiendrai" => "detj5dRE",
"détiendraient" => "detj5dRE",
"détiendrait" => "detj5dRE",
"détiendras" => "detj5dRa",
"détiendrez" => "detj5dRe",
"détiendront" => "detj5dR§",
"détienne" => "detjEn",
"détiennent" => "detjEn",
"détiens" => "detj5",
"détient" => "detj5",
"détimbrée" => "det5bRe",
"détint" => "det5",
"détînt" => "det5",
"détisse" => "detis",
"détonait" => "detonE",
"détonant" => "deton@",
"détonante" => "deton@t",
"détonants" => "deton@",
"détonateur" => "detonat9R",
"détonateurs" => "detonat9R",
"détonation" => "detonasj§",
"détonations" => "detonasj§",
"détonée" => "detone",
"détoner" => "detone",
"détonera" => "detOn°Ra",
"détonna" => "detona",
"détonnaient" => "detonE",
"détonnait" => "detonE",
"détonnant" => "deton@",
"détonne" => "detOn",
"détonnent" => "detOn",
"détonner" => "detone",
"détord" => "detOR",
"détordit" => "detORdi",
"détortillai" => "detORtijE",
"détortille" => "detORtij",
"détour" => "detuR",
"détourage" => "detuRaZ",
"détourna" => "detuRna",
"détournai" => "detuRnE",
"détournaient" => "detuRnE",
"détournais" => "detuRnE",
"détournait" => "detuRnE",
"détournant" => "detuRn@",
"détournât" => "detuRna",
"détourne" => "detuRn",
"détourné" => "detuRne",
"détournée" => "detuRne",
"détournées" => "detuRne",
"détournement" => "detuRn°m@",
"détournements" => "detuRn°m@",
"détournent" => "detuRn",
"détourner" => "detuRne",
"détournera" => "detuRn°Ra",
"détournerai" => "detuRn°RE",
"détourneraient" => "detuRn°RE",
"détournerais" => "detuRn°RE",
"détournerait" => "detuRn°RE",
"détournèrent" => "detuRnER",
"détourneront" => "detuRn°R§",
"détournes" => "detuRn",
"détournés" => "detuRne",
"détourneur" => "detuRn9R",
"détournez" => "detuRne",
"détourniez" => "detuRnje",
"détournions" => "detuRnj§",
"détournons" => "detuRn§",
"détours" => "detuR",
"détracteur" => "detRakt9R",
"détracteurs" => "detRakt9R",
"détraquaient" => "detRakE",
"détraquais" => "detRakE",
"détraquant" => "detRak@",
"détraque" => "detRak",
"détraqué" => "detRake",
"détraquée" => "detRake",
"détraquées" => "detRake",
"détraquement" => "detRak°m@",
"détraquent" => "detRak",
"détraquer" => "detRake",
"détraquera" => "detRak°Ra",
"détraquerais" => "detRak°RE",
"détraqués" => "detRake",
"détrempaient" => "detR@pE",
"détrempait" => "detR@pE",
"détrempant" => "detR@p@",
"détrempe" => "detR@p",
"détrempé" => "detR@pe",
"détrempée" => "detR@pe",
"détrempées" => "detR@pe",
"détremper" => "detR@pe",
"détrempés" => "detR@pe",
"détresse" => "detREs",
"détresses" => "detREs",
"détribalisée" => "detRibalize",
"détricote" => "detRikOt",
"détricoter" => "detRikote",
"détriment" => "detRim@",
"détriments" => "detRim@",
"détritiques" => "detRitik",
"détritus" => "detRitys",
"détroit" => "detRwa",
"détroits" => "detRwa",
"détrompa" => "detR§pa",
"détrompai" => "detR§pE",
"détrompais" => "detR§pE",
"détrompait" => "detR§pE",
"détrompe" => "detR§p",
"détrompé" => "detR§pe",
"détrompée" => "detR§pe",
"détromper" => "detR§pe",
"détromperai" => "detR§p°RE",
"détrompés" => "detR§pe",
"détrompez" => "detR§pe",
"détrônaient" => "detRonE",
"détrônât" => "detRona",
"détroncha" => "detR§Sa",
"détronchant" => "detR§S@",
"détronche" => "detR§S",
"détronché" => "detR§Se",
"détronchent" => "detR§S",
"détroncher" => "detR§Se",
"détroncherais" => "detR§S°RE",
"détronchèrent" => "detR§SER",
"détrône" => "detRon",
"détrôné" => "detRone",
"détrônée" => "detRone",
"détrônement" => "detRon°m@",
"détrôner" => "detRone",
"détroussaient" => "detRusE",
"détroussais" => "detRusE",
"détroussant" => "detRus@",
"détroussé" => "detRuse",
"détroussent" => "detRus",
"détrousser" => "detRuse",
"détrousses" => "detRus",
"détroussés" => "detRuse",
"détrousseur" => "detRus9R",
"détrousseurs" => "detRus9R",
"détroussez" => "detRuse",
"détruira" => "detR8iRa",
"détruirai" => "detR8iRE",
"détruiraient" => "detR8iRE",
"détruirais" => "detR8iRE",
"détruirait" => "detR8iRE",
"détruiras" => "detR8iRa",
"détruire" => "detR8iR",
"détruirez" => "detR8iRe",
"détruiriez" => "detR8iRje",
"détruirions" => "detR8iRj§",
"détruirons" => "detR8iR§",
"détruiront" => "detR8iR§",
"détruis" => "detR8i",
"détruisaient" => "detR8izE",
"détruisais" => "detR8izE",
"détruisait" => "detR8izE",
"détruisant" => "detR8iz@",
"détruise" => "detR8iz",
"détruisent" => "detR8iz",
"détruises" => "detR8iz",
"détruisez" => "detR8ize",
"détruisiez" => "detR8izje",
"détruisions" => "detR8izj§",
"détruisirent" => "detR8iziR",
"détruisis" => "detR8izi",
"détruisit" => "detR8izi",
"détruisons" => "detR8iz§",
"détruit" => "detR8i",
"détruite" => "detR8it",
"détruites" => "detR8it",
"détruits" => "detR8i",
"dette" => "dEt",
"dettes" => "dEt",
"deuche" => "d2S",
"deuil" => "d9j",
"deuils" => "d9j",
"deus ex machina" => "deuseksmakina",
"deusio" => "d2zjo",
"deutérium" => "d2teRjOm",
"deutéronome" => "d2teRonom",
"deutsche mark" => "dOjtSmaRk",
"deux" => "d2",
"deux-chevaux" => "d2S°vo",
"deux-deux" => "d2d2",
"deux-mâts" => "d2ma",
"deux-pièces" => "d2pjEs",
"deux-points" => "d2pw5",
"deux-ponts" => "d2p§",
"deux-quatre" => "d2katR",
"deux-roues" => "d2Ru",
"deuxième" => "d2zjEm",
"deuxièmement" => "d2zjEm°m@",
"deuxièmes" => "d2zjEm",
"deuzio" => "d2zjo",
"devaient" => "d°vE",
"devais" => "d°vE",
"devait" => "d°vE",
"dévala" => "devala",
"dévalai" => "devalE",
"dévalaient" => "devalE",
"dévalais" => "devalE",
"dévalait" => "devalE",
"dévalant" => "deval@",
"dévale" => "deval",
"dévalé" => "devale",
"dévalée" => "devale",
"dévalement" => "deval°m@",
"dévalent" => "deval",
"dévaler" => "devale",
"dévalèrent" => "devalER",
"dévales" => "deval",
"dévalions" => "devalj§",
"dévalisai" => "devalizE",
"dévalisaient" => "devalizE",
"dévalisait" => "devalizE",
"dévalisant" => "devaliz@",
"dévalise" => "devaliz",
"dévalisé" => "devalize",
"dévalisée" => "devalize",
"dévalisent" => "devaliz",
"dévaliser" => "devalize",
"dévalisera" => "devaliz°Ra",
"dévaliserait" => "devaliz°RE",
"dévalises" => "devaliz",
"dévalisés" => "devalize",
"dévalisez" => "devalize",
"dévalons" => "deval§",
"dévalorisaient" => "devaloRizE",
"dévalorisait" => "devaloRizE",
"dévalorisant" => "devalORiz@",
"dévalorisation" => "devaloRizasj§",
"dévalorise" => "devaloRiz",
"dévalorisé" => "devaloRize",
"dévalorisée" => "devaloRize",
"dévalorisent" => "devaloRiz",
"dévaloriser" => "devaloRize",
"dévalorisez" => "devaloRize",
"dévaluait" => "deval8E",
"dévaluation" => "deval8asj§",
"dévaluations" => "deval8asj§",
"dévalue" => "devaly",
"dévalué" => "deval8e",
"dévaluée" => "deval8e",
"dévaluer" => "deval8e",
"dévaluera" => "devalyRa",
"dévalués" => "deval8e",
"devança" => "d°v@sa",
"devançaient" => "d°v@sE",
"devançais" => "d°v@sE",
"devançait" => "d°v@sE",
"devançant" => "d°v@s@",
"devance" => "d°v@s",
"devancé" => "d°v@se",
"devancée" => "d°v@se",
"devancent" => "d°v@s",
"devancer" => "d°v@se",
"devancerait" => "d°v@s°RE",
"devancèrent" => "d°v@sER",
"devancerez" => "d°v@s°Re",
"devancés" => "d°v@se",
"devancez" => "d°v@se",
"devanciers" => "d°v@sje",
"devançons" => "d°v@s§",
"devant" => "d°v@",
"devants" => "d°v@",
"devanture" => "d°v@tyR",
"devantures" => "d°v@tyR",
"dévasta" => "devasta",
"dévastaient" => "devastE",
"dévastait" => "devastE",
"dévastant" => "devast@",
"dévastateur" => "devastat9R",
"dévastateurs" => "devastat9R",
"dévastation" => "devastasj§",
"dévastations" => "devastasj§",
"dévastatrice" => "devastatRis",
"dévastatrices" => "devastatRis",
"dévaste" => "devast",
"dévasté" => "devaste",
"dévastée" => "devaste",
"dévastées" => "devaste",
"dévastent" => "devast",
"dévaster" => "devaste",
"dévastera" => "devast°Ra",
"dévasterait" => "devast°RE",
"dévastèrent" => "devastER",
"dévasteront" => "devast°R§",
"dévastés" => "devaste",
"déveinards" => "devEnaR",
"déveine" => "devEn",
"déveines" => "devEn",
"développa" => "dev°lopa",
"développai" => "dev°lopE",
"développaient" => "dev°lopE",
"développais" => "dev°lopE",
"développait" => "dev°lopE",
"développant" => "dev°lop@",
"développât" => "dev°lopa",
"développe" => "dev°lOp",
"développé" => "dev°lope",
"développée" => "dev°lope",
"développées" => "dev°lope",
"développement" => "dev°lOp°m@",
"développements" => "dev°lOp°m@",
"développent" => "dev°lOp",
"développer" => "dev°lope",
"développera" => "dev°lOp°Ra",
"développerai" => "dev°lOp°RE",
"développeraient" => "dev°lOp°RE",
"développerais" => "dev°lOp°RE",
"développerait" => "dev°lOp°RE",
"développèrent" => "dev°lOpER",
"développerez" => "dev°lOp°Re",
"développeront" => "dev°lOp°R§",
"développés" => "dev°lope",
"développeur" => "dev°lop9R",
"développez" => "dev°lope",
"développons" => "dev°lop§",
"devenaient" => "d°v°nE",
"devenais" => "d°v°nE",
"devenait" => "d°v°nE",
"devenant" => "d°v°n@",
"devenez" => "d°v°ne",
"deveniez" => "d°v°nje",
"devenions" => "d°v°nj§",
"devenir" => "d°v°niR",
"devenons" => "d°v°n§",
"déventer" => "dev@te",
"devenu" => "d°v°ny",
"devenue" => "d°v°ny",
"devenues" => "d°v°ny",
"devenus" => "d°v°ny",
"dévergondage" => "devERg§daZ",
"dévergondages" => "devERg§daZ",
"dévergonde" => "devERg§d",
"dévergondé" => "devERg§de",
"dévergondée" => "devERg§de",
"dévergondées" => "devERg§de",
"dévergondent" => "devERg§d",
"dévergonder" => "devERg§de",
"dévergondés" => "devERg§de",
"dévernie" => "devERni",
"dévernies" => "devERni",
"dévernir" => "devERniR",
"déverrouilla" => "devERuja",
"déverrouillage" => "devERujaZ",
"déverrouillait" => "devERujE",
"déverrouille" => "devERuj",
"déverrouillé" => "devERuje",
"déverrouillée" => "devERuje",
"déverrouillées" => "devERuje",
"déverrouillent" => "devERuj",
"déverrouiller" => "devERuje",
"déverrouillez" => "devERuje",
"devers" => "d°vER",
"déversa" => "devERsa",
"déversaient" => "devERsE",
"déversais" => "devERsE",
"déversait" => "devERsE",
"déversant" => "devERs@",
"déverse" => "devERs",
"déversé" => "devERse",
"déversée" => "devERse",
"déversées" => "devERse",
"déversement" => "devERs°m@",
"déversements" => "devERs°m@",
"déversent" => "devERs",
"déverser" => "devERse",
"déversera" => "devERs°Ra",
"déverserai" => "devERs°RE",
"déverseraient" => "devERs°RE",
"déverserait" => "devERs°RE",
"déversèrent" => "devERsER",
"déversés" => "devERse",
"déversez" => "devERse",
"déversoir" => "devERswaR",
"dévêt" => "devE",
"dévêtaient" => "devEtE",
"dévêtait" => "devEtE",
"dévêtant" => "devEt@",
"dévêtez" => "devEte",
"dévêtir" => "devetiR",
"dévêtit" => "devEti",
"dévêtu" => "devEty",
"dévêtue" => "devEty",
"dévêtues" => "devEty",
"dévêtus" => "devEty",
"devez" => "d°ve",
"dévia" => "devja",
"déviai" => "devjE",
"déviaient" => "devjE",
"déviait" => "devjE",
"déviance" => "devj@s",
"déviances" => "devj@s",
"déviant" => "devj@",
"déviante" => "devj@t",
"déviants" => "devj@",
"déviateur" => "devjat9R",
"déviation" => "devjasj§",
"déviationnisme" => "devjasjonizm",
"déviationniste" => "devjasjonist",
"déviations" => "devjasj§",
"dévida" => "devida",
"dévidais" => "devidE",
"dévidait" => "devidE",
"dévidant" => "devid@",
"dévide" => "devid",
"dévidé" => "devide",
"dévidée" => "devide",
"dévident" => "devid",
"dévider" => "devide",
"déviderait" => "devid°RE",
"dévideur" => "devid9R",
"dévidions" => "devidj§",
"dévidoir" => "devidwaR",
"dévidoirs" => "devidwaR",
"dévie" => "devi",
"dévié" => "devje",
"déviée" => "devje",
"deviendra" => "d°vj5dRa",
"deviendrai" => "d°vj5dRE",
"deviendraient" => "d°vj5dRE",
"deviendrais" => "d°vj5dRE",
"deviendrait" => "d°vj5dRE",
"deviendras" => "d°vj5dRa",
"deviendrez" => "d°vj5dRe",
"deviendriez" => "d°vj5dRije",
"deviendrions" => "d°vj5dRij§",
"deviendrons" => "d°vj5dR§",
"deviendront" => "d°vj5dR§",
"devienne" => "d°vjEn",
"deviennent" => "d°vjEn",
"deviennes" => "d°vjEn",
"deviens" => "d°vj5",
"devient" => "d°vj5",
"dévient" => "devi",
"dévier" => "devje",
"déviera" => "deviRa",
"dévierait" => "devijRE",
"déviés" => "devje",
"deviez" => "d°vje",
"déviez" => "devje",
"devin" => "d°v5",
"devina" => "d°vina",
"devinai" => "d°vinE",
"devinaient" => "d°vinE",
"devinais" => "d°vinE",
"devinait" => "d°vinE",
"devinâmes" => "d°vinam",
"devinant" => "d°vin@",
"devinât" => "d°vina",
"devine" => "d°vin",
"deviné" => "d°vine",
"devinée" => "d°vine",
"devinées" => "d°vine",
"devinent" => "d°vin",
"deviner" => "d°vine",
"devinera" => "d°vin°Ra",
"devinerai" => "d°vin°RE",
"devineraient" => "d°vin°RE",
"devinerais" => "d°vin°RE",
"devinerait" => "d°vin°RE",
"devineras" => "d°vin°Ra",
"devinèrent" => "d°vinER",
"devineresse" => "d°vin°REs",
"devineresses" => "d°vin°REs",
"devinerez" => "d°vin°Re",
"devineriez" => "d°vin°Rje",
"devineront" => "d°vin°R§",
"devines" => "d°vin",
"devinés" => "d°vine",
"devinette" => "d°vinEt",
"devinettes" => "d°vinEt",
"devineur" => "d2vin9R",
"devinez" => "d°vine",
"devinions" => "d°vinj§",
"devînmes" => "d°v5m",
"devinons" => "d°vin§",
"devinrent" => "d°v5R",
"devins" => "d°v5",
"devinsse" => "d°v5s",
"devinssent" => "d°v5s",
"devinssiez" => "d°v5sje",
"devint" => "d°v5",
"devînt" => "d°v5",
"devions" => "d°vj§",
"dévions" => "devj§",
"dévirginisée" => "deviRZinize",
"dévirginiser" => "deviRZinize",
"dévirilisant" => "deviRiliz@",
"dévirilisation" => "deviRilizasj§",
"dévirilisé" => "deviRilize",
"devis" => "d°vi",
"dévisage" => "devizaZ",
"dévisagé" => "devizaZe",
"dévisagea" => "devizaZa",
"dévisageai" => "devizaZE",
"dévisageaient" => "devizaZE",
"dévisageais" => "devizaZE",
"dévisageait" => "devizaZE",
"dévisageâmes" => "devizaZam",
"dévisageant" => "devizaZ@",
"dévisagée" => "devizaZe",
"dévisagent" => "devizaZ",
"dévisageons" => "devizaZ§",
"dévisager" => "devizaZe",
"dévisageraient" => "devizaZ°RE",
"dévisagèrent" => "devizaZER",
"dévisagés" => "devizaZe",
"dévisagez" => "devizaZe",
"dévisagions" => "devizaZj§",
"devisaient" => "d°vizE",
"devisais" => "d°vizE",
"devisait" => "d°vizE",
"devisant" => "d°viz@",
"devise" => "d°viz",
"devisé" => "d°vize",
"devisent" => "d°viz",
"deviser" => "d°vize",
"devisèrent" => "d°vizER",
"devises" => "d°viz",
"devisions" => "d°vizj§",
"dévissa" => "devisa",
"dévissable" => "devisabl",
"dévissage" => "devisaZ",
"dévissaient" => "devisE",
"dévissait" => "devisE",
"dévissant" => "devis@",
"dévisse" => "devis",
"dévissé" => "devise",
"dévissée" => "devise",
"dévissées" => "devise",
"dévisser" => "devise",
"dévissera" => "devis°Ra",
"dévissés" => "devise",
"dévissez" => "devise",
"dévitalisation" => "devitalizasj§",
"dévitalisé" => "devitalize",
"dévitaliser" => "devitalize",
"dévoie" => "devwa",
"dévoiement" => "devwam@",
"dévoila" => "devwala",
"dévoilai" => "devwalE",
"dévoilaient" => "devwalE",
"dévoilais" => "devwalE",
"dévoilait" => "devwalE",
"dévoilant" => "devwal@",
"dévoile" => "devwal",
"dévoilé" => "devwale",
"dévoilée" => "devwale",
"dévoilées" => "devwale",
"dévoilement" => "devwal°m@",
"dévoilements" => "devwal°m@",
"dévoilent" => "devwal",
"dévoiler" => "devwale",
"dévoilera" => "devwal°Ra",
"dévoilerai" => "devwal°RE",
"dévoilerais" => "devwal°RE",
"dévoilerait" => "devwal°RE",
"dévoilerez" => "devwal°Re",
"dévoileront" => "devwal°R§",
"dévoiles" => "devwal",
"dévoilés" => "devwale",
"dévoilez" => "devwale",
"dévoilons" => "devwal§",
"devoir" => "d°vwaR",
"devoirs" => "d°vwaR",
"dévolu" => "devoly",
"dévolue" => "devoly",
"dévolues" => "devoly",
"dévolus" => "devoly",
"dévolution" => "devolysj§",
"devon" => "dev§",
"dévonien" => "devonj5",
"dévonienne" => "devonjEn",
"devons" => "d°v§",
"dévora" => "devoRa",
"dévorai" => "devoRE",
"dévoraient" => "devoRE",
"dévorais" => "devoRE",
"dévorait" => "devoRE",
"dévorant" => "devoR@",
"dévorante" => "devoR@t",
"dévorantes" => "devoR@t",
"dévorants" => "devoR@",
"dévorateur" => "devoRat9R",
"dévorateurs" => "devoRat9R",
"dévoration" => "devoRasj§",
"dévoratrice" => "devoRatRis",
"dévore" => "devOR",
"dévoré" => "devoRe",
"dévorée" => "devoRe",
"dévorées" => "devoRe",
"dévorent" => "devOR",
"dévorer" => "devoRe",
"dévorera" => "devOR°Ra",
"dévorerai" => "devOR°RE",
"dévoreraient" => "devOR°RE",
"dévorerais" => "devOR°RE",
"dévorerait" => "devOR°RE",
"dévorèrent" => "devORER",
"dévorerez" => "devOR°Re",
"dévoreront" => "devOR°R§",
"dévores" => "devOR",
"dévorés" => "devoRe",
"dévoreur" => "devoR9R",
"dévoreurs" => "devoR9R",
"dévoreuse" => "devoR2z",
"dévoreuses" => "devoR2z",
"dévorez" => "devoRe",
"dévorions" => "devoRj§",
"dévorons" => "devoR§",
"dévot" => "devo",
"dévote" => "devOt",
"dévotement" => "devOt°m@",
"dévotes" => "devOt",
"dévotieusement" => "devosj2z°m@",
"dévotion" => "devosj§",
"dévotionnelle" => "devosjonEl",
"dévotions" => "devosj§",
"dévots" => "devo",
"dévoua" => "devwa",
"dévouaient" => "devwE",
"dévouait" => "devwE",
"dévouant" => "devw@",
"dévouât" => "devwa",
"dévoue" => "devu",
"dévoué" => "devwe",
"dévouée" => "devwe",
"dévouées" => "devwe",
"dévouement" => "devum@",
"dévouements" => "devum@",
"dévouent" => "devu",
"dévouer" => "devwe",
"dévouera" => "devuRa",
"dévouerais" => "devuRE",
"dévoues" => "devu",
"dévoués" => "devwe",
"dévouez" => "devue",
"dévoyait" => "devwajE",
"dévoyé" => "devwaje",
"dévoyée" => "devwaje",
"dévoyées" => "devwaje",
"dévoyer" => "devwaje",
"dévoyés" => "devwaje",
"dévoyez" => "devwaje",
"devra" => "d°vRa",
"devrai" => "d°vRE",
"devraient" => "d°vRE",
"devrais" => "d°vRE",
"devrait" => "d°vRE",
"devras" => "d°vRa",
"devrez" => "d°vRe",
"devriez" => "d°vRje",
"devrions" => "d°vRij§",
"devrons" => "d°vR§",
"devront" => "d°vR§",
"dexaméthasone" => "dEgzametazOn",
"dextérité" => "dEksteRite",
"dextre" => "dEkstR",
"dextrement" => "dEkstR°m@",
"dextrose" => "dEkstRoz",
"dey" => "dE",
"dézingue" => "dez5g",
"dézinguer" => "dez5ge",
"dézingués" => "dez5ge",
"dharma" => "daRma",
"dhole" => "dol2",
"dia" => "dja",
"diabète" => "djabEt",
"diabètes" => "djabEt",
"diabétique" => "djabetik",
"diabétiques" => "djabetik",
"diable" => "djabl",
"diablement" => "djabl°m@",
"diablerie" => "djabl°Ri",
"diableries" => "djabl°Ri",
"diables" => "djabl",
"diablesse" => "djablEs",
"diablesses" => "djablEs",
"diablotin" => "djablot5",
"diablotins" => "djablot5",
"diabolique" => "djabolik",
"diaboliquement" => "djabolik°m@",
"diaboliques" => "djabolik",
"diabolisé" => "djabolize",
"diabolisée" => "djabolize",
"diabolisent" => "djaboliz",
"diaboliser" => "djabolize",
"diabolisme" => "djabOlism",
"diabolo" => "djabolo",
"diabolos" => "djabolo",
"diacétylmorphine" => "diasetilmORfin",
"diachronique" => "djakRonik",
"diaclase" => "djaklaz",
"diaconesse" => "djakonEs",
"diaconesses" => "djakonEs",
"diaconie" => "djakoni",
"diacre" => "djakR",
"diacres" => "djakR",
"diacritique" => "djakRitik",
"diadème" => "djadEm",
"diadèmes" => "djadEm",
"diagnose" => "djagnoz",
"diagnostic" => "djagnostik",
"diagnostics" => "djagnostik",
"diagnostiqua" => "djagnostika",
"diagnostiquait" => "djagnostikE",
"diagnostiquant" => "djagnostik@",
"diagnostique" => "djagnostik",
"diagnostiqué" => "djagnostike",
"diagnostiquer" => "djagnostike",
"diagnostiquèrent" => "djagnostikER",
"diagnostiques" => "djagnostik",
"diagnostiqués" => "djagnostike",
"diagnostiqueur" => "djagnOstik9R",
"diagnostiquez" => "djagnostike",
"diagonal" => "djagonal",
"diagonale" => "djagonal",
"diagonalement" => "djagonal°m@",
"diagonales" => "djagonal",
"diagonaux" => "djagono",
"diagramme" => "djagRam",
"diagrammes" => "djagRam",
"dialectal" => "djalEktal",
"dialectale" => "djalEktal",
"dialecte" => "djalEkt",
"dialectes" => "djalEkt",
"dialecticien" => "djalEktisj5",
"dialecticienne" => "djalEktisjEn",
"dialecticiens" => "djalEktisj5",
"dialectique" => "djalEktik",
"dialectiques" => "djalEktik",
"dialogique" => "djaloZik",
"dialoguai" => "djalogE",
"dialoguaient" => "djalogE",
"dialoguait" => "djalogE",
"dialoguant" => "djalog@",
"dialoguât" => "djaloga",
"dialogue" => "djalOg",
"dialogué" => "djaloge",
"dialoguée" => "djaloge",
"dialoguées" => "djaloge",
"dialoguent" => "djalOg",
"dialoguer" => "djaloge",
"dialoguera" => "djalOg°Ra",
"dialogues" => "djalOg",
"dialoguez" => "djaloge",
"dialoguiste" => "djalogist",
"dialoguistes" => "djalogist",
"dialoguons" => "djalog§",
"dialyse" => "djaliz",
"dialysé" => "djalize",
"dialysée" => "djalize",
"dialyser" => "djalize",
"dialyses" => "djaliz",
"diam" => "djam",
"diamant" => "djam@",
"diamantaire" => "djam@tER",
"diamantaires" => "djam@tER",
"diamante" => "djam@t",
"diamanté" => "djam@te",
"diamantée" => "djam@te",
"diamantés" => "djam@te",
"diamantifère" => "djam@tifER",
"diamantin" => "djam@t5",
"diamantine" => "djam@tin",
"diamantines" => "djam@tin",
"diamantins" => "djam@t5",
"diamants" => "djam@",
"diamétralement" => "djametRal°m@",
"diamètre" => "djamEtR",
"diamine" => "djamin",
"diamorphine" => "djamORfin",
"diams" => "djam",
"diane" => "djan",
"dianes" => "djan",
"diantre" => "dj@tR",
"diapason" => "djapaz§",
"diapasons" => "djapaz§",
"diaphane" => "djafan",
"diaphanes" => "djafan",
"diaphorétique" => "djafORetik",
"diaphragma" => "djafRagma",
"diaphragmatique" => "djafRagmatik",
"diaphragme" => "djafRagm",
"diaphragmes" => "djafRagm",
"diapo" => "djapo",
"diaporama" => "djapORama",
"diaporamas" => "djapoRama",
"diapos" => "djapo",
"diapositifs" => "djapozitif",
"diapositive" => "djapozitiv",
"diapositives" => "djapozitiv",
"diapré" => "djapRe",
"diaprée" => "djapRe",
"diaprées" => "djapRe",
"diaprés" => "djapRe",
"diaprures" => "djapRyR",
"diarrhée" => "djaRe",
"diarrhées" => "djaRe",
"diarrhéique" => "djaReik",
"diaspora" => "djaspoRa",
"diasporas" => "djaspoRa",
"diastole" => "djastOl",
"diastoles" => "djastOl",
"diastolique" => "djastolik",
"diastoliques" => "djastolik",
"diatomée" => "djatOme",
"diatomées" => "djatome",
"diatonique" => "djatonik",
"diatribe" => "djatRib",
"diatribes" => "djatRib",
"dicastères" => "dikastER",
"dichotomie" => "dikotomi",
"dichroïque" => "dikROik",
"dichroïsme" => "dikRoizm",
"dicible" => "disibl",
"dico" => "diko",
"dicos" => "diko",
"dicta" => "dikta",
"dictai" => "diktE",
"dictaient" => "diktE",
"dictais" => "diktE",
"dictait" => "diktE",
"dictames" => "diktam",
"dictant" => "dikt@",
"dictaphone" => "diktafOn",
"dictaphones" => "diktafOn",
"dictât" => "dikta",
"dictateur" => "diktat9R",
"dictateurs" => "diktat9R",
"dictatorial" => "diktatoRjal",
"dictatoriale" => "diktatoRjal",
"dictatoriales" => "diktatoRjal",
"dictatoriaux" => "diktatORjo",
"dictatrice" => "diktatRis",
"dictats" => "dikta",
"dictature" => "diktatyR",
"dictatures" => "diktatyR",
"dicte" => "dikt",
"dicté" => "dikte",
"dictée" => "dikte",
"dictées" => "dikte",
"dictent" => "dikt",
"dicter" => "dikte",
"dictera" => "dikt°Ra",
"dicterai" => "dikt°RE",
"dictèrent" => "diktER",
"dicterez" => "dikt°Re",
"dictes" => "dikt",
"dictés" => "dikte",
"dictez" => "dikte",
"dictiez" => "diktje",
"diction" => "diksj§",
"dictionnaire" => "diksjonER",
"dictionnaires" => "diksjonER",
"dicton" => "dikt§",
"dictons" => "dikt§",
"didactique" => "didaktik",
"didactiquement" => "didaktik°m@",
"didactiques" => "didaktik",
"die" => "di",
"dièdre" => "djEdR",
"dièdres" => "djEdR",
"dieffenbachia" => "dif9nbaRja",
"diem" => "djEm",
"dieppoise" => "djEpwaz",
"dieppoises" => "djEpwaz",
"diérèses" => "djeREz",
"dies irae" => "djEsiRe",
"dièse" => "djEz",
"diesel" => "djezEl",
"diesels" => "djezEl",
"dièses" => "djEz",
"diète" => "djEt",
"diététicien" => "djetetisj5",
"diététicienne" => "djetetisjEn",
"diététiciens" => "djetetisj5",
"diététique" => "djetetik",
"diététiques" => "djetetik",
"diététiste" => "djetetist",
"diéthylénique" => "djetilenik",
"dieu" => "dj2",
"dieu-roi" => "dj2Rwa",
"dieux" => "dj2",
"diffamait" => "difamE",
"diffamant" => "difam@",
"diffamateur" => "difamat9R",
"diffamateurs" => "difamat9R",
"diffamation" => "difamasj§",
"diffamations" => "difamasj§",
"diffamatoire" => "difamatwaR",
"diffamatoires" => "difamatwaR",
"diffamatrice" => "difamatRis",
"diffame" => "difam",
"diffamé" => "difame",
"diffamée" => "difame",
"diffamées" => "difame",
"diffament" => "difam",
"diffamer" => "difame",
"diffamés" => "difame",
"différa" => "difeRa",
"différaient" => "difeRE",
"différais" => "difeRE",
"différait" => "difeRE",
"différant" => "difeR@",
"différât" => "difeRa",
"diffère" => "difER",
"différé" => "difeRe",
"différée" => "difeRe",
"différées" => "difeRe",
"différemment" => "difeRam@",
"différence" => "difeR@s",
"différences" => "difeR@s",
"différenciables" => "difeR@sjabl",
"différenciaient" => "difeR@sjE",
"différenciais" => "difeR@sjE",
"différenciait" => "difeR@sjE",
"différenciant" => "difeR@sj@",
"différenciation" => "difeR@sjasj§",
"différenciations" => "difeR@sjasj§",
"différencie" => "difeR@si",
"différencié" => "difeR@sje",
"différenciée" => "difeR@sje",
"différenciées" => "difeR@sje",
"différencient" => "difeR@si",
"différencier" => "difeR@sje",
"différenciera" => "difeR@siRa",
"différencierez" => "difeR@siRe",
"différencieront" => "difeR@siR§",
"différenciés" => "difeR@sje",
"différenciez" => "difeR@sje",
"différend" => "difeR@",
"différends" => "difeR@",
"différent" => "difeR@",
"diffèrent" => "difER",
"différente" => "difeR@t",
"différentes" => "difeR@t",
"différentie" => "difeR@ti",
"différentiel" => "difeR@sjEl",
"différentielle" => "difeR@sjEl",
"différentielles" => "difeR@sjEl",
"différents" => "difeR@",
"différer" => "difeRe",
"différera" => "difeR°Ra",
"différerais" => "difeR°RE",
"différerait" => "difeR°RE",
"différèrent" => "difeRER",
"différeront" => "difeR@",
"différés" => "difeRe",
"différez" => "difeRe",
"différions" => "difeRj§",
"différons" => "difeR§",
"difficile" => "difisil",
"difficilement" => "difisil°m@",
"difficiles" => "difisil",
"difficulté" => "difikylte",
"difficultés" => "difikylte",
"difficultueux" => "difikylt82",
"difforme" => "difORm",
"difformes" => "difORm",
"difformité" => "difORmite",
"difformités" => "difORmite",
"diffractée" => "difRakte",
"diffractent" => "difRakt",
"diffraction" => "difRaksj§",
"diffus" => "dify",
"diffusa" => "difyza",
"diffusaient" => "difyzE",
"diffusais" => "difyzE",
"diffusait" => "difyzE",
"diffusant" => "difyz@",
"diffuse" => "difyz",
"diffusé" => "difyze",
"diffusée" => "difyze",
"diffusées" => "difyze",
"diffusent" => "difyz",
"diffuser" => "difyze",
"diffusera" => "difyz°Ra",
"diffuserai" => "difyz°RE",
"diffuseraient" => "difyz°RE",
"diffuserais" => "difyz°RE",
"diffuserait" => "difyz°RE",
"diffusèrent" => "difyzER",
"diffuserions" => "difyz°Rj§",
"diffuserons" => "difyz°R§",
"diffuseront" => "difyz°R§",
"diffuses" => "difyz",
"diffusés" => "difyze",
"diffuseur" => "difyz9R",
"diffuseurs" => "difyz9R",
"diffusez" => "difyze",
"diffusion" => "difyzj§",
"diffusions" => "difyzj§",
"diffusons" => "difyz§",
"difracter" => "difRakte",
"dig" => "dig",
"digéra" => "diZeRa",
"digérai" => "diZeRE",
"digéraient" => "diZeRE",
"digérait" => "diZeRE",
"digérant" => "diZeR@",
"digérât" => "diZeRa",
"digère" => "diZER",
"digéré" => "diZeRe",
"digérée" => "diZeRe",
"digérées" => "diZeRe",
"digèrent" => "diZER",
"digérer" => "diZeRe",
"digérera" => "diZeR°Ra",
"digérerait" => "diZeR°RE",
"digérés" => "diZeRe",
"digérons" => "diZeR§",
"digest" => "diZEst",
"digeste" => "diZEst",
"digestibles" => "diZEstibl",
"digestif" => "diZEstif",
"digestifs" => "diZEstif",
"digestion" => "diZEstj§",
"digestions" => "diZEstj§",
"digestive" => "diZEstiv",
"digestives" => "diZEstiv",
"digests" => "diZEst",
"digicode" => "diZikOd",
"digit" => "diZit",
"digital" => "diZital",
"digitale" => "diZital",
"digitales" => "diZital",
"digitaline" => "diZitalin",
"digitalisée" => "diZitalize",
"digitalisées" => "diZitalize",
"digitaliseur" => "diZitaliz9R",
"digitaux" => "diZito",
"digitée" => "diZite",
"digne" => "diN",
"dignement" => "diN°m@",
"dignes" => "diN",
"dignitaire" => "diNitER",
"dignitaires" => "diNitER",
"dignité" => "diNite",
"dignités" => "diNite",
"dignus est intrare" => "dignusEstintRaRe",
"digresse" => "digREs",
"digression" => "digResj§",
"digressions" => "digResj§",
"digue" => "dig",
"digues" => "dig",
"dijonnais" => "diZonE",
"diktat" => "dikta",
"diktats" => "dikta",
"dilapida" => "dilapida",
"dilapidait" => "dilapidE",
"dilapidant" => "dilapid@",
"dilapidation" => "dilapidasj§",
"dilapide" => "dilapid",
"dilapidé" => "dilapide",
"dilapidée" => "dilapide",
"dilapidées" => "dilapide",
"dilapider" => "dilapide",
"dilapides" => "dilapid",
"dilapidez" => "dilapide",
"dilata" => "dilata",
"dilatable" => "dilatabl",
"dilataient" => "dilatE",
"dilatait" => "dilatE",
"dilatant" => "dilat@",
"dilatât" => "dilata",
"dilatateur" => "dilatat9R",
"dilatateurs" => "dilatat9R",
"dilatation" => "dilatasj§",
"dilatations" => "dilatasj§",
"dilate" => "dilat",
"dilaté" => "dilate",
"dilatée" => "dilate",
"dilatées" => "dilate",
"dilatent" => "dilat",
"dilater" => "dilate",
"dilatèrent" => "dilatER",
"dilatés" => "dilate",
"dilation" => "dilasj§",
"dilatoire" => "dilatwaR",
"dilatoires" => "dilatwaR",
"dilection" => "dilEksj§",
"dilemme" => "dilEm",
"dilemmes" => "dilEm",
"dilettante" => "dilet@t",
"dilettantes" => "dilEt@t",
"dilettantisme" => "dilet@tizm",
"dilettantismes" => "dilEt@tizm",
"diligemment" => "diliZam@",
"diligence" => "diliZ@s",
"diligences" => "diliZ@s",
"diligent" => "diliZ@",
"diligente" => "diliZ@t",
"diligenter" => "diliZ@te",
"diligentes" => "diliZ@t",
"diligents" => "diliZ@",
"dilua" => "dil8a",
"diluaient" => "dil8E",
"diluait" => "dil8E",
"diluant" => "dil8@",
"dilue" => "dily",
"dilué" => "dil8e",
"diluée" => "dil8e",
"diluées" => "dil8e",
"diluent" => "dily",
"diluer" => "dil8e",
"diluerait" => "dilyRE",
"dilués" => "dil8e",
"diluons" => "dil8§",
"dilution" => "dilysj§",
"diluvien" => "dilyvj5",
"diluvienne" => "dilyvjEn",
"diluviennes" => "dilyvjEn",
"dimanche" => "dim@S",
"dimanches" => "dim@S",
"dîme" => "dim",
"dimension" => "dim@sj§",
"dimensionnel" => "dim@sjonEl",
"dimensionnelle" => "dim@sjonEl",
"dimensionnelles" => "dim@sjonEl",
"dimensionnels" => "dim@sjonEl",
"dimensionnement" => "dim@sjOn°m@",
"dimensions" => "dim@sj§",
"dîmes" => "dim",
"diminua" => "dimin8a",
"diminuaient" => "dimin8E",
"diminuais" => "dimin8E",
"diminuait" => "dimin8E",
"diminuant" => "dimin8@",
"diminuât" => "dimin8a",
"diminue" => "diminy",
"diminué" => "dimin8e",
"diminuée" => "dimin8e",
"diminuées" => "dimin8e",
"diminuendo" => "dimin85do",
"diminuent" => "diminy",
"diminuer" => "dimin8e",
"diminuera" => "diminyRa",
"diminuerai" => "diminyRE",
"diminuerais" => "diminyRE",
"diminuerait" => "diminyRE",
"diminuèrent" => "dimin8ER",
"diminueront" => "diminyR§",
"diminués" => "dimin8e",
"diminuez" => "diminye",
"diminuiez" => "diminyje",
"diminutif" => "diminytif",
"diminutifs" => "diminytif",
"diminution" => "diminysj§",
"diminutions" => "diminysj§",
"dîna" => "dina",
"dînai" => "dinE",
"dînaient" => "dinE",
"dînais" => "dinE",
"dînait" => "dinE",
"dînâmes" => "dinam",
"dinamiteros" => "dinamit°Ro",
"dinanderie" => "din@d°Ri",
"dînant" => "din@",
"dinar" => "dinaR",
"dinars" => "dinaR",
"dînât" => "dina",
"dînatoire" => "dinatwaR",
"dînatoires" => "dinatwaR",
"dinde" => "d5d",
"dindes" => "d5d",
"dindon" => "d5d§",
"dindonne" => "d5dOn",
"dindonné" => "d5done",
"dindonneau" => "d5dOno",
"dindonneaux" => "d5dono",
"dindons" => "d5d§",
"dine" => "din",
"dîne" => "din",
"dîné" => "dine",
"dînent" => "din",
"dîner" => "dine",
"dînera" => "din°Ra",
"dînerai" => "din°RE",
"dîneraient" => "din°RE",
"dînerais" => "din°RE",
"dînerait" => "din°RE",
"dîneras" => "din°Ra",
"dînèrent" => "dinER",
"dînerez" => "din°Re",
"dîneriez" => "din°Rje",
"dînerions" => "din°Rj§",
"dînerons" => "din°R§",
"dîneront" => "din°R§",
"dîners" => "dine",
"dînes" => "din",
"dînette" => "dinEt",
"dînettes" => "dinEt",
"dîneur" => "din9R",
"dîneurs" => "din9R",
"dîneuse" => "din2z",
"dînez" => "dine",
"ding" => "diG",
"dingo" => "d5go",
"dingos" => "d5go",
"dingue" => "d5g",
"dingué" => "d5ge",
"dinguent" => "d5g",
"dinguer" => "d5ge",
"dinguerie" => "d5g°Ri",
"dingueries" => "d5g°Ri",
"dingues" => "d5g",
"dîniez" => "dinje",
"dînions" => "dinj§",
"dînons" => "din§",
"dinosaure" => "dinozoR",
"dinosaures" => "dinozoR",
"diocésain" => "djOsez5",
"diocésaines" => "djosezEn",
"diocèse" => "djosEz",
"diocèses" => "djosEz",
"dioclétienne" => "diokletjEn",
"dioclétiennes" => "diokletjEn",
"diode" => "djOd",
"diodon" => "djod§",
"dionée" => "djone",
"dionysiaque" => "djonizjak",
"dionysiaques" => "djonizjak",
"dionysien" => "djonizj5",
"dioptre" => "djOptR",
"dioptries" => "djOptRi",
"diorama" => "djoRama",
"dioramas" => "djoRama",
"diorite" => "djORit",
"dioxine" => "diOksin",
"dioxines" => "djOksin",
"dioxyde" => "djOksid",
"diphényle" => "difenil",
"diphtérie" => "difteRi",
"diphtongue" => "dift§g",
"diphtongues" => "dift§g",
"diplodocus" => "diplodokys",
"diplomate" => "diplomat",
"diplomates" => "diplomat",
"diplomatie" => "diplomasi",
"diplomatique" => "diplomatik",
"diplomatiquement" => "diplomatik°m@",
"diplomatiques" => "diplomatik",
"diplôme" => "diplom",
"diplômé" => "diplome",
"diplômée" => "diplome",
"diplômées" => "diplome",
"diplômer" => "diplOme",
"diplômes" => "diplom",
"diplômés" => "diplome",
"diplopie" => "diplOpi",
"dipneuste" => "dipn2st",
"dipneustes" => "dipn2st",
"dipôle" => "dipol",
"dipsomane" => "dipsOman",
"dipsomanes" => "dipsoman",
"dipsomanie" => "dipsOmani",
"diptères" => "diptER",
"diptyque" => "diptik",
"dira" => "diRa",
"dirai" => "diRE",
"diraient" => "diRE",
"dirais" => "diRE",
"dirait" => "diRE",
"diras" => "diRa",
"dire" => "diR",
"direct" => "diREkt",
"directe" => "diREkt",
"directement" => "diREkt°m@",
"directes" => "diREkt",
"directeur" => "diREkt9R",
"directeur-adjoint" => "diREkt9RadZw5",
"directeurs" => "diREkt9R",
"directif" => "diREktif",
"direction" => "diREksj§",
"directionnel" => "diREksjonEl",
"directionnelle" => "diREksjOnEl",
"directionnelles" => "diREksjonEl",
"directionnels" => "diREksjonEl",
"directions" => "diREksj§",
"directive" => "diREktiv",
"directives" => "diREktiv",
"directo" => "diREkto",
"directoire" => "diREktwaR",
"directorat" => "diREktoRa",
"directorial" => "diREktoRjal",
"directoriale" => "diREktoRjal",
"directoriaux" => "diREktoRjo",
"directos" => "diREkto",
"directrice" => "diREktRis",
"directrices" => "diREktRis",
"directs" => "diREkt",
"dirent" => "diR",
"dires" => "diR",
"direz" => "diRe",
"dirham" => "diRam",
"dirhams" => "diRam",
"diriez" => "diRje",
"dirige" => "diRiZ",
"dirigé" => "diRiZe",
"dirigea" => "diRiZa",
"dirigeable" => "diRiZabl",
"dirigeables" => "diRiZabl",
"dirigeai" => "diRiZE",
"dirigeaient" => "diRiZE",
"dirigeais" => "diRiZE",
"dirigeait" => "diRiZE",
"dirigeâmes" => "diRiZam",
"dirigeant" => "diRiZ@",
"dirigeante" => "diRiZ@t",
"dirigeantes" => "diRiZ@t",
"dirigeants" => "diRiZ@",
"dirigeât" => "diRiZa",
"dirigée" => "diRiZe",
"dirigées" => "diRiZe",
"dirigent" => "diRiZ",
"dirigeons" => "diRiZ§",
"diriger" => "diRiZe",
"dirigera" => "diRiZ°Ra",
"dirigerai" => "diRiZ°RE",
"dirigeraient" => "diRiZ°RE",
"dirigerais" => "diRiZ°RE",
"dirigerait" => "diRiZ°RE",
"dirigeras" => "diRiZ°Ra",
"dirigèrent" => "diRiZER",
"dirigerez" => "diRiZ°Re",
"dirigerons" => "diRiZ°R§",
"dirigeront" => "diRiZ°R§",
"diriges" => "diRiZ",
"dirigés" => "diRiZe",
"dirigez" => "diRiZe",
"dirigiez" => "diRiZje",
"dirigions" => "diRiZj§",
"dirimant" => "diRim@",
"dirimants" => "diRim@",
"dirions" => "diRj§",
"dirlo" => "diRlo",
"dirlos" => "diRlo",
"dirons" => "diR§",
"diront" => "diR§",
"dis" => "di",
"disaient" => "dizE",
"disais" => "dizE",
"disait" => "dizE",
"disant" => "diz@",
"disants" => "diz@",
"disc-jockey" => "diskZokE",
"disc-jockeys" => "diskZokE",
"discal" => "diskal",
"discale" => "diskal",
"discerna" => "disERna",
"discernable" => "disERnabl",
"discernables" => "disERnabl",
"discernai" => "disERnE",
"discernaient" => "disERnE",
"discernais" => "disERnE",
"discernait" => "disERnE",
"discernâmes" => "disERnam",
"discernant" => "disERn@",
"discernât" => "disERna",
"discerne" => "disERn",
"discerné" => "disERne",
"discernées" => "disERne",
"discernement" => "disERn°m@",
"discernent" => "disERn",
"discerner" => "disERne",
"discernerait" => "disERn°RE",
"discernes" => "disERn",
"discernions" => "disERnj§",
"disciple" => "disipl",
"disciple-roi" => "disipl°Rwa",
"disciples" => "disipl",
"disciplina" => "disiplina",
"disciplinaient" => "disiplinE",
"disciplinaire" => "disiplinER",
"disciplinaires" => "disiplinER",
"disciplinais" => "disiplinE",
"disciplinait" => "disiplinE",
"discipline" => "disiplin",
"discipliné" => "disipline",
"disciplinée" => "disipline",
"disciplinées" => "disipline",
"discipliner" => "disipline",
"disciplinera" => "disiplin°Ra",
"disciplinerait" => "disiplin°RE",
"disciplines" => "disiplin",
"disciplinés" => "disipline",
"disco" => "disko",
"discobole" => "diskobOl",
"discoboles" => "diskobOl",
"discographie" => "diskOgRafi",
"discographiques" => "diskogRafik",
"discontinu" => "disk§tiny",
"discontinuaient" => "disk§tin8E",
"discontinue" => "disk§tiny",
"discontinuer" => "disk§tin8e",
"discontinues" => "disk§tiny",
"discontinuité" => "disk§tin8ite",
"discontinus" => "disk§tiny",
"disconviens" => "disk§vj5",
"disconvint" => "disk§v5",
"discordance" => "diskORd@s",
"discordances" => "diskORd@s",
"discordant" => "diskORd@",
"discordante" => "diskORd@t",
"discordantes" => "diskORd@t",
"discordants" => "diskORd@",
"discorde" => "diskORd",
"discordes" => "diskORd",
"discos" => "disko",
"discothèque" => "diskotEk",
"discothèques" => "diskotEk",
"discount" => "diskunt",
"discouraient" => "diskuRE",
"discourait" => "diskuRE",
"discourant" => "diskuR@",
"discoure" => "diskuR",
"discourent" => "diskuR",
"discoureur" => "diskuR9R",
"discoureurs" => "diskuR9R",
"discourir" => "diskuRiR",
"discours" => "diskuR",
"discourt" => "diskuR",
"discourtois" => "diskuRtwa",
"discourtoise" => "diskuRtwaz",
"discourtoises" => "diskuRtwaz",
"discouru" => "diskuRy",
"discourut" => "diskuRy",
"discrédit" => "diskRedi",
"discréditait" => "diskReditE",
"discréditant" => "diskRedit@",
"discrédite" => "diskRedit",
"discrédité" => "diskRedite",
"discréditée" => "diskRedite",
"discréditées" => "diskRedite",
"discréditer" => "diskRedite",
"discréditerait" => "diskRedit°RE",
"discrédités" => "diskRedite",
"discréditez" => "diskRedite",
"discret" => "diskRE",
"discrète" => "diskREt",
"discrètement" => "diskREt°m@",
"discrètes" => "diskREt",
"discrétion" => "diskResj§",
"discrétionnaire" => "diskResjonER",
"discrétionnaires" => "diskResjonER",
"discrets" => "diskRE",
"discriminant" => "diskRimin@",
"discriminants" => "diskRimin@",
"discrimination" => "diskRiminasj§",
"discriminations" => "diskRiminasj§",
"discriminatoire" => "diskRiminatwaR",
"discriminé" => "diskRimine",
"discriminer" => "diskRimine",
"disculpait" => "diskylpE",
"disculpant" => "diskylp@",
"disculpation" => "diskylpasj§",
"disculpe" => "diskylp",
"disculpé" => "diskylpe",
"disculpent" => "diskylp",
"disculper" => "diskylpe",
"disculperait" => "diskylp°RE",
"disculpés" => "diskylpe",
"disculpez" => "diskylpe",
"discursives" => "diskyRsiv",
"discussion" => "diskysj§",
"discussions" => "diskysj§",
"discuta" => "diskyta",
"discutable" => "diskytabl",
"discutables" => "diskytabl",
"discutai" => "diskytE",
"discutaient" => "diskytE",
"discutaillaient" => "diskytajE",
"discutaillait" => "diskytajE",
"discutaille" => "diskytaj",
"discutaillent" => "diskytaj",
"discutailler" => "diskytaje",
"discutailleries" => "diskytaj°Ri",
"discutailleur" => "diskytaj9R",
"discutailleuse" => "diskytaj2z",
"discutais" => "diskytE",
"discutait" => "diskytE",
"discutâmes" => "diskytam",
"discutant" => "diskyt@",
"discutât" => "diskyta",
"discute" => "diskyt",
"discuté" => "diskyte",
"discutée" => "diskyte",
"discutées" => "diskyte",
"discutent" => "diskyt",
"discuter" => "diskyte",
"discutera" => "diskyt°Ra",
"discuterai" => "diskyt°RE",
"discuteraient" => "diskyt°RE",
"discuterais" => "diskyt°RE",
"discuterait" => "diskyt°RE",
"discutèrent" => "diskytER",
"discuterez" => "diskyt°Re",
"discuteriez" => "diskyt°Rje",
"discuterions" => "diskyt°Rj§",
"discuterons" => "diskyt°R§",
"discuteront" => "diskyt°R§",
"discutes" => "diskyt",
"discutés" => "diskyte",
"discutez" => "diskyte",
"discutiez" => "diskytje",
"discutions" => "diskytj§",
"discutons" => "diskyt§",
"dise" => "diz",
"disent" => "diz",
"disert" => "dizER",
"diserte" => "dizERt",
"dises" => "diz",
"disette" => "dizEt",
"disettes" => "dizEt",
"diseur" => "diz9R",
"diseurs" => "diz9R",
"diseuse" => "diz2z",
"diseuses" => "diz2z",
"disfonctionnement" => "disf§ksjOn°m@",
"disgrâce" => "disgRas",
"disgrâces" => "disgRas",
"disgracia" => "disgRasja",
"disgraciaient" => "disgRasjE",
"disgraciait" => "disgRasjE",
"disgracié" => "disgRasje",
"disgraciée" => "disgRasje",
"disgraciées" => "disgRasje",
"disgracier" => "disgRasje",
"disgraciera" => "disgRasiRa",
"disgraciés" => "disgRasje",
"disgracieuse" => "disgRasj2z",
"disgracieusement" => "disgRasj2z°m@",
"disgracieuses" => "disgRasj2z",
"disgracieux" => "disgRasj2",
"disharmonie" => "dizaRmoni",
"disiez" => "dizje",
"disions" => "dizj§",
"disjoignait" => "disZwaNE",
"disjoignant" => "disZwaN@",
"disjoignent" => "disZwaN",
"disjoindre" => "disZw5dR",
"disjoint" => "disZw5",
"disjointe" => "disZw5t",
"disjointes" => "disZw5t",
"disjoints" => "disZw5",
"disjoncta" => "disZ§kta",
"disjonctais" => "disZ§ktE",
"disjonctait" => "diZ§ktE",
"disjoncte" => "diZ§kt",
"disjoncté" => "disZ§kte",
"disjonctée" => "disZ§kte",
"disjonctent" => "diZ§kt",
"disjoncter" => "disZ§kte",
"disjoncterais" => "diZ§kt°RE",
"disjoncterait" => "disZ§kt°RE",
"disjonctes" => "diZ§kt",
"disjonctés" => "diZ§kte",
"disjoncteur" => "disZ§kt9R",
"disjoncteurs" => "disZ§kt9R",
"disjonctez" => "diZ§kte",
"disjonction" => "disZ§ksj§",
"disjonctions" => "disZ§ksj§",
"diskette" => "diskEt",
"dislocation" => "dislokasj§",
"dislocations" => "dislokasj§",
"disloqua" => "disloka",
"disloquai" => "dislokE",
"disloquaient" => "dislokE",
"disloquait" => "dislokE",
"disloquant" => "dislok@",
"disloquât" => "disloka",
"disloque" => "dislOk",
"disloqué" => "disloke",
"disloquée" => "disloke",
"disloquées" => "disloke",
"disloquent" => "dislOk",
"disloquer" => "disloke",
"disloquerai" => "dislOk°RE",
"disloquèrent" => "dislokER",
"disloqueront" => "dislOk°R§",
"disloqués" => "disloke",
"disons" => "diz§",
"disparais" => "dispaRE",
"disparaissaient" => "dispaREsE",
"disparaissais" => "dispaREsE",
"disparaissait" => "dispaREsE",
"disparaissant" => "dispaREs@",
"disparaissante" => "dispaREs@t",
"disparaisse" => "dispaREs",
"disparaissent" => "dispaREs",
"disparaisses" => "dispaREs",
"disparaissez" => "dispaREse",
"disparaissiez" => "dispaREsje",
"disparaissions" => "dispaREsj§",
"disparaissons" => "dispaREs§",
"disparaît" => "dispaRE",
"disparaîtra" => "dispaREtRa",
"disparaîtrai" => "dispaREtRE",
"disparaîtraient" => "dispaREtRE",
"disparaîtrais" => "dispaREtRE",
"disparaîtrait" => "dispaREtRE",
"disparaîtras" => "dispaREtRa",
"disparaître" => "dispaREtR",
"disparaîtrez" => "dispaREtRe",
"disparaîtrions" => "dispaREtRi§",
"disparaîtrons" => "dispaREtR§",
"disparaîtront" => "dispaREtR§",
"disparate" => "dispaRat",
"disparates" => "dispaRat",
"disparité" => "dispaRite",
"disparition" => "dispaRisj§",
"disparitions" => "dispaRisj§",
"disparu" => "dispaRy",
"disparue" => "dispaRy",
"disparues" => "dispaRy",
"disparûmes" => "dispaRym",
"disparurent" => "dispaRyR",
"disparus" => "dispaRy",
"disparut" => "dispaRy",
"disparût" => "dispaRy",
"dispatchais" => "dispatSE",
"dispatchait" => "dispatSE",
"dispatche" => "dispatS",
"dispatcher" => "dispatSe",
"dispatching" => "dispatSiG",
"dispendieuse" => "disp@dj2z",
"dispendieusement" => "disp@dj2z°m@",
"dispendieux" => "disp@dj2",
"dispensa" => "disp@sa",
"dispensable" => "disp@sabl",
"dispensaient" => "disp@sE",
"dispensaire" => "disp@sER",
"dispensaires" => "disp@sER",
"dispensais" => "disp@sE",
"dispensait" => "disp@sE",
"dispensant" => "disp@s@",
"dispensât" => "disp@sa",
"dispensateur" => "disp@sat9R",
"dispensateurs" => "disp@sat9R",
"dispensation" => "disp@sasj§",
"dispensatrice" => "disp@satRis",
"dispensatrices" => "disp@satRis",
"dispense" => "disp@s",
"dispensé" => "disp@se",
"dispensée" => "disp@se",
"dispensées" => "disp@se",
"dispensent" => "disp@s",
"dispenser" => "disp@se",
"dispenserait" => "disp@s°RE",
"dispenseras" => "disp@s°Ra",
"dispensèrent" => "disp@sER",
"dispenses" => "disp@s",
"dispensés" => "disp@se",
"dispensez" => "disp@se",
"dispersa" => "dispERsa",
"dispersaient" => "dispERsE",
"dispersait" => "dispERsE",
"dispersant" => "dispERs@",
"dispersât" => "dispERsa",
"disperse" => "dispERs",
"dispersé" => "dispERse",
"dispersée" => "dispERse",
"dispersées" => "dispERse",
"dispersement" => "dispERs°m@",
"dispersent" => "dispERs",
"disperser" => "dispERse",
"dispersera" => "dispERs°Ra",
"disperserai" => "dispERs°RE",
"disperseraient" => "dispERs°RE",
"disperserait" => "dispERs°RE",
"dispersèrent" => "dispERsER",
"disperserons" => "dispERs°R§",
"disperseront" => "dispERs°R§",
"disperses" => "dispERs",
"dispersés" => "dispERse",
"dispersez" => "dispERse",
"dispersif" => "dispERsif",
"dispersion" => "dispERsj§",
"dispersions" => "dispERsj§",
"dispersons" => "dispERs§",
"dispo" => "dispo",
"disponibilité" => "disponibilite",
"disponibilités" => "disponibilite",
"disponible" => "disponibl",
"disponibles" => "disponibl",
"dispos" => "dispo",
"disposa" => "dispoza",
"disposai" => "dispozE",
"disposaient" => "dispozE",
"disposais" => "dispozE",
"disposait" => "dispozE",
"disposâmes" => "dispozam",
"disposant" => "dispoz@",
"disposas" => "dispoza",
"disposât" => "dispoza",
"dispose" => "dispoz",
"disposé" => "dispoze",
"disposée" => "dispoze",
"disposées" => "dispoze",
"disposent" => "dispoz",
"disposer" => "dispoze",
"disposera" => "dispoz°Ra",
"disposerai" => "dispoz°RE",
"disposeraient" => "dispoz°RE",
"disposerais" => "dispoz°RE",
"disposerait" => "dispoz°RE",
"disposeras" => "dispoz°Ra",
"disposèrent" => "dispozER",
"disposerez" => "dispoz°Re",
"disposerons" => "dispoz°R§",
"disposeront" => "dispoz°R§",
"disposes" => "dispoz",
"disposés" => "dispoze",
"disposez" => "dispoze",
"disposiez" => "dispozje",
"disposions" => "dispozj§",
"dispositif" => "dispozitif",
"dispositifs" => "dispozitif",
"disposition" => "dispozisj§",
"dispositions" => "dispozisj§",
"disposons" => "dispoz§",
"disproportion" => "dispRopORsj§",
"disproportionné" => "dispRopORsjone",
"disproportionnée" => "dispRopORsjone",
"disproportionnées" => "dispRopORsjone",
"disproportionnelle" => "dispRopORsjonEl",
"disproportionnés" => "dispRopORsjone",
"disproportions" => "dispRopORsj§",
"disputa" => "dispyta",
"disputaient" => "dispytE",
"disputais" => "dispytE",
"disputait" => "dispytE",
"disputâmes" => "dispytam",
"disputant" => "dispyt@",
"disputât" => "dispyta",
"dispute" => "dispyt",
"disputé" => "dispyte",
"disputée" => "dispyte",
"disputées" => "dispyte",
"disputent" => "dispyt",
"disputer" => "dispyte",
"disputera" => "dispyt°Ra",
"disputerai" => "dispyt°RE",
"disputeraient" => "dispyt°RE",
"disputerait" => "dispyt°RE",
"disputèrent" => "dispytER",
"disputerez" => "dispyt°Re",
"disputerons" => "dispyt°R§",
"disputeront" => "dispyt°R§",
"disputes" => "dispyt",
"disputés" => "dispyte",
"disputeur" => "dispyt9R",
"disputez" => "dispyte",
"disputiez" => "dispytje",
"disputions" => "dispytj§",
"disputons" => "dispyt§",
"disquaire" => "diskER",
"disquaires" => "diskER",
"disqualifiait" => "diskalifjE",
"disqualifiant" => "diskalifj@",
"disqualification" => "diskalifikasj§",
"disqualifications" => "diskalifikasj§",
"disqualifie" => "diskalifi",
"disqualifié" => "diskalifje",
"disqualifiée" => "diskalifje",
"disqualifiées" => "diskalifje",
"disqualifient" => "diskalifi",
"disqualifier" => "diskalifje",
"disqualifiés" => "diskalifje",
"disque" => "disk",
"disque-jockey" => "diskZokE",
"disques" => "disk",
"disquette" => "diskEt",
"disquettes" => "diskEt",
"disruptif" => "disRyptif",
"disruption" => "disRypsj§",
"dissection" => "diseksj§",
"dissections" => "diseksj§",
"dissemblable" => "dis@blabl",
"dissemblables" => "dis@blabl",
"dissemblance" => "dis@bl@s",
"dissémina" => "disemina",
"disséminait" => "diseminE",
"disséminant" => "disemin@",
"dissémination" => "diseminasj§",
"disséminé" => "disemine",
"disséminée" => "disemine",
"disséminées" => "disemine",
"disséminent" => "disemin",
"disséminer" => "disemine",
"disséminèrent" => "diseminER",
"disséminés" => "disemine",
"dissension" => "dis@sj§",
"dissensions" => "dis@sj§",
"dissent" => "dis",
"dissentiment" => "dis@tim@",
"dissentiments" => "dis@tim@",
"disséquai" => "disekE",
"disséquait" => "disekE",
"disséquant" => "disek@",
"dissèque" => "disEk",
"disséqué" => "diseke",
"disséquée" => "diseke",
"dissèquent" => "disEk",
"disséquer" => "diseke",
"disséqueraient" => "disek°RE",
"disséquerais" => "disek°RE",
"disséqués" => "diseke",
"disséqueur" => "disek9R",
"disséquez" => "diseke",
"disséquiez" => "disekje",
"disséquions" => "disekj§",
"disséquons" => "disek§",
"dissertait" => "disERtE",
"dissertant" => "disERt@",
"dissertation" => "disERtasj§",
"dissertations" => "disERtasj§",
"disserte" => "disERt",
"disserté" => "disERte",
"dissertent" => "disERt",
"disserter" => "disERte",
"disserterait" => "disERt°RE",
"dissertes" => "disERt",
"dissidence" => "disid@s",
"dissidences" => "disid@s",
"dissident" => "disid@",
"dissidente" => "disid@t",
"dissidentes" => "disid@t",
"dissidents" => "disid@",
"dissimilaires" => "disimilER",
"dissimiler" => "disimile",
"dissimula" => "disimyla",
"dissimulables" => "disimylabl",
"dissimulai" => "disimylE",
"dissimulaient" => "disimylE",
"dissimulais" => "disimylE",
"dissimulait" => "disimylE",
"dissimulant" => "disimyl@",
"dissimulât" => "disimyla",
"dissimulateur" => "disimylat9R",
"dissimulateurs" => "disimylat9R",
"dissimulation" => "disimylasj§",
"dissimulations" => "disimylasj§",
"dissimulatrice" => "disimylatRis",
"dissimulatrices" => "disimylatRis",
"dissimule" => "disimyl",
"dissimulé" => "disimyle",
"dissimulée" => "disimyle",
"dissimulées" => "disimyle",
"dissimulent" => "disimyl",
"dissimuler" => "disimyle",
"dissimulera" => "disimyl°Ra",
"dissimuleraient" => "disimyl°RE",
"dissimulerais" => "disimyl°RE",
"dissimulerait" => "disimyl°RE",
"dissimulèrent" => "disimylER",
"dissimulerons" => "disimyl°R§",
"dissimules" => "disimyl",
"dissimulés" => "disimyle",
"dissimulez" => "disimyle",
"dissimuliez" => "disimylje",
"dissimulions" => "disimylj§",
"dissimulons" => "disimyl§",
"dissipa" => "disipa",
"dissipaient" => "disipE",
"dissipait" => "disipE",
"dissipant" => "disip@",
"dissipateur" => "disipat9R",
"dissipateurs" => "disipat9R",
"dissipation" => "disipasj§",
"dissipations" => "disipasj§",
"dissipe" => "disip",
"dissipé" => "disipe",
"dissipée" => "disipe",
"dissipées" => "disipe",
"dissipent" => "disip",
"dissiper" => "disipe",
"dissipera" => "disip°Ra",
"dissiperais" => "disip°RE",
"dissiperait" => "disip°RE",
"dissipèrent" => "disipER",
"dissiperont" => "disip°R§",
"dissipés" => "disipe",
"dissipez" => "disipe",
"dissocia" => "disosja",
"dissociaient" => "disosjE",
"dissociait" => "disosjE",
"dissociant" => "disosj@",
"dissociatif" => "disosjatif",
"dissociatifs" => "disosjatif",
"dissociation" => "disosjasj§",
"dissociations" => "disosjasj§",
"dissociative" => "disosjativ",
"dissocie" => "disosi",
"dissocié" => "disosje",
"dissociée" => "disosje",
"dissociées" => "disosje",
"dissocient" => "disosi",
"dissocier" => "disosje",
"dissocierons" => "disosiR§",
"dissociés" => "disosje",
"dissolu" => "disoly",
"dissolue" => "disoly",
"dissolues" => "disoly",
"dissolus" => "disoly",
"dissolution" => "disolysj§",
"dissolvaient" => "disOlvE",
"dissolvait" => "disOlvE",
"dissolvant" => "disOlv@",
"dissolvante" => "disOlv@t",
"dissolvantes" => "disOlv@t",
"dissolvants" => "disOlv@",
"dissolve" => "disOlv",
"dissolvent" => "disOlv",
"dissolves" => "disOlv",
"dissonance" => "dison@s",
"dissonances" => "dison@s",
"dissonant" => "dison@",
"dissonants" => "dison@",
"dissoudra" => "disudRa",
"dissoudrai" => "disudRE",
"dissoudrait" => "disudRE",
"dissoudre" => "disudR",
"dissoudront" => "disudR§",
"dissous" => "disu",
"dissout" => "disu",
"dissoute" => "disut",
"dissoutes" => "disut",
"dissuada" => "dis8ada",
"dissuadai" => "dis8adE",
"dissuadait" => "dis8adE",
"dissuadant" => "dis8ad@",
"dissuade" => "dis8ad",
"dissuadé" => "dis8ade",
"dissuadée" => "dis8ade",
"dissuadent" => "dis8ad",
"dissuader" => "dis8ade",
"dissuadera" => "disyad°Ra",
"dissuaderas" => "disyad°Ra",
"dissuadèrent" => "dis8adER",
"dissuaderez" => "disyad°Re",
"dissuaderont" => "disyad°R§",
"dissuadés" => "dis8ade",
"dissuadez" => "disyade",
"dissuadiez" => "disyadje",
"dissuasif" => "dis8azif",
"dissuasion" => "dis8azj§",
"dissuasive" => "dis8asiv",
"dissymétrie" => "disimetRi",
"dissymétrique" => "disimetRik",
"dissymétriques" => "disimetRik",
"distal" => "distal",
"distale" => "distal",
"distança" => "dist@sa",
"distançait" => "dist@sE",
"distançant" => "dist@s@",
"distance" => "dist@s",
"distancé" => "dist@se",
"distancée" => "dist@se",
"distancent" => "dist@s",
"distancer" => "dist@se",
"distancerez" => "dist@s°Re",
"distances" => "dist@s",
"distancés" => "dist@se",
"distanciation" => "dist@sjasj§",
"distancié" => "dist@sje",
"distancier" => "dist@sje",
"distançons" => "dist@s§",
"distant" => "dist@",
"distante" => "dist@t",
"distantes" => "dist@t",
"distants" => "dist@",
"distaux" => "disto",
"distend" => "dist@",
"distendaient" => "dist@dE",
"distendait" => "dist@dE",
"distendant" => "dist@d@",
"distende" => "dist@d",
"distendent" => "dist@d",
"distendit" => "dist@di",
"distendrait" => "dist@dRE",
"distendre" => "dist@dR",
"distendu" => "dist@dy",
"distendue" => "dist@dy",
"distendues" => "dist@dy",
"distendus" => "dist@dy",
"distension" => "dist@sj§",
"distillaient" => "distilE",
"distillait" => "distilE",
"distillant" => "distil@",
"distillat" => "distila",
"distillateur" => "distilat9R",
"distillateurs" => "distijat9R",
"distillation" => "distilasj§",
"distillations" => "distilasj§",
"distille" => "distil",
"distillé" => "distile",
"distillée" => "distile",
"distillées" => "distile",
"distillent" => "distil",
"distiller" => "distile",
"distillera" => "distil°Ra",
"distillerie" => "distil°Ri",
"distilleries" => "distil°Ri",
"distilleront" => "distil°R§",
"distillés" => "distile",
"distillez" => "distile",
"distinct" => "dist5",
"distincte" => "dist5kt",
"distinctement" => "dist5kt°m@",
"distinctes" => "dist5kt",
"distinctif" => "dist5ktif",
"distinctifs" => "dist5ktif",
"distinction" => "dist5ksj§",
"distinctions" => "dist5ksj§",
"distinctive" => "dist5ktiv",
"distinctives" => "dist5ktiv",
"distincts" => "dist5",
"distingua" => "dist5ga",
"distinguai" => "dist5gE",
"distinguaient" => "dist5gE",
"distinguais" => "dist5gE",
"distinguait" => "dist5gE",
"distinguant" => "dist5g@",
"distinguât" => "dist5ga",
"distingue" => "dist5g",
"distingué" => "dist5ge",
"distinguée" => "dist5ge",
"distinguées" => "dist5ge",
"distinguent" => "dist5g",
"distinguer" => "dist5ge",
"distinguera" => "dist5g°Ra",
"distingueraient" => "dist5g°RE",
"distinguerait" => "dist5g°RE",
"distinguèrent" => "dist5gER",
"distinguerez" => "dist5g°Re",
"distingues" => "dist5g",
"distingués" => "dist5ge",
"distinguez" => "dist5ge",
"distinguions" => "dist5gj§",
"distinguo" => "dist5go",
"distinguons" => "dist5g§",
"distinguos" => "dist5go",
"distord" => "distOR",
"distordant" => "distORd@",
"distordre" => "distORdR",
"distordu" => "distORdy",
"distordue" => "distORdy",
"distordues" => "distORdy",
"distorsion" => "distORsj§",
"distorsions" => "distORsj§",
"distraction" => "distRaksj§",
"distractions" => "distRaksj§",
"distractives" => "distRaktiv",
"distraie" => "distRE",
"distraient" => "distRE",
"distraies" => "distRE",
"distraira" => "distRERa",
"distrairaient" => "distRERE",
"distrairait" => "distRERE",
"distraire" => "distRER",
"distrairont" => "distRER§",
"distrais" => "distRE",
"distrait" => "distRE",
"distraite" => "distREt",
"distraitement" => "distREt°m@",
"distraites" => "distREt",
"distraits" => "distRE",
"distrayaient" => "distREjE",
"distrayais" => "distREjE",
"distrayait" => "distREjE",
"distrayant" => "distREj@",
"distrayante" => "distREj@t",
"distrayantes" => "distREj@t",
"distrayants" => "distREj@",
"distrayez" => "distREje",
"distrayons" => "distREj§",
"distribua" => "distRib8a",
"distribuai" => "distRib8E",
"distribuaient" => "distRib8E",
"distribuais" => "distRib8E",
"distribuait" => "distRib8E",
"distribuant" => "distRib8@",
"distribuât" => "distRib8a",
"distribue" => "distRiby",
"distribué" => "distRib8e",
"distribuée" => "distRib8e",
"distribuées" => "distRib8e",
"distribuent" => "distRiby",
"distribuer" => "distRib8e",
"distribuera" => "distRibyRa",
"distribuerai" => "distRibyRE",
"distribuerais" => "distRibyRE",
"distribuerait" => "distRibyRE",
"distribuèrent" => "distRib8ER",
"distribuerez" => "distRibyRe",
"distribuerions" => "distRibyRj§",
"distribuerons" => "distRibyR§",
"distribueront" => "distRibyR§",
"distribues" => "distRiby",
"distribués" => "distRib8e",
"distribuez" => "distRibye",
"distribuiez" => "distRibyje",
"distribuions" => "distRibyj§",
"distribuons" => "distRib8§",
"distributeur" => "distRibyt9R",
"distributeurs" => "distRibyt9R",
"distribution" => "distRibysj§",
"distributions" => "distRibysj§",
"distributive" => "distRibytiv",
"distributrice" => "distRibytRis",
"district" => "distRikt",
"districts" => "distRikt",
"dit" => "di",
"dît" => "di",
"dite" => "dit",
"dites" => "dit",
"dîtes" => "dit",
"dithyrambe" => "ditiR@b",
"dithyrambes" => "ditiR@b",
"dithyrambique" => "ditiR@bik",
"dithyrambiques" => "ditiR@bik",
"dito" => "dito",
"dits" => "di",
"diurèse" => "djyREz",
"diurétique" => "djyRetik",
"diurétiques" => "djyRetik",
"diurnal" => "djyRnal",
"diurne" => "djyRn",
"diurnes" => "djyRn",
"diva" => "diva",
"divagant" => "divag@",
"divagants" => "divag@",
"divagation" => "divagasj§",
"divagations" => "divagasj§",
"divaguaient" => "divagE",
"divaguait" => "divagE",
"divaguant" => "divag@",
"divague" => "divag",
"divagué" => "divage",
"divaguent" => "divag",
"divaguer" => "divage",
"divagues" => "divag",
"divaguez" => "divage",
"divan" => "div@",
"divans" => "div@",
"divas" => "diva",
"dive" => "div",
"diverge" => "divERZ",
"divergé" => "divERZe",
"divergeaient" => "divERZE",
"divergeait" => "divERZE",
"divergeant" => "divERZ@",
"divergence" => "divERZ@s",
"divergences" => "divERZ@s",
"divergent" => "divERZ",
"divergente" => "divERZ@t",
"divergentes" => "divERZ@t",
"divergents" => "divERZ@",
"divergeons" => "divERZ§",
"diverger" => "divERZe",
"divergez" => "divERZe",
"divergions" => "divERZj§",
"divers" => "divER",
"diverse" => "divERs",
"diversement" => "divERs°m@",
"diverses" => "divERs",
"diversifiant" => "divERsifj@",
"diversification" => "divERsifikasj§",
"diversifie" => "divERsifi",
"diversifié" => "divERsifje",
"diversifiée" => "divERsifje",
"diversifiées" => "divERsifje",
"diversifient" => "divERsifi",
"diversifier" => "divERsifje",
"diversifiés" => "divERsifje",
"diversion" => "divERsj§",
"diversions" => "divERsj§",
"diversité" => "divERsite",
"diversités" => "divERsite",
"diverti" => "divERti",
"diverticule" => "divERtikyl",
"diverticulose" => "divERtikyloz",
"divertie" => "divERti",
"divertimento" => "divERtimEnto",
"divertir" => "divERtiR",
"divertira" => "divERtiRa",
"divertirait" => "divERtiRE",
"divertirent" => "divERtiR",
"divertirons" => "divERtiR§",
"divertiront" => "divERtiR§",
"divertis" => "divERti",
"divertissaient" => "divERtisE",
"divertissais" => "divERtisE",
"divertissait" => "divERtisE",
"divertissant" => "divERtis@",
"divertissante" => "divERtis@t",
"divertissantes" => "divERtis@t",
"divertissants" => "divERtis@",
"divertissement" => "divERtis°m@",
"divertissements" => "divERtis°m@",
"divertissent" => "divERtis",
"divertissez" => "divERtise",
"divertissons" => "divERtis§",
"divertit" => "divERti",
"dividende" => "divid@d",
"dividendes" => "divid@d",
"divin" => "div5",
"divination" => "divinasj§",
"divinations" => "divinasj§",
"divinatoire" => "divinatwaR",
"divinatoires" => "divinatwaR",
"divinatrice" => "divinatRis",
"divinatrices" => "divinatRis",
"divine" => "divin",
"divinement" => "divin°m@",
"divines" => "divin",
"divinisaient" => "divinizE",
"divinisant" => "diviniz@",
"divinise" => "diviniz",
"divinisé" => "divinize",
"divinisée" => "divinize",
"divinisez" => "divinize",
"divinité" => "divinite",
"divinités" => "divinite",
"divins" => "div5",
"divisa" => "diviza",
"divisaient" => "divizE",
"divisais" => "divizE",
"divisait" => "divizE",
"divisant" => "diviz@",
"divise" => "diviz",
"divisé" => "divize",
"divisée" => "divize",
"divisées" => "divize",
"divisent" => "diviz",
"diviser" => "divize",
"divisera" => "diviz°Ra",
"diviserais" => "diviz°RE",
"diviserait" => "diviz°RE",
"divisèrent" => "divizER",
"divises" => "diviz",
"divisés" => "divize",
"diviseur" => "diviz9R",
"diviseuse" => "diviz2z",
"divisez" => "divize",
"divisible" => "divizibl",
"divisibles" => "divizibl",
"division" => "divizj§",
"divisionnaire" => "divizjonER",
"divisionnaires" => "divizjonER",
"divisionnisme" => "divizjonizm",
"divisions" => "divizj§",
"divisons" => "diviz§",
"divorça" => "divORsa",
"divorçaient" => "divORsE",
"divorçait" => "divORsE",
"divorçant" => "divORs@",
"divorce" => "divORs",
"divorcé" => "divORse",
"divorcée" => "divORse",
"divorcées" => "divORse",
"divorcent" => "divORs",
"divorcer" => "divORse",
"divorcera" => "divORs°Ra",
"divorcerai" => "divORs°RE",
"divorcerais" => "divORs°RE",
"divorcerait" => "divORs°RE",
"divorceras" => "divORs°Ra",
"divorcèrent" => "divORsER",
"divorcerez" => "divORs°Re",
"divorceriez" => "divORs°Rje",
"divorcerons" => "divORs°R§",
"divorceront" => "divORs°R§",
"divorces" => "divORs",
"divorcés" => "divORse",
"divorcez" => "divORse",
"divorciez" => "divORsje",
"divorcions" => "divORsj§",
"divorçons" => "divORs§",
"divulgation" => "divylgasj§",
"divulguait" => "divylgE",
"divulguant" => "divylg@",
"divulgue" => "divylg",
"divulgué" => "divylge",
"divulguée" => "divylge",
"divulguées" => "divylge",
"divulguer" => "divylge",
"divulguera" => "divylg°Ra",
"divulgués" => "divylge",
"divulguez" => "divylge",
"divulguons" => "divylg§",
"dix" => "dis",
"dix-cors" => "dikOR",
"dix-huit" => "diz8it",
"dix-huitième" => "diz8itjEm",
"dix-neuf" => "dizn9f",
"dix-neuvième" => "dizn9vjEm",
"dix-sept" => "disEt",
"dix-septième" => "disEtjEm",
"dixie" => "diksi",
"dixieland" => "diksil@d",
"dixième" => "dizjEm",
"dixièmement" => "dizjEm°m@",
"dixièmes" => "dizjEm",
"dixit" => "diksit",
"dizain" => "diz5",
"dizaine" => "dizEn",
"dizaines" => "dizEn",
"djebel" => "dZebEl",
"djebels" => "dZebEl",
"djellaba" => "dZElaba",
"djellabas" => "dZElaba",
"djemââ" => "dZemaa",
"djihad" => "dZiad",
"djihads" => "dZiad",
"djinn" => "dZin",
"djinns" => "dZin",
"dm" => "desimEtR",
"dna" => "deEna",
"do" => "do",
"doberman" => "dobERman",
"dobermans" => "dobERman",
"doc" => "dOk",
"doche" => "dOS",
"docile" => "dosil",
"docilement" => "dosil°m@",
"dociles" => "dosil",
"docilité" => "dosilite",
"dock" => "dOk",
"docker" => "dok9R",
"dockers" => "dokER",
"docks" => "dOk",
"docte" => "dOkt",
"doctement" => "dOkt°m@",
"doctes" => "dOkt",
"docteur" => "dOkt9R",
"docteurs" => "dOkt9R",
"doctissime" => "dOktisim",
"doctoral" => "dOktoRal",
"doctorale" => "dOktoRal",
"doctorat" => "dOktoRa",
"doctorats" => "dOktoRa",
"doctoresse" => "dOktoREs",
"doctrina" => "dOktRina",
"doctrinaire" => "dOktRinER",
"doctrinaires" => "dOktRinER",
"doctrinal" => "dOktRinal",
"doctrinale" => "dOktRinal",
"doctrinales" => "dOktRinal",
"doctrine" => "dOktRin",
"doctrines" => "dOktRin",
"docudrame" => "dokydRam",
"document" => "dokym@",
"documenta" => "dokym@ta",
"documentaire" => "dokym@tER",
"documentaires" => "dokym@tER",
"documentais" => "dokym@tE",
"documentait" => "dokym@tE",
"documentaliste" => "dokym@talist",
"documentalistes" => "dokym@talist",
"documentant" => "dokym@t@",
"documentariste" => "dokym@taRist",
"documentaristes" => "dokym@taRist",
"documentation" => "dokym@tasj§",
"documentations" => "dokym@tasj§",
"documente" => "dokym@t",
"documenté" => "dokym@te",
"documentée" => "dokym@te",
"documentent" => "dokym@t",
"documenter" => "dokym@te",
"documenterai" => "dokym@t°RE",
"documentes" => "dokym@t",
"documentés" => "dokym@te",
"documents" => "dokym@",
"dodécaèdre" => "dodekaEdR",
"dodécagone" => "dodekagon",
"dodécaphoniste" => "dodekafonist",
"dodelinaient" => "dod°linE",
"dodelinais" => "dod°linE",
"dodelinait" => "dod°linE",
"dodelinant" => "dod°lin@",
"dodelinante" => "dod°lin@t",
"dodelinantes" => "dod°lin@t",
"dodeline" => "dod°lin",
"dodeliné" => "dod°line",
"dodelinent" => "dod°lin",
"dodeliner" => "dod°line",
"dodelinèrent" => "dod°linER",
"dodine" => "dodin",
"dodo" => "dodo",
"dodos" => "dodo",
"dodu" => "dody",
"dodue" => "dody",
"dodues" => "dody",
"dodus" => "dody",
"dog-cart" => "dOgkaRt",
"dogaresse" => "dogaREs",
"dogaresses" => "dogaREs",
"doge" => "dOZ",
"doges" => "dOZ",
"dogger" => "dOg9R",
"dogmatique" => "dOgmatik",
"dogmatiques" => "dOgmatik",
"dogmatisme" => "dOgmatizm",
"dogme" => "dOgm",
"dogmes" => "dOgm",
"dogue" => "dOg",
"dogues" => "dOg",
"doguin" => "dog5",
"doigt" => "dwa",
"doigta" => "dwata",
"doigtait" => "dwatE",
"doigté" => "dwate",
"doigter" => "dwate",
"doigtier" => "dwatje",
"doigts" => "dwa",
"dois" => "dwa",
"doit" => "dwa",
"doive" => "dwav",
"doivent" => "dwav",
"doives" => "dwav",
"dojo" => "doZo",
"dol" => "dOl",
"dolby" => "dOlbi",
"dolce" => "dOltSe",
"dôle" => "dol",
"doléance" => "dole@s",
"doléances" => "dole@s",
"dolent" => "dOl@",
"dolente" => "dol@t",
"dolentes" => "dol@t",
"dolents" => "dol@",
"dolichocéphale" => "dolikosefal",
"dolichocéphales" => "dolikosefal",
"dolichocéphalie" => "dolikosefali",
"doline" => "dOlin",
"dolique" => "dOlik",
"dollar" => "dolaR",
"dollars" => "dolaR",
"dolman" => "dOlm@",
"dolmans" => "dOlm@",
"dolmen" => "dOlmEn",
"dolmens" => "dOlmEn",
"dolomies" => "dolomi",
"dolomite" => "dolomit",
"dolorisme" => "doloRizm",
"doloriste" => "doloRist",
"dom" => "d§",
"domaine" => "domEn",
"domaines" => "domEn",
"domanial" => "domanjal",
"domaniale" => "domanjal",
"domaniaux" => "domanjo",
"dôme" => "dom",
"dômes" => "dom",
"domestication" => "domEstikasj§",
"domesticité" => "domEstisite",
"domestiqua" => "domEstika",
"domestiquait" => "domEstikE",
"domestique" => "domEstik",
"domestiqué" => "domEstike",
"domestiquée" => "domEstike",
"domestiquées" => "domEstike",
"domestiquement" => "dOmEstik°m@",
"domestiquer" => "domEstike",
"domestiques" => "domEstik",
"domestiqués" => "domEstike",
"domestiquez" => "domEstike",
"domicile" => "domisil",
"domiciles" => "domisil",
"domiciliaires" => "domisiljER",
"domiciliation" => "domisiljasj§",
"domicilié" => "domisilje",
"domiciliée" => "domisilje",
"domicilier" => "domisilje",
"domiciliés" => "domisilje",
"domina" => "domina",
"dominaient" => "dominE",
"dominais" => "dominE",
"dominait" => "dominE",
"dominance" => "domin@s",
"dominant" => "domin@",
"dominante" => "domin@t",
"dominantes" => "domin@t",
"dominants" => "domin@",
"dominât" => "domina",
"dominateur" => "dominat9R",
"dominateurs" => "dominat9R",
"domination" => "dominasj§",
"dominations" => "dominasj§",
"dominatrice" => "dominatRis",
"dominatrices" => "dominatRis",
"domine" => "domin",
"dominé" => "domine",
"dominée" => "domine",
"dominées" => "domine",
"dominent" => "domin",
"dominer" => "domine",
"dominera" => "domin°Ra",
"dominerai" => "domin°RE",
"domineraient" => "domin°RE",
"dominerais" => "domin°RE",
"dominerait" => "domin°RE",
"domineras" => "domin°Ra",
"dominèrent" => "dominER",
"domineriez" => "domin°Rje",
"dominerions" => "domin°Rj§",
"dominerons" => "domin°R§",
"domineront" => "domin°R§",
"domines" => "domin",
"dominés" => "domine",
"dominez" => "domine",
"dominicain" => "dominik5",
"dominicaine" => "dominikEn",
"dominicaines" => "dominikEn",
"dominicains" => "dominik5",
"dominical" => "dominikal",
"dominicale" => "dominikal",
"dominicales" => "dominikal",
"dominicaux" => "dominiko",
"dominiez" => "dominje",
"dominion" => "dominjOn",
"dominions" => "dominj§",
"domino" => "domino",
"dominons" => "domin§",
"dominos" => "domino",
"dommage" => "domaZ",
"dommageable" => "domaZabl",
"dommageables" => "domaZabl",
"dommages" => "domaZ",
"dommages-intérêts" => "domaZze5teRE",
"domotique" => "domotik",
"dompta" => "d§pta",
"domptage" => "d§ptaZ",
"domptai" => "d§ptE",
"domptait" => "d§ptE",
"dompte" => "d§pt",
"dompté" => "d§pte",
"domptée" => "d§pte",
"domptées" => "d§pte",
"domptent" => "d§pt",
"dompter" => "d§pte",
"dompterai" => "d§pt°RE",
"dompterait" => "d§pt°RE",
"domptés" => "d§pte",
"dompteur" => "d§pt9R",
"dompteurs" => "d§pt9R",
"dompteuse" => "d§pt2z",
"dompteuses" => "d§pt2z",
"domptez" => "d§pte",
"don" => "d§",
"dona" => "dona",
"doña" => "dONa",
"donateur" => "donat9R",
"donateurs" => "donat9R",
"donation" => "donasj§",
"donations" => "donasj§",
"donatrice" => "donatRis",
"donc" => "d§k",
"dondaine" => "d§dEn",
"dondaines" => "d§dEn",
"dondon" => "d§d§",
"dondons" => "d§d§",
"dong" => "d§g",
"dôngs" => "d§g",
"donjon" => "d§Z§",
"donjons" => "d§Z§",
"donjuanesque" => "d§Z8anEsk",
"donjuanisme" => "d§Z8anizm",
"donna" => "dona",
"donnai" => "donE",
"donnaient" => "donE",
"donnais" => "donE",
"donnait" => "donE",
"donnâmes" => "donam",
"donnant" => "don@",
"donnant-donnant" => "don@don@",
"donnas" => "dona",
"donnassent" => "donas",
"donnât" => "dona",
"donne" => "dOn",
"donné" => "done",
"donnée" => "done",
"données" => "done",
"donnent" => "dOn",
"donner" => "done",
"donnera" => "dOn°Ra",
"donnerai" => "dOn°RE",
"donneraient" => "dOn°RE",
"donnerais" => "dOn°RE",
"donnerait" => "dOn°RE",
"donneras" => "dOn°Ra",
"donnèrent" => "donER",
"donnerez" => "dOn°Re",
"donneriez" => "don°Rje",
"donnerions" => "don°Rj§",
"donnerons" => "dOn°R§",
"donneront" => "dOn°R§",
"donnes" => "dOn",
"donnés" => "done",
"donneur" => "don9R",
"donneurs" => "don9R",
"donneuse" => "don2z",
"donneuses" => "don2z",
"donnez" => "done",
"donniez" => "donje",
"donnions" => "donj§",
"donnons" => "don§",
"donquichottesque" => "d§kiSOtEsk",
"donquichottesques" => "d§kiSOtEsk",
"donquichottisme" => "d§kiSOtizm",
"dons" => "d§",
"dont" => "d§",
"donzelle" => "d§zEl",
"donzelles" => "d§zEl",
"dopage" => "dopaZ",
"dopais" => "dopE",
"dopait" => "dopE",
"dopamine" => "dopamin",
"dopant" => "dOp@",
"dopants" => "dop@",
"dope" => "dOp",
"dopé" => "dope",
"dopée" => "dope",
"doper" => "dope",
"dopes" => "dOp",
"dopés" => "dope",
"dopez" => "dope",
"doping" => "dOpiG",
"doppler" => "dOplER",
"dora" => "doRa",
"dorade" => "doRad",
"dorades" => "doRad",
"dorage" => "doRaZ",
"doraient" => "doRE",
"dorais" => "doRE",
"dorait" => "doRE",
"dorant" => "doR@",
"dorcades" => "doRkad",
"dore" => "dOR",
"doré" => "doRe",
"dorée" => "doRe",
"dorées" => "doRe",
"dorénavant" => "doRenav@",
"dorent" => "dOR",
"dorer" => "doRe",
"dorera" => "dOR°Ra",
"doreront" => "dOR°R§",
"dorés" => "doRe",
"doreurs" => "doR9R",
"doriennes" => "doRjEn",
"doriens" => "doRj5",
"dorique" => "doRik",
"doriques" => "doRik",
"dorlotait" => "dORlotE",
"dorlotant" => "dORlot@",
"dorlote" => "dORlOt",
"dorloté" => "dORlote",
"dorlotée" => "dORlote",
"dorlotées" => "dORlote",
"dorlotent" => "dORlOt",
"dorloter" => "dORlote",
"dorloterai" => "dORlOt°RE",
"dorloterons" => "dORlOt°R§",
"dorlotés" => "dORlote",
"dorlotez" => "dORlote",
"dormaient" => "dORmE",
"dormais" => "dORmE",
"dormait" => "dORmE",
"dormance" => "dORm@s",
"dormant" => "dORm@",
"dormante" => "dORm@t",
"dormantes" => "dORm@t",
"dormants" => "dORm@",
"dorme" => "dORm",
"dorment" => "dORm",
"dormes" => "dORm",
"dormeur" => "dORm9R",
"dormeurs" => "dORm9R",
"dormeuse" => "dORm2z",
"dormeuses" => "dORm2z",
"dormez" => "dORme",
"dormi" => "dORmi",
"dormiez" => "dORmje",
"dormîmes" => "dORmim",
"dormions" => "dORmj§",
"dormir" => "dORmiR",
"dormira" => "dORmiRa",
"dormirai" => "dORmiRE",
"dormiraient" => "dORmiRE",
"dormirais" => "dORmiRE",
"dormirait" => "dORmiRE",
"dormiras" => "dORmiRa",
"dormirent" => "dORmiR",
"dormirez" => "dORmiRe",
"dormiriez" => "dORmiRje",
"dormirions" => "dORmiRj§",
"dormirons" => "dORmiR§",
"dormiront" => "dORmiR§",
"dormis" => "dORmi",
"dormit" => "dORmi",
"dormît" => "dORmi",
"dormitif" => "dORmitif",
"dormition" => "dORmisj§",
"dormons" => "dORm§",
"dors" => "dOR",
"dorsal" => "dORsal",
"dorsale" => "dORsal",
"dorsales" => "dORsal",
"dorsaux" => "dORso",
"dort" => "dOR",
"dortoir" => "dORtwaR",
"dortoirs" => "dORtwaR",
"dorure" => "dORyR",
"dorures" => "dORyR",
"doryphore" => "doRifOR",
"doryphores" => "doRifOR",
"dos" => "do",
"dos-d'âne" => "dodan",
"dosage" => "dozaZ",
"dosages" => "dozaZ",
"dosaient" => "dozE",
"dosais" => "dozE",
"dosait" => "dozE",
"dosant" => "doz@",
"dose" => "doz",
"dosé" => "doze",
"dosée" => "doze",
"dosées" => "doze",
"dosent" => "doz",
"doser" => "doze",
"doses" => "doz",
"dosés" => "doze",
"doseur" => "doz9R",
"doseurs" => "doz9R",
"dosimètre" => "dozimEtR",
"dossard" => "dosaR",
"dossards" => "dosaR",
"dosseret" => "dos°RE",
"dossier" => "dosje",
"dossière" => "dosjER",
"dossières" => "dosjER",
"dossiers" => "dosje",
"dostoïevskiens" => "dOstojEvskj5",
"dot" => "dOt",
"dota" => "dota",
"dotaient" => "dotE",
"dotait" => "dotE",
"dotant" => "dot@",
"dotation" => "dotasj§",
"dote" => "dOt",
"doté" => "dote",
"dotée" => "dote",
"dotées" => "dote",
"doter" => "dote",
"dotés" => "dote",
"dots" => "dOt",
"douaire" => "dwER",
"douairière" => "dwERjER",
"douairières" => "dwERjER",
"douait" => "dwE",
"douane" => "dwan",
"douanes" => "dwan",
"douanier" => "dwanje",
"douanière" => "dwanjER",
"douanières" => "dwanjER",
"douaniers" => "dwanje",
"douar" => "dwaR",
"douars" => "dwaR",
"doubla" => "dubla",
"doublage" => "dublaZ",
"doublages" => "dublaZ",
"doublai" => "dublE",
"doublaient" => "dublE",
"doublais" => "dublE",
"doublait" => "dublE",
"doublant" => "dubl@",
"doublard" => "dublaR",
"doublards" => "dublaR",
"doublât" => "dubla",
"double" => "dubl",
"doublé" => "duble",
"double-cliqué" => "dubl°klike",
"double-cliquer" => "dubl2klike",
"double-croche" => "dubl2kROS",
"double-décimètre" => "dubl°desimEtR",
"double-fond" => "dubl2f§",
"double-six" => "dubl2sis",
"doubleau" => "dublo",
"doubleaux" => "dublo",
"doublée" => "duble",
"doublées" => "duble",
"doublement" => "dubl°m@",
"doublent" => "dubl",
"doubler" => "duble",
"doublera" => "dubl°Ra",
"doublerai" => "dubl°RE",
"doubleraient" => "dubl°RE",
"doublerait" => "dubl°RE",
"doublèrent" => "dublER",
"doublerez" => "dubl°Re",
"doublerons" => "dubl°R§",
"doubles" => "dubl",
"doublés" => "duble",
"doublet" => "dublE",
"doublets" => "dublE",
"doublette" => "dublEt",
"doubleur" => "dubl9R",
"doubleuse" => "dubl2z",
"doubleuses" => "dubl2z",
"doublez" => "duble",
"doubliez" => "dublie",
"doublions" => "dublij§",
"doublon" => "dubl§",
"doublonner" => "dublone",
"doublons" => "dubl§",
"doublure" => "dublyR",
"doublures" => "dublyR",
"douçâtre" => "dusatR",
"douce" => "dus",
"douce-amère" => "dusamER",
"douceâtre" => "dusatR",
"douceâtres" => "dusatR",
"doucement" => "dus°m@",
"doucereuse" => "dus°R2z",
"doucereusement" => "dus°R2z°m@",
"doucereuses" => "dus°R2z",
"doucereux" => "dus°R2",
"douces" => "dus",
"douces-amères" => "dusamER",
"doucet" => "dusE",
"doucette" => "dusEt",
"doucettement" => "dusEt°m@",
"douceur" => "dus9R",
"douceurs" => "dus9R",
"doucha" => "duSa",
"douchais" => "duSE",
"douchait" => "duSE",
"douchant" => "duS@",
"douche" => "duS",
"douché" => "duSe",
"douchée" => "duSe",
"douchent" => "duS",
"doucher" => "duSe",
"douchera" => "duS°Ra",
"doucherai" => "duS°RE",
"doucheras" => "duS°Ra",
"douches" => "duS",
"douchés" => "duSe",
"doucheur" => "duS9R",
"douchez" => "duSe",
"douchiez" => "duSje",
"douchons" => "duS§",
"doucie" => "dusi",
"doucin" => "dus5",
"doucine" => "dusin",
"doucins" => "dus5",
"doudou" => "dudu",
"doudoune" => "dudun",
"doudounes" => "dudun",
"doué" => "dwe",
"douée" => "dwe",
"douées" => "dwe",
"douelle" => "dwEl",
"douelles" => "dwEl",
"douer" => "dwe",
"doués" => "dwe",
"douglas" => "dugla",
"douillait" => "dujE",
"douille" => "duj",
"douillé" => "duje",
"douillée" => "duje",
"douillent" => "duj",
"douiller" => "duje",
"douillera" => "duj°Ra",
"douilles" => "duj",
"douillet" => "dujE",
"douillets" => "dujE",
"douillette" => "dujEt",
"douillettement" => "dujEt°m@",
"douillettes" => "dujEt",
"douillons" => "duj§",
"douleur" => "dul9R",
"douleurs" => "dul9R",
"douloureuse" => "duluR2z",
"douloureusement" => "duluR2z°m@",
"douloureuses" => "duluR2z",
"douloureux" => "duluR2",
"douma" => "duma",
"doura" => "duRa",
"douro" => "duRo",
"douros" => "duRo",
"douta" => "duta",
"doutai" => "dutE",
"doutaient" => "dutE",
"doutais" => "dutE",
"doutait" => "dutE",
"doutance" => "dut@s",
"doutances" => "dut@s",
"doutant" => "dut@",
"doutât" => "duta",
"doute" => "dut",
"douté" => "dute",
"doutée" => "dute",
"doutent" => "dut",
"douter" => "dute",
"doutera" => "dut°Ra",
"douterai" => "dut°RE",
"douterais" => "dut°RE",
"douterait" => "dut°RE",
"douteras" => "dut°Ra",
"doutèrent" => "dutER",
"douterez" => "dut°Re",
"douteriez" => "dut°Rje",
"douteront" => "dut°R§",
"doutes" => "dut",
"doutés" => "dute",
"douteurs" => "dut9R",
"douteuse" => "dut2z",
"douteusement" => "dut2z°m@",
"douteuses" => "dut2z",
"douteux" => "dut2",
"doutez" => "dute",
"doutiez" => "dutje",
"doutions" => "dutj§",
"doutons" => "dut§",
"douve" => "duv",
"douves" => "duv",
"doux" => "du",
"doux-amer" => "duamER",
"douzaine" => "duzEn",
"douzaines" => "duzEn",
"douze" => "duz",
"douzième" => "duzjEm",
"douzièmes" => "duzjEm",
"down" => "dawn",
"downing street" => "dawniGstRit",
"doyen" => "dwaj5",
"doyenne" => "dwajEn",
"doyenné" => "dwajEne",
"doyens" => "dwaj5",
"drache" => "dRaS",
"drachme" => "dRakm",
"drachmes" => "dRakm",
"draconien" => "dRakonj5",
"draconienne" => "dRakonjEn",
"draconiennes" => "dRakonjEn",
"draconiens" => "dRakonj5",
"drag" => "dRag",
"dragage" => "dRagaZ",
"dragée" => "dRaZe",
"dragées" => "dRaZe",
"drageoir" => "dRaZwaR",
"drageoirs" => "dRaZwaR",
"dragon" => "dRag§",
"dragonnades" => "dRagonad",
"dragonne" => "dRagOn",
"dragonnier" => "dRagOnje",
"dragons" => "dRag§",
"drags" => "dRag",
"dragster" => "dRagstER",
"dragua" => "dRaga",
"draguaient" => "dRagE",
"draguais" => "dRagE",
"draguait" => "dRagE",
"draguant" => "dRag@",
"drague" => "dRag",
"dragué" => "dRage",
"draguée" => "dRage",
"draguées" => "dRage",
"draguent" => "dRag",
"draguer" => "dRage",
"draguera" => "dRag°Ra",
"draguerai" => "dRag°RE",
"draguerais" => "dRag°RE",
"draguerait" => "dRag°RE",
"dragues" => "dRag",
"dragués" => "dRage",
"dragueur" => "dRag9R",
"dragueurs" => "dRag9R",
"dragueuse" => "dRag2z",
"draguez" => "dRage",
"draguiez" => "dRagje",
"draguons" => "dRag§",
"drailles" => "dRaj",
"drain" => "dR5",
"draina" => "dREna",
"drainage" => "dREnaZ",
"drainages" => "dREnaZ",
"drainaient" => "dREnE",
"drainait" => "dREnE",
"drainant" => "dREn@",
"draine" => "dREn",
"drainé" => "dREne",
"drainées" => "dREne",
"drainent" => "dREn",
"drainer" => "dRene",
"drainera" => "dREn°Ra",
"drainés" => "dREne",
"drainons" => "dREn§",
"drains" => "dR5",
"draisienne" => "dREzjEn",
"draisine" => "dREzin",
"drakkar" => "dRakaR",
"drakkars" => "dRakaR",
"dramatique" => "dRamatik",
"dramatiquement" => "dRamatik°m@",
"dramatiques" => "dRamatik",
"dramatisait" => "dRamatizE",
"dramatisant" => "dRamatiz@",
"dramatisation" => "dRamatizasj§",
"dramatise" => "dRamatiz",
"dramatisé" => "dRamatize",
"dramatisée" => "dRamatize",
"dramatisent" => "dRamatiz",
"dramatiser" => "dRamatize",
"dramatises" => "dRamatiz",
"dramatisés" => "dRamatize",
"dramatisez" => "dRamatize",
"dramatisons" => "dRamatiz§",
"dramaturge" => "dRamatyRZ",
"dramaturges" => "dRamatyRZ",
"dramaturgie" => "dRamatyRZi",
"drame" => "dRam",
"drames" => "dRam",
"drap" => "dRa",
"drapa" => "dRapa",
"drapai" => "dRapE",
"drapaient" => "dRapE",
"drapait" => "dRapE",
"drapant" => "dRap@",
"drape" => "dRap",
"drapé" => "dRape",
"drapeau" => "dRapo",
"drapeaux" => "dRapo",
"drapée" => "dRape",
"drapées" => "dRape",
"drapelets" => "dRap°lE",
"drapent" => "dRap",
"draper" => "dRape",
"draperaient" => "dRap°RE",
"drapèrent" => "dRapER",
"draperez" => "dRap°Re",
"draperie" => "dRap°Ri",
"draperies" => "dRap°Ri",
"drapés" => "dRape",
"drapier" => "dRapje",
"drapiers" => "dRapje",
"draps" => "dRa",
"drastique" => "dRastik",
"drastiquement" => "dRastik°m@",
"drastiques" => "dRastik",
"drave" => "dRav",
"draveurs" => "dRav9R",
"dreadlocks" => "dREdlOk",
"dream team" => "dRimtim",
"drège" => "dREZ",
"drelin" => "dR2l5",
"drépanocytose" => "dRepanOsitoz",
"drepou" => "dREpu",
"dressa" => "dREsa",
"dressage" => "dREsaZ",
"dressages" => "dREsaZ",
"dressai" => "dREsE",
"dressaient" => "dREsE",
"dressais" => "dREsE",
"dressait" => "dREsE",
"dressant" => "dREs@",
"dressât" => "dREsa",
"dresse" => "dREs",
"dressé" => "dRese",
"dressée" => "dRese",
"dressées" => "dRese",
"dressement" => "dREs°m@",
"dressent" => "dREs",
"dresser" => "dRese",
"dressera" => "dREs°Ra",
"dresserai" => "dREs°RE",
"dresseraient" => "dREs°RE",
"dresserait" => "dREs°RE",
"dresseras" => "dREs°Ra",
"dressèrent" => "dREsER",
"dresserons" => "dREs°R§",
"dresseront" => "dREs°R§",
"dresses" => "dREs",
"dressés" => "dRese",
"dresseur" => "dREs9R",
"dresseurs" => "dREs9R",
"dresseuse" => "dREs2z",
"dressez" => "dREse",
"dressing" => "dResiG",
"dressing-room" => "dResiGRum",
"dressions" => "dREsj§",
"dressoir" => "dREswaR",
"dressoirs" => "dREswaR",
"dressons" => "dREs§",
"dreyfusard" => "dREfyzaR",
"dreyfusards" => "dREfyzaR",
"dreyfusisme" => "dREfyzizm",
"dribbla" => "dRibla",
"dribblais" => "dRiblE",
"dribblait" => "dRiblE",
"dribble" => "dRibl",
"dribblé" => "dRible",
"dribbler" => "dRible",
"dribbles" => "dRibl",
"dribbleur" => "dRibl9R",
"dribblez" => "dRible",
"drible" => "dRibl",
"dribler" => "dRible",
"drift" => "dRift",
"drifter" => "dRift9R",
"drifters" => "dRift9R",
"drill" => "dRil",
"drille" => "dRij",
"drilles" => "dRij",
"dring" => "dRiG",
"drink" => "dR5k",
"drinks" => "dR5k",
"drisse" => "dRis",
"drisses" => "dRis",
"drivait" => "dRajvE",
"drivant" => "dRajv@",
"drive" => "dRajv",
"drivé" => "dRajve",
"drive-in" => "dRajvin",
"drivée" => "dRajve",
"driver" => "dRajv9R",
"drivers" => "dRajv9R",
"drives" => "dRiv",
"drogman" => "dROgman",
"drogmans" => "dROgman",
"droguaient" => "dRogE",
"droguais" => "dRogE",
"droguait" => "dRogE",
"droguant" => "dROg@",
"drogue" => "dROg",
"drogué" => "dRoge",
"droguée" => "dRoge",
"droguées" => "dRoge",
"droguent" => "dROg",
"droguer" => "dRoge",
"droguerie" => "dROg°Ri",
"drogueries" => "dROg°Ri",
"drogues" => "dROg",
"drogués" => "dRoge",
"droguet" => "dRogE",
"droguets" => "dRogE",
"droguez" => "dRoge",
"droguiez" => "dRogje",
"droguiste" => "dRogist",
"droguistes" => "dRogist",
"droicos" => "dRoiko",
"droit" => "dRwa",
"droit-fil" => "dRwafil",
"droite" => "dRwat",
"droitement" => "dRwat°m@",
"droites" => "dRwat",
"droitier" => "dRwatje",
"droitière" => "dRwatjER",
"droitiers" => "dRwatje",
"droits" => "dRwa",
"droiture" => "dRwatyR",
"drolatique" => "dRolatik",
"drolatiques" => "dRolatik",
"drôle" => "dRol",
"drôlement" => "dRol°m@",
"drôlerie" => "dRol°Ri",
"drôleries" => "dRol°Ri",
"drôles" => "dRol",
"drôlesse" => "dRolEs",
"drôlesses" => "dRolEs",
"drôlet" => "dRolE",
"drôlette" => "dRolEt",
"dromadaire" => "dRomadER",
"dromadaires" => "dRomadER",
"drome" => "dRom",
"dromes" => "dRom",
"drone" => "dRon",
"drone-espion" => "dRonEspj§",
"drones" => "dRon",
"dronte" => "dR§t",
"drop" => "dROp",
"drope" => "dROp",
"dropé" => "dRope",
"dropent" => "dROp",
"droppage" => "dRopaZ",
"droppant" => "dRop@",
"droppe" => "dROp",
"droséra" => "dRozeRa",
"drosophile" => "dRozofil",
"drosophiles" => "dRozofil",
"dross" => "dROs",
"drossait" => "dRosE",
"drossant" => "dRos@",
"drossart" => "dRosaR",
"drossé" => "dRose",
"drossée" => "dRose",
"drosser" => "dRose",
"drossés" => "dRose",
"dru" => "dRy",
"drue" => "dRy",
"drues" => "dRy",
"drugstore" => "dR9gstOR",
"drugstores" => "dR9gstOR",
"druide" => "dR8id",
"druides" => "dR8id",
"druidesse" => "dR8idEs",
"druidesses" => "dR8idEs",
"druidique" => "dR8idik",
"druidiques" => "dR8idik",
"druidisme" => "dR8idizm",
"drumlin" => "dR9mlin",
"drummer" => "dR9m9R",
"drums" => "dR9m",
"drus" => "dRy",
"druze" => "dRyz",
"druzes" => "dRyz",
"dry" => "dRaj",
"dryade" => "dRijad",
"dryades" => "dRijad",
"du" => "dy",
"dû" => "dy",
"dual" => "d8al",
"dualisme" => "d8alizm",
"dualiste" => "d8alist",
"dualité" => "d8alite",
"dubitatif" => "dybitatif",
"dubitatifs" => "dybitatif",
"dubitation" => "dybitasj§",
"dubitations" => "dybitasj§",
"dubitative" => "dybitativ",
"dubitativement" => "dybitativ°m@",
"dubitatives" => "dybitativ",
"duc" => "dyk",
"ducal" => "dykal",
"ducale" => "dykal",
"ducales" => "dykal",
"ducasse" => "dykas",
"ducasses" => "dykas",
"ducat" => "dyka",
"ducaton" => "dykat§",
"ducats" => "dyka",
"ducaux" => "dyko",
"duce" => "dutSe",
"duces" => "dutSe",
"duché" => "dySe",
"duchesse" => "dySEs",
"duchesses" => "dySEs",
"duchnoque" => "dySnOk",
"ducon" => "dyk§",
"ducs" => "dyk",
"ducs-d'albe" => "dykdalbe",
"ductile" => "dyktil",
"dudit" => "dydit",
"due" => "dy",
"duègne" => "d8EN",
"duel" => "d8El",
"duelliste" => "d8Elist",
"duellistes" => "d8Elist",
"duels" => "d8El",
"dues" => "dy",
"duettistes" => "dyEtist",
"duffel-coat" => "d9f9lkOwt",
"duffle-coat" => "d9f9lkOwt",
"duffle-coats" => "d9f9lkOwt",
"dugong" => "dyg§",
"dugongs" => "dyg§g",
"duit" => "d8i",
"dulcifiant" => "dylsifj@",
"dulcinée" => "dylsine",
"dum-dum" => "dumdum",
"dûment" => "dym@",
"dûmes" => "dym",
"dumper" => "d9mp9R",
"dumping" => "d9mpiG",
"dundee" => "d9ndi",
"dune" => "dyn",
"dunes" => "dyn",
"dunette" => "dynEt",
"dunettes" => "dynEt",
"dunkerque" => "d1kERk",
"duo" => "d8o",
"duodécimale" => "d8odesimal",
"duodénal" => "d8Odenal",
"duodénale" => "d8odenal",
"duodénum" => "d8odenOm",
"duodi" => "d8odi",
"duopole" => "d8OpOl",
"duos" => "d8o",
"dupait" => "dypE",
"dupant" => "dyp@",
"dupe" => "dyp",
"dupé" => "dype",
"dupée" => "dype",
"dupent" => "dyp",
"duper" => "dype",
"dupera" => "dyp°Ra",
"duperas" => "dyp°Ra",
"duperie" => "dyp°Ri",
"duperies" => "dyp°Ri",
"dupes" => "dyp",
"dupés" => "dype",
"dupeur" => "dyp9R",
"dupez" => "dype",
"duplex" => "dyplEks",
"duplicata" => "dyplikata",
"duplicate" => "dyplikat",
"duplicateur" => "dyplikat9R",
"duplicateurs" => "dyplikat9R",
"duplication" => "dyplikasj§",
"duplice" => "dyplis",
"duplicité" => "dyplisite",
"dupliqué" => "dyplike",
"dupliquer" => "dyplike",
"dupliqués" => "dyplike",
"dupons" => "dyp§",
"duquel" => "dykEl",
"dur" => "dyR",
"dura" => "dyRa",
"durabilité" => "dyRabilite",
"durable" => "dyRabl",
"durablement" => "dyRabl°m@",
"durables" => "dyRabl",
"duraient" => "dyRE",
"duraille" => "dyRaj",
"durailles" => "dyRaj",
"durait" => "dyRE",
"durale" => "dyRal",
"duralumin" => "dyRalym5",
"durant" => "dyR@",
"durassent" => "dyRas",
"durât" => "dyRa",
"durci" => "dyRsi",
"durcie" => "dyRsi",
"durcies" => "dyRsi",
"durcir" => "dyRsiR",
"durciraient" => "dyRsiRE",
"durcirent" => "dyRsiR",
"durcis" => "dyRsi",
"durcissaient" => "dyRsisE",
"durcissais" => "dyRsisE",
"durcissait" => "dyRsisE",
"durcissant" => "dyRsis@",
"durcisse" => "dyRsis",
"durcissement" => "dyRsis°m@",
"durcissent" => "dyRsis",
"durcisseur" => "dyRsis9R",
"durcit" => "dyRsi",
"dure" => "dyR",
"duré" => "dyRe",
"dure-mère" => "dyRmER",
"durée" => "dyRe",
"durées" => "dyRe",
"durement" => "dyR°m@",
"durent" => "dyR",
"durer" => "dyRe",
"durera" => "dyR°Ra",
"durerai" => "dyR°RE",
"dureraient" => "dyR°RE",
"durerais" => "dyR°RE",
"durerait" => "dyR°RE",
"dureras" => "dyR°Ra",
"durèrent" => "dyRER",
"durerez" => "dyR°Re",
"dureront" => "dyR°R§",
"dures" => "dyR",
"dureté" => "dyR°te",
"duretés" => "dyR°te",
"durham" => "dyRam",
"durian" => "dyRj@",
"durillon" => "dyRij§",
"durillons" => "dyRij§",
"durit" => "dyRit",
"durite" => "dyRit",
"durites" => "dyRit",
"durs" => "dyR",
"dus" => "dy",
"dusse" => "dys",
"dussent" => "dys",
"dusses" => "dys",
"dussiez" => "dysje",
"dussions" => "dysj§",
"dut" => "dy",
"dût" => "dy",
"duvet" => "dyvE",
"duveté" => "dyv°te",
"duvetée" => "dyv°te",
"duvetées" => "dyv°te",
"duvetés" => "dyv°te",
"duveteuse" => "dyv°t2z",
"duveteuses" => "dyv°t2z",
"duveteux" => "dyv°t2",
"duvets" => "dyvE",
"dyke" => "dik",
"dykes" => "dik",
"dynamique" => "dinamik",
"dynamiques" => "dinamik",
"dynamisé" => "dinamize",
"dynamisée" => "dinamize",
"dynamisées" => "dinamize",
"dynamiser" => "dinamize",
"dynamisera" => "dinamiz°Ra",
"dynamiserait" => "dinamiz°RE",
"dynamisez" => "dinamize",
"dynamisme" => "dinamizm",
"dynamitage" => "dinamitaZ",
"dynamitait" => "dinamitE",
"dynamitant" => "dinamit@",
"dynamite" => "dinamit",
"dynamité" => "dinamite",
"dynamitée" => "dinamite",
"dynamiter" => "dinamite",
"dynamiteur" => "dinamit9R",
"dynamiteurs" => "dinamit9R",
"dynamitez" => "dinamite",
"dynamitons" => "dinamit§",
"dynamo" => "dinamo",
"dynamomètre" => "dinamomEtR",
"dynamométrique" => "dinamometRik",
"dynamos" => "dinamo",
"dynastie" => "dinasti",
"dynasties" => "dinasti",
"dynastique" => "dinastik",
"dynes" => "din",
"dyscinésie" => "disinezi",
"dyscrasie" => "diskRazi",
"dysenterie" => "dis@t°Ri",
"dysenteries" => "dis@t°Ri",
"dysentérique" => "dis@teRik",
"dysentériques" => "dis@teRik",
"dysfonction" => "disf§ksj§",
"dysfonctionnement" => "disf§ksjOn°m@",
"dysfonctionnements" => "disf§ksjOn°m@",
"dyslexie" => "dislEksi",
"dyslexique" => "dislEksik",
"dysménorrhée" => "dismenORe",
"dyspepsie" => "dispEpsi",
"dyspepsique" => "dispEpsik",
"dyspeptique" => "dispEptik",
"dysphonie" => "disfOni",
"dysphorie" => "disfoRi",
"dysplasie" => "displazi",
"dyspnée" => "dispne",
"dyspnéique" => "dispneik",
"dyspnéiques" => "dispneik",
"dysthymie" => "distimi",
"dystocie" => "distOsi",
"dystrophie" => "distROfi",
"dysurie" => "dizyRi",
"dytique" => "ditik",
"e" => "2",
"é" => "e",
"e-commerce" => "ikomERs",
"e-mail" => "imEjl",
"e-mails" => "imEjl",
"east river" => "istRiv9R",
"eau" => "o",
"eau-de-vie" => "od°vi",
"eau-forte" => "ofORt",
"eau-minute" => "ominyt",
"eaux" => "o",
"eaux-de-vie" => "od°vi",
"eaux-fortes" => "ofORt",
"ébahi" => "ebai",
"ébahie" => "ebai",
"ébahies" => "ebai",
"ébahir" => "ebaiR",
"ébahirons" => "ebaiR§",
"ébahis" => "ebai",
"ébahissait" => "ebaisE",
"ébahissant" => "ebais@",
"ébahissement" => "ebais°m@",
"ébahissent" => "ebais",
"ébahissons" => "ebais§",
"ébahit" => "ebai",
"ébarbage" => "ebaRbaZ",
"ébarbait" => "ebaRbE",
"ébarbé" => "ebaRbe",
"ébarber" => "ebaRbe",
"ébat" => "eba",
"ébats" => "eba",
"ébattaient" => "ebatE",
"ébattait" => "ebatE",
"ébattant" => "ebat@",
"ébattements" => "ebat°m@",
"ébattent" => "ebat",
"ébattit" => "ebati",
"ébattît" => "ebati",
"ébattons" => "ebat§",
"ébattre" => "ebatR",
"ébaubi" => "ebobi",
"ébaubie" => "ebobi",
"ébaubis" => "ebobi",
"ébaubissaient" => "ebobisE",
"ébaucha" => "eboSa",
"ébauchai" => "eboSE",
"ébauchaient" => "eboSE",
"ébauchais" => "eboSE",
"ébauchait" => "eboSE",
"ébauchant" => "eboS@",
"ébauchât" => "eboSa",
"ébauche" => "eboS",
"ébauché" => "eboSe",
"ébauchée" => "eboSe",
"ébauchées" => "eboSe",
"ébauchent" => "eboS",
"ébaucher" => "eboSe",
"ébauchèrent" => "eboSER",
"ébauches" => "eboS",
"ébauchés" => "eboSe",
"ébaucheurs" => "eboS9R",
"ébauchons" => "eboS§",
"ébaudi" => "ebodi",
"ébène" => "ebEn",
"ébéniste" => "ebenist",
"ébénisterie" => "ebenist°Ri",
"ébénisteries" => "ebenist°Ri",
"ébénistes" => "ebenist",
"éberlua" => "ebERl8a",
"éberluait" => "ebERl8E",
"éberlue" => "ebERly",
"éberlué" => "ebERl8e",
"éberluée" => "ebERl8e",
"éberluées" => "ebERlye",
"éberluer" => "ebERl8e",
"éberlués" => "ebERlye",
"ébloui" => "eblui",
"éblouie" => "eblui",
"éblouies" => "eblui",
"éblouir" => "ebluiR",
"éblouira" => "ebluiRa",
"éblouirai" => "ebluiRE",
"éblouirait" => "ebluiRE",
"éblouirent" => "ebluiR",
"éblouirez" => "ebluiRe",
"éblouis" => "eblui",
"éblouissaient" => "ebluisE",
"éblouissait" => "ebluisE",
"éblouissant" => "ebluis@",
"éblouissante" => "ebluis@t",
"éblouissantes" => "ebluis@t",
"éblouissants" => "ebluis@",
"éblouisse" => "ebluis",
"éblouissement" => "ebluis°m@",
"éblouissements" => "ebluis°m@",
"éblouissent" => "ebluis",
"éblouisses" => "ebluis",
"éblouissez" => "ebluise",
"éblouissions" => "ebluisj§",
"éblouit" => "eblui",
"ébonite" => "ebonit",
"éborgna" => "ebORNa",
"éborgne" => "ebORN",
"éborgné" => "ebORNe",
"éborgner" => "ebORNe",
"éboué" => "ebwe",
"éboueur" => "ebw9R",
"éboueurs" => "ebw9R",
"ébouillanta" => "ebuj@ta",
"ébouillante" => "ebuj@t",
"ébouillanté" => "ebuj@te",
"ébouillantée" => "ebuj@te",
"ébouillantées" => "ebuj@te",
"ébouillanter" => "ebuj@te",
"ébouillantés" => "ebuj@te",
"éboula" => "ebula",
"éboulaient" => "ebulE",
"éboulait" => "ebulE",
"éboulant" => "ebul@",
"éboule" => "ebul",
"éboulé" => "ebule",
"éboulée" => "ebule",
"éboulées" => "ebule",
"éboulement" => "ebul°m@",
"éboulements" => "ebul°m@",
"éboulent" => "ebul",
"ébouler" => "ebule",
"éboulèrent" => "ebulER",
"éboulés" => "ebule",
"ébouleuses" => "ebul2z",
"éboulis" => "ebuli",
"ébouriffa" => "ebuRifa",
"ébouriffaient" => "ebuRifE",
"ébouriffait" => "ebuRifE",
"ébouriffant" => "ebuRif@",
"ébouriffante" => "ebuRif@t",
"ébouriffe" => "ebuRif",
"ébouriffé" => "ebuRife",
"ébouriffée" => "ebuRife",
"ébouriffées" => "ebuRife",
"ébouriffent" => "ebuRif",
"ébouriffer" => "ebuRife",
"ébouriffés" => "ebuRife",
"ébouser" => "ebuze",
"ébouzé" => "ebuze",
"ébouzer" => "ebuze",
"ébrancha" => "ebR@Sa",
"ébranchait" => "ebR@SE",
"ébranchant" => "ebR@S@",
"ébranché" => "ebR@Se",
"ébranchement" => "ebR@S°m@",
"ébrancher" => "ebR@Se",
"ébrancherez" => "ebR@S°Re",
"ébranchés" => "ebR@Se",
"ébranla" => "ebR@la",
"ébranlaient" => "ebR@lE",
"ébranlait" => "ebR@lE",
"ébranlant" => "ebR@l@",
"ébranlât" => "ebR@la",
"ébranle" => "ebR@l",
"ébranlé" => "ebR@le",
"ébranlée" => "ebR@le",
"ébranlées" => "ebR@le",
"ébranlement" => "ebR@l°m@",
"ébranlements" => "ebR@l°m@",
"ébranlent" => "ebR@l",
"ébranler" => "ebR@le",
"ébranlera" => "ebR@l°Ra",
"ébranlerai" => "ebR@l°RE",
"ébranleraient" => "ebR@l°RE",
"ébranlerais" => "ebR@l°RE",
"ébranlerait" => "ebR@l°RE",
"ébranlèrent" => "ebR@lER",
"ébranlés" => "ebR@le",
"ébréchaient" => "ebReSE",
"ébrèche" => "ebRES",
"ébréché" => "ebReSe",
"ébréchée" => "ebReSe",
"ébréchées" => "ebReSe",
"ébrécher" => "ebReSe",
"ébréchés" => "ebReSe",
"ébréchure" => "ebReSyR",
"ébréchures" => "ebReSyR",
"ébriété" => "ebRijete",
"ébroua" => "ebRua",
"ébrouaient" => "ebRuE",
"ébrouais" => "ebRuE",
"ébrouait" => "ebRuE",
"ébrouant" => "ebRu@",
"ébroue" => "ebRu",
"ébroué" => "ebRue",
"ébrouement" => "ebRum@",
"ébrouent" => "ebRu",
"ébrouer" => "ebRue",
"ébrouèrent" => "ebRuER",
"ébruita" => "ebR8ita",
"ébruitât" => "ebR8ita",
"ébruite" => "ebR8it",
"ébruité" => "ebR8ite",
"ébruitée" => "ebR8ite",
"ébruitent" => "ebR8it",
"ébruiter" => "ebR8ite",
"ébruitera" => "ebR8it°Ra",
"ébruiterait" => "ebR8it°RE",
"ébruitez" => "ebR8ite",
"ébruitons" => "ebR8it§",
"ébullition" => "ebylisj§",
"écaillage" => "ekajaZ",
"écaillaient" => "ekajE",
"écaillait" => "ekajE",
"écaillant" => "ekaj@",
"écaille" => "ekaj",
"écaillé" => "ekaje",
"écaillée" => "ekaje",
"écaillées" => "ekaje",
"écaillent" => "ekaj",
"écailler" => "ekaje",
"écaillera" => "ekaj°Ra",
"écaillerai" => "ekaj°RE",
"écaillère" => "ekajER",
"écaillers" => "ekaje",
"écailles" => "ekaj",
"écaillés" => "ekaje",
"écailleur" => "ekaj9R",
"écailleuse" => "ekaj2z",
"écailleuses" => "ekaj2z",
"écailleux" => "ekaj2",
"écaillure" => "ekajyR",
"écaillures" => "ekajyR",
"écalait" => "ekalE",
"écale" => "ekal",
"écaler" => "ekale",
"écales" => "ekal",
"écarlate" => "ekaRlat",
"écarlates" => "ekaRlat",
"écarquilla" => "ekaRkija",
"écarquillai" => "ekaRkijE",
"écarquillaient" => "ekaRkijE",
"écarquillais" => "ekaRkijE",
"écarquillait" => "ekaRkijE",
"écarquillant" => "ekaRkij@",
"écarquille" => "ekaRkij",
"écarquillé" => "ekaRkije",
"écarquillée" => "ekaRkije",
"écarquillées" => "ekaRkije",
"écarquillement" => "ekaRkij°m@",
"écarquillent" => "ekaRkij",
"écarquiller" => "ekaRkije",
"écarquillèrent" => "ekaRkijER",
"écarquillés" => "ekaRkije",
"écarquillez" => "ekaRkije",
"écarquillions" => "ekaRkijj§",
"écart" => "ekaR",
"écarta" => "ekaRta",
"écartai" => "ekaRtE",
"écartaient" => "ekaRtE",
"écartais" => "ekaRtE",
"écartait" => "ekaRtE",
"écartâmes" => "ekaRtam",
"écartant" => "ekaRt@",
"écartât" => "ekaRta",
"écarte" => "ekaRt",
"écarté" => "ekaRte",
"écartée" => "ekaRte",
"écartées" => "ekaRte",
"écartela" => "ekaRt°la",
"écartelaient" => "ekaRt°lE",
"écartelait" => "ekaRt°lE",
"écartelant" => "ekaRt°l@",
"écartèle" => "ekaRtEl",
"écartelé" => "ekaRt°le",
"écartelée" => "ekaRt°le",
"écartelées" => "ekaRt°le",
"écartèlement" => "ekaRtEl°m@",
"écartèlements" => "ekaRtEl°m@",
"écartèlent" => "ekaRtEl",
"écarteler" => "ekaRt°le",
"écartèleront" => "ekaRtEl°R§",
"écartelés" => "ekaRt°le",
"écartement" => "ekaRt°m@",
"écartements" => "ekaRt°m@",
"écartent" => "ekaRt",
"écarter" => "ekaRte",
"écartera" => "ekaRt°Ra",
"écarteraient" => "ekaRt°RE",
"écarterait" => "ekaRt°RE",
"écarteras" => "ekaRt°Ra",
"écartèrent" => "ekaRtER",
"écarterez" => "ekaRt°Re",
"écarteront" => "ekaRt°R§",
"écartes" => "ekaRt",
"écartés" => "ekaRte",
"écarteur" => "ekaRt9R",
"écartez" => "ekaRte",
"écartions" => "ekaRtj§",
"écartons" => "ekaRt§",
"écarts" => "ekaR",
"ecce homo" => "EtSeomo",
"ecchymose" => "ekimoz",
"ecchymosé" => "ekimoze",
"ecchymosée" => "ekimoze",
"ecchymoses" => "ekimoz",
"ecclésiale" => "Eklezjal",
"ecclésiastique" => "eklezjastik",
"ecclésiastiques" => "eklezjastik",
"écervelé" => "esERv°le",
"écervelée" => "esERv°le",
"écervelées" => "esERv°le",
"écervelés" => "esERv°le",
"échafaud" => "eSafo",
"échafauda" => "eSafoda",
"échafaudage" => "eSafodaZ",
"échafaudages" => "eSafodaZ",
"échafaudaient" => "eSafodE",
"échafaudais" => "eSafodE",
"échafaudait" => "eSafodE",
"échafaudant" => "eSafod@",
"échafaude" => "eSafod",
"échafaudé" => "eSafode",
"échafaudées" => "eSafode",
"échafaudent" => "eSafod",
"échafauder" => "eSafode",
"échafaudèrent" => "eSafodER",
"échafaudés" => "eSafode",
"échafaudons" => "eSafod§",
"échafauds" => "eSafo",
"échalas" => "eSala",
"échalier" => "eSalje",
"échaliers" => "eSalje",
"échalote" => "eSalOt",
"échalotes" => "eSalOt",
"échancraient" => "eS@kRE",
"échancre" => "eS@kR",
"échancré" => "eS@kRe",
"échancrée" => "eS@kRe",
"échancrées" => "eS@kRe",
"échancrer" => "eS@kRe",
"échancrés" => "eS@kRe",
"échancrure" => "eS@kRyR",
"échancrures" => "eS@kRyR",
"échange" => "eS@Z",
"échangé" => "eS@Ze",
"échangea" => "eS@Za",
"échangeables" => "eS@Zabl",
"échangeai" => "eS@ZE",
"échangeaient" => "eS@ZE",
"échangeais" => "eS@ZE",
"échangeait" => "eS@ZE",
"échangeâmes" => "eS@Zam",
"échangeant" => "eS@Z@",
"échangée" => "eS@Ze",
"échangées" => "eS@Ze",
"échangent" => "eS@Z",
"échangeons" => "eS@Z§",
"échanger" => "eS@Ze",
"échangera" => "eS@Z°Ra",
"échangerai" => "eS@Z°RE",
"échangeraient" => "eS@Z°RE",
"échangerais" => "eS@Z°RE",
"échangerait" => "eS@Z°RE",
"échangeras" => "eS@Z°Ra",
"échangèrent" => "eS@ZER",
"échangerez" => "eS@Z°Re",
"échangeriez" => "eS@Z°Rje",
"échangerions" => "eS@Z°Rj§",
"échangerons" => "eS@Z°R§",
"échangeront" => "eS@Z°R§",
"échanges" => "eS@Z",
"échangés" => "eS@Ze",
"échangeur" => "eS@Z9R",
"échangeurs" => "eS@Z9R",
"échangez" => "eS@Ze",
"échangiez" => "eS@Zje",
"échangions" => "eS@Zj§",
"échangisme" => "eS@Zizm",
"échangiste" => "eS@Zist",
"échangistes" => "eS@Zist",
"échanson" => "eS@s§",
"échansons" => "eS@s§",
"échantillon" => "eS@tij§",
"échantillonnage" => "eS@tijonaZ",
"échantillonne" => "eS@tijOn",
"échantillons" => "eS@tij§",
"échappa" => "eSapa",
"échappai" => "eSapE",
"échappaient" => "eSapE",
"échappais" => "eSapE",
"échappait" => "eSapE",
"échappâmes" => "eSapam",
"échappant" => "eSap@",
"échappât" => "eSapa",
"échappatoire" => "eSapatwaR",
"échappatoires" => "eSapatwaR",
"échappe" => "eSap",
"échappé" => "eSape",
"échappée" => "eSape",
"échappées" => "eSape",
"échappement" => "eSap°m@",
"échappements" => "eSap°m@",
"échappent" => "eSap",
"échapper" => "eSape",
"échappera" => "eSap°Ra",
"échapperai" => "eSap°RE",
"échapperaient" => "eSap°RE",
"échapperais" => "eSap°RE",
"échapperait" => "eSap°RE",
"échapperas" => "eSap°Ra",
"échappèrent" => "eSapER",
"échapperez" => "eSap°Re",
"échapperiez" => "eSap°Rje",
"échapperions" => "eSap°Rj§",
"échapperons" => "eSap°R§",
"échapperont" => "eSap°R§",
"échappes" => "eSap",
"échappés" => "eSape",
"échappez" => "eSape",
"échappiez" => "eSapje",
"échappions" => "eSapj§",
"échappons" => "eSap§",
"écharde" => "eSaRd",
"échardes" => "eSaRd",
"écharnait" => "eSaRnE",
"écharner" => "eSaRne",
"écharpe" => "eSaRp",
"écharpé" => "eSaRpe",
"écharpée" => "eSaRpe",
"écharpent" => "eSaRp",
"écharper" => "eSaRpe",
"écharperaient" => "eSaRp°RE",
"écharpes" => "eSaRp",
"échasse" => "eSas",
"échasses" => "eSas",
"échassier" => "eSasje",
"échassière" => "eSasjER",
"échassières" => "eSasjER",
"échassiers" => "eSasje",
"échaudé" => "eSode",
"échaudée" => "eSode",
"échauder" => "eSode",
"échauderont" => "eSod°R§",
"échaudés" => "eSode",
"échauffa" => "eSofa",
"échauffaient" => "eSofE",
"échauffais" => "eSofE",
"échauffait" => "eSofE",
"échauffant" => "eSof@",
"échauffe" => "eSof",
"échauffé" => "eSofe",
"échauffée" => "eSofe",
"échauffées" => "eSofe",
"échauffement" => "eSofm@",
"échauffements" => "eSofm@",
"échauffent" => "eSof",
"échauffer" => "eSofe",
"échauffés" => "eSofe",
"échauffez" => "eSofe",
"échauffons" => "eSof§",
"échauffourée" => "eSofuRe",
"échauffourées" => "eSofuRe",
"échauguette" => "eSogEt",
"échauguettes" => "eSogEt",
"échéance" => "eSe@s",
"échéances" => "eSe@s",
"échéancier" => "eSe@sje",
"échéant" => "eSe@",
"échec" => "eSEk",
"échecs" => "eSEk",
"échelle" => "eSEl",
"échelles" => "eSEl",
"échelon" => "eS°l§",
"échelonnaient" => "eS°lonE",
"échelonnait" => "eS°lonE",
"échelonnant" => "eS°lon@",
"échelonne" => "eS°lOn",
"échelonné" => "eS°lone",
"échelonnée" => "eS°lone",
"échelonnées" => "eS°lone",
"échelonnent" => "eS°lOn",
"échelonner" => "eS°lone",
"échelonnerons" => "eS°lOn°R§",
"échelonnés" => "eS°lone",
"échelons" => "eS°l§",
"écher" => "eSe",
"écheveau" => "ES°vo",
"écheveaux" => "ES°vo",
"échevelait" => "eS°v°lE",
"échevelant" => "eS°v°l@",
"échevelé" => "eS°v°le",
"échevelée" => "eS°v°le",
"échevelées" => "eS°v°le",
"écheveler" => "eS°v°le",
"échevelés" => "eS°v°le",
"échevellement" => "eS°vEl°m@",
"échevin" => "ES°v5",
"échevins" => "ES°v5",
"échina" => "eSina",
"échinaient" => "eSinE",
"échinais" => "eSinE",
"échinait" => "eSinE",
"échinant" => "eSin@",
"échine" => "eSin",
"échiné" => "eSine",
"échinée" => "eSine",
"échinent" => "eSin",
"échiner" => "eSine",
"échines" => "eSin",
"échinodermes" => "ekinodERm",
"échiquier" => "eSikje",
"échiquiers" => "eSikje",
"écho" => "eko",
"échocardiogramme" => "ekokaRdjOgRam",
"échocardiographie" => "ekokaRdjOgRafi",
"échographie" => "ekogRafi",
"échographier" => "ekogRafje",
"échographiste" => "ekogRafist",
"échoir" => "eSwaR",
"échoirait" => "eSwaRE",
"échoit" => "eSwa",
"écholocalisation" => "ekolOkalizasj§",
"écholocation" => "ekolOkasj§",
"échoppe" => "eSOp",
"échoppes" => "eSOp",
"échos" => "eko",
"échos-radars" => "ekoRadaR",
"échotier" => "ekotje",
"échotière" => "ekotjER",
"échotiers" => "ekotje",
"échoua" => "eSwa",
"échouage" => "eSwaZ",
"échouages" => "eSwaZ",
"échouai" => "eSwE",
"échouaient" => "eSwE",
"échouais" => "eSwE",
"échouait" => "eSwE",
"échouâmes" => "eSwam",
"échouant" => "eSw@",
"échouât" => "eSwa",
"échoue" => "eSu",
"échoué" => "eSwe",
"échouée" => "eSwe",
"échouées" => "eSwe",
"échouement" => "eSum@",
"échouent" => "eSu",
"échouer" => "eSwe",
"échouera" => "eSuRa",
"échouerai" => "eSuRE",
"échoueraient" => "eSuRE",
"échouerais" => "eSuRE",
"échouerait" => "eSuRE",
"échoueras" => "eSuRa",
"échouèrent" => "eSwER",
"échouerez" => "eSuRe",
"échouerons" => "eSuR§",
"échoueront" => "eSuR§",
"échoués" => "eSwe",
"échouez" => "eSue",
"échouiez" => "eSuje",
"échouions" => "eSuj§",
"échouons" => "eSw§",
"échu" => "eSy",
"échue" => "eSy",
"échues" => "eSy",
"échut" => "eSy",
"échût" => "eSy",
"éclaboussa" => "eklabusa",
"éclaboussaient" => "eklabusE",
"éclaboussait" => "eklabusE",
"éclaboussant" => "eklabus@",
"éclaboussante" => "eklabus@t",
"éclaboussantes" => "eklabus@t",
"éclaboussants" => "eklabus@",
"éclabousse" => "eklabus",
"éclaboussé" => "eklabuse",
"éclaboussée" => "eklabuse",
"éclaboussées" => "eklabuse",
"éclaboussement" => "eklabus°m@",
"éclaboussements" => "eklabus°m@",
"éclaboussent" => "eklabus",
"éclabousser" => "eklabuse",
"éclaboussera" => "eklabus°Ra",
"éclaboussèrent" => "eklabusER",
"éclabousses" => "eklabus",
"éclaboussés" => "eklabuse",
"éclaboussez" => "eklabuse",
"éclaboussure" => "eklabusyR",
"éclaboussures" => "eklabusyR",
"éclair" => "eklER",
"éclaira" => "eklERa",
"éclairage" => "eklERaZ",
"éclairages" => "eklERaZ",
"éclairagiste" => "eklERaZist",
"éclairagistes" => "eklERaZist",
"éclairai" => "eklERE",
"éclairaient" => "eklERE",
"éclairais" => "eklERE",
"éclairait" => "eklERE",
"éclairant" => "eklER@",
"éclairante" => "eklER@t",
"éclairantes" => "eklER@t",
"éclairants" => "eklER@",
"éclairât" => "eklERa",
"éclairci" => "eklERsi",
"éclaircie" => "eklERsi",
"éclaircies" => "eklERsi",
"éclaircir" => "eklERsiR",
"éclaircira" => "eklERsiRa",
"éclaircirai" => "eklERsiRE",
"éclaircirait" => "eklERsiRE",
"éclairciras" => "eklERsiRa",
"éclaircirez" => "eklERsiRe",
"éclaircirons" => "eklERsiR§",
"éclairciront" => "eklERsiR§",
"éclaircis" => "eklERsi",
"éclaircissage" => "eklERsisaZ",
"éclaircissaient" => "eklERsisE",
"éclaircissait" => "eklERsisE",
"éclaircissant" => "eklERsis@",
"éclaircisse" => "eklERsis",
"éclaircissement" => "eklERsis°m@",
"éclaircissements" => "eklERsis°m@",
"éclaircissent" => "eklERsis",
"éclaircissez" => "eklERsise",
"éclaircissons" => "eklERsis§",
"éclaircit" => "eklERsi",
"éclaire" => "eklER",
"éclairé" => "ekleRe",
"éclairée" => "ekleRe",
"éclairées" => "ekleRe",
"éclairement" => "eklER°m@",
"éclairent" => "eklER",
"éclairer" => "ekleRe",
"éclairera" => "eklER°Ra",
"éclaireraient" => "eklER°RE",
"éclairerait" => "eklER°RE",
"éclairèrent" => "eklERER",
"éclaireront" => "eklER°R§",
"éclaires" => "eklER",
"éclairés" => "ekleRe",
"éclaireur" => "eklER9R",
"éclaireurs" => "eklER9R",
"éclaireuse" => "eklER2z",
"éclaireuses" => "eklER2z",
"éclairez" => "eklERe",
"éclairiez" => "eklERje",
"éclairons" => "eklER§",
"éclairs" => "eklER",
"éclampsie" => "ekl@psi",
"éclamptique" => "ekl@ptik",
"éclat" => "ekla",
"éclata" => "eklata",
"éclatage" => "eklataZ",
"éclatai" => "eklatE",
"éclataient" => "eklatE",
"éclatais" => "eklatE",
"éclatait" => "eklatE",
"éclatant" => "eklat@",
"éclatante" => "eklat@t",
"éclatantes" => "eklat@t",
"éclatants" => "eklat@",
"éclatât" => "eklata",
"éclate" => "eklat",
"éclaté" => "eklate",
"éclatée" => "eklate",
"éclatées" => "eklate",
"éclatement" => "eklat°m@",
"éclatements" => "eklat°m@",
"éclatent" => "eklat",
"éclater" => "eklate",
"éclatera" => "eklat°Ra",
"éclaterai" => "eklat°RE",
"éclateraient" => "eklat°RE",
"éclaterais" => "eklat°RE",
"éclaterait" => "eklat°RE",
"éclateras" => "eklat°Ra",
"éclatèrent" => "eklatER",
"éclateriez" => "eklat°Rje",
"éclateront" => "eklat°R§",
"éclates" => "eklat",
"éclatés" => "eklate",
"éclateurs" => "eklat9R",
"éclatez" => "eklate",
"éclatiez" => "eklatje",
"éclatons" => "eklat§",
"éclats" => "ekla",
"éclectique" => "eklEktik",
"éclectiques" => "eklEktik",
"éclectisme" => "eklEktizm",
"éclipsa" => "eklipsa",
"éclipsai" => "eklipsE",
"éclipsaient" => "eklipsE",
"éclipsait" => "eklipsE",
"éclipsant" => "eklips@",
"éclipse" => "eklips",
"éclipsé" => "eklipse",
"éclipsée" => "eklipse",
"éclipsées" => "eklipse",
"éclipsent" => "eklips",
"éclipser" => "eklipse",
"éclipsera" => "eklips°Ra",
"éclipserais" => "eklips°RE",
"éclipserait" => "eklips°RE",
"éclipsèrent" => "eklipsER",
"éclipses" => "eklips",
"éclipsés" => "eklipse",
"éclipsez" => "eklipse",
"éclipsions" => "eklipsj§",
"écliptique" => "ekliptik",
"éclisse" => "eklis",
"éclisses" => "eklis",
"éclopait" => "eklopE",
"éclopé" => "eklope",
"éclopée" => "eklope",
"écloper" => "eklOpe",
"éclopés" => "eklope",
"éclore" => "eklOR",
"éclos" => "eklo",
"éclose" => "ekloz",
"écloses" => "ekloz",
"éclosion" => "eklozj§",
"éclosions" => "eklozj§",
"éclusa" => "eklyza",
"éclusaient" => "eklyzE",
"éclusais" => "eklyzE",
"éclusait" => "eklyzE",
"éclusant" => "eklyz@",
"écluse" => "eklyz",
"éclusé" => "eklyze",
"éclusée" => "eklyze",
"éclusées" => "eklyze",
"éclusent" => "eklyz",
"écluser" => "eklyze",
"écluses" => "eklyz",
"éclusier" => "eklyzje",
"éclusiers" => "eklyzje",
"écoeura" => "ek9Ra",
"écoeuraient" => "ek9RE",
"écoeurais" => "ek9RE",
"écoeurait" => "ek9RE",
"écoeurant" => "ek9R@",
"écoeurante" => "ek9R@t",
"écoeurantes" => "ek9R@t",
"écoeurants" => "ek9R@",
"écoeure" => "ek9R",
"écoeuré" => "ek9Re",
"écoeurée" => "ek9Re",
"écoeurées" => "ek9Re",
"écoeurement" => "ek9R°m@",
"écoeurements" => "ek9R°m@",
"écoeurent" => "ek9R",
"écoeurer" => "ek9Re",
"écoeurerais" => "ek9R°RE",
"écoeurèrent" => "ek9RER",
"écoeurés" => "ek9Re",
"écoeurez" => "ek9Re",
"écoinçon" => "ekw5s§",
"école" => "ekOl",
"écoles" => "ekOl",
"écolier" => "ekolje",
"écolière" => "ekoljER",
"écolières" => "ekoljER",
"écoliers" => "ekolje",
"écolo" => "ekolo",
"écologie" => "ekoloZi",
"écologique" => "ekoloZik",
"écologiquement" => "ekoloZik°m@",
"écologiques" => "ekoloZik",
"écologiste" => "ekoloZist",
"écologistes" => "ekoloZist",
"écolos" => "ekolo",
"éconduira" => "ek§d8iRa",
"éconduire" => "ek§d8iR",
"éconduis" => "ek§d8i",
"éconduisirent" => "ek§d8iziR",
"éconduisit" => "ek§d8izi",
"éconduit" => "ek§d8i",
"éconduite" => "ek§d8it",
"éconduits" => "ek§d8i",
"éconocroques" => "ekOnOkROk",
"économat" => "ekonoma",
"économe" => "ekonOm",
"économes" => "ekonOm",
"économie" => "ekonomi",
"économies" => "ekonomi",
"économique" => "ekonomik",
"économiquement" => "ekonomik°m@",
"économiques" => "ekonomik",
"économisaient" => "ekonomizE",
"économisais" => "ekonomizE",
"économisait" => "ekonomizE",
"économisant" => "ekonomiz@",
"économise" => "ekonomiz",
"économisé" => "ekonomize",
"économisée" => "ekonomize",
"économisées" => "ekonomize",
"économisent" => "ekonomiz",
"économiser" => "ekonomize",
"économisera" => "ekonomiz°Ra",
"économiserai" => "ekonomiz°RE",
"économiserais" => "ekonomiz°RE",
"économiserait" => "ekonomiz°RE",
"économiserez" => "ekonomiz°Re",
"économiserons" => "ekonomiz°R§",
"économiseront" => "ekonomiz°R§",
"économisés" => "ekonomize",
"économiseur" => "ekonomiz9R",
"économiseurs" => "ekonomiz9R",
"économisez" => "ekonomize",
"économisme" => "ekonomizm",
"économisons" => "ekonomiz§",
"économiste" => "ekonomist",
"économistes" => "ekonomist",
"écopa" => "ekopa",
"écopai" => "ekopE",
"écopais" => "ekopE",
"écopait" => "ekopE",
"écope" => "ekOp",
"écopé" => "ekope",
"écopée" => "ekope",
"écopent" => "ekOp",
"écoper" => "ekope",
"écopera" => "ekOp°Ra",
"écoperai" => "ekOp°RE",
"écoperait" => "ekOp°RE",
"écoperas" => "ekOp°Ra",
"écoperches" => "ekopERS",
"écoperez" => "ekOp°Re",
"écoperont" => "ekOp°R§",
"écopes" => "ekOp",
"écopez" => "ekope",
"écopiez" => "ekopje",
"écopons" => "ekop§",
"écorce" => "ekORs",
"écorcé" => "ekORse",
"écorcer" => "ekORse",
"écorces" => "ekORs",
"écorcés" => "ekORse",
"écorcha" => "ekORSa",
"écorchage" => "ekORSaZ",
"écorchaient" => "ekORSE",
"écorchais" => "ekORSE",
"écorchait" => "ekORSE",
"écorchant" => "ekORS@",
"écorche" => "ekORS",
"écorché" => "ekORSe",
"écorchée" => "ekORSe",
"écorchées" => "ekORSe",
"écorchement" => "ekORS°m@",
"écorchent" => "ekORS",
"écorcher" => "ekORSe",
"écorchera" => "ekORS°Ra",
"écorcherai" => "ekORS°RE",
"écorcherais" => "ekORS°RE",
"écorcherait" => "ekORS°RE",
"écorcherie" => "ekORS°Ri",
"écorcheront" => "ekORS°R§",
"écorchés" => "ekORSe",
"écorcheur" => "ekORS9R",
"écorcheurs" => "ekORS9R",
"écorchez" => "ekORSe",
"écorchiez" => "ekORSje",
"écorchions" => "ekORSj§",
"écorchure" => "ekORSyR",
"écorchures" => "ekORSyR",
"écornait" => "ekORnE",
"écorné" => "ekORne",
"écornée" => "ekORne",
"écornées" => "ekORne",
"écornent" => "ekORn",
"écorner" => "ekORne",
"écornés" => "ekORne",
"écornifler" => "ekORnifle",
"écosphère" => "ekosfER",
"écossa" => "ekosa",
"écossaient" => "ekosE",
"écossais" => "ekosE",
"écossaise" => "ekosEz",
"écossaises" => "ekosEz",
"écossait" => "ekosE",
"écossant" => "ekos@",
"écosse" => "ekOs",
"écossé" => "ekose",
"écossent" => "ekOs",
"écosser" => "ekose",
"écossés" => "ekose",
"écosystème" => "ekosistEm",
"écosystèmes" => "ekosistEm",
"écot" => "eko",
"écotone" => "ekOtOn",
"écoula" => "ekula",
"écoulaient" => "ekulE",
"écoulait" => "ekulE",
"écoulant" => "ekul@",
"écoulât" => "ekula",
"écoule" => "ekul",
"écoulé" => "ekule",
"écoulée" => "ekule",
"écoulées" => "ekule",
"écoulement" => "ekul°m@",
"écoulements" => "ekul°m@",
"écoulent" => "ekul",
"écouler" => "ekule",
"écoulera" => "ekul°Ra",
"écouleraient" => "ekul°RE",
"écoulerait" => "ekul°RE",
"écoulèrent" => "ekulER",
"écouleront" => "ekul°R§",
"écoulés" => "ekule",
"écourta" => "ekuRta",
"écourtaient" => "ekuRtE",
"écourtais" => "ekuRtE",
"écourtant" => "ekuRt@",
"écourte" => "ekuRt",
"écourté" => "ekuRte",
"écourtée" => "ekuRte",
"écourtées" => "ekuRte",
"écourter" => "ekuRte",
"écourtera" => "ekuRt°Ra",
"écourteraient" => "ekuRt°RE",
"écourtés" => "ekuRte",
"écouta" => "ekuta",
"écoutai" => "ekutE",
"écoutaient" => "ekutE",
"écoutais" => "ekutE",
"écoutait" => "ekutE",
"écoutâmes" => "ekutam",
"écoutant" => "ekut@",
"écoutât" => "ekuta",
"écoute" => "ekut",
"écouté" => "ekute",
"écoutée" => "ekute",
"écoutées" => "ekute",
"écoutent" => "ekut",
"écouter" => "ekute",
"écoutera" => "ekut°Ra",
"écouterai" => "ekut°RE",
"écouteraient" => "ekut°RE",
"écouterais" => "ekut°RE",
"écouterait" => "ekut°RE",
"écouteras" => "ekut°Ra",
"écoutèrent" => "ekutER",
"écouterez" => "ekut°Re",
"écouteriez" => "ekut°Rje",
"écouterons" => "ekut°R§",
"écouteront" => "ekut°R§",
"écoutes" => "ekut",
"écoutés" => "ekute",
"écouteur" => "ekut9R",
"écouteurs" => "ekut9R",
"écouteuse" => "ekut2z",
"écoutez" => "ekute",
"écoutiez" => "ekutje",
"écoutille" => "ekutij",
"écoutilles" => "ekutij",
"écoutions" => "ekutj§",
"écoutons" => "ekut§",
"écouvillon" => "ekuvij§",
"écouvillonne" => "ekuvijOn",
"écouvillons" => "ekuvij§",
"écrabouilla" => "ekRabuja",
"écrabouillage" => "ekRabujaZ",
"écrabouillait" => "ekRabujE",
"écrabouillant" => "ekRabuj@",
"écrabouille" => "ekRabuj",
"écrabouillé" => "ekRabuje",
"écrabouillée" => "ekRabuje",
"écrabouillées" => "ekRabuje",
"écrabouillement" => "ekRabuj°m@",
"écrabouillements" => "ekRabuj°m@",
"écrabouiller" => "ekRabuje",
"écrabouillera" => "ekRabuj°Ra",
"écrabouillèrent" => "ekRabujER",
"écrabouillés" => "ekRabuje",
"écrabouillons" => "ekRabuj§",
"écran" => "ekR@",
"écrans" => "ekR@",
"écrasa" => "ekRaza",
"écrasage" => "ekRazaZ",
"écrasai" => "ekRazE",
"écrasaient" => "ekRazE",
"écrasais" => "ekRazE",
"écrasait" => "ekRazE",
"écrasant" => "ekRaz@",
"écrasante" => "ekRaz@t",
"écrasantes" => "ekRaz@t",
"écrasants" => "ekRaz@",
"écrasât" => "ekRaza",
"écrase" => "ekRaz",
"écrasé" => "ekRaze",
"écrase-merde" => "ekRazmERd",
"écrase-merdes" => "ekRazmERd",
"écrasée" => "ekRaze",
"écrasées" => "ekRaze",
"écrasement" => "ekRaz°m@",
"écrasements" => "ekRaz°m@",
"écrasent" => "ekRaz",
"écraser" => "ekRaze",
"écrasera" => "ekRaz°Ra",
"écraserai" => "ekRaz°RE",
"écraseraient" => "ekRaz°RE",
"écraserais" => "ekRaz°RE",
"écraserait" => "ekRaz°RE",
"écraseras" => "ekRaz°Ra",
"écrasèrent" => "ekRazER",
"écraserez" => "ekRaz°Re",
"écraserons" => "ekRaz°R§",
"écraseront" => "ekRaz°R§",
"écrases" => "ekRaz",
"écrasés" => "ekRaze",
"écraseur" => "ekRaz9R",
"écrasez" => "ekRaze",
"écrasiez" => "ekRazje",
"écrasions" => "ekRazj§",
"écrasons" => "ekRaz§",
"écrasure" => "ekRazyR",
"écrémage" => "ekRemaZ",
"écrème" => "ekREm",
"écrémé" => "ekReme",
"écrémées" => "ekReme",
"écrémer" => "ekReme",
"écrémeuse" => "ekRem2z",
"écrêtait" => "ekREtE",
"écrêtée" => "ekREte",
"écrêter" => "ekREte",
"écrevisse" => "ekR°vis",
"écrevisses" => "ekR°vis",
"écria" => "ekRija",
"écriai" => "ekRijE",
"écriaient" => "ekRijE",
"écriais" => "ekRijE",
"écriait" => "ekRijE",
"écriant" => "ekRij@",
"écriât" => "ekRija",
"écrie" => "ekRi",
"écrié" => "ekRije",
"écriée" => "ekRije",
"écrient" => "ekRi",
"écrier" => "ekRije",
"écriera" => "ekRiRa",
"écrierait" => "ekRiRE",
"écrièrent" => "ekRijER",
"écries" => "ekRi",
"écriés" => "ekRije",
"écrin" => "ekR5",
"écrins" => "ekR5",
"écrions" => "ekRij§",
"écrira" => "ekRiRa",
"écrirai" => "ekRiRE",
"écriraient" => "ekRiRE",
"écrirais" => "ekRiRE",
"écrirait" => "ekRiRE",
"écriras" => "ekRiRa",
"écrire" => "ekRiR",
"écrirez" => "ekRiRe",
"écririez" => "ekRiRje",
"écrirons" => "ekRiR§",
"écriront" => "ekRiR§",
"écris" => "ekRi",
"écrit" => "ekRi",
"écrite" => "ekRit",
"écriteau" => "ekRito",
"écriteaux" => "ekRito",
"écrites" => "ekRit",
"écritoire" => "ekRitwaR",
"écritoires" => "ekRitwaR",
"écrits" => "ekRi",
"écriture" => "ekRityR",
"écritures" => "ekRityR",
"écrivaient" => "ekRivE",
"écrivaillé" => "ekRivaje",
"écrivailler" => "ekRivaje",
"écrivailleur" => "ekRivaj9R",
"écrivaillon" => "ekRivaj§",
"écrivaillons" => "ekRivaj§",
"écrivain" => "ekRiv5",
"écrivaine" => "ekRivEn",
"écrivaines" => "ekRivEn",
"écrivains" => "ekRiv5",
"écrivais" => "ekRivE",
"écrivait" => "ekRivE",
"écrivant" => "ekRiv@",
"écrivassiers" => "ekRivasje",
"écrive" => "ekRiv",
"écrivent" => "ekRiv",
"écrives" => "ekRiv",
"écriveur" => "ekRiv9R",
"écrivez" => "ekRive",
"écriviez" => "ekRivje",
"écrivîmes" => "ekRivim",
"écrivions" => "ekRivj§",
"écrivirent" => "ekRiviR",
"écrivis" => "ekRivi",
"écrivisse" => "ekRivis",
"écrivit" => "ekRivi",
"écrivît" => "ekRivi",
"écrivons" => "ekRiv§",
"écrou" => "ekRu",
"écroué" => "ekRue",
"écrouée" => "ekRue",
"écrouelles" => "ekRuEl",
"écrouer" => "ekRue",
"écroueront" => "ekRuR§",
"écroula" => "ekRula",
"écroulai" => "ekRulE",
"écroulaient" => "ekRulE",
"écroulais" => "ekRulE",
"écroulait" => "ekRulE",
"écroulant" => "ekRul@",
"écroulât" => "ekRula",
"écroule" => "ekRul",
"écroulé" => "ekRule",
"écroulée" => "ekRule",
"écroulées" => "ekRule",
"écroulement" => "ekRul°m@",
"écroulements" => "ekRul°m@",
"écroulent" => "ekRul",
"écrouler" => "ekRule",
"écroulera" => "ekRul°Ra",
"écroulerai" => "ekRul°RE",
"écrouleraient" => "ekRul°RE",
"écroulerais" => "ekRul°RE",
"écroulerait" => "ekRul°RE",
"écrouleras" => "ekRul°Ra",
"écroulèrent" => "ekRulER",
"écroulerions" => "ekRul°Rj§",
"écrouleront" => "ekRul°R§",
"écroulés" => "ekRule",
"écroulions" => "ekRulj§",
"écroulons" => "ekRul§",
"écrous" => "ekRu",
"écru" => "ekRy",
"écrue" => "ekRy",
"ecsta" => "2ksta",
"ecstasy" => "Ekstazi",
"ectasie" => "2ktazi",
"ecthyma" => "Ektima",
"ectodermique" => "EktOdERmik",
"ectopie" => "EktOpi",
"ectopique" => "EktOpik",
"ectoplasme" => "Ektoplasm",
"ectoplasmes" => "Ektoplasm",
"ectoplasmique" => "Ektoplasmik",
"ectoplasmiques" => "Ektoplasmik",
"écu" => "eky",
"écubier" => "ekybje",
"écueil" => "ek9j",
"écueils" => "ek9j",
"écuelle" => "ek8El",
"écuellée" => "ek8Ele",
"écuellées" => "ek8Ele",
"écuelles" => "ek8El",
"écuissé" => "ek8ise",
"écuissées" => "ek8ise",
"éculé" => "ekyle",
"éculée" => "ekyle",
"éculées" => "ekyle",
"éculer" => "ekyle",
"éculés" => "ekyle",
"écuma" => "ekyma",
"écumai" => "ekymE",
"écumaient" => "ekymE",
"écumais" => "ekymE",
"écumait" => "ekymE",
"écumâmes" => "ekymam",
"écumant" => "ekym@",
"écumante" => "ekym@t",
"écumantes" => "ekym@t",
"écumants" => "ekym@",
"écume" => "ekym",
"écumé" => "ekyme",
"écumée" => "ekyme",
"écument" => "ekym",
"écumer" => "ekyme",
"écumera" => "ekym°Ra",
"écumèrent" => "ekymER",
"écumeront" => "ekym°R§",
"écumes" => "ekym",
"écumeur" => "ekym9R",
"écumeurs" => "ekym9R",
"écumeuse" => "ekym2z",
"écumeuses" => "ekym2z",
"écumeux" => "ekym2",
"écumez" => "ekyme",
"écumiez" => "ekymje",
"écumoire" => "ekymwaR",
"écumoires" => "ekymwaR",
"écureuil" => "ekyR9j",
"écureuils" => "ekyR9j",
"écurie" => "ekyRi",
"écuries" => "ekyRi",
"écus" => "eky",
"écusson" => "ekys§",
"écussonné" => "ekysone",
"écussonnées" => "ekysone",
"écussonnés" => "ekysone",
"écussons" => "ekys§",
"écuyer" => "ek8ije",
"écuyère" => "ek8ijER",
"écuyères" => "ek8ijER",
"écuyers" => "ek8ije",
"eczéma" => "Egzema",
"eczémas" => "Egzema",
"eczémateuses" => "Egzemat2z",
"eczémateux" => "Egzemat2",
"édam" => "edam",
"edelweiss" => "edElvajs",
"éden" => "edEn",
"édénique" => "edenik",
"édéniques" => "edenik",
"édens" => "edEn",
"édenté" => "ed@te",
"édentée" => "ed@te",
"édentées" => "ed@te",
"édentés" => "ed@te",
"édicte" => "edikt",
"édicté" => "edikte",
"édictée" => "edikte",
"édictées" => "edikte",
"édicter" => "edikte",
"édicule" => "edikyl",
"édicules" => "edikyl",
"édifia" => "edifja",
"édifiaient" => "edifjE",
"édifiait" => "edifjE",
"édifiant" => "edifj@",
"édifiante" => "edifj@t",
"édifiantes" => "edifj@t",
"édifiants" => "edifj@",
"édification" => "edifikasj§",
"édifice" => "edifis",
"édifices" => "edifis",
"édifie" => "edifi",
"édifié" => "edifje",
"édifiée" => "edifje",
"édifiées" => "edifje",
"édifient" => "edifi",
"édifier" => "edifje",
"édifierait" => "edifiRE",
"édifièrent" => "edifjER",
"édifierons" => "edifiR§",
"édifiés" => "edifje",
"édifions" => "edifj§",
"édiles" => "edil",
"édilitaire" => "edilitER",
"édilitaires" => "edilitER",
"édit" => "edi",
"éditait" => "editE",
"édite" => "edit",
"édité" => "edite",
"éditée" => "edite",
"éditées" => "edite",
"éditer" => "edite",
"éditera" => "edit°Ra",
"éditerais" => "edit°RE",
"édités" => "edite",
"éditeur" => "edit9R",
"éditeurs" => "edit9R",
"édition" => "edisj§",
"éditions" => "edisj§",
"édito" => "edito",
"éditons" => "edit§",
"éditorial" => "editoRjal",
"éditoriale" => "editoRjal",
"éditorialiste" => "editoRjalist",
"éditorialistes" => "editoRjalist",
"éditoriaux" => "editoRjo",
"éditos" => "edito",
"éditrice" => "editRis",
"éditrices" => "editRis",
"édits" => "edi",
"édouardienne" => "eduaRdjEn",
"édredon" => "edR°d§",
"édredons" => "edR°d§",
"éducable" => "edykabl",
"éducables" => "edykabl",
"éducateur" => "edykat9R",
"éducateurs" => "edykat9R",
"éducatif" => "edykatif",
"éducatifs" => "edykatif",
"éducation" => "edykasj§",
"éducationnel" => "edykasjOnEl",
"éducationnelle" => "edykasjonEl",
"éducations" => "edykasj§",
"éducative" => "edykativ",
"éducatives" => "edykativ",
"éducatrice" => "edykatRis",
"éducatrices" => "edykatRis",
"éduen" => "edy5",
"éduennes" => "edyEn",
"éduens" => "edy5",
"édulcorais" => "edylkoRE",
"édulcorant" => "edylkoR@",
"édulcoré" => "edylkoRe",
"édulcorée" => "edylkoRe",
"édulcorées" => "edylkoRe",
"édulcorer" => "edylkORe",
"éduquais" => "edykE",
"éduquant" => "edyk@",
"éduque" => "edyk",
"éduqué" => "edyke",
"éduquée" => "edyke",
"éduquées" => "edyke",
"éduquer" => "edyke",
"éduquera" => "edyk°Ra",
"éduqués" => "edyke",
"éduquez" => "edyke",
"éduquons" => "edyk§",
"edwardienne" => "edwaRdjEn",
"effaça" => "efasa",
"effaçable" => "efasabl",
"effaçables" => "efasabl",
"effaçage" => "efasaZ",
"effaçai" => "efasE",
"effaçaient" => "efasE",
"effaçais" => "efasE",
"effaçait" => "efasE",
"effaçant" => "efas@",
"effaçassent" => "efasas",
"effaçât" => "efasa",
"efface" => "efas",
"effacé" => "efase",
"effacée" => "efase",
"effacées" => "efase",
"effacement" => "efas°m@",
"effacements" => "efas°m@",
"effacent" => "efas",
"effacer" => "efase",
"effacera" => "efas°Ra",
"effacerai" => "efas°RE",
"effaceraient" => "efas°RE",
"effacerais" => "efas°RE",
"effacerait" => "efas°RE",
"effaceras" => "efas°Ra",
"effacèrent" => "efasER",
"effacerez" => "efas°Re",
"effacerions" => "efas°Rj§",
"effacerons" => "efas°R§",
"effaceront" => "efas°R§",
"effaces" => "efas",
"effacés" => "efase",
"effaceur" => "efas9R",
"effacez" => "efase",
"effaciez" => "efasje",
"effacions" => "efasj§",
"effaçons" => "efas§",
"effara" => "efaRa",
"effaraient" => "efaRE",
"effarait" => "efaRE",
"effarant" => "efaR@",
"effarante" => "efaR@t",
"effarantes" => "efaR@t",
"effarants" => "efaR@",
"effare" => "efaR",
"effaré" => "efaRe",
"effarée" => "efaRe",
"effarées" => "efaRe",
"effarement" => "efaR°m@",
"effarer" => "efaRe",
"effarèrent" => "efaRER",
"effarés" => "efaRe",
"effaroucha" => "efaRuSa",
"effarouchaient" => "efaRuSE",
"effarouchait" => "efaRuSE",
"effarouchâmes" => "efaRuSam",
"effarouchant" => "efaRuS@",
"effarouchât" => "efaRuSa",
"effarouche" => "efaRuS",
"effarouché" => "efaRuSe",
"effarouchée" => "efaRuSe",
"effarouchées" => "efaRuSe",
"effarouchement" => "efaRuS°m@",
"effarouchements" => "efaRuS°m@",
"effarouchent" => "efaRuS",
"effaroucher" => "efaRuSe",
"effarouches" => "efaRuS",
"effarouchés" => "efaRuSe",
"effarvatte" => "efaRvat",
"effarvattes" => "efaRvat",
"effectif" => "efEktif",
"effectifs" => "efEktif",
"effective" => "efEktiv",
"effectivement" => "efEktiv°m@",
"effectives" => "efEktiv",
"effectivité" => "efEktivite",
"effectua" => "efEkt8a",
"effectuai" => "efEkt8E",
"effectuaient" => "efEkt8E",
"effectuais" => "efEktyE",
"effectuait" => "efEkt8E",
"effectuant" => "efEkt8@",
"effectue" => "efEkty",
"effectué" => "efEkt8e",
"effectuée" => "efEkt8e",
"effectuées" => "efEkt8e",
"effectuent" => "efEkty",
"effectuer" => "efEkt8e",
"effectuera" => "efEktyRa",
"effectuerai" => "efEktyRE",
"effectuerait" => "efEktyRE",
"effectuerons" => "efEktyR§",
"effectues" => "efEkty",
"effectués" => "efEkt8e",
"effectuez" => "efEktye",
"effectuions" => "efEktyj§",
"effectuons" => "efEkt8§",
"efféminait" => "efeminE",
"efféminé" => "efemine",
"efféminée" => "efemine",
"efféminés" => "efemine",
"effendi" => "ef5di",
"effervescence" => "efERves@s",
"effervescences" => "efERvEs@s",
"effervescent" => "efERves@",
"effervescente" => "efERves@t",
"effervescentes" => "efERvEs@t",
"effervescents" => "efERvEs@",
"effet" => "efE",
"effets" => "efE",
"effeuilla" => "ef9ja",
"effeuillage" => "ef9jaZ",
"effeuillaient" => "ef9jE",
"effeuillait" => "ef9jE",
"effeuillant" => "ef9j@",
"effeuille" => "ef9j",
"effeuillé" => "ef9je",
"effeuillée" => "ef9je",
"effeuillent" => "ef9j",
"effeuiller" => "ef9je",
"effeuilleras" => "ef9j°Ra",
"effeuillèrent" => "ef9jER",
"effeuillés" => "ef9je",
"effeuilleuse" => "ef9j2z",
"effeuilleuses" => "ef9j2z",
"effeuillez" => "ef9je",
"efficace" => "efikas",
"efficacement" => "efikas°m@",
"efficaces" => "efikas",
"efficacité" => "efikasite",
"efficience" => "efisj@s",
"efficient" => "efisj@",
"efficiente" => "efisj@t",
"efficientes" => "efisj@t",
"efficients" => "efisj@",
"effigie" => "efiZi",
"effigies" => "efiZi",
"effila" => "efila",
"effilaient" => "efilE",
"effilait" => "efilE",
"effilant" => "efil@",
"effile" => "efil",
"effilé" => "efile",
"effilée" => "efile",
"effilées" => "efile",
"effilement" => "efil°m@",
"effilent" => "efil",
"effiler" => "efile",
"effilés" => "efile",
"effilochage" => "efiloSaZ",
"effilochaient" => "efiloSE",
"effilochait" => "efiloSE",
"effilochant" => "efiloS@",
"effiloche" => "efilOS",
"effiloché" => "efiloSe",
"effilochée" => "efiloSe",
"effilochées" => "efiloSe",
"effilochent" => "efilOS",
"effilocher" => "efiloSe",
"effilochera" => "efilOS°Ra",
"effilochèrent" => "efiloSER",
"effilochés" => "efiloSe",
"effilochure" => "efiloSyR",
"effilochures" => "efiloSyR",
"effilure" => "efilyR",
"effilures" => "efilyR",
"efflanqué" => "efl@ke",
"efflanquée" => "efl@ke",
"efflanquées" => "efl@ke",
"efflanqués" => "efl@ke",
"effleura" => "efl9Ra",
"effleurage" => "efl9RaZ",
"effleurai" => "efl9RE",
"effleuraient" => "efl9RE",
"effleurais" => "efl9RE",
"effleurait" => "efl9RE",
"effleurâmes" => "efl9Ram",
"effleurant" => "efl9R@",
"effleurât" => "efl9Ra",
"effleure" => "efl9R",
"effleuré" => "efl9Re",
"effleurée" => "efl9Re",
"effleurées" => "efl9Re",
"effleurement" => "efl9R°m@",
"effleurements" => "efl9R°m@",
"effleurent" => "efl9R",
"effleurer" => "efl9Re",
"effleurera" => "efl9R°Ra",
"effleurerait" => "efl9R°RE",
"effleurèrent" => "efl9RER",
"effleureront" => "efl9R°R§",
"effleures" => "efl9R",
"effleurés" => "efl9Re",
"effleurez" => "efl9Re",
"efflorescence" => "efloRes@s",
"effluent" => "efly@",
"effluve" => "eflyv",
"effluves" => "eflyv",
"effondra" => "ef§dRa",
"effondrai" => "ef§dRE",
"effondraient" => "ef§dRE",
"effondrais" => "ef§dRE",
"effondrait" => "ef§dRE",
"effondrant" => "ef§dR@",
"effondrât" => "ef§dRa",
"effondre" => "ef§dR",
"effondré" => "ef§dRe",
"effondrée" => "ef§dRe",
"effondrées" => "ef§dRe",
"effondrement" => "ef§dR°m@",
"effondrements" => "ef§dR°m@",
"effondrent" => "ef§dR",
"effondrer" => "ef§dRe",
"effondrera" => "ef§dR°Ra",
"effondreraient" => "ef§dR°RE",
"effondrerais" => "ef§dR°RE",
"effondrerait" => "ef§dR°RE",
"effondrèrent" => "ef§dRER",
"effondreront" => "ef§dR°R§",
"effondrés" => "ef§dRe",
"effondrez" => "ef§dRe",
"efforça" => "efORsa",
"efforçai" => "efORsE",
"efforçaient" => "efORsE",
"efforçais" => "efORsE",
"efforçait" => "efORsE",
"efforçâmes" => "efORsam",
"efforçant" => "efORs@",
"efforçât" => "efORsa",
"efforce" => "efORs",
"efforcé" => "efORse",
"efforcée" => "efORse",
"efforcent" => "efORs",
"efforcer" => "efORse",
"efforcera" => "efORs°Ra",
"efforcerai" => "efORs°RE",
"efforceraient" => "efORs°RE",
"efforcerais" => "efORs°RE",
"efforcerait" => "efORs°RE",
"efforcèrent" => "efORsER",
"efforcerons" => "efORs°R§",
"efforces" => "efORs",
"efforcés" => "efORse",
"efforcez" => "efORse",
"efforcions" => "efORsj§",
"efforçons" => "efORs§",
"effort" => "efOR",
"efforts" => "efOR",
"effraction" => "efRaksj§",
"effractions" => "efRaksj§",
"effraie" => "efRE",
"effraient" => "efRE",
"effraiera" => "efRERa",
"effraieraient" => "efRERE",
"effraierait" => "efRERE",
"effraieras" => "efRERa",
"effraierez" => "efRERe",
"effraies" => "efRE",
"effrange" => "efR@Z",
"effrangé" => "efR@Ze",
"effrangeait" => "efR@ZE",
"effrangée" => "efR@Ze",
"effrangées" => "efR@Ze",
"effrangent" => "efR@Z",
"effrangés" => "efR@Ze",
"effraya" => "efReja",
"effrayaient" => "efRejE",
"effrayais" => "efRejE",
"effrayait" => "efRejE",
"effrayamment" => "efREjam@",
"effrayant" => "efREj@",
"effrayante" => "efREj@t",
"effrayantes" => "efREj@t",
"effrayants" => "efREj@",
"effraye" => "efREj",
"effrayé" => "efREje",
"effrayée" => "efREje",
"effrayées" => "efREje",
"effrayent" => "efRej",
"effrayer" => "efREje",
"effrayerais" => "efREj°RE",
"effrayerait" => "efREj°RE",
"effrayeras" => "efREj°Ra",
"effrayèrent" => "efRejER",
"effrayés" => "efREje",
"effrayez" => "efReje",
"effrayons" => "efRej§",
"effréné" => "efRene",
"effrénée" => "efRene",
"effrénées" => "efRene",
"effrénés" => "efRene",
"effrita" => "efRita",
"effritaient" => "efRitE",
"effritait" => "efRitE",
"effritant" => "efRit@",
"effrite" => "efRit",
"effrité" => "efRite",
"effritée" => "efRite",
"effritées" => "efRite",
"effritement" => "efRit°m@",
"effritements" => "efRit°m@",
"effritent" => "efRit",
"effriter" => "efRite",
"effriterait" => "efRit°RE",
"effrités" => "efRite",
"effroi" => "efRwa",
"effronté" => "efR§te",
"effrontée" => "efR§te",
"effrontées" => "efR§te",
"effrontément" => "efR§tem@",
"effronterie" => "efR§t°Ri",
"effronteries" => "efR§t°Ri",
"effrontés" => "efR§te",
"effroyable" => "efRwajabl",
"effroyablement" => "efRwajabl°m@",
"effroyables" => "efRwajabl",
"effulgente" => "efylZ@t",
"effusion" => "efyzj§",
"effusionniste" => "efyzjonist",
"effusionnistes" => "efyzjonist",
"effusions" => "efyzj§",
"efrit" => "EfRit",
"égaie" => "egE",
"égaieraient" => "egERE",
"égaierait" => "egERE",
"égaieront" => "egER§",
"égailla" => "egaja",
"égaillaient" => "egajE",
"égaillait" => "egajE",
"égaillant" => "egaj@",
"égaillée" => "egeje",
"égaillées" => "egeje",
"égaillent" => "egEj",
"égailler" => "egeje",
"égaillèrent" => "egejER",
"égaillés" => "egeje",
"égal" => "egal",
"égala" => "egala",
"égalable" => "egalabl",
"égalaient" => "egalE",
"égalais" => "egalE",
"égalait" => "egalE",
"égalant" => "egal@",
"égalât" => "egala",
"égale" => "egal",
"égalé" => "egale",
"égalée" => "egale",
"égalées" => "egale",
"également" => "egal°m@",
"égalent" => "egal",
"égaler" => "egale",
"égalera" => "egal°Ra",
"égalerai" => "egal°RE",
"égalerais" => "egal°RE",
"égalerait" => "egal°RE",
"égaleras" => "egal°Ra",
"égaleront" => "egal°R§",
"égales" => "egal",
"égalisa" => "egaliza",
"égalisais" => "egalizE",
"égalisait" => "egalizE",
"égalisant" => "egaliz@",
"égalisateur" => "egalizat9R",
"égalisateurs" => "egalizat9R",
"égalisation" => "egalizasj§",
"égalisatrice" => "egalizatRis",
"égalise" => "egaliz",
"égalisé" => "egalize",
"égalisées" => "egalize",
"égalisent" => "egaliz",
"égaliser" => "egalize",
"égalisèrent" => "egalizER",
"égalisés" => "egalize",
"égaliseur" => "egaliz9R",
"égalisez" => "egalize",
"égalitaire" => "egalitER",
"égalitarisme" => "egalitaRizm",
"égalité" => "egalite",
"égalités" => "egalite",
"égara" => "egaRa",
"égarai" => "egaRE",
"égaraient" => "egaRE",
"égarais" => "egaRE",
"égarait" => "egaRE",
"égarant" => "egaR@",
"égarât" => "egaRa",
"égard" => "egaR",
"égards" => "egaR",
"égare" => "egaR",
"égaré" => "egaRe",
"égarée" => "egaRe",
"égarées" => "egaRe",
"égarement" => "egaR°m@",
"égarements" => "egaR°m@",
"égarent" => "egaR",
"égarer" => "egaRe",
"égareraient" => "egaR°RE",
"égarerais" => "egaR°RE",
"égarerait" => "egaR°RE",
"égarèrent" => "egaRER",
"égarerions" => "egaR°Rj§",
"égares" => "egaR",
"égarés" => "egaRe",
"égarez" => "egaRe",
"égarons" => "egaR§",
"égaux" => "ego",
"égaya" => "egEja",
"égayaient" => "egEjE",
"égayait" => "egEjE",
"égayant" => "egEj@",
"égayante" => "egEj@t",
"égayât" => "egEja",
"égaye" => "egEj",
"égayé" => "egEje",
"égayée" => "egEje",
"égayées" => "egEje",
"égayer" => "egeje",
"égayerais" => "egEj°RE",
"égayèrent" => "egEjER",
"égayés" => "egEje",
"égayez" => "egEje",
"égéenne" => "eZeEn",
"égérie" => "eZeRi",
"égide" => "eZid",
"égipan" => "eZip@",
"égipans" => "eZip@",
"églantier" => "egl@tje",
"églantiers" => "egl@tje",
"églantine" => "egl@tin",
"églantines" => "egl@tin",
"église" => "egliz",
"églises" => "egliz",
"églogue" => "eglOg",
"églogues" => "eglOg",
"ego" => "ego",
"égocentrique" => "egos@tRik",
"égocentriques" => "egos@tRik",
"égocentrisme" => "egos@tRizm",
"égocentrismes" => "egos@tRizm",
"égocentriste" => "egos@tRist",
"égocentristes" => "egos@tRist",
"égoïne" => "egoin",
"égoïsme" => "egoizm",
"égoïsmes" => "egoizm",
"égoïste" => "egoist",
"égoïstement" => "egoist°m@",
"égoïstes" => "egoist",
"égorge" => "egORZ",
"égorgé" => "egORZe",
"égorgea" => "egORZa",
"égorgeaient" => "egORZE",
"égorgeais" => "egORZE",
"égorgeait" => "egORZE",
"égorgeant" => "egORZ@",
"égorgée" => "egORZe",
"égorgées" => "egORZe",
"égorgement" => "egORZ°m@",
"égorgements" => "egORZ°m@",
"égorgent" => "egORZ",
"égorgeoir" => "egORZwaR",
"égorger" => "egORZe",
"égorgerai" => "egORZ°RE",
"égorgeraient" => "egORZ°RE",
"égorgerais" => "egORZ°RE",
"égorgeras" => "egORZ°Ra",
"égorgèrent" => "egORZER",
"égorgeront" => "egORZ°R§",
"égorgés" => "egORZe",
"égorgeur" => "egORZ9R",
"égorgeurs" => "egORZ9R",
"égorgeuses" => "egORZ2z",
"égorgez" => "egORZe",
"égosilla" => "egozija",
"égosillaient" => "egozijE",
"égosillait" => "egozijE",
"égosillant" => "egozij@",
"égosille" => "egozij",
"égosillent" => "egozij",
"égosiller" => "egozije",
"égotisme" => "egotizm",
"égotiste" => "egotist",
"égotistes" => "egotist",
"égout" => "egu",
"égoutier" => "egutje",
"égoutiers" => "egutje",
"égouts" => "egu",
"égoutta" => "eguta",
"égouttaient" => "egutE",
"égouttait" => "egutE",
"égouttant" => "egut@",
"égoutte" => "egut",
"égoutté" => "egute",
"égouttement" => "egut°m@",
"égouttent" => "egut",
"égoutter" => "egute",
"égoutterait" => "egut°RE",
"égouttèrent" => "egutER",
"égouttez" => "egute",
"égouttis" => "eguti",
"égouttoir" => "egutwaR",
"égrainer" => "egREne",
"égrappait" => "egRapE",
"égratigna" => "egRatiNa",
"égratignaient" => "egRatiNE",
"égratignait" => "egRatiNE",
"égratignant" => "egRatiN@",
"égratigne" => "egRatiN",
"égratigné" => "egRatiNe",
"égratignée" => "egRatiNe",
"égratignent" => "egRatiN",
"égratigner" => "egRatiNe",
"égratignes" => "egRatiN",
"égratignés" => "egRatiNe",
"égratignure" => "egRatiNyR",
"égratignures" => "egRatiNyR",
"égrena" => "egR°na",
"égrenage" => "egR°naZ",
"égrenaient" => "egR°nE",
"égrenais" => "egR°nE",
"égrenait" => "egR°nE",
"égrenant" => "egR°n@",
"égrène" => "egREn",
"égrené" => "egR°ne",
"égrenée" => "egR°ne",
"égrenées" => "egR°ne",
"égrènements" => "egREn°m@",
"égrènent" => "egREn",
"égrener" => "egR°ne",
"égrenèrent" => "egR°nER",
"égrenés" => "egR°ne",
"égreneuse" => "egR°n2z",
"égrillard" => "egRijaR",
"égrillarde" => "egRijaRd",
"égrillardes" => "egRijaRd",
"égrillards" => "egRijaR",
"égrotant" => "egRot@",
"égrotantes" => "egRot@t",
"égrotants" => "egRot@",
"égyptien" => "eZipsj5",
"égyptienne" => "eZipsjEn",
"égyptiennes" => "eZipsjEn",
"égyptiens" => "eZipsj5",
"égyptologie" => "eZiptoloZi",
"égyptologue" => "eZiptolOg",
"égyptologues" => "eZiptolOg",
"eh" => "e",
"éhonté" => "e§te",
"éhontée" => "e§te",
"éhontées" => "e§te",
"éhontés" => "e§te",
"eider" => "edER",
"eiders" => "EdER",
"eidétique" => "Edetik",
"einsteinienne" => "5stEnjEn",
"éjacula" => "eZakyla",
"éjaculait" => "eZakylE",
"éjaculant" => "eZakyl@",
"éjaculat" => "eZakyla",
"éjaculateur" => "eZakylat9R",
"éjaculateurs" => "eZakylat9R",
"éjaculation" => "eZakylasj§",
"éjaculations" => "eZakylasj§",
"éjacule" => "eZakyl",
"éjaculé" => "eZakyle",
"éjaculent" => "eZakyl",
"éjaculer" => "eZakyle",
"éjaculés" => "eZakyle",
"éjecta" => "eZEkta",
"éjectable" => "eZEktabl",
"éjectables" => "eZEktabl",
"éjectaient" => "eZEktE",
"éjectait" => "eZEktE",
"éjectant" => "eZEkt@",
"éjectas" => "eZEkta",
"éjecte" => "eZEkt",
"éjecté" => "eZEkte",
"éjectée" => "eZEkte",
"éjectées" => "eZEkte",
"éjectent" => "eZEkt",
"éjecter" => "eZEkte",
"éjectera" => "eZEkt°Ra",
"éjecterais" => "eZEkt°RE",
"éjectèrent" => "eZEktER",
"éjectés" => "eZEkte",
"éjecteur" => "eZEkt9R",
"éjecteurs" => "eZEkt9R",
"éjectez" => "eZEkte",
"éjection" => "eZEksj§",
"éjections" => "eZEksj§",
"éjectons" => "eZEkt§",
"ektachromes" => "EktakRom",
"élabora" => "elaboRa",
"élaborai" => "elaboRE",
"élaboraient" => "elaboRE",
"élaborait" => "elaboRE",
"élaborant" => "elaboR@",
"élaboration" => "elaboRasj§",
"élaborations" => "elaboRasj§",
"élabore" => "elabOR",
"élaboré" => "elaboRe",
"élaborée" => "elaboRe",
"élaborées" => "elaboRe",
"élaborent" => "elabOR",
"élaborer" => "elaboRe",
"élaboreraient" => "elabOR°RE",
"élaborèrent" => "elaboRER",
"élaborés" => "elaboRe",
"élaboriez" => "elaboRje",
"élaborions" => "elaboRj§",
"élaborons" => "elaboR§",
"élagage" => "elagaZ",
"élaguais" => "elagE",
"élaguait" => "elagE",
"élague" => "elag",
"élagué" => "elage",
"élaguer" => "elage",
"élagués" => "elage",
"élagueur" => "elag9R",
"élagueurs" => "elag9R",
"élaguez" => "elage",
"élaguons" => "elag§",
"élan" => "el@",
"élança" => "el@sa",
"élançai" => "el@sE",
"élançaient" => "el@sE",
"élançais" => "el@sE",
"élançait" => "el@sE",
"élançant" => "el@s@",
"élance" => "el@s",
"élancé" => "el@se",
"élancée" => "el@se",
"élancées" => "el@se",
"élancement" => "el@s°m@",
"élancements" => "el@s°m@",
"élancent" => "el@s",
"élancer" => "el@se",
"élancera" => "el@s°Ra",
"élanceraient" => "el@s°RE",
"élancerait" => "el@s°RE",
"élancèrent" => "el@sER",
"élancerions" => "el@s°Rj§",
"élanceront" => "el@s°R§",
"élancés" => "el@se",
"élancions" => "el@sj§",
"élans" => "el@",
"élargi" => "elaRZi",
"élargie" => "elaRZi",
"élargies" => "elaRZi",
"élargir" => "elaRZiR",
"élargira" => "elaRZiRa",
"élargirait" => "elaRZiRE",
"élargirent" => "elaRZiR",
"élargirez" => "elaRZiRe",
"élargirons" => "elaRZiR§",
"élargis" => "elaRZi",
"élargissaient" => "elaRZisE",
"élargissait" => "elaRZisE",
"élargissant" => "elaRZis@",
"élargissement" => "elaRZis°m@",
"élargissent" => "elaRZis",
"élargissez" => "elaRZise",
"élargissions" => "elaRZisj§",
"élargit" => "elaRZi",
"élargît" => "elaRZi",
"élasticimétrie" => "elastisimetRi",
"élasticité" => "elastisite",
"élastique" => "elastik",
"élastiques" => "elastik",
"élastomère" => "elastomER",
"eldorado" => "EldORado",
"éléates" => "eleat",
"électeur" => "elEkt9R",
"électeurs" => "elEkt9R",
"électif" => "elEktif",
"élection" => "elEksj§",
"élections" => "elEksj§",
"élective" => "elEktiv",
"électivement" => "elEktiv°m@",
"électives" => "elEktiv",
"électoral" => "elEktoRal",
"électorale" => "elEktoRal",
"électoralement" => "elEktoRal°m@",
"électorales" => "elEktoRal",
"électorat" => "elEktoRa",
"électoraux" => "elEktoRo",
"électrice" => "elEktRis",
"électrices" => "elEktRis",
"électricien" => "elEktRisj5",
"électricienne" => "elEktRisjEn",
"électriciennes" => "elEktRisjEn",
"électriciens" => "elEktRisj5",
"électricité" => "elEktRisite",
"électrifia" => "elEktRifja",
"électrifiait" => "elEktRifjE",
"électrifiant" => "elEktRifj@",
"électrification" => "elEktRifikasj§",
"électrifié" => "elEktRifje",
"électrifiée" => "elEktRifje",
"électrifiées" => "elEktRifje",
"électrifier" => "elEktRifje",
"électrifiés" => "elEktRifje",
"électrique" => "elEktRik",
"électriquement" => "elEktRik°m@",
"électriques" => "elEktRik",
"électrisa" => "elEktRiza",
"électrisaient" => "elEktRizE",
"électrisais" => "elEktRizE",
"électrisait" => "elEktRizE",
"électrisant" => "elEktRiz@",
"électrisante" => "elEktRiz@t",
"électrisation" => "elEktRizasj§",
"électrise" => "elEktRiz",
"électrisé" => "elEktRize",
"électrisée" => "elEktRize",
"électrisées" => "elEktRize",
"électrisent" => "elEktRiz",
"électriser" => "elEktRize",
"électrisèrent" => "elEktRizER",
"électro-acoustique" => "elEktRoakustik",
"électro-aimant" => "elEktRoEm@",
"électro-encéphalogramme" => "elEktRo@sefalogRam",
"électroacoustique" => "elEktRoakustik",
"électroaimant" => "elEktRoEm@",
"électroaimants" => "elEktRoEm@",
"électrobiologie" => "elEktRobjoloZi",
"électrocardiogramme" => "elEktRokaRdiogRam",
"électrochimie" => "elEktRoSimi",
"électrochimique" => "elEktRoSimik",
"électrochimiques" => "elEktRoSimik",
"électrochoc" => "elEktRoSOk",
"électrochocs" => "elEktRoSOk",
"électrocutant" => "elEktRokyt@",
"électrocute" => "elEktRokyt",
"électrocuté" => "elEktRokyte",
"électrocutée" => "elEktRokyte",
"électrocutent" => "elEktRokyt",
"électrocuter" => "elEktRokyte",
"électrocutera" => "elEktRokyt°Ra",
"électrocutes" => "elEktRokyt",
"électrocutés" => "elEktRokyte",
"électrocutez" => "elEktRokyte",
"électrocution" => "elEktRokysj§",
"électrode" => "elEktROd",
"électrodes" => "elEktROd",
"électrodynamique" => "elEktRodinamik",
"électroencéphalogramme" => "elEktRo@sefalogRam",
"électroencéphalographie" => "elEktRo@sefalOgRafi",
"électrogène" => "elEktRoZEn",
"électrologie" => "elEktROlOZi",
"électrolyse" => "elEktRoliz",
"électrolyte" => "elEktRolit",
"électrolytes" => "elEktRolit",
"électrolytique" => "elEktRolitik",
"électromagnétique" => "elEktRomaNetik",
"électromagnétiques" => "elEktRomaNetik",
"électromagnétisme" => "elEktRomaNetizm",
"électroménager" => "elEktRomenaZe",
"électromètre" => "elEktROmEtR",
"électron" => "elEktR§",
"électronicien" => "elEktRonisj5",
"électroniciens" => "elEktRonisj5",
"électronique" => "elEktRonik",
"électroniquement" => "elEktRonik°m@",
"électroniques" => "elEktRonik",
"électrons" => "elEktR§",
"électronucléaire" => "elEktRonykleER",
"électronvolts" => "elEktR§vOlt",
"électrophone" => "elEktRofOn",
"électrophones" => "elEktRofOn",
"électrophorèse" => "elEktROfOREz",
"électrostatique" => "elEktRostatik",
"électrostatiques" => "elEktRostatik",
"électrum" => "elEktROm",
"électuaires" => "elEkt8ER",
"élégamment" => "elegam@",
"élégance" => "eleg@s",
"élégances" => "eleg@s",
"élégant" => "eleg@",
"élégante" => "eleg@t",
"élégantes" => "eleg@t",
"élégants" => "eleg@",
"élégiaque" => "eleZjak",
"élégiaques" => "eleZjak",
"élégie" => "eleZi",
"élégies" => "eleZi",
"élément" => "elem@",
"élément-clé" => "elem@kle",
"élémentaire" => "elem@tER",
"élémentaires" => "elem@tER",
"élémentarité" => "elem@taRite",
"éléments" => "elem@",
"éléments-clés" => "elem@kle",
"éléphant" => "elef@",
"éléphante" => "elef@t",
"éléphanteau" => "elef@to",
"éléphantes" => "elef@t",
"éléphantesque" => "elef@tEsk",
"éléphantesques" => "elef@tEsk",
"éléphantiasique" => "elef@tjazik",
"éléphantiasis" => "elef@tjazis",
"éléphantine" => "elef@tin",
"éléphantines" => "elef@tin",
"éléphants" => "elef@",
"éleusinienne" => "el2zinjEn",
"éleva" => "El°va",
"élevage" => "El°vaZ",
"élevages" => "El°vaZ",
"élevai" => "El°vE",
"élevaient" => "El°vE",
"élevais" => "El°vE",
"élevait" => "El°vE",
"élevant" => "El°v@",
"élevât" => "El°va",
"élévateur" => "elevat9R",
"élévateurs" => "elevat9R",
"élévation" => "elevasj§",
"élévations" => "elevasj§",
"élévatrice" => "elevatRis",
"élévatrices" => "elevatRis",
"élève" => "elEv",
"élevé" => "El°ve",
"élevée" => "El°ve",
"élevées" => "El°ve",
"élèvent" => "elEv",
"élever" => "El°ve",
"élèvera" => "elEv°Ra",
"élèverai" => "elEv°RE",
"élèveraient" => "elEv°RE",
"élèverais" => "elEv°RE",
"élèverait" => "elEv°RE",
"élèveras" => "elEv°Ra",
"élevèrent" => "El°vER",
"élèveriez" => "elEv°Rje",
"élèverons" => "elEv°R§",
"élèveront" => "elEv°R§",
"élèves" => "elEv",
"élevés" => "El°ve",
"éleveur" => "El°v9R",
"éleveurs" => "El°v9R",
"éleveuse" => "el°v2z",
"élevez" => "El°ve",
"éleviez" => "el°vje",
"élevions" => "El°vj§",
"élevons" => "El°v§",
"élevures" => "El°vyR",
"elfe" => "Elf",
"elfes" => "Elf",
"élia" => "elja",
"élias" => "elja",
"éliciter" => "elisite",
"élie" => "eli",
"éligibilité" => "eliZibilite",
"éligible" => "eliZibl",
"éligibles" => "eliZibl",
"élimâmes" => "elimam",
"élime" => "elim",
"élimé" => "elime",
"élimée" => "elime",
"élimées" => "elime",
"élimer" => "elime",
"élimés" => "elime",
"élimina" => "elimina",
"éliminais" => "eliminE",
"éliminait" => "eliminE",
"éliminant" => "elimin@",
"éliminateur" => "eliminat9R",
"éliminateurs" => "eliminat9R",
"élimination" => "eliminasj§",
"éliminations" => "eliminasj§",
"éliminatoire" => "eliminatwaR",
"éliminatoires" => "eliminatwaR",
"élimine" => "elimin",
"éliminé" => "elimine",
"éliminée" => "elimine",
"éliminées" => "elimine",
"éliminent" => "elimin",
"éliminer" => "elimine",
"éliminera" => "elimin°Ra",
"éliminerai" => "elimin°RE",
"élimineraient" => "elimin°RE",
"éliminerais" => "elimin°RE",
"éliminerait" => "elimin°RE",
"élimineras" => "elimin°Ra",
"éliminèrent" => "eliminER",
"éliminerez" => "elimin°Re",
"éliminerons" => "elimin°R§",
"élimineront" => "elimin°R§",
"élimines" => "elimin",
"éliminés" => "elimine",
"éliminez" => "elimine",
"éliminiez" => "eliminje",
"éliminons" => "elimin§",
"élingue" => "el5g",
"élirait" => "eliRE",
"élire" => "eliR",
"élirez" => "eliRe",
"éliront" => "eliR§",
"élis" => "eli",
"élisabéthain" => "elizabet5",
"élisabéthaine" => "elizabetEn",
"élisaient" => "elizE",
"élisais" => "elizE",
"élisait" => "elizE",
"élisant" => "eliz@",
"élise" => "eliz",
"élisent" => "eliz",
"élisez" => "elize",
"élit" => "eli",
"élite" => "elit",
"élites" => "elit",
"élitisme" => "elitizm",
"élitiste" => "elitist",
"élitistes" => "elitist",
"élixir" => "eliksiR",
"élixirs" => "eliksiR",
"elle" => "El",
"elle-même" => "ElmEm",
"ellébore" => "elebOR",
"elles" => "El",
"elles-mêmes" => "ElmEm",
"ellipse" => "elips",
"ellipses" => "elips",
"ellipsoïde" => "elipsoid",
"elliptique" => "eliptik",
"elliptiques" => "eliptik",
"élocution" => "elokysj§",
"éloge" => "elOZ",
"éloges" => "elOZ",
"élogieuse" => "eloZj2z",
"élogieuses" => "eloZj2z",
"élogieux" => "eloZj2",
"éloigna" => "elwaNa",
"éloignai" => "elwaNE",
"éloignaient" => "elwaNE",
"éloignais" => "elwaNE",
"éloignait" => "elwaNE",
"éloignâmes" => "elwaNam",
"éloignant" => "elwaN@",
"éloignât" => "elwaNa",
"éloigne" => "elwaN",
"éloigné" => "elwaNe",
"éloignée" => "elwaNe",
"éloignées" => "elwaNe",
"éloignement" => "elwaN°m@",
"éloignent" => "elwaN",
"éloigner" => "elwaNe",
"éloignera" => "elwaN°Ra",
"éloignerai" => "elwaN°RE",
"éloigneraient" => "elwaN°RE",
"éloignerais" => "elwaN°RE",
"éloignerait" => "elwaN°RE",
"éloigneras" => "elwaN°Ra",
"éloignèrent" => "elwaNER",
"éloignerez" => "elwaN°Re",
"éloignerons" => "elwaN°R§",
"éloigneront" => "elwaN°R§",
"éloignes" => "elwaN",
"éloignés" => "elwaNe",
"éloignez" => "elwaNe",
"éloignions" => "elwaN§",
"éloignons" => "elwaN§",
"élongation" => "el§gasj§",
"élongations" => "el§gasj§",
"éloquemment" => "elokam@",
"éloquence" => "elok@s",
"éloquent" => "elok@",
"éloquente" => "elok@t",
"éloquentes" => "elok@t",
"éloquents" => "elok@",
"élu" => "ely",
"élucida" => "elysida",
"élucidai" => "elysidE",
"élucidation" => "elysidasj§",
"élucide" => "elysid",
"élucidé" => "elyside",
"élucidée" => "elyside",
"élucidées" => "elyside",
"élucider" => "elyside",
"élucideraient" => "elysid°RE",
"éluciderait" => "elysid°RE",
"élucidés" => "elyside",
"élucubration" => "elykybRasj§",
"élucubrations" => "elykybRasj§",
"élucubre" => "elykybR",
"élucubrent" => "elykybR",
"élucubrer" => "elykybRe",
"éluda" => "elyda",
"éludai" => "elydE",
"éludaient" => "elydE",
"éludais" => "elydE",
"éludait" => "elydE",
"éludant" => "elyd@",
"éludât" => "elyda",
"élude" => "elyd",
"éludé" => "elyde",
"éludée" => "elyde",
"éludées" => "elyde",
"éludent" => "elyd",
"éluder" => "elyde",
"éludes" => "elyd",
"éludez" => "elyde",
"élue" => "ely",
"élues" => "ely",
"élus" => "ely",
"élusifs" => "elyzif",
"élusive" => "elyziv",
"élut" => "ely",
"élysée" => "elize",
"élyséen" => "elize5",
"élyséenne" => "elizeEn",
"élytre" => "elitR",
"élytres" => "elitR",
"elzévir" => "ElzeviR",
"émaciait" => "emasjE",
"émacie" => "emasi",
"émacié" => "emasje",
"émaciée" => "emasje",
"émaciées" => "emasje",
"émaciés" => "emasje",
"émail" => "emaj",
"émailla" => "emaja",
"émaillaient" => "emajE",
"émaillait" => "emajE",
"émaillant" => "emaj@",
"émaille" => "emaj",
"émaillé" => "emaje",
"émaillée" => "emaje",
"émaillées" => "emaje",
"émaillent" => "emaj",
"émailler" => "emaje",
"émaillés" => "emaje",
"emails" => "imEl",
"émanaient" => "emanE",
"émanait" => "emanE",
"émanant" => "eman@",
"émanation" => "emanasj§",
"émanations" => "emanasj§",
"émancipait" => "em@sipE",
"émancipateur" => "em@sipat9R",
"émancipation" => "em@sipasj§",
"émancipatrice" => "em@sipatRis",
"émancipe" => "em@sip",
"émancipé" => "em@sipe",
"émancipée" => "em@sipe",
"émancipées" => "em@sipe",
"émancipent" => "em@sip",
"émanciper" => "em@sipe",
"émancipés" => "em@sipe",
"émane" => "eman",
"émané" => "emane",
"émanée" => "emane",
"émanées" => "emane",
"émanent" => "eman",
"émaner" => "emane",
"émanera" => "eman°Ra",
"émanerait" => "eman°RE",
"émanés" => "emane",
"émarge" => "emaRZ",
"émargeaient" => "emaRZE",
"émargeait" => "emaRZE",
"émargeant" => "emaRZ@",
"émargement" => "emaRZ°m@",
"émarger" => "emaRZe",
"émasculaient" => "emaskylE",
"émasculation" => "emaskylasj§",
"émascule" => "emaskyl",
"émasculé" => "emaskyle",
"émasculée" => "emaskyle",
"émasculées" => "emaskyle",
"émasculer" => "emaskyle",
"émasculés" => "emaskyle",
"émaux" => "emo",
"embabouiner" => "@babwine",
"embâcle" => "@bakl",
"emballa" => "@bala",
"emballage" => "@balaZ",
"emballages" => "@balaZ",
"emballai" => "@balE",
"emballaient" => "@balE",
"emballais" => "@balE",
"emballait" => "@balE",
"emballant" => "@bal@",
"emballât" => "@bala",
"emballe" => "@bal",
"emballé" => "@bale",
"emballée" => "@bale",
"emballées" => "@bale",
"emballement" => "@bal°m@",
"emballements" => "@bal°m@",
"emballent" => "@bal",
"emballer" => "@bale",
"emballera" => "@bal°Ra",
"emballeraient" => "@bal°RE",
"emballerait" => "@bal°RE",
"emballeras" => "@bal°Ra",
"emballèrent" => "@balER",
"emballerons" => "@bal°R§",
"emballes" => "@bal",
"emballés" => "@bale",
"emballeur" => "@bal9R",
"emballeurs" => "@bal9R",
"emballeuse" => "@bal2z",
"emballeuses" => "@bal2z",
"emballez" => "@bale",
"emballons" => "@bal§",
"embaluchonnés" => "@balySone",
"embarbouilla" => "@baRbuja",
"embarbouillé" => "@baRbuje",
"embarcadère" => "@baRkadER",
"embarcadères" => "@baRkadER",
"embarcation" => "@baRkasj§",
"embarcations" => "@baRkasj§",
"embardée" => "@baRde",
"embardées" => "@baRde",
"embargo" => "@baRgo",
"embargos" => "@baRgo",
"embarqua" => "@baRka",
"embarquai" => "@baRkE",
"embarquaient" => "@baRkE",
"embarquais" => "@baRkE",
"embarquait" => "@baRkE",
"embarquâmes" => "@baRkam",
"embarquant" => "@baRk@",
"embarque" => "@baRk",
"embarqué" => "@baRke",
"embarquée" => "@baRke",
"embarquées" => "@baRke",
"embarquement" => "@baRk°m@",
"embarquements" => "@baRk°m@",
"embarquent" => "@baRk",
"embarquer" => "@baRke",
"embarquera" => "@baRk°Ra",
"embarquerai" => "@baRk°RE",
"embarqueraient" => "@baRk°RE",
"embarquerais" => "@baRk°RE",
"embarquerait" => "@baRk°RE",
"embarqueras" => "@baRk°Ra",
"embarquèrent" => "@baRkER",
"embarquerez" => "@baRk°Re",
"embarquerions" => "@baRk°Rj§",
"embarqueront" => "@baRk°R§",
"embarqués" => "@baRke",
"embarquez" => "@baRke",
"embarquiez" => "@baRkje",
"embarquions" => "@baRkj§",
"embarquons" => "@baRk§",
"embarras" => "@baRa",
"embarrassa" => "@baRasa",
"embarrassai" => "@baRasE",
"embarrassaient" => "@baRasE",
"embarrassais" => "@baRasE",
"embarrassait" => "@baRasE",
"embarrassant" => "@baRas@",
"embarrassante" => "@baRas@t",
"embarrassantes" => "@baRas@t",
"embarrassants" => "@baRas@",
"embarrasse" => "@baRas",
"embarrassé" => "@baRase",
"embarrassée" => "@baRase",
"embarrassées" => "@baRase",
"embarrassent" => "@baRas",
"embarrasser" => "@baRase",
"embarrasserai" => "@baRas°RE",
"embarrasseraient" => "@baRas°RE",
"embarrassèrent" => "@baRasER",
"embarrasses" => "@baRas",
"embarrassés" => "@baRase",
"embarrassez" => "@baRase",
"embarrassions" => "@baRasj§",
"embarrassons" => "@baRas§",
"embarrure" => "@baRyR",
"embase" => "@baz",
"embases" => "@baz",
"embastillé" => "@bastije",
"embastillée" => "@bastije",
"embastiller" => "@bastije",
"embastillés" => "@bastije",
"embats" => "@ba",
"embaucha" => "@boSa",
"embauchage" => "@boSaZ",
"embauchaient" => "@boSE",
"embauchais" => "@boSE",
"embauchait" => "@boSE",
"embauchant" => "@boS@",
"embauchât" => "@boSa",
"embauche" => "@boS",
"embauché" => "@boSe",
"embauchée" => "@boSe",
"embauchées" => "@boSe",
"embauchent" => "@boS",
"embaucher" => "@boSe",
"embauchera" => "@boS°Ra",
"embaucherai" => "@boS°RE",
"embaucherais" => "@boS°RE",
"embaucherait" => "@boS°RE",
"embaucheront" => "@boS°R§",
"embauches" => "@boS",
"embauchés" => "@boSe",
"embauchez" => "@boSe",
"embauchoir" => "@boSwaR",
"embauchoirs" => "@boSwaR",
"embauchons" => "@boS§",
"embauma" => "@boma",
"embaumaient" => "@bomE",
"embaumait" => "@bomE",
"embaumant" => "@bom@",
"embaumants" => "@bom@",
"embaume" => "@bom",
"embaumé" => "@bome",
"embaumée" => "@bome",
"embaumées" => "@bome",
"embaumement" => "@bom°m@",
"embaumements" => "@bom°m@",
"embaument" => "@bom",
"embaumer" => "@bome",
"embaumerait" => "@bom°RE",
"embaumés" => "@bome",
"embaumeur" => "@bom9R",
"embaumeurs" => "@bom9R",
"embaumeuse" => "@bom2z",
"embaumez" => "@bome",
"embaumions" => "@bomj§",
"embéguinées" => "@begine",
"embelli" => "@bEli",
"embellie" => "@bEli",
"embellies" => "@bEli",
"embellir" => "@beliR",
"embellira" => "@bEliRa",
"embellirai" => "@bEliRE",
"embellirait" => "@bEliRE",
"embellis" => "@bEli",
"embellissaient" => "@bElisE",
"embellissais" => "@bElisE",
"embellissait" => "@bElisE",
"embellissant" => "@bElis@",
"embellissement" => "@belis°m@",
"embellissements" => "@belis°m@",
"embellissent" => "@bElis",
"embellissez" => "@bElise",
"embellissons" => "@bElis§",
"embellit" => "@bEli",
"emberlificotaient" => "@bERlifikotE",
"emberlificotais" => "@bERlifikotE",
"emberlificote" => "@bERlifikOt",
"emberlificoté" => "@bERlifikote",
"emberlificotée" => "@bERlifikote",
"emberlificotées" => "@bERlifikote",
"emberlificoter" => "@bERlifikote",
"emberlificotés" => "@bERlifikote",
"emberlucoquer" => "@bERlykoke",
"embêtaient" => "@bEtE",
"embêtais" => "@bEtE",
"embêtait" => "@bEtE",
"embêtant" => "@bEt@",
"embêtante" => "@bEt@t",
"embêtantes" => "@bEt@t",
"embêtants" => "@bEt@",
"embête" => "@bEt",
"embêté" => "@bEte",
"embêtée" => "@bEte",
"embêtées" => "@bEte",
"embêtement" => "@bEt°m@",
"embêtements" => "@bEt°m@",
"embêtent" => "@bEt",
"embêter" => "@bete",
"embêtera" => "@bEt°Ra",
"embêterai" => "@bEt°RE",
"embêteraient" => "@bEt°RE",
"embêterais" => "@bEt°RE",
"embêterait" => "@bEt°RE",
"embêtes" => "@bEt",
"embêtés" => "@bEte",
"embêtez" => "@bEte",
"embijoutée" => "@biZute",
"emblavages" => "@blavaZ",
"emblavé" => "@blave",
"emblavée" => "@blave",
"emblaver" => "@blave",
"emblavure" => "@blavyR",
"emblavures" => "@blavyR",
"emblématique" => "@blematik",
"emblématiques" => "@blematik",
"emblème" => "@blEm",
"emblèmes" => "@blEm",
"embobeliner" => "@bOb°line",
"embobinant" => "@bobin@",
"embobine" => "@bobin",
"embobiné" => "@bobine",
"embobinée" => "@bobine",
"embobinées" => "@bobine",
"embobiner" => "@bobine",
"embobinés" => "@bobine",
"embobinez" => "@bobine",
"emboîta" => "@bwata",
"emboîtables" => "@bwatabl",
"emboîtage" => "@bwataZ",
"emboîtages" => "@bwataZ",
"emboîtai" => "@bwatE",
"emboîtaient" => "@bwatE",
"emboîtais" => "@bwatE",
"emboîtait" => "@bwatE",
"emboîtâmes" => "@bwatam",
"emboîtant" => "@bwat@",
"emboîtas" => "@bwata",
"emboîte" => "@bwat",
"emboîté" => "@bwate",
"emboîtée" => "@bwate",
"emboîtées" => "@bwate",
"emboîtement" => "@bwat°m@",
"emboîtent" => "@bwat",
"emboîter" => "@bwate",
"emboîterai" => "@bwat°RE",
"emboîtèrent" => "@bwatER",
"emboîtés" => "@bwate",
"emboîtions" => "@bwatj§",
"emboîtons" => "@bwat§",
"emboîtures" => "@bwatyR",
"embole" => "@bOl",
"embolie" => "@boli",
"embolies" => "@boli",
"embolique" => "@bOlik",
"embonpoint" => "@b§pw5",
"embossé" => "@bose",
"embossée" => "@bose",
"embosser" => "@bose",
"embossés" => "@bose",
"emboucanent" => "@bukan",
"emboucha" => "@buSa",
"embouchant" => "@buS@",
"embouche" => "@buS",
"embouché" => "@buSe",
"embouchée" => "@buSe",
"embouchées" => "@buSe",
"emboucher" => "@buSe",
"emboucherait" => "@buS°RE",
"embouchés" => "@buSe",
"embouchoir" => "@buSwaR",
"embouchoirs" => "@buSwaR",
"embouchure" => "@buSyR",
"embouchures" => "@buSyR",
"embouqué" => "@buke",
"embouquer" => "@buke",
"embourbaient" => "@buRbE",
"embourbait" => "@buRbE",
"embourbe" => "@buRb",
"embourbé" => "@buRbe",
"embourbée" => "@buRbe",
"embourbées" => "@buRbe",
"embourbent" => "@buRb",
"embourber" => "@buRbe",
"embourbés" => "@buRbe",
"embourgeoise" => "@buRZwaz",
"embourgeoisé" => "@buRZwaze",
"embourgeoisement" => "@buRZwaz°m@",
"embourgeoiser" => "@buRZwaze",
"embourgeoises" => "@buRZwaz",
"embourgeoisés" => "@buRZwaze",
"embout" => "@bu",
"embouteillage" => "@butEjaZ",
"embouteillages" => "@butEjaZ",
"embouteillait" => "@butEjE",
"embouteille" => "@butEj",
"embouteillé" => "@butEje",
"embouteillée" => "@butEje",
"embouteillées" => "@butEje",
"embouteiller" => "@buteje",
"embouti" => "@buti",
"emboutie" => "@buti",
"embouties" => "@buti",
"emboutir" => "@butiR",
"emboutis" => "@buti",
"emboutissant" => "@butis@",
"emboutisseur" => "@butis9R",
"emboutisseuse" => "@butis2z",
"emboutit" => "@buti",
"embouts" => "@bu",
"embranchant" => "@bR@S@",
"embranchement" => "@bR@S°m@",
"embranchements" => "@bR@S°m@",
"embraquer" => "@bRake",
"embrasa" => "@bRaza",
"embrasaient" => "@bRazE",
"embrasait" => "@bRazE",
"embrasant" => "@bRaz@",
"embrase" => "@bRaz",
"embrasé" => "@bRaze",
"embrasée" => "@bRaze",
"embrasées" => "@bRaze",
"embrasement" => "@bRaz°m@",
"embrasements" => "@bRaz°m@",
"embrasent" => "@bRaz",
"embraser" => "@bRaze",
"embrasera" => "@bRaz°Ra",
"embraserait" => "@bRaz°RE",
"embrasèrent" => "@bRazER",
"embrasés" => "@bRaze",
"embrasez" => "@bRaze",
"embrassa" => "@bRasa",
"embrassade" => "@bRasad",
"embrassades" => "@bRasad",
"embrassai" => "@bRasE",
"embrassaient" => "@bRasE",
"embrassais" => "@bRasE",
"embrassait" => "@bRasE",
"embrassâmes" => "@bRasam",
"embrassant" => "@bRas@",
"embrassât" => "@bRasa",
"embrassâtes" => "@bRasat",
"embrasse" => "@bRas",
"embrassé" => "@bRase",
"embrassée" => "@bRase",
"embrassées" => "@bRase",
"embrassement" => "@bRas°m@",
"embrassements" => "@bRas°m@",
"embrassent" => "@bRas",
"embrasser" => "@bRase",
"embrassera" => "@bRas°Ra",
"embrasserai" => "@bRas°RE",
"embrasseraient" => "@bRas°RE",
"embrasserais" => "@bRas°RE",
"embrasserait" => "@bRas°RE",
"embrasseras" => "@bRas°Ra",
"embrassèrent" => "@bRasER",
"embrasserez" => "@bRas°Re",
"embrasseriez" => "@bRas°Rje",
"embrasseront" => "@bRas°R§",
"embrasses" => "@bRas",
"embrassés" => "@bRase",
"embrasseur" => "@bRas9R",
"embrasseurs" => "@bRas9R",
"embrasseuse" => "@bRas2z",
"embrasseuses" => "@bRas2z",
"embrassez" => "@bRase",
"embrassiez" => "@bRasje",
"embrassions" => "@bRasj§",
"embrassons" => "@bRas§",
"embrasure" => "@bRazyR",
"embrasures" => "@bRazyR",
"embraya" => "@bReja",
"embrayage" => "@bREjaZ",
"embrayages" => "@bREjaZ",
"embrayais" => "@bRejE",
"embrayait" => "@bRejE",
"embrayant" => "@bRej@",
"embraye" => "@bRej",
"embrayé" => "@bReje",
"embrayée" => "@bReje",
"embrayer" => "@bReje",
"embrayes" => "@bRej",
"embrigadé" => "@bRigade",
"embrigadée" => "@bRigade",
"embringua" => "@bR5ga",
"embringuaient" => "@bR5gE",
"embringuait" => "@bR5gE",
"embringué" => "@bR5ge",
"embringuée" => "@bR5ge",
"embringuer" => "@bR5ge",
"embringues" => "@bR5g",
"embrocation" => "@bRokasj§",
"embrocations" => "@bRokasj§",
"embrocha" => "@bRoSa",
"embrochais" => "@bRoSE",
"embrochant" => "@bRoS@",
"embroche" => "@bROS",
"embroché" => "@bRoSe",
"embrochée" => "@bRoSe",
"embrochées" => "@bRoSe",
"embrochent" => "@bROS",
"embrocher" => "@bRoSe",
"embrochera" => "@bROS°Ra",
"embrochèrent" => "@bRoSER",
"embrochés" => "@bRoSe",
"embrochez" => "@bRoSe",
"embrouilla" => "@bRuja",
"embrouillage" => "@bRujaZ",
"embrouillai" => "@bRujE",
"embrouillaient" => "@bRujE",
"embrouillais" => "@bRujE",
"embrouillait" => "@bRujE",
"embrouillamini" => "@bRujamini",
"embrouillaminis" => "@bRujamini",
"embrouillant" => "@bRuj@",
"embrouillasse" => "@bRujas",
"embrouillât" => "@bRuja",
"embrouille" => "@bRuj",
"embrouillé" => "@bRuje",
"embrouillée" => "@bRuje",
"embrouillées" => "@bRuje",
"embrouillement" => "@bRuj°m@",
"embrouillements" => "@bRuj°m@",
"embrouillent" => "@bRuj",
"embrouiller" => "@bRuje",
"embrouillerai" => "@bRuj°RE",
"embrouillerais" => "@bRuj°RE",
"embrouillerait" => "@bRuj°RE",
"embrouillèrent" => "@bRujER",
"embrouilles" => "@bRuj",
"embrouillés" => "@bRuje",
"embrouilleur" => "@bRuj9R",
"embrouilleurs" => "@bRuj9R",
"embrouilleuses" => "@bRuj2z",
"embrouillez" => "@bRuje",
"embroussaille" => "@bRusaj",
"embroussaillé" => "@bRusaje",
"embroussaillée" => "@bRusaje",
"embroussaillées" => "@bRusaje",
"embroussailler" => "@bRusaje",
"embroussaillés" => "@bRusaje",
"embruiné" => "@bR8ine",
"embrumait" => "@bRymE",
"embrume" => "@bRym",
"embrumé" => "@bRyme",
"embrumée" => "@bRyme",
"embrumées" => "@bRyme",
"embrument" => "@bRym",
"embrumer" => "@bRyme",
"embrumés" => "@bRyme",
"embrun" => "@bR1",
"embruns" => "@bR1",
"embryologie" => "@bRijOlOZi",
"embryologiste" => "@bRijOlOZist",
"embryon" => "@bRij§",
"embryonnaire" => "@bRijonER",
"embryonnaires" => "@bRijonER",
"embryons" => "@bRij§",
"embu" => "@by",
"embua" => "@b8a",
"embuaient" => "@b8E",
"embuait" => "@b8E",
"embuant" => "@b8@",
"embûche" => "@byS",
"embûches" => "@byS",
"embue" => "@by",
"embué" => "@b8e",
"embuée" => "@b8e",
"embuées" => "@b8e",
"embuent" => "@by",
"embuer" => "@b8e",
"embuèrent" => "@b8ER",
"embués" => "@b8e",
"embus" => "@by",
"embuscade" => "@byskad",
"embuscades" => "@byskad",
"embusqua" => "@byska",
"embusquaient" => "@byskE",
"embusquait" => "@byskE",
"embusque" => "@bysk",
"embusqué" => "@byske",
"embusquée" => "@byske",
"embusquées" => "@byske",
"embusquent" => "@bysk",
"embusquer" => "@byske",
"embusqués" => "@byske",
"éméché" => "emeSe",
"éméchée" => "emeSe",
"éméchées" => "emeSe",
"émèchent" => "emES",
"éméchés" => "emeSe",
"émeraude" => "Em°Rod",
"émeraudes" => "Em°Rod",
"émerge" => "emERZ",
"émergé" => "emERZe",
"émergea" => "emERZa",
"émergeai" => "emERZE",
"émergeaient" => "emERZE",
"émergeais" => "emERZE",
"émergeait" => "emERZE",
"émergeant" => "emERZ@",
"émergeât" => "emERZa",
"émergée" => "emERZe",
"émergées" => "emERZe",
"émergence" => "emERZ@s",
"émergences" => "emERZ@s",
"emergency" => "im9RdZansi",
"émergent" => "emERZ",
"émergente" => "emERZ@t",
"émergeons" => "emERZ§",
"émerger" => "emERZe",
"émergera" => "emERZ°Ra",
"émergerait" => "emERZ°RE",
"émergeras" => "emERZ°Ra",
"émergèrent" => "emERZER",
"émergerons" => "emERZ°R§",
"émergeront" => "emERZ°R§",
"émerges" => "emERZ",
"émergés" => "emERZe",
"émergions" => "emERZj§",
"émeri" => "Em°Ri",
"émerillon" => "Em°Rij§",
"émerillonné" => "Em°Rijone",
"émerisé" => "Em°Rize",
"émerisées" => "Em°Rize",
"émérite" => "emeRit",
"émérites" => "emeRit",
"émersion" => "emERsj§",
"émerveilla" => "emERvEja",
"émerveillai" => "emERvEjE",
"émerveillaient" => "emERvEjE",
"émerveillais" => "emERvEjE",
"émerveillait" => "emERvEjE",
"émerveillant" => "emERvEj@",
"émerveille" => "emERvEj",
"émerveillé" => "emERveje",
"émerveillée" => "emERveje",
"émerveillées" => "emERveje",
"émerveillement" => "emERvEj°m@",
"émerveillements" => "emERvEj°m@",
"émerveillent" => "emERvEj",
"émerveiller" => "emERveje",
"émerveillerait" => "emERvEj°RE",
"émerveillèrent" => "emERvEjER",
"émerveillés" => "emERveje",
"émet" => "emE",
"émétine" => "emetin",
"émétique" => "emetik",
"émets" => "emE",
"émettaient" => "emEtE",
"émettait" => "emEtE",
"émettant" => "emEt@",
"émette" => "emEt",
"émettent" => "emEt",
"émetteur" => "emet9R",
"émetteur-récepteur" => "emet9RResEpt9R",
"émetteurs" => "emet9R",
"émettez" => "emEte",
"émettons" => "emEt§",
"émettra" => "emEtRa",
"émettrai" => "emEtRE",
"émettre" => "emEtR",
"émettrice" => "emetRis",
"émettrons" => "emEtR§",
"émettront" => "emEtR§",
"émeu" => "em2",
"émeus" => "em2",
"émeut" => "em2",
"émeute" => "em2t",
"émeutes" => "em2t",
"émeutier" => "em2tje",
"émeutiers" => "em2tje",
"émeuve" => "em9v",
"émeuvent" => "em9v",
"émietta" => "emjEta",
"émiettaient" => "emjEtE",
"émiettait" => "emjEtE",
"émiette" => "emjEt",
"émietté" => "emjEte",
"émiettée" => "emjEte",
"émiettement" => "emjEt°m@",
"émiettements" => "emjEt°m@",
"émiettent" => "emjEt",
"émietter" => "emjete",
"émietterait" => "emjEt°RE",
"émiettèrent" => "emjEtER",
"émiettés" => "emjEte",
"émiettez" => "emjEte",
"émigra" => "emigRa",
"émigrai" => "emigRE",
"émigraient" => "emigRE",
"émigrais" => "emigRE",
"émigrait" => "emigRE",
"émigrant" => "emigR@",
"émigrante" => "emigR@t",
"émigrants" => "emigR@",
"émigration" => "emigRasj§",
"émigre" => "emigR",
"émigré" => "emigRe",
"émigrée" => "emigRe",
"émigrent" => "emigR",
"émigrer" => "emigRe",
"émigrèrent" => "emigRER",
"émigrés" => "emigRe",
"émilien" => "emilj5",
"émilienne" => "emiljEn",
"émincé" => "em5se",
"émincée" => "em5se",
"émincées" => "em5se",
"émincer" => "em5se",
"émincés" => "em5se",
"émincez" => "em5se",
"éminemment" => "eminam@",
"éminence" => "emin@s",
"éminences" => "emin@s",
"éminent" => "emin@",
"éminente" => "emin@t",
"éminentes" => "emin@t",
"éminentissimes" => "emin@tisim",
"éminents" => "emin@",
"émir" => "emiR",
"émirat" => "emiRa",
"émirats" => "emiRa",
"émirs" => "emiR",
"émis" => "emi",
"émise" => "emiz",
"émises" => "emiz",
"émissaire" => "emisER",
"émissaires" => "emisER",
"émission" => "emisj§",
"émissions" => "emisj§",
"émit" => "emi",
"emmagasinaient" => "@magazinE",
"emmagasinais" => "@magazinE",
"emmagasinait" => "@magazinE",
"emmagasine" => "@magazin",
"emmagasiné" => "@magazine",
"emmagasinée" => "@magazine",
"emmagasinées" => "@magazine",
"emmagasinent" => "@magazin",
"emmagasiner" => "@magazine",
"emmagasinés" => "@magazine",
"emmaillota" => "@majota",
"emmaillotaient" => "@majotE",
"emmailloté" => "@majote",
"emmaillotée" => "@majote",
"emmaillotées" => "@majote",
"emmaillotement" => "@majOt°m@",
"emmailloter" => "@majote",
"emmaillotés" => "@majote",
"emmanchage" => "@m@SaZ",
"emmanchant" => "@m@S@",
"emmanche" => "@m@S",
"emmanché" => "@m@Se",
"emmanchée" => "@m@Se",
"emmanchées" => "@m@Se",
"emmanchent" => "@m@S",
"emmancher" => "@m@Se",
"emmanchés" => "@m@Se",
"emmanchure" => "@m@SyR",
"emmanchures" => "@m@SyR",
"emmêla" => "@mEla",
"emmêlai" => "@mElE",
"emmêlaient" => "@mElE",
"emmêlait" => "@mElE",
"emmêlant" => "@mEl@",
"emmêle" => "@mEl",
"emmêlé" => "@mele",
"emmêlée" => "@mele",
"emmêlées" => "@mele",
"emmêlement" => "@mEl°m@",
"emmêlements" => "@mEl°m@",
"emmêlent" => "@mEl",
"emmêler" => "@mele",
"emmêlera" => "@mEl°Ra",
"emmêlèrent" => "@mElER",
"emmêleront" => "@mEl°R§",
"emmêles" => "@mEl",
"emmêlés" => "@mele",
"emmena" => "@m°na",
"emménage" => "@menaZ",
"emménagé" => "@menaZe",
"emménagea" => "@menaZa",
"emménageaient" => "@menaZE",
"emménageais" => "@menaZE",
"emménageait" => "@menaZE",
"emménageant" => "@menaZ@",
"emménagement" => "@menaZ°m@",
"emménagent" => "@menaZ",
"emménageons" => "@menaZ§",
"emménager" => "@menaZe",
"emménagera" => "@menaZ°Ra",
"emménagerai" => "@menaZ°RE",
"emménagerais" => "@menaZ°RE",
"emménagerait" => "@menaZ°RE",
"emménagèrent" => "@menaZER",
"emménagerez" => "@menaZ°Re",
"emménagerons" => "@menaZ°R§",
"emménages" => "@menaZ",
"emménagez" => "@menaZe",
"emménagiez" => "@menaZje",
"emménagions" => "@menaZj§",
"emmenai" => "@m°nE",
"emmenaient" => "@m°nE",
"emmenais" => "@m°nE",
"emmenait" => "@m°nE",
"emmenant" => "@m°n@",
"emmenât" => "@m°na",
"emmène" => "@mEn",
"emmené" => "@m°ne",
"emmenée" => "@m°ne",
"emmenées" => "@m°ne",
"emmènent" => "@mEn",
"emmener" => "@m°ne",
"emmènera" => "@mEn°Ra",
"emmènerai" => "@mEn°RE",
"emmèneraient" => "@mEn°RE",
"emmènerais" => "@mEn°RE",
"emmènerait" => "@mEn°RE",
"emmèneras" => "@mEn°Ra",
"emmenèrent" => "@m°nER",
"emmènerez" => "@mEn°Re",
"emmèneriez" => "@mEn°Rje",
"emmènerions" => "@mEn°Rj§",
"emmènerons" => "@mEn°R§",
"emmèneront" => "@mEn°R§",
"emmènes" => "@mEn",
"emmenés" => "@m°ne",
"emmenez" => "@m°ne",
"emmeniez" => "@m°nje",
"emmenions" => "@m°nj§",
"emmenons" => "@m°n§",
"emmenotté" => "@m2note",
"emmental" => "em5tal",
"emmenthal" => "em@tal",
"emmerda" => "@mERda",
"emmerdaient" => "@mERdE",
"emmerdais" => "@mERdE",
"emmerdait" => "@mERdE",
"emmerdant" => "@mERd@",
"emmerdante" => "@mERd@t",
"emmerdantes" => "@mERd@t",
"emmerdants" => "@mERd@",
"emmerdatoires" => "@mERdatwaR",
"emmerde" => "@mERd",
"emmerdé" => "@mERde",
"emmerdée" => "@mERde",
"emmerdement" => "@mERd°m@",
"emmerdements" => "@mERd°m@",
"emmerdent" => "@mERd",
"emmerder" => "@mERde",
"emmerdera" => "@mERd°Ra",
"emmerderai" => "@mERd°RE",
"emmerderaient" => "@mERd°RE",
"emmerderais" => "@mERd°RE",
"emmerderait" => "@mERd°RE",
"emmerderez" => "@mERd°Re",
"emmerderont" => "@mERd°R§",
"emmerdes" => "@mERd",
"emmerdés" => "@mERde",
"emmerdeur" => "@mERd9R",
"emmerdeurs" => "@mERd9R",
"emmerdeuse" => "@mERd2z",
"emmerdeuses" => "@mERd2z",
"emmerdez" => "@mERde",
"emmerdons" => "@mERd§",
"emmi" => "@mi",
"emmitoufla" => "@mitufla",
"emmitouflai" => "@mituflE",
"emmitouflait" => "@mituflE",
"emmitouflant" => "@mitufl@",
"emmitoufle" => "@mitufl",
"emmitouflé" => "@mitufle",
"emmitouflée" => "@mitufle",
"emmitouflées" => "@mitufle",
"emmitoufler" => "@mitufle",
"emmitouflés" => "@mitufle",
"emmitouflez" => "@mitufle",
"emmouflé" => "@mufle",
"emmouscaillements" => "@muskaj°m@",
"emmura" => "@myRa",
"emmurait" => "@myRE",
"emmure" => "@myR",
"emmuré" => "@myRe",
"emmurée" => "@myRe",
"emmurées" => "@myRe",
"emmurement" => "@myR°m@",
"emmurer" => "@myRe",
"emmurés" => "@myRe",
"émoi" => "emwa",
"émois" => "emwa",
"émollient" => "emolj@",
"émolliente" => "emolj@t",
"émoluments" => "emolym@",
"émondait" => "em§dE",
"émondé" => "em§de",
"émondée" => "em§de",
"émondées" => "em§de",
"émonder" => "em§de",
"émondera" => "em§d°Ra",
"émondeur" => "em§d9R",
"émondons" => "em§d§",
"émotif" => "emotif",
"émotifs" => "emotif",
"émotion" => "emosj§",
"émotionnante" => "emosjon@t",
"émotionne" => "emosjOn",
"émotionné" => "emosjone",
"émotionnel" => "emosjonEl",
"émotionnelle" => "emosjonEl",
"émotionnellement" => "emosjonEl°m@",
"émotionnelles" => "emosjonEl",
"émotionnels" => "emosjonEl",
"émotions" => "emosj§",
"émotive" => "emotiv",
"émotives" => "emotiv",
"émotivité" => "emotivite",
"émouchets" => "emuSE",
"émoulu" => "emuly",
"émoulue" => "emuly",
"émoulus" => "emuly",
"émoussa" => "emusa",
"émoussai" => "emusE",
"émoussaient" => "emusE",
"émoussait" => "emusE",
"émoussant" => "emus@",
"émousse" => "emus",
"émoussé" => "emuse",
"émoussée" => "emuse",
"émoussées" => "emuse",
"émoussement" => "emus°m@",
"émoussent" => "emus",
"émousser" => "emuse",
"émoussèrent" => "emusER",
"émousseront" => "emus°R§",
"émoussés" => "emuse",
"émoustilla" => "emustija",
"émoustillait" => "emustijE",
"émoustillant" => "emustij@",
"émoustillante" => "emustij@t",
"émoustillé" => "emustije",
"émoustillée" => "emustije",
"émoustillées" => "emustije",
"émoustiller" => "emustije",
"émoustillera" => "emustij°Ra",
"émoustillés" => "emustije",
"émouvaient" => "emuvE",
"émouvais" => "emuvE",
"émouvait" => "emuvE",
"émouvant" => "emuv@",
"émouvante" => "emuv@t",
"émouvantes" => "emuv@t",
"émouvants" => "emuv@",
"émouvez" => "emuve",
"émouvoir" => "emuvwaR",
"émouvrait" => "emuvRE",
"empaffe" => "@paf",
"empaffé" => "@pafe",
"empaffer" => "@pafe",
"empaffés" => "@pafe",
"empaillant" => "@paj@",
"empaillé" => "@paje",
"empaillée" => "@paje",
"empaillées" => "@paje",
"empailler" => "@paje",
"empaillés" => "@paje",
"empailleur" => "@paj9R",
"empailleurs" => "@paj9R",
"empaillez" => "@paje",
"empalait" => "@palE",
"empalant" => "@pal@",
"empale" => "@pal",
"empalé" => "@pale",
"empalée" => "@pale",
"empalées" => "@pale",
"empalement" => "@pal°m@",
"empaler" => "@pale",
"empalerais" => "@pal°RE",
"empaleront" => "@pal°R§",
"empalés" => "@pale",
"empalmait" => "@palmE",
"empalme" => "@palm",
"empalmé" => "@palme",
"empan" => "@p@",
"empanaché" => "@panaSe",
"empanachée" => "@panaSe",
"empanachées" => "@panaSe",
"empanachés" => "@panaSe",
"empanner" => "@pane",
"empapaouté" => "@papaute",
"empapaoutent" => "@papaut",
"empapaouter" => "@papaute",
"empapaoutés" => "@papaute",
"empaqueta" => "@pak°ta",
"empaquetage" => "@pak°taZ",
"empaqueté" => "@pak°te",
"empaquetée" => "@pak°te",
"empaquetées" => "@pak°te",
"empaqueter" => "@pak°te",
"empaquetèrent" => "@pak°tER",
"empaquetés" => "@pak°te",
"empaqueteur" => "@pak°t9R",
"empaquette" => "@pakEt",
"empaquettent" => "@pakEt",
"empaquettes" => "@pakEt",
"empara" => "@paRa",
"emparadisé" => "@paRadize",
"emparai" => "@paRE",
"emparaient" => "@paRE",
"emparais" => "@paRE",
"emparait" => "@paRE",
"emparant" => "@paR@",
"emparassent" => "@paRas",
"emparât" => "@paRa",
"empare" => "@paR",
"emparé" => "@paRe",
"emparée" => "@paRe",
"emparées" => "@paRe",
"emparent" => "@paR",
"emparer" => "@paRe",
"emparera" => "@paR°Ra",
"emparerai" => "@paR°RE",
"empareraient" => "@paR°RE",
"emparerais" => "@paR°RE",
"emparerait" => "@paR°RE",
"emparèrent" => "@paRER",
"empareront" => "@paR°R§",
"emparés" => "@paRe",
"emparez" => "@paRe",
"emparons" => "@paR§",
"empâta" => "@pata",
"empâtait" => "@patE",
"empâte" => "@pat",
"empâté" => "@pate",
"empâtée" => "@pate",
"empâtées" => "@pate",
"empâtement" => "@pat°m@",
"empâtements" => "@pat°m@",
"empâtent" => "@pat",
"empâter" => "@pate",
"empâtés" => "@pate",
"empathie" => "@pati",
"empathique" => "@patik",
"empathiques" => "@patik",
"empattement" => "@pat°m@",
"empattements" => "@pat°m@",
"empaume" => "@pom",
"empaumer" => "@pome",
"empaumure" => "@pomyR",
"empaumures" => "@pomyR",
"empêcha" => "@pESa",
"empêchai" => "@pESE",
"empêchaient" => "@pESE",
"empêchais" => "@pESE",
"empêchait" => "@pESE",
"empêchant" => "@pES@",
"empêchât" => "@pESa",
"empêche" => "@pES",
"empêché" => "@peSe",
"empêchée" => "@peSe",
"empêchées" => "@peSe",
"empêchement" => "@pES°m@",
"empêchements" => "@pES°m@",
"empêchent" => "@pES",
"empêcher" => "@peSe",
"empêchera" => "@pES°Ra",
"empêcherai" => "@pES°RE",
"empêcheraient" => "@pES°RE",
"empêcherais" => "@pES°RE",
"empêcherait" => "@pES°RE",
"empêcheras" => "@pES°Ra",
"empêchèrent" => "@pESER",
"empêcherez" => "@pES°Re",
"empêcherons" => "@pES°R§",
"empêcheront" => "@pES°R§",
"empêches" => "@pES",
"empêchés" => "@peSe",
"empêcheur" => "@pES9R",
"empêcheurs" => "@pES9R",
"empêcheuse" => "@pES2z",
"empêchez" => "@pESe",
"empêchions" => "@pESj§",
"empêchons" => "@pES§",
"empeigne" => "@pEN",
"empeignés" => "@pENe",
"empennage" => "@p°naZ",
"empennait" => "@pEnE",
"empenne" => "@pEn",
"empennée" => "@pEne",
"empennées" => "@pEne",
"empennés" => "@pEne",
"empereur" => "@p°R9R",
"empereurs" => "@p°R9R",
"emperlait" => "@pERlE",
"emperlant" => "@pERl@",
"emperlé" => "@pERle",
"emperlées" => "@pERle",
"emperler" => "@pERle",
"emperlés" => "@pERle",
"emperlousées" => "@pERluze",
"emperruqués" => "@pERyke",
"empesage" => "@p°zaZ",
"empesant" => "@p°z@",
"empesé" => "@p°ze",
"empesée" => "@p°ze",
"empesées" => "@p°ze",
"empesés" => "@p°ze",
"empesta" => "@pEsta",
"empestaient" => "@pEstE",
"empestais" => "@pEstE",
"empestait" => "@pEstE",
"empestant" => "@pEst@",
"empeste" => "@pEst",
"empesté" => "@pEste",
"empestée" => "@pEste",
"empestées" => "@pEste",
"empestent" => "@pEst",
"empester" => "@pEste",
"empestes" => "@pEst",
"empestez" => "@pEste",
"empêtra" => "@pEtRa",
"empêtraient" => "@pEtRE",
"empêtrais" => "@pEtRE",
"empêtrait" => "@pEtRE",
"empêtrant" => "@pEtR@",
"empêtre" => "@pEtR",
"empêtré" => "@petRe",
"empêtrée" => "@petRe",
"empêtrées" => "@petRe",
"empêtrent" => "@pEtR",
"empêtrer" => "@petRe",
"empêtrés" => "@petRe",
"empêtrons" => "@pEtR§",
"emphase" => "@faz",
"emphases" => "@faz",
"emphatique" => "@fatik",
"emphatiquement" => "@fatik°m@",
"emphatiques" => "@fatik",
"emphatise" => "@fatiz",
"emphysémateuse" => "@fizemat2z",
"emphysème" => "@fizEm",
"emphysèmes" => "@fizEm",
"empiècement" => "@pjEs°m@",
"empiècements" => "@pjEs°m@",
"empierrage" => "@pjeRaZ",
"empierrait" => "@pjeRE",
"empierré" => "@pjeRe",
"empierrée" => "@pjeRe",
"empierrées" => "@pjeRe",
"empierrement" => "@pjER°m@",
"empierrer" => "@pjERe",
"empierrés" => "@pjeRe",
"empiétaient" => "@pjetE",
"empiétais" => "@pjetE",
"empiétait" => "@pjetE",
"empiétant" => "@pjet@",
"empiète" => "@pjEt",
"empiété" => "@pjete",
"empiétement" => "@pjEt°m@",
"empiétements" => "@pjEt°m@",
"empiètements" => "@pjEt°m@",
"empiètent" => "@pjEt",
"empiéter" => "@pjete",
"empiètes" => "@pjEt",
"empiétez" => "@pjete",
"empiffra" => "@pifRa",
"empiffraient" => "@pifRE",
"empiffrais" => "@pifRE",
"empiffrait" => "@pifRE",
"empiffrant" => "@pifR@",
"empiffre" => "@pifR",
"empiffrée" => "@pifRe",
"empiffrées" => "@pifRe",
"empiffrent" => "@pifR",
"empiffrer" => "@pifRe",
"empiffres" => "@pifR",
"empiffrez" => "@pifRe",
"empila" => "@pila",
"empilage" => "@pilaZ",
"empilages" => "@pilaZ",
"empilaient" => "@pilE",
"empilais" => "@pilE",
"empilait" => "@pilE",
"empilant" => "@pil@",
"empile" => "@pil",
"empilé" => "@pile",
"empilée" => "@pile",
"empilées" => "@pile",
"empilement" => "@pil°m@",
"empilements" => "@pil°m@",
"empilent" => "@pil",
"empiler" => "@pile",
"empilerai" => "@pil°RE",
"empilèrent" => "@pilER",
"empilerions" => "@pil°Rj§",
"empilés" => "@pile",
"empilez" => "@pile",
"empilons" => "@pil§",
"empira" => "@piRa",
"empirait" => "@piRE",
"empirant" => "@piR@",
"empire" => "@piR",
"empiré" => "@piRe",
"empirée" => "@piRe",
"empirent" => "@piR",
"empirer" => "@piRe",
"empirera" => "@piR°Ra",
"empirerait" => "@piR°RE",
"empirèrent" => "@piRER",
"empireront" => "@piR°R§",
"empires" => "@piR",
"empirez" => "@piRe",
"empirique" => "@piRik",
"empiriquement" => "@piRik°m@",
"empiriques" => "@piRik",
"empirisme" => "@piRizm",
"empirismes" => "@piRizm",
"emplacement" => "@plas°m@",
"emplacements" => "@plas°m@",
"emplafonne" => "@plafOn",
"emplafonné" => "@plafone",
"emplafonnée" => "@plafone",
"emplafonnent" => "@plafOn",
"emplafonner" => "@plafone",
"emplanture" => "@pl@tyR",
"emplâtrage" => "@platRaZ",
"emplâtrais" => "@platRE",
"emplâtre" => "@platR",
"emplâtré" => "@platRe",
"emplâtrer" => "@platRe",
"emplâtres" => "@platR",
"emplette" => "@plEt",
"emplettes" => "@plEt",
"empli" => "@pli",
"emplie" => "@pli",
"emplies" => "@pli",
"emplir" => "@pliR",
"emplira" => "@pliRa",
"empliraient" => "@pliRE",
"emplirait" => "@pliRE",
"emplirent" => "@pliR",
"emplis" => "@pli",
"emplissaient" => "@plisE",
"emplissais" => "@plisE",
"emplissait" => "@plisE",
"emplissant" => "@plis@",
"emplissent" => "@plis",
"emplissez" => "@plise",
"emplissons" => "@plis§",
"emplit" => "@pli",
"emplît" => "@pli",
"emploi" => "@plwa",
"emploie" => "@plwa",
"emploient" => "@plwa",
"emploiera" => "@plwaRa",
"emploierai" => "@plwaRE",
"emploieraient" => "@plwaRE",
"emploierais" => "@plwaRE",
"emploierait" => "@plwaRE",
"emploierez" => "@plwaRe",
"emploieriez" => "@plwaRje",
"emploierons" => "@plwaR§",
"emploieront" => "@plwaR§",
"emploies" => "@plwa",
"emplois" => "@plwa",
"employa" => "@plwaja",
"employai" => "@plwajE",
"employaient" => "@plwajE",
"employais" => "@plwajE",
"employait" => "@plwajE",
"employâmes" => "@plwajam",
"employant" => "@plwaj@",
"employât" => "@plwaja",
"employé" => "@plwaje",
"employée" => "@plwaje",
"employées" => "@plwaje",
"employer" => "@plwaje",
"employèrent" => "@plwajER",
"employés" => "@plwaje",
"employeur" => "@plwaj9R",
"employeurs" => "@plwaj9R",
"employez" => "@plwaje",
"employiez" => "@plwaje",
"employions" => "@plwajj§",
"employons" => "@plwaj§",
"empluma" => "@plyma",
"emplume" => "@plym",
"emplumé" => "@plyme",
"emplumée" => "@plyme",
"emplumées" => "@plyme",
"emplumés" => "@plyme",
"empocha" => "@poSa",
"empochai" => "@poSE",
"empochaient" => "@poSE",
"empochais" => "@poSE",
"empochait" => "@poSE",
"empochant" => "@poS@",
"empoche" => "@pOS",
"empoché" => "@poSe",
"empochée" => "@poSe",
"empochées" => "@poSe",
"empochent" => "@pOS",
"empocher" => "@poSe",
"empochera" => "@pOS°Ra",
"empocherais" => "@pOS°RE",
"empocheras" => "@pOS°Ra",
"empoches" => "@pOS",
"empochés" => "@poSe",
"empochez" => "@poSe",
"empochiez" => "@poSje",
"empoigna" => "@pwaNa",
"empoignade" => "@pwaNad",
"empoignades" => "@pwaNad",
"empoignai" => "@pwaNE",
"empoignaient" => "@pwaNE",
"empoignais" => "@pwaNE",
"empoignait" => "@pwaNE",
"empoignant" => "@pwaN@",
"empoigne" => "@pwaN",
"empoigné" => "@pwaNe",
"empoignée" => "@pwaNe",
"empoignées" => "@pwaNe",
"empoignent" => "@pwaN",
"empoigner" => "@pwaNe",
"empoignera" => "@pwaN°Ra",
"empoignèrent" => "@pwaNER",
"empoigneront" => "@pwaN°R§",
"empoignes" => "@pwaN",
"empoignez" => "@pwaNe",
"empoignons" => "@pwaN§",
"empoiler" => "@pwale",
"empoilés" => "@pwale",
"empois" => "@pwa",
"empoisonna" => "@pwazona",
"empoisonnaient" => "@pwazonE",
"empoisonnais" => "@pwazonE",
"empoisonnait" => "@pwazonE",
"empoisonnant" => "@pwazon@",
"empoisonnante" => "@pwazon@t",
"empoisonnantes" => "@pwazon@t",
"empoisonne" => "@pwazOn",
"empoisonné" => "@pwazone",
"empoisonnée" => "@pwazone",
"empoisonnées" => "@pwazone",
"empoisonnement" => "@pwazOn°m@",
"empoisonnements" => "@pwazOn°m@",
"empoisonnent" => "@pwazOn",
"empoisonner" => "@pwazone",
"empoisonnera" => "@pwazOn°Ra",
"empoisonnerai" => "@pwazOn°RE",
"empoisonneraient" => "@pwazOn°RE",
"empoisonnerais" => "@pwazOn°RE",
"empoisonnerez" => "@pwazOn°Re",
"empoisonneront" => "@pwazOn°R§",
"empoisonnes" => "@pwazOn",
"empoisonnés" => "@pwazone",
"empoisonneur" => "@pwazon9R",
"empoisonneurs" => "@pwazon9R",
"empoisonneuse" => "@pwazon2z",
"empoisonneuses" => "@pwazon2z",
"empoisonnez" => "@pwazone",
"empoissait" => "@pwasE",
"empoisse" => "@pwas",
"empoissé" => "@pwase",
"empoisser" => "@pwase",
"empoissés" => "@pwase",
"empoissonné" => "@pwasone",
"empoissonnées" => "@pwasone",
"empoissonner" => "@pwasOne",
"emporium" => "@poRjOm",
"emport" => "@pOR",
"emporta" => "@pORta",
"emportai" => "@pORtE",
"emportaient" => "@pORtE",
"emportais" => "@pORtE",
"emportait" => "@pORtE",
"emportant" => "@pORt@",
"emportât" => "@pORta",
"emporte" => "@pORt",
"emporté" => "@pORte",
"emporte-pièce" => "@pORt°pjEs",
"emportée" => "@pORte",
"emportées" => "@pORte",
"emportement" => "@pORt°m@",
"emportements" => "@pORt°m@",
"emportent" => "@pORt",
"emporter" => "@pORte",
"emportera" => "@pORt°Ra",
"emporterai" => "@pORt°RE",
"emporteraient" => "@pORt°RE",
"emporterais" => "@pORt°RE",
"emporterait" => "@pORt°RE",
"emporteras" => "@pORt°Ra",
"emportèrent" => "@pORtER",
"emporterez" => "@pORt°Re",
"emporteriez" => "@pORt°Rje",
"emporterions" => "@pORt°Rj§",
"emporterons" => "@pORt°R§",
"emporteront" => "@pORt°R§",
"emportes" => "@pORt",
"emportés" => "@pORte",
"emportez" => "@pORte",
"emportiez" => "@pORtje",
"emportions" => "@pORtj§",
"emportons" => "@pORt§",
"empoté" => "@pote",
"empotée" => "@pote",
"empotés" => "@pote",
"empourpra" => "@puRpRa",
"empourprait" => "@puRpRE",
"empourprant" => "@puRpR@",
"empourpre" => "@puRpR",
"empourpré" => "@puRpRe",
"empourprée" => "@puRpRe",
"empourprées" => "@puRpRe",
"empourprent" => "@puRpR",
"empourprer" => "@puRpRe",
"empourprés" => "@puRpRe",
"empoussiérait" => "@pusjeRE",
"empoussière" => "@pusjER",
"empoussiéré" => "@pusjeRe",
"empoussiérée" => "@pusjeRe",
"empoussiérées" => "@pusjeRe",
"empoussièrent" => "@pusjER",
"empoussiérés" => "@pusjeRe",
"empreignit" => "@pRENi",
"empreint" => "@pR5",
"empreinte" => "@pR5t",
"empreintes" => "@pR5t",
"empreints" => "@pR5",
"empressa" => "@pREsa",
"empressai" => "@pREsE",
"empressaient" => "@pREsE",
"empressais" => "@pREsE",
"empressait" => "@pREsE",
"empressâmes" => "@pREsam",
"empressant" => "@pREs@",
"empresse" => "@pREs",
"empressé" => "@pRese",
"empressée" => "@pRese",
"empressées" => "@pRese",
"empressement" => "@pREs°m@",
"empressements" => "@pREs°m@",
"empressent" => "@pREs",
"empresser" => "@pREse",
"empressera" => "@pREs°Ra",
"empresserait" => "@pREs°RE",
"empresseras" => "@pREs°Ra",
"empressèrent" => "@pREsER",
"empresserez" => "@pREs°Re",
"empresses" => "@pREs",
"empressés" => "@pRese",
"emprise" => "@pRiz",
"emprises" => "@pRiz",
"emprisonna" => "@pRizona",
"emprisonnaient" => "@pRizonE",
"emprisonnait" => "@pRizonE",
"emprisonnant" => "@pRizon@",
"emprisonne" => "@pRizOn",
"emprisonné" => "@pRizone",
"emprisonnée" => "@pRizone",
"emprisonnées" => "@pRizone",
"emprisonnement" => "@pRizOn°m@",
"emprisonnements" => "@pRizOn°m@",
"emprisonnent" => "@pRizOn",
"emprisonner" => "@pRizone",
"emprisonnera" => "@pRizOn°Ra",
"emprisonnèrent" => "@pRizonER",
"emprisonnés" => "@pRizone",
"emprisonnez" => "@pRizone",
"emprunt" => "@pR1",
"emprunta" => "@pR1ta",
"empruntai" => "@pR1tE",
"empruntaient" => "@pR1tE",
"empruntais" => "@pR1tE",
"empruntait" => "@pR1tE",
"empruntâmes" => "@pR1tam",
"empruntant" => "@pR1t@",
"empruntât" => "@pR1ta",
"emprunte" => "@pR1t",
"emprunté" => "@pR1te",
"empruntée" => "@pR1te",
"empruntées" => "@pR1te",
"empruntent" => "@pR1t",
"emprunter" => "@pR1te",
"empruntera" => "@pR1t°Ra",
"emprunterai" => "@pR1t°RE",
"emprunteraient" => "@pR1t°RE",
"emprunterais" => "@pR1t°RE",
"emprunterait" => "@pR1t°RE",
"emprunteras" => "@pR1t°Ra",
"empruntèrent" => "@pR1tER",
"emprunterons" => "@pR1t°R§",
"emprunteront" => "@pR1t°R§",
"empruntes" => "@pR1t",
"empruntés" => "@pR1te",
"emprunteur" => "@pR1t9R",
"empruntez" => "@pR1te",
"empruntions" => "@pR1tj§",
"empruntons" => "@pR1t§",
"emprunts" => "@pR1",
"empuanti" => "@p8@ti",
"empuantie" => "@p8@ti",
"empuanties" => "@p8@ti",
"empuantir" => "@p8@tiR",
"empuantis" => "@p8@ti",
"empuantissaient" => "@p8@tisE",
"empuantissait" => "@p8@tisE",
"empuantisse" => "@p8@tis",
"empuantissent" => "@p8@tis",
"empyrée" => "@piRe",
"empyrées" => "@piRe",
"ému" => "emy",
"émue" => "emy",
"émues" => "emy",
"émulation" => "emylasj§",
"émulations" => "emylasj§",
"émule" => "emyl",
"émuler" => "emyle",
"émules" => "emyl",
"émulsifiant" => "emylsifj@",
"émulsifier" => "emylsifje",
"émulsion" => "emylsj§",
"émulsionné" => "emylsjone",
"émulsive" => "emylsiv",
"émurent" => "emyR",
"émus" => "emy",
"émussent" => "emys",
"émut" => "emy",
"émût" => "emy",
"en" => "@",
"en catimini" => "@katimini",
"en loucedé" => "@lusde",
"en tapinois" => "@tapinwa",
"en-avant" => "@nav@",
"en-but" => "@byt",
"en-cas" => "@ka",
"en-cours" => "@kuR",
"en-dehors" => "@d2OR",
"en-tête" => "@tEt",
"en-têtes" => "@tEt",
"énamourant" => "enamuR@",
"enamouré" => "@namuRe",
"énamouré" => "enamuRe",
"enamourée" => "@namuRe",
"énamourée" => "enamuRe",
"enamourées" => "@namuRe",
"énamourées" => "enamuRe",
"enamourés" => "@namuRe",
"énamourés" => "enamuRe",
"énarque" => "enaRk",
"énarques" => "enaRk",
"encabanée" => "@kabane",
"encablure" => "@kablyR",
"encablures" => "@kablyR",
"encadra" => "@kadRa",
"encadraient" => "@kadRE",
"encadrait" => "@kadRE",
"encadrant" => "@kadR@",
"encadre" => "@kadR",
"encadré" => "@kadRe",
"encadrée" => "@kadRe",
"encadrées" => "@kadRe",
"encadrement" => "@kadR°m@",
"encadrements" => "@kadR°m@",
"encadrent" => "@kadR",
"encadrer" => "@kadRe",
"encadrera" => "@kadR°Ra",
"encadrerai" => "@kadR°RE",
"encadreraient" => "@kadR°RE",
"encadrerait" => "@kadR°RE",
"encadrèrent" => "@kadRER",
"encadreront" => "@kadR°R§",
"encadrés" => "@kadRe",
"encadreur" => "@kadR9R",
"encadrez" => "@kadRe",
"encadrions" => "@kadRij§",
"encagé" => "@kaZe",
"encagée" => "@kaZe",
"encagent" => "@kaZ",
"encager" => "@kaZe",
"encagés" => "@kaZe",
"encagez" => "@kaZe",
"encagoulées" => "@kagule",
"encagoulés" => "@kagule",
"encaissa" => "@kEsa",
"encaissable" => "@kEsabl",
"encaissai" => "@kEsE",
"encaissaient" => "@kEsE",
"encaissais" => "@kEsE",
"encaissait" => "@kEsE",
"encaissant" => "@kEs@",
"encaissât" => "@kEsa",
"encaisse" => "@kEs",
"encaissé" => "@kese",
"encaissée" => "@kese",
"encaissées" => "@kese",
"encaissement" => "@kEs°m@",
"encaissements" => "@kEs°m@",
"encaissent" => "@kEs",
"encaisser" => "@kese",
"encaissera" => "@kEs°Ra",
"encaisserai" => "@kEs°RE",
"encaisserais" => "@kEs°RE",
"encaisserait" => "@kEs°RE",
"encaisserez" => "@kEs°Re",
"encaisseront" => "@kEs°R§",
"encaisses" => "@kEs",
"encaissés" => "@kese",
"encaisseur" => "@kEs9R",
"encaisseurs" => "@kEs9R",
"encaissez" => "@kEse",
"encaissons" => "@kEs§",
"encalminé" => "@kalmine",
"encalminés" => "@kalmine",
"encanaillais" => "@kanajE",
"encanaillait" => "@kanajE",
"encanaille" => "@kanaj",
"encanaillé" => "@kanaje",
"encanaillement" => "@kanaj°m@",
"encanaillent" => "@kanaj",
"encanailler" => "@kanaje",
"encapsulé" => "@kapsyle",
"encapsuler" => "@kapsyle",
"encapuchonna" => "@kapySona",
"encapuchonnait" => "@kapySonE",
"encapuchonnant" => "@kapySon@",
"encapuchonne" => "@kapySOn",
"encapuchonné" => "@kapySone",
"encapuchonnée" => "@kapySone",
"encapuchonnées" => "@kapySone",
"encapuchonnés" => "@kapySone",
"encaqués" => "@kake",
"encart" => "@kaR",
"encartage" => "@kaRtaZ",
"encartait" => "@kaRtE",
"encarté" => "@kaRte",
"encartées" => "@kaRte",
"encarter" => "@kaRte",
"encartés" => "@kaRte",
"encarts" => "@kaR",
"encas" => "@ka",
"encaserner" => "@kazERne",
"encastelé" => "@kast2le",
"encastra" => "@kastRa",
"encastraient" => "@kastRE",
"encastrait" => "@kastRE",
"encastrant" => "@kastR@",
"encastre" => "@kastR",
"encastré" => "@kastRe",
"encastrée" => "@kastRe",
"encastrées" => "@kastRe",
"encastrement" => "@kastR°m@",
"encastrent" => "@kastR",
"encastrer" => "@kastRe",
"encastrés" => "@kastRe",
"encaustiquait" => "@kostikE",
"encaustique" => "@kostik",
"encaustiqué" => "@kostike",
"encaustiquée" => "@kostike",
"encaustiquer" => "@kostike",
"encavée" => "@kave",
"encaver" => "@kave",
"enceint" => "@s5",
"enceinte" => "@s5t",
"enceinter" => "@s5te",
"enceintes" => "@s5t",
"enceints" => "@s5",
"encellulée" => "@sElyle",
"encellulées" => "@sElyle",
"encellulement" => "@sElyl°m@",
"encens" => "@s@",
"encensaient" => "@s@sE",
"encensait" => "@s@sE",
"encensant" => "@s@s@",
"encense" => "@s@s",
"encensé" => "@s@se",
"encensement" => "@s@s°m@",
"encenser" => "@s@se",
"encensés" => "@s@se",
"encensoir" => "@s@swaR",
"encensoirs" => "@s@swaR",
"encéphale" => "@sefal",
"encéphalique" => "@sefalik",
"encéphaliques" => "@sefalik",
"encéphalite" => "@sefalit",
"encéphalogramme" => "@sefalogRam",
"encéphalographie" => "@sefalogRafi",
"encéphalopathie" => "@sefalopati",
"encercla" => "@sERkla",
"encerclaient" => "@sERklE",
"encerclais" => "@sERklE",
"encerclait" => "@sERklE",
"encerclant" => "@sERkl@",
"encercle" => "@sERkl",
"encerclé" => "@sERkle",
"encerclée" => "@sERkle",
"encerclées" => "@sERkle",
"encerclement" => "@sERkl°m@",
"encerclent" => "@sERkl",
"encercler" => "@sERkle",
"encerclera" => "@sERkl°Ra",
"encercleraient" => "@sERkl°RE",
"encerclèrent" => "@sERklER",
"encerclés" => "@sERkle",
"encerclez" => "@sERkle",
"encerclons" => "@sERkl§",
"enchaîna" => "@SEna",
"enchaînai" => "@SEnE",
"enchaînaient" => "@SEnE",
"enchaînais" => "@SEnE",
"enchaînait" => "@SEnE",
"enchaînant" => "@SEn@",
"enchaîne" => "@SEn",
"enchaîné" => "@Sene",
"enchaînée" => "@Sene",
"enchaînées" => "@Sene",
"enchaînement" => "@SEn°m@",
"enchaînements" => "@SEn°m@",
"enchaînent" => "@SEn",
"enchaîner" => "@Sene",
"enchaînera" => "@SEn°Ra",
"enchaîneraient" => "@SEn°RE",
"enchaînerait" => "@SEn°RE",
"enchaîneras" => "@SEn°Ra",
"enchaînèrent" => "@SEnER",
"enchaînerez" => "@SEn°Re",
"enchaînerons" => "@SEn°R§",
"enchaînés" => "@Sene",
"enchaînez" => "@SEne",
"enchaînons" => "@SEn§",
"enchanta" => "@S@ta",
"enchantaient" => "@S@tE",
"enchantais" => "@S@tE",
"enchantait" => "@S@tE",
"enchantant" => "@S@t@",
"enchante" => "@S@t",
"enchanté" => "@S@te",
"enchantée" => "@S@te",
"enchantées" => "@S@te",
"enchantement" => "@S@t°m@",
"enchantements" => "@S@t°m@",
"enchantent" => "@S@t",
"enchanter" => "@S@te",
"enchantera" => "@S@t°Ra",
"enchanteraient" => "@S@t°RE",
"enchanterait" => "@S@t°RE",
"enchantèrent" => "@S@tER",
"enchanteresse" => "@S@t°REs",
"enchanteresses" => "@S@t°REs",
"enchanteront" => "@S@t°R§",
"enchantes" => "@S@t",
"enchantés" => "@S@te",
"enchanteur" => "@S@t9R",
"enchanteurs" => "@S@t9R",
"enchantez" => "@S@te",
"enchantions" => "@S@tj§",
"enchâssaient" => "@SasE",
"enchâssait" => "@SasE",
"enchâssant" => "@Sas@",
"enchâsse" => "@Sas",
"enchâssé" => "@Sase",
"enchâssée" => "@Sase",
"enchâsser" => "@Sase",
"enchâssés" => "@Sase",
"enchemisé" => "@S°mize",
"enchère" => "@SER",
"enchères" => "@SER",
"enchéri" => "@SeRi",
"enchérir" => "@SeRiR",
"enchérissant" => "@SeRis@",
"enchérisse" => "@SeRis",
"enchérisseur" => "@SeRis9R",
"enchérisseurs" => "@SeRis9R",
"enchérisseuse" => "@SeRis2z",
"enchérit" => "@SeRi",
"enchevêtraient" => "@S°vEtRE",
"enchevêtrais" => "@S°vEtRE",
"enchevêtrant" => "@S°vEtR@",
"enchevêtre" => "@S°vEtR",
"enchevêtré" => "@S°vEtRe",
"enchevêtrée" => "@S°vEtRe",
"enchevêtrées" => "@S°vEtRe",
"enchevêtrement" => "@S°vEtR°m@",
"enchevêtrements" => "@S°vEtR°m@",
"enchevêtrent" => "@S°vEtR",
"enchevêtrés" => "@S°vEtRe",
"enchifrené" => "@SifR°ne",
"enchriste" => "@kRist",
"enchristé" => "@kRiste",
"enchristée" => "@kRiste",
"enchrister" => "@kRiste",
"enchtibé" => "@Stibe",
"enchtiber" => "@tibe",
"enchtibés" => "@Stibe",
"enclave" => "@klav",
"enclavé" => "@klave",
"enclavée" => "@klave",
"enclavées" => "@klave",
"enclaves" => "@klav",
"enclencha" => "@kl@Sa",
"enclenchai" => "@kl@SE",
"enclenchait" => "@kl@SE",
"enclenchant" => "@kl@S@",
"enclenche" => "@kl@S",
"enclenché" => "@kl@Se",
"enclenchée" => "@kl@Se",
"enclenchées" => "@kl@Se",
"enclenchement" => "@kl@S°m@",
"enclenchent" => "@kl@S",
"enclencher" => "@kl@Se",
"enclenchera" => "@kl@S°Ra",
"enclenches" => "@kl@S",
"enclenchés" => "@kl@Se",
"enclenchez" => "@kl@Se",
"enclin" => "@kl5",
"encline" => "@klin",
"enclines" => "@klin",
"enclins" => "@kl5",
"encliqueter" => "@klik°te",
"encloîtrer" => "@klwatRe",
"encloqué" => "@klOke",
"enclore" => "@klOR",
"enclos" => "@klo",
"enclose" => "@kloz",
"encloses" => "@kloz",
"enclosure" => "@klozyR",
"enclouer" => "@klue",
"enclume" => "@klym",
"enclumes" => "@klym",
"encoche" => "@kOS",
"encoché" => "@koSe",
"encoches" => "@kOS",
"encoconnée" => "@kokone",
"encoconner" => "@kokone",
"encodage" => "@kodaZ",
"encode" => "@kOd",
"encodé" => "@kode",
"encodée" => "@kode",
"encoder" => "@kode",
"encodés" => "@kode",
"encodeur" => "@kod9R",
"encoignure" => "@kONyR",
"encoignures" => "@kONyR",
"encolérée" => "@koleRe",
"encolérés" => "@koleRe",
"encollage" => "@kolaZ",
"encollait" => "@kolE",
"encollé" => "@kole",
"encollée" => "@kole",
"encollées" => "@kole",
"encoller" => "@kole",
"encolleuses" => "@kol2z",
"encolure" => "@kolyR",
"encolures" => "@kolyR",
"encombra" => "@k§bRa",
"encombraient" => "@k§bRE",
"encombrais" => "@k§bRE",
"encombrait" => "@k§bRE",
"encombrant" => "@k§bR@",
"encombrante" => "@k§bR@t",
"encombrantes" => "@k§bR@t",
"encombrants" => "@k§bR@",
"encombre" => "@k§bR",
"encombré" => "@k§bRe",
"encombrée" => "@k§bRe",
"encombrées" => "@k§bRe",
"encombrement" => "@k§bR°m@",
"encombrements" => "@k§bR°m@",
"encombrent" => "@k§bR",
"encombrer" => "@k§bRe",
"encombrera" => "@k§bR°Ra",
"encombrerai" => "@k§bR°RE",
"encombrerait" => "@k§bR°RE",
"encombrèrent" => "@k§bRER",
"encombres" => "@k§bR",
"encombrés" => "@k§bRe",
"encombrez" => "@k§bRe",
"encor" => "@kOR",
"encorbellement" => "@kORbEl°m@",
"encorbellements" => "@kORbEl°m@",
"encordé" => "@kORde",
"encordée" => "@kORde",
"encorder" => "@kORde",
"encordés" => "@kORde",
"encore" => "@kOR",
"encornaient" => "@kORnE",
"encorné" => "@kORne",
"encornée" => "@kORne",
"encorner" => "@kORne",
"encornés" => "@kORne",
"encornet" => "@kORnE",
"encornets" => "@kORnE",
"encotonne" => "@kotOn",
"encotonner" => "@kotone",
"encourage" => "@kuRaZ",
"encouragé" => "@kuRaZe",
"encouragea" => "@kuRaZa",
"encourageai" => "@kuRaZE",
"encourageaient" => "@kuRaZE",
"encourageais" => "@kuRaZE",
"encourageait" => "@kuRaZE",
"encourageant" => "@kuRaZ@",
"encourageante" => "@kuRaZ@t",
"encourageantes" => "@kuRaZ@t",
"encourageants" => "@kuRaZ@",
"encourageas" => "@kuRaZa",
"encourageât" => "@kuRaZa",
"encouragée" => "@kuRaZe",
"encouragées" => "@kuRaZe",
"encouragement" => "@kuRaZ°m@",
"encouragements" => "@kuRaZ°m@",
"encouragent" => "@kuRaZ",
"encourageons" => "@kuRaZ§",
"encourager" => "@kuRaZe",
"encouragera" => "@kuRaZ°Ra",
"encouragerai" => "@kuRaZ°RE",
"encouragerais" => "@kuRaZ°RE",
"encouragerait" => "@kuRaZ°RE",
"encourageras" => "@kuRaZ°Ra",
"encouragèrent" => "@kuRaZER",
"encourages" => "@kuRaZ",
"encouragés" => "@kuRaZe",
"encouragez" => "@kuRaZe",
"encouragiez" => "@kuRaZje",
"encouraient" => "@kuRE",
"encourais" => "@kuRE",
"encourait" => "@kuRE",
"encourant" => "@kuR@",
"encourent" => "@kuR",
"encourir" => "@kuRiR",
"encourrait" => "@kuRE",
"encours" => "@kuR",
"encourt" => "@kuR",
"encouru" => "@kuRy",
"encourue" => "@kuRy",
"encourues" => "@kuRy",
"encourus" => "@kuRy",
"encrage" => "@kRaZ",
"encrait" => "@kRE",
"encrassait" => "@kRasE",
"encrasse" => "@kRas",
"encrassé" => "@kRase",
"encrassée" => "@kRase",
"encrassées" => "@kRase",
"encrassent" => "@kRas",
"encrasser" => "@kRase",
"encrassés" => "@kRase",
"encre" => "@kR",
"encré" => "@kRe",
"encrée" => "@kRe",
"encrer" => "@kRe",
"encres" => "@kR",
"encrés" => "@kRe",
"encreur" => "@kR9R",
"encreurs" => "@kR9R",
"encrier" => "@kRije",
"encriers" => "@kRije",
"encrotté" => "@kRote",
"encroûtaient" => "@kRutE",
"encroûte" => "@kRut",
"encroûté" => "@kRute",
"encroûtée" => "@kRute",
"encroûtées" => "@kRute",
"encroûtement" => "@kRut°m@",
"encroûter" => "@kRute",
"encroûtèrent" => "@kRutER",
"encroûtés" => "@kRute",
"encryptage" => "@kRiptaZ",
"encrypté" => "@kRipte",
"enculade" => "@kylad",
"enculades" => "@kylad",
"enculage" => "@kylaZ",
"enculant" => "@kyl@",
"encule" => "@kyl",
"enculé" => "@kyle",
"enculée" => "@kyle",
"enculées" => "@kyle",
"enculent" => "@kyl",
"enculer" => "@kyle",
"enculera" => "@kyl°Ra",
"enculerais" => "@kyl°RE",
"enculerait" => "@kyl°RE",
"enculerie" => "@kyl°Ri",
"enculeries" => "@kyl°Ri",
"encules" => "@kyl",
"enculés" => "@kyle",
"enculeur" => "@kyl9R",
"enculeurs" => "@kyl9R",
"encyclique" => "@siklik",
"encycliques" => "@siklik",
"encyclopédie" => "@siklopedi",
"encyclopédies" => "@siklopedi",
"encyclopédique" => "@siklopedik",
"encyclopédiques" => "@siklopedik",
"encyclopédistes" => "@siklopedist",
"endémique" => "@demik",
"endémiques" => "@demik",
"endettait" => "@dEtE",
"endettant" => "@dEt@",
"endette" => "@dEt",
"endetté" => "@dete",
"endettée" => "@dete",
"endettées" => "@dEte",
"endettement" => "@dEt°m@",
"endetter" => "@dete",
"endettés" => "@dete",
"endettez" => "@dEte",
"endeuille" => "@d9j",
"endeuillé" => "@d9je",
"endeuillée" => "@d9je",
"endeuillées" => "@d9je",
"endeuillent" => "@d9j",
"endeuiller" => "@d9je",
"endeuillerai" => "@d9j°RE",
"endeuillés" => "@d9je",
"endêver" => "@dEve",
"endiable" => "@djabl",
"endiablé" => "@djable",
"endiablée" => "@djable",
"endiablées" => "@djable",
"endiablent" => "@djabl",
"endiablerez" => "@djabl°Re",
"endiablés" => "@djable",
"endiamanté" => "@djam@te",
"endiamantée" => "@djam@te",
"endiamantées" => "@djam@te",
"endiamantés" => "@djam@te",
"endigua" => "@diga",
"endiguait" => "@digE",
"endigue" => "@dig",
"endigué" => "@dige",
"endiguée" => "@dige",
"endiguement" => "@dig°m@",
"endiguer" => "@dige",
"endiguera" => "@dig°Ra",
"endigués" => "@dige",
"endimanchait" => "@dim@SE",
"endimanché" => "@dim@Se",
"endimanchée" => "@dim@Se",
"endimanchées" => "@dim@Se",
"endimanchement" => "@dim@S°m@",
"endimancher" => "@dim@Se",
"endimanchés" => "@dim@Se",
"endive" => "@div",
"endives" => "@div",
"endivisionnés" => "@divizjone",
"endocarde" => "@dOkaRd",
"endocardite" => "@dOkaRdit",
"endocrine" => "@dokRin",
"endocrines" => "@dokRin",
"endocrinien" => "@dOkRinj5",
"endocrinienne" => "@dOkRinjEn",
"endocriniens" => "@dokRinj5",
"endocrinologie" => "@dokRinoloZi",
"endocrinologiste" => "@dOkRinOlOZist",
"endocrinologue" => "@dokRinolOg",
"endoctrina" => "@dOktRina",
"endoctriné" => "@dOktRine",
"endoctrinée" => "@dOktRine",
"endoctrinement" => "@dOktRin°m@",
"endoctriner" => "@dOktRine",
"endoctrinés" => "@dOktRine",
"endogamie" => "@dogami",
"endogène" => "@doZEn",
"endolori" => "@doloRi",
"endolorie" => "@doloRi",
"endolories" => "@doloRi",
"endolorir" => "@doloRiR",
"endoloris" => "@doloRi",
"endolorissement" => "@doloRis°m@",
"endométriose" => "@dOmetRijoz",
"endométrite" => "@dOmetRit",
"endommagé" => "@domaZe",
"endommagea" => "@domaZa",
"endommageant" => "@domaZ@",
"endommagée" => "@domaZe",
"endommagées" => "@domaZe",
"endommagement" => "@dOmaZ°m@",
"endommagements" => "@domaZ°m@",
"endommager" => "@domaZe",
"endommagera" => "@domaZ°Ra",
"endommagerait" => "@domaZ°RE",
"endommagerez" => "@domaZ°Re",
"endommagés" => "@domaZe",
"endommagez" => "@domaZe",
"endomorphe" => "@dOmORf",
"endomorphine" => "@domORfin",
"endoplasmique" => "@dOplasmik",
"endormaient" => "@dORmE",
"endormais" => "@dORmE",
"endormait" => "@dORmE",
"endormant" => "@dORm@",
"endormante" => "@dORm@t",
"endorme" => "@dORm",
"endorment" => "@dORm",
"endormes" => "@dORm",
"endormeur" => "@dORm9R",
"endormeurs" => "@dORm9R",
"endormez" => "@dORme",
"endormi" => "@dORmi",
"endormie" => "@dORmi",
"endormies" => "@dORmi",
"endormîmes" => "@dORmim",
"endormions" => "@dORmj§",
"endormir" => "@dORmiR",
"endormira" => "@dORmiRa",
"endormirai" => "@dORmiRE",
"endormiraient" => "@dORmiRE",
"endormirais" => "@dORmiRE",
"endormirait" => "@dORmiRE",
"endormirent" => "@dORmiR",
"endormirez" => "@dORmiRe",
"endormirions" => "@dORmiRj§",
"endormiront" => "@dORmiR§",
"endormis" => "@dORmi",
"endormisse" => "@dORmis",
"endormissement" => "@dORmis°m@",
"endormissements" => "@dORmis°m@",
"endormit" => "@dORmi",
"endormît" => "@dORmi",
"endormons" => "@dORm§",
"endorphine" => "@dORfin",
"endorphines" => "@dORfin",
"endors" => "@dOR",
"endort" => "@dOR",
"endoscope" => "@doskOp",
"endoscopie" => "@doskopi",
"endoscopique" => "@dOskOpik",
"endosquelette" => "@dosk°lEt",
"endossa" => "@dosa",
"endossables" => "@dosabl",
"endossai" => "@dosE",
"endossaient" => "@dosE",
"endossais" => "@dosE",
"endossait" => "@dosE",
"endossant" => "@dos@",
"endossât" => "@dosa",
"endosse" => "@dos",
"endossé" => "@dose",
"endossée" => "@dose",
"endossées" => "@dose",
"endossement" => "@dos°m@",
"endossent" => "@dos",
"endosser" => "@dose",
"endosserai" => "@dos°RE",
"endosserais" => "@dos°RE",
"endosserait" => "@dos°RE",
"endosseras" => "@dos°Ra",
"endossèrent" => "@dosER",
"endosses" => "@dos",
"endossés" => "@dose",
"endosseur" => "@dos9R",
"endossez" => "@dose",
"endossiez" => "@dosje",
"endothermique" => "@dotERmik",
"endroit" => "@dRwa",
"endroits" => "@dRwa",
"enduira" => "@d8iRa",
"enduirais" => "@d8iRE",
"enduirait" => "@d8iRE",
"enduire" => "@d8iR",
"enduis" => "@d8i",
"enduisaient" => "@d8izE",
"enduisait" => "@d8izE",
"enduisant" => "@d8iz@",
"enduisent" => "@d8iz",
"enduisit" => "@d8izi",
"enduisons" => "@d8iz§",
"enduit" => "@d8i",
"enduite" => "@d8it",
"enduites" => "@d8it",
"enduits" => "@d8i",
"endura" => "@dyRa",
"endurable" => "@dyRabl",
"enduraient" => "@dyRE",
"endurais" => "@dyRE",
"endurait" => "@dyRE",
"endurance" => "@dyR@s",
"endurant" => "@dyR@",
"endurante" => "@dyR@t",
"endurants" => "@dyR@",
"endurci" => "@dyRsi",
"endurcie" => "@dyRsi",
"endurcies" => "@dyRsi",
"endurcir" => "@dyRsiR",
"endurcirait" => "@dyRsiRE",
"endurcis" => "@dyRsi",
"endurcissait" => "@dyRsisE",
"endurcissement" => "@dyRsis°m@",
"endurcit" => "@dyRsi",
"endure" => "@dyR",
"enduré" => "@dyRe",
"endurée" => "@dyRe",
"endurées" => "@dyRe",
"endurent" => "@dyR",
"endurer" => "@dyRe",
"endurera" => "@dyR°Ra",
"endurerai" => "@dyR°RE",
"endureras" => "@dyR°Ra",
"endurés" => "@dyRe",
"endurez" => "@dyRe",
"enduriez" => "@dyRje",
"endurons" => "@dyR§",
"énergétique" => "enERZetik",
"énergétiques" => "enERZetik",
"énergie" => "enERZi",
"énergies" => "enERZi",
"énergique" => "enERZik",
"énergiquement" => "enERZik°m@",
"énergiques" => "enERZik",
"énergisant" => "enERZiz@",
"énergisante" => "enERZiz@t",
"énergisée" => "enERZize",
"énergumène" => "enERgymEn",
"énergumènes" => "enERgymEn",
"énerva" => "enERva",
"énervai" => "enERvE",
"énervaient" => "enERvE",
"énervais" => "enERvE",
"énervait" => "enERvE",
"énervâmes" => "enERvam",
"énervant" => "enERv@",
"énervante" => "enERv@t",
"énervantes" => "enERv@t",
"énervants" => "enERv@",
"énerve" => "enERv",
"énervé" => "enERve",
"énervée" => "enERve",
"énervées" => "enERve",
"énervement" => "enERv°m@",
"énervements" => "enERv°m@",
"énervent" => "enERv",
"énerver" => "enERve",
"énervera" => "enERv°Ra",
"énerverai" => "enERv°RE",
"énerveraient" => "enERv°RE",
"énerverait" => "enERv°RE",
"énerveront" => "enERv°R§",
"énerves" => "enERv",
"énervés" => "enERve",
"énervez" => "enERve",
"énerviez" => "enERvje",
"énervions" => "enERvj§",
"énervons" => "enERv§",
"enfance" => "@f@s",
"enfances" => "@f@s",
"enfançon" => "@f@s§",
"enfançons" => "@f@s§",
"enfant" => "@f@",
"enfant-robot" => "@f@Robo",
"enfant-roi" => "@f@Rwa",
"enfanta" => "@f@ta",
"enfantaient" => "@f@tE",
"enfantait" => "@f@tE",
"enfante" => "@f@t",
"enfanté" => "@f@te",
"enfantée" => "@f@te",
"enfantées" => "@f@te",
"enfantelets" => "@f@t°lE",
"enfantement" => "@f@t°m@",
"enfantements" => "@f@t°m@",
"enfantent" => "@f@t",
"enfanter" => "@f@te",
"enfantera" => "@f@t°Ra",
"enfanterai" => "@f@t°RE",
"enfantés" => "@f@te",
"enfantillage" => "@f@tijaZ",
"enfantillages" => "@f@tijaZ",
"enfantin" => "@f@t5",
"enfantine" => "@f@tin",
"enfantinement" => "@f@tin°m@",
"enfantines" => "@f@tin",
"enfantins" => "@f@t5",
"enfantons" => "@f@t§",
"enfants" => "@f@",
"enfants-robots" => "@f@Robo",
"enfants-rois" => "@f@Rwa",
"enfarinait" => "@faRinE",
"enfarine" => "@faRin",
"enfariné" => "@faRine",
"enfarinée" => "@faRine",
"enfariner" => "@faRine",
"enfarinés" => "@faRine",
"enfer" => "@fER",
"enferma" => "@fERma",
"enfermai" => "@fERmE",
"enfermaient" => "@fERmE",
"enfermais" => "@fERmE",
"enfermait" => "@fERmE",
"enfermant" => "@fERm@",
"enferme" => "@fERm",
"enfermé" => "@fERme",
"enfermée" => "@fERme",
"enfermées" => "@fERme",
"enfermement" => "@fERm°m@",
"enferment" => "@fERm",
"enfermer" => "@fERme",
"enfermera" => "@fERm°Ra",
"enfermerai" => "@fERm°RE",
"enfermeraient" => "@fERm°RE",
"enfermerais" => "@fERm°RE",
"enfermerait" => "@fERm°RE",
"enfermèrent" => "@fERmER",
"enfermerez" => "@fERm°Re",
"enfermerons" => "@fERm°R§",
"enfermeront" => "@fERm°R§",
"enfermes" => "@fERm",
"enfermés" => "@fERme",
"enfermez" => "@fERme",
"enfermiez" => "@fERmje",
"enfermons" => "@fERm§",
"enferra" => "@fERa",
"enferrait" => "@fERE",
"enferrant" => "@fER@",
"enferre" => "@fER",
"enferré" => "@fERe",
"enferrée" => "@fERe",
"enferrent" => "@fER",
"enferrer" => "@fERe",
"enferres" => "@fER",
"enferrez" => "@fERe",
"enferrons" => "@fER§",
"enfers" => "@fER",
"enfiche" => "@fiS",
"enfiévra" => "@fjevRa",
"enfiévraient" => "@fjevRE",
"enfiévrait" => "@fjevRE",
"enfièvre" => "@fjEvR",
"enfiévré" => "@fjevRe",
"enfiévrée" => "@fjevRe",
"enfiévrées" => "@fjevRe",
"enfièvrent" => "@fjEvR",
"enfiévrés" => "@fjevRe",
"enfila" => "@fila",
"enfilade" => "@filad",
"enfilades" => "@filad",
"enfilage" => "@filaZ",
"enfilai" => "@filE",
"enfilaient" => "@filE",
"enfilais" => "@filE",
"enfilait" => "@filE",
"enfilant" => "@fil@",
"enfile" => "@fil",
"enfilé" => "@file",
"enfilée" => "@file",
"enfilées" => "@file",
"enfilent" => "@fil",
"enfiler" => "@file",
"enfilera" => "@fil°Ra",
"enfilerai" => "@fil°RE",
"enfileraient" => "@fil°RE",
"enfilerais" => "@fil°RE",
"enfilerait" => "@fil°RE",
"enfilèrent" => "@filER",
"enfilerez" => "@fil°Re",
"enfileront" => "@fil°R§",
"enfiles" => "@fil",
"enfilés" => "@file",
"enfileur" => "@fil9R",
"enfilez" => "@file",
"enfilions" => "@filj§",
"enfilons" => "@fil§",
"enfin" => "@f5",
"enfla" => "@fla",
"enflaient" => "@flE",
"enflait" => "@flE",
"enflamma" => "@flama",
"enflammai" => "@flamE",
"enflammaient" => "@flamE",
"enflammait" => "@flamE",
"enflammant" => "@flam@",
"enflammât" => "@flama",
"enflamme" => "@flam",
"enflammé" => "@flame",
"enflammée" => "@flame",
"enflammées" => "@flame",
"enflamment" => "@flam",
"enflammer" => "@flame",
"enflammera" => "@flam°Ra",
"enflammerait" => "@flam°RE",
"enflammèrent" => "@flamER",
"enflammés" => "@flame",
"enflammez" => "@flame",
"enflant" => "@fl@",
"enfle" => "@fl",
"enflé" => "@fle",
"enflée" => "@fle",
"enflées" => "@fle",
"enflent" => "@fl",
"enfler" => "@fle",
"enflerait" => "@fl°RE",
"enflèrent" => "@flER",
"enfles" => "@fl",
"enflés" => "@fle",
"enflure" => "@flyR",
"enflures" => "@flyR",
"enfoiré" => "@fwaRe",
"enfoirée" => "@fwaRe",
"enfoirés" => "@fwaRe",
"enfonça" => "@f§sa",
"enfonçage" => "@f§saZ",
"enfonçai" => "@f§sE",
"enfonçaient" => "@f§sE",
"enfonçais" => "@f§sE",
"enfonçait" => "@f§sE",
"enfonçâmes" => "@f§sam",
"enfonçant" => "@f§s@",
"enfonce" => "@f§s",
"enfoncé" => "@f§se",
"enfoncée" => "@f§se",
"enfoncées" => "@f§se",
"enfoncement" => "@f§s°m@",
"enfoncements" => "@f§s°m@",
"enfoncent" => "@f§s",
"enfoncer" => "@f§se",
"enfoncera" => "@f§s°Ra",
"enfoncerai" => "@f§s°RE",
"enfonceraient" => "@f§s°RE",
"enfoncerais" => "@f§s°RE",
"enfoncerait" => "@f§s°RE",
"enfonceras" => "@f§s°Ra",
"enfoncèrent" => "@f§sER",
"enfoncerez" => "@f§s°Re",
"enfoncerions" => "@f§s°Rj§",
"enfoncerons" => "@f§s°R§",
"enfonceront" => "@f§s°R§",
"enfonces" => "@f§s",
"enfoncés" => "@f§se",
"enfonceur" => "@f§s9R",
"enfoncez" => "@f§se",
"enfonciez" => "@f§sje",
"enfoncions" => "@f§sj§",
"enfonçons" => "@f§s§",
"enfoui" => "@fwi",
"enfouie" => "@fwi",
"enfouies" => "@fwi",
"enfouillais" => "@fujE",
"enfouillant" => "@fuj@",
"enfouille" => "@fuj",
"enfouillé" => "@fuje",
"enfouillée" => "@fuje",
"enfouiller" => "@fuje",
"enfouir" => "@fwiR",
"enfouiraient" => "@fwiRE",
"enfouis" => "@fwi",
"enfouissais" => "@fwisE",
"enfouissait" => "@fwisE",
"enfouissant" => "@fwis@",
"enfouissement" => "@fwis°m@",
"enfouissements" => "@fwis°m@",
"enfouissent" => "@fwis",
"enfouissez" => "@fwise",
"enfouissons" => "@fwis§",
"enfouit" => "@fwi",
"enfouraille" => "@fuRaj",
"enfouraillé" => "@fuRaje",
"enfouraillée" => "@fuRaje",
"enfouraillés" => "@fuRaje",
"enfourcha" => "@fuRSa",
"enfourchai" => "@fuRSE",
"enfourchaient" => "@fuRSE",
"enfourchais" => "@fuRSE",
"enfourchait" => "@fuRSE",
"enfourchant" => "@fuRS@",
"enfourche" => "@fuRS",
"enfourché" => "@fuRSe",
"enfourchement" => "@fuRS°m@",
"enfourcher" => "@fuRSe",
"enfourcherait" => "@fuRS°RE",
"enfourchèrent" => "@fuRSER",
"enfourchez" => "@fuRSe",
"enfourchiez" => "@fuRSje",
"enfourchure" => "@fuRSyR",
"enfourna" => "@fuRna",
"enfournage" => "@fuRnaZ",
"enfournaient" => "@fuRnE",
"enfournait" => "@fuRnE",
"enfournant" => "@fuRn@",
"enfourne" => "@fuRn",
"enfourné" => "@fuRne",
"enfournée" => "@fuRne",
"enfournées" => "@fuRne",
"enfournent" => "@fuRn",
"enfourner" => "@fuRne",
"enfournèrent" => "@fuRnER",
"enfournés" => "@fuRne",
"enfourniez" => "@fuRnje",
"enfreignaient" => "@fRENE",
"enfreignais" => "@fRENE",
"enfreignait" => "@fRENE",
"enfreignant" => "@fREN@",
"enfreignent" => "@fREN",
"enfreignez" => "@fRENe",
"enfreindra" => "@fR5dRa",
"enfreindrai" => "@fR5dRE",
"enfreindrais" => "@fR5dRE",
"enfreindre" => "@fR5dR",
"enfreins" => "@fR5",
"enfreint" => "@fR5",
"enfreinte" => "@fR5t",
"enfreintes" => "@fR5t",
"enfui" => "@f8i",
"enfuie" => "@f8i",
"enfuient" => "@f8i",
"enfuies" => "@f8i",
"enfuir" => "@f8iR",
"enfuira" => "@f8iRa",
"enfuirai" => "@f8iRE",
"enfuiraient" => "@f8iRE",
"enfuirais" => "@f8iRE",
"enfuirait" => "@f8iRE",
"enfuiras" => "@f8iRa",
"enfuirent" => "@f8iR",
"enfuiront" => "@f8iR§",
"enfuis" => "@f8i",
"enfuit" => "@f8i",
"enfuma" => "@fyma",
"enfumaient" => "@fymE",
"enfumait" => "@fymE",
"enfumé" => "@fyme",
"enfumée" => "@fyme",
"enfumées" => "@fyme",
"enfumer" => "@fyme",
"enfumés" => "@fyme",
"enfumez" => "@fyme",
"enfuyaient" => "@f8ijE",
"enfuyais" => "@f8ijE",
"enfuyait" => "@f8ijE",
"enfuyant" => "@f8ij@",
"enfuyez" => "@f8ije",
"enfuyiez" => "@f8ijje",
"enfuyons" => "@f8ij§",
"engage" => "@gaZ",
"engagé" => "@gaZe",
"engagea" => "@gaZa",
"engageable" => "@gaZabl",
"engageai" => "@gaZE",
"engageaient" => "@gaZE",
"engageais" => "@gaZE",
"engageait" => "@gaZE",
"engageâmes" => "@gaZam",
"engageant" => "@gaZ@",
"engageante" => "@gaZ@t",
"engageantes" => "@gaZ@t",
"engageants" => "@gaZ@",
"engageât" => "@gaZa",
"engagée" => "@gaZe",
"engagées" => "@gaZe",
"engagement" => "@gaZ°m@",
"engagements" => "@gaZ°m@",
"engagent" => "@gaZ",
"engageons" => "@gaZ§",
"engager" => "@gaZe",
"engagera" => "@gaZ°Ra",
"engagerai" => "@gaZ°RE",
"engageraient" => "@gaZ°RE",
"engagerais" => "@gaZ°RE",
"engagerait" => "@gaZ°RE",
"engagèrent" => "@gaZER",
"engageriez" => "@gaZ°Rje",
"engagerions" => "@gaZ°Rj§",
"engagerons" => "@gaZ°R§",
"engageront" => "@gaZ°R§",
"engages" => "@gaZ",
"engagés" => "@gaZe",
"engagez" => "@gaZe",
"engagiez" => "@gaZje",
"engagions" => "@gaZj§",
"engazonnée" => "@gazone",
"engeance" => "@Z@s",
"engeances" => "@Z@s",
"engelure" => "@Z°lyR",
"engelures" => "@Z°lyR",
"engendra" => "@Z@dRa",
"engendraient" => "@Z@dRE",
"engendrait" => "@Z@dRE",
"engendrant" => "@Z@dR@",
"engendrassent" => "@Z@dRas",
"engendre" => "@Z@dR",
"engendré" => "@Z@dRe",
"engendrée" => "@Z@dRe",
"engendrées" => "@Z@dRe",
"engendrement" => "@Z@dR°m@",
"engendrent" => "@Z@dR",
"engendrer" => "@Z@dRe",
"engendrera" => "@Z@dR°Ra",
"engendreraient" => "@Z@dR°RE",
"engendrerait" => "@Z@dR°RE",
"engendrèrent" => "@Z@dRER",
"engendrés" => "@Z@dRe",
"engendreuse" => "@Z@dR2z",
"engendrez" => "@Z@dRe",
"engendrons" => "@Z@dR§",
"engin" => "@Z5",
"engineering" => "EnZiniRiG",
"engins" => "@Z5",
"englacé" => "@glase",
"englande" => "@gl@d",
"englander" => "@gl@d9R",
"englandés" => "@gl@de",
"engliche" => "@gliS",
"engloba" => "@globa",
"englobaient" => "@globE",
"englobais" => "@globE",
"englobait" => "@globE",
"englobant" => "@glob@",
"englobe" => "@glOb",
"englobé" => "@globe",
"englobée" => "@globe",
"englobées" => "@globe",
"englobent" => "@glOb",
"englober" => "@globe",
"englobera" => "@glOb°Ra",
"engloberaient" => "@glOb°RE",
"engloberait" => "@glOb°RE",
"englobés" => "@globe",
"englouti" => "@gluti",
"engloutie" => "@gluti",
"englouties" => "@gluti",
"engloutir" => "@glutiR",
"engloutira" => "@glutiRa",
"engloutiraient" => "@glutiRE",
"engloutirait" => "@glutiRE",
"engloutirent" => "@glutiR",
"engloutirons" => "@glutiR§",
"engloutis" => "@gluti",
"engloutissaient" => "@glutisE",
"engloutissais" => "@glutisE",
"engloutissait" => "@glutisE",
"engloutissant" => "@glutis@",
"engloutisse" => "@glutis",
"engloutissement" => "@glutis°m@",
"engloutissent" => "@glutis",
"engloutissions" => "@glutisj§",
"engloutit" => "@gluti",
"engluaient" => "@gl8E",
"engluait" => "@gl8E",
"engluant" => "@gly@",
"englue" => "@gly",
"englué" => "@gl8e",
"engluée" => "@gl8e",
"engluées" => "@gl8e",
"engluent" => "@gly",
"engluer" => "@glye",
"englués" => "@gl8e",
"engonçaient" => "@g§sE",
"engonçait" => "@g§sE",
"engonçant" => "@g§s@",
"engonce" => "@g§s",
"engoncé" => "@g§se",
"engoncée" => "@g§se",
"engoncées" => "@g§se",
"engoncement" => "@g§s°m@",
"engoncés" => "@g§se",
"engorge" => "@gORZ",
"engorgé" => "@gORZe",
"engorgeaient" => "@gORZE",
"engorgeait" => "@gORZE",
"engorgée" => "@gORZe",
"engorgées" => "@gORZe",
"engorgement" => "@gORZ°m@",
"engorgements" => "@gORZ°m@",
"engorgent" => "@gORZ",
"engorger" => "@gORZe",
"engorgeraient" => "@gORZ°RE",
"engorgèrent" => "@gORZER",
"engorgés" => "@gORZe",
"engouai" => "@gwE",
"engouait" => "@gwE",
"engoué" => "@gwe",
"engouée" => "@gwe",
"engouement" => "@gum@",
"engouements" => "@gum@",
"engoués" => "@gwe",
"engouffra" => "@gufRa",
"engouffrai" => "@gufRE",
"engouffraient" => "@gufRE",
"engouffrait" => "@gufRE",
"engouffrant" => "@gufR@",
"engouffrât" => "@gufRa",
"engouffre" => "@gufR",
"engouffré" => "@gufRe",
"engouffrée" => "@gufRe",
"engouffrées" => "@gufRe",
"engouffrement" => "@gufR°m@",
"engouffrent" => "@gufR",
"engouffrer" => "@gufRe",
"engouffrera" => "@gufR°Ra",
"engouffreraient" => "@gufR°RE",
"engouffrerait" => "@gufR°RE",
"engouffrèrent" => "@gufRER",
"engouffrés" => "@gufRe",
"engouffrons" => "@gufR§",
"engoulevent" => "@gul°v@",
"engourdi" => "@guRdi",
"engourdie" => "@guRdi",
"engourdies" => "@guRdi",
"engourdir" => "@guRdiR",
"engourdira" => "@guRdiRa",
"engourdirai" => "@guRdiRE",
"engourdirais" => "@guRdiRE",
"engourdis" => "@guRdi",
"engourdissaient" => "@guRdisE",
"engourdissait" => "@guRdisE",
"engourdissant" => "@guRdis@",
"engourdissante" => "@guRdis@t",
"engourdissantes" => "@guRdis@t",
"engourdissement" => "@guRdis°m@",
"engourdissements" => "@guRdis°m@",
"engourdissent" => "@guRdis",
"engourdit" => "@guRdi",
"engrainait" => "@gREnE",
"engrais" => "@gRE",
"engraissaient" => "@gREsE",
"engraissait" => "@gREsE",
"engraissant" => "@gREs@",
"engraisse" => "@gREs",
"engraissé" => "@gRese",
"engraissée" => "@gRese",
"engraissées" => "@gRese",
"engraissement" => "@gREs°m@",
"engraissent" => "@gREs",
"engraisser" => "@gRese",
"engraisseraient" => "@gREs°RE",
"engraisserait" => "@gREs°RE",
"engraissèrent" => "@gREsER",
"engraisserons" => "@gREs°R@",
"engraisses" => "@gREs",
"engraissés" => "@gRese",
"engraissez" => "@gREse",
"engrange" => "@gR@Z",
"engrangé" => "@gR@Ze",
"engrangea" => "@gR@Za",
"engrangeais" => "@gR@ZE",
"engrangeait" => "@gR@ZE",
"engrangeant" => "@gR@Z@",
"engrangée" => "@gR@Ze",
"engrangées" => "@gR@Ze",
"engrangement" => "@gR@Z°m@",
"engrangent" => "@gR@Z",
"engrangeons" => "@gR@Z§",
"engranger" => "@gR@Ze",
"engrangés" => "@gR@Ze",
"engravement" => "@gRav°m@",
"engraver" => "@gRave",
"engrenage" => "@gR°naZ",
"engrenages" => "@gR°naZ",
"engrenait" => "@gR°nE",
"engrenant" => "@gR°n@",
"engrener" => "@gR°ne",
"engrenez" => "@gR°ne",
"engrossait" => "@gRosE",
"engrossant" => "@gRos@",
"engrosse" => "@gRos",
"engrossé" => "@gRose",
"engrossée" => "@gRose",
"engrossées" => "@gRose",
"engrossent" => "@gRos",
"engrosser" => "@gRose",
"engrossera" => "@gRos°Ra",
"engrosses" => "@gRos",
"engueula" => "@g2la",
"engueulade" => "@g2lad",
"engueulades" => "@g2lad",
"engueulaient" => "@g2lE",
"engueulais" => "@g2lE",
"engueulait" => "@g2lE",
"engueulant" => "@g2l@",
"engueule" => "@g9l",
"engueulé" => "@g2le",
"engueulée" => "@g2le",
"engueulent" => "@g9l",
"engueuler" => "@g2le",
"engueulera" => "@g2l°Ra",
"engueuleraient" => "@g2l°RE",
"engueulerait" => "@g2l°RE",
"engueuleras" => "@g2l°Ra",
"engueulèrent" => "@g2lER",
"engueulerez" => "@g2l°Re",
"engueuleront" => "@g2l°R§",
"engueules" => "@g9l",
"engueulés" => "@g2le",
"engueulez" => "@g2le",
"engueuliez" => "@g2lje",
"engueulions" => "@g2lj§",
"engueulons" => "@g2l§",
"enguirlandaient" => "@giRl@dE",
"enguirlandait" => "@giRl@dE",
"enguirlande" => "@giRl@d",
"enguirlandé" => "@giRl@de",
"enguirlandée" => "@giRl@de",
"enguirlandées" => "@giRl@de",
"enguirlandent" => "@giRl@d",
"enguirlander" => "@giRl@de",
"enguirlandés" => "@giRl@de",
"enhardi" => "@aRdi",
"enhardie" => "@aRdi",
"enhardies" => "@aRdi",
"enhardir" => "@aRdiR",
"enhardirent" => "@aRdiR",
"enhardis" => "@aRdi",
"enhardissaient" => "@aRdisE",
"enhardissait" => "@aRdisE",
"enhardissant" => "@aRdis@",
"enhardissement" => "@aRdis°m@",
"enhardissent" => "@aRdis",
"enhardit" => "@aRdi",
"énième" => "EnjEm",
"énigmatique" => "enigmatik",
"énigmatiquement" => "enigmatik°m@",
"énigmatiques" => "enigmatik",
"énigme" => "enigm",
"énigmes" => "enigm",
"enivra" => "@nivRa",
"enivrai" => "@nivRE",
"enivraient" => "@nivRE",
"enivrais" => "@nivRE",
"enivrait" => "@nivRE",
"enivrant" => "@nivR@",
"enivrante" => "@nivR@t",
"enivrantes" => "@nivR@t",
"enivrants" => "@nivR@",
"enivre" => "@nivR",
"enivré" => "@nivRe",
"enivrée" => "@nivRe",
"enivrées" => "@nivRe",
"enivrement" => "@nivR°m@",
"enivrent" => "@nivR",
"enivrer" => "@nivRe",
"enivreras" => "@nivR°Ra",
"enivrèrent" => "@nivRER",
"enivrerez" => "@nivR°Re",
"enivres" => "@nivR",
"enivrés" => "@nivRe",
"enivrez" => "@nivRe",
"enivrons" => "@nivR§",
"enjamba" => "@Z@ba",
"enjambai" => "@Z@bE",
"enjambaient" => "@Z@bE",
"enjambais" => "@Z@bE",
"enjambait" => "@Z@bE",
"enjambant" => "@Z@b@",
"enjambe" => "@Z@b",
"enjambé" => "@Z@be",
"enjambée" => "@Z@be",
"enjambées" => "@Z@be",
"enjambements" => "@Z@b°m@",
"enjambent" => "@Z@b",
"enjamber" => "@Z@be",
"enjamberais" => "@Z@b°RE",
"enjamberait" => "@Z@b°RE",
"enjambèrent" => "@Z@bER",
"enjambes" => "@Z@b",
"enjambés" => "@Z@be",
"enjambeur" => "@Z@b9R",
"enjambeurs" => "@Z@b9R",
"enjambez" => "@Z@be",
"enjambions" => "@Z@bj§",
"enjambons" => "@Z@b§",
"enjeu" => "@Z2",
"enjeux" => "@Z2",
"enjoignaient" => "@ZwaNE",
"enjoignait" => "@ZwaNE",
"enjoignant" => "@ZwaN@",
"enjoignis" => "@ZwaNi",
"enjoignit" => "@ZwaNi",
"enjoignons" => "@ZwaN§",
"enjoindre" => "@Zw5dR",
"enjoint" => "@Zw5",
"enjôlait" => "@ZolE",
"enjôlant" => "@Zol@",
"enjôle" => "@Zol",
"enjôlé" => "@Zole",
"enjôlée" => "@Zole",
"enjôlement" => "@Zol°m@",
"enjôler" => "@Zole",
"enjôleur" => "@Zol9R",
"enjôleurs" => "@Zol9R",
"enjôleuse" => "@Zol2z",
"enjôleuses" => "@Zol2z",
"enjolivaient" => "@ZolivE",
"enjolivait" => "@ZolivE",
"enjolivant" => "@Zoliv@",
"enjolive" => "@Zoliv",
"enjolivé" => "@Zolive",
"enjolivée" => "@Zolive",
"enjolivements" => "@Zoliv°m@",
"enjoliver" => "@Zolive",
"enjolivés" => "@Zolive",
"enjoliveur" => "@Zoliv9R",
"enjoliveurs" => "@Zoliv9R",
"enjoué" => "@Zwe",
"enjouée" => "@Zwe",
"enjouées" => "@Zwe",
"enjouement" => "@Zum@",
"enjoués" => "@Zwe",
"enjuiver" => "@Z8ive",
"enjuivés" => "@Z8ive",
"enjuponne" => "@ZypOn",
"enjuponnée" => "@Zypone",
"enkystées" => "@kiste",
"enkyster" => "@kiste",
"enlaça" => "@lasa",
"enlaçaient" => "@lasE",
"enlaçais" => "@lasE",
"enlaçait" => "@lasE",
"enlaçant" => "@las@",
"enlace" => "@las",
"enlacé" => "@lase",
"enlacée" => "@lase",
"enlacées" => "@lase",
"enlacement" => "@las°m@",
"enlacements" => "@las°m@",
"enlacent" => "@las",
"enlacer" => "@lase",
"enlacerai" => "@las°RE",
"enlacèrent" => "@lasER",
"enlacerons" => "@las°R§",
"enlacés" => "@lase",
"enlacez" => "@lase",
"enlacions" => "@lasj§",
"enlaçons" => "@las§",
"enlaidi" => "@lEdi",
"enlaidie" => "@lEdi",
"enlaidir" => "@lediR",
"enlaidis" => "@lEdi",
"enlaidissait" => "@lEdisE",
"enlaidissant" => "@lEdis@",
"enlaidisse" => "@lEdis",
"enlaidissement" => "@ledis°m@",
"enlaidissent" => "@lEdis",
"enlaidisses" => "@lEdis",
"enlaidit" => "@lEdi",
"enleva" => "@l°va",
"enlevai" => "@l°vE",
"enlevaient" => "@l°vE",
"enlevais" => "@l°vE",
"enlevait" => "@l°vE",
"enlevant" => "@l°v@",
"enlevât" => "@l°va",
"enlève" => "@lEv",
"enlevé" => "@l°ve",
"enlevée" => "@l°ve",
"enlevées" => "@l°ve",
"enlèvement" => "@lEv°m@",
"enlèvements" => "@lEv°m@",
"enlèvent" => "@lEv",
"enlever" => "@l°ve",
"enlèvera" => "@lEv°Ra",
"enlèverai" => "@lEv°RE",
"enlèveraient" => "@lEv°RE",
"enlèverais" => "@lEv°RE",
"enlèverait" => "@lEv°RE",
"enlèveras" => "@lEv°Ra",
"enlevèrent" => "@l°vER",
"enlèverez" => "@lEv°Re",
"enlèveriez" => "@lEv°Rje",
"enlèverons" => "@lEv°R§",
"enlèveront" => "@lEv°R§",
"enlèves" => "@lEv",
"enlevés" => "@l°ve",
"enlevez" => "@l°ve",
"enleviez" => "@l°vje",
"enlevions" => "@l°vj§",
"enlevons" => "@l°v§",
"enliasser" => "@ljase",
"enlisa" => "@liza",
"enlisaient" => "@lizE",
"enlisais" => "@lizE",
"enlisait" => "@lizE",
"enlisant" => "@liz@",
"enlise" => "@liz",
"enlisé" => "@lize",
"enlisée" => "@lize",
"enlisées" => "@lize",
"enlisement" => "@liz°m@",
"enlisent" => "@liz",
"enliser" => "@lize",
"enlisera" => "@liz°Ra",
"enliserais" => "@liz°RE",
"enlisés" => "@lize",
"enlumine" => "@lymin",
"enluminé" => "@lymine",
"enluminée" => "@lymine",
"enluminées" => "@lymine",
"enluminent" => "@lymin",
"enluminer" => "@lymine",
"enluminés" => "@lymine",
"enlumineur" => "@lymin9R",
"enlumineurs" => "@lymin9R",
"enluminure" => "@lyminyR",
"enluminures" => "@lyminyR",
"enneige" => "@nEZ",
"enneigé" => "@neZe",
"enneigeait" => "@nEZE",
"enneigée" => "@neZe",
"enneigées" => "@neZe",
"enneigement" => "@nEZ°m@",
"enneiger" => "@nEZe",
"enneigés" => "@neZe",
"ennemi" => "En°mi",
"ennemie" => "En°mi",
"ennemies" => "En°mi",
"ennemis" => "En°mi",
"ennobli" => "@nobli",
"ennoblie" => "@nobli",
"ennoblir" => "@nobliR",
"ennoblis" => "@nobli",
"ennoblissement" => "@noblis°m@",
"ennoblit" => "@nobli",
"ennuagé" => "@n8aZe",
"ennuagent" => "@nyaZ",
"ennuager" => "@n8aZe",
"ennui" => "@n8i",
"ennuie" => "@n8i",
"ennuient" => "@n8i",
"ennuiera" => "@n8iRa",
"ennuierai" => "@n8iRE",
"ennuieraient" => "@n8iRE",
"ennuierais" => "@n8iRE",
"ennuierait" => "@n8iRE",
"ennuieras" => "@n8iRa",
"ennuierez" => "@n8iRe",
"ennuieriez" => "@n8iRje",
"ennuierions" => "@n8iRj§",
"ennuierons" => "@n8iR§",
"ennuieront" => "@n8iR§",
"ennuies" => "@n8i",
"ennuis" => "@n8i",
"ennuya" => "@n8ija",
"ennuyai" => "@n8ijE",
"ennuyaient" => "@n8ijE",
"ennuyais" => "@n8ijE",
"ennuyait" => "@n8ijE",
"ennuyant" => "@n8ij@",
"ennuyante" => "@n8ij@t",
"ennuyât" => "@n8ija",
"ennuyé" => "@n8ije",
"ennuyée" => "@n8ije",
"ennuyées" => "@n8ije",
"ennuyer" => "@n8ije",
"ennuyèrent" => "@n8ijER",
"ennuyés" => "@n8ije",
"ennuyeuse" => "@n8ij2z",
"ennuyeuses" => "@n8ij2z",
"ennuyeux" => "@n8ij2",
"ennuyez" => "@n8ije",
"ennuyiez" => "@n8ije",
"ennuyions" => "@n8ij§",
"ennuyons" => "@n8ij§",
"énonça" => "en§sa",
"énonçai" => "en§sE",
"énonçaient" => "en§sE",
"énonçais" => "en§sE",
"énonçait" => "en§sE",
"énonçant" => "en§s@",
"énonce" => "en§s",
"énoncé" => "en§se",
"énoncée" => "en§se",
"énoncées" => "en§se",
"énoncent" => "en§s",
"énoncer" => "en§se",
"énonceront" => "en§s°R§",
"énoncés" => "en§se",
"énonciateurs" => "en§sjat9R",
"énonciation" => "en§sjasj§",
"enorgueilli" => "@nORg9ji",
"enorgueillir" => "@nORg9jiR",
"enorgueillirent" => "@nORg9jiR",
"enorgueillis" => "@nORg9ji",
"enorgueillissais" => "@nORg9jisE",
"enorgueillissait" => "@nORg9jisE",
"enorgueillissant" => "@nORg9jis@",
"enorgueillisse" => "@nORg9jis",
"enorgueillissent" => "@nORg9jis",
"enorgueillit" => "@nORg9ji",
"enorgueillît" => "@nORg9ji",
"énorme" => "enORm",
"énormément" => "enORmem@",
"énormes" => "enORm",
"énormité" => "enORmite",
"énormités" => "enORmite",
"enquéraient" => "@keRE",
"enquérais" => "@keRE",
"enquérait" => "@keRE",
"enquérant" => "@keR@",
"enquérez" => "@keRe",
"enquérir" => "@keRiR",
"enquerraient" => "@kERE",
"enquêta" => "@kEta",
"enquêtais" => "@kEtE",
"enquêtait" => "@kEtE",
"enquêtant" => "@kEt@",
"enquête" => "@kEt",
"enquêté" => "@kete",
"enquêtent" => "@kEt",
"enquêter" => "@kete",
"enquêtes" => "@kEt",
"enquêtes-minute" => "@kEtminyt",
"enquêteur" => "@kEt9R",
"enquêteurs" => "@kEt9R",
"enquêteuse" => "@kEt2z",
"enquêtez" => "@kEte",
"enquêtrices" => "@kEtRis",
"enquière" => "@kjER",
"enquièrent" => "@kjER",
"enquiers" => "@kjER",
"enquiert" => "@kjER",
"enquillais" => "@kijE",
"enquillait" => "@kijE",
"enquillant" => "@kij@",
"enquille" => "@kij",
"enquillé" => "@kije",
"enquillent" => "@kij",
"enquiller" => "@kije",
"enquillés" => "@kije",
"enquillons" => "@kij§",
"enquiquinaient" => "@kikinE",
"enquiquinait" => "@kikinE",
"enquiquinant" => "@kikin@",
"enquiquinante" => "@kikin@t",
"enquiquinants" => "@kikin@",
"enquiquine" => "@kikin",
"enquiquiné" => "@kikine",
"enquiquinement" => "@kikin°m@",
"enquiquinent" => "@kikin",
"enquiquiner" => "@kikine",
"enquiquineraient" => "@kikin°RE",
"enquiquines" => "@kikin",
"enquiquineur" => "@kikin9R",
"enquiquineurs" => "@kikin9R",
"enquiquineuse" => "@kikin2z",
"enquis" => "@ki",
"enquise" => "@kiz",
"enquit" => "@ki",
"enracinais" => "@RasinE",
"enracinait" => "@RasinE",
"enracinant" => "@Rasin@",
"enracine" => "@Rasin",
"enraciné" => "@Rasine",
"enracinée" => "@Rasine",
"enracinées" => "@Rasine",
"enracinement" => "@Rasin°m@",
"enracinements" => "@Rasin°m@",
"enracinent" => "@Rasin",
"enraciner" => "@Rasine",
"enracinerait" => "@Rasin°RE",
"enracineras" => "@Rasin°Ra",
"enracinerez" => "@Rasin°Re",
"enracinés" => "@Rasine",
"enrage" => "@RaZ",
"enragé" => "@RaZe",
"enragea" => "@RaZa",
"enrageai" => "@RaZE",
"enrageais" => "@RaZE",
"enrageait" => "@RaZE",
"enrageant" => "@RaZ@",
"enrageante" => "@RaZ@t",
"enragée" => "@RaZe",
"enragées" => "@RaZe",
"enragement" => "@RaZ°m@",
"enragent" => "@RaZ",
"enrager" => "@RaZe",
"enragerais" => "@RaZ°RE",
"enragés" => "@RaZe",
"enraie" => "@RE",
"enraillée" => "@Raje",
"enraya" => "@Reja",
"enrayage" => "@REjaZ",
"enrayait" => "@RejE",
"enrayant" => "@Rej@",
"enraye" => "@Rej",
"enrayé" => "@Reje",
"enrayée" => "@Reje",
"enrayement" => "@REjm@",
"enrayent" => "@Rej",
"enrayer" => "@Reje",
"enrayera" => "@REj°Ra",
"enrégimentait" => "@ReZim@tE",
"enrégimenter" => "@ReZim@te",
"enrégimenterait" => "@ReZim@t°RE",
"enregistra" => "@R°ZistRa",
"enregistrable" => "@R°ZistRabl",
"enregistrai" => "@R°ZistRE",
"enregistraient" => "@R°ZistRE",
"enregistrais" => "@R°ZistRE",
"enregistrait" => "@R°ZistRE",
"enregistrant" => "@R°ZistR@",
"enregistre" => "@R°ZistR",
"enregistré" => "@R°ZistRe",
"enregistrée" => "@R°ZistRe",
"enregistrées" => "@R°ZistRe",
"enregistrement" => "@R°ZistR°m@",
"enregistrements" => "@R°ZistR°m@",
"enregistrent" => "@R°ZistR",
"enregistrer" => "@R°ZistRe",
"enregistrera" => "@R°ZistR°Ra",
"enregistrerai" => "@R°ZistR°RE",
"enregistrerait" => "@R°ZistR°RE",
"enregistreras" => "@R°ZistR°Ra",
"enregistrerez" => "@R°ZistR°Re",
"enregistrerons" => "@R°ZistR°R§",
"enregistreront" => "@R°ZistR°R§",
"enregistres" => "@R°ZistR",
"enregistrés" => "@R°ZistRe",
"enregistreur" => "@R°ZistR9R",
"enregistreurs" => "@R°ZistR9R",
"enregistreuse" => "@R°ZistR2z",
"enregistreuses" => "@R°ZistR2z",
"enregistrez" => "@R°ZistRe",
"enregistriez" => "@R°ZistRje",
"enregistrions" => "@R°ZistRij§",
"enregistrons" => "@R°ZistR§",
"enrhumait" => "@RymE",
"enrhume" => "@Rym",
"enrhumé" => "@Ryme",
"enrhumée" => "@Ryme",
"enrhumées" => "@Ryme",
"enrhument" => "@Rym",
"enrhumer" => "@Ryme",
"enrhumes" => "@Rym",
"enrhumés" => "@Ryme",
"enrhumez" => "@Ryme",
"enrichi" => "@RiSi",
"enrichie" => "@RiSi",
"enrichies" => "@RiSi",
"enrichir" => "@RiSiR",
"enrichira" => "@RiSiRa",
"enrichirais" => "@RiSiRE",
"enrichirait" => "@RiSiRE",
"enrichiront" => "@RiSiR§",
"enrichis" => "@RiSi",
"enrichissaient" => "@RiSisE",
"enrichissais" => "@RiSisE",
"enrichissait" => "@RiSisE",
"enrichissant" => "@RiSis@",
"enrichissante" => "@RiSis@t",
"enrichissantes" => "@RiSis@t",
"enrichissants" => "@RiSis@",
"enrichisse" => "@RiSis",
"enrichissement" => "@RiSis°m@",
"enrichissements" => "@RiSis°m@",
"enrichissent" => "@RiSis",
"enrichissez" => "@RiSise",
"enrichit" => "@RiSi",
"enrobage" => "@RobaZ",
"enrobaient" => "@RobE",
"enrobait" => "@RobE",
"enrobant" => "@Rob@",
"enrobe" => "@ROb",
"enrobé" => "@Robe",
"enrobée" => "@Robe",
"enrobées" => "@Robe",
"enrober" => "@Robe",
"enrobèrent" => "@RobER",
"enrobés" => "@Robe",
"enrochements" => "@ROS°m@",
"enrôla" => "@Rola",
"enrôlaient" => "@RolE",
"enrôlais" => "@RolE",
"enrôlait" => "@RolE",
"enrôlant" => "@Rol@",
"enrôle" => "@Rol",
"enrôlé" => "@Role",
"enrôlée" => "@Role",
"enrôlées" => "@Role",
"enrôlement" => "@Rol°m@",
"enrôlements" => "@Rol°m@",
"enrôler" => "@Role",
"enrôlerait" => "@Rol°RE",
"enrôleriez" => "@Rol°Rje",
"enrôlés" => "@Role",
"enrôlez" => "@Role",
"enrôlons" => "@Rol§",
"enroua" => "@Rwa",
"enrouaient" => "@RwE",
"enrouait" => "@RwE",
"enroue" => "@Ru",
"enroué" => "@Rwe",
"enrouée" => "@Rwe",
"enrouées" => "@Rwe",
"enrouement" => "@Rum@",
"enrouements" => "@Rum@",
"enrouer" => "@Rwe",
"enroués" => "@Rwe",
"enroula" => "@Rula",
"enroulage" => "@RulaZ",
"enroulai" => "@RulE",
"enroulaient" => "@RulE",
"enroulais" => "@RulE",
"enroulait" => "@RulE",
"enroulant" => "@Rul@",
"enroule" => "@Rul",
"enroulé" => "@Rule",
"enroulée" => "@Rule",
"enroulées" => "@Rule",
"enroulement" => "@Rul°m@",
"enroulements" => "@Rul°m@",
"enroulent" => "@Rul",
"enrouler" => "@Rule",
"enroulera" => "@Rul°Ra",
"enroulerais" => "@Rul°RE",
"enroulèrent" => "@RulER",
"enroulés" => "@Rule",
"enroulez" => "@Rule",
"enrubannaient" => "@RybanE",
"enrubannait" => "@RybanE",
"enrubanné" => "@Rybane",
"enrubannée" => "@Rybane",
"enrubannées" => "@Rybane",
"enrubanner" => "@Rybane",
"enrubannés" => "@Rybane",
"ensablait" => "@sablE",
"ensable" => "@sabl",
"ensablé" => "@sable",
"ensablée" => "@sable",
"ensablées" => "@sable",
"ensablement" => "@sabl°m@",
"ensablent" => "@sabl",
"ensabler" => "@sable",
"ensablèrent" => "@sablER",
"ensablés" => "@sable",
"ensaché" => "@saSe",
"ensacher" => "@saSe",
"ensanglanta" => "@s@gl@ta",
"ensanglantaient" => "@s@gl@tE",
"ensanglantant" => "@s@gl@t@",
"ensanglante" => "@s@gl@t",
"ensanglanté" => "@s@gl@te",
"ensanglantée" => "@s@gl@te",
"ensanglantées" => "@s@gl@te",
"ensanglantement" => "@s@gl@t°m@",
"ensanglanter" => "@s@gl@te",
"ensanglantèrent" => "@s@gl@tER",
"ensanglantés" => "@s@gl@te",
"ensauvagé" => "@sovaZe",
"ensauvageait" => "@sovaZE",
"ensauvagée" => "@sovaZe",
"ensauvagées" => "@sovaZe",
"ensauvagement" => "@sovaZ°m@",
"ensauvagés" => "@sovaZe",
"ensauve" => "@sov",
"ensauvés" => "@sove",
"enseigna" => "@sENa",
"enseignaient" => "@sENE",
"enseignais" => "@sENE",
"enseignait" => "@sENE",
"enseignant" => "@sEN@",
"enseignant-robot" => "@sEN@Robo",
"enseignante" => "@sEN@t",
"enseignantes" => "@sEN@t",
"enseignants" => "@sEN@",
"enseignât" => "@sENa",
"enseigne" => "@sEN",
"enseigné" => "@seNe",
"enseignée" => "@seNe",
"enseignées" => "@seNe",
"enseignement" => "@sEN°m@",
"enseignements" => "@sEN°m@",
"enseignent" => "@sEN",
"enseigner" => "@seNe",
"enseignera" => "@sEN°Ra",
"enseignerai" => "@sEN°RE",
"enseigneraient" => "@sEN°RE",
"enseignerais" => "@sEN°RE",
"enseignerait" => "@sEN°RE",
"enseigneras" => "@sEN°Ra",
"enseignèrent" => "@sENER",
"enseignerez" => "@sEN°Re",
"enseignerons" => "@sEN°R§",
"enseigneront" => "@sEN°R§",
"enseignes" => "@sEN",
"enseignés" => "@seNe",
"enseigneur" => "@sEN9R",
"enseignez" => "@sENe",
"enseigniez" => "@sENe",
"enseignons" => "@sEN§",
"ensellé" => "@sele",
"ensellement" => "@sEl°m@",
"ensellés" => "@sEle",
"ensellure" => "@selyR",
"ensemble" => "@s@bl",
"ensembles" => "@s@bl",
"ensemença" => "@s°m@sa",
"ensemençaient" => "@s°m@sE",
"ensemençait" => "@s°m@sE",
"ensemençant" => "@s°m@s@",
"ensemencé" => "@s°m@se",
"ensemencée" => "@s°m@se",
"ensemencement" => "@s°m@s°m@",
"ensemencements" => "@s°m@s°m@",
"ensemencer" => "@s°m@se",
"ensemencés" => "@s°m@se",
"enserra" => "@sERa",
"enserrai" => "@sERE",
"enserraient" => "@sERE",
"enserrait" => "@sERE",
"enserrant" => "@sER@",
"enserre" => "@sER",
"enserré" => "@sERe",
"enserrée" => "@sERe",
"enserrées" => "@sERe",
"enserrent" => "@sER",
"enserrer" => "@seRe",
"enserrera" => "@sER°Ra",
"enserrerait" => "@sER°RE",
"enserrèrent" => "@sERER",
"enserres" => "@sER",
"enserrés" => "@sERe",
"enseveli" => "@s°v°li",
"ensevelie" => "@s°v°li",
"ensevelies" => "@s°v°li",
"ensevelir" => "@s°v°liR",
"ensevelira" => "@s°v°liRa",
"ensevelirait" => "@s°v°liRE",
"ensevelis" => "@s°v°li",
"ensevelissaient" => "@s°v°lisE",
"ensevelissais" => "@s°v°lisE",
"ensevelissait" => "@s°v°lisE",
"ensevelissant" => "@s°v°lis@",
"ensevelisse" => "@s°v°lis",
"ensevelissement" => "@s°v°lis°m@",
"ensevelissent" => "@s°v°lis",
"ensevelisseuse" => "@s°v°lis2z",
"ensevelissez" => "@s°v°lise",
"ensevelissons" => "@s°v°lis§",
"ensevelit" => "@s°v°li",
"ensoleilla" => "@solEja",
"ensoleillé" => "@solEje",
"ensoleillée" => "@solEje",
"ensoleillées" => "@solEje",
"ensoleillement" => "@solEj°m@",
"ensoleiller" => "@soleje",
"ensoleillèrent" => "@solEjER",
"ensoleillés" => "@solEje",
"ensommeilla" => "@somEja",
"ensommeillaient" => "@somEjE",
"ensommeillait" => "@somEjE",
"ensommeillé" => "@somEje",
"ensommeillée" => "@somEje",
"ensommeillées" => "@somEje",
"ensommeiller" => "@somEje",
"ensommeillés" => "@somEje",
"ensorcelaient" => "@sORs°lE",
"ensorcelant" => "@sORs°l@",
"ensorcelante" => "@sORs°l@t",
"ensorcelantes" => "@sORs°l@t",
"ensorcelé" => "@sORs°le",
"ensorcelée" => "@sORs°le",
"ensorcelées" => "@sORs°le",
"ensorceler" => "@sORs°le",
"ensorcelés" => "@sORs°le",
"ensorceleur" => "@sORs°l9R",
"ensorceleuse" => "@sORs°l2z",
"ensorceleuses" => "@sORs°l2z",
"ensorcelez" => "@sORs°le",
"ensorcelle" => "@sORsEl",
"ensorcellement" => "@sORsEl°m@",
"ensorcellent" => "@sORsEl",
"ensorcelles" => "@sORsEl",
"ensouple" => "@supl",
"ensoutanée" => "@sutane",
"ensoutanées" => "@sutane",
"ensuit" => "@s8i",
"ensuite" => "@s8it",
"ensuivaient" => "@s8ivE",
"ensuivait" => "@s8ivE",
"ensuive" => "@s8iv",
"ensuivent" => "@s8iv",
"ensuivi" => "@s8ivi",
"ensuivie" => "@s8ivi",
"ensuivies" => "@s8ivi",
"ensuivirent" => "@s8iviR",
"ensuivit" => "@s8ivi",
"ensuivra" => "@s8ivRa",
"ensuivraient" => "@s8ivRE",
"ensuivrait" => "@s8ivRE",
"ensuivre" => "@s8ivR",
"ensuivront" => "@s8ivR§",
"ensuqué" => "@syke",
"ensuquée" => "@syke",
"ensuquent" => "@syk",
"entablement" => "@tabl°m@",
"entachait" => "@taSE",
"entache" => "@taS",
"entaché" => "@taSe",
"entachée" => "@taSe",
"entachées" => "@taSe",
"entachent" => "@taS",
"entacher" => "@taSe",
"entacherait" => "@taS°RE",
"entachés" => "@taSe",
"entailla" => "@taja",
"entaillait" => "@tajE",
"entaille" => "@taj",
"entaillé" => "@taje",
"entaillée" => "@taje",
"entaillées" => "@taje",
"entaillent" => "@taj",
"entailler" => "@taje",
"entaillerai" => "@taj°RE",
"entailles" => "@taj",
"entaillés" => "@taje",
"entama" => "@tama",
"entamai" => "@tamE",
"entamaient" => "@tamE",
"entamais" => "@tamE",
"entamait" => "@tamE",
"entamant" => "@tam@",
"entamât" => "@tama",
"entame" => "@tam",
"entamé" => "@tame",
"entamée" => "@tame",
"entamées" => "@tame",
"entament" => "@tam",
"entamer" => "@tame",
"entamera" => "@tam°Ra",
"entamerai" => "@tam°RE",
"entameraient" => "@tam°RE",
"entamerais" => "@tam°RE",
"entamerait" => "@tam°RE",
"entamèrent" => "@tamER",
"entamerez" => "@tam°Re",
"entamerons" => "@tam°R§",
"entames" => "@tam",
"entamés" => "@tame",
"entamez" => "@tame",
"entamons" => "@tam§",
"entant" => "@t@",
"entassa" => "@tasa",
"entassaient" => "@tasE",
"entassait" => "@tasE",
"entassâmes" => "@tasam",
"entassant" => "@tas@",
"entasse" => "@tas",
"entassé" => "@tase",
"entassée" => "@tase",
"entassées" => "@tase",
"entassement" => "@tas°m@",
"entassements" => "@tas°m@",
"entassent" => "@tas",
"entasser" => "@tase",
"entassera" => "@tas°Ra",
"entasseraient" => "@tas°RE",
"entasserait" => "@tas°RE",
"entassèrent" => "@tasER",
"entasseront" => "@tas°R§",
"entassés" => "@tase",
"entassez" => "@tase",
"entassions" => "@tasj§",
"entassons" => "@tas§",
"ente" => "@t",
"entéléchies" => "@teleSi",
"entement" => "@t°m@",
"entend" => "@t@",
"entendaient" => "@t@dE",
"entendais" => "@t@dE",
"entendait" => "@t@dE",
"entendant" => "@t@d@",
"entende" => "@t@d",
"entendement" => "@t@d°m@",
"entendent" => "@t@d",
"entendes" => "@t@d",
"entendeur" => "@t@d9R",
"entendeurs" => "@t@d9R",
"entendez" => "@t@de",
"entendiez" => "@t@dje",
"entendîmes" => "@t@dim",
"entendions" => "@t@dj§",
"entendirent" => "@t@diR",
"entendis" => "@t@di",
"entendisse" => "@t@dis",
"entendissent" => "@t@dis",
"entendit" => "@t@di",
"entendît" => "@t@di",
"entendons" => "@t@d§",
"entendra" => "@t@dRa",
"entendrai" => "@t@dRE",
"entendraient" => "@t@dRE",
"entendrais" => "@t@dRE",
"entendrait" => "@t@dRE",
"entendras" => "@t@dRa",
"entendre" => "@t@dR",
"entendrez" => "@t@dRe",
"entendriez" => "@t@dRje",
"entendrions" => "@t@dRij§",
"entendrons" => "@t@dR§",
"entendront" => "@t@dR§",
"entends" => "@t@",
"entendu" => "@t@dy",
"entendue" => "@t@dy",
"entendues" => "@t@dy",
"entendus" => "@t@dy",
"enténébra" => "@tenebRa",
"enténébrait" => "@tenebRE",
"enténébrant" => "@tenebR@",
"enténèbre" => "@tenEbR",
"enténébré" => "@tenebRe",
"enténébrée" => "@tenebRe",
"enténébrées" => "@tenebRe",
"enténèbrent" => "@tenEbR",
"enténébrer" => "@tenebRe",
"enténébrés" => "@tenebRe",
"entente" => "@t@t",
"ententes" => "@t@t",
"enter" => "@te",
"entérinais" => "@teRinE",
"entérinait" => "@teRinE",
"entérinant" => "@teRin@",
"entérine" => "@teRin",
"entériné" => "@teRine",
"entérinée" => "@teRine",
"entérinées" => "@teRine",
"entérinement" => "@teRin°m@",
"entériner" => "@teRine",
"entérique" => "@teRik",
"entérite" => "@teRit",
"entérocolite" => "@teRokolit",
"entérovirus" => "@teRoviRys",
"enterra" => "@tERa",
"enterrai" => "@tERE",
"enterraient" => "@tERE",
"enterrais" => "@tERE",
"enterrait" => "@tERE",
"enterrâmes" => "@tERam",
"enterrant" => "@tER@",
"enterre" => "@tER",
"enterré" => "@teRe",
"enterrée" => "@teRe",
"enterrées" => "@teRe",
"enterrement" => "@tER°m@",
"enterrements" => "@tER°m@",
"enterrent" => "@tER",
"enterrer" => "@teRe",
"enterrera" => "@tER°Ra",
"enterrerai" => "@tER°RE",
"enterrerais" => "@tER°RE",
"enterrerait" => "@tER°RE",
"enterreras" => "@tER°Ra",
"enterrèrent" => "@tERER",
"enterrerez" => "@tER°Re",
"enterrerons" => "@tER°R§",
"enterreront" => "@tER°R§",
"enterres" => "@tER",
"enterrés" => "@teRe",
"enterreur" => "@tER9R",
"enterrez" => "@tERe",
"enterriez" => "@tERje",
"enterrions" => "@tERj§",
"enterrons" => "@tER§",
"entêta" => "@tEta",
"entêtai" => "@tEtE",
"entêtaient" => "@tEtE",
"entêtais" => "@tEtE",
"entêtait" => "@tEtE",
"entêtant" => "@tEt@",
"entêtante" => "@tEt@t",
"entêtantes" => "@tEt@t",
"entêtants" => "@tEt@",
"entêtât" => "@tEta",
"entête" => "@tEt",
"entêté" => "@tete",
"entêtée" => "@tete",
"entêtées" => "@tete",
"entêtement" => "@tEt°m@",
"entêtements" => "@tEt°m@",
"entêtent" => "@tEt",
"entêter" => "@tete",
"entêteraient" => "@tEt°RE",
"entêterais" => "@tEt°RE",
"entêtes" => "@tEt",
"entêtés" => "@tete",
"entêtez" => "@tEte",
"entêtiez" => "@tEtje",
"entêtons" => "@tEt§",
"enthalpie" => "@talpi",
"enthousiasma" => "@tuzjasma",
"enthousiasmai" => "@tuzjasmE",
"enthousiasmaient" => "@tuzjasmE",
"enthousiasmais" => "@tuzjasmE",
"enthousiasmait" => "@tuzjasmE",
"enthousiasmant" => "@tuzjasm@",
"enthousiasmante" => "@tuzjasm@t",
"enthousiasme" => "@tuzjasm",
"enthousiasmé" => "@tuzjasme",
"enthousiasmée" => "@tuzjasme",
"enthousiasmer" => "@tuzjasme",
"enthousiasmèrent" => "@tuzjasmER",
"enthousiasmes" => "@tuzjasm",
"enthousiasmés" => "@tuzjasme",
"enthousiasmez" => "@tuzjasme",
"enthousiaste" => "@tuzjast",
"enthousiastes" => "@tuzjast",
"enticha" => "@tiSa",
"entichait" => "@tiSE",
"entiche" => "@tiS",
"entiché" => "@tiSe",
"entichée" => "@tiSe",
"entichement" => "@tiS°m@",
"entichent" => "@tiS",
"enticher" => "@tiSe",
"entichera" => "@tiS°Ra",
"entichèrent" => "@tiSER",
"entichés" => "@tiSe",
"entier" => "@tje",
"entière" => "@tjER",
"entièrement" => "@tjER°m@",
"entières" => "@tjER",
"entièreté" => "@tjER°te",
"entiers" => "@tje",
"entiflé" => "@tifle",
"entifler" => "@tifle",
"entité" => "@tite",
"entités" => "@tite",
"entoilage" => "@twalaZ",
"entoilées" => "@twale",
"entoiler" => "@twale",
"entoilés" => "@twale",
"entôlage" => "@tolaZ",
"entôlé" => "@tole",
"entôlée" => "@tole",
"entôler" => "@tole",
"entôleur" => "@tol9R",
"entolome" => "@tolOm",
"entolomes" => "@tolOm",
"entomologie" => "@tomoloZi",
"entomologique" => "@tomoloZik",
"entomologiste" => "@tomoloZist",
"entomologistes" => "@tomoloZist",
"entonna" => "@tona",
"entonnaient" => "@tonE",
"entonnais" => "@tonE",
"entonnait" => "@tonE",
"entonnâmes" => "@tonam",
"entonnant" => "@ton@",
"entonne" => "@tOn",
"entonné" => "@tone",
"entonnent" => "@tOn",
"entonner" => "@tone",
"entonnera" => "@tOn°Ra",
"entonneraient" => "@tOn°RE",
"entonnèrent" => "@tonER",
"entonnions" => "@tonj§",
"entonnoir" => "@tonwaR",
"entonnoirs" => "@tonwaR",
"entonnons" => "@ton§",
"entorse" => "@tORs",
"entorses" => "@tORs",
"entortilla" => "@tORtija",
"entortillage" => "@tORtijaZ",
"entortillages" => "@tORtijaZ",
"entortillai" => "@tORtijE",
"entortillaient" => "@tORtijE",
"entortillait" => "@tORtijE",
"entortillant" => "@tORtij@",
"entortille" => "@tORtij",
"entortillé" => "@tORtije",
"entortillée" => "@tORtije",
"entortillées" => "@tORtije",
"entortillement" => "@tORtij°m@",
"entortillent" => "@tORtij",
"entortiller" => "@tORtije",
"entortilleraient" => "@tORtij°RE",
"entortillés" => "@tORtije",
"entour" => "@tuR",
"entoura" => "@tuRa",
"entourage" => "@tuRaZ",
"entourages" => "@tuRaZ",
"entourai" => "@tuRE",
"entouraient" => "@tuRE",
"entourais" => "@tuRE",
"entourait" => "@tuRE",
"entourant" => "@tuR@",
"entourât" => "@tuRa",
"entoure" => "@tuR",
"entouré" => "@tuRe",
"entourée" => "@tuRe",
"entourées" => "@tuRe",
"entourent" => "@tuR",
"entourer" => "@tuRe",
"entourera" => "@tuR°Ra",
"entoureraient" => "@tuR°RE",
"entourerait" => "@tuR°RE",
"entourèrent" => "@tuRER",
"entoureront" => "@tuR°R§",
"entoures" => "@tuR",
"entourés" => "@tuRe",
"entourez" => "@tuRe",
"entourions" => "@tuRj§",
"entourloupe" => "@tuRlup",
"entourloupent" => "@tuRlup",
"entourlouper" => "@tuRlupe",
"entourloupes" => "@tuRlup",
"entourloupette" => "@tuRlupEt",
"entourloupettes" => "@tuRlupEt",
"entournures" => "@tuRnyR",
"entourons" => "@tuR§",
"entours" => "@tuR",
"entr'acte" => "@tRakt",
"entr'actes" => "@tRakt",
"entr'aimer" => "@tREme",
"entr'apercevoir" => "@tRapERs°vwaR",
"entr'aperçu" => "@tRapERsy",
"entr'aperçue" => "@tRapERsy",
"entr'aperçues" => "@tRapERsy",
"entr'aperçus" => "@tRapERsy",
"entr'appellent" => "@tRapEl",
"entr'égorgent" => "@tRegORZ",
"entr'égorger" => "@tRegORZe",
"entr'égorgèrent" => "@tRegORZER",
"entr'ouvert" => "@tRuvER",
"entr'ouverte" => "@tRuvERt",
"entr'ouvertes" => "@tRuvERt",
"entr'ouverts" => "@tRuvER",
"entra" => "@tRa",
"entracte" => "@tRakt",
"entractes" => "@tRakt",
"entrai" => "@tRE",
"entraidait" => "@tREdE",
"entraidant" => "@tREd@",
"entraide" => "@tREd",
"entraident" => "@tREd",
"entraider" => "@tREde",
"entraidés" => "@tREde",
"entraidez" => "@tREde",
"entraidiez" => "@tREdje",
"entraidons" => "@tREd§",
"entraient" => "@tRE",
"entrailles" => "@tRaj",
"entrain" => "@tR5",
"entraîna" => "@tREna",
"entraînai" => "@tREnE",
"entraînaient" => "@tREnE",
"entraînais" => "@tREnE",
"entraînait" => "@tREnE",
"entraînant" => "@tREn@",
"entraînante" => "@tREn@t",
"entraînants" => "@tREn@",
"entraînât" => "@tREna",
"entraîne" => "@tREn",
"entraîné" => "@tRene",
"entraînée" => "@tRene",
"entraînées" => "@tRene",
"entraînement" => "@tREn°m@",
"entraînements" => "@tREn°m@",
"entraînent" => "@tREn",
"entraîner" => "@tRene",
"entraînera" => "@tREn°Ra",
"entraînerai" => "@tREn°RE",
"entraîneraient" => "@tREn°RE",
"entraînerais" => "@tREn°RE",
"entraînerait" => "@tREn°RE",
"entraîneras" => "@tREn°Ra",
"entraînèrent" => "@tREnER",
"entraînerez" => "@tREn°Re",
"entraîneriez" => "@tREn°Rje",
"entraîneront" => "@tREn°R§",
"entraînes" => "@tREn",
"entraînés" => "@tRene",
"entraîneur" => "@tREn9R",
"entraîneurs" => "@tREn9R",
"entraîneuse" => "@tREn2z",
"entraîneuses" => "@tREn2z",
"entraînez" => "@tREne",
"entraîniez" => "@tREnje",
"entraînons" => "@tREn§",
"entrais" => "@tRE",
"entrait" => "@tRE",
"entrâmes" => "@tRam",
"entrant" => "@tR@",
"entrante" => "@tR@t",
"entrantes" => "@tR@t",
"entrants" => "@tR@",
"entrapercevoir" => "@tRapERs°vwaR",
"entraperçu" => "@tRapERsy",
"entraperçues" => "@tRapERsy",
"entraperçus" => "@tRapERsy",
"entrassent" => "@tRas",
"entrât" => "@tRa",
"entrava" => "@tRava",
"entravai" => "@tRavE",
"entravaient" => "@tRavE",
"entravais" => "@tRavE",
"entravait" => "@tRavE",
"entravant" => "@tRav@",
"entrave" => "@tRav",
"entravé" => "@tRave",
"entravée" => "@tRave",
"entravées" => "@tRave",
"entravent" => "@tRav",
"entraver" => "@tRave",
"entravera" => "@tRav°Ra",
"entraverais" => "@tRav°RE",
"entraverait" => "@tRav°RE",
"entravèrent" => "@tRavER",
"entraveront" => "@tRav°R§",
"entraves" => "@tRav",
"entravés" => "@tRave",
"entravez" => "@tRave",
"entre" => "@tR",
"entré" => "@tRe",
"entre-déchiraient" => "@tR°deSiRE",
"entre-déchirait" => "@tR°deSiRE",
"entre-déchire" => "@tR°deSiR",
"entre-déchirent" => "@tR°deSiR",
"entre-déchirer" => "@tR°deSiRe",
"entre-déchirèrent" => "@tR°deSiRER",
"entre-deux" => "@tR°d2",
"entre-deux-guerres" => "@tR°d2gER",
"entre-dévorant" => "@tR°devoR@",
"entre-dévorent" => "@tR°devOR",
"entre-dévorer" => "@tR°devoRe",
"entre-dévorèrent" => "@tR°devoRER",
"entre-jambe" => "@tR°Z@b",
"entre-jambes" => "@tR°Z@b",
"entre-rail" => "@tR°Raj",
"entre-regardait" => "@tR°R°gaRdE",
"entre-regardent" => "@tR°R°gaRd",
"entre-regardèrent" => "@tR°R°gaRdER",
"entre-regardés" => "@tR°R°gaRde",
"entre-temps" => "@tR°t@",
"entre-tuaient" => "@tR°t8E",
"entre-tuait" => "@tR°t8E",
"entre-tue" => "@tR°ty",
"entre-tuent" => "@tR°ty",
"entre-tuer" => "@tR°t8e",
"entre-tueront" => "@tR°tyR§",
"entre-tués" => "@tR°t8e",
"entre-tuez" => "@tR°tye",
"entre-tuions" => "@tR°tyj§",
"entrebâilla" => "@tR°baja",
"entrebâillaient" => "@tR°bajE",
"entrebâillais" => "@tR°bajE",
"entrebâillait" => "@tR°bajE",
"entrebâillant" => "@tR°baj@",
"entrebâille" => "@tR°baj",
"entrebâillé" => "@tR°baje",
"entrebâillée" => "@tR°baje",
"entrebâillées" => "@tR°baje",
"entrebâillement" => "@tR°baj°m@",
"entrebâillent" => "@tR°baj",
"entrebâiller" => "@tR°baje",
"entrebâillerait" => "@tR°baj°RE",
"entrebâillèrent" => "@tR°bajER",
"entrebâillés" => "@tR°baje",
"entrebâilleur" => "@tR2baj9R",
"entrebattre" => "@tR°batR",
"entrechat" => "@tR°Sa",
"entrechats" => "@tR°Sa",
"entrechoc" => "@tR°SOk",
"entrechocs" => "@tR°SOk",
"entrechoquaient" => "@tR°SokE",
"entrechoquait" => "@tR°SokE",
"entrechoquant" => "@tR°Sok@",
"entrechoque" => "@tR°SOk",
"entrechoqué" => "@tR°Soke",
"entrechoquées" => "@tR°Soke",
"entrechoquement" => "@tR°SOk°m@",
"entrechoquent" => "@tR°SOk",
"entrechoquer" => "@tR°Soke",
"entrechoquèrent" => "@tR°SokER",
"entrechoqueront" => "@tR°SOk°R§",
"entrechoqués" => "@tR°Soke",
"entrechoquions" => "@tR°Sokj§",
"entreclos" => "@tR°klo",
"entrecloses" => "@tR°kloz",
"entrecôte" => "@tR°kot",
"entrecôtes" => "@tR°kot",
"entrecoupaient" => "@tR°kupE",
"entrecoupais" => "@tR°kupE",
"entrecoupait" => "@tR°kupE",
"entrecoupant" => "@tR°kup@",
"entrecoupe" => "@tR°kup",
"entrecoupé" => "@tR°kupe",
"entrecoupée" => "@tR°kupe",
"entrecoupées" => "@tR°kupe",
"entrecoupent" => "@tR°kup",
"entrecouper" => "@tR°kupe",
"entrecoupés" => "@tR°kupe",
"entrecroisaient" => "@tR°kRwazE",
"entrecroisait" => "@tR°kRwazE",
"entrecroisant" => "@tR°kRwaz@",
"entrecroise" => "@tR°kRwaz",
"entrecroisé" => "@tR°kRwaze",
"entrecroisées" => "@tR°kRwaze",
"entrecroisement" => "@tR°kRwaz°m@",
"entrecroisements" => "@tR°kRwaz°m@",
"entrecroisent" => "@tR°kRwaz",
"entrecroiser" => "@tR°kRwaze",
"entrecroisèrent" => "@tR°kRwazER",
"entrecroisés" => "@tR°kRwaze",
"entrecuisse" => "@tR°k8is",
"entredéchire" => "@tR°deSiR",
"entredévorait" => "@tR°devoRE",
"entredévorer" => "@tR°devoRe",
"entrée" => "@tRe",
"entrée-sortie" => "@tResORti",
"entrées" => "@tRe",
"entrefaites" => "@tR°fEt",
"entreferma" => "@tR°fERma",
"entrefermée" => "@tR°fERme",
"entrefermées" => "@tR°fERme",
"entrefilet" => "@tR°filE",
"entrefilets" => "@tR°filE",
"entregent" => "@tR°Z@",
"entrejambe" => "@tR°Z@b",
"entrejambes" => "@tR°Z@b",
"entrelaçaient" => "@tR°lasE",
"entrelaçait" => "@tR°lasE",
"entrelace" => "@tR°las",
"entrelacé" => "@tR°lase",
"entrelacée" => "@tR°lase",
"entrelacées" => "@tR°lase",
"entrelacement" => "@tR°las°m@",
"entrelacent" => "@tR°las",
"entrelacer" => "@tR°lase",
"entrelacèrent" => "@tR°lasER",
"entrelacés" => "@tR°lase",
"entrelacs" => "@tR°la",
"entrelarde" => "@tR°laRd",
"entrelardé" => "@tR°laRde",
"entrelardée" => "@tR°laRde",
"entrelardées" => "@tR°laRde",
"entrelarder" => "@tR°laRde",
"entrelardés" => "@tR°laRde",
"entremêlaient" => "@tR°mElE",
"entremêlait" => "@tR°mElE",
"entremêlant" => "@tR°mEl@",
"entremêle" => "@tR°mEl",
"entremêlé" => "@tR°mele",
"entremêlées" => "@tR°mele",
"entremêlement" => "@tR°mEl°m@",
"entremêlent" => "@tR°mEl",
"entremêlés" => "@tR°mele",
"entremet" => "@tR°mE",
"entremets" => "@tR°mE",
"entremettait" => "@tR°mEtE",
"entremetteur" => "@tR°mEt9R",
"entremetteurs" => "@tR°mEt9R",
"entremetteuse" => "@tR°mEt2z",
"entremettre" => "@tR°mEtR",
"entremis" => "@tR°mi",
"entremise" => "@tR°miz",
"entremit" => "@tR°mi",
"entrent" => "@tR",
"entrepont" => "@tR°p§",
"entreponts" => "@tR°p§",
"entreposage" => "@tR°pozaZ",
"entreposais" => "@tR°pozE",
"entreposait" => "@tR°pozE",
"entrepose" => "@tR°poz",
"entreposé" => "@tR°poze",
"entreposée" => "@tR°poze",
"entreposées" => "@tR°poze",
"entreposent" => "@tR°poz",
"entreposer" => "@tR°poze",
"entreposerait" => "@tR°poz°RE",
"entreposés" => "@tR°poze",
"entreposez" => "@tR°poze",
"entreposions" => "@tR°pozj§",
"entrepôt" => "@tR°po",
"entrepôts" => "@tR°po",
"entreprenaient" => "@tR°pR°nE",
"entreprenais" => "@tR°pR°nE",
"entreprenait" => "@tR°pR°nE",
"entreprenant" => "@tR°pR°n@",
"entreprenante" => "@tR°pR°n@t",
"entreprenantes" => "@tR°pR°n@t",
"entreprenants" => "@tR°pR°n@",
"entreprend" => "@tR°pR@",
"entreprendrai" => "@tR°pR@dRE",
"entreprendraient" => "@tR°pR@dRE",
"entreprendrais" => "@tR°pR@dRE",
"entreprendrait" => "@tR°pR@dRE",
"entreprendras" => "@tR°pR@dRa",
"entreprendre" => "@tR°pR@dR",
"entreprendrez" => "@tR°pR@dRe",
"entreprendrons" => "@tR°pR@dR§",
"entreprends" => "@tR°pR@",
"entrepreneur" => "@tR°pR°n9R",
"entrepreneurs" => "@tR°pR°n9R",
"entrepreneuse" => "@tR°pR°n2z",
"entrepreneuses" => "@tR°pR°n2z",
"entreprenez" => "@tR°pR9ne",
"entrepreniez" => "@tR°pR°nje",
"entreprenions" => "@tR°pR°nj§",
"entreprenne" => "@tR°pREn",
"entreprennent" => "@tR°pREn",
"entreprenons" => "@tR°pR9n§",
"entreprîmes" => "@tR°pRim",
"entreprirent" => "@tR°pRiR",
"entrepris" => "@tR°pRi",
"entreprise" => "@tR°pRiz",
"entreprises" => "@tR°pRiz",
"entreprit" => "@tR°pRi",
"entreprît" => "@tR°pRi",
"entrer" => "@tRe",
"entrera" => "@tR°Ra",
"entrerai" => "@tR°RE",
"entreraient" => "@tR°RE",
"entrerais" => "@tR°RE",
"entrerait" => "@tR°RE",
"entreras" => "@tR°Ra",
"entreregardèrent" => "@tR°RgaRdER",
"entrèrent" => "@tRER",
"entrerez" => "@tR°Re",
"entrerions" => "@tR°Rj§",
"entrerons" => "@tR°R§",
"entreront" => "@tR°R§",
"entres" => "@tR",
"entrés" => "@tRe",
"entresol" => "@tR°sOl",
"entresols" => "@tR°sOl",
"entretenaient" => "@tR°t°nE",
"entretenais" => "@tR°t°nE",
"entretenait" => "@tR°t°nE",
"entretenant" => "@tR°t°n@",
"entreteneur" => "@tR°t°n9R",
"entreteneuse" => "@tR°t°n2z",
"entretenez" => "@tR°t°ne",
"entreteniez" => "@tR°t°nje",
"entretenions" => "@tR°t°nj§",
"entretenir" => "@tR°t°niR",
"entretenons" => "@tR°t°n§",
"entretenu" => "@tR°t°ny",
"entretenue" => "@tR°t°ny",
"entretenues" => "@tR°t°ny",
"entretenus" => "@tR°t°ny",
"entretien" => "@tR°tj5",
"entretiendra" => "@tR°tj5dRa",
"entretiendrai" => "@tR°tj5dRE",
"entretiendraient" => "@tR°tj5dRE",
"entretiendrait" => "@tR°tj5dRE",
"entretiendras" => "@tR°tj5dRa",
"entretiendrez" => "@tR°tj5dRe",
"entretiendrons" => "@tR°tj5dR§",
"entretienne" => "@tR°tjEn",
"entretiennent" => "@tR°tjEn",
"entretiennes" => "@tR°tjEn",
"entretiens" => "@tR°tj5",
"entretient" => "@tR°tj5",
"entretînmes" => "@tR°t5m",
"entretinrent" => "@tR°t5R",
"entretins" => "@tR°t5",
"entretint" => "@tR°t5",
"entretînt" => "@tR°t5",
"entretissait" => "@tR°tisE",
"entretissé" => "@tR°tise",
"entretissées" => "@tR°tise",
"entretoisaient" => "@tR°twazE",
"entretoise" => "@tR°twaz",
"entretoisement" => "@tR°twaz°m@",
"entretuaient" => "@tR°t8E",
"entretuant" => "@tR°ty@",
"entretue" => "@tR°ty",
"entretuées" => "@tR°tye",
"entretuent" => "@tR°ty",
"entretuer" => "@tR°tye",
"entretueraient" => "@tR°tyRE",
"entretuerait" => "@tR°tyRE",
"entretueront" => "@tR°tyR§",
"entretués" => "@tR°tye",
"entretuez" => "@tR°tye",
"entreverrai" => "@tR°vERE",
"entrevirent" => "@tR°viR",
"entrevis" => "@tR°vi",
"entrevit" => "@tR°vi",
"entrevît" => "@tR°vi",
"entrevoie" => "@tR°vwa",
"entrevoient" => "@tR°vwa",
"entrevoir" => "@tR°vwaR",
"entrevois" => "@tR°vwa",
"entrevoit" => "@tR°vwa",
"entrevous" => "@tR°vu",
"entrevoyaient" => "@tR°vwajE",
"entrevoyais" => "@tR°vwajE",
"entrevoyait" => "@tR°vwajE",
"entrevoyant" => "@tR°vwaj@",
"entrevoyons" => "@tR°vwaj§",
"entrevu" => "@tR°vy",
"entrevue" => "@tR°vy",
"entrevues" => "@tR°vy",
"entrevus" => "@tR°vy",
"entrez" => "@tRe",
"entriez" => "@tRje",
"entrions" => "@tRij§",
"entrisme" => "@tRizm",
"entrons" => "@tR§",
"entropie" => "@tRopi",
"entropique" => "@tRopik",
"entropiques" => "@tRopik",
"entrouvert" => "@tRuvER",
"entrouverte" => "@tRuvERt",
"entrouvertes" => "@tRuvERt",
"entrouverts" => "@tRuvER",
"entrouverture" => "@tRuvERtyR",
"entrouvraient" => "@tRuvRE",
"entrouvrait" => "@tRuvRE",
"entrouvrant" => "@tRuvR@",
"entrouvre" => "@tRuvR",
"entrouvrent" => "@tRuvR",
"entrouvrir" => "@tRuvRiR",
"entrouvrirait" => "@tRuvRiRE",
"entrouvrirent" => "@tRuvRiR",
"entrouvris" => "@tRuvRi",
"entrouvrit" => "@tRuvRi",
"entrouvrît" => "@tRuvRi",
"entubait" => "@tybE",
"entube" => "@tyb",
"entubé" => "@tybe",
"entubée" => "@tybe",
"entubent" => "@tyb",
"entuber" => "@tybe",
"entuberais" => "@tyb°RE",
"entubes" => "@tyb",
"entubés" => "@tybe",
"entubez" => "@tybe",
"enturbanné" => "@tyRbane",
"enturbannée" => "@tyRbane",
"enturbannées" => "@tyRbane",
"enturbanner" => "@tyRbane",
"enturbannés" => "@tyRbane",
"enture" => "@tyR",
"énucléation" => "enykleasj§",
"énucléé" => "enyklee",
"énucléer" => "enyklee",
"énucléés" => "enyklee",
"énuméra" => "enymeRa",
"énumérai" => "enymeRE",
"énuméraient" => "enymeRE",
"énumérais" => "enymeRE",
"énumérait" => "enymeRE",
"énumérant" => "enymeR@",
"énumération" => "enymeRasj§",
"énumérations" => "enymeRasj§",
"énumérative" => "enymeRativ",
"énumère" => "enymER",
"énuméré" => "enymeRe",
"énumérées" => "enymeRe",
"énumèrent" => "enymER",
"énumérer" => "enymeRe",
"énumérerai" => "enymeR°RE",
"énumérerais" => "enymeR°RE",
"énumères" => "enymER",
"énumérez" => "enymeRe",
"énumérons" => "enymeR§",
"énurésie" => "enyRezi",
"énurétique" => "enyRetik",
"envahi" => "@vai",
"envahie" => "@vai",
"envahies" => "@vai",
"envahir" => "@vaiR",
"envahira" => "@vaiRa",
"envahirai" => "@vaiRE",
"envahiraient" => "@vaiRE",
"envahirait" => "@vaiRE",
"envahirent" => "@vaiR",
"envahirez" => "@vaiRe",
"envahirons" => "@vaiR§",
"envahiront" => "@vaiR§",
"envahis" => "@vai",
"envahissaient" => "@vaisE",
"envahissait" => "@vaisE",
"envahissant" => "@vais@",
"envahissante" => "@vais@t",
"envahissantes" => "@vais@t",
"envahissants" => "@vais@",
"envahisse" => "@vais",
"envahissement" => "@vais°m@",
"envahissements" => "@vais°m@",
"envahissent" => "@vais",
"envahisseur" => "@vais9R",
"envahisseurs" => "@vais9R",
"envahissez" => "@vaise",
"envahissiez" => "@vaisje",
"envahit" => "@vai",
"envahît" => "@vai",
"envasait" => "@vazE",
"envasé" => "@vaze",
"envasée" => "@vaze",
"envasées" => "@vaze",
"envasement" => "@vaz°m@",
"envaser" => "@vaze",
"enveloppa" => "@v°lopa",
"enveloppai" => "@v°lopE",
"enveloppaient" => "@v°lopE",
"enveloppais" => "@v°lopE",
"enveloppait" => "@v°lopE",
"enveloppant" => "@v°lop@",
"enveloppante" => "@v°lop@t",
"enveloppantes" => "@v°lop@t",
"enveloppants" => "@v°lop@",
"enveloppât" => "@v°lopa",
"enveloppe" => "@v°lOp",
"enveloppé" => "@v°lope",
"enveloppée" => "@v°lope",
"enveloppées" => "@v°lope",
"enveloppement" => "@v°lOp°m@",
"enveloppements" => "@v°lOp°m@",
"enveloppent" => "@v°lOp",
"envelopper" => "@v°lope",
"enveloppera" => "@v°lOp°Ra",
"envelopperaient" => "@v°lOp°RE",
"envelopperait" => "@v°lOp°RE",
"enveloppèrent" => "@v°lopER",
"envelopperez" => "@v°lOp°Re",
"enveloppes" => "@v°lOp",
"enveloppés" => "@v°lope",
"enveloppeur" => "@v°lop9R",
"enveloppez" => "@v°lope",
"enveloppons" => "@v°lop§",
"envenima" => "@v°nima",
"envenimait" => "@v°nimE",
"envenimant" => "@v°nim@",
"envenime" => "@v°nim",
"envenimé" => "@v°nime",
"envenimée" => "@v°nime",
"envenimées" => "@v°nime",
"enveniment" => "@v°nim",
"envenimer" => "@v°nime",
"envenimèrent" => "@v°nimER",
"envenimés" => "@v°nime",
"envenimons" => "@v°nim§",
"enverguée" => "@vERge",
"envergure" => "@vERgyR",
"enverra" => "@vERa",
"enverrai" => "@vERE",
"enverraient" => "@vERE",
"enverrais" => "@vERE",
"enverrait" => "@vERE",
"enverras" => "@vERa",
"enverrez" => "@vERe",
"enverriez" => "@vERje",
"enverrions" => "@vERj§",
"enverrons" => "@vERR§",
"enverront" => "@vERR§",
"envers" => "@vER",
"envia" => "@vja",
"enviable" => "@vjabl",
"enviables" => "@vjabl",
"enviai" => "@vjE",
"enviaient" => "@vjE",
"enviais" => "@vjE",
"enviait" => "@vjE",
"enviandait" => "@vj@dE",
"enviandé" => "@vj@de",
"enviandés" => "@vj@de",
"enviant" => "@vj@",
"enviât" => "@vja",
"envie" => "@vi",
"envié" => "@vje",
"enviée" => "@vje",
"enviées" => "@vje",
"envient" => "@vi",
"envier" => "@vje",
"enviera" => "@viRa",
"envieraient" => "@viRE",
"envierais" => "@viRE",
"envierait" => "@viRE",
"envieront" => "@viR§",
"envies" => "@vi",
"enviés" => "@vje",
"envieuse" => "@vj2z",
"envieuses" => "@vj2z",
"envieux" => "@vj2",
"enviez" => "@vje",
"enviions" => "@vijj§",
"envions" => "@vj§",
"environ" => "@viR§",
"environnaient" => "@viRonE",
"environnait" => "@viRonE",
"environnant" => "@viRon@",
"environnante" => "@viRon@t",
"environnantes" => "@viRon@t",
"environnants" => "@viRon@",
"environne" => "@viROn",
"environné" => "@viRone",
"environnée" => "@viRone",
"environnées" => "@viRone",
"environnement" => "@viROn°m@",
"environnemental" => "@viROn°m@tal",
"environnementale" => "@viROn°m@tal",
"environnementaux" => "@viROn°m@to",
"environnements" => "@viROn°m@",
"environnent" => "@viROn",
"environner" => "@viRone",
"environnés" => "@viRone",
"environs" => "@viR§",
"envisage" => "@vizaZ",
"envisagé" => "@vizaZe",
"envisagea" => "@vizaZa",
"envisageable" => "@vizaZabl",
"envisageables" => "@vizaZabl",
"envisageai" => "@vizaZE",
"envisageaient" => "@vizaZE",
"envisageais" => "@vizaZE",
"envisageait" => "@vizaZE",
"envisageant" => "@vizaZ@",
"envisageât" => "@vizaZa",
"envisagée" => "@vizaZe",
"envisagées" => "@vizaZe",
"envisagent" => "@vizaZ",
"envisageons" => "@vizaZ§",
"envisager" => "@vizaZe",
"envisagera" => "@vizaZ°Ra",
"envisagerai" => "@vizaZ°RE",
"envisagerais" => "@vizaZ°RE",
"envisagerait" => "@vizaZ°RE",
"envisageras" => "@vizaZ°Ra",
"envisagèrent" => "@vizaZER",
"envisagerez" => "@vizaZ°Re",
"envisageriez" => "@vizaZ°Rje",
"envisagerions" => "@vizaZ°Rj§",
"envisages" => "@vizaZ",
"envisagés" => "@vizaZe",
"envisagez" => "@vizaZe",
"envisagiez" => "@vizaZje",
"envisagions" => "@vizaZj§",
"envoi" => "@vwa",
"envoie" => "@vwa",
"envoient" => "@vwa",
"envoies" => "@vwa",
"envois" => "@vwa",
"envol" => "@vOl",
"envola" => "@vola",
"envolai" => "@volE",
"envolaient" => "@volE",
"envolais" => "@volE",
"envolait" => "@volE",
"envolâmes" => "@volam",
"envolant" => "@vol@",
"envolât" => "@vola",
"envole" => "@vOl",
"envolé" => "@vole",
"envolée" => "@vole",
"envolées" => "@vole",
"envolent" => "@vOl",
"envoler" => "@vole",
"envolera" => "@vOl°Ra",
"envolerai" => "@vOl°RE",
"envoleraient" => "@vOl°RE",
"envolerais" => "@vOl°RE",
"envolerait" => "@vOl°RE",
"envolèrent" => "@volER",
"envolerez" => "@vOl°Re",
"envolerions" => "@vOl°Rj§",
"envolerons" => "@vOl°R§",
"envoleront" => "@vOl°R§",
"envoles" => "@vOl",
"envolés" => "@vole",
"envolez" => "@vole",
"envolons" => "@vol§",
"envols" => "@vOl",
"envoûtaient" => "@vutE",
"envoûtait" => "@vutE",
"envoûtant" => "@vut@",
"envoûtante" => "@vut@t",
"envoûtantes" => "@vut@t",
"envoûtants" => "@vut@",
"envoûte" => "@vut",
"envoûté" => "@vute",
"envoûtée" => "@vute",
"envoûtées" => "@vute",
"envoûtement" => "@vut°m@",
"envoûtements" => "@vut°m@",
"envoûter" => "@vute",
"envoûteras" => "@vut°Ra",
"envoûtés" => "@vute",
"envoûteur" => "@vut9R",
"envoûteurs" => "@vut9R",
"envoya" => "@vwaja",
"envoyai" => "@vwajE",
"envoyaient" => "@vwajE",
"envoyais" => "@vwajE",
"envoyait" => "@vwajE",
"envoyâmes" => "@vwajam",
"envoyant" => "@vwaj@",
"envoyât" => "@vwaja",
"envoyé" => "@vwaje",
"envoyée" => "@vwaje",
"envoyées" => "@vwaje",
"envoyer" => "@vwaje",
"envoyèrent" => "@vwajER",
"envoyés" => "@vwaje",
"envoyeur" => "@vwaj9R",
"envoyeurs" => "@vwaj9R",
"envoyez" => "@vwaje",
"envoyiez" => "@vwaje",
"envoyions" => "@vwajj§",
"envoyons" => "@vwaj§",
"enzymatique" => "@zimatik",
"enzyme" => "@zim",
"enzymes" => "@zim",
"éocène" => "eOsEn",
"éolien" => "eolj5",
"éolienne" => "eoljEn",
"éoliennes" => "eoljEn",
"éoliens" => "eolj5",
"éon" => "e§",
"éonisme" => "eonizm",
"éosine" => "eOzin",
"épagneul" => "epaN9l",
"épagneule" => "epaN9l",
"épagomènes" => "epagomEn",
"épais" => "epE",
"épaisse" => "epEs",
"épaissement" => "epEs°m@",
"épaisses" => "epEs",
"épaisseur" => "epEs9R",
"épaisseurs" => "epEs9R",
"épaissi" => "epEsi",
"épaissie" => "epEsi",
"épaissies" => "epesi",
"épaissir" => "epesiR",
"épaissirais" => "epEsiRE",
"épaissirent" => "epEsiR",
"épaissis" => "epEsi",
"épaississaient" => "epEsisE",
"épaississait" => "epEsisE",
"épaississant" => "epEsis@",
"épaississe" => "epEsis",
"épaississement" => "epesis°m@",
"épaississent" => "epEsis",
"épaissit" => "epEsi",
"épancha" => "ep@Sa",
"épanchaient" => "ep@SE",
"épanchais" => "ep@SE",
"épanchait" => "ep@SE",
"épanchant" => "ep@S@",
"épanche" => "ep@S",
"épanché" => "ep@Se",
"épanchement" => "ep@S°m@",
"épanchements" => "ep@S°m@",
"épanchent" => "ep@S",
"épancher" => "ep@Se",
"épancherait" => "ep@S°RE",
"épand" => "ep@",
"épandage" => "ep@daZ",
"épandages" => "ep@daZ",
"épandaient" => "ep@dE",
"épandait" => "ep@dE",
"épandant" => "ep@d@",
"épandent" => "ep@d",
"épandeur" => "ep@d9R",
"épandez" => "ep@de",
"épandre" => "ep@dR",
"épands" => "ep@",
"épandu" => "ep@dy",
"épandue" => "ep@dy",
"épandues" => "ep@dy",
"épanoui" => "epanwi",
"épanouie" => "epanwi",
"épanouies" => "epanwi",
"épanouir" => "epanwiR",
"épanouira" => "epanwiRa",
"épanouirait" => "epanwiRE",
"épanouirent" => "epanwiR",
"épanouis" => "epanwi",
"épanouissaient" => "epanwisE",
"épanouissais" => "epanwisE",
"épanouissait" => "epanwisE",
"épanouissant" => "epanwis@",
"épanouissante" => "epanwis@t",
"épanouissantes" => "epanwis@t",
"épanouisse" => "epanwis",
"épanouissement" => "epanwis°m@",
"épanouissements" => "epanwis°m@",
"épanouissent" => "epanwis",
"épanouisses" => "epanuis",
"épanouit" => "epanwi",
"épanouît" => "epanwi",
"épargna" => "epaRNa",
"épargnaient" => "epaRNE",
"épargnais" => "epaRNE",
"épargnait" => "epaRNE",
"épargnant" => "epaRN@",
"épargnantes" => "epaRN@t",
"épargnants" => "epaRN@",
"épargnât" => "epaRNa",
"épargne" => "epaRN",
"épargné" => "epaRNe",
"épargnée" => "epaRNe",
"épargnées" => "epaRNe",
"épargnent" => "epaRN",
"épargner" => "epaRNe",
"épargnera" => "epaRN°Ra",
"épargnerai" => "epaRN°RE",
"épargnerais" => "epaRN°RE",
"épargnerait" => "epaRN°RE",
"épargneras" => "epaRN°Ra",
"épargnèrent" => "epaRNER",
"épargnerez" => "epaRN°Re",
"épargneriez" => "epaRN°Rje",
"épargnerons" => "epaRN°R§",
"épargneront" => "epaRN°R§",
"épargnes" => "epaRN",
"épargnés" => "epaRNe",
"épargnez" => "epaRNe",
"épargniez" => "epaRNe",
"épargnions" => "epaRN§",
"épargnons" => "epaRN§",
"éparpilla" => "epaRpija",
"éparpillaient" => "epaRpijE",
"éparpillait" => "epaRpijE",
"éparpillant" => "epaRpij@",
"éparpille" => "epaRpij",
"éparpillé" => "epaRpije",
"éparpillée" => "epaRpije",
"éparpillées" => "epaRpije",
"éparpillement" => "epaRpij°m@",
"éparpillent" => "epaRpij",
"éparpiller" => "epaRpije",
"éparpillera" => "epaRpij°Ra",
"éparpilleraient" => "epaRpij°RE",
"éparpillèrent" => "epaRpijER",
"éparpillés" => "epaRpije",
"éparpillez" => "epaRpije",
"éparpillons" => "epaRpij§",
"épars" => "epaR",
"éparse" => "epaRs",
"éparses" => "epaRs",
"épart" => "epaR",
"épastrouillant" => "epastRuj@",
"épastrouillera" => "epastRuj°Ra",
"épata" => "epata",
"épataient" => "epatE",
"épatais" => "epatE",
"épatait" => "epatE",
"épatamment" => "epatam@",
"épatant" => "epat@",
"épatante" => "epat@t",
"épatantes" => "epat@t",
"épatants" => "epat@",
"épate" => "epat",
"épaté" => "epate",
"épatée" => "epate",
"épatement" => "epat°m@",
"épatent" => "epat",
"épater" => "epate",
"épatera" => "epat°Ra",
"épaterait" => "epat°RE",
"épateras" => "epat°Ra",
"épates" => "epat",
"épatés" => "epate",
"épateur" => "epat9R",
"épateurs" => "epat9R",
"épatez" => "epate",
"épaula" => "epola",
"épaulaient" => "epolE",
"épaulait" => "epolE",
"épaulant" => "epol@",
"épaulard" => "epolaR",
"épaulards" => "epolaR",
"épaule" => "epol",
"épaulé" => "epole",
"épaulée" => "epole",
"épaulées" => "epole",
"épaulement" => "epol°m@",
"épaulements" => "epol°m@",
"épaulent" => "epol",
"épauler" => "epole",
"épauleras" => "epol°Ra",
"épaulèrent" => "epolER",
"épaules" => "epol",
"épaulés" => "epole",
"épaulette" => "epolEt",
"épaulettes" => "epolEt",
"épaulez" => "epole",
"épaulière" => "epoljER",
"épaulières" => "epoljER",
"épave" => "epav",
"épaves" => "epav",
"épeautre" => "epotR",
"épectase" => "epEktaz",
"épée" => "epe",
"épées" => "epe",
"épeichette" => "epESEt",
"épeire" => "epER",
"épéiste" => "epeist",
"épéistes" => "epeist",
"épela" => "ep°la",
"épelais" => "ep°lE",
"épelait" => "ep°lE",
"épelant" => "ep°l@",
"épelé" => "ep°le",
"épeler" => "ep°le",
"épelés" => "ep°le",
"épelez" => "ep°le",
"épeliez" => "ep°lje",
"épelions" => "ep°lj§",
"épellation" => "epElasj§",
"épelle" => "epEl",
"épellent" => "epEl",
"épellerais" => "epEl°RE",
"épelles" => "epEl",
"épendyme" => "ep@dim",
"épépine" => "epepin",
"éperdu" => "epERdy",
"éperdue" => "epERdy",
"éperdues" => "epERdy",
"éperdument" => "epERdym@",
"éperdus" => "epERdy",
"éperlan" => "epERl@",
"éperlans" => "epERl@",
"éperon" => "ep°R§",
"éperonna" => "ep°Rona",
"éperonnant" => "ep°Ron@",
"éperonne" => "ep°ROn",
"éperonné" => "ep°Rone",
"éperonnée" => "ep°Rone",
"éperonner" => "ep°Rone",
"éperonnera" => "ep°ROn°Ra",
"éperonnèrent" => "ep°RonER",
"éperonnés" => "ep°Rone",
"éperonnez" => "ep°Rone",
"éperons" => "ep°R§",
"épervier" => "epERvje",
"épervière" => "epERvjER",
"épervières" => "epERvjER",
"éperviers" => "epERvje",
"épeurant" => "ep9R@",
"épeuré" => "ep9Re",
"épeurée" => "ep9Re",
"épeurer" => "ep9Re",
"éphèbe" => "efEb",
"éphèbes" => "efEb",
"éphébie" => "efebi",
"éphédrine" => "efedRin",
"éphélides" => "efelid",
"éphémère" => "efemER",
"éphémèrement" => "efemER°m@",
"éphémères" => "efemER",
"éphéméride" => "efemeRid",
"éphémérides" => "efemeRid",
"éphésiens" => "efezj5",
"épi" => "epi",
"épia" => "epja",
"épiai" => "epjE",
"épiaient" => "epjE",
"épiais" => "epjE",
"épiait" => "epjE",
"épiant" => "epj@",
"épicanthus" => "epik@tys",
"épice" => "epis",
"épicé" => "epise",
"épicéa" => "episea",
"épicée" => "epise",
"épicées" => "epise",
"épicemard" => "epis°maR",
"épicemards" => "epis°maR",
"épicentre" => "epis@tR",
"épicer" => "epise",
"épicerie" => "epis°Ri",
"épiceries" => "epis°Ri",
"épices" => "epis",
"épicés" => "epise",
"épicier" => "episje",
"épicière" => "episjER",
"épicières" => "episjER",
"épiciers" => "episje",
"épicondyle" => "epik§dil",
"épicrânienne" => "epikRanjEn",
"épicurien" => "epikyRj5",
"épicurienne" => "epikyRjEn",
"épicuriens" => "epikyRj5",
"épicurisme" => "epikyRizm",
"épidémie" => "epidemi",
"épidémies" => "epidemi",
"épidémiologie" => "epidemjoloZi",
"épidémiologique" => "epidemjOlOgik",
"épidémiologiste" => "epidemjoloZist",
"épidémique" => "epidemik",
"épidémiques" => "epidemik",
"épiderme" => "epidERm",
"épidermes" => "epidERm",
"épidermique" => "epidERmik",
"épidermiques" => "epidERmik",
"épidiascopes" => "epidjaskOp",
"épididyme" => "epididim",
"épididymes" => "epididim",
"épidural" => "epidyRal",
"épidurale" => "epidyRal",
"épie" => "epi",
"épié" => "epje",
"épiée" => "epje",
"épiées" => "epje",
"épient" => "epi",
"épier" => "epje",
"épierais" => "epjeRE",
"épierait" => "epjeRE",
"épièrent" => "epjER",
"épierrer" => "epjeRe",
"épies" => "epi",
"épiés" => "epje",
"épieu" => "epj2",
"épieux" => "epj2",
"épiez" => "epje",
"épigastre" => "epigastR",
"épigastrique" => "epigastRik",
"épiglotte" => "epiglOt",
"épigone" => "epigon",
"épigones" => "epigon",
"épigramme" => "epigRam",
"épigrammes" => "epigRam",
"épigraphe" => "epigRaf",
"épigraphie" => "epigRafi",
"épigraphistes" => "epigRafist",
"épilais" => "epilE",
"épilait" => "epilE",
"épilant" => "epil@",
"épilateur" => "epilat9R",
"épilation" => "epilasj§",
"épilatoire" => "epilatwaR",
"épile" => "epil",
"épilé" => "epile",
"épilée" => "epile",
"épilées" => "epile",
"épilent" => "epil",
"épilepsie" => "epilEpsi",
"épileptiforme" => "epilEptifORm",
"épileptique" => "epilEptik",
"épileptiques" => "epilEptik",
"épiler" => "epile",
"épilés" => "epile",
"épileuse" => "epil2z",
"épilez" => "epile",
"épiloguaient" => "epilogE",
"épilogue" => "epilOg",
"épilogué" => "epiloge",
"épiloguer" => "epiloge",
"épiloguèrent" => "epilogER",
"épilogues" => "epilOg",
"épiloguions" => "epilogj§",
"épinaie" => "epinE",
"épinard" => "epinaR",
"épinards" => "epinaR",
"épine" => "epin",
"épine-vinette" => "epinvinEt",
"épines" => "epin",
"épinette" => "epinEt",
"épinettes" => "epinEt",
"épineuse" => "epin2z",
"épineuses" => "epin2z",
"épineux" => "epin2",
"épingla" => "ep5gla",
"épinglage" => "ep5glaZ",
"épinglai" => "ep5glE",
"épinglaient" => "ep5glE",
"épinglait" => "ep5glE",
"épingle" => "ep5gl",
"épinglé" => "ep5gle",
"épinglée" => "ep5gle",
"épinglées" => "ep5gle",
"épinglent" => "ep5gl",
"épingler" => "ep5gle",
"épinglera" => "ep5gl°Ra",
"épinglerai" => "ep5gl°RE",
"épinglèrent" => "ep5glER",
"épingleront" => "ep5gl°R§",
"épingles" => "ep5gl",
"épinglés" => "ep5gle",
"épinglette" => "ep5glEt",
"épinglez" => "ep5gle",
"épinglons" => "ep5gl§",
"épinière" => "epinjER",
"épiniers" => "epinje",
"épinoches" => "epinOS",
"épions" => "epj§",
"épiphane" => "epifan",
"épiphanie" => "epifani",
"épiphénomène" => "epifenomEn",
"épiphylle" => "epifil",
"épiphylles" => "epifil",
"épiphysaire" => "epifizER",
"épiphyse" => "epifiz",
"épiphyte" => "epifit",
"épiphytes" => "epifit",
"épiploon" => "epiplun",
"épiploons" => "epiplun",
"épique" => "epik",
"épiques" => "epik",
"épis" => "epi",
"épiscopal" => "episkopal",
"épiscopale" => "episkopal",
"épiscopales" => "episkopal",
"épiscopalien" => "episkopalj5",
"épiscopalienne" => "episkopaljEn",
"épiscopat" => "episkopa",
"épiscopaux" => "episkopo",
"épisiotomie" => "epizjotomi",
"épisode" => "epizOd",
"épisodes" => "epizOd",
"épisodique" => "epizodik",
"épisodiquement" => "epizodik°m@",
"épisodiques" => "epizodik",
"épissé" => "epise",
"épisser" => "epise",
"épissoirs" => "episwaR",
"épissures" => "episyR",
"épistémologie" => "epistemoloZi",
"épistémologique" => "epistemoloZik",
"épistémologues" => "epistemolOg",
"épistolaire" => "epistolER",
"épistolaires" => "epistolER",
"épistolier" => "epistolje",
"épistolière" => "epistoljER",
"épitaphe" => "epitaf",
"épitaphes" => "epitaf",
"épithalame" => "epitalam",
"épithalames" => "epitalam",
"épithélial" => "epiteljal",
"épithéliale" => "epiteljal",
"épithélioma" => "epiteljoma",
"épithélium" => "epiteljOm",
"épithète" => "epitEt",
"épithètes" => "epitEt",
"épitoge" => "epitOZ",
"épitomé" => "epitome",
"épître" => "epitR",
"épîtres" => "epitR",
"éploie" => "eplwa",
"éploient" => "eplwa",
"éploré" => "eploRe",
"éplorée" => "eploRe",
"éplorées" => "eploRe",
"éplorés" => "eploRe",
"éployai" => "eplwajE",
"éployait" => "eplwajE",
"éployé" => "eplwaje",
"éployée" => "eplwaje",
"éployées" => "eplwaje",
"éployer" => "eplwaje",
"éployés" => "eplwaje",
"éplucha" => "eplySa",
"épluchage" => "eplySaZ",
"épluchages" => "eplySaZ",
"épluchaient" => "eplySE",
"épluchais" => "eplySE",
"épluchait" => "eplySE",
"épluchant" => "eplyS@",
"épluchât" => "eplySa",
"épluche" => "eplyS",
"épluché" => "eplySe",
"épluche-légumes" => "eplySlegym",
"épluchée" => "eplySe",
"épluchées" => "eplySe",
"épluchent" => "eplyS",
"éplucher" => "eplySe",
"épluchera" => "eplyS°Ra",
"éplucherai" => "eplyS°RE",
"éplucherons" => "eplyS°R§",
"épluches" => "eplyS",
"épluchés" => "eplySe",
"éplucheur" => "eplyS9R",
"éplucheurs" => "eplyS9R",
"éplucheuses" => "eplyS2z",
"épluchez" => "eplySe",
"épluchions" => "eplySj§",
"épluchons" => "eplyS§",
"épluchure" => "eplySyR",
"épluchures" => "eplySyR",
"épointé" => "epw5te",
"épointées" => "epw5te",
"épointés" => "epw5te",
"éponge" => "ep§Z",
"épongé" => "ep§Ze",
"épongea" => "ep§Za",
"épongeage" => "ep§ZaZ",
"épongeaient" => "ep§ZE",
"épongeais" => "ep§ZE",
"épongeait" => "ep§ZE",
"épongeant" => "ep§Z@",
"épongée" => "ep§Ze",
"épongent" => "ep§Z",
"épongeons" => "ep§Z§",
"éponger" => "ep§Ze",
"épongèrent" => "ep§ZER",
"éponges" => "ep§Z",
"épongés" => "ep§Ze",
"épongez" => "ep§Ze",
"épongiez" => "ep§Zje",
"éponyme" => "eponim",
"épopée" => "epope",
"épopées" => "epope",
"époque" => "epOk",
"époques" => "epOk",
"épouillage" => "epujaZ",
"épouillaient" => "epujE",
"épouillait" => "epujE",
"épouille" => "epuj",
"épouillé" => "epuje",
"épouillent" => "epuj",
"épouiller" => "epuje",
"épouillés" => "epuje",
"époumonaient" => "epumonE",
"époumonait" => "epumonE",
"époumonant" => "epumon@",
"époumone" => "epumOn",
"époumoner" => "epumone",
"époumonèrent" => "epumonER",
"époumonés" => "epumone",
"épousa" => "epuza",
"épousable" => "epuzabl",
"épousai" => "epuzE",
"épousaient" => "epuzE",
"épousailles" => "epuzaj",
"épousais" => "epuzE",
"épousait" => "epuzE",
"épousant" => "epuz@",
"épousât" => "epuza",
"épouse" => "epuz",
"épousé" => "epuze",
"épousée" => "epuze",
"épousées" => "epuze",
"épousent" => "epuz",
"épouser" => "epuze",
"épousera" => "epuz°Ra",
"épouserai" => "epuz°RE",
"épouseraient" => "epuz°RE",
"épouserais" => "epuz°RE",
"épouserait" => "epuz°RE",
"épouseras" => "epuz°Ra",
"épousèrent" => "epuzER",
"épouserez" => "epuz°Re",
"épouseriez" => "epuz°Rje",
"épouserons" => "epuz°R§",
"épouseront" => "epuz°R§",
"épouses" => "epuz",
"épousés" => "epuze",
"épouseur" => "epuz9R",
"épouseurs" => "epuz9R",
"épousez" => "epuze",
"épousiez" => "epuzje",
"épousions" => "epuzj§",
"épousons" => "epuz§",
"épousseta" => "epus°ta",
"époussetage" => "epustaZ",
"époussetaient" => "epus°tE",
"époussetais" => "epus°tE",
"époussetait" => "epus°tE",
"époussetant" => "epus°t@",
"épousseté" => "epus°te",
"époussetée" => "epus°te",
"épousseter" => "epuste",
"époussetèrent" => "epus°tER",
"époussetés" => "epus°te",
"époussetez" => "epus°te",
"époussette" => "epusEt",
"époussettent" => "epusEt",
"époustouflait" => "epustuflE",
"époustouflant" => "epustufl@",
"époustouflante" => "epustufl@t",
"époustouflantes" => "epustufl@t",
"époustouflants" => "epustufl@",
"époustoufle" => "epustufl",
"époustouflé" => "epustufle",
"époustouflée" => "epustufle",
"époustoufler" => "epustufle",
"époustouflés" => "epustufle",
"épouvanta" => "epuv@ta",
"épouvantable" => "epuv@tabl",
"épouvantablement" => "epuv@tabl°m@",
"épouvantables" => "epuv@tabl",
"épouvantaient" => "epuv@tE",
"épouvantail" => "epuv@taj",
"épouvantails" => "epuv@taj",
"épouvantait" => "epuv@tE",
"épouvante" => "epuv@t",
"épouvanté" => "epuv@te",
"épouvantée" => "epuv@te",
"épouvantées" => "epuv@te",
"épouvantement" => "epuv@t°m@",
"épouvantements" => "epuv@t°m@",
"épouvantent" => "epuv@t",
"épouvanter" => "epuv@te",
"épouvanteraient" => "epuv@t°RE",
"épouvantèrent" => "epuv@tER",
"épouvantes" => "epuv@t",
"épouvantés" => "epuv@te",
"épouvantez" => "epuv@te",
"époux" => "epu",
"époxy" => "epOksi",
"époxyde" => "epOksid",
"éprenait" => "epR°nE",
"éprenant" => "epR°n@",
"éprend" => "epR@",
"éprendre" => "epR@dR",
"éprends" => "epR@",
"éprenne" => "epREn",
"éprennent" => "epREn",
"épreuve" => "epR9v",
"épreuves" => "epR9v",
"épris" => "epRi",
"éprise" => "epRiz",
"éprises" => "epRiz",
"éprit" => "epRi",
"éprouva" => "epRuva",
"éprouvai" => "epRuvE",
"éprouvaient" => "epRuvE",
"éprouvais" => "epRuvE",
"éprouvait" => "epRuvE",
"éprouvâmes" => "epRuvam",
"éprouvant" => "epRuv@",
"éprouvante" => "epRuv@t",
"éprouvantes" => "epRuv@t",
"éprouvants" => "epRuv@",
"éprouvât" => "epRuva",
"éprouve" => "epRuv",
"éprouvé" => "epRuve",
"éprouvée" => "epRuve",
"éprouvées" => "epRuve",
"éprouvent" => "epRuv",
"éprouver" => "epRuve",
"éprouvera" => "epRuv°Ra",
"éprouverai" => "epRuv°RE",
"éprouveraient" => "epRuv°RE",
"éprouverais" => "epRuv°RE",
"éprouverait" => "epRuv°RE",
"éprouveras" => "epRuv°Ra",
"éprouvèrent" => "epRuvER",
"éprouverez" => "epRuv°Re",
"éprouveront" => "epRuv°R§",
"éprouves" => "epRuv",
"éprouvés" => "epRuve",
"éprouvette" => "epRuvEt",
"éprouvettes" => "epRuvEt",
"éprouvez" => "epRuve",
"éprouviez" => "epRuvje",
"éprouvions" => "epRuvj§",
"éprouvons" => "epRuv§",
"epsilon" => "Epsil§",
"épuçât" => "epysa",
"épucer" => "epyse",
"épuisa" => "ep8iza",
"épuisai" => "ep8izE",
"épuisaient" => "ep8izE",
"épuisais" => "ep8izE",
"épuisait" => "ep8izE",
"épuisant" => "ep8iz@",
"épuisante" => "ep8iz@t",
"épuisantes" => "ep8iz@t",
"épuisants" => "ep8iz@",
"épuisât" => "ep8iza",
"épuise" => "ep8iz",
"épuisé" => "ep8ize",
"épuisée" => "ep8ize",
"épuisées" => "ep8ize",
"épuisement" => "ep8iz°m@",
"épuisements" => "ep8iz°m@",
"épuisent" => "ep8iz",
"épuiser" => "ep8ize",
"épuisera" => "ep8iz°Ra",
"épuiseraient" => "ep8iz°RE",
"épuiserait" => "ep8iz°RE",
"épuiseras" => "ep8iz°Ra",
"épuisèrent" => "ep8izER",
"épuiserons" => "ep8iz°R§",
"épuiseront" => "ep8iz°R§",
"épuises" => "ep8iz",
"épuisés" => "ep8ize",
"épuisette" => "ep8izEt",
"épuisettes" => "ep8izEt",
"épuisez" => "ep8ize",
"épuisiez" => "ep8izje",
"épuisons" => "ep8iz§",
"épulie" => "epyli",
"épurait" => "epyRE",
"épurant" => "epyR@",
"épurateur" => "epyRat9R",
"épuration" => "epyRasj§",
"épurations" => "epyRasj§",
"épurative" => "epyRativ",
"épure" => "epyR",
"épuré" => "epyRe",
"épurée" => "epyRe",
"épurées" => "epyRe",
"épurer" => "epyRe",
"épures" => "epyR",
"épurés" => "epyRe",
"équanimité" => "ekwanimite",
"équarisseur" => "ekaRis9R",
"équarisseurs" => "ekaRis9R",
"équarri" => "ekaRi",
"équarrie" => "ekaRi",
"équarries" => "ekaRi",
"équarrir" => "ekaRiR",
"équarris" => "ekaRi",
"équarrissage" => "ekaRisaZ",
"équarrissait" => "ekaRisE",
"équarrisseur" => "ekaRis9R",
"équarrisseurs" => "ekaRis9R",
"équateur" => "ekwat9R",
"équation" => "ekwasj§",
"équations" => "ekwasj§",
"équatorial" => "ekwatoRjal",
"équatoriale" => "ekwatoRjal",
"équatoriaux" => "ekwatoRjo",
"équatorien" => "ekwatoRj5",
"équatoriennes" => "ekwatoRjEn",
"équerrage" => "ekERaZ",
"équerre" => "ekER",
"équerres" => "ekER",
"équestre" => "ekEstR",
"équestres" => "ekEstR",
"équeutées" => "ek2te",
"équeuter" => "ek2te",
"équidés" => "ekide",
"équidistance" => "ek8idist@s",
"équidistant" => "ek8idist@",
"équidistante" => "ek8idist@t",
"équidistantes" => "ek8idist@t",
"équidistants" => "ek8idist@",
"équilatéral" => "ek8ilateRal",
"équilatéraux" => "ek8ilateRo",
"équilibra" => "ekilibRa",
"équilibrage" => "ekilibRaZ",
"équilibraient" => "ekilibRE",
"équilibrais" => "ekilibRE",
"équilibrait" => "ekilibRE",
"équilibrant" => "ekilibR@",
"équilibrante" => "ekilibR@t",
"équilibre" => "ekilibR",
"équilibré" => "ekilibRe",
"équilibrée" => "ekilibRe",
"équilibrées" => "ekilibRe",
"équilibrent" => "ekilibR",
"équilibrer" => "ekilibRe",
"équilibrèrent" => "ekilibRER",
"équilibres" => "ekilibR",
"équilibrés" => "ekilibRe",
"équilibreur" => "ekilibR9R",
"équilibrisme" => "ekilibRizm",
"équilibriste" => "ekilibRist",
"équilibristes" => "ekilibRist",
"équin" => "ekin",
"équine" => "ekin",
"équinoxe" => "ekinOks",
"équinoxes" => "ekinOks",
"équipa" => "ekipa",
"équipage" => "ekipaZ",
"équipages" => "ekipaZ",
"équipai" => "ekipE",
"équipait" => "ekipE",
"équipant" => "ekip@",
"équipe" => "ekip",
"équipé" => "ekipe",
"équipée" => "ekipe",
"équipées" => "ekipe",
"équipement" => "ekip°m@",
"équipements" => "ekip°m@",
"équipent" => "ekip",
"équiper" => "ekipe",
"équipera" => "ekip°Ra",
"équiperai" => "ekip°RE",
"équiperais" => "ekip°RE",
"équipèrent" => "ekipER",
"équipes" => "ekip",
"équipés" => "ekipe",
"équipez" => "ekipe",
"équipier" => "ekipje",
"équipière" => "ekipjER",
"équipiers" => "ekipje",
"équipons" => "ekip§",
"équitable" => "ekitabl",
"équitablement" => "ekitabl°m@",
"équitables" => "ekitabl",
"équitation" => "ekitasj§",
"équité" => "ekite",
"équivalaient" => "ekivalE",
"équivalait" => "ekivalE",
"équivalant" => "ekival@",
"équivalence" => "ekival@s",
"équivalences" => "ekival@s",
"équivalent" => "ekival@",
"équivalente" => "ekival@t",
"équivalentes" => "ekival@t",
"équivalents" => "ekival@",
"équivaloir" => "ekivalwaR",
"équivalu" => "ekivaly",
"équivalût" => "ekivaly",
"équivaudra" => "ekivodRa",
"équivaudrait" => "ekivodRE",
"équivaut" => "ekivo",
"équivoque" => "ekivOk",
"équivoquer" => "ekivOke",
"équivoques" => "ekivOk",
"érable" => "eRabl°",
"érables" => "eRabl",
"érablières" => "eRablijER",
"éradicateur" => "eRadikat9R",
"éradication" => "eRadikasj§",
"éradiqué" => "eRadike",
"éradiquée" => "eRadike",
"éradiquer" => "eRadike",
"éradiquerai" => "eRadik°RE",
"éradiqueront" => "eRadik°R§",
"éradiquons" => "eRadik§",
"érafla" => "eRafla",
"éraflait" => "eRaflE",
"érafle" => "eRafl",
"éraflé" => "eRafle",
"éraflée" => "eRafle",
"éraflées" => "eRafle",
"érafler" => "eRafle",
"éraflés" => "eRafle",
"éraflez" => "eRafle",
"éraflure" => "eRaflyR",
"éraflures" => "eRaflyR",
"érailla" => "eRaja",
"éraillaient" => "eRajE",
"éraillait" => "eRajE",
"éraillant" => "eRaj@",
"éraille" => "eRaj",
"éraillé" => "eRaje",
"éraillée" => "eRaje",
"éraillées" => "eRaje",
"éraillent" => "eRaj",
"érailler" => "eRaje",
"éraillés" => "eRaje",
"éraillures" => "eRajyR",
"ère" => "ER",
"érectile" => "eREktil",
"érectiles" => "eREktil",
"érection" => "eREksj§",
"érections" => "eREksj§",
"éreintait" => "eR5tE",
"éreintant" => "eR5t@",
"éreintante" => "eR5t@t",
"éreintants" => "eR5t@",
"éreinte" => "eR5t",
"éreinté" => "eR5te",
"éreintée" => "eR5te",
"éreintées" => "eR5te",
"éreintement" => "eR5t°m@",
"éreintent" => "eR5t",
"éreinter" => "eR5te",
"éreintés" => "eR5te",
"éreinteur" => "eR5t9R",
"ères" => "ER",
"erg" => "ERg",
"ergastule" => "ERgastyl",
"ergastules" => "ERgastyl",
"ergo" => "ERgo",
"ergol" => "ERgOl",
"ergonomie" => "ERgonomi",
"ergonomique" => "ERgonomik",
"ergot" => "ERgo",
"ergotage" => "ERgotaZ",
"ergotait" => "ERgotE",
"ergotamine" => "ERgotamin",
"ergote" => "ERgOt",
"ergoté" => "ERgote",
"ergotent" => "ERgOt",
"ergoter" => "ERgote",
"ergoteur" => "ERgot9R",
"ergoteurs" => "ERgot9R",
"ergoteuse" => "ERgot2z",
"ergothérapeute" => "ERgoteRap2t",
"ergothérapie" => "ERgoteRapi",
"ergotons" => "ERgot§",
"ergots" => "ERgo",
"ergs" => "ERg",
"érige" => "eRiZ",
"érigé" => "eRiZe",
"érigea" => "eRiZa",
"érigeaient" => "eRiZE",
"érigeait" => "eRiZE",
"érigeant" => "eRiZ@",
"érigeât" => "eRiZa",
"érigée" => "eRiZe",
"érigées" => "eRiZe",
"érigent" => "eRiZ",
"ériger" => "eRiZe",
"érigés" => "eRiZe",
"ermitage" => "ERmitaZ",
"ermitages" => "ERmitaZ",
"ermite" => "ERmit",
"ermites" => "ERmit",
"érode" => "eROd",
"érodé" => "eRode",
"érodée" => "eRode",
"érodées" => "eRode",
"érodent" => "eROd",
"éroder" => "eRode",
"érodés" => "eRode",
"érogène" => "eRoZEn",
"érogènes" => "eRoZEn",
"éros" => "eRos",
"érosion" => "eRozj§",
"érosions" => "eRozj§",
"érotique" => "eRotik",
"érotiquement" => "eRotik°m@",
"érotiques" => "eRotik",
"érotise" => "eRotiz",
"érotisé" => "eRotize",
"érotisée" => "eRotize",
"érotiser" => "eROtize",
"érotisme" => "eRotizm",
"érotomane" => "eRotoman",
"érotomanie" => "eRotomani",
"erpétologiste" => "ERpetOlOZist",
"erra" => "ERa",
"errai" => "ERE",
"erraient" => "ERE",
"errais" => "ERE",
"errait" => "ERE",
"errâmes" => "ERam",
"errance" => "ER@s",
"errances" => "ER@s",
"errant" => "ER@",
"errante" => "ER@t",
"errantes" => "ER@t",
"errants" => "ER@",
"errata" => "ERata",
"erratique" => "ERatik",
"erratiques" => "ERatik",
"erratum" => "eRatOm",
"erre" => "ER",
"erré" => "ERe",
"errements" => "ER°m@",
"errent" => "ER",
"errer" => "ERe",
"errera" => "ER°Ra",
"errerai" => "ER°RE",
"erreraient" => "ER°RE",
"errerait" => "ER°RE",
"erreras" => "ER°Ra",
"errèrent" => "ERER",
"errerons" => "ER°R§",
"erreront" => "ER°R§",
"erres" => "ER",
"errés" => "ERe",
"erreur" => "ER9R",
"erreurs" => "ER9R",
"errez" => "ERe",
"erriez" => "ERje",
"errions" => "ERj§",
"erroné" => "ERone",
"erronée" => "ERone",
"erronées" => "ERone",
"erronés" => "ERone",
"errons" => "ER§",
"ers" => "ER",
"ersatz" => "ERzats",
"éructa" => "eRykta",
"éructait" => "eRyktE",
"éructant" => "eRykt@",
"éructation" => "eRyktasj§",
"éructations" => "eRyktasj§",
"éructe" => "eRykt",
"éructé" => "eRykte",
"éructées" => "eRykte",
"éructer" => "eRykte",
"éructes" => "eRykt",
"érudit" => "eRydi",
"érudite" => "eRydit",
"érudites" => "eRydit",
"érudition" => "eRydisj§",
"érudits" => "eRydi",
"éruption" => "eRypsj§",
"éruptions" => "eRypsj§",
"éruptive" => "eRyptiv",
"éruptives" => "eRyptiv",
"érythémateux" => "eRitemat2",
"érythème" => "eRitEm",
"érythèmes" => "eRitEm",
"érythréenne" => "eRitReEn",
"érythromycine" => "eRitRomisin",
"érythrophobie" => "eRitRofObi",
"es" => "E",
"ès" => "Es",
"esbaudir" => "EzbodiR",
"esbignais" => "EsbiNE",
"esbignait" => "EsbiNE",
"esbigne" => "EsbiN",
"esbigné" => "EsbiNe",
"esbignent" => "EsbiN",
"esbigner" => "EsbiNe",
"esbroufe" => "EsbRuf",
"esbroufée" => "EsbRufe",
"esbroufer" => "EsbRufe",
"esbroufeur" => "EzbRuf9R",
"esbroufeurs" => "EzbRuf9R",
"escabeau" => "Eskabo",
"escabeaux" => "Eskabo",
"escabèches" => "EskabES",
"escadre" => "EskadR",
"escadres" => "EskadR",
"escadrille" => "EskadRij",
"escadrilles" => "EskadRij",
"escadrin" => "EskadR5",
"escadron" => "EskadR§",
"escadrons" => "EskadR§",
"escagasse" => "Eskagas",
"escagasser" => "Eskagase",
"escalada" => "Eskalada",
"escaladaient" => "EskaladE",
"escaladais" => "EskaladE",
"escaladait" => "EskaladE",
"escaladâmes" => "Eskaladam",
"escaladant" => "Eskalad@",
"escalade" => "Eskalad",
"escaladé" => "Eskalade",
"escaladée" => "Eskalade",
"escaladées" => "Eskalade",
"escaladent" => "Eskalad",
"escalader" => "Eskalade",
"escaladera" => "Eskalad°Ra",
"escaladerais" => "Eskalad°RE",
"escaladerait" => "Eskalad°RE",
"escaladèrent" => "EskaladER",
"escalades" => "Eskalad",
"escaladés" => "Eskalade",
"escaladeur" => "Eskalad9R",
"escaladeuse" => "Eskalad2z",
"escaladeuses" => "Eskalad2z",
"escaladez" => "Eskalade",
"escaladions" => "Eskaladj§",
"escaladons" => "Eskalad§",
"escalais" => "EskalE",
"escalator" => "EskalatOR",
"escalators" => "EskalatOR",
"escale" => "Eskal",
"escalera" => "Eskal°Ra",
"escales" => "Eskal",
"escalier" => "Eskalje",
"escaliers" => "Eskalje",
"escalope" => "EskalOp",
"escalopes" => "EskalOp",
"escamota" => "Eskamota",
"escamotable" => "Eskamotabl",
"escamotables" => "Eskamotabl",
"escamotage" => "EskamotaZ",
"escamotages" => "EskamotaZ",
"escamotaient" => "EskamotE",
"escamotait" => "EskamotE",
"escamotant" => "Eskamot@",
"escamote" => "EskamOt",
"escamoté" => "Eskamote",
"escamotée" => "Eskamote",
"escamotées" => "Eskamote",
"escamoter" => "Eskamote",
"escamoterai" => "EskamOt°RE",
"escamotés" => "Eskamote",
"escamoteur" => "Eskamot9R",
"escampette" => "Esk@pEt",
"escapade" => "Eskapad",
"escapades" => "Eskapad",
"escape" => "Eskap",
"escarbille" => "EskaRbij",
"escarbilles" => "EskaRbij",
"escarboucle" => "EskaRbukl",
"escarboucles" => "EskaRbukl",
"escarcelle" => "EskaRsEl",
"escargot" => "EskaRgo",
"escargots" => "EskaRgo",
"escarmouchaient" => "EskaRmuSE",
"escarmouche" => "EskaRmuS",
"escarmouchent" => "EskaRmuS",
"escarmouches" => "EskaRmuS",
"escarpé" => "EskaRpe",
"escarpée" => "EskaRpe",
"escarpées" => "EskaRpe",
"escarpement" => "EskaRp°m@",
"escarpements" => "EskaRp°m@",
"escarpes" => "EskaRp",
"escarpés" => "EskaRpe",
"escarpin" => "EskaRp5",
"escarpins" => "EskaRp5",
"escarpolette" => "EskaRpolEt",
"escarpolettes" => "EskaRpolEt",
"escarre" => "EskaR",
"escarres" => "EskaR",
"eschatologie" => "EskatoloZi",
"esche" => "ES",
"escher" => "ESe",
"escient" => "esj@",
"esclaffa" => "Esklafa",
"esclaffai" => "EsklafE",
"esclaffaient" => "EsklafE",
"esclaffait" => "EsklafE",
"esclaffant" => "Esklaf@",
"esclaffe" => "Esklaf",
"esclaffé" => "Esklafe",
"esclaffée" => "Esklafe",
"esclaffement" => "Esklafm@",
"esclaffements" => "Esklafm@",
"esclaffent" => "Esklaf",
"esclaffer" => "Esklafe",
"esclafferaient" => "Esklaf°RE",
"esclaffèrent" => "EsklafER",
"esclaffés" => "Esklafe",
"esclandre" => "Eskl@dR",
"esclandres" => "Eskl@dR",
"esclavage" => "EsklavaZ",
"esclavagé" => "EsklavaZe",
"esclavagea" => "EsklavaZa",
"esclavager" => "EsklavaZe",
"esclavagisme" => "EsklavaZizm",
"esclavagiste" => "EsklavaZist",
"esclavagistes" => "EsklavaZist",
"esclave" => "Esklav",
"esclaves" => "Esklav",
"esclavons" => "Esklav§",
"escogriffe" => "EskogRif",
"escogriffes" => "EskogRif",
"escomptai" => "Esk§tE",
"escomptaient" => "Esk§tE",
"escomptais" => "Esk§tE",
"escomptait" => "Esk§tE",
"escomptant" => "Esk§t@",
"escompte" => "Esk§t",
"escompté" => "Esk§te",
"escomptée" => "Esk§te",
"escomptées" => "Esk§te",
"escomptent" => "Esk§t",
"escompter" => "Esk§te",
"escomptes" => "Esk§t",
"escomptés" => "Esk§te",
"escomptez" => "Esk§te",
"escomptions" => "Esk§tj§",
"escopette" => "EskopEt",
"escorta" => "EskORta",
"escortaient" => "EskORtE",
"escortais" => "EskORtE",
"escortait" => "EskORtE",
"escortant" => "EskORt@",
"escorte" => "EskORt",
"escorté" => "EskORte",
"escortée" => "EskORte",
"escortées" => "EskORte",
"escortent" => "EskORt",
"escorter" => "EskORte",
"escortera" => "EskORt°Ra",
"escorterai" => "EskORt°RE",
"escorteraient" => "EskORt°RE",
"escortèrent" => "EskORtER",
"escorterez" => "EskORt°Re",
"escorteriez" => "EskORt°Rje",
"escorterons" => "EskORt°R§",
"escorteront" => "EskORt°R§",
"escortes" => "EskORt",
"escortés" => "EskORte",
"escorteur" => "EskORt9R",
"escorteurs" => "EskORt9R",
"escortez" => "EskORte",
"escortiez" => "EskORtje",
"escortons" => "EskORt§",
"escot" => "Esko",
"escouade" => "Eskwad",
"escouades" => "Eskwad",
"escrimai" => "EskRimE",
"escrimaient" => "EskRimE",
"escrimais" => "EskRimE",
"escrimait" => "EskRimE",
"escrimant" => "EskRim@",
"escrime" => "EskRim",
"escriment" => "EskRim",
"escrimer" => "EskRime",
"escrimera" => "EskRim°Ra",
"escrimeraient" => "EskRim°RE",
"escrimes" => "EskRim",
"escrimeur" => "EskRim9R",
"escrimeurs" => "EskRim9R",
"escrimeuses" => "EskRim2z",
"escroc" => "EskRo",
"escrocs" => "EskRo",
"escroquant" => "EskRok@",
"escroque" => "EskROk",
"escroqué" => "EskRoke",
"escroquées" => "EskRoke",
"escroquent" => "EskROk",
"escroquer" => "Esk°Roke",
"escroquera" => "Esk°ROk°Ra",
"escroquerie" => "EskROk°Ri",
"escroqueries" => "EskROk°Ri",
"escroques" => "EskROk",
"escroqués" => "EskRoke",
"escroqueuse" => "EskRok2z",
"escroquez" => "EskRoke",
"escudo" => "Eskydo",
"escudos" => "Eskydo",
"esgourdai" => "EsguRdE",
"esgourdant" => "EsguRd@",
"esgourde" => "EsguRd",
"esgourdé" => "EsguRde",
"esgourdée" => "EsguRde",
"esgourder" => "EsguRde",
"esgourdes" => "EsguRd",
"eskimo" => "Eskimo",
"eskimos" => "Eskimo",
"ésotérique" => "ezoteRik",
"ésotériques" => "ezoteRik",
"ésotérisme" => "ezoteRizm",
"ésotéristes" => "ezoteRist",
"espaça" => "Espasa",
"espaçaient" => "EspasE",
"espaçait" => "EspasE",
"espaçant" => "Espas@",
"espace" => "Espas",
"espacé" => "Espase",
"espace-temps" => "Espast@",
"espacée" => "Espase",
"espacées" => "Espase",
"espacement" => "Espas°m@",
"espacements" => "Espas°m@",
"espacent" => "Espas",
"espacer" => "Espase",
"espacerait" => "Espas°RE",
"espacèrent" => "EspasER",
"espaceront" => "Espas°R§",
"espaces" => "Espas",
"espacés" => "Espase",
"espacez" => "Espase",
"espacions" => "Espasj§",
"espada" => "Espada",
"espadas" => "Espada",
"espadon" => "Espad§",
"espadons" => "Espad§",
"espadrille" => "EspadRij",
"espadrilles" => "EspadRij",
"espagnol" => "EspaNOl",
"espagnole" => "EspaNOl",
"espagnoles" => "EspaNOl",
"espagnolette" => "EspaNolEt",
"espagnols" => "EspaNOl",
"espalier" => "Espalje",
"espaliers" => "Espalje",
"espar" => "EspaR",
"espars" => "EspaR",
"espèce" => "EspEs",
"espèces" => "EspEs",
"espéra" => "EspeRa",
"espérai" => "EspeRE",
"espéraient" => "EspeRE",
"espérais" => "EspeRE",
"espérait" => "EspeRE",
"espérâmes" => "EspeRam",
"espérance" => "EspeR@s",
"espérances" => "EspeR@s",
"espérant" => "EspeR@",
"espérantiste" => "EspeR@tist",
"esperanto" => "EspeR@to",
"espéranto" => "EspeR@to",
"espérât" => "EspeRa",
"espère" => "EspER",
"espéré" => "EspeRe",
"espérée" => "EspeRe",
"espérées" => "EspeRe",
"espèrent" => "EspER",
"espérer" => "EspeRe",
"espérerai" => "EspeR°RE",
"espérerais" => "EspeR°RE",
"espérerait" => "EspeR°RE",
"espérèrent" => "EspeRER",
"espères" => "EspER",
"espérés" => "EspeRe",
"espérez" => "EspeRe",
"espériez" => "EspeRje",
"espérions" => "EspeRj§",
"espérons" => "EspeR§",
"espiègle" => "EspjEgl",
"espièglement" => "EspjEgl2m@",
"espièglerie" => "EspjEgl°Ri",
"espiègleries" => "EspjEgl°Ri",
"espiègles" => "EspjEgl",
"espingo" => "Esp5go",
"espingole" => "Esp5gOl",
"espingoles" => "Esp5gOl",
"espingos" => "Esp5go",
"espingouin" => "Esp5gw5",
"espingouins" => "Esp5gw5",
"espion" => "Espj§",
"espionite" => "EspjOnit",
"espionnage" => "EspjonaZ",
"espionnaient" => "EspjonE",
"espionnais" => "EspijonE",
"espionnait" => "EspijonE",
"espionnant" => "Espijon@",
"espionnât" => "Espijona",
"espionne" => "EspjOn",
"espionné" => "Espjone",
"espionnée" => "Espjone",
"espionnent" => "EspijOn",
"espionner" => "Espjone",
"espionnera" => "EspjOn°Ra",
"espionnerai" => "EspjOn°RE",
"espionnerions" => "Espjon°Rj§",
"espionnes" => "EspijOn",
"espionnés" => "Espjone",
"espionnez" => "Espjone",
"espionniez" => "Espjonje",
"espionnite" => "Espjonit",
"espionnons" => "Espjon§",
"espions" => "Espj§",
"esplanade" => "Esplanad",
"esplanades" => "Esplanad",
"espoir" => "EspwaR",
"espoirs" => "EspwaR",
"esprit" => "EspRi",
"esprit-de-sel" => "EspRid°sEl",
"esprit-de-vin" => "EspRid°v5",
"esprits" => "EspRi",
"esquif" => "Eskif",
"esquifs" => "Eskif",
"esquille" => "Eskij",
"esquilles" => "Eskij",
"esquimau" => "Eskimo",
"esquimaude" => "Eskimod",
"esquimaudes" => "Eskimod",
"esquimaux" => "Eskimo",
"esquintait" => "Esk5tE",
"esquinte" => "Esk5t",
"esquinté" => "Esk5te",
"esquintée" => "Esk5te",
"esquintées" => "Esk5te",
"esquintement" => "Esk5t°m@",
"esquintent" => "Esk5t",
"esquinter" => "Esk5te",
"esquinterais" => "Esk5t°RE",
"esquintes" => "Esk5t",
"esquintés" => "Esk5te",
"esquintez" => "Esk5te",
"esquire" => "EskiR",
"esquissa" => "Eskisa",
"esquissai" => "EskisE",
"esquissaient" => "EskisE",
"esquissais" => "EskisE",
"esquissait" => "EskisE",
"esquissant" => "Eskis@",
"esquisse" => "Eskis",
"esquissé" => "Eskise",
"esquissée" => "Eskise",
"esquissées" => "Eskise",
"esquissent" => "Eskis",
"esquisser" => "Eskise",
"esquissèrent" => "EskisER",
"esquisses" => "Eskis",
"esquissés" => "Eskise",
"esquiva" => "Eskiva",
"esquivai" => "EskivE",
"esquivaient" => "EskivE",
"esquivait" => "EskivE",
"esquivant" => "Eskiv@",
"esquive" => "Eskiv",
"esquivé" => "Eskive",
"esquivée" => "Eskive",
"esquivent" => "Eskiv",
"esquiver" => "Eskive",
"esquivera" => "Eskiv°Ra",
"esquivèrent" => "EskivER",
"esquiveront" => "Eskiv°R§",
"esquives" => "Eskiv",
"essai" => "esE",
"essaie" => "EsE",
"essaient" => "EsE",
"essaiera" => "EsERa",
"essaierai" => "EsERE",
"essaieraient" => "EsERE",
"essaierais" => "EsERE",
"essaierait" => "EsERE",
"essaieras" => "EsERa",
"essaierez" => "EsERe",
"essaieriez" => "esERje",
"essaierions" => "EsERj§",
"essaierons" => "EsER§",
"essaieront" => "EsER§",
"essaies" => "EsE",
"essaim" => "es5",
"essaimaient" => "EsEmE",
"essaimait" => "EsEmE",
"essaimé" => "EsEme",
"essaimées" => "EsEme",
"essaiment" => "EsEm",
"essaimés" => "EsEme",
"essaims" => "Es5",
"essais" => "esE",
"essangent" => "Es@Z",
"essartage" => "EsaRtaZ",
"essarte" => "EsaRt",
"essartée" => "EsaRte",
"essarts" => "EsaR",
"essaya" => "eseja",
"essayage" => "esEjaZ",
"essayages" => "esEjaZ",
"essayai" => "esejE",
"essayaient" => "esejE",
"essayais" => "esejE",
"essayait" => "esejE",
"essayâmes" => "esejam",
"essayant" => "esej@",
"essayât" => "eseja",
"essaye" => "esEj",
"essayé" => "esEje",
"essayée" => "esEje",
"essayées" => "esEje",
"essayent" => "esej",
"essayer" => "eseje",
"essayera" => "esej°Ra",
"essayerai" => "esej°RE",
"essayeraient" => "esej°RE",
"essayerais" => "esej°RE",
"essayerait" => "esej°RE",
"essayeras" => "esEj°Ra",
"essayèrent" => "esejER",
"essayerez" => "esej°Re",
"essayeriez" => "esEj°Rje",
"essayerons" => "esej°R§",
"essayeront" => "esej°R§",
"essayes" => "esEj",
"essayés" => "esEje",
"essayeur" => "esEj9R",
"essayeuses" => "esej2z",
"essayez" => "eseje",
"essayiez" => "esejje",
"essayions" => "esejj§",
"essayiste" => "esejist",
"essayistes" => "esejist",
"essayons" => "esej§",
"esse" => "Es",
"essence" => "es@s",
"essences" => "es@s",
"essential" => "Es@tjal",
"essentialisme" => "Es@sjalizm",
"essentiel" => "es@sjEl",
"essentielle" => "es@sjEl",
"essentiellement" => "es@sjEl°m@",
"essentielles" => "es@sjEl",
"essentiels" => "es@sjEl",
"esseulé" => "es9le",
"esseulée" => "es9le",
"esseulées" => "Es9le",
"esseulement" => "s9l°m@",
"esseulés" => "Es9le",
"essieu" => "Esj2",
"essieux" => "Esj2",
"essor" => "esOR",
"essora" => "EsoRa",
"essorage" => "esoRaZ",
"essoraient" => "EsoRE",
"essorait" => "EsoRE",
"essorant" => "EsoR@",
"essore" => "EsOR",
"essoré" => "EsoRe",
"essorée" => "EsoRe",
"essorent" => "EsOR",
"essorer" => "esoRe",
"essorerait" => "EsOR°RE",
"essorés" => "EsoRe",
"essoreuse" => "esoR2z",
"essorillé" => "EsoRije",
"essouffla" => "Esufla",
"essoufflaient" => "EsuflE",
"essoufflais" => "EsuflE",
"essoufflait" => "EsuflE",
"essoufflant" => "Esufl@",
"essouffle" => "Esufl",
"essoufflé" => "esufle",
"essoufflée" => "esufle",
"essoufflées" => "esufle",
"essoufflement" => "esufl°m@",
"essoufflements" => "esufl°m@",
"essoufflent" => "Esufl",
"essouffler" => "esufle",
"essoufflèrent" => "EsuflER",
"essouffleront" => "Esufl°R§",
"essouffles" => "Esufl",
"essoufflés" => "esufle",
"essoufflez" => "Esufle",
"essuie" => "Es8i",
"essuie-glace" => "Es8iglas",
"essuie-glaces" => "Es8iglas",
"essuie-mains" => "Es8im5",
"essuie-tout" => "Es8itu",
"essuient" => "Es8i",
"essuiera" => "Es8iRa",
"essuierais" => "es8iRE",
"essuieras" => "Es8iRa",
"essuierez" => "es8iRe",
"essuierions" => "Es8iRj§",
"essuies" => "Es8i",
"essuya" => "Es8ija",
"essuyage" => "es8ijaZ",
"essuyages" => "Es8ijaZ",
"essuyai" => "Es8ijE",
"essuyaient" => "Es8ijE",
"essuyais" => "Es8ijE",
"essuyait" => "Es8ijE",
"essuyant" => "Es8ij@",
"essuyé" => "es8ije",
"essuyée" => "es8ije",
"essuyées" => "es8ije",
"essuyer" => "es8ije",
"essuyèrent" => "Es8ijER",
"essuyés" => "es8ije",
"essuyeur" => "es8ij9R",
"essuyez" => "Es8ije",
"essuyions" => "Es8ij§",
"essuyons" => "Es8ij§",
"est" => "e",
"est-africain" => "EstafRik5",
"est-allemand" => "Estal°m@",
"est-allemande" => "Estal°m@d",
"est-allemands" => "Estal°m@",
"est-ce" => "Es°",
"est-ce qu" => "Es°k°",
"est-ce que" => "Es°k°",
"est-ce-que" => "Es°k°",
"est-ouest" => "EstwEst",
"establishment" => "EstabliSmEnt",
"estacade" => "Estakad",
"estacades" => "Estakad",
"estafette" => "EstafEt",
"estafettes" => "EstafEt",
"estafier" => "Estafje",
"estafiers" => "Estafje",
"estafilade" => "Estafilad",
"estafilades" => "Estafilad",
"estagnon" => "EstaN§",
"estaminet" => "EstaminE",
"estaminets" => "EstaminE",
"estampage" => "Est@paZ",
"estampe" => "Est@p",
"estampé" => "Est@pe",
"estampée" => "Est@pe",
"estamper" => "Est@pe",
"estampes" => "Est@p",
"estampilla" => "Est@pija",
"estampillaient" => "Est@pijE",
"estampille" => "Est@pij",
"estampillé" => "Est@pije",
"estampillées" => "Est@pije",
"estampiller" => "Est@pije",
"estampillés" => "Est@pije",
"estancia" => "Est@sja",
"estancias" => "Est@sja",
"este" => "Est",
"ester" => "estER",
"estes" => "Est",
"esthésiomètre" => "EstezjomEtR",
"esthète" => "EstEt",
"esthètes" => "EstEt",
"esthéticien" => "Estetisj5",
"esthéticienne" => "EstetisjEn",
"esthéticiennes" => "EstetisjEn",
"esthétique" => "Estetik",
"esthétiquement" => "Estetik°m@",
"esthétiques" => "Estetik",
"esthétisait" => "EstetizE",
"esthétisme" => "Estetizm",
"estima" => "Estima",
"estimable" => "Estimabl",
"estimables" => "Estimabl",
"estimai" => "EstimE",
"estimaient" => "EstimE",
"estimais" => "EstimE",
"estimait" => "EstimE",
"estimant" => "Estim@",
"estimât" => "Estima",
"estimation" => "Estimasj§",
"estimations" => "Estimasj§",
"estime" => "Estim",
"estimé" => "Estime",
"estimée" => "Estime",
"estimées" => "Estime",
"estiment" => "Estim",
"estimer" => "Estime",
"estimera" => "Estim°Ra",
"estimerai" => "Estim°RE",
"estimerais" => "Estim°RE",
"estimerait" => "Estim°RE",
"estimeras" => "Estim°Ra",
"estimèrent" => "EstimER",
"estimerez" => "Estim°Re",
"estimes" => "Estim",
"estimés" => "Estime",
"estimez" => "Estime",
"estimiez" => "Estimje",
"estimions" => "Estimj§",
"estimons" => "Estim§",
"estival" => "Estival",
"estivale" => "Estival",
"estivales" => "Estival",
"estivant" => "Estiv@",
"estivante" => "Estiv@t",
"estivantes" => "Estiv@t",
"estivants" => "Estiv@",
"estivaux" => "Estivo",
"estoc" => "EstOk",
"estocade" => "Estokad",
"estocades" => "Estokad",
"estocs" => "EstOk",
"estom" => "EstOm",
"estomac" => "Estoma",
"estomacs" => "Estoma",
"estomaquait" => "EstomakE",
"estomaquant" => "Estomak@",
"estomaque" => "Estomak",
"estomaqué" => "Estomake",
"estomaquée" => "Estomake",
"estomaquer" => "Estomake",
"estomaqués" => "Estomake",
"estompa" => "Est§pa",
"estompaient" => "Est§pE",
"estompait" => "Est§pE",
"estompant" => "Est§p@",
"estompât" => "Est§pa",
"estompe" => "Est§p",
"estompé" => "Est§pe",
"estompée" => "Est§pe",
"estompées" => "Est§pe",
"estompent" => "Est§p",
"estomper" => "Est§pe",
"estompera" => "Est§p°Ra",
"estompèrent" => "Est§pER",
"estomperont" => "Est§p°R§",
"estompes" => "Est§p",
"estompés" => "Est§pe",
"estonien" => "Estonj5",
"estonienne" => "EstOnjEn",
"estoniens" => "Estonj5",
"estoqua" => "Estoka",
"estoque" => "EstOk",
"estoqué" => "Estoke",
"estoquer" => "Estoke",
"estouffade" => "Estufad",
"estourbi" => "EstuRbi",
"estourbie" => "EstuRbi",
"estourbies" => "EstuRbi",
"estourbir" => "EstuRbiR",
"estourbirait" => "EstuRbiRE",
"estourbis" => "EstuRbi",
"estourbissais" => "EstuRbisE",
"estourbissant" => "EstuRbis@",
"estourbisse" => "EstuRbis",
"estourbit" => "EstuRbi",
"estrade" => "EstRad",
"estrades" => "EstRad",
"estragon" => "EstRag§",
"estrangers" => "EstR@Ze",
"estrapade" => "EstRapad",
"estrapades" => "EstRapad",
"estrapassée" => "EstRapase",
"estrogène" => "EstROZEn",
"estropiait" => "EstRopjE",
"estropie" => "EstRopi",
"estropié" => "EstRopje",
"estropiée" => "EstRopje",
"estropier" => "EstRopje",
"estropierai" => "EstRopiRE",
"estropierait" => "EstRopiRE",
"estropiés" => "EstRopje",
"estropiez" => "EstRopje",
"estuaire" => "Est8ER",
"estuaires" => "Est8ER",
"estudiantin" => "Estydj@t5",
"estudiantine" => "Estydj@tin",
"estudiantines" => "Estydj@tin",
"estudiantins" => "Estydj@t5",
"esturgeon" => "EstyRZ§",
"esturgeons" => "EstyRZ§",
"et" => "e",
"et caetera" => "etseteRa",
"et cetera" => "etseteRa",
"et seq" => "Etsek",
"étable" => "etabl",
"étables" => "etabl",
"établi" => "etabli",
"établie" => "etabli",
"établies" => "etabli",
"établir" => "etabliR",
"établira" => "etabliRa",
"établirai" => "etabliRE",
"établiraient" => "etabliRE",
"établirais" => "etabliRE",
"établirait" => "etabliRE",
"établirent" => "etabliR",
"établirez" => "etabliRe",
"établirions" => "etabliRj§",
"établirons" => "etabliR§",
"établiront" => "etabliR§",
"établis" => "etabli",
"établissaient" => "etablisE",
"établissais" => "etablisE",
"établissait" => "etablisE",
"établissant" => "etablis@",
"établisse" => "etablis",
"établissement" => "etablis°m@",
"établissements" => "etablis°m@",
"établissent" => "etablis",
"établisses" => "etablis",
"établissez" => "etablise",
"établissions" => "etablisj§",
"établissons" => "etablis§",
"établit" => "etabli",
"établît" => "etabli",
"étage" => "etaZ",
"étagé" => "etaZe",
"étagea" => "etaZa",
"étageaient" => "etaZE",
"étageait" => "etaZE",
"étageant" => "etaZ@",
"étagée" => "etaZe",
"étagées" => "etaZe",
"étagent" => "etaZ",
"étagère" => "etaZER",
"étagères" => "etaZER",
"étages" => "etaZ",
"étagés" => "etaZe",
"étai" => "etE",
"étaie" => "etE",
"étaient" => "etE",
"étain" => "et5",
"étains" => "et5",
"étais" => "etE",
"était" => "etE",
"étal" => "etal",
"étala" => "etala",
"étalage" => "etalaZ",
"étalages" => "etalaZ",
"étalagiste" => "etalaZist",
"étalai" => "etalE",
"étalaient" => "etalE",
"étalais" => "etalE",
"étalait" => "etalE",
"étalant" => "etal@",
"étalât" => "etala",
"étale" => "etal",
"étalé" => "etale",
"étalée" => "etale",
"étalées" => "etale",
"étalement" => "etal°m@",
"étalements" => "etal°m@",
"étalent" => "etal",
"étaler" => "etale",
"étalera" => "etal°Ra",
"étalerai" => "etal°RE",
"étaleraient" => "etal°RE",
"étalerait" => "etal°RE",
"étaleras" => "etal°Ra",
"étalèrent" => "etalER",
"étaleront" => "etal°R§",
"étales" => "etal",
"étalés" => "etale",
"étalez" => "etale",
"étalions" => "etalj§",
"étalon" => "etal§",
"étalonnage" => "etalonaZ",
"étalonnages" => "etalonaZ",
"étalonne" => "etalOn",
"étalonné" => "etalone",
"étalonner" => "etalone",
"étalonnés" => "etalone",
"étalons" => "etal§",
"étals" => "etal",
"étamaient" => "etamE",
"étambot" => "et@bo",
"étamé" => "etame",
"étameur" => "etam9R",
"étameurs" => "etam9R",
"étamine" => "etamin",
"étamines" => "etamin",
"étampes" => "et@p",
"étampures" => "et@pyR",
"étanchaient" => "et@SE",
"étanchait" => "et@SE",
"étanche" => "et@S",
"étanché" => "et@Se",
"étanchée" => "et@Se",
"étanchéité" => "et@Seite",
"étanchement" => "et@S°m@",
"étanchent" => "et@S",
"étancher" => "et@Se",
"étancherait" => "et@S°RE",
"étanches" => "et@S",
"étançon" => "et@s§",
"étang" => "et@",
"étangs" => "et@",
"étant" => "et@",
"étape" => "etap",
"étapes" => "etap",
"état" => "eta",
"état-civil" => "etasivil",
"état-major" => "etamaZOR",
"étatique" => "etatik",
"étatiques" => "etatik",
"étatisation" => "etatizasj§",
"étatisme" => "etatizm",
"états" => "eta",
"états-civils" => "etasivil",
"états-majors" => "etamaZOR",
"étau" => "eto",
"étaux" => "eto",
"étayage" => "etejaZ",
"étayaient" => "etejE",
"étayait" => "etejE",
"étayant" => "etej@",
"étaye" => "etej",
"étayé" => "eteje",
"étayée" => "eteje",
"étayées" => "eteje",
"étayer" => "eteje",
"étayés" => "eteje",
"étayez" => "eteje",
"etc" => "EtseteRa",
"etc." => "EtseteRa",
"etcetera" => "EtseteRa",
"été" => "ete",
"éteignaient" => "etENE",
"éteignais" => "etENE",
"éteignait" => "etENE",
"éteignant" => "etEN@",
"éteigne" => "etEN",
"éteignent" => "etEN",
"éteignes" => "etEN",
"éteignez" => "etENe",
"éteignions" => "etEN§",
"éteignirent" => "etENiR",
"éteignis" => "etENi",
"éteignit" => "etENi",
"éteignît" => "etENi",
"éteignoir" => "etENwaR",
"éteignons" => "etEN§",
"éteindra" => "et5dRa",
"éteindrai" => "et5dRE",
"éteindraient" => "et5dRE",
"éteindrais" => "et5dRE",
"éteindrait" => "et5dRE",
"éteindras" => "et5dRa",
"éteindre" => "et5dR",
"éteindrez" => "et5dRe",
"éteindrons" => "et5dR§",
"éteindront" => "et5dR§",
"éteins" => "et5",
"éteint" => "et5",
"éteinte" => "et5t",
"éteintes" => "et5t",
"éteints" => "et5",
"étend" => "et@",
"étendage" => "et@daZ",
"étendaient" => "et@dE",
"étendais" => "et@dE",
"étendait" => "et@dE",
"étendant" => "et@d@",
"étendard" => "et@daR",
"étendards" => "et@daR",
"étende" => "et@d",
"étendent" => "et@d",
"étendez" => "et@de",
"étendîmes" => "et@dim",
"étendions" => "et@dj§",
"étendirent" => "et@diR",
"étendis" => "et@di",
"étendit" => "et@di",
"étendît" => "et@di",
"étendoir" => "et@dwaR",
"étendons" => "et@d§",
"étendra" => "et@dRa",
"étendrai" => "et@dRE",
"étendraient" => "et@dRE",
"étendrais" => "et@dRE",
"étendrait" => "et@dRE",
"étendre" => "et@dR",
"étendrez" => "et@dRe",
"étendrions" => "et@dRij§",
"étendrons" => "et@dR§",
"étendront" => "et@dR§",
"étends" => "et@",
"étendu" => "et@dy",
"étendue" => "et@dy",
"étendues" => "et@dy",
"étendus" => "et@dy",
"éternel" => "etERnEl",
"éternelle" => "etERnEl",
"éternellement" => "etERnEl°m@",
"éternelles" => "etERnEl",
"éternels" => "etERnEl",
"éternisa" => "etERniza",
"éternisaient" => "etERnizE",
"éternisais" => "etERnizE",
"éternisait" => "etERnizE",
"éternisât" => "etERniza",
"éternise" => "etERniz",
"éternisé" => "etERnize",
"éternisée" => "etERnize",
"éternisent" => "etERniz",
"éterniser" => "etERnize",
"éterniserai" => "etERniz°RE",
"éterniserait" => "etERniz°RE",
"éterniserons" => "etERniz°R§",
"éternisés" => "etERnize",
"éternisez" => "etERnize",
"éternisons" => "etERniz§",
"éternité" => "etERnite",
"éternités" => "etERnite",
"éternua" => "etERn8a",
"éternuaient" => "etERn8E",
"éternuais" => "etERn8E",
"éternuait" => "etERn8E",
"éternuant" => "etERn8@",
"éternue" => "etERny",
"éternué" => "etERn8e",
"éternuement" => "etERnym@",
"éternuements" => "etERnym@",
"éternuent" => "etERny",
"éternuer" => "etERn8e",
"éternuerait" => "etERnyRE",
"éternues" => "etERny",
"éternuez" => "etERnye",
"êtes" => "Et",
"étés" => "ete",
"étêta" => "etEta",
"étêtait" => "etEtE",
"étêté" => "etEte",
"étêtés" => "etEte",
"éteule" => "et9l",
"éteules" => "et9l",
"éthane" => "etan",
"éthanol" => "etanOl",
"éther" => "etER",
"éthéré" => "eteRe",
"éthérée" => "eteRe",
"éthérées" => "eteRe",
"éthérés" => "eteRe",
"éthérique" => "eteRik",
"éthers" => "etER",
"éthiopien" => "etjopj5",
"éthiopienne" => "etjopjEn",
"éthiopiennes" => "etjopjEn",
"éthiopiens" => "etjopj5",
"éthique" => "etik",
"éthiquement" => "etik°m@",
"éthiques" => "etik",
"ethmoïdal" => "EtmOidal",
"ethmoïdaux" => "EtmOido",
"ethnicité" => "Etnisite",
"ethnie" => "Etni",
"ethnies" => "Etni",
"ethnique" => "Etnik",
"ethniquement" => "Etnik°m@",
"ethniques" => "Etnik",
"ethnobotaniste" => "Etnobotanist",
"ethnographe" => "EtnogRaf",
"ethnographie" => "EtnogRafi",
"ethnographique" => "EtnogRafik",
"ethnologie" => "EtnoloZi",
"ethnologique" => "EtnoloZik",
"ethnologiques" => "EtnoloZik",
"ethnologue" => "EtnolOg",
"ethnologues" => "EtnolOg",
"éthologie" => "etoloZi",
"éthologue" => "EtOlOg",
"éthyle" => "etil",
"éthylène" => "etilEn",
"éthylique" => "etilik",
"éthyliques" => "etilik",
"éthylisme" => "etilizm",
"éthylotest" => "etilOtEs°t",
"étiage" => "etjaZ",
"étier" => "etje",
"étiers" => "etje",
"étiez" => "etje",
"étincela" => "et5s°la",
"étincelaient" => "et5s°lE",
"étincelait" => "et5s°lE",
"étincelant" => "et5s°l@",
"étincelante" => "et5s°l@t",
"étincelantes" => "et5s°l@t",
"étincelants" => "et5s°l@",
"étincelé" => "et5s°le",
"étinceler" => "et5s°le",
"étincelèrent" => "et5s°lER",
"étincelle" => "et5sEl",
"étincellement" => "et5sEl°m@",
"étincellements" => "et5sEl°m@",
"étincellent" => "et5sEl",
"étincellera" => "et5sEl°Ra",
"étincelles" => "et5sEl",
"étiolaient" => "etjolE",
"étiolais" => "etjolE",
"étiolait" => "etjolE",
"étiolant" => "etjol@",
"étiole" => "etjOl",
"étiolé" => "etjole",
"étiolée" => "etjole",
"étiolées" => "etjole",
"étiolement" => "etjOl°m@",
"étiolent" => "etjOl",
"étioler" => "etjole",
"étiologie" => "etjOlOZi",
"étiologique" => "etjOlOZik",
"étiologiques" => "etjoloZik",
"étions" => "etj§",
"étique" => "etik",
"étiques" => "etik",
"étiquetage" => "etik°taZ",
"étiquetaient" => "etik°tE",
"étiqueté" => "etik°te",
"étiquetée" => "etik°te",
"étiquetées" => "etik°te",
"étiqueter" => "etik°te",
"étiquetés" => "etik°te",
"étiqueteuse" => "etik°t2z",
"étiquetez" => "etik°te",
"étiquette" => "etikEt",
"étiquettent" => "etikEt",
"étiquettes" => "etikEt",
"étira" => "etiRa",
"étirable" => "etiRabl",
"étirage" => "etiRaZ",
"étirai" => "etiRE",
"étiraient" => "etiRE",
"étirais" => "etiRE",
"étirait" => "etiRE",
"étirant" => "etiR@",
"étire" => "etiR",
"étiré" => "etiRe",
"étirée" => "etiRe",
"étirées" => "etiRe",
"étirement" => "etiR°m@",
"étirements" => "etiR°m@",
"étirent" => "etiR",
"étirer" => "etiRe",
"étirerait" => "etiR°RE",
"étirèrent" => "etiRER",
"étirés" => "etiRe",
"étirez" => "etiRe",
"étisie" => "etizi",
"étoffaient" => "etofE",
"étoffait" => "etofE",
"étoffe" => "etOf",
"étoffé" => "etofe",
"étoffée" => "etofe",
"étoffées" => "etofe",
"étoffer" => "etofe",
"étoffes" => "etOf",
"étoffés" => "etofe",
"étoila" => "etwala",
"étoilaient" => "etwalE",
"étoilait" => "etwalE",
"étoile" => "etwal",
"étoilé" => "etwale",
"étoilée" => "etwale",
"étoilées" => "etwale",
"étoilent" => "etwal",
"étoiles" => "etwal",
"étoilés" => "etwale",
"étole" => "etOl",
"étoles" => "etOl",
"étonna" => "etona",
"étonnai" => "etonE",
"étonnaient" => "etonE",
"étonnais" => "etonE",
"étonnait" => "etonE",
"étonnâmes" => "etonam",
"étonnamment" => "etonam@",
"étonnant" => "eton@",
"étonnante" => "eton@t",
"étonnantes" => "eton@t",
"étonnants" => "eton@",
"étonnât" => "etona",
"étonne" => "etOn",
"étonné" => "etone",
"étonnée" => "etone",
"étonnées" => "etone",
"étonnement" => "etOn°m@",
"étonnements" => "EtOn°m@",
"étonnent" => "etOn",
"étonner" => "etone",
"étonnera" => "etOn°Ra",
"étonnerai" => "etOn°RE",
"étonneraient" => "etOn°RE",
"étonnerais" => "etOn°RE",
"étonnerait" => "etOn°RE",
"étonneras" => "etOn°Ra",
"étonnèrent" => "etonER",
"étonnerez" => "etOn°Re",
"étonneriez" => "eton°Rje",
"étonnerons" => "etOn°R§",
"étonneront" => "etOn°R§",
"étonnes" => "etOn",
"étonnés" => "etone",
"étonnez" => "etone",
"étonniez" => "etonje",
"étonnions" => "etonj§",
"étonnons" => "eton§",
"étouffa" => "etufa",
"étouffai" => "etufE",
"étouffaient" => "etufE",
"étouffais" => "etufE",
"étouffait" => "etufE",
"étouffant" => "etuf@",
"étouffante" => "etuf@t",
"étouffantes" => "etuf@t",
"étouffants" => "etuf@",
"étouffassent" => "etufas",
"étouffât" => "etufa",
"étouffe" => "etuf",
"étouffé" => "etufe",
"étouffe-chrétien" => "etufkRetj5",
"étouffée" => "etufe",
"étouffées" => "etufe",
"étouffement" => "etufm@",
"étouffements" => "etufm@",
"étouffent" => "etuf",
"étouffer" => "etufe",
"étouffera" => "etuf°Ra",
"étoufferai" => "etuf°RE",
"étoufferaient" => "etuf°RE",
"étoufferais" => "etuf°RE",
"étoufferait" => "etuf°RE",
"étouffèrent" => "etufER",
"étoufferez" => "etuf°Re",
"étoufferiez" => "etuf°Rje",
"étoufferons" => "etuf°R§",
"étoufferont" => "etuf°R§",
"étouffes" => "etuf",
"étouffés" => "etufe",
"étouffeur" => "etuf9R",
"étouffeuses" => "etuf2z",
"étouffez" => "etufe",
"étouffiez" => "etufje",
"étouffions" => "etufj§",
"étouffoir" => "etufwaR",
"étouffoirs" => "etufwaR",
"étouffons" => "etuf§",
"étoupe" => "etup",
"étourderie" => "etuRd°Ri",
"étourderies" => "etuRd°Ri",
"étourdi" => "etuRdi",
"étourdie" => "etuRdi",
"étourdies" => "etuRdi",
"étourdiment" => "etuRdim@",
"étourdir" => "etuRdiR",
"étourdira" => "etuRdiRa",
"étourdirait" => "etuRdiRE",
"étourdirent" => "etuRdiR",
"étourdis" => "etuRdi",
"étourdissaient" => "etuRdisE",
"étourdissait" => "etuRdisE",
"étourdissant" => "etuRdis@",
"étourdissante" => "etuRdis@t",
"étourdissantes" => "etuRdis@t",
"étourdissants" => "etuRdis@",
"étourdissement" => "etuRdis°m@",
"étourdissements" => "etuRdis°m@",
"étourdissent" => "etuRdis",
"étourdissez" => "etuRdise",
"étourdissons" => "etuRdis§",
"étourdit" => "etuRdi",
"étourneau" => "etuRno",
"étourneaux" => "etuRno",
"étrange" => "etR@Z",
"étrangéité" => "etR@Zeite",
"étrangement" => "etR@Z°m@",
"étranger" => "etR@Ze",
"étrangère" => "etR@ZER",
"étrangères" => "etR@ZER",
"étrangers" => "etR@Ze",
"étranges" => "etR@Z",
"étrangeté" => "etR@Z°te",
"étrangetés" => "etR@Z°te",
"étrangla" => "etR@gla",
"étranglai" => "etR@glE",
"étranglaient" => "etR@glE",
"étranglais" => "etR@glE",
"étranglait" => "etR@glE",
"étranglant" => "etR@gl@",
"étranglât" => "etR@gla",
"étrangle" => "etR@gl",
"étranglé" => "etR@gle",
"étranglée" => "etR@gle",
"étranglées" => "etR@gle",
"étranglement" => "etR@gl°m@",
"étranglements" => "etR@gl°m@",
"étranglent" => "etR@gl",
"étrangler" => "etR@gle",
"étranglera" => "etR@gl°Ra",
"étranglerai" => "etR@gl°RE",
"étrangleraient" => "etR@gl°RE",
"étranglerais" => "etR@gl°RE",
"étranglerait" => "etR@gl°RE",
"étrangleront" => "etR@gl°R§",
"étrangles" => "etR@gl",
"étranglés" => "etR@gle",
"étrangleur" => "etR@gl9R",
"étrangleurs" => "etR@gl9R",
"étrangleuse" => "etR@gl2z",
"étrangleuses" => "etR@gl2z",
"étranglez" => "etR@gle",
"étrave" => "etRav",
"étraves" => "etRav",
"être" => "EtR",
"être-là" => "EtRla",
"étréci" => "etResi",
"étrécie" => "etResi",
"étrécir" => "etResiR",
"étrécissement" => "etResis°m@",
"étrécit" => "etResi",
"étreignaient" => "etRENE",
"étreignais" => "etRENE",
"étreignait" => "etRENE",
"étreignant" => "etREN@",
"étreigne" => "etREN",
"étreignent" => "etREN",
"étreignîmes" => "etRENim",
"étreignions" => "etREN§",
"étreignirent" => "etRENiR",
"étreignit" => "etRENi",
"étreignons" => "etREN§",
"étreindrait" => "etR5dRE",
"étreindre" => "etR5dR",
"étreindrons" => "etR5dR§",
"étreindront" => "etR5dR§",
"étreins" => "etR5",
"étreint" => "etR5",
"étreinte" => "etR5t",
"étreintes" => "etR5t",
"étreints" => "etR5",
"étrenna" => "etREna",
"étrennait" => "etREnE",
"étrennant" => "etREn@",
"étrenne" => "etREn",
"étrenné" => "etREne",
"étrennée" => "etREne",
"étrennent" => "etREn",
"étrenner" => "etRene",
"étrennera" => "etREn°Ra",
"étrennerais" => "etREn°RE",
"étrennes" => "etREn",
"êtres" => "EtR",
"étrésillon" => "etRezij§",
"étrier" => "etRije",
"étriers" => "etRije",
"étrilla" => "etRija",
"étrillage" => "etRijaZ",
"étrillaient" => "etRijE",
"étrillait" => "etRijE",
"étrille" => "etRij",
"étrillé" => "etRije",
"étrillée" => "etRije",
"étriller" => "etRije",
"étrillerez" => "etRij°Re",
"étrilles" => "etRil",
"étrillés" => "etRije",
"étripage" => "etRipaZ",
"étripages" => "etRipaZ",
"étripaient" => "etRipE",
"étripe" => "etRip",
"étripé" => "etRipe",
"étripée" => "etRipe",
"étripent" => "etRip",
"étriper" => "etRipe",
"étripera" => "etRip°Ra",
"étriperai" => "etRip°RE",
"étriperaient" => "etRip°RE",
"étriperais" => "etRip°RE",
"étripèrent" => "etRipER",
"étripés" => "etRipe",
"étriqua" => "etRika",
"étriquaient" => "etRikE",
"étriquant" => "etRik@",
"étriqué" => "etRike",
"étriquée" => "etRike",
"étriquées" => "etRike",
"étriqués" => "etRike",
"étrivière" => "etRivjER",
"étrivières" => "etRivjER",
"étroit" => "etRwa",
"étroite" => "etRwat",
"étroitement" => "etRwat°m@",
"étroites" => "etRwat",
"étroitesse" => "etRwatEs",
"étroits" => "etRwa",
"étron" => "etR§",
"étrons" => "etR§",
"étrusque" => "etRysk",
"étrusques" => "etRysk",
"étude" => "etyd",
"études" => "etyd",
"étudia" => "etydja",
"étudiai" => "etydjE",
"étudiaient" => "etydjE",
"étudiais" => "etydjE",
"étudiait" => "etydjE",
"étudiant" => "etydj@",
"étudiante" => "etydj@t",
"étudiantes" => "etydj@t",
"étudiants" => "etydj@",
"étudie" => "etydi",
"étudié" => "etydje",
"étudiée" => "etydje",
"étudiées" => "etydje",
"étudient" => "etydi",
"étudier" => "etydje",
"étudiera" => "etydiRa",
"étudierai" => "etydiRE",
"étudierais" => "etydiRE",
"étudierait" => "etydiRE",
"étudieras" => "etydiRa",
"étudièrent" => "etydjER",
"étudierez" => "etydiRe",
"étudierions" => "etydiRj§",
"étudierons" => "etydiR§",
"étudies" => "etydi",
"étudiés" => "etydje",
"étudiez" => "etydje",
"étudions" => "etydj§",
"étui" => "et8i",
"étuis" => "et8i",
"étuve" => "etyv",
"étuvé" => "etyve",
"étuvée" => "etyve",
"étuver" => "etyve",
"étuves" => "etyv",
"étuveuse" => "etyv2z",
"étymologie" => "etimoloZi",
"étymologies" => "etimoloZi",
"étymologique" => "etimoloZik",
"étymologiquement" => "etimoloZik°m@",
"étymologiques" => "etimoloZik",
"étymologiste" => "etimoloZist",
"eu" => "y",
"eubage" => "2baZ",
"eubine" => "2bin",
"eucalyptus" => "2kaliptys",
"eucharistie" => "2kaRisti",
"eucharistique" => "2kaRistik",
"eucharistiques" => "2kaRistik",
"euclidien" => "2klidj5",
"euclidienne" => "2klidjEn",
"euclidiens" => "2klidj5",
"eudistes" => "2dist",
"eue" => "y",
"eues" => "y",
"eugénique" => "2Zenik",
"eugénisme" => "2Zenizm",
"euh" => "2",
"eulogie" => "2loZi",
"eûmes" => "ym",
"eunuque" => "2nyk",
"eunuques" => "2nyk",
"eunuques-espions" => "2nykEspj§",
"euphémisme" => "2femizm",
"euphémismes" => "2femizm",
"euphonie" => "2foni",
"euphonique" => "2fonik",
"euphoniquement" => "2fonik°m@",
"euphoniques" => "2fonik",
"euphorbe" => "2fORb",
"euphorbes" => "2fORb",
"euphorie" => "2foRi",
"euphorique" => "2foRik",
"euphorisant" => "2foRiz@",
"euphorisante" => "2foRiz@t",
"euphorisants" => "2foRiz@",
"euphorisé" => "2foRize",
"euphorisée" => "2foRize",
"euphorisent" => "2foRiz",
"eurafricaine" => "2RafRikEn",
"eurafricains" => "9RafRik5",
"eurasien" => "2Razj5",
"eurasienne" => "2RazjEn",
"eurêka" => "2REka",
"eurent" => "yR",
"euro" => "2Ro",
"euro-africaines" => "2RoafRikEn",
"eurodollar" => "2RodolaR",
"euromarché" => "2RomaRSe",
"européen" => "2Rope5",
"européenne" => "2RopeEn",
"européennes" => "2RopeEn",
"européens" => "2Rope5",
"euros" => "2Ro",
"eurythmiques" => "2Ritmik",
"eus" => "y",
"euskera" => "2skeRa",
"eusse" => "ys",
"eussé" => "yse",
"eussent" => "ys",
"eusses" => "ys",
"eussiez" => "ysje",
"eussions" => "ysj§",
"eustache" => "2staS",
"eustaches" => "2staS",
"eut" => "y",
"eût" => "y",
"eûtes" => "yt",
"euthanasie" => "2tanazi",
"euthanasies" => "2tanazi",
"eux" => "2",
"eux-mêmes" => "2mEm",
"évacua" => "evak8a",
"évacuai" => "evak8E",
"évacuaient" => "evak8E",
"évacuais" => "evak8E",
"évacuait" => "evak8E",
"évacuant" => "evak8@",
"évacuation" => "evak8asj§",
"évacuations" => "evak8asj§",
"évacue" => "evaky",
"évacué" => "evak8e",
"évacuée" => "evak8e",
"évacuées" => "evak8e",
"évacuent" => "evaky",
"évacuer" => "evak8e",
"évacuera" => "evakyRa",
"évacuerai" => "evakyRE",
"évacueraient" => "evakyRE",
"évacuerais" => "evakyRE",
"évacuerait" => "evakyRE",
"évacuèrent" => "evak8ER",
"évacuerez" => "evakyRe",
"évacuerions" => "evakyRj§",
"évacuerons" => "evakyR§",
"évacueront" => "evakyR§",
"évacués" => "evak8e",
"évacuez" => "evakye",
"évacuons" => "evak8§",
"évada" => "evada",
"évadaient" => "evadE",
"évadais" => "evadE",
"évadait" => "evadE",
"évadant" => "evad@",
"évade" => "evad",
"évadé" => "evade",
"évadée" => "evade",
"évadées" => "evade",
"évadent" => "evad",
"évader" => "evade",
"évadera" => "evad°Ra",
"évaderai" => "evad°RE",
"évaderaient" => "evad°RE",
"évaderais" => "evad°RE",
"évaderait" => "evad°RE",
"évaderas" => "evad°Ra",
"évadèrent" => "evadER",
"évaderont" => "evad°R§",
"évades" => "evad",
"évadés" => "evade",
"évadez" => "evade",
"évalua" => "eval8a",
"évaluables" => "eval8abl",
"évaluaient" => "eval8E",
"évaluais" => "eval8E",
"évaluait" => "eval8E",
"évaluant" => "eval8@",
"évaluât" => "eval8a",
"évaluateur" => "eval8at9R",
"évaluation" => "eval8asj§",
"évaluations" => "eval8asj§",
"évalue" => "evaly",
"évalué" => "eval8e",
"évaluée" => "eval8e",
"évaluées" => "eval8e",
"évaluent" => "evaly",
"évaluer" => "eval8e",
"évaluèrent" => "eval8ER",
"évaluerez" => "evalyRe",
"évalueront" => "evalyR§",
"évalues" => "evaly",
"évalués" => "eval8e",
"évaluez" => "evalye",
"évaluons" => "evaly§",
"évanescence" => "evanes@s",
"évanescences" => "evanes@s",
"évanescent" => "evanes@",
"évanescente" => "evanes@t",
"évanescentes" => "evanes@t",
"évanescents" => "evanes@",
"évangéliaire" => "ev@ZeljER",
"évangélique" => "ev@Zelik",
"évangéliques" => "ev@Zelik",
"évangélisateur" => "ev@Zelizat9R",
"évangélisation" => "ev@Zelizasj§",
"évangélisatrices" => "ev@ZelizatRis",
"évangélisé" => "ev@Zelize",
"évangéliser" => "ev@Zelize",
"évangéliseront" => "ev@Zeliz°R§",
"évangélisés" => "ev@Zelize",
"évangélisons" => "ev@Zeliz§",
"évangéliste" => "ev@Zelist",
"évangélistes" => "ev@Zelist",
"évangile" => "ev@Zil",
"évangiles" => "ev@Zil",
"évanoui" => "evanwi",
"évanouie" => "evanwi",
"évanouies" => "evanwi",
"évanouir" => "evanuiR",
"évanouira" => "evanwiRa",
"évanouirai" => "evanwiRE",
"évanouirait" => "evanwiRE",
"évanouirent" => "evanwiR",
"évanouirez" => "evanuiRe",
"évanouiront" => "evanwiR§",
"évanouis" => "evanwi",
"évanouissaient" => "evanwisE",
"évanouissais" => "evanwisE",
"évanouissait" => "evanwisE",
"évanouissant" => "evanwis@",
"évanouisse" => "evanwis",
"évanouissement" => "evanwis°m@",
"évanouissements" => "evanwis°m@",
"évanouissent" => "evanwis",
"évanouisses" => "evanuis",
"évanouissez" => "evanwise",
"évanouit" => "evanwi",
"évanouît" => "evanwi",
"évapora" => "evapoRa",
"évaporaient" => "evapoRE",
"évaporais" => "evapoRE",
"évaporait" => "evapoRE",
"évaporateur" => "evapoRat9R",
"évaporateurs" => "evapoRat9R",
"évaporation" => "evapoRasj§",
"évapore" => "evapOR",
"évaporé" => "evapoRe",
"évaporée" => "evapoRe",
"évaporées" => "evapoRe",
"évaporent" => "evapOR",
"évaporer" => "evapoRe",
"évaporerait" => "evapOR°RE",
"évaporeront" => "evapOR°R§",
"évaporés" => "evapoRe",
"évasaient" => "evazE",
"évasait" => "evazE",
"évasant" => "evaz@",
"évase" => "evaz",
"évasé" => "evaze",
"évasée" => "evaze",
"évasées" => "evaze",
"évasement" => "evaz°m@",
"évasent" => "evaz",
"évaser" => "evaze",
"évasés" => "evaze",
"évasif" => "evazif",
"évasifs" => "evazif",
"évasion" => "evazj§",
"évasions" => "evazj§",
"évasive" => "evaziv",
"évasivement" => "evaziv°m@",
"évasives" => "evaziv",
"ève" => "Ev",
"évêché" => "eveSe",
"évêchés" => "eveSe",
"éveil" => "evEj",
"éveilla" => "evEja",
"éveillai" => "evEjE",
"éveillaient" => "evEjE",
"éveillais" => "evEjE",
"éveillait" => "evEjE",
"éveillant" => "evEj@",
"éveillât" => "evEja",
"éveille" => "evEj",
"éveillé" => "eveje",
"éveillée" => "eveje",
"éveillées" => "eveje",
"éveillent" => "evEj",
"éveiller" => "eveje",
"éveillera" => "evEj°Ra",
"éveillerai" => "evEj°RE",
"éveilleraient" => "evEj°RE",
"éveillerait" => "evEj°RE",
"éveilleras" => "evEj°Ra",
"éveillèrent" => "evEjER",
"éveillerez" => "evEj°Re",
"éveilleront" => "evEj°R§",
"éveilles" => "evEj",
"éveillés" => "eveje",
"éveilleur" => "evEj9R",
"éveillez" => "evEje",
"éveillions" => "evEjj§",
"éveillons" => "evEj§",
"éveils" => "evEj",
"éveinage" => "evEnaZ",
"événement" => "evEn°m@",
"évènement" => "evEn°m@",
"événementiel" => "even°m@sjEl",
"évènementielle" => "evEn°m@tjEl",
"événements" => "evEn°m@",
"évènements" => "evEn°m@",
"event" => "ivEnt",
"évent" => "ev@",
"éventa" => "ev@ta",
"éventai" => "ev@tE",
"éventaient" => "ev@tE",
"éventail" => "ev@taj",
"éventails" => "ev@taj",
"éventaire" => "ev@tER",
"éventaires" => "ev@tER",
"éventait" => "ev@tE",
"éventant" => "ev@t@",
"évente" => "ev@t",
"éventé" => "ev@te",
"éventée" => "ev@te",
"éventées" => "ev@te",
"éventent" => "ev@t",
"éventer" => "ev@te",
"éventerai" => "ev@t°RE",
"éventés" => "ev@te",
"éventez" => "ev@te",
"éventons" => "ev@t§",
"éventra" => "ev@tRa",
"éventraient" => "ev@tRE",
"éventrait" => "ev@tRE",
"éventrant" => "ev@tR@",
"éventrât" => "ev@tRa",
"éventration" => "ev@tRasj§",
"éventre" => "ev@tR",
"éventré" => "ev@tRe",
"éventrée" => "ev@tRe",
"éventrées" => "ev@tRe",
"éventrement" => "ev@tR°m@",
"éventrent" => "ev@tR",
"éventrer" => "ev@tRe",
"éventrerai" => "ev@tR°RE",
"éventrerait" => "ev@tR°RE",
"éventrerez" => "ev@tR°Re",
"éventres" => "ev@tR",
"éventrés" => "ev@tRe",
"éventreur" => "ev@tR9R",
"éventreurs" => "ev@tR9R",
"éventrez" => "ev@tRe",
"éventrions" => "ev@tRij§",
"évents" => "ev@",
"éventualité" => "ev@t8alite",
"éventualités" => "ev@t8alite",
"éventuel" => "ev@t8El",
"éventuelle" => "ev@t8El",
"éventuellement" => "ev@t8El°m@",
"éventuelles" => "ev@t8El",
"éventuels" => "ev@t8El",
"évêque" => "evEk",
"évêques" => "evEk",
"évergète" => "evERZEt",
"éversé" => "evERse",
"éversées" => "evERse",
"évertua" => "evERt8a",
"évertuaient" => "evERt8E",
"évertuais" => "evERt8E",
"évertuait" => "evERt8E",
"évertuant" => "evERt8@",
"évertue" => "evERty",
"évertué" => "evERt8e",
"évertuent" => "evERty",
"évertuer" => "evERtye",
"éviction" => "eviksj§",
"évida" => "evida",
"évidaient" => "evidE",
"évide" => "evid",
"évidé" => "evide",
"évidée" => "evide",
"évidées" => "evide",
"évidement" => "evid°m@",
"évidemment" => "evidam@",
"évidence" => "evid@s",
"évidences" => "evid@s",
"évident" => "evid@",
"évidente" => "evid@t",
"évidentes" => "evid@t",
"évidents" => "evid@",
"évider" => "evide",
"évidés" => "evide",
"évier" => "evje",
"éviers" => "evje",
"évinçai" => "ev5sE",
"évinçant" => "ev5s@",
"évince" => "ev5s",
"évincé" => "ev5se",
"évincée" => "ev5se",
"évincer" => "ev5se",
"évincerait" => "ev5s°RE",
"évincés" => "ev5se",
"évincez" => "ev5se",
"éviscérant" => "eviseR@",
"éviscération" => "eviseRasj§",
"éviscère" => "evisER",
"éviscérée" => "eviseRe",
"éviscèrent" => "evisER",
"éviscérer" => "eviseRe",
"éviscérés" => "eviseRe",
"évita" => "evita",
"évitable" => "evitabl",
"évitables" => "evitabl",
"évitai" => "evitE",
"évitaient" => "evitE",
"évitais" => "evitE",
"évitait" => "evitE",
"évitâmes" => "evitam",
"évitant" => "evit@",
"évitât" => "evita",
"évite" => "evit",
"évité" => "evite",
"évitée" => "evite",
"évitées" => "evite",
"évitement" => "evit°m@",
"évitent" => "evit",
"éviter" => "evite",
"évitera" => "evit°Ra",
"éviterai" => "evit°RE",
"éviteraient" => "evit°RE",
"éviterais" => "evit°RE",
"éviterait" => "evit°RE",
"éviteras" => "evit°Ra",
"évitèrent" => "evitER",
"éviterez" => "evit°Re",
"éviteriez" => "evit°Rje",
"éviterons" => "evit°R§",
"éviteront" => "evit°R§",
"évites" => "evit",
"évités" => "evite",
"évitez" => "evite",
"évitiez" => "evitje",
"évitions" => "evitj§",
"évitons" => "evit§",
"évocateur" => "evokat9R",
"évocateurs" => "evokat9R",
"évocation" => "evokasj§",
"évocations" => "evokasj§",
"évocatrice" => "evokatRis",
"évocatrices" => "evokatRis",
"évolua" => "evol8a",
"évoluaient" => "evol8E",
"évoluais" => "evol8E",
"évoluait" => "evol8E",
"évoluant" => "evol8@",
"évolue" => "evoly",
"évolué" => "evol8e",
"évoluée" => "evol8e",
"évoluées" => "evol8e",
"évoluent" => "evoly",
"évoluer" => "evol8e",
"évoluera" => "evolyRa",
"évoluerait" => "evolyRE",
"évoluèrent" => "evol8ER",
"évolueront" => "evolyR§",
"évolués" => "evol8e",
"évoluez" => "evolye",
"évoluons" => "evol8§",
"évolutif" => "evolytif",
"évolution" => "evolysj§",
"évolutionniste" => "evolysjonist",
"évolutions" => "evolysj§",
"évolutive" => "evolytiv",
"évolutives" => "evolytiv",
"évoqua" => "evoka",
"évoquai" => "evokE",
"évoquaient" => "evokE",
"évoquais" => "evokE",
"évoquait" => "evokE",
"évoquâmes" => "evokam",
"évoquant" => "evok@",
"évoquât" => "evoka",
"évoque" => "evOk",
"évoqué" => "evoke",
"évoquée" => "evoke",
"évoquées" => "evoke",
"évoquent" => "evOk",
"évoquer" => "evoke",
"évoquera" => "evOk°Ra",
"évoquerai" => "evOk°RE",
"évoqueraient" => "evOk°RE",
"évoquerait" => "evOk°RE",
"évoquèrent" => "evokER",
"évoquerez" => "evOk°Re",
"évoquerons" => "evOk°R§",
"évoqueront" => "evOk°R§",
"évoques" => "evOk",
"évoqués" => "evoke",
"évoquez" => "evoke",
"évoquiez" => "evokje",
"évoquions" => "evokj§",
"évoquons" => "evok§",
"evzones" => "evzon",
"éwé" => "eve",
"éwés" => "eve",
"ex abrupto" => "EksabRypto",
"ex nihilo" => "Eksnajilo",
"ex-abbé" => "Eksabe",
"ex-acteur" => "Eksakt9R",
"ex-adjudant" => "EksadZyd@",
"ex-agent" => "EksaZ@",
"ex-alcoolo" => "Eksalkolo",
"ex-allée" => "Eksale",
"ex-amant" => "Eksam@",
"ex-amante" => "Eksam@t",
"ex-amants" => "Eksam@",
"ex-ambassadeur" => "Eks@basad9R",
"ex-amour" => "EksamuR",
"ex-appartement" => "EksapaRt°m@",
"ex-apprenti" => "EksapR@ti",
"ex-arriviste" => "EksaRivist",
"ex-artiste" => "EksaRtist",
"ex-assistant" => "Eksasist@",
"ex-assistante" => "Eksasist@t",
"ex-associé" => "Eksasosje",
"ex-associés" => "Eksasosje",
"ex-ballerine" => "Eksbal°Rin",
"ex-banquier" => "Eksb@kje",
"ex-barman" => "EksbaRman",
"ex-basketteur" => "EksbaskEt9R",
"ex-batteur" => "Eksbat9R",
"ex-beatnik" => "Eksbitnik",
"ex-belle-mère" => "EksbElmER",
"ex-bibliothécaire" => "EksbibliotekER",
"ex-boss" => "EksbOs",
"ex-boxeur" => "EksbOks9R",
"ex-branleurs" => "EksbR@l9R",
"ex-buteur" => "Eksbyt9R",
"ex-caïd" => "Ekskaid",
"ex-camarades" => "EkskamaRad",
"ex-capitaine" => "EkskapitEn",
"ex-champion" => "EksS@pj§",
"ex-championne" => "EksS@pjOn",
"ex-champions" => "EksS@pj§",
"ex-chanteur" => "EksS@t9R",
"ex-chanteuse" => "EksS@t2z",
"ex-chauffeur" => "EksSof9R",
"ex-chef" => "EksSEf",
"ex-chiropracteur" => "EkskiRopRakt9R",
"ex-citation" => "Ekssitasj§",
"ex-citoyen" => "Ekssitwaj5",
"ex-civils" => "Ekssivil",
"ex-collabo" => "Ekskolabo",
"ex-collègue" => "EkskolEg",
"ex-collègues" => "EkskolEg",
"ex-colonel" => "EkskolonEl",
"ex-commando" => "Ekskom@do",
"ex-concierge" => "Eksk§sjERZ",
"ex-contrebandier" => "Eksk§tR°b@dje",
"ex-copain" => "Ekskop5",
"ex-copains" => "Ekskop5",
"ex-copine" => "Ekskopin",
"ex-copines" => "Ekskopin",
"ex-corps" => "EkskOR",
"ex-couple" => "Ekskupl",
"ex-danseuse" => "Eksd@s2z",
"ex-dealer" => "EksdilER",
"ex-démon" => "Eksdem§",
"ex-démons" => "Eksdem§",
"ex-dieu" => "Eksdj2",
"ex-diva" => "Eksdiva",
"ex-drifter" => "EksdRift9R",
"ex-drôlesse" => "EksdRolEs",
"ex-dulcinée" => "Eksdylsine",
"ex-élève" => "EkselEv",
"ex-enseigne" => "Eks@sEN",
"ex-enzymes" => "Eks@zim",
"ex-épouse" => "Eksepuz",
"ex-épouses" => "Eksepuz",
"ex-équipier" => "Eksekipje",
"ex-esclavagistes" => "EksEsklavaZist",
"ex-femme" => "Eksfam",
"ex-femmes" => "Eksfam",
"ex-fiancé" => "Eksfj@se",
"ex-fiancée" => "Eksfj@se",
"ex-fils" => "Eksfis",
"ex-flic" => "Eksflik",
"ex-flics" => "Eksflik",
"ex-forçats" => "EksfORsa",
"ex-fusilleurs" => "Eksfyzij9R",
"ex-gang" => "Eksg@g",
"ex-garde" => "EksgaRd",
"ex-gardes" => "EksgaRd",
"ex-gauchiste" => "EksgoSist",
"ex-gendre" => "EksZ@dR",
"ex-génie" => "EksZeni",
"ex-gonzesse" => "Eksg§zEs",
"ex-gouverneur" => "EksguvERn9R",
"ex-gravosse" => "EksgRavos",
"ex-griot" => "EksgRio",
"ex-griveton" => "EksgRiv°t§",
"ex-grognasse" => "EksgRoNas",
"ex-groupe" => "EksgRup",
"ex-guenilles" => "Eksg°nij",
"ex-guitariste" => "EksgitaRist",
"ex-hippies" => "Eksipi",
"ex-homme" => "EksOm",
"ex-homme-grenouille" => "EksOmgR°nuj",
"ex-hôpital" => "Eksopital",
"ex-immeuble" => "Eksim9bl",
"ex-inspecteur" => "Eks5spEkt9R",
"ex-inspecteurs" => "Eks5spEkt9R",
"ex-journaliste" => "EksZuRnalist",
"ex-junkie" => "EksdZ9nki",
"ex-kid" => "Ekskid",
"ex-leader" => "Ekslid9R",
"ex-légionnaire" => "EksleZjonER",
"ex-libris" => "EkslibRi",
"ex-lieutenant" => "Ekslj2t°n@",
"ex-lit" => "Eksli",
"ex-lycée" => "Ekslise",
"ex-madame" => "Eksmadam",
"ex-maire" => "EksmER",
"ex-maître" => "EksmEtR",
"ex-mari" => "EksmaRi",
"ex-marine" => "EksmaRin",
"ex-maris" => "EksmaRi",
"ex-mecs" => "EksmEk",
"ex-membre" => "Eksm@bR",
"ex-mercenaires" => "EksmERs°nER",
"ex-militaire" => "EksmilitER",
"ex-militaires" => "EksmilitER",
"ex-ministre" => "EksministR",
"ex-ministres" => "EksministR",
"ex-miss" => "Eksmis",
"ex-monteur" => "Eksm§t9R",
"ex-motard" => "EksmotaR",
"ex-nana" => "Eksnana",
"ex-officier" => "Eksofisje",
"ex-opérateur" => "EksopeRat9R",
"ex-palmes" => "Ekspalm",
"ex-para" => "EkspaRa",
"ex-partenaire" => "EkspaRt°nER",
"ex-patron" => "EkspatR§",
"ex-pensionnaires" => "Eksp@sjonER",
"ex-perroquet" => "EkspERokE",
"ex-petit" => "Eksp°ti",
"ex-petite" => "Eksp°tit",
"ex-petits" => "Eksp°ti",
"ex-pharmaciennes" => "EksfaRmasjEn",
"ex-pilote" => "EkspilOt",
"ex-planète" => "EksplanEt",
"ex-planton" => "Ekspl@t§",
"ex-plaquée" => "Eksplake",
"ex-plâtrier" => "EksplatRie",
"ex-poivrots" => "EkspwavRo",
"ex-premier" => "EkspR°mje",
"ex-présentateur" => "EkspRez@tat9R",
"ex-président" => "EkspRezid@",
"ex-présidents" => "EkspRezid@",
"ex-prêtre" => "EkspREtR",
"ex-primaire" => "EkspRimER",
"ex-prison" => "EkspRiz§",
"ex-procureur" => "EkspRokyR9R",
"ex-profession" => "EkspRofEsj§",
"ex-profileur" => "EkspRofil9R",
"ex-promoteur" => "EkspRomot9R",
"ex-propriétaire" => "EkspRopRietER",
"ex-putain" => "Ekspyt5",
"ex-putes" => "Ekspyt",
"ex-quincaillerie" => "Eksk5kaj°Ri",
"ex-quincaillier" => "Eksk5kaje",
"ex-rebelle" => "EksR°bEl",
"ex-reine" => "EksREn",
"ex-républiques" => "EksRepyblik",
"ex-résidence" => "EksRezid@s",
"ex-révolutionnaire" => "EksRevolysjonER",
"ex-roi" => "EksRwa",
"ex-sacs" => "Ekssak",
"ex-secrétaire" => "Ekss°kREtER",
"ex-séminariste" => "EksseminaRist",
"ex-sénateur" => "Ekssenat9R",
"ex-sergent" => "EkssERZ@",
"ex-sergents" => "EkssERZ@",
"ex-sévère" => "EkssevER",
"ex-soldats" => "Ekssolda",
"ex-solistes" => "Ekssolist",
"ex-standardiste" => "Eksst@daRdist",
"ex-star" => "EksstaR",
"ex-strip-teaseuse" => "EksstRiptiz2z",
"ex-super" => "EkssypER",
"ex-taulard" => "EkstolaR",
"ex-taulards" => "EkstolaR",
"ex-teinturier" => "Ekst5tyRje",
"ex-tirailleur" => "EkstiRaj9R",
"ex-tueur" => "Eksty9R",
"ex-tuteur" => "Ekstyt9R",
"ex-union" => "Eksynj§",
"ex-usine" => "Eksyzin",
"ex-vedette" => "Eksv°dEt",
"ex-violeurs" => "Eksvjol9R",
"ex-voto" => "Eksvoto",
"exacerba" => "EgzasERba",
"exacerbant" => "EgzasERb@",
"exacerbation" => "EgzasERbasj§",
"exacerbe" => "EgzasERb",
"exacerbé" => "EgzasERbe",
"exacerbée" => "EgzasERbe",
"exacerbées" => "EgzasERbe",
"exacerbent" => "EgzasERb",
"exacerber" => "EgzasERbe",
"exacerbés" => "EgzasERbe",
"exact" => "Egzakt",
"exacte" => "Egzakt",
"exactement" => "Egzakt°m@",
"exactes" => "Egzakt",
"exaction" => "Egzaksj§",
"exactions" => "Egzaksj§",
"exactitude" => "Egzaktityd",
"exactitudes" => "Egzaktityd",
"exacts" => "Egzakt",
"exagéra" => "EgzaZeRa",
"exagérai" => "EgzaZeRE",
"exagéraient" => "EgzaZeRE",
"exagérais" => "EgzaZeRE",
"exagérait" => "EgzaZeRE",
"exagérant" => "EgzaZeR@",
"exagération" => "EgzaZeRasj§",
"exagérations" => "EgzaZeRasj§",
"exagère" => "EgzaZER",
"exagéré" => "EgzaZeRe",
"exagérée" => "EgzaZeRe",
"exagérées" => "EgzaZeRe",
"exagérément" => "EgzaZeRem@",
"exagèrent" => "EgzaZER",
"exagérer" => "EgzaZeRe",
"exagérerais" => "EgzaZeR°RE",
"exagérerait" => "EgzaZeR°RE",
"exagérèrent" => "EgzaZeRER",
"exagérerons" => "EgzaZeR°R§",
"exagères" => "EgzaZER",
"exagérés" => "EgzaZeRe",
"exagérez" => "EgzaZeRe",
"exagérions" => "EgzaZeRj§",
"exagérons" => "EgzaZeR§",
"exalta" => "Egzalta",
"exaltai" => "EgzaltE",
"exaltaient" => "EgzaltE",
"exaltais" => "EgzaltE",
"exaltait" => "EgzaltE",
"exaltant" => "Egzalt@",
"exaltante" => "Egzalt@t",
"exaltantes" => "Egzalt@t",
"exaltants" => "Egzalt@",
"exaltation" => "Egzaltasj§",
"exaltations" => "Egzaltasj§",
"exalte" => "Egzalt",
"exalté" => "Egzalte",
"exaltée" => "Egzalte",
"exaltées" => "Egzalte",
"exaltent" => "Egzalt",
"exalter" => "Egzalte",
"exalterait" => "Egzalt°RE",
"exaltèrent" => "EgzaltER",
"exaltes" => "Egzalt",
"exaltés" => "Egzalte",
"exaltons" => "Egzalt§",
"exam" => "Egzam",
"examen" => "Egzam5",
"examens" => "Egzam5",
"examina" => "Egzamina",
"examinai" => "EgzaminE",
"examinaient" => "EgzaminE",
"examinais" => "EgzaminE",
"examinait" => "EgzaminE",
"examinant" => "Egzamin@",
"examinateur" => "Egzaminat9R",
"examinateurs" => "Egzaminat9R",
"examinatrice" => "EgzaminatRis",
"examine" => "Egzamin",
"examiné" => "Egzamine",
"examinée" => "Egzamine",
"examinées" => "Egzamine",
"examinent" => "Egzamin",
"examiner" => "Egzamine",
"examinera" => "Egzamin°Ra",
"examinerai" => "Egzamin°RE",
"examineraient" => "Egzamin°RE",
"examinerais" => "Egzamin°RE",
"examinerait" => "Egzamin°RE",
"examinèrent" => "EgzaminER",
"examinerez" => "Egzamin°Re",
"examineriez" => "Egzamin°Rje",
"examinerons" => "Egzamin°R§",
"examineront" => "Egzamin°R§",
"examines" => "Egzamin",
"examinés" => "Egzamine",
"examinez" => "Egzamine",
"examiniez" => "Egzaminje",
"examinions" => "Egzaminj§",
"examinons" => "Egzamin§",
"exams" => "Egzam",
"exarque" => "EgzaRk",
"exaspéra" => "EgzaspeRa",
"exaspéraient" => "EgzaspeRE",
"exaspérais" => "EgzaspeRE",
"exaspérait" => "EgzaspeRE",
"exaspérant" => "EgzaspeR@",
"exaspérante" => "EgzaspeR@t",
"exaspérantes" => "EgzaspeR@t",
"exaspérants" => "EgzaspeR@",
"exaspérât" => "EgzaspeRa",
"exaspération" => "EgzaspeRasj§",
"exaspérations" => "EgzaspeRasj§",
"exaspère" => "EgzaspER",
"exaspéré" => "EgzaspeRe",
"exaspérée" => "EgzaspeRe",
"exaspérées" => "EgzaspeRe",
"exaspèrent" => "EgzaspER",
"exaspérer" => "EgzaspeRe",
"exaspérera" => "EgzaspeR°Ra",
"exaspéreraient" => "EgzaspeR°RE",
"exaspérerait" => "EgzaspeR°RE",
"exaspérèrent" => "EgzaspeRER",
"exaspérés" => "EgzaspeRe",
"exaspérez" => "EgzaspeRe",
"exauça" => "Egzosa",
"exauçai" => "EgzosE",
"exauçaient" => "EgzosE",
"exauçant" => "Egzos@",
"exauçât" => "Egzosa",
"exauce" => "Egzos",
"exaucé" => "Egzose",
"exaucée" => "Egzose",
"exaucées" => "Egzose",
"exaucement" => "Egzos°m@",
"exaucent" => "Egzos",
"exaucer" => "Egzose",
"exaucera" => "Egzos°Ra",
"exaucerai" => "Egzos°RE",
"exaucés" => "Egzose",
"exaucez" => "Egzose",
"exauçons" => "Egzos§",
"excavateur" => "Ekskavat9R",
"excavateurs" => "Ekskavat9R",
"excavation" => "Ekskavasj§",
"excavations" => "Ekskavasj§",
"excavatrice" => "EkskavatRis",
"excavée" => "Ekskave",
"excavées" => "Ekskave",
"excaver" => "Ekskave",
"excédaient" => "EksedE",
"excédais" => "EksedE",
"excédait" => "EksedE",
"excédant" => "Eksed@",
"excédât" => "Ekseda",
"excède" => "EksEd",
"excédé" => "Eksede",
"excédée" => "Eksede",
"excédées" => "Eksede",
"excédent" => "Eksed@",
"excèdent" => "EksEd",
"excédentaire" => "Eksed@tER",
"excédentaires" => "Eksed@tER",
"excédents" => "Eksed@",
"excéder" => "Eksede",
"excédera" => "Eksed°Ra",
"excédés" => "Eksede",
"excella" => "EksEla",
"excellaient" => "EksElE",
"excellais" => "EksElE",
"excellait" => "EksElE",
"excellant" => "EksEl@",
"excelle" => "EksEl",
"excellé" => "EksEle",
"excellemment" => "EksElam@",
"excellence" => "EksEl@s",
"excellences" => "Eksel@s",
"excellent" => "eksEl@",
"excellente" => "EksEl@t",
"excellentes" => "Eksel@t",
"excellentissime" => "EksEl@tisim",
"excellents" => "EksEl@",
"exceller" => "Eksele",
"excelleraient" => "EksEl°RE",
"excelles" => "EksEl",
"excellez" => "EksEle",
"excentré" => "Eks@tRe",
"excentrée" => "Eks@tRe",
"excentrer" => "Eks@tRe",
"excentricité" => "Eks@tRisite",
"excentricités" => "Eks@tRisite",
"excentrique" => "Eks@tRik",
"excentriques" => "Eks@tRik",
"exceptais" => "EksEptE",
"exceptait" => "EksEptE",
"exceptant" => "EksEpt@",
"excepte" => "EksEpt",
"excepté" => "EksEpte",
"exceptée" => "EksEpte",
"exceptées" => "EksEpte",
"excepter" => "EksEpte",
"exceptes" => "EksEpt",
"exceptés" => "EksEpte",
"exception" => "EksEpsj§",
"exceptionnel" => "EksEpsjonEl",
"exceptionnelle" => "EksEpsjonEl",
"exceptionnellement" => "EksEpsjonEl°m@",
"exceptionnelles" => "EksEpsjonEl",
"exceptionnels" => "EksEpsjonEl",
"exceptions" => "eksEpsj§",
"excès" => "EksE",
"excessif" => "Eksesif",
"excessifs" => "Eksesif",
"excessive" => "Eksesiv",
"excessivement" => "Eksesiv°m@",
"excessives" => "Eksesiv",
"excipent" => "Eksip",
"exciper" => "Eksipe",
"excisant" => "Eksiz@",
"excise" => "Eksiz",
"excisé" => "Eksize",
"excisée" => "Eksize",
"excisées" => "Eksize",
"exciser" => "Eksize",
"exciseuse" => "Eksiz2z",
"exciseuses" => "Eksiz2z",
"excision" => "Eksizj§",
"excita" => "Eksita",
"excitable" => "Eksitabl",
"excitaient" => "EksitE",
"excitais" => "EksitE",
"excitait" => "EksitE",
"excitant" => "Eksit@",
"excitante" => "Eksit@t",
"excitantes" => "Eksit@t",
"excitants" => "Eksit@",
"excitation" => "Eksitasj§",
"excitations" => "Eksitasj§",
"excite" => "Eksit",
"excité" => "Eksite",
"excitée" => "Eksite",
"excitées" => "Eksite",
"excitent" => "Eksit",
"exciter" => "Eksite",
"excitera" => "Eksit°Ra",
"exciterait" => "Eksit°RE",
"excitèrent" => "EksitER",
"exciterez" => "Eksit°Re",
"exciteriez" => "Eksit°Rje",
"exciteront" => "Eksit°R§",
"excites" => "Eksit",
"excités" => "Eksite",
"exciteur" => "Eksit9R",
"excitez" => "Eksite",
"excitions" => "Eksitj§",
"excitons" => "Eksit§",
"exclama" => "Eksklama",
"exclamai" => "EksklamE",
"exclamaient" => "EksklamE",
"exclamais" => "EksklamE",
"exclamait" => "EksklamE",
"exclamâmes" => "Eksklamam",
"exclamant" => "Eksklam@",
"exclamatif" => "Eksklamatif",
"exclamation" => "Eksklamasj§",
"exclamations" => "Eksklamasj§",
"exclamative" => "Eksklamativ",
"exclame" => "Eksklam",
"exclamé" => "Eksklame",
"exclamée" => "Eksklame",
"exclament" => "Eksklam",
"exclamer" => "Eksklame",
"exclameraient" => "Eksklam°RE",
"exclamerait" => "Eksklam°RE",
"exclamèrent" => "EksklamER",
"exclu" => "Ekskly",
"excluaient" => "EksklyE",
"excluais" => "EksklyE",
"excluait" => "EksklyE",
"excluant" => "Ekskly@",
"exclue" => "Ekskly",
"excluent" => "Ekskly",
"exclues" => "Ekskly",
"excluez" => "Eksklye",
"excluions" => "Eksklyj§",
"excluons" => "Ekskly§",
"exclura" => "EksklyRa",
"exclurais" => "EksklyRE",
"exclure" => "EksklyR",
"exclus" => "Ekskly",
"exclusif" => "Eksklyzif",
"exclusifs" => "Eksklyzif",
"exclusion" => "Eksklyzj§",
"exclusions" => "Eksklyzj§",
"exclusive" => "Eksklyziv",
"exclusivement" => "Eksklyziv°m@",
"exclusives" => "Eksklyziv",
"exclusivité" => "Eksklyzivite",
"exclusivités" => "Eksklyzivite",
"exclut" => "Ekskly",
"exclût" => "Ekskly",
"excommuniaient" => "EkskomynjE",
"excommuniait" => "EkskomynjE",
"excommuniant" => "Ekskomynj@",
"excommunication" => "Ekskomynikasj§",
"excommunications" => "Ekskomynikasj§",
"excommunie" => "Ekskomyni",
"excommunié" => "Ekskomynje",
"excommuniée" => "Ekskomynje",
"excommunient" => "Ekskomyni",
"excommunier" => "Ekskomynje",
"excommuniés" => "Ekskomynje",
"excommuniez" => "Ekskomynje",
"excoriée" => "EkskoRje",
"excoriées" => "EkskoRje",
"excrément" => "EkskRem@",
"excrémentiel" => "EkskRem@sjEl",
"excrémentielle" => "EkskRem@sjEl",
"excréments" => "EkskRem@",
"excrété" => "EkskRete",
"excréter" => "EkskRete",
"excrétera" => "EkskREt°Ra",
"excrétion" => "EkskResj§",
"excrétions" => "ekskResj§",
"excroissance" => "EkskRwas@s",
"excroissances" => "EkskRwas@s",
"excursion" => "EkskyRsj§",
"excursionnaient" => "EkskyRsjonE",
"excursionnant" => "EkskyRsijon@",
"excursionner" => "EkskyRsjone",
"excursionniste" => "EkskyRsjonist",
"excursionnistes" => "EkskyRsijonist",
"excursions" => "EkskyRsj§",
"excusa" => "Ekskyza",
"excusable" => "Ekskyzabl",
"excusables" => "Ekskyzabl",
"excusai" => "EkskyzE",
"excusaient" => "EkskyzE",
"excusais" => "EkskyzE",
"excusait" => "EkskyzE",
"excusâmes" => "Ekskyzam",
"excusant" => "Ekskyz@",
"excusât" => "Ekskyza",
"excuse" => "Ekskyz",
"excusé" => "Ekskyze",
"excusée" => "Ekskyze",
"excusées" => "Ekskyze",
"excusent" => "Ekskyz",
"excuser" => "Ekskyze",
"excusera" => "Ekskyz°Ra",
"excuserai" => "Ekskyz°RE",
"excuserais" => "Ekskyz°RE",
"excuserait" => "Ekskyz°RE",
"excuseras" => "Ekskyz°Ra",
"excusèrent" => "EkskyzER",
"excuserez" => "Ekskyz°Re",
"excuseriez" => "Ekskyz°Rje",
"excuserons" => "Ekskyz°R§",
"excuseront" => "Ekskyz°R§",
"excuses" => "Ekskyz",
"excusés" => "Ekskyze",
"excusez" => "Ekskyze",
"excusiez" => "Ekskyzje",
"excusions" => "Ekskyzj§",
"excusons" => "Ekskyz§",
"exeat" => "Egzeat",
"exécra" => "EgzekRa",
"exécrable" => "EgzekRabl",
"exécrables" => "EgzekRabl",
"exécrais" => "EgzekRE",
"exécrait" => "EgzekRE",
"exécration" => "EgzekRasj§",
"exécrations" => "EgzekRasj§",
"exècre" => "EgzEkR",
"exécré" => "EgzekRe",
"exécrée" => "EgzekRe",
"exécrées" => "EgzekRe",
"exècrent" => "EgzEkR",
"exécrer" => "EgzekRe",
"exécrés" => "EgzekRe",
"exécuta" => "Egzekyta",
"exécutai" => "EgzekytE",
"exécutaient" => "EgzekytE",
"exécutais" => "EgzekytE",
"exécutait" => "EgzekytE",
"exécutant" => "Egzekyt@",
"exécutants" => "Egzekyt@",
"exécute" => "Egzekyt",
"exécuté" => "Egzekyte",
"exécutée" => "Egzekyte",
"exécutées" => "Egzekyte",
"exécutent" => "Egzekyt",
"exécuter" => "Egzekyte",
"exécutera" => "Egzekyt°Ra",
"exécuterai" => "Egzekyt°RE",
"exécuteraient" => "Egzekyt°RE",
"exécuterais" => "Egzekyt°RE",
"exécuterait" => "Egzekyt°RE",
"exécuteras" => "Egzekyt°Ra",
"exécutèrent" => "EgzekytER",
"exécuterez" => "Egzekyt°Re",
"exécuteriez" => "Egzekyt°Rje",
"exécuterons" => "Egzekyt°R§",
"exécuteront" => "Egzekyt°R§",
"exécutes" => "Egzekyt",
"exécutés" => "Egzekyte",
"exécuteur" => "Egzekyt9R",
"exécuteurs" => "Egzekyt9R",
"exécutez" => "Egzekyte",
"exécutiez" => "Egzekytje",
"exécutif" => "Egzekytif",
"exécutifs" => "Egzekytif",
"exécution" => "Egzekysj§",
"exécutions" => "egzekysj§",
"exécutive" => "Egzekytiv",
"exécutoire" => "EgzekytwaR",
"exécutoires" => "EgzekytwaR",
"exécutons" => "Egzekyt§",
"exécutrice" => "EgzekytRis",
"exégèse" => "EgzeZEz",
"exégèses" => "EgzeZEz",
"exégète" => "EgzeZEt",
"exégètes" => "EgzeZEt",
"exemplaire" => "Egz@plER",
"exemplairement" => "Egz@plER°m@",
"exemplaires" => "Egz@plER",
"exemplarité" => "Egz@plaRite",
"exemple" => "Egz@pl",
"exemples" => "Egz@pl",
"exemplifier" => "Egz@plifje",
"exempt" => "Egz@",
"exempte" => "Egz@t",
"exempté" => "Egz@te",
"exemptée" => "Egz@te",
"exempter" => "Egz@te",
"exemptes" => "Egz@t",
"exemptés" => "Egz@te",
"exemptiez" => "Egz@ptje",
"exemption" => "Egz@psj§",
"exemptions" => "egz@psj§",
"exempts" => "Egz@t",
"exequatur" => "EgzekwatyR",
"exerça" => "EgzERsa",
"exerçai" => "EgzERsE",
"exerçaient" => "EgzERsE",
"exerçais" => "EgzERsE",
"exerçait" => "EgzERsE",
"exerçant" => "EgzERs@",
"exerçassent" => "EgzERsas",
"exerçât" => "EgzERsa",
"exerce" => "EgzERs",
"exercé" => "EgzERse",
"exercée" => "EgzERse",
"exercées" => "EgzERse",
"exercent" => "EgzERs",
"exercer" => "EgzERse",
"exercera" => "EgzERs°Ra",
"exercerai" => "EgzERs°RE",
"exerceraient" => "EgzERs°RE",
"exercerais" => "EgzERs°RE",
"exercerait" => "EgzERs°RE",
"exercèrent" => "EgzERsER",
"exercerez" => "EgzERs°Re",
"exercerons" => "EgzERs°R§",
"exerceront" => "EgzERs°R§",
"exerces" => "EgzERs",
"exercés" => "EgzERse",
"exercez" => "EgzERse",
"exercice" => "EgzERsis",
"exercices" => "EgzERsis",
"exerciez" => "EgzERsje",
"exerçons" => "EgzERs§",
"exergue" => "EgzERg",
"exfiltration" => "EksfiltRasj§",
"exfiltré" => "EksfiltRe",
"exfiltrer" => "EksfiltRe",
"exfoliant" => "Eksfolj@",
"exfoliée" => "Eksfolje",
"exfolier" => "EksfOlje",
"exfolions" => "Eksfolj§",
"exhala" => "Egzala",
"exhalaient" => "EgzalE",
"exhalaison" => "EgzalEz§",
"exhalaisons" => "EgzalEz§",
"exhalait" => "EgzalE",
"exhalâmes" => "Egzalam",
"exhalant" => "Egzal@",
"exhalât" => "Egzala",
"exhalation" => "Egzalasj§",
"exhale" => "Egzal",
"exhalé" => "Egzale",
"exhalée" => "Egzale",
"exhalent" => "Egzal",
"exhaler" => "Egzale",
"exhaleraient" => "Egzal°RE",
"exhaussait" => "EgzosE",
"exhausse" => "Egzos",
"exhaussé" => "Egzose",
"exhaussée" => "Egzose",
"exhaussement" => "Egzos°m@",
"exhausser" => "Egzose",
"exhaustif" => "Egzostif",
"exhaustifs" => "Egzostif",
"exhaustion" => "Egzostj§",
"exhaustive" => "Egzostiv",
"exhaustivement" => "Egzostiv°m@",
"exhaustivité" => "Egzostivite",
"exhiba" => "Egziba",
"exhibai" => "EgzibE",
"exhibaient" => "EgzibE",
"exhibais" => "EgzibE",
"exhibait" => "EgzibE",
"exhibant" => "Egzib@",
"exhibe" => "Egzib",
"exhibé" => "Egzibe",
"exhibée" => "Egzibe",
"exhibées" => "Egzibe",
"exhibent" => "Egzib",
"exhiber" => "Egzibe",
"exhibera" => "Egzib°Ra",
"exhiberait" => "Egzib°RE",
"exhiberas" => "Egzib°Ra",
"exhibés" => "Egzibe",
"exhibez" => "Egzibe",
"exhibions" => "Egzibj§",
"exhibition" => "Egzibisj§",
"exhibitionnisme" => "Egzibisjonizm",
"exhibitionniste" => "Egzibisjonist",
"exhibitionnistes" => "Egzibisjonist",
"exhibitions" => "Egzibisj§",
"exhorta" => "EgzORta",
"exhortai" => "EgzORtE",
"exhortaient" => "EgzORtE",
"exhortais" => "EgzORtE",
"exhortait" => "EgzORtE",
"exhortâmes" => "EgzORtam",
"exhortant" => "EgzORt@",
"exhortation" => "EgzORtasj§",
"exhortations" => "EgzORtasj§",
"exhorte" => "EgzORt",
"exhorté" => "EgzORte",
"exhortent" => "EgzORt",
"exhorter" => "EgzORte",
"exhortions" => "EgzORtj§",
"exhortons" => "EgzORt§",
"exhuma" => "Egzyma",
"exhumaient" => "EgzymE",
"exhumais" => "EgzymE",
"exhumait" => "EgzymE",
"exhumant" => "Egzym@",
"exhumation" => "Egzymasj§",
"exhume" => "Egzym",
"exhumé" => "Egzyme",
"exhumée" => "Egzyme",
"exhumées" => "Egzyme",
"exhumer" => "Egzyme",
"exhumera" => "Egzym°Ra",
"exhumeront" => "Egzym°R§",
"exhumés" => "Egzyme",
"exige" => "EgziZ",
"exigé" => "EgziZe",
"exigea" => "EgziZa",
"exigeai" => "EgziZE",
"exigeaient" => "EgziZE",
"exigeais" => "EgziZE",
"exigeait" => "EgziZE",
"exigeant" => "EgziZ@",
"exigeante" => "EgziZ@t",
"exigeantes" => "EgziZ@t",
"exigeants" => "EgziZ@",
"exigeassent" => "EgziZas",
"exigée" => "EgziZe",
"exigées" => "EgziZe",
"exigence" => "EgziZ@s",
"exigences" => "EgziZ@s",
"exigent" => "EgziZ",
"exigeons" => "EgziZ§",
"exiger" => "EgziZe",
"exigera" => "EgziZ°Ra",
"exigerai" => "EgziZ°RE",
"exigeraient" => "EgziZ°RE",
"exigerais" => "EgziZ°RE",
"exigerait" => "EgziZ°RE",
"exigèrent" => "EgziZER",
"exigerez" => "EgziZ°Re",
"exigeriez" => "EgziZ°Rje",
"exigerions" => "EgziZ°Rj§",
"exigerons" => "EgziZ°R§",
"exigeront" => "EgziZ°R§",
"exiges" => "EgziZ",
"exigés" => "EgziZe",
"exigez" => "EgziZe",
"exigible" => "EgziZibl",
"exigiez" => "EgziZje",
"exigu" => "Egzigy",
"exiguë" => "Egzigy",
"exiguës" => "Egzigy",
"exiguïté" => "Egzig8ite",
"exigus" => "Egzigy",
"exil" => "Egzil",
"exila" => "Egzila",
"exilaient" => "EgzilE",
"exilait" => "EgzilE",
"exilant" => "Egzil@",
"exilât" => "Egzila",
"exile" => "Egzil",
"exilé" => "Egzile",
"exilée" => "Egzile",
"exilées" => "Egzile",
"exilent" => "Egzil",
"exiler" => "Egzile",
"exiles" => "Egzil",
"exilés" => "Egzile",
"exilez" => "Egzile",
"exils" => "Egzil",
"exista" => "Egzista",
"existai" => "EgzistE",
"existaient" => "EgzistE",
"existais" => "EgzistE",
"existait" => "EgzistE",
"existant" => "Egzist@",
"existante" => "Egzist@t",
"existantes" => "Egzist@t",
"existants" => "Egzist@",
"existât" => "Egzista",
"existe" => "Egzist",
"existé" => "Egziste",
"existée" => "Egziste",
"existence" => "Egzist@s",
"existences" => "Egzist@s",
"existent" => "Egzist",
"existentialisme" => "Egzist@sjalizm",
"existentialiste" => "Egzist@sjalist",
"existentialistes" => "Egzist@sjalist",
"existentiel" => "Egzist@sjEl",
"existentielle" => "Egzist@sjEl",
"existentielles" => "Egzist@sjEl",
"exister" => "Egziste",
"existera" => "Egzist°Ra",
"existerai" => "Egzist°RE",
"existeraient" => "Egzist°RE",
"existerais" => "Egzist°RE",
"existerait" => "Egzist°RE",
"existeras" => "Egzist°Ra",
"existèrent" => "EgzistER",
"existeriez" => "Egzist°Rje",
"existerions" => "Egzist°Rj§",
"existerons" => "Egzist°R§",
"existeront" => "Egzist°R§",
"existes" => "Egzist",
"existés" => "Egziste",
"existez" => "Egziste",
"existiez" => "Egzistje",
"existions" => "Egzistj§",
"existons" => "Egzist§",
"exit" => "Egzit",
"exo" => "Ekso",
"exobiologie" => "EgzobjolOZi",
"exocet" => "EgzosE",
"exode" => "EgzOd",
"exodes" => "EgzOd",
"exogamie" => "Egzogami",
"exogamique" => "Egzogamik",
"exogène" => "EgzoZEn",
"exonérait" => "EgzoneRE",
"exonération" => "EgzoneRasj§",
"exonérées" => "EgzoneRe",
"exonérer" => "EgzoneRe",
"exonérera" => "EgzoneR°Ra",
"exophtalmique" => "EgzOftalmik",
"exorable" => "EgzoRabl",
"exorbitaient" => "EgzORbitE",
"exorbitait" => "EgzORbitE",
"exorbitant" => "EgzORbit@",
"exorbitante" => "EgzORbit@t",
"exorbitantes" => "EgzORbit@t",
"exorbitants" => "EgzORbit@",
"exorbité" => "EgzORbite",
"exorbitées" => "EgzORbite",
"exorbiter" => "EgzORbite",
"exorbités" => "EgzORbite",
"exorcisa" => "EgzORsiza",
"exorcisait" => "EgzORsizE",
"exorcisant" => "EgzoRsiz@",
"exorcise" => "EgzORsiz",
"exorcisé" => "EgzORsize",
"exorcisée" => "EgzORsize",
"exorcisées" => "EgzORsize",
"exorcisent" => "EgzORsiz",
"exorciser" => "EgzORsize",
"exorciserait" => "EgzORsiz°RE",
"exorcisés" => "EgzORsize",
"exorcisez" => "EgzORsize",
"exorcisions" => "EgzORsizj§",
"exorcisme" => "EgzORsizm",
"exorcismes" => "EgzORsizm",
"exorciste" => "EgzORsist",
"exorcistes" => "EgzORsist",
"exorde" => "EgzORd",
"exordes" => "EgzORd",
"exos" => "Ekso",
"exosphère" => "EgzosfER",
"exosquelette" => "Egzosk2lEt",
"exostose" => "Egzostoz",
"exostoses" => "Egzostoz",
"exothermique" => "EgzotERmik",
"exotique" => "Egzotik",
"exotiquement" => "Egzotik°m@",
"exotiques" => "Egzotik",
"exotisme" => "Egzotizm",
"expansé" => "Eksp@se",
"expansible" => "Eksp@sibl",
"expansif" => "Eksp@sif",
"expansifs" => "Eksp@sif",
"expansion" => "Eksp@sj§",
"expansionnisme" => "Eksp@sjonizm",
"expansionniste" => "Eksp@sjonist",
"expansionnistes" => "Eksp@sjonist",
"expansive" => "Eksp@siv",
"expansives" => "Eksp@siv",
"expatriait" => "EkspatRijE",
"expatriation" => "EkspatRijasj§",
"expatrié" => "EkspatRije",
"expatriée" => "EkspatRije",
"expatrier" => "EkspatRije",
"expatrièrent" => "EkspatRijER",
"expatriés" => "EkspatRije",
"expectatif" => "EkspEktatif",
"expectation" => "EkspEktasj§",
"expectative" => "EkspEktativ",
"expectatives" => "EkspEktativ",
"expectora" => "EkspEktoRa",
"expectorant" => "EkspEktoR@",
"expectoration" => "EkspEktoRasj§",
"expectoré" => "EkspEktoRe",
"expectorées" => "EkspEktoRe",
"expectorer" => "EkspEktoRe",
"expédia" => "Ekspedja",
"expédiai" => "EkspedjE",
"expédiaient" => "EkspedjE",
"expédiais" => "EkspedjE",
"expédiait" => "EkspedjE",
"expédiant" => "Ekspedj@",
"expédie" => "Ekspedi",
"expédié" => "Ekspedje",
"expédiée" => "Ekspedje",
"expédiées" => "Ekspedje",
"expédient" => "ekspedi",
"expédientes" => "Ekspedj@t",
"expédients" => "Ekspedj@",
"expédier" => "Ekspedje",
"expédiera" => "EkspediRa",
"expédierai" => "EkspediRE",
"expédierait" => "EkspediRE",
"expédieras" => "EkspediRa",
"expédieriez" => "EkspediRje",
"expédierons" => "EkspediR§",
"expédieront" => "EkspediR§",
"expédies" => "Ekspedi",
"expédiés" => "Ekspedje",
"expédiez" => "Ekspedje",
"expédions" => "Ekspedj§",
"expéditeur" => "Ekspedit9R",
"expéditeurs" => "Ekspedit9R",
"expéditif" => "Ekspeditif",
"expéditifs" => "Ekspeditif",
"expédition" => "Ekspedisj§",
"expéditionnaire" => "EkspedisjonER",
"expéditionnaires" => "EkspedisjonER",
"expéditions" => "Ekspedisj§",
"expéditive" => "Ekspeditiv",
"expéditives" => "Ekspeditiv",
"expéditrice" => "EkspeditRis",
"expérience" => "EkspeRj@s",
"expériences" => "EkspeRj@s",
"expérimenta" => "EkspeRim@ta",
"expérimentai" => "EkspeRim@tE",
"expérimentaient" => "EkspeRim@tE",
"expérimentais" => "EkspeRim@tE",
"expérimentait" => "EkspeRim@tE",
"expérimental" => "EkspeRim@tal",
"expérimentale" => "EkspeRim@tal",
"expérimentalement" => "EkspeRim@tal°m@",
"expérimentales" => "EkspeRim@tal",
"expérimentant" => "EkspeRim@t@",
"expérimentateur" => "EkspeRim@tat9R",
"expérimentation" => "EkspeRim@tasj§",
"expérimentations" => "EkspeRim@tasj§",
"expérimentaux" => "EkspeRim@to",
"expérimente" => "EkspeRim@t",
"expérimenté" => "EkspeRim@te",
"expérimentée" => "EkspeRim@te",
"expérimentées" => "EkspeRim@te",
"expérimentent" => "EkspeRim@t",
"expérimenter" => "EkspeRim@te",
"expérimenteras" => "EkspeRim@t°Ra",
"expérimentés" => "EkspeRim@te",
"expérimentez" => "EkspeRim@te",
"expérimentiez" => "EkspeRim@tje",
"expérimentons" => "EkspeRim@t§",
"expert" => "EkspER",
"expert-comptable" => "EkspERk§tabl",
"experte" => "EkspERt",
"expertement" => "EkspERt°m@",
"expertes" => "EkspERt",
"expertisaient" => "EkspERtizE",
"expertisait" => "EkspERtizE",
"expertisant" => "EkspERtiz@",
"expertise" => "EkspERtiz",
"expertiser" => "EkspERtize",
"expertises" => "EkspERtiz",
"experts" => "EkspER",
"expiaient" => "EkspjE",
"expiait" => "EkspjE",
"expiant" => "Ekspj@",
"expiation" => "Ekspjasj§",
"expiatoire" => "EkspjatwaR",
"expiatoires" => "EkspjatwaR",
"expiatrice" => "EkspjatRis",
"expie" => "Ekspi",
"expié" => "Ekspje",
"expiée" => "Ekspje",
"expier" => "Ekspje",
"expieras" => "EkspiRa",
"expiés" => "Ekspje",
"expira" => "EkspiRa",
"expirais" => "EkspiRE",
"expirait" => "EkspiRE",
"expirant" => "EkspiR@",
"expirante" => "EkspiR@t",
"expirantes" => "EkspiR@t",
"expiration" => "EkspiRasj§",
"expirations" => "EkspiRasj§",
"expire" => "EkspiR",
"expiré" => "EkspiRe",
"expirée" => "EkspiRe",
"expirent" => "EkspiR",
"expirer" => "EkspiRe",
"expirera" => "EkspiR°Ra",
"expirerait" => "EkspiR°RE",
"expirés" => "EkspiRe",
"expirez" => "EkspiRe",
"expirons" => "EkspiR§",
"explétif" => "Ekspletif",
"explétive" => "Ekspletiv",
"explicable" => "Eksplikabl",
"explicables" => "Eksplikabl",
"explicatif" => "Eksplikatif",
"explicatifs" => "Eksplikatif",
"explication" => "Eksplikasj§",
"explications" => "Eksplikasj§",
"explicative" => "Eksplikativ",
"explicatives" => "Eksplikativ",
"explicitant" => "Eksplisit@",
"explicite" => "Eksplisit",
"explicitement" => "Eksplisit°m@",
"expliciter" => "Eksplisite",
"explicites" => "Eksplisit",
"expliqua" => "Eksplika",
"expliquai" => "EksplikE",
"expliquaient" => "EksplikE",
"expliquais" => "EksplikE",
"expliquait" => "EksplikE",
"expliquâmes" => "Eksplikam",
"expliquant" => "Eksplik@",
"expliquât" => "Eksplika",
"explique" => "Eksplik",
"expliqué" => "Eksplike",
"expliquée" => "Eksplike",
"expliquées" => "Eksplike",
"expliquent" => "Eksplik",
"expliquer" => "Eksplike",
"expliquera" => "Eksplik°Ra",
"expliquerai" => "Eksplik°RE",
"expliqueraient" => "Eksplik°RE",
"expliquerais" => "Eksplik°RE",
"expliquerait" => "Eksplik°RE",
"expliqueras" => "Eksplik°Ra",
"expliquèrent" => "EksplikER",
"expliquerez" => "Eksplik°Re",
"expliqueriez" => "Eksplik°Rje",
"expliquerons" => "Eksplik°R§",
"expliqueront" => "Eksplik°R§",
"expliques" => "Eksplik",
"expliqués" => "Eksplike",
"expliquez" => "Eksplike",
"expliquiez" => "Eksplikje",
"expliquions" => "Eksplikj§",
"expliquons" => "Eksplik§",
"exploit" => "Eksplwa",
"exploita" => "Eksplwata",
"exploitable" => "Eksplwatabl",
"exploitables" => "Eksplwatabl",
"exploitai" => "EksplwatE",
"exploitaient" => "EksplwatE",
"exploitais" => "EksplwatE",
"exploitait" => "EksplwatE",
"exploitant" => "Eksplwat@",
"exploitante" => "Eksplwat@t",
"exploitants" => "Eksplwat@",
"exploitât" => "Eksplwata",
"exploitation" => "Eksplwatasj§",
"exploitations" => "Eksplwatasj§",
"exploite" => "Eksplwat",
"exploité" => "Eksplwate",
"exploitée" => "Eksplwate",
"exploitées" => "Eksplwate",
"exploitent" => "Eksplwat",
"exploiter" => "Eksplwate",
"exploitera" => "Eksplwat°Ra",
"exploiterais" => "Eksplwat°RE",
"exploiterait" => "Eksplwat°RE",
"exploitèrent" => "EksplwatER",
"exploiteront" => "Eksplwat°R§",
"exploites" => "Eksplwat",
"exploités" => "Eksplwate",
"exploiteur" => "Eksplwat9R",
"exploiteurs" => "Eksplwat9R",
"exploiteuses" => "Eksplwat2z",
"exploitez" => "Eksplwate",
"exploitions" => "Eksplwatj§",
"exploitons" => "Eksplwat§",
"exploits" => "Eksplwa",
"explora" => "EksploRa",
"explorai" => "EksploRE",
"exploraient" => "EksploRE",
"explorais" => "EksploRE",
"explorait" => "EksploRE",
"explorant" => "EksploR@",
"explorateur" => "EksploRat9R",
"explorateurs" => "EksploRat9R",
"exploration" => "EksploRasj§",
"explorations" => "EksploRasj§",
"exploratoire" => "EksploRatwaR",
"exploratoires" => "EksploRatwaR",
"exploratrice" => "EksploRatRis",
"exploratrices" => "EksploRatRis",
"explore" => "EksplOR",
"exploré" => "EksploRe",
"explorée" => "EksploRe",
"explorées" => "EksploRe",
"explorent" => "EksplOR",
"explorer" => "EksploRe",
"explorera" => "EksplOR°Ra",
"explorerai" => "EksplOR°RE",
"explorèrent" => "EksploRER",
"explorerez" => "EksplOR°Re",
"explorerons" => "EksplOR°R§",
"explorés" => "EksploRe",
"exploreur" => "EksploR9R",
"explorez" => "EksploRe",
"explorions" => "EksploRj§",
"explorons" => "EksploR§",
"explosa" => "Eksploza",
"explosai" => "EksplozE",
"explosaient" => "EksplozE",
"explosais" => "EksplozE",
"explosait" => "EksplozE",
"explosant" => "Eksploz@",
"explosât" => "Eksploza",
"explose" => "Eksploz",
"explosé" => "Eksploze",
"explosée" => "Eksploze",
"explosées" => "Eksploze",
"explosent" => "Eksploz",
"exploser" => "Eksploze",
"explosera" => "Eksploz°Ra",
"exploserai" => "Eksploz°RE",
"exploseraient" => "Eksploz°RE",
"exploserais" => "Eksploz°RE",
"exploserait" => "Eksploz°RE",
"exploseras" => "Eksploz°Ra",
"explosèrent" => "EksplozER",
"exploserez" => "Eksploz°Re",
"exploseront" => "Eksploz°R§",
"exploses" => "Eksploz",
"explosés" => "Eksploze",
"exploseur" => "Eksploz9R",
"explosez" => "Eksploze",
"explosif" => "Eksplozif",
"explosifs" => "Eksplozif",
"explosion" => "Eksplozj§",
"explosions" => "Eksplozj§",
"explosive" => "Eksploziv",
"explosives" => "Eksploziv",
"explosons" => "Eksploz§",
"expo" => "Ekspo",
"exponentiel" => "Ekspon@sjEl",
"exponentielle" => "Ekspon@sjEl",
"exponentiellement" => "Ekspon@sjEl°m@",
"exponentielles" => "Ekspon@sjEl",
"export" => "EkspOR",
"exporta" => "EkspORta",
"exportaient" => "EkspORtE",
"exportant" => "EkspORt@",
"exportateur" => "EkspORtat9R",
"exportateurs" => "EkspORtat9R",
"exportation" => "EkspORtasj§",
"exportations" => "EkspORtasj§",
"exporte" => "EkspORt",
"exporté" => "EkspORte",
"exportée" => "EkspORte",
"exportées" => "EkspORte",
"exporter" => "EkspORte",
"exportera" => "EkspORt°Ra",
"exporterons" => "EkspORt°R§",
"exportés" => "EkspORte",
"exportez" => "EkspORte",
"exports" => "EkspOR",
"expos" => "Ekspo",
"exposa" => "Ekspoza",
"exposai" => "EkspozE",
"exposaient" => "EkspozE",
"exposais" => "EkspozE",
"exposait" => "EkspozE",
"exposâmes" => "Ekspozam",
"exposant" => "Ekspoz@",
"expose" => "Ekspoz",
"exposé" => "Ekspoze",
"exposée" => "Ekspoze",
"exposées" => "Ekspoze",
"exposent" => "Ekspoz",
"exposer" => "Ekspoze",
"exposera" => "Ekspoz°Ra",
"exposerai" => "Ekspoz°RE",
"exposerais" => "Ekspoz°RE",
"exposerait" => "Ekspoz°RE",
"exposèrent" => "EkspozER",
"exposerez" => "Ekspoz°Re",
"exposerions" => "Ekspoz°Rj§",
"exposeront" => "Ekspoz°R§",
"exposes" => "Ekspoz",
"exposés" => "Ekspoze",
"exposez" => "Ekspoze",
"exposiez" => "Ekspozje",
"exposition" => "Ekspozisj§",
"expositions" => "Ekspozisj§",
"exposons" => "Ekspoz§",
"exprès" => "EkspRE",
"express" => "EkspREs",
"expresse" => "EkspREs",
"expressément" => "EkspREsem@",
"expresses" => "EkspREs",
"expressif" => "EkspResif",
"expressifs" => "EkspResif",
"expression" => "EkspREsj§",
"expressionnisme" => "EkspREsjonizm",
"expressionniste" => "EkspREsjonist",
"expressionnistes" => "EkspREsjonist",
"expressions" => "EkspResj§",
"expressive" => "EkspResiv",
"expressivement" => "EkspResiv°m@",
"expressives" => "EkspResiv",
"exprima" => "EkspRima",
"exprimable" => "EkspRimabl",
"exprimai" => "EkspRimE",
"exprimaient" => "EkspRimE",
"exprimais" => "EkspRimE",
"exprimait" => "EkspRimE",
"exprimant" => "EkspRim@",
"exprimât" => "EkspRima",
"exprime" => "EkspRim",
"exprimé" => "EkspRime",
"exprimée" => "EkspRime",
"exprimées" => "EkspRime",
"expriment" => "EkspRim",
"exprimer" => "EkspRime",
"exprimera" => "EkspRim°Ra",
"exprimerai" => "EkspRim°RE",
"exprimerais" => "EkspRim°RE",
"exprimerait" => "EkspRim°RE",
"exprimeras" => "EkspRim°Ra",
"exprimèrent" => "EkspRimER",
"exprimerez" => "EkspRim°Re",
"exprimeront" => "EkspRim°R§",
"exprimes" => "EkspRim",
"exprimés" => "EkspRime",
"exprimez" => "EkspRime",
"exprimiez" => "EkspRimje",
"exprimions" => "EkspRimj§",
"exprimons" => "EkspRim§",
"expropria" => "EkspRopRia",
"expropriation" => "EkspRopRijasj§",
"expropriations" => "EkspRopRijasj§",
"exproprie" => "EkspRopRi",
"exproprié" => "EkspRopRije",
"expropriée" => "EkspRopRije",
"expropriées" => "EkspRopRije",
"exproprier" => "EkspRopRije",
"exproprierait" => "EkspRopRiRE",
"expropriés" => "EkspRopRije",
"expulsa" => "Ekspylsa",
"expulsai" => "EkspylsE",
"expulsaient" => "EkspylsE",
"expulsais" => "EkspylsE",
"expulsait" => "EkspylsE",
"expulsant" => "Ekspyls@",
"expulsât" => "Ekspylsa",
"expulse" => "Ekspyls",
"expulsé" => "Ekspylse",
"expulsée" => "Ekspylse",
"expulsées" => "Ekspylse",
"expulsent" => "Ekspyls",
"expulser" => "Ekspylse",
"expulsera" => "Ekspyls°Ra",
"expulserai" => "Ekspyls°RE",
"expulserait" => "Ekspyls°RE",
"expulseront" => "Ekspyls°R§",
"expulsés" => "Ekspylse",
"expulsez" => "Ekspylse",
"expulsion" => "Ekspylsj§",
"expulsions" => "Ekspylsj§",
"expulsive" => "Ekspylsiv",
"expulsons" => "Ekspyls§",
"expurgé" => "EkspyRZe",
"expurgeait" => "EkspyRZE",
"expurgée" => "EkspyRZe",
"expurger" => "EkspyRZe",
"expurgera" => "EkspyRZ°Ra",
"expurgés" => "EkspyRZe",
"exquis" => "Ekski",
"exquise" => "Ekskiz",
"exquises" => "Ekskiz",
"exsangue" => "Eks@g",
"exsangues" => "Eks@g",
"exsudaient" => "EksydE",
"exsudait" => "EksydE",
"exsudant" => "Eksyd@",
"exsudat" => "Eksyda",
"exsudation" => "Eksydasj§",
"exsude" => "Eksyd",
"exsudé" => "Eksyde",
"exsuder" => "Eksyde",
"extase" => "Ekstaz",
"extases" => "Ekstaz",
"extasia" => "Ekstazja",
"extasiaient" => "EkstazjE",
"extasiais" => "EkstazjE",
"extasiait" => "EkstazjE",
"extasiant" => "Ekstazj@",
"extasiantes" => "Ekstazij@t",
"extasiât" => "Ekstazja",
"extasie" => "Ekstazi",
"extasié" => "Ekstazje",
"extasiée" => "Ekstazje",
"extasiées" => "Ekstazje",
"extasient" => "Ekstazi",
"extasier" => "Ekstazje",
"extasièrent" => "EkstazjER",
"extasieront" => "EkstaziR§",
"extasiés" => "Ekstazje",
"extasiez" => "Ekstazje",
"extasions" => "Ekstazj§",
"extatique" => "Ekstatik",
"extatiquement" => "Ekstatik°m@",
"extatiques" => "Ekstatik",
"extenseur" => "Ekst@s9R",
"extenseurs" => "Ekst@s9R",
"extensible" => "Ekst@sibl",
"extensibles" => "Ekst@sibl",
"extension" => "Ekst@sj§",
"extensions" => "Ekst@sj§",
"extensive" => "Ekst@siv",
"exténua" => "Eksten8a",
"exténuait" => "Eksten8E",
"exténuant" => "Eksten8@",
"exténuante" => "Eksten8@t",
"exténuantes" => "Eksten8@t",
"exténuants" => "Eksten8@",
"exténuation" => "Eksten8asj§",
"exténue" => "Eksteny",
"exténué" => "Eksten8e",
"exténuée" => "Eksten8e",
"exténuées" => "Eksten8e",
"exténuement" => "Ekstenym@",
"exténuent" => "Eksteny",
"exténuer" => "Eksten8e",
"exténuerait" => "EkstenyRE",
"exténués" => "Eksten8e",
"extérieur" => "EksteRj9R",
"extérieure" => "EksteRj9R",
"extérieurement" => "EksteRj9R°m@",
"extérieures" => "EksteRj9R",
"extérieurs" => "EksteRj9R",
"extériorisa" => "EksteRjoRiza",
"extériorisaient" => "EksteRjoRizE",
"extériorisait" => "EksteRjoRizE",
"extériorisation" => "EksteRjoRizasj§",
"extériorise" => "EksteRjoRiz",
"extériorisé" => "EksteRjoRize",
"extérioriser" => "EksteRjoRize",
"extériorisés" => "EksteRjoRize",
"extériorisez" => "EksteRjoRize",
"extériorité" => "EksteRjoRite",
"extermina" => "EkstERmina",
"exterminaient" => "EkstERminE",
"exterminais" => "EkstERminE",
"exterminait" => "EkstERminE",
"exterminant" => "EkstERmin@",
"exterminateur" => "EkstERminat9R",
"exterminateurs" => "EkstERminat9R",
"extermination" => "EkstERminasj§",
"exterminations" => "EkstERminasj§",
"exterminatrice" => "EkstERminat°Ris",
"exterminatrices" => "EkstERminat°Ris",
"extermine" => "EkstERmin",
"exterminé" => "EkstERmine",
"exterminée" => "EkstERmine",
"exterminées" => "EkstERmine",
"exterminent" => "EkstERmin",
"exterminer" => "EkstERmine",
"exterminera" => "EkstERmin°Ra",
"exterminerait" => "EkstERmin°RE",
"exterminerons" => "EkstERmin°R§",
"extermineront" => "EkstERmin°R§",
"exterminés" => "EkstERmine",
"exterminez" => "EkstERmine",
"exterminions" => "EkstERminj§",
"exterminons" => "EkstERmin§",
"externalité" => "EkstERnalite",
"externat" => "EkstERna",
"externe" => "EkstERn",
"externes" => "EkstERn",
"exterritorialité" => "EkstERitoRjalite",
"extincteur" => "Ekst5kt9R",
"extincteurs" => "Ekst5kt9R",
"extinction" => "Ekst5ksj§",
"extinctrice" => "Ekst5ktRis",
"extirpa" => "EkstiRpa",
"extirpaient" => "EkstiRpE",
"extirpais" => "EkstiRpE",
"extirpait" => "EkstiRpE",
"extirpant" => "EkstiRp@",
"extirpation" => "EkstiRpasj§",
"extirpe" => "EkstiRp",
"extirpé" => "EkstiRpe",
"extirpée" => "EkstiRpe",
"extirpées" => "EkstiRpe",
"extirpent" => "EkstiRp",
"extirper" => "EkstiRpe",
"extirpera" => "EkstiRp°Ra",
"extirperai" => "EkstiRp°RE",
"extirperais" => "EkstiRp°RE",
"extirperait" => "EkstiRp°RE",
"extirpés" => "EkstiRpe",
"extorquai" => "EkstORkE",
"extorquais" => "EkstORkE",
"extorquait" => "EkstORkE",
"extorque" => "EkstORk",
"extorqué" => "EkstORke",
"extorquée" => "EkstORke",
"extorquées" => "EkstORke",
"extorquent" => "EkstORk",
"extorquer" => "EkstORke",
"extorquèrent" => "EkstORkER",
"extorqués" => "EkstORke",
"extorqueur" => "EkstORk9R",
"extorquez" => "EkstORke",
"extorsion" => "EkstORsj§",
"extorsions" => "EkstORsj§",
"extra" => "EkstRa",
"extra-dry" => "EkstRadRaj",
"extra-fin" => "EkstRaf5",
"extra-fins" => "EkstRaf5",
"extra-fort" => "EkstRafOR",
"extra-forte" => "EkstRafORt",
"extra-lucide" => "EkstRalysid",
"extra-lucides" => "EkstRalysid",
"extra-muros" => "EkstRamyRo",
"extra-sensoriel" => "EkstRas@soRjEl",
"extra-sensorielle" => "EkstRas@soRjEl",
"extra-souples" => "EkstRasupl",
"extra-terrestre" => "EkstRatEREstR",
"extra-terrestres" => "EkstRatEREstR",
"extra-utérin" => "EkstRayteR5",
"extra-utérine" => "EkstRayteRin",
"extraconjugal" => "EkstRak§Zygal",
"extraconjugale" => "EkstRak§Zygal",
"extraconjugales" => "EkstRak§Zygal",
"extraconjugaux" => "EkstRak§Zygo",
"extracorporelle" => "EkstRakORpOREl",
"extracteur" => "EkstRakt9R",
"extracteurs" => "EkstRakt9R",
"extraction" => "EkstRaksj§",
"extractions" => "EkstRaksj§",
"extractive" => "EkstRaktiv",
"extradaient" => "EkstRadE",
"extrade" => "EkstRad",
"extradé" => "EkstRade",
"extradée" => "EkstRade",
"extrader" => "EkstRade",
"extradition" => "EkstRadisj§",
"extraforte" => "EkstRafORt",
"extragalactique" => "EkstRagalaktik",
"extraient" => "EkstRE",
"extraira" => "EkstRERa",
"extrairai" => "EkstRERE",
"extraire" => "EkstRER",
"extrairons" => "EkstRER§",
"extrairont" => "EkstRER§",
"extrais" => "EkstRE",
"extrait" => "EkstRE",
"extraite" => "EkstREt",
"extraites" => "EkstREt",
"extraits" => "EkstRE",
"extralucide" => "EkstRalysid",
"extralucides" => "EkstRalysid",
"extraordinaire" => "EkstRaORdinER",
"extraordinairement" => "EkstRaORdinER°m@",
"extraordinaires" => "EkstRaORdinER",
"extrapolant" => "EkstRapol@",
"extrapolation" => "EkstRapolasj§",
"extrapolations" => "EkstRapolasj§",
"extrapole" => "EkstRapOl",
"extrapolé" => "EkstRapole",
"extrapolée" => "EkstRapole",
"extrapolées" => "EkstRapole",
"extrapolent" => "EkstRapOl",
"extrapoler" => "EkstRapole",
"extrapolez" => "EkstRapole",
"extrapolons" => "EkstRapol§",
"extras" => "EkstRa",
"extrascolaire" => "EkstRaskOlER",
"extrascolaires" => "EkstRaskolER",
"extrasensoriel" => "EkstRas@soRjEl",
"extrasensorielle" => "EkstRas@soRjEl",
"extrasensoriels" => "EkstRas@soRjEl",
"extrasystole" => "EkstRasistOl",
"extraterrestre" => "EkstRatEREst°R",
"extraterrestres" => "EkstRatEREst°R",
"extraterritoriale" => "Ekst°RatERitORjal",
"extravagance" => "EkstRavag@s",
"extravagances" => "EkstRavag@s",
"extravagant" => "EkstRavag@",
"extravagante" => "EkstRavag@t",
"extravagantes" => "EkstRavag@t",
"extravagants" => "EkstRavag@",
"extravaguait" => "EkstRavagE",
"extravague" => "EkstRavag",
"extravagué" => "EkstRavage",
"extravaguer" => "EkstRavage",
"extravasation" => "EkstRavazasj§",
"extravéhiculaire" => "EkstRaveikylER",
"extraverti" => "EkstRavERti",
"extravertie" => "EkstRavERti",
"extrayaient" => "EkstRajE",
"extrayait" => "EkstRajE",
"extrayant" => "EkstRaj@",
"extrayez" => "EkstREje",
"extrayions" => "EkstREj§",
"extrême" => "EkstREm",
"extrême-onction" => "EkstREm§ksj§",
"extrême-orient" => "EkstREmORj@",
"extrême-orientale" => "EkstREmoRj@tal",
"extrêmement" => "EkstREm°m@",
"extrêmes" => "EkstREm",
"extrêmes-onctions" => "EkstREm§ksj§",
"extrémisme" => "EkstRemizm",
"extrémiste" => "EkstRemist",
"extrémistes" => "EkstRemist",
"extrémité" => "EkstRemite",
"extrémités" => "EkstRemite",
"extroverti" => "EkstROvERti",
"extrovertie" => "EkstROvERti",
"extrusion" => "EkstRyzj§",
"exubérance" => "EgzybeR@s",
"exubérances" => "EgzybeR@s",
"exubérant" => "EgzybeR@",
"exubérante" => "EgzybeR@t",
"exubérantes" => "EgzybeR@t",
"exubérants" => "EgzybeR@",
"exulta" => "Egzylta",
"exultai" => "EgzyltE",
"exultaient" => "EgzyltE",
"exultais" => "EgzyltE",
"exultait" => "EgzyltE",
"exultant" => "Egzylt@",
"exultante" => "Egzylt@t",
"exultantes" => "Egzylt@t",
"exultants" => "Egzylt@",
"exultation" => "Egzyltasj§",
"exulte" => "Egzylt",
"exultent" => "Egzylt",
"exulter" => "Egzylte",
"exultèrent" => "EgzyltER",
"exultons" => "Egzylt§",
"exutoire" => "EgzytwaR",
"exutoires" => "EgzytwaR",
"eye-liner" => "ajlajn9R",
"eyeliner" => "ajlajn9R",
"f" => "Ef",
"fa" => "fa",
"fabiens" => "fabj5",
"fable" => "fabl",
"fables" => "fabl",
"fabliau" => "fablijo",
"fabliaux" => "fablijo",
"fabricant" => "fabRik@",
"fabricante" => "fabRik@t",
"fabricantes" => "fabRik@t",
"fabricants" => "fabRik@",
"fabrication" => "fabRikasj§",
"fabrications" => "fabRikasj§",
"fabriqua" => "fabRika",
"fabriquai" => "fabRikE",
"fabriquaient" => "fabRikE",
"fabriquais" => "fabRikE",
"fabriquait" => "fabRikE",
"fabriquant" => "fabRik@",
"fabrique" => "fabRik",
"fabriqué" => "fabRike",
"fabriquée" => "fabRike",
"fabriquées" => "fabRike",
"fabriquent" => "fabRik",
"fabriquer" => "fabRike",
"fabriquera" => "fabRik°Ra",
"fabriquerai" => "fabRik°RE",
"fabriquerais" => "fabRik°RE",
"fabriquerait" => "fabRik°RE",
"fabriquèrent" => "fabRikER",
"fabriquerez" => "fabRik°Re",
"fabriquerons" => "fabRik°R§",
"fabriqueront" => "fabRik°R§",
"fabriques" => "fabRik",
"fabriqués" => "fabRike",
"fabriquez" => "fabRike",
"fabriquiez" => "fabRikje",
"fabriquions" => "fabRikj§",
"fabriquons" => "fabRik§",
"fabulateur" => "fabylat9R",
"fabulation" => "fabylasj§",
"fabulations" => "fabylasj§",
"fabulatrice" => "fabylatRis",
"fabule" => "fabyl",
"fabulé" => "fabyle",
"fabuler" => "fabyle",
"fabuleuse" => "fabyl2z",
"fabuleusement" => "fabyl2z°m@",
"fabuleuses" => "fabyl2z",
"fabuleux" => "fabyl2",
"fabulez" => "fabyle",
"fabuliste" => "fabylist",
"fac" => "fak",
"fac-similé" => "faksimile",
"fac-similés" => "faksimile",
"façade" => "fasad",
"façades" => "fasad",
"face" => "fas",
"face-à-face" => "fasafas",
"face-à-main" => "fasam5",
"faces" => "fas",
"faces-à-main" => "fasam5",
"facétie" => "fasesi",
"facéties" => "fasesi",
"facétieuse" => "fasesj2z",
"facétieusement" => "fasesj2z°m@",
"facétieuses" => "fasesj2z",
"facétieux" => "fasesj2",
"facette" => "fasEt",
"facettes" => "fasEt",
"facettés" => "fasEte",
"fâcha" => "faSa",
"fâchai" => "faSE",
"fâchaient" => "faSE",
"fâchais" => "faSE",
"fâchait" => "faSE",
"fâche" => "faS",
"fâché" => "faSe",
"fâchée" => "faSe",
"fâchées" => "faSe",
"fâchent" => "faS",
"fâcher" => "faSe",
"fâchera" => "faS°Ra",
"fâcherai" => "faS°RE",
"fâcherais" => "faS°RE",
"fâcherait" => "faS°RE",
"fâcheras" => "faS°Ra",
"fâchèrent" => "faSER",
"fâcherie" => "faS°Ri",
"fâcheries" => "faS°Ri",
"fâcheront" => "faS°R§",
"fâches" => "faS",
"fâchés" => "faSe",
"fâcheuse" => "faS2z",
"fâcheusement" => "faS2z°m@",
"fâcheuses" => "faS2z",
"fâcheux" => "faS2",
"fâchez" => "faSe",
"fâchiez" => "faSje",
"fâchions" => "faSj§",
"facho" => "faSo",
"fâchons" => "faS§",
"fachos" => "faSo",
"facial" => "fasjal",
"faciale" => "fasjal",
"faciales" => "fasjal",
"faciaux" => "fasjo",
"faciès" => "fasjEs",
"facile" => "fasil",
"facilement" => "fasil°m@",
"faciles" => "fasil",
"facilita" => "fasilita",
"facilitaient" => "fasilitE",
"facilitait" => "fasilitE",
"facilitant" => "fasilit@",
"facilitateur" => "fasilitat9R",
"facilitation" => "fasilitasj§",
"facilite" => "fasilit",
"facilité" => "fasilite",
"facilitée" => "fasilite",
"facilitées" => "fasilite",
"facilitent" => "fasilit",
"faciliter" => "fasilite",
"facilitera" => "fasilit°Ra",
"faciliterai" => "fasilit°RE",
"faciliteraient" => "fasilit°RE",
"faciliterais" => "fasilit°RE",
"faciliterait" => "fasilit°RE",
"faciliteront" => "fasilit°R§",
"facilités" => "fasilite",
"facilitez" => "fasilite",
"facilitons" => "fasilit§",
"façon" => "fas§",
"faconde" => "fak§d",
"façonna" => "fasona",
"façonnable" => "fasOnabl",
"façonnaient" => "fasonE",
"façonnait" => "fasonE",
"façonnant" => "fason@",
"façonne" => "fasOn",
"façonné" => "fasone",
"façonnée" => "fasone",
"façonnées" => "fasone",
"façonnent" => "fasOn",
"façonner" => "fasone",
"façonnera" => "fasOn°Ra",
"façonnerai" => "fasOn°RE",
"façonnerais" => "fasOn°RE",
"façonnerez" => "fasOn°Re",
"façonneront" => "fasOn°R§",
"façonnés" => "fasone",
"façonnière" => "fasonjER",
"façons" => "fas§",
"facs" => "fak",
"facteur" => "fakt9R",
"facteurs" => "fakt9R",
"factice" => "faktis",
"factices" => "faktis",
"factieux" => "faksj2",
"faction" => "faksj§",
"factionnaire" => "faksjonER",
"factionnaires" => "faksjonER",
"factions" => "faksj§",
"factor" => "faktOR",
"factorielle" => "faktoRjEl",
"factorielles" => "faktoRjEl",
"factorisation" => "faktoRizasj§",
"factoriser" => "faktORize",
"factotum" => "faktotOm",
"factotums" => "faktotOm",
"factrice" => "faktRis",
"factuel" => "faktyEl",
"factuelles" => "fakt8El",
"factuels" => "faktyEl",
"factum" => "faktOm",
"factums" => "faktOm",
"facturation" => "faktyRasj§",
"facture" => "faktyR",
"facturé" => "faktyRe",
"facturée" => "faktyRe",
"facturées" => "faktyRe",
"facturent" => "faktyR",
"facturer" => "faktyRe",
"facturera" => "faktyR°Ra",
"facturerait" => "faktyR°RE",
"factures" => "faktyR",
"facturés" => "faktyRe",
"facturette" => "faktyREt",
"facturez" => "faktyRe",
"facturier" => "faktyRje",
"facturière" => "faktyRjER",
"facturons" => "faktyR§",
"facultatif" => "fakyltatif",
"facultatifs" => "fakyltatif",
"facultative" => "fakyltativ",
"faculté" => "fakylte",
"facultés" => "fakylte",
"fada" => "fada",
"fadaise" => "fadEz",
"fadaises" => "fadEz",
"fadas" => "fada",
"fadasse" => "fadas",
"fadasses" => "fadas",
"fade" => "fad",
"fadé" => "fade",
"fadée" => "fade",
"fadement" => "fad°m@",
"fadent" => "fad",
"fader" => "fade",
"faderas" => "fad°Ra",
"fades" => "fad",
"fadés" => "fade",
"fadette" => "fadEt",
"fadeur" => "fad9R",
"fadeurs" => "fad9R",
"fading" => "fEjdiG",
"fado" => "fado",
"faena" => "fena",
"faf" => "faf",
"fafiot" => "fafjo",
"fafiots" => "fafjo",
"fafs" => "faf",
"fagne" => "faN",
"fagnes" => "faN",
"fagot" => "fago",
"fagotage" => "fagotaZ",
"fagotait" => "fagotE",
"fagotant" => "fagot@",
"fagote" => "fagOt",
"fagoté" => "fagote",
"fagotée" => "fagote",
"fagotées" => "fagote",
"fagoter" => "fagote",
"fagotés" => "fagote",
"fagotiers" => "fagotje",
"fagotin" => "fagot5",
"fagotins" => "fagot5",
"fagots" => "fago",
"fahrenheit" => "faREnajt",
"faiblard" => "fEblaR",
"faiblarde" => "fEblaRd",
"faiblards" => "fEblaR",
"faible" => "fEbl",
"faiblement" => "fEbl°m@",
"faibles" => "fEbl",
"faiblesse" => "fEblEs",
"faiblesses" => "fEblEs",
"faibli" => "fEbli",
"faiblir" => "febliR",
"faiblira" => "fEbliRa",
"faiblirent" => "fEbliR",
"faiblis" => "fEbli",
"faiblissaient" => "fEblisE",
"faiblissais" => "fEblisE",
"faiblissait" => "fEblisE",
"faiblissant" => "fEblis@",
"faiblissante" => "fEblis@t",
"faiblissantes" => "fEblis@t",
"faiblisse" => "fEblis",
"faiblissent" => "fEblis",
"faiblissez" => "fEblise",
"faiblissions" => "fEblisj§",
"faiblit" => "fEbli",
"faiblît" => "fEbli",
"faïence" => "faj@s",
"faïencerie" => "faj@s°Ri",
"faïences" => "faj@s",
"faïencier" => "faj@sje",
"faïenciers" => "faj@sje",
"faignant" => "fEN@",
"faignante" => "fEN@t",
"faignants" => "fEN@",
"faillait" => "fajE",
"faille" => "faj",
"failles" => "faj",
"failli" => "faji",
"faillibilité" => "fajibilite",
"faillibilités" => "fajibilite",
"faillible" => "fajibl",
"faillibles" => "fajibl",
"faillie" => "faji",
"faillies" => "faji",
"faillîmes" => "fajim",
"faillir" => "fajiR",
"faillirai" => "fajiRE",
"faillirent" => "fajiR",
"faillis" => "faji",
"faillit" => "faji",
"faillite" => "fajit",
"faillites" => "fajit",
"faim" => "f5",
"faims" => "f5",
"faine" => "fEn",
"fainéant" => "fene@",
"fainéantais" => "fene@tE",
"fainéantant" => "fene@t@",
"fainéante" => "fene@t",
"fainéanter" => "fene@te",
"fainéantes" => "fEne@t",
"fainéantise" => "fene@tiz",
"fainéants" => "fene@",
"faînes" => "fEn",
"fair-play" => "fERplE",
"faire" => "fER",
"faire-part" => "fERpaR",
"faire-valoir" => "fERvalwaR",
"fais" => "fE",
"faisabilité" => "f°zabilite",
"faisable" => "f°zabl",
"faisaient" => "f°zE",
"faisais" => "f°zE",
"faisait" => "f°zE",
"faisan" => "f2z@",
"faisandé" => "f°z@de",
"faisandée" => "f°z@de",
"faisandées" => "f°z@de",
"faisander" => "f°z@de",
"faisanderie" => "f°z@d°Ri",
"faisandés" => "f°z@de",
"faisane" => "f°zan",
"faisans" => "f°z@",
"faisant" => "f°z@",
"faisceau" => "fEso",
"faisceaux" => "fEso",
"faiseur" => "f°z9R",
"faiseurs" => "f°z9R",
"faiseuse" => "f°z2z",
"faiseuses" => "f°z2z",
"faisiez" => "f°zje",
"faisions" => "f°zj§",
"faisons" => "f°z§",
"fait" => "fE",
"fait-divers" => "fEdivER",
"fait-tout" => "fEtu",
"faîtage" => "fEtaZ",
"faîtages" => "fEtaZ",
"faite" => "fEt",
"faîte" => "fEt",
"faites" => "fEt",
"faîtes-la-moi" => "fEtlamwa",
"faîtière" => "fEtjER",
"faîtières" => "fEsjER",
"faitout" => "fEtu",
"faitouts" => "fEtu",
"faits" => "fE",
"faits-divers" => "fEdivER",
"faix" => "fE",
"fakir" => "fakiR",
"fakirs" => "fakiR",
"falaise" => "falEz",
"falaises" => "falEz",
"falbala" => "falbala",
"falbalas" => "falbala",
"falciforme" => "falsifORm",
"falerne" => "falERn",
"fallacieuse" => "falasj2z",
"fallacieusement" => "falasj2z°m@",
"fallacieuses" => "falasj2z",
"fallacieux" => "falasj2",
"fallait" => "falE",
"falloir" => "falwaR",
"fallu" => "faly",
"fallut" => "faly",
"fallût" => "faly",
"falot" => "falo",
"falote" => "falOt",
"falotes" => "falOt",
"falots" => "falo",
"falsifiaient" => "falsifjE",
"falsifiais" => "falsifjE",
"falsifiait" => "falsifjE",
"falsifiant" => "falsifj@",
"falsification" => "falsifikasj§",
"falsifié" => "falsifje",
"falsifiée" => "falsifje",
"falsifiées" => "falsifje",
"falsifient" => "falsifi",
"falsifier" => "falsifje",
"falsifiés" => "falsifje",
"falsifiez" => "falsifje",
"faluche" => "falyS",
"falzar" => "falzaR",
"falzars" => "falzaR",
"famé" => "fame",
"famée" => "fame",
"famées" => "fame",
"famélique" => "famelik",
"faméliques" => "famelik",
"famés" => "fame",
"fameuse" => "fam2z",
"fameusement" => "fam2z°m@",
"fameuses" => "fam2z",
"fameux" => "fam2",
"familial" => "familjal",
"familiale" => "familjal",
"familiales" => "familjal",
"familialiste" => "familjalist",
"familiarisa" => "familjaRiza",
"familiarisaient" => "familjaRizE",
"familiarisais" => "familjaRizE",
"familiarisait" => "familjaRizE",
"familiarisant" => "familjaRiz@",
"familiarise" => "familjaRiz",
"familiarisé" => "familjaRize",
"familiarisée" => "familjaRize",
"familiarisent" => "familjaRiz",
"familiariser" => "familjaRize",
"familiariserez" => "familjaRiz°Re",
"familiarisés" => "familjaRize",
"familiarisez" => "familjaRize",
"familiarité" => "familjaRite",
"familiarités" => "familjaRite",
"familiaux" => "familjo",
"familier" => "familje",
"familière" => "familjER",
"familièrement" => "familjER°m@",
"familières" => "familjER",
"familiers" => "familje",
"familistère" => "familistER",
"famille" => "famij",
"familles" => "famij",
"famine" => "famin",
"famines" => "famin",
"famulus" => "famylys",
"fan" => "fan",
"fan-club" => "fankl9b",
"fana" => "fana",
"fanaient" => "fanE",
"fanait" => "fanE",
"fanal" => "fanal",
"fanant" => "fan@",
"fanas" => "fana",
"fanatique" => "fanatik",
"fanatiquement" => "fanatik°m@",
"fanatiques" => "fanatik",
"fanatisait" => "fanatizE",
"fanatise" => "fanatiz",
"fanatisé" => "fanatize",
"fanatiser" => "fanatize",
"fanatisés" => "fanatize",
"fanatisme" => "fanatizm",
"fanatismes" => "fanatizm",
"fanaux" => "fano",
"fanchon" => "f@S§",
"fandango" => "f@d@go",
"fane" => "fan",
"fané" => "fane",
"fanée" => "fane",
"fanées" => "fane",
"fanent" => "fan",
"faner" => "fane",
"fanera" => "fan°Ra",
"faneraient" => "fan°RE",
"fanerait" => "fan°RE",
"faneras" => "fan°Ra",
"fanerions" => "fan°Rj§",
"faneront" => "fan°R§",
"fanes" => "fan",
"fanés" => "fane",
"faneuse" => "fan2z",
"faneuses" => "fan2z",
"fanez" => "fane",
"fanfan" => "f@f@",
"fanfare" => "f@faR",
"fanfares" => "f@faR",
"fanfaron" => "f@faR§",
"fanfaronna" => "f@faRona",
"fanfaronnade" => "f@faRonad",
"fanfaronnades" => "f@faRonad",
"fanfaronnaient" => "f@faRonE",
"fanfaronnait" => "f@faRonE",
"fanfaronnant" => "f@faRon@",
"fanfaronne" => "f@faROn",
"fanfaronné" => "f@faRone",
"fanfaronner" => "f@faRone",
"fanfaronnes" => "f@faROn",
"fanfarons" => "f@faR§",
"fanfreluche" => "f@fR°lyS",
"fanfreluches" => "f@fR°lyS",
"fang" => "f@g",
"fange" => "f@Z",
"fanges" => "f@Z",
"fangeuse" => "f@Z2z",
"fangeuses" => "f@Z2z",
"fangeux" => "f@Z2",
"fanion" => "fanj§",
"fanions" => "fanj§",
"fanny" => "fani",
"fanon" => "fan§",
"fanons" => "fan§",
"fans" => "fan",
"fantaisie" => "f@tezi",
"fantaisies" => "f@tezi",
"fantaisiste" => "f@tezist",
"fantaisistes" => "f@tezist",
"fantasia" => "f@tazja",
"fantasmagorie" => "f@tasmagoRi",
"fantasmagories" => "f@tasmagoRi",
"fantasmagorique" => "f@tasmagoRik",
"fantasmaient" => "f@tasmE",
"fantasmais" => "f@tasmE",
"fantasmait" => "f@tasmE",
"fantasmatique" => "f@tasmatik",
"fantasmatiquement" => "f@tasmatik°m@",
"fantasme" => "f@tasm",
"fantasmé" => "f@tasme",
"fantasment" => "f@tasm",
"fantasmer" => "f@tasme",
"fantasmes" => "f@tasm",
"fantasmés" => "f@tasme",
"fantasmez" => "f@tasme",
"fantasque" => "f@task",
"fantasquement" => "f@task2m@",
"fantasques" => "f@task",
"fantassin" => "f@tas5",
"fantassins" => "f@tas5",
"fantastique" => "f@tastik",
"fantastiquement" => "f@tastik°m@",
"fantastiques" => "f@tastik",
"fanti" => "f@ti",
"fantoche" => "f@tOS",
"fantoches" => "f@tOS",
"fantomale" => "f@tomal",
"fantomales" => "f@tomal",
"fantomatique" => "f@tomatik",
"fantomatiquement" => "f@tomatik°m@",
"fantomatiques" => "f@tomatik",
"fantôme" => "f@tom",
"fantômes" => "f@tom",
"fanzine" => "f@zin",
"fanzines" => "f@zin",
"faon" => "f@",
"faons" => "f@",
"faquin" => "fak5",
"faquins" => "fak5",
"far" => "faR",
"far-west" => "faRwEst",
"farad" => "faRad",
"farads" => "faRad",
"faramineuse" => "faRamin2z",
"faramineuses" => "faRamin2z",
"faramineux" => "faRamin2",
"farandolaient" => "faR@dolE",
"farandole" => "faR@dOl",
"farandoles" => "faR@dOl",
"faraud" => "faRo",
"faraude" => "faRod",
"farauder" => "faRode",
"faraudes" => "faRod",
"farauds" => "faRo",
"farce" => "faRs",
"farces" => "faRs",
"farceur" => "faRs9R",
"farceurs" => "faRs9R",
"farceuse" => "faRs2z",
"farceuses" => "faRs2z",
"farci" => "faRsi",
"farcie" => "faRsi",
"farcies" => "faRsi",
"farcir" => "faRsiR",
"farcirai" => "faRsiRE",
"farcirait" => "faRsiRE",
"farcis" => "faRsi",
"farcissaient" => "faRsisE",
"farcissais" => "faRsisE",
"farcissait" => "faRsisE",
"farcissant" => "faRsis@",
"farcisse" => "faRsis",
"farcissez" => "faRsise",
"farcit" => "faRsi",
"fard" => "faR",
"fardaient" => "faRdE",
"fardait" => "faRdE",
"fardant" => "faRd@",
"farde" => "faRd",
"fardé" => "faRde",
"fardeau" => "faRdo",
"fardeaux" => "faRdo",
"fardée" => "faRde",
"fardées" => "faRde",
"fardent" => "faRd",
"farder" => "faRde",
"fardés" => "faRde",
"fardier" => "faRdje",
"fardiers" => "faRdje",
"fards" => "faR",
"fare" => "faR",
"farfadet" => "faRfadE",
"farfadets" => "faRfadE",
"farfelu" => "faRf°ly",
"farfelue" => "faRf°ly",
"farfelues" => "faRf°ly",
"farfelus" => "faRf°ly",
"farfouilla" => "faRfuja",
"farfouillais" => "faRfujE",
"farfouillait" => "faRfujE",
"farfouillant" => "faRfuj@",
"farfouille" => "faRfuj",
"farfouillé" => "faRfuje",
"farfouillent" => "faRfuj",
"farfouiller" => "faRfuje",
"farfouillerait" => "faRfuj°RE",
"farfouilles" => "faRfuj",
"farfouilleurs" => "faRfuj9R",
"farfouillez" => "faRfuje",
"faribole" => "faRibOl",
"fariboler" => "faRibole",
"fariboles" => "faRibOl",
"farigoule" => "faRigul",
"farine" => "faRin",
"farinée" => "faRine",
"farines" => "faRin",
"farinés" => "faRine",
"farineuse" => "faRin2z",
"farineuses" => "faRin2z",
"farineux" => "faRin2",
"farniente" => "faRnjEnte",
"faro" => "faRo",
"farouche" => "faRuS",
"farouchement" => "faRuS°m@",
"farouches" => "faRuS",
"farsi" => "faRsi",
"fart" => "faR",
"farter" => "faRte",
"fascia" => "fasja",
"fascicule" => "fasikyl",
"fascicules" => "fasikyl",
"fascina" => "fasina",
"fascinaient" => "fasinE",
"fascinais" => "fasinE",
"fascinait" => "fasinE",
"fascinant" => "fasin@",
"fascinante" => "fasin@t",
"fascinantes" => "fasin@t",
"fascinants" => "fasin@",
"fascination" => "fasinasj§",
"fascinations" => "fasinasj§",
"fascine" => "fasin",
"fasciné" => "fasine",
"fascinée" => "fasine",
"fascinées" => "fasine",
"fascinent" => "fasin",
"fasciner" => "fasine",
"fascinerait" => "fasin°RE",
"fascinèrent" => "fasinER",
"fascines" => "fasin",
"fascinés" => "fasine",
"fascinez" => "fasine",
"fascisée" => "faSize",
"fascisme" => "faSizm",
"fasciste" => "faSist",
"fascistes" => "faSist",
"faseyaient" => "fazEjE",
"faseyait" => "fazEjE",
"fashion" => "faSOn",
"fashionable" => "faSonabl",
"fasse" => "fas",
"fassent" => "fas",
"fasses" => "fas",
"fassiez" => "fasje",
"fassions" => "fasj§",
"fast food" => "fastfud",
"fast-food" => "fastfud",
"fast-foods" => "fastfud",
"faste" => "fast",
"fastes" => "fast",
"fastidieuse" => "fastidj2z",
"fastidieusement" => "fastidj2z°m@",
"fastidieuses" => "fastidj2z",
"fastidieux" => "fastidj2",
"fastoche" => "fastOS",
"fastueuse" => "fast82z",
"fastueusement" => "fast82z°m@",
"fastueuses" => "fast82z",
"fastueux" => "fast82",
"fat" => "fat",
"fatal" => "fatal",
"fatale" => "fatal",
"fatalement" => "fatal°m@",
"fatales" => "fatal",
"fatalise" => "fataliz",
"fatalisé" => "fatalize",
"fataliser" => "fatalize",
"fatalisme" => "fatalizm",
"fataliste" => "fatalist",
"fatalistes" => "fatalist",
"fatalité" => "fatalite",
"fatalités" => "fatalite",
"fatals" => "fatal",
"fate" => "fat",
"fathma" => "fatma",
"fathom" => "fazOm",
"fatidique" => "fatidik",
"fatidiques" => "fatidik",
"fatigant" => "fatig@",
"fatigante" => "fatig@t",
"fatigantes" => "fatig@t",
"fatigants" => "fatig@",
"fatigua" => "fatiga",
"fatiguai" => "fatigE",
"fatiguaient" => "fatigE",
"fatiguais" => "fatigE",
"fatiguait" => "fatigE",
"fatiguant" => "fatig@",
"fatiguât" => "fatiga",
"fatigue" => "fatig",
"fatigué" => "fatige",
"fatiguée" => "fatige",
"fatiguées" => "fatige",
"fatiguent" => "fatig",
"fatiguer" => "fatige",
"fatiguera" => "fatig°Ra",
"fatiguerai" => "fatig°RE",
"fatigueraient" => "fatig°RE",
"fatiguerais" => "fatig°RE",
"fatiguerait" => "fatig°RE",
"fatigueras" => "fatig°Ra",
"fatiguèrent" => "fatigER",
"fatigues" => "fatig",
"fatigués" => "fatige",
"fatiguez" => "fatige",
"fatiguons" => "fatig§",
"fatma" => "fatma",
"fatmas" => "fatma",
"fatras" => "fatRa",
"fats" => "fat",
"fatuité" => "fat8ite",
"fatum" => "fatOm",
"fau" => "fo",
"faubert" => "fobER",
"faubourg" => "fobuR",
"faubourgs" => "fobuR",
"faubourien" => "fobuRj5",
"faubourienne" => "fobuRjEn",
"faubouriennes" => "fobuRjEn",
"faubouriens" => "fobuRj5",
"faucardé" => "fokaRde",
"faucardée" => "fokaRde",
"faucardées" => "fokaRde",
"faucardés" => "fokaRde",
"faucha" => "foSa",
"fauchage" => "foSaZ",
"fauchaient" => "foSE",
"fauchais" => "foSE",
"fauchaison" => "foSEz§",
"fauchait" => "foSE",
"fauchant" => "foS@",
"fauchard" => "foSaR",
"fauche" => "foS",
"fauché" => "foSe",
"fauchée" => "foSe",
"fauchées" => "foSe",
"fauchent" => "foS",
"faucher" => "foSe",
"fauchera" => "foS°Ra",
"faucherait" => "foS°RE",
"faucheras" => "foS°Ra",
"faucheront" => "foS°R§",
"fauches" => "foS",
"fauchés" => "foSe",
"faucheur" => "foS9R",
"faucheurs" => "foS9R",
"faucheuse" => "foS2z",
"faucheuses" => "foS2z",
"faucheux" => "foS2",
"fauchez" => "foSe",
"fauchon" => "foS§",
"faucille" => "fosij",
"faucilles" => "fosij",
"faucillon" => "fosij§",
"faucon" => "fok§",
"fauconneau" => "fokOno",
"fauconnerie" => "fokOn°Ri",
"fauconnier" => "fokonje",
"fauconniers" => "fokonje",
"faucons" => "fok§",
"faudra" => "fodRa",
"faudrait" => "fodRE",
"faufil" => "fofil",
"faufila" => "fofila",
"faufilai" => "fofilE",
"faufilaient" => "fofilE",
"faufilais" => "fofilE",
"faufilait" => "fofilE",
"faufilâmes" => "fofilam",
"faufilant" => "fofil@",
"faufilât" => "fofila",
"faufile" => "fofil",
"faufilé" => "fofile",
"faufilée" => "fofile",
"faufilées" => "fofile",
"faufilent" => "fofil",
"faufiler" => "fofile",
"faufilera" => "fofil°Ra",
"faufilerai" => "fofil°RE",
"faufilerait" => "fofil°RE",
"faufileras" => "fofil°Ra",
"faufilèrent" => "fofilER",
"faufileront" => "fofil°R§",
"faufilés" => "fofile",
"faufilez" => "fofile",
"faufilons" => "fofil§",
"faune" => "fon",
"faunes" => "fon",
"faunesque" => "fonEsk",
"faunesques" => "fonEsk",
"faunesse" => "fonEs",
"faussa" => "fosa",
"faussaient" => "fosE",
"faussaire" => "fosER",
"faussaires" => "fosER",
"faussait" => "fosE",
"faussant" => "fos@",
"faussât" => "fosa",
"fausse" => "fos",
"faussé" => "fose",
"fausse-couche" => "foskuS",
"faussée" => "fose",
"faussées" => "fose",
"faussement" => "fos°m@",
"faussent" => "fos",
"fausser" => "fose",
"fausseront" => "fos°R§",
"fausses" => "fos",
"faussés" => "fose",
"fausset" => "fosE",
"fausseté" => "foste",
"faussets" => "fosE",
"faussez" => "fose",
"faussions" => "fosj§",
"faustien" => "fostj5",
"faustienne" => "fostjEn",
"faut" => "fo",
"faute" => "fot",
"fauté" => "fote",
"fauter" => "fote",
"fautes" => "fot",
"fauteuil" => "fot9j",
"fauteuil-club" => "fot9jkl9b",
"fauteuils" => "fot9j",
"fauteuils-club" => "fot9jkl9b",
"fauteur" => "fot9R",
"fauteurs" => "fot9R",
"fauteuse" => "fot2z",
"fautif" => "fotif",
"fautifs" => "fotif",
"fautive" => "fotiv",
"fautives" => "fotiv",
"fautrice" => "fotRis",
"fauve" => "fov",
"fauverie" => "fov°Ri",
"fauves" => "fov",
"fauvette" => "fovEt",
"fauvettes" => "fovEt",
"fauvisme" => "fovism",
"faux" => "fo",
"faux-bond" => "fob§",
"faux-bourdon" => "fobuRd§",
"faux-col" => "fokOl",
"faux-cul" => "foky",
"faux-filet" => "fofilE",
"faux-frère" => "fofRER",
"faux-fuyant" => "fof8ij@",
"faux-fuyants" => "fof8ij@",
"faux-monnayeur" => "fomonEj9R",
"faux-monnayeurs" => "fomonEj9R",
"faux-pas" => "fopa",
"faux-pont" => "fop§",
"faux-sauniers" => "fosonje",
"faux-semblant" => "fos@bl@",
"faux-semblants" => "fos@bl@",
"favela" => "favela",
"favelas" => "favela",
"faveur" => "fav9R",
"faveurs" => "fav9R",
"favorable" => "favoRabl",
"favorablement" => "favoRabl°m@",
"favorables" => "favoRabl",
"favori" => "favoRi",
"favoris" => "favoRi",
"favorisa" => "favoRiza",
"favorisaient" => "favoRizE",
"favorisait" => "favoRizE",
"favorisant" => "favoRiz@",
"favorisât" => "favoRiza",
"favorise" => "favoRiz",
"favorisé" => "favoRize",
"favorisée" => "favoRize",
"favorisées" => "favoRize",
"favorisent" => "favoRiz",
"favoriser" => "favoRize",
"favorisera" => "favoRiz°Ra",
"favoriserai" => "favoRiz°RE",
"favoriseraient" => "favoRiz°RE",
"favoriserait" => "favoRiz°RE",
"favorisèrent" => "favoRizER",
"favorisés" => "favoRize",
"favorisez" => "favoRize",
"favorite" => "favoRit",
"favorites" => "favoRit",
"favoritisme" => "favoRitizm",
"fax" => "faks",
"faxe" => "faks",
"faxé" => "fakse",
"faxer" => "fakse",
"faxera" => "faks°Ra",
"faxerai" => "faks°RE",
"faxes" => "faks",
"faxés" => "fakse",
"faxez" => "fakse",
"faxons" => "faks§",
"fayard" => "fajaR",
"fayards" => "fajaR",
"fayot" => "fajo",
"fayotage" => "fajotaZ",
"fayotaient" => "fajotE",
"fayotais" => "fajotE",
"fayotait" => "fajotE",
"fayote" => "fajOt",
"fayotée" => "fajote",
"fayoter" => "fajote",
"fayots" => "fajo",
"fayotte" => "fajOt",
"fazenda" => "fazEnda",
"féal" => "feal",
"féaux" => "feo",
"fébrile" => "febRil",
"fébrilement" => "febRil°m@",
"fébriles" => "febRil",
"fébrilité" => "febRilite",
"fécal" => "fekal",
"fécale" => "fekal",
"fécales" => "fekal",
"fécalome" => "fekalom",
"fécaux" => "feko",
"fèces" => "fEs",
"fécond" => "fek§",
"fécondais" => "fek§dE",
"fécondait" => "fek§dE",
"fécondant" => "fek§d@",
"fécondante" => "fek§d@t",
"fécondateur" => "fek§dat9R",
"fécondation" => "fek§dasj§",
"fécondations" => "fek§dasj§",
"féconde" => "fek§d",
"fécondé" => "fek§de",
"fécondée" => "fek§de",
"fécondées" => "fek§de",
"fécondent" => "fek§d",
"féconder" => "fek§de",
"féconderai" => "fek§d°RE",
"féconderait" => "fek§d°RE",
"fécondes" => "fek§d",
"fécondés" => "fek§de",
"fécondez" => "fek§de",
"fécondité" => "fek§dite",
"féconds" => "fek§",
"fécule" => "fekyl",
"féculent" => "fekyl@",
"féculents" => "fekyl@",
"fedayin" => "fedaj5",
"fédéral" => "fedeRal",
"fédérale" => "fedeRal",
"fédérales" => "fedeRal",
"fédéralisme" => "fedeRalizm",
"fédéraliste" => "fedeRalist",
"fédérateur" => "fedeRat9R",
"fédération" => "fedeRasj§",
"fédérations" => "fedeRasj§",
"fédérative" => "fedeRativ",
"fédératrice" => "fedeRatRis",
"fédéraux" => "fedeRo",
"fédéré" => "fedeRe",
"fédérée" => "fedeRe",
"fédérées" => "fedeRe",
"fédérer" => "fedeRe",
"fédérés" => "fedeRe",
"fée" => "fe",
"feed-back" => "fidbak",
"feedback" => "fidbak",
"feeder" => "fid9R",
"feeling" => "filiG",
"feelings" => "filiG",
"féerie" => "feRi",
"féeries" => "feRi",
"féerique" => "feRik",
"féeriquement" => "feeRik°m@",
"féeriques" => "feRik",
"fées" => "fe",
"feignaient" => "fENE",
"feignais" => "fENE",
"feignait" => "fENE",
"feignant" => "fEN@",
"feignante" => "fEN@t",
"feignantes" => "fEN@t",
"feignants" => "fEN@",
"feignasse" => "fENas",
"feignasses" => "fENas",
"feigne" => "fEN",
"feignent" => "fEN",
"feignez" => "fENe",
"feigniez" => "fENe",
"feignîmes" => "fENim",
"feignirent" => "fENiR",
"feignis" => "fENi",
"feignit" => "fENi",
"feignons" => "fEN§",
"feindra" => "f5dRa",
"feindrai" => "f5dRE",
"feindrait" => "f5dRE",
"feindre" => "f5dR",
"feins" => "f5",
"feint" => "f5",
"feintait" => "f5tE",
"feintant" => "f5t@",
"feinte" => "f5t",
"feinté" => "f5te",
"feinter" => "f5te",
"feinterez" => "f5t°Re",
"feintes" => "f5t",
"feintés" => "f5te",
"feinteur" => "f5t9R",
"feintise" => "f5tiz",
"feints" => "f5",
"fêla" => "fEla",
"fêlant" => "fEl@",
"feld-maréchal" => "fEldmaReSal",
"feldgrau" => "fEldgRo",
"feldspath" => "fEldspat",
"feldwebel" => "fEldvebEl",
"feldwebels" => "fEldvebEl",
"fêle" => "fEl",
"fêlé" => "fele",
"fêlée" => "fele",
"fêlées" => "fEle",
"fêler" => "fele",
"fêles" => "fEl",
"fêlés" => "fEle",
"félibre" => "felibR",
"félibres" => "felibR",
"félibrige" => "felibRiZ",
"félicita" => "felisita",
"félicitai" => "felisitE",
"félicitaient" => "felisitE",
"félicitais" => "felisitE",
"félicitait" => "felisitE",
"félicitâmes" => "felisitam",
"félicitant" => "felisit@",
"félicitation" => "felisitasj§",
"félicitations" => "felisitasj§",
"félicite" => "felisit",
"félicité" => "felisite",
"félicitée" => "felisite",
"félicitent" => "felisit",
"féliciter" => "felisite",
"félicitera" => "felisit°Ra",
"féliciterai" => "felisit°RE",
"féliciteraient" => "felisit°RE",
"féliciterais" => "felisit°RE",
"féliciterait" => "felisit°RE",
"féliciteras" => "felisit°Ra",
"félicitèrent" => "felisitER",
"féliciteriez" => "felisit°Rje",
"félicités" => "felisite",
"félicitez" => "felisite",
"félicitiez" => "felisitje",
"félicitions" => "felisitj§",
"félicitons" => "felisit§",
"félidé" => "felide",
"félin" => "fel5",
"féline" => "felin",
"félinement" => "felin°m@",
"félines" => "felin",
"félinité" => "felinite",
"félins" => "fel5",
"fellaga" => "fElaga",
"fellagas" => "fElaga",
"fellagha" => "fElaga",
"fellaghas" => "fElaga",
"fellah" => "fela",
"fellahs" => "fela",
"fellation" => "fElasj§",
"fellationne" => "fElasjOn",
"fellations" => "fElasj§",
"fellinien" => "f°linj5",
"fellinienne" => "felinjEn",
"félon" => "fel§",
"félonie" => "feloni",
"félonne" => "felOn",
"félons" => "fel§",
"felouque" => "f°luk",
"felouques" => "f°luk",
"fêlure" => "felyR",
"fêlures" => "fElyR",
"femelle" => "f°mEl",
"femelles" => "f°mEl",
"féminin" => "femin5",
"féminine" => "feminin",
"féminines" => "feminin",
"féminins" => "femin5",
"féminisaient" => "feminizE",
"féminisation" => "feminizasj§",
"féminisé" => "feminize",
"féminiser" => "feminize",
"féminisme" => "feminizm",
"féministe" => "feminist",
"féministes" => "feminist",
"féminité" => "feminite",
"féminités" => "feminite",
"féminitude" => "feminityd",
"femme" => "fam",
"femme-enfant" => "fam@f@",
"femme-fleur" => "famfl9R",
"femme-objet" => "famObZE",
"femme-refuge" => "famR°fyZ",
"femme-robot" => "famRobo",
"femmelette" => "fam°lEt",
"femmelettes" => "fam°lEt",
"femmes" => "fam",
"fémoral" => "femoRal",
"fémorale" => "femoRal",
"fémorales" => "femoRal",
"fémoraux" => "femORo",
"fémur" => "femyR",
"fémurs" => "femyR",
"fenaison" => "f°nEz§",
"fenaisons" => "f°nEz§",
"fend" => "f@",
"fendaient" => "f@dE",
"fendais" => "f@dE",
"fendait" => "f@dE",
"fendant" => "f@d@",
"fendants" => "f@d@",
"fendard" => "f@daR",
"fende" => "f@d",
"fendent" => "f@d",
"fendeur" => "f@d9R",
"fendeurs" => "f@d9R",
"fendez" => "f@de",
"fendillaient" => "f@dijE",
"fendillait" => "f@dijE",
"fendille" => "f@dij",
"fendillé" => "f@dije",
"fendillée" => "f@dije",
"fendillées" => "f@dije",
"fendillement" => "f@dij°m@",
"fendillements" => "f@dij°m@",
"fendiller" => "f@dije",
"fendillèrent" => "f@dijER",
"fendillés" => "f@dije",
"fendis" => "f@di",
"fendissent" => "f@dis",
"fendit" => "f@di",
"fendoir" => "f@dwaR",
"fendons" => "f@d§",
"fendra" => "f@dRa",
"fendrai" => "f@dRE",
"fendraient" => "f@dRE",
"fendrait" => "f@dRE",
"fendre" => "f@dR",
"fends" => "f@",
"fendu" => "f@dy",
"fendue" => "f@dy",
"fendues" => "f@dy",
"fendus" => "f@dy",
"fénelonienne" => "fen°lonjEn",
"fenestrages" => "f°nEstRaZ",
"fenestrelle" => "f2nEstREl",
"fenêtre" => "f°nEtR",
"fenêtres" => "f°nEtR",
"fenians" => "f°nj@",
"fenil" => "f°nil",
"fenils" => "f°nil",
"fennec" => "fenEk",
"fennecs" => "fenEk",
"fenouil" => "f°nuj",
"fente" => "f@t",
"fentes" => "f@t",
"fenton" => "f@t§",
"fenugrec" => "f°nygREk",
"féodal" => "feodal",
"féodale" => "feodal",
"féodales" => "feodal",
"féodalisme" => "feodalizm",
"féodalité" => "feodalite",
"féodaux" => "feodo",
"fer" => "fER",
"fer-blanc" => "fERbl@",
"fera" => "f°Ra",
"féra" => "feRa",
"ferai" => "f°RE",
"feraient" => "f°RE",
"ferais" => "f°RE",
"ferait" => "f°RE",
"feras" => "f°Ra",
"féras" => "feRa",
"ferblanterie" => "fERbl@t°Ri",
"ferblantier" => "fERbl@tje",
"ferblantiers" => "fERbl@tje",
"fère" => "fER",
"ferez" => "f°Re",
"feria" => "f°Rja",
"féria" => "feRja",
"ferias" => "f°Rja",
"férias" => "feRja",
"férié" => "feRje",
"fériés" => "feRje",
"feriez" => "f°Rje",
"ferions" => "f°Rj§",
"férir" => "feRiR",
"ferlage" => "fERlaZ",
"ferlée" => "fERle",
"ferlez" => "fERle",
"ferma" => "fERma",
"fermage" => "fERmaZ",
"fermages" => "fERmaZ",
"fermai" => "fERmE",
"fermaient" => "fERmE",
"fermais" => "fERmE",
"fermait" => "fERmE",
"fermant" => "fERm@",
"fermât" => "fERma",
"ferme" => "fERm",
"fermé" => "fERme",
"fermée" => "fERme",
"fermées" => "fERme",
"fermement" => "fERm°m@",
"ferment" => "fERm",
"fermentaient" => "fERm@tE",
"fermentais" => "fERm@tE",
"fermentait" => "fERm@tE",
"fermentation" => "fERm@tasj§",
"fermentations" => "fERm@tasj§",
"fermente" => "fERm@t",
"fermenté" => "fERm@te",
"fermentée" => "fERm@te",
"fermentées" => "fERm@te",
"fermenter" => "fERm@te",
"fermentèrent" => "fERm@tER",
"fermentés" => "fERm@te",
"ferments" => "fERm@",
"fermer" => "fERme",
"fermera" => "fERm°Ra",
"fermerai" => "fERm°RE",
"fermeraient" => "fERm°RE",
"fermerais" => "fERm°RE",
"fermerait" => "fERm°RE",
"fermeras" => "fERm°Ra",
"fermèrent" => "fERmER",
"fermerez" => "fERm°Re",
"fermeriez" => "fERm°Rje",
"fermerons" => "fERm°R§",
"fermeront" => "fERm°R§",
"fermes" => "fERm",
"fermés" => "fERme",
"fermes-hôtels" => "fERmotEl",
"fermeté" => "fERm°te",
"fermette" => "fERmEt",
"fermeture" => "fERm°tyR",
"fermetures" => "fERm°tyR",
"fermez" => "fERme",
"fermi" => "fERmi",
"fermier" => "fERmje",
"fermière" => "fERmjER",
"fermières" => "fERmjER",
"fermiers" => "fERmje",
"fermiez" => "fERmje",
"fermions" => "fERmj§",
"fermium" => "fERmjOm",
"fermoir" => "fERmwaR",
"fermoirs" => "fERmwaR",
"fermons" => "fERm§",
"féroce" => "feROs",
"férocement" => "feROs°m@",
"féroces" => "feROs",
"férocité" => "feRosite",
"férocités" => "feRosite",
"ferons" => "f°R§",
"feront" => "f°R§",
"ferra" => "fERa",
"ferrage" => "fERaZ",
"ferrages" => "fERaZ",
"ferrai" => "fERE",
"ferrailla" => "fERaja",
"ferraillaient" => "fERajE",
"ferraillait" => "fERajE",
"ferraillant" => "fERaj@",
"ferraillante" => "fERaj@t",
"ferraille" => "fERaj",
"ferraillé" => "fERaje",
"ferraillement" => "fERaj°m@",
"ferrailler" => "fERaje",
"ferrailles" => "fERaj",
"ferrailleur" => "fERaj9R",
"ferrailleurs" => "fERaj9R",
"ferrais" => "fERE",
"ferrait" => "fERE",
"ferrant" => "fER@",
"ferrasse" => "fERas",
"ferre" => "fER",
"ferré" => "fERe",
"ferrée" => "fERe",
"ferrées" => "feRe",
"ferrer" => "fERe",
"ferrera" => "fER°Ra",
"ferrerait" => "fER°RE",
"ferrés" => "feRe",
"ferrets" => "fERE",
"ferreuse" => "fER2z",
"ferreux" => "fER2",
"ferrez" => "fERe",
"ferries" => "fERi",
"ferriques" => "fERik",
"ferrite" => "feRit",
"ferro" => "fERo",
"ferrocérium" => "fERoseRjOm",
"ferrocyanure" => "fERosjanyR",
"ferronnerie" => "fEROn°Ri",
"ferronneries" => "fEROn°Ri",
"ferronnier" => "fERonje",
"ferronnière" => "fEROnjER",
"ferronniers" => "fERonje",
"ferrons" => "fER§",
"ferroviaire" => "fERovjER",
"ferroviaires" => "fERovjER",
"ferrugineuse" => "fERyZin2z",
"ferrugineuses" => "fERyZin2z",
"ferrugineux" => "fERyZin2",
"ferrure" => "fERyR",
"ferrures" => "fERyR",
"ferry" => "fERi",
"ferry-boat" => "fERibOwt",
"fers" => "fER",
"ferté" => "fERte",
"fertile" => "fERtil",
"fertiles" => "fERtil",
"fertilisable" => "fERtilizabl",
"fertilisait" => "fERtilizE",
"fertilisant" => "fERtiliz@",
"fertilisateur" => "fERtilizat9R",
"fertilisation" => "fERtilizasj§",
"fertilise" => "fERtiliz",
"fertilisé" => "fERtilize",
"fertilisée" => "fERtilize",
"fertilisent" => "fERtiliz",
"fertiliser" => "fERtilize",
"fertilisera" => "fERtiliz°Ra",
"fertilisèrent" => "fERtilizER",
"fertiliserons" => "fERtiliz°R§",
"fertilisés" => "fERtilize",
"fertilisez" => "fERtilize",
"fertilité" => "fERtilite",
"féru" => "feRy",
"férue" => "feRy",
"férues" => "feRy",
"férule" => "feRyl",
"férus" => "feRy",
"fervent" => "fERv@",
"fervente" => "fERv@t",
"ferventes" => "fERv@t",
"fervents" => "fERv@",
"ferveur" => "fERv9R",
"ferveurs" => "fERv9R",
"fessait" => "fEsE",
"fesse" => "fEs",
"fessé" => "fEse",
"fesse-mathieu" => "fEsmatj2",
"fessée" => "fese",
"fessées" => "fEse",
"fesser" => "fese",
"fesserai" => "fEs°RE",
"fesserais" => "fEs°RE",
"fesses" => "fEs",
"fessés" => "fEse",
"fesseur" => "fEs9R",
"fesseuse" => "fEs2z",
"fessier" => "fesje",
"fessière" => "fesjER",
"fessières" => "fEsjER",
"fessiers" => "fEsje",
"fessiez" => "fEsje",
"fessu" => "fEsy",
"fessue" => "fEsy",
"fessues" => "fEsy",
"festif" => "fEstif",
"festin" => "fEst5",
"festins" => "fEst5",
"festival" => "fEstival",
"festivalier" => "fEstivalje",
"festivals" => "fEstival",
"festive" => "fEstiv",
"festives" => "fEstiv",
"festivité" => "fEstivite",
"festivités" => "fEstivite",
"festoie" => "fEstwa",
"festoient" => "fEstwa",
"festoiera" => "fEstwaRa",
"festoierons" => "fEstwaR§",
"feston" => "fEst§",
"festonnaient" => "fEstonE",
"festonnait" => "fEstonE",
"festonne" => "fEstOn",
"festonné" => "fEstone",
"festonnée" => "fEstone",
"festonnées" => "fEstone",
"festonnements" => "fEstOn°m@",
"festonner" => "fEstone",
"festonnés" => "fEstone",
"festons" => "fEst§",
"festoya" => "fEstwaja",
"festoyaient" => "fEstwajE",
"festoyant" => "fEstwaj@",
"festoyé" => "fEstwaje",
"festoyer" => "fEstwaje",
"festoyez" => "fEstwaje",
"feta" => "fEta",
"fêta" => "fEta",
"fêtaient" => "fEtE",
"fêtait" => "fEtE",
"fêtâmes" => "fEtam",
"fêtant" => "fEt@",
"fêtard" => "fEtaR",
"fêtards" => "fEtaR",
"fête" => "fEt",
"fêté" => "fete",
"fête-dieu" => "fEtdj2",
"fêtée" => "fete",
"fêtent" => "fEt",
"fêter" => "fete",
"fêtera" => "fEt°Ra",
"fêterait" => "fEt°RE",
"fêtèrent" => "fEtER",
"fêterons" => "fEt°R§",
"fêtes" => "fEt",
"fêtés" => "fete",
"fêtez" => "fEte",
"fétiche" => "fetiS",
"fétiches" => "fetiS",
"féticheur" => "fetiS9R",
"féticheurs" => "fetiS9R",
"fétichisations" => "fetiSizasj§",
"fétichisme" => "fetiSizm",
"fétichismes" => "fetiSizm",
"fétichiste" => "fetiSist",
"fétichistes" => "fetiSist",
"fétide" => "fetid",
"fétides" => "fetid",
"fétidité" => "fetidite",
"fêtions" => "fEtj§",
"fêtons" => "fEt§",
"fettucine" => "fetutSine",
"fétu" => "fety",
"fétuque" => "fetyk",
"fétus" => "fety",
"feu" => "f2",
"feudataire" => "f2datER",
"feue" => "f2",
"feuillage" => "f9jaZ",
"feuillages" => "f9jaZ",
"feuillaison" => "f9jEz§",
"feuillantines" => "f9j@tin",
"feuille" => "f9j",
"feuille-morte" => "f9jmORt",
"feuillée" => "f9je",
"feuillées" => "f9je",
"feuilles" => "f9j",
"feuillet" => "f9jE",
"feuilleta" => "f9j°ta",
"feuilletage" => "f9j°taZ",
"feuilletai" => "f9j°tE",
"feuilletaient" => "f9j°tE",
"feuilletais" => "f9j°tE",
"feuilletait" => "f9j°tE",
"feuilletant" => "f9j°t@",
"feuilleté" => "f9j°te",
"feuilletée" => "f9j°te",
"feuilletées" => "f9j°te",
"feuilleter" => "f9j°te",
"feuilletèrent" => "f9j°tER",
"feuilletés" => "f9j°te",
"feuilletez" => "f9j°te",
"feuilletiez" => "f9j°tje",
"feuilletions" => "f9j°tj§",
"feuilleton" => "f9j°t§",
"feuilletoniste" => "f9j°tonist",
"feuilletons" => "f9j°t§",
"feuillets" => "f9jE",
"feuillette" => "f9jEt",
"feuillettement" => "f9jEt°m@",
"feuillettent" => "f9jEt",
"feuillettes" => "f9jEt",
"feuillu" => "f9jy",
"feuillue" => "f9jy",
"feuillues" => "f9jy",
"feuillure" => "f9jyR",
"feuillures" => "f9jyR",
"feuillus" => "f9jy",
"feuj" => "f2Z",
"feula" => "f9la",
"feulait" => "f9lE",
"feulant" => "f9l@",
"feule" => "f9l",
"feulée" => "f9le",
"feulement" => "f9l°m@",
"feulements" => "f9l°m@",
"feulent" => "f9l",
"feuler" => "f9le",
"feurre" => "f9R",
"feutra" => "f2tRa",
"feutrage" => "f2tRaZ",
"feutrages" => "f2tRaZ",
"feutrait" => "f2tRE",
"feutrant" => "f2tR@",
"feutre" => "f2tR",
"feutré" => "f2tRe",
"feutrée" => "f2tRe",
"feutrées" => "f2tRe",
"feutrent" => "f2tR",
"feutrer" => "f2tRe",
"feutres" => "f2tR",
"feutrés" => "f2tRe",
"feutrine" => "f2tRin",
"feux" => "f2",
"fève" => "fEv",
"féveroles" => "fev°ROl",
"fèves" => "fEv",
"février" => "fevRije",
"fez" => "fEz",
"fi" => "fi",
"fia" => "fja",
"fiabilité" => "fjabilite",
"fiable" => "fjabl",
"fiables" => "fjabl",
"fiacre" => "fjakR",
"fiacres" => "fjakR",
"fiaient" => "fjE",
"fiais" => "fjE",
"fiait" => "fjE",
"fiança" => "fj@sa",
"fiançailles" => "fij@saj",
"fiançais" => "fj@sE",
"fiance" => "fj@s",
"fiancé" => "fj@se",
"fiancée" => "fj@se",
"fiancées" => "fj@se",
"fiancent" => "fj@s",
"fiancer" => "fj@se",
"fiancerais" => "fj@s°RE",
"fiancèrent" => "fj@sER",
"fiancerons" => "fj@s°R@",
"fiancés" => "fj@se",
"fiancez" => "fj@se",
"fiançons" => "fj@s§",
"fiant" => "fj@",
"fias" => "fja",
"fiasco" => "fjasko",
"fiascos" => "fjasko",
"fiasque" => "fjask",
"fiasques" => "fjask",
"fiassent" => "fjas",
"fiat" => "fjat",
"fibre" => "fibR",
"fibré" => "fibRe",
"fibres" => "fibR",
"fibreuse" => "fibR2z",
"fibreuses" => "fibR2z",
"fibreux" => "fibR2",
"fibrillation" => "fibRilasj§",
"fibrille" => "fibRij",
"fibrillé" => "fibRije",
"fibrilles" => "fibRij",
"fibrilleux" => "fibRij2",
"fibrine" => "fibRin",
"fibrinogène" => "fibRinOZEn",
"fibrociment" => "fibRosim@",
"fibromateuse" => "fibRomat2z",
"fibrome" => "fibRom",
"fibromes" => "fibRom",
"fibroscope" => "fibRoskOp",
"fibroscopie" => "fibRoskOpi",
"fibrose" => "fibRoz",
"fibrotoxine" => "fibRotOksin",
"fibule" => "fibyl",
"fic" => "fik",
"ficaires" => "fikER",
"ficela" => "fis°la",
"ficelai" => "fis°lE",
"ficelaient" => "fis°lE",
"ficelait" => "fis°lE",
"ficelant" => "fis°l@",
"ficelé" => "fis°le",
"ficelée" => "fis°le",
"ficelées" => "fis°le",
"ficeler" => "fis°le",
"ficelèrent" => "fis°lER",
"ficelés" => "fis°le",
"ficelez" => "fis°le",
"ficelle" => "fisEl",
"ficellerait" => "fisEl°RE",
"ficelles" => "fisEl",
"ficha" => "fiSa",
"fichage" => "fiSaZ",
"fichaient" => "fiSE",
"fichais" => "fiSE",
"fichaise" => "fiSEz",
"fichaises" => "fiSEz",
"fichait" => "fiSE",
"fichant" => "fiS@",
"fichât" => "fiSa",
"fiche" => "fiS",
"fiché" => "fiSe",
"fichée" => "fiSe",
"fichées" => "fiSe",
"fichent" => "fiS",
"ficher" => "fiSe",
"fichera" => "fiS°Ra",
"ficherai" => "fiS°RE",
"ficheraient" => "fiS°RE",
"ficherais" => "fiS°RE",
"ficherait" => "fiS°RE",
"ficheras" => "fiS°Ra",
"ficherons" => "fiS°R§",
"ficheront" => "fiS°R§",
"fiches" => "fiS",
"fichés" => "fiSe",
"fichez" => "fiSe",
"fichier" => "fiSje",
"fichiers" => "fiSje",
"fichiez" => "fiSje",
"fichions" => "fiSj§",
"fichons" => "fiS§",
"fichtre" => "fiStR",
"fichtrement" => "fiStR°m@",
"fichu" => "fiSy",
"fichue" => "fiSy",
"fichues" => "fiSy",
"fichus" => "fiSy",
"fictif" => "fiktif",
"fictifs" => "fiktif",
"fiction" => "fiksj§",
"fictionnel" => "fiksjonEl",
"fictions" => "fiksj§",
"fictive" => "fiktiv",
"fictivement" => "fiktiv°m@",
"fictives" => "fiktiv",
"ficus" => "fikys",
"fidéicommis" => "fideikomi",
"fidèle" => "fidEl",
"fidèlement" => "fidEl°m@",
"fidèles" => "fidEl",
"fidéliser" => "fidElize",
"fidéliseras" => "fideliz°Ra",
"fidélité" => "fidelite",
"fidélités" => "fidelite",
"fiduciaire" => "fidysjER",
"fiduciaires" => "fidysjER",
"fiducie" => "fidysi",
"fie" => "fi",
"fié" => "fje",
"fiée" => "fje",
"fief" => "fjEf",
"fieffé" => "fjefe",
"fieffée" => "fjefe",
"fieffés" => "fjEfe",
"fiefs" => "fjEf",
"fiel" => "fjEl",
"field" => "fild",
"fielleuse" => "fjEl2z",
"fielleusement" => "fjEl2z°m@",
"fielleuses" => "fjElyz",
"fielleux" => "fjEl2",
"fient" => "fi",
"fiente" => "fj@t",
"fienté" => "fj@te",
"fientes" => "fj@t",
"fienteuse" => "fj@t2z",
"fienteux" => "fj@t2",
"fier" => "fjER",
"fier-à-bras" => "fjERabRa",
"fiera" => "fiRa",
"fierai" => "fiRE",
"fierais" => "fiRE",
"fieras" => "fiRa",
"fière" => "fjER",
"fièrement" => "fjER°m@",
"fières" => "fjER",
"fiérot" => "fjeRo",
"fiérote" => "fjeROt",
"fiérots" => "fjeRo",
"fiers" => "fjER",
"fiers-à-bras" => "fjERabRa",
"fierté" => "fjERte",
"fiertés" => "fjERte",
"fiés" => "fje",
"fiesta" => "fjEsta",
"fiestas" => "fjEsta",
"fieu" => "fj2",
"fieux" => "fj2",
"fièvre" => "fjEvR",
"fièvres" => "fjEvR",
"fiévreuse" => "fjevR2z",
"fiévreusement" => "fjevR2z°m@",
"fiévreuses" => "fjevR2z",
"fiévreux" => "fjevR2",
"fiez" => "fje",
"fifi" => "fifi",
"fifille" => "fifij",
"fifis" => "fifi",
"fifre" => "fifR",
"fifrelin" => "fifR°l5",
"fifrelins" => "fifR°l5",
"fifres" => "fifR",
"fifties" => "fifti",
"fifty" => "fifti",
"fifty-fifty" => "fiftififti",
"figaro" => "figaRo",
"figaros" => "figaRo",
"fige" => "fiZ",
"figé" => "fiZe",
"figea" => "fiZa",
"figeaient" => "fiZE",
"figeais" => "fiZE",
"figeait" => "fiZE",
"figeant" => "fiZ@",
"figée" => "fiZe",
"figées" => "fiZe",
"figent" => "fiZ",
"figer" => "fiZe",
"figera" => "fiZ°Ra",
"figerai" => "fiZ°RE",
"figeraient" => "fiZ°RE",
"figerait" => "fiZ°RE",
"figèrent" => "fiZER",
"figés" => "fiZe",
"figez" => "fiZe",
"fignard" => "fiNaR",
"fignola" => "fiNola",
"fignolage" => "fiNolaZ",
"fignolages" => "fiNolaZ",
"fignolaient" => "fiNolE",
"fignolait" => "fiNolE",
"fignolant" => "fiNol@",
"fignole" => "fiNOl",
"fignolé" => "fiNole",
"fignolée" => "fiNole",
"fignolent" => "fiNOl",
"fignoler" => "fiNole",
"fignolerai" => "fiNOl°RE",
"fignolerais" => "fiNOl°RE",
"fignolerait" => "fiNOl°RE",
"fignolés" => "fiNole",
"fignoleur" => "fiNOl9R",
"fignolons" => "fiNol§",
"figue" => "fig",
"figues" => "fig",
"figuier" => "figje",
"figuiers" => "figje",
"figura" => "figyRa",
"figurai" => "figyRE",
"figuraient" => "figyRE",
"figurais" => "figyRE",
"figurait" => "figyRE",
"figurant" => "figyR@",
"figurante" => "figyR@t",
"figurantes" => "figyR@t",
"figurants" => "figyR@",
"figurât" => "figyRa",
"figuratif" => "figyRatif",
"figuratifs" => "figyRatif",
"figuration" => "figyRasj§",
"figurations" => "figyRasj§",
"figurative" => "figyRativ",
"figurativement" => "figyRativ°m@",
"figuratives" => "figyRativ",
"figure" => "figyR",
"figuré" => "figyRe",
"figurée" => "figyRe",
"figurées" => "figyRe",
"figurent" => "figyR",
"figurer" => "figyRe",
"figurera" => "figyR°Ra",
"figureraient" => "figyR°RE",
"figurerait" => "figyR°RE",
"figurèrent" => "figyRER",
"figures" => "figyR",
"figurés" => "figyRe",
"figurez" => "figyRe",
"figuriez" => "figyRje",
"figurine" => "figyRin",
"figurines" => "figyRin",
"figurions" => "figyRj§",
"fil" => "fil",
"fil-à-fil" => "filafil",
"fila" => "fila",
"filage" => "filaZ",
"filai" => "filE",
"filaient" => "filE",
"filaire" => "filER",
"filais" => "filE",
"filait" => "filE",
"filament" => "filam@",
"filamenteux" => "filam@t2",
"filaments" => "filam@",
"filâmes" => "filam",
"filandres" => "fil@dR",
"filandreuse" => "fil@dR2z",
"filandreuses" => "fil@dR2z",
"filandreux" => "fil@dR2",
"filant" => "fil@",
"filante" => "fil@t",
"filantes" => "fil@t",
"filaos" => "filao",
"filariose" => "filaRjoz",
"filasse" => "filas",
"filasses" => "filas",
"filât" => "fila",
"filateur" => "filat9R",
"filateurs" => "filat9R",
"filature" => "filatyR",
"filatures" => "filatyR",
"file" => "fil",
"filé" => "file",
"file-la-moi" => "fillamwa",
"filée" => "file",
"filées" => "file",
"filent" => "fil",
"filer" => "file",
"filera" => "fil°Ra",
"filerai" => "fil°RE",
"fileraient" => "fil°RE",
"filerais" => "fil°RE",
"filerait" => "fil°RE",
"fileras" => "fil°Ra",
"filèrent" => "filER",
"filerez" => "fil°Re",
"fileriez" => "fil°Rje",
"filerons" => "fil°R§",
"fileront" => "fil°R§",
"files" => "fil",
"filés" => "file",
"filet" => "filE",
"filetage" => "fil°taZ",
"fileté" => "fil°te",
"filetée" => "fil°te",
"filets" => "filE",
"fileur" => "fil9R",
"fileuse" => "fil2z",
"filez" => "file",
"filial" => "filjal",
"filiale" => "filjal",
"filialement" => "filjal°m@",
"filiales" => "filjal",
"filiation" => "filjasj§",
"filiations" => "filjasj§",
"filiaux" => "filjo",
"filière" => "filjER",
"filières" => "filjER",
"filiez" => "filje",
"filiforme" => "filifORm",
"filiformes" => "filifORm",
"filigrane" => "filigRan",
"filigranes" => "filigRan",
"filigranés" => "filigRane",
"filin" => "fil5",
"filins" => "fil5",
"filions" => "filj§",
"filioque" => "filjOk",
"fillasses" => "fijas",
"fille" => "fij",
"fille-mère" => "fijmER",
"fillér" => "fjeR",
"filles" => "fij",
"fillette" => "fijEt",
"fillettes" => "fijEt",
"filleul" => "fij9l",
"filleule" => "fij9l",
"filleuls" => "fij9l",
"film" => "film",
"film-livre" => "filmlivR",
"filma" => "filma",
"filmage" => "filmaZ",
"filmaient" => "filmE",
"filmais" => "filmE",
"filmait" => "filmE",
"filmant" => "film@",
"filme" => "film",
"filmé" => "filme",
"filmée" => "filme",
"filmées" => "filme",
"filment" => "film",
"filmer" => "filme",
"filmera" => "film°Ra",
"filmerai" => "film°RE",
"filmerais" => "film°RE",
"filmerait" => "film°RE",
"filmerez" => "film°Re",
"filmeront" => "film°R§",
"filmes" => "film",
"filmés" => "filme",
"filmez" => "filme",
"filmiez" => "filmje",
"filmions" => "filmj§",
"filmique" => "filmik",
"filmographie" => "filmogRafi",
"filmons" => "film§",
"filmothèque" => "filmOtEk",
"films" => "film",
"films-annonces" => "filman§s",
"filochard" => "filoSaR",
"filoche" => "filOS",
"filoché" => "filoSe",
"filocher" => "filoSe",
"filochez" => "filoSe",
"filoguidé" => "filogide",
"filon" => "fil§",
"filons" => "fil§",
"filoselle" => "filozEl",
"filou" => "filu",
"filous" => "filu",
"filouté" => "filute",
"filouter" => "filute",
"filouterie" => "filut°Ri",
"filouteries" => "filut°Ri",
"filoutes" => "filut",
"filoutés" => "filute",
"fils" => "fis",
"filtra" => "filtRa",
"filtrage" => "filtRaZ",
"filtraient" => "filtRE",
"filtrais" => "filtRE",
"filtrait" => "filtRE",
"filtrant" => "filtR@",
"filtrantes" => "filtR@t",
"filtrants" => "filtR@",
"filtration" => "filtRasj§",
"filtrations" => "filtRasj§",
"filtre" => "filtR",
"filtré" => "filtRe",
"filtrée" => "filtRe",
"filtrées" => "filtRe",
"filtrent" => "filtR",
"filtrer" => "filtRe",
"filtrerait" => "filtR°RE",
"filtrèrent" => "filtRER",
"filtres" => "filtR",
"filtrés" => "filtRe",
"filtrez" => "filtRe",
"fîmes" => "fim",
"fin" => "f5",
"finage" => "finaZ",
"final" => "final",
"finale" => "final",
"finalement" => "final°m@",
"finales" => "final",
"finalisation" => "finalizasj§",
"finalisé" => "finalize",
"finalisées" => "finalize",
"finaliser" => "finalize",
"finaliste" => "finalist",
"finalistes" => "finalist",
"finalité" => "finalite",
"finalités" => "finalite",
"finals" => "final",
"finançai" => "fin@sE",
"finançaient" => "fin@sE",
"finançait" => "fin@sE",
"finançant" => "fin@s@",
"finance" => "fin@s",
"financé" => "fin@se",
"financée" => "fin@se",
"financement" => "fin@s°m@",
"financements" => "fin@s°m@",
"financent" => "fin@s",
"financer" => "fin@se",
"financera" => "fin@s°Ra",
"financerai" => "fin@s°RE",
"financeraient" => "fin@s°RE",
"financerait" => "fin@s°RE",
"financeras" => "fin@s°Ra",
"financerons" => "fin@s°R§",
"financeront" => "fin@s°R§",
"finances" => "fin@s",
"financés" => "fin@se",
"financez" => "fin@se",
"financier" => "fin@sje",
"financière" => "fin@sjER",
"financièrement" => "fin@sjER°m@",
"financières" => "fin@sjER",
"financiers" => "fin@sje",
"financiez" => "fin@sje",
"finançons" => "fin@s§",
"finassait" => "finasE",
"finasse" => "finas",
"finassé" => "finase",
"finasser" => "finase",
"finasserie" => "finas°Ri",
"finasseries" => "finas°Ri",
"finasses" => "finas",
"finassons" => "finas§",
"finaud" => "fino",
"finaude" => "finod",
"finauds" => "fino",
"finaux" => "fino",
"fine" => "fin",
"finement" => "fin°m@",
"fines" => "fin",
"finesse" => "finEs",
"finesses" => "finEs",
"finet" => "finE",
"finette" => "finEt",
"fini" => "fini",
"finie" => "fini",
"finies" => "fini",
"finîmes" => "finim",
"finir" => "finiR",
"finira" => "finiRa",
"finirai" => "finiRE",
"finiraient" => "finiRE",
"finirais" => "finiRE",
"finirait" => "finiRE",
"finiras" => "finiRa",
"finirent" => "finiR",
"finirez" => "finiRe",
"finiriez" => "finiRje",
"finirions" => "finiRj§",
"finirons" => "finiR§",
"finiront" => "finiR§",
"finis" => "fini",
"finish" => "finiS",
"finissaient" => "finisE",
"finissais" => "finisE",
"finissait" => "finisE",
"finissant" => "finis@",
"finissante" => "finis@t",
"finissantes" => "finis@t",
"finissants" => "finis@",
"finisse" => "finis",
"finissent" => "finis",
"finisses" => "finis",
"finisseur" => "finis9R",
"finisseuse" => "finis2z",
"finissez" => "finise",
"finissiez" => "finisje",
"finissions" => "finisj§",
"finissons" => "finis§",
"finit" => "fini",
"finît" => "fini",
"finition" => "finisj§",
"finitions" => "finisj§",
"finitude" => "finityd",
"finlandais" => "f5l@dE",
"finlandaise" => "f5l@dEz",
"finlandaises" => "f5l@dEz",
"finlandisation" => "f5l@dizasj§",
"finnois" => "finwa",
"fins" => "f5",
"fiole" => "fjOl",
"fioles" => "fjOl",
"fion" => "fj§",
"fions" => "fj§",
"fiord" => "fjORd",
"fioriture" => "fjoRityR",
"fioritures" => "fjoRityR",
"fioul" => "fjul",
"firent" => "fiR",
"firmament" => "fiRmam@",
"firmaments" => "fiRmam@",
"firman" => "fiRm@",
"firmans" => "fiRm@",
"firme" => "fiRm",
"firmes" => "fiRm",
"fis" => "fi",
"fisc" => "fisk",
"fiscal" => "fiskal",
"fiscale" => "fiskal",
"fiscalement" => "fiskal°m@",
"fiscales" => "fiskal",
"fiscaliste" => "fiskalist",
"fiscalité" => "fiskalite",
"fiscaux" => "fisko",
"fissa" => "fisa",
"fisse" => "fis",
"fissent" => "fis",
"fissible" => "fisibl",
"fissibles" => "fisibl",
"fissiez" => "fisje",
"fission" => "fisj§",
"fissionné" => "fisjone",
"fissionner" => "fisjone",
"fissions" => "fisj§",
"fissurait" => "fisyRE",
"fissurant" => "fisyR@",
"fissure" => "fisyR",
"fissuré" => "fisyRe",
"fissurée" => "fisyRe",
"fissurées" => "fisyRe",
"fissurent" => "fisyR",
"fissurer" => "fisyRe",
"fissures" => "fisyR",
"fissurés" => "fisyRe",
"fiston" => "fist§",
"fistons" => "fist§",
"fistule" => "fistyl",
"fistules" => "fistyl",
"fit" => "fi",
"fît" => "fi",
"fîtes" => "fit",
"fitness" => "fitnEs",
"fitzgéraldiennes" => "fitsZeRaldjEn",
"five o'clock" => "fajvoklOk",
"fivete" => "fivEt",
"fixa" => "fiksa",
"fixage" => "fiksaZ",
"fixai" => "fiksE",
"fixaient" => "fiksE",
"fixais" => "fiksE",
"fixait" => "fiksE",
"fixâmes" => "fiksam",
"fixant" => "fiks@",
"fixât" => "fiksa",
"fixateur" => "fiksat9R",
"fixatif" => "fiksatif",
"fixation" => "fiksasj§",
"fixations" => "fiksasj§",
"fixe" => "fiks",
"fixé" => "fikse",
"fixe-chaussettes" => "fiksSosEt",
"fixée" => "fikse",
"fixées" => "fikse",
"fixement" => "fiks°m@",
"fixent" => "fiks",
"fixer" => "fikse",
"fixera" => "fiks°Ra",
"fixerai" => "fiks°RE",
"fixeraient" => "fiks°RE",
"fixerais" => "fiks°RE",
"fixerait" => "fiks°RE",
"fixeras" => "fiks°Ra",
"fixèrent" => "fiksER",
"fixerez" => "fiks°Re",
"fixeriez" => "fiks°Rje",
"fixerons" => "fiks°R§",
"fixeront" => "fiks°R§",
"fixes" => "fiks",
"fixés" => "fikse",
"fixette" => "figzEt",
"fixez" => "fikse",
"fixiez" => "fiksje",
"fixing" => "fiksiG",
"fixions" => "fiksj§",
"fixité" => "fiksite",
"fixons" => "fiks§",
"fjord" => "fjORd",
"fjords" => "fjORd",
"fla" => "fla",
"flac" => "flak",
"flaccide" => "flaksid",
"flaccidité" => "flaksidite",
"flache" => "flaS",
"flaches" => "flaS",
"flacon" => "flak§",
"flacons" => "flak§",
"flafla" => "flafla",
"flag" => "flag",
"flagada" => "flagada",
"flagella" => "flaZEla",
"flagellaient" => "flaZElE",
"flagellait" => "flaZElE",
"flagellant" => "flaZ2l@",
"flagellants" => "flaZEl@",
"flagellateur" => "flaZElat9R",
"flagellation" => "flaZElasj§",
"flagellations" => "flaZelasj§",
"flagelle" => "flaZEl",
"flagellé" => "flaZEle",
"flagellée" => "flaZEle",
"flagellées" => "flaZEle",
"flagellent" => "flaZEl",
"flageller" => "flaZele",
"flagellerez" => "flaZEl°Re",
"flagelleront" => "flaZEl°R§",
"flagellés" => "flaZEle",
"flageola" => "flaZola",
"flageolai" => "flaZolE",
"flageolaient" => "flaZolE",
"flageolait" => "flaZolE",
"flageolant" => "flaZol@",
"flageolante" => "flaZol@t",
"flageolantes" => "flaZol@t",
"flageolants" => "flaZol@",
"flageole" => "flaZOl",
"flageolent" => "flaZOl",
"flageoler" => "flaZole",
"flageolèrent" => "flaZolER",
"flageoleront" => "flaZOl°R§",
"flageolet" => "flaZolE",
"flageolets" => "flaZolE",
"flagornait" => "flagORnE",
"flagornent" => "flagORn",
"flagorner" => "flagORne",
"flagornerie" => "flagORn°Ri",
"flagorneries" => "flagORn°Ri",
"flagorneur" => "flagORn9R",
"flagorneurs" => "flagORn9R",
"flagorneuse" => "flagORn2z",
"flagrance" => "flagR@s",
"flagrant" => "flagR@",
"flagrante" => "flagR@t",
"flagrantes" => "flagR@t",
"flagrants" => "flagR@",
"flahutes" => "flayt",
"flair" => "flER",
"flaira" => "flERa",
"flairaient" => "flERE",
"flairais" => "flERE",
"flairait" => "flERE",
"flairant" => "flER@",
"flaire" => "flER",
"flairé" => "fleRe",
"flairée" => "fleRe",
"flairent" => "flER",
"flairer" => "fleRe",
"flairera" => "flER°Ra",
"flairerait" => "flER°RE",
"flaires" => "flER",
"flairés" => "fleRe",
"flaireur" => "flER9R",
"flaireurs" => "flER9R",
"flaireuse" => "flER2z",
"flairez" => "flERe",
"flamand" => "flam@",
"flamande" => "flam@d",
"flamandes" => "flam@d",
"flamands" => "flam@",
"flamant" => "flam@",
"flamants" => "flam@",
"flamba" => "fl@ba",
"flambaient" => "fl@bE",
"flambait" => "fl@bE",
"flambant" => "fl@b@",
"flambante" => "fl@b@t",
"flambantes" => "fl@b@t",
"flambants" => "fl@b@",
"flambard" => "fl@baR",
"flambe" => "fl@b",
"flambé" => "fl@be",
"flambeau" => "fl@bo",
"flambeaux" => "fl@bo",
"flambée" => "fl@be",
"flambées" => "fl@be",
"flambent" => "fl@b",
"flamber" => "fl@be",
"flambera" => "fl@b°Ra",
"flamberaient" => "fl@b°RE",
"flamberait" => "fl@b°RE",
"flambèrent" => "fl@bER",
"flamberge" => "fl@bERZ",
"flamberont" => "fl@b°R§",
"flambes" => "fl@b",
"flambés" => "fl@be",
"flambeur" => "fl@b9R",
"flambeurs" => "fl@b9R",
"flambeuse" => "fl@b2z",
"flambez" => "fl@be",
"flamboie" => "fl@bwa",
"flamboiement" => "fl@bwam@",
"flamboiements" => "fl@bwam@",
"flamboient" => "fl@bwa",
"flamboierait" => "fl@bwaRE",
"flambons" => "fl@b§",
"flamboya" => "fl@bwaja",
"flamboyaient" => "fl@bwajE",
"flamboyait" => "fl@bwajE",
"flamboyance" => "fl@bwaj@s",
"flamboyant" => "fl@bwaj@",
"flamboyante" => "fl@bwaj@t",
"flamboyantes" => "fl@bwaj@t",
"flamboyants" => "fl@bwaj@",
"flamboyer" => "fl@bwaje",
"flamboyèrent" => "fl@bwajER",
"flamenco" => "flamEnko",
"flamencos" => "flamEnko",
"flamine" => "flamin",
"flamme" => "flam",
"flammé" => "flame",
"flammèche" => "flamES",
"flammèches" => "flamES",
"flammée" => "flame",
"flammes" => "flam",
"flammés" => "flame",
"flan" => "fl@",
"flâna" => "flana",
"flânai" => "flanE",
"flânaient" => "flanE",
"flânais" => "flanE",
"flânait" => "flanE",
"flânant" => "flan@",
"flanc" => "fl@",
"flanc-garde" => "fl@gaRd",
"flancha" => "fl@Sa",
"flanchais" => "fl@SE",
"flanchait" => "fl@SE",
"flanche" => "fl@S",
"flanché" => "fl@Se",
"flanchent" => "fl@S",
"flancher" => "fl@Se",
"flanchera" => "fl@S°Ra",
"flancherai" => "fl@S°RE",
"flancheraient" => "fl@S°RE",
"flancherait" => "fl@S°RE",
"flanchet" => "fl@SE",
"flancs" => "fl@",
"flancs-gardes" => "fl@gaRd",
"flandrin" => "fl@dR5",
"flâne" => "flan",
"flâné" => "flane",
"flanelle" => "flanEl",
"flanelles" => "flanEl",
"flânent" => "flan",
"flâner" => "flane",
"flânera" => "flan°Ra",
"flânerais" => "flan°RE",
"flânerait" => "flan°RE",
"flânerie" => "flan°Ri",
"flâneries" => "flan°Ri",
"flâneront" => "flan°R§",
"flâneur" => "flan9R",
"flâneurs" => "flan9R",
"flâneuse" => "flan2z",
"flâneuses" => "flan2z",
"flânions" => "flanj§",
"flânochent" => "flanOS",
"flânocher" => "flanoSe",
"flânons" => "flan§",
"flanqua" => "fl@ka",
"flanquaient" => "fl@kE",
"flanquait" => "fl@kE",
"flanquant" => "fl@k@",
"flanque" => "fl@k",
"flanqué" => "fl@ke",
"flanquée" => "fl@ke",
"flanquées" => "fl@ke",
"flanquement" => "fl@k°m@",
"flanquent" => "fl@k",
"flanquer" => "fl@ke",
"flanquera" => "fl@k°Ra",
"flanquerai" => "fl@k°RE",
"flanqueraient" => "fl@k°RE",
"flanquerais" => "fl@k°RE",
"flanquerait" => "fl@k°RE",
"flanquerez" => "fl@k°Re",
"flanques" => "fl@k",
"flanqués" => "fl@ke",
"flanquez" => "fl@ke",
"flanquons" => "fl@k§",
"flans" => "fl@",
"flapi" => "flapi",
"flapie" => "flapi",
"flapies" => "flapi",
"flapis" => "flapi",
"flaque" => "flak",
"flaques" => "flak",
"flash" => "flaS",
"flash-back" => "flaSbak",
"flashage" => "flaSaZ",
"flashaient" => "flaSE",
"flashant" => "flaS@",
"flashe" => "flaS",
"flashé" => "flaSe",
"flashent" => "flaS",
"flasher" => "flaSe",
"flashes" => "flaS",
"flasheur" => "flaS9R",
"flashs" => "flaS",
"flask" => "flask",
"flasque" => "flask",
"flasques" => "flask",
"flat" => "fla",
"flats" => "fla",
"flatta" => "flata",
"flattai" => "flatE",
"flattaient" => "flatE",
"flattais" => "flatE",
"flattait" => "flatE",
"flattant" => "flat@",
"flattasse" => "flatas",
"flattassent" => "flatas",
"flatte" => "flat",
"flatté" => "flate",
"flattée" => "flate",
"flattées" => "flate",
"flattent" => "flat",
"flatter" => "flate",
"flatteras" => "flat°Ra",
"flattèrent" => "flatER",
"flatterie" => "flat°Ri",
"flatteries" => "flat°Ri",
"flatteront" => "flat°R§",
"flattes" => "flat",
"flattés" => "flate",
"flatteur" => "flat9R",
"flatteurs" => "flat9R",
"flatteuse" => "flat2z",
"flatteuses" => "flat2z",
"flattez" => "flate",
"flattions" => "flatj§",
"flattons" => "flat§",
"flatulence" => "flatyl@s",
"flatulences" => "flatyl@s",
"flatulent" => "flatyl@",
"flatulents" => "flatyl@",
"flatuosité" => "flat8ozite",
"flatus vocis" => "flatyvosi",
"flave" => "flav",
"flaveur" => "flav9R",
"fléau" => "fleo",
"fléaux" => "fleo",
"flèche" => "flES",
"fléché" => "fleSe",
"fléchée" => "fleSe",
"fléchées" => "fleSe",
"flécher" => "fleSe",
"flèches" => "flES",
"fléchés" => "fleSe",
"fléchette" => "fleSEt",
"fléchettes" => "fleSEt",
"fléchi" => "fleSi",
"fléchie" => "fleSi",
"fléchies" => "fleSi",
"fléchir" => "fleSiR",
"fléchiraient" => "fleSiRE",
"fléchirait" => "fleSiRE",
"fléchirent" => "fleSiR",
"fléchis" => "fleSi",
"fléchissaient" => "fleSisE",
"fléchissais" => "fleSisE",
"fléchissait" => "fleSisE",
"fléchissant" => "fleSis@",
"fléchisse" => "fleSis",
"fléchissement" => "fleSis°m@",
"fléchissements" => "fleSis°m@",
"fléchissent" => "fleSis",
"fléchisseur" => "fleSis9R",
"fléchissez" => "fleSise",
"fléchissions" => "fleSisj§",
"fléchissons" => "fleSis§",
"fléchit" => "fleSi",
"flegmatique" => "flEgmatik",
"flegmatiquement" => "flEgmatik°m@",
"flegmatiques" => "flEgmatik",
"flegmatisme" => "flEgmatizm",
"flegme" => "flEgm",
"flemmard" => "flemaR",
"flemmardais" => "flEmaRdE",
"flemmardant" => "flEmaRd@",
"flemmarde" => "flemaRd",
"flemmarder" => "flemaRde",
"flemmardes" => "flEmaRd",
"flemmardise" => "flEmaRdiz",
"flemmards" => "flemaR",
"flemme" => "flEm",
"flemmer" => "fleme",
"fléole" => "fleOl",
"flétan" => "flet@",
"flétans" => "flet@",
"flétri" => "fletRi",
"flétrie" => "fletRi",
"flétries" => "fletRi",
"flétrir" => "fletRiR",
"flétrira" => "fletRiRa",
"flétrirai" => "fletRiRE",
"flétrirent" => "fletRiR",
"flétriront" => "fletRiR§",
"flétris" => "fletRi",
"flétrissaient" => "fletRisE",
"flétrissait" => "fletRisE",
"flétrissant" => "fletRis@",
"flétrissement" => "fletRis°m@",
"flétrissent" => "fletRis",
"flétrissure" => "fletRisyR",
"flétrissures" => "fletRisyR",
"flétrit" => "fletRi",
"flétrît" => "fletRi",
"fleur" => "fl9R",
"fleurage" => "fl9RaZ",
"fleuraient" => "fl9RE",
"fleurais" => "fl9RE",
"fleurait" => "fl9RE",
"fleurant" => "fl9R@",
"fleurdelisé" => "fl9Rd°lize",
"fleurdelisée" => "fl9Rd°lize",
"fleurdelisés" => "fl9Rd°lize",
"fleure" => "fl9R",
"fleurent" => "fl9R",
"fleurer" => "fl9Re",
"fleuret" => "fl9RE",
"fleuretais" => "fl9R°tE",
"fleuretait" => "fl9R°tE",
"fleurets" => "fl9RE",
"fleurette" => "fl9REt",
"fleurettes" => "fl9REt",
"fleuri" => "fl9Ri",
"fleurie" => "fl9Ri",
"fleuries" => "fl9Ri",
"fleurir" => "fl9RiR",
"fleurira" => "fl9RiRa",
"fleuriraient" => "fl9RiRE",
"fleurirent" => "fl9RiR",
"fleuriront" => "fl9RiR§",
"fleuris" => "fl9Ri",
"fleurissaient" => "fl9RisE",
"fleurissait" => "fl9RisE",
"fleurissant" => "fl9Ris@",
"fleurisse" => "fl9Ris",
"fleurissement" => "fl9Ris°m@",
"fleurissent" => "f°l9Ris",
"fleurissiez" => "fl9Risje",
"fleurissons" => "fl9Ris§",
"fleuriste" => "fl9Rist",
"fleuristes" => "fl9Rist",
"fleurit" => "fl9Ri",
"fleuron" => "fl9R§",
"fleuronnée" => "fl9Rone",
"fleuronner" => "fl9ROne",
"fleurons" => "fl9R§",
"fleurs" => "fl9R",
"fleuve" => "fl9v",
"fleuves" => "fl9v",
"flexibilité" => "flEksibilite",
"flexible" => "flEksibl",
"flexibles" => "flEksibl",
"flexion" => "flEksj§",
"flexions" => "flEksj§",
"flexuosité" => "flEks8ozite",
"flibuste" => "flibyst",
"flibustier" => "flibystje",
"flibustiers" => "flibystje",
"flic" => "flik",
"flicage" => "flikaZ",
"flicaille" => "flikaj",
"flicailles" => "flikaj",
"flicard" => "flikaR",
"flicarde" => "flikaRd",
"flicardes" => "flikaRd",
"flicards" => "flikaR",
"flics" => "flik",
"flingage" => "fl5gaZ",
"flingot" => "fl5go",
"flingoté" => "fl5gote",
"flingots" => "fl5go",
"flinguait" => "fl5gE",
"flinguant" => "fl5g@",
"flinguât" => "fl5ga",
"flingue" => "fl5g",
"flingué" => "fl5ge",
"flinguée" => "fl5ge",
"flinguent" => "fl5g",
"flinguer" => "fl5ge",
"flinguera" => "fl5g°Ra",
"flinguerai" => "fl5g°RE",
"flingueraient" => "fl5g°RE",
"flinguerais" => "fl5g°RE",
"flingueront" => "fl5g°R§",
"flingues" => "fl5g",
"flingués" => "fl5ge",
"flingueur" => "fl5g9R",
"flingueurs" => "fl5g9R",
"flingueuse" => "fl5g2z",
"flingueuses" => "fl5g2z",
"flinguez" => "fl5ge",
"flinguons" => "fl5g§",
"flint" => "flint",
"flip" => "flip",
"flip-flap" => "flipflap",
"flip-flop" => "flipflOp",
"flippais" => "flipE",
"flippait" => "flipE",
"flippant" => "flip@",
"flippe" => "flip",
"flippé" => "flipe",
"flippée" => "flipe",
"flippent" => "flip",
"flipper" => "flipe",
"flipperais" => "flip°RE",
"flipperait" => "flip°RE",
"flipperont" => "flip°R§",
"flippers" => "flip9R",
"flippes" => "flip",
"flippés" => "flipe",
"flips" => "flip",
"fliqué" => "flike",
"fliquer" => "flike",
"fliqués" => "flike",
"fliquesse" => "flikEs",
"flirt" => "fl9Rt",
"flirta" => "fl9Rta",
"flirtaient" => "fl9RtE",
"flirtais" => "fl9RtE",
"flirtait" => "fl9RtE",
"flirtant" => "fl9Rt@",
"flirtation" => "fl9Rtasj§",
"flirte" => "fl9Rt",
"flirté" => "fl9Rte",
"flirtent" => "fl9Rt",
"flirter" => "fl9Rte",
"flirtèrent" => "fl9RtER",
"flirteront" => "fl9Rt°R§",
"flirtes" => "fl9Rt",
"flirteur" => "fl9Rt9R",
"flirteuse" => "fl9Rt2z",
"flirteuses" => "fl9Rt2z",
"flirtez" => "fl9Rte",
"flirtiez" => "fl9Rtje",
"flirtons" => "fl9Rt§",
"flirts" => "fl9Rt",
"floc" => "flOk",
"floche" => "flOS",
"floches" => "flOS",
"flocon" => "flok§",
"floconne" => "flokOn",
"floconnent" => "flokOn",
"floconneuse" => "flokon2z",
"floconneuses" => "flokon2z",
"floconneux" => "flokon2",
"flocons" => "flok§",
"floculation" => "flokylasj§",
"floculent" => "flokyl",
"flonflon" => "fl§fl§",
"flonflons" => "fl§fl§",
"flood" => "flud",
"flop" => "flOp",
"flopée" => "flope",
"flopées" => "flope",
"flops" => "flOp",
"floraison" => "floREz§",
"floraisons" => "floREz§",
"floral" => "floRal",
"florale" => "floRal",
"florales" => "floRal",
"floralies" => "floRali",
"floraux" => "floRo",
"flore" => "flOR",
"floréal" => "floReal",
"florence" => "floR@s",
"florentin" => "floR@t5",
"florentine" => "floR@tin",
"florentines" => "floR@tin",
"florentins" => "floR@t5",
"flores" => "flOR",
"florès" => "floREs",
"florilège" => "floRilEZ",
"florin" => "floR5",
"florins" => "floR5",
"florissaient" => "floRisE",
"florissait" => "floRisE",
"florissant" => "floRis@",
"florissante" => "floRis@t",
"florissantes" => "floRis@t",
"florissants" => "floRis@",
"flot" => "flo",
"flots" => "flo",
"flotta" => "flota",
"flottabilité" => "flotabilite",
"flottage" => "flotaZ",
"flottaient" => "flotE",
"flottais" => "flotE",
"flottaison" => "flotEz§",
"flottaisons" => "flotEz§",
"flottait" => "flotE",
"flottant" => "flot@",
"flottante" => "flot@t",
"flottantes" => "flot@t",
"flottants" => "flot@",
"flottât" => "flota",
"flottation" => "flOtasj§",
"flotte" => "flOt",
"flotté" => "flote",
"flottée" => "flote",
"flottées" => "flote",
"flottement" => "flOt°m@",
"flottements" => "flOt°m@",
"flottent" => "flOt",
"flotter" => "flote",
"flottera" => "flOt°Ra",
"flotteraient" => "flOt°RE",
"flotterait" => "flOt°RE",
"flotteras" => "flOt°Ra",
"flottèrent" => "flotER",
"flotterez" => "flOt°Re",
"flotteront" => "flOt°R§",
"flottes" => "flOt",
"flottés" => "flote",
"flotteur" => "flot9R",
"flotteurs" => "flot9R",
"flottez" => "flote",
"flottiez" => "flotje",
"flottille" => "flotij",
"flottilles" => "flotij",
"flottions" => "flotj§",
"flou" => "flu",
"flouant" => "flu@",
"floue" => "flu",
"floué" => "flue",
"flouée" => "flue",
"flouer" => "flue",
"flouerie" => "fluRi",
"floues" => "flu",
"floués" => "flue",
"flous" => "flu",
"flouse" => "fluz",
"flouve" => "fluv",
"flouzaille" => "fluzaj",
"flouze" => "fluz",
"fluaient" => "flyE",
"fluait" => "flyE",
"flubes" => "flyb",
"fluctuait" => "flykt8E",
"fluctuant" => "flykt8@",
"fluctuante" => "flykt8@t",
"fluctuation" => "flykt8asj§",
"fluctuations" => "flykt8asj§",
"fluctue" => "flykty",
"fluctué" => "flykt8e",
"fluctuent" => "flykty",
"fluctuer" => "flykt8e",
"fluctuerait" => "flyktyRE",
"fluence" => "fly@s",
"fluet" => "flyE",
"fluets" => "flyE",
"fluette" => "flyEt",
"fluettes" => "flyEt",
"fluide" => "fl8id",
"fluidement" => "fl8id°m@",
"fluides" => "fl8id",
"fluidifiant" => "fl8idifj@",
"fluidifié" => "fl8idifje",
"fluidifier" => "fl8idifje",
"fluidiques" => "fl8idik",
"fluidité" => "fl8idite",
"fluo" => "flyo",
"fluor" => "flyOR",
"fluorée" => "flyoRe",
"fluorescéine" => "flyOResein",
"fluorescence" => "flyoRes@s",
"fluorescent" => "flyoRes@",
"fluorescente" => "flyoRes@t",
"fluorescentes" => "flyoRes@t",
"fluorescents" => "flyoRes@",
"fluorhydrique" => "flyoRidRik",
"fluorite" => "flyORit",
"fluorure" => "flyoRyR",
"flush" => "fl9S",
"flûta" => "flyta",
"flûte" => "flyt",
"flûté" => "flyte",
"flûtée" => "flyte",
"flûter" => "flyte",
"flûtes" => "flyt",
"flûtés" => "flyte",
"flûtiau" => "flytjo",
"flûtiste" => "flytist",
"flûtistes" => "flytist",
"fluvial" => "flyvjal",
"fluviale" => "flyvjal",
"fluviales" => "flyvjal",
"fluviatile" => "flyvjatil",
"fluviaux" => "flyvjo",
"flux" => "fly",
"fluxe" => "flyks",
"fluxion" => "flyksj§",
"foc" => "fOk",
"focal" => "fokal",
"focale" => "fokal",
"focales" => "fokal",
"focalisation" => "fokalizasj§",
"focalise" => "fokaliz",
"focalisé" => "fokalize",
"focaliser" => "fokalize",
"focalisés" => "fokalize",
"focalisez" => "fokalize",
"focalisons" => "fokaliz§",
"focaux" => "fOko",
"focs" => "fOk",
"foehn" => "f2n",
"foëne" => "fwEn",
"foetal" => "fetal",
"foetale" => "fetal",
"foetales" => "fetal",
"foetaux" => "feto",
"foetus" => "fetys",
"fofolle" => "fofOl",
"fofolles" => "fofOl",
"foi" => "fwa",
"foie" => "fwa",
"foies" => "fwa",
"foil" => "fOjl",
"foin" => "fw5",
"foins" => "fw5",
"foira" => "fwaRa",
"foirade" => "fwaRad",
"foirades" => "fwaRad",
"foiraient" => "fwaRE",
"foirail" => "fwaRaj",
"foirails" => "fwaRaj",
"foirais" => "fwaRE",
"foirait" => "fwaRE",
"foire" => "fwaR",
"foiré" => "fwaRe",
"foirée" => "fwaRe",
"foirées" => "fwaRe",
"foirent" => "fwaR",
"foirer" => "fwaRe",
"foirera" => "fwaR°Ra",
"foires" => "fwaR",
"foirés" => "fwaRe",
"foireuse" => "fwaR2z",
"foireuses" => "fwaR2z",
"foireux" => "fwaR2",
"foirez" => "fwaRe",
"foiridon" => "fwaRid§",
"fois" => "fwa",
"foison" => "fwaz§",
"foisonnaient" => "fwazonE",
"foisonnait" => "fwazonE",
"foisonnant" => "fwazon@",
"foisonnante" => "fwazon@t",
"foisonnantes" => "fwazon@t",
"foisonne" => "fwazOn",
"foisonnement" => "fwazOn°m@",
"foisonnent" => "fwazOn",
"foisonner" => "fwazone",
"foisonneraient" => "fwazOn°RE",
"foisonneront" => "fwazOn°R§",
"fol" => "fOl",
"folasse" => "folas",
"folâtraient" => "folatRE",
"folâtrait" => "folatRE",
"folâtre" => "folatR",
"folâtrent" => "folatR",
"folâtrer" => "folatRe",
"folâtreries" => "folatR°Ri",
"folâtres" => "folatR",
"foldingue" => "fold5g",
"foldingues" => "fold5g",
"foliacée" => "foljase",
"folichon" => "fOliS§",
"folichonnait" => "foliSonE",
"folichonne" => "foliSOn",
"folichonneries" => "foliSOn°Ri",
"folichonnes" => "foliSOn",
"folie" => "foli",
"folies" => "foli",
"folingue" => "fol5g",
"folingues" => "fol5g",
"folio" => "foljo",
"folioles" => "foljOl",
"folios" => "foljo",
"folique" => "fOlik",
"folk" => "fOlk",
"folklo" => "fOlklo",
"folklore" => "fOlklOR",
"folklores" => "fOlklOR",
"folklorique" => "fOlkloRik",
"folkloriques" => "fOlkloRik",
"folkloriste" => "fOlkloRist",
"folkloristes" => "fOlkloRist",
"folks" => "fOlk",
"folle" => "fOl",
"folledingue" => "fOl°d5g",
"follement" => "fOl°m@",
"folles" => "fOl",
"follet" => "folE",
"follets" => "folE",
"follette" => "folEt",
"follettes" => "folEt",
"folliculaire" => "folikylER",
"folliculaires" => "folikylER",
"follicule" => "folikyl",
"follicules" => "folikyl",
"folliculite" => "fOlikylit",
"follingue" => "fol5g",
"fols" => "fOl",
"fomentaient" => "fom@tE",
"fomentait" => "fom@tE",
"fomentateurs" => "fom@tat9R",
"fomente" => "fom@t",
"fomenté" => "fom@te",
"fomentée" => "fom@te",
"fomentent" => "fom@t",
"fomenter" => "fom@te",
"fonça" => "f§sa",
"fonçai" => "f§sE",
"fonçaient" => "f§sE",
"fonçais" => "f§sE",
"fonçait" => "f§sE",
"fonçant" => "f§s@",
"fonce" => "f§s",
"foncé" => "f§se",
"foncée" => "f§se",
"foncées" => "f§se",
"foncent" => "f§s",
"foncer" => "f§se",
"foncera" => "f§s°Ra",
"foncerai" => "f§s°RE",
"fonceraient" => "f§s°RE",
"foncerais" => "f§s°RE",
"foncerait" => "f§s°RE",
"foncèrent" => "f§sER",
"foncerons" => "f§s°R§",
"fonceront" => "f§s°R§",
"fonces" => "f§s",
"foncés" => "f§se",
"fonceur" => "f§s9R",
"fonceurs" => "f§s9R",
"fonceuse" => "f§s2z",
"foncez" => "f§se",
"foncier" => "f§sje",
"foncière" => "f§sjER",
"foncièrement" => "f§sjER°m@",
"foncières" => "f§sjER",
"fonciers" => "f§sje",
"fonciez" => "f§sje",
"foncions" => "f§sj§",
"fonçons" => "f§s§",
"foncteur" => "f§kt9R",
"fonction" => "f§ksj§",
"fonctionna" => "f§ksjona",
"fonctionnaient" => "f§ksjonE",
"fonctionnaire" => "f§ksjonER",
"fonctionnaires" => "f§ksjonER",
"fonctionnais" => "f§ksjonE",
"fonctionnait" => "f§ksjonE",
"fonctionnaliste" => "f§ksjonalist",
"fonctionnalité" => "f§ksjOnalite",
"fonctionnant" => "f§ksjon@",
"fonctionnarisé" => "f§ksjonaRize",
"fonctionnarisée" => "f§ksjonaRize",
"fonctionnassent" => "f§ksjonas",
"fonctionnât" => "f§ksjona",
"fonctionne" => "f§ksjOn",
"fonctionné" => "f§ksjone",
"fonctionnel" => "f§ksjonEl",
"fonctionnelle" => "f§ksjonEl",
"fonctionnellement" => "f§ksjonEl°m@",
"fonctionnelles" => "f§ksjonEl",
"fonctionnels" => "f§ksjonEl",
"fonctionnement" => "f§ksjOn°m@",
"fonctionnent" => "f§ksjOn",
"fonctionner" => "f§ksjone",
"fonctionnera" => "f§ksjOn°Ra",
"fonctionneraient" => "f§ksjOn°RE",
"fonctionnerait" => "f§ksjOn°RE",
"fonctionneront" => "f§ksjOn°R§",
"fonctionnes" => "f§ksjOn",
"fonctionnez" => "f§ksjone",
"fonctionnons" => "f§ksjon§",
"fonctions" => "f§ksj§",
"fond" => "f§",
"fonda" => "f§da",
"fondaient" => "f§dE",
"fondais" => "f§dE",
"fondait" => "f§dE",
"fondamental" => "f§dam@tal",
"fondamentale" => "f§dam@tal",
"fondamentalement" => "f§dam@tal°m@",
"fondamentales" => "f§dam@tal",
"fondamentalisme" => "f§dam@talism",
"fondamentaliste" => "f§dam@talist",
"fondamentalistes" => "f§dam@talist",
"fondamentaux" => "f§dam@to",
"fondant" => "f§d@",
"fondante" => "f§d@t",
"fondantes" => "f§d@t",
"fondants" => "f§d@",
"fondât" => "f§da",
"fondateur" => "f§dat9R",
"fondateurs" => "f§dat9R",
"fondation" => "f§dasj§",
"fondations" => "f§dasj§",
"fondatrice" => "f§datRis",
"fondatrices" => "f§datRis",
"fonde" => "f§d",
"fondé" => "f§de",
"fondée" => "f§de",
"fondées" => "f§de",
"fondement" => "f§d°m@",
"fondements" => "f§d°m@",
"fondent" => "f§d",
"fonder" => "f§de",
"fondera" => "f§d°Ra",
"fonderais" => "f§d°RE",
"fonderait" => "f§d°RE",
"fondèrent" => "f§dER",
"fonderez" => "f§d°Re",
"fonderie" => "f§d°Ri",
"fonderies" => "f§d°Ri",
"fonderons" => "f§d°R§",
"fonderont" => "f§d°R§",
"fondés" => "f§de",
"fondeur" => "f§d9R",
"fondez" => "f§de",
"fondions" => "f§dj§",
"fondirent" => "f§diR",
"fondis" => "f§di",
"fondit" => "f§di",
"fondît" => "f§di",
"fondons" => "f§d§",
"fondouk" => "f§duk",
"fondra" => "f§dRa",
"fondrai" => "f§dRE",
"fondraient" => "f§dRE",
"fondrait" => "f§dRE",
"fondras" => "f§dRa",
"fondre" => "f§dR",
"fondrière" => "f§dRijER",
"fondrières" => "f§dRijER",
"fondriez" => "f§dRie",
"fonds" => "f§",
"fondu" => "f§dy",
"fondue" => "f§dy",
"fondues" => "f§dy",
"fondus" => "f§dy",
"fongible" => "f§Zibl",
"fongicide" => "f§Zisid",
"fongique" => "f§Zik",
"fongueuse" => "f§g2z",
"fongueuses" => "f§g2z",
"fongus" => "f§gy",
"font" => "f§",
"fontaine" => "f§tEn",
"fontaines" => "f§tEn",
"fontainette" => "f§tEnEt",
"fontainier" => "f§tEnje",
"fontanelle" => "f§tanEl",
"fonte" => "f§t",
"fontes" => "f§t",
"fonts" => "f§",
"foot" => "fut",
"football" => "futbOl",
"footballeur" => "futbOl9R",
"footballeur-vedette" => "futbOl9Rv°dEt",
"footballeurs" => "futbal9R",
"footballeuse" => "futbol2z",
"footballistique" => "futbalistik",
"footballistiques" => "futbalistik",
"footeuse" => "fut2z",
"footeux" => "fut2",
"footing" => "futiG",
"for" => "fOR",
"forage" => "foRaZ",
"forages" => "foRaZ",
"foraient" => "foRE",
"forain" => "foR5",
"foraine" => "foREn",
"foraines" => "foREn",
"forains" => "foR5",
"forait" => "foRE",
"foramen" => "foRamEn",
"foraminifères" => "fORaminifER",
"forant" => "foR@",
"forban" => "fORb@",
"forbans" => "fORb@",
"força" => "fORsa",
"forçage" => "fORsaZ",
"forçai" => "fORsE",
"forçaient" => "fORsE",
"forçais" => "fORsE",
"forçait" => "fORsE",
"forçant" => "fORs@",
"forçat" => "fORsa",
"forçât" => "fORsa",
"forçats" => "fORsa",
"force" => "fORs",
"forcé" => "fORse",
"forcée" => "fORse",
"forcées" => "fORse",
"forcement" => "fORs°m@",
"forcément" => "fORsem@",
"forcené" => "fORs°ne",
"forcenée" => "fORs°ne",
"forcenées" => "fORs°ne",
"forcenés" => "fORs°ne",
"forcent" => "fORs",
"forceps" => "fORsEps",
"forcer" => "fORse",
"forcera" => "fORs°Ra",
"forcerai" => "fORs°RE",
"forcerais" => "fORs°RE",
"forcerait" => "fORs°RE",
"forceras" => "fORs°Ra",
"forcèrent" => "fORsER",
"forcerez" => "fORs°Re",
"forceront" => "fORs°R§",
"forces" => "fORs",
"forcés" => "fORse",
"forceur" => "fORs9R",
"forceurs" => "fORs9R",
"forcez" => "fORse",
"forci" => "fORsi",
"forciez" => "fORsje",
"forcing" => "fORsiG",
"forcions" => "fORsj§",
"forcir" => "fORsiR",
"forcis" => "fORsi",
"forcissait" => "fORsisE",
"forcit" => "fORsi",
"forçons" => "fORs§",
"fore" => "fOR",
"foré" => "foRe",
"forée" => "foRe",
"foreign office" => "foRENnOfis",
"forent" => "fOR",
"forer" => "foRe",
"forés" => "foRe",
"forestier" => "foREstje",
"forestière" => "foREstjER",
"forestières" => "foREstjER",
"forestiers" => "foREstje",
"foret" => "foRE",
"forêt" => "foRE",
"forets" => "foRE",
"forêts" => "foRE",
"foreur" => "fOR9R",
"foreurs" => "foR9R",
"foreuse" => "foR2z",
"foreuses" => "foR2z",
"forez" => "foRe",
"forfait" => "fORfE",
"forfaitaire" => "fORfEtER",
"forfaitaires" => "fORfEtER",
"forfaits" => "fORfE",
"forfaiture" => "fORfetyR",
"forfanterie" => "fORf@t°Ri",
"forfanteries" => "fORf@t°Ri",
"forficules" => "fORfikyl",
"forge" => "fORZ",
"forgé" => "fORZe",
"forgea" => "fORZa",
"forgeage" => "fORZaZ",
"forgeaient" => "fORZE",
"forgeais" => "fORZE",
"forgeait" => "fORZE",
"forgeant" => "fORZ@",
"forgée" => "fORZe",
"forgées" => "fORZe",
"forgent" => "fORZ",
"forgeons" => "fORZ§",
"forger" => "fORZe",
"forgera" => "fORZ°Ra",
"forgerai" => "fORZ°RE",
"forgèrent" => "fORZER",
"forgeries" => "fORZ°Ri",
"forgeron" => "fORZ°R§",
"forgeronne" => "fORZ°ROn",
"forgerons" => "fORZ°R§",
"forges" => "fORZ",
"forgés" => "fORZe",
"forgeur" => "fORZ9R",
"forgions" => "fORZj§",
"forints" => "foRint",
"forlane" => "fORlan",
"forlonger" => "fORl§Ze",
"forlongés" => "fORl§Ze",
"forma" => "fORma",
"formage" => "fORmaZ",
"formai" => "fORmE",
"formaient" => "fORmE",
"formais" => "fORmE",
"formait" => "fORmE",
"formaldéhyde" => "fORmaldeid",
"formalisa" => "fORmaliza",
"formalisaient" => "fORmalizE",
"formalisais" => "fORmalizE",
"formalisait" => "fORmalizE",
"formalisât" => "fORmaliza",
"formalise" => "fORmaliz",
"formalisé" => "fORmalize",
"formalisée" => "fORmalize",
"formaliser" => "fORmalize",
"formalisera" => "fORmaliz°Ra",
"formaliserait" => "fORmaliz°RE",
"formalisés" => "fORmalize",
"formalisez" => "fORmalize",
"formalisme" => "fORmalizm",
"formaliste" => "fORmalist",
"formalistes" => "fORmalist",
"formalité" => "fORmalite",
"formalités" => "fORmalite",
"formant" => "fORm@",
"format" => "fORma",
"formatage" => "fORmataZ",
"formaté" => "fORmate",
"formater" => "fORmate",
"formateur" => "fORmat9R",
"formation" => "fORmasj§",
"formations" => "foRmasj§",
"formatrice" => "fORmatRis",
"formatrices" => "fORmatRis",
"formats" => "fORma",
"forme" => "fORm",
"formé" => "fORme",
"formée" => "fORme",
"formées" => "fORme",
"formel" => "fORmEl",
"formelle" => "fORmEl",
"formellement" => "fORmEl°m@",
"formelles" => "fORmEl",
"formels" => "fORmEl",
"forment" => "fORm",
"former" => "fORme",
"formera" => "fORm°Ra",
"formerai" => "fORm°RE",
"formeraient" => "fORm°RE",
"formerais" => "fORm°RE",
"formerait" => "fORm°RE",
"formèrent" => "fORmER",
"formerez" => "fORm°Re",
"formeriez" => "fORm°Rje",
"formerons" => "fORm°R§",
"formeront" => "fORm°R§",
"formes" => "fORm",
"formés" => "fORme",
"formez" => "fORme",
"formica" => "fORmika",
"formicas" => "fORmika",
"formid" => "fORmid",
"formidable" => "fORmidabl",
"formidablement" => "fORmidabl°m@",
"formidables" => "fORmidabl",
"formide" => "fORmid",
"formides" => "fORmid",
"formids" => "fORmid",
"formiez" => "fORmje",
"formions" => "fORmj§",
"formique" => "fORmik",
"formol" => "fORmOl",
"formons" => "fORm§",
"formula" => "fORmyla",
"formulai" => "fORmylE",
"formulaient" => "fORmylE",
"formulaire" => "fORmylER",
"formulaires" => "fORmylER",
"formulais" => "fORmylE",
"formulait" => "fORmylE",
"formulant" => "fORmyl@",
"formulât" => "fORmyla",
"formulation" => "fORmylasj§",
"formulations" => "fORmylasj§",
"formule" => "fORmyl",
"formulé" => "fORmyle",
"formulée" => "fORmyle",
"formulées" => "fORmyle",
"formulent" => "fORmyl",
"formuler" => "fORmyle",
"formulera" => "fORmyl°Ra",
"formules" => "fORmyl",
"formulés" => "fORmyle",
"formulettes" => "fORmylEt",
"formulez" => "fORmyle",
"formulons" => "fORmyl§",
"fornicateur" => "fORnikat9R",
"fornicateurs" => "fORnikat9R",
"fornication" => "fORnikasj§",
"fornications" => "fORnikasj§",
"fornicatrice" => "fORnikatRis",
"forniquaient" => "fORnikE",
"forniquait" => "fORnikE",
"forniquant" => "fORnik@",
"fornique" => "fORnik",
"forniqué" => "fORnike",
"forniquent" => "fORnik",
"forniquer" => "fORnike",
"fors" => "fOR",
"forsythias" => "fORsitja",
"fort" => "fOR",
"forte" => "fORt",
"fortement" => "fORt°m@",
"forteresse" => "fORt°REs",
"forteresses" => "fORt°REs",
"fortes" => "fORt",
"fortiche" => "fORtiS",
"fortiches" => "fORtiS",
"fortifia" => "fORtifja",
"fortifiaient" => "fORtifjE",
"fortifiais" => "fORtifjE",
"fortifiait" => "fORtifjE",
"fortifiant" => "fORtifj@",
"fortifiants" => "fORtifj@",
"fortifiât" => "fORtifja",
"fortification" => "fORtifikasj§",
"fortifications" => "fORtifikasj§",
"fortifie" => "fORtifi",
"fortifié" => "fORtifje",
"fortifiée" => "fORtifje",
"fortifiées" => "fORtifje",
"fortifient" => "fORtifi",
"fortifier" => "fORtifje",
"fortifiera" => "fORtifiRa",
"fortifierait" => "fORtifiRE",
"fortifièrent" => "fORtifjER",
"fortifiés" => "fORtifje",
"fortifiez" => "fORtifje",
"fortifions" => "fORtifj§",
"fortifs" => "fORtif",
"fortin" => "fORt5",
"fortins" => "fORt5",
"fortissimo" => "fORtisimo",
"fortitude" => "fORtityd",
"fortraiture" => "fORtREtyR",
"forts" => "fOR",
"fortuit" => "fORt8i",
"fortuite" => "fORt8it",
"fortuitement" => "fORt8it°m@",
"fortuites" => "fORt8it",
"fortuits" => "fORt8i",
"fortune" => "fORtyn",
"fortuné" => "fORtyne",
"fortunée" => "fORtyne",
"fortunées" => "fORtyne",
"fortunes" => "fORtyn",
"fortunés" => "fORtyne",
"forum" => "foROm",
"forums" => "foROm",
"fosse" => "fOs",
"fossé" => "fose",
"fosses" => "fOs",
"fossés" => "fose",
"fossette" => "fosEt",
"fossettes" => "fosEt",
"fossile" => "fosil",
"fossiles" => "fosil",
"fossilisation" => "fosilizasj§",
"fossilisé" => "fosilize",
"fossilisés" => "fosilize",
"fossoyeur" => "foswaj9R",
"fossoyeurs" => "foswaj9R",
"fossoyeuse" => "foswaj2z",
"fou" => "fu",
"fou-fou" => "fufu",
"fou-rire" => "fuRiR",
"fouaces" => "fwas",
"fouailla" => "fwaja",
"fouaillai" => "fwajE",
"fouaillaient" => "fwajE",
"fouaillait" => "fwajE",
"fouaillant" => "fwaj@",
"fouaille" => "fwaj",
"fouaillé" => "fwaje",
"fouaillée" => "fwaje",
"fouaillées" => "fwaje",
"fouailler" => "fwaje",
"foucade" => "fukad",
"foucades" => "fukad",
"fouchtra" => "fuStRa",
"foudre" => "fudR",
"foudres" => "fudR",
"foudroie" => "fudRwa",
"foudroiement" => "fudRwam@",
"foudroient" => "fudRwa",
"foudroiera" => "fudRwaRa",
"foudroieraient" => "fudRwaRE",
"foudroierait" => "fudRwaRE",
"foudroya" => "fudRwaja",
"foudroyaient" => "fudRwajE",
"foudroyait" => "fudRwajE",
"foudroyant" => "fudRwaj@",
"foudroyante" => "fudRwaj@t",
"foudroyantes" => "fudRwaj@t",
"foudroyants" => "fudRwaj@",
"foudroyé" => "fudRwaje",
"foudroyée" => "fudRwaje",
"foudroyées" => "fudRwaje",
"foudroyer" => "fudRwaje",
"foudroyèrent" => "fudRwajER",
"foudroyés" => "fudRwaje",
"foudroyions" => "fudRwaj§",
"fouet" => "fwE",
"fouets" => "fwE",
"fouetta" => "fwEta",
"fouettaient" => "fwEtE",
"fouettais" => "fwEtE",
"fouettait" => "fwEtE",
"fouettant" => "fwEt@",
"fouettard" => "fwEtaR",
"fouettards" => "fwEtaR",
"fouette" => "fwEt",
"fouetté" => "fwete",
"fouettée" => "fwete",
"fouettées" => "fwete",
"fouettement" => "fwEt°m@",
"fouettements" => "fwEt°m@",
"fouettent" => "fwEt",
"fouetter" => "fwete",
"fouettera" => "fwEt°Ra",
"fouetterai" => "fwEt°RE",
"fouetterait" => "fwEt°RE",
"fouettèrent" => "fwEtER",
"fouetteront" => "fwEt°R§",
"fouettes" => "fwEt",
"fouettés" => "fwete",
"fouetteur" => "fuEt9R",
"fouetteurs" => "fwEt9R",
"fouetteuse" => "fwEt2z",
"fouettez" => "fwEte",
"fouettons" => "fwEt§",
"foufou" => "fufu",
"foufoune" => "fufun",
"foufounes" => "fufun",
"foufounette" => "fufunEt",
"foufous" => "fufu",
"fougasse" => "fugas",
"fouge" => "fuZ",
"fougeraie" => "fuZ°RE",
"fougeraies" => "fuZ°RE",
"fougère" => "fuZER",
"fougères" => "fuZER",
"fougue" => "fug",
"fougues" => "fug",
"fougueuse" => "fug2z",
"fougueusement" => "fug2z°m@",
"fougueuses" => "fug2z",
"fougueux" => "fug2",
"foui" => "fwi",
"fouie" => "fwi",
"fouies" => "fwi",
"fouilla" => "fuja",
"fouillai" => "fujE",
"fouillaient" => "fujE",
"fouillais" => "fujE",
"fouillait" => "fujE",
"fouillant" => "fuj@",
"fouillasse" => "fujas",
"fouille" => "fuj",
"fouillé" => "fuje",
"fouillée" => "fuje",
"fouillées" => "fuje",
"fouillent" => "fuj",
"fouiller" => "fuje",
"fouillera" => "fuj°Ra",
"fouillerai" => "fuj°RE",
"fouillerais" => "fuj°RE",
"fouillerait" => "fuj°RE",
"fouilleras" => "fuj°Ra",
"fouillèrent" => "fujER",
"fouillerons" => "fuj°R§",
"fouilleront" => "fuj°R§",
"fouilles" => "fuj",
"fouillés" => "fuje",
"fouillette" => "fujEt",
"fouilleur" => "fuj9R",
"fouilleurs" => "fuj9R",
"fouilleuse" => "fuj2z",
"fouillez" => "fuje",
"fouilliez" => "fuje",
"fouillis" => "fuji",
"fouillons" => "fuj§",
"fouinaient" => "fwinE",
"fouinais" => "fwinE",
"fouinait" => "fwinE",
"fouinant" => "fwin@",
"fouinard" => "fwinaR",
"fouinards" => "fwinaR",
"fouine" => "fwin",
"fouiné" => "fwine",
"fouinent" => "fwin",
"fouiner" => "fwine",
"fouinera" => "fwin°Ra",
"fouineriez" => "fwin°Rje",
"fouines" => "fwin",
"fouineur" => "fwin9R",
"fouineurs" => "fwin9R",
"fouineuse" => "fwin2z",
"fouinez" => "fwine",
"fouiniez" => "fwinje",
"fouir" => "fwiR",
"fouissait" => "fwisE",
"fouissant" => "fwis@",
"fouissent" => "fwis",
"fouisseur" => "fwis9R",
"fouisseurs" => "fwis9R",
"fouisseuse" => "fwis2z",
"fouisseuses" => "fwis2z",
"fouit" => "fwi",
"foula" => "fula",
"foulage" => "fulaZ",
"foulaient" => "fulE",
"foulais" => "fulE",
"foulait" => "fulE",
"foulant" => "ful@",
"foulard" => "fulaR",
"foulards" => "fulaR",
"foulbé" => "fulbe",
"foule" => "ful",
"foulé" => "fule",
"foulée" => "fule",
"foulées" => "fule",
"foulent" => "ful",
"fouler" => "fule",
"foulera" => "ful°Ra",
"fouleraient" => "ful°RE",
"foulerait" => "ful°RE",
"foulèrent" => "fulER",
"foulerez" => "ful°Re",
"foules" => "ful",
"foulés" => "fule",
"fouleur" => "ful9R",
"foulions" => "fulj§",
"fouloir" => "fulwaR",
"foulon" => "ful§",
"foulons" => "ful§",
"foulque" => "fulk",
"foulques" => "fulk",
"foulure" => "fulyR",
"foulures" => "fulyR",
"four" => "fuR",
"fourbais" => "fuRbE",
"fourbe" => "fuRb",
"fourber" => "fuRbe",
"fourberie" => "fuRb°Ri",
"fourberies" => "fuRb°Ri",
"fourbes" => "fuRb",
"fourbi" => "fuRbi",
"fourbie" => "fuRbi",
"fourbir" => "fuRbiR",
"fourbis" => "fuRbi",
"fourbissaient" => "fuRbisE",
"fourbissais" => "fuRbisE",
"fourbissait" => "fuRbisE",
"fourbissant" => "fuRbis@",
"fourbit" => "fuRbi",
"fourbu" => "fuRby",
"fourbue" => "fuRby",
"fourbues" => "fuRby",
"fourbus" => "fuRby",
"fourcha" => "fuRSa",
"fourche" => "fuRS",
"fourché" => "fuRSe",
"fourchée" => "fuRSe",
"fourchent" => "fuRS",
"fourcher" => "fuRSe",
"fourches" => "fuRS",
"fourchet" => "fuRSE",
"fourchets" => "fuRSE",
"fourchette" => "fuRSEt",
"fourchettes" => "fuRSEt",
"fourchez" => "fuRSe",
"fourchu" => "fuRSy",
"fourchue" => "fuRSy",
"fourchues" => "fuRSy",
"fourchures" => "fuRSyR",
"fourchus" => "fuRSy",
"fourgon" => "fuRg§",
"fourgonnait" => "fuRgonE",
"fourgonnas" => "fuRgona",
"fourgonne" => "fuRgOn",
"fourgonner" => "fuRgone",
"fourgonnette" => "fuRgonEt",
"fourgonnettes" => "fuRgonEt",
"fourgons" => "fuRg§",
"fourguais" => "fuRgE",
"fourguait" => "fuRgE",
"fourguant" => "fuRg@",
"fourgue" => "fuRg",
"fourgué" => "fuRge",
"fourguée" => "fuRge",
"fourguées" => "fuRge",
"fourguent" => "fuRg",
"fourguer" => "fuRge",
"fourgueraient" => "fuRg°RE",
"fourguerais" => "fuRg°RE",
"fourguerait" => "fuRg°RE",
"fourgues" => "fuRg",
"fourgués" => "fuRge",
"fourguez" => "fuRge",
"fourme" => "fuRm",
"fourmes" => "fuRm",
"fourmi" => "fuRmi",
"fourmi-lion" => "fuRmilj§",
"fourmilier" => "fuRmilje",
"fourmilière" => "fuRmiljER",
"fourmilières" => "fuRmiljER",
"fourmilion" => "fuRmilj§",
"fourmillaient" => "fuRmijE",
"fourmillait" => "fuRmijE",
"fourmillant" => "fuRmij@",
"fourmillante" => "fuRmij@t",
"fourmillants" => "fuRmij@",
"fourmille" => "fuRmij",
"fourmillé" => "fuRmije",
"fourmillement" => "fuRmij°m@",
"fourmillements" => "fuRmij°m@",
"fourmillent" => "fuRmij",
"fourmiller" => "fuRmije",
"fourmis" => "fuRmi",
"fourmis-lions" => "fuRmilj§",
"fournaise" => "fuRnEz",
"fournaises" => "fuRnEz",
"fourneau" => "fuRno",
"fourneaux" => "fuRno",
"fournée" => "fuRne",
"fournées" => "fuRne",
"fourni" => "fuRni",
"fournie" => "fuRni",
"fournier" => "fuRnje",
"fournies" => "fuRni",
"fournil" => "fuRni",
"fourniment" => "fuRnim@",
"fourniments" => "fuRnim@",
"fournîmes" => "fuRnim",
"fournir" => "fuRniR",
"fournira" => "fuRniRa",
"fournirai" => "fuRniRE",
"fourniraient" => "fuRniRE",
"fournirait" => "fuRniRE",
"fournirent" => "fuRniR",
"fournirez" => "fuRniRe",
"fournirons" => "fuRniR§",
"fourniront" => "fuRniR§",
"fournis" => "fuRni",
"fournissaient" => "fuRnisE",
"fournissais" => "fuRnisE",
"fournissait" => "fuRnisE",
"fournissant" => "fuRnis@",
"fournisse" => "fuRnis",
"fournissent" => "fuRnis",
"fournisseur" => "fuRnis9R",
"fournisseurs" => "fuRnis9R",
"fournisseuses" => "fuRnis2z",
"fournissez" => "fuRnise",
"fournissiez" => "fuRnisje",
"fournissions" => "fuRnisj§",
"fournissons" => "fuRnis§",
"fournit" => "fuRni",
"fournît" => "fuRni",
"fourniture" => "fuRnityR",
"fournitures" => "fuRnityR",
"fourra" => "fuRa",
"fourrage" => "fuRaZ",
"fourragé" => "fuRaZe",
"fourragea" => "fuRaZa",
"fourrageaient" => "fuRaZE",
"fourrageais" => "fuRaZE",
"fourrageait" => "fuRaZE",
"fourrageant" => "fuRaZ@",
"fourragement" => "fuRaZ°m@",
"fourrager" => "fuRaZe",
"fourragerait" => "fuRaZ°RE",
"fourragère" => "fuRaZER",
"fourragères" => "fuRaZER",
"fourrages" => "fuRaZ",
"fourrageurs" => "fuRaZ9R",
"fourrai" => "fuRE",
"fourraient" => "fuRE",
"fourrais" => "fuRE",
"fourrait" => "fuRE",
"fourrant" => "fuR@",
"fourrât" => "fuRa",
"fourre" => "fuR",
"fourré" => "fuRe",
"fourre-tout" => "fuRtu",
"fourreau" => "fuRo",
"fourreaux" => "fuRo",
"fourrée" => "fuRe",
"fourrées" => "fuRe",
"fourrent" => "fuR",
"fourrer" => "fuRe",
"fourrerai" => "fuR°RE",
"fourrèrent" => "fuRER",
"fourrés" => "fuRe",
"fourreur" => "fuR9R",
"fourreurs" => "fuR9R",
"fourrez" => "fuRe",
"fourrier" => "fuRje",
"fourrière" => "fuRjER",
"fourriers" => "fuRje",
"fourriez" => "fuRje",
"fourrions" => "fuRj§",
"fourrons" => "fuR§",
"fourrure" => "fuRyR",
"fourrures" => "fuRyR",
"fours" => "fuR",
"fourvoie" => "fuRvwa",
"fourvoiement" => "fuRvwam@",
"fourvoiements" => "fuRvwam@",
"fourvoient" => "fuRvwa",
"fourvoierais" => "fuRvwaRE",
"fourvoierait" => "fuRvwaRE",
"fourvoyaient" => "fuRvwajE",
"fourvoyait" => "fuRvwajE",
"fourvoyâmes" => "fuRvwajam",
"fourvoyant" => "fuRvwaj@",
"fourvoyé" => "fuRvwaje",
"fourvoyée" => "fuRvwaje",
"fourvoyées" => "fuRvwaje",
"fourvoyer" => "fuRvwaje",
"fourvoyés" => "fuRvwaje",
"fous" => "fu",
"fout" => "fu",
"fouta" => "futa",
"foutaient" => "futE",
"foutais" => "futE",
"foutaise" => "futEz",
"foutaises" => "futEz",
"foutait" => "futE",
"foutant" => "fut@",
"foute" => "fut",
"foutent" => "fut",
"fouterie" => "fut°Ri",
"fouteries" => "fut°Ri",
"foutes" => "fut",
"fouteur" => "fut9R",
"fouteurs" => "fut9R",
"foutez" => "fute",
"foutiez" => "futje",
"foutions" => "futj§",
"foutit" => "futi",
"foutît" => "futi",
"foutoir" => "futwaR",
"foutoirs" => "futwaR",
"foutons" => "fut§",
"foutra" => "futRa",
"foutrai" => "futRE",
"foutraient" => "futRE",
"foutrais" => "futRE",
"foutrait" => "futRE",
"foutral" => "futRal",
"foutrale" => "futRal",
"foutraque" => "futRak",
"foutras" => "futRa",
"foutre" => "futR",
"foutrement" => "futR°m@",
"foutrerie" => "futR°Ri",
"foutrez" => "futRe",
"foutriquet" => "futRikE",
"foutriquets" => "futRikE",
"foutrons" => "futR§",
"foutront" => "futR§",
"foutu" => "futy",
"foutue" => "futy",
"foutues" => "futy",
"foutument" => "futym@",
"foutus" => "futy",
"fox" => "fOks",
"fox-terrier" => "fOkstERje",
"fox-terriers" => "fOkstERje",
"fox-trot" => "fOkstRo",
"foyard" => "fwajaR",
"foyards" => "fwajaR",
"foyer" => "fwaje",
"foyers" => "fwaje",
"fra" => "fRa",
"frac" => "fRak",
"fracas" => "fRaka",
"fracassa" => "fRakasa",
"fracassaient" => "fRakasE",
"fracassait" => "fRakasE",
"fracassant" => "fRakas@",
"fracassante" => "fRakas@t",
"fracassantes" => "fRakas@t",
"fracassants" => "fRakas@",
"fracassât" => "fRakasa",
"fracasse" => "fRakas",
"fracassé" => "fRakase",
"fracassée" => "fRakase",
"fracassées" => "fRakase",
"fracassent" => "fRakas",
"fracasser" => "fRakase",
"fracassera" => "fRakas°Ra",
"fracasserait" => "fRakas°RE",
"fracassés" => "fRakase",
"fracassez" => "fRakase",
"fracs" => "fRak",
"fractal" => "fRaktal",
"fractale" => "fRaktal",
"fractales" => "fRaktal",
"fraction" => "fRaksj§",
"fractionnait" => "fRaksjonE",
"fractionnant" => "fRaksjon@",
"fractionne" => "fRaksjOn",
"fractionné" => "fRaksjone",
"fractionnée" => "fRaksjOne",
"fractionnées" => "fRaksjone",
"fractionnel" => "fRaksjonEl",
"fractionnelles" => "fRaksjonEl",
"fractionnement" => "fRaksjOn°m@",
"fractionner" => "fRaksjone",
"fractions" => "fRaksj§",
"fractura" => "fRaktyRa",
"fracturant" => "fRaktyR@",
"fracture" => "fRaktyR",
"fracturé" => "fRaktyRe",
"fracturée" => "fRaktyRe",
"fracturées" => "fRaktyRe",
"fracturent" => "fRaktyR",
"fracturer" => "fRaktyRe",
"fractures" => "fRaktyR",
"fracturés" => "fRaktyRe",
"fractus" => "fRaktys",
"fragile" => "fRaZil",
"fragilement" => "fRaZil°m@",
"fragiles" => "fRaZil",
"fragilise" => "fRaZiliz",
"fragilisé" => "fRaZilize",
"fragilisée" => "fRaZilize",
"fragiliser" => "fRaZilize",
"fragilisés" => "fRaZilize",
"fragilité" => "fRaZilite",
"fragilités" => "fRaZilite",
"fragment" => "fRagm@",
"fragmentaient" => "fRagm@tE",
"fragmentaire" => "fRagm@tER",
"fragmentaires" => "fRagm@tER",
"fragmentait" => "fRagm@tE",
"fragmentant" => "fRagm@t@",
"fragmentation" => "fRagm@tasj§",
"fragmente" => "fRagm@t",
"fragmenté" => "fRagm@te",
"fragmentée" => "fRagm@te",
"fragmentées" => "fRagm@te",
"fragmentent" => "fRagm@t",
"fragmenter" => "fRagm@te",
"fragmentèrent" => "fRagm@tER",
"fragmentés" => "fRagm@te",
"fragments" => "fRagm@",
"fragrance" => "fRagR@s",
"fragrances" => "fRagR@s",
"fragrant" => "fRagR@",
"frai" => "fRE",
"fraîche" => "fRES",
"fraîchement" => "fRES°m@",
"fraîches" => "fRES",
"fraîcheur" => "fRES9R",
"fraîcheurs" => "fRES9R",
"fraîchi" => "fRESi",
"fraîchir" => "fReSiR",
"fraîchira" => "fRESiRa",
"fraîchissait" => "fRESisE",
"fraîchissant" => "fRESis@",
"fraîchissent" => "fRESis",
"fraîchit" => "fRESi",
"fraie" => "fRE",
"fraient" => "fRE",
"fraies" => "fRE",
"frairie" => "fRERi",
"frais" => "fRE",
"fraise" => "fREz",
"fraisées" => "fReze",
"fraiser" => "fREze",
"fraises" => "fREz",
"fraiseur" => "fREz9R",
"fraiseur-outilleur" => "fREz9Rutij9R",
"fraiseurs" => "fREz9R",
"fraiseuse" => "fREz2z",
"fraisier" => "fRezje",
"fraisiers" => "fRezje",
"fraisil" => "fREzil",
"framboise" => "fR@bwaz",
"framboises" => "fR@bwaz",
"framboisier" => "fR@bwazje",
"framboisiers" => "fR@bwazje",
"franc" => "fR@",
"franc-comtois" => "fR@k§twa",
"franc-comtoise" => "fR@k§twaz",
"franc-jeu" => "fR@Z2",
"franc-maçon" => "fR@mas§",
"franc-maçonne" => "fR@masOn",
"franc-maçonnerie" => "fR@masOn°Ri",
"franc-parler" => "fR@paRle",
"franc-tireur" => "fR@tiR9R",
"français" => "fR@sE",
"française" => "fR@sEz",
"françaises" => "fR@sEz",
"francatu" => "fR@katy",
"francfort" => "fR@kfOR",
"francforts" => "fR@kfOR",
"franche" => "fR@S",
"franchement" => "fR@S°m@",
"franches" => "fR@S",
"franchi" => "fR@Si",
"franchie" => "fR@Si",
"franchies" => "fR@Si",
"franchîmes" => "fR@Sim",
"franchir" => "fR@SiR",
"franchira" => "fR@SiRa",
"franchirai" => "fR@SiRE",
"franchiraient" => "fR@SiRE",
"franchirais" => "fR@SiRE",
"franchirait" => "fR@SiRE",
"franchiras" => "fR@SiRa",
"franchirent" => "fR@SiR",
"franchirez" => "fR@SiRe",
"franchirions" => "fR@SiRj§",
"franchirons" => "fR@SiR§",
"franchiront" => "fR@SiR§",
"franchis" => "fR@Si",
"franchisage" => "fR@SizaZ",
"franchisant" => "fR@Siz@",
"franchise" => "fR@Siz",
"franchisé" => "fR@Size",
"franchisée" => "fR@Size",
"franchiser" => "fR@Size",
"franchises" => "fR@Siz",
"franchissables" => "fR@Sisabl",
"franchissaient" => "fR@SisE",
"franchissais" => "fR@SisE",
"franchissait" => "fR@SisE",
"franchissant" => "fR@Sis@",
"franchisse" => "fR@Sis",
"franchissement" => "fR@Sis°m@",
"franchissements" => "fR@Sis°m@",
"franchissent" => "fR@Sis",
"franchissez" => "fR@Sise",
"franchissions" => "fR@Sisj§",
"franchissons" => "fR@Sis§",
"franchit" => "fR@Si",
"franchît" => "fR@Si",
"franchouillard" => "fR@SujaR",
"franchouillarde" => "fR@SujaRd",
"franchouillards" => "fR@SujaR",
"francisant" => "fR@siz@",
"francisation" => "fR@sizasj§",
"franciscain" => "fR@sisk5",
"franciscaine" => "fR@siskEn",
"franciscains" => "fR@sisk5",
"francisé" => "fR@size",
"franciser" => "fR@size",
"francisés" => "fR@size",
"francisque" => "fR@sisk",
"francisques" => "fR@sisk",
"francité" => "fR@site",
"franco" => "fR@ko",
"franco-africain" => "fR@koafRik5",
"franco-algérienne" => "fR@koalZeRjEn",
"franco-allemand" => "fR@koal°m@",
"franco-allemande" => "fR@koal°m@d",
"franco-allemandes" => "fR@koal°m@d",
"franco-américain" => "fR@koameRik5",
"franco-américaine" => "fR@koameRikEn",
"franco-américaines" => "fR@koameRikEn",
"franco-américains" => "fR@koameRik5",
"franco-anglais" => "fR@ko@glE",
"franco-anglaise" => "fR@ko@glEz",
"franco-anglaises" => "fR@ko@glEz",
"franco-belge" => "fR@kobElZ",
"franco-britannique" => "fR@kobRitanik",
"franco-britanniques" => "fR@kobRitanik",
"franco-canadien" => "fR@kokanadj5",
"franco-chinoises" => "fR@koSinwaz",
"franco-italienne" => "fR@koitaljEn",
"franco-japonaise" => "fR@koZaponEz",
"franco-libanais" => "fR@kolibanE",
"franco-mongole" => "fR@kom§gOl",
"franco-polonaise" => "fR@kopolonEz",
"franco-russe" => "fR@koRys",
"franco-russes" => "fR@koRys",
"franco-soviétique" => "fR@kosovjetik",
"franco-syrien" => "fR@kosiRj5",
"franco-turque" => "fR@kotyRk",
"franco-vietnamien" => "fR@kovjEtnamj5",
"francomanie" => "fR@komani",
"francophile" => "fR@kofil",
"francophiles" => "fR@kofil",
"francophilie" => "fR@kofili",
"francophobie" => "fR@kofobi",
"francophone" => "fR@kofOn",
"francophones" => "fR@kofOn",
"francophonie" => "fR@kofoni",
"francs" => "fR@",
"francs-bourgeois" => "fR@buRZwa",
"francs-maçons" => "fR@mas§",
"francs-tireurs" => "fR@tiR9R",
"frange" => "fR@Z",
"frangé" => "fR@Ze",
"frangeaient" => "fR@ZE",
"frangeait" => "fR@ZE",
"frangeant" => "fR@Z@",
"frangée" => "fR@Ze",
"frangées" => "fR@Ze",
"frangent" => "fR@Z",
"franges" => "fR@Z",
"frangés" => "fR@Ze",
"frangin" => "fR@Z5",
"frangine" => "fR@Zin",
"frangines" => "fR@Zin",
"frangins" => "fR@Z5",
"frangipane" => "fR@Zipan",
"frangipanes" => "fR@Zipan",
"frangipaniers" => "fR@Zipanje",
"franglais" => "fR@glE",
"frankaoui" => "fR@kawi",
"franklin" => "fR@kl5",
"franque" => "fR@k",
"franques" => "fR@k",
"franquette" => "fR@kEt",
"franquisme" => "fR@kizm",
"franquiste" => "fR@kist",
"franquistes" => "fR@kist",
"frapadingue" => "fRapad5g",
"frapadingues" => "fRapad5g",
"frappa" => "fRapa",
"frappadingue" => "fRapad5g",
"frappadingues" => "fRapad5g",
"frappai" => "fRapE",
"frappaient" => "fRapE",
"frappais" => "fRapE",
"frappait" => "fRapE",
"frappant" => "fRap@",
"frappante" => "fRap@t",
"frappantes" => "fRap@t",
"frappants" => "fRap@",
"frappât" => "fRapa",
"frappe" => "fRap",
"frappé" => "fRape",
"frappée" => "fRape",
"frappées" => "fRape",
"frappement" => "fRap°m@",
"frappements" => "fRap°m@",
"frappent" => "fRap",
"frapper" => "fRape",
"frappera" => "fRap°Ra",
"frapperai" => "fRap°RE",
"frapperaient" => "fRap°RE",
"frapperais" => "fRap°RE",
"frapperait" => "fRap°RE",
"frapperas" => "fRap°Ra",
"frappèrent" => "fRapER",
"frapperez" => "fRap°Re",
"frapperiez" => "fRap°Rje",
"frapperons" => "fRap°R§",
"frapperont" => "fRap°R§",
"frappes" => "fRap",
"frappés" => "fRape",
"frappeur" => "fRap9R",
"frappeurs" => "fRap9R",
"frappez" => "fRape",
"frappiez" => "fRapje",
"frappions" => "fRapj§",
"frappons" => "fRap§",
"fraser" => "fRaze",
"frasque" => "fRask",
"frasques" => "fRask",
"frater" => "fRatER",
"fraternel" => "fRatERnEl",
"fraternelle" => "fRatERnEl",
"fraternellement" => "fRatERnEl°m@",
"fraternelles" => "fRatERnEl",
"fraternels" => "fRatERnEl",
"fraternisa" => "fRatERniza",
"fraternisaient" => "fRatERnizE",
"fraternisant" => "fRatERniz@",
"fraternisation" => "fRatERnizasj§",
"fraternise" => "fRatERniz",
"fraternisé" => "fRatERnize",
"fraternisent" => "fRatERniz",
"fraterniser" => "fRatERnize",
"fraterniserait" => "fRatERniz°RE",
"fraternisèrent" => "fRatERnizER",
"fraternisiez" => "fRatERnizje",
"fraternisons" => "fRatERniz§",
"fraternité" => "fRatERnite",
"fraternités" => "fRatERnite",
"fratricide" => "fRatRisid",
"fratricides" => "fRatRisid",
"fratrie" => "fRatRi",
"fratries" => "fRatRi",
"frauda" => "fRoda",
"fraudais" => "fRodE",
"fraude" => "fRod",
"fraudé" => "fRode",
"frauder" => "fRode",
"fraudes" => "fRod",
"fraudeur" => "fRod9R",
"fraudeurs" => "fRod9R",
"fraudeuse" => "fRod2z",
"frauduleuse" => "fRodyl2z",
"frauduleusement" => "fRodyl2z°m@",
"frauduleuses" => "fRodyl2z",
"frauduleux" => "fRodyl2",
"fraya" => "fReja",
"frayai" => "fRejE",
"frayaient" => "fRejE",
"frayais" => "fRejE",
"frayait" => "fRejE",
"frayant" => "fRej@",
"fraye" => "fRej",
"frayé" => "fReje",
"frayée" => "fReje",
"frayent" => "fRej",
"frayer" => "fReje",
"frayèrent" => "fRejER",
"frayes" => "fRej",
"frayeur" => "fREj9R",
"frayeurs" => "fREj9R",
"frayez" => "fREje",
"frayons" => "fRej§",
"freak" => "fREk",
"freaks" => "fREk",
"fredaines" => "fR°dEn",
"fredonna" => "fR°dona",
"fredonnaient" => "fR°donE",
"fredonnais" => "fR°donE",
"fredonnait" => "fR°donE",
"fredonnâmes" => "fR°donam",
"fredonnant" => "fR°don@",
"fredonne" => "fR°dOn",
"fredonné" => "fR°done",
"fredonnée" => "fR°done",
"fredonnées" => "fR°done",
"fredonnement" => "fR°dOn°m@",
"fredonnent" => "fR°dOn",
"fredonner" => "fR°done",
"fredonnera" => "fR°dOn°Ra",
"fredonnerai" => "fR°dOn°RE",
"fredonnerait" => "fR°dOn°RE",
"fredonneras" => "fR°dOn°Ra",
"fredonnèrent" => "fR°donER",
"fredonnés" => "fR°done",
"fredonnez" => "fR°done",
"fredonnons" => "fR°don§",
"free jazz" => "fRidZaz",
"free-jazz" => "fRidZaz",
"free-lance" => "fRil@s",
"freelance" => "fRil@s",
"freesia" => "fRizja",
"freesias" => "fRizja",
"freezer" => "fRiz9R",
"frégate" => "fRegat",
"frégates" => "fRegat",
"frein" => "fR5",
"freina" => "fREna",
"freinage" => "fREnaZ",
"freinages" => "fREnaZ",
"freinai" => "fREnE",
"freinaient" => "fREnE",
"freinais" => "fREnE",
"freinait" => "fREnE",
"freinant" => "fREn@",
"freine" => "fREn",
"freiné" => "fRene",
"freinée" => "fRene",
"freinées" => "fRene",
"freinent" => "fREn",
"freiner" => "fRene",
"freinera" => "fREn°Ra",
"freinerais" => "fREn°RE",
"freinèrent" => "fREnER",
"freinerez" => "fREn°Re",
"freines" => "fREn",
"freinés" => "fRene",
"freineurs" => "fREn9R",
"freinez" => "fREne",
"freinons" => "fREn§",
"freins" => "fR5",
"frelaté" => "fR°late",
"frelatée" => "fR°late",
"frelatées" => "fR°late",
"frelater" => "fR2late",
"frelatés" => "fR°late",
"frêle" => "fREl",
"frêles" => "fREl",
"frelon" => "fR°l§",
"frelons" => "fR°l§",
"freluquet" => "fR°lykE",
"freluquets" => "fR°lykE",
"frémi" => "fRemi",
"frémir" => "fRemiR",
"frémirait" => "fRemiRE",
"frémirent" => "fRemiR",
"frémiront" => "fRemiR§",
"frémis" => "fRemi",
"frémissaient" => "fRemisE",
"frémissais" => "fRemisE",
"frémissait" => "fRemisE",
"frémissant" => "fRemis@",
"frémissante" => "fRemis@t",
"frémissantes" => "fRemis@t",
"frémissants" => "fRemis@",
"frémisse" => "fRemis",
"frémissement" => "fRemis°m@",
"frémissements" => "fRemis°m@",
"frémissent" => "fRemis",
"frémissez" => "fRemise",
"frémit" => "fRemi",
"french" => "fREnS",
"frêne" => "fREn",
"frênes" => "fREn",
"frénésie" => "fRenezi",
"frénésies" => "fRenezi",
"frénétique" => "fRenetik",
"frénétiquement" => "fRenetik°m@",
"frénétiques" => "fRenetik",
"fréon" => "fRe§",
"fréquemment" => "fRekam@",
"fréquence" => "fRek@s",
"fréquences" => "fRek@s",
"fréquent" => "fRek@",
"fréquenta" => "fRek@ta",
"fréquentable" => "fRek@tabl",
"fréquentables" => "fRek@tabl",
"fréquentai" => "fRek@tE",
"fréquentaient" => "fRek@tE",
"fréquentais" => "fRek@tE",
"fréquentait" => "fRek@tE",
"fréquentant" => "fRek@t@",
"fréquentât" => "fRek@ta",
"fréquentation" => "fRek@tasj§",
"fréquentations" => "fRek@tasj§",
"fréquente" => "fRek@t",
"fréquenté" => "fRek@te",
"fréquentée" => "fRek@te",
"fréquentées" => "fRek@te",
"fréquentent" => "fRek@t",
"fréquenter" => "fRek@te",
"fréquenterais" => "fRek@t°RE",
"fréquenterait" => "fRek@t°RE",
"fréquenteras" => "fRek@t°Ra",
"fréquentèrent" => "fRek@tER",
"fréquenterez" => "fRek@t°Re",
"fréquentes" => "fRek@t",
"fréquentés" => "fRek@te",
"fréquentez" => "fRek@te",
"fréquentiez" => "fRek@tje",
"fréquentions" => "fRek@tj§",
"fréquentons" => "fRek@t§",
"fréquents" => "fRek@",
"frère" => "fRER",
"frères" => "fRER",
"frérot" => "fReRo",
"frérots" => "fReRo",
"fresque" => "fREsk",
"fresques" => "fREsk",
"fresquiste" => "fREskist",
"fret" => "fRE",
"fréta" => "fReta",
"frétait" => "fRetE",
"frétant" => "fRet@",
"frète" => "fREt",
"frété" => "fRete",
"frétée" => "fRete",
"fréter" => "fRete",
"frétèrent" => "fRetER",
"frétilla" => "fRetija",
"frétillaient" => "fRetijE",
"frétillait" => "fRetijE",
"frétillant" => "fRetij@",
"frétillante" => "fRetij@t",
"frétillantes" => "fRetij@t",
"frétillants" => "fRetij@",
"frétillard" => "fRetijaR",
"frétillarde" => "fRetijaRd",
"frétille" => "fRetij",
"frétillé" => "fRetije",
"frétillement" => "fRetij°m@",
"frétillements" => "fRetij°m@",
"frétillent" => "fRetij",
"frétiller" => "fRetije",
"frétillon" => "fRetij§",
"fretin" => "fR°t5",
"fretins" => "fR°t5",
"frets" => "fRE",
"fretta" => "fREta",
"frette" => "fREt",
"freudien" => "fR2dj5",
"freudienne" => "fR2djEn",
"freudiennes" => "fR2djEn",
"freudiens" => "fR2dj5",
"freudisme" => "fR2dizm",
"freux" => "fR2",
"friabilité" => "fRijabilite",
"friable" => "fRijabl",
"friables" => "fRijabl",
"friand" => "fRij@",
"friande" => "fRij@d",
"friandes" => "fRij@d",
"friandise" => "fRij@diz",
"friandises" => "fRij@diz",
"friands" => "fRij@",
"fribourgeoise" => "fRibuRZwaz",
"fric" => "fRik",
"fric-frac" => "fRikfRak",
"fricadelle" => "fRikadEl",
"fricadelles" => "fRikadEl",
"fricandeau" => "fRik@do",
"fricandeaux" => "fRik@do",
"fricasse" => "fRikas",
"fricassé" => "fRikase",
"fricassée" => "fRikase",
"fricassées" => "fRikase",
"fricasserai" => "fRikas°RE",
"fricatif" => "fRikatif",
"fricatives" => "fRikativ",
"friche" => "fRiS",
"friches" => "fRiS",
"frichti" => "fRiSti",
"frichtis" => "fRiSti",
"fricot" => "fRiko",
"fricotage" => "fRikOtaZ",
"fricotages" => "fRikotaZ",
"fricotaient" => "fRikotE",
"fricotais" => "fRikotE",
"fricotait" => "fRikotE",
"fricotant" => "fRikot@",
"fricote" => "fRikOt",
"fricoté" => "fRikote",
"fricotent" => "fRikOt",
"fricoter" => "fRikote",
"fricotes" => "fRikOt",
"fricoteur" => "fRikOt9R",
"fricoteurs" => "fRikot9R",
"fricotez" => "fRikote",
"fricotiez" => "fRikotje",
"fricots" => "fRiko",
"frics" => "fRik",
"friction" => "fRiksj§",
"frictionna" => "fRiksjona",
"frictionnais" => "fRiksjonE",
"frictionnait" => "fRiksjonE",
"frictionnant" => "fRiksjon@",
"frictionne" => "fRiksjOn",
"frictionné" => "fRiksjone",
"frictionnent" => "fRiksjOn",
"frictionner" => "fRiksjone",
"frictionnerai" => "fRiksjOn°RE",
"frictionnerait" => "fRiksjOn°RE",
"frictionnèrent" => "fRiksjonER",
"frictionnez" => "fRiksjone",
"frictions" => "fRiksj§",
"fridolin" => "fRidOl5",
"fridolins" => "fRidol5",
"frigidaire" => "fRiZidER",
"frigidaires" => "fRiZidER",
"frigide" => "fRiZid",
"frigides" => "fRiZid",
"frigidité" => "fRiZidite",
"frigo" => "fRigo",
"frigorifiant" => "fRigoRifj@",
"frigorifié" => "fRigoRifje",
"frigorifiée" => "fRigoRifje",
"frigorifiées" => "fRigoRifje",
"frigorifier" => "fRigORifje",
"frigorifiés" => "fRigoRifje",
"frigorifique" => "fRigoRifik",
"frigorifiques" => "fRigoRifik",
"frigorigène" => "fRigORiZEn",
"frigos" => "fRigo",
"frileuse" => "fRil2z",
"frileusement" => "fRil2z°m@",
"frileuses" => "fRil2z",
"frileux" => "fRil2",
"frilosité" => "fRilozite",
"frima" => "fRima",
"frimaient" => "fRimE",
"frimaire" => "fRimER",
"frimais" => "fRimE",
"frimait" => "fRimE",
"frimant" => "fRim@",
"frimas" => "fRima",
"frime" => "fRim",
"frimé" => "fRime",
"frimée" => "fRime",
"frimées" => "fRime",
"friment" => "fRim",
"frimer" => "fRime",
"frimerais" => "fRim°RE",
"frimes" => "fRim",
"frimés" => "fRime",
"frimeur" => "fRim9R",
"frimeurs" => "fRim9R",
"frimeuse" => "fRim2z",
"frimez" => "fRime",
"frimiez" => "fRimje",
"frimousse" => "fRimus",
"frimousses" => "fRimus",
"fringale" => "fR5gal",
"fringales" => "fR5gal",
"fringant" => "fR5g@",
"fringante" => "fR5g@t",
"fringantes" => "fR5g@t",
"fringants" => "fR5g@",
"fringillidé" => "fR5Zilide",
"fringuait" => "fR5gE",
"fringue" => "fR5g",
"fringué" => "fR5ge",
"fringuée" => "fR5ge",
"fringuées" => "fR5ge",
"fringuent" => "fR5g",
"fringuer" => "fR5ge",
"fringues" => "fR5g",
"fringués" => "fR5ge",
"fringuez" => "fR5ge",
"frio" => "fRijo",
"fripa" => "fRipa",
"fripaient" => "fRipE",
"fripant" => "fRip@",
"fripe" => "fRip",
"fripé" => "fRipe",
"fripée" => "fRipe",
"fripées" => "fRipe",
"fripent" => "fRip",
"friper" => "fRipe",
"friperie" => "fRip°Ri",
"fripes" => "fRip",
"fripés" => "fRipe",
"fripier" => "fRipje",
"fripiers" => "fRipje",
"fripon" => "fRip§",
"friponne" => "fRipOn",
"friponnerie" => "fRipOn°Ri",
"friponnes" => "fRipOn",
"fripons" => "fRip§",
"fripouille" => "fRipuj",
"fripouillerie" => "fRipuj°Ri",
"fripouilleries" => "fRipuj°Ri",
"fripouilles" => "fRipuj",
"frippe" => "fRip",
"friqué" => "fRike",
"friquée" => "fRike",
"friquées" => "fRike",
"friqués" => "fRike",
"frire" => "fRiR",
"fris" => "fRi",
"frisa" => "fRiza",
"frisaient" => "fRizE",
"frisais" => "fRizE",
"frisait" => "fRizE",
"frisâmes" => "fRizam",
"frisant" => "fRiz@",
"frisante" => "fRiz@t",
"frisants" => "fRiz@",
"frisbee" => "fRisbi",
"frise" => "fRiz",
"frisé" => "fRize",
"frise-poulet" => "fRizpulE",
"frisée" => "fRize",
"frisées" => "fRize",
"friselée" => "fRiz°le",
"friseler" => "fRiz°le",
"friselis" => "fRiz°li",
"frisent" => "fRiz",
"friser" => "fRize",
"friserai" => "fRiz°RE",
"frises" => "fRiz",
"frisés" => "fRize",
"frisette" => "fRizEt",
"frisettes" => "fRizEt",
"friseur" => "fRiz9R",
"frisez" => "fRize",
"frison" => "fRiz§",
"frisonne" => "fRizOn",
"frisonnes" => "fRizOn",
"frisons" => "fRiz§",
"frisottaient" => "fRizotE",
"frisottant" => "fRizot@",
"frisottants" => "fRizot@",
"frisotté" => "fRizote",
"frisottée" => "fRizote",
"frisottées" => "fRizote",
"frisottement" => "fRizOt°m@",
"frisottent" => "fRizOt",
"frisotter" => "fRizote",
"frisottés" => "fRizote",
"frisottis" => "fRizoti",
"frisous" => "fRizu",
"frisquet" => "fRiskE",
"frisquette" => "fRiskEt",
"frisselis" => "fRis°li",
"frisson" => "fRis§",
"frissonna" => "fRisona",
"frissonnai" => "fRisonE",
"frissonnaient" => "fRisonE",
"frissonnais" => "fRisonE",
"frissonnait" => "fRisonE",
"frissonnant" => "fRison@",
"frissonnante" => "fRison@t",
"frissonnantes" => "fRison@t",
"frissonnants" => "fRison@",
"frissonne" => "fRisOn",
"frissonné" => "fRisone",
"frissonnement" => "fRisOn°m@",
"frissonnements" => "fRisOn°m@",
"frissonnent" => "fRisOn",
"frissonner" => "fRisone",
"frissonnèrent" => "fRisonER",
"frissonnes" => "fRisOn",
"frissonnez" => "fRisone",
"frissons" => "fRis§",
"frisure" => "fRizyR",
"frisures" => "fRizyR",
"frit" => "fRi",
"frite" => "fRit",
"friterie" => "fRit°Ri",
"friteries" => "fRit°Ri",
"frites" => "fRit",
"friteuse" => "fRit2z",
"friteuses" => "fRit2z",
"fritillaires" => "fRitilER",
"fritons" => "fRit§",
"frits" => "fRi",
"fritte" => "fRit",
"fritter" => "fRite",
"frittés" => "fRite",
"friture" => "fRityR",
"fritures" => "fRityR",
"friturier" => "fRityRje",
"fritz" => "fRits",
"frivole" => "fRivOl",
"frivoles" => "fRivOl",
"frivolité" => "fRivolite",
"frivolités" => "fRivolite",
"froc" => "fROk",
"frocard" => "fRokaR",
"frocards" => "fRokaR",
"frocs" => "fROk",
"froid" => "fRwa",
"froidasse" => "fRwadas",
"froide" => "fRwad",
"froidement" => "fRwad°m@",
"froides" => "fRwad",
"froideur" => "fRwad9R",
"froideurs" => "fRwad9R",
"froidi" => "fRwadi",
"froidir" => "fRwadiR",
"froidissait" => "fRwadisE",
"froids" => "fRwa",
"froidure" => "fRwadyR",
"froidures" => "fRwadyR",
"froissa" => "fRwasa",
"froissaient" => "fRwasE",
"froissais" => "fRwasE",
"froissait" => "fRwasE",
"froissant" => "fRwas@",
"froisse" => "fRwas",
"froissé" => "fRwase",
"froissée" => "fRwase",
"froissées" => "fRwase",
"froissement" => "fRwas°m@",
"froissements" => "fRwas°m@",
"froissent" => "fRwas",
"froisser" => "fRwase",
"froissera" => "fRwas°Ra",
"froisserais" => "fRwas°RE",
"froisserait" => "fRwas°RE",
"froissèrent" => "fRwasER",
"froisses" => "fRwas",
"froissés" => "fRwase",
"froissez" => "fRwase",
"froissions" => "fRwasj§",
"frôla" => "fRola",
"frôlai" => "fRolE",
"frôlaient" => "fRolE",
"frôlais" => "fRolE",
"frôlait" => "fRolE",
"frôlant" => "fRol@",
"frôlât" => "fRola",
"frôle" => "fRol",
"frôlé" => "fRole",
"frôlée" => "fRole",
"frôlées" => "fRole",
"frôlement" => "fRol°m@",
"frôlements" => "fRol°m@",
"frôlent" => "fRol",
"frôler" => "fRole",
"frôlerais" => "fRol°RE",
"frôlerait" => "fRol°RE",
"frôlèrent" => "fRolER",
"frôles" => "fRol",
"frôlés" => "fRole",
"frôleur" => "fRol9R",
"frôleurs" => "fRol9R",
"frôleuse" => "fRol2z",
"frôleuses" => "fRol2z",
"frôlez" => "fRole",
"frôlions" => "fRolj§",
"frôlons" => "fRol§",
"fromage" => "fRomaZ",
"fromager" => "fRomaZe",
"fromagère" => "fRomaZER",
"fromagerie" => "fRomaZ°Ri",
"fromagers" => "fRomaZe",
"fromages" => "fRomaZ",
"fromegi" => "fRomZi",
"froment" => "fRom@",
"fromental" => "fRom@tal",
"frometon" => "fROm°t§",
"frometons" => "fROm°t§",
"fronça" => "fR§sa",
"fronçai" => "fR§sE",
"fronçaient" => "fR§sE",
"fronçais" => "fR§sE",
"fronçait" => "fR§sE",
"fronçant" => "fR§s@",
"fronce" => "fR§s",
"froncé" => "fR§se",
"froncée" => "fR§se",
"froncées" => "fR§se",
"froncement" => "fR§s°m@",
"froncements" => "fR§s°m@",
"froncer" => "fR§se",
"froncerait" => "fR§s°RE",
"froncèrent" => "fR§sER",
"fronces" => "fR§s",
"froncés" => "fR§se",
"froncez" => "fR§se",
"frondaient" => "fR§dE",
"frondaison" => "fR§dEz§",
"frondaisons" => "fR§dEz§",
"fronde" => "fR§d",
"frondé" => "fR§de",
"frondent" => "fR§d",
"frondes" => "fR§d",
"frondeur" => "fR§d9R",
"frondeurs" => "fR§d9R",
"frondeuse" => "fR§d2z",
"front" => "fR§",
"frontal" => "fR§tal",
"frontale" => "fR§tal",
"frontalier" => "fR§talje",
"frontalière" => "fR§taljER",
"frontalières" => "fR§taljER",
"frontaliers" => "fR§talje",
"frontaux" => "fR§to",
"fronteau" => "fR§to",
"frontière" => "fR§tjER",
"frontières" => "fR§tjER",
"frontispice" => "fR§tispis",
"frontispices" => "fR§tispis",
"fronton" => "fR§t§",
"frontons" => "fR§t§",
"fronts" => "fR§",
"frotta" => "fRota",
"frottage" => "fRotaZ",
"frottages" => "fRotaZ",
"frottai" => "fRotE",
"frottaient" => "fRotE",
"frottais" => "fRotE",
"frottait" => "fRotE",
"frottant" => "fRot@",
"frotte" => "fROt",
"frotté" => "fRote",
"frottée" => "fRote",
"frottées" => "fRote",
"frottement" => "fROt°m@",
"frottements" => "fROt°m@",
"frottent" => "fROt",
"frotter" => "fRote",
"frottera" => "fROt°Ra",
"frotterai" => "fROt°RE",
"frotterais" => "fROt°RE",
"frotterait" => "fROt°RE",
"frotteras" => "fROt°Ra",
"frottèrent" => "fRotER",
"frotterons" => "fROt°R§",
"frottes" => "fROt",
"frottés" => "fRote",
"frotteur" => "fRot9R",
"frotteurs" => "fRot9R",
"frotteuse" => "fRot2z",
"frotteuses" => "fRot2z",
"frottez" => "fRote",
"frotti-frotta" => "fRotifRota",
"frottiez" => "fRotje",
"frottin" => "fRot5",
"frottions" => "fRotj§",
"frottis" => "fRoti",
"frottoir" => "fRotwaR",
"frottoirs" => "fRotwaR",
"frottons" => "fRot§",
"frou-frou" => "fRufRu",
"frouement" => "fRum@",
"frouements" => "fRum@",
"froufrou" => "fRufRu",
"froufrous" => "fRufRu",
"froufroutait" => "fRufRutE",
"froufroutant" => "fRufRut@",
"froufroutante" => "fRufRut@t",
"froufroutantes" => "fRufRut@t",
"froufroutants" => "fRufRut@",
"froufroutement" => "fRufRut°m@",
"froufrouter" => "fRufRute",
"frous-frous" => "fRufRu",
"froussard" => "fRusaR",
"froussarde" => "fRusaRd",
"froussards" => "fRusaR",
"frousse" => "fRus",
"frousses" => "fRus",
"fructidor" => "fRyktidOR",
"fructifiaient" => "fRyktifjE",
"fructifiant" => "fRyktifj@",
"fructification" => "fRyktifikasj§",
"fructifié" => "fRyktifje",
"fructifier" => "fRyktifje",
"fructose" => "fRyktoz",
"fructueuse" => "fRykt82z",
"fructueuses" => "fRykt82z",
"fructueux" => "fRykt82",
"frugal" => "fRygal",
"frugale" => "fRygal",
"frugalement" => "fRygal°m@",
"frugales" => "fRygal",
"frugalité" => "fRygalite",
"frugaux" => "fRygo",
"frugivore" => "fRyZivOR",
"fruit" => "fR8i",
"fruité" => "fR8ite",
"fruitée" => "fR8ite",
"fruitées" => "fR8ite",
"fruiter" => "fR8ite",
"fruiteries" => "fR8it°Ri",
"fruités" => "fR8ite",
"fruiteux" => "fR8it2",
"fruitier" => "fR8itje",
"fruitière" => "fR8itjER",
"fruitières" => "fR8itjER",
"fruitiers" => "fR8itje",
"fruits" => "fR8i",
"frusquée" => "fRyske",
"frusquer" => "fRyske",
"frusques" => "fRysk",
"fruste" => "fRyst",
"frustes" => "fRyst",
"frustra" => "fRystRa",
"frustrait" => "fRystRE",
"frustrant" => "fRystR@",
"frustrante" => "fRystR@t",
"frustrantes" => "fRystR@t",
"frustrât" => "fRystRa",
"frustration" => "fRystRasj§",
"frustrations" => "fRystRasj§",
"frustre" => "fRystR",
"frustré" => "fRystRe",
"frustrée" => "fRystRe",
"frustrées" => "fRystRe",
"frustrer" => "fRystRe",
"frustrés" => "fRystRe",
"fuchsia" => "fySja",
"fuchsias" => "fySja",
"fuégien" => "f8eZj5",
"fuel" => "fjul",
"fuel-oil" => "fjulOjl",
"fugace" => "fygas",
"fugacement" => "fygas°m@",
"fugaces" => "fygas",
"fugacité" => "fygasite",
"fugitif" => "fyZitif",
"fugitifs" => "fyZitif",
"fugitive" => "fyZitiv",
"fugitivement" => "fyZitiv°m@",
"fugitives" => "fyZitiv",
"fugu" => "fygy",
"fuguaient" => "fygE",
"fuguait" => "fygE",
"fugue" => "fyg",
"fugué" => "fyge",
"fuguées" => "fyge",
"fuguent" => "fyg",
"fuguer" => "fyge",
"fuguerais" => "fyg°RE",
"fuguèrent" => "fygER",
"fugues" => "fyg",
"fugueur" => "fyg9R",
"fugueurs" => "fyg9R",
"fugueuse" => "fyg2z",
"fugueuses" => "fyg2z",
"führer" => "fyR9R",
"führers" => "fyR9R",
"fui" => "f8i",
"fuie" => "f8i",
"fuient" => "f8i",
"fuies" => "f8i",
"fuir" => "f8iR",
"fuira" => "f8iRa",
"fuirai" => "f8iRE",
"fuiraient" => "f8iRE",
"fuirais" => "f8iRE",
"fuirait" => "f8iRE",
"fuiras" => "f8iRa",
"fuirent" => "f8iR",
"fuirez" => "f8iRe",
"fuiriez" => "f8iRje",
"fuirions" => "f8iRj§",
"fuirons" => "f8iR§",
"fuiront" => "f8iR§",
"fuis" => "f8i",
"fuisse" => "f8is",
"fuit" => "f8i",
"fuite" => "f8it",
"fuiter" => "f8ite",
"fuites" => "f8it",
"fulgores" => "fylgOR",
"fulgura" => "fylgyRa",
"fulguraient" => "fylgyRE",
"fulgurait" => "fylgyRE",
"fulgurance" => "fylgyR@s",
"fulgurances" => "fylgyR@s",
"fulgurant" => "fylgyR@",
"fulgurante" => "fylgyR@t",
"fulgurantes" => "fylgyR@t",
"fulgurants" => "fylgyR@",
"fulguration" => "fylgyRasj§",
"fulgurations" => "fylgyRasj§",
"fulgure" => "fylgyR",
"fulguré" => "fylgyRe",
"fulgurent" => "fylgyR",
"fulgurer" => "fylgyRe",
"fulgurèrent" => "fylgyRER",
"fuligineuse" => "fyliZin2z",
"fuligineuses" => "fyliZin2z",
"fuligineux" => "fyliZin2",
"fuligule" => "fyligyl",
"full" => "ful",
"full-contact" => "fulk§takt",
"fullerène" => "fyl°REn",
"fulls" => "ful",
"fulmicoton" => "fylmikot§",
"fulmina" => "fylmina",
"fulminaient" => "fylminE",
"fulminais" => "fylminE",
"fulminait" => "fylminE",
"fulminant" => "fylmin@",
"fulminante" => "fylmin@t",
"fulminantes" => "fylmin@t",
"fulminants" => "fylmin@",
"fulminate" => "fylminat",
"fulmination" => "fylminasj§",
"fulminations" => "fylminasj§",
"fulmine" => "fylmin",
"fulminement" => "fylmin°m@",
"fulminent" => "fylmin",
"fulminer" => "fylmine",
"fulminera" => "fylmin°Ra",
"fuma" => "fyma",
"fumaga" => "fymaga",
"fumage" => "fymaZ",
"fumai" => "fymE",
"fumaient" => "fymE",
"fumaillé" => "fymaje",
"fumailler" => "fymaje",
"fumais" => "fymE",
"fumaison" => "fymEz§",
"fumait" => "fymE",
"fumâmes" => "fymam",
"fumant" => "fym@",
"fumante" => "fym@t",
"fumantes" => "fym@t",
"fumants" => "fym@",
"fumasse" => "fymas",
"fumât" => "fyma",
"fume" => "fym",
"fumé" => "fyme",
"fume-cigarette" => "fymsigaREt",
"fume-cigarettes" => "fymsigaREt",
"fumée" => "fyme",
"fumées" => "fyme",
"fument" => "fym",
"fumer" => "fyme",
"fumera" => "fym°Ra",
"fumerai" => "fym°RE",
"fumeraient" => "fym°RE",
"fumerais" => "fym°RE",
"fumerait" => "fym°RE",
"fumeras" => "fym°Ra",
"fumèrent" => "fymER",
"fumerez" => "fym°Re",
"fumerie" => "fym°Ri",
"fumeries" => "fym°Ri",
"fumerolles" => "fym°ROl",
"fumeron" => "fym°R§",
"fumeronne" => "fym°ROn",
"fumerons" => "fym°R§",
"fumes" => "fym",
"fûmes" => "fym",
"fumés" => "fyme",
"fumet" => "fymE",
"fumets" => "fymE",
"fumette" => "fymEt",
"fumeur" => "fym9R",
"fumeurs" => "fym9R",
"fumeuse" => "fym2z",
"fumeuses" => "fym2z",
"fumeux" => "fym2",
"fumez" => "fyme",
"fumier" => "fymje",
"fumière" => "fymjER",
"fumiers" => "fymje",
"fumiez" => "fymje",
"fumigateur" => "fymigat9R",
"fumigation" => "fymigasj§",
"fumigations" => "fymigasj§",
"fumigé" => "fymiZe",
"fumigène" => "fymiZEn",
"fumigènes" => "fymiZEn",
"fumiger" => "fymiZe",
"fumions" => "fymj§",
"fumiste" => "fymist",
"fumisterie" => "fymist°Ri",
"fumisteries" => "fymist°Ri",
"fumistes" => "fymist",
"fumoir" => "fymwaR",
"fumons" => "fym§",
"fumure" => "fymyR",
"fun" => "fyn",
"funambule" => "fyn@byl",
"funambules" => "fyn@byl",
"funambulesque" => "fyn@bylEsk",
"funèbre" => "fynEbR",
"funèbres" => "fynEbR",
"funérailles" => "fyneRaj",
"funéraire" => "fyneRER",
"funéraires" => "fyneRER",
"funérarium" => "fyneRaRjOm",
"funérariums" => "fyneRaRjOm",
"funeste" => "fynEst",
"funestement" => "fynEst°m@",
"funestes" => "fynEst",
"fung" => "fuG",
"funiculaire" => "fynikylER",
"funiculaires" => "fynikylER",
"funk" => "f1k",
"funky" => "f9nki",
"fur et à mesure" => "fyReam°zyR",
"furax" => "fyRaks",
"furent" => "fyR",
"furet" => "fyRE",
"fureta" => "fyR°ta",
"furetage" => "fyR°taZ",
"furetai" => "fyR°tE",
"furetaient" => "fyR°tE",
"furetait" => "fyR°tE",
"furetant" => "fyR°t@",
"furète" => "fyREt",
"fureté" => "fyR°te",
"furètent" => "fyREt",
"fureter" => "fyR°te",
"furèterais" => "fyREt°RE",
"fureteur" => "fyR°t9R",
"fureteurs" => "fyR°t9R",
"fureteuse" => "fyR°t2z",
"fureteuses" => "fyR°t2z",
"furetez" => "fyR°te",
"furets" => "fyRE",
"furette" => "fyREt",
"fureur" => "fyR9R",
"fureurs" => "fyR9R",
"furia" => "fyRja",
"furibard" => "fyRibaR",
"furibarde" => "fyRibaRd",
"furibardes" => "fyRibaRd",
"furibond" => "fyRib§",
"furibonde" => "fyRib§d",
"furibondes" => "fyRib§d",
"furibonds" => "fyRib§",
"furie" => "fyRi",
"furies" => "fyRi",
"furieuse" => "fyRj2z",
"furieusement" => "fyRj2z°m@",
"furieuses" => "fyRj2z",
"furieux" => "fyRj2",
"furioso" => "fyRjozo",
"furoncle" => "fyR§kl",
"furoncles" => "fyR§kl",
"furonculeux" => "fyR§kyl2",
"furonculose" => "fyR§kyloz",
"furonculoses" => "fyR§kyloz",
"furtif" => "fyRtif",
"furtifs" => "fyRtif",
"furtive" => "fyRtiv",
"furtivement" => "fyRtiv°m@",
"furtives" => "fyRtiv",
"furtivité" => "fyRtivite",
"fus" => "fy",
"fusa" => "fyza",
"fusaient" => "fyzE",
"fusain" => "fyz5",
"fusains" => "fyz5",
"fusait" => "fyzE",
"fusant" => "fyz@",
"fusante" => "fyz@t",
"fusants" => "fyz@",
"fuse" => "fyz",
"fusé" => "fyze",
"fuseau" => "fyzo",
"fuseaux" => "fyzo",
"fusée" => "fyze",
"fusées" => "fyze",
"fuselage" => "fyz°laZ",
"fuselages" => "fyz°laZ",
"fuselé" => "fyz°le",
"fuselée" => "fyz°le",
"fuselées" => "fyz°le",
"fuselés" => "fyz°le",
"fusent" => "fyz",
"fuser" => "fyze",
"fusèrent" => "fyzER",
"fusible" => "fyzibl",
"fusibles" => "fyzibl",
"fusiforme" => "fyzifORm",
"fusil" => "fyzi",
"fusil-mitrailleur" => "fyzimitRaj9R",
"fusilier" => "fyzilje",
"fusiliers" => "fyzilje",
"fusiliers-marins" => "fyziljemaR5",
"fusilla" => "fyzija",
"fusillade" => "fyzijad",
"fusillades" => "fyzijad",
"fusillaient" => "fyzijE",
"fusillait" => "fyzijE",
"fusillant" => "fyzij@",
"fusille" => "fyzij",
"fusillé" => "fyzije",
"fusillée" => "fyzije",
"fusillées" => "fyzije",
"fusillent" => "fyzij",
"fusiller" => "fyzije",
"fusillera" => "fyzij°Ra",
"fusilleraient" => "fyzij°RE",
"fusillerait" => "fyzij°RE",
"fusillerons" => "fyzij°R§",
"fusilleront" => "fyzij°R§",
"fusillés" => "fyzije",
"fusilleurs" => "fyzij9R",
"fusillez" => "fyzije",
"fusillions" => "fyzij§",
"fusillons" => "fyzij§",
"fusils" => "fyzi",
"fusils-mitrailleurs" => "fyzimitRaj9R",
"fusion" => "fyzj§",
"fusionnaient" => "fyzjonE",
"fusionnant" => "fyzjon@",
"fusionne" => "fyzjOn",
"fusionné" => "fyzjone",
"fusionnel" => "fyzjonEl",
"fusionnelle" => "fyzjonEl",
"fusionnement" => "fyzjOn°m@",
"fusionnent" => "fyzjOn",
"fusionner" => "fyzjone",
"fusionneraient" => "fyzjOn°RE",
"fusionnerait" => "fyzjOn°RE",
"fusionneront" => "fyzjOn°R§",
"fusionnés" => "fyzjone",
"fusionnons" => "fyzjon§",
"fusions" => "fyzj§",
"fusse" => "fys",
"fussent" => "fys",
"fusses" => "fys",
"fussiez" => "fysje",
"fussions" => "fysj§",
"fustanelle" => "fystanEl",
"fustigation" => "fystigasj§",
"fustigations" => "fystigasj§",
"fustige" => "fystiZ",
"fustigé" => "fystiZe",
"fustigea" => "fystiZa",
"fustigeaient" => "fystiZE",
"fustigeais" => "fystiZE",
"fustigeait" => "fystiZE",
"fustigeant" => "fystiZ@",
"fustigée" => "fystiZe",
"fustiger" => "fystiZe",
"fustigés" => "fystiZe",
"fustigez" => "fystiZe",
"fut" => "fy",
"fût" => "fy",
"futaie" => "fytE",
"futaies" => "fytE",
"futaille" => "fytaj",
"futailles" => "fytaj",
"futaine" => "fytEn",
"futal" => "fytal",
"futals" => "fytal",
"futé" => "fyte",
"futée" => "fyte",
"futées" => "fyte",
"fûtes" => "fyt",
"futés" => "fyte",
"futile" => "fytil",
"futilement" => "fytil°m@",
"futiles" => "fytil",
"futilité" => "fytilite",
"futilités" => "fytilite",
"futon" => "fyt§",
"futons" => "fyt§",
"fûts" => "fy",
"futur" => "fytyR",
"future" => "fytyR",
"futures" => "fytyR",
"futurisme" => "fytyRizm",
"futuriste" => "fytyRist",
"futuristes" => "fytyRist",
"futurologue" => "fytyRolOg",
"futurs" => "fytyR",
"fuyaient" => "f8ijE",
"fuyais" => "f8ijE",
"fuyait" => "f8ijE",
"fuyant" => "f8ij@",
"fuyante" => "f8ij@t",
"fuyantes" => "f8ij@t",
"fuyants" => "f8ij@",
"fuyard" => "f8ijaR",
"fuyarde" => "f8ijaRd",
"fuyards" => "f8ijaR",
"fuyez" => "f8ije",
"fuyiez" => "f8ijje",
"fuyions" => "f8ij§",
"fuyons" => "f8ij§",
"fy" => "fi1",
"g" => "Ze",
"gaba" => "gaba",
"gabardine" => "gabaRdin",
"gabardines" => "gabaRdin",
"gabare" => "gabaR",
"gabariers" => "gabaRje",
"gabarit" => "gabaRi",
"gabarits" => "gabaRi",
"gabarres" => "gabaR",
"gabbro" => "gabRo",
"gabe" => "gab",
"gabegie" => "gabZi",
"gabelle" => "gabEl",
"gabelou" => "gab°lu",
"gabier" => "gabje",
"gabiers" => "gabje",
"gabion" => "gabj§",
"gabions" => "gabj§",
"gable" => "gabl",
"gables" => "gabl",
"gabonais" => "gabonE",
"gabonaise" => "gabonEz",
"gâcha" => "gaSa",
"gâchage" => "gaSaZ",
"gâchaient" => "gaSE",
"gâchais" => "gaSE",
"gâchait" => "gaSE",
"gâchant" => "gaS@",
"gâchât" => "gaSa",
"gâche" => "gaS",
"gâché" => "gaSe",
"gâchée" => "gaSe",
"gâchées" => "gaSe",
"gâchent" => "gaS",
"gâcher" => "gaSe",
"gâchera" => "gaS°Ra",
"gâcherai" => "gaS°RE",
"gâcheraient" => "gaS°RE",
"gâcherais" => "gaS°RE",
"gâcherait" => "gaS°RE",
"gâcheras" => "gaS°Ra",
"gâcherez" => "gaS°Re",
"gâcheriez" => "gaS°Rje",
"gâches" => "gaS",
"gâchés" => "gaSe",
"gâchette" => "gaSEt",
"gâchettes" => "gaSEt",
"gâcheur" => "gaS9R",
"gâcheurs" => "gaS9R",
"gâcheuse" => "gaS2z",
"gâchez" => "gaSe",
"gâchiez" => "gaSje",
"gâchis" => "gaSi",
"gâchons" => "gaS§",
"gade" => "gad",
"gadget" => "gadZEt",
"gadgets" => "gadZEt",
"gadin" => "gad5",
"gadins" => "gad5",
"gadjo" => "gadZo",
"gadolinium" => "gadOlinjOm",
"gadoue" => "gadu",
"gadoues" => "gadu",
"gadouille" => "gaduj",
"gaélique" => "gaelik",
"gaffa" => "gafa",
"gaffaient" => "gafE",
"gaffais" => "gafE",
"gaffait" => "gafE",
"gaffant" => "gaf@",
"gaffe" => "gaf",
"gaffé" => "gafe",
"gaffée" => "gafe",
"gaffent" => "gaf",
"gaffer" => "gafe",
"gafferai" => "gaf°RE",
"gaffes" => "gaf",
"gaffés" => "gafe",
"gaffeur" => "gaf9R",
"gaffeurs" => "gaf9R",
"gaffeuse" => "gaf2z",
"gaffeuses" => "gaf2z",
"gaffez" => "gafe",
"gag" => "gag",
"gaga" => "gaga",
"gagas" => "gaga",
"gage" => "gaZ",
"gagé" => "gaZe",
"gageaient" => "gaZE",
"gagée" => "gaZe",
"gageons" => "gaZ§",
"gager" => "gaZe",
"gagerai" => "gaZ°RE",
"gagerais" => "gaZ°RE",
"gages" => "gaZ",
"gageure" => "gaZyR",
"gageures" => "gaZ9R",
"gagez" => "gaZe",
"gagna" => "gaNa",
"gagnage" => "gaNaZ",
"gagnages" => "gaNaZ",
"gagnai" => "gaNE",
"gagnaient" => "gaNE",
"gagnais" => "gaNE",
"gagnait" => "gaNE",
"gagnâmes" => "gaNam",
"gagnant" => "gaN@",
"gagnante" => "gaN@t",
"gagnantes" => "gaN@t",
"gagnants" => "gaN@",
"gagnât" => "gaNa",
"gagne" => "gaN",
"gagné" => "gaNe",
"gagne-pain" => "gaNp5",
"gagne-petit" => "gaNp°ti",
"gagnée" => "gaNe",
"gagnées" => "gaNe",
"gagnent" => "gaN",
"gagner" => "gaNe",
"gagnera" => "gaN°Ra",
"gagnerai" => "gaN°RE",
"gagneraient" => "gaN°RE",
"gagnerais" => "gaN°RE",
"gagnerait" => "gaN°RE",
"gagneras" => "gaN°Ra",
"gagnèrent" => "gaNER",
"gagnerez" => "gaN°Re",
"gagneriez" => "gaN°Rje",
"gagnerions" => "gaN°Rj§",
"gagnerons" => "gaN°R§",
"gagneront" => "gaN°R§",
"gagnes" => "gaN",
"gagnés" => "gaNe",
"gagneur" => "gaN9R",
"gagneurs" => "gaN9R",
"gagneuse" => "gaN2z",
"gagneuses" => "gaN2z",
"gagnez" => "gaNe",
"gagniez" => "gaNe",
"gagnions" => "gaN§",
"gagnons" => "gaN§",
"gags" => "gag",
"gai" => "gE",
"gaie" => "gE",
"gaiement" => "gem@",
"gaies" => "ge",
"gaieté" => "gete",
"gaietés" => "gEte",
"gail" => "gEl",
"gaillard" => "gajaR",
"gaillarde" => "gajaRd",
"gaillardement" => "gajaRd°m@",
"gaillardes" => "gajaRd",
"gaillardise" => "gajaRdiz",
"gaillards" => "gajaR",
"gaillet" => "gajE",
"gaillette" => "gajEt",
"gaillettes" => "gajEt",
"gaîment" => "gem@",
"gain" => "g5",
"gainaient" => "gEnE",
"gainait" => "gEnE",
"gaine" => "gEn",
"gainé" => "gEne",
"gaine-culotte" => "gEnkylOt",
"gainée" => "gEne",
"gainées" => "gEne",
"gainent" => "gEn",
"gainer" => "gene",
"gaines" => "gEn",
"gainés" => "gEne",
"gainiers" => "gEnje",
"gains" => "g5",
"gais" => "ge",
"gaîté" => "gete",
"gaîtés" => "gEte",
"gal" => "gal",
"gala" => "gala",
"galactique" => "galaktik",
"galactiques" => "galaktik",
"galactophore" => "galaktOfOR",
"galago" => "galago",
"galalithe" => "galalit",
"galamment" => "galam@",
"galant" => "gal@",
"galante" => "gal@t",
"galanterie" => "gal@t°Ri",
"galanteries" => "gal@t°Ri",
"galantes" => "gal@t",
"galantine" => "gal@tin",
"galantines" => "gal@tin",
"galantins" => "gal@t5",
"galantisait" => "gal@tizE",
"galantisé" => "gal@tize",
"galants" => "gal@",
"galapiat" => "galapja",
"galapiats" => "galapja",
"galas" => "gala",
"galate" => "galat",
"galates" => "galat",
"galathée" => "galate",
"galaxie" => "galaksi",
"galaxies" => "galaksi",
"galbait" => "galbE",
"galbe" => "galb",
"galbé" => "galbe",
"galbée" => "galbe",
"galbées" => "galbe",
"galber" => "galbe",
"galbes" => "galb",
"galbés" => "galbe",
"gale" => "gal",
"galéasses" => "galeas",
"galée" => "gale",
"galées" => "gale",
"galéjade" => "galeZad",
"galéjades" => "galeZad",
"galéjeur" => "galeZ9R",
"galène" => "galEn",
"galéniste" => "galenist",
"galérais" => "galeRE",
"galérait" => "galeRE",
"galère" => "galER",
"galéré" => "galeRe",
"galèrent" => "galER",
"galérer" => "galeRe",
"galères" => "galER",
"galerie" => "gal°Ri",
"galerie-refuge" => "gal°RiR°fyZ",
"galérien" => "galeRj5",
"galériens" => "galeRj5",
"galeries" => "gal°Ri",
"galeries-refuges" => "gal°RiR°fyZ",
"galeriste" => "gal°Rist",
"galernes" => "galERn",
"gales" => "gal",
"galet" => "galE",
"galetas" => "gal°ta",
"galetouse" => "gal°tuz",
"galets" => "galE",
"galette" => "galEt",
"galettes" => "galEt",
"galetteux" => "galEt2",
"galeuse" => "gal2z",
"galeuses" => "gal2z",
"galeux" => "gal2",
"galibot" => "galibo",
"galibots" => "galibo",
"galicien" => "galisj5",
"galiciennes" => "galisjEn",
"galiciens" => "galisj5",
"galiléen" => "galile5",
"galimatias" => "galimatja",
"galion" => "galj§",
"galions" => "galj§",
"galiote" => "galjOt",
"galiotes" => "galjOt",
"galipette" => "galipEt",
"galipettes" => "galipEt",
"gallant" => "gal@",
"galle" => "gal",
"galles" => "gal",
"gallicanes" => "galikan",
"gallicanisme" => "galikanizm",
"gallinacé" => "galinase",
"galline" => "galin",
"gallique" => "galik",
"gallium" => "galjOm",
"gallo" => "galo",
"gallo-romain" => "galoRom5",
"gallo-romains" => "galoRom5",
"gallois" => "galwa",
"galloise" => "galwaz",
"galloises" => "galwaz",
"gallon" => "gal§",
"gallons" => "gal§",
"gallos" => "galo",
"galoche" => "galOS",
"galoché" => "galoSe",
"galoches" => "galOS",
"galochés" => "galoSe",
"galon" => "gal§",
"galonnage" => "galonaZ",
"galonnait" => "galonE",
"galonne" => "galOn",
"galonné" => "galone",
"galonnée" => "galone",
"galonnées" => "galone",
"galonnés" => "galone",
"galons" => "gal§",
"galop" => "galo",
"galopa" => "galopa",
"galopade" => "galopad",
"galopades" => "galopad",
"galopaient" => "galopE",
"galopais" => "galopE",
"galopait" => "galopE",
"galopant" => "galop@",
"galopante" => "galop@t",
"galopantes" => "galop@t",
"galopants" => "galop@",
"galope" => "galOp",
"galopé" => "galope",
"galopent" => "galOp",
"galoper" => "galope",
"galopera" => "galOp°Ra",
"galoperaient" => "galOp°RE",
"galopèrent" => "galopER",
"galoperez" => "galOp°Re",
"galopes" => "galOp",
"galopez" => "galope",
"galopin" => "galop5",
"galopine" => "galopin",
"galopiner" => "galopine",
"galopines" => "galopin",
"galopins" => "galop5",
"galopons" => "galop§",
"galops" => "galo",
"galoubet" => "galubE",
"galoup" => "galu",
"galtouse" => "galtuz",
"galtouses" => "galtuz",
"galuchat" => "galySa",
"galure" => "galyR",
"galures" => "galyR",
"galurin" => "galyR5",
"galvanique" => "galvanik",
"galvanisa" => "galvaniza",
"galvanisait" => "galvanizE",
"galvanisant" => "galvaniz@",
"galvanise" => "galvaniz",
"galvanisé" => "galvanize",
"galvanisée" => "galvanize",
"galvanisées" => "galvanize",
"galvaniser" => "galvanize",
"galvanisés" => "galvanize",
"galvanisme" => "galvanizm",
"galvaudait" => "galvodE",
"galvaudant" => "galvod@",
"galvaude" => "galvod",
"galvaudé" => "galvode",
"galvaudée" => "galvode",
"galvaudent" => "galvod",
"galvauder" => "galvode",
"galvaudeux" => "galvod2",
"galvaudez" => "galvode",
"galvaudiez" => "galvodje",
"gamahuche" => "gamayS",
"gamay" => "gamE",
"gambada" => "g@bada",
"gambadaient" => "g@badE",
"gambadais" => "g@badE",
"gambadait" => "g@badE",
"gambadant" => "g@bad@",
"gambadante" => "g@bad@t",
"gambade" => "g@bad",
"gambadent" => "g@bad",
"gambader" => "g@bade",
"gambadèrent" => "g@badER",
"gambades" => "g@bad",
"gambadeurs" => "g@bad9R",
"gambadez" => "g@bade",
"gambas" => "g@bas",
"gambe" => "g@b",
"gamberge" => "g@bERZ",
"gambergé" => "g@bERZe",
"gambergea" => "g@bERZa",
"gambergeaient" => "g@bERZE",
"gambergeailler" => "g@bERZaje",
"gambergeais" => "g@bERZE",
"gambergeait" => "g@bERZE",
"gambergeant" => "g@bERZ@",
"gambergent" => "g@bERZ",
"gambergeons" => "g@bERZ§",
"gamberger" => "g@bERZe",
"gamberges" => "g@bERZ",
"gambergez" => "g@bERZe",
"gambette" => "g@bEt",
"gambettes" => "g@bEt",
"gambillait" => "g@bijE",
"gambillant" => "g@bij@",
"gambille" => "g@bij",
"gambillé" => "g@bije",
"gambiller" => "g@bije",
"gambilles" => "g@bij",
"gambilleurs" => "g@bij9R",
"gambilleuses" => "g@bij2z",
"gambit" => "g@bi",
"game" => "gEjm",
"gamelan" => "gam°l@",
"gamelle" => "gamEl",
"gamelles" => "gamEl",
"gamète" => "gamEt",
"gamètes" => "gamEt",
"gamin" => "gam5",
"gaminas" => "gamina",
"gamine" => "gamin",
"gaminement" => "gamin°m@",
"gaminerie" => "gamin°Ri",
"gamineries" => "gamin°Ri",
"gamines" => "gamin",
"gamins" => "gam5",
"gamma" => "gama",
"gammaglobuline" => "gamaglobylin",
"gammaglobulines" => "gamaglobylin",
"gammas" => "gama",
"gamme" => "gam",
"gammée" => "game",
"gammées" => "game",
"gammes" => "gam",
"gan" => "gan",
"ganache" => "ganaS",
"ganaderia" => "ganadeRja",
"ganaderias" => "ganadeRja",
"gandin" => "g@d5",
"gandins" => "g@d5",
"gandoura" => "g@duRa",
"gandourah" => "g@duRa",
"gandouras" => "g@duRa",
"gang" => "g@g",
"ganglion" => "g@glij§",
"ganglionnaires" => "g@gljonER",
"ganglions" => "g@glij§",
"gangrena" => "g@gR°na",
"gangrène" => "g@gREn",
"gangrené" => "g@gR°ne",
"gangrenée" => "g@gR°ne",
"gangrenées" => "g@gR°ne",
"gangrener" => "g@gR°ne",
"gangrènes" => "g@gREn",
"gangrenés" => "g@gR°ne",
"gangreneux" => "g@gR°n2",
"gangs" => "g@g",
"gangster" => "g@gstER",
"gangstérisme" => "g@gsteRizm",
"gangsters" => "g@gstER",
"gangue" => "g@g",
"gangues" => "g@g",
"ganja" => "g@Za",
"ganse" => "g@s",
"gansé" => "g@se",
"gansée" => "g@se",
"ganses" => "g@s",
"gant" => "g@",
"gantait" => "g@tE",
"gantant" => "g@t@",
"gante" => "g@t",
"ganté" => "g@te",
"gantée" => "g@te",
"gantées" => "g@te",
"gantelet" => "g@t°lE",
"gantelets" => "g@t°lE",
"ganterie" => "g@t°Ri",
"gantés" => "g@te",
"gantier" => "g@tje",
"gantières" => "g@tjER",
"gants" => "g@",
"ganymèdes" => "ganimEd",
"gap" => "gap",
"gaperon" => "gap°R§",
"gapette" => "gapEt",
"gâpette" => "gapEt",
"gapettes" => "gapEt",
"gara" => "gaRa",
"garage" => "gaRaZ",
"garages" => "gaRaZ",
"garagiste" => "gaRaZist",
"garagistes" => "gaRaZist",
"garaient" => "gaRE",
"garais" => "gaRE",
"garait" => "gaRE",
"garance" => "gaR@s",
"garancière" => "gaR@sjER",
"garant" => "gaR@",
"garante" => "gaR@t",
"garantes" => "gaR@t",
"garanti" => "gaR@ti",
"garantie" => "gaR@ti",
"garanties" => "gaR@ti",
"garantir" => "gaR@tiR",
"garantira" => "gaR@tiRa",
"garantirais" => "gaR@tiRE",
"garantirait" => "gaR@tiRE",
"garantiriez" => "gaR@tiRje",
"garantirons" => "gaR@tiR§",
"garantiront" => "gaR@tiR§",
"garantis" => "gaR@ti",
"garantissaient" => "gaR@tisE",
"garantissais" => "gaR@tisE",
"garantissait" => "gaR@tisE",
"garantissant" => "gaR@tis@",
"garantisse" => "gaR@tis",
"garantissent" => "gaR@tis",
"garantissez" => "gaR@tise",
"garantissons" => "gaR@tis§",
"garantit" => "gaR@ti",
"garantît" => "gaR@ti",
"garants" => "gaR@",
"garbure" => "gaRbyR",
"garce" => "gaRs",
"garces" => "gaRs",
"garcette" => "gaRsEt",
"garcettes" => "gaRsEt",
"garçon" => "gaRs§",
"garçonne" => "gaRsOn",
"garçonnet" => "gaRsonE",
"garçonnets" => "gaRsonE",
"garçonnier" => "gaRsonje",
"garçonnière" => "gaRsonjER",
"garçonnières" => "gaRsonjER",
"garçonniers" => "gaRsonje",
"garçons" => "gaRs§",
"garda" => "gaRda",
"gardai" => "gaRdE",
"gardaient" => "gaRdE",
"gardais" => "gaRdE",
"gardait" => "gaRdE",
"gardâmes" => "gaRdam",
"gardant" => "gaRd@",
"gardât" => "gaRda",
"garde" => "gaRd",
"gardé" => "gaRde",
"garde-à-vous" => "gaRdavu",
"garde-barrière" => "gaRd°baRjER",
"garde-boue" => "gaRd°bu",
"garde-champêtre" => "gaRd°S@pEtR",
"garde-chasse" => "gaRd°Sas",
"garde-chiourme" => "gaRd°SjuRm",
"garde-corps" => "gaRd°kOR",
"garde-côte" => "gaRd°kot",
"garde-côtes" => "gaRd°kot",
"garde-feu" => "gaRd°f2",
"garde-forestier" => "gaRd2fOREstje",
"garde-fou" => "gaRd°fu",
"garde-fous" => "gaRd°fu",
"garde-frontière" => "gaRd°fR§tjER",
"garde-malade" => "gaRdmalad",
"garde-manger" => "gaRdm@Ze",
"garde-meuble" => "gaRd°m9bl",
"garde-meubles" => "gaRd°m9bl",
"garde-pêche" => "gaRd°pES",
"garde-robe" => "gaRd°ROb",
"garde-robes" => "gaRd°ROb",
"garde-voie" => "gaRd°vwa",
"garde-vue" => "gaRd°vy",
"gardée" => "gaRde",
"gardées" => "gaRde",
"garden-party" => "gaRdEnpaRti",
"gardénal" => "gaRdenal",
"gardénia" => "gaRdenja",
"gardénias" => "gaRdenja",
"gardent" => "gaRd",
"garder" => "gaRde",
"gardera" => "gaRd°Ra",
"garderai" => "gaRd°RE",
"garderaient" => "gaRd°RE",
"garderais" => "gaRd°RE",
"garderait" => "gaRd°RE",
"garderas" => "gaRd°Ra",
"gardèrent" => "gaRdER",
"garderez" => "gaRd°Re",
"garderie" => "gaRd°Ri",
"garderies" => "gaRd°Ri",
"garderiez" => "gaRd°Rje",
"garderions" => "gaRd°Rj§",
"garderons" => "gaRd°R§",
"garderont" => "gaRd°R§",
"gardes" => "gaRd",
"gardés" => "gaRde",
"gardes-barrières" => "gaRd°baRjER",
"gardes-champêtres" => "gaRd°S@pEtR",
"gardes-chasse" => "gaRd°Sas",
"gardes-chiourme" => "gaRd°SjuRm",
"gardes-chiourmes" => "gaRd°SjuRm",
"gardes-côtes" => "gaRd°kot",
"gardes-françaises" => "gaRd°fR@sEz",
"gardes-frontières" => "gaRd°fR§tjER",
"gardes-voies" => "gaRd°vwa",
"gardeur" => "gaRd9R",
"gardeurs" => "gaRd9R",
"gardeuse" => "gaRd2z",
"gardeuses" => "gaRd2z",
"gardez" => "gaRde",
"gardian" => "gaRdj@",
"gardians" => "gaRdij@",
"gardien" => "gaRdj5",
"gardien-chef" => "gaRdj5SEf",
"gardiennage" => "gaRdjEnaZ",
"gardiennait" => "gaRdjEnE",
"gardienne" => "gaRdjEn",
"gardiennes" => "gaRdjEn",
"gardiens" => "gaRdj5",
"gardiez" => "gaRdje",
"gardions" => "gaRdj§",
"gardois" => "gaRdwa",
"gardon" => "gaRd§",
"gardons" => "gaRd§",
"gare" => "gaR",
"garé" => "gaRe",
"garée" => "gaRe",
"garées" => "gaRe",
"garenne" => "gaREn",
"garennes" => "gaREn",
"garent" => "gaR",
"garer" => "gaRe",
"garerai" => "gaR°RE",
"garerais" => "gaR°RE",
"garerait" => "gaR°RE",
"garèrent" => "gaRER",
"gareront" => "gaR°R§",
"gares" => "gaR",
"garés" => "gaRe",
"garez" => "gaRe",
"gargamelle" => "gaRgamEl",
"gargantua" => "gaRg@t8a",
"gargantuesque" => "gaRg@t8Esk",
"gargantuesques" => "gaRg@t8Esk",
"gargarisa" => "gaRgaRiza",
"gargarisaient" => "gaRgaRizE",
"gargarisait" => "gaRgaRizE",
"gargarisant" => "gaRgaRiz@",
"gargarise" => "gaRgaRiz",
"gargarisé" => "gaRgaRize",
"gargarisent" => "gaRgaRiz",
"gargariser" => "gaRgaRize",
"gargarisme" => "gaRgaRizm",
"gargarismes" => "gaRgaRizm",
"gargote" => "gaRgOt",
"gargotes" => "gaRgOt",
"gargotier" => "gaRgotje",
"gargotiers" => "gaRgotje",
"gargouilla" => "gaRguja",
"gargouillaient" => "gaRgujE",
"gargouillait" => "gaRgujE",
"gargouillant" => "gaRguj@",
"gargouillante" => "gaRguj@t",
"gargouille" => "gaRguj",
"gargouillé" => "gaRguje",
"gargouillement" => "gaRguj°m@",
"gargouillements" => "gaRguj°m@",
"gargouillent" => "gaRguj",
"gargouiller" => "gaRguje",
"gargouilles" => "gaRguj",
"gargouillette" => "gaRgujEt",
"gargouillis" => "gaRguji",
"gargoulette" => "gaRgulEt",
"gargoulettes" => "gaRgulEt",
"gargousses" => "gaRgus",
"gari" => "gaRi",
"garibaldien" => "gaRibaldj5",
"garibaldiens" => "gaRibaldj5",
"garions" => "gaRj§",
"garnement" => "gaRn°m@",
"garnements" => "gaRn°m@",
"garni" => "gaRni",
"garnie" => "gaRni",
"garnies" => "gaRni",
"garnir" => "gaRniR",
"garnirent" => "gaRniR",
"garniront" => "gaRniR§",
"garnis" => "gaRni",
"garnison" => "gaRniz§",
"garnisons" => "gaRniz§",
"garnissage" => "gaRnisaZ",
"garnissaient" => "gaRnisE",
"garnissais" => "gaRnisE",
"garnissait" => "gaRnisE",
"garnissant" => "gaRnis@",
"garnissent" => "gaRnis",
"garnissez" => "gaRnise",
"garnit" => "gaRni",
"garniture" => "gaRnityR",
"garnitures" => "gaRnityR",
"garno" => "gaRno",
"garons" => "gaR§",
"garou" => "gaRu",
"garrick" => "gaRik",
"garrigue" => "gaRig",
"garrigues" => "gaRig",
"garrot" => "gaRo",
"garrots" => "gaRo",
"garrottaient" => "gaRotE",
"garrotte" => "gaROt",
"garrotté" => "gaRote",
"garrottée" => "gaRote",
"garrottent" => "gaROt",
"garrotter" => "gaRote",
"garrottés" => "gaRote",
"gars" => "ga",
"gas-oil" => "gazOjl",
"gascon" => "gask§",
"gasconne" => "gaskOn",
"gascons" => "gask§",
"gasoil" => "gazwal",
"gaspacho" => "gaspatSo",
"gaspard" => "gaspaR",
"gaspards" => "gaspaR",
"gaspilla" => "gaspija",
"gaspillage" => "gaspijaZ",
"gaspillages" => "gaspijaZ",
"gaspillaient" => "gaspijE",
"gaspillait" => "gaspijE",
"gaspillant" => "gaspij@",
"gaspillasse" => "gaspijas",
"gaspillât" => "gaspija",
"gaspille" => "gaspij",
"gaspillé" => "gaspije",
"gaspillée" => "gaspije",
"gaspillées" => "gaspije",
"gaspillent" => "gaspij",
"gaspiller" => "gaspije",
"gaspillerai" => "gaspij°RE",
"gaspilleraient" => "gaspij°RE",
"gaspillerais" => "gaspij°RE",
"gaspillerez" => "gaspij°Re",
"gaspilles" => "gaspij",
"gaspillés" => "gaspije",
"gaspilleur" => "gaspij9R",
"gaspilleurs" => "gaspij9R",
"gaspilleuse" => "gaspij2z",
"gaspilleuses" => "gaspij2z",
"gaspillez" => "gaspije",
"gaspillons" => "gaspij§",
"gaster" => "gastER",
"gastéropode" => "gasteRopOd",
"gastéropodes" => "gasteRopOd",
"gastralgie" => "gastRalZi",
"gastralgies" => "gastRalZi",
"gastrectomie" => "gastREktOmi",
"gastrique" => "gastRik",
"gastriques" => "gastRik",
"gastrite" => "gastRit",
"gastrites" => "gastRit",
"gastro" => "gastRo",
"gastro-entérite" => "gastRo@teRit",
"gastro-entérologue" => "gastRo@teRolOg",
"gastro-entérologues" => "gastRo@teRolOg",
"gastro-intestinal" => "gastRo5tEstinal",
"gastro-intestinale" => "gastRo5tEstinal",
"gastro-intestinaux" => "gastRo5tEstino",
"gastroentérologue" => "gastRo@teRolOg",
"gastrolâtre" => "gastRolatR",
"gastronome" => "gastRonOm",
"gastronomes" => "gastRonOm",
"gastronomie" => "gastRonomi",
"gastronomique" => "gastRonomik",
"gastronomiques" => "gastRonomik",
"gastrula" => "gastRyla",
"gâta" => "gata",
"gâtaient" => "gatE",
"gâtais" => "gatE",
"gâtait" => "gatE",
"gâtant" => "gat@",
"gâtât" => "gata",
"gâte" => "gat",
"gâté" => "gate",
"gâte-bois" => "gatbwa",
"gâte-sauce" => "gatsos",
"gâteau" => "gato",
"gâteaux" => "gato",
"gâtée" => "gate",
"gâtées" => "gate",
"gâtent" => "gat",
"gâter" => "gate",
"gâtera" => "gat°Ra",
"gâterais" => "gat°RE",
"gâterait" => "gat°RE",
"gâtèrent" => "gatER",
"gâterie" => "gat°Ri",
"gâteries" => "gat°Ri",
"gâteront" => "gat°R§",
"gâtes" => "gat",
"gâtés" => "gate",
"gâteuse" => "gat2z",
"gâteuses" => "gat2z",
"gâteux" => "gat2",
"gâtez" => "gate",
"gâtifie" => "gatifi",
"gâtine" => "gatin",
"gâtisme" => "gatizm",
"gatte" => "gEt",
"gauche" => "goS",
"gauchement" => "goS°m@",
"gaucher" => "goSe",
"gauchère" => "goSER",
"gaucherie" => "goS°Ri",
"gaucheries" => "goS°Ri",
"gauchers" => "goSe",
"gauches" => "goS",
"gauchi" => "goSi",
"gauchie" => "goSi",
"gauchir" => "goSiR",
"gauchis" => "goSi",
"gauchisante" => "goSiz@t",
"gauchisantes" => "goSiz@t",
"gauchisme" => "goSizm",
"gauchismes" => "goSizm",
"gauchissaient" => "goSisE",
"gauchissait" => "goSisE",
"gauchissement" => "goSis°m@",
"gauchiste" => "goSist",
"gauchistes" => "goSist",
"gaucho" => "goSo",
"gauchos" => "goSo",
"gaudriole" => "godRijOl",
"gaudrioles" => "godRijOl",
"gaufre" => "gofR",
"gaufré" => "gofRe",
"gaufrée" => "gofRe",
"gaufrées" => "gofRe",
"gaufres" => "gofR",
"gaufrés" => "gofRe",
"gaufrette" => "gofREt",
"gaufrettes" => "gofREt",
"gaufrier" => "gofRije",
"gaulant" => "gol@",
"gauldo" => "goldo",
"gauldos" => "goldo",
"gaule" => "gol",
"gaulé" => "gole",
"gaulée" => "gole",
"gauleiter" => "golajt9R",
"gauler" => "gole",
"gaulerais" => "gol°RE",
"gaulerait" => "gol°RE",
"gaulèrent" => "golER",
"gaules" => "gol",
"gaulis" => "goli",
"gaulle" => "gol",
"gaullisme" => "golizm",
"gaulliste" => "golist",
"gaullistes" => "golist",
"gaulois" => "golwa",
"gauloise" => "golwaz",
"gauloisement" => "golwaz°m@",
"gauloiseries" => "golwaz°Ri",
"gauloises" => "golwaz",
"gaulthérie" => "golteRi",
"gaupe" => "gop",
"gauss" => "gos",
"gaussaient" => "gosE",
"gaussait" => "gosE",
"gaussant" => "gos@",
"gausse" => "gos",
"gaussé" => "gose",
"gaussée" => "gose",
"gaussent" => "gos",
"gausser" => "gose",
"gausserai" => "gos°RE",
"gausserait" => "gos°RE",
"gaussèrent" => "gosER",
"gaussez" => "gose",
"gava" => "gava",
"gavage" => "gavaZ",
"gavai" => "gavE",
"gavaient" => "gavE",
"gavais" => "gavE",
"gavait" => "gavE",
"gavant" => "gav@",
"gave" => "gav",
"gavé" => "gave",
"gavée" => "gave",
"gavées" => "gave",
"gavent" => "gav",
"gaver" => "gave",
"gavera" => "gav°Ra",
"gaveraient" => "gav°RE",
"gaves" => "gav",
"gavés" => "gave",
"gavez" => "gave",
"gavial" => "gavjal",
"gaviot" => "gavjo",
"gavons" => "gav§",
"gavroche" => "gavROS",
"gavroches" => "gavROS",
"gay" => "gE",
"gayac" => "gajak",
"gays" => "gE",
"gaz" => "gaz",
"gazage" => "gazaZ",
"gazait" => "gazE",
"gaze" => "gaz",
"gazé" => "gaze",
"gazée" => "gaze",
"gazées" => "gaze",
"gazéifiée" => "gazeifje",
"gazéifier" => "gazeifje",
"gazelle" => "gazEl",
"gazelles" => "gazEl",
"gazer" => "gaze",
"gazera" => "gaz°Ra",
"gazerait" => "gaz°RE",
"gazes" => "gaz",
"gazés" => "gaze",
"gazette" => "gazEt",
"gazettes" => "gazEt",
"gazeuse" => "gaz2z",
"gazeuses" => "gaz2z",
"gazeux" => "gaz2",
"gazez" => "gaze",
"gazier" => "gazje",
"gaziers" => "gazje",
"gazinière" => "gazinjER",
"gazinières" => "gazinjER",
"gazoduc" => "gazOdyk",
"gazogène" => "gazoZEn",
"gazogènes" => "gazoZEn",
"gazole" => "gazOl",
"gazoline" => "gazolin",
"gazomètre" => "gazomEtR",
"gazométrie" => "gazometRi",
"gazon" => "gaz§",
"gazonné" => "gazone",
"gazonnée" => "gazone",
"gazons" => "gaz§",
"gazouilla" => "gazuja",
"gazouillaient" => "gazujE",
"gazouillait" => "gazujE",
"gazouillant" => "gazuj@",
"gazouillante" => "gazuj@t",
"gazouillants" => "gazuj@",
"gazouille" => "gazuj",
"gazouillement" => "gazuj°m@",
"gazouillements" => "gazuj°m@",
"gazouillent" => "gazuj",
"gazouiller" => "gazuje",
"gazouilles" => "gazuj",
"gazouilleurs" => "gazuj9R",
"gazouillis" => "gazuji",
"gazpacho" => "gaspatSo",
"geai" => "ZE",
"geais" => "ZE",
"géant" => "Ze@",
"géante" => "Ze@t",
"géantes" => "Ze@t",
"géants" => "Ze@",
"gecko" => "ZEko",
"geckos" => "ZEko",
"geez" => "dZiz",
"gégène" => "ZeZEn",
"géhenne" => "ZeEn",
"géhennes" => "ZeEn",
"geignaient" => "ZENE",
"geignais" => "ZENE",
"geignait" => "ZENE",
"geignant" => "ZEN@",
"geignante" => "ZEN@t",
"geignantes" => "ZEN@t",
"geignard" => "ZENaR",
"geignarde" => "ZENaRd",
"geignardes" => "ZENaRd",
"geignardises" => "ZENaRdiz",
"geignards" => "ZENaR",
"geignement" => "ZEN°m@",
"geignements" => "ZEN°m@",
"geignent" => "ZEN",
"geignez" => "ZENe",
"geignit" => "ZENi",
"geindre" => "Z5dR",
"geins" => "Z5",
"geint" => "Z5",
"geisha" => "geSa",
"geishas" => "geSa",
"gel" => "ZEl",
"gela" => "Z°la",
"gelaient" => "Z°lE",
"gelais" => "Z°lE",
"gelait" => "Z°lE",
"gelant" => "Z°l@",
"gelât" => "Z°la",
"gélatine" => "Zelatin",
"gélatines" => "Zelatin",
"gélatineuse" => "Zelatin2z",
"gélatineuses" => "Zelatin2z",
"gélatineux" => "Zelatin2",
"gélatino-bromure" => "ZelatinobRomyR",
"gèle" => "ZEl",
"gelé" => "Z°le",
"gelée" => "Z°le",
"gelées" => "Z°le",
"gèlent" => "ZEl",
"geler" => "Z°le",
"gèlera" => "ZEl°Ra",
"gèlerai" => "ZEl°RE",
"gèlerait" => "ZEl°RE",
"gèles" => "ZEl",
"gelés" => "Z°le",
"gelez" => "Z°le",
"gélifiant" => "Zelifj@",
"gélification" => "Zelifikasj§",
"gélifié" => "Zelifje",
"geline" => "Z°lin",
"géline" => "Zelin",
"gélines" => "Zelin",
"gelinotte" => "ZelinOt",
"gélinotte" => "ZelinOt",
"gélolevure" => "Zelol°vyR",
"gelons" => "Z°l§",
"gélose" => "Zeloz",
"gels" => "ZEl",
"gélule" => "Zelyl",
"gélules" => "Zelyl",
"gelure" => "Z°lyR",
"gelures" => "Z°lyR",
"gémeau" => "Zemo",
"gémeaux" => "Zemo",
"gémellaire" => "ZemelER",
"gémellaires" => "ZemelER",
"gémellité" => "Zemelite",
"gémi" => "Zemi",
"gémie" => "Zemi",
"gémir" => "ZemiR",
"gémira" => "ZemiRa",
"gémirai" => "ZemiRE",
"gémiraient" => "ZemiRE",
"gémirais" => "ZemiRE",
"gémirait" => "ZemiRE",
"gémirent" => "ZemiR",
"gémis" => "Zemi",
"gémissaient" => "ZemisE",
"gémissais" => "ZemisE",
"gémissait" => "ZemisE",
"gémissant" => "Zemis@",
"gémissante" => "Zemis@t",
"gémissantes" => "Zemis@t",
"gémissants" => "Zemis@",
"gémisse" => "Zemis",
"gémissement" => "Zemis°m@",
"gémissements" => "Zemis°m@",
"gémissent" => "Zemis",
"gémisseur" => "Zemis9R",
"gémisseurs" => "Zemis9R",
"gémissez" => "Zemise",
"gémissiez" => "Zemisje",
"gémit" => "Zemi",
"gemme" => "ZEm",
"gemmes" => "ZEm",
"gemmologie" => "ZEmOlOZi",
"gémonies" => "Zemoni",
"gêna" => "ZEna",
"gênaient" => "ZEnE",
"gênais" => "ZEnE",
"gênait" => "ZEnE",
"gênant" => "ZEn@",
"gênante" => "ZEn@t",
"gênantes" => "ZEn@t",
"gênants" => "ZEn@",
"gênât" => "ZEna",
"gencive" => "Z@siv",
"gencives" => "Z@siv",
"gendarme" => "Z@daRm",
"gendarmer" => "Z@daRme",
"gendarmerie" => "Z@daRm°Ri",
"gendarmeries" => "Z@daRm°Ri",
"gendarmes" => "Z@daRm",
"gendelettres" => "Z@d°lEtR",
"gendre" => "Z@dR",
"gendres" => "Z@dR",
"gène" => "ZEn",
"gêne" => "ZEn",
"gêné" => "ZEne",
"généalogie" => "ZenealoZi",
"généalogies" => "ZenealoZi",
"généalogique" => "ZenealoZik",
"généalogiques" => "ZenealoZik",
"généalogiste" => "ZenealoZist",
"généalogistes" => "ZenealoZist",
"gênée" => "ZEne",
"gênées" => "Zene",
"gênent" => "ZEn",
"gêner" => "Zene",
"gênera" => "ZEn°Ra",
"gênerai" => "ZEn°RE",
"gêneraient" => "ZEn°RE",
"gênerais" => "ZEn°RE",
"gênerait" => "ZEn°RE",
"général" => "ZeneRal",
"générale" => "ZeneRal",
"généralement" => "ZeneRal°m@",
"générales" => "ZeneRal",
"généralife" => "ZeneRalif",
"généralisable" => "ZeneRalizabl",
"généralisait" => "ZeneRalizE",
"généralisant" => "ZeneRaliz@",
"généralisation" => "ZeneRalizasj§",
"généralisations" => "ZeneRalizasj§",
"généralise" => "ZeneRaliz",
"généralisé" => "ZeneRalize",
"généralisée" => "ZeneRalize",
"généralisées" => "ZeneRalize",
"généraliser" => "ZeneRalize",
"généralisez" => "ZeneRalize",
"généralisions" => "ZeneRalizj§",
"généralissime" => "ZeneRalisim",
"généraliste" => "ZeneRalist",
"généralistes" => "ZeneRalist",
"généralité" => "ZeneRalite",
"généralités" => "ZeneRalite",
"générant" => "ZeneR@",
"générateur" => "ZeneRat9R",
"générateurs" => "ZeneRat9R",
"génératif" => "ZeneRatif",
"génération" => "ZeneRasj§",
"générationnel" => "ZeneRasjOnEl",
"générations" => "ZeneRasj§",
"générative" => "ZeneRativ",
"génératrice" => "ZeneRatRis",
"génératrices" => "ZeneRatRis",
"généraux" => "ZeneRo",
"génère" => "ZenER",
"généré" => "ZeneRe",
"générée" => "ZeneRe",
"générer" => "ZeneRe",
"génères" => "ZenER",
"générés" => "ZeneRe",
"généreuse" => "ZeneR2z",
"généreusement" => "ZeneR2z°m@",
"généreuses" => "ZeneR2z",
"généreux" => "ZeneR2",
"générez" => "ZeneRe",
"générique" => "ZeneRik",
"génériques" => "ZeneRik",
"gênerons" => "ZEn°R§",
"gêneront" => "ZEn°R§",
"générosité" => "ZeneRozite",
"générosités" => "ZeneRozite",
"gènes" => "ZEn",
"gênes" => "ZEn",
"gênés" => "Zene",
"genèse" => "Z°nEz",
"génésique" => "Zenezik",
"genet" => "Z2nE",
"genêt" => "Z°nE",
"généticien" => "Zenetisj5",
"généticienne" => "ZenetisjEn",
"généticiens" => "Zenetisj5",
"genêtière" => "Z°nEtjER",
"génétique" => "Zenetik",
"génétiquement" => "Zenetik°m@",
"génétiques" => "Zenetik",
"genêts" => "Z°nE",
"gêneur" => "ZEn9R",
"gêneurs" => "ZEn9R",
"gêneuse" => "ZEn2z",
"gêneuses" => "ZEn2z",
"genevois" => "Z°n°vwa",
"genevoises" => "Z°n°vwaz",
"genévrier" => "Z°nevRije",
"genévriers" => "Z°nevRije",
"gênez" => "ZEne",
"gengis khan" => "dZEndZiskan",
"gengiskhanide" => "Z@Ziskanid",
"génial" => "Zenjal",
"géniale" => "Zenjal",
"génialement" => "Zenjal°m@",
"géniales" => "Zenjal",
"génialité" => "Zenjalite",
"géniaux" => "Zenjo",
"génie" => "Zeni",
"génies" => "Zeni",
"genièvre" => "Z°njEvR",
"gêniez" => "ZEnje",
"génique" => "Zenik",
"génisse" => "Zenis",
"génisses" => "Zenis",
"génital" => "Zenital",
"génitale" => "Zenital",
"génitales" => "Zenital",
"génitalité" => "Zenitalite",
"génitaux" => "Zenito",
"géniteur" => "Zenit9R",
"géniteurs" => "Zenit9R",
"génitoires" => "ZenitwaR",
"génitrice" => "ZenitRis",
"génitrices" => "ZenitRis",
"génocidaire" => "ZenOsidER",
"génocide" => "Zenosid",
"génocides" => "Zenosid",
"génois" => "Zenwa",
"génoise" => "Zenwaz",
"génoises" => "Zenwaz",
"génome" => "Zenom",
"génomique" => "Zenomik",
"génomiques" => "Zenomik",
"gênons" => "ZEn§",
"génotype" => "Zenotip",
"génotypes" => "Zenotip",
"genou" => "Z°nu",
"genouillère" => "Z°nujER",
"genouillères" => "Z°nujER",
"genoux" => "Z°nu",
"génovéfains" => "Zenovef5",
"genre" => "Z@R",
"genres" => "Z@R",
"genreux" => "Z@R2",
"gens" => "Z@",
"gent" => "Z@",
"gentamicine" => "Z@tamisin",
"gente" => "Z@t",
"gentes" => "Z@t",
"gentiane" => "Z@sjan",
"gentianes" => "Z@sjan",
"gentil" => "Z@ti",
"gentilhomme" => "Z@tijOm",
"gentilhommière" => "Z@tijOmjER",
"gentilhommières" => "Z@tijOmjER",
"gentilice" => "Z@tilis",
"gentille" => "Z@tij",
"gentilles" => "Z@tij",
"gentillesse" => "Z@tijEs",
"gentillesses" => "Z@tijEs",
"gentillet" => "Z@tijE",
"gentillets" => "Z@tijE",
"gentillette" => "Z@tijEt",
"gentils" => "Z@ti",
"gentilshommes" => "Z@tizOm",
"gentiment" => "Z@tim@",
"gentleman" => "dZEntl°man",
"gentleman-farmer" => "ZEntl°manfaRm9R",
"gentlemen" => "dZEntl°mEn",
"gentlemen-farmers" => "ZEntl°manfaRm9R",
"gentry" => "dZEntRi",
"gents" => "Z@",
"génuflexion" => "ZenyflEksj§",
"génuflexions" => "ZenyflEksj§",
"génuine" => "Zen8in",
"géo" => "Zeo",
"géocorises" => "ZeokoRiz",
"géode" => "ZeOd",
"géodésiens" => "Zeodezj5",
"géodésigraphe" => "ZeodezigRaf",
"géodésique" => "Zeodezik",
"géodésiques" => "Zeodezik",
"géographe" => "ZeogRaf",
"géographes" => "ZeogRaf",
"géographie" => "ZeogRafi",
"géographies" => "ZeogRafi",
"géographique" => "ZeogRafik",
"géographiquement" => "ZeogRafik°m@",
"géographiques" => "ZeogRafik",
"geôle" => "Zol",
"geôles" => "Zol",
"geôlier" => "Zolje",
"geôlière" => "ZoljER",
"geôlières" => "ZoljER",
"geôliers" => "Zolje",
"géologie" => "ZeoloZi",
"géologique" => "ZeoloZik",
"géologiquement" => "ZeoloZik°m@",
"géologiques" => "ZeoloZik",
"géologue" => "ZeolOg",
"géologues" => "ZeolOg",
"géomagnétique" => "ZeomaNetik",
"géomagnétiques" => "ZeomaNetik",
"géomancie" => "Zeom@si",
"géomètre" => "ZeomEtR",
"géomètres" => "ZeomEtR",
"géométrie" => "ZeometRi",
"géométries" => "ZeometRi",
"géométrique" => "ZeometRik",
"géométriquement" => "ZeometRik°m@",
"géométriques" => "ZeometRik",
"géophysiciens" => "Zeofizisj5",
"géophysique" => "Zeofizik",
"géopolitique" => "Zeopolitik",
"géorgien" => "ZeORZj5",
"géorgienne" => "ZeORZjEn",
"géorgiennes" => "ZeORZjEn",
"géorgiens" => "ZeORZj5",
"géosciences" => "Zeosj@s",
"géostationnaire" => "ZeostasjonER",
"géostratégie" => "ZeostRateZi",
"géosynchrone" => "Zeos5kRon",
"géothermale" => "ZeotERmal",
"géothermie" => "ZeotERmi",
"géothermique" => "ZeotERmik",
"géotropique" => "ZeotRopik",
"géotropiques" => "ZeotRopik",
"géra" => "ZeRa",
"gérable" => "ZeRabl",
"gérables" => "ZeRabl",
"gérais" => "ZeRE",
"gérait" => "ZeRE",
"gérance" => "ZeR@s",
"géranium" => "ZeRanjOm",
"géraniums" => "ZeRanjOm",
"gérant" => "ZeR@",
"gérante" => "ZeR@t",
"gérants" => "ZeR@",
"gerba" => "ZERba",
"gerbaient" => "ZERbE",
"gerbais" => "ZERbE",
"gerbait" => "ZERbE",
"gerbant" => "ZERb@",
"gerbe" => "ZERb",
"gerbé" => "ZERbe",
"gerbée" => "ZERbe",
"gerbées" => "ZERbe",
"gerbent" => "ZERb",
"gerber" => "ZERbe",
"gerberais" => "ZERb°RE",
"gerberas" => "ZERb°Ra",
"gerbèrent" => "ZERbER",
"gerbes" => "ZERb",
"gerbés" => "ZERbe",
"gerbeuse" => "ZERb2z",
"gerbeuses" => "ZERb2z",
"gerbier" => "ZERbje",
"gerbière" => "ZERbjER",
"gerbille" => "ZERbij",
"gerboise" => "ZERbwaz",
"gerboises" => "ZERbwaz",
"gerçait" => "ZERsE",
"gerce" => "ZERs",
"gercé" => "ZERse",
"gercée" => "ZERse",
"gercées" => "ZERse",
"gercent" => "ZERs",
"gercer" => "ZERse",
"gercèrent" => "ZERsER",
"gerces" => "ZERs",
"gercés" => "ZERse",
"gerçures" => "ZERsyR",
"gère" => "ZER",
"géré" => "ZeRe",
"gérée" => "ZeRe",
"gérées" => "ZeRe",
"gèrent" => "ZER",
"gérer" => "ZeRe",
"gérera" => "ZeR°Ra",
"gérerai" => "ZeR°RE",
"gérerais" => "ZeR°RE",
"gérerez" => "ZeR°Re",
"géreriez" => "ZeR°Rje",
"gérés" => "ZeRe",
"gérez" => "ZeRe",
"gerfaut" => "ZERfo",
"gerfauts" => "ZERfo",
"gériatrie" => "ZeRjatRi",
"gériatrique" => "ZeRjatRik",
"gériatriques" => "ZeRjatRik",
"germa" => "ZERma",
"germaient" => "ZERmE",
"germain" => "ZERm5",
"germaine" => "ZERmEn",
"germaines" => "ZERmEn",
"germains" => "ZERm5",
"germait" => "ZERmE",
"germanique" => "ZERmanik",
"germaniques" => "ZERmanik",
"germanisation" => "ZERmanizasj§",
"germanisme" => "ZERmanizm",
"germaniste" => "ZERmanist",
"germanité" => "ZERmanite",
"germanium" => "ZERmanjOm",
"germano" => "ZERmano",
"germano-anglaises" => "ZERmano@glEz",
"germano-belge" => "ZERmanobElZ",
"germano-irlandais" => "ZERmanoiRl@dE",
"germano-russe" => "ZERmanoRys",
"germano-soviétique" => "ZERmanosovjetik",
"germanophile" => "ZERmanofil",
"germanophilie" => "ZERmanofili",
"germanophone" => "ZERmanOfOn",
"germant" => "ZERm@",
"germe" => "ZERm",
"germé" => "ZERme",
"germée" => "ZERme",
"germées" => "ZERme",
"germen" => "ZERmEn",
"germent" => "ZERm",
"germer" => "ZERme",
"germera" => "ZERm°Ra",
"germerait" => "ZERm°RE",
"germes" => "ZERm",
"germinal" => "ZERminal",
"germinale" => "ZERminal",
"germination" => "ZERminasj§",
"germinations" => "ZERminasj§",
"gérons" => "ZeR§",
"géronte" => "ZeR§t",
"gérontes" => "ZeR§t",
"gérontisme" => "ZeR§tism",
"gérontologie" => "ZeR§toloZi",
"gérontologue" => "ZeR§tolOg",
"gérontophiles" => "ZeR§tofil",
"gerris" => "ZERi",
"gésier" => "Zezje",
"gésiers" => "Zezje",
"gésine" => "Zezin",
"gésir" => "ZeziR",
"gestapiste" => "gEstapist",
"gestapo" => "gEstapo",
"gestation" => "ZEstasj§",
"gestations" => "ZEstasj§",
"geste" => "ZEst",
"gestes" => "ZEst",
"gesticula" => "ZEstikyla",
"gesticulai" => "ZEstikylE",
"gesticulaient" => "ZEstikylE",
"gesticulais" => "ZEstikylE",
"gesticulait" => "ZEstikylE",
"gesticulant" => "ZEstikyl@",
"gesticulante" => "ZEstikyl@t",
"gesticulantes" => "ZEstikyl@t",
"gesticulants" => "ZEstikyl@",
"gesticulateurs" => "ZEstikylat9R",
"gesticulation" => "ZEstikylasj§",
"gesticulations" => "ZEstikylasj§",
"gesticulatoire" => "ZEstikylatwaR",
"gesticule" => "ZEstikyl",
"gesticulé" => "ZEstikyle",
"gesticulent" => "ZEstikyl",
"gesticuler" => "ZEstikyle",
"gesticules" => "ZEstikyl",
"gestion" => "ZEstj§",
"gestionnaire" => "ZEstjonER",
"gestionnaires" => "ZEstjonER",
"gestuel" => "ZEst8El",
"gestuelle" => "ZEst8El",
"geyser" => "ZEzER",
"geysers" => "ZEzER",
"ghanéens" => "gane5",
"ghât" => "ga",
"ghetto" => "gEto",
"ghettos" => "gEto",
"gi" => "Zi",
"giaour" => "ZjauR",
"giaours" => "ZjauR",
"gibbeuse" => "Zib2z",
"gibbeux" => "Zib2",
"gibbon" => "Zib§",
"gibbons" => "Zib§",
"gibbosité" => "Zibozite",
"gibecière" => "Zib°sjER",
"gibecières" => "Zib°sjER",
"gibelet" => "Zib°lE",
"gibelin" => "Zib°l5",
"gibeline" => "Zib°lin",
"gibelins" => "Zib°l5",
"gibelotte" => "Zib°lOt",
"gibelottes" => "Zib°lOt",
"giberne" => "ZibERn",
"gibernes" => "ZibERn",
"gibet" => "ZibE",
"gibets" => "ZibE",
"gibier" => "Zibje",
"gibiers" => "Zibje",
"giboulée" => "Zibule",
"giboulées" => "Zibule",
"giboyeuse" => "Zibwaj2z",
"giboyeuses" => "Zibwaj2z",
"giboyeux" => "Zibwaj2",
"gibus" => "Zibys",
"gicla" => "Zikla",
"giclaient" => "ZiklE",
"giclais" => "ZiklE",
"giclait" => "ZiklE",
"giclant" => "Zikl@",
"gicle" => "Zikl",
"giclé" => "Zikle",
"giclée" => "Zikle",
"giclées" => "Zikle",
"giclement" => "Zikl°m@",
"giclements" => "Zikl°m@",
"giclent" => "Zikl",
"gicler" => "Zikle",
"giclera" => "Zikl°Ra",
"giclèrent" => "ZiklER",
"gicleront" => "Zikl°R§",
"gicles" => "Zikl",
"gicleur" => "Zikl9R",
"giclez" => "Zikle",
"gidien" => "Zidj5",
"gidienne" => "ZidjEn",
"gidiennes" => "ZidjEn",
"gidouille" => "Ziduj",
"gifla" => "Zifla",
"giflai" => "ZiflE",
"giflaient" => "ZiflE",
"giflais" => "ZiflE",
"giflait" => "ZiflE",
"giflant" => "Zifl@",
"giflât" => "Zifla",
"gifle" => "Zifl",
"giflé" => "Zifle",
"giflée" => "Zifle",
"giflées" => "Zifle",
"giflent" => "Zifl",
"gifler" => "Zifle",
"giflera" => "Zifl°Ra",
"giflerai" => "Zifl°RE",
"giflerais" => "Zifl°RE",
"giflerait" => "Zifl°RE",
"gifles" => "Zifl",
"giflés" => "Zifle",
"gifleuse" => "Zifl2z",
"giflez" => "Zifle",
"gifts" => "Zif",
"gig" => "Zig",
"giga" => "Ziga",
"gigabits" => "Zigabi",
"gigahertz" => "ZigaERts",
"gigantesque" => "Zig@tEsk",
"gigantesques" => "Zig@tEsk",
"gigantisme" => "Zig@tizm",
"gigantismes" => "Zig@tizm",
"gigantomachie" => "Zig@tomaSi",
"gigaoctets" => "ZigaoktE",
"gigas" => "Ziga",
"gigogne" => "ZigON",
"gigognes" => "ZigON",
"gigolette" => "ZigolEt",
"gigolo" => "Zigolo",
"gigolos" => "Zigolo",
"gigolpince" => "ZigOlp5s",
"gigolpinces" => "ZigOlp5s",
"gigot" => "Zigo",
"gigota" => "Zigota",
"gigotaient" => "ZigotE",
"gigotait" => "ZigotE",
"gigotant" => "Zigot@",
"gigote" => "ZigOt",
"gigoté" => "ZigOte",
"gigotements" => "ZigOt°m@",
"gigotent" => "ZigOt",
"gigoter" => "Zigote",
"gigotes" => "ZigOt",
"gigotez" => "Zigote",
"gigots" => "Zigo",
"gigue" => "Zig",
"gilbert" => "ZilbER",
"gilet" => "ZilE",
"giletières" => "Zil°tjER",
"gilets" => "ZilE",
"gilles" => "Zil",
"gimmick" => "Z5mik",
"gimmicks" => "Z5mik",
"gin" => "dZin",
"gin-fizz" => "dZinfidz",
"gin-rami" => "dZinRami",
"gin-rummy" => "dZinRymi",
"gineste" => "ZinEst",
"gingembre" => "Z5Z@bR",
"gingin" => "Z5Z5",
"gingivite" => "Z5Zivit",
"ginkgo" => "Z5ko",
"gins" => "dZin",
"ginseng" => "Zins@G",
"giocoso" => "dZjokozo",
"gipsy" => "Zipsi",
"girafe" => "ZiRaf",
"girafeau" => "ZiRafo",
"girafes" => "ZiRaf",
"girafon" => "ZiRaf§",
"girandes" => "ZiR@d",
"girandole" => "ZiR@dOl",
"girandoles" => "ZiR@dOl",
"giration" => "ZiRasj§",
"girations" => "ZiRasj§",
"giratoire" => "ZiRatwaR",
"giraudistes" => "ZiRodist",
"gire" => "ZiR",
"girelles" => "ZiREl",
"girer" => "ZiRe",
"gires" => "ZiR",
"girie" => "ZiRi",
"giries" => "ZiRi",
"girl" => "g9Rl",
"girl friend" => "g9RlfR5d",
"girl-scout" => "g9Rlskut",
"girls" => "g9Rl",
"girofle" => "ZiROfl",
"giroflée" => "ZiRofle",
"giroflées" => "ZiRofle",
"girofles" => "ZiROfl",
"giroflier" => "ZiROflije",
"girolle" => "ZiROl",
"girolles" => "ZiROl",
"giron" => "ZiR§",
"girond" => "ZiR§",
"gironde" => "ZiR§d",
"girondes" => "ZiR§d",
"girondin" => "ZiR§d5",
"girondine" => "ZiR§din",
"girondines" => "ZiR§din",
"girondins" => "ZiR§d5",
"gironds" => "ZiR§",
"girouettait" => "ZiRwEtE",
"girouettant" => "ZiRwEt@",
"girouette" => "ZiRwEt",
"girouettes" => "ZiRwEt",
"gis" => "Zi",
"gisaient" => "ZizE",
"gisais" => "ZizE",
"gisait" => "ZizE",
"gisant" => "Ziz@",
"gisante" => "Ziz@t",
"gisantes" => "Ziz@t",
"gisants" => "Ziz@",
"gisement" => "Ziz°m@",
"gisements" => "Ziz°m@",
"gisent" => "Ziz",
"gisions" => "Zizj§",
"gisquette" => "ZiskEt",
"gisquettes" => "ZiskEt",
"gît" => "Zi",
"gîta" => "Zita",
"gîtait" => "ZitE",
"gitan" => "Zit@",
"gitane" => "Zitan",
"gitanes" => "Zitan",
"gitans" => "Zit@",
"gîte" => "Zit",
"gîté" => "Zite",
"gîtent" => "Zit",
"gîter" => "Zite",
"gîtera" => "Zit°Ra",
"gîtes" => "Zit",
"giton" => "Zit§",
"gitons" => "Zit§",
"givrage" => "ZivRaZ",
"givrait" => "ZivRE",
"givrante" => "ZivR@t",
"givre" => "ZivR",
"givré" => "ZivRe",
"givrée" => "ZivRe",
"givrées" => "ZivRe",
"givrer" => "ZivRe",
"givres" => "ZivR",
"givrés" => "ZivRe",
"gla-gla" => "glagla",
"glabelle" => "glabEl",
"glabre" => "glabR",
"glabres" => "glabR",
"glaça" => "glasa",
"glaçage" => "glasaZ",
"glaçages" => "glasaZ",
"glaçaient" => "glasE",
"glaçais" => "glasE",
"glaçait" => "glasE",
"glaçant" => "glas@",
"glaçante" => "glas@t",
"glace" => "glas",
"glacé" => "glase",
"glacée" => "glase",
"glacées" => "glase",
"glacent" => "glas",
"glacer" => "glase",
"glacera" => "glas°Ra",
"glacèrent" => "glasER",
"glaceront" => "glas°R§",
"glaces" => "glas",
"glacés" => "glase",
"glacez" => "glase",
"glaciaire" => "glasjER",
"glaciaires" => "glasjER",
"glacial" => "glasjal",
"glaciale" => "glasjal",
"glacialement" => "glasjal°m@",
"glaciales" => "glasjal",
"glacials" => "glasjal",
"glaciation" => "glasjasj§",
"glaciations" => "glasjasj§",
"glaciaux" => "glasjo",
"glacier" => "glasje",
"glacière" => "glasjER",
"glacières" => "glasjER",
"glaciers" => "glasje",
"glaciologue" => "glasjOlOg",
"glacis" => "glasi",
"glaçon" => "glas§",
"glaçons" => "glas§",
"glaçure" => "glasyR",
"glaçures" => "glasyR",
"gladiateur" => "gladjat9R",
"gladiateurs" => "gladjat9R",
"gladiatrices" => "gladjatRis",
"glaglate" => "glaglat",
"glaglater" => "glaglate",
"glaïeul" => "glaj9l",
"glaïeuls" => "glaj9l",
"glaire" => "glER",
"glaires" => "glER",
"glaireuse" => "glER2z",
"glaireuses" => "glER2z",
"glaireux" => "glER2",
"glaise" => "glEz",
"glaises" => "glEz",
"glaiseuse" => "glEz2z",
"glaiseuses" => "glEz2z",
"glaiseux" => "glEz2",
"glaive" => "glEv",
"glaives" => "glEv",
"glamour" => "glamuR",
"glana" => "glana",
"glanage" => "glanaZ",
"glanaient" => "glanE",
"glanais" => "glanE",
"glanait" => "glanE",
"glanant" => "glan@",
"gland" => "gl@",
"glandage" => "gl@daZ",
"glandais" => "gl@dE",
"glandait" => "gl@dE",
"glande" => "gl@d",
"glandé" => "gl@de",
"glandent" => "gl@d",
"glander" => "gl@de",
"glandes" => "gl@d",
"glandeur" => "gl@d9R",
"glandeurs" => "gl@d9R",
"glandez" => "gl@de",
"glandiez" => "gl@dje",
"glandilleuse" => "gl@dij2z",
"glandilleuses" => "gl@dij2z",
"glandilleux" => "gl@dij2",
"glandons" => "gl@d§",
"glandouillant" => "gl@duj@",
"glandouille" => "gl@duj",
"glandouillé" => "gl@duje",
"glandouiller" => "gl@duje",
"glandouilleur" => "gl@duj9R",
"glandouillez" => "gl@duje",
"glands" => "gl@",
"glandu" => "gl@dy",
"glandulaire" => "gl@dylER",
"glandulaires" => "gl@dylER",
"glanduleuse" => "gl@dyl2z",
"glandus" => "gl@dy",
"glane" => "glan",
"glané" => "glane",
"glanée" => "glane",
"glanées" => "glane",
"glanent" => "glan",
"glaner" => "glane",
"glanes" => "glan",
"glanés" => "glane",
"glaneur" => "glan9R",
"glaneuse" => "glan2z",
"glanez" => "glane",
"glanure" => "glanyR",
"glapi" => "glapi",
"glapie" => "glapi",
"glapir" => "glapiR",
"glapirent" => "glapiR",
"glapissaient" => "glapisE",
"glapissait" => "glapisE",
"glapissant" => "glapis@",
"glapissante" => "glapis@t",
"glapissantes" => "glapis@t",
"glapissants" => "glapis@",
"glapissement" => "glapis°m@",
"glapissements" => "glapis°m@",
"glapissent" => "glapis",
"glapisseurs" => "glapis9R",
"glapissions" => "glapisj§",
"glapit" => "glapi",
"glaréole" => "glaReOl",
"glas" => "gla",
"glasnost" => "glasnOst",
"glass" => "glas",
"glasses" => "glas",
"glaucome" => "glokom",
"glauque" => "glok",
"glauquement" => "glok°m@",
"glauques" => "glok",
"glaviot" => "glavjo",
"glaviotaient" => "glavjotE",
"glaviotait" => "glavjotE",
"glaviotant" => "glavjot@",
"glaviote" => "glavjOt",
"glavioter" => "glavjote",
"glavioteurs" => "glavjot9R",
"glaviots" => "glavjo",
"glaviotte" => "glavjOt",
"glèbe" => "glEb",
"glèbes" => "glEb",
"glène" => "glEn",
"glénoïde" => "glenOid",
"glide" => "glid",
"glioblastome" => "glijOblastom",
"gliome" => "gliom",
"glissa" => "glisa",
"glissade" => "glisad",
"glissades" => "glisad",
"glissai" => "glisE",
"glissaient" => "glisE",
"glissais" => "glisE",
"glissait" => "glisE",
"glissâmes" => "glisam",
"glissandi" => "glis@di",
"glissando" => "glis@do",
"glissandos" => "glis@do",
"glissant" => "glis@",
"glissante" => "glis@t",
"glissantes" => "glis@t",
"glissants" => "glis@",
"glissât" => "glisa",
"glisse" => "glis",
"glissé" => "glise",
"glisse-la-moi" => "glislamwa",
"glissée" => "glise",
"glissées" => "glise",
"glissement" => "glis°m@",
"glissements" => "glis°m@",
"glissent" => "glis",
"glisser" => "glise",
"glissera" => "glis°Ra",
"glisserai" => "glis°RE",
"glisseraient" => "glis°RE",
"glisserais" => "glis°RE",
"glisserait" => "glis°RE",
"glissèrent" => "glisER",
"glisserez" => "glis°Re",
"glisseriez" => "glis°Rje",
"glisserons" => "glis°R§",
"glisseront" => "glis°R§",
"glisses" => "glis",
"glissés" => "glise",
"glissez" => "glise",
"glissière" => "glisjER",
"glissières" => "glisjER",
"glissions" => "glisj§",
"glissoire" => "gliswaR",
"glissons" => "glis§",
"global" => "global",
"globale" => "global",
"globalement" => "global°m@",
"globalisation" => "globalizasj§",
"globalisé" => "glObalize",
"globalité" => "globalite",
"globaux" => "globo",
"globe" => "glOb",
"globe-trotter" => "glObt°ROt9R",
"globe-trotters" => "glObt°ROt9R",
"globes" => "glOb",
"globulaire" => "globylER",
"globulaires" => "globylER",
"globule" => "glObyl",
"globules" => "glObyl",
"globuleuse" => "globyl2z",
"globuleux" => "globyl2",
"globuline" => "globylin",
"glockenspiel" => "glokEnSpil",
"gloire" => "glwaR",
"gloires" => "glwaR",
"glomérule" => "glomeRyl",
"glop" => "glOp",
"gloria" => "gloRja",
"gloriette" => "gloRjEt",
"gloriettes" => "gloRjEt",
"glorieuse" => "gloRj2z",
"glorieusement" => "gloRj2z°m@",
"glorieuses" => "gloRj2z",
"glorieux" => "gloRj2",
"glorifia" => "gloRifja",
"glorifiaient" => "gloRifjE",
"glorifiait" => "gloRifjE",
"glorifiant" => "gloRifj@",
"glorification" => "gloRifikasj§",
"glorifie" => "gloRifi",
"glorifié" => "gloRifje",
"glorifiées" => "gloRifje",
"glorifient" => "gloRifi",
"glorifier" => "gloRifje",
"glorifiés" => "gloRifje",
"glorifiez" => "gloRifje",
"glorifions" => "gloRifj§",
"gloriole" => "gloRjOl",
"glosaient" => "glozE",
"glose" => "gloz",
"glosé" => "gloze",
"glosées" => "gloze",
"gloser" => "gloze",
"gloses" => "gloz",
"glossaire" => "glosER",
"glossateurs" => "glosat9R",
"glossématique" => "glosematik",
"glotte" => "glOt",
"glottique" => "glotik",
"glouglou" => "gluglu",
"glouglous" => "gluglu",
"glougloutait" => "gluglutE",
"glougloutant" => "gluglut@",
"glougloute" => "gluglut",
"glougloutement" => "gluglut°m@",
"glouglouter" => "gluglute",
"gloussa" => "glusa",
"gloussaient" => "glusE",
"gloussait" => "glusE",
"gloussant" => "glus@",
"gloussante" => "glus@t",
"gloussantes" => "glus@t",
"gloussants" => "glus@",
"glousse" => "glus",
"gloussé" => "gluse",
"gloussement" => "glus°m@",
"gloussements" => "glus°m@",
"gloussent" => "glus",
"glousser" => "gluse",
"glousserait" => "glus°RE",
"gloussèrent" => "glusER",
"gloussez" => "gluse",
"glouton" => "glut§",
"gloutonnant" => "gluton@",
"gloutonne" => "glutOn",
"gloutonnement" => "glutOn°m@",
"gloutonnerie" => "glutOn°Ri",
"gloutons" => "glut§",
"gloxinias" => "glOksinja",
"glu" => "gly",
"gluant" => "gly@",
"gluante" => "gly@t",
"gluantes" => "gly@t",
"gluants" => "gly@",
"glucagon" => "glykag§",
"glucide" => "glysid",
"glucides" => "glysid",
"gluconique" => "glykOnik",
"glucose" => "glykoz",
"glue" => "gly",
"gluent" => "gly",
"gluon" => "gly§",
"glus" => "gly",
"glutamate" => "glytamat",
"gluten" => "glytEn",
"glycémie" => "glisemi",
"glycérine" => "gliseRin",
"glycérol" => "gliseROl",
"glycine" => "glisin",
"glycines" => "glisin",
"glycol" => "glikOl",
"glycoprotéine" => "glikopROtein",
"glyphe" => "glif",
"glyphes" => "glif",
"gna gna" => "NaNa",
"gnafron" => "NafR§",
"gnafrons" => "NafR§",
"gnagnagna" => "NaNaNa",
"gnangnan" => "N@N@",
"gnard" => "NaR",
"gnards" => "NaR",
"gnaule" => "Nol",
"gnian-gnian" => "N@N@",
"gniard" => "NaR",
"gniards" => "NaR",
"gniouf" => "Nuf",
"gnocchi" => "NOki",
"gnocchis" => "NOki",
"gnognote" => "NoNOt",
"gnognotte" => "NoNOt",
"gnole" => "Nol",
"gnôle" => "Nol",
"gnome" => "gnom",
"gnomes" => "gnom",
"gnon" => "N§",
"gnons" => "N§",
"gnose" => "gnoz",
"gnosticisme" => "gnostisizm",
"gnostique" => "gnostik",
"gnostiques" => "gnostik",
"gnou" => "gnu",
"gnouf" => "Nuf",
"gnous" => "gnu",
"go" => "go",
"goal" => "gol",
"goals" => "gol",
"goba" => "goba",
"gobage" => "gobaZ",
"gobages" => "gobaZ",
"gobaient" => "gobE",
"gobais" => "gobE",
"gobait" => "gobE",
"gobant" => "gob@",
"gobe" => "gOb",
"gobé" => "gobe",
"gobe-mouches" => "gObmuS",
"gobée" => "gobe",
"gobées" => "gobe",
"gobelet" => "gOb°lE",
"gobelets" => "gOb°lE",
"gobelin" => "gOb°l5",
"gobelins" => "gOb°l5",
"gobelottes" => "gOb°lOt",
"gobent" => "gOb",
"gober" => "gobe",
"gobera" => "gOb°Ra",
"goberaient" => "gOb°RE",
"goberait" => "gOb°RE",
"gobèrent" => "gobER",
"goberge" => "gobERZ",
"gobergé" => "gobERZe",
"gobergeait" => "gobERZE",
"gobergent" => "gobERZ",
"goberger" => "gobERZe",
"gobergez" => "gobERZe",
"goberont" => "gOb°R§",
"gobes" => "gOb",
"gobés" => "gobe",
"gobet" => "gobE",
"gobets" => "gobE",
"gobette" => "gobEt",
"gobeur" => "gOb9R",
"gobeurs" => "gob9R",
"gobeuse" => "gOb2z",
"gobez" => "gobe",
"gobions" => "gobj§",
"goda" => "goda",
"godaille" => "godaj",
"godaillera" => "godaj°Ra",
"godailles" => "godaj",
"godait" => "godE",
"godant" => "god@",
"godasse" => "godas",
"godasses" => "godas",
"goddam" => "gOdam",
"gode" => "gOd",
"godelureau" => "god°lyRo",
"godelureaux" => "god°lyRo",
"godemiché" => "god°miSe",
"godemichés" => "god°miSe",
"godent" => "gOd",
"goder" => "gode",
"goderas" => "god°Ra",
"godes" => "gOd",
"godet" => "godE",
"godets" => "godE",
"godiche" => "godiS",
"godiches" => "godiS",
"godillais" => "godijE",
"godillait" => "godijE",
"godillant" => "godij@",
"godille" => "godij",
"godillé" => "godije",
"godiller" => "godije",
"godilles" => "godij",
"godilleur" => "godij9R",
"godillot" => "godijo",
"godillots" => "godijo",
"godronnés" => "godRone",
"godrons" => "godR§",
"goéland" => "goel@",
"goélands" => "goel@",
"goélette" => "goelEt",
"goélettes" => "goelEt",
"goémon" => "goem§",
"goémons" => "goem§",
"goétie" => "gOesi",
"goglu" => "gOgly",
"gogo" => "gogo",
"gogol" => "gogOl",
"gogols" => "gogOl",
"gogos" => "gogo",
"gogs" => "gOg",
"goguenard" => "gOg°naR",
"goguenarda" => "gOg°naRda",
"goguenarde" => "gOg°naRd",
"goguenardes" => "gOg°naRd",
"goguenards" => "gOg°naR",
"goguenots" => "gOg°no",
"gogues" => "gOg",
"goguette" => "gogEt",
"goguettes" => "gogEt",
"goinfraient" => "gw5fRE",
"goinfrait" => "gw5fRE",
"goinfre" => "gw5fR",
"goinfré" => "gw5fRe",
"goinfrée" => "gw5fRe",
"goinfrent" => "gw5fR",
"goinfrer" => "gw5fRe",
"goinfreras" => "gw5fR°Ra",
"goinfrerie" => "gw5fR°Ri",
"goinfres" => "gw5fR",
"goinfrés" => "gw5fRe",
"goinfrez" => "gw5fRe",
"goitre" => "gwatR",
"goitres" => "gwatR",
"goitreux" => "gwatR2",
"gold" => "gOld",
"golden" => "gOldEn",
"goldens" => "gOldEn",
"goldo" => "gOldo",
"goldos" => "gOldo",
"golem" => "golEm",
"golf" => "gOlf",
"golf-club" => "gOlfkl9b",
"golfe" => "gOlf",
"golfes" => "gOlf",
"golfeur" => "gOlf9R",
"golfeurs" => "gOlf9R",
"golfeuse" => "gOlf2z",
"golfeuses" => "gOlf2z",
"golfs" => "gOlf",
"golgotha" => "gOlgOta",
"goliath" => "gOliat",
"gombo" => "g§bo",
"gombos" => "g§bo",
"goménol" => "gomenOl",
"goménolée" => "gomenole",
"gomina" => "gomina",
"gominé" => "gomine",
"gominée" => "gomine",
"gominées" => "gomine",
"gominer" => "gomine",
"gominés" => "gomine",
"gomma" => "goma",
"gommage" => "gomaZ",
"gommait" => "gomE",
"gommant" => "gom@",
"gomme" => "gOm",
"gommé" => "gome",
"gommée" => "gome",
"gommées" => "gome",
"gomment" => "gOm",
"gommer" => "gome",
"gommerait" => "gOm°RE",
"gommes" => "gOm",
"gommés" => "gome",
"gommette" => "gOmEt",
"gommeuse" => "gom2z",
"gommeux" => "gom2",
"gommier" => "gomje",
"gommiers" => "gomje",
"gon" => "gon",
"gonade" => "gonad",
"gonades" => "gonad",
"gonadotropes" => "gonadotROp",
"gonadotrophine" => "gOnadOtROfin",
"goncier" => "g§sje",
"gond" => "g§",
"gonde" => "g§d",
"gonder" => "g§de",
"gondolaient" => "g§dolE",
"gondolais" => "g§dolE",
"gondolait" => "g§dolE",
"gondolant" => "g§dol@",
"gondole" => "g§dOl",
"gondolé" => "g§dole",
"gondolée" => "g§dole",
"gondolées" => "g§dole",
"gondolement" => "g§dOl°m@",
"gondolent" => "g§dOl",
"gondoler" => "g§dole",
"gondolera" => "g§dOl°Ra",
"gondolèrent" => "g§dolER",
"gondoles" => "g§dOl",
"gondolés" => "g§dole",
"gondolier" => "g§dolje",
"gondolière" => "g§dOljER",
"gondoliers" => "g§dolje",
"gonds" => "g§",
"gone" => "gon",
"gonelle" => "gonEl",
"gonfalon" => "g§fal§",
"gonfaloniers" => "g§falonje",
"gonfalons" => "g§fal§",
"gonfanon" => "g§fan§",
"gonfanons" => "g§fan§",
"gonfla" => "g§fla",
"gonflable" => "g§flabl",
"gonflables" => "g§flabl",
"gonflage" => "g§flaZ",
"gonflaient" => "g§flE",
"gonflais" => "g§flE",
"gonflait" => "g§flE",
"gonflant" => "g§fl@",
"gonflante" => "g§fl@t",
"gonflantes" => "g§fl@t",
"gonflants" => "g§fl@",
"gonfle" => "g§fl",
"gonflé" => "g§fle",
"gonflée" => "g§fle",
"gonflées" => "g§fle",
"gonflement" => "g§fl°m@",
"gonflements" => "g§fl°m@",
"gonflent" => "g§fl",
"gonfler" => "g§fle",
"gonflera" => "g§fl°Ra",
"gonflerait" => "g§fl°RE",
"gonflèrent" => "g§flER",
"gonfles" => "g§fl",
"gonflés" => "g§fle",
"gonflette" => "g§flEt",
"gonfleur" => "g§fl9R",
"gonflez" => "g§fle",
"gong" => "g§g",
"gongoriste" => "g§goRist",
"gongs" => "g§g",
"goniomètre" => "gonjomEtR",
"gonococcie" => "gOnOkOksi",
"gonococcique" => "gOnOkOksik",
"gonocoque" => "gonokOk",
"gonocoques" => "gonokOk",
"gonorrhée" => "gonoRe",
"gonze" => "g§z",
"gonzes" => "g§z",
"gonzesse" => "g§zEs",
"gonzesses" => "g§zEs",
"gopak" => "gopak",
"gopher" => "gOf9R",
"gord" => "gOR",
"gordien" => "gORdj5",
"gordiens" => "gORdj5",
"gore" => "gOR",
"goret" => "goRE",
"gorets" => "goRE",
"gorge" => "gORZ",
"gorgé" => "gORZe",
"gorge-de-pigeon" => "gORZd2piZ§",
"gorgea" => "gORZa",
"gorgeai" => "gORZE",
"gorgeaient" => "gORZE",
"gorgeais" => "gORZE",
"gorgeait" => "gORZE",
"gorgeant" => "gORZ@",
"gorgée" => "gORZe",
"gorgées" => "gORZe",
"gorgent" => "gORZ",
"gorgeon" => "gORZ§",
"gorgeons" => "gORZ§",
"gorger" => "gORZe",
"gorgèrent" => "gORZER",
"gorgerette" => "gORZ°REt",
"gorgerin" => "gORZ°R5",
"gorges" => "gORZ",
"gorgés" => "gORZe",
"gorget" => "gORZE",
"gorgez" => "gORZe",
"gorgone" => "gORgOn",
"gorgonzola" => "gORg§zola",
"gorille" => "goRij",
"gorilles" => "goRij",
"gosier" => "gozje",
"gosiers" => "gozje",
"gospel" => "gospEl",
"gosplan" => "gospl@",
"gosse" => "gOs",
"gosseline" => "gOs°lin",
"gosselines" => "gOs°lin",
"gosses" => "gOs",
"goth" => "go",
"gotha" => "gota",
"gothas" => "gota",
"gothique" => "gotik",
"gothiques" => "gotik",
"goths" => "go",
"goton" => "got§",
"gouache" => "gwaS",
"gouaches" => "gwaS",
"gouachez" => "gwaSe",
"gouailla" => "gwaja",
"gouaille" => "gwaj",
"gouaillé" => "gwaje",
"gouailleur" => "gwaj9R",
"gouailleurs" => "gwaj9R",
"gouailleuse" => "gwaj2z",
"gouailleuses" => "gwaj2z",
"goualante" => "gwal@t",
"goualantes" => "gwal@t",
"goualer" => "gwale",
"gouape" => "gwap",
"gouapes" => "gwap",
"gouda" => "guda",
"goudou" => "gudu",
"goudous" => "gudu",
"goudron" => "gudR§",
"goudronnage" => "gudRonaZ",
"goudronne" => "gudROn",
"goudronné" => "gudRone",
"goudronnée" => "gudRone",
"goudronnées" => "gudRone",
"goudronner" => "gudRone",
"goudronnés" => "gudRone",
"goudronneux" => "gudRon2",
"goudronnez" => "gudRone",
"goudrons" => "gudR§",
"gouet" => "gwE",
"gouffre" => "gufR",
"gouffres" => "gufR",
"gouge" => "guZ",
"gougère" => "guZER",
"gougères" => "guZER",
"gouges" => "guZ",
"gougnafier" => "guNafje",
"gougnafiers" => "guNafje",
"gougnottes" => "guNOt",
"gougoutte" => "gugut",
"gougouttes" => "gugut",
"gouine" => "gwin",
"gouines" => "gwin",
"goujat" => "guZa",
"goujaterie" => "guZat°Ri",
"goujats" => "guZa",
"goujon" => "guZ§",
"goujons" => "guZ§",
"goulache" => "gulaS",
"goulafre" => "gulafR",
"goulafres" => "gulafR",
"goulag" => "gulag",
"goulags" => "gulag",
"goulasch" => "gulaS",
"goule" => "gul",
"goulée" => "gule",
"goulées" => "gule",
"goules" => "gul",
"goulet" => "gulE",
"goulette" => "gulEt",
"gouleyant" => "gulEj@",
"goulot" => "gulo",
"goulots" => "gulo",
"goulotte" => "gulOt",
"goulu" => "guly",
"goulue" => "guly",
"goulues" => "guly",
"goulûment" => "gulym@",
"goulus" => "guly",
"goum" => "gum",
"goumi" => "gumi",
"goumier" => "gumje",
"goumiers" => "gumje",
"goums" => "gum",
"goupil" => "gupil",
"goupillait" => "gupijE",
"goupille" => "gupij",
"goupillé" => "gupije",
"goupillée" => "gupije",
"goupiller" => "gupije",
"goupilles" => "gupij",
"goupillon" => "gupij§",
"goupillons" => "gupij§",
"gour" => "guR",
"goura" => "guRa",
"gouraient" => "guRE",
"gourais" => "guRE",
"gourait" => "guRE",
"gourance" => "guR@s",
"gourances" => "guR@s",
"gourbi" => "guRbi",
"gourbis" => "guRbi",
"gourd" => "guR",
"gourde" => "guRd",
"gourdes" => "guRd",
"gourdin" => "guRd5",
"gourdins" => "guRd5",
"gourds" => "guR",
"goure" => "guR",
"gouré" => "guRe",
"gourée" => "guRe",
"gourées" => "guRe",
"gourent" => "guR",
"gourer" => "guRe",
"gourerait" => "guR°RE",
"goures" => "guR",
"gourés" => "guRe",
"gourez" => "guRe",
"gourgandine" => "guRg@din",
"gourgandines" => "guRg@din",
"gourmand" => "guRm@",
"gourmandai" => "guRm@dE",
"gourmandais" => "guRm@dE",
"gourmandait" => "guRm@dE",
"gourmandant" => "guRm@d@",
"gourmande" => "guRm@d",
"gourmandé" => "guRm@de",
"gourmandement" => "guRm@d°m@",
"gourmandent" => "guRm@d",
"gourmander" => "guRm@de",
"gourmandes" => "guRm@d",
"gourmandise" => "guRm@diz",
"gourmandises" => "guRm@diz",
"gourmands" => "guRm@",
"gourme" => "guRm",
"gourmé" => "guRme",
"gourmée" => "guRme",
"gourmés" => "guRme",
"gourmet" => "guRmE",
"gourmets" => "guRmE",
"gourmette" => "guRmEt",
"gourmettes" => "guRmEt",
"gourou" => "guRu",
"gourous" => "guRu",
"gours" => "guR",
"gousse" => "gus",
"gousses" => "gus",
"gousset" => "gusE",
"goussets" => "gusE",
"goût" => "gu",
"goûta" => "guta",
"goûtables" => "gutabl",
"goûtai" => "gutE",
"goûtaient" => "gutE",
"goûtais" => "gutE",
"goûtait" => "gutE",
"goûtâmes" => "gutam",
"goûtant" => "gut@",
"goûte" => "gut",
"goûté" => "gute",
"goûtée" => "gute",
"goûtées" => "gute",
"goûtent" => "gut",
"goûter" => "gute",
"goûtera" => "gut°Ra",
"goûterai" => "gut°RE",
"goûterais" => "gut°RE",
"goûterait" => "gut°RE",
"goûteras" => "gut°Ra",
"goûtèrent" => "gutER",
"goûterez" => "gut°Re",
"goûterons" => "gut°R§",
"goûteront" => "gut°R§",
"goûters" => "gute",
"goûtes" => "gut",
"goûtés" => "gute",
"goûteur" => "gut9R",
"goûteuse" => "gut2z",
"goûteuses" => "gut2z",
"goûteux" => "gut2",
"goûtez" => "gute",
"goûtiez" => "gutje",
"goûtions" => "gutj§",
"goûtons" => "gut§",
"goûts" => "gu",
"gouttait" => "gutE",
"gouttant" => "gut@",
"goutte" => "gut",
"gouttelaient" => "gut°lE",
"gouttelait" => "gut°lE",
"gouttelette" => "gut°lEt",
"gouttelettes" => "gut°lEt",
"goutter" => "gute",
"gouttera" => "gut°Ra",
"goutterais" => "gut°RE",
"gouttereau" => "gut°Ro",
"gouttereaux" => "gut°Ro",
"gouttes" => "gut",
"goutteuse" => "gut2z",
"goutteuses" => "gut2z",
"goutteux" => "gut2",
"gouttière" => "gutjER",
"gouttières" => "gutjER",
"gouvernable" => "guvERnabl",
"gouvernaient" => "guvERnE",
"gouvernail" => "guvERnaj",
"gouvernails" => "guvERnaj",
"gouvernait" => "guvERnE",
"gouvernance" => "guvERn@s",
"gouvernant" => "guvERn@",
"gouvernante" => "guvERn@t",
"gouvernantes" => "guvERn@t",
"gouvernants" => "guvERn@",
"gouvernât" => "guvERna",
"gouverne" => "guvERn",
"gouverné" => "guvERne",
"gouvernée" => "guvERne",
"gouvernement" => "guvERn°m@",
"gouvernemental" => "guvERn°m@tal",
"gouvernementale" => "guvERn°m@tal",
"gouvernementales" => "guvERn°m@tal",
"gouvernementaux" => "guvERn°m@to",
"gouvernements" => "guvERn°m@",
"gouvernent" => "guvERn",
"gouverner" => "guvERne",
"gouvernera" => "guvERn°Ra",
"gouvernerai" => "guvERn°RE",
"gouvernerait" => "guvERn°RE",
"gouverneras" => "guvERn°Ra",
"gouvernerez" => "guvERn°Re",
"gouvernerons" => "guvERn°R§",
"gouverneront" => "guvERn°R§",
"gouvernes" => "guvERn",
"gouvernés" => "guvERne",
"gouverneur" => "guvERn9R",
"gouverneurs" => "guvERn9R",
"gouvernez" => "guvERne",
"gouverniez" => "guvERnje",
"gouvernorat" => "guvERnORa",
"gouvernorats" => "guvERnoRa",
"gouzi-gouzi" => "guziguzi",
"goy" => "gOj",
"goyave" => "gojav",
"goyesque" => "gojEsk",
"goyesques" => "gojEsk",
"graal" => "gRal",
"grabat" => "gRaba",
"grabataire" => "gRabatER",
"grabataires" => "gRabatER",
"grabats" => "gRaba",
"graben" => "gRab9n",
"grabuge" => "gRabyZ",
"grâce" => "gRas",
"grâces" => "gRas",
"gracia" => "gRasja",
"graciai" => "gRasjE",
"gracias" => "gRasja",
"graciât" => "gRasja",
"gracie" => "gRasi",
"gracié" => "gRasje",
"graciée" => "gRasje",
"gracier" => "gRasje",
"graciera" => "gRasjERa",
"gracierai" => "gRasiRE",
"gracieras" => "gRasiRa",
"graciés" => "gRasje",
"gracieuse" => "gRasj2z",
"gracieusé" => "gRasj2ze",
"gracieusement" => "gRasj2z°m@",
"gracieuses" => "gRasj2z",
"gracieuseté" => "gRasj2z°te",
"gracieusetés" => "gRasj2z°te",
"gracieux" => "gRasj2",
"graciez" => "gRasje",
"gracile" => "gRasil",
"graciles" => "gRasil",
"gracilité" => "gRasilite",
"gradaille" => "gRadaj",
"gradation" => "gRadasj§",
"gradations" => "gRadasj§",
"grade" => "gRad",
"gradé" => "gRade",
"gradée" => "gRade",
"grader" => "gRade",
"grades" => "gRad",
"gradés" => "gRade",
"gradient" => "gRadj@",
"gradients" => "gRadj@",
"gradin" => "gRad5",
"gradins" => "gRad5",
"graduation" => "gRad8asj§",
"graduations" => "gRad8asj§",
"gradué" => "gRad8e",
"graduée" => "gRad8e",
"graduées" => "gRad8e",
"graduel" => "gRad8El",
"graduelle" => "gRad8El",
"graduellement" => "gRad8El°m@",
"graduer" => "gRad8e",
"gradués" => "gRad8e",
"gradus" => "gRadys",
"graff" => "gRaf",
"graffeur" => "gRaf9R",
"graffita" => "gRafita",
"graffité" => "gRafite",
"graffiter" => "gRafite",
"graffiteur" => "gRafit9R",
"graffiteurs" => "gRafit9R",
"graffiti" => "gRafiti",
"graffitis" => "gRafiti",
"graffito" => "gRafito",
"grafigner" => "gRafiNe",
"graillant" => "gRaj@",
"graille" => "gRaj",
"graillé" => "gRaje",
"graillée" => "gRaje",
"grailler" => "gRaje",
"graillon" => "gRaj§",
"graillonna" => "gRajona",
"graillonnait" => "gRajonE",
"graillonnant" => "gRajon@",
"graillonne" => "gRajOn",
"graillonnements" => "gRajOn°m@",
"graillonneuse" => "gRajon2z",
"graillonneuses" => "gRajon2z",
"graillonneux" => "gRajon2",
"graillons" => "gRaj§",
"grain" => "gR5",
"graine" => "gREn",
"grainé" => "gREne",
"grainer" => "gREne",
"graines" => "gREn",
"graineterie" => "gREn°t°Ri",
"grainetier" => "gREn°tje",
"grainetiers" => "gREn°tje",
"grains" => "gR5",
"graissa" => "gREsa",
"graissage" => "gREsaZ",
"graissages" => "gREsaZ",
"graissait" => "gREsE",
"graissant" => "gREs@",
"graissât" => "gREsa",
"graisse" => "gREs",
"graissé" => "gREse",
"graissée" => "gREse",
"graissées" => "gREse",
"graissent" => "gREs",
"graisser" => "gRese",
"graissera" => "gREs°Ra",
"graisserai" => "gREs°RE",
"graisses" => "gREs",
"graissés" => "gREse",
"graisseur" => "gREs9R",
"graisseuse" => "gREs2z",
"graisseuses" => "gREs2z",
"graisseux" => "gREs2",
"graissez" => "gREse",
"gram" => "gRam",
"gramen" => "gRamEn",
"gramens" => "gRamEn",
"graminée" => "gRamine",
"graminées" => "gRamine",
"grammage" => "gRamaZ",
"grammages" => "gRamaZ",
"grammaire" => "gRamER",
"grammaires" => "gRamER",
"grammairien" => "gRamERj5",
"grammairienne" => "gRamERjEn",
"grammairiennes" => "gRamERjEn",
"grammairiens" => "gRamERj5",
"grammatical" => "gRamatikal",
"grammaticale" => "gRamatikal",
"grammaticalement" => "gRamatikal°m@",
"grammaticales" => "gRamatikal",
"grammaticaux" => "gRamatiko",
"gramme" => "gRam",
"grammer" => "gRame",
"grammes" => "gRam",
"gramophone" => "gRamofOn",
"gramophones" => "gRamofOn",
"grana" => "gRana",
"granas" => "gRana",
"grand" => "gR@",
"grand-angle" => "gR@t@gl",
"grand-chose" => "gR@Soz",
"grand-duc" => "gR@dyk",
"grand-ducale" => "gR@dykal",
"grand-duché" => "gR@dySe",
"grand-faim" => "gR@f5",
"grand-guignol" => "gR@giNOl",
"grand-guignolesque" => "gR@giNOlEsk",
"grand-hâte" => "gR@at",
"grand-hôtel" => "gR@totEl",
"grand-maître" => "gR@mEtR",
"grand-maman" => "gR@mam@",
"grand-mère" => "gR@mER",
"grand-mères" => "gR@mER",
"grand-messe" => "gR@mEs",
"grand-neige" => "gR@nEZ",
"grand-officier" => "gR@tofisje",
"grand-oncle" => "gR@t§kl",
"grand-papa" => "gR@papa",
"grand-peine" => "gR@pEn",
"grand-père" => "gR@pER",
"grand-peur" => "gR@p9R",
"grand-place" => "gR@plas",
"grand-prêtre" => "gR@pREtR",
"grand-quartier" => "gR@kaRtje",
"grand-route" => "gR@Rut",
"grand-routes" => "gR@Rut",
"grand-rue" => "gR@Ry",
"grand-salle" => "gR@sal",
"grand-tante" => "gR@t@t",
"grand-tantes" => "gR@t@t",
"grand-vergue" => "gR@vERg",
"grand-voile" => "gR@vwal",
"grande" => "gR@d",
"grande-duchesse" => "gR@ddySEs",
"grandement" => "gR@d°m@",
"grandes" => "gR@d",
"grandes-duchesses" => "gR@ddySEs",
"grandesse" => "gR@dEs",
"grandet" => "gR@dE",
"grandeur" => "gR@d9R",
"grandeurs" => "gR@d9R",
"grandi" => "gR@di",
"grandie" => "gR@di",
"grandiloque" => "gR@dilOk",
"grandiloquence" => "gR@dilok@s",
"grandiloquent" => "gR@dilok@",
"grandiloquente" => "gR@dilok@t",
"grandiloquentes" => "gR@dilok@t",
"grandiloquents" => "gR@dilok@",
"grandiose" => "gR@djoz",
"grandiosement" => "gR@djoz°m@",
"grandioses" => "gR@djoz",
"grandir" => "gR@diR",
"grandira" => "gR@diRa",
"grandirai" => "gR@diRE",
"grandiraient" => "gR@diRE",
"grandirais" => "gR@diRE",
"grandirait" => "gR@diRE",
"grandiras" => "gR@diRa",
"grandirent" => "gR@diR",
"grandirez" => "gR@diRe",
"grandiriez" => "gR@diRje",
"grandirons" => "gR@diR§",
"grandiront" => "gR@diR§",
"grandis" => "gR@di",
"grandissaient" => "gR@disE",
"grandissais" => "gR@disE",
"grandissait" => "gR@disE",
"grandissant" => "gR@dis@",
"grandissante" => "gR@dis@t",
"grandissantes" => "gR@dis@t",
"grandissants" => "gR@dis@",
"grandisse" => "gR@dis",
"grandissement" => "gR@dis°m@",
"grandissent" => "gR@dis",
"grandisses" => "gR@dis",
"grandissez" => "gR@dise",
"grandissime" => "gR@disim",
"grandissions" => "gR@disj§",
"grandissons" => "gR@dis§",
"grandit" => "gR@di",
"grandît" => "gR@di",
"grands" => "gR@",
"grands-croix" => "gR@kRwa",
"grands-ducs" => "gR@dyk",
"grands-mères" => "gR@mER",
"grands-oncles" => "gR@t§kl",
"grands-parents" => "gR@paR@",
"grands-pères" => "gR@pER",
"grands-tantes" => "gR@t@t",
"grange" => "gR@Z",
"granges" => "gR@Z",
"grangette" => "gR@ZEt",
"granit" => "gRanit",
"granita" => "gRanita",
"granite" => "gRanit",
"granité" => "gRanite",
"granitée" => "gRanite",
"granités" => "gRanite",
"granitique" => "gRanitik",
"granitiques" => "gRanitik",
"granito" => "gRanito",
"granits" => "gRanit",
"granulaire" => "gRanylER",
"granulait" => "gRanylE",
"granulation" => "gRanylasj§",
"granulations" => "gRanylasj§",
"granule" => "gRanyl",
"granulé" => "gRanyle",
"granulée" => "gRanyle",
"granules" => "gRanyl",
"granulés" => "gRanyle",
"granuleuse" => "gRanyl2z",
"granuleuses" => "gRanyl2z",
"granuleux" => "gRanyl2",
"granulie" => "gRanyli",
"granulome" => "gRanylom",
"grape-fruit" => "gRapfR8i",
"graphe" => "gRaf",
"graphes" => "gRaf",
"graphie" => "gRafi",
"graphies" => "gRafi",
"graphique" => "gRafik",
"graphiques" => "gRafik",
"graphisme" => "gRafizm",
"graphismes" => "gRafizm",
"graphiste" => "gRafist",
"graphite" => "gRafit",
"graphites" => "gRafit",
"graphologie" => "gRafOlOZi",
"graphologique" => "gRafoloZik",
"graphologue" => "gRafolOg",
"graphologues" => "gRafolOg",
"graphomane" => "gRafOman",
"graphomanes" => "gRafoman",
"graphomanie" => "gRafomani",
"graphomètre" => "gRafomEtR",
"graphophone" => "gRafofOn",
"grappa" => "gRapa",
"grappe" => "gRap",
"grappes" => "gRap",
"grappillage" => "gRapijaZ",
"grappillais" => "gRapijE",
"grappillait" => "gRapijE",
"grappillé" => "gRapije",
"grappillées" => "gRapije",
"grappillent" => "gRapij",
"grappiller" => "gRapije",
"grappilleur" => "gRapij9R",
"grappillon" => "gRapij§",
"grappillons" => "gRapij§",
"grappin" => "gRap5",
"grappins" => "gRap5",
"gras" => "gRa",
"gras-double" => "gRadubl",
"gras-doubles" => "gRadubl",
"grasse" => "gRas",
"grassement" => "gRas°m@",
"grasses" => "gRas",
"grasseya" => "gRasEja",
"grasseyait" => "gRasEjE",
"grasseyant" => "gRasEj@",
"grasseyante" => "gRasEj@t",
"grasseyé" => "gRaseje",
"grasseyement" => "gRasEjm@",
"grasseyements" => "gRasEjm@",
"grasseyer" => "gRasEje",
"grassouillet" => "gRasujE",
"grassouillets" => "gRasujE",
"grassouillette" => "gRasujEt",
"grassouillettes" => "gRasujEt",
"gratifia" => "gRatifja",
"gratifiaient" => "gRatifjE",
"gratifiait" => "gRatifjE",
"gratifiant" => "gRatifj@",
"gratifiante" => "gRatifj@t",
"gratification" => "gRatifikasj§",
"gratifications" => "gRatifikasj§",
"gratifie" => "gRatifi",
"gratifié" => "gRatifje",
"gratifiée" => "gRatifje",
"gratifier" => "gRatifje",
"gratifierait" => "gRatifiRE",
"gratifièrent" => "gRatifjER",
"gratifies" => "gRatifi",
"gratifiés" => "gRatifje",
"gratifiez" => "gRatifje",
"gratin" => "gRat5",
"gratiné" => "gRatine",
"gratinée" => "gRatine",
"gratinées" => "gRatine",
"gratiner" => "gRatine",
"gratinés" => "gRatine",
"gratins" => "gRat5",
"gratis" => "gRatis",
"gratis pro deo" => "gRatispRodeo",
"gratitude" => "gRatityd",
"gratitudes" => "gRatityd",
"gratos" => "gRatos",
"gratouillait" => "gRatujE",
"gratouillant" => "gRatuj@",
"gratouille" => "gRatuj",
"gratouillerait" => "gRatuj°RE",
"gratouillis" => "gRatuji",
"gratta" => "gRata",
"grattage" => "gRataZ",
"grattages" => "gRataZ",
"grattai" => "gRatE",
"grattaient" => "gRatE",
"grattais" => "gRatE",
"grattait" => "gRatE",
"grattant" => "gRat@",
"grattât" => "gRata",
"gratte" => "gRat",
"gratté" => "gRate",
"gratte-ciel" => "gRatsjEl",
"gratte-ciels" => "gRatsjEl",
"gratte-cul" => "gRatky",
"gratte-dos" => "gRatdo",
"gratte-papier" => "gRatpapje",
"gratte-papiers" => "gRatpapje",
"gratte-pieds" => "gRatpje",
"grattée" => "gRate",
"grattées" => "gRate",
"grattement" => "gRat°m@",
"grattements" => "gRat°m@",
"grattent" => "gRat",
"gratter" => "gRate",
"grattera" => "gRat°Ra",
"gratterai" => "gRat°RE",
"gratteraient" => "gRat°RE",
"gratterait" => "gRat°RE",
"gratterez" => "gRat°Re",
"gratterons" => "gRat°R§",
"grattes" => "gRat",
"grattés" => "gRate",
"gratteur" => "gRat9R",
"gratteurs" => "gRat9R",
"grattez" => "gRate",
"grattoir" => "gRatwaR",
"grattoirs" => "gRatwaR",
"grattons" => "gRat§",
"grattouillant" => "gRatuj@",
"grattouillé" => "gRatuje",
"grattouillent" => "gRatuj",
"grattouiller" => "gRatuje",
"grattouilles" => "gRatuj",
"grattouillis" => "gRatuji",
"gratture" => "gRatyR",
"gratuit" => "gRat8i",
"gratuite" => "gRat8it",
"gratuité" => "gRat8ite",
"gratuitement" => "gRat8it°m@",
"gratuites" => "gRat8it",
"gratuits" => "gRat8i",
"grau" => "gRo",
"grava" => "gRava",
"gravai" => "gRavE",
"gravaient" => "gRavE",
"gravais" => "gRavE",
"gravait" => "gRavE",
"gravant" => "gRav@",
"gravât" => "gRava",
"gravats" => "gRava",
"grave" => "gRav",
"gravé" => "gRave",
"gravée" => "gRave",
"gravées" => "gRave",
"gravelé" => "gRav°le",
"gravelés" => "gRav°le",
"graveleuse" => "gRav°l2z",
"graveleuses" => "gRav°l2z",
"graveleux" => "gRav°l2",
"gravelle" => "gRavEl",
"gravelles" => "gRavEl",
"gravement" => "gRav°m@",
"gravent" => "gRav",
"graver" => "gRave",
"graveraient" => "gRav°RE",
"graverais" => "gRav°RE",
"graverait" => "gRav°RE",
"gravèrent" => "gRavER",
"graves" => "gRav",
"gravés" => "gRave",
"graveur" => "gRav9R",
"graveurs" => "gRav9R",
"gravez" => "gRave",
"gravi" => "gRavi",
"gravide" => "gRavid",
"gravidité" => "gRavidite",
"gravie" => "gRavi",
"gravier" => "gRavje",
"gravières" => "gRavjER",
"graviers" => "gRavje",
"gravies" => "gRavi",
"gravillon" => "gRavij§",
"gravillonnée" => "gRavijone",
"gravillonnées" => "gRavijone",
"gravillons" => "gRavij§",
"gravir" => "gRaviR",
"gravirai" => "gRaviRE",
"gravirait" => "gRaviRE",
"gravirent" => "gRaviR",
"gravirons" => "gRaviR§",
"gravis" => "gRavi",
"gravissaient" => "gRavisE",
"gravissais" => "gRavisE",
"gravissait" => "gRavisE",
"gravissant" => "gRavis@",
"gravisse" => "gRavis",
"gravissent" => "gRavis",
"gravissime" => "gRavisim",
"gravissimes" => "gRavisim",
"gravissions" => "gRavisj§",
"gravissons" => "gRavis§",
"gravit" => "gRavi",
"gravitaient" => "gRavitE",
"gravitait" => "gRavitE",
"gravitant" => "gRavit@",
"gravitation" => "gRavitasj§",
"gravitationnel" => "gRavitasjonEl",
"gravitationnelle" => "gRavitasjonEl",
"gravitationnelles" => "gRavitasjonEl",
"gravitationnels" => "gRavitasjonEl",
"gravite" => "gRavit",
"gravité" => "gRavite",
"graviter" => "gRavite",
"gravitons" => "gRavit§",
"gravons" => "gRav§",
"gravos" => "gRavos",
"gravosse" => "gRavos",
"gravosses" => "gRavos",
"gravure" => "gRavyR",
"gravures" => "gRavyR",
"gray" => "gRE",
"grays" => "gRE",
"gré" => "gRe",
"gréage" => "gReaZ",
"grèbe" => "gREb",
"grèbes" => "gREb",
"grébiche" => "gRebiS",
"grec" => "gREk",
"gréco" => "gReko",
"gréco-latine" => "gRekolatin",
"gréco-latines" => "gRekolatin",
"gréco-romain" => "gRekoRom5",
"gréco-romaine" => "gRekoRomEn",
"gréco-romaines" => "gRekoRomEn",
"gréco-romains" => "gRekoRom5",
"grecque" => "gREk",
"grecques" => "gREk",
"grecs" => "gREk",
"gredin" => "gR°d5",
"gredine" => "gR°din",
"gredins" => "gR°d5",
"gréé" => "gRee",
"gréée" => "gRee",
"gréées" => "gRee",
"gréement" => "gRem@",
"gréements" => "gRem@",
"green" => "gRin",
"greens" => "gRin",
"gréer" => "gRee",
"gréez" => "gRee",
"greffage" => "gREfaZ",
"greffaient" => "gREfE",
"greffais" => "gREfE",
"greffait" => "gREfE",
"greffant" => "gREf@",
"greffe" => "gREf",
"greffé" => "gRefe",
"greffée" => "gRefe",
"greffées" => "gRefe",
"greffent" => "gREf",
"greffer" => "gRefe",
"greffera" => "gREf°Ra",
"grefferais" => "gREf°RE",
"grefferons" => "gREf°R§",
"grefferont" => "gREf°R§",
"greffes" => "gREf",
"greffés" => "gRefe",
"greffier" => "gRefje",
"greffière" => "gREfjER",
"greffiers" => "gRefje",
"greffon" => "gREf§",
"greffons" => "gREf§",
"grégaire" => "gRegER",
"grège" => "gREZ",
"grégeois" => "gReZwa",
"grèges" => "gREZ",
"grégorien" => "gRegoRj5",
"grégorienne" => "gRegoRjEn",
"grégoriens" => "gRegoRj5",
"grègues" => "gREg",
"grêlaient" => "gRElE",
"grêlait" => "gRElE",
"grêle" => "gREl",
"grêlé" => "gRele",
"grêlée" => "gRele",
"grêlées" => "gRele",
"grêlent" => "gREl",
"grêler" => "gRele",
"grêleraient" => "gREl°RE",
"grêles" => "gREl",
"grêlés" => "gRele",
"grêlon" => "gREl§",
"grêlons" => "gREl§",
"grelot" => "gR°lo",
"grelots" => "gR°lo",
"grelotta" => "gR°lota",
"grelottaient" => "gR°lotE",
"grelottais" => "gR°lotE",
"grelottait" => "gR°lotE",
"grelottant" => "gR°lot@",
"grelottante" => "gR°lot@t",
"grelottantes" => "gR°lot@t",
"grelottants" => "gR°lot@",
"grelotte" => "gR°lOt",
"grelotté" => "gR°lote",
"grelottée" => "gR°lote",
"grelottement" => "gR°lOt°m@",
"grelottements" => "gR°lOt°m@",
"grelottent" => "gR°lOt",
"grelotter" => "gR°lote",
"grelottèrent" => "gR°lotER",
"grelottes" => "gR°lOt",
"grelotteux" => "gR°lot2",
"grelottions" => "gR°lotj§",
"grelottons" => "gR°lot§",
"greluche" => "gR°lyS",
"greluches" => "gR°lyS",
"greluchon" => "gR°lyS§",
"grenache" => "gR°naS",
"grenadage" => "gR°nadaZ",
"grenade" => "gR°nad",
"grenadé" => "gR°nade",
"grenader" => "gR°nade",
"grenades" => "gR°nad",
"grenadeur" => "gR2nad9R",
"grenadier" => "gR°nadje",
"grenadiers" => "gR°nadje",
"grenadine" => "gR°nadin",
"grenadines" => "gR°nadin",
"grenaille" => "gR°naj",
"grenailles" => "gR°naj",
"grenat" => "gR°na",
"grenats" => "gR°na",
"grène" => "gREn",
"grené" => "gR°ne",
"grenée" => "gR°ne",
"grenées" => "gR°ne",
"grenelle" => "gR°nEl",
"grènera" => "gREn°Ra",
"greneta" => "gR°n°ta",
"greneuse" => "gR°n2z",
"grenier" => "gR°nje",
"greniers" => "gR°nje",
"grenoblois" => "gR°noblwa",
"grenouillage" => "gR°nujaZ",
"grenouillait" => "gR°nujE",
"grenouillard" => "gR°nujaR",
"grenouille" => "gR°nuj",
"grenouille-taureau" => "gR°nujtoRo",
"grenouillère" => "gR2nujER",
"grenouillères" => "gR°nujER",
"grenouilles" => "gR°nuj",
"grenouillettes" => "gR°nujEt",
"grenu" => "gR°ny",
"grenue" => "gR°ny",
"grenues" => "gR°ny",
"grenures" => "gR°nyR",
"grenus" => "gR°ny",
"grès" => "gRE",
"grésil" => "gRezil",
"grésilla" => "gRezija",
"grésillaient" => "gRezijE",
"grésillait" => "gRezijE",
"grésillant" => "gRezij@",
"grésillante" => "gRezij@t",
"grésillantes" => "gRezij@t",
"grésille" => "gRezij",
"grésillé" => "gRezije",
"grésillement" => "gRezij°m@",
"grésillements" => "gRezij°m@",
"grésillent" => "gRezij",
"grésiller" => "gRezije",
"grésillerait" => "gRezij°RE",
"gressin" => "gRes5",
"gressins" => "gRes5",
"gretchen" => "gR°tSEn",
"gretchens" => "gR°tSEn",
"grevaient" => "gR°vE",
"grève" => "gREv",
"grevé" => "gR°ve",
"grevée" => "gR°ve",
"grèvent" => "gREv",
"grever" => "gR°ve",
"grèverait" => "gREv°RE",
"grèves" => "gREv",
"grevés" => "gR°ve",
"gréviste" => "gRevist",
"grévistes" => "gRevist",
"gri-gri" => "gRigRi",
"gribiche" => "gRibiS",
"gribouilla" => "gRibuja",
"gribouillage" => "gRibujaZ",
"gribouillages" => "gRibujaZ",
"gribouillais" => "gRibujE",
"gribouillait" => "gRibujE",
"gribouillant" => "gRibuj@",
"gribouille" => "gRibuj",
"gribouillé" => "gRibuje",
"gribouillée" => "gRibuje",
"gribouillées" => "gRibuje",
"gribouillent" => "gRibuj",
"gribouiller" => "gRibuje",
"gribouilles" => "gRibuj",
"gribouillés" => "gRibuje",
"gribouilleur" => "gRibuj9R",
"gribouillez" => "gRibuje",
"gribouillis" => "gRibuji",
"grief" => "gRijEf",
"griefs" => "gRijEf",
"grièvement" => "gRijEv°m@",
"griffa" => "gRifa",
"griffage" => "gRifaZ",
"griffai" => "gRifE",
"griffaient" => "gRifE",
"griffais" => "gRifE",
"griffait" => "gRifE",
"griffant" => "gRif@",
"griffe" => "gRif",
"griffé" => "gRife",
"griffée" => "gRife",
"griffées" => "gRife",
"griffent" => "gRif",
"griffer" => "gRife",
"griffera" => "gRif°Ra",
"grifferait" => "gRif°RE",
"griffes" => "gRif",
"griffés" => "gRife",
"griffeur" => "gRif9R",
"griffon" => "gRif§",
"griffonna" => "gRifona",
"griffonnage" => "gRifonaZ",
"griffonnages" => "gRifonaZ",
"griffonnai" => "gRifonE",
"griffonnaient" => "gRifonE",
"griffonnais" => "gRifonE",
"griffonnait" => "gRifonE",
"griffonnant" => "gRifon@",
"griffonne" => "gRifOn",
"griffonné" => "gRifone",
"griffonnée" => "gRifone",
"griffonnées" => "gRifone",
"griffonnent" => "gRifOn",
"griffonner" => "gRifone",
"griffonnes" => "gRifOn",
"griffonnés" => "gRifone",
"griffonneur" => "gRifOn9R",
"griffonnez" => "gRifone",
"griffons" => "gRif§",
"grifftons" => "gRift§",
"griffu" => "gRify",
"griffue" => "gRify",
"griffues" => "gRify",
"griffure" => "gRifyR",
"griffures" => "gRifyR",
"griffus" => "gRify",
"grifton" => "gRift§",
"grignota" => "gRiNota",
"grignotage" => "gRiNotaZ",
"grignotages" => "gRiNotaZ",
"grignotaient" => "gRiNotE",
"grignotais" => "gRiNotE",
"grignotait" => "gRiNotE",
"grignotant" => "gRiNot@",
"grignote" => "gRiNOt",
"grignoté" => "gRiNote",
"grignotée" => "gRiNote",
"grignotées" => "gRiNote",
"grignotement" => "gRiNOt°m@",
"grignotent" => "gRiNOt",
"grignoter" => "gRiNote",
"grignotera" => "gRiNOt°Ra",
"grignoterai" => "gRiNOt°RE",
"grignoteraient" => "gRiNOt°RE",
"grignotèrent" => "gRiNotER",
"grignoterons" => "gRiNOt°R§",
"grignoteront" => "gRiNOt°R§",
"grignotés" => "gRiNote",
"grignoteurs" => "gRiNot9R",
"grignoteuses" => "gRiNot2z",
"grignotions" => "gRiNotj§",
"grignotis" => "gRiNoti",
"grignotons" => "gRiNot§",
"grigou" => "gRigu",
"grigri" => "gRigRi",
"grigris" => "gRigRi",
"gril" => "gRil",
"grill" => "gRil",
"grill-room" => "gRilRum",
"grilla" => "gRija",
"grillade" => "gRijad",
"grilladerie" => "gRijad°Ri",
"grillades" => "gRijad",
"grillage" => "gRijaZ",
"grillagé" => "gRijaZe",
"grillagée" => "gRijaZe",
"grillagées" => "gRijaZe",
"grillageront" => "gRijaZ°R§",
"grillages" => "gRijaZ",
"grillagés" => "gRijaZe",
"grillagez" => "gRijaZe",
"grillaient" => "gRijE",
"grillais" => "gRijE",
"grillait" => "gRijE",
"grillant" => "gRij@",
"grille" => "gRij",
"grillé" => "gRije",
"grille-pain" => "gRijp5",
"grillée" => "gRije",
"grillées" => "gRije",
"grillent" => "gRij",
"griller" => "gRije",
"grillera" => "gRij°Ra",
"grillerai" => "gRij°RE",
"grilleraient" => "gRij°RE",
"grillerais" => "gRij°RE",
"grillerait" => "gRij°RE",
"grilleras" => "gRij°Ra",
"grillerez" => "gRij°Re",
"grillerions" => "gRij°Rj§",
"grilleront" => "gRij°R§",
"grilles" => "gRij",
"grillés" => "gRije",
"grillez" => "gRije",
"grilliez" => "gRije",
"grilloirs" => "gRijwaR",
"grillon" => "gRij§",
"grillons" => "gRij§",
"grillots" => "gRijo",
"grils" => "gRil",
"grima" => "gRima",
"grimaça" => "gRimasa",
"grimaçai" => "gRimasE",
"grimaçaient" => "gRimasE",
"grimaçais" => "gRimasE",
"grimaçait" => "gRimasE",
"grimaçant" => "gRimas@",
"grimaçante" => "gRimas@t",
"grimaçantes" => "gRimas@t",
"grimaçants" => "gRimas@",
"grimace" => "gRimas",
"grimacé" => "gRimase",
"grimace-éclair" => "gRimaseklER",
"grimacement" => "gRimas°m@",
"grimacent" => "gRimas",
"grimacer" => "gRimase",
"grimacèrent" => "gRimasER",
"grimaceries" => "gRimas°Ri",
"grimaces" => "gRimas",
"grimacez" => "gRimase",
"grimacier" => "gRimasje",
"grimaciers" => "gRimasje",
"grimaciez" => "gRimasje",
"grimacions" => "gRimasj§",
"grimaçons" => "gRimas§",
"grimage" => "gRimaZ",
"grimait" => "gRimE",
"grimant" => "gRim@",
"grimasse" => "gRimas",
"grimauds" => "gRimo",
"grimé" => "gRime",
"grimée" => "gRime",
"grimées" => "gRime",
"griment" => "gRim",
"grimer" => "gRime",
"grimes" => "gRim",
"grimés" => "gRime",
"grimoire" => "gRimwaR",
"grimoires" => "gRimwaR",
"grimpa" => "gR5pa",
"grimpai" => "gR5pE",
"grimpaient" => "gR5pE",
"grimpais" => "gR5pE",
"grimpait" => "gR5pE",
"grimpâmes" => "gR5pam",
"grimpant" => "gR5p@",
"grimpante" => "gR5p@t",
"grimpantes" => "gR5p@t",
"grimpants" => "gR5p@",
"grimpât" => "gR5pa",
"grimpe" => "gR5p",
"grimpé" => "gR5pe",
"grimpée" => "gR5pe",
"grimpées" => "gR5pe",
"grimpent" => "gR5p",
"grimper" => "gR5pe",
"grimpera" => "gR5p°Ra",
"grimperai" => "gR5p°RE",
"grimperaient" => "gR5p°RE",
"grimperais" => "gR5p°RE",
"grimperait" => "gR5p°RE",
"grimpèrent" => "gR5pER",
"grimperez" => "gR5p°Re",
"grimperons" => "gR5p°R§",
"grimperont" => "gR5p°R§",
"grimpés" => "gR5pe",
"grimpette" => "gR5pEt",
"grimpettes" => "gR5pEt",
"grimpeur" => "gR5p9R",
"grimpeurs" => "gR5p9R",
"grimpeuse" => "gR5p2z",
"grimpez" => "gR5pe",
"grimpiez" => "gR5pje",
"grimpions" => "gR5pj§",
"grimpons" => "gR5p§",
"grinça" => "gR5sa",
"grinçaient" => "gR5sE",
"grinçais" => "gR5sE",
"grinçait" => "gR5sE",
"grinçant" => "gR5s@",
"grinçante" => "gR5s@t",
"grinçantes" => "gR5s@t",
"grinçants" => "gR5s@",
"grinçât" => "gR5sa",
"grince" => "gR5s",
"grincé" => "gR5se",
"grincement" => "gR5s°m@",
"grincements" => "gR5s°m@",
"grincent" => "gR5s",
"grincer" => "gR5se",
"grincerait" => "gR5s°RE",
"grincèrent" => "gR5sER",
"grinces" => "gR5s",
"grincez" => "gR5se",
"grinche" => "gR5S",
"grincheuse" => "gR5S2z",
"grincheuses" => "gR5S2z",
"grincheux" => "gR5S2",
"grinchir" => "gR5SiR",
"gringalet" => "gR5galE",
"gringalets" => "gR5galE",
"gringo" => "gRiGo",
"gringos" => "gR5gos",
"gringue" => "gR5g",
"gringuer" => "g°R5ge",
"griot" => "gRijo",
"griots" => "gRijo",
"griotte" => "gRijOt",
"griottes" => "gRijOt",
"grip" => "gRip",
"grippa" => "gRipa",
"grippaient" => "gRipE",
"grippal" => "gRipal",
"grippant" => "gRip@",
"grippaux" => "gRipo",
"grippe" => "gRip",
"grippé" => "gRipe",
"grippe-sou" => "gRipsu",
"grippe-sous" => "gRipsu",
"grippée" => "gRipe",
"grippements" => "gRip°m@",
"gripper" => "gRipe",
"gripperait" => "gRip°RE",
"grippes" => "gRip",
"grippés" => "gRipe",
"gris" => "gRi",
"gris-blanc" => "gRibl@",
"gris-bleu" => "gRibl2",
"gris-gris" => "gRigRi",
"gris-jaune" => "gRiZon",
"gris-perle" => "gRipERl",
"gris-rose" => "gRiRoz",
"gris-vert" => "gRivER",
"grisa" => "gRiza",
"grisai" => "gRizE",
"grisaient" => "gRizE",
"grisaille" => "gRizaj",
"grisaillèrent" => "gRizajER",
"grisailles" => "gRizaj",
"grisais" => "gRizE",
"grisait" => "gRizE",
"grisant" => "gRiz@",
"grisante" => "gRiz@t",
"grisantes" => "gRiz@t",
"grisants" => "gRiz@",
"grisassent" => "gRizas",
"grisâtre" => "gRizatR",
"grisâtres" => "gRizatR",
"grisbi" => "gRisbi",
"grise" => "gRiz",
"grisé" => "gRize",
"grisée" => "gRize",
"grisées" => "gRize",
"grisent" => "gRiz",
"griser" => "gRize",
"grisera" => "gRiz°Ra",
"griserie" => "gRiz°Ri",
"griseries" => "gRiz°Ri",
"grises" => "gRiz",
"grisés" => "gRize",
"grisette" => "gRizEt",
"grisettes" => "gRizEt",
"grison" => "gRiz§",
"grisonnaient" => "gRizonE",
"grisonnait" => "gRizonE",
"grisonnant" => "gRizon@",
"grisonnante" => "gRizon@t",
"grisonnantes" => "gRizon@t",
"grisonnants" => "gRizon@",
"grisonne" => "gRizOn",
"grisonné" => "gRizone",
"grisonnent" => "gRizOn",
"grisonner" => "gRizone",
"grisons" => "gRiz§",
"grisotte" => "gRizOt",
"grisou" => "gRizu",
"grive" => "gRiv",
"grivelée" => "gRiv°le",
"grivèlerie" => "gRivEl°Ri",
"grivelle" => "gRivEl",
"grivelures" => "gRiv°lyR",
"grives" => "gRiv",
"grivet" => "gRivE",
"griveton" => "gRiv°t§",
"grivetons" => "gRiv°t§",
"grivois" => "gRivwa",
"grivoise" => "gRivwaz",
"grivoiserie" => "gRivwaz°Ri",
"grivoiseries" => "gRivwaz°Ri",
"grivoises" => "gRivwaz",
"grizzli" => "gRizli",
"grizzlis" => "gRizli",
"grizzly" => "gRizli",
"grizzlys" => "gRizli",
"groenlandais" => "gRoenl@dE",
"grog" => "gROg",
"groggy" => "gRogi",
"grogna" => "gRoNa",
"grognai" => "gRoNE",
"grognaient" => "gRoNE",
"grognais" => "gRoNE",
"grognait" => "gRoNE",
"grognant" => "gRoN@",
"grognard" => "gRoNaR",
"grognards" => "gRoNaR",
"grognassaient" => "gRoNasE",
"grognasse" => "gRoNas",
"grognasser" => "gRoNase",
"grognasses" => "gRoNas",
"grogne" => "gRON",
"grogné" => "gRoNe",
"grognées" => "gRoNe",
"grognement" => "gRON°m@",
"grognements" => "gRON°m@",
"grognent" => "gRON",
"grogner" => "gRoNe",
"grognera" => "gRON°Ra",
"grognèrent" => "gRoNER",
"grognes" => "gRON",
"grogneurs" => "gRoN9R",
"grogneuse" => "gRoN2z",
"grognions" => "gRoN§",
"grognon" => "gRoN§",
"grognonna" => "gRoNona",
"grognonne" => "gRoNOn",
"grognonner" => "gRoNone",
"grognons" => "gRoN§",
"grogs" => "gROg",
"groin" => "gRw5",
"groins" => "gRw5",
"grole" => "gROl",
"groles" => "gROl",
"grolle" => "gROl",
"grolles" => "gROl",
"grommela" => "gROm°la",
"grommelai" => "gROm°lE",
"grommelaient" => "gROm°lE",
"grommelait" => "gROm°lE",
"grommelant" => "gROm°l@",
"grommelé" => "gROm°le",
"grommelée" => "gROm°le",
"grommeler" => "gROm°le",
"grommelèrent" => "gROm°lER",
"grommelez" => "gROm°le",
"grommelle" => "gRomEl",
"grommellement" => "gRomEl°m@",
"grommellements" => "gRomEl°m@",
"grommellent" => "gRomEl",
"grommellerait" => "gRomEl°RE",
"gronda" => "gR§da",
"grondai" => "gR§dE",
"grondaient" => "gR§dE",
"grondais" => "gR§dE",
"grondait" => "gR§dE",
"grondant" => "gR§d@",
"grondante" => "gR§d@t",
"grondants" => "gR§d@",
"gronde" => "gR§d",
"grondé" => "gR§de",
"grondée" => "gR§de",
"grondement" => "gR§d°m@",
"grondements" => "gR§d°m@",
"grondent" => "gR§d",
"gronder" => "gR§de",
"grondera" => "gR§d°Ra",
"gronderai" => "gR§d°RE",
"gronderait" => "gR§d°RE",
"grondèrent" => "gR§dER",
"gronderies" => "gR§d°Ri",
"grondes" => "gR§d",
"grondés" => "gR§de",
"grondeur" => "gR§d9R",
"grondeurs" => "gR§d9R",
"grondeuse" => "gR§d2z",
"grondeuses" => "gR§d2z",
"grondez" => "gR§de",
"grondin" => "gR§d5",
"grondins" => "gR§d5",
"groom" => "gRum",
"grooms" => "gRum",
"gros" => "gRo",
"gros-bec" => "gRobEk",
"gros-becs" => "gRobEk",
"gros-cul" => "gRoky",
"gros-grain" => "gRogR5",
"gros-porteur" => "gRopORt9R",
"groschen" => "gRoS°n",
"groseille" => "gRozEj",
"groseilles" => "gRozEj",
"groseillier" => "gRozEje",
"groseilliers" => "gRozEje",
"grosse" => "gRos",
"grosses" => "gRos",
"grossesse" => "gRosEs",
"grossesses" => "gRosEs",
"grosseur" => "gRos9R",
"grosseurs" => "gRos9R",
"grossi" => "gRosi",
"grossie" => "gRosi",
"grossier" => "gRosje",
"grossière" => "gRosjER",
"grossièrement" => "gRosjER°m@",
"grossières" => "gRosjER",
"grossièreté" => "gRosjER°te",
"grossièretés" => "gRosjER°te",
"grossiers" => "gRosje",
"grossies" => "gRosi",
"grossir" => "gRosiR",
"grossira" => "gRosiRa",
"grossirent" => "gRosiR",
"grossirez" => "gRosiRe",
"grossiront" => "gRosiR§",
"grossis" => "gRosi",
"grossissaient" => "gRosisE",
"grossissais" => "gRosisE",
"grossissait" => "gRosisE",
"grossissant" => "gRosis@",
"grossissante" => "gRosis@t",
"grossissantes" => "gRosis@t",
"grossissants" => "gRosis@",
"grossisse" => "gRosis",
"grossissement" => "gRosis°m@",
"grossissent" => "gRosis",
"grossisses" => "gRosis",
"grossissez" => "gRosise",
"grossiste" => "gRosist",
"grossistes" => "gRosist",
"grossit" => "gRosi",
"grossium" => "gRosjOm",
"grossiums" => "gRosjOm",
"grosso modo" => "gRosomodo",
"grotesque" => "gRotEsk",
"grotesquement" => "gRotEsk°m@",
"grotesques" => "gRotEsk",
"grotte" => "gROt",
"grottes" => "gROt",
"grouillaient" => "gRujE",
"grouillais" => "gRujE",
"grouillait" => "gRujE",
"grouillant" => "gRuj@",
"grouillante" => "gRuj@t",
"grouillantes" => "gRuj@t",
"grouillants" => "gRuj@",
"grouille" => "gRuj",
"grouillé" => "gRuje",
"grouillées" => "gRuje",
"grouillement" => "gRuj°m@",
"grouillements" => "gRuj°m@",
"grouillent" => "gRuj",
"grouiller" => "gRuje",
"grouillera" => "gRuj°Ra",
"grouillerait" => "gRuj°RE",
"grouillèrent" => "gRujER",
"grouilleront" => "gRuj°R§",
"grouilles" => "gRuj",
"grouillez" => "gRuje",
"grouillis" => "gRuji",
"grouillons" => "gRuj§",
"grouillot" => "gRujo",
"grouillots" => "gRujo",
"grouiner" => "gRwine",
"groumais" => "gRumE",
"groumait" => "gRumE",
"groumant" => "gRum@",
"groume" => "gRum",
"groumer" => "gRum9R",
"ground" => "gRawnd",
"group" => "gRup",
"groupa" => "gRupa",
"groupage" => "gRupaZ",
"groupaient" => "gRupE",
"groupais" => "gRupE",
"groupait" => "gRupE",
"groupant" => "gRup@",
"groupât" => "gRupa",
"groupe" => "gRup",
"groupé" => "gRupe",
"groupée" => "gRupe",
"groupées" => "gRupe",
"groupement" => "gRup°m@",
"groupements" => "gRup°m@",
"groupent" => "gRup",
"grouper" => "gRupe",
"grouperaient" => "gRup°RE",
"groupèrent" => "gRupER",
"grouperont" => "gRup°R§",
"groupes" => "gRup",
"groupés" => "gRupe",
"groupez" => "gRupe",
"groupie" => "gRupi",
"groupies" => "gRupi",
"groupons" => "gRup§",
"groups" => "gRup",
"groupuscule" => "gRupyskyl",
"groupuscules" => "gRupyskyl",
"grouse" => "gRuz",
"grouses" => "gRuz",
"gruau" => "gRyo",
"gruaux" => "gRyo",
"grue" => "gRy",
"grues" => "gRy",
"gruge" => "gRyZ",
"grugé" => "gRyZe",
"grugeaient" => "gRyZE",
"grugeait" => "gRyZE",
"grugeant" => "gRyZ@",
"grugée" => "gRyZe",
"gruger" => "gRyZe",
"grume" => "gRym",
"grumeau" => "gRymo",
"grumeaux" => "gRymo",
"grumeleuse" => "gRym°l2z",
"grumeleuses" => "gRym°l2z",
"grumeleux" => "gRym°l2",
"grumes" => "gRym",
"grumier" => "gRymje",
"grunge" => "gR9nZ",
"gruppetto" => "gRupEto",
"gruta" => "gRyta",
"grute" => "gRyt",
"grutier" => "gRytje",
"grutière" => "gRytjER",
"grutiers" => "gRytje",
"gruyère" => "gRyjER",
"guacamole" => "gwakamole",
"guadeloupéenne" => "gwad°lupeEn",
"guanaco" => "gwanako",
"guanine" => "gwanin",
"guano" => "gwano",
"guaracha" => "gaRaSa",
"guarani" => "gwaRani",
"guatémaltèque" => "gwatemaltEk",
"gué" => "ge",
"guéable" => "geabl",
"guède" => "gEd",
"guéguerre" => "gegER",
"guéguerres" => "gegER",
"guelfe" => "gElf",
"guelfes" => "gElf",
"guenille" => "g°nij",
"guenilles" => "g°nij",
"guenilleux" => "g°nij2",
"guenillons" => "g°nij§",
"guenipe" => "g°nip",
"guenon" => "g°n§",
"guenons" => "g°n§",
"guépard" => "gepaR",
"guépards" => "gepaR",
"guêpe" => "gEp",
"guêpes" => "gEp",
"guêpier" => "gepje",
"guêpière" => "gEpjER",
"guêpières" => "gEpjER",
"guère" => "gER",
"guéret" => "geRE",
"guérets" => "geRE",
"guéri" => "geRi",
"guéridon" => "geRid§",
"guéridons" => "geRid§",
"guérie" => "geRi",
"guéries" => "geRi",
"guérilla" => "geRija",
"guérillas" => "geRija",
"guérillero" => "geRijeRo",
"guérilleros" => "geRijeRos",
"guérir" => "geRiR",
"guérira" => "geRiRa",
"guérirai" => "geRiRE",
"guérirais" => "geRiRE",
"guérirait" => "geRiRE",
"guériras" => "geRiRa",
"guérirez" => "geRiRe",
"guérirons" => "geRiR§",
"guériront" => "geRiR§",
"guéris" => "geRi",
"guérison" => "geRiz§",
"guérisons" => "geRiz§",
"guérissable" => "geRisabl",
"guérissables" => "geRisabl",
"guérissaient" => "geRisE",
"guérissais" => "geRisE",
"guérissait" => "geRisE",
"guérissant" => "geRis@",
"guérisse" => "geRis",
"guérissent" => "geRis",
"guérisses" => "geRis",
"guérisseur" => "geRis9R",
"guérisseurs" => "geRis9R",
"guérisseuse" => "geRis2z",
"guérisseuses" => "geRis2z",
"guérissez" => "geRise",
"guérissiez" => "geRisje",
"guérissons" => "geRis§",
"guérit" => "geRi",
"guérît" => "geRi",
"guérite" => "geRit",
"guérites" => "geRit",
"guerre" => "gER",
"guerre-éclair" => "gEReklER",
"guerres" => "gER",
"guerrier" => "gERje",
"guerrière" => "gERjER",
"guerrières" => "gERjER",
"guerriers" => "gERje",
"guerroient" => "gERwa",
"guerroyai" => "gERwajE",
"guerroyaient" => "gERwajE",
"guerroyait" => "gERwajE",
"guerroyant" => "gERwaj@",
"guerroyé" => "gERwaje",
"guerroyer" => "gERwaje",
"guerroyeur" => "gERwaj9R",
"guet" => "gE",
"guet-apens" => "gEtap@",
"guêtre" => "gEtR",
"guêtré" => "getRe",
"guêtres" => "gEtR",
"guêtrés" => "gEtRe",
"guets" => "gE",
"guets-apens" => "gEap@",
"guetta" => "gEta",
"guettai" => "gEtE",
"guettaient" => "gEtE",
"guettais" => "gEtE",
"guettait" => "gEtE",
"guettant" => "gEt@",
"guettât" => "gEta",
"guette" => "gEt",
"guetté" => "gete",
"guettée" => "gete",
"guettées" => "gete",
"guettent" => "gEt",
"guetter" => "gete",
"guettera" => "gEt°Ra",
"guetterai" => "gEt°RE",
"guetterais" => "gEt°RE",
"guetterait" => "gEt°RE",
"guettèrent" => "gEtER",
"guetterez" => "gEt°Re",
"guetterons" => "gEt°R§",
"guetteront" => "gEt°R§",
"guettes" => "gEt",
"guettés" => "gete",
"guetteur" => "gEt9R",
"guetteurs" => "gEt9R",
"guetteuse" => "gEt2z",
"guetteuses" => "gEt2z",
"guettez" => "gEte",
"guettiez" => "gEtje",
"guettions" => "gEtj§",
"guettons" => "gEt§",
"gueugueule" => "g2g9l",
"gueula" => "g2la",
"gueulai" => "g2lE",
"gueulaient" => "g2lE",
"gueulais" => "g2lE",
"gueulait" => "g2lE",
"gueulant" => "g2l@",
"gueulante" => "g2l@t",
"gueulantes" => "g2l@t",
"gueulard" => "g2laR",
"gueularde" => "g2laRd",
"gueulards" => "g2laR",
"gueule" => "g9l",
"gueulé" => "g9le",
"gueule-de-loup" => "g9ld2lu",
"gueulée" => "g9le",
"gueulement" => "g9l°m@",
"gueulements" => "g9l°m@",
"gueulent" => "g9l",
"gueuler" => "g9le",
"gueulera" => "g9l°Ra",
"gueulerai" => "g9l°RE",
"gueulerais" => "g9l°RE",
"gueulerait" => "g9l°RE",
"gueules" => "g9l",
"gueulés" => "g9le",
"gueules-de-loup" => "g9ld°lu",
"gueuleton" => "g9l°t§",
"gueuletonnait" => "g9l°tonE",
"gueuletonner" => "g9l°tone",
"gueuletons" => "g9l°t§",
"gueulette" => "g9lEt",
"gueulettes" => "g9lEt",
"gueulez" => "g9le",
"gueuloir" => "g9lwaR",
"gueusant" => "g2z@",
"gueusards" => "g2zaR",
"gueuse" => "g2z",
"gueuserie" => "g2z°Ri",
"gueuses" => "g2z",
"gueux" => "g2",
"gueuze" => "g2z",
"guévariste" => "gevaRist",
"gugusse" => "gygys",
"gugusses" => "gygys",
"gui" => "gi",
"guibole" => "gibOl",
"guiboles" => "gibOl",
"guibolle" => "gibOl",
"guibolles" => "gibOl",
"guiche" => "giS",
"guiches" => "giS",
"guichet" => "giSE",
"guichetier" => "giS°tje",
"guichetière" => "giS°tjER",
"guichetiers" => "giS°tje",
"guichets" => "giSE",
"guida" => "gida",
"guidage" => "gidaZ",
"guidai" => "gidE",
"guidaient" => "gidE",
"guidais" => "gidE",
"guidait" => "gidE",
"guidance" => "gid@s",
"guidant" => "gid@",
"guide" => "gid",
"guidé" => "gide",
"guide-interprète" => "gid5tERpREt",
"guidée" => "gide",
"guidées" => "gide",
"guident" => "gid",
"guider" => "gide",
"guidera" => "gid°Ra",
"guiderai" => "gid°RE",
"guiderait" => "gid°RE",
"guideras" => "gid°Ra",
"guidèrent" => "gidER",
"guiderez" => "gid°Re",
"guideront" => "gid°R§",
"guides" => "gid",
"guidés" => "gide",
"guidez" => "gide",
"guidiez" => "gidje",
"guidon" => "gid§",
"guidons" => "gid§",
"guigna" => "giNa",
"guignaient" => "giNE",
"guignais" => "giNE",
"guignait" => "giNE",
"guignant" => "giN@",
"guigne" => "giN",
"guigner" => "giNe",
"guignes" => "giN",
"guignol" => "giNOl",
"guignolades" => "giNolad",
"guignolesque" => "giNolEsk",
"guignolet" => "giNolE",
"guignols" => "giNOl",
"guignon" => "giN§",
"guilde" => "gild",
"guildes" => "gild",
"guili-guili" => "giligili",
"guillaume" => "gijom",
"guillaumes" => "gijom",
"guilledou" => "gijdu",
"guillemet" => "gij°mE",
"guillemets" => "gij°mE",
"guillemot" => "gij°mo",
"guilleret" => "gij°RE",
"guillerets" => "gij°RE",
"guillerette" => "gij°REt",
"guillerettes" => "gij°REt",
"guilloche" => "gijOS",
"guilloché" => "gijoSe",
"guillochée" => "gijoSe",
"guillochées" => "gijoSe",
"guillochés" => "gijoSe",
"guillochures" => "gijoSyR",
"guillotina" => "gijotina",
"guillotinaient" => "gijotinE",
"guillotinait" => "gijotinE",
"guillotine" => "gijotin",
"guillotiné" => "gijotine",
"guillotinée" => "gijotine",
"guillotinées" => "gijotine",
"guillotinent" => "gijotin",
"guillotiner" => "gijotine",
"guillotines" => "gijotin",
"guillotinés" => "gijotine",
"guillotineur" => "gijotin9R",
"guillotineurs" => "gijotin9R",
"guimauve" => "gimov",
"guimauves" => "gimov",
"guimbarde" => "g5baRd",
"guimbardes" => "g5baRd",
"guimpe" => "g5p",
"guimpes" => "g5p",
"guinchait" => "g5SE",
"guinche" => "g5S",
"guincher" => "g5Se",
"guinches" => "g5S",
"guindaient" => "g5dE",
"guindait" => "g5dE",
"guindal" => "g5dal",
"guindals" => "g5dal",
"guindant" => "g5d@",
"guinde" => "g5d",
"guindé" => "g5de",
"guindeau" => "g5do",
"guindée" => "g5de",
"guindées" => "g5de",
"guinder" => "g5de",
"guindés" => "g5de",
"guinée" => "gine",
"guinéen" => "gine5",
"guinéenne" => "gineEn",
"guinéennes" => "gineEn",
"guinéens" => "gine5",
"guinées" => "gine",
"guinguette" => "g5gEt",
"guinguettes" => "g5gEt",
"guipure" => "gipyR",
"guipures" => "gipyR",
"guirlande" => "giRl@d",
"guirlandes" => "giRl@d",
"guise" => "giz",
"guises" => "giz",
"guitare" => "gitaR",
"guitares" => "gitaR",
"guitariste" => "gitaRist",
"guitaristes" => "gitaRist",
"guitoune" => "gitun",
"guitounes" => "gitun",
"gulden" => "gyldEn",
"gun" => "g9n",
"guna" => "gyna",
"guns" => "g9n",
"guppy" => "gypi",
"guru" => "guRu",
"gus" => "gys",
"gusse" => "gys",
"gustatif" => "gystatif",
"gustation" => "gystasj§",
"gustative" => "gystativ",
"gustatives" => "gystativ",
"gusto" => "gysto",
"gut" => "gyt",
"gutta-percha" => "gytapERka",
"guttural" => "gytyRal",
"gutturale" => "gytyRal",
"gutturales" => "gytyRal",
"gutturaux" => "gytyRo",
"guyanais" => "g8ijanE",
"guzla" => "gyzla",
"gy" => "Zi",
"gym" => "Zim",
"gymkhana" => "Zimkana",
"gymnase" => "Zimnaz",
"gymnases" => "Zimnaz",
"gymnasium" => "ZimnazjOm",
"gymnaste" => "Zimnast",
"gymnastes" => "Zimnast",
"gymnastique" => "Zimnastik",
"gymnastiques" => "Zimnastik",
"gymnique" => "Zimnik",
"gymniques" => "Zimnik",
"gymnopédie" => "Zimnopedi",
"gymnosophiste" => "Zimnosofist",
"gymnosophistes" => "Zimnosofist",
"gynécée" => "Zinese",
"gynécées" => "Zinese",
"gynéco" => "Zineko",
"gynécologie" => "ZinekoloZi",
"gynécologique" => "ZinekoloZik",
"gynécologiques" => "ZinekoloZik",
"gynécologue" => "ZinekolOg",
"gynécologues" => "ZinekolOg",
"gynécomastie" => "Zinekomasti",
"gypaète" => "ZipaEt",
"gypse" => "Zips",
"gypses" => "Zips",
"gypseuse" => "Zips2z",
"gypseux" => "Zips2",
"gypsophile" => "Zipsofil",
"gypsophiles" => "Zipsofil",
"gyrins" => "ZiR5",
"gyrocompas" => "ZiRok§pa",
"gyrophare" => "ZiRofaR",
"gyrophares" => "ZiRofaR",
"gyroscope" => "ZiRoskOp",
"gyroscopes" => "ZiRoskOp",
"gyroscopique" => "ZiRoskopik",
"gyrus" => "ZiRys",
"ha" => "a",
"habanera" => "abanERa",
"habile" => "abil",
"habilement" => "abil°m@",
"habiles" => "abil",
"habileté" => "abil°te",
"habiletés" => "abil°te",
"habilitation" => "abilitasj§",
"habilitations" => "abilitasj§",
"habilite" => "abilit",
"habilité" => "abilite",
"habilitée" => "abilite",
"habilitées" => "abilite",
"habilités" => "abilite",
"habilla" => "abija",
"habillage" => "abijaZ",
"habillai" => "abijE",
"habillaient" => "abijE",
"habillais" => "abijE",
"habillait" => "abijE",
"habillâmes" => "abijam",
"habillant" => "abij@",
"habillas" => "abija",
"habillât" => "abija",
"habille" => "abij",
"habillé" => "abije",
"habillée" => "abije",
"habillées" => "abije",
"habillement" => "abij°m@",
"habillent" => "abij",
"habiller" => "abije",
"habillera" => "abij°Ra",
"habillerai" => "abij°RE",
"habilleraient" => "abij°RE",
"habillerais" => "abij°RE",
"habillerait" => "abij°RE",
"habilleras" => "abij°Ra",
"habillèrent" => "abijER",
"habillerez" => "abij°Re",
"habillerons" => "abij°R§",
"habilles" => "abil",
"habillés" => "abije",
"habilleur" => "abij9R",
"habilleurs" => "abij9R",
"habilleuse" => "abij2z",
"habilleuses" => "abij2z",
"habillez" => "abije",
"habilliez" => "abije",
"habillions" => "abijj§",
"habillons" => "abij§",
"habit" => "abi",
"habita" => "abita",
"habitabilité" => "abitabilite",
"habitable" => "abitabl",
"habitables" => "abitabl",
"habitacle" => "abitakl",
"habitacles" => "abitakl",
"habitai" => "abitE",
"habitaient" => "abitE",
"habitais" => "abitE",
"habitait" => "abitE",
"habitant" => "abit@",
"habitante" => "abit@t",
"habitants" => "abit@",
"habitassent" => "abitas",
"habitat" => "abita",
"habitât" => "abita",
"habitation" => "abitasj§",
"habitations" => "abitasj§",
"habitats" => "abita",
"habite" => "abit",
"habité" => "abite",
"habitée" => "abite",
"habitées" => "abite",
"habitent" => "abit",
"habiter" => "abite",
"habitera" => "abit°Ra",
"habiterai" => "abit°RE",
"habiteraient" => "abit°RE",
"habiterais" => "abit°RE",
"habiterait" => "abit°RE",
"habiteras" => "abit°Ra",
"habitèrent" => "abitER",
"habiterez" => "abit°Re",
"habiterions" => "abit°Rj§",
"habiterons" => "abit°R§",
"habiteront" => "abit°R§",
"habites" => "abit",
"habités" => "abite",
"habitez" => "abite",
"habitiez" => "abitje",
"habitions" => "abitj§",
"habitons" => "abit§",
"habits" => "abi",
"habitua" => "abit8a",
"habituai" => "abit8E",
"habituaient" => "abit8E",
"habituais" => "abit8E",
"habituait" => "abit8E",
"habituant" => "abit8@",
"habituât" => "abit8a",
"habitude" => "abityd",
"habitudes" => "abityd",
"habitue" => "abity",
"habitué" => "abit8e",
"habituée" => "abit8e",
"habituées" => "abit8e",
"habituel" => "abit8El",
"habituelle" => "abit8El",
"habituellement" => "abit8El°m@",
"habituelles" => "abit8El",
"habituels" => "abit8El",
"habituent" => "abity",
"habituer" => "abit8e",
"habituera" => "abityRa",
"habituerai" => "abityRE",
"habitueraient" => "abityRE",
"habituerais" => "abityRE",
"habituerait" => "abityRE",
"habitueras" => "abityRa",
"habituèrent" => "abit8ER",
"habituerez" => "abityRe",
"habituerons" => "abityR§",
"habitueront" => "abityR§",
"habitues" => "abity",
"habitués" => "abit8e",
"habituez" => "abitye",
"habituons" => "abit8§",
"habitus" => "abitys",
"hâblerie" => "abl°Ri",
"hâbleries" => "abl°Ri",
"hâbleur" => "abl9R",
"hâbleurs" => "abl9R",
"hacha" => "aSa",
"hachage" => "aSaZ",
"hachaient" => "aSE",
"hachait" => "aSE",
"hachant" => "aS@",
"hachard" => "aSaR",
"hache" => "aS",
"haché" => "aSe",
"hache-paille" => "aSpaj",
"hachée" => "aSe",
"hachées" => "aSe",
"hachent" => "aS",
"hacher" => "aSe",
"hacherai" => "aS°RE",
"hacherait" => "aS°RE",
"hachèrent" => "aSER",
"haches" => "aS",
"hachés" => "aSe",
"hachette" => "aSEt",
"hachettes" => "aSEt",
"hacheur" => "aS9R",
"hacheurs" => "aS9R",
"hachez" => "aSe",
"hachis" => "aSi",
"hachisch" => "aSiS",
"hachoir" => "aSwaR",
"hachoirs" => "aSwaR",
"hachuraient" => "aSyRE",
"hachurait" => "aSyRE",
"hachurant" => "aSyR@",
"hachure" => "aSyR",
"hachuré" => "aSyRe",
"hachurée" => "aSyRe",
"hachurées" => "aSyRe",
"hachures" => "aSyR",
"hachurés" => "aSyRe",
"hacienda" => "asjEnda",
"haciendas" => "asjEnda",
"hack" => "ak",
"hacker" => "ak9R",
"hackers" => "ak9R",
"haddock" => "adOk",
"hadith" => "adit",
"hadj" => "adZ",
"hadji" => "adZi",
"hagard" => "agaR",
"hagarde" => "agaRd",
"hagardes" => "agaRd",
"hagards" => "agaR",
"haggadah" => "agada",
"haggis" => "agis",
"hagiographe" => "aZjogRaf",
"hagiographie" => "aZjogRafi",
"haha" => "aa",
"hai" => "E",
"haï" => "ai",
"haie" => "E",
"haïe" => "ai",
"haies" => "E",
"haïes" => "ai",
"haïk" => "aik",
"haïkaï" => "aikai",
"haïks" => "aik",
"haïku" => "aiky",
"haïkus" => "aiky",
"haillon" => "aj§",
"haillonneuse" => "ajon2z",
"haillonneux" => "ajon2",
"haillons" => "aj§",
"haine" => "En",
"haines" => "En",
"haineuse" => "En2z",
"haineusement" => "En2z°m@",
"haineuses" => "En2z",
"haineux" => "En2",
"haïr" => "aiR",
"haïra" => "aiRa",
"haïrai" => "aiRE",
"haïraient" => "aiRE",
"haïrais" => "aiRE",
"haïrait" => "aiRE",
"haïras" => "aiRa",
"haire" => "ER",
"haires" => "ER",
"haïrez" => "aiRe",
"haïriez" => "aiRje",
"haïrons" => "aiR§",
"haïront" => "aiR§",
"hais" => "E",
"haïs" => "ai",
"haïssable" => "aisabl",
"haïssables" => "aisabl",
"haïssaient" => "aisE",
"haïssais" => "aisE",
"haïssait" => "aisE",
"haïssant" => "ais@",
"haïsse" => "ais",
"haïssent" => "ais",
"haïsses" => "ais",
"haïssez" => "aise",
"haïssiez" => "aisje",
"haïssions" => "aisj§",
"haïssons" => "ais§",
"hait" => "E",
"haït" => "ai",
"haïtien" => "aisj5",
"haïtienne" => "aisjEn",
"haïtiens" => "aisj5",
"haka" => "aka",
"hakka" => "aka",
"hala" => "ala",
"halage" => "alaZ",
"halages" => "alaZ",
"halaient" => "alE",
"halait" => "alE",
"hâlait" => "alE",
"halal" => "alal",
"halant" => "al@",
"hâlant" => "al@",
"halcyon" => "alsj§",
"hale" => "al",
"hâle" => "al",
"halé" => "ale",
"hâlé" => "ale",
"halée" => "ale",
"hâlée" => "ale",
"hâlées" => "ale",
"haleine" => "alEn",
"haleines" => "alEn",
"halent" => "al",
"haler" => "ale",
"halèrent" => "alER",
"hâles" => "al",
"halés" => "ale",
"hâlés" => "ale",
"haleta" => "al°ta",
"haletaient" => "al°tE",
"haletais" => "al°tE",
"haletait" => "al°tE",
"haletant" => "al°t@",
"haletante" => "al°t@t",
"haletantes" => "al°t@t",
"haletants" => "al°t@",
"halète" => "alEt",
"haleté" => "al°te",
"halètement" => "alEt°m@",
"halètements" => "alEt°m@",
"halètent" => "alEt",
"haleter" => "al°te",
"halètes" => "alEt",
"haleur" => "al9R",
"haleurs" => "al9R",
"halez" => "ale",
"half-track" => "alftRak",
"half-tracks" => "alftRak",
"halieutiques" => "alj2tik",
"hall" => "ol",
"hallali" => "alali",
"halle" => "al",
"hallebarde" => "al°baRd",
"hallebardes" => "al°baRd",
"hallebardier" => "al°baRdje",
"hallebardiers" => "al°baRdje",
"halles" => "al",
"hallier" => "alje",
"halliers" => "alje",
"halloween" => "alowin",
"halls" => "ol",
"hallucinais" => "alysinE",
"hallucinant" => "alysin@",
"hallucinante" => "alysin@t",
"hallucinantes" => "alysin@t",
"hallucinants" => "alysin@",
"hallucination" => "alysinasj§",
"hallucinations" => "alysinasj§",
"hallucinatoire" => "alysinatwaR",
"hallucinatoires" => "alysinatwaR",
"hallucine" => "alysin",
"halluciné" => "alysine",
"hallucinée" => "alysine",
"hallucinées" => "alysine",
"halluciner" => "alysine",
"hallucinés" => "alysine",
"hallucinez" => "alysine",
"hallucinogène" => "alysinoZEn",
"hallucinogènes" => "alysinoZEn",
"hallucinons" => "alysin§",
"halo" => "alo",
"halogène" => "aloZEn",
"halogènes" => "aloZEn",
"halogénure" => "alOZenyR",
"halon" => "al§",
"halons" => "al§",
"halopéridol" => "alopeRidOl",
"halos" => "alo",
"halothane" => "alotan",
"halte" => "alt",
"halte-garderie" => "altgaRd2Ri",
"halter" => "alte",
"haltère" => "altER",
"haltères" => "altER",
"haltérophile" => "alteRofil",
"haltérophiles" => "alteRofil",
"haltérophilie" => "alteRofili",
"haltes" => "alt",
"halva" => "alva",
"hamac" => "amak",
"hamacs" => "amak",
"hamada" => "amada",
"hamadryade" => "amadRijad",
"hamadryas" => "amadRijas",
"hamamélis" => "amamelis",
"hambourgeois" => "@buRZwa",
"hambourgeoises" => "@buRZwaz",
"hamburger" => "@buRg9R",
"hamburgers" => "@buRg9R",
"hameau" => "amo",
"hameaux" => "amo",
"hameçon" => "am°s§",
"hameçonne" => "am°sOn",
"hameçons" => "am°s§",
"hammam" => "amam",
"hammams" => "amam",
"hammerless" => "amERlEs",
"hampe" => "@p",
"hampes" => "@p",
"hamster" => "amstER",
"hamsters" => "amstER",
"han" => "@",
"hanap" => "anap",
"hanaps" => "anap",
"hanche" => "@S",
"hanchée" => "@Se",
"hanches" => "@S",
"hand-ball" => "@dbOl",
"handball" => "@dbal",
"handicap" => "@dikap",
"handicapait" => "@dikapE",
"handicapant" => "@dikap@",
"handicape" => "@dikap",
"handicapé" => "@dikape",
"handicapée" => "@dikape",
"handicapées" => "@dikape",
"handicaper" => "@dikape",
"handicapera" => "@dikap°Ra",
"handicapés" => "@dikape",
"handicapeur" => "@dikap9R",
"handicaps" => "@dikap",
"hangar" => "@gaR",
"hangars" => "@gaR",
"hanneton" => "an°t§",
"hannetons" => "an°t§",
"hanoukka" => "anuka",
"hanovrien" => "anOvRi5",
"hanovriens" => "anOvRi5",
"hanséatique" => "@seatik",
"hanta" => "@ta",
"hantaient" => "@tE",
"hantais" => "@tE",
"hantait" => "@tE",
"hantant" => "@t@",
"hantavirus" => "@taviRys",
"hante" => "@t",
"hanté" => "@te",
"hantée" => "@te",
"hantées" => "@te",
"hantent" => "@t",
"hanter" => "@te",
"hantera" => "@t°Ra",
"hanterai" => "@t°RE",
"hanterait" => "@t°RE",
"hanteront" => "@t°R§",
"hantes" => "@t",
"hantés" => "@te",
"hanteur" => "@t9R",
"hantez" => "@te",
"hantise" => "@tiz",
"hantises" => "@tiz",
"happa" => "apa",
"happai" => "apE",
"happaient" => "apE",
"happait" => "apE",
"happant" => "ap@",
"happe" => "ap",
"happé" => "ape",
"happée" => "ape",
"happées" => "ape",
"happement" => "ap°m@",
"happening" => "ap°niG",
"happenings" => "ap°niG",
"happent" => "ap",
"happer" => "ape",
"happerait" => "ap°RE",
"happés" => "ape",
"happeurs" => "ap9R",
"happy end" => "apiEnd",
"happy ends" => "apiEnd",
"happy few" => "apifju",
"haptoglobine" => "aptoglObin",
"haque" => "ak",
"haquenée" => "ak°ne",
"haquet" => "akE",
"haquets" => "akE",
"hara-kiri" => "aRakiRi",
"harangua" => "aR@ga",
"haranguaient" => "aR@gE",
"haranguait" => "aR@gE",
"haranguant" => "aR@g@",
"harangue" => "aR@g",
"harangué" => "aR@ge",
"haranguée" => "aR@ge",
"haranguer" => "aR@ge",
"haranguerais" => "aR@g°RE",
"harangues" => "aR@g",
"harangués" => "aR@ge",
"haranguez" => "aR@ge",
"harari" => "aRaRi",
"haras" => "aRa",
"harassaient" => "aRasE",
"harassant" => "aRas@",
"harassante" => "aRas@t",
"harassantes" => "aRas@t",
"harassants" => "aRas@",
"harasse" => "aRas",
"harassé" => "aRase",
"harassée" => "aRase",
"harassées" => "aRase",
"harassement" => "aRas°m@",
"harassent" => "aRas",
"harasser" => "aRase",
"harassés" => "aRase",
"harcela" => "aRs°la",
"harcelai" => "aRs°lE",
"harcelaient" => "aRs°lE",
"harcelais" => "aRs°lE",
"harcelait" => "aRs°lE",
"harcelant" => "aRs°l@",
"harcelante" => "aRs°l@t",
"harcelantes" => "aRs°l@t",
"harcelants" => "aRs°l@",
"harcèle" => "aRsEl",
"harcelé" => "aRs°le",
"harcelée" => "aRs°le",
"harcelées" => "aRs°le",
"harcèlement" => "aRsEl°m@",
"harcèlements" => "aRsEl°m@",
"harcèlent" => "aRsEl",
"harceler" => "aRs°le",
"harcèlera" => "aRsEl°Ra",
"harcèlerai" => "aRsEl°RE",
"harcèleraient" => "aRsEl°RE",
"harcelèrent" => "aRs°lER",
"harcèlerez" => "aRsEl°Re",
"harcèlerons" => "aRsEl°R§",
"harcèleront" => "aRsEl°R§",
"harcelés" => "aRs°le",
"harceleur" => "aRs°l9R",
"harceleuse" => "aRs°l2z",
"harcelez" => "aRs°le",
"harceliez" => "aRs°lje",
"hard" => "aRd",
"hard edge" => "aRdEdZ",
"hard-top" => "aRdtOp",
"harde" => "aRd",
"hardent" => "aRd",
"harder" => "aRde",
"hardes" => "aRd",
"hardi" => "aRdi",
"hardie" => "aRdi",
"hardies" => "aRdi",
"hardiesse" => "aRdjEs",
"hardiesses" => "aRdijEs",
"hardiment" => "aRdim@",
"hardis" => "aRdi",
"hare" => "aR",
"harem" => "aREm",
"harems" => "aREm",
"hareng" => "aR@",
"harengère" => "aR@ZER",
"harengs" => "aR@",
"harenguet" => "aR@gE",
"harenguier" => "aR@gje",
"haret" => "aRE",
"harfang" => "aRf@",
"hargne" => "aRN",
"hargnes" => "aRN",
"hargneuse" => "aRN2z",
"hargneusement" => "aRN2z°m@",
"hargneuses" => "aRN2z",
"hargneux" => "aRN2",
"haricot" => "aRiko",
"haricots" => "aRiko",
"haridelle" => "aRidEl",
"haridelles" => "aRidEl",
"harissa" => "aRisa",
"harki" => "aRki",
"harkis" => "aRki",
"harmattan" => "aRmat@",
"harmonica" => "aRmonika",
"harmonicas" => "aRmonika",
"harmoniciste" => "aRmonisist",
"harmonie" => "aRmoni",
"harmonies" => "aRmoni",
"harmonieuse" => "aRmonj2z",
"harmonieusement" => "aRmonj2z°m@",
"harmonieuses" => "aRmonj2z",
"harmonieux" => "aRmonj2",
"harmonique" => "aRmonik",
"harmoniquement" => "aRmOnik°m@",
"harmoniques" => "aRmonik",
"harmonisaient" => "aRmonizE",
"harmonisait" => "aRmonizE",
"harmonisant" => "aRmoniz@",
"harmonisateurs" => "aRmonizat9R",
"harmonisation" => "aRmonizasj§",
"harmonisatrices" => "aRmonizatRis",
"harmonise" => "aRmoniz",
"harmonisé" => "aRmonize",
"harmonisent" => "aRmoniz",
"harmoniser" => "aRmonize",
"harmonisera" => "aRmoniz°Ra",
"harmonisèrent" => "aRmonizER",
"harmonisés" => "aRmonize",
"harmonisez" => "aRmonize",
"harmonium" => "aRmonjOm",
"harmoniums" => "aRmonjOm",
"harnacha" => "aRnaSa",
"harnachaient" => "aRnaSE",
"harnachais" => "aRnaSE",
"harnachait" => "aRnaSE",
"harnaché" => "aRnaSe",
"harnachée" => "aRnaSe",
"harnachées" => "aRnaSe",
"harnachement" => "aRnaS°m@",
"harnachements" => "aRnaS°m@",
"harnacher" => "aRnaSe",
"harnachèrent" => "aRnaSER",
"harnachés" => "aRnaSe",
"harnachiez" => "aRnaSje",
"harnais" => "aRnE",
"harnois" => "aRnwa",
"haro" => "aRo",
"harpagon" => "aRpag§",
"harpe" => "aRp",
"harper" => "aRpe",
"harpes" => "aRp",
"harpie" => "aRpi",
"harpies" => "aRpi",
"harpin" => "aRp5",
"harpions" => "aRpj§",
"harpiste" => "aRpist",
"harpon" => "aRp§",
"harponna" => "aRpona",
"harponnage" => "aRponaZ",
"harponne" => "aRpOn",
"harponné" => "aRpone",
"harponnée" => "aRpone",
"harponnent" => "aRpOn",
"harponner" => "aRpone",
"harponnera" => "aRpOn°Ra",
"harponnés" => "aRpone",
"harponneur" => "aRpon9R",
"harponneurs" => "aRpon9R",
"harpons" => "aRp§",
"harpyes" => "aRpi",
"hart" => "aR",
"harts" => "aR",
"haruspices" => "aRyspis",
"has been" => "abij5n",
"hasard" => "azaR",
"hasarda" => "azaRda",
"hasardai" => "azaRdE",
"hasardaient" => "azaRdE",
"hasardais" => "azaRdE",
"hasardait" => "azaRdE",
"hasardant" => "azaRd@",
"hasarde" => "azaRd",
"hasardé" => "azaRde",
"hasardée" => "azaRde",
"hasardent" => "azaRd",
"hasarder" => "azaRde",
"hasardera" => "azaRd°Ra",
"hasarderais" => "azaRd°RE",
"hasardeuse" => "azaRd2z",
"hasardeusement" => "azaRd2z°m@",
"hasardeuses" => "azaRd2z",
"hasardeux" => "azaRd2",
"hasards" => "azaR",
"hasch" => "aS",
"haschich" => "aSiS",
"haschisch" => "aSiS",
"hase" => "az",
"haseki" => "aski",
"hasekis" => "aski",
"hases" => "az",
"hassidim" => "asidim",
"hassidique" => "asidik",
"hassidisme" => "asidizm",
"hâta" => "ata",
"hâtai" => "atE",
"hâtaient" => "atE",
"hâtais" => "atE",
"hâtait" => "atE",
"hâtâmes" => "atam",
"hâtant" => "at@",
"hâtât" => "ata",
"hâte" => "at",
"hâté" => "ate",
"hâtée" => "ate",
"hâtent" => "at",
"hâter" => "ate",
"hâtera" => "at°Ra",
"hâteraient" => "at°RE",
"hâterait" => "at°RE",
"hâtèrent" => "atER",
"hâtes" => "at",
"hâtés" => "ate",
"hâtez" => "ate",
"hâtif" => "atif",
"hâtifs" => "atif",
"hâtions" => "atj§",
"hâtive" => "ativ",
"hâtivement" => "ativ°m@",
"hâtives" => "ativ",
"hâtons" => "at§",
"hauban" => "ob@",
"haubanée" => "obane",
"haubanés" => "obane",
"haubans" => "ob@",
"haubert" => "obER",
"haussa" => "osa",
"haussai" => "osE",
"haussaient" => "osE",
"haussais" => "osE",
"haussait" => "osE",
"haussant" => "os@",
"haussât" => "osa",
"hausse" => "os",
"haussé" => "ose",
"haussée" => "ose",
"haussées" => "ose",
"haussement" => "os°m@",
"haussements" => "os°m@",
"haussent" => "os",
"hausser" => "ose",
"hausserait" => "os°RE",
"haussèrent" => "osER",
"hausses" => "os",
"haussés" => "ose",
"haussez" => "ose",
"haussier" => "osje",
"haussière" => "osjER",
"haussières" => "osjER",
"haussons" => "os§",
"haut" => "o",
"haut-commandement" => "okOm@nd°m@",
"haut-commissaire" => "okomisER",
"haut-commissariat" => "okomisaRja",
"haut-de-chausse" => "od°Sos",
"haut-de-chausses" => "od°Sos",
"haut-de-forme" => "od°fORm",
"haut-fond" => "of§",
"haut-le-coeur" => "ol°k9R",
"haut-le-corps" => "ol°kOR",
"haut-parleur" => "opaRl9R",
"haut-parleurs" => "opaRl9R",
"haut-relief" => "oR°ljEf",
"hautain" => "ot5",
"hautaine" => "otEn",
"hautainement" => "otEn°m@",
"hautaines" => "otEn",
"hautains" => "ot5",
"hautbois" => "obwa",
"haute" => "ot",
"haute-fidélité" => "otfidelite",
"hautement" => "ot°m@",
"hautes" => "ot",
"hautesse" => "otEs",
"hauteur" => "ot9R",
"hauteurs" => "ot9R",
"hautin" => "ot5",
"hautins" => "ot5",
"hauts" => "o",
"hauts-commissaires" => "okomisER",
"hauts-de-chausses" => "od°Sos",
"hauts-de-forme" => "od°fORm",
"hauts-fonds" => "of§",
"hauts-fourneaux" => "ofuRno",
"hauturière" => "otyRjER",
"havanais" => "avanE",
"havanaise" => "avanEz",
"havane" => "avan",
"havanes" => "avan",
"have" => "av",
"hâve" => "av",
"haveneau" => "av°no",
"haveneaux" => "av°no",
"haver" => "ave",
"haves" => "av",
"hâves" => "av",
"havrais" => "avRE",
"havre" => "avR",
"havres" => "avR",
"havresac" => "avR°sak",
"havresacs" => "avR°sak",
"hawaïen" => "awaj5",
"hawaïenne" => "awajEn",
"hawaiienne" => "awajEn",
"hawaiiennes" => "awajEn",
"hayon" => "Ej§",
"hayons" => "Ej§",
"hé" => "e",
"heaume" => "om",
"heaumes" => "om",
"hebdo" => "Ebdo",
"hebdomadaire" => "EbdomadER",
"hebdomadairement" => "EbdomadER°m@",
"hebdomadaires" => "EbdomadER",
"hebdos" => "Ebdo",
"hébéphrénique" => "ebefRenik",
"héberge" => "ebERZ",
"hébergé" => "ebERZe",
"hébergea" => "ebERZa",
"hébergeai" => "ebERZE",
"hébergeaient" => "ebERZE",
"hébergeais" => "ebERZE",
"hébergeait" => "ebERZE",
"hébergeant" => "ebERZ@",
"hébergée" => "ebERZe",
"hébergées" => "ebERZe",
"hébergement" => "ebERZ°m@",
"hébergent" => "ebERZ",
"hébergeons" => "ebERZ§",
"héberger" => "ebERZe",
"hébergera" => "ebERZ°Ra",
"hébergerait" => "ebERZ°RE",
"hébergeras" => "ebERZ°Ra",
"hébergés" => "ebERZe",
"hébergez" => "ebERZe",
"hébergiez" => "ebERZje",
"hébergions" => "ebERZj§",
"hébertisme" => "ebERtizm",
"hébéta" => "ebeta",
"hébétait" => "ebetE",
"hébété" => "ebete",
"hébétée" => "ebete",
"hébétées" => "ebete",
"hébétement" => "ebEt°m@",
"hébètent" => "ebEt",
"hébétés" => "ebete",
"hébétude" => "ebetyd",
"hébraïque" => "ebRaik",
"hébraïquement" => "ebRaik°m@",
"hébraïques" => "ebRaik",
"hébraïsant" => "ebRaiz@",
"hébreu" => "ebR2",
"hébreux" => "ebR2",
"hécatombe" => "ekat§b",
"hécatombes" => "ekat§b",
"hectare" => "EktaR",
"hectares" => "EktaR",
"hecto" => "Ekto",
"hectolitres" => "EktolitR",
"hectomètres" => "EktomEtR",
"hédonisme" => "edonizm",
"hédoniste" => "edonist",
"hédonistes" => "edonist",
"hégélianisme" => "eZeljanizm",
"hégélien" => "eZelj5",
"hégélienne" => "eZeljEn",
"hégéliens" => "eZelj5",
"hégémonie" => "eZemoni",
"hégire" => "eZiR",
"hein" => "5",
"héla" => "ela",
"hélai" => "elE",
"hélaient" => "elE",
"hélait" => "elE",
"hélant" => "el@",
"hélas" => "elas",
"hèle" => "El",
"hélé" => "ele",
"héler" => "ele",
"hélèrent" => "elER",
"hélés" => "ele",
"hélez" => "ele",
"hélianthes" => "elj@t",
"hélice" => "elis",
"hélices" => "elis",
"hélico" => "eliko",
"hélicoïdal" => "elikoidal",
"hélicoïdale" => "elikOidal",
"hélicoptère" => "elikOptER",
"hélicoptères" => "elikOptER",
"hélio" => "eljo",
"héliographe" => "eljOgRaf",
"héliogravure" => "eljogRavyR",
"héliophanie" => "eljofani",
"héliotrope" => "eljotROp",
"héliotropes" => "eljotROp",
"héliport" => "elipOR",
"héliporté" => "elipORte",
"héliportée" => "elipORte",
"héliporter" => "elipORte",
"héliportés" => "elipORte",
"hélitreuiller" => "elitR9je",
"hélium" => "eljOm",
"hélix" => "eliks",
"hellène" => "ElEn",
"hellènes" => "ElEn",
"hellénique" => "Elenik",
"helléniques" => "Elenik",
"hellénisé" => "Elenize",
"helléniser" => "Elenize",
"hellénisme" => "Elenizm",
"helléniste" => "Elenist",
"hellénistes" => "Elenist",
"hellénistique" => "Elenistik",
"hellénistiques" => "Elenistik",
"hello" => "Elo",
"helminthe" => "Elm5t",
"helvelles" => "ElvEl",
"helvète" => "ElvEt",
"helvètes" => "ElvEt",
"helvétien" => "Elvesj5",
"helvétique" => "Elvetik",
"helvétiques" => "Elvetik",
"hem" => "Em",
"hématie" => "emasi",
"hématies" => "emasi",
"hématine" => "ematin",
"hématite" => "ematit",
"hématocèle" => "ematosEl",
"hématocrite" => "ematokRit",
"hématologie" => "ematoloZi",
"hématologique" => "ematOlOZik",
"hématologue" => "ematolOg",
"hématome" => "ematom",
"hématomes" => "ematom",
"hématopoïèse" => "ematopojEz",
"hématose" => "ematoz",
"hématurie" => "ematyRi",
"hémi" => "emi",
"hémicycle" => "emisikl",
"hémièdres" => "emjEdR",
"hémiplégie" => "emipleZi",
"hémiplégique" => "emipleZik",
"hémiptère" => "emiptER",
"hémisphère" => "emisfER",
"hémisphères" => "emisfER",
"hémisphérique" => "emisfeRik",
"hémisphériques" => "emisfeRik",
"hémistiche" => "emistiS",
"hémistiches" => "emistiS",
"hemlock" => "EmlOk",
"hémoculture" => "emokyltyR",
"hémocultures" => "emokyltyR",
"hémodialyse" => "emodjaliz",
"hémodynamique" => "emodinamik",
"hémoglobine" => "emoglobin",
"hémoglobines" => "emoglobin",
"hémogramme" => "emogRam",
"hémolyse" => "emoliz",
"hémolytique" => "emolitik",
"hémophile" => "emofil",
"hémophiles" => "emofil",
"hémophilie" => "emofili",
"hémoptysie" => "emoptizi",
"hémoptysies" => "emoptizi",
"hémorragie" => "emoRaZi",
"hémorragies" => "emoRaZi",
"hémorragique" => "emoRaZik",
"hémorroïdaire" => "emOROidER",
"hémorroïdale" => "emOROidal",
"hémorroïde" => "emoRoid",
"hémorroïdes" => "emoRoid",
"hémostase" => "emOstaz",
"hémostatique" => "emostatik",
"henné" => "ene",
"hennin" => "en5",
"hennir" => "eniR",
"hennirent" => "eniR",
"hennissaient" => "enisE",
"hennissait" => "enisE",
"hennissant" => "enis@",
"hennissantes" => "enis@t",
"hennissement" => "enis°m@",
"hennissements" => "enis°m@",
"hennissent" => "enis",
"hennit" => "eni",
"henry" => "@Ri",
"hep" => "Ep",
"héparine" => "epaRin",
"hépatique" => "epatik",
"hépatiques" => "epatik",
"hépatite" => "epatit",
"hépatites" => "epatit",
"hépatomégalie" => "epatOmegali",
"heptagone" => "Eptagon",
"heptaméron" => "EptameR§",
"heptane" => "Eptan",
"héraclitéen" => "eRaklite5",
"héraclitéenne" => "eRakliteEn",
"héraclitienne" => "eRaklisjEn",
"héraldique" => "eRaldik",
"héraldiques" => "eRaldik",
"héraut" => "eRo",
"hérauts" => "eRo",
"herba" => "ERba",
"herbage" => "ERbaZ",
"herbagers" => "ERbaZe",
"herbages" => "ERbaZ",
"herbe" => "ERb",
"herber" => "ERbe",
"herbes" => "ERb",
"herbette" => "ERbEt",
"herbettes" => "ERbEt",
"herbeuse" => "ERb2z",
"herbeuses" => "ERb2z",
"herbeux" => "ERb2",
"herbicide" => "ERbisid",
"herbier" => "ERbje",
"herbiers" => "ERbje",
"herbivore" => "ERbivOR",
"herbivores" => "ERbivOR",
"herborisais" => "ERboRizE",
"herborisait" => "ERboRizE",
"herboriser" => "ERboRize",
"herboriste" => "ERboRist",
"herboristerie" => "ERboRist°Ri",
"herboristeries" => "ERboRist°Ri",
"herboristes" => "ERboRist",
"herbu" => "ERby",
"herbue" => "ERby",
"herbues" => "ERby",
"herbus" => "ERby",
"hercher" => "ERSe",
"hercule" => "ERkyl",
"herculéen" => "ERkyle5",
"herculéenne" => "ERkyleEn",
"herculéennes" => "ERkyleEn",
"herculéens" => "ERkyle5",
"hercules" => "ERkyl",
"hercynien" => "ERsinj5",
"hercyniennes" => "ERsinjEn",
"hère" => "ER",
"héréditaire" => "eReditER",
"héréditairement" => "eReditER°m@",
"héréditaires" => "eReditER",
"hérédité" => "eRedite",
"hérédo" => "eRedo",
"hères" => "ER",
"hérésiarque" => "eRezjaRk",
"hérésiarques" => "eRezjaRk",
"hérésie" => "eRezi",
"hérésies" => "eRezi",
"hérétique" => "eRetik",
"hérétiques" => "eRetik",
"hérissa" => "eRisa",
"hérissaient" => "eRisE",
"hérissait" => "eRisE",
"hérissant" => "eRis@",
"hérissât" => "eRisa",
"hérisse" => "eRis",
"hérissé" => "eRise",
"hérissée" => "eRise",
"hérissées" => "eRise",
"hérissement" => "eRis°m@",
"hérissements" => "eRis°m@",
"hérissent" => "eRis",
"hérisser" => "eRise",
"hérisseraient" => "eRis°RE",
"hérissèrent" => "eRisER",
"hérisses" => "eRis",
"hérissés" => "eRise",
"hérisson" => "eRis§",
"hérissons" => "eRis§",
"hérita" => "eRita",
"héritage" => "eRitaZ",
"héritages" => "eRitaZ",
"héritai" => "eRitE",
"héritaient" => "eRitE",
"héritais" => "eRitE",
"héritait" => "eRitE",
"hérite" => "eRit",
"hérité" => "eRite",
"héritée" => "eRite",
"héritées" => "eRite",
"héritent" => "eRit",
"hériter" => "eRite",
"héritera" => "eRit°Ra",
"hériterai" => "eRit°RE",
"hériteraient" => "eRit°RE",
"hériterait" => "eRit°RE",
"hériteras" => "eRit°Ra",
"hériterez" => "eRit°Re",
"hériteront" => "eRit°R§",
"hérites" => "eRit",
"hérités" => "eRite",
"héritez" => "eRite",
"héritier" => "eRitje",
"héritière" => "eRitjER",
"héritières" => "eRitjER",
"héritiers" => "eRitje",
"héritons" => "eRit§",
"hermaphrodisme" => "ERmafRodizm",
"hermaphrodite" => "ERmafRodit",
"hermaphrodites" => "ERmafRodit",
"hermaphroditisme" => "ERmafRoditizm",
"herméneutique" => "ERmen2tik",
"hermès" => "ERmEz",
"hermétique" => "ERmetik",
"hermétiquement" => "ERmetik°m@",
"hermétiques" => "ERmetik",
"hermétisme" => "ERmetizm",
"hermétistes" => "ERmetist",
"hermine" => "ERmin",
"herminé" => "ERmine",
"hermines" => "ERmin",
"herminette" => "ERminEt",
"herminettes" => "ERminEt",
"herniaire" => "ERnjER",
"herniaires" => "ERnijER",
"hernie" => "ERni",
"hernies" => "ERni",
"hernieux" => "ERnj2",
"héro" => "eRo",
"héroïde" => "eRoid",
"héroïne" => "eRoin",
"héroïnes" => "eRoin",
"héroïnomane" => "eRoinoman",
"héroïque" => "eRoik",
"héroïquement" => "eRoik°m@",
"héroïques" => "eRoik",
"héroïsme" => "eRoizm",
"héron" => "eR§",
"hérons" => "eR§",
"héros" => "eRo",
"herpès" => "ERpEs",
"herpétique" => "ERpetik",
"herpétologie" => "ERpetOlOZi",
"herpétologiste" => "ERpetOlOZist",
"hersait" => "ERsE",
"herse" => "ERs",
"hersé" => "ERse",
"herser" => "ERse",
"herses" => "ERs",
"hersés" => "ERse",
"hertz" => "ERts",
"hertzienne" => "ERtsjEn",
"hertziennes" => "ERtsjEn",
"hertziens" => "ERtzj5",
"hésita" => "ezita",
"hésitai" => "ezitE",
"hésitaient" => "ezitE",
"hésitais" => "ezitE",
"hésitait" => "ezitE",
"hésitant" => "ezit@",
"hésitante" => "ezit@t",
"hésitantes" => "ezit@t",
"hésitants" => "ezit@",
"hésitât" => "ezita",
"hésitation" => "ezitasj§",
"hésitations" => "ezitasj§",
"hésite" => "ezit",
"hésité" => "ezite",
"hésitent" => "ezit",
"hésiter" => "ezite",
"hésitera" => "ezit°Ra",
"hésiterai" => "ezit°RE",
"hésiteraient" => "ezit°RE",
"hésiterais" => "ezit°RE",
"hésiterait" => "ezit°RE",
"hésiteras" => "ezit°Ra",
"hésitèrent" => "ezitER",
"hésiterez" => "ezit°Re",
"hésiteriez" => "ezit°Rje",
"hésiterions" => "ezit°Rj§",
"hésiterons" => "ezit°R§",
"hésiteront" => "ezit°R§",
"hésites" => "ezit",
"hésitez" => "ezite",
"hésitiez" => "ezitje",
"hésitions" => "ezitj§",
"hésitons" => "ezit§",
"hessois" => "Eswa",
"hessoise" => "Eswaz",
"hétaïre" => "etaiR",
"hétaïres" => "etaiR",
"hétéro" => "eteRo",
"hétérochromie" => "eteRokROmi",
"hétéroclite" => "eteRoklit",
"hétéroclites" => "eteRoklit",
"hétérodoxes" => "eteRodOks",
"hétérodoxie" => "eteRodOksi",
"hétérogène" => "eteRoZEn",
"hétérogénéité" => "eteRoZeneite",
"hétérogènes" => "eteRoZEn",
"hétéroptère" => "eteROptER",
"hétéros" => "eteRo",
"hétérosexualité" => "eteRoseks8alite",
"hétérosexuel" => "eteRoseks8El",
"hétérosexuelle" => "eteRoseks8El",
"hétérosexuelles" => "eteRoseks8El",
"hétérosexuels" => "eteRoseks8El",
"hétérozygote" => "eteRozigOt",
"hétérozygotes" => "eteRozigOt",
"hetman" => "Etm@",
"hêtraie" => "EtRE",
"hêtraies" => "EtRE",
"hêtre" => "EtR",
"hêtres" => "EtR",
"heu" => "2",
"heur" => "9R",
"heure" => "9R",
"heures" => "9R",
"heureuse" => "2R2z",
"heureusement" => "2R2z°m@",
"heureuses" => "2R2z",
"heureux" => "2R2",
"heuristique" => "2Ristik",
"heurs" => "9R",
"heurt" => "9R",
"heurta" => "9Rta",
"heurtai" => "9RtE",
"heurtaient" => "9RtE",
"heurtais" => "9RtE",
"heurtait" => "9RtE",
"heurtant" => "9Rt@",
"heurtât" => "9Rta",
"heurte" => "9Rt",
"heurté" => "9Rte",
"heurtée" => "9Rte",
"heurtées" => "9Rte",
"heurtent" => "9Rt",
"heurter" => "9Rte",
"heurtera" => "9Rt°Ra",
"heurterai" => "9Rt°RE",
"heurteraient" => "9Rt°RE",
"heurterait" => "9Rt°RE",
"heurtèrent" => "9RtER",
"heurterions" => "9Rt°Rj§",
"heurtés" => "9Rte",
"heurtez" => "9Rte",
"heurtions" => "9Rtj§",
"heurtoir" => "9RtwaR",
"heurtoirs" => "9RtwaR",
"heurtons" => "9Rt§",
"heurts" => "9R",
"hévéa" => "evea",
"hévéas" => "evea",
"hexagonal" => "Egzagonal",
"hexagonale" => "Egzagonal",
"hexagonales" => "Egzagonal",
"hexagonaux" => "Egzagono",
"hexagone" => "Egzagon",
"hexagones" => "Egzagon",
"hexamètres" => "EgzamEtR",
"hi" => "i",
"hi-fi" => "ifi",
"hi-han" => "i@",
"hiatale" => "jatal",
"hiatus" => "jatys",
"hibernaient" => "ibERnE",
"hibernait" => "ibERnE",
"hibernation" => "ibERnasj§",
"hiberne" => "ibERn",
"hiberné" => "ibERne",
"hibernent" => "ibERn",
"hiberner" => "ibERne",
"hibiscus" => "ibiskys",
"hibou" => "ibu",
"hiboux" => "ibu",
"hic" => "ik",
"hic et nunc" => "ikEtnunk",
"hickory" => "ikoRi",
"hidalgo" => "idalgo",
"hidalgos" => "idalgo",
"hideur" => "id9R",
"hideurs" => "id9R",
"hideuse" => "id2z",
"hideusement" => "id2z°m@",
"hideuses" => "id2z",
"hideux" => "id2",
"hier" => "jER",
"hiérarchie" => "jeRaRSi",
"hiérarchies" => "jeRaRSi",
"hiérarchique" => "jeRaRSik",
"hiérarchiquement" => "jeRaRSik°m@",
"hiérarchiques" => "jeRaRSik",
"hiérarchisait" => "jeRaRSizE",
"hiérarchisation" => "jeRaRSizasj§",
"hiérarchise" => "jeRaRSiz",
"hiérarchisé" => "jeRaRSize",
"hiérarchisée" => "jeRaRSize",
"hiérarchisés" => "jeRaRSize",
"hiératique" => "jeRatik",
"hiératiquement" => "jeRatik°m@",
"hiératiques" => "jeRatik",
"hiératisme" => "jeRatizm",
"hiéroglyphe" => "jeRoglif",
"hiéroglyphes" => "jeRoglif",
"hiéroglyphique" => "jeRoglifik",
"hiéroglyphiques" => "jeRoglifik",
"hiéronymites" => "jeRonimit",
"hiérophante" => "jeRof@t",
"high life" => "ajlajf",
"high tech" => "ajtEk",
"high-life" => "ajlajf",
"high-tech" => "ajtEk",
"highlander" => "ajl@d9R",
"highlanders" => "ajl@d9R",
"higoumène" => "igumEn",
"hilaire" => "ilER",
"hilarant" => "ilaR@",
"hilarante" => "ilaR@t",
"hilarantes" => "ilaR@t",
"hilarants" => "ilaR@",
"hilare" => "ilaR",
"hilares" => "ilaR",
"hilarité" => "ilaRite",
"hilarités" => "ilaRite",
"hile" => "il",
"hiloire" => "ilwaR",
"hilotes" => "ilOt",
"himalaya" => "imalaja",
"himalayenne" => "imalajEn",
"himalayens" => "imalaj5",
"hindi" => "indi",
"hindou" => "5du",
"hindoue" => "5du",
"hindoues" => "5du",
"hindouisme" => "5duizm",
"hindous" => "5du",
"hindoustani" => "5dustani",
"hip" => "ip",
"hip-hop" => "ipOp",
"hippie" => "ipi",
"hippies" => "ipi",
"hippique" => "ipik",
"hippiques" => "ipik",
"hippisme" => "ipism",
"hippo" => "ipo",
"hippocampe" => "ipok@p",
"hippocampes" => "ipok@p",
"hippocratique" => "ipokRatik",
"hippodrome" => "ipodRom",
"hippodromes" => "ipodRom",
"hippogriffe" => "ipogRif",
"hippomobile" => "ipOmObil",
"hippophagique" => "ipofaZik",
"hippophagiques" => "ipofaZik",
"hippopotame" => "ipopotam",
"hippopotames" => "ipopotam",
"hippopotamesque" => "ipopotamEsk",
"hippy" => "ipi",
"hirondelle" => "iR§dEl",
"hirondelles" => "iR§dEl",
"hirsute" => "iRsyt",
"hirsutes" => "iRsyt",
"hirsutisme" => "iRsytizm",
"hirudine" => "iRydin",
"hispanique" => "ispanik",
"hispaniques" => "ispanik",
"hispanisante" => "ispaniz@t",
"hispanisants" => "ispaniz@",
"hispano" => "ispano",
"hispano-américain" => "ispanoameRik5",
"hispano-américaine" => "ispanoameRikEn",
"hispano-cubain" => "ispanokyb5",
"hispano-mauresque" => "ispanomoREsk",
"hispanophone" => "ispanofOn",
"hissa" => "isa",
"hissai" => "isE",
"hissaient" => "isE",
"hissais" => "isE",
"hissait" => "isE",
"hissâmes" => "isam",
"hissant" => "is@",
"hisse" => "is",
"hissé" => "ise",
"hissée" => "ise",
"hissées" => "ise",
"hissent" => "is",
"hisser" => "ise",
"hissera" => "is°Ra",
"hisserai" => "is°RE",
"hissèrent" => "isER",
"hissés" => "ise",
"hissez" => "ise",
"hissons" => "is§",
"histamine" => "istamin",
"histaminique" => "istaminik",
"hister" => "istER",
"histocompatibilité" => "istok§patibilite",
"histocompatibles" => "istok§patibl",
"histoire" => "istwaR",
"histoires" => "istwaR",
"histologie" => "istoloZi",
"histologique" => "istoloZik",
"histopathologie" => "istopatOlOZi",
"histoplasmose" => "istoplasmoz",
"historia" => "istoRja",
"historicité" => "istoRisite",
"historico-culturelle" => "istoRikokyltyREl",
"historiée" => "istoRje",
"historien" => "istoRj5",
"historienne" => "istoRjEn",
"historiens" => "istoRj5",
"historiés" => "istoRje",
"historiette" => "istoRjEt",
"historiettes" => "istoRjEt",
"historiographe" => "istORjOgRaf",
"historiographie" => "istoRjogRafi",
"historique" => "istoRik",
"historiquement" => "istoRik°m@",
"historiques" => "istoRik",
"histrion" => "istRij§",
"histrions" => "istRij§",
"hit" => "it",
"hit-parade" => "itpaRad",
"hit-parades" => "itpaRad",
"hitchcockien" => "itSkOkj5",
"hitlérien" => "itleRj5",
"hitlérienne" => "itleRjEn",
"hitlériennes" => "itleRjEn",
"hitlériens" => "itleRj5",
"hitlérisme" => "itleRizm",
"hits" => "it",
"hittite" => "itit",
"hittites" => "itit",
"hiv" => "aSive",
"hiver" => "ivER",
"hivernage" => "ivERnaZ",
"hivernaient" => "ivERnE",
"hivernait" => "ivERnE",
"hivernal" => "ivERnal",
"hivernale" => "ivERnal",
"hivernales" => "ivERnal",
"hivernant" => "ivERn@",
"hivernante" => "ivERn@t",
"hivernantes" => "ivERn@t",
"hivernants" => "ivERn@",
"hivernaux" => "ivERno",
"hiverne" => "ivERn",
"hiverné" => "ivERne",
"hiverner" => "ivERne",
"hivernons" => "ivERn§",
"hivers" => "ivER",
"ho" => "o",
"hobbies" => "Obiz",
"hobby" => "Obi",
"hobereau" => "Ob°Ro",
"hobereaux" => "Ob°Ro",
"hocha" => "oSa",
"hochai" => "oSE",
"hochaient" => "oSE",
"hochais" => "oSE",
"hochait" => "oSE",
"hochant" => "oS@",
"hoche" => "OS",
"hoché" => "oSe",
"hochement" => "OS°m@",
"hochements" => "OS°m@",
"hochent" => "OS",
"hochepot" => "OSpo",
"hocher" => "oSe",
"hocheraient" => "OS°RE",
"hochèrent" => "oSER",
"hocheront" => "OS°R§",
"hoches" => "OS",
"hochet" => "oSE",
"hochets" => "oSE",
"hocheurs" => "oS9R",
"hochez" => "oSe",
"hochions" => "oSj§",
"hockey" => "OkE",
"hockeyeur" => "OkEj9R",
"hockeyeurs" => "OkEj9R",
"hodgkinien" => "OdZkinj5",
"hodja" => "OdZa",
"hoirie" => "waRi",
"hoiries" => "waRi",
"holà" => "ola",
"hold up" => "Old9p",
"hold-up" => "Old9p",
"holding" => "OldiG",
"holdings" => "OldiG",
"holistique" => "olistik",
"holistiques" => "olistik",
"hollandais" => "ol@dE",
"hollandaise" => "ol@dEz",
"hollandaises" => "ol@dEz",
"hollande" => "ol@d",
"hollywoodien" => "Oliwudj5",
"hollywoodienne" => "OliwudjEn",
"hollywoodiennes" => "OliwudjEn",
"hollywoodiens" => "Oliwudj5",
"holocauste" => "olokost",
"holocaustes" => "olokost",
"holoèdres" => "oloEdR",
"hologramme" => "ologRam",
"hologrammes" => "ologRam",
"holographe" => "ologRaf",
"holographes" => "ologRaf",
"holographie" => "ologRafi",
"holographique" => "ologRafik",
"holographiques" => "ologRafik",
"holothuries" => "olotyRi",
"holster" => "Olst9R",
"hom" => "Om",
"homard" => "omaR",
"homardiers" => "omaRdje",
"homards" => "omaR",
"hombre" => "§bR",
"home" => "om",
"home-trainer" => "omtREjn9R",
"homeland" => "omEl@d",
"homélie" => "omeli",
"homélies" => "omeli",
"homéopathe" => "omeopat",
"homéopathie" => "omeopati",
"homéopathique" => "omeopatik",
"homéopathiques" => "omeopatik",
"homéostatique" => "OmeOstatik",
"homéothermie" => "OmeOtERmi",
"homérique" => "omeRik",
"homériques" => "omeRik",
"homes" => "om",
"homicide" => "omisid",
"homicides" => "omisid",
"hominien" => "ominj5",
"hominiens" => "ominj5",
"hominisation" => "ominizasj§",
"hommage" => "omaZ",
"hommages" => "omaZ",
"hommasse" => "omas",
"hommasses" => "omas",
"homme" => "Om",
"homme-chien" => "OmSj5",
"homme-clé" => "Omkle",
"homme-femme" => "Omfam",
"homme-grenouille" => "OmgR°nuj",
"homme-loup" => "Omlu",
"homme-machine" => "OmmaSin",
"homme-oiseau" => "Omwazo",
"homme-orchestre" => "OmORkEstR",
"homme-poisson" => "Ompwas§",
"homme-robot" => "OmRobo",
"homme-sandwich" => "Oms@dwitS",
"homme-serpent" => "OmsERp@",
"hommes" => "Om",
"hommes-grenouilles" => "OmgR°nuj",
"homo" => "omo",
"homo erectus" => "omoeRektys",
"homo habilis" => "omoabilis",
"homogène" => "omoZEn",
"homogénéisateur" => "OmOZeneizat9R",
"homogénéisation" => "omoZeneizasj§",
"homogénéisé" => "omoZeneize",
"homogénéisée" => "omoZeneize",
"homogénéité" => "omoZeneite",
"homogènes" => "omoZEn",
"homologable" => "omologabl",
"homologation" => "omologasj§",
"homologue" => "omolOg",
"homologué" => "omologe",
"homologuée" => "omologe",
"homologuer" => "omologe",
"homologues" => "omolOg",
"homologués" => "omologe",
"homoncule" => "om§kyl",
"homonyme" => "omonim",
"homonymes" => "omonim",
"homonymie" => "omonimi",
"homonymique" => "omonimik",
"homophile" => "omofil",
"homophilie" => "omofili",
"homophobe" => "omofOb",
"homophobes" => "omofOb",
"homophone" => "OmOfOn",
"homophonie" => "omofoni",
"homos" => "omo",
"homosexualité" => "omoseks8alite",
"homosexuel" => "omoseks8El",
"homosexuelle" => "omoseks8El",
"homosexuelles" => "omoseks8El",
"homosexuels" => "omoseks8El",
"homozygote" => "omozigOt",
"homuncule" => "Om§kyl",
"hon" => "§",
"hondurien" => "§dyRj5",
"hong kong" => "§gk§g",
"hongkongais" => "§gk§gE",
"hongre" => "§gR",
"hongres" => "§gR",
"hongrois" => "§gRwa",
"hongroise" => "§gRwaz",
"hongroises" => "§gRwaz",
"honnête" => "onEt",
"honnêtement" => "onEt°m@",
"honnêtes" => "onEt",
"honnêteté" => "onEtte",
"honneur" => "on9R",
"honneurs" => "on9R",
"honni" => "oni",
"honnie" => "oni",
"honnir" => "oniR",
"honnis" => "oni",
"honnissait" => "onisE",
"honnissant" => "onis@",
"honnissent" => "onis",
"honnit" => "oni",
"honora" => "onoRa",
"honorabilité" => "onoRabilite",
"honorable" => "onoRabl",
"honorablement" => "onoRabl°m@",
"honorables" => "onoRabl",
"honorai" => "onoRE",
"honoraient" => "onoRE",
"honoraire" => "onoRER",
"honoraires" => "onoRER",
"honorais" => "onoRE",
"honorait" => "onoRE",
"honorant" => "onoR@",
"honorât" => "onoRa",
"honore" => "onOR",
"honoré" => "onoRe",
"honorée" => "onoRe",
"honorées" => "onoRe",
"honorent" => "onOR",
"honorer" => "onoRe",
"honorera" => "onOR°Ra",
"honorerai" => "onOR°RE",
"honorerait" => "onOR°RE",
"honoreras" => "onOR°Ra",
"honorèrent" => "onoRER",
"honorerez" => "onOR°Re",
"honorerons" => "onOR°R§",
"honoreront" => "onOR°R§",
"honores" => "onOR",
"honorés" => "onoRe",
"honorez" => "onoRe",
"honoriez" => "onoRje",
"honorifique" => "onoRifik",
"honorifiques" => "onoRifik",
"honoris causa" => "onoRiskoza",
"honorons" => "onoR§",
"honte" => "§t",
"hontes" => "§t",
"honteuse" => "§t2z",
"honteusement" => "§t2z°m@",
"honteuses" => "§t2z",
"honteux" => "§t2",
"hooligan" => "uligan",
"hooligans" => "ulig@",
"hop" => "Op",
"hopak" => "Opak",
"hopi" => "opi",
"hopis" => "opi",
"hôpital" => "opital",
"hôpitaux" => "opito",
"hoplite" => "oplit",
"hoquet" => "okE",
"hoqueta" => "Ok°ta",
"hoquetai" => "Ok°tE",
"hoquetais" => "Ok°tE",
"hoquetait" => "Ok°tE",
"hoquetant" => "Ok°t@",
"hoqueté" => "Ok°te",
"hoqueter" => "Ok°te",
"hoquetons" => "Ok°t§",
"hoquets" => "okE",
"hoquette" => "okEt",
"horaire" => "oRER",
"horaires" => "oRER",
"horde" => "ORd",
"hordes" => "ORd",
"horion" => "oRj§",
"horions" => "oRj§",
"horizon" => "oRiz§",
"horizons" => "oRiz§",
"horizontal" => "oRiz§tal",
"horizontale" => "oRiz§tal",
"horizontalement" => "oRiz§tal°m@",
"horizontales" => "oRiz§tal",
"horizontalité" => "oRiz§talite",
"horizontaux" => "oRiz§to",
"horloge" => "ORlOZ",
"horloger" => "ORloZe",
"horlogère" => "ORloZER",
"horlogerie" => "ORlOZ°Ri",
"horlogers" => "ORloZe",
"horloges" => "ORlOZ",
"hormis" => "ORmi",
"hormonal" => "ORmonal",
"hormonale" => "ORmonal",
"hormonales" => "ORmonal",
"hormonaux" => "ORmOno",
"hormone" => "ORmOn",
"hormones" => "ORmOn",
"hormonés" => "ORmone",
"hornblende" => "ORnbl5nd",
"horoscope" => "oRoskOp",
"horoscopes" => "oRoskOp",
"horreur" => "oR9R",
"horreurs" => "oR9R",
"horrible" => "oRibl",
"horriblement" => "oRibl°m@",
"horribles" => "oRibl",
"horrifia" => "oRifja",
"horrifiaient" => "oRifjE",
"horrifiait" => "oRifjE",
"horrifiant" => "oRifj@",
"horrifiante" => "oRifj@t",
"horrifiants" => "oRifj@",
"horrifie" => "oRifi",
"horrifié" => "oRifje",
"horrifiée" => "oRifje",
"horrifiées" => "oRifje",
"horrifier" => "oRifje",
"horrifièrent" => "oRifjER",
"horrifiés" => "oRifje",
"horrifique" => "oRifik",
"horripilaient" => "oRipilE",
"horripilais" => "oRipilE",
"horripilait" => "oRipilE",
"horripilant" => "oRipil@",
"horripilante" => "oRipil@t",
"horripilantes" => "oRipil@t",
"horripilants" => "oRipil@",
"horripilation" => "oRipilasj§",
"horripilations" => "oRipilasj§",
"horripile" => "oRipil",
"horripilé" => "oRipile",
"horripilée" => "oRipile",
"horripilent" => "oRipil",
"horripiler" => "oRipile",
"horripilés" => "oRipile",
"hors" => "OR",
"hors-bord" => "ORbOR",
"hors-cote" => "ORkOt",
"hors-d'oeuvre" => "ORd9vR",
"hors-jeu" => "ORZ2",
"hors-la-loi" => "ORlalwa",
"hors-piste" => "ORpist",
"hors-série" => "ORseRi",
"horse-guard" => "ORsgwaRd",
"horse-guards" => "ORsgwaRds",
"hortensia" => "ORt@sja",
"hortensias" => "ORt@sja",
"horticoles" => "ORtikOl",
"horticulteur" => "ORtikylt9R",
"horticulteurs" => "ORtikylt9R",
"horticultrice" => "ORtikyltRis",
"horticulture" => "ORtikyltyR",
"hortillonnage" => "ORtijonaZ",
"hosanna" => "ozana",
"hosannah" => "ozana",
"hosannas" => "ozana",
"hospice" => "Ospis",
"hospices" => "Ospis",
"hospitalier" => "Ospitalje",
"hospitalière" => "OspitaljER",
"hospitalières" => "OspitaljER",
"hospitaliers" => "Ospitalje",
"hospitalisation" => "Ospitalizasj§",
"hospitalisations" => "Ospitalizasj§",
"hospitalisé" => "Ospitalize",
"hospitalisée" => "Ospitalize",
"hospitalisées" => "Ospitalize",
"hospitaliser" => "Ospitalize",
"hospitaliserons" => "Ospitaliz°R§",
"hospitalisés" => "Ospitalize",
"hospitalité" => "Ospitalite",
"hospodar" => "OspodaR",
"hospodars" => "OspodaR",
"hostau" => "Osto",
"hostellerie" => "OtEl°Ri",
"hostelleries" => "OtEl°Ri",
"hostie" => "Osti",
"hosties" => "Osti",
"hostile" => "Ostil",
"hostilement" => "Ostil°m@",
"hostiles" => "Ostil",
"hostilité" => "Ostilite",
"hostilités" => "Ostilite",
"hosto" => "Osto",
"hostos" => "Osto",
"hot" => "Ot",
"hot dog" => "OtdOg",
"hot dogs" => "OtdOg",
"hot-dog" => "OtdOg",
"hot-dogs" => "OtdOg",
"hôte" => "ot",
"hôtel" => "otEl",
"hôtel-dieu" => "otEldj2",
"hôtel-restaurant" => "otElREstOR@",
"hôtelier" => "ot°lje",
"hôtelière" => "ot°ljER",
"hôtelières" => "ot°ljER",
"hôteliers" => "ot°lje",
"hôtellerie" => "otEl°Ri",
"hôtelleries" => "otEl°Ri",
"hôtels" => "otEl",
"hôtes" => "ot",
"hôtesse" => "otEs",
"hôtesses" => "otEs",
"hotline" => "Otlajn",
"hotte" => "Ot",
"hottée" => "ote",
"hotter" => "Ote",
"hottes" => "Ot",
"hotu" => "oty",
"hotus" => "oty",
"hou" => "u",
"houa" => "ua",
"houari" => "waRi",
"houblon" => "ubl§",
"houblonnés" => "ublone",
"houblons" => "ubl§",
"houe" => "u",
"houhou" => "uu",
"houille" => "uj",
"houiller" => "uje",
"houillère" => "ujER",
"houillères" => "ujER",
"houilles" => "uj",
"houlà" => "ula",
"houle" => "ul",
"houler" => "ule",
"houles" => "ul",
"houlette" => "ulEt",
"houleuse" => "ul2z",
"houleuses" => "ul2z",
"houleux" => "ul2",
"houligan" => "uligan",
"houliganisme" => "uliganizm",
"houlque" => "ulk",
"houp" => "up",
"houppe" => "up",
"houppelande" => "up°l@d",
"houppelandes" => "up°l@d",
"houppes" => "up",
"houppette" => "upEt",
"houppettes" => "upEt",
"hourdis" => "uRdi",
"hourds" => "uR",
"houri" => "uRi",
"houris" => "uRi",
"hourra" => "uRa",
"hourrah" => "uRa",
"hourrahs" => "uRa",
"hourras" => "uRa",
"hourvari" => "uRvaRi",
"hourvaris" => "uRvaRi",
"housards" => "uzaR",
"house" => "awz",
"house music" => "awzmjyzik",
"house-boat" => "awsbOwt",
"house-boats" => "awzbOwts",
"houseau" => "uzo",
"houseaux" => "uzo",
"houspilla" => "uspija",
"houspillaient" => "uspijE",
"houspillait" => "uspijE",
"houspillâmes" => "uspijam",
"houspillant" => "uspij@",
"houspille" => "uspij",
"houspillé" => "uspije",
"houspillée" => "uspije",
"houspillées" => "uspije",
"houspillent" => "uspij",
"houspiller" => "uspije",
"houspillèrent" => "uspijER",
"houspillés" => "uspije",
"housse" => "us",
"housses" => "us",
"houssés" => "use",
"houx" => "u",
"hovercraft" => "Ov9RkRaft",
"hoyau" => "wajo",
"hua" => "8a",
"huaient" => "yE",
"huait" => "8E",
"huant" => "8@",
"huard" => "8aR",
"huards" => "8aR",
"huart" => "8aR",
"hublot" => "yblo",
"hublots" => "yblo",
"huche" => "yS",
"huches" => "yS",
"huchet" => "ySE",
"hue" => "y",
"hué" => "8e",
"huée" => "8e",
"huées" => "8e",
"huer" => "8e",
"huèrent" => "8ER",
"huerta" => "wERta",
"hués" => "8e",
"huez" => "ye",
"hugh" => "yg",
"hugolien" => "ygolj5",
"hugoliens" => "ygolj5",
"huguenot" => "yg°no",
"huguenote" => "yg°nOt",
"huguenots" => "yg°no",
"hui" => "8i",
"huilai" => "8ilE",
"huilait" => "8ilE",
"huile" => "8il",
"huilé" => "8ile",
"huilée" => "8ile",
"huilées" => "8ile",
"huilent" => "8il",
"huiler" => "8ile",
"huilerai" => "8il°RE",
"huiles" => "8il",
"huilés" => "8ile",
"huileuse" => "8il2z",
"huileuses" => "8il2z",
"huileux" => "8il2",
"huilez" => "8ile",
"huilier" => "8ilje",
"huiliers" => "8ilje",
"huipil" => "8ipil",
"huipils" => "8ipil",
"huis" => "8i",
"huisserie" => "8is°Ri",
"huisseries" => "8is°Ri",
"huissier" => "8isje",
"huissiers" => "8isje",
"huit" => "8it",
"huit-reflets" => "8itR°flE",
"huitaine" => "8itEn",
"huitième" => "8itjEm",
"huitièmes" => "8itjEm",
"huître" => "8itR",
"huîtres" => "8itR",
"huîtrier" => "8itRie",
"huîtrière" => "8itRijER",
"huîtriers" => "8itRje",
"hulotte" => "ylOt",
"hulottes" => "ylOt",
"hulula" => "ylyla",
"hululaient" => "ylylE",
"hululait" => "ylylE",
"hululant" => "ylyl@",
"hulule" => "ylyl",
"hululée" => "ylyle",
"hululement" => "ylyl°m@",
"hululements" => "ylyl°m@",
"hululent" => "ylyl",
"hululer" => "ylyle",
"hum" => "9m",
"huma" => "yma",
"humai" => "ymE",
"humaient" => "ymE",
"humain" => "ym5",
"humain-robot" => "ym5Robo",
"humaine" => "ymEn",
"humainement" => "ymEn°m@",
"humaines" => "ymEn",
"humains" => "ym5",
"humais" => "ymE",
"humait" => "ymE",
"humanisait" => "ymanizE",
"humanisant" => "ymaniz@",
"humanisation" => "ymanizasj§",
"humanise" => "ymaniz",
"humanisé" => "ymanize",
"humanisée" => "ymanize",
"humanisées" => "ymanize",
"humanisent" => "ymaniz",
"humaniser" => "ymanize",
"humanisés" => "ymanize",
"humanisme" => "ymanizm",
"humaniste" => "ymanist",
"humanistes" => "ymanist",
"humanitaire" => "ymanitER",
"humanitaires" => "ymanitER",
"humanitarisme" => "ymanitaRizm",
"humanité" => "ymanite",
"humanités" => "ymanite",
"humano" => "ymano",
"humanoïde" => "ymanoid",
"humanoïdes" => "ymanoid",
"humant" => "ym@",
"humble" => "1bl",
"humblement" => "1bl°m@",
"humbles" => "1bl",
"humbug" => "9mb9g",
"hume" => "ym",
"humé" => "yme",
"humecta" => "ymEkta",
"humectage" => "ymEktaZ",
"humectai" => "ymEktE",
"humectaient" => "ymEktE",
"humectais" => "ymEktE",
"humectait" => "ymEktE",
"humectant" => "ymEkt@",
"humecte" => "ymEkt",
"humecté" => "ymEkte",
"humectée" => "ymEkte",
"humectées" => "ymEkte",
"humectent" => "ymEkt",
"humecter" => "ymEkte",
"humectés" => "ymEkte",
"humée" => "yme",
"hument" => "ym",
"humer" => "yme",
"humérale" => "ymeRal",
"humeras" => "ym°Ra",
"humèrent" => "ymER",
"humérus" => "ymeRys",
"humés" => "yme",
"humeur" => "ym9R",
"humeurs" => "ym9R",
"humez" => "yme",
"humide" => "ymid",
"humidement" => "ymid°m@",
"humides" => "ymid",
"humidifia" => "ymidifja",
"humidifiant" => "ymidifj@",
"humidificateur" => "ymidifikat9R",
"humidification" => "ymidifikasj§",
"humidifié" => "ymidifje",
"humidifient" => "ymidifi",
"humidifier" => "ymidifje",
"humidifiés" => "ymidifje",
"humidité" => "ymidite",
"humilia" => "ymilja",
"humiliaient" => "ymiljE",
"humiliais" => "ymiljE",
"humiliait" => "ymiljE",
"humiliant" => "ymilj@",
"humiliante" => "ymilj@t",
"humiliantes" => "ymilj@t",
"humiliants" => "ymilj@",
"humiliassent" => "ymiljas",
"humiliation" => "ymiljasj§",
"humiliations" => "ymiljasj§",
"humilie" => "ymili",
"humilié" => "ymilje",
"humiliée" => "ymilje",
"humiliées" => "ymilje",
"humilient" => "ymili",
"humilier" => "ymilje",
"humiliera" => "ymiliRa",
"humilierai" => "ymiliRE",
"humilieraient" => "ymiliRE",
"humilierais" => "ymiliRE",
"humilierait" => "ymiliRE",
"humilies" => "ymili",
"humiliés" => "ymilje",
"humiliez" => "ymilje",
"humilité" => "ymilite",
"humilités" => "ymilite",
"humions" => "ymj§",
"humons" => "ym§",
"humoral" => "ymoRal",
"humoriste" => "ymoRist",
"humoristes" => "ymoRist",
"humoristique" => "ymoRistik",
"humoristiques" => "ymoRistik",
"humour" => "ymuR",
"humus" => "ymys",
"hun" => "1",
"hune" => "yn",
"hunes" => "yn",
"hunier" => "ynje",
"huniers" => "ynje",
"huns" => "1",
"hunter" => "9nt9R",
"huppe" => "yp",
"huppé" => "ype",
"huppée" => "ype",
"huppées" => "ype",
"huppés" => "ype",
"hure" => "yR",
"hures" => "yR",
"hurla" => "yRla",
"hurlai" => "yRlE",
"hurlaient" => "yRlE",
"hurlais" => "yRlE",
"hurlait" => "yRlE",
"hurlant" => "yRl@",
"hurlante" => "yRl@t",
"hurlantes" => "yRl@t",
"hurlants" => "yRl@",
"hurlât" => "yRla",
"hurle" => "yRl",
"hurlé" => "yRle",
"hurlée" => "yRle",
"hurlées" => "yRle",
"hurlement" => "yRl°m@",
"hurlements" => "yRl°m@",
"hurlent" => "yRl",
"hurler" => "yRle",
"hurlera" => "yRl°Ra",
"hurlerai" => "yRl°RE",
"hurleraient" => "yRl°RE",
"hurlerais" => "yRl°RE",
"hurlerait" => "yRl°RE",
"hurlèrent" => "yRlER",
"hurlerez" => "yRl°Re",
"hurleront" => "yRl°R§",
"hurles" => "yRl",
"hurlés" => "yRle",
"hurleur" => "yRl9R",
"hurleurs" => "yRl9R",
"hurlez" => "yRle",
"hurlions" => "yRlj§",
"hurluberlu" => "yRlybERly",
"hurluberlus" => "yRlybERly",
"huron" => "yR§",
"huronne" => "yROn",
"hurrah" => "yRa",
"hurrahs" => "yRa",
"hurricane" => "9Rikan",
"hurricanes" => "9Rikan",
"huskies" => "yski",
"husky" => "yski",
"hussard" => "ysaR",
"hussarde" => "ysaRd",
"hussards" => "ysaR",
"husseinites" => "ysEnit",
"hussite" => "ysit",
"hussites" => "ysit",
"hutte" => "yt",
"hutter" => "yt9R",
"huttes" => "yt",
"hyacinthe" => "jas5t",
"hyades" => "jad",
"hybridation" => "ibRidasj§",
"hybride" => "ibRid",
"hybridé" => "ibRide",
"hybrides" => "ibRid",
"hydatique" => "idatik",
"hydne" => "idn",
"hydratant" => "idRat@",
"hydratante" => "idRat@t",
"hydratantes" => "idRat@t",
"hydratants" => "idRat@",
"hydratation" => "idRatasj§",
"hydrate" => "idRat",
"hydraté" => "idRate",
"hydratée" => "idRate",
"hydrater" => "idRate",
"hydrates" => "idRat",
"hydratez" => "idRate",
"hydraulicien" => "idRolisj5",
"hydraulique" => "idRolik",
"hydrauliques" => "idRolik",
"hydravion" => "idRavj§",
"hydravions" => "idRavj§",
"hydre" => "idR",
"hydrique" => "idRik",
"hydro" => "idRo",
"hydro-électrique" => "idRoelEktRik",
"hydrocarbure" => "idRokaRbyR",
"hydrocarbures" => "idRokaRbyR",
"hydrocèle" => "idRosEl",
"hydrocéphale" => "idRosefal",
"hydrocéphales" => "idRosefal",
"hydrocéphalie" => "idRosefali",
"hydrochlorique" => "idRoklORik",
"hydrocortisone" => "idRokORtizOn",
"hydrocution" => "idRokysj§",
"hydrodynamique" => "idROdinamik",
"hydroélectrique" => "idRoelEktRik",
"hydrofoil" => "idRofOjl",
"hydrogène" => "idRoZEn",
"hydrogéné" => "idRoZene",
"hydrogénée" => "idRoZene",
"hydrogènes" => "idRoZEn",
"hydrogénisation" => "idRoZenizasj§",
"hydroglisseur" => "idRoglis9R",
"hydrographe" => "idRogRaf",
"hydrographie" => "idRogRafi",
"hydrographique" => "idRogRafik",
"hydrographiques" => "idRogRafik",
"hydrolase" => "idRolaz",
"hydrologie" => "idROlOZi",
"hydrolyse" => "idRoliz",
"hydromel" => "idRomEl",
"hydromètres" => "idRomEtR",
"hydrophile" => "idRofil",
"hydrophiles" => "idRofil",
"hydrophobe" => "idRofOb",
"hydrophobie" => "idRofobi",
"hydrophone" => "idRofOn",
"hydrophyte" => "idRofit",
"hydropique" => "idRopik",
"hydropisie" => "idRopizi",
"hydropneumatique" => "idRopn2matik",
"hydroponique" => "idRoponik",
"hydroponiques" => "idRoponik",
"hydroptère" => "idROptER",
"hydroquinone" => "idRokinOn",
"hydrostatique" => "idROstatik",
"hydrothérapie" => "idRoteRapi",
"hydrox" => "idROks",
"hydroxyde" => "idROksid",
"hyène" => "jEn",
"hyènes" => "jEn",
"hygiaphone" => "iZjafOn",
"hygiène" => "iZjEn",
"hygiènes" => "iZjEn",
"hygiénique" => "iZjenik",
"hygiéniquement" => "iZjenik°m@",
"hygiéniques" => "iZjenik",
"hygiéniste" => "iZjenist",
"hygiénistes" => "iZjenist",
"hygroma" => "igROma",
"hygromètre" => "igRomEtR",
"hygromètres" => "igRomEtR",
"hygrométrie" => "igRometRi",
"hygrométrique" => "igRometRik",
"hygrométriques" => "igRometRik",
"hylémorphique" => "ilemoRfik",
"hymen" => "imEn",
"hyménée" => "imene",
"hyménées" => "imene",
"hyménoptère" => "imenOptER",
"hyménoptères" => "imenOptER",
"hymne" => "imn",
"hymnes" => "imn",
"hyoïde" => "ioid",
"hypallage" => "ipalaZ",
"hyper" => "ipER",
"hyperacidité" => "ipERasidite",
"hyperactif" => "ipERaktif",
"hyperactive" => "ipERaktiv",
"hyperactivité" => "ipERaktivite",
"hyperbare" => "ipERbaR",
"hyperbole" => "ipERbOl",
"hyperboles" => "ipERbOl",
"hyperbolique" => "ipERbolik",
"hyperboliquement" => "ipERbolik°m@",
"hyperborée" => "ipERboRe",
"hyperboréen" => "ipERboRe5",
"hyperboréenne" => "ipERboReEn",
"hyperboréens" => "ipERboRe5",
"hypercalcémie" => "ipERkalsemi",
"hypercholestérolémie" => "ipERkOlEsteROlemi",
"hypercoagulabilité" => "ipERkOagylabilite",
"hyperémotive" => "ipERemOtiv",
"hyperémotivité" => "ipERemotivite",
"hyperespace" => "ipERspas",
"hyperesthésie" => "ipEREstezi",
"hyperglycémies" => "ipERglisemi",
"hyperkaliémie" => "ipERkaliemi",
"hyperlipémie" => "ipERlipemi",
"hyperlipidémie" => "ipERlipidemi",
"hypermarché" => "ipERmaRSe",
"hypermarchés" => "ipERmaRSe",
"hypermnésie" => "ipERm°nezi",
"hypernerveuse" => "ipERnERv2z",
"hypernerveux" => "ipERnERv2",
"hyperplan" => "ipERpl@",
"hyperplasie" => "ipERplazi",
"hyperréactivité" => "ipEReaktivite",
"hyperréalisme" => "ipERRealizm",
"hyperréaliste" => "ipERRealist",
"hyperréalistes" => "ipERRealist",
"hypersensibilité" => "ipERs@sibilite",
"hypersensible" => "ipERs@sibl",
"hypersensibles" => "ipERs@sibl",
"hypersomnie" => "ipERsOmni",
"hypersonique" => "ipERsOnik",
"hypersustentateur" => "ipERsyst@tat9R",
"hypertendu" => "ipERt@dy",
"hypertendue" => "ipERt@dy",
"hypertendus" => "ipERt@dy",
"hypertension" => "ipERt@sj§",
"hypertensions" => "ipERt@sj§",
"hyperthermie" => "ipERtERmi",
"hyperthyroïdien" => "ipERtiRoidj5",
"hypertonique" => "ipERtonik",
"hypertrichose" => "ipERtRikOz",
"hypertrophie" => "ipERtRofi",
"hypertrophié" => "ipERtRofje",
"hypertrophiée" => "ipERtRofje",
"hypertrophiés" => "ipERtRofje",
"hypertrophique" => "ipERtROfik",
"hyperventilation" => "ipERv@tilasj§",
"hypholomes" => "ifolOm",
"hypnagogique" => "ipnagOZik",
"hypnagogiques" => "ipnagoZik",
"hypnogène" => "ipnoZEn",
"hypnogènes" => "ipnoZEn",
"hypnose" => "ipnoz",
"hypnoses" => "ipnoz",
"hypnotique" => "ipnotik",
"hypnotiquement" => "ipnOtik°m@",
"hypnotiques" => "ipnotik",
"hypnotisa" => "ipnotiza",
"hypnotisaient" => "ipnotizE",
"hypnotisais" => "ipnotizE",
"hypnotisait" => "ipnotizE",
"hypnotisant" => "ipnotiz@",
"hypnotise" => "ipnotiz",
"hypnotisé" => "ipnotize",
"hypnotisée" => "ipnotize",
"hypnotisées" => "ipnotize",
"hypnotisent" => "ipnotiz",
"hypnotiser" => "ipnotize",
"hypnotisés" => "ipnotize",
"hypnotiseur" => "ipnotiz9R",
"hypnotiseurs" => "ipnotiz9R",
"hypnotiseuse" => "ipnotiz2z",
"hypnotisme" => "ipnotizm",
"hypo" => "ipo",
"hypoallergénique" => "ipoalERZenik",
"hypoallergéniques" => "ipoalERZenik",
"hypocalcémie" => "ipokalsemi",
"hypocapnie" => "ipokapni",
"hypocauste" => "ipokost",
"hypocaustes" => "ipokost",
"hypocentre" => "ipos@tR",
"hypochlorite" => "ipoklORit",
"hypochondriaque" => "ipok§dRiak",
"hypochondriaques" => "ipok§dRiak",
"hypocondre" => "ipok§dR",
"hypocondriaque" => "ipok§dRijak",
"hypocondriaques" => "ipok§dRijak",
"hypocondrie" => "ipok§dRi",
"hypocras" => "ipokRas",
"hypocrisie" => "ipokRizi",
"hypocrisies" => "ipokRizi",
"hypocrite" => "ipokRit",
"hypocritement" => "ipokRit°m@",
"hypocrites" => "ipokRit",
"hypoderme" => "ipodERm",
"hypodermique" => "ipodERmik",
"hypodermiques" => "ipodERmik",
"hypogée" => "ipoZe",
"hypogées" => "ipoZe",
"hypoglycémie" => "ipoglisemi",
"hypoglycémique" => "ipoglisemik",
"hypoglycémiques" => "ipoglisemik",
"hypogonadisme" => "ipogOnadism",
"hypokhâgne" => "ipokaN",
"hypokhâgnes" => "ipokaN",
"hypomaniaques" => "ipomanjak",
"hyponatrémie" => "iponatRemi",
"hyponomeutes" => "iponom2t",
"hypophysaire" => "ipofizER",
"hypophyse" => "ipofiz",
"hypophyses" => "ipofiz",
"hypoplasie" => "ipoplazi",
"hypospadias" => "ipospadjas",
"hypostase" => "ipostaz",
"hypostases" => "ipostaz",
"hyposulfite" => "ipozylfit",
"hypotaupe" => "ipotop",
"hypotendu" => "ipOt@dy",
"hypotendue" => "ipOt@dy",
"hypotensif" => "ipot@sif",
"hypotension" => "ipot@sj§",
"hypotensive" => "ipot@siv",
"hypoténuse" => "ipotenyz",
"hypothalamus" => "ipotalamys",
"hypothécaire" => "ipotekER",
"hypothécaires" => "ipotekER",
"hypothéquait" => "ipotekE",
"hypothéquant" => "ipotek@",
"hypothèque" => "ipotEk",
"hypothéqué" => "ipoteke",
"hypothéquée" => "ipoteke",
"hypothèquent" => "ipotEk",
"hypothéquer" => "ipoteke",
"hypothéqueraient" => "ipotek°RE",
"hypothèques" => "ipotEk",
"hypothéquez" => "ipoteke",
"hypothéquions" => "ipotekj§",
"hypothermie" => "ipotERmi",
"hypothermique" => "ipotERmik",
"hypothèse" => "ipotEz",
"hypothèses" => "ipotEz",
"hypothétique" => "ipotetik",
"hypothétiquement" => "ipotetik°m@",
"hypothétiques" => "ipotetik",
"hypothyroïdie" => "ipotiRoidi",
"hypotonie" => "ipOtOni",
"hypoxie" => "ipOksi",
"hypoxique" => "ipOksik",
"hysope" => "izOp",
"hysopes" => "izOp",
"hystérectomie" => "isteREktomi",
"hystérie" => "isteRi",
"hystéries" => "isteRi",
"hystérique" => "isteRik",
"hystériquement" => "isteRik°m@",
"hystériques" => "isteRik",
"hystéro" => "isteRo",
"i" => "i",
"i.e." => "idEst",
"iambe" => "j@b",
"iambique" => "j@bik",
"iambiques" => "j@bik",
"ibère" => "ibER",
"ibères" => "ibER",
"ibérique" => "ibeRik",
"ibériques" => "ibeRik",
"ibex" => "ibeks",
"ibis" => "ibis",
"ibm" => "ibeEm",
"ibo" => "ibo",
"iboga" => "ibOga",
"icarienne" => "ikaRjEn",
"ice cream" => "ajskRim",
"ice-cream" => "ajskRim",
"ice-creams" => "ajskRimz",
"iceberg" => "ajsbERg",
"icebergs" => "ajsbERg",
"icelle" => "isEl",
"icelles" => "isEl",
"icelui" => "is°l8i",
"ichtyologie" => "iktjOlOZi",
"ichtyologiste" => "iktjoloZist",
"ici" => "isi",
"ici-bas" => "isiba",
"icoglan" => "ikogl@",
"icoglans" => "ikogl@",
"icône" => "ikon",
"icônes" => "ikon",
"iconoclaste" => "ikonoklast",
"iconoclastes" => "ikonoklast",
"iconographe" => "ikonogRaf",
"iconographie" => "ikonogRafi",
"iconographies" => "ikonogRafi",
"iconographique" => "ikonogRafik",
"iconostase" => "ikonostaz",
"icosaèdre" => "ikozaEdR",
"ictère" => "iktER",
"ictérique" => "ikteRik",
"ictus" => "iktys",
"ide" => "id",
"idéal" => "ideal",
"idéale" => "ideal",
"idéalement" => "ideal°m@",
"idéales" => "ideal",
"idéalisait" => "idealizE",
"idéalisant" => "idealiz@",
"idéalisation" => "idealizasj§",
"idéalise" => "idealiz",
"idéalisé" => "idealize",
"idéalisée" => "idealize",
"idéalisées" => "idealize",
"idéalisent" => "idealiz",
"idéaliser" => "idealize",
"idéalisés" => "idealize",
"idéalisme" => "idealizm",
"idéalismes" => "idealizm",
"idéaliste" => "idealist",
"idéalistes" => "idealist",
"idéals" => "ideal",
"idéation" => "ideasj§",
"idéaux" => "ideo",
"idée" => "ide",
"idée-clé" => "idekle",
"idée-force" => "idefORs",
"idéel" => "ideEl",
"idées" => "ide",
"idées-forces" => "idefORs",
"idem" => "idEm",
"identifia" => "id@tifja",
"identifiable" => "id@tifjabl",
"identifiables" => "id@tifjabl",
"identifiai" => "id@tifjE",
"identifiaient" => "id@tifjE",
"identifiais" => "id@tifjE",
"identifiait" => "id@tifjE",
"identifiant" => "id@tifj@",
"identifiassent" => "id@tifjas",
"identifiât" => "id@tifja",
"identificateur" => "id@tifikat9R",
"identification" => "id@tifikasj§",
"identifications" => "id@tifikasj§",
"identifie" => "id@tifi",
"identifié" => "id@tifje",
"identifiée" => "id@tifje",
"identifiées" => "id@tifje",
"identifient" => "id@tifi",
"identifier" => "id@tifje",
"identifiera" => "id@tifiRa",
"identifierai" => "id@tifiRE",
"identifierais" => "id@tifiRE",
"identifierait" => "id@tifiRE",
"identifièrent" => "id@tifjER",
"identifierez" => "id@tifiRe",
"identifieront" => "id@tifiR§",
"identifiés" => "id@tifje",
"identifiez" => "id@tifje",
"identifions" => "id@tifj§",
"identique" => "id@tik",
"identiquement" => "id@tik°m@",
"identiques" => "id@tik",
"identitaire" => "id@titER",
"identitaires" => "id@titER",
"identitarisme" => "id@titaRizm",
"identité" => "id@tite",
"identités" => "id@tite",
"idéogramme" => "ideogRam",
"idéogrammes" => "ideogRam",
"idéographie" => "ideOgRafi",
"idéographique" => "ideogRafik",
"idéologie" => "ideoloZi",
"idéologies" => "ideoloZi",
"idéologique" => "ideoloZik",
"idéologiquement" => "ideoloZik°m@",
"idéologiques" => "ideoloZik",
"idéologue" => "ideolOg",
"idéologues" => "ideolOg",
"ides" => "id",
"idiolectes" => "idjolEkt",
"idiomatique" => "idjomatik",
"idiomatiques" => "idjomatik",
"idiome" => "idjom",
"idiomes" => "idjom",
"idiopathique" => "idjopatik",
"idiosyncrasie" => "idjos5kRazi",
"idiosyncrasies" => "idjos5kRazi",
"idiosyncrasique" => "idjOs5kRazik",
"idiot" => "idjo",
"idiote" => "idjOt",
"idiotement" => "idjOt°m@",
"idiotes" => "idjOt",
"idiotie" => "idjosi",
"idioties" => "idjosi",
"idiotisme" => "idjotizm",
"idiotismes" => "idjotizm",
"idiots" => "idjo",
"idoine" => "idwan",
"idoines" => "idwan",
"idolâtraient" => "idolatRE",
"idolâtrait" => "idolatRE",
"idolâtrant" => "idolatR@",
"idolâtre" => "idolatR",
"idolâtré" => "idolatRe",
"idolâtrée" => "idolatRe",
"idolâtrent" => "idolatR",
"idolâtrer" => "idolatRe",
"idolâtres" => "idolatR",
"idolâtrie" => "idolatRi",
"idolâtries" => "idolatRi",
"idole" => "idOl",
"idoles" => "idOl",
"idylle" => "idil",
"idylles" => "idil",
"idyllique" => "idilik",
"idylliques" => "idilik",
"if" => "if",
"ifs" => "if",
"iftar" => "iftaR",
"igloo" => "iglu",
"igloos" => "iglu",
"igname" => "iNam",
"ignames" => "iNam",
"ignare" => "iNaR",
"ignares" => "iNaR",
"igné" => "iNe",
"ignée" => "igne",
"ignifuge" => "iNifyZ",
"ignifugé" => "iNifyZe",
"ignifugeant" => "iNifyZ@",
"ignifugée" => "iNifyZe",
"ignifugées" => "iNifyZe",
"ignifuger" => "iNifyZe",
"ignifugés" => "iNifyZe",
"ignition" => "iNisj§",
"ignoble" => "iNObl",
"ignoblement" => "iNObl°m@",
"ignobles" => "iNObl",
"ignominie" => "iNomini",
"ignominies" => "iNomini",
"ignominieuse" => "iNomiN2z",
"ignominieusement" => "iNomiN2z°m@",
"ignominieuses" => "iNomiN2z",
"ignominieux" => "iNomiN2",
"ignora" => "iNoRa",
"ignorai" => "iNoRE",
"ignoraient" => "iNoRE",
"ignorais" => "iNoRE",
"ignorait" => "iNoRE",
"ignorance" => "iNoR@s",
"ignorances" => "iNoR@s",
"ignorant" => "iNoR@",
"ignorante" => "iNoR@t",
"ignorantes" => "iNoR@t",
"ignorantins" => "iNoR@t5",
"ignorants" => "iNoR@",
"ignorassent" => "iNoRas",
"ignorât" => "iNoRa",
"ignore" => "iNoR",
"ignoré" => "iNoRe",
"ignorée" => "iNoRe",
"ignorées" => "iNoRe",
"ignorent" => "iNoR",
"ignorer" => "iNoRe",
"ignorera" => "iNOR°Ra",
"ignorerai" => "iNOR°RE",
"ignoreraient" => "iNOR°RE",
"ignorerais" => "iNOR°RE",
"ignorerait" => "iNOR°RE",
"ignoreras" => "iNOR°Ra",
"ignorèrent" => "iNORER",
"ignoreriez" => "iNOR°Rje",
"ignorerons" => "iNOR°R§",
"ignoreront" => "iNOR°R§",
"ignores" => "iNOR",
"ignorés" => "iNoRe",
"ignorez" => "iNoRe",
"ignoriez" => "iNoRje",
"ignorions" => "iNoRj§",
"ignorons" => "iNoR§",
"iguane" => "igwan",
"iguanes" => "igwan",
"iguanodon" => "igwanod§",
"iguanodons" => "igwanod§",
"igue" => "ig",
"igues" => "ig",
"ikebana" => "ikebana",
"il" => "il",
"île" => "il",
"iléaux" => "ileo",
"iles" => "il",
"îles" => "il",
"îlette" => "ilEt",
"iléus" => "ileys",
"iliaque" => "iljak",
"iliaques" => "iljak",
"ilium" => "iljOm",
"illégal" => "ilegal",
"illégale" => "ilegal",
"illégalement" => "ilegal°m@",
"illégales" => "ilegal",
"illégalistes" => "ilegalist",
"illégalité" => "ilegalite",
"illégaux" => "ilego",
"illégitime" => "ileZitim",
"illégitimement" => "ileZitim°m@",
"illégitimes" => "ileZitim",
"illégitimité" => "ileZitimite",
"illettré" => "iletRe",
"illettrée" => "iletRe",
"illettrés" => "iletRe",
"illettrisme" => "ilEtRizm",
"illicite" => "ilisit",
"illicitement" => "ilisit°m@",
"illicites" => "ilisit",
"illico" => "iliko",
"illimité" => "ilimite",
"illimitée" => "ilimite",
"illimitées" => "ilimite",
"illimités" => "ilimite",
"illisible" => "ilizibl",
"illisibles" => "ilizibl",
"illogique" => "iloZik",
"illogiquement" => "iloZik°m@",
"illogiques" => "iloZik",
"illogisme" => "iloZizm",
"illogismes" => "iloZizm",
"illumina" => "ilymina",
"illuminaient" => "ilyminE",
"illuminait" => "ilyminE",
"illuminant" => "ilymin@",
"illuminateurs" => "ilyminat9R",
"illumination" => "ilyminasj§",
"illuminations" => "ilyminasj§",
"illumine" => "ilymin",
"illuminé" => "ilymine",
"illuminée" => "ilymine",
"illuminées" => "ilymine",
"illuminent" => "ilymin",
"illuminer" => "ilymine",
"illuminera" => "ilymin°Ra",
"illuminerai" => "ilymin°RE",
"illuminerait" => "ilymin°RE",
"illuminèrent" => "ilyminER",
"illumineront" => "ilymin°R§",
"illuminés" => "ilymine",
"illuminez" => "ilymine",
"illuministes" => "ilyminist",
"illusion" => "ilyzj§",
"illusionnait" => "ilyzjonE",
"illusionne" => "ilyzjOn",
"illusionnent" => "ilyzjOn",
"illusionner" => "ilyzjone",
"illusionnez" => "ilyzjone",
"illusionnisme" => "ilyzjonizm",
"illusionniste" => "ilyzjonist",
"illusionnistes" => "ilyzjonist",
"illusions" => "ilyzj§",
"illusoire" => "ilyzwaR",
"illusoirement" => "ilyzwaR°m@",
"illusoires" => "ilyzwaR",
"illustra" => "ilystRa",
"illustraient" => "ilystRE",
"illustrait" => "ilystRE",
"illustrant" => "ilystR@",
"illustrateur" => "ilystRat9R",
"illustration" => "ilystRasj§",
"illustrations" => "ilystRasj§",
"illustratrice" => "ilystRatRis",
"illustre" => "ilystR",
"illustré" => "ilystRe",
"illustrée" => "ilystRe",
"illustrées" => "ilystRe",
"illustrement" => "ilystR2m@",
"illustrent" => "ilystR",
"illustrer" => "ilystRe",
"illustrera" => "ilystR°Ra",
"illustrerai" => "ilystR°RE",
"illustrerait" => "ilystR°RE",
"illustres" => "ilystR",
"illustrés" => "ilystRe",
"illustrions" => "ilystRij§",
"illustrissime" => "ilystRisim",
"illustrissimes" => "ilystRisim",
"îlot" => "ilo",
"ilote" => "ilOt",
"ilotes" => "ilOt",
"îlotier" => "ilotje",
"ilotisme" => "ilOtism",
"îlots" => "ilo",
"ils" => "il",
"image" => "imaZ",
"imagé" => "imaZe",
"imageant" => "imaZ@",
"imagée" => "imaZe",
"imagées" => "imaZe",
"imager" => "imaZe",
"imagerie" => "imaZ°Ri",
"imageries" => "imaZ°Ri",
"images" => "imaZ",
"imagés" => "imaZe",
"imageur" => "imaZ9R",
"imageurs" => "imaZ9R",
"imagier" => "imaZje",
"imagiers" => "imaZje",
"imagina" => "imaZina",
"imaginable" => "imaZinabl",
"imaginables" => "imaZinabl",
"imaginai" => "imaZinE",
"imaginaient" => "imaZinE",
"imaginaire" => "imaZinER",
"imaginairement" => "imaZinER°m@",
"imaginaires" => "imaZinER",
"imaginais" => "imaZinE",
"imaginait" => "imaZinE",
"imaginâmes" => "imaZinam",
"imaginant" => "imaZin@",
"imaginât" => "imaZina",
"imaginatif" => "imaZinatif",
"imaginatifs" => "imaZinatif",
"imagination" => "imaZinasj§",
"imaginations" => "imaZinasj§",
"imaginative" => "imaZinativ",
"imaginatives" => "imaZinativ",
"imagine" => "imaZin",
"imaginé" => "imaZine",
"imaginée" => "imaZine",
"imaginées" => "imaZine",
"imaginent" => "imaZin",
"imaginer" => "imaZine",
"imaginerai" => "imaZin°RE",
"imagineraient" => "imaZin°RE",
"imaginerais" => "imaZin°RE",
"imaginerait" => "imaZin°RE",
"imagineras" => "imaZin°Ra",
"imaginèrent" => "imaZinER",
"imaginerez" => "imaZin°Re",
"imagineriez" => "imaZin°Rje",
"imaginerons" => "imaZin°R§",
"imagineront" => "imaZin°R§",
"imagines" => "imaZin",
"imaginés" => "imaZine",
"imaginez" => "imaZine",
"imaginiez" => "imaZinje",
"imaginions" => "imaZinj§",
"imaginons" => "imaZin§",
"imago" => "imago",
"imam" => "imam",
"imams" => "imam",
"iman" => "im@",
"imbaisable" => "5bEzabl",
"imbattable" => "5batabl",
"imbattables" => "5batabl",
"imbécile" => "5besil",
"imbécilement" => "5besil°m@",
"imbéciles" => "5besil",
"imbécillité" => "5besilite",
"imbécillités" => "5besilite",
"imberbe" => "5bERb",
"imberbes" => "5bERb",
"imbiba" => "5biba",
"imbibaient" => "5bibE",
"imbibais" => "5bibE",
"imbibait" => "5bibE",
"imbibant" => "5bib@",
"imbibe" => "5bib",
"imbibé" => "5bibe",
"imbibée" => "5bibe",
"imbibées" => "5bibe",
"imbiber" => "5bibe",
"imbiberai" => "5bib°RE",
"imbiberais" => "5bib°RE",
"imbiberait" => "5bib°RE",
"imbibés" => "5bibe",
"imbibition" => "5bibisj§",
"imbitable" => "5bitabl",
"imbitables" => "5bitabl",
"imbittable" => "5bitabl",
"imbrication" => "5bRikasj§",
"imbrications" => "5bRikasj§",
"imbriquaient" => "5bRikE",
"imbriquait" => "5bRikE",
"imbriquant" => "5bRik@",
"imbrique" => "5bRik",
"imbriqué" => "5bRike",
"imbriquée" => "5bRike",
"imbriquées" => "5bRike",
"imbriquent" => "5bRik",
"imbriquer" => "5bRike",
"imbriqués" => "5bRike",
"imbrisable" => "5bRizabl",
"imbroglio" => "5bRoglijo",
"imbroglios" => "5bRoglijo",
"imbu" => "5by",
"imbue" => "5by",
"imbues" => "5by",
"imbus" => "5by",
"imbuvable" => "5byvabl",
"imidazole" => "imidazOl",
"imita" => "imita",
"imitable" => "imitabl",
"imitables" => "imitabl",
"imitai" => "imitE",
"imitaient" => "imitE",
"imitais" => "imitE",
"imitait" => "imitE",
"imitâmes" => "imitam",
"imitant" => "imit@",
"imitât" => "imita",
"imitateur" => "imitat9R",
"imitateurs" => "imitat9R",
"imitation" => "imitasj§",
"imitations" => "imitasj§",
"imitative" => "imitativ",
"imitatives" => "imitativ",
"imitatrice" => "imitatRis",
"imite" => "imit",
"imité" => "imite",
"imitée" => "imite",
"imitées" => "imite",
"imitent" => "imit",
"imiter" => "imite",
"imitera" => "imit°Ra",
"imiterai" => "imit°RE",
"imiteraient" => "imit°RE",
"imiterais" => "imit°RE",
"imiterait" => "imit°RE",
"imitèrent" => "imitER",
"imiteront" => "imit°R§",
"imites" => "imit",
"imités" => "imite",
"imitez" => "imite",
"imitiez" => "imitje",
"imitions" => "imitj§",
"imitons" => "imit§",
"immaculation" => "imakylasj§",
"immaculé" => "imakyle",
"immaculée" => "imakyle",
"immaculées" => "imakyle",
"immaculés" => "imakyle",
"immanence" => "iman@s",
"immanent" => "iman@",
"immanente" => "iman@t",
"immanentisme" => "man@tizm",
"immangeable" => "5m@Zabl",
"immangeables" => "5m@Zabl",
"immanquable" => "5m@kabl",
"immanquablement" => "5m@kabl°m@",
"immanquables" => "5m@kabl",
"immarcescible" => "5maRsEsibl",
"immatérialité" => "imateRjalite",
"immatériel" => "imateRjEl",
"immatérielle" => "imateRjEl",
"immatérielles" => "imateRjEl",
"immatériels" => "imateRjEl",
"immatriculation" => "imatRikylasj§",
"immatriculations" => "imatRikylasj§",
"immatriculé" => "imatRikyle",
"immatriculée" => "imatRikyle",
"immatriculées" => "imatRikyle",
"immatriculer" => "imatRikyle",
"immature" => "imatyR",
"immatures" => "imatyR",
"immaturité" => "imatyRite",
"immédiat" => "imedja",
"immédiate" => "imedjat",
"immédiatement" => "imedjat°m@",
"immédiates" => "imedjat",
"immédiateté" => "imedjat°te",
"immédiats" => "imedja",
"immémorial" => "imemoRjal",
"immémoriale" => "imemoRjal",
"immémoriales" => "imemoRjal",
"immémoriaux" => "imemoRjo",
"immense" => "im@s",
"immensément" => "im@sem@",
"immenses" => "im@s",
"immensité" => "im@site",
"immensités" => "im@site",
"immensurable" => "im@syRabl",
"immerge" => "imERZ",
"immergé" => "imERZe",
"immergea" => "imERZa",
"immergeait" => "imERZE",
"immergeant" => "imERZ@",
"immergée" => "imERZe",
"immergées" => "imERZe",
"immergent" => "imERZ",
"immergeons" => "imERZ§",
"immerger" => "imERZe",
"immergèrent" => "imERZER",
"immergerons" => "imERZ°R§",
"immergés" => "imERZe",
"immergez" => "imERZe",
"immergiez" => "imERZje",
"immérité" => "imeRite",
"imméritée" => "imeRite",
"imméritées" => "imeRite",
"immérités" => "imeRite",
"immersion" => "imERsj§",
"immettable" => "5mEtabl",
"immeuble" => "im9bl",
"immeubles" => "im9bl",
"immigrai" => "imigRE",
"immigrant" => "imigR@",
"immigrante" => "imigR@t",
"immigrants" => "imigR@",
"immigration" => "imigRasj§",
"immigré" => "imigRe",
"immigrée" => "imigRe",
"immigrées" => "imigRe",
"immigrer" => "imigRe",
"immigrés" => "imigRe",
"imminence" => "imin@s",
"imminent" => "imin@",
"imminente" => "imin@t",
"imminentes" => "imin@t",
"imminents" => "imin@",
"immisçaient" => "imisE",
"immisçait" => "imisE",
"immisçant" => "imis@",
"immisce" => "imis",
"immiscé" => "imise",
"immiscée" => "imise",
"immiscent" => "imis",
"immiscer" => "imise",
"immiscerait" => "imis°RE",
"immisces" => "imis",
"immiscibles" => "imisibl",
"immixtion" => "imiksj§",
"immixtions" => "imiksj§",
"immobile" => "imobil",
"immobiles" => "imobil",
"immobilier" => "imobilje",
"immobilière" => "imobiljER",
"immobilières" => "imobiljER",
"immobiliers" => "imobilje",
"immobilisa" => "imobiliza",
"immobilisai" => "imobilizE",
"immobilisaient" => "imobilizE",
"immobilisais" => "imobilizE",
"immobilisait" => "imobilizE",
"immobilisant" => "imobiliz@",
"immobilisation" => "imobilizasj§",
"immobilisations" => "imobilizasj§",
"immobilise" => "imobiliz",
"immobilisé" => "imobilize",
"immobilisée" => "imobilize",
"immobilisées" => "imobilize",
"immobilisent" => "imobiliz",
"immobiliser" => "imobilize",
"immobilisera" => "imobiliz°Ra",
"immobiliserait" => "imobiliz°RE",
"immobilisèrent" => "imobilizER",
"immobiliseront" => "imobiliz°R§",
"immobilises" => "imobiliz",
"immobilisés" => "imobilize",
"immobilisez" => "imobilize",
"immobilisme" => "imobilizm",
"immobilisons" => "imobiliz§",
"immobilité" => "imobilite",
"immobilités" => "imobilite",
"immodéré" => "imodeRe",
"immodérée" => "imodeRe",
"immodérées" => "imodeRe",
"immodérément" => "imodeRem@",
"immodérés" => "imodeRe",
"immodeste" => "imodEst",
"immodestes" => "imodEst",
"immodestie" => "imodEsti",
"immola" => "imola",
"immolation" => "imolasj§",
"immolations" => "imolasj§",
"immole" => "imOl",
"immolé" => "imole",
"immolée" => "imole",
"immolent" => "imol",
"immoler" => "imole",
"immolés" => "imole",
"immonde" => "im§d",
"immondes" => "im§d",
"immondice" => "im§dis",
"immondices" => "im§dis",
"immoral" => "imoRal",
"immorale" => "imoRal",
"immoralement" => "imoRal°m@",
"immorales" => "imoRal",
"immoralisme" => "imoRalizm",
"immoraliste" => "imoRalist",
"immoralité" => "imoRalite",
"immoraux" => "imoRo",
"immortalisa" => "imORtaliza",
"immortalisait" => "imORtalizE",
"immortalisant" => "imORtaliz@",
"immortalisation" => "imORtalizasj§",
"immortalise" => "imORtaliz",
"immortalisé" => "imORtalize",
"immortalisée" => "imORtalize",
"immortalisées" => "imORtalize",
"immortaliser" => "imORtalize",
"immortaliseraient" => "imORtaliz°RE",
"immortaliseront" => "imORtaliz°R§",
"immortalisés" => "imORtalize",
"immortalisez" => "imORtalize",
"immortalité" => "imORtalite",
"immortalités" => "imORtalite",
"immortel" => "imORtEl",
"immortelle" => "imORtEl",
"immortelles" => "imORtEl",
"immortels" => "imORtEl",
"immortifiées" => "imORtifje",
"immotivée" => "imotive",
"immotivés" => "imotive",
"immuabilité" => "im8abilite",
"immuable" => "im8abl",
"immuablement" => "im8abl°m@",
"immuables" => "im8abl",
"immune" => "imyn",
"immunisait" => "imynizE",
"immunisation" => "imynizasj§",
"immunise" => "imyniz",
"immunisé" => "imynize",
"immunisée" => "imynize",
"immunisent" => "imyniz",
"immuniser" => "imynize",
"immunisés" => "imynize",
"immunitaire" => "imynitER",
"immunitaires" => "imynitER",
"immunité" => "imynite",
"immunités" => "imynite",
"immunodéficience" => "imynodefisj@s",
"immunodéficitaire" => "imynodefisitER",
"immunodéprimé" => "imynodepRime",
"immunogène" => "imynoZEn",
"immunologie" => "imynoloZi",
"immunologique" => "imynoloZik",
"immunologiste" => "imynolOZist",
"immunostimulant" => "imynostimyl@",
"immunothérapie" => "imynoteRapi",
"immutabilité" => "imytabilite",
"impact" => "5pakt",
"impacts" => "5pakt",
"impair" => "5pER",
"impaire" => "5pER",
"impaires" => "5pER",
"impairs" => "5pER",
"impala" => "5pala",
"impalas" => "5pala",
"impalpabilité" => "5palpabilite",
"impalpable" => "5palpabl",
"impalpablement" => "5palpabl2m@",
"impalpables" => "5palpabl",
"imparable" => "5paRabl",
"imparablement" => "5paRabl°m@",
"imparables" => "5paRabl",
"impardonnable" => "5paRdonabl",
"impardonnablement" => "5paRdOnabl2m@",
"impardonnables" => "5paRdonabl",
"imparfait" => "5paRfE",
"imparfaite" => "5paRfEt",
"imparfaitement" => "5paRfEt°m@",
"imparfaites" => "5paRfEt",
"imparfaits" => "5paRfE",
"impartageable" => "5paRtaZabl",
"imparti" => "5paRti",
"impartial" => "5paRsjal",
"impartiale" => "5paRsjal",
"impartialement" => "5paRsjal°m@",
"impartiales" => "5paRsjal",
"impartialité" => "5paRsjalite",
"impartiaux" => "5paRsjo",
"impartie" => "5paRti",
"impartir" => "5paRtiR",
"impartis" => "5paRti",
"impassable" => "5pasabl",
"impasse" => "5pas",
"impasses" => "5pas",
"impassibilité" => "5pasibilite",
"impassible" => "5pasibl",
"impassiblement" => "5pasibl°m@",
"impassibles" => "5pasibl",
"impatiemment" => "5pasjam@",
"impatience" => "5pasj@s",
"impatiences" => "5pasj@s",
"impatiens" => "5pasj@s",
"impatient" => "5pasj@",
"impatienta" => "5pasj@ta",
"impatientai" => "5pasj@tE",
"impatientaient" => "5pasj@tE",
"impatientais" => "5pasj@tE",
"impatientait" => "5pasj@tE",
"impatientant" => "5pasj@t@",
"impatiente" => "5pasj@t",
"impatienté" => "5pasj@te",
"impatientée" => "5pasj@te",
"impatientent" => "5pasj@t",
"impatienter" => "5pasj@te",
"impatienterait" => "5pasj@t°RE",
"impatientèrent" => "5pasj@tER",
"impatientes" => "5pasj@t",
"impatientés" => "5pasj@te",
"impatientez" => "5pasj@te",
"impatients" => "5pasj@",
"impatronisait" => "5patRonizE",
"impatronisé" => "5patRonize",
"impatroniser" => "5patRonize",
"impavide" => "5pavid",
"impavides" => "5pavid",
"impayable" => "5pEjabl",
"impayables" => "5pEjabl",
"impayé" => "5pEje",
"impayée" => "5peje",
"impayées" => "5peje",
"impayés" => "5peje",
"impeachment" => "impitSmEnt",
"impec" => "5pEk",
"impeccabilité" => "5pEkabilite",
"impeccable" => "5pekabl",
"impeccablement" => "5pekabl°m@",
"impeccables" => "5pekabl",
"impécunieuse" => "5pekynj2z",
"impécunieux" => "5pekynj2",
"impécuniosité" => "5pekynjozite",
"impédance" => "5ped@s",
"impedimenta" => "5pedim@ta",
"impénétrabilité" => "5penetRabilite",
"impénétrable" => "5penetRabl",
"impénétrables" => "5penetRabl",
"impénitent" => "5penit@",
"impénitente" => "5penit@t",
"impénitents" => "5penit@",
"impensable" => "5p@sabl",
"impensables" => "5p@sabl",
"impensé" => "5p@se",
"imper" => "5pER",
"impératif" => "5peRatif",
"impératifs" => "5peRatif",
"impérative" => "5peRativ",
"impérativement" => "5peRativ°m@",
"impératives" => "5peRativ",
"imperator" => "5peRatOR",
"impératrice" => "5peRatRis",
"impératrices" => "5peRatRis",
"imperceptible" => "5pERsEptibl",
"imperceptiblement" => "5pERsEptibl°m@",
"imperceptibles" => "5pERsEptibl",
"imperfectible" => "5pERfEktibl",
"imperfection" => "5pERfEksj§",
"imperfections" => "5pERfEksj§",
"impérial" => "5peRjal",
"impériale" => "5peRjal",
"impériales" => "5peRjal",
"impérialisation" => "5peRjalizasj§",
"impérialisme" => "5peRjalizm",
"impérialiste" => "5peRjalist",
"impérialistes" => "5peRjalist",
"impériaux" => "5peRjo",
"impérieuse" => "5peRj2z",
"impérieusement" => "5peRj2z°m@",
"impérieuses" => "5peRj2z",
"impérieux" => "5peRj2",
"impérissable" => "5peRisabl",
"impérissables" => "5peRisabl",
"impéritie" => "5peRisi",
"imperium" => "5p°RjOm",
"imperméabilisant" => "5pERmeabiliz@",
"imperméabilisé" => "5pERmeabilize",
"imperméabiliser" => "5pERmeabilize",
"imperméabilité" => "5pERmeabilite",
"imperméable" => "5pERmeabl",
"imperméables" => "5pERmeabl",
"impers" => "5pER",
"impersonnaliser" => "5pERsOnalize",
"impersonnalité" => "5pERsonalite",
"impersonnel" => "5pERsonEl",
"impersonnelle" => "5pERsonEl",
"impersonnelles" => "5pERsonEl",
"impersonnels" => "5pERsonEl",
"impertinemment" => "5pERtinam@",
"impertinence" => "5pERtin@s",
"impertinences" => "5pERtin@s",
"impertinent" => "5pERtin@",
"impertinente" => "5pERtin@t",
"impertinentes" => "5pERtin@t",
"impertinents" => "5pERtin@",
"imperturbable" => "5pERtyRbabl",
"imperturbablement" => "5pERtyRbabl°m@",
"imperturbables" => "5pERtyRbabl",
"impétigo" => "5petigo",
"impétrant" => "5petR@",
"impétrante" => "5petR@t",
"impétrants" => "5petR@",
"impétueuse" => "5pet82z",
"impétueusement" => "5pet82z°m@",
"impétueuses" => "5pet82z",
"impétueux" => "5pet82",
"impétuosité" => "5pet8ozite",
"impie" => "5pi",
"impies" => "5pi",
"impiété" => "5pjete",
"impiétés" => "5pjete",
"impitoyable" => "5pitwajabl",
"impitoyablement" => "5pitwajabl°m@",
"impitoyables" => "5pitwajabl",
"implacabilité" => "5plakabilite",
"implacable" => "5plakabl",
"implacablement" => "5plakabl°m@",
"implacables" => "5plakabl",
"implant" => "5pl@",
"implanta" => "5pl@ta",
"implantable" => "5pl@tabl",
"implantaient" => "5pl@tE",
"implantais" => "5pl@tE",
"implantait" => "5pl@tE",
"implantant" => "5pl@t@",
"implantation" => "5pl@tasj§",
"implantations" => "5pl@tasj§",
"implante" => "5pl@t",
"implanté" => "5pl@te",
"implantée" => "5pl@te",
"implantées" => "5pl@te",
"implantent" => "5pl@t",
"implanter" => "5pl@te",
"implantés" => "5pl@te",
"implantez" => "5pl@te",
"implantiez" => "5pl@tje",
"implantons" => "5pl@t§",
"implants" => "5pl@",
"implémentation" => "5plem@tasj§",
"implémenter" => "5plem@te",
"implication" => "5plikasj§",
"implications" => "5plikasj§",
"implicite" => "5plisit",
"implicitement" => "5plisit°m@",
"implicites" => "5plisit",
"impliqua" => "5plika",
"impliquaient" => "5plikE",
"impliquait" => "5plikE",
"impliquant" => "5plik@",
"impliquât" => "5plika",
"implique" => "5plik",
"impliqué" => "5plike",
"impliquée" => "5plike",
"impliquées" => "5plike",
"impliquent" => "5plik",
"impliquer" => "5plike",
"impliquera" => "5plik°Ra",
"impliquerai" => "5plik°RE",
"impliquerais" => "5plik°RE",
"impliquerait" => "5plik°RE",
"impliquerons" => "5plik°R§",
"impliqueront" => "5plik°R§",
"impliqués" => "5plike",
"impliquez" => "5plike",
"impliquions" => "5plikj§",
"impliquons" => "5plik§",
"implora" => "5ploRa",
"implorai" => "5ploRE",
"imploraient" => "5ploRE",
"implorais" => "5ploRE",
"implorait" => "5ploRE",
"implorant" => "5ploR@",
"implorante" => "5ploR@t",
"implorantes" => "5ploR@t",
"implorants" => "5ploR@",
"imploration" => "5ploRasj§",
"implorations" => "5ploRasj§",
"implore" => "5plOR",
"imploré" => "5ploRe",
"implorée" => "5ploRe",
"implorent" => "5plOR",
"implorer" => "5ploRe",
"implorera" => "5plOR°Ra",
"implorerai" => "5plOR°RE",
"implorerais" => "5plOR°RE",
"implorèrent" => "5plORER",
"implorerez" => "5plOR°Re",
"imploreront" => "5plOR°R§",
"implorez" => "5ploRe",
"imploriez" => "5ploRje",
"implorons" => "5ploR§",
"implose" => "5ploz",
"implosent" => "5ploz",
"imploser" => "5ploze",
"implosera" => "5ploz°Ra",
"implosez" => "5ploze",
"implosif" => "5plozif",
"implosifs" => "5plozif",
"implosion" => "5plozj§",
"implosive" => "5ploziv",
"implosives" => "5ploziv",
"impoli" => "5poli",
"impolie" => "5poli",
"impoliment" => "5polim@",
"impolis" => "5poli",
"impolitesse" => "5politEs",
"impolitesses" => "5politEs",
"impollu" => "5pOly",
"impolluable" => "5pOl8abl",
"impollué" => "5pol8e",
"impolluée" => "5pol8e",
"impolluées" => "5pol8e",
"impollués" => "5pol8e",
"impondérable" => "5p§deRabl",
"impondérables" => "5p§deRabl",
"impopulaire" => "5popylER",
"impopulaires" => "5popylER",
"impopularité" => "5popylaRite",
"import" => "5pOR",
"import-export" => "5pOREkspOR",
"importa" => "5pORta",
"importable" => "5pORtabl",
"importables" => "5pORtabl",
"importaient" => "5pORtE",
"importait" => "5pORtE",
"importance" => "5pORt@s",
"importances" => "5pORt@s",
"important" => "5pORt@",
"importante" => "5pORt@t",
"importantes" => "5pORt@t",
"importants" => "5pORt@",
"importât" => "5pORta",
"importateur" => "5pORtat9R",
"importateurs" => "5pORtat9R",
"importation" => "5pORtasj§",
"importations" => "5pORtasj§",
"importe" => "5pORt",
"importé" => "5pORte",
"importée" => "5pORte",
"importées" => "5pORte",
"importent" => "5pORt",
"importer" => "5pORte",
"importera" => "5pORt°Ra",
"importeraient" => "5pORt°RE",
"importerait" => "5pORt°RE",
"importes" => "5pORt",
"importés" => "5pORte",
"imports" => "5pOR",
"importun" => "5pORt1",
"importuna" => "5pORtyna",
"importunaient" => "5pORtynE",
"importunais" => "5pORtynE",
"importunait" => "5pORtynE",
"importunât" => "5pORtyna",
"importune" => "5pORtyn",
"importuné" => "5pORtyne",
"importunée" => "5pORtyne",
"importunent" => "5pORtyn",
"importuner" => "5pORtyne",
"importunerai" => "5pORtyn°RE",
"importunerait" => "5pORtyn°RE",
"importunerez" => "5pORtyn°Re",
"importunerons" => "5pORtyn°R§",
"importunes" => "5pORtyn",
"importunés" => "5pORtyne",
"importunez" => "5pORtyne",
"importunités" => "5pORtynite",
"importuns" => "5pORt1",
"imposa" => "5poza",
"imposable" => "5pozabl",
"imposables" => "5pozabl",
"imposai" => "5pozE",
"imposaient" => "5pozE",
"imposais" => "5pozE",
"imposait" => "5pozE",
"imposant" => "5poz@",
"imposante" => "5poz@t",
"imposantes" => "5poz@t",
"imposants" => "5poz@",
"imposassent" => "5pozas",
"imposât" => "5poza",
"impose" => "5poz",
"imposé" => "5poze",
"imposée" => "5poze",
"imposées" => "5poze",
"imposent" => "5poz",
"imposer" => "5poze",
"imposera" => "5poz°Ra",
"imposerai" => "5poz°RE",
"imposeraient" => "5poz°RE",
"imposerais" => "5poz°RE",
"imposerait" => "5poz°RE",
"imposèrent" => "5pozER",
"imposerez" => "5poz°Re",
"imposerions" => "5poz°Rj§",
"imposerons" => "5poz°R§",
"imposeront" => "5poz°R§",
"imposes" => "5poz",
"imposés" => "5poze",
"imposez" => "5poze",
"imposiez" => "5pozje",
"imposition" => "5pozisj§",
"impositions" => "5pozisj§",
"imposons" => "5poz§",
"impossibilité" => "5posibilite",
"impossibilités" => "5posibilite",
"impossible" => "5posibl",
"impossibles" => "5posibl",
"imposte" => "5pOst",
"imposteur" => "5pOst9R",
"imposteurs" => "5pOst9R",
"imposture" => "5pOstyR",
"impostures" => "5pOstyR",
"impôt" => "5po",
"impotence" => "5pot@s",
"impotent" => "5pot@",
"impotente" => "5pot@t",
"impotentes" => "5pot@t",
"impotents" => "5pot@",
"impôts" => "5po",
"impraticabilité" => "5pRatikabilite",
"impraticable" => "5pRatikabl",
"impraticables" => "5pRatikabl",
"impratique" => "5pRatik",
"imprécateur" => "5pRekat9R",
"imprécation" => "5pRekasj§",
"imprécations" => "5pRekasj§",
"imprécis" => "5pResi",
"imprécisable" => "5pResizabl",
"imprécise" => "5pResiz",
"imprécises" => "5pResiz",
"imprécision" => "5pResizj§",
"imprécisions" => "5pResizj§",
"imprégna" => "5pReNa",
"imprégnaient" => "5pReNE",
"imprégnais" => "5pReNE",
"imprégnait" => "5pReNE",
"imprégnant" => "5pReN@",
"imprégnation" => "5pReNasj§",
"imprégnations" => "5pReNasj§",
"imprègne" => "5pREN",
"imprégné" => "5pReNe",
"imprégnée" => "5pReNe",
"imprégnées" => "5pReNe",
"imprègnent" => "5pREN",
"imprégner" => "5pReNe",
"imprégnèrent" => "5pReNER",
"imprégnés" => "5pReNe",
"imprégnez" => "5pReNe",
"imprenable" => "5pR2nabl",
"imprenables" => "5pR2nabl",
"impréparation" => "5pRepaRasj§",
"impresarii" => "5pResaRi",
"impresario" => "5pResaRjo",
"imprésario" => "5pResaRjo",
"impresarios" => "5pResaRjo",
"imprésarios" => "5pResaRjo",
"imprescriptible" => "5pREskRiptibl",
"imprescriptibles" => "5pREskRiptibl",
"imprésentable" => "5pRez@tabl",
"imprésentables" => "5pRez@tabl",
"impression" => "5pResj§",
"impressionna" => "5pREsjona",
"impressionnable" => "5pResjonabl",
"impressionnables" => "5pResjonabl",
"impressionnaient" => "5pREsjonE",
"impressionnais" => "5pResjonE",
"impressionnait" => "5pREsjonE",
"impressionnant" => "5pResjon@",
"impressionnante" => "5pResjon@t",
"impressionnantes" => "5pResjon@t",
"impressionnants" => "5pResjon@",
"impressionnât" => "5pREsjona",
"impressionne" => "5pREsjOn",
"impressionné" => "5pResjone",
"impressionnée" => "5pResjone",
"impressionnées" => "5pResjone",
"impressionnent" => "5pREsjOn",
"impressionner" => "5pResjone",
"impressionnera" => "5pREsjOn°Ra",
"impressionnerait" => "5pREsjOn°RE",
"impressionneras" => "5pResjOn°Ra",
"impressionnèrent" => "5pREsjonER",
"impressionneront" => "5pREsjOn°R§",
"impressionnes" => "5pREsjOn",
"impressionnés" => "5pResjone",
"impressionnez" => "5pREsjone",
"impressionnisme" => "5pResjonizm",
"impressionniste" => "5pResjonist",
"impressionnistes" => "5pREsjonist",
"impressions" => "5pResj§",
"impressive" => "5pResiv",
"imprévisibilité" => "5pRevizibilite",
"imprévisible" => "5pRevizibl",
"imprévisiblement" => "5pRevizibl2m@",
"imprévisibles" => "5pRevizibl",
"imprévision" => "5pRevizj§",
"imprévoyance" => "5pRevwaj@s",
"imprévoyant" => "5pRevwaj@",
"imprévoyante" => "5pRevwaj@t",
"imprévoyants" => "5pRevwaj@",
"imprévu" => "5pRevy",
"imprévue" => "5pRevy",
"imprévues" => "5pRevy",
"imprévus" => "5pRevy",
"imprima" => "5pRima",
"imprimable" => "5pRimabl",
"imprimaient" => "5pRimE",
"imprimais" => "5pRimE",
"imprimait" => "5pRimE",
"imprimant" => "5pRim@",
"imprimante" => "5pRim@t",
"imprimatur" => "5pRimatyR",
"imprime" => "5pRim",
"imprimé" => "5pRime",
"imprimée" => "5pRime",
"imprimées" => "5pRime",
"impriment" => "5pRim",
"imprimer" => "5pRime",
"imprimera" => "5pRim°Ra",
"imprimerai" => "5pRim°RE",
"imprimerait" => "5pRim°RE",
"imprimeras" => "5pRim°Ra",
"imprimèrent" => "5pRimER",
"imprimerie" => "5pRim°Ri",
"imprimeries" => "5pRim°Ri",
"imprimerons" => "5pRim°R§",
"imprimés" => "5pRime",
"imprimeur" => "5pRim9R",
"imprimeurs" => "5pRim9R",
"imprimez" => "5pRime",
"impro" => "5pRo",
"improbabilité" => "5pRobabilite",
"improbable" => "5pRobabl",
"improbables" => "5pRobabl",
"improductif" => "5pRodyktif",
"improductifs" => "5pRodyktif",
"improductive" => "5pRodyktiv",
"improductives" => "5pRodyktiv",
"impromptu" => "5pR§pty",
"impromptue" => "5pR§pty",
"impromptues" => "5pR§pty",
"impromptus" => "5pR§pty",
"imprononçable" => "5pRon§sabl",
"imprononçables" => "5pRon§sabl",
"imprononcé" => "5pROn§se",
"impropre" => "5pROpR",
"improprement" => "5pROpR°m@",
"impropres" => "5pROpR",
"impropriétés" => "5pRopRijete",
"improuva" => "5pRuva",
"improuvable" => "5pRuvabl",
"improvisa" => "5pRoviza",
"improvisade" => "5pROvizad",
"improvisai" => "5pRovizE",
"improvisaient" => "5pRovizE",
"improvisais" => "5pRovizE",
"improvisait" => "5pRovizE",
"improvisant" => "5pRoviz@",
"improvisateur" => "5pRovizat9R",
"improvisateurs" => "5pRovizat9R",
"improvisation" => "5pRovizasj§",
"improvisations" => "5pRovizasj§",
"improvise" => "5pRoviz",
"improvisé" => "5pRovize",
"improvisée" => "5pRovize",
"improvisées" => "5pRovize",
"improvisent" => "5pRoviz",
"improviser" => "5pRovize",
"improvisera" => "5pRoviz°Ra",
"improviserai" => "5pRoviz°RE",
"improvisèrent" => "5pRovizER",
"improviserons" => "5pRoviz°R§",
"improvisés" => "5pRovize",
"improvisez" => "5pRovize",
"improvisions" => "5pRovizj§",
"improvisons" => "5pRoviz§",
"imprudemment" => "5pRydam@",
"imprudence" => "5pRyd@s",
"imprudences" => "5pRyd@s",
"imprudent" => "5pRyd@",
"imprudente" => "5pRyd@t",
"imprudentes" => "5pRyd@t",
"imprudents" => "5pRyd@",
"impubère" => "5pybER",
"impubères" => "5pybER",
"impubliable" => "5pyblijabl",
"impubliables" => "5pyblijabl",
"impudemment" => "5pydam@",
"impudence" => "5pyd@s",
"impudences" => "5pyd@s",
"impudent" => "5pyd@",
"impudente" => "5pyd@t",
"impudentes" => "5pyd@t",
"impudents" => "5pyd@",
"impudeur" => "5pyd9R",
"impudeurs" => "5pyd9R",
"impudicité" => "5pydisite",
"impudique" => "5pydik",
"impudiquement" => "5pydik°m@",
"impudiques" => "5pydik",
"impuissance" => "5p8is@s",
"impuissances" => "5p8is@s",
"impuissant" => "5p8is@",
"impuissante" => "5p8is@t",
"impuissantes" => "5p8is@t",
"impuissants" => "5p8is@",
"impulsif" => "5pylsif",
"impulsifs" => "5pylsif",
"impulsion" => "5pylsj§",
"impulsions" => "5pylsj§",
"impulsive" => "5pylsiv",
"impulsivement" => "5pylsiv°m@",
"impulsives" => "5pylsiv",
"impulsivité" => "5pylsivite",
"impunément" => "5pynem@",
"impuni" => "5pyni",
"impunie" => "5pyni",
"impunis" => "5pyni",
"impunité" => "5pynite",
"impur" => "5pyR",
"impure" => "5pyR",
"impures" => "5pyR",
"impureté" => "5pyR°te",
"impuretés" => "5pyR°te",
"impurs" => "5pyR",
"imputable" => "5pytabl",
"imputables" => "5pytabl",
"imputai" => "5pytE",
"imputaient" => "5pytE",
"imputais" => "5pytE",
"imputait" => "5pytE",
"imputant" => "5pyt@",
"imputasse" => "5pytas",
"imputât" => "5pyta",
"imputation" => "5pytasj§",
"imputations" => "5pytasj§",
"impute" => "5pyt",
"imputé" => "5pyte",
"imputée" => "5pyte",
"imputées" => "5pyte",
"imputer" => "5pyte",
"imputera" => "5pyt°Ra",
"imputerai" => "5pyt°RE",
"imputèrent" => "5pytER",
"imputeront" => "5pyt°R§",
"imputés" => "5pyte",
"imputrescible" => "5pytResibl",
"imputrescibles" => "5pytResibl",
"in" => "in",
"in absentia" => "inabsEntja",
"in abstracto" => "inapstRakto",
"in anima vili" => "inanimavili",
"in cauda venenum" => "inkodavenenOm",
"in extenso" => "inEkst5so",
"in extremis" => "inEkstRemis",
"in memoriam" => "inm°moRjam",
"in pace" => "inpas",
"in petto" => "inpeto",
"in utero" => "inyteRo",
"in vino veritas" => "invinovERitas",
"in vitro" => "invitRo",
"in vivo" => "invivo",
"in-bord" => "inbORd",
"in-folio" => "infoljo",
"in-folios" => "infoljo",
"in-octavo" => "inOktavo",
"in-octavos" => "inOktavo",
"in-quarto" => "inkwaRto",
"in-seize" => "insEz",
"inabordable" => "inabORdabl",
"inabouti" => "inabuti",
"inaboutie" => "inabuti",
"inacceptable" => "inaksEptabl",
"inacceptables" => "inaksEptabl",
"inaccessibilité" => "inaksEsibilite",
"inaccessible" => "inaksesibl",
"inaccessibles" => "inaksesibl",
"inaccompli" => "inak§pli",
"inaccomplis" => "inak§pli",
"inaccomplissement" => "inak§plis°m@",
"inaccoutumé" => "inakutyme",
"inaccoutumée" => "inakutyme",
"inaccoutumées" => "inakutyme",
"inachevé" => "inaS°ve",
"inachevée" => "inaS°ve",
"inachevées" => "inaS°ve",
"inachèvement" => "inaSEv°m@",
"inachevés" => "inaS°ve",
"inactif" => "inaktif",
"inactifs" => "inaktif",
"inaction" => "inaksj§",
"inactivation" => "inaktivasj§",
"inactive" => "inaktiv",
"inactivé" => "inaktive",
"inactives" => "inaktiv",
"inactivité" => "inaktivite",
"inactuel" => "inakt8El",
"inadaptable" => "inadaptabl",
"inadaptation" => "inadaptasj§",
"inadapté" => "inadapte",
"inadaptée" => "inadapte",
"inadaptées" => "inadapte",
"inadaptés" => "inadapte",
"inadéquat" => "inadekwa",
"inadéquate" => "inadekwat",
"inadéquatement" => "inadekwat°m@",
"inadéquates" => "inadekwat",
"inadéquation" => "inadekwasj§",
"inadéquats" => "inadekwa",
"inadmissible" => "inadmisibl",
"inadmissibles" => "inadmisibl",
"inadvertance" => "inadvERt@s",
"inadvertances" => "inadvERt@s",
"inaliénable" => "inaljenabl",
"inaliénables" => "inaljenabl",
"inaltérable" => "inalteRabl",
"inaltérables" => "inalteRabl",
"inaltéré" => "inalteRe",
"inaltérée" => "inalteRe",
"inaltérées" => "inalteRe",
"inaltérés" => "inalteRe",
"inamical" => "inamikal",
"inamicale" => "inamikal",
"inamicaux" => "inamiko",
"inamovible" => "inamovibl",
"inamovibles" => "inamovibl",
"inanalysable" => "inanalizabl",
"inanalysables" => "inanalizabl",
"inane" => "inan",
"inanimation" => "inanimasj§",
"inanimé" => "inanime",
"inanimée" => "inanime",
"inanimées" => "inanime",
"inanimés" => "inanime",
"inanité" => "inanite",
"inanition" => "inanisj§",
"inapaisable" => "inapEzabl",
"inapaisée" => "inapEze",
"inapaisées" => "inapEze",
"inapaisés" => "inapEze",
"inaperçu" => "inapERsy",
"inaperçue" => "inapERsy",
"inaperçues" => "inapERsy",
"inaperçus" => "inapERsy",
"inappétence" => "inapet@s",
"inapplicable" => "inaplikabl",
"inapplicables" => "inaplikabl",
"inapplication" => "inaplikasj§",
"inappréciable" => "inapResjabl",
"inappréciables" => "inapResjabl",
"inappréciée" => "inapResje",
"inapprivoisables" => "inapRivwazabl",
"inapprochable" => "inapROSabl",
"inapproprié" => "inapRopRije",
"inappropriée" => "inapRopRije",
"inappropriées" => "inapRopRie",
"inappropriés" => "inapRopRie",
"inapte" => "inapt",
"inaptes" => "inapt",
"inaptitude" => "inaptityd",
"inaptitudes" => "inaptityd",
"inarrangeable" => "inaR@Zabl",
"inarticulé" => "inaRtikyle",
"inarticulée" => "inaRtikyle",
"inarticulées" => "inaRtikyle",
"inarticulés" => "inaRtikyle",
"inassimilable" => "inasimilabl",
"inassimilables" => "inasimilabl",
"inassouvi" => "inasuvi",
"inassouvie" => "inasuvi",
"inassouvies" => "inasuvi",
"inassouvis" => "inasuvi",
"inassouvissable" => "inasuvisabl",
"inassouvissables" => "inasuvisabl",
"inassouvissement" => "inasuvis°m@",
"inassurable" => "inasyRabl",
"inattaquable" => "inatakabl",
"inattaquables" => "inatakabl",
"inatteignable" => "inatENabl",
"inatteignables" => "inatENabl",
"inattendu" => "inat@dy",
"inattendue" => "inat@dy",
"inattendues" => "inat@dy",
"inattendus" => "inat@dy",
"inattentif" => "inat@tif",
"inattentifs" => "inat@tif",
"inattention" => "inat@sj§",
"inattentive" => "inat@tiv",
"inattentives" => "inat@tiv",
"inattrapable" => "inatRapabl",
"inaudible" => "inodibl",
"inaudibles" => "inodibl",
"inaugura" => "inogyRa",
"inaugurai" => "inogyRE",
"inaugurais" => "inogyRE",
"inaugurait" => "inogyRE",
"inaugural" => "inogyRal",
"inaugurale" => "inogyRal",
"inaugurales" => "inogyRal",
"inaugurant" => "inogyR@",
"inauguration" => "inogyRasj§",
"inaugurations" => "inogyRasj§",
"inaugure" => "inogyR",
"inauguré" => "inogyRe",
"inaugurée" => "inogyRe",
"inaugurer" => "inogyRe",
"inaugurera" => "inogyR°Ra",
"inaugurèrent" => "inogyRER",
"inaugurés" => "inogyRe",
"inaugurions" => "inogyRj§",
"inaugurons" => "inogyR§",
"inauthenticité" => "inot@tisite",
"inaverti" => "inavERti",
"inavouable" => "inavwabl",
"inavouablement" => "inavwabl2m@",
"inavouables" => "inavwabl",
"inavoué" => "inavwe",
"inavouée" => "inavwe",
"inavouées" => "inavwe",
"inavoués" => "inavwe",
"inca" => "5ka",
"incalculable" => "5kalkylabl",
"incalculables" => "5kalkylabl",
"incandescence" => "5k@des@s",
"incandescences" => "5k@dEs@s",
"incandescent" => "5k@des@",
"incandescente" => "5k@des@t",
"incandescentes" => "5k@des@t",
"incandescents" => "5k@des@",
"incantation" => "5k@tasj§",
"incantations" => "5k@tasj§",
"incantatoire" => "5k@tatwaR",
"incantatoires" => "5k@tatwaR",
"incantatrice" => "5k@tatRis",
"incapable" => "5kapabl",
"incapables" => "5kapabl",
"incapacitant" => "5kapasit@",
"incapacitante" => "5kapasit@t",
"incapacitants" => "5kapasit@",
"incapacité" => "5kapasite",
"incapacités" => "5kapasite",
"incarcération" => "5kaRseRasj§",
"incarcère" => "5kaRsER",
"incarcéré" => "5kaRseRe",
"incarcérée" => "5kaRseRe",
"incarcérées" => "5kaRseRe",
"incarcérer" => "5kaRseRe",
"incarcérés" => "5kaRseRe",
"incarcérez" => "5kaRseRe",
"incarna" => "5kaRna",
"incarnadines" => "5kaRnadin",
"incarnai" => "5kaRnE",
"incarnaient" => "5kaRnE",
"incarnais" => "5kaRnE",
"incarnait" => "5kaRnE",
"incarnant" => "5kaRn@",
"incarnat" => "5kaRna",
"incarnât" => "5kaRna",
"incarnation" => "5kaRnasj§",
"incarnations" => "5kaRnasj§",
"incarne" => "5kaRn",
"incarné" => "5kaRne",
"incarnée" => "5kaRne",
"incarnées" => "5kaRne",
"incarnent" => "5kaRn",
"incarner" => "5kaRne",
"incarnera" => "5kaRn°Ra",
"incarneraient" => "5kaRn°RE",
"incarnerais" => "5kaRn°RE",
"incarnerait" => "5kaRn°RE",
"incarnerez" => "5kaRn°Re",
"incarnes" => "5kaRn",
"incarnés" => "5kaRne",
"incarnez" => "5kaRne",
"incarniez" => "5kaRnje",
"incarnions" => "5kaRnj§",
"incartade" => "5kaRtad",
"incartades" => "5kaRtad",
"incas" => "5ka",
"incassable" => "5kasabl",
"incassables" => "5kasabl",
"incendia" => "5s@dja",
"incendiaient" => "5s@djE",
"incendiaire" => "5s@djER",
"incendiaires" => "5s@djER",
"incendiait" => "5s@djE",
"incendiant" => "5s@dj@",
"incendie" => "5s@di",
"incendié" => "5s@dje",
"incendiée" => "5s@dje",
"incendiées" => "5s@dje",
"incendient" => "5s@di",
"incendier" => "5s@dje",
"incendieras" => "5s@diRa",
"incendièrent" => "5s@djER",
"incendies" => "5s@di",
"incendiés" => "5s@dje",
"incendiez" => "5s@dje",
"incernable" => "5sERnabl",
"incertain" => "5sERt5",
"incertaine" => "5sERtEn",
"incertaines" => "5sERtEn",
"incertains" => "5sERt5",
"incertitude" => "5sERtityd",
"incertitudes" => "5sERtityd",
"incessamment" => "5sesam@",
"incessant" => "5ses@",
"incessante" => "5ses@t",
"incessantes" => "5ses@t",
"incessants" => "5ses@",
"inceste" => "5sEst",
"incestes" => "5sEst",
"incestueuse" => "5sEst82z",
"incestueuses" => "5sEst82z",
"incestueux" => "5sEst82",
"inch allah" => "inSala",
"inchangé" => "5S@Ze",
"inchangeable" => "5S@Zabl",
"inchangée" => "5S@Ze",
"inchangées" => "5S@Ze",
"inchangés" => "5S@Ze",
"inchavirable" => "5SaviRabl",
"inchiffrable" => "5SifRabl",
"incidemment" => "5sidam@",
"incidence" => "5sid@s",
"incidences" => "5sid@s",
"incident" => "5sid@",
"incidente" => "5sid@t",
"incidentes" => "5sid@t",
"incidents" => "5sid@",
"incinérait" => "5sineRE",
"incinérant" => "5sineR@",
"incinérateur" => "5sineRat9R",
"incinérateurs" => "5sineRat9R",
"incinération" => "5sineRasj§",
"incinère" => "5sinER",
"incinéré" => "5sineRe",
"incinérée" => "5sineRe",
"incinérer" => "5sineRe",
"incinérés" => "5sineRe",
"incinérez" => "5sineRe",
"incirconcis" => "5siRk§si",
"incisa" => "5siza",
"incisaient" => "5sizE",
"incisait" => "5sizE",
"incisant" => "5siz@",
"incise" => "5siz",
"incisé" => "5size",
"incisée" => "5size",
"incisées" => "5size",
"inciser" => "5size",
"incisera" => "5siz°Ra",
"incises" => "5siz",
"incisés" => "5size",
"incisez" => "5size",
"incisif" => "5sizif",
"incisifs" => "5sizif",
"incision" => "5sizj§",
"incisions" => "5sizj§",
"incisive" => "5siziv",
"incisives" => "5siziv",
"incita" => "5sita",
"incitaient" => "5sitE",
"incitait" => "5sitE",
"incitant" => "5sit@",
"incitateur" => "5sitat9R",
"incitatif" => "5sitatif",
"incitation" => "5sitasj§",
"incitatrice" => "5sitatRis",
"incite" => "5sit",
"incité" => "5site",
"incitée" => "5site",
"incitent" => "5sit",
"inciter" => "5site",
"incitera" => "5sit°Ra",
"inciterai" => "5sit°RE",
"inciteraient" => "5sit°RE",
"inciterais" => "5sit°RE",
"inciterait" => "5sit°RE",
"incitèrent" => "5sitER",
"inciteront" => "5sit°R§",
"incités" => "5site",
"incitez" => "5site",
"incitiez" => "5sitje",
"incivil" => "5sivil",
"incivils" => "5sivil",
"inclassable" => "5klasabl",
"inclassables" => "5klasabl",
"inclémence" => "5klem@s",
"inclémences" => "5klem@s",
"inclément" => "5klem@",
"inclémente" => "5klem@t",
"inclina" => "5klina",
"inclinable" => "5klinabl",
"inclinables" => "5klinabl",
"inclinai" => "5klinE",
"inclinaient" => "5klinE",
"inclinais" => "5klinE",
"inclinaison" => "5klinEz§",
"inclinaisons" => "5klinEz§",
"inclinait" => "5klinE",
"inclinant" => "5klin@",
"inclinante" => "5klin@t",
"inclinât" => "5klina",
"inclination" => "5klinasj§",
"inclinations" => "5klinasj§",
"incline" => "5klin",
"incliné" => "5kline",
"inclinée" => "5kline",
"inclinées" => "5kline",
"inclinent" => "5klin",
"incliner" => "5kline",
"inclinerai" => "5klin°RE",
"inclineraient" => "5klin°RE",
"inclinerais" => "5klin°RE",
"inclinerait" => "5klin°RE",
"inclineras" => "5klin°Ra",
"inclinèrent" => "5klinER",
"inclinerez" => "5klin°Re",
"inclineront" => "5klin°R§",
"inclinés" => "5kline",
"inclinez" => "5kline",
"inclinions" => "5klinj§",
"inclinomètre" => "5klinomEtR",
"inclinons" => "5klin§",
"incluais" => "5klyE",
"incluait" => "5klyE",
"incluant" => "5kly@",
"inclue" => "5kly",
"incluent" => "5kly",
"incluez" => "5klye",
"incluons" => "5kly§",
"inclura" => "5klyRa",
"inclurai" => "5klyRE",
"inclurait" => "5klyRE",
"inclure" => "5klyR",
"inclus" => "5kly",
"incluse" => "5klyz",
"incluses" => "5klyz",
"inclusion" => "5klyzj§",
"inclusive" => "5klyziv",
"inclusivement" => "5klyziv°m@",
"inclut" => "5kly",
"incoercible" => "5koERsibl",
"incoerciblement" => "5kOERsibl2m@",
"incoercibles" => "5koERsibl",
"incognito" => "5koNito",
"incognitos" => "5koNito",
"incohérence" => "5koeR@s",
"incohérences" => "5koeR@s",
"incohérent" => "5koeR@",
"incohérente" => "5koeR@t",
"incohérentes" => "5koeR@t",
"incohérents" => "5koeR@",
"incoiffables" => "5kwafabl",
"incollable" => "5kolabl",
"incolore" => "5kolOR",
"incolores" => "5kolOR",
"incombaient" => "5k§bE",
"incombait" => "5k§bE",
"incombant" => "5k§b@",
"incombe" => "5k§b",
"incombent" => "5k§b",
"incomber" => "5k§be",
"incombera" => "5k§b°Ra",
"incomberait" => "5k§b°RE",
"incombèrent" => "5k§bER",
"incombustible" => "5k§bystibl",
"incombustibles" => "5k§bystibl",
"incomestible" => "5komEstibl",
"incommensurable" => "5kom@syRabl",
"incommensurablement" => "5kom@syRabl°m@",
"incommensurables" => "5kom@syRabl",
"incommodait" => "5komodE",
"incommodant" => "5kOmOd@",
"incommodante" => "5komod@t",
"incommodantes" => "5komod@t",
"incommode" => "5komOd",
"incommodé" => "5komode",
"incommodée" => "5komode",
"incommodées" => "5komode",
"incommoder" => "5komode",
"incommodera" => "5komod°Ra",
"incommoderai" => "5komod°RE",
"incommodes" => "5komOd",
"incommodés" => "5komode",
"incommodez" => "5komode",
"incommodité" => "5komodite",
"incommodités" => "5komodite",
"incommunicabilité" => "5komynikabilite",
"incommunicable" => "5komynikabl",
"incommunicables" => "5komynikabl",
"incomparable" => "5k§paRabl",
"incomparablement" => "5k§paRabl°m@",
"incomparables" => "5k§paRabl",
"incompatibilité" => "5k§patibilite",
"incompatibilités" => "5k§patibilite",
"incompatible" => "5k§patibl",
"incompatibles" => "5k§patibl",
"incompétence" => "5k§pet@s",
"incompétences" => "5k§pet@s",
"incompétent" => "5k§pet@",
"incompétente" => "5k§pet@t",
"incompétents" => "5k§pet@",
"incomplet" => "5k§plE",
"incomplète" => "5k§plEt",
"incomplètement" => "5k§plEt°m@",
"incomplètes" => "5k§plEt",
"incomplets" => "5k§plE",
"incomplétude" => "5k§pletyd",
"incompréhensible" => "5k§pRe@sibl",
"incompréhensiblement" => "5k§pRe@sibl2m@",
"incompréhensibles" => "5k§pRe@sibl",
"incompréhensif" => "5k§pRe@sif",
"incompréhensifs" => "5k§pRe@sif",
"incompréhension" => "5k§pRe@sj§",
"incompréhensions" => "5k§pRe@sj§",
"incompressible" => "5k§pResibl",
"incompris" => "5k§pRi",
"incomprise" => "5k§pRiz",
"incomprises" => "5k§pRiz",
"inconcevable" => "5k§s°vabl",
"inconcevablement" => "5k§s°vabl°m@",
"inconcevables" => "5k§s°vabl",
"inconciliable" => "5k§siljabl",
"inconciliables" => "5k§siljabl",
"inconditionné" => "5k§disjone",
"inconditionnée" => "5k§disjone",
"inconditionnel" => "5k§disjonEl",
"inconditionnelle" => "5k§disjonEl",
"inconditionnellement" => "5k§disjonEl°m@",
"inconditionnelles" => "5k§disjonEl",
"inconditionnels" => "5k§disjonEl",
"inconduite" => "5k§d8it",
"inconfiance" => "5k§fj@s",
"inconfort" => "5k§fOR",
"inconfortable" => "5k§fORtabl",
"inconfortablement" => "5k§fORtabl°m@",
"inconfortables" => "5k§fORtabl",
"incongelables" => "5k§Z°labl",
"incongru" => "5k§gRy",
"incongrue" => "5k§gRy",
"incongrues" => "5k§gRy",
"incongruité" => "5k§gR8ite",
"incongruités" => "5k§gR8ite",
"incongrus" => "5k§gRy",
"inconnaissable" => "5konEsabl",
"inconnaissance" => "5konEs@s",
"inconnu" => "5kony",
"inconnue" => "5kony",
"inconnues" => "5kony",
"inconnus" => "5kony",
"inconsciemment" => "5k§sjam@",
"inconscience" => "5k§sj@s",
"inconsciences" => "5k§sj@s",
"inconscient" => "5k§sj@",
"inconsciente" => "5k§sj@t",
"inconscientes" => "5k§sj@t",
"inconscients" => "5k§sj@",
"inconséquence" => "5k§sek@s",
"inconséquences" => "5k§sek@s",
"inconséquent" => "5k§sek@",
"inconséquente" => "5k§sek@t",
"inconséquents" => "5k§sek@",
"inconsidéré" => "5k§sideRe",
"inconsidérée" => "5k§sideRe",
"inconsidérées" => "5k§sideRe",
"inconsidérément" => "5k§sideRem@",
"inconsidérés" => "5k§sideRe",
"inconsistance" => "5k§sist@s",
"inconsistant" => "5k§sist@",
"inconsistante" => "5k§sist@t",
"inconsistantes" => "5k§sist@t",
"inconsistants" => "5k§sist@",
"inconsolable" => "5k§solabl",
"inconsolables" => "5k§solabl",
"inconsolé" => "5k§sole",
"inconsolée" => "5k§sole",
"inconsolées" => "5k§sole",
"inconsolés" => "5k§sole",
"inconsommable" => "5k§somabl",
"inconstance" => "5k§st@s",
"inconstant" => "5k§st@",
"inconstante" => "5k§st@t",
"inconstants" => "5k§st@",
"inconstitutionnel" => "5k§stitysjonEl",
"inconstitutionnelle" => "5k§stitysjonEl",
"inconstructibles" => "5k§stRyktibl",
"incontestable" => "5k§tEstabl",
"incontestablement" => "5k§tEstabl°m@",
"incontestables" => "5k§tEstabl",
"incontesté" => "5k§tEste",
"incontestée" => "5k§tEste",
"incontestés" => "5k§tEste",
"incontinence" => "5k§tin@s",
"incontinences" => "5k§tin@s",
"incontinent" => "5k§tin@",
"incontinente" => "5k§tin@t",
"incontinentes" => "5k§tin@t",
"incontinents" => "5k§tin@",
"incontournable" => "5k§tuRnabl",
"incontournables" => "5k§tuRnabl",
"incontrôlable" => "5k§tRolabl",
"incontrôlables" => "5k§tRolabl",
"incontrôlé" => "5k§tRole",
"incontrôlée" => "5k§tRole",
"incontrôlées" => "5k§tRole",
"incontrôlés" => "5k§tRole",
"inconvenance" => "5k§v°n@s",
"inconvenances" => "5k§v°n@s",
"inconvenant" => "5k§v°n@",
"inconvenante" => "5k§v°n@t",
"inconvenantes" => "5k§v°n@t",
"inconvenants" => "5k§v°n@",
"inconvénient" => "5k§venj@",
"inconvénients" => "5k§venj@",
"inconvertible" => "5k§vERtibl",
"inconvertissable" => "5k§vERtisabl",
"incoordination" => "5koORdinasj§",
"incorpora" => "5kORpoRa",
"incorporable" => "5kORpoRabl",
"incorporaient" => "5kORpoRE",
"incorporait" => "5kORpoRE",
"incorporant" => "5kORpoR@",
"incorporation" => "5kORpoRasj§",
"incorporations" => "5kORpoRasj§",
"incorpore" => "5kORpOR",
"incorporé" => "5kORpoRe",
"incorporée" => "5kORpoRe",
"incorporées" => "5kORpoRe",
"incorporel" => "5kORpoREl",
"incorporelle" => "5kORpoREl",
"incorporelles" => "5kORpoREl",
"incorporent" => "5kORpOR",
"incorporer" => "5kORpoRe",
"incorporés" => "5kORpoRe",
"incorporez" => "5kORpoRe",
"incorrect" => "5koREkt",
"incorrecte" => "5koREkt",
"incorrectement" => "5koREkt°m@",
"incorrection" => "5koREksj§",
"incorrects" => "5koREkt",
"incorrigible" => "5koRiZibl",
"incorrigiblement" => "5koRiZibl°m@",
"incorrigibles" => "5koRiZibl",
"incorruptibilité" => "5koRyptibilite",
"incorruptible" => "5koRyptibl",
"incorruptibles" => "5koRyptibl",
"incrédibilité" => "5kRedibilite",
"incrédule" => "5kRedyl",
"incrédules" => "5kRedyl",
"incrédulité" => "5kRedylite",
"incréé" => "5kRee",
"incréée" => "5kRee",
"increvable" => "5kR°vabl",
"increvables" => "5kR°vabl",
"incrimina" => "5kRimina",
"incriminant" => "5kRimin@",
"incrimination" => "5kRiminasj§",
"incrimine" => "5kRimin",
"incriminé" => "5kRimine",
"incriminée" => "5kRimine",
"incriminées" => "5kRimine",
"incriminent" => "5kRimin",
"incriminer" => "5kRimine",
"incrochetable" => "5kROS°tabl",
"incroyable" => "5kRwajabl",
"incroyablement" => "5kRwajabl°m@",
"incroyables" => "5kRwajabl",
"incroyance" => "5kRwaj@s",
"incroyant" => "5kRwaj@",
"incroyante" => "5kRwaj@t",
"incroyants" => "5kRwaj@",
"incrusta" => "5kRysta",
"incrustaient" => "5kRystE",
"incrustais" => "5kRystE",
"incrustait" => "5kRystE",
"incrustant" => "5kRyst@",
"incrustation" => "5kRystasj§",
"incrustations" => "5kRystasj§",
"incruste" => "5kRyst",
"incrusté" => "5kRyste",
"incrustée" => "5kRyste",
"incrustées" => "5kRyste",
"incrustent" => "5kRyst",
"incruster" => "5kRyste",
"incrusterait" => "5kRyst°RE",
"incrustèrent" => "5kRystER",
"incrustés" => "5kRyste",
"incrustez" => "5kRyste",
"incubateur" => "5kybat9R",
"incubateurs" => "5kybat9R",
"incubation" => "5kybasj§",
"incube" => "5kyb",
"incubé" => "5kybe",
"incuber" => "5kybe",
"incubes" => "5kyb",
"inculcation" => "5kylkasj§",
"inculpa" => "5kylpa",
"inculpant" => "5kylp@",
"inculpation" => "5kylpasj§",
"inculpations" => "5kylpasj§",
"inculpe" => "5kylp",
"inculpé" => "5kylpe",
"inculpée" => "5kylpe",
"inculpent" => "5kylp",
"inculper" => "5kylpe",
"inculpera" => "5kylp°Ra",
"inculperai" => "5kylp°RE",
"inculperais" => "5kylp°RE",
"inculperont" => "5kylp°R§",
"inculpés" => "5kylpe",
"inculpez" => "5kylpe",
"inculpons" => "5kylp§",
"inculqua" => "5kylka",
"inculquait" => "5kylkE",
"inculquant" => "5kylk@",
"inculquât" => "5kylka",
"inculque" => "5kylk",
"inculqué" => "5kylke",
"inculquée" => "5kylke",
"inculquées" => "5kylke",
"inculquent" => "5kylk",
"inculquer" => "5kylke",
"inculqués" => "5kylke",
"inculquons" => "5kylk§",
"inculte" => "5kylt",
"incultes" => "5kylt",
"incultivable" => "5kyltivabl",
"incultivables" => "5kyltivabl",
"inculture" => "5kyltyR",
"incunables" => "5kynabl",
"incurable" => "5kyRabl",
"incurablement" => "5kyRabl°m@",
"incurables" => "5kyRabl",
"incurie" => "5kyRi",
"incurieux" => "5kyRj2",
"incuriosité" => "5kyRjozite",
"incursion" => "5kyRsj§",
"incursions" => "5kyRsj§",
"incurvaient" => "5kyRvE",
"incurvait" => "5kyRvE",
"incurvant" => "5kyRv@",
"incurvation" => "5kyRvasj§",
"incurve" => "5kyRv",
"incurvé" => "5kyRve",
"incurvée" => "5kyRve",
"incurvées" => "5kyRve",
"incurvent" => "5kyRv",
"incurver" => "5kyRve",
"incurvèrent" => "5kyRvER",
"incurvés" => "5kyRve",
"incus" => "5ky",
"indansable" => "5d@sabl",
"inde" => "5d",
"indécelable" => "5des°labl",
"indécelables" => "5des°labl",
"indécemment" => "5desam@",
"indécence" => "5des@s",
"indécences" => "5des@s",
"indécent" => "5des@",
"indécente" => "5des@t",
"indécentes" => "5des@t",
"indécents" => "5des@",
"indéchiffrable" => "5deSifRabl",
"indéchiffrables" => "5deSifRabl",
"indéchirable" => "5deSiRabl",
"indéchirables" => "5deSiRabl",
"indécidable" => "5desidabl",
"indécidables" => "5desidabl",
"indécis" => "5desi",
"indécise" => "5desiz",
"indécises" => "5desiz",
"indécision" => "5desizj§",
"indécisions" => "5desizj§",
"indécodable" => "5dekOdabl",
"indécollable" => "5dekolabl",
"indécollables" => "5dekolabl",
"indécrassables" => "5dekRasabl",
"indécrottable" => "5dekRotabl",
"indécrottablement" => "5dekROtabl2m@",
"indécrottables" => "5dekRotabl",
"indéfectible" => "5defEktibl",
"indéfectiblement" => "5defEktibl°m@",
"indéfectibles" => "5defEktibl",
"indéfendable" => "5def@dabl",
"indéfini" => "5defini",
"indéfinie" => "5defini",
"indéfinies" => "5defini",
"indéfiniment" => "5definim@",
"indéfinis" => "5defini",
"indéfinissable" => "5definisabl",
"indéfinissablement" => "5definisabl2m@",
"indéfinissables" => "5definisabl",
"indéfinition" => "5definisj§",
"indéformables" => "5defORmabl",
"indéfriché" => "5defRiSe",
"indéfrisable" => "5defRizabl",
"indéfrisables" => "5defRizabl",
"indélébile" => "5delebil",
"indélébiles" => "5delebil",
"indélicat" => "5delika",
"indélicate" => "5delikat",
"indélicatesse" => "5delikatEs",
"indélicatesses" => "5delikatEs",
"indélicats" => "5delika",
"indélivrable" => "5delivRabl",
"indélogeable" => "5deloZabl",
"indélogeables" => "5deloZabl",
"indémaillable" => "5demajabl",
"indémaillables" => "5demajabl",
"indémêlables" => "5demElabl",
"indemne" => "5dEmn",
"indemnes" => "5dEmn",
"indemnisable" => "5dEmnizabl",
"indemnisation" => "5dEmnizasj§",
"indemnisations" => "5dEmnizasj§",
"indemnise" => "5dEmniz",
"indemnisé" => "5dEmnize",
"indemniser" => "5dEmnize",
"indemniserai" => "5dEmniz°RE",
"indemniseraient" => "5dEmniz°RE",
"indemnisés" => "5dEmnize",
"indemnisez" => "5dEmnize",
"indemnité" => "5dEmnite",
"indemnités" => "5dEmnite",
"indemnités-repas" => "5dEmniteR°pa",
"indémodable" => "5demodabl",
"indémodables" => "5demodabl",
"indémontrable" => "5dem§tRabl",
"indémontrables" => "5dem§tRabl",
"indéniable" => "5denjabl",
"indéniablement" => "5denjabl°m@",
"indéniables" => "5denjabl",
"indénombrables" => "5den§bRabl",
"indénouable" => "5denuabl",
"indentation" => "5d@tasj§",
"indenté" => "5d@te",
"indenter" => "5d@te",
"indentification" => "5d@tifikasj§",
"indépassable" => "5depasabl",
"indépendamment" => "5dep@dam@",
"indépendance" => "5dep@d@s",
"indépendant" => "5dep@d@",
"indépendante" => "5dep@d@t",
"indépendantes" => "5dep@d@t",
"indépendantisme" => "5dep@d@tism",
"indépendantiste" => "5dep@d@tist",
"indépendantistes" => "5dep@d@tist",
"indépendants" => "5dep@d@",
"indéracinable" => "5deRasinabl",
"indéracinables" => "5deRasinabl",
"indéréglables" => "5deReglabl",
"indes" => "5d",
"indescriptible" => "5dEskRiptibl",
"indescriptiblement" => "5dEskRiptibl2m@",
"indescriptibles" => "5dEskRiptibl",
"indésirable" => "5deziRabl",
"indésirables" => "5deziRabl",
"indestructibilité" => "5dEstRyktibilite",
"indestructible" => "5dEstRyktibl",
"indestructibles" => "5dEstRyktibl",
"indétectable" => "5detEktabl",
"indétectables" => "5detEktabl",
"indéterminable" => "5detERminabl",
"indétermination" => "5detERminasj§",
"indéterminé" => "5detERmine",
"indéterminée" => "5detERmine",
"indéterminées" => "5detERmine",
"indéterminés" => "5detERmine",
"index" => "5dEks",
"indexation" => "5dEksasj§",
"indexé" => "5dEkse",
"indexée" => "5dEkse",
"indexer" => "5dEkse",
"indexeur" => "5dEks9R",
"indianisés" => "5djanize",
"indic" => "5dik",
"indicateur" => "5dikat9R",
"indicateurs" => "5dikat9R",
"indicatif" => "5dikatif",
"indicatifs" => "5dikatif",
"indication" => "5dikasj§",
"indications" => "5dikasj§",
"indicatrice" => "5dikatRis",
"indicatrices" => "5dikatRis",
"indice" => "5dis",
"indices" => "5dis",
"indiciaire" => "5disjER",
"indiciaires" => "5disjER",
"indicible" => "5disibl",
"indiciblement" => "5disibl°m@",
"indicibles" => "5disibl",
"indics" => "5dik",
"indien" => "5dj5",
"indienne" => "5djEn",
"indienneries" => "5djEn°Ri",
"indiennes" => "5djEn",
"indiens" => "5dj5",
"indifféraient" => "5difeRE",
"indifférait" => "5difeRE",
"indiffère" => "5difER",
"indifféré" => "5difeRe",
"indifféremment" => "5difeRam@",
"indifférence" => "5difeR@s",
"indifférences" => "5difeR@s",
"indifférenciation" => "5difeR@sjasj§",
"indifférencié" => "5difeR@sje",
"indifférenciée" => "5difeR@sje",
"indifférenciés" => "5difeR@sje",
"indifférent" => "5difeR@",
"indiffèrent" => "5difER",
"indifférente" => "5difeR@t",
"indifférentes" => "5difeR@t",
"indifférentisme" => "5difeR@tizm",
"indifférents" => "5difeR@",
"indiffères" => "5difER",
"indigence" => "5diZ@s",
"indigène" => "5diZEn",
"indigènes" => "5diZEn",
"indigent" => "5diZ@",
"indigente" => "5diZ@t",
"indigentes" => "5diZ@t",
"indigents" => "5diZ@",
"indigeste" => "5diZEst",
"indigestes" => "5diZEst",
"indigestion" => "5diZEstj§",
"indigestionner" => "5diZEstjOne",
"indigestions" => "5diZEstj§",
"indigna" => "5diNa",
"indignai" => "5diNE",
"indignaient" => "5diNE",
"indignais" => "5diNE",
"indignait" => "5diNE",
"indignant" => "5diN@",
"indignassent" => "5diNas",
"indignation" => "5diNasj§",
"indignations" => "5diNasj§",
"indigne" => "5diN",
"indigné" => "5diNe",
"indignée" => "5diNe",
"indignées" => "5diNe",
"indignement" => "5diN°m@",
"indignent" => "5diN",
"indigner" => "5diNe",
"indignera" => "5diN°Ra",
"indignèrent" => "5diNER",
"indignes" => "5diN",
"indignés" => "5diNe",
"indignité" => "5diNite",
"indignités" => "5diNite",
"indigo" => "5digo",
"indiqua" => "5dika",
"indiquai" => "5dikE",
"indiquaient" => "5dikE",
"indiquais" => "5dikE",
"indiquait" => "5dikE",
"indiquant" => "5dik@",
"indiquât" => "5dika",
"indique" => "5dik",
"indiqué" => "5dike",
"indiquée" => "5dike",
"indiquées" => "5dike",
"indiquent" => "5dik",
"indiquer" => "5dike",
"indiquera" => "5dik°Ra",
"indiquerai" => "5dik°RE",
"indiqueraient" => "5dik°RE",
"indiquerais" => "5dik°RE",
"indiquerait" => "5dik°RE",
"indiqueras" => "5dik°Ra",
"indiquèrent" => "5dikER",
"indiquerez" => "5dik°Re",
"indiqueriez" => "5dik°Rje",
"indiquerons" => "5dik°R§",
"indiqués" => "5dike",
"indiquez" => "5dike",
"indiquiez" => "5dikje",
"indiquions" => "5dikj§",
"indiquons" => "5dik§",
"indirect" => "5diREkt",
"indirecte" => "5diREkt",
"indirectement" => "5diREkt°m@",
"indirectes" => "5diREkt",
"indirects" => "5diREkt",
"indiscernable" => "5disERnabl",
"indiscernables" => "5disERnabl",
"indiscipline" => "5disiplin",
"indiscipliné" => "5disipline",
"indisciplinée" => "5disipline",
"indisciplinées" => "5disipline",
"indisciplinés" => "5disipline",
"indiscret" => "5diskRE",
"indiscrète" => "5diskREt",
"indiscrètement" => "5diskREt°m@",
"indiscrètes" => "5diskREt",
"indiscrétion" => "5diskResj§",
"indiscrétions" => "5diskResj§",
"indiscrets" => "5diskRE",
"indiscutable" => "5diskytabl",
"indiscutablement" => "5diskytabl°m@",
"indiscutables" => "5diskytabl",
"indiscuté" => "5diskyte",
"indiscutée" => "5diskyte",
"indiscutés" => "5diskyte",
"indispensable" => "5disp@sabl",
"indispensables" => "5disp@sabl",
"indisponibilité" => "5dispOnibilite",
"indisponible" => "5disponibl",
"indisponibles" => "5disponibl",
"indisposa" => "5dispoza",
"indisposaient" => "5dispozE",
"indisposait" => "5dispozE",
"indispose" => "5dispoz",
"indisposé" => "5dispoze",
"indisposée" => "5dispoze",
"indisposent" => "5dispoz",
"indisposer" => "5dispoze",
"indisposerait" => "5dispoz°RE",
"indisposèrent" => "5dispozER",
"indisposés" => "5dispoze",
"indisposition" => "5dispozisj§",
"indisposons" => "5dispoz§",
"indissociable" => "5disosjabl",
"indissociables" => "5disosjabl",
"indissociés" => "5disosje",
"indissoluble" => "5disolybl",
"indissolublement" => "5disolybl°m@",
"indissolubles" => "5disolybl",
"indistinct" => "5dist5",
"indistincte" => "5dist5kt",
"indistinctement" => "5dist5kt°m@",
"indistinctes" => "5dist5kt",
"indistinction" => "5dist5ksj§",
"indistincts" => "5dist5",
"individu" => "5dividy",
"individualisé" => "5divid8alize",
"individualiser" => "5divid8alize",
"individualisés" => "5divid8alize",
"individualisme" => "5divid8alizm",
"individualiste" => "5divid8alist",
"individualistes" => "5divid8alist",
"individualité" => "5divid8alite",
"individualités" => "5divid8alite",
"individuée" => "5divid8e",
"individuel" => "5divid8El",
"individuelle" => "5divid8El",
"individuellement" => "5divid8El°m@",
"individuelles" => "5divid8El",
"individuels" => "5divid8El",
"individus" => "5dividy",
"indivis" => "5divi",
"indivisé" => "5divize",
"indivises" => "5diviz",
"indivisibilité" => "5divizibilite",
"indivisible" => "5divizibl",
"indivisibles" => "5divizibl",
"indivision" => "5divizj§",
"indo" => "5do",
"indo-européen" => "5dO2ROpe5",
"indo-européenne" => "5do2RopeEn",
"indo-européennes" => "5do2RopeEn",
"indo-européens" => "5do2Rope5",
"indochinois" => "5doSinwa",
"indochinoise" => "5doSinwaz",
"indochinoises" => "5doSinwaz",
"indocile" => "5dosil",
"indocilité" => "5dosilite",
"indole" => "5dOl",
"indolemment" => "5dolam@",
"indolence" => "5dol@s",
"indolences" => "5dol@s",
"indolent" => "5dol@",
"indolente" => "5dol@t",
"indolentes" => "5dol@t",
"indolents" => "5dol@",
"indolore" => "5dolOR",
"indolores" => "5dolOR",
"indomptable" => "5d§tabl",
"indomptables" => "5d§tabl",
"indompté" => "5d§te",
"indomptée" => "5d§te",
"indomptés" => "5d§te",
"indonésien" => "5donezj5",
"indonésienne" => "5donezjEn",
"indonésiens" => "5donezj5",
"indoor" => "indOR",
"indosable" => "5dozabl",
"indou" => "5du",
"indous" => "5du",
"indu" => "5dy",
"indubitable" => "5dybitabl",
"indubitablement" => "5dybitabl°m@",
"indubitables" => "5dybitabl",
"inducteur" => "5dykt9R",
"inductif" => "5dyktif",
"induction" => "5dyksj§",
"inductions" => "5dyksj§",
"inductive" => "5dyktiv",
"inductrice" => "5dyktRis",
"indue" => "5dy",
"indues" => "5dy",
"induiraient" => "5d8iRE",
"induirait" => "5d8iRE",
"induire" => "5d8iR",
"induis" => "5d8i",
"induisaient" => "5d8izE",
"induisait" => "5d8izE",
"induisant" => "5d8iz@",
"induisez" => "5d8ize",
"induisit" => "5d8izi",
"induit" => "5d8i",
"induite" => "5d8it",
"induits" => "5d8i",
"indulgence" => "5dylZ@s",
"indulgences" => "5dylZ@s",
"indulgent" => "5dylZ@",
"indulgente" => "5dylZ@t",
"indulgentes" => "5dylZ@t",
"indulgents" => "5dylZ@",
"indûment" => "5dym@",
"induré" => "5dyRe",
"indurée" => "5dyRe",
"indurées" => "5dyRe",
"indus" => "5dy",
"industrialisation" => "5dystRijalizasj§",
"industrialisé" => "5dystRijalize",
"industrialisée" => "5dystRijalize",
"industrialiser" => "5dystRijalize",
"industrialisés" => "5dystRijalize",
"industrie" => "5dystRi",
"industrie-clé" => "5dystRikle",
"industriel" => "5dystRijEl",
"industrielle" => "5dystRijEl",
"industriellement" => "5dystRijEl°m@",
"industrielles" => "5dystRijEl",
"industriels" => "5dystRijEl",
"industries" => "5dystRi",
"industrieuse" => "5dystRij2z",
"industrieusement" => "5dystRij2z°m@",
"industrieuses" => "5dystRij2z",
"industrieux" => "5dystRij2",
"inébranlable" => "inebR@labl",
"inébranlablement" => "inebR@labl°m@",
"inébranlables" => "inebR@labl",
"inébranlé" => "inebR@le",
"inéchangeable" => "ineS@Zabl",
"inécoutée" => "inekute",
"inédit" => "inedi",
"inédite" => "inedit",
"inédites" => "inedit",
"inédits" => "inedi",
"inéducable" => "inedykabl",
"ineffable" => "inefabl",
"ineffablement" => "inefabl°m@",
"ineffables" => "inEfabl",
"ineffaçable" => "inefasabl",
"ineffaçablement" => "inefasabl°m@",
"ineffaçables" => "inEfasabl",
"inefficace" => "inefikas",
"inefficaces" => "inefikas",
"inefficacité" => "inefikasite",
"inégal" => "inegal",
"inégalable" => "inegalabl",
"inégalables" => "inegalabl",
"inégale" => "inegal",
"inégalé" => "inegale",
"inégalée" => "inegale",
"inégalées" => "inegale",
"inégalement" => "inegal°m@",
"inégales" => "inegal",
"inégalité" => "inegalite",
"inégalités" => "inegalite",
"inégaux" => "inego",
"inélégamment" => "inelegam@",
"inélégance" => "ineleg@s",
"inélégant" => "ineleg@",
"inélégantes" => "ineleg@t",
"inéligibilité" => "ineliZibilite",
"inéligible" => "ineliZibl",
"inéluctabilité" => "inelyktabilite",
"inéluctable" => "inelyktabl",
"inéluctablement" => "inelyktabl°m@",
"inéluctables" => "inelyktabl",
"inemploi" => "in@plwa",
"inemployable" => "in@plwajabl",
"inemployables" => "in@plwajabl",
"inemployé" => "in@plwaje",
"inemployée" => "in@plwaje",
"inemployées" => "in@plwaje",
"inemployés" => "in@plwaje",
"inénarrable" => "inenaRabl",
"inénarrables" => "inenaRabl",
"inentamable" => "in@tamabl",
"inentamé" => "in@tame",
"inentamée" => "in@tame",
"inentamées" => "in@tame",
"inenvisageable" => "in@vizaZabl",
"inepte" => "inEpt",
"ineptement" => "inEpt2m@",
"ineptes" => "inEpt",
"ineptie" => "inEpsi",
"inepties" => "inEpsi",
"inépuisable" => "inep8izabl",
"inépuisablement" => "inep8izabl°m@",
"inépuisables" => "inep8izabl",
"inépuisées" => "inep8ize",
"inéquitable" => "inekitabl",
"inerte" => "inERt",
"inertes" => "inERt",
"inertie" => "inERsi",
"inertiel" => "inERsjEl",
"inertielle" => "inERsjEl",
"inerties" => "inERti",
"inespérable" => "inEspeRabl",
"inespéré" => "inEspeRe",
"inespérée" => "inEspeRe",
"inespérées" => "inEspeRe",
"inespérément" => "inEspeRem@",
"inespoir" => "inEspwaR",
"inessentiel" => "inEs@sjEl",
"inesthétique" => "inEstetik",
"inesthétiques" => "inEstetik",
"inestimable" => "inEstimabl",
"inestimables" => "inEstimabl",
"inévaluable" => "ineval8abl",
"inévitabilité" => "inevitabilite",
"inévitable" => "inevitabl",
"inévitablement" => "inevitabl°m@",
"inévitables" => "inevitabl",
"inexact" => "inEgzakt",
"inexacte" => "inEgzakt",
"inexactement" => "inEgzakt°m@",
"inexactes" => "inEgzakt",
"inexactitude" => "inEgzaktityd",
"inexactitudes" => "inEgzaktityd",
"inexacts" => "inEgzakt",
"inexcusable" => "inEkskyzabl",
"inexcusables" => "inEkskyzabl",
"inexistant" => "inEgzist@",
"inexistante" => "inEgzist@t",
"inexistantes" => "inEgzist@t",
"inexistants" => "inEgzist@",
"inexistence" => "inEgzist@s",
"inexorabilité" => "inEgzoRabilite",
"inexorable" => "inEgzoRabl",
"inexorablement" => "inEgzoRabl°m@",
"inexorables" => "inEgzoRabl",
"inexpérience" => "inEkspeRj@s",
"inexpériences" => "inEkspeRj@s",
"inexpérimenté" => "inEkspeRim@te",
"inexpérimentée" => "inEkspeRim@te",
"inexpérimentées" => "inEkspeRim@te",
"inexpérimentés" => "inEkspeRim@te",
"inexperte" => "inEkspERt",
"inexpiable" => "inEkspjabl",
"inexplicable" => "inEksplikabl",
"inexplicablement" => "inEksplikabl°m@",
"inexplicables" => "inEksplikabl",
"inexpliqué" => "inEksplike",
"inexpliquée" => "inEksplike",
"inexpliquées" => "inEksplike",
"inexpliqués" => "inEksplike",
"inexploitable" => "inEksplwatabl",
"inexploité" => "inEksplwate",
"inexploitée" => "inEksplwate",
"inexploitées" => "inEksplwate",
"inexploités" => "inEksplwate",
"inexploré" => "inEksploRe",
"inexplorée" => "inEksploRe",
"inexplorées" => "inEksploRe",
"inexplorés" => "inEksploRe",
"inexplosible" => "inEksplozibl",
"inexplosibles" => "inEksplozibl",
"inexpressif" => "inEkspResif",
"inexpressifs" => "inEkspResif",
"inexpression" => "inEkspREsj§",
"inexpressive" => "inEkspResiv",
"inexpressives" => "inEkspResiv",
"inexprimable" => "inEkspRimabl",
"inexprimablement" => "inEkspRimabl2m@",
"inexprimables" => "inEkspRimabl",
"inexprimé" => "inEkspRime",
"inexprimée" => "inEkspRime",
"inexpugnable" => "inEkspyNabl",
"inexpugnablement" => "inEkspyNabl2m@",
"inexpugnables" => "inEkspyNabl",
"inextinguible" => "inEkst5gibl",
"inextinguibles" => "inEkst5gibl",
"inextirpable" => "inEkstiRpabl",
"inextricable" => "inEkstRikabl",
"inextricablement" => "inEkstRikabl°m@",
"inextricables" => "inEkstRikabl",
"infaillibilité" => "5fajibilite",
"infaillible" => "5fajibl",
"infailliblement" => "5fajibl°m@",
"infaillibles" => "5fajibl",
"infaisable" => "5f°zabl",
"infalsifiable" => "5falsifjabl",
"infamant" => "5fam@",
"infamante" => "5fam@t",
"infamantes" => "5fam@t",
"infamants" => "5fam@",
"infâme" => "5fam",
"infâmes" => "5fam",
"infamie" => "5fami",
"infamies" => "5fami",
"infant" => "5f@",
"infante" => "5f@t",
"infanterie" => "5f@t°Ri",
"infanteries" => "5f@t°Ri",
"infantes" => "5f@t",
"infanticide" => "5f@tisid",
"infanticides" => "5f@tisid",
"infantile" => "5f@til",
"infantilement" => "5f@til°m@",
"infantiles" => "5f@til",
"infantilisé" => "5f@tilize",
"infantiliser" => "5f@tilize",
"infantilisme" => "5f@tilizm",
"infantilismes" => "5f@tilizm",
"infants" => "5f@",
"infarctus" => "5faRktys",
"infatigable" => "5fatigabl",
"infatigablement" => "5fatigabl°m@",
"infatigables" => "5fatigabl",
"infatuation" => "5fat8asj§",
"infatué" => "5fat8e",
"infatuer" => "@fat8e",
"infatués" => "5fat8e",
"inféconde" => "5fek§d",
"infécondes" => "5fek§d",
"infécondité" => "5fek§dite",
"infect" => "5fEkt",
"infectaient" => "5fEktE",
"infectait" => "5fEktE",
"infectant" => "5fEkt@",
"infectassent" => "5fEktas",
"infecte" => "5fEkt",
"infecté" => "5fEkte",
"infectée" => "5fEkte",
"infectées" => "5fEkte",
"infectement" => "5fEkt2m@",
"infectent" => "5fEkt",
"infecter" => "5fEkte",
"infectera" => "5fEkt°Ra",
"infectes" => "5fEkt",
"infectés" => "5fEkte",
"infectez" => "5fEkte",
"infectieuse" => "5fEksj2z",
"infectieuses" => "5fEksj2z",
"infectieux" => "5fEksj2",
"infectiologie" => "5fEksjOlOZi",
"infection" => "5fEksj§",
"infections" => "5fEksj§",
"infects" => "5fEkt",
"inféode" => "5feOd",
"inféodée" => "5feode",
"inféoder" => "5feode",
"inférai" => "5feRE",
"inféré" => "5feRe",
"inférer" => "5feRe",
"inférieur" => "5feRj9R",
"inférieure" => "5feRj9R",
"inférieures" => "5feRj9R",
"inférieurs" => "5feRj9R",
"inférioriser" => "5feRjoRize",
"infériorité" => "5feRjoRite",
"infériorités" => "5feRjoRite",
"infernal" => "5fERnal",
"infernale" => "5fERnal",
"infernalement" => "5fERnal°m@",
"infernales" => "5fERnal",
"infernaux" => "5fERno",
"infertile" => "5fERtil",
"infertiles" => "5fERtil",
"infertilité" => "5fERtilite",
"infestaient" => "5fEstE",
"infestait" => "5fEstE",
"infestant" => "5fEst@",
"infestât" => "5fEsta",
"infestation" => "5fEstasj§",
"infeste" => "5fEst",
"infesté" => "5fEste",
"infestée" => "5fEste",
"infestées" => "5fEste",
"infestent" => "5fEst",
"infester" => "5fEste",
"infestèrent" => "5fEstER",
"infesteront" => "5fEst°R§",
"infestés" => "5fEste",
"infibulation" => "5fibylasj§",
"infidèle" => "5fidEl",
"infidèles" => "5fidEl",
"infidélité" => "5fidelite",
"infidélités" => "5fidelite",
"infigurable" => "5figyRabl",
"infiltra" => "5filtRa",
"infiltraient" => "5filtRE",
"infiltrait" => "5filtRE",
"infiltrant" => "5filtR@",
"infiltrat" => "5filtRa",
"infiltration" => "5filtRasj§",
"infiltrations" => "5filtRasj§",
"infiltre" => "5filtR",
"infiltré" => "5filtRe",
"infiltrée" => "5filtRe",
"infiltrées" => "5filtRe",
"infiltrent" => "5filtR",
"infiltrer" => "5filtRe",
"infiltrera" => "5filtR°Ra",
"infiltrèrent" => "5filtRER",
"infiltreront" => "5filtR°R§",
"infiltrés" => "5filtRe",
"infiltrez" => "5filtRe",
"infiltriez" => "5filtRie",
"infiltrions" => "5filtRij§",
"infiltrons" => "5filtR§",
"infime" => "5fim",
"infimes" => "5fim",
"infini" => "5fini",
"infinie" => "5fini",
"infinies" => "5fini",
"infiniment" => "5finim@",
"infinis" => "5fini",
"infinité" => "5finite",
"infinités" => "5finite",
"infinitésimal" => "5finitezimal",
"infinitésimale" => "5finitezimal",
"infinitésimalement" => "5finitezimal°m@",
"infinitésimales" => "5finitezimal",
"infinitésimaux" => "5finitezimo",
"infinitif" => "5finitif",
"infinitifs" => "5finitif",
"infinitive" => "5finitiv",
"infinitude" => "5finityd",
"infirma" => "5fiRma",
"infirmait" => "5fiRmE",
"infirmant" => "5fiRm@",
"infirme" => "5fiRm",
"infirmé" => "5fiRme",
"infirment" => "5fiRm",
"infirmer" => "5fiRme",
"infirmerie" => "5fiRm°Ri",
"infirmeries" => "5fiRm°Ri",
"infirmeront" => "5fiRm°R§",
"infirmes" => "5fiRm",
"infirmier" => "5fiRmje",
"infirmière" => "5fiRmjER",
"infirmière-major" => "5fiRmjERmaZOR",
"infirmières" => "5fiRmjER",
"infirmiers" => "5fiRmje",
"infirmité" => "5fiRmite",
"infirmités" => "5fiRmite",
"inflammabilité" => "5flamabilite",
"inflammable" => "5flamabl",
"inflammables" => "5flamabl",
"inflammation" => "5flamasj§",
"inflammatoire" => "5flamatwaR",
"inflammatoires" => "5flamatwaR",
"inflation" => "5flasj§",
"inflationniste" => "5flasjonist",
"infléchi" => "5fleSi",
"infléchie" => "5fleSi",
"infléchies" => "5fleSi",
"infléchir" => "5fleSiR",
"infléchirai" => "5fleSiRE",
"infléchissaient" => "5fleSisE",
"infléchissant" => "5fleSis@",
"infléchissement" => "5fleSis°m@",
"infléchissent" => "5fleSis",
"infléchissez" => "5fleSise",
"infléchit" => "5fleSi",
"inflexibilité" => "5flEksibilite",
"inflexible" => "5flEksibl",
"inflexiblement" => "5flEksibl°m@",
"inflexibles" => "5flEksibl",
"inflexion" => "5flEksj§",
"inflexions" => "5flEksj§",
"infliction" => "5fliksj§",
"inflige" => "5fliZ",
"infligé" => "5fliZe",
"infligea" => "5fliZa",
"infligeaient" => "5fliZE",
"infligeais" => "5fliZE",
"infligeait" => "5fliZE",
"infligeâmes" => "5fliZam",
"infligeant" => "5fliZ@",
"infligée" => "5fliZe",
"infligées" => "5fliZe",
"infligent" => "5fliZ",
"infligeons" => "5fliZ§",
"infliger" => "5fliZe",
"infligera" => "5fliZ°Ra",
"infligerai" => "5fliZ°RE",
"infligeraient" => "5fliZ°RE",
"infligerais" => "5fliZ°RE",
"infligerait" => "5fliZ°RE",
"infligèrent" => "5fliZER",
"infligerez" => "5fliZ°Re",
"infligerions" => "5fliZ°Rj§",
"infliges" => "5fliZ",
"infligés" => "5fliZe",
"infligez" => "5fliZe",
"inflorescence" => "5floRes@s",
"inflorescences" => "5floRes@s",
"influaient" => "5flyE",
"influait" => "5flyE",
"influant" => "5fly@",
"influe" => "5fly",
"influé" => "5flye",
"influença" => "5fly@sa",
"influençable" => "5fly@sabl",
"influençables" => "5fly@sabl",
"influençaient" => "5fly@sE",
"influençait" => "5fly@sE",
"influençant" => "5fly@s@",
"influence" => "5fly@s",
"influencé" => "5fly@se",
"influencée" => "5fly@se",
"influencent" => "5fly@s",
"influencer" => "5fly@se",
"influencera" => "5fly@s°Ra",
"influencerait" => "5fly@s°RE",
"influencerez" => "5fly@s°Re",
"influenceriez" => "5fly@s°Rje",
"influenceront" => "5fly@s°R§",
"influences" => "5fly@s",
"influencés" => "5fly@se",
"influent" => "5fly@",
"influente" => "5fly@t",
"influentes" => "5fly@t",
"influents" => "5fly@",
"influenza" => "5fly@za",
"influer" => "5flye",
"influera" => "5flyRa",
"influeraient" => "5flyRE",
"influeront" => "5flyR§",
"influx" => "5fly",
"info" => "5fo",
"infographie" => "5fogRafi",
"infondé" => "5f§de",
"infondée" => "5f§de",
"infondées" => "5f§de",
"infondés" => "5f§de",
"informa" => "5fORma",
"informai" => "5fORmE",
"informaient" => "5fORmE",
"informais" => "5fORmE",
"informait" => "5fORmE",
"informant" => "5fORm@",
"informateur" => "5fORmat9R",
"informateurs" => "5fORmat9R",
"informaticien" => "5fORmatisj5",
"informaticienne" => "5fORmatisjEn",
"informaticiens" => "5fORmatisj5",
"informatif" => "5fORmatif",
"information" => "5fORmasj§",
"informations" => "5fORmasj§",
"informatique" => "5fORmatik",
"informatiquement" => "5fORmatik°m@",
"informatiques" => "5fORmatik",
"informatisé" => "5fORmatize",
"informatisée" => "5fORmatize",
"informatisées" => "5fORmatize",
"informatiser" => "5fORmatize",
"informatisés" => "5fORmatize",
"informative" => "5fORmativ",
"informatives" => "5fORmativ",
"informatrice" => "5fORmatRis",
"informe" => "5fORm",
"informé" => "5fORme",
"informée" => "5fORme",
"informées" => "5fORme",
"informel" => "5fORmEl",
"informelle" => "5fORmEl",
"informelles" => "5fORmEl",
"informels" => "5fORmEl",
"informent" => "5fORm",
"informer" => "5fORme",
"informera" => "5fORm°Ra",
"informerai" => "5fORm°RE",
"informerais" => "5fORm°RE",
"informeras" => "5fORm°Ra",
"informèrent" => "5fORmER",
"informerez" => "5fORm°Re",
"informerons" => "5fORm°R§",
"informeront" => "5fORm°R§",
"informes" => "5fORm",
"informés" => "5fORme",
"informez" => "5fORme",
"informiez" => "5fORmje",
"informions" => "5fORmj§",
"informons" => "5fORm§",
"informulable" => "5fORmylabl",
"informulables" => "5fORmylabl",
"informulé" => "5fORmyle",
"informulée" => "5fORmyle",
"informulées" => "5fORmyle",
"infortune" => "5fORtyn",
"infortuné" => "5fORtyne",
"infortunée" => "5fORtyne",
"infortunées" => "5fORtyne",
"infortunes" => "5fORtyn",
"infortunés" => "5fORtyne",
"infos" => "5fo",
"infoutu" => "5futy",
"infoutue" => "5futy",
"infoutus" => "5futy",
"infra" => "5fRa",
"infraction" => "5fRaksj§",
"infractions" => "5fRaksj§",
"infranchi" => "5fR@Si",
"infranchissable" => "5fR@Sisabl",
"infranchissables" => "5fR@Sisabl",
"infrangible" => "5fR@Zibl",
"infrarouge" => "5fRaRuZ",
"infrarouges" => "5fRaRuZ",
"infrason" => "5fRas§",
"infrastructure" => "5fRastRyktyR",
"infrastructures" => "5fRastRyktyR",
"infréquentable" => "5fRek@tabl",
"infréquentables" => "5fRek@tabl",
"infréquentée" => "5fRek@te",
"infréquentés" => "5fRek@te",
"infroissable" => "5fRwasabl",
"infructueuse" => "5fRykt82z",
"infructueuses" => "5fRykt82z",
"infructueux" => "5fRykt82",
"infus" => "5fy",
"infusaient" => "5fyzE",
"infusait" => "5fyzE",
"infusant" => "5fyz@",
"infuse" => "5fyz",
"infusé" => "5fyze",
"infusée" => "5fyze",
"infusées" => "5fyze",
"infusent" => "5fyz",
"infuser" => "5fyze",
"infuses" => "5fyz",
"infusion" => "5fyzj§",
"infusions" => "5fyzj§",
"infusoires" => "5fyzwaR",
"ingagnable" => "5gaNabl",
"ingambe" => "5g@b",
"ingambes" => "5g@b",
"ingénia" => "5Zenja",
"ingéniai" => "5ZenjE",
"ingéniaient" => "5ZenjE",
"ingéniais" => "5ZenjE",
"ingéniait" => "5ZenjE",
"ingéniant" => "5Zenj@",
"ingénie" => "5Zeni",
"ingénié" => "5Zenje",
"ingénient" => "5Zeni",
"ingénier" => "5Zenje",
"ingénierie" => "5ZeniRi",
"ingéniés" => "5Zenje",
"ingénieur" => "5Zenj9R",
"ingénieur-chimiste" => "5Zenj9RSimist",
"ingénieur-conseil" => "5Zenj9Rk§sEj",
"ingénieurs" => "5Zenj9R",
"ingénieuse" => "5Zenj2z",
"ingénieusement" => "5Zenj2z°m@",
"ingénieuses" => "5Zenj2z",
"ingénieux" => "5Zenj2",
"ingéniosité" => "5Zenjozite",
"ingéniosités" => "5Zenjozite",
"ingénu" => "5Zeny",
"ingénue" => "5Zeny",
"ingénues" => "5Zeny",
"ingénuité" => "5Zen8ite",
"ingénuités" => "5Zen8ite",
"ingénument" => "5Zenym@",
"ingénus" => "5Zeny",
"ingérable" => "5ZeRabl",
"ingérant" => "5ZeR@",
"ingère" => "5ZER",
"ingéré" => "5ZeRe",
"ingérée" => "5ZeRe",
"ingérées" => "5ZeRe",
"ingérence" => "5ZeR@s",
"ingérences" => "5ZeR@s",
"ingèrent" => "5ZER",
"ingérer" => "5ZeRe",
"ingérés" => "5ZeRe",
"ingérons" => "5ZeR§",
"ingestion" => "5ZEstj§",
"inglorieusement" => "5glORj2z°m@",
"inglorieux" => "5glORj2",
"ingouvernable" => "5guvERnabl",
"ingrat" => "5gRa",
"ingrate" => "5gRat",
"ingratement" => "5gRat°m@",
"ingrates" => "5gRat",
"ingratitude" => "5gRatityd",
"ingrats" => "5gRa",
"ingrédient" => "5gRedj@",
"ingrédients" => "5gRedj@",
"inguérissable" => "5geRisabl",
"inguérissables" => "5geRisabl",
"inguinal" => "5g8inal",
"inguinales" => "5ginal",
"ingurgita" => "5gyRZita",
"ingurgitaient" => "5gyRZitE",
"ingurgitais" => "5gyRZitE",
"ingurgitait" => "5gyRZitE",
"ingurgitant" => "5gyRZit@",
"ingurgitation" => "5gyRZitasj§",
"ingurgite" => "5gyRZit",
"ingurgité" => "5gyRZite",
"ingurgitée" => "5gyRZite",
"ingurgitées" => "5gyRZite",
"ingurgitent" => "5gyRZit",
"ingurgiter" => "5gyRZite",
"ingurgiterait" => "5gyRZit°RE",
"ingurgités" => "5gyRZite",
"inhabile" => "inabil",
"inhabitable" => "inabitabl",
"inhabitables" => "inabitabl",
"inhabité" => "inabite",
"inhabitée" => "inabite",
"inhabitées" => "inabite",
"inhabités" => "inabite",
"inhabituel" => "inabit8El",
"inhabituelle" => "inabit8El",
"inhabituellement" => "inabityEl°m@",
"inhabituelles" => "inabit8El",
"inhabituels" => "inabit8El",
"inhala" => "inala",
"inhalais" => "inalE",
"inhalait" => "inalE",
"inhalant" => "inal@",
"inhalateur" => "inalat9R",
"inhalateurs" => "inalat9R",
"inhalation" => "inalasj§",
"inhalations" => "inalasj§",
"inhalé" => "inale",
"inhaler" => "inale",
"inhalera" => "inal°Ra",
"inhalez" => "inale",
"inharmonieux" => "inaRmOnj2",
"inhérent" => "ineR@",
"inhérente" => "ineR@t",
"inhérentes" => "ineR@t",
"inhérents" => "ineR@",
"inhibait" => "inibE",
"inhibant" => "inib@",
"inhibât" => "iniba",
"inhibe" => "inib",
"inhibé" => "inibe",
"inhibée" => "inibe",
"inhibent" => "inib",
"inhiber" => "inibe",
"inhibés" => "inibe",
"inhibiteur" => "inibit9R",
"inhibiteurs" => "inibit9R",
"inhibition" => "inibisj§",
"inhibitions" => "inibisj§",
"inhibitrice" => "inibitRis",
"inhospitalier" => "inOspitalje",
"inhospitalière" => "inOspitaljER",
"inhospitalières" => "inOspitaljER",
"inhospitaliers" => "inOspitalje",
"inhospitalité" => "inOspitalite",
"inhuma" => "inyma",
"inhumaient" => "inymE",
"inhumain" => "inym5",
"inhumaine" => "inymEn",
"inhumainement" => "inymEn°m@",
"inhumaines" => "inymEn",
"inhumains" => "inym5",
"inhumait" => "inymE",
"inhumanité" => "inymanite",
"inhumation" => "inymasj§",
"inhumations" => "inymasj§",
"inhume" => "inym",
"inhumé" => "inyme",
"inhumée" => "inyme",
"inhumer" => "inyme",
"inhumés" => "inyme",
"inhumons" => "inym§",
"inidentifiable" => "inid@tifjabl",
"inidentifiables" => "inid@tifjabl",
"inimaginable" => "inimaZinabl",
"inimaginablement" => "inimaZinabl2m@",
"inimaginables" => "inimaZinabl",
"inimitable" => "inimitabl",
"inimitablement" => "inimitabl2m@",
"inimité" => "inimite",
"inimitié" => "inimitje",
"inimitiés" => "inimitje",
"ininflammable" => "in5flamabl",
"inintelligence" => "in5teliZ@s",
"inintelligent" => "in5teliZ@",
"inintelligents" => "in5tEliZ@",
"inintelligible" => "in5teliZibl",
"inintelligibles" => "in5teliZibl",
"inintéressant" => "in5teREs@",
"inintéressante" => "in5teREs@t",
"inintéressantes" => "in5teREs@t",
"inintéressants" => "in5teREs@",
"inintérêt" => "in5teRE",
"ininterprétables" => "in5tERpRetabl",
"ininterrompu" => "in5tER§py",
"ininterrompue" => "in5tER§py",
"ininterrompues" => "in5tER§py",
"ininterrompus" => "in5tER§py",
"inique" => "inik",
"iniques" => "inik",
"iniquité" => "inikite",
"iniquités" => "inikite",
"initia" => "inisja",
"initiai" => "inisjE",
"initiaient" => "inisjE",
"initiais" => "inisjE",
"initiait" => "inisjE",
"initial" => "inisjal",
"initiale" => "inisjal",
"initialement" => "inisjal°m@",
"initiales" => "inisjal",
"initialisation" => "inisjalizasj§",
"initialise" => "inisjaliz",
"initialisé" => "inisjalize",
"initialisée" => "inisjalize",
"initialiser" => "inisjalize",
"initialisés" => "inisjalize",
"initialisez" => "inisjalize",
"initiâmes" => "inisjam",
"initiant" => "inisj@",
"initiât" => "inisja",
"initiateur" => "inisjat9R",
"initiateurs" => "inisjat9R",
"initiation" => "inisjasj§",
"initiations" => "inisjasj§",
"initiatique" => "inisjatik",
"initiatiques" => "inisjatik",
"initiative" => "inisjativ",
"initiatives" => "inisjativ",
"initiatrice" => "inisjatRis",
"initiatrices" => "inisjatRis",
"initiaux" => "inisjo",
"initie" => "inisi",
"initié" => "inisje",
"initiée" => "inisje",
"initiées" => "inisje",
"initier" => "inisje",
"initiera" => "inisiRa",
"initierai" => "inisiRE",
"initierait" => "inisiRE",
"initièrent" => "inisjER",
"initierons" => "inisiR§",
"initiés" => "inisje",
"initiez" => "inisje",
"injecta" => "5ZEkta",
"injectable" => "5ZEktabl",
"injectaient" => "5ZEktE",
"injectait" => "5ZEktE",
"injectant" => "5ZEkt@",
"injecte" => "5ZEkt",
"injecté" => "5ZEkte",
"injectée" => "5ZEkte",
"injectent" => "5ZEkt",
"injecter" => "5ZEkte",
"injectera" => "5ZEkt°Ra",
"injecteras" => "5ZEkt°Ra",
"injectes" => "5ZEkt",
"injectés" => "5ZEkte",
"injecteur" => "5ZEkt9R",
"injecteurs" => "5ZEkt9R",
"injectez" => "5ZEkte",
"injection" => "5ZEksj§",
"injections" => "5ZEksj§",
"injoignable" => "5ZwaNabl",
"injoignables" => "5ZwaNabl",
"injonction" => "5Z§ksj§",
"injonctions" => "5Z§ksj§",
"injouable" => "5Zwabl",
"injure" => "5ZyR",
"injures" => "5ZyR",
"injuria" => "5ZyRja",
"injuriai" => "5ZyRjE",
"injuriaient" => "5ZyRjE",
"injuriais" => "5ZyRjE",
"injuriait" => "5ZyRjE",
"injuriant" => "5ZyRj@",
"injurie" => "5ZyRi",
"injurié" => "5ZyRje",
"injuriée" => "5ZyRje",
"injurient" => "5ZyRi",
"injurier" => "5ZyRje",
"injuries" => "5ZyRi",
"injuriés" => "5ZyRje",
"injurieuse" => "5ZyRj2z",
"injurieusement" => "5ZyRj2z°m@",
"injurieux" => "5ZyRj2",
"injuste" => "5Zyst",
"injustement" => "5Zyst°m@",
"injustes" => "5Zyst",
"injustice" => "5Zystis",
"injustices" => "5Zystis",
"injustifiable" => "5Zystifjabl",
"injustifiables" => "5Zystifjabl",
"injustifié" => "5Zystifje",
"injustifiée" => "5Zystifje",
"injustifiées" => "5Zystifje",
"injustifiés" => "5Zystifje",
"inlassable" => "5lasabl",
"inlassablement" => "5lasabl°m@",
"inlassables" => "5lasabl",
"inné" => "ine",
"innée" => "ine",
"innées" => "ine",
"innervant" => "inERv@",
"innervation" => "inERvasj§",
"innervé" => "inERve",
"innerver" => "inERve",
"innés" => "ine",
"innocemment" => "inosam@",
"innocence" => "inos@s",
"innocences" => "inos@s",
"innocent" => "inos@",
"innocentait" => "inos@tE",
"innocentant" => "inOs@t@",
"innocente" => "inos@t",
"innocenté" => "inos@te",
"innocentée" => "inos@te",
"innocenter" => "inos@te",
"innocentera" => "inos@t°Ra",
"innocenterai" => "inos@t°RE",
"innocenterait" => "inos@t°RE",
"innocentes" => "inos@t",
"innocents" => "inos@",
"innocuité" => "inok8ite",
"innombrable" => "in§bRabl",
"innombrablement" => "in§bRabl2m@",
"innombrables" => "in§bRabl",
"innominés" => "inomine",
"innommable" => "inomabl",
"innommables" => "inomabl",
"innommé" => "inome",
"innommée" => "inOme",
"innommés" => "inome",
"innova" => "inova",
"innovais" => "inovE",
"innovait" => "inovE",
"innovant" => "inov@",
"innovante" => "inov@t",
"innovateur" => "inovat9R",
"innovation" => "inovasj§",
"innovations" => "inovasj§",
"innovatrice" => "inOvatRis",
"innove" => "inOv",
"innové" => "inove",
"innover" => "inove",
"innovez" => "inove",
"inoccupations" => "inokypasj§",
"inoccupé" => "inokype",
"inoccupée" => "inokype",
"inoccupées" => "inokype",
"inoccupés" => "inokype",
"inoculant" => "inOkyl@",
"inoculation" => "inokylasj§",
"inocule" => "inokyl",
"inoculé" => "inokyle",
"inoculée" => "inokyle",
"inoculées" => "inokyle",
"inoculent" => "inokyl",
"inoculer" => "inokyle",
"inoculerait" => "inokyl°RE",
"inodore" => "inodOR",
"inodores" => "inodOR",
"inoffensif" => "inof@sif",
"inoffensifs" => "inof@sif",
"inoffensive" => "inof@siv",
"inoffensives" => "inof@siv",
"inonda" => "in§da",
"inondable" => "in§dabl",
"inondables" => "in§dabl",
"inondaient" => "in§dE",
"inondait" => "in§dE",
"inondant" => "in§d@",
"inondât" => "in§da",
"inondation" => "in§dasj§",
"inondations" => "in§dasj§",
"inonde" => "in§d",
"inondé" => "in§de",
"inondée" => "in§de",
"inondées" => "in§de",
"inondent" => "in§d",
"inonder" => "in§de",
"inondera" => "in§d°Ra",
"inonderai" => "in§d°RE",
"inonderait" => "in§d°RE",
"inondèrent" => "in§dER",
"inonderons" => "in§d°R§",
"inondés" => "in§de",
"inondez" => "in§de",
"inondiez" => "in§dje",
"inopérable" => "inopeRabl",
"inopérables" => "inopeRabl",
"inopérant" => "inopeR@",
"inopérante" => "inopeR@t",
"inopérantes" => "inopeR@t",
"inopérants" => "inopeR@",
"inopiné" => "inopine",
"inopinée" => "inopine",
"inopinées" => "inopine",
"inopinément" => "inopinem@",
"inopportun" => "inopORt1",
"inopportune" => "inopORtyn",
"inopportunément" => "inopORtynem@",
"inopportunes" => "inopORtyn",
"inopportunité" => "inopORtynite",
"inopportuns" => "inopORt1",
"inorganique" => "inORganik",
"inorganisé" => "inORganize",
"inorganisée" => "inORganize",
"inorganisées" => "inORganize",
"inoubliable" => "inublijabl",
"inoubliablement" => "inublijabl2m@",
"inoubliables" => "inublijabl",
"inoublié" => "inublje",
"inoubliées" => "inublje",
"inouï" => "inwi",
"inouïe" => "inwi",
"inouïes" => "inwi",
"inouïs" => "inwi",
"inox" => "inOks",
"inoxydable" => "inOksidabl",
"inoxydables" => "inOksidabl",
"input" => "input",
"inqualifiable" => "5kalifjabl",
"inqualifiables" => "5kalifjabl",
"inquiet" => "5kjE",
"inquiéta" => "5kjeta",
"inquiétai" => "5kjetE",
"inquiétaient" => "5kjetE",
"inquiétais" => "5kjetE",
"inquiétait" => "5kjetE",
"inquiétant" => "5kjet@",
"inquiétante" => "5kjet@t",
"inquiétantes" => "5kjet@t",
"inquiétants" => "5kjet@",
"inquiétassent" => "5kjetas",
"inquiétât" => "5kjeta",
"inquiète" => "5kjEt",
"inquiété" => "5kjete",
"inquiétée" => "5kjete",
"inquiétées" => "5kjete",
"inquiètent" => "5kjEt",
"inquiéter" => "5kjete",
"inquiétera" => "5kjet°Ra",
"inquiéterai" => "5kjet°RE",
"inquiéteraient" => "5kjet°RE",
"inquiéterais" => "5kjet°RE",
"inquiéterait" => "5kjet°RE",
"inquiéteras" => "5kjet°Ra",
"inquiétèrent" => "5kjetER",
"inquiéteriez" => "5kjEt°Rje",
"inquiéteront" => "5kjEt°R§",
"inquiètes" => "5kjEt",
"inquiétés" => "5kjete",
"inquiéteur" => "5kjet9R",
"inquiétez" => "5kjete",
"inquiétiez" => "5kjetje",
"inquiétions" => "5kjetj§",
"inquiétons" => "5kjet§",
"inquiets" => "5kjE",
"inquiétude" => "5kjetyd",
"inquiétudes" => "5kjetyd",
"inquilisme" => "5kilism",
"inquisiteur" => "5kizit9R",
"inquisiteurs" => "5kizit9R",
"inquisition" => "5kizisj§",
"inquisitionner" => "5kizisjOne",
"inquisitions" => "5kizisj§",
"inquisitive" => "5kizitiv",
"inquisitorial" => "5kizitoRjal",
"inquisitoriale" => "5kizitoRjal",
"inquisitoriales" => "5kizitoRjal",
"inquisitoriaux" => "5kizitoRjo",
"inquisitrice" => "5kizitRis",
"inracontables" => "5Rak§tabl",
"insaisissable" => "5sezisabl",
"insaisissables" => "5sezisabl",
"insalissable" => "5salisabl",
"insalubre" => "5salybR",
"insalubres" => "5salybR",
"insalubrité" => "5salybRite",
"insane" => "5san",
"insanes" => "5san",
"insanité" => "5sanite",
"insanités" => "5sanite",
"insatiable" => "5sasjabl",
"insatiablement" => "5sasjabl°m@",
"insatiables" => "5sasjabl",
"insatisfaction" => "5satisfaksj§",
"insatisfactions" => "5satisfaksj§",
"insatisfaisant" => "5satisf°z@",
"insatisfaisante" => "5satisf°z@t",
"insatisfaisantes" => "5satisf°z@t",
"insatisfait" => "5satisfE",
"insatisfaite" => "5satisfEt",
"insatisfaites" => "5satisfEt",
"insatisfaits" => "5satisfE",
"inscription" => "5skRipsj§",
"inscriptions" => "5skRipsj§",
"inscrira" => "5skRiRa",
"inscrirai" => "5skRiRE",
"inscriraient" => "5skRiRE",
"inscrirais" => "5skRiRE",
"inscrirait" => "5skRiRE",
"inscriras" => "5skRiRa",
"inscrire" => "5skRiR",
"inscris" => "5skRi",
"inscrit" => "5skRi",
"inscrite" => "5skRit",
"inscrites" => "5skRit",
"inscrits" => "5skRi",
"inscrivaient" => "5skRivE",
"inscrivais" => "5skRivE",
"inscrivait" => "5skRivE",
"inscrivant" => "5skRiv@",
"inscrive" => "5skRiv",
"inscrivent" => "5skRiv",
"inscrivez" => "5skRive",
"inscrivirent" => "5skRiviR",
"inscrivis" => "5skRivi",
"inscrivit" => "5skRivi",
"inscrivons" => "5skRiv§",
"inscrutable" => "5skRytabl",
"insécable" => "5sekabl",
"insecte" => "5sEkt",
"insectes" => "5sEkt",
"insecticide" => "5sEktisid",
"insecticides" => "5sEktisid",
"insectivore" => "5sEktivOR",
"insécurité" => "5sekyRite",
"insécurités" => "5sekyRite",
"inséminateur" => "5seminat9R",
"insémination" => "5seminasj§",
"inséminations" => "5seminasj§",
"inséminé" => "5semine",
"inséminée" => "5semine",
"inséminer" => "5semine",
"inséminés" => "5semine",
"insensé" => "5s@se",
"insensée" => "5s@se",
"insensées" => "5s@se",
"insensément" => "5s@sem@",
"insensés" => "5s@se",
"insensibilisait" => "5s@sibilizE",
"insensibilisé" => "5s@sibilize",
"insensibilisée" => "5s@sibilize",
"insensibiliser" => "5s@sibilize",
"insensibilité" => "5s@sibilite",
"insensible" => "5s@sibl",
"insensiblement" => "5s@sibl°m@",
"insensibles" => "5s@sibl",
"inséparabilité" => "5sepaRabilite",
"inséparable" => "5sepaRabl",
"inséparablement" => "5sepaRabl°m@",
"inséparables" => "5sepaRabl",
"inséra" => "5seRa",
"inséraient" => "5seRE",
"insérait" => "5seRE",
"insérant" => "5seR@",
"insère" => "5sER",
"inséré" => "5seRe",
"insérée" => "5seRe",
"insérées" => "5seRe",
"insèrent" => "5sER",
"insérer" => "5seRe",
"insérera" => "5seR°Ra",
"insérerait" => "5seR°RE",
"insérèrent" => "5seRER",
"insérerons" => "5seR°R§",
"insérés" => "5seRe",
"insérez" => "5seRe",
"insérons" => "5seR§",
"insert" => "5sER",
"insertion" => "5sERsj§",
"inserts" => "5sER",
"insidieuse" => "5sidj2z",
"insidieusement" => "5sidj2z°m@",
"insidieuses" => "5sidj2z",
"insidieux" => "5sidj2",
"insight" => "insajt",
"insights" => "5sit",
"insigne" => "5siN",
"insignes" => "5siN",
"insignifiance" => "5siNifj@s",
"insignifiances" => "5siNifj@s",
"insignifiant" => "5siNifj@",
"insignifiante" => "5siNifj@t",
"insignifiantes" => "5siNifj@t",
"insignifiants" => "5siNifj@",
"insincère" => "5s5sER",
"insincérité" => "5s5seRite",
"insinua" => "5sin8a",
"insinuai" => "5sin8E",
"insinuaient" => "5sin8E",
"insinuais" => "5sin8E",
"insinuait" => "5sin8E",
"insinuant" => "5sin8@",
"insinuante" => "5sin8@t",
"insinuantes" => "5sin8@t",
"insinuants" => "5sin8@",
"insinuation" => "5sin8asj§",
"insinuations" => "5sin8asj§",
"insinue" => "5siny",
"insinué" => "5sin8e",
"insinuée" => "5sin8e",
"insinuent" => "5siny",
"insinuer" => "5sin8e",
"insinuerai" => "5sinyRE",
"insinuerait" => "5sinyRE",
"insinues" => "5siny",
"insinuez" => "5sinye",
"insinuiez" => "5sinyje",
"insipide" => "5sipid",
"insipides" => "5sipid",
"insipidité" => "5sipidite",
"insista" => "5sista",
"insistai" => "5sistE",
"insistaient" => "5sistE",
"insistais" => "5sistE",
"insistait" => "5sistE",
"insistance" => "5sist@s",
"insistances" => "5sist@s",
"insistant" => "5sist@",
"insistante" => "5sist@t",
"insistantes" => "5sist@t",
"insistants" => "5sist@",
"insistât" => "5sista",
"insiste" => "5sist",
"insisté" => "5siste",
"insistent" => "5sist",
"insister" => "5siste",
"insistera" => "5sist°Ra",
"insisterai" => "5sist°RE",
"insisteraient" => "5sist°RE",
"insisterais" => "5sist°RE",
"insisterait" => "5sist°RE",
"insisteras" => "5sist°Ra",
"insistèrent" => "5sistER",
"insisterons" => "5sist°R§",
"insistes" => "5sist",
"insistez" => "5siste",
"insistiez" => "5sistje",
"insistions" => "5sistj§",
"insistons" => "5sist§",
"insociable" => "5sosjabl",
"insolant" => "5sol@",
"insolation" => "5solasj§",
"insolations" => "5solasj§",
"insolé" => "5sole",
"insolemment" => "5solam@",
"insolence" => "5sol@s",
"insolences" => "5sol@s",
"insolent" => "5sOl@",
"insolente" => "5sol@t",
"insolentes" => "5sol@t",
"insolents" => "5sol@",
"insolite" => "5solit",
"insolitement" => "5sOlit°m@",
"insolites" => "5solit",
"insoluble" => "5solybl",
"insolubles" => "5solybl",
"insolvable" => "5sOlvabl",
"insolvables" => "5solvabl",
"insomniaque" => "5sOmnjak",
"insomniaques" => "5sOmnjak",
"insomnie" => "5sOmni",
"insomnies" => "5sOmni",
"insomnieuse" => "5sOmnj2z",
"insomnieux" => "5sOmnj2",
"insondable" => "5s§dabl",
"insondablement" => "5s§dabl2m@",
"insondables" => "5s§dabl",
"insonore" => "5sonOR",
"insonorisation" => "5sonoRizasj§",
"insonorisé" => "5sonoRize",
"insonorisée" => "5sonoRize",
"insonorisées" => "5sonoRize",
"insonoriser" => "5sonoRize",
"insonorisés" => "5sonoRize",
"insonorité" => "5sonoRite",
"insortable" => "5sORtabl",
"insortables" => "5sORtabl",
"insouciance" => "5susj@s",
"insouciant" => "5susj@",
"insouciante" => "5susj@t",
"insouciantes" => "5susj@t",
"insouciants" => "5susj@",
"insoucieuse" => "5susj2z",
"insoucieusement" => "5susj2z°m@",
"insoucieux" => "5susj2",
"insoulevables" => "5sul°vabl",
"insoumis" => "5sumi",
"insoumise" => "5sumiz",
"insoumission" => "5sumisj§",
"insoupçonnable" => "5supsonabl",
"insoupçonnables" => "5supsonabl",
"insoupçonné" => "5supsone",
"insoupçonnée" => "5supsone",
"insoupçonnées" => "5supsone",
"insoupçonnés" => "5supsone",
"insoutenable" => "5sut°nabl",
"insoutenables" => "5sut°nabl",
"inspecta" => "5spEkta",
"inspectai" => "5spEktE",
"inspectaient" => "5spEktE",
"inspectais" => "5spEktE",
"inspectait" => "5spEktE",
"inspectant" => "5spEkt@",
"inspecte" => "5spEkt",
"inspecté" => "5spEkte",
"inspectée" => "5spEkte",
"inspectées" => "5spEkte",
"inspectent" => "5spEkt",
"inspecter" => "5spEkte",
"inspectera" => "5spEkt°Ra",
"inspecterais" => "5spEkt°RE",
"inspectèrent" => "5spEktER",
"inspecterez" => "5spEkt°Re",
"inspecteront" => "5spEkt°R§",
"inspectes" => "5spEkt",
"inspectés" => "5spEkte",
"inspecteur" => "5spEkt9R",
"inspecteurs" => "5spEkt9R",
"inspectez" => "5spEkte",
"inspectiez" => "5spEktje",
"inspection" => "5spEksj§",
"inspections" => "5spEksj§",
"inspectons" => "5spEkt§",
"inspectrice" => "5spEktRis",
"inspira" => "5spiRa",
"inspirai" => "5spiRE",
"inspiraient" => "5spiRE",
"inspirais" => "5spiRE",
"inspirait" => "5spiRE",
"inspirant" => "5spiR@",
"inspirante" => "5spiR@t",
"inspirantes" => "5spiR@t",
"inspirants" => "5spiR@",
"inspirât" => "5spiRa",
"inspirateur" => "5spiRat9R",
"inspirateurs" => "5spiRat9R",
"inspiration" => "5spiRasj§",
"inspirations" => "5spiRasj§",
"inspiratoire" => "5spiRatwaR",
"inspiratrice" => "5spiRatRis",
"inspiratrices" => "5spiRatRis",
"inspire" => "5spiR",
"inspiré" => "5spiRe",
"inspirée" => "5spiRe",
"inspirées" => "5spiRe",
"inspirent" => "5spiR",
"inspirer" => "5spiRe",
"inspirera" => "5spiR°Ra",
"inspireraient" => "5spiR°RE",
"inspirerait" => "5spiR°RE",
"inspireras" => "5spiR°Ra",
"inspirèrent" => "5spiRER",
"inspireront" => "5spiR°R§",
"inspires" => "5spiR",
"inspirés" => "5spiRe",
"inspirez" => "5spiRe",
"inspiriez" => "5spiRje",
"inspirions" => "5spiRj§",
"instabilité" => "5stabilite",
"instable" => "5stabl",
"instables" => "5stabl",
"installa" => "5stala",
"installai" => "5stalE",
"installaient" => "5stalE",
"installais" => "5stalE",
"installait" => "5stalE",
"installâmes" => "5stalam",
"installant" => "5stal@",
"installasse" => "5stalas",
"installât" => "5stala",
"installateur" => "5stalat9R",
"installation" => "5stalasj§",
"installations" => "5stalasj§",
"installe" => "5stal",
"installé" => "5stale",
"installée" => "5stale",
"installées" => "5stale",
"installent" => "5stal",
"installer" => "5stale",
"installera" => "5stal°Ra",
"installerai" => "5stal°RE",
"installeraient" => "5stal°RE",
"installerais" => "5stal°RE",
"installerait" => "5stal°RE",
"installeras" => "5stal°Ra",
"installèrent" => "5stalER",
"installerez" => "5stal°Re",
"installerions" => "5stal°Rj§",
"installerons" => "5stal°R§",
"installeront" => "5stal°R§",
"installes" => "5stal",
"installés" => "5stale",
"installeur" => "5stal9R",
"installez" => "5stale",
"installiez" => "5stalje",
"installions" => "5stalj§",
"installons" => "5stal§",
"instamment" => "5stam@",
"instance" => "5st@s",
"instances" => "5st@s",
"instant" => "5st@",
"instantané" => "5st@tane",
"instantanée" => "5st@tane",
"instantanées" => "5st@tane",
"instantanéité" => "5st@taneite",
"instantanément" => "5st@tanem@",
"instantanés" => "5st@tane",
"instante" => "5st@t",
"instantes" => "5st@t",
"instants" => "5st@",
"instaura" => "5stoRa",
"instaurai" => "5stoRE",
"instaurait" => "5stoRE",
"instaurant" => "5stoR@",
"instauration" => "5stoRasj§",
"instauratrice" => "5stoRatRis",
"instaure" => "5stoR",
"instauré" => "5stoRe",
"instaurée" => "5stoRe",
"instaurées" => "5stoRe",
"instaurer" => "5stoRe",
"instaurera" => "5stoR°Ra",
"instaurèrent" => "5stoRER",
"instaurerions" => "5stoR°Rj§",
"instaurés" => "5stoRe",
"instaurions" => "5stoRj§",
"instigateur" => "5stigat9R",
"instigateurs" => "5stigat9R",
"instigation" => "5stigasj§",
"instigatrice" => "5stigatRis",
"instilla" => "5stila",
"instille" => "5stil",
"instillé" => "5stile",
"instillées" => "5stile",
"instiller" => "5stile",
"instillera" => "5stil°Ra",
"instinct" => "5st5",
"instinctif" => "5st5ktif",
"instinctifs" => "5st5ktif",
"instinctive" => "5st5ktiv",
"instinctivement" => "5st5ktiv°m@",
"instinctives" => "5st5ktiv",
"instinctivo" => "5st5ktivo",
"instincts" => "5st5",
"instinctuel" => "5st5kt8El",
"instit" => "5stit",
"instits" => "5stit",
"institua" => "5stit8a",
"instituai" => "5stit8E",
"instituaient" => "5stit8E",
"instituait" => "5stit8E",
"instituant" => "5stit8@",
"institue" => "5stity",
"institué" => "5stit8e",
"instituée" => "5stit8e",
"instituées" => "5stit8e",
"instituent" => "5stity",
"instituer" => "5stit8e",
"instituèrent" => "5stit8ER",
"institués" => "5stit8e",
"instituons" => "5stity§",
"institut" => "5stity",
"instituteur" => "5stityt9R",
"instituteurs" => "5stityt9R",
"institution" => "5stitysj§",
"institutionnalisé" => "5stitysjonalize",
"institutionnel" => "5stitysjonEl",
"institutionnelle" => "5stitysjonEl",
"institutionnels" => "5stitysjonEl",
"institutions" => "5stitysj§",
"institutrice" => "5stitytRis",
"institutrices" => "5stitytRis",
"instituts" => "5stity",
"instructeur" => "5stRykt9R",
"instructeurs" => "5stRykt9R",
"instructif" => "5stRyktif",
"instructifs" => "5stRyktif",
"instruction" => "5stRyksj§",
"instructions" => "5stRyksj§",
"instructive" => "5stRyktiv",
"instructives" => "5stRyktiv",
"instruira" => "5stR8iRa",
"instruirai" => "5stR8iRE",
"instruiraient" => "5stR8iRE",
"instruirait" => "5stR8iRE",
"instruire" => "5stR8iR",
"instruis" => "5stR8i",
"instruisaient" => "5stR8izE",
"instruisais" => "5stR8izE",
"instruisait" => "5stR8izE",
"instruisant" => "5stR8iz@",
"instruise" => "5stR8iz",
"instruisent" => "5stR8iz",
"instruisez" => "5stR8ize",
"instruisîmes" => "5stR8izim",
"instruisirent" => "5stR8iziR",
"instruisis" => "5stR8izi",
"instruisit" => "5stR8izi",
"instruit" => "5stR8i",
"instruite" => "5stR8it",
"instruites" => "5stR8it",
"instruits" => "5stR8i",
"instrument" => "5stRym@",
"instrumentais" => "5stRym@tE",
"instrumental" => "5stRym@tal",
"instrumentale" => "5stRym@tal",
"instrumentation" => "5stRym@tasj§",
"instrumentaux" => "5stRym@to",
"instrumenter" => "5stRym@te",
"instrumentiste" => "5stRym@tist",
"instrumentistes" => "5stRym@tist",
"instruments" => "5stRym@",
"insu" => "5sy",
"insubmersible" => "5sybmERsibl",
"insubmersibles" => "5sybmERsibl",
"insubordination" => "5sybORdinasj§",
"insubordinations" => "5sybORdinasj§",
"insubordonné" => "5sybORdone",
"insubordonnée" => "5sybORdOne",
"insuccès" => "5syksE",
"insuffisamment" => "5syfizam@",
"insuffisance" => "5syfiz@s",
"insuffisances" => "5syfiz@s",
"insuffisant" => "5syfiz@",
"insuffisante" => "5syfiz@t",
"insuffisantes" => "5syfiz@t",
"insuffisants" => "5syfiz@",
"insufflaient" => "5syflE",
"insufflait" => "5syflE",
"insufflant" => "5syfl@",
"insufflateur" => "5syflat9R",
"insuffle" => "5syfl",
"insufflé" => "5syfle",
"insufflée" => "5syfle",
"insufflées" => "5syfle",
"insufflent" => "5syfl",
"insuffler" => "5syfle",
"insufflera" => "5syfl°Ra",
"insula" => "5syla",
"insulaire" => "5sylER",
"insulaires" => "5sylER",
"insularité" => "5sylaRite",
"insulation" => "5sylasj§",
"insuline" => "5sylin",
"insulinique" => "5sylinik",
"insulta" => "5sylta",
"insultaient" => "5syltE",
"insultais" => "5syltE",
"insultait" => "5syltE",
"insultant" => "5sylt@",
"insultante" => "5sylt@t",
"insultantes" => "5sylt@t",
"insultants" => "5sylt@",
"insulte" => "5sylt",
"insulté" => "5sylte",
"insultée" => "5sylte",
"insultées" => "5sylte",
"insultent" => "5sylt",
"insulter" => "5sylte",
"insulterai" => "5sylt°RE",
"insulterais" => "5sylt°RE",
"insulteras" => "5sylt°Ra",
"insultes" => "5sylt",
"insultés" => "5sylte",
"insulteur" => "5sylt9R",
"insulteurs" => "5sylt9R",
"insultez" => "5sylte",
"insultions" => "5syltj§",
"insultons" => "5sylt§",
"insupportable" => "5sypORtabl",
"insupportablement" => "5sypORtabl°m@",
"insupportables" => "5sypORtabl",
"insupportaient" => "5sypORtE",
"insupporte" => "5sypORt",
"insupportent" => "5sypORt",
"insurge" => "5syRZ",
"insurgé" => "5syRZe",
"insurgea" => "5syRZa",
"insurgeai" => "5syRZE",
"insurgeaient" => "5syRZE",
"insurgeais" => "5syRZE",
"insurgeait" => "5syRZE",
"insurgeant" => "5syRZ@",
"insurgeât" => "5syRZa",
"insurgée" => "5syRZe",
"insurgent" => "5syRZ",
"insurgeons" => "5syRZ§",
"insurger" => "5syRZe",
"insurgera" => "5syRZ°Ra",
"insurgerai" => "5syRZ°RE",
"insurgerait" => "5syRZ°RE",
"insurgèrent" => "5syRZER",
"insurgés" => "5syRZe",
"insurmontable" => "5syRm§tabl",
"insurmontables" => "5syRm§tabl",
"insurpassable" => "5syRpasabl",
"insurpassé" => "5syRpase",
"insurrection" => "5syREksj§",
"insurrectionnel" => "5syREksjonEl",
"insurrectionnelle" => "5syREksjonEl",
"insurrections" => "5syREksj§",
"intact" => "5takt",
"intacte" => "5takt",
"intactes" => "5takt",
"intacts" => "5takt",
"intaille" => "5taj",
"intailles" => "5taj",
"intangibilité" => "5t@Zibilite",
"intangible" => "5t@Zibl",
"intangibles" => "5t@Zibl",
"intarissable" => "5taRisabl",
"intarissablement" => "5taRisabl°m@",
"intarissables" => "5taRisabl",
"intégra" => "5tegRa",
"intégraient" => "5tegRE",
"intégrait" => "5tegRE",
"intégral" => "5tegRal",
"intégrale" => "5tegRal",
"intégralement" => "5tegRal°m@",
"intégrales" => "5tegRal",
"intégralisme" => "5tegRalism",
"intégralité" => "5tegRalite",
"intégrant" => "5tegR@",
"intégrante" => "5tegR@t",
"intégrateur" => "5tegRat9R",
"intégration" => "5tegRasj§",
"intégraux" => "5tegRo",
"intègre" => "5tEgR",
"intégré" => "5tegRe",
"intégrée" => "5tegRe",
"intégrées" => "5tegRe",
"intègrent" => "5tEgR",
"intégrer" => "5tegRe",
"intégrera" => "5tegR°Ra",
"intégrerais" => "5tegR°RE",
"intégreras" => "5tegR°Ra",
"intégrèrent" => "5tegRER",
"intégrerez" => "5tegR°Re",
"intégreront" => "5tegR°R§",
"intègres" => "5tEgR",
"intégrés" => "5tegRe",
"intégrez" => "5tegRe",
"intégriez" => "5tegRije",
"intégrisme" => "5tegRism",
"intégrismes" => "5tegRizm",
"intégriste" => "5tegRist",
"intégristes" => "5tegRist",
"intégrité" => "5tegRite",
"intégrités" => "5tegRite",
"intellect" => "5telEkt",
"intellectualisation" => "5tElEkt8alizasj§",
"intellectualise" => "5tElEkt8aliz",
"intellectualisées" => "5tElEkt8alize",
"intellectualiser" => "5tElEkt8alize",
"intellectualisme" => "5telEkt8alizm",
"intellectualiste" => "5telEkt8alist",
"intellectuel" => "5telEkt8El",
"intellectuel-phare" => "5telEkt8ElfaR",
"intellectuelle" => "5telEkt8El",
"intellectuellement" => "5telEkt8El°m@",
"intellectuelles" => "5telEkt8El",
"intellectuels" => "5telEkt8El",
"intellige" => "5tEliZ",
"intelligemment" => "5teliZam@",
"intelligence" => "5teliZ@s",
"intelligences" => "5teliZ@s",
"intelligent" => "5teliZ@",
"intelligente" => "5teliZ@t",
"intelligentes" => "5teliZ@t",
"intelligents" => "5teliZ@",
"intelligentsia" => "5teliZEnsja",
"intelligibilité" => "5teliZibilite",
"intelligible" => "5teliZibl",
"intelligiblement" => "5teliZibl°m@",
"intelligibles" => "5teliZibl",
"intello" => "5tElo",
"intellos" => "5tElo",
"intempérance" => "5t@peR@s",
"intempérances" => "5t@peR@s",
"intempérante" => "5t@peR@t",
"intempéries" => "5t@peRi",
"intempestif" => "5t@pEstif",
"intempestifs" => "5t@pEstif",
"intempestive" => "5t@pEstiv",
"intempestivement" => "5t@pEstiv°m@",
"intempestives" => "5t@pEstiv",
"intemporalité" => "5t@poRalite",
"intemporel" => "5t@poREl",
"intemporelle" => "5t@poREl",
"intemporelles" => "5t@poREl",
"intenable" => "5t°nabl",
"intenables" => "5t°nabl",
"intendance" => "5t@d@s",
"intendances" => "5t@d@s",
"intendant" => "5t@d@",
"intendante" => "5t@d@t",
"intendants" => "5t@d@",
"intense" => "5t@s",
"intensément" => "5t@sem@",
"intenses" => "5t@s",
"intensif" => "5t@sif",
"intensifia" => "5t@sifja",
"intensifiaient" => "5t@sifjE",
"intensifiait" => "5t@sifjE",
"intensifiant" => "5t@sifj@",
"intensification" => "5t@sifikasj§",
"intensifie" => "5t@sifi",
"intensifié" => "5t@sifje",
"intensifiée" => "5t@sifje",
"intensifiées" => "5t@sifje",
"intensifient" => "5t@sifi",
"intensifier" => "5t@sifje",
"intensifiez" => "5t@sifje",
"intensifs" => "5t@sif",
"intension" => "5t@sj§",
"intensité" => "5t@site",
"intensités" => "5t@site",
"intensive" => "5t@siv",
"intensivement" => "5t@siv°m@",
"intensives" => "5t@siv",
"intenta" => "5t@ta",
"intentait" => "5t@tE",
"intente" => "5t@t",
"intenté" => "5t@te",
"intentée" => "5t@te",
"intentées" => "5t@te",
"intenter" => "5t@te",
"intentera" => "5t@t°Ra",
"intenterai" => "5t@t°RE",
"intentés" => "5t@te",
"intention" => "5t@sj§",
"intentionnalité" => "5t@sjOnalite",
"intentionné" => "5t@sjone",
"intentionnée" => "5t@sjone",
"intentionnées" => "5t@sjone",
"intentionnel" => "5t@sjonEl",
"intentionnelle" => "5t@sjonEl",
"intentionnellement" => "5t@sjonEl°m@",
"intentionnels" => "5t@sjonEl",
"intentionnés" => "5t@sjone",
"intentions" => "5t@sj§",
"inter" => "5tER",
"inter-écoles" => "5tERekOl",
"interactif" => "5tERaktif",
"interactifs" => "5tERaktif",
"interaction" => "5tERaksj§",
"interactions" => "5tERaksj§",
"interactive" => "5tERaktiv",
"interactivité" => "5tERaktivite",
"interagir" => "5tERaZiR",
"interagis" => "5tERaZi",
"interagissais" => "5tERaZisE",
"interagissant" => "5tERaZis@",
"interagit" => "5tERaZi",
"interallié" => "5tERalje",
"interalliée" => "5tERalje",
"interalliées" => "5tERalje",
"interalliés" => "5tERalje",
"interarmées" => "5tERaRme",
"interarmes" => "5tERaRm",
"intercalaient" => "5tERkalE",
"intercalaire" => "5tERkalER",
"intercalaires" => "5tERkalER",
"intercalait" => "5tERkalE",
"intercalant" => "5tERkal@",
"intercale" => "5tERkal",
"intercalé" => "5tERkale",
"intercalée" => "5tERkale",
"intercalées" => "5tERkale",
"intercalent" => "5tERkal",
"intercaler" => "5tERkale",
"intercalera" => "5tERkal°Ra",
"intercalerai" => "5tERkal°RE",
"intercalerez" => "5tERkal°Re",
"intercalés" => "5tERkale",
"intercéda" => "5tERseda",
"intercédait" => "5tERsedE",
"intercédant" => "5tERsed@",
"intercède" => "5tERsEd",
"intercédé" => "5tERsede",
"intercéder" => "5tERsede",
"intercédera" => "5tERsed°Ra",
"intercéderai" => "5tERsed°RE",
"intercellulaire" => "5tERsElylER",
"intercepta" => "5tERsEpta",
"interceptai" => "5tERsEptE",
"interceptais" => "5tERsEptE",
"interceptait" => "5tERsEptE",
"interceptant" => "5tERsEpt@",
"intercepte" => "5tERsEpt",
"intercepté" => "5tERsEpte",
"interceptée" => "5tERsEpte",
"interceptées" => "5tERsEpte",
"interceptent" => "5tERsEpt",
"intercepter" => "5tERsEpte",
"interceptera" => "5tERsEpt°Ra",
"intercepterait" => "5tERsEpt°RE",
"interceptèrent" => "5tERsEptER",
"intercepterez" => "5tERsEpt°Re",
"intercepterons" => "5tERsEpt°R§",
"interceptés" => "5tERsEpte",
"intercepteur" => "5tERsEpt9R",
"intercepteurs" => "5tERsEpt9R",
"interceptez" => "5tERsEpte",
"interception" => "5tERsEpsj§",
"interceptions" => "5tERsepsj§",
"intercesseur" => "5tERses9R",
"intercesseurs" => "5tERses9R",
"intercession" => "5tERsesj§",
"interchangé" => "5tERS@Ze",
"interchangeable" => "5tERS@Zabl",
"interchangeables" => "5tERS@Zabl",
"interchanger" => "5tERS@Ze",
"interclasse" => "5tERklas",
"interclasses" => "5tERklas",
"interclubs" => "5tERklyb",
"intercommunal" => "5tERkOmynal",
"intercommunautaire" => "5tERkOmynotER",
"intercommunication" => "5tERkomynikasj§",
"interconnecté" => "5tERkOnEkte",
"interconnectée" => "5tERkonEkte",
"interconnexion" => "5tERkOnEksj§",
"intercontinental" => "5tERk§tin@tal",
"intercontinentale" => "5tERk§tin@tal",
"intercontinentales" => "5tERk§tin@tal",
"intercontinentaux" => "5tERk§tin@to",
"intercostal" => "5tERkOstal",
"intercostale" => "5tERkOstal",
"intercostaux" => "5tERkOsto",
"intercours" => "5tERkuR",
"intercourse" => "5tERkuRs",
"interculturel" => "5tERkyltyREl",
"interculturels" => "5tERkyltyREl",
"interdépartementaux" => "5tERdepaRt2m@to",
"interdépendance" => "5tERdep@d@s",
"interdépendant" => "5tERdep@d@",
"interdiction" => "5tERdiksj§",
"interdictions" => "5tERdiksj§",
"interdira" => "5tERdiRa",
"interdirai" => "5tERdiRE",
"interdiraient" => "5tERdiRE",
"interdirais" => "5tERdiRE",
"interdirait" => "5tERdiRE",
"interdire" => "5tERdiR",
"interdirent" => "5tERdiR",
"interdis" => "5tERdi",
"interdisaient" => "5tERdizE",
"interdisais" => "5tERdizE",
"interdisait" => "5tERdizE",
"interdisant" => "5tERdiz@",
"interdisciplinaires" => "5tERdisiplinER",
"interdise" => "5tERdiz",
"interdisent" => "5tERdiz",
"interdisez" => "5tERdize",
"interdisiez" => "5tERdizje",
"interdisons" => "5tERdiz§",
"interdissent" => "5tERdis",
"interdit" => "5tERdi",
"interdît" => "5tERdi",
"interdite" => "5tERdit",
"interdites" => "5tERdit",
"interdits" => "5tERdi",
"intéressa" => "5teREsa",
"intéressai" => "5teREsE",
"intéressaient" => "5teREsE",
"intéressais" => "5teREsE",
"intéressait" => "5teREsE",
"intéressant" => "5teREs@",
"intéressante" => "5teREs@t",
"intéressantes" => "5teREs@t",
"intéressants" => "5teREs@",
"intéressât" => "5teREsa",
"intéresse" => "5teREs",
"intéressé" => "5teRese",
"intéressée" => "5teRese",
"intéressées" => "5teRese",
"intéressement" => "5teREs°m@",
"intéressent" => "5teREs",
"intéresser" => "5teRese",
"intéressera" => "5teREs°Ra",
"intéresserai" => "5teREs°RE",
"intéresseraient" => "5teREs°RE",
"intéresserais" => "5teREs°RE",
"intéresserait" => "5teREs°RE",
"intéresseras" => "5teREs°Ra",
"intéressèrent" => "5teREsER",
"intéresseriez" => "5teRes°Rje",
"intéresserons" => "5teREs°R§",
"intéresseront" => "5teREs°R§",
"intéresses" => "5teREs",
"intéressés" => "5teRese",
"intéressez" => "5teRese",
"intéressiez" => "5teREsje",
"intéressions" => "5teREsj§",
"intéressons" => "5teREs§",
"intérêt" => "5teRE",
"interétatique" => "5tERetatik",
"interethnique" => "5tEREtnik",
"intérêts" => "5teRE",
"interface" => "5tERfas",
"interfacer" => "5tERfase",
"interfaces" => "5tERfas",
"interféraient" => "5tERfeRE",
"interférait" => "5tERfeRE",
"interférant" => "5tERfeR@",
"interfère" => "5tERfER",
"interféré" => "5tERfeRe",
"interférence" => "5tERfeR@s",
"interférences" => "5tERfeR@s",
"interférent" => "5tERfeR@",
"interfèrent" => "5tERfER",
"interférer" => "5tERfeRe",
"interférez" => "5tERfeRe",
"interférométrie" => "5tERfeROmet°Ri",
"interféron" => "5tERfeR§",
"interférons" => "5tERfeR§",
"intergalactique" => "5tERgalaktik",
"intergalactiques" => "5tERgalaktik",
"interglaciaire" => "5tERglasjER",
"intergouvernemental" => "5tERguvERn2m@tal",
"intergouvernementale" => "5tERguvERn2m@tal",
"intérieur" => "5teRj9R",
"intérieure" => "5teRj9R",
"intérieurement" => "5teRj9R°m@",
"intérieures" => "5teRj9R",
"intérieurs" => "5teRj9R",
"intérim" => "5teRim",
"intérimaire" => "5teRimER",
"intérimaires" => "5teRimER",
"intérims" => "5teRim",
"intériorisa" => "5teRjoRiza",
"intériorisait" => "5teRjoRizE",
"intériorisation" => "5teRjoRizasj§",
"intériorise" => "5teRjoRiz",
"intériorisée" => "5teRjoRize",
"intériorisées" => "5teRjoRize",
"intériorisent" => "5teRjoRiz",
"intérioriser" => "5teRjoRize",
"intériorisés" => "5teRjoRize",
"intériorité" => "5teRjoRite",
"interjecter" => "5tERZEkte",
"interjection" => "5tERZEksj§",
"interjections" => "5tERZeksj§",
"interjeta" => "5tERZ°ta",
"interjeter" => "5tERZ2te",
"interligne" => "5tERliN",
"interlignes" => "5tERliN",
"interlignés" => "5tERliNe",
"interlocuteur" => "5tERlokyt9R",
"interlocuteurs" => "5tERlokyt9R",
"interlocutoire" => "5tERlOkytwaR",
"interlocutoires" => "5tERlokytwaR",
"interlocutrice" => "5tERlokytRis",
"interlocutrices" => "5tERlokytRis",
"interlope" => "5tERlOp",
"interlopes" => "5tERlOp",
"interloque" => "5tERlOk",
"interloqué" => "5tERloke",
"interloquée" => "5tERloke",
"interloquées" => "5tERloke",
"interloqués" => "5tERloke",
"interlude" => "5tERlyd",
"interludes" => "5tERlyd",
"intermède" => "5tERmEd",
"intermèdes" => "5tERmEd",
"intermédiaire" => "5tERmedjER",
"intermédiaires" => "5tERmedjER",
"intermezzo" => "5tERmEdzo",
"interminable" => "5tERminabl",
"interminablement" => "5tERminabl°m@",
"interminables" => "5tERminabl",
"interministérielles" => "5tERministeRjEl",
"interministériels" => "5tERministeRjEl",
"intermission" => "5tERmisj§",
"intermittence" => "5tERmit@s",
"intermittences" => "5tERmit@s",
"intermittent" => "5tERmit@",
"intermittente" => "5tERmit@t",
"intermittentes" => "5tERmit@t",
"intermittents" => "5tERmit@",
"internat" => "5tERna",
"international" => "5tERnasjonal",
"internationale" => "5tERnasjonal",
"internationalement" => "5tERnasjonal°m@",
"internationales" => "5tERnasjonal",
"internationalisation" => "5tERnasjonalizasj§",
"internationalisée" => "5tERnasjonalize",
"internationalisés" => "5tERnasjonalize",
"internationalisme" => "5tERnasjonalizm",
"internationaliste" => "5tERnasjonalist",
"internationalistes" => "5tERnasjonalist",
"internationaux" => "5tERnasjono",
"internats" => "5tERna",
"internaute" => "5tERnot",
"internautes" => "5tERnot",
"interne" => "5tERn",
"interné" => "5tERne",
"internée" => "5tERne",
"internées" => "5tERne",
"internement" => "5tERn°m@",
"interner" => "5tERne",
"internes" => "5tERn",
"internés" => "5tERne",
"internet" => "5tERnEt",
"internez" => "5tERne",
"interniste" => "5tERnist",
"interpella" => "5tERpEla",
"interpellai" => "5tERpElE",
"interpellaient" => "5tERpElE",
"interpellais" => "5tERpElE",
"interpellait" => "5tERpElE",
"interpellant" => "5tERpEl@",
"interpellateur" => "5tERpelat9R",
"interpellateurs" => "5tERpelat9R",
"interpellation" => "5tERpelasj§",
"interpellations" => "5tERpelasj§",
"interpelle" => "5tERpEl",
"interpellé" => "5tERpele",
"interpellée" => "5tERpele",
"interpellées" => "5tERpele",
"interpellent" => "5tERpEl",
"interpeller" => "5tERpEle",
"interpellerait" => "5tERpEl°RE",
"interpellèrent" => "5tERpElER",
"interpellés" => "5tERpele",
"interpellez" => "5tERpEle",
"interpénétration" => "5tERpenetRasj§",
"interpénétrations" => "5tERpenetRasj§",
"interpénètre" => "5tERpenEtR",
"interpénètrent" => "5tERpenEtR",
"interpénétrer" => "5tERpenetRe",
"interphase" => "5tERfaz",
"interphone" => "5tERfOn",
"interphones" => "5tERfOn",
"interplanétaire" => "5tERplanetER",
"interplanétaires" => "5tERplanetER",
"interpolateur" => "5tERpOlat9R",
"interpolation" => "5tERpolasj§",
"interpolations" => "5tERpolasj§",
"interpole" => "5tERpOl",
"interpolez" => "5tERpole",
"interposa" => "5tERpoza",
"interposai" => "5tERpozE",
"interposaient" => "5tERpozE",
"interposais" => "5tERpozE",
"interposait" => "5tERpozE",
"interposant" => "5tERpoz@",
"interpose" => "5tERpoz",
"interposé" => "5tERpoze",
"interposée" => "5tERpoze",
"interposées" => "5tERpoze",
"interposent" => "5tERpoz",
"interposer" => "5tERpoze",
"interposera" => "5tERpoz°Ra",
"interposèrent" => "5tERpozER",
"interposeront" => "5tERpoz°R§",
"interposés" => "5tERpoze",
"interposez" => "5tERpoze",
"interposition" => "5tERpozisj§",
"interpréta" => "5tERpReta",
"interprétable" => "5tERpRetabl",
"interprétai" => "5tERpRetE",
"interprétaient" => "5tERpRetE",
"interprétais" => "5tERpRetE",
"interprétait" => "5tERpRetE",
"interprétant" => "5tERpRet@",
"interprétante" => "5tERpRet@t",
"interprétât" => "5tERpReta",
"interprétatif" => "5tERpRetatif",
"interprétation" => "5tERpRetasj§",
"interprétations" => "5tERpRetasj§",
"interprétative" => "5tERpRetativ",
"interprétatives" => "5tERpRetativ",
"interprète" => "5tERpREt",
"interprété" => "5tERpRete",
"interprétée" => "5tERpRete",
"interprétées" => "5tERpRete",
"interprètent" => "5tERpREt",
"interpréter" => "5tERpRete",
"interprétera" => "5tERpRet°Ra",
"interpréteraient" => "5tERpRet°RE",
"interpréterait" => "5tERpRet°RE",
"interprétèrent" => "5tERpRetER",
"interpréteriez" => "5tERpRet°Rje",
"interprètes" => "5tERpREt",
"interprétés" => "5tERpRete",
"interpréteur" => "5tERpRet9R",
"interprétez" => "5tERpRete",
"interprofessionnelle" => "5tERpRofEsjonEl",
"interracial" => "5tERRasjal",
"interraciale" => "5tERasjal",
"interraciaux" => "5tERasjo",
"interrègne" => "5tERREN",
"interrelations" => "5tERR°lasj§",
"interrogateur" => "5tERogat9R",
"interrogateurs" => "5tERogat9R",
"interrogatif" => "5tERogatif",
"interrogatifs" => "5tERogatif",
"interrogation" => "5tERogasj§",
"interrogations" => "5tERogasj§",
"interrogative" => "5tERogativ",
"interrogativement" => "5tERogativ°m@",
"interrogatives" => "5tERogativ",
"interrogatoire" => "5tERogatwaR",
"interrogatoires" => "5tERogatwaR",
"interrogatrice" => "5tEROgatRis",
"interroge" => "5tEROZ",
"interrogé" => "5tERoZe",
"interrogea" => "5tERoZa",
"interrogeai" => "5tERoZE",
"interrogeaient" => "5tERoZE",
"interrogeais" => "5tERoZE",
"interrogeait" => "5tERoZE",
"interrogeâmes" => "5tERoZam",
"interrogeant" => "5tERoZ@",
"interrogeât" => "5tERoZa",
"interrogée" => "5tERoZe",
"interrogées" => "5tERoZe",
"interrogent" => "5tEROZ",
"interrogeons" => "5tERoZ§",
"interroger" => "5tERoZe",
"interrogera" => "5tEROZ°Ra",
"interrogerai" => "5tEROZ°RE",
"interrogeraient" => "5tEROZ°RE",
"interrogerais" => "5tEROZ°RE",
"interrogerait" => "5tEROZ°RE",
"interrogeras" => "5tEROZ°Ra",
"interrogèrent" => "5tERoZER",
"interrogerez" => "5tEROZ°Re",
"interrogerons" => "5tEROZ°R§",
"interrogeront" => "5tEROZ°R§",
"interroges" => "5tEROZ",
"interrogés" => "5tERoZe",
"interrogez" => "5tERoZe",
"interrogiez" => "5tERoZje",
"interrogions" => "5tERoZj§",
"interrompaient" => "5tER§pE",
"interrompais" => "5tER§pE",
"interrompait" => "5tER§pE",
"interrompant" => "5tER§p@",
"interrompe" => "5tER§p",
"interrompent" => "5tER§p",
"interrompes" => "5tER§p",
"interrompez" => "5tER§pe",
"interrompiez" => "5tER§pje",
"interrompirent" => "5tER§piR",
"interrompis" => "5tER§pi",
"interrompisse" => "5tER§pis",
"interrompit" => "5tER§pi",
"interrompît" => "5tER§pi",
"interrompons" => "5tER§p§",
"interrompra" => "5tER§pRa",
"interromprai" => "5tER§pRE",
"interromprais" => "5tER§pRE",
"interromprait" => "5tER§pRE",
"interrompras" => "5tER§pRa",
"interrompre" => "5tER§pR",
"interromps" => "5tER§",
"interrompt" => "5tER§",
"interrompu" => "5tER§py",
"interrompue" => "5tER§py",
"interrompues" => "5tER§py",
"interrompus" => "5tER§py",
"interrupteur" => "5tERypt9R",
"interrupteurs" => "5tERypt9R",
"interruption" => "5tERypsj§",
"interruptions" => "5tERypsj§",
"inters" => "5tER",
"intersaison" => "5tERsEz§",
"interscolaire" => "5tERskOlER",
"intersectant" => "5tERsEkt@",
"intersection" => "5tERseksj§",
"intersections" => "5tERseksj§",
"interservices" => "5tERsERvis",
"intersidéral" => "5tERsideRal",
"intersidérale" => "5tERsideRal",
"intersidéraux" => "5tERsideRo",
"interstellaire" => "5tERstElER",
"interstellaires" => "5tERstElER",
"interstice" => "5tERstis",
"interstices" => "5tERstis",
"intersubjectif" => "5tERsybZEktif",
"intertitre" => "5tERtit°R",
"intertribal" => "5tERt°Ribal",
"interurbain" => "5tERyRb5",
"interurbaine" => "5tERyRbEn",
"intervalle" => "5tERval",
"intervalles" => "5tERval",
"intervenaient" => "5tERv°nE",
"intervenais" => "5tERv°nE",
"intervenait" => "5tERv°nE",
"intervenant" => "5tERv°n@",
"intervenante" => "5tERv2n@t",
"intervenants" => "5tERv°n@",
"intervenez" => "5tERv°ne",
"interveniez" => "5tERv°nje",
"intervenir" => "5tERv°niR",
"intervenons" => "5tERv°n§",
"intervention" => "5tERv@sj§",
"interventionnisme" => "5tERv@sjOnism",
"interventionniste" => "5tERv@sjOnist",
"interventionnistes" => "5tERv@sjonist",
"interventions" => "5tERv@sj§",
"interventriculaire" => "5tERv@t°RikylER",
"intervenu" => "5tERv°ny",
"intervenue" => "5tERv°ny",
"intervenues" => "5tERv°ny",
"intervenus" => "5tERv°ny",
"interversion" => "5tERvERsj§",
"interversions" => "5tERvERsj§",
"intervertébral" => "5tERvERtebRal",
"intervertébraux" => "5tERvERtebRo",
"interverti" => "5tERvERti",
"intervertir" => "5tERvERtiR",
"intervertirai" => "5tERvERtiRE",
"intervertis" => "5tERvERti",
"intervertissait" => "5tERvERtisE",
"intervertissent" => "5tERvERtis",
"intervertissiez" => "5tERvERtisje",
"intervertissons" => "5tERvERtis§",
"intervertit" => "5tERvERti",
"interviendra" => "5tERvj5dRa",
"interviendrai" => "5tERvj5dRE",
"interviendraient" => "5tERvj5dRE",
"interviendrais" => "5tERvj5dRE",
"interviendrait" => "5tERvj5dRE",
"interviendrez" => "5tERvj5dRe",
"interviendrons" => "5tERvj5dR§",
"interviendront" => "5tERvj5dR§",
"intervienne" => "5tERvjEn",
"interviennent" => "5tERvjEn",
"interviens" => "5tERvj5",
"intervient" => "5tERvj5",
"interview" => "5tERvju",
"interviewaient" => "5tERvjuvE",
"interviewais" => "5tERvjuvE",
"interviewait" => "5tERvjuvE",
"interviewe" => "5tERvju",
"interviewé" => "5tERvjuve",
"interviewée" => "5tERvjuve",
"interviewer" => "5tERvjuve",
"interviewèrent" => "5tERvjuvER",
"interviewers" => "5tERvjuv9R",
"interviewés" => "5tERvjuve",
"intervieweur" => "5tERvjuv9R",
"interviews" => "5tERvju",
"intervinrent" => "5tERv5R",
"intervins" => "5tERv5",
"intervinsse" => "5tERv5s",
"intervint" => "5tERv5",
"intervînt" => "5tERv5",
"interzones" => "5tERzon",
"intestat" => "5tEsta",
"intestats" => "5tEsta",
"intestin" => "5tEst5",
"intestinal" => "5tEstinal",
"intestinale" => "5tEstinal",
"intestinales" => "5tEstinal",
"intestinaux" => "5tEstino",
"intestine" => "5tEstin",
"intestines" => "5tEstin",
"intestins" => "5tEst5",
"inti" => "5ti",
"intifada" => "5tifada",
"intima" => "5tima",
"intimait" => "5timE",
"intimant" => "5tim@",
"intimât" => "5tima",
"intimation" => "5timasj§",
"intime" => "5tim",
"intimé" => "5time",
"intimement" => "5tim°m@",
"intimer" => "5time",
"intimerait" => "5tim°RE",
"intimèrent" => "5timER",
"intimes" => "5tim",
"intimés" => "5time",
"intimida" => "5timida",
"intimidable" => "5timidabl",
"intimidaient" => "5timidE",
"intimidais" => "5timidE",
"intimidait" => "5timidE",
"intimidant" => "5timid@",
"intimidante" => "5timid@t",
"intimidants" => "5timid@",
"intimidât" => "5timida",
"intimidateur" => "5timidat9R",
"intimidation" => "5timidasj§",
"intimidations" => "5timidasj§",
"intimide" => "5timid",
"intimidé" => "5timide",
"intimidée" => "5timide",
"intimidées" => "5timide",
"intimident" => "5timid",
"intimider" => "5timide",
"intimiderait" => "5timid°RE",
"intimides" => "5timid",
"intimidés" => "5timide",
"intimidez" => "5timide",
"intimidiez" => "5timidje",
"intimiste" => "5timist",
"intimistes" => "5timist",
"intimité" => "5timite",
"intimités" => "5timite",
"intirable" => "5tiRabl",
"intitula" => "5tityla",
"intitulai" => "5titylE",
"intitulaient" => "5titylE",
"intitulais" => "5titylE",
"intitulait" => "5titylE",
"intitulant" => "5tityl@",
"intitule" => "5tityl",
"intitulé" => "5tityle",
"intitulée" => "5tityle",
"intitulées" => "5tityle",
"intituler" => "5tityle",
"intitulerait" => "5tityl°RE",
"intitulés" => "5tityle",
"intolérable" => "5toleRabl",
"intolérablement" => "5toleRabl°m@",
"intolérables" => "5toleRabl",
"intolérance" => "5toleR@s",
"intolérant" => "5toleR@",
"intolérante" => "5toleR@t",
"intolérants" => "5toleR@",
"intonation" => "5tonasj§",
"intonations" => "5tonasj§",
"intouchable" => "5tuSabl",
"intouchables" => "5tuSabl",
"intouché" => "5tuSe",
"intouchée" => "5tuSe",
"intouchées" => "5tuSe",
"intouchés" => "5tuSe",
"intox" => "5tOks",
"intoxe" => "5tOks",
"intoxicant" => "5tOksik@",
"intoxication" => "5tOksikasj§",
"intoxications" => "5tOksikasj§",
"intoxiquant" => "5tOksik@",
"intoxique" => "5tOksik",
"intoxiqué" => "5tOksike",
"intoxiquée" => "5tOksike",
"intoxiquées" => "5tOksike",
"intoxiquer" => "5tOksike",
"intoxiqués" => "5tOksike",
"intra" => "5tRa",
"intra muros" => "5tRamyRo",
"intra-atomique" => "5tRaatomik",
"intra-muros" => "5tRamyRos",
"intra-rachidienne" => "5tRaRaSidjEn",
"intra-utérine" => "5tRayteRin",
"intra-utérines" => "5tRayteRin",
"intracardiaque" => "5tRakaRdjak",
"intracérébrale" => "5tRaseRebRal",
"intracrânien" => "5tRakRanj5",
"intracrânienne" => "5tRakRanjEn",
"intradermique" => "5tRadERmik",
"intrados" => "5tRado",
"intraduisible" => "5tRad8izibl",
"intraduisibles" => "5tRad8izibl",
"intrait" => "5tRE",
"intraitable" => "5tREtabl",
"intraitables" => "5tREtabl",
"intramusculaire" => "5tRamyskylER",
"intramusculaires" => "5tRamyskylER",
"intranet" => "5tRanEt",
"intransgressible" => "5tR@zgREsibl",
"intransigeance" => "5tR@ziZ@s",
"intransigeances" => "5tR@ziZ@s",
"intransigeant" => "5tR@ziZ@",
"intransigeante" => "5tR@ziZ@t",
"intransigeantes" => "5tR@ziZ@t",
"intransigeants" => "5tR@ziZ@",
"intransitif" => "5tR@zitif",
"intransmissible" => "5tR@smisibl",
"intransportable" => "5tR@spORtabl",
"intransportables" => "5tR@spORtabl",
"intraoculaire" => "5tRaOkylER",
"intravasculaire" => "5tRavaskylER",
"intraveineuse" => "5tRavEn2z",
"intraveineuses" => "5tRavEn2z",
"intraveineux" => "5tRavEn2",
"intrépide" => "5tRepid",
"intrépidement" => "5tRepid°m@",
"intrépides" => "5tRepid",
"intrépidité" => "5tRepidite",
"intrigant" => "5tRig@",
"intrigante" => "5tRig@t",
"intrigantes" => "5tRig@t",
"intrigants" => "5tRig@",
"intrigua" => "5tRiga",
"intriguaient" => "5tRigE",
"intriguait" => "5tRigE",
"intriguant" => "5tRig@",
"intriguassent" => "5tRigas",
"intriguât" => "5tRiga",
"intrigue" => "5tRig",
"intrigué" => "5tRige",
"intriguée" => "5tRige",
"intriguent" => "5tRig",
"intriguer" => "5tRige",
"intriguera" => "5tRig°Ra",
"intriguerait" => "5tRig°RE",
"intriguèrent" => "5tRigER",
"intrigues" => "5tRig",
"intrigués" => "5tRige",
"intriguez" => "5tRige",
"intrinsèque" => "5tR5sEk",
"intrinsèquement" => "5tR5sEk°m@",
"introducteur" => "5tRodykt9R",
"introductif" => "5tRodyktif",
"introduction" => "5tRodyksj§",
"introductions" => "5tRodyksj§",
"introductrice" => "5tRodyktRis",
"introduira" => "5tRod8iRa",
"introduirai" => "5tRod8iRE",
"introduiraient" => "5tRod8iRE",
"introduirais" => "5tRod8iRE",
"introduirait" => "5tRod8iRE",
"introduire" => "5tRod8iR",
"introduirez" => "5tRod8iRe",
"introduirions" => "5tRod8iRj§",
"introduis" => "5tRod8i",
"introduisaient" => "5tRod8izE",
"introduisais" => "5tRod8izE",
"introduisait" => "5tRod8izE",
"introduisant" => "5tRod8iz@",
"introduise" => "5tRod8iz",
"introduisent" => "5tRod8iz",
"introduisez" => "5tRod8ize",
"introduisirent" => "5tRod8iziR",
"introduisis" => "5tRod8izi",
"introduisit" => "5tRod8izi",
"introduisît" => "5tRod8izi",
"introduisons" => "5tRod8iz§",
"introduit" => "5tRod8i",
"introduite" => "5tRod8it",
"introduites" => "5tRod8it",
"introduits" => "5tRod8i",
"introït" => "5tRoit",
"intromission" => "5tRomisj§",
"intronisa" => "5tRoniza",
"intronisait" => "5tRonizE",
"intronisation" => "5tRonizasj§",
"intronise" => "5tRoniz",
"intronisé" => "5tRonize",
"introniser" => "5tROnize",
"introspecter" => "5t°ROspEkte",
"introspectif" => "5tRospEktif",
"introspection" => "5tRospEksj§",
"introspections" => "5tROspeksj§",
"introspective" => "5tRospEktiv",
"introspectives" => "5tRospEktiv",
"introuvable" => "5tRuvabl",
"introuvables" => "5tRuvabl",
"introversions" => "5tRovERsj§",
"introverti" => "5tRovERti",
"introvertie" => "5tROvERti",
"introvertis" => "5tRovERti",
"intrus" => "5tRy",
"intruse" => "5tRyz",
"intruses" => "5tRyz",
"intrusif" => "5tRyzif",
"intrusion" => "5tRyzj§",
"intrusions" => "5tRyzj§",
"intubation" => "5tybasj§",
"intube" => "5tyb",
"intubé" => "5tybe",
"intubée" => "5tybe",
"intuber" => "5tybe",
"intubez" => "5tybe",
"intuitif" => "5t8itif",
"intuitifs" => "5t8itif",
"intuition" => "5t8isj§",
"intuitions" => "5t8isj§",
"intuitive" => "5t8itiv",
"intuitivement" => "5t8itiv°m@",
"intuitives" => "5t8itiv",
"intumescence" => "5tymes@s",
"intussusception" => "5tyssysEpsj§",
"inuit" => "in8it",
"inupik" => "inypik",
"inusabilité" => "inyzabilite",
"inusable" => "inyzabl",
"inusables" => "inyzabl",
"inusité" => "inyzite",
"inusitée" => "inyzite",
"inusitées" => "inyzite",
"inusités" => "inyzite",
"inusuelle" => "inyz8El",
"inutile" => "inytil",
"inutilement" => "inytil°m@",
"inutiles" => "inytil",
"inutilisable" => "inytilizabl",
"inutilisables" => "inytilizabl",
"inutilisation" => "inytilizasj§",
"inutilisé" => "inytilize",
"inutilisée" => "inytilize",
"inutilisées" => "inytilize",
"inutilisés" => "inytilize",
"inutilité" => "inytilite",
"inutilités" => "inytilite",
"invagination" => "5vaZinasj§",
"invaincu" => "5v5ky",
"invaincue" => "5v5ky",
"invaincues" => "5v5ky",
"invaincus" => "5v5ky",
"invalidant" => "5valid@",
"invalidante" => "5valid@t",
"invalidation" => "5validasj§",
"invalide" => "5valid",
"invalidé" => "5valide",
"invalider" => "5valide",
"invalides" => "5valid",
"invalidés" => "5valide",
"invalidité" => "5validite",
"invalidités" => "5validite",
"invariable" => "5vaRjabl",
"invariablement" => "5vaRjabl°m@",
"invariables" => "5vaRjabl",
"invariance" => "5vaRj@s",
"invasif" => "5vazif",
"invasion" => "5vazj§",
"invasions" => "5vazj§",
"invasive" => "5vaziv",
"invasives" => "5vaziv",
"invectiva" => "5vEktiva",
"invectivai" => "5vEktivE",
"invectivaient" => "5vEktivE",
"invectivait" => "5vEktivE",
"invectivant" => "5vEktiv@",
"invective" => "5vEktiv",
"invectivent" => "5vEktiv",
"invectiver" => "5vEktive",
"invectives" => "5vEktiv",
"invendable" => "5v@dabl",
"invendables" => "5v@dabl",
"invendu" => "5v@dy",
"invendues" => "5v@dy",
"invendus" => "5v@dy",
"inventa" => "5v@ta",
"inventai" => "5v@tE",
"inventaient" => "5v@tE",
"inventaire" => "5v@tER",
"inventaires" => "5v@tER",
"inventais" => "5v@tE",
"inventait" => "5v@tE",
"inventant" => "5v@t@",
"inventât" => "5v@ta",
"invente" => "5v@t",
"inventé" => "5v@te",
"inventée" => "5v@te",
"inventées" => "5v@te",
"inventent" => "5v@t",
"inventer" => "5v@te",
"inventera" => "5v@t°Ra",
"inventerai" => "5v@t°RE",
"inventeraient" => "5v@t°RE",
"inventerais" => "5v@t°RE",
"inventerait" => "5v@t°RE",
"inventeras" => "5v@t°Ra",
"inventèrent" => "5v@tER",
"inventerez" => "5v@t°Re",
"inventeriez" => "5v@t°Rje",
"inventerions" => "5v@t°Rj§",
"inventerons" => "5v@t°R§",
"inventeront" => "5v@t°R§",
"inventes" => "5v@t",
"inventés" => "5v@te",
"inventeur" => "5v@t9R",
"inventeurs" => "5v@t9R",
"inventez" => "5v@te",
"inventiez" => "5v@tje",
"inventif" => "5v@tif",
"inventifs" => "5v@tif",
"invention" => "5v@sj§",
"inventions" => "5v@sj§",
"inventive" => "5v@tiv",
"inventivité" => "5v@tivite",
"inventivités" => "5v@tivite",
"inventons" => "5v@t§",
"inventoria" => "5v@toRja",
"inventoriai" => "5v@toRjE",
"inventoriaient" => "5v@toRjE",
"inventoriait" => "5v@toRjE",
"inventorié" => "5v@toRje",
"inventoriée" => "5v@toRje",
"inventoriées" => "5v@toRje",
"inventorient" => "5v@toRi",
"inventorier" => "5v@toRje",
"invérifiable" => "5veRifjabl",
"invérifiables" => "5veRifjabl",
"inversa" => "5vERsa",
"inversaient" => "5vERsE",
"inversait" => "5vERsE",
"inversant" => "5vERs@",
"inverse" => "5vERs",
"inversé" => "5vERse",
"inversée" => "5vERse",
"inversées" => "5vERse",
"inversement" => "5vERs°m@",
"inversent" => "5vERs",
"inverser" => "5vERse",
"inversera" => "5vERs°Ra",
"inverserais" => "5vERs°RE",
"inverserait" => "5vERs°RE",
"inversèrent" => "5vERsER",
"inverses" => "5vERs",
"inversés" => "5vERse",
"inverseur" => "5vERs9R",
"inversez" => "5vERse",
"inversible" => "5vERsibl",
"inversion" => "5vERsj§",
"inversions" => "5vERsj§",
"inversons" => "5vERs§",
"invertébré" => "5vERtebRe",
"invertébrée" => "5vERtebRe",
"invertébrés" => "5vERtebRe",
"inverti" => "5vERti",
"invertis" => "5vERti",
"investi" => "5vEsti",
"investie" => "5vEsti",
"investies" => "5vEsti",
"investigateur" => "5vEstigat9R",
"investigateurs" => "5vEstigat9R",
"investigation" => "5vEstigasj§",
"investigations" => "5vEstigasj§",
"investigatrice" => "5vEstigatRis",
"investigatrices" => "5vEstigatRis",
"investiguant" => "5vEstig@",
"investiguer" => "5vEstige",
"investir" => "5vEstiR",
"investira" => "5vEstiRa",
"investirais" => "5vEstiRE",
"investirait" => "5vEstiRE",
"investirent" => "5vEstiR",
"investirons" => "5vEstiR§",
"investiront" => "5vEstiR§",
"investis" => "5vEsti",
"investissaient" => "5vEstisE",
"investissais" => "5vEstisE",
"investissait" => "5vEstisE",
"investissant" => "5vEstis@",
"investisse" => "5vEstis",
"investissement" => "5vEstis°m@",
"investissements" => "5vEstis°m@",
"investissent" => "5vEstis",
"investisseur" => "5vEstis9R",
"investisseurs" => "5vEstis9R",
"investissez" => "5vEstise",
"investissons" => "5vEstis§",
"investit" => "5vEsti",
"investît" => "5vEsti",
"investiture" => "5vEstityR",
"investitures" => "5vEstityR",
"invétéré" => "5veteRe",
"invétérée" => "5veteRe",
"invétérées" => "5veteRe",
"invétérés" => "5veteRe",
"invincibilité" => "5v5sibilite",
"invincible" => "5v5sibl",
"invinciblement" => "5v5sibl°m@",
"invincibles" => "5v5sibl",
"inviolabilité" => "5vjolabilite",
"inviolable" => "5vjolabl",
"inviolables" => "5vjolabl",
"inviolé" => "5vjole",
"inviolée" => "5vjole",
"inviolées" => "5vjole",
"inviolés" => "5vjole",
"invisibilité" => "5vizibilite",
"invisible" => "5vizibl",
"invisible piston" => "5vizibl°pist§",
"invisiblement" => "5vizibl°m@",
"invisibles" => "5vizibl",
"invita" => "5vita",
"invitai" => "5vitE",
"invitaient" => "5vitE",
"invitais" => "5vitE",
"invitait" => "5vitE",
"invitâmes" => "5vitam",
"invitant" => "5vit@",
"invitante" => "5vit@t",
"invitantes" => "5vit@t",
"invitants" => "5vit@",
"invitât" => "5vita",
"invitation" => "5vitasj§",
"invitations" => "5vitasj§",
"invite" => "5vit",
"invité" => "5vite",
"invitée" => "5vite",
"invitées" => "5vite",
"invitent" => "5vit",
"inviter" => "5vite",
"invitera" => "5vit°Ra",
"inviterai" => "5vit°RE",
"inviteraient" => "5vit°RE",
"inviterais" => "5vit°RE",
"inviterait" => "5vit°RE",
"inviteras" => "5vit°Ra",
"invitèrent" => "5vitER",
"inviterez" => "5vit°Re",
"inviteriez" => "5vit°Rje",
"inviterions" => "5vit°Rj§",
"inviterons" => "5vit°R§",
"inviteront" => "5vit°R§",
"invites" => "5vit",
"invités" => "5vite",
"inviteur" => "5vit9R",
"inviteurs" => "5vit9R",
"invitez" => "5vite",
"invitiez" => "5vitje",
"invitions" => "5vitj§",
"invitons" => "5vit§",
"invivable" => "5vivabl",
"invocation" => "5vokasj§",
"invocations" => "5vokasj§",
"invocatoire" => "5vokatwaR",
"involontaire" => "5vol§tER",
"involontairement" => "5vol§tER°m@",
"involontaires" => "5vol§tER",
"involutif" => "5volytif",
"involutifs" => "5volytif",
"involution" => "5volysj§",
"invoqua" => "5voka",
"invoquai" => "5vokE",
"invoquaient" => "5vokE",
"invoquais" => "5vokE",
"invoquait" => "5vokE",
"invoquant" => "5vok@",
"invoquât" => "5voka",
"invoque" => "5vOk",
"invoqué" => "5voke",
"invoquée" => "5voke",
"invoquées" => "5voke",
"invoquent" => "5vOk",
"invoquer" => "5voke",
"invoquera" => "5vOk°Ra",
"invoquerai" => "5vOk°RE",
"invoquerais" => "5vOk°RE",
"invoquerait" => "5vOk°RE",
"invoquerez" => "5vOk°Re",
"invoquerons" => "5vOk°R§",
"invoques" => "5vOk",
"invoqués" => "5voke",
"invoquez" => "5voke",
"invoquons" => "5vok§",
"invraisemblable" => "5vREs@blabl",
"invraisemblablement" => "5vREs@blabl°m@",
"invraisemblables" => "5vREs@blabl",
"invraisemblance" => "5vREs@bl@s",
"invraisemblances" => "5vREz@bl@s",
"invulnérabilité" => "5vylneRabilite",
"invulnérable" => "5vylneRabl",
"invulnérables" => "5vylneRabl",
"iode" => "jOd",
"iodé" => "jode",
"iodée" => "jode",
"iodle" => "jodl",
"iodler" => "jOdle",
"iodoforme" => "jodofORm",
"iodure" => "jOdyR",
"ion" => "j§",
"ionien" => "jonj5",
"ionienne" => "jonjEn",
"ioniennes" => "jonjEn",
"ioniens" => "jonj5",
"ionique" => "jonik",
"ioniques" => "jonik",
"ionisant" => "jOniz@",
"ionisante" => "jOniz@t",
"ionisation" => "jonizasj§",
"ionisé" => "jonize",
"ionisée" => "jonize",
"ioniser" => "jonize",
"ionisez" => "jonize",
"ionosphère" => "jonosfER",
"ions" => "j§",
"iota" => "jota",
"ipéca" => "ipeka",
"ipécas" => "ipeka",
"ipomée" => "ipome",
"ippon" => "ip§",
"ipse" => "ipse",
"ipso facto" => "ipsofakto",
"ira" => "iRa",
"irai" => "iRE",
"iraient" => "iRE",
"irais" => "iRE",
"irait" => "iRE",
"irakien" => "iRakj5",
"irakienne" => "iRakjEn",
"irakiens" => "iRakj5",
"iranien" => "iRanj5",
"iranienne" => "iRanjEn",
"iraniennes" => "iRanjEn",
"iraniens" => "iRanj5",
"iraquien" => "iRakj5",
"iraquienne" => "iRakijEn",
"iraquiens" => "iRakj5",
"iras" => "iRa",
"irascible" => "iRasibl",
"irascibles" => "iRasibl",
"ire" => "iR",
"ires" => "iR",
"irez" => "iRe",
"iridescence" => "iRidEs@s",
"iridescent" => "iRidEs@",
"iridescentes" => "iRidEs@t",
"iridium" => "iRidjOm",
"iridologie" => "iRidOlOZi",
"iriez" => "iRje",
"irions" => "iRj§",
"iris" => "iRis",
"irisaient" => "iRizE",
"irisait" => "iRizE",
"irisant" => "iRiz@",
"irisation" => "iRizasj§",
"irisations" => "iRizasj§",
"irise" => "iRiz",
"irisé" => "iRize",
"irisée" => "iRize",
"irisées" => "iRize",
"irisent" => "iRiz",
"iriser" => "iRize",
"iriserait" => "iRiz°RE",
"irisés" => "iRize",
"irish coffee" => "ajRiSkOfi",
"irlandais" => "iRl@dE",
"irlandaise" => "iRl@dEz",
"irlandaises" => "iRl@dEz",
"ironie" => "iRoni",
"ironies" => "iRoni",
"ironique" => "iRonik",
"ironiquement" => "iRonik°m@",
"ironiques" => "iRonik",
"ironisa" => "iRoniza",
"ironisai" => "iRonizE",
"ironisais" => "iRonizE",
"ironisait" => "iRonizE",
"ironise" => "iRoniz",
"ironisé" => "iRonize",
"ironisent" => "iRoniz",
"ironiser" => "iRonize",
"ironisme" => "iROnism",
"ironiste" => "iRonist",
"irons" => "iR§",
"iront" => "iR§",
"iroquois" => "iRokwa",
"iroquoise" => "iRokwaz",
"irradia" => "iRadja",
"irradiaient" => "iRadjE",
"irradiait" => "iRadjE",
"irradiant" => "iRadj@",
"irradiante" => "iRadj@t",
"irradiantes" => "iRadj@t",
"irradiation" => "iRadjasj§",
"irradiations" => "iRadjasj§",
"irradie" => "iRadi",
"irradié" => "iRadje",
"irradiée" => "iRadje",
"irradiées" => "iRadje",
"irradier" => "iRadje",
"irradiera" => "iRadiRa",
"irradiés" => "iRadje",
"irradiez" => "iRadje",
"irraisonnable" => "iREzonabl",
"irraisonné" => "iREzone",
"irraisonnée" => "iREzone",
"irraisonnés" => "iREzone",
"irrationalité" => "iRasjonalite",
"irrationnel" => "iRasjonEl",
"irrationnelle" => "iRasjonEl",
"irrationnellement" => "iRasjonEl°m@",
"irrationnelles" => "iRasjonEl",
"irrationnels" => "iRasjonEl",
"irrattrapable" => "iRatRapabl",
"irrattrapables" => "iRatRapabl",
"irréalisable" => "iRealizabl",
"irréalisables" => "iRealizabl",
"irréalisait" => "iRealizE",
"irréalise" => "iRealiz",
"irréalisé" => "iRealize",
"irréalisés" => "iRealize",
"irréalisme" => "iRealizm",
"irréaliste" => "iRealist",
"irréalistes" => "iRealist",
"irréalité" => "iRealite",
"irrecevabilité" => "iR2s°vabilite",
"irrecevable" => "iR2s°vabl",
"irrecevables" => "iR2s°vabl",
"irréconciliable" => "iRek§siljabl",
"irréconciliables" => "iRek§siljabl",
"irrécupérable" => "iRekypeRabl",
"irrécupérables" => "iRekypeRabl",
"irrécusable" => "iRekyzabl",
"irrécusables" => "iRekyzabl",
"irréductible" => "iRedyktibl",
"irréductiblement" => "iRedyktibl°m@",
"irréductibles" => "iRedyktibl",
"irréel" => "iReEl",
"irréelle" => "iReEl",
"irréellement" => "iReEl°m@",
"irréelles" => "iReEl",
"irréels" => "iReEl",
"irréfléchi" => "iRefleSi",
"irréfléchie" => "iRefleSi",
"irréfléchis" => "iRefleSi",
"irréfragable" => "iRefRagabl",
"irréfutable" => "iRefytabl",
"irréfutablement" => "iRefytabl°m@",
"irréfutables" => "iRefytabl",
"irrégularité" => "iRegylaRite",
"irrégularités" => "iRegylaRite",
"irrégulier" => "iRegylje",
"irrégulière" => "iRegyljER",
"irrégulièrement" => "iRegyljER°m@",
"irrégulières" => "iRegyljER",
"irréguliers" => "iRegylje",
"irréligieuse" => "iReliZj2z",
"irréligieux" => "iReliZj2",
"irréligiosité" => "iReliZjozite",
"irrémédiable" => "iRemedjabl",
"irrémédiablement" => "iRemedjabl°m@",
"irrémédiables" => "iRemedjabl",
"irrémissible" => "iRemisibl",
"irremplaçable" => "iR@plasabl",
"irremplaçables" => "iR@plasabl",
"irréparable" => "iRepaRabl",
"irréparablement" => "iRepaRabl°m@",
"irréparables" => "iRepaRabl",
"irreprésentable" => "iR2pRez@tabl",
"irrépressible" => "iRepResibl",
"irrépressibles" => "iRepResibl",
"irréprochable" => "iRepRoSabl",
"irréprochablement" => "iRepRoSabl°m@",
"irréprochables" => "iRepRoSabl",
"irrésistible" => "iRezistibl",
"irrésistiblement" => "iRezistibl°m@",
"irrésistibles" => "iRezistibl",
"irrésolu" => "iRezoly",
"irrésolue" => "iRezOly",
"irrésolues" => "iRezoly",
"irrésolus" => "iRezoly",
"irrésolution" => "iRezolysj§",
"irrespect" => "iREspE",
"irrespectueuse" => "iREspEkt82z",
"irrespectueusement" => "iREspEkt82z°m@",
"irrespectueuses" => "iREspEkt82z",
"irrespectueux" => "iREspEkt82",
"irrespirable" => "iREspiRabl",
"irrespirables" => "iREspiRabl",
"irresponsabilité" => "iREsp§sabilite",
"irresponsable" => "iREsp§sabl",
"irresponsables" => "iREsp§sabl",
"irrétrécissable" => "iRetResisabl",
"irrévérence" => "iReveR@s",
"irrévérencieuse" => "iReveR@sj2z",
"irrévérencieusement" => "iReveR@sj2z°m@",
"irrévérencieuses" => "iReveR@sj2z",
"irrévérencieux" => "iReveR@sj2",
"irréversibilité" => "iRevERsibilite",
"irréversible" => "iRevERsibl",
"irréversiblement" => "iRevERsibl°m@",
"irréversibles" => "iRevERsibl",
"irrévocabilité" => "iRevOkabilite",
"irrévocable" => "iRevokabl",
"irrévocablement" => "iRevokabl°m@",
"irrévocables" => "iRevokabl",
"irrigateur" => "iRigat9R",
"irrigateurs" => "iRigat9R",
"irrigation" => "iRigasj§",
"irriguaient" => "iRigE",
"irriguait" => "iRigE",
"irriguant" => "iRig@",
"irrigue" => "iRig",
"irrigué" => "iRige",
"irriguée" => "iRige",
"irriguées" => "iRige",
"irriguent" => "iRig",
"irriguer" => "iRige",
"irriguera" => "iRig°Ra",
"irrigueraient" => "iRig°RE",
"irriguerait" => "iRig°RE",
"irrigués" => "iRige",
"irriguons" => "iRig§",
"irrita" => "iRita",
"irritabilité" => "iRitabilite",
"irritable" => "iRitabl",
"irritables" => "iRitabl",
"irritai" => "iRitE",
"irritaient" => "iRitE",
"irritais" => "iRitE",
"irritait" => "iRitE",
"irritant" => "iRit@",
"irritante" => "iRit@t",
"irritantes" => "iRit@t",
"irritants" => "iRit@",
"irritât" => "iRita",
"irritation" => "iRitasj§",
"irritations" => "iRitasj§",
"irrite" => "iRit",
"irrité" => "iRite",
"irritée" => "iRite",
"irritées" => "iRite",
"irritent" => "iRit",
"irriter" => "iRite",
"irritera" => "iRit°Ra",
"irriterait" => "iRit°RE",
"irritèrent" => "iRitER",
"irriterons" => "iRit°R§",
"irrités" => "iRite",
"irritez" => "iRite",
"irritons" => "iRit§",
"irroration" => "iRoRasj§",
"irruption" => "iRypsj§",
"irruptions" => "iRypsj§",
"isabelle" => "izabEl",
"isard" => "izaR",
"isards" => "izaR",
"isatis" => "izatis",
"isba" => "izba",
"isbas" => "isba",
"ischémie" => "iskemi",
"ischémique" => "iskemik",
"ischion" => "iskj§",
"islam" => "islam",
"islamique" => "islamik",
"islamiques" => "islamik",
"islamisants" => "islamiz@",
"islamisée" => "islamize",
"islamisées" => "islamize",
"islamiser" => "islamize",
"islamisme" => "islamizm",
"islamiste" => "islamist",
"islamistes" => "islamist",
"islandais" => "isl@dE",
"islandaise" => "isl@dEz",
"ismaélien" => "ismaelj5",
"ismaéliens" => "ismaelj5",
"ismaélite" => "ismaelit",
"ismaïliens" => "ismailj5",
"isme" => "ism",
"isocèle" => "izosEl",
"isochronisme" => "izOkROnism",
"isola" => "izola",
"isolables" => "izolabl",
"isolai" => "izolE",
"isolaient" => "izolE",
"isolais" => "izolE",
"isolait" => "izolE",
"isolant" => "izol@",
"isolante" => "izol@t",
"isolateur" => "izolat9R",
"isolateurs" => "izolat9R",
"isolation" => "izolasj§",
"isolationnisme" => "izolasjonizm",
"isolationniste" => "izolasjonist",
"isolations" => "izolasj§",
"isole" => "izOl",
"isolé" => "izole",
"isolée" => "izole",
"isolées" => "izole",
"isolement" => "izOl°m@",
"isolément" => "izolem@",
"isolements" => "izOl°m@",
"isolent" => "izOl",
"isoler" => "izole",
"isolera" => "izOl°Ra",
"isoleraient" => "izOl°RE",
"isolerait" => "izOl°RE",
"isolèrent" => "izolER",
"isoleront" => "izOl°R§",
"isolés" => "izole",
"isolez" => "izole",
"isoliez" => "izolje",
"isolions" => "izolj§",
"isoloir" => "izolwaR",
"isoloirs" => "izolwaR",
"isomère" => "izOmER",
"isométrique" => "izOmetRik",
"isoniazide" => "izOnjazid",
"isorel" => "izoREl",
"isotherme" => "izOtERm",
"isothermique" => "izOtERmik",
"isotonique" => "izOtOnik",
"isotope" => "izotOp",
"isotopes" => "izotOp",
"isotopique" => "izotopik",
"israélien" => "isRaelj5",
"israélienne" => "isRaeljEn",
"israéliennes" => "isRaeljEn",
"israéliens" => "isRaelj5",
"israélite" => "isRaelit",
"israélites" => "isRaelit",
"israélo-arabe" => "isRaeloaRab",
"israélo-syrienne" => "isRaelosiRjEn",
"issu" => "isy",
"issue" => "isy",
"issues" => "isy",
"issus" => "isy",
"isthme" => "izm",
"isthmes" => "izm",
"isthmique" => "ismik",
"italianisme" => "italjanizm",
"italiano" => "italjano",
"italien" => "italj5",
"italienne" => "italjEn",
"italiennes" => "italjEn",
"italiens" => "italj5",
"italique" => "italik",
"italiques" => "italik",
"italo-allemande" => "italoal°m@d",
"italo-allemandes" => "italoal°m@d",
"italo-américain" => "italoameRik5",
"italo-américaine" => "italoameRikEn",
"italo-brésilien" => "italobRezilj5",
"italo-égyptien" => "italoeZipsj5",
"italo-français" => "italofR@sE",
"italo-françaises" => "italofR@sEz",
"italo-irlandais" => "italoiRl@dE",
"italo-polonais" => "italopolonE",
"ite missa est" => "itemisaEst",
"item" => "itEm",
"ithos" => "itOs",
"ithyphallique" => "itifalik",
"itinéraire" => "itineRER",
"itinéraires" => "itineRER",
"itinérant" => "itineR@",
"itinérante" => "itineR@t",
"itinérantes" => "itineR@t",
"itinérants" => "itineR@",
"itou" => "itu",
"iules" => "jyl",
"ive" => "iv",
"ives" => "iv",
"ivoire" => "ivwaR",
"ivoires" => "ivwaR",
"ivoirien" => "ivwaRj5",
"ivoirienne" => "ivwaRjEn",
"ivoirin" => "ivwaR5",
"ivoirine" => "ivwaRin",
"ivoirines" => "ivwaRin",
"ivoirins" => "ivwaR5",
"ivraie" => "ivRE",
"ivre" => "ivR",
"ivres" => "ivR",
"ivresse" => "ivREs",
"ivresses" => "ivREs",
"ivrognait" => "ivRoNE",
"ivrognasse" => "ivRoNas",
"ivrogne" => "ivRON",
"ivrogner" => "ivRoNe",
"ivrognerie" => "ivRON°Ri",
"ivrognes" => "ivRON",
"ivrognesse" => "ivRoNEs",
"ixe" => "iks",
"ixième" => "iksjEm",
"j" => "Zi",
"jà" => "Za",
"jabadao" => "Zabadao",
"jabot" => "Zabo",
"jaboter" => "Zabote",
"jabots" => "Zabo",
"jacarandas" => "ZakaR@da",
"jacassaient" => "ZakasE",
"jacassais" => "ZakasE",
"jacassait" => "ZakasE",
"jacassant" => "Zakas@",
"jacassante" => "Zakas@t",
"jacassantes" => "Zakas@t",
"jacassants" => "Zakas@",
"jacasse" => "Zakas",
"jacassé" => "Zakase",
"jacassement" => "Zakas°m@",
"jacassements" => "Zakas°m@",
"jacassent" => "Zakas",
"jacasser" => "Zakase",
"jacasseraient" => "Zakas°RE",
"jacasserie" => "Zakas°Ri",
"jacasseries" => "Zakas°Ri",
"jacasses" => "Zakas",
"jacasseur" => "Zakas9R",
"jacasseurs" => "Zakas9R",
"jacasseuse" => "Zakas2z",
"jacassez" => "Zakase",
"jacassière" => "ZakasjER",
"jacassiers" => "Zakasje",
"jacassiez" => "Zakasje",
"jachère" => "ZaSER",
"jachères" => "ZaSER",
"jacinthe" => "Zas5t",
"jacinthes" => "Zas5t",
"jack" => "dZak",
"jacket" => "ZakEt",
"jackets" => "ZakE",
"jackpot" => "Zakpo",
"jacks" => "Zak",
"jacob" => "ZakOb",
"jacobées" => "Zakobe",
"jacobin" => "Zakob5",
"jacobine" => "Zakobin",
"jacobins" => "Zakob5",
"jacobite" => "Zakobit",
"jacobites" => "Zakobit",
"jacot" => "Zako",
"jacquard" => "ZakaR",
"jacqueline" => "Zak°lin",
"jacquemart" => "Zak°maR",
"jacquemarts" => "Zak°maR",
"jacqueries" => "Zak°Ri",
"jacques" => "Zak",
"jacquet" => "ZakE",
"jacquier" => "Zakje",
"jacquot" => "Zako",
"jactais" => "ZaktE",
"jactait" => "ZaktE",
"jactance" => "Zakt@s",
"jactancier" => "Zakt@sje",
"jactant" => "Zakt@",
"jacte" => "Zakt",
"jacté" => "Zakte",
"jactent" => "Zakt",
"jacter" => "Zakte",
"jacteraient" => "Zakt°RE",
"jacterais" => "Zakt°RE",
"jactes" => "Zakt",
"jacteur" => "Zakt9R",
"jactez" => "Zakte",
"jactions" => "Zaktj§",
"jaculatoire" => "ZakylatwaR",
"jacuzzi" => "Zakyzi",
"jacuzzis" => "Zakyzi",
"jade" => "Zad",
"jades" => "Zad",
"jadis" => "Zadis",
"jaffa" => "Zafa",
"jaffas" => "Zafa",
"jaffe" => "Zaf",
"jaffer" => "Zafe",
"jaguar" => "ZagwaR",
"jaguarondi" => "ZagwaR§di",
"jaguars" => "ZagwaR",
"jailli" => "Zaji",
"jaillie" => "Zaji",
"jaillies" => "Zaji",
"jaillir" => "ZajiR",
"jaillira" => "ZajiRa",
"jailliraient" => "ZajiRE",
"jaillirait" => "ZajiRE",
"jaillirent" => "ZajiR",
"jailliront" => "ZajiR§",
"jaillis" => "Zaji",
"jaillissaient" => "ZajisE",
"jaillissait" => "ZajisE",
"jaillissant" => "Zajis@",
"jaillissante" => "Zajis@t",
"jaillissantes" => "Zajis@t",
"jaillissants" => "Zajis@",
"jaillisse" => "Zajis",
"jaillissement" => "Zajis°m@",
"jaillissements" => "Zajis°m@",
"jaillissent" => "Zajis",
"jaillit" => "Zaji",
"jaillît" => "Zaji",
"jaïnistes" => "Zainist",
"jais" => "ZE",
"jaja" => "ZaZa",
"jalmince" => "Zalm5s",
"jalminces" => "Zalm5s",
"jalon" => "Zal§",
"jalonnaient" => "ZalonE",
"jalonnais" => "ZalonE",
"jalonnait" => "ZalonE",
"jalonnant" => "Zalon@",
"jalonne" => "ZalOn",
"jalonné" => "Zalone",
"jalonnée" => "Zalone",
"jalonnent" => "ZalOn",
"jalonner" => "Zalone",
"jalonnés" => "Zalone",
"jalons" => "Zal§",
"jalousaient" => "ZaluzE",
"jalousais" => "ZaluzE",
"jalousait" => "ZaluzE",
"jalousant" => "Zaluz@",
"jalouse" => "Zaluz",
"jalousé" => "Zaluze",
"jalousée" => "Zaluze",
"jalousement" => "Zaluz°m@",
"jalousent" => "Zaluz",
"jalouser" => "Zaluze",
"jalouserais" => "Zaluz°RE",
"jalouses" => "Zaluz",
"jalousie" => "Zaluzi",
"jalousies" => "Zaluzi",
"jaloux" => "Zalu",
"jam" => "dZam",
"jam-session" => "dZamsesj9n",
"jam-sessions" => "dZamsesj9n",
"jamaïcain" => "Zamaik5",
"jamaïcaine" => "ZamaikEn",
"jamaïcains" => "Zamaik5",
"jamaïquain" => "Zamaik5",
"jamaïquains" => "Zamaik5",
"jamais" => "ZamE",
"jamais-vu" => "ZamEvy",
"jambage" => "Z@baZ",
"jambages" => "Z@baZ",
"jambart" => "Z@baR",
"jambe" => "Z@b",
"jambes" => "Z@b",
"jambier" => "Z@bje",
"jambière" => "Z@bjER",
"jambières" => "Z@bjER",
"jambon" => "Z@b§",
"jambonneau" => "Z@bono",
"jambonneaux" => "Z@bono",
"jambons" => "Z@b§",
"jamboree" => "ZamboRi",
"janissaire" => "ZanisER",
"janissaires" => "ZanisER",
"jans" => "Z@",
"jansénisme" => "Z@senizm",
"janséniste" => "Z@senist",
"jansénistes" => "Z@senist",
"jante" => "Z@t",
"jantes" => "Z@t",
"janvier" => "Z@vje",
"jap" => "Zap",
"japon" => "Zap§",
"japonais" => "ZaponE",
"japonaise" => "ZaponEz",
"japonaiserie" => "ZaponEz°Ri",
"japonaises" => "ZaponEz",
"japonerie" => "ZapOn°Ri",
"japoneries" => "ZapOn°Ri",
"japonisants" => "Zaponiz@",
"japoniser" => "Zaponize",
"japons" => "Zap§",
"jappa" => "Zapa",
"jappaient" => "ZapE",
"jappait" => "ZapE",
"jappant" => "Zap@",
"jappe" => "Zap",
"jappé" => "Zape",
"jappement" => "Zap°m@",
"jappements" => "Zap°m@",
"jappent" => "Zap",
"japper" => "Zape",
"jappèrent" => "ZapER",
"jappeur" => "Zap9R",
"japs" => "Zap",
"jaquelin" => "ZakEl5",
"jaquemart" => "Zak°maR",
"jaquemarts" => "Zak°maR",
"jaquet" => "ZakE",
"jaquette" => "ZakEt",
"jaquettes" => "ZakEt",
"jar" => "ZaR",
"jardin" => "ZaRd5",
"jardinage" => "ZaRdinaZ",
"jardinait" => "ZaRdinE",
"jardinant" => "ZaRdin@",
"jardine" => "ZaRdin",
"jardiné" => "ZaRdine",
"jardinent" => "ZaRdin",
"jardiner" => "ZaRdine",
"jardinerai" => "ZaRdin°RE",
"jardineras" => "ZaRdin°Ra",
"jardinerie" => "ZaRdin°Ri",
"jardinet" => "ZaRdinE",
"jardinets" => "ZaRdinE",
"jardinier" => "ZaRdinje",
"jardinière" => "ZaRdinjER",
"jardinières" => "ZaRdinjER",
"jardiniers" => "ZaRdinje",
"jardins" => "ZaRd5",
"jargon" => "ZaRg§",
"jargonnant" => "ZaRgon@",
"jargonne" => "ZaRgOn",
"jargonné" => "ZaRgone",
"jargonnent" => "ZaRgOn",
"jargonner" => "ZaRgone",
"jargons" => "ZaRg§",
"jarnicoton" => "ZaRnikot§",
"jarre" => "ZaR",
"jarres" => "ZaR",
"jarret" => "ZaRE",
"jarretelle" => "ZaR°tEl",
"jarretelles" => "ZaR°tEl",
"jarretière" => "ZaR°tjER",
"jarretières" => "ZaR°tjER",
"jarrets" => "ZaRE",
"jars" => "ZaR",
"jas" => "Za",
"jasaient" => "ZazE",
"jasait" => "ZazE",
"jase" => "Zaz",
"jasé" => "Zaze",
"jasent" => "Zaz",
"jaser" => "Zaze",
"jaserait" => "Zaz°RE",
"jases" => "Zaz",
"jaseur" => "Zaz9R",
"jasmin" => "Zasm5",
"jasmins" => "Zasm5",
"jaspaient" => "ZaspE",
"jaspe" => "Zasp",
"jaspé" => "Zaspe",
"jaspées" => "Zaspe",
"jasper" => "Zaspe",
"jaspés" => "Zaspe",
"jaspin" => "Zasp5",
"jaspinaient" => "ZaspinE",
"jaspinais" => "ZaspinE",
"jaspinait" => "ZaspinE",
"jaspine" => "Zaspin",
"jaspiné" => "Zaspine",
"jaspinent" => "Zaspin",
"jaspiner" => "Zaspine",
"jatte" => "Zat",
"jattes" => "Zat",
"jauge" => "ZoZ",
"jaugé" => "ZoZe",
"jaugea" => "ZoZa",
"jaugeait" => "ZoZE",
"jaugeant" => "ZoZ@",
"jaugée" => "ZoZe",
"jaugent" => "ZoZ",
"jauger" => "ZoZe",
"jauges" => "ZoZ",
"jaugés" => "ZoZe",
"jaugez" => "ZoZe",
"jaunasse" => "Zonas",
"jaunasses" => "Zonas",
"jaunâtre" => "ZonatR",
"jaunâtres" => "ZonatR",
"jaune" => "Zon",
"jaune-vert" => "ZonvER",
"jaunes" => "Zon",
"jaunets" => "ZonE",
"jauni" => "Zoni",
"jaunie" => "Zoni",
"jaunies" => "Zoni",
"jaunir" => "ZoniR",
"jaunira" => "ZoniRa",
"jauniront" => "ZoniR§",
"jaunis" => "Zoni",
"jaunissaient" => "ZonisE",
"jaunissait" => "ZonisE",
"jaunissant" => "Zonis@",
"jaunissante" => "Zonis@t",
"jaunissantes" => "Zonis@t",
"jaunissants" => "Zonis@",
"jaunisse" => "Zonis",
"jaunissement" => "Zonis°m@",
"jaunissent" => "Zonis",
"jaunisses" => "Zonis",
"jaunit" => "Zoni",
"java" => "Zava",
"javanais" => "ZavanE",
"javanaise" => "ZavanEz",
"javanaises" => "ZavanEz",
"javas" => "Zava",
"javel" => "ZavEl",
"javeline" => "Zav°lin",
"javelle" => "ZavEl",
"javelles" => "ZavEl",
"javellise" => "ZavEliz",
"javellisé" => "ZavElize",
"javellisée" => "ZavElize",
"javellisées" => "ZavElize",
"javelliser" => "Zavelize",
"javelot" => "Zav°lo",
"javelots" => "Zav°lo",
"javotte" => "ZavOt",
"jazz" => "dZaz",
"jazz-band" => "dZazb@d",
"jazz-rock" => "dZazROk",
"jazzman" => "dZazman",
"jazzmen" => "dZazmEn",
"jazzy" => "dZazi",
"je" => "Z2",
"je-m'en-fichiste" => "Z°m@fiSist",
"je-m'en-foutisme" => "Z2m@futizm",
"je-m'en-foutiste" => "Z2m@futist",
"je-m'en-foutistes" => "Z°m@futist",
"je-ne-sais-quoi" => "Z°n°sekwa",
"jean" => "dZin",
"jean-foutre" => "Z@futR",
"jean-le-blanc" => "Z@l°bl@",
"jeanneton" => "Zan°t§",
"jeannette" => "ZanEt",
"jeannettes" => "ZanEt",
"jeannot" => "Zano",
"jeans" => "dZins",
"jeep" => "dZip",
"jeeps" => "dZip",
"jéjunale" => "ZeZynal",
"jéjunum" => "ZeZynOm",
"jellaba" => "dZElaba",
"jenny" => "Zeni",
"jérémiade" => "ZeRemjad",
"jérémiades" => "ZeRemjad",
"jerez" => "xeREs",
"jerk" => "dZERk",
"jéroboam" => "ZeRoboam",
"jéroboams" => "ZeRoboam",
"jerrican" => "ZeRikan",
"jerricane" => "ZERikan",
"jerricanes" => "ZERikan",
"jerricans" => "ZeRikan",
"jerrycan" => "ZeRikan",
"jerrycans" => "ZeRikan",
"jersey" => "ZERzE",
"jerseys" => "ZERsE",
"jésuite" => "Zez8it",
"jésuites" => "Zez8it",
"jésuitière" => "Zez8itjER",
"jésuitique" => "Zez8itik",
"jésuitiques" => "Zez8itik",
"jésus" => "Zezy",
"jet" => "dZEt",
"jet society" => "dZEtsosajti",
"jet-set" => "dZEtsEt",
"jet-stream" => "dZEtstRim",
"jeta" => "Z°ta",
"jetable" => "Z°tabl",
"jetables" => "Z°tabl",
"jetai" => "Z°tE",
"jetaient" => "Z°tE",
"jetais" => "Z°tE",
"jetait" => "Z°tE",
"jetâmes" => "Z°tam",
"jetant" => "Z°t@",
"jetas" => "Z°ta",
"jetât" => "Z°ta",
"jeté" => "Z°te",
"jetée" => "Z°te",
"jetées" => "Z°te",
"jeter" => "Z°te",
"jetèrent" => "Z°tER",
"jetés" => "Z°te",
"jeteur" => "Z°t9R",
"jeteurs" => "Z°t9R",
"jeteuse" => "Z°t2z",
"jeteuses" => "Z°t2z",
"jetez" => "Z°te",
"jetiez" => "Z°tje",
"jetions" => "Z°tj§",
"jeton" => "Z°t§",
"jetons" => "Z°t§",
"jets" => "dZEt",
"jette" => "ZEt",
"jettent" => "ZEt",
"jettera" => "ZEt°Ra",
"jetterai" => "ZEt°RE",
"jetteraient" => "ZEt°RE",
"jetterais" => "ZEt°RE",
"jetterait" => "ZEt°RE",
"jetteras" => "ZEt°Ra",
"jetterez" => "ZEt°Re",
"jetteriez" => "ZEt°Rje",
"jetterions" => "ZEt°Rj§",
"jetterons" => "ZEt°R§",
"jetteront" => "ZEt°R§",
"jettes" => "ZEt",
"jeu" => "Z2",
"jeu-concours" => "Z2k§kuR",
"jeudi" => "Z2di",
"jeudis" => "Z2di",
"jeûna" => "Z2na",
"jeûnaient" => "Z2nE",
"jeûnait" => "Z2nE",
"jeûnant" => "Z2n@",
"jeune" => "Z9n",
"jeûne" => "Z2n",
"jeûné" => "Z2ne",
"jeune-homme" => "Z9nOm",
"jeunement" => "Z9n°m@",
"jeûnent" => "Z2n",
"jeûner" => "Z2ne",
"jeûnerai" => "Z2n°RE",
"jeûnerait" => "Z2n°RE",
"jeûneras" => "Z2n°Ra",
"jeûnerons" => "Z2n°R§",
"jeunes" => "Z9n",
"jeûnes" => "Z2n",
"jeunesse" => "Z9nEs",
"jeunesses" => "Z9nEs",
"jeunet" => "Z9nE",
"jeunets" => "Z9nE",
"jeunette" => "Z9nEt",
"jeunettes" => "Z9nEt",
"jeûneurs" => "Z2n9R",
"jeûnez" => "Z2ne",
"jeunot" => "Z9no",
"jeunots" => "Z9no",
"jeux" => "Z2",
"jèze" => "ZEz",
"jèzes" => "ZEz",
"jigger" => "dZig9R",
"jihad" => "dZijad",
"jingle" => "dZing9l",
"jingles" => "dZing9ls",
"jinjin" => "dZindZin",
"jiu-jitsu" => "ZjyZitsy",
"jivaro" => "ZivaRo",
"joaillerie" => "Zoaj°Ri",
"joaillier" => "Zoaje",
"joailliers" => "Zoaje",
"job" => "dZOb",
"jobard" => "ZobaR",
"jobardes" => "ZobaRd",
"jobardise" => "ZobaRdiz",
"jobards" => "ZobaR",
"jobs" => "dZOb",
"jociste" => "Zosist",
"jocistes" => "Zosist",
"jockey" => "ZokE",
"jockeys" => "ZokE",
"jocko" => "ZOko",
"jocrisse" => "ZokRis",
"jocrisses" => "ZokRis",
"jodhpurs" => "ZodpyR",
"jodler" => "jOdl9R",
"jogger" => "dZOge",
"joggers" => "dZOg9R",
"joggeur" => "dZOg9R",
"joggeurs" => "dZOgZ9R",
"joggeuse" => "dZOg2z",
"jogging" => "dZOgiG",
"joggings" => "dZOgiG",
"johannisberg" => "ZOanisb9Rg",
"joice" => "Zwas",
"joices" => "Zwas",
"joie" => "Zwa",
"joies" => "Zwa",
"joignable" => "ZwaNabl",
"joignaient" => "ZwaNE",
"joignais" => "ZwaNE",
"joignait" => "ZwaNE",
"joignant" => "ZwaN@",
"joigne" => "ZwaN",
"joignent" => "ZwaN",
"joignes" => "ZwaN",
"joignez" => "ZwaNe",
"joigniez" => "ZwaNe",
"joignîmes" => "ZwaNim",
"joignions" => "ZwaN§",
"joignirent" => "ZwaNiR",
"joignis" => "ZwaNi",
"joignissent" => "ZwaNis",
"joignit" => "ZwaNi",
"joignons" => "ZwaN§",
"joindra" => "Zw5dRa",
"joindrai" => "Zw5dRE",
"joindraient" => "Zw5dRE",
"joindrais" => "Zw5dRE",
"joindrait" => "Zw5dRE",
"joindras" => "Zw5dRa",
"joindre" => "Zw5dR",
"joindrez" => "Zw5dRe",
"joindriez" => "Zw5dRie",
"joindrons" => "Zw5dR§",
"joindront" => "Zw5dR§",
"joins" => "Zw5",
"joint" => "Zw5",
"joint-venture" => "dZOjntvEntS9R",
"jointe" => "Zw5t",
"jointée" => "Zw5te",
"jointes" => "Zw5t",
"jointés" => "Zw5te",
"jointif" => "Zw5tif",
"jointifs" => "Zw5tif",
"jointives" => "Zw5tiv",
"jointoyaient" => "Zw5twajE",
"joints" => "Zw5",
"jointure" => "Zw5tyR",
"jointures" => "Zw5tyR",
"jojo" => "ZoZo",
"jojoba" => "ZoZoba",
"jojos" => "ZoZo",
"jokari" => "ZokaRi",
"joker" => "ZokER",
"jokers" => "ZokER",
"joli" => "Zoli",
"joli-coeur" => "ZOlik9R",
"joli-joli" => "ZOliZOli",
"jolibois" => "ZOlibwa",
"jolie" => "Zoli",
"jolies" => "Zoli",
"joliesse" => "ZoljEs",
"joliesses" => "ZoljEs",
"joliet" => "ZOljE",
"joliette" => "ZoljEt",
"joliment" => "Zolim@",
"jolis" => "Zoli",
"jonc" => "Z§",
"joncaille" => "Z§kaj",
"jonchaie" => "Z§SE",
"jonchaient" => "Z§SE",
"jonchaies" => "Z§SE",
"jonchait" => "Z§SE",
"jonchant" => "Z§S@",
"jonché" => "Z§Se",
"jonchée" => "Z§Se",
"jonchées" => "Z§Se",
"jonchent" => "Z§S",
"joncher" => "Z§Se",
"joncheraies" => "Z§S°RE",
"jonchère" => "Z§SER",
"jonchés" => "Z§Se",
"jonchet" => "Z§SE",
"jonchets" => "Z§SE",
"joncs" => "Z§",
"jonction" => "Z§ksj§",
"jonctions" => "Z§ksj§",
"jonglage" => "Z§glaZ",
"jonglaient" => "Z§glE",
"jonglais" => "Z§glE",
"jonglait" => "Z§glE",
"jonglant" => "Z§gl@",
"jongle" => "Z§gl",
"jonglé" => "Z§gle",
"jonglent" => "Z§gl",
"jongler" => "Z§gle",
"jonglera" => "Z§gl°Ra",
"jonglerie" => "Z§gl°Ri",
"jongleries" => "Z§gl°Ri",
"jongles" => "Z§gl",
"jongleur" => "Z§gl9R",
"jongleurs" => "Z§gl9R",
"jongleuse" => "Z§gl2z",
"jongleuses" => "Z§gl2z",
"jonglez" => "Z§gle",
"jonkheer" => "jOnkER",
"jonque" => "Z§k",
"jonques" => "Z§k",
"jonquille" => "Z§kij",
"jonquilles" => "Z§kij",
"jordanienne" => "ZORdanjEn",
"jordaniens" => "ZORdanj5",
"jordonner" => "ZORdOne",
"joseph" => "ZozEf",
"joua" => "Zwa",
"jouable" => "Zwabl",
"jouai" => "ZwE",
"jouaient" => "ZwE",
"jouais" => "ZwE",
"jouait" => "ZwE",
"jouâmes" => "Zwam",
"jouant" => "Zw@",
"jouasse" => "Zwas",
"jouasses" => "Zwas",
"jouât" => "Zwa",
"joubarbe" => "ZubaRb",
"joue" => "Zu",
"joué" => "Zwe",
"jouée" => "Zwe",
"jouées" => "Zwe",
"jouent" => "Zu",
"jouer" => "Zwe",
"jouera" => "ZuRa",
"jouerai" => "ZuRE",
"joueraient" => "ZuRE",
"jouerais" => "ZuRE",
"jouerait" => "ZuRE",
"joueras" => "ZuRa",
"jouèrent" => "ZwER",
"jouerez" => "ZuRe",
"joueriez" => "ZuRje",
"jouerions" => "ZuRj§",
"jouerons" => "ZuR§",
"joueront" => "ZuR§",
"joues" => "Zu",
"joués" => "Zwe",
"jouet" => "ZwE",
"jouets" => "ZwE",
"joueur" => "Zw9R",
"joueurs" => "Zw9R",
"joueuse" => "Zw2z",
"joueuses" => "Zw2z",
"jouez" => "Zue",
"joufflu" => "Zufly",
"joufflue" => "Zufly",
"joufflues" => "Zufly",
"joufflus" => "Zufly",
"joug" => "Zu",
"jougs" => "Zu",
"joui" => "Zwi",
"jouiez" => "Zuje",
"jouions" => "Zuj§",
"jouir" => "ZwiR",
"jouira" => "ZwiRa",
"jouirai" => "ZwiRE",
"jouiraient" => "ZwiRE",
"jouirait" => "ZwiRE",
"jouiras" => "ZwiRa",
"jouirent" => "ZwiR",
"jouirions" => "ZwiRj§",
"jouirons" => "ZwiR§",
"jouis" => "Zwi",
"jouissaient" => "ZwisE",
"jouissais" => "ZwisE",
"jouissait" => "ZwisE",
"jouissance" => "Zwis@s",
"jouissances" => "Zwis@s",
"jouissant" => "Zwis@",
"jouissants" => "Zwis@",
"jouisse" => "Zwis",
"jouissent" => "Zwis",
"jouisses" => "Zwis",
"jouisseur" => "Zwis9R",
"jouisseurs" => "Zwis9R",
"jouisseuse" => "Zwis2z",
"jouissez" => "Zwise",
"jouissif" => "Zwisif",
"jouissifs" => "Zwisif",
"jouissions" => "Zwisj§",
"jouissive" => "Zwisiv",
"jouissives" => "Zwisiv",
"jouissons" => "Zwis§",
"jouit" => "Zwi",
"joujou" => "ZuZu",
"joujoux" => "ZuZu",
"joules" => "Zul",
"jouons" => "Zw§",
"jour" => "ZuR",
"journal" => "ZuRnal",
"journaleuse" => "ZuRnal2z",
"journaleux" => "ZuRnal2",
"journalier" => "ZuRnalje",
"journalière" => "ZuRnaljER",
"journalières" => "ZuRnaljER",
"journaliers" => "ZuRnalje",
"journalisme" => "ZuRnalizm",
"journaliste" => "ZuRnalist",
"journalistes" => "ZuRnalist",
"journalistique" => "ZuRnalistik",
"journalistiques" => "ZuRnalistik",
"journaux" => "ZuRno",
"journée" => "ZuRne",
"journées" => "ZuRne",
"journellement" => "ZuRnEl°m@",
"jours" => "ZuR",
"joute" => "Zut",
"jouté" => "Zute",
"jouter" => "Zute",
"joutes" => "Zut",
"jouteur" => "Zut9R",
"jouteurs" => "Zut9R",
"jouteuse" => "Zut2z",
"joutez" => "Zute",
"jouvence" => "Zuv@s",
"jouvenceau" => "Zuv@so",
"jouvenceaux" => "Zuv@so",
"jouvencelle" => "Zuv@sEl",
"jouvencelles" => "Zuv@sEl",
"jouxtaient" => "ZukstE",
"jouxtait" => "ZukstE",
"jouxtant" => "Zukst@",
"jouxte" => "Zukst",
"jovial" => "Zovjal",
"joviale" => "Zovjal",
"jovialement" => "Zovjal°m@",
"joviales" => "Zovjal",
"jovialité" => "Zovjalite",
"joviaux" => "Zovjo",
"joyau" => "Zwajo",
"joyaux" => "Zwajo",
"joyciennes" => "ZwajsjEn",
"joyeuse" => "Zwaj2z",
"joyeusement" => "Zwaj2z°m@",
"joyeuses" => "Zwaj2z",
"joyeuseté" => "Zwaj2z°te",
"joyeusetés" => "Zwaj2z°te",
"joyeux" => "Zwaj2",
"joystick" => "ZOjstik",
"juan" => "xwan",
"jubé" => "Zybe",
"jubila" => "Zybila",
"jubilai" => "ZybilE",
"jubilaient" => "ZybilE",
"jubilaire" => "ZybilER",
"jubilais" => "ZybilE",
"jubilait" => "ZybilE",
"jubilant" => "Zybil@",
"jubilante" => "Zybil@t",
"jubilantes" => "Zybil@t",
"jubilants" => "Zybil@",
"jubilation" => "Zybilasj§",
"jubilations" => "Zybilasj§",
"jubilatoire" => "ZybilatwaR",
"jubilatoires" => "ZybilatwaR",
"jubile" => "Zybil",
"jubilé" => "Zybile",
"jubilée" => "Zybile",
"jubilent" => "Zybil",
"jubiler" => "Zybile",
"jubilera" => "Zybil°Ra",
"jubileraient" => "Zybil°RE",
"jubilèrent" => "ZybilER",
"jubiles" => "Zybil",
"jucha" => "ZySa",
"juchai" => "ZySE",
"juchaient" => "ZySE",
"juchais" => "ZySE",
"juchait" => "ZySE",
"juchant" => "ZyS@",
"juche" => "ZyS",
"juché" => "ZySe",
"juchée" => "ZySe",
"juchées" => "ZySe",
"juchent" => "ZyS",
"jucher" => "ZySe",
"jucheront" => "ZyS°R§",
"juchés" => "ZySe",
"juchions" => "ZySj§",
"judaïcité" => "Zydaisite",
"judaïque" => "Zydaik",
"judaïques" => "Zydaik",
"judaïsant" => "Zydaiz@",
"judaïsées" => "Zydaize",
"judaïser" => "Zydaize",
"judaïsme" => "Zydaizm",
"judaïté" => "Zydaite",
"judas" => "Zyda",
"judéen" => "Zyde5",
"judéenne" => "ZydeEn",
"judéité" => "Zydeite",
"judéo" => "Zydeo",
"judéo-chrétienne" => "ZydeokRetjEn",
"judéo-chrétiennes" => "ZydeokRetjEn",
"judéo-chrétiens" => "ZydeokRetj5",
"judéo-christianisme" => "ZydeokRistjanism",
"judiciaire" => "ZydisjER",
"judiciaires" => "ZydisjER",
"judicieuse" => "Zydisj2z",
"judicieusement" => "Zydisj2z°m@",
"judicieuses" => "Zydisj2z",
"judicieux" => "Zydisj2",
"judo" => "Zydo",
"judoka" => "Zydoka",
"juge" => "ZyZ",
"jugé" => "ZyZe",
"jugea" => "ZyZa",
"jugeai" => "ZyZE",
"jugeaient" => "ZyZE",
"jugeais" => "ZyZE",
"jugeait" => "ZyZE",
"jugeâmes" => "ZyZam",
"jugeant" => "ZyZ@",
"jugeât" => "ZyZa",
"jugée" => "ZyZe",
"jugées" => "ZyZe",
"jugement" => "ZyZ°m@",
"jugements" => "ZyZ°m@",
"jugent" => "ZyZ",
"jugeons" => "ZyZ§",
"jugeote" => "ZyZOt",
"juger" => "ZyZe",
"jugera" => "ZyZ°Ra",
"jugerai" => "ZyZ°RE",
"jugeraient" => "ZyZ°RE",
"jugerais" => "ZyZ°RE",
"jugerait" => "ZyZ°RE",
"jugeras" => "ZyZ°Ra",
"jugèrent" => "ZyZER",
"jugerez" => "ZyZ°Re",
"jugeriez" => "ZyZ2Rje",
"jugerons" => "ZyZ°R§",
"jugeront" => "ZyZ°R§",
"juges" => "ZyZ",
"jugés" => "ZyZe",
"jugeur" => "ZyZ9R",
"jugez" => "ZyZe",
"jugiez" => "ZyZje",
"jugions" => "ZyZj§",
"jugula" => "Zygyla",
"jugulaire" => "ZygylER",
"jugulaires" => "ZygylER",
"jugulant" => "Zygyl@",
"jugule" => "Zygyl",
"jugulé" => "Zygyle",
"jugulée" => "Zygyle",
"juguler" => "Zygyle",
"juif" => "Z8if",
"juifs" => "Z8if",
"juillet" => "Z8ijE",
"juillets" => "Z8ijE",
"juin" => "Z85",
"juive" => "Z8iv",
"juiverie" => "Z8iv°Ri",
"juiveries" => "Z8iv°Ri",
"juives" => "Z8iv",
"jujube" => "ZyZyb",
"jujubes" => "ZyZyb",
"jujubiers" => "ZyZybje",
"juke-box" => "dZukbOks",
"juke-boxes" => "dZukbOks",
"julep" => "ZylEp",
"juleps" => "ZylEp",
"jules" => "Zyl",
"julien" => "Zylj5",
"julienne" => "ZyljEn",
"juliennes" => "ZyljEn",
"julot" => "Zylo",
"julots" => "Zylo",
"jumbo" => "dZ9mbo",
"jumeau" => "Zymo",
"jumeaux" => "Zymo",
"jumelage" => "Zym°laZ",
"jumelé" => "Zym°le",
"jumelée" => "Zym°le",
"jumelées" => "Zym°le",
"jumeler" => "Zym°le",
"jumelés" => "Zym°le",
"jumelle" => "ZymEl",
"jumellera" => "ZymEl°Ra",
"jumelles" => "ZymEl",
"jument" => "Zym@",
"jumenterie" => "Zym@t°Ri",
"juments" => "Zym@",
"jumper" => "dZ9mp9R",
"jumping" => "dZ9mpiG",
"jungien" => "juGj5",
"jungiens" => "juGj5",
"jungle" => "Z1gl",
"jungles" => "Z1gl",
"junior" => "ZynjOR",
"juniors" => "ZynjOR",
"junker" => "Z9nkER",
"junkers" => "Z9nkER",
"junkie" => "Z9nki",
"junkies" => "Z9nki",
"junky" => "Zynki",
"junte" => "Z1t",
"jupe" => "Zyp",
"jupe-culotte" => "ZypkylOt",
"jupée" => "Zype",
"jupées" => "Zype",
"jupes" => "Zyp",
"jupes-culottes" => "ZypkylOt",
"jupette" => "ZypEt",
"jupettes" => "ZypEt",
"jupiers" => "Zypje",
"jupitérien" => "ZypiteRj5",
"jupitérienne" => "ZypiteRjEn",
"jupitériens" => "ZypiteRj5",
"jupon" => "Zyp§",
"juponnée" => "Zypone",
"juponnés" => "Zypone",
"jupons" => "Zyp§",
"jura" => "ZyRa",
"jurai" => "ZyRE",
"juraient" => "ZyRE",
"jurais" => "ZyRE",
"jurait" => "ZyRE",
"jurâmes" => "ZyRam",
"jurançon" => "ZyR@s§",
"jurant" => "ZyR@",
"jurassien" => "ZyRasj5",
"jurassiens" => "ZyRasj5",
"jurassique" => "ZyRasik",
"jurassiques" => "ZyRasik",
"jure" => "ZyR",
"juré" => "ZyRe",
"jurée" => "ZyRe",
"jurées" => "ZyRe",
"jurent" => "ZyR",
"jurer" => "ZyRe",
"jurera" => "ZyR°Ra",
"jurerai" => "ZyR°RE",
"jurerais" => "ZyR°RE",
"jurerait" => "ZyR°RE",
"jureras" => "ZyR°Ra",
"jurèrent" => "ZyRER",
"jurerez" => "ZyR°Re",
"jureriez" => "ZyR°Rje",
"jureront" => "ZyR°R§",
"jures" => "ZyR",
"jurés" => "ZyRe",
"jurez" => "ZyRe",
"juridiction" => "ZyRidiksj§",
"juridictionnel" => "ZyRidiksjOnEl",
"juridictionnelle" => "ZyRidiksjOnEl",
"juridictions" => "ZyRidiksj§",
"juridique" => "ZyRidik",
"juridiquement" => "ZyRidik°m@",
"juridiques" => "ZyRidik",
"juriez" => "ZyRje",
"jurisprudence" => "ZyRispRyd@s",
"juriste" => "ZyRist",
"juristes" => "ZyRist",
"juron" => "ZyR§",
"jurons" => "ZyR§",
"jury" => "ZyRi",
"jurys" => "ZyRi",
"jus" => "Zy",
"jusant" => "Zyz@",
"jusqu" => "Zysk",
"jusqu'à" => "Zyska",
"jusqu'au" => "Zysko",
"jusque" => "Zysk",
"jusque-là" => "Zysk°la",
"jusques" => "Zysk",
"jusquiame" => "Zyskjam",
"justaucorps" => "ZystokOR",
"juste" => "Zyst",
"juste-milieu" => "Zyst°milj2",
"justement" => "Zyst°m@",
"justes" => "Zyst",
"justesse" => "ZystEs",
"justice" => "Zystis",
"justices" => "Zystis",
"justiciable" => "Zystisjabl",
"justiciables" => "Zystisjabl",
"justicier" => "Zystisje",
"justicière" => "ZystisjER",
"justiciers" => "Zystisje",
"justifia" => "Zystifja",
"justifiable" => "Zystifjabl",
"justifiables" => "Zystifjabl",
"justifiaient" => "ZystifjE",
"justifiais" => "ZystifjE",
"justifiait" => "ZystifjE",
"justifiant" => "Zystifj@",
"justifiât" => "Zystifja",
"justificatif" => "Zystifikatif",
"justificatifs" => "Zystifikatif",
"justification" => "Zystifikasj§",
"justifications" => "Zystifikasj§",
"justificative" => "Zystifikativ",
"justificatives" => "Zystifikativ",
"justifie" => "Zystifi",
"justifié" => "Zystifje",
"justifiée" => "Zystifje",
"justifiées" => "Zystifje",
"justifient" => "Zystifi",
"justifier" => "Zystifje",
"justifiera" => "ZystifiRa",
"justifierai" => "ZystifiRE",
"justifieraient" => "ZystifiRE",
"justifierais" => "ZystifiRE",
"justifierait" => "ZystifiRE",
"justifiés" => "Zystifje",
"justifiez" => "Zystifje",
"justinien" => "Zystinj5",
"juta" => "Zyta",
"jutait" => "ZytE",
"jute" => "Zyt",
"juté" => "Zyte",
"juter" => "Zyte",
"juteuse" => "Zyt2z",
"juteuses" => "Zyt2z",
"juteux" => "Zyt2",
"juvénile" => "Zyvenil",
"juvéniles" => "Zyvenil",
"juvénilité" => "Zyvenilite",
"juxtaposaient" => "ZykstapozE",
"juxtaposais" => "ZykstapozE",
"juxtaposait" => "ZykstapozE",
"juxtaposant" => "Zykstapoz@",
"juxtapose" => "Zykstapoz",
"juxtaposées" => "Zykstapoze",
"juxtaposent" => "Zykstapoz",
"juxtaposer" => "Zykstapoze",
"juxtaposèrent" => "ZykstapozER",
"juxtaposés" => "Zykstapoze",
"juxtaposition" => "Zykstapozisj§",
"juxtapositions" => "Zykstapozisj§",
"k" => "ka",
"k-o" => "kao",
"k-way" => "kawe",
"ka" => "ka",
"kabarde" => "kabaRd",
"kabbale" => "kabal",
"kabbalistique" => "kabalistik",
"kabuki" => "kabuki",
"kabyle" => "kabil",
"kabyles" => "kabil",
"kacha" => "kaSa",
"kacher" => "kaSe",
"kachoube" => "kaSub",
"kaddisch" => "kadiS",
"kaddish" => "kadiS",
"kadi" => "kadi",
"kafir" => "kafiR",
"kafkaïen" => "kafkaj5",
"kaftan" => "kaft@",
"kaftans" => "kaft@",
"kaiser" => "kajz9R",
"kaki" => "kaki",
"kakis" => "kaki",
"kala-azar" => "kalaazaR",
"kalachnikovs" => "kalaknikOv",
"kaléidoscope" => "kaleidoskOp",
"kaléidoscopes" => "kaleidoskOp",
"kali" => "kali",
"kaliémie" => "kaljemi",
"kalmouk" => "kalmuk",
"kalmouks" => "kalmuk",
"kalpa" => "kalpa",
"kama" => "kama",
"kamala" => "kamala",
"kami" => "kami",
"kamikaze" => "kamikaz",
"kamikazes" => "kamikaz",
"kan" => "kan",
"kana" => "kana",
"kandjar" => "k@djaR",
"kangourou" => "k@guRu",
"kangourous" => "k@guRu",
"kanji" => "k@Zi",
"kantien" => "k@tj5",
"kantisme" => "k@tizm",
"kaolin" => "kaol5",
"kaori" => "kaORi",
"kapo" => "kapo",
"kapok" => "kapOk",
"kapokier" => "kapOkje",
"kapos" => "kapo",
"kaposi" => "kapozi",
"kapout" => "kaput",
"kappa" => "kapa",
"karaoké" => "kaRaoke",
"karaokés" => "kaRaoke",
"karaté" => "kaRate",
"karatéka" => "kaRateka",
"karatékas" => "kaRateka",
"karen" => "kaREn",
"kari" => "kaRi",
"karité" => "kaRite",
"karma" => "kaRma",
"karmique" => "kaRmik",
"kart" => "kaRt",
"karting" => "kaRtiG",
"kasbah" => "kasba",
"kascher" => "kaSER",
"kasher" => "kaSER",
"kastro" => "kastRo",
"kastros" => "kastRo",
"kata" => "kata",
"katal" => "katal",
"katangais" => "kat@gE",
"katas" => "kata",
"katchinas" => "katSina",
"katiba" => "katiba",
"kava" => "kava",
"kawa" => "kawa",
"kayac" => "kajak",
"kayak" => "kajak",
"kayakiste" => "kajakist",
"kazakh" => "kazak",
"kazakhs" => "kazak",
"kebab" => "kebab",
"kebabs" => "k°bab",
"kebla" => "k°bla",
"keblas" => "k°bla",
"kébour" => "kebuR",
"kébours" => "kebuR",
"keepsake" => "kipsEk",
"keffieh" => "kefje",
"kéfir" => "kefiR",
"kéfirs" => "kefiR",
"keiretsu" => "keREtsu",
"kekchose" => "kEkSoz",
"kelvins" => "kElvin",
"kendo" => "kEndo",
"kényan" => "kenj@",
"képi" => "kepi",
"képis" => "kepi",
"kérabau" => "keRabo",
"kératinisée" => "keRatinize",
"kératoplastie" => "keRatoplasti",
"kératose" => "keRatoz",
"kermesse" => "kERmEs",
"kermesses" => "kERmEs",
"kérosène" => "keRozEn",
"kérosènes" => "keRozEn",
"kerrie" => "kERi",
"ket" => "kEt",
"ketch" => "kEtS",
"ketchup" => "kEtS9p",
"keuf" => "k9f",
"keufs" => "k9f",
"keum" => "k2m",
"keums" => "k2m",
"kevlar" => "k°vlaR",
"khâgne" => "kaN",
"khâgnes" => "kaN",
"khâgneux" => "kaN2",
"khalife" => "kalif",
"khamsin" => "Ramsin",
"khan" => "kan",
"khanat" => "kana",
"khans" => "kan",
"khat" => "kat",
"khazar" => "kazaR",
"khédival" => "kedival",
"khédive" => "kediv",
"khmer" => "kmER",
"khmère" => "kmER",
"khôl" => "kol",
"kibboutz" => "kibuts",
"kibboutzim" => "kibutsim",
"kick" => "kik",
"kicker" => "kike",
"kicks" => "kik",
"kid" => "kid",
"kidnappa" => "kidnapa",
"kidnappait" => "kidnapE",
"kidnappant" => "kidnap@",
"kidnappe" => "kidnap",
"kidnappé" => "kidnape",
"kidnappée" => "kidnape",
"kidnappées" => "kidnape",
"kidnappent" => "kidnap",
"kidnapper" => "kidnape",
"kidnapperai" => "kidnap°RE",
"kidnapperaient" => "kidnap°RE",
"kidnapperas" => "kidnap°Ra",
"kidnapperez" => "kidnap°Re",
"kidnappés" => "kidnape",
"kidnappeur" => "kidnap9R",
"kidnappeurs" => "kidnap9R",
"kidnappez" => "kidnape",
"kidnappiez" => "kidnapje",
"kidnapping" => "kidnapiG",
"kidnappings" => "kidnapiG",
"kidnappons" => "kidnap§",
"kids" => "kid",
"kief" => "kjEf",
"kierkegaardienne" => "kiRk°gaaRdjEn",
"kif" => "kif",
"kif-kif" => "kifkif",
"kiki" => "kiki",
"kil" => "kil",
"kilbus" => "kilbus",
"kilim" => "kilim",
"killer" => "kil9R",
"kilo" => "kilo",
"kilogramme" => "kilogRam",
"kilogrammes" => "kilogRam",
"kilohertz" => "kiloERts",
"kilométrage" => "kilometRaZ",
"kilométrages" => "kilometRaZ",
"kilomètre" => "kilomEtR",
"kilomètres" => "kilomEtR",
"kilomètres-heure" => "kilomEtR9R",
"kilométrique" => "kilometRik",
"kilométriques" => "kilometRik",
"kilos" => "kilo",
"kilotonnes" => "kilotOn",
"kilowattheure" => "kilowat9R",
"kilowatts" => "kilowat",
"kils" => "kil",
"kilt" => "kilt",
"kilts" => "kilt",
"kimono" => "kimono",
"kimonos" => "kimono",
"kinase" => "kinaz",
"kiné" => "kine",
"kinescope" => "kinEskOp",
"kinésiques" => "kinezik",
"kinésithérapeute" => "kineziteRap2t",
"kinésithérapie" => "kineziteRapi",
"kinesthésie" => "kinEstezi",
"king-charles" => "kiGSaRl",
"kinnor" => "kinOR",
"kino" => "kino",
"kiosk" => "kjOsk",
"kiosks" => "kjOsk",
"kiosque" => "kjOsk",
"kiosques" => "kjOsk",
"kip" => "kip",
"kipa" => "kipa",
"kippa" => "kipa",
"kipper" => "kip9R",
"kippers" => "kip9R",
"kips" => "kip",
"kir" => "kiR",
"kirghiz" => "kiRgiz",
"kirghize" => "kiRgiz",
"kirghizes" => "kiRgiz",
"kirs" => "kiR",
"kirsch" => "kiRS",
"kit" => "kit",
"kitch" => "kitS",
"kitchenette" => "kitS°nEt",
"kits" => "kit",
"kitsch" => "kitS",
"kiva" => "kiva",
"kiwi" => "kiwi",
"kiwis" => "kiwi",
"klaxon" => "klaks§",
"klaxonna" => "klaksona",
"klaxonnai" => "klaksonE",
"klaxonnaient" => "klaksonE",
"klaxonnais" => "klaksonE",
"klaxonnait" => "klaksonE",
"klaxonnant" => "klakson@",
"klaxonne" => "klaksOn",
"klaxonné" => "klaksone",
"klaxonnent" => "klaksOn",
"klaxonner" => "klaksone",
"klaxonnera" => "klaksOn°Ra",
"klaxonnerai" => "klaksOn°RE",
"klaxonnes" => "klaksOn",
"klaxonnez" => "klaksone",
"klaxons" => "klaks§",
"klebs" => "klEps",
"kleenex" => "klinEks",
"kleptomane" => "klEptoman",
"kleptomanes" => "klEptoman",
"kleptomanie" => "klEptomani",
"klystron" => "klistR§",
"km" => "kilomEtR",
"knickerbockers" => "knik9RbOk9R",
"knickers" => "knik9Rs",
"knock-out" => "nOkawt",
"knout" => "knut",
"koala" => "koala",
"koalas" => "koala",
"kobold" => "kobOld",
"kobolds" => "kobOld",
"kodak" => "kodak",
"kodiak" => "kodjak",
"kohl" => "kol",
"kola" => "kola",
"kolatiers" => "kolatje",
"kolkhoze" => "kOlkoz",
"kolkhozien" => "kOlkozj5",
"kolkhozienne" => "kOlkozjEn",
"kolkhoziennes" => "kOlkozjEn",
"kolkhoziens" => "kOlkozj5",
"komi" => "komi",
"komintern" => "kOmintERn",
"kommandantur" => "kom@d@ntuR",
"kommando" => "kOm@do",
"komsomol" => "kOmsomOl",
"komsomols" => "kOmsomOl",
"kondo" => "k§do",
"kopeck" => "kopEk",
"kopecks" => "kopEk",
"kopeks" => "kopEk",
"kora" => "kORa",
"koran" => "kOR@",
"koré" => "kORe",
"korè" => "koRE",
"korrigan" => "koRig@",
"korrigans" => "koRig@",
"kosovar" => "kOsOvaR",
"kot" => "kOt",
"koto" => "koto",
"kouglof" => "kuglOf",
"koulak" => "kulak",
"koulaks" => "kulak",
"kouros" => "kuRos",
"kraal" => "kRal",
"krach" => "kRak",
"krachs" => "kRak",
"kraft" => "kRaft",
"krak" => "kRak",
"kraken" => "kRakEn",
"kremlin" => "kREml5",
"kreutzer" => "kROjts9R",
"kriegspiel" => "kRikSpil",
"krill" => "kRil",
"kriss" => "kRis",
"kroumir" => "kRumiR",
"kroumirs" => "kRumiR",
"krypton" => "kRipt§",
"ksar" => "ksaR",
"kugelhof" => "kuglOf",
"kula" => "kyla",
"kummel" => "kymEl",
"kumquat" => "kOmkwat",
"kumquats" => "kOmkwat",
"kung fu" => "kuGfu",
"kung-fu" => "kuGfu",
"kurde" => "kyRd",
"kurdes" => "kyRd",
"kursaal" => "kyRsal",
"kurus" => "kyRy",
"kvas" => "kvas",
"kyrie" => "kiRje",
"kyrie eleison" => "kiRjeeleisOn",
"kyrielle" => "kiRjEl",
"kyrielles" => "kiRjEl",
"kyste" => "kist",
"kystes" => "kist",
"kystique" => "kistik",
"l" => "El",
"l-dopa" => "Eldopa",
"l'" => "l",
"l'un" => "l1",
"l'une" => "lyn",
"la" => "la",
"là" => "la",
"la plata" => "laplata",
"la plupart" => "laplypaR",
"la plupart de" => "laplypaRd2",
"la plupart des" => "laplypaRdE",
"la plupart du" => "laplypaRdy",
"là-bas" => "laba",
"là-dedans" => "lad°d@",
"là-dehors" => "lad2OR",
"là-derrière" => "ladERjER",
"là-dessous" => "lad°su",
"là-dessus" => "lad°sy",
"là-devant" => "lad°v@",
"là-haut" => "lao",
"la-la-la" => "lalala",
"labbe" => "lab",
"labbes" => "lab",
"label" => "labEl",
"labelle" => "labEl",
"labels" => "labEl",
"labeur" => "lab9R",
"labeurs" => "lab9R",
"labial" => "labjal",
"labiale" => "labjal",
"labiales" => "labjal",
"labialisant" => "labjaliz@",
"labiaux" => "labjo",
"labile" => "labil",
"labo" => "labo",
"laborantin" => "laboR@t5",
"laborantine" => "laboR@tin",
"laborantins" => "laboR@t5",
"laboratoire" => "laboRatwaR",
"laboratoires" => "laboRatwaR",
"laborieuse" => "laboRj2z",
"laborieusement" => "laboRj2z°m@",
"laborieuses" => "laboRj2z",
"laborieux" => "laboRj2",
"labos" => "labo",
"labour" => "labuR",
"laboura" => "labuRa",
"labourable" => "labuRabl",
"labourage" => "labuRaZ",
"labouraient" => "labuRE",
"labourais" => "labuRE",
"labourait" => "labuRE",
"labourant" => "labuR@",
"laboure" => "labuR",
"labouré" => "labuRe",
"labourée" => "labuRe",
"labourées" => "labuRe",
"labourent" => "labuR",
"labourer" => "labuRe",
"labourerait" => "labuR°RE",
"labourés" => "labuRe",
"laboureur" => "labuR9R",
"laboureurs" => "labuR9R",
"labours" => "labuR",
"labrador" => "labRadOR",
"labradors" => "labRadOR",
"labre" => "labR",
"labres" => "labR",
"labri" => "labRi",
"labris" => "labRi",
"labyrinthe" => "labiR5t",
"labyrinthes" => "labiR5t",
"labyrinthique" => "labiR5tik",
"labyrinthiques" => "labiR5tik",
"lac" => "lak",
"laça" => "lasa",
"laçage" => "lasaZ",
"laçais" => "lasE",
"laçait" => "lasE",
"lacandon" => "lak@d§",
"lacanien" => "lakanj5",
"lacaniens" => "lakanj5",
"laçant" => "las@",
"lace" => "las",
"lacé" => "lase",
"lacédémoniens" => "lasedemonj5",
"lacée" => "lase",
"lacées" => "lase",
"lacent" => "las",
"lacer" => "lase",
"lacéra" => "laseRa",
"lacéraient" => "laseRE",
"lacérait" => "laseRE",
"lacérant" => "laseR@",
"lacération" => "laseRasj§",
"lacérations" => "laseRasj§",
"lacère" => "lasER",
"lacéré" => "laseRe",
"lacérée" => "laseRe",
"lacérées" => "laseRe",
"lacèrent" => "lasER",
"lacérer" => "laseRe",
"lacérés" => "laseRe",
"lacérions" => "laseRj§",
"lacés" => "lase",
"lacet" => "lasE",
"lacets" => "lasE",
"lâcha" => "laSa",
"lâchage" => "laSaZ",
"lâchai" => "laSE",
"lâchaient" => "laSE",
"lâchais" => "laSE",
"lâchait" => "laSE",
"lâchant" => "laS@",
"lâchât" => "laSa",
"lâche" => "laS",
"lâché" => "laSe",
"lâchée" => "laSe",
"lâchées" => "laSe",
"lâchement" => "laS°m@",
"lâchent" => "laS",
"lâcher" => "laSe",
"lâchera" => "laS°Ra",
"lâcherai" => "laS°RE",
"lâcheraient" => "laS°RE",
"lâcherais" => "laS°RE",
"lâcherait" => "laS°RE",
"lâcheras" => "laS°Ra",
"lâchèrent" => "laSER",
"lâcherez" => "laS°Re",
"lâcheriez" => "laS°Rje",
"lâcherons" => "laS°R§",
"lâcheront" => "laS°R§",
"lâchers" => "laSe",
"lâches" => "laS",
"lâchés" => "laSe",
"lâcheté" => "laS°te",
"lâchetés" => "laS°te",
"lâcheur" => "laS9R",
"lâcheurs" => "laS9R",
"lâcheuse" => "laS2z",
"lâchez" => "laSe",
"lâchiez" => "laSje",
"lâchions" => "laSj§",
"lâchons" => "laS§",
"lacis" => "lasi",
"lack" => "lak",
"laconique" => "lakonik",
"laconiquement" => "lakonik°m@",
"laconiques" => "lakonik",
"laconisme" => "lakonizm",
"lacrima-christi" => "lakRimakRisti",
"lacryma christi" => "lakRimakRisti",
"lacryma-christi" => "lakRimakRisti",
"lacrymal" => "lakRimal",
"lacrymale" => "lakRimal",
"lacrymales" => "lakRimal",
"lacrymaux" => "lakRimo",
"lacrymogène" => "lakRimoZEn",
"lacrymogènes" => "lakRimoZEn",
"lacs" => "lak",
"lactaires" => "laktER",
"lactate" => "laktat",
"lactation" => "laktasj§",
"lacté" => "lakte",
"lactée" => "lakte",
"lactés" => "lakte",
"lactescent" => "laktEs@",
"lactescente" => "laktEs@t",
"lactifère" => "laktifER",
"lactique" => "laktik",
"lactose" => "laktoz",
"lacunaire" => "lakynER",
"lacune" => "lakyn",
"lacunes" => "lakyn",
"lacustre" => "lakystR",
"lacustres" => "lakystR",
"lad" => "lad",
"ladies" => "lEjdiz",
"ladino" => "ladino",
"ladite" => "ladit",
"ladre" => "ladR",
"ladrerie" => "ladR°Ri",
"ladreries" => "ladR°Ri",
"ladres" => "ladR",
"lads" => "lad",
"lady" => "lEjdi",
"ladys" => "lEjdiz",
"lagan" => "lag@",
"lagon" => "lag§",
"lagons" => "lag§",
"laguiole" => "lagjOl",
"lagunaire" => "lagynER",
"lagune" => "lagyn",
"lagunes" => "lagyn",
"lai" => "lE",
"laïc" => "laik",
"laîche" => "lES",
"laîches" => "lES",
"laïciser" => "laisize",
"laïcité" => "laisite",
"laïcs" => "laik",
"laid" => "lE",
"laide" => "lEd",
"laidement" => "lEd°m@",
"laideron" => "lEd°R§",
"laiderons" => "lEd°R§",
"laides" => "lEd",
"laideur" => "lEd9R",
"laideurs" => "lEd9R",
"laids" => "lE",
"laie" => "lE",
"laies" => "lE",
"lainage" => "lEnaZ",
"lainages" => "lEnaZ",
"laine" => "lEn",
"laines" => "lEn",
"laineurs" => "lEn9R",
"laineuse" => "lEn2z",
"laineuses" => "lEn2z",
"laineux" => "lEn2",
"lainier" => "lEnje",
"lainière" => "lEnjER",
"laïque" => "laik",
"laïques" => "laik",
"laird" => "lER",
"lais" => "lE",
"laissa" => "lEsa",
"laissai" => "lEsE",
"laissaient" => "lEsE",
"laissais" => "lEsE",
"laissait" => "lEsE",
"laissâmes" => "lEsam",
"laissant" => "lEs@",
"laissassent" => "lEsas",
"laissât" => "lEsa",
"laisse" => "lEs",
"laissé" => "lese",
"laisse-la-moi" => "lEslamwa",
"laissé-pour-compte" => "lesepuRk§t",
"laissée" => "lese",
"laissées" => "lese",
"laissent" => "lEs",
"laisser" => "lese",
"laisser-aller" => "leseale",
"laisser-faire" => "lesefER",
"laissera" => "lEs°Ra",
"laisserai" => "lEs°RE",
"laisseraient" => "lEs°RE",
"laisserais" => "lEs°RE",
"laisserait" => "lEs°RE",
"laisseras" => "lEs°Ra",
"laissèrent" => "lEsER",
"laisserez" => "lEs°Re",
"laisseriez" => "lEs2Rje",
"laisserions" => "lEs2Rj§",
"laisserons" => "lEs°R§",
"laisseront" => "lEs°R§",
"laisses" => "lEs",
"laissés" => "lese",
"laissés-pour-compte" => "lesepuRk§t",
"laissez" => "lEse",
"laissez-faire" => "lEsefER",
"laissez-passer" => "lEsepase",
"laissiez" => "lEsje",
"laissions" => "lEsj§",
"laissons" => "lEs§",
"lait" => "lE",
"laitage" => "lEtaZ",
"laitages" => "lEtaZ",
"laitance" => "lEt@s",
"laitances" => "lEt@s",
"laiterie" => "lEt°Ri",
"laiteries" => "lEt°Ri",
"laites" => "lEt",
"laiteuse" => "lEt2z",
"laiteuses" => "lEt2z",
"laiteux" => "lEt2",
"laitier" => "letje",
"laitière" => "lEtjER",
"laitières" => "lEtjER",
"laitiers" => "letje",
"laiton" => "lEt§",
"laits" => "lE",
"laitue" => "lety",
"laitues" => "lety",
"laïus" => "lajys",
"laïusse" => "lajys",
"laizes" => "lEz",
"lala" => "lala",
"lama" => "lama",
"lamais" => "lamE",
"lamaïsme" => "lamaizm",
"lamantin" => "lam@t5",
"lamantins" => "lam@t5",
"lamartiniennes" => "lamaRtinjEn",
"lamas" => "lama",
"lambada" => "l@bada",
"lambda" => "l@bda",
"lambdas" => "l@bda",
"lambeau" => "l@bo",
"lambeaux" => "l@bo",
"lambel" => "l@bEl",
"lambi" => "l@bi",
"lambic" => "l@bik",
"lambin" => "l@b5",
"lambinaient" => "l@binE",
"lambinais" => "l@binE",
"lambinait" => "l@binE",
"lambinant" => "l@bin@",
"lambine" => "l@bin",
"lambiné" => "l@bine",
"lambiner" => "l@bine",
"lambines" => "l@bin",
"lambinez" => "l@bine",
"lambiniez" => "l@binje",
"lambinions" => "l@binj§",
"lambinons" => "l@bin§",
"lambins" => "l@b5",
"lambrequins" => "l@bR°k5",
"lambris" => "l@bRi",
"lambrissage" => "l@bRisaZ",
"lambrissé" => "l@bRise",
"lambrissée" => "l@bRise",
"lambrissées" => "l@bRise",
"lambrusques" => "l@bRysk",
"lambswool" => "l@bswul",
"lame" => "lam",
"lamé" => "lame",
"lamedé" => "lam°de",
"lamedés" => "lam°de",
"lamedu" => "lam°dy",
"lamée" => "lame",
"lamées" => "lame",
"lamelle" => "lamEl",
"lamelles" => "lamEl",
"lamellibranches" => "lamelibR@S",
"lamelliforme" => "lamElifORm",
"lamenta" => "lam@ta",
"lamentable" => "lam@tabl",
"lamentablement" => "lam@tabl°m@",
"lamentables" => "lam@tabl",
"lamentaient" => "lam@tE",
"lamentais" => "lam@tE",
"lamentait" => "lam@tE",
"lamentant" => "lam@t@",
"lamentation" => "lam@tasj§",
"lamentations" => "lam@tasj§",
"lamente" => "lam@t",
"lamenté" => "lam@te",
"lamentent" => "lam@t",
"lamenter" => "lam@te",
"lamentera" => "lam@t°Ra",
"lamenterait" => "lam@t°RE",
"lamentèrent" => "lam@tER",
"lamenteront" => "lam@t°R§",
"lamentés" => "lam@te",
"lamentez" => "lam@te",
"lamentions" => "lam@tj§",
"lamento" => "lamEnto",
"lamentons" => "lam@t§",
"lamer" => "lame",
"lames" => "lam",
"lamés" => "lame",
"lamie" => "lami",
"lamifié" => "lamifje",
"lamifiés" => "lamifje",
"laminage" => "laminaZ",
"laminages" => "laminaZ",
"laminaire" => "laminER",
"laminaires" => "laminER",
"laminait" => "laminE",
"laminant" => "lamin@",
"lamine" => "lamin",
"laminé" => "lamine",
"laminectomie" => "laminEktOmi",
"laminée" => "lamine",
"laminées" => "lamine",
"laminer" => "lamine",
"lamineront" => "lamin°R§",
"lamines" => "lamin",
"laminés" => "lamine",
"laminoir" => "laminwaR",
"laminoirs" => "laminwaR",
"lampa" => "l@pa",
"lampadaire" => "l@padER",
"lampadaires" => "l@padER",
"lampadophore" => "l@padofOR",
"lampais" => "l@pE",
"lampait" => "l@pE",
"lampant" => "l@p@",
"lamparos" => "l@paRo",
"lampas" => "l@pa",
"lampe" => "l@p",
"lampé" => "l@pe",
"lampe-phare" => "l@pfaR",
"lampe-tempête" => "l@pt@pEt",
"lampée" => "l@pe",
"lampées" => "l@pe",
"lampent" => "l@p",
"lamper" => "l@pe",
"lampes" => "l@p",
"lampes-tempête" => "l@pt@pEt",
"lampez" => "l@pe",
"lampion" => "l@pj§",
"lampions" => "l@pj§",
"lampiste" => "l@pist",
"lampisterie" => "l@pist°Ri",
"lampisteries" => "l@pist°Ri",
"lampistes" => "l@pist",
"lampons" => "l@p§",
"lamproie" => "l@pRwa",
"lamproies" => "l@pRwa",
"lampyres" => "l@piR",
"lança" => "l@sa",
"lançai" => "l@sE",
"lançaient" => "l@sE",
"lançais" => "l@sE",
"lançait" => "l@sE",
"lançâmes" => "l@sam",
"lançant" => "l@s@",
"lanças" => "l@sa",
"lançât" => "l@sa",
"lance" => "l@s",
"lancé" => "l@se",
"lance-engins" => "l@s@Z5",
"lance-flamme" => "l@sflam",
"lance-flammes" => "l@sflam",
"lance-fusée" => "l@sfyze",
"lance-fusées" => "l@sfyze",
"lance-grenade" => "l@sgR°nad",
"lance-grenades" => "l@sgR°nad",
"lance-missiles" => "l@smisil",
"lance-pierre" => "l@spjER",
"lance-pierres" => "l@spjER",
"lance-roquette" => "l@sRokEt",
"lance-roquettes" => "l@sRokEt",
"lance-torpille" => "l@stORpij",
"lance-torpilles" => "l@stORpij",
"lancée" => "l@se",
"lancées" => "l@se",
"lancelot" => "l@s°lo",
"lancement" => "l@s°m@",
"lancements" => "l@s°m@",
"lancent" => "l@s",
"lancéolés" => "l@seole",
"lancequine" => "l@skin",
"lancequiner" => "l@skine",
"lancer" => "l@se",
"lancera" => "l@s°Ra",
"lancerai" => "l@s°RE",
"lanceraient" => "l@s°RE",
"lancerais" => "l@s°RE",
"lancerait" => "l@s°RE",
"lanceras" => "l@s°Ra",
"lancèrent" => "l@sER",
"lancerez" => "l@s°Re",
"lancerons" => "l@s°R§",
"lanceront" => "l@s°R§",
"lancers" => "l@se",
"lances" => "l@s",
"lancés" => "l@se",
"lancette" => "l@sEt",
"lanceur" => "l@s9R",
"lanceurs" => "l@s9R",
"lanceuse" => "l@s2z",
"lancez" => "l@se",
"lancier" => "l@sje",
"lanciers" => "l@sje",
"lanciez" => "l@sje",
"lancinait" => "l@sinE",
"lancinance" => "l@sin@s",
"lancinant" => "l@sin@",
"lancinante" => "l@sin@t",
"lancinantes" => "l@sin@t",
"lancinants" => "l@sin@",
"lancine" => "l@sin",
"lanciné" => "l@sine",
"lancions" => "l@sj§",
"lançons" => "l@s§",
"land" => "l@d",
"landais" => "l@dE",
"landaise" => "l@dEz",
"landaises" => "l@dEz",
"landau" => "l@do",
"landaulet" => "l@dolE",
"landaus" => "l@do",
"lande" => "l@d",
"landerneau" => "l@dERno",
"landes" => "l@d",
"landiers" => "l@dje",
"landing" => "l@diG",
"landlord" => "l@dlOR",
"lands" => "l@d",
"landsturm" => "l@dstuRm",
"landwehr" => "l@dvER",
"langage" => "l@gaZ",
"langages" => "l@gaZ",
"langagiers" => "l@gaZje",
"lange" => "l@Z",
"langé" => "l@Ze",
"langeait" => "l@ZE",
"langeant" => "l@Z@",
"langée" => "l@Ze",
"langer" => "l@Ze",
"langes" => "l@Z",
"langoureuse" => "l@guR2z",
"langoureusement" => "l@guR2z°m@",
"langoureuses" => "l@guR2z",
"langoureux" => "l@guR2",
"langouste" => "l@gust",
"langoustes" => "l@gust",
"langoustine" => "l@gustin",
"langoustines" => "l@gustin",
"langue" => "l@g",
"languedociens" => "l@gdosj5",
"langues" => "l@g",
"languette" => "l@gEt",
"languettes" => "l@gEt",
"langueur" => "l@g9R",
"langueurs" => "l@g9R",
"langui" => "l@gi",
"languide" => "l@gid",
"languides" => "l@gid",
"languir" => "l@giR",
"languirait" => "l@giRE",
"languirent" => "l@giR",
"languiront" => "l@giR§",
"languis" => "l@gi",
"languissaient" => "l@gisE",
"languissais" => "l@gisE",
"languissait" => "l@gisE",
"languissamment" => "l@gisam@",
"languissant" => "l@gis@",
"languissante" => "l@gis@t",
"languissantes" => "l@gis@t",
"languissants" => "l@gis@",
"languisse" => "l@gis",
"languissent" => "l@gis",
"languisses" => "l@gis",
"languissons" => "l@gis§",
"languit" => "l@gi",
"lanière" => "lanjER",
"lanières" => "lanjER",
"lanlaire" => "l@lER",
"lanoline" => "lanolin",
"lansquenet" => "l@sk°nE",
"lansquenets" => "l@sk°nE",
"lansquine" => "l@skin",
"lansquiner" => "l@skine",
"lanternant" => "l@tERn@",
"lanterne" => "l@tERn",
"lanterné" => "l@tERne",
"lanterne-tempête" => "l@tERnt@pEt",
"lanterner" => "l@tERne",
"lanternes" => "l@tERn",
"lanternez" => "l@tERne",
"lanternier" => "l@tERnje",
"lanthane" => "l@tan",
"lao" => "lao",
"laos" => "laos",
"laotien" => "laosj5",
"laotienne" => "laosjEn",
"laotiens" => "laosj5",
"lap" => "lap",
"lapais" => "lapE",
"lapait" => "lapE",
"lapalissade" => "lapalisad",
"lapant" => "lap@",
"laparoscopie" => "lapaRoskopi",
"laparotomie" => "lapaRotomi",
"lape" => "lap",
"lapé" => "lape",
"lapées" => "lape",
"lapement" => "lap°m@",
"lapements" => "lap°m@",
"lapent" => "lap",
"laper" => "lape",
"lapereau" => "lap°Ro",
"lapereaux" => "lap°Ro",
"lapida" => "lapida",
"lapidaire" => "lapidER",
"lapidaires" => "lapidER",
"lapidait" => "lapidE",
"lapidant" => "lapid@",
"lapidation" => "lapidasj§",
"lapidations" => "lapidasj§",
"lapide" => "lapid",
"lapidé" => "lapide",
"lapidée" => "lapide",
"lapident" => "lapid",
"lapider" => "lapide",
"lapiderait" => "lapid°RE",
"lapideras" => "lapid°Ra",
"lapidèrent" => "lapidER",
"lapidés" => "lapide",
"lapidez" => "lapide",
"lapidification" => "lapidifikasj§",
"lapidifiés" => "lapidifje",
"lapin" => "lap5",
"lapine" => "lapin",
"lapiner" => "lapine",
"lapines" => "lapin",
"lapinière" => "lapinjER",
"lapins" => "lap5",
"lapis" => "lapis",
"lapis-lazuli" => "lapizlazyli",
"lapon" => "lap§",
"lapone" => "lapOn",
"lapones" => "lapOn",
"laponne" => "lapOn",
"lapons" => "lap§",
"lappant" => "lap@",
"lappé" => "lape",
"lapper" => "lape",
"laps" => "laps",
"lapsus" => "lapsys",
"laquaient" => "lakE",
"laquais" => "lakE",
"laquait" => "lakE",
"laque" => "lak",
"laqué" => "lake",
"laquée" => "lake",
"laquées" => "lake",
"laquelle" => "lakEl",
"laquer" => "lake",
"laquerai" => "lak°RE",
"laques" => "lak",
"laqués" => "lake",
"larbin" => "laRb5",
"larbineries" => "laRbin°Ri",
"larbins" => "laRb5",
"larcin" => "laRs5",
"larcins" => "laRs5",
"lard" => "laR",
"larda" => "laRda",
"lardage" => "laRdaZ",
"lardais" => "laRdE",
"lardait" => "laRdE",
"lardant" => "laRd@",
"larde" => "laRd",
"lardé" => "laRde",
"lardée" => "laRde",
"lardées" => "laRde",
"larder" => "laRde",
"lardeuss" => "laRdeus",
"lardeux" => "laRd2",
"lardon" => "laRd§",
"lardons" => "laRd§",
"lards" => "laR",
"lardu" => "laRdy",
"lardus" => "laRdy",
"lare" => "laR",
"lares" => "laR",
"larfeuil" => "laRf9j",
"larfeuille" => "laRf9j",
"larfeuilles" => "laRf9j",
"larfeuils" => "laRf9j",
"largable" => "laRgabl",
"largage" => "laRgaZ",
"largages" => "laRgaZ",
"large" => "laRZ",
"largement" => "laRZ°m@",
"larges" => "laRZ",
"largesse" => "laRZEs",
"largesses" => "laRZEs",
"largeur" => "laRZ9R",
"largeurs" => "laRZ9R",
"larghetto" => "laRgEto",
"largo" => "laRgo",
"largua" => "laRga",
"larguaient" => "laRgE",
"larguais" => "laRgE",
"larguait" => "laRgE",
"larguant" => "laRg@",
"largue" => "laRg",
"largué" => "laRge",
"larguée" => "laRge",
"larguées" => "laRge",
"larguent" => "laRg",
"larguer" => "laRge",
"larguera" => "laRg°Ra",
"larguerai" => "laRg°RE",
"larguerait" => "laRg°RE",
"larguerez" => "laRg°Re",
"largueront" => "laRg°R§",
"largues" => "laRg",
"largués" => "laRge",
"largueur" => "laRg9R",
"larguez" => "laRge",
"larguiez" => "laRgje",
"larguons" => "laRg§",
"larigot" => "laRigo",
"larme" => "laRm",
"larmes" => "laRm",
"larmichette" => "laRmiSEt",
"larmichettes" => "laRmiSEt",
"larmiers" => "laRmje",
"larmoie" => "laRmwa",
"larmoiement" => "laRmwam@",
"larmoiements" => "laRmwam@",
"larmoient" => "laRmwa",
"larmoyait" => "laRmwajE",
"larmoyant" => "laRmwaj@",
"larmoyante" => "laRmwaj@t",
"larmoyantes" => "laRmwaj@t",
"larmoyants" => "laRmwaj@",
"larmoyé" => "laRmwaje",
"larmoyer" => "laRmwaje",
"larmoyeur" => "laRmwaj9R",
"larmoyons" => "laRmwaj§",
"larron" => "laR§",
"larronne" => "laROn",
"larrons" => "laR§",
"larsen" => "laRsEn",
"larvaire" => "laRvER",
"larvaires" => "laRvER",
"larve" => "laRv",
"larvé" => "laRve",
"larvée" => "laRve",
"larvées" => "laRve",
"larves" => "laRv",
"larvicide" => "laRvisid",
"laryngé" => "laR5Ze",
"laryngée" => "laR5Ze",
"laryngite" => "laR5Zit",
"laryngologique" => "laR5gOlOZik",
"laryngologiste" => "laR5goloZist",
"laryngoscope" => "laR5gOskOp",
"laryngoscopes" => "laR5goskOp",
"laryngoscopie" => "laR5gOskOpi",
"larynx" => "laR5ks",
"las" => "la",
"lasagne" => "lazaN",
"lasagnes" => "lazaN",
"lascar" => "laskaR",
"lascars" => "laskaR",
"lascif" => "lasif",
"lascifs" => "lasif",
"lascive" => "lasiv",
"lascivement" => "lasiv°m@",
"lascives" => "lasiv",
"lascivité" => "lasivite",
"lascivités" => "lasivite",
"laser" => "lazER",
"lasers" => "lazER",
"lassa" => "lasa",
"lassai" => "lasE",
"lassaient" => "lasE",
"lassais" => "lasE",
"lassait" => "lasE",
"lassant" => "las@",
"lassante" => "las@t",
"lassantes" => "las@t",
"lassants" => "las@",
"lasse" => "las",
"lassé" => "lase",
"lassée" => "lase",
"lassées" => "lase",
"lassent" => "las",
"lasser" => "lase",
"lassera" => "las°Ra",
"lasserai" => "las°RE",
"lasseraient" => "las°RE",
"lasserais" => "las°RE",
"lasserait" => "las°RE",
"lassèrent" => "lasER",
"lasserez" => "las°Re",
"lasseront" => "las°R§",
"lasses" => "las",
"lassés" => "lase",
"lassez" => "lase",
"lassitude" => "lasityd",
"lassitudes" => "lasityd",
"lasso" => "laso",
"lassons" => "las§",
"lassos" => "laso",
"lasure" => "lasyR",
"latence" => "lat@s",
"latences" => "lat@s",
"latent" => "lat@",
"latente" => "lat@t",
"latentes" => "lat@t",
"latents" => "lat@",
"latéral" => "lateRal",
"latérale" => "lateRal",
"latéralement" => "lateRal°m@",
"latérales" => "lateRal",
"latéralisée" => "lateRalize",
"latéralité" => "lateRalite",
"latéraux" => "lateRo",
"latérite" => "lateRit",
"latex" => "latEks",
"laticlave" => "latiklav",
"latifundistes" => "latif§dist",
"latin" => "lat5",
"latine" => "latin",
"latines" => "latin",
"latinisaient" => "latinizE",
"latinisé" => "latinize",
"latinisée" => "latinize",
"latinismes" => "latinizm",
"latiniste" => "latinist",
"latinistes" => "latinist",
"latinité" => "latinite",
"latinités" => "latinite",
"latino" => "latino",
"latino-américain" => "latinoameRik5",
"latino-américaine" => "latinoameRikEn",
"latino-américains" => "latinoameRik5",
"latinos" => "latino",
"latins" => "lat5",
"latitude" => "latityd",
"latitudes" => "latityd",
"latrine" => "latRin",
"latrines" => "latRin",
"lats" => "lats",
"latte" => "lat",
"latté" => "late",
"latter" => "late",
"lattes" => "lat",
"lattés" => "late",
"lattis" => "lati",
"latviens" => "latvj5",
"laubé" => "lobe",
"laudanum" => "lodanOm",
"laudateur" => "lodat9R",
"laudative" => "lodativ",
"laudes" => "lod",
"lauréat" => "loRea",
"lauréate" => "loReat",
"lauréats" => "loRea",
"laurier" => "loRje",
"laurier-cerise" => "loRjes°Riz",
"laurier-rose" => "loRjeRoz",
"lauriers" => "loRje",
"lauriers-cerises" => "loRjes°Riz",
"lauriers-roses" => "loRjeRoz",
"lausannoises" => "lozanwaz",
"lauzes" => "loz",
"lav" => "lav",
"lava" => "lava",
"lavable" => "lavabl",
"lavables" => "lavabl",
"lavabo" => "lavabo",
"lavabos" => "lavabo",
"lavage" => "lavaZ",
"lavages" => "lavaZ",
"lavai" => "lavE",
"lavaient" => "lavE",
"lavais" => "lavE",
"lavait" => "lavE",
"lavallière" => "lavaljER",
"lavallières" => "lavaljER",
"lavande" => "lav@d",
"lavandes" => "lav@d",
"lavandière" => "lav@djER",
"lavandières" => "lav@djER",
"lavandin" => "lav@d5",
"lavant" => "lav@",
"lavasse" => "lavas",
"lave" => "lav",
"lavé" => "lave",
"lave-auto" => "lavoto",
"lave-glace" => "lavglas",
"lave-linge" => "lavl5Z",
"lave-mains" => "lavm5",
"lave-pont" => "lavp§",
"lave-ponts" => "lavp§",
"lave-vaisselle" => "lavvEsEl",
"lavedu" => "lavdy",
"lavée" => "lave",
"lavées" => "lave",
"lavement" => "lav°m@",
"lavements" => "lav°m@",
"lavent" => "lav",
"laver" => "lave",
"lavera" => "lav°Ra",
"laverai" => "lav°RE",
"laverais" => "lav°RE",
"laverait" => "lav°RE",
"laveras" => "lav°Ra",
"lavèrent" => "lavER",
"laverez" => "lav°Re",
"laverie" => "lav°Ri",
"laveries" => "lav°Ri",
"laverions" => "lav°Rj§",
"laverons" => "lav°R§",
"laveront" => "lav°R§",
"laves" => "lav",
"lavés" => "lave",
"lavette" => "lavEt",
"lavettes" => "lavEt",
"laveur" => "lav9R",
"laveurs" => "lav9R",
"laveuse" => "lav2z",
"laveuses" => "lav2z",
"lavez" => "lave",
"lavions" => "lavj§",
"lavis" => "lavi",
"lavoir" => "lavwaR",
"lavoirs" => "lavwaR",
"lavons" => "lav§",
"lavure" => "lavyR",
"lavures" => "lavyR",
"laxatif" => "laksatif",
"laxatifs" => "laksatif",
"laxative" => "laksativ",
"laxatives" => "laksativ",
"laxisme" => "laksizm",
"laxiste" => "laksist",
"laxistes" => "laksist",
"laxité" => "laksite",
"laya" => "leja",
"layer" => "leje",
"layette" => "lEjEt",
"layettes" => "lEjEt",
"layon" => "lEj§",
"layons" => "lEj§",
"lazaret" => "lazaRE",
"lazarets" => "lazaRE",
"lazaro" => "lazaRo",
"lazingue" => "laz5g",
"lazzi" => "ladzi",
"lazzis" => "ladzi",
"le" => "l2",
"lé" => "le",
"leader" => "lid9R",
"leaders" => "lid9R",
"leadership" => "lid9RSip",
"leasing" => "liziG",
"lebel" => "l°bEl",
"lebels" => "l°bEl",
"leben" => "l°b@",
"lécha" => "leSa",
"léchage" => "leSaZ",
"léchages" => "leSaZ",
"léchaient" => "leSE",
"léchais" => "leSE",
"léchait" => "leSE",
"léchant" => "leS@",
"léchassions" => "leSasj§",
"lèche" => "lES",
"léché" => "leSe",
"lèche-botte" => "lESbOt",
"lèche-bottes" => "lESbOt",
"lèche-cul" => "lESky",
"lèche-vitrine" => "lESvitRin",
"lèche-vitrines" => "lESvitRin",
"léchée" => "leSe",
"léchées" => "leSe",
"lèchefrite" => "lESfRit",
"lèchent" => "lES",
"lécher" => "leSe",
"léchera" => "leS°Ra",
"lécherai" => "leS°RE",
"lécherais" => "leS°RE",
"lécherait" => "leS°RE",
"lécheras" => "leS°Ra",
"léchèrent" => "leSER",
"lècheries" => "lES°Ri",
"lécheront" => "leS°R§",
"lèches" => "lES",
"léchés" => "leSe",
"lécheur" => "leS9R",
"lécheurs" => "leS9R",
"lécheuse" => "leS2z",
"lécheuses" => "leS2z",
"léchez" => "leSe",
"léchouillait" => "leSujE",
"léchouillent" => "leSuj",
"léchouiller" => "leSuje",
"léchouilles" => "leSuj",
"lécithine" => "lesitin",
"leçon" => "l°s§",
"leçons" => "l°s§",
"lecteur" => "lEkt9R",
"lecteurs" => "lEkt9R",
"lectorat" => "lEktoRa",
"lectrice" => "lEktRis",
"lectrices" => "lEktRis",
"lecture" => "lEktyR",
"lectures" => "lEktyR",
"ledit" => "l°di",
"légal" => "legal",
"légale" => "legal",
"légalement" => "legal°m@",
"légales" => "legal",
"légalisant" => "legaliz@",
"légalisation" => "legalizasj§",
"légalise" => "legaliz",
"légalisé" => "legalize",
"légalisée" => "legalize",
"légaliser" => "legalize",
"légalisez" => "legalize",
"légaliste" => "legalist",
"légalistes" => "legalist",
"légalité" => "legalite",
"légat" => "lega",
"légataire" => "legatER",
"légataires" => "legatER",
"légation" => "legasj§",
"légations" => "legasj§",
"legato" => "legato",
"légats" => "lega",
"légaux" => "lego",
"légendaire" => "leZ@dER",
"légendaires" => "leZ@dER",
"légende" => "leZ@d",
"légendée" => "leZ@de",
"légender" => "leZ@de",
"légendes" => "leZ@d",
"léger" => "leZe",
"légère" => "leZER",
"légèrement" => "leZER°m@",
"légères" => "leZER",
"légèreté" => "leZER°te",
"légèretés" => "leZER°te",
"légers" => "leZe",
"leggins" => "legins",
"leghorns" => "legORn",
"légiférait" => "leZifeRE",
"légifère" => "leZifER",
"légiféré" => "leZifeRe",
"légiférer" => "leZifeRe",
"légion" => "leZj§",
"légionellose" => "leZjOneloz",
"légionnaire" => "leZjonER",
"légionnaires" => "leZjonER",
"légions" => "leZj§",
"législateur" => "leZislat9R",
"législateurs" => "leZislat9R",
"législatif" => "leZislatif",
"législatifs" => "leZislatif",
"législation" => "leZislasj§",
"législative" => "leZislativ",
"législatives" => "leZislativ",
"législature" => "leZislatyR",
"légiste" => "leZist",
"légistes" => "leZist",
"légitimaient" => "leZitimE",
"légitimait" => "leZitimE",
"légitimant" => "leZitim@",
"légitimation" => "leZitimasj§",
"légitimations" => "leZitimasj§",
"légitime" => "leZitim",
"légitimé" => "leZitime",
"légitimée" => "leZitime",
"légitimement" => "leZitim°m@",
"légitiment" => "leZitim",
"légitimer" => "leZitime",
"légitimera" => "leZitim°Ra",
"légitimes" => "leZitim",
"légitimiste" => "leZitimist",
"légitimistes" => "leZitimist",
"légitimité" => "leZitimite",
"lego" => "lego",
"legos" => "lEgo",
"legs" => "lEg",
"légua" => "lega",
"léguaient" => "legE",
"léguais" => "legE",
"léguait" => "legE",
"léguant" => "leg@",
"lègue" => "lEg",
"légué" => "lege",
"léguée" => "lege",
"léguées" => "lege",
"léguer" => "lege",
"léguera" => "leg°Ra",
"léguerai" => "leg°RE",
"léguerais" => "leg°RE",
"léguerez" => "leg°Re",
"léguerons" => "leg°R§",
"légueront" => "leg°R§",
"légués" => "lege",
"léguez" => "lege",
"légume" => "legym",
"légumes" => "legym",
"légumier" => "legymje",
"légumineuse" => "legymin2z",
"légumineux" => "legymin2",
"lei" => "lE",
"leishmaniose" => "lESmanjoz",
"leitmotiv" => "lEjtmotiv",
"leitmotive" => "lajtmotiv",
"lek" => "lEk",
"lem" => "lEm",
"lemmes" => "lEm",
"lemming" => "lEmiG",
"lemmings" => "lEmiG",
"lémur" => "lemyR",
"lémure" => "lemyR",
"lémures" => "lemyR",
"lémurien" => "lemyRj5",
"lémuriens" => "lemyRj5",
"lendemain" => "l@d°m5",
"lendemains" => "l@d°m5",
"lénifiait" => "lenifjE",
"lénifiant" => "lenifj@",
"lénifiante" => "lenifj@t",
"lénifiantes" => "lenifj@t",
"lénifiants" => "lenifj@",
"lénification" => "lenifikasj§",
"léninisme" => "leninizm",
"léniniste" => "leninist",
"léninistes" => "leninist",
"lénitive" => "lenitiv",
"lénitives" => "lenitiv",
"lent" => "l@",
"lente" => "l@t",
"lentement" => "l@t°m@",
"lentes" => "l@t",
"lenteur" => "l@t9R",
"lenteurs" => "l@t9R",
"lenticulaires" => "l@tikylER",
"lenticules" => "l@tikyl",
"lentille" => "l@tij",
"lentilles" => "l@tij",
"lentisque" => "l@tisk",
"lentisques" => "l@tisk",
"lento" => "lEnto",
"lents" => "l@",
"léonard" => "leonaR",
"léonin" => "leon5",
"léonine" => "leonin",
"léonins" => "leon5",
"léopard" => "leopaR",
"léopardé" => "leopaRde",
"léopards" => "leopaR",
"lépidoptère" => "lepidOptER",
"lépidoptères" => "lepidOptER",
"lépiotes" => "lepjOt",
"lépontique" => "lep§tik",
"lèpre" => "lEpR",
"lèpres" => "lEpR",
"lépreuse" => "lepR2z",
"lépreuses" => "lepR2z",
"lépreux" => "lepR2",
"léprologie" => "lepROlOZi",
"léproserie" => "lepRoz°Ri",
"léproseries" => "lepRoz°Ri",
"lepton" => "lEpt§",
"leptonique" => "lEptOnik",
"leptons" => "lEpt§",
"lequel" => "l°kEl",
"lerch" => "lERS",
"lerche" => "lERS",
"lérot" => "leRo",
"lérots" => "leRo",
"les" => "le",
"lés" => "le",
"lès" => "lE",
"lésaient" => "lezE",
"lésais" => "lezE",
"lesbianisme" => "lEsbjanizm",
"lesbien" => "lEzbj5",
"lesbienne" => "lEsbjEn",
"lesbiennes" => "lEsbjEn",
"lesdites" => "lEdit",
"lesdits" => "lEdi",
"lèse" => "lEz",
"lésé" => "leze",
"lèse-majesté" => "lEzmaZEste",
"lésée" => "leze",
"lésées" => "leze",
"léser" => "leze",
"lésés" => "leze",
"lésina" => "lezina",
"lésinaient" => "lezinE",
"lésinait" => "lezinE",
"lésine" => "lezin",
"lésiné" => "lezine",
"lésinent" => "lezin",
"lésiner" => "lezine",
"lésinerie" => "lezin°Ri",
"lésines" => "lezin",
"lésinez" => "lezine",
"lésion" => "lezj§",
"lésionnaire" => "lezjOnER",
"lésions" => "lezj§",
"lésons" => "lez§",
"lesquelles" => "lEkEl",
"lesquels" => "lEkEl",
"lessiva" => "lEsiva",
"lessivage" => "lesivaZ",
"lessivaient" => "lEsivE",
"lessivait" => "lEsivE",
"lessivant" => "lEsiv@",
"lessive" => "lesiv",
"lessivé" => "lEsive",
"lessivée" => "lEsive",
"lessiver" => "lesive",
"lessiverait" => "lEsiv°RE",
"lessives" => "lesiv",
"lessivés" => "lEsive",
"lessiveuse" => "lesiv2z",
"lessiveuses" => "lEsiv2z",
"lessivons" => "lEsiv§",
"lest" => "lEst",
"leste" => "lEst",
"lesté" => "lEste",
"lestée" => "lEste",
"lestées" => "lEste",
"lestement" => "lEst°m@",
"lester" => "lEste",
"lestera" => "lEst°Ra",
"lesterait" => "lEst°RE",
"lestes" => "lEst",
"lestés" => "lEste",
"lestez" => "lEste",
"let" => "lE",
"létal" => "letal",
"létale" => "letal",
"létales" => "letal",
"létalité" => "letalite",
"letchis" => "lEtSi",
"léthargie" => "letaRZi",
"léthargies" => "letaRZi",
"léthargique" => "letaRZik",
"léthargiques" => "letaRZik",
"lette" => "lEt",
"lettes" => "lEt",
"letton" => "lEt§",
"lettone" => "lEtOn",
"lettonne" => "lEtOn",
"lettonnes" => "lEtOn",
"lettons" => "lEt§",
"lettrage" => "lEtRaZ",
"lettre" => "lEtR",
"lettré" => "letRe",
"lettre-clé" => "lEtRkle",
"lettrée" => "letRe",
"lettres" => "lEtR",
"lettrés" => "lEtRe",
"lettreur" => "lEtR9R",
"lettrine" => "lEtRin",
"lettrines" => "lEtRin",
"lettriques" => "lEtRik",
"lettristes" => "lEtRist",
"leu" => "l2",
"leucémie" => "l2semi",
"leucémies" => "l2semi",
"leucémique" => "l2semik",
"leucocytaire" => "l2kOsitER",
"leucocyte" => "l2kosit",
"leucocytes" => "l2kosit",
"leucocytose" => "l2kOsitoz",
"leucopénie" => "l2kopeni",
"leucoplasie" => "l2koplazi",
"leucose" => "l2koz",
"leucotomie" => "l2kotomi",
"leur" => "l9R",
"leurrais" => "l9RE",
"leurrait" => "l9RE",
"leurre" => "l9R",
"leurré" => "l9Re",
"leurrent" => "l9R",
"leurrer" => "l9Re",
"leurres" => "l9R",
"leurrés" => "l9Re",
"leurrez" => "l9Re",
"leurrons" => "l9R§",
"leurs" => "l9R",
"lev" => "lEv",
"leva" => "l°va",
"levage" => "l°vaZ",
"levai" => "l°vE",
"levaient" => "l°vE",
"levain" => "l°v5",
"levais" => "l°vE",
"levait" => "l°vE",
"levâmes" => "l°vam",
"levant" => "l°v@",
"levante" => "l°v@t",
"levantin" => "l°v@t5",
"levantines" => "l°v@tin",
"levantins" => "l°v@t5",
"levât" => "l°va",
"lève" => "lEv",
"levé" => "l°ve",
"levée" => "l°ve",
"levées" => "l°ve",
"lèvent" => "lEv",
"lever" => "l°ve",
"lèvera" => "lEv°Ra",
"lèverai" => "lEv°RE",
"lèveraient" => "lEv°RE",
"lèverais" => "lEv°RE",
"lèverait" => "lEv°RE",
"lèveras" => "lEv°Ra",
"levèrent" => "l°vER",
"lèverez" => "lEv°Re",
"lèverons" => "lEv°R§",
"lèveront" => "lEv°R§",
"levers" => "l°ve",
"lèves" => "lEv",
"levés" => "l°ve",
"leveur" => "l°v9R",
"leveurs" => "l°v9R",
"leveuse" => "l°v2z",
"levez" => "l°ve",
"léviathan" => "levjat@",
"levier" => "l°vje",
"leviers" => "l°vje",
"leviez" => "l°vje",
"levions" => "l°vj§",
"lévitation" => "levitasj§",
"lévite" => "levit",
"lévitent" => "levit",
"léviter" => "levite",
"lévites" => "levit",
"lévitique" => "levitik",
"levons" => "l°v§",
"lèvre" => "lEvR",
"levreau" => "l°vRo",
"levreaux" => "l°vRo",
"lèvres" => "lEvR",
"levrette" => "l°vREt",
"levrettes" => "l°vREt",
"lévrier" => "levRije",
"lévriers" => "levRije",
"levure" => "l°vyR",
"levures" => "l°vyR",
"lexical" => "lEksikal",
"lexicographes" => "lEksikogRaf",
"lexie" => "lEksi",
"lexique" => "lEksik",
"lexiques" => "lEksik",
"lez" => "lE",
"lézard" => "lezaR",
"lézardaient" => "lezaRdE",
"lézardait" => "lezaRdE",
"lézarde" => "lezaRd",
"lézardé" => "lezaRde",
"lézardée" => "lezaRde",
"lézardées" => "lezaRde",
"lézardent" => "lezaRd",
"lézarder" => "lezaRde",
"lézardes" => "lezaRd",
"lézardés" => "lezaRde",
"lézards" => "lezaR",
"li" => "li",
"lia" => "lja",
"liage" => "ljaZ",
"liai" => "ljE",
"liaient" => "ljE",
"liais" => "ljE",
"liaison" => "ljEz§",
"liaisons" => "ljEz§",
"liait" => "ljE",
"liâmes" => "ljam",
"liane" => "ljan",
"lianes" => "ljan",
"liant" => "lj@",
"liante" => "lj@t",
"liants" => "lj@",
"liard" => "ljaR",
"liardais" => "ljaRdE",
"liards" => "ljaR",
"liasse" => "ljas",
"liasses" => "ljas",
"liât" => "lja",
"libanais" => "libanE",
"libanaise" => "libanEz",
"libanaises" => "libanEz",
"libation" => "libasj§",
"libations" => "libasj§",
"libeccio" => "libEksjo",
"libelle" => "libEl",
"libellé" => "libele",
"libellée" => "libEle",
"libellées" => "libEle",
"libeller" => "libele",
"libelles" => "libEl",
"libellule" => "libelyl",
"libellules" => "libElyl",
"liber" => "libER",
"libera" => "lib°Ra",
"libéra" => "libeRa",
"libérable" => "libeRabl",
"libérables" => "libeRabl",
"libérai" => "libeRE",
"libéraient" => "libeRE",
"libérais" => "libeRE",
"libérait" => "libeRE",
"libéral" => "libeRal",
"libérale" => "libeRal",
"libéralement" => "libeRal°m@",
"libérales" => "libeRal",
"libéralisation" => "libeRalizasj§",
"libéralisme" => "libeRalizm",
"libéralité" => "libeRalite",
"libéralités" => "libeRalite",
"libérant" => "libeR@",
"libérât" => "libeRa",
"libérateur" => "libeRat9R",
"libérateurs" => "libeRat9R",
"libération" => "libeRasj§",
"libérations" => "libeRasj§",
"libératoire" => "libeRatwaR",
"libératrice" => "libeRatRis",
"libératrices" => "libeRatRis",
"libéraux" => "libeRo",
"libère" => "libER",
"libéré" => "libeRe",
"libérée" => "libeRe",
"libérées" => "libeRe",
"libèrent" => "libER",
"libérer" => "libeRe",
"libérera" => "libeR°Ra",
"libérerai" => "libeR°RE",
"libéreraient" => "libeR°RE",
"libérerais" => "libeR°RE",
"libérerait" => "libeR°RE",
"libéreras" => "libeR°Ra",
"libérèrent" => "libeRER",
"libérerez" => "libeR°Re",
"libérerons" => "libeR°R§",
"libéreront" => "libeR°R§",
"libères" => "libER",
"libérés" => "libeRe",
"libérez" => "libeRe",
"libérien" => "libeRj5",
"libériez" => "libeRje",
"libérions" => "libeRj§",
"libero" => "lib°Ro",
"libéro" => "libeRo",
"libérons" => "libeR§",
"libertaire" => "libERtER",
"libertaires" => "libERtER",
"liberté" => "libERte",
"libertés" => "libERte",
"liberticide" => "libERtisid",
"libertin" => "libERt5",
"libertinage" => "libERtinaZ",
"libertine" => "libERtin",
"libertines" => "libERtin",
"libertins" => "libERt5",
"libidinal" => "libidinal",
"libidinale" => "libidinal",
"libidinales" => "libidinal",
"libidinaux" => "libidino",
"libidineuse" => "libidin2z",
"libidineuses" => "libidin2z",
"libidineux" => "libidin2",
"libido" => "libido",
"libraire" => "libRER",
"libraires" => "libRER",
"librairie" => "libReRi",
"librairie-papeterie" => "libReRipapet°Ri",
"librairies" => "libReRi",
"libre" => "libR",
"libre-arbitre" => "libRaRbitR",
"libre-échange" => "libReS@Z",
"libre-échangiste" => "libReS@Zist",
"libre-penseur" => "libR°p@s9R",
"libre-penseuse" => "libR2p@s2z",
"libre-service" => "libR°sERvis",
"librement" => "libR°m@",
"libres" => "libR",
"librettiste" => "libRetist",
"librettistes" => "libRetist",
"libretto" => "libREto",
"libyen" => "libj5",
"libyenne" => "libjEn",
"libyens" => "libj5",
"lice" => "lis",
"licéité" => "liseite",
"licence" => "lis@s",
"licences" => "lis@s",
"licencia" => "lis@sja",
"licenciables" => "lis@sjabl",
"licenciai" => "lis@sjE",
"licenciaient" => "lis@sjE",
"licenciait" => "lis@sjE",
"licenciant" => "lis@sj@",
"licencie" => "lis@si",
"licencié" => "lis@sje",
"licenciée" => "lis@sje",
"licenciées" => "lis@sje",
"licenciement" => "lis@sim@",
"licenciements" => "lis@sim@",
"licencient" => "lis@si",
"licencier" => "lis@sje",
"licenciera" => "lis@siRa",
"licenciés" => "lis@sje",
"licencieuse" => "lis@sj2z",
"licencieuses" => "lis@sj2z",
"licencieux" => "lis@sj2",
"licenciez" => "lis@sje",
"lices" => "lis",
"lichant" => "liS@",
"lichas" => "liSa",
"liche" => "liS",
"liché" => "liSe",
"lichée" => "liSe",
"lichées" => "liSe",
"lichen" => "likEn",
"lichens" => "likEn",
"licher" => "liSe",
"lichette" => "liSEt",
"lichettes" => "liSEt",
"lichotter" => "liSOte",
"liciers" => "lisje",
"licite" => "lisit",
"licites" => "lisit",
"licol" => "likOl",
"licols" => "likOl",
"licorne" => "likORn",
"licornes" => "likORn",
"licou" => "liku",
"licous" => "liku",
"licteur" => "likt9R",
"licteurs" => "likt9R",
"lido" => "lido",
"lidocaïne" => "lidokain",
"lie" => "li",
"lié" => "lje",
"lie-de-vin" => "lid°v5",
"lied" => "lid",
"lieder" => "lid9R",
"liée" => "lje",
"liées" => "lje",
"liège" => "ljEZ",
"liégeois" => "ljeZwa",
"lièges" => "ljEZ",
"lien" => "lj5",
"liens" => "lj5",
"lient" => "li",
"lier" => "lje",
"liera" => "liRa",
"lierais" => "liRE",
"lierait" => "liRE",
"lieras" => "liRa",
"lièrent" => "ljER",
"lieront" => "liR§",
"lierre" => "ljER",
"lierres" => "ljER",
"lies" => "li",
"liés" => "lje",
"liesse" => "ljEs",
"liesses" => "ljEs",
"lieu" => "lj2",
"lieu-dit" => "lj2di",
"lieudit" => "lj2di",
"lieudits" => "lj2di",
"lieue" => "lj2",
"lieues" => "lj2",
"lieur" => "lj9R",
"lieus" => "lj2",
"lieuse" => "lj2z",
"lieutenant" => "lj2t°n@",
"lieutenant-colonel" => "lj2t°n@kolonEl",
"lieutenant-pilote" => "lj2t°n@pilOt",
"lieutenants" => "lj2t°n@",
"lieutenants-colonels" => "lj2t°n@kolonEl",
"lieux" => "lj2",
"lieux-dits" => "lj2di",
"lièvre" => "ljEvR",
"lièvres" => "ljEvR",
"liez" => "lje",
"lift" => "lift",
"lifté" => "lifte",
"liftée" => "lifte",
"liftées" => "lifte",
"lifter" => "lifte",
"liftier" => "liftje",
"liftière" => "liftjER",
"liftiers" => "liftje",
"lifting" => "liftiG",
"liftings" => "liftiG",
"lifts" => "lif",
"ligament" => "ligam@",
"ligamentaire" => "ligam@tER",
"ligaments" => "ligam@",
"ligature" => "ligatyR",
"ligaturé" => "ligatyRe",
"ligaturée" => "ligatyRe",
"ligaturer" => "ligatyRe",
"ligatures" => "ligatyR",
"ligaturez" => "ligatyRe",
"lige" => "liZ",
"liges" => "liZ",
"light" => "lajt",
"ligna" => "liNa",
"lignage" => "liNaZ",
"lignages" => "liNaZ",
"lignards" => "liNaR",
"ligne" => "liN",
"ligné" => "liNe",
"lignée" => "liNe",
"lignées" => "liNe",
"ligner" => "liNe",
"lignes" => "liN",
"ligneuses" => "liN2z",
"ligneux" => "liN2",
"lignite" => "liNit",
"lignites" => "liNit",
"ligot" => "ligo",
"ligota" => "ligota",
"ligotage" => "ligotaZ",
"ligotaient" => "ligotE",
"ligotait" => "ligotE",
"ligotant" => "ligot@",
"ligote" => "ligOt",
"ligoté" => "ligote",
"ligotée" => "ligote",
"ligotées" => "ligote",
"ligotent" => "ligOt",
"ligoter" => "ligote",
"ligoterai" => "ligOt°RE",
"ligoterait" => "ligOt°RE",
"ligotèrent" => "ligotER",
"ligoterons" => "ligOt°R§",
"ligotés" => "ligote",
"ligotez" => "ligote",
"ligotons" => "ligot§",
"ligots" => "ligo",
"liguaient" => "ligE",
"liguait" => "ligE",
"liguant" => "lig@",
"ligue" => "lig",
"ligué" => "lige",
"liguées" => "lige",
"liguent" => "lig",
"liguer" => "lige",
"liguèrent" => "ligER",
"ligues" => "lig",
"ligués" => "lige",
"ligueur" => "lig9R",
"ligueurs" => "lig9R",
"liguez" => "lige",
"ligure" => "ligyR",
"ligures" => "ligyR",
"lilas" => "lila",
"liliacées" => "liljase",
"lilial" => "liljal",
"liliale" => "liljal",
"lilium" => "liljOm",
"lilliputien" => "lilipysj5",
"lilliputienne" => "lilipysjEn",
"lilliputiens" => "lilipysj5",
"lillois" => "lilwa",
"lilloise" => "lilwaz",
"lima" => "lima",
"limace" => "limas",
"limaces" => "limas",
"limaçon" => "limas§",
"limaçons" => "limas§",
"limage" => "limaZ",
"limaient" => "limE",
"limaille" => "limaj",
"limait" => "limE",
"liman" => "lim@",
"limande" => "lim@d",
"limandes" => "lim@d",
"limant" => "lim@",
"limbe" => "l5b",
"limbes" => "l5b",
"limbique" => "l5bik",
"limbo" => "limbo",
"lime" => "lim",
"limé" => "lime",
"limée" => "lime",
"liment" => "lim",
"limer" => "lime",
"limerick" => "lim°Rik",
"limericks" => "lim°Rik",
"limes" => "lim",
"limette" => "limEt",
"limez" => "lime",
"limier" => "limje",
"limiers" => "limje",
"liminaire" => "liminER",
"limions" => "limj§",
"limita" => "limita",
"limitai" => "limitE",
"limitaient" => "limitE",
"limitais" => "limitE",
"limitait" => "limitE",
"limitant" => "limit@",
"limitatif" => "limitatif",
"limitation" => "limitasj§",
"limitations" => "limitasj§",
"limitative" => "limitativ",
"limite" => "limit",
"limité" => "limite",
"limitée" => "limite",
"limitées" => "limite",
"limitent" => "limit",
"limiter" => "limite",
"limitera" => "limit°Ra",
"limiterai" => "limit°RE",
"limiteraient" => "limit°RE",
"limiterait" => "limit°RE",
"limiteront" => "limit°R§",
"limites" => "limit",
"limités" => "limite",
"limiteur" => "limit9R",
"limitez" => "limite",
"limitions" => "limitj§",
"limitons" => "limit§",
"limitrophe" => "limitROf",
"limitrophes" => "limitROf",
"limoge" => "limOZ",
"limogé" => "limoZe",
"limogeage" => "limoZaZ",
"limoger" => "limoZe",
"limoges" => "limOZ",
"limon" => "lim§",
"limonade" => "limonad",
"limonades" => "limonad",
"limonadier" => "limonadje",
"limonadière" => "limonadjER",
"limonadiers" => "limonadje",
"limonaire" => "limonER",
"limoneuse" => "limon2z",
"limoneuses" => "limon2z",
"limoneux" => "limon2",
"limonier" => "limonje",
"limonière" => "limonjER",
"limons" => "lim§",
"limoselle" => "limozEl",
"limousin" => "limuz5",
"limousine" => "limuzin",
"limousines" => "limuzin",
"limousins" => "limuz5",
"limpide" => "l5pid",
"limpides" => "l5pid",
"limpidité" => "l5pidite",
"lin" => "l5",
"linaire" => "linER",
"linceul" => "l5s9l",
"linceuls" => "l5s9l",
"lindor" => "l5dOR",
"line" => "lin",
"linéaire" => "lineER",
"linéairement" => "lineER°m@",
"linéaires" => "lineER",
"linéaments" => "lineam@",
"linga" => "linga",
"lingala" => "lingala",
"lingam" => "lingam",
"linge" => "l5Z",
"linger" => "l5Ze",
"lingère" => "l5ZER",
"lingères" => "l5ZER",
"lingerie" => "l5Z°Ri",
"lingeries" => "l5Z°Ri",
"linges" => "l5Z",
"lingette" => "l5ZEt",
"lingettes" => "l5ZEt",
"lingot" => "l5go",
"lingotière" => "l5gotjER",
"lingots" => "l5go",
"lingual" => "l5gwal",
"linguale" => "l5gwal",
"linguaux" => "l5gwo",
"linguiste" => "l5g8ist",
"linguistes" => "l5g8ist",
"linguistique" => "l5g8istik",
"linguistiquement" => "l5g8istik°m@",
"linguistiques" => "l5g8istik",
"liniment" => "linim@",
"lino" => "lino",
"linoléum" => "linoleOm",
"linoléums" => "linoleOm",
"linon" => "lin§",
"linons" => "lin§",
"linos" => "lino",
"linotte" => "linOt",
"linottes" => "linOt",
"linotype" => "linotip",
"linotypes" => "linotip",
"linotypistes" => "linotipist",
"lins" => "l5",
"linteau" => "l5to",
"linteaux" => "l5to",
"linter" => "lint9R",
"lion" => "lj§",
"lionceau" => "lj§so",
"lionceaux" => "lj§so",
"lionne" => "ljOn",
"lionnes" => "ljOn",
"lions" => "lj§",
"lipase" => "lipaz",
"lipide" => "lipid",
"lipides" => "lipid",
"lipiodol" => "lipjOdOl",
"lipome" => "lipom",
"liposome" => "lipozom",
"liposuccion" => "liposyksj§",
"liposuccions" => "liposyksj§",
"liposucer" => "lipOsyse",
"lipothymie" => "lipotimi",
"lippe" => "lip",
"lippées" => "lipe",
"lippes" => "lip",
"lippu" => "lipy",
"lippue" => "lipy",
"lippues" => "lipy",
"lippus" => "lipy",
"liquéfaction" => "likefaksj§",
"liquéfiaient" => "likefjE",
"liquéfiait" => "likefjE",
"liquéfiante" => "likefj@t",
"liquéfie" => "likefi",
"liquéfié" => "likefje",
"liquéfiée" => "likefje",
"liquéfiées" => "likefje",
"liquéfient" => "likefi",
"liquéfier" => "likefje",
"liquéfièrent" => "likefjER",
"liquéfiés" => "likefje",
"liquette" => "likEt",
"liquettes" => "likEt",
"liqueur" => "lik9R",
"liqueurs" => "lik9R",
"liquida" => "likida",
"liquidai" => "likidE",
"liquidaient" => "likidE",
"liquidait" => "likidE",
"liquidambars" => "likid@baR",
"liquidant" => "likid@",
"liquidateur" => "likidat9R",
"liquidateurs" => "likidat9R",
"liquidation" => "likidasj§",
"liquidations" => "likidasj§",
"liquidative" => "likidativ",
"liquide" => "likid",
"liquidé" => "likide",
"liquidée" => "likide",
"liquidées" => "likide",
"liquident" => "likid",
"liquider" => "likide",
"liquidera" => "likid°Ra",
"liquiderai" => "likid°RE",
"liquiderais" => "likid°RE",
"liquiderait" => "likid°RE",
"liquiderons" => "likid°R§",
"liquideront" => "likid°R§",
"liquides" => "likid",
"liquidés" => "likide",
"liquidez" => "likide",
"liquidions" => "likidj§",
"liquidité" => "likidite",
"liquidités" => "likidite",
"liquidons" => "likid§",
"liquor" => "likwOR",
"liquoreux" => "likoR2",
"liquoriste" => "likoRist",
"lira" => "liRa",
"lirai" => "liRE",
"liraient" => "liRE",
"lirais" => "liRE",
"lirait" => "liRE",
"liras" => "liRa",
"lire" => "liR",
"lires" => "liR",
"lirette" => "liREt",
"lirez" => "liRe",
"liriez" => "liRje",
"liron" => "liR§",
"lirons" => "liR§",
"liront" => "liR§",
"lis" => "li",
"lisaient" => "lizE",
"lisais" => "lizE",
"lisait" => "lizE",
"lisant" => "liz@",
"lise" => "liz",
"lisent" => "liz",
"lisérait" => "lizeRE",
"liseré" => "liz°Re",
"liséré" => "lizeRe",
"liserée" => "liz°Re",
"liserés" => "liz°Re",
"lisérés" => "lizeRe",
"liseron" => "liz°R§",
"liserons" => "liz°R§",
"lises" => "liz",
"liseur" => "liz9R",
"liseuse" => "liz2z",
"liseuses" => "liz2z",
"lisez" => "lize",
"lisibilité" => "lizibilite",
"lisible" => "lizibl",
"lisiblement" => "lizibl°m@",
"lisibles" => "lizibl",
"lisier" => "lizje",
"lisière" => "lizjER",
"lisières" => "lizjER",
"lisiez" => "lizje",
"lisions" => "lizj§",
"lisons" => "liz§",
"lissa" => "lisa",
"lissage" => "lisaZ",
"lissai" => "lisE",
"lissaient" => "lisE",
"lissais" => "lisE",
"lissait" => "lisE",
"lissant" => "lis@",
"lisse" => "lis",
"lissé" => "lise",
"lissée" => "lise",
"lissées" => "lise",
"lissent" => "lis",
"lisser" => "lise",
"lissera" => "lis°Ra",
"lisserait" => "lis°RE",
"lissèrent" => "lisER",
"lisses" => "lis",
"lissés" => "lise",
"lisseur" => "lis9R",
"lisseurs" => "lis9R",
"lissez" => "lise",
"lissons" => "lis§",
"lissotriche" => "lisOtRiS",
"liste" => "list",
"listé" => "liste",
"listée" => "liste",
"listées" => "liste",
"listel" => "listEl",
"lister" => "liste",
"listeria" => "listeRja",
"listes" => "list",
"listés" => "liste",
"listez" => "liste",
"listing" => "listiG",
"listings" => "listiG",
"liston" => "list§",
"lit" => "li",
"lit-bateau" => "libato",
"lit-cage" => "likaZ",
"lit-divan" => "lidiv@",
"lita" => "lita",
"litanie" => "litani",
"litanies" => "litani",
"lite" => "lit",
"lité" => "lite",
"liteaux" => "lito",
"litée" => "lite",
"liter" => "lite",
"literie" => "lit°Ri",
"literies" => "lit°Ri",
"lithiase" => "litjaz",
"lithinés" => "litine",
"lithique" => "litik",
"lithium" => "litjOm",
"litho" => "lito",
"lithographe" => "litogRaf",
"lithographie" => "litogRafi",
"lithographié" => "litogRafje",
"lithographies" => "litogRafi",
"lithophages" => "litofaZ",
"lithos" => "lito",
"lithosphère" => "litOsfER",
"lithotripsie" => "litotRipzi",
"lithotriteur" => "litotRit9R",
"lithuanien" => "lit8anj5",
"lithuanienne" => "lityanjEn",
"lithuaniennes" => "lit8anjEn",
"litière" => "litjER",
"litières" => "litjER",
"litige" => "litiZ",
"litiges" => "litiZ",
"litigieuse" => "litiZj2z",
"litigieux" => "litiZj2",
"litorne" => "litORn",
"litote" => "litOt",
"litotes" => "litOt",
"litre" => "litR",
"litrer" => "litRe",
"litres" => "litR",
"litron" => "litR§",
"litronaient" => "litRonE",
"litroné" => "litRone",
"litrons" => "litR§",
"lits" => "li",
"lits-cages" => "likaZ",
"littéraire" => "liteRER",
"littérairement" => "liteRER°m@",
"littéraires" => "liteRER",
"littéral" => "liteRal",
"littérale" => "liteRal",
"littéralement" => "liteRal°m@",
"littérales" => "liteRal",
"littéralité" => "liteRalite",
"littérateur" => "liteRat9R",
"littérateurs" => "liteRat9R",
"littérature" => "liteRatyR",
"littératures" => "liteRatyR",
"littéraux" => "liteRo",
"littoral" => "litoRal",
"littorale" => "litoRal",
"littoraux" => "litORo",
"lituanien" => "lit8anj5",
"lituanienne" => "lityanjEn",
"lituaniennes" => "lityanjEn",
"lituaniens" => "lit8anj5",
"liturgie" => "lityRZi",
"liturgies" => "lityRZi",
"liturgique" => "lityRZik",
"liturgiques" => "lityRZik",
"livarot" => "livaRo",
"live" => "liv",
"livèche" => "livES",
"livide" => "livid",
"livides" => "livid",
"lividité" => "lividite",
"living" => "liviG",
"living-room" => "liviGRum",
"livings" => "liviG",
"livoniennes" => "livonjEn",
"livra" => "livRa",
"livrable" => "livRabl",
"livrables" => "livRabl",
"livrai" => "livRE",
"livraient" => "livRE",
"livrais" => "livRE",
"livraison" => "livREz§",
"livraisons" => "livREz§",
"livrait" => "livRE",
"livrâmes" => "livRam",
"livrant" => "livR@",
"livrât" => "livRa",
"livre" => "livR",
"livré" => "livRe",
"livre-cassette" => "livR2kasEt",
"livrée" => "livRe",
"livrées" => "livRe",
"livrent" => "livR",
"livrer" => "livRe",
"livrera" => "livR°Ra",
"livrerai" => "livR°RE",
"livreraient" => "livR°RE",
"livrerais" => "livR°RE",
"livrerait" => "livR°RE",
"livreras" => "livR°Ra",
"livrèrent" => "livRER",
"livrerez" => "livR°Re",
"livrerons" => "livR°R§",
"livreront" => "livR°R§",
"livres" => "livR",
"livrés" => "livRe",
"livres-club" => "livRkl9b",
"livresque" => "livREsk",
"livresques" => "livREsk",
"livret" => "livRE",
"livrets" => "livRE",
"livreur" => "livR9R",
"livreurs" => "livR9R",
"livreuse" => "livR2z",
"livrez" => "livRe",
"livrions" => "livRij§",
"livrons" => "livR§",
"llanos" => "lanos",
"lloyd" => "lOjd",
"loader" => "lod9R",
"lob" => "lOb",
"lobaire" => "lObER",
"lobbies" => "lObi",
"lobby" => "lObi",
"lobbying" => "lObijiG",
"lobe" => "lOb",
"lobé" => "lobe",
"lobectomie" => "lobEktomi",
"lobée" => "lObe",
"lober" => "lobe",
"lobes" => "lOb",
"lobotomie" => "lobotomi",
"lobotomisé" => "lobotomize",
"lobotomisée" => "lObOtOmize",
"lobotomiser" => "lobotomize",
"lobs" => "lOb",
"lobulaire" => "lobylER",
"local" => "lokal",
"locale" => "lokal",
"localement" => "lokal°m@",
"locales" => "lokal",
"localisa" => "lokaliza",
"localisable" => "lokalizabl",
"localisaient" => "lokalizE",
"localisais" => "lokalizE",
"localisait" => "lokalizE",
"localisant" => "lokaliz@",
"localisateur" => "lokalizat9R",
"localisation" => "lokalizasj§",
"localisations" => "lokalizasj§",
"localise" => "lokaliz",
"localisé" => "lokalize",
"localisée" => "lokalize",
"localisées" => "lokalize",
"localisent" => "lokaliz",
"localiser" => "lokalize",
"localisera" => "lokaliz°Ra",
"localiseront" => "lokaliz°R§",
"localisés" => "lokalize",
"localisez" => "lokalize",
"localisions" => "lokalizj§",
"localisons" => "lokaliz§",
"localité" => "lokalite",
"localités" => "lokalite",
"locataire" => "lokatER",
"locataires" => "lokatER",
"locateurs" => "lokat9R",
"locatif" => "lOkatif",
"location" => "lokasj§",
"locations" => "lokasj§",
"locative" => "lOkativ",
"locatives" => "lokativ",
"locature" => "lOkatyR",
"locaux" => "loko",
"locdu" => "lOkdy",
"loch" => "lOk",
"loche" => "lOS",
"loches" => "lOS",
"lock-out" => "lOkawt",
"lock-outés" => "lokawte",
"loco" => "loko",
"locomobile" => "lokomobil",
"locomoteur" => "lOkOmOt9R",
"locomoteurs" => "lokomot9R",
"locomotion" => "lokomosj§",
"locomotive" => "lokomotiv",
"locomotives" => "lokomotiv",
"locomotrice" => "lokomotRis",
"locos" => "loko",
"locus" => "lokys",
"locuste" => "lokyst",
"locustes" => "lokyst",
"locuteur" => "lokyt9R",
"locution" => "lokysj§",
"locutions" => "lokysj§",
"locutrice" => "lOkytRis",
"loden" => "lodEn",
"lodens" => "lodEn",
"lof" => "lOf",
"lofe" => "lOf",
"lofez" => "lofe",
"loft" => "lOft",
"lofts" => "lOf",
"logarithme" => "logaRitm",
"logarithmes" => "logaRitm",
"logarithmique" => "lOgaRitmik",
"loge" => "lOZ",
"logé" => "loZe",
"logea" => "loZa",
"logeable" => "loZabl",
"logeables" => "loZabl",
"logeai" => "loZE",
"logeaient" => "loZE",
"logeais" => "loZE",
"logeait" => "loZE",
"logeant" => "loZ@",
"logeassent" => "loZas",
"logée" => "loZe",
"logées" => "loZe",
"logement" => "lOZ°m@",
"logements" => "lOZ°m@",
"logent" => "lOZ",
"loger" => "loZe",
"logera" => "lOZ°Ra",
"logerai" => "lOZ°RE",
"logeraient" => "lOZ°RE",
"logerait" => "lOZ°RE",
"logeras" => "lOZ°Ra",
"logèrent" => "loZER",
"logerez" => "lOZ°Re",
"logerions" => "lOZ°Rj§",
"logerons" => "lOZ°R§",
"logeront" => "lOZ°R§",
"loges" => "lOZ",
"logés" => "loZe",
"logettes" => "loZEt",
"logeur" => "loZ9R",
"logeurs" => "loZ9R",
"logeuse" => "loZ2z",
"logeuses" => "loZ2z",
"logez" => "loZe",
"loggia" => "lOdZja",
"loggias" => "lOdZja",
"logiciel" => "loZisjEl",
"logiciels" => "loZisjEl",
"logicien" => "loZisj5",
"logicienne" => "loZisjEn",
"logiciens" => "loZisj5",
"logiez" => "loZje",
"login" => "lOgin",
"logions" => "loZj§",
"logique" => "loZik",
"logiquement" => "loZik°m@",
"logiques" => "loZik",
"logis" => "loZi",
"logisticien" => "lOZistisj5",
"logistique" => "loZistik",
"logistiques" => "loZistik",
"logo" => "logo",
"logogriphe" => "logogRif",
"logogriphes" => "logogRif",
"logomachie" => "logomaSi",
"logorrhée" => "logoRe",
"logos" => "logOs",
"logosphère" => "logosfER",
"logothètes" => "logotEt",
"logue" => "lOg",
"loi" => "lwa",
"loin" => "lw5",
"lointain" => "lw5t5",
"lointaine" => "lw5tEn",
"lointainement" => "lw5tEn°m@",
"lointaines" => "lw5tEn",
"lointains" => "lw5t5",
"loir" => "lwaR",
"loirs" => "lwaR",
"lois" => "lwa",
"loisible" => "lwazibl",
"loisir" => "lwaziR",
"loisirs" => "lwaziR",
"lokoum" => "lokum",
"lolita" => "lolita",
"lolitas" => "lolita",
"lolo" => "lolo",
"lolos" => "lolo",
"lombaire" => "l§bER",
"lombaires" => "l§bER",
"lombalgie" => "l§balZi",
"lombard" => "l§baR",
"lombarde" => "l§baRd",
"lombardes" => "l§baRd",
"lombardo" => "l§baRdo",
"lombards" => "l§baR",
"lombes" => "l§b",
"lombostats" => "l§bosta",
"lombric" => "l§bRik",
"lombrics" => "l§bRik",
"lompe" => "l§p",
"londonien" => "l§donj5",
"londonienne" => "l§donjEn",
"londoniennes" => "l§donjEn",
"londoniens" => "l§donj5",
"londrès" => "l§dREs",
"long" => "l§",
"long-courrier" => "l§kuRje",
"long-courriers" => "l§kuRje",
"long-métrage" => "l§metRaZ",
"longane" => "l§gan",
"longanimité" => "l§ganimite",
"longe" => "l§Z",
"longé" => "l§Ze",
"longea" => "l§Za",
"longeai" => "l§ZE",
"longeaient" => "l§ZE",
"longeais" => "l§ZE",
"longeait" => "l§ZE",
"longeâmes" => "l§Zam",
"longeant" => "l§Z@",
"longée" => "l§Ze",
"longent" => "l§Z",
"longeons" => "l§Z§",
"longer" => "l§Ze",
"longera" => "l§Z°Ra",
"longeraient" => "l§Z°RE",
"longerait" => "l§Z°RE",
"longèrent" => "l§ZER",
"longerions" => "l§Z°Rj§",
"longeron" => "l§Z°R§",
"longerons" => "l§Z°R§",
"longeront" => "l§Z°R§",
"longes" => "l§Z",
"longés" => "l§Ze",
"longévité" => "l§Zevite",
"longez" => "l§Ze",
"longicornes" => "l§ZikORn",
"longiez" => "l§Zje",
"longiforme" => "l§ZifORm",
"longiligne" => "l§ZiliN",
"longilignes" => "l§ZiliN",
"longions" => "l§Zj§",
"longitude" => "l§Zityd",
"longitudinal" => "l§Zitydinal",
"longitudinale" => "l§Zitydinal",
"longitudinalement" => "l§Zitydinal°m@",
"longitudinales" => "l§Zitydinal",
"longitudinaux" => "l§Zitydino",
"longrines" => "l§gRin",
"longs" => "l§",
"longtemps" => "l§t@",
"longue" => "l§g",
"longue-vue" => "l§gvy",
"longuement" => "l§g°m@",
"longues" => "l§g",
"longues-vues" => "l§gvy",
"longuet" => "l§gE",
"longuette" => "l§gEt",
"longuettes" => "l§gEt",
"longueur" => "l§g9R",
"longueurs" => "l§g9R",
"look" => "luk",
"looks" => "luks",
"looping" => "lupiG",
"loopings" => "lupiG",
"looser" => "luz9R",
"loosers" => "luz9R",
"lopaille" => "lOpaj",
"lope" => "lOp",
"lopes" => "lOp",
"lopette" => "lopEt",
"lopettes" => "lopEt",
"lopin" => "lop5",
"lopins" => "lop5",
"loquace" => "lokas",
"loquaces" => "lokas",
"loquacité" => "lokasite",
"loquait" => "lokE",
"loque" => "lOk",
"loqué" => "lOke",
"loquedu" => "lOk°dy",
"loquedus" => "lOk°dy",
"loquer" => "loke",
"loques" => "lOk",
"loqués" => "loke",
"loquet" => "lokE",
"loqueteau" => "lOk°to",
"loqueteuse" => "lOk°t2z",
"loqueteuses" => "lOk°t2z",
"loqueteux" => "lOk°t2",
"loquets" => "lokE",
"loquette" => "lokEt",
"loran" => "loR@",
"lord" => "lORd",
"lord-maire" => "lORdmER",
"lordose" => "lORdoz",
"lords" => "lORdz",
"lorette" => "lOREt",
"lorettes" => "loREt",
"lorgna" => "lORNa",
"lorgnaient" => "lORNE",
"lorgnais" => "lORNE",
"lorgnait" => "lORNE",
"lorgnant" => "lORN@",
"lorgne" => "lORN",
"lorgné" => "lORNe",
"lorgnées" => "lORNe",
"lorgnent" => "lORN",
"lorgner" => "lORNe",
"lorgnerai" => "lORN°RE",
"lorgnèrent" => "lORNER",
"lorgnerez" => "lORN°Re",
"lorgnés" => "lORNe",
"lorgnette" => "lORNEt",
"lorgnettes" => "lORNEt",
"lorgnez" => "lORNe",
"lorgnon" => "lORN§",
"lorgnons" => "lORN§",
"lori" => "lORi",
"loriot" => "loRjo",
"loriots" => "loRjo",
"loris" => "lORis",
"lorrain" => "loR5",
"lorraine" => "loREn",
"lorraines" => "loREn",
"lorrains" => "loR5",
"lors" => "lOR",
"lorsqu" => "lORsk",
"lorsque" => "lORsk°",
"los" => "lo",
"losange" => "loz@Z",
"losangé" => "loz@Ze",
"losangée" => "loz@Ze",
"losanges" => "loz@Z",
"losangés" => "loz@Ze",
"loser" => "loze",
"losers" => "lozER",
"lot" => "lo",
"loterie" => "lOt°Ri",
"loteries" => "lOt°Ri",
"loti" => "loti",
"lotie" => "loti",
"lotier" => "lotje",
"loties" => "loti",
"lotion" => "losj§",
"lotionnés" => "losjone",
"lotions" => "losj§",
"lotir" => "lotiR",
"lotis" => "loti",
"lotissement" => "lotis°m@",
"lotissements" => "lotis°m@",
"loto" => "loto",
"lotos" => "loto",
"lots" => "lo",
"lotta" => "lOta",
"lotte" => "lOt",
"lottes" => "lOt",
"lotus" => "lotys",
"loua" => "lwa",
"louable" => "lwabl",
"louablement" => "lwabl2m@",
"louables" => "lwabl",
"louage" => "lwaZ",
"louai" => "lwE",
"louaient" => "lwE",
"louais" => "lwE",
"louait" => "lwE",
"louâmes" => "lwam",
"louange" => "lw@Z",
"louangé" => "lw@Ze",
"louangea" => "lw@Za",
"louangeaient" => "lw@ZE",
"louangeant" => "lw@Z@",
"louangée" => "lw@Ze",
"louanger" => "lw@Ze",
"louanges" => "lw@Z",
"louangés" => "lw@Ze",
"louangeur" => "lw@Z9R",
"louangeuses" => "lw@Z2z",
"louant" => "lw@",
"loubard" => "lubaR",
"loubarde" => "lubaRd",
"loubards" => "lubaR",
"loucha" => "luSa",
"louchai" => "luSE",
"louchaient" => "luSE",
"louchais" => "luSE",
"louchait" => "luSE",
"louchant" => "luS@",
"louchât" => "luSa",
"louche" => "luS",
"louché" => "luSe",
"louchebem" => "lukEbEm",
"louchébème" => "luSebEm",
"louchée" => "luSe",
"louchement" => "luS°m@",
"louchent" => "luS",
"loucher" => "luSe",
"louches" => "luS",
"louchet" => "luSE",
"loucheur" => "luS9R",
"loucheuse" => "luS2z",
"louchez" => "luSe",
"louchon" => "luS§",
"louchons" => "luS§",
"loue" => "lu",
"loué" => "lwe",
"louée" => "lwe",
"louées" => "lwe",
"louent" => "lu",
"louer" => "lwe",
"louera" => "luRa",
"louerai" => "luRE",
"loueraient" => "luRE",
"louerais" => "luRE",
"louerait" => "luRE",
"loueras" => "luRa",
"louèrent" => "lwER",
"loueriez" => "luRje",
"louerons" => "luR§",
"loues" => "lu",
"loués" => "lwe",
"loueur" => "lw9R",
"loueurs" => "lw9R",
"loueuse" => "lw2z",
"louez" => "lue",
"louf" => "luf",
"loufer" => "lufe",
"loufes" => "luf",
"loufiat" => "lufja",
"loufiats" => "lufja",
"loufoque" => "lufOk",
"loufoquerie" => "lufOk°Ri",
"loufoqueries" => "lufOk°Ri",
"loufoques" => "lufOk",
"louftingue" => "luft5g",
"louions" => "luj§",
"louis" => "lwi",
"louis-philippard" => "lwifilipaRd",
"louis-philipparde" => "lwifilipaRd",
"louis-philippards" => "lwifilipaR",
"louise-bonne" => "lwizbOn",
"louisianais" => "luizijanE",
"loukoum" => "lukum",
"loukoums" => "lukum",
"loulou" => "lulu",
"loulous" => "lulu",
"louloute" => "lulut",
"louloutes" => "lulut",
"louloutte" => "lulut",
"louons" => "lw§",
"loup" => "lu",
"loup-cervier" => "lusERvje",
"loup-garou" => "lugaRu",
"loupa" => "lupa",
"loupai" => "lupE",
"loupaient" => "lupE",
"loupais" => "lupE",
"loupait" => "lupE",
"loupe" => "lup",
"loupé" => "lupe",
"loupée" => "lupe",
"loupées" => "lupe",
"loupent" => "lup",
"louper" => "lupe",
"loupera" => "lup°Ra",
"louperai" => "lup°RE",
"louperais" => "lup°RE",
"louperait" => "lup°RE",
"louperas" => "lup°Ra",
"louperez" => "lup°Re",
"loupes" => "lup",
"loupés" => "lupe",
"loupez" => "lupe",
"loupiat" => "lupja",
"loupiez" => "lupje",
"loupiot" => "lupjo",
"loupiote" => "lupjOt",
"loupiotes" => "lupjOt",
"loupiots" => "lupjo",
"loupiotte" => "lupjOt",
"loupiottes" => "lupjOt",
"loups" => "lu",
"loups-cerviers" => "lusERvje",
"loups-garous" => "lugaRu",
"lourant" => "luR@",
"lourd" => "luR",
"lourdait" => "luRdE",
"lourdant" => "luRd@",
"lourdaud" => "luRdo",
"lourdaude" => "luRdod",
"lourdaudes" => "luRdod",
"lourdauds" => "luRdo",
"lourde" => "luRd",
"lourdé" => "luRde",
"lourdée" => "luRde",
"lourdées" => "luRde",
"lourdement" => "luRd°m@",
"lourder" => "luRde",
"lourderie" => "luRd°Ri",
"lourdes" => "luRd",
"lourdés" => "luRde",
"lourdeur" => "luRd9R",
"lourdeurs" => "luRd9R",
"lourdingue" => "luRd5g",
"lourdingues" => "luRd5g",
"lourds" => "luR",
"loustic" => "lustik",
"loustics" => "lustik",
"loute" => "lut",
"loutre" => "lutR",
"loutres" => "lutR",
"louve" => "luv",
"louves" => "luv",
"louvet" => "luvE",
"louveteau" => "luv°to",
"louveteaux" => "luv°to",
"louvetiers" => "luv°tje",
"louvoie" => "luvwa",
"louvoiements" => "luvwam@",
"louvoient" => "luvwa",
"louvoyaient" => "luvwajE",
"louvoyait" => "luvwajE",
"louvoyant" => "luvwaj@",
"louvoyants" => "luvwaj@",
"louvoyât" => "luvwaja",
"louvoyé" => "luvwaje",
"louvoyer" => "luvwaje",
"louvoyons" => "luvwaj§",
"lova" => "lova",
"lovaient" => "lovE",
"lovais" => "lovE",
"lovait" => "lovE",
"lovant" => "lov@",
"love" => "lOv",
"lové" => "love",
"lovée" => "love",
"lovées" => "love",
"lovent" => "lOv",
"lover" => "love",
"lovés" => "love",
"loyal" => "lwajal",
"loyale" => "lwajal",
"loyalement" => "lwajal°m@",
"loyales" => "lwajal",
"loyalisme" => "lwajalizm",
"loyaliste" => "lwajalist",
"loyalistes" => "lwajalist",
"loyauté" => "lwajote",
"loyautés" => "lwajote",
"loyaux" => "lwajo",
"loyer" => "lwaje",
"loyers" => "lwaje",
"lsd" => "ElEsde",
"lu" => "ly",
"lubie" => "lybi",
"lubies" => "lybi",
"lubricité" => "lybRisite",
"lubrifiant" => "lybRifj@",
"lubrifiante" => "lybRifj@t",
"lubrifiants" => "lybRifj@",
"lubrification" => "lybRifikasj§",
"lubrifie" => "lybRifi",
"lubrifié" => "lybRifje",
"lubrifiée" => "lybRifje",
"lubrifiées" => "lybRifje",
"lubrifient" => "lybRifi",
"lubrifier" => "lybRifje",
"lubrifiés" => "lybRifje",
"lubrique" => "lybRik",
"lubriques" => "lybRik",
"lucarne" => "lykaRn",
"lucarnes" => "lykaRn",
"luce" => "lys",
"lucet" => "lysE",
"lucide" => "lysid",
"lucidement" => "lysid°m@",
"lucides" => "lysid",
"lucidité" => "lysidite",
"lucidités" => "lysidite",
"luciférien" => "lysifeRj5",
"luciférienne" => "lysifeRjEn",
"lucifériens" => "lysifeRj5",
"lucilie" => "lysili",
"luciole" => "lysjOl",
"lucioles" => "lysjOl",
"lucite" => "lysit",
"lucratif" => "lykRatif",
"lucratifs" => "lykRatif",
"lucrative" => "lykRativ",
"lucratives" => "lykRativ",
"lucre" => "lykR",
"luddite" => "lydit",
"ludion" => "lydj§",
"ludions" => "lydj§",
"ludique" => "lydik",
"ludiques" => "lydik",
"lue" => "ly",
"lues" => "ly",
"luette" => "l8Et",
"luettes" => "l8Et",
"lueur" => "l89R",
"lueurs" => "l89R",
"luffa" => "l9fa",
"luge" => "lyZ",
"luger" => "lyZe",
"lugers" => "lyZe",
"luges" => "lyZ",
"lugubre" => "lygybR",
"lugubrement" => "lygybR°m@",
"lugubres" => "lygybR",
"lui" => "l8i",
"lui-même" => "l8imEm",
"luira" => "l8iRa",
"luiraient" => "l8iRE",
"luirait" => "l8iRE",
"luire" => "l8iR",
"luirent" => "l8iR",
"luis" => "l8i",
"luisaient" => "l8izE",
"luisait" => "l8izE",
"luisance" => "l8iz@s",
"luisances" => "l8iz@s",
"luisant" => "l8iz@",
"luisante" => "l8iz@t",
"luisantes" => "l8iz@t",
"luisants" => "l8iz@",
"luise" => "l8iz",
"luisent" => "l8iz",
"luit" => "l8i",
"lulu" => "lyly",
"lulus" => "lyly",
"lumbago" => "l§bago",
"lumbagos" => "l§bago",
"lumen" => "lymEn",
"lûmes" => "lym",
"lumière" => "lymjER",
"lumières" => "lymjER",
"lumignon" => "lymiN§",
"lumignons" => "lymiN§",
"luminaire" => "lyminER",
"luminaires" => "lyminER",
"luminescence" => "lyminEs@s",
"luminescent" => "lyminEs@",
"luminescente" => "lyminEs@t",
"luminescentes" => "lyminEs@t",
"luminescents" => "lyminEs@",
"lumineuse" => "lymin2z",
"lumineusement" => "lymin2z°m@",
"lumineuses" => "lymin2z",
"lumineux" => "lymin2",
"luminosité" => "lyminozite",
"luminosités" => "lyminozite",
"lump" => "l1p",
"lunaire" => "lynER",
"lunaires" => "lynER",
"lunaison" => "lynEz§",
"lunaisons" => "lynEz§",
"lunatique" => "lynatik",
"lunatiques" => "lynatik",
"lunch" => "l9ntS",
"luncher" => "l1Se",
"lunches" => "l9ntS",
"lundi" => "l1di",
"lundis" => "l1di",
"lune" => "lyn",
"luné" => "lyne",
"lunée" => "lyne",
"lunes" => "lyn",
"lunés" => "lyne",
"lunetier" => "lyn°tje",
"lunette" => "lynEt",
"lunetté" => "lynEte",
"lunetteries" => "lynEt°Ri",
"lunettes" => "lynEt",
"lunetteux" => "lynEt2",
"lunule" => "lynyl",
"lunules" => "lynyl",
"lupanar" => "lypanaR",
"lupanars" => "lypanaR",
"lupin" => "lyp5",
"lupins" => "lyp5",
"lupus" => "lypys",
"lur" => "luR",
"lurent" => "lyR",
"lurex" => "lyREks",
"luron" => "lyR§",
"luronne" => "lyROn",
"luronnes" => "lyROn",
"lurons" => "lyR§",
"lus" => "ly",
"lusitanienne" => "lyzitanjEn",
"lustra" => "lystRa",
"lustrage" => "lystRaZ",
"lustraient" => "lystRE",
"lustrait" => "lystRE",
"lustral" => "lystRal",
"lustrale" => "lystRal",
"lustrales" => "lystRal",
"lustrant" => "lystR@",
"lustre" => "lystR",
"lustré" => "lystRe",
"lustrée" => "lystRe",
"lustrées" => "lystRe",
"lustrer" => "lystRe",
"lustres" => "lystR",
"lustrés" => "lystRe",
"lustreur" => "lystR9R",
"lustreuse" => "lystR2z",
"lustrine" => "lystRin",
"lustucru" => "lystykRy",
"lut" => "ly",
"lût" => "ly",
"luté" => "lyte",
"lutécien" => "lytesj5",
"luth" => "lyt",
"luthéranisme" => "lyteRanizm",
"luthérianisme" => "lyteRjanizm",
"lutherie" => "lytRi",
"luthérien" => "lyteRj5",
"luthérienne" => "lyteRjEn",
"luthériennes" => "lyteRjEn",
"luthériens" => "lyteRj5",
"luthier" => "lytje",
"luths" => "lyt",
"lutin" => "lyt5",
"lutinaient" => "lytinE",
"lutinait" => "lytinE",
"lutinant" => "lytin@",
"lutine" => "lytin",
"lutiné" => "lytine",
"lutinée" => "lytine",
"lutinent" => "lytin",
"lutiner" => "lytine",
"lutinerais" => "lytin°RE",
"lutinèrent" => "lytinER",
"lutins" => "lyt5",
"lutrin" => "lytR5",
"lutrins" => "lytR5",
"lutta" => "lyta",
"luttai" => "lytE",
"luttaient" => "lytE",
"luttais" => "lytE",
"luttait" => "lytE",
"luttant" => "lyt@",
"luttât" => "lyta",
"lutte" => "lyt",
"lutté" => "lyte",
"luttent" => "lyt",
"lutter" => "lyte",
"luttera" => "lyt°Ra",
"lutterai" => "lyt°RE",
"lutterais" => "lyt°RE",
"lutterait" => "lyt°RE",
"luttèrent" => "lytER",
"lutterions" => "lyt°Rj§",
"lutterons" => "lyt°R§",
"lutteront" => "lyt°R§",
"luttes" => "lyt",
"lutteur" => "lyt9R",
"lutteurs" => "lyt9R",
"lutteuse" => "lyt2z",
"lutteuses" => "lyt2z",
"luttez" => "lyte",
"luttiez" => "lytje",
"luttions" => "lytj§",
"luttons" => "lyt§",
"lutz" => "lyts",
"lux" => "lyks",
"luxa" => "lyksa",
"luxation" => "lyksasj§",
"luxations" => "lyksasj§",
"luxe" => "lyks",
"luxé" => "lykse",
"luxembourgeois" => "lyks@buRZwa",
"luxembourgeoise" => "lyks@buRZwaz",
"luxer" => "lykse",
"luxes" => "lyks",
"luxueuse" => "lyks82z",
"luxueusement" => "lyks82z°m@",
"luxueuses" => "lyks82z",
"luxueux" => "lyks82",
"luxure" => "lyksyR",
"luxuriance" => "lyksyRj@s",
"luxuriant" => "lyksyRj@",
"luxuriante" => "lyksyRj@t",
"luxuriantes" => "lyksyRj@t",
"luxuriants" => "lyksyRj@",
"luxurieuse" => "lyksyRj2z",
"luxurieux" => "lyksyRj2",
"luzerne" => "lyzERn",
"luzernes" => "lyzERn",
"luzernières" => "lyzERnjER",
"lycanthrope" => "lik@tROp",
"lycanthropes" => "lik@tROp",
"lycanthropie" => "lik@tRopi",
"lycaons" => "lika§",
"lycée" => "lise",
"lycéen" => "lise5",
"lycéenne" => "liseEn",
"lycéennes" => "liseEn",
"lycéens" => "lise5",
"lycées" => "lise",
"lychee" => "litSi",
"lychees" => "litSi",
"lychnis" => "liknis",
"lycien" => "lisj5",
"lyciennes" => "lisjEn",
"lycoperdon" => "likopERd§",
"lycoperdons" => "likopERd§",
"lycra" => "likRa",
"lymphangite" => "l5f@Zit",
"lymphatique" => "l5fatik",
"lymphatiques" => "l5fatik",
"lymphatisme" => "l5fatizm",
"lymphe" => "l5f",
"lymphes" => "l5f",
"lymphocytaire" => "l5fositER",
"lymphocytaires" => "l5fositER",
"lymphocyte" => "l5fosit",
"lymphocytes" => "l5fosit",
"lymphocytose" => "l5fOsitoz",
"lymphoïde" => "l5fOid",
"lymphome" => "l5fom",
"lymphomes" => "l5fom",
"lymphopénie" => "l5fopeni",
"lymphosarcome" => "l5fosaRkom",
"lynch" => "l5S",
"lynchage" => "l5SaZ",
"lynchages" => "l5SaZ",
"lynchait" => "l5SE",
"lynché" => "l5Se",
"lynchée" => "l5Se",
"lynchent" => "l5S",
"lyncher" => "l5Se",
"lynchés" => "l5Se",
"lyncheurs" => "l5S9R",
"lynchez" => "l5Se",
"lynchiez" => "l5Sje",
"lynchons" => "l5S§",
"lynx" => "l5ks",
"lyonnais" => "ljonE",
"lyonnaise" => "ljonEz",
"lyophilisant" => "ljofiliz@",
"lyophilisé" => "ljOfilize",
"lyophilisée" => "ljofilize",
"lyophiliser" => "ljofilize",
"lyophilisés" => "ljofilize",
"lyre" => "liR",
"lyres" => "liR",
"lyrique" => "liRik",
"lyriques" => "liRik",
"lyriser" => "liRize",
"lyrisme" => "liRizm",
"lys" => "lis",
"lyse" => "liz",
"lysergique" => "lizERZik",
"lysimaque" => "lizimak",
"lysine" => "lizin",
"lysosomes" => "lizozom",
"m" => "Em",
"m'as-tu-vu" => "matyvy",
"ma" => "ma",
"ma-jong" => "maZ§G",
"maboul" => "mabul",
"maboule" => "mabul",
"maboules" => "mabul",
"mabouls" => "mabul",
"mac" => "mak",
"macabre" => "makabR",
"macabres" => "makabR",
"macache" => "makaS",
"macadam" => "makadam",
"macadamia" => "makadamja",
"macaque" => "makak",
"macaques" => "makak",
"macarel" => "makaREl",
"macarelle" => "makaREl",
"macareux" => "makaR2",
"macaron" => "makaR§",
"macaroni" => "makaRoni",
"macaronique" => "makaRonik",
"macaronis" => "makaRoni",
"macarons" => "makaR§",
"macassar" => "makasaR",
"maccarthysme" => "makaRtizm",
"macchab" => "makab",
"macchabée" => "makabe",
"macchabées" => "makabe",
"macchabs" => "makab",
"macédoine" => "masedwan",
"macédoines" => "masedwan",
"macédonien" => "masedonj5",
"macédonienne" => "masedonjEn",
"macédoniennes" => "masedonjEn",
"macérai" => "maseRE",
"macéraient" => "maseRE",
"macérait" => "maseRE",
"macération" => "maseRasj§",
"macérations" => "maseRasj§",
"macère" => "masER",
"macéré" => "maseRe",
"macérée" => "maseRe",
"macèrent" => "masER",
"macérer" => "maseRe",
"macérés" => "maseRe",
"macfarlane" => "makfaRlan",
"mach" => "mak",
"mâcha" => "maSa",
"mâchage" => "maSaZ",
"mâchaient" => "maSE",
"mâchais" => "maSE",
"mâchait" => "maSE",
"mâchant" => "maS@",
"machaon" => "maka§",
"mâche" => "maS",
"mâché" => "maSe",
"mâchée" => "maSe",
"mâchefer" => "maSfER",
"mâchent" => "maS",
"mâcher" => "maSe",
"mâcherai" => "maS°RE",
"mâcherais" => "maS°RE",
"mâcherait" => "maS°RE",
"mâchèrent" => "maSER",
"mâcherez" => "maS°Re",
"mâches" => "maS",
"mâchés" => "maSe",
"machette" => "maSEt",
"machettes" => "maSEt",
"mâcheur" => "maS9R",
"mâcheurs" => "maS9R",
"mâcheuse" => "maS2z",
"mâchez" => "maSe",
"machiavélique" => "makjavelik",
"machiavéliques" => "makjavelik",
"machiavélisme" => "makjavelizm",
"machiavélismes" => "makjavelizm",
"mâchicoulis" => "maSikuli",
"machin" => "maS5",
"machina" => "maSina",
"machinaient" => "maSinE",
"machinal" => "maSinal",
"machinale" => "maSinal",
"machinalement" => "maSinal°m@",
"machinales" => "maSinal",
"machination" => "maSinasj§",
"machinations" => "maSinasj§",
"machinaux" => "maSino",
"machinchouette" => "maSiSuEt",
"machine" => "maSin",
"machiné" => "maSine",
"machine-outil" => "maSinuti",
"machinée" => "maSine",
"machinées" => "maSine",
"machiner" => "maSine",
"machinerie" => "maSin°Ri",
"machineries" => "maSin°Ri",
"machines" => "maSin",
"machinés" => "maSine",
"machines-outils" => "maSinuti",
"machinette" => "maSinEt",
"machinique" => "maSinik",
"machinisme" => "maSinizm",
"machiniste" => "maSinist",
"machinistes" => "maSinist",
"machino" => "makino",
"machinos" => "makino",
"machins" => "maS5",
"machisme" => "matSizm",
"machiste" => "matSist",
"machistes" => "matSist",
"machmètre" => "makmEtR",
"macho" => "matSo",
"mâchoire" => "maSwaR",
"mâchoires" => "maSwaR",
"mâchonna" => "maSona",
"mâchonnaient" => "maSonE",
"mâchonnais" => "maSonE",
"mâchonnait" => "maSonE",
"mâchonnant" => "maSon@",
"mâchonne" => "maSOn",
"mâchonné" => "maSone",
"mâchonnements" => "maSOn°m@",
"mâchonnent" => "maSOn",
"mâchonner" => "maSone",
"mâchonnés" => "maSone",
"mâchons" => "maS§",
"machos" => "matSo",
"mâchouilla" => "maSuja",
"mâchouillait" => "maSujE",
"mâchouillant" => "maSuj@",
"mâchouille" => "maSuj",
"mâchouillé" => "maSuje",
"mâchouillée" => "maSuje",
"mâchouiller" => "maSuje",
"mâchouilles" => "maSuj",
"mâchouilleur" => "maSuj9R",
"mâchuré" => "maSyRe",
"mâchurée" => "maSyRe",
"macintosh" => "makintoS",
"macis" => "masi",
"mackintosh" => "makintOS",
"maçon" => "mas§",
"mâconnaise" => "makonEz",
"mâconnaises" => "makonEz",
"maçonnant" => "mason@",
"maçonne" => "masOn",
"maçonné" => "masone",
"maçonnée" => "masone",
"maçonnées" => "masone",
"maçonnent" => "masOn",
"maçonner" => "masone",
"maçonnerie" => "masOn°Ri",
"maçonneries" => "masOn°Ri",
"maçonnés" => "masone",
"maçonnique" => "masonik",
"maçonniques" => "masonik",
"maçons" => "mas§",
"macoute" => "makut",
"macoutes" => "makut",
"macramé" => "makRame",
"macres" => "makR",
"macreuse" => "makR2z",
"macreuses" => "makR2z",
"macro" => "makRo",
"macrobiotique" => "makRobjotik",
"macroclimat" => "makRoklima",
"macrocosme" => "makRokOsm",
"macroéconomie" => "makRoekOnOmi",
"macrolide" => "makRolid",
"macrophage" => "makROfaZ",
"macroscopique" => "makRoskopik",
"macs" => "mak",
"macula" => "makyla",
"maculage" => "makylaZ",
"maculaient" => "makylE",
"maculait" => "makylE",
"maculant" => "makyl@",
"maculation" => "makylasj§",
"maculature" => "makylatyR",
"macule" => "makyl",
"maculé" => "makyle",
"maculée" => "makyle",
"maculées" => "makyle",
"maculent" => "makyl",
"maculer" => "makyle",
"maculèrent" => "makylER",
"macules" => "makyl",
"maculés" => "makyle",
"macumba" => "makymba",
"madame" => "madam",
"madapolam" => "madapolam",
"made in" => "mejdin",
"madeleine" => "mad°lEn",
"madeleines" => "mad°lEn",
"mademoiselle" => "mad°mwazEl",
"mademoiselles" => "mad°mwazEl",
"madère" => "madER",
"madone" => "madOn",
"madones" => "madOn",
"madrague" => "madRag",
"madras" => "madRas",
"madre" => "madR",
"madré" => "madRe",
"madre de dios" => "madRededeioEs",
"madrée" => "madRe",
"madrépore" => "madRepOR",
"madrépores" => "madRepOR",
"madrés" => "madRe",
"madrier" => "madRije",
"madriers" => "madRije",
"madrigal" => "madRigal",
"madrigaux" => "madRigo",
"madrilène" => "madRilEn",
"madrilènes" => "madRilEn",
"maelstrom" => "malstROm",
"maelström" => "mElstR2m",
"maestria" => "maEstRija",
"maestro" => "maEstRo",
"maffia" => "mafja",
"maffieux" => "mafj2",
"maffiosi" => "mafjozi",
"mafflu" => "mafly",
"mafflue" => "mafly",
"mafflus" => "mafly",
"mafia" => "mafja",
"mafias" => "mafja",
"mafieuse" => "mafj2z",
"mafieuses" => "mafj2z",
"mafieux" => "mafj2",
"mafiosi" => "mafjozi",
"mafioso" => "mafjozo",
"maganer" => "magane",
"magasin" => "magaz5",
"magasinage" => "magazinaZ",
"magasine" => "magazin",
"magasiner" => "magazine",
"magasines" => "magazin",
"magasinier" => "magazinje",
"magasinière" => "magazinjER",
"magasiniers" => "magazinje",
"magasins" => "magaz5",
"magazine" => "magazin",
"magazines" => "magazin",
"magdalénien" => "magdalenj5",
"magdaléniennes" => "magdalenjEn",
"mage" => "maZ",
"magenta" => "maZ@ta",
"mages" => "maZ",
"maghrébin" => "magReb5",
"maghrébine" => "magRebin",
"maghrébines" => "magRebin",
"maghrébins" => "magReb5",
"maghzen" => "makzEn",
"magicien" => "maZisj5",
"magicienne" => "maZisjEn",
"magiciens" => "maZisj5",
"magico" => "maZiko",
"magie" => "maZi",
"magies" => "maZi",
"magique" => "maZik",
"magiquement" => "maZik°m@",
"magiques" => "maZik",
"magister" => "maZistER",
"magistère" => "maZistER",
"magisters" => "maZistER",
"magistral" => "maZistRal",
"magistrale" => "maZistRal",
"magistralement" => "maZistRal°m@",
"magistrales" => "maZistRal",
"magistrat" => "maZistRa",
"magistrate" => "maZistRat",
"magistrats" => "maZistRa",
"magistrature" => "maZistRatyR",
"magistratures" => "maZistRatyR",
"magistraux" => "maZistRo",
"magma" => "magma",
"magmas" => "magma",
"magmatique" => "magmatik",
"magmatiques" => "magmatik",
"magna" => "maNa",
"magnait" => "maNE",
"magnaneries" => "maNan°Ri",
"magnanime" => "maNanim",
"magnanimes" => "maNanim",
"magnanimité" => "maNanimite",
"magnans" => "maN@",
"magnat" => "magna",
"magnats" => "magna",
"magne" => "maN",
"magné" => "maNe",
"magnent" => "maN",
"magner" => "maNe",
"magnes" => "maN",
"magnésie" => "maNezi",
"magnésium" => "maNezjOm",
"magnétique" => "maNetik",
"magnétiquement" => "maNetik°m@",
"magnétiques" => "maNetik",
"magnétisait" => "maNetizE",
"magnétise" => "maNetiz",
"magnétisé" => "maNetize",
"magnétisée" => "maNetize",
"magnétisées" => "maNetize",
"magnétisés" => "maNetize",
"magnétiseur" => "maNetiz9R",
"magnétiseuses" => "maNetiz2z",
"magnétisme" => "maNetizm",
"magnétismes" => "maNetizm",
"magnétite" => "maNetit",
"magnéto" => "maNeto",
"magnétomètre" => "maNetomEtR",
"magnétophone" => "maNetofOn",
"magnétophones" => "maNetofOn",
"magnétos" => "maNeto",
"magnétoscope" => "maNetoskOp",
"magnétoscopes" => "maNetoskOp",
"magnétron" => "maNetR§",
"magnez" => "maNe",
"magnifiaient" => "maNifjE",
"magnifiais" => "maNifjE",
"magnifiait" => "maNifjE",
"magnifiant" => "maNifj@",
"magnificat" => "maNifika",
"magnificence" => "maNifis@s",
"magnificences" => "maNifis@s",
"magnifie" => "maNifi",
"magnifié" => "maNifje",
"magnifiée" => "maNifje",
"magnifiées" => "maNifje",
"magnifient" => "maNifi",
"magnifier" => "maNifje",
"magnifiés" => "maNifje",
"magnifiez" => "maNifje",
"magnifique" => "maNifik",
"magnifiquement" => "maNifik°m@",
"magnifiques" => "maNifik",
"magnitude" => "maNityd",
"magnolia" => "maNolja",
"magnolias" => "maNolja",
"magnons" => "maN§",
"magnum" => "magnOm",
"magnums" => "magnOm",
"magot" => "mago",
"magots" => "mago",
"magouillais" => "magujE",
"magouillait" => "magujE",
"magouillant" => "maguj@",
"magouille" => "maguj",
"magouillé" => "maguje",
"magouiller" => "maguje",
"magouilles" => "maguj",
"magouilleur" => "maguj9R",
"magouilleurs" => "maguj9R",
"magouillez" => "maguje",
"magret" => "magRE",
"magyar" => "magjaR",
"magyare" => "magjaR",
"magyares" => "magjaR",
"magyars" => "magjaR",
"mah-jong" => "maZ§G",
"maharadja" => "maaRadZa",
"maharadjah" => "maaRadZa",
"maharadjahs" => "maaRadZa",
"maharadjas" => "maaRadZa",
"maharaja" => "maaRadZa",
"maharajah" => "maaRadZa",
"maharajahs" => "maaRadZa",
"maharajas" => "maaRaZa",
"maharani" => "maaRani",
"mahatma" => "maatma",
"mahatmas" => "maatma",
"mahométan" => "maomet@",
"mahométane" => "maometan",
"mahométans" => "maomet@",
"mahonia" => "maonja",
"mahonias" => "maonja",
"mahousse" => "maus",
"mahousses" => "maus",
"mai" => "mE",
"maïa" => "maja",
"maid" => "mEd",
"maie" => "mE",
"maies" => "mE",
"maigre" => "mEgR",
"maigrelet" => "mEgR°lE",
"maigrelets" => "mEgR°lE",
"maigrelette" => "mEgR°lEt",
"maigrelettes" => "mEgR°lEt",
"maigrement" => "mEgR°m@",
"maigres" => "mEgR",
"maigreur" => "mEgR9R",
"maigri" => "mEgRi",
"maigrichon" => "megRiS§",
"maigrichonne" => "megRiSOn",
"maigrichonnes" => "mEgRiSOn",
"maigrichons" => "mEgRiS§",
"maigrie" => "mEgRi",
"maigriot" => "megRijo",
"maigrir" => "megRiR",
"maigris" => "mEgRi",
"maigrissais" => "mEgRisE",
"maigrissait" => "mEgRisE",
"maigrissant" => "mEgRis@",
"maigrisse" => "mEgRis",
"maigrissent" => "mEgRis",
"maigrisses" => "mEgRis",
"maigrissez" => "mEgRise",
"maigrit" => "mEgRi",
"mail" => "mEjl",
"mail-coach" => "mEjlkOwtS",
"mailé" => "mEjle",
"mailer" => "mEjle",
"mailing" => "mEjliG",
"maillait" => "majE",
"maille" => "maj",
"maillé" => "maje",
"maillechort" => "majSOR",
"mailler" => "maje",
"mailles" => "maj",
"maillés" => "maje",
"maillet" => "majE",
"maillets" => "majE",
"mailloche" => "majOS",
"maillon" => "maj§",
"maillons" => "maj§",
"maillot" => "majo",
"maillotin" => "majot5",
"maillotins" => "majot5",
"maillots" => "majo",
"mails" => "mEjl",
"main" => "m5",
"main-courante" => "m5kuR@t",
"main-d'oeuvre" => "m5d9vR",
"main-forte" => "m5fORt",
"mainate" => "mEnat",
"maincourantier" => "m5kuR@tje",
"mainlevée" => "m5l°ve",
"mainmise" => "m5miz",
"mains" => "m5",
"maint" => "m5",
"mainte" => "m5t",
"maintenaient" => "m5t°nE",
"maintenais" => "m5t°nE",
"maintenait" => "m5t°nE",
"maintenance" => "m5t°n@s",
"maintenant" => "m5t°n@",
"mainteneur" => "m5t°n9R",
"mainteneurs" => "m5t°n9R",
"maintenez" => "m5t°ne",
"mainteniez" => "m5t°nje",
"maintenions" => "m5t°nj§",
"maintenir" => "m5t°niR",
"maintenons" => "m5t°n§",
"maintenu" => "m5t°ny",
"maintenue" => "m5t°ny",
"maintenues" => "m5t°ny",
"maintenus" => "m5t°ny",
"maintes" => "m5t",
"maintien" => "m5tj5",
"maintiendra" => "m5tj5dRa",
"maintiendrai" => "m5tj5dRE",
"maintiendraient" => "m5tj5dRE",
"maintiendrait" => "m5tj5dRE",
"maintiendras" => "m5tj5dRa",
"maintiendriez" => "m5tj5dRje",
"maintiendrons" => "m5tj5dR§",
"maintiendront" => "m5tj5dR§",
"maintienne" => "m5tjEn",
"maintiennent" => "m5tjEn",
"maintiennes" => "m5tjEn",
"maintiens" => "m5tj5",
"maintient" => "m5tj5",
"maintinrent" => "m5t5R",
"maintins" => "m5t5",
"maintint" => "m5t5",
"maintînt" => "m5t5",
"maints" => "m5",
"maire" => "mER",
"maires" => "mER",
"mairesse" => "mEREs",
"mairie" => "meRi",
"mairies" => "meRi",
"mais" => "mE",
"maïs" => "mais",
"maison" => "mEz§",
"maison-mère" => "mEz§mER",
"maisonnée" => "mEzone",
"maisonnées" => "mEzone",
"maisonnette" => "mEzonEt",
"maisonnettes" => "mEzonEt",
"maisons" => "mEz§",
"maître" => "mEtR",
"maître queux" => "mEtR°k2",
"maître-à-danser" => "mEtRad@se",
"maître-assistant" => "mEtRasist@",
"maître-autel" => "mEtRotEl",
"maître-chanteur" => "mEtR°S@t9R",
"maître-chien" => "mEtR°Sj5",
"maître-coq" => "mEtR2kOk",
"maître-nageur" => "mEtR°naZ9R",
"maîtres" => "mEtR",
"maîtresse" => "mEtREs",
"maîtresses" => "mEtREs",
"maîtrisa" => "mEtRiza",
"maîtrisable" => "metRizabl",
"maîtrisables" => "mEtRizabl",
"maîtrisaient" => "mEtRizE",
"maîtrisais" => "mEtRizE",
"maîtrisait" => "mEtRizE",
"maîtrisant" => "mEtRiz@",
"maîtrise" => "metRiz",
"maîtrisé" => "metRize",
"maîtrisée" => "metRize",
"maîtrisées" => "metRize",
"maîtrisent" => "metRiz",
"maîtriser" => "metRize",
"maîtrisera" => "mEtRiz°Ra",
"maîtriserai" => "mEtRiz°RE",
"maîtriseraient" => "mEtRiz°RE",
"maîtriserait" => "mEtRiz°RE",
"maîtriseras" => "mEtRiz°Ra",
"maîtrisèrent" => "mEtRizER",
"maîtriserez" => "mEtRiz°Re",
"maîtriseriez" => "mEtRiz°Rje",
"maîtriserons" => "mEtRiz°R§",
"maîtriseront" => "mEtRiz°R§",
"maîtrises" => "metRiz",
"maîtrisés" => "metRize",
"maîtrisez" => "mEtRize",
"maîtrisiez" => "mEtRizje",
"maîtrisions" => "mEtRizj§",
"maîtrisons" => "mEtRiz§",
"maïzena" => "maizena",
"maja" => "maZa",
"majesté" => "maZEste",
"majestés" => "maZEste",
"majestueuse" => "maZEst82z",
"majestueusement" => "maZEst82z°m@",
"majestueuses" => "maZEst82z",
"majestueux" => "maZEst82",
"majeur" => "maZ9R",
"majeure" => "maZ9R",
"majeures" => "maZ9R",
"majeurs" => "maZ9R",
"majo" => "maZo",
"majolique" => "maZolik",
"major" => "maZOR",
"major-général" => "maZORZeneRal",
"majora" => "maZoRa",
"majoral" => "maZoRal",
"majorat" => "maZoRa",
"majoration" => "maZoRasj§",
"majordome" => "maZoRdOm",
"majordomes" => "maZoRdOm",
"majore" => "maZOR",
"majorée" => "maZoRe",
"majorer" => "maZoRe",
"majorette" => "maZoREt",
"majorettes" => "maZoREt",
"majoritaire" => "maZoRitER",
"majoritairement" => "maZoRitER°m@",
"majoritaires" => "maZoRitER",
"majorité" => "maZoRite",
"majorités" => "maZoRite",
"majors" => "maZOR",
"majuscule" => "maZyskyl",
"majuscules" => "maZyskyl",
"maki" => "maki",
"mal" => "mal",
"mal-aimé" => "maleme",
"mal-aimée" => "maleme",
"mal-aimés" => "maleme",
"mal-baisé" => "malbeze",
"mal-baisée" => "malbeze",
"mal-être" => "malEtR",
"mal-pensante" => "malp@s@t",
"mal-pensants" => "malp@s@",
"malabar" => "malabaR",
"malabars" => "malabaR",
"malachite" => "malakit",
"malade" => "malad",
"malades" => "malad",
"maladie" => "maladi",
"maladies" => "maladi",
"maladif" => "maladif",
"maladifs" => "maladif",
"maladive" => "maladiv",
"maladivement" => "maladiv°m@",
"maladives" => "maladiv",
"maladrerie" => "maladR2Ri",
"maladresse" => "maladREs",
"maladresses" => "maladREs",
"maladroit" => "maladRwa",
"maladroite" => "maladRwat",
"maladroitement" => "maladRwat°m@",
"maladroites" => "maladRwat",
"maladroits" => "maladRwa",
"malaga" => "malaga",
"malaire" => "malER",
"malais" => "malE",
"malaise" => "malEz",
"malaisé" => "maleze",
"malaisée" => "maleze",
"malaisées" => "malEze",
"malaisément" => "malezem@",
"malaises" => "malEz",
"malaisés" => "maleze",
"malaisien" => "malEzj5",
"malaisienne" => "malEzjEn",
"malaisiens" => "malEzj5",
"malandrin" => "mal@dR5",
"malandrins" => "mal@dR5",
"malappris" => "malapRi",
"malapprise" => "malapRiz",
"malard" => "malaR",
"malards" => "malaR",
"malaria" => "malaRja",
"malarias" => "malaRja",
"malaventures" => "malav@tyR",
"malavisé" => "malavize",
"malavisée" => "malavize",
"malaxa" => "malaksa",
"malaxaient" => "malaksE",
"malaxait" => "malaksE",
"malaxant" => "malaks@",
"malaxe" => "malaks",
"malaxé" => "malakse",
"malaxée" => "malakse",
"malaxées" => "malakse",
"malaxer" => "malakse",
"malaxera" => "malaks°Ra",
"malaxés" => "malakse",
"malaxeur" => "malaks9R",
"malaxez" => "malakse",
"malchance" => "malS@s",
"malchances" => "malS@s",
"malchanceuse" => "malS@s2z",
"malchanceuses" => "malS@s2z",
"malchanceux" => "malS@s2",
"malcommode" => "malkomOd",
"malcommodes" => "malkomOd",
"malcontent" => "malk§t@",
"malcontents" => "malk§t@",
"maldonne" => "maldOn",
"maldonnes" => "maldOn",
"male" => "mal",
"mâle" => "mal",
"malédiction" => "malediksj§",
"malédictions" => "malediksj§",
"maléfice" => "malefis",
"maléfices" => "malefis",
"maléficié" => "malefisje",
"maléficier" => "malefisje",
"maléfique" => "malefik",
"maléfiques" => "malefik",
"malencontre" => "mal@k§tR",
"malencontres" => "mal@k§tR",
"malencontreuse" => "mal@k§tR2z",
"malencontreusement" => "mal@k§tR2z°m@",
"malencontreuses" => "mal@k§tR2z",
"malencontreux" => "mal@k§tR2",
"malentendant" => "mal@t@d@",
"malentendante" => "mal@t@d@t",
"malentendants" => "mal@t@d@",
"malentendu" => "mal@t@dy",
"malentendus" => "mal@t@dy",
"males" => "mal",
"mâles" => "mal",
"malfaçon" => "malfas§",
"malfaçons" => "malfas§",
"malfaisance" => "malf°z@s",
"malfaisances" => "malf°z@s",
"malfaisant" => "malf°z@",
"malfaisante" => "malf°z@t",
"malfaisantes" => "malf°z@t",
"malfaisants" => "malf°z@",
"malfaiteur" => "malfEt9R",
"malfaiteurs" => "malfEt9R",
"malfamé" => "malfame",
"malfamée" => "malfame",
"malfamés" => "malfame",
"malformation" => "malfORmasj§",
"malformé" => "malfORme",
"malfrat" => "malfRa",
"malfrats" => "malfRa",
"malgache" => "malgaS",
"malgaches" => "malgaS",
"malgracieuse" => "malgRasj2z",
"malgracieux" => "malgRasj2",
"malgré" => "malgRe",
"malhabile" => "malabil",
"malhabilement" => "malabil°m@",
"malhabiles" => "malabil",
"malherbe" => "malERb",
"malheur" => "mal9R",
"malheureuse" => "mal2R2z",
"malheureusement" => "mal2R2z°m@",
"malheureuses" => "mal2R2z",
"malheureux" => "mal2R2",
"malheurs" => "mal9R",
"malhonnête" => "malonEt",
"malhonnêtement" => "malonEt°m@",
"malhonnêtes" => "malonEt",
"malhonnêteté" => "malonEtte",
"malhonnêtetés" => "malonEtte",
"mali" => "mali",
"malice" => "malis",
"malices" => "malis",
"malicieuse" => "malisj2z",
"malicieusement" => "malisj2z°m@",
"malicieuses" => "malisj2z",
"malicieux" => "malisj2",
"malien" => "malj5",
"malienne" => "maljEn",
"maliens" => "malj5",
"maligne" => "maliN",
"malignement" => "maliN°m@",
"malignes" => "maliN",
"malignité" => "maliNite",
"malignités" => "maliNite",
"malin" => "mal5",
"maline" => "malin",
"malines" => "malin",
"malingre" => "mal5gR",
"malingres" => "mal5gR",
"malinké" => "mal5ke",
"malinois" => "malinwa",
"malins" => "mal5",
"malintentionné" => "mal5t@sjone",
"malintentionnée" => "mal5t@sjone",
"malintentionnés" => "mal5t@sjone",
"mallarméen" => "malaRme5",
"malle" => "mal",
"malléabilité" => "maleabilite",
"malléable" => "maleabl",
"malléables" => "maleabl",
"malléolaire" => "maleOlER",
"malléole" => "maleOl",
"malles" => "mal",
"mallette" => "malEt",
"mallettes" => "malEt",
"mallophages" => "malofaZ",
"malm" => "malm",
"malmenage" => "malm2naZ",
"malmenaient" => "malm°nE",
"malmenais" => "malm°nE",
"malmenait" => "malm°nE",
"malmenant" => "malm°n@",
"malmène" => "malmEn",
"malmené" => "malm°ne",
"malmenée" => "malm°ne",
"malmenées" => "malm°ne",
"malmènent" => "malmEn",
"malmener" => "malm°ne",
"malmèneront" => "malmEn°R§",
"malmenés" => "malm°ne",
"malmenez" => "malm°ne",
"malnutrition" => "malnytRisj§",
"malodorant" => "malodoR@",
"malodorante" => "malodoR@t",
"malodorantes" => "malodoR@t",
"malodorants" => "malodoR@",
"malotru" => "malotRy",
"malotrus" => "malotRy",
"malouin" => "malw5",
"malouine" => "malwin",
"malouines" => "malwin",
"malouins" => "malw5",
"malpoli" => "malpoli",
"malpolie" => "malpoli",
"malpolis" => "malpoli",
"malpropre" => "malpROpR",
"malproprement" => "malpROpR°m@",
"malpropres" => "malpROpR",
"malpropreté" => "malpROpR°te",
"malsain" => "mals5",
"malsaine" => "malsEn",
"malsainement" => "malsEn°m@",
"malsaines" => "malsEn",
"malsains" => "mals5",
"malséance" => "malse@s",
"malséant" => "malse@",
"malséante" => "malse@t",
"malsonnants" => "malson@",
"malt" => "malt",
"malta" => "malta",
"maltais" => "maltE",
"maltaises" => "maltEz",
"malté" => "malte",
"maltée" => "malte",
"maltraitaient" => "maltREtE",
"maltraitais" => "maltREtE",
"maltraitait" => "maltREtE",
"maltraitance" => "maltREt@s",
"maltraitances" => "maltREt@s",
"maltraitant" => "maltREt@",
"maltraitât" => "maltREta",
"maltraite" => "maltREt",
"maltraité" => "maltRete",
"maltraitée" => "maltRete",
"maltraitées" => "maltRete",
"maltraitent" => "maltREt",
"maltraiter" => "maltRete",
"maltraitera" => "maltREt°Ra",
"maltraitèrent" => "maltREtER",
"maltraiterez" => "maltREt°Re",
"maltraités" => "maltRete",
"maltraitez" => "maltREte",
"malus" => "malys",
"malveillance" => "malvEj@s",
"malveillances" => "malvEj@s",
"malveillant" => "malvEj@",
"malveillante" => "malvEj@t",
"malveillantes" => "malvEj@t",
"malveillants" => "malvEj@",
"malvenu" => "malv°ny",
"malvenue" => "malv°ny",
"malvenus" => "malv°ny",
"malversation" => "malvERsasj§",
"malversations" => "malvERsasj§",
"malvoisie" => "malvwazi",
"malvoisies" => "malvwazi",
"mam" => "mam",
"mam'selle" => "mamzEl",
"mam'zelle" => "mamzEl",
"mamaliga" => "mamaliga",
"mamamouchi" => "mamamuSi",
"maman" => "mam@",
"mamans" => "mam@",
"mamba" => "m@ba",
"mambo" => "m@bo",
"mambos" => "m@bo",
"mame" => "mam",
"mamelle" => "mamEl",
"mamelles" => "mamEl",
"mamelon" => "mam°l§",
"mamelonnée" => "mam°lone",
"mamelons" => "mam°l§",
"mamelouk" => "mam°luk",
"mamelouks" => "mam°luk",
"mamelu" => "mam°ly",
"mamelue" => "mam°ly",
"mamelues" => "mam°ly",
"mameluk" => "mam°luk",
"mameluks" => "mam°luk",
"mamelus" => "mam°ly",
"mamie" => "mami",
"mamies" => "mami",
"mamma" => "mamma",
"mammaire" => "mamER",
"mammaires" => "mamER",
"mammectomie" => "mamEktomi",
"mammifère" => "mamifER",
"mammifères" => "mamifER",
"mammographie" => "mamogRafi",
"mammoplastie" => "mamOplasti",
"mammouth" => "mamut",
"mammouths" => "mamut",
"mammy" => "mami",
"mamours" => "mamuR",
"mamy" => "mami",
"mamys" => "mami",
"mamzelle" => "mamzEl",
"man" => "m@",
"mana" => "mana",
"manade" => "manad",
"manades" => "manad",
"manage" => "manaZ",
"manageait" => "manaZE",
"management" => "manaZ°m@",
"manager" => "manadZ9R",
"managerais" => "manaZ°RE",
"managers" => "manadZER",
"manageur" => "manaZ9R",
"manant" => "man@",
"manants" => "man@",
"manceau" => "m@so",
"mancenillier" => "m@snije",
"manche" => "m@S",
"mancheron" => "m@S°R§",
"mancherons" => "m@S°R§",
"manches" => "m@S",
"manchette" => "m@SEt",
"manchettes" => "m@SEt",
"manchon" => "m@S§",
"manchons" => "m@S§",
"manchot" => "m@So",
"manchote" => "m@SOt",
"manchotes" => "m@SOt",
"manchots" => "m@So",
"mandai" => "m@dE",
"mandaient" => "m@dE",
"mandait" => "m@dE",
"mandala" => "m@dala",
"mandalas" => "m@dala",
"mandale" => "m@dal",
"mandales" => "m@dal",
"mandant" => "m@d@",
"mandants" => "m@d@",
"mandarin" => "m@daR5",
"mandarine" => "m@daRin",
"mandarines" => "m@daRin",
"mandarinier" => "m@daRinje",
"mandariniers" => "m@daRinje",
"mandarins" => "m@daR5",
"mandas" => "m@da",
"mandat" => "m@da",
"mandat-carte" => "m@dakaRt",
"mandat-lettre" => "m@dalEtR",
"mandat-poste" => "m@dapOst",
"mandataire" => "m@datER",
"mandataires" => "m@datER",
"mandatait" => "m@datE",
"mandatant" => "m@dat@",
"mandaté" => "m@date",
"mandatée" => "m@date",
"mandatement" => "m@dat°m@",
"mandater" => "m@date",
"mandatés" => "m@date",
"mandatez" => "m@date",
"mandats" => "m@da",
"mandchoue" => "m@dSu",
"mandchous" => "m@dSu",
"mande" => "m@d",
"mandé" => "m@de",
"mandée" => "m@de",
"mandement" => "m@d°m@",
"mandements" => "m@d°m@",
"mander" => "m@de",
"mandera" => "m@d°Ra",
"manderai" => "m@d°RE",
"manderaient" => "m@d°RE",
"manderais" => "m@d°RE",
"mandèrent" => "m@dER",
"mandes" => "m@d",
"mandez" => "m@de",
"mandibulaire" => "m@dibylER",
"mandibule" => "m@dibyl",
"mandibules" => "m@dibyl",
"mandingue" => "m@d5g",
"mandingues" => "m@d5g",
"mandoline" => "m@dolin",
"mandolines" => "m@dolin",
"mandore" => "m@dOR",
"mandorle" => "m@dORl",
"mandorles" => "m@dORl",
"mandragore" => "m@dRagOR",
"mandragores" => "m@dRagOR",
"mandrill" => "m@dRil",
"mandrin" => "m@dR5",
"mandrins" => "m@dR5",
"manducation" => "m@dykasj§",
"manécanterie" => "manek@t°Ri",
"manège" => "manEZ",
"manèges" => "manEZ",
"manégés" => "maneZe",
"mânes" => "man",
"manette" => "manEt",
"manettes" => "manEt",
"manga" => "m@ga",
"manganèse" => "m@ganEz",
"manganite" => "m@ganit",
"mangas" => "m@ga",
"mange" => "m@Z",
"mangé" => "m@Ze",
"mange-disque" => "m@Zdisk",
"mange-disques" => "m@Zdisk",
"mange-tout" => "m@Ztu",
"mangea" => "m@Za",
"mangeable" => "m@Zabl",
"mangeables" => "m@Zabl",
"mangeai" => "m@ZE",
"mangeaient" => "m@ZE",
"mangeaille" => "m@Zaj",
"mangeailles" => "m@Zaj",
"mangeais" => "m@ZE",
"mangeait" => "m@ZE",
"mangeâmes" => "m@Zam",
"mangeant" => "m@Z@",
"mangeas" => "m@Za",
"mangeasse" => "m@Zas",
"mangeât" => "m@Za",
"mangée" => "m@Ze",
"mangées" => "m@Ze",
"mangent" => "m@Z",
"mangeoire" => "m@ZwaR",
"mangeoires" => "m@ZwaR",
"mangeons" => "m@Z§",
"manger" => "m@Ze",
"mangera" => "m@Z°Ra",
"mangerai" => "m@Z°RE",
"mangeraient" => "m@Z°RE",
"mangerais" => "m@Z°RE",
"mangerait" => "m@Z°RE",
"mangeras" => "m@Z°Ra",
"mangèrent" => "m@ZER",
"mangerez" => "m@Z°Re",
"mangerie" => "m@Z°Ri",
"mangeriez" => "m@Z°Rje",
"mangerions" => "m@Z°Rj§",
"mangerons" => "m@Z°R§",
"mangeront" => "m@Z°R§",
"manges" => "m@Z",
"mangés" => "m@Ze",
"mangetout" => "m@Z°tu",
"mangeur" => "m@Z9R",
"mangeurs" => "m@Z9R",
"mangeuse" => "m@Z2z",
"mangeuses" => "m@Z2z",
"mangez" => "m@Ze",
"mangiez" => "m@Zje",
"mangions" => "m@Zj§",
"mango" => "m@go",
"mangonneaux" => "m@gono",
"mangouste" => "m@gust",
"mangrove" => "m@gROv",
"mangroves" => "m@gROv",
"mangue" => "m@g",
"mangues" => "m@g",
"manguier" => "m@gje",
"manguiers" => "m@gje",
"manhattan" => "manatan",
"mania" => "manja",
"maniabilité" => "manjabilite",
"maniable" => "manjabl",
"maniables" => "manjabl",
"maniaco-dépressif" => "manjakodepResif",
"maniaco-dépressifs" => "manjakodepResif",
"maniaco-dépressive" => "manjakodepResiv",
"maniacodépressif" => "manjakodepResif",
"maniacodépressive" => "manjakodepREsiv",
"maniaient" => "manjE",
"maniais" => "manjE",
"maniait" => "manjE",
"maniant" => "manj@",
"maniaque" => "manjak",
"maniaquement" => "manjak°m@",
"maniaquerie" => "manjak°Ri",
"maniaqueries" => "manjak°Ri",
"maniaques" => "manjak",
"manichéen" => "manike5",
"manichéisme" => "manikeizm",
"manichéiste" => "manikeist",
"manie" => "mani",
"manié" => "manje",
"maniée" => "manje",
"maniées" => "manje",
"maniement" => "manim@",
"maniements" => "manim@",
"manient" => "mani",
"manier" => "manje",
"manierais" => "maniRE",
"manière" => "manjER",
"maniéré" => "manjeRe",
"maniérée" => "manjeRe",
"maniérées" => "manjeRe",
"manièrent" => "manjER",
"manières" => "manjER",
"maniérés" => "manjeRe",
"maniérisme" => "manjeRizm",
"maniérismes" => "manjeRizm",
"maniériste" => "manjeRist",
"maniéristes" => "manjeRist",
"manieront" => "maniR§",
"manies" => "mani",
"maniés" => "manje",
"manieur" => "manj9R",
"manieurs" => "manj9R",
"manieuse" => "manj2z",
"maniez" => "manje",
"manif" => "manif",
"manifesta" => "manifEsta",
"manifestai" => "manifEstE",
"manifestaient" => "manifEstE",
"manifestais" => "manifEstE",
"manifestait" => "manifEstE",
"manifestant" => "manifEst@",
"manifestante" => "manifEst@t",
"manifestantes" => "manifEst@t",
"manifestants" => "manifEst@",
"manifestât" => "manifEsta",
"manifestation" => "manifEstasj§",
"manifestations" => "manifEstasj§",
"manifeste" => "manifEst",
"manifesté" => "manifEste",
"manifestée" => "manifEste",
"manifestées" => "manifEste",
"manifestement" => "manifEst°m@",
"manifestent" => "manifEst",
"manifester" => "manifEste",
"manifestera" => "manifEst°Ra",
"manifesterai" => "manifEst°RE",
"manifesteraient" => "manifEst°RE",
"manifesterais" => "manifEst°RE",
"manifesterait" => "manifEst°RE",
"manifestèrent" => "manifEstER",
"manifesteront" => "manifEst°R§",
"manifestes" => "manifEst",
"manifestés" => "manifEste",
"manifestez" => "manifEste",
"manifestiez" => "manifEstje",
"manifestions" => "manifEstj§",
"manifestons" => "manifEst§",
"manifold" => "manifOld",
"manifolds" => "manifOld",
"manifs" => "manif",
"manigançaient" => "manig@sE",
"manigançais" => "manig@sE",
"manigançait" => "manig@sE",
"manigance" => "manig@s",
"manigancé" => "manig@se",
"manigancée" => "manig@se",
"manigancent" => "manig@s",
"manigancer" => "manig@se",
"manigancerait" => "manig@s°RE",
"manigances" => "manig@s",
"manigancez" => "manig@se",
"maniganciez" => "manig@sje",
"manilla" => "manija",
"manille" => "manij",
"manilles" => "manij",
"manilleurs" => "manij9R",
"manillon" => "manij§",
"manioc" => "manjOk",
"manip" => "manip",
"manipe" => "manip",
"manipula" => "manipyla",
"manipulable" => "manipylabl",
"manipulables" => "manipylabl",
"manipulaient" => "manipylE",
"manipulais" => "manipylE",
"manipulait" => "manipylE",
"manipulant" => "manipyl@",
"manipulateur" => "manipylat9R",
"manipulateurs" => "manipylat9R",
"manipulation" => "manipylasj§",
"manipulations" => "manipylasj§",
"manipulatrice" => "manipylatRis",
"manipulatrices" => "manipylatRis",
"manipule" => "manipyl",
"manipulé" => "manipyle",
"manipulée" => "manipyle",
"manipulées" => "manipyle",
"manipulent" => "manipyl",
"manipuler" => "manipyle",
"manipulera" => "manipyl°Ra",
"manipulerai" => "manipyl°RE",
"manipulerait" => "manipyl°RE",
"manipuleras" => "manipyl°Ra",
"manipules" => "manipyl",
"manipulés" => "manipyle",
"manipulez" => "manipyle",
"manipulons" => "manipyl§",
"manitoba" => "manitoba",
"manitou" => "manitu",
"manitous" => "manitu",
"manivelle" => "manivEl",
"manivelles" => "manivEl",
"manne" => "man",
"mannequin" => "man°k5",
"mannequine" => "man°kin",
"mannequins" => "man°k5",
"mannes" => "man",
"mannezingue" => "manz5g",
"mannitol" => "manitOl",
"manoeuvra" => "man9vRa",
"manoeuvrabilité" => "man9vRabilite",
"manoeuvrable" => "man9vRabl",
"manoeuvraient" => "man9vRE",
"manoeuvrais" => "man9vRE",
"manoeuvrait" => "man9vRE",
"manoeuvrant" => "man9vR@",
"manoeuvre" => "man9vR",
"manoeuvré" => "man9vRe",
"manoeuvrée" => "man9vRe",
"manoeuvrées" => "man9vRe",
"manoeuvrent" => "man9vR",
"manoeuvrer" => "man9vRe",
"manoeuvrèrent" => "man9vRER",
"manoeuvres" => "man9vR",
"manoeuvrés" => "man9vRe",
"manoeuvrez" => "man9vRe",
"manoeuvrier" => "man9vRije",
"manoeuvrière" => "man9vRijER",
"manoeuvrières" => "man9vRijER",
"manoeuvriers" => "man9vRije",
"manoeuvrons" => "man9vR§",
"manoir" => "manwaR",
"manoirs" => "manwaR",
"manomètre" => "manomEtR",
"manomètres" => "manomEtR",
"manouche" => "manuS",
"manouches" => "manuS",
"manouvrier" => "manuvRije",
"manqua" => "m@ka",
"manquai" => "m@kE",
"manquaient" => "m@kE",
"manquais" => "m@kE",
"manquait" => "m@kE",
"manquâmes" => "m@kam",
"manquant" => "m@k@",
"manquante" => "m@k@t",
"manquantes" => "m@k@t",
"manquants" => "m@k@",
"manquassent" => "m@kas",
"manquât" => "m@ka",
"manque" => "m@k",
"manqué" => "m@ke",
"manquée" => "m@ke",
"manquées" => "m@ke",
"manquement" => "m@k°m@",
"manquements" => "m@k°m@",
"manquent" => "m@k",
"manquer" => "m@ke",
"manquera" => "m@k°Ra",
"manquerai" => "m@k°RE",
"manqueraient" => "m@k°RE",
"manquerais" => "m@k°RE",
"manquerait" => "m@k°RE",
"manqueras" => "m@k°Ra",
"manquèrent" => "m@kER",
"manquerez" => "m@k°Re",
"manqueriez" => "m@k°Rje",
"manquerions" => "m@k°Rj§",
"manquerons" => "m@k°R§",
"manqueront" => "m@k°R§",
"manques" => "m@k",
"manqués" => "m@ke",
"manquez" => "m@ke",
"manquiez" => "m@kje",
"manquions" => "m@kj§",
"manquons" => "m@k§",
"mansard" => "m@saR",
"mansarde" => "m@saRd",
"mansardé" => "m@saRde",
"mansardée" => "m@saRde",
"mansardées" => "m@saRde",
"mansardes" => "m@saRd",
"mansion" => "m@sj§",
"mansions" => "m@sj§",
"mansuétude" => "m@s8etyd",
"mansuétudes" => "m@s8etyd",
"manta" => "m@ta",
"mante" => "m@t",
"manteau" => "m@to",
"manteaux" => "m@to",
"mantelet" => "m@t°lE",
"mantelets" => "m@t°lE",
"mantelure" => "m@tElyR",
"mantes" => "m@t",
"mantille" => "m@tij",
"mantilles" => "m@tij",
"mantique" => "m@tik",
"mantra" => "m@tRa",
"manu militari" => "manymilitaRi",
"manubrium" => "manybRijOm",
"manucure" => "manykyR",
"manucuré" => "manykyRe",
"manucurée" => "manykyRe",
"manucurées" => "manykyRe",
"manucurer" => "manykyRe",
"manucures" => "manykyR",
"manucurés" => "manykyRe",
"manuel" => "man8El",
"manuélin" => "man8el5",
"manuelle" => "man8El",
"manuellement" => "man8El°m@",
"manuelles" => "man8El",
"manuels" => "man8El",
"manufacture" => "manyfaktyR",
"manufacturé" => "manyfaktyRe",
"manufacturée" => "manyfaktyRe",
"manufacturées" => "manyfaktyRe",
"manufacturer" => "manyfaktyRe",
"manufactures" => "manyfaktyR",
"manufacturés" => "manyfaktyRe",
"manufacturiers" => "manyfaktyRje",
"manufacturons" => "manyfaktyR§",
"manuscrit" => "manyskRi",
"manuscrite" => "manyskRit",
"manuscrites" => "manyskRit",
"manuscrits" => "manyskRi",
"manutention" => "manyt@sj§",
"manutentionnaire" => "manyt@sjonER",
"manutentionnaires" => "manyt@sjonER",
"manutentionner" => "manyt@sjOne",
"manutentions" => "manyt@sj§",
"manzanilla" => "m@zanija",
"mao" => "mao",
"maoïsme" => "maoizm",
"maoïste" => "maoist",
"maori" => "maoRi",
"maorie" => "maoRi",
"maos" => "mao",
"maous" => "maus",
"maousse" => "maus",
"mappemonde" => "map°m§d",
"mappemondes" => "map°m§d",
"maquaient" => "makE",
"maque" => "mak",
"maqué" => "make",
"maquée" => "make",
"maquent" => "mak",
"maquer" => "make",
"maquereau" => "mak°Ro",
"maquereautage" => "mak°RotaZ",
"maquereauter" => "mak°Rote",
"maquereautins" => "makERot5",
"maquereaux" => "mak°Ro",
"maquerellage" => "mak°RElaZ",
"maquerelle" => "mak°REl",
"maquerelles" => "mak°REl",
"maques" => "mak",
"maqués" => "make",
"maquette" => "makEt",
"maquettes" => "makEt",
"maquettiste" => "maketist",
"maquettistes" => "makEtist",
"maquignon" => "makiN§",
"maquignonnage" => "makiNonaZ",
"maquignonnages" => "makiNonaZ",
"maquignonne" => "makiNOn",
"maquignonné" => "makiNone",
"maquignonnés" => "makiNone",
"maquignons" => "makiN§",
"maquilla" => "makija",
"maquillage" => "makijaZ",
"maquillages" => "makijaZ",
"maquillai" => "makijE",
"maquillais" => "makijE",
"maquillait" => "makijE",
"maquillant" => "makij@",
"maquille" => "makij",
"maquillé" => "makije",
"maquillée" => "makije",
"maquillées" => "makije",
"maquillent" => "makij",
"maquiller" => "makije",
"maquillerai" => "makij°RE",
"maquillerais" => "makij°RE",
"maquilleras" => "makij°Ra",
"maquilles" => "makij",
"maquillés" => "makije",
"maquilleur" => "makij9R",
"maquilleurs" => "makij9R",
"maquilleuse" => "makij2z",
"maquilleuses" => "makij2z",
"maquillez" => "makije",
"maquilliez" => "makije",
"maquillons" => "makij§",
"maquis" => "maki",
"maquisard" => "makizaR",
"maquisarde" => "makizaRd",
"maquisardes" => "makizaRd",
"maquisards" => "makizaR",
"mara" => "maRa",
"marabout" => "maRabu",
"marabouts" => "maRabu",
"maracas" => "maRakas",
"marae" => "maRe",
"maraîcher" => "maReSe",
"maraîchère" => "maRESER",
"maraîchères" => "maRESER",
"maraîchers" => "maReSe",
"marais" => "maRE",
"maranta" => "maR@ta",
"marante" => "maR@t",
"marasme" => "maRasm",
"marasmes" => "maRasm",
"marasquin" => "maRask5",
"marathon" => "maRat§",
"marathonien" => "maRatonj5",
"marathonienne" => "maRatonjEn",
"marathons" => "maRat§",
"marâtre" => "maRatR",
"marâtres" => "maRatR",
"maraud" => "maRo",
"maraudaient" => "maRodE",
"maraudait" => "maRodE",
"maraude" => "maRod",
"maraudé" => "maRode",
"marauder" => "maRode",
"maraudes" => "maRod",
"maraudés" => "maRode",
"maraudeur" => "maRod9R",
"maraudeurs" => "maRod9R",
"maraudeuse" => "maRod2z",
"marauds" => "maRo",
"maravédis" => "maRavedis",
"marbra" => "maRbRa",
"marbraient" => "maRbRE",
"marbrait" => "maRbRE",
"marbre" => "maRbR",
"marbré" => "maRbRe",
"marbrée" => "maRbRe",
"marbrées" => "maRbRe",
"marbrent" => "maRbR",
"marbrerie" => "maRbR°Ri",
"marbreries" => "maRbR°Ri",
"marbres" => "maRbR",
"marbrés" => "maRbRe",
"marbrier" => "maRbRje",
"marbrure" => "maRbRyR",
"marbrures" => "maRbRyR",
"marc" => "maR",
"marcassin" => "maRkas5",
"marcassins" => "maRkas5",
"marcel" => "maRsEl",
"marceline" => "maRs2lin",
"marcha" => "maRSa",
"marchai" => "maRSE",
"marchaient" => "maRSE",
"marchais" => "maRSE",
"marchait" => "maRSE",
"marchâmes" => "maRSam",
"marchand" => "maRS@",
"marchandage" => "maRS@daZ",
"marchandages" => "maRS@daZ",
"marchandaient" => "maRS@dE",
"marchandais" => "maRS@dE",
"marchandait" => "maRS@dE",
"marchandant" => "maRS@d@",
"marchande" => "maRS@d",
"marchandé" => "maRS@de",
"marchandée" => "maRS@de",
"marchandent" => "maRS@d",
"marchander" => "maRS@de",
"marchandera" => "maRS@d°Ra",
"marchanderais" => "maRS@d°RE",
"marchanderez" => "maRS@d°Re",
"marchandes" => "maRS@d",
"marchandeuse" => "maRS@d2z",
"marchandez" => "maRS@de",
"marchandise" => "maRS@diz",
"marchandises" => "maRS@diz",
"marchandiseur" => "maRS@diz9R",
"marchandons" => "maRS@d§",
"marchands" => "maRS@",
"marchant" => "maRS@",
"marchante" => "maRS@t",
"marchantes" => "maRS@t",
"marchât" => "maRSa",
"marche" => "maRS",
"marché" => "maRSe",
"marchées" => "maRSe",
"marchent" => "maRS",
"marchepied" => "maRS°pje",
"marchepieds" => "maRS°pje",
"marcher" => "maRSe",
"marchera" => "maRS°Ra",
"marcherai" => "maRS°RE",
"marcheraient" => "maRS°RE",
"marcherais" => "maRS°RE",
"marcherait" => "maRS°RE",
"marcheras" => "maRS°Ra",
"marchèrent" => "maRSER",
"marcherez" => "maRS°Re",
"marcheriez" => "maRS°Rje",
"marcherions" => "maRS°Rj§",
"marcherons" => "maRS°R§",
"marcheront" => "maRS°R§",
"marches" => "maRS",
"marchés" => "maRSe",
"marcheur" => "maRS9R",
"marcheurs" => "maRS9R",
"marcheuse" => "maRS2z",
"marcheuses" => "maRS2z",
"marchez" => "maRSe",
"marchiez" => "maRSije",
"marchions" => "maRSj§",
"marchons" => "maRS§",
"marconi" => "maRkoni",
"marcotin" => "maRkOt5",
"marcotte" => "maRkOt",
"marcs" => "maR",
"mardi" => "maRdi",
"mardis" => "maRdi",
"mare" => "maR",
"marécage" => "maRekaZ",
"marécages" => "maRekaZ",
"marécageuse" => "maRekaZ2z",
"marécageuses" => "maRekaZ2z",
"marécageux" => "maRekaZ2",
"maréchal" => "maReSal",
"maréchal-ferrant" => "maReSalfER@",
"maréchalat" => "maReSala",
"maréchale" => "maReSal",
"maréchalerie" => "maReSal°Ri",
"maréchalistes" => "maReSalist",
"maréchaussée" => "maReSose",
"maréchaux" => "maReSo",
"maréchaux-ferrants" => "maReSofER@",
"marée" => "maRe",
"marées" => "maRe",
"marelle" => "maREl",
"marelles" => "maREl",
"marémotrice" => "maRemotRis",
"marengo" => "maR@go",
"marennes" => "maREn",
"mares" => "maR",
"mareyeur" => "maREj9R",
"mareyeurs" => "maREj9R",
"mareyeuse" => "maREj2z",
"mareyeuses" => "maREj2z",
"margarine" => "maRgaRin",
"margaux" => "maRgo",
"margay" => "maRgE",
"marge" => "maRZ",
"margeait" => "maRZE",
"margelle" => "maRZEl",
"margelles" => "maRZEl",
"marger" => "maRZe",
"marges" => "maRZ",
"margeuse" => "maRZ2z",
"margina" => "maRZina",
"marginal" => "maRZinal",
"marginale" => "maRZinal",
"marginalement" => "maRZinal°m@",
"marginales" => "maRZinal",
"marginalisant" => "maRZinaliz@",
"marginalisé" => "maRZinalize",
"marginalisée" => "maRZinalize",
"marginaliser" => "maRZinalize",
"marginaliseraient" => "maRZinaliz°RE",
"marginalisés" => "maRZinalize",
"marginalité" => "maRZinalite",
"marginaux" => "maRZino",
"marginée" => "maRZine",
"margis" => "maRZi",
"margot" => "maRgo",
"margotait" => "maRgotE",
"margotin" => "maRgot5",
"margotins" => "maRgot5",
"margoton" => "maRgOt§",
"margotte" => "maRgOt",
"margottons" => "maRgot§",
"margouillat" => "maRguja",
"margouillats" => "maRguja",
"margouillis" => "maRguji",
"margoulette" => "maRgulEt",
"margoulin" => "maRgul5",
"margoulins" => "maRgul5",
"margrave" => "maRgRav",
"margraviat" => "maRgRavja",
"marguerite" => "maRg°Rit",
"marguerites" => "maRg°Rit",
"marguillier" => "maRgije",
"marguilliers" => "maRgije",
"mari" => "maRi",
"maria" => "maRja",
"mariable" => "maRjabl",
"mariachi" => "maRjaSi",
"mariachis" => "maRjaSi",
"mariage" => "maRjaZ",
"mariages" => "maRjaZ",
"mariai" => "maRjE",
"mariaient" => "maRjE",
"mariais" => "maRjE",
"mariait" => "maRjE",
"mariales" => "maRjal",
"marianne" => "maRjan",
"mariant" => "maRj@",
"marias" => "maRja",
"mariassent" => "maRjas",
"mariât" => "maRja",
"marida" => "maRida",
"maridas" => "maRida",
"marie" => "maRi",
"marié" => "maRje",
"marie-couche-toi-là" => "maRikuStwala",
"marie-jeanne" => "maRiZan",
"marie-louise" => "maRilwiz",
"marie-salope" => "maRisalOp",
"mariée" => "maRje",
"mariées" => "maRje",
"marient" => "maRi",
"marier" => "maRje",
"mariera" => "maRiRa",
"marierai" => "maRiRE",
"marieraient" => "maRiRE",
"marierais" => "maRiRE",
"marierait" => "maRiRE",
"marieras" => "maRiRa",
"marièrent" => "maRjER",
"marierez" => "maRiRe",
"marieriez" => "maRiRje",
"marierions" => "maRiRj§",
"marierons" => "maRiR§",
"marieront" => "maRiR§",
"maries" => "maRi",
"mariés" => "maRje",
"marieur" => "maRj9R",
"marieuse" => "maRj2z",
"marieuses" => "maRj2z",
"mariez" => "maRje",
"marigot" => "maRigo",
"marigots" => "maRigo",
"marihuana" => "maRiRwana",
"mariions" => "maRijj§",
"marijuana" => "maRiRwana",
"marimba" => "maRimba",
"marin" => "maR5",
"marin-pêcheur" => "maR5pES9R",
"marina" => "maRina",
"marinade" => "maRinad",
"marinades" => "maRinad",
"marinage" => "maRinaZ",
"marinaient" => "maRinE",
"marinait" => "maRinE",
"marinant" => "maRin@",
"marinas" => "maRina",
"marine" => "maRin",
"mariné" => "maRine",
"marinée" => "maRine",
"marinées" => "maRine",
"mariner" => "maRine",
"marinera" => "maRin°Ra",
"marines" => "maRin",
"marinés" => "maRine",
"maringoins" => "maR5gw5",
"marinier" => "maRinje",
"marinière" => "maRinjER",
"marinières" => "maRinjER",
"mariniers" => "maRinje",
"marins" => "maR5",
"mariol" => "maRjOl",
"mariole" => "maRjOl",
"marioles" => "maRjOl",
"mariolle" => "maRjOl",
"mariolles" => "maRjOl",
"marionnette" => "maRjonEt",
"marionnettes" => "maRjonEt",
"marionnettiste" => "maRjonEtist",
"marions" => "maRj§",
"maris" => "maRi",
"maristes" => "maRist",
"marital" => "maRital",
"maritale" => "maRital",
"maritalement" => "maRital°m@",
"maritales" => "maRital",
"maritaux" => "maRito",
"maritime" => "maRitim",
"maritimes" => "maRitim",
"maritorne" => "maRitORn",
"marivaudage" => "maRivodaZ",
"marivaudages" => "maRivodaZ",
"marivaudant" => "maRivod@",
"marivauder" => "maRivode",
"marjolaine" => "maRZolEn",
"mark" => "maRk",
"marker" => "maRk9R",
"marketing" => "maRketiG",
"marketings" => "maRketiG",
"marks" => "maRk",
"marle" => "maRl",
"marles" => "maRl",
"marlin" => "maRl5",
"marlou" => "maRlu",
"marloupin" => "maRlup5",
"marloupinerie" => "maRlupin°Ri",
"marloupineries" => "maRlupin°Ri",
"marloupins" => "maRlup5",
"marlous" => "maRlu",
"marmaille" => "maRmaj",
"marmailles" => "maRmaj",
"marmelade" => "maRm°lad",
"marmelades" => "maRm°lad",
"marmitage" => "maRmitaZ",
"marmitages" => "maRmitaZ",
"marmite" => "maRmit",
"marmitées" => "maRmite",
"marmiter" => "maRmite",
"marmites" => "maRmit",
"marmités" => "maRmite",
"marmiteuse" => "maRmit2z",
"marmiteux" => "maRmit2",
"marmiton" => "maRmit§",
"marmitons" => "maRmit§",
"marmonna" => "maRmona",
"marmonnaient" => "maRmonE",
"marmonnait" => "maRmonE",
"marmonnant" => "maRmon@",
"marmonne" => "maRmOn",
"marmonné" => "maRmone",
"marmonnée" => "maRmone",
"marmonnement" => "maRmOn°m@",
"marmonnements" => "maRmOn°m@",
"marmonnent" => "maRmOn",
"marmonner" => "maRmone",
"marmonnes" => "maRmOn",
"marmonnés" => "maRmone",
"marmonnez" => "maRmone",
"marmonniez" => "maRmonje",
"marmoréen" => "maRmoRe5",
"marmoréenne" => "maRmoReEn",
"marmoréens" => "maRmoRe5",
"marmot" => "maRmo",
"marmots" => "maRmo",
"marmotta" => "maRmota",
"marmottages" => "maRmotaZ",
"marmottait" => "maRmotE",
"marmottant" => "maRmot@",
"marmotte" => "maRmOt",
"marmotté" => "maRmote",
"marmottement" => "maRmOt°m@",
"marmotter" => "maRmote",
"marmottes" => "maRmOt",
"marmouset" => "maRmuzE",
"marmousets" => "maRmuzE",
"marna" => "maRna",
"marnaise" => "maRnEz",
"marnait" => "maRnE",
"marne" => "maRn",
"marné" => "maRne",
"marnent" => "maRn",
"marner" => "maRne",
"marnes" => "maRn",
"marneuse" => "maRn2z",
"marnières" => "maRnjER",
"marocain" => "maRok5",
"marocaine" => "maRokEn",
"marocaines" => "maRokEn",
"marocains" => "maRok5",
"maronite" => "maRonit",
"maronites" => "maRonit",
"maronné" => "maRone",
"maronner" => "maROne",
"maroquin" => "maRok5",
"maroquinerie" => "maRokin°Ri",
"maroquineries" => "maRokin°Ri",
"maroquinier" => "maRokinje",
"maroquiniers" => "maRokinje",
"maroquins" => "maRok5",
"marotte" => "maROt",
"marottes" => "maROt",
"marouette" => "maRwEt",
"maroufle" => "maRufl",
"maroufler" => "maRufle",
"maroufles" => "maRufl",
"marqua" => "maRka",
"marquage" => "maRkaZ",
"marquai" => "maRkE",
"marquaient" => "maRkE",
"marquais" => "maRkE",
"marquait" => "maRkE",
"marquant" => "maRk@",
"marquante" => "maRk@t",
"marquantes" => "maRk@t",
"marquants" => "maRk@",
"marquât" => "maRka",
"marque" => "maRk",
"marqué" => "maRke",
"marque-page" => "maRk°paZ",
"marque-pages" => "maRk°paZ",
"marquée" => "maRke",
"marquées" => "maRke",
"marquent" => "maRk",
"marquer" => "maRke",
"marquera" => "maRk°Ra",
"marquerai" => "maRk°RE",
"marqueraient" => "maRk°RE",
"marquerait" => "maRk°RE",
"marqueras" => "maRk°Ra",
"marquèrent" => "maRkER",
"marquerez" => "maRk°Re",
"marquerons" => "maRk°R§",
"marqueront" => "maRk°R§",
"marques" => "maRk",
"marqués" => "maRke",
"marqueté" => "maRk°te",
"marquetées" => "maRk°te",
"marqueterie" => "maRkEt°Ri",
"marqueteries" => "maRkEt°Ri",
"marquetés" => "maRk°te",
"marquette" => "maRkEt",
"marqueur" => "maRk9R",
"marqueurs" => "maRk9R",
"marquez" => "maRke",
"marquiez" => "maRkje",
"marquions" => "maRkj§",
"marquis" => "maRki",
"marquisat" => "maRkiza",
"marquisats" => "maRkiza",
"marquise" => "maRkiz",
"marquises" => "maRkiz",
"marquisien" => "maRkizj5",
"marquisiens" => "maRkizj5",
"marquons" => "maRk§",
"marra" => "maRa",
"marrade" => "maRad",
"marraient" => "maRE",
"marraine" => "maREn",
"marraines" => "maREn",
"marrais" => "maRE",
"marrait" => "maRE",
"marrane" => "maRan",
"marranes" => "maRan",
"marrant" => "maR@",
"marrante" => "maR@t",
"marrantes" => "maR@t",
"marrants" => "maR@",
"marre" => "maR",
"marré" => "maRe",
"marrée" => "maRe",
"marrent" => "maR",
"marrer" => "maRe",
"marrera" => "maR°Ra",
"marrerais" => "maR°RE",
"marrerait" => "maR°RE",
"marres" => "maR",
"marrés" => "maRe",
"marrez" => "maRe",
"marri" => "maRi",
"marrie" => "maRi",
"marrions" => "maRj§",
"marris" => "maRi",
"marron" => "maR§",
"marronnais" => "maRonE",
"marronnasse" => "maRonas",
"marronné" => "maRone",
"marronner" => "maRone",
"marronnera" => "maROn°Ra",
"marronnier" => "maRonje",
"marronniers" => "maRonje",
"marrons" => "maR§",
"mars" => "maRs",
"marsala" => "maRsala",
"marsaules" => "maRsol",
"marseillais" => "maRsEjE",
"marseillaise" => "maRsEjEz",
"marseillaises" => "maRsEjEz",
"marshal" => "maRSal",
"marshals" => "maRSal",
"marsouin" => "maRsw5",
"marsouins" => "maRsw5",
"marsupial" => "maRsypjal",
"marsupiaux" => "maRsypjo",
"marsupilami" => "maRsypilami",
"marsupilamis" => "maRsypilami",
"martagon" => "maRtag§",
"marteau" => "maRto",
"marteau-pilon" => "maRtopil§",
"marteau-piqueur" => "maRtopik9R",
"marteaux" => "maRto",
"marteaux-pilons" => "maRtopil§",
"martel" => "maRtEl",
"martela" => "maRt°la",
"martelage" => "maRt°laZ",
"martelai" => "maRt°lE",
"martelaient" => "maRt°lE",
"martelait" => "maRt°lE",
"martelant" => "maRt°l@",
"martèle" => "maRtEl",
"martelé" => "maRt°le",
"martelée" => "maRt°le",
"martelées" => "maRt°le",
"martèlement" => "maRtEl°m@",
"martèlements" => "maRtEl°m@",
"martèlent" => "maRtEl",
"marteler" => "maRt°le",
"martèlera" => "maRtEl°Ra",
"martelèrent" => "maRt°lER",
"martelés" => "maRt°le",
"martelet" => "maRt°lE",
"marteleur" => "maRt°l9R",
"martelez" => "maRt°le",
"martels" => "maRtEl",
"martial" => "maRsjal",
"martiale" => "maRsjal",
"martiales" => "maRsjal",
"martialités" => "maRsjalite",
"martiaux" => "maRsjo",
"martien" => "maRsj5",
"martienne" => "maRsjEn",
"martiennes" => "maRsjEn",
"martiens" => "maRsj5",
"martin" => "maRt5",
"martin-pêcheur" => "maRt5pES9R",
"martine" => "maRtin",
"martinet" => "maRtinE",
"martinets" => "maRtinE",
"martinez" => "maRtine",
"martingale" => "maRt5gal",
"martingales" => "maRt5gal",
"martini" => "maRtini",
"martiniquais" => "maRtinikE",
"martiniquaise" => "maRtinikEz",
"martiniquaises" => "maRtinikEz",
"martinis" => "maRtini",
"martins" => "maRt5",
"martins-pêcheurs" => "maRt5pES9R",
"martre" => "maRtR",
"martres" => "maRtR",
"martyr" => "maRtiR",
"martyre" => "maRtiR",
"martyres" => "maRtiR",
"martyrisaient" => "maRtiRizE",
"martyrisait" => "maRtiRizE",
"martyrisant" => "maRtiRiz@",
"martyrise" => "maRtiRiz",
"martyrisé" => "maRtiRize",
"martyrisée" => "maRtiRize",
"martyrisées" => "maRtiRize",
"martyrisent" => "maRtiRiz",
"martyriser" => "maRtiRize",
"martyriserait" => "maRtiRiz°RE",
"martyrisés" => "maRtiRize",
"martyrologe" => "maRtiRolOZ",
"martyrologes" => "maRtiRolOZ",
"martyrs" => "maRtiR",
"marxisme" => "maRksizm",
"marxisme-léninisme" => "maRksizm°leninizm",
"marxiste" => "maRksist",
"marxiste-léniniste" => "maRksist°leninist",
"marxistes" => "maRksist",
"marxistes-léninistes" => "maRksist°leninist",
"mary" => "maRi",
"maryland" => "maRil@d",
"mas" => "ma",
"masaï" => "masaj",
"mascara" => "maskaRa",
"mascarade" => "maskaRad",
"mascarades" => "maskaRad",
"mascaret" => "maskaRE",
"mascaron" => "maskaR§",
"mascarons" => "maskaR§",
"mascarpone" => "maskaRpOn",
"mascotte" => "maskOt",
"mascottes" => "maskOt",
"masculin" => "maskyl5",
"masculine" => "maskylin",
"masculines" => "maskylin",
"masculinisée" => "maskylinize",
"masculiniser" => "maskylinize",
"masculinité" => "maskylinite",
"masculins" => "maskyl5",
"maser" => "mazER",
"maskinongé" => "maskin§Ze",
"maso" => "mazo",
"masochisme" => "mazoSizm",
"masochiste" => "mazoSist",
"masochistes" => "mazoSist",
"masos" => "mazo",
"masqua" => "maska",
"masquage" => "maskaZ",
"masquages" => "maskaZ",
"masquaient" => "maskE",
"masquait" => "maskE",
"masquant" => "mask@",
"masque" => "mask",
"masqué" => "maske",
"masque-espion" => "maskEspj§",
"masquée" => "maske",
"masquées" => "maske",
"masquent" => "mask",
"masquer" => "maske",
"masqueraient" => "mask°RE",
"masques" => "mask",
"masqués" => "maske",
"masquons" => "mask§",
"mass media" => "masmedja",
"massa" => "masa",
"massacra" => "masakRa",
"massacraient" => "masakRE",
"massacrais" => "masakRE",
"massacrait" => "masakRE",
"massacrant" => "masakR@",
"massacrante" => "masakR@t",
"massacrât" => "masakRa",
"massacre" => "masakR",
"massacré" => "masakRe",
"massacrée" => "masakRe",
"massacrées" => "masakRe",
"massacrent" => "masakR",
"massacrer" => "masakRe",
"massacrera" => "masakR°Ra",
"massacrerai" => "masakR°RE",
"massacreraient" => "masakR°RE",
"massacrerait" => "masakR°RE",
"massacrèrent" => "masakRER",
"massacrerons" => "masakR°R§",
"massacreront" => "masakR°R§",
"massacres" => "masakR",
"massacrés" => "masakRe",
"massacreur" => "masakR9R",
"massacreurs" => "masakR9R",
"massacrez" => "masakRe",
"massacrons" => "masakR§",
"massage" => "masaZ",
"massages" => "masaZ",
"massaient" => "masE",
"massais" => "masE",
"massait" => "masE",
"massant" => "mas@",
"masse" => "mas",
"massé" => "mase",
"massée" => "mase",
"massées" => "mase",
"massent" => "mas",
"massepain" => "masp5",
"massepains" => "masp5",
"masser" => "mase",
"massera" => "mas°Ra",
"masserai" => "mas°RE",
"masseraient" => "mas°RE",
"masserais" => "mas°RE",
"masseras" => "mas°Ra",
"massèrent" => "masER",
"masserez" => "mas°Re",
"masses" => "mas",
"massés" => "mase",
"massettes" => "masEt",
"masseur" => "mas9R",
"masseurs" => "mas9R",
"masseuse" => "mas2z",
"masseuses" => "mas2z",
"massez" => "mase",
"massicot" => "masiko",
"massicoté" => "masikote",
"massicoter" => "masikote",
"massicotier" => "masikotje",
"massicots" => "masiko",
"massif" => "masif",
"massifs" => "masif",
"massive" => "masiv",
"massivement" => "masiv°m@",
"massives" => "masiv",
"massivité" => "masivite",
"massue" => "masy",
"massues" => "masy",
"mastaba" => "mastaba",
"mastabas" => "mastaba",
"mastar" => "mastaR",
"mastard" => "mastaR",
"mastards" => "mastaR",
"mastectomie" => "mastEktomi",
"master" => "mast9R",
"mastère" => "mastER",
"masters" => "mast9R",
"mastic" => "mastik",
"masticage" => "mastikaZ",
"masticateurs" => "mastikat9R",
"mastication" => "mastikasj§",
"mastications" => "mastikasj§",
"mastiff" => "mastif",
"mastiqua" => "mastika",
"mastiquaient" => "mastikE",
"mastiquais" => "mastikE",
"mastiquait" => "mastikE",
"mastiquant" => "mastik@",
"mastique" => "mastik",
"mastiqué" => "mastike",
"mastiquent" => "mastik",
"mastiquer" => "mastike",
"mastiqués" => "mastike",
"mastiquez" => "mastike",
"mastiquons" => "mastik§",
"mastite" => "mastit",
"mastoc" => "mastOk",
"mastodonte" => "mastod§t",
"mastodontes" => "mastod§t",
"mastoïde" => "mastoid",
"mastroquet" => "mastRokE",
"mastroquets" => "mastRokE",
"masturbais" => "mastyRbE",
"masturbait" => "mastyRbE",
"masturbant" => "mastyRb@",
"masturbateur" => "mastyRbat9R",
"masturbation" => "mastyRbasj§",
"masturbations" => "mastyRbasj§",
"masturbatoire" => "mastyRbatwaR",
"masturbatoires" => "mastyRbatwaR",
"masturbe" => "mastyRb",
"masturbé" => "mastyRbe",
"masturbée" => "mastyRbe",
"masturbent" => "mastyRb",
"masturber" => "mastyRbe",
"masturberas" => "mastyRb°Ra",
"masturbés" => "mastyRbe",
"masturbez" => "mastyRbe",
"masure" => "mazyR",
"masures" => "mazyR",
"mat" => "mat",
"mât" => "ma",
"mat'" => "mat",
"mata" => "mata",
"matador" => "matadOR",
"matadors" => "matadOR",
"mataf" => "mataf",
"matafs" => "mataf",
"mataient" => "matE",
"matais" => "matE",
"matait" => "matE",
"matamore" => "matamOR",
"matamores" => "matamOR",
"matant" => "mat@",
"match" => "matS",
"matcha" => "matSa",
"matche" => "matS",
"matches" => "matS",
"matchiche" => "matSiS",
"matchs" => "matS",
"mate" => "mat",
"mâte" => "mat",
"maté" => "mate",
"matée" => "mate",
"mâtée" => "mate",
"matées" => "mate",
"matelas" => "mat°la",
"matelassé" => "mat°lase",
"matelassée" => "mat°lase",
"matelassées" => "mat°lase",
"matelassent" => "mat°las",
"matelasser" => "mat°lase",
"matelassés" => "mat°lase",
"matelassier" => "mat°lasje",
"matelassière" => "mat°lasjER",
"matelassières" => "mat°lasjER",
"matelassiers" => "mat°lasje",
"matelot" => "mat°lo",
"matelote" => "mat°lOt",
"matelots" => "mat°lo",
"matent" => "mat",
"mater" => "mate",
"mâter" => "mate",
"mater dolorosa" => "matERdoloRoza",
"matera" => "mat°Ra",
"materai" => "mat°RE",
"materais" => "mat°RE",
"materait" => "mat°RE",
"matèrent" => "matER",
"matérialisa" => "mateRjaliza",
"matérialisaient" => "mateRjalizE",
"matérialisait" => "mateRjalizE",
"matérialisant" => "mateRjaliz@",
"matérialisation" => "mateRjalizasj§",
"matérialisations" => "mateRjalizasj§",
"matérialise" => "mateRjaliz",
"matérialisé" => "mateRjalize",
"matérialisée" => "mateRjalize",
"matérialisées" => "mateRjalize",
"matérialisent" => "mateRjaliz",
"matérialiser" => "mateRjalize",
"matérialisera" => "mateRjaliz°Ra",
"matérialisèrent" => "mateRjalizER",
"matérialiseront" => "mateRjaliz°R§",
"matérialisés" => "mateRjalize",
"matérialisions" => "mateRjalizj§",
"matérialisme" => "mateRjalizm",
"matérialiste" => "mateRjalist",
"matérialistes" => "mateRjalist",
"matérialité" => "mateRjalite",
"matériau" => "mateRjo",
"matériaux" => "mateRjo",
"matériel" => "mateRjEl",
"matérielle" => "mateRjEl",
"matériellement" => "mateRjEl°m@",
"matérielles" => "mateRjEl",
"matériels" => "mateRjEl",
"maternage" => "matERnaZ",
"maternalisme" => "matERnalizm",
"maternant" => "matERn@",
"materné" => "matERne",
"maternel" => "matERnEl",
"maternelle" => "matERnEl",
"maternellement" => "matERnEl°m@",
"maternelles" => "matERnEl",
"maternels" => "matERnEl",
"materner" => "matERne",
"maternera" => "matERn°Ra",
"maternisé" => "matERnize",
"materniser" => "matERnize",
"maternité" => "matERnite",
"maternités" => "matERnite",
"materons" => "mat°R§",
"materont" => "mat°R§",
"mates" => "mat",
"matés" => "mate",
"mateur" => "mat9R",
"mateurs" => "mat9R",
"mateuse" => "mat2z",
"matez" => "mate",
"math" => "mat",
"mathématicien" => "matematisj5",
"mathématicienne" => "matematisjEn",
"mathématiciens" => "matematisj5",
"mathématique" => "matematik",
"mathématiquement" => "matematik°m@",
"mathématiques" => "matematik",
"mathématiser" => "matematize",
"matheuse" => "mat2z",
"matheux" => "mat2",
"maths" => "mat",
"mathurins" => "matyR5",
"mathusalems" => "matyzalEm",
"mati" => "mati",
"matière" => "matjER",
"matières" => "matjER",
"matiez" => "matje",
"matin" => "mat5",
"mâtin" => "mat5",
"matinal" => "matinal",
"matinale" => "matinal",
"matinalement" => "matinal°m@",
"matinales" => "matinal",
"mâtinant" => "matin@",
"matinaux" => "matino",
"mâtine" => "matin",
"mâtiné" => "matine",
"matinée" => "matine",
"mâtinée" => "matine",
"matinées" => "matine",
"matines" => "matin",
"mâtines" => "matin",
"mâtinés" => "matine",
"matineux" => "matin2",
"matins" => "mat5",
"mâtins" => "mat5",
"matis" => "mati",
"matisse" => "matis",
"matité" => "matite",
"matois" => "matwa",
"matoise" => "matwaz",
"matoiserie" => "matwaz°Ri",
"maton" => "mat§",
"matonne" => "matOn",
"matonnes" => "matOn",
"matons" => "mat§",
"matos" => "matos",
"matou" => "matu",
"matous" => "matu",
"matouse" => "matuz",
"matouser" => "matuze",
"matraqua" => "matRaka",
"matraquage" => "matRakaZ",
"matraquages" => "matRakaZ",
"matraquaient" => "matRakE",
"matraquais" => "matRakE",
"matraquait" => "matRakE",
"matraquant" => "matRak@",
"matraque" => "matRak",
"matraqué" => "matRake",
"matraquée" => "matRake",
"matraquer" => "matRake",
"matraques" => "matRak",
"matraqués" => "matRake",
"matraqueur" => "matRak9R",
"matraqueurs" => "matRak9R",
"matraquez" => "matRake",
"matras" => "matRa",
"matriarcal" => "matRijaRkal",
"matriarcale" => "matRijaRkal",
"matriarcales" => "matRijaRkal",
"matriarcat" => "matRijaRka",
"matriarche" => "matRiaRS",
"matrice" => "matRis",
"matrices" => "matRis",
"matricide" => "matRisid",
"matriciel" => "matRisjEl",
"matricielle" => "matRisjEl",
"matricielles" => "matRisjEl",
"matriciels" => "matRisjEl",
"matriculaire" => "matRikylER",
"matricule" => "matRikyl",
"matricules" => "matRikyl",
"matrilinéaire" => "matRilineER",
"matrilinéaires" => "matRilineER",
"matrilocales" => "matRilokal",
"matrimonial" => "matRimonjal",
"matrimoniale" => "matRimonjal",
"matrimoniales" => "matRimonjal",
"matrimoniaux" => "matRimonjo",
"matriochka" => "matRiOSka",
"matrone" => "matROn",
"matrones" => "matROn",
"mats" => "mat",
"mâts" => "ma",
"matte" => "mat",
"matter" => "mate",
"mattes" => "mat",
"matuche" => "matyS",
"maturation" => "matyRasj§",
"maturations" => "matyRasj§",
"mature" => "matyR",
"mâture" => "matyR",
"maturer" => "matyRe",
"matures" => "matyR",
"mâtures" => "matyR",
"maturité" => "matyRite",
"matutinal" => "matytinal",
"matutinale" => "matytinal",
"matutinales" => "matytinal",
"matutinaux" => "matytino",
"maudira" => "modiRa",
"maudirai" => "modiRE",
"maudirais" => "modiRE",
"maudirait" => "modiRE",
"maudire" => "modiR",
"maudirent" => "modiR",
"maudirons" => "modiR§",
"maudiront" => "modiR§",
"maudis" => "modi",
"maudissaient" => "modisE",
"maudissais" => "modisE",
"maudissait" => "modisE",
"maudissant" => "modis@",
"maudisse" => "modis",
"maudissent" => "modis",
"maudissez" => "modise",
"maudissions" => "modisj§",
"maudit" => "modi",
"maudite" => "modit",
"maudites" => "modit",
"maudits" => "modi",
"maugréa" => "mogRea",
"maugréai" => "mogReE",
"maugréaient" => "mogReE",
"maugréait" => "mogReE",
"maugréant" => "mogRe@",
"maugrée" => "mogRe",
"maugréer" => "mogRee",
"maure" => "moR",
"maures" => "moR",
"mauresque" => "moREsk",
"mauresques" => "moREsk",
"mauricienne" => "moRisjEn",
"mauritanienne" => "moRitanjEn",
"maurrassien" => "moRasj5",
"maurrassisme" => "moRasizm",
"mauser" => "moz9R",
"mausers" => "mozER",
"mausolée" => "mozole",
"mausolées" => "mozole",
"maussade" => "mosad",
"maussadement" => "mosad°m@",
"maussaderie" => "mosad°Ri",
"maussaderies" => "mosad°Ri",
"maussades" => "mosad",
"mauvais" => "movE",
"mauvaise" => "movEz",
"mauvaisement" => "movEz°m@",
"mauvaises" => "movEz",
"mauvaiseté" => "movEz°te",
"mauve" => "mov",
"mauves" => "mov",
"mauviette" => "movjEt",
"mauviettes" => "movjEt",
"maux" => "mo",
"max" => "maks",
"maxi" => "maksi",
"maxillaire" => "maksilER",
"maxillaires" => "maksilER",
"maxillo-facial" => "maksilofasjal",
"maxima" => "maksima",
"maximal" => "maksimal",
"maximale" => "maksimal",
"maximales" => "maksimal",
"maximalise" => "maksimaliz",
"maximaliser" => "maksimalize",
"maximalisme" => "maksimalizm",
"maxime" => "maksim",
"maximes" => "maksim",
"maximisation" => "maksimizasj§",
"maximiser" => "maksimize",
"maximum" => "maksimOm",
"maximums" => "maksimOm",
"maxis" => "maksi",
"maxiton" => "maksit§",
"maya" => "maja",
"mayas" => "maja",
"mayo" => "majo",
"mayonnaise" => "majonEz",
"mayonnaises" => "majonEz",
"mazagran" => "mazagR@",
"mazagrans" => "mazagR@",
"mazas" => "maza",
"mazdéens" => "mazde5",
"maze" => "maz",
"mazé" => "maze",
"mazet" => "mazE",
"mazette" => "mazEt",
"mazettes" => "mazEt",
"mazout" => "mazut",
"mazouté" => "mazute",
"mazoutés" => "mazute",
"mazurka" => "mazyRka",
"mazurkas" => "mazyRka",
"me" => "m2",
"mea culpa" => "meakylpa",
"mea-culpa" => "meakylpa",
"méandre" => "me@dR",
"méandres" => "me@dR",
"méandreux" => "me@dR2",
"méandrine" => "me@dRin",
"méat" => "mea",
"mec" => "mEk",
"mécanicien" => "mekanisj5",
"mécanicienne" => "mekanisjEn",
"mécaniciennes" => "mekanisjEn",
"mécaniciens" => "mekanisj5",
"mécanique" => "mekanik",
"mécaniquement" => "mekanik°m@",
"mécaniques" => "mekanik",
"mécanisait" => "mekanizE",
"mécanisation" => "mekanizasj§",
"mécanise" => "mekaniz",
"mécanisé" => "mekanize",
"mécanisée" => "mekanize",
"mécanisées" => "mekanize",
"mécaniser" => "mekanize",
"mécanisés" => "mekanize",
"mécanisme" => "mekanizm",
"mécanismes" => "mekanizm",
"mécanistes" => "mekanist",
"mécano" => "mekano",
"mécanographiques" => "mekanogRafik",
"mécanos" => "mekano",
"meccano" => "mekano",
"meccanos" => "mekano",
"mécénat" => "mesena",
"mécène" => "mesEn",
"mécènes" => "mesEn",
"méchait" => "meSE",
"méchamment" => "meSam@",
"méchanceté" => "meS@s°te",
"méchancetés" => "meS@s°te",
"méchant" => "meS@",
"méchante" => "meS@t",
"méchantes" => "meS@t",
"méchants" => "meS@",
"mèche" => "mES",
"mécher" => "meSe",
"mèches" => "mES",
"méchoui" => "meSwi",
"méchouis" => "meSwi",
"mechta" => "mESta",
"mechtas" => "mESta",
"mecklembourgeois" => "mekl@buRZwa",
"mécompte" => "mek§t",
"mécomptes" => "mek§t",
"méconduite" => "mek§d8it",
"méconium" => "mekOnjOm",
"méconnais" => "mekonE",
"méconnaissable" => "mekonEsabl",
"méconnaissables" => "mekonEsabl",
"méconnaissais" => "mekonEsE",
"méconnaissance" => "mekonEs@s",
"méconnaissant" => "mekonEs@",
"méconnaisse" => "mekonEs",
"méconnaissent" => "mekonEs",
"méconnaîtra" => "mekonEtRa",
"méconnaître" => "mekonEtR",
"méconnu" => "mekony",
"méconnue" => "mekony",
"méconnues" => "mekony",
"méconnus" => "mekony",
"mécontent" => "mek§t@",
"mécontenta" => "mek§t@ta",
"mécontentait" => "mek§t@tE",
"mécontente" => "mek§t@t",
"mécontenté" => "mek§t@te",
"mécontentement" => "mek§t@t°m@",
"mécontentements" => "mek§t@t°m@",
"mécontenter" => "mek§t@te",
"mécontentes" => "mek§t@t",
"mécontentés" => "mek§t@te",
"mécontents" => "mek§t@",
"mécréance" => "mekRe@s",
"mécréant" => "mekRe@",
"mécréante" => "mekRe@t",
"mécréants" => "mekRe@",
"mécru" => "mekRy",
"mecs" => "mEk",
"mecton" => "mEkt§",
"mectons" => "mEkt§",
"médaille" => "medaj",
"médaillé" => "medaje",
"médaillée" => "medaje",
"médailles" => "medaj",
"médailleurs" => "medaj9R",
"médaillon" => "medaj§",
"médaillons" => "medaj§",
"médecin" => "mEds5",
"médecin-chef" => "mEds5SEf",
"médecin-conseil" => "mEds5k§sEj",
"médecin-général" => "mEds5ZeneRal",
"médecin-major" => "mEds5maZOR",
"médecine" => "mEdsin",
"médecine-ball" => "mEdsinbol",
"médecines" => "mEdsin",
"médecins" => "mEds5",
"media" => "medja",
"média" => "medja",
"médian" => "medj@",
"médiane" => "medjan",
"médianes" => "medjan",
"médianoche" => "medjanOS",
"médians" => "medj@",
"médias" => "medja",
"médiascope" => "medjaskOp",
"médiastin" => "medjast5",
"médiateur" => "medjat9R",
"médiateurs" => "medjat9R",
"médiation" => "medjasj§",
"médiatique" => "medjatik",
"médiatiques" => "medjatik",
"médiatisant" => "medjatiz@",
"médiatisation" => "medjatizasj§",
"médiatisé" => "medjatize",
"médiatisée" => "medjatize",
"médiatisées" => "medjatize",
"médiatisés" => "medjatize",
"médiator" => "medjatOR",
"médiatrice" => "medjatRis",
"médiatrices" => "medjatRis",
"médical" => "medikal",
"médicale" => "medikal",
"médicalement" => "medikal°m@",
"médicales" => "medikal",
"médicalisation" => "medikalizasj§",
"médicalisé" => "medikalize",
"médicalisée" => "medikalize",
"médicament" => "medikam@",
"médicamentait" => "medikam@tE",
"médicamentation" => "medikam@tasj§",
"médicamenté" => "medikam@te",
"médicamenter" => "medikam@te",
"médicamenteuse" => "medikam@t2z",
"médicamenteux" => "medikam@t2",
"médicaments" => "medikam@",
"médicastre" => "medikastR",
"médicastres" => "medikastR",
"médication" => "medikasj§",
"médications" => "medikasj§",
"médicaux" => "mediko",
"médicinal" => "medisinal",
"médicinale" => "medisinal",
"médicinales" => "medisinal",
"médicinaux" => "medisino",
"médicine" => "medisin",
"medicine-ball" => "medisinbOl",
"médico-légal" => "medikolegal",
"médico-légale" => "medikolegal",
"médico-légales" => "medikolegal",
"médico-légaux" => "medikOlego",
"médico-psychologique" => "medikopsikOlOZik",
"médico-social" => "medikososjal",
"médiéval" => "medjeval",
"médiévale" => "medjeval",
"médiévales" => "medjeval",
"médiévaux" => "medjevo",
"médiéviste" => "medjevist",
"médiévistes" => "medjevist",
"médina" => "medina",
"médinas" => "medina",
"médiocre" => "medjOkR",
"médiocrement" => "medjOkR°m@",
"médiocres" => "medjOkR",
"médiocrité" => "medjokRite",
"médiocrités" => "medjokRite",
"médire" => "mediR",
"médis" => "medi",
"médisaient" => "medizE",
"médisait" => "medizE",
"médisance" => "mediz@s",
"médisances" => "mediz@s",
"médisant" => "mediz@",
"médisante" => "mediz@t",
"médisants" => "mediz@",
"médise" => "mediz",
"médisent" => "mediz",
"médisez" => "medize",
"médisons" => "mediz§",
"médit" => "medi",
"médita" => "medita",
"méditai" => "meditE",
"méditaient" => "meditE",
"méditais" => "meditE",
"méditait" => "meditE",
"méditant" => "medit@",
"méditatif" => "meditatif",
"méditatifs" => "meditatif",
"méditation" => "meditasj§",
"méditations" => "meditasj§",
"méditative" => "meditativ",
"méditativement" => "meditativ°m@",
"méditatives" => "meditativ",
"médite" => "medit",
"médité" => "medite",
"méditée" => "medite",
"méditées" => "medite",
"méditent" => "medit",
"méditer" => "medite",
"méditera" => "medit°Ra",
"méditerait" => "medit°RE",
"méditeras" => "medit°Ra",
"méditèrent" => "meditER",
"méditerranée" => "meditERane",
"méditerranéen" => "meditERane5",
"méditerranéenne" => "meditERaneEn",
"méditerranéennes" => "meditERaneEn",
"méditerranéens" => "meditERane5",
"médites" => "medit",
"médités" => "medite",
"méditez" => "medite",
"méditiez" => "meditje",
"méditons" => "medit§",
"medium" => "medjOm",
"médium" => "medjOm",
"médiumnique" => "medjOmnik",
"médiumniques" => "medjOmnik",
"médiumnité" => "medjOmnite",
"médiums" => "medjOm",
"médius" => "medjys",
"médoc" => "medOk",
"médocs" => "medOk",
"médulla" => "medyla",
"médullaire" => "medylER",
"médusa" => "medyza",
"médusait" => "medyzE",
"médusant" => "medyz@",
"méduse" => "medyz",
"médusé" => "medyze",
"médusée" => "medyze",
"médusées" => "medyze",
"médusent" => "medyz",
"méduser" => "medyze",
"méduses" => "medyz",
"médusés" => "medyze",
"meeting" => "mitiG",
"meetings" => "mitiG",
"méfait" => "mefE",
"méfaits" => "mefE",
"méfiaient" => "mefjE",
"méfiais" => "mefjE",
"méfiait" => "mefjE",
"méfiance" => "mefj@s",
"méfiances" => "mefj@s",
"méfiant" => "mefj@",
"méfiante" => "mefj@t",
"méfiantes" => "mefj@t",
"méfiants" => "mefj@",
"méfie" => "mefi",
"méfié" => "mefje",
"méfiée" => "mefje",
"méfient" => "mefi",
"méfier" => "mefje",
"méfiera" => "mefiRa",
"méfierai" => "mefiRE",
"méfierais" => "mefiRE",
"méfierait" => "mefiRE",
"méfièrent" => "mefjER",
"méfieront" => "mefiR§",
"méfies" => "mefi",
"méfiés" => "mefje",
"méfiez" => "mefje",
"méfiions" => "mefij§",
"méfions" => "mefj§",
"méforme" => "mefORm",
"méga" => "mega",
"mégacôlon" => "megakol§",
"mégahertz" => "megaERts",
"mégajoules" => "megaZul",
"mégalithe" => "megalit",
"mégalithique" => "megalitik",
"mégalo" => "megalo",
"mégalomane" => "megaloman",
"mégalomanes" => "megaloman",
"mégalomaniaque" => "megalomanjak",
"mégalomanie" => "megalomani",
"mégalopole" => "megalOpOl",
"mégalos" => "megalo",
"mégalosaure" => "megalozoR",
"mégaphone" => "megafOn",
"mégaphones" => "megafOn",
"mégapole" => "megapOl",
"mégaron" => "megaR§",
"mégathériums" => "megateRjOm",
"mégatonne" => "megatOn",
"mégatonnes" => "megatOn",
"mégawatts" => "megawat",
"mégère" => "meZER",
"mégères" => "meZER",
"mégisserie" => "meZis°Ri",
"mégissiers" => "meZisje",
"mégot" => "mego",
"mégotage" => "megotaZ",
"mégotages" => "megotaZ",
"mégotaient" => "megotE",
"mégotait" => "megotE",
"mégote" => "megOt",
"mégoté" => "megote",
"mégoter" => "megote",
"mégots" => "mego",
"méhari" => "meaRi",
"méhariste" => "meaRist",
"méharistes" => "meaRist",
"meiji" => "mEZi",
"meilleur" => "mEj9R",
"meilleure" => "mEj9R",
"meilleures" => "mEj9R",
"meilleurs" => "mEj9R",
"méiose" => "mejoz",
"méjugé" => "meZyZe",
"méjugement" => "meZyZ°m@",
"méjugés" => "meZyZe",
"méjugez" => "meZyZe",
"mêla" => "mEla",
"mêlai" => "mElE",
"mêlaient" => "mElE",
"mêlais" => "mElE",
"mêlait" => "mElE",
"mélancolie" => "mel@koli",
"mélancolies" => "mel@koli",
"mélancolieux" => "mel@kolj2",
"mélancolique" => "mel@kolik",
"mélancoliquement" => "mel@kolik°m@",
"mélancoliques" => "mel@kolik",
"mélancoliser" => "mel@kolize",
"mélanésiennes" => "melanezjEn",
"mélange" => "mel@Z",
"mélangé" => "mel@Ze",
"mélangea" => "mel@Za",
"mélangeaient" => "mel@ZE",
"mélangeais" => "mel@ZE",
"mélangeait" => "mel@ZE",
"mélangeant" => "mel@Z@",
"mélangée" => "mel@Ze",
"mélangées" => "mel@Ze",
"mélangent" => "mel@Z",
"mélangeons" => "mel@Z§",
"mélanger" => "mel@Ze",
"mélangera" => "mel@Z°Ra",
"mélangerai" => "mel@Z°RE",
"mélangeraient" => "mel@Z°RE",
"mélangèrent" => "mel@ZER",
"mélanges" => "mel@Z",
"mélangés" => "mel@Ze",
"mélangeur" => "mel@Z9R",
"mélangeurs" => "mel@Z9R",
"mélangez" => "mel@Ze",
"mélangions" => "mel@Zj§",
"mélanine" => "melanin",
"mélanome" => "melanom",
"mélanomes" => "melanom",
"mêlant" => "mEl@",
"mélasse" => "melas",
"mêlasse" => "mElas",
"mêlât" => "mEla",
"mélatonine" => "melatonin",
"melba" => "mElba",
"mêle" => "mEl",
"mêlé" => "mele",
"mêlé-cass" => "mElekas",
"mêlé-casse" => "melekas",
"mêle-tout" => "mEltu",
"mêlécasse" => "mElekas",
"mêlée" => "mele",
"mêlées" => "mele",
"mêlent" => "mEl",
"mêler" => "mele",
"mêlera" => "mEl°Ra",
"mêlerai" => "mEl°RE",
"mêleraient" => "mEl°RE",
"mêlerais" => "mEl°RE",
"mêlerait" => "mEl°RE",
"mêlèrent" => "mElER",
"mêleront" => "mEl°R§",
"mêles" => "mEl",
"mêlés" => "mele",
"mêlez" => "mEle",
"mélèze" => "melEz",
"mélèzes" => "melEz",
"méli-mélo" => "melimelo",
"mêliez" => "mElje",
"mélilot" => "melilo",
"mélinite" => "melinit",
"mêlions" => "mElj§",
"mélis-mélos" => "melimelo",
"mélisse" => "melis",
"melkites" => "mElkit",
"mellifère" => "mElifER",
"mellifères" => "mElifER",
"melliflues" => "mElifly",
"mélo" => "melo",
"mélodie" => "melodi",
"mélodies" => "melodi",
"mélodieuse" => "melodj2z",
"mélodieusement" => "melodj2z°m@",
"mélodieuses" => "melodj2z",
"mélodieux" => "melodj2",
"mélodique" => "melodik",
"mélodiques" => "melodik",
"mélodramatique" => "melodRamatik",
"mélodramatiques" => "melodRamatik",
"mélodrame" => "melodRam",
"mélodrames" => "melodRam",
"mélomane" => "meloman",
"mélomanes" => "meloman",
"melon" => "m°l§",
"melons" => "m°l§",
"mêlons" => "mEl§",
"mélopée" => "melope",
"mélopées" => "melope",
"mélos" => "melo",
"melting pot" => "mEltiGpOt",
"melting-pot" => "mEltiGpOt",
"membranaire" => "m@bRanER",
"membrane" => "m@bRan",
"membranes" => "m@bRan",
"membraneuse" => "m@bRan2z",
"membraneuses" => "m@bRan2z",
"membraneux" => "m@bRan2",
"membre" => "m@bR",
"membré" => "m@bRe",
"membres" => "m@bR",
"membrues" => "m@bRy",
"membrure" => "m@bRyR",
"membrures" => "m@bRyR",
"même" => "mEm",
"mémé" => "meme",
"mêmement" => "mEm°m@",
"mémentos" => "mem5to",
"mémère" => "memER",
"mémères" => "memER",
"mêmes" => "mEm",
"mémés" => "meme",
"mémo" => "memo",
"mémoire" => "memwaR",
"mémoires" => "memwaR",
"mémorabilité" => "memoRabilite",
"mémorable" => "memoRabl",
"mémorables" => "memoRabl",
"mémorandum" => "memoR@dOm",
"mémorandums" => "memoR@dOm",
"mémorial" => "memoRjal",
"mémorialiste" => "memoRjalist",
"mémorialistes" => "memoRjalist",
"mémoriaux" => "memoRjo",
"mémoriel" => "memoRjEl",
"mémorielle" => "memoRjEl",
"mémoriels" => "memoRjEl",
"mémorisables" => "memoRizabl",
"mémorisaient" => "memoRizE",
"mémorisait" => "memoRizE",
"mémorisation" => "memoRizasj§",
"mémorise" => "memoRiz",
"mémorisé" => "memORize",
"mémorisée" => "memoRize",
"mémorisées" => "memoRize",
"mémorisent" => "memoRiz",
"mémoriser" => "memoRize",
"mémoriserai" => "memoRiz°RE",
"mémoriserais" => "memoRiz°RE",
"mémorisés" => "memoRize",
"mémorisez" => "memoRize",
"mémorisiez" => "memoRizje",
"mémos" => "memo",
"mena" => "m°na",
"menaça" => "m°nasa",
"menaçaient" => "m°nasE",
"menaçais" => "m°nasE",
"menaçait" => "m°nasE",
"menaçant" => "m°nas@",
"menaçante" => "m°nas@t",
"menaçantes" => "m°nas@t",
"menaçants" => "m°nas@",
"menaçât" => "m°nasa",
"menace" => "m°nas",
"menacé" => "m°nase",
"menacée" => "m°nase",
"menacées" => "m°nase",
"menacent" => "m°nas",
"menacer" => "m°nase",
"menacera" => "m°nas°Ra",
"menaceraient" => "m°nas°RE",
"menacerait" => "m°nas°RE",
"menaceras" => "m°nas°Ra",
"menacèrent" => "m°nasER",
"menaceriez" => "m°nas°Rje",
"menaceront" => "m°nas°R§",
"menaces" => "m°nas",
"menacés" => "m°nase",
"menacez" => "m°nase",
"menaciez" => "m°nasje",
"menacions" => "m°nasj§",
"menaçons" => "m°nas§",
"ménade" => "menad",
"ménades" => "menad",
"ménage" => "menaZ",
"ménagé" => "menaZe",
"ménagea" => "menaZa",
"ménageaient" => "menaZE",
"ménageais" => "menaZE",
"ménageait" => "menaZE",
"ménageant" => "menaZ@",
"ménageât" => "menaZa",
"ménagée" => "menaZe",
"ménagées" => "menaZe",
"ménagement" => "menaZ°m@",
"ménagements" => "menaZ°m@",
"ménagent" => "menaZ",
"ménager" => "menaZe",
"ménagera" => "menaZ°Ra",
"ménagerai" => "menaZ°RE",
"ménagerait" => "menaZ°RE",
"ménageras" => "menaZ°Ra",
"ménagère" => "menaZER",
"ménagèrent" => "menaZER",
"ménagères" => "menaZER",
"ménagerie" => "menaZ°Ri",
"ménageries" => "menaZ°Ri",
"ménagers" => "menaZe",
"ménages" => "menaZ",
"ménagés" => "menaZe",
"ménagez" => "menaZe",
"ménagiez" => "menaZje",
"ménagions" => "menaZj§",
"menai" => "m°nE",
"menaient" => "m°nE",
"menais" => "m°nE",
"menait" => "m°nE",
"menant" => "m°n@",
"menassent" => "m°nas",
"menât" => "m°na",
"mencheviks" => "mEnSevik",
"mendé" => "m@de",
"mendia" => "m@dja",
"mendiaient" => "m@djE",
"mendiais" => "m@djE",
"mendiait" => "m@djE",
"mendiant" => "m@dj@",
"mendiante" => "m@dj@t",
"mendiantes" => "m@dj@t",
"mendiants" => "m@dj@",
"mendicité" => "m@disite",
"mendicités" => "m@disite",
"mendie" => "m@di",
"mendié" => "m@dje",
"mendiée" => "m@dje",
"mendiées" => "m@dje",
"mendient" => "m@di",
"mendier" => "m@dje",
"mendierait" => "m@diRE",
"mendieras" => "m@diRa",
"mendies" => "m@di",
"mendiez" => "m@dje",
"mendigot" => "m@digo",
"mendigotant" => "m@digot@",
"mendigote" => "m@digOt",
"mendigoter" => "m@digote",
"mendigots" => "m@digo",
"mendions" => "m@dj§",
"mène" => "mEn",
"mené" => "m°ne",
"meneau" => "m°no",
"meneaux" => "m°no",
"menée" => "m°ne",
"menées" => "m°ne",
"mènent" => "mEn",
"mener" => "m°ne",
"mènera" => "mEn°Ra",
"mènerai" => "mEn°RE",
"mèneraient" => "mEn°RE",
"mènerais" => "mEn°RE",
"mènerait" => "mEn°RE",
"mèneras" => "mEn°Ra",
"menèrent" => "m°nER",
"mènerez" => "mEn°Re",
"mènerons" => "mEn°R§",
"mèneront" => "mEn°R§",
"mènes" => "mEn",
"menés" => "m°ne",
"ménesse" => "menEs",
"ménestrel" => "menEstREl",
"ménestrels" => "menEstREl",
"meneur" => "m°n9R",
"meneurs" => "m°n9R",
"meneuse" => "m°n2z",
"menez" => "m°ne",
"menhaden" => "mEnad°n",
"menhir" => "meniR",
"menhirs" => "meniR",
"meniez" => "m°nje",
"méningée" => "men5Ze",
"méninges" => "men5Z",
"méningiome" => "men5Zjom",
"méningite" => "men5Zit",
"méningites" => "men5Zit",
"méningocoque" => "men5gOkOk",
"menions" => "m°nj§",
"ménisque" => "menisk",
"ménisques" => "menisk",
"mennonite" => "menonit",
"mennonites" => "menonit",
"menon" => "m2n§",
"menons" => "m°n§",
"ménopause" => "menopoz",
"ménopausé" => "menopoze",
"ménopausée" => "menopoze",
"ménopausées" => "menopoze",
"menora" => "menoRa",
"menotte" => "m°nOt",
"menotté" => "m°note",
"menottée" => "m°note",
"menotter" => "m°note",
"menottes" => "m°nOt",
"menottés" => "m°note",
"menottez" => "m°note",
"mens" => "m@",
"mensonge" => "m@s§Z",
"mensonger" => "m@s§Ze",
"mensongère" => "m@s§ZER",
"mensongèrement" => "m@s§ZER°m@",
"mensongères" => "m@s§ZER",
"mensongers" => "m@s§Ze",
"mensonges" => "m@s§Z",
"menstruation" => "m@stRyasj§",
"menstruations" => "m@stRyasj§",
"menstruel" => "m@stRyEl",
"menstruelle" => "m@stRyEl",
"menstruelles" => "m@stRyEl",
"menstruels" => "m@stR8El",
"menstrues" => "m@stRy",
"mensualité" => "m@s8alite",
"mensualités" => "m@s8alite",
"mensuel" => "m@s8El",
"mensuelle" => "m@s8El",
"mensuellement" => "m@s8El°m@",
"mensuelles" => "m@s8El",
"mensuels" => "m@s8El",
"mensuration" => "m@syRasj§",
"mensurations" => "m@syRasj§",
"ment" => "m@",
"mentaient" => "m@tE",
"mentais" => "m@tE",
"mentait" => "m@tE",
"mental" => "m@tal",
"mentale" => "m@tal",
"mentalement" => "m@tal°m@",
"mentales" => "m@tal",
"mentaliser" => "m@talize",
"mentalité" => "m@talite",
"mentalités" => "m@talite",
"mentant" => "m@t@",
"mentaux" => "m@to",
"mente" => "m@t",
"mentent" => "m@t",
"menterie" => "m@t°Ri",
"menteries" => "m@t°Ri",
"mentes" => "m@t",
"menteur" => "m@t9R",
"menteurs" => "m@t9R",
"menteuse" => "m@t2z",
"menteuses" => "m@t2z",
"mentez" => "m@te",
"menthe" => "m@t",
"menthes" => "m@t",
"menthol" => "m@tOl",
"mentholé" => "m@tole",
"mentholée" => "m@tole",
"mentholées" => "m@tole",
"mentholés" => "m@tole",
"menthols" => "m@tOl",
"menti" => "m@ti",
"mentiez" => "m@tje",
"mention" => "m@sj§",
"mentionna" => "m@sjona",
"mentionnai" => "m@sjonE",
"mentionnaient" => "m@sjonE",
"mentionnais" => "m@sjonE",
"mentionnait" => "m@sjonE",
"mentionnant" => "m@sjon@",
"mentionnât" => "m@sjona",
"mentionne" => "m@sjOn",
"mentionné" => "m@sjone",
"mentionnée" => "m@sjone",
"mentionnées" => "m@sjone",
"mentionnent" => "m@sjOn",
"mentionner" => "m@sjone",
"mentionnerai" => "m@sjOn°RE",
"mentionnerais" => "m@sjOn°RE",
"mentionnerait" => "m@sjOn°RE",
"mentionneras" => "m@sjOn°Ra",
"mentionnerez" => "m@sjOn°Re",
"mentionnes" => "m@sjOn",
"mentionnés" => "m@sjone",
"mentionnez" => "m@sjone",
"mentionniez" => "m@sjonje",
"mentionnons" => "m@sjon§",
"mentions" => "m@sj§",
"mentir" => "m@tiR",
"mentira" => "m@tiRa",
"mentirai" => "m@tiRE",
"mentiraient" => "m@tiRE",
"mentirais" => "m@tiRE",
"mentirait" => "m@tiRE",
"mentiras" => "m@tiRa",
"mentirez" => "m@tiRe",
"mentiriez" => "m@tiRje",
"mentirons" => "m@tiR§",
"mentiront" => "m@tiR§",
"mentis" => "m@ti",
"mentissent" => "m@tis",
"mentit" => "m@ti",
"mentît" => "m@ti",
"menton" => "m@t§",
"mentonnet" => "m@tonE",
"mentonnier" => "m@tonje",
"mentonnière" => "m@tonjER",
"mentons" => "m@t§",
"mentor" => "m5tOR",
"mentors" => "m5tOR",
"mentule" => "m@tyl",
"menu" => "m°ny",
"menue" => "m°ny",
"menues" => "m°ny",
"menuet" => "m°n8E",
"menuets" => "m2nyE",
"menuise" => "m2n8iz",
"menuiser" => "m2n8ize",
"menuisera" => "m2n8iz°Ra",
"menuiserie" => "m2n8iz°Ri",
"menuisier" => "m2n8izje",
"menuisiers" => "m2n8izje",
"menus" => "m°ny",
"méphistophélique" => "mefistofelik",
"méphistophéliques" => "mefistofelik",
"méphitique" => "mefitik",
"méphitiques" => "mefitik",
"méplat" => "mepla",
"méplats" => "mepla",
"méprenais" => "mepR°nE",
"méprenait" => "mepR°nE",
"méprenant" => "mepR°n@",
"méprend" => "mepR@",
"méprendre" => "mepR@dR",
"méprendriez" => "mepR@dRije",
"méprends" => "mepR@",
"méprenez" => "mepR°ne",
"mépreniez" => "mepR°nje",
"méprenne" => "mepREn",
"méprennent" => "mepREn",
"mépris" => "mepRi",
"méprisa" => "mepRiza",
"méprisable" => "mepRizabl",
"méprisables" => "mepRizabl",
"méprisai" => "mepRizE",
"méprisaient" => "mepRizE",
"méprisais" => "mepRizE",
"méprisait" => "mepRizE",
"méprisamment" => "mepRizam@",
"méprisant" => "mepRiz@",
"méprisante" => "mepRiz@t",
"méprisantes" => "mepRiz@t",
"méprisants" => "mepRiz@",
"méprise" => "mepRiz",
"méprisé" => "mepRize",
"méprisée" => "mepRize",
"méprisées" => "mepRize",
"méprisent" => "mepRiz",
"mépriser" => "mepRize",
"méprisera" => "mepRiz°Ra",
"mépriserai" => "mepRiz°RE",
"mépriseraient" => "mepRiz°RE",
"mépriserais" => "mepRiz°RE",
"mépriserait" => "mepRiz°RE",
"mépriseras" => "mepRiz°Ra",
"mépriseriez" => "mepRiz°Rje",
"méprises" => "mepRiz",
"méprisés" => "mepRize",
"méprisez" => "mepRize",
"méprisiez" => "mepRizje",
"méprisions" => "mepRizj§",
"méprisons" => "mepRiz§",
"méprit" => "mepRi",
"méprît" => "mepRi",
"mer" => "mER",
"mer-air" => "mERER",
"mercanti" => "mERk@ti",
"mercantile" => "mERk@til",
"mercantiles" => "mERk@til",
"mercantilisme" => "mERk@tilizm",
"mercantis" => "mERk@ti",
"mercaptan" => "mERkapt@",
"mercenaire" => "mERs°nER",
"mercenaires" => "mERs°nER",
"mercerie" => "mERs°Ri",
"merceries" => "mERs°Ri",
"mercerisé" => "mERs°Rize",
"merchandising" => "mERtS@diziG",
"merci" => "mERsi",
"mercier" => "mERsje",
"mercière" => "mERsjER",
"mercières" => "mERsjER",
"merciers" => "mERsje",
"mercis" => "mERsi",
"mercredi" => "mERkR°di",
"mercredis" => "mERkR°di",
"mercure" => "mERkyR",
"mercurey" => "mERkyRE",
"mercuriale" => "mERkyRjal",
"mercuriales" => "mERkyRjal",
"mercurochrome" => "mERkyRokRom",
"merda" => "mERda",
"merdait" => "mERdE",
"merdasse" => "mERdas",
"merde" => "mERd",
"merdé" => "mERde",
"merdée" => "mERde",
"merdent" => "mERd",
"merder" => "mERde",
"merderai" => "mERd°RE",
"merdes" => "mERd",
"merdeuse" => "mERd2z",
"merdeuses" => "mERd2z",
"merdeux" => "mERd2",
"merdez" => "mERde",
"merdier" => "mERdje",
"merdiers" => "mERdje",
"merdique" => "mERdik",
"merdiques" => "mERdik",
"merdoie" => "mERdwa",
"merdouille" => "mERduj",
"merdouillé" => "mERduje",
"merdoyait" => "mERdwajE",
"merdre" => "mERdR",
"mère" => "mER",
"mère-grand" => "mERgR@",
"mère-patrie" => "mERpatRi",
"mères" => "mER",
"merguez" => "mERgEz",
"méridien" => "meRidj5",
"méridienne" => "meRidjEn",
"méridiennes" => "meRidjEn",
"méridiens" => "meRidj5",
"méridional" => "meRidjonal",
"méridionale" => "meRidjonal",
"méridionales" => "meRidjonal",
"méridionaux" => "meRidjono",
"meringue" => "m°R5g",
"meringué" => "m°R5ge",
"meringuée" => "m°R5ge",
"meringuées" => "m°R5ge",
"meringues" => "m°R5g",
"mérinos" => "meRinos",
"merise" => "m°Riz",
"merises" => "m°Riz",
"merisier" => "m°Rizje",
"merisiers" => "m°Rizje",
"mérita" => "meRita",
"méritaient" => "meRitE",
"méritais" => "meRitE",
"méritait" => "meRitE",
"méritant" => "meRit@",
"méritante" => "meRit@t",
"méritantes" => "meRit@t",
"méritants" => "meRit@",
"méritassent" => "meRitas",
"méritât" => "meRita",
"mérite" => "meRit",
"mérité" => "meRite",
"méritée" => "meRite",
"méritées" => "meRite",
"méritent" => "meRit",
"mériter" => "meRite",
"méritera" => "meRit°Ra",
"mériterai" => "meRit°RE",
"mériteraient" => "meRit°RE",
"mériterais" => "meRit°RE",
"mériterait" => "meRit°RE",
"mériteras" => "meRit°Ra",
"mériteriez" => "meRit°Rje",
"mériteront" => "meRit°R§",
"mérites" => "meRit",
"mérités" => "meRite",
"méritez" => "meRite",
"méritiez" => "meRitje",
"méritions" => "meRitj§",
"méritocratie" => "meRitOkRasi",
"méritoire" => "meRitwaR",
"méritoires" => "meRitwaR",
"méritons" => "meRit§",
"merl" => "mERl",
"merlan" => "mERl@",
"merlans" => "mERl@",
"merle" => "mERl",
"merleau" => "mERlo",
"merles" => "mERl",
"merlette" => "mERlEt",
"merlin" => "mERl5",
"merlot" => "mERlo",
"merlu" => "mERly",
"merluche" => "mERlyS",
"merluches" => "mERlyS",
"mérou" => "meRu",
"mérovingien" => "meRov5Zj5",
"mérovingienne" => "meRov5ZjEn",
"mérovingiennes" => "meRov5ZjEn",
"merrain" => "mER5",
"merrains" => "mER5",
"mers" => "mER",
"merveille" => "mERvEj",
"merveilles" => "mERvEj",
"merveilleuse" => "mERvEj2z",
"merveilleusement" => "mERvEj2z°m@",
"merveilleuses" => "mERvEj2z",
"merveilleux" => "mERvEj2",
"merveillosité" => "mERvEjozite",
"mes" => "me",
"mesa" => "meza",
"mésalliance" => "mezalj@s",
"mésalliances" => "mezalj@s",
"mésallieras" => "mezalijRa",
"mésallies" => "mezalij",
"mésalliés" => "mezalje",
"mésange" => "mez@Z",
"mésanges" => "mez@Z",
"mésaventure" => "mezav@tyR",
"mésaventures" => "mezav@tyR",
"mescal" => "mEskal",
"mescaline" => "mEskalin",
"mesclun" => "mEskl1",
"mesdames" => "mEdam",
"mesdemoiselles" => "mEd°mwazEl",
"mésencéphale" => "mez@sefal",
"mésentente" => "mez@t@t",
"mésententes" => "mez@t@t",
"mésentère" => "mez@tER",
"mésentérique" => "mez@teRik",
"mésestimant" => "mezEstim@",
"mésestime" => "mezEstim",
"mésestimé" => "mezEstime",
"mésestimer" => "mezEstime",
"mésestimez" => "mezEstime",
"mésintelligence" => "mez5teliZ@s",
"mésinterpréter" => "mez5tERpRete",
"mesmérisme" => "mEsmeRizm",
"mesnils" => "mEsnil",
"mésodermiques" => "mezodERmik",
"mésomorphe" => "mezomORf",
"mésomorphique" => "mezomORfik",
"méson" => "mez§",
"mésons" => "mez§",
"mésopotamien" => "mezopotamj5",
"mésopotamienne" => "mezopotamjEn",
"mésopotamiens" => "mezopotamj5",
"mésosphère" => "mezosfER",
"mésozoïque" => "mezozoik",
"mesquin" => "mEsk5",
"mesquine" => "mEskin",
"mesquinement" => "mEskin°m@",
"mesquinerie" => "mEskin°Ri",
"mesquineries" => "mEskin°Ri",
"mesquines" => "mEskin",
"mesquins" => "mEsk5",
"mess" => "mEs",
"message" => "mesaZ",
"messager" => "mesaZe",
"messagère" => "mesaZER",
"messagères" => "mesaZER",
"messagerie" => "mesaZ°Ri",
"messageries" => "mesaZ°Ri",
"messagers" => "mesaZe",
"messages" => "mesaZ",
"messaliste" => "mEsalist",
"messalistes" => "mEsalist",
"messe" => "mEs",
"messéance" => "mese@s",
"messeigneurs" => "mEsEN9R",
"messer" => "mes9R",
"messes" => "mEs",
"messianique" => "mesjanik",
"messianiques" => "mesjanik",
"messianisme" => "mesjanizm",
"messidor" => "mesidOR",
"messie" => "mesi",
"messies" => "mesi",
"messieurs" => "mesj2",
"messieurs-dames" => "mEsj2dam",
"messine" => "mesin",
"messire" => "mesiR",
"messires" => "mesiR",
"mestre" => "mEstR",
"mesura" => "m°zyRa",
"mesurable" => "m°zyRabl",
"mesurables" => "m°zyRabl",
"mesurai" => "m°zyRE",
"mesuraient" => "m°zyRE",
"mesurais" => "m°zyRE",
"mesurait" => "m°zyRE",
"mesurant" => "m°zyR@",
"mesurassent" => "m°zyRas",
"mesurât" => "m°zyRa",
"mesure" => "m°zyR",
"mesuré" => "m°zyRe",
"mesurée" => "m°zyRe",
"mesurées" => "m°zyRe",
"mesurent" => "m°zyR",
"mesurer" => "m°zyRe",
"mesurera" => "m°zyR°Ra",
"mesurerait" => "m°zyR°RE",
"mesurèrent" => "m°zyRER",
"mesurerez" => "m°zyR°Re",
"mesurerons" => "m°zyR°R§",
"mesureront" => "m°zyR°R§",
"mesures" => "m°zyR",
"mesurés" => "m°zyRe",
"mesurette" => "m2zyREt",
"mesureur" => "m°zyR9R",
"mesurez" => "m°zyRe",
"mesuriez" => "m°zyRje",
"mesurions" => "m°zyRj§",
"mesurons" => "m°zyR§",
"mésusage" => "mezyzaZ",
"mésuser" => "mezyze",
"met" => "mE",
"méta" => "meta",
"métabolique" => "metabolik",
"métaboliser" => "metabolize",
"métabolisme" => "metabolizm",
"métabolismes" => "metabolizm",
"métabolite" => "metabOlit",
"métacarpe" => "metakaRp",
"métacarpien" => "metakaRpj5",
"métacarpiens" => "metakaRpj5",
"métairie" => "meteRi",
"métairies" => "meteRi",
"métal" => "metal",
"métallique" => "metalik",
"métalliques" => "metalik",
"métallisation" => "metalizasj§",
"métallise" => "metaliz",
"métallisé" => "metalize",
"métallisée" => "metalize",
"métallisées" => "metalize",
"métallisent" => "metaliz",
"métallisés" => "metalize",
"métallo" => "metalo",
"métallographie" => "metalogRafi",
"métallos" => "metalo",
"métallurgie" => "metalyRZi",
"métallurgique" => "metalyRZik",
"métallurgiques" => "metalyRZik",
"métallurgiste" => "metalyRZist",
"métallurgistes" => "metalyRZist",
"métamorphique" => "metamORfik",
"métamorphosa" => "metamORfoza",
"métamorphosaient" => "metamORfozE",
"métamorphosait" => "metamORfozE",
"métamorphosant" => "metamORfoz@",
"métamorphosât" => "metamORfoza",
"métamorphose" => "metamORfoz",
"métamorphosé" => "metamORfoze",
"métamorphosée" => "metamORfoze",
"métamorphosées" => "metamORfoze",
"métamorphosent" => "metamORfoz",
"métamorphoser" => "metamORfoze",
"métamorphoseraient" => "metamORfoz°RE",
"métamorphoserait" => "metamORfoz°RE",
"métamorphosèrent" => "metamORfozER",
"métamorphoses" => "metamORfoz",
"métamorphosés" => "metamORfoze",
"métamorphosez" => "metamORfoze",
"métamorphosions" => "metamORfozj§",
"métaphase" => "metafaz",
"métaphore" => "metafOR",
"métaphores" => "metafOR",
"métaphorique" => "metafoRik",
"métaphoriquement" => "metafoRik°m@",
"métaphoriques" => "metafoRik",
"métaphysicien" => "metafizisj5",
"métaphysicienne" => "metafizisjEn",
"métaphysiciens" => "metafizisj5",
"métaphysique" => "metafizik",
"métaphysiquement" => "metafizik°m@",
"métaphysiques" => "metafizik",
"métapsychique" => "metapsiSik",
"métapsychologie" => "metapsikoloZi",
"métapsychologique" => "metapsikoloZik",
"métastase" => "metastaz",
"métastasé" => "metastaze",
"métastases" => "metastaz",
"métastatique" => "metastatik",
"métatarses" => "metataRs",
"métatarsienne" => "metataRsjEn",
"métaux" => "meto",
"métayage" => "metEjaZ",
"métayer" => "meteje",
"métayers" => "meteje",
"métazoaires" => "metazoER",
"métempsychose" => "met@psikoz",
"métempsycose" => "met@psikoz",
"météo" => "meteo",
"météore" => "meteOR",
"météores" => "meteOR",
"météorique" => "meteoRik",
"météoriquement" => "meteoRik°m@",
"météorite" => "meteoRit",
"météorites" => "meteoRit",
"météoritique" => "meteoRitik",
"météorologie" => "meteoRoloZi",
"météorologique" => "meteoRoloZik",
"météorologiques" => "meteoRoloZik",
"météorologiste" => "meteoRoloZist",
"météorologue" => "meteoRolOg",
"météorologues" => "meteoRolOg",
"métèque" => "metEk",
"métèques" => "metEk",
"méthacrylate" => "metakRilat",
"méthadone" => "metadOn",
"méthanal" => "metanal",
"méthane" => "metan",
"méthanol" => "metanOl",
"méthédrine" => "metedRin",
"méthode" => "metOd",
"méthodes" => "metOd",
"méthodique" => "metodik",
"méthodiquement" => "metodik°m@",
"méthodiques" => "metodik",
"méthodisme" => "metodizm",
"méthodiste" => "metodist",
"méthodistes" => "metodist",
"méthodologie" => "metodoloZi",
"méthodologique" => "metodoloZik",
"méthyle" => "metil",
"méthylène" => "metilEn",
"méthylique" => "metilik",
"méticuleuse" => "metikyl2z",
"méticuleusement" => "metikyl2z°m@",
"méticuleuses" => "metikyl2z",
"méticuleux" => "metikyl2",
"méticulosité" => "metikylozite",
"métier" => "metje",
"métiers" => "metje",
"métingue" => "met5g",
"métis" => "metis",
"métissage" => "metisaZ",
"métissages" => "metisaZ",
"métisse" => "metis",
"métissé" => "metise",
"métissée" => "metise",
"métisser" => "metise",
"métisses" => "metis",
"métissez" => "metise",
"métonymie" => "metonimi",
"métopes" => "metOp",
"métra" => "metRa",
"métrage" => "metRaZ",
"métrages" => "metRaZ",
"métras" => "metRa",
"mètre" => "mEtR",
"mètres" => "mEtR",
"métreur" => "metR9R",
"métrique" => "metRik",
"métriques" => "metRik",
"métrite" => "metRit",
"métrites" => "metRit",
"métro" => "metRo",
"métronome" => "metRonOm",
"métronomes" => "metRonOm",
"métropole" => "metRopOl",
"métropoles" => "metRopOl",
"métropolitain" => "metRopolit5",
"métropolitaine" => "metRopolitEn",
"métropolitaines" => "metRopolitEn",
"métropolitains" => "metRopolit5",
"métropolite" => "metRopolit",
"métros" => "metRo",
"mets" => "mE",
"mets-la-toi" => "mElatwa",
"mettable" => "mEtabl",
"mettaient" => "mEtE",
"mettais" => "mEtE",
"mettait" => "mEtE",
"mettant" => "mEt@",
"mette" => "mEt",
"mettent" => "mEt",
"mettes" => "mEt",
"metteur" => "mEt9R",
"metteurs" => "mEt9R",
"metteuse" => "mEt2z",
"mettez" => "mEte",
"mettiez" => "mEtje",
"mettions" => "mEtj§",
"mettons" => "mEt§",
"mettra" => "mEtRa",
"mettrai" => "mEtRE",
"mettraient" => "mEtRE",
"mettrais" => "mEtRE",
"mettrait" => "mEtRE",
"mettras" => "mEtRa",
"mettre" => "mEtR",
"mettrez" => "mEtRe",
"mettriez" => "mEtRije",
"mettrions" => "mEtRij§",
"mettrons" => "mEtR§",
"mettront" => "mEtR§",
"meubla" => "m9bla",
"meublaient" => "m9blE",
"meublais" => "m9blE",
"meublait" => "m9blE",
"meublant" => "m9bl@",
"meuble" => "m9bl",
"meublé" => "m9ble",
"meublée" => "m9ble",
"meublées" => "m9ble",
"meublent" => "m9bl",
"meubler" => "m9ble",
"meublèrent" => "m9blER",
"meubles" => "m9bl",
"meublés" => "m9ble",
"meuf" => "m9f",
"meufs" => "m9f",
"meugla" => "m2gla",
"meuglaient" => "m2glE",
"meuglait" => "m2glE",
"meuglant" => "m2gl@",
"meugle" => "m2gl",
"meuglé" => "m2gle",
"meuglement" => "m2gl°m@",
"meuglements" => "m2gl°m@",
"meugler" => "m2gle",
"meuh" => "m2",
"meulage" => "m2laZ",
"meule" => "m2l",
"meuler" => "m2le",
"meules" => "m2l",
"meuleuse" => "m2l2z",
"meulez" => "m9le",
"meulière" => "m2ljER",
"meulières" => "m2ljER",
"meunier" => "m2nje",
"meunière" => "m2njER",
"meuniers" => "m2nje",
"meure" => "m9R",
"meurent" => "m9R",
"meures" => "m9R",
"meurette" => "m9REt",
"meurs" => "m9R",
"meursault" => "m9Rso",
"meurt" => "m9R",
"meurtre" => "m9RtR",
"meurtre-suicide" => "m9RtR°s8isid",
"meurtres" => "m9RtR",
"meurtri" => "m9RtRi",
"meurtrie" => "m9RtRi",
"meurtrier" => "m9RtRije",
"meurtrière" => "m9RtRijER",
"meurtrières" => "m9RtRijER",
"meurtriers" => "m9RtRije",
"meurtries" => "m9RtRi",
"meurtrir" => "m9RtRiR",
"meurtrira" => "m9RtRiRa",
"meurtriront" => "m9RtRiR§",
"meurtris" => "m9RtRi",
"meurtrissaient" => "m9RtRisE",
"meurtrissais" => "m9RtRisE",
"meurtrissait" => "m9RtRisE",
"meurtrissant" => "m9RtRis@",
"meurtrissent" => "m9RtRis",
"meurtrissure" => "m9RtRisyR",
"meurtrissures" => "m9RtRisyR",
"meurtrit" => "m9RtRi",
"meus" => "m2",
"meusien" => "m2zj5",
"meusienne" => "m2zjEn",
"meusiennes" => "m2zjEn",
"meusiens" => "m2zj5",
"meut" => "m2",
"meute" => "m2t",
"meutes" => "m2t",
"meuvent" => "m9v",
"mévente" => "mev@t",
"mexicain" => "mEksik5",
"mexicaine" => "mEksikEn",
"mexicaines" => "mEksikEn",
"mexicains" => "mEksik5",
"mexico" => "mEksiko",
"mezcal" => "mezkal",
"mézig" => "mezig",
"mézigue" => "mezig",
"mezza voce" => "mEdzavotSe",
"mezza-voce" => "mEdzavotSe",
"mezzanine" => "mEdzanin",
"mezzanines" => "mEdzanin",
"mezzo" => "mEdzo",
"mezzo-soprano" => "mEdzosOpRano",
"mezzos" => "mEdzo",
"mi" => "mi",
"mi-accablé" => "miakable",
"mi-africains" => "miafRik5",
"mi-airain" => "miER5",
"mi-allemand" => "mial°m@",
"mi-allongé" => "mial§Ze",
"mi-américaine" => "miameRikEn",
"mi-ange" => "mi@Z",
"mi-angevins" => "mi@Z°v5",
"mi-animal" => "mianimal",
"mi-animaux" => "mianimo",
"mi-août" => "miut",
"mi-appointées" => "miapw5te",
"mi-appréhension" => "miapRe@sj§",
"mi-arabe" => "miaRab",
"mi-artisan" => "miaRtiz@",
"mi-automne" => "miotOn",
"mi-bandit" => "mib@di",
"mi-bas" => "miba",
"mi-bête" => "mibEt",
"mi-biblique" => "mibiblik",
"mi-black" => "miblak",
"mi-blanc" => "mibl@",
"mi-blancs" => "mibl@",
"mi-bleu" => "mibl2",
"mi-bois" => "mibwa",
"mi-bordel" => "mibORdEl",
"mi-bourgeois" => "mibuRZwa",
"mi-bovins" => "mibov5",
"mi-braconniers" => "mibRakonje",
"mi-bras" => "mibRa",
"mi-britannique" => "mibRitanik",
"mi-building" => "mibildiG",
"mi-bureaucrates" => "mibyRokRat",
"mi-café" => "mikafe",
"mi-campagnarde" => "mik@paNaRd",
"mi-canard" => "mikanaR",
"mi-capacité" => "mikapasite",
"mi-carême" => "mikaREm",
"mi-carrière" => "mikaRjER",
"mi-céleste" => "miselEst",
"mi-cérémonieux" => "miseRemonj2",
"mi-chair" => "miSER",
"mi-chat" => "miSa",
"mi-châtaigniers" => "miSateNe",
"mi-chatte" => "miSat",
"mi-chauve" => "miSov",
"mi-chemin" => "miS°m5",
"mi-chênes" => "miSEn",
"mi-chèvre" => "miSEvR",
"mi-chou" => "miSu",
"mi-chourineur" => "miSuRin9R",
"mi-clair" => "miklER",
"mi-cloître" => "miklwatR",
"mi-clos" => "miklo",
"mi-close" => "mikloz",
"mi-closes" => "mikloz",
"mi-comique" => "mikomik",
"mi-complices" => "mik§plis",
"mi-compote" => "mik§pOt",
"mi-confit" => "mik§fi",
"mi-confondus" => "mik§f§dy",
"mi-connue" => "mikony",
"mi-consterné" => "mik§stERne",
"mi-contrariés" => "mik§tRaRje",
"mi-corbeaux" => "mikORbo",
"mi-corps" => "mikOR",
"mi-côte" => "mikot",
"mi-course" => "mikuRs",
"mi-courtois" => "mikuRtwa",
"mi-cousine" => "mikuzin",
"mi-cousins" => "mikuz5",
"mi-coutume" => "mikutym",
"mi-crabe" => "mikRab",
"mi-créature" => "mikReatyR",
"mi-croyant" => "mikRwaj@",
"mi-cruel" => "mikRyEl",
"mi-cuisse" => "mik8is",
"mi-cuisses" => "mik8is",
"mi-curieux" => "mikyRj2",
"mi-décadents" => "midekad@",
"mi-décembre" => "mides@bR",
"mi-démon" => "midem§",
"mi-dentelle" => "mid@tEl",
"mi-désir" => "mideziR",
"mi-didactique" => "mididaktik",
"mi-distance" => "midist@s",
"mi-douce" => "midus",
"mi-effrayée" => "miefREje",
"mi-effrayés" => "miefREje",
"mi-effrontée" => "miefR§te",
"mi-enfant" => "mi@f@",
"mi-enjouée" => "mi@Zwe",
"mi-enterré" => "mi@teRe",
"mi-envieux" => "mi@vj2",
"mi-épaule" => "miepol",
"mi-espagnol" => "miEspaNOl",
"mi-étage" => "mietaZ",
"mi-été" => "miete",
"mi-étendue" => "miet@dy",
"mi-étonné" => "mietone",
"mi-étudiant" => "mietydj@",
"mi-européen" => "mi2Rope5",
"mi-éveillée" => "mieveje",
"mi-excitation" => "miEksitasj§",
"mi-farceur" => "mifaRs9R",
"mi-faux" => "mifo",
"mi-femme" => "mifam",
"mi-fermiers" => "mifERmje",
"mi-février" => "mifevRije",
"mi-fiel" => "mifjEl",
"mi-figue" => "mifig",
"mi-flanc" => "mifl@",
"mi-fleuve" => "mifl9v",
"mi-français" => "mifR@sE",
"mi-furieux" => "mifyRj2",
"mi-garçon" => "migaRs§",
"mi-geste" => "miZEst",
"mi-gigolpince" => "miZigolpis",
"mi-gnon" => "miN§",
"mi-goélands" => "migoel@",
"mi-goguenarde" => "migog°naRd",
"mi-gonzesse" => "mig§zEs",
"mi-graves" => "migRav",
"mi-grenier" => "migR°nje",
"mi-grognon" => "migRoN§",
"mi-grondeur" => "migR§d9R",
"mi-grossières" => "migRosjER",
"mi-haute" => "miot",
"mi-hauteur" => "miot9R",
"mi-hésitant" => "miezit@",
"mi-historiques" => "miistoRik",
"mi-homme" => "miOm",
"mi-humain" => "miym5",
"mi-humaine" => "miymEn",
"mi-humains" => "miym5",
"mi-idiotes" => "miidjOt",
"mi-images" => "miimaZ",
"mi-indien" => "mi5dj5",
"mi-indifférente" => "mi5difeR@t",
"mi-indigène" => "mi5diZEn",
"mi-indignée" => "mi5diNe",
"mi-indulgent" => "mi5dylZ@",
"mi-inquiète" => "mi5kjEt",
"mi-ironique" => "miiRonik",
"mi-ironiques" => "miiRonik",
"mi-jambe" => "miZ@b",
"mi-jambes" => "miZ@b",
"mi-janvier" => "miZ@vje",
"mi-jaune" => "miZon",
"mi-jaunes" => "miZon",
"mi-jersey" => "miZERzE",
"mi-joue" => "miZu",
"mi-jour" => "miZuR",
"mi-journée" => "miZuRne",
"mi-juif" => "miZ8if",
"mi-juillet" => "miZ8ijE",
"mi-juin" => "miZ85",
"mi-laiton" => "milEt§",
"mi-lent" => "mil@",
"mi-londrès" => "mil§dREs",
"mi-longs" => "mil§",
"mi-longueur" => "mil§g9R",
"mi-lourd" => "miluR",
"mi-machine" => "mimaSin",
"mi-machines" => "mimaSin",
"mi-mai" => "mimE",
"mi-mao" => "mimao",
"mi-marchande" => "mimaRS@d",
"mi-marécages" => "mimaRekaZ",
"mi-mars" => "mimaRs",
"mi-menaçante" => "mim°nas@t",
"mi-métal" => "mimetal",
"mi-meublé" => "mim9ble",
"mi-mexicain" => "mimEksik5",
"mi-miel" => "mimjEl",
"mi-mollet" => "mimolE",
"mi-mollets" => "mimolE",
"mi-mondaine" => "mim§dEn",
"mi-moqueur" => "mimok9R",
"mi-mot" => "mimo",
"mi-mots" => "mimo",
"mi-mouton" => "mimut§",
"mi-moyen" => "mimwaj5",
"mi-moyens" => "mimwaj5",
"mi-narquoise" => "minaRkwaz",
"mi-noir" => "minwaR",
"mi-novembre" => "minov@bR",
"mi-nuit" => "min8i",
"mi-obscure" => "miOpskyR",
"mi-octobre" => "miOktObR",
"mi-officiel" => "miofisjEl",
"mi-ogre" => "miOgR",
"mi-oiseau" => "miwazo",
"mi-oriental" => "mioRj@tal",
"mi-parcours" => "mipaRkuR",
"mi-partie" => "mipaRti",
"mi-pathétique" => "mipatetik",
"mi-patio" => "mipatjo",
"mi-patois" => "mipatwa",
"mi-peau" => "mipo",
"mi-pêcheurs" => "mipES9R",
"mi-pelouse" => "mip°luz",
"mi-pensées" => "mip@se",
"mi-pente" => "mip@t",
"mi-pierre" => "mipjER",
"mi-pincé" => "mip5se",
"mi-plaintif" => "mipl5tif",
"mi-plaisant" => "miplEz@",
"mi-pleurant" => "mipl9R@",
"mi-pleurnichard" => "mipl9RniSaR",
"mi-plombiers" => "mipl§bje",
"mi-poisson" => "mipwas§",
"mi-poitrine" => "mipwatRin",
"mi-porcine" => "mipORsin",
"mi-porté" => "mipORte",
"mi-portugaise" => "mipORtygEz",
"mi-poucet" => "mipusE",
"mi-poulet" => "mipulE",
"mi-prestidigitateur" => "mipREstidiZitat9R",
"mi-promenoir" => "mipRomnwaR",
"mi-protecteur" => "mipRotEkt9R",
"mi-putain" => "mipyt5",
"mi-rageur" => "miRaZ9R",
"mi-raide" => "miREd",
"mi-railleur" => "miRaj9R",
"mi-raisin" => "miREz5",
"mi-réalité" => "miRealite",
"mi-régime" => "miReZim",
"mi-renaissance" => "miR°nEs@s",
"mi-réprobateur" => "miRepRobat9R",
"mi-résigné" => "miReziNe",
"mi-respectueuse" => "miREspEkt82z",
"mi-riant" => "miRj@",
"mi-rose" => "miRoz",
"mi-roulotte" => "miRulOt",
"mi-route" => "miRut",
"mi-russe" => "miRys",
"mi-saison" => "misEz§",
"mi-salade" => "misalad",
"mi-salaire" => "misalER",
"mi-samoan" => "misamo@",
"mi-sanglotant" => "mis@glot@",
"mi-satin" => "misat5",
"mi-satisfait" => "misatisfE",
"mi-sceptique" => "misEptik",
"mi-scientifiques" => "misj@tifik",
"mi-secours" => "mis°kuR",
"mi-seigneur" => "misEN9R",
"mi-sel" => "misEl",
"mi-septembre" => "misEpt@bR",
"mi-série" => "miseRi",
"mi-sérieux" => "miseRj2",
"mi-sidérée" => "misideRe",
"mi-singe" => "mis5Z",
"mi-sombre" => "mis§bR",
"mi-sommet" => "misomE",
"mi-songe" => "mis§Z",
"mi-souriant" => "misuRj@",
"mi-souriante" => "misuRj@t",
"mi-suisse" => "mis8is",
"mi-tantouse" => "mit@tuz",
"mi-tendre" => "mit@dR",
"mi-terrorisé" => "mitERoRize",
"mi-timide" => "mitimid",
"mi-tortue" => "mitORty",
"mi-tour" => "mituR",
"mi-tout" => "mitu",
"mi-tragique" => "mitRaZik",
"mi-trimestre" => "mitRimEstR",
"mi-végétal" => "miveZetal",
"mi-velours" => "miv°luR",
"mi-vénitien" => "mivenisj5",
"mi-verre" => "mivER",
"mi-vie" => "mivi",
"mi-voix" => "mivwa",
"mi-voluptueux" => "mivolypt82",
"mi-vrais" => "mivRE",
"miam" => "mjam",
"miam-miam" => "mjammjam",
"miao" => "miao",
"miaou" => "mjau",
"miaous" => "mjau",
"miasme" => "mjasm",
"miasmes" => "mjasm",
"miaula" => "mjola",
"miaulaient" => "mjolE",
"miaulais" => "mjolE",
"miaulait" => "mjolE",
"miaulant" => "mjol@",
"miaule" => "mjol",
"miaulé" => "mjole",
"miaulement" => "mjol°m@",
"miaulements" => "mjol°m@",
"miaulent" => "mjol",
"miauler" => "mjole",
"miauleur" => "mjOl9R",
"miaulez" => "mjole",
"mica" => "mika",
"micacées" => "mikase",
"micas" => "mika",
"miche" => "miS",
"miché" => "miSe",
"micheline" => "miS°lin",
"miches" => "miS",
"michés" => "miSe",
"micheton" => "miS°t§",
"michetonnais" => "miS°tonE",
"michetonne" => "miS°tOn",
"michetonner" => "miS°tone",
"michetonnes" => "miS°tOn",
"michetonneuse" => "miS°ton2z",
"michetonneuses" => "miS°ton2z",
"michetons" => "miS°t§",
"mickeys" => "mikE",
"micmac" => "mikmak",
"micmacs" => "mikmak",
"micocoulier" => "mikokulje",
"micocouliers" => "mikokulje",
"micro" => "mikRo",
"micro-cravate" => "mikRokRavat",
"micro-onde" => "mikRo§d",
"micro-ondes" => "mikRo§d",
"micro-ordinateur" => "mikRoORdinat9R",
"micro-ordinateurs" => "mikRoORdinat9R",
"micro-organisme" => "mikRoORganizm",
"micro-trottoir" => "mikRotRotwaR",
"microanalyse" => "mikRoanaliz",
"microbe" => "mikROb",
"microbes" => "mikROb",
"microbienne" => "mikRobjEn",
"microbiens" => "mikRobj5",
"microbiologie" => "mikRObjOlOZi",
"microbiologiste" => "mikRobjoloZist",
"microbus" => "mikRobys",
"microcassette" => "mikRokasEt",
"microcéphale" => "mikRosefal",
"microcéphales" => "mikRosefal",
"microchimie" => "mikRoSimi",
"microchirurgie" => "mikRoSiRyRZi",
"microcircuit" => "mikRosiRk8i",
"microcircuits" => "mikRosiRk8i",
"microclimat" => "mikRoklima",
"microcomposants" => "mikRok§poz@",
"microcopie" => "mikRokOpi",
"microcosme" => "mikRokOsm",
"microcycles" => "mikRosikl",
"microédition" => "mikRoedisj§",
"microfiches" => "mikRofiS",
"microfilm" => "mikRofilm",
"microfilms" => "mikRofilm",
"microgramme" => "mikROgRam",
"microgravité" => "mikRogRavite",
"microlithes" => "mikRolit",
"micromètre" => "mikRomEtR",
"micromètres" => "mikRomEtR",
"micron" => "mikR§",
"microns" => "mikR§",
"microphone" => "mikRofOn",
"microphones" => "mikRofOn",
"microprocesseur" => "mikRopRosEs9R",
"microprocesseurs" => "mikRopRosEs9R",
"micros" => "mikRo",
"microscope" => "mikRoskOp",
"microscopes" => "mikRoskOp",
"microscopie" => "mikRoskOpi",
"microscopique" => "mikRoskopik",
"microscopiquement" => "mikRoskOpik°m@",
"microscopiques" => "mikRoskopik",
"microseconde" => "mikRos°g§d",
"microsecondes" => "mikRos°g§d",
"microsillon" => "mikRosij§",
"microsillons" => "mikRosij§",
"microsociologie" => "mikRososjoloZi",
"microsonde" => "mikRos§d",
"microstructure" => "mikRostRyktyR",
"microstructures" => "mikRostRyktyR",
"miction" => "miksj§",
"mictions" => "miksj§",
"middle class" => "mid2lklas",
"middle-west" => "mid2lwEst",
"midi" => "midi",
"midinette" => "midinEt",
"midinettes" => "midinEt",
"midis" => "midi",
"midrash" => "midRaS",
"midship" => "mitSip",
"mie" => "mi",
"miel" => "mjEl",
"miellat" => "mjElat",
"mielle" => "mjEl",
"miellé" => "mjEle",
"miellée" => "mjEle",
"miellées" => "mjEle",
"mielleuse" => "mjEl2z",
"mielleuses" => "mjEl2z",
"mielleux" => "mjEl2",
"miels" => "mjEl",
"mien" => "mj5",
"mienne" => "mjEn",
"miennes" => "mjEn",
"miens" => "mj5",
"mies" => "mi",
"miette" => "mjEt",
"miettes" => "mjEt",
"mieux" => "mj2",
"mieux-être" => "mj2zEtR",
"mieux-vivre" => "mj2vivR",
"mièvre" => "mjEvR",
"mièvrement" => "mjEvR°m@",
"mièvrerie" => "mjEvR°Ri",
"mièvreries" => "mjEvR°Ri",
"mièvres" => "mjEvR",
"mignard" => "miNaR",
"mignardant" => "miNaRd@",
"mignarde" => "miNaRd",
"mignardé" => "miNaRde",
"mignardement" => "miNaRd2m@",
"mignardes" => "miNaRd",
"mignardise" => "miNaRdiz",
"mignardises" => "miNaRdiz",
"mignards" => "miNaR",
"mignon" => "miN§",
"mignonne" => "miNOn",
"mignonnement" => "miNOn°m@",
"mignonnes" => "miNOn",
"mignonnet" => "miNonE",
"mignonnets" => "miNonE",
"mignonnette" => "miNonEt",
"mignonnettes" => "miNonEt",
"mignons" => "miN§",
"mignoté" => "miNote",
"mignoter" => "miNote",
"mignoteront" => "miNot°R§",
"migraine" => "migREn",
"migraines" => "migREn",
"migraineuse" => "migREn2z",
"migraineux" => "migREn2",
"migrait" => "migRE",
"migrant" => "migR@",
"migrante" => "migR@t",
"migrants" => "migR@",
"migrateur" => "migRat9R",
"migrateurs" => "migRat9R",
"migration" => "migRasj§",
"migrations" => "migRasj§",
"migratoire" => "migRatwaR",
"migratoires" => "migRatwaR",
"migratrice" => "migRatRis",
"migratrices" => "migRatRis",
"migre" => "migR",
"migré" => "migRe",
"migrent" => "migR",
"migrer" => "migRe",
"migres" => "migR",
"mijaurée" => "miZoRe",
"mijaurées" => "miZoRe",
"mijota" => "miZota",
"mijotaient" => "miZotE",
"mijotais" => "miZotE",
"mijotait" => "miZotE",
"mijotant" => "miZot@",
"mijote" => "miZOt",
"mijoté" => "miZote",
"mijotées" => "miZote",
"mijotent" => "miZOt",
"mijoter" => "miZote",
"mijotera" => "miZOt°Ra",
"mijotes" => "miZOt",
"mijotés" => "miZote",
"mijoteuse" => "miZot2z",
"mijotez" => "miZote",
"mijotions" => "miZotj§",
"mijotons" => "miZot§",
"mikado" => "mikado",
"mil" => "mil",
"milady" => "miledi",
"milan" => "mil@",
"milanais" => "milanE",
"milanaise" => "milanEz",
"milanaises" => "milanEz",
"milans" => "mil@",
"mildiou" => "mildju",
"mile" => "majl",
"miles" => "majls",
"milésiennes" => "milezjEn",
"milice" => "milis",
"milices" => "milis",
"milicien" => "milisj5",
"miliciennes" => "milisjEn",
"miliciens" => "milisj5",
"milieu" => "milj2",
"milieux" => "milj2",
"milita" => "milita",
"militaient" => "militE",
"militaire" => "militER",
"militairement" => "militER°m@",
"militaires" => "militER",
"militait" => "militE",
"militant" => "milit@",
"militante" => "milit@t",
"militantes" => "milit@t",
"militantisme" => "milit@tizm",
"militants" => "milit@",
"militarisation" => "militaRizasj§",
"militarisé" => "militaRize",
"militariser" => "militaRize",
"militarisme" => "militaRizm",
"militariste" => "militaRist",
"militaristes" => "militaRist",
"militaro" => "militaRo",
"militaro-industriel" => "militaRo5dystRijEl",
"militaro-industrielle" => "militaRo5dystRiEl",
"milite" => "milit",
"milité" => "milite",
"militent" => "milit",
"militer" => "milite",
"militerai" => "milit°RE",
"militèrent" => "militER",
"milites" => "milit",
"militons" => "milit§",
"milk shake" => "milkSEjk",
"milk-bar" => "milkbaR",
"milk-bars" => "milkbaR",
"milk-shake" => "milkSEjk",
"milk-shakes" => "milkSEjk",
"mille" => "mil",
"mille-feuille" => "milf9j",
"mille-feuilles" => "milf9j",
"mille-pattes" => "milpat",
"millefeuille" => "mil°f9j",
"millefeuilles" => "mil°f9j",
"millénaire" => "milenER",
"millénaires" => "milenER",
"millénarisme" => "milenaRism",
"millénariste" => "milenaRist",
"millenium" => "milenjOm",
"millénium" => "milenjOm",
"milles" => "mil",
"millésime" => "milezim",
"millésimé" => "milezime",
"millésimée" => "milezime",
"millésimées" => "milezime",
"millésimes" => "milezim",
"millésimés" => "milezime",
"millet" => "mijE",
"milli" => "mili",
"milliaire" => "miljER",
"milliard" => "miljaR",
"milliardaire" => "miljaRdER",
"milliardaires" => "miljaRdER",
"milliardième" => "miljaRdjEm",
"milliards" => "miljaR",
"millième" => "miljEm",
"millièmes" => "miljEm",
"millier" => "milje",
"milliers" => "milje",
"milligramme" => "miligRam",
"milligrammes" => "miligRam",
"millilitre" => "mililitR",
"millimètre" => "milimEtR",
"millimétré" => "milimetRe",
"millimétrées" => "milimetRe",
"millimètres" => "milimEtR",
"millimétrés" => "milimetRe",
"millimétrique" => "milimetRik",
"millimétriques" => "milimetRik",
"million" => "milj§",
"millionième" => "miljonjEm",
"millionnaire" => "miljonER",
"millionnaires" => "miljonER",
"millions" => "milj§",
"milliseconde" => "milis°g§d",
"millisecondes" => "milisg§d",
"milonga" => "miloga",
"milord" => "milOR",
"milords" => "milOR",
"milouin" => "milw5",
"mima" => "mima",
"mimaient" => "mimE",
"mimais" => "mimE",
"mimait" => "mimE",
"mimâmes" => "mimam",
"mimant" => "mim@",
"mimas" => "mima",
"mime" => "mim",
"mimé" => "mime",
"mimée" => "mime",
"miment" => "mim",
"mimer" => "mime",
"mimerai" => "mim°RE",
"mimerait" => "mim°RE",
"mimèrent" => "mimER",
"mimes" => "mim",
"mîmes" => "mim",
"mimétique" => "mimetik",
"mimétisme" => "mimetizm",
"mimi" => "mimi",
"mimique" => "mimik",
"mimiques" => "mimik",
"mimis" => "mimi",
"mimodrames" => "mimodRam",
"mimolette" => "mimOlEt",
"mimosa" => "mimoza",
"mimosas" => "mimoza",
"mimosées" => "mimoze",
"min" => "min",
"mina" => "mina",
"minable" => "minabl",
"minablement" => "minabl°m@",
"minables" => "minabl",
"minage" => "minaZ",
"minait" => "minE",
"minant" => "min@",
"minaret" => "minaRE",
"minarets" => "minaRE",
"minas" => "mina",
"minauda" => "minoda",
"minaudaient" => "minodE",
"minaudait" => "minodE",
"minaudant" => "minod@",
"minaudants" => "minod@",
"minaude" => "minod",
"minaudé" => "minode",
"minaudent" => "minod",
"minauder" => "minode",
"minauderait" => "minod°RE",
"minauderie" => "minod°Ri",
"minauderies" => "minod°Ri",
"minaudeur" => "minod9R",
"minaudez" => "minode",
"minaudière" => "minodjER",
"minbar" => "minbaR",
"mince" => "m5s",
"minces" => "m5s",
"minceur" => "m5s9R",
"minceurs" => "m5s9R",
"minci" => "m5si",
"mincir" => "m5siR",
"mincirait" => "m5siRE",
"mincis" => "m5si",
"mincissaient" => "m5sisE",
"mine" => "min",
"miné" => "mine",
"minée" => "mine",
"minées" => "mine",
"minent" => "min",
"miner" => "mine",
"minera" => "min°Ra",
"minerai" => "min°RE",
"minerais" => "min°RE",
"minéral" => "mineRal",
"minérale" => "mineRal",
"minérales" => "mineRal",
"minéraliers" => "mineRalje",
"minéralisation" => "mineRalizasj§",
"minéralisés" => "mineRalize",
"minéralogique" => "mineRaloZik",
"minéralogiques" => "mineRaloZik",
"minéraux" => "mineRo",
"minerval" => "minERval",
"minerve" => "minERv",
"mines" => "min",
"minés" => "mine",
"minestrone" => "minEstROn",
"minet" => "minE",
"minets" => "minE",
"minette" => "minEt",
"minettes" => "minEt",
"mineur" => "min9R",
"mineure" => "min9R",
"mineures" => "min9R",
"mineurs" => "min9R",
"ming" => "miG",
"mini" => "mini",
"mini-chaîne" => "miniSEn",
"mini-jupe" => "miniZyp",
"mini-jupes" => "miniZyp",
"mini-ordinateur" => "miniORdinat9R",
"miniature" => "minjatyR",
"miniatures" => "minjatyR",
"miniaturisation" => "minjatyRizasj§",
"miniaturise" => "minjatyRiz",
"miniaturisé" => "minjatyRize",
"miniaturisée" => "minjatyRize",
"miniaturisées" => "minjatyRize",
"miniaturiser" => "minjatyRize",
"miniaturisés" => "minjatyRize",
"miniaturiste" => "minjatyRist",
"minibar" => "minibaR",
"minibus" => "minibys",
"minicassette" => "minikasEt",
"minicassettes" => "minikasEt",
"minier" => "minje",
"minière" => "minjER",
"minières" => "minjER",
"miniers" => "minje",
"minigolf" => "minigOlf",
"minijupe" => "miniZyp",
"minijupes" => "miniZyp",
"minima" => "minima",
"minimal" => "minimal",
"minimale" => "minimal",
"minimales" => "minimal",
"minimaliser" => "minimalize",
"minimalisme" => "minimalizm",
"minimaliste" => "minimalist",
"minimaux" => "minimo",
"minimax" => "minimaks",
"minime" => "minim",
"minimes" => "minim",
"minimisa" => "minimiza",
"minimisaient" => "minimizE",
"minimisait" => "minimizE",
"minimisant" => "minimiz@",
"minimisation" => "minimizasj§",
"minimise" => "minimiz",
"minimisé" => "minimize",
"minimisée" => "minimize",
"minimisées" => "minimize",
"minimisent" => "minimiz",
"minimiser" => "minimize",
"minimiserons" => "minimiz°R§",
"minimises" => "minimiz",
"minimisez" => "minimize",
"minimisons" => "minimiz§",
"minimum" => "minimOm",
"minimums" => "minimOm",
"minis" => "mini",
"ministère" => "ministER",
"ministères" => "ministER",
"ministériel" => "ministeRjEl",
"ministérielle" => "ministeRjEl",
"ministérielles" => "ministeRjEl",
"ministériels" => "ministeRjEl",
"ministrables" => "ministRabl",
"ministre" => "ministR",
"ministres" => "ministR",
"minitel" => "minitEl",
"minium" => "minjOm",
"mino" => "mino",
"minoen" => "minO5",
"minoenne" => "minOen",
"minoens" => "minO5",
"minois" => "minwa",
"minoritaire" => "minoRitER",
"minoritaires" => "minoRitER",
"minorité" => "minoRite",
"minorités" => "minoRite",
"minot" => "mino",
"minotaure" => "minotoR",
"minotaures" => "minotoR",
"minoteries" => "minOt°Ri",
"minotier" => "minotje",
"minots" => "mino",
"minou" => "minu",
"minouche" => "minuS",
"minous" => "minu",
"minuit" => "min8i",
"minuits" => "min8i",
"minus" => "minys",
"minus habens" => "minyszabEns",
"minuscule" => "minyskyl",
"minuscules" => "minyskyl",
"minutage" => "minytaZ",
"minutât" => "minyta",
"minute" => "minyt",
"minuté" => "minyte",
"minutée" => "minyte",
"minuter" => "minyte",
"minuterie" => "minyt°Ri",
"minuteries" => "minyt°Ri",
"minutes" => "minyt",
"minutés" => "minyte",
"minuteur" => "minyt9R",
"minuteurs" => "minyt9R",
"minutie" => "minysi",
"minuties" => "minysi",
"minutieuse" => "minysj2z",
"minutieusement" => "minysj2z°m@",
"minutieuses" => "minysj2z",
"minutieux" => "minysj2",
"minutions" => "minytj§",
"mioche" => "mjOS",
"mioches" => "mjOS",
"miquette" => "mikEt",
"mir" => "miR",
"mira" => "miRa",
"mirabelle" => "miRabEl",
"mirabelles" => "miRabEl",
"mirabellier" => "miRabelje",
"mirabelliers" => "miRabelje",
"mirabilis" => "miRabilis",
"miracle" => "miRakl",
"miracles" => "miRakl",
"miraculant" => "miRakyl@",
"miraculantes" => "miRakyl@t",
"miraculé" => "miRakyle",
"miraculée" => "miRakyle",
"miraculés" => "miRakyle",
"miraculeuse" => "miRakyl2z",
"miraculeusement" => "miRakyl2z°m@",
"miraculeuses" => "miRakyl2z",
"miraculeux" => "miRakyl2",
"mirador" => "miRadOR",
"miradors" => "miRadOR",
"mirage" => "miRaZ",
"mirages" => "miRaZ",
"miraient" => "miRE",
"mirais" => "miRE",
"mirait" => "miRE",
"mirant" => "miR@",
"miraud" => "miRo",
"mirauds" => "miRo",
"mire" => "miR",
"mirée" => "miRe",
"mirent" => "miR",
"mirepoix" => "miRpwa",
"mirer" => "miRe",
"mirerais" => "miR°RE",
"mires" => "miR",
"mirette" => "miREt",
"mirettes" => "miREt",
"mirez" => "miRe",
"mirifique" => "miRifik",
"mirifiques" => "miRifik",
"mirliflore" => "miRliflOR",
"mirliton" => "miRlit§",
"mirlitons" => "miRlit§",
"mirmidon" => "miRmid§",
"miro" => "miRo",
"mirobolant" => "miRobol@",
"mirobolante" => "miRobol@t",
"mirobolantes" => "miRobol@t",
"mirobolants" => "miRobol@",
"miroir" => "miRwaR",
"miroirs" => "miRwaR",
"miroita" => "miRwata",
"miroitaient" => "miRwatE",
"miroitait" => "miRwatE",
"miroitant" => "miRwat@",
"miroitante" => "miRwat@t",
"miroitantes" => "miRwat@t",
"miroitants" => "miRwat@",
"miroite" => "miRwat",
"miroitement" => "miRwat°m@",
"miroitements" => "miRwat°m@",
"miroitent" => "miRwat",
"miroiter" => "miRwate",
"miroiterie" => "miRwat°Ri",
"miroités" => "miRwate",
"miroitier" => "miRwatje",
"miroitiers" => "miRwatje",
"mironton" => "miR§t§",
"mirontons" => "miR§t§",
"miros" => "miRo",
"miroton" => "miRot§",
"mirus" => "miRys",
"mis" => "mi",
"misa" => "miza",
"misai" => "mizE",
"misaient" => "mizE",
"misaine" => "mizEn",
"misaines" => "mizEn",
"misais" => "mizE",
"misait" => "mizE",
"misant" => "miz@",
"misanthrope" => "miz@tROp",
"misanthropes" => "miz@tROp",
"misanthropie" => "miz@tRopi",
"misanthropiques" => "miz@tRopik",
"misât" => "miza",
"miscible" => "misibl",
"mise" => "miz",
"misé" => "mize",
"misent" => "miz",
"miser" => "mize",
"misera" => "miz°Ra",
"misérabilisme" => "mizeRabilizm",
"misérabiliste" => "mizeRabilist",
"misérable" => "mizeRabl",
"misérablement" => "mizeRabl°m@",
"misérables" => "mizeRabl",
"miserais" => "miz°RE",
"miseras" => "miz°Ra",
"misère" => "mizER",
"miserere" => "mizeReRe",
"misères" => "mizER",
"miséreuse" => "mizeR2z",
"miséreuses" => "mizeR2z",
"miséreux" => "mizeR2",
"miséricorde" => "mizeRikORd",
"miséricordes" => "mizeRikORd",
"miséricordieuse" => "mizeRikORdj2z",
"miséricordieusement" => "mizeRikORdj2z°m@",
"miséricordieuses" => "mizeRikORdj2z",
"miséricordieux" => "mizeRikORdj2",
"miseriez" => "miz°Rje",
"miseront" => "miz°R§",
"mises" => "miz",
"misez" => "mize",
"misiez" => "mizje",
"misogyne" => "mizoZin",
"misogynes" => "mizoZin",
"misogynie" => "mizoZini",
"misons" => "miz§",
"miss" => "mis",
"missel" => "misEl",
"missels" => "misEl",
"missent" => "mis",
"missile" => "misil",
"missiles" => "misil",
"missilier" => "misilje",
"mission" => "misj§",
"mission-suicide" => "misj§s8isid",
"missionna" => "misjona",
"missionnaire" => "misjonER",
"missionnaires" => "misjonER",
"missionné" => "misjOne",
"missionnés" => "misjone",
"missions" => "misj§",
"missive" => "misiv",
"missives" => "misiv",
"mister" => "mist9R",
"mistigri" => "mistigRi",
"mistigris" => "mistigRi",
"mistonne" => "mistOn",
"mistonnes" => "mistOn",
"mistoufle" => "mistufl",
"mistoufles" => "mistufl",
"mistral" => "mistRal",
"mistrals" => "mistRal",
"mit" => "mi",
"mît" => "mi",
"mita" => "mita",
"mitaine" => "mitEn",
"mitaines" => "mitEn",
"mitan" => "mit@",
"mitard" => "mitaR",
"mitarder" => "mitaRde",
"mitardés" => "mitaRde",
"mitards" => "mitaR",
"mitchouriniens" => "mitSuRinj5",
"mite" => "mit",
"mité" => "mite",
"mitée" => "mite",
"mitées" => "mite",
"mitent" => "mit",
"miter" => "mite",
"mites" => "mit",
"mités" => "mite",
"miteuse" => "mit2z",
"miteusement" => "mit2z°m@",
"miteuserie" => "mit2z°Ri",
"miteuses" => "mit2z",
"miteux" => "mit2",
"mithriaque" => "mitRijak",
"mithridatisation" => "mitRidatizasj§",
"mithridatisé" => "mitRidatize",
"mithridatisés" => "mitRidatize",
"mitigé" => "mitiZe",
"mitigea" => "mitiZa",
"mitigée" => "mitiZe",
"mitigées" => "mitiZe",
"mitiger" => "mitiZe",
"mitigés" => "mitiZe",
"mitigeurs" => "mitiZ9R",
"mitochondrial" => "mitOk§dRijal",
"mitochondrie" => "mitOk§dRi",
"mitochondries" => "mitok§dRi",
"miton" => "mit§",
"mitonnaient" => "mitonE",
"mitonnait" => "mitonE",
"mitonnant" => "miton@",
"mitonne" => "mitOn",
"mitonné" => "mitone",
"mitonnée" => "mitone",
"mitonnées" => "mitone",
"mitonnent" => "mitOn",
"mitonner" => "mitone",
"mitonnerait" => "mitOn°RE",
"mitonnés" => "mitone",
"mitose" => "mitoz",
"mitotique" => "mitOtik",
"mitoufle" => "mitufl",
"mitoyen" => "mitwaj5",
"mitoyenne" => "mitwajEn",
"mitoyennes" => "mitwajEn",
"mitoyenneté" => "mitwajEn°te",
"mitoyens" => "mitwaj5",
"mitra" => "mitRa",
"mitrailla" => "mitRaja",
"mitraillade" => "mitRajad",
"mitraillades" => "mitRajad",
"mitraillage" => "mitRajaZ",
"mitraillages" => "mitRajaZ",
"mitraillaient" => "mitRajE",
"mitraillait" => "mitRajE",
"mitraillant" => "mitRaj@",
"mitraille" => "mitRaj",
"mitraillé" => "mitRaje",
"mitraillée" => "mitRaje",
"mitraillées" => "mitRaje",
"mitraillent" => "mitRaj",
"mitrailler" => "mitRaje",
"mitrailleraient" => "mitRaj°RE",
"mitraillèrent" => "mitRajER",
"mitrailles" => "mitRaj",
"mitraillés" => "mitRaje",
"mitraillette" => "mitRajEt",
"mitraillettes" => "mitRajEt",
"mitrailleur" => "mitRaj9R",
"mitrailleurs" => "mitRaj9R",
"mitrailleuse" => "mitRaj2z",
"mitrailleuses" => "mitRaj2z",
"mitrailliez" => "mitRaje",
"mitral" => "mitRal",
"mitrale" => "mitRal",
"mitre" => "mitR",
"mitré" => "mitRe",
"mitres" => "mitR",
"mitrés" => "mitRe",
"mitron" => "mitR§",
"mitrons" => "mitR§",
"mixage" => "miksaZ",
"mixait" => "miksE",
"mixe" => "miks",
"mixé" => "mikse",
"mixée" => "mikse",
"mixer" => "mikse",
"mixers" => "miks9R",
"mixés" => "mikse",
"mixeur" => "miks9R",
"mixeurs" => "miks9R",
"mixité" => "miksite",
"mixte" => "mikst",
"mixtes" => "mikst",
"mixture" => "mikstyR",
"mixtures" => "mikstyR",
"ml" => "mililitR",
"mlle" => "madmwazEl",
"mm" => "milimEtR",
"mme" => "madam",
"mn" => "minyt",
"mnémonique" => "mnemOnik",
"mnémoniques" => "mnemonik",
"mnémotechnie" => "mnemotEkni",
"mnémotechnique" => "mnemotEknik",
"mnésiques" => "mnezik",
"mob" => "mOb",
"mobil-home" => "mObilom",
"mobile" => "mobil",
"mobiles" => "mobil",
"mobilier" => "mobilje",
"mobilière" => "mobiljER",
"mobilières" => "mobiljER",
"mobiliers" => "mobilje",
"mobilisa" => "mobiliza",
"mobilisable" => "mobilizabl",
"mobilisables" => "mobilizabl",
"mobilisaient" => "mobilizE",
"mobilisais" => "mobilizE",
"mobilisait" => "mobilizE",
"mobilisant" => "mobiliz@",
"mobilisateur" => "mobilizat9R",
"mobilisateurs" => "mobilizat9R",
"mobilisation" => "mobilizasj§",
"mobilise" => "mobiliz",
"mobilisé" => "mobilize",
"mobilisée" => "mobilize",
"mobilisées" => "mobilize",
"mobilisent" => "mobiliz",
"mobiliser" => "mobilize",
"mobilisera" => "mobiliz°Ra",
"mobiliserait" => "mobiliz°RE",
"mobiliserons" => "mobiliz°R§",
"mobilisés" => "mobilize",
"mobilisez" => "mobilize",
"mobilisions" => "mobilizj§",
"mobilisons" => "mobiliz§",
"mobilité" => "mobilite",
"mobylette" => "mobilEt",
"mobylettes" => "mobilEt",
"mocassin" => "mokas5",
"mocassins" => "mokas5",
"mochard" => "moSaR",
"mocharde" => "moSaRd",
"moche" => "mOS",
"moches" => "mOS",
"mocheté" => "mOS°te",
"mochetés" => "mOS°te",
"moco" => "moko",
"mod" => "mOd",
"modalité" => "mOdalite",
"modalités" => "modalite",
"mode" => "mOd",
"model" => "modEl",
"modela" => "mod°la",
"modelable" => "mod°labl",
"modelage" => "mod°laZ",
"modelaient" => "mod°lE",
"modelais" => "mod°lE",
"modelait" => "mod°lE",
"modelant" => "mod°l@",
"modèle" => "modEl",
"modelé" => "mod°le",
"modelée" => "mod°le",
"modelées" => "mod°le",
"modèlent" => "modEl",
"modeler" => "mod°le",
"modèles" => "modEl",
"modelés" => "mod°le",
"modeleur" => "mOd°l9R",
"modelez" => "mod°le",
"modélisation" => "modelizasj§",
"modélisé" => "modelize",
"modélisée" => "modelize",
"modélisme" => "mOdelism",
"modéliste" => "modelist",
"modem" => "modEm",
"modems" => "modEm",
"modéra" => "modeRa",
"modérai" => "modeRE",
"modérait" => "modeRE",
"modérant" => "modeR@",
"modérateur" => "modeRat9R",
"modérateurs" => "modeRat9R",
"modération" => "modeRasj§",
"modérations" => "modeRasj§",
"moderato" => "modeRato",
"modère" => "modER",
"modéré" => "modeRe",
"modérée" => "modeRe",
"modérées" => "modeRe",
"modérément" => "modeRem@",
"modérer" => "modeRe",
"modéreras" => "modeR°Ra",
"modérés" => "modeRe",
"modérez" => "modeRe",
"modern style" => "modERnstil",
"modern-style" => "modERnstil",
"moderne" => "modERn",
"modernes" => "modERn",
"modernisaient" => "modERnizE",
"modernisait" => "modERnizE",
"modernisation" => "modERnizasj§",
"modernisations" => "modERnizasj§",
"modernise" => "modERniz",
"modernisé" => "modERnize",
"modernisée" => "modERnize",
"modernisent" => "modERniz",
"moderniser" => "modERnize",
"modernisés" => "modERnize",
"modernisme" => "modERnizm",
"modernisons" => "modERniz§",
"modernissime" => "mOdERnisim",
"moderniste" => "modERnist",
"modernistes" => "modERnist",
"modernité" => "modERnite",
"modernités" => "modERnite",
"modes" => "mOd",
"modeste" => "modEst",
"modestement" => "modEst°m@",
"modestes" => "modEst",
"modestie" => "modEsti",
"modesties" => "modEsti",
"modicité" => "modisite",
"modifia" => "modifja",
"modifiable" => "modifjabl",
"modifiables" => "modifjabl",
"modifiaient" => "modifjE",
"modifiais" => "modifjE",
"modifiait" => "modifjE",
"modifiant" => "modifj@",
"modifiât" => "modifja",
"modificateur" => "modifikat9R",
"modification" => "modifikasj§",
"modifications" => "modifikasj§",
"modifie" => "modifi",
"modifié" => "modifje",
"modifiée" => "modifje",
"modifiées" => "modifje",
"modifient" => "modifi",
"modifier" => "modifje",
"modifiera" => "modifiRa",
"modifierai" => "modifiRE",
"modifieraient" => "modifiRE",
"modifierais" => "modifiRE",
"modifierait" => "modifiRE",
"modifièrent" => "modifjER",
"modifiés" => "modifje",
"modifiez" => "modifje",
"modifions" => "modifj§",
"modillon" => "modij§",
"modillons" => "modij§",
"modique" => "modik",
"modiques" => "modik",
"modiste" => "modist",
"modistes" => "modist",
"modula" => "modyla",
"modulable" => "modylabl",
"modulables" => "modylabl",
"modulai" => "modylE",
"modulaire" => "modylER",
"modulaires" => "modylER",
"modulais" => "modylE",
"modulait" => "modylE",
"modulant" => "modyl@",
"modulateur" => "modylat9R",
"modulation" => "modylasj§",
"modulations" => "modylasj§",
"module" => "modyl",
"modulé" => "modyle",
"modulée" => "modyle",
"modulées" => "modyle",
"modulent" => "modyl",
"moduler" => "modyle",
"modules" => "modyl",
"modulés" => "modyle",
"modus operandi" => "modusopeR@di",
"modus vivendi" => "modusvivEndi",
"moelle" => "mwal",
"moelles" => "mwal",
"moelleuse" => "mwal2z",
"moelleusement" => "mwal2z°m@",
"moelleuses" => "mwal2z",
"moelleux" => "mwal2",
"moellon" => "mwal§",
"moellons" => "mwel§",
"moeurs" => "m9Rs",
"moghol" => "mOgOl",
"mogol" => "mogOl",
"mohair" => "moER",
"mohairs" => "moER",
"mohican" => "mOik@",
"moho" => "moo",
"moi" => "mwa",
"moï" => "mOj",
"moi-même" => "mwamEm",
"moi-moi-moi" => "mwamwamwa",
"moignon" => "mwaN§",
"moignons" => "mwaN§",
"moindre" => "mw5dR",
"moindrement" => "mw5dR°m@",
"moindres" => "mw5dR",
"moine" => "mwan",
"moineau" => "mwano",
"moineaux" => "mwano",
"moines" => "mwan",
"moinillon" => "mwanij§",
"moinillons" => "mwanij§",
"moins" => "mw5",
"moiraient" => "mwaRE",
"moire" => "mwaR",
"moiré" => "mwaRe",
"moirée" => "mwaRe",
"moirées" => "mwaRe",
"moires" => "mwaR",
"moirés" => "mwaRe",
"moirure" => "mwaRyR",
"moirures" => "mwaRyR",
"mois" => "mwa",
"moise" => "mwaz",
"moïse" => "moiz",
"moises" => "mwaz",
"moisi" => "mwazi",
"moisie" => "mwazi",
"moisies" => "mwazi",
"moisir" => "mwaziR",
"moisira" => "mwaziRa",
"moisirai" => "mwaziRE",
"moisiraient" => "mwaziRE",
"moisirais" => "mwaziRE",
"moisirait" => "mwaziRE",
"moisiras" => "mwaziRa",
"moisirez" => "mwaziRe",
"moisiront" => "mwaziR§",
"moisis" => "mwazi",
"moisissaient" => "mwazisE",
"moisissais" => "mwazisE",
"moisissait" => "mwazisE",
"moisissant" => "mwazis@",
"moisisse" => "mwazis",
"moisissent" => "mwazis",
"moisissez" => "mwazise",
"moisissure" => "mwazisyR",
"moisissures" => "mwazisyR",
"moisit" => "mwazi",
"moisson" => "mwas§",
"moissonnait" => "mwasonE",
"moissonnant" => "mwason@",
"moissonne" => "mwasOn",
"moissonné" => "mwasone",
"moissonnée" => "mwasone",
"moissonnées" => "mwasone",
"moissonnent" => "mwasOn",
"moissonner" => "mwasone",
"moissonnera" => "mwasOn°Ra",
"moissonnerai" => "mwasOn°RE",
"moissonnés" => "mwasone",
"moissonneur" => "mwason9R",
"moissonneurs" => "mwason9R",
"moissonneuse" => "mwason2z",
"moissonneuse-batteuse" => "mwason2zbat2z",
"moissonneuse-lieuse" => "mwason2zlj2z",
"moissonneuses" => "mwason2z",
"moissonneuses-batteuses" => "mwason2zbat2z",
"moissonneuses-lieuses" => "mwason2zlj2z",
"moissonnez" => "mwasone",
"moissons" => "mwas§",
"moite" => "mwat",
"moites" => "mwat",
"moiteur" => "mwat9R",
"moiteurs" => "mwat9R",
"moiti" => "mwati",
"moitié" => "mwatje",
"moitié-moitié" => "mwatjemwatje",
"moitiés" => "mwatje",
"moka" => "moka",
"mokas" => "moka",
"moko" => "moko",
"mol" => "mOl",
"molaire" => "molER",
"molaires" => "molER",
"molard" => "mOlaR",
"molasse" => "molas",
"moldave" => "mOldav",
"moldaves" => "mOldav",
"mole" => "mOl",
"môle" => "mol",
"moléculaire" => "molekylER",
"moléculaires" => "molekylER",
"molécule" => "molekyl",
"molécules" => "molekyl",
"molènes" => "molEn",
"moles" => "mOl",
"môles" => "mol",
"moleskine" => "molEskin",
"molesquine" => "molEskin",
"molesta" => "molEsta",
"molestaient" => "molEstE",
"molestant" => "molEst@",
"molestation" => "molEstasj§",
"moleste" => "molEst",
"molesté" => "molEste",
"molestée" => "molEste",
"molester" => "molEste",
"molestés" => "molEste",
"molestez" => "molEste",
"moleta" => "mol°ta",
"molette" => "molEt",
"molettes" => "molEt",
"moliéresque" => "moljeREsk",
"mollah" => "mola",
"mollahs" => "mola",
"mollard" => "molaR",
"mollardé" => "molaRde",
"mollarder" => "molaRde",
"mollards" => "molaR",
"mollasse" => "molas",
"mollasses" => "molas",
"mollasson" => "molas§",
"mollassonne" => "molasOn",
"mollassons" => "molas§",
"molle" => "mOl",
"mollement" => "mOl°m@",
"molles" => "mOl",
"mollesse" => "molEs",
"mollesses" => "molEs",
"mollet" => "molE",
"molletière" => "mOl°tjER",
"molletières" => "mOl°tjER",
"molleton" => "mOl°t§",
"molletonné" => "mOl°tone",
"molletonnée" => "mOl°tone",
"molletonneux" => "mOl°ton2",
"molletons" => "mOl°t§",
"mollets" => "molE",
"mollette" => "molEt",
"mollettes" => "molEt",
"molli" => "moli",
"mollie" => "moli",
"mollir" => "moliR",
"mollis" => "moli",
"mollissaient" => "molisE",
"mollissait" => "molisE",
"mollissant" => "molis@",
"mollisse" => "molis",
"mollissent" => "molis",
"mollissez" => "molise",
"mollit" => "moli",
"mollo" => "molo",
"mollusque" => "molysk",
"mollusques" => "molysk",
"moloch" => "molOk",
"molosse" => "molOs",
"molosses" => "molOs",
"mols" => "mOl",
"molto" => "mOlto",
"moly" => "mOli",
"molybdène" => "mOlibdEn",
"moman" => "mom@",
"mombin" => "m§b5",
"môme" => "mom",
"moment" => "mom@",
"moment-clé" => "mom@kle",
"momentané" => "mom@tane",
"momentanée" => "mom@tane",
"momentanées" => "mom@tane",
"momentanément" => "mom@tanem@",
"momentanés" => "mom@tane",
"moments" => "mom@",
"moments-clés" => "mom@kle",
"momerie" => "mom°Ri",
"momeries" => "mom°Ri",
"mômeries" => "mom°Ri",
"mômes" => "mom",
"momichons" => "momiS§",
"momie" => "momi",
"momies" => "momi",
"momifiait" => "momifjE",
"momifiant" => "momifj@",
"momification" => "momifikasj§",
"momifie" => "momifi",
"momifié" => "momifje",
"momifiée" => "momifje",
"momifiées" => "momifje",
"momifier" => "momifje",
"momifiés" => "momifje",
"mominette" => "mOminEt",
"mon" => "m§",
"monacal" => "monakal",
"monacale" => "monakal",
"monacales" => "monakal",
"monachisme" => "monaSizm",
"monades" => "monad",
"monadologie" => "mOnadOlOZi",
"monarchie" => "monaRSi",
"monarchies" => "monaRSi",
"monarchique" => "monaRSik",
"monarchiste" => "monaRSist",
"monarchistes" => "monaRSist",
"monarque" => "monaRk",
"monarques" => "monaRk",
"monastère" => "monastER",
"monastères" => "monastER",
"monastique" => "monastik",
"monastiques" => "monastik",
"monbazillac" => "m§bazijak",
"monceau" => "m§so",
"monceaux" => "m§so",
"monda" => "m§da",
"mondain" => "m§d5",
"mondaine" => "m§dEn",
"mondainement" => "m§dEn°m@",
"mondaines" => "m§dEn",
"mondains" => "m§d5",
"mondanisaient" => "m§danizE",
"mondanisé" => "m§danize",
"mondanité" => "m§danite",
"mondanités" => "m§danite",
"monde" => "m§d",
"mondée" => "m§de",
"monder" => "m§de",
"mondes" => "m§d",
"mondial" => "m§djal",
"mondiale" => "m§djal",
"mondialement" => "m§djal°m@",
"mondiales" => "m§djal",
"mondialisation" => "m§djalizasj§",
"mondialisent" => "m§djaliz",
"mondialistes" => "m§djalist",
"mondiaux" => "m§djo",
"mondovision" => "m§dovizj§",
"monétaire" => "monetER",
"monétaires" => "monetER",
"monétariste" => "monetaRist",
"mongo" => "m§go",
"mongol" => "m§gOl",
"mongole" => "m§gOl",
"mongoles" => "m§gOl",
"mongolie" => "m§gOli",
"mongolien" => "m§golj5",
"mongolienne" => "m§goljEn",
"mongoliennes" => "m§goljEn",
"mongoliens" => "m§golj5",
"mongolique" => "m§golik",
"mongoliques" => "m§golik",
"mongoloïde" => "m§goloid",
"mongols" => "m§gOl",
"moniale" => "monjal",
"moniales" => "monjal",
"moniteur" => "monit9R",
"moniteurs" => "monit9R",
"monition" => "mOnisj§",
"monitor" => "monitOR",
"monitorage" => "mOnitORaZ",
"monitoring" => "monitoRiG",
"monitrice" => "monitRis",
"monitrices" => "monitRis",
"monnaie" => "monE",
"monnaie-du-pape" => "monEdypap",
"monnaiera" => "monERa",
"monnaierai" => "monERE",
"monnaies" => "monE",
"monnaies-du-pape" => "monEdypap",
"monnaya" => "monEja",
"monnayable" => "monEjabl",
"monnayables" => "monEjabl",
"monnayait" => "monejE",
"monnayant" => "monej@",
"monnaye" => "monej",
"monnayé" => "moneje",
"monnayée" => "moneje",
"monnayer" => "moneje",
"monnayeur" => "mOnEj9R",
"monnayeurs" => "monEj9R",
"mono" => "mono",
"monoamine" => "monoamin",
"monobloc" => "monoblOk",
"monocellulaire" => "monoselylER",
"monochrome" => "monokRom",
"monochromes" => "monokRom",
"monochromie" => "monokRomi",
"monocle" => "monOkl",
"monoclé" => "mOnOkle",
"monocles" => "monOkl",
"monoclonal" => "monoklonal",
"monoclonaux" => "monoklono",
"monocoque" => "monokOk",
"monocorde" => "monokORd",
"monocordes" => "monokORd",
"monocratie" => "monokRasi",
"monoculaire" => "monokylER",
"monoculaires" => "monokylER",
"monoculture" => "monokyltyR",
"monocycle" => "monosikl",
"monocylindre" => "monosil5dR",
"monodie" => "monodi",
"monofilament" => "monofilam@",
"monogame" => "monogam",
"monogames" => "monogam",
"monogamie" => "monogami",
"monogramme" => "monogRam",
"monogrammées" => "monogRame",
"monogrammes" => "monogRam",
"monographie" => "monogRafi",
"monographies" => "monogRafi",
"monokini" => "monokini",
"monolinguisme" => "monol5g8ism",
"monolithe" => "monolit",
"monolithes" => "monolit",
"monolithique" => "monolitik",
"monolithiques" => "monolitik",
"monolithisme" => "monolitizm",
"monologua" => "monologa",
"monologuaient" => "monologE",
"monologuais" => "monologE",
"monologuait" => "monologE",
"monologuant" => "monolog@",
"monologue" => "monolOg",
"monologuer" => "monologe",
"monologues" => "monolOg",
"monomane" => "monoman",
"monomanes" => "monoman",
"monomaniaque" => "monomanjak",
"monomaniaques" => "monomanjak",
"monomanie" => "monomani",
"monômes" => "monom",
"monomoteur" => "monomot9R",
"monomoteurs" => "monomot9R",
"mononucléaire" => "mononykleER",
"mononucléose" => "mononykleoz",
"monoparental" => "monopaR@tal",
"monoparentale" => "monopaR@tal",
"monoparentales" => "monopaR@tal",
"monoparentaux" => "monopaR@to",
"monophasée" => "monofaze",
"monoplace" => "monoplas",
"monoplaces" => "monoplas",
"monoplan" => "monopl@",
"monoplans" => "monopl@",
"monopode" => "monopOd",
"monopole" => "monopOl",
"monopoles" => "monopOl",
"monopolisa" => "monopoliza",
"monopolisaient" => "monopolizE",
"monopolisais" => "monopolizE",
"monopolisait" => "monopolizE",
"monopolise" => "monopoliz",
"monopolisé" => "mOnOpOlize",
"monopolisent" => "monopoliz",
"monopoliser" => "monopolize",
"monopolisera" => "monopoliz°Ra",
"monopolisèrent" => "monopolizER",
"monopolisés" => "monopolize",
"monopolisez" => "monopolize",
"monopoly" => "monopoli",
"monoprix" => "monopRi",
"monorail" => "monoRaj",
"monorails" => "monoRaj",
"monospace" => "monospas",
"monosyllabe" => "monosilab",
"monosyllabes" => "monosilab",
"monosyllabique" => "monosilabik",
"monosyllabiques" => "monosilabik",
"monothéisme" => "monoteizm",
"monothéismes" => "monoteizm",
"monothéiste" => "monoteist",
"monothéistes" => "monoteist",
"monotone" => "monotOn",
"monotonement" => "monotOn°m@",
"monotones" => "monotOn",
"monotonie" => "monotoni",
"monotype" => "monotip",
"monoxyde" => "monOksid",
"monoxyle" => "monOksil",
"mons" => "m§s",
"monseigneur" => "m§sEN9R",
"monsieur" => "m°sj2",
"monsignor" => "m§siNOR",
"monsignore" => "m§siNOR",
"monstrance" => "m§stR@s",
"monstrances" => "m§stR@s",
"monstre" => "m§stR",
"monstres" => "m§stR",
"monstrueuse" => "m§stRy2z",
"monstrueusement" => "m§stRy2z°m@",
"monstrueuses" => "m§stRy2z",
"monstrueux" => "m§stRy2",
"monstruosité" => "m§stRyozite",
"monstruosités" => "m§stRyozite",
"mont" => "m§",
"mont-blanc" => "m§bl@",
"mont-de-piété" => "m§d°pjete",
"monta" => "m§ta",
"montage" => "m§taZ",
"montages" => "m§taZ",
"montagnard" => "m§taNaR",
"montagnarde" => "m§taNaRd",
"montagnardes" => "m§taNaRd",
"montagnards" => "m§taNaR",
"montagne" => "m§taN",
"montagnes" => "m§taN",
"montagneuse" => "m§taN2z",
"montagneuses" => "m§taN2z",
"montagneux" => "m§taN2",
"montai" => "m§tE",
"montaient" => "m§tE",
"montais" => "m§tE",
"montaison" => "m§tEz§",
"montait" => "m§tE",
"montâmes" => "m§tam",
"montant" => "m§t@",
"montante" => "m§t@t",
"montantes" => "m§t@t",
"montants" => "m§t@",
"montât" => "m§ta",
"monte" => "m§t",
"monté" => "m§te",
"monte-charge" => "m§tSaRZ",
"monte-charges" => "m§tSaRZ",
"monte-en-l'air" => "m§t@lER",
"monte-plat" => "m§tpla",
"monte-plats" => "m§tpla",
"montée" => "m§te",
"montées" => "m§te",
"monténégrin" => "m§tenegR5",
"monténégrines" => "m§tenegRin",
"montent" => "m§t",
"monter" => "m§te",
"montera" => "m§t°Ra",
"monterai" => "m§t°RE",
"monteraient" => "m§t°RE",
"monterais" => "m§t°RE",
"monterait" => "m§t°RE",
"monteras" => "m§t°Ra",
"montèrent" => "m§tER",
"monterez" => "m§t°Re",
"monteriez" => "m§t°Rje",
"monterons" => "m§t°R§",
"monteront" => "m§t°R§",
"montes" => "m§t",
"montés" => "m§te",
"monteur" => "m§t9R",
"monteurs" => "m§t9R",
"monteuse" => "m§t2z",
"montez" => "m§te",
"montgolfière" => "m§gOlfjER",
"montgolfières" => "m§gOlfjER",
"monticule" => "m§tikyl",
"monticules" => "m§tikyl",
"montiez" => "m§tje",
"montions" => "m§tj§",
"montjoie" => "m§Zwa",
"montmartrois" => "m§maRtRwa",
"montmartroise" => "m§maRtRwaz",
"montmartroises" => "m§maRtRwaz",
"montons" => "m§t§",
"montparno" => "m§paRno",
"montpelliéraine" => "m§p°ljeREn",
"montra" => "m§tRa",
"montrable" => "m§tRabl",
"montrables" => "m§tRabl",
"montrai" => "m§tRE",
"montraient" => "m§tRE",
"montrais" => "m§tRE",
"montrait" => "m§tRE",
"montrâmes" => "m§tRam",
"montrant" => "m§tR@",
"montrassent" => "m§tRas",
"montrât" => "m§tRa",
"montre" => "m§tR",
"montré" => "m§tRe",
"montre-bracelet" => "m§tR°bRas°lE",
"montre-gousset" => "m§tRgusE",
"montre-la-moi" => "m§tR°lamwa",
"montrée" => "m§tRe",
"montrées" => "m§tRe",
"montrent" => "m§tR",
"montrer" => "m§tRe",
"montrera" => "m§tR°Ra",
"montrerai" => "m§tR°RE",
"montreraient" => "m§tR°RE",
"montrerais" => "m§tR°RE",
"montrerait" => "m§tR°RE",
"montreras" => "m§tR°Ra",
"montrèrent" => "m§tRER",
"montrerez" => "m§tR°Re",
"montreriez" => "m§tR°Rje",
"montrerons" => "m§tR°R§",
"montreront" => "m§tR°R§",
"montres" => "m§tR",
"montrés" => "m§tRe",
"montres-bracelets" => "m§tR°bRas°lE",
"montreur" => "m§tR9R",
"montreurs" => "m§tR9R",
"montreuse" => "m§tR2z",
"montreuses" => "m§tR2z",
"montrez" => "m§tRe",
"montriez" => "m§tRije",
"montrions" => "m§tRij§",
"montrons" => "m§tR§",
"monts" => "m§",
"monts-blancs" => "m§bl@",
"montueuse" => "m§t82z",
"montueuses" => "m§t82z",
"montueux" => "m§t82",
"monture" => "m§tyR",
"montures" => "m§tyR",
"monument" => "monym@",
"monumental" => "monym@tal",
"monumentale" => "monym@tal",
"monumentalement" => "mOnym@tal°m@",
"monumentales" => "monym@tal",
"monumentalité" => "mOnym@talite",
"monumentaux" => "monym@to",
"monuments" => "monym@",
"moonisme" => "munizm",
"moonistes" => "munist",
"mooré" => "mORe",
"moos" => "mOs",
"moose" => "muz",
"moqua" => "moka",
"moquai" => "mokE",
"moquaient" => "mokE",
"moquais" => "mokE",
"moquait" => "mokE",
"moquant" => "mok@",
"moquât" => "moka",
"moque" => "mOk",
"moqué" => "moke",
"moquée" => "moke",
"moquées" => "moke",
"moquent" => "mOk",
"moquer" => "moke",
"moquera" => "mOk°Ra",
"moquerai" => "mOk°RE",
"moqueraient" => "mOk°RE",
"moquerais" => "mOk°RE",
"moquerait" => "mOk°RE",
"moqueras" => "mOk°Ra",
"moquèrent" => "mokER",
"moquerez" => "mOk°Re",
"moquerie" => "mOk°Ri",
"moqueries" => "mOk°Ri",
"moqueriez" => "mOk°Rje",
"moqueront" => "mOk°R§",
"moques" => "mOk",
"moqués" => "moke",
"moquette" => "mokEt",
"moquetté" => "mokete",
"moquettées" => "mokete",
"moquettes" => "mokEt",
"moquettés" => "mokete",
"moqueur" => "mok9R",
"moqueurs" => "mok9R",
"moqueuse" => "mok2z",
"moqueusement" => "mok2z°m@",
"moqueuses" => "mok2z",
"moquez" => "moke",
"moquiez" => "mokje",
"moquions" => "mokj§",
"moquons" => "mok§",
"moraillon" => "moRaj§",
"moraine" => "moREn",
"moraines" => "moREn",
"morainique" => "moREnik",
"morainiques" => "moREnik",
"moral" => "moRal",
"morale" => "moRal",
"moralement" => "moRal°m@",
"morales" => "moRal",
"moralisante" => "moRaliz@t",
"moralisateur" => "moRalizat9R",
"moralisateurs" => "moRalizat9R",
"moralisation" => "moRalizasj§",
"moralisatrice" => "moRalizatRis",
"moralise" => "moRaliz",
"moralisée" => "moRalize",
"moraliser" => "moRalize",
"moralisme" => "moRalizm",
"moraliste" => "moRalist",
"moralistes" => "moRalist",
"moralité" => "moRalite",
"moralités" => "moRalite",
"morasse" => "moRas",
"morasses" => "moRas",
"moratoire" => "moRatwaR",
"moraux" => "moRo",
"morave" => "mORav",
"moraves" => "moRav",
"morbac" => "mORbak",
"morbacs" => "mORbak",
"morbaque" => "mORbak",
"morbaques" => "mORbak",
"morbide" => "mORbid",
"morbidement" => "mORbid°m@",
"morbides" => "mORbid",
"morbidesse" => "mORbidEs",
"morbidité" => "mORbidite",
"morbier" => "mORbje",
"morbleu" => "mORbl2",
"morceau" => "mORso",
"morceaux" => "mORso",
"morcela" => "mORs°la",
"morcelait" => "mORs°lE",
"morcelant" => "mORs°l@",
"morcelé" => "mORs°le",
"morcelée" => "mORs°le",
"morcelées" => "mORs°le",
"morceler" => "mORs°le",
"morcelés" => "mORs°le",
"morcellement" => "mORsEl°m@",
"morcellements" => "mORsEl°m@",
"morcellent" => "mORsEl",
"morcellera" => "mORsEl°Ra",
"morcif" => "mORsif",
"morcifs" => "mORsif",
"mord" => "mOR",
"mordaient" => "mORdE",
"mordais" => "mORdE",
"mordait" => "mORdE",
"mordançage" => "mORd@saZ",
"mordant" => "mORd@",
"mordante" => "mORd@t",
"mordantes" => "mORd@t",
"mordants" => "mORd@",
"morde" => "mORd",
"mordent" => "mORd",
"mordes" => "mORd",
"mordeur" => "mORd9R",
"mordeurs" => "mORd9R",
"mordeuse" => "mORd2z",
"mordez" => "mORde",
"mordicus" => "mORdikys",
"mordieu" => "mORdj2",
"mordilla" => "mORdija",
"mordillage" => "mORdijaZ",
"mordillaient" => "mORdijE",
"mordillais" => "mORdijE",
"mordillait" => "mORdijE",
"mordillant" => "mORdij@",
"mordille" => "mORdij",
"mordillé" => "mORdije",
"mordillée" => "mORdije",
"mordillées" => "mORdije",
"mordillement" => "mORdij°m@",
"mordillements" => "mORdij°m@",
"mordillent" => "mORdij",
"mordiller" => "mORdije",
"mordillera" => "mORdij°Ra",
"mordillés" => "mORdije",
"mordillez" => "mORdije",
"mordions" => "mORdj§",
"mordirent" => "mORdiR",
"mordis" => "mORdi",
"mordissent" => "mORdis",
"mordit" => "mORdi",
"mordît" => "mORdi",
"mordorait" => "mORdoRE",
"mordoré" => "mORdoRe",
"mordorée" => "mORdoRe",
"mordorées" => "mORdoRe",
"mordorés" => "mORdoRe",
"mordra" => "mORdRa",
"mordrai" => "mORdRE",
"mordraient" => "mORdRE",
"mordrais" => "mORdRE",
"mordrait" => "mORdRE",
"mordras" => "mORdRa",
"mordre" => "mORdR",
"mordrez" => "mORdRe",
"mordront" => "mORdR§",
"mords" => "mOR",
"mordu" => "mORdy",
"mordue" => "mORdy",
"mordues" => "mORdy",
"mordus" => "mORdy",
"more" => "mOR",
"moreau" => "mORo",
"morelle" => "mOREl",
"mores" => "mOR",
"moresque" => "moREsk",
"morfal" => "mORfal",
"morfale" => "mORfal",
"morfalé" => "mORfale",
"morfalée" => "mORfale",
"morfaler" => "mORfale",
"morfales" => "mORfal",
"morfalés" => "mORfale",
"morfalou" => "mORfalu",
"morfals" => "mORfal",
"morfil" => "mORfil",
"morflais" => "mORflE",
"morflait" => "mORflE",
"morfle" => "mORfl",
"morflé" => "mORfle",
"morflée" => "mORfle",
"morfler" => "mORfle",
"morflera" => "mORfl°Ra",
"morfleras" => "mORfl°Ra",
"morflerez" => "mORfl°Re",
"morfles" => "mORfl",
"morfond" => "mORf§",
"morfondaient" => "mORf§dE",
"morfondais" => "mORf§dE",
"morfondait" => "mORf§dE",
"morfondant" => "mORf§d@",
"morfonde" => "mORf§d",
"morfondis" => "mORf§di",
"morfondra" => "mORf§dRa",
"morfondre" => "mORf§dR",
"morfonds" => "mORf§",
"morfondu" => "mORf§dy",
"morfondue" => "mORf§dy",
"morgana" => "mORgana",
"morganatique" => "mORganatik",
"morganatiques" => "mORganatik",
"morgane" => "mORgan",
"morganer" => "mORgane",
"morganerai" => "mORgan°RE",
"morgeline" => "mORZ2lin",
"morgon" => "mORg§",
"morgue" => "mORg",
"morgues" => "mORg",
"moria" => "mORja",
"moribond" => "moRib§",
"moribonde" => "moRib§d",
"moribondes" => "moRib§d",
"moribonds" => "moRib§",
"moricaud" => "moRiko",
"moricaude" => "moRikod",
"moricaudes" => "moRikod",
"moricauds" => "moRiko",
"morigéna" => "moRiZena",
"morigénai" => "moRiZenE",
"morigénais" => "moRiZenE",
"morigénait" => "moRiZenE",
"morigénant" => "moRiZen@",
"morigène" => "moRiZEn",
"morigéné" => "moRiZene",
"morigénée" => "moRiZene",
"morigéner" => "moRiZene",
"morille" => "moRij",
"morilles" => "moRij",
"morillon" => "moRij§",
"morillons" => "moRij§",
"morlingue" => "mORl5g",
"morlingues" => "mORl5g",
"mormon" => "mORm§",
"mormone" => "mORmOn",
"mormones" => "mORmOn",
"mormons" => "mORm§",
"morne" => "mORn",
"mornement" => "mORn2m@",
"mornes" => "mORn",
"mornifle" => "mORnifl",
"moro" => "moRo",
"morose" => "moRoz",
"morosement" => "mORoz°m@",
"moroses" => "moRoz",
"morosité" => "moRozite",
"morosités" => "moRozite",
"morphine" => "mORfin",
"morphing" => "mORfiG",
"morphinomane" => "mORfinoman",
"morphique" => "mORfik",
"morpho" => "mORfo",
"morphogenèse" => "mORfoZ2nEz",
"morphogénétique" => "mORfoZenetik",
"morphologie" => "mORfoloZi",
"morphologique" => "mORfoloZik",
"morphologiques" => "mORfoloZik",
"morpion" => "mORpj§",
"morpions" => "mORpj§",
"mors" => "mOR",
"morse" => "mORs",
"morsure" => "mORsyR",
"morsures" => "mORsyR",
"mort" => "mOR",
"mort-aux-rats" => "mORoRa",
"mort-né" => "mORne",
"mort-née" => "mORne",
"mort-nées" => "mORne",
"mort-nés" => "mORne",
"mort-vivant" => "mORviv@",
"mortadelle" => "mORtadEl",
"mortaise" => "mORtEz",
"mortaiser" => "mORtEze",
"mortaises" => "mORtEz",
"mortaiseuse" => "mORtEz2z",
"mortalité" => "mORtalite",
"morte" => "mORt",
"morte-saison" => "mORtsEz§",
"mortel" => "mORtEl",
"mortelle" => "mORtEl",
"mortellement" => "mORtEl°m@",
"mortelles" => "mORtEl",
"mortels" => "mORtEl",
"mortes" => "mORt",
"mortes-eaux" => "mORt°zo",
"mortes-saisons" => "mORtsEz§",
"mortibus" => "mORtibys",
"mortier" => "mORtje",
"mortiers" => "mORtje",
"mortifère" => "mORtifER",
"mortifères" => "mORtifER",
"mortifia" => "mORtifja",
"mortifiai" => "mORtifjE",
"mortifiaient" => "mORtifjE",
"mortifiait" => "mORtifjE",
"mortifiant" => "mORtifj@",
"mortifiante" => "mORtifj@t",
"mortifiantes" => "mORtifj@t",
"mortifiants" => "mORtifj@",
"mortification" => "mORtifikasj§",
"mortifications" => "mORtifikasj§",
"mortifie" => "mORtifi",
"mortifié" => "mORtifje",
"mortifiée" => "mORtifje",
"mortifier" => "mORtifje",
"mortifiés" => "mORtifje",
"morts" => "mOR",
"morts-vivants" => "mORviv@",
"mortuaire" => "mORt8ER",
"mortuaires" => "mORt8ER",
"morue" => "moRy",
"morues" => "moRy",
"morula" => "mORyla",
"morvandiau" => "mORv@djo",
"morve" => "mORv",
"morves" => "mORv",
"morveuse" => "mORv2z",
"morveuses" => "mORv2z",
"morveux" => "mORv2",
"mos" => "mos",
"mosaïque" => "mozaik",
"mosaïquée" => "mozaike",
"mosaïques" => "mozaik",
"mosaïqués" => "mozaike",
"mosaïste" => "mozaist",
"moscoutaire" => "mOskutER",
"moscovite" => "mOskovit",
"moscovites" => "mOskovit",
"mosellane" => "mozElan",
"mosellanes" => "mozElan",
"mosquée" => "mOske",
"mosquées" => "mOske",
"mot" => "mo",
"mot-clé" => "mokle",
"mot-valise" => "movaliz",
"motard" => "motaR",
"motarde" => "motaRd",
"motardes" => "motaRd",
"motards" => "motaR",
"motel" => "motEl",
"motels" => "motEl",
"motesse" => "mOtEs",
"motet" => "motE",
"motets" => "motE",
"moteur" => "mot9R",
"moteur-fusée" => "mOt9Rfyze",
"moteurs" => "mot9R",
"moteurs-fusées" => "mot9Rfyze",
"motif" => "motif",
"motifs" => "motif",
"motilité" => "mOtilite",
"motion" => "mosj§",
"motions" => "mosj§",
"motiva" => "motiva",
"motivai" => "motivE",
"motivaient" => "motivE",
"motivais" => "motivE",
"motivait" => "motivE",
"motivant" => "motiv@",
"motivante" => "mOtiv@t",
"motivateur" => "motivat9R",
"motivation" => "motivasj§",
"motivations" => "motivasj§",
"motive" => "motiv",
"motivé" => "motive",
"motivée" => "motive",
"motivées" => "motive",
"motivent" => "motiv",
"motiver" => "motive",
"motivera" => "motiv°Ra",
"motivés" => "motive",
"motivez" => "motive",
"moto" => "moto",
"moto-club" => "motokl9b",
"moto-cross" => "motokROs",
"motocross" => "motokROs",
"motoculteur" => "motokylt9R",
"motoculture" => "motokyltyR",
"motocycles" => "motosikl",
"motocyclette" => "motosiklEt",
"motocyclettes" => "motosiklEt",
"motocyclisme" => "motosiklism",
"motocycliste" => "motosiklist",
"motocyclistes" => "motosiklist",
"motoneige" => "motonEZ",
"motoneiges" => "motonEZ",
"motoneurone" => "moton2ROn",
"motorisation" => "motoRizasj§",
"motorisé" => "motoRize",
"motorisée" => "motoRize",
"motorisées" => "motoRize",
"motoriser" => "motoRize",
"motorisés" => "motoRize",
"motos" => "moto",
"motrice" => "motRis",
"motrices" => "motRis",
"motricité" => "motRisite",
"mots" => "mo",
"mots-clefs" => "mokle",
"mots-clés" => "mokle",
"mots-croisés" => "mokRwaze",
"motte" => "mOt",
"mottereau" => "mOt°Ro",
"mottes" => "mOt",
"motteux" => "mot2",
"motu proprio" => "motypRopRio",
"motus" => "motys",
"mou" => "mu",
"mouais" => "mwE",
"moucha" => "muSa",
"mouchachou" => "muSaSu",
"mouchage" => "muSaZ",
"mouchai" => "muSE",
"mouchaient" => "muSE",
"mouchait" => "muSE",
"mouchant" => "muS@",
"mouchard" => "muSaR",
"moucharda" => "muSaRda",
"mouchardage" => "muSaRdaZ",
"mouchardait" => "muSaRdE",
"moucharde" => "muSaRd",
"mouchardé" => "muSaRde",
"mouchardent" => "muSaRd",
"moucharder" => "muSaRde",
"mouchardera" => "muSaRd°Ra",
"moucharderait" => "muSaRd°RE",
"mouchardes" => "muSaRd",
"mouchards" => "muSaR",
"mouche" => "muS",
"mouché" => "muSe",
"mouchée" => "muSe",
"mouchent" => "muS",
"moucher" => "muSe",
"moucheron" => "muS°R§",
"moucherons" => "muS°R§",
"mouches" => "muS",
"mouchés" => "muSe",
"mouchetait" => "muS°tE",
"mouchetant" => "muS°t@",
"moucheté" => "muS°te",
"mouchetée" => "muS°te",
"mouchetées" => "muS°te",
"mouchetés" => "muS°te",
"mouchette" => "muSEt",
"moucheture" => "muS°tyR",
"mouchetures" => "muS°tyR",
"moucheur" => "muS9R",
"mouchez" => "muSe",
"mouchoir" => "muSwaR",
"mouchoirs" => "muSwaR",
"mouchons" => "muS§",
"moud" => "mu",
"moudjahiddine" => "mudZaidin",
"moudjahidin" => "mudZaid5",
"moudjahidine" => "mudZaidin",
"moudrai" => "mudRE",
"moudre" => "mudR",
"mouds" => "mu",
"moue" => "mu",
"moues" => "mu",
"mouette" => "mwEt",
"mouettes" => "mwEt",
"moufetait" => "muf°tE",
"moufeté" => "muf°te",
"moufette" => "mufEt",
"mouffette" => "mufEt",
"moufle" => "mufl",
"moufles" => "mufl",
"mouflet" => "muflE",
"mouflets" => "muflE",
"mouflette" => "muflEt",
"mouflettes" => "muflEt",
"mouflon" => "mufl§",
"mouflons" => "mufl§",
"mouftaient" => "muftE",
"mouftais" => "muftE",
"mouftait" => "muftE",
"moufte" => "muft",
"moufté" => "mufte",
"mouftent" => "muft",
"moufter" => "mufte",
"mouftera" => "muft°Ra",
"mouftes" => "muft",
"mouftez" => "mufte",
"mouilla" => "muja",
"mouillage" => "mujaZ",
"mouillages" => "mujaZ",
"mouillaient" => "mujE",
"mouillais" => "mujE",
"mouillait" => "mujE",
"mouillant" => "muj@",
"mouillante" => "muj@t",
"mouillasse" => "mujas",
"mouille" => "muj",
"mouillé" => "muje",
"mouillée" => "muje",
"mouillées" => "muje",
"mouillent" => "muj",
"mouiller" => "muje",
"mouillera" => "muj°Ra",
"mouillerai" => "muj°RE",
"mouillerais" => "muj°RE",
"mouillerait" => "muj°RE",
"mouilleras" => "muj°Ra",
"mouillèrent" => "mujER",
"mouilleront" => "muj°R§",
"mouilles" => "muj",
"mouillés" => "muje",
"mouillette" => "mujEt",
"mouillettes" => "mujEt",
"mouilleur" => "muj9R",
"mouilleuse" => "muj2z",
"mouillez" => "muje",
"mouillon" => "muj§",
"mouillons" => "muj§",
"mouillure" => "mujyR",
"mouillures" => "mujyR",
"mouise" => "mwiz",
"moujahid" => "muZai",
"moujik" => "muZik",
"moujiks" => "muZik",
"moujingue" => "muZ5g",
"moujingues" => "muZ5g",
"moukère" => "mukER",
"moukères" => "mukER",
"moula" => "mula",
"moulage" => "mulaZ",
"moulages" => "mulaZ",
"moulaient" => "mulE",
"moulait" => "mulE",
"moulant" => "mul@",
"moulante" => "mul@t",
"moulantes" => "mul@t",
"moulants" => "mul@",
"moule" => "mul",
"moulé" => "mule",
"moulée" => "mule",
"moulées" => "mule",
"moulent" => "mul",
"mouler" => "mule",
"mouleraient" => "mul°RE",
"moulerait" => "mul°RE",
"moules" => "mul",
"moulés" => "mule",
"mouleur" => "mul9R",
"moulez" => "mule",
"moulin" => "mul5",
"moulin-à-vent" => "mul5av@",
"moulinage" => "mulinaZ",
"moulinait" => "mulinE",
"mouline" => "mulin",
"moulinent" => "mulin",
"mouliner" => "muline",
"moulines" => "mulin",
"moulinet" => "mulinE",
"moulinets" => "mulinE",
"moulinette" => "mulinEt",
"moulinettes" => "mulinEt",
"moulinez" => "muline",
"moulins" => "mul5",
"moult" => "mult",
"moulu" => "muly",
"moulue" => "muly",
"moulues" => "muly",
"moulurations" => "mulyRasj§",
"moulure" => "mulyR",
"mouluré" => "mulyRe",
"moulures" => "mulyR",
"moulus" => "muly",
"moulut" => "muly",
"moumounes" => "mumun",
"moumoute" => "mumut",
"moumoutes" => "mumut",
"mound" => "mund",
"mouquère" => "mukER",
"mouraient" => "muRE",
"mourais" => "muRE",
"mourait" => "muRE",
"mourant" => "muR@",
"mourante" => "muR@t",
"mourantes" => "muR@t",
"mourants" => "muR@",
"mourez" => "muRe",
"mourides" => "muRid",
"mouriez" => "muRje",
"mourions" => "muRj§",
"mourir" => "muRiR",
"mouroir" => "muRwaR",
"mouron" => "muR§",
"mouronne" => "muROn",
"mouronner" => "muRone",
"mourons" => "muR§",
"mourra" => "muRa",
"mourrai" => "muRE",
"mourraient" => "muRE",
"mourrais" => "muRE",
"mourrait" => "muRE",
"mourras" => "muRa",
"mourre" => "muR",
"mourrez" => "muRe",
"mourriez" => "muRje",
"mourrions" => "muRj§",
"mourrons" => "muR§",
"mourront" => "muR§",
"moururent" => "muRyR",
"mourus" => "muRy",
"mourussent" => "muRys",
"mourut" => "muRy",
"mourût" => "muRy",
"mourûtes" => "muRyt",
"mous" => "mu",
"mouscaille" => "muskaj",
"mouscailles" => "muskaj",
"mousmé" => "musme",
"mousmés" => "musme",
"mousquet" => "muskE",
"mousquetades" => "musk°tad",
"mousquetaire" => "musk°tER",
"mousquetaires" => "musk°tER",
"mousqueterie" => "muskEt°Ri",
"mousqueton" => "musk°t§",
"mousquetons" => "musk°t§",
"mousquets" => "muskE",
"moussage" => "musaZ",
"moussaient" => "musE",
"moussaillon" => "musaj§",
"moussaillons" => "musaj§",
"moussait" => "musE",
"moussaka" => "musaka",
"moussakas" => "musaka",
"moussant" => "mus@",
"moussante" => "mus@t",
"moussants" => "mus@",
"mousse" => "mus",
"mousseline" => "mus°lin",
"mousselines" => "mus°lin",
"moussent" => "mus",
"mousser" => "muse",
"mousseron" => "mus°R§",
"mousserons" => "mus°R§",
"mousses" => "mus",
"mousseuse" => "mus2z",
"mousseuses" => "mus2z",
"mousseux" => "mus2",
"mousson" => "mus§",
"moussons" => "mus§",
"moussu" => "musy",
"moussue" => "musy",
"moussues" => "musy",
"moussus" => "musy",
"moustache" => "mustaS",
"moustaches" => "mustaS",
"moustachu" => "mustaSy",
"moustachue" => "mustaSy",
"moustachues" => "mustaSy",
"moustachus" => "mustaSy",
"moustagache" => "mustagaS",
"moustagaches" => "mustagaS",
"moustiquaire" => "mustikER",
"moustiquaires" => "mustikER",
"moustique" => "mustik",
"moustiques" => "mustik",
"moût" => "mu",
"moutard" => "mutaR",
"moutarde" => "mutaRd",
"moutardé" => "mutaRde",
"moutardes" => "mutaRd",
"moutardier" => "mutaRdje",
"moutards" => "mutaR",
"moutier" => "mutje",
"mouton" => "mut§",
"moutonnaient" => "mutonE",
"moutonnait" => "mutonE",
"moutonnant" => "muton@",
"moutonnante" => "muton@t",
"moutonnantes" => "muton@t",
"moutonnants" => "muton@",
"moutonne" => "mutOn",
"moutonnement" => "mutOn°m@",
"moutonnements" => "mutOn°m@",
"moutonnent" => "mutOn",
"moutonner" => "mutone",
"moutonnerie" => "mutOn°Ri",
"moutonneux" => "muton2",
"moutonnier" => "mutonje",
"moutonnière" => "mutonjER",
"moutonniers" => "mutonje",
"moutons" => "mut§",
"moûts" => "mu",
"mouture" => "mutyR",
"moutures" => "mutyR",
"mouvaient" => "muvE",
"mouvais" => "muvE",
"mouvait" => "muvE",
"mouvance" => "muv@s",
"mouvances" => "muv@s",
"mouvant" => "muv@",
"mouvante" => "muv@t",
"mouvantes" => "muv@t",
"mouvants" => "muv@",
"mouvement" => "muv°m@",
"mouvementé" => "muv°m@te",
"mouvementée" => "muv°m@te",
"mouvementées" => "muv°m@te",
"mouvementent" => "muv°m@t",
"mouvementés" => "muv°m@te",
"mouvements" => "muv°m@",
"mouvoir" => "muvwaR",
"moyen" => "mwaj5",
"moyen-âge" => "mwajEnaZ",
"moyen-oriental" => "mwajEnoRj@tal",
"moyen-orientaux" => "mwajEnoRj@to",
"moyenâgeuse" => "mwajEnaZ2z",
"moyenâgeuses" => "mwajEnaZ2z",
"moyenâgeux" => "mwajEnaZ2",
"moyennant" => "mwajEn@",
"moyenne" => "mwajEn",
"moyennement" => "mwajEn°m@",
"moyenner" => "mwajEne",
"moyennes" => "mwajEn",
"moyens" => "mwaj5",
"moyer" => "mwaje",
"moyeu" => "mwaj2",
"moyeux" => "mwaj2",
"mozarabe" => "mozaRab",
"mozartiennes" => "mozaRsjEn",
"mozzarella" => "modzaREla",
"mozzarelle" => "mOdzaREl",
"mû" => "my",
"mua" => "m8a",
"muai" => "m8E",
"muaient" => "m8E",
"muait" => "m8E",
"muant" => "m8@",
"muchacho" => "mutSatSo",
"muchachos" => "mutSatSo",
"muchas" => "mutSas",
"muche" => "myS",
"mucilage" => "mysilaZ",
"mucilagineuse" => "mysilaZin2z",
"mucor" => "mykOR",
"mucosité" => "mykozite",
"mucosités" => "mykozite",
"mucoviscidose" => "mykovisidoz",
"mucus" => "mykys",
"mudéjar" => "mydeZaR",
"mudéjare" => "mydeZaR",
"mue" => "my",
"mué" => "m8e",
"muée" => "m8e",
"muées" => "m8e",
"muent" => "my",
"muer" => "m8e",
"muera" => "myRa",
"mueront" => "myR§",
"mues" => "my",
"mués" => "m8e",
"muesli" => "m82sli",
"muet" => "m8E",
"muets" => "m8E",
"muette" => "m8Et",
"muettement" => "m8Et°m@",
"muettes" => "m8Et",
"muezzin" => "m8Edzin",
"muezzins" => "m8Edzin",
"muffin" => "m9fin",
"muffins" => "m9finz",
"mufle" => "myfl",
"muflée" => "myfle",
"muflerie" => "myfl°Ri",
"mufleries" => "myfl°Ri",
"mufles" => "myfl",
"muflier" => "myflie",
"mufliers" => "myflije",
"mufti" => "mufti",
"muftis" => "mufti",
"muges" => "myZ",
"mugi" => "myZi",
"mugir" => "myZiR",
"mugis" => "myZi",
"mugissaient" => "myZisE",
"mugissait" => "myZisE",
"mugissant" => "myZis@",
"mugissante" => "myZis@t",
"mugissantes" => "myZis@t",
"mugissants" => "myZis@",
"mugissement" => "myZis°m@",
"mugissements" => "myZis°m@",
"mugissent" => "myZis",
"mugit" => "myZi",
"muguet" => "mygE",
"muguets" => "mygE",
"muguette" => "mygEt",
"muids" => "m8i",
"mulard" => "mylaR",
"mulâtre" => "mylatR",
"mulâtres" => "mylatR",
"mulâtresse" => "mylatREs",
"mulâtresses" => "mylatREs",
"mule" => "myl",
"mules" => "myl",
"mulet" => "mylE",
"muleta" => "myl°ta",
"muletier" => "myl°tje",
"muletière" => "myl°tjER",
"muletiers" => "myl°tje",
"mulets" => "mylE",
"mulettes" => "mylEt",
"mulhousien" => "myluzj5",
"mullah" => "myla",
"mulon" => "myl§",
"mulot" => "mylo",
"mulots" => "mylo",
"multi" => "mylti",
"multi-tâches" => "myltitaS",
"multicellulaire" => "myltisElylER",
"multicolore" => "myltikolOR",
"multicolores" => "myltikolOR",
"multiconfessionnel" => "myltik§fEsjOnEl",
"multicouche" => "myltikuS",
"multiculturalisme" => "myltikyltyRalizm",
"multiculturel" => "myltikyltyREl",
"multiculturelle" => "myltikyltyREl",
"multidimensionnel" => "myltidim@sjonEl",
"multidimensionnelle" => "myltidim@sjonEl",
"multidimensionnels" => "myltidim@sjonEl",
"multidisciplinaire" => "myltidisiplinER",
"multifamilial" => "myltifamiljal",
"multifonction" => "myltif§ksj§",
"multifonctionnel" => "myltif§ksjonEl",
"multifonctions" => "myltif§ksj§",
"multiforme" => "myltifORm",
"multiformes" => "myltifORm",
"multifréquences" => "myltifRek@s",
"multigrade" => "myltigRad",
"multimédia" => "myltimedja",
"multimilliardaire" => "myltimiljaRdER",
"multimillionnaire" => "myltimiljonER",
"multimillionnaires" => "myltimiljonER",
"multinational" => "myltinasjonal",
"multinationale" => "myltinasjonal",
"multinationales" => "myltinasjonal",
"multinationaux" => "myltinasjono",
"multipare" => "myltipaR",
"multipartite" => "myltipaRtit",
"multiple" => "myltipl",
"multiples" => "myltipl",
"multiplex" => "myltiplEks",
"multiplexe" => "myltiplEks",
"multiplexé" => "myltiplEkse",
"multiplexer" => "myltiplEkse",
"multiplexes" => "myltiplEks",
"multiplia" => "myltiplija",
"multipliai" => "myltiplijE",
"multipliaient" => "myltiplijE",
"multipliais" => "myltiplijE",
"multipliait" => "myltiplijE",
"multipliant" => "myltiplij@",
"multipliât" => "myltiplja",
"multiplicateur" => "myltiplikat9R",
"multiplication" => "myltiplikasj§",
"multiplications" => "myltiplikasj§",
"multiplicité" => "myltiplisite",
"multiplicités" => "myltiplisite",
"multiplie" => "myltipli",
"multiplié" => "myltiplije",
"multipliée" => "myltiplije",
"multipliées" => "myltiplije",
"multiplient" => "myltipli",
"multiplier" => "myltiplije",
"multiplierai" => "myltipliRE",
"multiplieraient" => "myltipliRE",
"multiplierait" => "myltipliRE",
"multiplièrent" => "myltiplijER",
"multiplierons" => "myltipliR§",
"multiplieront" => "myltipliR§",
"multiplies" => "myltipli",
"multipliés" => "myltiplije",
"multipliez" => "myltiplije",
"multipliions" => "myltiplij§",
"multipoints" => "myltipw5",
"multiprise" => "myltipRiz",
"multipropriété" => "myltipROpRiete",
"multiracial" => "myltiRasjal",
"multiraciale" => "myltiRasjal",
"multiraciaux" => "myltiRasjo",
"multirécidiviste" => "myltiResidivist",
"multirisque" => "myltiRisk",
"multiséculaires" => "myltisekylER",
"multitâche" => "myltitaS",
"multitâches" => "myltitaS",
"multitude" => "myltityd",
"multitudes" => "myltityd",
"mungo" => "muGo",
"muni" => "myni",
"munich" => "mynik",
"munichois" => "mynikwa",
"munichoise" => "mynikwaz",
"municipal" => "mynisipal",
"municipale" => "mynisipal",
"municipales" => "mynisipal",
"municipalité" => "mynisipalite",
"municipalités" => "mynisipalite",
"municipaux" => "mynisipo",
"municipe" => "mynisip",
"municipes" => "mynisip",
"munie" => "myni",
"munies" => "myni",
"munificence" => "mynifis@s",
"munificences" => "mynifis@s",
"munificente" => "mynifis@t",
"munificents" => "mynifis@",
"munir" => "myniR",
"munis" => "myni",
"munissaient" => "mynisE",
"munissait" => "mynisE",
"munissant" => "mynis@",
"munissent" => "mynis",
"munit" => "myni",
"munition" => "mynisj§",
"munitions" => "mynisj§",
"munster" => "mynst9R",
"muon" => "m8§",
"muphti" => "mufti",
"muqueuse" => "myk2z",
"muqueuses" => "myk2z",
"muqueux" => "myk2",
"mur" => "myR",
"mûr" => "myR",
"mura" => "myRa",
"murage" => "myRaZ",
"muraient" => "myRE",
"muraille" => "myRaj",
"murailles" => "myRaj",
"murait" => "myRE",
"mural" => "myRal",
"murale" => "myRal",
"murales" => "myRal",
"murant" => "myR@",
"muraux" => "myRo",
"mure" => "myR",
"mûre" => "myR",
"muré" => "myRe",
"murée" => "myRe",
"murées" => "myRe",
"mûrement" => "myR°m@",
"murène" => "myREn",
"murènes" => "myREn",
"murent" => "myR",
"murer" => "myRe",
"murerait" => "myR°RE",
"murèrent" => "myRER",
"mures" => "myR",
"mûres" => "myR",
"murés" => "myRe",
"muret" => "myRE",
"muretin" => "myR°t5",
"muretins" => "myR°t5",
"murets" => "myRE",
"murette" => "myREt",
"murettes" => "myREt",
"murex" => "myREks",
"murez" => "myRe",
"mûri" => "myRi",
"muriatique" => "myRjatik",
"muridés" => "myRide",
"mûrie" => "myRi",
"mûrier" => "myRje",
"mûriers" => "myRje",
"mûries" => "myRi",
"murin" => "myR5",
"mûrir" => "myRiR",
"mûrira" => "myRiRa",
"mûriraient" => "myRiRE",
"mûrirez" => "myRiRe",
"mûris" => "myRi",
"mûrissaient" => "myRisE",
"mûrissait" => "myRisE",
"mûrissant" => "myRis@",
"mûrissante" => "myRis@t",
"mûrissantes" => "myRis@t",
"mûrissants" => "myRis@",
"mûrisse" => "myRis",
"mûrissement" => "myRis°m@",
"mûrissements" => "myRis°m@",
"mûrissent" => "myRis",
"mûrisseries" => "myRis°Ri",
"mûrit" => "myRi",
"murmel" => "myRmEl",
"murmura" => "myRmyRa",
"murmurai" => "myRmyRE",
"murmuraient" => "myRmyRE",
"murmurais" => "myRmyRE",
"murmurait" => "myRmyRE",
"murmurant" => "myRmyR@",
"murmurante" => "myRmyR@t",
"murmurantes" => "myRmyR@t",
"murmurants" => "myRmyR@",
"murmuras" => "myRmyRa",
"murmure" => "myRmyR",
"murmuré" => "myRmyRe",
"murmurée" => "myRmyRe",
"murmurées" => "myRmyRe",
"murmurent" => "myRmyR",
"murmurer" => "myRmyRe",
"murmurera" => "myRmyR°Ra",
"murmureraient" => "myRmyR°RE",
"murmurerait" => "myRmyR°RE",
"murmurèrent" => "myRmyRER",
"murmureront" => "myRmyR°R§",
"murmures" => "myRmyR",
"murmurés" => "myRmyRe",
"murmurez" => "myRmyRe",
"murmurions" => "myRmyRj§",
"mûron" => "myR§",
"murs" => "myR",
"mûrs" => "myR",
"mus" => "my",
"musa" => "myza",
"musagètes" => "myzaZEt",
"musait" => "myzE",
"musant" => "myz@",
"musaraigne" => "myzaREN",
"musaraignes" => "myzaREN",
"musard" => "myzaR",
"musarda" => "myzaRda",
"musardaient" => "myzaRdE",
"musardait" => "myzaRdE",
"musardant" => "myzaRd@",
"musarde" => "myzaRd",
"musarder" => "myzaRde",
"musardez" => "myzaRde",
"musardise" => "myzaRdiz",
"musards" => "myzaR",
"musc" => "mysk",
"muscade" => "myskad",
"muscadelle" => "myskadEl",
"muscadet" => "myskadE",
"muscadin" => "myskad5",
"muscadine" => "myskadin",
"muscat" => "myska",
"muscats" => "myska",
"musclant" => "myskl@",
"muscle" => "myskl",
"musclé" => "myskle",
"musclée" => "myskle",
"musclées" => "myskle",
"musclent" => "myskl",
"muscler" => "myskle",
"muscles" => "myskl",
"musclés" => "myskle",
"muscovite" => "myskOvit",
"musculaire" => "myskylER",
"musculaires" => "myskylER",
"musculation" => "myskylasj§",
"musculature" => "myskylatyR",
"musculeuse" => "myskyl2z",
"musculeuses" => "myskyl2z",
"musculeux" => "myskyl2",
"muse" => "myz",
"museau" => "myzo",
"museaux" => "myzo",
"musée" => "myze",
"musées" => "myze",
"muselait" => "myz°lE",
"muselant" => "myz°l@",
"muselé" => "myz°le",
"muselée" => "myz°le",
"muselées" => "myz°le",
"museler" => "myz°le",
"muselés" => "myz°le",
"muselière" => "myz°ljER",
"muselières" => "myz°ljER",
"muselle" => "myzEl",
"musellerait" => "myzEl°RE",
"muselons" => "myz°l§",
"muséologie" => "myzeOlOZi",
"muséologique" => "myzeOlOZik",
"muséologue" => "myzeOlOg",
"muser" => "myze",
"muserolle" => "myz°ROl",
"muses" => "myz",
"musette" => "myzEt",
"musettes" => "myzEt",
"musettes-repas" => "myzEtR°pa",
"muséum" => "myzeOm",
"music hall" => "myzikOl",
"music-hall" => "myzikOl",
"music-halls" => "myzikOl",
"musical" => "myzikal",
"musicale" => "myzikal",
"musicalement" => "myzikal°m@",
"musicales" => "myzikal",
"musicalité" => "myzikalite",
"musicaux" => "myziko",
"musicien" => "myzisj5",
"musicienne" => "myzisjEn",
"musiciennes" => "myzisjEn",
"musiciens" => "myzisj5",
"musico" => "myziko",
"musicographes" => "myzikogRaf",
"musicologie" => "myzikOlOZi",
"musicologique" => "myzikoloZik",
"musicologue" => "myzikolOg",
"musicologues" => "myzikolOg",
"musicothérapie" => "myzikoteRapi",
"musiquait" => "myzikE",
"musique" => "myzik",
"musiquer" => "myzike",
"musiques" => "myzik",
"musiquette" => "myzikEt",
"musiquettes" => "myzikEt",
"muskogee" => "myskoZi",
"musoir" => "myzwaR",
"musqué" => "myske",
"musquée" => "myske",
"musquées" => "myske",
"musqués" => "myske",
"mussais" => "mysE",
"musse" => "mys",
"mussée" => "myse",
"mussent" => "mys",
"mussés" => "myse",
"mussolinien" => "mysolinj5",
"mussolinienne" => "mysolinjEn",
"mussoliniens" => "mysolinj5",
"must" => "m9st",
"mustang" => "myst@g",
"mustangs" => "myst@g",
"mustélidés" => "mystelide",
"musulman" => "myzylm@",
"musulmane" => "myzylman",
"musulmanes" => "myzylman",
"musulmans" => "myzylm@",
"mutabilité" => "mytabilite",
"mutable" => "mytabl",
"mutables" => "mytabl",
"mutagène" => "mytaZEn",
"mutant" => "myt@",
"mutante" => "myt@t",
"mutantes" => "myt@t",
"mutants" => "myt@",
"mutât" => "myta",
"mutation" => "mytasj§",
"mutations" => "mytasj§",
"mutatis mutandis" => "mutatismut@dis",
"mute" => "myt",
"muté" => "myte",
"mutée" => "myte",
"mutées" => "myte",
"mutent" => "myt",
"muter" => "myte",
"mutera" => "myt°Ra",
"muterai" => "myt°RE",
"muteront" => "myt°R§",
"mutés" => "myte",
"mutila" => "mytila",
"mutilais" => "mytilE",
"mutilait" => "mytilE",
"mutilant" => "mytil@",
"mutilante" => "mytil@t",
"mutilateur" => "mytilat9R",
"mutilation" => "mytilasj§",
"mutilations" => "mytilasj§",
"mutile" => "mytil",
"mutilé" => "mytile",
"mutilée" => "mytile",
"mutilées" => "mytile",
"mutilent" => "mytil",
"mutiler" => "mytile",
"mutilera" => "mytil°Ra",
"mutileraient" => "mytil°RE",
"mutilés" => "mytile",
"mutin" => "myt5",
"mutina" => "mytina",
"mutinaient" => "mytinE",
"mutine" => "mytin",
"mutiné" => "mytine",
"mutinée" => "mytine",
"mutinent" => "mytin",
"mutiner" => "mytine",
"mutinerie" => "mytin°Ri",
"mutineries" => "mytin°Ri",
"mutines" => "mytin",
"mutinés" => "mytine",
"mutinez" => "mytine",
"mutins" => "myt5",
"mutique" => "mytik",
"mutisme" => "mytizm",
"mutismes" => "mytizm",
"mutité" => "mytite",
"mutualisme" => "myt8alizm",
"mutualité" => "myt8alite",
"mutualités" => "myt8alite",
"mutuel" => "myt8El",
"mutuelle" => "myt8El",
"mutuellement" => "myt8El°m@",
"mutuelles" => "myt8El",
"mutuels" => "myt8El",
"myasthénie" => "mjasteni",
"mycène" => "misEn",
"mycénien" => "misenj5",
"mycéniennes" => "misenjEn",
"mycéniens" => "misenj5",
"mycologie" => "mikoloZi",
"mycologue" => "mikolOg",
"mycologues" => "mikolOg",
"mycose" => "mikoz",
"myéline" => "mjelin",
"myélite" => "mjelit",
"myéloblaste" => "mjeloblast",
"myéloblastes" => "mjeloblast",
"myéloïde" => "mjeloid",
"mygale" => "migal",
"mygales" => "migal",
"mylord" => "milOR",
"myocarde" => "mjokaRd",
"myocardiopathie" => "mjOkaRdjOpati",
"myocardique" => "mjOkaRdik",
"myocardite" => "mjokaRdit",
"myoclonie" => "mjoklOni",
"myoglobine" => "mjOglObin",
"myographe" => "mjogRaf",
"myopathes" => "mjopat",
"myopathie" => "mjopati",
"myopathique" => "mjOpatik",
"myope" => "mjOp",
"myopes" => "mjOp",
"myopie" => "mjopi",
"myopies" => "mjopi",
"myosine" => "mjozin",
"myosis" => "mjozis",
"myosotis" => "mjozotis",
"myriade" => "miRjad",
"myriades" => "miRjad",
"myriophylle" => "miRjofil",
"myrmidon" => "miRmid§",
"myrmidons" => "miRmid§",
"myrrhe" => "miR",
"myrte" => "miRt",
"myrtes" => "miRt",
"myrtille" => "miRtij",
"myrtilles" => "miRtij",
"mystagogie" => "mistagoZi",
"mystagogique" => "mistagOZik",
"mystagogue" => "mistagOg",
"myste" => "mist",
"mystère" => "mistER",
"mystères" => "mistER",
"mystérieuse" => "misteRj2z",
"mystérieusement" => "misteRj2z°m@",
"mystérieuses" => "misteRj2z",
"mystérieux" => "misteRj2",
"mysticisme" => "mistisizm",
"mysticismes" => "mistisizm",
"mystificateur" => "mistifikat9R",
"mystificateurs" => "mistifikat9R",
"mystification" => "mistifikasj§",
"mystifications" => "mistifikasj§",
"mystificatrice" => "mistifikatRis",
"mystifie" => "mistifi",
"mystifié" => "mistifje",
"mystifiée" => "mistifje",
"mystifiées" => "mistifje",
"mystifier" => "mistifje",
"mystifiés" => "mistifje",
"mystique" => "mistik",
"mystiquement" => "mistik°m@",
"mystiques" => "mistik",
"mythe" => "mit",
"mythes" => "mit",
"mythifiait" => "mitifjE",
"mythifier" => "mitifje",
"mythique" => "mitik",
"mythiques" => "mitik",
"mythisation" => "mitizasj§",
"mytho" => "mito",
"mythologie" => "mitoloZi",
"mythologies" => "mitoloZi",
"mythologique" => "mitoloZik",
"mythologiques" => "mitoloZik",
"mythologisé" => "mitoloZize",
"mythologue" => "mitolOg",
"mythologues" => "mitolOg",
"mythomane" => "mitoman",
"mythomanes" => "mitoman",
"mythomanie" => "mitomani",
"myxoedémateuse" => "miks2demat2z",
"myxomatose" => "miksomatoz",
"n" => "En",
"n'" => "n",
"n'est-ce pas" => "nEs°pa",
"na" => "na",
"nabab" => "nabab",
"nababs" => "nabab",
"nabi" => "nabi",
"nable" => "nabl",
"nabot" => "nabo",
"nabote" => "nabOt",
"nabots" => "nabo",
"nacarat" => "nakaRa",
"nacelle" => "nasEl",
"nacelles" => "nasEl",
"nacra" => "nakRa",
"nacraient" => "nakRE",
"nacre" => "nakR",
"nacré" => "nakRe",
"nacrée" => "nakRe",
"nacrées" => "nakRe",
"nacres" => "nakR",
"nacrés" => "nakRe",
"nacrure" => "nakRyR",
"nada" => "nada",
"nadir" => "nadiR",
"naevus" => "nevys",
"naga" => "naga",
"nage" => "naZ",
"nagé" => "naZe",
"nagea" => "naZa",
"nageai" => "naZE",
"nageaient" => "naZE",
"nageais" => "naZE",
"nageait" => "naZE",
"nageant" => "naZ@",
"nageante" => "naZ@t",
"nageât" => "naZa",
"nagent" => "naZ",
"nageoire" => "naZwaR",
"nageoires" => "naZwaR",
"nageons" => "naZ§",
"nager" => "naZe",
"nagera" => "naZ°Ra",
"nagerai" => "naZ°RE",
"nageraient" => "naZ°RE",
"nagerais" => "naZ°RE",
"nagerait" => "naZ°RE",
"nageras" => "naZ°Ra",
"nagèrent" => "naZER",
"nagerez" => "naZ°Re",
"nagerons" => "naZ°R§",
"nageront" => "naZ°R§",
"nages" => "naZ",
"nageur" => "naZ9R",
"nageurs" => "naZ9R",
"nageuse" => "naZ2z",
"nageuses" => "naZ2z",
"nagez" => "naZe",
"nagiez" => "naZje",
"nagions" => "naZj§",
"naguère" => "nagER",
"naïade" => "najad",
"naïades" => "najad",
"naïf" => "naif",
"naïfs" => "naif",
"nain" => "n5",
"naine" => "nEn",
"naines" => "nEn",
"nains" => "n5",
"naira" => "nERa",
"nais" => "nE",
"naissaient" => "nEsE",
"naissain" => "nEs5",
"naissais" => "nEsE",
"naissait" => "nEsE",
"naissance" => "nEs@s",
"naissances" => "nEs@s",
"naissant" => "nEs@",
"naissante" => "nEs@t",
"naissantes" => "nEs@t",
"naissants" => "nEs@",
"naisse" => "nEs",
"naissent" => "nEs",
"naisses" => "nEs",
"naisseur" => "nEs9R",
"naissez" => "nEse",
"naissions" => "nEsj§",
"naissons" => "nEs§",
"naît" => "nE",
"naîtra" => "nEtRa",
"naîtrai" => "nEtRE",
"naîtraient" => "nEtRE",
"naîtrait" => "nEtRE",
"naître" => "nEtR",
"naîtrions" => "nEtRij§",
"naîtront" => "nEtR§",
"naïve" => "naiv",
"naïvement" => "naiv°m@",
"naïves" => "naiv",
"naïveté" => "naiv°te",
"naïvetés" => "naiv°te",
"naja" => "naZa",
"najas" => "naZa",
"namibiens" => "namibj5",
"nan" => "n@",
"nana" => "nana",
"nanan" => "nan@",
"nanar" => "nanaR",
"nanard" => "nanaR",
"nanas" => "nana",
"nancéiens" => "n@sej5",
"nanisme" => "nanizm",
"nankin" => "n@k5",
"nano" => "nano",
"nanomètre" => "nanOmEtR",
"nanomètres" => "nanomEtR",
"nanoseconde" => "nanoz°g§d",
"nanosecondes" => "nanos°g§d",
"nanotechnologie" => "nanotEknoloZi",
"nant" => "n@",
"nantais" => "n@tE",
"nantaise" => "n@tEz",
"nantaises" => "n@tEz",
"nanti" => "n@ti",
"nantie" => "n@ti",
"nanties" => "n@ti",
"nantir" => "n@tiR",
"nantis" => "n@ti",
"nantissement" => "n@tis°m@",
"nap" => "nap",
"napalm" => "napalm",
"napel" => "napEl",
"naphtalène" => "naftalEn",
"naphtaline" => "naftalin",
"naphtalines" => "naftalin",
"naphte" => "naft",
"napoléon" => "napole§",
"napoléonien" => "napoleonj5",
"napoléonienne" => "napoleonjEn",
"napoléoniennes" => "napoleonjEn",
"napoléoniens" => "napoleonj5",
"napoléons" => "napole§",
"napolitain" => "napolit5",
"napolitaine" => "napolitEn",
"napolitaines" => "napolitEn",
"napolitains" => "napolit5",
"nappa" => "napa",
"nappage" => "napaZ",
"nappaient" => "napE",
"nappait" => "napE",
"nappe" => "nap",
"nappé" => "nape",
"nappée" => "nape",
"nappées" => "nape",
"napper" => "nape",
"napperon" => "nap°R§",
"napperons" => "nap°R§",
"nappes" => "nap",
"nappés" => "nape",
"naquirent" => "nakiR",
"naquis" => "naki",
"naquisse" => "nakis",
"naquissent" => "nakis",
"naquit" => "naki",
"naquît" => "naki",
"narbonnais" => "naRbonE",
"narcisse" => "naRsis",
"narcisses" => "naRsis",
"narcissique" => "naRsisik",
"narcissiquement" => "naRsisik°m@",
"narcissiques" => "naRsisik",
"narcissisme" => "naRsisizm",
"narcissiste" => "naRsisist",
"narco-analyse" => "naRkoanaliz",
"narcolepsie" => "naRkolEpsi",
"narcoleptique" => "naRkolEptik",
"narcose" => "naRkoz",
"narcotique" => "naRkotik",
"narcotiques" => "naRkotik",
"narcotrafic" => "naRkotRafik",
"narcotrafiquants" => "naRkotRafik@",
"nard" => "naR",
"nards" => "naR",
"narghilé" => "naRgile",
"narghileh" => "naRgile",
"nargua" => "naRga",
"narguaient" => "naRgE",
"narguais" => "naRgE",
"narguait" => "naRgE",
"narguant" => "naRg@",
"nargue" => "naRg",
"nargué" => "naRge",
"narguées" => "naRge",
"narguent" => "naRg",
"narguer" => "naRge",
"nargues" => "naRg",
"narguez" => "naRge",
"narguilé" => "naRgile",
"narguilés" => "naRgile",
"narguons" => "naRg§",
"narine" => "naRin",
"narines" => "naRin",
"narquois" => "naRkwa",
"narquoise" => "naRkwaz",
"narquoisement" => "naRkwaz°m@",
"narquoiserie" => "naRkwaz°Ri",
"narquoises" => "naRkwaz",
"narra" => "naRa",
"narrai" => "naRE",
"narrait" => "naRE",
"narrant" => "naR@",
"narrateur" => "naRat9R",
"narratif" => "naRatif",
"narratifs" => "naRatif",
"narration" => "naRasj§",
"narrations" => "naRasj§",
"narrative" => "naRativ",
"narratives" => "naRativ",
"narratrice" => "naRatRis",
"narratrices" => "naRatRis",
"narre" => "naR",
"narré" => "naRe",
"narrée" => "naRe",
"narrées" => "naRe",
"narrer" => "naRe",
"narthex" => "naRtEks",
"narval" => "naRval",
"narvals" => "naRval",
"nasal" => "nazal",
"nasale" => "nazal",
"nasales" => "nazal",
"nasard" => "nazaR",
"nasardes" => "nazaRd",
"nasaux" => "nazo",
"nasdaq" => "nazdak",
"nase" => "naz",
"naseau" => "nazo",
"naseaux" => "nazo",
"nases" => "naz",
"nasilla" => "nazija",
"nasillaient" => "nazijE",
"nasillait" => "nazijE",
"nasillant" => "nazij@",
"nasillard" => "nazijaR",
"nasillarde" => "nazijaRd",
"nasillardes" => "nazijaRd",
"nasillards" => "nazijaR",
"nasille" => "nazij",
"nasillement" => "nazij°m@",
"nasillent" => "nazij",
"nasiller" => "nazije",
"nasillonne" => "nazijOn",
"nasique" => "nazik",
"nasopharynx" => "nazofaR5ks",
"nasse" => "nas",
"nassérien" => "naseRj5",
"nasses" => "nas",
"natal" => "natal",
"natale" => "natal",
"natales" => "natal",
"natalité" => "natalite",
"natals" => "natal",
"natation" => "natasj§",
"natatoire" => "natatwaR",
"natif" => "natif",
"natifs" => "natif",
"nation" => "nasj§",
"national" => "nasjonal",
"national-socialisme" => "nasjonalsosjalizm",
"national-socialiste" => "nasjonalsosjalist",
"nationale" => "nasjonal",
"nationale-socialiste" => "nasjonalsosjalist",
"nationalement" => "nasjonal°m@",
"nationales" => "nasjonal",
"nationalisait" => "nasjonalizE",
"nationalisation" => "nasjonalizasj§",
"nationalisations" => "nasjonalizasj§",
"nationalisé" => "nasjonalize",
"nationalisée" => "nasjonalize",
"nationalisées" => "nasjonalize",
"nationalisent" => "nasjonaliz",
"nationaliser" => "nasjonalize",
"nationalisés" => "nasjonalize",
"nationalisme" => "nasjonalizm",
"nationalisons" => "nasjonaliz§",
"nationaliste" => "nasjonalist",
"nationalistes" => "nasjonalist",
"nationalité" => "nasjonalite",
"nationalités" => "nasjonalite",
"nationaux" => "nasjono",
"nationaux-socialistes" => "nasjonososjalist",
"nations" => "nasj§",
"native" => "nativ",
"natives" => "nativ",
"nativité" => "nativite",
"nativités" => "nativite",
"natrémie" => "natRemi",
"natron" => "natR§",
"natrum" => "natROm",
"natta" => "nata",
"natte" => "nat",
"natté" => "nate",
"nattée" => "nate",
"nattées" => "nate",
"natter" => "nate",
"nattes" => "nat",
"nattés" => "nate",
"nattier" => "natje",
"naturalisation" => "natyRalizasj§",
"naturalisé" => "natyRalize",
"naturalisée" => "natyRalize",
"naturaliser" => "natyRalize",
"naturalisés" => "natyRalize",
"naturalisme" => "natyRalizm",
"naturaliste" => "natyRalist",
"naturalistes" => "natyRalist",
"nature" => "natyR",
"naturel" => "natyREl",
"naturelle" => "natyREl",
"naturellement" => "natyREl°m@",
"naturelles" => "natyREl",
"naturels" => "natyREl",
"natures" => "natyR",
"naturisme" => "natyRizm",
"naturiste" => "natyRist",
"naturistes" => "natyRist",
"naturlich" => "natyRliS",
"naturopathe" => "natyRopat",
"naufrage" => "nofRaZ",
"naufragé" => "nofRaZe",
"naufrageant" => "nofRaZ@",
"naufragée" => "nofRaZe",
"naufragées" => "nofRaZe",
"naufragent" => "nofRaZ",
"naufrager" => "nofRaZe",
"naufrages" => "nofRaZ",
"naufragés" => "nofRaZe",
"naufrageur" => "nofRaZ9R",
"naufrageurs" => "nofRaZ9R",
"naufrageuse" => "nofRaZ2z",
"nauséabond" => "nozeab§",
"nauséabonde" => "nozeab§d",
"nauséabondes" => "nozeab§d",
"nauséabonds" => "nozeab§",
"nausée" => "noze",
"nausées" => "noze",
"nauséeuse" => "noze2z",
"nauséeuses" => "noze2z",
"nauséeux" => "noze2",
"nautes" => "not",
"nautile" => "notil",
"nautilus" => "notily",
"nautique" => "notik",
"nautiques" => "notik",
"nautonier" => "notonje",
"nautoniers" => "notonje",
"navaja" => "navaZa",
"navajas" => "navaZa",
"navajo" => "navaRo",
"navajos" => "navaRos",
"naval" => "naval",
"navale" => "naval",
"navales" => "naval",
"navals" => "naval",
"navarin" => "navaR5",
"navarins" => "navaR5",
"navarrais" => "navaRE",
"nave" => "nav",
"navel" => "navEl",
"navet" => "navE",
"navets" => "navE",
"navette" => "navEt",
"navettes" => "navEt",
"navicert" => "navisER",
"navigabilité" => "navigabilite",
"navigable" => "navigabl",
"navigables" => "navigabl",
"navigant" => "navig@",
"navigante" => "navig@t",
"navigateur" => "navigat9R",
"navigateurs" => "navigat9R",
"navigation" => "navigasj§",
"navigations" => "navigasj§",
"navigatrice" => "navigatRis",
"navigua" => "naviga",
"naviguaient" => "navigE",
"naviguais" => "navigE",
"naviguait" => "navigE",
"naviguant" => "navig@",
"navigue" => "navig",
"navigué" => "navige",
"naviguent" => "navig",
"naviguer" => "navige",
"naviguera" => "navig°Ra",
"naviguerai" => "navig°RE",
"navigueraient" => "navig°RE",
"naviguèrent" => "navigER",
"naviguerons" => "navig°R§",
"navigues" => "navig",
"naviguez" => "navige",
"naviguiez" => "navigje",
"naviguions" => "navigj§",
"naviguons" => "navig§",
"navire" => "naviR",
"navire-citerne" => "naviRsitERn",
"navire-hôpital" => "naviRopital",
"navires" => "naviR",
"navires-citernes" => "naviRsitERn",
"navires-écoles" => "naviRekOl",
"navra" => "navRa",
"navrait" => "navRE",
"navrance" => "navR@s",
"navrant" => "navR@",
"navrante" => "navR@t",
"navrantes" => "navR@t",
"navrants" => "navR@",
"navre" => "navR",
"navré" => "navRe",
"navrée" => "navRe",
"navrées" => "navRe",
"navrer" => "navRe",
"navres" => "navR",
"navrés" => "navRe",
"navrez" => "navRe",
"nay" => "nE",
"nazaréen" => "nazaRe5",
"naze" => "naz",
"nazes" => "naz",
"nazi" => "nazi",
"nazie" => "nazi",
"nazies" => "nazi",
"nazillons" => "nazij§",
"nazis" => "nazi",
"nazisme" => "nazizm",
"ne" => "n2",
"né" => "ne",
"ne varietur" => "n°vaRjetyR",
"néandertalien" => "ne@dERtalj5",
"néandertaliens" => "ne@dERtalj5",
"néanderthalien" => "ne@dERtalj5",
"néanmoins" => "ne@mw5",
"néant" => "ne@",
"néantisation" => "ne@tizasj§",
"néantisée" => "ne@tize",
"néants" => "ne@",
"nébuleuse" => "nebyl2z",
"nébuleuses" => "nebyl2z",
"nébuleux" => "nebyl2",
"nébuliseur" => "nebyliz9R",
"nébulosité" => "nebylozite",
"nec" => "nEk",
"nécessaire" => "nesesER",
"nécessairement" => "nesesER°m@",
"nécessaires" => "nesesER",
"nécessita" => "nesesita",
"nécessitaient" => "nesesitE",
"nécessitait" => "nesesitE",
"nécessitant" => "nesesit@",
"nécessite" => "nesesit",
"nécessité" => "nesesite",
"nécessitée" => "nesesite",
"nécessitées" => "nesesite",
"nécessitent" => "nesesit",
"nécessiter" => "nesesite",
"nécessitera" => "nesesit°Ra",
"nécessiterait" => "nesesit°RE",
"nécessités" => "nesesite",
"nécessiteuse" => "nesesit2z",
"nécessiteuses" => "nesesit2z",
"nécessiteux" => "nesesit2",
"neck" => "nEk",
"nécro" => "nekRo",
"nécrobioses" => "nekRobjoz",
"nécrologe" => "nekRolOZ",
"nécrologie" => "nekRoloZi",
"nécrologies" => "nekRoloZi",
"nécrologique" => "nekRoloZik",
"nécrologiques" => "nekRoloZik",
"nécrologue" => "nekRolOg",
"nécromancie" => "nekRom@si",
"nécromancien" => "nekRom@sj5",
"nécromancienne" => "nekRom@sjEn",
"nécromanciens" => "nekRom@sj5",
"nécromant" => "nekRom@",
"nécrophage" => "nekRofaZ",
"nécrophagie" => "nekRofaZi",
"nécrophile" => "nekRofil",
"nécrophiles" => "nekRofil",
"nécrophilie" => "nekRofili",
"nécropole" => "nekRopOl",
"nécropoles" => "nekRopOl",
"nécropsie" => "nekRopsi",
"nécros" => "nekRo",
"nécrosant" => "nekRoz@",
"nécrose" => "nekRoz",
"nécrosé" => "nekRoze",
"nécrosée" => "nekRoze",
"nécroser" => "nekRoze",
"nécroses" => "nekRoz",
"nécrotique" => "nekRotik",
"nectar" => "nEktaR",
"nectarine" => "nEktaRin",
"nectarines" => "nEktaRin",
"née" => "ne",
"néerlandais" => "neERl@dE",
"néerlandaise" => "neERl@dEz",
"néerlandaises" => "neERl@dEz",
"nées" => "ne",
"nef" => "nEf",
"néfaste" => "nefast",
"néfastes" => "nefast",
"nèfles" => "nEfl",
"néflier" => "neflije",
"néfliers" => "neflije",
"nefs" => "nEf",
"négateur" => "negat9R",
"négatif" => "negatif",
"négatifs" => "negatif",
"négation" => "negasj§",
"négationnisme" => "negasjonism",
"négations" => "negasj§",
"négative" => "negativ",
"négativement" => "negativ°m@",
"négatives" => "negativ",
"négativisme" => "negativizm",
"négativiste" => "negativist",
"négativité" => "negativite",
"néglige" => "negliZ",
"négligé" => "negliZe",
"négligea" => "negliZa",
"négligeable" => "negliZabl",
"négligeables" => "negliZabl",
"négligeai" => "negliZE",
"négligeaient" => "negliZE",
"négligeais" => "negliZE",
"négligeait" => "negliZE",
"négligeant" => "negliZ@",
"négligeât" => "negliZa",
"négligée" => "negliZe",
"négligées" => "negliZe",
"négligemment" => "negliZam@",
"négligence" => "negliZ@s",
"négligences" => "negliZ@s",
"négligent" => "negliZ@",
"négligente" => "negliZ@t",
"négligents" => "negliZ@",
"négligeons" => "negliZ§",
"négliger" => "negliZe",
"négligera" => "negliZ°Ra",
"négligerai" => "negliZ°RE",
"négligerait" => "negliZ°RE",
"négligèrent" => "negliZER",
"négligeriez" => "negliZ°Rje",
"négliges" => "negliZ",
"négligés" => "negliZe",
"négligez" => "negliZe",
"négligiez" => "negliZje",
"négligions" => "negliZj§",
"négoce" => "negOs",
"négoces" => "negOs",
"négocia" => "negosja",
"négociable" => "negosjabl",
"négociables" => "negosjabl",
"négociaient" => "negosjE",
"négociais" => "negosjE",
"négociait" => "negosjE",
"négociant" => "negosj@",
"négociante" => "negOsj@t",
"négociants" => "negosj@",
"négociateur" => "negosjat9R",
"négociateurs" => "negosjat9R",
"négociation" => "negosjasj§",
"négociations" => "negosjasj§",
"négociatrice" => "negOsjatRis",
"négociatrices" => "negosjatRis",
"négocie" => "negosi",
"négocié" => "negosje",
"négociée" => "negosje",
"négociées" => "negosje",
"négocient" => "negosi",
"négocier" => "negosje",
"négociera" => "negosiRa",
"négocierai" => "negosiRE",
"négocieraient" => "negosiRE",
"négocierions" => "negosiRj§",
"négocierons" => "negosiR§",
"négocieront" => "negosiR§",
"négociés" => "negosje",
"négociez" => "negosje",
"négocions" => "negosj§",
"nègre" => "nEgR",
"nègres" => "nEgR",
"négresse" => "negREs",
"négresses" => "negREs",
"négrier" => "negRije",
"négrière" => "negRijER",
"négriers" => "negRije",
"négril" => "negRil",
"négrillon" => "negRij§",
"négrillons" => "negRij§",
"négritude" => "negRityd",
"negro" => "negRo",
"négro" => "negRo",
"negro spiritual" => "negRospiRit8Ol",
"negro spirituals" => "negRospiRit8al",
"négroïde" => "negRoid",
"négroïdes" => "negRoid",
"négrophile" => "negRofil",
"négrophiles" => "negRofil",
"négros" => "negRo",
"négus" => "negys",
"neige" => "nEZ",
"neigé" => "neZe",
"neigeait" => "nEZE",
"neiger" => "neZe",
"neigera" => "nEZ°Ra",
"neigerait" => "nEZ°RE",
"neiges" => "nEZ",
"neigeuse" => "neZ2z",
"neigeuses" => "nEZ2z",
"neigeux" => "neZ2",
"nem" => "nEm",
"nématodes" => "nematOd",
"nemrod" => "nEmROd",
"nems" => "nEm",
"néné" => "nene",
"nénés" => "nene",
"nénesse" => "nenEs",
"nénesses" => "nenEs",
"nénette" => "nenEt",
"nénettes" => "nenEt",
"nenni" => "nEni",
"nénuphar" => "nenyfaR",
"nénuphars" => "nenyfaR",
"néo" => "neo",
"néo-barbares" => "neobaRbaR",
"néo-classique" => "neoklasik",
"néo-colonialisme" => "neokolonjalizm",
"néo-communiste" => "neokomynist",
"néo-fascisme" => "neofaSizm",
"néo-fascistes" => "neofaSist",
"néo-figuration" => "neofigyRasj§",
"néo-flics" => "neoflik",
"néo-gangster" => "neog@gstER",
"néo-gothique" => "neogotik",
"néo-gothiques" => "neogotik",
"néo-grec" => "neogREk",
"néo-helléniques" => "neoelenik",
"néo-malthusianisme" => "neomaltyzjanizm",
"néo-mauresque" => "neomoREsk",
"néo-mauresques" => "neomoREsk",
"néo-mouvement" => "neomuv°m@",
"néo-réalisme" => "neoRealizm",
"néo-réaliste" => "neoRealist",
"néo-réalistes" => "neoRealist",
"néo-renaissant" => "neoR°nEs@",
"néo-romantique" => "neoRom@tik",
"néo-russe" => "neoRys",
"néo-zélandais" => "neozel@dE",
"néo-zélandaise" => "neozel@dEz",
"néoclassique" => "neoklasik",
"néocolonial" => "neokolonjal",
"néocolonialisme" => "neokolonjalizm",
"néocortex" => "neokORtEks",
"néofascisme" => "neofaSizm",
"néogothique" => "neogotik",
"néolibéralisme" => "neolibeRalism",
"néolithique" => "neolitik",
"néolithiques" => "neolitik",
"néologisme" => "neoloZizm",
"néologismes" => "neoloZizm",
"néon" => "ne§",
"néonatal" => "neonatal",
"néonatale" => "neonatal",
"néonazie" => "neonazi",
"néonazis" => "neonazi",
"néons" => "ne§",
"néophyte" => "neofit",
"néophytes" => "neofit",
"néoplasie" => "neoplazi",
"néoplasique" => "neoplazik",
"néoplasme" => "neoplasm",
"néoplatonisme" => "neoplatonizm",
"néoprène" => "neopREn",
"néoréalisme" => "neoRealizm",
"népalais" => "nepalE",
"népalaise" => "nepalEz",
"népalaises" => "nepalEz",
"nèpe" => "nEp",
"népenthès" => "nep@tEz",
"nèpes" => "nEp",
"néphrectomie" => "nefREktomi",
"néphrétique" => "nefRetik",
"néphrétiques" => "nefRetik",
"néphrite" => "nefRit",
"néphrologie" => "nefRoloZi",
"néphrologue" => "nefRolOg",
"nephtys" => "nEftis",
"népotisme" => "nepotizm",
"neptunienne" => "nEptynjEn",
"neptuniens" => "nEptynj5",
"néréide" => "neReid",
"néréides" => "neReid",
"nerf" => "nER",
"nerfs" => "nER",
"néroli" => "neROli",
"nerprun" => "nERpR1",
"nerpruns" => "nERpR1",
"nerva" => "nERva",
"nervé" => "nERve",
"nerver" => "n2Rve",
"nerveuse" => "nERv2z",
"nerveusement" => "nERv2z°m@",
"nerveuses" => "nERv2z",
"nerveux" => "nERv2",
"nervi" => "nERvi",
"nervis" => "nERvi",
"nervosité" => "nERvozite",
"nervosités" => "nERvozite",
"nervure" => "nERvyR",
"nervuré" => "nERvyRe",
"nervurée" => "nERvyRe",
"nervurées" => "nERvyRe",
"nervures" => "nERvyR",
"nés" => "ne",
"nescafé" => "nEskafe",
"nestor" => "nEstOR",
"nestorianisme" => "nEstoRjanizm",
"nestorien" => "nEstoRj5",
"nestorienne" => "nEstoRjEn",
"nestoriennes" => "nEstoRjEn",
"nestoriens" => "nEstoRj5",
"net" => "nEt",
"nets" => "nEt",
"nette" => "nEt",
"nettement" => "nEt°m@",
"nettes" => "nEt",
"netteté" => "nEtte",
"nettoie" => "nEtwa",
"nettoiement" => "netwam@",
"nettoient" => "netwa",
"nettoiera" => "netwaRa",
"nettoierai" => "netwaRE",
"nettoieraient" => "nEtwaRE",
"nettoierais" => "nEtwaRE",
"nettoierait" => "netwaRE",
"nettoieras" => "nEtwaRa",
"nettoierez" => "netwaRe",
"nettoierons" => "nEtwaR§",
"nettoies" => "netwa",
"nettoya" => "netwaja",
"nettoyable" => "netwajabl",
"nettoyables" => "netwajabl",
"nettoyage" => "netwajaZ",
"nettoyages" => "netwajaZ",
"nettoyai" => "netwajE",
"nettoyaient" => "netwajE",
"nettoyais" => "netwajE",
"nettoyait" => "netwajE",
"nettoyant" => "netwaj@",
"nettoyante" => "netwaj@t",
"nettoyants" => "netwaj@",
"nettoyât" => "netwaja",
"nettoyé" => "netwaje",
"nettoyée" => "netwaje",
"nettoyées" => "netwaje",
"nettoyer" => "netwaje",
"nettoyèrent" => "netwajER",
"nettoyés" => "netwaje",
"nettoyeur" => "netwaj9R",
"nettoyeurs" => "netwaj9R",
"nettoyeuse" => "netwaj2z",
"nettoyeuses" => "netwaj2z",
"nettoyez" => "netwaje",
"nettoyiez" => "netwajje",
"nettoyons" => "netwaj§",
"neuf" => "n9f",
"neufs" => "n9f",
"neuneu" => "n2n2",
"neural" => "n2Ral",
"neurale" => "n2Ral",
"neurales" => "n2Ral",
"neurasthénie" => "n2Rasteni",
"neurasthénique" => "n2Rastenik",
"neurasthéniques" => "n2Rastenik",
"neurinome" => "n2Rinom",
"neurobiologie" => "n2RobjoloZi",
"neurobiologiste" => "n2RobjOlOZist",
"neurochimie" => "n2RoSimi",
"neurochimique" => "n2RoSimik",
"neurochirurgie" => "n2RoSiRyRZi",
"neurochirurgien" => "n2RoSiRyRZj5",
"neurochirurgienne" => "n2RoSiRyRZjEn",
"neurofibromatose" => "n2RofibROmatoz",
"neuroleptique" => "n2RolEptik",
"neuroleptiques" => "n2RolEptik",
"neurolinguistique" => "n2ROl5g8istik",
"neurologie" => "n2RoloZi",
"neurologique" => "n2RoloZik",
"neurologiquement" => "n2RoloZik°m@",
"neurologiques" => "n2RoloZik",
"neurologiste" => "n2RoloZist",
"neurologue" => "n2RolOg",
"neurologues" => "n2RolOg",
"neuromusculaire" => "n2RomyskylER",
"neuronal" => "n2Ronal",
"neuronale" => "n2Ronal",
"neuronales" => "n2Ronal",
"neuronaux" => "n2Rono",
"neurone" => "n2Ron",
"neurones" => "n2Ron",
"neuronique" => "n2ROnik",
"neuropathie" => "n2Ropati",
"neuropathologie" => "n2RopatoloZi",
"neuropeptide" => "n2RopEptid",
"neurophysiologie" => "n2RofizjoloZi",
"neuroplégique" => "n2RopleZik",
"neuropsychiatrie" => "n2RopsikjatRi",
"neuropsychologiques" => "n2RopsikoloZik",
"neuropsychologue" => "n2RopsikolOg",
"neuroscience" => "n2Rosj@s",
"neurotoxine" => "n2RotOksin",
"neurotoxique" => "n2RotOksik",
"neurotransmetteur" => "n2RotR@smEt9R",
"neurotransmetteurs" => "n2RotR@smEt9R",
"neutralisaient" => "n2tRalizE",
"neutralisait" => "n2tRalizE",
"neutralisant" => "n2tRaliz@",
"neutralisante" => "n2tRaliz@t",
"neutralisateur" => "n2tRalizat9R",
"neutralisation" => "n2tRalizasj§",
"neutralise" => "n2tRaliz",
"neutralisé" => "n2tRalize",
"neutralisée" => "n2tRalize",
"neutralisées" => "n2tRalize",
"neutralisent" => "n2tRaliz",
"neutraliser" => "n2tRalize",
"neutralisera" => "n2tRaliz°Ra",
"neutraliserai" => "n2tRaliz°RE",
"neutraliseraient" => "n2tRaliz°RE",
"neutraliserait" => "n2tRaliz°RE",
"neutraliseront" => "n2tRaliz°R§",
"neutralisés" => "n2tRalize",
"neutralisez" => "n2tRalize",
"neutralisiez" => "n2tRalizje",
"neutralisons" => "n2tRaliz§",
"neutraliste" => "n2tRalist",
"neutralité" => "n2tRalite",
"neutre" => "n2tR",
"neutres" => "n2tR",
"neutrino" => "n2tRino",
"neutrinos" => "n2tRino",
"neutron" => "n2tR§",
"neutronique" => "n2tROnik",
"neutrons" => "n2tR§",
"neutropénie" => "n2tROpeni",
"neuvaine" => "n9vEn",
"neuvaines" => "n9vEn",
"neuve" => "n9v",
"neuves" => "n9v",
"neuvième" => "n9vjEm",
"neuvièmes" => "n9vjEm",
"névé" => "neve",
"névés" => "neve",
"neveu" => "n°v2",
"neveux" => "n°v2",
"névralgie" => "nevRalZi",
"névralgies" => "nEvRalZi",
"névralgique" => "nevRalZik",
"névralgiques" => "nevRalZik",
"névrite" => "nevRit",
"névropathe" => "nevRopat",
"névroptères" => "nevRoptER",
"névrose" => "nevRoz",
"névrosé" => "nevRoze",
"névrosée" => "nevRoze",
"névrosées" => "nevRoze",
"névroses" => "nevRoz",
"névrosés" => "nevRoze",
"névrotique" => "nevRotik",
"névrotiques" => "nevRotik",
"new" => "nuw",
"new wave" => "njuwejv",
"new-yorkais" => "njujORkE",
"new-yorkaise" => "njujORkEz",
"new-yorkaises" => "njujORkEz",
"news" => "njuz",
"ney" => "ne",
"nez" => "ne",
"ni" => "ni",
"nia" => "nja",
"niable" => "njabl",
"niai" => "njE",
"niaient" => "njE",
"niais" => "njE",
"niaise" => "njEz",
"niaisé" => "njEze",
"niaisement" => "njEz°m@",
"niaiser" => "njEze",
"niaiserie" => "njEz°Ri",
"niaiseries" => "njEz°Ri",
"niaises" => "njEz",
"niaiseuse" => "njEz2z",
"niaiseux" => "njEz2",
"niait" => "njE",
"niakoué" => "njakue",
"niakoués" => "njakue",
"niant" => "nj@",
"nib" => "nib",
"nibard" => "nibaR",
"nibards" => "nibaR",
"nibergue" => "nibERg",
"nicaraguayen" => "nikaRagwaj5",
"nicaraguayenne" => "nikaRagwajEn",
"nicaraguayens" => "nikaRagwaj5",
"nice" => "nis",
"nicet" => "nisE",
"nicha" => "niSa",
"nichaient" => "niSE",
"nichait" => "niSE",
"nichan" => "niS@",
"nichant" => "niS@",
"niche" => "niS",
"niché" => "niSe",
"nichée" => "niSe",
"nichées" => "niSe",
"nichent" => "niS",
"nicher" => "niSe",
"nichèrent" => "niSER",
"niches" => "niS",
"nichés" => "niSe",
"nicheurs" => "niS9R",
"nichions" => "niSj§",
"nichon" => "niS§",
"nichonnée" => "niSone",
"nichonnées" => "niSone",
"nichons" => "niS§",
"nickel" => "nikEl",
"nickelé" => "nik°le",
"nickelée" => "nik°le",
"nickelées" => "nik°le",
"nickelés" => "nik°le",
"nickelle" => "nikEl",
"nickels" => "nikEl",
"niçois" => "niswa",
"niçoise" => "niswaz",
"niçoises" => "niswaz",
"nicotine" => "nikotin",
"nicotinisé" => "nikotinize",
"nicotinisés" => "nikotinize",
"nictation" => "niktasj§",
"nictitant" => "niktit@",
"nictitante" => "niktit@t",
"nid" => "ni",
"nid-de-poule" => "nid°pul",
"nidification" => "nidifikasj§",
"nidificatrices" => "nidifikatRis",
"nidifie" => "nidifi",
"nids" => "ni",
"nids-de-poule" => "nid°pul",
"nie" => "ni",
"nié" => "nje",
"niébé" => "njebe",
"nièce" => "njEs",
"nièces" => "njEs",
"niée" => "nje",
"nielle" => "njEl",
"niellé" => "njele",
"nième" => "njEm",
"nient" => "ni",
"nier" => "nje",
"niera" => "niRa",
"nierai" => "niRE",
"nierais" => "niRE",
"nierait" => "niRE",
"nieras" => "niRa",
"nière" => "njER",
"nièrent" => "njER",
"nierez" => "niRe",
"nieriez" => "niRje",
"nierons" => "niR§",
"nieront" => "niR§",
"nies" => "ni",
"niés" => "nje",
"niet" => "njEt",
"nietzschéen" => "nitSe5",
"nietzschéenne" => "nitSeEn",
"nietzschéennes" => "nitSeEn",
"niez" => "nje",
"nigaud" => "nigo",
"nigaude" => "nigod",
"nigaudement" => "nigod°m@",
"nigauderie" => "nigod°Ri",
"nigauds" => "nigo",
"nigelle" => "niZEl",
"nigérian" => "niZeRj@",
"nigériane" => "niZeRjan",
"nigérians" => "niZeRj@",
"nigérien" => "niZeRj5",
"nigériens" => "niZeRj5",
"night club" => "najtkl9b",
"night-club" => "najtkl9b",
"night-clubs" => "najtkl9b",
"niguedouille" => "nigduj",
"nihil obstat" => "niilOpsta",
"nihilisme" => "niilizm",
"nihiliste" => "niilist",
"nihilistes" => "niilist",
"nikkei" => "nikEj",
"nil" => "nil",
"nim" => "nim",
"nimba" => "n5ba",
"nimbaient" => "n5bE",
"nimbait" => "n5bE",
"nimbant" => "n5b@",
"nimbe" => "n5b",
"nimbé" => "n5be",
"nimbée" => "n5be",
"nimbées" => "n5be",
"nimbent" => "n5b",
"nimber" => "n5be",
"nimbes" => "n5b",
"nimbés" => "n5be",
"nimbo" => "n5bo",
"nimbo-stratus" => "n5bostRatys",
"nimbostratus" => "n5bostRatys",
"nimbus" => "n5bys",
"ninas" => "nina",
"niobium" => "njObjOm",
"niolo" => "nijolo",
"nions" => "nj§",
"nioulouque" => "njuluk",
"nippe" => "nip",
"nippé" => "nipe",
"nippée" => "nipe",
"nippées" => "nipe",
"nipper" => "nipe",
"nippes" => "nip",
"nippez" => "nipe",
"nippo" => "nipo",
"nippon" => "nip§",
"nippone" => "nipOn",
"nippones" => "nipOn",
"nipponne" => "nipOn",
"nippons" => "nip§",
"niquait" => "nikEt",
"nique" => "nik",
"niqué" => "nike",
"niquedouille" => "nik°duj",
"niquée" => "nike",
"niquent" => "nik",
"niquer" => "nike",
"niquera" => "nik°Ra",
"niquerait" => "nik°RE",
"niques" => "nik",
"niqués" => "nike",
"niquez" => "nike",
"niquons" => "nik§",
"nirvana" => "niRvana",
"nirvâna" => "niRvana",
"nirvanas" => "niRvana",
"nisan" => "niz@",
"nitratant" => "nitRat@",
"nitrate" => "nitRat",
"nitrates" => "nitRat",
"nitre" => "nitR",
"nitré" => "nitRe",
"nitreuse" => "nitR2z",
"nitreux" => "nitR2",
"nitrique" => "nitRik",
"nitrite" => "nitRit",
"nitrogène" => "nitRoZEn",
"nitroglycérine" => "nitRogliseRin",
"nivaquine" => "nivakin",
"niveau" => "nivo",
"niveaux" => "nivo",
"nivelait" => "niv°lE",
"nivelant" => "niv°l@",
"nivelât" => "niv°la",
"nivelé" => "niv°le",
"nivelée" => "niv°le",
"nivelées" => "niv°le",
"niveler" => "niv°le",
"nivelés" => "niv°le",
"niveleur" => "niv°l9R",
"niveleurs" => "niv°l9R",
"niveleuse" => "niv°l2z",
"nivelle" => "nivEl",
"nivellement" => "nivEl°m@",
"nivellent" => "nivEl",
"nivernais" => "nivERnE",
"nivernaise" => "nivERnEz",
"nivôse" => "nivoz",
"nixe" => "niks",
"no man's land" => "nomansl@d",
"nobiliaire" => "nobiljER",
"nobiliaires" => "nobiljER",
"nobilitas" => "nobilita",
"noblaillon" => "noblaj§",
"noble" => "nObl",
"noblement" => "nObl°m@",
"nobles" => "nObl",
"noblesse" => "noblEs",
"noblesses" => "noblEs",
"nobliau" => "nOblijo",
"nobliaux" => "noblijo",
"noce" => "nOs",
"nocer" => "nOse",
"noces" => "nOs",
"noceur" => "nos9R",
"noceurs" => "nos9R",
"noceuse" => "nos2z",
"noceuses" => "nos2z",
"nocher" => "noSe",
"nochère" => "nOSER",
"nocif" => "nosif",
"nocifs" => "nosif",
"nocive" => "nosiv",
"nocives" => "nosiv",
"nocivité" => "nosivite",
"noctambule" => "nOkt@byl",
"noctambules" => "nOkt@byl",
"noctambulisme" => "nOkt@bylizm",
"nocturnal" => "nOktyRnal",
"nocturne" => "nOktyRn",
"nocturnes" => "nOktyRn",
"nodal" => "nodal",
"nodales" => "nodal",
"nodosités" => "nodozite",
"nodule" => "nodyl",
"nodules" => "nodyl",
"noduleux" => "nodyl2",
"nodus" => "nodys",
"noël" => "noEl",
"noëls" => "noEl",
"noeud" => "n2",
"noeuds" => "n2",
"noie" => "nwa",
"noient" => "nwa",
"noiera" => "nwaRa",
"noierai" => "nwaRE",
"noieraient" => "nwaRE",
"noierait" => "nwaRE",
"noieras" => "nwaRa",
"noierez" => "nwaRe",
"noieront" => "nwaR§",
"noies" => "nwa",
"noir" => "nwaR",
"noirâtre" => "nwaRatR",
"noirâtres" => "nwaRatR",
"noiraud" => "nwaRo",
"noiraude" => "nwaRod",
"noiraudes" => "nwaRod",
"noirauds" => "nwaRo",
"noirceur" => "nwaRs9R",
"noirceurs" => "nwaRs9R",
"noirci" => "nwaRsi",
"noircie" => "nwaRsi",
"noircies" => "nwaRsi",
"noircir" => "nwaRsiR",
"noircirai" => "nwaRsiRE",
"noircirais" => "nwaRsiRE",
"noircirait" => "nwaRsiRE",
"noircirent" => "nwaRsiR",
"noircis" => "nwaRsi",
"noircissaient" => "nwaRsisE",
"noircissais" => "nwaRsisE",
"noircissait" => "nwaRsisE",
"noircissant" => "nwaRsis@",
"noircisse" => "nwaRsis",
"noircissent" => "nwaRsis",
"noircissez" => "nwaRsise",
"noircit" => "nwaRsi",
"noire" => "nwaR",
"noires" => "nwaR",
"noirs" => "nwaR",
"noise" => "nwaz",
"noises" => "nwaz",
"noisetier" => "nwaz°tje",
"noisetiers" => "nwaz°tje",
"noisette" => "nwazEt",
"noisettes" => "nwazEt",
"noix" => "nwa",
"nok" => "nOk",
"nolis" => "noli",
"nom" => "n§",
"nomade" => "nomad",
"nomades" => "nomad",
"nomadisait" => "nomadizE",
"nomadisant" => "nomadiz@",
"nomadisent" => "nomadiz",
"nomadisme" => "nomadizm",
"nombre" => "n§bR",
"nombres" => "n§bR",
"nombreuse" => "n§bR2z",
"nombreuses" => "n§bR2z",
"nombreux" => "n§bR2",
"nombril" => "n§bRil",
"nombrilisme" => "n§bRilism",
"nombriliste" => "n§bRilist",
"nombrils" => "n§bRil",
"nome" => "nOm",
"nomenclature" => "nom@klatyR",
"nomenclatures" => "nom@klatyR",
"nomenklatura" => "nom@klatyRa",
"nominal" => "nominal",
"nominale" => "nominal",
"nominalement" => "nOminal°m@",
"nominales" => "nominal",
"nominaliste" => "nominalist",
"nominatif" => "nominatif",
"nominatifs" => "nominatif",
"nomination" => "nominasj§",
"nominations" => "nominasj§",
"nominative" => "nominativ",
"nominatives" => "nominativ",
"nominaux" => "nOmino",
"nomine" => "nomin",
"nominé" => "nomine",
"nominée" => "nomine",
"nominées" => "nomine",
"nominer" => "nOmine",
"nominés" => "nomine",
"nomma" => "noma",
"nommai" => "nomE",
"nommaient" => "nomE",
"nommais" => "nomE",
"nommait" => "nomE",
"nommant" => "nom@",
"nommât" => "noma",
"nomme" => "nOm",
"nommé" => "nome",
"nommée" => "nome",
"nommées" => "nome",
"nommément" => "nomem@",
"nomment" => "nOm",
"nommer" => "nome",
"nommera" => "nOm°Ra",
"nommerai" => "nOm°RE",
"nommerais" => "nOm°RE",
"nommerait" => "nOm°RE",
"nommeras" => "nOm°Ra",
"nommèrent" => "nomER",
"nommeriez" => "nOm°Rje",
"nommerons" => "nOm°R§",
"nommeront" => "nOm°R§",
"nommes" => "nOm",
"nommés" => "nome",
"nommez" => "nome",
"nommiez" => "nomje",
"nommions" => "nomj§",
"nommons" => "nom§",
"noms" => "n§",
"non" => "n§",
"non troppo" => "nOntRopo",
"non-agression" => "nOnagREsj§",
"non-alignement" => "nOnaliN°m@",
"non-alignés" => "nOnaliNe",
"non-amour" => "nOnamuR",
"non-appartenance" => "nOnapaRt2n@s",
"non-assistance" => "nOnasist@s",
"non-blanc" => "n§bl@",
"non-blancs" => "n§bl@",
"non-combattant" => "n§k§bat@",
"non-combattants" => "n§k§bat@",
"non-comparution" => "n§k§paRysj§",
"non-concurrence" => "n§k§kyR@s",
"non-conformisme" => "n§k§fORmizm",
"non-conformiste" => "n§k§fORmist",
"non-conformistes" => "n§k§fORmist",
"non-conformité" => "n§k§fORmite",
"non-consommation" => "n§k§sOmasj§",
"non-croyance" => "n§kRwaj@s",
"non-croyant" => "n§kRwaj@",
"non-croyants" => "n§kRwaj@",
"non-culpabilité" => "n§kylpabilite",
"non-dit" => "n§di",
"non-dits" => "n§di",
"non-droit" => "n§dRwa",
"non-être" => "n§nEtR",
"non-événement" => "nOneven°m@",
"non-existence" => "nOnEgzist@s",
"non-ferreux" => "n§fER2",
"non-fumeur" => "n§fym9R",
"non-fumeurs" => "n§fym9R",
"non-initié" => "nOninisje",
"non-initiés" => "nOninisje",
"non-intervention" => "nOn5tERv@sj§",
"non-lieu" => "n§lj2",
"non-lieux" => "n§lj2",
"non-malades" => "n§malad",
"non-paiement" => "n§pEm@",
"non-participation" => "n§paRtisipasj§",
"non-pesanteur" => "n§p°z@t9R",
"non-présence" => "n§pRez@s",
"non-prolifération" => "n§pRolifeRasj§",
"non-recevoir" => "n§R2s2vwaR",
"non-représentation" => "n§R2pRez@tasj§",
"non-résistance" => "n§Rezist@s",
"non-respect" => "n§REspE",
"non-retour" => "n§R2tuR",
"non-savoir" => "n§savwaR",
"non-sens" => "n§s@s",
"non-séparation" => "n§sepaRasj§",
"non-spécialiste" => "n§spesjalist",
"non-spécialistes" => "n§spesjalist",
"non-stop" => "nOnstOp",
"non-utilisation" => "nOnytilizasj§",
"non-vie" => "n§vi",
"non-violence" => "n§vjol@s",
"non-violent" => "n§vjol@",
"non-violente" => "n§vjol@t",
"non-violents" => "n§vjol@",
"non-vouloir" => "n§vulwaR",
"non-voyant" => "n§vwaj@",
"non-voyante" => "n§vwaj@t",
"non-voyants" => "n§vwaj@",
"nonagénaire" => "nonaZenER",
"nonagénaires" => "nonaZenER",
"nonante" => "non@t",
"nonante-huit" => "non@t8it",
"nonce" => "n§s",
"nonchalamment" => "n§Salam@",
"nonchalance" => "n§Sal@s",
"nonchalant" => "n§Sal@",
"nonchalante" => "n§Sal@t",
"nonchalantes" => "n§Sal@t",
"nonchalants" => "n§Sal@",
"nonciature" => "n§sjatyR",
"none" => "nOn",
"nones" => "nOn",
"nonette" => "nonEt",
"nonettes" => "nonEt",
"nonidi" => "nonidi",
"nonnain" => "non5",
"nonne" => "nOn",
"nonnes" => "nOn",
"nonnette" => "nonEt",
"nonnettes" => "nonEt",
"nonobstant" => "nonOpst@",
"nonpareille" => "n§paREj",
"nonsense" => "n§s@s",
"nope" => "nOp",
"noradrénaline" => "nORadRenalin",
"nord" => "nOR",
"nord-africain" => "nORafRik5",
"nord-africaine" => "nORafRikEn",
"nord-africaines" => "nORafRikEn",
"nord-africains" => "nORafRik5",
"nord-américain" => "nORameRik5",
"nord-américaine" => "nORameRikEn",
"nord-américains" => "nORameRik5",
"nord-coréen" => "nORkoRe5",
"nord-coréenne" => "nORkoReEn",
"nord-coréennes" => "nORkoReEn",
"nord-coréens" => "nORkoRe5",
"nord-est" => "nOREst",
"nord-nord-est" => "nORnOREst",
"nord-ouest" => "nORwEst",
"nord-sud" => "nORsyd",
"nord-vietnamien" => "nORvjEtnamj5",
"nord-vietnamienne" => "nORvjEtnamjEn",
"nord-vietnamiens" => "nORvjEtnamj5",
"nordet" => "nORdE",
"nordicité" => "nORdisite",
"nordique" => "nORdik",
"nordiques" => "nORdik",
"nordiste" => "nORdist",
"nordistes" => "nORdist",
"noria" => "noRja",
"norias" => "noRja",
"normal" => "nORmal",
"normale" => "nORmal",
"normalement" => "nORmal°m@",
"normales" => "nORmal",
"normalien" => "nORmalj5",
"normalienne" => "nORmaljEn",
"normaliennes" => "nORmaljEn",
"normaliens" => "nORmalj5",
"normalisation" => "nORmalizasj§",
"normalise" => "nORmaliz",
"normalisée" => "nORmalize",
"normalisées" => "nORmalize",
"normalisent" => "nORmaliz",
"normaliser" => "nORmalize",
"normalisés" => "nORmalize",
"normalisons" => "nORmaliz§",
"normalité" => "nORmalite",
"normand" => "nORm@",
"normande" => "nORm@d",
"normandes" => "nORm@d",
"normands" => "nORm@",
"normatif" => "nORmatif",
"normative" => "nORmativ",
"normaux" => "nORmo",
"norme" => "nORm",
"normes" => "nORm",
"noroît" => "noRwa",
"norroise" => "nORwaz",
"norvégien" => "nORveZj5",
"norvégienne" => "nORveZjEn",
"norvégiennes" => "nORveZjEn",
"norvégiens" => "nORveZj5",
"nos" => "no",
"nosocomiale" => "nozOkOmjal",
"nostalgie" => "nOstalZi",
"nostalgies" => "nOstalZi",
"nostalgique" => "nOstalZik",
"nostalgiquement" => "nOstalZik°m@",
"nostalgiques" => "nOstalZik",
"not" => "nOt",
"nota" => "nota",
"nota bene" => "notabene",
"notabilité" => "notabilite",
"notabilités" => "notabilite",
"notable" => "notabl",
"notablement" => "notabl°m@",
"notables" => "notabl",
"notai" => "notE",
"notaient" => "notE",
"notaire" => "notER",
"notaires" => "notER",
"notais" => "notE",
"notait" => "notE",
"notamment" => "notam@",
"notant" => "not@",
"notarial" => "notaRjal",
"notariale" => "nOtaRjal",
"notariat" => "notaRja",
"notariaux" => "notaRjo",
"notarié" => "notaRje",
"notariée" => "notaRje",
"notariées" => "notaRje",
"notariés" => "notaRje",
"notation" => "notasj§",
"notations" => "notasj§",
"note" => "nOt",
"noté" => "note",
"notée" => "note",
"notées" => "note",
"notent" => "nOt",
"noter" => "note",
"notera" => "nOt°Ra",
"noterai" => "nOt°RE",
"noterais" => "nOt°RE",
"noterait" => "nOt°RE",
"noteras" => "nOt°Ra",
"notèrent" => "notER",
"noterez" => "nOt°Re",
"noterons" => "nOt°R§",
"noteront" => "nOt°R§",
"notes" => "nOt",
"notés" => "note",
"notez" => "note",
"notice" => "notis",
"notices" => "notis",
"notiez" => "notje",
"notifia" => "notifja",
"notifiai" => "notifjE",
"notifiaient" => "notifjE",
"notifiait" => "notifjE",
"notifiant" => "notifj@",
"notification" => "notifikasj§",
"notifié" => "notifje",
"notifiée" => "notifje",
"notifiées" => "notifje",
"notifier" => "notifje",
"notifiez" => "notifje",
"notifions" => "notifj§",
"notion" => "nosj§",
"notions" => "nOsj§",
"notoire" => "notwaR",
"notoirement" => "notwaR°m@",
"notoires" => "notwaR",
"notonecte" => "notonEkt",
"notonectes" => "notonEkt",
"notons" => "not§",
"notoriété" => "notoRjete",
"notoriétés" => "notoRjete",
"notre" => "nOtR",
"nôtre" => "notR",
"notre-dame" => "nOtR°dam",
"nôtres" => "notR",
"notules" => "notyl",
"noua" => "nwa",
"nouage" => "nwaZ",
"nouai" => "nwE",
"nouaient" => "nwE",
"nouais" => "nwE",
"nouait" => "nwE",
"nouant" => "nw@",
"nouas" => "nua",
"nouba" => "nuba",
"noubas" => "nuba",
"noue" => "nu",
"noué" => "nwe",
"nouée" => "nwe",
"nouées" => "nwe",
"nouent" => "nu",
"nouer" => "nwe",
"nouera" => "nuRa",
"nouerais" => "nuRE",
"nouerait" => "nuRE",
"nouèrent" => "nwER",
"nouerez" => "nuRe",
"noueront" => "nuR§",
"noués" => "nwe",
"noueuse" => "nw2z",
"noueuses" => "nw2z",
"noueux" => "nw2",
"nouez" => "nue",
"nougat" => "nuga",
"nougatine" => "nugatin",
"nougatines" => "nugatin",
"nougats" => "nuga",
"nouille" => "nuj",
"nouilles" => "nuj",
"noumène" => "numEn",
"nounou" => "nunu",
"nounours" => "nunuRs",
"nounous" => "nunu",
"nourri" => "nuRi",
"nourrice" => "nuRis",
"nourrices" => "nuRis",
"nourricier" => "nuRisje",
"nourricière" => "nuRisjER",
"nourricières" => "nuRisjER",
"nourriciers" => "nuRisje",
"nourrie" => "nuRi",
"nourries" => "nuRi",
"nourrir" => "nuRiR",
"nourrira" => "nuRiRa",
"nourrirai" => "nuRiRE",
"nourriraient" => "nuRiRE",
"nourrirais" => "nuRiRE",
"nourrirait" => "nuRiRE",
"nourriras" => "nuRiRa",
"nourrirent" => "nuRiR",
"nourrirez" => "nuRiRe",
"nourririons" => "nuRiRj§",
"nourrirons" => "nuRiR§",
"nourriront" => "nuRiR§",
"nourris" => "nuRi",
"nourrissage" => "nuRisaZ",
"nourrissaient" => "nuRisE",
"nourrissais" => "nuRisE",
"nourrissait" => "nuRisE",
"nourrissant" => "nuRis@",
"nourrissante" => "nuRis@t",
"nourrissantes" => "nuRis@t",
"nourrissants" => "nuRis@",
"nourrisse" => "nuRis",
"nourrissent" => "nuRis",
"nourrisses" => "nuRis",
"nourrisseur" => "nuRis9R",
"nourrissez" => "nuRise",
"nourrissiez" => "nuRisje",
"nourrissions" => "nuRisj§",
"nourrisson" => "nuRis§",
"nourrissons" => "nuRis§",
"nourrit" => "nuRi",
"nourrît" => "nuRi",
"nourriture" => "nuRityR",
"nourritures" => "nuRityR",
"nous" => "nu",
"nous-même" => "numEm",
"nous-mêmes" => "numEm",
"nouveau" => "nuvo",
"nouveau-né" => "nuvone",
"nouveau-nés" => "nuvone",
"nouveauté" => "nuvote",
"nouveautés" => "nuvote",
"nouveaux" => "nuvo",
"nouveaux-nés" => "nuvone",
"nouvel" => "nuvEl",
"nouvelle" => "nuvEl",
"nouvellement" => "nuvEl°m@",
"nouvelles" => "nuvEl",
"nouvelleté" => "nuvEl°te",
"nouvelliste" => "nuvelist",
"nova" => "nova",
"novateur" => "novat9R",
"novateurs" => "novat9R",
"novation" => "nOvasj§",
"novatrice" => "novatRis",
"novatrices" => "novatRis",
"nove" => "nOv",
"novelettes" => "nov°lEt",
"novélisation" => "novelizasj§",
"novembre" => "nov@bR",
"novice" => "novis",
"novices" => "novis",
"noviciat" => "novisja",
"novilleros" => "novijeRo",
"novillo" => "novijo",
"novocaïne" => "novokain",
"novotique" => "nOvOtik",
"noya" => "nwaja",
"noyade" => "nwajad",
"noyades" => "nwajad",
"noyaient" => "nwajE",
"noyais" => "nwajE",
"noyait" => "nwajE",
"noyant" => "nwaj@",
"noyau" => "nwajo",
"noyauta" => "nwajota",
"noyautage" => "nwajotaZ",
"noyautant" => "nwajot@",
"noyauté" => "nwajote",
"noyautée" => "nwajote",
"noyautées" => "nwajote",
"noyautent" => "nwajot",
"noyauter" => "nwajote",
"noyaux" => "nwajo",
"noyé" => "nwaje",
"noyée" => "nwaje",
"noyées" => "nwaje",
"noyer" => "nwaje",
"noyèrent" => "nwajER",
"noyers" => "nwaje",
"noyés" => "nwaje",
"noyez" => "nwaje",
"noyions" => "nwajj§",
"noyons" => "nwaj§",
"nu" => "ny",
"nu-propriétaire" => "nypRopRijetER",
"nu-tête" => "nytEt",
"nuage" => "n8aZ",
"nuages" => "n8aZ",
"nuageuse" => "n8aZ2z",
"nuageuses" => "n8aZ2z",
"nuageux" => "n8aZ2",
"nuança" => "n8@sa",
"nuançaient" => "n8@sE",
"nuançait" => "n8@sE",
"nuançant" => "n8@s@",
"nuançât" => "n8@sa",
"nuance" => "n8@s",
"nuancé" => "n8@se",
"nuancée" => "n8@se",
"nuancées" => "n8@se",
"nuancer" => "n8@se",
"nuances" => "n8@s",
"nuancés" => "n8@se",
"nuancier" => "ny@sje",
"nuas" => "n8a",
"nubien" => "nybj5",
"nubienne" => "nybjEn",
"nubiens" => "nybj5",
"nubile" => "nybil",
"nubiles" => "nybil",
"nubilité" => "nybilite",
"nubuck" => "nybyk",
"nucal" => "nykal",
"nucléaire" => "nykleER",
"nucléaires" => "nykleER",
"nucléée" => "nyklee",
"nucléique" => "nykleik",
"nucléoside" => "nykleozid",
"nucléotides" => "nykleotid",
"nucléus" => "nykleys",
"nudisme" => "nydizm",
"nudiste" => "nydist",
"nudistes" => "nydist",
"nudité" => "nydite",
"nudités" => "nydite",
"nue" => "ny",
"nue-propriété" => "nypRopRijete",
"nuée" => "n8e",
"nuées" => "n8e",
"nuer" => "n8e",
"nues" => "ny",
"nui" => "n8i",
"nuira" => "n8iRa",
"nuirai" => "n8iRE",
"nuirait" => "n8iRE",
"nuiras" => "n8iRa",
"nuire" => "n8iR",
"nuiront" => "n8iR§",
"nuis" => "n8i",
"nuisaient" => "n8izE",
"nuisait" => "n8izE",
"nuisance" => "n8iz@s",
"nuisances" => "n8iz@s",
"nuisant" => "n8iz@",
"nuise" => "n8iz",
"nuisent" => "n8iz",
"nuisette" => "n8izEt",
"nuisez" => "n8ize",
"nuisible" => "n8izibl",
"nuisibles" => "n8izibl",
"nuisît" => "n8izi",
"nuit" => "n8i",
"nuitamment" => "n8itam@",
"nuitards" => "n8itaR",
"nuitée" => "n8ite",
"nuitées" => "n8ite",
"nuiteux" => "n8it2",
"nuits" => "n8i",
"nul" => "nyl",
"nullard" => "nylaR",
"nullarde" => "nylaRd",
"nullardes" => "nylaRd",
"nullards" => "nylaR",
"nulle" => "nyl",
"nullement" => "nyl°m@",
"nulles" => "nyl",
"nullissime" => "nylisim",
"nullité" => "nylite",
"nullités" => "nylite",
"nullos" => "nylo",
"nuls" => "nyl",
"numéraire" => "nymeRER",
"numéral" => "nymeRal",
"numérateur" => "nymeRat9R",
"numération" => "nymeRasj§",
"numérique" => "nymeRik",
"numériquement" => "nymeRik°m@",
"numériques" => "nymeRik",
"numérisation" => "nymeRizasj§",
"numérise" => "nymeRiz",
"numérisé" => "nymeRize",
"numérisée" => "nymeRize",
"numérisées" => "nymeRize",
"numériser" => "nymeRize",
"numérisez" => "nymeRize",
"numéro" => "nymeRo",
"numérologie" => "nymeROlOZi",
"numérologue" => "nymeRolOg",
"numéros" => "nymeRo",
"numérota" => "nymeRota",
"numérotage" => "nymeRotaZ",
"numérotaient" => "nymeRotE",
"numérotait" => "nymeRotE",
"numérotation" => "nymeRotasj§",
"numérote" => "nymeROt",
"numéroté" => "nymeRote",
"numérotée" => "nymeRote",
"numérotées" => "nymeRote",
"numérotent" => "nymeROt",
"numéroter" => "nymeRote",
"numérotés" => "nymeRote",
"numérotez" => "nymeRote",
"numerus clausus" => "nym°Rysklozys",
"numide" => "nymid",
"numides" => "nymid",
"numismate" => "nymismat",
"numismates" => "nymismat",
"numismatique" => "nymismatik",
"nunchaku" => "nunSaku",
"nunchakus" => "nunSaku",
"nuncupatifs" => "n§kypatif",
"nunuche" => "nynyS",
"nunuches" => "nynyS",
"nuoc-mâm" => "n8Okmam",
"nuptial" => "nypsjal",
"nuptiale" => "nypsjal",
"nuptiales" => "nypsjal",
"nuptialité" => "nypsjalite",
"nuptiaux" => "nypsjo",
"nuque" => "nyk",
"nuques" => "nyk",
"nurse" => "n9Rs",
"nurseries" => "n9Rs°Ri",
"nursery" => "n9Rs°Ri",
"nurses" => "n9Rs",
"nursing" => "n9RsiG",
"nus" => "ny",
"nutriment" => "nytRim@",
"nutriments" => "nytRim@",
"nutritif" => "nytRitif",
"nutritifs" => "nytRitif",
"nutrition" => "nytRisj§",
"nutritionnel" => "nytRisjonEl",
"nutritionnelle" => "nytRisjonEl",
"nutritionniste" => "nytRisjonist",
"nutritive" => "nytRitiv",
"nutritives" => "nytRitiv",
"nyctalope" => "niktalOp",
"nyctalopes" => "niktalOp",
"nylon" => "nil§",
"nylons" => "nil§",
"nymphal" => "n5fal",
"nymphe" => "n5f",
"nymphéa" => "n5fea",
"nymphéas" => "n5fea",
"nymphées" => "n5fe",
"nymphes" => "n5f",
"nymphette" => "n5fEt",
"nymphettes" => "n5fEt",
"nympho" => "n5fo",
"nymphomane" => "n5foman",
"nymphomanes" => "n5foman",
"nymphomanie" => "n5fomani",
"nymphos" => "n5fo",
"o" => "o",
"ô" => "o",
"oaristys" => "oaRistis",
"oasis" => "oazis",
"ob" => "Ob",
"obédience" => "obedj@s",
"obédiences" => "obedj@s",
"obéi" => "obei",
"obéie" => "obei",
"obéîmes" => "obeim",
"obéir" => "obeiR",
"obéira" => "obeiRa",
"obéirai" => "obeiRE",
"obéiraient" => "obeiRE",
"obéirais" => "obeiRE",
"obéirait" => "obeiRE",
"obéiras" => "obeiRa",
"obéirent" => "obeiR",
"obéirez" => "obeiRe",
"obéiriez" => "obeiRje",
"obéirons" => "obeiR§",
"obéiront" => "obeiR§",
"obéis" => "obei",
"obéissaient" => "obeisE",
"obéissais" => "obeisE",
"obéissait" => "obeisE",
"obéissance" => "obeis@s",
"obéissant" => "obeis@",
"obéissante" => "obeis@t",
"obéissantes" => "obeis@t",
"obéissants" => "obeis@",
"obéisse" => "obeis",
"obéissent" => "obeis",
"obéisses" => "obeis",
"obéissez" => "obeise",
"obéissiez" => "obeisje",
"obéissions" => "obeisj§",
"obéissons" => "obeis§",
"obéit" => "obei",
"obélisque" => "obelisk",
"obélisques" => "obelisk",
"obérant" => "obeR@",
"obère" => "obER",
"obérer" => "obeRe",
"obèse" => "obEz",
"obèses" => "obEz",
"obésité" => "obezite",
"obésités" => "obezite",
"obi" => "obi",
"obituaire" => "obit8ER",
"objecta" => "ObZEkta",
"objectai" => "ObZEktE",
"objectais" => "ObZEktE",
"objectait" => "ObZEktE",
"objectal" => "ObZEktal",
"objectale" => "ObZEktal",
"objectant" => "ObZEkt@",
"objecte" => "ObZEkt",
"objecté" => "ObZEkte",
"objectent" => "ObZEkt",
"objecter" => "ObZEkte",
"objectera" => "ObZEkt°Ra",
"objectèrent" => "ObZEktER",
"objecterez" => "ObZEkt°Re",
"objecteront" => "ObZEkt°R§",
"objecteur" => "ObZEkt9R",
"objecteurs" => "ObZEkt9R",
"objectez" => "ObZEkte",
"objectif" => "ObZEktif",
"objectifs" => "ObZEktif",
"objection" => "ObZEksj§",
"objections" => "ObZEksj§",
"objectivation" => "ObZEktivasj§",
"objective" => "ObZEktiv",
"objectivement" => "ObZEktiv°m@",
"objectivent" => "ObZEktiv",
"objectives" => "ObZEktiv",
"objectivité" => "ObZEktivite",
"objet" => "ObZE",
"objets" => "ObZE",
"objurgation" => "ObZyRgasj§",
"objurgations" => "ObZyRgasj§",
"objurgua" => "ObZyRga",
"objurguant" => "ObZyRg@",
"oblatif" => "oblatif",
"oblation" => "oblasj§",
"oblative" => "oblativ",
"oblats" => "obla",
"obligado" => "obligado",
"obligataire" => "obligatER",
"obligataires" => "obligatER",
"obligation" => "obligasj§",
"obligations" => "obligasj§",
"obligatoire" => "obligatwaR",
"obligatoirement" => "obligatwaR°m@",
"obligatoires" => "obligatwaR",
"oblige" => "obliZ",
"obligé" => "obliZe",
"obligea" => "obliZa",
"obligeai" => "obliZE",
"obligeaient" => "obliZE",
"obligeais" => "obliZE",
"obligeait" => "obliZE",
"obligeamment" => "obliZam@",
"obligeance" => "obliZ@s",
"obligeances" => "obliZ@s",
"obligeant" => "obliZ@",
"obligeante" => "obliZ@t",
"obligeantes" => "obliZ@t",
"obligeants" => "obliZ@",
"obligeât" => "obliZa",
"obligée" => "obliZe",
"obligées" => "obliZe",
"obligent" => "obliZ",
"obligeons" => "obliZ§",
"obliger" => "obliZe",
"obligera" => "obliZ°Ra",
"obligerai" => "obliZ°RE",
"obligerais" => "obliZ°RE",
"obligerait" => "obliZ°RE",
"obligeras" => "obliZ°Ra",
"obligèrent" => "obliZER",
"obligerez" => "obliZ°Re",
"obligeriez" => "obliZ°Rje",
"obligeront" => "obliZ°R§",
"obliges" => "obliZ",
"obligés" => "obliZe",
"obligez" => "obliZe",
"obligiez" => "obliZje",
"obliqua" => "oblika",
"obliquaient" => "oblikE",
"obliquait" => "oblikE",
"obliquâmes" => "oblikam",
"obliquant" => "oblik@",
"oblique" => "oblik",
"obliqué" => "oblike",
"obliquement" => "oblik°m@",
"obliquent" => "oblik",
"obliquer" => "oblike",
"obliquèrent" => "oblikER",
"obliques" => "oblik",
"obliquez" => "oblike",
"obliquité" => "oblik8ite",
"oblitéraient" => "obliteRE",
"oblitérait" => "obliteRE",
"oblitération" => "obliteRasj§",
"oblitère" => "oblitER",
"oblitéré" => "obliteRe",
"oblitérée" => "obliteRe",
"oblitérées" => "obliteRe",
"oblitèrent" => "oblitER",
"oblitérer" => "obliteRe",
"oblitérèrent" => "obliteRER",
"oblitérés" => "obliteRe",
"oblitérons" => "obliteR§",
"oblong" => "obl§",
"oblongs" => "obl§",
"oblongue" => "obl§g",
"oblongues" => "obl§g",
"obnubila" => "Obnybila",
"obnubilait" => "ObnybilE",
"obnubilant" => "Obnybil@",
"obnubilation" => "Obnybilasj§",
"obnubile" => "Obnybil",
"obnubilé" => "Obnybile",
"obnubilée" => "Obnybile",
"obnubilées" => "Obnybile",
"obnubiler" => "Obnybile",
"obnubilés" => "Obnybile",
"obole" => "obOl",
"oboles" => "obOl",
"obscène" => "OpsEn",
"obscènement" => "OpsEn°m@",
"obscènes" => "OpsEn",
"obscénité" => "Opsenite",
"obscénités" => "Opsenite",
"obscur" => "OpskyR",
"obscurantisme" => "OpskyR@tizm",
"obscurantismes" => "OpskyR@tizm",
"obscurantiste" => "OpskyR@tist",
"obscurci" => "OpskyRsi",
"obscurcie" => "OpskyRsi",
"obscurcies" => "OpskyRsi",
"obscurcir" => "OpskyRsiR",
"obscurcira" => "OpskyRsiRa",
"obscurcirait" => "OpskyRsiRE",
"obscurcis" => "OpskyRsi",
"obscurcissaient" => "OpskyRsisE",
"obscurcissait" => "OpskyRsisE",
"obscurcissant" => "OpskyRsis@",
"obscurcissement" => "OpskyRsis°m@",
"obscurcissements" => "OpskyRsis°m@",
"obscurcissent" => "OpskyRsis",
"obscurcit" => "OpskyRsi",
"obscurcît" => "OpskyRsi",
"obscure" => "OpskyR",
"obscurément" => "OpskyRem@",
"obscures" => "OpskyR",
"obscurité" => "OpskyRite",
"obscurités" => "OpskyRite",
"obscurs" => "OpskyR",
"obséda" => "opseda",
"obsédaient" => "opsedE",
"obsédais" => "opsedE",
"obsédait" => "opsedE",
"obsédant" => "opsed@",
"obsédante" => "opsed@t",
"obsédantes" => "opsed@t",
"obsédants" => "opsed@",
"obsède" => "opsEd",
"obsédé" => "opsede",
"obsédée" => "opsede",
"obsédées" => "opsede",
"obsèdent" => "opsEd",
"obséder" => "opsede",
"obsédèrent" => "opsedER",
"obsèdes" => "opsEd",
"obsédés" => "opsede",
"obsèques" => "OpsEk",
"obséquieuse" => "Opsekj2z",
"obséquieusement" => "Opsekj2z°m@",
"obséquieuses" => "Opsekj2z",
"obséquieux" => "Opsekj2",
"obséquiosité" => "Opsekjozite",
"observa" => "opsERva",
"observable" => "OpsERvabl",
"observai" => "opsERvE",
"observaient" => "opsERvE",
"observais" => "opsERvE",
"observait" => "opsERvE",
"observâmes" => "opsERvam",
"observance" => "opsERv@s",
"observances" => "opsERv@s",
"observant" => "opsERv@",
"observateur" => "opsERvat9R",
"observateurs" => "opsERvat9R",
"observation" => "opsERvasj§",
"observations" => "opsERvasj§",
"observatoire" => "opsERvatwaR",
"observatoires" => "opsERvatwaR",
"observatrice" => "opsERvatRis",
"observatrices" => "opsERvatRis",
"observe" => "opsERv",
"observé" => "opsERve",
"observée" => "opsERve",
"observées" => "opsERve",
"observent" => "opsERv",
"observer" => "opsERve",
"observera" => "opsERv°Ra",
"observerai" => "opsERv°RE",
"observeraient" => "opsERv°RE",
"observerais" => "opsERv°RE",
"observerait" => "opsERv°RE",
"observèrent" => "opsERvER",
"observerez" => "opsERv°Re",
"observerons" => "opsERv°R§",
"observeront" => "opsERv°R§",
"observes" => "opsERv",
"observés" => "opsERve",
"observez" => "opsERve",
"observiez" => "opsERvje",
"observions" => "opsERvj§",
"observons" => "opsERv§",
"obsessif" => "OpsEsif",
"obsession" => "Opsesj§",
"obsessionnel" => "OpsesjonEl",
"obsessionnelle" => "OpsesjonEl",
"obsessionnellement" => "OpsEsjonEl°m@",
"obsessionnelles" => "OpsesjonEl",
"obsessionnels" => "OpsesjonEl",
"obsessions" => "Opsesj§",
"obsessive" => "OpsEsiv",
"obsidienne" => "OpsidjEn",
"obsidional" => "Opsidjonal",
"obsidionale" => "Opsidjonal",
"obsolescence" => "OpsolEs@s",
"obsolète" => "OpsolEt",
"obsolètes" => "OpsolEt",
"obstacle" => "Opstakl",
"obstacles" => "Opstakl",
"obstétrical" => "OpstetRikal",
"obstétricien" => "OpstetRisj5",
"obstétricienne" => "OpstetRisjEn",
"obstétriciens" => "OpstetRisj5",
"obstétrique" => "OpstetRik",
"obstina" => "Opstina",
"obstinai" => "OpstinE",
"obstinaient" => "OpstinE",
"obstinais" => "OpstinE",
"obstinait" => "OpstinE",
"obstinant" => "Opstin@",
"obstination" => "Opstinasj§",
"obstinations" => "Opstinasj§",
"obstine" => "Opstin",
"obstiné" => "Opstine",
"obstinée" => "Opstine",
"obstinées" => "Opstine",
"obstinément" => "Opstinem@",
"obstinent" => "Opstin",
"obstiner" => "Opstine",
"obstinera" => "Opstin°Ra",
"obstineraient" => "Opstin°RE",
"obstinerait" => "Opstin°RE",
"obstineras" => "Opstin°Ra",
"obstinèrent" => "OpstinER",
"obstinerez" => "Opstin°Re",
"obstineriez" => "Opstin°Rje",
"obstineront" => "Opstin°R§",
"obstines" => "Opstin",
"obstinés" => "Opstine",
"obstinez" => "Opstine",
"obstinions" => "Opstinj§",
"obstinons" => "Opstin§",
"obstrua" => "OpstRya",
"obstruaient" => "OpstRyE",
"obstruait" => "OpstRyE",
"obstruant" => "OpstRy@",
"obstructif" => "OpstRyktif",
"obstruction" => "OpstRyksj§",
"obstructionnisme" => "OpstRyksjOnism",
"obstructions" => "OpstRyksj§",
"obstructive" => "OpstRyktiv",
"obstrue" => "OpstRy",
"obstrué" => "OpstRye",
"obstruée" => "OpstRye",
"obstruées" => "OpstRye",
"obstruent" => "OpstRy",
"obstruer" => "OpstRye",
"obstrueraient" => "OpstRyRE",
"obstrueront" => "OpstRyR§",
"obstrués" => "OpstRye",
"obstruez" => "OpstRye",
"obtempéra" => "Opt@peRa",
"obtempérai" => "Opt@peRE",
"obtempéraient" => "Opt@peRE",
"obtempérait" => "Opt@peRE",
"obtempère" => "Opt@pER",
"obtempéré" => "Opt@peRe",
"obtempérer" => "Opt@peRe",
"obtempérèrent" => "Opt@peRER",
"obtempérez" => "Opt@peRe",
"obtempérions" => "Opt@peRj§",
"obtenaient" => "Opt°nE",
"obtenais" => "Opt°nE",
"obtenait" => "Opt°nE",
"obtenant" => "Opt°n@",
"obtenez" => "Opt°ne",
"obteniez" => "Opt°nje",
"obtenions" => "Opt°nj§",
"obtenir" => "Opt°niR",
"obtenons" => "Opt°n§",
"obtention" => "Opt@sj§",
"obtenu" => "Opt°ny",
"obtenue" => "Opt°ny",
"obtenues" => "Opt°ny",
"obtenus" => "Opt°ny",
"obtiendra" => "Optj5dRa",
"obtiendrai" => "Optj5dRE",
"obtiendraient" => "Optj5dRE",
"obtiendrais" => "Optj5dRE",
"obtiendrait" => "Optj5dRE",
"obtiendras" => "Optj5dRa",
"obtiendrez" => "Optj5dRe",
"obtiendriez" => "Optj5dRije",
"obtiendrions" => "Optj5dRij§",
"obtiendrons" => "Optj5dR§",
"obtiendront" => "Optj5dR§",
"obtienne" => "OptjEn",
"obtiennent" => "OptjEn",
"obtiennes" => "OptjEn",
"obtiens" => "Optj5",
"obtient" => "Optj5",
"obtînmes" => "Opt5m",
"obtinrent" => "Opt5R",
"obtins" => "Opt5",
"obtinsse" => "Opt5s",
"obtint" => "Opt5",
"obtînt" => "Opt5",
"obtura" => "OptyRa",
"obturait" => "OptyRE",
"obturateur" => "OptyRat9R",
"obturateurs" => "OptyRat9R",
"obturation" => "OptyRasj§",
"obture" => "OptyR",
"obturé" => "OptyRe",
"obturée" => "OptyRe",
"obturer" => "OptyRe",
"obturez" => "OptyRe",
"obtus" => "Opty",
"obtuse" => "Optyz",
"obtuses" => "Optyz",
"obus" => "oby",
"obusier" => "obyzje",
"obusiers" => "obyzje",
"obverse" => "ObvERs",
"obvie" => "Obvi",
"obvier" => "Obvje",
"ocarina" => "okaRina",
"ocarinas" => "okaRina",
"occase" => "okaz",
"occases" => "okaz",
"occasion" => "okazj§",
"occasionna" => "okazjona",
"occasionnait" => "okazjonE",
"occasionnant" => "okazjon@",
"occasionne" => "okazjOn",
"occasionné" => "okazjone",
"occasionnée" => "okazjone",
"occasionnées" => "okazjone",
"occasionnel" => "okazjonEl",
"occasionnelle" => "okazjonEl",
"occasionnellement" => "okazjonEl°m@",
"occasionnelles" => "okazjonEl",
"occasionnels" => "okazjonEl",
"occasionnent" => "okazjOn",
"occasionner" => "okazjone",
"occasionnèrent" => "okazjonER",
"occasionnés" => "okazjone",
"occasions" => "okazj§",
"occident" => "Oksid@",
"occidental" => "Oksid@tal",
"occidentale" => "Oksid@tal",
"occidentales" => "Oksid@tal",
"occidentalisation" => "Oksid@talizasj§",
"occidentalise" => "Oksid@taliz",
"occidentalisme" => "Oksid@talizm",
"occidentaux" => "Oksid@to",
"occipital" => "Oksipital",
"occipitale" => "Oksipital",
"occipitales" => "Oksipital",
"occipitaux" => "Oksipito",
"occiput" => "Oksipyt",
"occire" => "OksiR",
"occis" => "Oksi",
"occitan" => "Oksit@",
"occitane" => "Oksitan",
"occitans" => "Oksit@",
"occlusion" => "oklyzj§",
"occlut" => "okly",
"occulta" => "okylta",
"occultaient" => "okyltE",
"occultait" => "okyltE",
"occultant" => "Okylt@",
"occultation" => "okyltasj§",
"occultations" => "okyltasj§",
"occulte" => "okylt",
"occulté" => "okylte",
"occultée" => "okylte",
"occultement" => "okylt°m@",
"occultent" => "okylt",
"occulter" => "okylte",
"occultera" => "okylt°Ra",
"occultes" => "okylt",
"occultez" => "okylte",
"occultisme" => "okyltizm",
"occultismes" => "okyltizm",
"occultiste" => "Okyltist",
"occultistes" => "okyltist",
"occupa" => "okypa",
"occupai" => "okypE",
"occupaient" => "okypE",
"occupais" => "okypE",
"occupait" => "okypE",
"occupant" => "okyp@",
"occupante" => "okyp@t",
"occupantes" => "okyp@t",
"occupants" => "okyp@",
"occupas" => "okypa",
"occupât" => "okypa",
"occupation" => "okypasj§",
"occupations" => "okypasj§",
"occupe" => "okyp",
"occupé" => "okype",
"occupée" => "okype",
"occupées" => "okype",
"occupent" => "okyp",
"occuper" => "okype",
"occupera" => "okyp°Ra",
"occuperai" => "okyp°RE",
"occuperaient" => "okyp°RE",
"occuperais" => "okyp°RE",
"occuperait" => "okyp°RE",
"occuperas" => "okyp°Ra",
"occupèrent" => "okypER",
"occuperez" => "okyp°Re",
"occuperions" => "okyp°Rj§",
"occuperons" => "okyp°R§",
"occuperont" => "okyp°R§",
"occupes" => "okyp",
"occupés" => "okype",
"occupez" => "okype",
"occupiez" => "okypje",
"occupions" => "okypj§",
"occupons" => "okyp§",
"occurrence" => "okyR@s",
"occurrences" => "okyR@s",
"occurrentes" => "okyR@t",
"océan" => "ose@",
"océane" => "osean",
"océanienne" => "oseanjEn",
"océanique" => "oseanik",
"océaniques" => "oseanik",
"océanographe" => "oseanogRaf",
"océanographie" => "oseanogRafi",
"océanographique" => "oseanogRafik",
"océanographiques" => "oseanogRafik",
"océanologie" => "OseanOlOZi",
"océanologue" => "OseanOlOg",
"océans" => "ose@",
"ocellée" => "osEle",
"ocelles" => "osEl",
"ocellés" => "osEle",
"ocelot" => "Os°lo",
"ocelots" => "Os°lo",
"ocre" => "OkR",
"ocré" => "okRe",
"ocrée" => "okRe",
"ocrées" => "okRe",
"ocres" => "OkR",
"ocrés" => "okRe",
"ocreux" => "okR2",
"octane" => "Oktan",
"octant" => "Okt@",
"octante" => "Okt@t",
"octave" => "Oktav",
"octaves" => "Oktav",
"octavia" => "Oktavja",
"octavie" => "Oktavi",
"octavo" => "Oktavo",
"octet" => "OktE",
"octets" => "OktE",
"octidi" => "Oktidi",
"octobre" => "OktObR",
"octogénaire" => "OktoZenER",
"octogénaires" => "OktoZenER",
"octogonal" => "Oktogonal",
"octogonale" => "Oktogonal",
"octogonales" => "Oktogonal",
"octogonaux" => "Oktogono",
"octogone" => "Oktogon",
"octogones" => "Oktogon",
"octosyllabe" => "Oktosilab",
"octosyllabes" => "Oktosilab",
"octroi" => "OktRwa",
"octroie" => "OktRwa",
"octroient" => "OktRwa",
"octroiera" => "OktRwaRa",
"octrois" => "OktRwa",
"octroya" => "OktRwaja",
"octroyaient" => "OktRwajE",
"octroyait" => "OktRwajE",
"octroyant" => "OktRwaj@",
"octroyât" => "OktRwaja",
"octroyé" => "OktRwaje",
"octroyée" => "OktRwaje",
"octroyées" => "OktRwaje",
"octroyer" => "OktRwaje",
"octroyés" => "OktRwaje",
"octroyons" => "OktRwaj§",
"octuor" => "Okt8OR",
"octuple" => "Oktypl",
"oculaire" => "okylER",
"oculaires" => "okylER",
"oculi" => "Okyli",
"oculiste" => "okylist",
"oculistes" => "okylist",
"oculomoteur" => "OkylomOt9R",
"oculus" => "okylys",
"ocytocine" => "OsitOsin",
"odalisque" => "odalisk",
"odalisques" => "odalisk",
"ode" => "Od",
"odelette" => "od°lEt",
"odelettes" => "od°lEt",
"odéon" => "ode§",
"odes" => "Od",
"odeur" => "od9R",
"odeurs" => "od9R",
"odieuse" => "odj2z",
"odieusement" => "odj2z°m@",
"odieuses" => "odj2z",
"odieux" => "odj2",
"odomètre" => "OdOmEtR",
"odontologie" => "Od§tOlOZi",
"odontologiste" => "Od§tOlOZist",
"odontologues" => "Od§tolOg",
"odorant" => "odoR@",
"odorante" => "odoR@t",
"odorantes" => "odoR@t",
"odorants" => "odoR@",
"odorat" => "odoRa",
"odoriférant" => "odoRifeR@",
"odoriférante" => "odoRifeR@t",
"odoriférantes" => "odoRifeR@t",
"odoriférants" => "odoRifeR@",
"odyssée" => "odise",
"odyssées" => "odise",
"oecuménique" => "2kymenik",
"oecuméniques" => "2kymenik",
"oecuménisme" => "2kymenizm",
"oedémateuse" => "2demat2z",
"oedème" => "2dEm",
"oedèmes" => "2dEm",
"oedipe" => "2dip",
"oedipien" => "2dipj5",
"oedipienne" => "edipjEn",
"oeil" => "9j",
"oeil-de-boeuf" => "9jd°b9f",
"oeillade" => "9jad",
"oeillades" => "9jad",
"oeillère" => "9jER",
"oeillères" => "9jER",
"oeillet" => "9jE",
"oeilleton" => "9j°t§",
"oeilletons" => "9j°t§",
"oeillets" => "9jE",
"oeillette" => "9jEt",
"oeils" => "9j",
"oeils-de-boeuf" => "9jd°b9f",
"oeils-de-perdrix" => "9jd°pERdRi",
"oenologie" => "2noloZi",
"oenologique" => "2noloZik",
"oenologues" => "2nolOg",
"oenophile" => "2nofil",
"oenothera" => "2notRa",
"oenothère" => "2notER",
"oesophage" => "2zofaZ",
"oesophages" => "2zofaZ",
"oesophagien" => "ezOfaZj5",
"oesophagienne" => "2zofaZjEn",
"oesophagiennes" => "2zofaZjEn",
"oestrogène" => "2stRoZEn",
"oestrogènes" => "2stRoZEn",
"oeuf" => "9f",
"oeufs" => "2",
"oeuvraient" => "9vRE",
"oeuvrait" => "9vRE",
"oeuvrant" => "9vR@",
"oeuvre" => "9vR",
"oeuvré" => "9vRe",
"oeuvrent" => "9vR",
"oeuvrer" => "9vRe",
"oeuvrera" => "9vR°Ra",
"oeuvres" => "9vR",
"oeuvrette" => "9vREt",
"oeuvrettes" => "9vREt",
"oeuvrez" => "9vRe",
"oeuvrions" => "9vRij§",
"off" => "Of",
"off-shore" => "OfSOR",
"offensa" => "of@sa",
"offensaient" => "of@sE",
"offensais" => "of@sE",
"offensait" => "of@sE",
"offensant" => "of@s@",
"offensante" => "of@s@t",
"offensantes" => "of@s@t",
"offensants" => "of@s@",
"offense" => "of@s",
"offensé" => "of@se",
"offensée" => "of@se",
"offensées" => "of@se",
"offensent" => "of@s",
"offenser" => "of@se",
"offensera" => "of@s°Ra",
"offenserai" => "of@s°RE",
"offenseraient" => "of@s°RE",
"offenserais" => "of@s°RE",
"offensèrent" => "of@sER",
"offenserez" => "of@s°Re",
"offenseront" => "of@s°R§",
"offenses" => "of@s",
"offensés" => "of@se",
"offenseur" => "of@s9R",
"offenseurs" => "of@s9R",
"offensez" => "of@se",
"offensif" => "of@sif",
"offensifs" => "of@sif",
"offensive" => "of@siv",
"offensives" => "of@siv",
"offensons" => "of@s§",
"offert" => "ofER",
"offerte" => "ofERt",
"offertes" => "ofERt",
"offertoire" => "ofERtwaR",
"offerts" => "ofER",
"office" => "ofis",
"offices" => "ofis",
"officiaient" => "ofisjE",
"officiais" => "ofisjE",
"officiait" => "ofisjE",
"official" => "Ofisjal",
"officialisait" => "ofisjalizE",
"officialise" => "ofisjaliz",
"officialisé" => "ofisjalize",
"officialiser" => "ofisjalize",
"officialisez" => "ofisjalize",
"officialité" => "ofisjalite",
"officiant" => "ofisj@",
"officiants" => "ofisj@",
"officie" => "ofisi",
"officié" => "Ofisje",
"officiel" => "ofisjEl",
"officielle" => "ofisjEl",
"officiellement" => "ofisjEl°m@",
"officielles" => "ofisjEl",
"officiels" => "ofisjEl",
"officient" => "ofisi",
"officier" => "ofisje",
"officière" => "OfisjER",
"officiers" => "ofisje",
"officieuse" => "ofisj2z",
"officieusement" => "ofisj2z°m@",
"officieuses" => "ofisj2z",
"officieux" => "ofisj2",
"officiez" => "ofisje",
"officine" => "ofisin",
"officines" => "ofisin",
"officions" => "ofisj§",
"offraient" => "ofRE",
"offrais" => "ofRE",
"offrait" => "ofRE",
"offrande" => "ofR@d",
"offrandes" => "ofR@d",
"offrant" => "ofR@",
"offrante" => "OfR@t",
"offrantes" => "ofR@t",
"offrants" => "ofR@",
"offre" => "OfR",
"offrent" => "OfR",
"offres" => "OfR",
"offrez" => "ofRe",
"offriez" => "ofRije",
"offrions" => "ofRij§",
"offrir" => "ofRiR",
"offrira" => "ofRiRa",
"offrirai" => "ofRiRE",
"offriraient" => "ofRiRE",
"offrirais" => "ofRiRE",
"offrirait" => "ofRiRE",
"offriras" => "ofRiRa",
"offrirent" => "ofRiR",
"offrirez" => "ofRiRe",
"offririez" => "ofRiRje",
"offrirons" => "ofRiR§",
"offriront" => "ofRiR§",
"offris" => "ofRi",
"offrit" => "ofRi",
"offrît" => "ofRi",
"offrons" => "ofR§",
"offset" => "OfsEt",
"offshore" => "OfSOR",
"offuscation" => "ofyskasj§",
"offuscations" => "ofyskasj§",
"offusqua" => "ofyska",
"offusquaient" => "ofyskE",
"offusquais" => "ofyskE",
"offusquait" => "ofyskE",
"offusquant" => "ofysk@",
"offusquât" => "ofyska",
"offusque" => "ofysk",
"offusqué" => "ofyske",
"offusquée" => "ofyske",
"offusquées" => "ofyske",
"offusquent" => "ofysk",
"offusquer" => "ofyske",
"offusquerai" => "ofysk°RE",
"offusquerait" => "ofysk°RE",
"offusquèrent" => "ofyskER",
"offusquerez" => "ofysk°Re",
"offusques" => "ofysk",
"offusqués" => "ofyske",
"oflag" => "Oflag",
"oflags" => "Oflag",
"ogival" => "oZival",
"ogive" => "oZiv",
"ogives" => "oZiv",
"ognons" => "oN§",
"ogre" => "OgR",
"ogres" => "OgR",
"ogresse" => "ogREs",
"ogresses" => "ogREs",
"oh" => "o",
"ohé" => "oe",
"ohms" => "om",
"oie" => "wa",
"oies" => "wa",
"oignait" => "waNE",
"oignant" => "waN@",
"oigne" => "waN",
"oignes" => "waN",
"oignez" => "waNe",
"oignit" => "waNi",
"oignon" => "ON§",
"oignons" => "ON§",
"oïl" => "Ojl",
"oille" => "waj",
"oindra" => "w5dRa",
"oindre" => "w5dR",
"oing" => "w5",
"oins" => "w5",
"oint" => "w5",
"ointe" => "w5t",
"ointes" => "w5t",
"oints" => "w5",
"ois" => "wa",
"oiseau" => "wazo",
"oiseau-clé" => "wazokle",
"oiseau-lyre" => "wazoliR",
"oiseau-mouche" => "wazomuS",
"oiseau-vedette" => "wazov°dEt",
"oiseaux" => "wazo",
"oiseaux-mouches" => "wazomuS",
"oiselet" => "waz°lE",
"oiselets" => "waz°lE",
"oiseleur" => "waz°l9R",
"oiseleurs" => "waz°l9R",
"oiselez" => "waz°le",
"oiselier" => "waz°lje",
"oiselière" => "waz°ljER",
"oiseliers" => "waz°lje",
"oiselle" => "wazEl",
"oisellerie" => "wazEl°Ri",
"oiselles" => "wazEl",
"oiseuse" => "waz2z",
"oiseuses" => "waz2z",
"oiseux" => "waz2",
"oisif" => "wazif",
"oisifs" => "wazif",
"oisillon" => "wazij§",
"oisillons" => "wazij§",
"oisive" => "waziv",
"oisivement" => "waziv°m@",
"oisives" => "waziv",
"oisiveté" => "waziv°te",
"oison" => "waz§",
"oisons" => "waz§",
"oit" => "wa",
"ok" => "oke",
"oka" => "oka",
"okapi" => "Okapi",
"okoumé" => "okume",
"ola" => "ola",
"olé" => "ole",
"olé-olé" => "oleole",
"oléagineux" => "oleaZin2",
"olécrane" => "OlekRan",
"olécrâne" => "olekRan",
"oléfine" => "Olefin",
"oléiculteurs" => "oleikylt9R",
"oléine" => "olein",
"oléoduc" => "oleodyk",
"oléoducs" => "oleodyk",
"olfactif" => "Olfaktif",
"olfactifs" => "Olfaktif",
"olfactive" => "Olfaktiv",
"olfactives" => "Olfaktiv",
"olfactomètre" => "OlfaktOmEtR",
"olibrius" => "olibRijys",
"olifant" => "olif@",
"oligarchie" => "oligaRSi",
"oligo-éléments" => "oligoelem@",
"olivaies" => "olivE",
"olivâtre" => "olivatR",
"olivâtres" => "olivatR",
"olive" => "oliv",
"oliver" => "Olive",
"oliveraie" => "oliv°RE",
"oliveraies" => "oliv°RE",
"olives" => "oliv",
"olivette" => "olivEt",
"olivettes" => "olivEt",
"olivier" => "olivje",
"oliviers" => "olivje",
"olivine" => "Olivin",
"olla podrida" => "olapodRida",
"ollé" => "Olle",
"olmèque" => "OlmEk",
"olmèques" => "OlmEk",
"olographe" => "ologRaf",
"olympe" => "ol5p",
"olympes" => "ol5p",
"olympiade" => "ol5pjad",
"olympiades" => "ol5pjad",
"olympien" => "ol5pj5",
"olympienne" => "ol5pjEn",
"olympiens" => "ol5pj5",
"olympique" => "ol5pik",
"olympiques" => "ol5pik",
"omani" => "omani",
"ombelle" => "§bEl",
"ombelles" => "§bEl",
"ombellifères" => "§bElifER",
"ombilic" => "§bilik",
"ombilical" => "§bilikal",
"ombilicale" => "§bilikal",
"ombilicaux" => "§biliko",
"omble" => "§bl",
"ombles" => "§bl",
"ombra" => "§bRa",
"ombrage" => "§bRaZ",
"ombragé" => "§bRaZe",
"ombragea" => "§bRaZa",
"ombrageaient" => "§bRaZE",
"ombrageait" => "§bRaZE",
"ombragée" => "§bRaZe",
"ombragées" => "§bRaZe",
"ombragent" => "§bRaZ",
"ombrager" => "§bRaZe",
"ombrages" => "§bRaZ",
"ombragés" => "§bRaZe",
"ombrageuse" => "§bRaZ2z",
"ombrageusement" => "§bRaZ2z°m@",
"ombrageuses" => "§bRaZ2z",
"ombrageux" => "§bRaZ2",
"ombraient" => "§bRE",
"ombrait" => "§bRE",
"ombrant" => "§bR@",
"ombre" => "§bR",
"ombré" => "§bRe",
"ombrée" => "§bRe",
"ombrées" => "§bRe",
"ombrelle" => "§bREl",
"ombrelles" => "§bREl",
"ombrer" => "§bRe",
"ombres" => "§bR",
"ombrés" => "§bRe",
"ombreuse" => "§bR2z",
"ombreuses" => "§bR2z",
"ombreux" => "§bR2",
"oméga" => "omega",
"omelette" => "om°lEt",
"omelettes" => "om°lEt",
"omerta" => "omERta",
"omet" => "omE",
"omets" => "omE",
"omettaient" => "omEtE",
"omettais" => "omEtE",
"omettait" => "omEtE",
"omettant" => "omEt@",
"omette" => "omEt",
"omettent" => "omEt",
"omettez" => "omEte",
"omettiez" => "omEtje",
"omettrai" => "omEtRE",
"omettre" => "omEtR",
"omettrez" => "omEtRe",
"omicron" => "omikR§",
"omis" => "omi",
"omise" => "omiz",
"omises" => "omiz",
"omission" => "omisj§",
"omissions" => "omisj§",
"omit" => "omi",
"omît" => "omi",
"omni" => "Omni",
"omnibus" => "Omnibys",
"omnidirectionnel" => "OmnidiREksjonEl",
"omnidirectionnelle" => "OmnidiREksjonEl",
"omnipotence" => "Omnipot@s",
"omnipotent" => "Omnipot@",
"omnipotente" => "Omnipot@t",
"omnipotentes" => "Omnipot@t",
"omniprésence" => "OmnipRez@s",
"omniprésent" => "OmnipRez@",
"omniprésente" => "OmnipRez@t",
"omniprésentes" => "OmnipRez@t",
"omniprésents" => "OmnipRez@",
"omnipuissance" => "Omnip8is@s",
"omniscience" => "Omnisj@s",
"omniscient" => "Omnisj@",
"omnisciente" => "Omnisj@t",
"omniscients" => "Omnisj@",
"omnisports" => "OmnispOR",
"omnium" => "OmnjOm",
"omnivore" => "OmnivOR",
"omnivores" => "OmnivOR",
"omoplate" => "omoplat",
"omoplates" => "omoplat",
"omphalos" => "§falo",
"on" => "§",
"on-dit" => "§di",
"on-line" => "Onlajn",
"onagre" => "onagR",
"onanisme" => "onanizm",
"onanismes" => "onanizm",
"onaniste" => "onanist",
"onc" => "§k",
"once" => "§s",
"onces" => "§s",
"oncle" => "§kl",
"oncles" => "§kl",
"oncologie" => "§koloZi",
"oncologique" => "§koloZik",
"oncologue" => "§kolOg",
"oncologues" => "§kolOg",
"onction" => "§ksj§",
"onctions" => "§ksj§",
"onctueuse" => "§kt82z",
"onctueusement" => "§kt82z°m@",
"onctueuses" => "§kt82z",
"onctueux" => "§kt82",
"onctuosité" => "§kt8ozite",
"ondatra" => "§datRa",
"onde" => "§d",
"ondée" => "§de",
"ondées" => "§de",
"onder" => "§de",
"ondes" => "§d",
"ondés" => "§de",
"ondin" => "§d5",
"ondine" => "§din",
"ondines" => "§din",
"ondins" => "§d5",
"ondoie" => "§dwa",
"ondoiement" => "§dwam@",
"ondoiements" => "§dwam@",
"ondoient" => "§dwa",
"ondoyaient" => "§dwajE",
"ondoyait" => "§dwajE",
"ondoyant" => "§dwaj@",
"ondoyante" => "§dwaj@t",
"ondoyantes" => "§dwaj@t",
"ondoyants" => "§dwaj@",
"ondoyé" => "§dwaje",
"ondoyer" => "§dwaje",
"ondoyons" => "§dwaj§",
"ondula" => "§dyla",
"ondulaient" => "§dylE",
"ondulait" => "§dylE",
"ondulant" => "§dyl@",
"ondulante" => "§dyl@t",
"ondulantes" => "§dyl@t",
"ondulants" => "§dyl@",
"ondulation" => "§dylasj§",
"ondulations" => "§dylasj§",
"ondulatoire" => "§dylatwaR",
"ondulatoires" => "§dylatwaR",
"ondule" => "§dyl",
"ondulé" => "§dyle",
"ondulée" => "§dyle",
"ondulées" => "§dyle",
"ondulent" => "§dyl",
"onduler" => "§dyle",
"ondulerait" => "§dyl°RE",
"ondulèrent" => "§dylER",
"ondulés" => "§dyle",
"onduleuse" => "§dyl2z",
"onduleuses" => "§dyl2z",
"onduleux" => "§dyl2",
"ondulons" => "§dyl§",
"one-step" => "wanstEp",
"onéreuse" => "oneR2z",
"onéreuses" => "oneR2z",
"onéreux" => "oneR2",
"ongle" => "§gl",
"onglée" => "§gle",
"ongles" => "§gl",
"onglet" => "§glE",
"onglets" => "§glE",
"onglon" => "§gl§",
"onguent" => "§g@",
"onguents" => "§g@",
"ongulé" => "§gyle",
"ongulés" => "§gyle",
"onirique" => "oniRik",
"oniriques" => "oniRik",
"onirisme" => "OniRism",
"onirologie" => "oniRoloZi",
"onomatopée" => "onomatope",
"onomatopées" => "onomatope",
"onomatopéique" => "OnOmatOpeik",
"onopordons" => "onopORd§",
"ont" => "§",
"onto" => "§to",
"ontologie" => "§toloZi",
"ontologique" => "§toloZik",
"ontologiquement" => "§tOlOZik°m@",
"onusienne" => "onyzjEn",
"onusiennes" => "onyzjEn",
"onusiens" => "onyzj5",
"onyx" => "oniks",
"onze" => "§z",
"onzième" => "§zjEm",
"opacifiait" => "opasifjE",
"opacifiant" => "opasifj@",
"opacification" => "opasifikasj§",
"opacifie" => "opasifi",
"opacifié" => "opasifje",
"opacifient" => "opasifi",
"opacifier" => "opasifje",
"opacité" => "opasite",
"opacités" => "opasite",
"opale" => "opal",
"opales" => "opal",
"opalescence" => "opales@s",
"opalescent" => "opales@",
"opalescente" => "opales@t",
"opalescentes" => "opales@t",
"opalin" => "opal5",
"opaline" => "opalin",
"opalines" => "opalin",
"opalins" => "opal5",
"opaque" => "opak",
"opaques" => "opak",
"ope" => "Op",
"open" => "op°n",
"opéra" => "opeRa",
"opéra-comique" => "opeRakomik",
"opérable" => "opeRabl",
"opéraient" => "opeRE",
"opérais" => "opeRE",
"opérait" => "opeRE",
"opérant" => "opeR@",
"opéras" => "opeRa",
"opérât" => "opeRa",
"opérateur" => "opeRat9R",
"opérateurs" => "opeRat9R",
"opération" => "opeRasj§",
"opération-miracle" => "opeRasj§miRakl",
"opérationnel" => "opeRasjonEl",
"opérationnelle" => "opeRasjonEl",
"opérationnelles" => "opeRasjonEl",
"opérationnels" => "opeRasjonEl",
"opérations" => "opeRasj§",
"opératique" => "OpeRatik",
"opératoire" => "opeRatwaR",
"opératoires" => "opeRatwaR",
"opératrice" => "opeRatRis",
"opératrices" => "opeRatRis",
"opercule" => "opERkyl",
"opère" => "opER",
"opéré" => "opeRe",
"opérée" => "opeRe",
"opérées" => "opeRe",
"opèrent" => "opER",
"opérer" => "opeRe",
"opérera" => "opeR°Ra",
"opérerai" => "opeR°RE",
"opéreraient" => "opeR°RE",
"opérerait" => "opeR°RE",
"opéreras" => "opeR°Ra",
"opérèrent" => "opeRER",
"opérerez" => "opeR°Re",
"opérerons" => "opeR°R§",
"opéreront" => "opeR°R§",
"opérés" => "opeRe",
"opérette" => "opeREt",
"opérettes" => "opeREt",
"opérez" => "opeRe",
"opériez" => "opeRje",
"opérions" => "opeRj§",
"opérons" => "opeR§",
"ophidien" => "Ofidj5",
"ophidiens" => "ofidj5",
"ophite" => "ofit",
"ophtalmique" => "Oftalmik",
"ophtalmologie" => "OftalmoloZi",
"ophtalmologique" => "OftalmOlOZik",
"ophtalmologiste" => "OftalmoloZist",
"ophtalmologistes" => "OftalmoloZist",
"ophtalmologue" => "OftalmolOg",
"ophtalmoscope" => "OftalmoskOp",
"opiacé" => "opjase",
"opiacées" => "opjase",
"opiacés" => "opjase",
"opiat" => "Opja",
"opiats" => "opja",
"opimes" => "opim",
"opina" => "opina",
"opinai" => "opinE",
"opinaient" => "opinE",
"opinais" => "opinE",
"opinait" => "opinE",
"opinant" => "opin@",
"opine" => "opin",
"opiné" => "opine",
"opinel" => "opinEl",
"opinels" => "opinEl",
"opiner" => "opine",
"opinèrent" => "opinER",
"opines" => "opin",
"opiniâtra" => "opinjatRa",
"opiniâtre" => "opinjatR",
"opiniâtrement" => "opinjatR°m@",
"opiniâtres" => "opinjatR",
"opiniâtreté" => "opinjatR°te",
"opiniâtrez" => "opinjatRe",
"opinion" => "opinj§",
"opinions" => "opinj§",
"opiomane" => "opjoman",
"opium" => "opjOm",
"opopanax" => "opopanaks",
"opoponax" => "opoponaks",
"opossum" => "oposOm",
"opossums" => "oposOm",
"opothérapiques" => "opoteRapik",
"oppidum" => "opidOm",
"opportun" => "opORt1",
"opportune" => "opORtyn",
"opportunément" => "opORtynem@",
"opportunes" => "opORtyn",
"opportunisme" => "opORtynizm",
"opportuniste" => "opORtynist",
"opportunistes" => "opORtynist",
"opportunité" => "opORtynite",
"opportunités" => "opORtynite",
"opportuns" => "opORt1",
"opposa" => "opoza",
"opposable" => "Opozabl",
"opposables" => "opozabl",
"opposai" => "opozE",
"opposaient" => "opozE",
"opposais" => "opozE",
"opposait" => "opozE",
"opposant" => "opoz@",
"opposante" => "Opoz@t",
"opposants" => "opoz@",
"opposât" => "opoza",
"oppose" => "opoz",
"opposé" => "opoze",
"opposée" => "opoze",
"opposées" => "opoze",
"opposent" => "opoz",
"opposer" => "opoze",
"opposera" => "opoz°Ra",
"opposerai" => "opoz°RE",
"opposeraient" => "opoz°RE",
"opposerais" => "opoz°RE",
"opposerait" => "opoz°RE",
"opposèrent" => "opozER",
"opposerez" => "opoz°Re",
"opposerions" => "opoz°Rj§",
"opposerons" => "opoz°R§",
"opposeront" => "opoz°R§",
"opposes" => "opoz",
"opposés" => "opoze",
"opposez" => "opoze",
"opposions" => "opozj§",
"opposition" => "opozisj§",
"oppositionnel" => "OpozisjOnEl",
"oppositionnelle" => "opozisjonEl",
"oppositions" => "opozisj§",
"opposons" => "opoz§",
"oppressa" => "opResa",
"oppressaient" => "opResE",
"oppressait" => "opResE",
"oppressant" => "opRes@",
"oppressante" => "opRes@t",
"oppressantes" => "opRes@t",
"oppressants" => "opRes@",
"oppresse" => "opREs",
"oppressé" => "opRese",
"oppressée" => "opRese",
"oppressées" => "opRese",
"oppressent" => "opREs",
"oppresser" => "opRese",
"oppresseur" => "opRes9R",
"oppresseurs" => "opRes9R",
"oppressif" => "opResif",
"oppression" => "opResj§",
"oppressions" => "opResj§",
"oppressive" => "opResiv",
"opprimait" => "opRimE",
"opprimant" => "opRim@",
"opprime" => "opRim",
"opprimé" => "opRime",
"opprimée" => "opRime",
"opprimées" => "opRime",
"oppriment" => "opRim",
"opprimer" => "opRime",
"opprimés" => "opRime",
"opprimez" => "opRime",
"opprobre" => "opRObR",
"opprobres" => "opRObR",
"opta" => "Opta",
"optai" => "OptE",
"optaient" => "OptE",
"optais" => "OptE",
"optait" => "OptE",
"optalidon" => "Optalid§",
"optant" => "Opt@",
"optât" => "Opta",
"optatif" => "Optatif",
"optatifs" => "Optatif",
"opte" => "Opt",
"opté" => "Opte",
"optent" => "Opt",
"opter" => "Opte",
"opterais" => "Opt°RE",
"optèrent" => "OptER",
"optes" => "Opt",
"opticien" => "Optisj5",
"opticienne" => "OptisjEn",
"opticiens" => "Optisj5",
"optima" => "Optima",
"optimal" => "Optimal",
"optimale" => "Optimal",
"optimales" => "Optimal",
"optimaux" => "Optimo",
"optime" => "Optim",
"optimisation" => "Optimizasj§",
"optimise" => "Optimiz",
"optimisé" => "Optimize",
"optimisées" => "Optimize",
"optimiser" => "Optimize",
"optimisez" => "Optimize",
"optimisme" => "Optimizm",
"optimiste" => "Optimist",
"optimistes" => "Optimist",
"optimum" => "OptimOm",
"option" => "Opsj§",
"optionnel" => "OpsjonEl",
"optionnelle" => "OpsjonEl",
"options" => "opsj§",
"optique" => "Optik",
"optiques" => "Optik",
"optométrie" => "OptometRi",
"optométriste" => "OptometRist",
"optons" => "Opt§",
"opulence" => "opyl@s",
"opulences" => "opyl@s",
"opulent" => "opyl@",
"opulente" => "opyl@t",
"opulentes" => "opyl@t",
"opulents" => "opyl@",
"opus" => "opys",
"opuscule" => "opyskyl",
"opuscules" => "opyskyl",
"or" => "OR",
"oracle" => "oRakl",
"oracles" => "oRakl",
"orage" => "oRaZ",
"orages" => "oRaZ",
"orageuse" => "oRaZ2z",
"orageuses" => "oRaZ2z",
"orageux" => "oRaZ2",
"oraison" => "oREz§",
"oraisons" => "oREz§",
"oral" => "oRal",
"orale" => "oRal",
"oralement" => "oRal°m@",
"orales" => "oRal",
"oralité" => "oRalite",
"oranais" => "oRanE",
"oranaise" => "oRanEz",
"orang-outan" => "oR@ut@",
"orang-outang" => "oR@ut@",
"orange" => "oR@Z",
"orangé" => "oR@Ze",
"orangeade" => "oR@Zad",
"orangeades" => "oR@Zad",
"orangée" => "oR@Ze",
"orangées" => "oR@Ze",
"oranger" => "oR@Ze",
"orangeraie" => "oR@Z°RE",
"orangeraies" => "oR@Z°RE",
"orangerie" => "oR@Z°Ri",
"orangeries" => "oR@Z°Ri",
"orangers" => "oR@Ze",
"oranges" => "oR@Z",
"orangés" => "oR@Ze",
"orangistes" => "OR@Zist",
"orangs-outangs" => "oR@ut@",
"orangs-outans" => "oR@ut@",
"orant" => "oR@",
"orante" => "oR@t",
"orantes" => "oR@t",
"orants" => "oR@",
"orateur" => "oRat9R",
"orateurs" => "oRat9R",
"oratoire" => "oRatwaR",
"oratoires" => "oRatwaR",
"oratorien" => "oRatoRj5",
"oratoriens" => "oRatoRj5",
"oratorio" => "oRatoRjo",
"oratorios" => "oRatoRjo",
"oratrice" => "oRatRis",
"oraux" => "oRo",
"orbe" => "ORb",
"orbes" => "ORb",
"orbiculaire" => "ORbikylER",
"orbitaire" => "ORbitER",
"orbitaires" => "ORbitER",
"orbital" => "ORbital",
"orbitale" => "ORbital",
"orbitales" => "ORbital",
"orbitaux" => "ORbito",
"orbite" => "ORbit",
"orbitèle" => "ORbitEl",
"orbitèles" => "ORbitEl",
"orbiter" => "ORbite",
"orbites" => "ORbit",
"orbitons" => "ORbit§",
"orchestra" => "ORkEstRa",
"orchestraient" => "ORkEstRE",
"orchestrait" => "ORkEstRE",
"orchestral" => "ORkEstRal",
"orchestrale" => "ORkEstRal",
"orchestration" => "ORkEstRasj§",
"orchestrations" => "ORkEstRasj§",
"orchestraux" => "ORkEstRo",
"orchestre" => "ORkEstR",
"orchestré" => "ORkEstRe",
"orchestrée" => "ORkEstRe",
"orchestrées" => "ORkEstRe",
"orchestrent" => "ORkEstR",
"orchestrer" => "ORkEstRe",
"orchestres" => "ORkEstR",
"orchestrés" => "ORkEstRe",
"orchidée" => "ORkide",
"orchidées" => "ORkide",
"orchis" => "ORkis",
"ord" => "OR",
"ordalie" => "ORdali",
"ordinaire" => "ORdinER",
"ordinairement" => "ORdinER°m@",
"ordinaires" => "ORdinER",
"ordinal" => "ORdinal",
"ordinant" => "ORdin@",
"ordinateur" => "ORdinat9R",
"ordinateurs" => "ORdinat9R",
"ordination" => "ORdinasj§",
"ordo" => "ORdo",
"ordonna" => "ORdona",
"ordonnai" => "ORdonE",
"ordonnaient" => "ORdonE",
"ordonnais" => "ORdonE",
"ordonnait" => "ORdonE",
"ordonnance" => "ORdon@s",
"ordonnancée" => "ORdon@se",
"ordonnancement" => "ORdon@s°m@",
"ordonnancer" => "ORdon@se",
"ordonnances" => "ORdon@s",
"ordonnant" => "ORdon@",
"ordonnateur" => "ORdonat9R",
"ordonnateurs" => "ORdonat9R",
"ordonnatrice" => "ORdonatRis",
"ordonne" => "ORdOn",
"ordonné" => "ORdone",
"ordonnée" => "ORdone",
"ordonnées" => "ORdone",
"ordonnent" => "ORdOn",
"ordonner" => "ORdone",
"ordonnera" => "ORdOn°Ra",
"ordonnerai" => "ORdOn°RE",
"ordonnerais" => "ORdOn°RE",
"ordonnerait" => "ORdOn°RE",
"ordonnèrent" => "ORdOnER",
"ordonneront" => "ORdOn°R§",
"ordonnes" => "ORdOn",
"ordonnés" => "ORdone",
"ordonnez" => "ORdone",
"ordonniez" => "ORdonje",
"ordonnons" => "ORdon§",
"ordre" => "ORdR",
"ordres" => "ORdR",
"ordure" => "ORdyR",
"ordureries" => "ORdyR°Ri",
"ordures" => "ORdyR",
"ordurier" => "ORdyRje",
"ordurière" => "ORdyRjER",
"ordurières" => "ORdyRjER",
"orduriers" => "ORdyRje",
"ore" => "OR",
"oréade" => "oRead",
"orée" => "oRe",
"oreille" => "oREj",
"oreiller" => "oReje",
"oreillers" => "oReje",
"oreilles" => "oREj",
"oreillette" => "oREjEt",
"oreillettes" => "oREjEt",
"oreillons" => "oREj§",
"orémus" => "oRemys",
"orfèvre" => "ORfEvR",
"orfévrée" => "ORfevRe",
"orfèvrerie" => "ORfEvR°Ri",
"orfèvreries" => "ORfEvR°Ri",
"orfèvres" => "ORfEvR",
"orfraie" => "ORfRE",
"organdi" => "ORg@di",
"organdis" => "ORg@di",
"organe" => "ORgan",
"organes" => "ORgan",
"organiciser" => "ORganisize",
"organigramme" => "ORganigRam",
"organique" => "ORganik",
"organiquement" => "ORganik°m@",
"organiques" => "ORganik",
"organisa" => "ORganiza",
"organisai" => "ORganizE",
"organisaient" => "ORganizE",
"organisais" => "ORganizE",
"organisait" => "ORganizE",
"organisâmes" => "ORganizam",
"organisant" => "ORganiz@",
"organisât" => "ORganiza",
"organisateur" => "ORganizat9R",
"organisateurs" => "ORganizat9R",
"organisation" => "ORganizasj§",
"organisationnelle" => "ORganizasjOnEl",
"organisations" => "ORganizasj§",
"organisatrice" => "ORganizatRis",
"organise" => "ORganiz",
"organisé" => "ORganize",
"organisée" => "ORganize",
"organisées" => "ORganize",
"organisent" => "ORganiz",
"organiser" => "ORganize",
"organisera" => "ORganiz°Ra",
"organiserai" => "ORganiz°RE",
"organiserais" => "ORganiz°RE",
"organiserait" => "ORganiz°RE",
"organisèrent" => "ORganizER",
"organiserez" => "ORganiz°Re",
"organiseriez" => "ORganiz°Rje",
"organiserons" => "ORganiz°R§",
"organiseront" => "ORganiz°R§",
"organises" => "ORganiz",
"organisés" => "ORganize",
"organiseur" => "ORganiz9R",
"organisez" => "ORganize",
"organisiez" => "ORganizje",
"organisions" => "ORganizj§",
"organisme" => "ORganizm",
"organismes" => "ORganizm",
"organisons" => "ORganiz§",
"organiste" => "ORganist",
"organistes" => "ORganist",
"organistique" => "ORganistik",
"organométallique" => "ORganometalik",
"organon" => "ORgan§",
"orgasme" => "ORgasm",
"orgasmes" => "ORgasm",
"orgasmique" => "ORgasmik",
"orgastique" => "ORgastik",
"orge" => "ORZ",
"orgeat" => "ORZa",
"orgelet" => "ORZ°lE",
"orgelets" => "ORZ°lE",
"orges" => "ORZ",
"orgiaque" => "ORZjak",
"orgiastique" => "ORZjastik",
"orgiastiques" => "ORZjastik",
"orgie" => "ORZi",
"orgies" => "ORZi",
"orgue" => "ORg",
"orgueil" => "ORg9j",
"orgueilleuse" => "ORg9j2z",
"orgueilleusement" => "ORg9j2z°m@",
"orgueilleuses" => "ORg9j2z",
"orgueilleux" => "ORg9j2",
"orgueils" => "ORg9j",
"orgues" => "ORg",
"oribus" => "oRibys",
"orient" => "oRj@",
"orienta" => "oRj@ta",
"orientable" => "oRj@tabl",
"orientai" => "oRj@tE",
"orientaient" => "oRj@tE",
"orientais" => "oRj@tE",
"orientait" => "oRj@tE",
"oriental" => "oRj@tal",
"orientale" => "oRj@tal",
"orientales" => "oRj@tal",
"orientalisme" => "oRj@talizm",
"orientaliste" => "oRj@talist",
"orientalistes" => "oRj@talist",
"orientant" => "oRj@t@",
"orientateurs" => "oRj@tat9R",
"orientation" => "oRj@tasj§",
"orientations" => "oRj@tasj§",
"orientaux" => "oRj@to",
"oriente" => "oRj@t",
"orienté" => "oRj@te",
"orientée" => "oRj@te",
"orientées" => "oRj@te",
"orientent" => "oRj@t",
"orienter" => "oRj@te",
"orienterai" => "oRj@t°RE",
"orienterait" => "oRj@t°RE",
"orientèrent" => "oRj@tER",
"orienterez" => "oRj@t°Re",
"orientés" => "oRj@te",
"orienteur" => "oRj@t9R",
"orienteurs" => "oRj@t9R",
"orienteuse" => "oRj@t2z",
"orientez" => "oRj@te",
"orients" => "oRj@",
"orifice" => "oRifis",
"orifices" => "oRifis",
"oriflamme" => "oRiflam",
"oriflammes" => "oRiflam",
"origami" => "oRigami",
"origan" => "oRig@",
"originaire" => "oRiZinER",
"originairement" => "oRiZinER°m@",
"originaires" => "oRiZinER",
"original" => "oRiZinal",
"originale" => "oRiZinal",
"originalement" => "oRiZinal°m@",
"originales" => "oRiZinal",
"originalité" => "oRiZinalite",
"originalités" => "oRiZinalite",
"originaux" => "oRiZino",
"origine" => "oRiZin",
"originel" => "oRiZinEl",
"originelle" => "oRiZinEl",
"originellement" => "oRiZinEl°m@",
"originelles" => "oRiZinEl",
"originels" => "oRiZinEl",
"origines" => "oRiZin",
"orignal" => "oRiNal",
"orignaux" => "oRiNo",
"orillon" => "oRij§",
"orillons" => "oRij§",
"orin" => "oR5",
"oriol" => "ORjOl",
"oripeaux" => "oRipo",
"orléanais" => "ORleanE",
"orléanaise" => "ORleanEz",
"orléanaises" => "ORleanEz",
"orléanisme" => "ORleanizm",
"orléaniste" => "ORleanist",
"orléanistes" => "ORleanist",
"orlon" => "ORl§",
"orme" => "ORm",
"ormeau" => "ORmo",
"ormeaux" => "ORmo",
"ormes" => "ORm",
"orna" => "ORna",
"ornaient" => "ORnE",
"ornait" => "ORnE",
"ornant" => "ORn@",
"ornât" => "ORna",
"orne" => "ORn",
"orné" => "ORne",
"ornée" => "ORne",
"ornées" => "ORne",
"ornement" => "ORn°m@",
"ornemental" => "ORn°m@tal",
"ornementale" => "ORn°m@tal",
"ornementales" => "ORn°m@tal",
"ornementation" => "ORn°m@tasj§",
"ornementations" => "ORn°m@tasj§",
"ornementé" => "ORn°m@te",
"ornementée" => "ORn°m@te",
"ornementer" => "ORn°m@te",
"ornementés" => "ORn°m@te",
"ornements" => "ORn°m@",
"ornent" => "ORn",
"orner" => "ORne",
"ornera" => "ORn°Ra",
"ornerait" => "ORn°RE",
"ornèrent" => "ORnER",
"orneront" => "ORn°R§",
"ornés" => "ORne",
"ornez" => "ORne",
"ornière" => "ORnjER",
"ornières" => "ORnjER",
"ornithologie" => "ORnitoloZi",
"ornithologique" => "ORnitoloZik",
"ornithologue" => "ORnitolOg",
"ornithologues" => "ORnitolOg",
"ornithoptère" => "ORnitOptER",
"ornithorynque" => "ORnitoR5k",
"ornithorynques" => "ORnitoR5k",
"orographie" => "OROgRafi",
"oronge" => "oR§Z",
"oronges" => "oR§Z",
"oropharynx" => "ORofaR5ks",
"orpailleur" => "ORpaj9R",
"orpailleurs" => "ORpaj9R",
"orphée" => "ORfe",
"orphelin" => "ORf°l5",
"orphelinat" => "ORf°lina",
"orphelinats" => "ORf°lina",
"orpheline" => "ORf°lin",
"orphelines" => "ORf°lin",
"orphelins" => "ORf°l5",
"orphéon" => "ORfe§",
"orphéoniste" => "ORfeonist",
"orphéonistes" => "ORfeonist",
"orphéons" => "ORfe§",
"orphie" => "ORfi",
"orphique" => "ORfik",
"orphiques" => "ORfik",
"orphisme" => "ORfizm",
"orpiment" => "ORpim@",
"orpin" => "ORp5",
"orque" => "ORk",
"orques" => "ORk",
"ors" => "OR",
"orsec" => "ORsEk",
"ort" => "OR",
"ortédrine" => "ORtedRin",
"orteil" => "ORtEj",
"orteils" => "ORtEj",
"ortho" => "ORto",
"orthodontie" => "ORtod§si",
"orthodontique" => "ORtod§tik",
"orthodontiste" => "ORtod§tist",
"orthodontistes" => "ORtod§tist",
"orthodoxe" => "ORtodOks",
"orthodoxes" => "ORtodOks",
"orthodoxie" => "ORtodOksi",
"orthogonal" => "ORtOgOnal",
"orthogonaux" => "ORtogono",
"orthographe" => "ORtogRaf",
"orthographiait" => "ORtogRafjE",
"orthographie" => "ORtogRafi",
"orthographié" => "ORtogRafje",
"orthographiées" => "ORtogRafje",
"orthographier" => "ORtogRafje",
"orthographique" => "ORtogRafik",
"orthographiques" => "ORtogRafik",
"orthopédie" => "ORtopedi",
"orthopédique" => "ORtopedik",
"orthopédiques" => "ORtopedik",
"orthopédiste" => "ORtopedist",
"orthophonie" => "ORtofoni",
"orthophoniste" => "ORtofonist",
"orthophonistes" => "ORtofonist",
"orthoptère" => "ORtOptER",
"orthoptères" => "ORtoptER",
"orthostatique" => "ORtostatik",
"ortie" => "ORti",
"orties" => "ORti",
"ortolan" => "ORtol@",
"ortolans" => "ORtol@",
"orvet" => "ORvE",
"oryctérope" => "oRikteROp",
"oryx" => "oRiks",
"os" => "Os",
"osa" => "oza",
"osai" => "ozE",
"osaient" => "ozE",
"osais" => "ozE",
"osait" => "ozE",
"osâmes" => "ozam",
"osant" => "oz@",
"osât" => "oza",
"oscar" => "OskaR",
"oscars" => "OskaR",
"oscilla" => "osija",
"oscillai" => "osijE",
"oscillaient" => "osijE",
"oscillais" => "osijE",
"oscillait" => "osijE",
"oscillant" => "osij@",
"oscillante" => "osij@t",
"oscillants" => "osij@",
"oscillateur" => "osijat9R",
"oscillation" => "osijasj§",
"oscillations" => "osijasj§",
"oscillatoire" => "osijatwaR",
"oscillatoires" => "osijatwaR",
"oscille" => "osij",
"oscillé" => "osije",
"oscillent" => "osij",
"osciller" => "osije",
"oscillèrent" => "osijER",
"oscillez" => "osije",
"oscillographe" => "osijogRaf",
"oscillomètre" => "osijomEtR",
"oscilloscope" => "osijoskOp",
"ose" => "oz",
"osé" => "oze",
"osée" => "oze",
"osées" => "oze",
"oseille" => "ozEj",
"oseilles" => "ozEj",
"osent" => "oz",
"oser" => "oze",
"osera" => "oz°Ra",
"oserai" => "oz°RE",
"oseraie" => "oz°Re",
"oseraient" => "oz°RE",
"oseraies" => "oz°RE",
"oserais" => "oz°RE",
"oserait" => "oz°RE",
"oseras" => "oz°Ra",
"osèrent" => "ozER",
"oserez" => "oz°Re",
"oseriez" => "oz°Rje",
"oserions" => "oz°Rj§",
"oserons" => "oz°R§",
"oseront" => "oz°R§",
"oses" => "oz",
"osés" => "oze",
"osez" => "oze",
"osier" => "ozje",
"osiers" => "ozje",
"osiez" => "ozje",
"osions" => "ozj§",
"osmium" => "OsmjOm",
"osmonde" => "Osm§d",
"osmose" => "Osmoz",
"osmoses" => "Osmoz",
"osons" => "oz§",
"ossature" => "osatyR",
"ossatures" => "osatyR",
"osselet" => "Os°lE",
"osselets" => "Os°lE",
"ossement" => "Os°m@",
"ossements" => "Os°m@",
"osseuse" => "os2z",
"osseuses" => "os2z",
"osseux" => "os2",
"ossification" => "osifikasj§",
"ossifié" => "osifje",
"osso buco" => "osobuko",
"ossuaire" => "os8ER",
"ossuaires" => "os8ER",
"ossue" => "osy",
"ost" => "Ost",
"ostensible" => "Ost@sibl",
"ostensiblement" => "Ost@sibl°m@",
"ostensoir" => "Ost@swaR",
"ostensoirs" => "Ost@swaR",
"ostentation" => "Ost@tasj§",
"ostentatoire" => "Ost@tatwaR",
"ostentatoirement" => "Ost@tatwaR°m@",
"ostéoarthrite" => "OsteoaRtRit",
"ostéogenèse" => "OsteoZ°nEz",
"ostéogéniques" => "OsteoZenik",
"ostéologique" => "OsteOlOZik",
"ostéomyélite" => "Osteomjelit",
"ostéopathe" => "Osteopat",
"ostéopathes" => "Osteopat",
"ostéopathie" => "Osteopati",
"ostéoporose" => "OsteopoRoz",
"ostéosarcome" => "OsteosaRkom",
"ostéotomie" => "OsteotOmi",
"ostinato" => "Ostinato",
"ostracisme" => "OstRasizm",
"ostréiculteur" => "OstReikylt9R",
"ostréiculteurs" => "OstReikylt9R",
"ostréiculture" => "OstReikyltyR",
"ostrogoth" => "OstRogo",
"ostrogoths" => "OstRogo",
"ôta" => "ota",
"otage" => "otaZ",
"otages" => "otaZ",
"ôtai" => "otE",
"ôtaient" => "otE",
"ôtais" => "otE",
"ôtait" => "otE",
"otalgie" => "OtalZi",
"ôtant" => "ot@",
"otarie" => "otaRi",
"otaries" => "otaRi",
"ôtât" => "ota",
"ôte" => "ot",
"ôté" => "ote",
"ôtée" => "ote",
"ôtées" => "ote",
"ôtent" => "ot",
"ôter" => "ote",
"ôtera" => "ot°Ra",
"ôterai" => "ot°RE",
"ôterais" => "ot°RE",
"ôterait" => "ot°RE",
"ôteras" => "ot°Ra",
"ôtèrent" => "otER",
"ôterez" => "ot°Re",
"ôterions" => "ot°Rj§",
"ôtes" => "ot",
"ôtés" => "ote",
"ôtez" => "ote",
"ôtiez" => "otje",
"otite" => "otit",
"otites" => "otit",
"oto rhino" => "otoRino",
"oto-rhino" => "otoRino",
"oto-rhino-laryngologique" => "otoRinolaR5gOlOZik",
"oto-rhino-laryngologiste" => "otoRinolaR5goloZist",
"oto-rhinos" => "otoRino",
"ôtons" => "ot§",
"otoscope" => "OtOskOp",
"otospongiose" => "Otosp§Zjoz",
"ottoman" => "otom@",
"ottomane" => "otoman",
"ottomanes" => "otoman",
"ottomans" => "otom@",
"ou" => "u",
"où" => "u",
"ouah" => "wa",
"ouaille" => "waj",
"ouailles" => "waj",
"ouais" => "wE",
"ouananiche" => "wananiS",
"ouananiches" => "wananiS",
"ouaouaron" => "wawaR§",
"ouata" => "wata",
"ouatant" => "wat@",
"ouate" => "wat",
"ouaté" => "wate",
"ouatée" => "wate",
"ouatées" => "wate",
"ouates" => "wat",
"ouatés" => "wate",
"ouateuse" => "wat2z",
"ouateux" => "wat2",
"ouatiné" => "watine",
"ouatinée" => "watine",
"ouatinées" => "watine",
"ouatiner" => "watine",
"oubli" => "ubli",
"oublia" => "ublija",
"oubliable" => "ublijabl",
"oubliai" => "ublijE",
"oubliaient" => "ublijE",
"oubliais" => "ublijE",
"oubliait" => "ublijE",
"oubliâmes" => "ublijam",
"oubliant" => "ublij@",
"oublias" => "ublija",
"oubliasse" => "ublijas",
"oubliât" => "ublija",
"oublie" => "ubli",
"oublié" => "ublije",
"oubliée" => "ublije",
"oubliées" => "ublije",
"oublient" => "ubli",
"oublier" => "ublije",
"oubliera" => "ubliRa",
"oublierai" => "ubliRE",
"oublieraient" => "ubliRE",
"oublierais" => "ubliRE",
"oublierait" => "ubliRE",
"oublieras" => "ubliRa",
"oublièrent" => "ublijER",
"oublierez" => "ubliRe",
"oublierions" => "ubliRj§",
"oublierons" => "ubliR§",
"oublieront" => "ubliR§",
"oublies" => "ubli",
"oubliés" => "ublije",
"oubliette" => "ublijEt",
"oubliettes" => "ublijEt",
"oublieuse" => "ublij2z",
"oublieuses" => "ublij2z",
"oublieux" => "ublij2",
"oubliez" => "ublije",
"oubliiez" => "ublije",
"oubliions" => "ublij§",
"oublions" => "ublij§",
"oublis" => "ubli",
"ouche" => "uS",
"oued" => "wEd",
"oueds" => "wEd",
"ouest" => "wEst",
"ouest-allemand" => "wEstal°m@",
"ouf" => "uf",
"ougandais" => "ug@dE",
"ougandaise" => "ug@dEz",
"ouh" => "u",
"oui" => "wi",
"ouï" => "wi",
"oui-da" => "wida",
"ouï-dire" => "widiR",
"ouiche" => "wiS",
"ouïe" => "wi",
"ouïes" => "wi",
"ouighour" => "uiguR",
"ouighours" => "uiguR",
"ouïgour" => "uiguR",
"ouille" => "uj",
"ouïr" => "wiR",
"ouïrais" => "uiRE",
"ouïs" => "wi",
"ouistiti" => "wistiti",
"ouistitis" => "wistiti",
"ouït" => "wi",
"oukases" => "ukaz",
"ouléma" => "ulema",
"oulémas" => "ulema",
"ounce" => "awns",
"ouragan" => "uRag@",
"ouragans" => "uRag@",
"ouralienne" => "uRaljEn",
"ouraniennes" => "uRanjEn",
"ourdi" => "uRdi",
"ourdie" => "uRdi",
"ourdies" => "uRdi",
"ourdir" => "uRdiR",
"ourdira" => "uRdiRa",
"ourdis" => "uRdi",
"ourdissage" => "uRdisaZ",
"ourdissait" => "uRdisE",
"ourdissant" => "uRdis@",
"ourdissent" => "uRdis",
"ourdisseur" => "uRdis9R",
"ourdisseurs" => "uRdis9R",
"ourdisseuses" => "uRdis2z",
"ourdissoir" => "uRdiswaR",
"ourdit" => "uRdi",
"ourdou" => "uRdu",
"ourlaient" => "uRlE",
"ourlait" => "uRlE",
"ourlant" => "uRl@",
"ourle" => "uRl",
"ourlé" => "uRle",
"ourlée" => "uRle",
"ourlées" => "uRle",
"ourlent" => "uRl",
"ourler" => "uRle",
"ourlés" => "uRle",
"ourlet" => "uRlE",
"ourlets" => "uRlE",
"ouroboros" => "uRoboROs",
"ours" => "uRs",
"ourse" => "uRs",
"ourses" => "uRs",
"oursin" => "uRs5",
"oursins" => "uRs5",
"ourson" => "uRs§",
"oursonne" => "uRsOn",
"oursonnes" => "uRsOn",
"oursons" => "uRs§",
"ousque" => "usk",
"oust" => "ust",
"oustachi" => "ustaSi",
"oustachis" => "ustaSi",
"ouste" => "ust",
"out" => "awt",
"outarde" => "utaRd",
"outardes" => "utaRd",
"outil" => "uti",
"outillage" => "utijaZ",
"outillages" => "utijaZ",
"outillé" => "utije",
"outillée" => "utije",
"outillées" => "utije",
"outiller" => "utije",
"outillés" => "utije",
"outilleur" => "utij9R",
"outils" => "uti",
"outlaw" => "awtlo",
"outlaws" => "awtlo",
"outrage" => "utRaZ",
"outragé" => "utRaZe",
"outrageant" => "utRaZ@",
"outrageante" => "utRaZ@t",
"outrageantes" => "utRaZ@t",
"outrageants" => "utRaZ@",
"outragée" => "utRaZe",
"outragées" => "utRaZe",
"outragent" => "utRaZ",
"outrager" => "utRaZe",
"outragerais" => "utRaZ°RE",
"outragèrent" => "utRaZER",
"outrages" => "utRaZ",
"outragés" => "utRaZe",
"outrageuse" => "utRaZ2z",
"outrageusement" => "utRaZ2z°m@",
"outrageuses" => "utRaZ2z",
"outrageux" => "utRaZ2",
"outragez" => "utRaZe",
"outrait" => "utRE",
"outrance" => "utR@s",
"outrances" => "utR@s",
"outrancier" => "utR@sje",
"outrancière" => "utR@sjER",
"outrancières" => "utR@sjER",
"outrant" => "utR@",
"outre" => "utR",
"outré" => "utRe",
"outre-atlantique" => "utRatl@tik",
"outre-manche" => "utR°m@S",
"outre-mer" => "utR°mER",
"outre-rhin" => "utR°R5",
"outre-tombe" => "utR°t§b",
"outrecuidance" => "utR°k8id@s",
"outrecuidant" => "utR°k8id@",
"outrecuidante" => "utR°k8id@t",
"outrecuidantes" => "utR°k8id@t",
"outrecuidants" => "utR°k8id@",
"outrée" => "utRe",
"outrées" => "utRe",
"outremer" => "utR°mER",
"outrepassa" => "utR°pasa",
"outrepassaient" => "utR°pasE",
"outrepassait" => "utR°pasE",
"outrepassant" => "utR2pas@",
"outrepasse" => "utR°pas",
"outrepassé" => "utR°pase",
"outrepassent" => "utR°pas",
"outrepasser" => "utR°pase",
"outrepasserai" => "utR°pas°RE",
"outrepasses" => "utR°pas",
"outrepassez" => "utR°pase",
"outrer" => "utRe",
"outres" => "utR",
"outrés" => "utRe",
"outrigger" => "awtRig9R",
"outsider" => "awtsajd9R",
"outsiders" => "awtsajd9R",
"ouvert" => "uvER",
"ouverte" => "uvERt",
"ouvertement" => "uvERt°m@",
"ouvertes" => "uvERt",
"ouverts" => "uvER",
"ouverture" => "uvERtyR",
"ouvertures" => "uvERtyR",
"ouvrable" => "uvRabl",
"ouvrables" => "uvRabl",
"ouvrage" => "uvRaZ",
"ouvragé" => "uvRaZe",
"ouvrageant" => "uvRaZ@",
"ouvragée" => "uvRaZe",
"ouvragées" => "uvRaZe",
"ouvrager" => "uvRaZe",
"ouvrages" => "uvRaZ",
"ouvragés" => "uvRaZe",
"ouvraient" => "uvRE",
"ouvrais" => "uvRE",
"ouvrait" => "uvRE",
"ouvrant" => "uvR@",
"ouvrants" => "uvR@",
"ouvre" => "uvR",
"ouvré" => "uvRe",
"ouvre-boîte" => "uvR°bwat",
"ouvre-boîtes" => "uvR°bwat",
"ouvre-bouteille" => "uvR°butEj",
"ouvre-bouteilles" => "uvR°butEj",
"ouvrées" => "uvRe",
"ouvrent" => "uvR",
"ouvrer" => "uvRe",
"ouvres" => "uvR",
"ouvrés" => "uvRe",
"ouvreur" => "uvR9R",
"ouvreurs" => "uvR9R",
"ouvreuse" => "uvR2z",
"ouvreuses" => "uvR2z",
"ouvrez" => "uvRe",
"ouvrier" => "uvRije",
"ouvrière" => "uvRijER",
"ouvrières" => "uvRijER",
"ouvriérisme" => "uvRijeRizm",
"ouvriériste" => "uvRijeRist",
"ouvriers" => "uvRije",
"ouvriez" => "uvRie",
"ouvrîmes" => "uvRim",
"ouvrions" => "uvRij§",
"ouvrir" => "uvRiR",
"ouvrira" => "uvRiRa",
"ouvrirai" => "uvRiRE",
"ouvriraient" => "uvRiRE",
"ouvrirais" => "uvRiRE",
"ouvrirait" => "uvRiRE",
"ouvriras" => "uvRiRa",
"ouvrirent" => "uvRiR",
"ouvrirez" => "uvRiRe",
"ouvririez" => "uvRiRje",
"ouvririons" => "uvRiRj§",
"ouvrirons" => "uvRiR§",
"ouvriront" => "uvRiR§",
"ouvris" => "uvRi",
"ouvrissent" => "uvRis",
"ouvrit" => "uvRi",
"ouvrît" => "uvRi",
"ouvroir" => "uvRwaR",
"ouvroirs" => "uvRwaR",
"ouvrons" => "uvR§",
"ouzbeks" => "uzbEk",
"ouzo" => "uzo",
"ouzos" => "uzo",
"ovaire" => "ovER",
"ovaires" => "ovER",
"ovalaire" => "ovalER",
"ovale" => "oval",
"ovales" => "oval",
"ovalisées" => "ovalize",
"ovariectomie" => "OvaRjEktOmi",
"ovarien" => "OvaRj5",
"ovarienne" => "ovaRjEn",
"ovariotomie" => "ovaRjotomi",
"ovation" => "ovasj§",
"ovationnaient" => "ovasjonE",
"ovationné" => "ovasjone",
"ovationner" => "ovasjone",
"ovationnés" => "ovasjone",
"ovations" => "ovasj§",
"ove" => "Ov",
"ovée" => "Ove",
"overdose" => "Ov9Rdoz",
"overdoses" => "Ov9Rdoz",
"overdrive" => "Ov9RdRajv",
"ovibos" => "ovibOs",
"ovin" => "Ov5",
"ovins" => "ov5",
"ovipare" => "OvipaR",
"ovipares" => "OvipaR",
"ovni" => "Ovni",
"ovnis" => "Ovni",
"ovocyte" => "ovosit",
"ovocytes" => "ovosit",
"ovoïdal" => "ovoidal",
"ovoïdale" => "OvOidal",
"ovoïde" => "ovoid",
"ovoïdes" => "ovoid",
"ovulaire" => "OvylER",
"ovulation" => "ovylasj§",
"ovule" => "ovyl",
"ovuler" => "ovyle",
"ovules" => "ovyl",
"oxalate" => "Oksalat",
"oxer" => "Okse",
"oxfordien" => "OksfORdj5",
"oxfordiennes" => "OksfORdjEn",
"oxfords" => "OksfORd",
"oxhydrique" => "OksidRik",
"oxo" => "Okso",
"oxonienne" => "OksonjEn",
"oxychlorure" => "OksiklORyR",
"oxydant" => "Oksid@",
"oxydants" => "Oksid@",
"oxydation" => "Oksidasj§",
"oxyde" => "Oksid",
"oxydé" => "Okside",
"oxydée" => "Okside",
"oxydées" => "Okside",
"oxyder" => "Okside",
"oxydes" => "Oksid",
"oxygénation" => "OksiZenasj§",
"oxygène" => "OksiZEn",
"oxygéné" => "OksiZene",
"oxygénée" => "OksiZene",
"oxygénées" => "OksiZene",
"oxygènent" => "OksiZEn",
"oxygéner" => "OksiZene",
"oxygénés" => "OksiZene",
"oxymétrie" => "OksimetRi",
"oxymore" => "OksimOR",
"oxymores" => "OksimOR",
"oxymoron" => "OksimoR§",
"oyant" => "waj@",
"oyat" => "oja",
"oyats" => "oja",
"oye" => "wa",
"oyez" => "waje",
"oyons" => "waj§",
"ozone" => "ozon",
"p." => "pe",
"p.m." => "peEm",
"pa" => "pa",
"pacage" => "pakaZ",
"pacages" => "pakaZ",
"pacas" => "paka",
"pacemaker" => "pEs°mEk9R",
"pacemakers" => "pEs°mEk9R",
"pacha" => "paSa",
"pachas" => "paSa",
"pachinko" => "patSinko",
"pachon" => "paS§",
"pachyderme" => "paSidERm",
"pachydermes" => "paSidERm",
"pachydermique" => "paSidERmik",
"pachydermiques" => "paSidERmik",
"pacifiait" => "pasifjE",
"pacifiant" => "pasifj@",
"pacifiante" => "pasifj@t",
"pacifiantes" => "pasifj@t",
"pacificateur" => "pasifikat9R",
"pacificateurs" => "pasifikat9R",
"pacification" => "pasifikasj§",
"pacificatrice" => "pasifikatRis",
"pacifie" => "pasifi",
"pacifié" => "pasifje",
"pacifiée" => "pasifje",
"pacifiées" => "pasifje",
"pacifier" => "pasifje",
"pacifiés" => "pasifje",
"pacifique" => "pasifik",
"pacifiquement" => "pasifik°m@",
"pacifiques" => "pasifik",
"pacifisme" => "pasifizm",
"pacifiste" => "pasifist",
"pacifistes" => "pasifist",
"pack" => "pak",
"package" => "pakaZ",
"packaging" => "pakaZiG",
"packs" => "pak",
"packson" => "paks§",
"pacotille" => "pakotij",
"pacotilles" => "pakotij",
"pacs" => "paks",
"pacsés" => "pakze",
"pacsif" => "pakif",
"pacsifs" => "pakif",
"pacson" => "paks§",
"pacsons" => "paks§",
"pacte" => "pakt",
"pactes" => "pakt",
"pactisaient" => "paktizE",
"pactisait" => "paktizE",
"pactisant" => "paktiz@",
"pactise" => "paktiz",
"pactisé" => "paktize",
"pactiser" => "paktize",
"pactiseras" => "paktiz°Ra",
"pactiseurs" => "paktiz9R",
"pactisez" => "paktize",
"pactisions" => "paktizj§",
"pactole" => "paktOl",
"pactoles" => "paktOl",
"pad" => "pad",
"paddock" => "padOk",
"paddocker" => "padok9R",
"paddocks" => "padOk",
"paddy" => "padi",
"padouanes" => "padwan",
"paella" => "paela",
"paellas" => "paela",
"paf" => "paf",
"pagaie" => "pagE",
"pagaïe" => "pagaj",
"pagaient" => "pagE",
"pagaiera" => "pagERa",
"pagaies" => "pagE",
"pagaille" => "pagaj",
"pagailles" => "pagaj",
"pagailleux" => "pagaj2",
"paganisme" => "paganizm",
"pagaya" => "pageja",
"pagayait" => "pagejE",
"pagayant" => "pagej@",
"pagaye" => "pagaj",
"pagayé" => "pageje",
"pagayer" => "pageje",
"pagayèrent" => "pagejER",
"pagayeur" => "pagEj9R",
"pagayeurs" => "pagEj9R",
"pagayez" => "pagEje",
"page" => "paZ",
"pagé" => "paZe",
"pageais" => "paZE",
"pageait" => "paZE",
"pageant" => "paZ@",
"pagée" => "paZe",
"pagels" => "paZEl",
"pageot" => "paZo",
"pageots" => "paZo",
"pager" => "paZe",
"pages" => "paZ",
"pagés" => "paZe",
"pagination" => "paZinasj§",
"paginer" => "paZine",
"pagne" => "paN",
"pagnes" => "paN",
"pagnon" => "paN§",
"pagnote" => "paNOt",
"pagnoter" => "paNote",
"pagode" => "pagOd",
"pagodes" => "pagOd",
"pagodon" => "pagod§",
"pagure" => "pagyR",
"pagures" => "pagyR",
"pagus" => "pagys",
"paie" => "pE",
"paiement" => "pEm@",
"paiements" => "pEm@",
"païen" => "paj5",
"païenne" => "pajEn",
"païennes" => "pajEn",
"païens" => "paj5",
"paient" => "pE",
"paiera" => "pERa",
"paierai" => "pERE",
"paieraient" => "pERE",
"paierais" => "pERE",
"paierait" => "pERE",
"paieras" => "pERa",
"paierez" => "pERe",
"paierie" => "peRi",
"paieriez" => "pERje",
"paierions" => "pERj§",
"paierons" => "pER§",
"paieront" => "pER§",
"paies" => "pE",
"paillard" => "pajaR",
"paillardait" => "pajaRdE",
"paillarde" => "pajaRd",
"paillardement" => "pajaRd2m@",
"paillardes" => "pajaRd",
"paillardise" => "pajaRdiz",
"paillards" => "pajaR",
"paillasse" => "pajas",
"paillasses" => "pajas",
"paillasson" => "pajas§",
"paillassons" => "pajas§",
"paille" => "paj",
"paillé" => "paje",
"paillée" => "paje",
"paillées" => "paje",
"pailler" => "paje",
"pailles" => "paj",
"pailleté" => "paj°te",
"pailletée" => "paj°te",
"pailletées" => "paj°te",
"pailleter" => "paj°te",
"pailletés" => "paj°te",
"paillette" => "pajEt",
"paillettes" => "pajEt",
"pailleux" => "paj2",
"paillis" => "paji",
"paillon" => "paj§",
"paillons" => "paj§",
"paillot" => "pajo",
"paillote" => "pajOt",
"paillotes" => "pajOt",
"paillu" => "pajy",
"paimpolaise" => "p5polEz",
"paimpolaises" => "p5polEz",
"pain" => "p5",
"pains" => "p5",
"pair" => "pER",
"paire" => "pER",
"paires" => "pER",
"pairesses" => "pEREs",
"pairie" => "peRi",
"pairs" => "pER",
"pais" => "pE",
"paisible" => "pezibl",
"paisiblement" => "pezibl°m@",
"paisibles" => "pezibl",
"paissaient" => "pEsE",
"paissait" => "pEsE",
"paissant" => "pEs@",
"paissent" => "pEs",
"paît" => "pE",
"paître" => "pEtR",
"paîtront" => "pEtR§",
"paiute" => "pEiyt",
"paiutes" => "pEiyt",
"paix" => "pE",
"pakistanais" => "pakistanE",
"pakistanaise" => "pakistanEz",
"pakistanaises" => "pakistanEz",
"pakistano" => "pakistano",
"pal" => "pal",
"palabra" => "palabRa",
"palabraient" => "palabRE",
"palabrait" => "palabRE",
"palabrant" => "palabR@",
"palabre" => "palabR",
"palabré" => "palabRe",
"palabrent" => "palabR",
"palabrer" => "palabRe",
"palabres" => "palabR",
"palabreur" => "palabR9R",
"palabreurs" => "palabR9R",
"palace" => "palas",
"palaces" => "palas",
"paladin" => "palad5",
"paladins" => "palad5",
"palais" => "palE",
"palan" => "pal@",
"palanche" => "pal@S",
"palanches" => "pal@S",
"palangrotte" => "pal@gROt",
"palanquée" => "pal@ke",
"palanquées" => "pal@ke",
"palanquer" => "pal@ke",
"palanquin" => "pal@k5",
"palanquins" => "pal@k5",
"palans" => "pal@",
"palastre" => "palastR",
"palatales" => "palatal",
"palatin" => "palat5",
"palatine" => "palatin",
"palatines" => "palatin",
"palatisation" => "palatizasj§",
"palazzo" => "paladzo",
"pale" => "pal",
"pâle" => "pal",
"palé" => "pale",
"palefrenier" => "pal°fR°nje",
"palefrenière" => "pal°fR2njER",
"palefreniers" => "pal°fR°nje",
"palefroi" => "pal°fRwa",
"palefrois" => "pal°fRwa",
"pâlement" => "palem@",
"paléo" => "paleo",
"paléographie" => "paleogRafi",
"paléolithique" => "paleolitik",
"paléolithiques" => "paleolitik",
"paléontologie" => "pale§toloZi",
"paléontologiques" => "pale§toloZik",
"paléontologiste" => "pale§toloZist",
"paléontologistes" => "pale§toloZist",
"paléontologue" => "pale§tolOg",
"paléontologues" => "pale§tolOg",
"paléozoïque" => "paleozoik",
"paleron" => "pal°R§",
"pales" => "pal",
"pâles" => "pal",
"palestinien" => "palEstinj5",
"palestinienne" => "palEstinjEn",
"palestiniens" => "palEstinj5",
"palestre" => "palEstR",
"palestres" => "palEstR",
"palet" => "palE",
"paletot" => "pal°to",
"paletots" => "pal°to",
"palets" => "palE",
"palette" => "palEt",
"palettes" => "palEt",
"palétuvier" => "paletyvje",
"palétuviers" => "paletyvje",
"pâleur" => "pal9R",
"pâleurs" => "pal9R",
"pâli" => "pali",
"pâlichon" => "paliS§",
"pâlichonne" => "paliSOn",
"pâlichons" => "paliS§",
"pâlie" => "pali",
"palier" => "palje",
"palière" => "paljER",
"paliers" => "palje",
"pâlies" => "pali",
"palikare" => "palikaR",
"palikares" => "palikaR",
"palilalie" => "palilali",
"palimpseste" => "pal5psEst",
"palindrome" => "pal5dRom",
"palindromes" => "pal5dRom",
"palinodie" => "palinodi",
"palinodier" => "palinOdje",
"palinodies" => "palinodi",
"pâlir" => "paliR",
"pâlirait" => "paliRE",
"pâlirent" => "paliR",
"palis" => "pali",
"pâlis" => "pali",
"palissade" => "palisad",
"palissadé" => "palisade",
"palissadée" => "palisade",
"palissades" => "palisad",
"palissadés" => "palisade",
"pâlissaient" => "palisE",
"pâlissait" => "palisE",
"palissandre" => "palis@dR",
"palissant" => "palis@",
"pâlissant" => "palis@",
"pâlissante" => "palis@t",
"pâlissantes" => "palis@t",
"pâlissent" => "palis",
"pâlissions" => "palisj§",
"palissonnage" => "palisOnaZ",
"pâlit" => "pali",
"palladiennes" => "paladjEn",
"palladium" => "paladjOm",
"palle" => "pal2",
"palliait" => "paljE",
"palliatif" => "paljatif",
"palliatifs" => "paljatif",
"pallié" => "palje",
"pallient" => "pali",
"pallier" => "palje",
"palliera" => "paliRa",
"palma-christi" => "palmakRisti",
"palmaient" => "palmE",
"palmaire" => "palmER",
"palmarès" => "palmaREs",
"palmas" => "palma",
"palme" => "palm",
"palmé" => "palme",
"palmée" => "palme",
"palmées" => "palme",
"palmer" => "palmER",
"palmeraie" => "palm°Re",
"palmeraies" => "palm°RE",
"palmes" => "palm",
"palmés" => "palme",
"palmette" => "palmEt",
"palmettes" => "palmEt",
"palmier" => "palmje",
"palmiers" => "palmje",
"palmipède" => "palmipEd",
"palmipèdes" => "palmipEd",
"palmiste" => "palmist",
"palmistes" => "palmist",
"palmure" => "palmyR",
"palmures" => "palmyR",
"palombe" => "pal§b",
"palombes" => "pal§b",
"palonnier" => "palonje",
"palot" => "palo",
"pâlot" => "palo",
"palots" => "palo",
"pâlots" => "palo",
"pâlotte" => "palOt",
"pâlottes" => "palOt",
"palourde" => "paluRd",
"palourdes" => "paluRd",
"palpa" => "palpa",
"palpable" => "palpabl",
"palpables" => "palpabl",
"palpaient" => "palpE",
"palpais" => "palpE",
"palpait" => "palpE",
"palpant" => "palp@",
"palpation" => "palpasj§",
"palpations" => "palpasj§",
"palpe" => "palp",
"palpé" => "palpe",
"palpées" => "palpe",
"palpent" => "palp",
"palper" => "palpe",
"palpera" => "palp°Ra",
"palperai" => "palp°RE",
"palpèrent" => "palpER",
"palpes" => "palp",
"palpés" => "palpe",
"palpeur" => "palp9R",
"palpeurs" => "palp9R",
"palpez" => "palpe",
"palpita" => "palpita",
"palpitaient" => "palpitE",
"palpitait" => "palpitE",
"palpitant" => "palpit@",
"palpitante" => "palpit@t",
"palpitantes" => "palpit@t",
"palpitants" => "palpit@",
"palpitation" => "palpitasj§",
"palpitations" => "palpitasj§",
"palpite" => "palpit",
"palpité" => "palpite",
"palpitement" => "palpit°m@",
"palpitent" => "palpit",
"palpiter" => "palpite",
"palpiterait" => "palpit°RE",
"palpitèrent" => "palpitER",
"palpites" => "palpit",
"palpons" => "palp§",
"pals" => "pal",
"palsambleu" => "pals@bl2",
"paltoquet" => "paltokE",
"palu" => "paly",
"paluchait" => "palySE",
"paluche" => "palyS",
"palucher" => "palySe",
"paluches" => "palyS",
"paludamentum" => "palydam@tOm",
"paludéenne" => "palydeEn",
"paludéennes" => "palydeEn",
"paludéens" => "palyde5",
"paludes" => "palyd",
"paludière" => "palydjER",
"paludiers" => "palydje",
"paludiques" => "palydik",
"paludisme" => "palydizm",
"palus" => "paly",
"palustre" => "palystR",
"palynologie" => "palinOlOZi",
"pâma" => "pama",
"pâmaient" => "pamE",
"pâmait" => "pamE",
"pâmant" => "pam@",
"pâme" => "pam",
"pâmé" => "pame",
"pâmée" => "pame",
"pâmées" => "pame",
"pâment" => "pam",
"pâmer" => "pame",
"pâmerais" => "pam°RE",
"pâmerait" => "pam°RE",
"pâmèrent" => "pamER",
"pâmeront" => "pam°R§",
"pâmés" => "pame",
"pâmez" => "pame",
"pâmoison" => "pamwaz§",
"pâmoisons" => "pamwaz§",
"pampa" => "p@pa",
"pampas" => "p@pa",
"pampero" => "p@p°Ro",
"pamphlet" => "p@flE",
"pamphlétaire" => "p@fletER",
"pamphlétaires" => "p@fletER",
"pamphlets" => "p@flE",
"pamplemousse" => "p@pl°mus",
"pamplemousses" => "p@pl°mus",
"pamplemoussier" => "p@pl°musje",
"pamplemoussiers" => "p@pl°musje",
"pampre" => "p@pR",
"pampres" => "p@pR",
"pan" => "p@",
"pan bagnat" => "p@baNa",
"pana" => "pana",
"panacée" => "panase",
"panacées" => "panase",
"panachage" => "panaSaZ",
"panachait" => "panaSE",
"panache" => "panaS",
"panaché" => "panaSe",
"panachée" => "panaSe",
"panacher" => "panaSe",
"panaches" => "panaS",
"panachés" => "panaSe",
"panade" => "panad",
"panades" => "panad",
"panais" => "panE",
"panama" => "panama",
"panamas" => "panama",
"panaméen" => "paname5",
"panaméenne" => "panameEn",
"panaméricain" => "panameRik5",
"panaméricaine" => "panameRikEn",
"panamienne" => "panamjEn",
"panamiens" => "panamj5",
"panarabisme" => "panaRabizm",
"panard" => "panaR",
"panards" => "panaR",
"panaris" => "panaRi",
"panatella" => "panatEla",
"panathénaïque" => "panatenaik",
"panathénées" => "panatene",
"pancake" => "p@kEk",
"pancakes" => "p@kEk",
"pancarte" => "p@kaRt",
"pancartes" => "p@kaRt",
"panceltique" => "p@sEltik",
"pancetta" => "p@sEta",
"panclastite" => "p@klastit",
"pancrace" => "p@kRas",
"pancraces" => "p@kRas",
"pancréas" => "p@kReas",
"pancréatectomie" => "p@kReatEktOmi",
"pancréatique" => "p@kReatik",
"pancréatiques" => "p@kReatik",
"pancréatite" => "p@kReatit",
"panda" => "p@da",
"pandanus" => "p@danys",
"pandas" => "p@da",
"pandémie" => "p@demi",
"pandémonium" => "p@demonjOm",
"pandémoniums" => "p@demonjOm",
"pandit" => "p@di",
"pandore" => "p@dOR",
"pandores" => "p@dOR",
"pane" => "pan",
"pané" => "pane",
"panée" => "pane",
"panées" => "pane",
"panégyrique" => "paneZiRik",
"panégyriques" => "paneZiRik",
"panégyristes" => "paneZiRist",
"panel" => "panEl",
"paner" => "pane",
"panés" => "pane",
"panetier" => "pan°tje",
"panetière" => "pan°tjER",
"panetières" => "pan°tjER",
"pangermanisme" => "p@ZERmanizm",
"panic" => "panik",
"panicules" => "panikyl",
"panier" => "panje",
"panier-repas" => "panjeR°pa",
"panière" => "panjER",
"panières" => "panjER",
"paniers" => "panje",
"panification" => "panifikasj§",
"panini" => "panini",
"paniqua" => "panika",
"paniquaient" => "panikE",
"paniquais" => "panikE",
"paniquait" => "panikE",
"paniquant" => "panik@",
"paniquards" => "panikaR",
"panique" => "panik",
"paniqué" => "panike",
"paniquée" => "panike",
"paniquent" => "panik",
"paniquer" => "panike",
"paniquera" => "panik°Ra",
"paniquerai" => "panik°RE",
"paniqueraient" => "panik°RE",
"paniquerais" => "panik°RE",
"paniqueras" => "panik°Ra",
"paniquèrent" => "panikER",
"paniqueront" => "panik°R§",
"paniques" => "panik",
"paniqués" => "panike",
"paniquez" => "panike",
"paniquons" => "panik§",
"panis" => "pani",
"panka" => "p@ka",
"pankas" => "p@ka",
"panna" => "pana",
"pannais" => "panE",
"pannait" => "panE",
"panne" => "pan",
"panné" => "pane",
"panneau" => "pano",
"panneau-réclame" => "panoReklam",
"panneaux" => "pano",
"panner" => "pane",
"pannes" => "pan",
"panneton" => "pan°t§",
"pano" => "pano",
"panonceau" => "pan§so",
"panonceaux" => "pan§so",
"panoplie" => "panopli",
"panoplies" => "panopli",
"panorama" => "panoRama",
"panoramas" => "panoRama",
"panoramique" => "panoRamik",
"panoramiqué" => "panoRamike",
"panoramiquer" => "panoRamike",
"panoramiques" => "panoRamik",
"panos" => "pano",
"panosse" => "panOs",
"panouille" => "panuj",
"panouilles" => "panuj",
"pans" => "p@",
"pansa" => "p@sa",
"pansage" => "p@saZ",
"pansait" => "p@sE",
"pansant" => "p@s@",
"pansas" => "p@sa",
"panse" => "p@s",
"pansé" => "p@se",
"pansée" => "p@se",
"pansées" => "p@se",
"pansement" => "p@s°m@",
"pansements" => "p@s°m@",
"pansent" => "p@s",
"panser" => "p@se",
"panserai" => "p@s°RE",
"pansèrent" => "p@sER",
"panses" => "p@s",
"pansés" => "p@se",
"pansez" => "p@se",
"pansiez" => "p@sje",
"pansions" => "p@sj§",
"panspermie" => "p@spERmi",
"pansu" => "p@sy",
"pansue" => "p@sy",
"pansues" => "p@sy",
"pansus" => "p@sy",
"pantagruélique" => "p@tagRyelik",
"pantagruéliques" => "p@tagRyelik",
"pantalon" => "p@tal§",
"pantalonnade" => "p@talonad",
"pantalonnades" => "p@talonad",
"pantalons" => "p@tal§",
"pante" => "p@t",
"pantela" => "p@t°la",
"pantelaient" => "p@t°lE",
"pantelait" => "p@t°lE",
"pantelant" => "p@t°l@",
"pantelante" => "p@t°l@t",
"pantelantes" => "p@t°l@t",
"pantelants" => "p@t°l@",
"pantelé" => "p@t°le",
"panteler" => "p@t°le",
"pantelle" => "p@tEl",
"pantes" => "p@t",
"panthéisme" => "p@teizm",
"panthéiste" => "p@teist",
"panthéon" => "p@te§",
"panthéons" => "p@te§",
"panthère" => "p@tER",
"panthères" => "p@tER",
"pantière" => "p@tjER",
"pantin" => "p@t5",
"pantins" => "p@t5",
"pantocrator" => "p@tOkRatOR",
"pantographe" => "p@togRaf",
"pantographes" => "p@togRaf",
"pantois" => "p@twa",
"pantoise" => "p@twaz",
"pantoises" => "p@twaz",
"pantomètres" => "p@tomEtR",
"pantomime" => "p@tomim",
"pantomimes" => "p@tomim",
"pantouflard" => "p@tuflaR",
"pantouflarde" => "p@tuflaRd",
"pantouflards" => "p@tuflaR",
"pantoufle" => "p@tufl",
"pantoufler" => "p@tufle",
"pantoufles" => "p@tufl",
"panty" => "p@ti",
"panurge" => "panyRZ",
"panurgisme" => "panyRZizm",
"panzer" => "p@nzER",
"panzers" => "p@nzER",
"paolistes" => "paolist",
"paolo" => "paOlo",
"paon" => "p@",
"paonne" => "pan",
"paons" => "p@",
"papa" => "papa",
"papa-cadeau" => "papakado",
"papable" => "papabl",
"papal" => "papal",
"papale" => "papal",
"papamobile" => "papamObil",
"paparazzi" => "papaRadzi",
"paparazzis" => "papaRadzi",
"paparazzo" => "papaRadzo",
"papas" => "papa",
"papauté" => "papote",
"papaux" => "papo",
"papaver" => "papavER",
"papavérine" => "papaveRin",
"papaye" => "papaj",
"papayer" => "papaje",
"papayers" => "papaje",
"papayes" => "papaj",
"pape" => "pap",
"papé" => "pape",
"papegai" => "papgE",
"papegais" => "papgE",
"papelard" => "pap°laR",
"papelarde" => "pap°laRd",
"papelards" => "pap°laR",
"paperasse" => "pap°Ras",
"paperasser" => "pap°Rase",
"paperasserie" => "pap°Ras°Ri",
"paperasseries" => "pap°Ras°Ri",
"paperasses" => "pap°Ras",
"paperassier" => "pap°Rasje",
"papes" => "pap",
"papesse" => "papEs",
"papet" => "papE",
"papeterie" => "papet°Ri",
"papeteries" => "papet°Ri",
"papetier" => "pap°tje",
"papetiers" => "pap°tje",
"papi" => "papi",
"papier" => "papje",
"papier-cadeau" => "papjekado",
"papier-monnaie" => "papjemonE",
"papiers" => "papje",
"papiers-calque" => "papjekalk",
"papilionacé" => "papiljOnase",
"papilionacée" => "papiljonase",
"papilionacées" => "papiljonase",
"papillaire" => "papilER",
"papille" => "papij",
"papilles" => "papij",
"papillomavirus" => "papijOmaviRys",
"papillomes" => "papilom",
"papillon" => "papij§",
"papillonna" => "papijona",
"papillonnage" => "papijonaZ",
"papillonnaient" => "papijonE",
"papillonnais" => "papijonE",
"papillonnait" => "papijonE",
"papillonnant" => "papijon@",
"papillonnante" => "papijon@t",
"papillonne" => "papijOn",
"papillonné" => "papijone",
"papillonnement" => "papijOn°m@",
"papillonnent" => "papijOn",
"papillonner" => "papijone",
"papillonnes" => "papijOn",
"papillons" => "papij§",
"papillotaient" => "papijotE",
"papillotait" => "papijotE",
"papillotant" => "papijot@",
"papillotantes" => "papijot@t",
"papillotants" => "papijot@",
"papillote" => "papijOt",
"papillotent" => "papijOt",
"papilloter" => "papijote",
"papillotèrent" => "papijotER",
"papillotes" => "papijOt",
"papis" => "papi",
"papisme" => "papizm",
"papiste" => "papist",
"papistes" => "papist",
"papotage" => "papotaZ",
"papotages" => "papotaZ",
"papotaient" => "papotE",
"papotait" => "papotE",
"papotant" => "papot@",
"papote" => "papOt",
"papoté" => "papote",
"papotent" => "papOt",
"papoter" => "papote",
"papotera" => "papOt°Ra",
"papotèrent" => "papotER",
"papotez" => "papote",
"papou" => "papu",
"papouille" => "papuj",
"papouillé" => "papuje",
"papouillent" => "papuj",
"papouiller" => "papuje",
"papouilles" => "papuj",
"papouillez" => "papuje",
"papous" => "papu",
"paprika" => "papRika",
"papy" => "papi",
"papyrus" => "papiRys",
"papys" => "papi",
"paqson" => "paks§",
"pâque" => "pak",
"paquebot" => "pak°bo",
"paquebots" => "pak°bo",
"pâquerette" => "pak°REt",
"pâquerettes" => "pak°REt",
"pâques" => "pak",
"paquet" => "pakE",
"paquet-cadeau" => "pakEkado",
"paqueta" => "pak°ta",
"paquetage" => "pak°taZ",
"paquetages" => "pak°taZ",
"paqueté" => "pak°te",
"paquets" => "pakE",
"paquets-cadeaux" => "pakEkado",
"paquette" => "pakEt",
"pâquis" => "paki",
"par" => "paR",
"par mégarde" => "paRmegaRd",
"par-ci" => "paRsi",
"par-dedans" => "paRd°d@",
"par-delà" => "paRd°la",
"par-derrière" => "paRdERjER",
"par-dessous" => "paRd°su",
"par-dessus" => "paRd°sy",
"par-devant" => "paRd°v@",
"par-devers" => "paRd°vER",
"para" => "paRa",
"para-humain" => "paRaym5",
"parabellum" => "paRabelOm",
"parabellums" => "paRabElOm",
"parabole" => "paRabOl",
"paraboles" => "paRabOl",
"parabolique" => "paRabolik",
"paraboliquement" => "paRabOlik°m@",
"paraboliques" => "paRabolik",
"paraboloïde" => "paRabOlOid",
"paracétamol" => "paRasetamOl",
"parachevaient" => "paRaS°vE",
"parachevait" => "paRaS°vE",
"parachevant" => "paRaS°v@",
"parachevé" => "paRaS°ve",
"parachèvement" => "paRaSEv°m@",
"parachèvent" => "paRaSEv",
"parachever" => "paRaS°ve",
"parachèvera" => "paRaSEv°Ra",
"parachèveraient" => "paRaSEv°RE",
"parachevèrent" => "paRaS°vER",
"parachutage" => "paRaSytaZ",
"parachutages" => "paRaSytaZ",
"parachute" => "paRaSyt",
"parachuté" => "paRaSyte",
"parachutée" => "paRaSyte",
"parachutées" => "paRaSyte",
"parachutent" => "paRaSyt",
"parachuter" => "paRaSyte",
"parachuterais" => "paRaSyt°RE",
"parachutèrent" => "paRaSytER",
"parachuterons" => "paRaSyt°R§",
"parachutes" => "paRaSyt",
"parachutés" => "paRaSyte",
"parachutez" => "paRaSyte",
"parachutisme" => "paRaSytizm",
"parachutiste" => "paRaSytist",
"parachutistes" => "paRaSytist",
"paraclet" => "paRaklE",
"parada" => "paRada",
"paradaient" => "paRadE",
"paradais" => "paRadE",
"paradait" => "paRadE",
"paradant" => "paRad@",
"parade" => "paRad",
"paradé" => "paRade",
"paradée" => "paRade",
"paradent" => "paRad",
"parader" => "paRade",
"paradera" => "paRad°Ra",
"paradèrent" => "paRadER",
"parades" => "paRad",
"paradeurs" => "paRad9R",
"paradigme" => "paRadigm",
"paradigmes" => "paRadigm",
"paradis" => "paRadi",
"paradisiaque" => "paRadizjak",
"paradisiaques" => "paRadizjak",
"paradisiers" => "paRadizje",
"paradons" => "paRad§",
"parador" => "paRadOR",
"parados" => "paRado",
"paradoxal" => "paRadOksal",
"paradoxale" => "paRadOksal",
"paradoxalement" => "paRadOksal°m@",
"paradoxales" => "paRadOksal",
"paradoxaux" => "paRadOkso",
"paradoxe" => "paRadOks",
"paradoxes" => "paRadOks",
"paradoxie" => "paRadOksi",
"parafer" => "paRafe",
"paraffine" => "paRafin",
"paraffiné" => "paRafine",
"paraffinée" => "paRafine",
"paraffinés" => "paRafine",
"parage" => "paRaZ",
"parages" => "paRaZ",
"paragouvernementales" => "paRaguvERn°m@tal",
"paragraphe" => "paRagRaf",
"paragraphes" => "paRagRaf",
"paraguayen" => "paRagwaj5",
"paraguayenne" => "paRagwajEn",
"paraguayennes" => "paRagwajEn",
"paraguayens" => "paRagwaj5",
"parai" => "paRE",
"paraient" => "paRE",
"parais" => "paRE",
"paraissaient" => "paREsE",
"paraissais" => "paREsE",
"paraissait" => "paREsE",
"paraissant" => "paREs@",
"paraisse" => "paREs",
"paraissent" => "paREs",
"paraissez" => "paREse",
"paraissiez" => "paREsje",
"paraissions" => "paREsj§",
"paraissons" => "paREs§",
"parait" => "paRE",
"paraît" => "paRE",
"paraîtra" => "paREtRa",
"paraîtrai" => "paREtRE",
"paraîtraient" => "paREtRE",
"paraîtrais" => "paREtRE",
"paraîtrait" => "paREtRE",
"paraîtras" => "paREtRa",
"paraître" => "paREtR",
"paraîtrez" => "paREtRe",
"paraîtront" => "paREtR§",
"parallaxe" => "paRalaks",
"parallaxes" => "paRalaks",
"parallèle" => "paRalEl",
"parallèlement" => "paRalEl°m@",
"parallélépipède" => "paRalelepipEd",
"parallélépipèdes" => "paRalelepipEd",
"parallélépipédique" => "paRalelepipedik",
"parallèles" => "paRalEl",
"parallélisme" => "paRalelizm",
"paralléliste" => "paRalelist",
"parallélogramme" => "paRalelogRam",
"paralogismes" => "paRaloZizm",
"paralympiques" => "paRal5pik",
"paralysa" => "paRaliza",
"paralysaient" => "paRalizE",
"paralysais" => "paRalizE",
"paralysait" => "paRalizE",
"paralysant" => "paRaliz@",
"paralysante" => "paRaliz@t",
"paralysantes" => "paRaliz@t",
"paralysants" => "paRaliz@",
"paralysât" => "paRaliza",
"paralyse" => "paRaliz",
"paralysé" => "paRalize",
"paralysée" => "paRalize",
"paralysées" => "paRalize",
"paralysent" => "paRaliz",
"paralyser" => "paRalize",
"paralysera" => "paRaliz°Ra",
"paralyserait" => "paRaliz°RE",
"paralysèrent" => "paRalizER",
"paralyserez" => "paRaliz°Re",
"paralysés" => "paRalize",
"paralysie" => "paRalizi",
"paralysies" => "paRalizi",
"paralytique" => "paRalitik",
"paralytiques" => "paRalitik",
"paramagnétique" => "paRamaNetik",
"paramédical" => "paRamedikal",
"paramédicale" => "paRamedikal",
"paramédicaux" => "paRamediko",
"paramètre" => "paRamEtR",
"paramètres" => "paRamEtR",
"paramétrique" => "paRametRik",
"paramilitaire" => "paRamilitER",
"paramilitaires" => "paRamilitER",
"paramnésie" => "paRamnezi",
"paranéoplasique" => "paRaneoplazik",
"parangon" => "paR@g§",
"parangonnages" => "paR@gonaZ",
"parangons" => "paR@g§",
"parano" => "paRano",
"paranoïa" => "paRanoja",
"paranoïaque" => "paRanojak",
"paranoïaques" => "paRanojak",
"paranoïde" => "paRanoid",
"paranormal" => "paRanORmal",
"paranormale" => "paRanORmal",
"paranormales" => "paRanORmal",
"paranormaux" => "paRanORmo",
"paranos" => "paRano",
"parant" => "paR@",
"parapente" => "paRap@t",
"parapet" => "paRapE",
"parapets" => "paRapE",
"paraphait" => "paRafE",
"paraphant" => "paRaf@",
"parapharmacie" => "paRafaRmasi",
"paraphe" => "paRaf",
"paraphé" => "paRafe",
"paraphée" => "paRafe",
"parapher" => "paRafe",
"paraphes" => "paRaf",
"paraphés" => "paRafe",
"parapheurs" => "paRaf9R",
"paraphez" => "paRafe",
"paraphrasa" => "paRafRaza",
"paraphrasait" => "paRafRazE",
"paraphrasant" => "paRafRaz@",
"paraphrase" => "paRafRaz",
"paraphrasé" => "paRafRaze",
"paraphraser" => "paRafRaze",
"paraphrases" => "paRafRaz",
"paraplégique" => "paRapleZik",
"paraplégiques" => "paRapleZik",
"parapluie" => "paRapl8i",
"parapluies" => "paRapl8i",
"parapsychique" => "paRapsiSik",
"parapsychologie" => "paRapsikoloZi",
"parapsychologique" => "paRapsikoloZik",
"parapsychologiques" => "paRapsikoloZik",
"parapsychologue" => "paRapsikolOg",
"parapsychologues" => "paRapsikolOg",
"parareligieuse" => "paRaR°liZj2z",
"paras" => "paRa",
"parascève" => "paRasEv",
"parascolaire" => "paRaskolER",
"parascolaires" => "paRaskolER",
"parasitaire" => "paRazitER",
"parasitaires" => "paRazitER",
"parasitait" => "paRazitE",
"parasite" => "paRazit",
"parasité" => "paRazite",
"parasitée" => "paRazite",
"parasitent" => "paRazit",
"parasiter" => "paRazite",
"parasites" => "paRazit",
"parasités" => "paRazite",
"parasiticide" => "paRazitisid",
"parasitisme" => "paRazitizm",
"parasitologie" => "paRazitoloZi",
"parasitose" => "paRazitoz",
"parasol" => "paRasOl",
"parasols" => "paRasOl",
"parathyroïdienne" => "paRatiRoidjEn",
"paratonnerre" => "paRatonER",
"paratonnerres" => "paRatonER",
"parâtre" => "paRatR",
"paravent" => "paRav@",
"paravents" => "paRav@",
"parbleu" => "paRbl2",
"parc" => "paRk",
"parcage" => "paRkaZ",
"parce" => "paRs",
"parce qu" => "paRs°k",
"parce que" => "paRs°k",
"parcellaire" => "paRselER",
"parcelle" => "paRsEl",
"parcelles" => "paRsEl",
"parchemin" => "paRS°m5",
"parcheminé" => "paRS°mine",
"parcheminée" => "paRS°mine",
"parcheminées" => "paRS°mine",
"parcheminés" => "paRS°mine",
"parchemineuse" => "paRS°min2z",
"parchemins" => "paRS°m5",
"parcimonie" => "paRsimoni",
"parcimonieuse" => "paRsimonj2z",
"parcimonieusement" => "paRsimonj2z°m@",
"parcimonieuses" => "paRsimonj2z",
"parcimonieux" => "paRsimonj2",
"parcmètre" => "paRkmEtR",
"parcmètres" => "paRkmEtR",
"parcomètre" => "paRkomEtR",
"parcouraient" => "paRkuRE",
"parcourais" => "paRkuRE",
"parcourait" => "paRkuRE",
"parcourant" => "paRkuR@",
"parcoure" => "paRkuR",
"parcourent" => "paRkuR",
"parcourez" => "paRkuRe",
"parcouriez" => "paRkuRje",
"parcourions" => "paRkuRj§",
"parcourir" => "paRkuRiR",
"parcourons" => "paRkuR§",
"parcourra" => "paRkuRa",
"parcourrai" => "paRkuRE",
"parcourraient" => "paRkuRE",
"parcourrais" => "paRkuRE",
"parcourrait" => "paRkuRE",
"parcourrez" => "paRkuRe",
"parcourrions" => "paRkuRj§",
"parcourront" => "paRkuR§",
"parcours" => "paRkuR",
"parcourt" => "paRkuR",
"parcouru" => "paRkuRy",
"parcourue" => "paRkuRy",
"parcourues" => "paRkuRy",
"parcourûmes" => "paRkuRym",
"parcoururent" => "paRkuRyR",
"parcourus" => "paRkuRy",
"parcourut" => "paRkuRy",
"parcs" => "paRk",
"pardessus" => "paRd°sy",
"pardi" => "paRdi",
"pardieu" => "paRdj2",
"pardingue" => "paRd5g",
"pardon" => "paRd§",
"pardonna" => "paRdona",
"pardonnable" => "paRdonabl",
"pardonnaient" => "paRdonE",
"pardonnais" => "paRdonE",
"pardonnait" => "paRdonE",
"pardonnant" => "paRdon@",
"pardonnât" => "paRdona",
"pardonne" => "paRdOn",
"pardonné" => "paRdone",
"pardonnée" => "paRdone",
"pardonnées" => "paRdone",
"pardonnent" => "paRdOn",
"pardonner" => "paRdone",
"pardonnera" => "paRdOn°Ra",
"pardonnerai" => "paRdOn°RE",
"pardonneraient" => "paRdOn°RE",
"pardonnerais" => "paRdOn°RE",
"pardonnerait" => "paRdOn°RE",
"pardonneras" => "paRdOn°Ra",
"pardonnèrent" => "paRdonER",
"pardonnerez" => "paRdOn°Re",
"pardonneriez" => "paRdon°Rje",
"pardonnerons" => "paRdOn°R§",
"pardonneront" => "paRdOn°R§",
"pardonnes" => "paRdOn",
"pardonnés" => "paRdone",
"pardonnez" => "paRdone",
"pardonniez" => "paRdonje",
"pardonnions" => "paRdonj§",
"pardonnons" => "paRdon§",
"pardons" => "paRd§",
"pare" => "paR",
"paré" => "paRe",
"pare-balle" => "paRbal",
"pare-balles" => "paRbal",
"pare-boue" => "paRbu",
"pare-brise" => "paRbRiz",
"pare-brises" => "paRbRiz",
"pare-chocs" => "paRSOk",
"pare-éclats" => "paRekla",
"pare-étincelles" => "paRet5sEl",
"pare-feu" => "paRf2",
"pare-feux" => "paRf2",
"pare-soleil" => "paRsolEj",
"parée" => "paRe",
"parées" => "paRe",
"parégorique" => "paRegoRik",
"pareil" => "paREj",
"pareille" => "paREj",
"pareillement" => "paREj°m@",
"pareilles" => "paREj",
"pareils" => "paREj",
"parement" => "paR°m@",
"parements" => "paR°m@",
"parenchyme" => "paR@Sim",
"parent" => "paR@",
"parentage" => "paR@taZ",
"parental" => "paR@tal",
"parentale" => "paR@tal",
"parentales" => "paR@tal",
"parentaux" => "paR@to",
"parente" => "paR@t",
"parenté" => "paR@te",
"parentèle" => "paR@tEl",
"parentèles" => "paR@tEl",
"parentes" => "paR@t",
"parentés" => "paR@te",
"parenthèse" => "paR@tEz",
"parenthèses" => "paR@tEz",
"parents" => "paR@",
"paréo" => "paReo",
"paréos" => "paReo",
"parer" => "paRe",
"parerai" => "paR°RE",
"parerait" => "paR°RE",
"parés" => "paRe",
"parésie" => "paRezi",
"paressaient" => "paREsE",
"paressais" => "paREsE",
"paressait" => "paREsE",
"paressant" => "paREs@",
"paresse" => "paREs",
"paressé" => "paRese",
"paresser" => "paRese",
"paresses" => "paREs",
"paresseuse" => "paREs2z",
"paresseusement" => "paREs2z°m@",
"paresseuses" => "paRes2z",
"paresseux" => "paREs2",
"paressions" => "paREsj§",
"paresthésie" => "paREstezi",
"pareur" => "paR9R",
"parez" => "paRe",
"parfaire" => "paRfER",
"parfais" => "paRfE",
"parfaisais" => "paRf°zE",
"parfaisait" => "paRf°zE",
"parfait" => "paRfE",
"parfaite" => "paRfEt",
"parfaitement" => "paRfEt°m@",
"parfaites" => "paRfEt",
"parfaits" => "paRfE",
"parferont" => "paRf°R§",
"parfit" => "paRfi",
"parfois" => "paRfwa",
"parfum" => "paRf1",
"parfuma" => "paRfyma",
"parfumaient" => "paRfymE",
"parfumait" => "paRfymE",
"parfume" => "paRfym",
"parfumé" => "paRfyme",
"parfumée" => "paRfyme",
"parfumées" => "paRfyme",
"parfument" => "paRfym",
"parfumer" => "paRfyme",
"parfumera" => "paRfym°Ra",
"parfumerie" => "paRfym°Ri",
"parfumeries" => "paRfym°Ri",
"parfumés" => "paRfyme",
"parfumeur" => "paRfym9R",
"parfumeurs" => "paRfym9R",
"parfumeuse" => "paRfym2z",
"parfumez" => "paRfyme",
"parfums" => "paRf1",
"pari" => "paRi",
"paria" => "paRja",
"pariade" => "paRjad",
"pariaient" => "paRjE",
"pariais" => "paRjE",
"pariait" => "paRjE",
"pariant" => "paRj@",
"parias" => "paRja",
"parie" => "paRi",
"parié" => "paRje",
"parient" => "paRi",
"parier" => "paRje",
"parierai" => "paRiRE",
"parierais" => "paRiRE",
"parierait" => "paRiRE",
"parieriez" => "paRiRje",
"paries" => "paRi",
"pariétal" => "paRjetal",
"pariétale" => "paRjetal",
"pariétaux" => "paRjeto",
"parieur" => "paRj9R",
"parieurs" => "paRj9R",
"parieuse" => "paRj2z",
"pariez" => "paRje",
"parigot" => "paRigo",
"parigote" => "paRigOt",
"parigotes" => "paRigOt",
"parigots" => "paRigo",
"parions" => "paRj§",
"paris" => "paRi",
"paris-brest" => "paRibREst",
"parisien" => "paRizj5",
"parisienne" => "paRizjEn",
"parisiennes" => "paRizjEn",
"parisiens" => "paRizj5",
"paritaire" => "paRitER",
"parité" => "paRite",
"parjurant" => "paRZyR@",
"parjure" => "paRZyR",
"parjuré" => "paRZyRe",
"parjurée" => "paRZyRe",
"parjurer" => "paRZyRe",
"parjurera" => "paRZyR°Ra",
"parjures" => "paRZyR",
"parka" => "paRka",
"parking" => "paRkiG",
"parkings" => "paRkiG",
"parkinson" => "paRkinsOn",
"parkinsonien" => "paRkinsonj5",
"parkinsonienne" => "paRkinsonjEn",
"parkinsoniens" => "paRkinsonj5",
"parla" => "paRla",
"parlai" => "paRlE",
"parlaient" => "paRlE",
"parlais" => "paRlE",
"parlait" => "paRlE",
"parlâmes" => "paRlam",
"parlant" => "paRl@",
"parlante" => "paRl@t",
"parlantes" => "paRl@t",
"parlants" => "paRl@",
"parlas" => "paRla",
"parlassent" => "paRlas",
"parlasses" => "paRlas",
"parlât" => "paRla",
"parle" => "paRl",
"parlé" => "paRle",
"parlée" => "paRle",
"parlées" => "paRle",
"parlement" => "paRl°m@",
"parlementaire" => "paRl°m@tER",
"parlementaires" => "paRl°m@tER",
"parlementait" => "paRl°m@tE",
"parlementant" => "paRl°m@t@",
"parlementarisme" => "paRl°m@taRizm",
"parlementariste" => "paRl°m@taRist",
"parlemente" => "paRl°m@t",
"parlementé" => "paRl2m@te",
"parlementent" => "paRl°m@t",
"parlementer" => "paRl°m@te",
"parlementèrent" => "paRl°m@tER",
"parlementons" => "paRl°m@t§",
"parlements" => "paRl°m@",
"parlent" => "paRl",
"parler" => "paRle",
"parlera" => "paRl°Ra",
"parlerai" => "paRl°RE",
"parleraient" => "paRl°RE",
"parlerais" => "paRl°RE",
"parlerait" => "paRl°RE",
"parleras" => "paRl°Ra",
"parlèrent" => "paRlER",
"parlerez" => "paRl°Re",
"parlerie" => "paRl°Ri",
"parleriez" => "paRl°Rje",
"parlerions" => "paRl°Rj§",
"parlerons" => "paRl°R§",
"parleront" => "paRl°R§",
"parlers" => "paRle",
"parles" => "paRl",
"parlés" => "paRle",
"parleur" => "paRl9R",
"parleurs" => "paRl9R",
"parleuse" => "paRl2z",
"parlez" => "paRle",
"parliez" => "paRlje",
"parlions" => "paRlj§",
"parloir" => "paRlwaR",
"parloirs" => "paRlwaR",
"parlons" => "paRl§",
"parlophone" => "paRlOfOn",
"parlotaient" => "paRlotE",
"parlote" => "paRlOt",
"parloter" => "paRlote",
"parlotes" => "paRlOt",
"parlotte" => "paRlOt",
"parlottes" => "paRlOt",
"parme" => "paRm",
"parmélies" => "paRmeli",
"parménidien" => "paRmenidj5",
"parmentier" => "paRm@tje",
"parmentures" => "paRm@tyR",
"parmesan" => "paRm°z@",
"parmesane" => "paRm°zan",
"parmesans" => "paRm°z@",
"parmi" => "paRmi",
"parnassienne" => "paRnasjEn",
"parodiai" => "paRodjE",
"parodiait" => "paRodjE",
"parodiant" => "paRodj@",
"parodie" => "paRodi",
"parodier" => "paRodje",
"parodies" => "paRodi",
"parodique" => "paRodik",
"parodiquement" => "paRodik°m@",
"parodiques" => "paRodik",
"parodontal" => "paRod§tal",
"parodontale" => "paROd§tal",
"paroi" => "paRwa",
"paroir" => "paRwaR",
"paroirs" => "paRwaR",
"parois" => "paRwa",
"paroisse" => "paRwas",
"paroisses" => "paRwas",
"paroissial" => "paRwasjal",
"paroissiale" => "paRwasjal",
"paroissiales" => "paRwasjal",
"paroissiaux" => "paRwasjo",
"paroissien" => "paRwasj5",
"paroissienne" => "paRwasjEn",
"paroissiennes" => "paRwasjEn",
"paroissiens" => "paRwasj5",
"parole" => "paROl",
"paroles" => "paROl",
"paroli" => "paRoli",
"parolier" => "paRolje",
"parolière" => "paROljER",
"paronomasie" => "paRonomazi",
"paros" => "paROs",
"parotidienne" => "paROtidjEn",
"parousie" => "paRuzi",
"paroxysme" => "paROksizm",
"paroxysmes" => "paROksizm",
"paroxysmique" => "paROksismik",
"paroxysmiques" => "paROksismik",
"paroxystique" => "paROksistik",
"paroxystiques" => "paROksistik",
"parpaillot" => "paRpajo",
"parpaillote" => "paRpajOt",
"parpaillotes" => "paRpajOt",
"parpaing" => "paRp5",
"parpaings" => "paRp5",
"parquait" => "paRkE",
"parque" => "paRk",
"parqué" => "paRke",
"parquée" => "paRke",
"parquées" => "paRke",
"parquent" => "paRk",
"parquer" => "paRke",
"parqués" => "paRke",
"parquet" => "paRkE",
"parquetage" => "paRk°taZ",
"parqueté" => "paRk°te",
"parquetée" => "paRk°te",
"parquetées" => "paRk°te",
"parqueteur" => "paRk°t9R",
"parqueteuse" => "paRk2t2z",
"parquets" => "paRkE",
"parquez" => "paRke",
"parr" => "paR",
"parrain" => "paR5",
"parrainage" => "paREnaZ",
"parrainait" => "paREnE",
"parrainant" => "paREn@",
"parraine" => "paREn",
"parrainé" => "paREne",
"parrainée" => "paREne",
"parrainent" => "paREn",
"parrainer" => "paREne",
"parrainerai" => "paRE°nRE",
"parrainés" => "paREne",
"parraineuse" => "paREn2z",
"parrains" => "paR5",
"parricide" => "paRisid",
"parricides" => "paRisid",
"pars" => "paR",
"parsec" => "paRsEk",
"parsecs" => "paRsEk",
"parsemaient" => "paRs°mE",
"parsemant" => "paRs°m@",
"parsème" => "paRsEm",
"parsemé" => "paRs°me",
"parsemée" => "paRs°me",
"parsemées" => "paRs°me",
"parsèment" => "paRsEm",
"parsemer" => "paRs°me",
"parsemés" => "paRs°me",
"parsi" => "paRsi",
"parsis" => "paRsi",
"part" => "paR",
"part time" => "paRtajm",
"partage" => "paRtaZ",
"partagé" => "paRtaZe",
"partagea" => "paRtaZa",
"partageable" => "paRtaZabl",
"partageai" => "paRtaZE",
"partageaient" => "paRtaZE",
"partageais" => "paRtaZE",
"partageait" => "paRtaZE",
"partageâmes" => "paRtaZam",
"partageant" => "paRtaZ@",
"partageât" => "paRtaZa",
"partagée" => "paRtaZe",
"partagées" => "paRtaZe",
"partagent" => "paRtaZ",
"partageons" => "paRtaZ§",
"partager" => "paRtaZe",
"partagera" => "paRtaZ°Ra",
"partagerai" => "paRtaZ°RE",
"partageraient" => "paRtaZ°RE",
"partagerais" => "paRtaZ°RE",
"partagerait" => "paRtaZ°RE",
"partageras" => "paRtaZ°Ra",
"partagèrent" => "paRtaZER",
"partagerez" => "paRtaZ°Re",
"partageriez" => "paRtaZ°Rje",
"partagerions" => "paRtaZ°Rj§",
"partagerons" => "paRtaZ°R§",
"partageront" => "paRtaZ°R§",
"partages" => "paRtaZ",
"partagés" => "paRtaZe",
"partageur" => "paRtaZ9R",
"partageurs" => "paRtaZ9R",
"partageuse" => "paRtaZ2z",
"partageux" => "paRtaZ2",
"partagez" => "paRtaZe",
"partagiez" => "paRtaZje",
"partagions" => "paRtaZj§",
"partaient" => "paRtE",
"partais" => "paRtE",
"partait" => "paRtE",
"partance" => "paRt@s",
"partant" => "paRt@",
"partante" => "paRt@t",
"partantes" => "paRt@t",
"partants" => "paRt@",
"parte" => "paRt",
"partenaire" => "paRt°nER",
"partenaire-robot" => "paRt°nERRobo",
"partenaires" => "paRt°nER",
"partenariat" => "paRt°naRja",
"partent" => "paRt",
"parterre" => "paRtER",
"parterres" => "paRtER",
"partes" => "paRt",
"partez" => "paRte",
"parthe" => "paRt",
"parthénogenèse" => "paRtenoZenEz",
"parthénogénèse" => "paRtenOZenEz",
"parthénogénétique" => "paRtenoZenetik",
"parthes" => "paRt",
"parthique" => "paRtik",
"parti" => "paRti",
"partial" => "paRsjal",
"partiale" => "paRsjal",
"partiales" => "paRsjal",
"partialité" => "paRsjalite",
"partiaux" => "paRsjo",
"participa" => "paRtisipa",
"participai" => "paRtisipE",
"participaient" => "paRtisipE",
"participais" => "paRtisipE",
"participait" => "paRtisipE",
"participant" => "paRtisip@",
"participante" => "paRtisip@t",
"participantes" => "paRtisip@t",
"participants" => "paRtisip@",
"participât" => "paRtisipa",
"participation" => "paRtisipasj§",
"participations" => "paRtisipasj§",
"participative" => "paRtisipativ",
"participe" => "paRtisip",
"participé" => "paRtisipe",
"participent" => "paRtisip",
"participer" => "paRtisipe",
"participera" => "paRtisip°Ra",
"participerai" => "paRtisip°RE",
"participeraient" => "paRtisip°RE",
"participerais" => "paRtisip°RE",
"participerait" => "paRtisip°RE",
"participeras" => "paRtisip°Ra",
"participèrent" => "paRtisipER",
"participerez" => "paRtisip°Re",
"participerons" => "paRtisip°R§",
"participeront" => "paRtisip°R§",
"participes" => "paRtisip",
"participés" => "paRtisipe",
"participez" => "paRtisipe",
"participiez" => "paRtisipje",
"participions" => "paRtisipj§",
"participons" => "paRtisip§",
"particularisées" => "paRtikylaRize",
"particularisme" => "paRtikylaRizm",
"particularismes" => "paRtikylaRizm",
"particularité" => "paRtikylaRite",
"particularités" => "paRtikylaRite",
"particule" => "paRtikyl",
"particules" => "paRtikyl",
"particulier" => "paRtikylje",
"particulière" => "paRtikyljER",
"particulièrement" => "paRtikyljER°m@",
"particulières" => "paRtikyljER",
"particuliers" => "paRtikylje",
"partie" => "paRti",
"partiel" => "paRsjEl",
"partielle" => "paRsjEl",
"partiellement" => "paRsjEl°m@",
"partielles" => "paRsjEl",
"partiels" => "paRsjEl",
"parties" => "paRti",
"partiez" => "paRtje",
"partîmes" => "paRtim",
"partions" => "paRtj§",
"partir" => "paRtiR",
"partira" => "paRtiRa",
"partirai" => "paRtiRE",
"partiraient" => "paRtiRE",
"partirais" => "paRtiRE",
"partirait" => "paRtiRE",
"partiras" => "paRtiRa",
"partirent" => "paRtiR",
"partirez" => "paRtiRe",
"partiriez" => "paRtiRje",
"partirions" => "paRtiRj§",
"partirons" => "paRtiR§",
"partiront" => "paRtiR§",
"partis" => "paRti",
"partisan" => "paRtiz@",
"partisane" => "paRtizan",
"partisanes" => "paRtizan",
"partisans" => "paRtiz@",
"partisse" => "paRtis",
"partissent" => "paRtis",
"partit" => "paRti",
"partît" => "paRti",
"partita" => "paRtita",
"partitas" => "paRtita",
"partitif" => "paRtitif",
"partition" => "paRtisj§",
"partitions" => "paRtisj§",
"partner" => "paRtnER",
"partons" => "paRt§",
"partouse" => "paRtuz",
"partouser" => "paRtuze",
"partout" => "paRtu",
"partouzait" => "paRtuzE",
"partouzarde" => "paRtuzaRd",
"partouzardes" => "paRtuzaRd",
"partouzards" => "paRtuzaR",
"partouze" => "paRtuz",
"partouzent" => "paRtuz",
"partouzer" => "paRtuze",
"partouzes" => "paRtuz",
"partouzeur" => "paRtuz9R",
"partouzeurs" => "paRtuz9R",
"parts" => "paR",
"parturiente" => "paRtyRj@t",
"parturientes" => "paRtyRj@t",
"parturition" => "paRtyRisj§",
"parturitions" => "paRtyRisj§",
"party" => "paRti",
"paru" => "paRy",
"parue" => "paRy",
"parure" => "paRyR",
"parurent" => "paRyR",
"parures" => "paRyR",
"parus" => "paRy",
"parussent" => "paRys",
"parut" => "paRy",
"parût" => "paRy",
"parution" => "paRysj§",
"parvenaient" => "paRv°nE",
"parvenais" => "paRv°nE",
"parvenait" => "paRv°nE",
"parvenant" => "paRv°n@",
"parvenez" => "paRv°ne",
"parveniez" => "paRv°nje",
"parvenions" => "paRv°nj§",
"parvenir" => "paRv°niR",
"parvenons" => "paRv°n§",
"parvenu" => "paRv°ny",
"parvenue" => "paRv°ny",
"parvenues" => "paRv°ny",
"parvenus" => "paRv°ny",
"parviendra" => "paRvj5dRa",
"parviendrai" => "paRvj5dRE",
"parviendraient" => "paRvj5dRE",
"parviendrais" => "paRvj5dRE",
"parviendrait" => "paRvj5dRE",
"parviendras" => "paRvj5dRa",
"parviendrez" => "paRvj5dRe",
"parviendrions" => "paRvj5dRij§",
"parviendrons" => "paRvj5dR§",
"parviendront" => "paRvj5dR§",
"parvienne" => "paRvjEn",
"parviennent" => "paRvjEn",
"parviens" => "paRvj5",
"parvient" => "paRvj5",
"parvînmes" => "paRv5m",
"parvinrent" => "paRv5R",
"parvins" => "paRv5",
"parvinssent" => "paRv5s",
"parvint" => "paRv5",
"parvînt" => "paRv5",
"parvis" => "paRvi",
"pas" => "pa",
"pas-de-porte" => "padpORt",
"pas-je" => "paZ2",
"pascal" => "paskal",
"pascale" => "paskal",
"pascales" => "paskal",
"pascalien" => "paskalj5",
"pascaliennes" => "paskaljEn",
"pascaliens" => "paskalj5",
"paseo" => "paseo",
"pasionaria" => "pazjonaRja",
"pasionarias" => "pazjonaRja",
"paso" => "pazo",
"paso doble" => "pazodObl",
"paso-doble" => "pasodOble",
"pasos" => "pazo",
"pasque" => "pask",
"pasquins" => "pask5",
"passa" => "pasa",
"passable" => "pasabl",
"passablement" => "pasabl°m@",
"passables" => "pasabl",
"passade" => "pasad",
"passades" => "pasad",
"passage" => "pasaZ",
"passager" => "pasaZe",
"passagère" => "pasaZER",
"passagèrement" => "pasaZER°m@",
"passagères" => "pasaZER",
"passagers" => "pasaZe",
"passages" => "pasaZ",
"passai" => "pasE",
"passaient" => "pasE",
"passais" => "pasE",
"passait" => "pasE",
"passâmes" => "pasam",
"passant" => "pas@",
"passante" => "pas@t",
"passantes" => "pas@t",
"passants" => "pas@",
"passas" => "pasa",
"passât" => "pasa",
"passâtes" => "pasat",
"passation" => "pasasj§",
"passavant" => "pasav@",
"passe" => "pas",
"passé" => "pase",
"passe-boule" => "pasbul",
"passe-boules" => "pasbul",
"passe-crassane" => "paskRasan",
"passe-droit" => "pasdRwa",
"passe-droits" => "pasdRwa",
"passe-la-moi" => "paslamwa",
"passe-lacet" => "paslasE",
"passe-lacets" => "paslasE",
"passe-montagne" => "pasm§taN",
"passe-montagnes" => "pasm§taN",
"passe-muraille" => "pasmyRaj",
"passe-partout" => "paspaRtu",
"passe-passe" => "paspas",
"passe-pied" => "paspje",
"passe-plat" => "paspla",
"passe-roses" => "pasRoz",
"passe-temps" => "past@",
"passée" => "pase",
"passées" => "pase",
"passéiste" => "paseist",
"passement" => "pas°m@",
"passementaient" => "pas°m@tE",
"passementé" => "pas°m@te",
"passementent" => "pas°m@t",
"passementerie" => "pas°m@t°Ri",
"passementeries" => "pas°m@t°Ri",
"passementier" => "pas°m@tje",
"passementière" => "pas°m@tjER",
"passent" => "pas",
"passepoil" => "paspwal",
"passeport" => "paspOR",
"passeports" => "paspOR",
"passer" => "pase",
"passera" => "pas°Ra",
"passerai" => "pas°RE",
"passeraient" => "pas°RE",
"passerais" => "pas°RE",
"passerait" => "pas°RE",
"passeras" => "pas°Ra",
"passereau" => "pas°Ro",
"passereaux" => "pas°Ro",
"passerelle" => "pas°REl",
"passerelles" => "pas°REl",
"passèrent" => "pasER",
"passerez" => "pas°Re",
"passeriez" => "pas°Rje",
"passerions" => "pas°Rj§",
"passerons" => "pas°R§",
"passeront" => "pas°R§",
"passeroses" => "pas°Roz",
"passes" => "pas",
"passés" => "pase",
"passeur" => "pas9R",
"passeurs" => "pas9R",
"passeuse" => "pas2z",
"passez" => "pase",
"passible" => "pasibl",
"passibles" => "pasibl",
"passiez" => "pasje",
"passif" => "pasif",
"passiflore" => "pasiflOR",
"passifs" => "pasif",
"passim" => "pasim",
"passing" => "pasiG",
"passion" => "pasj§",
"passionna" => "pasjona",
"passionnai" => "pasjonE",
"passionnaient" => "pasjonE",
"passionnais" => "pasjonE",
"passionnait" => "pasjonE",
"passionnant" => "pasjon@",
"passionnante" => "pasjon@t",
"passionnantes" => "pasjon@t",
"passionnants" => "pasjon@",
"passionne" => "pasjOn",
"passionné" => "pasjone",
"passionnée" => "pasjone",
"passionnées" => "pasjone",
"passionnel" => "pasjonEl",
"passionnelle" => "pasjonEl",
"passionnellement" => "pasjonEl°m@",
"passionnelles" => "pasjonEl",
"passionnels" => "pasjonEl",
"passionnément" => "pasjonem@",
"passionnent" => "pasjOn",
"passionner" => "pasjone",
"passionnera" => "pasjOn°Ra",
"passionnerait" => "pasjOn°RE",
"passionneras" => "pasjOn°Ra",
"passionnèrent" => "pasjonER",
"passionnés" => "pasjone",
"passionnons" => "pasjon§",
"passions" => "pasj§",
"passive" => "pasiv",
"passivement" => "pasiv°m@",
"passiver" => "pasive",
"passives" => "pasiv",
"passiveté" => "pasiv°te",
"passivité" => "pasivite",
"passoire" => "paswaR",
"passoires" => "paswaR",
"passons" => "pas§",
"past" => "past",
"pastaga" => "pastaga",
"pastagas" => "pastaga",
"pastel" => "pastEl",
"pastels" => "pastEl",
"pastenague" => "past2nag",
"pastèque" => "pastEk",
"pastèques" => "pastEk",
"pasteur" => "past9R",
"pasteurella" => "past2REla",
"pasteurisation" => "past9Rizasj§",
"pasteurisé" => "past9Rize",
"pasteurisée" => "past9Rize",
"pasteuriser" => "past9Rize",
"pasteurisés" => "past9Rize",
"pasteurs" => "past9R",
"pasticha" => "pastiSa",
"pastichai" => "pastiSE",
"pastichait" => "pastiSE",
"pastiche" => "pastiS",
"pastiché" => "pastiSe",
"pasticher" => "pastiSe",
"pastiches" => "pastiS",
"pasticheur" => "pastiS9R",
"pastille" => "pastij",
"pastiller" => "pastije",
"pastilles" => "pastij",
"pastis" => "pastis",
"pastophore" => "pastofOR",
"pastoral" => "pastoRal",
"pastorale" => "pastoRal",
"pastorales" => "pastoRal",
"pastoraux" => "pastoRo",
"pastour" => "pastuR",
"pastoureau" => "pastuRo",
"pastoureaux" => "pastuRo",
"pastourelle" => "pastuREl",
"pastourelles" => "pastuREl",
"pat" => "pat",
"pât" => "pa",
"patache" => "pataS",
"patachon" => "pataS§",
"patafiole" => "patafjOl",
"patagon" => "patag§",
"patagonien" => "patagonj5",
"patagons" => "patag§",
"patapouf" => "patapuf",
"patapoufs" => "patapuf",
"pataquès" => "patakEs",
"patarin" => "pataR5",
"patata" => "patata",
"patate" => "patat",
"patates" => "patat",
"patati" => "patati",
"patatras" => "patatRa",
"pataud" => "pato",
"pataude" => "patod",
"pataudes" => "patod",
"patauds" => "pato",
"pataugas" => "patoga",
"patauge" => "patoZ",
"pataugé" => "patoZe",
"pataugea" => "patoZa",
"pataugeaient" => "patoZE",
"pataugeais" => "patoZE",
"pataugeait" => "patoZE",
"pataugeant" => "patoZ@",
"pataugent" => "patoZ",
"pataugeoire" => "patoZwaR",
"pataugeons" => "patoZ§",
"patauger" => "patoZe",
"pataugera" => "patoZ°Ra",
"pataugerais" => "patoZ°RE",
"pataugèrent" => "patoZER",
"pataugerons" => "patoZ°R§",
"patauges" => "patoZ",
"pataugez" => "patoZe",
"pataugis" => "patoZi",
"patch" => "patS",
"patches" => "patS",
"patchouli" => "patSuli",
"patchs" => "patS",
"patchwork" => "patSw9Rk",
"pâte" => "pat",
"pâté" => "pate",
"pâtée" => "pate",
"pâtées" => "pate",
"patelin" => "pat°l5",
"pateline" => "pat°lin",
"patelins" => "pat°l5",
"patellaire" => "patElER",
"patelles" => "patEl",
"patène" => "patEn",
"patènes" => "patEn",
"patenôtres" => "pat°notR",
"patent" => "pat@",
"patente" => "pat@t",
"patenté" => "pat@te",
"patentée" => "pat@te",
"patentées" => "pat@te",
"patentes" => "pat@t",
"patentés" => "pat@te",
"patents" => "pat@",
"pater" => "patER",
"pater familias" => "patERfamiljas",
"pater noster" => "patERnOstER",
"patère" => "patER",
"patères" => "patER",
"paternalisme" => "patERnalizm",
"paternaliste" => "patERnalist",
"paternalistes" => "patERnalist",
"paterne" => "patERn",
"paternel" => "patERnEl",
"paternelle" => "patERnEl",
"paternellement" => "patERnEl°m@",
"paternelles" => "patERnEl",
"paternels" => "patERnEl",
"paternité" => "patERnite",
"paternités" => "patERnite",
"pâtes" => "pat",
"pâtés" => "pate",
"pâteuse" => "pat2z",
"pâteusement" => "pat2z°m@",
"pâteuses" => "pat2z",
"pâteux" => "pat2",
"pathétique" => "patetik",
"pathétiquement" => "patetik°m@",
"pathétiques" => "patetik",
"pathétisme" => "patetizm",
"pathogène" => "patoZEn",
"pathogénique" => "patOZenik",
"pathologie" => "patoloZi",
"pathologique" => "patoloZik",
"pathologiquement" => "patoloZik°m@",
"pathologiques" => "patoloZik",
"pathologiste" => "patoloZist",
"pathos" => "patos",
"pâti" => "pati",
"patibulaire" => "patibylER",
"patibulaires" => "patibylER",
"patiemment" => "pasjam@",
"patience" => "pasj@s",
"patiences" => "pasj@s",
"patient" => "pasj@",
"patienta" => "pasj@ta",
"patientai" => "pasj@tE",
"patientaient" => "pasj@tE",
"patientait" => "pasj@tE",
"patientant" => "pasj@t@",
"patiente" => "pasj@t",
"patienté" => "pasj@te",
"patientent" => "pasj@t",
"patienter" => "pasj@te",
"patientera" => "pasj@t°Ra",
"patienteraient" => "pasj@t°RE",
"patienterait" => "pasj@t°RE",
"patienteras" => "pasj@t°Ra",
"patientèrent" => "pasj@tER",
"patienterez" => "pasj@t°Re",
"patienterons" => "pasj@t°R§",
"patientes" => "pasj@t",
"patientez" => "pasj@te",
"patientions" => "pasj@tj§",
"patientons" => "pasj@t§",
"patients" => "pasj@",
"patin" => "pat5",
"patina" => "patina",
"patinage" => "patinaZ",
"patinaient" => "patinE",
"patinais" => "patinE",
"patinait" => "patinE",
"patinant" => "patin@",
"patine" => "patin",
"patiné" => "patine",
"patinée" => "patine",
"patinées" => "patine",
"patinent" => "patin",
"patiner" => "patine",
"patinerais" => "patin°RE",
"patinerons" => "patin°R§",
"patines" => "patin",
"patinés" => "patine",
"patinette" => "patinEt",
"patinettes" => "patinEt",
"patineur" => "patin9R",
"patineurs" => "patin9R",
"patineuse" => "patin2z",
"patineuses" => "patin2z",
"patinez" => "patine",
"patiniez" => "patinje",
"patinions" => "patinj§",
"patinoire" => "patinwaR",
"patinoires" => "patinwaR",
"patinons" => "patin§",
"patins" => "pat5",
"patio" => "patjo",
"patios" => "patjo",
"pâtir" => "patiR",
"pâtira" => "patiRa",
"pâtiraient" => "patiRE",
"pâtirait" => "patiRE",
"pâtirent" => "patiR",
"pâtiront" => "patiR§",
"pâtis" => "pati",
"pâtissaient" => "patisE",
"pâtissais" => "patisE",
"pâtissait" => "patisE",
"pâtisse" => "patis",
"pâtissent" => "patis",
"pâtisserie" => "patis°Ri",
"pâtisseries" => "patis°Ri",
"pâtisses" => "patis",
"pâtissez" => "patise",
"pâtissier" => "patisje",
"pâtissière" => "patisjER",
"pâtissiers" => "patisje",
"pâtissons" => "patis§",
"pâtit" => "pati",
"pâtît" => "pati",
"patoche" => "patOS",
"patoches" => "patOS",
"patois" => "patwa",
"patoisante" => "patwaz@t",
"patoise" => "patwaz",
"pâton" => "pat§",
"pâtons" => "pat§",
"patouillard" => "patujaR",
"patouille" => "patuj",
"patouillons" => "patuj§",
"pâtour" => "patuR",
"patraque" => "patRak",
"pâtre" => "patR",
"pâtres" => "patR",
"patri" => "patRi",
"patriarcal" => "patRijaRkal",
"patriarcale" => "patRijaRkal",
"patriarcales" => "patRijaRkal",
"patriarcat" => "patRijaRka",
"patriarcats" => "patRijaRka",
"patriarcaux" => "patRijaRko",
"patriarche" => "patRijaRS",
"patriarches" => "patRijaRk",
"patriarchie" => "patRiaRSi",
"patriciat" => "patRisja",
"patricien" => "patRisj5",
"patricienne" => "patRisjEn",
"patriciennes" => "patRisjEn",
"patriciens" => "patRisj5",
"patrie" => "patRi",
"patries" => "patRi",
"patrilinéaire" => "patRilineER",
"patrimoine" => "patRimwan",
"patrimoines" => "patRimwan",
"patrimonial" => "patRimonjal",
"patriotard" => "patRijotaR",
"patriotardes" => "patRijotaRd",
"patriotards" => "patRijotaR",
"patriote" => "patRijOt",
"patriotes" => "patRijOt",
"patriotique" => "patRijotik",
"patriotiquement" => "patRijotik°m@",
"patriotiques" => "patRijotik",
"patriotisme" => "patRijotizm",
"patron" => "patR§",
"patronage" => "patRonaZ",
"patronages" => "patRonaZ",
"patronal" => "patRonal",
"patronale" => "patRonal",
"patronales" => "patRonal",
"patronat" => "patRona",
"patronaux" => "patRono",
"patronna" => "patRona",
"patronne" => "patROn",
"patronné" => "patRone",
"patronnée" => "patRone",
"patronner" => "patRone",
"patronnes" => "patROn",
"patronnés" => "patRone",
"patronnesse" => "patRonEs",
"patronnesses" => "patRonEs",
"patrons" => "patR§",
"patronyme" => "patRonim",
"patronymes" => "patRonim",
"patronymique" => "patRonimik",
"patronymiques" => "patRonimik",
"patrouilla" => "patRuja",
"patrouillaient" => "patRujE",
"patrouillais" => "patRujE",
"patrouillait" => "patRujE",
"patrouillant" => "patRuj@",
"patrouille" => "patRuj",
"patrouillé" => "patRuje",
"patrouillée" => "patRuje",
"patrouillées" => "patRuje",
"patrouillent" => "patRuj",
"patrouiller" => "patRuje",
"patrouillerai" => "patRuj°RE",
"patrouilleras" => "patRuj°Ra",
"patrouillerez" => "patRuj°Re",
"patrouilleront" => "patRuj°R§",
"patrouilles" => "patRuj",
"patrouilleur" => "patRuj9R",
"patrouilleurs" => "patRuj9R",
"patrouillez" => "patRuje",
"patrouilliez" => "patRuje",
"patrouillions" => "patRuj§",
"patte" => "pat",
"pattée" => "pate",
"pattemouille" => "pat°muj",
"pattemouilles" => "pat°muj",
"pattern" => "pat9Rn",
"pattes" => "pat",
"pattu" => "paty",
"pattus" => "paty",
"pâturage" => "patyRaZ",
"pâturages" => "patyRaZ",
"pâturaient" => "patyRE",
"pâture" => "patyR",
"pâturé" => "patyRe",
"pâturent" => "patyR",
"pâturer" => "patyRe",
"pâtures" => "patyR",
"pâturin" => "patyR5",
"paturon" => "patyR§",
"paturons" => "patyR§",
"pauchouse" => "poSuz",
"pauline" => "polin",
"paulinienne" => "polinjEn",
"paulownias" => "polonja",
"pauma" => "poma",
"paumais" => "pomE",
"paumait" => "pomE",
"paumant" => "pom@",
"paume" => "pom",
"paumé" => "pome",
"paumée" => "pome",
"paumées" => "pome",
"paumelle" => "pomEl",
"paumelles" => "pomEl",
"paument" => "pom",
"paumer" => "pome",
"paumes" => "pom",
"paumés" => "pome",
"paupérisation" => "popeRizasj§",
"paupérise" => "popeRiz",
"paupérisme" => "popeRizm",
"paupière" => "popjER",
"paupières" => "popjER",
"paupiette" => "popjEt",
"paupiettes" => "popjEt",
"pause" => "poz",
"pause-café" => "pozkafe",
"pauser" => "poze",
"pauses" => "poz",
"pauses-café" => "pozkafe",
"pauses-repas" => "pozR°pa",
"pausez" => "poze",
"pauvre" => "povR",
"pauvrement" => "povR°m@",
"pauvres" => "povR",
"pauvresse" => "povREs",
"pauvresses" => "povREs",
"pauvret" => "povRE",
"pauvreté" => "povR°te",
"pauvretés" => "povR°te",
"pauvrets" => "povRE",
"pauvrette" => "povREt",
"pauvrettes" => "povREt",
"pavage" => "pavaZ",
"pavait" => "pavE",
"pavana" => "pavana",
"pavanaient" => "pavanE",
"pavanait" => "pavanE",
"pavanant" => "pavan@",
"pavane" => "pavan",
"pavané" => "pavane",
"pavanent" => "pavan",
"pavaner" => "pavane",
"pavanera" => "pavan°Ra",
"pavanerez" => "pavan°Re",
"pavanes" => "pavan",
"pavanons" => "pavan§",
"pave" => "pav",
"pavé" => "pave",
"pavée" => "pave",
"pavées" => "pave",
"pavement" => "pav°m@",
"pavements" => "pav°m@",
"paver" => "pave",
"pavés" => "pave",
"paveton" => "pav°t§",
"pavetons" => "pav°t§",
"paveur" => "pav9R",
"paveurs" => "pav9R",
"pavez" => "pave",
"pavillon" => "pavij§",
"pavillonnaire" => "pavijonER",
"pavillonnaires" => "pavijonER",
"pavillons" => "pavij§",
"pavlovien" => "pavlOvj5",
"pavlovienne" => "pavlOvjEn",
"pavois" => "pavwa",
"pavoisa" => "pavwaza",
"pavoisaient" => "pavwazE",
"pavoisait" => "pavwazE",
"pavoise" => "pavwaz",
"pavoisé" => "pavwaze",
"pavoisée" => "pavwaze",
"pavoisées" => "pavwaze",
"pavoisement" => "pavwaz°m@",
"pavoisent" => "pavwaz",
"pavoiser" => "pavwaze",
"pavoisera" => "pavwaz°Ra",
"pavoiseraient" => "pavwaz°RE",
"pavoisés" => "pavwaze",
"pavot" => "pavo",
"pavots" => "pavo",
"pax americana" => "paksameRikana",
"paxon" => "paks§",
"paya" => "peja",
"payable" => "pEjabl",
"payables" => "pEjabl",
"payai" => "pejE",
"payaient" => "pejE",
"payais" => "pejE",
"payait" => "pejE",
"payâmes" => "pejam",
"payant" => "pEj@",
"payante" => "pEj@t",
"payantes" => "pEj@t",
"payants" => "pEj@",
"payassent" => "pejas",
"payassiez" => "pejasje",
"payât" => "peja",
"paye" => "pEj",
"payé" => "peje",
"payée" => "peje",
"payées" => "peje",
"payement" => "pEjm@",
"payements" => "pEjm@",
"payent" => "pej",
"payer" => "peje",
"payera" => "pej°Ra",
"payerai" => "pej°RE",
"payeraient" => "pej°RE",
"payerais" => "pej°RE",
"payerait" => "pej°RE",
"payeras" => "pej°Ra",
"payèrent" => "pejER",
"payerez" => "pej°Re",
"payeriez" => "pej°Rje",
"payerons" => "pej°R§",
"payeront" => "pej°R§",
"payes" => "pej",
"payés" => "peje",
"payeur" => "pEj9R",
"payeurs" => "pEj9R",
"payez" => "peje",
"payiez" => "pEje",
"payions" => "pejj§",
"payons" => "pej§",
"pays" => "pei",
"paysage" => "peizaZ",
"paysagé" => "peizaZe",
"paysager" => "peizaZe",
"paysages" => "peizaZ",
"paysagés" => "peizaZe",
"paysagiste" => "peizaZist",
"paysagistes" => "peizaZist",
"paysan" => "peiz@",
"paysanne" => "peizan",
"paysannerie" => "peizan°Ri",
"paysannes" => "peizan",
"paysans" => "peiz@",
"payse" => "peiz",
"pc" => "pese",
"pchitt" => "pSit",
"péage" => "peaZ",
"péages" => "peaZ",
"péagiste" => "peaZist",
"péan" => "pe@",
"peanuts" => "pin9ts",
"peau" => "po",
"peau-rouge" => "poRuZ",
"peaucier" => "posje",
"peauciers" => "posje",
"peaufina" => "pofina",
"peaufinage" => "pofinaZ",
"peaufinait" => "pofinE",
"peaufinant" => "pofin@",
"peaufiné" => "pofine",
"peaufinée" => "pofine",
"peaufiner" => "pofine",
"peaufinés" => "pofine",
"peausserie" => "pos°Ri",
"peausseries" => "pos°Ri",
"peaussier" => "posje",
"peaux" => "po",
"peaux-rouges" => "poRuZ",
"pébroc" => "pebROk",
"pébroque" => "pebROk",
"pébroques" => "pebROk",
"pec" => "pEk",
"pécan" => "pek@",
"pécari" => "pekaRi",
"pécaris" => "pekaRi",
"peccable" => "pEkabl",
"peccadille" => "pekadij",
"peccadilles" => "pekadij",
"peccata" => "pekata",
"peccavi" => "pekavi",
"pêcha" => "pESa",
"pêchaient" => "pESE",
"péchais" => "peSE",
"pêchais" => "pESE",
"péchait" => "peSE",
"pêchait" => "pESE",
"péchant" => "peS@",
"pêchant" => "pES@",
"pèche" => "pES",
"pêche" => "pES",
"péché" => "peSe",
"pêché" => "peSe",
"pêchée" => "peSe",
"pêchées" => "peSe",
"pèchent" => "pES",
"pêchent" => "pES",
"pécher" => "peSe",
"pêcher" => "peSe",
"pêchera" => "pES°Ra",
"pécherai" => "peS°RE",
"pécherais" => "peS°RE",
"pêcherais" => "pES°RE",
"pécherait" => "peS°RE",
"pêcheras" => "pES°Ra",
"pécheresse" => "peS°REs",
"pécheresses" => "peS°REs",
"pêcherie" => "pES°Ri",
"pêcheries" => "pES°Ri",
"pêcherons" => "pES°R§",
"pêchers" => "peSe",
"pêches" => "pES",
"péchés" => "peSe",
"pêchés" => "peSe",
"pécheur" => "peS9R",
"pêcheur" => "pES9R",
"pécheurs" => "peS9R",
"pêcheurs" => "pES9R",
"pêcheuse" => "pES2z",
"pêcheuses" => "pES2z",
"péchez" => "peSe",
"pêchez" => "pESe",
"pêchions" => "pESj§",
"péchons" => "peS§",
"pecnots" => "pEkno",
"pécore" => "pekOR",
"pécores" => "pekOR",
"pecorino" => "p°koRino",
"pectoral" => "pEktoRal",
"pectorale" => "pEktoRal",
"pectorales" => "pEktoRal",
"pectoraux" => "pEktoRo",
"pécule" => "pekyl",
"pécules" => "pekyl",
"pécune" => "pekyn",
"pécuniaire" => "pekynjER",
"pécuniairement" => "pekynjER°m@",
"pécuniaires" => "pekynjER",
"pécunieux" => "pekynj2",
"pédagogie" => "pedagoZi",
"pédagogique" => "pedagoZik",
"pédagogiques" => "pedagoZik",
"pédagogue" => "pedagOg",
"pédagogues" => "pedagOg",
"pédala" => "pedala",
"pédalage" => "pedalaZ",
"pédalai" => "pedalE",
"pédalaient" => "pedalE",
"pédalais" => "pedalE",
"pédalait" => "pedalE",
"pédalant" => "pedal@",
"pédale" => "pedal",
"pédalé" => "pedale",
"pédalées" => "pedale",
"pédalent" => "pedal",
"pédaler" => "pedale",
"pédalerait" => "pedal°RE",
"pédalèrent" => "pedalER",
"pédalerons" => "pedal°R§",
"pédales" => "pedal",
"pédaleur" => "pedal9R",
"pédaleuses" => "pedal2z",
"pédalier" => "pedalje",
"pédaliers" => "pedalje",
"pédalo" => "pedalo",
"pédalos" => "pedalo",
"pédant" => "ped@",
"pédante" => "ped@t",
"pédanterie" => "ped@t°Ri",
"pédanteries" => "ped@t°Ri",
"pédantes" => "ped@t",
"pédantesque" => "ped@tEsk",
"pédantisme" => "ped@tizm",
"pédants" => "ped@",
"pédé" => "pede",
"pédégé" => "pedeZe",
"pédéraste" => "pedeRast",
"pédérastes" => "pedeRast",
"pédérastie" => "pedeRasti",
"pédérastique" => "pedeRastik",
"pédés" => "pede",
"pédestre" => "pedEstR",
"pédestrement" => "pedEstR°m@",
"pédestres" => "pedEstR",
"pédezouille" => "pedzuj",
"pédiatre" => "pedjatR",
"pédiatres" => "pedjatR",
"pédiatrie" => "pedjatRi",
"pédiatrique" => "pedjatRik",
"pédibus" => "pedibys",
"pédicule" => "pedikyl",
"pédicure" => "pedikyR",
"pédicures" => "pedikyR",
"pédicurie" => "pedikyRi",
"pédieuse" => "pedj2z",
"pédieux" => "pedj2",
"pedigree" => "pedigRe",
"pedigrees" => "pedigRe",
"pédologue" => "pedOlOg",
"pédomètre" => "pedomEtR",
"pédoncule" => "ped§kyl",
"pédonculé" => "ped§kyle",
"pédoncules" => "ped§kyl",
"pédophile" => "pedofil",
"pédophiles" => "pedofil",
"pédophilie" => "pedofili",
"pédophiliques" => "pedofilik",
"pédopsychiatre" => "pedopsikjatR",
"pédoque" => "pedOk",
"pedzouille" => "pedzuj",
"pedzouilles" => "pedzuj",
"peeling" => "piliG",
"pégamoïd" => "pegamOid",
"pègre" => "pEgR",
"pégriot" => "pegRijo",
"pégriots" => "pegRijo",
"peigna" => "pENa",
"peignaient" => "pENE",
"peignais" => "pENE",
"peignait" => "pENE",
"peignant" => "pEN@",
"peigne" => "pEN",
"peigné" => "peNe",
"peigne-cul" => "pENky",
"peigne-culs" => "pENky",
"peigne-zizi" => "pENzizi",
"peignée" => "peNe",
"peignées" => "peNe",
"peignent" => "pEN",
"peigner" => "peNe",
"peignerais" => "pEN°RE",
"peignerait" => "pEN°RE",
"peignes" => "pEN",
"peignés" => "peNe",
"peignez" => "pENe",
"peigniez" => "pENe",
"peignions" => "pEN§",
"peignis" => "pENi",
"peignit" => "pENi",
"peignît" => "pENi",
"peignoir" => "pENwaR",
"peignoirs" => "pENwaR",
"peignons" => "pEN§",
"peina" => "pEna",
"peinaient" => "pEnE",
"peinais" => "pEnE",
"peinait" => "pEnE",
"peinant" => "pEn@",
"peinard" => "pEnaR",
"peinarde" => "pEnaRd",
"peinardement" => "pEnaRd°m@",
"peinardes" => "pEnaRd",
"peinards" => "pEnaR",
"peinât" => "pEna",
"peindra" => "p5dRa",
"peindrai" => "p5dRE",
"peindrais" => "p5dRE",
"peindrait" => "p5dRE",
"peindras" => "p5dRa",
"peindre" => "p5dR",
"peine" => "pEn",
"peiné" => "pene",
"peinée" => "pene",
"peinées" => "pEne",
"peinent" => "pEn",
"peiner" => "pene",
"peinera" => "pEn°Ra",
"peinerait" => "pEn°RE",
"peinèrent" => "pEnER",
"peinerez" => "pEn°Re",
"peines" => "pEn",
"peinés" => "pene",
"peineuse" => "pEn2z",
"peinez" => "pEne",
"peinions" => "pEnj§",
"peinons" => "pEn§",
"peins" => "p5",
"peint" => "p5",
"peinte" => "p5t",
"peintes" => "p5t",
"peintre" => "p5tR",
"peintres" => "p5tR",
"peints" => "p5",
"peinture" => "p5tyR",
"peinturé" => "p5tyRe",
"peinturée" => "p5tyRe",
"peintures" => "p5tyR",
"peinturlure" => "p5tyRlyR",
"peinturluré" => "p5tyRlyRe",
"peinturlurée" => "p5tyRlyRe",
"peinturlurées" => "p5tyRlyRe",
"peinturlurent" => "p5tyRlyR",
"peinturlurer" => "p5tyRlyRe",
"peinturlures" => "p5tyRlyR",
"peinturlurés" => "p5tyRlyRe",
"peinturlureur" => "p5tyRlyR9R",
"peinturlureurs" => "p5tyRlyR9R",
"péjoratif" => "peZoRatif",
"péjoratifs" => "peZoRatif",
"péjorative" => "peZoRativ",
"péjorativement" => "peZoRativ°m@",
"péjoratives" => "peZoRativ",
"pékan" => "pek@",
"pékin" => "pek5",
"pékinois" => "pekinwa",
"pékinoise" => "pekinwaz",
"pékins" => "pek5",
"pela" => "p°la",
"pelade" => "p°lad",
"pelades" => "p°lad",
"pelage" => "p°laZ",
"pelages" => "p°laZ",
"pélagique" => "pelaZik",
"pelaient" => "p°lE",
"pelait" => "p°lE",
"pelant" => "p°l@",
"pélasgiques" => "pelasZik",
"pèle" => "pEl",
"pelé" => "p°le",
"pêle-mêle" => "pElmEl",
"pelée" => "p°le",
"pelées" => "p°le",
"pèlent" => "pEl",
"peler" => "p°le",
"pèlerai" => "pEl°RE",
"pèlerin" => "pEl°R5",
"pèlerinage" => "pEl°RinaZ",
"pèlerinages" => "pEl°RinaZ",
"pèlerine" => "pEl°Rin",
"pèlerines" => "pEl°Rin",
"pèlerins" => "pEl°R5",
"pèles" => "pEl",
"pelés" => "p°le",
"pélican" => "pelik@",
"pélicans" => "pelik@",
"pelisse" => "p°lis",
"pelisses" => "p°lis",
"pellagre" => "pelagR",
"pelle" => "pEl",
"pelle-bêche" => "pElbES",
"pelle-pioche" => "pElpjOS",
"pelles" => "pEl",
"pelles-bêches" => "pElbES",
"pelles-pioches" => "pElpjOS",
"pelletage" => "pEl°taZ",
"pelletaient" => "pEl°tE",
"pelletait" => "pEl°tE",
"pelletant" => "pEl°t@",
"pelletée" => "pEl°te",
"pelletées" => "pEl°te",
"pelleter" => "pEl°te",
"pelleterie" => "pElEt°Ri",
"pelleteur" => "pEl°t9R",
"pelleteuse" => "pEl°t2z",
"pelleteuses" => "pEl°t2z",
"pelletiers" => "pEl°tje",
"pellette" => "pElEt",
"pelliculages" => "pElikylaZ",
"pelliculaire" => "pElikylER",
"pellicule" => "pelikyl",
"pelliculé" => "pelikyle",
"pelliculée" => "pelikyle",
"pellicules" => "pelikyl",
"pelloche" => "pElOS",
"pélot" => "pelo",
"pelota" => "p°lota",
"pelotage" => "p°lotaZ",
"pelotages" => "p°lotaZ",
"pelotaient" => "p°lotE",
"pelotais" => "p°lotE",
"pelotait" => "p°lotE",
"pelotant" => "p°lot@",
"pelote" => "p°lOt",
"peloté" => "p°lote",
"pelotée" => "p°lote",
"pelotent" => "p°lOt",
"peloter" => "p°lote",
"peloterai" => "p°lOt°RE",
"peloterait" => "p°lOt°RE",
"pelotes" => "p°lOt",
"pelotés" => "p°lote",
"peloteur" => "p°lOt9R",
"peloteurs" => "p°lot9R",
"peloteuse" => "p°lot2z",
"pelotez" => "p°lote",
"peloton" => "p°lot§",
"pelotonna" => "p°lotona",
"pelotonnai" => "p°lotonE",
"pelotonnaient" => "p°lotonE",
"pelotonnais" => "p°lotonE",
"pelotonnait" => "p°lotonE",
"pelotonnant" => "p°loton@",
"pelotonne" => "p°lotOn",
"pelotonné" => "p°lotone",
"pelotonnée" => "p°lotone",
"pelotonnées" => "p°lotone",
"pelotonnent" => "p°lotOn",
"pelotonner" => "p°lotone",
"pelotonnés" => "p°lotone",
"pelotons" => "p°lot§",
"pelouse" => "p°luz",
"pelouses" => "p°luz",
"peluche" => "p°lyS",
"peluchée" => "p°lySe",
"peluches" => "p°lyS",
"pelucheuse" => "p°lyS2z",
"pelucheuses" => "p°lyS2z",
"pelucheux" => "p°lyS2",
"pelure" => "p°lyR",
"pelures" => "p°lyR",
"pelvien" => "pElvj5",
"pelvienne" => "pElvjEn",
"pelvis" => "pElvis",
"pembina" => "p@bina",
"pemmican" => "pemik@",
"pénal" => "penal",
"pénale" => "penal",
"pénalement" => "penal°m@",
"pénales" => "penal",
"pénalisaient" => "penalizE",
"pénalisation" => "penalizasj§",
"pénalise" => "penaliz",
"pénalisé" => "penalize",
"pénalisée" => "penalize",
"pénaliser" => "penalize",
"pénalisera" => "penaliz°Ra",
"pénaliserai" => "penaliz°RE",
"pénalisés" => "penalize",
"pénaliste" => "penalist",
"pénalistes" => "penalist",
"pénalité" => "penalite",
"pénalités" => "penalite",
"penalties" => "penalti",
"penalty" => "penalti",
"pénard" => "penaR",
"pénarde" => "penaRd",
"pénardement" => "penaRd°m@",
"pénardes" => "penaRd",
"pénards" => "penaR",
"pénates" => "penat",
"penaud" => "p°no",
"penaude" => "p°nod",
"penaudes" => "p°nod",
"penauds" => "p°no",
"pénaux" => "peno",
"pence" => "pEns",
"pencha" => "p@Sa",
"penchai" => "p@SE",
"penchaient" => "p@SE",
"penchais" => "p@SE",
"penchait" => "p@SE",
"penchâmes" => "p@Sam",
"penchant" => "p@S@",
"penchante" => "p@S@t",
"penchants" => "p@S@",
"penchât" => "p@Sa",
"penche" => "p@S",
"penché" => "p@Se",
"penchée" => "p@Se",
"penchées" => "p@Se",
"penchement" => "p@S°m@",
"penchent" => "p@S",
"pencher" => "p@Se",
"penchera" => "p@S°Ra",
"pencherai" => "p@S°RE",
"pencheraient" => "p@S°RE",
"pencherais" => "p@S°RE",
"pencherait" => "p@S°RE",
"pencheras" => "p@S°Ra",
"penchèrent" => "p@SER",
"pencherez" => "p@S°Re",
"pencheriez" => "p@S°Rje",
"pencherons" => "p@S°R§",
"pencheront" => "p@S°R§",
"penches" => "p@S",
"penchés" => "p@Se",
"penchez" => "p@Se",
"penchiez" => "p@Sje",
"penchions" => "p@Sj§",
"penchons" => "p@S§",
"pend" => "p@",
"pendable" => "p@dabl",
"pendables" => "p@dabl",
"pendaient" => "p@dE",
"pendais" => "p@dE",
"pendaison" => "p@dEz§",
"pendaisons" => "p@dEz§",
"pendait" => "p@dE",
"pendant" => "p@d@",
"pendante" => "p@d@t",
"pendantes" => "p@d@t",
"pendants" => "p@d@",
"pendard" => "p@daR",
"pendarde" => "p@daRd",
"pendards" => "p@daR",
"pende" => "p@d",
"pendeloque" => "p@d°lOk",
"pendeloques" => "p@d°lOk",
"pendent" => "p@d",
"pendentif" => "p@d@tif",
"pendentifs" => "p@d@tif",
"penderie" => "p@d°Ri",
"penderies" => "p@d°Ri",
"pendeur" => "p@d9R",
"pendez" => "p@de",
"pendillaient" => "p@dijE",
"pendillait" => "p@dijE",
"pendillant" => "p@dij@",
"pendille" => "p@dij",
"pendirent" => "p@diR",
"pendit" => "p@di",
"pendjabi" => "pEndZabi",
"pendons" => "p@d§",
"pendouillaient" => "p@dujE",
"pendouillait" => "p@dujE",
"pendouillant" => "p@duj@",
"pendouille" => "p@duj",
"pendouillent" => "p@duj",
"pendouiller" => "p@duje",
"pendouilles" => "p@duj",
"pendra" => "p@dRa",
"pendrai" => "p@dRE",
"pendrais" => "p@dRE",
"pendrait" => "p@dRE",
"pendras" => "p@dRa",
"pendre" => "p@dR",
"pendrez" => "p@dRe",
"pendrons" => "p@dR§",
"pendront" => "p@dR§",
"pends" => "p@",
"pendu" => "p@dy",
"pendue" => "p@dy",
"pendues" => "p@dy",
"pendulaire" => "p@dylER",
"pendulait" => "p@dylE",
"pendule" => "p@dyl",
"pendules" => "p@dyl",
"pendulette" => "p@dylEt",
"pendulettes" => "p@dylEt",
"pendus" => "p@dy",
"pêne" => "pEn",
"pénéplaines" => "peneplEn",
"pénétra" => "penetRa",
"pénétrable" => "penetRabl",
"pénétrables" => "penetRabl",
"pénétrai" => "penetRE",
"pénétraient" => "penetRE",
"pénétrais" => "penetRE",
"pénétrait" => "penetRE",
"pénétrâmes" => "penetRam",
"pénétrant" => "penetR@",
"pénétrante" => "penetR@t",
"pénétrantes" => "penetR@t",
"pénétrants" => "penetR@",
"pénétrât" => "penetRa",
"pénétration" => "penetRasj§",
"pénétrations" => "penetRasj§",
"pénètre" => "penEtR",
"pénétré" => "penetRe",
"pénétrée" => "penetRe",
"pénétrées" => "penetRe",
"pénètrent" => "penEtR",
"pénétrer" => "penetRe",
"pénétrera" => "penetR°Ra",
"pénétrerai" => "penetR°RE",
"pénétreraient" => "penetR°RE",
"pénétrerait" => "penetR°RE",
"pénétrèrent" => "penetRER",
"pénétrerons" => "penetR°R§",
"pénétreront" => "penetR°R§",
"pénètres" => "penEtR",
"pénétrés" => "penetRe",
"pénétrez" => "penetRe",
"pénétrions" => "penetRij§",
"pénétrons" => "penetR§",
"pénible" => "penibl",
"péniblement" => "penibl°m@",
"pénibles" => "penibl",
"péniche" => "peniS",
"péniches" => "peniS",
"pénicilline" => "penisilin",
"pénien" => "penj5",
"pénienne" => "penjEn",
"pénil" => "penil",
"péninsulaire" => "pen5sylER",
"péninsulaires" => "pen5sylER",
"péninsule" => "pen5syl",
"péninsules" => "pen5syl",
"pénis" => "penis",
"pénitence" => "penit@s",
"pénitences" => "penit@s",
"pénitencier" => "penit@sje",
"pénitenciers" => "penit@sje",
"pénitent" => "penit@",
"pénitente" => "penit@t",
"pénitentes" => "penit@t",
"pénitentiaire" => "penit@sjER",
"pénitentiaires" => "penit@sjER",
"pénitentielle" => "penit@sjEl",
"pénitents" => "penit@",
"pennage" => "pEnaZ",
"penne" => "pEn",
"pennées" => "pene",
"pennes" => "pEn",
"pennies" => "pEni",
"pennon" => "pEn§",
"pennons" => "pEn§",
"penny" => "peni",
"pénologie" => "penOlOZi",
"pénombre" => "pen§bR",
"pénombres" => "pen§bR",
"penon" => "p°n§",
"pensa" => "p@sa",
"pensable" => "p@sabl",
"pensai" => "p@sE",
"pensaient" => "p@sE",
"pensais" => "p@sE",
"pensait" => "p@sE",
"pensâmes" => "p@sam",
"pensant" => "p@s@",
"pensante" => "p@s@t",
"pensantes" => "p@s@t",
"pensants" => "p@s@",
"pensât" => "p@sa",
"pense" => "p@s",
"pensé" => "p@se",
"pense-bête" => "p@sbEt",
"pense-bêtes" => "p@sbEt",
"pensée" => "p@se",
"pensées" => "p@se",
"pensent" => "p@s",
"penser" => "p@se",
"pensera" => "p@s°Ra",
"penserai" => "p@s°RE",
"penseraient" => "p@s°RE",
"penserais" => "p@s°RE",
"penserait" => "p@s°RE",
"penseras" => "p@s°Ra",
"pensèrent" => "p@sER",
"penserez" => "p@s°Re",
"penseriez" => "p@s°Rje",
"penserions" => "p@s°Rj§",
"penserons" => "p@s°R§",
"penseront" => "p@s°R§",
"penses" => "p@s",
"pensés" => "p@se",
"penseur" => "p@s9R",
"penseurs" => "p@s9R",
"penseuse" => "p@s2z",
"penseuses" => "p@s2z",
"pensez" => "p@se",
"pensiez" => "p@sje",
"pensif" => "p@sif",
"pensifs" => "p@sif",
"pension" => "p@sj§",
"pensionna" => "p@sjona",
"pensionnaire" => "p@sjonER",
"pensionnaires" => "p@sjonER",
"pensionnat" => "p@sjona",
"pensionnats" => "p@sjona",
"pensionné" => "p@sjone",
"pensionner" => "p@sjone",
"pensionnés" => "p@sjone",
"pensions" => "p@sj§",
"pensive" => "p@siv",
"pensivement" => "p@siv°m@",
"pensons" => "p@s§",
"pensum" => "p5sOm",
"pensums" => "p@sOm",
"pentacle" => "p5takl",
"pentacles" => "p5takl",
"pentagonal" => "p5tagOnal",
"pentagone" => "p5tagon",
"pentagones" => "p5tagon",
"pentagramme" => "p5tagRam",
"pentagrammes" => "p5tagRam",
"pentamètre" => "p5tamEtR",
"pentamètres" => "p5tamEtR",
"pentasyllabe" => "p5tasilab",
"pentateuque" => "p5tat2k",
"pentathlon" => "p5tatl§",
"pente" => "p@t",
"pentecôte" => "p@tkot",
"pentecôtiste" => "p@tkotist",
"pentecôtistes" => "p@tkotist",
"pentélique" => "p5telik",
"pentes" => "p@t",
"penthiobarbital" => "p5tjObaRbital",
"penthotal" => "p5total",
"penthouse" => "p@tuz",
"pentothal" => "p5total",
"pentu" => "p@ty",
"pentue" => "p@ty",
"pentues" => "p@ty",
"penture" => "p@tyR",
"pentures" => "p@tyR",
"pentus" => "p@ty",
"pénultième" => "penyltjEm",
"pénurie" => "penyRi",
"pénuries" => "penyRi",
"péon" => "pe§",
"péons" => "pe§",
"people" => "pip9l",
"péottes" => "peOt",
"pep" => "pEp",
"pépé" => "pepe",
"pépée" => "pepe",
"pépées" => "pepe",
"pépère" => "pepER",
"pépères" => "pepER",
"pépés" => "pepe",
"pépètes" => "pepEt",
"pépettes" => "pepEt",
"pépia" => "pepja",
"pépiaient" => "pepjE",
"pépiait" => "pepjE",
"pépiant" => "pepj@",
"pépie" => "pepi",
"pépiement" => "pepim@",
"pépiements" => "pepim@",
"pépient" => "pepi",
"pépier" => "pepje",
"pépiés" => "pepje",
"pépin" => "pep5",
"pépinière" => "pepinjER",
"pépinières" => "pepinjER",
"pépiniériste" => "pepinjeRist",
"pépiniéristes" => "pepinjeRist",
"pépins" => "pep5",
"pépite" => "pepit",
"pépites" => "pepit",
"péplum" => "peplOm",
"péplums" => "peplOm",
"peppermint" => "pEpERmint",
"peps" => "pEps",
"pepsine" => "pEpsin",
"peptide" => "pEptid",
"peptique" => "pEptik",
"péquenaud" => "pEk°no",
"péquenaude" => "pek°nod",
"péquenaudes" => "pEk°nod",
"péquenauds" => "pEk°no",
"péquenot" => "pEk°no",
"péquenots" => "pEk°no",
"péquin" => "pek5",
"péquins" => "pek5",
"perça" => "pERsa",
"perçage" => "pERsaZ",
"perçaient" => "pERsE",
"perçais" => "pERsE",
"perçait" => "pERsE",
"percale" => "pERkal",
"percales" => "pERkal",
"perçant" => "pERs@",
"perçante" => "pERs@t",
"perçantes" => "pERs@t",
"perçants" => "pERs@",
"perçât" => "pERsa",
"perce" => "pERs",
"percé" => "pERse",
"perce-oreille" => "pERsoREj",
"perce-oreilles" => "pERsoREj",
"perce-pierre" => "pERspjER",
"percée" => "pERse",
"percées" => "pERse",
"percement" => "pERs°m@",
"percent" => "pERs",
"percepteur" => "pERsEpt9R",
"percepteurs" => "pERsEpt9R",
"perceptible" => "pERsEptibl",
"perceptibles" => "pERsEptibl",
"perceptif" => "pERsEptif",
"perception" => "pERsEpsj§",
"perceptions" => "pERsEpsj§",
"perceptive" => "pERsEptiv",
"perceptives" => "pERsEptiv",
"perceptrice" => "pERsEptRis",
"perceptuels" => "pERsEptyEl",
"percer" => "pERse",
"percera" => "pERs°Ra",
"percerai" => "pERs°RE",
"percerait" => "pERs°RE",
"percèrent" => "pERsER",
"percerez" => "pERs°Re",
"percés" => "pERse",
"perceur" => "pERs9R",
"perceurs" => "pERs9R",
"perceuse" => "pERs2z",
"perceuses" => "pERs2z",
"percevaient" => "pERs°vE",
"percevais" => "pERs°vE",
"percevait" => "pERs°vE",
"percevant" => "pERs°v@",
"percevez" => "pERs°ve",
"perceviez" => "pERs°vje",
"percevions" => "pERs°vj§",
"percevoir" => "pERs°vwaR",
"percevons" => "pERs°v§",
"percevra" => "pERs°vRa",
"percevrais" => "pERs°vRE",
"percevrait" => "pERs°vRE",
"percevrez" => "pERs°vRe",
"percez" => "pERse",
"percha" => "pERSa",
"perchaient" => "pERSE",
"perchais" => "pERSE",
"perchait" => "pERSE",
"perche" => "pERS",
"perché" => "pERSe",
"perchée" => "pERSe",
"perchées" => "pERSe",
"perchent" => "pERS",
"percher" => "pERSe",
"perchèrent" => "pERSER",
"percheron" => "pERS°R§",
"percheronne" => "pERS°ROn",
"percheronnes" => "pERS°ROn",
"percherons" => "pERS°R§",
"perches" => "pERS",
"perchés" => "pERSe",
"perchettes" => "pERSEt",
"percheurs" => "pERS9R",
"perchiste" => "pERSist",
"perchlorate" => "pERkloRat",
"perchlorique" => "pERklORik",
"perchman" => "pERSman",
"perchmans" => "pERSman",
"perchoir" => "pERSwaR",
"perchoirs" => "pERSwaR",
"percions" => "pERsj§",
"perclus" => "pERkly",
"percluse" => "pERklyz",
"percluses" => "pERklyz",
"perco" => "pERko",
"perçois" => "pERswa",
"perçoit" => "pERswa",
"perçoive" => "pERswav",
"perçoivent" => "pERswav",
"percolateur" => "pERkolat9R",
"percolateurs" => "pERkolat9R",
"percolation" => "pERkOlasj§",
"percoler" => "pERkOle",
"perçons" => "pERs§",
"percos" => "pERko",
"perçu" => "pERsy",
"perçue" => "pERsy",
"perçues" => "pERsy",
"perçurent" => "pERsyR",
"perçus" => "pERsy",
"percussion" => "pERkysj§",
"percussionniste" => "pERkysjonist",
"percussionnistes" => "pERkysjonist",
"percussions" => "pERkysj§",
"perçut" => "pERsy",
"perçût" => "pERsy",
"percuta" => "pERkyta",
"percutait" => "pERkytE",
"percutant" => "pERkyt@",
"percutante" => "pERkyt@t",
"percutantes" => "pERkyt@t",
"percutants" => "pERkyt@",
"percute" => "pERkyt",
"percuté" => "pERkyte",
"percutée" => "pERkyte",
"percutées" => "pERkyte",
"percutent" => "pERkyt",
"percuter" => "pERkyte",
"percuterait" => "pERkyt°RE",
"percutes" => "pERkyt",
"percutés" => "pERkyte",
"percuteur" => "pERkyt9R",
"percuteurs" => "pERkyt9R",
"percutez" => "pERkyte",
"perd" => "pER",
"perdaient" => "pERdE",
"perdais" => "pERdE",
"perdait" => "pERdE",
"perdant" => "pERd@",
"perdante" => "pERd@t",
"perdants" => "pERd@",
"perde" => "pERd",
"perdent" => "pERd",
"perdes" => "pERd",
"perdez" => "pERde",
"perdiez" => "pERdje",
"perdîmes" => "pERdim",
"perdions" => "pERdj§",
"perdirent" => "pERdiR",
"perdis" => "pERdi",
"perdisse" => "pERdis",
"perdit" => "pERdi",
"perdît" => "pERdi",
"perdition" => "pERdisj§",
"perdons" => "pERd§",
"perdra" => "pERdRa",
"perdrai" => "pERdRE",
"perdraient" => "pERdRE",
"perdrais" => "pERdRE",
"perdrait" => "pERdRE",
"perdras" => "pERdRa",
"perdre" => "pERdR",
"perdreau" => "pERdRo",
"perdreaux" => "pERdRo",
"perdrez" => "pERdRe",
"perdriez" => "pERdRije",
"perdrions" => "pERdRij§",
"perdrix" => "pERdRi",
"perdrons" => "pERdR§",
"perdront" => "pERdR§",
"perds" => "pER",
"perdu" => "pERdy",
"perdue" => "pERdy",
"perdues" => "pERdy",
"perdurable" => "pERdyRabl",
"perdurait" => "pERdyRE",
"perdure" => "pERdyR",
"perduré" => "pERdyRe",
"perdurent" => "pERdyR",
"perdurer" => "pERdyRe",
"perdurera" => "pERdyR°Ra",
"perdus" => "pERdy",
"père" => "pER",
"pérégrinant" => "peRegRin@",
"pérégrination" => "peRegRinasj§",
"pérégrinations" => "peRegRinasj§",
"pérégrine" => "peRegRin",
"pérégriner" => "peRegRine",
"pérégrines" => "peRegRin",
"péremptoire" => "peR@ptwaR",
"péremptoirement" => "peR@ptwaR°m@",
"péremptoires" => "peR@ptwaR",
"pérenne" => "peREn",
"pérennes" => "peREn",
"pérennise" => "peREniz",
"pérennité" => "peRenite",
"péréquation" => "peRekwasj§",
"péréquations" => "peRekwasj§",
"pères" => "pER",
"perestroïka" => "peREstRoika",
"perfectibilité" => "pERfEktibilite",
"perfectible" => "pERfEktibl",
"perfectibles" => "pERfEktibl",
"perfection" => "pERfEksj§",
"perfectionna" => "pERfEksjona",
"perfectionnaient" => "pERfEksjonE",
"perfectionnais" => "pERfEksjonE",
"perfectionnait" => "pERfEksjonE",
"perfectionnant" => "pERfEksjon@",
"perfectionne" => "pERfEksjOn",
"perfectionné" => "pERfEksjone",
"perfectionnée" => "pERfEksjone",
"perfectionnées" => "pERfEksjone",
"perfectionnement" => "pERfEksjOn°m@",
"perfectionnements" => "pERfEksjOn°m@",
"perfectionnent" => "pERfEksjOn",
"perfectionner" => "pERfEksjone",
"perfectionnerais" => "pERfEksjOn°RE",
"perfectionnèrent" => "pERfEksjonER",
"perfectionnés" => "pERfEksjone",
"perfectionnions" => "pERfEksjonj§",
"perfectionnisme" => "pERfEksjonizm",
"perfectionniste" => "pERfEksjonist",
"perfectionnistes" => "pERfEksjonist",
"perfections" => "pERfEksj§",
"perfecto" => "pERfEkto",
"perfectos" => "pERfEkto",
"perfide" => "pERfid",
"perfidement" => "pERfid°m@",
"perfides" => "pERfid",
"perfidie" => "pERfidi",
"perfidies" => "pERfidi",
"perfora" => "pERfoRa",
"perforage" => "pERfoRaZ",
"perforait" => "pERfoRE",
"perforant" => "pERfoR@",
"perforante" => "pERfoR@t",
"perforantes" => "pERfoR@t",
"perforants" => "pERfoR@",
"perforateur" => "pERfoRat9R",
"perforation" => "pERfoRasj§",
"perforations" => "pERfoRasj§",
"perforatrice" => "pERfoRatRis",
"perfore" => "pERfOR",
"perforé" => "pERfoRe",
"perforée" => "pERfoRe",
"perforées" => "pERfoRe",
"perforer" => "pERfoRe",
"perforera" => "pERfoR°Ra",
"perforés" => "pERfoRe",
"perforeuse" => "pERfoR2z",
"perforez" => "pERfoRe",
"perforions" => "pERfoRj§",
"performance" => "pERfORm@s",
"performances" => "pERfORm@s",
"performant" => "pERfORm@",
"performante" => "pERfORm@t",
"performantes" => "pERfORm@t",
"performants" => "pERfORm@",
"performer" => "pERfORm9R",
"perfuse" => "pERfyz",
"perfusé" => "pERfyze",
"perfuser" => "pERfyze",
"perfusion" => "pERfyzj§",
"perfusions" => "pERfyzj§",
"pergélisol" => "pERZelisOl",
"pergola" => "pERgola",
"péri" => "peRi",
"péricarde" => "peRikaRd",
"péricardique" => "peRikaRdik",
"péricardite" => "peRikaRdit",
"péricarpe" => "peRikaRp",
"périclita" => "peRiklita",
"périclitait" => "peRiklitE",
"périclitant" => "peRiklit@",
"périclité" => "peRiklite",
"périclitent" => "peRiklit",
"péricliter" => "peRiklite",
"périclitèrent" => "peRiklitER",
"péridurale" => "peRidyRal",
"périe" => "peRi",
"périf" => "peRif",
"périgée" => "peRiZe",
"périgourdin" => "peRiguRd5",
"périgourdine" => "peRiguRdin",
"périgourdins" => "peRiguRd5",
"péril" => "peRil",
"périlleuse" => "peRij2z",
"périlleusement" => "peRij2z°m@",
"périlleuses" => "peRij2z",
"périlleux" => "peRij2",
"périls" => "peRil",
"périme" => "peRim",
"périmé" => "peRime",
"périmée" => "peRime",
"périmées" => "peRime",
"périment" => "peRim",
"périmer" => "peRime",
"périmés" => "peRime",
"périmètre" => "peRimEtR",
"périmètres" => "peRimEtR",
"périnée" => "peRine",
"période" => "peRjOd",
"périodes" => "peRjOd",
"périodicité" => "peRjodisite",
"périodique" => "peRjodik",
"périodiquement" => "peRjodik°m@",
"périodiques" => "peRjodik",
"péripatéticiennes" => "peRipatetisjEn",
"péripétie" => "peRipesi",
"péripéties" => "peRipesi",
"périph" => "peRif",
"périphérie" => "peRifeRi",
"périphéries" => "peRifeRi",
"périphérique" => "peRifeRik",
"périphériques" => "peRifeRik",
"périphrase" => "peRifRaz",
"périphrases" => "peRifRaz",
"périple" => "peRipl",
"périples" => "peRipl",
"périr" => "peRiR",
"périra" => "peRiRa",
"périrais" => "peRiRE",
"périrait" => "peRiRE",
"périras" => "peRiRa",
"périrent" => "peRiR",
"périrez" => "peRiRe",
"péririez" => "peRiRje",
"périrons" => "peRiR§",
"périront" => "peRiR§",
"péris" => "peRi",
"périscolaire" => "peRiskOlER",
"périscope" => "peRiskOp",
"périscopes" => "peRiskOp",
"périscopique" => "peRiskopik",
"périssable" => "peRisabl",
"périssables" => "peRisabl",
"périssaient" => "peRisE",
"périssait" => "peRisE",
"périssant" => "peRis@",
"périsse" => "peRis",
"périssent" => "peRis",
"périssez" => "peRise",
"périssodactyle" => "peRisodaktil",
"périssoire" => "peRiswaR",
"périssoires" => "peRiswaR",
"périssons" => "peRis§",
"péristaltique" => "peRistaltik",
"péristaltiques" => "peRistaltik",
"péristaltisme" => "peRistaltism",
"péristyle" => "peRistil",
"périt" => "peRi",
"pérît" => "peRi",
"péritoine" => "peRitwan",
"péritonéal" => "peRitOneal",
"péritonéale" => "peRitoneal",
"péritonite" => "peRitonit",
"périurbaines" => "peRjoRbEn",
"perla" => "pERla",
"perlaient" => "pERlE",
"perlait" => "pERlE",
"perlant" => "pERl@",
"perle" => "pERl",
"perlé" => "pERle",
"perlée" => "pERle",
"perlées" => "pERle",
"perlent" => "pERl",
"perler" => "pERle",
"perlèrent" => "pERlER",
"perleront" => "pERl°R§",
"perles" => "pERl",
"perlés" => "pERle",
"perlière" => "pERljER",
"perlières" => "pERljER",
"perlimpinpin" => "pERl5p5p5",
"perlot" => "pERlo",
"perlots" => "pERlo",
"perlouse" => "pERluz",
"perlouses" => "pERluz",
"perlouze" => "pERluz",
"perlouzes" => "pERluz",
"perm" => "pERm",
"permafrost" => "pERmafRost",
"permalloy" => "pERmalOj",
"permane" => "pERman",
"permanence" => "pERman@s",
"permanences" => "pERman@s",
"permanent" => "pERman@",
"permanente" => "pERman@t",
"permanenté" => "pERman@te",
"permanentée" => "pERman@te",
"permanenter" => "pERman@te",
"permanentes" => "pERman@t",
"permanentés" => "pERman@te",
"permanents" => "pERman@",
"permanganate" => "pERm@ganat",
"perme" => "pERm",
"perméabilité" => "pERmeabilite",
"perméable" => "pERmeabl",
"perméables" => "pERmeabl",
"permes" => "pERm",
"permet" => "pERmE",
"permets" => "pERmE",
"permettaient" => "pERmEtE",
"permettais" => "pERmEtE",
"permettait" => "pERmEtE",
"permettant" => "pERmEt@",
"permette" => "pERmEt",
"permettent" => "pERmEt",
"permettes" => "pERmEt",
"permettez" => "pERmEte",
"permettiez" => "pERmEtje",
"permettions" => "pERmEtj§",
"permettons" => "pERmEt§",
"permettra" => "pERmEtRa",
"permettrai" => "pERmEtRE",
"permettraient" => "pERmEtRE",
"permettrais" => "pERmEtRE",
"permettrait" => "pERmEtRE",
"permettras" => "pERmEtRa",
"permettre" => "pERmEtR",
"permettrez" => "pERmEtRe",
"permettriez" => "pERmEtRije",
"permettrions" => "pERmEtRi§",
"permettrons" => "pERmEtR§",
"permettront" => "pERmEtR§",
"permirent" => "pERmiR",
"permis" => "pERmi",
"permise" => "pERmiz",
"permises" => "pERmiz",
"permissent" => "pERmis",
"permissifs" => "pERmisif",
"permission" => "pERmisj§",
"permissionnaire" => "pERmisjonER",
"permissionnaires" => "pERmisjonER",
"permissions" => "pERmisj§",
"permissive" => "pERmisiv",
"permissivité" => "pERmisivite",
"permit" => "pERmi",
"permît" => "pERmi",
"permutant" => "pERmyt@",
"permutation" => "pERmytasj§",
"permutations" => "pERmytasj§",
"permute" => "pERmyt",
"permuté" => "pERmyte",
"permutent" => "pERmyt",
"permuter" => "pERmyte",
"permutèrent" => "pERmytER",
"pernicieuse" => "pERnisj2z",
"pernicieuses" => "pERnisj2z",
"pernicieux" => "pERnisj2",
"pernod" => "pERno",
"pernods" => "pERno",
"pérodictique" => "peRodiktik",
"péroné" => "peRone",
"péronés" => "peRone",
"péroniste" => "peROnist",
"péronnelle" => "peRonEl",
"pérorais" => "peRoRE",
"péroraison" => "peRoREz§",
"péroraisons" => "peRoREz§",
"pérorait" => "peRoRE",
"pérorant" => "peRoR@",
"pérore" => "peROR",
"pérorer" => "peRoRe",
"péroreur" => "peRoR9R",
"pérorons" => "peRoR§",
"pérot" => "peRo",
"pérou" => "peRu",
"peroxydase" => "pEROksidaz",
"peroxyde" => "peROksid",
"peroxydé" => "pEROkside",
"perpendiculaire" => "pERp@dikylER",
"perpendiculairement" => "pERp@dikylER°m@",
"perpendiculaires" => "pERp@dikylER",
"perpète" => "pERpEt",
"perpétra" => "pERpetRa",
"perpétrait" => "pERpetRE",
"perpétration" => "pERpetRasj§",
"perpétré" => "pERpetRe",
"perpétrée" => "pERpetRe",
"perpétrées" => "pERpetRe",
"perpètrent" => "pERpEtR",
"perpétrer" => "pERpetRe",
"perpètres" => "pERpEtR",
"perpétrés" => "pERpetRe",
"perpétrons" => "pERpetR§",
"perpette" => "pERpEt",
"perpétua" => "pERpet8a",
"perpétuaient" => "pERpet8E",
"perpétuait" => "pERpet8E",
"perpétuant" => "pERpet8@",
"perpétuation" => "pERpet8asj§",
"perpétue" => "pERpety",
"perpétué" => "pERpet8e",
"perpétuée" => "pERpet8e",
"perpétuel" => "pERpet8El",
"perpétuelle" => "pERpet8El",
"perpétuellement" => "pERpet8El°m@",
"perpétuelles" => "pERpet8El",
"perpétuels" => "pERpet8El",
"perpétuent" => "pERpety",
"perpétuer" => "pERpet8e",
"perpétuera" => "pERpetyRa",
"perpétuerait" => "pERpetyRE",
"perpétués" => "pERpet8e",
"perpétuité" => "pERpet8ite",
"perpétuités" => "pERpet8ite",
"perpignan" => "pERpiN@",
"perplexe" => "pERplEks",
"perplexes" => "pERplEks",
"perplexité" => "pERplEksite",
"perplexités" => "pERplEksite",
"perquise" => "pERkiz",
"perquisition" => "pERkizisj§",
"perquisitionne" => "pERkizisjOn",
"perquisitionné" => "pERkizisjone",
"perquisitionnent" => "pERkizisjOn",
"perquisitionner" => "pERkizisjone",
"perquisitionnera" => "pERkizisjOn°Ra",
"perquisitions" => "pERkizisj§",
"perré" => "pERe",
"perrés" => "pERe",
"perrier" => "pERje",
"perrières" => "pERjER",
"perron" => "pER§",
"perrons" => "pER§",
"perroquet" => "pERokE",
"perroquets" => "pERokE",
"perruche" => "pERyS",
"perruches" => "pERyS",
"perruque" => "pERyk",
"perruques" => "pERyk",
"perruquier" => "pERykje",
"perruquière" => "pERykjER",
"perruquiers" => "pERykje",
"pers" => "pER",
"persan" => "pERs@",
"persane" => "pERsan",
"persanes" => "pERsan",
"persans" => "pERs@",
"perse" => "pERs",
"persécutaient" => "pERsekytE",
"persécutait" => "pERsekytE",
"persécutant" => "pERsekyt@",
"persécute" => "pERsekyt",
"persécuté" => "pERsekyte",
"persécutée" => "pERsekyte",
"persécutées" => "pERsekyte",
"persécutent" => "pERsekyt",
"persécuter" => "pERsekyte",
"persécuteraient" => "pERsekyt°RE",
"persécuterez" => "pERsekyt°Re",
"persécutes" => "pERsekyt",
"persécutés" => "pERsekyte",
"persécuteur" => "pERsekyt9R",
"persécuteurs" => "pERsekyt9R",
"persécutez" => "pERsekyte",
"persécution" => "pERsekysj§",
"persécutions" => "pERsekysj§",
"persécutrices" => "pERsekytRis",
"perséides" => "pERseid",
"perses" => "pERs",
"persévéra" => "pERseveRa",
"persévérai" => "pERseveRE",
"persévéraient" => "pERseveRE",
"persévérait" => "pERseveRE",
"persévéramment" => "pERseveRam@",
"persévérance" => "pERseveR@s",
"persévérant" => "pERseveR@",
"persévérante" => "pERseveR@t",
"persévérantes" => "pERseveR@t",
"persévérants" => "pERseveR@",
"persévère" => "pERsevER",
"persévéré" => "pERseveRe",
"persévérer" => "pERseveRe",
"persévérerai" => "pERseveR°RE",
"persévérerait" => "pERseveR°RE",
"persévères" => "pERsevER",
"persévérez" => "pERseveRe",
"persévériez" => "pERseveRje",
"persévérions" => "pERseveRj§",
"persévérons" => "pERseveR§",
"persienne" => "pERsjEn",
"persiennes" => "pERsjEn",
"persifla" => "pERsifla",
"persiflage" => "pERsiflaZ",
"persiflages" => "pERsiflaZ",
"persiflait" => "pERsiflE",
"persifle" => "pERsifl",
"persiflé" => "pERsifle",
"persifler" => "pERsifle",
"persifleur" => "pERsifl9R",
"persifleurs" => "pERsifl9R",
"persifleuse" => "pERsifl2z",
"persil" => "pERsi",
"persillé" => "pERsije",
"persillée" => "pERsije",
"persillées" => "pERsije",
"persique" => "pERsik",
"persista" => "pERsista",
"persistai" => "pERsistE",
"persistaient" => "pERsistE",
"persistais" => "pERsistE",
"persistait" => "pERsistE",
"persistance" => "pERsist@s",
"persistant" => "pERsist@",
"persistante" => "pERsist@t",
"persistantes" => "pERsist@t",
"persistants" => "pERsist@",
"persiste" => "pERsist",
"persisté" => "pERsiste",
"persistent" => "pERsist",
"persister" => "pERsiste",
"persistera" => "pERsist°Ra",
"persisterai" => "pERsist°RE",
"persisterait" => "pERsist°RE",
"persistèrent" => "pERsistER",
"persisteriez" => "pERsist°Rje",
"persistes" => "pERsist",
"persistez" => "pERsiste",
"persistions" => "pERsistj§",
"persistons" => "pERsist§",
"perso" => "pERso",
"persona grata" => "pERsonagRata",
"persona non grata" => "pERsonan§gRata",
"personnage" => "pERsonaZ",
"personnage-clé" => "pERsonaZkle",
"personnages" => "pERsonaZ",
"personnalisaient" => "pERsonalizE",
"personnalisation" => "pERsonalizasj§",
"personnalise" => "pERsonaliz",
"personnalisé" => "pERsonalize",
"personnalisée" => "pERsonalize",
"personnalisées" => "pERsonalize",
"personnalisent" => "pERsonaliz",
"personnaliser" => "pERsonalize",
"personnalisez" => "pERsonalize",
"personnalisme" => "pERsonalizm",
"personnalisons" => "pERsonaliz§",
"personnalité" => "pERsonalite",
"personnalités" => "pERsonalite",
"personne" => "pERsOn",
"personnel" => "pERsonEl",
"personnelle" => "pERsonEl",
"personnellement" => "pERsonEl°m@",
"personnelles" => "pERsonEl",
"personnels" => "pERsonEl",
"personnes" => "pERsOn",
"personnifiaient" => "pERsonifjE",
"personnifiait" => "pERsonifjE",
"personnifiant" => "pERsonifj@",
"personnification" => "pERsonifikasj§",
"personnifications" => "pERsonifikasj§",
"personnifie" => "pERsonifi",
"personnifié" => "pERsonifje",
"personnifiée" => "pERsonifje",
"personnifier" => "pERsonifje",
"persos" => "pERso",
"perspective" => "pERspEktiv",
"perspectives" => "pERspEktiv",
"perspicace" => "pERspikas",
"perspicaces" => "pERspikas",
"perspicacité" => "pERspikasite",
"perspiration" => "pERspiRasj§",
"persuada" => "pERs8ada",
"persuadai" => "pERs8adE",
"persuadaient" => "pERs8adE",
"persuadais" => "pERs8adE",
"persuadait" => "pERs8adE",
"persuadant" => "pERs8ad@",
"persuade" => "pERs8ad",
"persuadé" => "pERs8ade",
"persuadée" => "pERs8ade",
"persuadées" => "pERs8ade",
"persuadent" => "pERs8ad",
"persuader" => "pERs8ade",
"persuadera" => "pERs8ad°Ra",
"persuaderai" => "pERs8ad°RE",
"persuaderais" => "pERs8ad°RE",
"persuaderait" => "pERs8ad°RE",
"persuaderas" => "pERsyad°Ra",
"persuadèrent" => "pERs8adER",
"persuaderez" => "pERs8ad°Re",
"persuaderons" => "pERsyad°R§",
"persuadés" => "pERs8ade",
"persuadez" => "pERsyade",
"persuadiez" => "pERsyadje",
"persuadons" => "pERs8ad§",
"persuasif" => "pERs8azif",
"persuasifs" => "pERs8azif",
"persuasion" => "pERs8azj§",
"persuasive" => "pERs8aziv",
"persuasives" => "pERs8aziv",
"perte" => "pERt",
"pertes" => "pERt",
"pertinemment" => "pERtinam@",
"pertinence" => "pERtin@s",
"pertinent" => "pERtin@",
"pertinente" => "pERtin@t",
"pertinentes" => "pERtin@t",
"pertinents" => "pERtin@",
"pertuis" => "pERt8i",
"pertuisane" => "pERt8izan",
"pertuisanes" => "pERt8izan",
"perturba" => "pERtyRba",
"perturbaient" => "pERtyRbE",
"perturbait" => "pERtyRbE",
"perturbant" => "pERtyRb@",
"perturbante" => "pERtyRb@t",
"perturbants" => "pERtyRb@",
"perturbateur" => "pERtyRbat9R",
"perturbateurs" => "pERtyRbat9R",
"perturbation" => "pERtyRbasj§",
"perturbations" => "pERtyRbasj§",
"perturbatrice" => "pERtyRbatRis",
"perturbe" => "pERtyRb",
"perturbé" => "pERtyRbe",
"perturbée" => "pERtyRbe",
"perturbées" => "pERtyRbe",
"perturbent" => "pERtyRb",
"perturber" => "pERtyRbe",
"perturbera" => "pERtyRb°Ra",
"perturberait" => "pERtyRb°RE",
"perturberont" => "pERtyRb°R§",
"perturbés" => "pERtyRbe",
"perturbez" => "pERtyRbe",
"péruvien" => "peRyvj5",
"péruvienne" => "peRyvjEn",
"péruviens" => "peRyvj5",
"pervenche" => "pERv@S",
"pervenches" => "pERv@S",
"pervers" => "pERvER",
"perverse" => "pERvERs",
"perversement" => "pERvERs°m@",
"perverses" => "pERvERs",
"perversion" => "pERvERsj§",
"perversions" => "pERvERsj§",
"perversité" => "pERvERsite",
"perverti" => "pERvERti",
"pervertie" => "pERvERti",
"perverties" => "pERvERti",
"pervertir" => "pERvERtiR",
"pervertis" => "pERvERti",
"pervertissaient" => "pERvERtisE",
"pervertissait" => "pERvERtisE",
"pervertissant" => "pERvERtis@",
"pervertisse" => "pERvERtis",
"pervertit" => "pERvERti",
"pesa" => "p2za",
"pesage" => "p2zaZ",
"pesai" => "p2zE",
"pesaient" => "p2zE",
"pesais" => "p2zE",
"pesait" => "p2zE",
"pesamment" => "p2zam@",
"pesant" => "p2z@",
"pesante" => "p2z@t",
"pesantes" => "p2z@t",
"pesanteur" => "p2z@t9R",
"pesanteurs" => "p2z@t9R",
"pesants" => "p2z@",
"pesât" => "p°za",
"pèse" => "pEz",
"pesé" => "p°ze",
"pèse-acide" => "pEzasid",
"pèse-bébé" => "pEzbebe",
"pèse-lettre" => "pEzlEtR",
"pèse-personne" => "pEzpERsOn",
"pèse-personnes" => "pEzpERsOn",
"pesée" => "p°ze",
"pesées" => "p°ze",
"pèsent" => "pEz",
"peser" => "p2ze",
"pèsera" => "pEz°Ra",
"pèserai" => "pEz°RE",
"pèseraient" => "pEz°RE",
"pèserais" => "pEz°RE",
"pèserait" => "pEz°RE",
"pèseras" => "pEz°Ra",
"pesèrent" => "p°zER",
"pèseront" => "pEz°R§",
"pèses" => "pEz",
"pesés" => "p°ze",
"peseta" => "pezeta",
"pesetas" => "pezeta",
"peseurs" => "p2z9R",
"pesez" => "p2ze",
"pesions" => "p2zj§",
"peso" => "pezo",
"peson" => "p2z§",
"pesons" => "p2z§",
"pesos" => "pezOs",
"pessah" => "pesa",
"pessaire" => "pEsER",
"pesse" => "pEs",
"pessimisme" => "pesimizm",
"pessimiste" => "pesimist",
"pessimistes" => "pEsimist",
"pesta" => "pEsta",
"pestaient" => "pEstE",
"pestais" => "pEstE",
"pestait" => "pEstE",
"pestant" => "pEst@",
"peste" => "pEst",
"pesté" => "pEste",
"pestent" => "pEst",
"pester" => "pEste",
"pestes" => "pEst",
"pesteuse" => "pEst2z",
"pestez" => "pEste",
"pesticide" => "pEstisid",
"pesticides" => "pEstisid",
"pestiféré" => "pEstifeRe",
"pestiférée" => "pEstifeRe",
"pestiférées" => "pEstifeRe",
"pestiférés" => "pEstifeRe",
"pestilence" => "pEstil@s",
"pestilences" => "pEstil@s",
"pestilentiel" => "pEstil@sjEl",
"pestilentielle" => "pEstil@sjEl",
"pestilentielles" => "pEstil@sjEl",
"pestilentiels" => "pEstil@sjEl",
"pet" => "pE",
"pet-de-loup" => "pEd°lu",
"pétaient" => "petE",
"pétainiste" => "petEnist",
"pétainistes" => "petEnist",
"pétais" => "petE",
"pétait" => "petE",
"pétale" => "petal",
"pétales" => "petal",
"pétaloïdes" => "petaloid",
"pétanque" => "pet@k",
"pétant" => "pet@",
"pétante" => "pet@t",
"pétantes" => "pet@t",
"pétants" => "pet@",
"pétaradaient" => "petaRadE",
"pétaradait" => "petaRadE",
"pétaradant" => "petaRad@",
"pétaradante" => "petaRad@t",
"pétaradantes" => "petaRad@t",
"pétaradants" => "petaRad@",
"pétarade" => "petaRad",
"pétaradé" => "petaRade",
"pétarader" => "petaRade",
"pétarades" => "petaRad",
"pétard" => "petaR",
"pétarde" => "petaRd",
"pétardier" => "petaRdje",
"pétardière" => "petaRdjER",
"pétards" => "petaR",
"pétase" => "petaz",
"pétasse" => "petas",
"pétassent" => "petas",
"pétasses" => "petas",
"pétaudière" => "petodjER",
"pète" => "pEt",
"pété" => "pete",
"pète-sec" => "pEtsEk",
"pétéchiale" => "peteSjal",
"pétéchie" => "peteSi",
"pétéchies" => "peteSi",
"pétée" => "pete",
"pétées" => "pete",
"pètent" => "pEt",
"péter" => "pete",
"pétera" => "pet°Ra",
"péterai" => "pet°RE",
"péterais" => "pet°RE",
"péterait" => "pet°RE",
"péteras" => "pet°Ra",
"pètes" => "pEt",
"pétés" => "pete",
"pètesec" => "pEtsEk",
"péteur" => "pet9R",
"péteuse" => "pet2z",
"péteux" => "pet2",
"pétez" => "pete",
"pétiez" => "petje",
"pétilla" => "petija",
"pétillaient" => "petijE",
"pétillait" => "petijE",
"pétillant" => "petij@",
"pétillante" => "petij@t",
"pétillantes" => "petij@t",
"pétillants" => "petij@",
"pétille" => "petij",
"pétillé" => "petije",
"pétillement" => "petij°m@",
"pétillements" => "petij°m@",
"pétillent" => "petij",
"pétiller" => "petije",
"pétillèrent" => "petijER",
"pétilles" => "petij",
"pétiole" => "pesjOl",
"petiot" => "p°tjo",
"petiote" => "p°tjOt",
"petiots" => "p°tjo",
"petit" => "p°ti",
"petit-beurre" => "p°tib9R",
"petit-bourgeois" => "p°tibuRZwa",
"petit-cousin" => "p°tikuz5",
"petit-déjeuner" => "p°tideZ9ne",
"petit-fils" => "p°tifis",
"petit-four" => "p°tifuR",
"petit-gris" => "p°tigRi",
"petit-lait" => "p°tilE",
"petit-maître" => "p°timEtR",
"petit-nègre" => "p°tinEgR",
"petit-neveu" => "p°tin°v2",
"petit-salé" => "p°tisale",
"petit-suisse" => "p°tis8is",
"petite" => "p°tit",
"petite-bourgeoise" => "p°titbuRZwaz",
"petite-cousine" => "p°titkuzin",
"petite-fille" => "p°titfij",
"petite-nièce" => "p°titnjEs",
"petitement" => "p°tit°m@",
"petites" => "p°tit",
"petites-bourgeoises" => "p°titbuRZwaz",
"petites-filles" => "p°titfij",
"petitesse" => "p°titEs",
"petitesses" => "p°titEs",
"pétition" => "petisj§",
"pétitionnaires" => "petisjonER",
"pétitionnent" => "petisjOn",
"pétitionner" => "petisjone",
"pétitions" => "petisj§",
"petits" => "p°ti",
"petits-beurre" => "p°tib9R",
"petits-bourgeois" => "p°tibuRZwa",
"petits-déjeuners" => "p°tideZ9ne",
"petits-enfants" => "p°ti@f@",
"petits-fils" => "p°tifis",
"petits-fours" => "p°tifuR",
"petits-gris" => "p°tigRi",
"petits-neveux" => "p°tin°v2",
"petits-pois" => "p°tipwa",
"petits-suisses" => "p°tis8is",
"pétochais" => "petoSE",
"pétochait" => "petoSE",
"pétochard" => "petoSaR",
"pétoche" => "petOS",
"pétoches" => "petOS",
"pétoire" => "petwaR",
"pétoires" => "petwaR",
"pétomane" => "petoman",
"pétomanes" => "petoman",
"peton" => "p°t§",
"pétoncle" => "pet§kl",
"pétoncles" => "pet§kl",
"petons" => "p°t§",
"pétons" => "pet§",
"pétouille" => "petuj",
"pétoulet" => "petulE",
"pétrarquistes" => "petRaRkist",
"pétrée" => "petRe",
"pétrel" => "petREl",
"pétreux" => "petR2",
"pétri" => "petRi",
"pétrie" => "petRi",
"pétries" => "petRi",
"pétrifia" => "petRifja",
"pétrifiaient" => "petRifjE",
"pétrifiais" => "petRifjE",
"pétrifiait" => "petRifjE",
"pétrifiant" => "petRifj@",
"pétrifiante" => "petRifj@t",
"pétrifiantes" => "petRifj@t",
"pétrifiât" => "petRifja",
"pétrification" => "petRifikasj§",
"pétrifie" => "petRifi",
"pétrifié" => "petRifje",
"pétrifiée" => "petRifje",
"pétrifiées" => "petRifje",
"pétrifient" => "petRifi",
"pétrifier" => "petRifje",
"pétrifièrent" => "petRifjER",
"pétrifieront" => "petRifiR§",
"pétrifiés" => "petRifje",
"pétrifiez" => "petRifje",
"pétrin" => "petR5",
"pétrins" => "petR5",
"pétrir" => "petRiR",
"pétrirai" => "petRiRE",
"pétrirent" => "petRiR",
"pétris" => "petRi",
"pétrissage" => "petRisaZ",
"pétrissaient" => "petRisE",
"pétrissait" => "petRisE",
"pétrissant" => "petRis@",
"pétrisse" => "petRis",
"pétrissent" => "petRis",
"pétrisseur" => "petRis9R",
"pétrissez" => "petRise",
"pétrit" => "petRi",
"pétrochimie" => "petRoSimi",
"pétrochimique" => "petRoSimik",
"pétrodollars" => "petRodolaR",
"pétrole" => "petROl",
"pétroles" => "petROl",
"pétrolette" => "petRolEt",
"pétroleuse" => "petRol2z",
"pétroleuses" => "petRol2z",
"pétrolier" => "petRolje",
"pétrolière" => "petRoljER",
"pétrolières" => "petRoljER",
"pétroliers" => "petRolje",
"pétrolifère" => "petRolifER",
"pétrolifères" => "petRolifER",
"petros" => "pEtRo",
"pétrousquin" => "petRusk5",
"pétrus" => "petRy",
"pets" => "pE",
"pets-de-nonne" => "pEd°nOn",
"pétulance" => "petyl@s",
"pétulant" => "petyl@",
"pétulante" => "petyl@t",
"pétulantes" => "petyl@t",
"pétulants" => "petyl@",
"pétunant" => "petyn@",
"pétuné" => "petyne",
"pétuner" => "petyne",
"pétunez" => "petyne",
"pétunia" => "petynja",
"pétunias" => "petynja",
"petzouille" => "pEtzuj",
"petzouilles" => "pEtzuj",
"peu" => "p2",
"peu ou prou" => "p2upRu",
"peuchère" => "p2SER",
"peuh" => "p2",
"peuhl" => "p2l",
"peul" => "p2l",
"peulh" => "p2l",
"peupla" => "p2pla",
"peuplade" => "p2plad",
"peuplades" => "p2plad",
"peuplaient" => "p2plE",
"peuplait" => "p2plE",
"peuplant" => "p2pl@",
"peuple" => "p2pl",
"peuplé" => "p2ple",
"peuplée" => "p2ple",
"peuplées" => "p2ple",
"peuplement" => "p2pl°m@",
"peuplements" => "p2pl°m@",
"peuplent" => "p2pl",
"peupler" => "p2ple",
"peuplera" => "p2pl°Ra",
"peupleraie" => "p2pl°RE",
"peuplerait" => "p2pl°RE",
"peuplèrent" => "p2plER",
"peupleront" => "p2pl°R§",
"peuples" => "p9pl",
"peuplés" => "p2ple",
"peuplier" => "p2plije",
"peupliers" => "p2plije",
"peur" => "p2R",
"peureuse" => "p2R2z",
"peureusement" => "p2R2z°m@",
"peureuses" => "p2R2z",
"peureux" => "p2R2",
"peurs" => "p9R",
"peut" => "p2",
"peut-être" => "p2tEtR",
"peuvent" => "p9v",
"peux" => "p2",
"peyotl" => "pEjOtl",
"pèze" => "pEz",
"pfennig" => "pfenig",
"pfennigs" => "pfenig",
"pff" => "pf",
"pfft" => "pft",
"pfutt" => "pfyt",
"ph" => "peaS",
"phacochère" => "fakoSER",
"phacochères" => "fakoSER",
"phaéton" => "faet§",
"phagocyte" => "fagosit",
"phagocyter" => "fagosite",
"phagocytes" => "fagosit",
"phalange" => "fal@Z",
"phalanges" => "fal@Z",
"phalangettes" => "fal@ZEt",
"phalangine" => "fal@Zin",
"phalangisme" => "fal@Zizm",
"phalangiste" => "fal@Zist",
"phalangistes" => "fal@Zist",
"phalanstère" => "fal@stER",
"phalarope" => "falaROp",
"phalène" => "falEn",
"phalènes" => "falEn",
"phalère" => "falER",
"phallique" => "falik",
"phalliques" => "falik",
"phallo" => "falo",
"phallocentrique" => "falos@tRik",
"phallocrate" => "falokRat",
"phallocratie" => "falokRasi",
"phallocratique" => "falokRatik",
"phallocratiques" => "falokRatik",
"phalloïdes" => "faloid",
"phallologie" => "faloloZi",
"phallophore" => "falofOR",
"phallus" => "falys",
"phanères" => "fanER",
"phanérogames" => "faneRogam",
"phantasme" => "f@tasm",
"phantasmes" => "f@tasm",
"pharamineuses" => "faRamin2z",
"pharamineux" => "faRamin2",
"pharaon" => "faRa§",
"pharaonique" => "faRaonik",
"pharaoniques" => "faRaonik",
"pharaonnes" => "faRaOn",
"pharaons" => "faRa§",
"phare" => "faR",
"phares" => "faR",
"pharisaïque" => "faRizaik",
"pharisaïques" => "faRizaik",
"pharisaïsme" => "faRizaizm",
"pharisaïsmes" => "faRizaizm",
"pharisien" => "faRizj5",
"pharisiens" => "faRizj5",
"pharma" => "faRma",
"pharmaceutique" => "faRmas2tik",
"pharmaceutiques" => "faRmas2tik",
"pharmacie" => "faRmasi",
"pharmacien" => "faRmasj5",
"pharmacienne" => "faRmasjEn",
"pharmaciens" => "faRmasj5",
"pharmacies" => "faRmasi",
"pharmaco" => "faRmako",
"pharmacognosie" => "faRmakognozi",
"pharmacologie" => "faRmakoloZi",
"pharmacologique" => "faRmakOlOZik",
"pharmacomanie" => "faRmakomani",
"pharmacopée" => "faRmakope",
"pharmacothérapie" => "faRmakoteRapi",
"pharyngite" => "faR5Zit",
"pharynx" => "faR5ks",
"phascolome" => "faskOlOm",
"phase" => "faz",
"phases" => "faz",
"phasmes" => "fasm",
"phénate" => "fenat",
"phénicien" => "fenisj5",
"phénicienne" => "fenisjEn",
"phéniciennes" => "fenisjEn",
"phéniciens" => "fenisj5",
"phénique" => "fenik",
"phéniqués" => "fenike",
"phénix" => "feniks",
"phénobarbital" => "fenobaRbital",
"phénol" => "fenOl",
"phénoménal" => "fenomenal",
"phénoménale" => "fenomenal",
"phénoménalement" => "fenOmenal°m@",
"phénoménales" => "fenomenal",
"phénoménaux" => "fenomeno",
"phénomène" => "fenomEn",
"phénomènes" => "fenomEn",
"phénoménologie" => "fenomenoloZi",
"phénoménologique" => "fenOmenOlOZik",
"phénoménologues" => "fenomenolOg",
"phénothiazine" => "fenOtjazin",
"phénotype" => "fenotip",
"phéochromocytome" => "feokROmositom",
"phéromone" => "feRomOn",
"phéromones" => "feRomOn",
"phi" => "fi",
"philanthrope" => "fil@tROp",
"philanthropes" => "fil@tROp",
"philanthropie" => "fil@tRopi",
"philanthropique" => "fil@tRopik",
"philanthropiques" => "fil@tRopik",
"philarète" => "filaREt",
"philatélie" => "filateli",
"philatéliste" => "filatelist",
"philatélistes" => "filatelist",
"philharmonie" => "filaRmOni",
"philharmonique" => "filaRmonik",
"philhellène" => "filElEn",
"philhellènes" => "filElEn",
"philippin" => "filip5",
"philippine" => "filipin",
"philippines" => "filipin",
"philippins" => "filip5",
"philistin" => "filist5",
"philistins" => "filist5",
"philo" => "filo",
"philodendron" => "filod@dR§",
"philodendrons" => "filod@dR§",
"philologie" => "filoloZi",
"philologique" => "filoloZik",
"philologiques" => "filoloZik",
"philologue" => "filolOg",
"philologues" => "filolOg",
"philos" => "filo",
"philosémites" => "filozemit",
"philosémitisme" => "filozemitizm",
"philosophaient" => "filozofE",
"philosophaillerie" => "filozofaj°Ri",
"philosophait" => "filozofE",
"philosophal" => "filOzOfal",
"philosophale" => "filozofal",
"philosophales" => "filozofal",
"philosophant" => "filozof@",
"philosophard" => "filOzOfaR",
"philosophe" => "filozOf",
"philosophé" => "filozofe",
"philosopher" => "filozofe",
"philosophes" => "filozOf",
"philosophie" => "filozofi",
"philosophies" => "filozofi",
"philosophique" => "filozofik",
"philosophiquement" => "filozofik°m@",
"philosophiques" => "filozofik",
"philosophons" => "filozof§",
"philotechnique" => "filotEknik",
"philtre" => "filtR",
"philtres" => "filtR",
"phimosis" => "fimozis",
"phlébite" => "flebit",
"phlébites" => "flebit",
"phlébographie" => "flebOgRafi",
"phlébologue" => "flebOlOg",
"phlébotomie" => "flebOtOmi",
"phlox" => "flOks",
"phobie" => "fobi",
"phobies" => "fobi",
"phobique" => "fobik",
"phobiques" => "fobik",
"phocéenne" => "foseEn",
"phoenix" => "feniks",
"phonatoire" => "fonatwaR",
"phone" => "fon",
"phonèmes" => "fonEm",
"phones" => "fon",
"phonéticien" => "fonetisj5",
"phonétique" => "fonetik",
"phonétiquement" => "fonetik°m@",
"phonétiques" => "fonetik",
"phonique" => "fonik",
"phoniques" => "fonik",
"phono" => "fono",
"phonographe" => "fonogRaf",
"phonographes" => "fonogRaf",
"phonographiques" => "fonogRafik",
"phonologie" => "fonoloZi",
"phonos" => "fono",
"phoque" => "fOk",
"phoques" => "fOk",
"phosgène" => "fOsZEn",
"phosphatase" => "fOsfataz",
"phosphate" => "fOsfat",
"phosphates" => "fOsfat",
"phosphatine" => "fOsfatin",
"phosphène" => "fOsfEn",
"phosphènes" => "fOsfEn",
"phospholipide" => "fOsfolipid",
"phosphore" => "fOsfOR",
"phosphoré" => "fOsfORe",
"phosphorescence" => "fOsfoRes@s",
"phosphorescences" => "fOsfoRes@s",
"phosphorescent" => "fOsfoRes@",
"phosphorescente" => "fOsfoRes@t",
"phosphorescentes" => "fOsfoRes@t",
"phosphorescents" => "fOsfoRes@",
"phosphorylation" => "fOsfORilasj§",
"phot" => "fOt",
"photique" => "fOtik",
"photo" => "foto",
"photo-électrique" => "fOtOelEktRik",
"photo-finish" => "fOtofiniS",
"photo-robot" => "fotoRobo",
"photochimique" => "fOtoSimik",
"photocomposition" => "fotok§pozisj§",
"photoconducteur" => "fOtok§dykt9R",
"photocopie" => "fotokopi",
"photocopié" => "fotokopje",
"photocopiée" => "fotokopje",
"photocopiées" => "fotokopje",
"photocopient" => "fotokopi",
"photocopier" => "fotokopje",
"photocopiera" => "fotokopiRa",
"photocopierai" => "fotokopiRE",
"photocopies" => "fotokopi",
"photocopiés" => "fotokopje",
"photocopieur" => "fotokopj9R",
"photocopieurs" => "fotokopj9R",
"photocopieuse" => "fotokopj2z",
"photocopieuses" => "fotokopj2z",
"photoélectrique" => "fotoelEktRik",
"photogénie" => "fotoZeni",
"photogénique" => "fotoZenik",
"photogéniques" => "fotoZenik",
"photogramme" => "fotogRam",
"photographe" => "fotogRaf",
"photographes" => "fotogRaf",
"photographia" => "fotogRafja",
"photographiable" => "fotogRafjabl",
"photographiaient" => "fotogRafjE",
"photographiais" => "fotogRafjE",
"photographiait" => "fotogRafjE",
"photographiant" => "fotogRafj@",
"photographiât" => "fotogRafja",
"photographie" => "fotogRafi",
"photographié" => "fotogRafje",
"photographiée" => "fotogRafje",
"photographiées" => "fotogRafje",
"photographient" => "fotogRafi",
"photographier" => "fotogRafje",
"photographierai" => "fotogRafiRE",
"photographierait" => "fotogRafiRE",
"photographièrent" => "fotogRafjER",
"photographierions" => "fotogRafiRj§",
"photographierons" => "fotogRafiR§",
"photographieront" => "fotogRafiR§",
"photographies" => "fotogRafi",
"photographiés" => "fotogRafje",
"photographiez" => "fotogRafje",
"photographique" => "fotogRafik",
"photographiques" => "fotogRafik",
"photograveur" => "fotogRav9R",
"photogravure" => "fotogRavyR",
"photojournalisme" => "fOtoZuRnalism",
"photojournaliste" => "fOtoZuRnalist",
"photomaton" => "fotomat§",
"photomatons" => "fotomat§",
"photomicrographie" => "fOtomikRogRafi",
"photomontage" => "fotom§taZ",
"photomontages" => "fotom§taZ",
"photon" => "fOt§",
"photonique" => "fotonik",
"photons" => "fot§",
"photopériodique" => "fotopeRjodik",
"photophobie" => "fOtofObi",
"photopile" => "fotopil",
"photos" => "foto",
"photosensibilité" => "fotos@sibilite",
"photosensible" => "fotos@sibl",
"photosensibles" => "fotos@sibl",
"photostat" => "fOtosta",
"photosynthèse" => "fotos5tEz",
"phototaxie" => "fOtotaksi",
"phototype" => "fOtotip",
"photovoltaïque" => "fotovOltaik",
"phragmites" => "fRagmit",
"phrase" => "fRaz",
"phrasé" => "fRaze",
"phrase-clé" => "fRazkle",
"phrase-robot" => "fRazRobo",
"phrasée" => "fRaze",
"phraséologie" => "fRazeoloZi",
"phraséologies" => "fRazeoloZi",
"phraséologique" => "fRazeoloZik",
"phraser" => "fRaze",
"phrases" => "fRaz",
"phrases-clés" => "fRazkle",
"phraseur" => "fRaz9R",
"phraseurs" => "fRaz9R",
"phréatique" => "fReatik",
"phréatiques" => "fReatik",
"phrénique" => "fRenik",
"phrénologie" => "fRenOlOZi",
"phrénologiste" => "fRenoloZist",
"phrénologistes" => "fRenoloZist",
"phrénologues" => "fRenolOg",
"phrygien" => "fRiZj5",
"phrygiens" => "fRiZj5",
"phtaléine" => "ftalein",
"phtiriasis" => "ftiRjazis",
"phtisie" => "ftizi",
"phtisiologie" => "ftizjoloZi",
"phtisique" => "ftizik",
"phtisiques" => "ftizik",
"phylactère" => "filaktER",
"phylloxera" => "filokseRa",
"phylloxéra" => "filOkseRa",
"phylogenèse" => "filoZ2nEz",
"phylum" => "filOm",
"phynances" => "fin@s",
"physicien" => "fizisj5",
"physicienne" => "fizisjEn",
"physiciennes" => "fizisjEn",
"physiciens" => "fizisj5",
"physico-chimiques" => "fizikoSimik",
"physio" => "fizjo",
"physiologie" => "fizjoloZi",
"physiologies" => "fizjoloZi",
"physiologique" => "fizjoloZik",
"physiologiquement" => "fizjoloZik°m@",
"physiologiques" => "fizjoloZik",
"physiologiste" => "fizjoloZist",
"physionomie" => "fizjonomi",
"physionomies" => "fizjonomi",
"physionomique" => "fizjonomik",
"physionomiste" => "fizjonomist",
"physionomistes" => "fizjonomist",
"physiothérapie" => "fizjoteRapi",
"physique" => "fizik",
"physiquement" => "fizik°m@",
"physiques" => "fizik",
"phytoplancton" => "fitopl@kt§",
"pi" => "pi",
"piaf" => "pjaf",
"piaffa" => "pjafa",
"piaffaient" => "pjafE",
"piaffait" => "pjafE",
"piaffant" => "pjaf@",
"piaffante" => "pjaf@t",
"piaffantes" => "pjaf@t",
"piaffants" => "pjaf@",
"piaffe" => "pjaf",
"piaffé" => "pjafe",
"piaffement" => "pjafm@",
"piaffements" => "pjafm@",
"piaffent" => "pjaf",
"piaffer" => "pjafe",
"piaffes" => "pjaf",
"piafs" => "pjaf",
"piailla" => "pjaja",
"piaillaient" => "pjajE",
"piaillais" => "pjajE",
"piaillait" => "pjajE",
"piaillant" => "pjaj@",
"piaillante" => "pjaj@t",
"piaillantes" => "pjaj@t",
"piaillarde" => "pjajaRd",
"piaillards" => "pjajaR",
"piaille" => "pjaj",
"piaillement" => "pjaj°m@",
"piaillements" => "pjaj°m@",
"piaillent" => "pjaj",
"piailler" => "pjaje",
"piaillèrent" => "pjajER",
"piaillerie" => "pjaj°Ri",
"piailleries" => "pjaj°Ri",
"piailleurs" => "pjaj9R",
"piailleuse" => "pjaj2z",
"pian" => "pj@",
"pianissimo" => "pjanisimo",
"pianissimos" => "pjanisimo",
"pianiste" => "pjanist",
"pianistes" => "pjanist",
"piano" => "pjano",
"piano-bar" => "pjanobaR",
"pianola" => "pjanola",
"pianos" => "pjano",
"pianota" => "pjanota",
"pianotage" => "pjanotaZ",
"pianotaient" => "pjanotE",
"pianotait" => "pjanotE",
"pianotant" => "pjanot@",
"pianote" => "pjanOt",
"pianoté" => "pjanote",
"pianotée" => "pjanote",
"pianoter" => "pjanote",
"pianotèrent" => "pjanotER",
"piastre" => "pjastR",
"piastres" => "pjastR",
"piaula" => "pjola",
"piaulaient" => "pjolE",
"piaulait" => "pjolE",
"piaulant" => "pjol@",
"piaulante" => "pjol@t",
"piaule" => "pjol",
"piaulement" => "pjol°m@",
"piaulements" => "pjol°m@",
"piaulent" => "pjol",
"piauler" => "pjole",
"piaulera" => "pjol°Ra",
"piaulèrent" => "pjolER",
"piaules" => "pjol",
"piauleur" => "pjol9R",
"piaye" => "pjaj",
"piazza" => "pjadza",
"piazzetta" => "pjadzeta",
"pibloque" => "piblOk",
"pic" => "pik",
"pic-vert" => "pivER",
"pica" => "pika",
"picador" => "pikadOR",
"picadors" => "pikadOR",
"picaillon" => "pikaj§",
"picaillons" => "pikaj§",
"picard" => "pikaR",
"picarde" => "pikaRd",
"picardes" => "pikaRd",
"picards" => "pikaR",
"picaresque" => "pikaREsk",
"picaresques" => "pikaREsk",
"picaro" => "pikaRo",
"picassien" => "pikasj5",
"piccolo" => "pikolo",
"piccolos" => "pikolo",
"pichenette" => "piSnEt",
"pichenettes" => "piSnEt",
"pichet" => "piSE",
"pichets" => "piSE",
"pick-up" => "pik9p",
"picker" => "pik9R",
"pickles" => "pik9ls",
"pickpocket" => "pikpokEt",
"pickpockets" => "pikpokEt",
"pico" => "piko",
"picolaient" => "pikolE",
"picolais" => "pikolE",
"picolait" => "pikolE",
"picolant" => "pikol@",
"picole" => "pikOl",
"picolé" => "pikole",
"picolent" => "pikOl",
"picoler" => "pikole",
"picolerait" => "pikOl°RE",
"picoles" => "pikOl",
"picoleur" => "pikol9R",
"picoleurs" => "pikol9R",
"picolez" => "pikole",
"picoliez" => "pikolje",
"picolo" => "pikolo",
"picora" => "pikoRa",
"picoraient" => "pikoRE",
"picorait" => "pikoRE",
"picorant" => "pikoR@",
"picore" => "pikOR",
"picoré" => "pikoRe",
"picorée" => "pikoRe",
"picorées" => "pikoRe",
"picorent" => "pikOR",
"picorer" => "pikoRe",
"picorés" => "pikoRe",
"picoreur" => "pikoR9R",
"picorez" => "pikoRe",
"picot" => "piko",
"picota" => "pikota",
"picotaient" => "pikotE",
"picotait" => "pikotE",
"picotant" => "pikOt@",
"picote" => "pikOt",
"picoté" => "pikote",
"picotées" => "pikote",
"picotement" => "pikOt°m@",
"picotements" => "pikOt°m@",
"picotent" => "pikOt",
"picoter" => "pikote",
"picotin" => "pikot5",
"picotis" => "pikOti",
"picots" => "piko",
"picrate" => "pikRat",
"picrique" => "pikRik",
"pics" => "pik",
"pics-verts" => "pivER",
"picsou" => "piksu",
"picté" => "pikte",
"pictogramme" => "piktogRam",
"pictogrammes" => "piktogRam",
"picton" => "pikt§",
"pictural" => "piktyRal",
"picturale" => "piktyRal",
"picturalement" => "piktyRal°m@",
"picturales" => "piktyRal",
"pidgin" => "pidZin",
"pie" => "pi",
"pie-grièche" => "pigRijES",
"pie-mère" => "pimER",
"pièce" => "pjEs",
"pièces" => "pjEs",
"piécette" => "pjesEt",
"piécettes" => "pjesEt",
"pied" => "pje",
"pied-bot" => "pjebo",
"pied-d'alouette" => "pjedalwEt",
"pied-d'oeuvre" => "pjed9vR",
"pied-de-biche" => "pjed°biS",
"pied-de-poule" => "pjed°pul",
"pied-noir" => "pjenwaR",
"pied-plat" => "pjepla",
"piédestal" => "pjedEstal",
"piédestaux" => "pjedEsto",
"piedmont" => "pjem§",
"piédroit" => "pjedRwa",
"piédroits" => "pjedRwa",
"pieds" => "pje",
"pieds-de-biche" => "pjed°biS",
"pieds-de-coq" => "pjed°kOk",
"pieds-droits" => "pjedRwa",
"pieds-noirs" => "pjenwaR",
"piège" => "pjEZ",
"piégé" => "pjeZe",
"piégeage" => "pjeZaZ",
"piégeages" => "pjeZaZ",
"piégeais" => "pjeZE",
"piégeait" => "pjeZE",
"piégeant" => "pjeZ@",
"piégée" => "pjeZe",
"piégées" => "pjeZe",
"piègent" => "pjEZ",
"piéger" => "pjeZe",
"piégerai" => "pjeZ°RE",
"piégerais" => "pjeZ°RE",
"piégerait" => "pjeZ°RE",
"piégerez" => "pjeZ°Re",
"piégeront" => "pjeZ°R§",
"pièges" => "pjEZ",
"piégés" => "pjeZe",
"piégeur" => "pjeZ9R",
"piégeurs" => "pjeZ9R",
"piégeuse" => "pjeZ2z",
"piégeuses" => "pjeZ2z",
"piégez" => "pjeZe",
"piémont" => "pjem§",
"piémontais" => "pjem§tE",
"piémontaise" => "pjem§tEz",
"pier" => "pjER",
"piercing" => "piRsiG",
"piercings" => "piRsiG",
"piéride" => "pjeRid",
"piérides" => "pjeRid",
"pierraille" => "pjERaj",
"pierrailles" => "pjERaj",
"pierre" => "pjER",
"pierreries" => "pjER°Ri",
"pierres" => "pjER",
"pierreuse" => "pjER2z",
"pierreuses" => "pjeR2z",
"pierreux" => "pjER2",
"pierrier" => "pjeRje",
"pierrière" => "pjERjER",
"pierriers" => "pjeRje",
"pierrot" => "pjERo",
"pierrots" => "pjeRo",
"pierrures" => "pjeRyR",
"pies" => "pi",
"piéta" => "pjeta",
"pietà" => "pjeta",
"piétaille" => "pjetaj",
"piétait" => "pjetE",
"piétant" => "pjet@",
"piète" => "pjEt",
"piété" => "pjete",
"piétement" => "pjEt°m@",
"piètement" => "pjEt°m@",
"piéter" => "pjete",
"piétin" => "pjet5",
"piétina" => "pjetina",
"piétinai" => "pjetinE",
"piétinaient" => "pjetinE",
"piétinais" => "pjetinE",
"piétinait" => "pjetinE",
"piétinant" => "pjetin@",
"piétinante" => "pjetin@t",
"piétine" => "pjetin",
"piétiné" => "pjetine",
"piétinée" => "pjetine",
"piétinées" => "pjetine",
"piétinement" => "pjetin°m@",
"piétinements" => "pjetin°m@",
"piétinent" => "pjetin",
"piétiner" => "pjetine",
"piétinera" => "pjetin°Ra",
"piétinerai" => "pjetin°RE",
"piétinerais" => "pjetin°RE",
"piétinerait" => "pjetin°RE",
"piétinèrent" => "pjetinER",
"piétineront" => "pjetin°R§",
"piétinés" => "pjetine",
"piétinez" => "pjetine",
"piétinons" => "pjetin§",
"piétiste" => "pjetist",
"piéton" => "pjet§",
"piétonne" => "pjetOn",
"piétonnes" => "pjetOn",
"piétonnier" => "pjetonje",
"piétonnière" => "pjetonjER",
"piétonnières" => "pjetonjER",
"piétons" => "pjet§",
"piètre" => "pjEtR",
"piètrement" => "pjEtR°m@",
"piètres" => "pjEtR",
"pieu" => "pj2",
"pieuse" => "pj2z",
"pieusement" => "pj2z°m@",
"pieuses" => "pj2z",
"pieutait" => "pj2tE",
"pieute" => "pj2t",
"pieuté" => "pj2te",
"pieutée" => "pj2te",
"pieuter" => "pj2te",
"pieuterez" => "pj2t°Re",
"pieutes" => "pj2t",
"pieutés" => "pj2te",
"pieutez" => "pj2te",
"pieuvre" => "pj9vR",
"pieuvres" => "pj9vR",
"pieux" => "pj2",
"pif" => "pif",
"pifer" => "pife",
"piffait" => "pifE",
"piffé" => "pife",
"piffer" => "pife",
"piffre" => "pifR",
"piffrer" => "pifRe",
"pifomètre" => "pifomEtR",
"pige" => "piZ",
"pigé" => "piZe",
"pigeais" => "piZE",
"pigeait" => "piZE",
"pigent" => "piZ",
"pigeon" => "piZ§",
"pigeon-voyageur" => "piZ§vwajaZ9R",
"pigeonnant" => "piZon@",
"pigeonnante" => "piZon@t",
"pigeonnants" => "piZon@",
"pigeonne" => "piZOn",
"pigeonné" => "piZone",
"pigeonneau" => "piZono",
"pigeonneaux" => "piZono",
"pigeonner" => "piZone",
"pigeonnier" => "piZonje",
"pigeonniers" => "piZonje",
"pigeons" => "piZ§",
"piger" => "piZe",
"pigera" => "piZ°Ra",
"pigerai" => "piZ°RE",
"pigeraient" => "piZ°RE",
"pigerait" => "piZ°RE",
"pigeras" => "piZ°Ra",
"pigerez" => "piZ°Re",
"piges" => "piZ",
"pigez" => "piZe",
"pigiste" => "piZist",
"pigistes" => "piZist",
"pigment" => "pigm@",
"pigmentaire" => "pigm@tER",
"pigmentation" => "pigm@tasj§",
"pigments" => "pigm@",
"pigne" => "piN",
"pigner" => "piNe",
"pignes" => "piN",
"pignochait" => "piNoSE",
"pignole" => "piNOl",
"pignon" => "piN§",
"pignons" => "piN§",
"pignouf" => "piNuf",
"pignoufs" => "piNuf",
"pila" => "pila",
"pilaf" => "pilaf",
"pilaient" => "pilE",
"pilait" => "pilE",
"pilant" => "pil@",
"pilastre" => "pilastR",
"pilastres" => "pilastR",
"pilchards" => "pilSaR",
"pile" => "pil",
"pilé" => "pile",
"pile-poil" => "pilpwal",
"pilée" => "pile",
"pilées" => "pile",
"pilent" => "pil",
"piler" => "pile",
"piles" => "pil",
"pilés" => "pile",
"pileuse" => "pil2z",
"pileuses" => "pil2z",
"pileux" => "pil2",
"pilier" => "pilje",
"piliers" => "pilje",
"pilifère" => "pilifER",
"pilla" => "pija",
"pillage" => "pijaZ",
"pillages" => "pijaZ",
"pillaient" => "pijE",
"pillais" => "pijE",
"pillait" => "pijE",
"pillant" => "pij@",
"pillard" => "pijaR",
"pillarde" => "pijaRd",
"pillards" => "pijaR",
"pille" => "pij",
"pillé" => "pije",
"pillée" => "pije",
"pillées" => "pije",
"pillent" => "pij",
"piller" => "pije",
"pillera" => "pij°Ra",
"pillerait" => "pij°RE",
"pillèrent" => "pijER",
"pillerons" => "pij°R§",
"pilleront" => "pij°R§",
"pilles" => "pij",
"pillés" => "pije",
"pilleur" => "pij9R",
"pilleurs" => "pij9R",
"pilleuse" => "pij2z",
"pillez" => "pije",
"pilliez" => "pije",
"pillons" => "pij§",
"piloches" => "pilOS",
"pilon" => "pil§",
"pilonnage" => "pilonaZ",
"pilonnages" => "pilonaZ",
"pilonnaient" => "pilonE",
"pilonnait" => "pilonE",
"pilonnant" => "pilon@",
"pilonné" => "pilone",
"pilonnée" => "pilone",
"pilonnées" => "pilone",
"pilonnent" => "pilOn",
"pilonner" => "pilone",
"pilonnera" => "pilOn°Ra",
"pilonnés" => "pilone",
"pilonneurs" => "pilon9R",
"pilonnez" => "pilone",
"pilons" => "pil§",
"pilori" => "piloRi",
"piloris" => "piloRi",
"pilosité" => "pilozite",
"pilot" => "pilo",
"pilota" => "pilota",
"pilotage" => "pilotaZ",
"pilotaient" => "pilotE",
"pilotais" => "pilotE",
"pilotait" => "pilotE",
"pilotant" => "pilot@",
"pilote" => "pilOt",
"piloté" => "pilote",
"pilotée" => "pilote",
"pilotées" => "pilote",
"pilotent" => "pilOt",
"piloter" => "pilote",
"pilotera" => "pilOt°Ra",
"piloterai" => "pilOt°RE",
"piloterait" => "pilOt°RE",
"piloteras" => "pilOt°Ra",
"pilotèrent" => "pilotER",
"piloteront" => "pilOt°R§",
"pilotes" => "pilOt",
"pilotés" => "pilote",
"pilotez" => "pilote",
"pilotiez" => "pilotje",
"pilotin" => "pilOt5",
"pilotis" => "piloti",
"pilou" => "pilu",
"pilsen" => "pilsEn",
"pilule" => "pilyl",
"pilules" => "pilyl",
"pilum" => "pilOm",
"pimbêche" => "p5bES",
"pimbêches" => "p5bES",
"piment" => "pim@",
"pimenta" => "pim@ta",
"pimentait" => "pim@tE",
"pimentant" => "pim@t@",
"pimente" => "pim@t",
"pimenté" => "pim@te",
"pimentée" => "pim@te",
"pimentées" => "pim@te",
"pimentent" => "pim@t",
"pimenter" => "pim@te",
"pimentés" => "pim@te",
"piments" => "pim@",
"pimpant" => "p5p@",
"pimpante" => "p5p@t",
"pimpantes" => "p5p@t",
"pimpants" => "p5p@",
"pimpon" => "p5p§",
"pimpons" => "p5p§",
"pimprenelle" => "p5pR°nEl",
"pimprenelles" => "p5pR°nEl",
"pin" => "p5",
"pin-pon" => "p5p§",
"pin-up" => "pin9p",
"pin's" => "pins",
"pina" => "pina",
"pinacle" => "pinakl",
"pinacles" => "pinakl",
"pinacothèque" => "pinakOtEk",
"pinaillage" => "pinajaZ",
"pinaillait" => "pinajE",
"pinaille" => "pinaj",
"pinaillé" => "pinaje",
"pinailler" => "pinaje",
"pinailles" => "pinaj",
"pinailleur" => "pinaj9R",
"pinard" => "pinaR",
"pinardière" => "pinaRdjER",
"pinardiers" => "pinaRdje",
"pinards" => "pinaR",
"pinasse" => "pinas",
"pinasses" => "pinas",
"pinça" => "p5sa",
"pinçage" => "p5saZ",
"pinçai" => "p5sE",
"pinçaient" => "p5sE",
"pinçais" => "p5sE",
"pinçait" => "p5sE",
"pinçant" => "p5s@",
"pinçard" => "p5saR",
"pince" => "p5s",
"pincé" => "p5se",
"pince-fesses" => "p5sfEs",
"pince-mailles" => "p5smaj",
"pince-monseigneur" => "p5sm§sEN9R",
"pince-nez" => "p5sne",
"pince-sans-rire" => "p5ss@RiR",
"pinceau" => "p5so",
"pinceaux" => "p5so",
"pincée" => "p5se",
"pincées" => "p5se",
"pincement" => "p5s°m@",
"pincements" => "p5s°m@",
"pincent" => "p5s",
"pincer" => "p5se",
"pincera" => "p5s°Ra",
"pincerai" => "p5s°RE",
"pinceras" => "p5s°Ra",
"pincèrent" => "p5sER",
"pincerez" => "p5s°Re",
"pincerons" => "p5s°R§",
"pinces" => "p5s",
"pincés" => "p5se",
"pincette" => "p5sEt",
"pincettes" => "p5sEt",
"pinceur" => "p5s9R",
"pincez" => "p5se",
"pinchart" => "p5SaR",
"pinciez" => "p5sje",
"pincions" => "p5sj§",
"pinçon" => "p5s§",
"pinçons" => "p5s§",
"pinçotait" => "p5sOtE",
"pinçotant" => "p5sot@",
"pinçote" => "p5sOt",
"pinçure" => "p5syR",
"pine" => "pin",
"piné" => "pine",
"pinéal" => "pineal",
"pinéale" => "pineal",
"pinéales" => "pineal",
"pineau" => "pino",
"pinède" => "pinEd",
"pinèdes" => "pinEd",
"piner" => "pine",
"pines" => "pin",
"ping-pong" => "piGp§G",
"pinglot" => "p5glo",
"pinglots" => "p5glo",
"pingouin" => "p5gw5",
"pingouins" => "p5gw5",
"pingre" => "p5gR",
"pingrerie" => "p5gR°Ri",
"pingres" => "p5gR",
"pink" => "pink",
"pinot" => "pino",
"pinots" => "pino",
"pins" => "p5",
"pinson" => "p5s§",
"pinsons" => "p5s§",
"pinta" => "p5ta",
"pintade" => "p5tad",
"pintades" => "p5tad",
"pintait" => "p5tE",
"pinte" => "p5t",
"pinté" => "p5te",
"pintée" => "p5te",
"pinter" => "p5te",
"pintes" => "p5t",
"pintés" => "p5te",
"piochaient" => "pjoSE",
"piochais" => "pjoSE",
"piochait" => "pjoSE",
"piochant" => "pjoS@",
"pioche" => "pjOS",
"pioché" => "pjOSe",
"piochée" => "pjoSe",
"piochées" => "pjoSe",
"piochent" => "pjOS",
"piocher" => "pjoSe",
"pioches" => "pjOS",
"piocheur" => "pjoS9R",
"piochez" => "pjoSe",
"piolet" => "pjolE",
"pion" => "pj§",
"pionçais" => "pj§sE",
"pionçait" => "pj§sE",
"pionçant" => "pj§s@",
"pionce" => "pj§s",
"pioncé" => "pj§se",
"pioncent" => "pj§s",
"pioncer" => "pj§se",
"pioncera" => "pj§s°Ra",
"pionces" => "pj§s",
"pioncez" => "pj§se",
"pionne" => "pjOn",
"pionner" => "pjOne",
"pionnier" => "pjonje",
"pionnière" => "pjonjER",
"pionnières" => "pjonjER",
"pionniers" => "pjonje",
"pions" => "pj§",
"piot" => "pjo",
"piots" => "pjo",
"pioupiou" => "pjupju",
"pioupious" => "pjupju",
"pipa" => "pipa",
"pipai" => "pipE",
"pipais" => "pipE",
"pipait" => "pipE",
"pipant" => "pip@",
"pipasse" => "pipas",
"pipe" => "pip",
"pipé" => "pipe",
"pipe-line" => "pajplajn",
"pipe-lines" => "pajplajn",
"pipeau" => "pipo",
"pipeaux" => "pipo",
"pipée" => "pipe",
"pipées" => "pipe",
"pipelet" => "pip°lE",
"pipelets" => "pip°lE",
"pipelette" => "pip°lEt",
"pipelettes" => "pip°lEt",
"pipeline" => "pajp°lajn",
"pipelines" => "pajp°lajn",
"piper" => "pipe",
"pipera" => "pip°Ra",
"piperade" => "pip°Rad",
"piperie" => "pip°Ri",
"pipes" => "pip",
"pipés" => "pipe",
"pipette" => "pipEt",
"pipettes" => "pipEt",
"pipeur" => "pip9R",
"pipeuse" => "pip2z",
"pipeuses" => "pip2z",
"pipi" => "pipi",
"pipi-room" => "pipiRum",
"pipiers" => "pipje",
"pipis" => "pipi",
"pipistrelle" => "pipistREl",
"pipo" => "pipo",
"piqua" => "pika",
"piquage" => "pikaZ",
"piquages" => "pikaZ",
"piquai" => "pikE",
"piquaient" => "pikE",
"piquais" => "pikE",
"piquait" => "pikE",
"piquant" => "pik@",
"piquante" => "pik@t",
"piquantes" => "pik@t",
"piquants" => "pik@",
"pique" => "pik",
"piqué" => "pike",
"pique-assiette" => "pikasjEt",
"pique-assiettes" => "pikasjEt",
"pique-boeufs" => "pikb2",
"pique-feu" => "pikf2",
"pique-niquaient" => "piknikE",
"pique-nique" => "piknik",
"pique-niqué" => "piknike",
"pique-niquent" => "pik°nik",
"pique-niquer" => "piknike",
"pique-niqueraient" => "piknik°RE",
"pique-niquerons" => "piknik°R§",
"pique-niques" => "piknik",
"pique-niqueurs" => "piknik9R",
"pique-niquez" => "piknike",
"piquée" => "pike",
"piquées" => "pike",
"piquent" => "pik",
"piquer" => "pike",
"piquera" => "pik°Ra",
"piquerai" => "pik°RE",
"piqueraient" => "pik°RE",
"piquerais" => "pik°RE",
"piquerait" => "pik°RE",
"piqueras" => "pik°Ra",
"piquèrent" => "pikER",
"piquerez" => "pik°Re",
"piquerons" => "pik°R§",
"piqueront" => "pik°R§",
"piques" => "pik",
"piqués" => "pike",
"piquet" => "pikE",
"piquetage" => "pik°taZ",
"piquetaient" => "pik°tE",
"piquetait" => "pik°tE",
"piqueté" => "pik°te",
"piquetée" => "pik°te",
"piquetées" => "pik°te",
"piqueter" => "pik°te",
"piquetés" => "pik°te",
"piquetis" => "pik°ti",
"piquets" => "pikE",
"piquette" => "pikEt",
"piquettes" => "pikEt",
"piqueur" => "pik9R",
"piqueurs" => "pik9R",
"piqueuse" => "pik2z",
"piqueuses" => "pik2z",
"piqueux" => "pik2",
"piquez" => "pike",
"piquier" => "pikje",
"piquiez" => "pikje",
"piquions" => "pikj§",
"piquons" => "pik§",
"piquouse" => "pikuz",
"piquouser" => "pikuze",
"piquouses" => "pikuz",
"piquouze" => "pikuz",
"piquouzes" => "pikuz",
"piqûre" => "pikyR",
"piqûres" => "pikyR",
"pirandellienne" => "piR@dEljEn",
"piranha" => "piRana",
"piranhas" => "piRana",
"piratage" => "piRataZ",
"piratages" => "piRataZ",
"pirataient" => "piRatE",
"piratant" => "piRat@",
"pirate" => "piRat",
"piraté" => "piRate",
"piratée" => "piRate",
"piratent" => "piRat",
"pirater" => "piRate",
"piraterie" => "piRat°Ri",
"pirateries" => "piRat°Ri",
"pirates" => "piRat",
"piratés" => "piRate",
"piratez" => "piRate",
"pire" => "piR",
"pires" => "piR",
"piriforme" => "piRifORm",
"piriformes" => "piRifORm",
"pirogue" => "piROg",
"pirogues" => "piROg",
"pirojki" => "piROSki",
"pirojkis" => "piROSki",
"pirolle" => "piROl",
"pirouetta" => "piRwEta",
"pirouettais" => "piRwEtE",
"pirouettait" => "piRwEtE",
"pirouettant" => "piRwEt@",
"pirouette" => "piRwEt",
"pirouetter" => "piRwEte",
"pirouettes" => "piRwEt",
"pis" => "pi",
"pis-aller" => "pizale",
"pisa" => "piza",
"pisan" => "piz@",
"pisans" => "piz@",
"piscicole" => "pisikOl",
"piscicoles" => "pisikOl",
"pisciculteur" => "pisikylt9R",
"pisciculture" => "pisikyltyR",
"pisciforme" => "pisifORm",
"piscine" => "pisin",
"piscines" => "pisin",
"pisé" => "pize",
"pisiforme" => "pizifORm",
"pissa" => "pisa",
"pissaient" => "pisE",
"pissais" => "pisE",
"pissait" => "pisE",
"pissaladière" => "pisaladjER",
"pissant" => "pis@",
"pissat" => "pisa",
"pissât" => "pisa",
"pisse" => "pis",
"pissé" => "pise",
"pisse-copie" => "piskopi",
"pisse-copies" => "piskopi",
"pisse-froid" => "pisfRwa",
"pisse-vinaigre" => "pisvinEgR",
"pissée" => "pise",
"pissenlit" => "pis@li",
"pissenlits" => "pis@li",
"pissent" => "pis",
"pisser" => "pise",
"pissera" => "pis°Ra",
"pisserai" => "pis°RE",
"pisseraient" => "pis°RE",
"pisserais" => "pis°RE",
"pisserait" => "pis°RE",
"pisseras" => "pis°Ra",
"pissèrent" => "pisER",
"pisses" => "pis",
"pissette" => "pisEt",
"pisseur" => "pis9R",
"pisseurs" => "pis9R",
"pisseuse" => "pis2z",
"pisseuses" => "pis2z",
"pisseux" => "pis2",
"pissez" => "pise",
"pissoir" => "piswaR",
"pissons" => "pis§",
"pissotière" => "pisotjER",
"pissotières" => "pisotjER",
"pissou" => "pisu",
"pista" => "pista",
"pistache" => "pistaS",
"pistaches" => "pistaS",
"pistachier" => "pistaSje",
"pistachiers" => "pistaSje",
"pistage" => "pistaZ",
"pistais" => "pistE",
"pistait" => "pistE",
"pistant" => "pist@",
"pistard" => "pistaR",
"pistards" => "pistaR",
"piste" => "pist",
"pisté" => "piste",
"pistée" => "piste",
"pistées" => "piste",
"pistent" => "pist",
"pister" => "piste",
"pistera" => "pist°Ra",
"pisterai" => "pist°RE",
"pistes" => "pist",
"pistés" => "piste",
"pisteur" => "pist9R",
"pisteurs" => "pist9R",
"pistez" => "piste",
"pistil" => "pistil",
"pistils" => "pistil",
"pistole" => "pistOl",
"pistolero" => "pistoleRo",
"pistoleros" => "pistoleRo",
"pistoles" => "pistOl",
"pistolet" => "pistolE",
"pistolet-mitrailleur" => "pistOlEmitRaj9R",
"pistolétade" => "pistoletad",
"pistolets" => "pistolE",
"pistoleurs" => "pistol9R",
"piston" => "pist§",
"pistonnais" => "pistonE",
"pistonné" => "pistone",
"pistonnée" => "pistone",
"pistonner" => "pistone",
"pistonnera" => "pistOn°Ra",
"pistonnerai" => "pistOn°RE",
"pistonnés" => "pistone",
"pistonnions" => "pistonj§",
"pistons" => "pist§",
"pistou" => "pistu",
"pit bull" => "pitbul",
"pit-bull" => "pitbul",
"pit-bulls" => "pitbul",
"pita" => "pita",
"pitaine" => "pitEn",
"pitance" => "pit@s",
"pitances" => "pit@s",
"pitancher" => "pit@Se",
"pitancherai" => "pit@S°RE",
"pitancier" => "pit@sje",
"pitas" => "pita",
"pitbull" => "pitbul",
"pitbulls" => "pitbul",
"pitch" => "pitS",
"pitcher" => "pitSe",
"pitchoun" => "pitSun",
"pitchoune" => "pitSun",
"pitchounet" => "pitSunE",
"pitchounette" => "pitSunEt",
"pitchpin" => "pitSpin",
"piteuse" => "pit2z",
"piteusement" => "pit2z°m@",
"piteuses" => "pit2z",
"piteux" => "pit2",
"pithécanthrope" => "pitek@tROp",
"pithécanthropes" => "pitek@tROp",
"pithiviers" => "pitivje",
"pitié" => "pitje",
"pitiés" => "pitje",
"piton" => "pit§",
"pitonnant" => "piton@",
"pitonner" => "pitone",
"pitons" => "pit§",
"pitoyable" => "pitwajabl",
"pitoyablement" => "pitwajabl°m@",
"pitoyables" => "pitwajabl",
"pitre" => "pitR",
"pitrerie" => "pitR°Ri",
"pitreries" => "pitR°Ri",
"pitres" => "pitR",
"pittoresque" => "pitoREsk",
"pittoresques" => "pitoREsk",
"pituitaire" => "pit8itER",
"pituitaires" => "pit8itER",
"pituite" => "pit8it",
"pityriasis" => "pitiRjazis",
"piu" => "piu",
"più" => "pju",
"pive" => "piv",
"pivert" => "pivER",
"piverts" => "pivER",
"pivoine" => "pivwan",
"pivoines" => "pivwan",
"pivot" => "pivo",
"pivota" => "pivota",
"pivotai" => "pivotE",
"pivotaient" => "pivotE",
"pivotait" => "pivotE",
"pivotant" => "pivot@",
"pivotante" => "pivot@t",
"pivotantes" => "pivot@t",
"pivotants" => "pivot@",
"pivote" => "pivOt",
"pivoté" => "pivote",
"pivotement" => "pivOt°m@",
"pivotent" => "pivOt",
"pivoter" => "pivote",
"pivotèrent" => "pivotER",
"pivotes" => "pivOt",
"pivotez" => "pivote",
"pivots" => "pivo",
"pixel" => "piksEl",
"pixellisés" => "piksElize",
"pixels" => "piksEl",
"pizza" => "pidza",
"pizzaiolo" => "pidzajOlo",
"pizzas" => "pidza",
"pizzeria" => "pidzeRja",
"pizzerias" => "pidzeRja",
"pizzicato" => "pidzikato",
"plaça" => "plasa",
"placage" => "plakaZ",
"placages" => "plakaZ",
"plaçai" => "plasE",
"plaçaient" => "plasE",
"plaçais" => "plasE",
"plaçait" => "plasE",
"plaçant" => "plas@",
"placard" => "plakaR",
"placardait" => "plakaRdE",
"placarde" => "plakaRd",
"placardé" => "plakaRde",
"placardée" => "plakaRde",
"placardées" => "plakaRde",
"placarder" => "plakaRde",
"placardes" => "plakaRd",
"placardés" => "plakaRde",
"placardier" => "plakaRdje",
"placards" => "plakaR",
"plaçât" => "plasa",
"place" => "plas",
"placé" => "plase",
"placebo" => "plasebo",
"placebos" => "plasebo",
"placée" => "plase",
"placées" => "plase",
"placement" => "plas°m@",
"placements" => "plas°m@",
"placent" => "plas",
"placenta" => "plas5ta",
"placentaire" => "plas5tER",
"placentas" => "plas5ta",
"placer" => "plase",
"placera" => "plas°Ra",
"placerai" => "plas°RE",
"placeraient" => "plas°RE",
"placerais" => "plas°RE",
"placerait" => "plas°RE",
"placeras" => "plas°Ra",
"placèrent" => "plasER",
"placerez" => "plas°Re",
"placerons" => "plas°R§",
"placeront" => "plas°R§",
"places" => "plas",
"placés" => "plase",
"placet" => "plasE",
"placets" => "plasE",
"placette" => "plasEt",
"placettes" => "plasEt",
"placeur" => "plas9R",
"placeurs" => "plas9R",
"placeuse" => "plas2z",
"placeuses" => "plas2z",
"placez" => "plase",
"placide" => "plasid",
"placidement" => "plasid°m@",
"placides" => "plasid",
"placidité" => "plasidite",
"placier" => "plasje",
"placiers" => "plasje",
"placiez" => "plasje",
"placions" => "plasj§",
"plaçons" => "plas§",
"placoplâtre" => "plakoplatR",
"plafond" => "plaf§",
"plafonds" => "plaf§",
"plafonnant" => "plafon@",
"plafonne" => "plafOn",
"plafonné" => "plafone",
"plafonnée" => "plafone",
"plafonnées" => "plafone",
"plafonnement" => "plafOn°m@",
"plafonner" => "plafone",
"plafonnier" => "plafonje",
"plafonnière" => "plafonjER",
"plafonniers" => "plafonje",
"plafonnons" => "plafon§",
"plage" => "plaZ",
"plages" => "plaZ",
"plagiaire" => "plaZjER",
"plagiaires" => "plaZjER",
"plagiant" => "plaZj@",
"plagiat" => "plaZja",
"plagiats" => "plaZja",
"plagie" => "plaZi",
"plagié" => "plaZje",
"plagier" => "plaZje",
"plagies" => "plaZi",
"plagioclase" => "plaZjoklaz",
"plaid" => "plEd",
"plaida" => "plEda",
"plaidable" => "plEdabl",
"plaidai" => "plEdE",
"plaidaient" => "plEdE",
"plaidais" => "plEdE",
"plaidait" => "plEdE",
"plaidant" => "plEd@",
"plaidants" => "plEd@",
"plaide" => "plEd",
"plaidé" => "plede",
"plaidée" => "plede",
"plaident" => "plEd",
"plaider" => "plede",
"plaidera" => "plEd°Ra",
"plaiderai" => "plEd°RE",
"plaiderait" => "plEd°RE",
"plaideras" => "plEd°Ra",
"plaidèrent" => "plEdER",
"plaiderez" => "plEd°Re",
"plaiderons" => "plEd°R§",
"plaideront" => "plEd°R§",
"plaides" => "plEd",
"plaideur" => "plEd9R",
"plaideurs" => "plEd9R",
"plaidez" => "plEde",
"plaidiez" => "plEdje",
"plaidions" => "plEdj§",
"plaidoirie" => "plEdwaRi",
"plaidoiries" => "plEdwaRi",
"plaidons" => "plEd§",
"plaidoyer" => "plEdwaje",
"plaidoyers" => "plEdwaje",
"plaids" => "plEd",
"plaie" => "plE",
"plaies" => "plE",
"plaignaient" => "plENE",
"plaignais" => "plENE",
"plaignait" => "plENE",
"plaignant" => "plEN@",
"plaignante" => "plEN@t",
"plaignantes" => "plEN@t",
"plaignants" => "plEN@",
"plaigne" => "plEN",
"plaignent" => "plEN",
"plaignes" => "plEN",
"plaignez" => "plENe",
"plaigniez" => "plENe",
"plaignions" => "plEN§",
"plaignirent" => "plENiR",
"plaignis" => "plENi",
"plaignit" => "plENi",
"plaignît" => "plENi",
"plaignons" => "plEN§",
"plain" => "pl5",
"plain-chant" => "pl5S@",
"plain-pied" => "pl5pje",
"plaindra" => "pl5dRa",
"plaindrai" => "pl5dRE",
"plaindraient" => "pl5dRE",
"plaindrais" => "pl5dRE",
"plaindrait" => "pl5dRE",
"plaindras" => "pl5dRa",
"plaindre" => "pl5dR",
"plaindrez" => "pl5dRe",
"plaindriez" => "pl5dRije",
"plaindrions" => "pl5dRij§",
"plaindront" => "pl5dR§",
"plaine" => "plEn",
"plaines" => "plEn",
"plains" => "pl5",
"plaint" => "pl5",
"plainte" => "pl5t",
"plaintes" => "pl5t",
"plaintif" => "pl5tif",
"plaintifs" => "pl5tif",
"plaintive" => "pl5tiv",
"plaintivement" => "pl5tiv°m@",
"plaintives" => "pl5tiv",
"plaints" => "pl5",
"plaira" => "plERa",
"plairai" => "plERE",
"plairaient" => "plERE",
"plairais" => "plERE",
"plairait" => "plERE",
"plairas" => "plERa",
"plaire" => "plER",
"plairez" => "plERe",
"plairiez" => "plERje",
"plairont" => "plER§",
"plais" => "plE",
"plaisaient" => "plEzE",
"plaisais" => "plEzE",
"plaisait" => "plEzE",
"plaisamment" => "plEzam@",
"plaisance" => "plEz@s",
"plaisancier" => "plEz@sje",
"plaisanciers" => "plEz@sje",
"plaisant" => "plEz@",
"plaisanta" => "plEz@ta",
"plaisantai" => "plEz@tE",
"plaisantaient" => "plEz@tE",
"plaisantais" => "plEz@tE",
"plaisantait" => "plEz@tE",
"plaisantant" => "plEz@t@",
"plaisante" => "plEz@t",
"plaisanté" => "plEz@te",
"plaisantent" => "plEz@t",
"plaisanter" => "plEz@te",
"plaisantera" => "plEz@t°Ra",
"plaisanterai" => "plEz@t°RE",
"plaisanteraient" => "plEz@t°RE",
"plaisanterais" => "plEz@t°RE",
"plaisanteras" => "plEz@t°Ra",
"plaisantèrent" => "plEz@tER",
"plaisanterie" => "plEz@t°Ri",
"plaisanteries" => "plEz@t°Ri",
"plaisanterons" => "plEz@t°R§",
"plaisantes" => "plEz@t",
"plaisantez" => "plEz@te",
"plaisantiez" => "plEz@tje",
"plaisantin" => "plEz@t5",
"plaisantins" => "plEz@t5",
"plaisantions" => "plEz@tj§",
"plaisantons" => "plEz@t§",
"plaisants" => "plEz@",
"plaise" => "plEz",
"plaisent" => "plEz",
"plaises" => "plEz",
"plaisez" => "plEze",
"plaisiez" => "plEzje",
"plaisions" => "plEzj§",
"plaisir" => "pleziR",
"plaisirs" => "pleziR",
"plaisons" => "plEz§",
"plaît" => "plE",
"plan" => "pl@",
"plan-séquence" => "pl@sek@s",
"plana" => "plana",
"planaient" => "planE",
"planais" => "planE",
"planait" => "planE",
"planant" => "plan@",
"planante" => "plan@t",
"planantes" => "plan@t",
"planants" => "plan@",
"planas" => "plana",
"planchais" => "pl@SE",
"planche" => "pl@S",
"planché" => "pl@Se",
"planchent" => "pl@S",
"plancher" => "pl@Se",
"planchers" => "pl@Se",
"planches" => "pl@S",
"planches-contacts" => "pl@Sk§takt",
"planchette" => "pl@SEt",
"planchettes" => "pl@SEt",
"planchiste" => "pl@Sist",
"plancton" => "pl@kt§",
"planctons" => "pl@kt§",
"plane" => "plan",
"plané" => "plane",
"planelle" => "planEl",
"planement" => "plan°m@",
"planent" => "plan",
"planer" => "plane",
"planera" => "plan°Ra",
"planerait" => "plan°RE",
"planerions" => "plan°Rj§",
"planeront" => "plan°R§",
"planes" => "plan",
"planétaire" => "planetER",
"planétaires" => "planetER",
"planétarium" => "planetaRjOm",
"planétariums" => "planetaRjOm",
"planète" => "planEt",
"planètes" => "planEt",
"planétoïde" => "planetoid",
"planeur" => "plan9R",
"planeurs" => "plan9R",
"planez" => "plane",
"planiez" => "planje",
"planifiable" => "planifjabl",
"planifiaient" => "planifjE",
"planifiait" => "planifjE",
"planifiant" => "planifj@",
"planificateur" => "planifikat9R",
"planification" => "planifikasj§",
"planificatrice" => "planifikatRis",
"planifie" => "planifi",
"planifié" => "planifje",
"planifiée" => "planifje",
"planifient" => "planifi",
"planifier" => "planifje",
"planifierais" => "planifiRE",
"planifiés" => "planifje",
"planifiez" => "planifje",
"planifions" => "planifj§",
"planisphère" => "planisfER",
"planisphères" => "planisfER",
"planitude" => "planityd",
"planning" => "planiG",
"plannings" => "planiG",
"planqua" => "pl@ka",
"planquaient" => "pl@kE",
"planquais" => "pl@kE",
"planquait" => "pl@kE",
"planquant" => "pl@k@",
"planque" => "pl@k",
"planqué" => "pl@ke",
"planquée" => "pl@ke",
"planquées" => "pl@ke",
"planquent" => "pl@k",
"planquer" => "pl@ke",
"planquera" => "pl@k°Ra",
"planquerai" => "pl@k°RE",
"planquerais" => "pl@k°RE",
"planquerait" => "pl@k°RE",
"planqueras" => "pl@k°Ra",
"planquèrent" => "pl@kER",
"planques" => "pl@k",
"planqués" => "pl@ke",
"planquez" => "pl@ke",
"planquiez" => "pl@kje",
"planquions" => "pl@kj§",
"planquons" => "pl@k§",
"plans" => "pl@",
"plant" => "pl@",
"planta" => "pl@ta",
"plantage" => "pl@taZ",
"plantai" => "pl@tE",
"plantaient" => "pl@tE",
"plantain" => "pl@t5",
"plantains" => "pl@t5",
"plantaire" => "pl@tER",
"plantaires" => "pl@tER",
"plantais" => "pl@tE",
"plantait" => "pl@tE",
"plantant" => "pl@t@",
"plantation" => "pl@tasj§",
"plantations" => "pl@tasj§",
"plante" => "pl@t",
"planté" => "pl@te",
"plantée" => "pl@te",
"plantées" => "pl@te",
"plantent" => "pl@t",
"planter" => "pl@te",
"plantera" => "pl@t°Ra",
"planterai" => "pl@t°RE",
"planterais" => "pl@t°RE",
"planterait" => "pl@t°RE",
"planteras" => "pl@t°Ra",
"plantèrent" => "pl@tER",
"planterez" => "pl@t°Re",
"planterons" => "pl@t°R§",
"planteront" => "pl@t°R§",
"plantes" => "pl@t",
"plantés" => "pl@te",
"planteur" => "pl@t9R",
"planteurs" => "pl@t9R",
"plantez" => "pl@te",
"plantier" => "pl@tje",
"plantiez" => "pl@tje",
"plantigrade" => "pl@tigRad",
"plantions" => "pl@tj§",
"plantoir" => "pl@twaR",
"planton" => "pl@t§",
"plantons" => "pl@t§",
"plants" => "pl@",
"plantureuse" => "pl@tyR2z",
"plantureuses" => "pl@tyR2z",
"plantureux" => "pl@tyR2",
"plaqua" => "plaka",
"plaquage" => "plakaZ",
"plaquages" => "plakaZ",
"plaquai" => "plakE",
"plaquaient" => "plakE",
"plaquais" => "plakE",
"plaquait" => "plakE",
"plaquant" => "plak@",
"plaque" => "plak",
"plaqué" => "plake",
"plaquée" => "plake",
"plaquées" => "plake",
"plaqueminiers" => "plak°minje",
"plaquent" => "plak",
"plaquer" => "plake",
"plaquera" => "plak°Ra",
"plaquerai" => "plak°RE",
"plaquerais" => "plak°RE",
"plaquerait" => "plak°RE",
"plaqueras" => "plak°Ra",
"plaquèrent" => "plakER",
"plaques" => "plak",
"plaqués" => "plake",
"plaquettaire" => "plak2tER",
"plaquette" => "plakEt",
"plaquettes" => "plakEt",
"plaqueur" => "plak9R",
"plaquez" => "plake",
"plasma" => "plasma",
"plasmagène" => "plasmaZEn",
"plasmaphérèse" => "plasmafeREz",
"plasmique" => "plasmik",
"plaste" => "plast",
"plastic" => "plastik",
"plasticage" => "plastikaZ",
"plasticages" => "plastikaZ",
"plasticien" => "plastisj5",
"plasticienne" => "plastisjEn",
"plasticité" => "plastisite",
"plastie" => "plasti",
"plastifiant" => "plastifj@",
"plastification" => "plastifikasj§",
"plastifié" => "plastifje",
"plastifiée" => "plastifje",
"plastifiées" => "plastifje",
"plastifier" => "plastifje",
"plastifiés" => "plastifje",
"plastiquage" => "plastikaZ",
"plastiquais" => "plastikE",
"plastique" => "plastik",
"plastiqué" => "plastike",
"plastiquer" => "plastike",
"plastiques" => "plastik",
"plastiqueur" => "plastik9R",
"plastisol" => "plastisOl",
"plastoc" => "plastOk",
"plastron" => "plastR§",
"plastronnaient" => "plastRonE",
"plastronnait" => "plastRonE",
"plastronnant" => "plastRon@",
"plastronne" => "plastROn",
"plastronnent" => "plastROn",
"plastronner" => "plastRone",
"plastronnes" => "plastROn",
"plastronneur" => "plastRon9R",
"plastrons" => "plastR§",
"plat" => "pla",
"plat-bord" => "plabOR",
"plat-ventre" => "plav@tR",
"platane" => "platan",
"platanes" => "platan",
"plate" => "plat",
"plate-bande" => "platb@d",
"plate-forme" => "platfORm",
"plateau" => "plato",
"plateau-repas" => "platoR°pa",
"plateaux" => "plato",
"plateaux-repas" => "platoR°pa",
"platebandes" => "platb@d",
"platée" => "plate",
"platées" => "plate",
"plateforme" => "plat°fORm",
"platelage" => "plat°laZ",
"platement" => "plat°m@",
"plateresque" => "plat°REsk",
"plateresques" => "plat°REsk",
"plates" => "plat",
"plates-bandes" => "platb@d",
"plates-formes" => "platfORm",
"platière" => "platjER",
"platine" => "platin",
"platiné" => "platine",
"platinée" => "platine",
"platinées" => "platine",
"platines" => "platin",
"platinés" => "platine",
"platitude" => "platityd",
"platitudes" => "platityd",
"platonicien" => "platonisj5",
"platonicienne" => "platonisjEn",
"platoniciens" => "platonisj5",
"platonique" => "platonik",
"platoniquement" => "platonik°m@",
"platoniques" => "platonik",
"platonisant" => "platoniz@",
"plâtra" => "platRa",
"plâtrait" => "platRE",
"plâtras" => "platRa",
"plâtre" => "platR",
"plâtré" => "platRe",
"plâtrée" => "platRe",
"plâtrées" => "platRe",
"plâtrent" => "platR",
"plâtrer" => "platRe",
"plâtres" => "platR",
"plâtrés" => "platRe",
"plâtreuse" => "platR2z",
"plâtreuses" => "platR2z",
"plâtreux" => "platR2",
"plâtrier" => "platRije",
"plâtriers" => "platRije",
"plats" => "pla",
"plats-bords" => "plabOR",
"platures" => "platyR",
"platyrrhiniens" => "platiRinj5",
"plausibilité" => "plozibilite",
"plausible" => "plozibl",
"plausiblement" => "plozibl°m@",
"plausibles" => "plozibl",
"play" => "plE",
"play back" => "plEbak",
"play-back" => "plEbak",
"play-boy" => "plEbOj",
"play-boys" => "plEbOj",
"playboy" => "plEjbwaj",
"playmate" => "plEjmat",
"playmates" => "plEjmat",
"playon" => "plEj§",
"plaza" => "plaza",
"plazza" => "pladza",
"please" => "pliz",
"plèbe" => "plEb",
"plébéien" => "plebej5",
"plébéienne" => "plebejEn",
"plébéiennes" => "plebejEn",
"plébéiens" => "plebej5",
"plébiscite" => "plebisit",
"plébiscité" => "plebisite",
"plébisciter" => "plebisite",
"plébiscites" => "plebisit",
"plébiscités" => "plebisite",
"plectre" => "plEktR",
"pléiade" => "plejad",
"pléiades" => "plejad",
"plein" => "pl5",
"plein-air" => "plEnER",
"plein-cintre" => "pl5s5tR",
"plein-emploi" => "pl5n@plwa",
"plein-temps" => "pl5t@",
"pleine" => "plEn",
"pleinement" => "plEn°m@",
"pleines" => "plEn",
"pleins" => "pl5",
"pléistocène" => "pleistosEn",
"plénier" => "plenje",
"plénière" => "plenjER",
"plénières" => "plenjER",
"pléniers" => "plenje",
"plénipotentiaire" => "plenipot@sjER",
"plénipotentiaires" => "plenipot@sjER",
"plénitude" => "plenityd",
"plénitudes" => "plenityd",
"plénum" => "plenOm",
"pléonasme" => "pleonasm",
"pléonasmes" => "pleonasm",
"pléonastiques" => "pleonastik",
"plésiosaure" => "plezjozoR",
"plessis" => "plesi",
"plet" => "plE",
"pléthore" => "pletOR",
"pléthorique" => "pletoRik",
"pléthoriques" => "pletoRik",
"pleur" => "pl9R",
"pleura" => "pl2Ra",
"pleurai" => "pl2RE",
"pleuraient" => "pl2RE",
"pleurais" => "pl2RE",
"pleurait" => "pl2RE",
"pleural" => "pl9Ral",
"pleurale" => "pl2Ral",
"pleurant" => "pl2R@",
"pleurante" => "pl2R@t",
"pleurantes" => "pl2R@t",
"pleurants" => "pl2R@",
"pleurard" => "pl2RaR",
"pleurarde" => "pl2RaRd",
"pleurards" => "pl2RaR",
"pleurât" => "pl9Ra",
"pleure" => "pl9R",
"pleuré" => "pl9Re",
"pleurée" => "pl9Re",
"pleurées" => "pl9Re",
"pleurement" => "pl2R°m@",
"pleurements" => "pl2R°m@",
"pleurent" => "pl9R",
"pleurer" => "pl2Re",
"pleurera" => "pl2R°Ra",
"pleurerai" => "pl2R°RE",
"pleureraient" => "pl2R°RE",
"pleurerais" => "pl2R°RE",
"pleurerait" => "pl2R°RE",
"pleureras" => "pl2R°Ra",
"pleurèrent" => "pl9RER",
"pleurerez" => "pl2R°Re",
"pleurerons" => "pl2R°R§",
"pleureront" => "pl2R°R§",
"pleures" => "pl9R",
"pleurés" => "pl9Re",
"pleurésie" => "pl9Rezi",
"pleurétique" => "pl9Retik",
"pleureur" => "pl2R9R",
"pleureurs" => "pl2R9R",
"pleureuse" => "pl2R2z",
"pleureuses" => "pl2R2z",
"pleureux" => "pl9R2",
"pleurez" => "pl9Re",
"pleuriez" => "pl9Rje",
"pleurions" => "pl9Rj§",
"pleurite" => "pl9Rit",
"pleurnicha" => "pl9RniSa",
"pleurnichage" => "pl9RniSaZ",
"pleurnichages" => "pl9RniSaZ",
"pleurnichais" => "pl9RniSE",
"pleurnichait" => "pl9RniSE",
"pleurnichant" => "pl9RniS@",
"pleurnichard" => "pl9RniSaR",
"pleurnicharde" => "pl9RniSaRd",
"pleurnichardes" => "pl9RniSaRd",
"pleurnichards" => "pl9RniSaR",
"pleurniche" => "pl9RniS",
"pleurniché" => "pl9RniSe",
"pleurnichement" => "pl9RniS°m@",
"pleurnichements" => "pl9RniS°m@",
"pleurnichent" => "pl9RniS",
"pleurnicher" => "pl9RniSe",
"pleurnicherais" => "pl9RniS°RE",
"pleurnicherait" => "pl9RniS°RE",
"pleurnicheras" => "pl9RniS°Ra",
"pleurnicherie" => "pl9RniS°Ri",
"pleurnicheries" => "pl9RniS°Ri",
"pleurniches" => "pl9RniS",
"pleurnicheur" => "pl9RniS9R",
"pleurnicheurs" => "pl9RniS9R",
"pleurnicheuse" => "pl9RniS2z",
"pleurnicheuses" => "pl9RniS2z",
"pleurnichez" => "pl9RniSe",
"pleurons" => "pl9R§",
"pleurotes" => "pl9ROt",
"pleurs" => "pl9R",
"pleut" => "pl2",
"pleutre" => "pl2tR",
"pleutrerie" => "pl2tR°Ri",
"pleutres" => "pl2tR",
"pleuvaient" => "pl2vE",
"pleuvait" => "pl2vE",
"pleuvant" => "pl2v@",
"pleuve" => "pl2v",
"pleuvent" => "pl2v",
"pleuvinait" => "pl2vinE",
"pleuvine" => "pl9vin",
"pleuviner" => "pl2vine",
"pleuvioter" => "pl2vjote",
"pleuvoir" => "pl2vwaR",
"pleuvra" => "pl2vRa",
"pleuvrait" => "pl2vRE",
"plèvre" => "plEvR",
"plèvres" => "plEvR",
"plexi" => "plEksi",
"plexiglas" => "plEksiglas",
"plexus" => "plEksys",
"pleyel" => "plEjEl",
"pli" => "pli",
"plia" => "plija",
"pliable" => "pliabl",
"pliage" => "plijaZ",
"pliages" => "plijaZ",
"pliai" => "plijE",
"pliaient" => "plijE",
"pliais" => "plijE",
"pliait" => "plijE",
"pliant" => "plij@",
"pliante" => "plij@t",
"pliantes" => "plij@t",
"pliants" => "plij@",
"pliât" => "plja",
"plie" => "pli",
"plié" => "plije",
"pliée" => "plije",
"pliées" => "plije",
"plient" => "pli",
"plier" => "plije",
"pliera" => "pliRa",
"plierai" => "pliRE",
"plieraient" => "pliRE",
"plierait" => "pliRE",
"plieras" => "pliRa",
"plièrent" => "plijER",
"plierez" => "pliRe",
"plierons" => "pliR§",
"plies" => "pli",
"pliés" => "plije",
"plieur" => "plij9R",
"plieuse" => "plij2z",
"pliez" => "plije",
"plinthe" => "pl5t",
"plinthes" => "pl5t",
"pliocène" => "plijosEn",
"plioir" => "plijwaR",
"plions" => "plij§",
"plique" => "plik",
"plis" => "pli",
"plissa" => "plisa",
"plissai" => "plisE",
"plissaient" => "plisE",
"plissais" => "plisE",
"plissait" => "plisE",
"plissant" => "plis@",
"plisse" => "plis",
"plissé" => "plise",
"plissée" => "plise",
"plissées" => "plise",
"plissement" => "plis°m@",
"plissements" => "plis°m@",
"plissent" => "plis",
"plisser" => "plise",
"plissèrent" => "plisER",
"plisseront" => "plis°R§",
"plissés" => "plise",
"plisseur" => "plis9R",
"plissure" => "plisyR",
"plissures" => "plisyR",
"pliure" => "plijyR",
"pliures" => "plijyR",
"ploc" => "plOk",
"ploie" => "plwa",
"ploiement" => "plwam@",
"ploient" => "plwa",
"plomb" => "pl§",
"plombage" => "pl§baZ",
"plombages" => "pl§baZ",
"plombaient" => "pl§bE",
"plombait" => "pl§bE",
"plombant" => "pl§b@",
"plombe" => "pl§b",
"plombé" => "pl§be",
"plombée" => "pl§be",
"plombées" => "pl§be",
"plombent" => "pl§b",
"plomber" => "pl§be",
"plomberie" => "pl§b°Ri",
"plomberies" => "pl§b°Ri",
"plombes" => "pl§b",
"plombés" => "pl§be",
"plombez" => "pl§be",
"plombier" => "pl§bje",
"plombières" => "pl§bjER",
"plombiers" => "pl§bje",
"plombs" => "pl§",
"plombure" => "pl§byR",
"plonge" => "pl§Z",
"plongé" => "pl§Ze",
"plongea" => "pl§Za",
"plongeai" => "pl§ZE",
"plongeaient" => "pl§ZE",
"plongeais" => "pl§ZE",
"plongeait" => "pl§ZE",
"plongeâmes" => "pl§Zam",
"plongeant" => "pl§Z@",
"plongeante" => "pl§Z@t",
"plongeantes" => "pl§Z@t",
"plongeants" => "pl§Z@",
"plongeât" => "pl§Za",
"plongée" => "pl§Ze",
"plongées" => "pl§Ze",
"plongement" => "pl§Z°m@",
"plongent" => "pl§Z",
"plongeoir" => "pl§ZwaR",
"plongeoirs" => "pl§ZwaR",
"plongeon" => "pl§Z§",
"plongeons" => "pl§Z§",
"plonger" => "pl§Ze",
"plongera" => "pl§Z°Ra",
"plongerai" => "pl§Z°RE",
"plongeraient" => "pl§Z°RE",
"plongerais" => "pl§Z°RE",
"plongerait" => "pl§Z°RE",
"plongeras" => "pl§Z°Ra",
"plongèrent" => "pl§ZER",
"plongerez" => "pl§Z°Re",
"plongeriez" => "pl§Z°Rje",
"plongerons" => "pl§Z°R§",
"plongeront" => "pl§Z°R§",
"plonges" => "pl§Z",
"plongés" => "pl§Ze",
"plongeur" => "pl§Z9R",
"plongeurs" => "pl§Z9R",
"plongeuse" => "pl§Z2z",
"plongeuses" => "pl§Z2z",
"plongez" => "pl§Ze",
"plongiez" => "pl§Zje",
"plongions" => "pl§Zj§",
"plot" => "plo",
"plots" => "plo",
"plouc" => "pluk",
"ploucs" => "pluk",
"plouf" => "pluf",
"plouk" => "pluk",
"ploutocrate" => "plutOkRat",
"ploutocrates" => "plutokRat",
"ploutocratie" => "plutOkRasi",
"ploya" => "plwaja",
"ployaient" => "plwajE",
"ployait" => "plwajE",
"ployant" => "plwaj@",
"ployante" => "plwaj@t",
"ployé" => "plwaje",
"ployée" => "plwaje",
"ployées" => "plwaje",
"ployer" => "plwaje",
"ployés" => "plwaje",
"plu" => "ply",
"pluche" => "plyS",
"plucher" => "plySe",
"pluches" => "plyS",
"plue" => "ply",
"pluie" => "pl8i",
"pluies" => "pl8i",
"plum" => "plum",
"plum-pudding" => "plumpudiG",
"pluma" => "plyma",
"plumage" => "plymaZ",
"plumages" => "plymaZ",
"plumaient" => "plymE",
"plumait" => "plymE",
"plumant" => "plym@",
"plumard" => "plymaR",
"plumards" => "plymaR",
"plumassière" => "plymasjER",
"plume" => "plym",
"plumé" => "plyme",
"plumeau" => "plymo",
"plumeaux" => "plymo",
"plumée" => "plyme",
"plumées" => "plyme",
"plument" => "plym",
"plumer" => "plyme",
"plumes" => "plym",
"plumés" => "plyme",
"plumet" => "plymE",
"plumetis" => "plym°ti",
"plumets" => "plymE",
"plumeuse" => "plym2z",
"plumeuses" => "plym2z",
"plumeux" => "plym2",
"plumez" => "plyme",
"plumier" => "plymje",
"plumiers" => "plymje",
"plumitif" => "plymitif",
"plumitifs" => "plymitif",
"plumitives" => "plymitiv",
"plumules" => "plymyl",
"plupart" => "plypaR",
"pluralisme" => "plyRalizm",
"pluraliste" => "plyRalist",
"pluralité" => "plyRalite",
"plurent" => "plyR",
"pluriannuel" => "plyRian8El",
"pluridisciplinaire" => "plyRidisiplinER",
"pluriel" => "plyRjEl",
"plurielle" => "plyRjEl",
"pluriels" => "plyRjEl",
"plurinational" => "plyRinasjOnal",
"plus" => "plys",
"plus-que-parfait" => "plysk°paRfE",
"plus-que-parfaits" => "plysk°paRfE",
"plus-value" => "plyvaly",
"plus-values" => "plyvaly",
"plusieurs" => "plyzj9R",
"plusse" => "plys",
"plut" => "ply",
"plût" => "ply",
"pluton" => "plyt§",
"plutonien" => "plytonj5",
"plutonienne" => "plytOnjEn",
"plutonique" => "plytOnik",
"plutonium" => "plytonjOm",
"plutôt" => "plyto",
"pluvial" => "plyvjal",
"pluviale" => "plyvjal",
"pluviales" => "plyvjal",
"pluviaux" => "plyvjo",
"pluvier" => "plyvje",
"pluviers" => "plyvje",
"pluvieuse" => "plyvj2z",
"pluvieuses" => "plyvj2z",
"pluvieux" => "plyvj2",
"pluviomètre" => "plyvjomEtR",
"pluviomètres" => "plyvjomEtR",
"pluviométrie" => "plyvjometRi",
"pluviométrique" => "plyvjometRik",
"pluviôse" => "plyvjoz",
"pluviosité" => "plyvjozite",
"pneu" => "pn2",
"pneumatique" => "pn2matik",
"pneumatiques" => "pn2matik",
"pneumatophore" => "pn2matofOR",
"pneumo" => "pn2mo",
"pneumoconiose" => "pn2mokOnjoz",
"pneumocoque" => "pn2mokOk",
"pneumocoques" => "pn2mokOk",
"pneumocystose" => "pn2mosistoz",
"pneumologue" => "pn2mOlOg",
"pneumonectomie" => "pn2mOnEktOmi",
"pneumonie" => "pn2moni",
"pneumonies" => "pn2moni",
"pneumonique" => "pn2mOnik",
"pneumopathie" => "pn2mopati",
"pneumos" => "pn2mo",
"pneumothorax" => "pn2motoRaks",
"pneus" => "pn2",
"pneus-neige" => "pn2nEZ",
"pochade" => "poSad",
"pochades" => "poSad",
"pochage" => "poSaZ",
"pochard" => "poSaR",
"pocharde" => "poSaRd",
"pochards" => "poSaR",
"poche" => "pOS",
"poché" => "poSe",
"poche-revolver" => "pOSRevOlvER",
"pochée" => "poSe",
"pochées" => "poSe",
"pocher" => "poSe",
"poches" => "pOS",
"pochés" => "poSe",
"pocheté" => "pOS°te",
"pochetée" => "pOS°te",
"pochetées" => "pOS°te",
"pochetron" => "poSEtR§",
"pochetrons" => "poSEtR§",
"pochette" => "poSEt",
"pochette-surprise" => "poSEtsyRpRiz",
"pochettes" => "poSEt",
"pochettes-surprises" => "poSEtsyRpRiz",
"pochoir" => "poSwaR",
"pochon" => "poS§",
"pochons" => "poS§",
"pochtron" => "pOStR§",
"pochtrons" => "pOStR§",
"podagre" => "podagR",
"podestat" => "podEsta",
"podestats" => "podEsta",
"podium" => "podjOm",
"podiums" => "podjOm",
"podologue" => "podolOg",
"podomètre" => "pOdOmEtR",
"poecile" => "pesil",
"poêle" => "pwal",
"poêlées" => "pwale",
"poêles" => "pwal",
"poêlon" => "pwal§",
"poème" => "poEm",
"poèmes" => "poEm",
"poésie" => "poezi",
"poésies" => "poezi",
"poète" => "poEt",
"poètes" => "poEt",
"poétesse" => "poetEs",
"poétesses" => "poetEs",
"poéticien" => "poetisj5",
"poétique" => "poetik",
"poétiquement" => "poetik°m@",
"poétiques" => "poetik",
"poétisait" => "poetizE",
"poétisant" => "poetiz@",
"poétise" => "poetiz",
"poétiser" => "poetize",
"poétisez" => "poetize",
"pogne" => "pON",
"pognes" => "pON",
"pognon" => "poN§",
"pogo" => "pOgo",
"pogrom" => "pogROm",
"pogrome" => "pogROm",
"pogromes" => "pogROm",
"pogroms" => "pogROm",
"poids" => "pwa",
"poids-lourds" => "pwaluR",
"poignaient" => "pwaNE",
"poignait" => "pwaNE",
"poignant" => "pwaN@",
"poignante" => "pwaN@t",
"poignantes" => "pwaN@t",
"poignants" => "pwaN@",
"poignard" => "pwaNaR",
"poignarda" => "pwaNaRda",
"poignardaient" => "pwaNaRdE",
"poignardais" => "pwaNaRdE",
"poignardait" => "pwaNaRdE",
"poignardant" => "pwaNaRd@",
"poignarde" => "pwaNaRd",
"poignardé" => "pwaNaRde",
"poignardée" => "pwaNaRde",
"poignardées" => "pwaNaRde",
"poignardent" => "pwaNaRd",
"poignarder" => "pwaNaRde",
"poignardera" => "pwaNaRd°Ra",
"poignarderai" => "pwaNaRd°RE",
"poignarderais" => "pwaNaRd°RE",
"poignarderait" => "pwaNaRd°RE",
"poignarderont" => "pwaNaRd°R§",
"poignardés" => "pwaNaRde",
"poignardez" => "pwaNaRde",
"poignards" => "pwaNaR",
"poigne" => "pwaN",
"poignée" => "pwaNe",
"poignées" => "pwaNe",
"poignent" => "pwaN",
"poigner" => "pwaNe",
"poignerait" => "pwaN°RE",
"poignes" => "pwaN",
"poignet" => "pwaNE",
"poignets" => "pwaNE",
"poignons" => "pwaN§",
"poil" => "pwal",
"poil-de-carotte" => "pwald°kaROt",
"poilaient" => "pwalE",
"poilais" => "pwalE",
"poilait" => "pwalE",
"poilant" => "pwal@",
"poile" => "pwal",
"poilé" => "pwale",
"poiler" => "pwale",
"poilés" => "pwale",
"poileux" => "pwal2",
"poils" => "pwal",
"poilu" => "pwaly",
"poilue" => "pwaly",
"poilues" => "pwaly",
"poilus" => "pwaly",
"poinçon" => "pw5s§",
"poinçonnait" => "pw5sonE",
"poinçonné" => "pw5sone",
"poinçonnée" => "pw5sone",
"poinçonner" => "pw5sone",
"poinçonneraient" => "pw5sOn°RE",
"poinçonnés" => "pw5sone",
"poinçonneur" => "pw5son9R",
"poinçonneurs" => "pw5son9R",
"poinçons" => "pw5s§",
"poindra" => "pw5dRa",
"poindre" => "pw5dR",
"poing" => "pw5",
"poings" => "pw5",
"poinsettia" => "pw5sEtja",
"point" => "pw5",
"point-clé" => "pw5kle",
"point-virgule" => "pw5viRgyl",
"pointa" => "pw5ta",
"pointage" => "pw5taZ",
"pointages" => "pw5taZ",
"pointai" => "pw5tE",
"pointaient" => "pw5tE",
"pointais" => "pw5tE",
"pointait" => "pw5tE",
"pointâmes" => "pw5tam",
"pointant" => "pw5t@",
"pointe" => "pw5t",
"pointé" => "pw5te",
"pointeau" => "pw5to",
"pointée" => "pw5te",
"pointées" => "pw5te",
"pointement" => "pw5t°m@",
"pointent" => "pw5t",
"pointer" => "pw5te",
"pointera" => "pw5t°Ra",
"pointerai" => "pw5t°RE",
"pointeraient" => "pw5t°RE",
"pointerais" => "pw5t°RE",
"pointerait" => "pw5t°RE",
"pointeras" => "pw5t°Ra",
"pointèrent" => "pw5tER",
"pointerez" => "pw5t°Re",
"pointeront" => "pw5t°R§",
"pointers" => "pw5t9R",
"pointes" => "pw5t",
"pointés" => "pw5te",
"pointeur" => "pw5t9R",
"pointeurs" => "pw5t9R",
"pointeuse" => "pw5t2z",
"pointeuses" => "pw5t2z",
"pointez" => "pw5te",
"pointiez" => "pw5tje",
"pointillaient" => "pw5tijE",
"pointillant" => "pw5tij@",
"pointille" => "pw5tij",
"pointillé" => "pw5tije",
"pointillée" => "pw5tije",
"pointillées" => "pw5tije",
"pointillés" => "pw5tije",
"pointilleuse" => "pw5tij2z",
"pointilleuses" => "pw5tij2z",
"pointilleux" => "pw5tij2",
"pointillisme" => "pw5tijizm",
"pointilliste" => "pw5tijist",
"pointillistes" => "pw5tijist",
"pointons" => "pw5t§",
"points" => "pw5",
"points-virgules" => "pw5viRgyl",
"pointu" => "pw5ty",
"pointue" => "pw5ty",
"pointues" => "pw5ty",
"pointure" => "pw5tyR",
"pointures" => "pw5tyR",
"pointus" => "pw5ty",
"poire" => "pwaR",
"poiré" => "pwaRe",
"poire-vérité" => "pwaRveRite",
"poireau" => "pwaRo",
"poireautai" => "pwaRotE",
"poireautaient" => "pwaRotE",
"poireautais" => "pwaRotE",
"poireautait" => "pwaRotE",
"poireaute" => "pwaRot",
"poireauté" => "pwaRote",
"poireauter" => "pwaRote",
"poireautes" => "pwaRot",
"poireautions" => "pwaRotj§",
"poireaux" => "pwaRo",
"poirée" => "pwaRe",
"poirer" => "pwaRe",
"poires" => "pwaR",
"poirier" => "pwaRje",
"poiriers" => "pwaRje",
"poirota" => "pwaRota",
"poirotait" => "pwaRotE",
"poiroter" => "pwaRote",
"pois" => "pwa",
"poiscaille" => "pwaskaj",
"poiscailles" => "pwaskaj",
"poison" => "pwaz§",
"poisons" => "pwaz§",
"poissaient" => "pwasE",
"poissait" => "pwasE",
"poissard" => "pwasaR",
"poissardes" => "pwasaRd",
"poisse" => "pwas",
"poissé" => "pwase",
"poissée" => "pwase",
"poissées" => "pwase",
"poissent" => "pwas",
"poisser" => "pwase",
"poisses" => "pwas",
"poissés" => "pwase",
"poisseuse" => "pwas2z",
"poisseuses" => "pwas2z",
"poisseux" => "pwas2",
"poisson" => "pwas§",
"poisson-chat" => "pwas§Sa",
"poisson-épée" => "pwas§epe",
"poisson-globe" => "pwas§glOb",
"poisson-lune" => "pwas§lyn",
"poisson-pilote" => "pwas§pilOt",
"poissonnerie" => "pwasOn°Ri",
"poissonneuse" => "pwason2z",
"poissonneuses" => "pwason2z",
"poissonneux" => "pwason2",
"poissonnier" => "pwasonje",
"poissonnière" => "pwasonjER",
"poissonnières" => "pwasonjER",
"poissonniers" => "pwasonje",
"poissons" => "pwas§",
"poissons-chats" => "pwas§Sa",
"poitevin" => "pwatv5",
"poitevins" => "pwatv5",
"poitrail" => "pwatRaj",
"poitrails" => "pwatRaj",
"poitrinaire" => "pwatRinER",
"poitrinaires" => "pwatRinER",
"poitrinant" => "pwatRin@",
"poitrine" => "pwatRin",
"poitrines" => "pwatRin",
"poitrinières" => "pwatRinjER",
"poivra" => "pwavRa",
"poivrade" => "pwavRad",
"poivrades" => "pwavRad",
"poivrais" => "pwavRE",
"poivrait" => "pwavRE",
"poivre" => "pwavR",
"poivré" => "pwavRe",
"poivrée" => "pwavRe",
"poivrées" => "pwavRe",
"poivrent" => "pwavR",
"poivrer" => "pwavRe",
"poivres" => "pwavR",
"poivrés" => "pwavRe",
"poivrez" => "pwavRe",
"poivrier" => "pwavRije",
"poivrière" => "pwavRijER",
"poivrières" => "pwavRijER",
"poivriers" => "pwavRije",
"poivron" => "pwavR§",
"poivrons" => "pwavR§",
"poivrot" => "pwavRo",
"poivrote" => "pwavROt",
"poivrotes" => "pwavROt",
"poivrots" => "pwavRo",
"poix" => "pwa",
"poker" => "pokER",
"pokers" => "pokER",
"polack" => "polak",
"polacks" => "polak",
"polaire" => "polER",
"polaires" => "polER",
"polak" => "polak",
"polaks" => "polak",
"polaque" => "polak",
"polaques" => "polak",
"polar" => "polaR",
"polarde" => "polaRd",
"polardes" => "polaRd",
"polards" => "polaR",
"polarisaient" => "polaRizE",
"polarisait" => "polaRizE",
"polarisant" => "pOlaRiz@",
"polarisants" => "polaRiz@",
"polarisation" => "polaRizasj§",
"polarise" => "polaRiz",
"polarisé" => "polaRize",
"polarisée" => "polaRize",
"polarisent" => "polaRiz",
"polariser" => "polaRize",
"polarité" => "polaRite",
"polaroid" => "polaRoid",
"polaroïd" => "polaRoid",
"polaroïds" => "polaRoid",
"polars" => "polaR",
"polder" => "pOldER",
"polders" => "poldER",
"pole" => "pOl",
"pôle" => "pol",
"polémique" => "polemik",
"polémiquer" => "polemike",
"polémiques" => "polemik",
"polémiste" => "polemist",
"polémistes" => "polemist",
"polenta" => "polEnta",
"pôles" => "pol",
"poli" => "poli",
"police" => "polis",
"policé" => "polise",
"police-secours" => "pOliss2kuR",
"policée" => "polise",
"policées" => "polise",
"policeman" => "polis°man",
"policemen" => "polis°mEn",
"policer" => "pOlise",
"polices" => "polis",
"policés" => "polise",
"polichinelle" => "poliSinEl",
"polichinelles" => "poliSinEl",
"policier" => "polisje",
"policière" => "polisjER",
"policières" => "polisjER",
"policiers" => "polisje",
"policlinique" => "pOliklinik",
"polie" => "poli",
"polies" => "poli",
"poliment" => "polim@",
"polio" => "poljo",
"poliomyélite" => "poljomjelit",
"poliomyélitique" => "poljomjelitik",
"poliomyélitiques" => "poljomjelitik",
"poliorcétique" => "poljoRsetik",
"polios" => "poljo",
"polir" => "poliR",
"poliras" => "poliRa",
"polis" => "poli",
"polish" => "pOliS",
"polissage" => "polisaZ",
"polissages" => "polisaZ",
"polissaient" => "polisE",
"polissais" => "polisE",
"polissait" => "polisE",
"polissant" => "polis@",
"polissent" => "polis",
"polisseur" => "polis9R",
"polisseurs" => "polis9R",
"polisseuse" => "polis2z",
"polissoir" => "poliswaR",
"polisson" => "polis§",
"polissonnait" => "polisonE",
"polissonne" => "polisOn",
"polissonner" => "pOlisOne",
"polissonnerie" => "polisOn°Ri",
"polissonneries" => "polisOn°Ri",
"polissonnes" => "polisOn",
"polissons" => "polis§",
"polissure" => "polisyR",
"polit" => "poli",
"politburo" => "politbyRo",
"politesse" => "politEs",
"politesses" => "politEs",
"politicard" => "politikaR",
"politicards" => "politikaR",
"politicien" => "politisj5",
"politicienne" => "politisjEn",
"politiciennes" => "politisjEn",
"politiciens" => "politisj5",
"politico" => "politiko",
"politico-religieuse" => "politikoR°liZj2z",
"politique" => "politik",
"politique-fiction" => "politikfiksj§",
"politiquement" => "politik°m@",
"politiques" => "politik",
"politisation" => "pOlitizasj§",
"politisé" => "politize",
"politisée" => "politize",
"politiser" => "politize",
"politisés" => "politize",
"polka" => "pOlka",
"polkas" => "pOlka",
"pollen" => "polEn",
"pollens" => "polEn",
"pollinies" => "polini",
"pollinique" => "polinik",
"pollinisateur" => "pOlinizat9R",
"pollinisation" => "polinizasj§",
"pollinisé" => "pOlinize",
"polliniser" => "pOlinize",
"pollope" => "polOp",
"polluait" => "pol8E",
"polluant" => "pol8@",
"polluante" => "pOl8@t",
"polluants" => "pol8@",
"pollue" => "poly",
"pollué" => "pol8e",
"polluée" => "pol8e",
"polluées" => "pol8e",
"polluent" => "poly",
"polluer" => "pol8e",
"pollueront" => "polyR§",
"pollues" => "poly",
"pollués" => "pol8e",
"pollueur" => "poly9R",
"pollueurs" => "pol89R",
"pollueuse" => "poly2z",
"polluez" => "polye",
"pollution" => "polysj§",
"pollutions" => "polysj§",
"polo" => "polo",
"poloche" => "pOlOS",
"polochon" => "poloS§",
"polochons" => "poloS§",
"polonais" => "polonE",
"polonaise" => "polonEz",
"polonaises" => "polonEz",
"polope" => "polOp",
"polos" => "polo",
"polski" => "pOlski",
"poltron" => "pOltR§",
"poltronne" => "pOltROn",
"poltronnerie" => "pOltROn°Ri",
"poltrons" => "pOltR§",
"poly" => "poli",
"poly-sexuelle" => "poliseksyEl",
"polyacrylate" => "pOliakRilat",
"polyamide" => "poliamid",
"polyamides" => "poljamid",
"polyandre" => "polj@dR",
"polyarthrite" => "pOliaRtRit",
"polycarbonate" => "polikaRbonat",
"polycéphale" => "polisefal",
"polychlorure" => "polikloRyR",
"polychrome" => "polikRom",
"polychromé" => "polikRome",
"polychromées" => "polikRome",
"polychromes" => "polikRom",
"polychromie" => "polikRomi",
"polyclinique" => "poliklinik",
"polycopiait" => "polikopjE",
"polycopie" => "polikopi",
"polycopié" => "polikopje",
"polycopiée" => "polikopje",
"polycopier" => "polikopje",
"polycopiés" => "polikopje",
"polyculture" => "polikyltyR",
"polydactylie" => "pOlidakili",
"polyèdre" => "poljEdR",
"polyèdres" => "poljEdR",
"polyester" => "poliEstER",
"polyéthylène" => "polietilEn",
"polygame" => "poligam",
"polygamie" => "poligami",
"polygénique" => "pOliZenik",
"polyglotte" => "poliglOt",
"polyglottes" => "poliglOt",
"polygonal" => "pOligOnal",
"polygonales" => "poligonal",
"polygonaux" => "poligono",
"polygone" => "poligon",
"polygones" => "poligon",
"polygraphe" => "poligRaf",
"polygraphes" => "poligRaf",
"polykystique" => "pOlikistik",
"polymérase" => "pOlimeRaz",
"polymère" => "polimER",
"polymérique" => "polimeRik",
"polymériques" => "polimeRik",
"polymorphe" => "polimORf",
"polymorphes" => "polimORf",
"polymorphie" => "pOlimORfi",
"polymorphismes" => "polimORfizm",
"polynésien" => "polinezj5",
"polynésienne" => "polinezjEn",
"polynésiennes" => "polinezjEn",
"polynésiens" => "polinezj5",
"polype" => "polip",
"polypes" => "polip",
"polyphone" => "polifOn",
"polyphonie" => "polifoni",
"polyphonique" => "polifonik",
"polypier" => "polipje",
"polypiers" => "polipje",
"polypropylène" => "polipRopilEn",
"polysaccharides" => "polizakaRid",
"polystyrène" => "polistiREn",
"polysyllabe" => "pOlisilab",
"polysyllabique" => "polisilabik",
"polytechnicien" => "politEknisj5",
"polytechnicienne" => "pOlitEknisjEn",
"polytechniciens" => "politEknisj5",
"polytechnique" => "politEknik",
"polythéiste" => "pOliteist",
"polythène" => "politEn",
"polytonal" => "politonal",
"polytonalité" => "politonalite",
"polyuréthane" => "pOliyRetan",
"polyvalence" => "polival@s",
"polyvalent" => "polival@",
"polyvalente" => "pOlival@t",
"polyvalents" => "polival@",
"polyvinyle" => "polivinil",
"polyvinylique" => "pOlivinilik",
"pom-pom girl" => "pOmpOmg9Rl",
"pom-pom girls" => "pOmpOmg9Rl",
"pomelo" => "pOmelo",
"pomélo" => "pOmelo",
"poméranien" => "pomeRanj5",
"poméranienne" => "pomeRanjEn",
"poméraniennes" => "pomeRanjEn",
"poméraniens" => "pomeRanj5",
"pomerols" => "pOm°ROl",
"pommade" => "pomad",
"pommadé" => "pomade",
"pommadées" => "pomade",
"pommader" => "pomade",
"pommades" => "pomad",
"pommadés" => "pomade",
"pommadin" => "pOmad5",
"pommaient" => "pomE",
"pommard" => "pomaR",
"pommards" => "pomaR",
"pomme" => "pOm",
"pommé" => "pome",
"pommeau" => "pomo",
"pommeaux" => "pomo",
"pommée" => "pome",
"pommées" => "pome",
"pommelé" => "pOm°le",
"pommelées" => "pOm°le",
"pommeler" => "pOm°le",
"pommelés" => "pOm°le",
"pommer" => "pOme",
"pommeraie" => "pOm°RE",
"pommes" => "pOm",
"pommés" => "pome",
"pommette" => "pomEt",
"pommettes" => "pomEt",
"pommier" => "pomje",
"pommiers" => "pomje",
"pompadour" => "p§paduR",
"pompage" => "p§paZ",
"pompai" => "p§pE",
"pompaient" => "p§pE",
"pompais" => "p§pE",
"pompait" => "p§pE",
"pompant" => "p§p@",
"pompe" => "p§p",
"pompé" => "p§pe",
"pompée" => "p§pe",
"pompéien" => "p§pej5",
"pompéienne" => "p§pejEn",
"pompéiennes" => "p§pejEn",
"pompéiens" => "p§pej5",
"pompent" => "p§p",
"pomper" => "p§pe",
"pompera" => "p§p°Ra",
"pomperais" => "p§p°RE",
"pomperait" => "p§p°RE",
"pompes" => "p§p",
"pompés" => "p§pe",
"pompette" => "p§pEt",
"pompeur" => "p§p9R",
"pompeuse" => "p§p2z",
"pompeusement" => "p§p2z°m@",
"pompeuses" => "p§p2z",
"pompeux" => "p§p2",
"pompez" => "p§pe",
"pompidoliens" => "p§pidolj5",
"pompier" => "p§pje",
"pompiérisme" => "p§pjeRizm",
"pompiers" => "p§pje",
"pompions" => "p§pj§",
"pompiste" => "p§pist",
"pompistes" => "p§pist",
"pompon" => "p§p§",
"pomponna" => "p§pona",
"pomponnaient" => "p§ponE",
"pomponnait" => "p§ponE",
"pomponnant" => "p§pon@",
"pomponne" => "p§pOn",
"pomponné" => "p§pone",
"pomponnée" => "p§pone",
"pomponnées" => "p§pone",
"pomponnent" => "p§pOn",
"pomponner" => "p§pone",
"pomponnés" => "p§pone",
"pomponniez" => "p§ponje",
"pompons" => "p§p§",
"ponant" => "pon@",
"ponçage" => "p§saZ",
"ponçait" => "p§sE",
"ponçant" => "p§s@",
"ponce" => "p§s",
"poncé" => "p§se",
"ponceau" => "p§so",
"ponceaux" => "p§so",
"poncée" => "p§se",
"poncées" => "p§se",
"poncer" => "p§se",
"ponces" => "p§s",
"poncés" => "p§se",
"ponceuse" => "p§s2z",
"poncho" => "p§tSo",
"ponchos" => "p§tSo",
"poncif" => "p§sif",
"poncifs" => "p§sif",
"ponction" => "p§ksj§",
"ponctionna" => "p§ksjona",
"ponctionnait" => "p§ksjonE",
"ponctionne" => "p§ksjOn",
"ponctionner" => "p§ksjone",
"ponctions" => "p§ksj§",
"ponctua" => "p§kt8a",
"ponctuaient" => "p§kt8E",
"ponctuait" => "p§kt8E",
"ponctualité" => "p§kt8alite",
"ponctuant" => "p§kt8@",
"ponctuation" => "p§kt8asj§",
"ponctuations" => "p§kt8asj§",
"ponctue" => "p§kty",
"ponctué" => "p§kt8e",
"ponctuée" => "p§kt8e",
"ponctuées" => "p§kt8e",
"ponctuel" => "p§kt8El",
"ponctuelle" => "p§kt8El",
"ponctuellement" => "p§kt8El°m@",
"ponctuelles" => "p§kt8El",
"ponctuels" => "p§kt8El",
"ponctuent" => "p§kty",
"ponctuer" => "p§kt8e",
"ponctuèrent" => "p§ktyER",
"ponctués" => "p§kt8e",
"pond" => "p§",
"pondaient" => "p§dE",
"pondait" => "p§dE",
"pondant" => "p§d@",
"ponde" => "p§d",
"pondent" => "p§d",
"pondérable" => "p§deRabl",
"pondérables" => "p§deRabl",
"pondérale" => "p§deRal",
"pondération" => "p§deRasj§",
"pondéré" => "p§deRe",
"pondérée" => "p§deRe",
"pondérées" => "p§deRe",
"pondérer" => "p§deRe",
"pondérés" => "p§deRe",
"pondes" => "p§d",
"pondeur" => "p§d9R",
"pondeuse" => "p§d2z",
"pondeuses" => "p§d2z",
"pondez" => "p§de",
"pondiez" => "p§dje",
"pondoir" => "p§dwaR",
"pondoirs" => "p§dwaR",
"pondra" => "p§dRa",
"pondrai" => "p§dRE",
"pondraient" => "p§dRE",
"pondrais" => "p§dRE",
"pondras" => "p§dRa",
"pondre" => "p§dR",
"pondront" => "p§dR§",
"ponds" => "p§",
"pondu" => "p§dy",
"pondue" => "p§dy",
"pondus" => "p§dy",
"ponette" => "ponEt",
"ponettes" => "ponEt",
"poney" => "ponE",
"poneys" => "ponE",
"pongé" => "p§Ze",
"pongiste" => "p§Zist",
"pongistes" => "p§Zist",
"pongo" => "p§go",
"pont" => "p§",
"pont-l'évêque" => "p§levEk",
"pont-levis" => "p§l°vi",
"pont-neuf" => "p§n9f",
"pont-promenade" => "p§pROmnad",
"pontage" => "p§taZ",
"pontages" => "p§taZ",
"ponte" => "p§t",
"ponté" => "p§te",
"ponter" => "p§te",
"pontes" => "p§t",
"pontet" => "p§tE",
"pontets" => "p§tE",
"pontife" => "p§tif",
"pontifes" => "p§tif",
"pontifia" => "p§tifja",
"pontifiait" => "p§tifjE",
"pontifiant" => "p§tifj@",
"pontifiante" => "p§tifj@t",
"pontifiants" => "p§tifj@",
"pontifical" => "p§tifikal",
"pontificale" => "p§tifikal",
"pontificales" => "p§tifikal",
"pontificat" => "p§tifika",
"pontificaux" => "p§tifiko",
"pontifie" => "p§tifi",
"pontifier" => "p§tifje",
"pontifièrent" => "p§tifjER",
"pontil" => "p§til",
"pontin" => "p§t5",
"pontins" => "p§t5",
"ponton" => "p§t§",
"pontonnier" => "p§tonje",
"pontonniers" => "p§tonje",
"pontons" => "p§t§",
"ponts" => "p§",
"ponts-levis" => "p§l°vi",
"pool" => "pul",
"pop" => "pOp",
"pop-club" => "pOpkl9b",
"pop-corn" => "pOpkORn",
"popaul" => "popOl",
"pope" => "pOp",
"popeline" => "pOp°lin",
"popes" => "pOp",
"popistes" => "popist",
"poplité" => "pOplite",
"poplitée" => "pOplite",
"popote" => "popOt",
"popotes" => "popOt",
"popotin" => "popot5",
"populace" => "popylas",
"populacier" => "popylasje",
"populacière" => "popylasjER",
"populacières" => "popylasjER",
"populaire" => "popylER",
"populairement" => "popylER°m@",
"populaires" => "popylER",
"popularisé" => "popylaRize",
"populariser" => "popylaRize",
"popularité" => "popylaRite",
"popularités" => "popylaRite",
"population" => "popylasj§",
"populations" => "popylasj§",
"populeuse" => "popyl2z",
"populeuses" => "popyl2z",
"populeux" => "popyl2",
"populisme" => "popylizm",
"populismes" => "popylizm",
"populiste" => "popylist",
"populistes" => "popylist",
"populo" => "popylo",
"poquait" => "pokE",
"poque" => "pOk",
"poquette" => "pOkEt",
"porc" => "pOR",
"porc-épic" => "pORkepik",
"porcelaine" => "pORs°lEn",
"porcelaines" => "pORs°lEn",
"porcelainiers" => "pORs°lEnje",
"porcelet" => "pORs°lE",
"porcelets" => "pORs°lE",
"porche" => "pORS",
"porcher" => "pORSe",
"porchère" => "pORSER",
"porchères" => "pORSER",
"porcherie" => "pORS°Ri",
"porcheries" => "pORS°Ri",
"porches" => "pORS",
"porcif" => "pORsif",
"porcifs" => "pORsif",
"porcin" => "pORs5",
"porcine" => "pORsin",
"porcins" => "pORs5",
"porcs" => "pOR",
"pore" => "pOR",
"pores" => "pOR",
"poreuse" => "poR2z",
"poreuses" => "poR2z",
"poreux" => "poR2",
"porno" => "pORno",
"pornocrate" => "pORnokRat",
"pornocrates" => "pORnokRat",
"pornographe" => "pORnogRaf",
"pornographes" => "pORnogRaf",
"pornographie" => "pORnogRafi",
"pornographies" => "pORnogRafi",
"pornographique" => "pORnogRafik",
"pornographiques" => "pORnogRafik",
"pornos" => "pORno",
"porosité" => "poRozite",
"porphyre" => "pORfiR",
"porphyres" => "pORfiR",
"porphyrie" => "pORfiRi",
"porque" => "pORk",
"porridge" => "pORidZ",
"port" => "pOR",
"port-salut" => "pORsaly",
"porta" => "pORta",
"portabilité" => "pORtabilite",
"portable" => "pORtabl",
"portables" => "pORtabl",
"portage" => "pORtaZ",
"portager" => "pORtaZe",
"portai" => "pORtE",
"portaient" => "pORtE",
"portail" => "pORtaj",
"portails" => "pORtaj",
"portais" => "pORtE",
"portait" => "pORtE",
"portal" => "pORtal",
"portâmes" => "pORtam",
"portance" => "pORt@s",
"portant" => "pORt@",
"portante" => "pORt@t",
"portants" => "pORt@",
"portassent" => "pORtas",
"portât" => "pORta",
"portatif" => "pORtatif",
"portatifs" => "pORtatif",
"portative" => "pORtativ",
"portatives" => "pORtativ",
"porte" => "pORt",
"porté" => "pORte",
"porte-à-faux" => "pORtafo",
"porte-à-porte" => "pORtapORt",
"porte-aiguille" => "pORteg8ij",
"porte-avion" => "pORtavj§",
"porte-avions" => "pORtavj§",
"porte-bagages" => "pORtbagaZ",
"porte-bannière" => "pORtbanjER",
"porte-bébé" => "pORtbebe",
"porte-billets" => "pORtbijE",
"porte-bois" => "pORtbwa",
"porte-bonheur" => "pORtbOn9R",
"porte-bouteilles" => "pORtbutEj",
"porte-cannes" => "pORt°kan",
"porte-carte" => "pORt°kaRt",
"porte-cartes" => "pORt°kaRt",
"porte-chance" => "pORt°S@s",
"porte-chapeaux" => "pORtSapo",
"porte-cigarette" => "pOR°tsigaREt",
"porte-cigarettes" => "pOR°tsigaREt",
"porte-clé" => "pORt°kle",
"porte-clef" => "pORt°kle",
"porte-clefs" => "pORt°kle",
"porte-clés" => "pORt°kle",
"porte-conteneurs" => "pORt°k§t°n9R",
"porte-coton" => "pORtkot§",
"porte-couilles" => "pORt°kuj",
"porte-couteau" => "pORtkuto",
"porte-couteaux" => "pORtkuto",
"porte-cravate" => "pORtkRavat",
"porte-crayon" => "pORt°kREj§",
"porte-document" => "pORtdokym@",
"porte-documents" => "pORtdokym@",
"porte-drapeau" => "pORtdRapo",
"porte-drapeaux" => "pORtdRapo",
"porte-épée" => "pORtepe",
"porte-étendard" => "pORtet@daR",
"porte-étendards" => "pORtet@daR",
"porte-étrier" => "pORtetRije",
"porte-fanion" => "pORtfanj§",
"porte-fenêtre" => "pORtf°nEtR",
"porte-flingue" => "pORt°fl5g",
"porte-flingues" => "pORt°fl5g",
"porte-forets" => "pOR°tfoRE",
"porte-glaive" => "pORt°glEv",
"porte-jarretelles" => "pORt°ZaR°tEl",
"porte-malheur" => "pORtmal9R",
"porte-mine" => "pORt°min",
"porte-monnaie" => "pORt°monE",
"porte-musique" => "pORtmyzik",
"porte-objet" => "pORtObZE",
"porte-papier" => "pORtpapje",
"porte-parapluie" => "pORtpaRapl8i",
"porte-parapluies" => "pORtpaRapl8i",
"porte-plume" => "pORt°plym",
"porte-plumes" => "pORt°plym",
"porte-queue" => "pORt°k2",
"porte-savon" => "pORtsav§",
"porte-serviette" => "pORtsERvjEt",
"porte-serviettes" => "pORtsERvjEt",
"porte-tambour" => "pORt@buR",
"porte-voix" => "pORt°vwa",
"portée" => "pORte",
"portées" => "pORte",
"portefaix" => "pORt°fE",
"portefeuille" => "pORt°f9j",
"portefeuilles" => "pORt°f9j",
"portemanteau" => "pORt°m@to",
"portemanteaux" => "pORt°m@to",
"portement" => "pORt°m@",
"portent" => "pORt",
"porter" => "poRte",
"portera" => "pORt°Ra",
"porterai" => "pORt°RE",
"porteraient" => "pORt°RE",
"porterais" => "pORt°RE",
"porterait" => "pORt°RE",
"porteras" => "pORt°Ra",
"portèrent" => "pORtER",
"porterez" => "pORt°Re",
"porterie" => "pORt°Ri",
"porteriez" => "pORt°Rje",
"porterons" => "pORt°R§",
"porteront" => "pORt°R§",
"portes" => "pORt",
"portés" => "pORte",
"portes-fenêtres" => "pORtf°nEtR",
"porteur" => "pORt9R",
"porteurs" => "pORt9R",
"porteuse" => "pORt2z",
"porteuses" => "pORt2z",
"portez" => "pORte",
"portfolio" => "pORtfoljo",
"portier" => "pORtje",
"portière" => "pORtjER",
"portières" => "pORtjER",
"portiers" => "pORtje",
"portiez" => "pORtje",
"portillon" => "pORtij§",
"portillons" => "pORtij§",
"portion" => "pORsj§",
"portions" => "poRsj§",
"portique" => "pORtik",
"portiques" => "pORtik",
"portland" => "pORtl@d",
"porto" => "pORto",
"portons" => "pORt§",
"portor" => "pORtOR",
"portoricain" => "pORtoRik5",
"portoricaine" => "pORtoRikEn",
"portoricaines" => "pORtoRikEn",
"portoricains" => "pORtoRik5",
"portos" => "pORto",
"portraire" => "pORtRER",
"portrait" => "pORtRE",
"portrait-robot" => "pORtRERobo",
"portraitiste" => "pORtRetist",
"portraitistes" => "pORtREtist",
"portraits" => "pORtRE",
"portraits-robots" => "pORtRERobo",
"portraiturant" => "pORtREtyR@",
"portraiture" => "pORtREtyR",
"portraituré" => "pORtREtyRe",
"portraiturer" => "pORtRetyRe",
"portraiturés" => "pORtREtyRe",
"ports" => "pOR",
"portuaire" => "pORt8ER",
"portuaires" => "pORt8ER",
"portugais" => "pORtygE",
"portugaise" => "pORtygEz",
"portugaises" => "pORtygEz",
"portulan" => "pORtyl@",
"portulans" => "pORtyl@",
"portus" => "pORty",
"posa" => "poza",
"posada" => "pozada",
"posadas" => "pozada",
"posai" => "pozE",
"posaient" => "pozE",
"posais" => "pozE",
"posait" => "pozE",
"posâmes" => "pozam",
"posant" => "poz@",
"posas" => "poza",
"posât" => "poza",
"pose" => "poz",
"posé" => "poze",
"pose-la-moi" => "pozlamwa",
"posée" => "poze",
"posées" => "poze",
"posément" => "pozem@",
"posemètre" => "poz°mEtR",
"posent" => "poz",
"poser" => "poze",
"posera" => "poz°Ra",
"poserai" => "poz°RE",
"poseraient" => "poz°RE",
"poserais" => "poz°RE",
"poserait" => "poz°RE",
"poseras" => "poz°Ra",
"posèrent" => "pozER",
"poserez" => "poz°Re",
"poseriez" => "poz°Rje",
"poserions" => "poz°Rj§",
"poserons" => "poz°R§",
"poseront" => "poz°R§",
"poses" => "poz",
"posés" => "poze",
"poseur" => "poz9R",
"poseurs" => "poz9R",
"poseuse" => "poz2z",
"posez" => "poze",
"posiez" => "pozje",
"posions" => "pozj§",
"positif" => "pozitif",
"positifs" => "pozitif",
"position" => "pozisj§",
"position-clé" => "pozisj§kle",
"positionne" => "pozisjOn",
"positionné" => "pozisjone",
"positionnée" => "pozisjone",
"positionnel" => "pozisjOnEl",
"positionnement" => "pozisjOn°m@",
"positionnent" => "pozisjOn",
"positionner" => "pozisjone",
"positionnera" => "pozisjOn°Ra",
"positionneur" => "pozisjOn9R",
"positions" => "pozisj§",
"positive" => "pozitiv",
"positivement" => "pozitiv°m@",
"positiver" => "pOzitive",
"positives" => "pozitiv",
"positivisme" => "pozitivizm",
"positiviste" => "pozitivist",
"positivistes" => "pozitivist",
"positivité" => "pozitivite",
"positon" => "pozit§",
"positron" => "pozitR§",
"positrons" => "pozitR§",
"posologie" => "pozoloZi",
"posologies" => "pozoloZi",
"posons" => "poz§",
"posséda" => "poseda",
"possédaient" => "posedE",
"possédais" => "posedE",
"possédait" => "posedE",
"possédant" => "posed@",
"possédante" => "posed@t",
"possédants" => "posed@",
"possédasse" => "posedas",
"possédât" => "poseda",
"possède" => "posEd",
"possédé" => "posede",
"possédée" => "posede",
"possédées" => "posede",
"possèdent" => "posEd",
"posséder" => "posede",
"possédera" => "posed°Ra",
"posséderai" => "posed°RE",
"posséderaient" => "posed°RE",
"posséderais" => "posed°RE",
"posséderait" => "posed°RE",
"posséderas" => "posed°Ra",
"posséderez" => "posed°Re",
"posséderont" => "posed°R§",
"possèdes" => "posEd",
"possédés" => "posede",
"possédez" => "posede",
"possédiez" => "posedje",
"possédions" => "posedj§",
"possédons" => "posed§",
"possesseur" => "poses9R",
"possesseurs" => "poses9R",
"possessif" => "posesif",
"possessifs" => "posesif",
"possession" => "posesj§",
"possessions" => "posesj§",
"possessive" => "posesiv",
"possessives" => "posesiv",
"possessivité" => "posEsivite",
"possibilité" => "posibilite",
"possibilités" => "posibilite",
"possible" => "posibl",
"possiblement" => "posibl°m@",
"possibles" => "posibl",
"post" => "pOst",
"post it" => "pOstit",
"post mortem" => "pOst°mORtEm",
"post-apocalyptique" => "pOstapokaliptik",
"post-empire" => "pOst@piR",
"post-hypnotique" => "pOstipnotik",
"post-impressionnisme" => "pOst5pREsjOnism",
"post-it" => "pOstit",
"post-moderne" => "pOstmodERn",
"post-natal" => "pOstnatal",
"post-natale" => "pOstnatal",
"post-opératoire" => "pOstopeRatwaR",
"post-opératoires" => "pOstopeRatwaR",
"post-partum" => "pOstpaRtOm",
"post-production" => "pOstpRodyksj§",
"post-punk" => "pOstp9nk",
"post-romantique" => "pOstRom@tik",
"post-rupture" => "pOstRyptyR",
"post-scriptum" => "pOstskRiptOm",
"post-surréalistes" => "pOstsyRealist",
"post-synchro" => "pOsts5kRo",
"post-traumatique" => "pOsttRomatik",
"post-traumatiques" => "pOsttRomatik",
"post-victorien" => "pOstviktoRj5",
"post-zoo" => "pOstzoo",
"posta" => "pOsta",
"postage" => "pOstaZ",
"postai" => "pOstE",
"postaient" => "pOstE",
"postais" => "pOstE",
"postait" => "pOstE",
"postal" => "pOstal",
"postale" => "pOstal",
"postales" => "pOstal",
"postant" => "pOst@",
"postaux" => "pOsto",
"postcombustion" => "pOstk§bystj§",
"postcure" => "pOstkyR",
"postdaté" => "pOstdate",
"postdater" => "pOstdate",
"postdoctoral" => "pOstdOktoRal",
"poste" => "pOst",
"posté" => "pOste",
"poste-clé" => "pOst°kle",
"postée" => "pOste",
"postées" => "pOste",
"postent" => "pOst",
"poster" => "pOste",
"postera" => "pOst°Ra",
"posterai" => "pOst°RE",
"posterait" => "pOst°RE",
"posteras" => "pOst°Ra",
"postérieur" => "pOsteRj9R",
"postérieure" => "pOsteRj9R",
"postérieurement" => "pOsteRj9R°m@",
"postérieures" => "pOsteRj9R",
"postérieurs" => "pOsteRj9R",
"postérité" => "pOsteRite",
"postérités" => "pOsteRite",
"posterons" => "pOst°R§",
"posters" => "pOstER",
"postes" => "pOst",
"postés" => "pOste",
"postes-clés" => "pOst°kle",
"postez" => "pOste",
"postface" => "pOstfas",
"postfaces" => "pOstfas",
"posthume" => "pOstym",
"posthumes" => "pOstym",
"postiche" => "pOstiS",
"postiches" => "pOstiS",
"postier" => "pOstje",
"postière" => "pOstjER",
"postiers" => "pOstje",
"postillon" => "pOstij§",
"postillonna" => "pOstijona",
"postillonnait" => "pOstijonE",
"postillonnant" => "pOstijon@",
"postillonne" => "pOstijOn",
"postillonné" => "pOstijone",
"postillonnent" => "pOstijOn",
"postillonner" => "pOstijone",
"postillonnes" => "pOstijOn",
"postillonneur" => "pOstijon9R",
"postillonneurs" => "pOstijon9R",
"postillonnez" => "pOstijone",
"postillons" => "pOstij§",
"postmoderne" => "pOstmodERn",
"postmodernisme" => "pOstmodERnizm",
"postmoderniste" => "pOstmodERnist",
"postnatal" => "pOstnatal",
"postnatale" => "pOstnatal",
"postopératoire" => "pOstopeRatwaR",
"postopératoires" => "pOstopeRatwaR",
"postproduction" => "pOstpRodyksj§",
"postsynchronisation" => "pOsts5kRonizasj§",
"postulai" => "pOstylE",
"postulaient" => "pOstylE",
"postulait" => "pOstylE",
"postulant" => "pOstyl@",
"postulante" => "pOstyl@t",
"postulantes" => "pOstyl@t",
"postulants" => "pOstyl@",
"postulat" => "pOstyla",
"postulations" => "pOstylasj§",
"postulats" => "pOstyla",
"postule" => "pOstyl",
"postulé" => "pOstyle",
"postulent" => "pOstyl",
"postuler" => "pOstyle",
"postuleras" => "pOstyl°Ra",
"postules" => "pOstyl",
"posturaux" => "pOstyRo",
"posture" => "pOstyR",
"postures" => "pOstyR",
"pot" => "po",
"pot-au-feu" => "potof2",
"pot-bouille" => "pobuj",
"pot-de-vin" => "pod°v5",
"pot-pourri" => "popuRi",
"potable" => "potabl",
"potables" => "potabl",
"potache" => "potaS",
"potaches" => "potaS",
"potage" => "potaZ",
"potager" => "potaZe",
"potagère" => "potaZER",
"potagères" => "potaZER",
"potagers" => "potaZe",
"potages" => "potaZ",
"potard" => "potaR",
"potassa" => "potasa",
"potassait" => "potasE",
"potasse" => "potas",
"potassé" => "potase",
"potassent" => "potas",
"potasser" => "potase",
"potasserai" => "potas°RE",
"potasses" => "potas",
"potassez" => "potase",
"potassium" => "potasjOm",
"pote" => "pOt",
"poteau" => "poto",
"poteaux" => "poto",
"potée" => "pote",
"potées" => "pote",
"potelé" => "pOt°le",
"potelée" => "pOt°le",
"potelées" => "potEle",
"potelés" => "potEle",
"potence" => "pot@s",
"potencée" => "pot@se",
"potences" => "pot@s",
"potentat" => "pot@ta",
"potentats" => "pot@ta",
"potentialisation" => "pOt@sjalizasj§",
"potentialiser" => "pOt@sjalize",
"potentialité" => "pot@sjalite",
"potentiel" => "pot@sjEl",
"potentielle" => "pot@sjEl",
"potentiellement" => "pot@sjEl°m@",
"potentielles" => "pot@sjEl",
"potentiels" => "pot@sjEl",
"potentiomètre" => "pot@sjomEtR",
"poter" => "pOte",
"poterie" => "pOt°Ri",
"poteries" => "pOt°Ri",
"poterne" => "potERn",
"poternes" => "potERn",
"potes" => "pOt",
"potiche" => "potiS",
"potiches" => "potiS",
"potier" => "potje",
"potière" => "pOtjER",
"potiers" => "potje",
"potimarron" => "pOtimaR§",
"potin" => "pot5",
"potinais" => "potinE",
"potine" => "potin",
"potines" => "potin",
"potins" => "pot5",
"potion" => "posj§",
"potions" => "posj§",
"potiron" => "potiR§",
"potirons" => "potiR§",
"potlatch" => "potlatS",
"poto-poto" => "potopoto",
"potos" => "poto",
"potron-minet" => "potR§minE",
"pots" => "po",
"pots-de-vin" => "pod°v5",
"pots-pourris" => "popuRi",
"pou" => "pu",
"pouacre" => "pwakR",
"pouah" => "pwa",
"poubelle" => "pubEl",
"poubelles" => "pubEl",
"pouce" => "pus",
"pouce-pied" => "puspje",
"pouces" => "pus",
"poucet" => "pusE",
"poucets" => "pusE",
"poucette" => "pusEt",
"poucettes" => "pusEt",
"pouding" => "pudiG",
"poudingue" => "pud5g",
"poudra" => "pudRa",
"poudrage" => "pudRaZ",
"poudraient" => "pudRE",
"poudrait" => "pudRE",
"poudrant" => "pudR@",
"poudre" => "pudR",
"poudré" => "pudRe",
"poudrée" => "pudRe",
"poudrées" => "pudRe",
"poudrent" => "pudR",
"poudrer" => "pudRe",
"poudres" => "pudR",
"poudrés" => "pudRe",
"poudrette" => "pudREt",
"poudreuse" => "pudR2z",
"poudreuses" => "pudR2z",
"poudreux" => "pudR2",
"poudrier" => "pudRije",
"poudrière" => "pudRijER",
"poudriers" => "pudRije",
"poudroie" => "pudRwa",
"poudroiement" => "pudRwam@",
"poudroiements" => "pudRwam@",
"poudroyaient" => "pudRwajE",
"poudroyait" => "pudRwajE",
"poudroyante" => "pudRwaj@t",
"poudroyantes" => "pudRwaj@t",
"pouf" => "puf",
"pouffa" => "pufa",
"pouffaient" => "pufE",
"pouffait" => "pufE",
"pouffant" => "puf@",
"pouffante" => "puf@t",
"pouffantes" => "puf@t",
"pouffe" => "puf",
"pouffé" => "pufe",
"pouffement" => "pufm@",
"pouffements" => "pufm@",
"pouffent" => "puf",
"pouffer" => "pufe",
"poufferais" => "puf°RE",
"poufferait" => "puf°RE",
"pouffèrent" => "pufER",
"pouffes" => "puf",
"pouffiasse" => "pufjas",
"pouffiasses" => "pufjas",
"pouffions" => "pufj§",
"pouffons" => "puf§",
"poufiasse" => "pufjas",
"poufiasses" => "pufjas",
"poufs" => "puf",
"pouh" => "pu",
"pouic" => "pwik",
"pouille" => "puj",
"pouillerie" => "puj°Ri",
"pouilleries" => "puj°Ri",
"pouilles" => "puj",
"pouillés" => "puje",
"pouilleuse" => "puj2z",
"pouilleuses" => "puj2z",
"pouilleux" => "puj2",
"pouillot" => "pujo",
"pouillots" => "pujo",
"pouilly" => "puji",
"poujadisme" => "puZadizm",
"poujadiste" => "puZadist",
"poujadistes" => "puZadist",
"poulaga" => "pulaga",
"poulagas" => "pulaga",
"poulaille" => "pulaj",
"poulailler" => "pulaje",
"poulaillers" => "pulaje",
"poulain" => "pul5",
"poulaine" => "pulEn",
"poulaines" => "pulEn",
"poulains" => "pul5",
"poularde" => "pulaRd",
"poulardes" => "pulaRd",
"poulardin" => "pulaRd5",
"poulardins" => "pulaRd5",
"poulbot" => "pulbo",
"poulbots" => "pulbo",
"poule" => "pul",
"poules" => "pul",
"poulet" => "pulE",
"poulets" => "pulE",
"poulette" => "pulEt",
"poulettes" => "pulEt",
"pouliche" => "puliS",
"pouliches" => "puliS",
"poulie" => "puli",
"poulies" => "puli",
"poulinière" => "pulinjER",
"poulot" => "pulo",
"poulots" => "pulo",
"poulottant" => "pulOt@",
"poulotter" => "pulOte",
"poulpe" => "pulp",
"poulpes" => "pulp",
"pouls" => "pu",
"poumon" => "pum§",
"poumons" => "pum§",
"pound" => "pawnd",
"pounds" => "pawndz",
"poupard" => "pupaR",
"poupards" => "pupaR",
"poupe" => "pup",
"poupée" => "pupe",
"poupées" => "pupe",
"poupin" => "pup5",
"poupine" => "pupin",
"poupon" => "pup§",
"pouponnage" => "puponaZ",
"pouponne" => "pupOn",
"pouponné" => "pupone",
"pouponnent" => "pupOn",
"pouponner" => "pupone",
"pouponnière" => "puponjER",
"pouponnières" => "puponjER",
"poupons" => "pup§",
"poupoule" => "pupul",
"pour" => "puR",
"pour-cent" => "puRs@",
"pourboire" => "puRbwaR",
"pourboires" => "puRbwaR",
"pourceau" => "puRso",
"pourceaux" => "puRso",
"pourcent" => "puRs@",
"pourcentage" => "puRs@taZ",
"pourcentages" => "puRs@taZ",
"pourcents" => "puRs@",
"pourchas" => "puRSa",
"pourchassa" => "puRSasa",
"pourchassaient" => "puRSasE",
"pourchassais" => "puRSasE",
"pourchassait" => "puRSasE",
"pourchassant" => "puRSas@",
"pourchasse" => "puRSas",
"pourchassé" => "puRSase",
"pourchassée" => "puRSase",
"pourchassées" => "puRSase",
"pourchassent" => "puRSas",
"pourchasser" => "puRSase",
"pourchassera" => "puRSas°Ra",
"pourchasserai" => "puRSas°RE",
"pourchasseraient" => "puRSas°RE",
"pourchasserait" => "puRSas°RE",
"pourchassèrent" => "puRSasER",
"pourchasserons" => "puRSas°R§",
"pourchasseront" => "puRSas°R§",
"pourchassés" => "puRSase",
"pourchasseur" => "puRSas9R",
"pourchassez" => "puRSase",
"pourchassons" => "puRSas§",
"pourcif" => "puRsif",
"pourfendait" => "puRf@dE",
"pourfendant" => "puRf@d@",
"pourfende" => "puRf@d",
"pourfendeur" => "puRf@d9R",
"pourfendions" => "puRf@dj§",
"pourfendre" => "puRf@dR",
"pourfends" => "puRf@",
"pourfendu" => "puRf@dy",
"pourim" => "puRim",
"pourléchaient" => "puRleSE",
"pourléchait" => "puRleSE",
"pourléchant" => "puRleS@",
"pourlèche" => "puRlES",
"pourléchée" => "puRleSe",
"pourlèchent" => "puRlES",
"pourlécher" => "puRleSe",
"pourliche" => "puRliS",
"pourliches" => "puRliS",
"pourparler" => "puRpaRle",
"pourparlers" => "puRpaRle",
"pourpier" => "puRpje",
"pourpiers" => "puRpje",
"pourpoint" => "puRpw5",
"pourpoints" => "puRpw5",
"pourpre" => "puRpR",
"pourpré" => "puRpRe",
"pourprée" => "puRpRe",
"pourprées" => "puRpRe",
"pourpres" => "puRpR",
"pourquoi" => "puRkwa",
"pourra" => "puRa",
"pourrai" => "puRE",
"pourraient" => "puRE",
"pourrais" => "puRE",
"pourrait" => "puRE",
"pourras" => "puRa",
"pourrez" => "puRe",
"pourri" => "puRi",
"pourrie" => "puRi",
"pourries" => "puRi",
"pourriez" => "puRje",
"pourrions" => "puRj§",
"pourrir" => "puRiR",
"pourrira" => "puRiRa",
"pourrirai" => "puRiRE",
"pourrirait" => "puRiRE",
"pourriras" => "puRiRa",
"pourrirent" => "puRiR",
"pourrirez" => "puRiRe",
"pourririez" => "puRiRje",
"pourrirons" => "puRiR§",
"pourriront" => "puRiR§",
"pourris" => "puRi",
"pourrissaient" => "puRisE",
"pourrissais" => "puRisE",
"pourrissait" => "puRisE",
"pourrissant" => "puRis@",
"pourrissante" => "puRis@t",
"pourrissantes" => "puRis@t",
"pourrissants" => "puRis@",
"pourrisse" => "puRis",
"pourrissement" => "puRis°m@",
"pourrissent" => "puRis",
"pourrisseur" => "puRis9R",
"pourrissez" => "puRise",
"pourrissoir" => "puRiswaR",
"pourrissons" => "puRis§",
"pourrit" => "puRi",
"pourriture" => "puRityR",
"pourritures" => "puRityR",
"pourrons" => "puR§",
"pourront" => "puR§",
"poursuis" => "puRs8i",
"poursuit" => "puRs8i",
"poursuite" => "puRs8it",
"poursuites" => "puRs8it",
"poursuivaient" => "puRs8ivE",
"poursuivais" => "puRs8ivE",
"poursuivait" => "puRs8ivE",
"poursuivant" => "puRs8iv@",
"poursuivante" => "puRs8iv@t",
"poursuivants" => "puRs8iv@",
"poursuive" => "puRs8iv",
"poursuivent" => "puRs8iv",
"poursuives" => "puRs8iv",
"poursuiveurs" => "puRs8iv9R",
"poursuivez" => "puRs8ive",
"poursuivi" => "puRs8ivi",
"poursuivie" => "puRs8ivi",
"poursuivies" => "puRs8ivi",
"poursuiviez" => "puRs8ivje",
"poursuivîmes" => "puRs8ivim",
"poursuivions" => "puRs8ivj§",
"poursuivirent" => "puRs8iviR",
"poursuivis" => "puRs8ivi",
"poursuivit" => "puRs8ivi",
"poursuivît" => "puRs8ivi",
"poursuivons" => "puRs8iv§",
"poursuivra" => "puRs8ivRa",
"poursuivrai" => "puRs8ivRE",
"poursuivraient" => "puRs8ivRE",
"poursuivrais" => "puRs8ivRE",
"poursuivrait" => "puRs8ivRE",
"poursuivras" => "puRs8ivRa",
"poursuivre" => "puRs8ivR",
"poursuivrez" => "puRs8ivRe",
"poursuivrions" => "puRs8ivRij§",
"poursuivrons" => "puRs8ivR§",
"poursuivront" => "puRs8ivR§",
"pourtant" => "puRt@",
"pourtour" => "puRtuR",
"pourtours" => "puRtuR",
"pourvoi" => "puRvwa",
"pourvoie" => "puRvwa",
"pourvoient" => "puRvwa",
"pourvoir" => "puRvwaR",
"pourvoira" => "puRvwaRa",
"pourvoirai" => "puRvwaRE",
"pourvoiraient" => "puRvwaRE",
"pourvoirait" => "puRvwaRE",
"pourvoirons" => "puRvwaR§",
"pourvoiront" => "puRvwaR§",
"pourvois" => "puRvwa",
"pourvoit" => "puRvwa",
"pourvoyaient" => "puRvwajE",
"pourvoyait" => "puRvwajE",
"pourvoyant" => "puRvwaj@",
"pourvoyeur" => "puRvwaj9R",
"pourvoyeurs" => "puRvwaj9R",
"pourvoyeuse" => "puRvwaj2z",
"pourvoyons" => "puRvwaj§",
"pourvu" => "puRvy",
"pourvue" => "puRvy",
"pourvues" => "puRvy",
"pourvus" => "puRvy",
"pourvut" => "puRvy",
"poussa" => "pusa",
"poussah" => "pusa",
"poussai" => "pusE",
"poussaient" => "pusE",
"poussais" => "pusE",
"poussait" => "pusE",
"poussâmes" => "pusam",
"poussant" => "pus@",
"poussas" => "pusa",
"poussât" => "pusa",
"pousse" => "pus",
"poussé" => "puse",
"pousse-au-crime" => "pusokRim",
"pousse-café" => "puskafe",
"pousse-cailloux" => "puskaju",
"pousse-pousse" => "puspus",
"poussée" => "puse",
"poussées" => "puse",
"poussent" => "pus",
"pousser" => "puse",
"poussera" => "pus°Ra",
"pousserai" => "pus°RE",
"pousseraient" => "pus°RE",
"pousserais" => "pus°RE",
"pousserait" => "pus°RE",
"pousseras" => "pus°Ra",
"poussèrent" => "pusER",
"pousserez" => "pus°Re",
"pousseriez" => "pus°Rje",
"pousserions" => "pus°Rj§",
"pousserons" => "pus°R§",
"pousseront" => "pus°R§",
"pousses" => "pus",
"poussés" => "puse",
"poussette" => "pusEt",
"poussettes" => "pusEt",
"pousseur" => "pus9R",
"pousseurs" => "pus9R",
"poussez" => "puse",
"poussier" => "pusje",
"poussière" => "pusjER",
"poussières" => "pusjER",
"poussiéreuse" => "pusjeR2z",
"poussiéreuses" => "pusjeR2z",
"poussiéreux" => "pusjeR2",
"poussiez" => "pusje",
"poussif" => "pusif",
"poussifs" => "pusif",
"poussin" => "pus5",
"poussine" => "pusin",
"poussinière" => "pusinjER",
"poussins" => "pus5",
"poussions" => "pusj§",
"poussive" => "pusiv",
"poussivement" => "pusiv°m@",
"poussives" => "pusiv",
"poussoir" => "puswaR",
"poussons" => "pus§",
"poutargue" => "putaRg",
"poutine" => "putin",
"poutou" => "putu",
"poutrages" => "putRaZ",
"poutraison" => "putREz§",
"poutre" => "putR",
"poutrelle" => "putREl",
"poutrelles" => "putREl",
"poutres" => "putR",
"pouvaient" => "puvE",
"pouvais" => "puvE",
"pouvait" => "puvE",
"pouvant" => "puv@",
"pouvez" => "puve",
"pouviez" => "puvje",
"pouvions" => "puvj§",
"pouvoir" => "puvwaR",
"pouvoirs" => "puvwaR",
"pouvons" => "puv§",
"poux" => "pu",
"pouzzolane" => "pudzolan",
"practice" => "pRaktis",
"pradelle" => "pRadEl",
"praesidium" => "pRezidjOm",
"pragmatique" => "pRagmatik",
"pragmatiquement" => "pRagmatik°m@",
"pragmatiques" => "pRagmatik",
"pragmatisme" => "pRagmatizm",
"pragmatiste" => "pRagmatist",
"praire" => "pRER",
"praires" => "pRER",
"prairial" => "pRERjal",
"prairie" => "pReRi",
"prairies" => "pReRi",
"praline" => "pRalin",
"praliné" => "pRaline",
"pralines" => "pRalin",
"pralinés" => "pRaline",
"prang" => "pR@g",
"praticable" => "pRatikabl",
"praticables" => "pRatikabl",
"praticien" => "pRatisj5",
"praticienne" => "pRatisjEn",
"praticiens" => "pRatisj5",
"pratiqua" => "pRatika",
"pratiquai" => "pRatikE",
"pratiquaient" => "pRatikE",
"pratiquais" => "pRatikE",
"pratiquait" => "pRatikE",
"pratiquant" => "pRatik@",
"pratiquante" => "pRatik@t",
"pratiquants" => "pRatik@",
"pratiquât" => "pRatika",
"pratique" => "pRatik",
"pratiqué" => "pRatike",
"pratiquée" => "pRatike",
"pratiquées" => "pRatike",
"pratiquement" => "pRatik°m@",
"pratiquent" => "pRatik",
"pratiquer" => "pRatike",
"pratiquera" => "pRatik°Ra",
"pratiquerai" => "pRatik°RE",
"pratiquerais" => "pRatik°RE",
"pratiquerait" => "pRatik°RE",
"pratiquèrent" => "pRatikER",
"pratiquerons" => "pRatik°R§",
"pratiques" => "pRatik",
"pratiqués" => "pRatike",
"pratiquez" => "pRatike",
"pratiquiez" => "pRatikje",
"pratiquions" => "pRatikj§",
"pratiquons" => "pRatik§",
"praxie" => "pRaksi",
"pré" => "pRe",
"pré-établi" => "pReetabli",
"pré-salé" => "pResale",
"préadolescence" => "pReadOlEs@s",
"préadolescente" => "pReadOlEs@t",
"préalable" => "pRealabl",
"préalablement" => "pRealabl°m@",
"préalables" => "pRealabl",
"préambule" => "pRe@byl",
"préambules" => "pRe@byl",
"préau" => "pReo",
"préaux" => "pReo",
"préavis" => "pReavi",
"prébendes" => "pReb@d",
"précaire" => "pRekER",
"précairement" => "pRekER°m@",
"précaires" => "pRekER",
"précambrien" => "pRek@bRj5",
"précambrienne" => "pRek@bRiEn",
"précarité" => "pRekaRite",
"précaution" => "pRekosj§",
"précautionneuse" => "pRekosjon2z",
"précautionneusement" => "pRekosjon2z°m@",
"précautionneuses" => "pRekosjon2z",
"précautionneux" => "pRekosjon2",
"précautions" => "pRekosj§",
"précéda" => "pReseda",
"précédai" => "pResedE",
"précédaient" => "pResedE",
"précédais" => "pResedE",
"précédait" => "pResedE",
"précédant" => "pResed@",
"précédassent" => "pResedas",
"précède" => "pResEd",
"précédé" => "pResede",
"précédée" => "pResede",
"précédées" => "pResede",
"précédemment" => "pResedam@",
"précédent" => "pResed@",
"précèdent" => "pResEd",
"précédente" => "pResed@t",
"précédentes" => "pResed@t",
"précédents" => "pResed@",
"précéder" => "pResede",
"précédera" => "pResed°Ra",
"précéderai" => "pResed°RE",
"précéderaient" => "pResed°RE",
"précéderait" => "pResed°RE",
"précédèrent" => "pResedER",
"précéderions" => "pResed°Rj§",
"précédés" => "pResede",
"précédez" => "pResede",
"précédons" => "pResed§",
"précellence" => "pResel@s",
"précelles" => "pResEl",
"précepte" => "pResEpt",
"préceptes" => "pResEpt",
"précepteur" => "pResEpt9R",
"précepteurs" => "pResEpt9R",
"préceptrice" => "pResEptRis",
"précession" => "pResesj§",
"prêcha" => "pRESa",
"prêchaient" => "pRESE",
"prêchais" => "pRESE",
"prêchait" => "pRESE",
"prêchant" => "pRES@",
"préchauffage" => "pReSofaZ",
"préchauffer" => "pReSOfe",
"prêche" => "pRES",
"prêché" => "pReSe",
"prêchée" => "pReSe",
"prêchent" => "pRES",
"prêcher" => "pReSe",
"prêches" => "pRES",
"prêcheur" => "pRES9R",
"prêcheurs" => "pRES9R",
"prêcheuse" => "pRES2z",
"prêchez" => "pRESe",
"prêchi-prêcha" => "pRESipRESa",
"précieuse" => "pResj2z",
"précieusement" => "pResj2z°m@",
"précieuses" => "pResj2z",
"précieux" => "pResj2",
"préciosité" => "pResjozite",
"préciosités" => "pResjozite",
"précipice" => "pResipis",
"précipices" => "pResipis",
"précipita" => "pResipita",
"précipitai" => "pResipitE",
"précipitaient" => "pResipitE",
"précipitais" => "pResipitE",
"précipitait" => "pResipitE",
"précipitâmes" => "pResipitam",
"précipitamment" => "pResipitam@",
"précipitant" => "pResipit@",
"précipitât" => "pResipita",
"précipitation" => "pResipitasj§",
"précipitations" => "pResipitasj§",
"précipite" => "pResipit",
"précipité" => "pResipite",
"précipitée" => "pResipite",
"précipitées" => "pResipite",
"précipitent" => "pResipit",
"précipiter" => "pResipite",
"précipitera" => "pResipit°Ra",
"précipiterai" => "pResipit°RE",
"précipiteraient" => "pResipit°RE",
"précipiterais" => "pResipit°RE",
"précipiterait" => "pResipit°RE",
"précipiteras" => "pResipit°Ra",
"précipitèrent" => "pResipitER",
"précipiterez" => "pResipit°Re",
"précipiterions" => "pResipit°Rj§",
"précipiteront" => "pResipit°R§",
"précipites" => "pResipit",
"précipités" => "pResipite",
"précipitez" => "pResipite",
"précipitiez" => "pResipitje",
"précipitions" => "pResipitj§",
"précipitons" => "pResipit§",
"préciputs" => "pResipy",
"précis" => "pResi",
"précisa" => "pResiza",
"précisai" => "pResizE",
"précisaient" => "pResizE",
"précisais" => "pResizE",
"précisait" => "pResizE",
"précisant" => "pResiz@",
"précisât" => "pResiza",
"précise" => "pResiz",
"précisé" => "pResize",
"précisée" => "pResize",
"précisées" => "pResize",
"précisément" => "pResizem@",
"précisent" => "pResiz",
"préciser" => "pResize",
"précisera" => "pResiz°Ra",
"préciserai" => "pResiz°RE",
"préciserais" => "pResiz°RE",
"préciserait" => "pResiz°RE",
"précisèrent" => "pResizER",
"préciserez" => "pResiz°Re",
"préciseront" => "pResiz°R§",
"précises" => "pResiz",
"précisés" => "pResize",
"précisez" => "pResize",
"précision" => "pResizj§",
"précisions" => "pResizj§",
"précisons" => "pResiz§",
"précité" => "pResite",
"précitée" => "pResite",
"précitées" => "pResite",
"précités" => "pResite",
"précoce" => "pRekOs",
"précocement" => "pRekOs°m@",
"précoces" => "pRekOs",
"précocité" => "pRekosite",
"précognition" => "pRekOgnisj§",
"précolombien" => "pRekol§bj5",
"précolombienne" => "pRekol§bjEn",
"précolombiennes" => "pRekol§bjEn",
"préconçu" => "pRek§sy",
"préconçue" => "pRek§sy",
"préconçues" => "pRek§sy",
"préconisa" => "pRekoniza",
"préconisaient" => "pRekonizE",
"préconisais" => "pRekonizE",
"préconisait" => "pRekonizE",
"préconisant" => "pRekOniz@",
"préconisât" => "pRekoniza",
"préconisation" => "pRekonizasj§",
"préconise" => "pRekoniz",
"préconisé" => "pRekonize",
"préconisée" => "pRekonize",
"préconisées" => "pRekonize",
"préconisent" => "pRekoniz",
"préconiser" => "pRekonize",
"préconiserais" => "pRekoniz°RE",
"préconises" => "pRekoniz",
"préconisés" => "pRekonize",
"préconisez" => "pRekonize",
"préconisiez" => "pRekonizje",
"précuit" => "pRek8i",
"précuites" => "pRek8it",
"précurseur" => "pRekyRs9R",
"précurseurs" => "pRekyRs9R",
"prédateur" => "pRedat9R",
"prédateurs" => "pRedat9R",
"prédation" => "pRedasj§",
"prédatrice" => "pRedatRis",
"prédécesseur" => "pRedeses9R",
"prédécesseurs" => "pRedeses9R",
"prédécoupée" => "pRedekupe",
"prédéfini" => "pRedefini",
"prédéfinies" => "pRedefini",
"prédelle" => "pRedEl",
"prédestinaient" => "pRedEstinE",
"prédestination" => "pRedEstinasj§",
"prédestinations" => "pRedEstinasj§",
"prédestiné" => "pRedEstine",
"prédestinée" => "pRedEstine",
"prédestinées" => "pRedEstine",
"prédestinés" => "pRedEstine",
"prédéterminé" => "pRedetERmine",
"prédéterminée" => "pRedetERmine",
"prédéterminées" => "pRedetERmine",
"prédéterminer" => "pRedetERmine",
"prédéterminés" => "pRedetERmine",
"prédicant" => "pRedik@",
"prédicants" => "pRedik@",
"prédicat" => "pRedika",
"prédicateur" => "pRedikat9R",
"prédicateurs" => "pRedikat9R",
"prédication" => "pRedikasj§",
"prédications" => "pRedikasj§",
"prédictible" => "pRediktibl",
"prédictif" => "pRediktif",
"prédiction" => "pRediksj§",
"prédictions" => "pRediksj§",
"prédictive" => "pRediktiv",
"prédigéré" => "pRediZeRe",
"prédigestion" => "pRediZEstj§",
"prédilection" => "pRedilEksj§",
"prédilections" => "pRedilEksj§",
"prédira" => "pRediRa",
"prédire" => "pRediR",
"prédirent" => "pRediR",
"prédirez" => "pRediRe",
"prédis" => "pRedi",
"prédisaient" => "pRedizE",
"prédisait" => "pRedizE",
"prédisant" => "pRediz@",
"prédise" => "pRediz",
"prédisent" => "pRediz",
"prédisez" => "pRedize",
"prédisiez" => "pRedizje",
"prédisposait" => "pRedispozE",
"prédisposant" => "pRedispoz@",
"prédispose" => "pRedispoz",
"prédisposé" => "pRedispoze",
"prédisposée" => "pRedispoze",
"prédisposées" => "pRedispoze",
"prédisposés" => "pRedispoze",
"prédisposition" => "pRedispozisj§",
"prédispositions" => "pRedispozisj§",
"prédit" => "pRedi",
"prédite" => "pRedit",
"prédominaient" => "pRedominE",
"prédominait" => "pRedominE",
"prédominance" => "pRedomin@s",
"prédominant" => "pRedomin@",
"prédominante" => "pRedomin@t",
"prédomine" => "pRedomin",
"prédominer" => "pRedOmine",
"préélectoral" => "pReelEktoRal",
"préélectorale" => "pReelEktORal",
"prééminence" => "pReemin@s",
"prééminente" => "pReemin@t",
"préemption" => "pRe@psj§",
"préemptive" => "pRe@ptiv",
"préencollé" => "pRe@kole",
"préétabli" => "pReetabli",
"préétablie" => "pReetabli",
"préétablies" => "pReetabli",
"préétablis" => "pReetabli",
"préexistaient" => "pReEgzistE",
"préexistait" => "pReEgzistE",
"préexistant" => "pReEgzist@",
"préexistante" => "pReEgzist@t",
"préexistants" => "pReEgzist@",
"préexiste" => "pReEgzist",
"préexisté" => "pReEgziste",
"préfabriqué" => "pRefabRike",
"préfabriquée" => "pRefabRike",
"préfabriquées" => "pRefabRike",
"préfabriqués" => "pRefabRike",
"préface" => "pRefas",
"préfacé" => "pRefase",
"préfacées" => "pRefase",
"préfacent" => "pRefas",
"préfacer" => "pRefase",
"préfaces" => "pRefas",
"préfacier" => "pRefasje",
"préfectance" => "pRefEkt@s",
"préfectorale" => "pRefEktoRal",
"préfecture" => "pRefEktyR",
"préfectures" => "pRefEktyR",
"préféra" => "pRefeRa",
"préférable" => "pRefeRabl",
"préférablement" => "pRefeRabl2m@",
"préférables" => "pRefeRabl",
"préférai" => "pRefeRE",
"préféraient" => "pRefeRE",
"préférais" => "pRefeRE",
"préférait" => "pRefeRE",
"préférâmes" => "pRefeRam",
"préférant" => "pRefeR@",
"préférât" => "pRefeRa",
"préfère" => "pRefER",
"préféré" => "pRefeRe",
"préférée" => "pRefeRe",
"préférées" => "pRefeRe",
"préférence" => "pRefeR@s",
"préférences" => "pRefeR@s",
"préfèrent" => "pRefER",
"préférentiel" => "pRefeR@sjEl",
"préférentielle" => "pRefeR@sjEl",
"préférer" => "pRefeRe",
"préférera" => "pRefeR°Ra",
"préférerai" => "pRefeR°RE",
"préféreraient" => "pRefeR°RE",
"préférerais" => "pRefeR°RE",
"préférerait" => "pRefeR°RE",
"préféreras" => "pRefeR°Ra",
"préférèrent" => "pRefeRER",
"préférerez" => "pRefeR°Re",
"préféreriez" => "pRefeR°Rje",
"préférerions" => "pRefeR°Rj§",
"préféreront" => "pRefeR°R§",
"préfères" => "pRefER",
"préférés" => "pRefeRe",
"préférez" => "pRefeRe",
"préfériez" => "pRefeRje",
"préférions" => "pRefeRj§",
"préférons" => "pRefeR§",
"préfet" => "pRefE",
"préfets" => "pRefE",
"préfiguraient" => "pRefigyRE",
"préfigurait" => "pRefigyRE",
"préfigurant" => "pRefigyR@",
"préfiguration" => "pRefigyRasj§",
"préfigure" => "pRefigyR",
"préfiguré" => "pRefigyRe",
"préfigurée" => "pRefigyRe",
"préfigurent" => "pRefigyR",
"préfigurer" => "pRefigyRe",
"préfix" => "pRefiks",
"préfixation" => "pRefiksasj§",
"préfixe" => "pRefiks",
"préfixes" => "pRefiks",
"préformait" => "pRefORmE",
"préformation" => "pRefORmasj§",
"préformer" => "pRefORme",
"préfrontal" => "pRefR§tal",
"préfrontale" => "pRefR§tal",
"prégnance" => "pReN@s",
"prégnante" => "pRegn@t",
"préhenseur" => "pRe@s9R",
"préhensile" => "pRe@sil",
"préhension" => "pRe@sj§",
"préhensives" => "pRe@siv",
"préhistoire" => "pReistwaR",
"préhistorien" => "pReistoRj5",
"préhistorique" => "pReistoRik",
"préhistoriques" => "pReistoRik",
"préhominien" => "pReominj5",
"préindustriel" => "pRe5dystRijEl",
"préjudice" => "pReZydis",
"préjudices" => "pReZydis",
"préjudiciable" => "pReZydisjabl",
"préjudiciables" => "pReZydisjabl",
"préjuge" => "pReZyZ",
"préjugé" => "pReZyZe",
"préjugeait" => "pReZyZE",
"préjugeant" => "pReZyZ@",
"préjugée" => "pReZyZe",
"préjuger" => "pReZyZe",
"préjugés" => "pReZyZe",
"prélassaient" => "pRelasE",
"prélassais" => "pRelasE",
"prélassait" => "pRelasE",
"prélassant" => "pRelas@",
"prélasse" => "pRelas",
"prélassent" => "pRelas",
"prélasser" => "pRelase",
"prélassera" => "pRelas°Ra",
"prélassèrent" => "pRelasER",
"prélasseront" => "pRelas°R§",
"prélassez" => "pRelase",
"prélassiez" => "pRelasje",
"prélat" => "pRela",
"prélats" => "pRela",
"prélavage" => "pRelavaZ",
"prélaver" => "pRelave",
"prèle" => "pREl",
"prélegs" => "pRelE",
"prêles" => "pREl",
"préleva" => "pRel°va",
"prélevaient" => "pRel°vE",
"prélevais" => "pRel°vE",
"prélevait" => "pRel°vE",
"prélevant" => "pRel°v@",
"prélève" => "pRelEv",
"prélevé" => "pRel°ve",
"prélevée" => "pRel°ve",
"prélevées" => "pRel°ve",
"prélèvement" => "pRelEv°m@",
"prélèvements" => "pRelEv°m@",
"prélèvent" => "pRelEv",
"prélever" => "pRel°ve",
"prélèveraient" => "pRelEv°RE",
"prélèverait" => "pRelEv°RE",
"prélevèrent" => "pRel°vER",
"prélèverez" => "pRelEv°Re",
"prélèverions" => "pRelEv°Rj§",
"prélevés" => "pRel°ve",
"prélevez" => "pRel°ve",
"prélevons" => "pRel°v§",
"préliminaire" => "pReliminER",
"préliminaires" => "pReliminER",
"préluda" => "pRelyda",
"préludaient" => "pRelydE",
"préludait" => "pRelydE",
"préludant" => "pRelyd@",
"préludât" => "pRelyda",
"prélude" => "pRelyd",
"préludé" => "pRelyde",
"préludent" => "pRelyd",
"préluder" => "pRelyde",
"préluderait" => "pRelyd°RE",
"préludèrent" => "pRelydER",
"préludes" => "pRelyd",
"prématuré" => "pRematyRe",
"prématurée" => "pRematyRe",
"prématurées" => "pRematyRe",
"prématurément" => "pRematyRem@",
"prématurés" => "pRematyRe",
"prématurité" => "pRematyRite",
"préméditait" => "pRemeditE",
"préméditation" => "pRemeditasj§",
"préméditations" => "pRemeditasj§",
"prémédite" => "pRemedit",
"prémédité" => "pRemedite",
"préméditée" => "pRemedite",
"préméditées" => "pRemedite",
"préméditer" => "pRemedite",
"préméditera" => "pRemedit°Ra",
"prémédités" => "pRemedite",
"préméditons" => "pRemedit§",
"prémenstruel" => "pRem@stRyEl",
"prémenstruelle" => "pRem@stRyEl",
"prémices" => "pRemis",
"premier" => "pR2mje",
"premier-maître" => "pR2mjemEtR",
"premier-né" => "pR2mjene",
"première" => "pR2mjER",
"première-née" => "pR°mjERne",
"premièrement" => "pR2mjER°m@",
"premières" => "pR2mjER",
"premiers" => "pR2mje",
"premiers-nés" => "pR2mjene",
"prémisse" => "pRemis",
"prémisses" => "pRemis",
"premium" => "pRemjOm",
"prémolaire" => "pRemolER",
"prémolaires" => "pRemolER",
"prémonition" => "pRemonisj§",
"prémonitions" => "pRemonisj§",
"prémonitoire" => "pRemonitwaR",
"prémonitoires" => "pRemonitwaR",
"prémontrés" => "pRem§tRe",
"prémuni" => "pRemyni",
"prémunie" => "pRemyni",
"prémunir" => "pRemyniR",
"prémuniraient" => "pRemyniRE",
"prémunis" => "pRemyni",
"prémunissent" => "pRemynis",
"prenable" => "pR2nabl",
"prenables" => "pR2nabl",
"prenaient" => "pR2nE",
"prenais" => "pR2nE",
"prenait" => "pR2nE",
"prenant" => "pR2n@",
"prenante" => "pR2n@t",
"prenantes" => "pR2n@t",
"prenants" => "pR2n@",
"prénatal" => "pRenatal",
"prénatale" => "pRenatal",
"prénatales" => "pRenatal",
"prénataux" => "pRenato",
"prend" => "pR@",
"prendra" => "pR@dRa",
"prendrai" => "pR@dRE",
"prendraient" => "pR@dRE",
"prendrais" => "pR@dRE",
"prendrait" => "pR@dRE",
"prendras" => "pR@dRa",
"prendre" => "pR@dR",
"prendrez" => "pR@dRe",
"prendriez" => "pR@dRije",
"prendrions" => "pR@dRij§",
"prendrons" => "pR@dR§",
"prendront" => "pR@dR§",
"prends" => "pR@",
"preneur" => "pR°n9R",
"preneurs" => "pR°n9R",
"preneuse" => "pR°n2z",
"prenez" => "pR°ne",
"preniez" => "pR°nje",
"prenions" => "pR°nj§",
"prenne" => "pREn",
"prennent" => "pREn",
"prennes" => "pREn",
"prénom" => "pRen§",
"prénom-type" => "pRen§tip",
"prénomma" => "pRenoma",
"prénommaient" => "pRenomE",
"prénommais" => "pRenomE",
"prénommait" => "pRenomE",
"prénommant" => "pRenom@",
"prénommât" => "pRenoma",
"prénomme" => "pRenOm",
"prénommé" => "pRenome",
"prénommée" => "pRenome",
"prénomment" => "pRenOm",
"prénommer" => "pRenome",
"prénommèrent" => "pRenomER",
"prénommez" => "pRenome",
"prénoms" => "pRen§",
"prenons" => "pR°n§",
"prénuptial" => "pRenypsjal",
"prénuptiale" => "pRenypsjal",
"préoccupa" => "pReokypa",
"préoccupai" => "pReokypE",
"préoccupaient" => "pReokypE",
"préoccupais" => "pReokypE",
"préoccupait" => "pReokypE",
"préoccupant" => "pReokyp@",
"préoccupante" => "pReokyp@t",
"préoccupantes" => "pReokyp@t",
"préoccupât" => "pReokypa",
"préoccupâtes" => "pReokypat",
"préoccupation" => "pReokypasj§",
"préoccupations" => "pReokypasj§",
"préoccupe" => "pReokyp",
"préoccupé" => "pReokype",
"préoccupée" => "pReokype",
"préoccupées" => "pReokype",
"préoccupent" => "pReokyp",
"préoccuper" => "pReokype",
"préoccupera" => "pReokyp°Ra",
"préoccuperai" => "pReokyp°RE",
"préoccuperaient" => "pReokyp°RE",
"préoccuperais" => "pReokyp°RE",
"préoccuperait" => "pReokyp°RE",
"préoccupèrent" => "pReokypER",
"préoccupes" => "pReokyp",
"préoccupés" => "pReokype",
"préoccupez" => "pReokype",
"préoccupiez" => "pReokypje",
"préoccupions" => "pReokypj§",
"préoccupons" => "pReokyp§",
"préopératoire" => "pReopeRatwaR",
"prépa" => "pRepa",
"prépara" => "pRepaRa",
"préparai" => "pRepaRE",
"préparaient" => "pRepaRE",
"préparais" => "pRepaRE",
"préparait" => "pRepaRE",
"préparant" => "pRepaR@",
"préparât" => "pRepaRa",
"préparateur" => "pRepaRat9R",
"préparateurs" => "pRepaRat9R",
"préparatif" => "pRepaRatif",
"préparatifs" => "pRepaRatif",
"préparation" => "pRepaRasj§",
"préparations" => "pRepaRasj§",
"préparatoire" => "pRepaRatwaR",
"préparatoires" => "pRepaRatwaR",
"préparatrice" => "pRepaRatRis",
"préparatrices" => "pRepaRatRis",
"prépare" => "pRepaR",
"préparé" => "pRepaRe",
"préparée" => "pRepaRe",
"préparées" => "pRepaRe",
"préparent" => "pRepaR",
"préparer" => "pRepaRe",
"préparera" => "pRepaR°Ra",
"préparerai" => "pRepaR°RE",
"prépareraient" => "pRepaR°RE",
"préparerais" => "pRepaR°RE",
"préparerait" => "pRepaR°RE",
"prépareras" => "pRepaR°Ra",
"préparèrent" => "pRepaRER",
"préparerez" => "pRepaR°Re",
"préparerons" => "pRepaR°R§",
"prépareront" => "pRepaR°R§",
"prépares" => "pRepaR",
"préparés" => "pRepaRe",
"préparez" => "pRepaRe",
"prépariez" => "pRepaRje",
"préparions" => "pRepaRj§",
"préparons" => "pRepaR§",
"prépayée" => "pRepeje",
"prépondérance" => "pRep§deR@s",
"prépondérant" => "pRep§deR@",
"prépondérante" => "pRep§deR@t",
"prépondérants" => "pRep§deR@",
"préposé" => "pRepoze",
"préposée" => "pRepoze",
"préposées" => "pRepoze",
"préposés" => "pRepoze",
"préposition" => "pRepozisj§",
"prépositions" => "pRepozisj§",
"prépotence" => "pRepot@s",
"préprogrammé" => "pRepRogRame",
"préprogrammée" => "pRepROgRame",
"prépubère" => "pRepybER",
"prépuce" => "pRepys",
"prépuces" => "pRepys",
"préraphaélite" => "pReRafaelit",
"préréglé" => "pReRegle",
"prérentrée" => "pReR@tRe",
"préretraite" => "pReR°tREt",
"prérévolutionnaire" => "pReRevolysjonER",
"prérogative" => "pReRogativ",
"prérogatives" => "pReRogativ",
"préroman" => "pReRom@",
"prés" => "pRe",
"près" => "pRE",
"près de" => "pREd2",
"présage" => "pRezaZ",
"présagé" => "pRezaZe",
"présagea" => "pRezaZa",
"présageaient" => "pRezaZE",
"présageait" => "pRezaZE",
"présagent" => "pRezaZ",
"présager" => "pRezaZe",
"présagerait" => "pRezaZ°RE",
"présages" => "pRezaZ",
"presbyte" => "pREsbit",
"presbytère" => "pREsbitER",
"presbytérien" => "pREsbiteRj5",
"presbytérienne" => "pREsbiteRjEn",
"presbytériennes" => "pREsbiteRjEn",
"presbyterium" => "pREzbit°RjOm",
"presbytie" => "pREsbisi",
"prescience" => "pResj@s",
"presciente" => "pResj@t",
"préscolaire" => "pReskolER",
"préscolaires" => "pReskolER",
"prescription" => "pREskRipsj§",
"prescriptions" => "pREskRipsj§",
"prescrirait" => "pREskRiRE",
"prescrire" => "pREskRiR",
"prescris" => "pREskRi",
"prescrit" => "pREskRi",
"prescrite" => "pREskRit",
"prescrites" => "pREskRit",
"prescrits" => "pREskRi",
"prescrivaient" => "pREskRivE",
"prescrivais" => "pREskRivE",
"prescrivait" => "pREskRivE",
"prescrivant" => "pREskRiv@",
"prescrive" => "pREskRiv",
"prescrivent" => "pREskRiv",
"prescrivez" => "pREskRive",
"prescrivis" => "pREskRivi",
"prescrivit" => "pREskRivi",
"préséance" => "pRese@s",
"préséances" => "pRese@s",
"présélection" => "pReselEksj§",
"présélectionné" => "pReselEksjone",
"présélectionnée" => "pReselEksjone",
"présélections" => "pRezElEksj§",
"présence" => "pRez@s",
"présences" => "pRez@s",
"préséniles" => "pRezenil",
"présent" => "pRez@",
"présenta" => "pRez@ta",
"présentable" => "pRez@tabl",
"présentables" => "pRez@tabl",
"présentai" => "pRez@tE",
"présentaient" => "pRez@tE",
"présentais" => "pRez@tE",
"présentait" => "pRez@tE",
"présentant" => "pRez@t@",
"présentassent" => "pRez@tas",
"présentât" => "pRez@ta",
"présentateur" => "pRez@tat9R",
"présentateurs" => "pRez@tat9R",
"présentation" => "pRez@tasj§",
"présentations" => "pRez@tasj§",
"présentatrice" => "pRez@tatRis",
"présentatrices" => "pRez@tatRis",
"présente" => "pRez@t",
"présenté" => "pRez@te",
"présentée" => "pRez@te",
"présentées" => "pRez@te",
"présentement" => "pRez@t°m@",
"présentent" => "pRez@t",
"présenter" => "pRez@te",
"présentera" => "pRez@t°Ra",
"présenterai" => "pRez@t°RE",
"présenteraient" => "pRez@t°RE",
"présenterais" => "pRez@t°RE",
"présenterait" => "pRez@t°RE",
"présenteras" => "pRez@t°Ra",
"présentèrent" => "pRez@tER",
"présenterez" => "pRez@t°Re",
"présenteriez" => "pRez@t°Rje",
"présenterons" => "pRez@t°R§",
"présenteront" => "pRez@t°R§",
"présentes" => "pRez@t",
"présentés" => "pRez@te",
"présentez" => "pRez@te",
"présentiez" => "pRez@tje",
"présentions" => "pRez@tj§",
"présentoir" => "pRez@twaR",
"présentoirs" => "pRez@twaR",
"présentons" => "pRez@t§",
"présents" => "pRez@",
"préserva" => "pRezERva",
"préservaient" => "pRezERvE",
"préservais" => "pRezERvE",
"préservait" => "pRezERvE",
"préservant" => "pRezERv@",
"préservateur" => "pRezERvat9R",
"préservatif" => "pRezERvatif",
"préservatifs" => "pRezERvatif",
"préservation" => "pRezERvasj§",
"préserve" => "pRezERv",
"préservé" => "pRezERve",
"préservée" => "pRezERve",
"préservées" => "pRezERve",
"préservent" => "pRezERv",
"préserver" => "pRezERve",
"préservera" => "pRezERv°Ra",
"préserverai" => "pRezERv°RE",
"préserverait" => "pRezERv°RE",
"préservés" => "pRezERve",
"préservez" => "pRezERve",
"préservons" => "pRezERv§",
"présida" => "pRezida",
"présidai" => "pRezidE",
"présidaient" => "pRezidE",
"présidais" => "pRezidE",
"présidait" => "pRezidE",
"présidant" => "pRezid@",
"présidât" => "pRezida",
"préside" => "pRezid",
"présidé" => "pRezide",
"présidée" => "pRezide",
"présidence" => "pRezid@s",
"présidences" => "pRezid@s",
"président" => "pRezid@",
"président-directeur" => "pRezid@diREkt9R",
"présidente" => "pRezid@t",
"présidentes" => "pRezid@t",
"présidentiable" => "pRezid@sjabl",
"présidentiables" => "pRezid@sjabl",
"présidentiel" => "pRezid@sjEl",
"présidentielle" => "pRezid@sjEl",
"présidentielles" => "pRezid@sjEl",
"présidentiels" => "pRezid@sjEl",
"présidents" => "pRezid@",
"présidents-directeurs" => "pRezid@diREkt9R",
"présider" => "pRezide",
"présidera" => "pRezid°Ra",
"présiderai" => "pRezid°RE",
"présiderais" => "pRezid°RE",
"présiderait" => "pRezid°RE",
"présideras" => "pRezid°Ra",
"présidèrent" => "pRezidER",
"présiderez" => "pRezid°Re",
"présides" => "pRezid",
"présidés" => "pRezide",
"présidiez" => "pRezidje",
"présidium" => "pRezidjOm",
"présidons" => "pRezid§",
"présocratique" => "pResokRatik",
"présocratiques" => "pResokRatik",
"présomptif" => "pRez§ptif",
"présomption" => "pRez§psj§",
"présomptions" => "pRez§psj§",
"présomptive" => "pRez§ptiv",
"présomptueuse" => "pRez§pt82z",
"présomptueuses" => "pRez§pt82z",
"présomptueux" => "pRez§pt82",
"presqu'île" => "pREskil",
"presqu'îles" => "pREskil",
"presque" => "pREsk",
"press-book" => "pREsbuk",
"pressa" => "pREsa",
"pressage" => "pREsaZ",
"pressai" => "pREsE",
"pressaient" => "pREsE",
"pressais" => "pREsE",
"pressait" => "pREsE",
"pressant" => "pREs@",
"pressante" => "pREs@t",
"pressantes" => "pREs@t",
"pressants" => "pREs@",
"pressât" => "pREsa",
"presse" => "pREs",
"pressé" => "pRese",
"presse-agrumes" => "pREsagRym",
"presse-bouton" => "pREsbut§",
"presse-citron" => "pREssitR§",
"presse-fruits" => "pREsfR8i",
"presse-papier" => "pREspapje",
"presse-papiers" => "pREspapje",
"presse-purée" => "pREspyRe",
"presse-raquette" => "pREsRakEt",
"pressée" => "pRese",
"pressées" => "pRese",
"pressement" => "pREs°m@",
"pressements" => "pREs°m@",
"pressens" => "pRes@",
"pressent" => "pRes@",
"pressentaient" => "pRes@tE",
"pressentais" => "pRes@tE",
"pressentait" => "pRes@tE",
"pressentant" => "pRes@t@",
"pressentent" => "pRes@t",
"pressentez" => "pRes@te",
"pressenti" => "pRes@ti",
"pressentie" => "pRes@ti",
"pressenties" => "pRes@ti",
"pressentiez" => "pREs@tje",
"pressentiment" => "pRes@tim@",
"pressentiments" => "pRes@tim@",
"pressentîmes" => "pRes@tim",
"pressentions" => "pRes@tj§",
"pressentir" => "pRes@tiR",
"pressentirez" => "pRes@tiRe",
"pressentis" => "pRes@ti",
"pressentit" => "pRes@ti",
"pressentît" => "pRes@ti",
"pressentons" => "pRes@t§",
"presser" => "pRese",
"pressera" => "pREs°Ra",
"presserai" => "pREs°RE",
"presseraient" => "pREs°RE",
"presserait" => "pREs°RE",
"pressèrent" => "pREsER",
"presseront" => "pREs°R§",
"presses" => "pREs",
"pressés" => "pRese",
"presseur" => "pREs9R",
"pressez" => "pREse",
"pressiez" => "pREsje",
"pressing" => "pResiG",
"pressings" => "pResiG",
"pression" => "pREsj§",
"pressionnée" => "pREsjone",
"pressions" => "pREsj§",
"pressoir" => "pREswaR",
"pressoirs" => "pREswaR",
"pressons" => "pREs§",
"pressurant" => "pResyR@",
"pressure" => "pResyR",
"pressurée" => "pResyRe",
"pressurer" => "pResyRe",
"pressures" => "pResyR",
"pressurés" => "pResyRe",
"pressurisation" => "pREsyRizasj§",
"pressurisé" => "pResyRize",
"pressurisée" => "pResyRize",
"pressurisées" => "pResyRize",
"pressuriser" => "pREsyRize",
"pressurisés" => "pREsyRize",
"pressurisez" => "pREsyRize",
"prestance" => "pREst@s",
"prestataire" => "pREstatER",
"prestataires" => "pREstatER",
"prestation" => "pREstasj§",
"prestations" => "pREstasj§",
"preste" => "pREst",
"prestement" => "pREst°m@",
"prestes" => "pREst",
"prestesse" => "pREstEs",
"prestidigitateur" => "pREstidiZitat9R",
"prestidigitateurs" => "pREstidiZitat9R",
"prestidigitation" => "pREstidiZitasj§",
"prestidigitations" => "pREstidiZitasj§",
"prestidigitatrice" => "pREstidiZitatRis",
"prestige" => "pREstiZ",
"prestiges" => "pREstiZ",
"prestigieuse" => "pREstiZj2z",
"prestigieuses" => "pREstiZj2z",
"prestigieux" => "pREstiZj2",
"presto" => "pREsto",
"présumables" => "pRezymabl",
"présumai" => "pRezymE",
"présumais" => "pRezymE",
"présumait" => "pRezymE",
"présumant" => "pRezym@",
"présume" => "pRezym",
"présumé" => "pRezyme",
"présumée" => "pRezyme",
"présumées" => "pRezyme",
"présumer" => "pRezyme",
"présumerai" => "pRezym°RE",
"présumés" => "pRezyme",
"présumez" => "pRezyme",
"présumons" => "pRezym§",
"présupposant" => "pResypoz@",
"présuppose" => "pResypoz",
"présupposée" => "pResypoze",
"présupposent" => "pResypoz",
"prêt" => "pRE",
"prêt-à-porter" => "pREtapORte",
"prêt-bail" => "pREbaj",
"prêta" => "pREta",
"prêtai" => "pREtE",
"prêtaient" => "pREtE",
"prêtais" => "pREtE",
"prêtait" => "pREtE",
"prêtâmes" => "pREtam",
"prêtant" => "pREt@",
"prêtassent" => "pREtas",
"prêtât" => "pREta",
"prête" => "pREt",
"prêté" => "pRete",
"prête-nom" => "pREtn§",
"prêtée" => "pRete",
"prêtées" => "pRete",
"prétend" => "pRet@",
"prétendaient" => "pRet@dE",
"prétendais" => "pRet@dE",
"prétendait" => "pRet@dE",
"prétendant" => "pRet@d@",
"prétendante" => "pRet@d@t",
"prétendants" => "pRet@d@",
"prétende" => "pRet@d",
"prétendent" => "pRet@d",
"prétendez" => "pRet@de",
"prétendiez" => "pRet@dje",
"prétendions" => "pRet@dj§",
"prétendirent" => "pRet@diR",
"prétendis" => "pRet@di",
"prétendissent" => "pRet@dis",
"prétendit" => "pRet@di",
"prétendît" => "pRet@di",
"prétendons" => "pRet@d§",
"prétendra" => "pRet@dRa",
"prétendrai" => "pRet@dRE",
"prétendraient" => "pRet@dRE",
"prétendrais" => "pRet@dRE",
"prétendrait" => "pRet@dRE",
"prétendras" => "pRet@dRa",
"prétendre" => "pRet@dR",
"prétendront" => "pRet@dR§",
"prétends" => "pRet@",
"prétendu" => "pRet@dy",
"prétendue" => "pRet@dy",
"prétendues" => "pRet@dy",
"prétendument" => "pRet@dym@",
"prétendus" => "pRet@dy",
"prêtent" => "pREt",
"prétentaine" => "pRet@tEn",
"prétentiard" => "pRet@sjaR",
"prétentiarde" => "pRet@sjaRd",
"prétentiards" => "pRet@sjaR",
"prétentieuse" => "pRet@sj2z",
"prétentieuses" => "pRet@sj2z",
"prétentieux" => "pRet@sj2",
"prétention" => "pRet@sj§",
"prétentions" => "pRet@sj§",
"prêter" => "pRete",
"prêtera" => "pREt°Ra",
"prêterai" => "pREt°RE",
"prêteraient" => "pREt°RE",
"prêterais" => "pREt°RE",
"prêterait" => "pREt°RE",
"prêteras" => "pREt°Ra",
"prêtèrent" => "pREtER",
"prêterez" => "pREt°Re",
"prêteriez" => "pREt°Rje",
"prêterions" => "pREt°Rj§",
"préternaturel" => "pRetERnatyREl",
"prêterons" => "pREt°R§",
"prêteront" => "pREt°R§",
"prêtes" => "pREt",
"prêtés" => "pRete",
"préteur" => "pRet9R",
"prêteur" => "pREt9R",
"préteurs" => "pRet9R",
"prêteurs" => "pREt9R",
"prêteuse" => "pREt2z",
"prétexta" => "pRetEksta",
"prétextai" => "pRetEkstE",
"prétextait" => "pRetEkstE",
"prétextant" => "pRetEkst@",
"prétexte" => "pRetEkst",
"prétexté" => "pRetEkste",
"prétextent" => "pRetEkst",
"prétexter" => "pRetEkste",
"prétextes" => "pRetEkst",
"prêtez" => "pREte",
"prêtiez" => "pREtje",
"prêtions" => "pREtj§",
"prétoire" => "pRetwaR",
"prétoires" => "pRetwaR",
"prêtons" => "pREt§",
"prétorien" => "pRetORj5",
"prétorienne" => "pRetoRjEn",
"prétoriennes" => "pRetoRjEn",
"prétoriens" => "pRetoRj5",
"prêtraille" => "pREtRaj",
"prêtre" => "pREtR",
"prêtre-ouvrier" => "pREtRuvRije",
"prêtres" => "pREtR",
"prêtresse" => "pREtREs",
"prêtresses" => "pREtREs",
"prêtrise" => "pRetRiz",
"prêts" => "pRE",
"préture" => "pRetyR",
"preuve" => "pR9v",
"preuves" => "pR9v",
"preux" => "pR2",
"prévalaient" => "pRevalE",
"prévalait" => "pRevalE",
"prévalant" => "pReval@",
"prévalence" => "pReval@s",
"prévalent" => "pReval",
"prévalez" => "pRevale",
"prévaloir" => "pRevalwaR",
"prévalu" => "pRevaly",
"prévalut" => "pRevaly",
"prévaricateur" => "pRevaRikat9R",
"prévaudra" => "pRevodRa",
"prévaudrait" => "pRevodRE",
"prévaudront" => "pRevodR§",
"prévaut" => "pRevo",
"prévenaient" => "pRev°nE",
"prévenais" => "pRev°nE",
"prévenait" => "pRev°nE",
"prévenance" => "pREv°n@s",
"prévenances" => "pRev°n@s",
"prévenant" => "pREv°n@",
"prévenante" => "pREv°n@t",
"prévenants" => "pRev°n@",
"prévenez" => "pRev°ne",
"préveniez" => "pRev°nje",
"prévenions" => "pRev°nj§",
"prévenir" => "pREv°niR",
"prévenons" => "pRev°n§",
"préventif" => "pRev@tif",
"prévention" => "pRev@sj§",
"préventions" => "pRev@sj§",
"préventive" => "pRev@tiv",
"préventivement" => "pRev@tiv°m@",
"préventives" => "pRev@tiv",
"préventorium" => "pRev@toRjOm",
"prévenu" => "pREv°ny",
"prévenue" => "pREv°ny",
"prévenues" => "pRev°ny",
"prévenus" => "pRev°ny",
"préviendra" => "pRevj5dRa",
"préviendrai" => "pRevj5dRE",
"préviendrais" => "pRevj5dRE",
"préviendrait" => "pRevj5dRE",
"préviendras" => "pRevj5dRa",
"préviendrez" => "pRevj5dRe",
"préviendrons" => "pRevj5dR§",
"préviendront" => "pRevj5dR§",
"prévienne" => "pRevjEn",
"préviennent" => "pRevjEn",
"préviennes" => "pRevjEn",
"préviens" => "pRevj5",
"prévient" => "pRevj5",
"prévins" => "pRev5",
"prévint" => "pRev5",
"prévînt" => "pRev5",
"prévis" => "pRevi",
"prévisibilité" => "pRevizibilite",
"prévisible" => "pRevizibl",
"prévisibles" => "pRevizibl",
"prévision" => "pRevizj§",
"prévisionnel" => "pRevizjonEl",
"prévisionnelles" => "pRevizjonEl",
"prévisionnels" => "pRevizjonEl",
"prévisions" => "pRevizj§",
"prévit" => "pRevi",
"prévoie" => "pRevwa",
"prévoient" => "pRevwa",
"prévoies" => "pRevwa",
"prévoir" => "pRevwaR",
"prévoira" => "pRevwaRa",
"prévoirait" => "pRevwaRE",
"prévois" => "pRevwa",
"prévoit" => "pRevwa",
"prévôt" => "pRevo",
"prévôté" => "pRevote",
"prévôts" => "pRevo",
"prévoyaient" => "pRevwajE",
"prévoyais" => "pRevwajE",
"prévoyait" => "pRevwajE",
"prévoyance" => "pRevwaj@s",
"prévoyances" => "pRevwaj@s",
"prévoyant" => "pRevwaj@",
"prévoyante" => "pRevwaj@t",
"prévoyantes" => "pRevwaj@t",
"prévoyants" => "pRevwaj@",
"prévoyez" => "pRevwaje",
"prévoyions" => "pRevwajj§",
"prévoyons" => "pRevwaj§",
"prévu" => "pRevy",
"prévue" => "pRevy",
"prévues" => "pRevy",
"prévus" => "pRevy",
"pria" => "pRija",
"priai" => "pRijE",
"priaient" => "pRijE",
"priais" => "pRijE",
"priait" => "pRijE",
"priâmes" => "pRijam",
"priant" => "pRij@",
"priapique" => "pRijapik",
"priapiques" => "pRijapik",
"priapisme" => "pRijapizm",
"priasse" => "pRijas",
"priât" => "pRija",
"prie" => "pRi",
"prié" => "pRije",
"prie-dieu" => "pRidj2",
"priée" => "pRije",
"priées" => "pRije",
"prient" => "pRi",
"prier" => "pRije",
"priera" => "pRiRa",
"prierai" => "pRiRE",
"prieraient" => "pRiRE",
"prierais" => "pRiRE",
"prierait" => "pRiRE",
"prieras" => "pRiRa",
"prière" => "pRijER",
"prièrent" => "pRijER",
"prières" => "pRijER",
"prierez" => "pRiRe",
"prierons" => "pRiR§",
"prieront" => "pRiR§",
"pries" => "pRi",
"priés" => "pRije",
"prieur" => "pRij9R",
"prieure" => "pRij9R",
"prieuré" => "pRij9Re",
"prieurés" => "pRij9Re",
"prieurs" => "pRij9R",
"priez" => "pRije",
"priions" => "pRijj§",
"prima" => "pRima",
"primaire" => "pRimER",
"primaires" => "pRimER",
"primait" => "pRimE",
"primal" => "pRimal",
"primale" => "pRimal",
"primant" => "pRim@",
"primat" => "pRima",
"primate" => "pRimat",
"primates" => "pRimat",
"primatologue" => "pRimatOlOg",
"primauté" => "pRimote",
"prime" => "pRim",
"primé" => "pRime",
"prime time" => "pRimtajm",
"prime-saut" => "pRimso",
"primée" => "pRime",
"primées" => "pRime",
"priment" => "pRim",
"primer" => "pRime",
"primerait" => "pRim°RE",
"primerose" => "pRim°Roz",
"primes" => "pRim",
"prîmes" => "pRim",
"primés" => "pRime",
"primesautier" => "pRimsotje",
"primesautière" => "pRimsotjER",
"primesautiers" => "pRimsotje",
"primeur" => "pRim9R",
"primeurs" => "pRim9R",
"primevère" => "pRimvER",
"primevères" => "pRimvER",
"primidi" => "pRimidi",
"primitif" => "pRimitif",
"primitifs" => "pRimitif",
"primitive" => "pRimitiv",
"primitivement" => "pRimitiv°m@",
"primitives" => "pRimitiv",
"primitivisme" => "pRimitivizm",
"primo" => "pRimo",
"primo-infection" => "pRimo5fEksj§",
"primordial" => "pRimORdjal",
"primordiale" => "pRimORdjal",
"primordialement" => "pRimORdjal°m@",
"primordiales" => "pRimORdjal",
"primordiaux" => "pRimORdjo",
"prin" => "pR5",
"prince" => "pR5s",
"prince-de-galles" => "pR5sd°gal",
"prince-évêque" => "pR5sevEk",
"princeps" => "pR5sEps",
"princes" => "pR5s",
"princesse" => "pR5sEs",
"princesses" => "pR5sEs",
"princier" => "pR5sje",
"princière" => "pR5sjER",
"princièrement" => "pR5sjER°m@",
"princières" => "pR5sjER",
"princiers" => "pR5sje",
"principal" => "pR5sipal",
"principale" => "pR5sipal",
"principalement" => "pR5sipal°m@",
"principales" => "pR5sipal",
"principat" => "pR5sipa",
"principauté" => "pR5sipote",
"principautés" => "pR5sipote",
"principaux" => "pR5sipo",
"principe" => "pR5sip",
"principes" => "pR5sip",
"printanier" => "pR5tanje",
"printanière" => "pR5tanjER",
"printanières" => "pR5tanjER",
"printaniers" => "pR5tanje",
"printemps" => "pR5t@",
"prion" => "pRij§",
"prions" => "pRij§",
"prioritaire" => "pRijoRitER",
"prioritaires" => "pRijoRitER",
"priorité" => "pRijoRite",
"priorités" => "pRijoRite",
"prirent" => "pRiR",
"pris" => "pRi",
"prisa" => "pRiza",
"prisaient" => "pRizE",
"prisait" => "pRizE",
"prisant" => "pRiz@",
"prise" => "pRiz",
"prisé" => "pRize",
"prisée" => "pRize",
"prisées" => "pRize",
"prisent" => "pRiz",
"priser" => "pRize",
"prises" => "pRiz",
"prisés" => "pRize",
"priseur" => "pRiz9R",
"priseurs" => "pRiz9R",
"prisez" => "pRize",
"prismatique" => "pRismatik",
"prismatiques" => "pRismatik",
"prisme" => "pRizm",
"prismes" => "pRizm",
"prison" => "pRiz§",
"prisonnier" => "pRizonje",
"prisonnière" => "pRizonjER",
"prisonnières" => "pRizonjER",
"prisonniers" => "pRizonje",
"prisons" => "pRiz§",
"prisons-écoles" => "pRiz§ekOl",
"prisse" => "pRis",
"prissent" => "pRis",
"prissions" => "pRisj§",
"pristi" => "pRisti",
"prisunic" => "pRizynik",
"prit" => "pRi",
"prît" => "pRi",
"priva" => "pRiva",
"privai" => "pRivE",
"privaient" => "pRivE",
"privais" => "pRivE",
"privait" => "pRivE",
"privant" => "pRiv@",
"privasse" => "pRivas",
"privât" => "pRiva",
"privatif" => "pRivatif",
"privatifs" => "pRivatif",
"privation" => "pRivasj§",
"privations" => "pRivasj§",
"privatisation" => "pRivatizasj§",
"privatisé" => "pRivatize",
"privatisée" => "pRivatize",
"privatiser" => "pRivatize",
"privatisés" => "pRivatize",
"privative" => "pRivativ",
"privatives" => "pRivativ",
"privauté" => "pRivote",
"privautés" => "pRivote",
"prive" => "pRiv",
"privé" => "pRive",
"privée" => "pRive",
"privées" => "pRive",
"privément" => "pRivem@",
"privent" => "pRiv",
"priver" => "pRive",
"privera" => "pRiv°Ra",
"priverai" => "pRiv°RE",
"priveraient" => "pRiv°RE",
"priverais" => "pRiv°RE",
"priverait" => "pRiv°RE",
"priveras" => "pRiv°Ra",
"privèrent" => "pRivER",
"priveriez" => "pRiv°Rje",
"prives" => "pRiv",
"privés" => "pRive",
"privez" => "pRive",
"priviez" => "pRivje",
"privilège" => "pRivilEZ",
"privilèges" => "pRivilEZ",
"privilégiait" => "pRivileZjE",
"privilégiant" => "pRivileZj@",
"privilégie" => "pRivileZi",
"privilégié" => "pRivileZje",
"privilégiée" => "pRivileZje",
"privilégiées" => "pRivileZje",
"privilégient" => "pRivileZi",
"privilégier" => "pRivileZje",
"privilégiés" => "pRivileZje",
"privilégions" => "pRivileZj§",
"privions" => "pRivj§",
"privons" => "pRiv§",
"prix" => "pRi",
"prix-choc" => "pRiSOk",
"pro" => "pRo",
"pro-occidental" => "pRoOksid@tal",
"proactif" => "pRoaktif",
"probabilité" => "pRobabilite",
"probabilités" => "pRobabilite",
"probable" => "pRobabl°",
"probablement" => "pRobabl°m@",
"probables" => "pRobabl°",
"probant" => "pRob@",
"probante" => "pRob@t",
"probantes" => "pRob@t",
"probants" => "pRob@",
"probation" => "pRobasj§",
"probatoire" => "pRobatwaR",
"probe" => "pROb",
"probes" => "pROb",
"probité" => "pRobite",
"problématique" => "pRoblematik",
"problématiques" => "pRoblematik",
"problème" => "pRoblEm",
"problèmes" => "pRoblEm",
"probloc" => "pRoblOk",
"problocs" => "pRoblOk",
"probloque" => "pRoblOk",
"probloques" => "pRoblOk",
"proc" => "pROk",
"procaïne" => "pROkain",
"procalmadiol" => "pRokalmadjOl",
"procéda" => "pRoseda",
"procédaient" => "pRosedE",
"procédais" => "pRosedE",
"procédait" => "pRosedE",
"procédâmes" => "pRosedam",
"procédant" => "pRosed@",
"procédât" => "pRoseda",
"procède" => "pRosEd",
"procédé" => "pRosede",
"procèdent" => "pRosEd",
"procéder" => "pRosede",
"procédera" => "pRosed°Ra",
"procéderaient" => "pRosed°RE",
"procéderais" => "pRosed°RE",
"procéderait" => "pRosed°RE",
"procéderez" => "pRosed°Re",
"procéderiez" => "pRosed°Rje",
"procéderons" => "pRosed°R§",
"procéderont" => "pRosed°R§",
"procédés" => "pRosede",
"procédez" => "pRosede",
"procédiez" => "pRosedje",
"procédions" => "pRosedj§",
"procédons" => "pRosed§",
"procédural" => "pROsedyRal",
"procédurale" => "pROsedyRal",
"procédure" => "pRosedyR",
"procédures" => "pRosedyR",
"procédurier" => "pRosedyRje",
"procédurière" => "pRosedyRjER",
"procédurières" => "pRosedyRjER",
"procès" => "pRosE",
"procès-test" => "pRosEtEst",
"procès-verbal" => "pRosEvERbal",
"procès-verbaux" => "pRosEvERbo",
"process" => "pROsEs",
"processeur" => "pRoses9R",
"processeurs" => "pRosEs9R",
"procession" => "pRosesj§",
"processionnaient" => "pRosesjonE",
"processionnaire" => "pRosesjonER",
"processionnaires" => "pRosesjonER",
"processionnant" => "pRosesjon@",
"processionnelle" => "pRosesjonEl",
"processionnelles" => "pRosesjonEl",
"processions" => "pRosesj§",
"processus" => "pRosesys",
"prochain" => "pRoS5",
"prochaine" => "pRoSEn",
"prochainement" => "pRoSEn°m@",
"prochaines" => "pRoSEn",
"prochains" => "pRoS5",
"proche" => "pROS",
"proche-oriental" => "pROSORj@tal",
"proches" => "pROS",
"prochinois" => "pRoSinwa",
"prochinoise" => "pRoSinwaz",
"proclama" => "pRoklama",
"proclamai" => "pRoklamE",
"proclamaient" => "pRoklamE",
"proclamais" => "pRoklamE",
"proclamait" => "pRoklamE",
"proclamant" => "pRoklam@",
"proclamât" => "pRoklama",
"proclamation" => "pRoklamasj§",
"proclamations" => "pRoklamasj§",
"proclamatrices" => "pRoklamatRis",
"proclame" => "pRoklam",
"proclamé" => "pRoklame",
"proclamée" => "pRoklame",
"proclamées" => "pRoklame",
"proclament" => "pRoklam",
"proclamer" => "pRoklame",
"proclamera" => "pRoklam°Ra",
"proclamerai" => "pRoklam°RE",
"proclameraient" => "pRoklam°RE",
"proclamerait" => "pRoklam°RE",
"proclamèrent" => "pRoklamER",
"proclamerons" => "pRoklam°R§",
"proclamés" => "pRoklame",
"proclamez" => "pRoklame",
"proclamiez" => "pRoklamje",
"proclamions" => "pRoklamj§",
"proclamons" => "pRoklam§",
"procommuniste" => "pRokomynist",
"proconsul" => "pRok§syl",
"proconsuls" => "pRok§syl",
"procrastination" => "pRokRastinasj§",
"procréa" => "pRokRea",
"procréant" => "pRokRe@",
"procréateur" => "pRokReat9R",
"procréateurs" => "pRokReat9R",
"procréation" => "pRokReasj§",
"procréations" => "pRokReasj§",
"procréative" => "pRokReativ",
"procréatrice" => "pROkReatRis",
"procréatrices" => "pRokReatRis",
"procrée" => "pRokRe",
"procréé" => "pRokRee",
"procréent" => "pRokRe",
"procréer" => "pRokRee",
"procréerons" => "pRokReR§",
"procs" => "pROk",
"proctologie" => "pROktoloZi",
"proctologue" => "pROktolOg",
"proctologues" => "pROktolOg",
"procura" => "pRokyRa",
"procurai" => "pRokyRE",
"procuraient" => "pRokyRE",
"procurais" => "pRokyRE",
"procurait" => "pRokyRE",
"procurant" => "pRokyR@",
"procurât" => "pRokyRa",
"procurateur" => "pRokyRat9R",
"procurateurs" => "pRokyRat9R",
"procuraties" => "pRokyRasi",
"procuration" => "pRokyRasj§",
"procuratrice" => "pRokyRatRis",
"procure" => "pRokyR",
"procuré" => "pRokyRe",
"procurée" => "pRokyRe",
"procurées" => "pRokyRe",
"procurent" => "pRokyR",
"procurer" => "pRokyRe",
"procurera" => "pRokyR°Ra",
"procurerai" => "pRokyR°RE",
"procureraient" => "pRokyR°RE",
"procurerais" => "pRokyR°RE",
"procurerait" => "pRokyR°RE",
"procureras" => "pRokyR°Ra",
"procurèrent" => "pRokyRER",
"procureriez" => "pRokyR°Rje",
"procurerons" => "pRokyR°R§",
"procureront" => "pRokyR°R§",
"procures" => "pRokyR",
"procurés" => "pRokyRe",
"procureur" => "pRokyR9R",
"procureurs" => "pRokyR9R",
"procureuse" => "pRokyR2z",
"procureuses" => "pRokyR2z",
"procurez" => "pRokyRe",
"procuriez" => "pRokyRje",
"procurions" => "pRokyRj§",
"prodigalité" => "pRodigalite",
"prodigalités" => "pRodigalite",
"prodige" => "pRodiZ",
"prodiges" => "pRodiZ",
"prodigieuse" => "pRodiZj2z",
"prodigieusement" => "pRodiZj2z°m@",
"prodigieuses" => "pRodiZj2z",
"prodigieux" => "pRodiZj2",
"prodigua" => "pRodiga",
"prodiguaient" => "pRodigE",
"prodiguais" => "pRodigE",
"prodiguait" => "pRodigE",
"prodiguant" => "pRodig@",
"prodigue" => "pRodig",
"prodigué" => "pRodige",
"prodiguée" => "pRodige",
"prodiguées" => "pRodige",
"prodiguent" => "pRodig",
"prodiguer" => "pRodige",
"prodiguera" => "pRodig°Ra",
"prodiguerais" => "pRodig°RE",
"prodigueras" => "pRodig°Ra",
"prodiguèrent" => "pRodigER",
"prodigueront" => "pRodig°R§",
"prodigues" => "pRodig",
"prodigués" => "pRodige",
"prodiguions" => "pRodigj§",
"prodrome" => "pRodROm",
"prodromes" => "pRodROm",
"producteur" => "pRodykt9R",
"producteurs" => "pRodykt9R",
"productif" => "pRodyktif",
"productifs" => "pRodyktif",
"production" => "pRodyksj§",
"productions" => "pRodyksj§",
"productive" => "pRodyktiv",
"productives" => "pRodyktiv",
"productivité" => "pRodyktivite",
"productrice" => "pRodyktRis",
"productrices" => "pRodyktRis",
"produira" => "pRod8iRa",
"produiraient" => "pRod8iRE",
"produirais" => "pRod8iRE",
"produirait" => "pRod8iRE",
"produiras" => "pRod8iRa",
"produire" => "pRod8iR",
"produirez" => "pRod8iRe",
"produiriez" => "pRod8iRje",
"produirons" => "pRod8iR§",
"produiront" => "pRod8iR§",
"produis" => "pRod8i",
"produisaient" => "pRod8izE",
"produisais" => "pRod8izE",
"produisait" => "pRod8izE",
"produisant" => "pRod8iz@",
"produise" => "pRod8iz",
"produisent" => "pRod8iz",
"produises" => "pRod8iz",
"produisez" => "pRod8ize",
"produisions" => "pRod8izj§",
"produisirent" => "pRod8iziR",
"produisis" => "pRod8izi",
"produisit" => "pRod8izi",
"produisît" => "pRod8izi",
"produisons" => "pRod8iz§",
"produit" => "pRod8i",
"produite" => "pRod8it",
"produites" => "pRod8it",
"produits" => "pRod8i",
"proèdre" => "pRoEdR",
"proéminait" => "pRoeminE",
"proémine" => "pRoemin",
"proéminence" => "pROemin@s",
"proéminences" => "pRoemin@s",
"proéminent" => "pRoemin@",
"proéminente" => "pRoemin@t",
"proéminentes" => "pRoemin@t",
"proéminents" => "pRoemin@",
"prof" => "pROf",
"profana" => "pRofana",
"profanaient" => "pRofanE",
"profanait" => "pRofanE",
"profanant" => "pRofan@",
"profanateur" => "pRofanat9R",
"profanateurs" => "pRofanat9R",
"profanation" => "pRofanasj§",
"profanations" => "pRofanasj§",
"profanatoire" => "pRofanatwaR",
"profane" => "pRofan",
"profané" => "pRofane",
"profanée" => "pRofane",
"profanées" => "pRofane",
"profanent" => "pRofan",
"profaner" => "pRofane",
"profanera" => "pRofan°Ra",
"profanèrent" => "pRofanER",
"profanes" => "pRofan",
"profanés" => "pRofane",
"profanez" => "pRofane",
"proféra" => "pRofeRa",
"proféraient" => "pRofeRE",
"proférait" => "pRofeRE",
"proférant" => "pRofeR@",
"proférât" => "pRofeRa",
"proférations" => "pRofeRasj§",
"profère" => "pRofER",
"proféré" => "pRofeRe",
"proférée" => "pRofeRe",
"proférées" => "pRofeRe",
"profèrent" => "pRofER",
"proférer" => "pRofeRe",
"proféreraient" => "pRofeR°RE",
"proférés" => "pRofeRe",
"proférez" => "pRofeRe",
"proférions" => "pRofeRj§",
"professa" => "pRofEsa",
"professaient" => "pRofEsE",
"professait" => "pRofEsE",
"professant" => "pRofEs@",
"professe" => "pRofEs",
"professé" => "pRofEse",
"professées" => "pRofEse",
"professent" => "pRofEs",
"professer" => "p°Rofese",
"professeur" => "pRofEs9R",
"professeure" => "pROfEs9R",
"professeurs" => "pRofEs9R",
"professiez" => "pRofEsje",
"profession" => "pRofEsj§",
"professionnalisme" => "pRofEsjonalizm",
"professionnel" => "pRofEsjonEl",
"professionnelle" => "pRofEsjonEl",
"professionnellement" => "pRofEsjonEl°m@",
"professionnelles" => "pRofEsjonEl",
"professionnels" => "pRofEsjonEl",
"professions" => "pRofEsj§",
"professons" => "pRofEs§",
"professoral" => "pRofEsoRal",
"professorat" => "pRofEsoRa",
"profil" => "pRofil",
"profila" => "pRofila",
"profilage" => "pRofilaZ",
"profilaient" => "pRofilE",
"profilait" => "pRofilE",
"profilant" => "pRofil@",
"profile" => "pRofil",
"profilé" => "pRofile",
"profilée" => "pRofile",
"profilées" => "pRofile",
"profilent" => "pRofil",
"profiler" => "pRofile",
"profilèrent" => "pRofilER",
"profilés" => "pRofile",
"profileur" => "pRofil9R",
"profileuse" => "pRofil2z",
"profils" => "pRofil",
"profit" => "pRofi",
"profita" => "pRofita",
"profitabilité" => "pRofitabilite",
"profitable" => "pRofitabl",
"profitables" => "pRofitabl",
"profitai" => "pRofitE",
"profitaient" => "pRofitE",
"profitais" => "pRofitE",
"profitait" => "pRofitE",
"profitâmes" => "pRofitam",
"profitant" => "pRofit@",
"profitât" => "pRofita",
"profite" => "pRofit",
"profité" => "pRofite",
"profitée" => "pRofite",
"profitent" => "pRofit",
"profiter" => "pRofite",
"profitera" => "pRofit°Ra",
"profiterai" => "pRofit°RE",
"profiteraient" => "pRofit°RE",
"profiterais" => "pRofit°RE",
"profiterait" => "pRofit°RE",
"profiteras" => "pRofit°Ra",
"profitèrent" => "pRofitER",
"profiterez" => "pRofit°Re",
"profiteriez" => "pRofit°Rje",
"profiterole" => "pRofit°ROl",
"profiteroles" => "pRofit°ROl",
"profiterons" => "pRofit°R§",
"profiteront" => "pRofit°R§",
"profites" => "pRofit",
"profiteur" => "pRofit9R",
"profiteurs" => "pRofit9R",
"profiteuse" => "pRofit2z",
"profitez" => "pRofite",
"profitiez" => "pRofitje",
"profitions" => "pRofitj§",
"profitons" => "pRofit§",
"profits" => "pRofi",
"profond" => "pRof§",
"profonde" => "pRof§d",
"profondément" => "pRof§dem@",
"profondes" => "pRof§d",
"profondeur" => "pRof§d9R",
"profondeurs" => "pRof§d9R",
"profonds" => "pRof§",
"profs" => "pROf",
"profus" => "pRofy",
"profuse" => "pRofyz",
"profuses" => "pRofyz",
"profusion" => "pRofyzj§",
"profusions" => "pRofyzj§",
"progéniteur" => "pROZenit9R",
"progéniture" => "pRoZenityR",
"progénitures" => "pRoZenityR",
"progestérone" => "pRoZEsteROn",
"prognathe" => "pRognat",
"prognathisme" => "pROgnatism",
"programma" => "pRogRama",
"programmable" => "pRogRamabl",
"programmables" => "pRogRamabl",
"programmaient" => "pRogRamE",
"programmait" => "pRogRamE",
"programmateur" => "pRogRamat9R",
"programmateurs" => "pRogRamat9R",
"programmation" => "pRogRamasj§",
"programmatrice" => "pRogRamatRis",
"programme" => "pRogRam",
"programmé" => "pRogRame",
"programmée" => "pRogRame",
"programmées" => "pRogRame",
"programment" => "pRogRam",
"programmer" => "pRogRame",
"programmerai" => "pRogRam°RE",
"programmes" => "pRogRam",
"programmés" => "pRogRame",
"programmeur" => "pRogRam9R",
"programmeurs" => "pRogRam9R",
"programmeuse" => "pRogRam2z",
"programmez" => "pRogRame",
"programmons" => "pRogRam§",
"progrès" => "pRogRE",
"progressa" => "pRogREsa",
"progressai" => "pRogREsE",
"progressaient" => "pRogREsE",
"progressais" => "pRogREsE",
"progressait" => "pRogREsE",
"progressant" => "pRogREs@",
"progresse" => "pRogREs",
"progressé" => "pRogRese",
"progressée" => "pRogRese",
"progressent" => "pRogREs",
"progresser" => "pRogRese",
"progressera" => "pRogREs°Ra",
"progresseraient" => "pRogREs°RE",
"progresserais" => "pRogREs°RE",
"progresserait" => "pRogREs°RE",
"progressèrent" => "pRogREsER",
"progresserez" => "pRogRes°Re",
"progresserons" => "pRogRes°R§",
"progresseront" => "pRogREs°R§",
"progresses" => "pRogREs",
"progressez" => "pRogREse",
"progressif" => "pRogResif",
"progression" => "pRogREsj§",
"progressions" => "pRogREsj§",
"progressisme" => "pRogREsizm",
"progressiste" => "pRogResist",
"progressistes" => "pRogResist",
"progressive" => "pRogResiv",
"progressivement" => "pRogResiv°m@",
"progressives" => "pRogResiv",
"progressons" => "pRogREs§",
"prohibait" => "pRoibE",
"prohibe" => "pRoib",
"prohibé" => "pRoibe",
"prohibée" => "pRoibe",
"prohibées" => "pRoibe",
"prohibent" => "pRoib",
"prohibés" => "pRoibe",
"prohibition" => "pRoibisj§",
"prohibitive" => "pROibitiv",
"proie" => "pRwa",
"proies" => "pRwa",
"projecteur" => "pRoZEkt9R",
"projecteurs" => "pRoZEkt9R",
"projectif" => "pROZEktif",
"projectile" => "pRoZEktil",
"projectiles" => "pRoZEktil",
"projection" => "pRoZEksj§",
"projectionniste" => "pRoZEksjonist",
"projectionnistes" => "pRoZEksjonist",
"projections" => "pRoZEksj§",
"projet" => "pRoZE",
"projeta" => "pRoZ°ta",
"projetai" => "pRoZ°tE",
"projetaient" => "pRoZ°tE",
"projetais" => "pRoZ°tE",
"projetait" => "pRoZ°tE",
"projetâmes" => "pRoZ°tam",
"projetant" => "pRoZ°t@",
"projetât" => "pRoZ°ta",
"projeté" => "pRoZ°te",
"projetée" => "pRoZ°te",
"projetées" => "pRoZ°te",
"projeter" => "pRoZ°te",
"projetèrent" => "pRoZ°tER",
"projetés" => "pRoZ°te",
"projetez" => "pRoZ°te",
"projetiez" => "pRoZ°tje",
"projetions" => "pRoZ°tj§",
"projetons" => "pRoZ°t§",
"projets" => "pRoZE",
"projette" => "pRoZEt",
"projettent" => "pRoZEt",
"projettera" => "pRoZEt°Ra",
"projetterait" => "pRoZEt°RE",
"projetteriez" => "pRoZEt°Rje",
"projetterons" => "pRoZEt°R§",
"projettes" => "pRoZEt",
"projo" => "pRoZo",
"projos" => "pRoZo",
"prolapsus" => "pRolapsys",
"prolégomènes" => "pRolegomEn",
"prolétaire" => "pRoletER",
"prolétaires" => "pRoletER",
"prolétariat" => "pRoletaRja",
"prolétariats" => "pRoletaRja",
"prolétarien" => "pRoletaRj5",
"prolétarienne" => "pRoletaRjEn",
"prolétariennes" => "pRoletaRjEn",
"prolétariens" => "pRoletaRj5",
"prolétarisation" => "pRoletaRizasj§",
"prolétariser" => "pRoletaRize",
"proliféraient" => "pRolifeRE",
"proliférait" => "pRolifeRE",
"proliférant" => "pRolifeR@",
"proliférante" => "pRolifeR@t",
"proliférantes" => "pRolifeR@t",
"proliférants" => "pRolifeR@",
"prolifération" => "pRolifeRasj§",
"prolifère" => "pRolifER",
"proliféré" => "pRolifeRe",
"prolifèrent" => "pRolifER",
"proliférer" => "pRolifeRe",
"proliférera" => "pRolifeR°Ra",
"prolifique" => "pRolifik",
"prolifiques" => "pRolifik",
"proline" => "pROlin",
"prolixe" => "pRoliks",
"prolixes" => "pRoliks",
"prolixité" => "pRoliksite",
"prolo" => "pRolo",
"prologue" => "pRolOg",
"prolongateur" => "pROl§gat9R",
"prolongation" => "pRol§gasj§",
"prolongations" => "pRol§gasj§",
"prolonge" => "pRol§Z",
"prolongé" => "pRol§Ze",
"prolongea" => "pRol§Za",
"prolongeaient" => "pRol§ZE",
"prolongeais" => "pRol§ZE",
"prolongeait" => "pRol§ZE",
"prolongeant" => "pRol§Z@",
"prolongeât" => "pRol§Za",
"prolongée" => "pRol§Ze",
"prolongées" => "pRol§Ze",
"prolongement" => "pRol§Z°m@",
"prolongements" => "pRol§Z°m@",
"prolongent" => "pRol§Z",
"prolonger" => "pRol§Ze",
"prolongera" => "pRol§Z°Ra",
"prolongeraient" => "pRol§Z°RE",
"prolongerait" => "pRol§Z°RE",
"prolongèrent" => "pRol§ZER",
"prolongerons" => "pRol§Z°R§",
"prolonges" => "pRol§Z",
"prolongés" => "pRol§Ze",
"prolongez" => "pRol§Ze",
"prolos" => "pRolo",
"promazine" => "pRomazin",
"promena" => "pRom°na",
"promenade" => "pROmnad",
"promenades" => "pROmnad",
"promenai" => "pROm°nE",
"promenaient" => "pROm°nE",
"promenais" => "pROm°nE",
"promenait" => "pROm°nE",
"promenâmes" => "pROm°nam",
"promenant" => "pROm°n@",
"promenât" => "pROm°na",
"promène" => "pRomEn",
"promené" => "pROm°ne",
"promenée" => "pROm°ne",
"promenées" => "pROm°ne",
"promènent" => "pRomEn",
"promener" => "pROmne",
"promènera" => "pRomEn°Ra",
"promènerai" => "pRomEn°RE",
"promèneraient" => "pRomEn°RE",
"promènerais" => "pRomEn°RE",
"promènerait" => "pRomEn°RE",
"promèneras" => "pRomEn°Ra",
"promenèrent" => "pRom°nER",
"promènerez" => "pRomEn°Re",
"promènerions" => "pRomEn°Rj§",
"promènerons" => "pRomEn°R§",
"promènes" => "pRomEn",
"promenés" => "pRom°ne",
"promeneur" => "pRomn9R",
"promeneurs" => "pRomn9R",
"promeneuse" => "pRomn2z",
"promeneuses" => "pRomn2z",
"promenez" => "pRom°ne",
"promeniez" => "pRom°nje",
"promenions" => "pRom°nj§",
"promenoir" => "pRomnwaR",
"promenons" => "pRom°n§",
"promesse" => "pRomEs",
"promesses" => "pRomEs",
"promet" => "pRomE",
"prométhéen" => "pROmete5",
"prométhéenne" => "pROmeteEn",
"promets" => "pRomE",
"promettaient" => "pRomEtE",
"promettais" => "pRomEtE",
"promettait" => "pRomEtE",
"promettant" => "pRomEt@",
"promette" => "pRomEt",
"promettent" => "pRomEt",
"promettes" => "pRomEt",
"prometteur" => "pRomEt9R",
"prometteurs" => "pRomEt9R",
"prometteuse" => "pRomEt2z",
"prometteuses" => "pRomEt2z",
"promettez" => "pRomEte",
"promettiez" => "pRomEtje",
"promettons" => "pRomEt§",
"promettra" => "pRomEtRa",
"promettrai" => "pRomEtRE",
"promettraient" => "pRomEtRE",
"promettrais" => "pRomEtRE",
"promettrait" => "pRomEtRE",
"promettras" => "pRomEtRa",
"promettre" => "pRomEtR",
"promettriez" => "pRomEtRie",
"promettront" => "pRomEtR§",
"promeut" => "pRom2",
"promîmes" => "pRomim",
"promirent" => "pRomiR",
"promis" => "pRomi",
"promiscuité" => "pRomisk8ite",
"promiscuités" => "pRomisk8ite",
"promise" => "pRomiz",
"promises" => "pRomiz",
"promit" => "pRomi",
"promît" => "pRomi",
"promo" => "pRomo",
"promontoire" => "pRom§twaR",
"promontoires" => "pRom§twaR",
"promos" => "pRomo",
"promoteur" => "pRomot9R",
"promoteurs" => "pRomot9R",
"promotion" => "pRomosj§",
"promotionnait" => "pRomosjonE",
"promotionnel" => "pRomosjonEl",
"promotionnelle" => "pRomosjonEl",
"promotionnelles" => "pRomosjonEl",
"promotions" => "pRomosj§",
"promotrice" => "pROmOtRis",
"promouvaient" => "pRomuvE",
"promouvez" => "pRomuve",
"promouvoir" => "pRomuvwaR",
"prompt" => "pR§",
"prompte" => "pR§t",
"promptement" => "pR§t°m@",
"promptes" => "pR§t",
"prompteur" => "pR§pt9R",
"prompteurs" => "pR§t9R",
"promptitude" => "pR§tityd",
"prompto" => "pR§to",
"prompts" => "pR§",
"promu" => "pRomy",
"promue" => "pRomy",
"promues" => "pRomy",
"promulgation" => "pRomylgasj§",
"promulguait" => "pRomylgE",
"promulguant" => "pRomylg@",
"promulgué" => "pRomylge",
"promulguée" => "pRomylge",
"promulguées" => "pRomylge",
"promulguer" => "pRomylge",
"promulguera" => "pRomylg°Ra",
"promulgués" => "pRomylge",
"promus" => "pRomy",
"promut" => "pRomy",
"prônais" => "pRonE",
"prônait" => "pRonE",
"prônant" => "pRon@",
"pronateurs" => "pRonat9R",
"pronation" => "pRonasj§",
"prône" => "pRon",
"prôné" => "pRone",
"prônée" => "pRone",
"prônées" => "pRone",
"prônent" => "pRon",
"prôner" => "pRone",
"prônera" => "pRon°Ra",
"prônerez" => "pRon°Re",
"prônes" => "pRon",
"prônés" => "pRone",
"prôneur" => "pRon9R",
"prônez" => "pRone",
"pronom" => "pRon§",
"pronominal" => "pRonominal",
"pronominale" => "pRonominal",
"pronominaux" => "pRonomino",
"pronoms" => "pRon§",
"prononça" => "pRon§sa",
"prononçable" => "pRon§sabl",
"prononçai" => "pRon§sE",
"prononçaient" => "pRon§sE",
"prononçais" => "pRon§sE",
"prononçait" => "pRon§sE",
"prononçant" => "pRon§s@",
"prononças" => "pRon§sa",
"prononçât" => "pRon§sa",
"prononce" => "pRon§s",
"prononcé" => "pRon§se",
"prononcée" => "pRon§se",
"prononcées" => "pRon§se",
"prononcent" => "pRon§s",
"prononcer" => "pRon§se",
"prononcera" => "pRon§s°Ra",
"prononcerai" => "pRon§s°RE",
"prononceraient" => "pRon§s°RE",
"prononcerais" => "pRon§s°RE",
"prononcerait" => "pRon§s°RE",
"prononceras" => "pRon§s°Ra",
"prononcèrent" => "pRon§sER",
"prononcerez" => "pRon§s°Re",
"prononceriez" => "pRon§s°Rje",
"prononcerons" => "pRon§s°R§",
"prononceront" => "pRon§s°R§",
"prononces" => "pRon§s",
"prononcés" => "pRon§se",
"prononcez" => "pRon§se",
"prononciation" => "pRon§sjasj§",
"prononciations" => "pRon§sjasj§",
"prononciez" => "pRon§sje",
"prononcions" => "pRon§sj§",
"prononçons" => "pRon§s§",
"prônons" => "pRon§",
"pronostic" => "pRonOstik",
"pronostics" => "pRonOstik",
"pronostiquait" => "pRonOstikE",
"pronostique" => "pRonOstik",
"pronostiquer" => "pRonOstike",
"pronostiqueur" => "pRonOstik9R",
"pronostiquiez" => "pRonOstikje",
"pronunciamiento" => "pRonunsjamjEnto",
"propagande" => "pRopag@d",
"propagandes" => "pRopag@d",
"propagandiste" => "pRopag@dist",
"propagandistes" => "pRopag@dist",
"propagateur" => "pRopagat9R",
"propagateurs" => "pRopagat9R",
"propagation" => "pRopagasj§",
"propagations" => "pRopagasj§",
"propage" => "pRopaZ",
"propagé" => "pRopaZe",
"propagea" => "pRopaZa",
"propageaient" => "pRopaZE",
"propageait" => "pRopaZE",
"propageant" => "pRopaZ@",
"propageât" => "pRopaZa",
"propagée" => "pRopaZe",
"propagées" => "pRopaZe",
"propagent" => "pRopaZ",
"propager" => "pRopaZe",
"propagera" => "pRopaZ°Ra",
"propageraient" => "pRopaZ°RE",
"propagerait" => "pRopaZ°RE",
"propagèrent" => "pRopaZER",
"propagés" => "pRopaZe",
"propagez" => "pRopaZe",
"propane" => "pRopan",
"propédeute" => "pRoped2t",
"propension" => "pRop@sj§",
"propergol" => "pRopERgOl",
"prophase" => "pRofaz",
"prophète" => "pRofEt",
"prophètes" => "pRofEt",
"prophétesse" => "pRofEtEs",
"prophétie" => "pRofesi",
"prophéties" => "pRofesi",
"prophétique" => "pRofetik",
"prophétiquement" => "pRofetik°m@",
"prophétiques" => "pRofetik",
"prophétisaient" => "pRofetizE",
"prophétisait" => "pRofetizE",
"prophétisant" => "pRofetiz@",
"prophétise" => "pRofetiz",
"prophétisé" => "pRofetize",
"prophétisent" => "pRofetiz",
"prophétiser" => "pRofetize",
"prophétisez" => "pRofetize",
"prophylactique" => "pRofilaktik",
"prophylactiques" => "pRofilaktik",
"prophylaxie" => "pRofilaksi",
"propice" => "pRopis",
"propices" => "pRopis",
"propionate" => "pROpjOnat",
"propitiatoire" => "pRopisjatwaR",
"propitiatoires" => "pRopisjatwaR",
"propolis" => "pROpOlis",
"proportion" => "pRopORsj§",
"proportionnalité" => "pROpORsjOnalite",
"proportionné" => "pRopORsjone",
"proportionnée" => "pRopORsjone",
"proportionnées" => "pRopORsjone",
"proportionnel" => "pRopORsjonEl",
"proportionnelle" => "pRopORsjonEl",
"proportionnellement" => "pRopORsjonEl°m@",
"proportionnelles" => "pRopORsjonEl",
"proportionner" => "pRopORsjone",
"proportionnés" => "pRopORsjone",
"proportions" => "pRopORsj§",
"propos" => "pRopo",
"proposa" => "pRopoza",
"proposai" => "pRopozE",
"proposaient" => "pRopozE",
"proposais" => "pRopozE",
"proposait" => "pRopozE",
"proposâmes" => "pRopozam",
"proposant" => "pRopoz@",
"proposât" => "pRopoza",
"propose" => "pRopoz",
"proposé" => "pRopoze",
"proposée" => "pRopoze",
"proposées" => "pRopoze",
"proposent" => "pRopoz",
"proposer" => "pRopoze",
"proposera" => "pRopoz°Ra",
"proposerai" => "pRopoz°RE",
"proposeraient" => "pRopoz°RE",
"proposerais" => "pRopoz°RE",
"proposerait" => "pRopoz°RE",
"proposeras" => "pRopoz°Ra",
"proposèrent" => "pRopozER",
"proposerez" => "pRopoz°Re",
"proposeriez" => "pRopoz°Rje",
"proposerions" => "pRopoz°Rj§",
"proposerons" => "pRopoz°R§",
"proposeront" => "pRopoz°R§",
"proposes" => "pRopoz",
"proposés" => "pRopoze",
"proposez" => "pRopoze",
"proposiez" => "pRopozje",
"proposions" => "pRopozj§",
"proposition" => "pRopozisj§",
"propositions" => "pRopozisj§",
"proposons" => "pRopoz§",
"propre" => "pROpR",
"propre-à-rien" => "pROpRaRj5",
"proprement" => "pROpR°m@",
"propres" => "pROpR",
"propret" => "pRopRE",
"propreté" => "pROpR°te",
"proprets" => "pRopRE",
"proprette" => "pRopREt",
"proprettes" => "pRopREt",
"propriétaire" => "pRopRijetER",
"propriétaires" => "pRopRijetER",
"propriété" => "pRopRijete",
"propriétés" => "pRopRijete",
"proprio" => "pRopRijo",
"proprios" => "pRopRijo",
"propulsa" => "pRopylsa",
"propulsaient" => "pRopylsE",
"propulsais" => "pRopylsE",
"propulsait" => "pRopylsE",
"propulsant" => "pRopyls@",
"propulsât" => "pRopylsa",
"propulse" => "pRopyls",
"propulsé" => "pRopylse",
"propulsée" => "pRopylse",
"propulsées" => "pRopylse",
"propulsent" => "pRopyls",
"propulser" => "pRopylse",
"propulsera" => "pRopyls°Ra",
"propulserait" => "pRopyls°RE",
"propulsés" => "pRopylse",
"propulseur" => "pRopyls9R",
"propulseurs" => "pRopyls9R",
"propulsif" => "pROpylsif",
"propulsion" => "pRopylsj§",
"propulsions" => "pRopylsj§",
"propylées" => "pRopile",
"propylène" => "pROpilEn",
"prorata" => "pRoRata",
"prorogation" => "pRoRogasj§",
"prorogé" => "pRoRoZe",
"proroger" => "pRoRoZe",
"pros" => "pRo",
"prosaïque" => "pRozaik",
"prosaïquement" => "pRozaik°m@",
"prosaïques" => "pRozaik",
"prosaïsme" => "pRozaizm",
"prosateur" => "pRozat9R",
"prosateurs" => "pRozat9R",
"proscenium" => "pRosenjOm",
"proscription" => "pROskRipsj§",
"proscriptions" => "pROskRipsj§",
"proscrire" => "pROskRiR",
"proscrit" => "pROskRi",
"proscrite" => "pROskRit",
"proscrites" => "pROskRit",
"proscrits" => "pROskRi",
"proscrivait" => "pROskRivE",
"proscrivant" => "pROskRiv@",
"proscrivit" => "pROskRivi",
"prose" => "pRoz",
"prosélyte" => "pRozelit",
"prosélytes" => "pRozelit",
"prosélytique" => "pROzelitik",
"prosélytisme" => "pRozelitizm",
"prosit" => "pROzit",
"prosodie" => "pRozodi",
"prosodique" => "pRozodik",
"prosopopées" => "pRozopope",
"prosoviétique" => "pRosovjetik",
"prospect" => "pROspE",
"prospectais" => "pROspEktE",
"prospectait" => "pROspEktE",
"prospectant" => "pROspEkt@",
"prospecte" => "pROspEkt",
"prospecté" => "pROspEkte",
"prospecter" => "pROspEkte",
"prospecteur" => "pROspEkt9R",
"prospecteurs" => "pROspEkt9R",
"prospectif" => "pROspEktif",
"prospection" => "pROspEksj§",
"prospections" => "pRospEksj§",
"prospective" => "pROspEktiv",
"prospectus" => "pROspEktys",
"prospéra" => "pROspeRa",
"prospéraient" => "pROspeRE",
"prospérait" => "pROspeRE",
"prospère" => "pROspER",
"prospéré" => "pROspeRe",
"prospèrent" => "pROspER",
"prospérer" => "pROspeRe",
"prospérera" => "pROspeR°Ra",
"prospéreraient" => "pROspeR°RE",
"prospérèrent" => "pROspeRER",
"prospères" => "pROspER",
"prospérité" => "pROspeRite",
"prospérités" => "pROspeRite",
"prospérons" => "pROspeR§",
"prostate" => "pROstat",
"prostatectomie" => "pROstatEktOmi",
"prostatique" => "pROstatik",
"prostatite" => "pROstatit",
"prosterna" => "pRostERna",
"prosternaient" => "pRostERnE",
"prosternais" => "pRostERnE",
"prosternait" => "pRostERnE",
"prosternant" => "pRostERn@",
"prosternation" => "pRostERnasj§",
"prosternations" => "pRostERnasj§",
"prosterne" => "pRostERn",
"prosterné" => "pRostERne",
"prosternée" => "pRostERne",
"prosternées" => "pRostERne",
"prosternent" => "pRostERn",
"prosterner" => "pRostERne",
"prosternera" => "pRostERn°Ra",
"prosternerait" => "pRostERn°RE",
"prosterneras" => "pRostERn°Ra",
"prosternèrent" => "pRostERnER",
"prosternerons" => "pRostERn°R§",
"prosterneront" => "pRostERn°R§",
"prosternés" => "pRostERne",
"prosternez" => "pRostERne",
"prosternons" => "pRostERn§",
"prosthétique" => "pROstetik",
"prostitua" => "pROstit8a",
"prostituais" => "pROstityE",
"prostituait" => "pROstit8E",
"prostituant" => "pROstit8@",
"prostitue" => "pROstity",
"prostitué" => "pROstit8e",
"prostituée" => "pROstit8e",
"prostituées" => "pROstit8e",
"prostituent" => "pROstity",
"prostituer" => "pROstit8e",
"prostituerais" => "pROstityRE",
"prostitués" => "pROstit8e",
"prostitution" => "pROstitysj§",
"prostitutionnel" => "pROstitysjonEl",
"prostitutions" => "pROstitysj§",
"prostrant" => "pROstR@",
"prostration" => "pRostRasj§",
"prostrations" => "pRostRasj§",
"prostré" => "pROstRe",
"prostrée" => "pROstRe",
"prostrées" => "pROstRe",
"prostrés" => "pROstRe",
"protagoniste" => "pRotagonist",
"protagonistes" => "pRotagonist",
"protal" => "pROtal",
"prote" => "pROt",
"protéase" => "pROteaz",
"protecteur" => "pRotEkt9R",
"protecteurs" => "pRotEkt9R",
"protection" => "pRotEksj§",
"protectionnisme" => "pRotEksjonizm",
"protections" => "pRotEksj§",
"protectorat" => "pRotEktoRa",
"protectorats" => "pRotEktoRa",
"protectrice" => "pRotEktRis",
"protectrices" => "pRotEktRis",
"protège" => "pRotEZ",
"protégé" => "pRoteZe",
"protège-cahier" => "pRotEZkaje",
"protège-dents" => "pRotEZd@",
"protège-slip" => "pROtEZslip",
"protège-tibia" => "pRotEZtibja",
"protégea" => "pRoteZa",
"protégeai" => "pRoteZE",
"protégeaient" => "pRoteZE",
"protégeais" => "pRoteZE",
"protégeait" => "pRoteZE",
"protégeant" => "pRoteZ@",
"protégeât" => "pRoteZa",
"protégée" => "pRoteZe",
"protégées" => "pRoteZe",
"protègent" => "pRotEZ",
"protégeons" => "pRoteZ§",
"protéger" => "pRoteZe",
"protégera" => "pRoteZ°Ra",
"protégerai" => "pRoteZ°RE",
"protégeraient" => "pRoteZ°RE",
"protégerais" => "pRoteZ°RE",
"protégerait" => "pRoteZ°RE",
"protégeras" => "pRoteZ°Ra",
"protégerez" => "pRoteZ°Re",
"protégeriez" => "pRoteZ°Rje",
"protégerons" => "pRoteZ°R§",
"protégeront" => "pRoteZ°R§",
"protèges" => "pRotEZ",
"protégés" => "pRoteZe",
"protégez" => "pRoteZe",
"protégiez" => "pRoteZje",
"protégions" => "pRoteZj§",
"protéiforme" => "pRoteifORm",
"protéine" => "pRotein",
"protéiné" => "pROteine",
"protéinée" => "pROteine",
"protéines" => "pRotein",
"protéinique" => "pRoteinik",
"protéinurie" => "pROteinyRi",
"protéique" => "pRoteik",
"protéolytique" => "pRoteolitik",
"protes" => "pROt",
"protesta" => "pRotEsta",
"protestai" => "pRotEstE",
"protestaient" => "pRotEstE",
"protestais" => "pRotEstE",
"protestait" => "pRotEstE",
"protestâmes" => "pRotEstam",
"protestant" => "pRotEst@",
"protestante" => "pRotEst@t",
"protestantes" => "pRotEst@t",
"protestantisme" => "pRotEst@tizm",
"protestants" => "pRotEst@",
"protestât" => "pRotEsta",
"protestataires" => "pRotEstatER",
"protestation" => "pRotEstasj§",
"protestations" => "pRotEstasj§",
"proteste" => "pRotEst",
"protesté" => "pRotEste",
"protestent" => "pRotEst",
"protester" => "pRotEste",
"protestera" => "pRotEst°Ra",
"protesterai" => "pRotEst°RE",
"protesterais" => "pRotEst°RE",
"protesterait" => "pRotEst°RE",
"protestèrent" => "pRotEstER",
"protesterons" => "pRotEst°R§",
"protestes" => "pRotEst",
"protestés" => "pRotEste",
"protestez" => "pRotEste",
"protestions" => "pRotEstj§",
"protestons" => "pRotEst§",
"protêt" => "pRotE",
"protêts" => "pRotE",
"proteus" => "pROteys",
"prothèse" => "pRotEz",
"prothèses" => "pRotEz",
"prothésiste" => "pRotezist",
"prothésistes" => "pRotezist",
"prothétique" => "pROtetik",
"prothrombine" => "pROtR§bin",
"protide" => "pRotid",
"protides" => "pRotid",
"protidique" => "pROtidik",
"protistes" => "pROtist",
"protococcus" => "pROtOkOkys",
"protocolaire" => "pRotokolER",
"protocolaires" => "pRotokolER",
"protocole" => "pRotokOl",
"protocoles" => "pRotokOl",
"protocoques" => "pRotokOk",
"protohistoire" => "pRotoistwaR",
"proton" => "pRot§",
"protonique" => "pRotonik",
"protonotaire" => "pRotonotER",
"protons" => "pRot§",
"protoplasme" => "pRotoplasm",
"protoplasmes" => "pRotoplasm",
"protoplasmique" => "pRotoplasmik",
"protoplaste" => "pROtOplast",
"prototype" => "pRototip",
"prototypes" => "pRototip",
"protoxyde" => "pRotOksid",
"protozoaire" => "pROtOzOER",
"protrusion" => "pROtRyzj§",
"protubérance" => "pRotybeR@s",
"protubérances" => "pRotybeR@s",
"protubérant" => "pRotybeR@",
"protubérante" => "pRotybeR@t",
"protubérantes" => "pRotybeR@t",
"protubérants" => "pRotybeR@",
"proudhonisme" => "pRudonizm",
"proue" => "pRu",
"proues" => "pRu",
"prouesse" => "pRuEs",
"prouesses" => "pRuEs",
"proustien" => "pRustj5",
"proustienne" => "pRustjEn",
"prout" => "pRut",
"prouts" => "pRut",
"prouva" => "pRuva",
"prouvable" => "pRuvabl",
"prouvai" => "pRuvE",
"prouvaient" => "pRuvE",
"prouvais" => "pRuvE",
"prouvait" => "pRuvE",
"prouvant" => "pRuv@",
"prouve" => "pRuv",
"prouvé" => "pRuve",
"prouvée" => "pRuve",
"prouvées" => "pRuve",
"prouvent" => "pRuv",
"prouver" => "pRuve",
"prouvera" => "pRuv°Ra",
"prouverai" => "pRuv°RE",
"prouveraient" => "pRuv°RE",
"prouverait" => "pRuv°RE",
"prouveras" => "pRuv°Ra",
"prouvèrent" => "pRuvER",
"prouverez" => "pRuv°Re",
"prouverons" => "pRuv°R§",
"prouveront" => "pRuv°R§",
"prouves" => "pRuv",
"prouvés" => "pRuve",
"prouvez" => "pRuve",
"prouviez" => "pRuvje",
"prouvons" => "pRuv§",
"provéditeur" => "pRovedit9R",
"provéditeurs" => "pRovedit9R",
"provenaient" => "pRov°nE",
"provenait" => "pRov°nE",
"provenance" => "pRov°n@s",
"provenances" => "pRov°n@s",
"provenant" => "pRov°n@",
"provençal" => "pRov@sal",
"provençale" => "pRov@sal",
"provençales" => "pRov@sal",
"provençaux" => "pRov@so",
"provende" => "pRov@d",
"provenir" => "pRov°niR",
"provenu" => "pROv°ny",
"proverbe" => "pRovERb",
"proverbes" => "pRovERb",
"proverbial" => "pRovERbjal",
"proverbiale" => "pRovERbjal",
"providence" => "pRovid@s",
"providentiel" => "pRovid@sjEl",
"providentielle" => "pRovid@sjEl",
"providentiellement" => "pRovid@sjEl°m@",
"providentielles" => "pRovid@sjEl",
"providentiels" => "pRovid@sjEl",
"provider" => "pRovajd9R",
"proviendrait" => "pRovj5dRE",
"provienne" => "pRovjEn",
"proviennent" => "pRovjEn",
"provient" => "pRovj5",
"provietnamien" => "pRovjEtnamj5",
"province" => "pRov5s",
"provinces" => "pRov5s",
"provincial" => "pRov5sjal",
"provinciale" => "pRov5sjal",
"provincialement" => "pROv5sjal°m@",
"provinciales" => "pRov5sjal",
"provinciaux" => "pRov5sjo",
"proviseur" => "pRoviz9R",
"proviseurs" => "pRoviz9R",
"provision" => "pRovizj§",
"provisionnel" => "pRovizjonEl",
"provisionner" => "pRovizjone",
"provisionnons" => "pRovizjon§",
"provisions" => "pRovizj§",
"provisoire" => "pRovizwaR",
"provisoirement" => "pRovizwaR°m@",
"provisoires" => "pRovizwaR",
"provo" => "pRovo",
"provoc" => "pRovOk",
"provocant" => "pRovok@",
"provocante" => "pRovok@t",
"provocantes" => "pRovok@t",
"provocants" => "pRovok@",
"provocateur" => "pRovokat9R",
"provocateurs" => "pRovokat9R",
"provocation" => "pRovokasj§",
"provocations" => "pRovokasj§",
"provocatrice" => "pRovokatRis",
"provolone" => "pRovolOn",
"provoqua" => "pRovoka",
"provoquai" => "pRovokE",
"provoquaient" => "pRovokE",
"provoquais" => "pRovokE",
"provoquait" => "pRovokE",
"provoquant" => "pRovok@",
"provoquât" => "pRovoka",
"provoque" => "pRovOk",
"provoqué" => "pRovoke",
"provoquée" => "pRovoke",
"provoquées" => "pRovoke",
"provoquent" => "pRovOk",
"provoquer" => "pRovoke",
"provoquera" => "pRovOk°Ra",
"provoquerai" => "pRovOk°RE",
"provoqueraient" => "pRovOk°RE",
"provoquerais" => "pRovOk°RE",
"provoquerait" => "pRovOk°RE",
"provoquèrent" => "pRovokER",
"provoquerez" => "pRovOk°Re",
"provoqueriez" => "pRovOk°Rje",
"provoquerions" => "pRovOk°Rj§",
"provoquerons" => "pRovOk°R§",
"provoqueront" => "pRovOk°R§",
"provoques" => "pRovOk",
"provoqués" => "pRovoke",
"provoquez" => "pRovoke",
"provoquions" => "pRovokj§",
"provoquons" => "pRovok§",
"provos" => "pRovo",
"proxénète" => "pROksenEt",
"proxénètes" => "pROksenEt",
"proxénétisme" => "pROksenetizm",
"proximal" => "pROksimal",
"proximale" => "pROksimal",
"proximité" => "pROksimite",
"proxo" => "pROkso",
"proxos" => "pROkso",
"proze" => "pRoz",
"prud'homme" => "pRydOm",
"prud'hommes" => "pRydOm",
"prude" => "pRyd",
"prudemment" => "pRydam@",
"prudence" => "pRyd@s",
"prudences" => "pRyd@s",
"prudent" => "pRyd@",
"prudente" => "pRyd@t",
"prudentes" => "pRyd@t",
"prudents" => "pRyd@",
"pruderie" => "pRyd°Ri",
"pruderies" => "pRyd°Ri",
"prudes" => "pRyd",
"prudhommesque" => "pRydOmEsk",
"prudhommesques" => "pRydOmEsk",
"prune" => "pRyn",
"pruneau" => "pRyno",
"pruneaux" => "pRyno",
"prunelle" => "pRynEl",
"prunelles" => "pRynEl",
"prunellier" => "pRyn°lje",
"prunelliers" => "pRyn°lje",
"prunes" => "pRyn",
"prunier" => "pRynje",
"pruniers" => "pRynje",
"prunus" => "pRynys",
"prurigo" => "pRyRigo",
"prurit" => "pRyRit",
"prussianisé" => "pRysjanize",
"prussien" => "pRysj5",
"prussienne" => "pRysjEn",
"prussiennes" => "pRysjEn",
"prussiens" => "pRysj5",
"prussik" => "pRysik",
"prussique" => "pRysik",
"prytanée" => "pRitane",
"psalliotes" => "psaljOt",
"psalmiste" => "psalmist",
"psalmodia" => "psalmodja",
"psalmodiaient" => "psalmodjE",
"psalmodiais" => "psalmodjE",
"psalmodiait" => "psalmodjE",
"psalmodiant" => "psalmodj@",
"psalmodie" => "psalmodi",
"psalmodié" => "psalmodje",
"psalmodient" => "psalmodi",
"psalmodier" => "psalmodje",
"psalmodies" => "psalmodi",
"psalmodiés" => "psalmodje",
"psaume" => "psom",
"psaumes" => "psom",
"psautier" => "psotje",
"pschent" => "psSEnt",
"pschitt" => "pSit",
"pseudo" => "ps2do",
"pseudo-gouvernement" => "ps2doguvERn2m@",
"pseudobulbaire" => "ps2dobylbER",
"pseudomonas" => "ps2dOmOnas",
"pseudonyme" => "ps2donim",
"pseudonymes" => "ps2donim",
"pseudopodes" => "ps2dopOd",
"pseudos" => "ps2do",
"psi" => "psi",
"psilocybine" => "psilOsibin",
"psitt" => "psit",
"psittacose" => "psitakoz",
"psoriasis" => "psoRjazis",
"pst" => "pst",
"psy" => "psi",
"psychanalyse" => "psikanaliz",
"psychanalysé" => "psikanalize",
"psychanalyser" => "psikanalize",
"psychanalyserai" => "psikanaliz°RE",
"psychanalyses" => "psikanaliz",
"psychanalyste" => "psikanalist",
"psychanalystes" => "psikanalist",
"psychanalytique" => "psikanalitik",
"psychanalytiques" => "psikanalitik",
"psychasthéniques" => "psikastenik",
"psyché" => "psiSe",
"psychédélique" => "psikedelik",
"psychédéliques" => "psikedelik",
"psychés" => "psiSe",
"psychiatre" => "psikjatR",
"psychiatre-conseil" => "psikjatRk§sEj",
"psychiatres" => "psikjatR",
"psychiatrie" => "psikjatRi",
"psychiatrique" => "psikjatRik",
"psychiatriques" => "psikjatRik",
"psychique" => "psiSik",
"psychiquement" => "psiSik°m@",
"psychiques" => "psiSik",
"psychisme" => "psiSizm",
"psychismes" => "psiSizm",
"psycho" => "psiko",
"psychochirurgie" => "psikoSiRyRZi",
"psychodrame" => "psikodRam",
"psychodysleptique" => "psikodislEptik",
"psychogène" => "psikoZEn",
"psychogènes" => "psikoZEn",
"psychokinésie" => "psikokinezi",
"psycholinguistes" => "psikol5g8ist",
"psycholinguistique" => "psikol5g8istik",
"psychologie" => "psikoloZi",
"psychologie-fiction" => "psikoloZifiksj§",
"psychologies" => "psikoloZi",
"psychologique" => "psikoloZik",
"psychologiquement" => "psikoloZik°m@",
"psychologiques" => "psikoloZik",
"psychologisation" => "psikoloZizasj§",
"psychologue" => "psikolOg",
"psychologues" => "psikolOg",
"psychométrique" => "psikOmetRik",
"psychomotrice" => "psikOmOtRis",
"psychonévrose" => "psikonevRoz",
"psychopathe" => "psikopat",
"psychopathes" => "psikopat",
"psychopathie" => "psikOpati",
"psychopathique" => "psikopatik",
"psychopathologie" => "psikopatoloZi",
"psychopathologique" => "psikopatoloZik",
"psychopharmacologie" => "psikofaRmakoloZi",
"psychophysiologie" => "psikofizjoloZi",
"psychophysiologique" => "psikofizjoloZik",
"psychorigide" => "psikoRiZid",
"psychose" => "psikoz",
"psychosexuel" => "psikosEks8El",
"psychosociologie" => "psikososjoloZi",
"psychosociologue" => "psikosOsjOlOg",
"psychosomaticien" => "psikozomatisj5",
"psychosomatique" => "psikosomatik",
"psychosomatiques" => "psikosomatik",
"psychotechnicien" => "psikotEknisj5",
"psychotechniciens" => "psikotEknisj5",
"psychotechnique" => "psikOtEknik",
"psychothérapeute" => "psikoteRap2t",
"psychothérapie" => "psikoteRapi",
"psychotique" => "psikotik",
"psychotiques" => "psikotik",
"psychotoniques" => "psikotonik",
"psychotrope" => "psikotROp",
"psychotropes" => "psikotROp",
"psyllium" => "psiljOm",
"psys" => "psi",
"ptérodactyle" => "pteRodaktil",
"ptérodactyles" => "pteRodaktil",
"ptosis" => "ptozis",
"ptyx" => "ptiks",
"pu" => "py",
"pua" => "p8a",
"puaient" => "p8E",
"puais" => "p8E",
"puait" => "p8E",
"puant" => "p8@",
"puante" => "p8@t",
"puantes" => "p8@t",
"puanteur" => "p8@t9R",
"puanteurs" => "p8@t9R",
"puants" => "p8@",
"pub" => "p9b",
"pubère" => "pybER",
"pubères" => "pybER",
"pubertaire" => "pybERtER",
"pubertaires" => "pybERtER",
"puberté" => "pybERte",
"pubescentes" => "pybEs@t",
"pubien" => "pybj5",
"pubienne" => "pybjEn",
"pubiennes" => "pybjEn",
"pubiens" => "pybj5",
"pubis" => "pybis",
"publia" => "pyblija",
"publiable" => "pyblijabl",
"publiables" => "pybliabl",
"publiai" => "pyblijE",
"publiaient" => "pyblijE",
"publiais" => "pyblijE",
"publiait" => "pyblijE",
"publiant" => "pyblij@",
"publiât" => "pyblija",
"public" => "pyblik",
"public schools" => "p9blikskulz",
"public-relations" => "p9blikRilEjS9n",
"publicain" => "pyblik5",
"publicains" => "pyblik5",
"publication" => "pyblikasj§",
"publications" => "pyblikasj§",
"publiciste" => "pyblisist",
"publicistes" => "pyblisist",
"publicitaire" => "pyblisitER",
"publicitairement" => "pyblisitER°m@",
"publicitaires" => "pyblisitER",
"publicité" => "pyblisite",
"publicités" => "pyblisite",
"publico" => "pybliko",
"publics" => "pyblik",
"publie" => "pybli",
"publié" => "pyblije",
"publiée" => "pyblije",
"publiées" => "pyblije",
"publient" => "pybli",
"publier" => "pyblije",
"publiera" => "pybliRa",
"publierai" => "pybliRE",
"publieraient" => "pybliRE",
"publierais" => "pybliRE",
"publierait" => "pybliRE",
"publièrent" => "pyblijER",
"publierez" => "pybliRe",
"publierions" => "pybliRj§",
"publierons" => "pybliR§",
"publieront" => "pybliR§",
"publies" => "pybli",
"publiés" => "pyblije",
"publieur" => "pyblj9R",
"publiez" => "pyblije",
"publions" => "pyblij§",
"publiphone" => "pyblifOn",
"publique" => "pyblik",
"publiquement" => "pyblik°m@",
"publiques" => "pyblik",
"publireportage" => "pybliR2pORtaZ",
"pubs" => "p9b",
"puce" => "pys",
"puceau" => "pyso",
"puceaux" => "pyso",
"pucelage" => "pys°laZ",
"pucelages" => "pys°laZ",
"pucelle" => "pysEl",
"pucelles" => "pysEl",
"puceron" => "pys°R§",
"pucerons" => "pys°R§",
"puces" => "pys",
"pucher" => "pySe",
"pucheux" => "pyS2",
"pucier" => "pysje",
"puciers" => "pysje",
"pudding" => "pudiG",
"puddings" => "pudiG",
"puddle" => "p9dl",
"pudeur" => "pyd9R",
"pudeurs" => "pyd9R",
"pudibond" => "pydib§",
"pudibonde" => "pydib§d",
"pudibonderie" => "pydib§d°Ri",
"pudibonderies" => "pydib§d°Ri",
"pudibondes" => "pydib§d",
"pudibonds" => "pydib§",
"pudicité" => "pydisite",
"pudique" => "pydik",
"pudiquement" => "pydik°m@",
"pudiques" => "pydik",
"pue" => "py",
"pueblo" => "py°blo",
"puent" => "py",
"puer" => "p8e",
"puera" => "pyRa",
"puerait" => "pyRE",
"pueras" => "pyRa",
"puerez" => "pyRe",
"puéricultrice" => "p8eRikyltRis",
"puéricultrices" => "p8eRikyltRis",
"puériculture" => "p8eRikyltyR",
"puéril" => "p8eRil",
"puérile" => "p8eRil",
"puérilement" => "p8eRil°m@",
"puériles" => "p8eRil",
"puérilité" => "p8eRilite",
"puérilités" => "p8eRilite",
"puérils" => "p8eRil",
"puerpérale" => "p8ERpeRal",
"pues" => "py",
"puez" => "pye",
"puff" => "p9f",
"puffin" => "pyf5",
"pugilat" => "pyZila",
"pugilats" => "pyZila",
"pugiler" => "pyZile",
"pugiliste" => "pyZilist",
"pugilistes" => "pyZilist",
"pugilistique" => "pyZilistik",
"pugnace" => "pyNas",
"pugnacité" => "pyNasite",
"puîné" => "p8ine",
"puînée" => "p8ine",
"puînés" => "p8ine",
"puis" => "p8i",
"puisa" => "p8iza",
"puisai" => "p8izE",
"puisaient" => "p8izE",
"puisais" => "p8izE",
"puisait" => "p8izE",
"puisant" => "p8iz@",
"puisard" => "p8izaR",
"puisards" => "p8izaR",
"puisatier" => "p8izatje",
"puise" => "p8iz",
"puisé" => "p8ize",
"puisée" => "p8ize",
"puisées" => "p8ize",
"puisent" => "p8iz",
"puiser" => "p8ize",
"puisera" => "p8iz°Ra",
"puiserai" => "p8iz°RE",
"puiserait" => "p8iz°RE",
"puiserez" => "p8iz°Re",
"puiseront" => "p8iz°R§",
"puises" => "p8iz",
"puisés" => "p8ize",
"puisette" => "p8izEt",
"puisez" => "p8ize",
"puisions" => "p8izj§",
"puisons" => "p8iz§",
"puisqu" => "p8isk",
"puisque" => "p8isk°",
"puissamment" => "p8isam@",
"puissance" => "p8is@s",
"puissances" => "p8is@s",
"puissant" => "p8is@",
"puissante" => "p8is@t",
"puissantes" => "p8is@t",
"puissants" => "p8is@",
"puisse" => "p8is",
"puissent" => "p8is",
"puisses" => "p8is",
"puissiez" => "p8isje",
"puissions" => "p8isj§",
"puits" => "p8i",
"pull" => "pyl",
"pull-over" => "pylovER",
"pull-overs" => "pylovER",
"pullman" => "pulman",
"pullmans" => "pulman",
"pulls" => "pyl",
"pullula" => "pylyla",
"pullulaient" => "pylylE",
"pullulait" => "pylylE",
"pullulant" => "pylyl@",
"pullulantes" => "pylyl@t",
"pullulants" => "pylyl@",
"pullule" => "pylyl",
"pullulement" => "pylyl°m@",
"pullulent" => "pylyl",
"pulluler" => "pylyle",
"pulluleront" => "pylyl°R§",
"pulmonaire" => "pylmonER",
"pulmonaires" => "pylmonER",
"pulmonie" => "pylmOni",
"pulmonique" => "pylmOnik",
"pulpe" => "pylp",
"pulpes" => "pylp",
"pulpeuse" => "pylp2z",
"pulpeuses" => "pylp2z",
"pulpeux" => "pylp2",
"pulque" => "pylk",
"pulsait" => "pylsE",
"pulsant" => "pyls@",
"pulsar" => "pylsaR",
"pulsatile" => "pylsatil",
"pulsation" => "pylsasj§",
"pulsations" => "pylsasj§",
"pulsative" => "pylsativ",
"pulse" => "pyls",
"pulsé" => "pylse",
"pulser" => "pylse",
"pulseur" => "pyls9R",
"pulsion" => "pylsj§",
"pulsions" => "pylsj§",
"pulso-réacteurs" => "pylsoReakt9R",
"pulsoréacteurs" => "pylsoReakt9R",
"pulvérin" => "pylveR5",
"pulvérisa" => "pylveRiza",
"pulvérisaient" => "pylveRizE",
"pulvérisais" => "pylveRizE",
"pulvérisait" => "pylveRizE",
"pulvérisant" => "pylveRiz@",
"pulvérisateur" => "pylveRizat9R",
"pulvérisateurs" => "pylveRizat9R",
"pulvérisation" => "pylveRizasj§",
"pulvérisations" => "pylveRizasj§",
"pulvérise" => "pylveRiz",
"pulvérisé" => "pylveRize",
"pulvérisée" => "pylveRize",
"pulvérisées" => "pylveRize",
"pulvérisent" => "pylveRiz",
"pulvériser" => "pylveRize",
"pulvériserai" => "pylveRiz°RE",
"pulvériserait" => "pylveRiz°RE",
"pulvériserons" => "pylveRiz°R§",
"pulvériseront" => "pylveRiz°R§",
"pulvérises" => "pylveRiz",
"pulvérisés" => "pylveRize",
"pulvérisez" => "pylveRize",
"pulvérulence" => "pylveRyl@s",
"pulvérulentes" => "pylveRyl@t",
"puma" => "pyma",
"pumas" => "pyma",
"pûmes" => "pym",
"punais" => "pynE",
"punaisait" => "pynEzE",
"punaise" => "pynEz",
"punaisé" => "pynEze",
"punaisée" => "pynEze",
"punaisées" => "pynEze",
"punaises" => "pynEz",
"punaisés" => "pynEze",
"punch" => "p§S",
"puncheur" => "p9nS9R",
"punching ball" => "p9nSiGbOl",
"punching-ball" => "p9nSiGbOl",
"punchs" => "p9nS",
"punctiforme" => "p§ktifORm",
"puncture" => "p§ktyR",
"puni" => "pyni",
"punie" => "pyni",
"punies" => "pyni",
"punique" => "pynik",
"puniques" => "pynik",
"punir" => "pyniR",
"punira" => "pyniRa",
"punirai" => "pyniRE",
"punirais" => "pyniRE",
"punirait" => "pyniRE",
"puniras" => "pyniRa",
"punirez" => "pyniRe",
"punirons" => "pyniR§",
"puniront" => "pyniR§",
"punis" => "pyni",
"punissable" => "pynisabl",
"punissables" => "pynisabl",
"punissaient" => "pynisE",
"punissais" => "pynisE",
"punissait" => "pynisE",
"punissant" => "pynis@",
"punisse" => "pynis",
"punissent" => "pynis",
"punisses" => "pynis",
"punisseur" => "pynis9R",
"punissez" => "pynise",
"punissions" => "pynisj§",
"punissons" => "pynis§",
"punit" => "pyni",
"punitif" => "pynitif",
"punition" => "pynisj§",
"punitions" => "pynisj§",
"punitive" => "pynitiv",
"punitives" => "pynitiv",
"punk" => "p1k",
"punkette" => "p9nkEt",
"punks" => "p1k",
"punt" => "punt",
"pupazzo" => "pupadzo",
"pupe" => "pyp",
"pupillaire" => "pypilER",
"pupillaires" => "pypilER",
"pupille" => "pypij",
"pupilles" => "pypij",
"pupitre" => "pypitR",
"pupitres" => "pypitR",
"pupitreur" => "pypitR9R",
"pur" => "pyR",
"pur-sang" => "pyRs@",
"pure" => "pyR",
"pureau" => "pyRo",
"purée" => "pyRe",
"purées" => "pyRe",
"purement" => "pyR°m@",
"purent" => "pyR",
"pures" => "pyR",
"pureté" => "pyR°te",
"puretés" => "pyR°te",
"purgatif" => "pyRgatif",
"purgation" => "pyRgasj§",
"purgations" => "pyRgasj§",
"purgative" => "pyRgativ",
"purgatoire" => "pyRgatwaR",
"purgatoires" => "pyRgatwaR",
"purge" => "pyRZ",
"purgé" => "pyRZe",
"purgea" => "pyRZa",
"purgeaient" => "pyRZE",
"purgeais" => "pyRZE",
"purgeait" => "pyRZE",
"purgeant" => "pyRZ@",
"purgée" => "pyRZe",
"purgées" => "pyRZe",
"purgent" => "pyRZ",
"purger" => "pyRZe",
"purgera" => "pyRZ°Ra",
"purgerai" => "pyRZ°RE",
"purgerais" => "pyRZ°RE",
"purgeras" => "pyRZ°Ra",
"purgerez" => "pyRZ°Re",
"purgeriez" => "pyRZ°Rje",
"purges" => "pyRZ",
"purgés" => "pyRZe",
"purgez" => "pyRZe",
"purgiez" => "pyRZje",
"purifiaient" => "pyRifjE",
"purifiais" => "pyRifjE",
"purifiait" => "pyRifjE",
"purifiant" => "pyRifj@",
"purifiât" => "pyRifja",
"purificateur" => "pyRifikat9R",
"purificateurs" => "pyRifikat9R",
"purification" => "pyRifikasj§",
"purifications" => "pyRifikasj§",
"purificatoire" => "pyRifikatwaR",
"purificatrice" => "pyRifikatRis",
"purificatrices" => "pyRifikatRis",
"purifie" => "pyRifi",
"purifié" => "pyRifje",
"purifiée" => "pyRifje",
"purifiées" => "pyRifje",
"purifient" => "pyRifi",
"purifier" => "pyRifje",
"purifiera" => "pyRifiRa",
"purifiés" => "pyRifje",
"purifiez" => "pyRifje",
"purifions" => "pyRifj§",
"purin" => "pyR5",
"puriste" => "pyRist",
"puristes" => "pyRist",
"puritain" => "pyRit5",
"puritaine" => "pyRitEn",
"puritaines" => "pyRitEn",
"puritains" => "pyRit5",
"puritanisme" => "pyRitanizm",
"purotin" => "pyRot5",
"purotins" => "pyRot5",
"purpura" => "pyRpyRa",
"purpurin" => "pyRpyR5",
"purpurine" => "pyRpyRin",
"purpurines" => "pyRpyRin",
"purpurins" => "pyRpyR5",
"purs" => "pyR",
"purulence" => "pyRyl@s",
"purulences" => "pyRyl@s",
"purulent" => "pyRyl@",
"purulente" => "pyRyl@t",
"purulentes" => "pyRyl@t",
"purulents" => "pyRyl@",
"pus" => "py",
"pusillanime" => "pyzilanim",
"pusillanimes" => "pyzilanim",
"pusillanimité" => "pyzilanimite",
"pusse" => "pys",
"pussent" => "pys",
"pusses" => "pys",
"pussiez" => "pysje",
"pustule" => "pystyl",
"pustules" => "pystyl",
"pustuleuse" => "pystyl2z",
"pustuleux" => "pystyl2",
"put" => "py",
"pût" => "py",
"putain" => "pyt5",
"putains" => "pyt5",
"putanat" => "pytana",
"putasse" => "pytas",
"putasserie" => "pytas°Ri",
"putasseries" => "pytas°Ri",
"putasses" => "pytas",
"putassier" => "pytasje",
"putassière" => "pytasjER",
"putassières" => "pytasjER",
"putassiers" => "pytasje",
"putatif" => "pytatif",
"putatifs" => "pytatif",
"putative" => "pytativ",
"pute" => "pyt",
"putes" => "pyt",
"pûtes" => "pyt",
"putier" => "pytje",
"putois" => "pytwa",
"putréfaction" => "pytRefaksj§",
"putréfiaient" => "pytRefjE",
"putréfiait" => "pytRefjE",
"putréfiant" => "pytRefj@",
"putréfié" => "pytRefje",
"putréfiée" => "pytRefje",
"putréfiées" => "pytRefje",
"putréfient" => "pytRefi",
"putréfier" => "pytRefje",
"putréfiés" => "pytRefje",
"putrescence" => "pytRes@s",
"putrescences" => "pytRes@s",
"putrescent" => "pytRes@",
"putrescents" => "pytRes@",
"putrescible" => "pytResibl",
"putrescine" => "pytResin",
"putride" => "pytRid",
"putrides" => "pytRid",
"putsch" => "putS",
"putschiste" => "putSist",
"putt" => "p9t",
"putter" => "p9te",
"putti" => "puti",
"putting" => "p9tiG",
"puy" => "p8i",
"puzzle" => "p9z9l",
"puzzles" => "p9z9l",
"pygmée" => "pigme",
"pygmées" => "pigme",
"pyjama" => "piZama",
"pyjamas" => "piZama",
"pylône" => "pilon",
"pylônes" => "pilon",
"pylore" => "pilOR",
"pylorique" => "piloRik",
"pyogène" => "pjOZEn",
"pyralène" => "piRalEn",
"pyrame" => "piRam",
"pyramidal" => "piRamidal",
"pyramidale" => "piRamidal",
"pyramidalement" => "piRamidal°m@",
"pyramidales" => "piRamidal",
"pyramidaux" => "piRamido",
"pyramide" => "piRamid",
"pyramidé" => "piRamide",
"pyramides" => "piRamid",
"pyrénéen" => "piRene5",
"pyrénéenne" => "piReneEn",
"pyrèthre" => "piREtR",
"pyréthrine" => "piRetRin",
"pyrex" => "piREks",
"pyrexie" => "piREksi",
"pyridoxine" => "piRidOksin",
"pyrite" => "piRit",
"pyrites" => "piRit",
"pyroclastique" => "piRoklastik",
"pyroclastiques" => "piRoklastik",
"pyrogène" => "piRoZEn",
"pyrogravées" => "piRogRave",
"pyrolyse" => "piROliz",
"pyromane" => "piRoman",
"pyromanes" => "piRoman",
"pyromanie" => "piRomani",
"pyromètre" => "piRomEtR",
"pyrosphère" => "piRosfER",
"pyrotechnicien" => "piROtEknisj5",
"pyrotechnie" => "piRotEkni",
"pyrotechnique" => "piRotEknik",
"pyroxène" => "piROksEn",
"pyrrhique" => "piRik",
"pyrrhonien" => "piRonj5",
"pyrrhonisme" => "piRonizm",
"pythagoricien" => "pitagoRisj5",
"pythagoriques" => "pitagoRik",
"pythie" => "piti",
"pythies" => "piti",
"python" => "pit§",
"pythonisse" => "pitonis",
"pythons" => "pit§",
"pyxides" => "piksid",
"q" => "ky",
"qu" => "k",
"qu'en-dira-t-on" => "k@diRat§",
"quadra" => "kwadRa",
"quadragénaire" => "kwadRaZenER",
"quadragénaires" => "kwadRaZenER",
"quadrangle" => "kwadR@gl",
"quadrangulaire" => "kwadR@gylER",
"quadrangulaires" => "kwadR@gylER",
"quadrant" => "kwadR@",
"quadrants" => "kwadR@",
"quadras" => "kadRas",
"quadratique" => "kwadRatik",
"quadrature" => "kwadRatyR",
"quadri" => "kadRi",
"quadriceps" => "kwadRisEps",
"quadrichromie" => "kwadRikRomi",
"quadrichromies" => "kwadRikRomi",
"quadridimensionnel" => "kwadRidim@sjOnEl",
"quadriennal" => "kwadRijEnal",
"quadrige" => "kadRiZ",
"quadrilatère" => "kwadRilatER",
"quadrilatères" => "kwadRilatER",
"quadrillage" => "kadRijaZ",
"quadrillages" => "kadRijaZ",
"quadrillaient" => "kadRijE",
"quadrillais" => "kadRijE",
"quadrillait" => "kadRijE",
"quadrille" => "kadRij",
"quadrillé" => "kadRije",
"quadrillée" => "kadRije",
"quadrillées" => "kadRije",
"quadrillent" => "kadRij",
"quadriller" => "kadRije",
"quadrillerez" => "kadRij°Re",
"quadrilles" => "kadRij",
"quadrillés" => "kadRije",
"quadrillez" => "kadRije",
"quadrillion" => "kadRij§",
"quadrillons" => "kadRij§",
"quadrilobé" => "kwadRilobe",
"quadrimestre" => "kwadRimEstR",
"quadrimoteur" => "kwadRimot9R",
"quadripartite" => "kwadRipaRtit",
"quadripartites" => "kwadRipaRtit",
"quadriphonie" => "kwadRifoni",
"quadriphonique" => "kwadRifonik",
"quadriplégique" => "kwadRipleZik",
"quadriréacteur" => "kwadRiReakt9R",
"quadrivium" => "kwadRivjOm",
"quadrumane" => "kwadRuman",
"quadrupède" => "kwadRupEd",
"quadrupèdes" => "kwadRupEd",
"quadrupla" => "kwadRupla",
"quadruplait" => "kwadRuplE",
"quadruple" => "kwadRupl",
"quadruplé" => "kwadRyple",
"quadruplées" => "kwadRyple",
"quadrupler" => "kwadRyple",
"quadruples" => "kwadRupl",
"quadruplés" => "kwadRyple",
"quai" => "kE",
"quais" => "ke",
"quaker" => "kwEk9R",
"quakeresse" => "kwEk°REs",
"quakers" => "kwEk9R",
"qualifia" => "kalifja",
"qualifiable" => "kalifjabl",
"qualifiaient" => "kalifjE",
"qualifiais" => "kalifjE",
"qualifiait" => "kalifjE",
"qualifiant" => "kalifj@",
"qualifiassent" => "kalifjas",
"qualifiât" => "kalifja",
"qualificatif" => "kalifikatif",
"qualificatifs" => "kalifikatif",
"qualification" => "kalifikasj§",
"qualifications" => "kalifikasj§",
"qualifie" => "kalifi",
"qualifié" => "kalifje",
"qualifiée" => "kalifje",
"qualifiées" => "kalifje",
"qualifient" => "kalifi",
"qualifier" => "kalifje",
"qualifiera" => "kalifiRa",
"qualifierai" => "kalifiRE",
"qualifierais" => "kalifiRE",
"qualifierait" => "kalifiRE",
"qualifieriez" => "kalifiRje",
"qualifiés" => "kalifje",
"qualifiez" => "kalifje",
"qualitatif" => "kalitatif",
"qualitatifs" => "kalitatif",
"qualitative" => "kalitativ",
"qualité" => "kalite",
"qualités" => "kalite",
"quand" => "k@",
"quant" => "k@",
"quant-à-moi" => "k@tamwa",
"quant-à-soi" => "k@taswa",
"quanta" => "kw@ta",
"quantième" => "k@tjEm",
"quantièmes" => "k@tjEm",
"quantifiable" => "k@tifjabl",
"quantifiée" => "k@tifje",
"quantifier" => "k@tifje",
"quantique" => "kw@tik",
"quantiques" => "kw@tik",
"quantitatif" => "k@titatif",
"quantitative" => "k@titativ",
"quantitativement" => "k@titativ°m@",
"quantitatives" => "k@titativ",
"quantité" => "k@tite",
"quantités" => "k@tite",
"quanto" => "k@to",
"quantum" => "kw@tOm",
"quarantaine" => "kaR@tEn",
"quarantaines" => "kaR@tEn",
"quarante" => "kaR@t",
"quarante-cinq" => "kaR@ts5k",
"quarante-cinquième" => "kaR@ts5kjEm",
"quarante-deux" => "kaR@td2",
"quarante-deuxième" => "kaR@td2zjEm",
"quarante-huit" => "kaR@t8it",
"quarante-huitards" => "kaR@t°8itaR",
"quarante-huitième" => "kaR@t8itjEm",
"quarante-neuf" => "kaR@tn9f",
"quarante-quatre" => "kaR@t°katR",
"quarante-sept" => "kaR@tsEt",
"quarante-septième" => "kaR@tsEtjEm",
"quarante-six" => "kaR@tsis",
"quarante-trois" => "kaR@t°tRwa",
"quarante-troisième" => "kaR@ttRwazjEm",
"quarantenaire" => "kaR@t°nER",
"quarantenaires" => "kaR@t°nER",
"quarantième" => "kaR@tjEm",
"quarantièmes" => "kaR@tjEm",
"quark" => "kwaRk",
"quarks" => "kwaRk",
"quarre" => "kaR",
"quarrez" => "kaRe",
"quart" => "kaR",
"quart-monde" => "kaRm§d",
"quartaut" => "kaRto",
"quarte" => "kaRt",
"quarté" => "kaRte",
"quartenier" => "kaRt°nje",
"quarter" => "kaRte",
"quarteron" => "kaRt°R§",
"quarteronnes" => "kaRt°ROn",
"quarterons" => "kaRt°R§",
"quartet" => "kwaRtE",
"quartette" => "kwaRtEt",
"quartettes" => "kwaRtEt",
"quartidi" => "kwaRtidi",
"quartier" => "kaRtje",
"quartier-maître" => "kaRtjemEtR",
"quartiers" => "kaRtje",
"quartiers-maîtres" => "kaRtjemEtR",
"quarto" => "kwaRto",
"quarts" => "kaR",
"quartz" => "kwaRts",
"quasar" => "kazaR",
"quasi" => "kazi",
"quasi-agonie" => "kaziagoni",
"quasi-blasphème" => "kaziblasfEm",
"quasi-bonheur" => "kazibon9R",
"quasi-certitude" => "kazisERtityd",
"quasi-chômage" => "kaziSomaZ",
"quasi-débutant" => "kazidebyt@",
"quasi-décapitation" => "kazidekapitasj§",
"quasi-désertification" => "kazidezERtifikasj§",
"quasi-émeute" => "kaziem2t",
"quasi-équitable" => "kaziekitabl",
"quasi-facétieux" => "kazifasesj2",
"quasi-fiancée" => "kazifj@se",
"quasi-futuristes" => "kazifytyRist",
"quasi-génocide" => "kaziZenosid",
"quasi-hérétique" => "kazieRetik",
"quasi-ignare" => "kaziiNaR",
"quasi-impossibilité" => "kazi5posibilite",
"quasi-impunité" => "kazi5pynite",
"quasi-inconnu" => "kazi5kony",
"quasi-indifférence" => "kazi5difeR@s",
"quasi-infirme" => "kazi5fiRm",
"quasi-instantanée" => "kazi5st@tane",
"quasi-jungienne" => "kazijuGjEn",
"quasi-mariage" => "kazimaRjaZ",
"quasi-maximum" => "kazimaksimOm",
"quasi-mendiant" => "kazim@dj@",
"quasi-miracle" => "kazimiRakl",
"quasi-monopole" => "kazimOnOpOl",
"quasi-morceau" => "kazimORso",
"quasi-noyade" => "kazinwajad",
"quasi-nudité" => "kazinydite",
"quasi-permanence" => "kazipERman@s",
"quasi-protection" => "kazipRotEksj§",
"quasi-religieux" => "kaziR°liZj2",
"quasi-respect" => "kaziREspE",
"quasi-totalité" => "kazitotalite",
"quasi-unanime" => "kaziynanim",
"quasi-unanimité" => "kaziynanimite",
"quasi-veuvage" => "kaziv9vaZ",
"quasi-ville" => "kazivil",
"quasi-voisines" => "kazivwazin",
"quasiment" => "kazim@",
"quasimodo" => "kazimOdo",
"quasimodos" => "kazimodo",
"quat'zarts" => "katzaR",
"quater" => "kwatER",
"quaternaire" => "kwatERnER",
"quatorze" => "katORz",
"quatorzième" => "katORzjEm",
"quatrain" => "katR5",
"quatrains" => "katR5",
"quatre" => "katR",
"quatre-feuilles" => "katRf9j",
"quatre-heures" => "katR9R",
"quatre-mâts" => "katRma",
"quatre-quarts" => "katRkaR",
"quatre-saisons" => "katR°sEz§",
"quatre-vingt" => "katR°v5",
"quatre-vingt-cinq" => "katR°v5s5k",
"quatre-vingt-deux" => "katR°v5d2",
"quatre-vingt-dix" => "katR°v5dis",
"quatre-vingt-dix-huit" => "katR°v5diz8it",
"quatre-vingt-dix-neuf" => "katR°v5dizn9f",
"quatre-vingt-dix-sept" => "katR°v5disEt",
"quatre-vingt-dixième" => "katR°v5dizjEm",
"quatre-vingt-douze" => "katR°v5duz",
"quatre-vingt-douzième" => "katR°v5duzjEm",
"quatre-vingt-huit" => "katR°v58it",
"quatre-vingt-neuf" => "katR°v5n9f",
"quatre-vingt-onze" => "katR°v5§z",
"quatre-vingt-quatorze" => "katR°v5katORz",
"quatre-vingt-quatre" => "katR°v5katR",
"quatre-vingt-quinze" => "katR°v5k5z",
"quatre-vingt-seize" => "katR°v5sEz",
"quatre-vingt-sept" => "katR°v5sEt",
"quatre-vingt-six" => "katR°v5sis",
"quatre-vingt-treize" => "katR°v5tREz",
"quatre-vingt-treizième" => "katR°v5tREzjEm",
"quatre-vingt-trois" => "katR°v5tRwa",
"quatre-vingt-un" => "katR°v51",
"quatre-vingtième" => "katR°v5tjEm",
"quatre-vingts" => "katR°v5",
"quatrième" => "katRijEm",
"quatrièmement" => "katRijEm°m@",
"quatrièmes" => "katRijEm",
"quatrillion" => "kwatRilj§",
"quattrocento" => "kwatRotSEnto",
"quatuor" => "kwat8OR",
"quatuors" => "kwat8OR",
"que" => "k2",
"québécois" => "kebekwa",
"québécoise" => "kebekwaz",
"quechua" => "keSua",
"quel" => "kEl",
"quelconque" => "kElk§k",
"quelconques" => "kElk§k",
"quelle" => "kEl",
"quelles" => "kEl",
"quelqu'un" => "kElk1",
"quelqu'une" => "kElkyn",
"quelque" => "kElk",
"quelquefois" => "kElk°fwa",
"quelques" => "kElk",
"quelques-unes" => "kElk°zyn",
"quelques-uns" => "kElk°z1",
"quels" => "kEl",
"quémanda" => "kem@da",
"quémandaient" => "kem@dE",
"quémandait" => "kem@dE",
"quémandant" => "kem@d@",
"quémande" => "kem@d",
"quémandé" => "kem@de",
"quémandent" => "kem@d",
"quémander" => "kem@de",
"quémandeur" => "kem@d9R",
"quémandeurs" => "kem@d9R",
"quémandeuse" => "kem@d2z",
"quémandeuses" => "kem@d2z",
"quémandons" => "kem@d§",
"quenelle" => "k°nEl",
"quenelles" => "k°nEl",
"quenotte" => "k°nOt",
"quenottes" => "k°nOt",
"quenouille" => "k°nuj",
"quenouilles" => "k°nuj",
"quéquette" => "kekEt",
"quéquettes" => "kekEt",
"querella" => "k°REla",
"querellaient" => "k°RElE",
"querellais" => "k°RElE",
"querellait" => "k°RElE",
"querellant" => "k°REl@",
"querelle" => "k°REl",
"querellé" => "k°Rele",
"querellée" => "k°Rele",
"querellées" => "k°REle",
"querellent" => "k°REl",
"quereller" => "k°Rele",
"querellèrent" => "k°RElER",
"querelles" => "k°REl",
"querellés" => "k°Rele",
"querelleur" => "k°REl9R",
"querelleurs" => "k°REl9R",
"querelleuse" => "k°REl2z",
"querellez" => "k°REle",
"querellons" => "k°REl§",
"quérir" => "keRiR",
"questeur" => "k8Est9R",
"questeurs" => "kEst9R",
"question" => "kEstj§",
"question-clé" => "kEstj§kle",
"question-réponse" => "kEstj§Rep§s",
"questionna" => "kEstjona",
"questionnai" => "kEstjonE",
"questionnaient" => "kEstjonE",
"questionnaire" => "kEstjonER",
"questionnaires" => "kEstjonER",
"questionnais" => "kEstjonE",
"questionnait" => "kEstjonE",
"questionnant" => "kEstjon@",
"questionnât" => "kEstjona",
"questionne" => "kEstjOn",
"questionné" => "kEstjone",
"questionnée" => "kEstjone",
"questionnement" => "kEstjOn°m@",
"questionnements" => "kEstjOn°m@",
"questionnent" => "kEstjOn",
"questionner" => "kEstjone",
"questionnera" => "kEstjOn°Ra",
"questionnerai" => "kEstjOn°RE",
"questionnerait" => "kEstjOn°RE",
"questionnèrent" => "kEstjonER",
"questionnerons" => "kEstjOn°R§",
"questionneront" => "kEstjOn°R§",
"questionnés" => "kEstjone",
"questionneur" => "kEstjon9R",
"questionneurs" => "kEstjon9R",
"questionneuse" => "kEstjon2z",
"questionnez" => "kEstjone",
"questionnions" => "kEstjonj§",
"questionnons" => "kEstjon§",
"questions" => "kEstj§",
"questions-réponses" => "kEstj§Rep§s",
"questure" => "kEstyR",
"quêta" => "kEta",
"quêtai" => "kEtE",
"quêtaient" => "kEtE",
"quêtais" => "kEtE",
"quêtait" => "kEtE",
"quêtant" => "kEt@",
"quête" => "kEt",
"quêté" => "kete",
"quêtées" => "kete",
"quêtent" => "kEt",
"quêter" => "kete",
"quêtes" => "kEt",
"quêteur" => "kEt9R",
"quêteurs" => "kEt9R",
"quêteuse" => "kEt2z",
"quêtez" => "kEte",
"quetsche" => "kwEtS",
"quetsches" => "kwEtS",
"quette" => "kEt",
"quetzal" => "kEtzal",
"queue" => "k2",
"queue-d'aronde" => "k2daR§d",
"queue-de-cheval" => "k2d°S°val",
"queue-de-pie" => "k2d°pi",
"queues" => "k2",
"queues-d'aronde" => "k2daR§d",
"queues-de-rat" => "k2d°Ra",
"queursoir" => "k9RswaR",
"queutard" => "k2taR",
"queuté" => "k2te",
"queutée" => "k2te",
"qui" => "ki",
"qui-vive" => "kiviv",
"quibus" => "k8ibys",
"quiche" => "kiS",
"quiches" => "kiS",
"quichotte" => "kiSOt",
"quick" => "kik",
"quiconque" => "kik§k",
"quidam" => "k8idam",
"quidams" => "k8idam",
"quiet" => "kjE",
"quiète" => "kjEt",
"quiètement" => "kjEt°m@",
"quiètes" => "kjEt",
"quiétisme" => "kjetizm",
"quiétiste" => "kjetist",
"quiets" => "kjE",
"quiétude" => "kjetyd",
"quiétudes" => "kjetyd",
"quignon" => "kiN§",
"quignons" => "kiN§",
"quillai" => "kijE",
"quillards" => "kijaR",
"quille" => "kij",
"quillée" => "kije",
"quiller" => "kije",
"quilles" => "kij",
"quillon" => "kij§",
"quillons" => "kij§",
"quimpe" => "k5p",
"quimpé" => "k5pe",
"quimpent" => "k5p",
"quimper" => "k5pe",
"quincaille" => "k5kaj",
"quincaillerie" => "k5kaj°Ri",
"quincailleries" => "k5kaj°Ri",
"quincaillier" => "k5kaje",
"quincaillière" => "k5kajER",
"quincailliers" => "k5kaje",
"quinconce" => "k5k§s",
"quinconces" => "k5k§s",
"quine" => "kin",
"quinine" => "kinin",
"quinium" => "kinjOm",
"quinoa" => "kinOa",
"quinqua" => "k5ka",
"quinquagénaire" => "k5kaZenER",
"quinquagénaires" => "k5kaZenER",
"quinquagésime" => "k5kaZezim",
"quinquennal" => "k5kenal",
"quinquennat" => "k85kena",
"quinquet" => "k5kE",
"quinquets" => "k5kE",
"quinquina" => "k5kina",
"quint" => "k5",
"quintaine" => "k5tEn",
"quintal" => "k5tal",
"quintaux" => "k5to",
"quinte" => "k5t",
"quinté" => "k5te",
"quintes" => "k5t",
"quintessence" => "k5tes@s",
"quintessencié" => "k5tes@sje",
"quintessenciée" => "k5tes@sje",
"quintessenciées" => "k5tEs@sje",
"quintet" => "k5tE",
"quintette" => "k5tEt",
"quintettes" => "k5tEt",
"quinteux" => "k5t2",
"quintidi" => "k5tidi",
"quinto" => "k5to",
"quintolet" => "k85tOlE",
"quinton" => "k85t§",
"quintupla" => "k5typla",
"quintuple" => "k5typl",
"quintuplé" => "k85typle",
"quintuplées" => "k5typle",
"quintuples" => "k5typl",
"quintuplés" => "k5typle",
"quinzaine" => "k5zEn",
"quinzaines" => "k5zEn",
"quinze" => "k5z",
"quinzième" => "k5zjEm",
"quipos" => "kipo",
"quiproquo" => "kipRoko",
"quiproquos" => "kipRoko",
"quipu" => "kipu",
"quiquette" => "kikEt",
"quiqui" => "kiki",
"quiscale" => "kiskal",
"quite" => "kwit2",
"quitta" => "kita",
"quittai" => "kitE",
"quittaient" => "kitE",
"quittais" => "kitE",
"quittait" => "kitE",
"quittâmes" => "kitam",
"quittance" => "kit@s",
"quittances" => "kit@s",
"quittant" => "kit@",
"quittas" => "kita",
"quittassent" => "kitas",
"quittât" => "kita",
"quitte" => "kit",
"quitté" => "kite",
"quittée" => "kite",
"quittées" => "kite",
"quittent" => "kit",
"quitter" => "kite",
"quittera" => "kit°Ra",
"quitterai" => "kit°RE",
"quitteraient" => "kit°RE",
"quitterais" => "kit°RE",
"quitterait" => "kit°RE",
"quitteras" => "kit°Ra",
"quittèrent" => "kitER",
"quitterez" => "kit°Re",
"quitteriez" => "kit°Rje",
"quitterions" => "kit°Rj§",
"quitterons" => "kit°R§",
"quitteront" => "kit°R§",
"quittes" => "kit",
"quittés" => "kite",
"quittez" => "kite",
"quittiez" => "kitje",
"quittions" => "kitj§",
"quittons" => "kit§",
"quitus" => "kitys",
"quiz" => "kiz",
"quoaillant" => "kOaj@",
"quoi" => "kwa",
"quoique" => "kwak°",
"quolibet" => "kolibE",
"quolibets" => "kolibE",
"quorum" => "koROm",
"quota" => "kota",
"quotas" => "kota",
"quote-part" => "kotpaR",
"quotidien" => "kotidj5",
"quotidienne" => "kotidjEn",
"quotidiennement" => "kotidjEn°m@",
"quotidiennes" => "kotidjEn",
"quotidienneté" => "kotidjEn°te",
"quotidiens" => "kotidj5",
"quotient" => "kosj@",
"quotients" => "kosj@",
"quotité" => "kotite",
"ra" => "Ra",
"rab" => "Rab",
"rabâcha" => "RabaSa",
"rabâchage" => "RabaSaZ",
"rabâchages" => "RabaSaZ",
"rabâchaient" => "RabaSE",
"rabâchais" => "RabaSE",
"rabâchait" => "RabaSE",
"rabâchant" => "RabaS@",
"rabâche" => "RabaS",
"rabâché" => "RabaSe",
"rabâchée" => "RabaSe",
"rabâchées" => "RabaSe",
"rabâchent" => "RabaS",
"rabâcher" => "RabaSe",
"rabâcherait" => "RabaS°RE",
"rabâches" => "RabaS",
"rabâcheur" => "RabaS9R",
"rabais" => "RabE",
"rabaissa" => "RabEsa",
"rabaissaient" => "RabEsE",
"rabaissais" => "RabEsE",
"rabaissait" => "RabEsE",
"rabaissant" => "RabEs@",
"rabaisse" => "RabEs",
"rabaissé" => "Rabese",
"rabaissée" => "Rabese",
"rabaissées" => "Rabese",
"rabaissement" => "RabEs°m@",
"rabaissent" => "RabEs",
"rabaisser" => "Rabese",
"rabaissera" => "RabEs°Ra",
"rabaisserait" => "RabEs°RE",
"rabaisses" => "RabEs",
"rabaissez" => "RabEse",
"raban" => "Rab@",
"rabane" => "Raban",
"rabanes" => "Raban",
"rabans" => "Rab@",
"rabat" => "Raba",
"rabat-joie" => "RabaZwa",
"rabats" => "Raba",
"rabattable" => "Rabatabl",
"rabattaient" => "RabatE",
"rabattais" => "RabatE",
"rabattait" => "RabatE",
"rabattant" => "Rabat@",
"rabatte" => "Rabat",
"rabattent" => "Rabat",
"rabatteur" => "Rabat9R",
"rabatteurs" => "Rabat9R",
"rabatteuse" => "Rabat2z",
"rabatteuses" => "Rabat2z",
"rabattez" => "Rabate",
"rabattions" => "Rabatj§",
"rabattirent" => "RabatiR",
"rabattis" => "Rabati",
"rabattit" => "Rabati",
"rabattra" => "RabatRa",
"rabattraient" => "RabatRE",
"rabattrait" => "RabatRE",
"rabattras" => "RabatRa",
"rabattre" => "RabatR",
"rabattrons" => "RabatR§",
"rabattu" => "Rabaty",
"rabattue" => "Rabaty",
"rabattues" => "Rabaty",
"rabattus" => "Rabaty",
"rabbi" => "Rabi",
"rabbin" => "Rab5",
"rabbinat" => "Rabina",
"rabbinique" => "Rabinik",
"rabbiniques" => "Rabinik",
"rabbins" => "Rab5",
"rabe" => "Rab",
"rabelaisien" => "Rab°lEzj5",
"rabelaisienne" => "Rab°lEzjEn",
"rabelaisiennes" => "Rab°lEzjEn",
"rabelaisiens" => "Rab°lEzj5",
"rabes" => "Rab",
"rabibochage" => "RabiboSaZ",
"rabiboche" => "RabibOS",
"rabiboché" => "RabibOSe",
"rabibochées" => "RabiboSe",
"rabibochent" => "RabibOS",
"rabibocher" => "RabiboSe",
"rabibocherez" => "RabibOS°Re",
"rabibochés" => "RabiboSe",
"rabiot" => "Rabjo",
"rabiotait" => "RabjotE",
"rabioter" => "Rabjote",
"rabique" => "Rabik",
"râble" => "Rabl",
"râblé" => "Rable",
"râblée" => "Rable",
"râblés" => "Rable",
"rabonnir" => "RaboniR",
"rabot" => "Rabo",
"rabotage" => "RabotaZ",
"rabotais" => "RabotE",
"rabotait" => "RabotE",
"rabotant" => "Rabot@",
"raboté" => "Rabote",
"rabotée" => "Rabote",
"rabotées" => "Rabote",
"rabotent" => "RabOt",
"raboter" => "Rabote",
"rabotés" => "Rabote",
"raboteur" => "Rabot9R",
"raboteuse" => "Rabot2z",
"raboteuses" => "Rabot2z",
"raboteux" => "Rabot2",
"rabotin" => "RabOt5",
"rabots" => "Rabo",
"rabougri" => "RabugRi",
"rabougrie" => "RabugRi",
"rabougries" => "RabugRi",
"rabougrir" => "RabugRiR",
"rabougris" => "RabugRi",
"rabougrissent" => "RabugRis",
"rabougrit" => "RabugRi",
"rabouillères" => "RabujER",
"rabouin" => "Rabw5",
"rabouler" => "Rabule",
"rabouté" => "Rabute",
"rabouter" => "Rabute",
"rabroua" => "RabRua",
"rabrouai" => "RabRuE",
"rabrouaient" => "RabRuE",
"rabrouait" => "RabRuE",
"rabrouant" => "RabRu@",
"rabrouât" => "RabRua",
"rabroue" => "RabRu",
"rabroué" => "RabRue",
"rabrouée" => "RabRue",
"rabrouer" => "RabRue",
"rabrouèrent" => "RabRuER",
"rabs" => "Rab",
"rac" => "Rak",
"racaille" => "Rakaj",
"racailles" => "Rakaj",
"raccommoda" => "Rakomoda",
"raccommodage" => "RakomodaZ",
"raccommodages" => "RakomodaZ",
"raccommodaient" => "RakomodE",
"raccommodait" => "RakomodE",
"raccommodant" => "Rakomod@",
"raccommode" => "RakomOd",
"raccommodé" => "Rakomode",
"raccommodée" => "Rakomode",
"raccommodées" => "Rakomode",
"raccommodements" => "RakomOd°m@",
"raccommodent" => "RakomOd",
"raccommoder" => "Rakomode",
"raccommodera" => "RakomOd°Ra",
"raccommoderai" => "RakomOd°RE",
"raccommodés" => "Rakomode",
"raccommodeurs" => "Rakomod9R",
"raccommodez" => "Rakomode",
"raccommodions" => "Rakomodj§",
"raccompagna" => "Rak§paNa",
"raccompagnai" => "Rak§paNE",
"raccompagnaient" => "Rak§paNE",
"raccompagnais" => "Rak§paNE",
"raccompagnait" => "Rak§paNE",
"raccompagnant" => "Rak§paN@",
"raccompagne" => "Rak§paN",
"raccompagné" => "Rak§paNe",
"raccompagnée" => "Rak§paNe",
"raccompagnent" => "Rak§paN",
"raccompagner" => "Rak§paNe",
"raccompagnera" => "Rak§paN°Ra",
"raccompagnerai" => "Rak§paN°RE",
"raccompagnerais" => "Rak§paN°RE",
"raccompagnerait" => "Rak§paN°RE",
"raccompagneras" => "Rak§paN°Ra",
"raccompagnèrent" => "Rak§paNER",
"raccompagnerez" => "Rak§paN°Re",
"raccompagnes" => "Rak§paN",
"raccompagnés" => "Rak§paNe",
"raccompagnez" => "Rak§paNe",
"raccompagnons" => "Rak§paN§",
"raccord" => "RakOR",
"raccordaient" => "RakORdE",
"raccordait" => "RakORdE",
"raccordant" => "RakORd@",
"raccorde" => "RakORd",
"raccordé" => "RakORde",
"raccordée" => "RakORde",
"raccordées" => "RakORde",
"raccordement" => "RakORd°m@",
"raccordements" => "RakORd°m@",
"raccordent" => "RakORd",
"raccorder" => "RakORde",
"raccorderait" => "RakORd°RE",
"raccordés" => "RakORde",
"raccordez" => "RakORde",
"raccords" => "RakOR",
"raccourci" => "RakuRsi",
"raccourcie" => "RakuRsi",
"raccourcies" => "RakuRsi",
"raccourcir" => "RakuRsiR",
"raccourcira" => "RakuRsiRa",
"raccourciras" => "RakuRsiRa",
"raccourcirons" => "RakuRsiR§",
"raccourcis" => "RakuRsi",
"raccourcissaient" => "RakuRsisE",
"raccourcissait" => "RakuRsisE",
"raccourcissant" => "RakuRsis@",
"raccourcisse" => "RakuRsis",
"raccourcissement" => "RakuRsis°m@",
"raccourcissent" => "RakuRsis",
"raccourcit" => "RakuRsi",
"raccroc" => "RakRo",
"raccrocha" => "RakRoSa",
"raccrochage" => "RakRoSaZ",
"raccrochages" => "RakRoSaZ",
"raccrochai" => "RakRoSE",
"raccrochaient" => "RakRoSE",
"raccrochais" => "RakRoSE",
"raccrochait" => "RakRoSE",
"raccrochant" => "RakRoS@",
"raccroche" => "RakROS",
"raccroché" => "RakRoSe",
"raccrochée" => "RakRoSe",
"raccrochées" => "RakRoSe",
"raccrochent" => "RakROS",
"raccrocher" => "RakRoSe",
"raccrochera" => "RakROS°Ra",
"raccrocherai" => "RakROS°RE",
"raccrocheraient" => "RakROS°RE",
"raccrocherais" => "RakROS°RE",
"raccrocherait" => "RakROS°RE",
"raccrocheras" => "RakROS°Ra",
"raccrochèrent" => "RakRoSER",
"raccroches" => "RakROS",
"raccrochés" => "RakRoSe",
"raccrocheur" => "RakRoS9R",
"raccrocheurs" => "RakRoS9R",
"raccrochez" => "RakRoSe",
"raccrochons" => "RakRoS§",
"raccrocs" => "RakRo",
"raccusa" => "Rakyza",
"race" => "Ras",
"racé" => "Rase",
"racée" => "Rase",
"races" => "Ras",
"racés" => "Rase",
"rachat" => "RaSa",
"rachats" => "RaSa",
"racheta" => "RaS°ta",
"rachetai" => "RaS°tE",
"rachetaient" => "RaS°tE",
"rachetait" => "RaS°tE",
"rachetant" => "RaS°t@",
"rachetât" => "RaS°ta",
"rachète" => "RaSEt",
"racheté" => "RaS°te",
"rachetée" => "RaS°te",
"rachetées" => "RaS°te",
"rachètent" => "RaSEt",
"racheter" => "RaS°te",
"rachètera" => "RaSEt°Ra",
"rachèterai" => "RaSEt°RE",
"rachèterais" => "RaSEt°RE",
"rachèterait" => "RaSEt°RE",
"rachetèrent" => "RaS°tER",
"rachèterez" => "RaSEt°Re",
"rachèteront" => "RaSEt°R§",
"rachetés" => "RaS°te",
"rachetez" => "RaS°te",
"rachetiez" => "RaS°tje",
"rachianesthésie" => "RaSjanEstezi",
"rachidien" => "RaSidj5",
"rachidienne" => "RaSidjEn",
"rachis" => "RaSis",
"rachitique" => "RaSitik",
"rachitiques" => "RaSitik",
"rachitisme" => "RaSitizm",
"racho" => "RaSo",
"racial" => "Rasjal",
"raciale" => "Rasjal",
"racialement" => "Rasjal°m@",
"raciales" => "Rasjal",
"raciaux" => "Rasjo",
"racinait" => "RasinE",
"racine" => "Rasin",
"racinée" => "Rasine",
"racinées" => "Rasine",
"raciner" => "Rasine",
"racines" => "Rasin",
"racinés" => "Rasine",
"racingman" => "REjsiGman",
"racinienne" => "RasinjEn",
"raciniennes" => "RasinjEn",
"raciniens" => "Rasinj5",
"racisme" => "Rasizm",
"racismes" => "Rasizm",
"raciste" => "Rasist",
"racistes" => "Rasist",
"rack" => "Rak",
"racket" => "RakEt",
"rackets" => "RakEt",
"rackette" => "RakEt",
"racketté" => "Rakete",
"racketter" => "RakEte",
"racketteur" => "Raket9R",
"rackettez" => "Rakete",
"rackettons" => "Raket§",
"racla" => "Rakla",
"raclages" => "RaklaZ",
"raclaient" => "RaklE",
"raclais" => "RaklE",
"raclait" => "RaklE",
"raclant" => "Rakl@",
"raclante" => "Rakl@t",
"racle" => "Rakl",
"raclé" => "Rakle",
"raclée" => "Rakle",
"raclées" => "Rakle",
"raclement" => "Rakl°m@",
"raclements" => "Rakl°m@",
"raclent" => "Rakl",
"racler" => "Rakle",
"raclerai" => "Rakl°RE",
"racleras" => "Rakl°Ra",
"raclèrent" => "RaklER",
"racles" => "Rakl",
"raclés" => "Rakle",
"raclette" => "RaklEt",
"racleur" => "Rakl9R",
"racleuse" => "Rakl2z",
"racloir" => "RaklwaR",
"raclons" => "Rakl§",
"raclure" => "RaklyR",
"raclures" => "RaklyR",
"racolage" => "RakolaZ",
"racolages" => "RakolaZ",
"racolaient" => "RakolE",
"racolais" => "RakolE",
"racolait" => "RakolE",
"racolant" => "Rakol@",
"racole" => "RakOl",
"racolé" => "Rakole",
"racolent" => "RakOl",
"racoler" => "Rakole",
"racoles" => "RakOl",
"racoleur" => "Rakol9R",
"racoleurs" => "Rakol9R",
"racoleuse" => "Rakol2z",
"racoleuses" => "Rakol2z",
"raconta" => "Rak§ta",
"racontable" => "Rak§tabl",
"racontables" => "Rak§tabl",
"racontai" => "Rak§tE",
"racontaient" => "Rak§tE",
"racontais" => "Rak§tE",
"racontait" => "Rak§tE",
"racontant" => "Rak§t@",
"racontar" => "Rak§taR",
"racontars" => "Rak§taR",
"racontas" => "Rak§ta",
"racontât" => "Rak§ta",
"raconte" => "Rak§t",
"raconté" => "Rak§te",
"racontée" => "Rak§te",
"racontées" => "Rak§te",
"racontent" => "Rak§t",
"raconter" => "Rak§te",
"racontera" => "Rak§t°Ra",
"raconterai" => "Rak§t°RE",
"raconteraient" => "Rak§t°RE",
"raconterais" => "Rak§t°RE",
"raconterait" => "Rak§t°RE",
"raconteras" => "Rak§t°Ra",
"racontèrent" => "Rak§tER",
"raconterez" => "Rak§t°Re",
"raconterons" => "Rak§t°R§",
"raconteront" => "Rak§t°R§",
"racontes" => "Rak§t",
"racontés" => "Rak§te",
"raconteur" => "Rak§t9R",
"raconteuse" => "Rak§t2z",
"racontez" => "Rak§te",
"racontiez" => "Rak§tje",
"racontions" => "Rak§tj§",
"racontons" => "Rak§t§",
"racorni" => "RakORni",
"racornie" => "RakORni",
"racornies" => "RakORni",
"racornir" => "RakORniR",
"racornis" => "RakORni",
"racornissait" => "RakORnisE",
"racornissent" => "RakORnis",
"racornit" => "RakORni",
"rad" => "Rad",
"rada" => "Rada",
"radada" => "Radada",
"radar" => "RadaR",
"radars" => "RadaR",
"radasse" => "Radas",
"radasses" => "Radas",
"rade" => "Rad",
"radeau" => "Rado",
"radeau-radar" => "RadoRadaR",
"radeaux" => "Rado",
"rader" => "Rade",
"rades" => "Rad",
"radeuse" => "Rad2z",
"radeuses" => "Rad2z",
"radial" => "Radjal",
"radiale" => "Radjal",
"radiales" => "Radjal",
"radiant" => "Radj@",
"radiante" => "Radj@t",
"radiateur" => "Radjat9R",
"radiateurs" => "Radjat9R",
"radiation" => "Radjasj§",
"radiations" => "Radjasj§",
"radiative" => "Radjativ",
"radiaux" => "Radjo",
"radical" => "Radikal",
"radical-socialisme" => "Radikalsosjalizm",
"radical-socialiste" => "Radikalsosjalist",
"radicale" => "Radikal",
"radicale-socialiste" => "Radikalsosjalist",
"radicalement" => "Radikal°m@",
"radicales" => "Radikal",
"radicalisation" => "Radikalizasj§",
"radicalisé" => "Radikalize",
"radicaliser" => "Radikalize",
"radicalisme" => "Radikalizm",
"radicaux" => "Radiko",
"radicaux-socialistes" => "Radikososjalist",
"radicelles" => "RadisEl",
"radiculaire" => "RadikylER",
"radicule" => "Radikyl",
"radicules" => "Radikyl",
"radié" => "Radje",
"radiée" => "Radje",
"radier" => "Radje",
"radiers" => "Radje",
"radiés" => "Radje",
"radiesthésiste" => "RadjEstezist",
"radieuse" => "Radj2z",
"radieusement" => "Radj2z°m@",
"radieuses" => "Radj2z",
"radieux" => "Radj2",
"radin" => "Rad5",
"radinait" => "RadinE",
"radine" => "Radin",
"radiné" => "Radine",
"radinée" => "Radine",
"radinent" => "Radin",
"radiner" => "Radine",
"radinerie" => "Radin°Ri",
"radines" => "Radin",
"radinez" => "Radine",
"radins" => "Rad5",
"radio" => "Radjo",
"radio-isotope" => "RadjoizotOp",
"radio-réveil" => "RadjoRevEj",
"radio-taxi" => "Radjotaksi",
"radioactif" => "Radjoaktif",
"radioactifs" => "Radjoaktif",
"radioactive" => "Radjoaktiv",
"radioactives" => "Radjoaktiv",
"radioactivité" => "Radjoaktivite",
"radioamateur" => "Radjoamat9R",
"radioastronome" => "RadjoastRonOm",
"radiobalisage" => "RadjobalizaZ",
"radiobalise" => "Radjobaliz",
"radiocassette" => "RadjokasEt",
"radiodiffusé" => "Radjodifyze",
"radiodiffusée" => "Radjodifyze",
"radiodiffusées" => "Radjodifyze",
"radiodiffusion" => "Radjodifyzj§",
"radioélectrique" => "RadjoelEktRik",
"radioélément" => "Radjoelem@",
"radiogoniomètre" => "RadjogOnjomEtR",
"radiogoniométrique" => "RadjogOnjometRik",
"radiogramme" => "RadjogRam",
"radiogrammes" => "RadjogRam",
"radiographiant" => "RadjogRafj@",
"radiographie" => "RadjogRafi",
"radiographié" => "RadjogRafje",
"radiographiée" => "RadjogRafje",
"radiographient" => "RadjogRafi",
"radiographier" => "RadjogRafje",
"radiographies" => "RadjogRafi",
"radiographiés" => "RadjogRafje",
"radiographique" => "RadjogRafik",
"radioguidage" => "RadjogidaZ",
"radioguidera" => "Radjogid°Ra",
"radiologie" => "RadjoloZi",
"radiologique" => "RadjOlOZik",
"radiologiques" => "RadjoloZik",
"radiologiste" => "RadjOlOZist",
"radiologue" => "RadjolOg",
"radiologues" => "RadjolOg",
"radiomètre" => "RadjomEtR",
"radiomètres" => "RadjomEtR",
"radiométrie" => "RadjometRi",
"radiophare" => "RadjofaR",
"radiophonie" => "Radjofoni",
"radiophonique" => "Radjofonik",
"radiophoniques" => "Radjofonik",
"radioréveil" => "RadjoRevEj",
"radios" => "Radjo",
"radioscopie" => "Radjoskopi",
"radioscopique" => "RadjOskOpik",
"radioscopiques" => "Radjoskopik",
"radiosonde" => "Radjos§d",
"radiotélégraphie" => "RadjotelegRafi",
"radiotélégraphiste" => "RadjotelegRafist",
"radiotéléphone" => "RadjotelefOn",
"radiotéléphones" => "RadjotelefOn",
"radiotéléphonie" => "RadjotelefOni",
"radiotéléphonique" => "RadjotelefOnik",
"radiotélescope" => "RadjotelEskOp",
"radiotélescopes" => "RadjotelEskOp",
"radiothérapie" => "RadjoteRapi",
"radis" => "Radi",
"radium" => "RadjOm",
"radius" => "Radjys",
"radja" => "RadZa",
"radjah" => "RadZa",
"radjahs" => "RadZa",
"radôme" => "Radom",
"radon" => "Rad§",
"radotage" => "RadotaZ",
"radotages" => "RadotaZ",
"radotait" => "RadotE",
"radotant" => "Radot@",
"radote" => "RadOt",
"radoté" => "Radote",
"radotent" => "RadOt",
"radoter" => "Radote",
"radotes" => "RadOt",
"radoteur" => "Radot9R",
"radoteurs" => "Radot9R",
"radoteuses" => "Radot2z",
"radotez" => "Radote",
"radoub" => "Radu",
"radoubait" => "RadubE",
"radouber" => "Radube",
"radoubeur" => "Radub9R",
"radouci" => "Radusi",
"radoucie" => "Radusi",
"radoucir" => "RadusiR",
"radouciraient" => "RadusiRE",
"radoucis" => "Radusi",
"radoucissais" => "RadusisE",
"radoucissait" => "RadusisE",
"radoucissement" => "Radusis°m@",
"radoucit" => "Radusi",
"rads" => "Rad",
"rafa" => "Rafa",
"rafale" => "Rafal",
"rafales" => "Rafal",
"rafe" => "Raf",
"raff" => "Raf",
"raffermi" => "RafERmi",
"raffermie" => "RafERmi",
"raffermir" => "RafERmiR",
"raffermira" => "RafERmiRa",
"raffermis" => "RafERmi",
"raffermissait" => "RafERmisE",
"raffermissent" => "RafERmis",
"raffermit" => "RafERmi",
"raffinage" => "RafinaZ",
"raffinait" => "RafinE",
"raffinant" => "Rafin@",
"raffine" => "Rafin",
"raffiné" => "Rafine",
"raffinée" => "Rafine",
"raffinées" => "Rafine",
"raffinement" => "Rafin°m@",
"raffinements" => "Rafin°m@",
"raffiner" => "Rafine",
"raffinerie" => "Rafin°Ri",
"raffineries" => "Rafin°Ri",
"raffinés" => "Rafine",
"raffineur" => "Rafin9R",
"raffolaient" => "RafolE",
"raffolais" => "RafolE",
"raffolait" => "RafolE",
"raffolant" => "RafOl@",
"raffole" => "RafOl",
"raffolé" => "RafOle",
"raffolent" => "RafOl",
"raffoler" => "Rafole",
"raffoleront" => "RafOl°R§",
"raffoles" => "RafOl",
"raffolez" => "Rafole",
"raffoliez" => "Rafolje",
"raffut" => "Rafy",
"raffuts" => "Rafy",
"rafiau" => "Rafjo",
"rafiot" => "Rafjo",
"rafiots" => "Rafjo",
"rafistola" => "Rafistola",
"rafistolage" => "RafistolaZ",
"rafistolages" => "RafistolaZ",
"rafistolaient" => "RafistolE",
"rafistolais" => "RafistolE",
"rafistolait" => "RafistolE",
"rafistole" => "RafistOl",
"rafistolé" => "Rafistole",
"rafistolée" => "Rafistole",
"rafistolées" => "Rafistole",
"rafistoler" => "Rafistole",
"rafistolés" => "Rafistole",
"rafistolez" => "Rafistole",
"rafla" => "Rafla",
"raflais" => "RaflE",
"raflait" => "RaflE",
"raflant" => "Rafl@",
"rafle" => "Rafl",
"raflé" => "Rafle",
"raflée" => "Rafle",
"raflées" => "Rafle",
"raflent" => "Rafl",
"rafler" => "Rafle",
"raflera" => "Rafl°Ra",
"raflerai" => "Rafl°RE",
"raflerait" => "Rafl°RE",
"rafles" => "Rafl",
"raflés" => "Rafle",
"raflez" => "Rafle",
"rafraîchi" => "RafReSi",
"rafraîchie" => "RafReSi",
"rafraîchies" => "RafReSi",
"rafraîchir" => "RafReSiR",
"rafraîchira" => "RafReSiRa",
"rafraîchirais" => "RafRESiRE",
"rafraîchirait" => "RafReSiRE",
"rafraîchirent" => "RafReSiR",
"rafraîchiront" => "RafRESiR§",
"rafraîchis" => "RafReSi",
"rafraîchissaient" => "RafReSisE",
"rafraîchissais" => "RafReSisE",
"rafraîchissait" => "RafReSisE",
"rafraîchissant" => "RafReSis@",
"rafraîchissante" => "RafReSis@t",
"rafraîchissantes" => "RafReSis@t",
"rafraîchissants" => "RafReSis@",
"rafraîchisse" => "RafReSis",
"rafraîchissement" => "RafReSis°m@",
"rafraîchissements" => "RafReSis°m@",
"rafraîchissent" => "RafReSis",
"rafraîchisseur" => "RafReSis9R",
"rafraîchissez" => "RafReSise",
"rafraîchissoir" => "RafReSiswaR",
"rafraîchissoirs" => "RafReSiswaR",
"rafraîchissons" => "RafRESis§",
"rafraîchit" => "RafReSi",
"raft" => "Raft",
"rafting" => "RaftiG",
"rag" => "Rag",
"raga" => "Raga",
"ragaillardi" => "RagajaRdi",
"ragaillardie" => "RagajaRdi",
"ragaillardir" => "RagajaRdiR",
"ragaillardira" => "RagajaRdiRa",
"ragaillardirait" => "RagajaRdiRE",
"ragaillardis" => "RagajaRdi",
"ragaillardissaient" => "RagajaRdisE",
"ragaillardisse" => "RagajaRdis",
"ragaillardit" => "RagajaRdi",
"rage" => "RaZ",
"ragea" => "RaZa",
"rageaient" => "RaZE",
"rageais" => "RaZE",
"rageait" => "RaZE",
"rageant" => "RaZ@",
"ragent" => "RaZ",
"rager" => "RaZe",
"rages" => "RaZ",
"rageur" => "RaZ9R",
"rageurs" => "RaZ9R",
"rageuse" => "RaZ2z",
"rageusement" => "RaZ2z°m@",
"rageuses" => "RaZ2z",
"ragez" => "RaZe",
"raglan" => "Ragl@",
"raglans" => "Ragl@",
"ragnagnas" => "RaNaNa",
"ragondins" => "Rag§d5",
"ragot" => "Rago",
"ragota" => "Ragota",
"ragotait" => "RagotE",
"ragote" => "RagOt",
"ragoter" => "Ragote",
"ragots" => "Rago",
"ragougnasse" => "RaguNas",
"ragougnasses" => "RaguNas",
"ragoût" => "Ragu",
"ragoûtant" => "Ragut@",
"ragoûtante" => "Ragut@t",
"ragoûtantes" => "Ragut@t",
"ragoûtants" => "Ragut@",
"ragoûts" => "Ragu",
"ragrafait" => "RagRafE",
"ragrafant" => "RagRaf@",
"ragrafe" => "RagRaf",
"ragtime" => "Ragtajm",
"rahat-lokoum" => "Raatlokum",
"rahat-lokoums" => "Raatlokum",
"rahat-loukoums" => "Raalukum",
"rai" => "RE",
"raïa" => "Raja",
"raid" => "REd",
"raide" => "REd",
"raidement" => "REd°m@",
"raider" => "Rajd9R",
"raiders" => "Rajd9R",
"raides" => "REd",
"raideur" => "REd9R",
"raidi" => "REdi",
"raidie" => "REdi",
"raidies" => "REdi",
"raidillon" => "REdij§",
"raidillons" => "REdij§",
"raidir" => "RediR",
"raidirent" => "REdiR",
"raidis" => "REdi",
"raidissaient" => "REdisE",
"raidissais" => "REdisE",
"raidissait" => "REdisE",
"raidissant" => "REdis@",
"raidisse" => "REdis",
"raidissement" => "REdis°m@",
"raidissements" => "REdis°m@",
"raidissent" => "REdis",
"raidissez" => "REdise",
"raidit" => "REdi",
"raids" => "REd",
"raie" => "RE",
"raient" => "RE",
"raies" => "RE",
"raifort" => "REfOR",
"rail" => "Raj",
"railla" => "Raja",
"raillaient" => "RajE",
"raillait" => "RajE",
"raillant" => "Raj@",
"raille" => "Raj",
"raillé" => "Raje",
"raillée" => "Raje",
"railler" => "Raje",
"raillera" => "Raj°Ra",
"raillerai" => "Raj°RE",
"raillèrent" => "RajER",
"raillerie" => "Raj°Ri",
"railleries" => "Raj°Ri",
"raillés" => "Raje",
"railleur" => "Raj9R",
"railleurs" => "Raj9R",
"railleuse" => "Raj2z",
"railleuses" => "Raj2z",
"raillez" => "Raje",
"rails" => "Raj",
"railway" => "RElwE",
"rain" => "R5",
"raine" => "REn",
"rainer" => "Rene",
"raines" => "REn",
"rainette" => "REnEt",
"rainettes" => "REnEt",
"raineuse" => "REn2z",
"rainure" => "RenyR",
"rainuré" => "REnyRe",
"rainurer" => "RenyRe",
"rainures" => "RenyR",
"rainurés" => "RenyRe",
"raiponce" => "REp§s",
"raire" => "RER",
"rais" => "RE",
"raïs" => "Rai",
"raisin" => "REz5",
"raisiné" => "REzine",
"raisinets" => "REzinE",
"raisins" => "REz5",
"raison" => "REz§",
"raisonna" => "REzona",
"raisonnable" => "REzonabl",
"raisonnablement" => "REzonabl°m@",
"raisonnables" => "REzonabl",
"raisonnai" => "REzonE",
"raisonnaient" => "REzonE",
"raisonnais" => "REzonE",
"raisonnait" => "REzonE",
"raisonnant" => "REzon@",
"raisonnante" => "REzon@t",
"raisonnassent" => "REzonas",
"raisonne" => "REzOn",
"raisonné" => "REzone",
"raisonnée" => "REzone",
"raisonnement" => "REzOn°m@",
"raisonnements" => "REzOn°m@",
"raisonnent" => "REzOn",
"raisonner" => "REzone",
"raisonnes" => "REzOn",
"raisonneur" => "REzon9R",
"raisonneurs" => "REzon9R",
"raisonneuse" => "REzon2z",
"raisonnez" => "REzone",
"raisonniez" => "REzonje",
"raisonnons" => "REzon§",
"raisons" => "REz§",
"rait" => "RE",
"raites" => "REt",
"raja" => "RaZa",
"rajah" => "RaZa",
"rajahs" => "RaZa",
"rajeuni" => "RaZ9ni",
"rajeunie" => "RaZ9ni",
"rajeunies" => "RaZ9ni",
"rajeunir" => "RaZ9niR",
"rajeunira" => "RaZ9niRa",
"rajeunirai" => "RaZ9niRE",
"rajeunirait" => "RaZ9niRE",
"rajeunirez" => "RaZ9niRe",
"rajeunis" => "RaZ9ni",
"rajeunissaient" => "RaZ9nisE",
"rajeunissais" => "RaZ9nisE",
"rajeunissait" => "RaZ9nisE",
"rajeunissant" => "RaZ9nis@",
"rajeunissante" => "RaZ9nis@t",
"rajeunisse" => "RaZ9nis",
"rajeunissement" => "RaZ9nis°m@",
"rajeunissent" => "RaZ9nis",
"rajeunisseurs" => "RaZ9nis9R",
"rajeunissez" => "RaZ9nise",
"rajeunissons" => "RaZ9nis§",
"rajeunit" => "RaZ9ni",
"rajout" => "RaZu",
"rajouta" => "RaZuta",
"rajoutaient" => "RaZutE",
"rajoutais" => "RaZutE",
"rajoutait" => "RaZutE",
"rajoutant" => "RaZut@",
"rajoute" => "RaZut",
"rajouté" => "RaZute",
"rajoutée" => "RaZute",
"rajoutées" => "RaZute",
"rajoutent" => "RaZut",
"rajouter" => "RaZute",
"rajoutera" => "RaZut°Ra",
"rajouterais" => "RaZut°RE",
"rajouterait" => "RaZut°RE",
"rajouteras" => "RaZut°Ra",
"rajouterez" => "RaZut°Re",
"rajoutes" => "RaZut",
"rajoutés" => "RaZute",
"rajoutez" => "RaZute",
"rajoutons" => "RaZut§",
"rajouts" => "RaZu",
"rajusta" => "RaZysta",
"rajustaient" => "RaZystE",
"rajustais" => "RaZystE",
"rajustait" => "RaZystE",
"rajustant" => "RaZyst@",
"rajuste" => "RaZyst",
"rajusté" => "RaZyste",
"rajustée" => "RaZyste",
"rajustées" => "RaZyste",
"rajustement" => "RaZyst°m@",
"rajustent" => "RaZyst",
"rajuster" => "RaZyste",
"rajusteront" => "RaZyst°R§",
"raki" => "Raki",
"râla" => "Rala",
"râlai" => "RalE",
"râlaient" => "RalE",
"râlais" => "RalE",
"râlait" => "RalE",
"râlant" => "Ral@",
"râlante" => "Ral@t",
"ralbol" => "RalbOl",
"râle" => "Ral",
"râlé" => "Rale",
"râlement" => "Ral°m@",
"râlent" => "Ral",
"ralenti" => "Ral@ti",
"ralentie" => "Ral@ti",
"ralenties" => "Ral@ti",
"ralentir" => "Ral@tiR",
"ralentira" => "Ral@tiRa",
"ralentirai" => "Ral@tiRE",
"ralentiraient" => "Ral@tiRE",
"ralentirais" => "Ral@tiRE",
"ralentirait" => "Ral@tiRE",
"ralentirent" => "Ral@tiR",
"ralentirez" => "Ral@tiRe",
"ralentiriez" => "Ral@tiRje",
"ralentiront" => "Ral@tiR§",
"ralentis" => "Ral@ti",
"ralentissaient" => "Ral@tisE",
"ralentissais" => "Ral@tisE",
"ralentissait" => "Ral@tisE",
"ralentissant" => "Ral@tis@",
"ralentisse" => "Ral@tis",
"ralentissement" => "Ral@tis°m@",
"ralentissements" => "Ral@tis°m@",
"ralentissent" => "Ral@tis",
"ralentisseur" => "Ral@tis9R",
"ralentisseurs" => "Ral@tis9R",
"ralentissez" => "Ral@tise",
"ralentissiez" => "Ral@tisje",
"ralentissions" => "Ral@tisj§",
"ralentissons" => "Ral@tis§",
"ralentit" => "Ral@ti",
"ralentît" => "Ral@ti",
"râler" => "Rale",
"râlera" => "Ral°Ra",
"râlerai" => "Ral°RE",
"râlerait" => "Ral°RE",
"râles" => "Ral",
"râleur" => "Ral9R",
"râleurs" => "Ral9R",
"râleuse" => "Ral2z",
"râleuses" => "Ral2z",
"râleux" => "Ral2z",
"râlez" => "Rale",
"ralingue" => "Ral5g",
"ralingues" => "Ral5g",
"rallège" => "RalEZ",
"rallégé" => "RalEZe",
"ralléger" => "RalEZe",
"raller" => "Rale",
"rallia" => "Ralja",
"ralliai" => "RaljE",
"ralliaient" => "RaljE",
"ralliais" => "RaljE",
"ralliait" => "RaljE",
"ralliant" => "Ralj@",
"ralliassent" => "Raljas",
"rallie" => "Rali",
"rallié" => "Ralje",
"ralliée" => "Ralje",
"ralliées" => "Ralje",
"ralliement" => "Ralim@",
"ralliements" => "Ralim@",
"rallient" => "Rali",
"rallier" => "Ralje",
"ralliera" => "RaliRa",
"rallierai" => "RaliRE",
"rallieraient" => "RaliRE",
"rallierait" => "RaliRE",
"rallièrent" => "RaljER",
"rallieriez" => "RaliRje",
"rallierons" => "RaliR§",
"rallieront" => "RaliR§",
"rallies" => "Rali",
"ralliés" => "Ralje",
"ralliez" => "Ralie",
"rallions" => "Ralij§",
"rallonge" => "Ral§Z",
"rallongé" => "Ral§Ze",
"rallongea" => "Ral§Za",
"rallongeaient" => "Ral§ZE",
"rallongeait" => "Ral§ZE",
"rallongée" => "Ral§Ze",
"rallongement" => "Ral§Z°m@",
"rallongent" => "Ral§Z",
"rallonger" => "Ral§Ze",
"rallongerait" => "Ral§Z°RE",
"rallonges" => "Ral§Z",
"rallongez" => "Ral§Ze",
"ralluma" => "Ralyma",
"rallumage" => "RalymaZ",
"rallumai" => "RalymE",
"rallumaient" => "RalymE",
"rallumais" => "RalymE",
"rallumait" => "RalymE",
"rallumant" => "Ralym@",
"rallume" => "Ralym",
"rallumé" => "Ralyme",
"rallumée" => "Ralyme",
"rallumées" => "Ralyme",
"rallument" => "Ralym",
"rallumer" => "Ralyme",
"rallumerai" => "Ralym°RE",
"rallumèrent" => "RalymER",
"rallumeront" => "Ralym°R§",
"rallumes" => "Ralym",
"rallumés" => "Ralyme",
"rallumez" => "Ralyme",
"rallumons" => "Ralym§",
"rallye" => "Rali",
"rallyes" => "Rali",
"ram" => "Ram",
"rama" => "Rama",
"ramadan" => "Ramad@",
"ramage" => "RamaZ",
"ramageait" => "RamaZE",
"ramager" => "RamaZe",
"ramages" => "RamaZ",
"ramai" => "RamE",
"ramaient" => "RamE",
"ramais" => "RamE",
"ramait" => "RamE",
"ramant" => "Ram@",
"ramarraient" => "RamaRE",
"ramarrer" => "RamaRe",
"ramas" => "Rama",
"ramassa" => "Ramasa",
"ramassage" => "RamasaZ",
"ramassages" => "RamasaZ",
"ramassai" => "RamasE",
"ramassaient" => "RamasE",
"ramassais" => "RamasE",
"ramassait" => "RamasE",
"ramassant" => "Ramas@",
"ramassât" => "Ramasa",
"ramasse" => "Ramas",
"ramassé" => "Ramase",
"ramasse-miettes" => "RamasmjEt",
"ramasse-poussière" => "RamaspusjER",
"ramassée" => "Ramase",
"ramassées" => "Ramase",
"ramassent" => "Ramas",
"ramasser" => "Ramase",
"ramassera" => "Ramas°Ra",
"ramasserai" => "Ramas°RE",
"ramasseraient" => "Ramas°RE",
"ramasserais" => "Ramas°RE",
"ramasserait" => "Ramas°RE",
"ramasseras" => "Ramas°Ra",
"ramassèrent" => "RamasER",
"ramasseront" => "Ramas°R§",
"ramasses" => "Ramas",
"ramassés" => "Ramase",
"ramasseur" => "Ramas9R",
"ramasseurs" => "Ramas9R",
"ramasseuse" => "Ramas2z",
"ramassez" => "Ramase",
"ramassiez" => "Ramasje",
"ramassions" => "Ramasj§",
"ramassis" => "Ramasi",
"ramassons" => "Ramas§",
"rambarde" => "R@baRd",
"rambardes" => "R@baRd",
"rambin" => "R@b5",
"rambinait" => "R@binE",
"rambine" => "R@bin",
"rambiné" => "R@bine",
"rambinent" => "R@bin",
"rambiner" => "R@bine",
"rambineur" => "R@bin9R",
"rambla" => "Rambla",
"rambot" => "R@bo",
"rambour" => "R@buR",
"ramdam" => "Ramdam",
"ramdams" => "Ramdam",
"rame" => "Ram",
"ramé" => "Rame",
"rameau" => "Ramo",
"rameaux" => "Ramo",
"ramée" => "Rame",
"ramées" => "Rame",
"ramena" => "Ramna",
"ramenai" => "Ram°nE",
"ramenaient" => "Ram°nE",
"ramenais" => "Ram°nE",
"ramenait" => "Ram°nE",
"ramenâmes" => "Ram°nam",
"ramenant" => "Ram°n@",
"ramenard" => "RamnaR",
"ramenards" => "RamnaR",
"ramenât" => "Ram°na",
"ramendé" => "Ram@de",
"ramène" => "RamEn",
"ramené" => "Ram°ne",
"ramenée" => "Ram°ne",
"ramenées" => "Ram°ne",
"ramènent" => "RamEn",
"ramener" => "Ram°ne",
"ramènera" => "RamEn°Ra",
"ramènerai" => "RamEn°RE",
"ramèneraient" => "RamEn°RE",
"ramènerais" => "RamEn°RE",
"ramènerait" => "RamEn°RE",
"ramèneras" => "RamEn°Ra",
"ramenèrent" => "Ram°nER",
"ramènerez" => "RamEn°Re",
"ramèneriez" => "RamEn°Rje",
"ramènerions" => "RamEn°Rj§",
"ramènerons" => "RamEn°R§",
"ramèneront" => "RamEn°R§",
"ramènes" => "RamEn",
"ramenés" => "Ram°ne",
"ramenez" => "Ram°ne",
"rameniez" => "Ram°nje",
"ramenions" => "Ram°nj§",
"ramenons" => "Ram°n§",
"rament" => "Ram",
"ramer" => "Rame",
"ramera" => "Ram°Ra",
"rameras" => "Ram°Ra",
"ramèrent" => "RamER",
"ramerons" => "Ram°R§",
"rameront" => "Ram°R§",
"rames" => "Ram",
"ramés" => "Rame",
"ramette" => "RamEt",
"rameur" => "Ram9R",
"rameurs" => "Ram9R",
"rameutais" => "Ram2tE",
"rameutait" => "Ram2tE",
"rameutant" => "Ram2t@",
"rameute" => "Ram2t",
"rameuté" => "Ram2te",
"rameutées" => "Ram2te",
"rameutent" => "Ram2t",
"rameuter" => "Ram2te",
"rameutés" => "Ram2te",
"rameutez" => "Ram2te",
"rameutons" => "Ram2t§",
"ramez" => "Rame",
"rami" => "Rami",
"ramier" => "Ramje",
"ramiers" => "Ramje",
"ramies" => "Rami",
"ramifia" => "Ramifja",
"ramifiaient" => "RamifjE",
"ramifiait" => "RamifjE",
"ramifiant" => "Ramifj@",
"ramification" => "Ramifikasj§",
"ramifications" => "Ramifikasj§",
"ramifie" => "Ramifi",
"ramifié" => "Ramifje",
"ramifiée" => "Ramifje",
"ramifiées" => "Ramifje",
"ramifient" => "Ramifi",
"ramifier" => "Ramifje",
"ramifiés" => "Ramifje",
"ramille" => "Ramij",
"ramilles" => "Ramij",
"raminagrobis" => "RaminagRobis",
"ramions" => "Ramj§",
"ramis" => "Rami",
"ramolli" => "Ramoli",
"ramollie" => "Ramoli",
"ramollies" => "Ramoli",
"ramollir" => "RamoliR",
"ramollirent" => "RamoliR",
"ramollis" => "Ramoli",
"ramollissait" => "RamolisE",
"ramollisse" => "Ramolis",
"ramollissement" => "Ramolis°m@",
"ramollissent" => "Ramolis",
"ramollit" => "Ramoli",
"ramollo" => "Ramolo",
"ramollos" => "Ramolo",
"ramon" => "Ram§",
"ramonage" => "RamonaZ",
"ramonages" => "RamonaZ",
"ramonait" => "RamonE",
"ramonant" => "Ramon@",
"ramone" => "RamOn",
"ramoné" => "Ramone",
"ramonée" => "Ramone",
"ramonées" => "Ramone",
"ramonent" => "RamOn",
"ramoner" => "Ramone",
"ramones" => "RamOn",
"ramoneur" => "Ramon9R",
"ramoneurs" => "Ramon9R",
"ramons" => "Ram§",
"rampa" => "R@pa",
"rampai" => "R@pE",
"rampaient" => "R@pE",
"rampais" => "R@pE",
"rampait" => "R@pE",
"rampant" => "R@p@",
"rampante" => "R@p@t",
"rampantes" => "R@p@t",
"rampants" => "R@p@",
"rampe" => "R@p",
"rampé" => "R@pe",
"rampée" => "R@pe",
"rampement" => "R@p°m@",
"rampements" => "R@p°m@",
"rampent" => "R@p",
"ramper" => "R@pe",
"rampera" => "R@p°Ra",
"ramperai" => "R@p°RE",
"ramperaient" => "R@p°RE",
"ramperais" => "R@p°RE",
"ramperas" => "R@p°Ra",
"rampèrent" => "R@pER",
"ramperez" => "R@p°Re",
"rampes" => "R@p",
"rampez" => "R@pe",
"rampiez" => "R@pje",
"rampions" => "R@pj§",
"ramponneau" => "R@pono",
"rampons" => "R@p§",
"rams" => "Ram",
"ramser" => "Ramse",
"ramure" => "RamyR",
"ramures" => "RamyR",
"ran" => "R@",
"ranatres" => "RanatR",
"rancard" => "R@kaR",
"rancardait" => "R@kaRdE",
"rancarde" => "R@kaRd",
"rancardé" => "R@kaRde",
"rancardée" => "R@kaRde",
"rancarder" => "R@kaRde",
"rancardés" => "R@kaRde",
"rancardez" => "R@kaRde",
"rancards" => "R@kaR",
"rancart" => "R@kaR",
"rancarts" => "R@kaR",
"rance" => "R@s",
"rances" => "R@s",
"ranch" => "R@nS",
"ranche" => "R@S",
"rancher" => "R@ntS9R",
"ranches" => "R@nS",
"rancho" => "R@tSo",
"ranchs" => "R@tS",
"ranci" => "R@si",
"rancie" => "R@si",
"rancies" => "R@si",
"rancio" => "R@sjo",
"rancir" => "R@siR",
"rancis" => "R@si",
"rancissait" => "R@sisE",
"rancissure" => "R@sisyR",
"rancit" => "R@si",
"rancoeur" => "R@k9R",
"rancoeurs" => "R@k9R",
"rançon" => "R@s§",
"rançonnage" => "R@sonaZ",
"rançonnaient" => "R@sonE",
"rançonnait" => "R@sonE",
"rançonne" => "R@sOn",
"rançonné" => "R@sone",
"rançonnée" => "R@sone",
"rançonnées" => "R@sone",
"rançonnement" => "R@sOn°m@",
"rançonner" => "R@sone",
"rançonnés" => "R@sone",
"rançonneurs" => "R@son9R",
"rançons" => "R@s§",
"rancune" => "R@kyn",
"rancunes" => "R@kyn",
"rancuneuses" => "R@kyn2z",
"rancunier" => "R@kynje",
"rancunière" => "R@kynjER",
"rancunières" => "R@kynjER",
"rancuniers" => "R@kynje",
"randonnait" => "R@donE",
"randonne" => "R@dOn",
"randonnée" => "R@done",
"randonnées" => "R@done",
"randonner" => "R@dOne",
"randonneur" => "R@don9R",
"randonneurs" => "R@don9R",
"randonneuse" => "R@don2z",
"randonnez" => "R@done",
"rang" => "R@",
"range" => "R@Z",
"rangé" => "R@Ze",
"rangea" => "R@Za",
"rangeai" => "R@ZE",
"rangeaient" => "R@ZE",
"rangeais" => "R@ZE",
"rangeait" => "R@ZE",
"rangeâmes" => "R@Zam",
"rangeant" => "R@Z@",
"rangeât" => "R@Za",
"rangée" => "R@Ze",
"rangées" => "R@Ze",
"rangement" => "R@Z°m@",
"rangements" => "R@Z°m@",
"rangent" => "R@Z",
"rangeons" => "R@Z§",
"ranger" => "R@Ze",
"rangera" => "R@Z°Ra",
"rangerai" => "R@Z°RE",
"rangerais" => "R@Z°RE",
"rangerait" => "R@Z°RE",
"rangeras" => "R@Z°Ra",
"rangèrent" => "R@ZER",
"rangerez" => "R@Z°Re",
"rangerons" => "R@Z°R§",
"rangeront" => "R@Z°R§",
"rangers" => "R@Z9R",
"ranges" => "R@Z",
"rangés" => "R@Ze",
"rangez" => "R@Ze",
"rangions" => "R@Zj§",
"rangs" => "R@",
"rani" => "Rani",
"ranima" => "Ranima",
"ranimaient" => "RanimE",
"ranimait" => "RanimE",
"ranimant" => "Ranim@",
"ranimât" => "Ranima",
"ranimation" => "Ranimasj§",
"ranime" => "Ranim",
"ranimé" => "Ranime",
"ranimée" => "Ranime",
"ranimées" => "Ranime",
"raniment" => "Ranim",
"ranimer" => "Ranime",
"ranimera" => "Ranim°Ra",
"ranimèrent" => "RanimER",
"ranimés" => "Ranime",
"ranimez" => "Ranime",
"ranimions" => "Ranimj§",
"rantanplan" => "R@t@pl@",
"ranz" => "R@z",
"raout" => "Raut",
"raouts" => "Raut",
"rap" => "Rap",
"râpa" => "Rapa",
"rapace" => "Rapas",
"rapaces" => "Rapas",
"rapacité" => "Rapasite",
"râpaient" => "RapE",
"râpait" => "RapE",
"râpant" => "Rap@",
"rapatria" => "RapatRija",
"rapatriait" => "RapatRijE",
"rapatriant" => "RapatRij@",
"rapatrie" => "RapatRi",
"rapatrié" => "RapatRije",
"rapatriée" => "RapatRije",
"rapatriées" => "RapatRije",
"rapatriement" => "RapatRim@",
"rapatriements" => "RapatRim@",
"rapatrient" => "RapatRi",
"rapatrier" => "RapatRije",
"rapatriera" => "RapatRiRa",
"rapatriés" => "RapatRije",
"rapatriez" => "RapatRie",
"râpe" => "Rap",
"râpé" => "Rape",
"râpée" => "Rape",
"râpées" => "Rape",
"râpent" => "Rap",
"râper" => "Rape",
"râperait" => "Rap°RE",
"râperas" => "Rap°Ra",
"râpes" => "Rap",
"râpés" => "Rape",
"rapetassage" => "Rap°tasaZ",
"rapetassages" => "Rap°tasaZ",
"rapetassé" => "Rap°tase",
"rapetassées" => "Rap°tase",
"rapetasser" => "Rap°tase",
"rapetassés" => "Rap°tase",
"rapetasseur" => "Rap°tas9R",
"rapetassions" => "Rap°tasj§",
"rapetissaient" => "Rap°tisE",
"rapetissais" => "Rap°tisE",
"rapetissait" => "Rap°tisE",
"rapetissant" => "Rap°tis@",
"rapetisse" => "Rap°tis",
"rapetissé" => "Rap°tise",
"rapetissée" => "Rap°tise",
"rapetissées" => "Rap°tise",
"rapetissement" => "Rap°tis°m@",
"rapetissent" => "Rap°tis",
"rapetisser" => "Rap°tise",
"rapetissera" => "Rap°tis°Ra",
"rapetissèrent" => "Rap°tisER",
"rapetissés" => "Rap°tise",
"rapetissez" => "Rap°tise",
"rapetissons" => "Rap°tis§",
"râpeuse" => "Rap2z",
"râpeuses" => "Rap2z",
"râpeux" => "Rap2",
"raphaélesque" => "RafaelEsk",
"raphé" => "Rafe",
"raphia" => "Rafja",
"rapiat" => "Rapja",
"rapiater" => "Rapjate",
"rapiaterie" => "Rapjat°Ri",
"rapiats" => "Rapja",
"rapide" => "Rapid",
"rapidement" => "Rapid°m@",
"rapides" => "Rapid",
"rapidité" => "Rapidite",
"rapidités" => "Rapidite",
"rapidos" => "Rapido",
"rapiéçage" => "RapjesaZ",
"rapiéçages" => "RapjesaZ",
"rapiécé" => "Rapjese",
"rapiécée" => "Rapjese",
"rapiécées" => "Rapjese",
"rapiécer" => "Rapjese",
"rapiécerait" => "Rapjes°RE",
"rapiécés" => "Rapjese",
"rapière" => "RapjER",
"rapin" => "Rap5",
"rapine" => "Rapin",
"rapinent" => "Rapin",
"rapines" => "Rapin",
"rapinés" => "Rapine",
"rapins" => "Rap5",
"raplapla" => "Raplapla",
"rapointir" => "Rapw5tiR",
"rappel" => "RapEl",
"rappela" => "Rap°la",
"rappelai" => "Rap°lE",
"rappelaient" => "Rap°lE",
"rappelais" => "Rap°lE",
"rappelait" => "Rap°lE",
"rappelâmes" => "Rap°lam",
"rappelant" => "Rap°l@",
"rappelât" => "Rap°la",
"rappelé" => "Rap°le",
"rappelée" => "Rap°le",
"rappeler" => "Rap°le",
"rappelèrent" => "Rap°lER",
"rappelés" => "Rap°le",
"rappelez" => "Rap°le",
"rappeliez" => "Rap°lje",
"rappelions" => "Rap°lj§",
"rappelle" => "RapEl",
"rappellent" => "RapEl",
"rappellera" => "RapEl°Ra",
"rappellerai" => "RapEl°RE",
"rappelleraient" => "RapEl°RE",
"rappellerais" => "RapEl°RE",
"rappellerait" => "RapEl°RE",
"rappelleras" => "RapEl°Ra",
"rappellerez" => "RapEl°Re",
"rappelleriez" => "RapEl°Rje",
"rappellerons" => "RapEl°R§",
"rappelleront" => "RapEl°R§",
"rappelles" => "RapEl",
"rappelons" => "Rap°l§",
"rappels" => "RapEl",
"rapper" => "Rape",
"rappeur" => "Rap9R",
"rappeurs" => "Rap9R",
"rappeuse" => "Rap2z",
"rappliqua" => "Raplika",
"rappliquaient" => "RaplikE",
"rappliquais" => "RaplikE",
"rappliquait" => "RaplikE",
"rapplique" => "Raplik",
"rappliqué" => "Raplike",
"rappliquent" => "Raplik",
"rappliquer" => "Raplike",
"rappliquera" => "Raplik°Ra",
"rappliquerais" => "Raplik°RE",
"rappliquerait" => "Raplik°RE",
"rappliquèrent" => "RaplikER",
"rappliqueriez" => "Raplik°Rje",
"rappliqueront" => "Raplik°R§",
"rappliques" => "Raplik",
"rappliquez" => "Raplike",
"rapport" => "RapOR",
"rapporta" => "RapORta",
"rapportage" => "RapORtaZ",
"rapportai" => "RapORtE",
"rapportaient" => "RapORtE",
"rapportais" => "RapORtE",
"rapportait" => "RapORtE",
"rapportant" => "RapORt@",
"rapportât" => "RapORta",
"rapporte" => "RapORt",
"rapporté" => "RapORte",
"rapportée" => "RapORte",
"rapportées" => "RapORte",
"rapportent" => "RapORt",
"rapporter" => "RapORte",
"rapportera" => "RapORt°Ra",
"rapporterai" => "RapORt°RE",
"rapporteraient" => "RapORt°RE",
"rapporterais" => "RapORt°RE",
"rapporterait" => "RapORt°RE",
"rapporteras" => "RapORt°Ra",
"rapportèrent" => "RapORtER",
"rapporterez" => "RapORt°Re",
"rapporteriez" => "RapORt°Rje",
"rapporterons" => "RapORt°R§",
"rapporteront" => "RapORt°R§",
"rapportes" => "RapORt",
"rapportés" => "RapORte",
"rapporteur" => "RapORt9R",
"rapporteurs" => "RapORt9R",
"rapporteuse" => "RapORt2z",
"rapporteuses" => "RapORt2z",
"rapportez" => "RapORte",
"rapportiez" => "RapORtje",
"rapportions" => "RapORtj§",
"rapportons" => "RapORt§",
"rapports" => "RapOR",
"rapprendre" => "RapR@dR",
"rappris" => "RapRi",
"rapprocha" => "RapRoSa",
"rapprochai" => "RapRoSE",
"rapprochaient" => "RapRoSE",
"rapprochais" => "RapRoSE",
"rapprochait" => "RapRoSE",
"rapprochant" => "RapRoS@",
"rapprochât" => "RapRoSa",
"rapproche" => "RapROS",
"rapproché" => "RapRoSe",
"rapprochée" => "RapRoSe",
"rapprochées" => "RapRoSe",
"rapprochement" => "RapROS°m@",
"rapprochements" => "RapROS°m@",
"rapprochent" => "RapROS",
"rapprocher" => "RapRoSe",
"rapprochera" => "RapROS°Ra",
"rapprocherais" => "RapROS°RE",
"rapprocherait" => "RapROS°RE",
"rapprochèrent" => "RapRoSER",
"rapprocheront" => "RapROS°R§",
"rapprochés" => "RapRoSe",
"rapprocheur" => "RapRoS9R",
"rapprochez" => "RapRoSe",
"rapprochiez" => "RapRoSje",
"rapprochions" => "RapRoSj§",
"rapprochons" => "RapRoS§",
"rappropriait" => "RapRopRijE",
"rapsodie" => "RapsOdi",
"rapt" => "Rapt",
"rapts" => "Rapt",
"raquaient" => "RakE",
"raquait" => "RakE",
"raque" => "Rak",
"raqué" => "Rake",
"raquée" => "Rake",
"raquées" => "Rake",
"raquent" => "Rak",
"raquer" => "Rake",
"raques" => "Rak",
"raquette" => "RakEt",
"raquettes" => "RakEt",
"raquez" => "Rake",
"raquons" => "Rak§",
"rare" => "RaR",
"raréfaction" => "RaRefaksj§",
"raréfia" => "RaRefja",
"raréfiaient" => "RaRefjE",
"raréfiait" => "RaRefjE",
"raréfiant" => "RaRefj@",
"raréfie" => "RaRefi",
"raréfié" => "RaRefje",
"raréfiée" => "RaRefje",
"raréfiées" => "RaRefje",
"raréfient" => "RaRefi",
"raréfier" => "RaRefje",
"raréfièrent" => "RaRefjER",
"raréfiés" => "RaRefje",
"rarement" => "RaR°m@",
"rares" => "RaR",
"rareté" => "RaR°te",
"raretés" => "RaR°te",
"rarissime" => "RaRisim",
"rarissimement" => "RaRisim°m@",
"rarissimes" => "RaRisim",
"ras" => "Ra",
"ras-le-bol" => "Ral°bOl",
"rasa" => "Raza",
"rasade" => "Razad",
"rasades" => "Razad",
"rasage" => "RazaZ",
"rasages" => "RazaZ",
"rasai" => "RazE",
"rasaient" => "RazE",
"rasais" => "RazE",
"rasait" => "RazE",
"rasant" => "Raz@",
"rasante" => "Raz@t",
"rasantes" => "Raz@t",
"rasants" => "Raz@",
"rascasse" => "Raskas",
"rascasses" => "Raskas",
"rase" => "Raz",
"rasé" => "Raze",
"rase-mottes" => "RazmOt",
"rase-pet" => "RazpE",
"rase-pets" => "RazpE",
"rasée" => "Raze",
"rasées" => "Raze",
"rasent" => "Raz",
"raser" => "Raze",
"rasera" => "Raz°Ra",
"raserai" => "Raz°RE",
"raserais" => "Raz°RE",
"raserait" => "Raz°RE",
"raseras" => "Raz°Ra",
"rasèrent" => "RazER",
"raserez" => "Raz°Re",
"raseront" => "Raz°R§",
"rases" => "Raz",
"rasés" => "Raze",
"raseur" => "Raz9R",
"raseurs" => "Raz9R",
"raseuse" => "Raz2z",
"raseuses" => "Raz2z",
"rasez" => "Raze",
"rash" => "RaS",
"rasibus" => "Razibys",
"rasiez" => "Razje",
"rasif" => "Razif",
"rasifs" => "Razif",
"rasoir" => "RazwaR",
"rasoirs" => "RazwaR",
"rasons" => "Raz§",
"rassasiaient" => "RasazjE",
"rassasiais" => "RasazjE",
"rassasiait" => "RasazjE",
"rassasiant" => "Rasazj@",
"rassasiantes" => "Rasazj@t",
"rassasiât" => "Rasazja",
"rassasie" => "Rasazi",
"rassasié" => "Rasazje",
"rassasiée" => "Rasazje",
"rassasiées" => "Rasazje",
"rassasient" => "Rasazi",
"rassasier" => "Rasazje",
"rassasieraient" => "RasaziRE",
"rassasiés" => "Rasazje",
"rassasiez" => "Rasazje",
"rasse" => "Ras",
"rassembla" => "Ras@bla",
"rassemblai" => "Ras@blE",
"rassemblaient" => "Ras@blE",
"rassemblais" => "Ras@blE",
"rassemblait" => "Ras@blE",
"rassemblant" => "Ras@bl@",
"rassemble" => "Ras@bl",
"rassemblé" => "Ras@ble",
"rassemblée" => "Ras@ble",
"rassemblées" => "Ras@ble",
"rassemblement" => "Ras@bl°m@",
"rassemblements" => "Ras@bl°m@",
"rassemblent" => "Ras@bl",
"rassembler" => "Ras@ble",
"rassemblera" => "Ras@bl°Ra",
"rassemblerai" => "Ras@bl°RE",
"rassembleraient" => "Ras@bl°RE",
"rassemblerais" => "Ras@bl°RE",
"rassemblerait" => "Ras@bl°RE",
"rassembleras" => "Ras@bl°Ra",
"rassemblèrent" => "Ras@blER",
"rassemblerez" => "Ras@bl°Re",
"rassemblerons" => "Ras@bl°R§",
"rassembleront" => "Ras@bl°R§",
"rassembles" => "Ras@bl",
"rassemblés" => "Ras@ble",
"rassembleur" => "Ras@bl9R",
"rassemblez" => "Ras@ble",
"rassemblons" => "Ras@bl§",
"rasseoir" => "RaswaR",
"rasséréna" => "RaseRena",
"rassérénai" => "RaseRenE",
"rassérénait" => "RaseRenE",
"rassérénant" => "RaseRen@",
"rassérène" => "RaseREn",
"rasséréné" => "RaseRene",
"rassérénée" => "RaseRene",
"rassérénées" => "RaseRene",
"rasséréner" => "RaseRene",
"rassérénera" => "RaseRen°Ra",
"rassérénés" => "RaseRene",
"rasseyaient" => "RasEjE",
"rasseyais" => "RasEjE",
"rasseyait" => "RasEjE",
"rasseyant" => "RasEj@",
"rasseyent" => "RasEj",
"rasseyez" => "RasEje",
"rasseyons" => "RasEj§",
"rassied" => "Rasje",
"rassieds" => "Rasje",
"rassir" => "RasiR",
"rassirent" => "RasiR",
"rassis" => "Rasi",
"rassise" => "Rasiz",
"rassit" => "Rasi",
"rassoie" => "Raswa",
"rassoient" => "Raswa",
"rassoies" => "Raswa",
"rassois" => "Raswa",
"rassoit" => "Raswa",
"rassortiment" => "RasORtim@",
"rassortir" => "RasORtiR",
"rassoté" => "RasOte",
"rassoyait" => "RaswajE",
"rassura" => "RasyRa",
"rassurai" => "RasyRE",
"rassuraient" => "RasyRE",
"rassurais" => "RasyRE",
"rassurait" => "RasyRE",
"rassurâmes" => "RasyRam",
"rassurant" => "RasyR@",
"rassurante" => "RasyR@t",
"rassurantes" => "RasyR@t",
"rassurants" => "RasyR@",
"rassurât" => "RasyRa",
"rassure" => "RasyR",
"rassuré" => "RasyRe",
"rassurée" => "RasyRe",
"rassurées" => "RasyRe",
"rassurement" => "RasyR°m@",
"rassurent" => "RasyR",
"rassurer" => "RasyRe",
"rassurera" => "RasyR°Ra",
"rassurerait" => "RasyR°RE",
"rassurèrent" => "RasyRER",
"rassureront" => "RasyR°R§",
"rassures" => "RasyR",
"rassurés" => "RasyRe",
"rassurez" => "RasyRe",
"rassuriez" => "RasyRje",
"rassurons" => "RasyR§",
"rasta" => "Rasta",
"rastafari" => "RastafaRi",
"rastaquouère" => "RastakwER",
"rastaquouères" => "RastakwER",
"rastas" => "Rasta",
"rat" => "Ra",
"rat-de-cave" => "Rad°kav",
"rata" => "Rata",
"ratafia" => "Ratafja",
"ratage" => "RataZ",
"ratages" => "RataZ",
"ratai" => "RatE",
"rataient" => "RatE",
"ratais" => "RatE",
"ratait" => "RatE",
"ratant" => "Rat@",
"rataplan" => "Ratapl@",
"ratatinai" => "RatatinE",
"ratatinaient" => "RatatinE",
"ratatinais" => "RatatinE",
"ratatinait" => "RatatinE",
"ratatine" => "Ratatin",
"ratatiné" => "Ratatine",
"ratatinée" => "Ratatine",
"ratatinées" => "Ratatine",
"ratatinent" => "Ratatin",
"ratatiner" => "Ratatine",
"ratatinerait" => "Ratatin°RE",
"ratatineront" => "Ratatin°R§",
"ratatinés" => "Ratatine",
"ratatouille" => "Ratatuj",
"ratatouilles" => "Ratatuj",
"rate" => "Rat",
"raté" => "Rate",
"râteau" => "Rato",
"râteaux" => "Rato",
"ratée" => "Rate",
"ratées" => "Rate",
"râtelait" => "Rat°lE",
"râtelées" => "Rat°le",
"râteler" => "Rat°le",
"râtelier" => "Rat°lje",
"râteliers" => "Rat°lje",
"ratent" => "Rat",
"rater" => "Rate",
"ratera" => "Rat°Ra",
"raterai" => "Rat°RE",
"raterais" => "Rat°RE",
"raterait" => "Rat°RE",
"rateras" => "Rat°Ra",
"ratèrent" => "RatER",
"raterez" => "Rat°Re",
"rateriez" => "Rat°Rje",
"raterons" => "Rat°R§",
"rateront" => "Rat°R§",
"rates" => "Rat",
"ratés" => "Rate",
"ratez" => "Rate",
"ratiboisaient" => "RatibwazE",
"ratiboisait" => "RatibwazE",
"ratiboisé" => "Ratibwaze",
"ratiboiser" => "Ratibwaze",
"ratiboises" => "Ratibwaz",
"ratiboisés" => "Ratibwaze",
"ratiche" => "RatiS",
"ratiches" => "RatiS",
"ratichon" => "RatiS§",
"ratichons" => "RatiS§",
"raticide" => "Ratisid",
"ratier" => "Ratje",
"ratière" => "RatjER",
"ratières" => "RasjER",
"ratiez" => "Ratje",
"ratifia" => "Ratifja",
"ratifiant" => "Ratifj@",
"ratification" => "Ratifikasj§",
"ratifie" => "Ratifi",
"ratifié" => "Ratifje",
"ratifiée" => "Ratifje",
"ratifient" => "Ratifi",
"ratifier" => "Ratifje",
"ratifieront" => "RatifiR§",
"ratifiés" => "Ratifje",
"ratine" => "Ratin",
"ratio" => "Rasjo",
"ratiocinait" => "RasjosinE",
"ratiocinant" => "Rasjosin@",
"ratiocination" => "RasjOsinasj§",
"ratiocinations" => "Rasjosinasj§",
"ratiocineur" => "Rasjosin9R",
"ration" => "Rasj§",
"rational" => "RasjOnal",
"rationalisation" => "Rasjonalizasj§",
"rationalise" => "Rasjonaliz",
"rationalisé" => "Rasjonalize",
"rationalisée" => "Rasjonalize",
"rationaliser" => "Rasjonalize",
"rationalisez" => "Rasjonalize",
"rationalisme" => "Rasjonalizm",
"rationaliste" => "Rasjonalist",
"rationalistes" => "Rasjonalist",
"rationalité" => "Rasjonalite",
"rationne" => "RasjOn",
"rationné" => "Rasjone",
"rationnée" => "Rasjone",
"rationnées" => "Rasjone",
"rationnel" => "RasjonEl",
"rationnelle" => "RasjonEl",
"rationnellement" => "RasjonEl°m@",
"rationnelles" => "RasjonEl",
"rationnels" => "RasjonEl",
"rationnement" => "RasjOn°m@",
"rationner" => "Rasjone",
"rationnés" => "Rasjone",
"rationnez" => "Rasjone",
"rations" => "Rasj§",
"ratissa" => "Ratisa",
"ratissage" => "RatisaZ",
"ratissaient" => "RatisE",
"ratissais" => "RatisE",
"ratissait" => "RatisE",
"ratissant" => "Ratis@",
"ratisse" => "Ratis",
"ratissé" => "Ratise",
"ratissée" => "Ratise",
"ratissées" => "Ratise",
"ratissent" => "Ratis",
"ratisser" => "Ratise",
"ratisserai" => "Ratis°RE",
"ratisseront" => "Ratis°R§",
"ratissés" => "Ratise",
"ratisseur" => "Ratis9R",
"ratissez" => "Ratise",
"ratissons" => "Ratis§",
"ratite" => "Ratit",
"ratites" => "Ratit",
"raton" => "Rat§",
"ratonnade" => "Ratonad",
"ratonnades" => "Ratonad",
"ratonnent" => "RatOn",
"ratonner" => "Ratone",
"ratons" => "Rat§",
"rats" => "Ra",
"rattacha" => "RataSa",
"rattachaient" => "RataSE",
"rattachais" => "RataSE",
"rattachait" => "RataSE",
"rattachant" => "RataS@",
"rattachât" => "RataSa",
"rattache" => "RataS",
"rattaché" => "RataSe",
"rattachée" => "RataSe",
"rattachées" => "RataSe",
"rattachement" => "RataS°m@",
"rattachent" => "RataS",
"rattacher" => "RataSe",
"rattachera" => "RataS°Ra",
"rattacherait" => "RataS°RE",
"rattachés" => "RataSe",
"rattachez" => "RataSe",
"rattachions" => "RataSj§",
"rattachons" => "RataS§",
"ratte" => "Rat",
"rattrapa" => "RatRapa",
"rattrapage" => "RatRapaZ",
"rattrapages" => "RatRapaZ",
"rattrapai" => "RatRapE",
"rattrapaient" => "RatRapE",
"rattrapais" => "RatRapE",
"rattrapait" => "RatRapE",
"rattrapant" => "RatRap@",
"rattrapât" => "RatRapa",
"rattrape" => "RatRap",
"rattrapé" => "RatRape",
"rattrapée" => "RatRape",
"rattrapées" => "RatRape",
"rattrapent" => "RatRap",
"rattraper" => "RatRape",
"rattrapera" => "RatRap°Ra",
"rattraperai" => "RatRap°RE",
"rattraperaient" => "RatRap°RE",
"rattraperais" => "RatRap°RE",
"rattraperait" => "RatRap°RE",
"rattraperas" => "RatRap°Ra",
"rattrapèrent" => "RatRapER",
"rattraperez" => "RatRap°Re",
"rattraperons" => "RatRap°R§",
"rattraperont" => "RatRap°R§",
"rattrapes" => "RatRap",
"rattrapés" => "RatRape",
"rattrapez" => "RatRape",
"rattrapiez" => "RatRapje",
"rattrapions" => "RatRapj§",
"rattrapons" => "RatRap§",
"ratura" => "RatyRa",
"raturai" => "RatyRE",
"raturais" => "RatyRE",
"raturait" => "RatyRE",
"rature" => "RatyR",
"raturé" => "RatyRe",
"raturée" => "RatyRe",
"raturées" => "RatyRe",
"raturer" => "RatyRe",
"ratures" => "RatyR",
"raturés" => "RatyRe",
"raucité" => "Rosite",
"rauqua" => "Roka",
"rauque" => "Rok",
"rauquement" => "Rok°m@",
"rauques" => "Rok",
"ravage" => "RavaZ",
"ravagé" => "RavaZe",
"ravagea" => "RavaZa",
"ravageaient" => "RavaZE",
"ravageais" => "RavaZE",
"ravageait" => "RavaZE",
"ravageant" => "RavaZ@",
"ravageante" => "RavaZ@t",
"ravagée" => "RavaZe",
"ravagées" => "RavaZe",
"ravagent" => "RavaZ",
"ravager" => "RavaZe",
"ravagera" => "RavaZ°Ra",
"ravagerai" => "RavaZ°RE",
"ravageraient" => "RavaZ°RE",
"ravagèrent" => "RavaZER",
"ravages" => "RavaZ",
"ravagés" => "RavaZe",
"ravageur" => "RavaZ9R",
"ravageurs" => "RavaZ9R",
"ravageuse" => "RavaZ2z",
"ravageuses" => "RavaZ2z",
"ravagez" => "RavaZe",
"raval" => "Raval",
"ravala" => "Ravala",
"ravalai" => "RavalE",
"ravalaient" => "RavalE",
"ravalais" => "RavalE",
"ravalait" => "RavalE",
"ravalant" => "Raval@",
"ravalât" => "Ravala",
"ravale" => "Raval",
"ravalé" => "Ravale",
"ravalée" => "Ravale",
"ravalées" => "Ravale",
"ravalement" => "Raval°m@",
"ravalent" => "Raval",
"ravaler" => "Ravale",
"ravalera" => "Raval°Ra",
"ravaleront" => "Raval°R§",
"ravales" => "Raval",
"ravalés" => "Ravale",
"ravaleur" => "Raval9R",
"ravalez" => "Ravale",
"ravalons" => "Raval§",
"ravaudage" => "RavodaZ",
"ravaudait" => "RavodE",
"ravaudant" => "Ravod@",
"ravaude" => "Ravod",
"ravaudé" => "Ravode",
"ravaudées" => "Ravode",
"ravauder" => "Ravode",
"ravaudés" => "Ravode",
"rave" => "Rav",
"ravenelles" => "Rav°nEl",
"ravennate" => "Rav°nat",
"raves" => "Rav",
"ravi" => "Ravi",
"ravie" => "Ravi",
"ravier" => "Ravje",
"raviers" => "Ravje",
"ravies" => "Ravi",
"ravigotait" => "RavigotE",
"ravigotant" => "Ravigot@",
"ravigotants" => "Ravigot@",
"ravigote" => "RavigOt",
"ravigoter" => "Ravigote",
"ravin" => "Rav5",
"ravina" => "Ravina",
"ravinaient" => "RavinE",
"ravinant" => "Ravin@",
"ravine" => "Ravin",
"raviné" => "Ravine",
"ravinée" => "Ravine",
"ravinées" => "Ravine",
"ravinement" => "Ravin°m@",
"ravinements" => "Ravin°m@",
"ravinent" => "Ravin",
"raviner" => "Ravine",
"ravines" => "Ravin",
"ravinés" => "Ravine",
"ravins" => "Rav5",
"ravioli" => "Ravjoli",
"raviolis" => "Ravjoli",
"ravir" => "RaviR",
"ravirait" => "RaviRE",
"ravirent" => "RaviR",
"raviront" => "RaviR§",
"ravis" => "Ravi",
"ravisa" => "Raviza",
"ravisais" => "RavizE",
"ravisait" => "RavizE",
"ravisant" => "Raviz@",
"ravise" => "Raviz",
"ravisé" => "Ravize",
"ravisée" => "Ravize",
"ravisent" => "Raviz",
"raviser" => "Ravize",
"ravisera" => "Raviz°Ra",
"raviserais" => "Raviz°RE",
"ravises" => "Raviz",
"ravisez" => "Ravize",
"ravissaient" => "RavisE",
"ravissait" => "RavisE",
"ravissant" => "Ravis@",
"ravissante" => "Ravis@t",
"ravissantes" => "Ravis@t",
"ravissants" => "Ravis@",
"ravisse" => "Ravis",
"ravissement" => "Ravis°m@",
"ravissements" => "Ravis°m@",
"ravissent" => "Ravis",
"ravisseur" => "Ravis9R",
"ravisseurs" => "Ravis9R",
"ravisseuse" => "Ravis2z",
"ravit" => "Ravi",
"ravitaillaient" => "RavitajE",
"ravitaillait" => "RavitajE",
"ravitaille" => "Ravitaj",
"ravitaillé" => "Ravitaje",
"ravitaillée" => "Ravitaje",
"ravitaillées" => "Ravitaje",
"ravitaillement" => "Ravitaj°m@",
"ravitaillements" => "Ravitaj°m@",
"ravitaillent" => "Ravitaj",
"ravitailler" => "Ravitaje",
"ravitaillera" => "Ravitaj°Ra",
"ravitaillerait" => "Ravitaj°RE",
"ravitailleras" => "Ravitaj°Ra",
"ravitaillerez" => "Ravitaj°Re",
"ravitaillés" => "Ravitaje",
"ravitailleur" => "Ravitaj9R",
"ravitailleurs" => "Ravitaj9R",
"ravitailleuse" => "Ravitaj2z",
"ravitaillons" => "Ravitaj§",
"raviva" => "Raviva",
"ravivaient" => "RavivE",
"ravivait" => "RavivE",
"ravivant" => "Raviv@",
"ravivât" => "Raviva",
"ravive" => "Raviv",
"ravivé" => "Ravive",
"ravivée" => "Ravive",
"ravivement" => "Raviv°m@",
"ravivent" => "Raviv",
"raviver" => "Ravive",
"ravivez" => "Ravive",
"ravoir" => "RavwaR",
"ray-grass" => "REgRas",
"raya" => "Reja",
"rayables" => "REjabl",
"rayaient" => "RejE",
"rayait" => "RejE",
"rayant" => "Rej@",
"rayât" => "Reja",
"raye" => "Rej",
"rayé" => "Reje",
"rayée" => "Reje",
"rayées" => "Reje",
"rayent" => "Rej",
"rayer" => "Reje",
"rayera" => "REj°Ra",
"rayerai" => "REj°RE",
"rayerais" => "Rej°RE",
"rayeras" => "REj°Ra",
"rayeront" => "REj°R§",
"rayés" => "Reje",
"rayez" => "Reje",
"rayions" => "Rejj§",
"rayon" => "REj§",
"rayon-éclair" => "REj§eklER",
"rayonna" => "REjona",
"rayonnage" => "REjonaZ",
"rayonnages" => "REjonaZ",
"rayonnaient" => "REjonE",
"rayonnais" => "REjonE",
"rayonnait" => "REjonE",
"rayonnant" => "REjon@",
"rayonnante" => "REjon@t",
"rayonnantes" => "REjon@t",
"rayonnants" => "REjon@",
"rayonne" => "REjOn",
"rayonné" => "REjone",
"rayonnement" => "REjOn°m@",
"rayonnements" => "REjOn°m@",
"rayonnent" => "REjOn",
"rayonner" => "REjone",
"rayonnera" => "REjOn°Ra",
"rayonnerait" => "REjOn°RE",
"rayonnes" => "REjOn",
"rayonneur" => "REjOn9R",
"rayonnez" => "REjone",
"rayons" => "REj§",
"rayure" => "RejyR",
"rayures" => "RejyR",
"raz" => "Ra",
"raz-de-marée" => "Rad°maRe",
"razzia" => "Radzja",
"razziais" => "RadzjE",
"razzias" => "Radzja",
"razzier" => "Radzje",
"re" => "R2",
"ré" => "Re",
"re-aboie" => "R2abwa",
"re-balbutiant" => "R°balbysj@",
"re-baptême" => "R°batEm",
"re-belote" => "R°b2lOt",
"re-biberonner" => "R°bib°Rone",
"re-bide" => "R°bid",
"re-blinder" => "R°bl5de",
"re-bombardons" => "R°b§baRd§",
"re-boucler" => "R°bukle",
"re-cabossé" => "R°kabose",
"re-café" => "R°kafe",
"re-cailloux" => "R°kaju",
"re-calibrais" => "R°kalibRE",
"re-cassée" => "R°kase",
"re-chanteur" => "R°S@t9R",
"re-chiader" => "R°Sjade",
"re-cisèle" => "R°sizEl",
"re-classe" => "R°klas",
"re-classer" => "R°klase",
"re-connaître" => "R°konEtR",
"re-contacte" => "R°k§takt",
"re-contactent" => "R°k§takt",
"re-contacter" => "R°k§takte",
"re-contacterai" => "R°k§takt°RE",
"re-convaincra" => "R°k§v5kRa",
"re-coup" => "R°ku",
"re-crac" => "R°kRak",
"re-création" => "R°kReasj§",
"re-créée" => "R°kRee",
"re-creusés" => "R°kR2ze",
"re-croquis" => "R°kRoki",
"re-cul" => "R°ky",
"re-déchire" => "R°deSiR",
"re-déclic" => "R°deklik",
"re-décore" => "R°dekOR",
"re-décorer" => "R°dekoRe",
"re-déménager" => "R°demenaZe",
"re-diffuses" => "R°difyz",
"re-dose" => "R°doz",
"re-drapeau" => "R°dRapo",
"re-ébranlés" => "R2ebR@le",
"re-échanger" => "R2eS@Ze",
"re-explique" => "R2Eksplik",
"re-faim" => "R°f5",
"re-frappe" => "R°fRap",
"re-frappé" => "R°fRape",
"re-fuse" => "R°fyz",
"re-gomme" => "R°gOm",
"re-histoires" => "R°istwaR",
"re-hygiène" => "R°iZjEn",
"re-inter" => "R°5tER",
"re-kidnappais" => "R°kidnapE",
"re-lettre" => "R°lEtR",
"re-main" => "R°m5",
"re-matérialisation" => "R°mateRjalizasj§",
"re-morphine" => "R°mORfin",
"re-nés" => "R°ne",
"re-paye" => "R°pEj",
"re-penser" => "R°p@se",
"re-potassé" => "R°potase",
"re-programmation" => "R°pRogRamasj§",
"re-programmée" => "R°pRogRame",
"re-raconte" => "R°Rak§t",
"re-racontées" => "R°Rak§te",
"re-récurait" => "R°RekyRE",
"re-remplir" => "R°R@pliR",
"re-rentrer" => "R°R@tRe",
"re-réparer" => "R°RepaRe",
"re-respirer" => "R°REspiRe",
"re-ressortait" => "R°R°sORtE",
"re-retirent" => "R°R°tiR",
"re-rêvé" => "R°Reve",
"re-rigole" => "R°RigOl",
"re-salué" => "R°sal8e",
"re-savaté" => "R°savat",
"re-sculpte" => "R°skylt",
"re-séparés" => "R°sepaRe",
"re-sevrage" => "R°s°vRaZ",
"re-signer" => "R°siNe",
"re-sommeil" => "R°somEj",
"re-sonne" => "R°sOn",
"re-structuration" => "R°stRyktyRasj§",
"re-taloche" => "R°talOS",
"re-titille" => "R°titij",
"re-traitée" => "R°tRete",
"re-travail" => "R°tRavaj",
"re-tuage" => "R°tyaZ",
"re-tuer" => "R°t8e",
"re-tues" => "R°ty",
"re-vérifié" => "R°veRifje",
"re-vérifier" => "R°veRifje",
"re-veux" => "R°v2",
"re-vie" => "R°vi",
"re-visite" => "R°vizit",
"re-vit" => "R°vi",
"réa" => "Rea",
"réabonnement" => "ReabOn°m@",
"réabonner" => "ReabOne",
"réabsorption" => "ReapsORpsj§",
"réac" => "Reak",
"réaccoutumer" => "Reakutyme",
"réaccoutumerait" => "Reakutym°RE",
"réacheminer" => "ReaS2mine",
"réacs" => "Reak",
"réactant" => "Reakt@",
"réacteur" => "Reakt9R",
"réacteurs" => "Reakt9R",
"réactif" => "Reaktif",
"réactifs" => "Reaktif",
"réaction" => "Reaksj§",
"réactionnaire" => "ReaksjonER",
"réactionnaires" => "ReaksjonER",
"réactionnel" => "ReaksjonEl",
"réactions" => "Reaksj§",
"réactiva" => "Reaktiva",
"réactivait" => "ReaktivE",
"réactivation" => "Reaktivasj§",
"réactive" => "Reaktiv",
"réactivé" => "Reaktive",
"réactivée" => "Reaktive",
"réactivées" => "Reaktive",
"réactiver" => "Reaktive",
"réactiveront" => "Reaktiv°R§",
"réactives" => "Reaktiv",
"réactivez" => "Reaktive",
"réactiviez" => "Reaktivje",
"réactivité" => "Reaktivite",
"réactualisation" => "Reakt8alizasj§",
"réactualise" => "Reakt8aliz",
"réactualisé" => "Reakt8alize",
"réactualiser" => "Reakt8alize",
"réadaptait" => "ReadaptE",
"réadaptant" => "Readapt@",
"réadaptation" => "Readaptasj§",
"réadapte" => "Readapt",
"réadapter" => "Readapte",
"reader" => "Rid9R",
"réadmis" => "Readmi",
"réadmise" => "Readmiz",
"réadmission" => "Readmisj§",
"réadopter" => "ReadOpte",
"ready-made" => "REdimEjd",
"réaffectait" => "ReafEktE",
"réaffectation" => "ReafEktasj§",
"réaffecté" => "ReafEkte",
"réaffectée" => "ReafEkte",
"réaffecter" => "ReafEkte",
"réaffectés" => "ReafEkte",
"réaffectons" => "ReafEkt§",
"réaffichées" => "ReafiSe",
"réaffirmai" => "ReafiRmE",
"réaffirmaient" => "ReafiRmE",
"réaffirmait" => "ReafiRmE",
"réaffirmation" => "ReafiRmasj§",
"réaffirme" => "ReafiRm",
"réaffirmé" => "ReafiRme",
"réaffirmée" => "ReafiRme",
"réaffirmer" => "ReafiRme",
"réaffûtée" => "Reafyte",
"réagencement" => "ReaZ@s°m@",
"réagi" => "ReaZi",
"réagir" => "ReaZiR",
"réagira" => "ReaZiRa",
"réagirai" => "ReaZiRE",
"réagiraient" => "ReaZiRE",
"réagirais" => "ReaZiRE",
"réagirait" => "ReaZiRE",
"réagiras" => "ReaZiRa",
"réagirent" => "ReaZiR",
"réagirez" => "ReaZiRe",
"réagiriez" => "ReaZiRje",
"réagirons" => "ReaZiR§",
"réagiront" => "ReaZiR§",
"réagis" => "ReaZi",
"réagissaient" => "ReaZisE",
"réagissais" => "ReaZisE",
"réagissait" => "ReaZisE",
"réagissant" => "ReaZis@",
"réagissante" => "ReaZis@t",
"réagisse" => "ReaZis",
"réagissent" => "ReaZis",
"réagisses" => "ReaZis",
"réagissez" => "ReaZise",
"réagissiez" => "ReaZisje",
"réagissions" => "ReaZisj§",
"réagissons" => "ReaZis§",
"réagit" => "ReaZi",
"réagît" => "ReaZi",
"réait" => "ReE",
"réajusta" => "ReaZysta",
"réajustaient" => "ReaZystE",
"réajustait" => "ReaZystE",
"réajustant" => "ReaZyst@",
"réajuste" => "ReaZyst",
"réajusté" => "ReaZyste",
"réajustées" => "ReaZyste",
"réajustement" => "ReaZyst°m@",
"réajustements" => "ReaZyst°m@",
"réajuster" => "ReaZyste",
"réajustés" => "ReaZyste",
"réal" => "Real",
"réaligne" => "RealiN",
"réalignement" => "RealiN°m@",
"réaligner" => "RealiNe",
"réalimenter" => "Realim@te",
"réalisa" => "Realiza",
"réalisable" => "Realizabl",
"réalisables" => "Realizabl",
"réalisai" => "RealizE",
"réalisaient" => "RealizE",
"réalisais" => "RealizE",
"réalisait" => "RealizE",
"réalisâmes" => "Realizam",
"réalisant" => "Realiz@",
"réalisât" => "Realiza",
"réalisateur" => "Realizat9R",
"réalisateurs" => "Realizat9R",
"réalisation" => "Realizasj§",
"réalisations" => "Realizasj§",
"réalisatrice" => "RealizatRis",
"réalisatrices" => "RealizatRis",
"réalise" => "Realiz",
"réalisé" => "Realize",
"réalisée" => "Realize",
"réalisées" => "Realize",
"réalisent" => "Realiz",
"réaliser" => "Realize",
"réalisera" => "Realiz°Ra",
"réaliserai" => "Realiz°RE",
"réaliseraient" => "Realiz°RE",
"réaliserais" => "Realiz°RE",
"réaliserait" => "Realiz°RE",
"réaliseras" => "Realiz°Ra",
"réalisèrent" => "RealizER",
"réaliserez" => "Realiz°Re",
"réaliserions" => "Realiz°Rj§",
"réaliseront" => "Realiz°R§",
"réalises" => "Realiz",
"réalisés" => "Realize",
"réalisez" => "Realize",
"réalisiez" => "Realizje",
"réalisions" => "Realizj§",
"réalisme" => "Realizm",
"réalisons" => "Realiz§",
"réaliste" => "Realist",
"réalistes" => "Realist",
"réalité" => "Realite",
"réalités" => "Realite",
"réaménagé" => "ReamenaZe",
"réaménageait" => "ReamenaZE",
"réaménagement" => "ReamenaZ°m@",
"réaménagements" => "ReamenaZ°m@",
"réaménager" => "ReamenaZe",
"réamorçage" => "ReamORsaZ",
"réamorçait" => "ReamORsE",
"réamorce" => "ReamORs",
"réamorcent" => "ReamORs",
"réamorcer" => "ReamORse",
"réanimait" => "ReanimE",
"réanimateur" => "Reanimat9R",
"réanimation" => "Reanimasj§",
"réanime" => "Reanim",
"réanimé" => "Reanime",
"réanimée" => "Reanime",
"réanimer" => "Reanime",
"réanimeraient" => "Reanim°RE",
"réanimez" => "Reanime",
"réanimions" => "Reanimj§",
"réapercevoir" => "ReapERs2vwaR",
"réapparais" => "ReapaRE",
"réapparaissaient" => "ReapaREsE",
"réapparaissais" => "ReapaREsE",
"réapparaissait" => "ReapaREsE",
"réapparaissant" => "ReapaREs@",
"réapparaisse" => "ReapaREs",
"réapparaissent" => "ReapaREs",
"réapparaisses" => "ReapaREs",
"réapparaît" => "ReapaRE",
"réapparaîtra" => "ReapaREtRa",
"réapparaîtrai" => "ReapaREtRE",
"réapparaîtraient" => "ReapaREtRE",
"réapparaîtrait" => "ReapaREtRE",
"réapparaître" => "ReapaREtR",
"réapparaîtront" => "ReapaREtR§",
"réapparition" => "ReapaRisj§",
"réapparitions" => "ReapaRisj§",
"réapparu" => "ReapaRy",
"réapparue" => "ReapaRy",
"réapparues" => "ReapaRy",
"réapparurent" => "ReapaRyR",
"réapparus" => "ReapaRy",
"réapparut" => "ReapaRy",
"réapparût" => "ReapaRy",
"réappeler" => "Reap°le",
"réapprenaient" => "ReapR°nE",
"réapprenais" => "ReapR°nE",
"réapprenait" => "ReapR°nE",
"réapprend" => "ReapR@",
"réapprendraient" => "ReapR@dRE",
"réapprendre" => "ReapR@dR",
"réapprendrez" => "ReapR@dRe",
"réapprends" => "ReapR@",
"réapprenne" => "ReapREn",
"réappris" => "ReapRi",
"réapprises" => "ReapRiz",
"réapprit" => "ReapRi",
"réapprovisionne" => "ReapRovizjOn",
"réapprovisionné" => "ReapRovizjone",
"réapprovisionnée" => "ReapRovizjone",
"réapprovisionnement" => "ReapRovizjOn°m@",
"réapprovisionner" => "ReapRovizjone",
"réapprovisionnerait" => "ReapRovizjOn°RE",
"réargenter" => "ReaRZ@te",
"réarma" => "ReaRma",
"réarmant" => "ReaRm@",
"réarme" => "ReaRm",
"réarmé" => "ReaRme",
"réarmées" => "ReaRme",
"réarmement" => "ReaRm°m@",
"réarmer" => "ReaRme",
"réarrange" => "ReaR@Z",
"réarrangé" => "ReaR@Ze",
"réarrangeait" => "ReaR@ZE",
"réarrangeant" => "ReaR@Z@",
"réarrangement" => "ReaR@Z°m@",
"réarrangent" => "ReaR@Z",
"réarranger" => "ReaR@Ze",
"réassembler" => "Reas@ble",
"réassignation" => "ReasiNasj§",
"réassigné" => "ReasiNe",
"réassigner" => "ReasiNe",
"réassigneront" => "ReasiN°R§",
"réassimilé" => "Reasimile",
"réassorties" => "ReasORti",
"réassortir" => "ReasORtiR",
"réassumer" => "Reasyme",
"réassurer" => "ReasyRe",
"réattaquai" => "ReatakE",
"réattaquait" => "ReatakEt",
"réattaque" => "Reatak",
"réattaqué" => "Reatake",
"réattaquer" => "Reatake",
"réaux" => "Reo",
"rebab" => "R°bab",
"rebaise" => "R°bEz",
"rebaisé" => "R°bEze",
"rebaisent" => "R°bEz",
"rebaiser" => "R°bEze",
"rebaissa" => "R°bEsa",
"rebaissait" => "R°bEsE",
"rebaisse" => "R°bEs",
"rebaissé" => "R°bese",
"rebander" => "R°b@de",
"rebaptisa" => "R°batiza",
"rebaptise" => "R°batiz",
"rebaptisé" => "R°batize",
"rebaptisée" => "R°batize",
"rebaptisées" => "R°batize",
"rebaptiser" => "R°batize",
"rébarbatif" => "RebaRbatif",
"rébarbatifs" => "RebaRbatif",
"rébarbative" => "RebaRbativ",
"rébarbatives" => "RebaRbativ",
"rebarré" => "R2baRe",
"rebasculait" => "R°baskylE",
"rebascule" => "R°baskyl",
"rebasculera" => "R°baskyl°Ra",
"rebat" => "R°ba",
"rebâti" => "R°bati",
"rebâtie" => "R°bati",
"rebâties" => "R°bati",
"rebâtir" => "R°batiR",
"rebâtirai" => "R°batiRE",
"rebâtirent" => "R°batiR",
"rebâtirons" => "R°batiR§",
"rebâtis" => "R°bati",
"rebâtissaient" => "R°batisE",
"rebâtissant" => "R°batis@",
"rebâtissent" => "R°batis",
"rebâtissons" => "R°batis§",
"rebâtit" => "R°bati",
"rebats" => "R°ba",
"rebattait" => "R°batE",
"rebattent" => "R°bat",
"rebattez" => "R°bate",
"rebattit" => "R°bati",
"rebattre" => "R°batR",
"rebattu" => "R°baty",
"rebattue" => "R°baty",
"rebattues" => "R°baty",
"rebattus" => "R°baty",
"rebec" => "R2bEk",
"rébecca" => "Rebeka",
"rebecté" => "R2bEkte",
"rebecter" => "R2bEkte",
"rebella" => "R°bEla",
"rebellaient" => "R°bElE",
"rebellais" => "R°bElE",
"rebellait" => "R°bElE",
"rebellant" => "R°bEl@",
"rebellât" => "R°bEla",
"rebelle" => "R°bEl",
"rebellé" => "R°bele",
"rebellée" => "R°bele",
"rebellent" => "R°bEl",
"rebeller" => "R°bEle",
"rebellèrent" => "R°bElER",
"rebelles" => "R°bEl",
"rebellés" => "R°bEle",
"rebellez" => "R°bEle",
"rébellion" => "Rebelj§",
"rébellions" => "Rebelj§",
"rebelote" => "R°b2lOt",
"rebéquer" => "R2beke",
"rebiffa" => "R°bifa",
"rebiffai" => "R°bifE",
"rebiffaient" => "R°bifE",
"rebiffais" => "R°bifE",
"rebiffait" => "R°bifE",
"rebiffant" => "R°bif@",
"rebiffe" => "R°bif",
"rebiffé" => "R°bife",
"rebiffée" => "R°bife",
"rebiffent" => "R°bif",
"rebiffer" => "R°bife",
"rebifferai" => "R°bif°RE",
"rebiffèrent" => "R°bifER",
"rebiffes" => "R°bif",
"rebiquaient" => "R°bikE",
"rebiquait" => "R°bikE",
"rebique" => "R°bik",
"rebiquée" => "R°bike",
"rebiquer" => "R°bike",
"reblanchir" => "R°bl@SiR",
"reblochon" => "R°bloS§",
"reblochons" => "R°bloS§",
"rebloquer" => "R2blOke",
"rebobiner" => "R2bObine",
"reboire" => "R°bwaR",
"rebois" => "R°bwa",
"reboise" => "R°bwaz",
"reboisées" => "R°bwaze",
"reboisement" => "R°bwaz°m@",
"reboit" => "R°bwa",
"rebond" => "R°b§",
"rebondi" => "R°b§di",
"rebondie" => "R°b§di",
"rebondies" => "R°b§di",
"rebondir" => "R°b§diR",
"rebondira" => "R°b§diRa",
"rebondiraient" => "R°b§diRE",
"rebondirait" => "R°b§diRE",
"rebondirent" => "R°b§diR",
"rebondis" => "R°b§di",
"rebondissaient" => "R°b§disE",
"rebondissais" => "R°b§disE",
"rebondissait" => "R°b§disE",
"rebondissant" => "R°b§dis@",
"rebondissante" => "R°b§dis@t",
"rebondissantes" => "R°b§dis@t",
"rebondissants" => "R°b§dis@",
"rebondisse" => "R°b§dis",
"rebondissement" => "R°b§dis°m@",
"rebondissements" => "R°b§dis°m@",
"rebondissent" => "R°b§dis",
"rebondit" => "R°b§di",
"rebonds" => "R°b§",
"rebonjour" => "R2b§ZuR",
"rebooter" => "R°bOOte",
"rebord" => "R°bOR",
"rebordée" => "R°bORde",
"reborder" => "R2bORde",
"rebords" => "R°bOR",
"reboucha" => "R°buSa",
"rebouchait" => "R°buSE",
"rebouchant" => "R°buS@",
"rebouche" => "R°buS",
"rebouché" => "R°buSe",
"rebouchée" => "R°buSe",
"rebouchées" => "R°buSe",
"rebouchent" => "R°buS",
"reboucher" => "R°buSe",
"rebouchèrent" => "R°buSER",
"reboucheront" => "R°buS°R§",
"rebouchés" => "R°buSe",
"rebouchez" => "R°buSe",
"reboucla" => "R°bukla",
"reboucle" => "R°bukl",
"rebouclé" => "R°bukle",
"rebouclée" => "R°bukle",
"reboucler" => "R°bukle",
"reboule" => "R2bul",
"rebourrer" => "R2buRe",
"rebours" => "R°buR",
"reboute" => "R°but",
"rebouter" => "R°bute",
"rebouteuse" => "R°but2z",
"rebouteux" => "R°but2",
"reboutez" => "R°bute",
"reboutonna" => "R°butona",
"reboutonnaient" => "R°butonE",
"reboutonnais" => "R°butonE",
"reboutonnant" => "R°buton@",
"reboutonne" => "R°butOn",
"reboutonné" => "R°butone",
"reboutonnée" => "R°butone",
"reboutonner" => "R°butone",
"reboutonnerait" => "R°butOn°RE",
"reboutonnèrent" => "R°butonER",
"reboutonnés" => "R°butone",
"reboutonnez" => "R°butone",
"rebraguetté" => "R°bRagEte",
"rebraguetter" => "R°bRagEte",
"rebrancha" => "R°bR@Sa",
"rebranche" => "R°bR@S",
"rebranché" => "R°bR@Se",
"rebranchée" => "R°bR@Se",
"rebrancher" => "R°bR@Se",
"rebranchez" => "R°bR@Se",
"rebrodait" => "R°bRodE",
"rebrodée" => "R°bRode",
"rebrodés" => "R°bRode",
"rebrosser" => "R2bROse",
"rebroussa" => "R°bRusa",
"rebroussai" => "R°bRusE",
"rebroussaient" => "R°bRusE",
"rebroussait" => "R°bRusE",
"rebroussâmes" => "R°bRusam",
"rebroussant" => "R°bRus@",
"rebroussât" => "R°bRusa",
"rebrousse" => "R°bRus",
"rebroussé" => "R°bRuse",
"rebroussée" => "R°bRuse",
"rebroussées" => "R°bRuse",
"rebroussement" => "R°bRus°m@",
"rebroussent" => "R°bRus",
"rebrousser" => "R°bRuse",
"rebrousserai" => "R°bRus°RE",
"rebroussèrent" => "R°bRusER",
"rebrousserez" => "R°bRus°Re",
"rebroussés" => "R°bRuse",
"rebroussez" => "R°bRuse",
"rebroussons" => "R°bRus§",
"rebrûlé" => "R°bRyle",
"rebu" => "R°by",
"rebuffade" => "R°byfad",
"rebuffades" => "R°byfad",
"rebus" => "R°by",
"rébus" => "Rebys",
"rebut" => "R°by",
"rebuta" => "R°byta",
"rebutaient" => "R°bytE",
"rebutait" => "R°bytE",
"rebutant" => "R°byt@",
"rebutante" => "R°byt@t",
"rebutantes" => "R°byt@t",
"rebutants" => "R°byt@",
"rebute" => "R°byt",
"rebuté" => "R°byte",
"rebutée" => "R°byte",
"rebutées" => "R°byte",
"rebutent" => "R°byt",
"rebuter" => "R°byte",
"rebutera" => "R°byt°Ra",
"rebuterait" => "R°byt°RE",
"rebutèrent" => "R°bytER",
"rebutés" => "R°byte",
"rebuts" => "R°by",
"rebuvait" => "R°byvE",
"recâbler" => "R2kable",
"recache" => "R°kaS",
"recacher" => "R°kaSe",
"recachetée" => "R°kaS°te",
"recacheter" => "R°kaS°te",
"recadre" => "R°kadR",
"recadrer" => "R°kadRe",
"recadrez" => "R°kadRe",
"recala" => "R°kala",
"recalage" => "R2kalaZ",
"récalcitrant" => "RekalsitR@",
"récalcitrante" => "RekalsitR@t",
"récalcitrantes" => "RekalsitR@t",
"récalcitrants" => "RekalsitR@",
"recalculant" => "R°kalkyl@",
"recalcule" => "R°kalkyl",
"recalculé" => "R°kalkyle",
"recalculer" => "R°kalkyle",
"recalculez" => "R°kalkyle",
"recalé" => "R°kale",
"recalée" => "R°kale",
"recaler" => "R°kale",
"recalés" => "R°kale",
"recalez" => "R°kale",
"récapitula" => "Rekapityla",
"récapitulai" => "RekapitylE",
"récapitulais" => "RekapitylE",
"récapitulait" => "RekapitylE",
"récapitulant" => "Rekapityl@",
"récapitulatif" => "Rekapitylatif",
"récapitulation" => "Rekapitylasj§",
"récapitule" => "Rekapityl",
"récapitulé" => "Rekapityle",
"récapitulée" => "Rekapityle",
"récapitulent" => "Rekapityl",
"récapituler" => "Rekapityle",
"récapitulez" => "Rekapityle",
"récapitulions" => "Rekapitylj§",
"récapitulons" => "Rekapityl§",
"recarreler" => "R°kaR°le",
"recasa" => "R°kaza",
"recasable" => "R2kazabl",
"recasé" => "R°kaze",
"recaser" => "R°kaze",
"recaserai" => "R°kaz°RE",
"recassé" => "R°kase",
"recassée" => "R°kase",
"recasser" => "R2kase",
"recasses" => "R°kas",
"recel" => "R°sEl",
"recelaient" => "R°s°lE",
"recelait" => "R°s°lE",
"recélait" => "R°selE",
"recelant" => "R°s°l@",
"recélant" => "R°sel@",
"recèle" => "R°sEl",
"recelé" => "R°s°le",
"recelée" => "R°s°le",
"recelées" => "R°s°le",
"recèlent" => "R°sEl",
"receler" => "R°s°le",
"recéler" => "R°sele",
"recèles" => "R°sEl",
"recelés" => "R°s°le",
"receleur" => "R°s°l9R",
"receleur-miracle" => "R°s°l9RmiRakl",
"receleurs" => "R°s°l9R",
"receleuse" => "R°s°l2z",
"receleuses" => "R°s°l2z",
"recelons" => "R°s°l§",
"récemment" => "Resam@",
"recensa" => "R°s@sa",
"recensais" => "R°s@sE",
"recensait" => "R°s@sE",
"recensâmes" => "R°s@sam",
"recensant" => "R2s@s@",
"recense" => "R°s@s",
"recensé" => "R°s@se",
"recensées" => "R°s@se",
"recensement" => "R°s@s°m@",
"recensements" => "R°s@s°m@",
"recensent" => "R°s@s",
"recenser" => "R°s@se",
"recensèrent" => "R°s@sER",
"recensés" => "R°s@se",
"recenseur" => "R°s@s9R",
"recension" => "R°s@sj§",
"récent" => "Res@",
"récente" => "Res@t",
"récentes" => "Res@t",
"recentrage" => "R°s@tRaZ",
"recentre" => "R°s@tR",
"recentré" => "R°s@tRe",
"recentrée" => "R°s@tRe",
"recentrer" => "R°s@tRe",
"recentrons" => "R°s@tR§",
"récents" => "Res@",
"recépages" => "R°sepaZ",
"récépissé" => "Resepise",
"réceptacle" => "ResEptakl",
"réceptacles" => "ResEptakl",
"récepteur" => "ResEpt9R",
"récepteurs" => "ResEpt9R",
"réceptif" => "ResEptif",
"réceptifs" => "ResEptif",
"réception" => "ResEpsj§",
"réceptionna" => "ResEpsjona",
"réceptionnant" => "ResEpsjon@",
"réceptionne" => "ResEpsjOn",
"réceptionné" => "ResEpsjone",
"réceptionnées" => "ResEpsjone",
"réceptionnent" => "ResEpsjOn",
"réceptionner" => "ResEpsjone",
"réceptionnera" => "ResEpsjOn°Ra",
"réceptionniste" => "ResEpsjonist",
"réceptionnistes" => "ResEpsjonist",
"réceptions" => "ResEpsj§",
"réceptive" => "ResEptiv",
"réceptives" => "ResEptiv",
"réceptivité" => "ResEptivite",
"réceptrice" => "ResEptRis",
"recès" => "R°sE",
"récessif" => "Resesif",
"récessifs" => "Resesif",
"récession" => "Resesj§",
"récessive" => "Resesiv",
"recette" => "R°sEt",
"recettes" => "R°sEt",
"recevabilité" => "R2s2vabilite",
"recevable" => "R°s°vabl",
"recevables" => "R°s°vabl",
"recevaient" => "R°s°vE",
"recevais" => "R°s°vE",
"recevait" => "R°s°vE",
"recevant" => "R°s°v@",
"receveur" => "R°s°v9R",
"receveurs" => "R°s°v9R",
"receveuse" => "R°s°v2z",
"receveuses" => "R°s°v2z",
"recevez" => "R°s°ve",
"receviez" => "R°s°vje",
"recevions" => "R°s°vj§",
"recevoir" => "R°s°vwaR",
"recevons" => "R°s°v§",
"recevra" => "R°s°vRa",
"recevrai" => "R°s°vRE",
"recevraient" => "R°s°vRE",
"recevrais" => "R°s°vRE",
"recevrait" => "R°s°vRE",
"recevras" => "R°s°vRa",
"recevrez" => "R°s°vRe",
"recevriez" => "R°s°vRije",
"recevrions" => "R°s°vRij§",
"recevrons" => "R°s°vR§",
"recevront" => "R°s°vR§",
"rechampi" => "R°S@pi",
"rechampis" => "R°S@pi",
"rechampit" => "R°S@pi",
"rechange" => "R°S@Z",
"rechangé" => "R°S@Ze",
"rechanger" => "R2S@Ze",
"rechanges" => "R°S@Z",
"rechanta" => "R°S@ta",
"rechanté" => "R°S@te",
"rechanter" => "R°S@te",
"rechaper" => "R°Sape",
"réchappai" => "ReSapE",
"réchappais" => "ReSapE",
"réchappait" => "ReSapE",
"réchappe" => "ReSap",
"réchappé" => "ReSape",
"réchappent" => "ReSap",
"réchapper" => "ReSape",
"réchappera" => "ReSap°Ra",
"réchapperaient" => "ReSap°RE",
"réchapperais" => "ReSap°RE",
"réchapperait" => "ReSap°RE",
"réchappes" => "ReSap",
"réchappés" => "ReSape",
"réchappez" => "ReSape",
"réchappons" => "ReSap§",
"recharge" => "R°SaRZ",
"rechargé" => "R°SaRZe",
"rechargea" => "R°SaRZa",
"rechargeable" => "R°SaRZabl",
"rechargeaient" => "R°SaRZE",
"rechargeais" => "R°SaRZE",
"rechargeait" => "R°SaRZE",
"rechargeant" => "R°SaRZ@",
"rechargée" => "R°SaRZe",
"rechargées" => "R°SaRZe",
"rechargement" => "R°SaRZ°m@",
"rechargent" => "R°SaRZ",
"recharger" => "R°SaRZe",
"rechargerai" => "R°SaRZ°RE",
"rechargerait" => "R°SaRZ°RE",
"rechargerons" => "R°SaRZ°R§",
"recharges" => "R°SaRZ",
"rechargés" => "R°SaRZe",
"rechargez" => "R°SaRZe",
"rechasser" => "R°Sase",
"réchaud" => "ReSo",
"réchauds" => "ReSo",
"réchauffa" => "ReSofa",
"réchauffage" => "ReSofaZ",
"réchauffai" => "ReSofE",
"réchauffaient" => "ReSofE",
"réchauffais" => "ReSofE",
"réchauffait" => "ReSofE",
"réchauffant" => "ReSof@",
"réchauffante" => "ReSof@t",
"réchauffantes" => "ReSof@t",
"réchauffants" => "ReSof@",
"réchauffât" => "ReSofa",
"réchauffe" => "ReSof",
"réchauffé" => "ReSofe",
"réchauffée" => "ReSofe",
"réchauffées" => "ReSofe",
"réchauffement" => "ReSofm@",
"réchauffent" => "ReSof",
"réchauffer" => "ReSofe",
"réchauffera" => "ReSof°Ra",
"réchaufferai" => "ReSof°RE",
"réchaufferait" => "ReSof°RE",
"réchaufferas" => "ReSof°Ra",
"réchauffèrent" => "ReSofER",
"réchaufferez" => "ReSof°Re",
"réchaufferont" => "ReSof°R§",
"réchauffés" => "ReSofe",
"réchauffeur" => "ReSof9R",
"réchauffez" => "ReSofe",
"réchauffions" => "ReSofj§",
"réchauffons" => "ReSof§",
"rechaussaient" => "R°SosE",
"rechaussant" => "R°Sos@",
"rechaussée" => "R°Sose",
"rechausser" => "R°Sose",
"rechausserait" => "R°Sos°RE",
"rêche" => "RES",
"rechercha" => "R°SERSa",
"recherchai" => "R°SERSE",
"recherchaient" => "R°SERSE",
"recherchais" => "R°SERSE",
"recherchait" => "R°SERSE",
"recherchant" => "R°SERS@",
"recherche" => "R°SERS",
"recherché" => "R°SERSe",
"recherchée" => "R°SERSe",
"recherchées" => "R°SERSe",
"recherchent" => "R°SERS",
"rechercher" => "R°SERSe",
"recherchera" => "R°SERS°Ra",
"rechercherai" => "R°SERS°RE",
"rechercherais" => "R°SERS°RE",
"rechercherait" => "R°SERS°RE",
"rechercherions" => "R°SERS°Rj§",
"rechercherons" => "R°SERS°R§",
"rechercheront" => "R°SERS°R§",
"recherches" => "R°SERS",
"recherchés" => "R°SERSe",
"recherchez" => "R°SERSe",
"recherchiez" => "R°SERSje",
"recherchions" => "R°SERSj§",
"recherchiste" => "R2SERSist",
"recherchons" => "R°SERS§",
"rêches" => "RES",
"rechigna" => "R°SiNa",
"rechignaient" => "R°SiNE",
"rechignais" => "R°SiNE",
"rechignait" => "R°SiNE",
"rechignant" => "R°SiN@",
"rechigne" => "R°SiN",
"rechigné" => "R°SiNe",
"rechignée" => "R°SiNe",
"rechignées" => "R°SiNe",
"rechignent" => "R°SiN",
"rechigner" => "R°SiNe",
"rechignerais" => "R°SiN°RE",
"rechignes" => "R°SiN",
"rechuta" => "R°Syta",
"rechutant" => "R°Syt@",
"rechute" => "R°Syt",
"rechuté" => "R°Syte",
"rechuter" => "R°Syte",
"rechutera" => "R°Syt°Ra",
"rechuterait" => "R°Syt°RE",
"rechuteront" => "R°Syt°R§",
"rechutes" => "R°Syt",
"récidivai" => "ResidivE",
"récidivaient" => "ResidivE",
"récidivant" => "Residiv@",
"récidivante" => "Residiv@t",
"récidive" => "Residiv",
"récidivé" => "Residive",
"récidiver" => "Residive",
"récidiveras" => "Residiv°Ra",
"récidives" => "Residiv",
"récidivez" => "Residive",
"récidiviste" => "Residivist",
"récidivistes" => "Residivist",
"récif" => "Resif",
"récifale" => "Resifal",
"récifs" => "Resif",
"récipiendaire" => "Resipj@dER",
"récipiendaires" => "Resipj@dER",
"récipient" => "Resipj@",
"récipients" => "Resipj@",
"réciprocité" => "ResipRosite",
"réciproque" => "ResipROk",
"réciproquement" => "ResipROk°m@",
"réciproques" => "ResipROk",
"récit" => "Resi",
"récita" => "Resita",
"récitai" => "ResitE",
"récitaient" => "ResitE",
"récitais" => "ResitE",
"récitait" => "ResitE",
"récital" => "Resital",
"récitals" => "Resital",
"récitant" => "Resit@",
"récitante" => "Resit@t",
"récitants" => "Resit@",
"récitassent" => "Resitas",
"récitatif" => "Resitatif",
"récitatifs" => "Resitatif",
"récitation" => "Resitasj§",
"récitations" => "Resitasj§",
"récite" => "Resit",
"récité" => "Resite",
"récitée" => "Resite",
"récitées" => "Resite",
"récitent" => "Resit",
"réciter" => "Resite",
"récitera" => "Resit°Ra",
"réciterai" => "Resit°RE",
"réciteraient" => "Resit°RE",
"réciterait" => "Resit°RE",
"réciteras" => "Resit°Ra",
"récitèrent" => "ResitER",
"réciterez" => "Resit°Re",
"réciterons" => "Resit°R§",
"réciteront" => "Resit°R§",
"récites" => "Resit",
"récités" => "Resite",
"récitez" => "Resite",
"récitions" => "Resitj§",
"récitons" => "Resit§",
"récits" => "Resi",
"réclama" => "Reklama",
"réclamai" => "ReklamE",
"réclamaient" => "ReklamE",
"réclamais" => "ReklamE",
"réclamait" => "ReklamE",
"réclamant" => "Reklam@",
"réclamantes" => "Reklam@t",
"réclamation" => "Reklamasj§",
"réclamations" => "Reklamasj§",
"réclame" => "Reklam",
"réclamé" => "Reklame",
"réclamée" => "Reklame",
"réclamées" => "Reklame",
"réclament" => "Reklam",
"réclamer" => "Reklame",
"réclamera" => "Reklam°Ra",
"réclamerai" => "Reklam°RE",
"réclameraient" => "Reklam°RE",
"réclamerais" => "Reklam°RE",
"réclamerait" => "Reklam°RE",
"réclameras" => "Reklam°Ra",
"réclamèrent" => "ReklamER",
"réclamerez" => "Reklam°Re",
"réclameriez" => "Reklam°Rje",
"réclamerons" => "Reklam°R§",
"réclameront" => "Reklam°R§",
"réclames" => "Reklam",
"réclamés" => "Reklame",
"réclamez" => "Reklame",
"réclamiez" => "Reklamje",
"réclamions" => "Reklamj§",
"réclamons" => "Reklam§",
"reclassé" => "R°klase",
"reclassée" => "R°klase",
"reclassement" => "R°klas°m@",
"reclasser" => "R°klase",
"reclouer" => "R2klue",
"reclure" => "R°klyR",
"reclus" => "R°kly",
"recluse" => "R°klyz",
"recluses" => "R°klyz",
"réclusion" => "Reklyzj§",
"réclusionnaires" => "ReklyzjonER",
"réclusions" => "Reklyzj§",
"recodage" => "R°kodaZ",
"recogner" => "R2kONe",
"recognition" => "R°kOgnisj§",
"recoiffa" => "R°kwafa",
"recoiffai" => "R°kwafE",
"recoiffaient" => "R°kwafE",
"recoiffait" => "R°kwafE",
"recoiffant" => "R°kwaf@",
"recoiffe" => "R°kwaf",
"recoiffé" => "R°kwafe",
"recoiffée" => "R°kwafe",
"recoiffent" => "R°kwaf",
"recoiffer" => "R°kwafe",
"recoiffèrent" => "R°kwafER",
"recoiffés" => "R°kwafe",
"recoiffez" => "R°kwafe",
"recoin" => "R°kw5",
"recoins" => "R°kw5",
"reçois" => "R°swa",
"reçoit" => "R°swa",
"reçoive" => "R°swav",
"reçoivent" => "R°swav",
"reçoives" => "R°swav",
"recolla" => "R°kola",
"recollage" => "R°kolaZ",
"recollait" => "R°kolE",
"recolle" => "R°kOl",
"recollé" => "R°kole",
"recollée" => "R°kole",
"recollent" => "R°kOl",
"recoller" => "R°kole",
"recollera" => "R°kOl°Ra",
"recollés" => "R°kole",
"récollet" => "RekolE",
"récollets" => "RekolE",
"recoloration" => "R2kOlORasj§",
"récolta" => "RekOlta",
"récoltable" => "RekOltabl",
"récoltai" => "RekOltE",
"récoltaient" => "RekOltE",
"récoltais" => "RekOltE",
"récoltait" => "RekOltE",
"récoltant" => "RekOlt@",
"récolte" => "RekOlt",
"récolté" => "RekOlte",
"récoltée" => "RekOlte",
"récoltées" => "RekOlte",
"récoltent" => "RekOlt",
"récolter" => "RekOlte",
"récoltera" => "RekOlt°Ra",
"récolterai" => "RekOlt°RE",
"récolteraient" => "RekOlt°RE",
"récolterais" => "RekOlt°RE",
"récolterait" => "RekOlt°RE",
"récolteras" => "RekOlt°Ra",
"récolterons" => "RekOlt°R§",
"récolteront" => "RekOlt°R§",
"récoltes" => "RekOlt",
"récoltés" => "RekOlte",
"récolteurs" => "RekOlt9R",
"récolteuse" => "RekOlt2z",
"récoltez" => "RekOlte",
"récoltions" => "RekOltj§",
"récoltons" => "RekOlt§",
"recombinaison" => "R°k§binEz§",
"recombinant" => "R2k§bin@",
"recombiné" => "R2k§bine",
"recombiner" => "R2k§bine",
"recommanda" => "R°kom@da",
"recommandable" => "R°kom@dabl",
"recommandables" => "R°kom@dabl",
"recommandai" => "R°kom@dE",
"recommandaient" => "R°kom@dE",
"recommandais" => "R°kom@dE",
"recommandait" => "R°kom@dE",
"recommandant" => "R°kom@d@",
"recommandât" => "R°kom@da",
"recommandation" => "R°kom@dasj§",
"recommandations" => "R°kom@dasj§",
"recommande" => "R°kom@d",
"recommandé" => "R°kom@de",
"recommandée" => "R°kom@de",
"recommandées" => "R°kom@de",
"recommandent" => "R°kom@d",
"recommander" => "R°kom@de",
"recommandera" => "R°kom@d°Ra",
"recommanderai" => "R°kom@d°RE",
"recommanderais" => "R°kom@d°RE",
"recommanderait" => "R°kom@d°RE",
"recommandèrent" => "R°kom@dER",
"recommanderiez" => "R°kom@d°Rje",
"recommandes" => "R°kom@d",
"recommandés" => "R°kom@de",
"recommandez" => "R°kom@de",
"recommandiez" => "R°kom@dje",
"recommandons" => "R°kom@d§",
"recommença" => "R°kom@sa",
"recommençai" => "R°kom@sE",
"recommençaient" => "R°kom@sE",
"recommençais" => "R°kom@sE",
"recommençait" => "R°kom@sE",
"recommençâmes" => "R°kom@sam",
"recommençant" => "R°kom@s@",
"recommençât" => "R°kom@sa",
"recommence" => "R°kom@s",
"recommencé" => "R°kom@se",
"recommencée" => "R°kom@se",
"recommencées" => "R°kom@se",
"recommencement" => "R°kom@s°m@",
"recommencements" => "R°kom@s°m@",
"recommencent" => "R°kom@s",
"recommencer" => "R°kom@se",
"recommencera" => "R°kom@s°Ra",
"recommencerai" => "R°kom@s°RE",
"recommenceraient" => "R°kom@s°RE",
"recommencerais" => "R°kom@s°RE",
"recommencerait" => "R°kom@s°RE",
"recommenceras" => "R°kom@s°Ra",
"recommencèrent" => "R°kom@sER",
"recommencerez" => "R°kom@s°Re",
"recommenceriez" => "R°kom@s°Rje",
"recommencerions" => "R°kom@s°Rj§",
"recommencerons" => "R°kom@s°R§",
"recommenceront" => "R°kom@s°R§",
"recommences" => "R°kom@s",
"recommencés" => "R°kom@se",
"recommencez" => "R°kom@se",
"recommenciez" => "R°kom@sje",
"recommencions" => "R°kom@sj§",
"recommençons" => "R°kom@s§",
"recommercer" => "R2kOmERse",
"récompensa" => "Rek§p@sa",
"récompensaient" => "Rek§p@sE",
"récompensait" => "Rek§p@sE",
"récompensant" => "Rek§p@s@",
"récompense" => "Rek§p@s",
"récompensé" => "Rek§p@se",
"récompensée" => "Rek§p@se",
"récompensées" => "Rek§p@se",
"récompensent" => "Rek§p@s",
"récompenser" => "Rek§p@se",
"récompensera" => "Rek§p@s°Ra",
"récompenserai" => "Rek§p@s°RE",
"récompenserais" => "Rek§p@s°RE",
"récompensèrent" => "Rek§p@sER",
"récompenserons" => "Rek§p@s°R§",
"récompenseront" => "Rek§p@s°R§",
"récompenses" => "Rek§p@s",
"récompensés" => "Rek§p@se",
"récompensez" => "Rek§p@se",
"récompensons" => "Rek§p@s§",
"recomplété" => "R2k§plete",
"recompléter" => "R2k§plete",
"recomposa" => "R°k§poza",
"recomposaient" => "R°k§pozE",
"recomposais" => "R°k§pozE",
"recomposait" => "R°k§pozE",
"recompose" => "R°k§poz",
"recomposé" => "R°k§poze",
"recomposée" => "R2k§poze",
"recomposent" => "R°k§poz",
"recomposer" => "R°k§poze",
"recomposera" => "R°k§poz°Ra",
"recomposèrent" => "R°k§pozER",
"recomposés" => "R°k§poze",
"recomposition" => "R°k§pozisj§",
"recompta" => "R°k§ta",
"recomptaient" => "R°k§tE",
"recomptais" => "R°k§tE",
"recomptait" => "R°k§tE",
"recomptant" => "R°k§t@",
"recompte" => "R°k§t",
"recompté" => "R°k§te",
"recomptées" => "R°k§te",
"recompter" => "R°k§te",
"recomptez" => "R°k§te",
"recomptons" => "R°k§t§",
"réconcilia" => "Rek§silja",
"réconciliaient" => "Rek§siljE",
"réconciliait" => "Rek§siljE",
"réconciliâmes" => "Rek§siljam",
"réconciliant" => "Rek§silj@",
"réconciliateur" => "Rek§siljat9R",
"réconciliation" => "Rek§siljasj§",
"réconciliations" => "Rek§siljasj§",
"réconciliatrice" => "Rek§siljatRis",
"réconcilie" => "Rek§sili",
"réconcilié" => "Rek§silje",
"réconciliée" => "Rek§silje",
"réconciliées" => "Rek§silje",
"réconcilient" => "Rek§sili",
"réconcilier" => "Rek§silje",
"réconciliera" => "Rek§siliRa",
"réconcilierai" => "Rek§siljeRE",
"réconcilieraient" => "Rek§siljeRE",
"réconcilierait" => "Rek§siljeRE",
"réconcilierez" => "Rek§siliRe",
"réconciliés" => "Rek§silje",
"réconciliez" => "Rek§silje",
"réconciliions" => "Rek§silijj§",
"réconcilions" => "Rek§silj§",
"reconditionne" => "R°k§disjOn",
"reconditionné" => "R°k§disjone",
"reconditionnée" => "R°k§disjone",
"reconditionnement" => "R°k§disjOn°m@",
"reconditionnons" => "R°k§disjon§",
"reconductible" => "R°k§dyktibl",
"reconduction" => "R°k§dyksj§",
"reconduirai" => "R°k§d8iRE",
"reconduirais" => "R°k§d8iRE",
"reconduirait" => "R°k§d8iRE",
"reconduire" => "R°k§d8iR",
"reconduirez" => "R°k§d8iRe",
"reconduirons" => "R°k§d8iR§",
"reconduis" => "R°k§d8i",
"reconduisaient" => "R°k§d8izE",
"reconduisais" => "R°k§d8izE",
"reconduisait" => "R°k§d8izE",
"reconduisant" => "R°k§d8iz@",
"reconduise" => "R°k§d8iz",
"reconduisent" => "R°k§d8iz",
"reconduisez" => "R°k§d8ize",
"reconduisions" => "R°k§d8izj§",
"reconduisirent" => "R°k§d8iziR",
"reconduisit" => "R°k§d8izi",
"reconduisît" => "R°k§d8izi",
"reconduit" => "R°k§d8i",
"reconduite" => "R°k§d8it",
"reconduits" => "R°k§d8i",
"reconfiguration" => "R°k§figyRasj§",
"reconfigure" => "R°k§figyR",
"reconfiguré" => "R°k§figyRe",
"reconfigurer" => "R°k§figyRe",
"reconfigurés" => "R°k§figyRe",
"reconfigurez" => "R°k§figyRe",
"réconfort" => "Rek§fOR",
"réconforta" => "Rek§fORta",
"réconfortaient" => "Rek§fORtE",
"réconfortait" => "Rek§fORtE",
"réconfortant" => "Rek§fORt@",
"réconfortante" => "Rek§fORt@t",
"réconfortantes" => "Rek§fORt@t",
"réconfortants" => "Rek§fORt@",
"réconforte" => "Rek§fORt",
"réconforté" => "Rek§fORte",
"réconfortée" => "Rek§fORte",
"réconfortent" => "Rek§fORt",
"réconforter" => "Rek§fORte",
"réconfortera" => "Rek§fORt°Ra",
"réconforterai" => "Rek§fORt°RE",
"réconforterait" => "Rek§fORt°RE",
"réconforteras" => "Rek§fORt°Ra",
"réconforterez" => "Rek§fORt°Re",
"réconfortés" => "Rek§fORte",
"réconfortez" => "Rek§fORte",
"réconforts" => "Rek§fOR",
"recongeler" => "R°k§Z°le",
"reconnais" => "R°konE",
"reconnaissable" => "R°konEsabl",
"reconnaissables" => "R°konEsabl",
"reconnaissaient" => "R°konEsE",
"reconnaissais" => "R°konEsE",
"reconnaissait" => "R°konEsE",
"reconnaissance" => "R°konEs@s",
"reconnaissances" => "R°konEs@s",
"reconnaissant" => "R°konEs@",
"reconnaissante" => "R°konEs@t",
"reconnaissantes" => "R°konEs@t",
"reconnaissants" => "R°konEs@",
"reconnaisse" => "R°konEs",
"reconnaissent" => "R°konEs",
"reconnaisses" => "R°konEs",
"reconnaissez" => "R°konEse",
"reconnaissiez" => "R°konEsje",
"reconnaissions" => "R°konEsj§",
"reconnaissons" => "R°konEs§",
"reconnaît" => "R°konE",
"reconnaîtra" => "R°konEtRa",
"reconnaîtrai" => "R°konEtRE",
"reconnaîtraient" => "R°konEtRE",
"reconnaîtrais" => "R°konEtRE",
"reconnaîtrait" => "R°konEtRE",
"reconnaîtras" => "R°konEtRa",
"reconnaître" => "R°konEtR",
"reconnaîtrez" => "R°konEtRe",
"reconnaîtriez" => "R°konEtRije",
"reconnaîtrions" => "R°konEtRij§",
"reconnaîtrons" => "R°konEtR§",
"reconnaîtront" => "R°konEtR§",
"reconnecte" => "R°konEkt",
"reconnecté" => "R°konEkte",
"reconnecter" => "R°konEkte",
"reconnectés" => "R°konEkte",
"reconnectez" => "R°konEkte",
"reconnu" => "R°kony",
"reconnue" => "R°kony",
"reconnues" => "R°kony",
"reconnûmes" => "R°konym",
"reconnurent" => "R°konyR",
"reconnus" => "R°kony",
"reconnusse" => "R°konys",
"reconnussent" => "R°konys",
"reconnut" => "R°kony",
"reconnût" => "R°kony",
"reconquérais" => "R°k§keRE",
"reconquérait" => "R°k§keRE",
"reconquérir" => "R°k§keRiR",
"reconquérons" => "R°k§keR§",
"reconquerra" => "R°k§kERa",
"reconquerrait" => "R°k§kERE",
"reconquerrons" => "R°k§kERR§",
"reconquête" => "R°k§kEt",
"reconquière" => "R°k§kjER",
"reconquiert" => "R°k§kjER",
"reconquirent" => "R°k§kiR",
"reconquis" => "R°k§ki",
"reconquise" => "R°k§kiz",
"reconquises" => "R°k§kiz",
"reconquista" => "R2k§kista",
"reconquit" => "R°k§ki",
"reconsidéra" => "R°k§sideRa",
"reconsidérant" => "R°k§sideR@",
"reconsidère" => "R°k§sidER",
"reconsidéré" => "R°k§sideRe",
"reconsidérée" => "R°k§sideRe",
"reconsidèrent" => "R°k§sidER",
"reconsidérer" => "R°k§sideRe",
"reconsidérez" => "R°k§sideRe",
"reconstitua" => "R°k§stit8a",
"reconstituaient" => "R°k§stit8E",
"reconstituais" => "R°k§stit8E",
"reconstituait" => "R°k§stit8E",
"reconstituâmes" => "R°k§stit8am",
"reconstituant" => "R°k§stit8@",
"reconstituante" => "R°k§stit8@t",
"reconstituantes" => "R°k§stit8@t",
"reconstituants" => "R°k§stit8@",
"reconstituât" => "R°k§stit8a",
"reconstitue" => "R°k§stity",
"reconstitué" => "R°k§stit8e",
"reconstituée" => "R°k§stit8e",
"reconstituées" => "R°k§stit8e",
"reconstituent" => "R°k§stity",
"reconstituer" => "R°k§stit8e",
"reconstitueraient" => "R°k§stityRE",
"reconstituerais" => "R°k§stityRE",
"reconstituerait" => "R°k§stityRE",
"reconstituerons" => "R°k§stityR§",
"reconstitues" => "R°k§stity",
"reconstitués" => "R°k§stit8e",
"reconstituons" => "R°k§stity§",
"reconstitution" => "R°k§stitysj§",
"reconstitutions" => "R°k§stitysj§",
"reconstructeur" => "R2k§stRykt9R",
"reconstruction" => "R°k§stRyksj§",
"reconstructions" => "R°k§stRyksj§",
"reconstructrice" => "R°k§stRyktRis",
"reconstruira" => "R°k§stR8iRa",
"reconstruirai" => "R°k§stR8iRE",
"reconstruirais" => "R°k§stR8iRE",
"reconstruirait" => "R°k§stR8iRE",
"reconstruiras" => "R°k§stR8iRa",
"reconstruire" => "R°k§stR8iR",
"reconstruirons" => "R°k§stR8iR§",
"reconstruiront" => "R°k§stR8iR§",
"reconstruis" => "R°k§stR8i",
"reconstruisaient" => "R°k§stR8izE",
"reconstruisait" => "R°k§stR8izE",
"reconstruisant" => "R°k§stR8iz@",
"reconstruisent" => "R°k§stR8iz",
"reconstruisez" => "R°k§stR8ize",
"reconstruisirent" => "R°k§stR8iziR",
"reconstruisons" => "R°k§stR8iz§",
"reconstruit" => "R°k§stR8i",
"reconstruite" => "R°k§stR8it",
"reconstruites" => "R°k§stR8it",
"reconstruits" => "R°k§stR8i",
"reconsulter" => "R2k§sylte",
"recontacter" => "R2k§takte",
"reconter" => "R2k§te",
"recontrer" => "R2k§tRe",
"reconventionnelle" => "R°k§v@sjonEl",
"reconversion" => "R°k§vERsj§",
"reconverti" => "R°k§vERti",
"reconvertie" => "R°k§vERti",
"reconvertir" => "R°k§vERtiR",
"reconvertirent" => "R°k§vERtiR",
"reconvertis" => "R°k§vERti",
"reconvertissant" => "R°k§vERtis@",
"reconvertisse" => "R°k§vERtis",
"reconvertit" => "R°k§vERti",
"reconvoquer" => "R2k§vOke",
"recopia" => "R°kopja",
"recopiage" => "R°kopjaZ",
"recopiai" => "R°kopjE",
"recopiaient" => "R°kopjE",
"recopiais" => "R°kopjE",
"recopiait" => "R°kopjE",
"recopiant" => "R°kopj@",
"recopiât" => "R°kopja",
"recopie" => "R°kopi",
"recopié" => "R°kopje",
"recopiée" => "R°kopje",
"recopiées" => "R°kopje",
"recopient" => "R°kopi",
"recopier" => "R°kopje",
"recopierai" => "R°kopiRE",
"recopierait" => "R°kopijRE",
"recopies" => "R°kopi",
"recopiés" => "R°kopje",
"recopiez" => "R°kopje",
"record" => "R°kOR",
"recorder" => "R2kORde",
"recordman" => "R°kORdman",
"recordmen" => "R°kORdmEn",
"records" => "R°kOR",
"recors" => "R°kOR",
"recoucha" => "R°kuSa",
"recouchai" => "R°kuSE",
"recouchais" => "R°kuSE",
"recouchait" => "R°kuSE",
"recouchant" => "R°kuS@",
"recouche" => "R°kuS",
"recouché" => "R°kuSe",
"recouchée" => "R°kuSe",
"recouchées" => "R°kuSe",
"recoucher" => "R°kuSe",
"recoucherais" => "R°kuS°RE",
"recouchèrent" => "R°kuSER",
"recoucheriez" => "R°kuS°Rje",
"recouchés" => "R°kuSe",
"recouchez" => "R°kuSe",
"recoud" => "R°ku",
"recoudra" => "R°kudRa",
"recoudrai" => "R°kudRE",
"recoudras" => "R°kudRa",
"recoudre" => "R°kudR",
"recouds" => "R°ku",
"recouler" => "R°kule",
"recoupa" => "R°kupa",
"recoupaient" => "R°kupE",
"recoupait" => "R°kupE",
"recoupant" => "R°kup@",
"recoupe" => "R°kup",
"recoupé" => "R°kupe",
"recoupement" => "R°kup°m@",
"recoupements" => "R°kup°m@",
"recoupent" => "R°kup",
"recouper" => "R°kupe",
"recouperait" => "R°kup°RE",
"recouperont" => "R°kup°R§",
"recoupés" => "R°kupe",
"recoupez" => "R°kupe",
"recoupions" => "R°kupj§",
"recourait" => "R°kuRE",
"recourant" => "R°kuR@",
"recourba" => "R°kuRba",
"recourbaient" => "R°kuRbE",
"recourbait" => "R°kuRbE",
"recourbant" => "R°kuRb@",
"recourbe" => "R°kuRb",
"recourbé" => "R°kuRbe",
"recourbée" => "R°kuRbe",
"recourbées" => "R°kuRbe",
"recourber" => "R°kuRbe",
"recourbés" => "R°kuRbe",
"recoure" => "R°kuR",
"recourent" => "R°kuR",
"recourez" => "R°kuRe",
"recourir" => "R°kuRiR",
"recourons" => "R°kuR§",
"recourrait" => "R°kuRE",
"recours" => "R°kuR",
"recourt" => "R°kuR",
"recouru" => "R°kuRy",
"recoururent" => "R°kuRyR",
"recourus" => "R°kuRy",
"recourut" => "R°kuRy",
"recousais" => "R°kuzE",
"recousait" => "R°kuzE",
"recousant" => "R°kuz@",
"recouse" => "R°kuz",
"recousez" => "R°kuze",
"recousu" => "R°kuzy",
"recousue" => "R°kuzy",
"recousus" => "R°kuzy",
"recouvert" => "R°kuvER",
"recouverte" => "R°kuvERt",
"recouvertes" => "R°kuvERt",
"recouverts" => "R°kuvER",
"recouvra" => "R°kuvRa",
"recouvrables" => "R°kuvRabl",
"recouvrai" => "R°kuvRE",
"recouvraient" => "R°kuvRE",
"recouvrais" => "R°kuvRE",
"recouvrait" => "R°kuvRE",
"recouvrance" => "R°kuvR@s",
"recouvrant" => "R°kuvR@",
"recouvrât" => "R°kuvRa",
"recouvre" => "R°kuvR",
"recouvré" => "R°kuvRe",
"recouvrée" => "R°kuvRe",
"recouvrées" => "R°kuvRe",
"recouvrement" => "R°kuvR°m@",
"recouvrent" => "R°kuvR",
"recouvrer" => "R°kuvRe",
"recouvrerai" => "R°kuvR°RE",
"recouvrerait" => "R°kuvR°RE",
"recouvrerez" => "R°kuvR°Re",
"recouvreront" => "R°kuvR°R§",
"recouvrés" => "R°kuvRe",
"recouvrez" => "R°kuvRe",
"recouvriez" => "R°kuvRie",
"recouvrir" => "R°kuvRiR",
"recouvrira" => "R°kuvRiRa",
"recouvrirai" => "R°kuvRiRE",
"recouvriraient" => "R°kuvRiRE",
"recouvrirait" => "R°kuvRiRE",
"recouvrirent" => "R°kuvRiR",
"recouvris" => "R°kuvRi",
"recouvrissent" => "R°kuvRis",
"recouvrit" => "R°kuvRi",
"recouvrît" => "R°kuvRi",
"recouvrons" => "R°kuvR§",
"recracha" => "R°kRaSa",
"recrachaient" => "R°kRaSE",
"recrachais" => "R°kRaSE",
"recrachait" => "R°kRaSE",
"recrachant" => "R2kRaS@",
"recrache" => "R°kRaS",
"recraché" => "R°kRaSe",
"recrachée" => "R°kRaSe",
"recrachent" => "R°kRaS",
"recracher" => "R°kRaSe",
"recrachera" => "R°kRaS°Ra",
"recraches" => "R°kRaS",
"recrachez" => "R°kRaSe",
"récré" => "RekRe",
"recréa" => "R°kRea",
"recréaient" => "R°kReE",
"recréais" => "R°kReE",
"recréait" => "R°kReE",
"recréant" => "R°kRe@",
"récréatif" => "RekReatif",
"recréation" => "R°kReasj§",
"récréation" => "RekReasj§",
"récréations" => "RekReasj§",
"récréative" => "RekReativ",
"récréatives" => "RekReativ",
"recrée" => "R°kRe",
"récrée" => "RekRe",
"recréé" => "R°kRee",
"récréé" => "RekRee",
"recréée" => "R°kRee",
"recréées" => "R°kRee",
"recréent" => "R°kRe",
"recréer" => "R°kRee",
"récréer" => "R°kRee",
"recréerait" => "R°kReRE",
"recréés" => "R°kRee",
"recrépi" => "R°kRepi",
"recrépie" => "R°kRepi",
"recrépir" => "R°kRepiR",
"recrépis" => "R°kRepi",
"recrépit" => "R°kRepi",
"récrés" => "RekRe",
"recreuse" => "R°kR2z",
"recreuser" => "R°kR2ze",
"récri" => "RekRi",
"récria" => "RekRija",
"récriai" => "RekRijE",
"récriaient" => "RekRijE",
"récriait" => "RekRijE",
"récrie" => "RekRi",
"récrié" => "RekRije",
"récriée" => "RekRije",
"récriées" => "RekRije",
"récrient" => "RekRi",
"récrier" => "RekRie",
"récrièrent" => "RekRijER",
"récriés" => "RekRije",
"récriminait" => "RekRiminE",
"récrimination" => "RekRiminasj§",
"récriminations" => "RekRiminasj§",
"récriminer" => "RekRimine",
"récrirai" => "RekRiRE",
"récrire" => "RekRiR",
"récris" => "RekRi",
"récrit" => "RekRi",
"récrites" => "RekRit",
"récrivent" => "RekRiv",
"récrivit" => "RekRivi",
"recroisait" => "R°kRwazE",
"recroisant" => "R°kRwaz@",
"recroise" => "R°kRwaz",
"recroisé" => "R°kRwaze",
"recroiser" => "R°kRwaze",
"recroiseras" => "R°kRwaz°Ra",
"recroiserons" => "R°kRwaz°R§",
"recroisés" => "R°kRwaze",
"recroquevilla" => "R°kROkvija",
"recroquevillai" => "R°kROkvijE",
"recroquevillaient" => "R°kROkvijE",
"recroquevillais" => "R°kROkvijE",
"recroquevillait" => "R°kROkvijE",
"recroquevillant" => "R°kROkvij@",
"recroqueville" => "R°kROkvij",
"recroquevillé" => "R°kROkvije",
"recroquevillée" => "R°kROkvije",
"recroquevillées" => "R°kROkvije",
"recroquevillement" => "R2kROkvij°m@",
"recroquevillent" => "R°kROkvij",
"recroqueviller" => "R°kROkvje",
"recroquevillés" => "R°kROkvije",
"recroquevillions" => "R°kROkvijj§",
"recru" => "R2kRy",
"recrudescence" => "R°kRydes@s",
"recrudescente" => "R2kRydes@t",
"recrue" => "R°kRy",
"recrues" => "R°kRy",
"recrus" => "R°kRy",
"recruta" => "R°kRyta",
"recrutaient" => "R°kRytE",
"recrutais" => "R°kRytE",
"recrutait" => "R°kRytE",
"recrutant" => "R°kRyt@",
"recrute" => "R°kRyt",
"recruté" => "R°kRyte",
"recrutée" => "R°kRyte",
"recrutées" => "R°kRyte",
"recrutement" => "R°kRyt°m@",
"recrutent" => "R°kRyt",
"recruter" => "R°kRyte",
"recrutera" => "R°kRyt°Ra",
"recruterai" => "R°kRyt°RE",
"recruterez" => "R°kRyt°Re",
"recrutés" => "R°kRyte",
"recruteur" => "R°kRyt9R",
"recruteurs" => "R°kRyt9R",
"recrutez" => "R°kRyte",
"recrutiez" => "R°kRytje",
"recrutions" => "R°kRytj§",
"recrutons" => "R°kRyt§",
"recta" => "REkta",
"rectal" => "REktal",
"rectale" => "REktal",
"rectangle" => "REkt@gl",
"rectangles" => "REkt@gl",
"rectangulaire" => "REkt@gylER",
"rectangulaires" => "REkt@gylER",
"rectaux" => "REkto",
"recteur" => "REkt9R",
"recteurs" => "REkt9R",
"rectifia" => "REktifja",
"rectifiai" => "REktifjE",
"rectifiait" => "REktifjE",
"rectifiant" => "REktifj@",
"rectificatif" => "REktifikatif",
"rectification" => "REktifikasj§",
"rectifications" => "REktifikasj§",
"rectifie" => "REktifi",
"rectifié" => "REktifje",
"rectifiée" => "REktifje",
"rectifiées" => "REktifje",
"rectifient" => "REktifi",
"rectifier" => "REktifje",
"rectifiera" => "REktifiRa",
"rectifierai" => "REktifiRE",
"rectifièrent" => "REktifjER",
"rectifierez" => "REktifiRe",
"rectifies" => "REktifi",
"rectifiés" => "REktifje",
"rectifiez" => "REktifje",
"rectifions" => "REktifj§",
"rectiligne" => "REktiliN",
"rectilignes" => "REktiliN",
"rectilinéaire" => "REktilineER",
"rectitude" => "REktityd",
"recto" => "REkto",
"recto tono" => "REktotono",
"rectorat" => "REktoRa",
"rectos" => "REkto",
"rectrices" => "REktRis",
"rectum" => "REktOm",
"reçu" => "R°sy",
"reçue" => "R°sy",
"recueil" => "R°k9j",
"recueillaient" => "R°k9jE",
"recueillais" => "R°k9jE",
"recueillait" => "R°k9jE",
"recueillant" => "R°k9j@",
"recueille" => "R°k9j",
"recueillement" => "R°k9j°m@",
"recueillements" => "R°k9j°m@",
"recueillent" => "R°k9j",
"recueillera" => "R°k9j°Ra",
"recueillerai" => "R°k9j°RE",
"recueilleraient" => "R°k9j°RE",
"recueillerait" => "R°k9j°RE",
"recueilleront" => "R°k9j°R§",
"recueillez" => "R°k9je",
"recueilli" => "R°k9ji",
"recueillie" => "R°k9ji",
"recueillies" => "R°k9ji",
"recueillions" => "R°k9jj§",
"recueillir" => "R°k9jiR",
"recueillirent" => "R°k9jiR",
"recueillis" => "R°k9ji",
"recueillit" => "R°k9ji",
"recueillît" => "R°k9ji",
"recueillons" => "R°k9j§",
"recueils" => "R°k9j",
"reçues" => "R°sy",
"recuire" => "R°k8iR",
"recuisson" => "R2k8is§",
"recuit" => "R°k8i",
"recuite" => "R°k8it",
"recuites" => "R°k8it",
"recuits" => "R°k8i",
"recul" => "R°kyl",
"recula" => "R°kyla",
"reculade" => "R°kylad",
"reculades" => "R°kylad",
"reculai" => "R°kylE",
"reculaient" => "R°kylE",
"reculais" => "R°kylE",
"reculait" => "R°kylE",
"reculant" => "R°kyl@",
"reculât" => "R°kyla",
"recule" => "R°kyl",
"reculé" => "R°kyle",
"reculée" => "R°kyle",
"reculées" => "R°kyle",
"reculent" => "R°kyl",
"reculer" => "R°kyle",
"reculera" => "R°kyl°Ra",
"reculerai" => "R°kyl°RE",
"reculeraient" => "R°kyl°RE",
"reculerais" => "R°kyl°RE",
"reculerait" => "R°kyl°RE",
"reculeras" => "R°kyl°Ra",
"reculèrent" => "R°kylER",
"reculerons" => "R°kyl°R§",
"reculeront" => "R°kyl°R§",
"recules" => "R°kyl",
"reculés" => "R°kyle",
"reculez" => "R°kyle",
"reculons" => "R°kyl§",
"reculotta" => "R°kylota",
"reculotte" => "R°kylOt",
"reculotté" => "R°kylote",
"reculottée" => "R°kylote",
"reculotter" => "R°kylote",
"reculs" => "R°kyl",
"reçûmes" => "R°sym",
"récup" => "Rekyp",
"récupe" => "Rekyp",
"récupéra" => "RekypeRa",
"récupérable" => "RekypeRabl",
"récupérables" => "RekypeRabl",
"récupérai" => "RekypeRE",
"récupéraient" => "RekypeRE",
"récupérais" => "RekypeRE",
"récupérait" => "RekypeRE",
"récupérâmes" => "RekypeRam",
"récupérant" => "RekypeR@",
"récupérateur" => "RekypeRat9R",
"récupérateurs" => "RekypeRat9R",
"récupération" => "RekypeRasj§",
"récupérations" => "RekypeRasj§",
"récupère" => "RekypER",
"récupéré" => "RekypeRe",
"récupérée" => "RekypeRe",
"récupérées" => "RekypeRe",
"récupèrent" => "RekypER",
"récupérer" => "RekypeRe",
"récupérera" => "RekypeR°Ra",
"récupérerai" => "RekypeR°RE",
"récupérerais" => "RekypeR°RE",
"récupérerait" => "RekypeR°RE",
"récupéreras" => "RekypeR°Ra",
"récupérèrent" => "RekypeRER",
"récupérerez" => "RekypeR°Re",
"récupérerons" => "RekypeR°R§",
"récupéreront" => "RekypeR°R§",
"récupères" => "RekypER",
"récupérés" => "RekypeRe",
"récupérez" => "RekypeRe",
"récupériez" => "RekypeRje",
"récupérions" => "RekypeRj§",
"récupérons" => "RekypeR§",
"récurage" => "RekyRaZ",
"récuraient" => "RekyRE",
"récurais" => "RekyRE",
"récurait" => "RekyRE",
"récurant" => "RekyR@",
"récure" => "RekyR",
"récuré" => "RekyRe",
"récurée" => "RekyRe",
"récurées" => "RekyRe",
"récurent" => "RekyR",
"reçurent" => "R°syR",
"récurer" => "RekyRe",
"récurerai" => "RekyR°RE",
"récurés" => "RekyRe",
"récurrence" => "RekyR@s",
"récurrences" => "RekyR@s",
"récurrent" => "RekyR@",
"récurrente" => "RekyR@t",
"récurrentes" => "RekyR@t",
"récurrents" => "RekyR@",
"récursif" => "RekyRsif",
"reçus" => "R°sy",
"récusa" => "Rekyza",
"récusable" => "Rekyzabl",
"récusables" => "Rekyzabl",
"récusaient" => "RekyzE",
"récusais" => "RekyzE",
"récusait" => "RekyzE",
"récusant" => "Rekyz@",
"récusation" => "Rekyzasj§",
"récusations" => "Rekyzasj§",
"récuse" => "Rekyz",
"récusé" => "Rekyze",
"récusée" => "Rekyze",
"récuser" => "Rekyze",
"récuserait" => "Rekyz°RE",
"récusèrent" => "RekyzER",
"récuserons" => "Rekyz°R§",
"récusons" => "Rekyz§",
"reçut" => "R°sy",
"reçût" => "R°sy",
"recyclable" => "R°siklabl",
"recyclables" => "R°siklabl",
"recyclage" => "R°siklaZ",
"recyclaient" => "R°siklE",
"recyclait" => "R°siklE",
"recycle" => "R°sikl",
"recyclé" => "R°sikle",
"recyclée" => "R°sikle",
"recyclées" => "R°sikle",
"recyclent" => "R°sikl",
"recycler" => "R°sikle",
"recyclerai" => "R°sikl°RE",
"recyclés" => "R°sikle",
"recycleur" => "R°sikl9R",
"recyclez" => "R°sikle",
"recycliez" => "R°siklije",
"red river" => "REdRiv9R",
"rédacteur" => "Redakt9R",
"rédacteurs" => "Redakt9R",
"rédaction" => "Redaksj§",
"rédactionnel" => "RedaksjOnEl",
"rédactionnelle" => "RedaksjonEl",
"rédactions" => "Redaksj§",
"rédactrice" => "RedaktRis",
"rédactrices" => "RedaktRis",
"redan" => "R2d@",
"reddition" => "REdisj§",
"redéconner" => "R°dekone",
"redécoré" => "R2dekORe",
"redécoupage" => "R°dekupaZ",
"redécouvert" => "R°dekuvER",
"redécouverte" => "R°dekuvERt",
"redécouvertes" => "R°dekuvERt",
"redécouverts" => "R°dekuvER",
"redécouvraient" => "R°dekuvRE",
"redécouvrait" => "R°dekuvRE",
"redécouvrant" => "R°dekuvR@",
"redécouvre" => "R°dekuvR",
"redécouvrent" => "R°dekuvR",
"redécouvrions" => "R°dekuvRij§",
"redécouvrir" => "R°dekuvRiR",
"redécouvrira" => "R°dekuvRiRa",
"redécouvriront" => "R°dekuvRiR§",
"redécouvris" => "R°dekuvRi",
"redécouvrit" => "R°dekuvRi",
"redécouvrît" => "R°dekuvRi",
"redécouvrons" => "R°dekuvR§",
"redéfini" => "R°defini",
"redéfinir" => "R°definiR",
"redéfinis" => "R°defini",
"redéfinissons" => "R°definis§",
"redéfinition" => "R2definisj§",
"redégringoler" => "R2degR5gOle",
"redemanda" => "R°d°m@da",
"redemandai" => "R°d°m@dE",
"redemandaient" => "R°d°m@dE",
"redemandais" => "R°d°m@dE",
"redemandait" => "R°d°m@dE",
"redemandant" => "R°d°m@d@",
"redemande" => "R°d°m@d",
"redemandé" => "R°d°m@de",
"redemandent" => "R°d°m@d",
"redemander" => "R°d°m@de",
"redemanderai" => "R°d°m@d°RE",
"redemanderait" => "R°d°m@d°RE",
"redemanderas" => "R°d°m@d°Ra",
"redemanderez" => "R°d°m@d°Re",
"redemanderont" => "R°d°m@d°R§",
"redemandes" => "R°d°m@d",
"redemandez" => "R°d°m@de",
"redemandions" => "R°d°m@dj§",
"redémarra" => "R°demaRa",
"redémarrage" => "R°demaRaZ",
"redémarraient" => "R°demaRE",
"redémarrais" => "R°demaRE",
"redémarrait" => "R°demaRE",
"redémarrant" => "R°demaR@",
"redémarre" => "R°demaR",
"redémarré" => "R°demaRe",
"redémarrent" => "R°demaR",
"redémarrer" => "R°demaRe",
"redémarrera" => "R°demaR°Ra",
"redémarrerait" => "R°demaR°RE",
"redémarrez" => "R°demaRe",
"redémarrons" => "R°demaR§",
"redémolir" => "R2demOliR",
"rédempteur" => "Red@pt9R",
"rédemption" => "Red@psj§",
"rédemptions" => "Red@psj§",
"rédemptoriste" => "Red@ptORist",
"rédemptrice" => "Red@ptRis",
"redents" => "R°d@",
"redéploie" => "R°deplwa",
"redéploiement" => "R°deplwam@",
"redéployer" => "R°deplwaje",
"redéployez" => "R°deplwaje",
"redéposé" => "R°depoze",
"redéposer" => "R2depoze",
"redescend" => "R°dEs@",
"redescendaient" => "R°dEs@dE",
"redescendais" => "R°dEs@dE",
"redescendait" => "R°dEs@dE",
"redescendant" => "R°dEs@d@",
"redescende" => "R°dEs@d",
"redescendent" => "R°dEs@d",
"redescendes" => "R°dEs@d",
"redescendez" => "R°dEs@de",
"redescendiez" => "R°dEs@dje",
"redescendions" => "R°dEs@dj§",
"redescendirent" => "R°dEs@diR",
"redescendis" => "R°dEs@di",
"redescendit" => "R°dEs@di",
"redescendît" => "R°dEs@di",
"redescendons" => "R°dEs@d§",
"redescendra" => "R°dEs@dRa",
"redescendrai" => "R°dEs@dRE",
"redescendrais" => "R°dEs@dRE",
"redescendrait" => "R°dEs@dRE",
"redescendre" => "R°des@dR",
"redescendrons" => "R°dEs@dR§",
"redescendront" => "R°dEs@dR§",
"redescends" => "R°dEs@",
"redescendu" => "R°dEs@dy",
"redescendue" => "R°dEs@dy",
"redescendues" => "R°dEs@dy",
"redescendus" => "R°dEs@dy",
"redescente" => "R°des@t",
"redessina" => "R°dEsina",
"redessinaient" => "R°dEsinE",
"redessinait" => "R°dEsinE",
"redessine" => "R°dEsin",
"redessiné" => "R°dEsine",
"redessinée" => "R°dEsine",
"redessinent" => "R°dEsin",
"redessiner" => "R°dEsine",
"redevable" => "R°d°vabl",
"redevables" => "R°d°vabl",
"redevais" => "R°d°vE",
"redevait" => "R°d°vE",
"redevance" => "R°d°v@s",
"redevances" => "R°d°v@s",
"redevenaient" => "R°d°v°nE",
"redevenais" => "R°d°v°nE",
"redevenait" => "R°d°v°nE",
"redevenant" => "R°d°v°n@",
"redevenez" => "R°d°v°ne",
"redeveniez" => "R°d°v°nje",
"redevenir" => "R°d°v°niR",
"redevenons" => "R°d°v°n§",
"redevenu" => "R°d°v°ny",
"redevenue" => "R°d°v°ny",
"redevenues" => "R°d°v°ny",
"redevenus" => "R°d°v°ny",
"redeviendra" => "R°d°vj5dRa",
"redeviendrai" => "R°d°vj5dRE",
"redeviendraient" => "R°d°vj5dRE",
"redeviendrais" => "R°d°vj5dRE",
"redeviendrait" => "R°d°vj5dRE",
"redeviendras" => "R°d°vj5dRa",
"redeviendrez" => "R°d°vj5dRe",
"redeviendriez" => "R°d°vj5dRie",
"redeviendrons" => "R°d°vj5dR§",
"redeviendront" => "R°d°vj5dR§",
"redevienne" => "R°d°vjEn",
"redeviennent" => "R°d°vjEn",
"redeviennes" => "R°d°vjEn",
"redeviens" => "R°d°vj5",
"redevient" => "R°d°vj5",
"redevinrent" => "R°d°v5R",
"redevins" => "R°d°v5",
"redevint" => "R°d°v5",
"redevînt" => "R°d°v5",
"redevoir" => "R2d2vwaR",
"redevra" => "R°d°vRa",
"redevrez" => "R°d°vRe",
"rédhibition" => "Redibisj§",
"rédhibitoire" => "RedibitwaR",
"rédhibitoires" => "RedibitwaR",
"rediffusé" => "R2difyze",
"rediffusent" => "R°difyz",
"rediffuser" => "R°difyze",
"rediffuserons" => "R°difyz°R§",
"rediffusés" => "R°difyze",
"rediffusez" => "R°difyze",
"rediffusion" => "R°difyzj§",
"rediffusions" => "R°difyzj§",
"rédige" => "RediZ",
"rédigé" => "RediZe",
"rédigea" => "RediZa",
"rédigeai" => "RediZE",
"rédigeaient" => "RediZE",
"rédigeais" => "RediZE",
"rédigeait" => "RediZE",
"rédigeant" => "RediZ@",
"rédigée" => "RediZe",
"rédigées" => "RediZe",
"rédigent" => "RediZ",
"rédigeons" => "RediZ§",
"rédiger" => "RediZe",
"rédigera" => "RediZ°Ra",
"rédigerai" => "RediZ°RE",
"rédigerais" => "RediZ°RE",
"rédigeras" => "RediZ°Ra",
"rédigèrent" => "RediZER",
"rédigerez" => "RediZ°Re",
"rédiges" => "RediZ",
"rédigés" => "RediZe",
"rédigez" => "RediZe",
"rédigiez" => "RediZje",
"rédigions" => "RediZj§",
"rédimaient" => "RedimE",
"redimensionnées" => "R°dim@sjone",
"redimensionner" => "R2dim@sjOne",
"redingote" => "R°d5gOt",
"redingotes" => "R°d5gOt",
"redirai" => "R°diRE",
"redirais" => "R°diRE",
"redirait" => "R°diRE",
"redire" => "R°diR",
"redirez" => "R°diRe",
"rediriez" => "R°diRje",
"redirige" => "R°diRiZ",
"redirigé" => "R°diRiZe",
"rediriger" => "R°diRiZe",
"redis" => "R°di",
"redisais" => "R°dizE",
"redisait" => "R°dizE",
"redisant" => "R°diz@",
"rediscuter" => "R°diskyte",
"rediscutera" => "R°diskyt°Ra",
"rediscuterons" => "R°diskyt°R§",
"redise" => "R°diz",
"redisent" => "R°diz",
"redises" => "R°diz",
"redisposer" => "R2dispoze",
"redistribua" => "R°distRibya",
"redistribuais" => "R°distRib8E",
"redistribuait" => "R°distRib8E",
"redistribue" => "R°distRiby",
"redistribué" => "R°distRib8e",
"redistribuent" => "R°distRiby",
"redistribuer" => "R°distRib8e",
"redistribueras" => "R°distRibyRa",
"redistribués" => "R°distRib8e",
"redistribuons" => "R°distRiby§",
"redistribution" => "R°distRibysj§",
"redistributions" => "R°distRibysj§",
"redit" => "R°di",
"redite" => "R°dit",
"redites" => "R°dit",
"redits" => "R°di",
"redondance" => "R°d§d@s",
"redondances" => "R°d§d@s",
"redondant" => "R°d§d@",
"redondante" => "R°d§d@t",
"redondantes" => "R°d§d@t",
"redondants" => "R°d§d@",
"redonna" => "R°dona",
"redonnai" => "R°donE",
"redonnaient" => "R°donE",
"redonnais" => "R°donE",
"redonnait" => "R°donE",
"redonnant" => "R°don@",
"redonnât" => "R°dona",
"redonne" => "R°dOn",
"redonné" => "R°done",
"redonnent" => "R°dOn",
"redonner" => "R°done",
"redonnera" => "R°dOn°Ra",
"redonnerai" => "R°dOn°RE",
"redonneraient" => "R°dOn°RE",
"redonnerais" => "R°dOn°RE",
"redonnerait" => "R°dOn°RE",
"redonneras" => "R°dOn°Ra",
"redonnerons" => "R°dOn°R§",
"redonneront" => "R°dOn°R§",
"redonnes" => "R°dOn",
"redonnez" => "R°done",
"redonniez" => "R°donje",
"redonnons" => "R°don§",
"redoré" => "R°doRe",
"redorées" => "R°doRe",
"redorer" => "R°doRe",
"redormir" => "R°dORmiR",
"redors" => "R°dOR",
"redort" => "R°dOR",
"redoubla" => "R°dubla",
"redoublai" => "R°dublE",
"redoublaient" => "R°dublE",
"redoublais" => "R°dublE",
"redoublait" => "R°dublE",
"redoublant" => "R°dubl@",
"redoublants" => "R°dubl@",
"redouble" => "R°dubl",
"redoublé" => "R°duble",
"redoublée" => "R°duble",
"redoublées" => "R°duble",
"redoublement" => "R°dubl°m@",
"redoublent" => "R°dubl",
"redoubler" => "R°duble",
"redoublera" => "R°dubl°Ra",
"redoublerai" => "R°dubl°RE",
"redoublerait" => "R°dubl°RE",
"redoublèrent" => "R°dublER",
"redoubleront" => "R°dubl°R§",
"redoublés" => "R°duble",
"redoublez" => "R°duble",
"redoublions" => "R°dublij§",
"redoublons" => "R°dubl§",
"redouta" => "R°duta",
"redoutable" => "R°dutabl",
"redoutablement" => "R°dutabl°m@",
"redoutables" => "R°dutabl",
"redoutaient" => "R°dutE",
"redoutais" => "R°dutE",
"redoutait" => "R°dutE",
"redoutant" => "R°dut@",
"redoutasse" => "R°dutas",
"redoutât" => "R°duta",
"redoute" => "R°dut",
"redouté" => "R°dute",
"redoutée" => "R°dute",
"redoutées" => "R°dute",
"redoutent" => "R°dut",
"redouter" => "R°dute",
"redouterait" => "R°dut°RE",
"redouteras" => "R°dut°Ra",
"redoutèrent" => "R°dutER",
"redoutes" => "R°dut",
"redoutés" => "R°dute",
"redoutez" => "R°dute",
"redoutiez" => "R°dutje",
"redoutions" => "R°dutj§",
"redoutons" => "R°dut§",
"redoux" => "R°du",
"redressa" => "R°dREsa",
"redressai" => "R°dREsE",
"redressaient" => "R°dREsE",
"redressais" => "R°dREsE",
"redressait" => "R°dREsE",
"redressant" => "R°dREs@",
"redressât" => "R°dREsa",
"redresse" => "R°dREs",
"redressé" => "R°dRese",
"redressée" => "R°dRese",
"redressées" => "R°dRese",
"redressement" => "R°dREs°m@",
"redressements" => "R°dREs°m@",
"redressent" => "R°dREs",
"redresser" => "R°dRese",
"redressera" => "R°dREs°Ra",
"redresserai" => "R°dREs°RE",
"redresserait" => "R°dREs°RE",
"redressèrent" => "R°dREsER",
"redresserons" => "R°dREs°R§",
"redresses" => "R°dREs",
"redressés" => "R°dRese",
"redresseur" => "R°dREs9R",
"redresseurs" => "R°dREs9R",
"redresseuse" => "R°dREs2z",
"redressez" => "R°dREse",
"redressons" => "R°dREs§",
"réducteur" => "Redykt9R",
"réducteurs" => "Redykt9R",
"réduction" => "Redyksj§",
"réductionnisme" => "RedyksjOnism",
"réductionniste" => "Redyksjonist",
"réductions" => "Redyksj§",
"réduira" => "Red8iRa",
"réduirai" => "Red8iRE",
"réduiraient" => "Red8iRE",
"réduirait" => "Red8iRE",
"réduire" => "Red8iR",
"réduirons" => "Red8iR§",
"réduiront" => "Red8iR§",
"réduis" => "Red8i",
"réduisaient" => "Red8izE",
"réduisais" => "Red8izE",
"réduisait" => "Red8izE",
"réduisant" => "Red8iz@",
"réduise" => "Red8iz",
"réduisent" => "Red8iz",
"réduises" => "Red8iz",
"réduisez" => "Red8ize",
"réduisions" => "Red8izj§",
"réduisirent" => "Red8iziR",
"réduisis" => "Red8izi",
"réduisit" => "Red8izi",
"réduisît" => "Red8izi",
"réduisons" => "Red8iz§",
"réduit" => "Red8i",
"réduite" => "Red8it",
"réduites" => "Red8it",
"réduits" => "Red8i",
"réduplication" => "Redyplikasj§",
"rééchelonnement" => "ReeS°lOn°m@",
"réécoutais" => "ReekutE",
"réécoutait" => "ReekutE",
"réécoute" => "Reekut",
"réécouté" => "Reekute",
"réécoutent" => "Reekut",
"réécouter" => "Reekute",
"réécouterez" => "Reekut°Re",
"réécrira" => "ReekRiRa",
"réécrirai" => "ReekRiRE",
"réécrire" => "ReekRiR",
"réécris" => "ReekRi",
"réécrit" => "ReekRi",
"réécrite" => "ReekRit",
"réécrits" => "ReekRi",
"réécriture" => "ReekRityR",
"réécritures" => "ReekRityR",
"réécrivaient" => "ReekRivE",
"réécrive" => "ReekRiv",
"réécrivez" => "ReekRive",
"réédifier" => "Reedifje",
"réédifieras" => "ReedifiRa",
"rééditait" => "ReeditE",
"rééditant" => "Reedit@",
"réédité" => "Reedite",
"rééditées" => "Reedite",
"rééditer" => "Reedite",
"réédités" => "Reedite",
"réédition" => "Reedisj§",
"rééditions" => "Reedisj§",
"rééducateur" => "Reedykat9R",
"rééducation" => "Reedykasj§",
"rééduquais" => "ReedykE",
"rééduquait" => "ReedykE",
"rééduque" => "Reedyk",
"rééduqué" => "Reedyke",
"rééduquer" => "Reedyke",
"rééduqués" => "Reedyke",
"réel" => "ReEl",
"réélection" => "ReelEksj§",
"rééligible" => "ReeliZibl",
"réélira" => "ReeliRa",
"réélire" => "ReeliR",
"réélisent" => "Reeliz",
"réélisez" => "Reelize",
"réelle" => "ReEl",
"réellement" => "ReEl°m@",
"réelles" => "ReEl",
"réels" => "ReEl",
"réélu" => "Reely",
"réélus" => "Reely",
"réélut" => "Reely",
"réemballer" => "Re@bale",
"réembarque" => "Re@baRk",
"réembarquement" => "Re@baRk°m@",
"réembarquer" => "Re@baRke",
"réembauche" => "Re@boS",
"réembauché" => "Re@boSe",
"réembaucher" => "Re@boSe",
"réemploi" => "Re@plwa",
"réemployant" => "Re@plwaj@",
"réemployer" => "Re@plwaje",
"réemprunter" => "Re@pR1te",
"réencadrer" => "Re@kadRe",
"réenclenches" => "Re@kl@S",
"réendossant" => "Re@dos@",
"réendosser" => "Re@dose",
"réengage" => "Re@gaZ",
"réengagé" => "Re@gaZe",
"réengagées" => "Re@gaZe",
"réengagement" => "Re@gaZ°m@",
"réengager" => "Re@gaZe",
"réenregistré" => "Re@R°ZistRe",
"réenregistrer" => "Re@R°ZistRe",
"réentendaient" => "Re@t@dE",
"réentendais" => "Re@t@dE",
"réentendons" => "Re@t@d§",
"réentendre" => "Re@t@dR",
"réentends" => "Re@t@",
"réentendu" => "Re@t@dy",
"réenterrer" => "Re@teRe",
"réentraîner" => "Re@tREne",
"réenvahir" => "Re@vaiR",
"réenvisager" => "Re@vizaZe",
"rééquilibrage" => "ReekilibRaZ",
"rééquilibrait" => "ReekilibRE",
"rééquilibrant" => "ReekilibR@",
"rééquilibre" => "ReekilibR",
"rééquilibrer" => "ReekilibRe",
"rééquilibrera" => "ReekilibR°Ra",
"rééquipé" => "Reekipe",
"rééquipée" => "Reekipe",
"rééquipent" => "Reekip",
"rééquiper" => "Reekipe",
"réessaie" => "ReesE",
"réessaient" => "ReesE",
"réessaiera" => "ReesERa",
"réessaierai" => "ReesERE",
"réessaieras" => "ReesERa",
"réessaieront" => "ReesER§",
"réessayant" => "Reesej@",
"réessaye" => "ReesEj",
"réessayé" => "ReesEje",
"réessayer" => "Reeseje",
"réessayez" => "ReesEje",
"réessayiez" => "ReesEje",
"réessayons" => "ReesEj§",
"réétudier" => "Reetydje",
"réétudiez" => "Reetydje",
"réévaluation" => "Reeval8asj§",
"réévalue" => "Reevaly",
"réévalué" => "Reeval8e",
"réévaluée" => "Reeval8e",
"réévaluées" => "Reevalye",
"réévaluer" => "Reeval8e",
"réévaluera" => "ReevalyRa",
"réévalués" => "Reeval8e",
"réévaluez" => "Reevalye",
"réexamen" => "ReEgzam5",
"réexaminant" => "ReEgzamin@",
"réexamine" => "ReEgzamin",
"réexaminé" => "ReEgzamine",
"réexaminée" => "ReEgzamine",
"réexaminées" => "ReEgzamine",
"réexaminer" => "ReEgzamine",
"réexaminerons" => "ReEgzamin°R§",
"réexamines" => "ReEgzamin",
"réexaminez" => "ReEgzamine",
"réexaminiez" => "ReEgzaminje",
"réexaminions" => "ReEgzaminj§",
"réexpédia" => "ReEkspedja",
"réexpédiait" => "ReEkspedjE",
"réexpédiant" => "ReEkspedj@",
"réexpédié" => "ReEkspedje",
"réexpédier" => "ReEkspedje",
"réexpédiés" => "ReEkspedje",
"réexpédiez" => "ReEkspedje",
"réexpédions" => "ReEkspedj§",
"réexpédition" => "ReEkspedisj§",
"réf" => "Ref",
"refabriquer" => "R2fabRike",
"refaçonner" => "R2fasOne",
"refaire" => "R°fER",
"refais" => "R°fE",
"refaisaient" => "R°f°zE",
"refaisais" => "R°f°zE",
"refaisait" => "R°f°zE",
"refaisant" => "R°f°z@",
"refaisions" => "R°f°zj§",
"refaisons" => "R°f°z§",
"refait" => "R°fE",
"refaite" => "R°fEt",
"refaites" => "R°fEt",
"refaits" => "R°fE",
"refamiliariser" => "R2familjaRize",
"refasse" => "R°fas",
"refassent" => "R°fas",
"refasses" => "R°fas",
"refassiez" => "R°fasje",
"refaufile" => "R°fofil",
"réfection" => "RefEksj§",
"réfections" => "RefEksj§",
"réfectoire" => "RefEktwaR",
"réfectoires" => "RefEktwaR",
"refendre" => "R°f@dR",
"refendu" => "R°f@dy",
"refera" => "R°f°Ra",
"referai" => "R°f°RE",
"référaient" => "RefeRE",
"referais" => "R°f°RE",
"referait" => "R°f°RE",
"référait" => "RefeRE",
"référant" => "RefeR@",
"referas" => "R°f°Ra",
"réfère" => "RefER",
"référé" => "RefeRe",
"référée" => "RefeRe",
"référence" => "RefeR@s",
"référencé" => "RefeR@se",
"référencée" => "RefeR@se",
"référencement" => "RefeR@s°m@",
"référencer" => "RefeR@se",
"références" => "RefeR@s",
"référendaire" => "RefeR@dER",
"referendum" => "RefeR5dOm",
"référendum" => "RefeR5dOm",
"référendums" => "RefeR5dOm",
"référent" => "RefeR@",
"réfèrent" => "RefER",
"référer" => "RefeRe",
"référera" => "RefeR°Ra",
"référerai" => "RefeR°RE",
"référèrent" => "RefeRER",
"référerez" => "RefeR°Re",
"référés" => "RefeRe",
"référez" => "RefeRe",
"référiez" => "RefeRje",
"referions" => "R°f°Rj§",
"referma" => "R°fERma",
"refermai" => "R°fERmE",
"refermaient" => "R°fERmE",
"refermais" => "R°fERmE",
"refermait" => "R°fERmE",
"refermâmes" => "R°fERmam",
"refermant" => "R°fERm@",
"refermassent" => "R°fERmas",
"refermât" => "R°fERma",
"referme" => "R°fERm",
"refermé" => "R°fERme",
"refermée" => "R°fERme",
"refermées" => "R°fERme",
"referment" => "R°fERm",
"refermer" => "R°fERme",
"refermera" => "R°fERm°Ra",
"refermeraient" => "R°fERm°RE",
"refermerais" => "R°fERm°RE",
"refermerait" => "R°fERm°RE",
"refermèrent" => "R°fERmER",
"refermeront" => "R°fERm°R§",
"refermes" => "R°fERm",
"refermés" => "R°fERme",
"refermez" => "R°fERme",
"refermons" => "R°fERm§",
"referons" => "R°f°R§",
"referont" => "R°f°R§",
"refeuilleter" => "R2f9j°te",
"reficelai" => "R°fis°lE",
"reficelle" => "R°fisEl",
"refil" => "R2fil",
"refila" => "R°fila",
"refilai" => "R°filE",
"refilaient" => "R°filE",
"refilais" => "R°filE",
"refilait" => "R°filE",
"refilant" => "R°fil@",
"refile" => "R°fil",
"refilé" => "R°file",
"refilée" => "R°file",
"refilées" => "R°file",
"refilent" => "R°fil",
"refiler" => "R°file",
"refilera" => "R°fil°Ra",
"refilerait" => "R°fil°RE",
"refiles" => "R°fil",
"refilés" => "R°file",
"refilez" => "R°file",
"refîmes" => "R°fim",
"refinancée" => "R°fin@se",
"refinancement" => "R2fin@s°m@",
"refirent" => "R°fiR",
"refis" => "R°fi",
"refit" => "R°fi",
"refît" => "R°fi",
"réfléchi" => "RefleSi",
"réfléchie" => "RefleSi",
"réfléchies" => "RefleSi",
"réfléchir" => "RefleSiR",
"réfléchira" => "RefleSiRa",
"réfléchirai" => "RefleSiRE",
"réfléchirais" => "RefleSiRE",
"réfléchirait" => "RefleSiRE",
"réfléchiras" => "RefleSiRa",
"réfléchirent" => "RefleSiR",
"réfléchirez" => "RefleSiRe",
"réfléchiriez" => "RefleSiRje",
"réfléchirons" => "RefleSiR§",
"réfléchiront" => "RefleSiR§",
"réfléchis" => "RefleSi",
"réfléchissaient" => "RefleSisE",
"réfléchissais" => "RefleSisE",
"réfléchissait" => "RefleSisE",
"réfléchissant" => "RefleSis@",
"réfléchissante" => "RefleSis@t",
"réfléchissantes" => "RefleSis@t",
"réfléchissants" => "RefleSis@",
"réfléchisse" => "RefleSis",
"réfléchissent" => "RefleSis",
"réfléchisses" => "RefleSis",
"réfléchissez" => "RefleSise",
"réfléchissiez" => "RefleSisje",
"réfléchissons" => "RefleSis§",
"réfléchit" => "RefleSi",
"réfléchît" => "RefleSi",
"réflecteur" => "ReflEkt9R",
"réflecteurs" => "ReflEkt9R",
"reflet" => "R°flE",
"refléta" => "R°fleta",
"reflétaient" => "R°fletE",
"reflétait" => "R°fletE",
"reflétant" => "R°flet@",
"reflète" => "R°flEt",
"reflété" => "R°flete",
"reflétée" => "R°flete",
"reflétées" => "R°flete",
"reflètent" => "R°flEt",
"refléter" => "R°flete",
"reflétera" => "R°flet°Ra",
"refléteraient" => "R°flet°RE",
"refléterait" => "R°flet°RE",
"reflétèrent" => "R°fletER",
"reflétés" => "R°flete",
"reflétons" => "R°flet§",
"reflets" => "R°flE",
"refleurir" => "R°fl9RiR",
"refleurira" => "R°fl9RiRa",
"refleurissaient" => "R°fl9RisE",
"refleurissait" => "R°fl9RisE",
"refleurissent" => "R°fl9Ris",
"refleurit" => "R°fl9Ri",
"reflex" => "RiflEks",
"réflexe" => "ReflEks",
"réflexes" => "ReflEks",
"réflexif" => "ReflEksif",
"réflexion" => "ReflEksj§",
"réflexions" => "ReflEksj§",
"réflexive" => "ReflEksiv",
"réflexologie" => "ReflEksoloZi",
"reflua" => "R°fl8a",
"refluaient" => "R°flyE",
"refluait" => "R°flyE",
"refluant" => "R°fly@",
"reflue" => "R°fly",
"reflué" => "R°flye",
"refluée" => "R°flye",
"refluent" => "R°fly",
"refluer" => "R°flye",
"refluera" => "R°flyRa",
"refluèrent" => "R°flyER",
"reflux" => "R°fly",
"refoncer" => "R2f§se",
"refondant" => "R°f§d@",
"refonde" => "R°f§d",
"refondre" => "R°f§dR",
"refonds" => "R°f§",
"refondu" => "R°f§dy",
"refondus" => "R°f§dy",
"refont" => "R°f§",
"refonte" => "R°f§t",
"reforgé" => "R2fORZe",
"reforgée" => "R°fORZe",
"reforger" => "R°fORZe",
"reforma" => "R°fORma",
"réforma" => "RefORma",
"reformaient" => "R°fORmE",
"reformait" => "R°fORmE",
"reformant" => "R°fORm@",
"reformassent" => "R°fORmas",
"reformater" => "R°fORmate",
"réformateur" => "RefORmat9R",
"réformateurs" => "RefORmat9R",
"reformation" => "R°fORmasj§",
"réformation" => "RefORmasj§",
"reforme" => "R°fORm",
"réforme" => "RefORm",
"reformé" => "R°fORme",
"réformé" => "RefORme",
"reformée" => "R°fORme",
"réformée" => "RefORme",
"réformées" => "RefORme",
"reforment" => "R°fORm",
"reformer" => "R°fORme",
"réformer" => "RefORme",
"réformera" => "RefORm°Ra",
"reformèrent" => "R°fORmER",
"reformerons" => "R°fORm°R§",
"reformeront" => "R°fORm°R§",
"réformes" => "RefORm",
"reformés" => "R°fORme",
"réformés" => "RefORme",
"reformez" => "R°fORme",
"réformisme" => "RefORmism",
"réformiste" => "RefORmist",
"réformistes" => "RefORmist",
"réformons" => "RefORm§",
"reformulation" => "R2fORmylasj§",
"reformulé" => "R°fORmyle",
"reformulée" => "R°fORmyle",
"reformuler" => "R°fORmyle",
"refouillé" => "R°fuje",
"refouiller" => "R2fuje",
"refoula" => "R°fula",
"refoulai" => "R°fulE",
"refoulaient" => "R°fulE",
"refoulais" => "R°fulE",
"refoulait" => "R°fulE",
"refoulant" => "R°ful@",
"refoulante" => "R°ful@t",
"refoule" => "R°ful",
"refoulé" => "R°fule",
"refoulée" => "R°fule",
"refoulées" => "R°fule",
"refoulement" => "R°ful°m@",
"refoulements" => "R°ful°m@",
"refoulent" => "R°ful",
"refouler" => "R°fule",
"refoulerait" => "R°ful°RE",
"refoulés" => "R°fule",
"refoulez" => "R°fule",
"refouloir" => "R2fulwaR",
"refourgua" => "R°fuRga",
"refourgue" => "R°fuRg",
"refourgué" => "R°fuRge",
"refourguées" => "R°fuRge",
"refourguer" => "R°fuRge",
"refourguera" => "R°fuRg°Ra",
"refourguerait" => "R°fuRg°RE",
"refourgués" => "R°fuRge",
"refourguions" => "R°fuRgj§",
"refourrait" => "R°fuRE",
"refous" => "R°fu",
"refout" => "R°fu",
"refoutait" => "R°futE",
"refoute" => "R°fut",
"refoutent" => "R°fut",
"refoutes" => "R°fut",
"refoutez" => "R°fute",
"refoutre" => "R°futR",
"refoutu" => "R°futy",
"réfractaire" => "RefRaktER",
"réfractaires" => "RefRaktER",
"réfractant" => "RefRakt@",
"réfracté" => "RefRakte",
"réfractera" => "RefRakt°Ra",
"réfracterait" => "RefRakt°RE",
"réfraction" => "RefRaksj§",
"réfractionniste" => "RefRaksjOnist",
"refrain" => "R°fR5",
"refrains" => "R°fR5",
"refranchies" => "R°fR@Si",
"refranchir" => "R2fR@SiR",
"refrappe" => "R°fRap",
"refrapper" => "R2fRape",
"refréna" => "R°fRena",
"réfréna" => "RefRena",
"refrénai" => "R°fRenE",
"refrénait" => "R°fRenE",
"refrénant" => "R°fRen@",
"refrène" => "R°fREn",
"réfrène" => "RefREn",
"refréné" => "R°fRene",
"réfrénée" => "RefRene",
"refréner" => "R°fRene",
"réfréner" => "RefRene",
"refrénerait" => "R°fRen°RE",
"refrénés" => "R°fRene",
"réfrénez" => "RefRene",
"réfrigérant" => "RefRiZeR@",
"réfrigérante" => "RefRiZeR@t",
"réfrigérantes" => "RefRiZeR@t",
"réfrigérants" => "RefRiZeR@",
"réfrigérateur" => "RefRiZeRat9R",
"réfrigérateurs" => "RefRiZeRat9R",
"réfrigération" => "RefRiZeRasj§",
"réfrigéré" => "RefRiZeRe",
"réfrigérée" => "RefRiZeRe",
"réfrigérées" => "RefRiZeRe",
"réfrigèrent" => "RefRiZER",
"réfrigérer" => "RefRiZeRe",
"réfrigérés" => "RefRiZeRe",
"refroidi" => "R°fRwadi",
"refroidie" => "R°fRwadi",
"refroidies" => "R°fRwadi",
"refroidir" => "R°fRwadiR",
"refroidira" => "R°fRwadiRa",
"refroidiraient" => "R°fRwadiRE",
"refroidirais" => "R°fRwadiRE",
"refroidirait" => "R°fRwadiRE",
"refroidis" => "R°fRwadi",
"refroidissaient" => "R°fRwadisE",
"refroidissais" => "R°fRwadisE",
"refroidissait" => "R°fRwadisE",
"refroidissant" => "R°fRwadis@",
"refroidisse" => "R°fRwadis",
"refroidissement" => "R°fRwadis°m@",
"refroidissent" => "R°fRwadis",
"refroidisseur" => "R°fRwadis9R",
"refroidissiez" => "R°fRwadisje",
"refroidit" => "R°fRwadi",
"refuge" => "R°fyZ",
"refuges" => "R°fyZ",
"réfugia" => "RefyZja",
"réfugiai" => "RefyZjE",
"réfugiaient" => "RefyZjE",
"réfugiais" => "RefyZjE",
"réfugiait" => "RefyZjE",
"réfugiant" => "RefyZj@",
"réfugie" => "RefyZi",
"réfugié" => "RefyZje",
"réfugiée" => "RefyZje",
"réfugiées" => "RefyZje",
"réfugient" => "RefyZi",
"réfugier" => "RefyZje",
"réfugiera" => "RefyZiRa",
"réfugierais" => "RefyZiRE",
"réfugièrent" => "RefyZjER",
"réfugies" => "RefyZi",
"réfugiés" => "RefyZje",
"réfugiez" => "RefyZje",
"réfugiions" => "RefyZij§",
"réfugions" => "RefyZj§",
"refuites" => "R°f8it",
"refumer" => "R°fyme",
"refus" => "R°fy",
"refusa" => "R°fyza",
"refusai" => "R°fyzE",
"refusaient" => "R°fyzE",
"refusais" => "R°fyzE",
"refusait" => "R°fyzE",
"refusant" => "R°fyz@",
"refusât" => "R°fyza",
"refuse" => "R°fyz",
"refusé" => "R°fyze",
"refusée" => "R°fyze",
"refusées" => "R°fyze",
"refusent" => "R°fyz",
"refuser" => "R°fyze",
"refusera" => "R°fyz°Ra",
"refuserai" => "R°fyz°RE",
"refuseraient" => "R°fyz°RE",
"refuserais" => "R°fyz°RE",
"refuserait" => "R°fyz°RE",
"refuseras" => "R°fyz°Ra",
"refusèrent" => "R°fyzER",
"refuserez" => "R°fyz°Re",
"refuseriez" => "R°fyz°Rje",
"refuserions" => "R°fyz°Rj§",
"refuseront" => "R°fyz°R§",
"refuses" => "R°fyz",
"refusés" => "R°fyze",
"refusez" => "R°fyze",
"refusiez" => "R°fyzje",
"refusions" => "R°fyzj§",
"refusons" => "R°fyz§",
"réfuta" => "Refyta",
"réfutable" => "Refytabl",
"réfutaient" => "RefytE",
"réfutant" => "Refyt@",
"réfutation" => "Refytasj§",
"réfutations" => "Refytasj§",
"réfute" => "Refyt",
"réfuté" => "Refyte",
"réfutée" => "Refyte",
"réfutées" => "Refyte",
"réfutent" => "Refyt",
"réfuter" => "Refyte",
"réfutèrent" => "RefytER",
"réfutons" => "Refyt§",
"reg" => "REg",
"regagna" => "R°gaNa",
"regagnai" => "R°gaNE",
"regagnaient" => "R°gaNE",
"regagnais" => "R°gaNE",
"regagnait" => "R°gaNE",
"regagnâmes" => "R°gaNam",
"regagnant" => "R°gaN@",
"regagnât" => "R°gaNa",
"regagne" => "R°gaN",
"regagné" => "R°gaNe",
"regagnée" => "R°gaNe",
"regagnent" => "R°gaN",
"regagner" => "R°gaNe",
"regagnera" => "R°gaN°Ra",
"regagnerai" => "R°gaN°RE",
"regagneraient" => "R°gaN°RE",
"regagnerais" => "R°gaN°RE",
"regagnerait" => "R°gaN°RE",
"regagneras" => "R°gaN°Ra",
"regagnèrent" => "R°gaNER",
"regagnerez" => "R°gaN°Re",
"regagnerons" => "R°gaN°R§",
"regagneront" => "R°gaN°R§",
"regagnés" => "R°gaNe",
"regagnez" => "R°gaNe",
"regagniez" => "R°gaNe",
"regagnions" => "R°gaN§",
"regagnons" => "R°gaN§",
"regain" => "R°g5",
"regains" => "R°g5",
"régal" => "Regal",
"régala" => "Regala",
"régalade" => "Regalad",
"régalai" => "RegalE",
"régalaient" => "RegalE",
"régalais" => "RegalE",
"régalait" => "RegalE",
"régalant" => "Regal@",
"régalât" => "Regala",
"régale" => "Regal",
"régalé" => "Regale",
"régalée" => "Regale",
"régalent" => "Regal",
"régaler" => "Regale",
"régalera" => "Regal°Ra",
"régaleraient" => "Regal°RE",
"régalerais" => "Regal°RE",
"régalerait" => "Regal°RE",
"régaleras" => "Regal°Ra",
"régalèrent" => "RegalER",
"régalerez" => "Regal°Re",
"régaleront" => "Regal°R§",
"régalés" => "Regale",
"régaleur" => "Regal9R",
"régalez" => "Regale",
"régalien" => "Regalj5",
"régalions" => "Regalj§",
"régals" => "Regal",
"regard" => "R°gaR",
"regarda" => "R°gaRda",
"regardable" => "R°gaRdabl",
"regardables" => "R°gaRdabl",
"regardai" => "R°gaRdE",
"regardaient" => "R°gaRdE",
"regardais" => "R°gaRdE",
"regardait" => "R°gaRdE",
"regardâmes" => "R°gaRdam",
"regardant" => "R°gaRd@",
"regardante" => "R°gaRd@t",
"regardants" => "R°gaRd@",
"regardât" => "R°gaRda",
"regarde" => "R°gaRd",
"regardé" => "R°gaRde",
"regardée" => "R°gaRde",
"regardées" => "R°gaRde",
"regardent" => "R°gaRd",
"regarder" => "R°gaRde",
"regardera" => "R°gaRd°Ra",
"regarderai" => "R°gaRd°RE",
"regarderaient" => "R°gaRd°RE",
"regarderais" => "R°gaRd°RE",
"regarderait" => "R°gaRd°RE",
"regarderas" => "R°gaRd°Ra",
"regardèrent" => "R°gaRdER",
"regarderez" => "R°gaRd°Re",
"regarderiez" => "R°gaRd°Rje",
"regarderions" => "R°gaRd°Rj§",
"regarderons" => "R°gaRd°R§",
"regarderont" => "R°gaRd°R§",
"regardes" => "R°gaRd",
"regardés" => "R°gaRde",
"regardeur" => "R°gaRd9R",
"regardez" => "R°gaRde",
"regardiez" => "R°gaRdje",
"regardions" => "R°gaRdj§",
"regardons" => "R°gaRd§",
"regards" => "R°gaR",
"regarni" => "R2gaRni",
"regarnies" => "R°gaRni",
"regarnir" => "R°gaRniR",
"regarnirez" => "R°gaRniRe",
"regarnis" => "R°gaRni",
"regarnissez" => "R°gaRnise",
"régate" => "Regat",
"régates" => "Regat",
"regelés" => "R°Z°le",
"régence" => "ReZ@s",
"regency" => "R°Z@si",
"régénérait" => "ReZeneRE",
"régénérant" => "ReZeneR@",
"régénérateur" => "ReZeneRat9R",
"régénérateurs" => "ReZeneRat9R",
"régénération" => "ReZeneRasj§",
"régénératrice" => "ReZeneRatRis",
"régénère" => "ReZenER",
"régénéré" => "ReZeneRe",
"régénérée" => "ReZeneRe",
"régénérées" => "ReZeneRe",
"régénèrent" => "ReZenER",
"régénérer" => "ReZeneRe",
"régénérera" => "ReZeneR°Ra",
"régénérerait" => "ReZeneR°RE",
"régénérés" => "ReZeneRe",
"régénérescence" => "ReZeneREs@s",
"régent" => "ReZ@",
"régentaient" => "ReZ@tE",
"régentait" => "ReZ@tE",
"régentant" => "ReZ@t@",
"régente" => "ReZ@t",
"régenté" => "ReZ@te",
"régentée" => "ReZ@te",
"régentent" => "ReZ@t",
"régenter" => "ReZ@te",
"régenteraient" => "ReZ@t°RE",
"régentes" => "ReZ@t",
"reggae" => "Rege",
"reggaes" => "Rege",
"régi" => "ReZi",
"régicide" => "ReZisid",
"régicides" => "ReZisid",
"régie" => "ReZi",
"régies" => "ReZi",
"regimba" => "R°Z5ba",
"regimbais" => "R°Z5bE",
"regimbait" => "R°Z5bE",
"regimbe" => "R°Z5b",
"regimbé" => "R°Z5be",
"regimbements" => "R°Z5b°m@",
"regimber" => "R°Z5be",
"régime" => "ReZim",
"régiment" => "ReZim@",
"régimentaire" => "ReZim@tER",
"régimentaires" => "ReZim@tER",
"régiments" => "ReZim@",
"régimes" => "ReZim",
"région" => "ReZj§",
"régional" => "ReZjonal",
"régionale" => "ReZjonal",
"régionales" => "ReZjonal",
"régionaliser" => "ReZjonalize",
"régionalisme" => "ReZjonalizm",
"régionaliste" => "ReZjonalist",
"régionalistes" => "ReZjonalist",
"régionaux" => "ReZjono",
"régions" => "ReZj§",
"régir" => "ReZiR",
"régira" => "ReZiRa",
"régiraient" => "ReZiRE",
"régirait" => "ReZiRE",
"régiront" => "ReZiR§",
"régis" => "ReZi",
"régissaient" => "ReZisE",
"régissait" => "ReZisE",
"régissant" => "ReZis@",
"régissent" => "ReZis",
"régisseur" => "ReZis9R",
"régisseurs" => "ReZis9R",
"régisseuse" => "ReZis2z",
"registre" => "R°ZistR",
"registres" => "R°ZistR",
"régit" => "ReZi",
"régla" => "Regla",
"réglable" => "Reglabl",
"réglables" => "Reglabl",
"réglage" => "ReglaZ",
"réglages" => "ReglaZ",
"réglai" => "ReglE",
"réglaient" => "ReglE",
"réglais" => "ReglE",
"réglait" => "ReglE",
"réglant" => "Regl@",
"réglasse" => "Reglas",
"réglât" => "Regla",
"règle" => "REgl",
"réglé" => "Regle",
"réglée" => "Regle",
"réglées" => "Regle",
"règlement" => "REgl°m@",
"réglementaire" => "Regl°m@tER",
"réglementairement" => "Regl°m@tER°m@",
"réglementaires" => "Regl°m@tER",
"réglementait" => "Regl°m@tE",
"réglementant" => "Regl°m@t@",
"réglementation" => "Regl°m@tasj§",
"réglementations" => "Regl°m@tasj§",
"réglemente" => "Regl°m@t",
"réglementé" => "Regl°m@te",
"réglementée" => "Regl°m@te",
"réglementées" => "Regl°m@te",
"réglementer" => "Regl°m@te",
"réglementés" => "Regl°m@te",
"règlements" => "REgl°m@",
"règlent" => "REgl",
"régler" => "Regle",
"réglera" => "Regl°Ra",
"réglerai" => "Regl°RE",
"réglerais" => "Regl°RE",
"réglerait" => "Regl°RE",
"régleras" => "Regl°Ra",
"réglèrent" => "ReglER",
"réglerez" => "Regl°Re",
"réglerions" => "Regl°Rj§",
"réglerons" => "Regl°R§",
"régleront" => "Regl°R§",
"règles" => "REgl",
"réglés" => "Regle",
"réglette" => "ReglEt",
"régleur" => "Regl9R",
"réglez" => "Regle",
"régliez" => "Reglie",
"réglions" => "Reglij§",
"réglisse" => "Reglis",
"reglissé" => "R°glise",
"réglisses" => "Reglis",
"réglo" => "Reglo",
"réglons" => "Regl§",
"réglos" => "Reglo",
"réglure" => "ReglyR",
"régna" => "ReNa",
"régnaient" => "ReNE",
"régnais" => "ReNE",
"régnait" => "ReNE",
"régnant" => "ReN@",
"régnante" => "ReN@t",
"régnants" => "ReN@",
"régnas" => "ReNa",
"règne" => "REN",
"régné" => "ReNe",
"règnent" => "REN",
"régner" => "ReNe",
"régnera" => "ReN°Ra",
"régnerai" => "ReN°RE",
"régneraient" => "ReN°RE",
"régnerais" => "ReN°RE",
"régnerait" => "ReN°RE",
"régneras" => "ReN°Ra",
"régnèrent" => "ReNER",
"régnerez" => "ReN°Re",
"régnerons" => "ReN°R§",
"régneront" => "ReN°R§",
"règnes" => "REN",
"régnez" => "ReNe",
"régnions" => "ReN§",
"régnons" => "ReN§",
"regonflage" => "R2g§flaZ",
"regonflait" => "R°g§flE",
"regonfle" => "R°g§fl",
"regonflé" => "R°g§fle",
"regonfler" => "R°g§fle",
"regonflera" => "R°g§fl°Ra",
"regonflerais" => "R°g§fl°RE",
"regonflerait" => "R°g§fl°RE",
"regonflés" => "R°g§fle",
"regorge" => "R°gORZ",
"regorgea" => "R°gORZa",
"regorgeaient" => "R°gORZE",
"regorgeais" => "R°gORZE",
"regorgeait" => "R°gORZE",
"regorgeant" => "R°gORZ@",
"regorgent" => "R°gORZ",
"regorger" => "R°gORZe",
"regorges" => "R°gORZ",
"regoûté" => "R2gute",
"regoûter" => "R2gute",
"regrattières" => "R°gRatjER",
"regréaient" => "R°gReE",
"regréé" => "R°gRee",
"regréer" => "R°gRee",
"regreffe" => "R°gREf",
"régressait" => "RegREsE",
"régressant" => "RegREs@",
"régresse" => "RegREs",
"régressé" => "RegRese",
"régresser" => "RegRese",
"régressera" => "RegRes°Ra",
"régressif" => "RegResif",
"régression" => "RegResj§",
"régressions" => "RegResj§",
"régressive" => "RegResiv",
"regret" => "R°gRE",
"regrets" => "R°gRE",
"regretta" => "R°gREta",
"regrettable" => "R°gREtabl",
"regrettablement" => "R°gREtabl°m@",
"regrettables" => "R°gREtabl",
"regrettai" => "R°gREtE",
"regrettaient" => "R°gREtE",
"regrettais" => "R°gREtE",
"regrettait" => "R°gREtE",
"regrettant" => "R°gREt@",
"regrettât" => "R°gREta",
"regrette" => "R°gREt",
"regretté" => "R°gRete",
"regrettée" => "R°gRete",
"regrettées" => "R°gRete",
"regrettent" => "R°gREt",
"regretter" => "R°gRete",
"regrettera" => "R°gREt°Ra",
"regretterai" => "R°gREt°RE",
"regretteraient" => "R°gREt°RE",
"regretterais" => "R°gREt°RE",
"regretterait" => "R°gREt°RE",
"regretteras" => "R°gREt°Ra",
"regrettèrent" => "R°gREtER",
"regretterez" => "R°gREt°Re",
"regretteriez" => "R°gREt°Rje",
"regretterons" => "R°gREt°R§",
"regretteront" => "R°gREt°R§",
"regrettes" => "R°gREt",
"regrettés" => "R°gRete",
"regrettez" => "R°gREte",
"regrettiez" => "R°gREtje",
"regrettions" => "R°gREtj§",
"regrettons" => "R°gREt§",
"regrimpa" => "R°gR5pa",
"regrimpaient" => "R°gR5pE",
"regrimpait" => "R°gR5pE",
"regrimpe" => "R°gR5p",
"regrimpé" => "R°gR5pe",
"regrimpent" => "R°gR5p",
"regrimper" => "R°gR5pe",
"regrimperas" => "R°gR5p°Ra",
"regrimperons" => "R°gR5p°R§",
"regrimpez" => "R°gR5pe",
"regrossir" => "R2gRosiR",
"regroupa" => "R°gRupa",
"regroupaient" => "R°gRupE",
"regroupait" => "R°gRupE",
"regroupant" => "R°gRup@",
"regroupe" => "R°gRup",
"regroupé" => "R°gRupe",
"regroupée" => "R°gRupe",
"regroupées" => "R°gRupe",
"regroupement" => "R°gRup°m@",
"regroupements" => "R°gRup°m@",
"regroupent" => "R°gRup",
"regrouper" => "R°gRupe",
"regrouperaient" => "R°gRup°RE",
"regroupèrent" => "R°gRupER",
"regrouperions" => "R°gRup°Rj§",
"regroupés" => "R°gRupe",
"regroupez" => "R°gRupe",
"régul" => "Regyl",
"régulant" => "Regyl@",
"régularisa" => "RegylaRiza",
"régularisation" => "RegylaRizasj§",
"régularisations" => "RegylaRizasj§",
"régularisé" => "RegylaRize",
"régulariser" => "RegylaRize",
"régularisera" => "RegylaRiz°Ra",
"régularité" => "RegylaRite",
"régulateur" => "Regylat9R",
"régulateurs" => "Regylat9R",
"régulation" => "Regylasj§",
"régulatrice" => "RegylatRis",
"régulatrices" => "RegylatRis",
"régule" => "Regyl",
"régulé" => "Regyle",
"régulée" => "Regyle",
"régulées" => "Regyle",
"régulent" => "Regyl",
"réguler" => "Regyle",
"régulera" => "Regyl°Ra",
"régulés" => "Regyle",
"régulier" => "Regylje",
"régulière" => "RegyljER",
"régulièrement" => "RegyljER°m@",
"régulières" => "RegyljER",
"réguliers" => "Regylje",
"régurgitaient" => "RegyRZitE",
"régurgitant" => "RegyRZit@",
"régurgitation" => "RegyRZitasj§",
"régurgitations" => "RegyRZitasj§",
"régurgite" => "RegyRZit",
"régurgité" => "RegyRZite",
"régurgiter" => "RegyRZite",
"régurgiteras" => "RegyRZit°Ra",
"réhabilitaient" => "ReabilitE",
"réhabilitait" => "ReabilitE",
"réhabilitant" => "Reabilit@",
"réhabilitation" => "Reabilitasj§",
"réhabilite" => "Reabilit",
"réhabilité" => "Reabilite",
"réhabilitée" => "Reabilite",
"réhabilitées" => "Reabilite",
"réhabilitent" => "Reabilit",
"réhabiliter" => "Reabilite",
"réhabilitera" => "Reabilit°Ra",
"réhabiliterait" => "Reabilit°RE",
"réhabilités" => "Reabilite",
"réhabituais" => "Reabit8E",
"réhabituait" => "Reabit8E",
"réhabitue" => "Reabity",
"réhabituer" => "Reabit8e",
"rehaussaient" => "R2osE",
"rehaussait" => "R2osE",
"rehaussant" => "R2os@",
"rehausse" => "R2os",
"rehaussé" => "R2ose",
"rehaussée" => "R2ose",
"rehaussées" => "R2ose",
"rehaussement" => "R2os°m@",
"rehaussent" => "R2os",
"rehausser" => "R2ose",
"rehaussera" => "R2os°Ra",
"rehausses" => "R2os",
"rehaussés" => "R2ose",
"rehausseur" => "R2os9R",
"rehaussez" => "R2ose",
"rehaut" => "R2o",
"rehauts" => "R2o",
"réhydratation" => "ReidRatasj§",
"réhydraté" => "ReidRate",
"réhydrater" => "ReidRate",
"reich" => "RajS",
"reichsmark" => "RajSsmaRk",
"reichstag" => "RajSstag",
"reichswehr" => "RajSvER",
"réifiés" => "Reifje",
"réimplantation" => "Re5pl@tasj§",
"réimplanté" => "Re5pl@te",
"réimplantée" => "Re5pl@te",
"réimplanter" => "Re5pl@te",
"réimpression" => "Re5pREsj§",
"réimprima" => "Re5pRima",
"réimprimé" => "Re5pRime",
"réimprimer" => "Re5pRime",
"rein" => "R5",
"réincarcérer" => "Re5kaRseRe",
"réincarnait" => "Re5kaRnE",
"réincarnation" => "Re5kaRnasj§",
"réincarnations" => "Re5kaRnasj§",
"réincarne" => "Re5kaRn",
"réincarné" => "Re5kaRne",
"réincarnée" => "Re5kaRne",
"réincarnent" => "Re5kaRn",
"réincarner" => "Re5kaRne",
"réincarnera" => "Re5kaRn°Ra",
"réincarnerait" => "Re5kaRn°RE",
"réincarnèrent" => "Re5kaRnER",
"réincarneront" => "Re5kaRn°R§",
"réincarnés" => "Re5kaRne",
"réincarnons" => "Re5kaRn§",
"réincorpora" => "Re5kORpoRa",
"réincorporé" => "Re5kORpoRe",
"réincorporés" => "Re5kORpoRe",
"reine" => "REn",
"reine-claude" => "REnklod",
"reine-mère" => "REnmER",
"reines" => "REn",
"reines-claudes" => "REnklod",
"reines-marguerites" => "REnmaRg°Rit",
"reinette" => "REnEt",
"reinettes" => "REnEt",
"réinfecté" => "Re5fEkte",
"réinfecter" => "Re5fEkte",
"réinitialisation" => "Reinisjalizasj§",
"réinitialisé" => "Reinisjalize",
"réinitialiser" => "Reinisjalize",
"réinitialisez" => "Reinisjalize",
"réinjecter" => "Re5ZEkte",
"réinjection" => "Re5ZEksj§",
"reins" => "R5",
"réinscrire" => "Re5skRiR",
"réinscrit" => "Re5skRi",
"réinséré" => "Re5seRe",
"réinsérer" => "Re5seRe",
"réinsertion" => "Re5sERsj§",
"réinstalla" => "Re5stala",
"réinstallaient" => "Re5stalE",
"réinstallait" => "Re5stalE",
"réinstallant" => "Re5stal@",
"réinstallation" => "Re5stalasj§",
"réinstalle" => "Re5stal",
"réinstallé" => "Re5stale",
"réinstallée" => "Re5stale",
"réinstallées" => "Re5stale",
"réinstallent" => "Re5stal",
"réinstaller" => "Re5stale",
"réinstallés" => "Re5stale",
"réinstallez" => "Re5stale",
"réinstallons" => "Re5stal§",
"réinstaurer" => "Re5stORe",
"réintégra" => "Re5tegRa",
"réintégrai" => "Re5tegRE",
"réintégraient" => "Re5tegRE",
"réintégrais" => "Re5tegRE",
"réintégrait" => "Re5tegRE",
"réintégrant" => "Re5tegR@",
"réintégration" => "Re5tegRasj§",
"réintégrations" => "Re5tegRasj§",
"réintègre" => "Re5tEgR",
"réintégré" => "Re5tegRe",
"réintégrée" => "Re5tegRe",
"réintègrent" => "Re5tEgR",
"réintégrer" => "Re5tegRe",
"réintégrerait" => "Re5tegR°RE",
"réintégrèrent" => "Re5tegRER",
"réintégrés" => "Re5tegRe",
"réintégrez" => "Re5tegRe",
"réintégrions" => "Re5tegRij§",
"réintégrons" => "Re5tegR§",
"réinterprétation" => "Re5tERpRetasj§",
"réinterprète" => "Re5tERpREt",
"réinterpréter" => "Re5tERpRete",
"réinterroge" => "Re5tEROZ",
"réinterroger" => "Re5tERoZe",
"réintroduire" => "Re5tRod8iR",
"réintroduisait" => "Re5tRod8izE",
"réintroduisit" => "Re5tRod8izi",
"réintroduit" => "Re5tRod8i",
"réintroduite" => "Re5tRod8it",
"réinventa" => "Re5v@ta",
"réinventaient" => "Re5v@tE",
"réinventait" => "Re5v@tE",
"réinventant" => "Re5v@t@",
"réinvente" => "Re5v@t",
"réinventé" => "Re5v@te",
"réinventées" => "Re5v@te",
"réinventent" => "Re5v@t",
"réinventer" => "Re5v@te",
"réinventeraient" => "Re5v@t°RE",
"réinvention" => "Re5v@sj§",
"réinvesti" => "Re5vEsti",
"réinvestir" => "Re5vEstiR",
"réinvestirent" => "Re5vEstiR",
"réinvestis" => "Re5vEsti",
"réinvestissait" => "Re5vEstisE",
"réinvestissement" => "Re5vEstis°m@",
"réinvestissent" => "Re5vEstis",
"réinvestit" => "Re5vEsti",
"réinvita" => "Re5vita",
"réinvite" => "Re5vit",
"réinviter" => "Re5vite",
"réinviterai" => "Re5vit°RE",
"reis" => "REjs",
"réitéra" => "ReiteRa",
"réitérait" => "ReiteRE",
"réitérant" => "ReiteR@",
"réitération" => "ReiteRasj§",
"réitérations" => "ReiteRasj§",
"réitère" => "ReitER",
"réitéré" => "ReiteRe",
"réitérée" => "ReiteRe",
"réitérées" => "ReiteRe",
"réitérer" => "ReiteRe",
"réitérera" => "ReiteR°Ra",
"réitérèrent" => "ReiteRER",
"réitérés" => "ReiteRe",
"reître" => "REtR",
"reîtres" => "REtR",
"rejailli" => "R°Zaji",
"rejaillir" => "R°ZajiR",
"rejailliraient" => "R°ZajiRE",
"rejaillirait" => "R°ZajiRE",
"rejaillissaient" => "R°ZajisE",
"rejaillissait" => "R°ZajisE",
"rejaillissant" => "R°Zajis@",
"rejaillissements" => "R°Zajis°m@",
"rejaillissent" => "R°Zajis",
"rejaillit" => "R°Zaji",
"rejet" => "R°ZE",
"rejeta" => "R°Zta",
"rejetable" => "R°Ztabl",
"rejetai" => "R°ZtE",
"rejetaient" => "R°ZtE",
"rejetais" => "R°ZtE",
"rejetait" => "R°ZtE",
"rejetant" => "R°Zt@",
"rejetât" => "R°Zta",
"rejeté" => "R°Zte",
"rejetée" => "R°Zte",
"rejetées" => "R°Zte",
"rejeter" => "R°Zte",
"rejetèrent" => "R°ZtER",
"rejetés" => "R°Zte",
"rejetez" => "R°Zte",
"rejetiez" => "R°Z°tje",
"rejetions" => "R°Z°tj§",
"rejeton" => "R°Zt§",
"rejetons" => "R°Zt§",
"rejets" => "R°ZE",
"rejette" => "R°ZEt",
"rejettent" => "R°ZEt",
"rejettera" => "R°ZEt°Ra",
"rejetterai" => "R°ZEt°RE",
"rejetteraient" => "R°ZEt°RE",
"rejetterais" => "R°ZEt°RE",
"rejetterait" => "R°ZEt°RE",
"rejetteras" => "R°ZEt°Ra",
"rejetteront" => "R°ZEt°R§",
"rejettes" => "R°ZEt",
"rejoignaient" => "R°ZwaNE",
"rejoignais" => "R°ZwaNE",
"rejoignait" => "R°ZwaNE",
"rejoignant" => "R°ZwaN@",
"rejoigne" => "R°ZwaN",
"rejoignent" => "R°ZwaN",
"rejoignes" => "R°ZwaN",
"rejoignez" => "R°ZwaNe",
"rejoigniez" => "R°ZwaNe",
"rejoignîmes" => "R°ZwaNim",
"rejoignions" => "R°ZwaN§",
"rejoignirent" => "R°ZwaNiR",
"rejoignis" => "R°ZwaNi",
"rejoignisse" => "R°ZwaNis",
"rejoignissent" => "R°ZwaNis",
"rejoignit" => "R°ZwaNi",
"rejoignît" => "R°ZwaNi",
"rejoignons" => "R°ZwaN§",
"rejoindra" => "R°Zw5dRa",
"rejoindrai" => "R°Zw5dRE",
"rejoindraient" => "R°Zw5dRE",
"rejoindrais" => "R°Zw5dRE",
"rejoindrait" => "R°Zw5dRE",
"rejoindras" => "R°Zw5dRa",
"rejoindre" => "R°Zw5dR",
"rejoindrez" => "R°Zw5dRe",
"rejoindrions" => "R°Zw5dRij§",
"rejoindrons" => "R°Zw5dR§",
"rejoindront" => "R°Zw5dR§",
"rejoins" => "R°Zw5",
"rejoint" => "R°Zw5",
"rejointe" => "R°Zw5t",
"rejointes" => "R°Zw5t",
"rejointoyé" => "R°Zw5twaje",
"rejointoyer" => "R°Zw5twaje",
"rejointoyés" => "R°Zw5twaje",
"rejoints" => "R°Zw5",
"rejoua" => "R°Zwa",
"rejouaient" => "R°ZuE",
"rejouais" => "R°ZwE",
"rejouant" => "R°Zw@",
"rejoue" => "R°Zu",
"rejoué" => "R°Zwe",
"rejouent" => "R°Zu",
"rejouer" => "R°Zwe",
"rejouerait" => "R°ZuRE",
"rejoueras" => "R°ZuRa",
"rejouerez" => "R°ZuRe",
"rejouerons" => "R°ZuR§",
"rejoues" => "R°Zu",
"rejouez" => "R°Zue",
"réjoui" => "ReZwi",
"réjouie" => "ReZwi",
"réjouies" => "ReZwi",
"réjouir" => "ReZwiR",
"réjouira" => "ReZwiRa",
"réjouirai" => "ReZuiRE",
"réjouirais" => "ReZwiRE",
"réjouirait" => "ReZwiRE",
"réjouirent" => "ReZwiR",
"réjouirez" => "ReZwiRe",
"réjouirons" => "ReZuiR§",
"réjouiront" => "ReZwiR§",
"réjouis" => "ReZwi",
"réjouissaient" => "ReZwisE",
"réjouissais" => "ReZwisE",
"réjouissait" => "ReZwisE",
"réjouissance" => "ReZwis@s",
"réjouissances" => "ReZwis@s",
"réjouissant" => "ReZwis@",
"réjouissante" => "ReZwis@t",
"réjouissantes" => "ReZwis@t",
"réjouissants" => "ReZwis@",
"réjouisse" => "ReZwis",
"réjouissent" => "ReZwis",
"réjouissez" => "ReZwise",
"réjouissiez" => "ReZuisje",
"réjouissions" => "ReZwisj§",
"réjouissons" => "ReZwis§",
"réjouit" => "ReZwi",
"réjouît" => "ReZwi",
"rejouons" => "R°Zu§",
"rejugé" => "R°ZyZe",
"rejuger" => "R°ZyZe",
"rejugés" => "R°ZyZe",
"rejugez" => "R°ZyZe",
"relaça" => "R°lasa",
"relaçaient" => "R°lasE",
"relaçait" => "R°lasE",
"relacent" => "R°las",
"relacer" => "R°lase",
"relâcha" => "R°laSa",
"relâchai" => "R°laSE",
"relâchaient" => "R°laSE",
"relâchais" => "R°laSE",
"relâchait" => "R°laSE",
"relâchant" => "R°laS@",
"relâche" => "R°laS",
"relâché" => "R°laSe",
"relâchée" => "R°laSe",
"relâchées" => "R°laSe",
"relâchement" => "R°laS°m@",
"relâchements" => "R°laS°m@",
"relâchent" => "R°laS",
"relâcher" => "R°laSe",
"relâchera" => "R°laS°Ra",
"relâcherai" => "R°laS°RE",
"relâcheraient" => "R°laS°RE",
"relâcherait" => "R°laS°RE",
"relâcheras" => "R°laS°Ra",
"relâchèrent" => "R°laSER",
"relâcherez" => "R°laS°Re",
"relâcherons" => "R°laS°R§",
"relâcheront" => "R°laS°R§",
"relâchés" => "R°laSe",
"relâchez" => "R°laSe",
"relâchiez" => "R°laSje",
"relâchons" => "R°laS§",
"relaie" => "R°lE",
"relaient" => "R°lE",
"relaiera" => "R°lERa",
"relaieraient" => "R°lERE",
"relaierait" => "R°lERE",
"relaieront" => "R°lER§",
"relais" => "R°lE",
"relaisser" => "R°lEse",
"relança" => "R°l@sa",
"relançai" => "R°l@sE",
"relançaient" => "R°l@sE",
"relançais" => "R°l@sE",
"relançait" => "R°l@sE",
"relançant" => "R°l@s@",
"relançât" => "R°l@sa",
"relance" => "R°l@s",
"relancé" => "R°l@se",
"relancée" => "R°l@se",
"relancées" => "R°l@se",
"relancement" => "R2l@s°m@",
"relancent" => "R°l@s",
"relancer" => "R°l@se",
"relancera" => "R°l@s°Ra",
"relancerait" => "R°l@s°RE",
"relancèrent" => "R°l@sER",
"relanceront" => "R°l@s°R§",
"relances" => "R°l@s",
"relancés" => "R°l@se",
"relanceur" => "R2l@s9R",
"relancez" => "R°l@se",
"relançons" => "R°l@s§",
"relaps" => "R°laps",
"relapse" => "R°laps",
"relapses" => "R°laps",
"relargué" => "R2laRge",
"relata" => "R°lata",
"relatai" => "R°latE",
"relataient" => "R°latE",
"relatais" => "R°latE",
"relatait" => "R°latE",
"relatant" => "R°lat@",
"relate" => "R°lat",
"relaté" => "R°late",
"relatée" => "R°late",
"relatées" => "R°late",
"relatent" => "R°lat",
"relater" => "R°late",
"relateraient" => "R°lat°RE",
"relateront" => "R°lat°R§",
"relatés" => "R°late",
"relatif" => "R°latif",
"relatifs" => "R°latif",
"relation" => "R°lasj§",
"relationnel" => "R°lasjonEl",
"relationnelle" => "R°lasjonEl",
"relationnelles" => "R°lasjonEl",
"relationnels" => "R°lasjonEl",
"relations" => "R2lasj§",
"relative" => "R°lativ",
"relativement" => "R°lativ°m@",
"relatives" => "R°lativ",
"relativisant" => "R°lativiz@",
"relativisation" => "R°lativizasj§",
"relativise" => "R°lativiz",
"relativisé" => "R2lativize",
"relativisent" => "R°lativiz",
"relativiser" => "R°lativize",
"relativisme" => "R°lativizm",
"relativiste" => "R2lativist",
"relativité" => "R°lativite",
"relavait" => "R°lavE",
"relave" => "R°lav",
"relaver" => "R°lave",
"relavés" => "R°lave",
"relax" => "R°laks",
"relaxais" => "R°laksE",
"relaxant" => "R°laks@",
"relaxante" => "R°laks@t",
"relaxantes" => "R°laks@t",
"relaxants" => "R°laks@",
"relaxation" => "R°laksasj§",
"relaxe" => "R°laks",
"relaxé" => "R°lakse",
"relaxée" => "R°lakse",
"relaxer" => "R°lakse",
"relaxes" => "R°laks",
"relaxez" => "R°lakse",
"relaxons" => "R°laks§",
"relaya" => "R°leja",
"relayaient" => "R°lejE",
"relayait" => "R°lejE",
"relayâmes" => "R°lejam",
"relayant" => "R°lej@",
"relaye" => "R°lej",
"relayé" => "R°leje",
"relayée" => "R°leje",
"relayées" => "R°leje",
"relayent" => "R°lej",
"relayer" => "R°leje",
"relayera" => "R°lej°Ra",
"relayerai" => "R°lEj°RE",
"relayèrent" => "R°lejER",
"relayés" => "R°leje",
"relayeur" => "R2lej9R",
"relayez" => "R°lEje",
"relayions" => "R°lejj§",
"relayons" => "R°lej§",
"relecture" => "R°lEktyR",
"relégation" => "R°legasj§",
"relégua" => "R°lega",
"reléguai" => "R°legE",
"reléguaient" => "R°legE",
"reléguait" => "R°legE",
"reléguant" => "R°leg@",
"relègue" => "R°lEg",
"relégué" => "R°lege",
"reléguée" => "R°lege",
"reléguées" => "R°lege",
"relèguent" => "R°lEg",
"reléguer" => "R°lege",
"reléguera" => "R°leg°Ra",
"relégueraient" => "R°leg°RE",
"reléguerait" => "R°leg°RE",
"reléguèrent" => "R°legER",
"relégués" => "R°lege",
"reléguons" => "R°leg§",
"relent" => "R°l@",
"relents" => "R°l@",
"releva" => "R°l°va",
"relevable" => "R°l°vabl",
"relevai" => "R°l°vE",
"relevaient" => "R°l°vE",
"relevailles" => "R°l°vaj",
"relevais" => "R°l°vE",
"relevait" => "R°l°vE",
"relevâmes" => "R°l°vam",
"relevant" => "R°l°v@",
"relevât" => "R°l°va",
"relève" => "R°lEv",
"relevé" => "R°l°ve",
"relevée" => "R°l°ve",
"relevées" => "R°l°ve",
"relèvement" => "R°lEv°m@",
"relèvements" => "R°lEv°m@",
"relèvent" => "R°lEv",
"relever" => "R°l°ve",
"relèvera" => "R°lEv°Ra",
"relèverai" => "R°lEv°RE",
"relèveraient" => "R°lEv°RE",
"relèverais" => "R°lEv°RE",
"relèverait" => "R°lEv°RE",
"relèveras" => "R°lEv°Ra",
"relevèrent" => "R°l°vER",
"relèverez" => "R°lEv°Re",
"relèverions" => "R°lEv°Rj§",
"relèverons" => "R°lEv°R§",
"relèveront" => "R°lEv°R§",
"relèves" => "R°lEv",
"relevés" => "R°l°ve",
"releveur" => "R°l°v9R",
"releveurs" => "R°l°v9R",
"relevez" => "R°l°ve",
"releviez" => "R°l°vje",
"relevions" => "R°l°vj§",
"relevons" => "R°l°v§",
"reliage" => "R2ljaZ",
"reliaient" => "R°ljE",
"reliait" => "R°ljE",
"reliant" => "R°lj@",
"reliât" => "R°lja",
"relie" => "R°li",
"relié" => "R°lje",
"reliée" => "R°lje",
"reliées" => "R°lje",
"relief" => "R°ljEf",
"reliefs" => "R°ljEf",
"relient" => "R°li",
"relier" => "R°lje",
"reliera" => "R°liRa",
"reliés" => "R°lje",
"relieur" => "R°lj9R",
"relieurs" => "R°lj9R",
"reliez" => "R°lie",
"religieuse" => "R°liZj2z",
"religieusement" => "R°liZj2z°m@",
"religieuses" => "R°liZj2z",
"religieux" => "R°liZj2",
"religion" => "R°liZj§",
"religionnaires" => "R°liZjonER",
"religions" => "R°liZj§",
"religiosité" => "R°liZjozite",
"reliquaire" => "R°likER",
"reliquaires" => "R°likER",
"reliquat" => "R°lika",
"reliquats" => "R°lika",
"relique" => "R°lik",
"reliques" => "R°lik",
"relirai" => "R°liRE",
"relirais" => "R°liRE",
"relirait" => "R°liRE",
"reliras" => "R°liRa",
"relire" => "R°liR",
"relirez" => "R°liRe",
"relirons" => "R°liR§",
"relis" => "R°li",
"relisaient" => "R°lizE",
"relisais" => "R°lizE",
"relisait" => "R°lizE",
"relisant" => "R°liz@",
"relise" => "R°liz",
"relisez" => "R°lize",
"relisions" => "R°lizj§",
"relit" => "R°li",
"reliure" => "R°ljyR",
"reliures" => "R°ljyR",
"reloge" => "R°lOZ",
"relogé" => "R°loZe",
"relogement" => "R°lOZ°m@",
"relogements" => "R°lOZ°m@",
"reloger" => "R°loZe",
"relogerais" => "R°lOZ°RE",
"relooké" => "R°luke",
"relookée" => "R°luke",
"relooker" => "R°luke",
"relookerai" => "R°luk°RE",
"reloquer" => "R°loke",
"reloué" => "R2lwe",
"relouer" => "R°lue",
"relouerons" => "R°luR§",
"relourde" => "R°luRd",
"relourdé" => "R°luRde",
"relourder" => "R°luRde",
"relu" => "R°ly",
"relue" => "R°ly",
"relues" => "R°ly",
"relui" => "R°l8i",
"reluire" => "R°l8iR",
"reluiront" => "R°l8iR§",
"reluis" => "R°l8i",
"reluisaient" => "R°l8izE",
"reluisais" => "R°l8izE",
"reluisant" => "R°l8iz@",
"reluisante" => "R°l8iz@t",
"reluisantes" => "R°l8iz@t",
"reluisants" => "R°l8iz@",
"reluise" => "R°l8iz",
"reluisent" => "R°l8iz",
"reluit" => "R°l8i",
"reluqua" => "R°lyka",
"reluquaient" => "R°lykE",
"reluquais" => "R°lykE",
"reluquait" => "R°lykE",
"reluquant" => "R°lyk@",
"reluque" => "R°lyk",
"reluqué" => "R°lyke",
"reluquée" => "R°lyke",
"reluquent" => "R°lyk",
"reluquer" => "R°lyke",
"reluques" => "R°lyk",
"reluqués" => "R°lyke",
"reluquiez" => "R°lykje",
"relus" => "R°ly",
"relut" => "R°ly",
"remâcha" => "R°maSa",
"remâchaient" => "R°maSE",
"remâchais" => "R°maSE",
"remâchait" => "R°maSE",
"remâchant" => "R°maS@",
"remâche" => "R°maS",
"remâché" => "R°maSe",
"remâchée" => "R°maSe",
"remâchées" => "R°maSe",
"remâchent" => "R°maS",
"remâcher" => "R°maSe",
"remâchez" => "R°maSe",
"remaigrir" => "R2megRiR",
"remaillage" => "R°majaZ",
"remaillaient" => "R°majE",
"remaillant" => "R°maj@",
"remailler" => "R°maje",
"remaillés" => "R°maje",
"remailleuse" => "R2maj2z",
"remake" => "RimEk",
"rémanence" => "Reman@s",
"rémanent" => "Reman@",
"rémanente" => "Reman@t",
"remange" => "R°m@Z",
"remanger" => "R2m@Ze",
"remangerait" => "R°m@Z°RE",
"remania" => "R°manja",
"remaniait" => "R°manjE",
"remaniant" => "R°manj@",
"remanie" => "R°mani",
"remanié" => "R°manje",
"remaniée" => "R°manje",
"remaniement" => "R°manim@",
"remaniements" => "R°manim@",
"remanier" => "R°manje",
"remaniés" => "R°manje",
"remaquilla" => "R°makija",
"remaquillait" => "R°makijE",
"remaquille" => "R°makij",
"remaquillé" => "R°makije",
"remaquillée" => "R°makije",
"remaquiller" => "R°makije",
"remarchait" => "R°maRSE",
"remarche" => "R°maRS",
"remarchent" => "R°maRS",
"remarcher" => "R°maRSe",
"remarchera" => "R°maRS°Ra",
"remarcheras" => "R°maRS°Ra",
"remaria" => "R°maRja",
"remariage" => "R°maRjaZ",
"remariaient" => "R°maRjE",
"remariait" => "R°maRjE",
"remariant" => "R°maRj@",
"remarie" => "R°maRi",
"remarié" => "R°maRje",
"remariée" => "R°maRje",
"remarient" => "R°maRi",
"remarier" => "R°maRje",
"remariera" => "R°maRiRa",
"remarierai" => "R°maRiRE",
"remarierais" => "R°maRiRE",
"remarierait" => "R°maRiRE",
"remarieras" => "R°maRiRa",
"remarierez" => "R°maRiRe",
"remarieront" => "R°maRiR§",
"remaries" => "R°maRi",
"remariés" => "R°maRje",
"remariez" => "R°maRje",
"remariions" => "R°maRij§",
"remarqua" => "R°maRka",
"remarquable" => "R°maRkabl",
"remarquablement" => "R°maRkabl°m@",
"remarquables" => "R°maRkabl",
"remarquai" => "R°maRkE",
"remarquaient" => "R°maRkE",
"remarquais" => "R°maRkE",
"remarquait" => "R°maRkE",
"remarquâmes" => "R°maRkam",
"remarquant" => "R°maRk@",
"remarquas" => "R°maRka",
"remarquât" => "R°maRka",
"remarque" => "R°maRk",
"remarqué" => "R°maRke",
"remarquée" => "R°maRke",
"remarquées" => "R°maRke",
"remarquent" => "R°maRk",
"remarquer" => "R°maRke",
"remarquera" => "R°maRk°Ra",
"remarquerai" => "R°maRk°RE",
"remarqueraient" => "R°maRk°RE",
"remarquerais" => "R°maRk°RE",
"remarquerait" => "R°maRk°RE",
"remarqueras" => "R°maRk°Ra",
"remarquèrent" => "R°maRkER",
"remarquerez" => "R°maRk°Re",
"remarqueriez" => "R°maRk°Rje",
"remarqueront" => "R°maRk°R§",
"remarques" => "R°maRk",
"remarqués" => "R°maRke",
"remarquez" => "R°maRke",
"remarquiez" => "R°maRkje",
"remarquions" => "R°maRkj§",
"remarquons" => "R°maRk§",
"remballa" => "R@bala",
"remballage" => "R@balaZ",
"remballaient" => "R@balE",
"remballait" => "R@balE",
"remballant" => "R@bal@",
"remballe" => "R@bal",
"remballé" => "R@bale",
"remballent" => "R@bal",
"remballer" => "R@bale",
"remballés" => "R@bale",
"remballez" => "R@bale",
"rembarqua" => "R@baRka",
"rembarquaient" => "R@baRkE",
"rembarque" => "R@baRk",
"rembarqué" => "R@baRke",
"rembarquées" => "R@baRke",
"rembarquement" => "R@baRk°m@",
"rembarquements" => "R@baRk°m@",
"rembarquer" => "R@baRke",
"rembarquèrent" => "R@baRkER",
"rembarquez" => "R@baRke",
"rembarra" => "R@baRa",
"rembarrais" => "R@baRE",
"rembarrait" => "R@baRE",
"rembarre" => "R@baR",
"rembarré" => "R@baRe",
"rembarrée" => "R@baRe",
"rembarrer" => "R@baRe",
"rembarres" => "R@baR",
"rembauche" => "R@boS",
"rembauchés" => "R@boSe",
"remblai" => "R@blE",
"remblaiement" => "R@blEm@",
"remblais" => "R@blE",
"remblaya" => "R@bleja",
"remblayé" => "R@bleje",
"remblayée" => "R@bleje",
"remblayer" => "R@bleje",
"rembobinage" => "R@bobinaZ",
"rembobine" => "R@bobin",
"rembobiner" => "R@bobine",
"rembobinez" => "R@bobine",
"remboîter" => "R@bwate",
"rembour" => "R@buR",
"rembourrage" => "R@buRaZ",
"rembourrages" => "R@buRaZ",
"rembourraient" => "R@buRE",
"rembourrait" => "R@buRE",
"rembourrant" => "R@buR@",
"rembourre" => "R@buR",
"rembourré" => "R@buRe",
"rembourrée" => "R@buRe",
"rembourrées" => "R@buRe",
"rembourrer" => "R@buRe",
"rembourrés" => "R@buRe",
"remboursa" => "R@buRsa",
"remboursable" => "R@buRsabl",
"remboursaient" => "R@buRsE",
"remboursais" => "R@buRsE",
"remboursait" => "R@buRsE",
"remboursant" => "R@buRs@",
"remboursât" => "R@buRsa",
"rembourse" => "R@buRs",
"remboursé" => "R@buRse",
"remboursée" => "R@buRse",
"remboursées" => "R@buRse",
"remboursement" => "R@buRs°m@",
"remboursements" => "R@buRs°m@",
"remboursent" => "R@buRs",
"rembourser" => "R@buRse",
"remboursera" => "R@buRs°Ra",
"rembourserai" => "R@buRs°RE",
"rembourserais" => "R@buRs°RE",
"rembourserait" => "R@buRs°RE",
"rembourseras" => "R@buRs°Ra",
"remboursèrent" => "R@buRsER",
"rembourserez" => "R@buRs°Re",
"rembourserons" => "R@buRs°R§",
"rembourseront" => "R@buRs°R§",
"rembourses" => "R@buRs",
"remboursés" => "R@buRse",
"remboursez" => "R@buRse",
"remboursons" => "R@buRs§",
"rembruni" => "R@bRyni",
"rembrunir" => "R@bRyniR",
"rembrunis" => "R@bRyni",
"rembrunissait" => "R@bRynisE",
"rembrunissent" => "R@bRynis",
"rembrunit" => "R@bRyni",
"remède" => "R°mEd",
"remède-miracle" => "R°mEdmiRakl",
"remèdes" => "R°mEd",
"remédia" => "R°medja",
"remédiable" => "R2medjabl",
"remédiait" => "R°medjE",
"remédie" => "R°medi",
"remédié" => "R°medje",
"remédier" => "R°medje",
"remédiera" => "R°mediRa",
"remédierait" => "R°mediRE",
"remédierons" => "R°mediR§",
"remédiez" => "R°medje",
"remédions" => "R°medj§",
"remembrance" => "R°m@bR@s",
"remembrement" => "R°m@bR°m@",
"remembrés" => "R°m@bRe",
"remémora" => "R°memoRa",
"remémorais" => "R°memoRE",
"remémorait" => "R°memoRE",
"remémorant" => "R°memoR@",
"remémoration" => "R2memORasj§",
"remémorative" => "R°memoRativ",
"remémore" => "R°memoR",
"remémoré" => "R°memoRe",
"remémorent" => "R°memoR",
"remémorer" => "R°memoRe",
"remercia" => "R°mERsja",
"remerciai" => "R°mERsijE",
"remerciaient" => "R°mERsjE",
"remerciais" => "R°mERsijE",
"remerciait" => "R°mERsijE",
"remerciâmes" => "R°mERsijam",
"remerciant" => "R°mERsij@",
"remercie" => "R°mERsi",
"remercié" => "R°mERsje",
"remerciée" => "R°mERsje",
"remerciement" => "R°mERsim@",
"remerciements" => "R°mERsim@",
"remercient" => "R°mERsi",
"remercier" => "R°mERsje",
"remerciera" => "R°mERsiRa",
"remercierai" => "R°mERsiRE",
"remercierais" => "R°mERsiRE",
"remercierait" => "R°mERsiRE",
"remercieras" => "R°mERsiRa",
"remercièrent" => "R°mERsjER",
"remercierez" => "R°mERsiRe",
"remercierons" => "R°mERsiR§",
"remercieront" => "R°mERsiR§",
"remercies" => "R°mERsi",
"remerciés" => "R°mERsje",
"remerciez" => "R°mERsje",
"remercions" => "R°mERsj§",
"remet" => "R°mE",
"remets" => "R°mE",
"remettaient" => "R°mEtE",
"remettais" => "R°mEtE",
"remettait" => "R°mEtE",
"remettant" => "R°mEt@",
"remette" => "R°mEt",
"remettent" => "R°mEt",
"remettes" => "R°mEt",
"remettez" => "R°mEte",
"remettiez" => "R°mEtje",
"remettions" => "R°mEtj§",
"remettons" => "R°mEt§",
"remettra" => "R°mEtRa",
"remettrai" => "R°mEtRE",
"remettraient" => "R°mEtRE",
"remettrais" => "R°mEtRE",
"remettrait" => "R°mEtRE",
"remettras" => "R°mEtRa",
"remettre" => "R°mEtR",
"remettrez" => "R°mEtRe",
"remettriez" => "R°mEtRije",
"remettrions" => "R°mEtRij§",
"remettrons" => "R°mEtR§",
"remettront" => "R°mEtR§",
"remeublé" => "R°m9ble",
"rémiges" => "RemiZ",
"remîmes" => "R°mim",
"réminiscence" => "Reminis@s",
"réminiscences" => "Reminis@s",
"remirent" => "R°miR",
"remis" => "R°mi",
"remisa" => "R°miza",
"remisai" => "R°mizE",
"remisaient" => "R°mizE",
"remisait" => "R°mizE",
"remise" => "R°miz",
"remisé" => "R°mize",
"remisée" => "R°mize",
"remisent" => "R°miz",
"remiser" => "R°mize",
"remisèrent" => "R°mizER",
"remises" => "R°miz",
"remisés" => "R°mize",
"remisez" => "R°mize",
"remisons" => "R°miz§",
"remisse" => "R°mis",
"rémission" => "Remisj§",
"rémissions" => "Remisj§",
"remit" => "R°mi",
"remît" => "R°mi",
"remix" => "R2miks",
"remixer" => "R2mikse",
"rémiz" => "Remiz",
"remmailleuses" => "R@maj2z",
"remmenaient" => "R@m°nE",
"remmène" => "R@mEn",
"remmenée" => "R@m°ne",
"remmener" => "R@m°ne",
"remmènes" => "R@mEn",
"remmenez" => "R@m°ne",
"remobilisés" => "R°mobilize",
"remodela" => "R°mod°la",
"remodelage" => "R°mod°laZ",
"remodelant" => "R°mod°l@",
"remodèle" => "R°modEl",
"remodelé" => "R°mod°le",
"remodelée" => "R°mod°le",
"remodelées" => "R°mod°le",
"remodeler" => "R°mod°le",
"remodèles" => "R°modEl",
"remonta" => "R°m§ta",
"remontage" => "R°m§taZ",
"remontai" => "R°m§tE",
"remontaient" => "R°m§tE",
"remontais" => "R°m§tE",
"remontait" => "R°m§tE",
"remontâmes" => "R°m§tam",
"remontant" => "R°m§t@",
"remontantes" => "R°m§t@t",
"remontants" => "R°m§t@",
"remontât" => "R°m§ta",
"remonte" => "R°m§t",
"remonté" => "R°m§te",
"remonte-pente" => "R°m§tp@t",
"remonte-pentes" => "R°m§tp@t",
"remontée" => "R°m§te",
"remontées" => "R°m§te",
"remontent" => "R°m§t",
"remonter" => "R°m§te",
"remontera" => "R°m§t°Ra",
"remonterai" => "R°m§t°RE",
"remonteraient" => "R°m§t°RE",
"remonterait" => "R°m§t°RE",
"remonteras" => "R°m§t°Ra",
"remontèrent" => "R°m§tER",
"remonterez" => "R°m§t°Re",
"remonteriez" => "R°m§t°Rje",
"remonterons" => "R°m§t°R§",
"remonteront" => "R°m§t°R§",
"remontes" => "R°m§t",
"remontés" => "R°m§te",
"remontez" => "R°m§te",
"remontiez" => "R°m§tje",
"remontions" => "R°m§tj§",
"remontoir" => "R°m§twaR",
"remontons" => "R°m§t§",
"remontrait" => "R°m§tRE",
"remontrance" => "R°m§tR@s",
"remontrances" => "R°m§tR@s",
"remontrassent" => "R°m§tRas",
"remontre" => "R°m§tR",
"remontré" => "R°m§tRe",
"remontrer" => "R°m§tRe",
"remontrera" => "R°m§tR°Ra",
"remontrerai" => "R°m§tR°RE",
"remontrerais" => "R°m§tR°RE",
"remontrerait" => "R°m§tR°RE",
"remontreras" => "R°m§tR°Ra",
"remontres" => "R°m§tR",
"remontrez" => "R°m§tRe",
"rémora" => "RemORa",
"remord" => "R°mOR",
"remordait" => "R°mORdE",
"remords" => "R°mOR",
"remordu" => "R2mORdy",
"remorqua" => "R°mORka",
"remorquage" => "R°mORkaZ",
"remorquaient" => "R°mORkE",
"remorquait" => "R°mORkE",
"remorquant" => "R°mORk@",
"remorque" => "R°mORk",
"remorqué" => "R°mORke",
"remorquée" => "R°mORke",
"remorquer" => "R°mORke",
"remorquera" => "R°mORk°Ra",
"remorquerai" => "R°mORk°RE",
"remorques" => "R°mORk",
"remorqueur" => "R°mORk9R",
"remorqueurs" => "R°mORk9R",
"remorqueuse" => "R°mORk2z",
"remorquez" => "R°mORke",
"remorquions" => "R°mORkj§",
"remorquons" => "R°mORk§",
"remoucha" => "R°muSa",
"remouillaient" => "R°mujE",
"remouiller" => "R°muje",
"rémoulade" => "Remulad",
"rémouleur" => "Remul9R",
"rémouleurs" => "Remul9R",
"remous" => "R°mu",
"rempaillaient" => "R@pajE",
"rempaillée" => "R@paje",
"rempailler" => "R@paje",
"rempailleur" => "R@paj9R",
"rempailleurs" => "R@paj9R",
"rempailleuses" => "R@paj2z",
"rempaqueté" => "R@pak°te",
"rempaquette" => "R@pakEt",
"rempart" => "R@paR",
"remparts" => "R@paR",
"rempilait" => "R@pilE",
"rempile" => "R@pil",
"rempilé" => "R@pile",
"rempilent" => "R@pil",
"rempiler" => "R@pile",
"rempilerai" => "R@pil°RE",
"rempilerais" => "R@pil°RE",
"rempilerez" => "R@pil°Re",
"rempiles" => "R@pil",
"rempilez" => "R@pile",
"remplaça" => "R@plasa",
"remplaçable" => "R@plasabl",
"remplaçables" => "R@plasabl",
"remplaçai" => "R@plasE",
"remplaçaient" => "R@plasE",
"remplaçais" => "R@plasE",
"remplaçait" => "R@plasE",
"remplaçant" => "R@plas@",
"remplaçante" => "R@plas@t",
"remplaçantes" => "R@plas@t",
"remplaçants" => "R@plas@",
"remplaçât" => "R@plasa",
"remplace" => "R@plas",
"remplacé" => "R@plase",
"remplacée" => "R@plase",
"remplacées" => "R@plase",
"remplacement" => "R@plas°m@",
"remplacements" => "R@plas°m@",
"remplacent" => "R@plas",
"remplacer" => "R@plase",
"remplacera" => "R@plas°Ra",
"remplacerai" => "R@plas°RE",
"remplaceraient" => "R@plas°RE",
"remplacerais" => "R@plas°RE",
"remplacerait" => "R@plas°RE",
"remplaceras" => "R@plas°Ra",
"remplacèrent" => "R@plasER",
"remplacerez" => "R@plas°Re",
"remplaceriez" => "R@plas°Rje",
"remplacerons" => "R@plas°R§",
"remplaceront" => "R@plas°R§",
"remplaces" => "R@plas",
"remplacés" => "R@plase",
"remplacez" => "R@plase",
"remplaciez" => "R@plasje",
"remplaçons" => "R@plas§",
"rempli" => "R@pli",
"remplie" => "R@pli",
"remplies" => "R@pli",
"remplir" => "R@pliR",
"remplira" => "R@pliRa",
"remplirai" => "R@pliRE",
"rempliraient" => "R@pliRE",
"remplirais" => "R@pliRE",
"remplirait" => "R@pliRE",
"rempliras" => "R@pliRa",
"remplirent" => "R@pliR",
"remplirez" => "R@pliRe",
"remplirons" => "R@pliR§",
"rempliront" => "R@pliR§",
"remplis" => "R@pli",
"remplissage" => "R@plisaZ",
"remplissaient" => "R@plisE",
"remplissais" => "R@plisE",
"remplissait" => "R@plisE",
"remplissant" => "R@plis@",
"remplisse" => "R@plis",
"remplissent" => "R@plis",
"remplisses" => "R@plis",
"remplisseur" => "R@plis9R",
"remplissez" => "R@plise",
"remplissiez" => "R@plisje",
"remplissions" => "R@plisj§",
"remplissons" => "R@plis§",
"remplit" => "R@pli",
"remplît" => "R@pli",
"remploi" => "R@plwa",
"remployée" => "R@plwaje",
"remplumé" => "R@plyme",
"remplumer" => "R@plyme",
"remplumez" => "R@plyme",
"rempochait" => "R@poSE",
"rempoche" => "R@pOS",
"remporta" => "R@pORta",
"remportai" => "R@pORtE",
"remportaient" => "R@pORtE",
"remportais" => "R@pORtE",
"remportait" => "R@pORtE",
"remportant" => "R@pORt@",
"remportassent" => "R@pORtas",
"remportât" => "R@pORta",
"remporte" => "R@pORt",
"remporté" => "R@pORte",
"remportée" => "R@pORte",
"remportées" => "R@pORte",
"remportent" => "R@pORt",
"remporter" => "R@pORte",
"remportera" => "R@pORt°Ra",
"remporterai" => "R@pORt°RE",
"remporterait" => "R@pORt°RE",
"remportèrent" => "R@pORtER",
"remporterez" => "R@pORt°Re",
"remporterons" => "R@pORt°R§",
"remportés" => "R@pORte",
"remportez" => "R@pORte",
"remportiez" => "R@pORtje",
"remportions" => "R@pORtj§",
"rempoter" => "R@pote",
"remprunter" => "R@pR1te",
"remua" => "R°m8a",
"remuage" => "R°myaZ",
"remuai" => "R°m8E",
"remuaient" => "R°m8E",
"remuais" => "R°m8E",
"remuait" => "R°m8E",
"remuâmes" => "R°m8am",
"remuant" => "R°m8@",
"remuante" => "R°m8@t",
"remuantes" => "R°m8@t",
"remuants" => "R°m8@",
"remuât" => "R°m8a",
"remue" => "R°my",
"remué" => "R°m8e",
"remue-ménage" => "R°mymenaZ",
"remue-méninges" => "R°mymen5Z",
"remuée" => "R°m8e",
"remuées" => "R°m8e",
"remuement" => "R°mym@",
"remuements" => "R°mym@",
"remuent" => "R°my",
"remuer" => "R°m8e",
"remuera" => "R°myRa",
"remuerai" => "R°myRE",
"remueraient" => "R°myRE",
"remuerais" => "R°myRE",
"remuerait" => "R°myRE",
"remuèrent" => "R°m8ER",
"remueront" => "R°myR§",
"remues" => "R°my",
"remués" => "R°m8e",
"remueur" => "R°m89R",
"remueurs" => "R°m89R",
"remuez" => "R°mye",
"remugle" => "R°mygl",
"remugles" => "R°mygl",
"remuions" => "R°myj§",
"rémunéraient" => "RemyneRE",
"rémunérateur" => "RemyneRat9R",
"rémunérateurs" => "RemyneRat9R",
"rémunération" => "RemyneRasj§",
"rémunérations" => "RemyneRasj§",
"rémunératoires" => "RemyneRatwaR",
"rémunératrice" => "RemyneRatRis",
"rémunère" => "RemynER",
"rémunéré" => "RemyneRe",
"rémunérées" => "RemyneRe",
"rémunérer" => "RemyneRe",
"rémunérés" => "RemyneRe",
"remuons" => "R°my§",
"remuscle" => "R°myskl",
"remuscler" => "R2myskle",
"renâcla" => "R°nakla",
"renâclaient" => "R°naklE",
"renâclais" => "R°naklE",
"renâclait" => "R°naklE",
"renâclant" => "R°nakl@",
"renâcle" => "R°nakl",
"renâclé" => "R°nakle",
"renâclent" => "R°nakl",
"renâcler" => "R°nakle",
"renâcles" => "R°nakl",
"renâclez" => "R°nakle",
"renâclions" => "R°naklij§",
"renais" => "R°nE",
"renaissaient" => "R°nEsE",
"renaissais" => "R°nEsE",
"renaissait" => "R°nEsE",
"renaissance" => "R°nEs@s",
"renaissances" => "R°nEs@s",
"renaissant" => "R°nEs@",
"renaissante" => "R°nEs@t",
"renaissantes" => "R°nEs@t",
"renaissants" => "R°nEs@",
"renaisse" => "R°nEs",
"renaissent" => "R°nEs",
"renaisses" => "R°nEs",
"renaissons" => "R°nEs§",
"renaît" => "R°nE",
"renaîtra" => "R°nEtRa",
"renaîtrai" => "R°nEtRE",
"renaîtraient" => "R°nEtRE",
"renaîtrais" => "R°nEtRE",
"renaîtrait" => "R°nEtRE",
"renaîtras" => "R°nEtRa",
"renaître" => "R°nEtR",
"renaîtrez" => "R°nEtRe",
"renaîtrons" => "R°nEtR§",
"renaîtront" => "R°nEtR§",
"rénal" => "Renal",
"rénale" => "Renal",
"rénales" => "Renal",
"renaquit" => "R°naki",
"renard" => "R°naR",
"renarde" => "R°naRd",
"renardeau" => "R°naRdo",
"renardeaux" => "R°naRdo",
"renardes" => "R°naRd",
"renards" => "R°naR",
"renaud" => "R2no",
"renaudais" => "R°nodE",
"renaudait" => "R°nodE",
"renaudant" => "R°nod@",
"renaude" => "R°nod",
"renaudé" => "R°node",
"renaudent" => "R°nod",
"renauder" => "R°node",
"renaudeur" => "R2nod9R",
"rénaux" => "Reno",
"rencard" => "R@kaR",
"rencardaient" => "R@kaRdE",
"rencardait" => "R@kaRdE",
"rencarde" => "R@kaRd",
"rencardé" => "R@kaRde",
"rencardée" => "R@kaRde",
"rencardées" => "R@kaRde",
"rencarder" => "R@kaRde",
"rencardés" => "R@kaRde",
"rencards" => "R@kaR",
"renchéri" => "R@SeRi",
"renchérir" => "R@SeRiR",
"renchériront" => "R@SeRiR§",
"renchéris" => "R@SeRi",
"renchérissais" => "R@SeRisE",
"renchérissait" => "R@SeRisE",
"renchérissant" => "R@SeRis@",
"renchérissent" => "R@SeRis",
"renchérit" => "R@SeRi",
"rencogna" => "R@koNa",
"rencognait" => "R@koNE",
"rencognant" => "R@koN@",
"rencogne" => "R@kON",
"rencogné" => "R@koNe",
"rencogner" => "R@koNe",
"rencognerait" => "R@kON°RE",
"rencognés" => "R@koNe",
"rencontra" => "R@k§tRa",
"rencontrai" => "R@k§tRE",
"rencontraient" => "R@k§tRE",
"rencontrais" => "R@k§tRE",
"rencontrait" => "R@k§tRE",
"rencontrâmes" => "R@k§tRam",
"rencontrant" => "R@k§tR@",
"rencontrasse" => "R@k§tRas",
"rencontrât" => "R@k§tRa",
"rencontre" => "R@k§tR",
"rencontré" => "R@k§tRe",
"rencontrée" => "R@k§tRe",
"rencontrées" => "R@k§tRe",
"rencontrent" => "R@k§tR",
"rencontrer" => "R@k§tRe",
"rencontrera" => "R@k§tR°Ra",
"rencontrerai" => "R@k§tR°RE",
"rencontreraient" => "R@k§tR°RE",
"rencontrerais" => "R@k§tR°RE",
"rencontrerait" => "R@k§tR°RE",
"rencontreras" => "R@k§tR°Ra",
"rencontrèrent" => "R@k§tRER",
"rencontrerez" => "R@k§tR°Re",
"rencontreriez" => "R@k§tR°Rje",
"rencontrerions" => "R@k§tR°Rj§",
"rencontrerons" => "R@k§tR°R§",
"rencontreront" => "R@k§tR°R§",
"rencontres" => "R@k§tR",
"rencontrés" => "R@k§tRe",
"rencontrez" => "R@k§tRe",
"rencontriez" => "R@k§tRije",
"rencontrions" => "R@k§tRij§",
"rencontrons" => "R@k§tR§",
"rend" => "R@",
"rendaient" => "R@dE",
"rendais" => "R@dE",
"rendait" => "R@dE",
"rendant" => "R@d@",
"rende" => "R@d",
"rendement" => "R@d°m@",
"rendements" => "R@d°m@",
"rendent" => "R@d",
"rendes" => "R@d",
"rendez" => "R@de",
"rendez-vous" => "R@devu",
"rendiez" => "R@dje",
"rendîmes" => "R@dim",
"rendions" => "R@dj§",
"rendirent" => "R@diR",
"rendis" => "R@di",
"rendisse" => "R@dis",
"rendissent" => "R@dis",
"rendit" => "R@di",
"rendît" => "R@di",
"rendons" => "R@d§",
"rendormais" => "R@dORmE",
"rendormait" => "R@dORmE",
"rendormant" => "R@dORm@",
"rendorme" => "R@dORm",
"rendorment" => "R@dORm",
"rendormez" => "R@dORme",
"rendormi" => "R@dORmi",
"rendormiez" => "R@dORmje",
"rendormir" => "R@dORmiR",
"rendormira" => "R@dORmiRa",
"rendormirai" => "R@dORmiRE",
"rendormirait" => "R@dORmiRE",
"rendormis" => "R@dORmi",
"rendormit" => "R@dORmi",
"rendormît" => "R@dORmi",
"rendors" => "R@dOR",
"rendort" => "R@dOR",
"rendra" => "R@dRa",
"rendrai" => "R@dRE",
"rendraient" => "R@dRE",
"rendrais" => "R@dRE",
"rendrait" => "R@dRE",
"rendras" => "R@dRa",
"rendre" => "R@dR",
"rendrez" => "R@dRe",
"rendriez" => "R@dRije",
"rendrons" => "R@dR§",
"rendront" => "R@dR§",
"rends" => "R@",
"rendu" => "R@dy",
"rendue" => "R@dy",
"rendues" => "R@dy",
"rendus" => "R@dy",
"rêne" => "REn",
"rené" => "R°ne",
"renée" => "R°ne",
"renégat" => "R°nega",
"renégate" => "R°negat",
"renégats" => "R°nega",
"renégociation" => "R°negosjasj§",
"renégocie" => "R°negosi",
"renégociées" => "R°negosje",
"renégocier" => "R°negosje",
"renégociés" => "R°negosje",
"reneige" => "R°nEZ",
"reneiger" => "R°nEZe",
"rênes" => "REn",
"rénettes" => "RenEt",
"renettoyer" => "R2nEtwaje",
"renferma" => "R@fERma",
"renfermaient" => "R@fERmE",
"renfermait" => "R@fERmE",
"renfermant" => "R@fERm@",
"renferme" => "R@fERm",
"renfermé" => "R@fERme",
"renfermée" => "R@fERme",
"renfermées" => "R@fERme",
"renfermement" => "R@fERm°m@",
"renferment" => "R@fERm",
"renfermer" => "R@fERme",
"renfermerait" => "R@fERm°RE",
"renfermés" => "R@fERme",
"renfermez" => "R@fERme",
"renfila" => "R@fila",
"renfilait" => "R@filE",
"renfilant" => "R@fil@",
"renfile" => "R@fil",
"renfilé" => "R@file",
"renfiler" => "R@file",
"renflait" => "R@flE",
"renflant" => "R@fl@",
"renflé" => "R@fle",
"renflée" => "R@fle",
"renflées" => "R@fle",
"renflement" => "R@fl°m@",
"renflements" => "R@fl°m@",
"renflent" => "R@fl",
"renflés" => "R@fle",
"renfloua" => "R@flua",
"renflouage" => "R@fluaZ",
"renflouait" => "R@fluE",
"renflouant" => "R@flu@",
"renfloue" => "R@flu",
"renfloué" => "R@flue",
"renflouée" => "R@flue",
"renflouement" => "R@flum@",
"renflouent" => "R@flu",
"renflouer" => "R@flue",
"renfloués" => "R@flue",
"renfonça" => "R@f§sa",
"renfonçait" => "R@f§sE",
"renfonce" => "R@f§s",
"renfoncé" => "R@f§se",
"renfoncée" => "R@f§se",
"renfoncées" => "R@f§se",
"renfoncement" => "R@f§s°m@",
"renfoncements" => "R@f§s°m@",
"renfoncer" => "R@f§se",
"renfoncés" => "R@f§se",
"renforça" => "R@fORsa",
"renforçaient" => "R@fORsE",
"renforçait" => "R@fORsE",
"renforçant" => "R@fORs@",
"renforçât" => "R@fORsa",
"renforce" => "R@fORs",
"renforcé" => "R@fORse",
"renforcée" => "R@fORse",
"renforcées" => "R@fORse",
"renforcement" => "R@fORs°m@",
"renforcements" => "R@fORs°m@",
"renforcent" => "R@fORs",
"renforcer" => "R@fORse",
"renforcera" => "R@fORs°Ra",
"renforcerai" => "R@fORs°RE",
"renforceraient" => "R@fORs°RE",
"renforcerait" => "R@fORs°RE",
"renforcèrent" => "R@fORsER",
"renforcerez" => "R@fORs°Re",
"renforcerons" => "R@fORs°R§",
"renforcés" => "R@fORse",
"renforcez" => "R@fORse",
"renforciez" => "R@fORsje",
"renforçons" => "R@fORs§",
"renfort" => "R@fOR",
"renforts" => "R@fOR",
"renfourché" => "R@fuRSe",
"renfournait" => "R@fuRnE",
"renfrogna" => "R@fRoNa",
"renfrognait" => "R@fRoNE",
"renfrognant" => "R@fRoN@",
"renfrogne" => "R@fRON",
"renfrogné" => "R@fRoNe",
"renfrognée" => "R@fRoNe",
"renfrognement" => "R@fRON°m@",
"renfrogner" => "R@fRoNe",
"renfrognerait" => "R@fRON°RE",
"renfrognés" => "R@fRoNe",
"rengageait" => "R@gaZE",
"rengagement" => "R@gaZ°m@",
"rengager" => "R@gaZe",
"rengagerais" => "R@gaZ°RE",
"rengagés" => "R@gaZe",
"rengagez" => "R@gaZe",
"rengaina" => "R@gEna",
"rengainait" => "R@gEnE",
"rengainant" => "R@gEn@",
"rengaine" => "R@gEn",
"rengainé" => "R@gene",
"rengainer" => "R@gene",
"rengainèrent" => "R@gEnER",
"rengaines" => "R@gEn",
"rengainés" => "R@gEne",
"rengainez" => "R@gEne",
"rengorge" => "R@gORZ",
"rengorgé" => "R@gORZe",
"rengorgea" => "R@gORZa",
"rengorgeai" => "R@gORZE",
"rengorgeaient" => "R@gORZE",
"rengorgeais" => "R@gORZE",
"rengorgeait" => "R@gORZE",
"rengorgeant" => "R@gORZ@",
"rengorgement" => "R@gORZ°m@",
"rengorgements" => "R@gORZ°m@",
"rengorgent" => "R@gORZ",
"rengorger" => "R@gORZe",
"rengorges" => "R@gORZ",
"rengorgés" => "R@gORZe",
"rengracie" => "R@gRasi",
"rengracié" => "R@gRasje",
"renia" => "R°nja",
"reniai" => "R°njE",
"reniaient" => "R°njE",
"reniais" => "R°njE",
"reniait" => "R°njE",
"reniant" => "R°nj@",
"renie" => "R°ni",
"renié" => "R°nje",
"reniée" => "R°nje",
"reniées" => "R°nje",
"reniement" => "R°nim@",
"reniements" => "R°nim@",
"renient" => "R°ni",
"renier" => "R°nje",
"renierai" => "R°niRE",
"renierais" => "R°niRE",
"renierait" => "R°niRE",
"renieras" => "R°niRa",
"renièrent" => "R°njER",
"renieront" => "R°niR§",
"renies" => "R°ni",
"reniés" => "R°nje",
"reniez" => "R°nje",
"renifla" => "R°nifla",
"reniflage" => "R2niflaZ",
"reniflai" => "R°niflE",
"reniflaient" => "R°niflE",
"reniflais" => "R°niflE",
"reniflait" => "R°niflE",
"reniflant" => "R°nifl@",
"renifle" => "R°nifl",
"reniflé" => "R°nifle",
"reniflée" => "R°nifle",
"reniflées" => "R°nifle",
"reniflement" => "R°nifl°m@",
"reniflements" => "R°nifl°m@",
"reniflent" => "R°nifl",
"renifler" => "R°nifle",
"reniflera" => "R°nifl°Ra",
"reniflerait" => "R°nifl°RE",
"renifleries" => "R°nifl°Ri",
"reniflette" => "R°niflEt",
"renifleur" => "R°nifl9R",
"renifleurs" => "R°nifl9R",
"renifleuse" => "R°nifl2z",
"reniflez" => "R°nifle",
"rénine" => "Renin",
"renions" => "R°nj§",
"rennais" => "REnE",
"rennaises" => "REnEz",
"renne" => "REn",
"rennes" => "REn",
"renom" => "R°n§",
"renommait" => "R°nomE",
"renommé" => "R°nome",
"renommée" => "R°nome",
"renommées" => "R°nome",
"renommer" => "R°nome",
"renommera" => "R°nOm°Ra",
"renommés" => "R°nome",
"renommez" => "R°nome",
"renonça" => "R°n§sa",
"renonçai" => "R°n§sE",
"renonçaient" => "R°n§sE",
"renonçais" => "R°n§sE",
"renonçait" => "R°n§sE",
"renonçant" => "R°n§s@",
"renonçât" => "R°n§sa",
"renonce" => "R°n§s",
"renoncé" => "R°n§se",
"renoncée" => "R°n§se",
"renoncement" => "R°n§s°m@",
"renoncements" => "R°n§s°m@",
"renoncent" => "R°n§s",
"renoncer" => "R°n§se",
"renoncera" => "R°n§s°Ra",
"renoncerai" => "R°n§s°RE",
"renonceraient" => "R°n§s°RE",
"renoncerais" => "R°n§s°RE",
"renoncerait" => "R°n§s°RE",
"renonceras" => "R°n§s°Ra",
"renoncèrent" => "R°n§sER",
"renoncerez" => "R°n§s°Re",
"renonceriez" => "R°n§s°Rje",
"renoncerions" => "R°n§s°Rj§",
"renoncerons" => "R°n§s°R§",
"renonceront" => "R°n§s°R§",
"renonces" => "R°n§s",
"renoncez" => "R°n§se",
"renonciateur" => "R°n§sjat9R",
"renonciation" => "R°n§sjasj§",
"renonciations" => "R°n§sjasj§",
"renonciez" => "R°n§sje",
"renoncions" => "R°n§sj§",
"renonçons" => "R°n§s§",
"renonculacées" => "R°n§kylase",
"renoncule" => "R°n§kyl",
"renoncules" => "R°n§kyl",
"renoter" => "R2nOte",
"renoua" => "R°nwa",
"renouai" => "R°nwE",
"renouaient" => "R°nwE",
"renouais" => "R°nwE",
"renouait" => "R°nwE",
"renouant" => "R°nw@",
"renoue" => "R°nu",
"renoué" => "R°nwe",
"renouée" => "R°nwe",
"renouent" => "R°nu",
"renouer" => "R°nwe",
"renouerait" => "R°nuRE",
"renouèrent" => "R°nwER",
"renoueront" => "R°nuR§",
"renoués" => "R°nwe",
"renouons" => "R°nw§",
"renouveau" => "R°nuvo",
"renouveaux" => "R°nuvo",
"renouvela" => "R°nuv°la",
"renouvelable" => "R°nuv°labl",
"renouvelai" => "R°nuv°lE",
"renouvelaient" => "R°nuv°lE",
"renouvelais" => "R°nuv°lE",
"renouvelait" => "R°nuv°lE",
"renouvelâmes" => "R°nuv°lam",
"renouvelant" => "R°nuv°l@",
"renouvelât" => "R°nuv°la",
"renouvelé" => "R°nuv°le",
"renouvelée" => "R°nuv°le",
"renouvelées" => "R°nuv°le",
"renouveler" => "R°nuv°le",
"renouvelèrent" => "R°nuv°lER",
"renouvelés" => "R°nuv°le",
"renouvelez" => "R°nuv°le",
"renouvelions" => "R°nuv°lj§",
"renouvelle" => "R°nuvEl",
"renouvellement" => "R°nuvEl°m@",
"renouvellements" => "R°nuvEl°m@",
"renouvellent" => "R°nuvEl",
"renouvellera" => "R°nuvEl°Ra",
"renouvellerai" => "R°nuvEl°RE",
"renouvellerait" => "R°nuvEl°RE",
"renouvellerons" => "R°nuvEl°R§",
"renouvelleront" => "R°nuvEl°R§",
"renouvelles" => "R°nuvEl",
"renouvelons" => "R°nuv°l§",
"rénovait" => "RenovE",
"rénovant" => "Renov@",
"rénovateur" => "Renovat9R",
"rénovateurs" => "Renovat9R",
"rénovation" => "Renovasj§",
"rénovations" => "Renovasj§",
"rénovatrice" => "RenOvatRis",
"rénove" => "RenOv",
"rénové" => "Renove",
"rénovée" => "Renove",
"rénovées" => "Renove",
"rénover" => "Renove",
"rénovés" => "Renove",
"renquillait" => "R@kijE",
"renquille" => "R@kij",
"renquillé" => "R@kije",
"renseigna" => "R@sENa",
"renseignai" => "R@sENE",
"renseignaient" => "R@sENE",
"renseignais" => "R@sENE",
"renseignait" => "R@sENE",
"renseignant" => "R@sEN@",
"renseignât" => "R@sENa",
"renseigne" => "R@sEN",
"renseigné" => "R@seNe",
"renseignée" => "R@seNe",
"renseignées" => "R@seNe",
"renseignement" => "R@sEN°m@",
"renseignements" => "R@sEN°m@",
"renseignent" => "R@sEN",
"renseigner" => "R@seNe",
"renseignera" => "R@sEN°Ra",
"renseignerai" => "R@sEN°RE",
"renseigneraient" => "R@sEN°RE",
"renseignerais" => "R@sEN°RE",
"renseignerait" => "R@sEN°RE",
"renseigneras" => "R@sEN°Ra",
"renseignèrent" => "R@sENER",
"renseigneriez" => "R@sEN°Rje",
"renseignerons" => "R@sEN°R§",
"renseigneront" => "R@sEN°R§",
"renseignés" => "R@seNe",
"renseignez" => "R@sENe",
"renta" => "R@ta",
"rentabilisation" => "R@tabilizasj§",
"rentabilise" => "R@tabiliz",
"rentabilisé" => "R@tabilize",
"rentabilisée" => "R@tabilize",
"rentabiliser" => "R@tabilize",
"rentabilité" => "R@tabilite",
"rentable" => "R@tabl",
"rentables" => "R@tabl",
"rentamer" => "R@tame",
"rente" => "R@t",
"rentée" => "R@te",
"renter" => "R@te",
"rentes" => "R@t",
"rentier" => "R@tje",
"rentière" => "R@tjER",
"rentières" => "R@tjER",
"rentiers" => "R@tje",
"rentoilages" => "R@twalaZ",
"rentoilée" => "R@twale",
"rentra" => "R@tRa",
"rentrai" => "R@tRE",
"rentraient" => "R@tRE",
"rentrais" => "R@tRE",
"rentrait" => "R@tRE",
"rentrâmes" => "R@tRam",
"rentrant" => "R@tR@",
"rentrante" => "R@tR@t",
"rentrantes" => "R@tR@t",
"rentrants" => "R@tR@",
"rentrât" => "R@tRa",
"rentre" => "R@tR",
"rentré" => "R@tRe",
"rentre-dedans" => "R@tRd°d@",
"rentrée" => "R@tRe",
"rentrées" => "R@tRe",
"rentrent" => "R@tR",
"rentrer" => "R@tRe",
"rentrera" => "R@tR°Ra",
"rentrerai" => "R@tR°RE",
"rentreraient" => "R@tR°RE",
"rentrerais" => "R@tR°RE",
"rentrerait" => "R@tR°RE",
"rentreras" => "R@tR°Ra",
"rentrèrent" => "R@tRER",
"rentrerez" => "R@tR°Re",
"rentreriez" => "R@tR°Rje",
"rentrerions" => "R@tR°Rj§",
"rentrerons" => "R@tR°R§",
"rentreront" => "R@tR°R§",
"rentres" => "R@tR",
"rentrés" => "R@tRe",
"rentrez" => "R@tRe",
"rentriez" => "R@tRije",
"rentrions" => "R@tRij§",
"rentrons" => "R@tR§",
"renverra" => "R@vERa",
"renverrai" => "R@vERE",
"renverraient" => "R@vERE",
"renverrais" => "R@vERE",
"renverrait" => "R@vERE",
"renverras" => "R@vERa",
"renverrez" => "R@vERe",
"renverrions" => "R@vERj§",
"renverrons" => "R@vER§",
"renverront" => "R@vER§",
"renversa" => "R@vERsa",
"renversai" => "R@vERsE",
"renversaient" => "R@vERsE",
"renversais" => "R@vERsE",
"renversait" => "R@vERsE",
"renversant" => "R@vERs@",
"renversante" => "R@vERs@t",
"renversantes" => "R@vERs@t",
"renversât" => "R@vERsa",
"renverse" => "R@vERs",
"renversé" => "R@vERse",
"renversée" => "R@vERse",
"renversées" => "R@vERse",
"renversement" => "R@vERs°m@",
"renversements" => "R@vERs°m@",
"renversent" => "R@vERs",
"renverser" => "R@vERse",
"renversera" => "R@vERs°Ra",
"renverserai" => "R@vERs°RE",
"renverserais" => "R@vERs°RE",
"renverserait" => "R@vERs°RE",
"renverseras" => "R@vERs°Ra",
"renversèrent" => "R@vERsER",
"renverseront" => "R@vERs°R§",
"renverses" => "R@vERs",
"renversés" => "R@vERse",
"renverseur" => "R@vERs9R",
"renversez" => "R@vERse",
"renversons" => "R@vERs§",
"renvoi" => "R@vwa",
"renvoie" => "R@vwa",
"renvoient" => "R@vwa",
"renvoies" => "R@vwa",
"renvois" => "R@vwa",
"renvoya" => "R@vwaja",
"renvoyai" => "R@vwajE",
"renvoyaient" => "R@vwajE",
"renvoyais" => "R@vwajE",
"renvoyait" => "R@vwajE",
"renvoyant" => "R@vwaj@",
"renvoyât" => "R@vwaja",
"renvoyé" => "R@vwaje",
"renvoyée" => "R@vwaje",
"renvoyées" => "R@vwaje",
"renvoyer" => "R@vwaje",
"renvoyèrent" => "R@vwajER",
"renvoyés" => "R@vwaje",
"renvoyez" => "R@vwaje",
"renvoyiez" => "R@vwajje",
"renvoyions" => "R@vwaj§",
"renvoyons" => "R@vwaj§",
"réoccupait" => "ReokypE",
"réoccuper" => "Reokype",
"réoccupons" => "Reokyp§",
"réopère" => "ReopER",
"réopérer" => "ReopeRe",
"réordonnant" => "ReORdon@",
"réordonner" => "ReORdone",
"réorganisa" => "ReORganiza",
"réorganisait" => "ReORganizE",
"réorganisant" => "ReORganiz@",
"réorganisation" => "ReORganizasj§",
"réorganisations" => "ReORganizasj§",
"réorganise" => "ReORganiz",
"réorganisé" => "ReORganize",
"réorganisées" => "ReORganize",
"réorganiser" => "ReORganize",
"réorganisés" => "ReORganize",
"réorganisez" => "ReORganize",
"réorientation" => "ReORj@tasj§",
"réorienté" => "ReORj@te",
"réorienter" => "ReORj@te",
"réouverture" => "ReuvERtyR",
"réouvertures" => "ReuvERtyR",
"rep" => "REp",
"repaie" => "R°pE",
"repaies" => "R°pE",
"repaire" => "R°pER",
"repaires" => "R°pER",
"repais" => "R°pE",
"repaissaient" => "R°pEsE",
"repaissais" => "R°pEsE",
"repaissait" => "R°pEsE",
"repaissant" => "R°pEs@",
"repaissent" => "R°pEs",
"repaît" => "R°pE",
"repaître" => "R°pEtR",
"répand" => "Rep@",
"répandaient" => "Rep@dE",
"répandais" => "Rep@dE",
"répandait" => "Rep@dE",
"répandant" => "Rep@d@",
"répande" => "Rep@d",
"répandent" => "Rep@d",
"répandeur" => "Rep@d9R",
"répandez" => "Rep@de",
"répandirent" => "Rep@diR",
"répandit" => "Rep@di",
"répandît" => "Rep@di",
"répandons" => "Rep@d§",
"répandra" => "Rep@dRa",
"répandrai" => "Rep@dRE",
"répandraient" => "Rep@dRE",
"répandrait" => "Rep@dRE",
"répandras" => "Rep@dRa",
"répandre" => "Rep@dR",
"répandrez" => "Rep@dRe",
"répandrons" => "Rep@dR§",
"répandront" => "Rep@dR§",
"répands" => "Rep@",
"répandu" => "Rep@dy",
"répandue" => "Rep@dy",
"répandues" => "Rep@dy",
"répandus" => "Rep@dy",
"répara" => "RepaRa",
"réparable" => "RepaRabl",
"réparables" => "RepaRabl",
"réparaient" => "RepaRE",
"reparais" => "R°paRE",
"réparais" => "RepaRE",
"reparaissaient" => "R°paREsE",
"reparaissait" => "R°paREsE",
"reparaissant" => "R°paREs@",
"reparaisse" => "R°paREs",
"reparaissent" => "R°paREs",
"reparaissez" => "R°paREse",
"reparaissons" => "R°paREs§",
"réparait" => "RepaRE",
"reparaît" => "R°paRE",
"reparaîtra" => "R°paREtRa",
"reparaîtrait" => "R°paREtRE",
"reparaître" => "R°paREtR",
"réparant" => "RepaR@",
"réparateur" => "RepaRat9R",
"réparateurs" => "RepaRat9R",
"réparation" => "RepaRasj§",
"réparations" => "RepaRasj§",
"réparatrice" => "RepaRatRis",
"réparatrices" => "RepaRatRis",
"reparcourant" => "R2paRkuR@",
"reparcourir" => "R2paRkuRiR",
"reparcouru" => "R2paRkuRy",
"répare" => "RepaR",
"réparé" => "RepaRe",
"réparée" => "RepaRe",
"réparées" => "RepaRe",
"réparent" => "RepaR",
"réparer" => "RepaRe",
"réparera" => "RepaR°Ra",
"réparerai" => "RepaR°RE",
"répareraient" => "RepaR°RE",
"réparerait" => "RepaR°RE",
"répareras" => "RepaR°Ra",
"réparèrent" => "RepaRER",
"réparerez" => "RepaR°Re",
"réparerons" => "RepaR°R§",
"répareront" => "RepaR°R§",
"réparés" => "RepaRe",
"réparez" => "RepaRe",
"répariez" => "RepaRje",
"réparions" => "RepaRj§",
"reparla" => "R°paRla",
"reparlaient" => "R°paRlE",
"reparlais" => "R°paRlE",
"reparlait" => "R°paRlE",
"reparlâmes" => "R°paRlam",
"reparlant" => "R°paRl@",
"reparle" => "R°paRl",
"reparlé" => "R°paRle",
"reparlent" => "R°paRl",
"reparler" => "R°paRle",
"reparlera" => "R°paRl°Ra",
"reparlerai" => "R°paRl°RE",
"reparlerez" => "R°paRl°Re",
"reparlerions" => "R°paRl°Rj§",
"reparlerons" => "R°paRl°R§",
"reparles" => "R°paRl",
"reparlez" => "R°paRle",
"reparliez" => "R°paRlje",
"reparlons" => "R°paRl§",
"réparons" => "RepaR§",
"repars" => "R°paR",
"repart" => "R°paR",
"repartaient" => "R°paRtE",
"repartais" => "R°paRtE",
"repartait" => "R°paRtE",
"repartant" => "R°paRt@",
"reparte" => "R°paRt",
"repartent" => "R°paRt",
"repartes" => "R°paRt",
"repartez" => "R°paRte",
"reparti" => "R°paRti",
"réparti" => "RepaRti",
"repartie" => "R°paRti",
"répartie" => "RepaRti",
"reparties" => "R°paRti",
"réparties" => "RepaRti",
"repartiez" => "R°paRtje",
"repartîmes" => "R°paRtim",
"répartîmes" => "RepaRtim",
"repartions" => "R°paRtj§",
"repartir" => "R°paRtiR",
"répartir" => "RepaRtiR",
"repartira" => "R°paRtiRa",
"repartirai" => "R°paRtiRE",
"repartiraient" => "R°paRtiRE",
"repartirais" => "R°paRtiRE",
"repartirait" => "R°paRtiRE",
"repartiras" => "R°paRtiRa",
"repartirent" => "R°paRtiR",
"répartirent" => "RepaRtiR",
"repartirez" => "R°paRtiRe",
"repartirons" => "R°paRtiR§",
"repartiront" => "R°paRtiR§",
"répartiront" => "RepaRtiR§",
"repartis" => "R°paRti",
"répartis" => "RepaRti",
"répartissaient" => "RepaRtisE",
"répartissait" => "RepaRtisE",
"répartissant" => "RepaRtis@",
"repartisse" => "R°paRtis",
"répartissent" => "RepaRtis",
"répartissez" => "RepaRtise",
"répartissons" => "RepaRtis§",
"repartit" => "R°paRti",
"répartit" => "RepaRti",
"repartît" => "R°paRti",
"répartiteur" => "RepaRtit9R",
"répartition" => "RepaRtisj§",
"répartitions" => "RepaRtisj§",
"repartons" => "R°paRt§",
"reparu" => "R°paRy",
"reparue" => "R°paRy",
"reparurent" => "R°paRyR",
"reparut" => "R°paRy",
"reparût" => "R°paRy",
"repas" => "R°pa",
"repassa" => "R°pasa",
"repassage" => "R°pasaZ",
"repassages" => "R°pasaZ",
"repassai" => "R°pasE",
"repassaient" => "R°pasE",
"repassais" => "R°pasE",
"repassait" => "R°pasE",
"repassant" => "R°pas@",
"repasse" => "R°pas",
"repassé" => "R°pase",
"repassée" => "R°pase",
"repassées" => "R°pase",
"repassent" => "R°pas",
"repasser" => "R°pase",
"repassera" => "R°pas°Ra",
"repasserai" => "R°pas°RE",
"repasseraient" => "R°pas°RE",
"repasserais" => "R°pas°RE",
"repasserait" => "R°pas°RE",
"repasseras" => "R°pas°Ra",
"repasserez" => "R°pas°Re",
"repasserons" => "R°pas°R§",
"repasseront" => "R°pas°R§",
"repasses" => "R°pas",
"repassés" => "R°pase",
"repasseur" => "R°pas9R",
"repasseuse" => "R°pas2z",
"repasseuses" => "R°pas2z",
"repassez" => "R°pase",
"repassiez" => "R°pasje",
"repassions" => "R°pasj§",
"repassons" => "R°pas§",
"repavage" => "R2pavaZ",
"repavé" => "R°pave",
"repaver" => "R2pave",
"repayais" => "R°pEjE",
"repayait" => "R°pEjE",
"repaye" => "R°pEj",
"repayé" => "R°pEje",
"repayer" => "R°pEje",
"repêcha" => "R°pESa",
"repêchage" => "R°pESaZ",
"repêchages" => "R°pESaZ",
"repêchai" => "R°pESE",
"repêchait" => "R°pESE",
"repêchant" => "R2pES@",
"repêche" => "R°pES",
"repêché" => "R°peSe",
"repêchée" => "R°peSe",
"repêchées" => "R°peSe",
"repêcher" => "R°peSe",
"repêchera" => "R°pES°Ra",
"repêcherait" => "R°pES°RE",
"repêchèrent" => "R°pESER",
"repêches" => "R°pES",
"repêchés" => "R°peSe",
"repeigna" => "R°pENa",
"repeignais" => "R°pENE",
"repeignait" => "R°pENE",
"repeignant" => "R°pEN@",
"repeigne" => "R°pEN",
"repeigné" => "R°pENe",
"repeignée" => "R°pENe",
"repeignées" => "R°pENe",
"repeignent" => "R°pEN",
"repeignez" => "R°pENe",
"repeignit" => "R°pENi",
"repeindra" => "R°p5dRa",
"repeindrai" => "R°p5dRE",
"repeindrait" => "R°p5dRE",
"repeindre" => "R°p5dR",
"repeins" => "R°p5",
"repeint" => "R°p5",
"repeinte" => "R°p5t",
"repeintes" => "R°p5t",
"repeints" => "R°p5",
"rependra" => "R°p@dRa",
"rependre" => "R2p@dR",
"repends" => "R°p@",
"rependu" => "R°p@dy",
"rependus" => "R°p@dy",
"repens" => "R°p@",
"repensa" => "R°p@sa",
"repensai" => "R°p@sE",
"repensais" => "R°p@sE",
"repensait" => "R°p@sE",
"repensant" => "R°p@s@",
"repense" => "R°p@s",
"repensé" => "R°p@se",
"repensée" => "R°p@se",
"repensent" => "R°p@s",
"repenser" => "R°p@se",
"repensera" => "R°p@s°Ra",
"repenserai" => "R°p@s°RE",
"repenserais" => "R°p@s°RE",
"repenserez" => "R°p@s°Re",
"repenses" => "R°p@s",
"repensez" => "R°p@se",
"repensons" => "R°p@s§",
"repent" => "R°p@",
"repentaient" => "R°p@tE",
"repentait" => "R°p@tE",
"repentance" => "R°p@t@s",
"repentant" => "R°p@t@",
"repentante" => "R°p@t@t",
"repentantes" => "R°p@t@t",
"repentants" => "R°p@t@",
"repentent" => "R°p@t",
"repentez" => "R°p@te",
"repenti" => "R°p@ti",
"repentie" => "R°p@ti",
"repenties" => "R°p@ti",
"repentir" => "R°p@tiR",
"repentira" => "R°p@tiRa",
"repentirai" => "R°p@tiRE",
"repentirais" => "R°p@tiRE",
"repentiras" => "R°p@tiRa",
"repentirez" => "R°p@tiRe",
"repentirs" => "R°p@tiR",
"repentis" => "R°p@ti",
"repentisse" => "R°p@tis",
"repentissent" => "R°p@tis",
"repentit" => "R°p@ti",
"repentons" => "R°p@t§",
"repéra" => "R°peRa",
"repérable" => "R°peRabl",
"repérables" => "R°peRabl",
"repérage" => "R°peRaZ",
"repérages" => "R°peRaZ",
"repéraient" => "R°peRE",
"repérais" => "R°peRE",
"repérait" => "R°peRE",
"repérant" => "R°peR@",
"répercussion" => "RepERkysj§",
"répercussions" => "RepERkysj§",
"répercuta" => "RepERkyta",
"répercutaient" => "RepERkytE",
"répercutait" => "RepERkytE",
"répercutant" => "RepERkyt@",
"répercute" => "RepERkyt",
"répercuté" => "RepERkyte",
"répercutée" => "RepERkyte",
"répercutées" => "RepERkyte",
"répercutent" => "RepERkyt",
"répercuter" => "RepERkyte",
"répercuterait" => "RepERkyt°RE",
"répercutèrent" => "RepERkytER",
"répercuteront" => "RepERkyt°R§",
"répercutés" => "RepERkyte",
"répercutons" => "RepERkyt§",
"reperdaient" => "R°pERdE",
"reperdais" => "R°pERdE",
"reperdons" => "R°pERd§",
"reperdre" => "R°pERdR",
"reperds" => "R°pERd",
"reperdu" => "R°pERdy",
"reperdue" => "R°pERdy",
"reperdues" => "R°pERdy",
"repère" => "R°pER",
"repéré" => "R°peRe",
"repérée" => "R°peRe",
"repérées" => "R°peRe",
"repèrent" => "R°pER",
"repérer" => "R°peRe",
"repérera" => "R°peR°Ra",
"repérerai" => "R°peR°RE",
"repéreraient" => "R°peR°RE",
"repérerais" => "R°peR°RE",
"repérerait" => "R°peR°RE",
"repérèrent" => "R°peRER",
"repérerons" => "R°peR°R§",
"repéreront" => "R°peR°R§",
"repères" => "R°pER",
"repérés" => "R°peRe",
"repéreur" => "R2peR9R",
"repérez" => "R°peRe",
"repériez" => "R°peRje",
"repérions" => "R°peRj§",
"répertoire" => "RepERtwaR",
"répertoires" => "RepERtwaR",
"répertoriant" => "RepERtoRj@",
"répertorié" => "RepERtoRje",
"répertoriée" => "RepERtoRje",
"répertoriées" => "RepERtoRje",
"répertorier" => "RepERtoRje",
"répertoriés" => "RepERtoRje",
"répéta" => "Repeta",
"répétai" => "RepetE",
"répétaient" => "RepetE",
"répétais" => "RepetE",
"répétait" => "RepetE",
"répétant" => "Repet@",
"répétât" => "Repeta",
"répète" => "RepEt",
"répété" => "Repete",
"répétée" => "Repete",
"répétées" => "Repete",
"répètent" => "RepEt",
"répéter" => "Repete",
"répétera" => "Repet°Ra",
"répéterai" => "Repet°RE",
"répéteraient" => "Repet°RE",
"répéterais" => "Repet°RE",
"répéterait" => "Repet°RE",
"répéteras" => "Repet°Ra",
"répétèrent" => "RepetER",
"répéterez" => "Repet°Re",
"répéteriez" => "Repet°Rje",
"répètes" => "RepEt",
"répétés" => "Repete",
"répétez" => "Repete",
"répétiez" => "Repetje",
"répétions" => "Repetj§",
"répétiteur" => "Repetit9R",
"répétiteurs" => "Repetit9R",
"répétitif" => "Repetitif",
"répétitifs" => "Repetitif",
"répétition" => "Repetisj§",
"répétitions" => "Repetisj§",
"répétitive" => "Repetitiv",
"répétitives" => "Repetitiv",
"répétitrice" => "RepetitRis",
"répétons" => "Repet§",
"repétrir" => "R°petRiR",
"repétrissait" => "R°petRisE",
"repétrit" => "R°petRi",
"repeuplaient" => "R°p9plE",
"repeuplait" => "R°p9plE",
"repeuple" => "R°p9pl",
"repeuplée" => "R°p9ple",
"repeuplées" => "R°p9ple",
"repeuplement" => "R°p9pl°m@",
"repeupler" => "R°p9ple",
"repincé" => "R°p5se",
"repincer" => "R°p5se",
"repiqua" => "R°pika",
"repiquage" => "R°pikaZ",
"repiquaient" => "R°pikE",
"repiquait" => "R°pikE",
"repique" => "R°pik",
"repiqué" => "R°pike",
"repiquées" => "R°pike",
"repiquer" => "R°pike",
"repiquerai" => "R°pik°RE",
"répit" => "Repi",
"répits" => "Repi",
"replaça" => "R°plasa",
"replaçaient" => "R°plasE",
"replaçais" => "R°plasE",
"replaçait" => "R°plasE",
"replaçant" => "R°plas@",
"replace" => "R°plas",
"replacé" => "R°plase",
"replacée" => "R°plase",
"replacement" => "R°plas°m@",
"replacent" => "R°plas",
"replacer" => "R°plase",
"replacerai" => "R°plas°RE",
"replacèrent" => "R°plasER",
"replacerez" => "R°plas°Re",
"replacés" => "R°plase",
"replacez" => "R°plase",
"replaçons" => "R°plas§",
"replanta" => "R°pl@ta",
"replantait" => "R°pl@tE",
"replantation" => "R°pl@tasj§",
"replante" => "R°pl@t",
"replanté" => "R°pl@te",
"replantée" => "R°pl@te",
"replantées" => "R°pl@te",
"replantent" => "R°pl@t",
"replanter" => "R°pl@te",
"replantés" => "R°pl@te",
"replantez" => "R°pl@te",
"replat" => "R°pla",
"replâtra" => "R°platRa",
"replâtrage" => "R°platRaZ",
"replâtraient" => "R°platRE",
"replâtré" => "R°platRe",
"replâtrée" => "R°platRe",
"replâtrées" => "R°platRe",
"replâtrer" => "R°platRe",
"replâtrerait" => "R°platR°RE",
"replats" => "R°pla",
"replet" => "R°plE",
"replète" => "R°plEt",
"replètes" => "R°plEt",
"replets" => "R°plE",
"repli" => "R°pli",
"replia" => "R°plija",
"repliai" => "R°plijE",
"repliaient" => "R°plijE",
"repliais" => "R°plijE",
"repliait" => "R°plijE",
"repliant" => "R°plij@",
"repliât" => "R°plja",
"réplication" => "Replikasj§",
"replie" => "R°pli",
"replié" => "R°plije",
"repliée" => "R°plije",
"repliées" => "R°plije",
"repliement" => "R°plim@",
"replient" => "R°pli",
"replier" => "R°plije",
"repliera" => "R°pliRa",
"replierai" => "R°pliRE",
"replièrent" => "R°plijER",
"replierez" => "R°pliRe",
"replierons" => "R°pliR§",
"replieront" => "R°pliR§",
"replies" => "R°pli",
"repliés" => "R°plije",
"repliez" => "R°plije",
"replions" => "R°plij§",
"répliqua" => "Replika",
"répliquai" => "ReplikE",
"répliquaient" => "ReplikE",
"répliquais" => "ReplikE",
"répliquait" => "ReplikE",
"répliquant" => "Replik@",
"répliquât" => "Replika",
"réplique" => "Replik",
"répliqué" => "Replike",
"répliquent" => "Replik",
"répliquer" => "Replike",
"répliquera" => "Replik°Ra",
"répliquèrent" => "ReplikER",
"répliquerons" => "Replik°R§",
"répliqueront" => "Replik°R§",
"répliques" => "Replik",
"replis" => "R°pli",
"replonge" => "R°pl§Z",
"replongé" => "R°pl§Ze",
"replongea" => "R°pl§Za",
"replongeai" => "R°pl§ZE",
"replongeaient" => "R°pl§ZE",
"replongeais" => "R°pl§ZE",
"replongeait" => "R°pl§ZE",
"replongeant" => "R°pl§Z@",
"replongée" => "R°pl§Ze",
"replongées" => "R°pl§Ze",
"replongent" => "R°pl§Z",
"replonger" => "R°pl§Ze",
"replongera" => "R°pl§Z°Ra",
"replongerai" => "R°pl§Z°RE",
"replongerais" => "R°pl§Z°RE",
"replongerait" => "R°pl§Z°RE",
"replonges" => "R°pl§Z",
"replongés" => "R°pl§Ze",
"replongiez" => "R°pl§Zje",
"reployait" => "R°plwajE",
"répond" => "Rep§",
"répondaient" => "Rep§dE",
"répondais" => "Rep§dE",
"répondait" => "Rep§dE",
"répondant" => "Rep§d@",
"répondants" => "Rep§d@",
"réponde" => "Rep§d",
"répondent" => "Rep§d",
"répondes" => "Rep§d",
"répondeur" => "Rep§d9R",
"répondeurs" => "Rep§d9R",
"répondeuse" => "Rep§d2z",
"répondez" => "Rep§de",
"répondiez" => "Rep§dje",
"répondîmes" => "Rep§dim",
"répondions" => "Rep§dj§",
"répondirent" => "Rep§diR",
"répondis" => "Rep§di",
"répondit" => "Rep§di",
"répondît" => "Rep§di",
"répondons" => "Rep§d§",
"répondra" => "Rep§dRa",
"répondrai" => "Rep§dRE",
"répondraient" => "Rep§dRE",
"répondrais" => "Rep§dRE",
"répondrait" => "Rep§dRE",
"répondras" => "Rep§dRa",
"répondre" => "Rep§dR",
"répondrez" => "Rep§dRe",
"répondriez" => "Rep§dRije",
"répondrons" => "Rep§dR§",
"répondront" => "Rep§dR§",
"réponds" => "Rep§",
"répondu" => "Rep§dy",
"répondues" => "Rep§dy",
"répons" => "Rep§",
"réponse" => "Rep§s",
"réponses" => "Rep§s",
"report" => "R°pOR",
"reporta" => "R°pORta",
"reportage" => "R°pORtaZ",
"reportage-vérité" => "R°pORtaZveRite",
"reportages" => "R°pORtaZ",
"reportait" => "R°pORtE",
"reportant" => "R°pORt@",
"reporte" => "R°pORt",
"reporté" => "R°pORte",
"reportée" => "R°pORte",
"reportées" => "R°pORte",
"reportent" => "R°pORt",
"reporter" => "R°poRtER",
"reportera" => "R°pORt°Ra",
"reporterai" => "R°pORt°RE",
"reporterait" => "R°pORt°RE",
"reportèrent" => "R°pORtER",
"reporters" => "R°pORtER",
"reportés" => "R°pORte",
"reportez" => "R°pORte",
"reportons" => "R°pORt§",
"reports" => "R°pOR",
"repos" => "R°po",
"reposa" => "R°poza",
"reposai" => "R°pozE",
"reposaient" => "R°pozE",
"reposais" => "R°pozE",
"reposait" => "R°pozE",
"reposant" => "R°poz@",
"reposante" => "R°poz@t",
"reposantes" => "R°poz@t",
"reposants" => "R°poz@",
"reposât" => "R°poza",
"repose" => "R°poz",
"reposé" => "R°poze",
"repose-pied" => "R°pozpje",
"repose-pieds" => "R°pozpje",
"reposée" => "R°poze",
"reposées" => "R°poze",
"reposent" => "R°poz",
"reposer" => "R°poze",
"reposera" => "R°poz°Ra",
"reposerai" => "R°poz°RE",
"reposeraient" => "R°poz°RE",
"reposerais" => "R°poz°RE",
"reposerait" => "R°poz°RE",
"reposeras" => "R°poz°Ra",
"reposèrent" => "R°pozER",
"reposerez" => "R°poz°Re",
"reposerions" => "R°poz°Rj§",
"reposerons" => "R°poz°R§",
"reposeront" => "R°poz°R§",
"reposes" => "R°poz",
"reposés" => "R°poze",
"reposez" => "R°poze",
"reposiez" => "R°pozje",
"reposions" => "R°pozj§",
"repositionnent" => "R°pozisjon",
"repositionner" => "R°pozisjone",
"repositionnez" => "R°pozisjone",
"reposoir" => "R°pozwaR",
"reposoirs" => "R°pozwaR",
"reposons" => "R°poz§",
"reposséder" => "R2pOsede",
"repostait" => "R°postE",
"repoudraient" => "R°pudRE",
"repoudrait" => "R°pudRE",
"repoudrant" => "R°pudR@",
"repoudre" => "R°pudR",
"repoudré" => "R2pudRe",
"repoudrée" => "R°pudRe",
"repoudrer" => "R°pudRe",
"repoussa" => "R°pusa",
"repoussage" => "R°pusaZ",
"repoussai" => "R°pusE",
"repoussaient" => "R°pusE",
"repoussais" => "R°pusE",
"repoussait" => "R°pusE",
"repoussâmes" => "R°pusam",
"repoussant" => "R°pus@",
"repoussante" => "R°pus@t",
"repoussantes" => "R°pus@t",
"repoussants" => "R°pus@",
"repoussât" => "R°pusa",
"repousse" => "R°pus",
"repoussé" => "R°puse",
"repoussée" => "R°puse",
"repoussées" => "R°puse",
"repoussent" => "R°pus",
"repousser" => "R°puse",
"repoussera" => "R°pus°Ra",
"repousserai" => "R°pus°RE",
"repousseraient" => "R°pus°RE",
"repousserais" => "R°pus°RE",
"repousserait" => "R°pus°RE",
"repoussèrent" => "R°pusER",
"repousserons" => "R°pus°R§",
"repousseront" => "R°pus°R§",
"repousses" => "R°pus",
"repoussés" => "R°puse",
"repoussez" => "R°puse",
"repoussions" => "R°pusj§",
"repoussoir" => "R°puswaR",
"repoussoirs" => "R°puswaR",
"repoussons" => "R°pus§",
"répréhensible" => "RepRe@sibl",
"répréhensibles" => "RepRe@sibl",
"reprenaient" => "R°pR°nE",
"reprenais" => "R°pR°nE",
"reprenait" => "R°pR°nE",
"reprenant" => "R°pR°n@",
"reprend" => "R°pR@",
"reprendra" => "R°pR@dRa",
"reprendrai" => "R°pR@dRE",
"reprendraient" => "R°pR@dRE",
"reprendrais" => "R°pR@dRE",
"reprendrait" => "R°pR@dRE",
"reprendras" => "R°pR@dRa",
"reprendre" => "R°pR@dR",
"reprendrez" => "R°pR@dRe",
"reprendriez" => "R°pR@dRije",
"reprendrions" => "R°pR@dRij§",
"reprendrons" => "R°pR@dR§",
"reprendront" => "R°pR@dR§",
"reprends" => "R°pR@",
"repreneur" => "R°pR°n9R",
"repreneurs" => "R°pR°n9R",
"reprenez" => "R°pR°ne",
"repreniez" => "R°pR°nje",
"reprenions" => "R°pR°nj§",
"reprenne" => "R°pREn",
"reprennent" => "R°pREn",
"reprennes" => "R°pREn",
"reprenons" => "R°pR°n§",
"représailles" => "R°pRezaj",
"représenta" => "R°pRez@ta",
"représentai" => "R°pRez@tE",
"représentaient" => "R°pRez@tE",
"représentais" => "R°pRez@tE",
"représentait" => "R°pRez@tE",
"représentant" => "R°pRez@t@",
"représentante" => "R°pRez@t@t",
"représentantes" => "R°pRez@t@t",
"représentants" => "R°pRez@t@",
"représentât" => "R°pRez@ta",
"représentatif" => "R°pRez@tatif",
"représentatifs" => "R°pRez@tatif",
"représentation" => "R°pRez@tasj§",
"représentations" => "R°pRez@tasj§",
"représentative" => "R°pRez@tativ",
"représentatives" => "R°pRez@tativ",
"représente" => "R°pRez@t",
"représenté" => "R°pRez@te",
"représentée" => "R°pRez@te",
"représentées" => "R°pRez@te",
"représentent" => "R°pRez@t",
"représenter" => "R°pRez@te",
"représentera" => "R°pRez@t°Ra",
"représenterai" => "R°pRez@t°RE",
"représenteraient" => "R°pRez@t°RE",
"représenterais" => "R°pRez@t°RE",
"représenterait" => "R°pRez@t°RE",
"représenteras" => "R°pRez@t°Ra",
"représentèrent" => "R°pRez@tER",
"représenterez" => "R°pRez@t°Re",
"représenteront" => "R°pRez@t°R§",
"représentes" => "R°pRez@t",
"représentés" => "R°pRez@te",
"représentez" => "R°pRez@te",
"représentiez" => "R°pRez@tje",
"représentions" => "R°pRez@tj§",
"représentons" => "R°pRez@t§",
"répresseur" => "RepRes9R",
"répressif" => "RepResif",
"répression" => "RepResj§",
"répressions" => "RepResj§",
"répressive" => "RepResiv",
"répressives" => "RepResiv",
"réprima" => "RepRima",
"réprimai" => "RepRimE",
"réprimaient" => "RepRimE",
"réprimais" => "RepRimE",
"réprimait" => "RepRimE",
"réprimâmes" => "RepRimam",
"réprimanda" => "RepRim@da",
"réprimandait" => "RepRim@dE",
"réprimande" => "RepRim@d",
"réprimandé" => "RepRim@de",
"réprimandée" => "RepRim@de",
"réprimander" => "RepRim@de",
"réprimandes" => "RepRim@d",
"réprimandiez" => "RepRim@dje",
"réprimant" => "RepRim@",
"réprime" => "RepRim",
"réprimé" => "RepRime",
"réprimée" => "RepRime",
"réprimées" => "RepRime",
"réprimer" => "RepRime",
"réprimerai" => "RepRim°RE",
"réprimerait" => "RepRim°RE",
"réprimèrent" => "RepRimER",
"réprimerez" => "RepRim°Re",
"reprîmes" => "R°pRim",
"réprimés" => "RepRime",
"reprirent" => "R°pRiR",
"repris" => "R°pRi",
"reprisaient" => "R°pRizE",
"reprisait" => "R°pRizE",
"reprisant" => "R°pRiz@",
"reprise" => "R°pRiz",
"reprisé" => "R°pRize",
"reprisée" => "R°pRize",
"reprisées" => "R°pRize",
"reprisent" => "R°pRiz",
"repriser" => "R°pRize",
"reprises" => "R°pRiz",
"reprisés" => "R°pRize",
"reprisse" => "R°pRis",
"reprissent" => "R°pRis",
"reprit" => "R°pRi",
"reprît" => "R°pRi",
"réprobateur" => "RepRobat9R",
"réprobateurs" => "RepRobat9R",
"réprobation" => "RepRobasj§",
"réprobatrice" => "RepRobatRis",
"reprocha" => "R°pRoSa",
"reprochai" => "R°pRoSE",
"reprochaient" => "R°pRoSE",
"reprochais" => "R°pRoSE",
"reprochait" => "R°pRoSE",
"reprochant" => "R°pRoS@",
"reprochât" => "R°pRoSa",
"reproche" => "R°pROS",
"reproché" => "R°pRoSe",
"reprochée" => "R°pRoSe",
"reprochées" => "R°pRoSe",
"reprochent" => "R°pROS",
"reprocher" => "R°pRoSe",
"reprochera" => "R°pROS°Ra",
"reprocherai" => "R°pROS°RE",
"reprocherais" => "R°pROS°RE",
"reprocherait" => "R°pROS°RE",
"reprocheras" => "R°pROS°Ra",
"reprochèrent" => "R°pRoSER",
"reprocheriez" => "R°pRoS°Rje",
"reprocherons" => "R°pROS°R§",
"reprocheront" => "R°pROS°R§",
"reproches" => "R°pROS",
"reprochés" => "R°pRoSe",
"reprochez" => "R°pRoSe",
"reprochiez" => "R°pRoSje",
"reprochions" => "R°pRoSj§",
"reprochons" => "R°pRoS§",
"reproducteur" => "R°pRodykt9R",
"reproducteurs" => "R°pRodykt9R",
"reproductible" => "R°pRodyktibl",
"reproductif" => "R°pRodyktif",
"reproductifs" => "R°pRodyktif",
"reproduction" => "R°pRodyksj§",
"reproductions" => "R°pRodyksj§",
"reproductive" => "R2pROdyktiv",
"reproductrice" => "R°pRodyktRis",
"reproductrices" => "R°pRodyktRis",
"reproduira" => "R°pRod8iRa",
"reproduirai" => "R°pRod8iRE",
"reproduiraient" => "R°pRod8iRE",
"reproduirait" => "R°pRod8iRE",
"reproduire" => "R°pRod8iR",
"reproduirons" => "R°pRod8iR§",
"reproduiront" => "R°pRod8iR§",
"reproduis" => "R°pRod8i",
"reproduisaient" => "R°pRod8izE",
"reproduisait" => "R°pRod8izE",
"reproduisant" => "R°pRod8iz@",
"reproduise" => "R°pRod8iz",
"reproduisent" => "R°pRod8iz",
"reproduisez" => "R°pRod8ize",
"reproduisirent" => "R°pRod8iziR",
"reproduisit" => "R°pRod8izi",
"reproduisît" => "R°pRod8izi",
"reproduisons" => "R°pRod8iz§",
"reproduit" => "R°pRod8i",
"reproduite" => "R°pRod8it",
"reproduites" => "R°pRod8it",
"reproduits" => "R°pRod8i",
"reprogrammant" => "R°pRogRam@",
"reprogramme" => "R°pRogRam",
"reprogrammé" => "R°pRogRame",
"reprogrammée" => "R°pRogRame",
"reprogramment" => "R°pRogRam",
"reprogrammer" => "R°pRogRam9R",
"reprogrammera" => "R°pRogRam°Ra",
"reprogrammés" => "R°pRogRame",
"reprographie" => "R°pRogRafi",
"reproposer" => "R2pROpoze",
"réprouvais" => "RepRuvE",
"réprouvait" => "RepRuvE",
"réprouvant" => "RepRuv@",
"réprouvât" => "RepRuva",
"réprouve" => "RepRuv",
"réprouvé" => "RepRuve",
"réprouvées" => "RepRuve",
"réprouvent" => "RepRuv",
"réprouver" => "RepRuve",
"réprouverait" => "RepRuv°RE",
"réprouveront" => "RepRuv°R§",
"réprouves" => "RepRuv",
"réprouvés" => "RepRuve",
"réprouvez" => "RepRuve",
"réprouvons" => "RepRuv§",
"reps" => "REps",
"reptation" => "REptasj§",
"reptations" => "REptasj§",
"reptile" => "REptil",
"reptiles" => "REptil",
"reptilien" => "REptilj5",
"reptilienne" => "REptiljEn",
"reptiliennes" => "REptiljEn",
"reptiliens" => "REptilj5",
"repu" => "R°py",
"républicain" => "Repyblik5",
"républicaine" => "RepyblikEn",
"républicaines" => "RepyblikEn",
"républicains" => "Repyblik5",
"republication" => "R2pyblikasj§",
"republier" => "R°pyblije",
"republions" => "R°pybli§",
"république" => "Repyblik",
"républiques" => "Repyblik",
"répudiant" => "Repydj@",
"répudiation" => "Repydjasj§",
"répudie" => "Repydi",
"répudié" => "Repydje",
"répudiée" => "Repydje",
"répudiées" => "Repydje",
"répudier" => "Repydje",
"répudiera" => "RepydiRa",
"répudierai" => "RepydiRE",
"répudies" => "Repydi",
"répudiés" => "Repydje",
"repue" => "R°py",
"repues" => "R°py",
"répugna" => "RepyNa",
"répugnai" => "RepyNE",
"répugnaient" => "RepyNE",
"répugnais" => "RepyNE",
"répugnait" => "RepyNE",
"répugnance" => "RepyN@s",
"répugnances" => "RepyN@s",
"répugnant" => "RepyN@",
"répugnante" => "RepyN@t",
"répugnantes" => "RepyN@t",
"répugnants" => "RepyN@",
"répugnât" => "RepyNa",
"répugne" => "RepyN",
"répugné" => "RepyNe",
"répugnée" => "RepyNe",
"répugnent" => "RepyN",
"répugner" => "RepyNe",
"répugnerait" => "RepyN°RE",
"répugneront" => "RepyN°R§",
"répugnes" => "RepyN",
"répugnez" => "RepyNe",
"répugniez" => "RepyNe",
"répugnons" => "RepyN§",
"repuiser" => "R2p8ize",
"répulsif" => "Repylsif",
"répulsion" => "Repylsj§",
"répulsions" => "Repylsj§",
"répulsive" => "Repylsiv",
"repus" => "R°py",
"réputaient" => "RepytE",
"réputait" => "RepytE",
"réputation" => "Repytasj§",
"réputations" => "Repytasj§",
"répute" => "Repyt",
"réputé" => "Repyte",
"réputée" => "Repyte",
"réputées" => "Repyte",
"réputent" => "Repyt",
"réputer" => "Repyte",
"réputés" => "Repyte",
"requalifier" => "R2kalifje",
"requéraient" => "R°keRE",
"requérais" => "R°keRE",
"requérait" => "R°keRE",
"requérant" => "R°keR@",
"requérante" => "R°keR@t",
"requérants" => "R°keR@",
"requérir" => "R°keRiR",
"requérons" => "R°keR§",
"requête" => "R°kEt",
"requêtes" => "R°kEt",
"requiem" => "Rek8ijEm",
"requiems" => "Rek8ijEm",
"requière" => "R°kjER",
"requièrent" => "R°kjER",
"requiers" => "R°kjER",
"requiert" => "R°kjER",
"requiescat in pace" => "R°kijEskainpas",
"requin" => "R°k5",
"requin-baleine" => "R2k5balEn",
"requin-tigre" => "R2k5tigR",
"requinqua" => "R°k5ka",
"requinquait" => "R°k5kE",
"requinque" => "R°k5k",
"requinqué" => "R°k5ke",
"requinquée" => "R°k5ke",
"requinquent" => "R°k5k",
"requinquer" => "R°k5ke",
"requinquera" => "R°kik°Ra",
"requinquerait" => "R°kik°RE",
"requinqués" => "R°k5ke",
"requins" => "R°k5",
"requins-marteaux" => "R°k5maRto",
"requis" => "R°ki",
"requise" => "R°kiz",
"requises" => "R°kiz",
"réquisition" => "Rekizisj§",
"réquisitionnais" => "RekizisjonE",
"réquisitionnait" => "RekizisjonE",
"réquisitionnant" => "Rekizisjon@",
"réquisitionne" => "RekizisjOn",
"réquisitionné" => "Rekizisjone",
"réquisitionnée" => "Rekizisjone",
"réquisitionnées" => "Rekizisjone",
"réquisitionner" => "Rekizisjone",
"réquisitionnés" => "Rekizisjone",
"réquisitionnez" => "Rekizisjone",
"réquisitionnons" => "Rekizisjon§",
"réquisitions" => "Rekizisj§",
"réquisitoire" => "RekizitwaR",
"réquisitoires" => "RekizitwaR",
"resalir" => "R2saliR",
"resape" => "R°sap",
"resapée" => "R°sape",
"resapent" => "R°sap",
"resapés" => "R°sape",
"rescapé" => "REskape",
"rescapée" => "REskape",
"rescapées" => "REskape",
"rescaper" => "REskape",
"rescapes" => "REskape",
"rescapés" => "REskape",
"rescision" => "Resizj§",
"rescousse" => "REskus",
"rescrit" => "REskRi",
"réseau" => "Rezo",
"réseaux" => "Rezo",
"résection" => "Reseksj§",
"réséda" => "Rezeda",
"résédas" => "Rezeda",
"réséquer" => "Reseke",
"réserva" => "RezERva",
"réservai" => "RezERvE",
"réservaient" => "RezERvE",
"réservais" => "RezERvE",
"réservait" => "RezERvE",
"réservant" => "RezERv@",
"réservât" => "RezERva",
"réservataire" => "RezERvatER",
"réservation" => "RezERvasj§",
"réservations" => "RezERvasj§",
"réserve" => "RezERv",
"réservé" => "RezERve",
"réservée" => "RezERve",
"réservées" => "RezERve",
"réservent" => "RezERv",
"réserver" => "RezERve",
"réservera" => "RezERv°Ra",
"réserverai" => "RezERv°RE",
"réserverait" => "RezERv°RE",
"réservèrent" => "RezERvER",
"réserveriez" => "RezERv°Rje",
"réserveront" => "RezERv°R§",
"réserves" => "RezERv",
"réservés" => "RezERve",
"réservez" => "RezERve",
"réserviez" => "RezERvje",
"réservions" => "RezERvj§",
"reservir" => "R2sERviR",
"réserviste" => "RezERvist",
"réservistes" => "RezERvist",
"réservoir" => "RezERvwaR",
"réservoirs" => "RezERvwaR",
"réservons" => "RezERv§",
"reset" => "R2zEt",
"résidaient" => "RezidE",
"résidais" => "RezidE",
"résidait" => "RezidE",
"résidant" => "Rezid@",
"réside" => "Rezid",
"résidé" => "Rezide",
"résidence" => "Rezid@s",
"résidences" => "Rezid@s",
"résident" => "Rezid",
"résidente" => "Rezid@t",
"résidentiel" => "Rezid@sjEl",
"résidentielle" => "Rezid@sjEl",
"résidentielles" => "Rezid@sjEl",
"résidentiels" => "Rezid@sjEl",
"résidents" => "Rezid@",
"résider" => "Rezide",
"résidera" => "Rezid°Ra",
"résiderez" => "Rezid°Re",
"résides" => "Rezid",
"résidez" => "Rezide",
"résidons" => "Rezid§",
"résidu" => "Rezidy",
"résiduel" => "Rezid8El",
"résiduelle" => "Rezid8El",
"résiduelles" => "Rezid8El",
"résiduels" => "Rezid8El",
"résidus" => "Rezidy",
"résigna" => "ReziNa",
"résignai" => "ReziNE",
"résignaient" => "ReziNE",
"résignais" => "ReziNE",
"résignait" => "ReziNE",
"résignâmes" => "ReziNam",
"résignant" => "ReziN@",
"résignassent" => "ReziNas",
"résignât" => "ReziNa",
"résignation" => "ReziNasj§",
"résignations" => "ReziNasj§",
"résigne" => "ReziN",
"résigné" => "ReziNe",
"résignée" => "ReziNe",
"résignées" => "ReziNe",
"résignent" => "ReziN",
"résigner" => "ReziNe",
"résignera" => "ReziN°Ra",
"résignerais" => "ReziN°RE",
"résignerait" => "ReziN°RE",
"résignèrent" => "ReziNER",
"résigneront" => "ReziN°R§",
"résignés" => "ReziNe",
"résignez" => "ReziNe",
"résignions" => "ReziN§",
"résilia" => "Rezilja",
"résiliable" => "Reziljabl",
"résiliation" => "Reziljasj§",
"résilie" => "Rezili",
"résilié" => "Rezilje",
"résiliée" => "Rezilje",
"résiliées" => "Rezilje",
"résilience" => "Rezilj@s",
"résilier" => "Rezilje",
"résilierait" => "ReziliRE",
"résille" => "Rezij",
"résilles" => "Rezij",
"résine" => "Rezin",
"résiné" => "Rezine",
"résinée" => "Rezine",
"résines" => "Rezin",
"résineuse" => "Rezin2z",
"résineuses" => "Rezin2z",
"résineux" => "Rezin2",
"résipiscence" => "Resipis@s",
"résista" => "Rezista",
"résistai" => "RezistE",
"résistaient" => "RezistE",
"résistais" => "RezistE",
"résistait" => "RezistE",
"résistance" => "Rezist@s",
"résistances" => "Rezist@s",
"résistant" => "Rezist@",
"résistante" => "Rezist@t",
"résistantes" => "Rezist@t",
"résistants" => "Rezist@",
"résistât" => "Rezista",
"résiste" => "Rezist",
"résisté" => "Reziste",
"résistent" => "Rezist",
"résister" => "Reziste",
"résistera" => "Rezist°Ra",
"résisterai" => "Rezist°RE",
"résisteraient" => "Rezist°RE",
"résisterais" => "Rezist°RE",
"résisterait" => "Rezist°RE",
"résisteras" => "Rezist°Ra",
"résistèrent" => "RezistER",
"résisterez" => "Rezist°Re",
"résisteriez" => "Rezist°Rje",
"résisterions" => "Rezist°Rj§",
"résisterons" => "Rezist°R§",
"résisteront" => "Rezist°R§",
"résistes" => "Rezist",
"résistez" => "Reziste",
"résistible" => "Rezistibl",
"résistiez" => "Rezistje",
"résistions" => "Rezistj§",
"résistons" => "Rezist§",
"resocialisation" => "R2sosializasj§",
"résolu" => "Rezoly",
"résoluble" => "RezOlybl",
"résolue" => "Rezoly",
"résolues" => "Rezoly",
"résolument" => "Rezolym@",
"résolurent" => "RezolyR",
"résolus" => "Rezoly",
"résolut" => "Rezoly",
"résolution" => "Rezolysj§",
"résolutions" => "Rezolysj§",
"résolvaient" => "RezOlvE",
"résolvais" => "RezOlvE",
"résolvait" => "RezOlvE",
"résolvant" => "RezOlv@",
"résolve" => "RezOlv",
"résolvent" => "RezOlv",
"résolves" => "RezOlv",
"résolvez" => "RezOlve",
"résolviez" => "RezOlvje",
"résolvons" => "RezOlv§",
"résonance" => "Rezon@s",
"résonances" => "Rezon@s",
"résonateur" => "RezOnat9R",
"resongeait" => "R°z§ZE",
"resonger" => "R°z§Ze",
"résonna" => "Rezona",
"résonnaient" => "RezonE",
"résonnait" => "RezonE",
"résonnant" => "Rezon@",
"résonnante" => "Rezon@t",
"résonnants" => "Rezon@",
"résonne" => "RezOn",
"résonné" => "Rezone",
"résonnent" => "RezOn",
"résonner" => "Rezone",
"résonnera" => "RezOn°Ra",
"résonneraient" => "RezOn°RE",
"résonnèrent" => "RezonER",
"résonneront" => "RezOn°R§",
"résonnez" => "Rezone",
"résorba" => "RezORba",
"résorbable" => "RezORbabl",
"résorbaient" => "RezORbE",
"résorbait" => "RezORbE",
"résorbant" => "RezORb@",
"résorbe" => "RezORb",
"résorbé" => "RezORbe",
"résorbée" => "RezORbe",
"résorbent" => "RezORb",
"résorber" => "RezORbe",
"résorberait" => "RezORb°RE",
"résorberons" => "RezORb°R§",
"résorbés" => "RezORbe",
"résorption" => "RezORpsj§",
"résorptions" => "RezORpsj§",
"résoudra" => "RezudRa",
"résoudrai" => "RezudRE",
"résoudraient" => "RezudRE",
"résoudrais" => "RezudRE",
"résoudrait" => "RezudRE",
"résoudras" => "RezudRa",
"résoudre" => "RezudR",
"résoudrez" => "RezudRe",
"résoudrons" => "RezudR§",
"résoudront" => "RezudR§",
"résous" => "Rezu",
"résout" => "Rezu",
"respect" => "REspE",
"respecta" => "REspEkta",
"respectabilité" => "REspEktabilite",
"respectable" => "REspEktabl",
"respectables" => "REspEktabl",
"respectai" => "REspEktE",
"respectaient" => "REspEktE",
"respectais" => "REspEktE",
"respectait" => "REspEktE",
"respectant" => "REspEkt@",
"respectât" => "REspEkta",
"respecte" => "REspEkt",
"respecté" => "REspEkte",
"respectée" => "REspEkte",
"respectées" => "REspEkte",
"respectent" => "REspEkt",
"respecter" => "REspEkte",
"respectera" => "REspEkt°Ra",
"respecterai" => "REspEkt°RE",
"respecteraient" => "REspEkt°RE",
"respecterais" => "REspEkt°RE",
"respecterait" => "REspEkt°RE",
"respecteras" => "REspEkt°Ra",
"respecterez" => "REspEkt°Re",
"respecterons" => "REspEkt°R§",
"respecteront" => "REspEkt°R§",
"respectes" => "REspEkt",
"respectés" => "REspEkte",
"respectez" => "REspEkte",
"respectiez" => "REspEktje",
"respectif" => "REspEktif",
"respectifs" => "REspEktif",
"respections" => "REspEktj§",
"respective" => "REspEktiv",
"respectivement" => "REspEktiv°m@",
"respectives" => "REspEktiv",
"respectons" => "REspEkt§",
"respects" => "REspE",
"respectueuse" => "REspEkt82z",
"respectueusement" => "REspEkt82z°m@",
"respectueuses" => "REspEkt82z",
"respectueux" => "REspEkt82",
"respir" => "REspiR",
"respira" => "REspiRa",
"respirable" => "REspiRabl",
"respirables" => "REspiRabl",
"respirai" => "REspiRE",
"respiraient" => "REspiRE",
"respirais" => "REspiRE",
"respirait" => "REspiRE",
"respirant" => "REspiR@",
"respirât" => "REspiRa",
"respirateur" => "REspiRat9R",
"respirateurs" => "REspiRat9R",
"respiration" => "REspiRasj§",
"respirations" => "REspiRasj§",
"respiratoire" => "REspiRatwaR",
"respiratoires" => "REspiRatwaR",
"respire" => "REspiR",
"respiré" => "REspiRe",
"respirée" => "REspiRe",
"respirées" => "REspiRe",
"respirent" => "REspiR",
"respirer" => "REspiRe",
"respirera" => "REspiR°Ra",
"respirerai" => "REspiR°RE",
"respirerais" => "REspiR°RE",
"respirerait" => "REspiR°RE",
"respireras" => "REspiR°Ra",
"respirèrent" => "REspiRER",
"respirerez" => "REspiR°Re",
"respirerons" => "REspiR°R§",
"respireront" => "REspiR°R§",
"respires" => "REspiR",
"respirés" => "REspiRe",
"respirez" => "REspiRe",
"respiriez" => "REspiRje",
"respirions" => "REspiRj§",
"respirons" => "REspiR§",
"resplendi" => "REspl@di",
"resplendir" => "REspl@diR",
"resplendira" => "REspl@diRa",
"resplendiraient" => "REspl@diRE",
"resplendirent" => "REspl@diR",
"resplendis" => "REspl@di",
"resplendissaient" => "REspl@disE",
"resplendissait" => "REspl@disE",
"resplendissant" => "REspl@dis@",
"resplendissante" => "REspl@dis@t",
"resplendissantes" => "REspl@dis@t",
"resplendissants" => "REspl@dis@",
"resplendisse" => "REspl@dis",
"resplendissement" => "REspl@dis°m@",
"resplendissent" => "REspl@dis",
"resplendissez" => "REspl@dise",
"resplendit" => "REspl@di",
"responsabilisation" => "REsp§sabilizasj§",
"responsabilise" => "REsp§sabiliz",
"responsabiliser" => "REsp§sabilize",
"responsabilité" => "REsp§sabilite",
"responsabilités" => "REsp§sabilite",
"responsable" => "REsp§sabl",
"responsables" => "REsp§sabl",
"resquillaient" => "REskijE",
"resquillant" => "REskij@",
"resquille" => "REskij",
"resquillé" => "REskije",
"resquiller" => "REskije",
"resquillera" => "REskij°Ra",
"resquilles" => "REskij",
"resquilleur" => "REskij9R",
"resquilleurs" => "REskij9R",
"resquilleuse" => "REskij2z",
"resquilleuses" => "REskij2z",
"ressac" => "R°sak",
"ressacs" => "R°sak",
"ressaie" => "R°sE",
"ressaisi" => "R°sezi",
"ressaisie" => "R°sezi",
"ressaisir" => "R°seziR",
"ressaisira" => "R°seziRa",
"ressaisirais" => "R°sEziRE",
"ressaisis" => "R°sezi",
"ressaisissaient" => "R°sezisE",
"ressaisissais" => "R°sezisE",
"ressaisissait" => "R°sezisE",
"ressaisissant" => "R°sezis@",
"ressaisisse" => "R°sezis",
"ressaisissement" => "R°sezis°m@",
"ressaisisses" => "R°sEzis",
"ressaisissez" => "R°sezise",
"ressaisissions" => "R°sezisj§",
"ressaisissons" => "R°sezis§",
"ressaisit" => "R°sezi",
"ressaisît" => "R°sezi",
"ressassaient" => "R°sasE",
"ressassais" => "R°sasE",
"ressassait" => "R°sasE",
"ressassant" => "R°sas@",
"ressasse" => "R°sas",
"ressassé" => "R°sase",
"ressassée" => "R°sase",
"ressassées" => "R°sase",
"ressassement" => "R°sas°m@",
"ressassent" => "R°sas",
"ressasser" => "R°sase",
"ressassèrent" => "R°sasER",
"ressassés" => "R°sase",
"ressasseur" => "R°sas9R",
"ressassez" => "R°sase",
"ressassions" => "R°sasj§",
"ressaut" => "R°so",
"ressauté" => "R2sote",
"ressauter" => "R°sote",
"ressauts" => "R°so",
"ressayer" => "REsEje",
"ressembla" => "R°s@bla",
"ressemblaient" => "R°s@blE",
"ressemblais" => "R°s@blE",
"ressemblait" => "R°s@blE",
"ressemblance" => "R°s@bl@s",
"ressemblances" => "R°s@bl@s",
"ressemblant" => "R°s@bl@",
"ressemblante" => "R°s@bl@t",
"ressemblantes" => "R°s@bl@t",
"ressemblants" => "R°s@bl@",
"ressemblassent" => "R°s@blas",
"ressemblât" => "R°s@bla",
"ressemble" => "R°s@bl",
"ressemblé" => "R°s@ble",
"ressemblent" => "R°s@bl",
"ressembler" => "R°s@ble",
"ressemblera" => "R°s@bl°Ra",
"ressemblerai" => "R°s@bl°RE",
"ressembleraient" => "R°s@bl°RE",
"ressemblerais" => "R°s@bl°RE",
"ressemblerait" => "R°s@bl°RE",
"ressembleras" => "R°s@bl°Ra",
"ressemblèrent" => "R°s@blER",
"ressemblerez" => "R°s@bl°Re",
"ressembleront" => "R°s@bl°R§",
"ressembles" => "R°s@bl",
"ressemblez" => "R°s@ble",
"ressembliez" => "R°s@blije",
"ressemblions" => "R°s@blij§",
"ressemblons" => "R°s@bl§",
"ressemelage" => "R°s°m°laZ",
"ressemelages" => "R°s°m°laZ",
"ressemelait" => "R°s°m°lE",
"ressemelée" => "R°s°m°le",
"ressemeler" => "R°s°m°le",
"ressemellent" => "R°s°mEl",
"ressemer" => "R2s°me",
"ressens" => "R°s@",
"ressent" => "R°s@",
"ressentaient" => "R°s@tE",
"ressentais" => "R°s@tE",
"ressentait" => "R°s@tE",
"ressentant" => "R°s@t@",
"ressente" => "R°s@t",
"ressentent" => "R°s@t",
"ressentes" => "R°s@t",
"ressentez" => "R°s@te",
"ressenti" => "R°s@ti",
"ressentie" => "R°s@ti",
"ressenties" => "R°s@ti",
"ressentiez" => "R°s@tje",
"ressentiment" => "R°s@tim@",
"ressentiments" => "R°s@tim@",
"ressentîmes" => "R°s@tim",
"ressentions" => "R°s@tj§",
"ressentir" => "R°s@tiR",
"ressentira" => "R°s@tiRa",
"ressentirai" => "R°s@tiRE",
"ressentirais" => "R°s@tiRE",
"ressentirait" => "R°s@tiRE",
"ressentiras" => "R°s@tiRa",
"ressentirent" => "R°s@tiR",
"ressentirez" => "R°s@tiRe",
"ressentiriez" => "R°s@tiRje",
"ressentirions" => "R°s@tiRj§",
"ressentiront" => "R°s@tiR§",
"ressentis" => "R°s@ti",
"ressentit" => "R°s@ti",
"ressentît" => "R°s@ti",
"ressentons" => "R°s@t§",
"resserra" => "R°sERa",
"resserrage" => "R°sERaZ",
"resserraient" => "R°sERE",
"resserrait" => "R°sERE",
"resserrant" => "R°sER@",
"resserre" => "R°sER",
"resserré" => "R°seRe",
"resserrée" => "R°seRe",
"resserrées" => "R°seRe",
"resserrement" => "R°sER°m@",
"resserrent" => "R°sER",
"resserrer" => "R°seRe",
"resserrera" => "R°sER°Ra",
"resserrerai" => "R°sER°RE",
"resserrerait" => "R°sER°RE",
"resserrèrent" => "R°sERER",
"resserres" => "R°sER",
"resserrés" => "R°seRe",
"resserrez" => "R°sERe",
"resserrions" => "R°sERj§",
"resserrons" => "R°sER§",
"ressers" => "R°sER",
"ressert" => "R°sER",
"resservais" => "R°sERvE",
"resservait" => "R°sERvE",
"resservez" => "R°sERve",
"resservi" => "R°sERvi",
"resservir" => "R°sERviR",
"resservirai" => "R°sERviRE",
"resservirais" => "R°sERviRE",
"resservirait" => "R°sERviRE",
"resservis" => "R°sERvi",
"resservit" => "R°sERvi",
"ressors" => "R°sOR",
"ressort" => "R°sOR",
"ressortaient" => "R°sORtE",
"ressortais" => "R°sORtE",
"ressortait" => "R°sORtE",
"ressortant" => "R°sORt@",
"ressorte" => "R°sORt",
"ressortent" => "R°sORt",
"ressortes" => "R°sORt",
"ressortez" => "R°sORte",
"ressorti" => "R°sORti",
"ressortie" => "R°sORti",
"ressorties" => "R°sORti",
"ressortîmes" => "R°sORtim",
"ressortions" => "R°sORtj§",
"ressortir" => "R°sORtiR",
"ressortira" => "R°sORtiRa",
"ressortirai" => "R°sORtiRE",
"ressortiraient" => "R°sORtiRE",
"ressortirais" => "R°sORtiRE",
"ressortirait" => "R°sORtiRE",
"ressortiras" => "R°sORtiRa",
"ressortirent" => "R°sORtiR",
"ressortirez" => "R°sORtiRe",
"ressortiront" => "R°sORtiR§",
"ressortis" => "R°sORti",
"ressortissant" => "R°sORtis@",
"ressortissante" => "R°sORtis@t",
"ressortissants" => "R°sORtis@",
"ressortit" => "R°sORti",
"ressortons" => "R°sORt§",
"ressorts" => "R°sOR",
"ressoudant" => "R°sud@",
"ressoude" => "R°sud",
"ressoudé" => "R°sude",
"ressoudée" => "R°sude",
"ressouder" => "R°sude",
"ressoudés" => "R°sude",
"ressourçais" => "R°suRsE",
"ressourçait" => "R°suRsE",
"ressource" => "R°suRs",
"ressourcé" => "R°suRse",
"ressourcement" => "R°suRs°m@",
"ressourcer" => "R°suRse",
"ressources" => "R°suRs",
"ressouvenait" => "R°suv°nE",
"ressouvenant" => "R°suv°n@",
"ressouvenir" => "R°suv°niR",
"ressouvenue" => "R°suv°ny",
"ressouviens" => "R°suvj5",
"ressouvint" => "R°suv5",
"ressué" => "R°s8e",
"ressui" => "R°s8i",
"ressuiement" => "R2s8im@",
"ressurgi" => "R°syRZi",
"ressurgie" => "R°syRZi",
"ressurgir" => "R°syRZiR",
"ressurgirait" => "R°syRZiRE",
"ressurgirent" => "R°syRZiR",
"ressurgiront" => "R°syRZiR§",
"ressurgissait" => "R°syRZisE",
"ressurgissant" => "R°syRZis@",
"ressurgissent" => "R°syRZis",
"ressurgit" => "R°syRZi",
"ressuscita" => "Resysita",
"ressuscitai" => "ResysitE",
"ressuscitaient" => "ResysitE",
"ressuscitais" => "ResysitE",
"ressuscitait" => "ResysitE",
"ressuscitant" => "Resysit@",
"ressuscitât" => "Resysita",
"ressuscite" => "Resysit",
"ressuscité" => "Resysite",
"ressuscitée" => "Resysite",
"ressuscitées" => "Resysite",
"ressuscitent" => "Resysit",
"ressusciter" => "Resysite",
"ressuscitera" => "Resysit°Ra",
"ressusciterai" => "Resysit°RE",
"ressusciteraient" => "Resysit°RE",
"ressusciterait" => "Resysit°RE",
"ressusciteras" => "Resysit°Ra",
"ressusciterez" => "Resysit°Re",
"ressusciterons" => "Resysit°R§",
"ressusciteront" => "Resysit°R§",
"ressuscites" => "Resysit",
"ressuscités" => "Resysite",
"ressuscitez" => "Resysite",
"ressuscitons" => "Resysit§",
"ressuyé" => "R°s8ije",
"ressuyée" => "R°s8ije",
"resta" => "REsta",
"restai" => "REstE",
"restaient" => "REstE",
"restais" => "REstE",
"restait" => "REstE",
"restâmes" => "REstam",
"restant" => "REst@",
"restante" => "REst@t",
"restantes" => "REst@t",
"restants" => "REst@",
"restassent" => "REstas",
"restât" => "REsta",
"restau" => "REsto",
"restaura" => "REstoRa",
"restaurait" => "REstoRE",
"restaurant" => "REstoR@",
"restaurants" => "REstoR@",
"restaurateur" => "REstoRat9R",
"restaurateurs" => "REstoRat9R",
"restauration" => "REstoRasj§",
"restaurations" => "REstoRasj§",
"restauratrice" => "REstoRatRis",
"restaure" => "REstoR",
"restauré" => "REstoRe",
"restaurée" => "REstoRe",
"restaurées" => "REstoRe",
"restaurent" => "REstoR",
"restaurer" => "REstoRe",
"restaurera" => "REstoR°Ra",
"restaurerai" => "REstoR°RE",
"restaureraient" => "REstoR°RE",
"restaurerait" => "REstoR°RE",
"restaurés" => "REstoRe",
"restaurez" => "REstoRe",
"restaurons" => "REstoR§",
"restauroute" => "REstoRut",
"restaus" => "REsto",
"reste" => "REst",
"resté" => "REste",
"restée" => "REste",
"restées" => "REste",
"restent" => "REst",
"rester" => "REste",
"restera" => "REst°Ra",
"resterai" => "REst°RE",
"resteraient" => "REst°RE",
"resterais" => "REst°RE",
"resterait" => "REst°RE",
"resteras" => "REst°Ra",
"restèrent" => "REstER",
"resterez" => "REst°Re",
"resteriez" => "REst°Rje",
"resterions" => "REst°Rj§",
"resterons" => "REst°R§",
"resteront" => "REst°R§",
"restes" => "REst",
"restés" => "REste",
"restez" => "REste",
"restiez" => "REstje",
"restions" => "REstj§",
"restituaient" => "REstit8E",
"restituait" => "REstit8E",
"restituant" => "REstit8@",
"restitue" => "REstity",
"restitué" => "REstit8e",
"restituée" => "REstit8e",
"restituées" => "REstit8e",
"restituent" => "REstity",
"restituer" => "REstit8e",
"restituera" => "REstityRa",
"restituerai" => "REstityRE",
"restituerait" => "REstityRE",
"restituerons" => "REstityR§",
"restitués" => "REstit8e",
"restituez" => "REstitye",
"restituiez" => "REstityje",
"restitution" => "REstitysj§",
"resto" => "REsto",
"restons" => "REst§",
"restoroute" => "REstoRut",
"restos" => "REsto",
"restreignait" => "REstRENE",
"restreignant" => "REstREN@",
"restreignent" => "REstREN",
"restreignez" => "REstRENe",
"restreignit" => "REstRENi",
"restreindre" => "REstR5dR",
"restreins" => "REstR5",
"restreint" => "REstR5",
"restreinte" => "REstR5t",
"restreintes" => "REstR5t",
"restreints" => "REstR5",
"restrictif" => "REstRiktif",
"restriction" => "REstRiksj@",
"restrictions" => "REstRiksj§",
"restrictive" => "REstRiktiv",
"restrictives" => "REstRiktiv",
"restructurant" => "R°stRyktyR@",
"restructuration" => "R°stRyktyRasj§",
"restructurations" => "R°stRyktyRasj§",
"restructuré" => "R°stRyktyRe",
"restructurée" => "R°stRyktyRe",
"restructurer" => "R°stRyktyRe",
"restructureront" => "R°stRyktyR°R§",
"restructurons" => "R°stRyktyR§",
"resucée" => "R°syse",
"résulta" => "Rezylta",
"résultaient" => "RezyltE",
"résultais" => "RezyltE",
"résultait" => "RezyltE",
"résultant" => "Rezylt@",
"résultante" => "Rezylt@t",
"résultantes" => "Rezylt@t",
"résultat" => "Rezylta",
"résultats" => "Rezylta",
"résulte" => "Rezylt",
"résulté" => "Rezylte",
"résultées" => "Rezylte",
"résultent" => "Rezylt",
"résulter" => "Rezylte",
"résulteraient" => "Rezylt°RE",
"résulterait" => "Rezylt°RE",
"résulteront" => "Rezylt°R§",
"résuma" => "Rezyma",
"résumai" => "RezymE",
"résumaient" => "RezymE",
"résumais" => "RezymE",
"résumait" => "RezymE",
"résumant" => "Rezym@",
"résume" => "Rezym",
"résumé" => "Rezyme",
"résumée" => "Rezyme",
"résumées" => "Rezyme",
"résument" => "Rezym",
"résumer" => "Rezyme",
"résumera" => "Rezym°Ra",
"résumerai" => "Rezym°RE",
"résumerait" => "Rezym°RE",
"résumeriez" => "Rezym°Rje",
"résumés" => "Rezyme",
"résumez" => "Rezyme",
"résumons" => "Rezym§",
"résurgence" => "RezyRZ@s",
"résurgences" => "RezyRZ@s",
"résurgente" => "RezyRZ@t",
"resurgi" => "R°syRZi",
"resurgies" => "R°syRZi",
"resurgir" => "R°syRZiR",
"resurgira" => "R°syRZiRa",
"resurgirai" => "R°zyRZiRE",
"resurgirait" => "R°syRZiRE",
"resurgirent" => "R°syRZiR",
"resurgiront" => "R°syRZiR§",
"resurgis" => "R°syRZi",
"resurgissaient" => "R°syRZisE",
"resurgissait" => "R°syRZisE",
"resurgissant" => "R°syRZis@",
"resurgisse" => "R°syRZis",
"resurgissent" => "R°syRZis",
"resurgit" => "R°syRZi",
"resurgît" => "R°syRZi",
"résurrection" => "RezyREksj§",
"résurrections" => "RezyREksj§",
"retable" => "R°tabl",
"retables" => "R°tabl",
"rétabli" => "Retabli",
"rétablie" => "Retabli",
"rétablies" => "Retabli",
"rétablir" => "RetabliR",
"rétablira" => "RetabliRa",
"rétablirai" => "RetabliRE",
"rétablirait" => "RetabliRE",
"rétabliras" => "RetabliRa",
"rétablirent" => "RetabliR",
"rétablirez" => "RetabliRe",
"rétablirons" => "RetabliR§",
"rétabliront" => "RetabliR§",
"rétablis" => "Retabli",
"rétablissaient" => "RetablisE",
"rétablissais" => "RetablisE",
"rétablissait" => "RetablisE",
"rétablissant" => "Retablis@",
"rétablisse" => "Retablis",
"rétablissement" => "Retablis°m@",
"rétablissements" => "Retablis°m@",
"rétablissent" => "Retablis",
"rétablisses" => "Retablis",
"rétablissez" => "Retablise",
"rétablissons" => "Retablis§",
"rétablit" => "Retabli",
"retaillaient" => "R°tajE",
"retaillait" => "R°tajE",
"retaille" => "R°taj",
"retaillé" => "R°taje",
"retaillée" => "R°taje",
"retaillées" => "R°taje",
"retailler" => "R°taje",
"retaillés" => "R°taje",
"rétamai" => "RetamE",
"rétamait" => "RetamE",
"rétame" => "Retam",
"rétamé" => "Retame",
"rétamées" => "Retame",
"rétamer" => "Retame",
"rétameras" => "Retam°Ra",
"rétamés" => "Retame",
"rétameur" => "Retam9R",
"retapa" => "R°tapa",
"retapaient" => "R°tapE",
"retapait" => "R°tapE",
"retapant" => "R°tap@",
"retape" => "R°tap",
"retapé" => "R°tape",
"retapée" => "R°tape",
"retapées" => "R°tape",
"retapent" => "R°tap",
"retaper" => "R°tape",
"retaperait" => "R°tap°RE",
"retapés" => "R°tape",
"retapeur" => "R2tap9R",
"retapez" => "R°tape",
"retapissant" => "R°tapis@",
"retapisse" => "R°tapis",
"retapissé" => "R°tapise",
"retapissée" => "R°tapise",
"retapissées" => "R°tapise",
"retapissent" => "R°tapis",
"retapisser" => "R°tapise",
"retapisserait" => "R°tapis°RE",
"retapisses" => "R°tapis",
"retard" => "R°taR",
"retarda" => "R°taRda",
"retardaient" => "R°taRdE",
"retardais" => "R°taRdE",
"retardait" => "R°taRdE",
"retardant" => "R°taRd@",
"retardât" => "R°taRda",
"retardataire" => "R°taRdatER",
"retardataires" => "R°taRdatER",
"retardateur" => "R°taRdat9R",
"retarde" => "R°taRd",
"retardé" => "R°taRde",
"retardée" => "R°taRde",
"retardées" => "R°taRde",
"retardement" => "R°taRd°m@",
"retardent" => "R°taRd",
"retarder" => "R°taRde",
"retardera" => "R°taRd°Ra",
"retarderai" => "R°taRd°RE",
"retarderaient" => "R°taRd°RE",
"retarderait" => "R°taRd°RE",
"retardèrent" => "R°taRdER",
"retarderez" => "R°taRd°Re",
"retarderiez" => "R°taRd°Rje",
"retardes" => "R°taRd",
"retardés" => "R°taRde",
"retardez" => "R°taRde",
"retardions" => "R°taRdj§",
"retardons" => "R°taRd§",
"retards" => "R°taR",
"retâté" => "R°tate",
"reteindre" => "R°t5dR",
"reteints" => "R°t5",
"retéléphone" => "R°telefOn",
"retéléphoner" => "R2telefOne",
"retenaient" => "R°t°nE",
"retenais" => "R°t°nE",
"retenait" => "R°t°nE",
"retenant" => "R°t°n@",
"retendait" => "R°t@dE",
"retendre" => "R°t@dR",
"retends" => "R°t@",
"retendu" => "R°t@dy",
"retendues" => "R°t@dy",
"retenez" => "R°t°ne",
"reteniez" => "R°t°nje",
"retenions" => "R°t°nj§",
"retenir" => "R°t°niR",
"retenons" => "R°t°n§",
"retente" => "R°t@t",
"retenter" => "R°t@te",
"retentes" => "R°t@t",
"retenti" => "R°t@ti",
"rétention" => "Ret@sj§",
"retentir" => "R°t@tiR",
"retentira" => "R°t@tiRa",
"retentirait" => "R°t@tiRE",
"retentirent" => "R°t@tiR",
"retentiront" => "R°t@tiR§",
"retentissaient" => "R°t@tisE",
"retentissait" => "R°t@tisE",
"retentissant" => "R°t@tis@",
"retentissante" => "R°t@tis@t",
"retentissantes" => "R°t@tis@t",
"retentissants" => "R°t@tis@",
"retentisse" => "R°t@tis",
"retentissement" => "R°t@tis°m@",
"retentissent" => "R°t@tis",
"retentit" => "R°t@ti",
"retenu" => "R°t°ny",
"retenue" => "R°t°ny",
"retenues" => "R°t°ny",
"retenus" => "R°t°ny",
"réticence" => "Retis@s",
"réticences" => "Retis@s",
"réticent" => "Retis@",
"réticente" => "Retis@t",
"réticentes" => "Retis@t",
"réticents" => "Retis@",
"réticulaire" => "RetikylER",
"réticulaires" => "RetikylER",
"réticulation" => "Retikylasj§",
"réticule" => "Retikyl",
"réticulé" => "Retikyle",
"réticulée" => "Retikyle",
"réticulum" => "RetikylOm",
"retiendra" => "R°tj5dRa",
"retiendrai" => "R°tj5dRE",
"retiendraient" => "R°tj5dRE",
"retiendrais" => "R°tj5dRE",
"retiendrait" => "R°tj5dRE",
"retiendras" => "R°tj5dRa",
"retiendrez" => "R°tj5dRe",
"retiendrions" => "R°tj5dRij§",
"retiendrons" => "R°tj5dR§",
"retiendront" => "R°tj5dR§",
"retienne" => "R°tjEn",
"retiennent" => "R°tjEn",
"retiennes" => "R°tjEn",
"retiens" => "R°tj5",
"retient" => "R°tj5",
"rétif" => "Retif",
"rétifs" => "Retif",
"rétinal" => "Retinal",
"rétine" => "Retin",
"rétines" => "Retin",
"rétinien" => "Retinj5",
"rétinienne" => "RetinjEn",
"rétiniennes" => "RetinjEn",
"rétinite" => "Retinit",
"retînmes" => "R°t5m",
"rétinopathie" => "Retinopati",
"retinrent" => "R°t5R",
"retins" => "R°t5",
"retint" => "R°t5",
"retînt" => "R°t5",
"retira" => "R°tiRa",
"retirable" => "R2tiRabl",
"retirai" => "R°tiRE",
"retiraient" => "R°tiRE",
"retirais" => "R°tiRE",
"retirait" => "R°tiRE",
"retirâmes" => "R°tiRam",
"retirant" => "R°tiR@",
"retirât" => "R°tiRa",
"retire" => "R°tiR",
"retiré" => "R°tiRe",
"retirée" => "R°tiRe",
"retirées" => "R°tiRe",
"retirement" => "R2tiR°m@",
"retirent" => "R°tiR",
"retirer" => "R°tiRe",
"retirera" => "R°tiR°Ra",
"retirerai" => "R°tiR°RE",
"retireraient" => "R°tiR°RE",
"retirerais" => "R°tiR°RE",
"retirerait" => "R°tiR°RE",
"retireras" => "R°tiR°Ra",
"retirèrent" => "R°tiRER",
"retirerez" => "R°tiR°Re",
"retireriez" => "R°tiR°Rje",
"retirerions" => "R°tiR°Rj§",
"retirerons" => "R°tiR°R§",
"retireront" => "R°tiR°R§",
"retires" => "R°tiR",
"retirés" => "R°tiRe",
"retirez" => "R°tiRe",
"retiriez" => "R°tiRje",
"retirions" => "R°tiRj§",
"retiro" => "RetiRo",
"retirons" => "R°tiR§",
"retissaient" => "R°tisE",
"retissait" => "R°tisE",
"retisser" => "R°tise",
"rétive" => "Retiv",
"rétives" => "Retiv",
"retomba" => "R°t§ba",
"retombai" => "R°t§bE",
"retombaient" => "R°t§bE",
"retombais" => "R°t§bE",
"retombait" => "R°t§bE",
"retombâmes" => "R°t§bam",
"retombant" => "R°t§b@",
"retombante" => "R°t§b@t",
"retombantes" => "R°t§b@t",
"retombât" => "R°t§ba",
"retombe" => "R°t§b",
"retombé" => "R°t§be",
"retombée" => "R°t§be",
"retombées" => "R°t§be",
"retombement" => "R°t§b°m@",
"retombent" => "R°t§b",
"retomber" => "R°t§be",
"retombera" => "R°t§b°Ra",
"retomberai" => "R°t§b°RE",
"retomberaient" => "R°t§b°RE",
"retomberais" => "R°t§b°RE",
"retomberait" => "R°t§b°RE",
"retomberas" => "R°t§b°Ra",
"retombèrent" => "R°t§bER",
"retomberez" => "R°t§b°Re",
"retomberont" => "R°t§b°R§",
"retombes" => "R°t§b",
"retombés" => "R°t§be",
"retombez" => "R°t§be",
"retombions" => "R°t§bj§",
"retombons" => "R°t§b§",
"retordre" => "R°tORdR",
"rétorqua" => "RetORka",
"rétorquai" => "RetORkE",
"rétorquais" => "RetORkE",
"rétorquait" => "RetORkE",
"rétorquant" => "RetORk@",
"rétorque" => "RetORk",
"rétorqué" => "RetORke",
"rétorquer" => "RetORke",
"rétorquera" => "RetORk°Ra",
"rétorquèrent" => "RetORkER",
"retors" => "R°tOR",
"retorse" => "R°tORs",
"retorses" => "R°tORs",
"rétorsion" => "RetORsj§",
"retoucha" => "R°tuSa",
"retouchai" => "R°tuSE",
"retouchait" => "R°tuSE",
"retouchant" => "R°tuS@",
"retouche" => "R°tuS",
"retouché" => "R°tuSe",
"retouchée" => "R°tuSe",
"retouchées" => "R°tuSe",
"retouchent" => "R°tuS",
"retoucher" => "R°tuSe",
"retouchera" => "R°tuS°Ra",
"retoucherais" => "R°tuS°RE",
"retoucherait" => "R°tuS°RE",
"retouches" => "R°tuS",
"retouchés" => "R°tuSe",
"retoucheur" => "R°tuS9R",
"retouchez" => "R°tuSe",
"retour" => "R°tuR",
"retourna" => "R°tuRna",
"retournai" => "R°tuRnE",
"retournaient" => "R°tuRnE",
"retournais" => "R°tuRnE",
"retournait" => "R°tuRnE",
"retournâmes" => "R°tuRnam",
"retournant" => "R°tuRn@",
"retournât" => "R°tuRna",
"retourne" => "R°tuRn",
"retourné" => "R°tuRne",
"retournée" => "R°tuRne",
"retournées" => "R°tuRne",
"retournement" => "R°tuRn°m@",
"retournements" => "R°tuRn°m@",
"retournent" => "R°tuRn",
"retourner" => "R°tuRne",
"retournera" => "R°tuRn°Ra",
"retournerai" => "R°tuRn°RE",
"retourneraient" => "R°tuRn°RE",
"retournerais" => "R°tuRn°RE",
"retournerait" => "R°tuRn°RE",
"retourneras" => "R°tuRn°Ra",
"retournèrent" => "R°tuRnER",
"retournerez" => "R°tuRn°Re",
"retourneriez" => "R°tuRn°Rje",
"retournerions" => "R°tuRn°Rj§",
"retournerons" => "R°tuRn°R§",
"retourneront" => "R°tuRn°R§",
"retournes" => "R°tuRn",
"retournés" => "R°tuRne",
"retournez" => "R°tuRne",
"retourniez" => "R°tuRnje",
"retournions" => "R°tuRnj§",
"retournons" => "R°tuRn§",
"retours" => "R°tuR",
"retraçaient" => "R°tRasE",
"retraçais" => "R°tRasE",
"retraçait" => "R°tRasE",
"retraçant" => "R°tRas@",
"retrace" => "R°tRas",
"retracé" => "R°tRase",
"retracée" => "R°tRase",
"retracent" => "R°tRas",
"retracer" => "R°tRase",
"retracera" => "R°tRas°Ra",
"retracerais" => "R°tRas°RE",
"retracerait" => "R°tRas°RE",
"retraceront" => "R°tRas°R§",
"retracez" => "R°tRase",
"retracions" => "R°tRasj§",
"rétracta" => "RetRakta",
"rétractable" => "RetRaktabl",
"rétractais" => "RetRaktE",
"rétractait" => "RetRaktE",
"rétractant" => "RetRakt@",
"rétractation" => "RetRaktasj§",
"rétractations" => "RetRaktasj§",
"rétracte" => "RetRakt",
"rétracté" => "RetRakte",
"rétractée" => "RetRakte",
"rétractées" => "RetRakte",
"rétractent" => "RetRakt",
"rétracter" => "RetRakte",
"rétractera" => "RetRakt°Ra",
"rétracterait" => "RetRakt°RE",
"rétractèrent" => "RetRaktER",
"rétractés" => "RetRakte",
"rétracteur" => "RetRakt9R",
"rétracteurs" => "RetRakt9R",
"rétractez" => "RetRakte",
"rétractile" => "RetRaktil",
"rétractiles" => "RetRaktil",
"rétraction" => "RetRaksj§",
"retraduction" => "R2tRadyksj§",
"retraduit" => "R°tRad8i",
"retraire" => "R°tRER",
"retrait" => "R°tRE",
"retraitait" => "R°tREtE",
"retraite" => "R°tREt",
"retraité" => "R°tRete",
"retraitée" => "R°tRete",
"retraitées" => "R°tREte",
"retraitement" => "R°tREt°m@",
"retraites" => "R°tREt",
"retraités" => "R°tREte",
"retraitions" => "R°tREtj§",
"retraits" => "R°tRE",
"retranchai" => "R°tR@SE",
"retranchaient" => "R°tR@SE",
"retranchait" => "R°tR@SE",
"retranchant" => "R°tR@S@",
"retranche" => "R°tR@S",
"retranché" => "R°tR@Se",
"retranchée" => "R°tR@Se",
"retranchées" => "R°tR@Se",
"retranchement" => "R°tR@S°m@",
"retranchements" => "R°tR@S°m@",
"retranchent" => "R°tR@S",
"retrancher" => "R°tR@Se",
"retranchera" => "R°tR@S°Ra",
"retranchés" => "R°tR@Se",
"retranchez" => "R°tR@Se",
"retranchions" => "R°tR@Sj§",
"retranscription" => "R°tR@skRipsj§",
"retranscrire" => "R°tR@skRiR",
"retranscris" => "R°tR@skRi",
"retranscrit" => "R°tR@skRi",
"retranscrits" => "R°tR@skRi",
"retransférer" => "R2tR@sfeRe",
"retransforme" => "R2tR@sfORm",
"retransformer" => "R2tR@sfORme",
"retransformera" => "R2tR@sfORm°Ra",
"retransmet" => "R°tR@smE",
"retransmettait" => "R°tR@smEtE",
"retransmettant" => "R°tR@smEt@",
"retransmettez" => "R°tR@smEte",
"retransmettra" => "R°tR@smEtRa",
"retransmettre" => "R°tR@smEtR",
"retransmettrons" => "R°tR@smEtR§",
"retransmis" => "R°tR@smi",
"retransmise" => "R°tR@smiz",
"retransmission" => "R°tR@smisj§",
"retransmissions" => "R°tR@smisj§",
"retransmit" => "R°tR@smi",
"retravaillait" => "R°tRavajE",
"retravaille" => "R°tRavaj",
"retravaillé" => "R°tRavaje",
"retravaillée" => "R°tRavaje",
"retravaillent" => "R°tRavaj",
"retravailler" => "R°tRavaje",
"retravaillera" => "R°tRavaj°Ra",
"retravaillerai" => "R°tRavaj°RE",
"retravaillerait" => "R°tRavaj°RE",
"retravaillerez" => "R°tRavaj°Re",
"retravailles" => "R°tRavaj",
"retravaillez" => "R°tRavaje",
"retraversa" => "R°tRavERsa",
"retraversai" => "R°tRavERsE",
"retraversaient" => "R°tRavERsE",
"retraversais" => "R°tRavERsE",
"retraversait" => "R°tRavERsE",
"retraversant" => "R°tRavERs@",
"retraverse" => "R°tRavERs",
"retraversé" => "R°tRavERse",
"retraversée" => "R°tRavERse",
"retraversent" => "R°tRavERs",
"retraverser" => "R°tRavERse",
"retraverserait" => "R°tRavERs°RE",
"retraversions" => "R°tRavERsj§",
"retraversons" => "R°tRavERs§",
"rétréci" => "RetResi",
"rétrécie" => "RetResi",
"rétrécies" => "RetResi",
"rétrécir" => "RetResiR",
"rétrécirent" => "RetResiR",
"rétrécis" => "RetResi",
"rétrécissaient" => "RetResisE",
"rétrécissait" => "RetResisE",
"rétrécissant" => "RetResis@",
"rétrécisse" => "RetResis",
"rétrécissement" => "RetResis°m@",
"rétrécissements" => "RetResis°m@",
"rétrécissent" => "RetResis",
"rétrécissez" => "RetResise",
"rétrécit" => "RetResi",
"rétreint" => "RetR5",
"retreinte" => "R°tR5t",
"retrempai" => "R°tR@pE",
"retrempaient" => "R°tR@pE",
"retrempait" => "R°tR@pE",
"retrempé" => "R°tR@pe",
"retremper" => "R°tR@pe",
"rétribuant" => "RetRib8@",
"rétribue" => "RetRiby",
"rétribué" => "RetRib8e",
"rétribuée" => "RetRib8e",
"rétribuer" => "RetRib8e",
"rétribués" => "RetRib8e",
"rétribution" => "RetRibysj§",
"rétributions" => "RetRibysj§",
"retriever" => "RitRiv9R",
"rétro" => "RetRo",
"rétroactif" => "RetRoaktif",
"rétroaction" => "RetRoaksj§",
"rétroactive" => "RetRoaktiv",
"rétroactivement" => "RetRoaktiv°m@",
"rétrocédait" => "RetRosedE",
"rétrocède" => "RetRosEd",
"rétrocéder" => "RetRosede",
"rétrocession" => "RetRosesj§",
"rétrofusée" => "RetROfyze",
"rétrofusées" => "RetRofyze",
"rétrograda" => "RetRogRada",
"rétrogradation" => "RetRogRadasj§",
"rétrogradations" => "RetRogRadasj§",
"rétrograde" => "RetRogRad",
"rétrogradé" => "RetRogRade",
"rétrogradée" => "RetRogRade",
"rétrogradent" => "RetRogRad",
"rétrograder" => "RetRogRade",
"rétrogrades" => "RetRogRad",
"rétrogradés" => "RetRogRade",
"rétrogradez" => "RetRogRade",
"rétrogression" => "RetRogREsj§",
"rétroprojecteur" => "RetRopRoZEkt9R",
"rétropropulsion" => "RetRopRopylsj§",
"rétros" => "RetRo",
"rétrospectif" => "RetRospEktif",
"rétrospectifs" => "RetRospEktif",
"rétrospection" => "RetROspEksj§",
"rétrospective" => "RetRospEktiv",
"rétrospectivement" => "RetRospEktiv°m@",
"rétrospectives" => "RetRospEktiv",
"retroussa" => "R°tRusa",
"retroussage" => "R°tRusaZ",
"retroussaient" => "R°tRusE",
"retroussais" => "R°tRusE",
"retroussait" => "R°tRusE",
"retroussant" => "R°tRus@",
"retrousse" => "R°tRus",
"retroussé" => "R°tRuse",
"retroussée" => "R°tRuse",
"retroussées" => "R°tRuse",
"retroussent" => "R°tRus",
"retrousser" => "R°tRuse",
"retroussés" => "R°tRuse",
"retroussette" => "R°tRusEt",
"retroussez" => "R°tRuse",
"retroussis" => "R°tRusi",
"retrouva" => "R°tRuva",
"retrouvai" => "R°tRuvE",
"retrouvaient" => "R°tRuvE",
"retrouvaille" => "R°tRuvaj",
"retrouvailles" => "R°tRuvaj",
"retrouvais" => "R°tRuvE",
"retrouvait" => "R°tRuvE",
"retrouvâmes" => "R°tRuvam",
"retrouvant" => "R°tRuv@",
"retrouvas" => "R°tRuva",
"retrouvât" => "R°tRuva",
"retrouve" => "R°tRuv",
"retrouvé" => "R°tRuve",
"retrouvée" => "R°tRuve",
"retrouvées" => "R°tRuve",
"retrouvent" => "R°tRuv",
"retrouver" => "R°tRuve",
"retrouvera" => "R°tRuv°Ra",
"retrouverai" => "R°tRuv°RE",
"retrouveraient" => "R°tRuv°RE",
"retrouverais" => "R°tRuv°RE",
"retrouverait" => "R°tRuv°RE",
"retrouveras" => "R°tRuv°Ra",
"retrouvèrent" => "R°tRuvER",
"retrouverez" => "R°tRuv°Re",
"retrouveriez" => "R°tRuv°Rje",
"retrouverions" => "R°tRuv°Rj§",
"retrouverons" => "R°tRuv°R§",
"retrouveront" => "R°tRuv°R§",
"retrouves" => "R°tRuv",
"retrouvés" => "R°tRuve",
"retrouvez" => "R°tRuve",
"retrouviez" => "R°tRuvje",
"retrouvions" => "R°tRuvj§",
"retrouvons" => "R°tRuv§",
"rétroversion" => "RetRovERsj§",
"rétrovirale" => "RetROviRal",
"rétrovirus" => "RetRoviRys",
"rétroviseur" => "RetRoviz9R",
"rétroviseurs" => "RetRoviz9R",
"rets" => "RE",
"retsina" => "R°sina",
"retuber" => "R2tybe",
"retuer" => "R2t8e",
"reubeu" => "R9b2",
"reubeus" => "R9b2",
"réuni" => "Reyni",
"réunie" => "Reyni",
"réunies" => "Reyni",
"réunification" => "Reynifikasj§",
"réunifié" => "Reynifje",
"réunifiée" => "Reynifje",
"réunifiées" => "Reynifje",
"réunifier" => "Reynifje",
"réunîmes" => "Reynim",
"réunion" => "Reynj§",
"réunionnais" => "ReynjonE",
"réunionnite" => "Reynjonit",
"réunions" => "Reynj§",
"réunir" => "ReyniR",
"réunira" => "ReyniRa",
"réunirai" => "ReyniRE",
"réuniraient" => "ReyniRE",
"réunirais" => "ReyniRE",
"réunirait" => "ReyniRE",
"réuniras" => "ReyniRa",
"réunirent" => "ReyniR",
"réunirons" => "ReyniR§",
"réuniront" => "ReyniR§",
"réunis" => "Reyni",
"réunissaient" => "ReynisE",
"réunissais" => "ReynisE",
"réunissait" => "ReynisE",
"réunissant" => "Reynis@",
"réunisse" => "Reynis",
"réunissent" => "Reynis",
"réunisses" => "Reynis",
"réunissez" => "Reynise",
"réunissions" => "Reynisj§",
"réunissons" => "Reynis§",
"réunit" => "Reyni",
"réussi" => "Reysi",
"réussie" => "Reysi",
"réussies" => "Reysi",
"réussîmes" => "Reysim",
"réussir" => "ReysiR",
"réussira" => "ReysiRa",
"réussirai" => "ReysiRE",
"réussiraient" => "ReysiRE",
"réussirais" => "ReysiRE",
"réussirait" => "ReysiRE",
"réussiras" => "ReysiRa",
"réussirent" => "ReysiR",
"réussirez" => "ReysiRe",
"réussiriez" => "ReysiRje",
"réussirions" => "ReysiRj§",
"réussirons" => "ReysiR§",
"réussiront" => "ReysiR§",
"réussis" => "Reysi",
"réussissaient" => "ReysisE",
"réussissais" => "ReysisE",
"réussissait" => "ReysisE",
"réussissant" => "Reysis@",
"réussisse" => "Reysis",
"réussissent" => "Reysis",
"réussisses" => "Reysis",
"réussissez" => "Reysise",
"réussissiez" => "Reysisje",
"réussissions" => "Reysisj§",
"réussissons" => "Reysis§",
"réussit" => "Reysi",
"réussît" => "Reysi",
"réussite" => "Reysit",
"réussites" => "Reysit",
"réutilisables" => "Reytilizabl",
"réutilisait" => "ReytilizE",
"réutilisation" => "Reytilizaj§",
"réutilise" => "Reytiliz",
"réutilisé" => "Reytilize",
"réutiliser" => "Reytilize",
"réutilisés" => "Reytilize",
"rêva" => "REva",
"rêvai" => "REvE",
"rêvaient" => "REvE",
"rêvais" => "REvE",
"rêvait" => "REvE",
"revalidation" => "R°validasj§",
"revalider" => "R°valide",
"revaloir" => "R°valwaR",
"revalorisait" => "R°valoRizE",
"revalorisation" => "R°valoRizasj§",
"revalorisé" => "R°valoRize",
"revalorisent" => "R°valoRiz",
"revaloriser" => "R°valoRize",
"revancha" => "R°v@Sa",
"revanchaient" => "R°v@SE",
"revanchard" => "R°v@SaR",
"revancharde" => "R°v@SaRd",
"revanchardes" => "R°v@SaRd",
"revanchards" => "R°v@SaR",
"revanche" => "R°v@S",
"revanchent" => "R°v@S",
"revancher" => "R°v@Se",
"revanches" => "R°v@S",
"rêvant" => "REv@",
"rêvassa" => "REvasa",
"rêvassai" => "REvasE",
"rêvassaient" => "REvasE",
"rêvassais" => "REvasE",
"rêvassait" => "REvasE",
"rêvassant" => "REvas@",
"rêvasse" => "REvas",
"rêvassé" => "REvase",
"rêvassent" => "REvas",
"rêvasser" => "REvase",
"rêvasserie" => "REvas°Ri",
"rêvasseries" => "REvas°Ri",
"rêvât" => "REva",
"revaudra" => "R°vodRa",
"revaudrai" => "R°vodRE",
"revaudraient" => "R°vodRE",
"revaudrais" => "R°vodRE",
"revaudrait" => "R°vodRE",
"revaudras" => "R°vodRa",
"rêve" => "REv",
"rêvé" => "Reve",
"revêche" => "R°vES",
"revêches" => "R°vES",
"revécu" => "R°veky",
"revécue" => "R°veky",
"revécues" => "R°veky",
"revécurent" => "R°vekyR",
"revécut" => "R°veky",
"rêvée" => "Reve",
"rêvées" => "Reve",
"réveil" => "RevEj",
"réveilla" => "RevEja",
"réveillai" => "RevEjE",
"réveillaient" => "RevEjE",
"réveillais" => "RevEjE",
"réveillait" => "RevEjE",
"réveillâmes" => "RevEjam",
"réveillant" => "RevEj@",
"réveillât" => "RevEja",
"réveille" => "RevEj",
"réveillé" => "Reveje",
"réveille-matin" => "RevEjmat5",
"réveillée" => "Reveje",
"réveillées" => "Reveje",
"réveillent" => "RevEj",
"réveiller" => "Reveje",
"réveillera" => "RevEj°Ra",
"réveillerai" => "RevEj°RE",
"réveilleraient" => "RevEj°RE",
"réveillerais" => "RevEj°RE",
"réveillerait" => "RevEj°RE",
"réveilleras" => "RevEj°Ra",
"réveillèrent" => "RevEjER",
"réveillerez" => "RevEj°Re",
"réveilleriez" => "Revej°Rje",
"réveillerons" => "RevEj°R§",
"réveilleront" => "RevEj°R§",
"réveilles" => "RevEj",
"réveillés" => "Reveje",
"réveilleurs" => "RevEj9R",
"réveillez" => "RevEje",
"réveilliez" => "RevEje",
"réveillions" => "RevEj§",
"réveillon" => "RevEj§",
"réveillonnaient" => "RevEjonE",
"réveillonnait" => "RevEjonE",
"réveillonnâmes" => "RevEjonam",
"réveillonne" => "RevEjOn",
"réveillonné" => "RevEjOne",
"réveillonner" => "RevEjone",
"réveillonnèrent" => "RevEjonER",
"réveillonnerons" => "RevEjOn°R§",
"réveillonneurs" => "RevEjon9R",
"réveillonnons" => "RevEjon§",
"réveillons" => "RevEj§",
"réveils" => "RevEj",
"révéla" => "Revela",
"révélai" => "RevelE",
"révélaient" => "RevelE",
"révélais" => "RevelE",
"révélait" => "RevelE",
"révélant" => "Revel@",
"révélât" => "Revela",
"révélateur" => "Revelat9R",
"révélateurs" => "Revelat9R",
"révélation" => "Revelasj§",
"révélations" => "Revelasj§",
"révélatrice" => "RevelatRis",
"révélatrices" => "RevelatRis",
"révèle" => "RevEl",
"révélé" => "Revele",
"révélée" => "Revele",
"révélées" => "Revele",
"révèlent" => "RevEl",
"révéler" => "Revele",
"révélera" => "Revel°Ra",
"révélerai" => "Revel°RE",
"révéleraient" => "Revel°RE",
"révélerais" => "Revel°RE",
"révélerait" => "Revel°RE",
"révéleras" => "Revel°Ra",
"révélèrent" => "RevelER",
"révélerez" => "Revel°Re",
"révélerons" => "Revel°R§",
"révéleront" => "Revel°R§",
"révèles" => "RevEl",
"révélés" => "Revele",
"révélez" => "Revele",
"révéliez" => "Revelje",
"révélons" => "Revel§",
"revenaient" => "R°v°nE",
"revenais" => "R°v°nE",
"revenait" => "R°v°nE",
"revenant" => "R°v°n@",
"revenante" => "R°v°n@t",
"revenants" => "R°v°n@",
"revend" => "R°v@",
"revendable" => "R°v@dabl",
"revendaient" => "R°v@dE",
"revendais" => "R°v@dE",
"revendait" => "R°v@dE",
"revendant" => "R°v@d@",
"revendent" => "R°v@d",
"revendes" => "R°v@d",
"revendeur" => "R°v@d9R",
"revendeurs" => "R°v@d9R",
"revendeuse" => "R°v@d2z",
"revendez" => "R°v@de",
"revendicateur" => "R°v@dikat9R",
"revendicateurs" => "R°v@dikat9R",
"revendicatif" => "R°v@dikatif",
"revendicatifs" => "R°v@dikatif",
"revendication" => "R°v@dikasj§",
"revendications" => "R°v@dikasj§",
"revendicative" => "R°v@dikativ",
"revendicatives" => "R°v@dikativ",
"revendicatrice" => "R°v@dikatRis",
"revendicatrices" => "R°v@dikatRis",
"revendiqua" => "R°v@dika",
"revendiquai" => "R°v@dikE",
"revendiquaient" => "R°v@dikE",
"revendiquais" => "R°v@dikE",
"revendiquait" => "R°v@dikE",
"revendiquant" => "R°v@dik@",
"revendiquât" => "R°v@dika",
"revendique" => "R°v@dik",
"revendiqué" => "R°v@dike",
"revendiquée" => "R°v@dike",
"revendiquent" => "R°v@dik",
"revendiquer" => "R°v@dike",
"revendiquera" => "R°v@dik°Ra",
"revendiquerais" => "R°v@dik°RE",
"revendiquerait" => "R°v@dik°RE",
"revendiquez" => "R°v@dike",
"revendiquons" => "R°v@dik§",
"revendis" => "R°v@di",
"revendit" => "R°v@di",
"revendra" => "R°v@dRa",
"revendrai" => "R°v@dRE",
"revendraient" => "R°v@dRE",
"revendrais" => "R°v@dRE",
"revendrait" => "R°v@dRE",
"revendre" => "R°v@dR",
"revendrons" => "R°v@dR§",
"revendront" => "R°v@dR§",
"revends" => "R°v@",
"revendu" => "R°v@dy",
"revendue" => "R°v@dy",
"revendues" => "R°v@dy",
"revendus" => "R°v@dy",
"revenez" => "R°v°ne",
"reveniez" => "R°v°nje",
"revenions" => "R°v°nj§",
"revenir" => "R°v°niR",
"revenons" => "R°v°n§",
"rêvent" => "REv",
"revente" => "R°v@t",
"reventes" => "R°v@t",
"revenu" => "R°v°ny",
"revenue" => "R°v°ny",
"revenues" => "R°v°ny",
"revenus" => "R°v°ny",
"rêver" => "Reve",
"rêvera" => "REv°Ra",
"rêverai" => "REv°RE",
"rêveraient" => "REv°RE",
"rêverait" => "REv°RE",
"révérait" => "ReveRE",
"révérant" => "ReveR@",
"réverbéra" => "RevERbeRa",
"réverbéraient" => "RevERbeRE",
"réverbérait" => "RevERbeRE",
"réverbérant" => "RevERbeR@",
"réverbération" => "RevERbeRasj§",
"réverbérations" => "RevERbeRasj§",
"réverbère" => "RevERbER",
"réverbéré" => "RevERbeRe",
"réverbérée" => "RevERbeRe",
"réverbèrent" => "RevERbER",
"réverbérer" => "RevERbeRe",
"réverbères" => "RevERbER",
"reverdi" => "R°vERdi",
"reverdie" => "R°vERdi",
"reverdies" => "R°vERdi",
"reverdir" => "R°vERdiR",
"reverdiront" => "R°vERdiR§",
"reverdissaient" => "R°vERdisE",
"reverdit" => "R°vERdi",
"révère" => "RevER",
"révéré" => "ReveRe",
"révérée" => "ReveRe",
"révérence" => "ReveR@s",
"révérences" => "ReveR@s",
"révérenciel" => "ReveR@sjEl",
"révérencieuse" => "ReveR@sj2z",
"révérencieusement" => "ReveR@sj2z°m@",
"révérencieux" => "ReveR@sj2",
"révérend" => "ReveR@",
"révérende" => "ReveR@d",
"révérendissime" => "ReveR@disim",
"révérends" => "ReveR@",
"révèrent" => "RevER",
"rêvèrent" => "REvER",
"révérer" => "ReveRe",
"révérerait" => "ReveR°RE",
"rêverie" => "REv°Ri",
"rêveries" => "REv°Ri",
"revérifié" => "R2veRifje",
"revérifier" => "R2veRifje",
"reverni" => "R2vERni",
"revernie" => "R°vERni",
"revernir" => "R2vERniR",
"révérons" => "ReveR§",
"rêveront" => "REv°R§",
"reverra" => "R°vERa",
"reverrai" => "R°vERE",
"reverraient" => "R°vERE",
"reverrais" => "R°vERE",
"reverrait" => "R°vERE",
"reverras" => "R°vERa",
"reverrez" => "R°vERe",
"reverrions" => "R°vERj§",
"reverrons" => "R°vER§",
"reverront" => "R°vER§",
"revers" => "R°vER",
"reversa" => "R°vERsa",
"reversaient" => "R°vERsE",
"reversait" => "R°vERsE",
"reversant" => "R°vERs@",
"reverse" => "R°vERs",
"reversé" => "R°vERse",
"reverser" => "R°vERse",
"reverserait" => "R°vERs°RE",
"reversez" => "R°vERse",
"réversibilité" => "RevERsibilite",
"réversible" => "RevERsibl",
"réversibles" => "RevERsibl",
"réversion" => "RevERsj§",
"rêves" => "REv",
"rêvés" => "Reve",
"revêt" => "R°vE",
"revêtaient" => "R°vEtE",
"revêtais" => "R°vEtE",
"revêtait" => "R°vEtE",
"revêtant" => "R°vEt@",
"revêtement" => "R°vEt°m@",
"revêtements" => "R°vEt°m@",
"revêtent" => "R°vEt",
"revêtez" => "R°vEte",
"revêtir" => "R°vetiR",
"revêtira" => "R°vEtiRa",
"revêtirait" => "R°vEtiRE",
"revêtirent" => "R°vEtiR",
"revêtiront" => "R°vEtiR§",
"revêtis" => "R°vEti",
"revêtit" => "R°vEti",
"revêtît" => "R°vEti",
"revêts" => "R°vE",
"revêtu" => "R°vEty",
"revêtue" => "R°vEty",
"revêtues" => "R°vEty",
"revêtus" => "R°vEty",
"reveuille" => "R°v9j",
"reveulent" => "R°v9l",
"rêveur" => "REv9R",
"rêveurs" => "REv9R",
"rêveuse" => "REv2z",
"rêveusement" => "REv2z°m@",
"rêveuses" => "REv2z",
"reveux" => "R°v2",
"rêvez" => "REve",
"revida" => "R°vida",
"revidèrent" => "R°vidER",
"reviendra" => "R°vj5dRa",
"reviendrai" => "R°vj5dRE",
"reviendraient" => "R°vj5dRE",
"reviendrais" => "R°vj5dRE",
"reviendrait" => "R°vj5dRE",
"reviendras" => "R°vj5dRa",
"reviendrez" => "R°vj5dRe",
"reviendriez" => "R°vj5dRije",
"reviendrions" => "R°vj5dRij§",
"reviendrons" => "R°vj5dR§",
"reviendront" => "R°vj5dR§",
"revienne" => "R°vjEn",
"reviennent" => "R°vjEn",
"reviennes" => "R°vjEn",
"reviens" => "R°vj5",
"revient" => "R°vj5",
"rêviez" => "REvje",
"revigoraient" => "R°vigoRE",
"revigorant" => "R°vigoR@",
"revigorante" => "R°vigoR@t",
"revigorantes" => "R°vigoR@t",
"revigore" => "R°vigOR",
"revigoré" => "R°vigoRe",
"revigorée" => "R°vigoRe",
"revigorées" => "R°vigoRe",
"revigorent" => "R°vigOR",
"revigorer" => "R°vigoRe",
"revîmes" => "R°vim",
"revinrent" => "R°v5R",
"revins" => "R°v5",
"revinssent" => "R°v5s",
"revint" => "R°v5",
"revînt" => "R°v5",
"rêvions" => "REvj§",
"revirement" => "R°viR°m@",
"revirements" => "R°viR°m@",
"revirent" => "R°viR",
"revirer" => "R2viRe",
"revis" => "R°vi",
"révisa" => "Reviza",
"révisai" => "RevizE",
"révisaient" => "RevizE",
"révisais" => "RevizE",
"révisait" => "RevizE",
"révisant" => "Reviz@",
"révise" => "Reviz",
"révisé" => "Revize",
"révisée" => "Revize",
"révisées" => "Revize",
"révisent" => "Reviz",
"réviser" => "Revize",
"réviserais" => "Reviz°RE",
"réviserait" => "Reviz°RE",
"révises" => "Reviz",
"révisés" => "Revize",
"réviseur" => "Reviz9R",
"révisez" => "Revize",
"révisiez" => "Revizje",
"révision" => "Revizj§",
"révisionnisme" => "Revizjonizm",
"révisionniste" => "Revizjonist",
"révisionnistes" => "Revizjonist",
"révisions" => "Revizj§",
"revisita" => "R°vizita",
"revisite" => "R°vizit",
"revisité" => "R°vizite",
"revisitée" => "R°vizite",
"revisitent" => "R°vizit",
"revisiter" => "R°vizite",
"réviso" => "Revizo",
"révisons" => "Reviz§",
"revissa" => "R°visa",
"revisse" => "R°vis",
"revissé" => "R2vise",
"revissées" => "R°vise",
"revisser" => "R°vise",
"revit" => "R°vi",
"revitalisant" => "R2vitaliz@",
"revitalisation" => "R°vitalizasj§",
"revitalise" => "R°vitaliz",
"revitaliser" => "R°vitalize",
"revitalisera" => "R°vitaliz°Ra",
"revivaient" => "R°vivE",
"revivais" => "R°vivE",
"revivait" => "R°vivE",
"revival" => "RivajvOl",
"revivant" => "R°viv@",
"revive" => "R°viv",
"revivent" => "R°viv",
"revivez" => "R°vive",
"revivifiant" => "R°vivifj@",
"revivifie" => "R°vivifi",
"revivifié" => "R°vivifje",
"revivifiée" => "R°vivifje",
"revivifiées" => "R°vivifje",
"revivifier" => "R2vivifje",
"revivions" => "R°vivj§",
"reviviscence" => "R°vivis@s",
"revivons" => "R°viv§",
"revivra" => "R°vivRa",
"revivrai" => "R°vivRE",
"revivraient" => "R°vivRE",
"revivrais" => "R°vivRE",
"revivrait" => "R°vivRE",
"revivras" => "R°vivRa",
"revivre" => "R°vivR",
"revivrez" => "R°vivRe",
"revivrons" => "R°vivR§",
"révocable" => "Revokabl",
"révocables" => "Revokabl",
"révocation" => "Revokasj§",
"révocations" => "Revokasj§",
"revoici" => "R°vwasi",
"revoie" => "R°vwa",
"revoient" => "R°vwa",
"revoies" => "R°vwa",
"revoilà" => "R°vwala",
"revoir" => "R°vwaR",
"revois" => "R°vwa",
"revoit" => "R°vwa",
"revolait" => "R°volE",
"revole" => "R°vOl",
"revolé" => "R°vole",
"revolent" => "R°vOl",
"revoler" => "R2vOle",
"revolera" => "R°vOl°Ra",
"révolta" => "RevOlta",
"révoltai" => "RevOltE",
"révoltaient" => "RevOltE",
"révoltais" => "RevOltE",
"révoltait" => "RevOltE",
"révoltant" => "RevOlt@",
"révoltante" => "RevOlt@t",
"révoltantes" => "RevOlt@t",
"révoltants" => "RevOlt@",
"révoltât" => "RevOlta",
"révolte" => "RevOlt",
"révolté" => "RevOlte",
"révoltée" => "RevOlte",
"révoltées" => "RevOlte",
"révoltent" => "RevOlt",
"révolter" => "RevOlte",
"révoltèrent" => "RevOltER",
"révolteront" => "RevOlt°R§",
"révoltes" => "RevOlt",
"révoltés" => "RevOlte",
"révoltez" => "RevOlte",
"révoltions" => "RevOltj§",
"révoltons" => "RevOlt§",
"révolu" => "Revoly",
"révolue" => "Revoly",
"révolues" => "Revoly",
"révolus" => "Revoly",
"révolution" => "Revolysj§",
"révolutionna" => "Revolysjona",
"révolutionnaient" => "RevolysjonE",
"révolutionnaire" => "RevolysjonER",
"révolutionnairement" => "RevOlysjOnER°m@",
"révolutionnaires" => "RevolysjonER",
"révolutionnait" => "RevolysjonE",
"révolutionné" => "Revolysjone",
"révolutionnées" => "Revolysjone",
"révolutionner" => "Revolysjone",
"révolutionnera" => "RevolysjOn°Ra",
"révolutionnerait" => "RevolysjOn°RE",
"révolutionneront" => "RevolysjOn°R§",
"révolutions" => "Revolysj§",
"revolver" => "RevOlvER",
"revolvers" => "RevOlvER",
"revomir" => "R°vomiR",
"revomissant" => "R°vomis@",
"rêvons" => "REv§",
"révoquais" => "RevokE",
"révoque" => "RevOk",
"révoqué" => "Revoke",
"révoquée" => "Revoke",
"révoquées" => "Revoke",
"révoquer" => "Revoke",
"révoqués" => "Revoke",
"revoter" => "RevOte",
"revoulait" => "R°vulE",
"revoulez" => "R°vule",
"revouloir" => "R°vulwaR",
"revoyaient" => "R°vwajE",
"revoyais" => "R°vwajE",
"revoyait" => "R°vwajE",
"revoyant" => "R°vwaj@",
"revoyez" => "R°vwaje",
"revoyiez" => "R°vwaje",
"revoyions" => "R°vwajj§",
"revoyons" => "R°vwaj§",
"revoyure" => "R°vwajyR",
"revu" => "R°vy",
"revue" => "R°vy",
"revues" => "R°vy",
"revuistes" => "R°v8ist",
"révulsaient" => "RevylsE",
"révulsait" => "RevylsE",
"révulsant" => "Revyls@",
"révulse" => "Revyls",
"révulsé" => "Revylse",
"révulsée" => "Revylse",
"révulser" => "Revylse",
"révulserait" => "Revyls°RE",
"révulsèrent" => "RevylsER",
"révulsés" => "Revylse",
"révulsif" => "Revylsif",
"révulsifs" => "Revylsif",
"révulsion" => "Revylsj§",
"révulsive" => "Revylsiv",
"revus" => "R°vy",
"rewrité" => "R°wRajte",
"rex" => "REks",
"rexiste" => "REksist",
"rexistes" => "REksist",
"rez" => "Re",
"rez-de-chaussée" => "Red°Sose",
"rez-de-jardin" => "Red°ZaRd5",
"rezzou" => "R°zu",
"rezzous" => "R°zu",
"rhabilla" => "Rabija",
"rhabillage" => "RabijaZ",
"rhabillaient" => "RabijE",
"rhabillais" => "RabijE",
"rhabillait" => "RabijE",
"rhabillant" => "Rabij@",
"rhabille" => "Rabij",
"rhabillé" => "Rabije",
"rhabillée" => "Rabije",
"rhabillées" => "Rabije",
"rhabillent" => "Rabij",
"rhabiller" => "Rabije",
"rhabillèrent" => "RabijER",
"rhabilles" => "Rabij",
"rhabillés" => "Rabije",
"rhabilleur" => "Rabij9R",
"rhabillez" => "Rabije",
"rhabilliez" => "Rabije",
"rhabillons" => "Rabij§",
"rhapsodie" => "Rapsodi",
"rhapsodies" => "Rapsodi",
"rhénan" => "Ren@",
"rhénane" => "Renan",
"rhénans" => "Ren@",
"rhéostat" => "Reosta",
"rhésus" => "Rezys",
"rhéteur" => "Ret9R",
"rhéteurs" => "Ret9R",
"rhétoricien" => "RetORisj5",
"rhétorique" => "RetoRik",
"rhétoriques" => "RetoRik",
"rhingraves" => "R5gRav",
"rhinite" => "Rinit",
"rhinites" => "Rinit",
"rhino" => "Rino",
"rhinocéros" => "RinoseROs",
"rhinoplastie" => "RinOplasti",
"rhinos" => "Rino",
"rhinoscopie" => "RinOskOpi",
"rhizome" => "Rizom",
"rhizopus" => "RizOpys",
"rho" => "Ro",
"rhô" => "Ro",
"rhodamine" => "ROdamin",
"rhodanien" => "Rodanj5",
"rhodia" => "Rodja",
"rhodium" => "ROdjOm",
"rhodo" => "ROdO",
"rhododendron" => "Rodod5dR§",
"rhododendrons" => "Rodod5dR§",
"rhodoïd" => "Rodoid",
"rhombe" => "R§b",
"rhomboïdal" => "R§boidal",
"rhomboïdes" => "R§boid",
"rhovyl" => "Rovil",
"rhubarbe" => "RybaRb",
"rhubarbes" => "RybaRb",
"rhum" => "ROm",
"rhumatisant" => "Rymatiz@",
"rhumatisante" => "Rymatiz@t",
"rhumatisants" => "Rymatiz@",
"rhumatismal" => "Rymatismal",
"rhumatismale" => "Rymatismal",
"rhumatismales" => "Rymatismal",
"rhumatisme" => "Rymatizm",
"rhumatismes" => "Rymatizm",
"rhumatoïde" => "RymatOid",
"rhumatologie" => "RymatOlOZi",
"rhumatologue" => "RymatOlOg",
"rhumbs" => "R§b",
"rhume" => "Rym",
"rhumerie" => "ROm°Ri",
"rhumes" => "Rym",
"rhynchites" => "R5Sit",
"rhyolite" => "Riolit",
"rhythm and blues" => "RitmEnbluz",
"rhythm'n'blues" => "RitmEnbluz",
"ri" => "Ri",
"ria" => "Rja",
"riaient" => "RjE",
"riais" => "RjE",
"riait" => "RjE",
"rial" => "Rjal",
"rials" => "Rjal",
"riant" => "Rj@",
"riante" => "Rj@t",
"riantes" => "Rj@t",
"riants" => "Rj@",
"ribambelle" => "Rib@bEl",
"ribambelles" => "Rib@bEl",
"ribaud" => "Ribo",
"ribaude" => "Ribod",
"ribaudes" => "Ribod",
"ribauds" => "Ribo",
"ribes" => "RibEs",
"rible" => "Ribl",
"ribleur" => "Ribl9R",
"riboflavine" => "Riboflavin",
"ribosomes" => "Ribozom",
"ribot" => "Ribo",
"ribote" => "RibOt",
"riboter" => "RibOte",
"riboteur" => "RibOt9R",
"ribouis" => "Ribwi",
"riboulait" => "RibulE",
"riboulant" => "Ribul@",
"riboulants" => "Ribul@",
"ribouldingue" => "Ribuld5g",
"ribouler" => "Ribule",
"ric et rac" => "RikeRak",
"ric-à-rac" => "RikaRak",
"ric-rac" => "RikRak",
"ricain" => "Rik5",
"ricaine" => "RikEn",
"ricaines" => "RikEn",
"ricains" => "Rik5",
"ricana" => "Rikana",
"ricanai" => "RikanE",
"ricanaient" => "RikanE",
"ricanais" => "RikanE",
"ricanait" => "RikanE",
"ricanant" => "Rikan@",
"ricanante" => "Rikan@t",
"ricanantes" => "Rikan@t",
"ricanants" => "Rikan@",
"ricane" => "Rikan",
"ricané" => "Rikane",
"ricanement" => "Rikan°m@",
"ricanements" => "Rikan°m@",
"ricanent" => "Rikan",
"ricaner" => "Rikane",
"ricaneraient" => "Rikan°RE",
"ricanèrent" => "RikanER",
"ricaneront" => "Rikan°R§",
"ricanes" => "Rikan",
"ricaneur" => "Rikan9R",
"ricaneurs" => "Rikan9R",
"ricaneuse" => "Rikan2z",
"ricanions" => "Rikanj§",
"ricassant" => "Rikas@",
"ricasser" => "Rikase",
"richard" => "RiSaR",
"richarde" => "RiSaRd",
"richards" => "RiSaR",
"riche" => "RiS",
"richelieu" => "RiS°lj2",
"richelieus" => "RiS°lj2",
"richement" => "RiS°m@",
"riches" => "RiS",
"richesse" => "RiSEs",
"richesses" => "RiSEs",
"richissime" => "RiSisim",
"richissimes" => "RiSisim",
"richomme" => "RiSOm",
"ricin" => "Ris5",
"ricocha" => "RikoSa",
"ricochaient" => "RikoSE",
"ricochait" => "RikoSE",
"ricochant" => "RikoS@",
"ricoche" => "RikOS",
"ricoché" => "RikoSe",
"ricochent" => "RikOS",
"ricocher" => "RikoSe",
"ricochet" => "RikoSE",
"ricochets" => "RikoSE",
"ricotta" => "Rikota",
"rictus" => "Riktys",
"rida" => "Rida",
"ridaient" => "RidE",
"ridait" => "RidE",
"ridant" => "Rid@",
"ride" => "Rid",
"ridé" => "Ride",
"rideau" => "Rido",
"rideaux" => "Rido",
"ridée" => "Ride",
"ridées" => "Ride",
"ridelle" => "RidEl",
"ridelles" => "RidEl",
"rident" => "Rid",
"rider" => "Ride",
"rides" => "Rid",
"ridés" => "Ride",
"ridicule" => "Ridikyl",
"ridiculement" => "Ridikyl°m@",
"ridicules" => "Ridikyl",
"ridiculisa" => "Ridikyliza",
"ridiculisaient" => "RidikylizE",
"ridiculisais" => "RidikylizE",
"ridiculisait" => "RidikylizE",
"ridiculisant" => "Ridikyliz@",
"ridiculisation" => "Ridikylizasj§",
"ridiculise" => "Ridikyliz",
"ridiculisé" => "Ridikylize",
"ridiculisée" => "Ridikylize",
"ridiculisées" => "Ridikylize",
"ridiculisent" => "Ridikyliz",
"ridiculiser" => "Ridikylize",
"ridiculisera" => "Ridikyliz°Ra",
"ridiculiserai" => "Ridikyliz°RE",
"ridiculiserais" => "Ridikyliz°RE",
"ridiculiserait" => "Ridikyliz°RE",
"ridiculiseras" => "Ridikyliz°Ra",
"ridiculises" => "Ridikyliz",
"ridiculisés" => "Ridikylize",
"ridiculisez" => "Ridikylize",
"ridiculisiez" => "Ridikylizje",
"ridiculités" => "Ridikylite",
"ridule" => "Ridyl",
"ridules" => "Ridyl",
"rie" => "Ri",
"riel" => "RjEl",
"rien" => "Rj5",
"riens" => "Rj5",
"rient" => "Ri",
"ries" => "Ri",
"riesling" => "RisliG",
"rieur" => "Rj9R",
"rieurs" => "Rj9R",
"rieuse" => "Rj2z",
"rieuses" => "Rj2z",
"riez" => "Rje",
"rif" => "Rif",
"rifain" => "Rif5",
"rifains" => "Rif5",
"riff" => "Rif",
"riffaude" => "Rifod",
"riffaudé" => "Rifode",
"riffauder" => "Rifode",
"riffs" => "Rif",
"rififi" => "Rififi",
"riflard" => "RiflaR",
"rifle" => "Rifl",
"rifles" => "Rifl",
"riflette" => "RiflEt",
"rift" => "Rift",
"rigaudon" => "Rigod§",
"rigaudons" => "Rigod§",
"rigide" => "RiZid",
"rigidement" => "RiZid°m@",
"rigides" => "RiZid",
"rigidifier" => "RiZidifje",
"rigidité" => "RiZidite",
"rigidités" => "RiZidite",
"rigodon" => "Rigod§",
"rigola" => "Rigola",
"rigolade" => "Rigolad",
"rigolades" => "Rigolad",
"rigolage" => "RigolaZ",
"rigolaient" => "RigolE",
"rigolais" => "RigolE",
"rigolait" => "RigolE",
"rigolant" => "Rigol@",
"rigolard" => "RigolaR",
"rigolarde" => "RigolaRd",
"rigolardes" => "RigolaRd",
"rigolards" => "RigolaR",
"rigole" => "RigOl",
"rigolé" => "Rigole",
"rigolent" => "RigOl",
"rigoler" => "Rigole",
"rigolera" => "RigOl°Ra",
"rigolerai" => "RigOl°RE",
"rigoleraient" => "RigOl°RE",
"rigolerais" => "RigOl°RE",
"rigolerait" => "RigOl°RE",
"rigoleras" => "RigOl°Ra",
"rigolèrent" => "RigolER",
"rigolerez" => "RigOl°Re",
"rigoleront" => "RigOl°R§",
"rigoles" => "RigOl",
"rigoleur" => "Rigol9R",
"rigolez" => "Rigole",
"rigoliez" => "Rigolje",
"rigolions" => "Rigolj§",
"rigollot" => "Rigolo",
"rigolo" => "Rigolo",
"rigolons" => "Rigol§",
"rigolos" => "Rigolo",
"rigolote" => "RigolOt",
"rigolotes" => "RigolOt",
"rigorisme" => "RigoRizm",
"rigoriste" => "RigoRist",
"rigoristes" => "RigoRist",
"rigoureuse" => "RiguR2z",
"rigoureusement" => "RiguR2z°m@",
"rigoureuses" => "RiguR2z",
"rigoureux" => "RiguR2",
"rigueur" => "Rig9R",
"rigueurs" => "Rig9R",
"riiez" => "Rije",
"riions" => "Rij§",
"rikiki" => "Rikiki",
"rillettes" => "RijEt",
"rillons" => "Rij§",
"rima" => "Rima",
"rimaient" => "RimE",
"rimaillerie" => "Rimaj°Ri",
"rimailles" => "Rimaj",
"rimailleur" => "Rimaj9R",
"rimailleurs" => "Rimaj9R",
"rimait" => "RimE",
"rimante" => "Rim@t",
"rimaye" => "Rimaj",
"rimbaldien" => "R5baldj5",
"rime" => "Rim",
"rimé" => "Rime",
"rimée" => "Rime",
"riment" => "Rim",
"rimer" => "Rime",
"rimes" => "Rim",
"rîmes" => "Rim",
"rimés" => "Rime",
"rimeur" => "Rim9R",
"rimeurs" => "Rim9R",
"rimeuse" => "Rim2z",
"rimez" => "Rime",
"rimions" => "Rimj§",
"rimmel" => "RimEl",
"rinça" => "R5sa",
"rinçage" => "R5saZ",
"rinçages" => "R5saZ",
"rinçaient" => "R5sE",
"rinçais" => "R5sE",
"rinçait" => "R5sE",
"rinçant" => "R5s@",
"rince" => "R5s",
"rincé" => "R5se",
"rince-bouche" => "R5sbuS",
"rince-doigts" => "R5sdwa",
"rinceau" => "R5so",
"rinceaux" => "R5so",
"rincée" => "R5se",
"rincées" => "R5se",
"rincent" => "R5s",
"rincer" => "R5se",
"rincera" => "R5s°Ra",
"rincerai" => "R5s°RE",
"rinceraient" => "R5s°RE",
"rincèrent" => "R5sER",
"rinces" => "R5s",
"rincés" => "R5se",
"rincette" => "R5sEt",
"rinceur" => "R5s9R",
"rincez" => "R5se",
"rinforzando" => "RinfORdzando",
"ring" => "RiG",
"ringard" => "R5gaR",
"ringarde" => "R5gaRd",
"ringardes" => "R5gaRd",
"ringardise" => "R5gaRdiz",
"ringardises" => "R5gaRdiz",
"ringards" => "R5gaR",
"rings" => "RiG",
"rink" => "Rink",
"rinker" => "Rinke",
"rioja" => "Rjoxa",
"rions" => "Rj§",
"ripa" => "Ripa",
"ripaillait" => "RipajE",
"ripaille" => "Ripaj",
"ripaillé" => "Ripaje",
"ripailler" => "Ripaje",
"ripailles" => "Ripaj",
"ripaillons" => "Ripaj§",
"ripant" => "Rip@",
"ripaton" => "Ripat§",
"ripatons" => "Ripat§",
"ripe" => "Rip",
"ripé" => "Ripe",
"riper" => "Ripe",
"ripes" => "Rip",
"ripeur" => "Rip9R",
"ripolin" => "Ripol5",
"ripoliné" => "Ripoline",
"ripolinée" => "Ripoline",
"ripolinées" => "Ripoline",
"ripoliner" => "Ripoline",
"ripolines" => "Ripolin",
"ripolinés" => "Ripoline",
"riposta" => "RipOsta",
"ripostai" => "RipOstE",
"ripostaient" => "RipOstE",
"ripostais" => "RipOstE",
"ripostait" => "RipOstE",
"ripostant" => "RipOst@",
"riposte" => "RipOst",
"riposté" => "RipOste",
"ripostent" => "RipOst",
"riposter" => "RipOste",
"ripostera" => "RipOst°Ra",
"riposterai" => "RipOst°RE",
"riposterez" => "RipOst°Re",
"riposterons" => "RipOst°R§",
"riposteront" => "RipOst°R§",
"ripostes" => "RipOst",
"ripostez" => "RipOste",
"ripostions" => "RipOstj§",
"ripostons" => "RipOst§",
"ripou" => "Ripu",
"ripoux" => "Ripu",
"ripper" => "Rip9R",
"ripuaire" => "Rip8ER",
"riquiqui" => "Rikiki",
"rira" => "RiRa",
"rirai" => "RiRE",
"riraient" => "RiRE",
"rirais" => "RiRE",
"rirait" => "RiRE",
"riras" => "RiRa",
"rire" => "RiR",
"rirent" => "RiR",
"rires" => "RiR",
"rirez" => "RiRe",
"rirons" => "RiR§",
"riront" => "RiR§",
"ris" => "Ri",
"rise" => "Riz",
"risée" => "Rize",
"risées" => "Rize",
"riser" => "Rajz9R",
"risette" => "RizEt",
"risettes" => "RizEt",
"risibilité" => "Rizibilite",
"risible" => "Rizibl",
"risiblement" => "Rizibl°m@",
"risibles" => "Rizibl",
"risorius" => "RizoRjys",
"risotto" => "Rizoto",
"risqua" => "Riska",
"risquai" => "RiskE",
"risquaient" => "RiskE",
"risquais" => "RiskE",
"risquait" => "RiskE",
"risquant" => "Risk@",
"risquât" => "Riska",
"risque" => "Risk",
"risqué" => "Riske",
"risque-tout" => "Risk°tu",
"risquée" => "Riske",
"risquées" => "Riske",
"risquent" => "Risk",
"risquer" => "Riske",
"risquera" => "Risk°Ra",
"risquerai" => "Risk°RE",
"risqueraient" => "Risk°RE",
"risquerais" => "Risk°RE",
"risquerait" => "Risk°RE",
"risqueras" => "Risk°Ra",
"risquerez" => "Risk°Re",
"risqueriez" => "Risk°Rje",
"risquerions" => "Risk°Rj§",
"risquerons" => "Risk°R§",
"risqueront" => "Risk°R§",
"risques" => "Risk",
"risqués" => "Riske",
"risquez" => "Riske",
"risquiez" => "Riskje",
"risquions" => "Riskj§",
"risquons" => "Risk§",
"rissolaient" => "RisolE",
"rissolait" => "RisolE",
"rissole" => "RisOl",
"rissolé" => "Risole",
"rissolée" => "Risole",
"rissolées" => "Risole",
"rissolent" => "RisOl",
"rissoler" => "Risole",
"rissoles" => "RisOl",
"rissolés" => "Risole",
"ristournait" => "RistuRnE",
"ristourne" => "RistuRn",
"ristournes" => "RistuRn",
"rit" => "Ri",
"rît" => "Ri",
"rital" => "Rital",
"ritale" => "Rital",
"ritales" => "Rital",
"ritals" => "Rital",
"rite" => "Rit",
"rites" => "Rit",
"ritournelle" => "RituRnEl",
"ritournelles" => "RituRnEl",
"rittes" => "Rit",
"ritualisa" => "Rit8aliza",
"ritualisation" => "Rit8alizasj§",
"ritualisé" => "Rit8alize",
"ritualisés" => "Rit8alize",
"ritualiste" => "Rit8alist",
"ritualistes" => "Rit8alist",
"rituel" => "Rit8El",
"rituelle" => "Rit8El",
"rituellement" => "Rit8El°m@",
"rituelles" => "Rit8El",
"rituels" => "Rit8El",
"riva" => "Riva",
"rivage" => "RivaZ",
"rivages" => "RivaZ",
"rivaient" => "RivE",
"rivais" => "RivE",
"rivait" => "RivE",
"rival" => "Rival",
"rivale" => "Rival",
"rivales" => "Rival",
"rivalisaient" => "RivalizE",
"rivalisait" => "RivalizE",
"rivalisant" => "Rivaliz@",
"rivalise" => "Rivaliz",
"rivalisé" => "Rivalize",
"rivalisent" => "Rivaliz",
"rivaliser" => "Rivalize",
"rivalisera" => "Rivaliz°Ra",
"rivaliserait" => "Rivaliz°RE",
"rivalisèrent" => "RivalizER",
"rivalité" => "Rivalite",
"rivalités" => "Rivalite",
"rivant" => "Riv@",
"rivaux" => "Rivo",
"rive" => "Riv",
"rivé" => "Rive",
"rivée" => "Rive",
"rivées" => "Rive",
"river" => "Rive",
"riverain" => "Riv°R5",
"riveraines" => "Riv°REn",
"riverains" => "Riv°R5",
"riverait" => "Riv°RE",
"rives" => "Riv",
"rivés" => "Rive",
"rivet" => "RivE",
"rivetage" => "Riv°taZ",
"riveté" => "Riv°te",
"rivetées" => "Riv°te",
"riveteuse" => "Riv°t2z",
"rivets" => "RivE",
"rivette" => "RivEt",
"riviera" => "RivjERa",
"rivieras" => "RivjERa",
"rivière" => "RivjER",
"rivières" => "RivjER",
"rivoir" => "RivwaR",
"rixdales" => "Riksdal",
"rixe" => "Riks",
"rixes" => "Riks",
"riz" => "Ri",
"riz-minute" => "Riminyt",
"riz-pain-sel" => "Rip5sEl",
"rizière" => "RizjER",
"rizières" => "RizjER",
"roadster" => "ROwdst9R",
"roast beef" => "ROsbif",
"roast-beef" => "Rosbif",
"robe" => "ROb",
"rober" => "RObe",
"robert" => "RobER",
"roberts" => "RobER",
"robes" => "ROb",
"robette" => "RObEt",
"robin" => "Rob5",
"robinet" => "RobinE",
"robinets" => "RobinE",
"robinetterie" => "RobinEt°Ri",
"robiniers" => "Robinje",
"robins" => "Rob5",
"robinsonnade" => "Rob5sonad",
"robinsons" => "Rob5s§",
"roblot" => "ROblo",
"roboratif" => "RoboRatif",
"roborative" => "RoboRativ",
"roboratives" => "RoboRativ",
"robot" => "Robo",
"robotique" => "Robotik",
"robotiques" => "Robotik",
"robotisé" => "Robotize",
"robotisée" => "Robotize",
"robotisées" => "Robotize",
"robots" => "Robo",
"roburite" => "RobyRit",
"robuste" => "Robyst",
"robustement" => "Robyst°m@",
"robustes" => "Robyst",
"robustesse" => "RobystEs",
"roc" => "ROk",
"rocade" => "Rokad",
"rocades" => "Rokad",
"rocaille" => "Rokaj",
"rocaillé" => "ROkaje",
"rocailles" => "Rokaj",
"rocailleuse" => "Rokaj2z",
"rocailleuses" => "Rokaj2z",
"rocailleux" => "Rokaj2",
"rocambole" => "Rok@bOl",
"rocambolesque" => "Rok@bolEsk",
"rocambolesques" => "Rok@bolEsk",
"rochas" => "RoSa",
"rochassier" => "RoSasje",
"roche" => "ROS",
"roché" => "ROSe",
"rochelle" => "RoSEl",
"rocher" => "RoSe",
"rochers" => "RoSe",
"roches" => "ROS",
"rochet" => "RoSE",
"rocheuse" => "RoS2z",
"rocheuses" => "RoS2z",
"rocheux" => "RoS2",
"rochiers" => "RoSje",
"rock" => "ROk",
"rock-'n-roll" => "ROkEnROl",
"rock'n'roll" => "ROkEnROl",
"rocker" => "Rok9R",
"rockers" => "Rok9R",
"rocket" => "RokEt",
"rockets" => "RokEt",
"rockeur" => "Rok9R",
"rockeurs" => "Rok9R",
"rockeuse" => "Rok2z",
"rocking chair" => "ROkiGtSER",
"rocking-chair" => "ROkiGtSER",
"rocking-chairs" => "ROkiGtSER",
"rocks" => "ROk",
"rococo" => "Rokoko",
"rococos" => "Rokoko",
"rocs" => "ROk",
"rôda" => "Roda",
"rodage" => "RodaZ",
"rodages" => "RodaZ",
"rôdai" => "RodE",
"rôdaient" => "RodE",
"rôdailler" => "Rodaje",
"rôdais" => "RodE",
"rodait" => "RodE",
"rôdait" => "RodE",
"rôdâmes" => "Rodam",
"rôdant" => "Rod@",
"rode" => "Rod",
"rôde" => "Rod",
"rodé" => "Rode",
"rôdé" => "Rode",
"rodée" => "Rode",
"rôdée" => "Rode",
"rodées" => "Rode",
"rôdent" => "Rod",
"rodeo" => "ROdeo",
"rodéo" => "Rodeo",
"rodéos" => "Rodeo",
"roder" => "Rode",
"rôder" => "Rode",
"rôdera" => "Rod°Ra",
"rôderai" => "Rod°RE",
"roderait" => "Rod°RE",
"rôderait" => "Rod°RE",
"rôdèrent" => "RodER",
"rôdes" => "Rod",
"rodés" => "Rode",
"rôdés" => "Rode",
"rôdeur" => "Rod9R",
"rôdeurs" => "Rod9R",
"rôdeuse" => "Rod2z",
"rôdeuses" => "Rod2z",
"rôdez" => "Rode",
"rôdiez" => "Rodje",
"rôdions" => "Rodj§",
"rodomontades" => "Rodom§tad",
"roentgens" => "R9ntgEn",
"rogations" => "Rogasj§",
"rogatoire" => "RogatwaR",
"rogatoires" => "RogatwaR",
"rogaton" => "Rogat§",
"rogatons" => "Rogat§",
"rogna" => "RoNa",
"rognais" => "RoNE",
"rognait" => "RoNE",
"rognant" => "RoN@",
"rogne" => "RON",
"rogné" => "RoNe",
"rogne-pied" => "RONpje",
"rognée" => "RoNe",
"rognées" => "RoNe",
"rognent" => "RON",
"rogner" => "RoNe",
"rognes" => "RON",
"rognés" => "RoNe",
"rogneux" => "RON2",
"rognez" => "RoNe",
"rognon" => "RoN§",
"rognonnait" => "RoNonE",
"rognons" => "RoN§",
"rognure" => "RoNyR",
"rognures" => "RoNyR",
"rogomme" => "RogOm",
"rogommes" => "RogOm",
"rogue" => "ROg",
"rogues" => "ROg",
"roi" => "Rwa",
"roi-roi" => "RwaRwa",
"roi-soleil" => "RwasOlEj",
"roide" => "Rwad",
"roidement" => "Rwad°m@",
"roides" => "Rwad",
"roideur" => "Rwad9R",
"roidi" => "Rwadi",
"roidie" => "Rwadi",
"roidir" => "RwadiR",
"roidissait" => "RwadisE",
"rois" => "Rwa",
"roitelet" => "Rwat°lE",
"roitelets" => "Rwat°lE",
"rôle" => "Rol",
"rôle-titre" => "RoltitR",
"rôles" => "Rol",
"roll" => "ROl",
"rolle" => "ROl",
"roller" => "ROl9R",
"rollers" => "ROl9R",
"rollmops" => "ROlmOps",
"rom" => "ROm",
"romain" => "Rom5",
"romaine" => "RomEn",
"romaines" => "RomEn",
"romains" => "Rom5",
"roman" => "Rom@",
"roman-feuilleton" => "Rom@f9j°t§",
"roman-fleuve" => "Rom@fl9v",
"roman-photo" => "Rom@foto",
"romance" => "Rom@s",
"romancé" => "ROm@se",
"romancée" => "Rom@se",
"romancées" => "Rom@se",
"romancer" => "Rom@se",
"romancero" => "Rom@s°Ro",
"romances" => "Rom@s",
"romanche" => "Rom@S",
"romancier" => "Rom@sje",
"romancière" => "Rom@sjER",
"romancières" => "Rom@sjER",
"romanciers" => "Rom@sje",
"romande" => "Rom@d",
"romane" => "Roman",
"romanes" => "Roman",
"romanesque" => "RomanEsk",
"romanesques" => "RomanEsk",
"romani" => "Romani",
"romanichel" => "RomaniSEl",
"romanichelle" => "RomaniSEl",
"romanichelles" => "RomaniSEl",
"romanichels" => "RomaniSEl",
"romanisation" => "Romanizasj§",
"romanistes" => "Romanist",
"romanité" => "Romanite",
"romano" => "Romano",
"romanos" => "Romano",
"romans" => "Rom@",
"romans-feuilletons" => "Rom@f9j°t§",
"romans-photos" => "Rom@foto",
"romanticisme" => "ROm@tisism",
"romantique" => "Rom@tik",
"romantiquement" => "Rom@tik°m@",
"romantiques" => "Rom@tik",
"romantisme" => "Rom@tizm",
"romantismes" => "Rom@tizm",
"romarin" => "RomaR5",
"rombière" => "R§bjER",
"rombières" => "R§bjER",
"rompaient" => "R§pE",
"rompais" => "R§pE",
"rompait" => "R§pE",
"rompant" => "R§p@",
"rompe" => "R§p",
"rompent" => "R§p",
"rompez" => "R§pe",
"rompiez" => "R§pje",
"rompirent" => "R§piR",
"rompis" => "R§pi",
"rompissent" => "R§pis",
"rompit" => "R§pi",
"rompît" => "R§pi",
"rompons" => "R§p§",
"rompra" => "R§pRa",
"romprai" => "R§pRE",
"rompraient" => "R§pRE",
"romprais" => "R§pRE",
"romprait" => "R§pRE",
"rompre" => "R§pR",
"romprez" => "R§pRe",
"romprions" => "R§pRij§",
"romprons" => "R§pR§",
"romps" => "R§",
"rompt" => "R§",
"rompu" => "R§py",
"rompue" => "R§py",
"rompues" => "R§py",
"rompus" => "R§py",
"roms" => "ROm",
"ron" => "R§",
"ronce" => "R§s",
"ronces" => "R§s",
"roncet" => "R§sE",
"ronceux" => "R§s2",
"ronchon" => "R§S§",
"ronchonna" => "R§Sona",
"ronchonnaient" => "R§SonE",
"ronchonnais" => "R§SonE",
"ronchonnait" => "R§SonE",
"ronchonnant" => "R§Son@",
"ronchonne" => "R§SOn",
"ronchonné" => "R§Sone",
"ronchonnent" => "R§SOn",
"ronchonner" => "R§Sone",
"ronchonnes" => "R§SOn",
"ronchonneur" => "R§Son9R",
"ronchonneuse" => "R§Son2z",
"ronchonnot" => "R§Sono",
"roncier" => "R§sje",
"ronciers" => "R§sje",
"rond" => "R§",
"rond-de-cuir" => "R§d°k8iR",
"rond-point" => "R§pw5",
"rondache" => "R§daS",
"ronde" => "R§d",
"ronde-bosse" => "R§dbOs",
"rondeau" => "R§do",
"rondelet" => "R§d°lE",
"rondelette" => "R§d°lEt",
"rondelettes" => "R§d°lEt",
"rondelle" => "R§dEl",
"rondelles" => "R§dEl",
"rondement" => "R§d°m@",
"rondes" => "R§d",
"rondeur" => "R§d9R",
"rondeurs" => "R§d9R",
"rondin" => "R§d5",
"rondins" => "R§d5",
"rondo" => "R§do",
"rondos" => "R§do",
"rondouillard" => "R§dujaR",
"rondouillarde" => "R§dujaRd",
"rondouillards" => "R§dujaR",
"ronds" => "R§",
"ronds-de-cuir" => "R§d°k8iR",
"ronds-points" => "R§pw5",
"ronéo" => "Roneo",
"ronéoté" => "Roneote",
"ronéotions" => "Roneotj§",
"ronéotypé" => "Roneotipe",
"ronéotyper" => "Roneotipe",
"ronéotypés" => "Roneotipe",
"ronfla" => "R§fla",
"ronflaient" => "R§flE",
"ronflais" => "R§flE",
"ronflait" => "R§flE",
"ronflant" => "R§fl@",
"ronflante" => "R§fl@t",
"ronflantes" => "R§fl@t",
"ronflants" => "R§fl@",
"ronfle" => "R§fl",
"ronflé" => "R§fle",
"ronflement" => "R§fl°m@",
"ronflements" => "R§fl°m@",
"ronflent" => "R§fl",
"ronfler" => "R§fle",
"ronflerais" => "R§fl°RE",
"ronfleras" => "R§fl°Ra",
"ronflèrent" => "R§flER",
"ronfles" => "R§fl",
"ronflette" => "R§flEt",
"ronfleur" => "R§fl9R",
"ronfleurs" => "R§fl9R",
"ronfleuse" => "R§fl2z",
"ronflez" => "R§fle",
"ronfliez" => "R§flie",
"ronflotait" => "R§flotE",
"ronflotant" => "R§flot@",
"ronflote" => "R§flOt",
"ronge" => "R§Z",
"rongé" => "R§Ze",
"rongea" => "R§Za",
"rongeai" => "R§ZE",
"rongeaient" => "R§ZE",
"rongeais" => "R§ZE",
"rongeait" => "R§ZE",
"rongeant" => "R§Z@",
"rongeante" => "R§Z@t",
"rongeantes" => "R§Z@t",
"rongeât" => "R§Za",
"rongée" => "R§Ze",
"rongées" => "R§Ze",
"rongement" => "R§Z°m@",
"rongent" => "R§Z",
"ronger" => "R§Ze",
"rongera" => "R§Z°Ra",
"rongerait" => "R§Z°RE",
"rongèrent" => "R§ZER",
"ronges" => "R§Z",
"rongés" => "R§Ze",
"rongeur" => "R§Z9R",
"rongeurs" => "R§Z9R",
"rongeuse" => "R§Z2z",
"rongeuses" => "R§Z2z",
"rongez" => "R§Ze",
"rongicide" => "R§Zisid",
"rônier" => "Ronje",
"rôniers" => "Ronje",
"ronin" => "ROn5",
"rônin" => "Ron5",
"rônins" => "Ron5",
"ronron" => "R§R§",
"ronronna" => "R§Rona",
"ronronnaient" => "R§RonE",
"ronronnais" => "R§RonE",
"ronronnait" => "R§RonE",
"ronronnant" => "R§Ron@",
"ronronnante" => "R§Ron@t",
"ronronnantes" => "R§Ron@t",
"ronronnants" => "R§Ron@",
"ronronne" => "R§ROn",
"ronronné" => "R§Rone",
"ronronnement" => "R§ROn°m@",
"ronronnements" => "R§ROn°m@",
"ronronnent" => "R§ROn",
"ronronner" => "R§Rone",
"ronronnerait" => "R§ROn°RE",
"ronronnèrent" => "R§RonER",
"ronronnons" => "R§Ron§",
"ronrons" => "R§R§",
"röntgens" => "R2ntgEns",
"roof" => "Ruf",
"roploplos" => "Roploplo",
"roque" => "ROk",
"roquefort" => "ROkfOR",
"roquentin" => "Rok@t5",
"roquer" => "Roke",
"roques" => "ROk",
"roquet" => "RokE",
"roquets" => "RokE",
"roquette" => "RokEt",
"roquettes" => "RokEt",
"rorqual" => "RORkal",
"rorquals" => "RORkal",
"rosa" => "Roza",
"rosace" => "Rozas",
"rosaces" => "Rozas",
"rosages" => "RozaZ",
"rosaire" => "RozER",
"rosaires" => "RozER",
"rosales" => "Rozal",
"rosat" => "Roza",
"rosâtre" => "RozatR",
"rosâtres" => "RozatR",
"rosbif" => "ROsbif",
"rosbifs" => "ROsbif",
"rose" => "Roz",
"rosé" => "Roze",
"rose-croix" => "RozkRwa",
"rose-thé" => "Rozte",
"roseau" => "Rozo",
"roseaux" => "Rozo",
"rosée" => "Roze",
"rosées" => "Roze",
"roselière" => "Roz°ljER",
"roselières" => "Roz°ljER",
"roséole" => "RozeOl",
"roser" => "Roze",
"roseraie" => "Roz°RE",
"roseraies" => "Roz°RE",
"roses" => "Roz",
"rosés" => "Roze",
"rosette" => "RozEt",
"rosettes" => "RozEt",
"roseur" => "Roz9R",
"roseurs" => "Roz9R",
"rosi" => "Rozi",
"rosicrucien" => "RozikRysj5",
"rosicrucienne" => "RozikRysjEn",
"rosicruciens" => "RozikRysj5",
"rosie" => "Rozi",
"rosier" => "Rozje",
"rosière" => "RozjER",
"rosiers" => "Rozje",
"rosies" => "Rozi",
"rosir" => "RoziR",
"rosis" => "Rozi",
"rosissaient" => "RozisE",
"rosissait" => "RozisE",
"rosissant" => "Rozis@",
"rosissent" => "Rozis",
"rosit" => "Rozi",
"rossa" => "Rosa",
"rossaient" => "RosE",
"rossait" => "RosE",
"rossant" => "Ros@",
"rossard" => "RosaR",
"rossards" => "RosaR",
"rosse" => "ROs",
"rossé" => "Rose",
"rossée" => "Rose",
"rossent" => "ROs",
"rosser" => "Rose",
"rosserai" => "ROs°RE",
"rosserie" => "ROs°Ri",
"rosseries" => "ROs°Ri",
"rosses" => "ROs",
"rossés" => "Rose",
"rossez" => "Rose",
"rossignol" => "RosiNOl",
"rossignols" => "RosiNOl",
"rossinante" => "Rosin@t",
"rossinantes" => "Rosin@t",
"rostre" => "ROstR",
"rostres" => "ROstR",
"rot" => "Ro",
"rôt" => "Ro",
"rota" => "Rota",
"rotaient" => "RotE",
"rotais" => "RotE",
"rotait" => "RotE",
"rotant" => "Rot@",
"rotariens" => "RotaRj5",
"rotary" => "RotaRi",
"rotateur" => "Rotat9R",
"rotatif" => "Rotatif",
"rotatifs" => "Rotatif",
"rotation" => "Rotasj§",
"rotationnel" => "ROtasjOnEl",
"rotations" => "Rotasj§",
"rotative" => "Rotativ",
"rotatives" => "Rotativ",
"rotativistes" => "Rotativist",
"rotatoire" => "RotatwaR",
"rote" => "ROt",
"roté" => "Rote",
"rotées" => "Rote",
"rotengles" => "Rot@gl",
"roténone" => "RotenOn",
"rotent" => "ROt",
"roter" => "Rote",
"rotera" => "ROt°Ra",
"rotes" => "ROt",
"roteur" => "ROt9R",
"roteuse" => "Rot2z",
"roteuses" => "Rot2z",
"rotez" => "Rote",
"rôti" => "Roti",
"rôtie" => "Roti",
"rôties" => "Roti",
"rotin" => "Rot5",
"rôtir" => "RotiR",
"rôtiront" => "RotiR§",
"rôtis" => "Roti",
"rôtissaient" => "RotisE",
"rôtissait" => "RotisE",
"rôtissant" => "Rotis@",
"rôtissent" => "Rotis",
"rôtisserie" => "Rotis°Ri",
"rôtisseur" => "Rotis9R",
"rôtisseurs" => "Rotis9R",
"rôtisseuse" => "ROtis2z",
"rôtisseuses" => "Rotis2z",
"rôtissez" => "Rotise",
"rôtissions" => "Rotisj§",
"rôtissoire" => "RotiswaR",
"rôtissoires" => "RotiswaR",
"rôtit" => "Roti",
"roto" => "Roto",
"rotonde" => "Rot§d",
"rotondes" => "Rot§d",
"rotondité" => "Rot§dite",
"rotondités" => "Rot§dite",
"rotoplos" => "ROtOplo",
"rotoplots" => "Rotoplo",
"rotor" => "RotOR",
"rotors" => "RotOR",
"rotos" => "Roto",
"rototo" => "ROtOto",
"rototos" => "Rototo",
"rots" => "Ro",
"rôts" => "Ro",
"rotule" => "Rotyl",
"rotules" => "Rotyl",
"rotulien" => "ROtylj5",
"roture" => "RotyR",
"roturier" => "RotyRje",
"roturière" => "RotyRjER",
"roturiers" => "RotyRje",
"roua" => "Rwa",
"rouage" => "RwaZ",
"rouages" => "RwaZ",
"rouaient" => "RwE",
"rouais" => "RuE",
"rouait" => "RwE",
"rouan" => "Rw@",
"rouant" => "Rw@",
"roubaisienne" => "RubEzjEn",
"roubignoles" => "RubiNOl",
"roublard" => "RublaR",
"roublarde" => "RublaRd",
"roublarder" => "RublaRde",
"roublardes" => "RublaRd",
"roublardise" => "RublaRdiz",
"roublardises" => "RublaRdiz",
"rouble" => "Rubl",
"roubles" => "Rubl",
"roucoula" => "Rukula",
"roucoulade" => "Rukulad",
"roucoulades" => "Rukulad",
"roucoulaient" => "RukulE",
"roucoulais" => "RukulE",
"roucoulait" => "RukulE",
"roucoulant" => "Rukul@",
"roucoulante" => "Rukul@t",
"roucoulantes" => "Rukul@t",
"roucoulants" => "Rukul@",
"roucoule" => "Rukul",
"roucoulé" => "Rukule",
"roucoulement" => "Rukul°m@",
"roucoulements" => "Rukul°m@",
"roucoulent" => "Rukul",
"roucouler" => "Rukule",
"roucoulerez" => "Rukul°Re",
"roucoulés" => "Rukule",
"roucouleur" => "Rukul9R",
"roudoudou" => "Rududu",
"roudoudous" => "Rududu",
"roue" => "Ru",
"roué" => "Rwe",
"rouée" => "Rwe",
"rouelle" => "RwEl",
"rouennaise" => "RwanEz",
"rouenneries" => "RwEn°Ri",
"rouent" => "Ru",
"rouer" => "Rwe",
"rouerai" => "RuRE",
"rouergat" => "RwERga",
"rouerie" => "RuRi",
"roueries" => "RuRi",
"roueront" => "RuR§",
"roues" => "Ru",
"roués" => "Rwe",
"rouet" => "RwE",
"rouf" => "Ruf",
"rouflaquettes" => "RuflakEt",
"rouge" => "RuZ",
"rouge-brun" => "RuZbR1",
"rouge-feu" => "RuZf2",
"rouge-gorge" => "RuZgORZ",
"rouge-queue" => "RuZ°k2",
"rouge-sang" => "RuZs@",
"rougeâtre" => "RuZatR",
"rougeâtres" => "RuZatR",
"rougeaud" => "RuZo",
"rougeaude" => "RuZod",
"rougeaudes" => "RuZod",
"rougeauds" => "RuZo",
"rougeoie" => "RuZwa",
"rougeoiement" => "RuZwam@",
"rougeoiements" => "RuZwam@",
"rougeoient" => "RuZwa",
"rougeole" => "RuZOl",
"rougeoya" => "RuZwaja",
"rougeoyaient" => "RuZwajE",
"rougeoyait" => "RuZwajE",
"rougeoyant" => "RuZwaj@",
"rougeoyante" => "RuZwaj@t",
"rougeoyantes" => "RuZwaj@t",
"rougeoyants" => "RuZwaj@",
"rougeoyé" => "RuZwaje",
"rougeoyer" => "RuZwaje",
"rouges" => "RuZ",
"rouges-gorges" => "RuZgORZ",
"rouget" => "RuZE",
"rougets" => "RuZE",
"rougeur" => "RuZ9R",
"rougeurs" => "RuZ9R",
"rough" => "Ruf",
"rougi" => "RuZi",
"rougie" => "RuZi",
"rougies" => "RuZi",
"rougir" => "RuZiR",
"rougira" => "RuZiRa",
"rougiraient" => "RuZiRE",
"rougirais" => "RuZiRE",
"rougirait" => "RuZiRE",
"rougirent" => "RuZiR",
"rougirez" => "RuZiRe",
"rougis" => "RuZi",
"rougissaient" => "RuZisE",
"rougissais" => "RuZisE",
"rougissait" => "RuZisE",
"rougissant" => "RuZis@",
"rougissante" => "RuZis@t",
"rougissantes" => "RuZis@t",
"rougissants" => "RuZis@",
"rougisse" => "RuZis",
"rougissement" => "RuZis°m@",
"rougissements" => "RuZis°m@",
"rougissent" => "RuZis",
"rougissez" => "RuZise",
"rougit" => "RuZi",
"rougît" => "RuZi",
"roui" => "Rwi",
"rouies" => "Rwi",
"rouillaient" => "RujE",
"rouillait" => "RujE",
"rouillant" => "Ruj@",
"rouillarde" => "RujaRd",
"rouille" => "Ruj",
"rouillé" => "Ruje",
"rouillée" => "Ruje",
"rouillées" => "Ruje",
"rouillent" => "Ruj",
"rouiller" => "Ruje",
"rouillerait" => "Ruj°RE",
"rouilleront" => "Ruj°R§",
"rouilles" => "Ruj",
"rouillés" => "Ruje",
"rouilleux" => "Ruj2",
"rouillures" => "RujyR",
"rouissant" => "Rwis@",
"rouissent" => "Rwis",
"roula" => "Rula",
"roulade" => "Rulad",
"roulades" => "Rulad",
"roulage" => "RulaZ",
"roulages" => "RulaZ",
"roulai" => "RulE",
"roulaient" => "RulE",
"roulais" => "RulE",
"roulait" => "RulE",
"roulâmes" => "Rulam",
"roulant" => "Rul@",
"roulante" => "Rul@t",
"roulantes" => "Rul@t",
"roulants" => "Rul@",
"roulât" => "Rula",
"roule" => "Rul",
"roulé" => "Rule",
"roulé-boulé" => "Rulebule",
"rouleau" => "Rulo",
"rouleaux" => "Rulo",
"roulée" => "Rule",
"roulées" => "Rule",
"roulement" => "Rul°m@",
"roulements" => "Rul°m@",
"roulent" => "Rul",
"rouler" => "Rule",
"roulera" => "Rul°Ra",
"roulerai" => "Rul°RE",
"rouleraient" => "Rul°RE",
"roulerais" => "Rul°RE",
"roulerait" => "Rul°RE",
"rouleras" => "Rul°Ra",
"roulèrent" => "RulER",
"roulerez" => "Rul°Re",
"rouleriez" => "Rul°Rje",
"roulerons" => "Rul°R§",
"rouleront" => "Rul°R§",
"roules" => "Rul",
"roulés" => "Rule",
"roulés-boulés" => "Rulebule",
"roulette" => "RulEt",
"roulettes" => "RulEt",
"rouleur" => "Rul9R",
"rouleurs" => "Rul9R",
"rouleuse" => "Rul2z",
"rouleuses" => "Rul2z",
"roulez" => "Rule",
"roulier" => "Rulje",
"rouliers" => "Rulje",
"rouliez" => "Rulje",
"roulions" => "Rulj§",
"roulis" => "Ruli",
"roulons" => "Rul§",
"roulottait" => "RulotE",
"roulotte" => "RulOt",
"roulottent" => "RulOt",
"roulottes" => "RulOt",
"roulottière" => "RulotjER",
"roulottiers" => "Rulotje",
"roulure" => "RulyR",
"roulures" => "RulyR",
"roumain" => "Rum5",
"roumaine" => "RumEn",
"roumaines" => "RumEn",
"roumains" => "Rum5",
"roumi" => "Rumi",
"roumis" => "Rumi",
"round" => "Rund",
"rounds" => "Rund",
"roupane" => "Rupan",
"roupette" => "RupEt",
"roupettes" => "RupEt",
"roupie" => "Rupi",
"roupies" => "Rupi",
"roupillaient" => "RupijE",
"roupillais" => "RupijE",
"roupillait" => "RupijE",
"roupille" => "Rupij",
"roupillé" => "Rupije",
"roupillent" => "Rupij",
"roupiller" => "Rupije",
"roupillerai" => "Rupij°RE",
"roupillerais" => "Rupij°RE",
"roupillerait" => "Rupij°RE",
"roupilles" => "Rupij",
"roupillez" => "Rupije",
"roupillon" => "Rupij§",
"roupillons" => "Rupij§",
"rouquemoute" => "Ruk°mut",
"rouquette" => "RukEt",
"rouquin" => "Ruk5",
"rouquine" => "Rukin",
"rouquines" => "Rukin",
"rouquins" => "Ruk5",
"rouscaillait" => "RuskajE",
"rouscaillant" => "Ruskaj@",
"rouscaille" => "Ruskaj",
"rouscaillent" => "Ruskaj",
"rouscailler" => "Ruskaje",
"rouspéta" => "Ruspeta",
"rouspétage" => "RuspetaZ",
"rouspétaient" => "RuspetE",
"rouspétais" => "RuspEtE",
"rouspétait" => "RuspetE",
"rouspétance" => "Ruspet@s",
"rouspétant" => "Ruspet@",
"rouspète" => "RuspEt",
"rouspètent" => "RuspEt",
"rouspéter" => "Ruspete",
"rouspétera" => "Ruspet°Ra",
"rouspètes" => "RuspEt",
"rouspéteur" => "Ruspet9R",
"rouspéteurs" => "Ruspet9R",
"rouspétez" => "Ruspete",
"roussâtre" => "RusatR",
"roussâtres" => "RusatR",
"rousse" => "Rus",
"roussé" => "Ruse",
"rousseau" => "Ruso",
"rousseauiste" => "Rusoist",
"rousseaux" => "Ruso",
"rousselée" => "RusEle",
"rousserolle" => "Rus°ROl",
"rousses" => "Rus",
"roussette" => "RusEt",
"roussettes" => "RusEt",
"rousseur" => "Rus9R",
"rousseurs" => "Rus9R",
"roussi" => "Rusi",
"roussie" => "Rusi",
"roussies" => "Rusi",
"roussin" => "Rus5",
"roussins" => "Rus5",
"roussir" => "RusiR",
"roussis" => "Rusi",
"roussissaient" => "RusisE",
"roussissait" => "RusisE",
"roussissant" => "Rusis@",
"roussissures" => "RusisyR",
"roussit" => "Rusi",
"rouste" => "Rust",
"roustes" => "Rust",
"rousti" => "Rusti",
"rousties" => "Rusti",
"roustis" => "Rusti",
"rouston" => "Rust§",
"roustons" => "Rust§",
"routage" => "RutaZ",
"routard" => "RutaR",
"routarde" => "RutaRd",
"routards" => "RutaR",
"route" => "Rut",
"routé" => "Rute",
"router" => "Rute",
"routes" => "Rut",
"routeur" => "Rut9R",
"routeurs" => "Rut9R",
"routier" => "Rutje",
"routière" => "RutjER",
"routières" => "RutjER",
"routiers" => "Rutje",
"routin" => "Rut5",
"routine" => "Rutin",
"routines" => "Rutin",
"routinier" => "Rutinje",
"routinière" => "RutinjER",
"routinières" => "RutinjER",
"routiniers" => "Rutinje",
"rouvert" => "RuvER",
"rouverte" => "RuvERt",
"rouvertes" => "RuvERt",
"rouverts" => "RuvER",
"rouvraient" => "RuvRE",
"rouvrais" => "RuvRE",
"rouvrait" => "RuvRE",
"rouvrant" => "RuvR@",
"rouvre" => "RuvR",
"rouvrent" => "RuvR",
"rouvres" => "RuvR",
"rouvrez" => "RuvRe",
"rouvriez" => "RuvRie",
"rouvrir" => "RuvRiR",
"rouvrira" => "RuvRiRa",
"rouvrirai" => "RuvRiRE",
"rouvriraient" => "RuvRiRE",
"rouvrirais" => "RuvRiRE",
"rouvrirait" => "RuvRiRE",
"rouvrirent" => "RuvRiR",
"rouvrirez" => "RuvRiRe",
"rouvriront" => "RuvRiR§",
"rouvris" => "RuvRi",
"rouvrit" => "RuvRi",
"rouvrît" => "RuvRi",
"rouvrons" => "RuvR§",
"roux" => "Ru",
"roy" => "Rwa",
"royal" => "Rwajal",
"royale" => "Rwajal",
"royalement" => "Rwajal°m@",
"royales" => "Rwajal",
"royaliste" => "Rwajalist",
"royalistes" => "Rwajalist",
"royalties" => "Rwajalti",
"royalty" => "Rwajalti",
"royaume" => "Rwajom",
"royaumes" => "Rwajom",
"royauté" => "Rwajote",
"royautés" => "Rwajote",
"royaux" => "Rwajo",
"ru" => "Ry",
"rua" => "R8a",
"ruade" => "Ryad",
"ruades" => "Ryad",
"ruai" => "R8E",
"ruaient" => "R8E",
"ruais" => "R8E",
"ruait" => "R8E",
"ruâmes" => "R8am",
"ruant" => "R8@",
"ruât" => "R8a",
"ruban" => "Ryb@",
"rubans" => "Ryb@",
"rubato" => "Rybato",
"rubénienne" => "RybenjEn",
"rubéole" => "RybeOl",
"rubia" => "Rybja",
"rubican" => "Rybik@",
"rubicond" => "Rybik§",
"rubiconde" => "Rybik§d",
"rubicondes" => "Rybik§d",
"rubiconds" => "Rybik§",
"rubis" => "Rybi",
"rubricard" => "RybRikaR",
"rubrique" => "RybRik",
"rubriques" => "RybRik",
"ruche" => "RyS",
"ruché" => "RySe",
"ruchée" => "RySe",
"rucher" => "RySe",
"ruchers" => "RySe",
"ruches" => "RyS",
"rucksack" => "Ryksak",
"rude" => "Ryd",
"rudement" => "Ryd°m@",
"rudes" => "Ryd",
"rudesse" => "RydEs",
"rudesses" => "RydEs",
"rudiment" => "Rydim@",
"rudimentaire" => "Rydim@tER",
"rudimentaires" => "Rydim@tER",
"rudiments" => "Rydim@",
"rudoie" => "Rydwa",
"rudoiement" => "Rydwam@",
"rudoiements" => "Rydwam@",
"rudoient" => "Rydwa",
"rudoies" => "Rydwa",
"rudoya" => "Rydwaja",
"rudoyais" => "RydwajE",
"rudoyait" => "RydwajE",
"rudoyant" => "Rydwaj@",
"rudoyé" => "Rydwaje",
"rudoyer" => "Rydwaje",
"rudoyèrent" => "RydwajER",
"rudoyés" => "Rydwaje",
"rue" => "Ry",
"rué" => "R8e",
"ruée" => "R8e",
"ruées" => "R8e",
"ruelle" => "R8El",
"ruelles" => "R8El",
"ruent" => "Ry",
"ruer" => "R8e",
"ruèrent" => "R8ER",
"rueront" => "RyR§",
"rues" => "Ry",
"rués" => "R8e",
"ruffian" => "Ryfj@",
"ruffians" => "Ryfj@",
"rufian" => "Ryfj@",
"rugby" => "Rygbi",
"rugbyman" => "Rygbiman",
"rugbymen" => "RygbimEn",
"rugi" => "RyZi",
"rugir" => "RyZiR",
"rugiraient" => "RyZiRE",
"rugirent" => "RyZiR",
"rugiront" => "RyZiR§",
"rugis" => "RyZi",
"rugissaient" => "RyZisE",
"rugissait" => "RyZisE",
"rugissant" => "RyZis@",
"rugissante" => "RyZis@t",
"rugissantes" => "RyZis@t",
"rugissants" => "RyZis@",
"rugisse" => "RyZis",
"rugissement" => "RyZis°m@",
"rugissements" => "RyZis°m@",
"rugissent" => "RyZis",
"rugissez" => "RyZise",
"rugit" => "RyZi",
"rugosité" => "Rygozite",
"rugosités" => "Rygozite",
"rugueuse" => "Ryg2z",
"rugueuses" => "Ryg2z",
"rugueux" => "Ryg2",
"ruina" => "R8ina",
"ruinaient" => "R8inE",
"ruinais" => "R8inE",
"ruinait" => "R8inE",
"ruinant" => "R8in@",
"ruinât" => "R8ina",
"ruine" => "R8in",
"ruiné" => "R8ine",
"ruinée" => "R8ine",
"ruinées" => "R8ine",
"ruinent" => "R8in",
"ruiner" => "R8ine",
"ruinera" => "R8in°Ra",
"ruinerai" => "R8in°RE",
"ruinerais" => "R8in°RE",
"ruinerait" => "R8in°RE",
"ruineras" => "R8in°Ra",
"ruinerez" => "R8in°Re",
"ruinerons" => "R8in°R§",
"ruineront" => "R8in°R§",
"ruines" => "R8in",
"ruinés" => "R8ine",
"ruineuse" => "R8in2z",
"ruineuses" => "R8in2z",
"ruineux" => "R8in2",
"ruinez" => "R8ine",
"ruiniez" => "R8inje",
"ruisseau" => "R8iso",
"ruisseaux" => "R8iso",
"ruissela" => "R8is°la",
"ruisselaient" => "R8is°lE",
"ruisselait" => "R8is°lE",
"ruisselant" => "R8is°l@",
"ruisselante" => "R8is°l@t",
"ruisselantes" => "R8is°l@t",
"ruisselants" => "R8is°l@",
"ruisselât" => "R8is°la",
"ruisselé" => "R8is°le",
"ruisseler" => "R8is°le",
"ruisselèrent" => "R8is°lER",
"ruisselet" => "R8is°lE",
"ruisselets" => "R8is°lE",
"ruisselle" => "R8isEl",
"ruissellement" => "R8isEl°m@",
"ruissellements" => "R8isEl°m@",
"ruissellent" => "R8isEl",
"ruissellerait" => "R8isEl°RE",
"ruisson" => "R8is§",
"rumba" => "Rumba",
"rumbas" => "Rumba",
"rumeur" => "Rym9R",
"rumeurs" => "Rym9R",
"rumina" => "Rymina",
"ruminaient" => "RyminE",
"ruminais" => "RyminE",
"ruminait" => "RyminE",
"ruminant" => "Rymin@",
"ruminante" => "Rymin@t",
"ruminants" => "Rymin@",
"rumination" => "Ryminasj§",
"ruminations" => "Ryminasj§",
"rumine" => "Rymin",
"ruminé" => "Rymine",
"ruminée" => "Rymine",
"ruminées" => "Rymine",
"ruminement" => "Rymin°m@",
"ruminements" => "Rymin°m@",
"ruminent" => "Rymin",
"ruminer" => "Rymine",
"ruminerez" => "Rymin°Re",
"rumineront" => "Rymin°R§",
"ruminés" => "Rymine",
"rumsteck" => "ROmstEk",
"rune" => "Ryn",
"runes" => "Ryn",
"runique" => "Rynik",
"runiques" => "Rynik",
"running" => "RyniG",
"ruons" => "R8§",
"rupestre" => "RypEstR",
"rupestres" => "RypEstR",
"rupin" => "Ryp5",
"rupinasse" => "Rypinas",
"rupine" => "Rypin",
"rupines" => "Rypin",
"rupiniez" => "Rypinje",
"rupins" => "Ryp5",
"rupteur" => "Rypt9R",
"rupture" => "RyptyR",
"ruptures" => "RyptyR",
"rural" => "RyRal",
"rurale" => "RyRal",
"rurales" => "RyRal",
"ruraux" => "RyRo",
"rus" => "Ry",
"rusa" => "Ryza",
"rusais" => "RyzE",
"rusait" => "RyzE",
"rusâmes" => "Ryzam",
"rusant" => "Ryz@",
"ruse" => "Ryz",
"rusé" => "Ryze",
"rusée" => "Ryze",
"rusées" => "Ryze",
"rusent" => "Ryz",
"ruser" => "Ryze",
"rusera" => "Ryz°Ra",
"ruserai" => "Ryz°RE",
"ruserais" => "Ryz°RE",
"ruses" => "Ryz",
"rusés" => "Ryze",
"rush" => "R9S",
"rushes" => "R9S",
"russe" => "Rys",
"russes" => "Rys",
"russifiant" => "Rysifj@",
"russification" => "Rysifikasj§",
"russifié" => "Rysifje",
"russifiée" => "Rysifje",
"russo-allemand" => "Rysoal°m@",
"russo-allemande" => "Rysoal°m@d",
"russo-américain" => "RysoameRik5",
"russo-japonaise" => "RysoZaponEz",
"russo-polonais" => "RysopolonE",
"russo-polonaise" => "RysopolonEz",
"russo-turque" => "RysotyRk",
"russophone" => "RysofOn",
"russules" => "Rysyl",
"rustaud" => "Rysto",
"rustaude" => "Rystod",
"rustaudes" => "Rystod",
"rustauds" => "Rysto",
"rusticité" => "Rystisite",
"rustine" => "Rystin",
"rustines" => "Rystin",
"rustique" => "Rystik",
"rustiques" => "Rystik",
"rustre" => "RystR",
"rustres" => "RystR",
"rut" => "Ryt",
"rutabaga" => "Rytabaga",
"rutabagas" => "Rytabaga",
"rutherford" => "Ryt9RfORd",
"rutilaient" => "RytilE",
"rutilait" => "RytilE",
"rutilances" => "Rytil@s",
"rutilant" => "Rytil@",
"rutilante" => "Rytil@t",
"rutilantes" => "Rytil@t",
"rutilants" => "Rytil@",
"rutile" => "Rytil",
"rutilent" => "Rytil",
"rutiler" => "Rytile",
"rythmaient" => "RitmE",
"rythmait" => "RitmE",
"rythmant" => "Ritm@",
"rythme" => "Ritm",
"rythmé" => "Ritme",
"rythmée" => "Ritme",
"rythmées" => "Ritme",
"rythment" => "Ritm",
"rythmer" => "Ritme",
"rythmera" => "Ritm°Ra",
"rythmes" => "Ritm",
"rythmés" => "Ritme",
"rythmique" => "Ritmik",
"rythmiquement" => "Ritmik°m@",
"rythmiques" => "Ritmik",
"s" => "Es",
"s'" => "s",
"sa" => "sa",
"sabayon" => "sabaj§",
"sabayons" => "sabaj§",
"sabbat" => "saba",
"sabbatique" => "sabatik",
"sabbatiques" => "sabatik",
"sabbats" => "saba",
"sabéen" => "sabe5",
"sabéenne" => "sabeEn",
"sabelles" => "sabEl",
"sabin" => "sab5",
"sabines" => "sabin",
"sabins" => "sab5",
"sabir" => "sabiR",
"sabla" => "sabla",
"sablaient" => "sablE",
"sablait" => "sablE",
"sablant" => "sabl@",
"sable" => "sabl",
"sablé" => "sable",
"sablée" => "sable",
"sablées" => "sable",
"sabler" => "sable",
"sablera" => "sabl°Ra",
"sablerais" => "sabl°RE",
"sables" => "sabl",
"sablés" => "sable",
"sableuse" => "sabl2z",
"sableuses" => "sabl2z",
"sableux" => "sabl2",
"sablez" => "sable",
"sablier" => "sablije",
"sablière" => "sablijER",
"sablières" => "sablijER",
"sabliers" => "sablije",
"sablonneuse" => "sablon2z",
"sablonneuses" => "sablon2z",
"sablonneux" => "sablon2",
"sablons" => "sabl§",
"sabord" => "sabOR",
"sabordage" => "sabORdaZ",
"sabordait" => "sabORdE",
"saborde" => "sabORd",
"sabordé" => "sabORde",
"sabordée" => "sabORde",
"sabordent" => "sabORd",
"saborder" => "sabORde",
"sabordés" => "sabORde",
"sabordez" => "sabORde",
"sabords" => "sabOR",
"sabot" => "sabo",
"sabotage" => "sabotaZ",
"sabotages" => "sabotaZ",
"sabotais" => "sabotE",
"sabotait" => "sabotE",
"sabotant" => "sabOt@",
"sabote" => "sabOt",
"saboté" => "sabote",
"sabotée" => "sabote",
"sabotées" => "sabote",
"sabotent" => "sabOt",
"saboter" => "sabote",
"saboterai" => "sabOt°RE",
"saboterait" => "sabOt°RE",
"saboterie" => "sabOt°Ri",
"saboteront" => "sabOt°R§",
"sabotés" => "sabote",
"saboteur" => "sabot9R",
"saboteurs" => "sabot9R",
"saboteuse" => "sabOt2z",
"sabotez" => "sabote",
"sabotier" => "sabotje",
"sabotiers" => "sabotje",
"sabotons" => "sabot§",
"sabots" => "sabo",
"saboule" => "sabul",
"saboulé" => "sabule",
"saboulent" => "sabul",
"sabouler" => "sabule",
"saboulés" => "sabule",
"sabra" => "sabRa",
"sabrait" => "sabRE",
"sabrant" => "sabR@",
"sabre" => "sabR",
"sabré" => "sabRe",
"sabrée" => "sabRe",
"sabrées" => "sabRe",
"sabrent" => "sabR",
"sabrer" => "sabRe",
"sabrerai" => "sabR°RE",
"sabreraient" => "sabR°RE",
"sabrerais" => "sabR°RE",
"sabreras" => "sabR°Ra",
"sabrerons" => "sabR°R§",
"sabres" => "sabR",
"sabrés" => "sabRe",
"sabretache" => "sabR°taS",
"sabretaches" => "sabR°taS",
"sabreur" => "sabR9R",
"sabreurs" => "sabR9R",
"sabrez" => "sabRe",
"sac" => "sak",
"sac-poubelle" => "sakpubEl",
"saccade" => "sakad",
"saccadé" => "sakade",
"saccadée" => "sakade",
"saccadées" => "sakade",
"saccader" => "sakade",
"saccades" => "sakad",
"saccadés" => "sakade",
"saccage" => "sakaZ",
"saccagé" => "sakaZe",
"saccagea" => "sakaZa",
"saccageaient" => "sakaZE",
"saccageais" => "sakaZE",
"saccageait" => "sakaZE",
"saccageant" => "sakaZ@",
"saccagée" => "sakaZe",
"saccagées" => "sakaZe",
"saccagent" => "sakaZ",
"saccageons" => "sakaZ§",
"saccager" => "sakaZe",
"saccageraient" => "sakaZ°RE",
"saccagèrent" => "sakaZER",
"saccages" => "sakaZ",
"saccagés" => "sakaZe",
"saccageurs" => "sakaZ9R",
"saccagez" => "sakaZe",
"saccagiez" => "sakaZje",
"saccagne" => "sakaN",
"saccharine" => "sakaRin",
"saccharomyces" => "sakaRomisEs",
"saccharose" => "sakaRoz",
"sacculine" => "sakylin",
"sacculines" => "sakylin",
"sacerdoce" => "sasERdOs",
"sacerdoces" => "sasERdOs",
"sacerdotal" => "sasERdotal",
"sacerdotale" => "sasERdotal",
"sacerdotales" => "sasERdotal",
"sacerdotaux" => "sasERdoto",
"sachant" => "saS@",
"sache" => "saS",
"sachem" => "saSEm",
"sachent" => "saS",
"saches" => "saS",
"sachet" => "saSE",
"sachets" => "saSE",
"sachez" => "saSe",
"sachiez" => "saSje",
"sachions" => "saSj§",
"sachons" => "saS§",
"sacoche" => "sakOS",
"sacoches" => "sakOS",
"sacqua" => "saka",
"sacquais" => "sakE",
"sacquant" => "sak@",
"sacque" => "sak",
"sacqué" => "sake",
"sacquer" => "sake",
"sacra" => "sakRa",
"sacrait" => "sakRE",
"sacralisation" => "sakRalizasj§",
"sacralisés" => "sakRalize",
"sacramentel" => "sakRam@tEl",
"sacramentelle" => "sakRam@tEl",
"sacramentelles" => "sakRam@tEl",
"sacrant" => "sakR@",
"sacre" => "sakR",
"sacré" => "sakRe",
"sacré-coeur" => "sakRek9R",
"sacrebleu" => "sakR°bl2",
"sacrédié" => "sakRedje",
"sacredieu" => "sakR°dj2",
"sacrée" => "sakRe",
"sacrées" => "sakRe",
"sacrement" => "sakR°m@",
"sacrément" => "sakRem@",
"sacrements" => "sakR°m@",
"sacrer" => "sakRe",
"sacrera" => "sakR°Ra",
"sacrerai" => "sakR°RE",
"sacres" => "sakR",
"sacrés" => "sakRe",
"sacret" => "sakRE",
"sacrifia" => "sakRifja",
"sacrifiaient" => "sakRifjE",
"sacrifiais" => "sakRifjE",
"sacrifiait" => "sakRifjE",
"sacrifiant" => "sakRifj@",
"sacrifiât" => "sakRifja",
"sacrificateur" => "sakRifikat9R",
"sacrificateurs" => "sakRifikat9R",
"sacrifice" => "sakRifis",
"sacrifices" => "sakRifis",
"sacrificiel" => "sakRifisjEl",
"sacrificielle" => "sakRifisjEl",
"sacrificiels" => "sakRifisjEl",
"sacrifie" => "sakRifi",
"sacrifié" => "sakRifje",
"sacrifiée" => "sakRifje",
"sacrifiées" => "sakRifje",
"sacrifient" => "sakRifi",
"sacrifier" => "sakRifje",
"sacrifiera" => "sakRifiRa",
"sacrifierai" => "sakRifiRE",
"sacrifieraient" => "sakRifiRE",
"sacrifierais" => "sakRifiRE",
"sacrifierait" => "sakRifiRE",
"sacrifieras" => "sakRifiRa",
"sacrifièrent" => "sakRifjER",
"sacrifierez" => "sakRifiRe",
"sacrifieriez" => "sakRifiRje",
"sacrifierions" => "sakRifiRj§",
"sacrifierons" => "sakRifiR§",
"sacrifies" => "sakRifi",
"sacrifiés" => "sakRifje",
"sacrifiez" => "sakRifje",
"sacrifiiez" => "sakRifije",
"sacrifions" => "sakRifj§",
"sacrilège" => "sakRilEZ",
"sacrilèges" => "sakRilEZ",
"sacripant" => "sakRip@",
"sacripants" => "sakRip@",
"sacristain" => "sakRist5",
"sacristaine" => "sakRistEn",
"sacristaines" => "sakRistEn",
"sacristains" => "sakRist5",
"sacristie" => "sakRisti",
"sacristies" => "sakRisti",
"sacristine" => "sakRistin",
"sacro" => "sakRo",
"sacro-iliaque" => "sakRoiljak",
"sacro-iliaques" => "sakRoiljak",
"sacro-saint" => "sakRos5",
"sacro-sainte" => "sakRos5t",
"sacro-saintes" => "sakRos5t",
"sacro-saints" => "sakRos5",
"sacrum" => "sakROm",
"sacs" => "sak",
"sacs-poubelles" => "sakpubEl",
"sadducéen" => "sadyse5",
"sadienne" => "sadjEn",
"sadique" => "sadik",
"sadiquement" => "sadik°m@",
"sadiques" => "sadik",
"sadisme" => "sadizm",
"sadismes" => "sadizm",
"sado" => "sado",
"sadomasochisme" => "sadomazoSizm",
"sadomasochiste" => "sadomazoSist",
"sados" => "sado",
"saducéen" => "sadyse5",
"safari" => "safaRi",
"safari-photo" => "safaRifoto",
"safaris" => "safaRi",
"safran" => "safR@",
"safrane" => "safRan",
"safrané" => "safRane",
"saga" => "saga",
"sagace" => "sagas",
"sagaces" => "sagas",
"sagacité" => "sagasite",
"sagaie" => "sagE",
"sagaies" => "sagE",
"sagard" => "sagaR",
"sagas" => "saga",
"sage" => "saZ",
"sage-femme" => "saZfam",
"sagement" => "saZ°m@",
"sages" => "saZ",
"sages-femmes" => "saZfam",
"sagesse" => "saZEs",
"sagesses" => "saZEs",
"sagettes" => "saZEt",
"sagittaire" => "saZitER",
"sagittaires" => "saZitER",
"sagittal" => "saZital",
"sagittale" => "saZital",
"sagouin" => "sagw5",
"sagouins" => "sagw5",
"sagoutier" => "sagutje",
"sagum" => "sagOm",
"saharien" => "saaRj5",
"saharienne" => "saaRjEn",
"sahariennes" => "saaRjEn",
"sahariens" => "saaRj5",
"sahib" => "saib",
"sahibs" => "saib",
"saï" => "sai",
"saie" => "sE",
"saigna" => "sENa",
"saignaient" => "sENE",
"saignais" => "sENE",
"saignait" => "sENE",
"saignant" => "sEN@",
"saignante" => "sEN@t",
"saignantes" => "sEN@t",
"saignants" => "sEN@",
"saignasse" => "sENas",
"saigne" => "sEN",
"saigné" => "seNe",
"saignée" => "seNe",
"saignées" => "seNe",
"saignement" => "sEN°m@",
"saignements" => "sEN°m@",
"saignent" => "sEN",
"saigner" => "seNe",
"saignera" => "sEN°Ra",
"saignerai" => "sEN°RE",
"saignerais" => "sEN°RE",
"saignerait" => "sEN°RE",
"saigneras" => "sEN°Ra",
"saignerez" => "sEN°Re",
"saigneront" => "sEN°R§",
"saignes" => "sEN",
"saignés" => "seNe",
"saigneur" => "sEN9R",
"saignez" => "sENe",
"saigniez" => "sENe",
"saignons" => "sEN§",
"saillaient" => "sajE",
"saillait" => "sajE",
"saillant" => "saj@",
"saillante" => "saj@t",
"saillantes" => "saj@t",
"saillants" => "saj@",
"saille" => "saj",
"saillent" => "saj",
"sailli" => "saji",
"saillie" => "saji",
"saillies" => "saji",
"saillir" => "sajiR",
"saillissent" => "sajis",
"saillit" => "saji",
"sain" => "s5",
"saindoux" => "s5du",
"saine" => "sEn",
"sainement" => "sEn°m@",
"saines" => "sEn",
"sainfoin" => "s5fw5",
"sainfoins" => "s5fw5",
"sains" => "s5",
"saint" => "s5",
"saint-bernard" => "s5bERnaR",
"saint-crépin" => "s5kRep5",
"saint-cyrien" => "s5siRj5",
"saint-cyriens" => "s5siRj5",
"saint-émilion" => "s5temilj§",
"saint-esprit" => "s5tEspRi",
"saint-frusquin" => "s5fRysk5",
"saint-germain" => "s5ZERm5",
"saint-glinglin" => "s5gl5gl5",
"saint-guy" => "s5gi",
"saint-honoré" => "s5tonoRe",
"saint-hubert" => "s5tybER",
"saint-michel" => "s5miSEl",
"saint-nectaire" => "s5nEktER",
"saint-paulin" => "s5pol5",
"saint-père" => "s5pER",
"saint-pierre" => "s5pjER",
"saint-siège" => "s5sjEZ",
"saint-synode" => "s5sinOd",
"sainte" => "s5t",
"sainte nitouche" => "s5tnituS",
"sainte-nitouche" => "s5tnituS",
"saintement" => "s5t°m@",
"saintes" => "s5t",
"saintes-nitouches" => "s5tnituS",
"sainteté" => "s5tte",
"saintetés" => "s5tte",
"saints" => "s5",
"saints-pères" => "s5pER",
"sais" => "sE",
"saisi" => "sezi",
"saisie" => "sezi",
"saisie-arrêt" => "seziaRE",
"saisies" => "sezi",
"saisir" => "seziR",
"saisira" => "seziRa",
"saisirai" => "seziRE",
"saisirais" => "seziRE",
"saisirait" => "seziRE",
"saisiras" => "seziRa",
"saisirent" => "seziR",
"saisirez" => "seziRe",
"saisirions" => "seziRj§",
"saisirons" => "seziR§",
"saisiront" => "seziR§",
"saisis" => "sezi",
"saisissable" => "sezisabl",
"saisissables" => "sezisabl",
"saisissaient" => "sezisE",
"saisissais" => "sezisE",
"saisissait" => "sezisE",
"saisissant" => "sezis@",
"saisissante" => "sezis@t",
"saisissantes" => "sezis@t",
"saisissants" => "sezis@",
"saisisse" => "sezis",
"saisissement" => "sezis°m@",
"saisissements" => "sezis°m@",
"saisissent" => "sezis",
"saisisses" => "sezis",
"saisissez" => "sezise",
"saisissiez" => "sezisje",
"saisissions" => "sezisj§",
"saisissons" => "sezis§",
"saisit" => "sezi",
"saisît" => "sezi",
"saison" => "sEz§",
"saisonnier" => "sEzonje",
"saisonnière" => "sEzonjER",
"saisonnières" => "sEzonjER",
"saisonniers" => "sEzonje",
"saisons" => "sEz§",
"sait" => "sE",
"saké" => "sake",
"sakés" => "sake",
"saki" => "saki",
"sala" => "sala",
"salace" => "salas",
"salaces" => "salas",
"salacité" => "salasite",
"salacités" => "salasite",
"salade" => "salad",
"salader" => "salade",
"salades" => "salad",
"saladier" => "saladje",
"saladiers" => "saladje",
"salaient" => "salE",
"salaire" => "salER",
"salaires" => "salER",
"salaison" => "salEz§",
"salaisons" => "salEz§",
"salait" => "salE",
"salam" => "salam",
"salamalec" => "salamalEk",
"salamalecs" => "salamalEk",
"salamandre" => "salam@dR",
"salamandres" => "salam@dR",
"salami" => "salami",
"salamis" => "salami",
"salanque" => "sal@k",
"salant" => "sal@",
"salants" => "sal@",
"salariait" => "salaRjE",
"salariale" => "salaRjal",
"salariat" => "salaRja",
"salariaux" => "salaRjo",
"salarié" => "salaRje",
"salariée" => "salaRje",
"salarier" => "salaRje",
"salariés" => "salaRje",
"salas" => "sala",
"salat" => "sala",
"salaud" => "salo",
"salauds" => "salo",
"salazariste" => "salazaRist",
"sale" => "sal",
"salé" => "sale",
"salée" => "sale",
"salées" => "sale",
"salement" => "sal°m@",
"saler" => "sale",
"salera" => "sal°Ra",
"sales" => "sal",
"salés" => "sale",
"salésienne" => "salezjEn",
"saleté" => "sal°te",
"saletés" => "sal°te",
"saleur" => "sal9R",
"salez" => "sale",
"sali" => "sali",
"salicaires" => "salikER",
"salicine" => "salisin",
"salicole" => "salikOl",
"salicorne" => "salikORn",
"salie" => "sali",
"salière" => "saljER",
"salières" => "saljER",
"salies" => "sali",
"saligaud" => "saligo",
"saligauds" => "saligo",
"salin" => "sal5",
"saline" => "salin",
"salines" => "salin",
"salingue" => "sal5g",
"salingues" => "sal5g",
"salinité" => "salinite",
"salins" => "sal5",
"salique" => "salik",
"salir" => "saliR",
"salira" => "saliRa",
"salirai" => "saliRE",
"saliraient" => "saliRE",
"salirais" => "saliRE",
"salirait" => "saliRE",
"salirez" => "saliRe",
"salis" => "sali",
"salissaient" => "salisE",
"salissait" => "salisE",
"salissant" => "salis@",
"salissante" => "salis@t",
"salissantes" => "salis@t",
"salissants" => "salis@",
"salisse" => "salis",
"salissent" => "salis",
"salisses" => "salis",
"salisseur" => "salis9R",
"salissez" => "salise",
"salissiez" => "salisje",
"salissure" => "salisyR",
"salissures" => "salisyR",
"salit" => "sali",
"saliva" => "saliva",
"salivaient" => "salivE",
"salivaire" => "salivER",
"salivaires" => "salivER",
"salivais" => "salivE",
"salivait" => "salivE",
"salivant" => "saliv@",
"salivation" => "salivasj§",
"salive" => "saliv",
"salivé" => "salive",
"salivent" => "saliv",
"saliver" => "salive",
"salives" => "saliv",
"saliveur" => "saliv9R",
"saliveuse" => "saliv2z",
"saliveuses" => "saliv2z",
"salivez" => "salive",
"salle" => "sal",
"salles" => "sal",
"salmigondis" => "salmig§di",
"salmis" => "salmi",
"salmonelle" => "salmonEl",
"salmonellose" => "salmonEloz",
"salmonidé" => "salmOnide",
"saloir" => "salwaR",
"saloirs" => "salwaR",
"salon" => "sal§",
"salonnard" => "salonaR",
"salonnières" => "salonjER",
"salonniers" => "salonje",
"salons" => "sal§",
"saloon" => "salun",
"saloons" => "salun",
"salop" => "salo",
"salopard" => "salopaR",
"salopards" => "salopaR",
"salope" => "salOp",
"salopé" => "salope",
"salopée" => "salope",
"salopées" => "salope",
"salopent" => "salOp",
"saloper" => "salope",
"saloperie" => "salOp°Ri",
"saloperies" => "salOp°Ri",
"salopes" => "salOp",
"salopés" => "salope",
"salopette" => "salopEt",
"salopettes" => "salopEt",
"salopez" => "salope",
"salopiaud" => "salopjo",
"salopiauds" => "salopjo",
"salopiaux" => "salopjo",
"salopiot" => "salopjo",
"salopiots" => "salopjo",
"salops" => "salo",
"salpêtre" => "salpEtR",
"salpêtrées" => "salpEtRe",
"salpêtrés" => "salpEtRe",
"salpêtreux" => "salpEtR2",
"salpêtrière" => "salpEtRijER",
"salpicon" => "salpik§",
"salpingite" => "salp5Zit",
"sals" => "sal",
"salsa" => "salsa",
"salsepareille" => "sals°paREj",
"salsifis" => "salsifi",
"saltimbanque" => "salt5b@k",
"saltimbanques" => "salt5b@k",
"salto" => "salto",
"salua" => "sal8a",
"saluai" => "sal8E",
"saluaient" => "sal8E",
"saluais" => "sal8E",
"saluait" => "sal8E",
"saluâmes" => "sal8am",
"saluant" => "sal8@",
"saluât" => "sal8a",
"salubre" => "salybR",
"salubres" => "salybR",
"salubrité" => "salybRite",
"salue" => "saly",
"salué" => "sal8e",
"saluée" => "sal8e",
"saluées" => "sal8e",
"saluent" => "saly",
"saluer" => "sal8e",
"saluera" => "salyRa",
"saluerai" => "salyRE",
"salueraient" => "salyRE",
"saluerais" => "salyRE",
"saluerait" => "salyRE",
"salueras" => "salyRa",
"saluèrent" => "sal8ER",
"saluerons" => "salyR§",
"salueront" => "salyR§",
"salues" => "saly",
"salués" => "sal8e",
"salueur" => "sal89R",
"saluez" => "salye",
"saluiez" => "salyje",
"saluions" => "salyj§",
"saluons" => "sal8§",
"salut" => "saly",
"salutaire" => "salytER",
"salutairement" => "salytER°m@",
"salutaires" => "salytER",
"salutation" => "salytasj§",
"salutations" => "salytasj§",
"salutiste" => "salytist",
"salutistes" => "salytist",
"saluts" => "saly",
"salvadorien" => "salvadoRj5",
"salvadorienne" => "salvadoRjEn",
"salvadoriens" => "salvadoRj5",
"salvateur" => "salvat9R",
"salvateurs" => "salvat9R",
"salvation" => "salvasj§",
"salvatrice" => "salvatRis",
"salve" => "salv",
"salves" => "salv",
"salvifique" => "salvifik",
"salzbourgeoises" => "salzbuRZwaz",
"samaras" => "samaRa",
"samaritain" => "samaRit5",
"samaritaine" => "samaRitEn",
"samaritains" => "samaRit5",
"samba" => "s@ba",
"sambenito" => "s@benito",
"sambo" => "sambo",
"samedi" => "sam°di",
"samedis" => "sam°di",
"samizdats" => "samizda",
"sammy" => "sami",
"samoan" => "samo@",
"samoans" => "samo@",
"samouraï" => "samuRaj",
"samouraïs" => "samuRai",
"samovar" => "samovaR",
"samovars" => "samovaR",
"samoyède" => "samojEd",
"sampan" => "s@p@",
"sampang" => "s@p@G",
"sampangs" => "s@p@G",
"sample" => "s@pl",
"sampler" => "s@ple",
"samurai" => "samuRaj",
"san francisco" => "s@fR@sisko",
"sana" => "sana",
"sanas" => "sana",
"sanatorium" => "sanatoRjOm",
"sanatoriums" => "sanatoRjOm",
"sancerre" => "s@sER",
"sanctifiai" => "s@ktifjE",
"sanctifiait" => "s@ktifjE",
"sanctifiante" => "s@ktifj@t",
"sanctification" => "s@ktifikasj§",
"sanctificatrice" => "s@ktifikatRis",
"sanctifie" => "s@ktifi",
"sanctifié" => "s@ktifje",
"sanctifiée" => "s@ktifje",
"sanctifiées" => "s@ktifje",
"sanctifier" => "s@ktifje",
"sanctifiés" => "s@ktifje",
"sanctifiez" => "s@ktifje",
"sanction" => "s@ksj§",
"sanctionnaient" => "s@ksjonE",
"sanctionnait" => "s@ksjonE",
"sanctionnant" => "s@ksjon@",
"sanctionne" => "s@ksjOn",
"sanctionné" => "s@ksjone",
"sanctionnée" => "s@ksjone",
"sanctionnées" => "s@ksjone",
"sanctionner" => "s@ksjone",
"sanctionnera" => "s@ksjOn°Ra",
"sanctionnerait" => "s@ksjOn°RE",
"sanctionnèrent" => "s@ksjonER",
"sanctionnés" => "s@ksjone",
"sanctionnez" => "s@ksjone",
"sanctionnions" => "s@ksjonj§",
"sanctions" => "s@ksj§",
"sanctuaire" => "s@kt8ER",
"sanctuaires" => "s@kt8ER",
"sanctus" => "s@ktys",
"sandale" => "s@dal",
"sandales" => "s@dal",
"sandalettes" => "s@dalEt",
"sandalier" => "s@dalje",
"sanderling" => "s@dERliG",
"sandiniste" => "s@dinist",
"sandinistes" => "s@dinist",
"sandjak" => "s@djak",
"sandow" => "s@do",
"sandows" => "s@do",
"sandre" => "s@dR",
"sandres" => "s@dR",
"sandwich" => "s@dwitS",
"sandwiches" => "s@dwitS",
"sandwichs" => "s@dwitS",
"sang" => "s@",
"sang-froid" => "s@fRwa",
"sangla" => "s@gla",
"sanglai" => "s@glE",
"sanglait" => "s@glE",
"sanglant" => "s@gl@",
"sanglante" => "s@gl@t",
"sanglantes" => "s@gl@t",
"sanglants" => "s@gl@",
"sangle" => "s@gl",
"sanglé" => "s@gle",
"sanglée" => "s@gle",
"sanglées" => "s@gle",
"sanglent" => "s@gl",
"sangler" => "s@gle",
"sangles" => "s@gl",
"sanglés" => "s@gle",
"sanglez" => "s@gle",
"sanglier" => "s@glije",
"sangliers" => "s@glije",
"sanglot" => "s@glo",
"sanglota" => "s@glota",
"sanglotai" => "s@glotE",
"sanglotaient" => "s@glotE",
"sanglotais" => "s@glotE",
"sanglotait" => "s@glotE",
"sanglotâmes" => "s@glotam",
"sanglotant" => "s@glot@",
"sanglotante" => "s@glot@t",
"sanglotants" => "s@glot@",
"sanglote" => "s@glOt",
"sangloté" => "s@glote",
"sanglotent" => "s@glOt",
"sangloter" => "s@glote",
"sanglotés" => "s@glote",
"sanglotez" => "s@glote",
"sanglots" => "s@glo",
"sangria" => "s@gRija",
"sangs" => "s@",
"sangsue" => "s@sy",
"sangsues" => "s@sy",
"sanguin" => "s@g5",
"sanguinaire" => "s@ginER",
"sanguinaires" => "s@ginER",
"sanguine" => "s@gin",
"sanguines" => "s@gin",
"sanguinolent" => "s@ginol@",
"sanguinolente" => "s@ginol@t",
"sanguinolentes" => "s@ginol@t",
"sanguinolents" => "s@ginol@",
"sanguins" => "s@g5",
"sanhédrin" => "sanedR5",
"sanie" => "sani",
"sanies" => "sani",
"sanieuses" => "sanj2z",
"sanieux" => "sanj2",
"sanitaire" => "sanitER",
"sanitaires" => "sanitER",
"sans" => "s@",
"sans-coeur" => "s@k9R",
"sans-culotte" => "s@kylOt",
"sans-culottes" => "s@kylOt",
"sans-culottides" => "s@kylotid",
"sans-façon" => "s@fas§",
"sans-faute" => "s@fot",
"sans-fil" => "s@fil",
"sans-filiste" => "s@filist",
"sans-filistes" => "s@filist",
"sans-grade" => "s@gRad",
"sans-pareil" => "s@paREj",
"sanscrit" => "s@skRi",
"sanscrite" => "s@skRit",
"sanscrits" => "s@skRi",
"sanskrit" => "s@skRi",
"sansonnet" => "s@sonE",
"sansonnets" => "s@sonE",
"santal" => "s@tal",
"santals" => "s@tal",
"santé" => "s@te",
"santés" => "s@te",
"santiag" => "s@tjag",
"santiags" => "s@tjag",
"santoche" => "s@tOS",
"santon" => "s@t§",
"santons" => "s@t§",
"saoudien" => "saudj5",
"saoudienne" => "saudjEn",
"saoudiennes" => "saudjEn",
"saoudiens" => "saudj5",
"saoudite" => "saudit",
"saoul" => "su",
"saoula" => "sula",
"saoulaient" => "sulE",
"saoulais" => "sulE",
"saoulait" => "sulE",
"saoulant" => "sul@",
"saoulard" => "sulaR",
"saoule" => "sul",
"saoulé" => "sule",
"saoulée" => "sule",
"saoulées" => "sule",
"saoulent" => "sul",
"saouler" => "sule",
"saoulerait" => "sul°RE",
"saouleras" => "sul°Ra",
"saoulerez" => "sul°Re",
"saoulerie" => "sul°Ri",
"saouleries" => "sul°Ri",
"saoules" => "sul",
"saoulés" => "sule",
"saoulez" => "sule",
"saoulions" => "sulj§",
"saouls" => "su",
"sapaient" => "sapE",
"sapait" => "sapE",
"sapajou" => "sapaZu",
"sapajous" => "sapaZu",
"sape" => "sap",
"sapé" => "sape",
"sapée" => "sape",
"sapées" => "sape",
"sapement" => "sap°m@",
"sapements" => "sap°m@",
"sapent" => "sap",
"saper" => "sape",
"saperai" => "sap°RE",
"saperlipopette" => "sapERlipopEt",
"saperlotte" => "sapERlOt",
"sapes" => "sap",
"sapés" => "sape",
"sapeur" => "sap9R",
"sapeur-pompier" => "sap9Rp§pje",
"sapeurs" => "sap9R",
"sapeurs-pompiers" => "sap9Rp§pje",
"sapez" => "sape",
"saphène" => "safEn",
"saphir" => "safiR",
"saphirs" => "safiR",
"saphisme" => "safizm",
"sapide" => "sapid",
"sapides" => "sapid",
"sapidité" => "sapidite",
"sapien" => "sapj5",
"sapience" => "sapj@s",
"sapiens" => "sapj5",
"sapin" => "sap5",
"sapines" => "sapin",
"sapinette" => "sapinEt",
"sapinettes" => "sapinEt",
"sapinière" => "sapinjER",
"sapinières" => "sapinjER",
"sapins" => "sap5",
"saponaires" => "saponER",
"saponification" => "saponifikasj§",
"saponifiées" => "saponifje",
"saponite" => "saponit",
"sapotille" => "sapOtij",
"sapotillier" => "sapotije",
"sapristi" => "sapRisti",
"saque" => "sak",
"saqué" => "sake",
"saquée" => "sake",
"saquent" => "sak",
"saquer" => "sake",
"saqués" => "sake",
"sar" => "saR",
"sara" => "saRa",
"sarabande" => "saRab@d",
"sarabandes" => "saRab@d",
"sarbacane" => "saRbakan",
"sarbacanes" => "saRbakan",
"sarcasme" => "saRkasm",
"sarcasmes" => "saRkasm",
"sarcastique" => "saRkastik",
"sarcastiquement" => "saRkastik°m@",
"sarcastiques" => "saRkastik",
"sarcelle" => "saRsEl",
"sarcelles" => "saRsEl",
"sarcine" => "saRsin",
"sarclage" => "saRklaZ",
"sarclait" => "saRklE",
"sarclant" => "saRkl@",
"sarcle" => "saRkl",
"sarclées" => "saRkle",
"sarclent" => "saRkl",
"sarcler" => "saRkle",
"sarclette" => "saRklEt",
"sarcleuse" => "saRkl2z",
"sarcloir" => "saRklwaR",
"sarcoïdose" => "saRkOidoz",
"sarcome" => "saRkom",
"sarcophage" => "saRkofaZ",
"sarcophages" => "saRkofaZ",
"sardanapalesques" => "saRdanapalEsk",
"sardanes" => "saRdan",
"sarde" => "saRd",
"sardinaient" => "saRdinE",
"sardine" => "saRdin",
"sardines" => "saRdin",
"sardiniers" => "saRdinje",
"sardoine" => "saRdwan",
"sardonique" => "saRdonik",
"sardoniquement" => "saRdonik°m@",
"sardoniques" => "saRdonik",
"sargasse" => "saRgas",
"sargasses" => "saRgas",
"sari" => "saRi",
"sarigue" => "saRig",
"sarin" => "saR5",
"saris" => "saRi",
"sarment" => "saRm@",
"sarments" => "saRm@",
"sarong" => "saR§g",
"saroual" => "saRwal",
"sarouel" => "saRwEl",
"sarracénie" => "saRaseni",
"sarrasin" => "saRaz5",
"sarrasine" => "saRazin",
"sarrasines" => "saRazin",
"sarrasins" => "saRaz5",
"sarrau" => "saRo",
"sarraus" => "saRo",
"sarreau" => "saRo",
"sarriette" => "saRjEt",
"sarrois" => "saRwa",
"sarroise" => "saRwaz",
"sarrussophone" => "saRysofOn",
"sas" => "sa",
"sashimi" => "saSimi",
"sassafras" => "sasafRa",
"sassanide" => "sasanid",
"sassanides" => "sasanid",
"sasse" => "sas",
"sasseur" => "sas9R",
"satan" => "sat@",
"satana" => "satana",
"satanaient" => "satanE",
"satanas" => "satana",
"satané" => "satane",
"satanée" => "satane",
"satanées" => "satane",
"sataner" => "satane",
"satanés" => "satane",
"satanique" => "satanik",
"sataniques" => "satanik",
"sataniser" => "satanize",
"satanisme" => "satanizm",
"sataniste" => "satanist",
"satellisée" => "satElize",
"satelliser" => "satElize",
"satellitaire" => "satElitER",
"satellite" => "satelit",
"satellites" => "satelit",
"satellites-espions" => "satelitEspj§",
"sati" => "sati",
"satiation" => "sasjasj§",
"satiété" => "sasjete",
"satin" => "sat5",
"satinait" => "satinE",
"satine" => "satin",
"satiné" => "satine",
"satinée" => "satine",
"satinées" => "satine",
"satinés" => "satine",
"satinette" => "satinEt",
"satins" => "sat5",
"satire" => "satiR",
"satires" => "satiR",
"satirique" => "satiRik",
"satiriques" => "satiRik",
"satirisaient" => "satiRizE",
"satiriste" => "satiRist",
"satisfaction" => "satisfaksj§",
"satisfactions" => "satisfaksj§",
"satisfaire" => "satisfER",
"satisfais" => "satisfE",
"satisfaisaient" => "satisf°zE",
"satisfaisais" => "satisf°zE",
"satisfaisait" => "satisf°zE",
"satisfaisant" => "satisf°z@",
"satisfaisante" => "satisf°z@t",
"satisfaisantes" => "satisf°z@t",
"satisfaisants" => "satisf°z@",
"satisfait" => "satisfE",
"satisfaite" => "satisfEt",
"satisfaites" => "satisfEt",
"satisfaits" => "satisfE",
"satisfasse" => "satisfas",
"satisfassent" => "satisfas",
"satisfecit" => "satisfesit",
"satisfera" => "satisf°Ra",
"satisferai" => "satisf°RE",
"satisferaient" => "satisf°RE",
"satisferais" => "satisf°RE",
"satisferait" => "satisf°RE",
"satisferiez" => "satisf°Rje",
"satisferons" => "satisf°R§",
"satisferont" => "satisf°R§",
"satisfirent" => "satisfiR",
"satisfis" => "satisfi",
"satisfit" => "satisfi",
"satisfont" => "satisf§",
"satonne" => "satOn",
"satonné" => "satone",
"satonner" => "satone",
"satrape" => "satRap",
"satrapes" => "satRap",
"satrapie" => "satRapi",
"saturait" => "satyRE",
"saturant" => "satyR@",
"saturation" => "satyRasj§",
"sature" => "satyR",
"saturé" => "satyRe",
"saturée" => "satyRe",
"saturées" => "satyRe",
"saturent" => "satyR",
"saturer" => "satyRe",
"saturés" => "satyRe",
"saturnales" => "satyRnal",
"saturnien" => "satyRnj5",
"saturniennes" => "satyRnjEn",
"saturniens" => "satyRnj5",
"saturnisme" => "satyRnizm",
"saturons" => "satyR§",
"satyre" => "satiR",
"satyres" => "satiR",
"satyrique" => "satiRik",
"sauça" => "sosa",
"sauçant" => "sos@",
"sauce" => "sos",
"saucée" => "sose",
"saucent" => "sos",
"saucer" => "sose",
"sauces" => "sos",
"saucier" => "sosje",
"saucière" => "sosjER",
"saucières" => "sosjER",
"sauciflard" => "sosiflaR",
"saucisse" => "sosis",
"saucisses" => "sosis",
"saucisson" => "sosis§",
"saucissonnage" => "sosisonaZ",
"saucissonnages" => "sosisonaZ",
"saucissonnant" => "sosison@",
"saucissonne" => "sosisOn",
"saucissonné" => "sosisone",
"saucissonnée" => "sosisone",
"saucissonner" => "sosisone",
"saucissonnés" => "sosisone",
"saucissons" => "sosis§",
"sauçons" => "sos§",
"sauf" => "sof",
"sauf-conduit" => "sofk§d8i",
"sauf-conduits" => "sofk§d8i",
"saufs" => "sof",
"sauge" => "soZ",
"saugrenu" => "sogR°ny",
"saugrenue" => "sogR°ny",
"saugrenues" => "sogR°ny",
"saugrenus" => "sogR°ny",
"saulaie" => "solE",
"saulaies" => "solE",
"saule" => "sol",
"saules" => "sol",
"saulnier" => "sonje",
"saumâtre" => "somatR",
"saumâtres" => "somatR",
"saumon" => "som§",
"saumoné" => "somone",
"saumoneau" => "somono",
"saumonée" => "somone",
"saumonées" => "somone",
"saumonette" => "somonEt",
"saumons" => "som§",
"saumurage" => "somyRaZ",
"saumure" => "somyR",
"saumurées" => "somyRe",
"saumurer" => "somyRe",
"sauna" => "sona",
"saunas" => "sona",
"saunier" => "sonje",
"saunières" => "sonjER",
"sauniers" => "sonje",
"saupoudra" => "sopudRa",
"saupoudrage" => "sopudRaZ",
"saupoudrai" => "sopudRE",
"saupoudraient" => "sopudRE",
"saupoudrait" => "sopudRE",
"saupoudrant" => "sopudR@",
"saupoudre" => "sopudR",
"saupoudré" => "sopudRe",
"saupoudrée" => "sopudRe",
"saupoudrées" => "sopudRe",
"saupoudrer" => "sopudRe",
"saupoudrés" => "sopudRe",
"saupoudreur" => "sopudR9R",
"saupoudrez" => "sopudRe",
"saupoudriez" => "sopudRije",
"saupoudrons" => "sopudR§",
"saur" => "soR",
"saura" => "soRa",
"saurai" => "soRE",
"sauraient" => "soRE",
"saurais" => "soRE",
"saurait" => "soRE",
"sauras" => "soRa",
"saurer" => "soRe",
"sauret" => "soRE",
"saurets" => "soRE",
"saurez" => "soRe",
"sauri" => "sORi",
"saurien" => "soRj5",
"sauriens" => "soRj5",
"sauriez" => "soRje",
"saurin" => "soR5",
"saurions" => "soRj§",
"saurons" => "soR§",
"sauront" => "soR§",
"saurs" => "soR",
"saussaies" => "sosE",
"saut" => "so",
"saut-de-lit" => "sod°li",
"sauta" => "sota",
"sautai" => "sotE",
"sautaient" => "sotE",
"sautais" => "sotE",
"sautait" => "sotE",
"sautâmes" => "sotam",
"sautant" => "sot@",
"sautante" => "sot@t",
"sautât" => "sota",
"saute" => "sot",
"sauté" => "sote",
"saute-mouton" => "sotmut§",
"saute-ruisseau" => "sotR8iso",
"sautée" => "sote",
"sautées" => "sote",
"sautelant" => "sot°l@",
"sautelle" => "sotEl",
"sautent" => "sot",
"sauter" => "sote",
"sautera" => "sot°Ra",
"sauterai" => "sot°RE",
"sauteraient" => "sot°RE",
"sauterais" => "sot°RE",
"sauterait" => "sot°RE",
"sauteras" => "sot°Ra",
"sauterelle" => "sot°REl",
"sauterelles" => "sot°REl",
"sautèrent" => "sotER",
"sauterez" => "sot°Re",
"sauterie" => "sot°Ri",
"sauteries" => "sot°Ri",
"sauteriez" => "sot°Rje",
"sauternes" => "sotERn",
"sauterons" => "sot°R§",
"sauteront" => "sot°R§",
"sautes" => "sot",
"sautés" => "sote",
"sauteur" => "sot9R",
"sauteurs" => "sot9R",
"sauteuse" => "sot2z",
"sauteuses" => "sot2z",
"sautez" => "sote",
"sautiez" => "sotje",
"sautilla" => "sotija",
"sautillaient" => "sotijE",
"sautillais" => "sotijE",
"sautillait" => "sotijE",
"sautillant" => "sotij@",
"sautillante" => "sotij@t",
"sautillantes" => "sotij@t",
"sautillants" => "sotij@",
"sautille" => "sotij",
"sautillé" => "sotije",
"sautillement" => "sotij°m@",
"sautillements" => "sotij°m@",
"sautillent" => "sotij",
"sautiller" => "sotije",
"sautillèrent" => "sotijER",
"sautilles" => "sotij",
"sautillez" => "sotije",
"sautions" => "sotj§",
"sautoir" => "sotwaR",
"sautoirs" => "sotwaR",
"sauton" => "sot§",
"sautons" => "sot§",
"sauts" => "so",
"sauts-de-lit" => "sod°li",
"sauva" => "sova",
"sauvage" => "sovaZ",
"sauvagement" => "sovaZ°m@",
"sauvageon" => "sovaZ§",
"sauvageonne" => "sovaZOn",
"sauvageonnes" => "sovaZOn",
"sauvageons" => "sovaZ§",
"sauvagerie" => "sovaZ°Ri",
"sauvageries" => "sovaZ°Ri",
"sauvages" => "sovaZ",
"sauvagesse" => "sovaZEs",
"sauvagesses" => "sovaZEs",
"sauvagin" => "sovaZ5",
"sauvagine" => "sovaZin",
"sauvagines" => "sovaZin",
"sauvai" => "sovE",
"sauvaient" => "sovE",
"sauvais" => "sovE",
"sauvait" => "sovE",
"sauvâmes" => "sovam",
"sauvant" => "sov@",
"sauvât" => "sova",
"sauve" => "sov",
"sauvé" => "sove",
"sauve-qui-peut" => "sovkip2",
"sauvée" => "sove",
"sauvées" => "sove",
"sauvegardaient" => "sov°gaRdE",
"sauvegardait" => "sov°gaRdE",
"sauvegardant" => "sov°gaRd@",
"sauvegardât" => "sov°gaRda",
"sauvegarde" => "sov°gaRd",
"sauvegardé" => "sov°gaRde",
"sauvegardée" => "sov°gaRde",
"sauvegardées" => "sov°gaRde",
"sauvegarder" => "sov°gaRde",
"sauvegarderaient" => "sov°gaRd°RE",
"sauvegarderait" => "sov°gaRd°RE",
"sauvegardes" => "sov°gaRd",
"sauvegardés" => "sov°gaRde",
"sauvent" => "sov",
"sauver" => "sove",
"sauvera" => "sov°Ra",
"sauverai" => "sov°RE",
"sauveraient" => "sov°RE",
"sauverais" => "sov°RE",
"sauverait" => "sov°RE",
"sauveras" => "sov°Ra",
"sauvèrent" => "sovER",
"sauverez" => "sov°Re",
"sauverons" => "sov°R§",
"sauveront" => "sov°R§",
"sauves" => "sov",
"sauvés" => "sove",
"sauvetage" => "sov°taZ",
"sauvetages" => "sov°taZ",
"sauveté" => "sov°te",
"sauveteur" => "sov°t9R",
"sauveteurs" => "sov°t9R",
"sauvette" => "sovEt",
"sauveur" => "sov9R",
"sauveurs" => "sov9R",
"sauveuse" => "sov2z",
"sauvez" => "sove",
"sauviez" => "sovje",
"sauvignon" => "soviN§",
"sauvions" => "sovj§",
"sauvons" => "sov§",
"savaient" => "savE",
"savais" => "savE",
"savait" => "savE",
"savamment" => "savam@",
"savane" => "savan",
"savanes" => "savan",
"savant" => "sav@",
"savantasses" => "sav@tas",
"savante" => "sav@t",
"savantes" => "sav@t",
"savantissimes" => "sav@tisim",
"savants" => "sav@",
"savarin" => "savaR5",
"savata" => "savata",
"savatait" => "savatE",
"savate" => "savat",
"savater" => "savate",
"savates" => "savat",
"savent" => "sav",
"savetier" => "sav°tje",
"savetiers" => "sav°tje",
"saveur" => "sav9R",
"saveurs" => "sav9R",
"savez" => "save",
"saviez" => "savje",
"savions" => "savj§",
"savoir" => "savwaR",
"savoir-faire" => "savwaRfER",
"savoir-vivre" => "savwaRvivR",
"savoirs" => "savwaR",
"savon" => "sav§",
"savonna" => "savona",
"savonnage" => "savonaZ",
"savonnages" => "savonaZ",
"savonnai" => "savonE",
"savonnaient" => "savonE",
"savonnais" => "savonE",
"savonnait" => "savonE",
"savonnant" => "savon@",
"savonne" => "savOn",
"savonné" => "savone",
"savonnée" => "savone",
"savonnées" => "savone",
"savonnent" => "savOn",
"savonner" => "savone",
"savonnera" => "savOn°Ra",
"savonneries" => "savOn°Ri",
"savonnette" => "savonEt",
"savonnettes" => "savonEt",
"savonneuse" => "savon2z",
"savonneuses" => "savon2z",
"savonneux" => "savon2",
"savonnier" => "savonje",
"savons" => "sav§",
"savoura" => "savuRa",
"savourai" => "savuRE",
"savouraient" => "savuRE",
"savourais" => "savuRE",
"savourait" => "savuRE",
"savourant" => "savuR@",
"savoure" => "savuR",
"savouré" => "savuRe",
"savourée" => "savuRe",
"savourent" => "savuR",
"savourer" => "savuRe",
"savourera" => "savuR°Ra",
"savourerai" => "savuR°RE",
"savourerait" => "savuR°RE",
"savourèrent" => "savuRER",
"savourerons" => "savuR°R§",
"savourés" => "savuRe",
"savoureuse" => "savuR2z",
"savoureusement" => "savuR2z°m@",
"savoureuses" => "savuR2z",
"savoureux" => "savuR2",
"savourez" => "savuRe",
"savourions" => "savuRj§",
"savourons" => "savuR§",
"savoyard" => "savwajaR",
"savoyarde" => "savwajaRd",
"savoyardes" => "savwajaRd",
"savoyards" => "savwajaR",
"sax" => "saks",
"saxes" => "saks",
"saxhorn" => "saksORn",
"saxifragacées" => "saksifRagase",
"saxifrage" => "saksifRaZ",
"saxifrages" => "saksifRaZ",
"saxo" => "sakso",
"saxon" => "saks§",
"saxonne" => "saksOn",
"saxonnes" => "saksOn",
"saxons" => "saks§",
"saxophone" => "saksofOn",
"saxophones" => "saksofOn",
"saxophoniste" => "saksofonist",
"saxophonistes" => "saksofonist",
"saxos" => "sakso",
"saynète" => "sEnEt",
"saynètes" => "sEnEt",
"sayon" => "sEj§",
"sbire" => "sbiR",
"sbires" => "sbiR",
"scabieuse" => "skabj2z",
"scabreuse" => "skabR2z",
"scabreuses" => "skabR2z",
"scabreux" => "skabR2",
"scaferlati" => "skafERlati",
"scalaire" => "skalER",
"scalène" => "skalEn",
"scalp" => "skalp",
"scalpa" => "skalpa",
"scalpaient" => "skalpE",
"scalpait" => "skalpE",
"scalpe" => "skalp",
"scalpé" => "skalpe",
"scalpel" => "skalpEl",
"scalpels" => "skalpEl",
"scalpent" => "skalp",
"scalper" => "skalpe",
"scalpera" => "skalp°Ra",
"scalpés" => "skalpe",
"scalpeur" => "skalp9R",
"scalpez" => "skalpe",
"scalps" => "skalp",
"scampi" => "sk@pi",
"scanda" => "sk@da",
"scandaient" => "sk@dE",
"scandait" => "sk@dE",
"scandale" => "sk@dal",
"scandales" => "sk@dal",
"scandaleuse" => "sk@dal2z",
"scandaleusement" => "sk@dal2z°m@",
"scandaleuses" => "sk@dal2z",
"scandaleux" => "sk@dal2",
"scandalisa" => "sk@daliza",
"scandalisai" => "sk@dalizE",
"scandalisaient" => "sk@dalizE",
"scandalisais" => "sk@dalizE",
"scandalisait" => "sk@dalizE",
"scandalisant" => "sk@daliz@",
"scandalise" => "sk@daliz",
"scandalisé" => "sk@dalize",
"scandalisée" => "sk@dalize",
"scandalisées" => "sk@dalize",
"scandalisent" => "sk@daliz",
"scandaliser" => "sk@dalize",
"scandalisera" => "sk@daliz°Ra",
"scandaliserait" => "sk@daliz°RE",
"scandalisèrent" => "sk@dalizER",
"scandalisés" => "sk@dalize",
"scandalisons" => "sk@daliz§",
"scandant" => "sk@d@",
"scande" => "sk@d",
"scandé" => "sk@de",
"scandée" => "sk@de",
"scandées" => "sk@de",
"scandent" => "sk@d",
"scander" => "sk@de",
"scandera" => "sk@d°Ra",
"scandés" => "sk@de",
"scandinave" => "sk@dinav",
"scandinaves" => "sk@dinav",
"scannage" => "skanaZ",
"scannais" => "skanE",
"scanne" => "skan",
"scanné" => "skane",
"scannée" => "skane",
"scannent" => "skan",
"scanner" => "skanER",
"scannera" => "skan°Ra",
"scanneront" => "skan°R§",
"scanners" => "skanER",
"scannes" => "skan",
"scannés" => "skane",
"scanneur" => "skan9R",
"scannez" => "skane",
"scanning" => "skaniG",
"scannons" => "skan§",
"scanographie" => "skanogRafi",
"scansion" => "sk@sj§",
"scansions" => "sk@sj§",
"scaphandre" => "skaf@dR",
"scaphandres" => "skaf@dR",
"scaphandrier" => "skaf@dRije",
"scaphandriers" => "skaf@dRije",
"scaphoïde" => "skafOid",
"scapin" => "skap5",
"scapulaire" => "skapylER",
"scapulaires" => "skapylER",
"scarabée" => "skaRabe",
"scarabées" => "skaRabe",
"scare" => "skaR",
"scarifiant" => "skaRifj@",
"scarification" => "skaRifikasj§",
"scarifications" => "skaRifikasj§",
"scarifié" => "skaRifje",
"scarlatin" => "skaRlat5",
"scarlatine" => "skaRlatin",
"scarlatines" => "skaRlatin",
"scarole" => "skaROl",
"scaroles" => "skaROl",
"scat" => "skat",
"scato" => "skato",
"scatologie" => "skatoloZi",
"scatologique" => "skatoloZik",
"scatologiques" => "skatoloZik",
"scatologue" => "skatOlOg",
"scatophiles" => "skatofil",
"scatos" => "skato",
"scatter" => "skate",
"scazons" => "skaz§",
"sceau" => "so",
"sceaux" => "so",
"scélérat" => "seleRa",
"scélérate" => "seleRat",
"scélérates" => "seleRat",
"scélératesse" => "seleRatEs",
"scélératesses" => "seleRatEs",
"scélérats" => "seleRa",
"scella" => "sEla",
"scellage" => "sElaZ",
"scellaient" => "sElE",
"scellait" => "sElE",
"scellant" => "sEl@",
"scelle" => "sEl",
"scellé" => "sele",
"scellée" => "sele",
"scellées" => "sele",
"scellement" => "sEl°m@",
"scellements" => "sEl°m@",
"scellent" => "sEl",
"sceller" => "sele",
"scellera" => "sEl°Ra",
"scellerait" => "sEl°RE",
"scellèrent" => "sElER",
"scelleront" => "sEl°R§",
"scellés" => "sele",
"scellez" => "sEle",
"scellons" => "sEl§",
"scénar" => "senaR",
"scenarii" => "s°naRi",
"scénarii" => "senaRi",
"scénarimage" => "senaRimaZ",
"scénario" => "senaRjo",
"scénarios" => "senaRjo",
"scénariste" => "senaRist",
"scénaristes" => "senaRist",
"scénaristique" => "senaRistik",
"scénars" => "senaR",
"scène" => "sEn",
"scène-clé" => "sEnkle",
"scènes" => "sEn",
"scènes-clés" => "sEnkle",
"scenic railway" => "snikRajwEj",
"scénique" => "senik",
"scéniques" => "senik",
"scénographe" => "senogRaf",
"scénographie" => "senogRafi",
"scénographique" => "senogRafik",
"scepticisme" => "sEptisizm",
"sceptique" => "sEptik",
"sceptiques" => "sEptik",
"sceptre" => "sEptR",
"sceptres" => "sEptR",
"schah" => "Sa",
"schako" => "Sako",
"schampooing" => "S@pw5",
"schbeb" => "Sb°b",
"scheik" => "SEk",
"schéma" => "Sema",
"schémas" => "Sema",
"schématique" => "Sematik",
"schématiquement" => "Sematik°m@",
"schématiques" => "Sematik",
"schématise" => "Sematiz",
"schématisée" => "Sematize",
"schématiser" => "Sematize",
"schématisme" => "Sematizm",
"schème" => "SEm",
"schèmes" => "SEm",
"schilling" => "SiliG",
"schillings" => "SiliG",
"schismatique" => "Sismatik",
"schismatiques" => "Sismatik",
"schisme" => "Sizm",
"schismes" => "Sizm",
"schiste" => "Sist",
"schistes" => "Sist",
"schisteuses" => "Sist2z",
"schizoïde" => "skizoid",
"schizoïdes" => "skizoid",
"schizophasie" => "skizofazi",
"schizophrène" => "skizofREn",
"schizophrènes" => "skizofREn",
"schizophrénie" => "skizofReni",
"schizophrénique" => "skizofRenik",
"schizophréniques" => "skizofRenik",
"schlague" => "Slag",
"schlass" => "Slas",
"schlem" => "SlEm",
"schleu" => "Sl2",
"schlinguait" => "Sl5gE",
"schlinguant" => "Sl5g@",
"schlingue" => "Sl5g",
"schlinguer" => "Sl5ge",
"schlingues" => "Sl5g",
"schlitte" => "Slit",
"schmecte" => "SmEkt",
"schnaps" => "Snaps",
"schnauzer" => "Snawz9R",
"schnick" => "Snik",
"schnitzel" => "SnitzEl",
"schnock" => "SnOk",
"schnocks" => "SnOk",
"schnoque" => "SnOk",
"schnoques" => "SnOk",
"schnouf" => "Snuf",
"schnouff" => "Snuf",
"schnouffe" => "Snuf",
"schooner" => "skun9R",
"schooners" => "Sun9R",
"schpile" => "Spil",
"schproum" => "spRum",
"schtroumf" => "StRumf",
"schtroumpf" => "StRumf",
"schtroumpfs" => "StRumf",
"schupo" => "Sypo",
"schupos" => "Sypo",
"schuss" => "Sus",
"scia" => "sja",
"sciage" => "sjaZ",
"sciaient" => "sjE",
"sciais" => "sjE",
"sciait" => "sjE",
"scialytique" => "sjalitik",
"sciant" => "sj@",
"sciatique" => "sjatik",
"scie" => "si",
"scié" => "sje",
"sciée" => "sje",
"sciées" => "sje",
"sciemment" => "sjam@",
"science" => "sj@s",
"science-fiction" => "sj@sfiksj§",
"sciences" => "sj@s",
"sciène" => "sjEn",
"scient" => "si",
"scientificité" => "sj@tifisite",
"scientifique" => "sj@tifik",
"scientifiquement" => "sj@tifik°m@",
"scientifiques" => "sj@tifik",
"scientisme" => "sj@tism",
"scientiste" => "sj@tist",
"scientologie" => "sj@toloZi",
"scientologue" => "sj@tolOg",
"scientologues" => "sj@tolOg",
"scier" => "sje",
"sciera" => "sijRa",
"scierait" => "siRE",
"scièrent" => "sjER",
"scierie" => "siRi",
"scieries" => "siRi",
"scieront" => "siR§",
"scies" => "si",
"sciés" => "sje",
"scieur" => "sj9R",
"scieurs" => "sj9R",
"sciez" => "sje",
"scindaient" => "s5dE",
"scindait" => "s5dE",
"scindant" => "s5d@",
"scinde" => "s5d",
"scindé" => "s5de",
"scindée" => "s5de",
"scinder" => "s5de",
"scinderas" => "s5d°Ra",
"scindèrent" => "s5dER",
"scindés" => "s5de",
"scindez" => "s5de",
"scintigraphie" => "s5tigRafi",
"scintillaient" => "s5tijE",
"scintillait" => "s5tijE",
"scintillant" => "s5tij@",
"scintillante" => "s5tij@t",
"scintillantes" => "s5tij@t",
"scintillants" => "s5tij@",
"scintillation" => "s5tijasj§",
"scintillations" => "s5tijasj§",
"scintille" => "s5tij",
"scintillé" => "s5tije",
"scintillement" => "s5tij°m@",
"scintillements" => "s5tij°m@",
"scintillent" => "s5tij",
"scintiller" => "s5tije",
"scintilleraient" => "s5tij°RE",
"scintillerais" => "s5tij°RE",
"scintillèrent" => "s5tijER",
"scintilleront" => "s5tij°R§",
"scintilles" => "s5tij",
"scintillons" => "s5tij§",
"scion" => "sj§",
"scions" => "sj§",
"scirpe" => "siRp",
"scirpes" => "siRp",
"scission" => "sisj§",
"scissionniste" => "sisjonist",
"scissiparité" => "sisipaRite",
"scissures" => "sisyR",
"sciure" => "sjyR",
"sciures" => "sjyR",
"scléreux" => "skleR2",
"sclérodermie" => "skleRodERmi",
"sclérosante" => "skleRoz@t",
"sclérose" => "skleRoz",
"sclérosé" => "skleRoze",
"sclérosée" => "skleRoze",
"scléroserai" => "skleRoz°RE",
"scléroses" => "skleRoz",
"sclérosés" => "skleRoze",
"sclérotique" => "skleRotik",
"sclérotiques" => "skleRotik",
"scolaire" => "skolER",
"scolairement" => "skolER°m@",
"scolaires" => "skolER",
"scolarisation" => "skolaRizasj§",
"scolariser" => "skOlaRize",
"scolarité" => "skolaRite",
"scolarités" => "skolaRite",
"scolastique" => "skolastik",
"scolastiques" => "skolastik",
"scolie" => "skoli",
"scoliose" => "skoljoz",
"scolioses" => "skoljoz",
"scolopendre" => "skolop@dR",
"scolopendres" => "skolop@dR",
"scolyte" => "skolit",
"scone" => "skon",
"scones" => "skon",
"sconse" => "sk§s",
"scoop" => "skup",
"scoops" => "skup",
"scooter" => "skut9R",
"scooters" => "skut9R",
"scope" => "skOp",
"scopes" => "skOp",
"scopie" => "skOpi",
"scopitones" => "skopitOn",
"scopolamine" => "skopolamin",
"scorbut" => "skORbyt",
"score" => "skOR",
"scores" => "skOR",
"scories" => "skoRi",
"scorpion" => "skORpj§",
"scorpions" => "skORpj§",
"scotch" => "skOtS",
"scotch-terrier" => "skOtStERje",
"scotchais" => "skOtSE",
"scotché" => "skOtSe",
"scotchée" => "skOtSe",
"scotchées" => "skOtSe",
"scotcher" => "skOtSe",
"scotches" => "skOtS",
"scotchés" => "skOtSe",
"scotchons" => "skOtS§",
"scotchs" => "skOtS",
"scotomisant" => "skotomiz@",
"scotomiser" => "skotomize",
"scottish" => "skOtiS",
"scoubidou" => "skubidu",
"scoubidous" => "skubidu",
"scoumoune" => "skumun",
"scout" => "skut",
"scoute" => "skut",
"scoutisme" => "skutizm",
"scouts" => "skut",
"scrabble" => "skRabl",
"scratch" => "skRatS",
"scratcher" => "skRatSe",
"scratching" => "skRatSiG",
"scriban" => "skRib@",
"scribe" => "skRib",
"scribes" => "skRib",
"scribouillages" => "skRibujaZ",
"scribouillard" => "skRibujaR",
"scribouillards" => "skRibujaR",
"scribouille" => "skRibuj",
"scribouiller" => "skRibuje",
"script" => "skRipt",
"script-girl" => "skRiptg9Rl",
"scripte" => "skRipt",
"scripteur" => "skRipt9R",
"scripteurs" => "skRipt9R",
"scripts" => "skRipt",
"scrofulaire" => "skROfylER",
"scrofule" => "skRofyl",
"scrofules" => "skRofyl",
"scrofuleux" => "skRofyl2",
"scrogneugneu" => "skRoN2N2",
"scrotal" => "skROtal",
"scrotum" => "skRotOm",
"scrub" => "skROb",
"scrubs" => "skR9b",
"scrupule" => "skRypyl",
"scrupules" => "skRypyl",
"scrupuleuse" => "skRypyl2z",
"scrupuleusement" => "skRypyl2z°m@",
"scrupuleuses" => "skRypyl2z",
"scrupuleux" => "skRypyl2",
"scrupulosité" => "skRypylozite",
"scruta" => "skRyta",
"scrutai" => "skRytE",
"scrutaient" => "skRytE",
"scrutais" => "skRytE",
"scrutait" => "skRytE",
"scrutâmes" => "skRytam",
"scrutant" => "skRyt@",
"scrutateur" => "skRytat9R",
"scrutateurs" => "skRytat9R",
"scrutation" => "skRytasj§",
"scrutatrices" => "skRytatRis",
"scrute" => "skRyt",
"scruté" => "skRyte",
"scrutée" => "skRyte",
"scrutent" => "skRyt",
"scruter" => "skRyte",
"scrutera" => "skRyt°Ra",
"scruterai" => "skRyt°RE",
"scruterait" => "skRyt°RE",
"scrutèrent" => "skRytER",
"scruteront" => "skRyt°R§",
"scrutés" => "skRyte",
"scrutez" => "skRyte",
"scrutin" => "skRyt5",
"scrutins" => "skRyt5",
"scrutions" => "skRytj§",
"scrutons" => "skRyt§",
"sculpta" => "skylta",
"sculptaient" => "skyltE",
"sculptais" => "skyltE",
"sculptait" => "skyltE",
"sculptant" => "skylt@",
"sculptâtes" => "skyltat",
"sculpte" => "skylt",
"sculpté" => "skylte",
"sculptée" => "skylte",
"sculptées" => "skylte",
"sculptent" => "skylt",
"sculpter" => "skylte",
"sculptera" => "skylt°Ra",
"sculpterai" => "skylt°RE",
"sculpterait" => "skylt°RE",
"sculpteras" => "skylt°Ra",
"sculpterez" => "skylt°Re",
"sculptes" => "skylt",
"sculptés" => "skylte",
"sculpteur" => "skylt9R",
"sculpteurs" => "skylt9R",
"sculptez" => "skylte",
"sculptiez" => "skyltje",
"sculptrice" => "skyltRis",
"sculptural" => "skyltyRal",
"sculpturale" => "skyltyRal",
"sculpturales" => "skyltyRal",
"sculpturaux" => "skyltyRo",
"sculpture" => "skyltyR",
"sculptures" => "skyltyR",
"scutigère" => "skytiZER",
"scutigères" => "skytiZER",
"scythe" => "sit",
"scythes" => "sit",
"se" => "s2",
"seaborgium" => "sibORgjOm",
"séance" => "se@s",
"séances" => "se@s",
"séant" => "se@",
"séante" => "se@t",
"seau" => "so",
"seaux" => "so",
"sébacé" => "sebase",
"sébacée" => "sebase",
"sébacées" => "sebase",
"sébaste" => "sebast",
"sébile" => "sebil",
"sébiles" => "sebil",
"séborrhée" => "seboRe",
"séborrhéique" => "sebOReik",
"sébum" => "sebOm",
"sec" => "sEk",
"sécateur" => "sekat9R",
"sécateurs" => "sekat9R",
"secco" => "seko",
"seccos" => "seko",
"seccotine" => "sekOtin",
"sécession" => "sesesj§",
"sécessionniste" => "sesesjOnist",
"sécessionnistes" => "sesesjonist",
"sécha" => "seSa",
"séchage" => "seSaZ",
"séchai" => "seSE",
"séchaient" => "seSE",
"séchais" => "seSE",
"séchait" => "seSE",
"séchant" => "seS@",
"séchard" => "seSaR",
"séchât" => "seSa",
"sèche" => "sES",
"séché" => "seSe",
"sèche-cheveux" => "sESS°v2",
"sèche-linge" => "sESl5Z",
"sèche-mains" => "sESm5",
"séchée" => "seSe",
"séchées" => "seSe",
"sèchement" => "sES°m@",
"sèchent" => "sES",
"sécher" => "seSe",
"séchera" => "seS°Ra",
"sécherai" => "sES°RE",
"sécheraient" => "seS°RE",
"sécherais" => "sES°RE",
"sécherait" => "seS°RE",
"séchèrent" => "seSER",
"sécheresse" => "seS°REs",
"sécheresses" => "seS°REs",
"sécherez" => "sES°Re",
"sécherie" => "seS°Ri",
"sécheries" => "seS°Ri",
"sécheront" => "seS°R§",
"sèches" => "sES",
"séchés" => "seSe",
"sécheuse" => "seS2z",
"séchez" => "seSe",
"séchiez" => "seSje",
"séchions" => "seSj§",
"séchoir" => "seSwaR",
"séchoirs" => "seSwaR",
"séchons" => "seS§",
"sécolle" => "sekOl",
"second" => "s°g§",
"second-maître" => "s2g§dmEtR",
"secondaient" => "s°g§dE",
"secondaire" => "s°g§dER",
"secondairement" => "s°g§dER°m@",
"secondaires" => "s°g§dER",
"secondais" => "s°g§dE",
"secondait" => "s°g§dE",
"secondant" => "s°g§d@",
"seconde" => "s°g§d",
"secondé" => "s°g§de",
"secondée" => "s°g§de",
"secondement" => "s°g§d°m@",
"secondent" => "s°g§d",
"seconder" => "s°g§de",
"secondera" => "s°g§d°Ra",
"seconderai" => "s°g§d°RE",
"seconderas" => "s°g§d°Ra",
"seconderez" => "s°g§d°Re",
"seconderont" => "s°g§d°R§",
"secondes" => "s°g§d",
"secondés" => "s°g§de",
"secondo" => "s2g§do",
"seconds" => "s°g§",
"sécot" => "seko",
"secoua" => "s°kwa",
"secouai" => "s°kwE",
"secouaient" => "s°kwE",
"secouais" => "s°kwE",
"secouait" => "s°kwE",
"secouâmes" => "s°kwam",
"secouant" => "s°kw@",
"secouassent" => "s°kwas",
"secoue" => "s°ku",
"secoué" => "s°kwe",
"secouée" => "s°kwe",
"secouées" => "s°kwe",
"secouement" => "s°kum@",
"secouent" => "s°ku",
"secouer" => "s°kwe",
"secouera" => "s°kuRa",
"secouerai" => "s°kuRE",
"secoueraient" => "s°kuRE",
"secouerais" => "s°kuRE",
"secouerait" => "s°kuRE",
"secouèrent" => "s°kwER",
"secouerez" => "s°kuRe",
"secoueront" => "s°kuR§",
"secoues" => "s°ku",
"secoués" => "s°kwe",
"secoueur" => "s°kw9R",
"secoueurs" => "s°ku9R",
"secouez" => "s°kue",
"secouions" => "s°kuj§",
"secouons" => "s°kw§",
"secourable" => "s°kuRabl",
"secourables" => "s°kuRabl",
"secouraient" => "s°kuRE",
"secourait" => "s°kuRE",
"secourant" => "s°kuR@",
"secoures" => "s°kuR",
"secourez" => "s°kuRe",
"secourions" => "s°kuRj§",
"secourir" => "s°kuRiR",
"secourisme" => "s°kuRizm",
"secouriste" => "s°kuRist",
"secouristes" => "s°kuRist",
"secourra" => "s°kuRa",
"secours" => "s°kuR",
"secourt" => "s°kuR",
"secouru" => "s°kuRy",
"secourue" => "s°kuRy",
"secourues" => "s°kuRy",
"secourus" => "s°kuRy",
"secourut" => "s°kuRy",
"secourût" => "s°kuRy",
"secousse" => "s°kus",
"secousses" => "s°kus",
"secret" => "s°kRE",
"secrétaient" => "s°kRetE",
"sécrétaient" => "sekRetE",
"secrétaire" => "s°kRetER",
"secrétairerie" => "s°kRetER°Ri",
"secrétaires" => "s°kRetER",
"sécrétais" => "sekRetE",
"sécrétait" => "sekRetE",
"sécrétant" => "sekRet@",
"secrétariat" => "s°kRetaRja",
"secrétariats" => "s°kRetaRja",
"sécrétât" => "sekReta",
"secrète" => "s°kREt",
"sécrète" => "sekREt",
"secrété" => "s°kRete",
"sécrété" => "sekRete",
"secrétée" => "s°kRete",
"sécrétée" => "sekRete",
"secrètement" => "s°kREt°m@",
"secrètent" => "s°kREt",
"sécrètent" => "sekREt",
"secréter" => "s°kRete",
"sécréter" => "sekRete",
"secrètes" => "s°kREt",
"sécrètes" => "sekREt",
"sécrétés" => "sekRete",
"sécréteur" => "sekRet9R",
"sécréteurs" => "sekRet9R",
"sécrétez" => "sekRete",
"sécrétine" => "sekRetin",
"sécrétion" => "sekResj§",
"sécrétions" => "sekResj§",
"secrets" => "s°kRE",
"secs" => "sEk",
"sectaire" => "sektER",
"sectaires" => "sektER",
"sectarisme" => "sektaRizm",
"sectateur" => "sektat9R",
"sectateurs" => "sektat9R",
"secte" => "sEkt",
"sectes" => "sEkt",
"secteur" => "sekt9R",
"secteurs" => "sekt9R",
"section" => "seksj§",
"sectionna" => "seksjona",
"sectionnaient" => "seksjonE",
"sectionnant" => "sEksjOn@",
"sectionne" => "seksjOn",
"sectionné" => "seksjone",
"sectionnée" => "seksjone",
"sectionnées" => "seksjone",
"sectionnement" => "seksjOn°m@",
"sectionnent" => "seksjOn",
"sectionner" => "seksjone",
"sectionnera" => "seksjOn°Ra",
"sectionnés" => "seksjone",
"sectionnez" => "seksjone",
"sections" => "seksj§",
"sectorielles" => "sektoRjEl",
"sectoriels" => "sektoRjEl",
"sectorisation" => "sEktORizasj§",
"sécu" => "seky",
"séculaire" => "sekylER",
"séculairement" => "sekylER°m@",
"séculaires" => "sekylER",
"sécularisées" => "sekylaRize",
"séculariser" => "sekylaRize",
"séculier" => "sekylje",
"séculière" => "sekyljER",
"séculiers" => "sekylje",
"secundo" => "s°g§do",
"sécurisait" => "sekyRizE",
"sécurisant" => "sekyRiz@",
"sécurisante" => "sekyRiz@t",
"sécurisation" => "sekyRizasj§",
"sécurisé" => "sekyRize",
"sécurisée" => "sekyRize",
"sécurisées" => "sekyRize",
"sécuriser" => "sekyRize",
"sécurisés" => "sekyRize",
"sécurisez" => "sekyRize",
"sécurit" => "sekyRi",
"sécuritaire" => "sekyRitER",
"sécurité" => "sekyRite",
"sécurités" => "sekyRite",
"sedan" => "s°d@",
"sédatif" => "sedatif",
"sédatifs" => "sedatif",
"sédation" => "sedasj§",
"sédative" => "sedativ",
"sédatives" => "sedativ",
"sédentaire" => "sed@tER",
"sédentaires" => "sed@tER",
"sédentarisaient" => "sed@taRizE",
"sédentarisation" => "sed@taRizasj§",
"sédentarise" => "sed@taRiz",
"sédentariser" => "sed@taRize",
"sédentarisme" => "sed@taRizm",
"sédentarité" => "sed@taRite",
"sedia gestatoria" => "s°djaZEstatoRja",
"sédiment" => "sedim@",
"sédimentaire" => "sedim@tER",
"sédimentaires" => "sedim@tER",
"sédimentation" => "sedim@tasj§",
"sédimentations" => "sedim@tasj§",
"sédimente" => "sedim@t",
"sédimentée" => "sedim@te",
"sédiments" => "sedim@",
"séditieuse" => "sedisj2z",
"séditieuses" => "sedisj2z",
"séditieux" => "sedisj2",
"sédition" => "sedisj§",
"séducteur" => "sedykt9R",
"séducteurs" => "sedykt9R",
"séduction" => "sedyksj§",
"séductions" => "sedyksj§",
"séductrice" => "sedyktRis",
"séductrices" => "sedyktRis",
"séduira" => "sed8iRa",
"séduirait" => "sed8iRE",
"séduiras" => "sed8iRa",
"séduire" => "sed8iR",
"séduis" => "sed8i",
"séduisaient" => "sed8izE",
"séduisait" => "sed8izE",
"séduisant" => "sed8iz@",
"séduisante" => "sed8iz@t",
"séduisantes" => "sed8iz@t",
"séduisants" => "sed8iz@",
"séduise" => "sed8iz",
"séduisent" => "sed8iz",
"séduises" => "sed8iz",
"séduisez" => "sed8ize",
"séduisirent" => "sed8iziR",
"séduisit" => "sed8izi",
"séduit" => "sed8i",
"séduite" => "sed8it",
"séduites" => "sed8it",
"séduits" => "sed8i",
"sedums" => "sedOm",
"seersucker" => "siRs9k9R",
"séfarade" => "sefaRad",
"segment" => "sEgm@",
"segmentaire" => "sEgm@tER",
"segmentale" => "sEgm@tal",
"segmenté" => "sEgm@te",
"segmentez" => "sEgm@te",
"segments" => "sEgm@",
"ségrégation" => "segRegasj§",
"ségrégationniste" => "segRegasjOnist",
"seguedilla" => "s°g°dija",
"seguedillas" => "s°g°dija",
"séguedille" => "seg°dij",
"seiche" => "sES",
"seiches" => "sES",
"séide" => "seid",
"séides" => "seid",
"seigle" => "sEgl",
"seigles" => "sEgl",
"seigneur" => "sEN9R",
"seigneurial" => "sEN9Rjal",
"seigneuriale" => "sEN9Rjal",
"seigneuriales" => "sEN9Rjal",
"seigneuriaux" => "sEN9Rjo",
"seigneurie" => "sEN9Ri",
"seigneuries" => "sEN9Ri",
"seigneurs" => "sEN9R",
"seille" => "sEj",
"seilles" => "sEj",
"seillon" => "sEj§",
"sein" => "s5",
"seine" => "sEn",
"seing" => "s5",
"seins" => "s5",
"séisme" => "seizm",
"séismes" => "seizm",
"seize" => "sEz",
"seizième" => "sEzjEm",
"séjour" => "seZuR",
"séjourna" => "seZuRna",
"séjournaient" => "seZuRnE",
"séjournais" => "seZuRnE",
"séjournait" => "seZuRnE",
"séjournâmes" => "seZuRnam",
"séjournant" => "seZuRn@",
"séjourne" => "seZuRn",
"séjourné" => "seZuRne",
"séjournent" => "seZuRn",
"séjourner" => "seZuRne",
"séjourneraient" => "seZuRn°RE",
"séjournerez" => "seZuRn°Re",
"séjourneriez" => "seZuRn°Rje",
"séjournerons" => "seZuRn°R§",
"séjournes" => "seZuRn",
"séjournez" => "seZuRne",
"séjourniez" => "seZuRnje",
"séjournions" => "seZuRnj§",
"séjours" => "seZuR",
"sel" => "sEl",
"seldjoukide" => "sEldZukid",
"seldjoukides" => "sEldZukid",
"select" => "selEkt",
"sélect" => "selEkt",
"sélecte" => "selEkt",
"sélecteur" => "selEkt9R",
"sélecteurs" => "selEkt9R",
"sélectif" => "selEktif",
"sélectifs" => "selEktif",
"sélection" => "selEksj§",
"sélectionna" => "selEksjona",
"sélectionnaient" => "selEksjonE",
"sélectionnait" => "selEksjonE",
"sélectionnant" => "selEksjOn@",
"sélectionne" => "selEksjOn",
"sélectionné" => "selEksjone",
"sélectionnée" => "selEksjone",
"sélectionnées" => "selEksjone",
"sélectionner" => "selEksjone",
"sélectionnera" => "selEksjOn°Ra",
"sélectionnerai" => "selEksjOn°RE",
"sélectionnerais" => "selEksjOn°RE",
"sélectionnés" => "selEksjone",
"sélectionneur" => "selEksjon9R",
"sélectionneuse" => "selEksjOn2z",
"sélectionnez" => "selEksjone",
"sélections" => "selEksj§",
"sélective" => "selEktiv",
"sélectivement" => "selEktiv°m@",
"sélectives" => "selEktiv",
"sélectivité" => "selEktivite",
"selects" => "selEkt",
"sélects" => "selEkt",
"sélénite" => "selenit",
"sélénites" => "selenit",
"sélénium" => "selenjOm",
"séléniure" => "selenjyR",
"sélénographie" => "selenogRafi",
"self" => "sElf",
"self-control" => "sElfk§tRol",
"self-contrôle" => "sElfk§tRol",
"self-défense" => "sElfdef@s",
"self-made man" => "sElfmEjdman",
"self-made-man" => "sElfmEjdman",
"self-made-men" => "sElfmEjdmEn",
"self-service" => "sElfsERvis",
"self-services" => "sElfsERvis",
"selfs" => "sElf",
"sellait" => "sElE",
"selle" => "sEl",
"sellé" => "sEle",
"sellée" => "sEle",
"sellées" => "sEle",
"seller" => "sele",
"sellerie" => "sEl°Ri",
"selleries" => "sEl°Ri",
"selles" => "sEl",
"sellés" => "sEle",
"sellette" => "sElEt",
"sellez" => "sEle",
"sellier" => "selje",
"selon" => "s°l§",
"sels" => "sEl",
"seltz" => "sElts",
"selva" => "sElva",
"sema" => "s°ma",
"semaient" => "s°mE",
"semailles" => "s°maj",
"semaine" => "s°mEn",
"semaines" => "s°mEn",
"semainier" => "s°mEnje",
"semait" => "s°mE",
"semant" => "s°m@",
"sémantique" => "sem@tik",
"sémantiques" => "sem@tik",
"sémaphore" => "semafOR",
"sémaphores" => "semafOR",
"sémaphoriques" => "semafoRik",
"semât" => "s°ma",
"sembla" => "s@bla",
"semblable" => "s@blabl",
"semblablement" => "s@blabl°m@",
"semblables" => "s@blabl",
"semblaient" => "s@blE",
"semblais" => "s@blE",
"semblait" => "s@blE",
"semblance" => "s@bl@s",
"semblant" => "s@bl@",
"semblants" => "s@bl@",
"semblât" => "s@bla",
"semble" => "s@bl",
"semblé" => "s@ble",
"semblent" => "s@bl",
"sembler" => "s@ble",
"semblera" => "s@bl°Ra",
"sembleraient" => "s@bl°RE",
"semblerait" => "s@bl°RE",
"semblèrent" => "s@blER",
"sembleront" => "s@bl°R§",
"sembles" => "s@bl",
"semblez" => "s@ble",
"sembliez" => "s@blije",
"semblions" => "s@blij§",
"semblons" => "s@bl§",
"sème" => "sEm",
"semé" => "s°me",
"semée" => "s°me",
"semées" => "s°me",
"semelle" => "s°mEl",
"semelles" => "s°mEl",
"semen-contra" => "semEnk§tRa",
"semence" => "s°m@s",
"semences" => "s°m@s",
"sèment" => "sEm",
"semer" => "s°me",
"sèmera" => "sEm°Ra",
"sèmerai" => "sEm°RE",
"sèmerais" => "sEm°RE",
"sèmerait" => "sEm°RE",
"sèmeras" => "sEm°Ra",
"sèmerez" => "sEm°Re",
"sèmerions" => "sEm°Rj§",
"sèmerons" => "sEm°R§",
"sèmeront" => "sEm°R§",
"sèmes" => "sEm",
"semés" => "s°me",
"semestre" => "s°mEstR",
"semestres" => "s°mEstR",
"semestriel" => "s°mEstRijEl",
"semestrielle" => "s°mEstRijEl",
"semestriellement" => "s2mEstRijEl°m@",
"semeur" => "s°m9R",
"semeurs" => "s°m9R",
"semeuse" => "s°m2z",
"semeuses" => "s°m2z",
"semez" => "s°me",
"semi" => "s°mi",
"semi-arides" => "s°miaRid",
"semi-automatique" => "s°miotomatik",
"semi-automatiques" => "s°miotomatik",
"semi-circulaire" => "s°misiRkylER",
"semi-conducteur" => "s°mik§dykt9R",
"semi-conducteurs" => "s°mik§dykt9R",
"semi-liberté" => "s°milibERte",
"semi-lunaire" => "s°milynER",
"semi-nomades" => "s°minomad",
"semi-officiel" => "s°miofisjEl",
"semi-officielle" => "s°miofisjEl",
"semi-ouvert" => "s2miuvER",
"semi-perméable" => "s2mipERmeabl",
"semi-phonétique" => "s2mifOnetik",
"semi-précieuse" => "s°mipResj2z",
"semi-précieuses" => "s°mipResj2z",
"semi-public" => "s2mipyblik",
"semi-remorque" => "s°miR°mORk",
"semi-remorques" => "s°miR°mORk",
"semi-rigide" => "s°miRiZid",
"sémillant" => "semij@",
"sémillante" => "semij@t",
"sémillon" => "semij§",
"séminaire" => "seminER",
"séminaires" => "seminER",
"séminal" => "seminal",
"séminale" => "seminal",
"séminales" => "seminal",
"séminariste" => "seminaRist",
"séminaristes" => "seminaRist",
"séminaux" => "semino",
"séminole" => "seminOl",
"séminoles" => "seminOl",
"séminome" => "seminom",
"sémiologie" => "semjoloZi",
"sémiologue" => "semjolOg",
"sémiotique" => "semjotik",
"sémiotiques" => "semjotik",
"semis" => "s°mi",
"sémite" => "semit",
"sémites" => "semit",
"sémitique" => "semitik",
"sémitiques" => "semitik",
"semoir" => "s°mwaR",
"semoirs" => "s°mwaR",
"semonça" => "s°m§sa",
"semonçait" => "s°m§sE",
"semonçant" => "s°m§s@",
"semonce" => "s°m§s",
"semoncé" => "s°m§se",
"semoncer" => "s°m§se",
"semonces" => "s°m§s",
"semons" => "s°m§",
"semoule" => "s°mul",
"sempiternel" => "s@pitERnEl",
"sempiternelle" => "s@pitERnEl",
"sempiternellement" => "s@pitERnEl°m@",
"sempiternelles" => "s@pitERnEl",
"sempiternels" => "s@pitERnEl",
"semtex" => "sEmtEks",
"sen" => "sEn",
"sénat" => "sena",
"sénateur" => "senat9R",
"sénateurs" => "senat9R",
"sénatorial" => "senatoRjal",
"sénatoriale" => "senatoRjal",
"sénatoriales" => "senatoRjal",
"sénatrice" => "senatRis",
"sénatus-consulte" => "senatysk§sylt",
"séné" => "sene",
"sénéchal" => "seneSal",
"sénéchaux" => "seneSo",
"sénégalais" => "senegalE",
"sénégalaise" => "senegalEz",
"sénégalaises" => "senegalEz",
"sénés" => "sene",
"sénescence" => "senes@s",
"senestre" => "senEstR",
"sénevé" => "sEn°ve",
"sénile" => "senil",
"sénilement" => "senil°m@",
"séniles" => "senil",
"sénilité" => "senilite",
"senior" => "senjOR",
"seniors" => "senjOR",
"senne" => "sEn",
"señor" => "seNOR",
"sens" => "s@",
"sensas" => "s@sas",
"sensass" => "s@sas",
"sensation" => "s@sasj§",
"sensationnalisme" => "s@sasjonalizm",
"sensationnel" => "s@sasjonEl",
"sensationnelle" => "s@sasjonEl",
"sensationnellement" => "s@sasjonEl°m@",
"sensationnelles" => "s@sasjonEl",
"sensationnels" => "s@sasjonEl",
"sensations" => "s@sasj§",
"sensé" => "s@se",
"sensée" => "s@se",
"sensées" => "s@se",
"sensément" => "s@sem@",
"sensés" => "s@se",
"senseur" => "s@s9R",
"senseurs" => "s@s9R",
"sensibilisait" => "s@sibilizE",
"sensibilisation" => "s@sibilizasj§",
"sensibilise" => "s@sibiliz",
"sensibilisé" => "s@sibilize",
"sensibilisée" => "s@sibilize",
"sensibiliser" => "s@sibilize",
"sensibilisés" => "s@sibilize",
"sensibilité" => "s@sibilite",
"sensibilités" => "s@sibilite",
"sensible" => "s@sibl",
"sensiblement" => "s@sibl°m@",
"sensiblerie" => "s@sibl°Ri",
"sensibleries" => "s@sibl°Ri",
"sensibles" => "s@sibl",
"sensitif" => "s@sitif",
"sensitifs" => "s@sitif",
"sensitive" => "s@sitiv",
"sensitives" => "s@sitiv",
"sensorialité" => "s@soRjalite",
"sensoriel" => "s@soRjEl",
"sensorielle" => "s@soRjEl",
"sensorielles" => "s@soRjEl",
"sensoriels" => "s@soRjEl",
"sensualiste" => "s@s8alist",
"sensualité" => "s@s8alite",
"sensualités" => "s@s8alite",
"sensuel" => "s@s8El",
"sensuelle" => "s@s8El",
"sensuellement" => "s@s8El°m@",
"sensuelles" => "s@s8El",
"sensuels" => "s@s8El",
"sent" => "s@",
"sent-bon" => "s@b§",
"sentaient" => "s@tE",
"sentais" => "s@tE",
"sentait" => "s@tE",
"sentant" => "s@t@",
"sente" => "s@t",
"sentence" => "s@t@s",
"sentences" => "s@t@s",
"sentencieuse" => "s@t@sj2z",
"sentencieusement" => "s@t@sj2z°m@",
"sentencieuses" => "s@t@sj2z",
"sentencieux" => "s@t@sj2",
"sentent" => "s@t",
"sentes" => "s@t",
"senteur" => "s@t9R",
"senteurs" => "s@t9R",
"sentez" => "s@te",
"senti" => "s@ti",
"sentie" => "s@ti",
"sentier" => "s@tje",
"sentiers" => "s@tje",
"senties" => "s@ti",
"sentiez" => "s@tje",
"sentiment" => "s@tim@",
"sentimental" => "s@tim@tal",
"sentimentale" => "s@tim@tal",
"sentimentalement" => "s@tim@tal°m@",
"sentimentales" => "s@tim@tal",
"sentimentaliser" => "s@tim@talize",
"sentimentalisme" => "s@tim@talizm",
"sentimentalité" => "s@tim@talite",
"sentimentalités" => "s@tim@talite",
"sentimentaux" => "s@tim@to",
"sentiments" => "s@tim@",
"sentîmes" => "s@tim",
"sentine" => "s@tin",
"sentinelle" => "s@tinEl",
"sentinelles" => "s@tinEl",
"sentines" => "s@tin",
"sentions" => "s@tj§",
"sentir" => "s@tiR",
"sentira" => "s@tiRa",
"sentirai" => "s@tiRE",
"sentiraient" => "s@tiRE",
"sentirais" => "s@tiRE",
"sentirait" => "s@tiRE",
"sentiras" => "s@tiRa",
"sentirent" => "s@tiR",
"sentirez" => "s@tiRe",
"sentiriez" => "s@tiRje",
"sentirons" => "s@tiR§",
"sentiront" => "s@tiR§",
"sentis" => "s@ti",
"sentisse" => "s@tis",
"sentissent" => "s@tis",
"sentit" => "s@ti",
"sentît" => "s@ti",
"sentons" => "s@t§",
"séoudite" => "seudit",
"sépale" => "sepal",
"sépales" => "sepal",
"sépara" => "sepaRa",
"séparable" => "sepaRabl",
"séparai" => "sepaRE",
"séparaient" => "sepaRE",
"séparais" => "sepaRE",
"séparait" => "sepaRE",
"séparâmes" => "sepaRam",
"séparant" => "sepaR@",
"séparât" => "sepaRa",
"séparateur" => "sepaRat9R",
"séparation" => "sepaRasj§",
"séparations" => "sepaRasj§",
"séparatiste" => "sepaRatist",
"séparatistes" => "sepaRatist",
"séparatrice" => "sepaRatRis",
"sépare" => "sepaR",
"séparé" => "sepaRe",
"séparée" => "sepaRe",
"séparées" => "sepaRe",
"séparément" => "sepaRem@",
"séparent" => "sepaR",
"séparer" => "sepaRe",
"séparera" => "sepaR°Ra",
"séparerai" => "sepaR°RE",
"sépareraient" => "sepaR°RE",
"séparerais" => "sepaR°RE",
"séparerait" => "sepaR°RE",
"sépareras" => "sepaR°Ra",
"séparèrent" => "sepaRER",
"séparerez" => "sepaR°Re",
"séparerons" => "sepaR°R§",
"sépareront" => "sepaR°R§",
"séparés" => "sepaRe",
"séparez" => "sepaRe",
"sépariez" => "sepaRje",
"séparions" => "sepaRj§",
"séparons" => "sepaR§",
"sépharade" => "sefaRad",
"sépharades" => "sefaRad",
"sépia" => "sepja",
"sépias" => "sepja",
"seppuku" => "sepuku",
"seps" => "sEps",
"sept" => "sEt",
"septale" => "sEptal",
"septante" => "sEpt@t",
"septante-cinq" => "sEpt@ts5k",
"septante-sept" => "sEpt@t°sEt",
"septaux" => "sEpto",
"septembre" => "sEpt@bR",
"septembriseur" => "sEpt@bRiz9R",
"septennat" => "sEptena",
"septentrion" => "sEpt@tRij§",
"septentrional" => "sEpt@tRijonal",
"septentrionale" => "sEpt@tRijonal",
"septentrionales" => "sEpt@tRijonal",
"septicémie" => "sEptisemi",
"septicémique" => "sEptisemik",
"septicité" => "sEptisite",
"septidi" => "sEptidi",
"septième" => "sEtjEm",
"septièmes" => "sEtjEm",
"septime" => "sEptim",
"septique" => "sEptik",
"septuagénaire" => "sEpt8aZenER",
"septuagénaires" => "sEpt8aZenER",
"septum" => "sEptOm",
"septuor" => "sEpt8OR",
"septuple" => "sEptypl",
"sepuku" => "s2puku",
"sépulcral" => "sepylkRal",
"sépulcrale" => "sepylkRal",
"sépulcrales" => "sepylkRal",
"sépulcre" => "sepylkR",
"sépulcres" => "sepylkR",
"sépulture" => "sepyltyR",
"sépultures" => "sepyltyR",
"séquanaise" => "sekanEz",
"séquelle" => "sekEl",
"séquelles" => "sekEl",
"séquençage" => "sek@saZ",
"séquence" => "sek@s",
"séquencer" => "sek@se",
"séquences" => "sek@s",
"séquenceur" => "sek@s9R",
"séquentiel" => "sek@sjEl",
"séquentielle" => "sek@sjEl",
"séquentiellement" => "sek@sjEl°m@",
"séquestraient" => "sekEstRE",
"séquestrait" => "sekEstRE",
"séquestration" => "sekEstRasj§",
"séquestrations" => "sekEstRasj§",
"séquestre" => "sekEstR",
"séquestré" => "sekEstRe",
"séquestrée" => "sekEstRe",
"séquestrer" => "sekEstRe",
"séquestres" => "sekEstR",
"séquestrés" => "sekEstRe",
"séquestrez" => "sekEstRe",
"sequin" => "s°k5",
"sequins" => "s°k5",
"séquoia" => "sekoja",
"séquoias" => "sekoja",
"sera" => "s°Ra",
"sérac" => "seRak",
"séracs" => "seRak",
"serai" => "s°RE",
"seraient" => "s°RE",
"sérail" => "seRaj",
"serais" => "s°RE",
"serait" => "s°RE",
"séraphin" => "seRaf5",
"séraphins" => "seRaf5",
"séraphique" => "seRafik",
"séraphiques" => "seRafik",
"seras" => "s°Ra",
"serbe" => "sERb",
"serbes" => "sERb",
"serbo-croate" => "sERbokRoat",
"serein" => "s°R5",
"sereine" => "s°REn",
"sereinement" => "s°REn°m@",
"sereines" => "s°REn",
"sereins" => "s°R5",
"sérénade" => "seRenad",
"sérénades" => "seRenad",
"sérénissime" => "seRenisim",
"sérénité" => "seRenite",
"séreux" => "seR2",
"serez" => "s°Re",
"serf" => "sER",
"serfouette" => "sERfwEt",
"serfs" => "sER",
"serge" => "sERZ",
"sergé" => "sERZe",
"sergent" => "sERZ@",
"sergent-chef" => "sERZ@SEf",
"sergent-major" => "sERZ@maZOR",
"sergent-pilote" => "sERZ@pilOt",
"sergents" => "sERZ@",
"sergents-chefs" => "sERZ@SEf",
"sergents-majors" => "sERZ@maZOR",
"serges" => "sERZ",
"sergot" => "sERgo",
"sergots" => "sERgo",
"serial" => "s°Rjal",
"sérial" => "seRjal",
"sériant" => "seRj@",
"série" => "seRi",
"sériel" => "seRjEl",
"sérielle" => "seRjEl",
"sérier" => "seRje",
"séries" => "seRi",
"sérieuse" => "seRj2z",
"sérieusement" => "seRj2z°m@",
"sérieuses" => "seRj2z",
"sérieux" => "seRj2",
"seriez" => "s°Rje",
"serin" => "s°R5",
"serinais" => "s°RinE",
"serinait" => "s°RinE",
"serine" => "s°Rin",
"seriné" => "s°Rine",
"serinées" => "s°Rine",
"seriner" => "s°Rine",
"serinera" => "s°RinRa",
"serines" => "s°Rin",
"seringa" => "s°R5ga",
"seringas" => "s°R5ga",
"seringuaient" => "s°R5gE",
"seringuait" => "s°R5gE",
"seringue" => "s°R5g",
"seringuée" => "s°R5ge",
"seringueiros" => "s2RingEjRos",
"seringuer" => "s°R5ge",
"seringues" => "s°R5g",
"serinions" => "s°Rinj§",
"serins" => "s°R5",
"serions" => "s°Rj§",
"sérique" => "seRik",
"serment" => "sERm@",
"serments" => "sERm@",
"sermon" => "sERm§",
"sermonna" => "sERmona",
"sermonnaient" => "sERmonE",
"sermonnait" => "sERmonE",
"sermonnant" => "sERmon@",
"sermonne" => "sERmOn",
"sermonné" => "sERmone",
"sermonnée" => "sERmone",
"sermonner" => "sERmone",
"sermonnerai" => "sERmOn°RE",
"sermonnes" => "sERmOn",
"sermonneur" => "sERmon9R",
"sermonneurs" => "sERmon9R",
"sermonnez" => "sERmone",
"sermons" => "sERm§",
"sérologie" => "seRoloZi",
"séronégatif" => "seRonegatif",
"séronégatifs" => "seRonegatif",
"séronégative" => "seRonegativ",
"serons" => "s°R§",
"seront" => "s°R§",
"séropo" => "seRopo",
"séropositif" => "seRopozitif",
"séropositifs" => "seRopozitif",
"séropositive" => "seRopozitiv",
"séropositives" => "seRopozitiv",
"séropositivité" => "seRopozitivite",
"sérosité" => "seRozite",
"sérotonine" => "seRotonin",
"serpe" => "sERp",
"serpent" => "sERp@",
"serpentaient" => "sERp@tE",
"serpentaire" => "sERp@tER",
"serpentait" => "sERp@tE",
"serpentant" => "sERp@t@",
"serpente" => "sERp@t",
"serpenté" => "sERp@te",
"serpenteau" => "sERp@to",
"serpentement" => "sERp@t°m@",
"serpentements" => "sERp@t°m@",
"serpentent" => "sERp@t",
"serpenter" => "sERp@te",
"serpentiforme" => "sERp@tifORm",
"serpentin" => "sERp@t5",
"serpentine" => "sERp@tin",
"serpentines" => "sERp@tin",
"serpentins" => "sERp@t5",
"serpentons" => "sERp@t§",
"serpents" => "sERp@",
"serpes" => "sERp",
"serpette" => "sERpEt",
"serpillière" => "sERpijER",
"serpillières" => "sERpijER",
"serpolet" => "sERpolE",
"serra" => "sERa",
"serrage" => "sERaZ",
"serrai" => "sERE",
"serraient" => "sERE",
"serrais" => "sERE",
"serrait" => "sERE",
"serrâmes" => "sERam",
"serrant" => "sER@",
"serrante" => "sER@t",
"serrât" => "sERa",
"serre" => "sER",
"serré" => "sERe",
"serre-file" => "sERfil",
"serre-joint" => "sERZw5",
"serre-joints" => "sERZw5",
"serre-livres" => "sERlivR",
"serre-tête" => "sERtEt",
"serre-têtes" => "sERtEt",
"serrée" => "sERe",
"serrées" => "seRe",
"serrement" => "sER°m@",
"serrements" => "sER°m@",
"serrent" => "sER",
"serrer" => "seRe",
"serrera" => "sER°Ra",
"serrerai" => "sER°RE",
"serreraient" => "sER°RE",
"serrerais" => "sER°RE",
"serrerait" => "sER°RE",
"serrèrent" => "sERER",
"serrerez" => "sER°Re",
"serrerons" => "sER°R§",
"serreront" => "sER°R§",
"serres" => "sER",
"serrés" => "seRe",
"serrez" => "sERe",
"serriez" => "sERje",
"serrions" => "sERj§",
"serrons" => "sER§",
"serrure" => "seRyR",
"serrurerie" => "seRyR°Ri",
"serrures" => "seRyR",
"serrurier" => "seRyRje",
"serrurière" => "seRyRjER",
"serruriers" => "seRyRje",
"sers" => "se",
"sert" => "sER",
"sertao" => "sERtaw",
"sertão" => "sERtaw",
"serti" => "sERti",
"sertie" => "sERti",
"serties" => "sERti",
"sertir" => "sERtiR",
"sertirait" => "sERtiRE",
"sertis" => "sERti",
"sertissage" => "sERtisaZ",
"sertissaient" => "sERtisE",
"sertissait" => "sERtisE",
"sertissant" => "sERtis@",
"sertissent" => "sERtis",
"sertisseur" => "sERtis9R",
"sérum" => "seROm",
"sérums" => "seROm",
"servage" => "sERvaZ",
"servaient" => "sERvE",
"servais" => "sERvE",
"servait" => "sERvE",
"serval" => "sERval",
"servant" => "sERv@",
"servante" => "sERv@t",
"servantes" => "sERv@t",
"servants" => "sERv@",
"serve" => "sERv",
"servent" => "sERv",
"serves" => "sERv",
"serveur" => "sERv9R",
"serveurs" => "sERv9R",
"serveuse" => "sERv2z",
"serveuses" => "sERv2z",
"servez" => "sERve",
"servi" => "sERvi",
"serviabilité" => "sERvjabilite",
"serviable" => "sERvjabl",
"serviables" => "sERvjabl",
"service" => "sERvis",
"services" => "sERvis",
"servie" => "sERvi",
"servies" => "sERvi",
"serviette" => "sERvjEt",
"serviette-éponge" => "sERvjEtep§Z",
"serviettes" => "sERvjEt",
"serviettes-éponges" => "sERvjEtep§Z",
"serviez" => "sERvje",
"servile" => "sERvil",
"servilement" => "sERvil°m@",
"serviles" => "sERvil",
"servilité" => "sERvilite",
"servilités" => "sERvilite",
"servîmes" => "sERvim",
"servions" => "sERvj§",
"servir" => "sERviR",
"servira" => "sERviRa",
"servirai" => "sERviRE",
"serviraient" => "sERviRE",
"servirais" => "sERviRE",
"servirait" => "sERviRE",
"serviras" => "sERviRa",
"servirent" => "sERviR",
"servirez" => "sERviRe",
"serviriez" => "sERviRje",
"servirions" => "sERviRj§",
"servirons" => "sERviR§",
"serviront" => "sERviR§",
"servis" => "sERvi",
"servissent" => "sERvis",
"servit" => "sERvi",
"servît" => "sERvi",
"serviteur" => "sERvit9R",
"serviteurs" => "sERvit9R",
"servitude" => "sERvityd",
"servitudes" => "sERvityd",
"servofrein" => "sERvofR5",
"servomécanisme" => "sERvomekanizm",
"servomoteur" => "sERvomOt9R",
"servomoteurs" => "sERvomot9R",
"servons" => "sERv§",
"ses" => "se",
"sésame" => "sezam",
"sésamoïdes" => "sezamoid",
"session" => "sesj§",
"sessions" => "sesj§",
"sesterces" => "sEstERs",
"set" => "sEt",
"séton" => "set§",
"sets" => "sEt",
"setter" => "setER",
"setters" => "setER",
"seuil" => "s9j",
"seuils" => "s9j",
"seul" => "s9l",
"seulabre" => "s2labR",
"seulabres" => "s2labR",
"seule" => "s9l",
"seulement" => "s9l°m@",
"seules" => "s9l",
"seulet" => "s9lE",
"seulette" => "s9lEt",
"seulettes" => "s9lEt",
"seuls" => "s9l",
"sève" => "sEv",
"seventies" => "s°v@ti",
"sévère" => "sevER",
"sévèrement" => "sevER°m@",
"sévères" => "sevER",
"sévérité" => "seveRite",
"sévérités" => "seveRite",
"sèves" => "sEv",
"sévi" => "sevi",
"sévice" => "sevis",
"sévices" => "sevis",
"sévillan" => "sevil@",
"sévillane" => "sevilan",
"sévir" => "seviR",
"sévira" => "seviRa",
"sévirai" => "seviRE",
"sévissaient" => "sevisE",
"sévissais" => "sevisE",
"sévissait" => "sevisE",
"sévissant" => "sevis@",
"sévisse" => "sevis",
"sévissent" => "sevis",
"sévit" => "sevi",
"sévît" => "sevi",
"sevrage" => "s°vRaZ",
"sevrages" => "s°vRaZ",
"sevrait" => "s°vRE",
"sevré" => "s°vRe",
"sevrée" => "s°vRe",
"sevrées" => "s°vRe",
"sevrer" => "s°vRe",
"sèvres" => "sEvR",
"sevrés" => "s°vRe",
"sévrienne" => "sevRijEn",
"sévriennes" => "sevRijEn",
"sex appeal" => "sEksapil",
"sex shop" => "seksSOp",
"sex shops" => "seksSOp",
"sex-appeal" => "sEksapil",
"sex-shop" => "seksSOp",
"sex-shops" => "seksSOp",
"sex-symbol" => "sekss5bOl",
"sexagénaire" => "seksaZenER",
"sexagénaires" => "seksaZenER",
"sexe" => "sEks",
"sexes" => "sEks",
"sexisme" => "seksizm",
"sexiste" => "seksist",
"sexistes" => "seksist",
"sexologie" => "seksoloZi",
"sexologique" => "seksoloZik",
"sexologue" => "seksolOg",
"sexologues" => "seksolOg",
"sextant" => "sekst@",
"sextidi" => "sekstidi",
"sextile" => "sekstil",
"sexto" => "sEksto",
"sextuor" => "sekst8OR",
"sextuple" => "sekstypl",
"sexualisé" => "sEks8alize",
"sexualiser" => "sEks8alize",
"sexualité" => "seks8alite",
"sexué" => "seks8e",
"sexuel" => "seks8El",
"sexuelle" => "seks8El",
"sexuellement" => "seks8El°m@",
"sexuelles" => "seks8El",
"sexuels" => "seks8El",
"sexués" => "seks8e",
"sexy" => "seksi",
"seyait" => "sEjE",
"seyant" => "sEj@",
"seyante" => "sEj@t",
"seyantes" => "sEj@t",
"seyants" => "sEj@",
"sézigue" => "sezig",
"shabbat" => "Saba",
"shah" => "Sa",
"shahs" => "Sa",
"shake-hand" => "SEjk@d",
"shaker" => "SEjk9R",
"shakespearien" => "SEkspiRj5",
"shakespearienne" => "SEkspiRjEn",
"shakespeariens" => "SEkspiRj5",
"shako" => "Sako",
"shakos" => "Sako",
"shale" => "Sal",
"shaman" => "Saman",
"shamans" => "Saman",
"shamisen" => "Samiz°n",
"shampoing" => "S@pw5",
"shampoings" => "S@pw5",
"shampooiner" => "S@pwine",
"shampooing" => "S@pw5",
"shampooings" => "S@pw5",
"shampouine" => "S@pwin",
"shampouiné" => "S@pwine",
"shampouiner" => "S@pwine",
"shampouineur" => "S@pwin9R",
"shampouineuse" => "S@pwin2z",
"shampouineuses" => "S@pwin2z",
"shanghaien" => "S@gaj5",
"shanghaiens" => "S@gaj5",
"shantung" => "S@tuG",
"shed" => "SEd",
"shekels" => "SEkEl",
"shéol" => "SeOl",
"shérif" => "SeRif",
"sheriff" => "SERif",
"shérifs" => "SeRif",
"sherpa" => "SERpa",
"sherpas" => "SERpa",
"sherry" => "SERi",
"shetland" => "SEtl@d",
"shetlands" => "SEtl@d",
"shiatsu" => "Sjatsu",
"shift" => "Sift",
"shilling" => "SiliG",
"shillings" => "SiliG",
"shilom" => "SilOm",
"shimmy" => "Simi",
"shingle" => "S5gl",
"shintô" => "Sinto",
"shintoïsme" => "S5toizm",
"shintoïste" => "S5toist",
"shipchandler" => "SipS@dl9R",
"shipping" => "SipiG",
"shirting" => "SiRt5G",
"shit" => "Sit",
"shocking" => "SOkiG",
"shogoun" => "Sogun",
"shogun" => "Sogun",
"shôgun" => "Sogun",
"shogunal" => "Sogynal",
"shogunale" => "Sogynal",
"shogunat" => "SOguna",
"shoot" => "Sut",
"shoota" => "Suta",
"shootai" => "SutE",
"shootais" => "SutE",
"shootait" => "SutE",
"shootant" => "Sut@",
"shoote" => "Sut",
"shooté" => "Sute",
"shootée" => "Sute",
"shootent" => "Sut",
"shooter" => "Sute",
"shootera" => "Sut°Ra",
"shooterai" => "Sut°RE",
"shooteraient" => "Sut°RE",
"shooteras" => "Sut°Ra",
"shootes" => "Sut",
"shootés" => "Sute",
"shooteuse" => "Sut2z",
"shootiez" => "Sutje",
"shootions" => "Sutj§",
"shootons" => "Sut§",
"shoots" => "Sut",
"shopping" => "SOpiG",
"shoppings" => "SOpiG",
"short" => "SORt",
"shorts" => "SORt",
"shoshones" => "SoSon",
"show" => "So",
"show-business" => "SobiznEs",
"showbiz" => "Sobiz",
"shows" => "So",
"shrapnel" => "SRapnEl",
"shrapnell" => "SRapnEl",
"shrapnells" => "SRapnEl",
"shrapnels" => "SRapnEl",
"shunt" => "S9nt",
"shunte" => "S1t",
"shunter" => "S1te",
"si" => "si",
"siam" => "sjam",
"siamois" => "sjamwa",
"siamoise" => "sjamwaz",
"siamoises" => "sjamwaz",
"sibérien" => "sibeRj5",
"sibérienne" => "sibeRjEn",
"sibériennes" => "sibeRjEn",
"sibériens" => "sibeRj5",
"sibilant" => "sibil@",
"sibylle" => "sibil",
"sibylles" => "sibil",
"sibyllin" => "sibil5",
"sibylline" => "sibilin",
"sibyllines" => "sibilin",
"sibyllins" => "sibil5",
"sic" => "sik",
"sic transit gloria mundi" => "siktR@zitgloRjamundi",
"sicaire" => "sikER",
"sicaires" => "sikER",
"sicilien" => "sisilj5",
"sicilienne" => "sisiljEn",
"siciliennes" => "sisiljEn",
"siciliens" => "sisilj5",
"sicle" => "sikl",
"sida" => "sida",
"sidaïque" => "sidaik",
"sidas" => "sida",
"side-car" => "sajdkaR",
"side-cars" => "sajdkaR",
"sidéenne" => "sideEn",
"sidéens" => "side5",
"sidérais" => "sideRE",
"sidérait" => "sideRE",
"sidéral" => "sideRal",
"sidérale" => "sideRal",
"sidérales" => "sideRal",
"sidérant" => "sideR@",
"sidérante" => "sideR@t",
"sidération" => "sideRasj§",
"sidéraux" => "sideRo",
"sidère" => "sidER",
"sidéré" => "sideRe",
"sidérée" => "sideRe",
"sidérées" => "sideRe",
"sidérer" => "sideRe",
"sidérés" => "sideRe",
"sidérite" => "sideRit",
"sidérurgie" => "sideRyRZi",
"sidérurgique" => "sideRyRZik",
"sidérurgiques" => "sideRyRZik",
"sidérurgistes" => "sideRyRZist",
"sidi" => "sidi",
"sidis" => "sidi",
"siècle" => "sjEkl",
"siècles" => "sjEkl",
"sied" => "sje",
"siéent" => "sje",
"siège" => "sjEZ",
"siégé" => "sjeZe",
"siégeaient" => "sjeZE",
"siégeais" => "sjeZE",
"siégeait" => "sjeZE",
"siégeant" => "sjeZ@",
"siègent" => "sjEZ",
"siégeons" => "sjeZ§",
"siéger" => "sjeZe",
"siégera" => "sjeZ°Ra",
"siégerai" => "sjeZ°RE",
"siégeraient" => "sjeZ°RE",
"siégerait" => "sjeZ°RE",
"siégeras" => "sjeZ°Ra",
"siégerons" => "sjeZ°R§",
"siégeront" => "sjeZ°R§",
"sièges" => "sjEZ",
"siégez" => "sjeZe",
"siégiez" => "sjeZje",
"siégions" => "sjeZj§",
"sien" => "sj5",
"sienne" => "sjEn",
"siennes" => "sjEn",
"siennois" => "sjEnwa",
"siennoise" => "sjEnwaz",
"siennoises" => "sjEnwaz",
"siens" => "sj5",
"siéra" => "sjeRa",
"siérait" => "sjeRE",
"sierra" => "sjERa",
"sierras" => "sjERa",
"siesta" => "sjEsta",
"siestant" => "sjEst@",
"sieste" => "sjEst",
"siestes" => "sjEst",
"sieur" => "sj9R",
"sieurs" => "sj9R",
"siffla" => "sifla",
"sifflai" => "siflE",
"sifflaient" => "siflE",
"sifflais" => "siflE",
"sifflait" => "siflE",
"sifflant" => "sifl@",
"sifflante" => "sifl@t",
"sifflantes" => "sifl@t",
"sifflants" => "sifl@",
"sifflard" => "siflaR",
"siffle" => "sifl",
"sifflé" => "sifle",
"sifflée" => "sifle",
"sifflées" => "sifle",
"sifflement" => "sifl°m@",
"sifflements" => "sifl°m@",
"sifflent" => "sifl",
"siffler" => "sifle",
"sifflera" => "sifl°Ra",
"sifflerai" => "sifl°RE",
"siffleraient" => "sifl°RE",
"sifflerait" => "sifl°RE",
"siffleras" => "sifl°Ra",
"sifflèrent" => "siflER",
"siffles" => "sifl",
"sifflés" => "sifle",
"sifflet" => "siflE",
"sifflets" => "siflE",
"siffleur" => "sifl9R",
"sifflez" => "sifle",
"siffliez" => "siflie",
"sifflota" => "siflota",
"sifflotais" => "siflotE",
"sifflotait" => "siflotE",
"sifflotant" => "siflot@",
"sifflote" => "siflOt",
"siffloté" => "siflote",
"sifflotement" => "siflOt°m@",
"siffloter" => "siflote",
"siffloterai" => "siflOt°RE",
"sifflotèrent" => "siflotER",
"sifflotiez" => "siflotje",
"sifflotis" => "siflOti",
"sigillaire" => "siZilER",
"sigillé" => "siZile",
"sigillée" => "siZile",
"sigisbée" => "siZisbe",
"sigisbées" => "siZisbe",
"sigle" => "sigl",
"sigles" => "sigl",
"sigmoïde" => "sigmoid",
"signa" => "siNa",
"signai" => "siNE",
"signaient" => "siNE",
"signais" => "siNE",
"signait" => "siNE",
"signal" => "siNal",
"signala" => "siNala",
"signalai" => "siNalE",
"signalaient" => "siNalE",
"signalais" => "siNalE",
"signalait" => "siNalE",
"signalant" => "siNal@",
"signalât" => "siNala",
"signale" => "siNal",
"signalé" => "siNale",
"signalée" => "siNale",
"signalées" => "siNale",
"signalement" => "siNal°m@",
"signalements" => "siNal°m@",
"signalent" => "siNal",
"signaler" => "siNale",
"signalera" => "siNal°Ra",
"signalerai" => "siNal°RE",
"signalerait" => "siNal°RE",
"signaleront" => "siNal°R§",
"signales" => "siNal",
"signalés" => "siNale",
"signalétique" => "siNaletik",
"signalétiques" => "siNaletik",
"signaleur" => "siNal9R",
"signaleurs" => "siNal9R",
"signalez" => "siNale",
"signalisation" => "siNalizasj§",
"signalisations" => "siNalizasj§",
"signaliser" => "siNalize",
"signalons" => "siNal§",
"signâmes" => "siNam",
"signant" => "siN@",
"signasse" => "siNas",
"signât" => "siNa",
"signataire" => "siNatER",
"signataires" => "siNatER",
"signature" => "siNatyR",
"signatures" => "siNatyR",
"signaux" => "siNo",
"signe" => "siN",
"signé" => "siNe",
"signée" => "siNe",
"signées" => "siNe",
"signent" => "siN",
"signer" => "siNe",
"signera" => "siN°Ra",
"signerai" => "siN°RE",
"signeraient" => "siN°RE",
"signerais" => "siN°RE",
"signerait" => "siN°RE",
"signeras" => "siN°Ra",
"signèrent" => "siNER",
"signerez" => "siN°Re",
"signeriez" => "siN°Rje",
"signerions" => "siN°Rj§",
"signerons" => "siN°R§",
"signeront" => "siN°R§",
"signes" => "siN",
"signés" => "siNe",
"signet" => "siNE",
"signets" => "siNE",
"signez" => "siNe",
"signiez" => "siNe",
"signifia" => "siNifja",
"signifiaient" => "siNifjE",
"signifiais" => "siNifjE",
"signifiait" => "siNifjE",
"signifiance" => "siNifj@s",
"signifiant" => "siNifj@",
"signifiante" => "siNifj@t",
"signifiantes" => "siNifj@t",
"signifiants" => "siNifj@",
"signifiât" => "siNifja",
"significatif" => "siNifikatif",
"significatifs" => "siNifikatif",
"signification" => "siNifikasj§",
"significations" => "siNifikasj§",
"significative" => "siNifikativ",
"significativement" => "siNifikativ°m@",
"significatives" => "siNifikativ",
"signifie" => "siNifi",
"signifié" => "siNifje",
"signifiée" => "siNifje",
"signifiées" => "siNifje",
"signifient" => "siNifi",
"signifier" => "siNifje",
"signifiera" => "siNifiRa",
"signifierai" => "siNifiRE",
"signifierait" => "siNifiRE",
"signifièrent" => "siNifjER",
"signons" => "siN§",
"signor" => "siNOR",
"signora" => "siNoRa",
"signorina" => "siNoRina",
"sikh" => "sik",
"sikhs" => "sik",
"sil" => "sil",
"silence" => "sil@s",
"silences" => "sil@s",
"silencieuse" => "sil@sj2z",
"silencieusement" => "sil@sj2z°m@",
"silencieuses" => "sil@sj2z",
"silencieux" => "sil@sj2",
"silène" => "silEn",
"silènes" => "silEn",
"silésien" => "silezj5",
"silex" => "silEks",
"silhouettait" => "silwEtE",
"silhouettant" => "silwEt@",
"silhouette" => "silwEt",
"silhouetté" => "silwEte",
"silhouettée" => "silwEte",
"silhouettent" => "silwEt",
"silhouetter" => "silwete",
"silhouettes" => "silwEt",
"silicate" => "silikat",
"silice" => "silis",
"silices" => "silis",
"siliceuse" => "silis2z",
"siliceux" => "silis2",
"silicium" => "silisjOm",
"silicone" => "silikOn",
"siliconé" => "silikone",
"siliconée" => "silikone",
"siliconées" => "silikone",
"siliconer" => "silikone",
"silicose" => "silikoz",
"silicosé" => "silikoze",
"silicosée" => "silikoze",
"silionne" => "siljOn",
"sillage" => "sijaZ",
"sillages" => "sijaZ",
"sillet" => "sijE",
"sillon" => "sij§",
"sillonna" => "sijona",
"sillonnaient" => "sijonE",
"sillonnais" => "sijonE",
"sillonnait" => "sijonE",
"sillonnant" => "sijon@",
"sillonne" => "sijOn",
"sillonné" => "sijone",
"sillonnée" => "sijone",
"sillonnées" => "sijone",
"sillonnent" => "sijOn",
"sillonner" => "sijone",
"sillonnèrent" => "sijonER",
"sillonnes" => "sijOn",
"sillonnés" => "sijone",
"sillonnez" => "sijone",
"sillonnons" => "sijon§",
"sillons" => "sij§",
"silo" => "silo",
"silos" => "silo",
"sils" => "sil",
"silvaner" => "silvanER",
"sima" => "sima",
"simagrée" => "simagRe",
"simagrées" => "simagRe",
"simarre" => "simaR",
"simien" => "simj5",
"simienne" => "simjEn",
"simiens" => "simj5",
"simiesque" => "simjEsk",
"simiesques" => "simjEsk",
"similaire" => "similER",
"similairement" => "similER°m@",
"similaires" => "similER",
"similarité" => "similaRite",
"similarités" => "similaRite",
"simili" => "simili",
"similicuir" => "similik8iR",
"similitude" => "similityd",
"similitudes" => "similityd",
"similor" => "similOR",
"similors" => "similOR",
"simoniaque" => "simonjak",
"simoun" => "simun",
"simple" => "s5pl",
"simplement" => "s5pl°m@",
"simples" => "s5pl",
"simplesse" => "s5plEs",
"simplet" => "s5plE",
"simplets" => "s5plE",
"simplette" => "s5plEt",
"simplettes" => "s5plEt",
"simplicité" => "s5plisite",
"simplifiaient" => "s5plifjE",
"simplifiais" => "s5plifjE",
"simplifiait" => "s5plifjE",
"simplifiant" => "s5plifj@",
"simplification" => "s5plifikasj§",
"simplifications" => "s5plifikasj§",
"simplifie" => "s5plifi",
"simplifié" => "s5plifje",
"simplifiée" => "s5plifje",
"simplifiées" => "s5plifje",
"simplifient" => "s5plifi",
"simplifier" => "s5plifje",
"simplifiera" => "s5plifiRa",
"simplifierait" => "s5plifiRE",
"simplifiés" => "s5plifje",
"simplifiez" => "s5plifje",
"simplifions" => "s5plifj§",
"simplissime" => "s5plisim",
"simpliste" => "s5plist",
"simplistes" => "s5plist",
"simula" => "simyla",
"simulacre" => "simylakR",
"simulacres" => "simylakR",
"simulaient" => "simylE",
"simulais" => "simylE",
"simulait" => "simylE",
"simulant" => "simyl@",
"simulateur" => "simylat9R",
"simulateurs" => "simylat9R",
"simulation" => "simylasj§",
"simulations" => "simylasj§",
"simulatrice" => "simylatRis",
"simule" => "simyl",
"simulé" => "simyle",
"simulée" => "simyle",
"simulées" => "simyle",
"simulent" => "simyl",
"simuler" => "simyle",
"simulera" => "simyl°Ra",
"simulerai" => "simyl°RE",
"simulèrent" => "simylER",
"simulerez" => "simyl°Re",
"simules" => "simyl",
"simulés" => "simyle",
"simulez" => "simyle",
"simuliez" => "simylje",
"simulons" => "simyl§",
"simultané" => "simyltane",
"simultanée" => "simyltane",
"simultanées" => "simyltane",
"simultanéité" => "simyltaneite",
"simultanément" => "simyltanem@",
"simultanés" => "simyltane",
"sinapisme" => "sinapizm",
"sinapismes" => "sinapizm",
"sincère" => "s5sER",
"sincèrement" => "s5sER°m@",
"sincères" => "s5sER",
"sincérité" => "s5seRite",
"sinciput" => "s5sipyt",
"sindon" => "s5d§",
"sine die" => "sinedije",
"sine qua non" => "sinekwanOn",
"sinécure" => "sinekyR",
"sinécures" => "sinekyR",
"singe" => "s5Z",
"singé" => "s5Ze",
"singe-araignée" => "s5ZaRENe",
"singea" => "s5Za",
"singeaient" => "s5ZE",
"singeait" => "s5ZE",
"singeant" => "s5Z@",
"singées" => "s5Ze",
"singent" => "s5Z",
"singer" => "s5Ze",
"singerie" => "s5Z°Ri",
"singeries" => "s5Z°Ri",
"singes" => "s5Z",
"singiez" => "s5Zje",
"single" => "sing9l",
"singles" => "s5gl",
"singleton" => "s5gl2t§",
"singularisait" => "s5gylaRizE",
"singularise" => "s5gylaRiz",
"singulariser" => "s5gylaRize",
"singularises" => "s5gylaRiz",
"singularité" => "s5gylaRite",
"singularités" => "s5gylaRite",
"singulier" => "s5gylje",
"singulière" => "s5gyljER",
"singulièrement" => "s5gyljER°m@",
"singulières" => "s5gyljER",
"singuliers" => "s5gylje",
"sinistre" => "sinistR",
"sinistré" => "sinistRe",
"sinistrée" => "sinistRe",
"sinistrées" => "sinistRe",
"sinistrement" => "sinistR°m@",
"sinistres" => "sinistR",
"sinistrés" => "sinistRe",
"sinistrose" => "sinistRoz",
"sino" => "sino",
"sino-américain" => "sinoameRik5",
"sino-arabe" => "sinoaRab",
"sino-japonaise" => "sinoZaponEz",
"sinologie" => "sinoloZi",
"sinon" => "sin§",
"sinople" => "sinOpl",
"sinoque" => "sinOk",
"sinoques" => "sinOk",
"sinoquet" => "sinokE",
"sinuaient" => "sin8E",
"sinuait" => "sin8E",
"sinuant" => "sin8@",
"sinue" => "siny",
"sinué" => "sin8e",
"sinuent" => "siny",
"sinuer" => "sin8e",
"sinueuse" => "sin82z",
"sinueusement" => "sin82z°m@",
"sinueuses" => "sin82z",
"sinueux" => "sin82",
"sinuosité" => "sin8ozite",
"sinuosités" => "sin8ozite",
"sinus" => "sinys",
"sinusal" => "sinyzal",
"sinusale" => "sinyzal",
"sinusite" => "sinyzit",
"sinusites" => "sinyzit",
"sinusoïdal" => "sinyzoidal",
"sinusoïdale" => "sinyzoidal",
"sinusoïdaux" => "sinyzoido",
"sinusoïdes" => "sinyzoid",
"sionisme" => "sjonizm",
"sioniste" => "sjonist",
"sionistes" => "sjonist",
"sioux" => "sju",
"siphon" => "sif§",
"siphonnage" => "sifOnaZ",
"siphonnait" => "sifonE",
"siphonne" => "sifOn",
"siphonné" => "sifone",
"siphonnée" => "sifone",
"siphonner" => "sifone",
"siphonnés" => "sifone",
"siphons" => "sif§",
"sipo" => "sipo",
"sir" => "siR",
"sirdar" => "siRdaR",
"sire" => "siR",
"sirène" => "siREn",
"sirènes" => "siREn",
"sires" => "siR",
"sirocco" => "siRoko",
"sirop" => "siRo",
"sirops" => "siRo",
"sirota" => "siRota",
"sirotaient" => "siRotE",
"sirotais" => "siRotE",
"sirotait" => "siRotE",
"sirotant" => "siRot@",
"sirote" => "siROt",
"siroté" => "siRote",
"sirotent" => "siROt",
"siroter" => "siRote",
"siroterais" => "siROt°RE",
"sirotiez" => "siRotje",
"sirotions" => "siRotj§",
"sirupeuse" => "siRyp2z",
"sirupeuses" => "siRyp2z",
"sirupeux" => "siRyp2",
"sirventès" => "siRv@tEs",
"sis" => "si",
"sisal" => "sizal",
"sise" => "siz",
"sises" => "siz",
"sismique" => "sismik",
"sismiques" => "sismik",
"sismographe" => "sismogRaf",
"sismographes" => "sismogRaf",
"sismologie" => "sismoloZi",
"sismologique" => "sismoloZik",
"sismologue" => "sismOlOg",
"sismologues" => "sismolOg",
"sismomètre" => "sismomEtR",
"sismothérapie" => "sismoteRapi",
"sisymbre" => "siz5bR",
"sit-in" => "sitin",
"sitar" => "sitaR",
"sitariste" => "sitaRist",
"sitcom" => "sitkOm",
"sitcoms" => "sitkOm",
"site" => "sit",
"sites" => "sit",
"sitôt" => "sito",
"sittelle" => "sitEl",
"situ" => "sity",
"situa" => "sit8a",
"situable" => "sit8abl",
"situaient" => "sit8E",
"situais" => "sit8E",
"situait" => "sit8E",
"situant" => "sit8@",
"situasse" => "sit8as",
"situât" => "sit8a",
"situation" => "sit8asj§",
"situationnel" => "sit8asjOnEl",
"situationnisme" => "sit8asjonizm",
"situationnistes" => "sit8asjonist",
"situations" => "sit8asj§",
"situe" => "sity",
"situé" => "sit8e",
"située" => "sit8e",
"situées" => "sit8e",
"situent" => "sity",
"situer" => "sit8e",
"situera" => "sityRa",
"situerai" => "sityRE",
"situeraient" => "sityRE",
"situerais" => "sityRE",
"situerait" => "sityRE",
"situèrent" => "sit8ER",
"situes" => "sity",
"situés" => "sit8e",
"situez" => "sitye",
"situions" => "sityj§",
"situons" => "sit8§",
"six" => "sis",
"six-quatre" => "siskatR",
"sixain" => "siks5",
"sixième" => "sizjEm",
"sixièmement" => "sizjEm°m@",
"sixièmes" => "sizjEm",
"sixte" => "sikst",
"sixties" => "sikstiz",
"sixtus" => "sikstys",
"sizain" => "siz5",
"ska" => "ska",
"skaal" => "skal",
"skaï" => "skaj",
"skate" => "skEjt",
"skate-board" => "skEjtbORd",
"skateboard" => "skEjtbORd",
"skateboards" => "skEjtbORd",
"skates" => "skEt",
"skating" => "skEjtiG",
"skeet" => "skit",
"skeets" => "skit",
"sketch" => "skEtS",
"sketches" => "skEtS",
"sketchs" => "skEtS",
"ski" => "ski",
"skiable" => "skjabl",
"skiais" => "skjE",
"skiait" => "skjE",
"skiant" => "ski@",
"skie" => "ski",
"skié" => "skje",
"skient" => "ski",
"skier" => "skje",
"skierai" => "skiRE",
"skierait" => "skiRE",
"skies" => "ski",
"skieur" => "skj9R",
"skieurs" => "skj9R",
"skieuse" => "skj2z",
"skieuses" => "skj2z",
"skiez" => "skje",
"skiff" => "skif",
"skiffs" => "skif",
"skin" => "skin",
"skinhead" => "skjEd",
"skinheads" => "skjEd",
"skins" => "skin",
"skip" => "skip",
"skipper" => "skip9R",
"skis" => "ski",
"skunks" => "sk§s",
"skydome" => "skajdom",
"slalom" => "slalOm",
"slalomant" => "slalom@",
"slalomé" => "slalome",
"slalomer" => "slalome",
"slaloms" => "slalOm",
"slang" => "sl@g",
"slash" => "slaS",
"slave" => "slav",
"slaves" => "slav",
"slavisant" => "slaviz@",
"slavisme" => "slavizm",
"slavon" => "slav§",
"slavophiles" => "slavofil",
"sleeping" => "slipiG",
"sleepings" => "slipiG",
"slibard" => "slibaR",
"slice" => "slis",
"slip" => "slip",
"slips" => "slip",
"slogan" => "slog@",
"slogans" => "slog@",
"sloop" => "slup",
"sloughi" => "slugi",
"slovaque" => "slovak",
"slovaques" => "slovak",
"slovène" => "slovEn",
"slow" => "slo",
"slows" => "slo",
"slug" => "sl9g",
"slush" => "sl9S",
"smack" => "smak",
"smacks" => "smak",
"smala" => "smala",
"smalah" => "smala",
"smaragdin" => "smaRagd5",
"smart" => "smaRt",
"smash" => "smaS",
"smashe" => "smaS",
"smasher" => "smaSe",
"smegma" => "smEgma",
"smicard" => "smikaR",
"smicards" => "smikaR",
"smigard" => "smigaR",
"smiley" => "smajli",
"smocks" => "smok",
"smog" => "smOg",
"smoking" => "smOkiG",
"smokings" => "smOkiG",
"smorrebrod" => "smoR°bRod",
"smurf" => "sm9Rf",
"smyrniote" => "smiRnjOt",
"snack" => "snak",
"snack-bar" => "snakbaR",
"snack-bars" => "snakbaR",
"snacks" => "snak",
"snif" => "snif",
"snifer" => "snife",
"sniff" => "snif",
"sniffaient" => "snifE",
"sniffais" => "snifE",
"sniffait" => "snifE",
"sniffant" => "snif@",
"sniffe" => "snif",
"sniffé" => "snife",
"sniffée" => "snife",
"sniffées" => "snife",
"sniffent" => "snif",
"sniffer" => "snife",
"snifferai" => "snif°RE",
"sniffes" => "snif",
"sniffette" => "snifEt",
"sniffez" => "snife",
"snipe" => "snip",
"sniper" => "snajp9R",
"snipers" => "snipER",
"snob" => "snOb",
"snobaient" => "snobE",
"snobais" => "snobE",
"snobe" => "snOb",
"snobé" => "snobe",
"snobée" => "snobe",
"snobent" => "snOb",
"snober" => "snobe",
"snoberez" => "snOb°Re",
"snobés" => "snobe",
"snobez" => "snobe",
"snobinard" => "snobinaR",
"snobinarde" => "snobinaRd",
"snobinardes" => "snobinaRd",
"snobinards" => "snobinaR",
"snobisme" => "snobizm",
"snobismes" => "snobizm",
"snobs" => "snOb",
"snow-boots" => "snobuts",
"soap opéra" => "sOwpopeRa",
"soap-opéra" => "sOwpopeRa",
"sobre" => "sObR",
"sobrement" => "sObR°m@",
"sobres" => "sObR",
"sobriété" => "sobRijete",
"sobriquet" => "sobRikE",
"sobriquets" => "sobRikE",
"soc" => "sOk",
"soccer" => "sOs9R",
"sociabiliser" => "sOsjabilize",
"sociabilité" => "sosjabilite",
"sociable" => "sosjabl",
"sociables" => "sosjabl",
"social" => "sosjal",
"social-démocrate" => "sosjaldemokRat",
"social-démocratie" => "sosjaldemokRasi",
"social-traître" => "sOsjaltREtR",
"sociale" => "sosjal",
"socialement" => "sosjal°m@",
"sociales" => "sosjal",
"socialisation" => "sOsjalizasj§",
"socialise" => "sosjaliz",
"socialiser" => "sosjalize",
"socialisez" => "sosjalize",
"socialisme" => "sosjalizm",
"socialismes" => "sosjalizm",
"socialiste" => "sosjalist",
"socialistes" => "sosjalist",
"socialo" => "sOsjalo",
"socialos" => "sosjalo",
"sociaux" => "sosjo",
"sociaux-démocrates" => "sosjodemokRat",
"sociétaire" => "sosjetER",
"sociétaires" => "sosjetER",
"sociétal" => "sOsjetal",
"sociétale" => "sOsjetal",
"société" => "sosjete",
"sociétés" => "sosjete",
"sociniens" => "sosinj5",
"socio" => "sosjo",
"socio-culturelles" => "sosjokyltyREl",
"socio-culturels" => "sosjokyltyREl",
"socio-économique" => "sosjoekonomik",
"socio-économiques" => "sosjoekonomik",
"sociobiologie" => "sosjobjoloZi",
"socioculturel" => "sosjokyltyREl",
"socioculturelles" => "sosjokyltyREl",
"sociologie" => "sosjoloZi",
"sociologique" => "sosjoloZik",
"sociologiquement" => "sosjoloZik°m@",
"sociologiques" => "sosjoloZik",
"sociologue" => "sosjolOg",
"sociologues" => "sosjolOg",
"sociopathe" => "sosjopat",
"sociopathes" => "sosjopat",
"sociopathie" => "sOsjopati",
"sociopolitique" => "sOsjopOlitik",
"socius" => "sOsjys",
"socket" => "sOkEt",
"socle" => "sOkl",
"socles" => "sOkl",
"socque" => "sOk",
"socques" => "sOk",
"socquette" => "sokEt",
"socquettes" => "sokEt",
"socratique" => "sokRatik",
"socratiques" => "sokRatik",
"socs" => "sOk",
"soda" => "soda",
"sodas" => "soda",
"sodique" => "sOdik",
"sodium" => "sodjOm",
"sodomie" => "sodomi",
"sodomisa" => "sodomiza",
"sodomisait" => "sodomizE",
"sodomisant" => "sodomiz@",
"sodomisation" => "sodomizasj§",
"sodomise" => "sodomiz",
"sodomisé" => "sodomize",
"sodomisée" => "sodomize",
"sodomiser" => "sodomize",
"sodomiseront" => "sodomiz°R§",
"sodomisés" => "sodomize",
"sodomisez" => "sodomize",
"sodomite" => "sodomit",
"sodomites" => "sodomit",
"sodomitiques" => "sodomitik",
"soeur" => "s9R",
"soeurette" => "s9REt",
"soeurs" => "s9R",
"sofa" => "sofa",
"sofas" => "sofa",
"soft" => "sOft",
"softball" => "sOftbal",
"soi" => "swa",
"soi-disant" => "swadiz@",
"soi-même" => "swamEm",
"soie" => "swa",
"soient" => "swa",
"soierie" => "swaRi",
"soieries" => "swaRi",
"soies" => "swa",
"soif" => "swaf",
"soiffard" => "swafaR",
"soiffarde" => "swafaRd",
"soiffards" => "swafaR",
"soifs" => "swaf",
"soigna" => "swaNa",
"soignable" => "swaNabl",
"soignai" => "swaNE",
"soignaient" => "swaNE",
"soignais" => "swaNE",
"soignait" => "swaNE",
"soignant" => "swaN@",
"soignante" => "swaN@t",
"soignantes" => "swaN@t",
"soignants" => "swaN@",
"soigne" => "swaN",
"soigné" => "swaNe",
"soignée" => "swaNe",
"soignées" => "swaNe",
"soignent" => "swaN",
"soigner" => "swaNe",
"soignera" => "swaN°Ra",
"soignerai" => "swaN°RE",
"soigneraient" => "swaN°RE",
"soignerais" => "swaN°RE",
"soignerait" => "swaN°RE",
"soigneras" => "swaN°Ra",
"soignèrent" => "swaNER",
"soignerez" => "swaN°Re",
"soignerons" => "swaN°R§",
"soigneront" => "swaN°R§",
"soignes" => "swaN",
"soignés" => "swaNe",
"soigneur" => "swaN9R",
"soigneurs" => "swaN9R",
"soigneuse" => "swaN2z",
"soigneusement" => "swaN2z°m@",
"soigneuses" => "swaN2z",
"soigneux" => "swaN2",
"soignez" => "swaNe",
"soigniez" => "swaNe",
"soignons" => "swaN§",
"soin" => "sw5",
"soins" => "sw5",
"soir" => "swaR",
"soirée" => "swaRe",
"soirées" => "swaRe",
"soirs" => "swaR",
"sois" => "swa",
"soissonnais" => "swasonE",
"soit" => "swa",
"soixantaine" => "swas@tEn",
"soixante" => "swas@t",
"soixante-cinq" => "swas@ts5k",
"soixante-deux" => "swas@td2",
"soixante-deuxième" => "swas@td2zjEm",
"soixante-dix" => "swas@tdis",
"soixante-dix-huit" => "swas@tdiz8it",
"soixante-dix-neuf" => "swas@tdizn9f",
"soixante-dix-neuvième" => "swas@tdisn9vjEm",
"soixante-dix-sept" => "swas@tdisEt",
"soixante-dixième" => "swas@tdizjEm",
"soixante-douze" => "swas@tduz",
"soixante-huit" => "swas@t8it",
"soixante-huitard" => "swas@t8itaR",
"soixante-huitarde" => "swas@t°8itaRd",
"soixante-huitards" => "swas@t°8itaR",
"soixante-neuf" => "swas@tn9f",
"soixante-quatorze" => "swas@tkatORz",
"soixante-quatre" => "swas@tkatR",
"soixante-quinze" => "swas@tk5z",
"soixante-seize" => "swas@tsEz",
"soixante-sept" => "swas@tsEt",
"soixante-six" => "swas@tsis",
"soixante-treize" => "swas@ttREz",
"soixante-trois" => "swas@ttRwa",
"soixantième" => "swas@tjEm",
"soja" => "soZa",
"sol" => "sOl",
"sol-air" => "sOlER",
"solaire" => "solER",
"solaires" => "solER",
"solanacée" => "solanase",
"solanacées" => "solanase",
"solarium" => "solaRjOm",
"solariums" => "solaRjOm",
"solda" => "sOlda",
"soldaient" => "sOldE",
"soldait" => "sOldE",
"soldat" => "sOlda",
"soldât" => "sOlda",
"soldate" => "sOldat",
"soldatesque" => "sOldatEsk",
"soldats" => "sOlda",
"solde" => "sOld",
"soldé" => "sOlde",
"soldée" => "sOlde",
"soldées" => "sOlde",
"soldent" => "sOld",
"solder" => "sOlde",
"soldera" => "sOld°Ra",
"solderais" => "sOld°RE",
"solderait" => "sOld°RE",
"soldèrent" => "sOldER",
"solderie" => "sOld°Ri",
"soldes" => "sOld",
"soldés" => "sOlde",
"soldeur" => "sOld9R",
"soldeurs" => "sOld9R",
"soldez" => "sOlde",
"sole" => "sOl",
"solécismes" => "solesizm",
"soleil" => "solEj",
"soleil-roi" => "solEjRwa",
"soleilleux" => "solEj2",
"soleils" => "solEj",
"solen" => "solEn",
"solennel" => "solanEl",
"solennelle" => "solanEl",
"solennellement" => "solanEl°m@",
"solennelles" => "solanEl",
"solennels" => "solanEl",
"solenniser" => "sOlanize",
"solennisèrent" => "solanizER",
"solennité" => "solanite",
"solennités" => "solanite",
"solénoïde" => "sOlenOid",
"solénoïdes" => "solenoid",
"soles" => "sOl",
"solex" => "solEks",
"solfatares" => "solfataR",
"solfège" => "solfEZ",
"soli" => "soli",
"solicitor" => "solisitOR",
"solicitors" => "solisitOR",
"solidaire" => "solidER",
"solidairement" => "solidER°m@",
"solidaires" => "solidER",
"solidariser" => "solidaRize",
"solidarisez" => "solidaRize",
"solidarité" => "solidaRite",
"solidarités" => "solidaRite",
"solide" => "solid",
"solidement" => "solid°m@",
"solides" => "solid",
"solidifia" => "solidifja",
"solidifiait" => "solidifjE",
"solidification" => "sOlidifikasj§",
"solidifie" => "solidifi",
"solidifié" => "solidifje",
"solidifiée" => "solidifje",
"solidifiées" => "solidifje",
"solidifient" => "solidifi",
"solidifier" => "solidifje",
"solidifiés" => "solidifje",
"solidité" => "solidite",
"solidus" => "solidys",
"soliflore" => "soliflOR",
"soliloqua" => "soliloka",
"soliloquait" => "solilokE",
"soliloque" => "solilOk",
"soliloquer" => "soliloke",
"soliloques" => "solilOk",
"solipsisme" => "solipsizm",
"solipsiste" => "solipsist",
"soliste" => "solist",
"solistes" => "solist",
"solitaire" => "solitER",
"solitairement" => "solitER°m@",
"solitaires" => "solitER",
"solitude" => "solityd",
"solitudes" => "solityd",
"solive" => "soliv",
"soliveau" => "solivo",
"solives" => "soliv",
"sollicita" => "solisita",
"sollicitai" => "solisitE",
"sollicitaient" => "solisitE",
"sollicitais" => "solisitE",
"sollicitait" => "solisitE",
"sollicitant" => "solisit@",
"sollicitât" => "solisita",
"sollicitation" => "solisitasj§",
"sollicitations" => "solisitasj§",
"sollicite" => "solisit",
"sollicité" => "solisite",
"sollicitée" => "solisite",
"sollicitées" => "solisite",
"sollicitent" => "solisit",
"solliciter" => "solisite",
"sollicitera" => "solisit°Ra",
"solliciteraient" => "solisit°RE",
"sollicitèrent" => "solisitER",
"sollicités" => "solisite",
"solliciteur" => "solisit9R",
"solliciteurs" => "solisit9R",
"solliciteuse" => "solisit2z",
"sollicitez" => "solisite",
"sollicitons" => "solisit§",
"sollicitude" => "solisityd",
"sollicitudes" => "solisityd",
"solo" => "solo",
"solognot" => "soloNo",
"solognote" => "soloNOt",
"solognots" => "soloNo",
"solos" => "solo",
"sols" => "sOl",
"solstice" => "sOlstis",
"solstices" => "sOlstis",
"solubilité" => "sOlybilite",
"soluble" => "solybl",
"solubles" => "solybl",
"solucamphre" => "sOlyk@fR",
"soluté" => "solyte",
"solutés" => "solyte",
"solution" => "solysj§",
"solutionnait" => "solysjonE",
"solutionner" => "solysjone",
"solutionneur" => "solysjon9R",
"solutionnons" => "solysjon§",
"solutions" => "solysj§",
"solvabilité" => "sOlvabilite",
"solvable" => "sOlvabl",
"solvant" => "sOlv@",
"solvants" => "sOlv@",
"soma" => "soma",
"somalien" => "somalj5",
"somalienne" => "sOmaljEn",
"somaliens" => "somalj5",
"somalis" => "somali",
"somatique" => "somatik",
"somatiques" => "somatik",
"somatisant" => "somatiz@",
"somatise" => "somatiz",
"somatisée" => "somatize",
"somatiser" => "somatize",
"somatiserez" => "somatiz°Re",
"sombra" => "s§bRa",
"sombrai" => "s§bRE",
"sombraient" => "s§bRE",
"sombrais" => "s§bRE",
"sombrait" => "s§bRE",
"sombrant" => "s§bR@",
"sombre" => "s§bR",
"sombré" => "s§bRe",
"sombrée" => "s§bRe",
"sombrées" => "s§bRe",
"sombrement" => "s§bR°m@",
"sombrent" => "s§bR",
"sombrer" => "s§bRe",
"sombrera" => "s§bR°Ra",
"sombreraient" => "s§bR°RE",
"sombrerais" => "s§bR°RE",
"sombrerait" => "s§bR°RE",
"sombrèrent" => "s§bRER",
"sombrerez" => "s§bR°Re",
"sombrero" => "s§bReRo",
"sombrerons" => "s§bR°R§",
"sombreros" => "s§bR°Ro",
"sombres" => "s§bR",
"sombrés" => "s§bRe",
"sombrez" => "s§bRe",
"sombrions" => "s§bRij§",
"sombrons" => "s§bR§",
"somma" => "soma",
"sommai" => "somE",
"sommaire" => "somER",
"sommairement" => "somER°m@",
"sommaires" => "somER",
"sommais" => "somE",
"sommait" => "somE",
"sommant" => "som@",
"sommation" => "somasj§",
"sommations" => "somasj§",
"somme" => "sOm",
"sommé" => "some",
"sommée" => "some",
"sommeil" => "somEj",
"sommeilla" => "somEja",
"sommeillaient" => "somEjE",
"sommeillais" => "somEjE",
"sommeillait" => "somEjE",
"sommeillant" => "somEj@",
"sommeillante" => "somEj@t",
"sommeillants" => "somEj@",
"sommeille" => "somEj",
"sommeillé" => "someje",
"sommeillent" => "somEj",
"sommeiller" => "someje",
"sommeillèrent" => "somEjER",
"sommeilleux" => "somEj2",
"sommeils" => "somEj",
"sommelier" => "sOm°lje",
"somment" => "sOm",
"sommer" => "some",
"sommèrent" => "somER",
"sommes" => "sOm",
"sommés" => "some",
"sommet" => "somE",
"sommets" => "somE",
"sommier" => "somje",
"sommiers" => "somje",
"sommiez" => "somje",
"sommitales" => "somital",
"sommité" => "somite",
"sommités" => "somite",
"sommons" => "som§",
"somnambulant" => "sOmn@byl@",
"somnambule" => "sOmn@byl",
"somnambules" => "sOmn@byl",
"somnambulique" => "sOmn@bylik",
"somnambuliquement" => "sOmn@bylik°m@",
"somnambuliques" => "sOmn@bylik",
"somnambulisme" => "sOmn@bylizm",
"somnifère" => "sOmnifER",
"somnifères" => "sOmnifER",
"somno" => "sOmno",
"somnola" => "sOmnola",
"somnolai" => "sOmnolE",
"somnolaient" => "sOmnolE",
"somnolais" => "sOmnolE",
"somnolait" => "sOmnolE",
"somnolant" => "sOmnol@",
"somnole" => "sOmnOl",
"somnolé" => "sOmnole",
"somnolence" => "sOmnol@s",
"somnolences" => "sOmnol@s",
"somnolent" => "sOmnOl@",
"somnolente" => "sOmnol@t",
"somnolentes" => "sOmnol@t",
"somnolents" => "sOmnol@",
"somnoler" => "sOmnole",
"somnolerais" => "sOmnOl°RE",
"somnolez" => "sOmnole",
"somozistes" => "somozist",
"somptuaire" => "s§pt8ER",
"somptuaires" => "s§pt8ER",
"somptueuse" => "s§pt82z",
"somptueusement" => "s§pt82z°m@",
"somptueuses" => "s§pt82z",
"somptueux" => "s§pt82",
"somptuosité" => "s§pt8ozite",
"somptuosités" => "s§pt8ozite",
"son" => "s§",
"sonagramme" => "sOnagRam",
"sonar" => "sonaR",
"sonars" => "sonaR",
"sonate" => "sonat",
"sonates" => "sonat",
"sonatine" => "sonatin",
"sonda" => "s§da",
"sondage" => "s§daZ",
"sondages" => "s§daZ",
"sondaient" => "s§dE",
"sondait" => "s§dE",
"sondant" => "s§d@",
"sondas" => "s§da",
"sonde" => "s§d",
"sondé" => "s§de",
"sondée" => "s§de",
"sondent" => "s§d",
"sonder" => "s§de",
"sonderai" => "s§d°RE",
"sondèrent" => "s§dER",
"sondes" => "s§d",
"sondés" => "s§de",
"sondeur" => "s§d9R",
"sondeurs" => "s§d9R",
"sondeuse" => "s§d2z",
"sondez" => "s§de",
"sondions" => "s§dj§",
"sondons" => "s§d§",
"song" => "s§g",
"songe" => "s§Z",
"songé" => "s§Ze",
"songe-creux" => "s§ZkR2",
"songea" => "s§Za",
"songeai" => "s§ZE",
"songeaient" => "s§ZE",
"songeais" => "s§ZE",
"songeait" => "s§ZE",
"songeant" => "s§Z@",
"songeasse" => "s§Zas",
"songeât" => "s§Za",
"songent" => "s§Z",
"songeons" => "s§Z§",
"songer" => "s§Ze",
"songera" => "s§Z°Ra",
"songerai" => "s§Z°RE",
"songeraient" => "s§Z°RE",
"songerais" => "s§Z°RE",
"songerait" => "s§Z°RE",
"songèrent" => "s§ZER",
"songerie" => "s§Z°Ri",
"songeries" => "s§Z°Ri",
"songeriez" => "s§Z°Rje",
"songerons" => "s§Z°R§",
"songes" => "s§Z",
"songeur" => "s§Z9R",
"songeurs" => "s§Z9R",
"songeuse" => "s§Z2z",
"songeusement" => "s§Z2z°m@",
"songeuses" => "s§Z2z",
"songez" => "s§Ze",
"songiez" => "s§Zje",
"songions" => "s§Zj§",
"sonique" => "sonik",
"soniques" => "sonik",
"sonna" => "sona",
"sonnai" => "sonE",
"sonnaient" => "sonE",
"sonnaillaient" => "sonajE",
"sonnaille" => "sonaj",
"sonnailler" => "sonaje",
"sonnailles" => "sonaj",
"sonnais" => "sonE",
"sonnait" => "sonE",
"sonnant" => "son@",
"sonnante" => "son@t",
"sonnantes" => "son@t",
"sonnants" => "son@",
"sonnât" => "sona",
"sonne" => "sOn",
"sonné" => "sone",
"sonnée" => "sone",
"sonnées" => "sone",
"sonnent" => "sOn",
"sonner" => "sone",
"sonnera" => "sOn°Ra",
"sonnerai" => "sOn°RE",
"sonnerais" => "sOn°RE",
"sonnerait" => "sOn°RE",
"sonneras" => "sOn°Ra",
"sonnèrent" => "sonER",
"sonnerez" => "sOn°Re",
"sonnerie" => "sOn°Ri",
"sonneries" => "sOn°Ri",
"sonneront" => "sOn°R§",
"sonnes" => "sOn",
"sonnés" => "sone",
"sonnet" => "sonE",
"sonnets" => "sonE",
"sonnette" => "sonEt",
"sonnettes" => "sonEt",
"sonneur" => "son9R",
"sonneurs" => "son9R",
"sonnez" => "sone",
"sonniez" => "sonje",
"sonnons" => "son§",
"sono" => "sono",
"sonoluminescence" => "sonolyminEs@s",
"sonomètres" => "sonomEtR",
"sonore" => "sonOR",
"sonorement" => "sOnOR°m@",
"sonores" => "sonOR",
"sonorisateurs" => "sonoRizat9R",
"sonorisation" => "sonoRizasj§",
"sonorise" => "sonoRiz",
"sonorisé" => "sonoRize",
"sonorisées" => "sonoRize",
"sonoriser" => "sonoRize",
"sonorité" => "sonoRite",
"sonorités" => "sonoRite",
"sonos" => "sono",
"sonothèque" => "sOnOtEk",
"sonotone" => "sonotOn",
"sonotones" => "sonotOn",
"sons" => "s§",
"sont" => "s§",
"sopha" => "sOfa",
"sophie" => "sOfi",
"sophisme" => "sofizm",
"sophismes" => "sofizm",
"sophiste" => "sofist",
"sophistes" => "sofist",
"sophistication" => "sofistikasj§",
"sophistications" => "sofistikasj§",
"sophistique" => "sOfistik",
"sophistiqué" => "sofistike",
"sophistiquée" => "sofistike",
"sophistiquées" => "sofistike",
"sophistiqués" => "sofistike",
"sophora" => "sofoRa",
"sopor" => "sopOR",
"soporifique" => "sopoRifik",
"soporifiques" => "sopoRifik",
"soprano" => "sopRano",
"sopranos" => "sopRano",
"sorbes" => "sORb",
"sorbet" => "sORbE",
"sorbetière" => "sORb°tjER",
"sorbetières" => "sORb°tjER",
"sorbets" => "sORbE",
"sorbier" => "sORbje",
"sorbiers" => "sORbje",
"sorbitol" => "sORbitOl",
"sorbonnarde" => "sORbonaRd",
"sorbonne" => "sORbOn",
"sorcellerie" => "sORsEl°Ri",
"sorcelleries" => "sORsEl°Ri",
"sorcier" => "sORsje",
"sorcière" => "sORsjER",
"sorcières" => "sORsjER",
"sorciers" => "sORsje",
"sordide" => "sORdid",
"sordidement" => "sORdid°m@",
"sordides" => "sORdid",
"sordidité" => "sORdidite",
"sorgho" => "sORgo",
"sorite" => "sORit",
"sornette" => "sORnEt",
"sornettes" => "sORnEt",
"sororal" => "soRoRal",
"sororale" => "soRoRal",
"sororales" => "soRoRal",
"sororité" => "soRoRite",
"sors" => "sOR",
"sort" => "sOR",
"sortable" => "sORtabl",
"sortables" => "sORtabl",
"sortaient" => "sORtE",
"sortais" => "sORtE",
"sortait" => "sORtE",
"sortant" => "sORt@",
"sortante" => "sORt@t",
"sortantes" => "sORt@t",
"sortants" => "sORt@",
"sorte" => "sORt",
"sortent" => "sORt",
"sortes" => "sORt",
"sortez" => "sORte",
"sorti" => "sORti",
"sortie" => "sORti",
"sorties" => "sORti",
"sortiez" => "sORtje",
"sortilège" => "sORtilEZ",
"sortilèges" => "sORtilEZ",
"sortîmes" => "sORtim",
"sortions" => "sORtj§",
"sortir" => "sORtiR",
"sortira" => "sORtiRa",
"sortirai" => "sORtiRE",
"sortiraient" => "sORtiRE",
"sortirais" => "sORtiRE",
"sortirait" => "sORtiRE",
"sortiras" => "sORtiRa",
"sortirent" => "sORtiR",
"sortirez" => "sORtiRe",
"sortiriez" => "sORtiRje",
"sortirions" => "sORtiRj§",
"sortirons" => "sORtiR§",
"sortiront" => "sORtiR§",
"sortis" => "sORti",
"sortit" => "sORti",
"sortît" => "sORti",
"sortons" => "sORt§",
"sorts" => "sOR",
"sosie" => "sozi",
"sosies" => "sozi",
"sostenuto" => "sOstenuto",
"sot" => "so",
"sotie" => "soti",
"sots" => "so",
"sotte" => "sOt",
"sottement" => "sOt°m@",
"sottes" => "sOt",
"sottise" => "sotiz",
"sottises" => "sotiz",
"sou" => "su",
"souabe" => "swab",
"souabes" => "swab",
"soubassement" => "subas°m@",
"soubassements" => "subas°m@",
"soubise" => "subiz",
"soubresaut" => "subR°so",
"soubresautaient" => "subR°sotE",
"soubresautait" => "subR°sotE",
"soubresauts" => "subR°so",
"soubrette" => "subREt",
"soubrettes" => "subREt",
"souche" => "suS",
"souches" => "suS",
"souchet" => "suSE",
"souchette" => "suSEt",
"souci" => "susi",
"soucia" => "susja",
"souciai" => "susjE",
"souciaient" => "susjE",
"souciais" => "susjE",
"souciait" => "susjE",
"souciant" => "susj@",
"souciât" => "susja",
"soucie" => "susi",
"soucié" => "susje",
"souciée" => "susje",
"souciées" => "susje",
"soucient" => "susi",
"soucier" => "susje",
"souciera" => "susiRa",
"soucierai" => "susiRE",
"soucieraient" => "susiRE",
"soucierais" => "susiRE",
"soucierait" => "susiRE",
"soucièrent" => "susjER",
"soucierez" => "susiRe",
"soucies" => "susi",
"souciés" => "susje",
"soucieuse" => "susj2z",
"soucieuses" => "susj2z",
"soucieux" => "susj2",
"souciez" => "susje",
"soucions" => "susj§",
"soucis" => "susi",
"soucoupe" => "sukup",
"soucoupes" => "sukup",
"soudage" => "sudaZ",
"soudaient" => "sudE",
"soudain" => "sud5",
"soudaine" => "sudEn",
"soudainement" => "sudEn°m@",
"soudaines" => "sudEn",
"soudaineté" => "sudEn°te",
"soudains" => "sud5",
"soudait" => "sudE",
"soudanais" => "sudanE",
"soudanaise" => "sudanEz",
"soudant" => "sud@",
"soudard" => "sudaR",
"soudards" => "sudaR",
"soude" => "sud",
"soudé" => "sude",
"soudée" => "sude",
"soudées" => "sude",
"soudent" => "sud",
"souder" => "sude",
"souderait" => "sud°RE",
"soudèrent" => "sudER",
"soudés" => "sude",
"soudeur" => "sud9R",
"soudeurs" => "sud9R",
"soudeuse" => "sud2z",
"soudez" => "sude",
"soudoie" => "sudwa",
"soudoya" => "sudwaja",
"soudoyaient" => "sudwajE",
"soudoyait" => "sudwajE",
"soudoyant" => "sudwaj@",
"soudoyé" => "sudwaje",
"soudoyée" => "sudwaje",
"soudoyer" => "sudwaje",
"soudoyés" => "sudwaje",
"soudoyez" => "sudwaje",
"soudure" => "sudyR",
"soudures" => "sudyR",
"soue" => "su",
"souffert" => "sufER",
"soufferte" => "sufERt",
"souffertes" => "sufERt",
"soufferts" => "sufER",
"souffla" => "sufla",
"soufflages" => "suflaZ",
"soufflai" => "suflE",
"soufflaient" => "suflE",
"soufflais" => "suflE",
"soufflait" => "suflE",
"soufflant" => "sufl@",
"soufflante" => "sufl@t",
"soufflants" => "sufl@",
"soufflât" => "sufla",
"souffle" => "sufl",
"soufflé" => "sufle",
"soufflée" => "sufle",
"soufflées" => "sufle",
"soufflement" => "sufl°m@",
"soufflements" => "sufl°m@",
"soufflent" => "sufl",
"souffler" => "sufle",
"soufflera" => "sufl°Ra",
"soufflerai" => "sufl°RE",
"soufflerais" => "sufl°RE",
"soufflerait" => "sufl°RE",
"soufflèrent" => "suflER",
"soufflerez" => "sufl°Re",
"soufflerie" => "sufl°Ri",
"souffleront" => "sufl°R§",
"souffles" => "sufl",
"soufflés" => "sufle",
"soufflet" => "suflE",
"souffletai" => "sufl°tE",
"souffletaient" => "sufl°tE",
"souffletait" => "sufl°tE",
"souffletant" => "sufl°t@",
"souffleté" => "sufl°te",
"souffletée" => "sufl°te",
"souffleter" => "sufl°te",
"souffletés" => "sufl°te",
"soufflets" => "suflE",
"soufflette" => "suflEt",
"soufflettent" => "suflEt",
"soufflettes" => "suflEt",
"souffleur" => "sufl9R",
"souffleurs" => "sufl9R",
"souffleuse" => "sufl2z",
"soufflez" => "sufle",
"soufflons" => "sufl§",
"soufflure" => "suflyR",
"soufflures" => "suflyR",
"souffraient" => "sufRE",
"souffrais" => "sufRE",
"souffrait" => "sufRE",
"souffrance" => "sufR@s",
"souffrances" => "sufR@s",
"souffrant" => "sufR@",
"souffrante" => "sufR@t",
"souffrantes" => "sufR@t",
"souffrants" => "sufR@",
"souffre" => "sufR",
"souffre-douleur" => "sufR°dul9R",
"souffrent" => "sufR",
"souffres" => "sufR",
"souffreteuse" => "sufR°t2z",
"souffreteuses" => "sufR°t2z",
"souffreteux" => "sufR°t2",
"souffrez" => "sufRe",
"souffriez" => "sufRije",
"souffrions" => "sufRij§",
"souffrir" => "sufRiR",
"souffrira" => "sufRiRa",
"souffrirai" => "sufRiRE",
"souffriraient" => "sufRiRE",
"souffrirais" => "sufRiRE",
"souffrirait" => "sufRiRE",
"souffriras" => "sufRiRa",
"souffrirent" => "sufRiR",
"souffrirez" => "sufRiRe",
"souffririez" => "sufRiRje",
"souffririons" => "sufRiRj§",
"souffrirons" => "sufRiR§",
"souffriront" => "sufRiR§",
"souffris" => "sufRi",
"souffrisse" => "sufRis",
"souffrissent" => "sufRis",
"souffrit" => "sufRi",
"souffrît" => "sufRi",
"souffrons" => "sufR§",
"soufi" => "sufi",
"soufis" => "sufi",
"soufrages" => "sufRaZ",
"soufre" => "sufR",
"soufré" => "sufRe",
"soufrée" => "sufRe",
"soufrées" => "sufRe",
"soufrés" => "sufRe",
"souhait" => "swE",
"souhaita" => "swEta",
"souhaitable" => "swEtabl",
"souhaitables" => "swEtabl",
"souhaitai" => "swEtE",
"souhaitaient" => "swEtE",
"souhaitais" => "swEtE",
"souhaitait" => "swEtE",
"souhaitâmes" => "swEtam",
"souhaitant" => "swEt@",
"souhaitât" => "swEta",
"souhaite" => "swEt",
"souhaité" => "swete",
"souhaitée" => "swete",
"souhaitées" => "swete",
"souhaitent" => "swEt",
"souhaiter" => "swete",
"souhaitera" => "swEt°Ra",
"souhaiterai" => "swEt°RE",
"souhaiteraient" => "swEt°RE",
"souhaiterais" => "swEt°RE",
"souhaiterait" => "swEt°RE",
"souhaiteras" => "swEt°Ra",
"souhaitèrent" => "swEtER",
"souhaiterez" => "swEt°Re",
"souhaiteriez" => "swEt°Rje",
"souhaiterions" => "swEt°Rj§",
"souhaiterons" => "swEt°R§",
"souhaiteront" => "swEt°R§",
"souhaites" => "swEt",
"souhaités" => "swete",
"souhaitez" => "swEte",
"souhaitiez" => "swEtje",
"souhaitions" => "swEtj§",
"souhaitons" => "swEt§",
"souhaits" => "swE",
"souilla" => "suja",
"souillage" => "sujaZ",
"souillaient" => "sujE",
"souillait" => "sujE",
"souillant" => "suj@",
"souillarde" => "sujaRd",
"souille" => "suj",
"souillé" => "suje",
"souillée" => "suje",
"souillées" => "suje",
"souillent" => "suj",
"souiller" => "suje",
"souillerai" => "suj°RE",
"souilleraient" => "suj°RE",
"souillerait" => "suj°RE",
"souilleras" => "suj°Ra",
"souilleront" => "suj°R§",
"souilles" => "suj",
"souillés" => "suje",
"souillez" => "suje",
"souillon" => "suj§",
"souillonnes" => "sujOn",
"souillons" => "suj§",
"souillure" => "sujyR",
"souillures" => "sujyR",
"souk" => "suk",
"souks" => "suk",
"soul" => "sul",
"soûl" => "su",
"soulage" => "sulaZ",
"soulagé" => "sulaZe",
"soulagea" => "sulaZa",
"soulageai" => "sulaZE",
"soulageaient" => "sulaZE",
"soulageait" => "sulaZE",
"soulageâmes" => "sulaZam",
"soulageant" => "sulaZ@",
"soulagée" => "sulaZe",
"soulagées" => "sulaZe",
"soulagement" => "sulaZ°m@",
"soulagements" => "sulaZ°m@",
"soulagent" => "sulaZ",
"soulageons" => "sulaZ§",
"soulager" => "sulaZe",
"soulagera" => "sulaZ°Ra",
"soulagerai" => "sulaZ°RE",
"soulageraient" => "sulaZ°RE",
"soulagerait" => "sulaZ°RE",
"soulagèrent" => "sulaZER",
"soulagerez" => "sulaZ°Re",
"soulages" => "sulaZ",
"soulagés" => "sulaZe",
"soulagez" => "sulaZe",
"soûlait" => "sulE",
"soûlant" => "sul@",
"soûlante" => "sul@t",
"soûlard" => "sulaR",
"soûlarde" => "sulaRd",
"soûlards" => "sulaR",
"soûlaud" => "sulo",
"soûlauds" => "sulo",
"soule" => "sul",
"soûle" => "sul",
"soûlé" => "sule",
"soûlée" => "sule",
"soûlées" => "sule",
"soûlent" => "sul",
"soûler" => "sule",
"soûlerais" => "sul°RE",
"soûlerait" => "sul°RE",
"soûlèrent" => "sulER",
"soûlerie" => "sul°Ri",
"soûlés" => "sule",
"souleva" => "sul°va",
"soulevai" => "sul°vE",
"soulevaient" => "sul°vE",
"soulevais" => "sul°vE",
"soulevait" => "sul°vE",
"soulevant" => "sul°v@",
"soulevât" => "sul°va",
"soulève" => "sulEv",
"soulevé" => "sul°ve",
"soulevée" => "sul°ve",
"soulevées" => "sul°ve",
"soulèvement" => "sulEv°m@",
"soulèvements" => "sulEv°m@",
"soulèvent" => "sulEv",
"soulever" => "sul°ve",
"soulèvera" => "sulEv°Ra",
"soulèverai" => "sulEv°RE",
"soulèveraient" => "sulEv°RE",
"soulèverais" => "sulEv°RE",
"soulèverait" => "sulEv°RE",
"soulevèrent" => "sul°vER",
"soulèverez" => "sulEv°Re",
"soulèveriez" => "sulEv°Rje",
"soulèverons" => "sulEv°R§",
"soulèveront" => "sulEv°R§",
"soulèves" => "sulEv",
"soulevés" => "sul°ve",
"soulevez" => "sul°ve",
"soulevions" => "sul°vj§",
"soulevons" => "sul°v§",
"soûlez" => "sule",
"soulier" => "sulje",
"souliers" => "sulje",
"souligna" => "suliNa",
"soulignai" => "suliNE",
"soulignaient" => "suliNE",
"soulignais" => "suliNE",
"soulignait" => "suliNE",
"soulignant" => "suliN@",
"souligne" => "suliN",
"souligné" => "suliNe",
"soulignée" => "suliNe",
"soulignées" => "suliNe",
"soulignent" => "suliN",
"souligner" => "suliNe",
"soulignera" => "suliN°Ra",
"souligneraient" => "suliN°RE",
"soulignerait" => "suliN°RE",
"soulignés" => "suliNe",
"soulignez" => "suliNe",
"souligniez" => "suliNe",
"soulignions" => "suliN§",
"soûlographe" => "sulogRaf",
"soûlographie" => "sulogRafi",
"soûlons" => "sul§",
"soûlot" => "sulo",
"soûlots" => "sulo",
"soûls" => "su",
"soumet" => "sumE",
"soumets" => "sumE",
"soumettaient" => "sumEtE",
"soumettais" => "sumEtE",
"soumettait" => "sumEtE",
"soumettant" => "sumEt@",
"soumette" => "sumEt",
"soumettent" => "sumEt",
"soumettez" => "sumEte",
"soumettions" => "sumEtj§",
"soumettons" => "sumEt§",
"soumettra" => "sumEtRa",
"soumettrai" => "sumEtRE",
"soumettraient" => "sumEtRE",
"soumettrais" => "sumEtRE",
"soumettrait" => "sumEtRE",
"soumettras" => "sumEtRa",
"soumettre" => "sumEtR",
"soumettrez" => "sumEtRe",
"soumettront" => "sumEtR§",
"soumirent" => "sumiR",
"soumis" => "sumi",
"soumise" => "sumiz",
"soumises" => "sumiz",
"soumission" => "sumisj§",
"soumissionner" => "sumisjone",
"soumissions" => "sumisj§",
"soumit" => "sumi",
"soumît" => "sumi",
"soupa" => "supa",
"soupaient" => "supE",
"soupais" => "supE",
"soupait" => "supE",
"soupâmes" => "supam",
"soupant" => "sup@",
"soupape" => "supap",
"soupapes" => "supap",
"soupasse" => "supas",
"soupçon" => "sups§",
"soupçonna" => "supsona",
"soupçonnable" => "supsonabl",
"soupçonnai" => "supsonE",
"soupçonnaient" => "supsonE",
"soupçonnais" => "supsonE",
"soupçonnait" => "supsonE",
"soupçonnant" => "supson@",
"soupçonnât" => "supsona",
"soupçonne" => "supsOn",
"soupçonné" => "supsone",
"soupçonnée" => "supsone",
"soupçonnées" => "supsone",
"soupçonnent" => "supsOn",
"soupçonner" => "supsone",
"soupçonnera" => "supsOn°Ra",
"soupçonnerais" => "supsOn°RE",
"soupçonnerait" => "supsOn°RE",
"soupçonnèrent" => "supsonER",
"soupçonneriez" => "supson°Rje",
"soupçonneront" => "supsOn°R§",
"soupçonnes" => "supsOn",
"soupçonnés" => "supsone",
"soupçonneuse" => "supson2z",
"soupçonneuses" => "supson2z",
"soupçonneux" => "supson2",
"soupçonnez" => "supsone",
"soupçonniez" => "supsonje",
"soupçonnions" => "supsonj§",
"soupçonnons" => "supson§",
"soupçons" => "sups§",
"soupe" => "sup",
"soupé" => "supe",
"soupent" => "sup",
"soupente" => "sup@t",
"soupentes" => "sup@t",
"souper" => "supe",
"soupera" => "sup°Ra",
"souperaient" => "sup°RE",
"souperait" => "sup°RE",
"soupèrent" => "supER",
"souperons" => "sup°R§",
"soupers" => "supe",
"soupes" => "sup",
"soupesa" => "sup°za",
"soupesait" => "sup°zE",
"soupesant" => "sup°z@",
"soupèse" => "supEz",
"soupesé" => "sup°ze",
"soupesée" => "sup°ze",
"soupeser" => "sup°ze",
"soupèserait" => "supEz°RE",
"soupesés" => "sup°ze",
"soupesez" => "sup°ze",
"soupeur" => "sup9R",
"soupeurs" => "sup9R",
"soupez" => "supe",
"soupier" => "supje",
"soupière" => "supjER",
"soupières" => "supjER",
"soupir" => "supiR",
"soupira" => "supiRa",
"soupirai" => "supiRE",
"soupiraient" => "supiRE",
"soupirail" => "supiRaj",
"soupirais" => "supiRE",
"soupirait" => "supiRE",
"soupirant" => "supiR@",
"soupirants" => "supiR@",
"soupirât" => "supiRa",
"soupiraux" => "supiRo",
"soupire" => "supiR",
"soupiré" => "supiRe",
"soupirent" => "supiR",
"soupirer" => "supiRe",
"soupirerait" => "supiR°RE",
"soupirèrent" => "supiRER",
"soupires" => "supiR",
"soupirez" => "supiRe",
"soupirions" => "supiRj§",
"soupirons" => "supiR§",
"soupirs" => "supiR",
"souple" => "supl",
"souplement" => "supl°m@",
"souples" => "supl",
"souplesse" => "suplEs",
"souplesses" => "suplEs",
"soupons" => "sup§",
"souquaient" => "sukE",
"souque" => "suk",
"souqué" => "suke",
"souquenille" => "suk°nij",
"souquenilles" => "suk°nij",
"souquer" => "suke",
"souquez" => "suke",
"sourate" => "suRat",
"sourates" => "suRat",
"source" => "suRs",
"sources" => "suRs",
"sourcier" => "suRsje",
"sourciers" => "suRsje",
"sourcil" => "suRsi",
"sourcilière" => "suRsiljER",
"sourcilières" => "suRsiljER",
"sourcilla" => "suRsija",
"sourcillai" => "suRsijE",
"sourcille" => "suRsij",
"sourcillé" => "suRsije",
"sourciller" => "suRsije",
"sourcilleuse" => "suRsij2z",
"sourcilleuses" => "suRsij2z",
"sourcilleux" => "suRsij2",
"sourcils" => "suRsi",
"sourd" => "suR",
"sourd-muet" => "suRm8E",
"sourdaient" => "suRdE",
"sourdait" => "suRdE",
"sourdant" => "suRd@",
"sourde" => "suRd",
"sourde-muette" => "suRdm8Et",
"sourdement" => "suRd°m@",
"sourdes" => "suRd",
"sourdine" => "suRdin",
"sourdingue" => "suRd5g",
"sourdingues" => "suRd5g",
"sourdre" => "suRdR°",
"sourdront" => "suRdR§",
"sourds" => "suR",
"sourds-muets" => "suRm8E",
"souri" => "suRi",
"souriaient" => "suRjE",
"souriais" => "suRjE",
"souriait" => "suRjE",
"souriant" => "suRj@",
"souriante" => "suRj@t",
"souriantes" => "suRj@t",
"souriants" => "suRj@",
"souriceau" => "suRiso",
"souriceaux" => "suRiso",
"souricière" => "suRisjER",
"souricières" => "suRisjER",
"sourie" => "suRi",
"sourient" => "suRi",
"souries" => "suRi",
"souriez" => "suRje",
"souriions" => "suRij§",
"sourîmes" => "suRim",
"sourions" => "suRj§",
"sourira" => "suRiRa",
"sourirai" => "suRiRE",
"souriraient" => "suRiRE",
"sourirais" => "suRiRE",
"sourirait" => "suRiRE",
"souriras" => "suRiRa",
"sourire" => "suRiR",
"sourirent" => "suRiR",
"sourires" => "suRiR",
"sourirons" => "suRiR§",
"souriront" => "suRiR§",
"souris" => "suRi",
"sourit" => "suRi",
"sourît" => "suRi",
"sournois" => "suRnwa",
"sournoise" => "suRnwaz",
"sournoisement" => "suRnwaz°m@",
"sournoiserie" => "suRnwaz°Ri",
"sournoiseries" => "suRnwaz°Ri",
"sournoises" => "suRnwaz",
"sous" => "su",
"sous-alimentation" => "suzalim@tasj§",
"sous-alimenté" => "suzalim@te",
"sous-alimentée" => "suzalim@te",
"sous-alimentés" => "suzalim@te",
"sous-bibliothécaire" => "subiblijotekER",
"sous-bois" => "subwa",
"sous-chef" => "suSEf",
"sous-chefs" => "suSEf",
"sous-classe" => "suklas",
"sous-clavière" => "suklavjER",
"sous-comité" => "sukomite",
"sous-commission" => "sukomisj§",
"sous-continent" => "suk§tin@",
"sous-continents" => "suk§tin@",
"sous-couche" => "sukuS",
"sous-cul" => "suky",
"sous-cutané" => "sukytane",
"sous-cutanée" => "sukytane",
"sous-cutanées" => "sukytane",
"sous-cutanés" => "sukytane",
"sous-développé" => "sudev°lope",
"sous-développée" => "sudev°lope",
"sous-développées" => "sudev°lope",
"sous-développement" => "sudev°lOp°m@",
"sous-développés" => "sudev°lope",
"sous-diacre" => "sudjakR",
"sous-directeur" => "sudiREkt9R",
"sous-directeurs" => "sudiREkt9R",
"sous-directrice" => "sudiREktRis",
"sous-division" => "sudivizj§",
"sous-dominante" => "sudomin@t",
"sous-effectif" => "suzefEktif",
"sous-effectifs" => "suzefEktif",
"sous-emploi" => "suz@plwa",
"sous-ensemble" => "suz@s@bl",
"sous-entend" => "suz@t@",
"sous-entendais" => "suz@t@dE",
"sous-entendait" => "suz@t@dE",
"sous-entendant" => "suz@t@d@",
"sous-entendent" => "suz@t@d",
"sous-entendez" => "suz@t@de",
"sous-entendiez" => "suz@t@dje",
"sous-entendrait" => "suz@t@dRE",
"sous-entendre" => "suz@t@dR",
"sous-entends" => "suz@t@",
"sous-entendu" => "suz@t@dy",
"sous-entendue" => "suz@t@dy",
"sous-entendus" => "suz@t@dy",
"sous-équipés" => "suzekipe",
"sous-espace" => "suzEspas",
"sous-espèce" => "suzEspEs",
"sous-estimais" => "suzEstimE",
"sous-estimait" => "suzEstimE",
"sous-estimation" => "suzEstimasj§",
"sous-estime" => "suzEstim",
"sous-estimé" => "suzEstime",
"sous-estimée" => "suzEstime",
"sous-estimées" => "suzEstime",
"sous-estiment" => "suzEstim",
"sous-estimer" => "suzEstime",
"sous-estimerai" => "suzEstim°RE",
"sous-estimes" => "suzEstim",
"sous-estimés" => "suzEstime",
"sous-estimez" => "suzEstime",
"sous-estimons" => "suzEstim§",
"sous-évaluait" => "suzeval8E",
"sous-évalué" => "suzeval8e",
"sous-évaluées" => "suzeval8e",
"sous-exposé" => "suzEkspoze",
"sous-exposées" => "suzEkspoze",
"sous-fifre" => "sufifR",
"sous-fifres" => "sufifR",
"sous-garde" => "sugaRd",
"sous-genre" => "suZ@R",
"sous-gorge" => "sugORZ",
"sous-groupe" => "sugRup",
"sous-homme" => "suzOm",
"sous-hommes" => "suzOm",
"sous-humanité" => "suzymanite",
"sous-intendant" => "suz5t@d@",
"sous-intendants" => "suz5t@d@",
"sous-jacent" => "suZas@",
"sous-jacente" => "suZas@t",
"sous-jacentes" => "suZas@t",
"sous-jacents" => "suZas@",
"sous-lieutenant" => "sulj2t°n@",
"sous-lieutenants" => "sulj2t°n@",
"sous-locataire" => "sulOkatER",
"sous-locataires" => "sulokatER",
"sous-location" => "sulokasj§",
"sous-locations" => "sulokasj§",
"sous-loua" => "sulwa",
"sous-louait" => "sulwE",
"sous-loue" => "sulu",
"sous-loué" => "sulwe",
"sous-louer" => "sulwe",
"sous-louerai" => "suluRE",
"sous-louèrent" => "sulwER",
"sous-louez" => "sulue",
"sous-main" => "sum5",
"sous-maîtresse" => "sumEtREs",
"sous-marin" => "sumaR5",
"sous-marine" => "sumaRin",
"sous-marines" => "sumaRin",
"sous-marinier" => "sumaRinje",
"sous-mariniers" => "sumaRinje",
"sous-marins" => "sumaR5",
"sous-marque" => "sumaRk",
"sous-marques" => "sumaRk",
"sous-merde" => "sumERd",
"sous-merdes" => "sumERd",
"sous-ministre" => "suministR",
"sous-off" => "suzOf",
"sous-officier" => "suzofisje",
"sous-officiers" => "suzofisje",
"sous-offs" => "suzOf",
"sous-ordre" => "suzORdR",
"sous-ordres" => "suzORdR",
"sous-payé" => "supeje",
"sous-payer" => "supeje",
"sous-payés" => "supeje",
"sous-pied" => "supje",
"sous-pieds" => "supje",
"sous-plat" => "supla",
"sous-préfecture" => "supRefEktyR",
"sous-préfectures" => "supRefEktyR",
"sous-préfet" => "supRefE",
"sous-préfets" => "supRefE",
"sous-prieur" => "supRij9R",
"sous-produit" => "supRod8i",
"sous-produits" => "supRod8i",
"sous-programme" => "supRogRam",
"sous-programmes" => "supRogRam",
"sous-prolétaire" => "supRoletER",
"sous-prolétariat" => "supRoletaRja",
"sous-pulls" => "supyl",
"sous-qualifié" => "sukalifje",
"sous-qualifiée" => "sukalifje",
"sous-secrétaire" => "sus°kRetER",
"sous-secrétaires" => "sus°kRetER",
"sous-secrétariat" => "sus°kRetaRja",
"sous-secteur" => "susekt9R",
"sous-section" => "suseksj§",
"sous-sol" => "susOl",
"sous-sols" => "susOl",
"sous-station" => "sustasj§",
"sous-système" => "susistEm",
"sous-tasse" => "sutas",
"sous-tasses" => "sutas",
"sous-tend" => "sut@",
"sous-tendaient" => "sut@dE",
"sous-tendait" => "sut@dE",
"sous-tendent" => "sut@d",
"sous-tendu" => "sut@dy",
"sous-tendue" => "sut@dy",
"sous-tension" => "sut@sj§",
"sous-titrage" => "sutitRaZ",
"sous-titre" => "sutitR",
"sous-titré" => "sutitRe",
"sous-titrée" => "sutitRe",
"sous-titrer" => "sutitRe",
"sous-titres" => "sutitR",
"sous-titrés" => "sutitRe",
"sous-traitance" => "sutREt@s",
"sous-traitant" => "sutREt@",
"sous-traitants" => "sutREt@",
"sous-traite" => "sutREt",
"sous-traitent" => "sutREt",
"sous-traiter" => "sutRete",
"sous-traités" => "sutRete",
"sous-ventrière" => "suv@tRijER",
"sous-verge" => "suvERZ",
"sous-verre" => "suvER",
"sous-vêtement" => "suvEt°m@",
"sous-vêtements" => "suvEt°m@",
"souscripteur" => "suskRipt9R",
"souscripteurs" => "suskRipt9R",
"souscription" => "suskRipsj§",
"souscriptions" => "suskRipsj§",
"souscrira" => "suskRiRa",
"souscrirai" => "suskRiRE",
"souscrirait" => "suskRiRE",
"souscrire" => "suskRiR",
"souscris" => "suskRi",
"souscrit" => "suskRi",
"souscrite" => "suskRit",
"souscrites" => "suskRit",
"souscrits" => "suskRi",
"souscrivais" => "suskRivE",
"souscrivait" => "suskRivE",
"souscrivez" => "suskRive",
"souscrivons" => "suskRiv§",
"soussigné" => "susiNe",
"soussignée" => "susiNe",
"soussigner" => "susiNe",
"soussignés" => "susiNe",
"soussou" => "susu",
"soussous" => "susu",
"soustraction" => "sustRaksj§",
"soustractions" => "sustRaksj§",
"soustrairait" => "sustRERE",
"soustraire" => "sustRER",
"soustrais" => "sustRE",
"soustrait" => "sustRE",
"soustraite" => "sustREt",
"soustraites" => "sustREt",
"soustraits" => "sustRE",
"soustrayaient" => "sustREjE",
"soustrayait" => "sustREjE",
"soustrayant" => "sustREj@",
"soustrayez" => "sustREje",
"soutachait" => "sutaSE",
"soutache" => "sutaS",
"soutaché" => "sutaSe",
"soutachée" => "sutaSe",
"soutachées" => "sutaSe",
"soutaches" => "sutaS",
"soutachés" => "sutaSe",
"soutane" => "sutan",
"soutanelle" => "sutanEl",
"soutanes" => "sutan",
"soute" => "sut",
"soutenable" => "sut°nabl",
"soutenaient" => "sut°nE",
"soutenais" => "sut°nE",
"soutenait" => "sut°nE",
"soutenance" => "sut°n@s",
"soutenant" => "sut°n@",
"soutènement" => "sutEn°m@",
"souteneur" => "sut°n9R",
"souteneurs" => "sut°n9R",
"soutenez" => "sut°ne",
"souteniez" => "sut°nje",
"soutenions" => "sut°nj§",
"soutenir" => "sut°niR",
"soutenons" => "sut°n§",
"soutenu" => "sut°ny",
"soutenue" => "sut°ny",
"soutenues" => "sut°ny",
"soutenus" => "sut°ny",
"souter" => "sute",
"souterrain" => "sutER5",
"souterraine" => "sutEREn",
"souterrainement" => "sutEREn°m@",
"souterraines" => "sutEREn",
"souterrains" => "sutER5",
"soutes" => "sut",
"soutien" => "sutj5",
"soutien-gorge" => "sutj5gORZ",
"soutiendra" => "sutj5dRa",
"soutiendrai" => "sutj5dRE",
"soutiendraient" => "sutj5dRE",
"soutiendrais" => "sutj5dRE",
"soutiendrait" => "sutj5dRE",
"soutiendras" => "sutj5dRa",
"soutiendrez" => "sutj5dRe",
"soutiendriez" => "sutj5dRie",
"soutiendrons" => "sutj5dR§",
"soutiendront" => "sutj5dR§",
"soutienne" => "sutjEn",
"soutiennent" => "sutjEn",
"soutiennes" => "sutjEn",
"soutiens" => "sutj5",
"soutiens-gorge" => "sutj5gORZ",
"soutient" => "sutj5",
"soutier" => "sutje",
"soutiers" => "sutje",
"soutif" => "sutif",
"soutifs" => "sutif",
"soutinrent" => "sut5R",
"soutins" => "sut5",
"soutint" => "sut5",
"soutînt" => "sut5",
"soutirage" => "sutiRaZ",
"soutiraient" => "sutiRE",
"soutire" => "sutiR",
"soutiré" => "sutiRe",
"soutirée" => "sutiRe",
"soutirées" => "sutiRe",
"soutirent" => "sutiR",
"soutirer" => "sutiRe",
"soutirerai" => "sutiR°RE",
"soutirez" => "sutiRe",
"soutra" => "sutRa",
"souvenaient" => "suv°nE",
"souvenais" => "suv°nE",
"souvenait" => "suv°nE",
"souvenance" => "suv°n@s",
"souvenances" => "suv°n@s",
"souvenant" => "suv°n@",
"souvenez" => "suv°ne",
"souveniez" => "suv°nje",
"souvenions" => "suv°nj§",
"souvenir" => "suv°niR",
"souvenirs" => "suv°niR",
"souvenons" => "suv°n§",
"souvent" => "suv@",
"souventefois" => "suv@t°fwa",
"souventes fois" => "suv@tfwa",
"souvenu" => "suv°ny",
"souvenue" => "suv°ny",
"souvenus" => "suv°ny",
"souverain" => "suv°R5",
"souveraine" => "suv°REn",
"souverainement" => "suv°REn°m@",
"souveraines" => "suv°REn",
"souveraineté" => "suv°REn°te",
"souverainetés" => "suv°REn°te",
"souverains" => "suv°R5",
"souviendra" => "suvj5dRa",
"souviendrai" => "suvj5dRE",
"souviendraient" => "suvj5dRE",
"souviendrais" => "suvj5dRE",
"souviendrait" => "suvj5dRE",
"souviendras" => "suvj5dRa",
"souviendrez" => "suvj5dRe",
"souviendriez" => "suvj5dRie",
"souviendrons" => "suvj5dR§",
"souviendront" => "suvj5dR§",
"souvienne" => "suvjEn",
"souviennent" => "suvjEn",
"souviennes" => "suvjEn",
"souviens" => "suvj5",
"souvient" => "suvj5",
"souvinrent" => "suv5R",
"souvins" => "suv5",
"souvinssent" => "suv5s",
"souvint" => "suv5",
"souvînt" => "suv5",
"souvlaki" => "suvlaki",
"soviet" => "sovjEt",
"soviétique" => "sovjetik",
"soviétiques" => "sovjetik",
"soviétisation" => "sovjetizasj§",
"soviétisme" => "sovjetizm",
"soviétologues" => "sovjetolOg",
"soviets" => "sovjEt",
"sovkhoze" => "sOvkoz",
"sovkhozes" => "sOvkoz",
"soya" => "swaja",
"soyeuse" => "swaj2z",
"soyeusement" => "swaj2z°m@",
"soyeuses" => "swaj2z",
"soyeux" => "swaj2",
"soyez" => "swaje",
"soyons" => "swaj§",
"spa" => "spa",
"spacieuse" => "spasj2z",
"spacieuses" => "spasj2z",
"spacieux" => "spasj2",
"spadassin" => "spadas5",
"spadassins" => "spadas5",
"spadille" => "spadij",
"spaghetti" => "spageti",
"spaghettis" => "spageti",
"spahi" => "spai",
"spahis" => "spai",
"spamming" => "spamiG",
"sparadrap" => "spaRadRa",
"sparadraps" => "spaRadRa",
"sparring-partner" => "spERiGpaRtn9R",
"spartakistes" => "spaRtakist",
"sparte" => "spaRt",
"spartéine" => "spaRtein",
"sparterie" => "spaRt°Ri",
"spartiate" => "spaRsjat",
"spartiates" => "spaRsjat",
"spas" => "spa",
"spasme" => "spasm",
"spasmes" => "spasm",
"spasmodique" => "spasmodik",
"spasmodiquement" => "spasmodik°m@",
"spasmodiques" => "spasmodik",
"spasmophile" => "spasmofil",
"spasmophilie" => "spasmofili",
"spasticité" => "spastisite",
"spastique" => "spastik",
"spath" => "spat",
"spatial" => "spasjal",
"spatiale" => "spasjal",
"spatialement" => "spasjal°m@",
"spatiales" => "spasjal",
"spatiaux" => "spasjo",
"spatio-temporel" => "spasjot@poREl",
"spatio-temporelle" => "spasjot@poREl",
"spationaute" => "spasjonot",
"spatiotemporel" => "spatjot@poREl",
"spatule" => "spatyl",
"spatulée" => "spatyle",
"spatulées" => "spatyle",
"spatuler" => "spatyle",
"spatules" => "spatyl",
"spatulés" => "spatyle",
"speakeasy" => "spikizi",
"speaker" => "spik9R",
"speakerine" => "spikRin",
"speakerines" => "spikRin",
"speakers" => "spik9R",
"spécial" => "spesjal",
"spéciale" => "spesjal",
"spécialement" => "spesjal°m@",
"spéciales" => "spesjal",
"spécialisa" => "spesjaliza",
"spécialisaient" => "spesjalizE",
"spécialisait" => "spesjalizE",
"spécialisant" => "spesjaliz@",
"spécialisation" => "spesjalizasj§",
"spécialise" => "spesjaliz",
"spécialisé" => "spesjalize",
"spécialisée" => "spesjalize",
"spécialisées" => "spesjalize",
"spécialiser" => "spesjalize",
"spécialisés" => "spesjalize",
"spécialiste" => "spesjalist",
"spécialistes" => "spesjalist",
"spécialité" => "spesjalite",
"spécialités" => "spesjalite",
"spéciaux" => "spesjo",
"species" => "spesjEs",
"spécieuse" => "spesj2z",
"spécieusement" => "spesj2z°m@",
"spécieuses" => "spesj2z",
"spécieux" => "spesj2",
"spécifiais" => "spesifjE",
"spécifiait" => "spesifjE",
"spécifiant" => "spesifj@",
"spécification" => "spesifikasj§",
"spécifications" => "spesifikasj§",
"spécificité" => "spesifisite",
"spécificités" => "spesifisite",
"spécifie" => "spesifi",
"spécifié" => "spesifje",
"spécifiée" => "spesifje",
"spécifiées" => "spesifje",
"spécifient" => "spesifi",
"spécifier" => "spesifje",
"spécifiera" => "spesifiRa",
"spécifiés" => "spesifje",
"spécifiez" => "spesifje",
"spécifique" => "spesifik",
"spécifiquement" => "spesifik°m@",
"spécifiques" => "spesifik",
"spécimen" => "spesimEn",
"spécimens" => "spesimEn",
"spectacle" => "spEktakl",
"spectacles" => "spEktakl",
"spectaculaire" => "spEktakylER",
"spectaculairement" => "spEktakylER°m@",
"spectaculaires" => "spEktakylER",
"spectateur" => "spEktat9R",
"spectateurs" => "spEktat9R",
"spectatrice" => "spEktatRis",
"spectatrices" => "spEktatRis",
"spectral" => "spEktRal",
"spectrale" => "spEktRal",
"spectrales" => "spEktRal",
"spectraux" => "spEktRo",
"spectre" => "spEktR",
"spectres" => "spEktR",
"spectrogramme" => "spEktRogRam",
"spectrographe" => "spEktRogRaf",
"spectrographie" => "spEktRogRafi",
"spectrographique" => "spEktRogRafik",
"spectrohéliographe" => "spEktRoeljOgRaf",
"spectromètre" => "spEktRomEtR",
"spectrométrie" => "spEktRometRi",
"spectrométrique" => "spEktRometRik",
"spectrophotomètre" => "spEktRofOtomEtR",
"spectroscope" => "spEktROskOp",
"spectroscopie" => "spEktRoskopi",
"spéculaient" => "spekylE",
"spéculaire" => "spekylER",
"spéculait" => "spekylE",
"spéculant" => "spekyl@",
"spéculateur" => "spekylat9R",
"spéculateurs" => "spekylat9R",
"spéculatif" => "spekylatif",
"spéculatifs" => "spekylatif",
"spéculation" => "spekylasj§",
"spéculations" => "spekylasj§",
"spéculative" => "spekylativ",
"spéculatives" => "spekylativ",
"spéculatrice" => "spekylatRis",
"spéculatrices" => "spekylatRis",
"spécule" => "spekyl",
"spéculé" => "spekyle",
"spéculent" => "spekyl",
"spéculer" => "spekyle",
"spéculeraient" => "spekyl°RE",
"spéculez" => "spekyle",
"spéculoos" => "spekylos",
"spéculum" => "spekylOm",
"speech" => "spitS",
"speed" => "spid",
"speede" => "spid",
"speedé" => "spide",
"speedée" => "spide",
"speeder" => "spide",
"speedes" => "spid",
"speedés" => "spide",
"spéléo" => "speleo",
"spéléologie" => "speleoloZi",
"spéléologue" => "speleolOg",
"spéléologues" => "speleolOg",
"spéléotomie" => "speleotomi",
"spencer" => "spEnsER",
"spencers" => "spEnsER",
"spenglérienne" => "sp@gleRjEn",
"spermaceti" => "spERmaseti",
"spermatique" => "spERmatik",
"spermato" => "spERmato",
"spermatogenèse" => "spERmatoZ°nEz",
"spermatos" => "spERmato",
"spermatozoïde" => "spERmatozoid",
"spermatozoïdes" => "spERmatozoid",
"sperme" => "spERm",
"spermes" => "spERm",
"spermicide" => "spERmisid",
"spermogramme" => "spERmogRam",
"spermophiles" => "spERmofil",
"spetsnaz" => "spEtsnaz",
"sphaigne" => "sfEN",
"sphaignes" => "sfEN",
"sphénoïde" => "sfenoid",
"sphère" => "sfER",
"sphères" => "sfER",
"sphéricité" => "sfeRisite",
"sphérique" => "sfeRik",
"sphériquement" => "sfeRik°m@",
"sphériques" => "sfeRik",
"sphéroïde" => "sfeRoid",
"sphéroïdes" => "sfeRoid",
"sphincter" => "sf5ktER",
"sphincters" => "sf5ktER",
"sphinge" => "sf5Z",
"sphinges" => "sf5Z",
"sphinx" => "sf5ks",
"sphygmomanomètre" => "sfigmomanomEtR",
"spi" => "spi",
"spic" => "spik",
"spica" => "spika",
"spics" => "spik",
"spicules" => "spikyl",
"spider" => "spajd9R",
"spin" => "spin",
"spina" => "spina",
"spina-bifida" => "spinabifida",
"spina-ventosa" => "spinav@toza",
"spinal" => "spinal",
"spinale" => "spinal",
"spinaux" => "spino",
"spinnaker" => "spinak°R",
"spinnakers" => "spinak°R",
"spinozisme" => "spinozizm",
"spirale" => "spiRal",
"spiralé" => "spiRale",
"spiralées" => "spiRale",
"spiraler" => "spiRale",
"spirales" => "spiRal",
"spiralés" => "spiRale",
"spire" => "spiR",
"spirées" => "spiRe",
"spires" => "spiR",
"spirite" => "spiRit",
"spirites" => "spiRit",
"spiritisme" => "spiRitizm",
"spiritualisaient" => "spiRit8alizE",
"spiritualise" => "spiRit8aliz",
"spiritualisé" => "spiRit8alize",
"spiritualiser" => "spiRit8alize",
"spiritualisme" => "spiRit8alizm",
"spiritualiste" => "spiRit8alist",
"spiritualistes" => "spiRit8alist",
"spiritualité" => "spiRit8alite",
"spiritualités" => "spiRit8alite",
"spirituel" => "spiRit8El",
"spirituelle" => "spiRit8El",
"spirituellement" => "spiRit8El°m@",
"spirituelles" => "spiRit8El",
"spirituels" => "spiRit8El",
"spiritueux" => "spiRit82",
"spirochète" => "spiROSEt",
"spirographe" => "spiRogRaf",
"spiromètres" => "spiRomEtR",
"spiruline" => "spiRylin",
"spitz" => "spits",
"splash" => "splaS",
"spleen" => "splin",
"spleens" => "splin",
"splendeur" => "spl@d9R",
"splendeurs" => "spl@d9R",
"splendide" => "spl@did",
"splendidement" => "spl@did°m@",
"splendides" => "spl@did",
"splénectomie" => "splenEktOmi",
"splénique" => "splenik",
"splittaient" => "splitE",
"splitter" => "splite",
"spoiler" => "spOjlER",
"spoliait" => "spoljE",
"spoliation" => "spoljasj§",
"spoliations" => "spoljasj§",
"spolie" => "spoli",
"spolié" => "spolje",
"spoliée" => "spolje",
"spoliées" => "spolje",
"spolier" => "spolje",
"spoliés" => "spolje",
"spondées" => "sp§de",
"spondylarthrose" => "sp§dilaRtRoz",
"spondylite" => "sp§dilit",
"spongieuse" => "sp§Zj2z",
"spongieuses" => "sp§Zj2z",
"spongieux" => "sp§Zj2",
"spongiforme" => "sp§ZifORm",
"sponsor" => "sp§sOR",
"sponsoring" => "sp§soRiG",
"sponsorisait" => "sp§soRizE",
"sponsorise" => "sp§soRiz",
"sponsorisé" => "sp§soRize",
"sponsorisée" => "sp§soRize",
"sponsoriser" => "sp§soRize",
"sponsorisera" => "sp§soRiz°Ra",
"sponsorisés" => "sp§soRize",
"sponsors" => "sp§sOR",
"spontané" => "sp§tane",
"spontanée" => "sp§tane",
"spontanées" => "sp§tane",
"spontanéistes" => "sp§taneist",
"spontanéité" => "sp§taneite",
"spontanément" => "sp§tanem@",
"spontanés" => "sp§tane",
"spoon" => "spun",
"sporadique" => "spoRadik",
"sporadiquement" => "spoRadik°m@",
"sporadiques" => "spoRadik",
"spore" => "spOR",
"spores" => "spOR",
"sport" => "spOR",
"sportif" => "spORtif",
"sportifs" => "spORtif",
"sportive" => "spORtiv",
"sportivement" => "spORtiv°m@",
"sportives" => "spORtiv",
"sportivité" => "spORtivite",
"sports" => "spOR",
"sportsman" => "spORtsman",
"sportsmen" => "spORtsmEn",
"sportswear" => "spORtswER",
"spot" => "spOt",
"spots" => "spOt",
"spoutnik" => "sputnik",
"spoutniks" => "sputnik",
"sprat" => "spRat",
"sprats" => "spRat",
"spray" => "spREj",
"sprays" => "spREj",
"sprechgesang" => "SpReSgesaG",
"spring" => "spRiG",
"springer" => "spRing9R",
"sprinkler" => "spRinkl9R",
"sprinklers" => "spRinklER",
"sprint" => "spRint",
"sprinta" => "spRinta",
"sprintait" => "spRintE",
"sprintant" => "spRint@",
"sprinte" => "spRint",
"sprinter" => "spRint9R",
"sprinters" => "spRint9R",
"sprinteur" => "spRit9R",
"sprinteurs" => "spRit9R",
"sprints" => "spRint",
"spruce" => "spRys",
"spumescent" => "spymEs@",
"spumosité" => "spymozite",
"squale" => "skwal",
"squales" => "skwal",
"squames" => "skwam",
"squameuse" => "skwam2z",
"squameux" => "skwam2",
"square" => "skwaR",
"squares" => "skwaR",
"squash" => "skwaS",
"squat" => "skwat",
"squats" => "skwat",
"squattait" => "skwatE",
"squatte" => "skwat",
"squatté" => "skwate",
"squattée" => "skwate",
"squattées" => "skwate",
"squatter" => "skwat9R",
"squatteras" => "skwat°Ra",
"squattérisé" => "skwateRize",
"squatters" => "skwat9R",
"squattés" => "skwate",
"squatteur" => "skwat9R",
"squatteurs" => "skwat9R",
"squattez" => "skwate",
"squaw" => "skwo",
"squaws" => "skwo",
"squeeze" => "skwiz",
"squeezent" => "skwiz",
"squeezer" => "skwiz9R",
"squelette" => "sk°lEt",
"squelettes" => "sk°lEt",
"squelettique" => "sk°letik",
"squelettiques" => "sk°letik",
"squire" => "skwajR",
"squires" => "skwajR",
"sri lankais" => "sRil@kE",
"stabat mater" => "stabamatER",
"stabilisa" => "stabiliza",
"stabilisait" => "stabilizE",
"stabilisant" => "stabiliz@",
"stabilisante" => "stabiliz@t",
"stabilisateur" => "stabilizat9R",
"stabilisateurs" => "stabilizat9R",
"stabilisation" => "stabilizasj§",
"stabilisatrice" => "stabilizatRis",
"stabilise" => "stabiliz",
"stabilisé" => "stabilize",
"stabilisée" => "stabilize",
"stabilisées" => "stabilize",
"stabilisent" => "stabiliz",
"stabiliser" => "stabilize",
"stabilisèrent" => "stabilizER",
"stabilisés" => "stabilize",
"stabilisez" => "stabilize",
"stabilisons" => "stabiliz§",
"stabilité" => "stabilite",
"stable" => "stabl",
"stablement" => "stabl°m@",
"stables" => "stabl",
"stabulation" => "stabylasj§",
"staccato" => "stakato",
"stade" => "stad",
"stades" => "stad",
"stadium" => "stadjOm",
"staff" => "staf",
"staffs" => "staf",
"stage" => "staZ",
"stages" => "staZ",
"stagflation" => "stagflasj§",
"stagiaire" => "staZjER",
"stagiaires" => "staZjER",
"stagna" => "stagna",
"stagnaient" => "stagnE",
"stagnait" => "stagnE",
"stagnant" => "stagn@",
"stagnante" => "stagn@t",
"stagnantes" => "stagn@t",
"stagnation" => "stagnasj§",
"stagne" => "stagn",
"stagné" => "stagne",
"stagnent" => "stagn",
"stagner" => "stagne",
"stagnez" => "stagne",
"stakhanoviste" => "stakanovist",
"stalactite" => "stalaktit",
"stalactites" => "stalaktit",
"stalag" => "stalag",
"stalagmite" => "stalagmit",
"stalagmites" => "stalagmit",
"stalags" => "stalag",
"stalinien" => "stalinj5",
"stalinienne" => "stalinjEn",
"staliniennes" => "stalinjEn",
"staliniens" => "stalinj5",
"stalinisée" => "stalinize",
"stalinisme" => "stalinizm",
"stalino" => "stalino",
"stalle" => "stal",
"stalles" => "stal",
"stals" => "stal",
"stance" => "st@s",
"stances" => "st@s",
"stand" => "st@d",
"stand-by" => "st@dbaj",
"standard" => "st@daR",
"standardisation" => "st@daRdizasj§",
"standardisé" => "st@daRdize",
"standardisée" => "st@daRdize",
"standardisées" => "st@daRdize",
"standardisés" => "st@daRdize",
"standardiste" => "st@daRdist",
"standardistes" => "st@daRdist",
"standards" => "st@daR",
"standing" => "st@diG",
"stands" => "st@d",
"staphylococcie" => "stafilokOksi",
"staphylococcique" => "stafilokOksik",
"staphylocoque" => "stafilOkOk",
"staphylocoques" => "stafilokOk",
"star" => "staR",
"star-system" => "staRsistEm",
"starking" => "staRkiG",
"starlette" => "staRlEt",
"starlettes" => "staRlEt",
"staroste" => "staROst",
"stars" => "staR",
"start-up" => "staRt9p",
"starter" => "staRt9R",
"starting-gate" => "staRtiGgEjt",
"stase" => "staz",
"stat" => "stat",
"state" => "stEjt",
"stater" => "state",
"statère" => "statER",
"statères" => "statER",
"statices" => "statis",
"station" => "stasj§",
"station-éclair" => "stasj§eklER",
"station-service" => "stasj§sERvis",
"stationna" => "stasjona",
"stationnaient" => "stasjonE",
"stationnaire" => "stasjonER",
"stationnait" => "stasjonE",
"stationnant" => "stasjon@",
"stationne" => "stasjOn",
"stationné" => "stasjone",
"stationnée" => "stasjone",
"stationnées" => "stasjone",
"stationnement" => "stasjOn°m@",
"stationnements" => "stasjOn°m@",
"stationnent" => "stasjOn",
"stationner" => "stasjone",
"stationnera" => "stasjOn°Ra",
"stationnèrent" => "stasjonER",
"stationnés" => "stasjone",
"stationnez" => "stasjone",
"stationnions" => "stasjonj§",
"stations" => "stasj§",
"stations-service" => "stasj§sERvis",
"statique" => "statik",
"statiques" => "statik",
"statisticien" => "statistisj5",
"statisticienne" => "statistisjEn",
"statistique" => "statistik",
"statistiquement" => "statistik°m@",
"statistiquer" => "statistike",
"statistiques" => "statistik",
"statu quo" => "statykwo",
"statuaient" => "stat8E",
"statuaire" => "stat8ER",
"statuant" => "stat8@",
"statue" => "staty",
"statué" => "stat8e",
"statuer" => "stat8e",
"statuera" => "statyRa",
"statuerai" => "statyRE",
"statuerait" => "statyRE",
"statues" => "staty",
"statuette" => "stat8Et",
"statuettes" => "stat8Et",
"statufia" => "statyfja",
"statufiais" => "statyfjE",
"statufiait" => "statyfjE",
"statufiant" => "statyfj@",
"statufié" => "statyfje",
"statufiée" => "statyfje",
"statufiées" => "statyfje",
"statufier" => "statyfje",
"statufièrent" => "statyfjER",
"statufiés" => "statyfje",
"stature" => "statyR",
"statures" => "statyR",
"staturo-pondéral" => "statyRop§deRal",
"status" => "statys",
"statut" => "staty",
"statutaire" => "statytER",
"statuts" => "staty",
"stayer" => "stEj9R",
"steak" => "stEk",
"steaks" => "stEk",
"steamboat" => "stimbOwt",
"steamer" => "stim9R",
"steamers" => "stim9R",
"stéarate" => "steaRat",
"stéarique" => "steaRik",
"stéatopyges" => "steatopiZ",
"steeple" => "stipl",
"steeple-chase" => "stip°ltSEjz",
"steeples" => "stipl",
"stegomya" => "stegomia",
"stégosaure" => "stegozoR",
"stèle" => "stEl",
"stèles" => "stEl",
"stellaire" => "stElER",
"stellaires" => "stElER",
"stem" => "stEm",
"stencil" => "stEnsil",
"stendhalien" => "st5dalj5",
"sténo" => "steno",
"sténodactylo" => "stenodaktilo",
"sténodactylographie" => "stenodaktilogRafi",
"sténographe" => "stenogRaf",
"sténographiai" => "stenogRafjE",
"sténographie" => "stenogRafi",
"sténographique" => "stenogRafik",
"sténographiques" => "stenogRafik",
"sténopé" => "stenope",
"sténopés" => "stenope",
"sténos" => "steno",
"sténose" => "stenoz",
"sténotype" => "stenotip",
"sténotypiste" => "stenotipist",
"sténotypistes" => "stenotipist",
"stentor" => "st@tOR",
"stentors" => "st@tOR",
"stéphanois" => "stefanwa",
"steppe" => "stEp",
"stepper" => "stEpe",
"steppers" => "stEp9R",
"steppes" => "stEp",
"stercoraire" => "stERkoRER",
"stercoraires" => "stERkoRER",
"stère" => "stER",
"stéréo" => "steReo",
"stéréophonie" => "steReofoni",
"stéréophonique" => "steReofonik",
"stéréos" => "steReo",
"stéréoscope" => "steReoskOp",
"stéréoscopie" => "steReoskopi",
"stéréoscopique" => "steReoskopik",
"stéréotype" => "steReotip",
"stéréotypé" => "steReotipe",
"stéréotypée" => "steReotipe",
"stéréotypées" => "steReotipe",
"stéréotyper" => "steReOtipe",
"stéréotypes" => "steReotip",
"stéréotypés" => "steReotipe",
"stéréotypie" => "steReotipi",
"stères" => "stER",
"stérile" => "steRil",
"stérilement" => "steRil°m@",
"stériles" => "steRil",
"stérilet" => "steRilE",
"stérilisa" => "steRiliza",
"stérilisait" => "steRilizE",
"stérilisant" => "steRiliz@",
"stérilisante" => "steRiliz@t",
"stérilisantes" => "steRiliz@t",
"stérilisateur" => "steRilizat9R",
"stérilisation" => "steRilizasj§",
"stérilisations" => "steRilizasj§",
"stérilise" => "steRiliz",
"stérilisé" => "steRilize",
"stérilisée" => "steRilize",
"stérilisées" => "steRilize",
"stérilisent" => "steRiliz",
"stériliser" => "steRilize",
"stérilisés" => "steRilize",
"stérilisez" => "steRilize",
"stérilité" => "steRilite",
"sterling" => "stERliG",
"sternal" => "stERnal",
"sternale" => "stERnal",
"sterne" => "stERn",
"sternes" => "stERn",
"sterno-cléido-mastoïdien" => "stERnokleidomastOidj5",
"sternum" => "stERnOm",
"stéroïde" => "steRoid",
"stéroïdes" => "steRoid",
"stéthoscope" => "stetoskOp",
"stéthoscopes" => "stetoskOp",
"stetson" => "stEts§",
"steward" => "stiwaRd",
"stick" => "stik",
"sticker" => "stik9R",
"sticks" => "stik",
"stigma" => "stigma",
"stigmate" => "stigmat",
"stigmates" => "stigmat",
"stigmatisaient" => "stigmatizE",
"stigmatisait" => "stigmatizE",
"stigmatisant" => "stigmatiz@",
"stigmatisé" => "stigmatize",
"stigmatisée" => "stigmatize",
"stigmatiser" => "stigmatize",
"stigmatisés" => "stigmatize",
"stilton" => "stilt§",
"stimula" => "stimyla",
"stimulaient" => "stimylE",
"stimulait" => "stimylE",
"stimulant" => "stimyl@",
"stimulante" => "stimyl@t",
"stimulantes" => "stimyl@t",
"stimulants" => "stimyl@",
"stimulateur" => "stimylat9R",
"stimulation" => "stimylasj§",
"stimulations" => "stimylasj§",
"stimule" => "stimyl",
"stimulé" => "stimyle",
"stimulée" => "stimyle",
"stimulées" => "stimyle",
"stimulent" => "stimyl",
"stimuler" => "stimyle",
"stimulera" => "stimyl°Ra",
"stimulerait" => "stimyl°RE",
"stimuleront" => "stimyl°R§",
"stimulés" => "stimyle",
"stimulez" => "stimyle",
"stimuli" => "stimyli",
"stimulons" => "stimyl§",
"stimulus" => "stimylys",
"stimulus-réponse" => "stimylysRep§s",
"stipendiés" => "stip@dje",
"stipes" => "stip",
"stipulait" => "stipylE",
"stipulant" => "stipyl@",
"stipulation" => "stipylasj§",
"stipulations" => "stipylasj§",
"stipule" => "stipyl",
"stipulé" => "stipyle",
"stipulée" => "stipyle",
"stipulées" => "stipyle",
"stipulent" => "stipyl",
"stipuler" => "stipyle",
"stipulés" => "stipyle",
"stochastique" => "stOkastik",
"stock" => "stOk",
"stock-car" => "stOkkaR",
"stock-cars" => "stOkkaR",
"stock-options" => "stOkOpS9n",
"stockage" => "stokaZ",
"stockages" => "stokaZ",
"stockaient" => "stokE",
"stockait" => "stokE",
"stocke" => "stOk",
"stocké" => "stoke",
"stockée" => "stoke",
"stockées" => "stoke",
"stockent" => "stOk",
"stocker" => "stoke",
"stockés" => "stoke",
"stockez" => "stoke",
"stockons" => "stok§",
"stocks" => "stOk",
"stoïcien" => "stoisj5",
"stoïciens" => "stoisj5",
"stoïcisme" => "stoisizm",
"stoïque" => "stoik",
"stoïquement" => "stoik°m@",
"stoïques" => "stoik",
"stoker" => "stok9R",
"stokes" => "stOks",
"stomacal" => "stomakal",
"stomacale" => "stomakal",
"stomacales" => "stomakal",
"stomacaux" => "stomako",
"stomates" => "stomat",
"stomie" => "stOmi",
"stomoxys" => "stomOksi",
"stone" => "ston",
"stones" => "ston",
"stop" => "stOp",
"stoppa" => "stopa",
"stoppage" => "stopaZ",
"stoppai" => "stopE",
"stoppaient" => "stopE",
"stoppais" => "stopE",
"stoppait" => "stopE",
"stoppant" => "stop@",
"stoppât" => "stopa",
"stoppe" => "stOp",
"stoppé" => "stope",
"stoppée" => "stope",
"stoppées" => "stope",
"stoppent" => "stOp",
"stopper" => "stope",
"stoppera" => "stOp°Ra",
"stopperai" => "stOp°RE",
"stoppèrent" => "stopER",
"stopperiez" => "stOp°Rje",
"stoppes" => "stOp",
"stoppés" => "stope",
"stoppeur" => "stop9R",
"stoppeurs" => "stop9R",
"stoppeuse" => "stop2z",
"stoppez" => "stope",
"stoppions" => "stopj§",
"stoppons" => "stop§",
"stops" => "stOp",
"storage" => "stORaZ",
"store" => "stOR",
"stores" => "stOR",
"story board" => "stoRibORd",
"story-board" => "stoRibORd",
"story-boards" => "stoRibORd",
"stout" => "stut",
"strabisme" => "stRabizm",
"strabismes" => "stRabizm",
"stradivarius" => "stRadivaRjys",
"straight" => "stREt",
"stramoine" => "stRamwan",
"stramonium" => "stRamOnjOm",
"strangula" => "stR@gyla",
"strangulant" => "stR@gyl@",
"strangulation" => "stR@gylasj§",
"strangulé" => "stR@gyle",
"strangulées" => "stR@gyle",
"stranguler" => "stR@gyle",
"strapontin" => "stRap§t5",
"strapontins" => "stRap§t5",
"strasbourgeois" => "stRazbuRZwa",
"strasbourgeoise" => "stRazbuRZwaz",
"strass" => "stRas",
"strasse" => "stRas",
"stratagème" => "stRataZEm",
"stratagèmes" => "stRataZEm",
"strate" => "stRat",
"stratège" => "stRatEZ",
"stratèges" => "stRatEZ",
"stratégie" => "stRateZi",
"stratégies" => "stRateZi",
"stratégique" => "stRateZik",
"stratégiquement" => "stRateZik°m@",
"stratégiques" => "stRateZik",
"stratégiste" => "stRateZist",
"strates" => "stRat",
"stratification" => "stRatifikasj§",
"stratifications" => "stRatifikasj§",
"stratifié" => "stRatifje",
"stratifiée" => "stRatifje",
"stratifiées" => "stRatifje",
"stratigraphique" => "stRatigRafik",
"stratosphère" => "stRatosfER",
"stratosphérique" => "stRatosfeRik",
"stratosphériques" => "stRatosfeRik",
"stratus" => "stRatys",
"strelitzia" => "stRElitsja",
"streptococcie" => "stREptokOksi",
"streptococcique" => "stREptOkOksik",
"streptocoque" => "stREptokOk",
"streptokinase" => "stREptOkinaz",
"streptomycine" => "stREptomisin",
"stress" => "stREs",
"stressais" => "stREsE",
"stressait" => "stREsE",
"stressant" => "stREs@",
"stressante" => "stREs@t",
"stressantes" => "stREs@t",
"stressants" => "stREs@",
"stresse" => "stREs",
"stressé" => "stREse",
"stressée" => "stREse",
"stressées" => "stREse",
"stressent" => "stREs",
"stresser" => "stREse",
"stressera" => "stREs°Ra",
"stresserai" => "stREs°RE",
"stressés" => "stREse",
"stretch" => "stREtS",
"stretching" => "stREtSiG",
"striaient" => "stRijE",
"striait" => "stRijE",
"striations" => "stRiasj§",
"strict" => "stRikt",
"stricte" => "stRikt",
"strictement" => "stRikt°m@",
"strictes" => "stRikt",
"stricto sensu" => "stRiktOs5sy",
"stricts" => "stRikt",
"stridence" => "stRid@s",
"stridences" => "stRid@s",
"strident" => "stRid@",
"stridente" => "stRid@t",
"stridentes" => "stRid@t",
"stridents" => "stRid@",
"strider" => "stRide",
"stridor" => "stRidOR",
"stridulait" => "stRidylE",
"stridulation" => "stRidylasj§",
"stridulations" => "stRidylasj§",
"stridule" => "stRidyl",
"striduler" => "stRidyle",
"striduleuse" => "stRidyl2z",
"strie" => "stRi",
"strié" => "stRije",
"striée" => "stRije",
"striées" => "stRije",
"strient" => "stRi",
"strier" => "stRije",
"stries" => "stRi",
"striés" => "stRije",
"string" => "stRiG",
"strings" => "stRiG",
"strip" => "stRip",
"strip-poker" => "stRippokER",
"strip-tease" => "stRiptiz",
"strip-teases" => "stRiptiz",
"strip-teaseur" => "stRiptiz9R",
"strip-teaseurs" => "stRiptiz9R",
"strip-teaseuse" => "stRiptiz2z",
"strip-teaseuses" => "stRiptiz2z",
"stripper" => "stRip9R",
"striptease" => "stRiptiz",
"stripteaseuse" => "stRiptiz2z",
"stripteaseuses" => "stRiptiz2z",
"striures" => "stRijyR",
"stroboscope" => "stRObOskOp",
"stroboscopique" => "stRoboskopik",
"strontiane" => "stR§sjan",
"strontium" => "stR§sjOm",
"strophe" => "stROf",
"strophes" => "stROf",
"stropiats" => "stRopja",
"structura" => "stRyktyRa",
"structuraient" => "stRyktyRE",
"structurait" => "stRyktyRE",
"structural" => "stRyktyRal",
"structurale" => "stRyktyRal",
"structuralement" => "stRyktyRal°m@",
"structurales" => "stRyktyRal",
"structuralisme" => "stRyktyRalizm",
"structuraliste" => "stRyktyRalist",
"structuralistes" => "stRyktyRalist",
"structurant" => "stRyktyR@",
"structurations" => "stRyktyRasj§",
"structuraux" => "stRyktyRo",
"structure" => "stRyktyR",
"structuré" => "stRyktyRe",
"structurée" => "stRyktyRe",
"structurel" => "stRyktyREl",
"structurelle" => "stRyktyREl",
"structurellement" => "stRyktyREl°m@",
"structurels" => "stRyktyREl",
"structurent" => "stRyktyR",
"structurer" => "stRyktyRe",
"structures" => "stRyktyR",
"structurés" => "stRyktyRe",
"strudel" => "StRud9l",
"strudels" => "StRud9l",
"struggle for life" => "stR9g°lfoRlajf",
"strychnine" => "stRiknin",
"strychnos" => "stRiknos",
"stryges" => "stRiZ",
"stuc" => "styk",
"stucs" => "styk",
"studette" => "stydEt",
"studieuse" => "stydj2z",
"studieusement" => "stydj2z°m@",
"studieuses" => "stydj2z",
"studieux" => "stydj2",
"studio" => "stydjo",
"studiolo" => "stydjOlo",
"studios" => "stydjo",
"stuka" => "styka",
"stukas" => "styka",
"stup" => "styp",
"stupas" => "stypas",
"stupéfaction" => "stypefaksj§",
"stupéfait" => "stypefE",
"stupéfaite" => "stypefEt",
"stupéfaites" => "stypefEt",
"stupéfaits" => "stypefE",
"stupéfia" => "stypefja",
"stupéfiaient" => "stypefjE",
"stupéfiait" => "stypefjE",
"stupéfiant" => "stypefj@",
"stupéfiante" => "stypefj@t",
"stupéfiantes" => "stypefj@t",
"stupéfiants" => "stypefj@",
"stupéfie" => "stypefi",
"stupéfié" => "stypefje",
"stupéfiée" => "stypefje",
"stupéfiées" => "stypefje",
"stupéfient" => "stypefi",
"stupéfier" => "stypefje",
"stupéfierait" => "stypefiRE",
"stupéfiés" => "stypefje",
"stupéfiez" => "stypefje",
"stupeur" => "styp9R",
"stupide" => "stypid",
"stupidement" => "stypid°m@",
"stupides" => "stypid",
"stupidité" => "stypidite",
"stupidités" => "stypidite",
"stuporeuse" => "stypoR2z",
"stupre" => "stypR",
"stups" => "styp",
"stygien" => "stiZj5",
"style" => "stil",
"stylé" => "stile",
"stylée" => "stile",
"stylées" => "stile",
"styler" => "stile",
"styles" => "stil",
"stylés" => "stile",
"stylet" => "stilE",
"stylets" => "stilE",
"stylisa" => "stiliza",
"stylisation" => "stilizasj§",
"stylise" => "stiliz",
"stylisé" => "stilize",
"stylisée" => "stilize",
"stylisées" => "stilize",
"stylisés" => "stilize",
"stylisme" => "stilizm",
"styliste" => "stilist",
"stylistes" => "stilist",
"stylistique" => "stilistik",
"stylistiques" => "stilistik",
"stylite" => "stilit",
"stylo" => "stilo",
"stylo-bille" => "stilobij",
"stylo-feutre" => "stilof2tR",
"stylobille" => "stilobij",
"stylographe" => "stilogRaf",
"stylographes" => "stilogRaf",
"styloïde" => "stilOid",
"stylomine" => "stilomin",
"stylos" => "stilo",
"stylos-feutres" => "stilof2tR",
"styrax" => "stiRaks",
"styrène" => "stiREn",
"su" => "sy",
"sua" => "s8a",
"suaient" => "s8E",
"suaire" => "s8ER",
"suaires" => "s8ER",
"suais" => "s8E",
"suait" => "s8E",
"suant" => "s8@",
"suante" => "s8@t",
"suantes" => "s8@t",
"suants" => "s8@",
"suât" => "s8a",
"suave" => "s8av",
"suavement" => "s8av°m@",
"suaves" => "s8av",
"suavité" => "s8avite",
"sub" => "syb",
"sub-aquatique" => "sybakwatik",
"sub-atomique" => "sybatomik",
"sub-atomiques" => "sybatomik",
"sub-claquant" => "sybklak@",
"sub-espace" => "sybEspas",
"sub-normaux" => "sybnORmo",
"sub-nucléaires" => "sybnykleER",
"sub-véhiculaire" => "sybveikylER",
"sub-vocal" => "sybvokal",
"sub-zéro" => "sybzeRo",
"subaiguë" => "sybEgy",
"subalterne" => "sybaltERn",
"subalternes" => "sybaltERn",
"subaquatique" => "sybakwatik",
"subatomique" => "sybatomik",
"subatomiques" => "sybatomik",
"subcarpatique" => "sypkaRpatik",
"subcellulaire" => "sypsElylER",
"subconsciemment" => "sybk§sjam@",
"subconscient" => "sypk§sj@",
"subconsciente" => "sypk§sj@t",
"subconscientes" => "sypk§sj@t",
"subconscients" => "sypk§sj@",
"subculture" => "sybkyltyR",
"subdivisa" => "sybdiviza",
"subdivisaient" => "sybdivizE",
"subdivisait" => "sybdivizE",
"subdivisé" => "sybdivize",
"subdivisée" => "sybdivize",
"subdivisent" => "sybdiviz",
"subdivisés" => "sybdivize",
"subdivision" => "sybdivizj§",
"subdivisions" => "sybdivizj§",
"subduction" => "sybdyksj§",
"suber" => "sybER",
"subi" => "sybi",
"subie" => "sybi",
"subies" => "sybi",
"subir" => "sybiR",
"subira" => "sybiRa",
"subirai" => "sybiRE",
"subiraient" => "sybiRE",
"subirais" => "sybiRE",
"subirait" => "sybiRE",
"subiras" => "sybiRa",
"subirent" => "sybiR",
"subirez" => "sybiRe",
"subirions" => "sybiRj§",
"subirons" => "sybiR§",
"subiront" => "sybiR§",
"subis" => "sybi",
"subissaient" => "sybisE",
"subissais" => "sybisE",
"subissait" => "sybisE",
"subissant" => "sybis@",
"subisse" => "sybis",
"subissent" => "sybis",
"subisses" => "sybis",
"subissez" => "sybise",
"subissiez" => "sybisje",
"subissions" => "sybisj§",
"subissons" => "sybis§",
"subit" => "sybi",
"subît" => "sybi",
"subite" => "sybit",
"subitement" => "sybit°m@",
"subites" => "sybit",
"subîtes" => "sybit",
"subito" => "sybito",
"subits" => "sybi",
"subjectif" => "sybZEktif",
"subjectifs" => "sybZEktif",
"subjective" => "sybZEktiv",
"subjectivement" => "sybZEktiv°m@",
"subjectives" => "sybZEktiv",
"subjectivisme" => "sybZEktivizm",
"subjectiviste" => "sybZEktivist",
"subjectivité" => "sybZEktivite",
"subjonctif" => "sybZ§ktif",
"subjonctifs" => "sybZ§ktif",
"subjugation" => "sybZygasj§",
"subjugua" => "sybZyga",
"subjuguaient" => "sybZygE",
"subjuguait" => "sybZygE",
"subjuguant" => "sybZyg@",
"subjugue" => "sybZyg",
"subjugué" => "sybZyge",
"subjuguée" => "sybZyge",
"subjuguées" => "sybZyge",
"subjuguer" => "sybZyge",
"subjuguerais" => "sybZyg°RE",
"subjuguerait" => "sybZyg°RE",
"subjugues" => "sybZyg",
"subjugués" => "sybZyge",
"sublimable" => "syblimabl",
"sublimais" => "syblimE",
"sublimait" => "syblimE",
"sublimant" => "syblim@",
"sublimation" => "syblimasj§",
"sublimations" => "syblimasj§",
"sublime" => "syblim",
"sublimé" => "syblime",
"sublimée" => "syblime",
"sublimées" => "syblime",
"sublimement" => "syblim°m@",
"subliment" => "syblim",
"sublimer" => "syblime",
"sublimes" => "syblim",
"sublimés" => "syblime",
"subliminal" => "sybliminal",
"subliminale" => "sybliminal",
"subliminales" => "sybliminal",
"subliminaux" => "syblimino",
"sublimissime" => "syblimisim",
"sublimité" => "syblimite",
"sublimités" => "syblimite",
"sublingual" => "sybl5g8al",
"sublinguaux" => "sybl5gwo",
"sublunaire" => "syblynER",
"sublunaires" => "syblynER",
"submerge" => "sybmERZ",
"submergé" => "sybmERZe",
"submergea" => "sybmERZa",
"submergeaient" => "sybmERZE",
"submergeait" => "sybmERZE",
"submergeant" => "sybmERZ@",
"submergeât" => "sybmERZa",
"submergée" => "sybmERZe",
"submergées" => "sybmERZe",
"submergent" => "sybmERZ",
"submerger" => "sybmERZe",
"submergera" => "sybmERZ°Ra",
"submergerait" => "sybmERZ°RE",
"submergèrent" => "sybmERZER",
"submergés" => "sybmERZe",
"submersible" => "sybmERsibl",
"submersibles" => "sybmERsibl",
"submersion" => "sybmERsj§",
"subodora" => "sybodoRa",
"subodorais" => "sybodoRE",
"subodorait" => "sybodoRE",
"subodorant" => "sybodoR@",
"subodore" => "sybodOR",
"subodoré" => "sybodoRe",
"subodorent" => "sybodOR",
"subodorer" => "sybodoRe",
"subodorèrent" => "sybodoRER",
"subodorés" => "sybodoRe",
"suborbitale" => "sybORbital",
"subordination" => "sybORdinasj§",
"subordonnaient" => "sybORdonE",
"subordonnais" => "sybORdonE",
"subordonnant" => "sybORdon@",
"subordonne" => "sybORdOn",
"subordonné" => "sybORdone",
"subordonnée" => "sybORdone",
"subordonnées" => "sybORdone",
"subordonner" => "sybORdone",
"subordonnés" => "sybORdone",
"subornation" => "sybORnasj§",
"suborné" => "sybORne",
"subornée" => "sybORne",
"suborner" => "sybORne",
"subornés" => "sybORne",
"suborneur" => "sybORn9R",
"suborneurs" => "sybORn9R",
"subrécargue" => "sybRekaRg",
"subreptice" => "sybREptis",
"subrepticement" => "sybREptis°m@",
"subreptices" => "sybREptis",
"subrogation" => "sybRogasj§",
"subrogé" => "sybRoZe",
"subsaharienne" => "sybzaaRjEn",
"subséquemment" => "sypsekam@",
"subséquent" => "sybsek@",
"subséquente" => "sypsek@t",
"subséquentes" => "sypsek@t",
"subséquents" => "sypsek@",
"subside" => "sypzid",
"subsides" => "sybzid",
"subsidiaire" => "sybzidjER",
"subsidiairement" => "sybzidjER°m@",
"subsidiaires" => "sybzidjER",
"subsista" => "sybzista",
"subsistaient" => "sybzistE",
"subsistait" => "sybzistE",
"subsistâmes" => "sybzistam",
"subsistance" => "sybzist@s",
"subsistances" => "sybzist@s",
"subsistant" => "sybzist@",
"subsistantes" => "sybzist@t",
"subsistants" => "sybzist@",
"subsistât" => "sybzista",
"subsiste" => "sybzist",
"subsisté" => "sybziste",
"subsistent" => "sybzist",
"subsister" => "sybziste",
"subsistera" => "sybzist°Ra",
"subsisteraient" => "sybzist°RE",
"subsisterait" => "sybzist°RE",
"subsistèrent" => "sybzistER",
"subsisteront" => "sybzist°R§",
"subsistions" => "sybzistj§",
"subsistons" => "sybzist§",
"subsonique" => "sypsonik",
"substance" => "sypst@s",
"substances" => "sypst@s",
"substantiel" => "sypst@sjEl",
"substantielle" => "sypst@sjEl",
"substantiellement" => "sypst@sjEl°m@",
"substantielles" => "sypst@sjEl",
"substantiels" => "sypst@sjEl",
"substantif" => "sypst@tif",
"substantifique" => "sypst@tifik",
"substantifs" => "sypst@tif",
"substitua" => "sypstit8a",
"substituai" => "sypstit8E",
"substituaient" => "sypstit8E",
"substituait" => "sypstit8E",
"substituant" => "sypstit8@",
"substitue" => "sypstity",
"substitué" => "sypstit8e",
"substituées" => "sypstit8e",
"substituent" => "sypstity",
"substituer" => "sypstit8e",
"substituerait" => "sypstityRE",
"substituerez" => "sypstityRe",
"substitués" => "sypstit8e",
"substituez" => "sypstitye",
"substituons" => "sypstit8§",
"substitut" => "sypstity",
"substitution" => "sypstitysj§",
"substitutions" => "sypstitysj§",
"substituts" => "sypstity",
"substrat" => "sypstRa",
"substratum" => "sypstRatOm",
"substruction" => "sypstRyksj§",
"subterfuge" => "syptERfyZ",
"subterfuges" => "syptERfyZ",
"subtil" => "syptil",
"subtile" => "syptil",
"subtilement" => "syptil°m@",
"subtiles" => "syptil",
"subtilisa" => "syptiliza",
"subtilisait" => "syptilizE",
"subtilisant" => "syptiliz@",
"subtilisassent" => "syptilizas",
"subtilise" => "syptiliz",
"subtilisé" => "syptilize",
"subtilisée" => "syptilize",
"subtilisées" => "syptilize",
"subtiliser" => "syptilize",
"subtilisera" => "syptiliz°Ra",
"subtilisés" => "syptilize",
"subtilité" => "syptilite",
"subtilités" => "syptilite",
"subtils" => "syptil",
"subtropical" => "syptRopikal",
"subtropicale" => "syptRopikal",
"subtropicales" => "syptRopikal",
"suburbain" => "sybyRb5",
"suburbaine" => "sybyRbEn",
"suburbaines" => "sybyRbEn",
"suburbains" => "sybyRb5",
"subvenant" => "sybv2n@",
"subvenez" => "sybv°ne",
"subvenir" => "sybv°niR",
"subvention" => "sybv@sj§",
"subventionnant" => "sybv@sjon@",
"subventionne" => "sybv@sjOn",
"subventionné" => "sybv@sjone",
"subventionnée" => "sybv@sjone",
"subventionnées" => "sybv@sjone",
"subventionnent" => "sybv@sjOn",
"subventionner" => "sybv@sjone",
"subventionnera" => "sybv@sjOn°Ra",
"subventionnés" => "sybv@sjone",
"subventions" => "sybv@sj§",
"subvenu" => "sybv°ny",
"subversif" => "sybvERsif",
"subversifs" => "sybvERsif",
"subversion" => "sybvERsj§",
"subversions" => "sybvERsj§",
"subversive" => "sybvERsiv",
"subversives" => "sybvERsiv",
"subvertir" => "sybvERtiR",
"subviendra" => "sybvj5dRa",
"subviendrait" => "sybvj5dRE",
"subviens" => "sybvj5",
"subvient" => "sybvj5",
"suc" => "syk",
"suça" => "sysa",
"suçage" => "sysaZ",
"suçages" => "sysaZ",
"suçaient" => "sysE",
"suçais" => "sysE",
"suçait" => "sysE",
"suçant" => "sys@",
"succéda" => "sykseda",
"succédaient" => "syksedE",
"succédait" => "syksedE",
"succédâmes" => "syksedam",
"succédané" => "syksedane",
"succédanés" => "syksedane",
"succédant" => "syksed@",
"succédassent" => "syksedas",
"succédât" => "sykseda",
"succède" => "syksEd",
"succédé" => "syksede",
"succédées" => "syksede",
"succèdent" => "syksEd",
"succéder" => "syksede",
"succédera" => "syksed°Ra",
"succéderai" => "syksed°RE",
"succéderaient" => "syksed°RE",
"succéderait" => "syksed°RE",
"succéderas" => "syksed°Ra",
"succédèrent" => "syksedER",
"succéderez" => "syksed°Re",
"succéderiez" => "syksed°Rje",
"succéderont" => "syksed°R§",
"succédions" => "syksedj§",
"succès" => "syksE",
"successeur" => "sykses9R",
"successeurs" => "sykses9R",
"successibles" => "syksesibl",
"successif" => "syksesif",
"successifs" => "syksesif",
"succession" => "syksesj§",
"successions" => "syksesj§",
"successive" => "syksesiv",
"successivement" => "syksesiv°m@",
"successives" => "syksesiv",
"successoral" => "syksesORal",
"successorale" => "syksesORal",
"succinct" => "syks5",
"succincte" => "syks5t",
"succinctement" => "syks5t°m@",
"succinctes" => "syks5t",
"succion" => "sysj§",
"succions" => "sysj§",
"succomba" => "syk§ba",
"succombai" => "syk§bE",
"succombaient" => "syk§bE",
"succombais" => "syk§bE",
"succombait" => "syk§bE",
"succombant" => "syk§b@",
"succombe" => "syk§b",
"succombé" => "syk§be",
"succombent" => "syk§b",
"succomber" => "syk§be",
"succombera" => "syk§b°Ra",
"succomberai" => "syk§b°RE",
"succomberaient" => "syk§b°RE",
"succomberais" => "syk§b°RE",
"succomberait" => "syk§b°RE",
"succombèrent" => "syk§bER",
"succomberont" => "syk§b°R§",
"succombes" => "syk§b",
"succombez" => "syk§be",
"succombions" => "syk§bj§",
"succube" => "sykyb",
"succubes" => "sykyb",
"succulence" => "sykyl@s",
"succulent" => "sykyl@",
"succulente" => "sykyl@t",
"succulentes" => "sykyl@t",
"succulents" => "sykyl@",
"succursale" => "sykyRsal",
"succursales" => "sykyRsal",
"suce" => "sys",
"sucé" => "syse",
"sucée" => "syse",
"sucées" => "syse",
"sucent" => "sys",
"sucer" => "syse",
"sucera" => "sys°Ra",
"sucerai" => "sys°RE",
"suceraient" => "sys°RE",
"sucerais" => "sys°RE",
"sucerait" => "sys°RE",
"sucèrent" => "sysER",
"suces" => "sys",
"sucés" => "syse",
"sucette" => "sysEt",
"sucettes" => "sysEt",
"suceur" => "sys9R",
"suceurs" => "sys9R",
"suceuse" => "sys2z",
"suceuses" => "sys2z",
"sucez" => "syse",
"suçoir" => "syswaR",
"suçoirs" => "syswaR",
"suçon" => "sys§",
"suçons" => "sys§",
"suçota" => "sysota",
"suçotait" => "sysotE",
"suçotant" => "sysot@",
"suçote" => "sysOt",
"suçoté" => "sysote",
"suçotements" => "sysOt°m@",
"suçotent" => "sysOt",
"suçoter" => "sysote",
"sucra" => "sykRa",
"sucrait" => "sykRE",
"sucrant" => "sykR@",
"sucre" => "sykR",
"sucré" => "sykRe",
"sucrée" => "sykRe",
"sucrées" => "sykRe",
"sucrent" => "sykR",
"sucrer" => "sykRe",
"sucrerait" => "sykR°RE",
"sucrerie" => "sykR°Ri",
"sucreries" => "sykR°Ri",
"sucres" => "sykR",
"sucrés" => "sykRe",
"sucrette" => "sykREt",
"sucrettes" => "sykREt",
"sucrier" => "sykRije",
"sucrière" => "sykRijER",
"sucrières" => "sykRijER",
"sucriers" => "sykRije",
"sucrins" => "sykR5",
"sucs" => "syk",
"sud" => "syd",
"sud-africain" => "sydafRik5",
"sud-africaine" => "sydafRikEn",
"sud-africaines" => "sydafRikEn",
"sud-africains" => "sydafRik5",
"sud-américain" => "sydameRik5",
"sud-américaine" => "sydameRikEn",
"sud-américaines" => "sydameRikEn",
"sud-américains" => "sydameRik5",
"sud-coréen" => "sydkoRe5",
"sud-coréenne" => "sydkoReEn",
"sud-coréennes" => "sydkoReEn",
"sud-coréens" => "sydkoRe5",
"sud-est" => "sydEst",
"sud-ouest" => "sydwEst",
"sud-sud-est" => "sydsydEst",
"sud-vietnamien" => "sydvjEtnamj5",
"sud-vietnamienne" => "sydvjEtnamjEn",
"sud-vietnamiens" => "sydvjEtnamj5",
"sudation" => "sydasj§",
"sudatoires" => "sydatwaR",
"sudète" => "sydEt",
"sudètes" => "sydEt",
"sudiste" => "sydist",
"sudistes" => "sydist",
"sudoripare" => "sydoRipaR",
"sudoripares" => "sydoRipaR",
"sue" => "sy",
"sué" => "s8e",
"suède" => "s8Ed",
"suédine" => "s8edin",
"suédois" => "s8edwa",
"suédoise" => "s8edwaz",
"suédoises" => "s8edwaz",
"suée" => "s8e",
"suées" => "s8e",
"suent" => "sy",
"suer" => "s8e",
"suerai" => "syRE",
"suerais" => "syRE",
"suerait" => "syRE",
"suerte" => "swERte",
"sues" => "sy",
"sueur" => "s89R",
"sueurs" => "s89R",
"suez" => "sye",
"suffète" => "syfEt",
"suffi" => "syfi",
"sufficit" => "syfisit",
"suffira" => "syfiRa",
"suffirai" => "syfiRE",
"suffiraient" => "syfiRE",
"suffirais" => "syfiRE",
"suffirait" => "syfiRE",
"suffire" => "syfiR",
"suffirent" => "syfiR",
"suffiront" => "syfiR§",
"suffis" => "syfi",
"suffisaient" => "syfizE",
"suffisais" => "syfizE",
"suffisait" => "syfizE",
"suffisamment" => "syfizam@",
"suffisance" => "syfiz@s",
"suffisances" => "syfiz@s",
"suffisant" => "syfiz@",
"suffisante" => "syfiz@t",
"suffisantes" => "syfiz@t",
"suffisants" => "syfiz@",
"suffise" => "syfiz",
"suffisent" => "syfiz",
"suffisez" => "syfize",
"suffisions" => "syfizj§",
"suffisons" => "syfiz§",
"suffit" => "syfi",
"suffît" => "syfi",
"suffixes" => "syfiks",
"suffocant" => "syfok@",
"suffocante" => "syfok@t",
"suffocantes" => "syfok@t",
"suffocants" => "syfok@",
"suffocation" => "syfokasj§",
"suffocations" => "syfokasj§",
"suffoqua" => "syfoka",
"suffoquai" => "syfokE",
"suffoquaient" => "syfokE",
"suffoquais" => "syfokE",
"suffoquait" => "syfokE",
"suffoquant" => "syfok@",
"suffoque" => "syfOk",
"suffoqué" => "syfoke",
"suffoquée" => "syfoke",
"suffoquent" => "syfOk",
"suffoquer" => "syfoke",
"suffoquera" => "syfOk°Ra",
"suffoquerait" => "syfOk°RE",
"suffoquèrent" => "syfokER",
"suffoqueront" => "syfOk°R§",
"suffoqués" => "syfoke",
"suffoquez" => "syfoke",
"suffoquions" => "syfokj§",
"suffoquons" => "syfok§",
"suffrage" => "syfRaZ",
"suffrages" => "syfRaZ",
"suffragette" => "syfRaZEt",
"suffragettes" => "syfRaZEt",
"suggéra" => "sygZeRa",
"suggérai" => "sygZeRE",
"suggéraient" => "sygZeRE",
"suggérais" => "sygZeRE",
"suggérait" => "sygZeRE",
"suggérant" => "sygZeR@",
"suggérât" => "sygZeRa",
"suggère" => "sygZER",
"suggéré" => "sygZeRe",
"suggérée" => "sygZeRe",
"suggérées" => "sygZeRe",
"suggèrent" => "sygZER",
"suggérer" => "sygZeRe",
"suggérera" => "sygZeR°Ra",
"suggérerai" => "sygZeR°RE",
"suggérerais" => "sygZeR°RE",
"suggérerait" => "sygZeR°RE",
"suggérèrent" => "sygZeRER",
"suggères" => "sygZER",
"suggérés" => "sygZeRe",
"suggérez" => "sygZeRe",
"suggériez" => "sygZeRje",
"suggérions" => "sygZeRj§",
"suggérons" => "sygZeR§",
"suggestibilité" => "sygZEstibilite",
"suggestif" => "sygZEstif",
"suggestifs" => "sygZEstif",
"suggestion" => "sygZEstj§",
"suggestionné" => "sygZEstjone",
"suggestionner" => "sygZEstjone",
"suggestions" => "sygZEstj§",
"suggestive" => "sygZEstiv",
"suggestives" => "sygZEstiv",
"suggestivité" => "sygZEstivite",
"sui" => "s8i",
"sui generis" => "Es8iZ°n°Ri",
"suicida" => "s8isida",
"suicidaient" => "s8isidE",
"suicidaire" => "s8isidER",
"suicidaires" => "s8isidER",
"suicidait" => "s8isidE",
"suicidant" => "s8isid@",
"suicidants" => "s8isid@",
"suicidât" => "s8isida",
"suicide" => "s8isid",
"suicidé" => "s8iside",
"suicidée" => "s8iside",
"suicidées" => "s8iside",
"suicident" => "s8isid",
"suicider" => "s8iside",
"suicidera" => "s8isid°Ra",
"suiciderai" => "s8isid°RE",
"suiciderais" => "s8isid°RE",
"suiciderait" => "s8isid°RE",
"suicidèrent" => "s8isidER",
"suiciderez" => "s8isid°Re",
"suicideriez" => "s8isid°Rje",
"suicides" => "s8isid",
"suicidés" => "s8iside",
"suicidez" => "s8iside",
"suicidiez" => "s8isidje",
"suicidons" => "s8isid§",
"suie" => "s8i",
"suies" => "s8i",
"suif" => "s8if",
"suifer" => "s8ife",
"suifés" => "s8ife",
"suiffard" => "s8ifaR",
"suiffé" => "s8ife",
"suiffée" => "s8ife",
"suiffés" => "s8ife",
"suiffeuses" => "s8if2z",
"suiffeux" => "s8if2",
"suint" => "s85",
"suinta" => "s85ta",
"suintaient" => "s85tE",
"suintait" => "s85tE",
"suintant" => "s85t@",
"suintante" => "s85t@t",
"suintantes" => "s85t@t",
"suintants" => "s85t@",
"suinte" => "s85t",
"suinté" => "s85te",
"suintement" => "s85t°m@",
"suintements" => "s85t°m@",
"suintent" => "s85t",
"suinter" => "s85te",
"suis" => "s8i",
"suisse" => "s8is",
"suisses" => "s8is",
"suissesse" => "s8isEs",
"suissesses" => "s8isEs",
"suit" => "s8i",
"suite" => "s8it",
"suitée" => "s8ite",
"suites" => "s8it",
"suiv" => "s8iv",
"suivaient" => "s8ivE",
"suivais" => "s8ivE",
"suivait" => "s8ivE",
"suivant" => "s8iv@",
"suivante" => "s8iv@t",
"suivantes" => "s8iv@t",
"suivants" => "s8iv@",
"suive" => "s8iv",
"suivent" => "s8iv",
"suives" => "s8iv",
"suiveur" => "s8iv9R",
"suiveurs" => "s8iv9R",
"suiveuse" => "s8iv2z",
"suiveuses" => "s8iv2z",
"suivez" => "s8ive",
"suivez-moi-jeune-homme" => "s8ivemwaZ9nOm",
"suivi" => "s8ivi",
"suivie" => "s8ivi",
"suivies" => "s8ivi",
"suiviez" => "s8ivje",
"suivîmes" => "s8ivim",
"suivions" => "s8ivj§",
"suivirent" => "s8iviR",
"suivis" => "s8ivi",
"suivissent" => "s8ivis",
"suivistes" => "s8ivist",
"suivit" => "s8ivi",
"suivît" => "s8ivi",
"suivons" => "s8iv§",
"suivra" => "s8ivRa",
"suivrai" => "s8ivRE",
"suivraient" => "s8ivRE",
"suivrais" => "s8ivRE",
"suivrait" => "s8ivRE",
"suivras" => "s8ivRa",
"suivre" => "s8ivR",
"suivrez" => "s8ivRe",
"suivriez" => "s8ivRije",
"suivrions" => "s8ivRij§",
"suivrons" => "s8ivR§",
"suivront" => "s8ivR§",
"sujet" => "syZE",
"sujétion" => "syZesj§",
"sujétions" => "syZesj§",
"sujets" => "syZE",
"sujette" => "syZEt",
"sujettes" => "syZEt",
"sulfamide" => "sylfamid",
"sulfamides" => "sylfamid",
"sulfatages" => "sylfataZ",
"sulfatant" => "sylfat@",
"sulfate" => "sylfat",
"sulfaté" => "sylfate",
"sulfatées" => "sylfate",
"sulfater" => "sylfate",
"sulfates" => "sylfat",
"sulfateuse" => "sylfat2z",
"sulfateuses" => "sylfat2z",
"sulfhydrique" => "sylfidRik",
"sulfite" => "sylfit",
"sulfonate" => "sylfOnat",
"sulfonée" => "sylfone",
"sulfonés" => "sylfone",
"sulfonique" => "sylfOnik",
"sulfure" => "sylfyR",
"sulfuré" => "sylfyRe",
"sulfurée" => "sylfyRe",
"sulfures" => "sylfyR",
"sulfureuse" => "sylfyR2z",
"sulfureuses" => "sylfyR2z",
"sulfureux" => "sylfyR2",
"sulfurique" => "sylfyRik",
"sulfurisé" => "sylfyRize",
"sulky" => "sylki",
"sulpicien" => "sylpisj5",
"sulpicienne" => "sylpisjEn",
"sulpiciennes" => "sylpisjEn",
"sultan" => "sylt@",
"sultanat" => "syltana",
"sultane" => "syltan",
"sultanes" => "syltan",
"sultans" => "sylt@",
"sumac" => "symak",
"sumérien" => "symeRj5",
"sûmes" => "sym",
"summum" => "s9mOm",
"sumo" => "symo",
"sunlight" => "s9nlajt",
"sunlights" => "s9nlajt",
"sunna" => "syna",
"sunnites" => "synit",
"suons" => "sy§",
"super" => "sypER",
"super-espion" => "sypEREspj§",
"super-grands" => "sypERgR@",
"super-pilote" => "sypERpilOt",
"super-puissances" => "sypERp8is@s",
"superbe" => "sypERb",
"superbement" => "sypERb°m@",
"superbes" => "sypERb",
"supercalculateur" => "sypERkalkylat9R",
"supercarburant" => "sypERkaRbyR@",
"superchampion" => "sypERS@pj§",
"superchampions" => "sypERS@pj§",
"supercherie" => "sypERS°Ri",
"supercheries" => "sypERS°Ri",
"supérette" => "sypeREt",
"superfamille" => "sypERfamij",
"superfétatoire" => "sypERfetatwaR",
"superfétatoires" => "sypERfetatwaR",
"superficialité" => "sypERfisjalite",
"superficialités" => "sypERfisjalite",
"superficie" => "sypERfisi",
"superficiel" => "sypERfisjEl",
"superficielle" => "sypERfisjEl",
"superficiellement" => "sypERfisjEl°m@",
"superficielles" => "sypERfisjEl",
"superficiels" => "sypERfisjEl",
"superfin" => "sypERf5",
"superflu" => "sypERfly",
"superflue" => "sypERfly",
"superflues" => "sypERfly",
"superfluité" => "sypERfl8ite",
"superfluités" => "sypERfl8ite",
"superflus" => "sypERfly",
"superforteresses" => "sypERfORt°REs",
"supergrand" => "sypERgR@",
"supérieur" => "sypeRj9R",
"supérieure" => "sypeRj9R",
"supérieurement" => "sypeRj9R°m@",
"supérieures" => "sypeRj9R",
"supérieurs" => "sypeRj9R",
"superintendant" => "sypER5t@d@",
"superintendante" => "sypER5t@d@t",
"superintendants" => "sypER5t@d@",
"supériorité" => "sypeRjoRite",
"supériorités" => "sypeRjoRite",
"superlatif" => "sypERlatif",
"superlatifs" => "sypERlatif",
"superlative" => "sypERlativ",
"superlativement" => "sypERlativ°m@",
"superman" => "sypERman",
"supermarché" => "sypERmaRSe",
"supermarchés" => "sypERmaRSe",
"supermen" => "sypERmEn",
"supernova" => "sypERnova",
"supernovas" => "sypERnova",
"superordinateur" => "sypERORdinat9R",
"superphosphates" => "sypERfOsfat",
"superposa" => "sypERpoza",
"superposable" => "sypERpozabl",
"superposables" => "sypERpozabl",
"superposaient" => "sypERpozE",
"superposait" => "sypERpozE",
"superposant" => "sypERpoz@",
"superpose" => "sypERpoz",
"superposé" => "sypERpoze",
"superposée" => "sypERpoze",
"superposées" => "sypERpoze",
"superposent" => "sypERpoz",
"superposer" => "sypERpoze",
"superposés" => "sypERpoze",
"superposez" => "sypERpoze",
"superposition" => "sypERpozisj§",
"superpositions" => "sypERpozisj§",
"superpouvoirs" => "sypERpuvwaR",
"superproduction" => "sypERp°Rodyksj§",
"superproductions" => "sypERp°Rodyksj§",
"superpuissance" => "sypERp8is@s",
"superpuissances" => "sypERp8is@s",
"superpuissant" => "sypERp8is@",
"superpuissante" => "sypERp8is@t",
"superpuissants" => "sypERp8is@",
"supers" => "sypER",
"supersonique" => "sypERsonik",
"supersoniques" => "sypERsonik",
"superstar" => "sypERstaR",
"superstars" => "sypERstaR",
"superstitieuse" => "sypERstisj2z",
"superstitieusement" => "sypERstisj2z°m@",
"superstitieuses" => "sypERstisj2z",
"superstitieux" => "sypERstisj2",
"superstition" => "sypERstisj§",
"superstitions" => "sypERstisj§",
"superstructure" => "sypERstRyktyR",
"superstructures" => "sypERstRyktyR",
"supertanker" => "sypERt@kER",
"supervisa" => "sypERviza",
"supervisais" => "sypERvizE",
"supervisait" => "sypERvizE",
"supervisant" => "sypERviz@",
"supervise" => "sypERviz",
"supervisé" => "sypERvize",
"supervisée" => "sypERvize",
"supervisées" => "sypERvize",
"supervisent" => "sypERviz",
"superviser" => "sypERvize",
"supervisera" => "sypERviz°Ra",
"superviserai" => "sypERviz°RE",
"superviserais" => "sypERviz°RE",
"superviserait" => "sypERviz°RE",
"superviseras" => "sypERviz°Ra",
"superviserez" => "sypERviz°Re",
"superviserons" => "sypERviz°R§",
"superviseront" => "sypERviz°R§",
"supervisés" => "sypERvize",
"superviseur" => "sypERviz9R",
"superviseurs" => "sypERviz9R",
"supervisez" => "sypERvize",
"supervisiez" => "sypERvizje",
"supervision" => "sypERvizj§",
"supervisions" => "sypERvizj§",
"supervisons" => "sypERviz§",
"supin" => "syp5",
"supination" => "sypinasj§",
"supplanta" => "sypl@ta",
"supplantait" => "sypl@tE",
"supplantant" => "sypl@t@",
"supplante" => "sypl@t",
"supplanté" => "sypl@te",
"supplantée" => "sypl@te",
"supplantent" => "sypl@t",
"supplanter" => "sypl@te",
"suppléaient" => "sypleE",
"suppléait" => "sypleE",
"suppléance" => "syple@s",
"suppléant" => "syple@",
"suppléante" => "syple@t",
"suppléants" => "syple@",
"supplée" => "syple",
"suppléé" => "syplee",
"suppléent" => "syple",
"suppléer" => "syplee",
"suppléeraient" => "sypleRE",
"suppléerait" => "sypleRE",
"suppléerez" => "sypleRe",
"supplément" => "syplem@",
"supplémentaire" => "syplem@tER",
"supplémentaires" => "syplem@tER",
"supplémentées" => "syplem@te",
"supplémenter" => "syplem@te",
"suppléments" => "syplem@",
"supplétifs" => "sypletif",
"supplétive" => "sypletiv",
"supplia" => "syplija",
"suppliai" => "syplijE",
"suppliaient" => "syplijE",
"suppliais" => "syplijE",
"suppliait" => "syplijE",
"suppliant" => "syplij@",
"suppliante" => "syplij@t",
"suppliantes" => "syplij@t",
"suppliants" => "syplij@",
"suppliât" => "syplja",
"supplication" => "syplikasj§",
"supplications" => "syplikasj§",
"supplice" => "syplis",
"supplices" => "syplis",
"supplicia" => "syplisja",
"suppliciant" => "syplisj@",
"suppliciantes" => "syplisj@t",
"supplicié" => "syplisje",
"suppliciée" => "syplisje",
"suppliciées" => "syplisje",
"supplicient" => "syplisi",
"supplicier" => "syplisje",
"supplicierez" => "syplisiRe",
"suppliciés" => "syplisje",
"supplie" => "sypli",
"supplié" => "syplije",
"suppliée" => "syplije",
"supplient" => "sypli",
"supplier" => "syplije",
"suppliera" => "sypliRa",
"supplierai" => "sypliRE",
"supplieraient" => "sypliRE",
"supplierais" => "sypliRE",
"supplierait" => "sypliRE",
"supplieras" => "sypliRa",
"supplierez" => "sypliRe",
"supplieriez" => "sypliRje",
"supplieront" => "sypliR§",
"supplies" => "sypli",
"suppliés" => "syplije",
"suppliez" => "syplie",
"supplions" => "syplij§",
"supplique" => "syplik",
"suppliques" => "syplik",
"support" => "sypOR",
"supporta" => "sypORta",
"supportable" => "sypORtabl",
"supportables" => "sypORtabl",
"supportai" => "sypORtE",
"supportaient" => "sypORtE",
"supportais" => "sypORtE",
"supportait" => "sypORtE",
"supportant" => "sypORt@",
"supportât" => "sypORta",
"supporte" => "sypORt",
"supporté" => "sypORte",
"supportée" => "sypORte",
"supportées" => "sypORte",
"supportent" => "sypORt",
"supporter" => "sypoRte",
"supportera" => "sypORt°Ra",
"supporterai" => "sypORt°RE",
"supporteraient" => "sypORt°RE",
"supporterais" => "sypORt°RE",
"supporterait" => "sypORt°RE",
"supporteras" => "sypORt°Ra",
"supportèrent" => "sypORtER",
"supporterez" => "sypORt°Re",
"supporteriez" => "sypORt°Rje",
"supporterons" => "sypORt°R§",
"supporteront" => "sypORt°R§",
"supporters" => "sypORt9R",
"supportes" => "sypORt",
"supportés" => "sypORte",
"supporteur" => "sypORt9R",
"supportez" => "sypORte",
"supportiez" => "sypORtje",
"supportions" => "sypORtj§",
"supportons" => "sypORt§",
"supportrice" => "sypORtRis",
"supportrices" => "sypORtRis",
"supports" => "sypOR",
"supports-chaussettes" => "sypORSosEt",
"supposa" => "sypoza",
"supposable" => "sypozabl",
"supposai" => "sypozE",
"supposaient" => "sypozE",
"supposais" => "sypozE",
"supposait" => "sypozE",
"supposâmes" => "sypozam",
"supposant" => "sypoz@",
"suppose" => "sypoz",
"supposé" => "sypoze",
"supposée" => "sypoze",
"supposées" => "sypoze",
"supposément" => "sypozem@",
"supposent" => "sypoz",
"supposer" => "sypoze",
"supposera" => "sypoz°Ra",
"supposerai" => "sypoz°RE",
"supposerait" => "sypoz°RE",
"supposèrent" => "sypozER",
"supposeront" => "sypoz°R§",
"supposes" => "sypoz",
"supposés" => "sypoze",
"supposez" => "sypoze",
"supposiez" => "sypozje",
"supposions" => "sypozj§",
"supposition" => "sypozisj§",
"suppositions" => "sypozisj§",
"suppositoire" => "sypozitwaR",
"suppositoires" => "sypozitwaR",
"supposons" => "sypoz§",
"suppôt" => "sypo",
"suppôts" => "sypo",
"suppresseur" => "sypREs9R",
"suppression" => "sypResj§",
"suppressions" => "sypResj§",
"supprima" => "sypRima",
"supprimai" => "sypRimE",
"supprimaient" => "sypRimE",
"supprimais" => "sypRimE",
"supprimait" => "sypRimE",
"supprimant" => "sypRim@",
"supprimât" => "sypRima",
"supprime" => "sypRim",
"supprimé" => "sypRime",
"supprimée" => "sypRime",
"supprimées" => "sypRime",
"suppriment" => "sypRim",
"supprimer" => "sypRime",
"supprimera" => "sypRim°Ra",
"supprimerai" => "sypRim°RE",
"supprimeraient" => "sypRim°RE",
"supprimerait" => "sypRim°RE",
"supprimerons" => "sypRim°R§",
"supprimés" => "sypRime",
"supprimez" => "sypRime",
"supprimons" => "sypRim§",
"suppuraient" => "sypyRE",
"suppurait" => "sypyRE",
"suppurant" => "sypyR@",
"suppurante" => "sypyR@t",
"suppurantes" => "sypyR@t",
"suppuration" => "sypyRasj§",
"suppurations" => "sypyRasj§",
"suppure" => "sypyR",
"suppurent" => "sypyR",
"suppurer" => "sypyRe",
"suppurerait" => "sypyR°RE",
"supputa" => "sypyta",
"supputai" => "sypytE",
"supputaient" => "sypytE",
"supputais" => "sypytE",
"supputait" => "sypytE",
"supputant" => "sypyt@",
"supputation" => "sypytasj§",
"supputations" => "sypytasj§",
"suppute" => "sypyt",
"supputé" => "sypyte",
"supputées" => "sypyte",
"supputent" => "sypyt",
"supputer" => "sypyte",
"supra" => "sypRa",
"supra-humain" => "sypRaym5",
"supraconducteur" => "sypRak§dykt9R",
"supraconducteurs" => "sypRak§dykt9R",
"supraconductivité" => "sypRak§dyktivite",
"supraconductrice" => "sypRak§dyktRis",
"supranational" => "sypRanasjonal",
"supranationales" => "sypRanasjonal",
"supranaturel" => "sypRanatyREl",
"supraterrestre" => "sypRatEREstR",
"suprématie" => "sypRemasi",
"suprême" => "sypREm",
"suprêmement" => "sypREm°m@",
"suprêmes" => "sypREm",
"sur" => "syR",
"sûr" => "syR",
"sur-le-champ" => "syRl°S@",
"sur-mesure" => "syRm°zyR",
"sur-place" => "syRplas",
"surabondaient" => "syRab§dE",
"surabondamment" => "syRab§dam@",
"surabondance" => "syRab§d@s",
"surabondances" => "syRab§d@s",
"surabondant" => "syRab§d@",
"surabondante" => "syRab§d@t",
"surabondantes" => "syRab§d@t",
"surabondent" => "syRab§d",
"suractivé" => "syRaktive",
"suractivée" => "syRaktive",
"suractiver" => "syRaktive",
"suractivité" => "syRaktivite",
"suradaptation" => "syRadaptasj§",
"suradapté" => "syRadapte",
"surah" => "syRa",
"suraigu" => "syRegy",
"suraiguë" => "syRegy",
"suraiguës" => "syRegy",
"suraigus" => "syRegy",
"surajoute" => "syRaZut",
"surajouté" => "syRaZute",
"surajoutée" => "syRaZute",
"surajouter" => "syRaZute",
"surajoutés" => "syRaZute",
"suralimentation" => "syRalim@tasj§",
"suralimentée" => "syRalim@te",
"suralimenter" => "syRalim@te",
"suralimentes" => "syRalim@t",
"suralimentés" => "syRalim@te",
"suranné" => "syRane",
"surannée" => "syRane",
"surannées" => "syRane",
"surannés" => "syRane",
"surard" => "syRaR",
"surarmé" => "syRaRme",
"surarmée" => "syRaRme",
"surarmement" => "syRaRm2m@",
"surarmés" => "syRaRme",
"surbaissé" => "syRbEse",
"surbaissée" => "syRbEse",
"surbaissées" => "syRbEse",
"surbaissés" => "syRbEse",
"surbooké" => "syRbuke",
"surbookée" => "syRbuke",
"surbookées" => "syRbuke",
"surboum" => "syRbum",
"surboums" => "syRbum",
"surbrillance" => "syRbRij@s",
"surbrodé" => "syRbROde",
"surcapacité" => "syRkapasite",
"surcharge" => "syRSaRZ",
"surchargé" => "syRSaRZe",
"surchargeaient" => "syRSaRZE",
"surchargeait" => "syRSaRZE",
"surchargeant" => "syRSaRZ@",
"surchargée" => "syRSaRZe",
"surchargées" => "syRSaRZe",
"surcharger" => "syRSaRZe",
"surcharges" => "syRSaRZ",
"surchargés" => "syRSaRZe",
"surchauffait" => "syRSofE",
"surchauffe" => "syRSof",
"surchauffé" => "syRSofe",
"surchauffée" => "syRSofe",
"surchauffées" => "syRSofe",
"surchauffer" => "syRSofe",
"surchauffés" => "syRSofe",
"surchauffez" => "syRSofe",
"surchoix" => "syRSwa",
"surclassait" => "syRklasE",
"surclassant" => "syRklas@",
"surclasse" => "syRklas",
"surclassé" => "syRklase",
"surclassent" => "syRklas",
"surclasser" => "syRklase",
"surclasserais" => "syRklas°RE",
"surclasserait" => "syRklas°RE",
"surclasseras" => "syRklas°Ra",
"surclassés" => "syRklase",
"surcompensation" => "syRk§p@sasj§",
"surcompensé" => "syRk§p@se",
"surcompenser" => "syRk§p@se",
"surcomprimée" => "syRk§pRime",
"surconsommation" => "syRk§sOmasj§",
"surconsomme" => "syRkosOm",
"surcontre" => "syRk§tR",
"surcot" => "syRko",
"surcots" => "syRko",
"surcoupé" => "syRkupe",
"surcoût" => "syRku",
"surcroît" => "syRkRwa",
"surcroîts" => "syRkRwa",
"surdéterminé" => "syRdetERmine",
"surdéveloppé" => "syRdev°lOpe",
"surdéveloppée" => "syRdev°lOpe",
"surdéveloppées" => "syRdev°lope",
"surdévelopper" => "syRdev°lOpe",
"surdéveloppés" => "syRdev°lope",
"surdimensionné" => "syRdijm@sjone",
"surdimensionnée" => "syRdim@sjOne",
"surdité" => "syRdite",
"surdoré" => "syRdoRe",
"surdorée" => "syRdoRe",
"surdosage" => "syRdozaZ",
"surdose" => "syRdoz",
"surdoué" => "syRdwe",
"surdouée" => "syRdue",
"surdoués" => "syRdwe",
"sure" => "syR",
"sûre" => "syR",
"sureau" => "syRo",
"sureaux" => "syRo",
"sureffectif" => "syRefEktif",
"surélevait" => "syRel°vE",
"surélévation" => "syRelevasj§",
"surélève" => "syRelEv",
"surélevé" => "syRel°ve",
"surélevée" => "syRel°ve",
"surélevées" => "syRel°ve",
"surélever" => "syRel°ve",
"surélevés" => "syRel°ve",
"surélevez" => "syRel°ve",
"sûrement" => "syR°m@",
"suréminente" => "syRemin@t",
"suremploi" => "syR@plwa",
"surenchère" => "syR@SER",
"surenchères" => "syR@SER",
"surenchéri" => "syR@SeRi",
"surenchérir" => "syR@SeRiR",
"surenchérissant" => "syR@SeRis@",
"surenchérissent" => "syR@SeRis",
"surenchérit" => "syR@SeRi",
"surencombrée" => "syR@k§bRe",
"surendettés" => "syR@dEte",
"surent" => "syR",
"surentraîné" => "syR@tREne",
"surentraînées" => "syR@tREne",
"surentraînement" => "syR@tREn°m@",
"surentraînés" => "syR@tREne",
"suréquipée" => "syRekipe",
"sures" => "syR",
"sûres" => "syR",
"surestimation" => "syREstimasj§",
"surestime" => "syREstim",
"surestimé" => "syREstime",
"surestimée" => "syREstime",
"surestimer" => "syREstime",
"surestimerais" => "syREstim°RE",
"surestimés" => "syREstime",
"surestimez" => "syREstime",
"suret" => "syRE",
"sûreté" => "syR°te",
"sûretés" => "syR°te",
"surets" => "syRE",
"surette" => "syREt",
"surévaluation" => "syReval8asj§",
"surévalué" => "syReval8e",
"surexcitait" => "syREksitE",
"surexcitant" => "syREksit@",
"surexcitation" => "syREksitasj§",
"surexcite" => "syREksit",
"surexcité" => "syREksite",
"surexcitée" => "syREksite",
"surexcitées" => "syREksite",
"surexciter" => "syREksite",
"surexcités" => "syREksite",
"surexploité" => "syREksplwate",
"surexposé" => "syREkspoze",
"surexposée" => "syREkspoze",
"surexposées" => "syREkspoze",
"surexposés" => "syREkspoze",
"surexposition" => "syREkspozisj§",
"surf" => "s9Rf",
"surfaçage" => "syRfasaZ",
"surface" => "syRfas",
"surfacer" => "syRfase",
"surfaces" => "syRfas",
"surfactant" => "syRfakt@",
"surfacturation" => "syRfaktyRasj§",
"surfacture" => "syRfaktyR",
"surfacturé" => "syRfaktyRe",
"surfacturer" => "syRfaktyRe",
"surfacturés" => "syRfaktyRe",
"surfaire" => "syRfER",
"surfais" => "s9RfE",
"surfaisait" => "syRf°zE",
"surfait" => "syRfE",
"surfaite" => "syRfEt",
"surfaites" => "s9RfEt",
"surfaits" => "syRfE",
"surfant" => "syRf@",
"surfe" => "s9Rf",
"surfé" => "s9Rfe",
"surfent" => "s9Rf",
"surfer" => "s9Rfe",
"surferas" => "s9Rf°Ra",
"surfes" => "s9Rf",
"surfeur" => "s9Rf9R",
"surfeurs" => "s9Rf9R",
"surfeuse" => "s9Rf2z",
"surfeuses" => "s9Rf2z",
"surfez" => "s9Rfe",
"surfilage" => "syRfilaZ",
"surfin" => "syRf5",
"surfine" => "syRfin",
"surfons" => "syRf§",
"surgé" => "syRZe",
"surgèle" => "syRZEl",
"surgelé" => "syRZ°le",
"surgelée" => "syRZ°le",
"surgelées" => "syRZ°le",
"surgeler" => "syRZ°le",
"surgelés" => "syRZ°le",
"surgénérateur" => "syRZeneRat9R",
"surgeon" => "syRZ§",
"surgeonnent" => "syRZOn",
"surgeons" => "syRZ§",
"surgi" => "syRZi",
"surgie" => "syRZi",
"surgies" => "syRZi",
"surgir" => "syRZiR",
"surgira" => "syRZiRa",
"surgiraient" => "syRZiRE",
"surgirait" => "syRZiRE",
"surgirent" => "syRZiR",
"surgiront" => "syRZiR§",
"surgis" => "syRZi",
"surgissaient" => "syRZisE",
"surgissais" => "syRZisE",
"surgissait" => "syRZisE",
"surgissant" => "syRZis@",
"surgisse" => "syRZis",
"surgissement" => "syRZis°m@",
"surgissements" => "syRZis°m@",
"surgissent" => "syRZis",
"surgissez" => "syRZise",
"surgit" => "syRZi",
"surgît" => "syRZi",
"surhomme" => "syROm",
"surhommes" => "syROm",
"surhumain" => "syRym5",
"surhumaine" => "syRymEn",
"surhumaines" => "syRymEn",
"surhumains" => "syRym5",
"surhumanité" => "syRymanite",
"suri" => "syRi",
"suricate" => "syRikat",
"surie" => "syRi",
"suries" => "syRi",
"surimi" => "syRimi",
"surimpression" => "syR5pResj§",
"surimpressions" => "syR5pREsj§",
"surin" => "syR5",
"surinait" => "syRinE",
"surine" => "syRin",
"suriné" => "syRine",
"surinent" => "syRin",
"suriner" => "syRine",
"surinerais" => "syRin°RE",
"surinfections" => "syR5fEksj§",
"surinformation" => "syR5fORmasj§",
"surinformé" => "syR5fORme",
"surins" => "syR5",
"surintendance" => "syR5t@d@s",
"surintendant" => "syR5t@d@",
"surintendante" => "syR5t@d@t",
"surintensité" => "syR5t@site",
"surinvestissement" => "syR5vEstis°m@",
"surir" => "syRiR",
"surit" => "syRi",
"surjet" => "syRZE",
"surjeteuse" => "syRZ2t2z",
"surjets" => "syRZE",
"surlendemain" => "syRl@d°m5",
"surligné" => "syRliNe",
"surligner" => "syRliNe",
"surligneur" => "syRliN9R",
"surmâle" => "syRmal",
"surmédicalisation" => "syRmedikalizasj§",
"surmenage" => "syRm°naZ",
"surmenait" => "syRm°nE",
"surmenant" => "syRm°n@",
"surmène" => "syRmEn",
"surmené" => "syRm°ne",
"surmenée" => "syRm°ne",
"surmenées" => "syRm°ne",
"surmener" => "syRm°ne",
"surmenés" => "syRm°ne",
"surmenez" => "syRm°ne",
"surmoi" => "syRmwa",
"surmonta" => "syRm§ta",
"surmontai" => "syRm§tE",
"surmontaient" => "syRm§tE",
"surmontais" => "syRm§tE",
"surmontait" => "syRm§tE",
"surmontant" => "syRm§t@",
"surmonte" => "syRm§t",
"surmonté" => "syRm§te",
"surmontée" => "syRm§te",
"surmontées" => "syRm§te",
"surmontent" => "syRm§t",
"surmonter" => "syRm§te",
"surmontera" => "syRm§t°Ra",
"surmonterai" => "syRm§t°RE",
"surmonteraient" => "syRm§t°RE",
"surmonterait" => "syRm§t°RE",
"surmonteras" => "syRm§t°Ra",
"surmontèrent" => "syRm§tER",
"surmonterez" => "syRm§t°Re",
"surmonterons" => "syRm§t°R§",
"surmontés" => "syRm§te",
"surmontez" => "syRm§te",
"surmontions" => "syRm§tj§",
"surmulot" => "syRmylo",
"surmulots" => "syRmylo",
"surmultipliée" => "syRmyltiplije",
"surmultipliées" => "syRmyltiplije",
"surnage" => "syRnaZ",
"surnagé" => "syRnaZe",
"surnagea" => "syRnaZa",
"surnageaient" => "syRnaZE",
"surnageait" => "syRnaZE",
"surnageant" => "syRnaZ@",
"surnageants" => "syRnaZ@",
"surnagent" => "syRnaZ",
"surnageons" => "syRnaZ§",
"surnager" => "syRnaZe",
"surnagera" => "syRnaZ°Ra",
"surnagèrent" => "syRnaZER",
"surnages" => "syRnaZ",
"surnaturel" => "syRnatyREl",
"surnaturelle" => "syRnatyREl",
"surnaturelles" => "syRnatyREl",
"surnaturels" => "syRnatyREl",
"surnom" => "syRn§",
"surnombre" => "syRn§bR",
"surnomma" => "syRnoma",
"surnommaient" => "syRnomE",
"surnommais" => "syRnomE",
"surnommait" => "syRnomE",
"surnommant" => "syRnom@",
"surnomme" => "syRnOm",
"surnommé" => "syRnome",
"surnommée" => "syRnome",
"surnomment" => "syRnOm",
"surnommer" => "syRnome",
"surnommera" => "syRnom°Ra",
"surnommerais" => "syRnom°RE",
"surnommèrent" => "syRnomER",
"surnommés" => "syRnome",
"surnommions" => "syRnomj§",
"surnoms" => "syRn§",
"surnuméraire" => "syRnymeRER",
"surnuméraires" => "syRnymeRER",
"suroît" => "syRwa",
"suroîts" => "syRwa",
"suroxygéné" => "syROksiZene",
"suroxygéner" => "syROksiZene",
"surpassa" => "syRpasa",
"surpassaient" => "syRpasE",
"surpassais" => "syRpasE",
"surpassait" => "syRpasE",
"surpassant" => "syRpas@",
"surpassât" => "syRpasa",
"surpasse" => "syRpas",
"surpassé" => "syRpase",
"surpassée" => "syRpase",
"surpassées" => "syRpase",
"surpassent" => "syRpas",
"surpasser" => "syRpase",
"surpassera" => "syRpas°Ra",
"surpasserai" => "syRpas°RE",
"surpasseraient" => "syRpas°RE",
"surpasserait" => "syRpas°RE",
"surpasseras" => "syRpas°Ra",
"surpasses" => "syRpas",
"surpassés" => "syRpase",
"surpassez" => "syRpase",
"surpassons" => "syRpas§",
"surpatte" => "syRpat",
"surpattes" => "syRpat",
"surpaye" => "syRpEj",
"surpayé" => "syRpEje",
"surpayés" => "syRpEje",
"surpeuplé" => "syRp9ple",
"surpeuplée" => "syRp9ple",
"surpeuplées" => "syRp9ple",
"surpeuplement" => "syRp9pl°m@",
"surpeupler" => "syRp9ple",
"surpeuplés" => "syRp9ple",
"surpiqûres" => "syRpikyR",
"surplace" => "syRplas",
"surplis" => "syRpli",
"surplomb" => "syRpl§",
"surplomba" => "syRpl§ba",
"surplombaient" => "syRpl§bE",
"surplombait" => "syRpl§bE",
"surplombant" => "syRpl§b@",
"surplombante" => "syRpl§b@t",
"surplombe" => "syRpl§b",
"surplombé" => "syRpl§be",
"surplombée" => "syRpl§be",
"surplombent" => "syRpl§b",
"surplomber" => "syRpl§be",
"surplomberait" => "syRpl§b°RE",
"surplombés" => "syRpl§be",
"surplombions" => "syRpl§bj§",
"surplombs" => "syRpl§",
"surplus" => "syRply",
"surpoids" => "syRpwa",
"surpopulation" => "syRpopylasj§",
"surprenaient" => "syRpR°nE",
"surprenais" => "syRpR°nE",
"surprenait" => "syRpR°nE",
"surprenant" => "syRpR°n@",
"surprenante" => "syRpR°n@t",
"surprenantes" => "syRpR°n@t",
"surprenants" => "syRpR°n@",
"surprend" => "syRpR@",
"surprendra" => "syRpR@dRa",
"surprendrai" => "syRpR@dRE",
"surprendraient" => "syRpR@dRE",
"surprendrais" => "syRpR@dRE",
"surprendrait" => "syRpR@dRE",
"surprendras" => "syRpR@dRa",
"surprendre" => "syRpR@dR",
"surprendrez" => "syRpR@dRe",
"surprendrons" => "syRpR@dR§",
"surprendront" => "syRpR@dR§",
"surprends" => "syRpR@",
"surprenez" => "syRpR°ne",
"surpreniez" => "syRpR°nje",
"surprenions" => "syRpR°nj§",
"surprenne" => "syRpREn",
"surprennent" => "syRpREn",
"surprenons" => "syRpR°n§",
"surpresseur" => "syRpRes9R",
"surpression" => "syRpREsj§",
"surprime" => "syRpRim",
"surprirent" => "syRpRiR",
"surpris" => "syRpRi",
"surprise" => "syRpRiz",
"surprise-partie" => "syRpRizpaRti",
"surprise-party" => "syRpRizpaRti",
"surprises" => "syRpRiz",
"surprises-parties" => "syRpRizpaRti",
"surprit" => "syRpRi",
"surprît" => "syRpRi",
"surproduction" => "syRpRodyksj§",
"surprotecteur" => "syRpRotEkt9R",
"surprotectrice" => "syRpRotEktRis",
"surprotège" => "syRpRotEZ",
"surprotégé" => "syRpROteZe",
"surprotégeais" => "syRpRoteZE",
"surprotéger" => "syRpROteZe",
"surpuissance" => "syRp8is@s",
"surpuissant" => "syRp8is@",
"surpuissante" => "syRp8is@t",
"surpuissants" => "syRp8is@",
"surqualifié" => "syRkalifje",
"surqualifiée" => "syRkalifje",
"surréalisme" => "syRRealizm",
"surréaliste" => "syRRealist",
"surréalistes" => "syRRealist",
"surréalité" => "syRRealite",
"surréel" => "syRReEl",
"surréelle" => "syRReEl",
"surréelles" => "syRReEl",
"surrégime" => "syRReZim",
"surrénal" => "syRRenal",
"surrénale" => "syRRenal",
"surrénales" => "syRRenal",
"surrénalien" => "syRRenalj5",
"surréservation" => "syRezERvasj§",
"surs" => "syR",
"sûrs" => "syR",
"sursaturé" => "syRsatyRe",
"sursaturée" => "syRsatyRe",
"sursaturées" => "syRsatyRe",
"sursaut" => "syRso",
"sursauta" => "syRsota",
"sursautai" => "syRsotE",
"sursautaient" => "syRsotE",
"sursautais" => "syRsotE",
"sursautait" => "syRsotE",
"sursautant" => "syRsot@",
"sursautât" => "syRsota",
"sursaute" => "syRsot",
"sursauté" => "syRsote",
"sursautent" => "syRsot",
"sursauter" => "syRsote",
"sursauteraient" => "syRsot°RE",
"sursauterais" => "syRsot°RE",
"sursautèrent" => "syRsotER",
"sursautez" => "syRsote",
"sursautons" => "syRsot§",
"sursauts" => "syRso",
"surseoir" => "syRswaR",
"sursis" => "syRsi",
"sursitaire" => "syRsitER",
"sursitaires" => "syRsitER",
"sursum corda" => "syRsOmkORda",
"surtaxe" => "syRtaks",
"surtaxer" => "syRtakse",
"surtaxes" => "syRtaks",
"surtaxés" => "syRtakse",
"surtendu" => "syRt@dy",
"surtension" => "syRt@sj§",
"surtout" => "syRtu",
"surtouts" => "syRtu",
"survécu" => "syRveky",
"survécûmes" => "syRvekym",
"survécurent" => "syRvekyR",
"survécus" => "syRveky",
"survécut" => "syRveky",
"survécût" => "syRveky",
"surveilla" => "syRvEja",
"surveillaient" => "syRvEjE",
"surveillais" => "syRvEjE",
"surveillait" => "syRvEjE",
"surveillance" => "syRvEj@s",
"surveillances" => "syRvEj@s",
"surveillant" => "syRvEj@",
"surveillante" => "syRvEj@t",
"surveillantes" => "syRvEj@t",
"surveillants" => "syRvEj@",
"surveillât" => "syRvEja",
"surveille" => "syRvEj",
"surveillé" => "syRveje",
"surveillée" => "syRveje",
"surveillées" => "syRveje",
"surveillent" => "syRvEj",
"surveiller" => "syRveje",
"surveillera" => "syRvEj°Ra",
"surveillerai" => "syRvEj°RE",
"surveilleraient" => "syRvEj°RE",
"surveillerais" => "syRvEj°RE",
"surveillerait" => "syRvEj°RE",
"surveilleras" => "syRvEj°Ra",
"surveillerez" => "syRvEj°Re",
"surveillerons" => "syRvEj°R§",
"surveilleront" => "syRvEj°R§",
"surveilles" => "syRvEj",
"surveillés" => "syRveje",
"surveillez" => "syRvEje",
"surveilliez" => "syRvEje",
"surveillions" => "syRvEjj§",
"surveillons" => "syRvEj§",
"survenaient" => "syRv°nE",
"survenais" => "syRv°nE",
"survenait" => "syRv°nE",
"survenant" => "syRv°n@",
"survenants" => "syRv°n@",
"survenir" => "syRv°niR",
"survenu" => "syRv°ny",
"survenue" => "syRv°ny",
"survenues" => "syRv°ny",
"survenus" => "syRv°ny",
"survêt" => "syRvE",
"survêtement" => "syRvEt°m@",
"survêtements" => "syRvEt°m@",
"survêts" => "syRvE",
"survie" => "syRvi",
"surviendra" => "syRvj5dRa",
"surviendraient" => "syRvj5dRE",
"surviendrait" => "syRvj5dRE",
"surviendront" => "syRvj5dR§",
"survienne" => "syRvjEn",
"surviennent" => "syRvjEn",
"survient" => "syRvj5",
"survinrent" => "syRv5R",
"survint" => "syRv5",
"survînt" => "syRv5",
"survire" => "syRviR",
"survis" => "syRvi",
"survit" => "syRvi",
"survitesse" => "syRvitEs",
"survivaient" => "syRvivE",
"survivais" => "syRvivE",
"survivait" => "syRvivE",
"survivaliste" => "syRvivalist",
"survivance" => "syRviv@s",
"survivances" => "syRviv@s",
"survivant" => "syRviv@",
"survivante" => "syRviv@t",
"survivantes" => "syRviv@t",
"survivants" => "syRviv@",
"survive" => "syRviv",
"survivent" => "syRviv",
"survives" => "syRviv",
"survivez" => "syRvive",
"surviviez" => "syRvivje",
"survivions" => "syRvivj§",
"survivons" => "syRviv§",
"survivra" => "syRvivRa",
"survivrai" => "syRvivRE",
"survivraient" => "syRvivRE",
"survivrais" => "syRvivRE",
"survivrait" => "syRvivRE",
"survivras" => "syRvivRa",
"survivre" => "syRvivR",
"survivrez" => "syRvivRe",
"survivriez" => "syRvivRie",
"survivrons" => "syRvivR§",
"survivront" => "syRvivR§",
"survol" => "syRvOl",
"survola" => "syRvola",
"survolaient" => "syRvolE",
"survolais" => "syRvolE",
"survolait" => "syRvolE",
"survolâmes" => "syRvolam",
"survolant" => "syRvol@",
"survole" => "syRvOl",
"survolé" => "syRvole",
"survolée" => "syRvole",
"survolées" => "syRvole",
"survolent" => "syRvOl",
"survoler" => "syRvole",
"survolera" => "syRvOl°Ra",
"survolerai" => "syRvOl°RE",
"survolerez" => "syRvOl°Re",
"survolerons" => "syRvOl°R§",
"survolez" => "syRvole",
"survolions" => "syRvolj§",
"survolons" => "syRvol§",
"survols" => "syRvOl",
"survoltage" => "syRvOltaZ",
"survoltait" => "syRvOltE",
"survolté" => "syRvOlte",
"survoltée" => "syRvOlte",
"survoltées" => "syRvOlte",
"survoltés" => "syRvOlte",
"survolteur" => "syRvOlt9R",
"sus" => "sys",
"sus-orbitaire" => "sysORbitER",
"susceptibilité" => "sysEptibilite",
"susceptibilités" => "sysEptibilite",
"susceptible" => "sysEptibl",
"susceptibles" => "sysEptibl",
"suscita" => "sysita",
"suscitaient" => "sysitE",
"suscitais" => "sysitE",
"suscitait" => "sysitE",
"suscitant" => "sysit@",
"suscite" => "sysit",
"suscité" => "sysite",
"suscitée" => "sysite",
"suscitées" => "sysite",
"suscitent" => "sysit",
"susciter" => "sysite",
"susciteraient" => "sysit°RE",
"susciterait" => "sysit°RE",
"susciteront" => "sysit°R§",
"suscites" => "sysit",
"suscités" => "sysite",
"suscription" => "syskRipsj§",
"susdit" => "sysdi",
"susdite" => "sysdit",
"susdites" => "sysdit",
"sushi" => "suSi",
"susmentionné" => "sysm@sjone",
"susmentionnée" => "sysm@sjone",
"susnommé" => "sysnome",
"susnommée" => "sysnome",
"susnommés" => "sysnome",
"suspect" => "syspE",
"suspectaient" => "syspEktE",
"suspectais" => "syspEktE",
"suspectait" => "syspEktE",
"suspectant" => "syspEkt@",
"suspecte" => "syspEkt",
"suspecté" => "syspEkte",
"suspectée" => "syspEkte",
"suspectées" => "syspEkte",
"suspectent" => "syspEkt",
"suspecter" => "syspEkte",
"suspectera" => "syspEkt°Ra",
"suspecteraient" => "syspEkt°RE",
"suspecterait" => "syspEkt°RE",
"suspecteront" => "syspEkt°R§",
"suspectes" => "syspEkt",
"suspectés" => "syspEkte",
"suspectez" => "syspEkte",
"suspectiez" => "syspEktje",
"suspectons" => "syspEkt§",
"suspects" => "syspE",
"suspend" => "sysp@",
"suspendaient" => "sysp@dE",
"suspendais" => "sysp@dE",
"suspendait" => "sysp@dE",
"suspendant" => "sysp@d@",
"suspende" => "sysp@d",
"suspendent" => "sysp@d",
"suspendez" => "sysp@de",
"suspendirent" => "sysp@diR",
"suspendit" => "sysp@di",
"suspendît" => "sysp@di",
"suspendons" => "sysp@d§",
"suspendra" => "sysp@dRa",
"suspendrai" => "sysp@dRE",
"suspendrait" => "sysp@dRE",
"suspendre" => "sysp@dR",
"suspendrez" => "sysp@dRe",
"suspendrons" => "sysp@dR§",
"suspendront" => "sysp@dR§",
"suspends" => "sysp@",
"suspendu" => "sysp@dy",
"suspendue" => "sysp@dy",
"suspendues" => "sysp@dy",
"suspendus" => "sysp@dy",
"suspens" => "sysp@",
"suspense" => "syspEns",
"suspenses" => "syspEns",
"suspenseur" => "sysp@s9R",
"suspenseurs" => "sysp@s9R",
"suspensif" => "sysp@sif",
"suspension" => "sysp@sj§",
"suspensions" => "sysp@sj§",
"suspensive" => "sysp@siv",
"suspensoir" => "sysp@swaR",
"suspensoirs" => "sysp@swaR",
"suspente" => "sysp@t",
"suspentes" => "sysp@t",
"suspicieuse" => "syspisj2z",
"suspicieusement" => "syspisj2z°m@",
"suspicieuses" => "syspisj2z",
"suspicieux" => "syspisj2",
"suspicion" => "syspisj§",
"suspicions" => "syspisj§",
"susse" => "sys",
"sussent" => "sys",
"sustentation" => "syst@tasj§",
"sustente" => "syst@t",
"sustenter" => "syst@te",
"sustentés" => "syst@te",
"susu" => "sysy",
"susucre" => "sysykR",
"susurra" => "sysyRa",
"susurrai" => "sysyRE",
"susurraient" => "sysyRE",
"susurrait" => "sysyRE",
"susurrant" => "sysyR@",
"susurre" => "sysyR",
"susurré" => "sysyRe",
"susurrée" => "sysyRe",
"susurrées" => "sysyRe",
"susurrement" => "sysyR°m@",
"susurrements" => "sysyR°m@",
"susurrent" => "sysyR",
"susurrer" => "sysyRe",
"susurrerai" => "sysyR°RE",
"susurrés" => "sysyRe",
"susvisée" => "sysvize",
"sut" => "sy",
"sût" => "sy",
"sutémi" => "sutemi",
"sutra" => "sutRa",
"suturant" => "sytyR@",
"suture" => "sytyR",
"suturé" => "sytyRe",
"suturée" => "sytyRe",
"suturer" => "sytyRe",
"sutures" => "sytyR",
"suzerain" => "syzR5",
"suzeraine" => "syzREn",
"suzeraineté" => "syzREn°te",
"suzerains" => "syzR5",
"svastika" => "svastika",
"svastikas" => "svastika",
"svelte" => "svElt",
"sveltes" => "svElt",
"sveltesse" => "svEltEs",
"svp" => "Esvepe",
"swahili" => "swaili",
"sweat-shirt" => "switS9Rt",
"sweater" => "swit9R",
"sweaters" => "swit9R",
"sweepstake" => "swipstEjk",
"swiftiennes" => "swiftjEn",
"swing" => "swiG",
"swings" => "swiG",
"swinguaient" => "swiGE",
"sybarites" => "sibaRit",
"sybaritisme" => "sibaRitizm",
"sycomore" => "sikomOR",
"sycomores" => "sikomOR",
"sycophante" => "sikof@t",
"sycophantes" => "sikof@t",
"syénite" => "sjenit",
"syllabe" => "silab",
"syllabes" => "silab",
"syllabus" => "silabys",
"syllepse" => "silEps",
"syllogisme" => "siloZizm",
"syllogismes" => "siloZizm",
"syllogistique" => "silOZistik",
"syllogistiques" => "siloZistik",
"sylphes" => "silf",
"sylphide" => "silfid",
"sylphides" => "silfid",
"sylvain" => "silv5",
"sylvains" => "silv5",
"sylvaner" => "silvanER",
"sylve" => "silv",
"sylvestre" => "silvEstR",
"sylvestres" => "silvEstR",
"sylviculture" => "silvikyltyR",
"sylvie" => "silvi",
"symbionte" => "s5bj§t",
"symbiose" => "s5bjoz",
"symbiote" => "s5bjOt",
"symbiotes" => "s5bjOt",
"symbiotique" => "s5bjotik",
"symbole" => "s5bOl",
"symboles" => "s5bOl",
"symbolique" => "s5bolik",
"symboliquement" => "s5bolik°m@",
"symboliques" => "s5bolik",
"symbolisa" => "s5boliza",
"symbolisaient" => "s5bolizE",
"symbolisait" => "s5bolizE",
"symbolisant" => "s5boliz@",
"symbolisât" => "s5boliza",
"symbolisation" => "s5bolizasj§",
"symbolise" => "s5boliz",
"symbolisé" => "s5bolize",
"symbolisée" => "s5bolize",
"symbolisent" => "s5boliz",
"symboliser" => "s5bolize",
"symbolisera" => "s5boliz°Ra",
"symboliserai" => "s5boliz°RE",
"symboliserait" => "s5boliz°RE",
"symbolisés" => "s5bolize",
"symbolisme" => "s5bolizm",
"symboliste" => "s5bolist",
"symétrie" => "simetRi",
"symétries" => "simetRi",
"symétrique" => "simetRik",
"symétriquement" => "simetRik°m@",
"symétriques" => "simetRik",
"sympa" => "s5pa",
"sympas" => "s5pa",
"sympathectomie" => "s5patEktomi",
"sympathie" => "s5pati",
"sympathies" => "s5pati",
"sympathique" => "s5patik",
"sympathiques" => "s5patik",
"sympathisai" => "s5patizE",
"sympathisaient" => "s5patizE",
"sympathisait" => "s5patizE",
"sympathisant" => "s5patiz@",
"sympathisante" => "s5patiz@t",
"sympathisantes" => "s5patiz@t",
"sympathisants" => "s5patiz@",
"sympathise" => "s5patiz",
"sympathisé" => "s5patize",
"sympathiser" => "s5patize",
"sympathisera" => "s5patiz°Ra",
"sympathiserez" => "s5patiz°Re",
"sympathisez" => "s5patize",
"sympathisions" => "s5patizj§",
"sympathisons" => "s5patiz§",
"sympathomimétique" => "s5patomimetik",
"symphonie" => "s5foni",
"symphonies" => "s5foni",
"symphonique" => "s5fonik",
"symphoniques" => "s5fonik",
"symphorines" => "s5foRin",
"symphyse" => "s5fiz",
"symposium" => "s5pozjOm",
"symposiums" => "s5pozjOm",
"symptomatique" => "s5ptomatik",
"symptomatiques" => "s5ptomatik",
"symptomatologie" => "s5ptOmatOlOZi",
"symptôme" => "s5ptom",
"symptômes" => "s5ptom",
"synagogale" => "sinagogal",
"synagogaux" => "sinagogo",
"synagogue" => "sinagOg",
"synagogues" => "sinagOg",
"synapse" => "sinaps",
"synapses" => "sinaps",
"synaptique" => "sinaptik",
"synaptiques" => "sinaptik",
"synchro" => "s5kRo",
"synchrone" => "s5kRon",
"synchrones" => "s5kRon",
"synchronie" => "s5kRoni",
"synchronique" => "s5kRonik",
"synchronisaient" => "s5kRonizE",
"synchronisation" => "s5kRonizasj§",
"synchronise" => "s5kRoniz",
"synchronisé" => "s5kRonize",
"synchronisée" => "s5kRonize",
"synchronisées" => "s5kRonize",
"synchroniser" => "s5kRonize",
"synchronisera" => "s5kRoniz°Ra",
"synchronisés" => "s5kRonize",
"synchroniseur" => "s5kROniz9R",
"synchronisez" => "s5kRonize",
"synchronisme" => "s5kRonizm",
"synchronisons" => "s5kRoniz§",
"synchros" => "s5kRo",
"synchrotron" => "s5kRotR§",
"syncopal" => "s5kopal",
"syncope" => "s5kOp",
"syncopé" => "s5kope",
"syncopée" => "s5kope",
"syncopées" => "s5kope",
"syncoper" => "s5kOpe",
"syncopes" => "s5kOp",
"syncopés" => "s5kope",
"syncrétisme" => "s5kRetizm",
"syncrétiste" => "s5kRetist",
"syncytial" => "s5sitjal",
"syndic" => "s5dik",
"syndical" => "s5dikal",
"syndicale" => "s5dikal",
"syndicales" => "s5dikal",
"syndicalisation" => "s5dikalizasj§",
"syndicaliser" => "s5dikalize",
"syndicalisme" => "s5dikalizm",
"syndicaliste" => "s5dikalist",
"syndicalistes" => "s5dikalist",
"syndicat" => "s5dika",
"syndication" => "s5dikasj§",
"syndicats" => "s5dika",
"syndicaux" => "s5diko",
"syndics" => "s5dik",
"syndique" => "s5dik",
"syndiqué" => "s5dike",
"syndiquée" => "s5dike",
"syndiquées" => "s5dike",
"syndiquer" => "s5dike",
"syndiqués" => "s5dike",
"syndiquez" => "s5dike",
"syndrome" => "s5dRom",
"syndromes" => "s5dRom",
"synecdoque" => "sinEkdOk",
"synérèses" => "sineREz",
"synergétique" => "sinERZetik",
"synergie" => "sinERZi",
"synergies" => "sinERZi",
"synergique" => "sinERZik",
"synesthésie" => "sinEstezi",
"synode" => "sinOd",
"synonyme" => "sinonim",
"synonymes" => "sinonim",
"synopsie" => "sinOpsi",
"synopsis" => "sinOpsis",
"synoptique" => "sinOptik",
"synoviales" => "sinovjal",
"synovite" => "sinOvit",
"syntagme" => "s5tagm",
"syntaxe" => "s5taks",
"syntaxes" => "s5taks",
"syntaxique" => "s5taksik",
"synthé" => "s5te",
"synthés" => "s5te",
"synthèse" => "s5tEz",
"synthèses" => "s5tEz",
"synthétique" => "s5tetik",
"synthétiquement" => "s5tetik°m@",
"synthétiques" => "s5tetik",
"synthétise" => "s5tetiz",
"synthétisé" => "s5tetize",
"synthétisée" => "s5tetize",
"synthétisent" => "s5tetiz",
"synthétiser" => "s5tetize",
"synthétisera" => "s5tetiz°Ra",
"synthétisés" => "s5tetize",
"synthétiseur" => "s5tetiz9R",
"synthétiseurs" => "s5tetiz9R",
"syphilis" => "sifilis",
"syphilitique" => "sifilitik",
"syphilitiques" => "sifilitik",
"syrah" => "siRa",
"syriaque" => "siRjak",
"syriaques" => "siRjak",
"syrien" => "siRj5",
"syrienne" => "siRjEn",
"syriennes" => "siRjEn",
"syriens" => "siRj5",
"syringomyélie" => "siR5gOmjeli",
"syrinx" => "siR5ks",
"syro" => "siRo",
"syrtes" => "siRt",
"systématique" => "sistematik",
"systématiquement" => "sistematik°m@",
"systématiques" => "sistematik",
"systématisation" => "sistematizasj§",
"systématisé" => "sistematize",
"systématisée" => "sistematize",
"systématiser" => "sistematize",
"systématisés" => "sistematize",
"système" => "sistEm",
"systèmes" => "sistEm",
"systèmes-clés" => "sistEmkle",
"systémique" => "sistemik",
"systole" => "sistOl",
"systolique" => "sistolik",
"systoliques" => "sistolik",
"syzygie" => "siziZi",
"syzygies" => "siziZi",
"t" => "te",
"t-shirt" => "tiS9Rt",
"t-shirts" => "tiS9Rt",
"t'" => "t",
"ta" => "ta",
"tab" => "tab",
"tabac" => "taba",
"tabacs" => "taba",
"tabagie" => "tabaZi",
"tabagies" => "tabaZi",
"tabagisme" => "tabaZizm",
"tabard" => "tabaR",
"tabaski" => "tabaski",
"tabassage" => "tabasaZ",
"tabassages" => "tabasaZ",
"tabassaient" => "tabasE",
"tabassais" => "tabasE",
"tabassait" => "tabasE",
"tabassant" => "tabas@",
"tabasse" => "tabas",
"tabassé" => "tabase",
"tabassée" => "tabase",
"tabassent" => "tabas",
"tabasser" => "tabase",
"tabassera" => "tabas°Ra",
"tabasseraient" => "tabas°RE",
"tabasserais" => "tabas°RE",
"tabassèrent" => "tabasER",
"tabasses" => "tabas",
"tabassés" => "tabase",
"tabassez" => "tabase",
"tabassons" => "tabas§",
"tabatière" => "tabatjER",
"tabatières" => "tabatjER",
"tabellion" => "tabelj§",
"tabellions" => "tabelj§",
"tabernacle" => "tabERnakl",
"tabernacles" => "tabERnakl",
"tabès" => "tabEs",
"tabla" => "tabla",
"tablais" => "tablE",
"tablant" => "tabl@",
"tablature" => "tablatyR",
"table" => "tabl",
"tablé" => "table",
"table-bureau" => "tabl°byRo",
"table-coiffeuse" => "tablkwaf2z",
"tableau" => "tablo",
"tableautin" => "tablot5",
"tableautins" => "tablot5",
"tableaux" => "tablo",
"tablée" => "table",
"tablées" => "table",
"tabler" => "table",
"tablerez" => "tabl°Re",
"tables" => "tabl",
"tablette" => "tablEt",
"tabletterie" => "tablEt°Ri",
"tablettes" => "tablEt",
"tableur" => "tabl9R",
"tablier" => "tablije",
"tabliers" => "tablije",
"tabloïd" => "tablOid",
"tabloïde" => "tabloid",
"tabloïdes" => "tabloid",
"tabloïds" => "tabloid",
"tablons" => "tabl§",
"tabor" => "tabOR",
"taborites" => "taboRit",
"tabors" => "tabOR",
"tabou" => "tabu",
"taboue" => "tabu",
"taboues" => "tabu",
"taboulé" => "tabule",
"tabouret" => "tabuRE",
"tabourets" => "tabuRE",
"tabous" => "tabu",
"tabula" => "tabyla",
"tabulaire" => "tabylER",
"tabulateur" => "tabylat9R",
"tabulations" => "tabylasj§",
"tac" => "tak",
"tacatac" => "takatak",
"tacatacatac" => "takatakatak",
"tacauds" => "tako",
"tâcha" => "taSa",
"tâchai" => "taSE",
"tachaient" => "taSE",
"tâchaient" => "taSE",
"tâchais" => "taSE",
"tachait" => "taSE",
"tâchait" => "taSE",
"tachant" => "taS@",
"tâchant" => "taS@",
"tâchât" => "taSa",
"tache" => "taS",
"tâche" => "taS",
"taché" => "taSe",
"tâché" => "taSe",
"tachée" => "taSe",
"tâchée" => "taSe",
"tachées" => "taSe",
"tachent" => "taS",
"tâchent" => "taS",
"tachéomètre" => "takeomEtR",
"tacher" => "taSe",
"tâcher" => "taSe",
"tachera" => "taS°Ra",
"tâchera" => "taS°Ra",
"tacherai" => "taS°RE",
"tâcherai" => "taS°RE",
"tâcheraient" => "taS°RE",
"tacherais" => "taS°RE",
"tacherait" => "taS°RE",
"tâcherait" => "taS°RE",
"tâcheras" => "taS°Ra",
"tâchèrent" => "taSER",
"tâcherez" => "taS°Re",
"tâcheron" => "taS°R§",
"tâcherons" => "taS°R§",
"tâcheront" => "taS°R§",
"taches" => "taS",
"tâches" => "taS",
"tachés" => "taSe",
"tâchés" => "taSe",
"tachetaient" => "taS°tE",
"tachetant" => "taS°t@",
"tacheté" => "taS°te",
"tachetée" => "taS°te",
"tachetées" => "taS°te",
"tacheter" => "taS°te",
"tachetés" => "taS°te",
"tachetures" => "taS°tyR",
"tachez" => "taSe",
"tâchez" => "taSe",
"tâchions" => "taSj§",
"tachiste" => "taSist",
"tachons" => "taS§",
"tâchons" => "taS§",
"tachyarythmie" => "takiaRitmi",
"tachycarde" => "takikaRd",
"tachycardie" => "takikaRdi",
"tachycardies" => "takikaRdi",
"tachymètre" => "takimEtR",
"tachyon" => "takj§",
"tachyons" => "takj§",
"tacite" => "tasit",
"tacitement" => "tasit°m@",
"tacites" => "tasit",
"taciturne" => "tasityRn",
"taciturnes" => "tasityRn",
"taciturnité" => "tasityRnite",
"tacle" => "takl",
"tacler" => "takle",
"taco" => "tako",
"tacon" => "tak§",
"taconnet" => "takOnE",
"tacos" => "tako",
"tacot" => "tako",
"tacots" => "tako",
"tacs" => "tak",
"tact" => "takt",
"tacticien" => "taktisj5",
"tacticienne" => "taktisjEn",
"tacticiens" => "taktisj5",
"tactile" => "taktil",
"tactilement" => "taktil°m@",
"tactiles" => "taktil",
"tactique" => "taktik",
"tactiquement" => "taktik°m@",
"tactiques" => "taktik",
"tadjik" => "tadZik",
"tadorne" => "tadORn",
"tadornes" => "tadORn",
"taenia" => "tenja",
"taf" => "taf",
"tafanard" => "tafanaR",
"taffe" => "taf",
"taffes" => "taf",
"taffetas" => "taf°ta",
"tafia" => "tafja",
"tafs" => "taf",
"tag" => "tag",
"tagada" => "tagada",
"tagalog" => "tagalOg",
"tagger" => "tage",
"tagliatelle" => "tagliatEl",
"tagliatelles" => "taglijatEl",
"taguais" => "tagE",
"tague" => "tag",
"taguer" => "tage",
"tagueur" => "tag9R",
"tagueurs" => "tag9R",
"tahitien" => "taisj5",
"tahitienne" => "taisjEn",
"tahitiennes" => "taisjEn",
"tahitiens" => "taisj5",
"taï chi" => "tajSi",
"tai-chi" => "tajtSi",
"taïaut" => "tajo",
"taie" => "tE",
"taies" => "tE",
"taifas" => "tEifa",
"taïga" => "tajga",
"taïgas" => "tajga",
"tailla" => "taja",
"taillable" => "tajabl",
"taillables" => "tajabl",
"taillada" => "tajada",
"tailladait" => "tajadE",
"tailladant" => "tajad@",
"taillade" => "tajad",
"tailladé" => "tajade",
"tailladée" => "tajade",
"tailladées" => "tajade",
"tailladent" => "tajad",
"taillader" => "tajade",
"tailladés" => "tajade",
"tailladez" => "tajade",
"taillaient" => "tajE",
"taillais" => "tajE",
"taillait" => "tajE",
"taillandier" => "taj@dje",
"taillant" => "taj@",
"taillants" => "taj@",
"taille" => "taj",
"taillé" => "taje",
"taille-crayon" => "tajkREj§",
"taille-crayons" => "tajkREj§",
"taille-douce" => "tajdus",
"taille-haie" => "tajE",
"taille-haies" => "tajE",
"taillée" => "taje",
"taillées" => "taje",
"taillent" => "taj",
"tailler" => "taje",
"taillera" => "taj°Ra",
"taillerai" => "taj°RE",
"taillerais" => "taj°RE",
"taillerait" => "taj°RE",
"taillèrent" => "tajER",
"taillerez" => "taj°Re",
"tailleront" => "taj°R§",
"tailles" => "taj",
"taillés" => "taje",
"tailles-douces" => "tajdus",
"tailleur" => "taj9R",
"tailleur-pantalon" => "taj9Rp@tal§",
"tailleurs" => "taj9R",
"tailleuse" => "taj2z",
"taillez" => "taje",
"taillis" => "taji",
"tailloir" => "tajwaR",
"tailloirs" => "tajwaR",
"taillons" => "taj§",
"tain" => "t5",
"taira" => "tERa",
"tairai" => "tERE",
"tairaient" => "tERE",
"tairais" => "tERE",
"tairait" => "tERE",
"tairas" => "tERa",
"taire" => "tER",
"tairez" => "tERe",
"tairions" => "tERj§",
"tairons" => "tER§",
"tairont" => "tER§",
"tais" => "tE",
"taisaient" => "tEzE",
"taisais" => "tEzE",
"taisait" => "tEzE",
"taisant" => "tEz@",
"taise" => "tEz",
"taisent" => "tEz",
"taises" => "tEz",
"taiseux" => "tEz2",
"taisez" => "tEze",
"taisiez" => "tEzje",
"taisions" => "tEzj§",
"taisons" => "tEz§",
"tait" => "tE",
"tajine" => "taZin",
"tajines" => "taZin",
"take-off" => "tEkOf",
"tala" => "tala",
"talait" => "talE",
"talas" => "tala",
"talavera de la reina" => "talav°Rad°laREna",
"talbin" => "talb5",
"talbins" => "talb5",
"talc" => "talk",
"tale" => "tal",
"talée" => "tale",
"talées" => "tale",
"talent" => "tal@",
"talents" => "tal@",
"talentueuse" => "tal@t82z",
"talentueusement" => "tal@t82z°m@",
"talentueuses" => "tal@ty2z",
"talentueux" => "tal@t82",
"taler" => "tale",
"talés" => "tale",
"taleth" => "talEt",
"taleths" => "talEt",
"taliban" => "talib@",
"talibans" => "talib@",
"talion" => "talj§",
"talisman" => "talisman",
"talismans" => "talisman",
"talkie" => "tOlki",
"talkie-walkie" => "tOlkiwOlki",
"talkies" => "tOlki",
"talkies-walkies" => "tOlkiwOlkiz",
"talle" => "tal",
"taller" => "tale",
"tallipot" => "talipo",
"tallons" => "tal§",
"talmouse" => "talmuz",
"talmudique" => "talmydik",
"talmudiques" => "talmydik",
"talmudiste" => "talmydist",
"talmudistes" => "talmydist",
"talochaient" => "taloSE",
"talochait" => "taloSE",
"taloche" => "talOS",
"talocher" => "taloSe",
"taloches" => "talOS",
"talon" => "tal§",
"talonna" => "talona",
"talonnades" => "talonad",
"talonnait" => "talonE",
"talonnant" => "talon@",
"talonne" => "talOn",
"talonné" => "talone",
"talonnée" => "talone",
"talonnent" => "talOn",
"talonner" => "talone",
"talonnés" => "talone",
"talonnette" => "talonEt",
"talonnettes" => "talonEt",
"talonneur" => "talon9R",
"talonnons" => "talon§",
"talons" => "tal§",
"talqua" => "talka",
"talquât" => "talka",
"talqué" => "talke",
"talquées" => "talke",
"talquer" => "talke",
"talures" => "talyR",
"talus" => "taly",
"tam-tam" => "tamtam",
"tam-tams" => "tamtam",
"tamagotchi" => "tamagotSi",
"tamanoir" => "tamanwaR",
"tamarin" => "tamaR5",
"tamarinier" => "tamaRinje",
"tamariniers" => "tamaRinje",
"tamaris" => "tamaRis",
"tambouille" => "t@buj",
"tambouilles" => "t@buj",
"tambour" => "t@buR",
"tambour-major" => "t@buRmaZOR",
"tambourin" => "t@buR5",
"tambourina" => "t@buRina",
"tambourinade" => "t@buRinad",
"tambourinaient" => "t@buRinE",
"tambourinaire" => "t@buRinER",
"tambourinaires" => "t@buRinER",
"tambourinais" => "t@buRinE",
"tambourinait" => "t@buRinE",
"tambourinant" => "t@buRin@",
"tambourine" => "t@buRin",
"tambouriné" => "t@buRine",
"tambourinée" => "t@buRine",
"tambourinement" => "t@buRin°m@",
"tambourinent" => "t@buRin",
"tambouriner" => "t@buRine",
"tambourinèrent" => "t@buRinER",
"tambourineur" => "t@buRin9R",
"tambourins" => "t@buR5",
"tambours" => "t@buR",
"tamia" => "tamja",
"tamis" => "tami",
"tamisage" => "tamizaZ",
"tamisaient" => "tamizE",
"tamisais" => "tamizE",
"tamisait" => "tamizE",
"tamisant" => "tamiz@",
"tamise" => "tamiz",
"tamisé" => "tamize",
"tamisée" => "tamize",
"tamisées" => "tamize",
"tamisent" => "tamiz",
"tamiser" => "tamize",
"tamisés" => "tamize",
"tamiseur" => "tamiz9R",
"tamisez" => "tamize",
"tamoul" => "tamul",
"tamouré" => "tamuRe",
"tampax" => "t@paks",
"tampon" => "t@p§",
"tampon-buvard" => "t@p§byvaR",
"tamponna" => "t@pona",
"tamponnade" => "t@pOnad",
"tamponnage" => "t@ponaZ",
"tamponnages" => "t@ponaZ",
"tamponnai" => "t@ponE",
"tamponnaient" => "t@ponE",
"tamponnais" => "t@ponE",
"tamponnait" => "t@ponE",
"tamponnant" => "t@pon@",
"tamponne" => "t@pOn",
"tamponné" => "t@pone",
"tamponnée" => "t@pone",
"tamponnement" => "t@pOn°m@",
"tamponnent" => "t@pOn",
"tamponner" => "t@pone",
"tamponnera" => "t@pOn°Ra",
"tamponnés" => "t@pone",
"tamponneur" => "t@pon9R",
"tamponneuse" => "t@pon2z",
"tamponneuses" => "t@pon2z",
"tamponnez" => "t@pone",
"tamponnoir" => "t@ponwaR",
"tamponnoirs" => "t@ponwaR",
"tampons" => "t@p§",
"tamtam" => "tamtam",
"tan" => "t@",
"tan-sad" => "t@sad",
"tanaisie" => "tanEzi",
"tançai" => "t@sE",
"tançait" => "t@sE",
"tançant" => "t@s@",
"tance" => "t@s",
"tancé" => "t@se",
"tancée" => "t@se",
"tancer" => "t@se",
"tancés" => "t@se",
"tanche" => "t@S",
"tanches" => "t@S",
"tandem" => "t@dEm",
"tandems" => "t@dEm",
"tandis qu" => "t@dik",
"tandis que" => "t@dik2",
"tandoori" => "t@doRi",
"tangage" => "t@gaZ",
"tangara" => "t@gaRa",
"tangaras" => "t@gaRa",
"tangence" => "t@Z@s",
"tangent" => "t@Z@",
"tangente" => "t@Z@t",
"tangentes" => "t@Z@t",
"tangentiel" => "t@Z@sjEl",
"tangents" => "t@Z@",
"tangerine" => "t@n°Z2Rajn",
"tangérois" => "t@ZeRwa",
"tangibilité" => "t@Zibilite",
"tangible" => "t@Zibl",
"tangibles" => "t@Zibl",
"tango" => "t@go",
"tangon" => "t@g§",
"tangos" => "t@go",
"tangua" => "t@ga",
"tanguaient" => "t@gE",
"tanguait" => "t@gE",
"tanguant" => "t@g@",
"tangue" => "t@g",
"tangué" => "t@ge",
"tanguent" => "t@g",
"tanguer" => "t@ge",
"tangueraient" => "t@g°RE",
"tanière" => "tanjER",
"tanières" => "tanjER",
"tanin" => "tan5",
"tank" => "t@k",
"tanka" => "t@ka",
"tanker" => "t@k9R",
"tankers" => "t@kER",
"tankiste" => "t@kist",
"tankistes" => "t@kist",
"tanks" => "t@k",
"tanna" => "tana",
"tannage" => "tanaZ",
"tannaient" => "tanE",
"tannait" => "tanE",
"tannant" => "tan@",
"tannante" => "tan@t",
"tannantes" => "tan@t",
"tanne" => "tan",
"tanné" => "tane",
"tannée" => "tane",
"tannées" => "tane",
"tannent" => "tan",
"tanner" => "tane",
"tannerai" => "tan°RE",
"tannerie" => "tan°Ri",
"tannes" => "tan",
"tannés" => "tane",
"tanneur" => "tan9R",
"tanneurs" => "tan9R",
"tannin" => "tan5",
"tanrec" => "t@REk",
"tans" => "t@",
"tansad" => "t@sad",
"tant" => "t@",
"tante" => "t@t",
"tantes" => "t@t",
"tantièmes" => "t@tjEm",
"tantine" => "t@tin",
"tantines" => "t@tin",
"tantinet" => "t@tinE",
"tantôt" => "t@to",
"tantouse" => "t@tuz",
"tantouses" => "t@tuz",
"tantouze" => "t@tuz",
"tantouzes" => "t@tuz",
"tantra" => "t@tRa",
"tantrique" => "t@tRik",
"tantriques" => "t@tRik",
"tantrisme" => "t@tRizm",
"tao" => "tao",
"taoïsme" => "taoizm",
"taoïste" => "taoist",
"taoïstes" => "taoist",
"taon" => "t@",
"taons" => "t@",
"tap" => "tap",
"tapa" => "tapa",
"tapage" => "tapaZ",
"tapageait" => "tapaZE",
"tapages" => "tapaZ",
"tapageur" => "tapaZ9R",
"tapageurs" => "tapaZ9R",
"tapageuse" => "tapaZ2z",
"tapageuses" => "tapaZ2z",
"tapai" => "tapE",
"tapaient" => "tapE",
"tapais" => "tapE",
"tapait" => "tapE",
"tapâmes" => "tapam",
"tapant" => "tap@",
"tapante" => "tap@t",
"tapantes" => "tap@t",
"tapas" => "tapas",
"tape" => "tap",
"tapé" => "tape",
"tape-à-l'oeil" => "tapal9j",
"tape-cul" => "tapky",
"tapecul" => "tapky",
"tapée" => "tape",
"tapées" => "tape",
"tapement" => "tap°m@",
"tapements" => "tap°m@",
"tapenade" => "tap°nad",
"tapent" => "tap",
"taper" => "tape",
"tapera" => "tap°Ra",
"taperai" => "tap°RE",
"taperaient" => "tap°RE",
"taperais" => "tap°RE",
"taperait" => "tap°RE",
"taperas" => "tap°Ra",
"tapèrent" => "tapER",
"taperez" => "tap°Re",
"taperiez" => "tap°Rje",
"taperont" => "tap°R§",
"tapes" => "tap",
"tapés" => "tape",
"tapette" => "tapEt",
"tapettes" => "tapEt",
"tapeur" => "tap9R",
"tapeurs" => "tap9R",
"tapeuses" => "tap2z",
"tapez" => "tape",
"tapi" => "tapi",
"tapie" => "tapi",
"tapies" => "tapi",
"tapiez" => "tapje",
"tapin" => "tap5",
"tapinage" => "tapinaZ",
"tapinaient" => "tapinE",
"tapinais" => "tapinE",
"tapinait" => "tapinE",
"tapinant" => "tapin@",
"tapine" => "tapin",
"tapiné" => "tapine",
"tapinée" => "tapine",
"tapinent" => "tapin",
"tapiner" => "tapine",
"tapinera" => "tapin°Ra",
"tapinerai" => "tapin°RE",
"tapinerais" => "tapin°RE",
"tapines" => "tapin",
"tapineuse" => "tapin2z",
"tapineuses" => "tapin2z",
"tapins" => "tap5",
"tapioca" => "tapjoka",
"tapir" => "tapiR",
"tapira" => "tapiRa",
"tapirs" => "tapiR",
"tapis" => "tapi",
"tapis-brosse" => "tapibROs",
"tapissa" => "tapisa",
"tapissaient" => "tapisE",
"tapissais" => "tapisE",
"tapissait" => "tapisE",
"tapissant" => "tapis@",
"tapisse" => "tapis",
"tapissé" => "tapise",
"tapissée" => "tapise",
"tapissées" => "tapise",
"tapissent" => "tapis",
"tapisser" => "tapise",
"tapisserai" => "tapis°RE",
"tapisserie" => "tapis°Ri",
"tapisseries" => "tapis°Ri",
"tapissés" => "tapise",
"tapissier" => "tapisje",
"tapissière" => "tapisjER",
"tapissiers" => "tapisje",
"tapit" => "tapi",
"tapons" => "tap§",
"tapota" => "tapota",
"tapotai" => "tapotE",
"tapotaient" => "tapotE",
"tapotais" => "tapotE",
"tapotait" => "tapotE",
"tapotant" => "tapot@",
"tapote" => "tapOt",
"tapoté" => "tapote",
"tapotement" => "tapOt°m@",
"tapotements" => "tapOt°m@",
"tapotent" => "tapOt",
"tapoter" => "tapote",
"tapotèrent" => "tapotER",
"tapotez" => "tapote",
"tapotis" => "tapoti",
"tapotons" => "tapot§",
"taquet" => "takE",
"taquets" => "takE",
"taquin" => "tak5",
"taquina" => "takina",
"taquinaient" => "takinE",
"taquinais" => "takinE",
"taquinait" => "takinE",
"taquinant" => "takin@",
"taquine" => "takin",
"taquiné" => "takine",
"taquinée" => "takine",
"taquinent" => "takin",
"taquiner" => "takine",
"taquinerait" => "takin°RE",
"taquinerie" => "takin°Ri",
"taquineries" => "takin°Ri",
"taquines" => "takin",
"taquinez" => "takine",
"taquins" => "tak5",
"taquoir" => "takwaR",
"tara" => "taRa",
"tarabiscot" => "taRabisko",
"tarabiscotages" => "taRabiskotaZ",
"tarabiscoté" => "taRabiskote",
"tarabiscotée" => "taRabiskote",
"tarabiscotées" => "taRabiskote",
"tarabiscotés" => "taRabiskote",
"tarabustait" => "taRabystE",
"tarabuste" => "taRabyst",
"tarabusté" => "taRabyste",
"tarabustent" => "taRabyst",
"tarabuster" => "taRabyste",
"tarabustèrent" => "taRabystER",
"tarabustes" => "taRabyst",
"tarabustés" => "taRabyste",
"tarama" => "taRama",
"tarare" => "taRaR",
"taratata" => "taRatata",
"taraud" => "taRo",
"taraudaient" => "taRodE",
"taraudait" => "taRodE",
"taraudant" => "taRod@",
"taraude" => "taRod",
"taraudé" => "taRode",
"taraudée" => "taRode",
"taraudées" => "taRode",
"taraudent" => "taRod",
"tarauder" => "taRode",
"taraudèrent" => "taRodER",
"taraudés" => "taRode",
"tarauds" => "taRo",
"tarbais" => "taRbE",
"tarbouche" => "taRbuS",
"tarbouif" => "taRbuif",
"tard" => "taR",
"tard-venu" => "taRv°ny",
"tarda" => "taRda",
"tardai" => "taRdE",
"tardaient" => "taRdE",
"tardais" => "taRdE",
"tardait" => "taRdE",
"tardâmes" => "taRdam",
"tardant" => "taRd@",
"tarde" => "taRd",
"tardé" => "taRde",
"tardée" => "taRde",
"tardent" => "taRd",
"tarder" => "taRde",
"tardera" => "taRd°Ra",
"tarderai" => "taRd°RE",
"tarderaient" => "taRd°RE",
"tarderais" => "taRd°RE",
"tarderait" => "taRd°RE",
"tarderas" => "taRd°Ra",
"tardèrent" => "taRdER",
"tarderez" => "taRd°Re",
"tarderie" => "taRd°Ri",
"tarderies" => "taRd°Ri",
"tarderiez" => "taRd°Rje",
"tarderions" => "taRd°Rj§",
"tarderons" => "taRd°R§",
"tarderont" => "taRd°R§",
"tardes" => "taRd",
"tardez" => "taRde",
"tardiez" => "taRdje",
"tardif" => "taRdif",
"tardifs" => "taRdif",
"tardigrade" => "taRdigRad",
"tardillon" => "taRdij§",
"tardions" => "taRdj§",
"tardive" => "taRdiv",
"tardivement" => "taRdiv°m@",
"tardives" => "taRdiv",
"tardons" => "taRd§",
"tare" => "taR",
"taré" => "taRe",
"tarée" => "taRe",
"tarées" => "taRe",
"tarentelle" => "taR@tEl",
"tarentelles" => "taR@tEl",
"tarentule" => "taR@tyl",
"tarentules" => "taR@tyl",
"tares" => "taR",
"tarés" => "taRe",
"taret" => "taRE",
"tarets" => "taRE",
"targe" => "taRZ",
"targette" => "taRZEt",
"targettes" => "taRZEt",
"targua" => "taRga",
"targuaient" => "taRgE",
"targuais" => "taRgE",
"targuait" => "taRgE",
"targuant" => "taRg@",
"targuât" => "taRga",
"targue" => "taRg",
"targué" => "taRge",
"targuent" => "taRg",
"targuer" => "taRge",
"targuez" => "taRge",
"targui" => "taRgi",
"tari" => "taRi",
"taride" => "taRid",
"tarie" => "taRi",
"tarière" => "taRjER",
"tarières" => "taRjER",
"taries" => "taRi",
"tarif" => "taRif",
"tarifée" => "taRife",
"tarifées" => "taRife",
"tarifés" => "taRife",
"tarification" => "taRifikasj§",
"tarifications" => "taRifikasj§",
"tarifié" => "taRifje",
"tarifs" => "taRif",
"tarin" => "taR5",
"tarir" => "taRiR",
"tarira" => "taRiRa",
"tarirent" => "taRiR",
"taris" => "taRi",
"tarissaient" => "taRisE",
"tarissait" => "taRisE",
"tarissant" => "taRis@",
"tarisse" => "taRis",
"tarissement" => "taRis°m@",
"tarissent" => "taRis",
"tarissez" => "taRise",
"tarit" => "taRi",
"tarlatane" => "taRlatan",
"tarmac" => "taRmak",
"taro" => "taRo",
"tarot" => "taRo",
"tarots" => "taRo",
"tarpan" => "taRp@",
"tarpans" => "taRp@",
"tarpé" => "taRpe",
"tarpéienne" => "taRpejEn",
"tarpon" => "taRp§",
"tarse" => "taRs",
"tarses" => "taRs",
"tarsienne" => "taRsjEn",
"tarsiens" => "taRsj5",
"tarsier" => "taRsje",
"tartan" => "taRt@",
"tartane" => "taRtan",
"tartare" => "taRtaR",
"tartares" => "taRtaR",
"tartarin" => "taRtaR5",
"tartarinades" => "taRtaRinad",
"tartarins" => "taRtaR5",
"tarte" => "taRt",
"tarte-minute" => "taRtminyt",
"tartelette" => "taRt°lEt",
"tartelettes" => "taRt°lEt",
"tartempion" => "taRt@pj§",
"tartes" => "taRt",
"tartignolle" => "taRtiNOl",
"tartignolles" => "taRtiNOl",
"tartina" => "taRtina",
"tartinaient" => "taRtinE",
"tartinais" => "taRtinE",
"tartinait" => "taRtinE",
"tartinant" => "taRtin@",
"tartine" => "taRtin",
"tartiné" => "taRtine",
"tartinée" => "taRtine",
"tartinées" => "taRtine",
"tartinent" => "taRtin",
"tartiner" => "taRtine",
"tartinerait" => "taRtin°RE",
"tartines" => "taRtin",
"tartinez" => "taRtine",
"tartir" => "taRtiR",
"tartiss" => "taRtis",
"tartissent" => "taRtis",
"tartisses" => "taRtis",
"tartouille" => "taRtuj",
"tartouilles" => "taRtuj",
"tartre" => "taRtR",
"tartufe" => "taRtyf",
"tartuferie" => "taRtyf°Ri",
"tartuferies" => "taRtyf°Ri",
"tartufferie" => "taRtyf°Ri",
"tartuffes" => "taRtyf",
"tarzan" => "taRz@",
"tarzans" => "taRz@",
"tas" => "ta",
"tasmanien" => "tasmanj5",
"tassa" => "tasa",
"tassai" => "tasE",
"tassaient" => "tasE",
"tassais" => "tasE",
"tassait" => "tasE",
"tassant" => "tas@",
"tasse" => "tas",
"tassé" => "tase",
"tasseau" => "taso",
"tassée" => "tase",
"tassées" => "tase",
"tassement" => "tas°m@",
"tassements" => "tas°m@",
"tassent" => "tas",
"tasser" => "tase",
"tassera" => "tas°Ra",
"tasserai" => "tas°RE",
"tasserait" => "tas°RE",
"tassèrent" => "tasER",
"tasses" => "tas",
"tassés" => "tase",
"tassez" => "tase",
"tassiez" => "tasje",
"tassili" => "tasili",
"tassons" => "tas§",
"taste-vin" => "tajst°v5",
"tata" => "tata",
"tâta" => "tata",
"tâtai" => "tatE",
"tâtaient" => "tatE",
"tâtais" => "tatE",
"tâtait" => "tatE",
"tatami" => "tatami",
"tatamis" => "tatami",
"tatane" => "tatan",
"tatanes" => "tatan",
"tâtant" => "tat@",
"tatar" => "tataR",
"tatars" => "tataR",
"tatas" => "tata",
"tâte" => "tat",
"tâté" => "tate",
"tâtent" => "tat",
"tâter" => "tate",
"tâtera" => "tat°Ra",
"tâterai" => "tat°RE",
"tâteras" => "tat°Ra",
"tâtèrent" => "tatER",
"tâterez" => "tat°Re",
"tâtés" => "tate",
"tâtez" => "tate",
"tâtiez" => "tatje",
"tatillon" => "tatij§",
"tatillonne" => "tatijOn",
"tatillonner" => "tatijone",
"tatillonnes" => "tatijOn",
"tatillons" => "tatij§",
"tatin" => "tat5",
"tâtonna" => "tatona",
"tâtonnai" => "tatonE",
"tâtonnaient" => "tatonE",
"tâtonnais" => "tatonE",
"tâtonnait" => "tatonE",
"tâtonnâmes" => "tatonam",
"tâtonnant" => "taton@",
"tâtonnante" => "taton@t",
"tâtonnantes" => "taton@t",
"tâtonnants" => "taton@",
"tâtonnât" => "tatona",
"tâtonne" => "tatOn",
"tâtonné" => "tatone",
"tâtonnée" => "tatone",
"tâtonnement" => "tatOn°m@",
"tâtonnements" => "tatOn°m@",
"tâtonnent" => "tatOn",
"tâtonner" => "tatone",
"tâtonnera" => "tatOn°Ra",
"tâtonnerais" => "tatOn°RE",
"tâtonnèrent" => "tatonER",
"tâtonnions" => "tatonj§",
"tâtons" => "tat§",
"tatou" => "tatu",
"tatouage" => "tatwaZ",
"tatouages" => "tatwaZ",
"tatouaient" => "tatwE",
"tatouait" => "tatwE",
"tatoue" => "tatu",
"tatoué" => "tatwe",
"tatouée" => "tatwe",
"tatouées" => "tatwe",
"tatouent" => "tatu",
"tatouer" => "tatwe",
"tatoués" => "tatwe",
"tatoueur" => "tatw9R",
"tatoueurs" => "tatu9R",
"tatoueuse" => "tatw2z",
"tatouez" => "tatue",
"tatous" => "tatu",
"tau" => "to",
"taube" => "tob",
"taudis" => "todi",
"taulard" => "tolaR",
"taularde" => "tolaRd",
"taulardes" => "tolaRd",
"taulards" => "tolaR",
"taule" => "tol",
"taules" => "tol",
"taulier" => "tolje",
"taulière" => "toljER",
"taulières" => "toljER",
"tauliers" => "tolje",
"taupe" => "top",
"taupé" => "tope",
"taupes" => "top",
"taupés" => "tope",
"taupicide" => "topisid",
"taupin" => "top5",
"taupinées" => "topine",
"taupinière" => "topinjER",
"taupinières" => "topinjER",
"taure" => "toR",
"taureau" => "toRo",
"taureaux" => "toRo",
"taurillon" => "toRij§",
"taurillons" => "toRij§",
"taurin" => "toR5",
"taurine" => "toRin",
"taurins" => "toR5",
"taurobole" => "toRobOl",
"tauromachie" => "toRomaSi",
"tauromachique" => "toRomaSik",
"tautologie" => "totoloZi",
"taux" => "to",
"tavel" => "tavEl",
"tavelant" => "tav°l@",
"tavelé" => "tav°le",
"tavelée" => "tav°le",
"tavelées" => "tav°le",
"tavelures" => "tav°lyR",
"taverne" => "tavERn",
"tavernes" => "tavERn",
"tavernier" => "tavERnje",
"taverniers" => "tavERnje",
"taxa" => "taksa",
"taxables" => "taksabl",
"taxaient" => "taksE",
"taxait" => "taksE",
"taxant" => "taks@",
"taxation" => "taksasj§",
"taxaudier" => "taksodje",
"taxe" => "taks",
"taxé" => "takse",
"taxée" => "takse",
"taxent" => "taks",
"taxer" => "takse",
"taxerait" => "taks°RE",
"taxes" => "taks",
"taxés" => "takse",
"taxez" => "takse",
"taxi" => "taksi",
"taxi-auto" => "taksiOto",
"taxi-brousse" => "taksibRus",
"taxi-girl" => "taksig9Rl",
"taxi-girls" => "taksig9Rl",
"taxidermie" => "taksidERmi",
"taxidermiste" => "taksidERmist",
"taxidermistes" => "taksidERmist",
"taximan" => "taksiman",
"taximen" => "taksimEn",
"taximètre" => "taksimEtR",
"taxinomie" => "taksinomi",
"taxinomique" => "taksinomik",
"taxinomiste" => "taksinOmist",
"taxiphone" => "taksifOn",
"taxiphones" => "taksifOn",
"taxis" => "taksi",
"taxonomie" => "taksOnOmi",
"taxonomique" => "taksOnOmik",
"taylorisé" => "tEloRize",
"taylorisme" => "tEloRizm",
"tchadiens" => "tSadj5",
"tchador" => "tSadOR",
"tchao" => "tSao",
"tchatchant" => "tSatS@",
"tchatche" => "tSatS",
"tchatché" => "tSatSe",
"tchatchent" => "tSatS",
"tchatcher" => "tSatSe",
"tchatches" => "tSatS",
"tchécoslovaque" => "tSekOslovak",
"tchécoslovaques" => "tSekOslovak",
"tchékhoviennes" => "tSekOvjEn",
"tchékiste" => "tSekist",
"tchèque" => "tSEk",
"tchèques" => "tSEk",
"tcherkesse" => "tSERkEs",
"tchernoziom" => "tSERnozj§",
"tchétchène" => "tSetSEn",
"tchétchènes" => "tSetSEn",
"tchetnik" => "tSEtnik",
"tchetniks" => "tSEtnik",
"tchin tchin" => "tSintSin",
"tchin-tchin" => "tSintSin",
"te" => "t2",
"té" => "te",
"te deum" => "tedeum",
"tea-room" => "tiRum",
"team" => "tim",
"teams" => "tim",
"teaser" => "tiz9R",
"tec" => "tEk",
"technétium" => "tEknesjOm",
"technicien" => "tEknisj5",
"technicienne" => "tEknisjEn",
"techniciens" => "tEknisj5",
"technicité" => "tEknisite",
"technico-commerciaux" => "tEknikokomERsjo",
"technicolor" => "tEknikolOR",
"technique" => "tEknik",
"techniquement" => "tEknik°m@",
"techniques" => "tEknik",
"techno" => "tEkno",
"technocrate" => "tEknokRat",
"technocrates" => "tEknokRat",
"technocratique" => "tEknokRatik",
"technocratisme" => "tEknokRatizm",
"technologie" => "tEknoloZi",
"technologies" => "tEknoloZi",
"technologique" => "tEknoloZik",
"technologiquement" => "tEknoloZik°m@",
"technologiques" => "tEknoloZik",
"teck" => "tEk",
"teckel" => "tekEl",
"teckels" => "tekEl",
"tectonique" => "tEktonik",
"tectoniques" => "tEktonik",
"tee" => "ti",
"tee-shirt" => "tiS9Rt",
"tee-shirts" => "tiS9Rt",
"teen-agers" => "tinEdZ9R",
"teenager" => "tinedz9R",
"teenagers" => "tinedZ9R",
"tees" => "ti",
"tefillin" => "tefj5",
"téflon" => "tefl§",
"tégénaires" => "teZenER",
"tégument" => "tegym@",
"tégumentaire" => "tegym@tER",
"teignais" => "tENE",
"teignait" => "tENE",
"teignant" => "tEN@",
"teigne" => "tEN",
"teignent" => "tEN",
"teignes" => "tEN",
"teigneuse" => "tEN2z",
"teigneuses" => "tEN2z",
"teigneux" => "tEN2",
"teignit" => "tENi",
"teille" => "tEj",
"teindra" => "t5dRa",
"teindrai" => "t5dRE",
"teindrait" => "t5dRE",
"teindre" => "t5dR",
"teins" => "t5",
"teint" => "t5",
"teinta" => "t5ta",
"teintaient" => "t5tE",
"teintait" => "t5tE",
"teintant" => "t5t@",
"teinte" => "t5t",
"teinté" => "t5te",
"teintée" => "t5te",
"teintées" => "t5te",
"teintent" => "t5t",
"teinter" => "t5te",
"teinteraient" => "t5t°RE",
"teintes" => "t5t",
"teintés" => "t5te",
"teints" => "t5",
"teinture" => "t5tyR",
"teinturerie" => "t5tyR°Ri",
"teintureries" => "t5tyR°Ri",
"teintures" => "t5tyR",
"teinturier" => "t5tyRje",
"teinturière" => "t5tyRjER",
"teinturiers" => "t5tyRje",
"tek" => "tEk",
"tel" => "tEl",
"tél" => "tEl",
"tél." => "tel",
"télé" => "tele",
"téléachat" => "teleaSa",
"téléavertisseur" => "teleavERtis9R",
"télécabine" => "telekabin",
"télécartes" => "telekaRt",
"télécharge" => "teleSaRZ",
"téléchargé" => "teleSaRZe",
"téléchargeables" => "teleSaRZabl",
"téléchargée" => "teleSaRZe",
"téléchargées" => "teleSaRZe",
"téléchargement" => "teleSaRZ°m@",
"téléchargent" => "teleSaRZ",
"téléchargeons" => "teleSaRZ§",
"télécharger" => "teleSaRZe",
"téléchargera" => "teleSaRZ°Ra",
"téléchargerai" => "teleSaRZ°RE",
"téléchargerons" => "teleSaRZ°R§",
"téléchargés" => "teleSaRZe",
"téléchargez" => "teleSaRZe",
"télécinéma" => "telesinema",
"télécommande" => "telekom@d",
"télécommandé" => "telekom@de",
"télécommandée" => "telekom@de",
"télécommandées" => "telekom@de",
"télécommander" => "telekom@de",
"télécommandes" => "telekom@d",
"télécommandés" => "telekom@de",
"télécommunication" => "telekomynikasj§",
"télécommunications" => "telekomynikasj§",
"télécoms" => "telekOm",
"téléconférence" => "telek§feR@s",
"télécopieur" => "telekopj9R",
"télécran" => "telekR@",
"télécrans" => "telekR@",
"télédiffuser" => "teledifyze",
"télédiffusion" => "teledifyzj§",
"téléfax" => "telefaks",
"téléfaxe" => "telefaks",
"téléfaxez" => "telefakse",
"téléfériques" => "telefeRik",
"téléfilm" => "telefilm",
"téléfilms" => "telefilm",
"télégénie" => "teleZeni",
"télégénique" => "teleZenik",
"télégramme" => "telegRam",
"télégrammes" => "telegRam",
"télégraphe" => "telegRaf",
"télégraphes" => "telegRaf",
"télégraphia" => "telegRafja",
"télégraphiai" => "telegRafjE",
"télégraphiait" => "telegRafjE",
"télégraphiâmes" => "telegRafjam",
"télégraphiant" => "telegRafj@",
"télégraphie" => "telegRafi",
"télégraphié" => "telegRafje",
"télégraphiée" => "telegRafje",
"télégraphiées" => "telegRafje",
"télégraphient" => "telegRafi",
"télégraphier" => "telegRafje",
"télégraphierai" => "telegRafiRE",
"télégraphierais" => "telegRafiRE",
"télégraphierait" => "telegRafiRE",
"télégraphiés" => "telegRafje",
"télégraphiez" => "telegRafje",
"télégraphions" => "telegRafj§",
"télégraphique" => "telegRafik",
"télégraphiques" => "telegRafik",
"télégraphiste" => "telegRafist",
"télégraphistes" => "telegRafist",
"télègue" => "telEg",
"téléguidage" => "telegidaZ",
"téléguidé" => "telegide",
"téléguidée" => "telegide",
"téléguidées" => "telegide",
"téléguider" => "telegide",
"téléguidés" => "telegide",
"télékinésie" => "telekinezi",
"télémark" => "telemaRk",
"télémarketing" => "telemaRk°tiG",
"télématique" => "telematik",
"télémesure" => "telem°zyR",
"télémesures" => "telemzyR",
"télémètre" => "telemEtR",
"télémètres" => "telemEtR",
"télémétrie" => "telemetRi",
"télémétrique" => "telemetRik",
"télémétriques" => "telemetRik",
"télencéphale" => "tel@sefal",
"téléobjectif" => "teleobZEktif",
"téléobjectifs" => "teleobZEktif",
"téléologique" => "teleoloZik",
"télépathe" => "telepat",
"télépathes" => "telepat",
"télépathie" => "telepati",
"télépathique" => "telepatik",
"télépathiquement" => "telepatik°m@",
"télépathiques" => "telepatik",
"téléphérique" => "telefeRik",
"téléphona" => "telefona",
"téléphonage" => "telefonaZ",
"téléphonai" => "telefonE",
"téléphonaient" => "telefonE",
"téléphonais" => "telefonE",
"téléphonait" => "telefonE",
"téléphonant" => "telefon@",
"téléphonât" => "telefona",
"téléphone" => "telefOn",
"téléphoné" => "telefone",
"téléphonée" => "telefOne",
"téléphonées" => "telefone",
"téléphonent" => "telefOn",
"téléphoner" => "telefone",
"téléphonera" => "telefOn°Ra",
"téléphonerai" => "telefOn°RE",
"téléphoneraient" => "telefOn°RE",
"téléphonerais" => "telefOn°RE",
"téléphonerait" => "telefOn°RE",
"téléphoneras" => "telefOn°Ra",
"téléphonerez" => "telefOn°Re",
"téléphoneriez" => "telefOn°Rje",
"téléphonerons" => "telefOn°R§",
"téléphoneront" => "telefOn°R§",
"téléphones" => "telefOn",
"téléphonés" => "telefone",
"téléphonez" => "telefone",
"téléphonie" => "telefoni",
"téléphoniez" => "telefonje",
"téléphonions" => "telefonj§",
"téléphonique" => "telefonik",
"téléphoniquement" => "telefonik°m@",
"téléphoniques" => "telefonik",
"téléphoniste" => "telefonist",
"téléphonistes" => "telefonist",
"téléphonons" => "telefon§",
"téléport" => "telepOR",
"téléportation" => "telepORtasj§",
"téléprompteur" => "telepR§pt9R",
"téléreportage" => "teleR°pORtaZ",
"téléroman" => "teleROm@",
"télés" => "tele",
"télescopage" => "telEskopaZ",
"télescopait" => "telEskopE",
"télescope" => "telEskOp",
"télescopé" => "telEskope",
"télescopée" => "telEskope",
"télescopées" => "telEskope",
"télescopent" => "telEskOp",
"télescoper" => "telEskope",
"télescopèrent" => "telEskopER",
"télescopes" => "telEskOp",
"télescopique" => "telEskopik",
"télescopiques" => "telEskopik",
"téléscripteur" => "teleskRipt9R",
"télescripteurs" => "teleskRipt9R",
"téléscripteurs" => "teleskRipt9R",
"télésiège" => "telesjEZ",
"télésièges" => "telesjEZ",
"téléski" => "teleski",
"téléspectateur" => "telespEktat9R",
"téléspectateurs" => "telespEktat9R",
"téléspectatrice" => "telespEktatRis",
"téléspectatrices" => "telespEktatRis",
"télésurveillance" => "telesyRvEj@s",
"télétexte" => "teletEks°t",
"télétravail" => "teletRavaj",
"télétravailleuse" => "teletRavaj2z",
"télétype" => "teletip",
"télétypes" => "teletip",
"télévangéliste" => "telev@Zelist",
"télévangélistes" => "telev@Zelist",
"télévendeur" => "telev@d9R",
"télévente" => "telev@t",
"télévise" => "televiz",
"télévisé" => "televize",
"télévisée" => "televize",
"télévisées" => "televize",
"télévisera" => "televiz°Ra",
"télévises" => "televiz",
"télévisés" => "televize",
"téléviseur" => "televiz9R",
"téléviseurs" => "televiz9R",
"télévision" => "televizj§",
"télévisions" => "televizj§",
"télévisuel" => "televiz8El",
"télévisuelle" => "televiz8El",
"télévisuels" => "televiz8El",
"télex" => "telEks",
"télexa" => "telEksa",
"télexé" => "telEkse",
"télexer" => "telEkse",
"télexes" => "telEks",
"tell" => "tEl",
"telle" => "tEl",
"tellement" => "tEl°m@",
"telles" => "tEl",
"tellure" => "tElyR",
"tellurique" => "tElyRik",
"telluriques" => "tElyRik",
"téloche" => "telOS",
"tels" => "tEl",
"telson" => "tEls§",
"tem" => "tEm",
"téméraire" => "temeRER",
"témérairement" => "temeRER°m@",
"téméraires" => "temeRER",
"témérité" => "temeRite",
"témérités" => "temeRite",
"témoigna" => "temwaNa",
"témoignage" => "temwaNaZ",
"témoignages" => "temwaNaZ",
"témoignaient" => "temwaNE",
"témoignais" => "temwaNE",
"témoignait" => "temwaNE",
"témoignant" => "temwaN@",
"témoignât" => "temwaNa",
"témoigne" => "temwaN",
"témoigné" => "temwaNe",
"témoignée" => "temwaNe",
"témoignées" => "temwaNe",
"témoignent" => "temwaN",
"témoigner" => "temwaNe",
"témoignera" => "temwaN°Ra",
"témoignerai" => "temwaN°RE",
"témoigneraient" => "temwaN°RE",
"témoignerais" => "temwaN°RE",
"témoignerait" => "temwaN°RE",
"témoigneras" => "temwaN°Ra",
"témoignèrent" => "temwaNER",
"témoignerez" => "temwaN°Re",
"témoigneront" => "temwaN°R§",
"témoignes" => "temwaN",
"témoignés" => "temwaNe",
"témoignez" => "temwaNe",
"témoigniez" => "temwaNe",
"témoin" => "temw5",
"témoin-clé" => "temw5kle",
"témoin-vedette" => "temw5v°dEt",
"témoins" => "temw5",
"témoins-clés" => "temw5kle",
"tempe" => "t@p",
"tempera" => "t@peRa",
"tempéra" => "t@peRa",
"tempéraient" => "t@peRE",
"tempérait" => "t@peRE",
"tempérament" => "t@peRam@",
"tempéraments" => "t@peRam@",
"tempérance" => "t@peR@s",
"température" => "t@peRatyR",
"températures" => "t@peRatyR",
"tempère" => "t@pER",
"tempéré" => "t@peRe",
"tempérée" => "t@peRe",
"tempérées" => "t@peRe",
"tempérer" => "t@peRe",
"tempéreraient" => "t@peR°RE",
"tempérerait" => "t@peR°RE",
"tempérés" => "t@peRe",
"tempes" => "t@p",
"tempêta" => "t@pEta",
"tempêtaient" => "t@pEtE",
"tempêtais" => "t@pEtE",
"tempêtait" => "t@pEtE",
"tempêtant" => "t@pEt@",
"tempête" => "t@pEt",
"tempêté" => "t@pEte",
"tempêtent" => "t@pEt",
"tempêter" => "t@pete",
"tempêtes" => "t@pEt",
"tempétueux" => "t@pet82",
"tempi" => "t@pi",
"temple" => "t@pl",
"temples" => "t@pl",
"templier" => "t@plije",
"templière" => "t@pliER",
"templiers" => "t@plje",
"tempo" => "tEmpo",
"temporaire" => "t@poRER",
"temporairement" => "t@poRER°m@",
"temporaires" => "t@poRER",
"temporal" => "t@poRal",
"temporale" => "t@poRal",
"temporales" => "t@poRal",
"temporalité" => "t@poRalite",
"temporalités" => "t@poRalite",
"temporaux" => "t@poRo",
"temporel" => "t@poREl",
"temporelle" => "t@poREl",
"temporellement" => "t@poREl°m@",
"temporelles" => "t@poREl",
"temporels" => "t@poREl",
"temporisaient" => "t@poRizE",
"temporisait" => "t@poRizE",
"temporisateur" => "t@poRizat9R",
"temporisation" => "t@poRizasj§",
"temporise" => "t@poRiz",
"temporisé" => "t@poRize",
"temporisée" => "t@poRize",
"temporisent" => "t@poRiz",
"temporiser" => "t@poRize",
"temporiserai" => "t@poRiz°RE",
"temporisez" => "t@poRize",
"temporisons" => "t@poRiz§",
"tempos" => "tEmpo",
"temps" => "t@",
"tempura" => "t@pyRa",
"tempuras" => "t@pyRa",
"tenable" => "t°nabl",
"tenace" => "t°nas",
"tenacement" => "t°nas°m@",
"tenaces" => "t°nas",
"ténacité" => "tenasite",
"tenaient" => "t°nE",
"tenaillaient" => "t°najE",
"tenaillait" => "t°najE",
"tenaillant" => "t°naj@",
"tenaille" => "t°naj",
"tenaillé" => "t°naje",
"tenaillée" => "t°naje",
"tenaillent" => "t°naj",
"tenailler" => "t°naje",
"tenailles" => "t°naj",
"tenais" => "t°nE",
"tenait" => "t°nE",
"tenancier" => "t°n@sje",
"tenancière" => "t°n@sjER",
"tenancières" => "t°n@sjER",
"tenanciers" => "t°n@sje",
"tenant" => "t°n@",
"tenante" => "t°n@t",
"tenants" => "t°n@",
"tend" => "t@",
"tendaient" => "t@dE",
"tendais" => "t@dE",
"tendait" => "t@dE",
"tendance" => "t@d@s",
"tendances" => "t@d@s",
"tendancieuse" => "t@d@sj2z",
"tendancieusement" => "t@d@sj2z°m@",
"tendancieuses" => "t@d@sj2z",
"tendancieux" => "t@d@sj2",
"tendant" => "t@d@",
"tende" => "t@d",
"tendelet" => "t@d°lE",
"tendent" => "t@d",
"tender" => "t@d9R",
"tenders" => "t@dER",
"tendeur" => "t@d9R",
"tendeurs" => "t@d9R",
"tendez" => "t@de",
"tendiez" => "t@dje",
"tendineuses" => "t@din2z",
"tendinite" => "t@dinit",
"tendions" => "t@dj§",
"tendirent" => "t@diR",
"tendis" => "t@di",
"tendissent" => "t@dis",
"tendit" => "t@di",
"tendît" => "t@di",
"tendon" => "t@d§",
"tendons" => "t@d§",
"tendra" => "t@dRa",
"tendrai" => "t@dRE",
"tendraient" => "t@dRE",
"tendrais" => "t@dRE",
"tendrait" => "t@dRE",
"tendre" => "t@dR",
"tendrement" => "t@dR°m@",
"tendres" => "t@dR",
"tendresse" => "t@dREs",
"tendresses" => "t@dREs",
"tendreté" => "t@dR°te",
"tendron" => "t@dR§",
"tendrons" => "t@dR§",
"tendront" => "t@dR§",
"tends" => "t@",
"tendu" => "t@dy",
"tendue" => "t@dy",
"tendues" => "t@dy",
"tendus" => "t@dy",
"ténèbre" => "tenEbR",
"ténèbres" => "tenEbR",
"ténébreuse" => "tenebR2z",
"ténébreuses" => "tenebR2z",
"ténébreux" => "tenebR2",
"ténébrionidé" => "tenebRionide",
"teneur" => "t°n9R",
"tenez" => "t°ne",
"ténia" => "tenja",
"ténias" => "tenja",
"teniez" => "t°nje",
"tenions" => "t°nj§",
"tenir" => "t°niR",
"tennis" => "tenis",
"tennis-ballon" => "tenisbal§",
"tennis-club" => "teniskl9b",
"tennisman" => "tenisman",
"tennismen" => "tenismEn",
"tenon" => "t°n§",
"tenons" => "t°n§",
"ténor" => "tenOR",
"ténors" => "tenOR",
"tenseur" => "t@s9R",
"tensiomètre" => "t@sjomEtR",
"tension" => "t@sj§",
"tensions" => "t@sj§",
"tenta" => "t@ta",
"tentaculaire" => "t@takylER",
"tentaculaires" => "t@takylER",
"tentacule" => "t@takyl",
"tentacules" => "t@takyl",
"tentai" => "t@tE",
"tentaient" => "t@tE",
"tentais" => "t@tE",
"tentait" => "t@tE",
"tentâmes" => "t@tam",
"tentant" => "t@t@",
"tentante" => "t@t@t",
"tentantes" => "t@t@t",
"tentants" => "t@t@",
"tentât" => "t@ta",
"tentateur" => "t@tat9R",
"tentateurs" => "t@tat9R",
"tentation" => "t@tasj§",
"tentations" => "t@tasj§",
"tentative" => "t@tativ",
"tentatives" => "t@tativ",
"tentatrice" => "t@tatRis",
"tentatrices" => "t@tatRis",
"tente" => "t@t",
"tenté" => "t@te",
"tentée" => "t@te",
"tentées" => "t@te",
"tentent" => "t@t",
"tenter" => "t@te",
"tentera" => "t@t°Ra",
"tenterai" => "t@t°RE",
"tenteraient" => "t@t°RE",
"tenterais" => "t@t°RE",
"tenterait" => "t@t°RE",
"tenteras" => "t@t°Ra",
"tentèrent" => "t@tER",
"tenterez" => "t@t°Re",
"tenteriez" => "t@t°Rje",
"tenterons" => "t@t°R§",
"tenteront" => "t@t°R§",
"tentes" => "t@t",
"tentés" => "t@te",
"tentez" => "t@te",
"tentiaire" => "t@sjER",
"tentiez" => "t@tje",
"tentions" => "t@tj§",
"tentons" => "t@t§",
"tenture" => "t@tyR",
"tentures" => "t@tyR",
"tenu" => "t°ny",
"ténu" => "teny",
"tenue" => "t°ny",
"ténue" => "teny",
"tenues" => "t°ny",
"ténues" => "teny",
"ténuité" => "ten8ite",
"tenure" => "t2nyR",
"tenus" => "t°ny",
"ténus" => "teny",
"tepidarium" => "tepidaRjOm",
"tequila" => "tekila",
"tequilas" => "t°kila",
"ter" => "tER",
"téraoctets" => "teRaoktE",
"tératologique" => "teRatoloZik",
"tératologiques" => "teRatoloZik",
"tératome" => "teRatom",
"terce" => "tERs",
"tercer" => "tERse",
"tercets" => "tERsE",
"tercio" => "tERsjo",
"térébenthine" => "teReb@tin",
"térébinthe" => "teReb5t",
"térébinthes" => "teReb5t",
"térébrant" => "teRebR@",
"térébrants" => "teRebR@",
"tergal" => "tERgal",
"tergiversaient" => "tERZivERsE",
"tergiversais" => "tERZivERsE",
"tergiversant" => "tERZivERs@",
"tergiversation" => "tERZivERsasj§",
"tergiversations" => "tERZivERsasj§",
"tergiverse" => "tERZivERs",
"tergiversé" => "tERZivERse",
"tergiverser" => "tERZivERse",
"tergiverses" => "tERZivERs",
"tergiversez" => "tERZivERse",
"tergiversons" => "tERZivERs§",
"terme" => "tERm",
"termes" => "tERm",
"termina" => "tERmina",
"terminai" => "tERminE",
"terminaient" => "tERminE",
"terminais" => "tERminE",
"terminaison" => "tERminEz§",
"terminaisons" => "tERminEz§",
"terminait" => "tERminE",
"terminal" => "tERminal",
"terminale" => "tERminal",
"terminales" => "tERminal",
"terminant" => "tERmin@",
"terminât" => "tERmina",
"terminateur" => "tERminat9R",
"terminatrice" => "tERminat°Ris",
"terminaux" => "tERmino",
"termine" => "tERmin",
"terminé" => "tERmine",
"terminée" => "tERmine",
"terminées" => "tERmine",
"terminent" => "tERmin",
"terminer" => "tERmine",
"terminera" => "tERmin°Ra",
"terminerai" => "tERmin°RE",
"termineraient" => "tERmin°RE",
"terminerait" => "tERmin°RE",
"termineras" => "tERmin°Ra",
"terminèrent" => "tERminER",
"terminerez" => "tERmin°Re",
"terminerons" => "tERmin°R§",
"termineront" => "tERmin°R§",
"termines" => "tERmin",
"terminés" => "tERmine",
"terminez" => "tERmine",
"terminiez" => "tERminje",
"terminions" => "tERminj§",
"terminologie" => "tERminoloZi",
"terminologique" => "tERminoloZik",
"terminons" => "tERmin§",
"terminus" => "tERminys",
"termite" => "tERmit",
"termites" => "tERmit",
"termitière" => "tERmitjER",
"termitières" => "tERmisjER",
"ternaire" => "tERnER",
"terne" => "tERn",
"ternes" => "tERn",
"terni" => "tERni",
"ternie" => "tERni",
"ternies" => "tERni",
"ternir" => "tERniR",
"ternirai" => "tERniRE",
"ternirait" => "tERniRE",
"ternis" => "tERni",
"ternissaient" => "tERnisE",
"ternissait" => "tERnisE",
"ternissant" => "tERnis@",
"ternisse" => "tERnis",
"ternissent" => "tERnis",
"ternit" => "tERni",
"terra" => "tERa",
"terra incognita" => "tERainkOgnita",
"terrage" => "tERaZ",
"terrai" => "tERE",
"terraient" => "tERE",
"terrain" => "tER5",
"terrains" => "tER5",
"terrait" => "tERE",
"terramycine" => "tERamisin",
"terrant" => "tER@",
"terraplane" => "tERaplan",
"terrarium" => "tERaRjOm",
"terrassa" => "tERasa",
"terrassai" => "tERasE",
"terrassaient" => "tERasE",
"terrassait" => "tERasE",
"terrassant" => "tERas@",
"terrassât" => "tERasa",
"terrasse" => "tERas",
"terrassé" => "tERase",
"terrassée" => "tERase",
"terrassées" => "tERase",
"terrassement" => "tERas°m@",
"terrassements" => "tERas°m@",
"terrasser" => "tERase",
"terrasserait" => "tERas°RE",
"terrassèrent" => "tERasER",
"terrasses" => "tERas",
"terrassés" => "tERase",
"terrassier" => "tERasje",
"terrassiers" => "tERasje",
"terrasson" => "tERas§",
"terre" => "tER",
"terré" => "tERe",
"terre-à-terre" => "tERatER",
"terre-neuvas" => "tERn9va",
"terre-neuve" => "tERn9v",
"terre-neuvien" => "tERn9vj5",
"terre-plein" => "tERpl5",
"terre-pleins" => "tERpl5",
"terreau" => "tERo",
"terreaux" => "tERo",
"terrée" => "tERe",
"terrées" => "tERe",
"terrent" => "tER",
"terrer" => "tERe",
"terrerait" => "tER°RE",
"terreront" => "tER°R§",
"terres" => "tER",
"terrés" => "tERe",
"terrestre" => "tEREstR",
"terrestres" => "tEREstR",
"terreur" => "tER9R",
"terreurs" => "tER9R",
"terreuse" => "tER2z",
"terreuses" => "tER2z",
"terreux" => "tER2",
"terrez" => "tERe",
"terri" => "tERi",
"terrible" => "tERibl",
"terriblement" => "tERibl°m@",
"terribles" => "tERibl",
"terrien" => "tERj5",
"terrienne" => "tERjEn",
"terriennes" => "tERjEn",
"terriens" => "tERj5",
"terrier" => "tERje",
"terriers" => "tERje",
"terrifia" => "tERifja",
"terrifiaient" => "tERifjE",
"terrifiait" => "tERifjE",
"terrifiant" => "tERifj@",
"terrifiante" => "tERifj@t",
"terrifiantes" => "tERifj@t",
"terrifiants" => "tERifj@",
"terrifie" => "tERifi",
"terrifié" => "tERifje",
"terrifiée" => "tERifje",
"terrifiées" => "tERifje",
"terrifient" => "tERifi",
"terrifier" => "tERifje",
"terrifierait" => "tERifiRE",
"terrifiés" => "tERifje",
"terrifiez" => "tERifje",
"terrifions" => "tERifj§",
"terrifique" => "teRifik",
"terril" => "tERi",
"terrils" => "tERi",
"terrine" => "tERin",
"terrines" => "tERin",
"territoire" => "tERitwaR",
"territoires" => "tERitwaR",
"territorial" => "tERitoRjal",
"territoriale" => "tERitoRjal",
"territorialement" => "tERitoRjal°m@",
"territoriales" => "tERitoRjal",
"territorialité" => "teRitORjalite",
"territoriaux" => "tERitoRjo",
"terroir" => "tERwaR",
"terrons" => "tER§",
"terrorisa" => "tERoRiza",
"terrorisaient" => "tERoRizE",
"terrorisait" => "tERoRizE",
"terrorisant" => "tERoRiz@",
"terrorisante" => "tERoRiz@t",
"terrorisants" => "tERoRiz@",
"terrorise" => "tERoRiz",
"terrorisé" => "tERoRize",
"terrorisée" => "tERoRize",
"terrorisées" => "tERoRize",
"terrorisent" => "tERoRiz",
"terroriser" => "tERoRize",
"terroriseront" => "tERoRiz°R§",
"terrorises" => "tERoRiz",
"terrorisés" => "tERoRize",
"terrorisez" => "tERoRize",
"terrorisme" => "tERoRizm",
"terrorismes" => "tERoRizm",
"terroriste" => "tERoRist",
"terroristes" => "tERoRist",
"tertiaire" => "tERsjER",
"tertiaires" => "tERsjER",
"tertio" => "tERsjo",
"tertre" => "tERtR",
"tertres" => "tERtR",
"tes" => "te",
"tés" => "te",
"tesla" => "tEsla",
"tessiture" => "tesityR",
"tesson" => "tes§",
"tessons" => "tes§",
"test" => "tEst",
"test-match" => "tEstmatS",
"testa" => "tEsta",
"testais" => "tEstE",
"testait" => "tEstE",
"testament" => "tEstam@",
"testamentaire" => "tEstam@tER",
"testamentaires" => "tEstam@tER",
"testaments" => "tEstam@",
"testant" => "tEst@",
"teste" => "tEst",
"testé" => "tEste",
"testée" => "tEste",
"testées" => "tEste",
"testent" => "tEst",
"tester" => "tEste",
"testera" => "tEst°Ra",
"testeras" => "tEst°Ra",
"testèrent" => "tEstER",
"testerons" => "tEst°R§",
"testeront" => "tEst°R§",
"testes" => "tEst",
"testés" => "tEste",
"testeur" => "tEst9R",
"testeuse" => "tEst2z",
"testez" => "tEste",
"testiculaire" => "tEstikylER",
"testicule" => "tEstikyl",
"testicules" => "tEstikyl",
"testiez" => "tEstje",
"testions" => "tEstj§",
"testons" => "tEst§",
"testostérone" => "tEstosteROn",
"testostérones" => "tEstosteROn",
"tests" => "tEst",
"testu" => "tEsty",
"têt" => "tE",
"téta" => "teta",
"tétaient" => "tetE",
"tétais" => "tetE",
"tétait" => "tetE",
"tétanie" => "tetani",
"tétanique" => "tetanik",
"tétaniques" => "tetanik",
"tétanisait" => "tetanizE",
"tétanisant" => "tetaniz@",
"tétanisation" => "tetanizasj§",
"tétanisé" => "tetanize",
"tétanisée" => "tetanize",
"tétanisées" => "tetanize",
"tétanisent" => "tetaniz",
"tétaniser" => "tetanize",
"tétanisés" => "tetanize",
"tétanos" => "tetanos",
"tétant" => "tet@",
"têtard" => "tEtaR",
"têtards" => "tEtaR",
"tétasses" => "tetas",
"tète" => "tEt",
"tête" => "tEt",
"tété" => "tete",
"tête-à-queue" => "tEtak2",
"tête-à-tête" => "tEtatEt",
"tête-bêche" => "tEtbES",
"tête-de-mort" => "tEtd°mOR",
"tête-de-nègre" => "tEtd°nEgR",
"tétée" => "tete",
"tétées" => "tete",
"tètent" => "tEt",
"téter" => "tete",
"tétère" => "tetER",
"tétèrent" => "tetER",
"têtes" => "tEt",
"têtes-de-loup" => "tEtd°lu",
"téteur" => "tet9R",
"têtière" => "tEtjER",
"têtières" => "tEsjER",
"tétiez" => "tetje",
"tétine" => "tetin",
"tétines" => "tetin",
"tétins" => "tet5",
"téton" => "tet§",
"tétons" => "tet§",
"tétra" => "tetRa",
"tétrachlorure" => "tetRakloRyR",
"tétracycline" => "tetRasiklin",
"tétradrachme" => "tetRadRakm",
"tétragones" => "tetRagon",
"tétragramme" => "tetRagRam",
"tétragrammes" => "tetRagRam",
"tétralogie" => "tetRaloZi",
"tétramère" => "tetRamER",
"tétramètre" => "tetRamEtR",
"tétraplégie" => "tetRapleZi",
"tétraplégique" => "tetRapleZik",
"tétrarque" => "tetRaRk",
"tétrarques" => "tetRaRk",
"tétras" => "tetRas",
"tétrodotoxine" => "tetROdotOksin",
"tette" => "tEt",
"têtu" => "tety",
"têtue" => "tety",
"têtues" => "tEty",
"têtus" => "tety",
"teuf-teuf" => "t9ft9f",
"teuton" => "t2t§",
"teutonique" => "t2tonik",
"teutoniques" => "t2tonik",
"teutonne" => "t2tOn",
"teutonnes" => "t2tOn",
"teutons" => "t2t§",
"tévé" => "teve",
"tex" => "tEks",
"texan" => "tEks@",
"texane" => "tEksan",
"texanes" => "tEksan",
"texans" => "tEks@",
"texte" => "tEkst",
"textes" => "tEkst",
"textile" => "tEkstil",
"textiles" => "tEkstil",
"texto" => "tEksto",
"textologie" => "tEkstOlOZi",
"textuel" => "tEkst8El",
"textuelle" => "tEkst8El",
"textuellement" => "tEkst8El°m@",
"textuelles" => "tEkst8El",
"texture" => "tEkstyR",
"textures" => "tEkstyR",
"tézig" => "tezig",
"tézigue" => "tezig",
"thaï" => "taj",
"thaïe" => "taj",
"thaïlandais" => "tajl@dE",
"thaïlandaise" => "tajl@dEz",
"thaïlandaises" => "tajl@dEz",
"thaïs" => "taj",
"thalamique" => "talamik",
"thalamus" => "talamys",
"thalassémie" => "talasemi",
"thalasso" => "talaso",
"thalassothérapeutes" => "talasoteRap2t",
"thalassothérapie" => "talasoteRapi",
"thaler" => "talER",
"thalers" => "talER",
"thalidomide" => "talidomid",
"thallium" => "taljOm",
"thalweg" => "talvEg",
"thanatologie" => "tanatoloZi",
"thanatologique" => "tanatoloZik",
"thanatopraxie" => "tanatopRaksi",
"thanatos" => "tanatOs",
"thanksgiving" => "t@ksgiviG",
"thatchériennes" => "tatSeRjEn",
"thaumaturge" => "tomatyRZ",
"thaumaturges" => "tomatyRZ",
"thaumaturgie" => "tomatyRZi",
"thé" => "te",
"théâtral" => "teatRal",
"théâtrale" => "teatRal",
"théâtralement" => "teatRal°m@",
"théâtrales" => "teatRal",
"théâtralisant" => "teatRaliz@",
"théâtralisé" => "teatRalize",
"théâtralisée" => "teatRalize",
"théâtralité" => "teatRalite",
"théâtraux" => "teatRo",
"théâtre" => "teatR",
"théâtres" => "teatR",
"théâtreuse" => "teatR2z",
"théâtreux" => "teatR2",
"thébaïde" => "tebaid",
"thébaïdes" => "tebaid",
"thébaïne" => "tebain",
"théier" => "teje",
"théière" => "tejER",
"théières" => "tejER",
"théine" => "tein",
"théiste" => "teist",
"thématique" => "tematik",
"thématiquement" => "tematik°m@",
"thématiques" => "tematik",
"thème" => "tEm",
"thèmes" => "tEm",
"théo" => "teo",
"théocratique" => "teokRatik",
"théodolite" => "teOdOlit",
"théologales" => "teologal",
"théologie" => "teoloZi",
"théologien" => "teoloZj5",
"théologiennes" => "teoloZjEn",
"théologiens" => "teoloZj5",
"théologies" => "teoloZi",
"théologique" => "teoloZik",
"théologiquement" => "teOlOZik°m@",
"théologiques" => "teoloZik",
"théophylline" => "teOfilin",
"théorbe" => "teORb",
"théorbes" => "teORb",
"théorème" => "teoREm",
"théorèmes" => "teoREm",
"théoricien" => "teoRisj5",
"théoricienne" => "teoRisjEn",
"théoriciens" => "teoRisj5",
"théorie" => "teoRi",
"théories" => "teoRi",
"théorique" => "teoRik",
"théoriquement" => "teoRik°m@",
"théoriques" => "teoRik",
"théorise" => "teoRiz",
"théoriser" => "teoRize",
"théosophes" => "teozOf",
"théosophie" => "teozofi",
"théosophique" => "teozofik",
"thérapeute" => "teRap2t",
"thérapeutes" => "teRap2t",
"thérapeutique" => "teRap2tik",
"thérapeutiques" => "teRap2tik",
"thérapie" => "teRapi",
"thérapies" => "teRapi",
"thermal" => "tERmal",
"thermale" => "tERmal",
"thermales" => "tERmal",
"thermaux" => "tERmo",
"thermes" => "tERm",
"thermidor" => "tERmidOR",
"thermidorienne" => "tERmidoRjEn",
"thermique" => "tERmik",
"thermiques" => "tERmik",
"thermite" => "tERmit",
"thermo" => "tERmo",
"thermocollants" => "tERmokol@",
"thermodynamique" => "tERmodinamik",
"thermoélectriques" => "tERmoelEktRik",
"thermoformage" => "tERmofORmaZ",
"thermogène" => "tERmoZEn",
"thermographe" => "tERmogRaf",
"thermographie" => "tERmogRafi",
"thermoluminescence" => "tERmolyminEs@s",
"thermomètre" => "tERmomEtR",
"thermomètres" => "tERmomEtR",
"thermonucléaire" => "tERmonykleER",
"thermonucléaires" => "tERmonykleER",
"thermorégulateur" => "tERmoRegylat9R",
"thermos" => "tERmos",
"thermosensible" => "tERmos@sibl",
"thermostat" => "tERmosta",
"thermostats" => "tERmosta",
"thés" => "te",
"thésard" => "tezaR",
"thésards" => "tezaR",
"thésaurise" => "tezoRiz",
"thésauriser" => "tezoRize",
"thésaurisés" => "tezoRize",
"thesaurus" => "tesORys",
"thésaurus" => "tesORys",
"thèse" => "tEz",
"thèses" => "tEz",
"thessalien" => "tEsalj5",
"thessaliens" => "tEsalj5",
"thêta" => "tEta",
"théurgiques" => "teyRZik",
"thiamine" => "tjamin",
"thibaude" => "tibod",
"thomas" => "toma",
"thomisme" => "tomizm",
"thomiste" => "tomist",
"thon" => "t§",
"thonier" => "tonje",
"thoniers" => "tonje",
"thons" => "t§",
"thoracentèse" => "tORas5tEz",
"thoracique" => "toRasik",
"thoraciques" => "toRasik",
"thoracotomie" => "tORakOtOmi",
"thorax" => "toRaks",
"thorine" => "tORin",
"thoron" => "tOR§",
"thrace" => "tRas",
"thraces" => "tRas",
"thrène" => "tREn",
"thrill" => "tRil",
"thriller" => "tRil9R",
"thrillers" => "sRil9R",
"thrombolyse" => "tR§bOliz",
"thrombolytique" => "tR§bOlitik",
"thrombose" => "tR§boz",
"thrombosé" => "tR§boze",
"thrombotique" => "tR§bOtik",
"thug" => "tyg",
"thugs" => "tyg",
"thune" => "tyn",
"thunes" => "tyn",
"thuriféraire" => "tyRifeRER",
"thuriféraires" => "tyRifeRER",
"thuya" => "tyja",
"thuyas" => "tyja",
"thym" => "t5",
"thymectomie" => "timEktOmi",
"thymine" => "timin",
"thymus" => "timys",
"thyréotoxicose" => "tiReotOksikoz",
"thyroïde" => "tiRoid",
"thyroïdectomie" => "tiROidEktOmi",
"thyroïdien" => "tiRoidj5",
"thyroïdienne" => "tiRoidjEn",
"thyroxine" => "tiROksin",
"thyrses" => "tiRs",
"tiama" => "tjama",
"tian" => "tij@",
"tiare" => "tjaR",
"tiaré" => "tjaRe",
"tiares" => "tjaR",
"tibétain" => "tibet5",
"tibétaine" => "tibetEn",
"tibétaines" => "tibetEn",
"tibétains" => "tibet5",
"tibia" => "tibja",
"tibial" => "tibjal",
"tibiale" => "tibjal",
"tibias" => "tibja",
"tic" => "tik",
"tic-tac" => "tiktak",
"ticheurte" => "tiS9Rt",
"ticket" => "tikE",
"tickets" => "tikE",
"tics" => "tik",
"ticsons" => "tiks§",
"tictaquer" => "tiktake",
"tie-break" => "tajbREk",
"tiédasse" => "tjedas",
"tiédasses" => "tjedas",
"tiède" => "tjEd",
"tièdement" => "tjEd°m@",
"tièdes" => "tjEd",
"tiédeur" => "tjed9R",
"tiédeurs" => "tjed9R",
"tiédi" => "tjedi",
"tiédie" => "tjedi",
"tiédies" => "tjedi",
"tiédir" => "tjediR",
"tiédirait" => "tjediRE",
"tiédis" => "tjedi",
"tiédissaient" => "tjedisE",
"tiédissait" => "tjedisE",
"tiédissant" => "tjedis@",
"tiédissent" => "tjedis",
"tiédit" => "tjedi",
"tien" => "tj5",
"tiendra" => "tj5dRa",
"tiendrai" => "tj5dRE",
"tiendraient" => "tj5dRE",
"tiendrais" => "tj5dRE",
"tiendrait" => "tj5dRE",
"tiendras" => "tj5dRa",
"tiendrez" => "tj5dRe",
"tiendriez" => "tj5dRije",
"tiendrons" => "tj5dR§",
"tiendront" => "tj5dR§",
"tienne" => "tjEn",
"tiennent" => "tjEn",
"tiennes" => "tjEn",
"tiens" => "tj5",
"tiens-la-moi" => "tj5lamwa",
"tient" => "tj5",
"tierce" => "tjERs",
"tiercé" => "tjERse",
"tiercefeuille" => "tjERs°f9j",
"tiercelet" => "tjERs°lE",
"tiercelets" => "tjERs°lE",
"tierces" => "tjERs",
"tiercés" => "tjERse",
"tiers" => "tjER",
"tiers-état" => "tjEReta",
"tiers-monde" => "tjERm§d",
"tiers-mondes" => "tjERm§d",
"tiers-mondisme" => "tjERm§dizm",
"tiers-mondiste" => "tjERm§dist",
"tiers-mondistes" => "tjERm§dist",
"tiers-ordre" => "tjERORdR",
"tiers-point" => "tjERpw5",
"tif" => "tif",
"tifs" => "tif",
"tige" => "tiZ",
"tigelles" => "tiZEl",
"tiges" => "tiZ",
"tignasse" => "tiNas",
"tignasses" => "tiNas",
"tigre" => "tigR",
"tigré" => "tigRe",
"tigrée" => "tigRe",
"tigrées" => "tigRe",
"tigres" => "tigR",
"tigrés" => "tigRe",
"tigresse" => "tigREs",
"tigresses" => "tigREs",
"tigrure" => "tigRyR",
"tiki" => "tiki",
"tilbury" => "tilbyRi",
"tilburys" => "tilbyRi",
"till" => "til",
"tillac" => "tijak",
"tillacs" => "tijak",
"tille" => "tij",
"tiller" => "tije",
"tilles" => "tij",
"tilleul" => "tij9l",
"tilleuls" => "tij9l",
"tilt" => "tilt",
"tilts" => "tilt",
"timbale" => "t5bal",
"timbales" => "t5bal",
"timbalier" => "t5balje",
"timbaliers" => "t5balje",
"timbrage" => "t5bRaZ",
"timbrait" => "t5bRE",
"timbrât" => "t5bRa",
"timbre" => "t5bR",
"timbré" => "t5bRe",
"timbre-poste" => "t5bR°pOst",
"timbrée" => "t5bRe",
"timbrées" => "t5bRe",
"timbrer" => "t5bRe",
"timbres" => "t5bR",
"timbrés" => "t5bRe",
"timbres-poste" => "t5bR°pOst",
"time-sharing" => "tajmSERiG",
"timide" => "timid",
"timidement" => "timid°m@",
"timides" => "timid",
"timidité" => "timidite",
"timidités" => "timidite",
"timing" => "tajmiG",
"timings" => "tajmiG",
"timon" => "tim§",
"timonerie" => "timOn°Ri",
"timonier" => "timonje",
"timoniers" => "timonje",
"timons" => "tim§",
"timoré" => "timoRe",
"timorée" => "timoRe",
"timorées" => "timoRe",
"timorés" => "timoRe",
"tin" => "t5",
"tine" => "tin",
"tinée" => "tine",
"tinette" => "tinEt",
"tinettes" => "tinEt",
"tînmes" => "t5m",
"tinrent" => "t5R",
"tins" => "t5",
"tinssent" => "t5s",
"tint" => "t5",
"tînt" => "t5",
"tinta" => "t5ta",
"tintaient" => "t5tE",
"tintait" => "t5tE",
"tintamarre" => "t5tamaR",
"tintamarrent" => "t5tamaR",
"tintamarres" => "t5tamaR",
"tintamarresque" => "t5tamaREsk",
"tintamarresques" => "t5tamaREsk",
"tintant" => "t5t@",
"tinte" => "t5t",
"tinté" => "t5te",
"tintement" => "t5t°m@",
"tintements" => "t5t°m@",
"tintent" => "t5t",
"tinter" => "t5te",
"tintèrent" => "t5tER",
"tintés" => "t5te",
"tintin" => "t5t5",
"tintinnabula" => "t5tinabyla",
"tintinnabulaient" => "t5tinabylE",
"tintinnabulant" => "t5tinabyl@",
"tintinnabulante" => "t5tinabyl@t",
"tintinnabulantes" => "t5tinabyl@t",
"tintinnabulants" => "t5tinabyl@",
"tintinnabule" => "t5tinabyl",
"tintinnabulement" => "t5tinabyl°m@",
"tintinnabulements" => "t5tinabyl°m@",
"tintinnabulent" => "t5tinabyl",
"tintinnabuler" => "t5tinabyle",
"tintouin" => "t5tw5",
"tintouins" => "t5tw5",
"tipe" => "tip",
"tipi" => "tipi",
"tipis" => "tipi",
"tipper" => "tip9R",
"tipule" => "tipyl",
"tiqua" => "tika",
"tiquai" => "tikE",
"tiquaient" => "tikE",
"tiquais" => "tikE",
"tiquait" => "tikE",
"tiquant" => "tik@",
"tique" => "tik",
"tiqué" => "tike",
"tiquent" => "tik",
"tiquer" => "tike",
"tiquerais" => "tik°RE",
"tiques" => "tik",
"tiqueté" => "tik°te",
"tir" => "tiR",
"tira" => "tiRa",
"tirade" => "tiRad",
"tirades" => "tiRad",
"tirage" => "tiRaZ",
"tirages" => "tiRaZ",
"tirai" => "tiRE",
"tiraient" => "tiRE",
"tirailla" => "tiRaja",
"tiraillaient" => "tiRajE",
"tiraillait" => "tiRajE",
"tiraillant" => "tiRaj@",
"tiraille" => "tiRaj",
"tiraillé" => "tiRaje",
"tiraillée" => "tiRaje",
"tiraillées" => "tiRaje",
"tiraillement" => "tiRaj°m@",
"tiraillements" => "tiRaj°m@",
"tiraillent" => "tiRaj",
"tirailler" => "tiRaje",
"tiraillerait" => "tiRaj°RE",
"tirailleries" => "tiRaj°Ri",
"tiraillés" => "tiRaje",
"tirailleur" => "tiRaj9R",
"tirailleurs" => "tiRaj9R",
"tiraillez" => "tiRaje",
"tiraillons" => "tiRaj§",
"tirais" => "tiRE",
"tirait" => "tiRE",
"tirâmes" => "tiRam",
"tiramisu" => "tiRamizy",
"tirant" => "tiR@",
"tirants" => "tiR@",
"tiras" => "tiRa",
"tirassent" => "tiRas",
"tirât" => "tiRa",
"tire" => "tiR",
"tiré" => "tiRe",
"tire-au-cul" => "tiRoky",
"tire-au-flanc" => "tiRofl@",
"tire-botte" => "tiRbOt",
"tire-bouchon" => "tiRbuS§",
"tire-bouchonnaient" => "tiRbuSonE",
"tire-bouchonnant" => "tiRbuSon@",
"tire-bouchonne" => "tiRbuSOn",
"tire-bouchonné" => "tiRbuSone",
"tire-bouchonnent" => "tiRbuSOn",
"tire-bouchonnés" => "tiRbuSone",
"tire-bouchons" => "tiRbuS§",
"tire-bouton" => "tiRbut§",
"tire-d'aile" => "tiRdEl",
"tire-fesse" => "tiRfEs",
"tire-jus" => "tiRZy",
"tire-laine" => "tiRlEn",
"tire-lait" => "tiRlE",
"tire-larigot" => "tiRlaRigo",
"tire-ligne" => "tiRliN",
"tire-lignes" => "tiRliN",
"tire-lire" => "tiRliR",
"tirebouchonné" => "tiR°buSone",
"tirebouchonnée" => "tiR°buSone",
"tirebouchonner" => "tiR°buSone",
"tirée" => "tiRe",
"tirées" => "tiRe",
"tirelire" => "tiR°liR",
"tirelirent" => "tiR°liR",
"tirelires" => "tiR°liR",
"tirent" => "tiR",
"tirer" => "tiRe",
"tirera" => "tiR°Ra",
"tirerai" => "tiR°RE",
"tireraient" => "tiR°RE",
"tirerais" => "tiR°RE",
"tirerait" => "tiR°RE",
"tireras" => "tiR°Ra",
"tirèrent" => "tiRER",
"tirerez" => "tiR°Re",
"tireriez" => "tiR°Rje",
"tirerions" => "tiR°Rj§",
"tirerons" => "tiR°R§",
"tireront" => "tiR°R§",
"tires" => "tiR",
"tirés" => "tiRe",
"tiret" => "tiRE",
"tirets" => "tiRE",
"tirette" => "tiREt",
"tirettes" => "tiREt",
"tireur" => "tiR9R",
"tireurs" => "tiR9R",
"tireuse" => "tiR2z",
"tireuses" => "tiR2z",
"tirez" => "tiRe",
"tiriez" => "tiRje",
"tirions" => "tiRj§",
"tiroir" => "tiRwaR",
"tiroir-caisse" => "tiRwaRkEs",
"tiroirs" => "tiRwaR",
"tiroirs-caisses" => "tiRwaRkEs",
"tirons" => "tiR§",
"tirs" => "tiR",
"tisa" => "tiza",
"tisane" => "tizan",
"tisané" => "tizane",
"tisanes" => "tizan",
"tisanière" => "tizanjER",
"tiser" => "tize",
"tison" => "tiz§",
"tisonna" => "tizona",
"tisonnait" => "tizonE",
"tisonnant" => "tizon@",
"tisonne" => "tizOn",
"tisonné" => "tizone",
"tisonnent" => "tizOn",
"tisonner" => "tizone",
"tisonnés" => "tizone",
"tisonnier" => "tizonje",
"tisonniers" => "tizonje",
"tisons" => "tiz§",
"tissa" => "tisa",
"tissage" => "tisaZ",
"tissages" => "tisaZ",
"tissaient" => "tisE",
"tissais" => "tisE",
"tissait" => "tisE",
"tissant" => "tis@",
"tissât" => "tisa",
"tisse" => "tis",
"tissé" => "tise",
"tissée" => "tise",
"tissées" => "tise",
"tissent" => "tis",
"tisser" => "tise",
"tisserai" => "tis°RE",
"tisserais" => "tis°RE",
"tisserait" => "tis°RE",
"tisserand" => "tis°R@",
"tisserande" => "tis°R@d",
"tisserands" => "tis°R@",
"tissèrent" => "tisER",
"tisserons" => "tis°R§",
"tissés" => "tise",
"tisseur" => "tis9R",
"tisseuse" => "tis2z",
"tissez" => "tise",
"tissons" => "tis§",
"tissu" => "tisy",
"tissu-éponge" => "tisyep§Z",
"tissue" => "tisy",
"tissues" => "tisy",
"tissulaire" => "tisylER",
"tissulaires" => "tisylER",
"tissus" => "tisy",
"tissuterie" => "tisyt°Ri",
"tissutier" => "tisytje",
"titan" => "tit@",
"titane" => "titan",
"titanesque" => "titanEsk",
"titanesques" => "titanEsk",
"titanique" => "titanik",
"titans" => "tit@",
"titi" => "titi",
"titilla" => "titija",
"titillaient" => "titijE",
"titillais" => "titijE",
"titillait" => "titijE",
"titillant" => "titij@",
"titillation" => "titijasj§",
"titillations" => "titijasj§",
"titille" => "titij",
"titillé" => "titije",
"titillées" => "titije",
"titillement" => "titij°m@",
"titillements" => "titij°m@",
"titillent" => "titij",
"titiller" => "titije",
"titillera" => "titij°Ra",
"titillés" => "titije",
"titis" => "titi",
"titisme" => "titizm",
"titra" => "titRa",
"titrage" => "titRaZ",
"titrait" => "titRE",
"titre" => "titR",
"titré" => "titRe",
"titrée" => "titRe",
"titrées" => "titRe",
"titrer" => "titRe",
"titres" => "titR",
"titrés" => "titRe",
"tituba" => "tityba",
"titubai" => "titybE",
"titubaient" => "titybE",
"titubais" => "titybE",
"titubait" => "titybE",
"titubant" => "tityb@",
"titubante" => "tityb@t",
"titubantes" => "tityb@t",
"titubants" => "tityb@",
"titubation" => "titybasj§",
"titubations" => "titybasj§",
"titube" => "tityb",
"titubé" => "titybe",
"titubement" => "tityb°m@",
"titubent" => "tityb",
"tituber" => "titybe",
"titubèrent" => "titybER",
"titubez" => "titybe",
"titubiez" => "titybje",
"titubions" => "titybj§",
"titulaire" => "titylER",
"titulaires" => "titylER",
"titularisation" => "titylaRizasj§",
"titularisé" => "titylaRize",
"titularisée" => "titylaRize",
"titulariser" => "titylaRize",
"to" => "to",
"toast" => "tost",
"toasté" => "toste",
"toaster" => "toaste",
"toasteur" => "tost9R",
"toasts" => "tost",
"toboggan" => "tobog@",
"toboggans" => "tobog@",
"toc" => "tOk",
"tocade" => "tokad",
"tocante" => "tok@t",
"tocard" => "tokaR",
"tocarde" => "tokaRd",
"tocardes" => "tokaRd",
"tocards" => "tokaR",
"toccata" => "tokata",
"tocs" => "tOk",
"tocsin" => "tOks5",
"tocsins" => "tOks5",
"toffee" => "tOfi",
"tofu" => "tofy",
"toge" => "tOZ",
"toges" => "tOZ",
"togolais" => "togolE",
"togolaise" => "togolEz",
"togolaises" => "togolEz",
"tohu-bohu" => "toyboy",
"toi" => "twa",
"toi-même" => "twamEm",
"toilasses" => "twalas",
"toile" => "twal",
"toilé" => "twale",
"toilée" => "twale",
"toiles" => "twal",
"toilés" => "twale",
"toiletta" => "twalEta",
"toilettage" => "twalEtaZ",
"toilettait" => "twalEtE",
"toilette" => "twalEt",
"toiletté" => "twalEte",
"toilettées" => "twalEte",
"toiletter" => "twalEte",
"toilettes" => "twalEt",
"toilettés" => "twalEte",
"toiletteur" => "twalEt9R",
"toisa" => "twaza",
"toisaient" => "twazE",
"toisait" => "twazE",
"toisant" => "twaz@",
"toise" => "twaz",
"toisé" => "twaze",
"toisée" => "twaze",
"toisent" => "twaz",
"toiser" => "twaze",
"toisèrent" => "twazER",
"toises" => "twaz",
"toisés" => "twaze",
"toisez" => "twaze",
"toison" => "twaz§",
"toisons" => "twaz§",
"toit" => "twa",
"toits" => "twa",
"toiture" => "twatyR",
"toitures" => "twatyR",
"tokamak" => "tOkamak",
"tokay" => "tokE",
"tokharien" => "tokaRj5",
"tolar" => "tolaR",
"tôlarde" => "tolaRd",
"tôle" => "tol",
"toléra" => "toleRa",
"tolérable" => "toleRabl",
"tolérables" => "toleRabl",
"toléraient" => "toleRE",
"tolérais" => "toleRE",
"tolérait" => "toleRE",
"tolérance" => "toleR@s",
"tolérant" => "toleR@",
"tolérante" => "toleR@t",
"tolérantes" => "toleR@t",
"tolérants" => "toleR@",
"tolérât" => "toleRa",
"tolère" => "tolER",
"toléré" => "toleRe",
"tolérée" => "toleRe",
"tolérées" => "toleRe",
"tolèrent" => "tolER",
"tolérer" => "toleRe",
"tolérera" => "toleR°Ra",
"tolérerai" => "toleR°RE",
"tolérerais" => "toleR°RE",
"tolérerait" => "toleR°RE",
"tolérerions" => "toleR°Rj§",
"tolérerons" => "toleR°R§",
"toléreront" => "toleR°R§",
"tolérés" => "toleRe",
"tolérez" => "toleRe",
"tôlerie" => "tol°Ri",
"tolériez" => "toleRje",
"tolérions" => "toleRj§",
"tolérons" => "toleR§",
"tôles" => "tol",
"tolet" => "tolE",
"tolets" => "tolE",
"tôlier" => "tolje",
"tôlière" => "toljER",
"tôliers" => "tolje",
"tollé" => "tole",
"tolstoïen" => "tOlstoj5",
"toltèque" => "tOltEk",
"toltèques" => "tOltEk",
"tolu" => "toly",
"toluène" => "tol8En",
"toluidine" => "tOl8idin",
"tom" => "tOm",
"tom-pouce" => "tOmpus",
"tom-tom" => "tOmtOm",
"toma" => "toma",
"tomahawk" => "tomaOk",
"tomahawks" => "tomaOk",
"toman" => "tOman",
"tomate" => "tomat",
"tomates" => "tomat",
"tomba" => "t§ba",
"tombai" => "t§bE",
"tombaient" => "t§bE",
"tombais" => "t§bE",
"tombait" => "t§bE",
"tombal" => "t§bal",
"tombale" => "t§bal",
"tombales" => "t§bal",
"tombâmes" => "t§bam",
"tombant" => "t§b@",
"tombante" => "t§b@t",
"tombantes" => "t§b@t",
"tombants" => "t§b@",
"tombât" => "t§ba",
"tombe" => "t§b",
"tombé" => "t§be",
"tombeau" => "t§bo",
"tombeaux" => "t§bo",
"tombée" => "t§be",
"tombées" => "t§be",
"tombent" => "t§b",
"tomber" => "t§be",
"tombera" => "t§b°Ra",
"tomberai" => "t§b°RE",
"tomberaient" => "t§b°RE",
"tomberais" => "t§b°RE",
"tomberait" => "t§b°RE",
"tomberas" => "t§b°Ra",
"tombereau" => "t§b°Ro",
"tombereaux" => "t§b°Ro",
"tombèrent" => "t§bER",
"tomberez" => "t§b°Re",
"tomberiez" => "t§b°Rje",
"tomberions" => "t§b°Rj§",
"tomberons" => "t§b°R§",
"tomberont" => "t§b°R§",
"tombes" => "t§b",
"tombés" => "t§be",
"tombeur" => "t§b9R",
"tombeurs" => "t§b9R",
"tombeuse" => "t§b2z",
"tombeuses" => "t§b2z",
"tombez" => "t§be",
"tombiez" => "t§bje",
"tombions" => "t§bj§",
"tombola" => "t§bola",
"tombolas" => "t§bola",
"tombons" => "t§b§",
"tome" => "tOm",
"tomes" => "tOm",
"tomettes" => "tomEt",
"tomme" => "tOm",
"tommes" => "tOm",
"tommette" => "tomEt",
"tommettes" => "tomEt",
"tommies" => "tomi",
"tommy" => "tOmi",
"tomodensitomètre" => "tomod@sitOmEtR",
"tomodensitométrie" => "tomod@sitOmEtRi",
"tomographe" => "tomogRaf",
"tomographie" => "tomogRafi",
"ton" => "t§",
"tonal" => "tonal",
"tonale" => "tonal",
"tonalité" => "tonalite",
"tonalités" => "tonalite",
"tond" => "t§",
"tondais" => "t§dE",
"tondait" => "t§dE",
"tondant" => "t§d@",
"tonde" => "t§d",
"tondent" => "t§d",
"tondes" => "t§d",
"tondeur" => "t§d9R",
"tondeuse" => "t§d2z",
"tondeuses" => "t§d2z",
"tondit" => "t§di",
"tondons" => "t§d§",
"tondrai" => "t§dRE",
"tondrais" => "t§dRE",
"tondre" => "t§dR",
"tonds" => "t§",
"tondu" => "t§dy",
"tondue" => "t§dy",
"tondues" => "t§dy",
"tondus" => "t§dy",
"toner" => "tonER",
"tong" => "t§g",
"tongs" => "t§g",
"tonic" => "tonik",
"tonicardiaque" => "tonikaRdjak",
"tonicité" => "tonisite",
"tonics" => "tonik",
"tonie" => "toni",
"tonifiaient" => "tonifjE",
"tonifiant" => "tonifj@",
"tonifiante" => "tonifj@t",
"tonifiants" => "tonifj@",
"tonifie" => "tonifi",
"tonifient" => "tonifi",
"tonifier" => "tonifje",
"tonique" => "tonik",
"toniques" => "tonik",
"tonitrua" => "tonitRya",
"tonitruaient" => "tonitRyE",
"tonitruais" => "tonitRyE",
"tonitruait" => "tonitRyE",
"tonitruance" => "tonitRy@s",
"tonitruances" => "tonitRy@s",
"tonitruant" => "tonitRy@",
"tonitruante" => "tonitRy@t",
"tonitruantes" => "tonitRy@t",
"tonitruants" => "tonitRy@",
"tonitrue" => "tonitRy",
"tonitrué" => "tonitRye",
"tonitruent" => "tonitRy",
"tonitruer" => "tonitR8e",
"tonka" => "t§ka",
"tonkinois" => "t§kinwa",
"tonkinoise" => "t§kinwaz",
"tonna" => "tona",
"tonnage" => "tonaZ",
"tonnages" => "tonaZ",
"tonnaient" => "tonE",
"tonnais" => "tonE",
"tonnait" => "tonE",
"tonnant" => "ton@",
"tonnante" => "ton@t",
"tonnantes" => "ton@t",
"tonnants" => "ton@",
"tonne" => "tOn",
"tonné" => "tone",
"tonneau" => "tono",
"tonneaux" => "tono",
"tonnelet" => "tOn°lE",
"tonnelets" => "tOn°lE",
"tonnelier" => "ton°lje",
"tonneliers" => "ton°lje",
"tonnelle" => "tonEl",
"tonnellerie" => "tonEl°Ri",
"tonnelleries" => "tonEl°Ri",
"tonnelles" => "tonEl",
"tonnent" => "tOn",
"tonner" => "tone",
"tonnerait" => "tOn°RE",
"tonnerre" => "tonER",
"tonnerres" => "tonER",
"tonnes" => "tOn",
"tonnez" => "tone",
"tons" => "t§",
"tonsure" => "t§syR",
"tonsuré" => "t§syRe",
"tonsures" => "t§syR",
"tonte" => "t§t",
"tonton" => "t§t§",
"tontons" => "t§t§",
"tonus" => "tonys",
"too much" => "tum9tS",
"top" => "tOp",
"top models" => "tOpmodEl",
"top-modèle" => "tOpmodEl",
"top-modèles" => "tOpmodEl",
"topa" => "topa",
"topaze" => "topaz",
"topazes" => "topaz",
"tope" => "tOp",
"topé" => "tope",
"toper" => "tope",
"topés" => "tope",
"topette" => "topEt",
"topettes" => "topEt",
"topez" => "tope",
"tophus" => "tofys",
"topinambour" => "topin@buR",
"topinambours" => "topin@buR",
"topions" => "topj§",
"topique" => "topik",
"topless" => "toplEs",
"topo" => "topo",
"topographie" => "topogRafi",
"topographique" => "topogRafik",
"topographiquement" => "topogRafik°m@",
"topographiques" => "topogRafik",
"topologie" => "topoloZi",
"topologique" => "topoloZik",
"topons" => "top§",
"toponymie" => "toponimi",
"topos" => "topo",
"tops" => "tOp",
"toqua" => "toka",
"toquade" => "tokad",
"toquades" => "tokad",
"toquais" => "tokE",
"toquait" => "tokE",
"toquant" => "tok@",
"toquante" => "tok@t",
"toquantes" => "tok@t",
"toquard" => "tokaR",
"toquarde" => "tokaRd",
"toquardes" => "tokaRd",
"toquards" => "tokaR",
"toque" => "tOk",
"toqué" => "toke",
"toquée" => "toke",
"toquées" => "toke",
"toquer" => "toke",
"toques" => "tOk",
"toqués" => "toke",
"toquez" => "toke",
"torana" => "tORana",
"torcha" => "tORSa",
"torchaient" => "tORSE",
"torchais" => "tORSE",
"torchait" => "tORSE",
"torchant" => "tORS@",
"torchassions" => "tORSasj§",
"torche" => "tORS",
"torché" => "tORSe",
"torche-cul" => "tORS°ky",
"torchée" => "tORSe",
"torchées" => "tORSe",
"torchent" => "tORS",
"torcher" => "tORSe",
"torcherais" => "tORS°RE",
"torcheras" => "tORS°Ra",
"torchère" => "tORSER",
"torchères" => "tORSER",
"torches" => "tORS",
"torchés" => "tORSe",
"torchez" => "tORSe",
"torchis" => "tORSi",
"torchon" => "tORS§",
"torchonnait" => "tORSonE",
"torchonne" => "tORSOn",
"torchonner" => "tORSone",
"torchons" => "tORS§",
"tord" => "tOR",
"tord-boyaux" => "tORbwajo",
"tord-nez" => "tORne",
"tordage" => "tORdaZ",
"tordaient" => "tORdE",
"tordais" => "tORdE",
"tordait" => "tORdE",
"tordant" => "tORd@",
"tordante" => "tORd@t",
"tordantes" => "tORd@t",
"tordants" => "tORd@",
"torde" => "tORd",
"tordent" => "tORd",
"tordeur" => "tORd9R",
"tordeurs" => "tORd9R",
"tordez" => "tORde",
"tordiez" => "tORdje",
"tordion" => "tORdj§",
"tordions" => "tORdj§",
"tordirent" => "tORdiR",
"tordis" => "tORdi",
"tordit" => "tORdi",
"tordît" => "tORdi",
"tordra" => "tORdRa",
"tordrai" => "tORdRE",
"tordraient" => "tORdRE",
"tordrais" => "tORdRE",
"tordrait" => "tORdRE",
"tordras" => "tORdRa",
"tordre" => "tORdR",
"tordrez" => "tORdRe",
"tordront" => "tORdR§",
"tords" => "tOR",
"tordu" => "tORdy",
"tordue" => "tORdy",
"tordues" => "tORdy",
"tordus" => "tORdy",
"tore" => "tOR",
"toréador" => "toReadOR",
"toréador-vedette" => "toReadORv°dEt",
"toréadors" => "toReadOR",
"torée" => "toRe",
"toréer" => "toRee",
"torera" => "tOReRa",
"torero" => "toReRo",
"toreros" => "toReRo",
"tores" => "tOR",
"torgnole" => "tORNOl",
"torgnoles" => "tORNOl",
"tories" => "toRi",
"toril" => "toRil",
"tornade" => "tORnad",
"tornades" => "tORnad",
"toro" => "tORo",
"torons" => "toR§",
"torpédo" => "tORpedo",
"torpédos" => "tORpedo",
"torpeur" => "tORp9R",
"torpeurs" => "tORp9R",
"torpide" => "tORpid",
"torpillage" => "tORpijaZ",
"torpillages" => "tORpijaZ",
"torpillaient" => "tORpijE",
"torpillait" => "tORpijE",
"torpille" => "tORpij",
"torpillé" => "tORpije",
"torpillée" => "tORpije",
"torpiller" => "tORpije",
"torpillera" => "tORpij°Ra",
"torpilles" => "tORpij",
"torpillés" => "tORpije",
"torpilleur" => "tORpij9R",
"torpilleurs" => "tORpij9R",
"torque" => "tORk",
"torréfaction" => "toRefaksj§",
"torréfiait" => "toRefjE",
"torréfiant" => "toRefj@",
"torréfie" => "toRefi",
"torréfié" => "toRefje",
"torréfiée" => "toRefje",
"torréfiées" => "toRefje",
"torréfient" => "toRefi",
"torrent" => "toR@",
"torrentiel" => "toR@sjEl",
"torrentielle" => "toR@sjEl",
"torrentielles" => "toR@sjEl",
"torrentiels" => "toR@sjEl",
"torrents" => "toR@",
"torrentueuses" => "toR@t82z",
"torrentueux" => "toR@t82",
"torride" => "toRid",
"torrides" => "toRid",
"tors" => "tOR",
"torsada" => "tORsada",
"torsade" => "tORsad",
"torsadé" => "tORsade",
"torsadée" => "tORsade",
"torsadées" => "tORsade",
"torsades" => "tORsad",
"torsadés" => "tORsade",
"torse" => "tORs",
"torses" => "tORs",
"torsion" => "tORsj§",
"torsions" => "tORsj§",
"tort" => "tOR",
"tortellini" => "tORtElini",
"tortellinis" => "tORtElini",
"torticolis" => "tORtikoli",
"tortil" => "tORtil",
"tortilla" => "tORtija",
"tortillaient" => "tORtijE",
"tortillais" => "tORtijE",
"tortillait" => "tORtijE",
"tortillant" => "tORtij@",
"tortillard" => "tORtijaR",
"tortillards" => "tORtijaR",
"tortillas" => "tORtija",
"tortille" => "tORtij",
"tortillé" => "tORtije",
"tortillée" => "tORtije",
"tortillées" => "tORtije",
"tortillement" => "tORtij°m@",
"tortillements" => "tORtij°m@",
"tortillent" => "tORtij",
"tortiller" => "tORtije",
"tortillés" => "tORtije",
"tortillez" => "tORtije",
"tortillon" => "tORtij§",
"tortillons" => "tORtij§",
"tortils" => "tORtil",
"tortionnaire" => "tORsjonER",
"tortionnaires" => "tORsjonER",
"tortora" => "tORtoRa",
"tortorait" => "tORtoRE",
"tortorant" => "tORtoR@",
"tortore" => "tORtOR",
"tortoré" => "tORtoRe",
"tortorent" => "tORtOR",
"tortorer" => "tORtoRe",
"torts" => "tOR",
"tortu" => "tORty",
"tortue" => "tORty",
"tortues" => "tORty",
"tortueuse" => "tORt82z",
"tortueuses" => "tORt82z",
"tortueux" => "tORt82",
"tortura" => "tORtyRa",
"torturai" => "tORtyRE",
"torturaient" => "tORtyRE",
"torturais" => "tORtyRE",
"torturait" => "tORtyRE",
"torturant" => "tORtyR@",
"torturante" => "tORtyR@t",
"torturantes" => "tORtyR@t",
"torturants" => "tORtyR@",
"torture" => "tORtyR",
"torturé" => "tORtyRe",
"torturée" => "tORtyRe",
"torturées" => "tORtyRe",
"torturent" => "tORtyR",
"torturer" => "tORtyRe",
"torturera" => "tORtyR°Ra",
"torturerai" => "tORtyR°RE",
"tortureraient" => "tORtyR°RE",
"torturèrent" => "tORtyRER",
"torturerez" => "tORtyR°Re",
"tortureront" => "tORtyR°R§",
"tortures" => "tORtyR",
"torturés" => "tORtyRe",
"tortureurs" => "tORtyR9R",
"torturez" => "tORtyRe",
"torturions" => "tORtyRj§",
"torturons" => "tORtyR§",
"tortus" => "tORty",
"torve" => "tORv",
"torves" => "tORv",
"tos" => "to",
"toscan" => "tOsk@",
"toscane" => "tOskan",
"toscanes" => "tOskan",
"toscans" => "tOsk@",
"toss" => "tOs",
"tossé" => "tose",
"tôt" => "to",
"tôt-fait" => "tofE",
"total" => "total",
"totale" => "total",
"totalement" => "total°m@",
"totales" => "total",
"totalisait" => "totalizE",
"totalisant" => "totaliz@",
"totalisateur" => "tOtalizat9R",
"totalisation" => "totalizasj§",
"totalise" => "totaliz",
"totalisé" => "totalize",
"totalisent" => "totaliz",
"totaliser" => "totalize",
"totalitaire" => "totalitER",
"totalitaires" => "totalitER",
"totalitarisme" => "totalitaRizm",
"totalitarismes" => "totalitaRizm",
"totalité" => "totalite",
"totalités" => "totalite",
"totaux" => "toto",
"totem" => "totEm",
"totémique" => "totemik",
"totémiques" => "totemik",
"totémisme" => "tOtemism",
"totems" => "totEm",
"toto" => "toto",
"totoche" => "totOS",
"totoches" => "totOS",
"toton" => "tot§",
"totons" => "tot§",
"totos" => "toto",
"touareg" => "twaReg",
"touaregs" => "tuaREg",
"toubab" => "tubab",
"toubabs" => "tubab",
"toubib" => "tubib",
"toubibs" => "tubib",
"toucan" => "tuk@",
"toucha" => "tuSa",
"touchai" => "tuSE",
"touchaient" => "tuSE",
"touchais" => "tuSE",
"touchait" => "tuSE",
"touchant" => "tuS@",
"touchante" => "tuS@t",
"touchantes" => "tuS@t",
"touchants" => "tuS@",
"touchât" => "tuSa",
"touche" => "tuS",
"touché" => "tuSe",
"touche-pipi" => "tuSpipi",
"touche-touche" => "tuStuS",
"touchée" => "tuSe",
"touchées" => "tuSe",
"touchent" => "tuS",
"toucher" => "tuSe",
"touchera" => "tuS°Ra",
"toucherai" => "tuS°RE",
"toucheraient" => "tuS°RE",
"toucherais" => "tuS°RE",
"toucherait" => "tuS°RE",
"toucheras" => "tuS°Ra",
"touchèrent" => "tuSER",
"toucherez" => "tuS°Re",
"toucherions" => "tuS°Rj§",
"toucherons" => "tuS°R§",
"toucheront" => "tuS°R§",
"touchers" => "tuSe",
"touches" => "tuS",
"touchés" => "tuSe",
"touchette" => "tuSEt",
"touchez" => "tuSe",
"touchiez" => "tuSje",
"touchions" => "tuSj§",
"touchons" => "tuS§",
"touchotter" => "tuSOte",
"toue" => "tu",
"toué" => "twe",
"touer" => "twe",
"toues" => "tu",
"touffe" => "tuf",
"touffes" => "tuf",
"touffeur" => "tuf9R",
"touffeurs" => "tuf9R",
"touffu" => "tufy",
"touffue" => "tufy",
"touffues" => "tufy",
"touffus" => "tufy",
"touillais" => "tujE",
"touillait" => "tujE",
"touillant" => "tuj@",
"touille" => "tuj",
"touillé" => "tuje",
"touillée" => "tuje",
"touillées" => "tuje",
"touillent" => "tuj",
"touiller" => "tuje",
"touillés" => "tuje",
"toujours" => "tuZuR",
"toulonnais" => "tulonE",
"touloupes" => "tulup",
"toulousain" => "tuluz5",
"toulousaine" => "tuluzEn",
"toulousaines" => "tuluzEn",
"toulousains" => "tuluz5",
"toundra" => "tundRa",
"toundras" => "tundRa",
"toungouse" => "tuGuz",
"toupet" => "tupE",
"toupets" => "tupE",
"toupie" => "tupi",
"toupies" => "tupi",
"toupilleur" => "tupij9R",
"toupinant" => "tupin@",
"touque" => "tuk",
"touques" => "tuk",
"tour" => "tuR",
"tourangeau" => "tuR@Zo",
"tourangeaux" => "tuR@Zo",
"tourangelle" => "tuR@ZEl",
"tourangelles" => "tuR@ZEl",
"tourbe" => "tuRb",
"tourbes" => "tuRb",
"tourbeuse" => "tuRb2z",
"tourbeux" => "tuRb2",
"tourbière" => "tuRbjER",
"tourbières" => "tuRbjER",
"tourbiers" => "tuRbje",
"tourbillon" => "tuRbij§",
"tourbillonna" => "tuRbijona",
"tourbillonnaient" => "tuRbijonE",
"tourbillonnaire" => "tuRbijonER",
"tourbillonnais" => "tuRbijonE",
"tourbillonnait" => "tuRbijonE",
"tourbillonnant" => "tuRbijon@",
"tourbillonnante" => "tuRbijon@t",
"tourbillonnantes" => "tuRbijon@t",
"tourbillonnants" => "tuRbijon@",
"tourbillonne" => "tuRbijOn",
"tourbillonné" => "tuRbijone",
"tourbillonnement" => "tuRbijOn°m@",
"tourbillonnements" => "tuRbijOn°m@",
"tourbillonnent" => "tuRbijOn",
"tourbillonner" => "tuRbijone",
"tourbillonnèrent" => "tuRbijonER",
"tourbillonnez" => "tuRbijone",
"tourbillons" => "tuRbij§",
"tourde" => "tuRd",
"tourelle" => "tuREl",
"tourelles" => "tuREl",
"touret" => "tuRE",
"tourière" => "tuRjER",
"tourillon" => "tuRij§",
"tourisme" => "tuRizm",
"touriste" => "tuRist",
"touristes" => "tuRist",
"touristique" => "tuRistik",
"touristiques" => "tuRistik",
"tourlourou" => "tuRluRu",
"tourlousine" => "tuRluzin",
"tourmalines" => "tuRmalin",
"tourment" => "tuRm@",
"tourmenta" => "tuRm@ta",
"tourmentai" => "tuRm@tE",
"tourmentaient" => "tuRm@tE",
"tourmentais" => "tuRm@tE",
"tourmentait" => "tuRm@tE",
"tourmentant" => "tuRm@t@",
"tourmentante" => "tuRm@t@t",
"tourmentantes" => "tuRm@t@t",
"tourmentât" => "tuRm@ta",
"tourmente" => "tuRm@t",
"tourmenté" => "tuRm@te",
"tourmentée" => "tuRm@te",
"tourmentées" => "tuRm@te",
"tourmentent" => "tuRm@t",
"tourmenter" => "tuRm@te",
"tourmentera" => "tuRm@t°Ra",
"tourmenterai" => "tuRm@t°RE",
"tourmenteraient" => "tuRm@t°RE",
"tourmentèrent" => "tuRm@tER",
"tourmenteront" => "tuRm@t°R§",
"tourmentes" => "tuRm@t",
"tourmentés" => "tuRm@te",
"tourmenteur" => "tuRm@t9R",
"tourmenteurs" => "tuRm@t9R",
"tourmentez" => "tuRm@te",
"tourmentiez" => "tuRm@tje",
"tourmentin" => "tuRm@t5",
"tourmentins" => "tuRm@t5",
"tourments" => "tuRm@",
"tourna" => "tuRna",
"tournage" => "tuRnaZ",
"tournages" => "tuRnaZ",
"tournai" => "tuRnE",
"tournaient" => "tuRnE",
"tournaillaient" => "tuRnajE",
"tournaillé" => "tuRnaje",
"tournailler" => "tuRnaje",
"tournais" => "tuRnE",
"tournait" => "tuRnE",
"tournâmes" => "tuRnam",
"tournant" => "tuRn@",
"tournante" => "tuRn@t",
"tournantes" => "tuRn@t",
"tournants" => "tuRn@",
"tournas" => "tuRna",
"tournât" => "tuRna",
"tourne" => "tuRn",
"tourné" => "tuRne",
"tourne-disque" => "tuRn°disk",
"tourne-disques" => "tuRn°disk",
"tourneboulant" => "tuRn°bul@",
"tourneboule" => "tuRn°bul",
"tourneboulé" => "tuRn°bule",
"tourneboulée" => "tuRn°bule",
"tourneboulés" => "tuRn°bule",
"tournebroche" => "tuRn°bROS",
"tournedos" => "tuRn°do",
"tournée" => "tuRne",
"tournées" => "tuRne",
"tournelle" => "tuRnEl",
"tournemain" => "tuRn°m5",
"tournements" => "tuRn°m@",
"tournent" => "tuRn",
"tourner" => "tuRne",
"tournera" => "tuRn°Ra",
"tournerai" => "tuRn°RE",
"tourneraient" => "tuRn°RE",
"tournerais" => "tuRn°RE",
"tournerait" => "tuRn°RE",
"tourneras" => "tuRn°Ra",
"tournèrent" => "tuRnER",
"tournerez" => "tuRn°Re",
"tourneries" => "tuRn°Ri",
"tourneriez" => "tuRn°Rje",
"tournerions" => "tuRn°Rj§",
"tournerons" => "tuRn°R§",
"tourneront" => "tuRn°R§",
"tournes" => "tuRn",
"tournés" => "tuRne",
"tournesol" => "tuRn°sOl",
"tournesols" => "tuRn°sOl",
"tournette" => "tuRnEt",
"tourneur" => "tuRn9R",
"tourneurs" => "tuRn9R",
"tourneuses" => "tuRn2z",
"tournevis" => "tuRn°vis",
"tournez" => "tuRne",
"tournicota" => "tuRnikota",
"tournicotais" => "tuRnikotE",
"tournicotait" => "tuRnikotE",
"tournicotant" => "tuRnikot@",
"tournicote" => "tuRnikOt",
"tournicoté" => "tuRnikote",
"tournicotent" => "tuRnikOt",
"tournicoter" => "tuRnikote",
"tournicoterais" => "tuRnikOt°RE",
"tournicotés" => "tuRnikote",
"tournillant" => "tuRnij@",
"tournions" => "tuRnj§",
"tourniquant" => "tuRnik@",
"tournique" => "tuRnik",
"tourniquer" => "tuRnike",
"tourniquet" => "tuRnikE",
"tourniquets" => "tuRnikE",
"tournis" => "tuRni",
"tournoi" => "tuRnwa",
"tournoie" => "tuRnwa",
"tournoiement" => "tuRnwam@",
"tournoiements" => "tuRnwam@",
"tournoient" => "tuRnwa",
"tournoieraient" => "tuRnwaRE",
"tournoieront" => "tuRnwaR§",
"tournois" => "tuRnwa",
"tournons" => "tuRn§",
"tournoya" => "tuRnwaja",
"tournoyaient" => "tuRnwajE",
"tournoyais" => "tuRnwajE",
"tournoyait" => "tuRnwajE",
"tournoyant" => "tuRnwaj@",
"tournoyante" => "tuRnwaj@t",
"tournoyantes" => "tuRnwaj@t",
"tournoyants" => "tuRnwaj@",
"tournoyé" => "tuRnwaje",
"tournoyer" => "tuRnwaje",
"tournoyèrent" => "tuRnwajER",
"tournure" => "tuRnyR",
"tournures" => "tuRnyR",
"tours" => "tuR",
"tours-minute" => "tuRminyt",
"tourte" => "tuRt",
"tourteau" => "tuRto",
"tourteaux" => "tuRto",
"tourtereau" => "tuRt2Ro",
"tourtereaux" => "tuRt°Ro",
"tourterelle" => "tuRt°REl",
"tourterelles" => "tuRt°REl",
"tourtes" => "tuRt",
"tourtière" => "tuRtjER",
"tourtières" => "tuRtjER",
"tous" => "tus",
"tous-terrains" => "tutER5",
"toussa" => "tusa",
"toussai" => "tusE",
"toussaient" => "tusE",
"toussaint" => "tus5",
"toussais" => "tusE",
"toussait" => "tusE",
"toussant" => "tus@",
"tousse" => "tus",
"toussé" => "tuse",
"toussent" => "tus",
"tousser" => "tuse",
"toussera" => "tus°Ra",
"tousserait" => "tus°RE",
"tousses" => "tus",
"tousseur" => "tus9R",
"tousseurs" => "tus9R",
"tousseux" => "tus2",
"toussez" => "tuse",
"toussions" => "tusj§",
"toussons" => "tus§",
"toussota" => "tusota",
"toussotai" => "tusotE",
"toussotaient" => "tusotE",
"toussotait" => "tusotE",
"toussotant" => "tusot@",
"toussote" => "tusOt",
"toussoté" => "tusote",
"toussotement" => "tusOt°m@",
"toussotements" => "tusOt°m@",
"toussotent" => "tusOt",
"toussoter" => "tusote",
"toussoteux" => "tusot2",
"toussotiez" => "tusotje",
"tout" => "tu",
"tout-à-l'égout" => "tutalegu",
"tout-étoile" => "tutetwal",
"tout-fait" => "tufE",
"tout-fou" => "tufu",
"tout-paris" => "tupaRi",
"tout-petit" => "tup°ti",
"tout-petits" => "tup°ti",
"tout-puissant" => "tup8is@",
"tout-puissants" => "tup8is@",
"tout-terrain" => "tutER5",
"tout-venant" => "tuv°n@",
"toute" => "tut",
"toute-puissance" => "tutp8is@s",
"toute-puissante" => "tutp8is@t",
"toutefois" => "tut°fwa",
"toutes" => "tut",
"toutes-puissantes" => "tutp8is@t",
"toutim" => "tutim",
"toutime" => "tutim",
"toutou" => "tutu",
"toutous" => "tutu",
"touts" => "tu",
"toux" => "tu",
"toxicité" => "tOksisite",
"toxico" => "tOksiko",
"toxicologie" => "tOksikoloZi",
"toxicologique" => "tOksikoloZik",
"toxicologue" => "tOksikolOg",
"toxicologues" => "tOksikolOg",
"toxicomane" => "tOksikoman",
"toxicomanes" => "tOksikoman",
"toxicomanie" => "tOksikomani",
"toxicos" => "tOksiko",
"toxine" => "tOksin",
"toxines" => "tOksin",
"toxique" => "tOksik",
"toxiques" => "tOksik",
"toxoplasmose" => "tOksoplasmoz",
"trabans" => "tRab@",
"traboules" => "tRabul",
"trabuco" => "tRabyko",
"trac" => "tRak",
"traça" => "tRasa",
"traçabilité" => "tRasabilite",
"traçage" => "tRasaZ",
"traçai" => "tRasE",
"traçaient" => "tRasE",
"traçais" => "tRasE",
"traçait" => "tRasE",
"traçant" => "tRas@",
"traçante" => "tRas@t",
"traçantes" => "tRas@t",
"tracas" => "tRaka",
"tracassa" => "tRakasa",
"tracassaient" => "tRakasE",
"tracassait" => "tRakasE",
"tracassant" => "tRakas@",
"tracasse" => "tRakas",
"tracassé" => "tRakase",
"tracassée" => "tRakase",
"tracassées" => "tRakase",
"tracassent" => "tRakas",
"tracasser" => "tRakase",
"tracassera" => "tRakas°Ra",
"tracasserais" => "tRakas°RE",
"tracasserait" => "tRakas°RE",
"tracasserie" => "tRakas°Ri",
"tracasseries" => "tRakas°Ri",
"tracasserons" => "tRakas°R§",
"tracasses" => "tRakas",
"tracassez" => "tRakase",
"tracassier" => "tRakasje",
"tracassière" => "tRakasjER",
"tracassières" => "tRakasjER",
"tracassin" => "tRakas5",
"traçât" => "tRasa",
"trace" => "tRas",
"tracé" => "tRase",
"tracée" => "tRase",
"tracées" => "tRase",
"tracent" => "tRas",
"tracer" => "tRase",
"tracera" => "tRas°Ra",
"tracèrent" => "tRasER",
"tracerez" => "tRas°Re",
"tracerons" => "tRas°R§",
"traces" => "tRas",
"tracés" => "tRase",
"traceur" => "tRas9R",
"traceurs" => "tRas9R",
"traceuse" => "tRas2z",
"traceuses" => "tRas2z",
"tracez" => "tRase",
"trachéal" => "tRakeal",
"trachéale" => "tRakeal",
"trachée" => "tRaSe",
"trachée-artère" => "tRaSeaRtER",
"trachées" => "tRaSe",
"trachéite" => "tRakeit",
"trachéotomie" => "tRakeotomi",
"trachome" => "tRakom",
"tracions" => "tRasj§",
"traçons" => "tRas§",
"tracs" => "tRak",
"tract" => "tRakt",
"tractage" => "tRaktaZ",
"tractait" => "tRaktE",
"tractant" => "tRakt@",
"tractation" => "tRaktasj§",
"tractations" => "tRaktasj§",
"tracté" => "tRakte",
"tractée" => "tRakte",
"tracter" => "tRakte",
"tractés" => "tRakte",
"tracteur" => "tRakt9R",
"tracteurs" => "tRakt9R",
"traction" => "tRaksj§",
"traction-avant" => "tRaksj§av@",
"tractions" => "tRaksj§",
"tractopelle" => "tRaktOpEl",
"tractoriste" => "tRaktoRist",
"tractoristes" => "tRaktoRist",
"tracts" => "tRakt",
"tractus" => "tRaktys",
"trader" => "tREd9R",
"tradition" => "tRadisj§",
"traditionalisme" => "tRadisjonalizm",
"traditionaliste" => "tRadisjonalist",
"traditionalistes" => "tRadisjonalist",
"traditionnel" => "tRadisjonEl",
"traditionnelle" => "tRadisjonEl",
"traditionnellement" => "tRadisjonEl°m@",
"traditionnelles" => "tRadisjonEl",
"traditionnels" => "tRadisjonEl",
"traditions" => "tRadisj§",
"traduc" => "tRadyk",
"traducteur" => "tRadykt9R",
"traducteurs" => "tRadykt9R",
"traduction" => "tRadyksj§",
"traductions" => "tRadyksj§",
"traductrice" => "tRadyktRis",
"traductrices" => "tRadyktRis",
"traduira" => "tRad8iRa",
"traduirai" => "tRad8iRE",
"traduiraient" => "tRad8iRE",
"traduirais" => "tRad8iRE",
"traduirait" => "tRad8iRE",
"traduire" => "tRad8iR",
"traduirez" => "tRad8iRe",
"traduis" => "tRad8i",
"traduisaient" => "tRad8izE",
"traduisais" => "tRad8izE",
"traduisait" => "tRad8izE",
"traduisant" => "tRad8iz@",
"traduise" => "tRad8iz",
"traduisent" => "tRad8iz",
"traduises" => "tRad8iz",
"traduisez" => "tRad8ize",
"traduisibles" => "tRad8izibl",
"traduisions" => "tRad8izj§",
"traduisis" => "tRad8izi",
"traduisit" => "tRad8izi",
"traduisît" => "tRad8izi",
"traduisons" => "tRad8iz§",
"traduit" => "tRad8i",
"traduite" => "tRad8it",
"traduites" => "tRad8it",
"traduits" => "tRad8i",
"trafalgar" => "tRafalgaR",
"trafic" => "tRafik",
"traficotaient" => "tRafikotE",
"traficotait" => "tRafikotE",
"traficote" => "tRafikOt",
"traficoté" => "tRafikote",
"traficoter" => "t°Rafikote",
"traficotes" => "tRafikOt",
"traficoteurs" => "tRafikot9R",
"traficotez" => "tRafikote",
"trafics" => "tRafik",
"trafiquaient" => "tRafikE",
"trafiquais" => "tRafikE",
"trafiquait" => "tRafikE",
"trafiquant" => "tRafik@",
"trafiquant-espion" => "tRafik@Espj§",
"trafiquante" => "tRafik@t",
"trafiquants" => "tRafik@",
"trafique" => "tRafik",
"trafiqué" => "tRafike",
"trafiquée" => "tRafike",
"trafiquées" => "tRafike",
"trafiquent" => "tRafik",
"trafiquer" => "tRafike",
"trafiquerais" => "tRafik°RE",
"trafiques" => "tRafik",
"trafiqués" => "tRafike",
"trafiquez" => "tRafike",
"trafiquions" => "tRafikj§",
"tragédie" => "tRaZedi",
"tragédien" => "tRaZedj5",
"tragédienne" => "tRaZedjEn",
"tragédiennes" => "tRaZedjEn",
"tragédiens" => "tRaZedj5",
"tragédies" => "tRaZedi",
"tragi-comédie" => "tRaZikomedi",
"tragi-comédies" => "tRaZikomedi",
"tragi-comique" => "tRaZikomik",
"tragi-comiques" => "tRaZikomik",
"tragicomédies" => "tRaZikomedi",
"tragique" => "tRaZik",
"tragiquement" => "tRaZik°m@",
"tragiques" => "tRaZik",
"trahi" => "tRai",
"trahie" => "tRai",
"trahies" => "tRai",
"trahir" => "tRaiR",
"trahira" => "tRaiRa",
"trahirai" => "tRaiRE",
"trahiraient" => "tRaiRE",
"trahirais" => "tRaiRE",
"trahirait" => "tRaiRE",
"trahiras" => "tRaiRa",
"trahirent" => "tRaiR",
"trahirez" => "tRaiRe",
"trahiriez" => "tRaiRje",
"trahirons" => "tRaiR§",
"trahiront" => "tRaiR§",
"trahis" => "tRai",
"trahison" => "tRaiz§",
"trahisons" => "tRaiz§",
"trahissaient" => "tRaisE",
"trahissais" => "tRaisE",
"trahissait" => "tRaisE",
"trahissant" => "tRais@",
"trahisse" => "tRais",
"trahissent" => "tRais",
"trahissez" => "tRaise",
"trahissiez" => "tRaisje",
"trahissions" => "tRaisj§",
"trahissons" => "tRais§",
"trahit" => "tRai",
"traie" => "tRE",
"train" => "tR5",
"train-train" => "tR5tR5",
"traîna" => "tREna",
"traînage" => "tREnaZ",
"traînai" => "tREnE",
"traînaient" => "tREnE",
"traînaillait" => "tREnajE",
"traînaillant" => "tREnaj@",
"traînaille" => "tREnaj",
"traînaillé" => "tREnaje",
"traînailler" => "tREnaje",
"traînaillons" => "tREnaj§",
"traînais" => "tREnE",
"traînait" => "tREnE",
"traînâmes" => "tREnam",
"traînant" => "tREn@",
"traînante" => "tREn@t",
"traînantes" => "tREn@t",
"traînants" => "tREn@",
"traînard" => "tREnaR",
"traînarde" => "tREnaRd",
"traînards" => "tREnaR",
"traînassaient" => "tREnasE",
"traînassais" => "tREnasE",
"traînassait" => "tREnasE",
"traînassant" => "tREnas@",
"traînasse" => "tREnas",
"traînassé" => "tREnase",
"traînassent" => "tREnas",
"traînasser" => "tREnase",
"traînasserai" => "tREnas°RE",
"traînasses" => "tREnas",
"traînassez" => "tREnase",
"traînassons" => "tREnas§",
"traînât" => "tREna",
"traîne" => "tREn",
"traîné" => "tRene",
"traîne-misère" => "tREnmizER",
"traîne-patins" => "tREnpat5",
"traîne-savate" => "tREnsavat",
"traîne-savates" => "tREnsavat",
"traîne-semelle" => "tREns°mEl",
"traîne-semelles" => "tREns°mEl",
"traîneau" => "tREno",
"traîneaux" => "tREno",
"traînée" => "tRene",
"traînées" => "tRene",
"traînement" => "tREn°m@",
"traînent" => "tREn",
"traîner" => "tRene",
"traînera" => "tREn°Ra",
"traînerai" => "tREn°RE",
"traîneraient" => "tREn°RE",
"traînerais" => "tREn°RE",
"traînerait" => "tREn°RE",
"traîneras" => "tREn°Ra",
"traînèrent" => "tREnER",
"traînerez" => "tREn°Re",
"traînerons" => "tREn°R§",
"traîneront" => "tREn°R§",
"traînes" => "tREn",
"traînés" => "tRene",
"traîneur" => "tREn9R",
"traîneurs" => "tREn9R",
"traîneuses" => "tREn2z",
"traînez" => "tREne",
"trainglots" => "tR5glo",
"traînier" => "tREnje",
"traîniez" => "tREnje",
"training" => "tREjniG",
"traînions" => "tREnj§",
"traînons" => "tREn§",
"trains" => "tR5",
"traintrain" => "tR5tR5",
"traira" => "tRERa",
"trairait" => "tRERE",
"traire" => "tRER",
"trais" => "tRE",
"trait" => "tRE",
"traita" => "tREta",
"traitable" => "tREtabl",
"traitables" => "tREtabl",
"traitai" => "tREtE",
"traitaient" => "tREtE",
"traitais" => "tREtE",
"traitait" => "tREtE",
"traitant" => "tREt@",
"traitante" => "tREt@t",
"traitants" => "tREt@",
"traitassent" => "tREtas",
"traitât" => "tREta",
"traite" => "tREt",
"traité" => "tRete",
"traitée" => "tRete",
"traitées" => "tRete",
"traitement" => "tREt°m@",
"traitements" => "tREt°m@",
"traitent" => "tREt",
"traiter" => "tRete",
"traitera" => "tREt°Ra",
"traiterai" => "tREt°RE",
"traiteraient" => "tREt°RE",
"traiterais" => "tREt°RE",
"traiterait" => "tREt°RE",
"traiteras" => "tREt°Ra",
"traitèrent" => "tREtER",
"traiterez" => "tREt°Re",
"traiteriez" => "tREt°Rje",
"traiterons" => "tREt°R§",
"traiteront" => "tREt°R§",
"traites" => "tREt",
"traités" => "tRete",
"traiteur" => "tREt9R",
"traiteurs" => "tREt9R",
"traitez" => "tREte",
"traitiez" => "tREtje",
"traitions" => "tREtj§",
"traitons" => "tREt§",
"traître" => "tREtR",
"traîtres" => "tREtR",
"traîtresse" => "tREtREs",
"traîtresses" => "tREtREs",
"traîtreusement" => "tREtR2z°m@",
"traîtrise" => "tRetRiz",
"traîtrises" => "tRetRiz",
"traits" => "tRE",
"trajectographie" => "tRaZEktogRafi",
"trajectoire" => "tRaZEktwaR",
"trajectoires" => "tRaZEktwaR",
"trajet" => "tRaZE",
"trajets" => "tRaZE",
"tralala" => "tRalala",
"tralalas" => "tRalala",
"trâlée" => "tRale",
"tram" => "tRam",
"tramaient" => "tRamE",
"tramail" => "tRamaj",
"tramails" => "tRamaj",
"tramait" => "tRamE",
"tramant" => "tRam@",
"trame" => "tRam",
"tramé" => "tRame",
"trament" => "tRam",
"tramer" => "tRame",
"trames" => "tRam",
"tramés" => "tRame",
"tramez" => "tRame",
"tramontane" => "tRam§tan",
"tramontanes" => "tRam§tan",
"tramp" => "tR@p",
"trampoline" => "tR@polin",
"trams" => "tRam",
"tramway" => "tRamwE",
"tramways" => "tRamwE",
"trancha" => "tR@Sa",
"tranchage" => "tR@SaZ",
"tranchai" => "tR@SE",
"tranchaient" => "tR@SE",
"tranchais" => "tR@SE",
"tranchait" => "tR@SE",
"tranchant" => "tR@S@",
"tranchante" => "tR@S@t",
"tranchantes" => "tR@S@t",
"tranchants" => "tR@S@",
"tranchât" => "tR@Sa",
"tranche" => "tR@S",
"tranché" => "tR@Se",
"tranche-montagne" => "tR@Sm§taN",
"tranchecaille" => "tR@Skaj",
"tranchée" => "tR@Se",
"tranchée-abri" => "tR@SeabRi",
"tranchées" => "tR@Se",
"tranchées-abris" => "tR@SeabRi",
"tranchelards" => "tR@S°laR",
"tranchent" => "tR@S",
"trancher" => "tR@Se",
"tranchera" => "tR@S°Ra",
"trancherai" => "tR@S°RE",
"trancherais" => "tR@S°RE",
"trancherait" => "tR@S°RE",
"trancheras" => "tR@S°Ra",
"tranchèrent" => "tR@SER",
"trancheront" => "tR@S°R§",
"tranches" => "tR@S",
"tranchés" => "tR@Se",
"tranchet" => "tR@SE",
"tranchets" => "tR@SE",
"trancheur" => "tR@S9R",
"trancheuse" => "tR@S2z",
"tranchez" => "tR@Se",
"tranchiez" => "tR@Sje",
"tranchoir" => "tR@SwaR",
"tranchoirs" => "tR@SwaR",
"tranchons" => "tR@S§",
"tranquille" => "tR@kil",
"tranquillement" => "tR@kil°m@",
"tranquilles" => "tR@kil",
"tranquillisa" => "tR@kiliza",
"tranquillisai" => "tR@kilizE",
"tranquillisaient" => "tR@kilizE",
"tranquillisait" => "tR@kilizE",
"tranquillisant" => "tR@kiliz@",
"tranquillisante" => "tR@kiliz@t",
"tranquillisantes" => "tR@kiliz@t",
"tranquillisants" => "tR@kiliz@",
"tranquillise" => "tR@kiliz",
"tranquillisé" => "tR@kilize",
"tranquillisée" => "tR@kilize",
"tranquillisent" => "tR@kiliz",
"tranquilliser" => "tR@kilize",
"tranquillisera" => "tR@kiliz°Ra",
"tranquilliserait" => "tR@kiliz°RE",
"tranquillises" => "tR@kiliz",
"tranquillisés" => "tR@kilize",
"tranquillisez" => "tR@kilize",
"tranquillité" => "tR@kilite",
"tranquillités" => "tR@kilite",
"tranquillos" => "tR@kilos",
"trans" => "tR@s",
"transaction" => "tR@zaksj§",
"transactionnelle" => "tR@zaksjonEl",
"transactions" => "tR@zaksj§",
"transafricain" => "tR@zafRik5",
"transalpines" => "tR@zalpin",
"transamazonienne" => "tR@zamazonjEn",
"transaminase" => "tR@zaminaz",
"transaminases" => "tR@zaminaz",
"transat" => "tR@zat",
"transatlantique" => "tR@zatl@tik",
"transatlantiques" => "tR@zatl@tik",
"transats" => "tR@zat",
"transbahutaient" => "tR@sbaytE",
"transbahutant" => "tR@sbayt@",
"transbahute" => "tR@sbayt",
"transbahuté" => "tR@sbayte",
"transbahutée" => "tR@sbayte",
"transbahutent" => "tR@sbayt",
"transbahuter" => "tR@sbayte",
"transbahutés" => "tR@sbayte",
"transbahutez" => "tR@sbayte",
"transbordé" => "tR@sbORde",
"transbordement" => "tR@sbORd°m@",
"transbordements" => "tR@sbORd°m@",
"transborder" => "tR@sbORde",
"transbordeur" => "tR@sbORd9R",
"transcanadienne" => "tR@skanadjEn",
"transcaspien" => "tR@skaspj5",
"transcendance" => "tR@s@d@s",
"transcendant" => "tR@s@d@",
"transcendantal" => "tR@s@d@tal",
"transcendantale" => "tR@s@d@tal",
"transcendantales" => "tR@s@d@tal",
"transcendantalistes" => "tR@s@d@talist",
"transcendante" => "tR@s@d@t",
"transcendantes" => "tR@s@d@t",
"transcendants" => "tR@s@d@",
"transcende" => "tR@s@d",
"transcendé" => "tR@s@de",
"transcendée" => "tR@s@de",
"transcendent" => "tR@s@d",
"transcender" => "tR@s@de",
"transcendons" => "tR@s@d§",
"transcontinental" => "tR@sk§tin@tal",
"transcontinentale" => "tR@sk§tin@tal",
"transcriptase" => "tR@skRiptaz",
"transcripteur" => "tR@skRipt9R",
"transcription" => "tR@skRipsj§",
"transcriptions" => "tR@skRipsj§",
"transcrire" => "tR@skRiR",
"transcris" => "tR@skRi",
"transcrit" => "tR@skRi",
"transcrite" => "tR@skRit",
"transcrites" => "tR@skRit",
"transcrits" => "tR@skRi",
"transcrivaient" => "tR@skRivE",
"transcrivais" => "tR@skRivE",
"transcrivait" => "tR@skRivE",
"transcrivant" => "tR@skRiv@",
"transcrive" => "tR@skRiv",
"transcrivez" => "tR@skRive",
"transcrivis" => "tR@skRivi",
"transcrivit" => "tR@skRivi",
"transcutané" => "tR@skytane",
"transdermique" => "tR@sdERmik",
"transducteur" => "tR@sdykt9R",
"transducteurs" => "tR@sdykt9R",
"transduction" => "tR@sdyksj§",
"transe" => "tR@s",
"transept" => "tR@sEpt",
"transepts" => "tR@sEpt",
"transes" => "tR@s",
"transféra" => "tR@sfeRa",
"transférable" => "tR@sfeRabl",
"transféraient" => "tR@sfeRE",
"transférais" => "tR@sfeRE",
"transférait" => "tR@sfeRE",
"transférâmes" => "tR@sfeRam",
"transférant" => "tR@sfeR@",
"transfère" => "tR@sfER",
"transféré" => "tR@sfeRe",
"transférée" => "tR@sfeRe",
"transférées" => "tR@sfeRe",
"transfèrement" => "tR@sfER°m@",
"transfèrements" => "tR@sfER°m@",
"transfèrent" => "tR@sfER",
"transférer" => "tR@sfeRe",
"transférera" => "tR@sfeR°Ra",
"transférerai" => "tR@sfeR°RE",
"transférerait" => "tR@sfeR°RE",
"transféreras" => "tR@sfeR°Ra",
"transférèrent" => "tR@sfeRER",
"transférerez" => "tR@sfeR°Re",
"transférerons" => "tR@sfeR°R§",
"transféreront" => "tR@sfeR°R§",
"transférés" => "tR@sfeRe",
"transférez" => "tR@sfeRe",
"transfériez" => "tR@sfeRje",
"transférons" => "tR@sfeR§",
"transfert" => "tR@sfER",
"transferts" => "tR@sfER",
"transfigura" => "tR@sfigyRa",
"transfiguraient" => "tR@sfigyRE",
"transfigurait" => "tR@sfigyRE",
"transfigurant" => "tR@sfigyR@",
"transfiguration" => "tR@sfigyRasj§",
"transfigurations" => "tR@sfigyRasj§",
"transfiguratrice" => "tR@sfigyRatRis",
"transfigure" => "tR@sfigyR",
"transfiguré" => "tR@sfigyRe",
"transfigurée" => "tR@sfigyRe",
"transfigurées" => "tR@sfigyRe",
"transfigurent" => "tR@sfigyR",
"transfigurer" => "tR@sfigyRe",
"transfigurerait" => "tR@sfigyR°RE",
"transfigurés" => "tR@sfigyRe",
"transfigurez" => "tR@sfigyRe",
"transfilaient" => "tR@sfilE",
"transfilée" => "tR@sfile",
"transfo" => "tR@sfo",
"transforma" => "tR@sfORma",
"transformable" => "tR@sfORmabl",
"transformai" => "tR@sfORmE",
"transformaient" => "tR@sfORmE",
"transformais" => "tR@sfORmE",
"transformait" => "tR@sfORmE",
"transformant" => "tR@sfORm@",
"transformas" => "tR@sfORma",
"transformât" => "tR@sfORma",
"transformateur" => "tR@sfORmat9R",
"transformateurs" => "tR@sfORmat9R",
"transformation" => "tR@sfORmasj§",
"transformations" => "tR@sfORmasj§",
"transformatrice" => "tR@sfORmatRis",
"transforme" => "tR@sfORm",
"transformé" => "tR@sfORme",
"transformée" => "tR@sfORme",
"transformées" => "tR@sfORme",
"transforment" => "tR@sfORm",
"transformer" => "tR@sfORme",
"transformera" => "tR@sfORm°Ra",
"transformerai" => "tR@sfORm°RE",
"transformeraient" => "tR@sfORm°RE",
"transformerais" => "tR@sfORm°RE",
"transformerait" => "tR@sfORm°RE",
"transformeras" => "tR@sfORm°Ra",
"transformèrent" => "tR@sfORmER",
"transformeriez" => "tR@sfORm°Rje",
"transformerons" => "tR@sfORm°R§",
"transformeront" => "tR@sfORm°R§",
"transformes" => "tR@sfORm",
"transformés" => "tR@sfORme",
"transformez" => "tR@sfORme",
"transformiez" => "tR@sfORmje",
"transformiste" => "tR@sfORmist",
"transformons" => "tR@sfORm§",
"transfos" => "tR@sfo",
"transfuge" => "tR@sfyZ",
"transfuges" => "tR@sfyZ",
"transfusait" => "tR@sfyzE",
"transfuse" => "tR@sfyz",
"transfusé" => "tR@sfyze",
"transfusée" => "tR@sfyze",
"transfuser" => "tR@sfyze",
"transfusés" => "tR@sfyze",
"transfuseur" => "tR@sfyz9R",
"transfusion" => "tR@sfyzj§",
"transfusions" => "tR@sfyzj§",
"transgénique" => "tR@zZenik",
"transgéniques" => "tR@zZenik",
"transgressait" => "tR@sgREsE",
"transgresse" => "tR@sgREs",
"transgressé" => "tR@sgRese",
"transgressée" => "tR@sgRese",
"transgressées" => "tR@sgRese",
"transgressent" => "tR@sgREs",
"transgresser" => "tR@sgRese",
"transgresseur" => "tR@sgRes9R",
"transgressez" => "tR@zgREse",
"transgression" => "tR@sgREsj§",
"transgressions" => "tR@sgREsj§",
"transgressons" => "tR@sgREs§",
"transhistorique" => "tR@sistoRik",
"transhumait" => "tR@zymE",
"transhumance" => "tR@zym@s",
"transhumances" => "tR@zym@s",
"transhumant" => "tR@zym@",
"transhumantes" => "tR@zym@t",
"transhumants" => "tR@zym@",
"transhumés" => "tR@zyme",
"transi" => "tR@zi",
"transie" => "tR@zi",
"transies" => "tR@zi",
"transige" => "tR@ziZ",
"transigé" => "tR@ziZe",
"transigeait" => "tR@ziZE",
"transigeant" => "tR@ziZ@",
"transigent" => "tR@ziZ",
"transigeons" => "tR@ziZ§",
"transiger" => "tR@ziZe",
"transigera" => "tR@ziZ°Ra",
"transigerai" => "tR@ziZ°RE",
"transillumination" => "tR@zilyminasj§",
"transir" => "tR@ziR",
"transis" => "tR@zi",
"transistor" => "tR@zistOR",
"transistorisées" => "tR@zistoRize",
"transistorisés" => "tR@zistoRize",
"transistors" => "tR@zistOR",
"transit" => "tR@zit",
"transitaient" => "tR@zitE",
"transitaire" => "tR@zitER",
"transitaires" => "tR@zitER",
"transitais" => "tR@zitE",
"transitait" => "tR@zitE",
"transitant" => "tR@zit@",
"transite" => "tR@zit",
"transité" => "tR@zite",
"transitent" => "tR@zit",
"transiter" => "tR@zite",
"transitif" => "tR@zitif",
"transitifs" => "tR@zitif",
"transition" => "tR@zisj§",
"transitionnel" => "tR@zisjonEl",
"transitionnelle" => "tR@zisjOnEl",
"transitions" => "tR@zisj§",
"transitoire" => "tR@zitwaR",
"transitoirement" => "tR@zitwaR°m@",
"transitoires" => "tR@zitwaR",
"transits" => "tR@zit",
"translater" => "t°R@slate",
"translates" => "tR@slat",
"translation" => "tR@slasj§",
"translations" => "tR@slasj§",
"translocation" => "tR@slOkasj§",
"translucide" => "tR@slysid",
"translucides" => "tR@slysid",
"translucidité" => "tR@slysidite",
"transmet" => "tR@smE",
"transmets" => "tR@smE",
"transmettaient" => "tR@smEtE",
"transmettais" => "tR@smEtE",
"transmettait" => "tR@smEtE",
"transmettant" => "tR@smEt@",
"transmette" => "tR@smEt",
"transmettent" => "tR@smEt",
"transmetteur" => "tR@smEt9R",
"transmetteurs" => "tR@smEt9R",
"transmettez" => "tR@smEte",
"transmettions" => "tR@smEtj§",
"transmettons" => "tR@smEt§",
"transmettra" => "tR@smEtRa",
"transmettrai" => "tR@smEtRE",
"transmettrait" => "tR@smEtRE",
"transmettras" => "tR@smEtRa",
"transmettre" => "tR@smEtR",
"transmettrez" => "tR@smEtRe",
"transmettrons" => "tR@smEtR§",
"transmettront" => "tR@smEtR§",
"transmigrait" => "tR@smigRE",
"transmigration" => "tR@smigRasj§",
"transmigrent" => "tR@smigR",
"transmirent" => "tR@smiR",
"transmis" => "tR@smi",
"transmise" => "tR@smiz",
"transmises" => "tR@smiz",
"transmissible" => "tR@smisibl",
"transmissibles" => "tR@smisibl",
"transmission" => "tR@smisj§",
"transmissions" => "tR@smisj§",
"transmit" => "tR@smi",
"transmuait" => "tR@sm8E",
"transmué" => "tR@sm8e",
"transmuée" => "tR@sm8e",
"transmuées" => "tR@sm8e",
"transmuer" => "tR@sm8e",
"transmués" => "tR@sm8e",
"transmutait" => "tR@smytE",
"transmutant" => "tR@smyt@",
"transmutation" => "tR@smytasj§",
"transmutations" => "tR@smytasj§",
"transmute" => "tR@smyt",
"transmuté" => "tR@smyte",
"transmutent" => "tR@smyt",
"transmuter" => "tR@smyte",
"transnational" => "tR@snasjOnal",
"transnationaux" => "tR@snasjOno",
"transocéanique" => "tR@zOseanik",
"transocéaniques" => "tR@soseanik",
"transparaissaient" => "tR@spaREsE",
"transparaissait" => "tR@spaREsE",
"transparaisse" => "tR@spaREs",
"transparaissent" => "tR@spaREs",
"transparaît" => "tR@spaRE",
"transparaître" => "tR@spaREtR",
"transparence" => "tR@spaR@s",
"transparences" => "tR@spaR@s",
"transparent" => "tR@spaR@",
"transparente" => "tR@spaR@t",
"transparentes" => "tR@spaR@t",
"transparents" => "tR@spaR@",
"transperça" => "tR@spERsa",
"transperçaient" => "tR@spERsE",
"transperçait" => "tR@spERsE",
"transperçant" => "tR@spERs@",
"transperce" => "tR@spERs",
"transpercé" => "tR@spERse",
"transpercée" => "tR@spERse",
"transpercées" => "tR@spERse",
"transpercent" => "tR@spERs",
"transpercer" => "tR@spERse",
"transpercerai" => "tR@spERs°RE",
"transpercerait" => "tR@spERs°RE",
"transpercèrent" => "tR@spERsER",
"transpercés" => "tR@spERse",
"transpercez" => "tR@spERse",
"transpira" => "tR@spiRa",
"transpiraient" => "tR@spiRE",
"transpirais" => "tR@spiRE",
"transpirait" => "tR@spiRE",
"transpirant" => "tR@spiR@",
"transpirante" => "tR@spiR@t",
"transpirants" => "tR@spiR@",
"transpiration" => "tR@spiRasj§",
"transpire" => "tR@spiR",
"transpiré" => "tR@spiRe",
"transpirent" => "tR@spiR",
"transpirer" => "tR@spiRe",
"transpirera" => "tR@spiR°Ra",
"transpirerait" => "tR@spiR°RE",
"transpires" => "tR@spiR",
"transpirez" => "tR@spiRe",
"transplantable" => "tR@spl@tabl",
"transplantait" => "tR@spl@tE",
"transplantation" => "tR@spl@tasj§",
"transplantations" => "tR@spl@tasj§",
"transplante" => "tR@spl@t",
"transplanté" => "tR@spl@te",
"transplantée" => "tR@spl@te",
"transplantées" => "tR@spl@te",
"transplanter" => "tR@spl@te",
"transplantés" => "tR@spl@te",
"transplantons" => "tR@spl@t§",
"transplants" => "tR@spl@",
"transpondeur" => "tR@sp§d9R",
"transport" => "tR@spOR",
"transporta" => "tR@spORta",
"transportable" => "tR@spORtabl",
"transportables" => "tR@spORtabl",
"transportai" => "tR@spORtE",
"transportaient" => "tR@spORtE",
"transportais" => "tR@spORtE",
"transportait" => "tR@spORtE",
"transportâmes" => "tR@spORtam",
"transportant" => "tR@spORt@",
"transportât" => "tR@spORta",
"transportation" => "tR@spORtasj§",
"transporte" => "tR@spORt",
"transporté" => "tR@spORte",
"transportée" => "tR@spORte",
"transportées" => "tR@spORte",
"transportent" => "tR@spORt",
"transporter" => "tR@spORte",
"transportera" => "tR@spORt°Ra",
"transporteraient" => "tR@spORt°RE",
"transporterais" => "tR@spORt°RE",
"transporterait" => "tR@spORt°RE",
"transportèrent" => "tR@spORtER",
"transporterons" => "tR@spORt°R§",
"transportés" => "tR@spORte",
"transporteur" => "tR@spORt9R",
"transporteurs" => "tR@spORt9R",
"transporteuse" => "tR@spORt2z",
"transportez" => "tR@spORte",
"transportiez" => "tR@spORtje",
"transportions" => "tR@spORtj§",
"transportons" => "tR@spORt§",
"transports" => "tR@spOR",
"transposable" => "tR@spozabl",
"transposables" => "tR@spozabl",
"transposaient" => "tR@spozE",
"transposait" => "tR@spozE",
"transposant" => "tR@spoz@",
"transpose" => "tR@spoz",
"transposé" => "tR@spoze",
"transposée" => "tR@spoze",
"transposent" => "tR@spoz",
"transposer" => "tR@spoze",
"transposés" => "tR@spoze",
"transposez" => "tR@spoze",
"transposition" => "tR@spozisj§",
"transpositions" => "tR@spozisj§",
"transposon" => "tR@spoz§",
"transposons" => "tR@spoz§",
"transsaharienne" => "tR@ssaaRjEn",
"transsexualisme" => "tR@seksyalizm",
"transsexualité" => "tR@ssEks8alite",
"transsexuel" => "tR@sseks8El",
"transsexuelle" => "tR@seksyEl",
"transsexuels" => "tR@sseks8El",
"transsibérien" => "tR@ssibeRj5",
"transsibérienne" => "tR@ssibeRjEn",
"transsubstantiation" => "tR@ssypst@tjasj§",
"transsudait" => "tR@ssydE",
"transsudant" => "tR@ssyd@",
"transsudat" => "tR@ssyda",
"transuranienne" => "tR@zyRanjEn",
"transvasait" => "tR@svazE",
"transvase" => "tR@svaz",
"transvasées" => "tR@svaze",
"transvaser" => "tR@svaze",
"transvasèrent" => "tR@svazER",
"transvasons" => "tR@svaz§",
"transversal" => "tR@svERsal",
"transversale" => "tR@svERsal",
"transversalement" => "tR@svERsal°m@",
"transversales" => "tR@svERsal",
"transversaux" => "tR@svERso",
"transverse" => "tR@svERs",
"transvestisme" => "tR@svEstism",
"transylvain" => "tR@silv5",
"transylvanienne" => "tR@silvanjEn",
"trapèze" => "tRapEz",
"trapèzes" => "tRapEz",
"trapéziste" => "tRapezist",
"trapézistes" => "tRapezist",
"trapézoïdal" => "tRapezoidal",
"trapézoïdale" => "tRapezoidal",
"trapézoïdales" => "tRapezoidal",
"trapézoïdaux" => "tRapezoido",
"trapézoïde" => "tRapezOid",
"trappe" => "tRap",
"trappes" => "tRap",
"trappeur" => "tRap9R",
"trappeurs" => "tRap9R",
"trappiste" => "tRapist",
"trappistes" => "tRapist",
"trappon" => "tRap§",
"trapu" => "tRapy",
"trapue" => "tRapy",
"trapues" => "tRapy",
"trapus" => "tRapy",
"traqua" => "tRaka",
"traquaient" => "tRakE",
"traquais" => "tRakE",
"traquait" => "tRakE",
"traquant" => "tRak@",
"traque" => "tRak",
"traqué" => "tRake",
"traquée" => "tRake",
"traquées" => "tRake",
"traquenard" => "tRak°naR",
"traquenards" => "tRak°naR",
"traquent" => "tRak",
"traquer" => "tRake",
"traquera" => "tRak°Ra",
"traquerai" => "tRak°RE",
"traquerais" => "tRak°RE",
"traquerait" => "tRak°RE",
"traquèrent" => "tRakER",
"traquerons" => "tRak°R§",
"traqueront" => "tRak°R§",
"traques" => "tRak",
"traqués" => "tRake",
"traquet" => "tRakE",
"traquets" => "tRakE",
"traqueur" => "tRak9R",
"traqueurs" => "tRak9R",
"traqueuse" => "tRak2z",
"traquez" => "tRake",
"traquiez" => "tRakje",
"traquions" => "tRakj§",
"traquons" => "tRak§",
"trattoria" => "tRatoRja",
"trattorias" => "tRatoRja",
"trauma" => "tRoma",
"traumas" => "tRoma",
"traumatique" => "tRomatik",
"traumatiques" => "tRomatik",
"traumatisant" => "tRomatiz@",
"traumatisante" => "tRomatiz@t",
"traumatisantes" => "tRomatiz@t",
"traumatisants" => "tRomatiz@",
"traumatise" => "tRomatiz",
"traumatisé" => "tRomatize",
"traumatisée" => "tRomatize",
"traumatisées" => "tRomatize",
"traumatiser" => "tRomatize",
"traumatisés" => "tRomatize",
"traumatisme" => "tRomatizm",
"traumatismes" => "tRomatizm",
"traumatologie" => "tRomatOlOZi",
"traumatologique" => "tRomatOlOZik",
"traumatologue" => "tRomatolOg",
"travail" => "tRavaj",
"travailla" => "tRavaja",
"travaillai" => "tRavajE",
"travaillaient" => "tRavajE",
"travaillais" => "tRavajE",
"travaillait" => "tRavajE",
"travaillâmes" => "tRavajam",
"travaillant" => "tRavaj@",
"travaillassent" => "tRavajas",
"travaillât" => "tRavaja",
"travaille" => "tRavaj",
"travaillé" => "tRavaje",
"travaillée" => "tRavaje",
"travaillées" => "tRavaje",
"travaillent" => "tRavaj",
"travailler" => "tRavaje",
"travaillera" => "tRavaj°Ra",
"travaillerai" => "tRavaj°RE",
"travailleraient" => "tRavaj°RE",
"travaillerais" => "tRavaj°RE",
"travaillerait" => "tRavaj°RE",
"travailleras" => "tRavaj°Ra",
"travaillèrent" => "tRavajER",
"travaillerez" => "tRavaj°Re",
"travailleriez" => "tRavaj°Rje",
"travaillerions" => "tRavaj°Rij§",
"travaillerons" => "tRavaj°R§",
"travailleront" => "tRavaj°R§",
"travailles" => "tRavaj",
"travaillés" => "tRavaje",
"travailleur" => "tRavaj9R",
"travailleurs" => "tRavaj9R",
"travailleuse" => "tRavaj2z",
"travailleuses" => "tRavaj2z",
"travaillez" => "tRavaje",
"travailliez" => "tRavajje",
"travaillions" => "tRavajj§",
"travailliste" => "tRavajist",
"travaillistes" => "tRavajist",
"travaillons" => "tRavaj§",
"travaux" => "tRavo",
"trave" => "tRav",
"travée" => "tRave",
"travées" => "tRave",
"traveller" => "tRav°l9R",
"traveller's chèques" => "tRav°l9RsSEk",
"travellers" => "tRav2lERs",
"travelling" => "tRav°liG",
"travellings" => "tRav°liG",
"travelo" => "tRav°lo",
"travelos" => "tRav°lo",
"travers" => "tRavER",
"traversa" => "tRavERsa",
"traversable" => "tRavERsabl",
"traversables" => "tRavERsabl",
"traversai" => "tRavERsE",
"traversaient" => "tRavERsE",
"traversais" => "tRavERsE",
"traversait" => "tRavERsE",
"traversâmes" => "tRavERsam",
"traversant" => "tRavERs@",
"traverse" => "tRavERs",
"traversé" => "tRavERse",
"traversée" => "tRavERse",
"traversées" => "tRavERse",
"traversent" => "tRavERs",
"traverser" => "tRavERse",
"traversera" => "tRavERs°Ra",
"traverserai" => "tRavERs°RE",
"traverseraient" => "tRavERs°RE",
"traverserais" => "tRavERs°RE",
"traverserait" => "tRavERs°RE",
"traverseras" => "tRavERs°Ra",
"traversèrent" => "tRavERsER",
"traverserez" => "tRavERs°Re",
"traverserons" => "tRavERs°R§",
"traverseront" => "tRavERs°R§",
"traverses" => "tRavERs",
"traversés" => "tRavERse",
"traversez" => "tRavERse",
"traversier" => "tRavERsje",
"traversière" => "tRavERsjER",
"traversières" => "tRavERsjER",
"traversiez" => "tRavERsje",
"traversin" => "tRavERs5",
"traversine" => "tRavERsin",
"traversins" => "tRavERs5",
"traversions" => "tRavERsj§",
"traversons" => "tRavERs§",
"travertin" => "tRavERt5",
"travesti" => "tRavEsti",
"travestie" => "tRavEsti",
"travesties" => "tRavEsti",
"travestir" => "tRavEstiR",
"travestis" => "tRavEsti",
"travestisme" => "tRavEstizm",
"travestissais" => "tRavEstisE",
"travestissant" => "tRavEstis@",
"travestissement" => "tRavEstis°m@",
"travestissements" => "tRavEstis°m@",
"travestissez" => "tRavEstise",
"travestit" => "tRavEsti",
"travois" => "tRavwa",
"trax" => "tRaks",
"trayait" => "tREjE",
"trayant" => "tREj@",
"trayeuse" => "tREj2z",
"trayeuses" => "tREj2z",
"trayon" => "tREj§",
"trayons" => "tREj§",
"trébucha" => "tRebySa",
"trébuchai" => "tRebySE",
"trébuchaient" => "tRebySE",
"trébuchais" => "tRebySE",
"trébuchait" => "tRebySE",
"trébuchant" => "tRebyS@",
"trébuchante" => "tRebyS@t",
"trébuchantes" => "tRebyS@t",
"trébuchants" => "tRebyS@",
"trébuche" => "tRebyS",
"trébuché" => "tRebySe",
"trébuchement" => "tRebyS°m@",
"trébuchements" => "tRebyS°m@",
"trébuchent" => "tRebyS",
"trébucher" => "tRebySe",
"trébuches" => "tRebyS",
"trébuchet" => "tRebySE",
"trébuchez" => "tRebySe",
"trébuchons" => "tRebyS§",
"trecento" => "tRetSEnto",
"tréfilés" => "tRefile",
"trèfle" => "tREfl",
"trèfles" => "tREfl",
"tréflières" => "tReflijER",
"tréfonds" => "tRef§",
"treillage" => "tREjaZ",
"treillages" => "tREjaZ",
"treillard" => "tREjaR",
"treille" => "tREj",
"treilles" => "tREj",
"treillis" => "tReji",
"treillissé" => "tREjise",
"treillissée" => "tREjise",
"treizaine" => "tREzEn",
"treize" => "tREz",
"treizième" => "tREzjEm",
"trek" => "tREk",
"trekkeur" => "tREk9R",
"trekking" => "tREkiG",
"tréma" => "tRema",
"trémail" => "tRemaj",
"trémas" => "tRema",
"trembla" => "tR@bla",
"tremblai" => "tR@blE",
"tremblaient" => "tR@blE",
"tremblais" => "tR@blE",
"tremblait" => "tR@blE",
"tremblant" => "tR@bl@",
"tremblante" => "tR@bl@t",
"tremblantes" => "tR@bl@t",
"tremblants" => "tR@bl@",
"tremblât" => "tR@bla",
"tremble" => "tR@bl",
"tremblé" => "tR@ble",
"tremblée" => "tR@ble",
"tremblées" => "tR@ble",
"tremblement" => "tR@bl°m@",
"tremblements" => "tR@bl°m@",
"tremblent" => "tR@bl",
"trembler" => "tR@ble",
"tremblera" => "tR@bl°Ra",
"tremblerai" => "tR@bl°RE",
"trembleraient" => "tR@bl°RE",
"tremblerais" => "tR@bl°RE",
"tremblerait" => "tR@bl°RE",
"tremblèrent" => "tR@blER",
"tremblerons" => "tR@bl°R§",
"trembleront" => "tR@bl°R§",
"trembles" => "tR@bl",
"tremblés" => "tR@ble",
"trembleur" => "tR@bl9R",
"trembleurs" => "tR@bl9R",
"tremblez" => "tR@ble",
"trembliez" => "tR@blie",
"tremblions" => "tR@blij§",
"tremblochant" => "tR@bloS@",
"tremblons" => "tR@bl§",
"tremblota" => "tR@blota",
"tremblotaient" => "tR@blotE",
"tremblotait" => "tR@blotE",
"tremblotant" => "tR@blot@",
"tremblotante" => "tR@blot@t",
"tremblotantes" => "tR@blot@t",
"tremblotants" => "tR@blot@",
"tremblote" => "tR@blOt",
"trembloté" => "tR@blote",
"tremblotement" => "tR@blOt°m@",
"tremblotements" => "tR@blOt°m@",
"tremblotent" => "tR@blOt",
"trembloter" => "t°R@blote",
"trémie" => "tRemi",
"trémière" => "tRemjER",
"trémières" => "tRemjER",
"trémies" => "tRemi",
"trémois" => "tRemwa",
"trémolo" => "tRemolo",
"tremolos" => "tRemolo",
"trémolos" => "tRemolo",
"trémoussa" => "tRemusa",
"trémoussaient" => "tRemusE",
"trémoussait" => "tRemusE",
"trémoussant" => "tRemus@",
"trémoussât" => "tRemusa",
"trémousse" => "tRemus",
"trémoussement" => "tRemus°m@",
"trémoussements" => "tRemus°m@",
"trémoussent" => "tRemus",
"trémousser" => "tRemuse",
"trémoussèrent" => "tRemusER",
"trémousses" => "tRemus",
"trempa" => "tR@pa",
"trempage" => "tR@paZ",
"trempages" => "tR@paZ",
"trempai" => "tR@pE",
"trempaient" => "tR@pE",
"trempais" => "tR@pE",
"trempait" => "tR@pE",
"trempant" => "tR@p@",
"trempe" => "tR@p",
"trempé" => "tR@pe",
"trempée" => "tR@pe",
"trempées" => "tR@pe",
"trempent" => "tR@p",
"tremper" => "tR@pe",
"trempera" => "tR@p°Ra",
"tremperaient" => "tR@p°RE",
"tremperais" => "tR@p°RE",
"tremperait" => "tR@p°RE",
"trempèrent" => "tR@pER",
"trempes" => "tR@p",
"trempés" => "tR@pe",
"trempette" => "tR@pEt",
"trempeur" => "tR@p9R",
"trempez" => "tR@pe",
"trempions" => "tR@pj§",
"tremplin" => "tR@pl5",
"trempoline" => "tR@pOlin",
"trempons" => "tR@p§",
"trémulant" => "tRemyl@",
"trémulante" => "tRemyl@t",
"trémulation" => "tRemylasj§",
"trémuler" => "tRemyle",
"trench" => "tREnS",
"trench-coat" => "tREnSkOwt",
"trench-coats" => "tREnSkOwt",
"trentaine" => "tR@tEn",
"trente" => "tR@t",
"trente-cinq" => "tR@ts5k",
"trente-cinquième" => "tR@ts5kjEm",
"trente-deux" => "tR@td2",
"trente-et-quarante" => "tR@tekaR@t",
"trente-et-un" => "tR@te1",
"trente-et-unième" => "tR@teynjEm",
"trente-huit" => "tR@t8it",
"trente-huitième" => "tR@t8itjEm",
"trente-neuf" => "tR@tn9f",
"trente-neuvième" => "tR@tn9vjEm",
"trente-quatre" => "tR@tkatR",
"trente-quatrième" => "tR@tkatRijEm",
"trente-sept" => "tR@tsEt",
"trente-septième" => "tR@tsEtjEm",
"trente-six" => "tR@tsis",
"trente-sixième" => "tR@tsizjEm",
"trente-trois" => "tR@ttRwa",
"trente-troisième" => "tR@ttRwazjEm",
"trentenaire" => "tR@t°nER",
"trentenaires" => "tR@t°nER",
"trentième" => "tR@tjEm",
"trépan" => "tRep@",
"trépanation" => "tRepanasj§",
"trépané" => "tRepane",
"trépanée" => "tRepane",
"trépaner" => "tRepane",
"trépas" => "tRepa",
"trépassaient" => "tRepasE",
"trépassait" => "tRepasE",
"trépassant" => "tRepas@",
"trépasse" => "tRepas",
"trépassé" => "tRepase",
"trépassée" => "tRepase",
"trépassées" => "tRepase",
"trépassent" => "tRepas",
"trépasser" => "tRepase",
"trépasserait" => "tRepas°RE",
"trépasseront" => "tRepas°R§",
"trépassés" => "tRepase",
"trèpe" => "tREp",
"trépidant" => "tRepid@",
"trépidante" => "tRepid@t",
"trépidantes" => "tRepid@t",
"trépidants" => "tRepid@",
"trépidation" => "tRepidasj§",
"trépidations" => "tRepidasj§",
"trépide" => "tRepid",
"trépident" => "tRepid",
"trépider" => "tRepide",
"trépied" => "tRepje",
"trépieds" => "tRepje",
"trépigna" => "tRepiNa",
"trépignaient" => "tRepiNE",
"trépignais" => "tRepiNE",
"trépignait" => "tRepiNE",
"trépignant" => "tRepiN@",
"trépignante" => "tRepiN@t",
"trépignants" => "tRepiN@",
"trépigne" => "tRepiN",
"trépigné" => "tRepiNe",
"trépignée" => "tRepiNe",
"trépignement" => "tRepiN°m@",
"trépignements" => "tRepiN°m@",
"trépignent" => "tRepiN",
"trépigner" => "tRepiNe",
"trépignerai" => "tRepiN°RE",
"trépignez" => "tRepiNe",
"tréponème" => "tReponEm",
"tréponèmes" => "tReponEm",
"très" => "tRE",
"trésor" => "tRezOR",
"trésorerie" => "tRezOR°Ri",
"trésorier" => "tRezoRje",
"trésorier-payeur" => "tRezoRjepEj9R",
"trésorière" => "tRezoRjER",
"trésoriers" => "tRezoRje",
"trésors" => "tRezOR",
"tressa" => "tREsa",
"tressaient" => "tREsE",
"tressaillaient" => "tResajE",
"tressaillais" => "tResajE",
"tressaillait" => "tResajE",
"tressaillant" => "tResaj@",
"tressaille" => "tResaj",
"tressaillement" => "tResaj°m@",
"tressaillements" => "tResaj°m@",
"tressaillent" => "tResaj",
"tressaillez" => "tREsaje",
"tressailli" => "tResaji",
"tressaillir" => "tResajiR",
"tressaillira" => "tResajiRa",
"tressaillirait" => "tResajiRE",
"tressaillirent" => "tResajiR",
"tressaillis" => "tResaji",
"tressaillit" => "tResaji",
"tressait" => "tREsE",
"tressant" => "tREs@",
"tressauta" => "tREsota",
"tressautaient" => "tREsotE",
"tressautait" => "tREsotE",
"tressautant" => "tREsot@",
"tressautante" => "tREsot@t",
"tressaute" => "tREsot",
"tressautement" => "tResot°m@",
"tressautements" => "tResot°m@",
"tressautent" => "tREsot",
"tressauter" => "tResote",
"tressautera" => "tREsot°Ra",
"tressautés" => "tResote",
"tresse" => "tREs",
"tressé" => "tRese",
"tressée" => "tRese",
"tressées" => "tRese",
"tressent" => "tREs",
"tresser" => "tRese",
"tresseraient" => "tREs°RE",
"tresseras" => "tREs°Ra",
"tressèrent" => "tREsER",
"tresses" => "tREs",
"tressés" => "tRese",
"tresseurs" => "tREs9R",
"tressons" => "tREs§",
"tréteau" => "tReto",
"tréteaux" => "tReto",
"treuil" => "tR9j",
"treuiller" => "tR9je",
"treuils" => "tR9j",
"trêve" => "tREv",
"trêves" => "tREv",
"tri" => "tRi",
"tria" => "tRija",
"triade" => "tRijad",
"triades" => "tRijad",
"triage" => "tRijaZ",
"triaient" => "tRijE",
"triais" => "tRijE",
"triait" => "tRijE",
"trial" => "tRijal",
"triangle" => "tRij@gl",
"triangles" => "tRij@gl",
"triangulaire" => "tRij@gylER",
"triangulairement" => "tRij@gylER°m@",
"triangulaires" => "tRij@gylER",
"triangulation" => "tRij@gylasj§",
"trianguler" => "tRi@gyle",
"triangulez" => "tRi@gyle",
"trianon" => "tRijan§",
"triant" => "tRij@",
"trias" => "tRijas",
"triasique" => "tRijasik",
"triathlète" => "tRiatlEt",
"triathlon" => "tRijatl§",
"tribal" => "tRibal",
"tribale" => "tRibal",
"tribales" => "tRibal",
"tribart" => "tRibaR",
"tribaux" => "tRibo",
"tribord" => "tRibOR",
"tribu" => "tRiby",
"tribulation" => "tRibylasj§",
"tribulations" => "tRibylasj§",
"tribun" => "tRib1",
"tribunal" => "tRibynal",
"tribunat" => "tRibyna",
"tribunaux" => "tRibyno",
"tribune" => "tRibyn",
"tribunes" => "tRibyn",
"tribuns" => "tRib1",
"tribus" => "tRiby",
"tribut" => "tRiby",
"tributaire" => "tRibytER",
"tributaires" => "tRibytER",
"tributs" => "tRiby",
"tric" => "tRik",
"tricard" => "tRikaR",
"tricarde" => "tRikaRd",
"tricards" => "tRikaR",
"tricentenaire" => "tRis@t°nER",
"tricéphale" => "tRisefal",
"triceps" => "tRisEps",
"tricératops" => "tRiseRatOps",
"tricha" => "tRiSa",
"trichaient" => "tRiSE",
"trichais" => "tRiSE",
"trichait" => "tRiSE",
"trichant" => "tRiS@",
"triche" => "tRiS",
"triché" => "tRiSe",
"trichée" => "tRiSe",
"trichées" => "tRiSe",
"trichent" => "tRiS",
"tricher" => "tRiSe",
"trichera" => "tRiS°Ra",
"tricherai" => "tRiS°RE",
"tricherais" => "tRiS°RE",
"tricherait" => "tRiS°RE",
"tricherie" => "tRiS°Ri",
"tricheries" => "tRiS°Ri",
"tricheront" => "tRiS°R§",
"triches" => "tRiS",
"tricheur" => "tRiS9R",
"tricheurs" => "tRiS9R",
"tricheuse" => "tRiS2z",
"tricheuses" => "tRiS2z",
"trichez" => "tRiSe",
"trichiez" => "tRiSje",
"trichinose" => "tRikinoz",
"trichloracétique" => "tRiklORasetik",
"trichloréthylène" => "tRikloRetilEn",
"trichlorure" => "tRiklORyR",
"trichons" => "tRiS§",
"trichophyties" => "tRikofiti",
"trick" => "tRik",
"tricoises" => "tRikwaz",
"tricolore" => "tRikolOR",
"tricolores" => "tRikolOR",
"tricorne" => "tRikORn",
"tricornes" => "tRikORn",
"tricot" => "tRiko",
"tricota" => "tRikota",
"tricotage" => "tRikotaZ",
"tricotages" => "tRikotaZ",
"tricotai" => "tRikotE",
"tricotaient" => "tRikotE",
"tricotais" => "tRikotE",
"tricotait" => "tRikotE",
"tricotant" => "tRikot@",
"tricote" => "tRikOt",
"tricoté" => "tRikote",
"tricotée" => "tRikote",
"tricotées" => "tRikote",
"tricotent" => "tRikOt",
"tricoter" => "tRikote",
"tricotera" => "tRikOt°Ra",
"tricoterai" => "tRikOt°RE",
"tricoterait" => "tRikOt°RE",
"tricoteras" => "tRikOt°Ra",
"tricoterons" => "tRikOt°R§",
"tricotés" => "tRikote",
"tricoteur" => "tRikot9R",
"tricoteuse" => "tRikot2z",
"tricoteuses" => "tRikot2z",
"tricotez" => "tRikote",
"tricots" => "tRiko",
"trictrac" => "tRiktRak",
"tricuspide" => "tRikyspid",
"tricycle" => "tRisikl",
"tricycles" => "tRisikl",
"tricycliste" => "tRisiklist",
"trident" => "tRid@",
"tridents" => "tRid@",
"tridi" => "tRidi",
"tridimensionnel" => "tRidim@sjonEl",
"tridimensionnelle" => "tRidim@sjonEl",
"trie" => "tRi",
"trié" => "tRije",
"triée" => "tRije",
"triées" => "tRije",
"triennale" => "tRienal",
"triennales" => "tRienal",
"trient" => "tRi",
"trier" => "tRije",
"triera" => "tRiRa",
"trierait" => "tRiRE",
"trièrent" => "tRijER",
"triés" => "tRije",
"trieur" => "tRij9R",
"trieurs" => "tRij9R",
"trieuse" => "tRij2z",
"trieuses" => "tRij2z",
"triez" => "tRije",
"trifolium" => "tRifoljOm",
"triforium" => "tRifoRjOm",
"trifouillaient" => "tRifujE",
"trifouillait" => "tRifujE",
"trifouille" => "tRifuj",
"trifouillé" => "tRifuje",
"trifouiller" => "tRifuje",
"trifouillez" => "tRifuje",
"trigger" => "tRig9R",
"trigles" => "tRigl",
"triglycéride" => "tRigliseRid",
"triglycérides" => "tRigliseRid",
"trigonométrie" => "tRigonometRi",
"trigrammes" => "tRigRam",
"trilatérale" => "tRilateRal",
"trilingue" => "tRil5g",
"trilingues" => "tRil5g",
"trillant" => "tRij@",
"trille" => "tRij",
"trillé" => "tRije",
"trilles" => "tRij",
"trillion" => "tRilj§",
"trillions" => "tRilj§",
"trilobée" => "tRilobe",
"trilobés" => "tRilobe",
"trilobite" => "tRilobit",
"trilogie" => "tRiloZi",
"trimait" => "tRimE",
"trimant" => "tRim@",
"trimard" => "tRimaR",
"trimarde" => "tRimaRd",
"trimarder" => "tRimaRde",
"trimardeur" => "tRimaRd9R",
"trimardeurs" => "tRimaRd9R",
"trimards" => "tRimaR",
"trimbala" => "tR5bala",
"trimbalaient" => "tR5balE",
"trimbalais" => "tR5balE",
"trimbalait" => "tR5balE",
"trimbalant" => "tR5bal@",
"trimbale" => "tR5bal",
"trimbalé" => "tR5bale",
"trimbalée" => "tR5bale",
"trimbalent" => "tR5bal",
"trimbaler" => "tR5bale",
"trimbalerai" => "tR5bal°RE",
"trimbalerait" => "tR5bal°RE",
"trimbalerez" => "tR5bal°Re",
"trimbales" => "tR5bal",
"trimbalés" => "tR5bale",
"trimbalez" => "tR5bale",
"trimballage" => "tR5balaZ",
"trimballaient" => "tR5balE",
"trimballais" => "tR5balE",
"trimballait" => "tR5balE",
"trimballât" => "tR5bala",
"trimballe" => "tR5bal",
"trimballé" => "tR5bale",
"trimballée" => "tR5bale",
"trimballent" => "tR5bal",
"trimballer" => "tR5bale",
"trimballera" => "tR5bal°Ra",
"trimballes" => "tR5bal",
"trimballés" => "tR5bale",
"trimballez" => "tR5bale",
"trimbalons" => "tR5bal§",
"trime" => "tRim",
"trimé" => "tRime",
"triment" => "tRim",
"trimer" => "tRime",
"trimes" => "tRim",
"trimestre" => "tRimEstR",
"trimestres" => "tRimEstR",
"trimestriel" => "tRimEstRijEl",
"trimestrielle" => "tRimEstRijEl",
"trimestriellement" => "tRimEstRijEl°m@",
"trimestrielles" => "tRimEstRijEl",
"trimestriels" => "tRimEstRijEl",
"trimeur" => "tRim9R",
"trimeurs" => "tRim9R",
"trimmer" => "tRim9R",
"trimons" => "tRim§",
"trinacrie" => "tRinakRi",
"trine" => "tRin",
"tringlaient" => "tR5glE",
"tringlais" => "tR5glE",
"tringlait" => "tR5glE",
"tringle" => "tR5gl",
"tringlé" => "tR5gle",
"tringlée" => "tR5gle",
"tringler" => "tR5gle",
"tringlerais" => "tR5gl°RE",
"tringles" => "tR5gl",
"tringlette" => "tR5glEt",
"tringlot" => "tR5glo",
"tringlots" => "tR5glo",
"trinidadienne" => "tRinidadjEn",
"trinitaire" => "tRinitER",
"trinité" => "tRinite",
"trinitrine" => "tRinitRin",
"trinôme" => "tRinom",
"trinqua" => "tR5ka",
"trinquaient" => "tR5kE",
"trinquais" => "tR5kE",
"trinquait" => "tR5kE",
"trinquâmes" => "tR5kam",
"trinquant" => "tR5k@",
"trinque" => "tR5k",
"trinqué" => "tR5ke",
"trinquent" => "tR5k",
"trinquer" => "tR5ke",
"trinquera" => "tR5k°Ra",
"trinquerai" => "tR5k°RE",
"trinquerais" => "tR5k°RE",
"trinquerait" => "tR5k°RE",
"trinqueras" => "tR5k°Ra",
"trinquèrent" => "tR5kER",
"trinquerez" => "tR5k°Re",
"trinquerons" => "tR5k°R§",
"trinques" => "tR5k",
"trinquette" => "tR5kEt",
"trinquez" => "tR5ke",
"trinquions" => "tR5kj§",
"trinquons" => "tR5k§",
"trio" => "tRijo",
"triode" => "tRijOd",
"triolet" => "tRijOlE",
"triolets" => "tRijolE",
"triolisme" => "tRiolizm",
"triompha" => "tRij§fa",
"triomphai" => "tRij§fE",
"triomphaient" => "tRij§fE",
"triomphais" => "tRij§fE",
"triomphait" => "tRij§fE",
"triomphal" => "tRij§fal",
"triomphale" => "tRij§fal",
"triomphalement" => "tRij§fal°m@",
"triomphales" => "tRij§fal",
"triomphalisme" => "tRij§falism",
"triomphaliste" => "tRij§falist",
"triomphalistes" => "tRij§falist",
"triomphâmes" => "tRij§fam",
"triomphant" => "tRij§f@",
"triomphante" => "tRij§f@t",
"triomphantes" => "tRij§f@t",
"triomphants" => "tRij§f@",
"triomphât" => "tRij§fa",
"triomphateur" => "tRij§fat9R",
"triomphateurs" => "tRij§fat9R",
"triomphatrice" => "tRij§fatRis",
"triomphatrices" => "tRij§fatRis",
"triomphaux" => "tRij§fo",
"triomphe" => "tRij§f",
"triomphé" => "tRij§fe",
"triomphent" => "tRij§f",
"triompher" => "tRij§fe",
"triomphera" => "tRij§f°Ra",
"triompherai" => "tRij§f°RE",
"triompherais" => "tRij§f°RE",
"triompherait" => "tRij§f°RE",
"triompheras" => "tRij§f°Ra",
"triomphèrent" => "tRij§fER",
"triompherez" => "tRij§f°Re",
"triompherions" => "tRi§f°Rj§",
"triompherons" => "tRi§fR@",
"triompheront" => "tRij§f°R§",
"triomphes" => "tRij§f",
"triomphez" => "tRi§fe",
"triomphions" => "tRi§fj§",
"triomphons" => "tRij§f§",
"trional" => "tRijOnal",
"trionix" => "tRijOniks",
"trios" => "tRijo",
"trip" => "tRip",
"tripaille" => "tRipaj",
"tripailles" => "tRipaj",
"tripang" => "tRip@",
"tripangs" => "tRip@",
"tripant" => "tRip@",
"tripartite" => "tRipaRtit",
"tripartites" => "tRipaRtit",
"tripatouillage" => "tRipatujaZ",
"tripatouillages" => "tRipatujaZ",
"tripatouillant" => "tRipatuj@",
"tripatouillé" => "tRipatuje",
"tripatouillée" => "tRipatuje",
"tripatouillent" => "tRipatuj",
"tripatouiller" => "tRipatuje",
"tripatouillez" => "tRipatuje",
"tripe" => "tRip",
"triper" => "tRipe",
"triperie" => "tRip°Ri",
"triperies" => "tRip°Ri",
"tripes" => "tRip",
"tripette" => "tRipEt",
"triphasé" => "tRifaze",
"triphosphate" => "tRifOsfat",
"tripier" => "tRipje",
"tripière" => "tRipjER",
"tripiers" => "tRipje",
"tripla" => "tRipla",
"triplace" => "tRiplas",
"triplai" => "tRiplE",
"triplaient" => "tRiplE",
"triplait" => "tRiplE",
"triplant" => "tRipl@",
"triple" => "tRipl",
"triplé" => "tRiple",
"triplée" => "tRiple",
"triplées" => "tRiple",
"triplement" => "tRipl°m@",
"triplent" => "tRipl",
"tripler" => "tRiple",
"triplerais" => "tRipl°RE",
"triplerait" => "tRipl°RE",
"triplèrent" => "tRiplER",
"triples" => "tRipl",
"triplés" => "tRiple",
"triplets" => "tRiplE",
"triplette" => "tRiplEt",
"triplex" => "tRiplEks",
"triplice" => "tRiplis",
"triplions" => "tRiplj§",
"triploïde" => "tRiplOid",
"triplons" => "tRipl§",
"tripode" => "tRipOd",
"tripoli" => "tRipoli",
"triporteur" => "tRipORt9R",
"triporteurs" => "tRipORt9R",
"tripot" => "tRipo",
"tripota" => "tRipota",
"tripotage" => "tRipotaZ",
"tripotages" => "tRipotaZ",
"tripotaient" => "tRipotE",
"tripotais" => "tRipotE",
"tripotait" => "tRipotE",
"tripotant" => "tRipot@",
"tripote" => "tRipOt",
"tripoté" => "tRipote",
"tripotée" => "tRipote",
"tripotées" => "tRipote",
"tripotent" => "tRipOt",
"tripoter" => "tRipote",
"tripoterai" => "tRipOt°RE",
"tripotèrent" => "tRipotER",
"tripotes" => "tRipOt",
"tripotés" => "tRipote",
"tripoteur" => "tRipot9R",
"tripoteuse" => "tRipOt2z",
"tripotez" => "tRipote",
"tripotiez" => "tRipotje",
"tripots" => "tRipo",
"tripoux" => "tRipu",
"trips" => "tRip",
"triptyque" => "tRiptik",
"triptyques" => "tRiptik",
"triquais" => "tRikE",
"triquait" => "tRikE",
"trique" => "tRik",
"triqueballe" => "tRik°bal",
"triquer" => "tRike",
"triques" => "tRik",
"trirème" => "tRiREm",
"trirèmes" => "tRiREm",
"tris" => "tRi",
"trisaïeul" => "tRizaj9l",
"trisaïeule" => "tRizaj9l",
"trisaïeuls" => "tRizaj9l",
"trismégiste" => "tRismeZist",
"trismique" => "tRismik",
"trismus" => "tRismys",
"trisomie" => "tRizOmi",
"trisomique" => "tRizOmik",
"trissait" => "tRisE",
"trisse" => "tRis",
"trissent" => "tRis",
"trisser" => "tRise",
"trissés" => "tRise",
"triste" => "tRist",
"tristement" => "tRist°m@",
"tristes" => "tRist",
"tristesse" => "tRistEs",
"tristesses" => "tRistEs",
"tristouillard" => "tRistujaR",
"tristouillarde" => "tRistujaRd",
"tristouille" => "tRistuj",
"tristouilles" => "tRistuj",
"tristounet" => "tRistunE",
"tristounette" => "tRistunEt",
"tristounettes" => "tRistunEt",
"trithéisme" => "tRiteizm",
"trithérapie" => "tRiteRapi",
"tritium" => "tRitjOm",
"triton" => "tRit§",
"tritons" => "tRit§",
"tritura" => "tRityRa",
"trituraient" => "tRityRE",
"triturais" => "tRityRE",
"triturait" => "tRityRE",
"triturant" => "tRityR@",
"trituration" => "tRityRasj§",
"triturations" => "tRityRasj§",
"triture" => "tRityR",
"trituré" => "tRityRe",
"triturée" => "tRityRe",
"triturées" => "tRityRe",
"triturent" => "tRityR",
"triturer" => "tRityRe",
"triturera" => "tRityR°Ra",
"triturés" => "tRityRe",
"triturons" => "tRityR§",
"triumvir" => "tRijOmviR",
"triumvirat" => "tRijOmviRa",
"trivial" => "tRivjal",
"triviale" => "tRivjal",
"trivialement" => "tRivjal°m@",
"triviales" => "tRivjal",
"trivialiser" => "tRivjalize",
"trivialité" => "tRivjalite",
"trivialités" => "tRivjalite",
"triviaux" => "tRivjo",
"trivium" => "tRivjOm",
"trobriandais" => "tRobRij@dE",
"troc" => "tROk",
"trocart" => "tRokaR",
"trochaïque" => "tRokaik",
"trochanter" => "tROk@tER",
"troche" => "tROS",
"trochée" => "tRoSe",
"trochures" => "tRoSyR",
"trocs" => "tROk",
"troène" => "tRoEn",
"troènes" => "tRoEn",
"troglodyte" => "tRoglodit",
"troglodytes" => "tRoglodit",
"troglodytique" => "tROglOditik",
"troglodytiques" => "tRogloditik",
"trogne" => "tRON",
"trognes" => "tRON",
"trognon" => "tRoN§",
"trognons" => "tRoN§",
"troïka" => "tRoika",
"troïkas" => "tRoika",
"trois" => "tRwa",
"trois-deux" => "tRwad2",
"trois-huit" => "tRwa8it",
"trois-mâts" => "tRwama",
"trois-points" => "tRwapw5",
"trois-quarts" => "tRwakaR",
"trois-quatre" => "tRwakatR",
"trois-six" => "tRwasis",
"troisième" => "tRwazjEm",
"troisièmement" => "tRwazjEm°m@",
"troisièmes" => "tRwazjEm",
"trôler" => "tRole",
"troll" => "tROl",
"trolle" => "tROl",
"trolley" => "tRolE",
"trolleybus" => "tRolEbys",
"trolleys" => "tRolE",
"trolls" => "tROl",
"trombe" => "tR§b",
"trombes" => "tR§b",
"trombine" => "tR§bin",
"trombines" => "tR§bin",
"trombinoscope" => "tR§binoskOp",
"tromblon" => "tR§bl§",
"tromblons" => "tR§bl§",
"trombone" => "tR§bOn",
"trombones" => "tR§bOn",
"tromboniste" => "tR§bOnist",
"trommel" => "tRomEl",
"trompa" => "tR§pa",
"trompai" => "tR§pE",
"trompaient" => "tR§pE",
"trompais" => "tR§pE",
"trompait" => "tR§pE",
"trompâmes" => "tR§pam",
"trompant" => "tR§p@",
"trompât" => "tR§pa",
"trompe" => "tR§p",
"trompé" => "tR§pe",
"trompe-l'oeil" => "tR§pl9j",
"trompée" => "tR§pe",
"trompées" => "tR§pe",
"trompent" => "tR§p",
"tromper" => "tR§pe",
"trompera" => "tR§p°Ra",
"tromperai" => "tR§p°RE",
"tromperaient" => "tR§p°RE",
"tromperais" => "tR§p°RE",
"tromperait" => "tR§p°RE",
"tromperas" => "tR§p°Ra",
"trompèrent" => "tR§pER",
"tromperez" => "tR§p°Re",
"tromperie" => "tR§p°Ri",
"tromperies" => "tR§p°Ri",
"tromperiez" => "tR§p°Rje",
"tromperons" => "tR§p°R§",
"tromperont" => "tR§p°R§",
"trompes" => "tR§p",
"trompés" => "tR§pe",
"trompeter" => "tR§p°te",
"trompette" => "tR§pEt",
"trompettes" => "tR§pEt",
"trompettiste" => "tR§petist",
"trompettistes" => "tR§pEtist",
"trompeur" => "tR§p9R",
"trompeurs" => "tR§p9R",
"trompeuse" => "tR§p2z",
"trompeusement" => "tR§p2z°m@",
"trompeuses" => "tR§p2z",
"trompez" => "tR§pe",
"trompiez" => "tR§pje",
"trompions" => "tR§pj§",
"trompons" => "tR§p§",
"trôna" => "tRona",
"trônaient" => "tRonE",
"trônais" => "tRonE",
"trônait" => "tRonE",
"trônant" => "tRon@",
"tronc" => "tR§",
"tronchais" => "tR§SE",
"tronche" => "tR§S",
"tronché" => "tR§Se",
"tronchée" => "tR§Se",
"troncher" => "tR§Se",
"tronches" => "tR§S",
"tronçon" => "tR§s§",
"tronconique" => "tR§konik",
"tronçonnaient" => "tR§sonE",
"tronçonnait" => "tR§sonE",
"tronçonne" => "tR§sOn",
"tronçonné" => "tR§sone",
"tronçonnée" => "tR§sone",
"tronçonnées" => "tR§sone",
"tronçonner" => "tR§sone",
"tronçonnés" => "tR§sone",
"tronçonneuse" => "tR§son2z",
"tronçonneuses" => "tR§son2z",
"tronçons" => "tR§s§",
"troncs" => "tR§",
"trône" => "tRon",
"trôné" => "tRone",
"trônent" => "tRon",
"trôner" => "tRone",
"trônerait" => "tRon°RE",
"trônes" => "tRon",
"tronqué" => "tR§ke",
"tronquée" => "tR§ke",
"tronquées" => "tR§ke",
"tronquer" => "tR§ke",
"tronqués" => "tR§ke",
"trop" => "tRo",
"trop-perçu" => "tRopERsy",
"trop-plein" => "tRopl5",
"trop-pleins" => "tRopl5",
"trope" => "tROp",
"tropézienne" => "tRopezjEn",
"tropéziens" => "tRopezj5",
"trophée" => "tRofe",
"trophées" => "tRofe",
"tropical" => "tRopikal",
"tropicale" => "tRopikal",
"tropicales" => "tRopikal",
"tropicaux" => "tRopiko",
"tropique" => "tRopik",
"tropiques" => "tRopik",
"tropisme" => "tRopizm",
"tropismes" => "tRopizm",
"troposphère" => "tRoposfER",
"troposphérique" => "tRoposfeRik",
"troposphériques" => "tRoposfeRik",
"troqua" => "tRoka",
"troquaient" => "tRokE",
"troquais" => "tRokE",
"troquait" => "tRokE",
"troquant" => "tRok@",
"troquas" => "tRoka",
"troque" => "tROk",
"troqué" => "tRoke",
"troquée" => "tRoke",
"troquées" => "tRoke",
"troquer" => "tRoke",
"troquera" => "tROk°Ra",
"troquerai" => "tROk°RE",
"troquerais" => "tROk°RE",
"troquèrent" => "tRokER",
"troqués" => "tRoke",
"troquet" => "tRokE",
"troquets" => "tRokE",
"troquez" => "tRoke",
"trot" => "tRo",
"trots" => "tRo",
"trotskisme" => "tROtskizm",
"trotskiste" => "tROtskist",
"trotskistes" => "tROtskist",
"trotskystes" => "tROtskist",
"trotta" => "tRota",
"trottaient" => "tRotE",
"trottais" => "tRotE",
"trottait" => "tRotE",
"trottant" => "tRot@",
"trotte" => "tROt",
"trotté" => "tRote",
"trotte-menu" => "tROtm°ny",
"trottent" => "tROt",
"trotter" => "tRote",
"trottera" => "tROt°Ra",
"trotterions" => "tROt°Rj§",
"trottes" => "tROt",
"trotteur" => "tROt9R",
"trotteurs" => "tRot9R",
"trotteuse" => "tRot2z",
"trotteuses" => "tRot2z",
"trottez" => "tRote",
"trottignolles" => "tRotiNOl",
"trottin" => "tRot5",
"trottina" => "tRotina",
"trottinais" => "tRotinE",
"trottinait" => "tRotinE",
"trottinant" => "tRotin@",
"trottine" => "tRotin",
"trottiné" => "tRotine",
"trottinement" => "tRotin°m@",
"trottinements" => "tRotin°m@",
"trottinent" => "tRotin",
"trottiner" => "tRotine",
"trottinerait" => "tRotin°RE",
"trottinette" => "tRotinEt",
"trottinettes" => "tRotinEt",
"trottinez" => "tRotine",
"trottinions" => "tRotinj§",
"trottins" => "tRot5",
"trottions" => "tRotj§",
"trottoir" => "tRotwaR",
"trottoirs" => "tRotwaR",
"trottons" => "tRot§",
"trou" => "tRu",
"trou-du-cul" => "tRudyky",
"trou-trou" => "tRutRu",
"trou-trous" => "tRutRu",
"troua" => "tRua",
"trouai" => "tRuE",
"trouaient" => "tRuE",
"trouais" => "tRuE",
"trouait" => "tRuE",
"trouant" => "tRu@",
"troubades" => "tRubad",
"troubadour" => "tRubaduR",
"troubadours" => "tRubaduR",
"troubla" => "tRubla",
"troublai" => "tRublE",
"troublaient" => "tRublE",
"troublais" => "tRublE",
"troublait" => "tRublE",
"troublant" => "tRubl@",
"troublante" => "tRubl@t",
"troublantes" => "tRubl@t",
"troublants" => "tRubl@",
"troublât" => "tRubla",
"trouble" => "tRubl",
"troublé" => "tRuble",
"trouble-fêtes" => "tRubl°fEt",
"troublée" => "tRuble",
"troublées" => "tRuble",
"troublent" => "tRubl",
"troubler" => "tRuble",
"troublera" => "tRubl°Ra",
"troublerais" => "tRubl°RE",
"troublerait" => "tRubl°RE",
"troublèrent" => "tRublER",
"troubleront" => "tRubl°R§",
"troubles" => "tRubl",
"troublés" => "tRuble",
"troublez" => "tRuble",
"trouduc" => "tRudyk",
"trouducuteries" => "tRudykyt°Ri",
"troue" => "tRu",
"troué" => "tRue",
"trouée" => "tRue",
"trouées" => "tRue",
"trouent" => "tRu",
"trouer" => "tRue",
"trouerai" => "tRuRE",
"trouerais" => "tRuRE",
"trouèrent" => "tRuER",
"troués" => "tRue",
"trouez" => "tRue",
"troufignard" => "tRufiNaR",
"troufignon" => "tRufiN§",
"troufignons" => "tRufiN§",
"troufion" => "tRufj§",
"troufions" => "tRufj§",
"trouillait" => "tRujE",
"trouillard" => "tRujaR",
"trouillarde" => "tRujaRd",
"trouillards" => "tRujaR",
"trouille" => "tRuj",
"trouilles" => "tRuj",
"trouillomètre" => "tRujomEtR",
"troupe" => "tRup",
"troupeau" => "tRupo",
"troupeaux" => "tRupo",
"troupes" => "tRup",
"troupier" => "tRupje",
"troupiers" => "tRupje",
"trous" => "tRu",
"trous-du-cul" => "tRudyky",
"troussa" => "tRusa",
"troussaient" => "tRusE",
"troussait" => "tRusE",
"troussant" => "tRus@",
"trousse" => "tRus",
"troussé" => "tRuse",
"trousseau" => "tRuso",
"trousseaux" => "tRuso",
"troussée" => "tRuse",
"troussées" => "tRuse",
"troussequin" => "tRusk5",
"trousser" => "tRuse",
"troussèrent" => "tRusER",
"trousses" => "tRus",
"troussés" => "tRuse",
"trousseur" => "tRus9R",
"trouva" => "tRuva",
"trouvable" => "tRuvabl",
"trouvai" => "tRuvE",
"trouvaient" => "tRuvE",
"trouvaille" => "tRuvaj",
"trouvailles" => "tRuvaj",
"trouvais" => "tRuvE",
"trouvait" => "tRuvE",
"trouvâmes" => "tRuvam",
"trouvant" => "tRuv@",
"trouvas" => "tRuva",
"trouvasse" => "tRuvas",
"trouvassent" => "tRuvas",
"trouvât" => "tRuva",
"trouve" => "tRuv",
"trouvé" => "tRuve",
"trouvée" => "tRuve",
"trouvées" => "tRuve",
"trouvent" => "tRuv",
"trouver" => "tRuve",
"trouvera" => "tRuv°Ra",
"trouverai" => "tRuv°RE",
"trouveraient" => "tRuv°RE",
"trouverais" => "tRuv°RE",
"trouverait" => "tRuv°RE",
"trouveras" => "tRuv°Ra",
"trouvère" => "tRuvER",
"trouvèrent" => "tRuvER",
"trouvères" => "tRuvER",
"trouverez" => "tRuv°Re",
"trouveriez" => "tRuv°Rje",
"trouverions" => "tRuv°Rj§",
"trouverons" => "tRuv°R§",
"trouveront" => "tRuv°R§",
"trouves" => "tRuv",
"trouvés" => "tRuve",
"trouveur" => "tRuv9R",
"trouveurs" => "tRuv9R",
"trouvez" => "tRuve",
"trouviez" => "tRuvje",
"trouvions" => "tRuvj§",
"trouvons" => "tRuv§",
"troyen" => "tRwaj5",
"troyenne" => "tRwajEn",
"truand" => "tRy@",
"truandage" => "tRy@daZ",
"truandages" => "tRy@daZ",
"truandaille" => "tRy@daj",
"truande" => "tRy@d",
"truandé" => "tRy@de",
"truander" => "tRy@de",
"truanderie" => "tRy@d°Ri",
"truandes" => "tRy@d",
"truands" => "tRy@",
"trublion" => "tRyblij§",
"trublions" => "tRyblij§",
"truc" => "tRyk",
"trucage" => "tRykaZ",
"trucages" => "tRykaZ",
"truchement" => "tRyS°m@",
"truchements" => "tRyS°m@",
"trucida" => "tRysida",
"trucidais" => "tRysidE",
"trucidant" => "tRysid@",
"trucidé" => "tRyside",
"trucidée" => "tRyside",
"trucident" => "tRysid",
"trucider" => "tRyside",
"truciderai" => "tRysid°RE",
"trucides" => "tRysid",
"trucidés" => "tRyside",
"trucidons" => "tRysid§",
"truck" => "tRyk",
"trucks" => "tRyk",
"trucmuche" => "tRykmyS",
"trucs" => "tRyk",
"truculence" => "tRykyl@s",
"truculent" => "tRykyl@",
"truculente" => "tRykyl@t",
"truelle" => "tRyEl",
"truelles" => "tRyEl",
"truffaient" => "tRyfE",
"truffait" => "tRyfE",
"truffant" => "tRyf@",
"truffe" => "tRyf",
"truffé" => "tRyfe",
"truffée" => "tRyfe",
"truffées" => "tRyfe",
"truffer" => "tRyfe",
"truffes" => "tRyf",
"truffés" => "tRyfe",
"truffier" => "tRyfje",
"truffiers" => "tRyfje",
"truffons" => "tRyf§",
"truie" => "tR8i",
"truies" => "tR8i",
"truisme" => "tR8izm",
"truismes" => "tR8izm",
"truite" => "tR8it",
"truitelle" => "tR8itEl",
"truites" => "tR8it",
"trumeau" => "tRymo",
"trumeaux" => "tRymo",
"truqua" => "tRyka",
"truquage" => "tRykaZ",
"truquages" => "tRykaZ",
"truquaient" => "tRykE",
"truquait" => "tRykE",
"truquant" => "tRyk@",
"truque" => "tRyk",
"truqué" => "tRyke",
"truquée" => "tRyke",
"truquées" => "tRyke",
"truquer" => "tRyke",
"truquerai" => "tRyk°RE",
"truquerez" => "tRyk°Re",
"truqués" => "tRyke",
"truqueur" => "tRyk9R",
"truqueurs" => "tRyk9R",
"truqueuse" => "tRyk2z",
"truquez" => "tRyke",
"truquions" => "tRykj§",
"trusquin" => "tRysk5",
"trust" => "tR9st",
"trustais" => "tR9stE",
"trustait" => "tR9stE",
"truste" => "tR9st",
"trustee" => "tR9sti",
"trustees" => "tR9stiz",
"trusteeship" => "tR9stiSip",
"trusteeships" => "tR9stiSips",
"truster" => "tR9ste",
"trusterait" => "tR9st°RE",
"trusts" => "tR9st",
"trypanosome" => "tRipanozom",
"trypanosomes" => "tRipanozom",
"trypanosomiase" => "tRipanozomjaz",
"trypsine" => "tRipsin",
"tryptophane" => "tRiptofan",
"tsar" => "tsaR",
"tsarévitch" => "tsaRevitS",
"tsarine" => "tsaRin",
"tsarisme" => "tsaRizm",
"tsariste" => "tsaRist",
"tsaristes" => "tsaRist",
"tsars" => "tsaR",
"tsé-tsé" => "tsetse",
"tsigane" => "tsigan",
"tsiganes" => "tsigan",
"tsoin-tsoin" => "tsw5tsw5",
"tss tss" => "tsts",
"tss-tss" => "tsts",
"tsuica" => "ts8ika",
"tsunami" => "tsynami",
"tu" => "ty",
"tu autem" => "tyotEm",
"tua" => "t8a",
"tuai" => "t8E",
"tuaient" => "t8E",
"tuais" => "t8E",
"tuait" => "t8E",
"tuant" => "t8@",
"tuante" => "t8@t",
"tuantes" => "t8@t",
"tuants" => "ty@",
"tuas" => "t8a",
"tuât" => "t8a",
"tub" => "t9b",
"tuba" => "tyba",
"tubages" => "tybaZ",
"tubard" => "tybaR",
"tubarde" => "tybaRd",
"tubardise" => "tybaRdiz",
"tubards" => "tybaR",
"tubas" => "tyba",
"tube" => "tyb",
"tubé" => "tybe",
"tuber" => "tybe",
"tubercule" => "tybERkyl",
"tubercules" => "tybERkyl",
"tuberculeuse" => "tybERkyl2z",
"tuberculeuses" => "tybERkyl2z",
"tuberculeux" => "tybERkyl2",
"tuberculine" => "tybERkylin",
"tuberculose" => "tybERkyloz",
"tubéreuse" => "tybeR2z",
"tubéreuses" => "tybeR2z",
"tubéreux" => "tybeR2",
"tubérosité" => "tybeRozite",
"tubes" => "tyb",
"tubs" => "t9b",
"tubulaire" => "tybylER",
"tubulaires" => "tybylER",
"tubule" => "tybyl",
"tubuleuses" => "tybyl2z",
"tubulure" => "tybylyR",
"tubulures" => "tybylyR",
"tudesque" => "tydEsk",
"tudesques" => "tydEsk",
"tudieu" => "tydj2",
"tue" => "ty",
"tué" => "t8e",
"tue-loup" => "tylu",
"tue-loups" => "tylu",
"tue-mouche" => "tymuS",
"tue-mouches" => "tymuS",
"tuée" => "t8e",
"tuées" => "t8e",
"tuent" => "ty",
"tuer" => "t8e",
"tuera" => "tyRa",
"tuerai" => "tyRE",
"tuerais" => "tyRE",
"tuerait" => "tyRE",
"tueras" => "tyRa",
"tuèrent" => "t8ER",
"tuerez" => "tyRe",
"tuerie" => "tyRi",
"tueries" => "tyRi",
"tueriez" => "tyRje",
"tuerions" => "tyRj§",
"tuerons" => "tyR§",
"tueront" => "tyR§",
"tues" => "ty",
"tués" => "t8e",
"tueur" => "t89R",
"tueurs" => "t89R",
"tueuse" => "t82z",
"tueuses" => "t82z",
"tuez" => "tye",
"tuf" => "tyf",
"tuffeau" => "tyfo",
"tuffeaux" => "tyfo",
"tuiez" => "tyje",
"tuile" => "t8il",
"tuilerie" => "t8il°Ri",
"tuileries" => "t8il°Ri",
"tuiles" => "t8il",
"tuions" => "tyj§",
"tularémie" => "tylaRemi",
"tulipe" => "tylip",
"tulipes" => "tylip",
"tulipier" => "tylipje",
"tulipiers" => "tylipje",
"tulle" => "tyl",
"tulles" => "tyl",
"tuméfaction" => "tymefaksj§",
"tuméfie" => "tymefi",
"tuméfié" => "tymefje",
"tuméfiée" => "tymefje",
"tuméfiées" => "tymefje",
"tuméfier" => "tymefje",
"tuméfiés" => "tymefje",
"tûmes" => "tym",
"tumescence" => "tymEs@s",
"tumescent" => "tymEs@",
"tumeur" => "tym9R",
"tumeurs" => "tym9R",
"tumorale" => "tymORal",
"tumoraux" => "tymORo",
"tumuli" => "tymyli",
"tumulte" => "tymylt",
"tumultes" => "tymylt",
"tumultuaire" => "tymylt8ER",
"tumultueuse" => "tymylt82z",
"tumultueusement" => "tymylt82z°m@",
"tumultueuses" => "tymylt82z",
"tumultueux" => "tymylt82",
"tumulus" => "tymylys",
"tune" => "tyn",
"tuner" => "tynER",
"tunes" => "tyn",
"tungstène" => "t1kstEn",
"tunique" => "tynik",
"tuniques" => "tynik",
"tunisien" => "tynizj5",
"tunisienne" => "tynizjEn",
"tunisiennes" => "tynizjEn",
"tunisiens" => "tynizj5",
"tunnel" => "tynEl",
"tunnels" => "tynEl",
"tuons" => "t8§",
"tuque" => "tyk",
"turban" => "tyRb@",
"turbans" => "tyRb@",
"turbé" => "tyRbe",
"turbés" => "tyRbe",
"turbin" => "tyRb5",
"turbina" => "tyRbina",
"turbinaient" => "tyRbinE",
"turbinait" => "tyRbinE",
"turbine" => "tyRbin",
"turbiné" => "tyRbine",
"turbiner" => "tyRbine",
"turbines" => "tyRbin",
"turbinez" => "tyRbine",
"turbins" => "tyRb5",
"turbo" => "tyRbo",
"turbocompresseur" => "tyRbok§pRes9R",
"turbocompresseurs" => "tyRbok§pREs9R",
"turbopropulseur" => "tyRbopRopyls9R",
"turboréacteur" => "tyRboReakt9R",
"turbos" => "tyRbo",
"turbot" => "tyRbo",
"turbotière" => "tyRbotjER",
"turbotières" => "tyRbosjER",
"turbulence" => "tyRbyl@s",
"turbulences" => "tyRbyl@s",
"turbulent" => "tyRbyl@",
"turbulente" => "tyRbyl@t",
"turbulentes" => "tyRbyl@t",
"turbulents" => "tyRbyl@",
"turc" => "tyRk",
"turco" => "tyRko",
"turcoman" => "tyRkoman",
"turcomans" => "tyRkoman",
"turcos" => "tyRko",
"turcs" => "tyRk",
"turdus" => "tyRdy",
"turelure" => "tyR°lyR",
"turent" => "tyR",
"turf" => "tyRf",
"turfiste" => "tyRfist",
"turfistes" => "tyRfist",
"turfs" => "tyRf",
"turgescence" => "tyRZes@s",
"turgescent" => "tyRZes@",
"turgescente" => "tyRZes@t",
"turgescentes" => "tyRZes@t",
"turgescents" => "tyRZes@",
"turgide" => "tyRZid",
"turgotine" => "tyRgotin",
"turinois" => "tyRinwa",
"turinoise" => "tyRinwaz",
"turista" => "tyRista",
"turistas" => "tyRista",
"turkmènes" => "tyRkmEn",
"turlu" => "tyRly",
"turlupinade" => "tyRlypinad",
"turlupinades" => "tyRlypinad",
"turlupinaient" => "tyRlypinE",
"turlupinait" => "tyRlypinE",
"turlupine" => "tyRlypin",
"turlupiné" => "tyRlypine",
"turlupinée" => "tyRlypine",
"turlupinent" => "tyRlypin",
"turlupiner" => "tyRlypine",
"turlupinera" => "tyRlypin°Ra",
"turlupins" => "tyRlyp5",
"turlutaines" => "tyRlytEn",
"turlute" => "tyRlyt",
"turlutent" => "tyRlyt",
"turluter" => "tyRlyte",
"turlutes" => "tyRlyt",
"turlutte" => "tyRlyt",
"turlututu" => "tyRlytyty",
"turne" => "tyRn",
"turnes" => "tyRn",
"turnover" => "t9Rnov9R",
"turpides" => "tyRpid",
"turpitude" => "tyRpityd",
"turpitudes" => "tyRpityd",
"turque" => "tyRk",
"turquerie" => "tyRk°Ri",
"turques" => "tyRk",
"turquin" => "tyRk5",
"turquoise" => "tyRkwaz",
"turquoises" => "tyRkwaz",
"tus" => "ty",
"tussent" => "tys",
"tussilage" => "tysilaZ",
"tussor" => "tysOR",
"tut" => "ty",
"tût" => "ty",
"tutélaire" => "tytelER",
"tutélaires" => "tytelER",
"tutelle" => "tytEl",
"tuteur" => "tyt9R",
"tuteurs" => "tyt9R",
"tutoie" => "tytwa",
"tutoiement" => "tytwam@",
"tutoiements" => "tytwam@",
"tutoient" => "tytwa",
"tutoiera" => "tytwaRa",
"tutoierai" => "tytwaRE",
"tutoies" => "tytwa",
"tutorat" => "tytORa",
"tutorial" => "tytoRjal",
"tutoriaux" => "tytoRjo",
"tutoya" => "tytwaja",
"tutoyaient" => "tytwajE",
"tutoyais" => "tytwajE",
"tutoyait" => "tytwajE",
"tutoyant" => "tytwaj@",
"tutoyât" => "tytwaja",
"tutoyé" => "tytwaje",
"tutoyée" => "tytwaje",
"tutoyer" => "tytwaje",
"tutoyèrent" => "tytwajER",
"tutoyés" => "tytwaje",
"tutoyeuses" => "tytwaj2z",
"tutoyez" => "tytwaje",
"tutoyions" => "tytwajj§",
"tutoyons" => "tytwaj§",
"tutrice" => "tytRis",
"tutti frutti" => "tytifRyti",
"tutti quanti" => "tytikwanti",
"tutu" => "tyty",
"tutus" => "tyty",
"tutute" => "tytyt",
"tuyau" => "t8ijo",
"tuyautages" => "t8ijotaZ",
"tuyautait" => "t8ijotE",
"tuyauté" => "t8ijote",
"tuyautée" => "t8ijote",
"tuyautées" => "t8ijote",
"tuyautent" => "t8ijot",
"tuyauter" => "t8ijote",
"tuyautera" => "t8ijot°Ra",
"tuyauterie" => "t8ijot°Ri",
"tuyauteries" => "t8ijot°Ri",
"tuyautés" => "t8ijote",
"tuyauteur" => "t8ijot9R",
"tuyauteurs" => "t8ijot9R",
"tuyaux" => "t8ijo",
"tuyère" => "t8ijER",
"tuyères" => "t8ijER",
"tweed" => "twid",
"tweeds" => "twid",
"twill" => "twil",
"twin-set" => "twinsEt",
"twist" => "twist",
"twistant" => "twist@",
"twistées" => "twiste",
"twister" => "twiste",
"twists" => "twis",
"tympan" => "t5p@",
"tympanique" => "t5panik",
"tympanon" => "t5pan§",
"tympans" => "t5p@",
"type" => "tip",
"typé" => "tipe",
"typée" => "tipe",
"typer" => "tipe",
"types" => "tip",
"typés" => "tipe",
"typhique" => "tifik",
"typhiques" => "tifik",
"typhoïde" => "tifoid",
"typhon" => "tif§",
"typhons" => "tif§",
"typhus" => "tifys",
"typique" => "tipik",
"typiquement" => "tipik°m@",
"typiques" => "tipik",
"typo" => "tipo",
"typographe" => "tipogRaf",
"typographes" => "tipogRaf",
"typographie" => "tipogRafi",
"typographier" => "tipogRafje",
"typographique" => "tipogRafik",
"typographiques" => "tipogRafik",
"typologie" => "tipoloZi",
"typomètre" => "tipomEtR",
"typos" => "tipo",
"tyran" => "tiR@",
"tyranneau" => "tiRano",
"tyranneaux" => "tiRano",
"tyrannicide" => "tiRanisid",
"tyrannicides" => "tiRanisid",
"tyrannie" => "tiRani",
"tyrannies" => "tiRani",
"tyrannique" => "tiRanik",
"tyranniquement" => "tiRanik°m@",
"tyranniques" => "tiRanik",
"tyrannisais" => "tiRanizE",
"tyrannisait" => "tiRanizE",
"tyrannisant" => "tiRaniz@",
"tyrannise" => "tiRaniz",
"tyrannisé" => "tiRanize",
"tyrannisée" => "tiRanize",
"tyrannisent" => "tiRaniz",
"tyranniser" => "tiRanize",
"tyrannisèrent" => "tiRanizER",
"tyrannosaure" => "tiRanozoR",
"tyrannosaures" => "tiRanozoR",
"tyrans" => "tiR@",
"tyrienne" => "tiRjEn",
"tyrolien" => "tiRolj5",
"tyrolienne" => "tiRoljEn",
"tyroliennes" => "tiRoljEn",
"tyroliens" => "tiRolj5",
"tyrrhénienne" => "tiRenjEn",
"tzar" => "tsaR",
"tzarevitch" => "tsaRevitS",
"tzarine" => "tsaRin",
"tzars" => "tsaR",
"tzigane" => "tsigan",
"tziganes" => "tsigan",
"u" => "y",
"ubac" => "ybak",
"ubique" => "ybik",
"ubiquiste" => "ybik8ist",
"ubiquitaire" => "ybik8itER",
"ubiquité" => "ybik8ite",
"ubuesque" => "ybyEsk",
"ufologie" => "yfOlOZi",
"uhlan" => "yl@",
"uhlans" => "yl@",
"uht" => "yt",
"ukase" => "ykaz",
"ukases" => "ykaz",
"ukrainien" => "ykREnj5",
"ukrainienne" => "ykREnjEn",
"ukrainiennes" => "ykREnjEn",
"ukrainiens" => "ykREnj5",
"ukulélé" => "ykylele",
"ulcéra" => "ylseRa",
"ulcérait" => "ylseRE",
"ulcérant" => "ylseR@",
"ulcérations" => "ylseRasj§",
"ulcérative" => "ylseRativ",
"ulcère" => "ylsER",
"ulcéré" => "ylseRe",
"ulcérée" => "ylseRe",
"ulcérées" => "ylseRe",
"ulcères" => "ylsER",
"ulcérés" => "ylseRe",
"ulcéreuse" => "ylseR2z",
"ulcéreuses" => "ylseR2z",
"ulcéreux" => "ylseR2",
"ulna" => "ylna",
"ulnaire" => "ylnER",
"ultérieur" => "ylteRj9R",
"ultérieure" => "ylteRj9R",
"ultérieurement" => "ylteRj9R°m@",
"ultérieures" => "ylteRj9R",
"ultérieurs" => "ylteRj9R",
"ultima ratio" => "yltimaRasjo",
"ultimatum" => "yltimatOm",
"ultimatums" => "yltimatOm",
"ultime" => "yltim",
"ultimement" => "yltim°m@",
"ultimes" => "yltim",
"ultimo" => "yltimo",
"ultra" => "yltRa",
"ultra-catholique" => "yltRakatOlik",
"ultra-chic" => "yltRaSik",
"ultra-chics" => "yltRaSik",
"ultra-courtes" => "yltRakuRt",
"ultra-courts" => "yltRakuR",
"ultra-gauche" => "yltRagoS",
"ultra-rapide" => "yltRaRapid",
"ultra-secret" => "yltRas2kRE",
"ultra-sensible" => "yltRas@sibl",
"ultra-sons" => "yltRas§",
"ultra-violet" => "yl°tRavjolE",
"ultra-violets" => "yl°tRavjolE",
"ultrafin" => "yltRaf5",
"ultragauche" => "yltRagoS",
"ultraléger" => "yltRaleZe",
"ultramarine" => "yltRamaRin",
"ultramoderne" => "yltRamodERn",
"ultramodernes" => "yltRamodERn",
"ultramontain" => "yltRam§t5",
"ultramontains" => "yltRam§t5",
"ultraperformant" => "yltRapERfORm@",
"ultrarapide" => "yltRaRapid",
"ultrarapides" => "yltRaRapid",
"ultras" => "yltRa",
"ultrasecret" => "yltRaz°kRE",
"ultrasecrète" => "yltRaz°kREt",
"ultrasensible" => "yltRas@sibl",
"ultrasensibles" => "yltRas@sibl",
"ultrason" => "yltRas§",
"ultrasonique" => "yltRasonik",
"ultrasons" => "yltRas§",
"ultraviolet" => "yl°tRavjolE",
"ultraviolets" => "yl°tRavjolE",
"ultraviolette" => "yl°tRavjolEt",
"ultraviolettes" => "yl°tRavjolEt",
"ultravirus" => "yltRaviRys",
"ulula" => "ylyla",
"ululait" => "ylylE",
"ululant" => "ylyl@",
"ulule" => "ylyl",
"ululement" => "ylyl°m@",
"ululements" => "ylyl°m@",
"ululer" => "ylyle",
"umbanda" => "umb@da",
"un" => "1",
"unanime" => "ynanim",
"unanimement" => "ynanim°m@",
"unanimes" => "ynanim",
"unanimisme" => "ynanimizm",
"unanimité" => "ynanimite",
"unau" => "yno",
"underground" => "9nd9RgRawnd",
"une" => "yn",
"unes" => "yn",
"unetelle" => "yn°tEl",
"unguéal" => "§g8eal",
"uni" => "yni",
"uniate" => "ynjat",
"unicellulaire" => "ynisElylER",
"unicité" => "ynisite",
"unicorne" => "ynikORn",
"unidimensionnel" => "ynidim@sjonEl",
"unidimensionnelle" => "ynidim@sjOnEl",
"unidirectionnel" => "ynidiREksjonEl",
"unidirectionnelle" => "ynidiREksjonEl",
"unidirectionnels" => "ynidiREksjonEl",
"unie" => "yni",
"unième" => "ynjEm",
"unies" => "yni",
"unification" => "ynifikasj§",
"unificatrice" => "ynifikatRis",
"unifie" => "ynifi",
"unifié" => "ynifje",
"unifiée" => "ynifje",
"unifiées" => "ynifje",
"unifient" => "ynifi",
"unifier" => "ynifje",
"unifiés" => "ynifje",
"unifiez" => "ynifje",
"uniforme" => "ynifORm",
"uniformément" => "ynifORmem@",
"uniformes" => "ynifORm",
"uniformisait" => "ynifORmizE",
"uniformisation" => "ynifORmizasj§",
"uniformise" => "ynifORmiz",
"uniformisée" => "ynifORmize",
"uniformiser" => "ynifORmize",
"uniformisés" => "ynifORmize",
"uniformité" => "ynifORmite",
"unijambiste" => "yniZ@bist",
"unijambistes" => "yniZ@bist",
"unilatéral" => "ynilateRal",
"unilatérale" => "ynilateRal",
"unilatéralement" => "ynilateRal°m@",
"unilatérales" => "ynilateRal",
"unilatéralité" => "ynilateRalite",
"unilatéraux" => "ynilateRo",
"uniment" => "ynim@",
"uninominal" => "yninominal",
"uninominales" => "yninominal",
"union" => "ynj§",
"unioniste" => "ynjonist",
"unionistes" => "ynjonist",
"unions" => "ynj§",
"uniprix" => "ynipRi",
"unique" => "ynik",
"uniquement" => "ynik°m@",
"uniques" => "ynik",
"unir" => "yniR",
"unira" => "yniRa",
"unirai" => "yniRE",
"uniraient" => "yniRE",
"unirait" => "yniRE",
"unirent" => "yniR",
"unirez" => "yniRe",
"unirions" => "yniRj§",
"unirons" => "yniR§",
"uniront" => "yniR§",
"unis" => "yni",
"unisexe" => "ynisEks",
"unisexes" => "ynisEks",
"unissaient" => "ynisE",
"unissais" => "ynisE",
"unissait" => "ynisE",
"unissant" => "ynis@",
"unisse" => "ynis",
"unissent" => "ynis",
"unisses" => "ynis",
"unissez" => "ynise",
"unissiez" => "ynisje",
"unissions" => "ynisj§",
"unisson" => "ynis§",
"unissons" => "ynis§",
"unit" => "yni",
"unît" => "yni",
"unitaire" => "ynitER",
"unitarien" => "ynitaRj5",
"unitarienne" => "ynitaRjEn",
"unité" => "ynite",
"unités" => "ynite",
"univalves" => "ynivalv",
"univers" => "ynivER",
"universal" => "ynivERsal",
"universalisais" => "ynivERsalizE",
"universalise" => "ynivERsaliz",
"universalisme" => "ynivERsalizm",
"universaliste" => "ynivERsalist",
"universalité" => "ynivERsalite",
"universel" => "ynivERsEl",
"universelle" => "ynivERsEl",
"universellement" => "ynivERsEl°m@",
"universelles" => "ynivERsEl",
"universels" => "ynivERsEl",
"universitaire" => "ynivERsitER",
"universitaires" => "ynivERsitER",
"université" => "ynivERsite",
"universités" => "ynivERsite",
"univoque" => "ynivOk",
"uns" => "1",
"untel" => "1tEl",
"upanisads" => "ypanizad",
"upanishad" => "ypaniSa",
"upas" => "ypas",
"update" => "9pdajt",
"updater" => "9pdate",
"upgradée" => "9pgRade",
"uppercut" => "ypERkyt",
"uppercuts" => "ypERkyt",
"urane" => "yRan",
"uraniens" => "yRanj5",
"uranisme" => "yRanizm",
"uraniste" => "yRanist",
"uranium" => "yRanjOm",
"urbain" => "yRb5",
"urbaine" => "yRbEn",
"urbaines" => "yRbEn",
"urbains" => "yRb5",
"urbanisation" => "yRbanizasj§",
"urbanisé" => "yRbanize",
"urbanisée" => "yRbanize",
"urbanisme" => "yRbanizm",
"urbaniste" => "yRbanist",
"urbanistes" => "yRbanist",
"urbanité" => "yRbanite",
"urbi et orbi" => "uRbiEtORbi",
"urdu" => "yRdy",
"urée" => "yRe",
"urémie" => "yRemi",
"urémique" => "yRemik",
"ures" => "yR",
"uretère" => "yR°tER",
"uréthane" => "yRetan",
"urètre" => "yREtR",
"urétrite" => "yRetRit",
"urf" => "yRf",
"urge" => "yRZ",
"urgeait" => "yRZE",
"urgemment" => "yRZam@",
"urgence" => "yRZ@s",
"urgences" => "yRZ@s",
"urgent" => "yRZ@",
"urgente" => "yRZ@t",
"urgentes" => "yRZ@t",
"urgentissime" => "yRZ@tisim",
"urgentiste" => "yRZ@tist",
"urgents" => "yRZ@",
"urger" => "yRZe",
"urina" => "yRina",
"urinaient" => "yRinE",
"urinaire" => "yRinER",
"urinaires" => "yRinER",
"urinais" => "yRinE",
"urinait" => "yRinE",
"urinal" => "yRinal",
"urinant" => "yRin@",
"urine" => "yRin",
"uriné" => "yRine",
"urinent" => "yRin",
"uriner" => "yRine",
"urinera" => "yRin°Ra",
"urines" => "yRin",
"urineuse" => "yRin2z",
"urinez" => "yRine",
"urinoir" => "yRinwaR",
"urinoirs" => "yRinwaR",
"urinons" => "yRin§",
"urique" => "yRik",
"urne" => "yRn",
"urnes" => "yRn",
"urographie" => "yRogRafi",
"urokinase" => "yRokinaz",
"urologie" => "yRoloZi",
"urologique" => "yROlOZik",
"urologue" => "yRolOg",
"uroscopie" => "yRoskopi",
"ursuline" => "yRsylin",
"ursulines" => "yRsylin",
"urticaire" => "yRtikER",
"urticante" => "yRtik@t",
"urticantes" => "yRtik@t",
"urticants" => "yRtik@",
"urubu" => "yRyby",
"urubus" => "yRyby",
"uruguayen" => "yRygwEj5",
"urus" => "yRys",
"us" => "ys",
"usa" => "yza",
"usage" => "yzaZ",
"usagé" => "yzaZe",
"usagée" => "yzaZe",
"usagées" => "yzaZe",
"usager" => "yzaZe",
"usagères" => "yzaZER",
"usagers" => "yzaZe",
"usages" => "yzaZ",
"usagés" => "yzaZe",
"usai" => "yzE",
"usaient" => "yzE",
"usais" => "yzE",
"usait" => "yzE",
"usant" => "yz@",
"usante" => "yz@t",
"usât" => "yza",
"use" => "yz",
"usé" => "yze",
"usée" => "yze",
"usées" => "yze",
"usent" => "yz",
"user" => "yze",
"usera" => "yz°Ra",
"userai" => "yz°RE",
"userais" => "yz°RE",
"userait" => "yz°RE",
"usèrent" => "yzER",
"useriez" => "yz°Rje",
"userons" => "yz°R§",
"useront" => "yz°R§",
"uses" => "yz",
"usés" => "yze",
"usez" => "yze",
"usinage" => "yzinaZ",
"usinaient" => "yzinE",
"usinant" => "yzin@",
"usine" => "yzin",
"usiné" => "yzine",
"usine-pilote" => "yzinpilOt",
"usinée" => "yzine",
"usinées" => "yzine",
"usiner" => "yzine",
"usines" => "yzin",
"usinés" => "yzine",
"usinier" => "yzinje",
"usinière" => "yzinjER",
"usiniers" => "yzinje",
"usions" => "yzj§",
"usité" => "yzite",
"usités" => "yzite",
"usons" => "yz§",
"ustensile" => "yst@sil",
"ustensiles" => "yst@sil",
"ustion" => "ystj§",
"usuel" => "yz8El",
"usuelle" => "yz8El",
"usuellement" => "yz8El°m@",
"usuelles" => "yz8El",
"usuels" => "yz8El",
"usufruit" => "yzyfR8i",
"usufruitier" => "yzyfR8itje",
"usuraire" => "yzyRER",
"usuraires" => "yzyRER",
"usure" => "yzyR",
"usures" => "yzyR",
"usurier" => "yzyRje",
"usurière" => "yzyRjER",
"usuriers" => "yzyRje",
"usurpaient" => "yzyRpE",
"usurpait" => "yzyRpE",
"usurpant" => "yzyRp@",
"usurpateur" => "yzyRpat9R",
"usurpateurs" => "yzyRpat9R",
"usurpation" => "yzyRpasj§",
"usurpatrice" => "yzyRpatRis",
"usurpé" => "yzyRpe",
"usurpée" => "yzyRpe",
"usurpées" => "yzyRpe",
"usurpent" => "yzyRp",
"usurper" => "yzyRpe",
"usurperont" => "yzyRp°R§",
"usurpés" => "yzyRpe",
"ut" => "yt",
"utérin" => "yteR5",
"utérine" => "yteRin",
"utérines" => "yteRin",
"utérins" => "yteR5",
"utérus" => "yteRys",
"utile" => "ytil",
"utilement" => "ytil°m@",
"utiles" => "ytil",
"utilisa" => "ytiliza",
"utilisable" => "ytilizabl",
"utilisables" => "ytilizabl",
"utilisai" => "ytilizE",
"utilisaient" => "ytilizE",
"utilisais" => "ytilizE",
"utilisait" => "ytilizE",
"utilisant" => "ytiliz@",
"utilisât" => "ytiliza",
"utilisateur" => "ytilizat9R",
"utilisateurs" => "ytilizat9R",
"utilisation" => "ytilizasj§",
"utilisations" => "ytilizasj§",
"utilisatrice" => "ytilizatRis",
"utilise" => "ytiliz",
"utilisé" => "ytilize",
"utilisée" => "ytilize",
"utilisées" => "ytilize",
"utilisent" => "ytiliz",
"utiliser" => "ytilize",
"utilisera" => "ytiliz°Ra",
"utiliserai" => "ytiliz°RE",
"utiliseraient" => "ytiliz°RE",
"utiliserais" => "ytiliz°RE",
"utiliserait" => "ytiliz°RE",
"utiliseras" => "ytiliz°Ra",
"utilisèrent" => "ytilizER",
"utiliserez" => "ytiliz°Re",
"utiliseriez" => "ytiliz°Rje",
"utiliserions" => "ytiliz°Rj§",
"utiliserons" => "ytiliz°R§",
"utiliseront" => "ytiliz°R§",
"utilises" => "ytiliz",
"utilisés" => "ytilize",
"utilisez" => "ytilize",
"utilisiez" => "ytilizje",
"utilisions" => "ytilizj§",
"utilisons" => "ytiliz§",
"utilitaire" => "ytilitER",
"utilitaires" => "ytilitER",
"utilitarisme" => "ytilitaRizm",
"utilité" => "ytilite",
"utilités" => "ytilite",
"utopie" => "ytopi",
"utopies" => "ytopi",
"utopique" => "ytopik",
"utopiques" => "ytopik",
"utopiste" => "ytopist",
"utopistes" => "ytopist",
"uxorilocal" => "yksoRilokal",
"v" => "ve",
"va" => "va",
"va-et-vient" => "vaevj5",
"va-tout" => "vatu",
"vacance" => "vak@s",
"vacances" => "vak@s",
"vacancier" => "vak@sje",
"vacancière" => "vak@sjER",
"vacancières" => "vak@sjER",
"vacanciers" => "vak@sje",
"vacant" => "vak@",
"vacante" => "vak@t",
"vacantes" => "vak@t",
"vacants" => "vak@",
"vacarme" => "vakaRm",
"vacarmes" => "vakaRm",
"vacataire" => "vakatER",
"vacation" => "vakasj§",
"vacations" => "vakasj§",
"vaccin" => "vaks5",
"vaccinal" => "vaksinal",
"vaccinant" => "vaksin@",
"vaccination" => "vaksinasj§",
"vaccinations" => "vaksinasj§",
"vaccine" => "vaksin",
"vacciné" => "vaksine",
"vaccinée" => "vaksine",
"vaccinées" => "vaksine",
"vaccinent" => "vaksin",
"vacciner" => "vaksine",
"vaccinés" => "vaksine",
"vaccins" => "vaks5",
"vachard" => "vaSaR",
"vacharde" => "vaSaRd",
"vachardes" => "vaSaRd",
"vachardise" => "vaSaRdiz",
"vachards" => "vaSaR",
"vache" => "vaS",
"vachement" => "vaS°m@",
"vacher" => "vaSe",
"vachère" => "vaSER",
"vachères" => "vaSER",
"vacherie" => "vaS°Ri",
"vacheries" => "vaS°Ri",
"vacherin" => "vaS°R5",
"vachers" => "vaSe",
"vaches" => "vaS",
"vachette" => "vaSEt",
"vachettes" => "vaSEt",
"vacilla" => "vasija",
"vacillai" => "vasijE",
"vacillaient" => "vasijE",
"vacillait" => "vasijE",
"vacillant" => "vasij@",
"vacillante" => "vasij@t",
"vacillantes" => "vasij@t",
"vacillants" => "vasij@",
"vacillât" => "vasija",
"vacillations" => "vasijasj§",
"vacille" => "vasij",
"vacillé" => "vasije",
"vacillement" => "vasij°m@",
"vacillent" => "vasij",
"vaciller" => "vasije",
"vacillèrent" => "vasijER",
"vacuité" => "vak8ite",
"vacuole" => "vak8Ol",
"vacuolisation" => "vak8Olizasj§",
"vacuum" => "vak8Om",
"vade retro" => "vadeRetRo",
"vadrouillais" => "vadRujE",
"vadrouillait" => "vadRujE",
"vadrouille" => "vadRuj",
"vadrouillé" => "vadRuje",
"vadrouillent" => "vadRuj",
"vadrouiller" => "vadRuje",
"vadrouilles" => "vadRuj",
"vadrouilleur" => "vadRuj9R",
"vadrouilleurs" => "vadRuj9R",
"vadrouilleuse" => "vadRuj2z",
"vadrouilleuses" => "vadRuj2z",
"vadrouillez" => "vadRuje",
"vae soli" => "vaesoli",
"vae victis" => "vaeviktis",
"vagabond" => "vagab§",
"vagabonda" => "vagab§da",
"vagabondage" => "vagab§daZ",
"vagabondages" => "vagab§daZ",
"vagabondaient" => "vagab§dE",
"vagabondais" => "vagab§dE",
"vagabondait" => "vagab§dE",
"vagabondant" => "vagab§d@",
"vagabonde" => "vagab§d",
"vagabondé" => "vagab§de",
"vagabondent" => "vagab§d",
"vagabonder" => "vagab§de",
"vagabondèrent" => "vagab§dER",
"vagabondes" => "vagab§d",
"vagabondiez" => "vagab§dje",
"vagabonds" => "vagab§",
"vagal" => "vagal",
"vagi" => "vaZi",
"vagin" => "vaZ5",
"vaginal" => "vaZinal",
"vaginale" => "vaZinal",
"vaginales" => "vaZinal",
"vaginaux" => "vaZino",
"vaginite" => "vaZinit",
"vagins" => "vaZ5",
"vagir" => "vaZiR",
"vagis" => "vaZi",
"vagissaient" => "vaZisE",
"vagissais" => "vaZisE",
"vagissait" => "vaZisE",
"vagissant" => "vaZis@",
"vagissement" => "vaZis°m@",
"vagissements" => "vaZis°m@",
"vagissent" => "vaZis",
"vagissons" => "vaZis§",
"vagit" => "vaZi",
"vagotomie" => "vagOtOmi",
"vagua" => "vaga",
"vaguait" => "vagE",
"vaguant" => "vag@",
"vague" => "vag",
"vaguelette" => "vag°lEt",
"vaguelettes" => "vag°lEt",
"vaguement" => "vag°m@",
"vaguemestre" => "vag°mEstR",
"vaguent" => "vag",
"vaguer" => "vage",
"vagues" => "vag",
"vahiné" => "vaine",
"vahinés" => "vaine",
"vaillamment" => "vajam@",
"vaillance" => "vaj@s",
"vaillant" => "vaj@",
"vaillante" => "vaj@t",
"vaillantes" => "vaj@t",
"vaillants" => "vaj@",
"vaille" => "vaj",
"vaillent" => "vaj",
"vain" => "v5",
"vainc" => "v5k",
"vaincra" => "v5kRa",
"vaincrai" => "v5kRE",
"vaincraient" => "v5kRE",
"vaincrais" => "v5kRE",
"vaincrait" => "v5kRE",
"vaincras" => "v5kRa",
"vaincre" => "v5kR",
"vaincrez" => "v5kRe",
"vaincrons" => "v5kR§",
"vaincront" => "v5kR§",
"vaincs" => "v5k",
"vaincu" => "v5ky",
"vaincue" => "v5ky",
"vaincues" => "v5ky",
"vaincus" => "v5ky",
"vaine" => "vEn",
"vainement" => "vEn°m@",
"vaines" => "vEn",
"vainquant" => "v5k@",
"vainquent" => "v5k",
"vainqueur" => "v5k9R",
"vainqueurs" => "v5k9R",
"vainquez" => "v5ke",
"vainquions" => "v5kj§",
"vainquirent" => "v5kiR",
"vainquit" => "v5ki",
"vainquons" => "v5k§",
"vains" => "v5",
"vair" => "vER",
"vairon" => "vER§",
"vairons" => "vER§",
"vais" => "vE",
"vaisseau" => "vEso",
"vaisseau-amiral" => "vEsoamiRal",
"vaisseaux" => "vEso",
"vaisselier" => "vEs°lje",
"vaisseliers" => "vEs°lje",
"vaisselle" => "vEsEl",
"vaisselles" => "vEsEl",
"val" => "val",
"valable" => "valabl",
"valablement" => "valabl°m@",
"valables" => "valabl",
"valaient" => "valE",
"valais" => "valE",
"valait" => "valE",
"valant" => "val@",
"valaque" => "valak",
"valdingua" => "vald5ga",
"valdingue" => "vald5g",
"valdingué" => "vald5ge",
"valdinguer" => "vald5ge",
"valdingues" => "vald5g",
"valdingués" => "vald5ge",
"valdôtains" => "valdot5",
"valence" => "val@s",
"valencien" => "val@sj5",
"valencienne" => "val@sjEn",
"valent" => "val",
"valentin" => "val@t5",
"valentine" => "val@tin",
"valentinien" => "val@tinj5",
"valériane" => "valeRjan",
"valet" => "valE",
"valetaille" => "val°taj",
"valeter" => "val°te",
"valets" => "valE",
"valétudinaire" => "valetydinER",
"valeur" => "val9R",
"valeur-refuge" => "val9RR°fyZ",
"valeureuse" => "val2R2z",
"valeureusement" => "val9R2z°m@",
"valeureuses" => "val2R2z",
"valeureux" => "val2R2",
"valeurs" => "val9R",
"valez" => "vale",
"valgus" => "valgys",
"valida" => "valida",
"validait" => "validE",
"validant" => "valid@",
"validation" => "validasj§",
"valide" => "valid",
"validé" => "valide",
"validée" => "valide",
"valident" => "valid",
"valider" => "valide",
"valideront" => "valid°R§",
"valides" => "valid",
"validité" => "validite",
"valiez" => "valje",
"valions" => "valj§",
"valise" => "valiz",
"valisé" => "valize",
"valises" => "valiz",
"valkyries" => "valkiRi",
"vallée" => "vale",
"vallées" => "vale",
"valleuse" => "val2z",
"vallon" => "val§",
"vallonnaient" => "valonE",
"vallonnait" => "valonE",
"vallonné" => "valone",
"vallonnée" => "valone",
"vallonnées" => "valone",
"vallonnement" => "valOn°m@",
"vallonnements" => "valOn°m@",
"vallonner" => "valone",
"vallonnés" => "valone",
"vallons" => "val§",
"valoche" => "valOS",
"valoches" => "valOS",
"valoir" => "valwaR",
"valons" => "val§",
"valorisait" => "valoRizE",
"valorisant" => "valoRiz@",
"valorisante" => "valORiz@t",
"valorisation" => "valoRizasj§",
"valorise" => "valoRiz",
"valorisé" => "valoRize",
"valorisée" => "valoRize",
"valoriser" => "valoRize",
"valorisés" => "valoRize",
"valorisez" => "valoRize",
"valpolicella" => "valpolitSEla",
"vals" => "val",
"valsa" => "valsa",
"valsaient" => "valsE",
"valsait" => "valsE",
"valsant" => "vals@",
"valse" => "vals",
"valsé" => "valse",
"valse-hésitation" => "valsezitasj§",
"valsent" => "vals",
"valser" => "valse",
"valsera" => "vals°Ra",
"valsèrent" => "valsER",
"valses" => "vals",
"valses-hésitations" => "valsezitasj§",
"valseur" => "vals9R",
"valseurs" => "vals9R",
"valseuse" => "vals2z",
"valseuses" => "vals2z",
"valsez" => "valse",
"valsons" => "vals§",
"valu" => "valy",
"value" => "valy",
"values" => "valy",
"valurent" => "valyR",
"valut" => "valy",
"valût" => "valy",
"valve" => "valv",
"valves" => "valv",
"valvulaires" => "valvylER",
"valvule" => "valvyl",
"vamp" => "v@p",
"vamp-club" => "v@pkl9b",
"vampe" => "v@p",
"vampé" => "v@pe",
"vamper" => "v@pe",
"vampire" => "v@piR",
"vampires" => "v@piR",
"vampirique" => "v@piRik",
"vampirisant" => "v@piRiz@",
"vampirise" => "v@piRiz",
"vampirisé" => "v@piRize",
"vampirisée" => "v@piRize",
"vampirisées" => "v@piRize",
"vampirisme" => "v@piRizm",
"vamps" => "v@p",
"van" => "van",
"vanadium" => "vanadjOm",
"vandale" => "v@dal",
"vandales" => "v@dal",
"vandalisé" => "v@dalize",
"vandalisent" => "v@daliz",
"vandaliser" => "v@dalize",
"vandalisme" => "v@dalizm",
"vandoises" => "v@dwaz",
"vanille" => "vanij",
"vanillé" => "vanije",
"vanillée" => "vanije",
"vanillées" => "vanije",
"vanité" => "vanite",
"vanités" => "vanite",
"vaniteuse" => "vanit2z",
"vaniteusement" => "vanit2z°m@",
"vaniteuses" => "vanit2z",
"vaniteux" => "vanit2",
"vanity-case" => "vanitikEjs",
"vanna" => "vana",
"vannais" => "vanE",
"vannait" => "vanE",
"vanne" => "van",
"vanné" => "vane",
"vanneau" => "vano",
"vanneaux" => "vano",
"vannée" => "vane",
"vannent" => "van",
"vanner" => "vane",
"vannèrent" => "vanER",
"vannerie" => "van°Ri",
"vanneries" => "van°Ri",
"vannes" => "van",
"vannés" => "vane",
"vanneur" => "van9R",
"vanneurs" => "van9R",
"vannier" => "vanje",
"vannières" => "vanjER",
"vanniers" => "vanje",
"vans" => "van",
"vanta" => "v@ta",
"vantai" => "v@tE",
"vantaient" => "v@tE",
"vantail" => "v@taj",
"vantais" => "v@tE",
"vantait" => "v@tE",
"vantant" => "v@t@",
"vantard" => "v@taR",
"vantarde" => "v@taRd",
"vantardes" => "v@taRd",
"vantardise" => "v@taRdiz",
"vantardises" => "v@taRdiz",
"vantards" => "v@taR",
"vantât" => "v@ta",
"vantaux" => "v@to",
"vante" => "v@t",
"vanté" => "v@te",
"vantée" => "v@te",
"vantées" => "v@te",
"vantent" => "v@t",
"vanter" => "v@te",
"vantera" => "v@t°Ra",
"vanterai" => "v@t°RE",
"vanterais" => "v@t°RE",
"vanterait" => "v@t°RE",
"vanteras" => "v@t°Ra",
"vanterie" => "v@t°Ri",
"vanteries" => "v@t°Ri",
"vanteront" => "v@t°R§",
"vantes" => "v@t",
"vantés" => "v@te",
"vantez" => "v@te",
"vantiez" => "v@tje",
"vantions" => "v@tj§",
"vantons" => "v@t§",
"vape" => "vap",
"vapes" => "vap",
"vapeur" => "vap9R",
"vapeurs" => "vap9R",
"vaporetto" => "vapoREto",
"vaporeuse" => "vapoR2z",
"vaporeuses" => "vapoR2z",
"vaporeux" => "vapoR2",
"vaporisa" => "vapoRiza",
"vaporisais" => "vapoRizE",
"vaporisait" => "vapoRizE",
"vaporisant" => "vapoRiz@",
"vaporisateur" => "vapoRizat9R",
"vaporisateurs" => "vapoRizat9R",
"vaporisation" => "vapoRizasj§",
"vaporisations" => "vapoRizasj§",
"vaporise" => "vapoRiz",
"vaporisé" => "vapoRize",
"vaporisée" => "vapoRize",
"vaporiser" => "vapoRize",
"vaporiserait" => "vapoRiz°RE",
"vaporises" => "vapoRiz",
"vaporisez" => "vapoRize",
"vaps" => "vap",
"vaquai" => "vakE",
"vaquaient" => "vakE",
"vaquais" => "vakE",
"vaquait" => "vakE",
"vaquant" => "vak@",
"vaque" => "vak",
"vaqué" => "vake",
"vaquent" => "vak",
"vaquer" => "vake",
"vaquerait" => "vak°RE",
"vaquero" => "vakeRo",
"vaqueros" => "vakeRo",
"vaquions" => "vakj§",
"vaquons" => "vak§",
"var" => "vaR",
"vara" => "vaRa",
"varan" => "vaR@",
"varans" => "vaR@",
"varappe" => "vaRap",
"varapper" => "vaRape",
"varappeur" => "vaRap9R",
"varech" => "vaREk",
"varechs" => "vaREk",
"varenne" => "vaREn",
"varennes" => "vaREn",
"vareuse" => "vaR2z",
"vareuses" => "vaR2z",
"varia" => "vaRja",
"variabilité" => "vaRjabilite",
"variable" => "vaRjabl",
"variables" => "vaRjabl",
"variaient" => "vaRjE",
"variais" => "vaRjE",
"variait" => "vaRjE",
"variance" => "vaRj@s",
"variant" => "vaRj@",
"variante" => "vaRj@t",
"variantes" => "vaRj@t",
"variât" => "vaRja",
"variateur" => "vaRjat9R",
"variation" => "vaRjasj§",
"variations" => "vaRjasj§",
"varice" => "vaRis",
"varicelle" => "vaRisEl",
"varices" => "vaRis",
"varie" => "vaRi",
"varié" => "vaRje",
"variée" => "vaRje",
"variées" => "vaRje",
"varient" => "vaRi",
"varier" => "vaRje",
"varierai" => "vaRiRE",
"varieraient" => "vaRiRE",
"varierait" => "vaRiRE",
"varieront" => "vaRiR§",
"variés" => "vaRje",
"variétal" => "vaRjetal",
"variété" => "vaRjete",
"variétés" => "vaRjete",
"variole" => "vaRjOl",
"variorum" => "vaRjoROm",
"variqueuses" => "vaRik2z",
"variqueux" => "vaRik2",
"varlet" => "vaRlE",
"varlope" => "vaRlOp",
"varon" => "vaR§",
"varsovien" => "vaRsOvj5",
"vas" => "va",
"vasa" => "vaza",
"vasais" => "vazE",
"vasait" => "vazE",
"vasards" => "vazaR",
"vasculaire" => "vaskylER",
"vasculaires" => "vaskylER",
"vascularisé" => "vaskylaRize",
"vasculo-nerveux" => "vaskylonERv2",
"vase" => "vaz",
"vasectomie" => "vazEktomi",
"vaseline" => "vaz°lin",
"vaseliné" => "vaz°line",
"vaseliner" => "vaz°line",
"vaselinez" => "vazEline",
"vaser" => "vaze",
"vases" => "vaz",
"vaseuse" => "vaz2z",
"vaseuses" => "vaz2z",
"vaseux" => "vaz2",
"vasière" => "vazjER",
"vasières" => "vazjER",
"vasistas" => "vazistas",
"vasoconstricteur" => "vazok§stRikt9R",
"vasoconstriction" => "vazok§stRiksj§",
"vasodilatateur" => "vazodilatat9R",
"vasodilatation" => "vazodilatasj§",
"vasomoteurs" => "vazomot9R",
"vasopressine" => "vazopResin",
"vasouillard" => "vazujaR",
"vasouillarde" => "vazujaRd",
"vasouille" => "vazuj",
"vasouiller" => "vazuje",
"vasouilles" => "vazuj",
"vasque" => "vask",
"vasques" => "vask",
"vassal" => "vasal",
"vassale" => "vasal",
"vassalité" => "vasalite",
"vassaux" => "vaso",
"vaste" => "vast",
"vastes" => "vast",
"vastité" => "vastite",
"vastitude" => "vastityd",
"vastitudes" => "vastityd",
"vater" => "vat9R",
"vatères" => "vatER",
"vaticane" => "vatikan",
"vaticanesque" => "vatikanEsk",
"vaticinait" => "vatisinE",
"vaticinant" => "vatisin@",
"vaticination" => "vatisinasj§",
"vaticinations" => "vatisinasj§",
"vaticine" => "vatisin",
"vaticiner" => "vatisine",
"vau" => "vo",
"vau-l'eau" => "volo",
"vauclusien" => "voklyzj5",
"vauclusiennes" => "voklyzjEn",
"vaudeville" => "vod°vil",
"vaudevilles" => "vod°vil",
"vaudevillesque" => "vod°vilEsk",
"vaudevillesques" => "vod°vilEsk",
"vaudois" => "vodwa",
"vaudoise" => "vodwaz",
"vaudou" => "vodu",
"vaudoue" => "vodu",
"vaudoues" => "vodu",
"vaudouisme" => "voduizm",
"vaudous" => "vodu",
"vaudra" => "vodRa",
"vaudrai" => "vodRE",
"vaudraient" => "vodRE",
"vaudrais" => "vodRE",
"vaudrait" => "vodRE",
"vaudras" => "vodRa",
"vaudrez" => "vodRe",
"vaudrions" => "vodRi§",
"vaudrons" => "vodR§",
"vaudront" => "vodR§",
"vaurien" => "voRj5",
"vaurienne" => "voRjEn",
"vauriens" => "voRj5",
"vaut" => "vo",
"vautour" => "votuR",
"vautours" => "votuR",
"vautra" => "votRa",
"vautraient" => "votRE",
"vautrais" => "votRE",
"vautrait" => "votRE",
"vautrant" => "votR@",
"vautre" => "votR",
"vautré" => "votRe",
"vautrée" => "votRe",
"vautrées" => "votRe",
"vautrent" => "votR",
"vautrer" => "votRe",
"vautreraient" => "votR°RE",
"vautrerais" => "votR°RE",
"vautrèrent" => "votRER",
"vautrés" => "votRe",
"vautrez" => "votRe",
"vauvert" => "vovER",
"vaux" => "vo",
"vauxhall" => "voksol",
"veau" => "vo",
"veaux" => "vo",
"vécés" => "vese",
"vecteur" => "vEkt9R",
"vecteurs" => "vEkt9R",
"vectoriel" => "vEktORjEl",
"vectorielle" => "vEktoRjEl",
"vécu" => "veky",
"vécue" => "veky",
"vécues" => "veky",
"vécûmes" => "vekym",
"vécurent" => "vekyR",
"vécus" => "veky",
"vécussent" => "vekys",
"vécut" => "veky",
"vécût" => "veky",
"vedettariat" => "v°dEtaRja",
"vedette" => "v°dEt",
"vedettes" => "v°dEt",
"végéta" => "veZeta",
"végétaient" => "veZetE",
"végétais" => "veZetE",
"végétait" => "veZetE",
"végétal" => "veZetal",
"végétale" => "veZetal",
"végétales" => "veZetal",
"végétalien" => "veZetalj5",
"végétalienne" => "veZetaljEn",
"végétalisme" => "veZetalism",
"végétarien" => "veZetaRj5",
"végétarienne" => "veZetaRjEn",
"végétariennes" => "veZetaRjEn",
"végétariens" => "veZetaRj5",
"végétarisme" => "veZetaRizm",
"végétât" => "veZeta",
"végétatif" => "veZetatif",
"végétatifs" => "veZetatif",
"végétation" => "veZetasj§",
"végétations" => "veZetasj§",
"végétative" => "veZetativ",
"végétatives" => "veZetativ",
"végétaux" => "veZeto",
"végète" => "veZEt",
"végété" => "veZete",
"végètent" => "veZEt",
"végéter" => "veZete",
"végéteras" => "veZet°Ra",
"végéterez" => "veZet°Re",
"végètes" => "veZEt",
"végétons" => "veZet§",
"véhémence" => "veem@s",
"véhément" => "veem@",
"véhémente" => "veem@t",
"véhémentement" => "veem@t°m@",
"véhémentes" => "veem@t",
"véhéments" => "veem@",
"véhiculaient" => "veikylE",
"véhiculait" => "veikylE",
"véhiculant" => "veikyl@",
"véhicule" => "veikyl",
"véhiculé" => "veikyle",
"véhiculée" => "veikyle",
"véhiculent" => "veikyl",
"véhiculer" => "veikyle",
"véhicules" => "veikyl",
"véhiculez" => "veikyle",
"veilla" => "vEja",
"veillai" => "vEjE",
"veillaient" => "vEjE",
"veillais" => "vEjE",
"veillait" => "vEjE",
"veillâmes" => "vEjam",
"veillant" => "vEj@",
"veillât" => "vEja",
"veille" => "vEj",
"veillé" => "veje",
"veillée" => "veje",
"veillées" => "veje",
"veillent" => "vEj",
"veiller" => "veje",
"veillera" => "vEj°Ra",
"veillerai" => "vEj°RE",
"veillerais" => "vEj°RE",
"veillerait" => "vEj°RE",
"veilleras" => "vEj°Ra",
"veillèrent" => "vEjER",
"veillerez" => "vEj°Re",
"veillerons" => "vEj°R§",
"veilleront" => "vEj°R§",
"veilles" => "vEj",
"veillés" => "veje",
"veilleur" => "vEj9R",
"veilleurs" => "vEj9R",
"veilleuse" => "vEj2z",
"veilleuses" => "vEj2z",
"veillez" => "vEje",
"veillions" => "vEjj§",
"veillons" => "vEj§",
"veinaient" => "vEnE",
"veinait" => "vEnE",
"veinard" => "vEnaR",
"veinarde" => "vEnaRd",
"veinardes" => "vEnaRd",
"veinards" => "vEnaR",
"veine" => "vEn",
"veiné" => "vene",
"veinée" => "vene",
"veinées" => "vene",
"veinent" => "vEn",
"veines" => "vEn",
"veinés" => "vene",
"veineuse" => "vEn2z",
"veineux" => "vEn2",
"veinule" => "venyl",
"veinulé" => "venyle",
"veinules" => "venyl",
"veinures" => "venyR",
"vêlage" => "vElaZ",
"vêlages" => "vElaZ",
"vélaires" => "velER",
"vélar" => "velaR",
"velcro" => "vElkRo",
"veld" => "vEld",
"veldt" => "vElt",
"vêlé" => "vele",
"vêler" => "vele",
"vélin" => "vel5",
"vélins" => "vel5",
"véliplanchiste" => "velipl@Sist",
"vélique" => "velik",
"vellave" => "vElav",
"velléitaire" => "vEleitER",
"velléité" => "vEleite",
"velléités" => "vEleite",
"vélo" => "velo",
"vélo-cross" => "velokROs",
"vélo-pousse" => "velopus",
"véloce" => "velOs",
"vélocement" => "velOs°m@",
"véloces" => "velOs",
"vélocipède" => "velosipEd",
"vélocipèdes" => "velosipEd",
"vélocipédique" => "velosipedik",
"vélocipédiques" => "velosipedik",
"vélocipédistes" => "velosipedist",
"vélocité" => "velosite",
"vélodrome" => "velodRom",
"vélodromes" => "velodRom",
"vélomoteur" => "velomot9R",
"vélomoteurs" => "velomot9R",
"vélos" => "velo",
"velours" => "v°luR",
"veloutaient" => "v°lutE",
"veloutait" => "v°lutE",
"veloute" => "v°lut",
"velouté" => "v°lute",
"veloutée" => "v°lute",
"veloutées" => "v°lute",
"veloutent" => "v°lut",
"velouter" => "v°lute",
"veloutés" => "v°lute",
"velouteuse" => "v2lut2z",
"velouteux" => "v°lut2",
"velte" => "vElt",
"velu" => "v°ly",
"velue" => "v°ly",
"velues" => "v°ly",
"velum" => "velOm",
"vélum" => "velOm",
"vélums" => "velOm",
"velus" => "v°ly",
"velux" => "v2luks",
"velvet" => "vElvEt",
"venaient" => "v°nE",
"venais" => "v°nE",
"venaison" => "v°nEz§",
"venaisons" => "v°nEz§",
"venait" => "v°nE",
"vénal" => "venal",
"vénale" => "venal",
"vénales" => "venal",
"vénalité" => "venalite",
"venant" => "v°n@",
"vénaux" => "veno",
"vend" => "v@",
"vendable" => "v@dabl",
"vendables" => "v@dabl",
"vendaient" => "v@dE",
"vendais" => "v@dE",
"vendait" => "v@dE",
"vendange" => "v@d@Z",
"vendangé" => "v@d@Ze",
"vendangeait" => "v@d@ZE",
"vendanger" => "v@d@Ze",
"vendanges" => "v@d@Z",
"vendangeur" => "v@d@Z9R",
"vendangeurs" => "v@d@Z9R",
"vendangeuses" => "v@d@Z2z",
"vendant" => "v@d@",
"vende" => "v@d",
"vendéen" => "v@de5",
"vendéenne" => "v@deEn",
"vendéennes" => "v@deEn",
"vendéens" => "v@de5",
"vendémiaire" => "v@demjER",
"vendent" => "v@d",
"vendes" => "v@d",
"vendetta" => "v@dEta",
"vendettas" => "v@dEta",
"vendeur" => "v@d9R",
"vendeurs" => "v@d9R",
"vendeuse" => "v@d2z",
"vendeuses" => "v@d2z",
"vendez" => "v@de",
"vendiez" => "v@dje",
"vendions" => "v@dj§",
"vendirent" => "v@diR",
"vendis" => "v@di",
"vendisse" => "v@dis",
"vendit" => "v@di",
"vendît" => "v@di",
"vendômois" => "v@domwa",
"vendons" => "v@d§",
"vendra" => "v@dRa",
"vendrai" => "v@dRE",
"vendraient" => "v@dRE",
"vendrais" => "v@dRE",
"vendrait" => "v@dRE",
"vendras" => "v@dRa",
"vendre" => "v@dR",
"vendredi" => "v@dR°di",
"vendredis" => "v@dR°di",
"vendrez" => "v@dRe",
"vendriez" => "v@dRie",
"vendrons" => "v@dR§",
"vendront" => "v@dR§",
"vends" => "v@",
"vendu" => "v@dy",
"vendue" => "v@dy",
"vendues" => "v@dy",
"vendus" => "v@dy",
"venelle" => "v°nEl",
"venelles" => "v°nEl",
"vénéneuse" => "venen2z",
"vénéneuses" => "venen2z",
"vénéneux" => "venen2",
"vénérable" => "veneRabl",
"vénérables" => "veneRabl",
"vénérai" => "veneRE",
"vénéraient" => "veneRE",
"vénérais" => "veneRE",
"vénérait" => "veneRE",
"vénérant" => "veneR@",
"vénéras" => "veneRa",
"vénération" => "veneRasj§",
"vénérations" => "veneRasj§",
"vénère" => "venER",
"vénéré" => "veneRe",
"vénérée" => "veneRe",
"vénérées" => "veneRe",
"vénèrent" => "venER",
"vénéréologie" => "veneReoloZi",
"vénérer" => "veneRe",
"vénérera" => "veneR°Ra",
"vénéreraient" => "veneR°RE",
"vénérerais" => "veneR°RE",
"vénères" => "venER",
"vénérés" => "veneRe",
"vénérez" => "veneRe",
"vénerie" => "vEn°Ri",
"vénérien" => "veneRj5",
"vénérienne" => "veneRjEn",
"vénériennes" => "veneRjEn",
"vénériens" => "veneRj5",
"vénérions" => "veneRj§",
"vénérons" => "veneR§",
"venette" => "v°nEt",
"veneur" => "v°n9R",
"veneurs" => "v°n9R",
"venez" => "v°ne",
"vénézuélien" => "venez8elj5",
"vénézuélienne" => "venezyEljEn",
"vénézuéliens" => "venez8elj5",
"venge" => "v@Z",
"vengé" => "v@Ze",
"vengea" => "v@Za",
"vengeai" => "v@ZE",
"vengeaient" => "v@ZE",
"vengeais" => "v@ZE",
"vengeait" => "v@ZE",
"vengeance" => "v@Z@s",
"vengeances" => "v@Z@s",
"vengeant" => "v@Z@",
"vengeât" => "v@Za",
"vengée" => "v@Ze",
"vengées" => "v@Ze",
"vengent" => "v@Z",
"vengeons" => "v@Z§",
"venger" => "v@Ze",
"vengera" => "v@Z°Ra",
"vengerai" => "v@Z°RE",
"vengerais" => "v@Z°RE",
"vengerait" => "v@Z°RE",
"vengèrent" => "v@ZER",
"vengeresse" => "v@Z°REs",
"vengeresses" => "v@Z°REs",
"vengerez" => "v@Z°Re",
"vengerons" => "v@Z°R§",
"vengeront" => "v@Z°R§",
"venges" => "v@Z",
"vengés" => "v@Ze",
"vengeur" => "v@Z9R",
"vengeurs" => "v@Z9R",
"vengez" => "v@Ze",
"vengiez" => "v@Zje",
"véniel" => "venjEl",
"vénielle" => "venjEl",
"vénielles" => "venjEl",
"véniels" => "venjEl",
"veniez" => "v°nje",
"venimeuse" => "v°nim2z",
"venimeusement" => "venim2z°m@",
"venimeuses" => "v°nim2z",
"venimeux" => "v°nim2",
"venin" => "v°n5",
"venins" => "v°n5",
"venions" => "v°nj§",
"venir" => "v°niR",
"venise" => "v2niz",
"vénitien" => "venisj5",
"vénitienne" => "venisjEn",
"vénitiennes" => "venisjEn",
"vénitiens" => "venisj5",
"venons" => "v°n§",
"vent" => "v@",
"venta" => "v@ta",
"ventail" => "v@taj",
"ventas" => "v@ta",
"vente" => "v@t",
"venté" => "v@te",
"ventée" => "v@te",
"ventées" => "v@te",
"venter" => "v@te",
"ventes" => "v@t",
"ventés" => "v@te",
"venteuse" => "v@t2z",
"venteuses" => "v@t2z",
"venteux" => "v@t2",
"ventilant" => "v@til@",
"ventilateur" => "v@tilat9R",
"ventilateurs" => "v@tilat9R",
"ventilation" => "v@tilasj§",
"ventilations" => "v@tilasj§",
"ventile" => "v@til",
"ventilé" => "v@tile",
"ventilée" => "v@tile",
"ventilées" => "v@tile",
"ventiler" => "v@tile",
"ventilés" => "v@tile",
"ventilez" => "v@tile",
"ventilo" => "v@tilo",
"ventilos" => "v@tilo",
"ventis" => "v@ti",
"ventôse" => "v@toz",
"ventouse" => "v@tuz",
"ventousé" => "v@tuze",
"ventousée" => "v@tuze",
"ventousent" => "v@tuz",
"ventouses" => "v@tuz",
"ventral" => "v@tRal",
"ventrale" => "v@tRal",
"ventre" => "v@tR",
"ventre-saint-gris" => "v@tR°s5gRi",
"ventrebleu" => "v@tR°bl2",
"ventrée" => "v@tRe",
"ventrées" => "v@tRe",
"ventres" => "v@tR",
"ventriculaire" => "v@tRikylER",
"ventricule" => "v@tRikyl",
"ventricules" => "v@tRikyl",
"ventrière" => "v@tRijER",
"ventriloque" => "v@tRilOk",
"ventriloques" => "v@tRilOk",
"ventriloquie" => "v@tRiloki",
"ventripotent" => "v@tRipot@",
"ventripotents" => "v@tRipot@",
"ventru" => "v@tRy",
"ventrue" => "v@tRy",
"ventrues" => "v@tRy",
"ventrus" => "v@tRy",
"vents" => "v@",
"venu" => "v°ny",
"venue" => "v°ny",
"venues" => "v°ny",
"venus" => "v°ny",
"vénus" => "venys",
"vénusien" => "venyzj5",
"vénusienne" => "venyzjEn",
"vénusiens" => "venyzj5",
"vénusté" => "venyste",
"vêpre" => "vEpR",
"vêpres" => "vEpR",
"ver" => "vER",
"vérace" => "veRas",
"véraces" => "veRas",
"véracité" => "veRasite",
"véranda" => "veR@da",
"vérandas" => "veR@da",
"verbal" => "vERbal",
"verbale" => "vERbal",
"verbalement" => "vERbal°m@",
"verbales" => "vERbal",
"verbalisation" => "vERbalizasj§",
"verbalise" => "vERbaliz",
"verbalisé" => "vERbalize",
"verbalisée" => "vERbalize",
"verbaliser" => "vERbalize",
"verbalisez" => "vERbalize",
"verbalisme" => "vERbalizm",
"verbaliste" => "vERbalist",
"verbatim" => "vERbatim",
"verbaux" => "vERbo",
"verbe" => "vERb",
"verbes" => "vERb",
"verbeuse" => "vERb2z",
"verbeuses" => "vERb2z",
"verbeux" => "vERb2",
"verbiage" => "vERbjaZ",
"verbosité" => "vERbozite",
"verbosités" => "vERbozite",
"verdâtre" => "vERdatR",
"verdâtres" => "vERdatR",
"verdelet" => "vERd°lE",
"verdeur" => "vERd9R",
"verdeurs" => "vERd9R",
"verdi" => "vERdi",
"verdict" => "vERdikt",
"verdicts" => "vERdikt",
"verdie" => "vERdi",
"verdier" => "vERdje",
"verdiers" => "vERdje",
"verdies" => "vERdi",
"verdine" => "vERdin",
"verdir" => "vERdiR",
"verdis" => "vERdi",
"verdissaient" => "vERdisE",
"verdissait" => "vERdisE",
"verdissant" => "vERdis@",
"verdissante" => "vERdis@t",
"verdissants" => "vERdis@",
"verdissent" => "vERdis",
"verdit" => "vERdi",
"verdoie" => "vERdwa",
"verdoiement" => "vERdwam@",
"verdoient" => "vERdwa",
"verdoyant" => "vERdwaj@",
"verdoyante" => "vERdwaj@t",
"verdoyantes" => "vERdwaj@t",
"verdoyants" => "vERdwaj@",
"verdoyer" => "vERdwaje",
"verdure" => "vERdyR",
"verdures" => "vERdyR",
"véreuse" => "veR2z",
"véreuses" => "veR2z",
"véreux" => "veR2",
"verge" => "vERZ",
"vergé" => "vERZe",
"vergence" => "vERZ@s",
"verger" => "vERZe",
"vergers" => "vERZe",
"verges" => "vERZ",
"vergés" => "vERZe",
"vergeture" => "vERZ°tyR",
"vergetures" => "vERZ°tyR",
"verglacé" => "vERglase",
"verglacée" => "vERglase",
"verglacées" => "vERglase",
"verglas" => "vERgla",
"vergne" => "vERN",
"vergnes" => "vERN",
"vergogne" => "vERgON",
"vergogneux" => "vERgoN2",
"vergue" => "vERg",
"vergues" => "vERg",
"véridique" => "veRidik",
"véridiquement" => "veRidik°m@",
"véridiques" => "veRidik",
"vérif" => "veRif",
"vérifia" => "veRifja",
"vérifiable" => "veRifjabl",
"vérifiables" => "veRifjabl",
"vérifiai" => "veRifjE",
"vérifiaient" => "veRifjE",
"vérifiais" => "veRifjE",
"vérifiait" => "veRifjE",
"vérifiant" => "veRifj@",
"vérificateur" => "veRifikat9R",
"vérificateurs" => "veRifikat9R",
"vérification" => "veRifikasj§",
"vérifications" => "veRifikasj§",
"vérificatrice" => "veRifikatRis",
"vérifie" => "veRifi",
"vérifié" => "veRifje",
"vérifiée" => "veRifje",
"vérifiées" => "veRifje",
"vérifient" => "veRifi",
"vérifier" => "veRifje",
"vérifiera" => "veRifiRa",
"vérifierai" => "veRifiRE",
"vérifierais" => "veRifiRE",
"vérifierait" => "veRifiRE",
"vérifieras" => "veRifiRa",
"vérifièrent" => "veRifjER",
"vérifierons" => "veRifiR§",
"vérifieront" => "veRifiR§",
"vérifies" => "veRifi",
"vérifiés" => "veRifje",
"vérifieur" => "veRifj9R",
"vérifiez" => "veRifje",
"vérifiions" => "veRifij§",
"vérifions" => "veRifj§",
"vérin" => "veR5",
"vérins" => "veR5",
"vériste" => "veRist",
"véritable" => "veRitabl",
"véritablement" => "veRitabl°m@",
"véritables" => "veRitabl",
"vérité" => "veRite",
"vérités" => "veRite",
"verjus" => "vERZy",
"verlan" => "vERl@",
"vermeil" => "vERmEj",
"vermeille" => "vERmEj",
"vermeilles" => "vERmEj",
"vermeils" => "vERmEj",
"vermicelle" => "vERmisEl",
"vermicelles" => "vERmisEl",
"vermiculaire" => "vERmikylER",
"vermiculaires" => "vERmikylER",
"vermiculées" => "vERmikyle",
"vermifuge" => "vERmifyZ",
"vermillon" => "vERmij§",
"vermillonnait" => "vERmijonE",
"vermillonnée" => "vERmijone",
"vermillonnés" => "vERmijone",
"vermillons" => "vERmij§",
"vermine" => "vERmin",
"vermines" => "vERmin",
"vermineux" => "vERmin2",
"vermisseau" => "vERmiso",
"vermisseaux" => "vERmiso",
"vermoulu" => "vERmuly",
"vermoulue" => "vERmuly",
"vermoulues" => "vERmuly",
"vermoulure" => "vERmulyR",
"vermoulures" => "vERmulyR",
"vermoulus" => "vERmuly",
"vermout" => "vERmut",
"vermouth" => "vERmut",
"vermouths" => "vERmut",
"vernaculaire" => "vERnakylER",
"vernal" => "vERnal",
"verne" => "vERn",
"verni" => "vERni",
"vernie" => "vERni",
"vernier" => "vERnje",
"vernies" => "vERni",
"vernir" => "vERniR",
"vernis" => "vERni",
"vernissage" => "vERnisaZ",
"vernissages" => "vERnisaZ",
"vernissaient" => "vERnisE",
"vernissait" => "vERnisE",
"vernissant" => "vERnis@",
"vernissé" => "vERnise",
"vernissée" => "vERnise",
"vernissées" => "vERnise",
"vernissent" => "vERnis",
"vernisser" => "vERnise",
"vernissés" => "vERnise",
"vernisseur" => "vERnis9R",
"vernit" => "vERni",
"vérole" => "veROl",
"vérolé" => "veRole",
"vérolée" => "veRole",
"vérolées" => "veRole",
"véroles" => "veROl",
"vérolés" => "veRole",
"véronaise" => "veRonEz",
"véronal" => "veROnal",
"véronique" => "veRonik",
"véroniques" => "veRonik",
"verra" => "vERa",
"verrai" => "vERE",
"verraient" => "vERE",
"verrais" => "vERE",
"verrait" => "vERE",
"verras" => "vERa",
"verrat" => "vERa",
"verrats" => "vERa",
"verre" => "vER",
"verrerie" => "vER°Ri",
"verreries" => "vER°Ri",
"verres" => "vER",
"verrez" => "vERe",
"verrier" => "vERje",
"verrière" => "vERjER",
"verrières" => "vERjER",
"verriers" => "vERje",
"verriez" => "vERje",
"verrions" => "vERj§",
"verrons" => "veR§",
"verront" => "veR§",
"verroterie" => "veROt°Ri",
"verroteries" => "veROt°Ri",
"verrou" => "veRu",
"verrouilla" => "veRuja",
"verrouillage" => "veRujaZ",
"verrouillai" => "veRujE",
"verrouillait" => "veRujE",
"verrouillant" => "veRuj@",
"verrouille" => "veRuj",
"verrouillé" => "veRuje",
"verrouillée" => "veRuje",
"verrouillées" => "veRuje",
"verrouillent" => "veRuj",
"verrouiller" => "veRuje",
"verrouillèrent" => "veRujER",
"verrouilles" => "veRuj",
"verrouillés" => "veRuje",
"verrouillez" => "veRuje",
"verrouillons" => "veRuj§",
"verrous" => "veRu",
"verrue" => "veRy",
"verrues" => "veRy",
"verruqueuse" => "veRyk2z",
"vers" => "vER",
"versa" => "vERsa",
"versai" => "vERsE",
"versaient" => "vERsE",
"versaillais" => "vERsajE",
"versaillaise" => "vERsajEz",
"versais" => "vERsE",
"versait" => "vERsE",
"versâmes" => "vERsam",
"versant" => "vERs@",
"versants" => "vERs@",
"versât" => "vERsa",
"versatile" => "vERsatil",
"versatiles" => "vERsatil",
"versatilité" => "vERsatilite",
"verse" => "vERs",
"versé" => "vERse",
"verseau" => "vERso",
"versée" => "vERse",
"versées" => "vERse",
"versement" => "vERs°m@",
"versements" => "vERs°m@",
"versent" => "vERs",
"verser" => "vERse",
"versera" => "vERs°Ra",
"verserai" => "vERs°RE",
"verserais" => "vERs°RE",
"verserait" => "vERs°RE",
"verseras" => "vERs°Ra",
"versèrent" => "vERsER",
"verserez" => "vERs°Re",
"verseriez" => "vERs°Rje",
"verserons" => "vERs°R§",
"verseront" => "vERs°R§",
"verses" => "vERs",
"versés" => "vERse",
"verset" => "vERsE",
"versets" => "vERsE",
"verseur" => "vERs9R",
"verseurs" => "vERs9R",
"verseuse" => "vERs2z",
"verseuses" => "vERs2z",
"versez" => "vERse",
"versicolores" => "vERsikolOR",
"versiculets" => "vERsikylE",
"versiez" => "vERsje",
"versificateur" => "vERsifikat9R",
"versification" => "vERsifikasj§",
"versifiées" => "vERsifje",
"versifier" => "vERsifje",
"version" => "vERsj§",
"versions" => "vERsj§",
"verso" => "vERso",
"versons" => "vERs§",
"versos" => "vERso",
"verstes" => "vERst",
"versus" => "vERsys",
"vert" => "vER",
"vert-de-gris" => "vERd°gRi",
"vert-de-grisé" => "vERd°gRize",
"vert-de-grisée" => "vERd°gRize",
"vert-de-grisées" => "vERd°gRize",
"vert-de-grisés" => "vERd°gRize",
"vert-galant" => "vERgal@",
"vert-jaune" => "vERZon",
"verte" => "vERt",
"vertébral" => "vERtebRal",
"vertébrale" => "vERtebRal",
"vertébrales" => "vERtebRal",
"vertébraux" => "vERtebRo",
"vertèbre" => "vERtEbR",
"vertébré" => "vERtebRe",
"vertèbres" => "vERtEbR",
"vertébrés" => "vERtebRe",
"vertement" => "vERt°m@",
"vertes" => "vERt",
"vertex" => "vERtEks",
"vertical" => "vERtikal",
"verticale" => "vERtikal",
"verticalement" => "vERtikal°m@",
"verticales" => "vERtikal",
"verticalité" => "vERtikalite",
"verticaux" => "vERtiko",
"verticille" => "vERtisil",
"vertige" => "vERtiZ",
"vertiges" => "vERtiZ",
"vertigineuse" => "vERtiZin2z",
"vertigineusement" => "vERtiZin2z°m@",
"vertigineuses" => "vERtiZin2z",
"vertigineux" => "vERtiZin2",
"vertigo" => "vERtigo",
"verts" => "vER",
"vertu" => "vERty",
"vertubleu" => "vERtybl2",
"vertueuse" => "vERt82z",
"vertueusement" => "vERt82z°m@",
"vertueuses" => "vERt82z",
"vertueux" => "vERt82",
"vertugadin" => "vERtygad5",
"vertus" => "vERty",
"verve" => "vERv",
"verveine" => "vERvEn",
"verveux" => "vERv2",
"vésanie" => "vezani",
"vésanies" => "vezani",
"vesce" => "vEs",
"vesces" => "vEs",
"vésicale" => "vezikal",
"vésicante" => "vezik@t",
"vésicatoire" => "vezikatwaR",
"vésicatoires" => "vezikatwaR",
"vésiculaire" => "vezikylER",
"vésicule" => "vezikyl",
"vésicules" => "vezikyl",
"vespa" => "vEspa",
"vespas" => "vEspa",
"vespasienne" => "vEspazjEn",
"vespasiennes" => "vEspazjEn",
"vespéral" => "vEspeRal",
"vespérale" => "vEspeRal",
"vespérales" => "vEspeRal",
"vespéraux" => "vEspeRo",
"vesprée" => "vEspRe",
"vesse-de-loup" => "vEsd°lu",
"vesses" => "vEs",
"vesses-de-loup" => "vEsd°lu",
"vessie" => "vesi",
"vessies" => "vesi",
"vestalat" => "vestala",
"vestale" => "vEstal",
"vestales" => "vEstal",
"veste" => "vEst",
"vestes" => "vEst",
"vestiaire" => "vEstjER",
"vestiaires" => "vEstjER",
"vestibule" => "vEstibyl",
"vestibules" => "vEstibyl",
"vestige" => "vEstiZ",
"vestiges" => "vEstiZ",
"vestimentaire" => "vEstim@tER",
"vestimentaires" => "vEstim@tER",
"veston" => "vEst§",
"vestons" => "vEst§",
"vésuviennes" => "vezyvjEn",
"vêt" => "vE",
"vêtaient" => "vEtE",
"vêtait" => "vEtE",
"vêtant" => "vEt@",
"vête" => "vEt",
"vêtement" => "vEt°m@",
"vêtements" => "vEt°m@",
"vêtent" => "vEt",
"vétéran" => "veteR@",
"vétérans" => "veteR@",
"vétérinaire" => "veteRinER",
"vétérinaires" => "veteRinER",
"vêtez" => "vEte",
"vétille" => "vetij",
"vétilles" => "vetij",
"vétilleuse" => "vetij2z",
"vétilleuses" => "vetij2z",
"vétilleux" => "vetij2",
"vêtir" => "vetiR",
"vêtira" => "vEtiRa",
"vêtirais" => "vEtiRE",
"vêtirait" => "vEtiRE",
"vêtirons" => "vEtiR§",
"vêtis" => "vEti",
"vêtit" => "vEti",
"vétiver" => "vetive",
"veto" => "veto",
"vêtons" => "vEt§",
"vêts" => "vE",
"vêtu" => "vety",
"vêtue" => "vety",
"vêtues" => "vEty",
"vêture" => "vEtyR",
"vêtures" => "vEtyR",
"vêtus" => "vety",
"vétuste" => "vetyst",
"vétusté" => "vetyste",
"vétustes" => "vetyst",
"vétyver" => "vetivER",
"veuf" => "v9f",
"veufs" => "v9f",
"veuille" => "v9j",
"veuillent" => "v9j",
"veuilles" => "v9j",
"veuillez" => "v9je",
"veule" => "v2l",
"veulent" => "v9l",
"veulerie" => "v2l°Ri",
"veuleries" => "v2l°Ri",
"veules" => "v2l",
"veut" => "v2",
"veuvage" => "v9vaZ",
"veuvages" => "v9vaZ",
"veuve" => "v9v",
"veuves" => "v9v",
"veux" => "v2",
"vexa" => "vEksa",
"vexai" => "vEksE",
"vexait" => "vEksE",
"vexant" => "vEks@",
"vexante" => "vEks@t",
"vexantes" => "vEks@t",
"vexants" => "vEks@",
"vexation" => "vEksasj§",
"vexations" => "vEksasj§",
"vexatoire" => "vEksatwaR",
"vexatoires" => "vEksatwaR",
"vexe" => "vEks",
"vexé" => "vEkse",
"vexée" => "vEkse",
"vexées" => "vEkse",
"vexent" => "vEks",
"vexer" => "vEkse",
"vexera" => "vEks°Ra",
"vexerai" => "vEks°RE",
"vexerait" => "vEks°RE",
"vexeras" => "vEks°Ra",
"vexerez" => "vEks°Re",
"vexerions" => "vEks°Rj§",
"vexes" => "vEks",
"vexés" => "vEkse",
"vexez" => "vEkse",
"vexons" => "vEks§",
"via" => "vja",
"viabilité" => "vjabilite",
"viable" => "vjabl",
"viables" => "vjabl",
"viaduc" => "vjadyk",
"viager" => "vjaZe",
"viagère" => "vjaZER",
"viagra" => "vjagRa",
"viandard" => "vj@daR",
"viandasse" => "vj@das",
"viande" => "vj@d",
"viandé" => "vj@de",
"viander" => "vj@de",
"viandes" => "vj@d",
"viandeuse" => "vj@d2z",
"viandox" => "vj@dOks",
"viatique" => "vjatik",
"vibra" => "vibRa",
"vibraient" => "vibRE",
"vibrais" => "vibRE",
"vibrait" => "vibRE",
"vibrant" => "vibR@",
"vibrante" => "vibR@t",
"vibrantes" => "vibR@t",
"vibrants" => "vibR@",
"vibraphone" => "vibRafOn",
"vibraphones" => "vibRafOn",
"vibrateur" => "vibRat9R",
"vibrateurs" => "vibRat9R",
"vibratile" => "vibRatil",
"vibratiles" => "vibRatil",
"vibration" => "vibRasj§",
"vibrations" => "vibRasj§",
"vibrato" => "vibRato",
"vibratoire" => "vibRatwaR",
"vibratoires" => "vibRatwaR",
"vibratos" => "vibRato",
"vibre" => "vibR",
"vibré" => "vibRe",
"vibrée" => "vibRe",
"vibrées" => "vibRe",
"vibrent" => "vibR",
"vibrer" => "vibRe",
"vibrera" => "vibR°Ra",
"vibreur" => "vibR9R",
"vibrez" => "vibRe",
"vibrionnaient" => "vibRijonE",
"vibrionnait" => "vibRijonE",
"vibrionnant" => "vibRijon@",
"vibrionne" => "vibRijOn",
"vibrions" => "vibRij§",
"vibrisses" => "vibRis",
"vibro-masseur" => "vibRomas9R",
"vibromasseur" => "vibRomas9R",
"vibromasseurs" => "vibRomas9R",
"vibura" => "vibyRa",
"viburait" => "vibyRE",
"vibure" => "vibyR",
"vicaire" => "vikER",
"vicaires" => "vikER",
"vice" => "vis",
"vice-amiral" => "visamiRal",
"vice-chancelier" => "vis°S@s2lje",
"vice-consul" => "visk§syl",
"vice-ministre" => "visministR",
"vice-ministres" => "visministR",
"vice-premier" => "vispR°mje",
"vice-présidence" => "vispRezid@s",
"vice-président" => "vispRezid@",
"vice-présidente" => "vispRezid@t",
"vice-présidents" => "vispRezid@",
"vice-recteur" => "visREkt9R",
"vice-roi" => "visRwa",
"vice-rois" => "visRwa",
"vice-versa" => "visvERsa",
"vicelard" => "vis°laR",
"vicelarde" => "vis°laRd",
"vicelardes" => "vis°laRd",
"vicelardise" => "vis°laRdiz",
"vicelardises" => "vis°laRdiz",
"vicelards" => "vis°laR",
"vices" => "vis",
"vichy" => "viSi",
"vichysme" => "viSism",
"vichyssois" => "viSiswa",
"vichyssoise" => "viSiswaz",
"vichyste" => "viSist",
"vichystes" => "viSist",
"vicié" => "visje",
"viciée" => "visje",
"vicier" => "visje",
"viciés" => "visje",
"vicieuse" => "visj2z",
"vicieusement" => "visj2z°m@",
"vicieuses" => "visj2z",
"vicieux" => "visj2",
"vicinal" => "visinal",
"vicinales" => "visinal",
"vicinalité" => "visinalite",
"vicinaux" => "visino",
"vicissitude" => "visisityd",
"vicissitudes" => "visisityd",
"vicomte" => "vik§t",
"vicomté" => "vik§te",
"vicomtes" => "vik§t",
"vicomtesse" => "vik§tEs",
"vicomtesses" => "vik§tEs",
"victimaire" => "viktimER",
"victime" => "viktim",
"victimes" => "viktim",
"victimologie" => "viktimOlOZi",
"victoire" => "viktwaR",
"victoires" => "viktwaR",
"victoria" => "viktoRja",
"victorias" => "viktoRja",
"victorien" => "viktoRj5",
"victorienne" => "viktoRjEn",
"victoriennes" => "viktoRjEn",
"victoriens" => "viktoRj5",
"victorieuse" => "viktoRj2z",
"victorieusement" => "viktoRj2z°m@",
"victorieuses" => "viktoRj2z",
"victorieux" => "viktoRj2",
"victuaille" => "vikt8aj",
"victuailles" => "vikt8aj",
"vida" => "vida",
"vidage" => "vidaZ",
"vidai" => "vidE",
"vidaient" => "vidE",
"vidais" => "vidE",
"vidait" => "vidE",
"vidame" => "vidam",
"vidange" => "vid@Z",
"vidangé" => "vid@Ze",
"vidangée" => "vid@Ze",
"vidanger" => "vid@Ze",
"vidanges" => "vid@Z",
"vidangeur" => "vid@Z9R",
"vidangeurs" => "vid@Z9R",
"vidangez" => "vid@Ze",
"vidant" => "vid@",
"vidas" => "vida",
"vide" => "vid",
"vidé" => "vide",
"vide-gousset" => "vid°gusE",
"vide-greniers" => "vidgR2nje",
"vide-ordure" => "vidORdyR",
"vide-ordures" => "vidORdyR",
"vide-poche" => "vidpOS",
"vide-poches" => "vidpOS",
"vidéaste" => "videast",
"vidéastes" => "videast",
"vidée" => "vide",
"vidées" => "vide",
"vident" => "vid",
"vidéo" => "video",
"vidéo-clip" => "videoklip",
"vidéo-clips" => "videoklip",
"vidéo-club" => "videokl9b",
"vidéo-espion" => "videoEspj§",
"vidéocassette" => "videokasEt",
"vidéocassettes" => "videokasEt",
"vidéoclip" => "videoklip",
"vidéoclub" => "videokl9b",
"vidéoconférence" => "videok§feR@s",
"vidéogramme" => "videOgRam",
"vidéophone" => "videofOn",
"vidéophonie" => "videOfOni",
"vidéos" => "video",
"vidéosurveillance" => "videosyRvEj@s",
"vidéothèque" => "videotEk",
"vider" => "vide",
"videra" => "vid°Ra",
"viderai" => "vid°RE",
"viderais" => "vid°RE",
"viderait" => "vid°RE",
"videras" => "vid°Ra",
"vidèrent" => "vidER",
"viderions" => "vid°Rj§",
"videront" => "vid°R§",
"vides" => "vid",
"vidés" => "vide",
"videur" => "vid9R",
"videurs" => "vid9R",
"videz" => "vide",
"vidicon" => "vidik§",
"vidiez" => "vidje",
"vidons" => "vid§",
"viduité" => "vid8ite",
"vidures" => "vidyR",
"vie" => "vi",
"vieil" => "vjEj",
"vieillard" => "vjEjaR",
"vieillarde" => "vjEjaRd",
"vieillardes" => "vjEjaRd",
"vieillards" => "vjEjaR",
"vieille" => "vjEj",
"vieillerie" => "vjEj°Ri",
"vieilleries" => "vjEj°Ri",
"vieilles" => "vjEj",
"vieillesse" => "vjEjEs",
"vieillesses" => "vjEjEs",
"vieilli" => "vjeji",
"vieillie" => "vjeji",
"vieillies" => "vjeji",
"vieillir" => "vjejiR",
"vieillira" => "vjEjiRa",
"vieillirai" => "vjEjiRE",
"vieilliraient" => "vjEjiRE",
"vieillirais" => "vjEjiRE",
"vieillirait" => "vjEjiRE",
"vieilliras" => "vjEjiRa",
"vieillirent" => "vjEjiR",
"vieillirez" => "vjEjiRe",
"vieillirons" => "vjEjiR§",
"vieilliront" => "vjEjiR§",
"vieillis" => "vjeji",
"vieillissaient" => "vjEjisE",
"vieillissais" => "vjEjisE",
"vieillissait" => "vjEjisE",
"vieillissant" => "vjejis@",
"vieillissante" => "vjejis@t",
"vieillissantes" => "vjejis@t",
"vieillissants" => "vjejis@",
"vieillisse" => "vjEjis",
"vieillissement" => "vjejis°m@",
"vieillissent" => "vjEjis",
"vieillissez" => "vjEjise",
"vieillissiez" => "vjEjisje",
"vieillissions" => "vjEjisj§",
"vieillissons" => "vjEjis§",
"vieillit" => "vjEji",
"vieillot" => "vjEjo",
"vieillots" => "vjEjo",
"vieillotte" => "vjEjOt",
"vieillottes" => "vjEjOt",
"vielle" => "vjEl",
"vielles" => "vjEl",
"vielleux" => "vjEl2",
"viendra" => "vj5dRa",
"viendrai" => "vj5dRE",
"viendraient" => "vj5dRE",
"viendrais" => "vj5dRE",
"viendrait" => "vj5dRE",
"viendras" => "vj5dRa",
"viendrez" => "vj5dRe",
"viendriez" => "vj5dRije",
"viendrions" => "vj5dRij§",
"viendrons" => "vj5dR§",
"viendront" => "vj5dR§",
"vienne" => "vjEn",
"viennent" => "vjEn",
"viennes" => "vjEn",
"viennois" => "vjEnwa",
"viennoise" => "vjEnwaz",
"viennoiserie" => "vjEnwaz°Ri",
"viennoiseries" => "vjEnwaz°Ri",
"viennoises" => "vjEnwaz",
"viens" => "vj5",
"vient" => "vj5",
"vierge" => "vjERZ",
"vierges" => "vjERZ",
"vies" => "vi",
"vietnamien" => "vjEtnamj5",
"vietnamienne" => "vjEtnamjEn",
"vietnamiennes" => "vjEtnamjEn",
"vietnamiens" => "vjEtnamj5",
"vieux" => "vj2",
"vieux-rose" => "vj2Roz",
"vif" => "vif",
"vif-argent" => "vifaRZ@",
"vifs" => "vif",
"vigie" => "viZi",
"vigies" => "viZi",
"vigil" => "viZil",
"vigilance" => "viZil@s",
"vigilances" => "viZil@s",
"vigilant" => "viZil@",
"vigilante" => "viZil@t",
"vigilantes" => "viZil@t",
"vigilants" => "viZil@",
"vigile" => "viZil",
"vigiler" => "viZile",
"vigiles" => "viZil",
"vigne" => "viN",
"vigneaux" => "viNo",
"vigneron" => "viN°R§",
"vigneronne" => "viN°ROn",
"vigneronnes" => "viN°ROn",
"vignerons" => "viN°R§",
"vignes" => "viN",
"vignette" => "viNEt",
"vignettes" => "viNEt",
"vignoble" => "viNObl",
"vignobles" => "viNObl",
"vigogne" => "vigON",
"vigoureuse" => "viguR2z",
"vigoureusement" => "viguR2z°m@",
"vigoureuses" => "viguR2z",
"vigoureux" => "viguR2",
"vigousse" => "vigus",
"vigueur" => "vig9R",
"vigueurs" => "vig9R",
"viguier" => "vigje",
"viguiers" => "vigje",
"viking" => "vikiG",
"vikings" => "vikiG",
"vil" => "vil",
"vilain" => "vil5",
"vilaine" => "vilEn",
"vilainement" => "vilEn°m@",
"vilaines" => "vilEn",
"vilains" => "vil5",
"vile" => "vil",
"vilebrequin" => "vil°bR°k5",
"vilebrequins" => "vil°bR°k5",
"vilement" => "vil°m@",
"vilenie" => "vileni",
"vilenies" => "vileni",
"viles" => "vil",
"vilipendaient" => "vilip@dE",
"vilipendant" => "vilip@d@",
"vilipendé" => "vilip@de",
"vilipendées" => "vilip@de",
"vilipender" => "vilip@de",
"vilipendés" => "vilip@de",
"villa" => "villa",
"village" => "vilaZ",
"villageois" => "vilaZwa",
"villageoise" => "vilaZwaz",
"villageoises" => "vilaZwaz",
"villages" => "vilaZ",
"villas" => "villa",
"ville" => "vil",
"ville-champignon" => "vilS@piN§",
"ville-dortoir" => "vildORtwaR",
"villégiaturait" => "vileZjatyRE",
"villégiature" => "vileZjatyR",
"villégiaturé" => "vileZjatyRe",
"villégiaturer" => "vileZjatyRe",
"villégiatures" => "vileZjatyR",
"villes" => "vil",
"villes-clés" => "vilkle",
"villette" => "vilEt",
"vils" => "vil",
"vîmes" => "vim",
"vin" => "v5",
"vina" => "vina",
"vinaigre" => "vinEgR",
"vinaigré" => "vinEgRe",
"vinaigrée" => "vinEgRe",
"vinaigrer" => "vinEgRe",
"vinaigres" => "vinEgR",
"vinaigrette" => "vinEgREt",
"vinasse" => "vinas",
"vindicatif" => "v5dikatif",
"vindicatifs" => "v5dikatif",
"vindicative" => "v5dikativ",
"vindicativement" => "v5dikativ°m@",
"vindicatives" => "v5dikativ",
"vindicte" => "v5dikt",
"vine" => "vin",
"viner" => "vine",
"vines" => "vin",
"vineuse" => "vin2z",
"vineuses" => "vin2z",
"vineux" => "vin2",
"vinez" => "vine",
"vingt" => "v5",
"vingt-cinq" => "v5ts5k",
"vingt-cinquième" => "v5ts5kjEm",
"vingt-deux" => "v5td2",
"vingt-deuxième" => "v5td2zjEm",
"vingt-et-un" => "v5te1",
"vingt-et-une" => "v5teyn",
"vingt-et-unième" => "v5teynjEm",
"vingt-huit" => "v5t8it",
"vingt-huitième" => "v5t8itjEm",
"vingt-neuf" => "v5tn9f",
"vingt-neuvième" => "v5tn9vjEm",
"vingt-quatre" => "v5tkatR",
"vingt-quatrième" => "v5tkatRijEm",
"vingt-sept" => "v5tsEt",
"vingt-septième" => "v5tsEtjEm",
"vingt-six" => "v5tsis",
"vingt-sixième" => "v5tsizjEm",
"vingt-trois" => "v5ttRwa",
"vingt-troisième" => "v5ttRwazjEm",
"vingtaine" => "v5tEn",
"vingtaines" => "v5tEn",
"vingtième" => "v5tjEm",
"vingtièmes" => "v5tjEm",
"vinicole" => "vinikOl",
"vinificatrice" => "vinifikatRis",
"vinrent" => "v5R",
"vins" => "v5",
"vinsse" => "v5s",
"vinssent" => "v5s",
"vint" => "v5",
"vînt" => "v5",
"vintage" => "v5taZ",
"vinyle" => "vinil",
"vinyles" => "vinil",
"vinylique" => "vinilik",
"vioc" => "vjOk",
"viocard" => "vjOkaR",
"viocque" => "vjOk",
"viocs" => "vjOk",
"viol" => "vjOl",
"viola" => "vjola",
"violaçait" => "vjolasE",
"violacé" => "vjolase",
"violacée" => "vjolase",
"violacées" => "vjolase",
"violacer" => "vjolase",
"violacés" => "vjolase",
"violaient" => "vjolE",
"violais" => "vjolE",
"violait" => "vjolE",
"violant" => "vjol@",
"violation" => "vjolasj§",
"violations" => "vjolasj§",
"violâtre" => "vjolatR",
"violâtres" => "vjolatR",
"viole" => "vjOl",
"violé" => "vjole",
"violée" => "vjole",
"violées" => "vjole",
"violemment" => "vjolam@",
"violence" => "vjol@s",
"violences" => "vjol@s",
"violent" => "vjol@",
"violentaient" => "vjol@tE",
"violentait" => "vjol@tE",
"violente" => "vjol@t",
"violenté" => "vjol@te",
"violentée" => "vjol@te",
"violenter" => "vjol@te",
"violentes" => "vjol@t",
"violents" => "vjol@",
"violer" => "vjole",
"violerai" => "vjOl°RE",
"violerais" => "vjOl°RE",
"violerait" => "vjOl°RE",
"violeras" => "vjOl°Ra",
"violeront" => "vjOl°R§",
"violes" => "vjOl",
"violés" => "vjole",
"violet" => "vjolE",
"violeta" => "vjol°ta",
"violets" => "vjolE",
"violette" => "vjolEt",
"violettes" => "vjolEt",
"violeur" => "vjol9R",
"violeurs" => "vjol9R",
"violeuses" => "vjol2z",
"violez" => "vjole",
"violine" => "vjolin",
"violines" => "vjolin",
"violon" => "vjol§",
"violoncelle" => "vjol§sEl",
"violoncelles" => "vjol§sEl",
"violoncelliste" => "vjol§selist",
"violoncellistes" => "vjol§selist",
"violone" => "vjolOn",
"violoneux" => "vjolon2",
"violoniste" => "vjolonist",
"violonistes" => "vjolonist",
"violons" => "vjol§",
"viols" => "vjOl",
"vioque" => "vjOk",
"vioques" => "vjOk",
"viorne" => "vjORn",
"viornes" => "vjORn",
"vipère" => "vipER",
"vipéreau" => "vipeRo",
"vipères" => "vipER",
"vipérine" => "vipeRin",
"vipérines" => "vipeRin",
"vira" => "viRa",
"virage" => "viRaZ",
"virages" => "viRaZ",
"virago" => "viRago",
"viragos" => "viRago",
"virai" => "viRE",
"viraient" => "viRE",
"virais" => "viRE",
"virait" => "viRE",
"viral" => "viRal",
"virale" => "viRal",
"virales" => "viRal",
"virant" => "viR@",
"virât" => "viRa",
"viraux" => "viRo",
"vire" => "viR",
"viré" => "viRe",
"virée" => "viRe",
"virées" => "viRe",
"virement" => "viR°m@",
"virements" => "viR°m@",
"virent" => "viR",
"virer" => "viRe",
"virera" => "viR°Ra",
"virerai" => "viR°RE",
"virerais" => "viR°RE",
"virerait" => "viR°RE",
"vireras" => "viR°Ra",
"virèrent" => "viRER",
"virerez" => "viR°Re",
"vireront" => "viR°R§",
"vires" => "viR",
"virés" => "viRe",
"vireuse" => "viR2z",
"virevolta" => "viR°vOlta",
"virevoltaient" => "viR°vOltE",
"virevoltait" => "viR°vOltE",
"virevoltant" => "viR°vOlt@",
"virevoltante" => "viR°vOlt@t",
"virevoltantes" => "viR°vOlt@t",
"virevolte" => "viR°vOlt",
"virevolté" => "viR°vOlte",
"virevoltent" => "viR°vOlt",
"virevolter" => "viR°vOlte",
"virevoltes" => "viR°vOlt",
"virez" => "viRe",
"virgilien" => "viRZilj5",
"virgilienne" => "viRZiljEn",
"virginal" => "viRZinal",
"virginale" => "viRZinal",
"virginalement" => "viRZinal°m@",
"virginales" => "viRZinal",
"virginaux" => "viRZino",
"virginie" => "viRZini",
"virginien" => "viRZinj5",
"virginiens" => "viRZinj5",
"virginité" => "viRZinite",
"virginités" => "viRZinite",
"virgule" => "viRgyl",
"virgules" => "viRgyl",
"viriez" => "viRje",
"viril" => "viRil",
"virile" => "viRil",
"virilement" => "viRil°m@",
"viriles" => "viRil",
"virilise" => "viRiliz",
"virilisé" => "viRilize",
"viriliser" => "viRilize",
"virilisés" => "viRilize",
"virilité" => "viRilite",
"virilités" => "viRilite",
"virils" => "viRil",
"viroles" => "viROl",
"virolet" => "viROlE",
"virologie" => "viRoloZi",
"virologiste" => "viROlOZist",
"virologue" => "viRolOg",
"virologues" => "viRolOg",
"virons" => "viR§",
"virtualité" => "viRt8alite",
"virtualités" => "viRt8alite",
"virtuel" => "viRt8El",
"virtuelle" => "viRt8El",
"virtuellement" => "viRt8El°m@",
"virtuelles" => "viRt8El",
"virtuels" => "viRt8El",
"virtuose" => "viRt8oz",
"virtuoses" => "viRt8oz",
"virtuosité" => "viRt8ozite",
"virulence" => "viRyl@s",
"virulent" => "viRyl@",
"virulente" => "viRyl@t",
"virulentes" => "viRyl@t",
"virulents" => "viRyl@",
"virus" => "viRys",
"vis" => "vi",
"vis-à-vis" => "vizavi",
"visa" => "viza",
"visage" => "vizaZ",
"visages" => "vizaZ",
"visagiste" => "vizaZist",
"visai" => "vizE",
"visaient" => "vizE",
"visais" => "vizE",
"visait" => "vizE",
"visant" => "viz@",
"visas" => "viza",
"viscéral" => "viseRal",
"viscérale" => "viseRal",
"viscéralement" => "viseRal°m@",
"viscérales" => "viseRal",
"viscéraux" => "viseRo",
"viscère" => "visER",
"viscères" => "visER",
"viscose" => "viskoz",
"viscoses" => "viskoz",
"viscosité" => "viskozite",
"viscosités" => "viskozite",
"vise" => "viz",
"visé" => "vize",
"visée" => "vize",
"visées" => "vize",
"visent" => "viz",
"viser" => "vize",
"visera" => "viz°Ra",
"viserai" => "viz°RE",
"viseraient" => "viz°RE",
"viserais" => "viz°RE",
"viserait" => "viz°RE",
"viseront" => "viz°R§",
"vises" => "viz",
"visés" => "vize",
"viseur" => "viz9R",
"viseurs" => "viz9R",
"visez" => "vize",
"vishnouisme" => "viSnuism",
"visibilité" => "vizibilite",
"visible" => "vizibl",
"visiblement" => "vizibl°m@",
"visibles" => "vizibl",
"visière" => "vizjER",
"visières" => "vizjER",
"visiez" => "vizje",
"visioconférence" => "vizjok§feR@s",
"vision" => "vizj§",
"visionna" => "vizjona",
"visionnage" => "vizjonaZ",
"visionnaire" => "vizjonER",
"visionnaires" => "vizjonER",
"visionnant" => "vizjon@",
"visionne" => "vizjOn",
"visionné" => "vizjone",
"visionnent" => "vizjOn",
"visionner" => "vizjone",
"visionnera" => "vizjOn°Ra",
"visionneront" => "vizjOn°R§",
"visionnés" => "vizjone",
"visionneuse" => "vizjon2z",
"visionnez" => "vizjone",
"visionnons" => "vizjon§",
"visions" => "vizj§",
"visiophone" => "vizjofOn",
"visita" => "vizita",
"visitai" => "vizitE",
"visitaient" => "vizitE",
"visitais" => "vizitE",
"visitait" => "vizitE",
"visitâmes" => "vizitam",
"visitandines" => "vizit@din",
"visitant" => "vizit@",
"visitât" => "vizita",
"visitation" => "vizitasj§",
"visite" => "vizit",
"visité" => "vizite",
"visite-éclair" => "viziteklER",
"visitée" => "vizite",
"visitées" => "vizite",
"visitent" => "vizit",
"visiter" => "vizite",
"visitera" => "vizit°Ra",
"visiterai" => "vizit°RE",
"visiteraient" => "vizit°RE",
"visiterait" => "vizit°RE",
"visiteras" => "vizit°Ra",
"visitèrent" => "vizitER",
"visiterez" => "vizit°Re",
"visiterons" => "vizit°R§",
"visites" => "vizit",
"visités" => "vizite",
"visiteur" => "vizit9R",
"visiteurs" => "vizit9R",
"visiteuse" => "vizit2z",
"visiteuses" => "vizit2z",
"visitez" => "vizite",
"visitiez" => "vizitje",
"visitions" => "vizitj§",
"visitons" => "vizit§",
"vison" => "viz§",
"visons" => "viz§",
"visqueuse" => "visk2z",
"visqueuses" => "visk2z",
"visqueux" => "visk2",
"vissa" => "visa",
"vissaient" => "visE",
"vissait" => "visE",
"vissant" => "vis@",
"visse" => "vis",
"vissé" => "vise",
"vissée" => "vise",
"vissées" => "vise",
"vissent" => "vis",
"visser" => "vise",
"visserait" => "vis°RE",
"vissèrent" => "visER",
"visserie" => "vis°Ri",
"vissés" => "vise",
"vissez" => "vise",
"vista" => "vista",
"visualisaient" => "viz8alizE",
"visualisais" => "vizyalizE",
"visualisant" => "viz8aliz@",
"visualisation" => "viz8alizasj§",
"visualise" => "viz8aliz",
"visualisé" => "viz8alize",
"visualisée" => "viz8alize",
"visualisées" => "vizyalize",
"visualiser" => "viz8alize",
"visualiserai" => "vizyaliz°RE",
"visualises" => "viz8aliz",
"visualisés" => "viz8alize",
"visualisez" => "vizyalize",
"visuel" => "viz8El",
"visuelle" => "viz8El",
"visuellement" => "viz8El°m@",
"visuelles" => "viz8El",
"visuels" => "viz8El",
"vit" => "vi",
"vît" => "vi",
"vital" => "vital",
"vitale" => "vital",
"vitales" => "vital",
"vitaliser" => "vitalize",
"vitalité" => "vitalite",
"vitamine" => "vitamin",
"vitaminé" => "vitamine",
"vitaminée" => "vitamine",
"vitaminées" => "vitamine",
"vitaminer" => "vitamine",
"vitamines" => "vitamin",
"vitaminés" => "vitamine",
"vitaux" => "vito",
"vite" => "vit",
"vitellin" => "vitel5",
"vitement" => "vit°m@",
"vitesse" => "vitEs",
"vitesses" => "vitEs",
"viticole" => "vitikOl",
"viticulteur" => "vitikylt9R",
"viticulteurs" => "vitikylt9R",
"viticultrice" => "vitikyltRis",
"viticulture" => "vitikyltyR",
"vitiligo" => "vitiligo",
"vitrage" => "vitRaZ",
"vitrages" => "vitRaZ",
"vitrail" => "vitRaj",
"vitrauphanie" => "vitRofani",
"vitraux" => "vitRo",
"vitre" => "vitR",
"vitré" => "vitRe",
"vitrée" => "vitRe",
"vitrées" => "vitRe",
"vitres" => "vitR",
"vitrés" => "vitRe",
"vitreuse" => "vitR2z",
"vitreuses" => "vitR2z",
"vitreux" => "vitR2",
"vitrier" => "vitRije",
"vitriers" => "vitRije",
"vitrifia" => "vitRifja",
"vitrifie" => "vitRifi",
"vitrifié" => "vitRifje",
"vitrifiée" => "vitRifje",
"vitrifiées" => "vitRifje",
"vitrifient" => "vitRifi",
"vitrifier" => "vitRifje",
"vitrifiés" => "vitRifje",
"vitrine" => "vitRin",
"vitrines" => "vitRin",
"vitriol" => "vitRijOl",
"vitriolé" => "vitRijole",
"vitrioler" => "vitRiole",
"vitrioleurs" => "vitRijol9R",
"vitriolique" => "vitRijOlik",
"vitriols" => "vitRijOl",
"vitrophanie" => "vitRofani",
"vits" => "vi",
"vitupéraient" => "vitypeRE",
"vitupérait" => "vitypeRE",
"vitupérant" => "vitypeR@",
"vitupérations" => "vitypeRasj§",
"vitupère" => "vitypER",
"vitupérer" => "vitypeRe",
"vivable" => "vivabl",
"vivables" => "vivabl",
"vivace" => "vivas",
"vivaces" => "vivas",
"vivacité" => "vivasite",
"vivacités" => "vivasite",
"vivaient" => "vivE",
"vivais" => "vivE",
"vivait" => "vivE",
"vivandier" => "viv@dje",
"vivandière" => "viv@djER",
"vivandières" => "viv@djER",
"vivandiers" => "viv@dje",
"vivant" => "viv@",
"vivante" => "viv@t",
"vivantes" => "viv@t",
"vivants" => "viv@",
"vivarium" => "vivaRjOm",
"vivat" => "viva",
"vivats" => "viva",
"vive" => "viv",
"vivement" => "viv°m@",
"vivent" => "viv",
"vives" => "viv",
"viveur" => "viv9R",
"viveurs" => "viv9R",
"vivez" => "vive",
"vivier" => "vivje",
"viviers" => "vivje",
"viviez" => "vivje",
"vivifiait" => "vivifjE",
"vivifiant" => "vivifj@",
"vivifiante" => "vivifj@t",
"vivifiantes" => "vivifj@t",
"vivifiants" => "vivifj@",
"vivification" => "vivifikasj§",
"vivifie" => "vivifi",
"vivifié" => "vivifje",
"vivifiée" => "vivifje",
"vivifiées" => "vivifje",
"vivifier" => "vivifje",
"vivions" => "vivj§",
"vivisecteur" => "vivisekt9R",
"vivisection" => "viviseksj§",
"vivisections" => "viviseksj§",
"vivons" => "viv§",
"vivota" => "vivota",
"vivotaient" => "vivotE",
"vivotais" => "vivotE",
"vivotait" => "vivotE",
"vivotant" => "vivot@",
"vivote" => "vivOt",
"vivoté" => "vivote",
"vivotent" => "vivOt",
"vivoter" => "vivote",
"vivotèrent" => "vivotER",
"vivra" => "vivRa",
"vivrai" => "vivRE",
"vivraient" => "vivRE",
"vivrais" => "vivRE",
"vivrait" => "vivRE",
"vivras" => "vivRa",
"vivre" => "vivR",
"vivres" => "vivR",
"vivrez" => "vivRe",
"vivriers" => "vivRije",
"vivriez" => "vivRije",
"vivrions" => "vivRij§",
"vivrons" => "vivR§",
"vivront" => "vivR§",
"vizir" => "viziR",
"vizirs" => "viziR",
"vlan" => "vl@",
"vlouf" => "vluf",
"vocable" => "vokabl",
"vocables" => "vokabl",
"vocabulaire" => "vokabylER",
"vocabulaires" => "vokabylER",
"vocal" => "vokal",
"vocale" => "vokal",
"vocalement" => "vokal°m@",
"vocales" => "vokal",
"vocalique" => "vokalik",
"vocalisait" => "vokalizE",
"vocalisant" => "vokaliz@",
"vocalisation" => "vokalizasj§",
"vocalisations" => "vokalizasj§",
"vocalise" => "vokaliz",
"vocaliser" => "vOkalize",
"vocalises" => "vokaliz",
"vocaliste" => "vokalist",
"vocatif" => "vOkatif",
"vocatifs" => "vokatif",
"vocation" => "vokasj§",
"vocations" => "vokasj§",
"vocaux" => "voko",
"vociféra" => "vosifeRa",
"vociférai" => "vosifeRE",
"vociféraient" => "vosifeRE",
"vociférais" => "vosifeRE",
"vociférait" => "vosifeRE",
"vociférant" => "vosifeR@",
"vociférante" => "vosifeR@t",
"vociférantes" => "vosifeR@t",
"vociférants" => "vosifeR@",
"vocifération" => "vosifeRasj§",
"vociférations" => "vosifeRasj§",
"vocifère" => "vosifER",
"vocifèrent" => "vosifER",
"vociférer" => "vosifeRe",
"vociférés" => "vosifeRe",
"vocodeur" => "vOkOd9R",
"vodka" => "vOdka",
"vodkas" => "vOdka",
"vodou" => "vodu",
"vodous" => "vodu",
"voeu" => "v2",
"voeux" => "v2",
"vogua" => "voga",
"voguaient" => "vogE",
"voguais" => "vogE",
"voguait" => "vogE",
"voguant" => "vog@",
"vogue" => "vOg",
"vogué" => "voge",
"voguent" => "vOg",
"voguer" => "voge",
"voguera" => "vOg°Ra",
"voguerai" => "vOg°RE",
"voguerait" => "vOg°RE",
"voguerions" => "vOg°Rj§",
"voguerons" => "vOg°R§",
"vogues" => "vOg",
"voguions" => "vogj§",
"voguons" => "vog§",
"voici" => "vwasi",
"voie" => "vwa",
"voient" => "vwa",
"voies" => "vwa",
"voila" => "vwala",
"voilà" => "vwala",
"voilage" => "vwalaZ",
"voilages" => "vwalaZ",
"voilaient" => "vwalE",
"voilais" => "vwalE",
"voilait" => "vwalE",
"voilant" => "vwal@",
"voile" => "vwal",
"voilé" => "vwale",
"voilée" => "vwale",
"voilées" => "vwale",
"voilent" => "vwal",
"voiler" => "vwale",
"voilera" => "vwal°Ra",
"voilèrent" => "vwalER",
"voileront" => "vwal°R§",
"voiles" => "vwal",
"voilés" => "vwale",
"voilette" => "vwalEt",
"voilettes" => "vwalEt",
"voilez" => "vwale",
"voilier" => "vwalje",
"voiliers" => "vwalje",
"voilons" => "vwal§",
"voilure" => "vwalyR",
"voilures" => "vwalyR",
"voir" => "vwaR",
"voire" => "vwaR",
"voirie" => "vwaRi",
"vois" => "vwa",
"voisin" => "vwaz5",
"voisinage" => "vwazinaZ",
"voisinages" => "vwazinaZ",
"voisinaient" => "vwazinE",
"voisinait" => "vwazinE",
"voisinant" => "vwazin@",
"voisine" => "vwazin",
"voisiné" => "vwazine",
"voisinent" => "vwazin",
"voisiner" => "vwazine",
"voisines" => "vwazin",
"voisins" => "vwaz5",
"voit" => "vwa",
"voituraient" => "vwatyRE",
"voiturait" => "vwatyRE",
"voiture" => "vwatyR",
"voituré" => "vwatyRe",
"voiture-balai" => "vwatyRbalE",
"voiture-bar" => "vwatyRbaR",
"voiture-lit" => "vwatyRli",
"voiture-restaurant" => "vwatyRREstOR@",
"voiturer" => "vwatyRe",
"voitureront" => "vwatyR°R§",
"voitures" => "vwatyR",
"voitures-balais" => "vwatyRbalE",
"voiturette" => "vwatyREt",
"voiturettes" => "vwatyREt",
"voiturier" => "vwatyRje",
"voituriers" => "vwatyRje",
"voiturin" => "vwatyR5",
"voïvodie" => "vojvOdi",
"voïvodies" => "vojvOdi",
"voix" => "vwa",
"voix-off" => "vwaOf",
"vol" => "vOl",
"vol-au-vent" => "volov@",
"vola" => "vola",
"volage" => "volaZ",
"volages" => "volaZ",
"volai" => "volE",
"volaient" => "volE",
"volaille" => "volaj",
"volailler" => "volaje",
"volaillers" => "volaje",
"volailles" => "volaj",
"volais" => "volE",
"volait" => "volE",
"volant" => "vol@",
"volante" => "vol@t",
"volanté" => "vOl@te",
"volantes" => "vol@t",
"volants" => "vol@",
"volapük" => "volapyk",
"volassent" => "volas",
"volât" => "vola",
"volatil" => "volatil",
"volatile" => "volatil",
"volatiles" => "volatil",
"volatilisa" => "volatiliza",
"volatilisaient" => "volatilizE",
"volatilisait" => "volatilizE",
"volatilisant" => "volatiliz@",
"volatilisation" => "vOlatilizasj§",
"volatilise" => "volatiliz",
"volatilisé" => "volatilize",
"volatilisée" => "volatilize",
"volatilisées" => "volatilize",
"volatilisent" => "volatiliz",
"volatiliser" => "volatilize",
"volatilisés" => "volatilize",
"volatilité" => "volatilite",
"volatils" => "volatil",
"volcan" => "vOlk@",
"volcanique" => "vOlkanik",
"volcaniques" => "vOlkanik",
"volcanologique" => "vOlkanoloZik",
"volcanologue" => "vOlkanolOg",
"volcans" => "vOlk@",
"vole" => "vOl",
"volé" => "vole",
"volée" => "vole",
"volées" => "vole",
"volémie" => "vOlemi",
"volent" => "vOl",
"voler" => "vole",
"volera" => "vOl°Ra",
"volerai" => "vOl°RE",
"voleraient" => "vOl°RE",
"volerais" => "vOl°RE",
"volerait" => "vOl°RE",
"voleras" => "vOl°Ra",
"volèrent" => "volER",
"volerez" => "vOl°Re",
"volerie" => "vOl°Ri",
"voleriez" => "vOl°Rje",
"volerons" => "vOl°R§",
"voleront" => "vOl°R§",
"voles" => "vOl",
"volés" => "vole",
"volet" => "volE",
"voleta" => "vOl°ta",
"voletaient" => "vOl°tE",
"voletait" => "vOl°tE",
"voletant" => "vOl°t@",
"voletante" => "vOl°t@t",
"voletantes" => "vOl°t@t",
"voleter" => "vOl°te",
"voletez" => "vOl°te",
"volets" => "volE",
"volette" => "volEt",
"volettent" => "volEt",
"voleur" => "vol9R",
"voleurs" => "vol9R",
"voleuse" => "vol2z",
"voleuses" => "vol2z",
"volez" => "vole",
"volière" => "voljER",
"volières" => "voljER",
"voliez" => "volje",
"volige" => "voliZ",
"voliges" => "voliZ",
"volions" => "volj§",
"volition" => "volisj§",
"volitions" => "volisj§",
"volley" => "volE",
"volley-ball" => "volEbOl",
"volleyeur" => "volEj9R",
"volleyeurs" => "volEj9R",
"volons" => "vol§",
"volontaire" => "vol§tER",
"volontairement" => "vol§tER°m@",
"volontaires" => "vol§tER",
"volontariat" => "vol§taRja",
"volontarisme" => "vol§taRizm",
"volontariste" => "vol§taRist",
"volontaristes" => "vol§taRist",
"volonté" => "vol§te",
"volontés" => "vol§te",
"volontiers" => "vol§tje",
"vols" => "vOl",
"volt" => "vOlt",
"voltage" => "vOltaZ",
"voltaient" => "vOltE",
"voltaïque" => "vOltaik",
"voltaire" => "vOltER",
"voltaires" => "vOltER",
"voltairien" => "vOltERj5",
"volte" => "vOlt",
"volte-face" => "vOlt°fas",
"volter" => "vOlte",
"voltes" => "vOlt",
"voltige" => "vOltiZ",
"voltigé" => "vOltiZe",
"voltigea" => "vOltiZa",
"voltigeaient" => "vOltiZE",
"voltigeait" => "vOltiZE",
"voltigeant" => "vOltiZ@",
"voltigement" => "vOltiZ°m@",
"voltigent" => "vOltiZ",
"voltiger" => "vOltiZe",
"voltigèrent" => "vOltiZER",
"voltiges" => "vOltiZ",
"voltigeur" => "vOltiZ9R",
"voltigeurs" => "vOltiZ9R",
"voltmètre" => "vOltmEtR",
"volts" => "vOlt",
"volubile" => "volybil",
"volubilement" => "volybil°m@",
"volubiles" => "volybil",
"volubilis" => "volybilis",
"volubilité" => "volybilite",
"volume" => "volym",
"volumes" => "volym",
"volumétrique" => "volymetRik",
"volumineuse" => "volymin2z",
"volumineuses" => "volymin2z",
"volumineux" => "volymin2",
"volumique" => "vOlymik",
"volupté" => "volypte",
"voluptés" => "volypte",
"voluptueuse" => "volypt82z",
"voluptueusement" => "volypt82z°m@",
"voluptueuses" => "volypt82z",
"voluptueux" => "volypt82",
"volute" => "volyt",
"volutes" => "volyt",
"volvaires" => "volvER",
"volve" => "vOlv",
"vomi" => "vomi",
"vomie" => "vomi",
"vomies" => "vomi",
"vomique" => "vomik",
"vomir" => "vomiR",
"vomira" => "vomiRa",
"vomirai" => "vomiRE",
"vomirais" => "vomiRE",
"vomirait" => "vomiRE",
"vomiras" => "vomiRa",
"vomirent" => "vomiR",
"vomirez" => "vomiRe",
"vomiront" => "vomiR§",
"vomis" => "vomi",
"vomissaient" => "vomisE",
"vomissais" => "vomisE",
"vomissait" => "vomisE",
"vomissant" => "vomis@",
"vomisse" => "vomis",
"vomissement" => "vomis°m@",
"vomissements" => "vomis°m@",
"vomissent" => "vomis",
"vomisseur" => "vomis9R",
"vomissez" => "vomise",
"vomissions" => "vomisj§",
"vomissure" => "vomisyR",
"vomissures" => "vomisyR",
"vomit" => "vomi",
"vomitif" => "vomitif",
"vomitifs" => "vomitif",
"vomitives" => "vomitiv",
"vomito negro" => "vomitonegRo",
"vomitoire" => "vomitwaR",
"vomitoires" => "vomitwaR",
"vont" => "v§",
"vopo" => "vopo",
"vorace" => "voRas",
"voracement" => "voRas°m@",
"voraces" => "voRas",
"voracité" => "voRasite",
"vortex" => "vORtEks",
"vos" => "vo",
"vosgien" => "voZj5",
"vosgienne" => "voZjEn",
"vota" => "vota",
"votaient" => "votE",
"votais" => "votE",
"votait" => "votE",
"votant" => "vot@",
"votants" => "vot@",
"vote" => "vOt",
"voté" => "vote",
"votée" => "vote",
"votées" => "vote",
"votent" => "vOt",
"voter" => "vote",
"votera" => "vOt°Ra",
"voterai" => "vOt°RE",
"voterais" => "vOt°RE",
"voterait" => "vOt°RE",
"voteras" => "vOt°Ra",
"votèrent" => "votER",
"voterez" => "vOt°Re",
"voterons" => "vOt°R§",
"voteront" => "vOt°R§",
"votes" => "vOt",
"votés" => "vote",
"votez" => "vote",
"votiez" => "votje",
"votif" => "votif",
"votifs" => "votif",
"votions" => "votj§",
"votive" => "votiv",
"votives" => "votiv",
"votons" => "vot§",
"votre" => "vOtR",
"vôtre" => "votR",
"vôtres" => "votR",
"voua" => "vwa",
"vouai" => "vwE",
"vouaient" => "vwE",
"vouais" => "vwE",
"vouait" => "vwE",
"vouant" => "vw@",
"voudra" => "vudRa",
"voudrai" => "vudRE",
"voudraient" => "vudRE",
"voudrais" => "vudRE",
"voudrait" => "vudRE",
"voudras" => "vudRa",
"voudrez" => "vudRe",
"voudriez" => "vudRije",
"voudrions" => "vudRij§",
"voudrons" => "vudR§",
"voudront" => "vudR§",
"voue" => "vu",
"voué" => "vwe",
"vouée" => "vwe",
"vouées" => "vwe",
"vouent" => "vu",
"vouer" => "vwe",
"vouera" => "vuRa",
"vouerait" => "vuRE",
"vouèrent" => "vwER",
"voués" => "vwe",
"vouge" => "vuZ",
"vouivre" => "vwivR",
"vouivres" => "vwivR",
"voulaient" => "vulE",
"voulais" => "vulE",
"voulait" => "vulE",
"voulant" => "vul@",
"voulez" => "vule",
"vouliez" => "vulje",
"voulions" => "vulj§",
"vouloir" => "vulwaR",
"vouloirs" => "vulwaR",
"voulons" => "vul§",
"voulu" => "vuly",
"voulue" => "vuly",
"voulues" => "vuly",
"voulûmes" => "vulym",
"voulurent" => "vulyR",
"voulus" => "vuly",
"voulusse" => "vulys",
"voulussent" => "vulys",
"voulut" => "vuly",
"voulût" => "vuly",
"vouons" => "vw§",
"vous" => "vu",
"vous-même" => "vumEm",
"vous-mêmes" => "vumEm",
"vousoyait" => "vuswajE",
"vousoyez" => "vuswaje",
"voussoie" => "vuswa",
"voussoiement" => "vuswam@",
"voussoient" => "vuswa",
"voussoyait" => "vuswajE",
"voussoyer" => "vuswaje",
"voussoyez" => "vuswaje",
"voussure" => "vusyR",
"voussures" => "vusyR",
"voûta" => "vuta",
"voûtaient" => "vutE",
"voûtait" => "vutE",
"voûtant" => "vut@",
"voûtât" => "vuta",
"voûte" => "vut",
"voûté" => "vute",
"voûtée" => "vute",
"voûtées" => "vute",
"voûtent" => "vut",
"voûter" => "vute",
"voûtèrent" => "vutER",
"voûtes" => "vut",
"voûtés" => "vute",
"vouvoie" => "vuvwa",
"vouvoiement" => "vuvwam@",
"vouvoiements" => "vuvwam@",
"vouvoient" => "vuvwa",
"vouvoies" => "vuvwa",
"vouvoya" => "vuvwaja",
"vouvoyait" => "vuvwajE",
"vouvoyant" => "vuvwaj@",
"vouvoyer" => "vuvwaje",
"vouvray" => "vuvRE",
"vox populi" => "vOkspopyli",
"voyage" => "vwajaZ",
"voyagé" => "vwajaZe",
"voyagea" => "vwajaZa",
"voyageaient" => "vwajaZE",
"voyageais" => "vwajaZE",
"voyageait" => "vwajaZE",
"voyageant" => "vwajaZ@",
"voyagent" => "vwajaZ",
"voyageons" => "vwajaZ§",
"voyager" => "vwajaZe",
"voyagera" => "vwajaZ°Ra",
"voyagerai" => "vwajaZ°RE",
"voyagerais" => "vwajaZ°RE",
"voyagerait" => "vwajaZ°RE",
"voyageras" => "vwajaZ°Ra",
"voyagèrent" => "vwajaZER",
"voyagerez" => "vwajaZ°Re",
"voyageriez" => "vwajaZ°Rje",
"voyagerons" => "vwajaZ°R§",
"voyageront" => "vwajaZ°R§",
"voyages" => "vwajaZ",
"voyages-éclair" => "vwajaZeklER",
"voyageur" => "vwajaZ9R",
"voyageurs" => "vwajaZ9R",
"voyageuse" => "vwajaZ2z",
"voyageuses" => "vwajaZ2z",
"voyagez" => "vwajaZe",
"voyagiez" => "vwajaZje",
"voyagions" => "vwajaZj§",
"voyaient" => "vwajE",
"voyais" => "vwajE",
"voyait" => "vwajE",
"voyance" => "vwaj@s",
"voyances" => "vwaj@s",
"voyant" => "vwaj@",
"voyante" => "vwaj@t",
"voyantes" => "vwaj@t",
"voyants" => "vwaj@",
"voyelle" => "vwajEl",
"voyelles" => "vwajEl",
"voyer" => "vwaje",
"voyeur" => "vwaj9R",
"voyeurisme" => "vwaj9Rizm",
"voyeurs" => "vwaj9R",
"voyeuse" => "vwaj2z",
"voyez" => "vwaje",
"voyiez" => "vwajje",
"voyions" => "vwajj§",
"voyons" => "vwaj§",
"voyou" => "vwaju",
"voyoucratie" => "vwajukRasi",
"voyous" => "vwaju",
"voyoute" => "vwajut",
"voyouterie" => "vwajut°Ri",
"voyoutes" => "vwajut",
"voyoutisme" => "vwajutizm",
"vrac" => "vRak",
"vrai" => "vRE",
"vrai-faux" => "vREfo",
"vraie" => "vRE",
"vraies" => "vRE",
"vraiment" => "vREm@",
"vrais" => "vRE",
"vraisemblable" => "vREs@blabl",
"vraisemblablement" => "vREs@blabl°m@",
"vraisemblables" => "vREs@blabl",
"vraisemblance" => "vREs@bl@s",
"vraisemblances" => "vREs@bl@s",
"vraquier" => "vRakje",
"vrilla" => "vRija",
"vrillaient" => "vRijE",
"vrillait" => "vRijE",
"vrillant" => "vRij@",
"vrille" => "vRij",
"vrillé" => "vRije",
"vrillées" => "vRije",
"vrillement" => "vRij°m@",
"vrillent" => "vRij",
"vriller" => "vRije",
"vrillèrent" => "vRijER",
"vrilles" => "vRij",
"vrillés" => "vRije",
"vrillette" => "vRijEt",
"vrillettes" => "vRijEt",
"vrombir" => "vR§biR",
"vrombis" => "vR§bi",
"vrombissaient" => "vR§bisE",
"vrombissait" => "vR§bisE",
"vrombissant" => "vR§bis@",
"vrombissante" => "vR§bis@t",
"vrombissantes" => "vR§bis@t",
"vrombissement" => "vR§bis°m@",
"vrombissements" => "vR§bis°m@",
"vrombissent" => "vR§bis",
"vrombissions" => "vR§bisj§",
"vrombit" => "vR§bi",
"vroom" => "vRum",
"vroum" => "vRum",
"vu" => "vy",
"vue" => "vy",
"vues" => "vy",
"vulcain" => "vylk5",
"vulcanienne" => "vylkanjEn",
"vulcanisait" => "vylkanizE",
"vulcanisation" => "vylkanizasj§",
"vulcanisé" => "vylkanize",
"vulcaniser" => "vylkanize",
"vulcanologue" => "vylkanolOg",
"vulgaire" => "vylgER",
"vulgairement" => "vylgER°m@",
"vulgaires" => "vylgER",
"vulgarisateurs" => "vylgaRizat9R",
"vulgarisation" => "vylgaRizasj§",
"vulgarisations" => "vylgaRizasj§",
"vulgarisée" => "vylgaRize",
"vulgariser" => "vylgaRize",
"vulgarité" => "vylgaRite",
"vulgarités" => "vylgaRite",
"vulgate" => "vylgat",
"vulgum pecus" => "vylgOmpekys",
"vulnérabilité" => "vylneRabilite",
"vulnérable" => "vylneRabl",
"vulnérables" => "vylneRabl",
"vulnéraire" => "vylneRER",
"vulnéraires" => "vylneRER",
"vulnérant" => "vylneR@",
"vulpin" => "vylp5",
"vulvaire" => "vylvER",
"vulvaires" => "vylvER",
"vulve" => "vylv",
"vulves" => "vylv",
"vus" => "vy",
"w" => "dubl°ve",
"wagnérien" => "vagneRj5",
"wagnérienne" => "vagneRjEn",
"wagnériennes" => "vagneRjEn",
"wagon" => "vag§",
"wagon-bar" => "vag§baR",
"wagon-lit" => "vag§li",
"wagon-lits" => "vag§li",
"wagon-restaurant" => "vag§REstoR@",
"wagon-salon" => "vag§sal§",
"wagonnet" => "vagonE",
"wagonnets" => "vagonE",
"wagons" => "vag§",
"wagons-citernes" => "vag§sitERn",
"wagons-lits" => "vag§li",
"wagons-restaurants" => "vag§REstoR@",
"wait and see" => "wEjt5ndsi",
"wali" => "wali",
"walkie-talkie" => "wOlkitOlki",
"walkies-talkies" => "wOlkitOlkiz",
"walkman" => "wOlkman",
"walkmans" => "wOlkman",
"walkyrie" => "valkiRi",
"wall street" => "wOlstRit",
"wallaby" => "walabi",
"wallace" => "walas",
"wallon" => "wal§",
"wallonne" => "walOn",
"walter" => "waltER",
"wapiti" => "wapiti",
"wapitis" => "wapiti",
"warning" => "waRniG",
"warnings" => "waRniG",
"warrants" => "waR@",
"wassingue" => "was5g",
"wassingues" => "was5g",
"water" => "watER",
"water-closet" => "watERklozEt",
"water-polo" => "watERpolo",
"waterman" => "wat2Rman",
"waterproof" => "watERpRuf",
"waters" => "watER",
"watt" => "wat",
"wattman" => "watman",
"watts" => "wat",
"wax" => "waks",
"way of life" => "wEjOflajf",
"web" => "wEb",
"webcam" => "wEbkam",
"week end" => "wikEnd",
"week-end" => "wikEnd",
"week-ends" => "wikEnd",
"weimarienne" => "vajmaRjEn",
"weltanschauung" => "vEltanSawuG",
"welter" => "vElt9R",
"welters" => "wEltER",
"western" => "wEstERn",
"western-spaghetti" => "wEstERnspageti",
"westerns" => "wEstERn",
"westphalien" => "vEstpalj5",
"westphaliennes" => "vEstpaljEn",
"wharf" => "waRf",
"whig" => "wig",
"whigs" => "wig",
"whipcord" => "wipkORd",
"whiskey" => "wiski",
"whiskies" => "wiski",
"whisky" => "wiski",
"whisky-soda" => "wiskisoda",
"whiskys" => "wiski",
"whist" => "wist",
"white-spirit" => "wajtspiRit",
"wicket" => "wikEt",
"wigwam" => "wigwam",
"wigwams" => "wigwam",
"wildcat" => "wajldkat",
"wilhelmien" => "vilElmj5",
"willaya" => "wilEja",
"willayas" => "wilEja",
"william" => "wiljam",
"williams" => "wiljams",
"winchester" => "wintSEstER",
"winchesters" => "wintSEstER",
"windsurf" => "winds9Rf",
"wintergreen" => "wint2RgRin",
"wishbone" => "wiSbon",
"wisigothe" => "vizigOt",
"wisigothique" => "vizigotik",
"wisigothiques" => "vizigotik",
"wisigoths" => "vizigo",
"witz" => "witz",
"wombat" => "w§ba",
"woofer" => "wuf9R",
"woofers" => "vuf9R",
"world music" => "w9Rldmjuzik",
"wouah" => "wa",
"wurtembergeois" => "vuRtEmbERZwa",
"wurtembergeoise" => "vuRtEmbERZwaz",
"x" => "iks",
"xavier" => "gzavje",
"xénogenèse" => "gzenoZ°nEz",
"xénogreffe" => "gzenogREf",
"xénon" => "gzen§",
"xénophilie" => "gzenofili",
"xénophobe" => "gzenofOb",
"xénophobes" => "gzenofOb",
"xénophobie" => "gzenofobi",
"xérès" => "kseREs",
"xérographie" => "kseROgRafi",
"xérographique" => "gzeRogRafik",
"xiang" => "gzj@g",
"xième" => "iksjEm",
"xiphidion" => "gzifidj§",
"xiphoïde" => "ksifoid",
"xylène" => "ksilEn",
"xylographie" => "ksilOgRafi",
"xylophone" => "gzilofOn",
"xylophones" => "gzilofOn",
"xylophoniste" => "gzilofonist",
"y" => "i",
"ya" => "ja",
"yacht" => "jOt",
"yacht-club" => "jOtkl9b",
"yachting" => "jOtiG",
"yachtman" => "jOtman",
"yachtmen" => "jOtmEn",
"yachts" => "jOt",
"yachtwoman" => "jOtwuman",
"yack" => "jak",
"yacks" => "jak",
"yak" => "jak",
"yakitori" => "jakitORi",
"yaks" => "jak",
"yakusa" => "jakuza",
"yakuza" => "jakuza",
"yakuzas" => "jakuza",
"yali" => "jali",
"yalis" => "jali",
"yama" => "jama",
"yang" => "j@g",
"yankee" => "j@ki",
"yankees" => "j@ki",
"yanquis" => "j@ki",
"yaourt" => "jauRt",
"yaourtières" => "jauRtjER",
"yaourts" => "jauRt",
"yard" => "jaR",
"yards" => "jaR",
"yatagan" => "jatag@",
"yatagans" => "jatag@",
"yé-yé" => "jeje",
"yeah" => "jE",
"yearling" => "j9RliG",
"yèbles" => "jEbl",
"yéménites" => "jemenit",
"yen" => "jEn",
"yens" => "jEn",
"yeshiva" => "jESiva",
"yeti" => "jeti",
"yéti" => "jeti",
"yeuse" => "j2z",
"yeuses" => "i2z",
"yeux" => "j2",
"yeux-radars" => "j2RadaR",
"yéyé" => "jeje",
"yéyés" => "jeje",
"yiddish" => "jidiS",
"yin" => "jin",
"ylang-ylang" => "il@il@",
"yo-yo" => "jojo",
"yodlait" => "jodlE",
"yodler" => "jOdle",
"yoga" => "joga",
"yoghourt" => "joguRt",
"yogi" => "jogi",
"yogis" => "jogi",
"yogourt" => "joguRt",
"yole" => "jOl",
"yom kippour" => "jOmkipuR",
"yom kippur" => "jOmkipuR",
"york" => "jORk",
"yorkshire" => "jORkSiR",
"you-you" => "juju",
"yougoslave" => "jugOslav",
"yougoslaves" => "jugOslav",
"youp" => "jup",
"youpi" => "jupi",
"youpin" => "jup5",
"youpine" => "jupin",
"yourte" => "juRt",
"yourtes" => "juRt",
"youtre" => "jutR",
"youyou" => "juju",
"youyous" => "juju",
"yoyo" => "jojo",
"yoyos" => "jojo",
"ypérite" => "ipeRit",
"yu" => "jy",
"yuan" => "jyan",
"yuans" => "jyan",
"yucca" => "juka",
"yuccas" => "juka",
"yue" => "jy",
"yuppie" => "jupi",
"yuppies" => "jupi",
"z" => "zEd",
"zadé" => "zade",
"zaibatsu" => "zajbatsu",
"zain" => "z5",
"zaïrois" => "zaiRwa",
"zaïroise" => "zaiRwaz",
"zaïroises" => "zaiRwaz",
"zakouski" => "zakuski",
"zakouskis" => "zakuski",
"zani" => "zani",
"zanimaux" => "zanimo",
"zanzi" => "z@zi",
"zanzibar" => "z@zibaR",
"zappant" => "zap@",
"zappe" => "zap",
"zappé" => "zape",
"zapper" => "zape",
"zapperai" => "zap°RE",
"zapperait" => "zap°RE",
"zappes" => "zap",
"zappeur" => "zap9R",
"zappez" => "zape",
"zapping" => "zapiG",
"zarabe" => "zaRab",
"zarbi" => "zaRbi",
"zarbis" => "zaRbis",
"zazou" => "zazu",
"zazous" => "zazu",
"zeb" => "zEb",
"zébra" => "zebRa",
"zébraient" => "zebRE",
"zébrait" => "zebRE",
"zébrant" => "zebR@",
"zèbre" => "zEbR",
"zébré" => "zebRe",
"zébrée" => "zebRe",
"zébrées" => "zebRe",
"zèbrent" => "zEbR",
"zébrer" => "zebRe",
"zèbres" => "zEbR",
"zébrés" => "zebRe",
"zébrure" => "zebRyR",
"zébrures" => "zebRyR",
"zébu" => "zeby",
"zébus" => "zeby",
"zef" => "zEf",
"zélateur" => "zelat9R",
"zélateurs" => "zelat9R",
"zélatrice" => "zelatRis",
"zèle" => "zEl",
"zélé" => "zele",
"zélée" => "zele",
"zélées" => "zele",
"zèles" => "zEl",
"zélés" => "zele",
"zelle" => "zEl",
"zélote" => "zelOt",
"zélotes" => "zelOt",
"zemstvo" => "zemstvo",
"zen" => "zEn",
"zénana" => "zenana",
"zénith" => "zenit",
"zénithale" => "zenital",
"zénithales" => "zenital",
"zens" => "zEn",
"zéphire" => "zefiR",
"zéphyr" => "zefiR",
"zéphyrs" => "zefiR",
"zeppelin" => "zEp°l5",
"zeppelins" => "zEp°l5",
"zéro" => "zeRo",
"zéros" => "zeRo",
"zest" => "zEst",
"zeste" => "zEst",
"zester" => "zEste",
"zestes" => "zEst",
"zézaie" => "zezE",
"zézaiement" => "zezEm@",
"zézaient" => "zezE",
"zézayaient" => "zezejE",
"zézayant" => "zezej@",
"zézaye" => "zezej",
"zézayer" => "zezeje",
"zézette" => "zezEt",
"zézettes" => "zezEt",
"zibeline" => "zib°lin",
"zibelines" => "zib°lin",
"zicmu" => "zikmy",
"zieute" => "zj2t",
"zieutent" => "zj2t",
"zieuter" => "zj2te",
"zieutes" => "zj2t",
"zieutez" => "zj2te",
"zig" => "zig",
"zig-zig" => "zigzig",
"ziggourat" => "ziguRat",
"ziggourats" => "ziguRa",
"zigomar" => "zigomaR",
"zigomars" => "zigomaR",
"zigoto" => "zigoto",
"zigotos" => "zigoto",
"zigouillais" => "zigujE",
"zigouillait" => "zigujE",
"zigouille" => "ziguj",
"zigouillé" => "ziguje",
"zigouillées" => "ziguje",
"zigouillent" => "ziguj",
"zigouiller" => "ziguje",
"zigouillés" => "ziguje",
"zigouillez" => "ziguje",
"zigounette" => "zigunEt",
"zigue" => "zig",
"zigues" => "zig",
"zigzag" => "zigzag",
"zigzagant" => "zigzag@",
"zigzagante" => "zigzag@t",
"zigzagantes" => "zigzag@t",
"zigzags" => "zigzag",
"zigzagua" => "zigzaga",
"zigzaguai" => "zigzagE",
"zigzaguaient" => "zigzagE",
"zigzaguait" => "zigzagE",
"zigzaguant" => "zigzag@",
"zigzague" => "zigzag",
"zigzagué" => "zigzage",
"zigzaguée" => "zigzage",
"zigzaguent" => "zigzag",
"zigzaguer" => "zigzage",
"zigzaguèrent" => "zigzagER",
"zinc" => "z5g",
"zincs" => "z5g",
"zingage" => "z5gaZ",
"zingaro" => "zingaRo",
"zingué" => "z5ge",
"zingués" => "z5ge",
"zinnia" => "zinja",
"zinnias" => "zinja",
"zinzin" => "z5z5",
"zinzins" => "z5z5",
"zinzolin" => "z5zol5",
"zip" => "zip",
"zippa" => "zipa",
"zippait" => "zipE",
"zippé" => "zipe",
"zipper" => "zipe",
"zircon" => "ziRk§",
"zirconium" => "ziRkonjom",
"zircons" => "ziRk§",
"zizanie" => "zizani",
"zizanies" => "zizani",
"zizi" => "zizi",
"zizique" => "zizik",
"zizis" => "zizi",
"zloty" => "zloti",
"zlotys" => "zloti",
"zob" => "zOb",
"zobs" => "zOb",
"zodiac" => "zOdjak",
"zodiacal" => "zodjakal",
"zodiacale" => "zOdjakal",
"zodiaque" => "zodjak",
"zombi" => "z§bi",
"zombie" => "z§bi",
"zombies" => "z§bi",
"zombification" => "z§bifikasj§",
"zombis" => "z§bi",
"zona" => "zona",
"zonage" => "zonaZ",
"zonait" => "zonE",
"zonal" => "zonal",
"zonant" => "zon@",
"zonard" => "zonaR",
"zonarde" => "zonaRd",
"zonardes" => "zonaRd",
"zonards" => "zonaR",
"zonas" => "zona",
"zone" => "zon",
"zoné" => "zone",
"zoner" => "zone",
"zonera" => "zon°Ra",
"zones" => "zon",
"zones-clés" => "zonkle",
"zoning" => "zoniG",
"zonzon" => "z§z§",
"zoo" => "zoo",
"zoologie" => "zooloZi",
"zoologique" => "zooloZik",
"zoologiques" => "zooloZik",
"zoologiste" => "zooloZist",
"zoologue" => "zoolOg",
"zoom" => "zum",
"zoome" => "zum",
"zoomer" => "zume",
"zoomes" => "zum",
"zoomez" => "zume",
"zooms" => "zum",
"zoophile" => "zoofil",
"zoophiles" => "zoofil",
"zoophilie" => "zoofili",
"zoos" => "zoo",
"zoreille" => "zOREj",
"zoreilles" => "zoREj",
"zorille" => "zoRij",
"zoroastrien" => "zoRoastRij5",
"zoroastriens" => "zoRoastRi5",
"zoroastrisme" => "zoRoastRizm",
"zou" => "zu",
"zouave" => "zwav",
"zouaves" => "zwav",
"zouk" => "zuk",
"zoulou" => "zulu",
"zouloue" => "zulu",
"zoulous" => "zulu",
"zoziaux" => "zozjo",
"zozo" => "zozo",
"zozos" => "zozo",
"zozotait" => "zozotE",
"zozotant" => "zozot@",
"zozote" => "zozOt",
"zozotement" => "zozOt°m@",
"zozotements" => "zozOt°m@",
"zozotes" => "zozOt",
"zozoteuse" => "zozot2z",
"zozotez" => "zozote",
"zurichois" => "zyRikwa",
"zurichoise" => "zyRikwaz",
"zut" => "zyt",
"zydeco" => "zid2ko",
"zyeuta" => "zj2ta",
"zyeutais" => "zj2tE",
"zyeutait" => "zj2tE",
"zyeutant" => "zj2t@",
"zyeute" => "zj2t",
"zyeuté" => "zi2te",
"zyeuter" => "zj2te",
"zyeutes" => "zj2t",
"zygoma" => "zigoma",
"zygomatique" => "zigomatik",
"zygomatiques" => "zigomatik",
"zygote" => "zigOt",
"zyklon" => "zikl§",
"zzz" => "z",
"zzzz" => "z");



$dicoHomog = array("acceptions" => 1,
"actions" => 1,
"adoptions" => 1,
"affections" => 1,
"affluent" => 1,
"as" => 1,
"boxer" => 1,
"bus" => 1,
"but" => 1,
"carter" => 1,
"challenger" => 1,
"chopper" => 1,
"chut" => 1,
"coïncident" => 1,
"confluent" => 1,
"content" => 1,
"contractions" => 1,
"convergent" => 1,
"convient" => 1,
"corner" => 1,
"couvent" => 1,
"divergent" => 1,
"driver" => 1,
"éditions" => 1,
"émergent" => 1,
"équivalent" => 1,
"est" => 1,
"ester" => 1,
"évident" => 1,
"excellent" => 1,
"exceptions" => 1,
"exécutions" => 1,
"expédient" => 1,
"ferment" => 1,
"fier" => 1,
"fils" => 1,
"influent" => 1,
"insolent" => 1,
"inspections" => 1,
"intentions" => 1,
"interceptions" => 1,
"interviewer" => 1,
"inventions" => 1,
"lis" => 1,
"manager" => 1,
"mentions" => 1,
"mixer" => 1,
"négligent" => 1,
"notions" => 1,
"objections" => 1,
"options" => 1,
"palmer" => 1,
"parent" => 1,
"placer" => 1,
"plus" => 1,
"pointer" => 1,
"porter" => 1,
"portions" => 1,
"président" => 1,
"pressent" => 1,
"prospections" => 1,
"ranger" => 1,
"rations" => 1,
"relations" => 1,
"reporter" => 1,
"résident" => 1,
"scanner" => 1,
"sélections" => 1,
"sens" => 1,
"somnolent" => 1,
"sprinter" => 1,
"supporter" => 1,
"sus" => 1,
"talent" => 1,
"transit" => 1,
"urgent" => 1,
"violent" => 1,
"vis" => 1);
?>